/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the AArch64 target                         *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 100;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(AArch64InstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(AArch64InstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static AArch64InstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static AArch64InstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testMOPredicate_MO(unsigned PredicateID, const MachineOperand &MO, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(2),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s8,
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_s128,
  GILLT_v2s32,
  GILLT_v2s64,
  GILLT_v4s16,
  GILLT_v4s32,
  GILLT_v8s8,
  GILLT_v8s16,
  GILLT_v16s8,
  GILLT_nxv1s1,
  GILLT_nxv2s1,
  GILLT_nxv2s16,
  GILLT_nxv2s32,
  GILLT_nxv2s64,
  GILLT_nxv4s1,
  GILLT_nxv4s16,
  GILLT_nxv4s32,
  GILLT_nxv8s1,
  GILLT_nxv8s16,
  GILLT_nxv16s1,
  GILLT_nxv16s8,
};
const static size_t NumTypeObjects = 24;
const static LLT TypeObjects[] = {
  LLT::scalar(8),
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::scalar(128),
  LLT::vector(ElementCount::getFixed(2), 32),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(4), 16),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(8), 8),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(16), 8),
  LLT::vector(ElementCount::getScalable(1), 1),
  LLT::vector(ElementCount::getScalable(2), 1),
  LLT::vector(ElementCount::getScalable(2), 16),
  LLT::vector(ElementCount::getScalable(2), 32),
  LLT::vector(ElementCount::getScalable(2), 64),
  LLT::vector(ElementCount::getScalable(4), 1),
  LLT::vector(ElementCount::getScalable(4), 16),
  LLT::vector(ElementCount::getScalable(4), 32),
  LLT::vector(ElementCount::getScalable(8), 1),
  LLT::vector(ElementCount::getScalable(8), 16),
  LLT::vector(ElementCount::getScalable(16), 1),
  LLT::vector(ElementCount::getScalable(16), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_HasPAuthBit = 6,
  Feature_HasJSBit = 8,
  Feature_HasComplxNumBit = 68,
  Feature_HasRCPC_IMMOBit = 89,
  Feature_HasFPARMv8Bit = 7,
  Feature_HasNEONBit = 5,
  Feature_HasSM4Bit = 67,
  Feature_HasSHA3Bit = 66,
  Feature_HasSHA2Bit = 19,
  Feature_HasAESBit = 18,
  Feature_HasDotProdBit = 2,
  Feature_HasCRCBit = 10,
  Feature_HasCSSCBit = 20,
  Feature_HasNoCSSCBit = 32,
  Feature_HasLSEBit = 33,
  Feature_HasNoLSEBit = 99,
  Feature_HasRDMBit = 16,
  Feature_HasFullFP16Bit = 13,
  Feature_HasNoFullFP16Bit = 86,
  Feature_HasFP16FMLBit = 4,
  Feature_HasFuseAESBit = 80,
  Feature_HasSVEBit = 26,
  Feature_HasSVE2Bit = 27,
  Feature_HasSVE2p1Bit = 46,
  Feature_HasSVEAESBit = 29,
  Feature_HasSVE2SM4Bit = 30,
  Feature_HasSVESHA3Bit = 97,
  Feature_HasSVEBitPermBit = 40,
  Feature_HasSMEandIsNonStreamingSafeBit = 59,
  Feature_HasSMEBit = 52,
  Feature_HasSMEF64F64Bit = 54,
  Feature_HasSMEF16F16Bit = 56,
  Feature_HasSMEI16I64Bit = 57,
  Feature_HasSME2andIsNonStreamingSafeBit = 63,
  Feature_HasSME2Bit = 61,
  Feature_HasSME2p1Bit = 65,
  Feature_HasFP8Bit = 21,
  Feature_HasFAMINMAXBit = 22,
  Feature_HasFP8FMABit = 23,
  Feature_HasSSVE_FP8FMABit = 49,
  Feature_HasFP8DOT2Bit = 24,
  Feature_HasSSVE_FP8DOT2Bit = 44,
  Feature_HasFP8DOT4Bit = 25,
  Feature_HasSSVE_FP8DOT4Bit = 50,
  Feature_HasLUTBit = 51,
  Feature_HasSME_LUTv2Bit = 64,
  Feature_HasSMEF8F16Bit = 55,
  Feature_HasSMEF8F32Bit = 53,
  Feature_HasSME_MOP4Bit = 58,
  Feature_HasSME_TMOPBit = 62,
  Feature_HasCMPBRBit = 87,
  Feature_HasFPRCVTBit = 14,
  Feature_HasLSFEBit = 34,
  Feature_HasSVE_or_SMEBit = 0,
  Feature_HasNonStreamingSVE_or_SME2p1Bit = 96,
  Feature_HasNonStreamingSVE_or_SME2p2Bit = 41,
  Feature_HasNonStreamingSVE_or_SSVE_AESBit = 28,
  Feature_HasNonStreamingSVE_or_SSVE_BitPermBit = 39,
  Feature_HasNonStreamingSVE_or_SSVE_FEXPABit = 43,
  Feature_HasSVE2_or_SMEBit = 36,
  Feature_HasSVE2_or_SME2Bit = 48,
  Feature_HasSVE2p1_or_SMEBit = 60,
  Feature_HasSVE2p1_or_SME2Bit = 31,
  Feature_HasSVE2p1_or_SME2p1Bit = 47,
  Feature_HasSVE2p2_or_SME2p2Bit = 35,
  Feature_HasNonStreamingSVE2p2_or_SME2p2Bit = 42,
  Feature_HasSMEF16F16_or_SMEF8F16Bit = 98,
  Feature_HasNEONandIsStreamingSafeBit = 17,
  Feature_HasNEONandIsSME2p2StreamingSafeBit = 76,
  Feature_HasRCPCBit = 88,
  Feature_HasFRInt3264Bit = 15,
  Feature_HasMTEBit = 11,
  Feature_HasTMEBit = 9,
  Feature_HasMatMulInt8Bit = 3,
  Feature_HasMatMulFP32Bit = 95,
  Feature_HasMatMulFP64Bit = 45,
  Feature_HasLS64Bit = 83,
  Feature_HasHBCBit = 12,
  Feature_HasRCPC3Bit = 84,
  Feature_HasGCSBit = 1,
  Feature_HasCPABit = 85,
  Feature_IsLEBit = 74,
  Feature_IsBEBit = 79,
  Feature_UseExperimentalZeroingPseudosBit = 38,
  Feature_UseAlternateSExtLoadCVTF32Bit = 78,
  Feature_UseScalarIncVLBit = 37,
  Feature_NoUseScalarIncVLBit = 92,
  Feature_HasFastIncVLBit = 93,
  Feature_UseSVEFPLD1RBit = 91,
  Feature_UseLDAPURBit = 90,
  Feature_AllowMisalignedMemAccessesBit = 94,
  Feature_NotForCodeSizeBit = 77,
  Feature_UseSTRQroBit = 75,
  Feature_TailCallX16X17Bit = 70,
  Feature_TailCallX17Bit = 81,
  Feature_TailCallNotX16Bit = 82,
  Feature_TailCallAnyBit = 69,
  Feature_SLSBLRMitigationBit = 73,
  Feature_NoSLSBLRMitigationBit = 72,
  Feature_OptimizedGISelOrOtherSelectorBit = 71,
};

PredicateBitset AArch64InstructionSelector::
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const {
  PredicateBitset Features{};
  if (Subtarget->hasPAuth())
    Features.set(Feature_HasPAuthBit);
  if (Subtarget->hasJS())
    Features.set(Feature_HasJSBit);
  if (Subtarget->hasComplxNum())
    Features.set(Feature_HasComplxNumBit);
  if (Subtarget->hasRCPC_IMMO())
    Features.set(Feature_HasRCPC_IMMOBit);
  if (Subtarget->hasFPARMv8())
    Features.set(Feature_HasFPARMv8Bit);
  if (Subtarget->isNeonAvailable())
    Features.set(Feature_HasNEONBit);
  if (Subtarget->hasSM4())
    Features.set(Feature_HasSM4Bit);
  if (Subtarget->hasSHA3())
    Features.set(Feature_HasSHA3Bit);
  if (Subtarget->hasSHA2())
    Features.set(Feature_HasSHA2Bit);
  if (Subtarget->hasAES())
    Features.set(Feature_HasAESBit);
  if (Subtarget->hasDotProd())
    Features.set(Feature_HasDotProdBit);
  if (Subtarget->hasCRC())
    Features.set(Feature_HasCRCBit);
  if (Subtarget->hasCSSC())
    Features.set(Feature_HasCSSCBit);
  if (!Subtarget->hasCSSC())
    Features.set(Feature_HasNoCSSCBit);
  if (Subtarget->hasLSE())
    Features.set(Feature_HasLSEBit);
  if (!Subtarget->hasLSE())
    Features.set(Feature_HasNoLSEBit);
  if (Subtarget->hasRDM())
    Features.set(Feature_HasRDMBit);
  if (Subtarget->hasFullFP16())
    Features.set(Feature_HasFullFP16Bit);
  if (!Subtarget->hasFullFP16())
    Features.set(Feature_HasNoFullFP16Bit);
  if (Subtarget->hasFP16FML())
    Features.set(Feature_HasFP16FMLBit);
  if (Subtarget->hasFuseAES())
    Features.set(Feature_HasFuseAESBit);
  if (Subtarget->isSVEAvailable())
    Features.set(Feature_HasSVEBit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2())
    Features.set(Feature_HasSVE2Bit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2p1())
    Features.set(Feature_HasSVE2p1Bit);
  if (Subtarget->hasSVEAES())
    Features.set(Feature_HasSVEAESBit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2SM4())
    Features.set(Feature_HasSVE2SM4Bit);
  if (Subtarget->hasSVESHA3())
    Features.set(Feature_HasSVESHA3Bit);
  if (Subtarget->hasSVEBitPerm())
    Features.set(Feature_HasSVEBitPermBit);
  if (Subtarget->hasSME())
    Features.set(Feature_HasSMEandIsNonStreamingSafeBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME())
    Features.set(Feature_HasSMEBit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF64F64())
    Features.set(Feature_HasSMEF64F64Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF16F16())
    Features.set(Feature_HasSMEF16F16Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEI16I64())
    Features.set(Feature_HasSMEI16I64Bit);
  if (Subtarget->hasSME2())
    Features.set(Feature_HasSME2andIsNonStreamingSafeBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME2())
    Features.set(Feature_HasSME2Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSME2p1())
    Features.set(Feature_HasSME2p1Bit);
  if (Subtarget->hasFP8())
    Features.set(Feature_HasFP8Bit);
  if (Subtarget->hasFAMINMAX())
    Features.set(Feature_HasFAMINMAXBit);
  if (Subtarget->hasFP8FMA())
    Features.set(Feature_HasFP8FMABit);
  if (Subtarget->hasSSVE_FP8FMA() || (Subtarget->hasSVE2() && Subtarget->hasFP8FMA()))
    Features.set(Feature_HasSSVE_FP8FMABit);
  if (Subtarget->hasFP8DOT2())
    Features.set(Feature_HasFP8DOT2Bit);
  if (Subtarget->hasSSVE_FP8DOT2() || (Subtarget->hasSVE2() && Subtarget->hasFP8DOT2()))
    Features.set(Feature_HasSSVE_FP8DOT2Bit);
  if (Subtarget->hasFP8DOT4())
    Features.set(Feature_HasFP8DOT4Bit);
  if (Subtarget->hasSSVE_FP8DOT4() || (Subtarget->hasSVE2() && Subtarget->hasFP8DOT4()))
    Features.set(Feature_HasSSVE_FP8DOT4Bit);
  if (Subtarget->hasLUT())
    Features.set(Feature_HasLUTBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME_LUTv2())
    Features.set(Feature_HasSME_LUTv2Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF8F16())
    Features.set(Feature_HasSMEF8F16Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF8F32())
    Features.set(Feature_HasSMEF8F32Bit);
  if ((Subtarget->isStreaming() && Subtarget->hasSME_MOP4()))
    Features.set(Feature_HasSME_MOP4Bit);
  if ((Subtarget->isStreaming() && Subtarget->hasSME_TMOP()))
    Features.set(Feature_HasSME_TMOPBit);
  if (Subtarget->hasCMPBR())
    Features.set(Feature_HasCMPBRBit);
  if (Subtarget->hasFPRCVT())
    Features.set(Feature_HasFPRCVTBit);
  if (Subtarget->hasLSFE())
    Features.set(Feature_HasLSFEBit);
  if (Subtarget->isSVEorStreamingSVEAvailable())
    Features.set(Feature_HasSVE_or_SMEBit);
  if (Subtarget->isSVEAvailable() ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSME2p1()))
    Features.set(Feature_HasNonStreamingSVE_or_SME2p1Bit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSME2p2()))
    Features.set(Feature_HasNonStreamingSVE_or_SME2p2Bit);
  if (Subtarget->isSVEAvailable() ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_AES()))
    Features.set(Feature_HasNonStreamingSVE_or_SSVE_AESBit);
  if (Subtarget->isSVEAvailable() ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_BitPerm()))
    Features.set(Feature_HasNonStreamingSVE_or_SSVE_BitPermBit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_FEXPA()))
    Features.set(Feature_HasNonStreamingSVE_or_SSVE_FEXPABit);
  if (Subtarget->hasSVE2() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE2_or_SMEBit);
  if (Subtarget->hasSVE2() || (Subtarget->isStreaming() && Subtarget->hasSME2()))
    Features.set(Feature_HasSVE2_or_SME2Bit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE2p1_or_SMEBit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME2()))
    Features.set(Feature_HasSVE2p1_or_SME2Bit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME2p1()))
    Features.set(Feature_HasSVE2p1_or_SME2p1Bit);
  if (Subtarget->isSVEorStreamingSVEAvailable() && (Subtarget->hasSVE2p2() || Subtarget->hasSME2p2()))
    Features.set(Feature_HasSVE2p2_or_SME2p2Bit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE2p2()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSME2p2()))
    Features.set(Feature_HasNonStreamingSVE2p2_or_SME2p2Bit);
  if (Subtarget->isStreaming() && (Subtarget->hasSMEF16F16() || Subtarget->hasSMEF8F16()))
    Features.set(Feature_HasSMEF16F16_or_SMEF8F16Bit);
  if (Subtarget->hasNEON())
    Features.set(Feature_HasNEONandIsStreamingSafeBit);
  if (Subtarget->isNeonAvailable() || (Subtarget->hasNEON() && Subtarget->hasSME2p2()))
    Features.set(Feature_HasNEONandIsSME2p2StreamingSafeBit);
  if (Subtarget->hasRCPC())
    Features.set(Feature_HasRCPCBit);
  if (Subtarget->hasFRInt3264())
    Features.set(Feature_HasFRInt3264Bit);
  if (Subtarget->hasMTE())
    Features.set(Feature_HasMTEBit);
  if (Subtarget->hasTME())
    Features.set(Feature_HasTMEBit);
  if (Subtarget->hasMatMulInt8())
    Features.set(Feature_HasMatMulInt8Bit);
  if (Subtarget->hasMatMulFP32())
    Features.set(Feature_HasMatMulFP32Bit);
  if (Subtarget->hasMatMulFP64())
    Features.set(Feature_HasMatMulFP64Bit);
  if (Subtarget->hasLS64())
    Features.set(Feature_HasLS64Bit);
  if (Subtarget->hasHBC())
    Features.set(Feature_HasHBCBit);
  if (Subtarget->hasRCPC3())
    Features.set(Feature_HasRCPC3Bit);
  if (Subtarget->hasGCS())
    Features.set(Feature_HasGCSBit);
  if (Subtarget->hasCPA())
    Features.set(Feature_HasCPABit);
  if (Subtarget->isLittleEndian())
    Features.set(Feature_IsLEBit);
  if (!Subtarget->isLittleEndian())
    Features.set(Feature_IsBEBit);
  if (Subtarget->useExperimentalZeroingPseudos())
    Features.set(Feature_UseExperimentalZeroingPseudosBit);
  if (Subtarget->useAlternateSExtLoadCVTF32Pattern())
    Features.set(Feature_UseAlternateSExtLoadCVTF32Bit);
  if (Subtarget->useScalarIncVL())
    Features.set(Feature_UseScalarIncVLBit);
  if (!Subtarget->useScalarIncVL())
    Features.set(Feature_NoUseScalarIncVLBit);
  if (!Subtarget->hasDisableFastIncVL())
    Features.set(Feature_HasFastIncVLBit);
  if (!Subtarget->noSVEFPLD1R())
    Features.set(Feature_UseSVEFPLD1RBit);
  if (!Subtarget->avoidLDAPUR())
    Features.set(Feature_UseLDAPURBit);
  if (!Subtarget->requiresStrictAlign())
    Features.set(Feature_AllowMisalignedMemAccessesBit);
  return Features;
}

void AArch64InstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const AArch64Subtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset AArch64InstructionSelector::
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  if (!shouldOptForSize(MF))
    Features.set(Feature_NotForCodeSizeBit);
  if (!Subtarget->isSTRQroSlow() || shouldOptForSize(MF))
    Features.set(Feature_UseSTRQroBit);
  if (  MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && !MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallX16X17Bit);
  if ( MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallX17Bit);
  if ( !MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallNotX16Bit);
  if ( !MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && !MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallAnyBit);
  if ( MF->getSubtarget<AArch64Subtarget>().hardenSlsBlr() )
    Features.set(Feature_SLSBLRMitigationBit);
  if ( !MF->getSubtarget<AArch64Subtarget>().hardenSlsBlr() )
    Features.set(Feature_NoSLSBLRMitigationBit);
  if (!MF->getFunction().hasOptNone() || MF->getProperties().hasFailedISel() || !MF->getProperties().hasLegalized())
    Features.set(Feature_OptimizedGISelOrOtherSelectorBit);
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasAES,
  GIFBS_HasCPA,
  GIFBS_HasCRC,
  GIFBS_HasCSSC,
  GIFBS_HasDotProd,
  GIFBS_HasFP8,
  GIFBS_HasFP8DOT2,
  GIFBS_HasFP8DOT4,
  GIFBS_HasFP8FMA,
  GIFBS_HasFPARMv8,
  GIFBS_HasFRInt3264,
  GIFBS_HasFullFP16,
  GIFBS_HasFuseAES,
  GIFBS_HasGCS,
  GIFBS_HasLSE,
  GIFBS_HasLSFE,
  GIFBS_HasLUT,
  GIFBS_HasMTE,
  GIFBS_HasMatMulInt8,
  GIFBS_HasNEON,
  GIFBS_HasNEONandIsSME2p2StreamingSafe,
  GIFBS_HasNEONandIsStreamingSafe,
  GIFBS_HasNoCSSC,
  GIFBS_HasNoFullFP16,
  GIFBS_HasNoLSE,
  GIFBS_HasNonStreamingSVE2p2_or_SME2p2,
  GIFBS_HasNonStreamingSVE_or_SME2p2,
  GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA,
  GIFBS_HasPAuth,
  GIFBS_HasRCPC,
  GIFBS_HasRCPC_IMMO,
  GIFBS_HasRDM,
  GIFBS_HasSHA2,
  GIFBS_HasSHA3,
  GIFBS_HasSM4,
  GIFBS_HasSME,
  GIFBS_HasSME2,
  GIFBS_HasSMEF16F16,
  GIFBS_HasSMEF64F64,
  GIFBS_HasSMEF8F16,
  GIFBS_HasSMEF8F32,
  GIFBS_HasSMEI16I64,
  GIFBS_HasSME_MOP4,
  GIFBS_HasSMEandIsNonStreamingSafe,
  GIFBS_HasSSVE_FP8DOT2,
  GIFBS_HasSSVE_FP8DOT4,
  GIFBS_HasSSVE_FP8FMA,
  GIFBS_HasSVE,
  GIFBS_HasSVE2,
  GIFBS_HasSVE2SM4,
  GIFBS_HasSVE2_or_SME,
  GIFBS_HasSVE2p1_or_SME,
  GIFBS_HasSVE2p1_or_SME2,
  GIFBS_HasSVE2p1_or_SME2p1,
  GIFBS_HasSVE_or_SME,
  GIFBS_HasTME,
  GIFBS_IsBE,
  GIFBS_IsLE,
  GIFBS_OptimizedGISelOrOtherSelector,
  GIFBS_UseSTRQro,
  GIFBS_HasComplxNum_HasNEON,
  GIFBS_HasFAMINMAX_HasNEON,
  GIFBS_HasFAMINMAX_HasSVE2_or_SME2,
  GIFBS_HasFP16FML_HasNEON,
  GIFBS_HasFP8_HasSVE2_or_SME2,
  GIFBS_HasFPARMv8_HasJS,
  GIFBS_HasFPRCVT_HasNEON,
  GIFBS_HasFullFP16_HasNEON,
  GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe,
  GIFBS_HasFullFP16_HasNEONandIsStreamingSafe,
  GIFBS_HasLUT_HasSVE2_or_SME2,
  GIFBS_HasMatMulFP32_HasSVE,
  GIFBS_HasMatMulFP64_HasSVE,
  GIFBS_HasMatMulFP64_HasSVE_or_SME,
  GIFBS_HasMatMulInt8_HasSVE,
  GIFBS_HasMatMulInt8_HasSVE_or_SME,
  GIFBS_HasNEON_HasRCPC3,
  GIFBS_HasNEON_HasRDM,
  GIFBS_HasNonStreamingSVE_or_SME2p1_HasSVESHA3,
  GIFBS_HasNonStreamingSVE_or_SSVE_AES_HasSVEAES,
  GIFBS_HasNonStreamingSVE_or_SSVE_BitPerm_HasSVEBitPerm,
  GIFBS_HasRCPC_IMMO_UseLDAPUR,
  GIFBS_HasSMEF16F16_HasSME_MOP4,
  GIFBS_HasSMEF64F64_HasSME_MOP4,
  GIFBS_HasSMEF8F16_HasSME_MOP4,
  GIFBS_HasSMEF8F32_HasSME_MOP4,
  GIFBS_HasSMEI16I64_HasSME_MOP4,
  GIFBS_HasSVE_or_SME_IsLE,
  GIFBS_HasSVE_or_SME_UseScalarIncVL,
  GIFBS_IsLE_UseSTRQro,
  GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE,
  GIFBS_HasComplxNum_HasFullFP16_HasNEON,
  GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasAESBit, },
  {Feature_HasCPABit, },
  {Feature_HasCRCBit, },
  {Feature_HasCSSCBit, },
  {Feature_HasDotProdBit, },
  {Feature_HasFP8Bit, },
  {Feature_HasFP8DOT2Bit, },
  {Feature_HasFP8DOT4Bit, },
  {Feature_HasFP8FMABit, },
  {Feature_HasFPARMv8Bit, },
  {Feature_HasFRInt3264Bit, },
  {Feature_HasFullFP16Bit, },
  {Feature_HasFuseAESBit, },
  {Feature_HasGCSBit, },
  {Feature_HasLSEBit, },
  {Feature_HasLSFEBit, },
  {Feature_HasLUTBit, },
  {Feature_HasMTEBit, },
  {Feature_HasMatMulInt8Bit, },
  {Feature_HasNEONBit, },
  {Feature_HasNEONandIsSME2p2StreamingSafeBit, },
  {Feature_HasNEONandIsStreamingSafeBit, },
  {Feature_HasNoCSSCBit, },
  {Feature_HasNoFullFP16Bit, },
  {Feature_HasNoLSEBit, },
  {Feature_HasNonStreamingSVE2p2_or_SME2p2Bit, },
  {Feature_HasNonStreamingSVE_or_SME2p2Bit, },
  {Feature_HasNonStreamingSVE_or_SSVE_FEXPABit, },
  {Feature_HasPAuthBit, },
  {Feature_HasRCPCBit, },
  {Feature_HasRCPC_IMMOBit, },
  {Feature_HasRDMBit, },
  {Feature_HasSHA2Bit, },
  {Feature_HasSHA3Bit, },
  {Feature_HasSM4Bit, },
  {Feature_HasSMEBit, },
  {Feature_HasSME2Bit, },
  {Feature_HasSMEF16F16Bit, },
  {Feature_HasSMEF64F64Bit, },
  {Feature_HasSMEF8F16Bit, },
  {Feature_HasSMEF8F32Bit, },
  {Feature_HasSMEI16I64Bit, },
  {Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEandIsNonStreamingSafeBit, },
  {Feature_HasSSVE_FP8DOT2Bit, },
  {Feature_HasSSVE_FP8DOT4Bit, },
  {Feature_HasSSVE_FP8FMABit, },
  {Feature_HasSVEBit, },
  {Feature_HasSVE2Bit, },
  {Feature_HasSVE2SM4Bit, },
  {Feature_HasSVE2_or_SMEBit, },
  {Feature_HasSVE2p1_or_SMEBit, },
  {Feature_HasSVE2p1_or_SME2Bit, },
  {Feature_HasSVE2p1_or_SME2p1Bit, },
  {Feature_HasSVE_or_SMEBit, },
  {Feature_HasTMEBit, },
  {Feature_IsBEBit, },
  {Feature_IsLEBit, },
  {Feature_OptimizedGISelOrOtherSelectorBit, },
  {Feature_UseSTRQroBit, },
  {Feature_HasComplxNumBit, Feature_HasNEONBit, },
  {Feature_HasFAMINMAXBit, Feature_HasNEONBit, },
  {Feature_HasFAMINMAXBit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasFP16FMLBit, Feature_HasNEONBit, },
  {Feature_HasFP8Bit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasFPARMv8Bit, Feature_HasJSBit, },
  {Feature_HasFPRCVTBit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONandIsSME2p2StreamingSafeBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONandIsStreamingSafeBit, },
  {Feature_HasLUTBit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasMatMulFP32Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulFP64Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulFP64Bit, Feature_HasSVE_or_SMEBit, },
  {Feature_HasMatMulInt8Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulInt8Bit, Feature_HasSVE_or_SMEBit, },
  {Feature_HasNEONBit, Feature_HasRCPC3Bit, },
  {Feature_HasNEONBit, Feature_HasRDMBit, },
  {Feature_HasNonStreamingSVE_or_SME2p1Bit, Feature_HasSVESHA3Bit, },
  {Feature_HasNonStreamingSVE_or_SSVE_AESBit, Feature_HasSVEAESBit, },
  {Feature_HasNonStreamingSVE_or_SSVE_BitPermBit, Feature_HasSVEBitPermBit, },
  {Feature_HasRCPC_IMMOBit, Feature_UseLDAPURBit, },
  {Feature_HasSMEF16F16Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEF64F64Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEF8F16Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEF8F32Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEI16I64Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSVE_or_SMEBit, Feature_IsLEBit, },
  {Feature_HasSVE_or_SMEBit, Feature_UseScalarIncVLBit, },
  {Feature_IsLEBit, Feature_UseSTRQroBit, },
  {Feature_AllowMisalignedMemAccessesBit, Feature_HasSVE_or_SMEBit, Feature_IsLEBit, },
  {Feature_HasComplxNumBit, Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasNEONBit, Feature_NotForCodeSizeBit, Feature_UseAlternateSExtLoadCVTF32Bit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
  GICP_gi_addsub_shifted_imm32,
  GICP_gi_addsub_shifted_imm64,
  GICP_gi_am_indexed128,
  GICP_gi_am_indexed16,
  GICP_gi_am_indexed32,
  GICP_gi_am_indexed64,
  GICP_gi_am_indexed8,
  GICP_gi_am_unscaled128,
  GICP_gi_am_unscaled16,
  GICP_gi_am_unscaled32,
  GICP_gi_am_unscaled64,
  GICP_gi_am_unscaled8,
  GICP_gi_arith_extended_reg32_i32,
  GICP_gi_arith_extended_reg32_i64,
  GICP_gi_arith_extended_reg32to64_i64,
  GICP_gi_arith_shifted_reg32,
  GICP_gi_arith_shifted_reg64,
  GICP_gi_extract_high_v16i8,
  GICP_gi_extract_high_v4f32,
  GICP_gi_extract_high_v4i32,
  GICP_gi_extract_high_v8f16,
  GICP_gi_extract_high_v8i16,
  GICP_gi_logical_shifted_reg32,
  GICP_gi_logical_shifted_reg64,
  GICP_gi_neg_addsub_shifted_imm32,
  GICP_gi_neg_addsub_shifted_imm64,
  GICP_gi_ro_Windexed128,
  GICP_gi_ro_Windexed16,
  GICP_gi_ro_Windexed32,
  GICP_gi_ro_Windexed64,
  GICP_gi_ro_Windexed8,
  GICP_gi_ro_Xindexed128,
  GICP_gi_ro_Xindexed16,
  GICP_gi_ro_Xindexed32,
  GICP_gi_ro_Xindexed64,
  GICP_gi_ro_Xindexed8,
};
// See constructor for table contents

AArch64InstructionSelector::ComplexMatcherMemFn
AArch64InstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
  &AArch64InstructionSelector::selectArithImmed, // gi_addsub_shifted_imm32
  &AArch64InstructionSelector::selectArithImmed, // gi_addsub_shifted_imm64
  &AArch64InstructionSelector::selectAddrModeIndexed<128>, // gi_am_indexed128
  &AArch64InstructionSelector::selectAddrModeIndexed<16>, // gi_am_indexed16
  &AArch64InstructionSelector::selectAddrModeIndexed<32>, // gi_am_indexed32
  &AArch64InstructionSelector::selectAddrModeIndexed<64>, // gi_am_indexed64
  &AArch64InstructionSelector::selectAddrModeIndexed<8>, // gi_am_indexed8
  &AArch64InstructionSelector::selectAddrModeUnscaled128, // gi_am_unscaled128
  &AArch64InstructionSelector::selectAddrModeUnscaled16, // gi_am_unscaled16
  &AArch64InstructionSelector::selectAddrModeUnscaled32, // gi_am_unscaled32
  &AArch64InstructionSelector::selectAddrModeUnscaled64, // gi_am_unscaled64
  &AArch64InstructionSelector::selectAddrModeUnscaled8, // gi_am_unscaled8
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32_i32
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32_i64
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32to64_i64
  &AArch64InstructionSelector::selectArithShiftedRegister, // gi_arith_shifted_reg32
  &AArch64InstructionSelector::selectArithShiftedRegister, // gi_arith_shifted_reg64
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v16i8
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v4f32
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v4i32
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v8f16
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v8i16
  &AArch64InstructionSelector::selectLogicalShiftedRegister, // gi_logical_shifted_reg32
  &AArch64InstructionSelector::selectLogicalShiftedRegister, // gi_logical_shifted_reg64
  &AArch64InstructionSelector::selectNegArithImmed, // gi_neg_addsub_shifted_imm32
  &AArch64InstructionSelector::selectNegArithImmed, // gi_neg_addsub_shifted_imm64
  &AArch64InstructionSelector::selectAddrModeWRO<128>, // gi_ro_Windexed128
  &AArch64InstructionSelector::selectAddrModeWRO<16>, // gi_ro_Windexed16
  &AArch64InstructionSelector::selectAddrModeWRO<32>, // gi_ro_Windexed32
  &AArch64InstructionSelector::selectAddrModeWRO<64>, // gi_ro_Windexed64
  &AArch64InstructionSelector::selectAddrModeWRO<8>, // gi_ro_Windexed8
  &AArch64InstructionSelector::selectAddrModeXRO<128>, // gi_ro_Xindexed128
  &AArch64InstructionSelector::selectAddrModeXRO<16>, // gi_ro_Xindexed16
  &AArch64InstructionSelector::selectAddrModeXRO<32>, // gi_ro_Xindexed32
  &AArch64InstructionSelector::selectAddrModeXRO<64>, // gi_ro_Xindexed64
  &AArch64InstructionSelector::selectAddrModeXRO<8>, // gi_ro_Xindexed8
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_add_and_or_is_add = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_ldaxr_1,
  GICXXPred_MI_Predicate_ldaxr_2,
  GICXXPred_MI_Predicate_ldaxr_4,
  GICXXPred_MI_Predicate_ldaxr_8,
  GICXXPred_MI_Predicate_ldxr_1,
  GICXXPred_MI_Predicate_ldxr_2,
  GICXXPred_MI_Predicate_ldxr_4,
  GICXXPred_MI_Predicate_ldxr_8,
  GICXXPred_MI_Predicate_stlxr_1,
  GICXXPred_MI_Predicate_stlxr_2,
  GICXXPred_MI_Predicate_stlxr_4,
  GICXXPred_MI_Predicate_stlxr_8,
  GICXXPred_MI_Predicate_stxr_1,
  GICXXPred_MI_Predicate_stxr_2,
  GICXXPred_MI_Predicate_stxr_4,
  GICXXPred_MI_Predicate_stxr_8,
};
bool AArch64InstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_add_and_or_is_add: {
    
         return mi_match(MI, MRI, m_GAddLike(m_Reg(), m_Reg()));
      
  }
  case GICXXPred_MI_Predicate_ldaxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_ldaxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_ldaxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_ldaxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_ldxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_ldxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_ldxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_ldxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_stlxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_stlxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_stlxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_stlxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_stxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_stxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_stxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_stxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_MO_Predicate_top16Zero = GICXXPred_Invalid + 1,
  GICXXPred_MO_Predicate_top32Zero,
  GICXXPred_MO_Predicate_topbitsallzero32,
  GICXXPred_MO_Predicate_topbitsallzero64,
};
bool AArch64InstructionSelector::testMOPredicate_MO(unsigned PredicateID, const MachineOperand & MO, const MatcherState &State) const {
  const auto &Operands = State.RecordedOperands;
  Register Reg = MO.getReg();
  (void)Operands;
  (void)Reg;
  switch (PredicateID) {
  case GICXXPred_MO_Predicate_top16Zero: {
    
        return VT && VT->maskedValueIsZero(Reg, APInt::getHighBitsSet(32, 16)); 
  }
  case GICXXPred_MO_Predicate_top32Zero: {
     
        return VT && VT->maskedValueIsZero(Reg, APInt::getHighBitsSet(64, 32)); 
  }
  case GICXXPred_MO_Predicate_topbitsallzero32: {
     
        return VT && VT->maskedValueIsZero(Reg, APInt::getHighBitsSet(32, 31)); 
  }
  case GICXXPred_MO_Predicate_topbitsallzero64: {
     
        return VT && VT->maskedValueIsZero(Reg, APInt::getHighBitsSet(64, 63)); 
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_VectorIndex0 = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_VectorIndex0_timm,
  GICXXPred_I64_Predicate_VectorIndex1,
  GICXXPred_I64_Predicate_VectorIndex1_timm,
  GICXXPred_I64_Predicate_VectorIndex032b,
  GICXXPred_I64_Predicate_VectorIndex032b_timm,
  GICXXPred_I64_Predicate_VectorIndex132b,
  GICXXPred_I64_Predicate_VectorIndex132b_timm,
  GICXXPred_I64_Predicate_VectorIndexB,
  GICXXPred_I64_Predicate_VectorIndexB32b,
  GICXXPred_I64_Predicate_VectorIndexB32b_timm,
  GICXXPred_I64_Predicate_VectorIndexB_timm,
  GICXXPred_I64_Predicate_VectorIndexD,
  GICXXPred_I64_Predicate_VectorIndexD32b,
  GICXXPred_I64_Predicate_VectorIndexD32b_timm,
  GICXXPred_I64_Predicate_VectorIndexD_timm,
  GICXXPred_I64_Predicate_VectorIndexH,
  GICXXPred_I64_Predicate_VectorIndexH32b,
  GICXXPred_I64_Predicate_VectorIndexH32b_timm,
  GICXXPred_I64_Predicate_VectorIndexH_timm,
  GICXXPred_I64_Predicate_VectorIndexS,
  GICXXPred_I64_Predicate_VectorIndexS32b,
  GICXXPred_I64_Predicate_VectorIndexS32b_timm,
  GICXXPred_I64_Predicate_VectorIndexS_timm,
  GICXXPred_I64_Predicate_complexrotateop,
  GICXXPred_I64_Predicate_complexrotateopodd,
  GICXXPred_I64_Predicate_extq_timm32_0_1m8,
  GICXXPred_I64_Predicate_extq_timm32_0_3m4,
  GICXXPred_I64_Predicate_extq_timm32_0_7m2,
  GICXXPred_I64_Predicate_i64imm_32bit,
  GICXXPred_I64_Predicate_i64imm_32bit_tgt,
  GICXXPred_I64_Predicate_imm0_1,
  GICXXPred_I64_Predicate_imm0_3,
  GICXXPred_I64_Predicate_imm0_7,
  GICXXPred_I64_Predicate_imm0_15,
  GICXXPred_I64_Predicate_imm0_31,
  GICXXPred_I64_Predicate_imm0_63,
  GICXXPred_I64_Predicate_imm0_127,
  GICXXPred_I64_Predicate_imm0_127_64b,
  GICXXPred_I64_Predicate_imm0_255,
  GICXXPred_I64_Predicate_imm32_0_7,
  GICXXPred_I64_Predicate_imm32_0_15,
  GICXXPred_I64_Predicate_imm32_0_31,
  GICXXPred_I64_Predicate_imm64_0_65535,
  GICXXPred_I64_Predicate_maski8_or_more,
  GICXXPred_I64_Predicate_maski16_or_more,
  GICXXPred_I64_Predicate_rprfop,
  GICXXPred_I64_Predicate_s64imm_32bit,
  GICXXPred_I64_Predicate_simm4s1,
  GICXXPred_I64_Predicate_simm4s2,
  GICXXPred_I64_Predicate_simm4s3,
  GICXXPred_I64_Predicate_simm4s4,
  GICXXPred_I64_Predicate_simm4s16,
  GICXXPred_I64_Predicate_simm4s32,
  GICXXPred_I64_Predicate_simm5_8b,
  GICXXPred_I64_Predicate_simm5_8b_tgt,
  GICXXPred_I64_Predicate_simm5_16b,
  GICXXPred_I64_Predicate_simm5_16b_tgt,
  GICXXPred_I64_Predicate_simm5_32b,
  GICXXPred_I64_Predicate_simm5_32b_tgt,
  GICXXPred_I64_Predicate_simm5_64b,
  GICXXPred_I64_Predicate_simm5_64b_tgt,
  GICXXPred_I64_Predicate_simm6_32b,
  GICXXPred_I64_Predicate_simm6s1,
  GICXXPred_I64_Predicate_simm8_32b,
  GICXXPred_I64_Predicate_simm8_64b,
  GICXXPred_I64_Predicate_simm9,
  GICXXPred_I64_Predicate_sme_elm_idx0_0,
  GICXXPred_I64_Predicate_sme_elm_idx0_1,
  GICXXPred_I64_Predicate_sme_elm_idx0_3,
  GICXXPred_I64_Predicate_sme_elm_idx0_7,
  GICXXPred_I64_Predicate_sme_elm_idx0_15,
  GICXXPred_I64_Predicate_svcr_op,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_b,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_b_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_d,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_d_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_h,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_h_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_q,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_q_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_s,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_s_timm,
  GICXXPred_I64_Predicate_sve_incdec_imm,
  GICXXPred_I64_Predicate_sve_pred_enum,
  GICXXPred_I64_Predicate_sve_prfop,
  GICXXPred_I64_Predicate_sve_vec_len_specifier_enum,
  GICXXPred_I64_Predicate_tbz_imm0_31_diag,
  GICXXPred_I64_Predicate_tbz_imm0_31_nodiag,
  GICXXPred_I64_Predicate_tbz_imm32_63,
  GICXXPred_I64_Predicate_timm0_1,
  GICXXPred_I64_Predicate_timm0_31,
  GICXXPred_I64_Predicate_timm0_63,
  GICXXPred_I64_Predicate_timm32_0_0,
  GICXXPred_I64_Predicate_timm32_0_1,
  GICXXPred_I64_Predicate_timm32_0_3,
  GICXXPred_I64_Predicate_timm32_0_7,
  GICXXPred_I64_Predicate_timm32_0_15,
  GICXXPred_I64_Predicate_timm32_0_31,
  GICXXPred_I64_Predicate_timm32_0_255,
  GICXXPred_I64_Predicate_timm32_0_65535,
  GICXXPred_I64_Predicate_timm32_1_1,
  GICXXPred_I64_Predicate_timm32_1_3,
  GICXXPred_I64_Predicate_timm32_1_7,
  GICXXPred_I64_Predicate_timm64_0_65535,
  GICXXPred_I64_Predicate_tuimm5s2,
  GICXXPred_I64_Predicate_tuimm5s4,
  GICXXPred_I64_Predicate_tuimm5s8,
  GICXXPred_I64_Predicate_tvecshiftL8,
  GICXXPred_I64_Predicate_tvecshiftL16,
  GICXXPred_I64_Predicate_tvecshiftL32,
  GICXXPred_I64_Predicate_tvecshiftL64,
  GICXXPred_I64_Predicate_tvecshiftR8,
  GICXXPred_I64_Predicate_tvecshiftR16,
  GICXXPred_I64_Predicate_tvecshiftR32,
  GICXXPred_I64_Predicate_tvecshiftR64,
  GICXXPred_I64_Predicate_ubsan_trap_imm,
  GICXXPred_I64_Predicate_uimm0s2range,
  GICXXPred_I64_Predicate_uimm0s4range,
  GICXXPred_I64_Predicate_uimm1s2range,
  GICXXPred_I64_Predicate_uimm1s4range,
  GICXXPred_I64_Predicate_uimm2s2range,
  GICXXPred_I64_Predicate_uimm2s4range,
  GICXXPred_I64_Predicate_uimm3s2range,
  GICXXPred_I64_Predicate_uimm3s8,
  GICXXPred_I64_Predicate_uimm5s2,
  GICXXPred_I64_Predicate_uimm5s4,
  GICXXPred_I64_Predicate_uimm5s8,
  GICXXPred_I64_Predicate_uimm6,
  GICXXPred_I64_Predicate_uimm6_32b,
  GICXXPred_I64_Predicate_uimm6_64b,
  GICXXPred_I64_Predicate_uimm6s1,
  GICXXPred_I64_Predicate_uimm6s2,
  GICXXPred_I64_Predicate_uimm6s4,
  GICXXPred_I64_Predicate_uimm6s8,
  GICXXPred_I64_Predicate_uimm6s16,
  GICXXPred_I64_Predicate_uimm8_32b,
  GICXXPred_I64_Predicate_uimm8_64b,
  GICXXPred_I64_Predicate_uimm16,
  GICXXPred_I64_Predicate_vecshiftL8,
  GICXXPred_I64_Predicate_vecshiftL16,
  GICXXPred_I64_Predicate_vecshiftL32,
  GICXXPred_I64_Predicate_vecshiftL64,
  GICXXPred_I64_Predicate_vecshiftR8,
  GICXXPred_I64_Predicate_vecshiftR16,
  GICXXPred_I64_Predicate_vecshiftR16Narrow,
  GICXXPred_I64_Predicate_vecshiftR32,
  GICXXPred_I64_Predicate_vecshiftR32Narrow,
  GICXXPred_I64_Predicate_vecshiftR64,
  GICXXPred_I64_Predicate_vecshiftR64Narrow,
};
bool AArch64InstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_VectorIndex0: {
     return ((uint64_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex0_timm: {
     return ((uint64_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex1: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex1_timm: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex032b: {
     return ((uint32_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex032b_timm: {
     return ((uint32_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex132b: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex132b_timm: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB32b: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB32b_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD32b: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD32b_timm: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD_timm: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH32b: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH32b_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS32b: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS32b_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_complexrotateop: {
     return Imm >= 0 && Imm <= 270;  
  }
  case GICXXPred_I64_Predicate_complexrotateopodd: {
     return Imm >= 0 && Imm <= 270;  
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_1m8: {
    
      return ((uint32_t)Imm) < 2;
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_3m4: {
    
      return ((uint32_t)Imm) < 4;
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_7m2: {
    
      return ((uint32_t)Imm) < 8;
  }
  case GICXXPred_I64_Predicate_i64imm_32bit: {
    
      return (Imm & 0xffffffffULL) == static_cast<uint64_t>(Imm);
    
  }
  case GICXXPred_I64_Predicate_i64imm_32bit_tgt: {
    
      return (Imm & 0xffffffffULL) == static_cast<uint64_t>(Imm);
    
  }
  case GICXXPred_I64_Predicate_imm0_1: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_imm0_3: {
    
      return ((uint64_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_imm0_7: {
    
      return ((uint64_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_imm0_15: {
    
      return ((uint64_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_imm0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_imm0_63: {
    
      return ((uint64_t)Imm) < 64;
    
  }
  case GICXXPred_I64_Predicate_imm0_127: {
    
      return ((uint32_t)Imm) < 128;
    
  }
  case GICXXPred_I64_Predicate_imm0_127_64b: {
    
      return ((uint64_t)Imm) < 128;
    
  }
  case GICXXPred_I64_Predicate_imm0_255: {
    
      return ((uint32_t)Imm) < 256;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_7: {
    
      return ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_15: {
    
      return ((uint32_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_imm64_0_65535: {
    
      return ((uint64_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_maski8_or_more: {
     return (Imm & 0xff) == 0xff; 
  }
  case GICXXPred_I64_Predicate_maski16_or_more: {
     return (Imm & 0xffff) == 0xffff; 
  }
  case GICXXPred_I64_Predicate_rprfop: {
    
        return (((uint32_t)Imm) <= 63);
      
  }
  case GICXXPred_I64_Predicate_s64imm_32bit: {
    
      int64_t Imm64 = static_cast<int64_t>(Imm);
      return Imm64 >= std::numeric_limits<int32_t>::min() &&
             Imm64 <= std::numeric_limits<int32_t>::max();
    
    llvm_unreachable("s64imm_32bit should have returned");
  }
  case GICXXPred_I64_Predicate_simm4s1: {
     return Imm >=-8  && Imm <= 7; 
  }
  case GICXXPred_I64_Predicate_simm4s2: {
     return Imm >=-16  && Imm <= 14 && (Imm % 2) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s3: {
     return Imm >=-24  && Imm <= 21 && (Imm % 3) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s4: {
     return Imm >=-32  && Imm <= 28 && (Imm % 4) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s16: {
     return Imm >=-128  && Imm <= 112 && (Imm % 16) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s32: {
     return Imm >=-256  && Imm <= 224 && (Imm % 32) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm5_8b: {
     return (int8_t)Imm >= -16 && (int8_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_8b_tgt: {
     return (int8_t)Imm >= -16 && (int8_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_16b: {
     return (int16_t)Imm >= -16 && (int16_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_16b_tgt: {
     return (int16_t)Imm >= -16 && (int16_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_32b: {
     return Imm >= -16 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_32b_tgt: {
     return (int32_t)Imm >= -16 && (int32_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_64b: {
     return Imm >= -16 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_64b_tgt: {
     return (int64_t)Imm >= -16 && (int64_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm6_32b: {
     return Imm >= -32 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_simm6s1: {
     return Imm >= -32 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_simm8_32b: {
     return Imm >= -128 && Imm < 128; 
  }
  case GICXXPred_I64_Predicate_simm8_64b: {
     return Imm >= -128 && Imm < 128; 
  }
  case GICXXPred_I64_Predicate_simm9: {
     return Imm >= -256 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_0: {
    
      return ((uint32_t)Imm) == 0;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_1: {
    
      return ((uint32_t)Imm) <= 1;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_3: {
    
      return ((uint32_t)Imm) <= 3;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_7: {
    
      return ((uint32_t)Imm) <= 7;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_15: {
    
      return ((uint32_t)Imm) <= 15;
    
  }
  case GICXXPred_I64_Predicate_svcr_op: {
    
        return AArch64SVCR::lookupSVCRByEncoding(Imm) != nullptr;
      
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_b: {
     return ((uint64_t)Imm) < 64; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_b_timm: {
     return ((uint64_t)Imm) < 64; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_d: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_d_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_h: {
     return ((uint64_t)Imm) < 32; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_h_timm: {
     return ((uint64_t)Imm) < 32; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_q: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_q_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_s: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_s_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_sve_incdec_imm: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_sve_pred_enum: {
    
      return (((uint32_t)Imm) < 32);
      
  }
  case GICXXPred_I64_Predicate_sve_prfop: {
    
        return (((uint32_t)Imm) <= 15);
      
  }
  case GICXXPred_I64_Predicate_sve_vec_len_specifier_enum: {
    
      return (((uint32_t)Imm) < 2);
      
  }
  case GICXXPred_I64_Predicate_tbz_imm0_31_diag: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tbz_imm0_31_nodiag: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tbz_imm32_63: {
    
      return (((uint32_t)Imm) > 31) && (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_timm0_1: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_timm0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_timm0_63: {
    
      return ((uint64_t)Imm) < 64;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_0: {
    
      return ((uint32_t)Imm) == 0;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_1: {
    
      return ((uint32_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_3: {
    
      return ((uint32_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_7: {
    
      return ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_15: {
    
      return ((uint32_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_31: {
    
      return ((uint32_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_255: {
    
      return ((uint32_t)Imm) < 256;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_65535: {
    
      return ((uint32_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_1: {
    
        return ((uint32_t)Imm) == 1;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_3: {
    
      return ((uint32_t)Imm) > 0 && ((uint32_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_7: {
    
      return ((uint32_t)Imm) > 0 && ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_timm64_0_65535: {
    
      return ((uint64_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_tuimm5s2: {
     return Imm >= 0 && Imm < (32*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_tuimm5s4: {
     return Imm >= 0 && Imm < (32*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_tuimm5s8: {
     return Imm >= 0 && Imm < (32*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_tvecshiftL8: {
    
      return (((uint32_t)Imm) < 8);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL16: {
    
      return (((uint32_t)Imm) < 16);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL32: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL64: {
    
      return (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR8: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR16: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR32: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR64: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 65);
    
  }
  case GICXXPred_I64_Predicate_ubsan_trap_imm: {
    
      return isUInt<8>(Imm);
    
  }
  case GICXXPred_I64_Predicate_uimm0s2range: {
     return Imm == 0; 
  }
  case GICXXPred_I64_Predicate_uimm0s4range: {
     return Imm == 0; 
  }
  case GICXXPred_I64_Predicate_uimm1s2range: {
     return Imm >= 0 && Imm <= 2 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm1s4range: {
     return Imm >= 0 && Imm <= 4 && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm2s2range: {
     return Imm >= 0 && Imm <= 6 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm2s4range: {
     return Imm >= 0 && Imm <= 12 && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm3s2range: {
     return Imm >= 0 && Imm <= 14 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm3s8: {
     return Imm >= 0 && Imm <= 56 && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s2: {
     return Imm >= 0 && Imm < (32*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s4: {
     return Imm >= 0 && Imm < (32*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s8: {
     return Imm >= 0 && Imm < (32*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6_32b: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6_64b: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6s1: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6s2: {
     return Imm >= 0 && Imm < (64*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s4: {
     return Imm >= 0 && Imm < (64*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s8: {
     return Imm >= 0 && Imm < (64*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s16: {
     return Imm >= 0 && Imm < (64*16) && ((Imm % 16) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm8_32b: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_uimm8_64b: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_uimm16: {
    return Imm >= 0 && Imm < 65536;
  }
  case GICXXPred_I64_Predicate_vecshiftL8: {
    
      return (((uint32_t)Imm) < 8);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL16: {
    
      return (((uint32_t)Imm) < 16);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL32: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL64: {
    
      return (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR8: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR16: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR16Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR32: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR32Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR64: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 65);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR64Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APFloat_Predicate_fpimm0 = GICXXPred_Invalid + 1,
  GICXXPred_APFloat_Predicate_fpimm16,
  GICXXPred_APFloat_Predicate_fpimm32,
  GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4,
  GICXXPred_APFloat_Predicate_fpimm64,
  GICXXPred_APFloat_Predicate_fpimm_half,
  GICXXPred_APFloat_Predicate_fpimm_minus0,
  GICXXPred_APFloat_Predicate_fpimm_one,
  GICXXPred_APFloat_Predicate_fpimm_two,
  GICXXPred_APFloat_Predicate_fpimmbf16,
  GICXXPred_APFloat_Predicate_simdimmtype10,
};
bool AArch64InstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APFloat_Predicate_fpimm0: {
    
      return Imm.isExactlyValue(+0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm16: {
    
          return AArch64_AM::getFP16Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm32: {
    
          return AArch64_AM::getFP32Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4: {
    
          uint64_t Enc = Imm.bitcastToAPInt().getZExtValue();
          return Enc != 0 && AArch64_AM::isAdvSIMDModImmType4(Enc << 32 | Enc);
        
    llvm_unreachable("fpimm32SIMDModImmType4 should have returned");
  }
  case GICXXPred_APFloat_Predicate_fpimm64: {
    
          return AArch64_AM::getFP64Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm_half: {
    
      return Imm.isExactlyValue(+0.5);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_minus0: {
    
      return Imm.isExactlyValue(-0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_one: {
    
      return Imm.isExactlyValue(+1.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_two: {
    
      return Imm.isExactlyValue(+2.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimmbf16: {
    
          return AArch64_AM::getFP16Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_simdimmtype10: {
    
          return AArch64_AM::isAdvSIMDModImmType10(
                     Imm.bitcastToAPInt().getZExtValue());
        
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_logical_imm32 = GICXXPred_Invalid + 1,
  GICXXPred_APInt_Predicate_logical_imm64,
};
bool AArch64InstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_logical_imm32: {
    
      return AArch64_AM::isLogicalImmediate(Imm.getZExtValue(), 32);
    
  }
  case GICXXPred_APInt_Predicate_logical_imm64: {
    
      return AArch64_AM::isLogicalImmediate(Imm.getZExtValue(), 64);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64InstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("AArch64InstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
  GICR_renderFPImm16,
  GICR_renderFPImm32,
  GICR_renderFPImm32SIMDModImmType4,
  GICR_renderFPImm64,
  GICR_renderLogicalImm32,
  GICR_renderLogicalImm64,
  GICR_renderTruncImm,
  GICR_renderUbsanTrap,
};
AArch64InstructionSelector::CustomRendererFn
AArch64InstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
  &AArch64InstructionSelector::renderFPImm16,
  &AArch64InstructionSelector::renderFPImm32,
  &AArch64InstructionSelector::renderFPImm32SIMDModImmType4,
  &AArch64InstructionSelector::renderFPImm64,
  &AArch64InstructionSelector::renderLogicalImm32,
  &AArch64InstructionSelector::renderLogicalImm64,
  &AArch64InstructionSelector::renderTruncImm,
  &AArch64InstructionSelector::renderUbsanTrap,
};

bool AArch64InstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool AArch64InstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("AArch64InstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *AArch64InstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*      0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(903), /*)*//*default:*//*Label 155*/ GIMT_Encode4(441607),
     /*     10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(3410),
     /*     14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(37017),
     /*     18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(51869),
     /*     22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(54634),
     /*     26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(54716), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     46 */ /*TargetOpcode::G_AND*//*Label 5*/ GIMT_Encode4(54798),
     /*     50 */ /*TargetOpcode::G_OR*//*Label 6*/ GIMT_Encode4(62544),
     /*     54 */ /*TargetOpcode::G_XOR*//*Label 7*/ GIMT_Encode4(87659), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    114 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 8*/ GIMT_Encode4(98627), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    126 */ /*TargetOpcode::G_BITCAST*//*Label 9*/ GIMT_Encode4(106151), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    142 */ /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 10*/ GIMT_Encode4(116233),
     /*    146 */ /*TargetOpcode::G_INTRINSIC_ROUND*//*Label 11*/ GIMT_Encode4(116724),
     /*    150 */ /*TargetOpcode::G_INTRINSIC_LRINT*//*Label 12*/ GIMT_Encode4(117215),
     /*    154 */ /*TargetOpcode::G_INTRINSIC_LLRINT*//*Label 13*/ GIMT_Encode4(117483),
     /*    158 */ /*TargetOpcode::G_INTRINSIC_ROUNDEVEN*//*Label 14*/ GIMT_Encode4(117633),
     /*    162 */ /*TargetOpcode::G_READCYCLECOUNTER*//*Label 15*/ GIMT_Encode4(118124), GIMT_Encode4(0),
     /*    170 */ /*TargetOpcode::G_LOAD*//*Label 16*/ GIMT_Encode4(118157),
     /*    174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 17*/ GIMT_Encode4(127095),
     /*    178 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 18*/ GIMT_Encode4(128145), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    194 */ /*TargetOpcode::G_STORE*//*Label 19*/ GIMT_Encode4(131194), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    206 */ /*TargetOpcode::G_ATOMIC_CMPXCHG*//*Label 20*/ GIMT_Encode4(144720),
     /*    210 */ /*TargetOpcode::G_ATOMICRMW_XCHG*//*Label 21*/ GIMT_Encode4(146071),
     /*    214 */ /*TargetOpcode::G_ATOMICRMW_ADD*//*Label 22*/ GIMT_Encode4(147063),
     /*    218 */ /*TargetOpcode::G_ATOMICRMW_SUB*//*Label 23*/ GIMT_Encode4(148055),
     /*    222 */ /*TargetOpcode::G_ATOMICRMW_AND*//*Label 24*/ GIMT_Encode4(149547), GIMT_Encode4(0),
     /*    230 */ /*TargetOpcode::G_ATOMICRMW_OR*//*Label 25*/ GIMT_Encode4(151039),
     /*    234 */ /*TargetOpcode::G_ATOMICRMW_XOR*//*Label 26*/ GIMT_Encode4(152031),
     /*    238 */ /*TargetOpcode::G_ATOMICRMW_MAX*//*Label 27*/ GIMT_Encode4(153023),
     /*    242 */ /*TargetOpcode::G_ATOMICRMW_MIN*//*Label 28*/ GIMT_Encode4(154015),
     /*    246 */ /*TargetOpcode::G_ATOMICRMW_UMAX*//*Label 29*/ GIMT_Encode4(155007),
     /*    250 */ /*TargetOpcode::G_ATOMICRMW_UMIN*//*Label 30*/ GIMT_Encode4(155999),
     /*    254 */ /*TargetOpcode::G_ATOMICRMW_FADD*//*Label 31*/ GIMT_Encode4(156991), GIMT_Encode4(0),
     /*    262 */ /*TargetOpcode::G_ATOMICRMW_FMAX*//*Label 32*/ GIMT_Encode4(157696),
     /*    266 */ /*TargetOpcode::G_ATOMICRMW_FMIN*//*Label 33*/ GIMT_Encode4(158401),
     /*    270 */ /*TargetOpcode::G_ATOMICRMW_FMAXIMUM*//*Label 34*/ GIMT_Encode4(159106),
     /*    274 */ /*TargetOpcode::G_ATOMICRMW_FMINIMUM*//*Label 35*/ GIMT_Encode4(159811), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    294 */ /*TargetOpcode::G_FENCE*//*Label 36*/ GIMT_Encode4(160516), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    314 */ /*TargetOpcode::G_INTRINSIC*//*Label 37*/ GIMT_Encode4(160567),
     /*    318 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 38*/ GIMT_Encode4(265754), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    330 */ /*TargetOpcode::G_ANYEXT*//*Label 39*/ GIMT_Encode4(277270),
     /*    334 */ /*TargetOpcode::G_TRUNC*//*Label 40*/ GIMT_Encode4(277560),
     /*    338 */ /*TargetOpcode::G_CONSTANT*//*Label 41*/ GIMT_Encode4(278997),
     /*    342 */ /*TargetOpcode::G_FCONSTANT*//*Label 42*/ GIMT_Encode4(279117), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    354 */ /*TargetOpcode::G_SEXT*//*Label 43*/ GIMT_Encode4(279358),
     /*    358 */ /*TargetOpcode::G_SEXT_INREG*//*Label 44*/ GIMT_Encode4(281256),
     /*    362 */ /*TargetOpcode::G_ZEXT*//*Label 45*/ GIMT_Encode4(282910),
     /*    366 */ /*TargetOpcode::G_SHL*//*Label 46*/ GIMT_Encode4(285689),
     /*    370 */ /*TargetOpcode::G_LSHR*//*Label 47*/ GIMT_Encode4(286514),
     /*    374 */ /*TargetOpcode::G_ASHR*//*Label 48*/ GIMT_Encode4(287058), GIMT_Encode4(0),
     /*    382 */ /*TargetOpcode::G_FSHR*//*Label 49*/ GIMT_Encode4(287883),
     /*    386 */ /*TargetOpcode::G_ROTR*//*Label 50*/ GIMT_Encode4(288013), GIMT_Encode4(0),
     /*    394 */ /*TargetOpcode::G_ICMP*//*Label 51*/ GIMT_Encode4(288555), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    410 */ /*TargetOpcode::G_SELECT*//*Label 52*/ GIMT_Encode4(296332), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    454 */ /*TargetOpcode::G_UMULH*//*Label 53*/ GIMT_Encode4(297377),
     /*    458 */ /*TargetOpcode::G_SMULH*//*Label 54*/ GIMT_Encode4(297861),
     /*    462 */ /*TargetOpcode::G_UADDSAT*//*Label 55*/ GIMT_Encode4(298345),
     /*    466 */ /*TargetOpcode::G_SADDSAT*//*Label 56*/ GIMT_Encode4(298817),
     /*    470 */ /*TargetOpcode::G_USUBSAT*//*Label 57*/ GIMT_Encode4(301193),
     /*    474 */ /*TargetOpcode::G_SSUBSAT*//*Label 58*/ GIMT_Encode4(301665), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    518 */ /*TargetOpcode::G_FADD*//*Label 59*/ GIMT_Encode4(303055),
     /*    522 */ /*TargetOpcode::G_FSUB*//*Label 60*/ GIMT_Encode4(304853),
     /*    526 */ /*TargetOpcode::G_FMUL*//*Label 61*/ GIMT_Encode4(305591),
     /*    530 */ /*TargetOpcode::G_FMA*//*Label 62*/ GIMT_Encode4(310207), GIMT_Encode4(0),
     /*    538 */ /*TargetOpcode::G_FDIV*//*Label 63*/ GIMT_Encode4(326480), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    586 */ /*TargetOpcode::G_FNEG*//*Label 64*/ GIMT_Encode4(327096),
     /*    590 */ /*TargetOpcode::G_FPEXT*//*Label 65*/ GIMT_Encode4(330603),
     /*    594 */ /*TargetOpcode::G_FPTRUNC*//*Label 66*/ GIMT_Encode4(330851),
     /*    598 */ /*TargetOpcode::G_FPTOSI*//*Label 67*/ GIMT_Encode4(331039),
     /*    602 */ /*TargetOpcode::G_FPTOUI*//*Label 68*/ GIMT_Encode4(332016),
     /*    606 */ /*TargetOpcode::G_SITOFP*//*Label 69*/ GIMT_Encode4(332993),
     /*    610 */ /*TargetOpcode::G_UITOFP*//*Label 70*/ GIMT_Encode4(337621),
     /*    614 */ /*TargetOpcode::G_FPTOSI_SAT*//*Label 71*/ GIMT_Encode4(341627),
     /*    618 */ /*TargetOpcode::G_FPTOUI_SAT*//*Label 72*/ GIMT_Encode4(341947),
     /*    622 */ /*TargetOpcode::G_FABS*//*Label 73*/ GIMT_Encode4(342267), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    634 */ /*TargetOpcode::G_FCANONICALIZE*//*Label 74*/ GIMT_Encode4(343124),
     /*    638 */ /*TargetOpcode::G_FMINNUM*//*Label 75*/ GIMT_Encode4(343406),
     /*    642 */ /*TargetOpcode::G_FMAXNUM*//*Label 76*/ GIMT_Encode4(343784),
     /*    646 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 77*/ GIMT_Encode4(344162),
     /*    650 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 78*/ GIMT_Encode4(344512),
     /*    654 */ /*TargetOpcode::G_FMINIMUM*//*Label 79*/ GIMT_Encode4(344862),
     /*    658 */ /*TargetOpcode::G_FMAXIMUM*//*Label 80*/ GIMT_Encode4(345565), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    694 */ /*TargetOpcode::G_PTR_ADD*//*Label 81*/ GIMT_Encode4(346268), GIMT_Encode4(0),
     /*    702 */ /*TargetOpcode::G_SMIN*//*Label 82*/ GIMT_Encode4(346768),
     /*    706 */ /*TargetOpcode::G_SMAX*//*Label 83*/ GIMT_Encode4(347172),
     /*    710 */ /*TargetOpcode::G_UMIN*//*Label 84*/ GIMT_Encode4(347576),
     /*    714 */ /*TargetOpcode::G_UMAX*//*Label 85*/ GIMT_Encode4(347980),
     /*    718 */ /*TargetOpcode::G_ABS*//*Label 86*/ GIMT_Encode4(348384),
     /*    722 */ /*TargetOpcode::G_LROUND*//*Label 87*/ GIMT_Encode4(349199),
     /*    726 */ /*TargetOpcode::G_LLROUND*//*Label 88*/ GIMT_Encode4(349365),
     /*    730 */ /*TargetOpcode::G_BR*//*Label 89*/ GIMT_Encode4(349464), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    746 */ /*TargetOpcode::G_EXTRACT_SUBVECTOR*//*Label 90*/ GIMT_Encode4(349480),
     /*    750 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 91*/ GIMT_Encode4(354852),
     /*    754 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 92*/ GIMT_Encode4(387774), GIMT_Encode4(0),
     /*    762 */ /*TargetOpcode::G_SPLAT_VECTOR*//*Label 93*/ GIMT_Encode4(390692), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    774 */ /*TargetOpcode::G_CTTZ*//*Label 94*/ GIMT_Encode4(393012), GIMT_Encode4(0),
     /*    782 */ /*TargetOpcode::G_CTLZ*//*Label 95*/ GIMT_Encode4(393164), GIMT_Encode4(0),
     /*    790 */ /*TargetOpcode::G_CTPOP*//*Label 96*/ GIMT_Encode4(393838),
     /*    794 */ /*TargetOpcode::G_BSWAP*//*Label 97*/ GIMT_Encode4(393998),
     /*    798 */ /*TargetOpcode::G_BITREVERSE*//*Label 98*/ GIMT_Encode4(394312),
     /*    802 */ /*TargetOpcode::G_FCEIL*//*Label 99*/ GIMT_Encode4(394466), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    850 */ /*TargetOpcode::G_FSQRT*//*Label 100*/ GIMT_Encode4(394957),
     /*    854 */ /*TargetOpcode::G_FFLOOR*//*Label 101*/ GIMT_Encode4(395257),
     /*    858 */ /*TargetOpcode::G_FRINT*//*Label 102*/ GIMT_Encode4(395748),
     /*    862 */ /*TargetOpcode::G_FNEARBYINT*//*Label 103*/ GIMT_Encode4(396239), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    890 */ /*TargetOpcode::G_STRICT_FADD*//*Label 104*/ GIMT_Encode4(396730),
     /*    894 */ /*TargetOpcode::G_STRICT_FSUB*//*Label 105*/ GIMT_Encode4(397856),
     /*    898 */ /*TargetOpcode::G_STRICT_FMUL*//*Label 106*/ GIMT_Encode4(398472),
     /*    902 */ /*TargetOpcode::G_STRICT_FDIV*//*Label 107*/ GIMT_Encode4(402194), GIMT_Encode4(0),
     /*    910 */ /*TargetOpcode::G_STRICT_FMA*//*Label 108*/ GIMT_Encode4(402810),
     /*    914 */ /*TargetOpcode::G_STRICT_FSQRT*//*Label 109*/ GIMT_Encode4(418417), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    950 */ /*TargetOpcode::G_TRAP*//*Label 110*/ GIMT_Encode4(418717),
     /*    954 */ /*TargetOpcode::G_DEBUGTRAP*//*Label 111*/ GIMT_Encode4(418731),
     /*    958 */ /*TargetOpcode::G_UBSANTRAP*//*Label 112*/ GIMT_Encode4(418752), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    970 */ /*TargetOpcode::G_VECREDUCE_FADD*//*Label 113*/ GIMT_Encode4(418777), GIMT_Encode4(0),
     /*    978 */ /*TargetOpcode::G_VECREDUCE_FMAX*//*Label 114*/ GIMT_Encode4(419087),
     /*    982 */ /*TargetOpcode::G_VECREDUCE_FMIN*//*Label 115*/ GIMT_Encode4(419258),
     /*    986 */ /*TargetOpcode::G_VECREDUCE_FMAXIMUM*//*Label 116*/ GIMT_Encode4(419429),
     /*    990 */ /*TargetOpcode::G_VECREDUCE_FMINIMUM*//*Label 117*/ GIMT_Encode4(419600),
     /*    994 */ /*TargetOpcode::G_VECREDUCE_ADD*//*Label 118*/ GIMT_Encode4(419771), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   1014 */ /*TargetOpcode::G_VECREDUCE_SMAX*//*Label 119*/ GIMT_Encode4(420900),
     /*   1018 */ /*TargetOpcode::G_VECREDUCE_SMIN*//*Label 120*/ GIMT_Encode4(421103),
     /*   1022 */ /*TargetOpcode::G_VECREDUCE_UMAX*//*Label 121*/ GIMT_Encode4(421306),
     /*   1026 */ /*TargetOpcode::G_VECREDUCE_UMIN*//*Label 122*/ GIMT_Encode4(421509), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3278 */ /*AArch64::G_AARCH64_PREFETCH*//*Label 123*/ GIMT_Encode4(421712), GIMT_Encode4(0),
     /*   3286 */ /*AArch64::G_BSP*//*Label 124*/ GIMT_Encode4(421852),
     /*   3290 */ /*AArch64::G_DUP*//*Label 125*/ GIMT_Encode4(422840),
     /*   3294 */ /*AArch64::G_DUPLANE16*//*Label 126*/ GIMT_Encode4(424823),
     /*   3298 */ /*AArch64::G_DUPLANE32*//*Label 127*/ GIMT_Encode4(425078),
     /*   3302 */ /*AArch64::G_DUPLANE64*//*Label 128*/ GIMT_Encode4(425333),
     /*   3306 */ /*AArch64::G_DUPLANE8*//*Label 129*/ GIMT_Encode4(425479),
     /*   3310 */ /*AArch64::G_EXT*//*Label 130*/ GIMT_Encode4(425658),
     /*   3314 */ /*AArch64::G_FCMEQ*//*Label 131*/ GIMT_Encode4(427308),
     /*   3318 */ /*AArch64::G_FCMGE*//*Label 132*/ GIMT_Encode4(427867),
     /*   3322 */ /*AArch64::G_FCMGT*//*Label 133*/ GIMT_Encode4(428959),
     /*   3326 */ /*AArch64::G_REV16*//*Label 134*/ GIMT_Encode4(430051),
     /*   3330 */ /*AArch64::G_REV32*//*Label 135*/ GIMT_Encode4(430205),
     /*   3334 */ /*AArch64::G_REV64*//*Label 136*/ GIMT_Encode4(430381),
     /*   3338 */ /*AArch64::G_SADDLP*//*Label 137*/ GIMT_Encode4(430655),
     /*   3342 */ /*AArch64::G_SADDLV*//*Label 138*/ GIMT_Encode4(430861),
     /*   3346 */ /*AArch64::G_SDOT*//*Label 139*/ GIMT_Encode4(431260),
     /*   3350 */ /*AArch64::G_SITOF*//*Label 140*/ GIMT_Encode4(431630),
     /*   3354 */ /*AArch64::G_SMULL*//*Label 141*/ GIMT_Encode4(431747),
     /*   3358 */ /*AArch64::G_TRN1*//*Label 142*/ GIMT_Encode4(432980),
     /*   3362 */ /*AArch64::G_TRN2*//*Label 143*/ GIMT_Encode4(433760),
     /*   3366 */ /*AArch64::G_UADDLP*//*Label 144*/ GIMT_Encode4(434540),
     /*   3370 */ /*AArch64::G_UADDLV*//*Label 145*/ GIMT_Encode4(434746),
     /*   3374 */ /*AArch64::G_UDOT*//*Label 146*/ GIMT_Encode4(435613),
     /*   3378 */ /*AArch64::G_UITOF*//*Label 147*/ GIMT_Encode4(435983),
     /*   3382 */ /*AArch64::G_UMULL*//*Label 148*/ GIMT_Encode4(436100),
     /*   3386 */ /*AArch64::G_UZP1*//*Label 149*/ GIMT_Encode4(437333),
     /*   3390 */ /*AArch64::G_UZP2*//*Label 150*/ GIMT_Encode4(438113),
     /*   3394 */ /*AArch64::G_VASHR*//*Label 151*/ GIMT_Encode4(438893),
     /*   3398 */ /*AArch64::G_VLSHR*//*Label 152*/ GIMT_Encode4(439591),
     /*   3402 */ /*AArch64::G_ZIP1*//*Label 153*/ GIMT_Encode4(440047),
     /*   3406 */ /*AArch64::G_ZIP2*//*Label 154*/ GIMT_Encode4(440827),
     /*   3410 */ // Label 0: @3410
     /*   3410 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 169*/ GIMT_Encode4(37016),
     /*   3421 */ /*GILLT_s32*//*Label 156*/ GIMT_Encode4(3509),
     /*   3425 */ /*GILLT_s64*//*Label 157*/ GIMT_Encode4(6288), GIMT_Encode4(0),
     /*   3433 */ /*GILLT_v2s32*//*Label 158*/ GIMT_Encode4(12228),
     /*   3437 */ /*GILLT_v2s64*//*Label 159*/ GIMT_Encode4(15836),
     /*   3441 */ /*GILLT_v4s16*//*Label 160*/ GIMT_Encode4(21738),
     /*   3445 */ /*GILLT_v4s32*//*Label 161*/ GIMT_Encode4(25236),
     /*   3449 */ /*GILLT_v8s8*//*Label 162*/ GIMT_Encode4(31414),
     /*   3453 */ /*GILLT_v8s16*//*Label 163*/ GIMT_Encode4(32264),
     /*   3457 */ /*GILLT_v16s8*//*Label 164*/ GIMT_Encode4(35842), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3477 */ /*GILLT_nxv2s64*//*Label 165*/ GIMT_Encode4(36566), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3489 */ /*GILLT_nxv4s32*//*Label 166*/ GIMT_Encode4(36938), GIMT_Encode4(0),
     /*   3497 */ /*GILLT_nxv8s16*//*Label 167*/ GIMT_Encode4(36964), GIMT_Encode4(0),
     /*   3505 */ /*GILLT_nxv16s8*//*Label 168*/ GIMT_Encode4(36990),
     /*   3509 */ // Label 156: @3509
     /*   3509 */ GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(6287),
     /*   3514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   3517 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   3520 */   GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(3553), // Rule ID 13345 //
     /*   3525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   3529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   3533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*   3540 */     // (add:{ *:[i32] } addsub_shifted_imm32:{ *:[i32] }:$imm, GPR32sp:{ *:[i32] }:$Rn)  =>  (ADDWri:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   3540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*   3543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   3547 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   3551 */     GIR_RootConstrainSelectedInstOperands,
     /*   3552 */     // GIR_Coverage, 13345,
     /*   3552 */     GIR_EraseRootFromParent_Done,
     /*   3553 */   // Label 171: @3553
     /*   3553 */   GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(3705), // Rule ID 13782 //
     /*   3558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3585 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3588 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   3593 */     // MIs[2] pattern
     /*   3593 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3596 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3605 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3607 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3607 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3610 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3614 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3621 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3624 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3628 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3633 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3636 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3640 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3643 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3648 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3653 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   3665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3670 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3673 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3677 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3687 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3694 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3699 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3704 */     // GIR_Coverage, 13782,
     /*   3704 */     GIR_EraseRootFromParent_Done,
     /*   3705 */   // Label 172: @3705
     /*   3705 */   GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(3857), // Rule ID 15642 //
     /*   3710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3737 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3740 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   3745 */     // MIs[2] pattern
     /*   3745 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3748 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3757 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3759 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1344:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3759 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3762 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3766 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3773 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3776 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3780 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3785 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3788 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3792 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3795 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3800 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3805 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3810 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3813 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   3817 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3822 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3825 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3829 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3832 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3839 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3846 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3851 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3856 */     // GIR_Coverage, 15642,
     /*   3856 */     GIR_EraseRootFromParent_Done,
     /*   3857 */   // Label 173: @3857
     /*   3857 */   GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(4009), // Rule ID 15654 //
     /*   3862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3889 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3892 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   3897 */     // MIs[2] pattern
     /*   3897 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3900 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3909 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3911 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1350:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3911 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3914 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3918 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3923 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3925 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3928 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3932 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3937 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3940 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3944 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3947 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3952 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3957 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3962 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3965 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   3969 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3974 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3977 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3981 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3991 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3998 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4003 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4008 */     // GIR_Coverage, 15654,
     /*   4008 */     GIR_EraseRootFromParent_Done,
     /*   4009 */   // Label 174: @4009
     /*   4009 */   GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(4161), // Rule ID 15666 //
     /*   4014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4041 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4044 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   4049 */     // MIs[2] pattern
     /*   4049 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4052 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4061 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4063 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1343:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4063 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4066 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4070 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4077 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4080 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4084 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4089 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4092 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   4096 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4099 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4104 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4109 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   4121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4126 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4129 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4133 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4136 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4143 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4150 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4155 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4160 */     // GIR_Coverage, 15666,
     /*   4160 */     GIR_EraseRootFromParent_Done,
     /*   4161 */   // Label 175: @4161
     /*   4161 */   GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(4194), // Rule ID 91 //
     /*   4166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   4170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   4174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*   4181 */     // (add:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (ADDWri:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   4181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*   4184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4186 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4188 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   4192 */     GIR_RootConstrainSelectedInstOperands,
     /*   4193 */     // GIR_Coverage, 91,
     /*   4193 */     GIR_EraseRootFromParent_Done,
     /*   4194 */   // Label 176: @4194
     /*   4194 */   GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(4346), // Rule ID 2652 //
     /*   4199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4230 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4233 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   4238 */     // MIs[2] pattern
     /*   4238 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4241 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4246 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4248 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4248 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4251 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4255 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4260 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4262 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4265 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4269 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4274 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4277 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4281 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4284 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4289 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4294 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   4306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4311 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4314 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4318 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4321 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4328 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4335 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4340 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4345 */     // GIR_Coverage, 2652,
     /*   4345 */     GIR_EraseRootFromParent_Done,
     /*   4346 */   // Label 177: @4346
     /*   4346 */   GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(4498), // Rule ID 10060 //
     /*   4351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4382 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4385 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   4390 */     // MIs[2] pattern
     /*   4390 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4393 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4398 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4400 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1344:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4400 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4403 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4407 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4414 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4417 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4421 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4426 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4429 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4433 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4436 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4441 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4446 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   4458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4463 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4466 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4470 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4480 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4487 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4492 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4497 */     // GIR_Coverage, 10060,
     /*   4497 */     GIR_EraseRootFromParent_Done,
     /*   4498 */   // Label 178: @4498
     /*   4498 */   GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(4650), // Rule ID 10072 //
     /*   4503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4534 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4537 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   4542 */     // MIs[2] pattern
     /*   4542 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4545 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4550 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4552 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1350:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4552 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4555 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4559 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4566 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4569 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4573 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4578 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4581 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4585 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4588 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4593 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4598 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4603 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4606 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   4610 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4615 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4618 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4622 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4632 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4639 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4644 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4649 */     // GIR_Coverage, 10072,
     /*   4649 */     GIR_EraseRootFromParent_Done,
     /*   4650 */   // Label 179: @4650
     /*   4650 */   GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(4802), // Rule ID 10084 //
     /*   4655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4686 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4689 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   4694 */     // MIs[2] pattern
     /*   4694 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4697 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4702 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4704 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1343:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4704 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4707 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4711 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4718 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4721 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4725 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4730 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4733 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4737 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4740 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4745 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4750 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4755 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4758 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   4762 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4767 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4770 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4774 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4784 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4791 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4796 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4801 */     // GIR_Coverage, 10084,
     /*   4801 */     GIR_EraseRootFromParent_Done,
     /*   4802 */   // Label 180: @4802
     /*   4802 */   GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(4959), // Rule ID 15685 //
     /*   4807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   4810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4834 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   4837 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   4842 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   4846 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   4848 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   4853 */     // MIs[2] pred
     /*   4853 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   4858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4862 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4864 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   4864 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4867 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4871 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4878 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4881 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4885 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4890 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4893 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   4897 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4900 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4905 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4910 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*   4922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4927 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   4931 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4941 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4948 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4953 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4958 */     // GIR_Coverage, 15685,
     /*   4958 */     GIR_EraseRootFromParent_Done,
     /*   4959 */   // Label 181: @4959
     /*   4959 */   GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(5116), // Rule ID 15686 //
     /*   4964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   4967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4991 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   4994 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   4999 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   5003 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5005 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5010 */     // MIs[2] pred
     /*   5010 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5019 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5021 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5021 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5024 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5028 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5035 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5038 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5042 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5047 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5050 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   5054 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5057 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5062 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5067 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*   5079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5084 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5088 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5098 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5105 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5110 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5115 */     // GIR_Coverage, 15686,
     /*   5115 */     GIR_EraseRootFromParent_Done,
     /*   5116 */   // Label 182: @5116
     /*   5116 */   GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(5273), // Rule ID 15687 //
     /*   5121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5148 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5151 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5156 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   5160 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5162 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5167 */     // MIs[2] pred
     /*   5167 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5176 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5178 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5178 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5181 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5185 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5190 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5192 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5195 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5199 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5204 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5207 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   5211 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5214 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5219 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5224 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*   5236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5241 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5245 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5248 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5255 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5262 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5267 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5272 */     // GIR_Coverage, 15687,
     /*   5272 */     GIR_EraseRootFromParent_Done,
     /*   5273 */   // Label 183: @5273
     /*   5273 */   GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(5430), // Rule ID 15688 //
     /*   5278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5297 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5301 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5305 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5308 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5313 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   5317 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5319 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5324 */     // MIs[2] pred
     /*   5324 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5333 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5335 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5335 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5338 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5342 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5349 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5352 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5356 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5361 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5364 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   5368 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5371 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5376 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5381 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5386 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5389 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*   5393 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5398 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5402 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5405 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5412 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5419 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5424 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5429 */     // GIR_Coverage, 15688,
     /*   5429 */     GIR_EraseRootFromParent_Done,
     /*   5430 */   // Label 184: @5430
     /*   5430 */   GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(5587), // Rule ID 10176 //
     /*   5435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5466 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5469 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5474 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   5478 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5480 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5485 */     // MIs[2] pred
     /*   5485 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5490 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5492 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5492 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5495 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5499 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5506 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5509 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5513 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5518 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5521 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5525 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5528 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5533 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5538 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*   5550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5555 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5559 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5569 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5576 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5581 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5586 */     // GIR_Coverage, 10176,
     /*   5586 */     GIR_EraseRootFromParent_Done,
     /*   5587 */   // Label 185: @5587
     /*   5587 */   GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(5744), // Rule ID 10177 //
     /*   5592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5623 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5626 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5631 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   5635 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5637 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5642 */     // MIs[2] pred
     /*   5642 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5647 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5649 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5649 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5652 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5656 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5663 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5666 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5670 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5675 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5678 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5682 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5685 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5690 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5695 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*   5707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5712 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5716 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5726 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5733 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5738 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5743 */     // GIR_Coverage, 10177,
     /*   5743 */     GIR_EraseRootFromParent_Done,
     /*   5744 */   // Label 186: @5744
     /*   5744 */   GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(5901), // Rule ID 10178 //
     /*   5749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5780 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5783 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5788 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   5792 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5794 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5799 */     // MIs[2] pred
     /*   5799 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5804 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5806 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5806 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5809 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5813 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5820 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5823 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5827 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5832 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5835 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5839 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5842 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5847 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5852 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*   5864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5869 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5873 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5883 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5890 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5895 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5900 */     // GIR_Coverage, 10178,
     /*   5900 */     GIR_EraseRootFromParent_Done,
     /*   5901 */   // Label 187: @5901
     /*   5901 */   GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(6058), // Rule ID 10179 //
     /*   5906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5937 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5940 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5945 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   5949 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5951 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5956 */     // MIs[2] pred
     /*   5956 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5961 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5963 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5963 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5966 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5970 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5975 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5977 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5980 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5984 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5989 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5992 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5996 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5999 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   6004 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   6009 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   6017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*   6021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6026 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   6030 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   6033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6040 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   6047 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6052 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6057 */     // GIR_Coverage, 10179,
     /*   6057 */     GIR_EraseRootFromParent_Done,
     /*   6058 */   // Label 188: @6058
     /*   6058 */   GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(6091), // Rule ID 13349 //
     /*   6063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*   6078 */     // (add:{ *:[i32] } arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend, GPR32sp:{ *:[i32] }:$Rn)  =>  (ADDWrx:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)
     /*   6078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrx),
     /*   6081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6085 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*   6089 */     GIR_RootConstrainSelectedInstOperands,
     /*   6090 */     // GIR_Coverage, 13349,
     /*   6090 */     GIR_EraseRootFromParent_Done,
     /*   6091 */   // Label 189: @6091
     /*   6091 */   GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(6127), // Rule ID 13925 //
     /*   6096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*   6111 */     // (add:{ *:[i32] } neg_addsub_shifted_imm32:{ *:[i32] }:$imm, GPR32:{ *:[i32] }:$Rn)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   6111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*   6114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6118 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   6122 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*   6125 */     GIR_RootConstrainSelectedInstOperands,
     /*   6126 */     // GIR_Coverage, 13925,
     /*   6126 */     GIR_EraseRootFromParent_Done,
     /*   6127 */   // Label 190: @6127
     /*   6127 */   GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(6160), // Rule ID 97 //
     /*   6132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*   6147 */     // (add:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)  =>  (ADDWrx:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)
     /*   6147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrx),
     /*   6150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6152 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6154 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*   6158 */     GIR_RootConstrainSelectedInstOperands,
     /*   6159 */     // GIR_Coverage, 97,
     /*   6159 */     GIR_EraseRootFromParent_Done,
     /*   6160 */   // Label 191: @6160
     /*   6160 */   GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(6196), // Rule ID 3946 //
     /*   6165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*   6180 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   6180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*   6183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6185 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6187 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   6191 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*   6194 */     GIR_RootConstrainSelectedInstOperands,
     /*   6195 */     // GIR_Coverage, 3946,
     /*   6195 */     GIR_EraseRootFromParent_Done,
     /*   6196 */   // Label 192: @6196
     /*   6196 */   GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(6229), // Rule ID 13347 //
     /*   6201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*   6216 */     // (add:{ *:[i32] } arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ADDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*   6216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrs),
     /*   6219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6223 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*   6227 */     GIR_RootConstrainSelectedInstOperands,
     /*   6228 */     // GIR_Coverage, 13347,
     /*   6228 */     GIR_EraseRootFromParent_Done,
     /*   6229 */   // Label 193: @6229
     /*   6229 */   GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(6262), // Rule ID 95 //
     /*   6234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*   6249 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ADDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*   6249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrs),
     /*   6252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6254 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6256 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*   6260 */     GIR_RootConstrainSelectedInstOperands,
     /*   6261 */     // GIR_Coverage, 95,
     /*   6261 */     GIR_EraseRootFromParent_Done,
     /*   6262 */   // Label 194: @6262
     /*   6262 */   GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(6286), // Rule ID 93 //
     /*   6267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6279 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ADDWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*   6279 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDWrr),
     /*   6284 */     GIR_RootConstrainSelectedInstOperands,
     /*   6285 */     // GIR_Coverage, 93,
     /*   6285 */     GIR_Done,
     /*   6286 */   // Label 195: @6286
     /*   6286 */   GIM_Reject,
     /*   6287 */ // Label 170: @6287
     /*   6287 */ GIM_Reject,
     /*   6288 */ // Label 157: @6288
     /*   6288 */ GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(12227),
     /*   6293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   6296 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   6299 */   GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(6435), // Rule ID 5417 //
     /*   6304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6328 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6332 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6337 */     // MIs[1] Operand 2
     /*   6337 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6348 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6352 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6356 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6360 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6364 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6368 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6372 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6377 */     // MIs[3] Operand 2
     /*   6377 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6388 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6390 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6402 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6406 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6417 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6424 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6429 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6434 */     // GIR_Coverage, 5417,
     /*   6434 */     GIR_EraseRootFromParent_Done,
     /*   6435 */   // Label 197: @6435
     /*   6435 */   GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(6571), // Rule ID 5416 //
     /*   6440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6464 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6468 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6473 */     // MIs[1] Operand 2
     /*   6473 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6484 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6488 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6492 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6496 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6500 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6504 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6508 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6513 */     // MIs[3] Operand 2
     /*   6513 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6524 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6526 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6538 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6542 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6553 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6560 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6565 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6570 */     // GIR_Coverage, 5416,
     /*   6570 */     GIR_EraseRootFromParent_Done,
     /*   6571 */   // Label 198: @6571
     /*   6571 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(6707), // Rule ID 5426 //
     /*   6576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6604 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6609 */     // MIs[1] Operand 2
     /*   6609 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6620 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6624 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6628 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6632 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6636 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6640 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6644 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6649 */     // MIs[3] Operand 2
     /*   6649 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6660 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6662 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6662 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6665 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv2i32_v2i64),
     /*   6669 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6674 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6678 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6682 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6689 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6696 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6701 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6706 */     // GIR_Coverage, 5426,
     /*   6706 */     GIR_EraseRootFromParent_Done,
     /*   6707 */   // Label 199: @6707
     /*   6707 */   GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(6843), // Rule ID 5415 //
     /*   6712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6740 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6745 */     // MIs[1] Operand 2
     /*   6745 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6756 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6760 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6764 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6768 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6772 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6776 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6780 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6785 */     // MIs[3] Operand 2
     /*   6785 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6796 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6798 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6810 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6814 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6825 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6832 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6837 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6842 */     // GIR_Coverage, 5415,
     /*   6842 */     GIR_EraseRootFromParent_Done,
     /*   6843 */   // Label 200: @6843
     /*   6843 */   GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(6979), // Rule ID 5414 //
     /*   6848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6876 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6881 */     // MIs[1] Operand 2
     /*   6881 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6892 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6896 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6900 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6904 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6908 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6912 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6916 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6921 */     // MIs[3] Operand 2
     /*   6921 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6932 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6934 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6946 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6950 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6961 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6968 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6973 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6978 */     // GIR_Coverage, 5414,
     /*   6978 */     GIR_EraseRootFromParent_Done,
     /*   6979 */   // Label 201: @6979
     /*   6979 */   GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(7047), // Rule ID 6981 //
     /*   6984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   6996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7000 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7004 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7009 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /*   7013 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7017 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   7021 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   7025 */     // MIs[2] Rn
     /*   7025 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*   7030 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*   7034 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7036 */     // (add:{ *:[i64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }))  =>  (ADDPv2i64p:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn)
     /*   7036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /*   7039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   7045 */     GIR_RootConstrainSelectedInstOperands,
     /*   7046 */     // GIR_Coverage, 6981,
     /*   7046 */     GIR_EraseRootFromParent_Done,
     /*   7047 */   // Label 202: @7047
     /*   7047 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(7115), // Rule ID 14083 //
     /*   7052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   7064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7077 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   7081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   7089 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   7093 */     // MIs[2] Rn
     /*   7093 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*   7098 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /*   7102 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7104 */     // (add:{ *:[i64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (ADDPv2i64p:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn)
     /*   7104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /*   7107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   7113 */     GIR_RootConstrainSelectedInstOperands,
     /*   7114 */     // GIR_Coverage, 14083,
     /*   7114 */     GIR_EraseRootFromParent_Done,
     /*   7115 */   // Label 203: @7115
     /*   7115 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(7148), // Rule ID 13346 //
     /*   7120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*   7135 */     // (add:{ *:[i64] } addsub_shifted_imm64:{ *:[i64] }:$imm, GPR64sp:{ *:[i64] }:$Rn)  =>  (ADDXri:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*   7135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*   7138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   7142 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   7146 */     GIR_RootConstrainSelectedInstOperands,
     /*   7147 */     // GIR_Coverage, 13346,
     /*   7147 */     GIR_EraseRootFromParent_Done,
     /*   7148 */   // Label 204: @7148
     /*   7148 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(7281), // Rule ID 3998 //
     /*   7153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7169 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   7181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   7185 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7190 */     // MIs[2] Operand 2
     /*   7190 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*   7201 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7205 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7209 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7213 */     // MIs[3] Operand 1
     /*   7213 */     // No operand predicates
     /*   7213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7217 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7219 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7219 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*   7222 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7226 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7231 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   7238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7250 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   7256 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7261 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   7277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7279 */     GIR_RootConstrainSelectedInstOperands,
     /*   7280 */     // GIR_Coverage, 3998,
     /*   7280 */     GIR_EraseRootFromParent_Done,
     /*   7281 */   // Label 205: @7281
     /*   7281 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(7376), // Rule ID 3996 //
     /*   7286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7302 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7306 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7310 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7314 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7318 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7323 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7327 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7331 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7335 */     // MIs[3] Operand 1
     /*   7335 */     // No operand predicates
     /*   7335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7339 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7341 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7353 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7374 */     GIR_RootConstrainSelectedInstOperands,
     /*   7375 */     // GIR_Coverage, 3996,
     /*   7375 */     GIR_EraseRootFromParent_Done,
     /*   7376 */   // Label 206: @7376
     /*   7376 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(7471), // Rule ID 3997 //
     /*   7381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7409 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7413 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7418 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7422 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7426 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*   7430 */     // MIs[3] Operand 1
     /*   7430 */     // No operand predicates
     /*   7430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7434 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7436 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7448 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   7458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7469 */     GIR_RootConstrainSelectedInstOperands,
     /*   7470 */     // GIR_Coverage, 3997,
     /*   7470 */     GIR_EraseRootFromParent_Done,
     /*   7471 */   // Label 207: @7471
     /*   7471 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(7504), // Rule ID 92 //
     /*   7476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7480 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*   7491 */     // (add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (ADDXri:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*   7491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*   7494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7496 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   7498 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   7502 */     GIR_RootConstrainSelectedInstOperands,
     /*   7503 */     // GIR_Coverage, 92,
     /*   7503 */     GIR_EraseRootFromParent_Done,
     /*   7504 */   // Label 208: @7504
     /*   7504 */   GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(7637), // Rule ID 13935 //
     /*   7509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   7541 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   7545 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7550 */     // MIs[2] Operand 2
     /*   7550 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*   7561 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7565 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7569 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7573 */     // MIs[3] Operand 1
     /*   7573 */     // No operand predicates
     /*   7573 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7575 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7575 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*   7578 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7582 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7587 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   7594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7606 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   7612 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7617 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   7633 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   7635 */     GIR_RootConstrainSelectedInstOperands,
     /*   7636 */     // GIR_Coverage, 13935,
     /*   7636 */     GIR_EraseRootFromParent_Done,
     /*   7637 */   // Label 209: @7637
     /*   7637 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(7732), // Rule ID 13933 //
     /*   7642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7666 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7670 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7674 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7678 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7683 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7687 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7691 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7695 */     // MIs[3] Operand 1
     /*   7695 */     // No operand predicates
     /*   7695 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7697 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7709 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7725 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7728 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   7730 */     GIR_RootConstrainSelectedInstOperands,
     /*   7731 */     // GIR_Coverage, 13933,
     /*   7731 */     GIR_EraseRootFromParent_Done,
     /*   7732 */   // Label 210: @7732
     /*   7732 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(7827), // Rule ID 13934 //
     /*   7737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7757 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7773 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7778 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7782 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7786 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*   7790 */     // MIs[3] Operand 1
     /*   7790 */     // No operand predicates
     /*   7790 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7792 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7804 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   7814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7820 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7823 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   7825 */     GIR_RootConstrainSelectedInstOperands,
     /*   7826 */     // GIR_Coverage, 13934,
     /*   7826 */     GIR_EraseRootFromParent_Done,
     /*   7827 */   // Label 211: @7827
     /*   7827 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(7909), // Rule ID 13357 //
     /*   7832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7848 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7860 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7864 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7869 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7873 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7877 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   7881 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7890 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7892 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   7892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   7905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7907 */     GIR_RootConstrainSelectedInstOperands,
     /*   7908 */     // GIR_Coverage, 13357,
     /*   7908 */     GIR_EraseRootFromParent_Done,
     /*   7909 */   // Label 212: @7909
     /*   7909 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(7991), // Rule ID 13358 //
     /*   7914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7942 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7946 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7951 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7955 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7959 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   7963 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7972 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7974 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   7974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   7977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   7987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7989 */     GIR_RootConstrainSelectedInstOperands,
     /*   7990 */     // GIR_Coverage, 13358,
     /*   7990 */     GIR_EraseRootFromParent_Done,
     /*   7991 */   // Label 213: @7991
     /*   7991 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(8073), // Rule ID 123 //
     /*   7996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   8016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   8020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8028 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   8032 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8037 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   8041 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8045 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   8049 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8054 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   8056 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   8056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   8059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   8069 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   8071 */     GIR_RootConstrainSelectedInstOperands,
     /*   8072 */     // GIR_Coverage, 123,
     /*   8072 */     GIR_EraseRootFromParent_Done,
     /*   8073 */   // Label 214: @8073
     /*   8073 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(8155), // Rule ID 125 //
     /*   8078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   8098 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   8102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8106 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8110 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   8114 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8119 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   8123 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8127 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   8131 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8136 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   8138 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   8138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   8141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   8151 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   8153 */     GIR_RootConstrainSelectedInstOperands,
     /*   8154 */     // GIR_Coverage, 125,
     /*   8154 */     GIR_EraseRootFromParent_Done,
     /*   8155 */   // Label 215: @8155
     /*   8155 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(8213), // Rule ID 13777 //
     /*   8160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8175 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8178 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   8183 */     // MIs[1] pattern
     /*   8183 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8186 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8197 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   8200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8211 */     GIR_RootConstrainSelectedInstOperands,
     /*   8212 */     // GIR_Coverage, 13777,
     /*   8212 */     GIR_EraseRootFromParent_Done,
     /*   8213 */   // Label 216: @8213
     /*   8213 */   GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(8271), // Rule ID 15637 //
     /*   8218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8233 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8236 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   8241 */     // MIs[1] pattern
     /*   8241 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8244 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8255 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1344:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   8258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8269 */     GIR_RootConstrainSelectedInstOperands,
     /*   8270 */     // GIR_Coverage, 15637,
     /*   8270 */     GIR_EraseRootFromParent_Done,
     /*   8271 */   // Label 217: @8271
     /*   8271 */   GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(8329), // Rule ID 15649 //
     /*   8276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8291 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8294 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   8299 */     // MIs[1] pattern
     /*   8299 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8302 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8313 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1350:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   8316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8327 */     GIR_RootConstrainSelectedInstOperands,
     /*   8328 */     // GIR_Coverage, 15649,
     /*   8328 */     GIR_EraseRootFromParent_Done,
     /*   8329 */   // Label 218: @8329
     /*   8329 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(8387), // Rule ID 15661 //
     /*   8334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8349 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8352 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   8357 */     // MIs[1] pattern
     /*   8357 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8360 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8371 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1343:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   8374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8385 */     GIR_RootConstrainSelectedInstOperands,
     /*   8386 */     // GIR_Coverage, 15661,
     /*   8386 */     GIR_EraseRootFromParent_Done,
     /*   8387 */   // Label 219: @8387
     /*   8387 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(8484), // Rule ID 4013 //
     /*   8392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   8408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   8412 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*   8417 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   8421 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8425 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   8429 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8438 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8440 */     // (add:{ *:[i64] } (mul:{ *:[i64] } GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   8440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   8443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8452 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   8458 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8463 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   8471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8473 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   8476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   8480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   8482 */     GIR_RootConstrainSelectedInstOperands,
     /*   8483 */     // GIR_Coverage, 4013,
     /*   8483 */     GIR_EraseRootFromParent_Done,
     /*   8484 */   // Label 220: @8484
     /*   8484 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(8581), // Rule ID 13945 //
     /*   8489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   8505 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   8509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   8521 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8526 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*   8531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8535 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8537 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm), GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   8537 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   8540 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8544 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8549 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   8555 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8560 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   8568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8570 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   8573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   8577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   8579 */     GIR_RootConstrainSelectedInstOperands,
     /*   8580 */     // GIR_Coverage, 13945,
     /*   8580 */     GIR_EraseRootFromParent_Done,
     /*   8581 */   // Label 221: @8581
     /*   8581 */   GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(8639), // Rule ID 2649 //
     /*   8586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8605 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8608 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   8613 */     // MIs[1] pattern
     /*   8613 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8616 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8623 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   8626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8628 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8637 */     GIR_RootConstrainSelectedInstOperands,
     /*   8638 */     // GIR_Coverage, 2649,
     /*   8638 */     GIR_EraseRootFromParent_Done,
     /*   8639 */   // Label 222: @8639
     /*   8639 */   GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(8697), // Rule ID 10057 //
     /*   8644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8663 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8666 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   8671 */     // MIs[1] pattern
     /*   8671 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8674 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8681 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1344:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   8684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8686 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8695 */     GIR_RootConstrainSelectedInstOperands,
     /*   8696 */     // GIR_Coverage, 10057,
     /*   8696 */     GIR_EraseRootFromParent_Done,
     /*   8697 */   // Label 223: @8697
     /*   8697 */   GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(8755), // Rule ID 10069 //
     /*   8702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8721 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8724 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   8729 */     // MIs[1] pattern
     /*   8729 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8732 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8739 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1350:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   8742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8744 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8753 */     GIR_RootConstrainSelectedInstOperands,
     /*   8754 */     // GIR_Coverage, 10069,
     /*   8754 */     GIR_EraseRootFromParent_Done,
     /*   8755 */   // Label 224: @8755
     /*   8755 */   GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(8813), // Rule ID 10081 //
     /*   8760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8767 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8779 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8782 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   8787 */     // MIs[1] pattern
     /*   8787 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8790 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8797 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1343:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   8800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8802 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8811 */     GIR_RootConstrainSelectedInstOperands,
     /*   8812 */     // GIR_Coverage, 10081,
     /*   8812 */     GIR_EraseRootFromParent_Done,
     /*   8813 */   // Label 225: @8813
     /*   8813 */   GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(8910), // Rule ID 13946 //
     /*   8818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   8838 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   8842 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*   8847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   8851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8855 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   8859 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8864 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8866 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   8866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   8869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8878 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   8884 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8889 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   8897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   8902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   8906 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   8908 */     GIR_RootConstrainSelectedInstOperands,
     /*   8909 */     // GIR_Coverage, 13946,
     /*   8909 */     GIR_EraseRootFromParent_Done,
     /*   8910 */   // Label 226: @8910
     /*   8910 */   GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(9007), // Rule ID 13947 //
     /*   8915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   8935 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   8939 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8947 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   8951 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8956 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*   8961 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8963 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm), GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn))  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   8963 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   8966 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8970 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8975 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   8981 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8986 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   8994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8996 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   8999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9003 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   9005 */     GIR_RootConstrainSelectedInstOperands,
     /*   9006 */     // GIR_Coverage, 13947,
     /*   9006 */     GIR_EraseRootFromParent_Done,
     /*   9007 */   // Label 227: @9007
     /*   9007 */   GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(9170), // Rule ID 14055 //
     /*   9012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9028 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9032 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*   9036 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9040 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9044 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9049 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9054 */     // MIs[1] Operand 2
     /*   9054 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9069 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9071 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9071 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9074 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9078 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9083 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9085 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9088 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9092 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9097 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9100 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*   9104 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9107 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9112 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9117 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*   9129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9134 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9137 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   9141 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   9145 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9152 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9159 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9164 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9169 */     // GIR_Coverage, 14055,
     /*   9169 */     GIR_EraseRootFromParent_Done,
     /*   9170 */   // Label 228: @9170
     /*   9170 */   GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(9333), // Rule ID 14052 //
     /*   9175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9191 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9195 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*   9199 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9203 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9207 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9212 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9217 */     // MIs[1] Operand 2
     /*   9217 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9232 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9234 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9234 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9237 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9241 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9246 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9248 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9251 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9255 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9260 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9263 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*   9267 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9270 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9275 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9280 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9285 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9288 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*   9292 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9297 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9300 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   9304 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   9308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9315 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9322 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9327 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9332 */     // GIR_Coverage, 14052,
     /*   9332 */     GIR_EraseRootFromParent_Done,
     /*   9333 */   // Label 229: @9333
     /*   9333 */   GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(9483), // Rule ID 14061 //
     /*   9338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9362 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9366 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9371 */     // MIs[1] Operand 2
     /*   9371 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9386 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9388 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9388 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9391 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9395 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9402 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9405 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9409 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9414 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9417 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   9421 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9424 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9429 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9434 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   9446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9451 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9454 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9458 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9465 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9472 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9477 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9482 */     // GIR_Coverage, 14061,
     /*   9482 */     GIR_EraseRootFromParent_Done,
     /*   9483 */   // Label 230: @9483
     /*   9483 */   GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(9633), // Rule ID 14064 //
     /*   9488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9504 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9508 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9512 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9516 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9521 */     // MIs[1] Operand 2
     /*   9521 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9536 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9538 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9538 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9541 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9545 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9552 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9555 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9559 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9564 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9567 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   9571 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9574 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9579 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9584 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9589 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9592 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*   9596 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9601 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9604 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9615 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9622 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9627 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9632 */     // GIR_Coverage, 14064,
     /*   9632 */     GIR_EraseRootFromParent_Done,
     /*   9633 */   // Label 231: @9633
     /*   9633 */   GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(9783), // Rule ID 14060 //
     /*   9638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9650 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9654 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9658 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9662 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9666 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9671 */     // MIs[1] Operand 2
     /*   9671 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9686 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9688 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9688 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9691 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9695 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9702 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9705 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9709 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9714 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9717 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   9721 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9724 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9729 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9734 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9739 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9742 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   9746 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9751 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9754 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9765 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9772 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9777 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9782 */     // GIR_Coverage, 14060,
     /*   9782 */     GIR_EraseRootFromParent_Done,
     /*   9783 */   // Label 232: @9783
     /*   9783 */   GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(9946), // Rule ID 5399 //
     /*   9788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*   9816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9820 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9824 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9829 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9834 */     // MIs[1] Operand 2
     /*   9834 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9845 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9847 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9847 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9850 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9854 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9861 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9864 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9868 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9873 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9876 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*   9880 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9883 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9888 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9893 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*   9905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9910 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9913 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   9917 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   9921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9928 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9935 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9940 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9945 */     // GIR_Coverage, 5399,
     /*   9945 */     GIR_EraseRootFromParent_Done,
     /*   9946 */   // Label 233: @9946
     /*   9946 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(10109), // Rule ID 5396 //
     /*   9951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*   9979 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9983 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9987 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9992 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9997 */     // MIs[1] Operand 2
     /*   9997 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  10008 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  10010 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  10010 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  10013 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10017 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  10024 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  10027 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  10031 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10036 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  10039 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  10043 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  10046 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10051 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10056 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10061 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  10064 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*  10068 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10073 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  10076 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  10080 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  10084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10091 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10098 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10103 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10108 */     // GIR_Coverage, 5396,
     /*  10108 */     GIR_EraseRootFromParent_Done,
     /*  10109 */   // Label 234: @10109
     /*  10109 */   GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(10259), // Rule ID 5423 //
     /*  10114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  10134 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10138 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  10142 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  10146 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10151 */     // MIs[1] Operand 2
     /*  10151 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  10162 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  10164 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  10164 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  10167 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10171 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10176 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  10178 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  10181 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  10185 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10190 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  10193 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  10197 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  10200 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10205 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10210 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  10218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  10222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10227 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  10230 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  10234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10241 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10248 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10253 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10258 */     // GIR_Coverage, 5423,
     /*  10258 */     GIR_EraseRootFromParent_Done,
     /*  10259 */   // Label 235: @10259
     /*  10259 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(10409), // Rule ID 5429 //
     /*  10264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  10284 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10288 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  10292 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  10296 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10301 */     // MIs[1] Operand 2
     /*  10301 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  10312 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  10314 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  10314 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  10317 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10321 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  10328 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  10331 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  10335 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10340 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  10343 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  10347 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  10350 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10355 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10360 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10365 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  10368 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*  10372 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10377 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  10380 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  10384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10391 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10398 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10403 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10408 */     // GIR_Coverage, 5429,
     /*  10408 */     GIR_EraseRootFromParent_Done,
     /*  10409 */   // Label 236: @10409
     /*  10409 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(10559), // Rule ID 5422 //
     /*  10414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  10434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  10442 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  10446 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10451 */     // MIs[1] Operand 2
     /*  10451 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  10462 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  10464 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  10464 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  10467 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10471 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  10478 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  10481 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  10485 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10490 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  10493 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  10497 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  10500 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10505 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10510 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  10518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  10522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10527 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  10530 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  10534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10541 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10548 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10553 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10558 */     // GIR_Coverage, 5422,
     /*  10558 */     GIR_EraseRootFromParent_Done,
     /*  10559 */   // Label 237: @10559
     /*  10559 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(10592), // Rule ID 13350 //
     /*  10564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  10579 */     // (add:{ *:[i64] } arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend, GPR64sp:{ *:[i64] }:$Rn)  =>  (ADDXrx:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)
     /*  10579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrx),
     /*  10582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10586 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*  10590 */     GIR_RootConstrainSelectedInstOperands,
     /*  10591 */     // GIR_Coverage, 13350,
     /*  10591 */     GIR_EraseRootFromParent_Done,
     /*  10592 */   // Label 238: @10592
     /*  10592 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(10628), // Rule ID 13926 //
     /*  10597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  10612 */     // (add:{ *:[i64] } neg_addsub_shifted_imm64:{ *:[i64] }:$imm, GPR64:{ *:[i64] }:$Rn)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  10612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  10615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10619 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  10623 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  10626 */     GIR_RootConstrainSelectedInstOperands,
     /*  10627 */     // GIR_Coverage, 13926,
     /*  10627 */     GIR_EraseRootFromParent_Done,
     /*  10628 */   // Label 239: @10628
     /*  10628 */   GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(10740), // Rule ID 4012 //
     /*  10633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  10649 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  10653 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  10658 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  10663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10669 */     // (add:{ *:[i64] } (mul:{ *:[i64] } GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn, GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rm), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }), GPR64:{ *:[i64] }:$Ra)
     /*  10669 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  10672 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10676 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10681 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /*  10687 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  10692 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  10700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10709 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  10715 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  10720 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  10728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10730 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  10733 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  10736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*  10738 */     GIR_RootConstrainSelectedInstOperands,
     /*  10739 */     // GIR_Coverage, 4012,
     /*  10739 */     GIR_EraseRootFromParent_Done,
     /*  10740 */   // Label 240: @10740
     /*  10740 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(10773), // Rule ID 98 //
     /*  10745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  10760 */     // (add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)  =>  (ADDXrx:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)
     /*  10760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrx),
     /*  10763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10765 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10767 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*  10771 */     GIR_RootConstrainSelectedInstOperands,
     /*  10772 */     // GIR_Coverage, 98,
     /*  10772 */     GIR_EraseRootFromParent_Done,
     /*  10773 */   // Label 241: @10773
     /*  10773 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(10809), // Rule ID 3947 //
     /*  10778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  10793 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  10793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  10796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10798 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10800 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  10804 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  10807 */     GIR_RootConstrainSelectedInstOperands,
     /*  10808 */     // GIR_Coverage, 3947,
     /*  10808 */     GIR_EraseRootFromParent_Done,
     /*  10809 */   // Label 242: @10809
     /*  10809 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(10921), // Rule ID 13944 //
     /*  10814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10818 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  10834 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  10838 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  10843 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  10848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10850 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn, GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rm))  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }), GPR64:{ *:[i64] }:$Ra)
     /*  10850 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  10853 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10857 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10862 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /*  10868 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  10873 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  10881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10890 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  10896 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  10901 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  10909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10911 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  10914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  10917 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  10919 */     GIR_RootConstrainSelectedInstOperands,
     /*  10920 */     // GIR_Coverage, 13944,
     /*  10920 */     GIR_EraseRootFromParent_Done,
     /*  10921 */   // Label 243: @10921
     /*  10921 */   GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(10954), // Rule ID 13348 //
     /*  10926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  10941 */     // (add:{ *:[i64] } arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ADDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  10941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrs),
     /*  10944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10948 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  10952 */     GIR_RootConstrainSelectedInstOperands,
     /*  10953 */     // GIR_Coverage, 13348,
     /*  10953 */     GIR_EraseRootFromParent_Done,
     /*  10954 */   // Label 244: @10954
     /*  10954 */   GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(11017), // Rule ID 15677 //
     /*  10959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10974 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10977 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10982 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  10986 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10988 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10993 */     // MIs[1] pred
     /*  10993 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11004 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  11004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*  11007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  11009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  11013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  11015 */     GIR_RootConstrainSelectedInstOperands,
     /*  11016 */     // GIR_Coverage, 15677,
     /*  11016 */     GIR_EraseRootFromParent_Done,
     /*  11017 */   // Label 245: @11017
     /*  11017 */   GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(11080), // Rule ID 15678 //
     /*  11022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  11025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11037 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  11040 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  11045 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  11049 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  11051 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  11056 */     // MIs[1] pred
     /*  11056 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11067 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  11067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*  11070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  11072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  11076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  11078 */     GIR_RootConstrainSelectedInstOperands,
     /*  11079 */     // GIR_Coverage, 15678,
     /*  11079 */     GIR_EraseRootFromParent_Done,
     /*  11080 */   // Label 246: @11080
     /*  11080 */   GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(11143), // Rule ID 15679 //
     /*  11085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  11088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11100 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  11103 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  11108 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  11112 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  11114 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  11119 */     // MIs[1] pred
     /*  11119 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11128 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11130 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  11130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*  11133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  11135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  11139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  11141 */     GIR_RootConstrainSelectedInstOperands,
     /*  11142 */     // GIR_Coverage, 15679,
     /*  11142 */     GIR_EraseRootFromParent_Done,
     /*  11143 */   // Label 247: @11143
     /*  11143 */   GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(11206), // Rule ID 15680 //
     /*  11148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  11151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11163 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  11166 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  11171 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  11175 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  11177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  11182 */     // MIs[1] pred
     /*  11182 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11193 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  11193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*  11196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  11198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  11202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  11204 */     GIR_RootConstrainSelectedInstOperands,
     /*  11205 */     // GIR_Coverage, 15680,
     /*  11205 */     GIR_EraseRootFromParent_Done,
     /*  11206 */   // Label 248: @11206
     /*  11206 */   GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(11239), // Rule ID 96 //
     /*  11211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  11226 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ADDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  11226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrs),
     /*  11229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  11231 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  11233 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  11237 */     GIR_RootConstrainSelectedInstOperands,
     /*  11238 */     // GIR_Coverage, 96,
     /*  11238 */     GIR_EraseRootFromParent_Done,
     /*  11239 */   // Label 249: @11239
     /*  11239 */   GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(11302), // Rule ID 10168 //
     /*  11244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  11247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11251 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11263 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  11266 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  11271 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  11275 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  11277 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  11282 */     // MIs[1] pred
     /*  11282 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11289 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  11289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*  11292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  11294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  11298 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  11300 */     GIR_RootConstrainSelectedInstOperands,
     /*  11301 */     // GIR_Coverage, 10168,
     /*  11301 */     GIR_EraseRootFromParent_Done,
     /*  11302 */   // Label 250: @11302
     /*  11302 */   GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(11365), // Rule ID 10169 //
     /*  11307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  11310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11326 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  11329 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  11334 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  11338 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  11340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  11345 */     // MIs[1] pred
     /*  11345 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11352 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  11352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*  11355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  11357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  11361 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  11363 */     GIR_RootConstrainSelectedInstOperands,
     /*  11364 */     // GIR_Coverage, 10169,
     /*  11364 */     GIR_EraseRootFromParent_Done,
     /*  11365 */   // Label 251: @11365
     /*  11365 */   GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(11428), // Rule ID 10170 //
     /*  11370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  11373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11389 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  11392 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  11397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  11401 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  11403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  11408 */     // MIs[1] pred
     /*  11408 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11415 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  11415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*  11418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  11420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  11424 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  11426 */     GIR_RootConstrainSelectedInstOperands,
     /*  11427 */     // GIR_Coverage, 10170,
     /*  11427 */     GIR_EraseRootFromParent_Done,
     /*  11428 */   // Label 252: @11428
     /*  11428 */   GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(11491), // Rule ID 10171 //
     /*  11433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  11436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11452 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  11455 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  11460 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  11464 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  11466 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  11471 */     // MIs[1] pred
     /*  11471 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11478 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  11478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*  11481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  11483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  11487 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  11489 */     GIR_RootConstrainSelectedInstOperands,
     /*  11490 */     // GIR_Coverage, 10171,
     /*  11490 */     GIR_EraseRootFromParent_Done,
     /*  11491 */   // Label 253: @11491
     /*  11491 */   GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(11547), // Rule ID 13456 //
     /*  11496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11511 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  11514 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  11519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11534 */     // (add:{ *:[v1i64] } (intrinsic_wo_chain:{ *:[v1i64] } 670:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  11537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  11545 */     GIR_RootConstrainSelectedInstOperands,
     /*  11546 */     // GIR_Coverage, 13456,
     /*  11546 */     GIR_EraseRootFromParent_Done,
     /*  11547 */   // Label 254: @11547
     /*  11547 */   GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(11603), // Rule ID 13468 //
     /*  11552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11567 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  11570 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  11575 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11579 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11590 */     // (add:{ *:[v1i64] } (intrinsic_wo_chain:{ *:[v1i64] } 735:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  11593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  11601 */     GIR_RootConstrainSelectedInstOperands,
     /*  11602 */     // GIR_Coverage, 13468,
     /*  11602 */     GIR_EraseRootFromParent_Done,
     /*  11603 */   // Label 255: @11603
     /*  11603 */   GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(11670), // Rule ID 13684 //
     /*  11608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  11623 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11632 */     // MIs[1] imm
     /*  11632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11640 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11644 */     // MIs[2] Operand 1
     /*  11644 */     // No operand predicates
     /*  11644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11648 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11652 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11654 */     // (add:{ *:[v1i64] } (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  11657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11668 */     GIR_RootConstrainSelectedInstOperands,
     /*  11669 */     // GIR_Coverage, 13684,
     /*  11669 */     GIR_EraseRootFromParent_Done,
     /*  11670 */   // Label 256: @11670
     /*  11670 */   GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(11737), // Rule ID 13687 //
     /*  11675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  11690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11694 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11699 */     // MIs[1] imm
     /*  11699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11707 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11711 */     // MIs[2] Operand 1
     /*  11711 */     // No operand predicates
     /*  11711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11715 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11719 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11721 */     // (add:{ *:[v1i64] } (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  11724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11732 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11735 */     GIR_RootConstrainSelectedInstOperands,
     /*  11736 */     // GIR_Coverage, 13687,
     /*  11736 */     GIR_EraseRootFromParent_Done,
     /*  11737 */   // Label 257: @11737
     /*  11737 */   GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(11793), // Rule ID 997 //
     /*  11742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11761 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  11764 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  11769 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11773 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11780 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (intrinsic_wo_chain:{ *:[v1i64] } 670:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn))  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  11783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11785 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  11791 */     GIR_RootConstrainSelectedInstOperands,
     /*  11792 */     // GIR_Coverage, 997,
     /*  11792 */     GIR_EraseRootFromParent_Done,
     /*  11793 */   // Label 258: @11793
     /*  11793 */   GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(11849), // Rule ID 1058 //
     /*  11798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11817 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  11820 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  11825 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11834 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11836 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (intrinsic_wo_chain:{ *:[v1i64] } 735:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn))  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  11839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11841 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  11847 */     GIR_RootConstrainSelectedInstOperands,
     /*  11848 */     // GIR_Coverage, 1058,
     /*  11848 */     GIR_EraseRootFromParent_Done,
     /*  11849 */   // Label 259: @11849
     /*  11849 */   GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(11916), // Rule ID 2121 //
     /*  11854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  11873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11877 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11882 */     // MIs[1] imm
     /*  11882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11890 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11894 */     // MIs[2] Operand 1
     /*  11894 */     // No operand predicates
     /*  11894 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11898 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11900 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  11903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11905 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11911 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11914 */     GIR_RootConstrainSelectedInstOperands,
     /*  11915 */     // GIR_Coverage, 2121,
     /*  11915 */     GIR_EraseRootFromParent_Done,
     /*  11916 */   // Label 260: @11916
     /*  11916 */   GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(11983), // Rule ID 2130 //
     /*  11921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  11940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11944 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11949 */     // MIs[1] imm
     /*  11949 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11953 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11957 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11961 */     // MIs[2] Operand 1
     /*  11961 */     // No operand predicates
     /*  11961 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11965 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11967 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  11970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11972 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11978 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11981 */     GIR_RootConstrainSelectedInstOperands,
     /*  11982 */     // GIR_Coverage, 2130,
     /*  11982 */     GIR_EraseRootFromParent_Done,
     /*  11983 */   // Label 261: @11983
     /*  11983 */   GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(12031), // Rule ID 13455 //
     /*  11988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  12003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  12007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12018 */     // (add:{ *:[v1i64] } (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  12018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  12021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  12025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  12029 */     GIR_RootConstrainSelectedInstOperands,
     /*  12030 */     // GIR_Coverage, 13455,
     /*  12030 */     GIR_EraseRootFromParent_Done,
     /*  12031 */   // Label 262: @12031
     /*  12031 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(12079), // Rule ID 13467 //
     /*  12036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  12051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  12055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12066 */     // (add:{ *:[v1i64] } (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  12066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  12069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  12073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  12077 */     GIR_RootConstrainSelectedInstOperands,
     /*  12078 */     // GIR_Coverage, 13467,
     /*  12078 */     GIR_EraseRootFromParent_Done,
     /*  12079 */   // Label 263: @12079
     /*  12079 */   GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(12127), // Rule ID 996 //
     /*  12084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  12103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  12107 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12114 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn))  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  12114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  12117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12119 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  12121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  12125 */     GIR_RootConstrainSelectedInstOperands,
     /*  12126 */     // GIR_Coverage, 996,
     /*  12126 */     GIR_EraseRootFromParent_Done,
     /*  12127 */   // Label 264: @12127
     /*  12127 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(12175), // Rule ID 1057 //
     /*  12132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  12151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  12155 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12162 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn))  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  12162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  12165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12167 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  12169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  12173 */     GIR_RootConstrainSelectedInstOperands,
     /*  12174 */     // GIR_Coverage, 1057,
     /*  12174 */     GIR_EraseRootFromParent_Done,
     /*  12175 */   // Label 265: @12175
     /*  12175 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(12199), // Rule ID 94 //
     /*  12180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  12184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  12188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  12192 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ADDXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  12192 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDXrr),
     /*  12197 */     GIR_RootConstrainSelectedInstOperands,
     /*  12198 */     // GIR_Coverage, 94,
     /*  12198 */     GIR_Done,
     /*  12199 */   // Label 266: @12199
     /*  12199 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(12226), // Rule ID 1607 //
     /*  12204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12219 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (ADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  12219 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv1i64),
     /*  12224 */     GIR_RootConstrainSelectedInstOperands,
     /*  12225 */     // GIR_Coverage, 1607,
     /*  12225 */     GIR_Done,
     /*  12226 */   // Label 267: @12226
     /*  12226 */   GIM_Reject,
     /*  12227 */ // Label 196: @12227
     /*  12227 */ GIM_Reject,
     /*  12228 */ // Label 158: @12228
     /*  12228 */ GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(15835),
     /*  12233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  12236 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  12239 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(12427), // Rule ID 7002 //
     /*  12244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /*  12256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  12260 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  12264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12272 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12276 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12281 */     // MIs[2] Operand 2
     /*  12281 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  12292 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  12296 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12300 */     // MIs[3] Rn
     /*  12300 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12305 */     // MIs[3] Operand 2
     /*  12305 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(2),
     /*  12316 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  12320 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_ZIP2),
     /*  12324 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  12328 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  12332 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  12336 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12340 */     // MIs[5] Rn
     /*  12340 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12345 */     // MIs[5] Operand 2
     /*  12345 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(0),
     /*  12356 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/2, // MIs[6]
     /*  12360 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12364 */     // MIs[6] Rn
     /*  12364 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12369 */     // MIs[6] Operand 2
     /*  12369 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(2),
     /*  12380 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  12382 */     // (add:{ *:[v2i32] } (AArch64zip1:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })), (AArch64zip2:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /*  12382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  12385 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  12389 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12394 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12398 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12409 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12416 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12421 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12426 */     // GIR_Coverage, 7002,
     /*  12426 */     GIR_EraseRootFromParent_Done,
     /*  12427 */   // Label 269: @12427
     /*  12427 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(12615), // Rule ID 14094 //
     /*  12432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /*  12444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  12448 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  12452 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12456 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12460 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12464 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12469 */     // MIs[2] Operand 2
     /*  12469 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  12480 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  12484 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12488 */     // MIs[3] Rn
     /*  12488 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12493 */     // MIs[3] Operand 2
     /*  12493 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(2),
     /*  12504 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  12508 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_ZIP1),
     /*  12512 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  12516 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  12520 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  12524 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12528 */     // MIs[5] Rn
     /*  12528 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12533 */     // MIs[5] Operand 2
     /*  12533 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(0),
     /*  12544 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/2, // MIs[6]
     /*  12548 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12552 */     // MIs[6] Rn
     /*  12552 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12557 */     // MIs[6] Operand 2
     /*  12557 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(2),
     /*  12568 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  12570 */     // (add:{ *:[v2i32] } (AArch64zip2:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })), (AArch64zip1:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /*  12570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  12573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  12577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12582 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12586 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12590 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12597 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12604 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12609 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12614 */     // GIR_Coverage, 14094,
     /*  12614 */     GIR_EraseRootFromParent_Done,
     /*  12615 */   // Label 270: @12615
     /*  12615 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(12751), // Rule ID 5413 //
     /*  12620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12636 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12640 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12644 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12648 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12653 */     // MIs[1] Operand 2
     /*  12653 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12664 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12668 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12672 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12676 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12680 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12684 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12688 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12693 */     // MIs[3] Operand 2
     /*  12693 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12704 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12706 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12706 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12709 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12713 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12718 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12722 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12726 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12733 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12740 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12745 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12750 */     // GIR_Coverage, 5413,
     /*  12750 */     GIR_EraseRootFromParent_Done,
     /*  12751 */   // Label 271: @12751
     /*  12751 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(12887), // Rule ID 5412 //
     /*  12756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12780 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12784 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12789 */     // MIs[1] Operand 2
     /*  12789 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12800 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12804 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12808 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12812 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12816 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12820 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12824 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12829 */     // MIs[3] Operand 2
     /*  12829 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12840 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12842 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12854 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12858 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12862 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12869 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12876 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12881 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12886 */     // GIR_Coverage, 5412,
     /*  12886 */     GIR_EraseRootFromParent_Done,
     /*  12887 */   // Label 272: @12887
     /*  12887 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(13023), // Rule ID 5425 //
     /*  12892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12916 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12920 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12925 */     // MIs[1] Operand 2
     /*  12925 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12936 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12940 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12944 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12948 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12952 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12956 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12960 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12965 */     // MIs[3] Operand 2
     /*  12965 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12976 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12978 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i16_v4i32),
     /*  12985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12990 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12994 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12998 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13005 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13012 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13017 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13022 */     // GIR_Coverage, 5425,
     /*  13022 */     GIR_EraseRootFromParent_Done,
     /*  13023 */   // Label 273: @13023
     /*  13023 */   GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(13159), // Rule ID 5411 //
     /*  13028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13040 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13052 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13056 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13061 */     // MIs[1] Operand 2
     /*  13061 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13072 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  13076 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13080 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13084 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  13088 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  13092 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13096 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13101 */     // MIs[3] Operand 2
     /*  13101 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  13112 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  13114 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  13121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13126 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  13130 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  13134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13141 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13148 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13153 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13158 */     // GIR_Coverage, 5411,
     /*  13158 */     GIR_EraseRootFromParent_Done,
     /*  13159 */   // Label 274: @13159
     /*  13159 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(13295), // Rule ID 5410 //
     /*  13164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13180 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13184 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13188 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13192 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13197 */     // MIs[1] Operand 2
     /*  13197 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13208 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  13212 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13216 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13220 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  13224 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13228 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13232 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13237 */     // MIs[3] Operand 2
     /*  13237 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  13248 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  13250 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13250 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13253 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  13257 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13262 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  13266 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  13270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13277 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13284 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13289 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13294 */     // GIR_Coverage, 5410,
     /*  13294 */     GIR_EraseRootFromParent_Done,
     /*  13295 */   // Label 275: @13295
     /*  13295 */   GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(13458), // Rule ID 14054 //
     /*  13300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  13324 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13328 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  13332 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13337 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13342 */     // MIs[1] Operand 2
     /*  13342 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13357 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13359 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13359 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13362 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13366 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13371 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13373 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13376 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13380 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13385 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13388 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  13392 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13395 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13400 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13405 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  13417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13422 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13425 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  13429 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  13433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13440 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13447 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13452 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13457 */     // GIR_Coverage, 14054,
     /*  13457 */     GIR_EraseRootFromParent_Done,
     /*  13458 */   // Label 276: @13458
     /*  13458 */   GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(13621), // Rule ID 14051 //
     /*  13463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13479 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13483 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  13487 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13491 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  13495 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13500 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13505 */     // MIs[1] Operand 2
     /*  13505 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13520 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13522 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13522 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13525 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13529 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13536 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13539 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13543 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13548 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13551 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  13555 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13558 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13563 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13568 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13573 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13576 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  13580 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13585 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13588 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  13592 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  13596 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13603 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13610 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13615 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13620 */     // GIR_Coverage, 14051,
     /*  13620 */     GIR_EraseRootFromParent_Done,
     /*  13621 */   // Label 277: @13621
     /*  13621 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(13771), // Rule ID 14059 //
     /*  13626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  13650 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13654 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13659 */     // MIs[1] Operand 2
     /*  13659 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13674 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13676 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13676 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13679 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13683 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13690 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13693 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13697 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13702 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13705 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  13709 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13712 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13717 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13722 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  13734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13739 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13742 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13746 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13753 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13760 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13765 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13770 */     // GIR_Coverage, 14059,
     /*  13770 */     GIR_EraseRootFromParent_Done,
     /*  13771 */   // Label 278: @13771
     /*  13771 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(13921), // Rule ID 14063 //
     /*  13776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13792 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13796 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  13800 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13804 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13809 */     // MIs[1] Operand 2
     /*  13809 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13824 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13826 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13826 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13829 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13833 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13840 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13843 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13847 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13852 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13855 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  13859 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13862 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13867 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13872 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  13884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13889 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13892 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13903 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13910 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13915 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13920 */     // GIR_Coverage, 14063,
     /*  13920 */     GIR_EraseRootFromParent_Done,
     /*  13921 */   // Label 279: @13921
     /*  13921 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(14071), // Rule ID 14058 //
     /*  13926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13950 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13954 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13959 */     // MIs[1] Operand 2
     /*  13959 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13974 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13976 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13976 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13979 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13983 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13988 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13990 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13993 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13997 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14002 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  14005 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  14009 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  14012 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14017 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14022 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  14034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14039 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14042 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14046 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14053 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  14060 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14065 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14070 */     // GIR_Coverage, 14058,
     /*  14070 */     GIR_EraseRootFromParent_Done,
     /*  14071 */   // Label 280: @14071
     /*  14071 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(14234), // Rule ID 5398 //
     /*  14076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  14104 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  14108 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14112 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14117 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14122 */     // MIs[1] Operand 2
     /*  14122 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  14133 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14135 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  14135 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  14138 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14142 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  14149 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  14152 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  14156 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14161 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  14164 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  14168 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  14171 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14176 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14181 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  14193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14198 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14201 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  14205 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  14209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14216 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  14223 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14228 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14233 */     // GIR_Coverage, 5398,
     /*  14233 */     GIR_EraseRootFromParent_Done,
     /*  14234 */   // Label 281: @14234
     /*  14234 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(14397), // Rule ID 5395 //
     /*  14239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14259 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  14267 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  14271 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14275 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14280 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14285 */     // MIs[1] Operand 2
     /*  14285 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  14296 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14298 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  14298 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  14301 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14305 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14310 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  14312 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  14315 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  14319 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14324 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  14327 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  14331 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  14334 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14339 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14344 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14349 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14352 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  14356 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14361 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14364 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  14368 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  14372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14379 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  14386 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14391 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14396 */     // GIR_Coverage, 5395,
     /*  14396 */     GIR_EraseRootFromParent_Done,
     /*  14397 */   // Label 282: @14397
     /*  14397 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(14547), // Rule ID 5421 //
     /*  14402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  14430 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  14434 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14439 */     // MIs[1] Operand 2
     /*  14439 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  14450 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14452 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  14452 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  14455 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14459 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  14466 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  14469 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  14473 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14478 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  14481 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  14485 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  14488 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14493 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14498 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  14510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14515 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14518 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14529 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  14536 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14541 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14546 */     // GIR_Coverage, 5421,
     /*  14546 */     GIR_EraseRootFromParent_Done,
     /*  14547 */   // Label 283: @14547
     /*  14547 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(14697), // Rule ID 5428 //
     /*  14552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  14580 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  14584 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14589 */     // MIs[1] Operand 2
     /*  14589 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  14600 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14602 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  14602 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  14605 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14609 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  14616 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  14619 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  14623 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14628 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  14631 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  14635 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  14638 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14643 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14648 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14653 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14656 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  14660 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14665 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14668 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14679 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  14686 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14691 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14696 */     // GIR_Coverage, 5428,
     /*  14696 */     GIR_EraseRootFromParent_Done,
     /*  14697 */   // Label 284: @14697
     /*  14697 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(14847), // Rule ID 5420 //
     /*  14702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14726 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  14730 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  14734 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14739 */     // MIs[1] Operand 2
     /*  14739 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  14750 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14752 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  14752 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  14755 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14759 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14764 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  14766 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  14769 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  14773 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14778 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  14781 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  14785 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  14788 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14793 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14798 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14803 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14806 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  14810 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14815 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14818 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14822 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14829 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  14836 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14841 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14846 */     // GIR_Coverage, 5420,
     /*  14846 */     GIR_EraseRootFromParent_Done,
     /*  14847 */   // Label 285: @14847
     /*  14847 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(14916), // Rule ID 13490 //
     /*  14852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14867 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14870 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  14875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14879 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14888 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14899 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 669:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V64:{ *:[v2i32] }:$Rd)  =>  (SABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv2i32),
     /*  14902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14914 */     GIR_RootConstrainSelectedInstOperands,
     /*  14915 */     // GIR_Coverage, 13490,
     /*  14915 */     GIR_EraseRootFromParent_Done,
     /*  14916 */   // Label 286: @14916
     /*  14916 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(14985), // Rule ID 13502 //
     /*  14921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14936 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14939 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  14944 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14948 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14952 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14957 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14968 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 734:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V64:{ *:[v2i32] }:$Rd)  =>  (UABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv2i32),
     /*  14971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14983 */     GIR_RootConstrainSelectedInstOperands,
     /*  14984 */     // GIR_Coverage, 13502,
     /*  14984 */     GIR_EraseRootFromParent_Done,
     /*  14985 */   // Label 287: @14985
     /*  14985 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(15041), // Rule ID 13452 //
     /*  14990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  15005 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  15008 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  15013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  15017 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15028 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 670:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  15031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  15039 */     GIR_RootConstrainSelectedInstOperands,
     /*  15040 */     // GIR_Coverage, 13452,
     /*  15040 */     GIR_EraseRootFromParent_Done,
     /*  15041 */   // Label 288: @15041
     /*  15041 */   GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(15097), // Rule ID 13464 //
     /*  15046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  15061 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  15064 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  15069 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  15073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15084 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 735:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  15087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  15095 */     GIR_RootConstrainSelectedInstOperands,
     /*  15096 */     // GIR_Coverage, 13464,
     /*  15096 */     GIR_EraseRootFromParent_Done,
     /*  15097 */   // Label 289: @15097
     /*  15097 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(15164), // Rule ID 13704 //
     /*  15102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  15117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15126 */     // MIs[1] imm
     /*  15126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15134 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  15138 */     // MIs[2] Operand 1
     /*  15138 */     // No operand predicates
     /*  15138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15142 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  15146 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15148 */     // (add:{ *:[v2i32] } (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  15148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  15151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  15162 */     GIR_RootConstrainSelectedInstOperands,
     /*  15163 */     // GIR_Coverage, 13704,
     /*  15163 */     GIR_EraseRootFromParent_Done,
     /*  15164 */   // Label 290: @15164
     /*  15164 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(15231), // Rule ID 13725 //
     /*  15169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  15184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15188 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15193 */     // MIs[1] imm
     /*  15193 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15197 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15201 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  15205 */     // MIs[2] Operand 1
     /*  15205 */     // No operand predicates
     /*  15205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15209 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  15213 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15215 */     // (add:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  15215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  15218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15226 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  15229 */     GIR_RootConstrainSelectedInstOperands,
     /*  15230 */     // GIR_Coverage, 13725,
     /*  15230 */     GIR_EraseRootFromParent_Done,
     /*  15231 */   // Label 291: @15231
     /*  15231 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(15300), // Rule ID 1365 //
     /*  15236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  15255 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  15258 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  15263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15267 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  15271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15283 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 669:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  15283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv2i32),
     /*  15286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15288 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  15294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  15298 */     GIR_RootConstrainSelectedInstOperands,
     /*  15299 */     // GIR_Coverage, 1365,
     /*  15299 */     GIR_EraseRootFromParent_Done,
     /*  15300 */   // Label 292: @15300
     /*  15300 */   GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(15369), // Rule ID 1488 //
     /*  15305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  15324 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  15327 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  15332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15336 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  15340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15352 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 734:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  15352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv2i32),
     /*  15355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15357 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  15363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  15367 */     GIR_RootConstrainSelectedInstOperands,
     /*  15368 */     // GIR_Coverage, 1488,
     /*  15368 */     GIR_EraseRootFromParent_Done,
     /*  15369 */   // Label 293: @15369
     /*  15369 */   GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(15425), // Rule ID 993 //
     /*  15374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  15393 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  15396 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  15401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  15405 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15412 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 670:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  15415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15417 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  15423 */     GIR_RootConstrainSelectedInstOperands,
     /*  15424 */     // GIR_Coverage, 993,
     /*  15424 */     GIR_EraseRootFromParent_Done,
     /*  15425 */   // Label 294: @15425
     /*  15425 */   GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(15481), // Rule ID 1054 //
     /*  15430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  15449 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  15452 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  15457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  15461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15468 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 735:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  15471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15473 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  15479 */     GIR_RootConstrainSelectedInstOperands,
     /*  15480 */     // GIR_Coverage, 1054,
     /*  15480 */     GIR_EraseRootFromParent_Done,
     /*  15481 */   // Label 295: @15481
     /*  15481 */   GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(15548), // Rule ID 2238 //
     /*  15486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  15505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15514 */     // MIs[1] imm
     /*  15514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15522 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  15526 */     // MIs[2] Operand 1
     /*  15526 */     // No operand predicates
     /*  15526 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  15530 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15532 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  15532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  15535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15537 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  15546 */     GIR_RootConstrainSelectedInstOperands,
     /*  15547 */     // GIR_Coverage, 2238,
     /*  15547 */     GIR_EraseRootFromParent_Done,
     /*  15548 */   // Label 296: @15548
     /*  15548 */   GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(15615), // Rule ID 2297 //
     /*  15553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  15572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15581 */     // MIs[1] imm
     /*  15581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15589 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  15593 */     // MIs[2] Operand 1
     /*  15593 */     // No operand predicates
     /*  15593 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  15597 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15599 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  15599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  15602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15604 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15610 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  15613 */     GIR_RootConstrainSelectedInstOperands,
     /*  15614 */     // GIR_Coverage, 2297,
     /*  15614 */     GIR_EraseRootFromParent_Done,
     /*  15615 */   // Label 297: @15615
     /*  15615 */   GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(15663), // Rule ID 13451 //
     /*  15620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  15635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15639 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15650 */     // (add:{ *:[v2i32] } (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  15653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15661 */     GIR_RootConstrainSelectedInstOperands,
     /*  15662 */     // GIR_Coverage, 13451,
     /*  15662 */     GIR_EraseRootFromParent_Done,
     /*  15663 */   // Label 298: @15663
     /*  15663 */   GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(15711), // Rule ID 13463 //
     /*  15668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  15683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15698 */     // (add:{ *:[v2i32] } (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  15701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15709 */     GIR_RootConstrainSelectedInstOperands,
     /*  15710 */     // GIR_Coverage, 13463,
     /*  15710 */     GIR_EraseRootFromParent_Done,
     /*  15711 */   // Label 299: @15711
     /*  15711 */   GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(15759), // Rule ID 992 //
     /*  15716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  15735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15739 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15746 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  15749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15751 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15757 */     GIR_RootConstrainSelectedInstOperands,
     /*  15758 */     // GIR_Coverage, 992,
     /*  15758 */     GIR_EraseRootFromParent_Done,
     /*  15759 */   // Label 300: @15759
     /*  15759 */   GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(15807), // Rule ID 1053 //
     /*  15764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  15783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15794 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  15797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15799 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15805 */     GIR_RootConstrainSelectedInstOperands,
     /*  15806 */     // GIR_Coverage, 1053,
     /*  15806 */     GIR_EraseRootFromParent_Done,
     /*  15807 */   // Label 301: @15807
     /*  15807 */   GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(15834), // Rule ID 1104 //
     /*  15812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15827 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  15827 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv2i32),
     /*  15832 */     GIR_RootConstrainSelectedInstOperands,
     /*  15833 */     // GIR_Coverage, 1104,
     /*  15833 */     GIR_Done,
     /*  15834 */   // Label 302: @15834
     /*  15834 */   GIM_Reject,
     /*  15835 */ // Label 268: @15835
     /*  15835 */ GIM_Reject,
     /*  15836 */ // Label 159: @15836
     /*  15836 */ GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(21737),
     /*  15841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  15844 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  15847 */   GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(15965), // Rule ID 13633 //
     /*  15852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15871 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15879 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15883 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15887 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15891 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15895 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15899 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15903 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15908 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15912 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15916 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15920 */     // MIs[4] Operand 1
     /*  15920 */     // No operand predicates
     /*  15920 */     // MIs[2] Operand 2
     /*  15920 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15935 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15937 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15944 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  15947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15960 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15963 */     GIR_RootConstrainSelectedInstOperands,
     /*  15964 */     // GIR_Coverage, 13633,
     /*  15964 */     GIR_EraseRootFromParent_Done,
     /*  15965 */   // Label 304: @15965
     /*  15965 */   GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(16083), // Rule ID 13634 //
     /*  15970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16001 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16005 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16009 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16013 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16017 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16021 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16026 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16030 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16034 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16038 */     // MIs[4] Operand 1
     /*  16038 */     // No operand predicates
     /*  16038 */     // MIs[2] Operand 2
     /*  16038 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16053 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16055 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16062 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  16065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16078 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16081 */     GIR_RootConstrainSelectedInstOperands,
     /*  16082 */     // GIR_Coverage, 13634,
     /*  16082 */     GIR_EraseRootFromParent_Done,
     /*  16083 */   // Label 305: @16083
     /*  16083 */   GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(16201), // Rule ID 13669 //
     /*  16088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16107 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16119 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16123 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16127 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16131 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16135 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16139 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16144 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16148 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16152 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16156 */     // MIs[4] Operand 1
     /*  16156 */     // No operand predicates
     /*  16156 */     // MIs[2] Operand 2
     /*  16156 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16171 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16173 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16180 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  16183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16196 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16199 */     GIR_RootConstrainSelectedInstOperands,
     /*  16200 */     // GIR_Coverage, 13669,
     /*  16200 */     GIR_EraseRootFromParent_Done,
     /*  16201 */   // Label 306: @16201
     /*  16201 */   GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(16319), // Rule ID 13670 //
     /*  16206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16225 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16237 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16241 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16245 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16249 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16253 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16257 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16262 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16266 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16270 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16274 */     // MIs[4] Operand 1
     /*  16274 */     // No operand predicates
     /*  16274 */     // MIs[2] Operand 2
     /*  16274 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16289 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16291 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16298 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  16301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16314 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16317 */     GIR_RootConstrainSelectedInstOperands,
     /*  16318 */     // GIR_Coverage, 13670,
     /*  16318 */     GIR_EraseRootFromParent_Done,
     /*  16319 */   // Label 307: @16319
     /*  16319 */   GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(16437), // Rule ID 2042 //
     /*  16324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16347 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16359 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16363 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16367 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16371 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16375 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16379 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16384 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16388 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16392 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16396 */     // MIs[4] Operand 1
     /*  16396 */     // No operand predicates
     /*  16396 */     // MIs[2] Operand 2
     /*  16396 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16407 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16409 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16416 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  16419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16421 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16432 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16435 */     GIR_RootConstrainSelectedInstOperands,
     /*  16436 */     // GIR_Coverage, 2042,
     /*  16436 */     GIR_EraseRootFromParent_Done,
     /*  16437 */   // Label 308: @16437
     /*  16437 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(16555), // Rule ID 13632 //
     /*  16442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16469 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16473 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16477 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16481 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16485 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16489 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16493 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16497 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16502 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16506 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16510 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16514 */     // MIs[4] Operand 1
     /*  16514 */     // No operand predicates
     /*  16514 */     // MIs[2] Operand 2
     /*  16514 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16525 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16527 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16534 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  16537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16539 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16550 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16553 */     GIR_RootConstrainSelectedInstOperands,
     /*  16554 */     // GIR_Coverage, 13632,
     /*  16554 */     GIR_EraseRootFromParent_Done,
     /*  16555 */   // Label 309: @16555
     /*  16555 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(16673), // Rule ID 2094 //
     /*  16560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16583 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16595 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16599 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16603 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16607 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16611 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16615 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16620 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16624 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16628 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16632 */     // MIs[4] Operand 1
     /*  16632 */     // No operand predicates
     /*  16632 */     // MIs[2] Operand 2
     /*  16632 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16643 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16645 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16652 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  16655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16657 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16668 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16671 */     GIR_RootConstrainSelectedInstOperands,
     /*  16672 */     // GIR_Coverage, 2094,
     /*  16672 */     GIR_EraseRootFromParent_Done,
     /*  16673 */   // Label 310: @16673
     /*  16673 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(16791), // Rule ID 13668 //
     /*  16678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16701 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16705 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16709 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16713 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16717 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16721 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16725 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16729 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16733 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16738 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16742 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16746 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16750 */     // MIs[4] Operand 1
     /*  16750 */     // No operand predicates
     /*  16750 */     // MIs[2] Operand 2
     /*  16750 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16761 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16763 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16770 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  16773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16775 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16786 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16789 */     GIR_RootConstrainSelectedInstOperands,
     /*  16790 */     // GIR_Coverage, 13668,
     /*  16790 */     GIR_EraseRootFromParent_Done,
     /*  16791 */   // Label 311: @16791
     /*  16791 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(16878), // Rule ID 13534 //
     /*  16796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16815 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16819 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16823 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16826 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  16831 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16835 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16843 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16845 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16852 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16859 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 669:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))), V128:{ *:[v2i64] }:$Rd)  =>  (SABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i32_v2i64),
     /*  16862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16876 */     GIR_RootConstrainSelectedInstOperands,
     /*  16877 */     // GIR_Coverage, 13534,
     /*  16877 */     GIR_EraseRootFromParent_Done,
     /*  16878 */   // Label 312: @16878
     /*  16878 */   GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(16965), // Rule ID 13562 //
     /*  16883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16910 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16913 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  16918 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16922 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16930 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16932 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16939 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16946 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 734:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))), V128:{ *:[v2i64] }:$Rd)  =>  (UABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i32_v2i64),
     /*  16949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16963 */     GIR_RootConstrainSelectedInstOperands,
     /*  16964 */     // GIR_Coverage, 13562,
     /*  16964 */     GIR_EraseRootFromParent_Done,
     /*  16965 */   // Label 313: @16965
     /*  16965 */   GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(17052), // Rule ID 1699 //
     /*  16970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  17001 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  17004 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  17009 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17013 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  17017 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17019 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17026 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17033 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 669:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))))  =>  (SABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i32_v2i64),
     /*  17036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17038 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17050 */     GIR_RootConstrainSelectedInstOperands,
     /*  17051 */     // GIR_Coverage, 1699,
     /*  17051 */     GIR_EraseRootFromParent_Done,
     /*  17052 */   // Label 314: @17052
     /*  17052 */   GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(17139), // Rule ID 1777 //
     /*  17057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  17088 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  17091 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  17096 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17100 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  17104 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17106 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17113 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17120 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 734:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))))  =>  (UABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i32_v2i64),
     /*  17123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17125 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17137 */     GIR_RootConstrainSelectedInstOperands,
     /*  17138 */     // GIR_Coverage, 1777,
     /*  17138 */     GIR_EraseRootFromParent_Done,
     /*  17139 */   // Label 315: @17139
     /*  17139 */   GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(17254), // Rule ID 13628 //
     /*  17144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17163 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17167 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17171 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17175 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17179 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17183 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17187 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17191 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17195 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17200 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17204 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17208 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17212 */     // MIs[4] Operand 1
     /*  17212 */     // No operand predicates
     /*  17212 */     // MIs[2] Operand 2
     /*  17212 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17223 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17232 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17234 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  17237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17252 */     GIR_RootConstrainSelectedInstOperands,
     /*  17253 */     // GIR_Coverage, 13628,
     /*  17253 */     GIR_EraseRootFromParent_Done,
     /*  17254 */   // Label 316: @17254
     /*  17254 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(17369), // Rule ID 13627 //
     /*  17259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17278 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17295 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17299 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17303 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17307 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17311 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17315 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17320 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17324 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17328 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17332 */     // MIs[4] Operand 1
     /*  17332 */     // No operand predicates
     /*  17332 */     // MIs[2] Operand 2
     /*  17332 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17347 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17349 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  17352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17364 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17367 */     GIR_RootConstrainSelectedInstOperands,
     /*  17368 */     // GIR_Coverage, 13627,
     /*  17368 */     GIR_EraseRootFromParent_Done,
     /*  17369 */   // Label 317: @17369
     /*  17369 */   GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(17484), // Rule ID 13664 //
     /*  17374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17393 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17397 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17401 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17405 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17409 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17413 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17417 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17421 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17425 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17430 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17434 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17438 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17442 */     // MIs[4] Operand 1
     /*  17442 */     // No operand predicates
     /*  17442 */     // MIs[2] Operand 2
     /*  17442 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17453 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17462 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17464 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  17467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17479 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17482 */     GIR_RootConstrainSelectedInstOperands,
     /*  17483 */     // GIR_Coverage, 13664,
     /*  17483 */     GIR_EraseRootFromParent_Done,
     /*  17484 */   // Label 318: @17484
     /*  17484 */   GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(17599), // Rule ID 13663 //
     /*  17489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17512 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17525 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17529 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17533 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17537 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17541 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17545 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17550 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17554 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17558 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17562 */     // MIs[4] Operand 1
     /*  17562 */     // No operand predicates
     /*  17562 */     // MIs[2] Operand 2
     /*  17562 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17577 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17579 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  17582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17594 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17597 */     GIR_RootConstrainSelectedInstOperands,
     /*  17598 */     // GIR_Coverage, 13663,
     /*  17598 */     GIR_EraseRootFromParent_Done,
     /*  17599 */   // Label 319: @17599
     /*  17599 */   GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(17668), // Rule ID 1801 //
     /*  17604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17623 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17627 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17631 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17635 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17637 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17644 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17651 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17666 */     GIR_RootConstrainSelectedInstOperands,
     /*  17667 */     // GIR_Coverage, 1801,
     /*  17667 */     GIR_EraseRootFromParent_Done,
     /*  17668 */   // Label 320: @17668
     /*  17668 */   GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(17737), // Rule ID 1800 //
     /*  17673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17700 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17704 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17706 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17713 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17720 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17735 */     GIR_RootConstrainSelectedInstOperands,
     /*  17736 */     // GIR_Coverage, 1800,
     /*  17736 */     GIR_EraseRootFromParent_Done,
     /*  17737 */   // Label 321: @17737
     /*  17737 */   GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(17806), // Rule ID 1717 //
     /*  17742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  17757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  17769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17773 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17775 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17782 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17789 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i32_v2i64),
     /*  17792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17804 */     GIR_RootConstrainSelectedInstOperands,
     /*  17805 */     // GIR_Coverage, 1717,
     /*  17805 */     GIR_EraseRootFromParent_Done,
     /*  17806 */   // Label 322: @17806
     /*  17806 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(17875), // Rule ID 1799 //
     /*  17811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17842 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17844 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17851 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17858 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17873 */     GIR_RootConstrainSelectedInstOperands,
     /*  17874 */     // GIR_Coverage, 1799,
     /*  17874 */     GIR_EraseRootFromParent_Done,
     /*  17875 */   // Label 323: @17875
     /*  17875 */   GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(17944), // Rule ID 1798 //
     /*  17880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17907 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17911 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17913 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17920 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17927 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17942 */     GIR_RootConstrainSelectedInstOperands,
     /*  17943 */     // GIR_Coverage, 1798,
     /*  17943 */     GIR_EraseRootFromParent_Done,
     /*  17944 */   // Label 324: @17944
     /*  17944 */   GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(18059), // Rule ID 13626 //
     /*  17949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17984 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17988 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17992 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17996 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18000 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  18004 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18009 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  18013 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18017 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18021 */     // MIs[4] Operand 1
     /*  18021 */     // No operand predicates
     /*  18021 */     // MIs[2] Operand 2
     /*  18021 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  18032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18037 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  18039 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18044 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  18050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  18054 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  18057 */     GIR_RootConstrainSelectedInstOperands,
     /*  18058 */     // GIR_Coverage, 13626,
     /*  18058 */     GIR_EraseRootFromParent_Done,
     /*  18059 */   // Label 325: @18059
     /*  18059 */   GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(18174), // Rule ID 2040 //
     /*  18064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18087 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18091 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  18104 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18108 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  18112 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18116 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18120 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  18124 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18129 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  18133 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18137 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18141 */     // MIs[4] Operand 1
     /*  18141 */     // No operand predicates
     /*  18141 */     // MIs[2] Operand 2
     /*  18141 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  18152 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  18154 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18159 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  18169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  18172 */     GIR_RootConstrainSelectedInstOperands,
     /*  18173 */     // GIR_Coverage, 2040,
     /*  18173 */     GIR_EraseRootFromParent_Done,
     /*  18174 */   // Label 326: @18174
     /*  18174 */   GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(18289), // Rule ID 13662 //
     /*  18179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18202 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18206 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18210 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  18214 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18218 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  18222 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18226 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18230 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  18234 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18239 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  18243 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18247 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18251 */     // MIs[4] Operand 1
     /*  18251 */     // No operand predicates
     /*  18251 */     // MIs[2] Operand 2
     /*  18251 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  18262 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18267 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  18269 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  18272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18274 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  18280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  18284 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  18287 */     GIR_RootConstrainSelectedInstOperands,
     /*  18288 */     // GIR_Coverage, 13662,
     /*  18288 */     GIR_EraseRootFromParent_Done,
     /*  18289 */   // Label 327: @18289
     /*  18289 */   GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(18404), // Rule ID 2092 //
     /*  18294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18317 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18321 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18330 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  18334 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18338 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  18342 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18346 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18350 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  18354 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18359 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  18363 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18367 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18371 */     // MIs[4] Operand 1
     /*  18371 */     // No operand predicates
     /*  18371 */     // MIs[2] Operand 2
     /*  18371 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  18382 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  18384 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  18387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18389 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  18399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  18402 */     GIR_RootConstrainSelectedInstOperands,
     /*  18403 */     // GIR_Coverage, 2092,
     /*  18403 */     GIR_EraseRootFromParent_Done,
     /*  18404 */   // Label 328: @18404
     /*  18404 */   GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(18471), // Rule ID 13546 //
     /*  18409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18428 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18438 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18445 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18452 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  18452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_v2i64),
     /*  18455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  18464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  18469 */     GIR_RootConstrainSelectedInstOperands,
     /*  18470 */     // GIR_Coverage, 13546,
     /*  18470 */     GIR_EraseRootFromParent_Done,
     /*  18471 */   // Label 329: @18471
     /*  18471 */   GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(18538), // Rule ID 13580 //
     /*  18476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18505 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18512 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18519 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  18519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_v2i64),
     /*  18522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  18531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  18536 */     GIR_RootConstrainSelectedInstOperands,
     /*  18537 */     // GIR_Coverage, 13580,
     /*  18537 */     GIR_EraseRootFromParent_Done,
     /*  18538 */   // Label 330: @18538
     /*  18538 */   GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(18605), // Rule ID 1729 //
     /*  18543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18570 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18572 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18579 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18586 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  18586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_v2i64),
     /*  18589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18591 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  18598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  18603 */     GIR_RootConstrainSelectedInstOperands,
     /*  18604 */     // GIR_Coverage, 1729,
     /*  18604 */     GIR_EraseRootFromParent_Done,
     /*  18605 */   // Label 331: @18605
     /*  18605 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(18672), // Rule ID 1819 //
     /*  18610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18633 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18639 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18646 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18653 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  18653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_v2i64),
     /*  18656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18658 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  18665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  18670 */     GIR_RootConstrainSelectedInstOperands,
     /*  18671 */     // GIR_Coverage, 1819,
     /*  18671 */     GIR_EraseRootFromParent_Done,
     /*  18672 */   // Label 332: @18672
     /*  18672 */   GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(18753), // Rule ID 13532 //
     /*  18677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18704 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18707 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  18712 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18716 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18720 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18725 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18734 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18736 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 669:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (SABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv2i32_v2i64),
     /*  18739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18751 */     GIR_RootConstrainSelectedInstOperands,
     /*  18752 */     // GIR_Coverage, 13532,
     /*  18752 */     GIR_EraseRootFromParent_Done,
     /*  18753 */   // Label 333: @18753
     /*  18753 */   GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(18834), // Rule ID 13560 //
     /*  18758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18785 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18788 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  18793 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18797 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18801 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18806 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18815 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18817 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 734:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (UABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv2i32_v2i64),
     /*  18820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18832 */     GIR_RootConstrainSelectedInstOperands,
     /*  18833 */     // GIR_Coverage, 13560,
     /*  18833 */     GIR_EraseRootFromParent_Done,
     /*  18834 */   // Label 334: @18834
     /*  18834 */   GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(18915), // Rule ID 1697 //
     /*  18839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18870 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18873 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  18878 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18882 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18886 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18891 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18896 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18898 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 669:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)))  =>  (SABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv2i32_v2i64),
     /*  18901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18903 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18913 */     GIR_RootConstrainSelectedInstOperands,
     /*  18914 */     // GIR_Coverage, 1697,
     /*  18914 */     GIR_EraseRootFromParent_Done,
     /*  18915 */   // Label 335: @18915
     /*  18915 */   GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(18996), // Rule ID 1775 //
     /*  18920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18951 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18954 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  18959 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18963 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18967 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18972 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18977 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18979 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 734:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)))  =>  (UABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv2i32_v2i64),
     /*  18982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18984 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18994 */     GIR_RootConstrainSelectedInstOperands,
     /*  18995 */     // GIR_Coverage, 1775,
     /*  18995 */     GIR_EraseRootFromParent_Done,
     /*  18996 */   // Label 336: @18996
     /*  18996 */   GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(19088), // Rule ID 13631 //
     /*  19001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  19016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19020 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19028 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  19032 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19036 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19040 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19045 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19049 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19053 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19057 */     // MIs[3] Operand 1
     /*  19057 */     // No operand predicates
     /*  19057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19066 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19068 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  19071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19086 */     GIR_RootConstrainSelectedInstOperands,
     /*  19087 */     // GIR_Coverage, 13631,
     /*  19087 */     GIR_EraseRootFromParent_Done,
     /*  19088 */   // Label 337: @19088
     /*  19088 */   GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(19180), // Rule ID 13630 //
     /*  19093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  19108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19112 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19116 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19121 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19125 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  19129 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19133 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19137 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19142 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19146 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19150 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19154 */     // MIs[3] Operand 1
     /*  19154 */     // No operand predicates
     /*  19154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19158 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19160 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  19163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19175 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19178 */     GIR_RootConstrainSelectedInstOperands,
     /*  19179 */     // GIR_Coverage, 13630,
     /*  19179 */     GIR_EraseRootFromParent_Done,
     /*  19180 */   // Label 338: @19180
     /*  19180 */   GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(19272), // Rule ID 13667 //
     /*  19185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  19200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19204 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  19216 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19220 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19224 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19229 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19233 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19237 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19241 */     // MIs[3] Operand 1
     /*  19241 */     // No operand predicates
     /*  19241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19250 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19252 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  19255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19270 */     GIR_RootConstrainSelectedInstOperands,
     /*  19271 */     // GIR_Coverage, 13667,
     /*  19271 */     GIR_EraseRootFromParent_Done,
     /*  19272 */   // Label 339: @19272
     /*  19272 */   GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(19364), // Rule ID 13666 //
     /*  19277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  19292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  19313 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19317 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19321 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19326 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19330 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19334 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19338 */     // MIs[3] Operand 1
     /*  19338 */     // No operand predicates
     /*  19338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19342 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19344 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  19347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19359 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19362 */     GIR_RootConstrainSelectedInstOperands,
     /*  19363 */     // GIR_Coverage, 13666,
     /*  19363 */     GIR_EraseRootFromParent_Done,
     /*  19364 */   // Label 340: @19364
     /*  19364 */   GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(19456), // Rule ID 13629 //
     /*  19369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  19388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19392 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  19404 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19408 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19412 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19417 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19421 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19425 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19429 */     // MIs[3] Operand 1
     /*  19429 */     // No operand predicates
     /*  19429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19434 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19436 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  19439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19441 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19454 */     GIR_RootConstrainSelectedInstOperands,
     /*  19455 */     // GIR_Coverage, 13629,
     /*  19455 */     GIR_EraseRootFromParent_Done,
     /*  19456 */   // Label 341: @19456
     /*  19456 */   GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(19548), // Rule ID 2041 //
     /*  19461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  19480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  19501 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19505 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19509 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19514 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19518 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19522 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19526 */     // MIs[3] Operand 1
     /*  19526 */     // No operand predicates
     /*  19526 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19528 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  19531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19533 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19546 */     GIR_RootConstrainSelectedInstOperands,
     /*  19547 */     // GIR_Coverage, 2041,
     /*  19547 */     GIR_EraseRootFromParent_Done,
     /*  19548 */   // Label 342: @19548
     /*  19548 */   GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(19640), // Rule ID 13665 //
     /*  19553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  19572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  19588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19592 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19596 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19601 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19605 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19609 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19613 */     // MIs[3] Operand 1
     /*  19613 */     // No operand predicates
     /*  19613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19618 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19620 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  19623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19625 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19638 */     GIR_RootConstrainSelectedInstOperands,
     /*  19639 */     // GIR_Coverage, 13665,
     /*  19639 */     GIR_EraseRootFromParent_Done,
     /*  19640 */   // Label 343: @19640
     /*  19640 */   GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(19732), // Rule ID 2093 //
     /*  19645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19652 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  19664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19672 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  19685 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19689 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19693 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19698 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19702 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19706 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19710 */     // MIs[3] Operand 1
     /*  19710 */     // No operand predicates
     /*  19710 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19712 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  19715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19717 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19727 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19730 */     GIR_RootConstrainSelectedInstOperands,
     /*  19731 */     // GIR_Coverage, 2093,
     /*  19731 */     GIR_EraseRootFromParent_Done,
     /*  19732 */   // Label 344: @19732
     /*  19732 */   GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(19783), // Rule ID 13574 //
     /*  19737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19762 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19769 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  19776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19781 */     GIR_RootConstrainSelectedInstOperands,
     /*  19782 */     // GIR_Coverage, 13574,
     /*  19782 */     GIR_EraseRootFromParent_Done,
     /*  19783 */   // Label 345: @19783
     /*  19783 */   GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(19834), // Rule ID 13540 //
     /*  19788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  19803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19813 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19820 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (SADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i32_v2i64),
     /*  19823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  19827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19832 */     GIR_RootConstrainSelectedInstOperands,
     /*  19833 */     // GIR_Coverage, 13540,
     /*  19833 */     GIR_EraseRootFromParent_Done,
     /*  19834 */   // Label 346: @19834
     /*  19834 */   GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(19885), // Rule ID 13573 //
     /*  19839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  19854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19862 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19864 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19871 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  19878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19883 */     GIR_RootConstrainSelectedInstOperands,
     /*  19884 */     // GIR_Coverage, 13573,
     /*  19884 */     GIR_EraseRootFromParent_Done,
     /*  19885 */   // Label 347: @19885
     /*  19885 */   GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(19936), // Rule ID 1813 //
     /*  19890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19915 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19922 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19927 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19934 */     GIR_RootConstrainSelectedInstOperands,
     /*  19935 */     // GIR_Coverage, 1813,
     /*  19935 */     GIR_EraseRootFromParent_Done,
     /*  19936 */   // Label 348: @19936
     /*  19936 */   GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(19987), // Rule ID 1723 //
     /*  19941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  19960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19966 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19973 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i32_v2i64),
     /*  19976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19978 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19985 */     GIR_RootConstrainSelectedInstOperands,
     /*  19986 */     // GIR_Coverage, 1723,
     /*  19986 */     GIR_EraseRootFromParent_Done,
     /*  19987 */   // Label 349: @19987
     /*  19987 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(20038), // Rule ID 1812 //
     /*  19992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20017 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  20024 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  20024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  20027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20029 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  20031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  20036 */     GIR_RootConstrainSelectedInstOperands,
     /*  20037 */     // GIR_Coverage, 1812,
     /*  20037 */     GIR_EraseRootFromParent_Done,
     /*  20038 */   // Label 350: @20038
     /*  20038 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(20094), // Rule ID 13458 //
     /*  20043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  20058 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  20061 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  20066 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20081 */     // (add:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 670:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  20084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  20092 */     GIR_RootConstrainSelectedInstOperands,
     /*  20093 */     // GIR_Coverage, 13458,
     /*  20093 */     GIR_EraseRootFromParent_Done,
     /*  20094 */   // Label 351: @20094
     /*  20094 */   GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(20150), // Rule ID 13470 //
     /*  20099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  20114 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  20117 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  20122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20126 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20137 */     // (add:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 735:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  20140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  20148 */     GIR_RootConstrainSelectedInstOperands,
     /*  20149 */     // GIR_Coverage, 13470,
     /*  20149 */     GIR_EraseRootFromParent_Done,
     /*  20150 */   // Label 352: @20150
     /*  20150 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(20217), // Rule ID 13708 //
     /*  20155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  20170 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  20174 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20179 */     // MIs[1] imm
     /*  20179 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20183 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20187 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  20191 */     // MIs[2] Operand 1
     /*  20191 */     // No operand predicates
     /*  20191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20195 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  20199 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20201 */     // (add:{ *:[v2i64] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  20201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  20204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20212 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  20215 */     GIR_RootConstrainSelectedInstOperands,
     /*  20216 */     // GIR_Coverage, 13708,
     /*  20216 */     GIR_EraseRootFromParent_Done,
     /*  20217 */   // Label 353: @20217
     /*  20217 */   GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(20284), // Rule ID 13729 //
     /*  20222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  20237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  20241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20246 */     // MIs[1] imm
     /*  20246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20250 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20254 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  20258 */     // MIs[2] Operand 1
     /*  20258 */     // No operand predicates
     /*  20258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20262 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  20266 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20268 */     // (add:{ *:[v2i64] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  20268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  20271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20279 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  20282 */     GIR_RootConstrainSelectedInstOperands,
     /*  20283 */     // GIR_Coverage, 13729,
     /*  20283 */     GIR_EraseRootFromParent_Done,
     /*  20284 */   // Label 354: @20284
     /*  20284 */   GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(20340), // Rule ID 999 //
     /*  20289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  20308 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  20311 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  20316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20327 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 670:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  20330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20332 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  20338 */     GIR_RootConstrainSelectedInstOperands,
     /*  20339 */     // GIR_Coverage, 999,
     /*  20339 */     GIR_EraseRootFromParent_Done,
     /*  20340 */   // Label 355: @20340
     /*  20340 */   GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(20396), // Rule ID 1060 //
     /*  20345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  20364 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  20367 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  20372 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20376 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20383 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 735:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  20386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20388 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  20394 */     GIR_RootConstrainSelectedInstOperands,
     /*  20395 */     // GIR_Coverage, 1060,
     /*  20395 */     GIR_EraseRootFromParent_Done,
     /*  20396 */   // Label 356: @20396
     /*  20396 */   GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(20463), // Rule ID 2242 //
     /*  20401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  20420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  20424 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20429 */     // MIs[1] imm
     /*  20429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20437 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  20441 */     // MIs[2] Operand 1
     /*  20441 */     // No operand predicates
     /*  20441 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  20445 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20447 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  20447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  20450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20452 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20458 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  20461 */     GIR_RootConstrainSelectedInstOperands,
     /*  20462 */     // GIR_Coverage, 2242,
     /*  20462 */     GIR_EraseRootFromParent_Done,
     /*  20463 */   // Label 357: @20463
     /*  20463 */   GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(20530), // Rule ID 2301 //
     /*  20468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  20487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  20491 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20496 */     // MIs[1] imm
     /*  20496 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20500 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20504 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  20508 */     // MIs[2] Operand 1
     /*  20508 */     // No operand predicates
     /*  20508 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  20512 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20514 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  20514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  20517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20519 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  20528 */     GIR_RootConstrainSelectedInstOperands,
     /*  20529 */     // GIR_Coverage, 2301,
     /*  20529 */     GIR_EraseRootFromParent_Done,
     /*  20530 */   // Label 358: @20530
     /*  20530 */   GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(20600), // Rule ID 6998 //
     /*  20535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /*  20547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  20551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  20555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20560 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP2),
     /*  20573 */     // MIs[2] Rn
     /*  20573 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20578 */     // MIs[2] Rm
     /*  20578 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  20583 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20585 */     // (add:{ *:[v2i64] } (AArch64zip1:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm), (AArch64zip2:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm))  =>  (ADDPv2i64:{ *:[v2i64] } ?:{ *:[v2i64] }:$Rn, ?:{ *:[v2i64] }:$Rm)
     /*  20585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /*  20588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20598 */     GIR_RootConstrainSelectedInstOperands,
     /*  20599 */     // GIR_Coverage, 6998,
     /*  20599 */     GIR_EraseRootFromParent_Done,
     /*  20600 */   // Label 359: @20600
     /*  20600 */   GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(20670), // Rule ID 14090 //
     /*  20605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /*  20617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  20621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  20625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP1),
     /*  20643 */     // MIs[2] Rn
     /*  20643 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20648 */     // MIs[2] Rm
     /*  20648 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  20653 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20655 */     // (add:{ *:[v2i64] } (AArch64zip2:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm), (AArch64zip1:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm))  =>  (ADDPv2i64:{ *:[v2i64] } ?:{ *:[v2i64] }:$Rn, ?:{ *:[v2i64] }:$Rm)
     /*  20655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /*  20658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20668 */     GIR_RootConstrainSelectedInstOperands,
     /*  20669 */     // GIR_Coverage, 14090,
     /*  20669 */     GIR_EraseRootFromParent_Done,
     /*  20670 */   // Label 360: @20670
     /*  20670 */   GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(20733), // Rule ID 1797 //
     /*  20675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20694 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20707 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20711 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20716 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20718 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20731 */     GIR_RootConstrainSelectedInstOperands,
     /*  20732 */     // GIR_Coverage, 1797,
     /*  20732 */     GIR_EraseRootFromParent_Done,
     /*  20733 */   // Label 361: @20733
     /*  20733 */   GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(20796), // Rule ID 1796 //
     /*  20738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20757 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20766 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20770 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20774 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20779 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20781 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20794 */     GIR_RootConstrainSelectedInstOperands,
     /*  20795 */     // GIR_Coverage, 1796,
     /*  20795 */     GIR_EraseRootFromParent_Done,
     /*  20796 */   // Label 362: @20796
     /*  20796 */   GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(20859), // Rule ID 1716 //
     /*  20801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20833 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20837 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20842 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20844 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv2i32_v2i64),
     /*  20847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20857 */     GIR_RootConstrainSelectedInstOperands,
     /*  20858 */     // GIR_Coverage, 1716,
     /*  20858 */     GIR_EraseRootFromParent_Done,
     /*  20859 */   // Label 363: @20859
     /*  20859 */   GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(20922), // Rule ID 1795 //
     /*  20864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20896 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20900 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20905 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20907 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20920 */     GIR_RootConstrainSelectedInstOperands,
     /*  20921 */     // GIR_Coverage, 1795,
     /*  20921 */     GIR_EraseRootFromParent_Done,
     /*  20922 */   // Label 364: @20922
     /*  20922 */   GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(20985), // Rule ID 1794 //
     /*  20927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20959 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20963 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20968 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20970 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20983 */     GIR_RootConstrainSelectedInstOperands,
     /*  20984 */     // GIR_Coverage, 1794,
     /*  20984 */     GIR_EraseRootFromParent_Done,
     /*  20985 */   // Label 365: @20985
     /*  20985 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(21046), // Rule ID 13545 //
     /*  20990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  21005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21009 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  21013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21029 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*  21032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  21036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  21044 */     GIR_RootConstrainSelectedInstOperands,
     /*  21045 */     // GIR_Coverage, 13545,
     /*  21045 */     GIR_EraseRootFromParent_Done,
     /*  21046 */   // Label 366: @21046
     /*  21046 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(21107), // Rule ID 13579 //
     /*  21051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  21066 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21070 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  21074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21079 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21090 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*  21093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  21097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  21105 */     GIR_RootConstrainSelectedInstOperands,
     /*  21106 */     // GIR_Coverage, 13579,
     /*  21106 */     GIR_EraseRootFromParent_Done,
     /*  21107 */   // Label 367: @21107
     /*  21107 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(21155), // Rule ID 13572 //
     /*  21112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21131 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21140 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21142 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  21145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  21149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21153 */     GIR_RootConstrainSelectedInstOperands,
     /*  21154 */     // GIR_Coverage, 13572,
     /*  21154 */     GIR_EraseRootFromParent_Done,
     /*  21155 */   // Label 368: @21155
     /*  21155 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(21203), // Rule ID 13457 //
     /*  21160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  21175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21179 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21190 */     // (add:{ *:[v2i64] } (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  21190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  21193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  21197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21201 */     GIR_RootConstrainSelectedInstOperands,
     /*  21202 */     // GIR_Coverage, 13457,
     /*  21202 */     GIR_EraseRootFromParent_Done,
     /*  21203 */   // Label 369: @21203
     /*  21203 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(21251), // Rule ID 13539 //
     /*  21208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  21223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21227 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21238 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (SADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*  21241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  21245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21249 */     GIR_RootConstrainSelectedInstOperands,
     /*  21250 */     // GIR_Coverage, 13539,
     /*  21250 */     GIR_EraseRootFromParent_Done,
     /*  21251 */   // Label 370: @21251
     /*  21251 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(21299), // Rule ID 13469 //
     /*  21256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  21271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21275 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21286 */     // (add:{ *:[v2i64] } (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  21286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  21289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  21293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21297 */     GIR_RootConstrainSelectedInstOperands,
     /*  21298 */     // GIR_Coverage, 13469,
     /*  21298 */     GIR_EraseRootFromParent_Done,
     /*  21299 */   // Label 371: @21299
     /*  21299 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(21347), // Rule ID 13571 //
     /*  21304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21323 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21334 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  21337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  21341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21345 */     GIR_RootConstrainSelectedInstOperands,
     /*  21346 */     // GIR_Coverage, 13571,
     /*  21346 */     GIR_EraseRootFromParent_Done,
     /*  21347 */   // Label 372: @21347
     /*  21347 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(21408), // Rule ID 1728 //
     /*  21352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  21371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  21379 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21384 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21391 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*  21394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21396 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  21398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  21406 */     GIR_RootConstrainSelectedInstOperands,
     /*  21407 */     // GIR_Coverage, 1728,
     /*  21407 */     GIR_EraseRootFromParent_Done,
     /*  21408 */   // Label 373: @21408
     /*  21408 */   GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(21469), // Rule ID 1818 //
     /*  21413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  21432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21436 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  21440 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21445 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21452 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*  21455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21457 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  21459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  21467 */     GIR_RootConstrainSelectedInstOperands,
     /*  21468 */     // GIR_Coverage, 1818,
     /*  21468 */     GIR_EraseRootFromParent_Done,
     /*  21469 */   // Label 374: @21469
     /*  21469 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(21517), // Rule ID 1811 //
     /*  21474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21493 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21497 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21504 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  21507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21509 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  21511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21515 */     GIR_RootConstrainSelectedInstOperands,
     /*  21516 */     // GIR_Coverage, 1811,
     /*  21516 */     GIR_EraseRootFromParent_Done,
     /*  21517 */   // Label 375: @21517
     /*  21517 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(21565), // Rule ID 998 //
     /*  21522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  21541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21545 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21550 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21552 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  21552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  21555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21557 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  21559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21563 */     GIR_RootConstrainSelectedInstOperands,
     /*  21564 */     // GIR_Coverage, 998,
     /*  21564 */     GIR_EraseRootFromParent_Done,
     /*  21565 */   // Label 376: @21565
     /*  21565 */   GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(21613), // Rule ID 1722 //
     /*  21570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  21589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21600 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*  21603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21605 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  21607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21611 */     GIR_RootConstrainSelectedInstOperands,
     /*  21612 */     // GIR_Coverage, 1722,
     /*  21612 */     GIR_EraseRootFromParent_Done,
     /*  21613 */   // Label 377: @21613
     /*  21613 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(21661), // Rule ID 1059 //
     /*  21618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  21637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21641 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21648 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  21648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  21651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21653 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  21655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21659 */     GIR_RootConstrainSelectedInstOperands,
     /*  21660 */     // GIR_Coverage, 1059,
     /*  21660 */     GIR_EraseRootFromParent_Done,
     /*  21661 */   // Label 378: @21661
     /*  21661 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(21709), // Rule ID 1810 //
     /*  21666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21696 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  21699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21701 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  21703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21707 */     GIR_RootConstrainSelectedInstOperands,
     /*  21708 */     // GIR_Coverage, 1810,
     /*  21708 */     GIR_EraseRootFromParent_Done,
     /*  21709 */   // Label 379: @21709
     /*  21709 */   GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(21736), // Rule ID 1106 //
     /*  21714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21729 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  21729 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv2i64),
     /*  21734 */     GIR_RootConstrainSelectedInstOperands,
     /*  21735 */     // GIR_Coverage, 1106,
     /*  21735 */     GIR_Done,
     /*  21736 */   // Label 380: @21736
     /*  21736 */   GIM_Reject,
     /*  21737 */ // Label 303: @21737
     /*  21737 */ GIM_Reject,
     /*  21738 */ // Label 160: @21738
     /*  21738 */ GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(25235),
     /*  21743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  21746 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  21749 */   GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(21885), // Rule ID 5409 //
     /*  21754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21778 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21782 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21787 */     // MIs[1] Operand 2
     /*  21787 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21798 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21802 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21806 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21810 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21814 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21818 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21822 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21827 */     // MIs[3] Operand 2
     /*  21827 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21838 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21840 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21840 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21843 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21847 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21852 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21856 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21860 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21867 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21874 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21879 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21884 */     // GIR_Coverage, 5409,
     /*  21884 */     GIR_EraseRootFromParent_Done,
     /*  21885 */   // Label 382: @21885
     /*  21885 */   GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(22021), // Rule ID 5408 //
     /*  21890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21914 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21918 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21923 */     // MIs[1] Operand 2
     /*  21923 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21934 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21938 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21942 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21946 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21950 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21954 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21958 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21963 */     // MIs[3] Operand 2
     /*  21963 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21974 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21976 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21976 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21979 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21983 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21988 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21992 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22003 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22010 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22015 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22020 */     // GIR_Coverage, 5408,
     /*  22020 */     GIR_EraseRootFromParent_Done,
     /*  22021 */   // Label 383: @22021
     /*  22021 */   GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(22157), // Rule ID 5424 //
     /*  22026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  22050 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22054 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22059 */     // MIs[1] Operand 2
     /*  22059 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22070 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22074 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22078 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22082 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22086 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  22090 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22094 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22099 */     // MIs[3] Operand 2
     /*  22099 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  22110 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  22112 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22112 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22115 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i8_v8i16),
     /*  22119 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22124 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22128 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  22132 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22139 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22146 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22151 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22156 */     // GIR_Coverage, 5424,
     /*  22156 */     GIR_EraseRootFromParent_Done,
     /*  22157 */   // Label 384: @22157
     /*  22157 */   GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(22293), // Rule ID 5407 //
     /*  22162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22178 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22182 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  22186 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22190 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22195 */     // MIs[1] Operand 2
     /*  22195 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22206 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22210 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22214 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22218 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22222 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  22226 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22230 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22235 */     // MIs[3] Operand 2
     /*  22235 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  22246 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  22248 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22248 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22251 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  22255 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22260 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22264 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  22268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22275 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22282 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22287 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22292 */     // GIR_Coverage, 5407,
     /*  22292 */     GIR_EraseRootFromParent_Done,
     /*  22293 */   // Label 385: @22293
     /*  22293 */   GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(22429), // Rule ID 5406 //
     /*  22298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22314 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22318 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  22322 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22326 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22331 */     // MIs[1] Operand 2
     /*  22331 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22342 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22346 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22350 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22354 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22358 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  22362 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22366 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22371 */     // MIs[3] Operand 2
     /*  22371 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  22382 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  22384 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22384 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  22391 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22396 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22400 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  22404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22411 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22418 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22423 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22428 */     // GIR_Coverage, 5406,
     /*  22428 */     GIR_EraseRootFromParent_Done,
     /*  22429 */   // Label 386: @22429
     /*  22429 */   GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(22562), // Rule ID 14095 //
     /*  22434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  22458 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22462 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  22466 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22471 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  22475 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  22479 */     // MIs[1] Operand 2
     /*  22479 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22490 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  22494 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  22498 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22502 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  22506 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  22510 */     // MIs[5] Rn
     /*  22510 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22515 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  22517 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, (undef:{ *:[v8i16] })), 0:{ *:[i64] }), (trunc:{ *:[v4i16] } (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$Rn)))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /*  22517 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  22520 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  22524 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22529 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22533 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22537 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22544 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22551 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22556 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22561 */     // GIR_Coverage, 14095,
     /*  22561 */     GIR_EraseRootFromParent_Done,
     /*  22562 */   // Label 387: @22562
     /*  22562 */   GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(22695), // Rule ID 7003 //
     /*  22567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  22579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  22591 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22595 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22600 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22604 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22608 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22612 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22616 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_UZP2),
     /*  22620 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  22624 */     // MIs[4] Rn
     /*  22624 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22629 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22633 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  22637 */     // MIs[3] Operand 2
     /*  22637 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  22648 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  22650 */     // (add:{ *:[v4i16] } (trunc:{ *:[v4i16] } (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$Rn)), (extract_subvector:{ *:[v4i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, (undef:{ *:[v8i16] })), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /*  22650 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  22653 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  22657 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22662 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22666 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22677 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22684 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22689 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22694 */     // GIR_Coverage, 7003,
     /*  22694 */     GIR_EraseRootFromParent_Done,
     /*  22695 */   // Label 388: @22695
     /*  22695 */   GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(22858), // Rule ID 14053 //
     /*  22700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  22724 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22728 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22732 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22737 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22742 */     // MIs[1] Operand 2
     /*  22742 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22757 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22759 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22759 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22762 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22766 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22773 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22776 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22780 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22785 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22788 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  22792 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22795 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22800 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22805 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22810 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22813 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  22817 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22822 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22825 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22829 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  22833 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22840 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22847 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22852 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22857 */     // GIR_Coverage, 14053,
     /*  22857 */     GIR_EraseRootFromParent_Done,
     /*  22858 */   // Label 389: @22858
     /*  22858 */   GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(23021), // Rule ID 14050 //
     /*  22863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  22887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22891 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22895 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22900 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22905 */     // MIs[1] Operand 2
     /*  22905 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22920 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22922 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22922 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22925 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22929 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22936 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22939 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22943 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22948 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22951 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  22955 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22958 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22963 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22968 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22973 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22976 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  22980 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22985 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22988 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22992 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  22996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23003 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23010 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23015 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23020 */     // GIR_Coverage, 14050,
     /*  23020 */     GIR_EraseRootFromParent_Done,
     /*  23021 */   // Label 390: @23021
     /*  23021 */   GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(23171), // Rule ID 14057 //
     /*  23026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  23050 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23054 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23059 */     // MIs[1] Operand 2
     /*  23059 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23074 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23076 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23076 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23079 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23083 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23090 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23093 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23097 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23102 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23105 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  23109 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23112 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23117 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23122 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  23134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23139 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23142 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23153 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23160 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23165 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23170 */     // GIR_Coverage, 14057,
     /*  23170 */     GIR_EraseRootFromParent_Done,
     /*  23171 */   // Label 391: @23171
     /*  23171 */   GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(23321), // Rule ID 14062 //
     /*  23176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23192 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23196 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  23200 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23204 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23209 */     // MIs[1] Operand 2
     /*  23209 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23224 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23226 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23226 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23229 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23233 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23238 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23240 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23243 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23247 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23252 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23255 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  23259 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23262 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23267 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23272 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  23284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23289 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23292 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23303 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23310 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23315 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23320 */     // GIR_Coverage, 14062,
     /*  23320 */     GIR_EraseRootFromParent_Done,
     /*  23321 */   // Label 392: @23321
     /*  23321 */   GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(23471), // Rule ID 14056 //
     /*  23326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23346 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  23350 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23354 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23359 */     // MIs[1] Operand 2
     /*  23359 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23374 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23376 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23376 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23379 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23383 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23388 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23390 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23393 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23397 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23402 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23405 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  23409 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23412 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23417 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23422 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23427 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23430 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  23434 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23439 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23442 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23446 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23453 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23460 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23465 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23470 */     // GIR_Coverage, 14056,
     /*  23470 */     GIR_EraseRootFromParent_Done,
     /*  23471 */   // Label 393: @23471
     /*  23471 */   GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(23634), // Rule ID 5397 //
     /*  23476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23480 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23496 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23500 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  23504 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23508 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  23512 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23517 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23522 */     // MIs[1] Operand 2
     /*  23522 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23533 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23535 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23535 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23538 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23542 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23547 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23549 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23552 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23556 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23561 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23564 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  23568 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23571 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23576 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23581 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  23593 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23598 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23601 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  23605 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  23609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23616 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23623 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23628 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23633 */     // GIR_Coverage, 5397,
     /*  23633 */     GIR_EraseRootFromParent_Done,
     /*  23634 */   // Label 394: @23634
     /*  23634 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(23797), // Rule ID 5394 //
     /*  23639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  23667 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23671 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  23675 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23680 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23685 */     // MIs[1] Operand 2
     /*  23685 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23696 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23698 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23698 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23701 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23705 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23710 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23712 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23715 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23719 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23724 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23727 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  23731 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23734 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23739 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23744 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23749 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23752 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  23756 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23761 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23764 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  23768 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  23772 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23779 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23786 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23791 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23796 */     // GIR_Coverage, 5394,
     /*  23796 */     GIR_EraseRootFromParent_Done,
     /*  23797 */   // Label 395: @23797
     /*  23797 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(23947), // Rule ID 5419 //
     /*  23802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23822 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23826 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  23830 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23834 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23839 */     // MIs[1] Operand 2
     /*  23839 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23850 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23852 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23852 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23855 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23859 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23866 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23869 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23873 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23878 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23881 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  23885 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23888 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23893 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23898 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23903 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23906 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  23910 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23915 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23918 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23929 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23936 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23941 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23946 */     // GIR_Coverage, 5419,
     /*  23946 */     GIR_EraseRootFromParent_Done,
     /*  23947 */   // Label 396: @23947
     /*  23947 */   GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(24097), // Rule ID 5427 //
     /*  23952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23972 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23976 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  23980 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23984 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23989 */     // MIs[1] Operand 2
     /*  23989 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  24000 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24002 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  24002 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  24005 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  24009 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24014 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  24016 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  24019 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  24023 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24028 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  24031 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  24035 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  24038 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24043 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24048 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  24056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  24060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24065 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  24068 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  24072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  24074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24079 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  24086 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24091 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24096 */     // GIR_Coverage, 5427,
     /*  24096 */     GIR_EraseRootFromParent_Done,
     /*  24097 */   // Label 397: @24097
     /*  24097 */   GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(24247), // Rule ID 5418 //
     /*  24102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  24126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  24130 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24134 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24139 */     // MIs[1] Operand 2
     /*  24139 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  24150 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24152 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  24152 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  24155 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  24159 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  24166 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  24169 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  24173 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24178 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  24181 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  24185 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  24188 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24193 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24198 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24203 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  24206 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  24210 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24215 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  24218 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  24222 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  24224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24229 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  24236 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24241 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24246 */     // GIR_Coverage, 5418,
     /*  24246 */     GIR_EraseRootFromParent_Done,
     /*  24247 */   // Label 398: @24247
     /*  24247 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(24316), // Rule ID 13486 //
     /*  24252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24267 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  24270 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  24275 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24279 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  24283 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24288 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24299 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 669:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V64:{ *:[v4i16] }:$Rd)  =>  (SABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i16),
     /*  24302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  24314 */     GIR_RootConstrainSelectedInstOperands,
     /*  24315 */     // GIR_Coverage, 13486,
     /*  24315 */     GIR_EraseRootFromParent_Done,
     /*  24316 */   // Label 399: @24316
     /*  24316 */   GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(24385), // Rule ID 13498 //
     /*  24321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24336 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  24339 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  24344 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24348 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  24352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24357 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24368 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 734:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V64:{ *:[v4i16] }:$Rd)  =>  (UABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i16),
     /*  24371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  24383 */     GIR_RootConstrainSelectedInstOperands,
     /*  24384 */     // GIR_Coverage, 13498,
     /*  24384 */     GIR_EraseRootFromParent_Done,
     /*  24385 */   // Label 400: @24385
     /*  24385 */   GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(24441), // Rule ID 13448 //
     /*  24390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24405 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  24408 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  24413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24428 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 670:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  24431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24439 */     GIR_RootConstrainSelectedInstOperands,
     /*  24440 */     // GIR_Coverage, 13448,
     /*  24440 */     GIR_EraseRootFromParent_Done,
     /*  24441 */   // Label 401: @24441
     /*  24441 */   GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(24497), // Rule ID 13460 //
     /*  24446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24461 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  24464 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  24469 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24473 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24482 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24484 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 735:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  24487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24495 */     GIR_RootConstrainSelectedInstOperands,
     /*  24496 */     // GIR_Coverage, 13460,
     /*  24496 */     GIR_EraseRootFromParent_Done,
     /*  24497 */   // Label 402: @24497
     /*  24497 */   GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(24564), // Rule ID 13700 //
     /*  24502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  24517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24521 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24526 */     // MIs[1] imm
     /*  24526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24534 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  24538 */     // MIs[2] Operand 1
     /*  24538 */     // No operand predicates
     /*  24538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24542 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  24546 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24548 */     // (add:{ *:[v4i16] } (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  24551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24559 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  24562 */     GIR_RootConstrainSelectedInstOperands,
     /*  24563 */     // GIR_Coverage, 13700,
     /*  24563 */     GIR_EraseRootFromParent_Done,
     /*  24564 */   // Label 403: @24564
     /*  24564 */   GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(24631), // Rule ID 13721 //
     /*  24569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  24584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24588 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24593 */     // MIs[1] imm
     /*  24593 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24597 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24601 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  24605 */     // MIs[2] Operand 1
     /*  24605 */     // No operand predicates
     /*  24605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24609 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  24613 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24615 */     // (add:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  24618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24626 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  24629 */     GIR_RootConstrainSelectedInstOperands,
     /*  24630 */     // GIR_Coverage, 13721,
     /*  24630 */     GIR_EraseRootFromParent_Done,
     /*  24631 */   // Label 404: @24631
     /*  24631 */   GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(24700), // Rule ID 1361 //
     /*  24636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24655 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  24658 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  24663 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24667 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  24671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24676 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24683 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 669:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i16),
     /*  24686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24688 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  24698 */     GIR_RootConstrainSelectedInstOperands,
     /*  24699 */     // GIR_Coverage, 1361,
     /*  24699 */     GIR_EraseRootFromParent_Done,
     /*  24700 */   // Label 405: @24700
     /*  24700 */   GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(24769), // Rule ID 1484 //
     /*  24705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24724 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  24727 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  24732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24736 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  24740 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24752 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 734:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i16),
     /*  24755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24757 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  24767 */     GIR_RootConstrainSelectedInstOperands,
     /*  24768 */     // GIR_Coverage, 1484,
     /*  24768 */     GIR_EraseRootFromParent_Done,
     /*  24769 */   // Label 406: @24769
     /*  24769 */   GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(24825), // Rule ID 989 //
     /*  24774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24793 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  24796 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  24801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24812 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 670:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  24815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24817 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24823 */     GIR_RootConstrainSelectedInstOperands,
     /*  24824 */     // GIR_Coverage, 989,
     /*  24824 */     GIR_EraseRootFromParent_Done,
     /*  24825 */   // Label 407: @24825
     /*  24825 */   GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(24881), // Rule ID 1050 //
     /*  24830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24849 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  24852 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  24857 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24868 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 735:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  24871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24873 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24879 */     GIR_RootConstrainSelectedInstOperands,
     /*  24880 */     // GIR_Coverage, 1050,
     /*  24880 */     GIR_EraseRootFromParent_Done,
     /*  24881 */   // Label 408: @24881
     /*  24881 */   GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(24948), // Rule ID 2234 //
     /*  24886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24893 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  24905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24914 */     // MIs[1] imm
     /*  24914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24922 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  24926 */     // MIs[2] Operand 1
     /*  24926 */     // No operand predicates
     /*  24926 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  24930 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24932 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  24935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24937 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24943 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  24946 */     GIR_RootConstrainSelectedInstOperands,
     /*  24947 */     // GIR_Coverage, 2234,
     /*  24947 */     GIR_EraseRootFromParent_Done,
     /*  24948 */   // Label 409: @24948
     /*  24948 */   GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(25015), // Rule ID 2293 //
     /*  24953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  24972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24981 */     // MIs[1] imm
     /*  24981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24989 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  24993 */     // MIs[2] Operand 1
     /*  24993 */     // No operand predicates
     /*  24993 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  24997 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24999 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  25002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25004 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  25010 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  25013 */     GIR_RootConstrainSelectedInstOperands,
     /*  25014 */     // GIR_Coverage, 2293,
     /*  25014 */     GIR_EraseRootFromParent_Done,
     /*  25015 */   // Label 410: @25015
     /*  25015 */   GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(25063), // Rule ID 13447 //
     /*  25020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  25035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  25039 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25050 */     // (add:{ *:[v4i16] } (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  25050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  25053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  25061 */     GIR_RootConstrainSelectedInstOperands,
     /*  25062 */     // GIR_Coverage, 13447,
     /*  25062 */     GIR_EraseRootFromParent_Done,
     /*  25063 */   // Label 411: @25063
     /*  25063 */   GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(25111), // Rule ID 13459 //
     /*  25068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  25083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  25087 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25098 */     // (add:{ *:[v4i16] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  25098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  25101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  25109 */     GIR_RootConstrainSelectedInstOperands,
     /*  25110 */     // GIR_Coverage, 13459,
     /*  25110 */     GIR_EraseRootFromParent_Done,
     /*  25111 */   // Label 412: @25111
     /*  25111 */   GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(25159), // Rule ID 988 //
     /*  25116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  25135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  25139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25146 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  25146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  25149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25151 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  25157 */     GIR_RootConstrainSelectedInstOperands,
     /*  25158 */     // GIR_Coverage, 988,
     /*  25158 */     GIR_EraseRootFromParent_Done,
     /*  25159 */   // Label 413: @25159
     /*  25159 */   GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(25207), // Rule ID 1049 //
     /*  25164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25171 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  25183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  25187 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25194 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  25194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  25197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25199 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  25205 */     GIR_RootConstrainSelectedInstOperands,
     /*  25206 */     // GIR_Coverage, 1049,
     /*  25206 */     GIR_EraseRootFromParent_Done,
     /*  25207 */   // Label 414: @25207
     /*  25207 */   GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(25234), // Rule ID 1102 //
     /*  25212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25219 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25227 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  25227 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i16),
     /*  25232 */     GIR_RootConstrainSelectedInstOperands,
     /*  25233 */     // GIR_Coverage, 1102,
     /*  25233 */     GIR_Done,
     /*  25234 */   // Label 415: @25234
     /*  25234 */   GIM_Reject,
     /*  25235 */ // Label 381: @25235
     /*  25235 */ GIM_Reject,
     /*  25236 */ // Label 161: @25236
     /*  25236 */ GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(31413),
     /*  25241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25244 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25247 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(25365), // Rule ID 13624 //
     /*  25252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25271 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25275 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25279 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25283 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25287 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25291 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25295 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25299 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25303 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25308 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25312 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25316 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25320 */     // MIs[4] Operand 1
     /*  25320 */     // No operand predicates
     /*  25320 */     // MIs[2] Operand 2
     /*  25320 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25335 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25337 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25344 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  25347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25360 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25363 */     GIR_RootConstrainSelectedInstOperands,
     /*  25364 */     // GIR_Coverage, 13624,
     /*  25364 */     GIR_EraseRootFromParent_Done,
     /*  25365 */   // Label 417: @25365
     /*  25365 */   GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(25483), // Rule ID 13625 //
     /*  25370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25385 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25389 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25393 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25397 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25401 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25405 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25409 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25413 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25417 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25421 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25426 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25430 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25434 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25438 */     // MIs[4] Operand 1
     /*  25438 */     // No operand predicates
     /*  25438 */     // MIs[2] Operand 2
     /*  25438 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25453 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25455 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25462 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  25465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25478 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25481 */     GIR_RootConstrainSelectedInstOperands,
     /*  25482 */     // GIR_Coverage, 13625,
     /*  25482 */     GIR_EraseRootFromParent_Done,
     /*  25483 */   // Label 418: @25483
     /*  25483 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(25601), // Rule ID 13660 //
     /*  25488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25507 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25511 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25515 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25519 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25523 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25527 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25531 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25535 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25539 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25544 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25548 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25552 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25556 */     // MIs[4] Operand 1
     /*  25556 */     // No operand predicates
     /*  25556 */     // MIs[2] Operand 2
     /*  25556 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25571 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25573 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25580 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  25583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25596 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25599 */     GIR_RootConstrainSelectedInstOperands,
     /*  25600 */     // GIR_Coverage, 13660,
     /*  25600 */     GIR_EraseRootFromParent_Done,
     /*  25601 */   // Label 419: @25601
     /*  25601 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(25719), // Rule ID 13661 //
     /*  25606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25625 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25629 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25633 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25637 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25641 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25645 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25649 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25653 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25657 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25662 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25666 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25670 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25674 */     // MIs[4] Operand 1
     /*  25674 */     // No operand predicates
     /*  25674 */     // MIs[2] Operand 2
     /*  25674 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25689 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25691 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25698 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  25701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25714 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25717 */     GIR_RootConstrainSelectedInstOperands,
     /*  25718 */     // GIR_Coverage, 13661,
     /*  25718 */     GIR_EraseRootFromParent_Done,
     /*  25719 */   // Label 420: @25719
     /*  25719 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(25837), // Rule ID 2039 //
     /*  25724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25747 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25759 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25763 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25767 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25771 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25775 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25779 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25784 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25788 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25792 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25796 */     // MIs[4] Operand 1
     /*  25796 */     // No operand predicates
     /*  25796 */     // MIs[2] Operand 2
     /*  25796 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25807 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25809 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25816 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  25819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25821 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25832 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25835 */     GIR_RootConstrainSelectedInstOperands,
     /*  25836 */     // GIR_Coverage, 2039,
     /*  25836 */     GIR_EraseRootFromParent_Done,
     /*  25837 */   // Label 421: @25837
     /*  25837 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(25955), // Rule ID 13623 //
     /*  25842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25865 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25869 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25873 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25877 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25881 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25885 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25889 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25893 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25897 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25902 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25906 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25910 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25914 */     // MIs[4] Operand 1
     /*  25914 */     // No operand predicates
     /*  25914 */     // MIs[2] Operand 2
     /*  25914 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25925 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25927 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25934 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  25937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25939 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25950 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25953 */     GIR_RootConstrainSelectedInstOperands,
     /*  25954 */     // GIR_Coverage, 13623,
     /*  25954 */     GIR_EraseRootFromParent_Done,
     /*  25955 */   // Label 422: @25955
     /*  25955 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(26073), // Rule ID 2091 //
     /*  25960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25995 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25999 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26003 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26007 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26011 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26015 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26020 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26024 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26028 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26032 */     // MIs[4] Operand 1
     /*  26032 */     // No operand predicates
     /*  26032 */     // MIs[2] Operand 2
     /*  26032 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  26043 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26045 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26052 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  26055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26057 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26068 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26071 */     GIR_RootConstrainSelectedInstOperands,
     /*  26072 */     // GIR_Coverage, 2091,
     /*  26072 */     GIR_EraseRootFromParent_Done,
     /*  26073 */   // Label 423: @26073
     /*  26073 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(26191), // Rule ID 13659 //
     /*  26078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26101 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26113 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26117 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26121 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26125 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26129 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26133 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26138 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26142 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26146 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26150 */     // MIs[4] Operand 1
     /*  26150 */     // No operand predicates
     /*  26150 */     // MIs[2] Operand 2
     /*  26150 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  26161 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26163 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26170 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  26173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26175 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26186 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26189 */     GIR_RootConstrainSelectedInstOperands,
     /*  26190 */     // GIR_Coverage, 13659,
     /*  26190 */     GIR_EraseRootFromParent_Done,
     /*  26191 */   // Label 424: @26191
     /*  26191 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(26278), // Rule ID 13530 //
     /*  26196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  26223 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  26226 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  26231 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26235 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  26239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26243 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26245 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26252 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26259 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 669:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))), V128:{ *:[v4i32] }:$Rd)  =>  (SABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i16_v4i32),
     /*  26262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26276 */     GIR_RootConstrainSelectedInstOperands,
     /*  26277 */     // GIR_Coverage, 13530,
     /*  26277 */     GIR_EraseRootFromParent_Done,
     /*  26278 */   // Label 425: @26278
     /*  26278 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(26365), // Rule ID 13558 //
     /*  26283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  26310 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  26313 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  26318 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26322 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  26326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26330 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26332 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26339 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26346 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 734:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))), V128:{ *:[v4i32] }:$Rd)  =>  (UABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i16_v4i32),
     /*  26349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26363 */     GIR_RootConstrainSelectedInstOperands,
     /*  26364 */     // GIR_Coverage, 13558,
     /*  26364 */     GIR_EraseRootFromParent_Done,
     /*  26365 */   // Label 426: @26365
     /*  26365 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(26452), // Rule ID 1695 //
     /*  26370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26393 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26397 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  26401 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  26404 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  26409 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26413 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  26417 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26419 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26426 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26433 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 669:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))))  =>  (SABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i16_v4i32),
     /*  26436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26438 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26450 */     GIR_RootConstrainSelectedInstOperands,
     /*  26451 */     // GIR_Coverage, 1695,
     /*  26451 */     GIR_EraseRootFromParent_Done,
     /*  26452 */   // Label 427: @26452
     /*  26452 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(26539), // Rule ID 1773 //
     /*  26457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  26488 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  26491 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  26496 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26500 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  26504 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26506 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26513 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26520 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 734:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))))  =>  (UABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i16_v4i32),
     /*  26523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26525 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26537 */     GIR_RootConstrainSelectedInstOperands,
     /*  26538 */     // GIR_Coverage, 1773,
     /*  26538 */     GIR_EraseRootFromParent_Done,
     /*  26539 */   // Label 428: @26539
     /*  26539 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(26654), // Rule ID 13619 //
     /*  26544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26563 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26575 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26579 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26583 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26587 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26591 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26595 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26600 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26604 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26608 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26612 */     // MIs[4] Operand 1
     /*  26612 */     // No operand predicates
     /*  26612 */     // MIs[2] Operand 2
     /*  26612 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26623 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26632 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26634 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26649 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26652 */     GIR_RootConstrainSelectedInstOperands,
     /*  26653 */     // GIR_Coverage, 13619,
     /*  26653 */     GIR_EraseRootFromParent_Done,
     /*  26654 */   // Label 429: @26654
     /*  26654 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(26769), // Rule ID 13618 //
     /*  26659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26678 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26695 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26699 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26703 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26707 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26711 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26715 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26720 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26724 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26728 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26732 */     // MIs[4] Operand 1
     /*  26732 */     // No operand predicates
     /*  26732 */     // MIs[2] Operand 2
     /*  26732 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26747 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26749 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26764 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26767 */     GIR_RootConstrainSelectedInstOperands,
     /*  26768 */     // GIR_Coverage, 13618,
     /*  26768 */     GIR_EraseRootFromParent_Done,
     /*  26769 */   // Label 430: @26769
     /*  26769 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(26884), // Rule ID 13655 //
     /*  26774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26805 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26809 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26813 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26817 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26821 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26825 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26830 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26834 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26838 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26842 */     // MIs[4] Operand 1
     /*  26842 */     // No operand predicates
     /*  26842 */     // MIs[2] Operand 2
     /*  26842 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26862 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26864 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  26867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26882 */     GIR_RootConstrainSelectedInstOperands,
     /*  26883 */     // GIR_Coverage, 13655,
     /*  26883 */     GIR_EraseRootFromParent_Done,
     /*  26884 */   // Label 431: @26884
     /*  26884 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(26999), // Rule ID 13654 //
     /*  26889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26908 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26912 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26921 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26925 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26929 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26933 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26937 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26941 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26945 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26950 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26954 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26958 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26962 */     // MIs[4] Operand 1
     /*  26962 */     // No operand predicates
     /*  26962 */     // MIs[2] Operand 2
     /*  26962 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26977 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26979 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  26982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26994 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26997 */     GIR_RootConstrainSelectedInstOperands,
     /*  26998 */     // GIR_Coverage, 13654,
     /*  26998 */     GIR_EraseRootFromParent_Done,
     /*  26999 */   // Label 432: @26999
     /*  26999 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(27068), // Rule ID 1793 //
     /*  27004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  27019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  27027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  27031 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27035 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27037 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27044 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27051 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  27054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  27056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27066 */     GIR_RootConstrainSelectedInstOperands,
     /*  27067 */     // GIR_Coverage, 1793,
     /*  27067 */     GIR_EraseRootFromParent_Done,
     /*  27068 */   // Label 433: @27068
     /*  27068 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(27137), // Rule ID 1792 //
     /*  27073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  27088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  27096 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27100 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27104 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27106 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27113 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27120 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  27123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  27125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27135 */     GIR_RootConstrainSelectedInstOperands,
     /*  27136 */     // GIR_Coverage, 1792,
     /*  27136 */     GIR_EraseRootFromParent_Done,
     /*  27137 */   // Label 434: @27137
     /*  27137 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(27206), // Rule ID 1715 //
     /*  27142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  27157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  27165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  27169 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27173 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27175 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27182 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27189 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i16_v4i32),
     /*  27192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  27194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27204 */     GIR_RootConstrainSelectedInstOperands,
     /*  27205 */     // GIR_Coverage, 1715,
     /*  27205 */     GIR_EraseRootFromParent_Done,
     /*  27206 */   // Label 435: @27206
     /*  27206 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(27275), // Rule ID 1791 //
     /*  27211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  27234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  27238 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27242 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27244 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27251 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27258 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  27261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  27263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27273 */     GIR_RootConstrainSelectedInstOperands,
     /*  27274 */     // GIR_Coverage, 1791,
     /*  27274 */     GIR_EraseRootFromParent_Done,
     /*  27275 */   // Label 436: @27275
     /*  27275 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(27344), // Rule ID 1790 //
     /*  27280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  27303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27307 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27311 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27313 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27320 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27327 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  27330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  27332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27342 */     GIR_RootConstrainSelectedInstOperands,
     /*  27343 */     // GIR_Coverage, 1790,
     /*  27343 */     GIR_EraseRootFromParent_Done,
     /*  27344 */   // Label 437: @27344
     /*  27344 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(27459), // Rule ID 13617 //
     /*  27349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27372 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  27384 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27388 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27392 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27396 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27400 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  27404 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27409 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  27413 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27417 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27421 */     // MIs[4] Operand 1
     /*  27421 */     // No operand predicates
     /*  27421 */     // MIs[2] Operand 2
     /*  27421 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  27432 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27437 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  27439 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  27442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27444 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  27454 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  27457 */     GIR_RootConstrainSelectedInstOperands,
     /*  27458 */     // GIR_Coverage, 13617,
     /*  27458 */     GIR_EraseRootFromParent_Done,
     /*  27459 */   // Label 438: @27459
     /*  27459 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(27574), // Rule ID 2037 //
     /*  27464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27487 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27491 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27496 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27500 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  27504 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27508 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27512 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27516 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27520 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  27524 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27529 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  27533 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27537 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27541 */     // MIs[4] Operand 1
     /*  27541 */     // No operand predicates
     /*  27541 */     // MIs[2] Operand 2
     /*  27541 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  27552 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  27554 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  27557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27559 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  27569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  27572 */     GIR_RootConstrainSelectedInstOperands,
     /*  27573 */     // GIR_Coverage, 2037,
     /*  27573 */     GIR_EraseRootFromParent_Done,
     /*  27574 */   // Label 439: @27574
     /*  27574 */   GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(27689), // Rule ID 13653 //
     /*  27579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27602 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27610 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  27614 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27618 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27622 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27626 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27630 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  27634 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27639 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  27643 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27647 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27651 */     // MIs[4] Operand 1
     /*  27651 */     // No operand predicates
     /*  27651 */     // MIs[2] Operand 2
     /*  27651 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  27662 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27667 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  27669 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  27672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27674 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  27684 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  27687 */     GIR_RootConstrainSelectedInstOperands,
     /*  27688 */     // GIR_Coverage, 13653,
     /*  27688 */     GIR_EraseRootFromParent_Done,
     /*  27689 */   // Label 440: @27689
     /*  27689 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(27804), // Rule ID 2089 //
     /*  27694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27713 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27717 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27721 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27726 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27730 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  27734 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27738 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27742 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27746 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27750 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  27754 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27759 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  27763 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27767 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27771 */     // MIs[4] Operand 1
     /*  27771 */     // No operand predicates
     /*  27771 */     // MIs[2] Operand 2
     /*  27771 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  27782 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  27784 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  27787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27789 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  27799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  27802 */     GIR_RootConstrainSelectedInstOperands,
     /*  27803 */     // GIR_Coverage, 2089,
     /*  27803 */     GIR_EraseRootFromParent_Done,
     /*  27804 */   // Label 441: @27804
     /*  27804 */   GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(27871), // Rule ID 13544 //
     /*  27809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27828 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27838 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27845 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27852 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_v4i32),
     /*  27855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27869 */     GIR_RootConstrainSelectedInstOperands,
     /*  27870 */     // GIR_Coverage, 13544,
     /*  27870 */     GIR_EraseRootFromParent_Done,
     /*  27871 */   // Label 442: @27871
     /*  27871 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(27938), // Rule ID 13578 //
     /*  27876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27905 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27912 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27919 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_v4i32),
     /*  27922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27936 */     GIR_RootConstrainSelectedInstOperands,
     /*  27937 */     // GIR_Coverage, 13578,
     /*  27937 */     GIR_EraseRootFromParent_Done,
     /*  27938 */   // Label 443: @27938
     /*  27938 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(28005), // Rule ID 1727 //
     /*  27943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27966 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27972 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27979 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27986 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_v4i32),
     /*  27989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27991 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  28003 */     GIR_RootConstrainSelectedInstOperands,
     /*  28004 */     // GIR_Coverage, 1727,
     /*  28004 */     GIR_EraseRootFromParent_Done,
     /*  28005 */   // Label 444: @28005
     /*  28005 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(28072), // Rule ID 1817 //
     /*  28010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28033 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28039 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28046 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28053 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_v4i32),
     /*  28056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28058 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  28065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  28070 */     GIR_RootConstrainSelectedInstOperands,
     /*  28071 */     // GIR_Coverage, 1817,
     /*  28071 */     GIR_EraseRootFromParent_Done,
     /*  28072 */   // Label 445: @28072
     /*  28072 */   GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(28153), // Rule ID 13528 //
     /*  28077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28104 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  28107 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  28112 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28116 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  28120 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28125 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28134 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28136 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 669:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (SABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i16_v4i32),
     /*  28139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  28147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  28151 */     GIR_RootConstrainSelectedInstOperands,
     /*  28152 */     // GIR_Coverage, 13528,
     /*  28152 */     GIR_EraseRootFromParent_Done,
     /*  28153 */   // Label 446: @28153
     /*  28153 */   GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(28234), // Rule ID 13556 //
     /*  28158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28177 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28181 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28185 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  28188 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  28193 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28197 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  28201 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28206 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28215 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28217 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 734:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (UABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i16_v4i32),
     /*  28220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  28228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  28232 */     GIR_RootConstrainSelectedInstOperands,
     /*  28233 */     // GIR_Coverage, 13556,
     /*  28233 */     GIR_EraseRootFromParent_Done,
     /*  28234 */   // Label 447: @28234
     /*  28234 */   GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(28315), // Rule ID 1693 //
     /*  28239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28266 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28270 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  28273 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  28278 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28282 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  28286 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28291 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28296 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28298 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 669:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)))  =>  (SABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i16_v4i32),
     /*  28301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28303 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  28309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  28313 */     GIR_RootConstrainSelectedInstOperands,
     /*  28314 */     // GIR_Coverage, 1693,
     /*  28314 */     GIR_EraseRootFromParent_Done,
     /*  28315 */   // Label 448: @28315
     /*  28315 */   GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(28396), // Rule ID 1771 //
     /*  28320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28343 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28347 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28351 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  28354 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  28359 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28363 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  28367 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28372 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28377 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28379 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 734:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)))  =>  (UABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i16_v4i32),
     /*  28382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28384 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  28390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  28394 */     GIR_RootConstrainSelectedInstOperands,
     /*  28395 */     // GIR_Coverage, 1771,
     /*  28395 */     GIR_EraseRootFromParent_Done,
     /*  28396 */   // Label 449: @28396
     /*  28396 */   GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(28488), // Rule ID 13622 //
     /*  28401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28424 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28428 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28432 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28436 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28440 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28445 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28449 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28453 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28457 */     // MIs[3] Operand 1
     /*  28457 */     // No operand predicates
     /*  28457 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28466 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28468 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  28471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28483 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28486 */     GIR_RootConstrainSelectedInstOperands,
     /*  28487 */     // GIR_Coverage, 13622,
     /*  28487 */     GIR_EraseRootFromParent_Done,
     /*  28488 */   // Label 450: @28488
     /*  28488 */   GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(28580), // Rule ID 13621 //
     /*  28493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28512 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28516 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28521 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  28525 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28529 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28533 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28537 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28542 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28546 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28550 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28554 */     // MIs[3] Operand 1
     /*  28554 */     // No operand predicates
     /*  28554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28558 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28560 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  28563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28578 */     GIR_RootConstrainSelectedInstOperands,
     /*  28579 */     // GIR_Coverage, 13621,
     /*  28579 */     GIR_EraseRootFromParent_Done,
     /*  28580 */   // Label 451: @28580
     /*  28580 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(28672), // Rule ID 13658 //
     /*  28585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28604 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28616 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28620 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28624 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28629 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28633 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28637 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28641 */     // MIs[3] Operand 1
     /*  28641 */     // No operand predicates
     /*  28641 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28650 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28652 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28670 */     GIR_RootConstrainSelectedInstOperands,
     /*  28671 */     // GIR_Coverage, 13658,
     /*  28671 */     GIR_EraseRootFromParent_Done,
     /*  28672 */   // Label 452: @28672
     /*  28672 */   GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(28764), // Rule ID 13657 //
     /*  28677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28696 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28705 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  28709 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28713 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28717 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28721 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28726 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28730 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28734 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28738 */     // MIs[3] Operand 1
     /*  28738 */     // No operand predicates
     /*  28738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28742 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28744 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28762 */     GIR_RootConstrainSelectedInstOperands,
     /*  28763 */     // GIR_Coverage, 13657,
     /*  28763 */     GIR_EraseRootFromParent_Done,
     /*  28764 */   // Label 453: @28764
     /*  28764 */   GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(28856), // Rule ID 13620 //
     /*  28769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28792 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28796 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28800 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28804 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28808 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28812 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28817 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28821 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28825 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28829 */     // MIs[3] Operand 1
     /*  28829 */     // No operand predicates
     /*  28829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28834 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28836 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  28839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28841 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28851 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28854 */     GIR_RootConstrainSelectedInstOperands,
     /*  28855 */     // GIR_Coverage, 13620,
     /*  28855 */     GIR_EraseRootFromParent_Done,
     /*  28856 */   // Label 454: @28856
     /*  28856 */   GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(28948), // Rule ID 2038 //
     /*  28861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28884 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28888 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  28897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28901 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28905 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28909 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28914 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28918 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28922 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28926 */     // MIs[3] Operand 1
     /*  28926 */     // No operand predicates
     /*  28926 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28928 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  28931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28933 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28943 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28946 */     GIR_RootConstrainSelectedInstOperands,
     /*  28947 */     // GIR_Coverage, 2038,
     /*  28947 */     GIR_EraseRootFromParent_Done,
     /*  28948 */   // Label 455: @28948
     /*  28948 */   GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(29040), // Rule ID 13656 //
     /*  28953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28976 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28988 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28992 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28996 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  29001 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  29005 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29009 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  29013 */     // MIs[3] Operand 1
     /*  29013 */     // No operand predicates
     /*  29013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29018 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  29020 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  29020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  29023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29025 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  29035 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  29038 */     GIR_RootConstrainSelectedInstOperands,
     /*  29039 */     // GIR_Coverage, 13656,
     /*  29039 */     GIR_EraseRootFromParent_Done,
     /*  29040 */   // Label 456: @29040
     /*  29040 */   GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(29132), // Rule ID 2090 //
     /*  29045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  29064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  29072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  29085 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29089 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  29093 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  29098 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  29102 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29106 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  29110 */     // MIs[3] Operand 1
     /*  29110 */     // No operand predicates
     /*  29110 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  29112 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  29112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  29115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29117 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  29127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  29130 */     GIR_RootConstrainSelectedInstOperands,
     /*  29131 */     // GIR_Coverage, 2090,
     /*  29131 */     GIR_EraseRootFromParent_Done,
     /*  29132 */   // Label 457: @29132
     /*  29132 */   GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(29183), // Rule ID 13570 //
     /*  29137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29162 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  29169 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  29169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  29172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  29176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  29181 */     GIR_RootConstrainSelectedInstOperands,
     /*  29182 */     // GIR_Coverage, 13570,
     /*  29182 */     GIR_EraseRootFromParent_Done,
     /*  29183 */   // Label 458: @29183
     /*  29183 */   GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(29234), // Rule ID 13538 //
     /*  29188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  29203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29213 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  29220 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (SADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  29220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i16_v4i32),
     /*  29223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  29227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  29232 */     GIR_RootConstrainSelectedInstOperands,
     /*  29233 */     // GIR_Coverage, 13538,
     /*  29233 */     GIR_EraseRootFromParent_Done,
     /*  29234 */   // Label 459: @29234
     /*  29234 */   GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(29285), // Rule ID 13569 //
     /*  29239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  29254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29264 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  29271 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  29271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  29274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  29278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  29283 */     GIR_RootConstrainSelectedInstOperands,
     /*  29284 */     // GIR_Coverage, 13569,
     /*  29284 */     GIR_EraseRootFromParent_Done,
     /*  29285 */   // Label 460: @29285
     /*  29285 */   GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(29336), // Rule ID 1809 //
     /*  29290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29297 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29309 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29315 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  29322 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  29322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  29325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29327 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  29329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  29334 */     GIR_RootConstrainSelectedInstOperands,
     /*  29335 */     // GIR_Coverage, 1809,
     /*  29335 */     GIR_EraseRootFromParent_Done,
     /*  29336 */   // Label 461: @29336
     /*  29336 */   GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(29387), // Rule ID 1721 //
     /*  29341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  29360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29366 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  29373 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  29373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i16_v4i32),
     /*  29376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29378 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  29380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  29385 */     GIR_RootConstrainSelectedInstOperands,
     /*  29386 */     // GIR_Coverage, 1721,
     /*  29386 */     GIR_EraseRootFromParent_Done,
     /*  29387 */   // Label 462: @29387
     /*  29387 */   GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(29438), // Rule ID 1808 //
     /*  29392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  29411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29417 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  29424 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  29424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  29427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29429 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  29431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  29436 */     GIR_RootConstrainSelectedInstOperands,
     /*  29437 */     // GIR_Coverage, 1808,
     /*  29437 */     GIR_EraseRootFromParent_Done,
     /*  29438 */   // Label 463: @29438
     /*  29438 */   GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(29507), // Rule ID 13492 //
     /*  29443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29458 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29461 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  29466 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29470 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  29474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29479 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29488 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29490 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 669:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (SABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  29490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i32),
     /*  29493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29505 */     GIR_RootConstrainSelectedInstOperands,
     /*  29506 */     // GIR_Coverage, 13492,
     /*  29506 */     GIR_EraseRootFromParent_Done,
     /*  29507 */   // Label 464: @29507
     /*  29507 */   GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(29576), // Rule ID 13504 //
     /*  29512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29527 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29530 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  29535 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29539 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  29543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29548 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29559 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 734:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (UABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  29559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i32),
     /*  29562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29574 */     GIR_RootConstrainSelectedInstOperands,
     /*  29575 */     // GIR_Coverage, 13504,
     /*  29575 */     GIR_EraseRootFromParent_Done,
     /*  29576 */   // Label 465: @29576
     /*  29576 */   GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(29632), // Rule ID 13454 //
     /*  29581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29596 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  29599 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  29604 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29619 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 670:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  29622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29630 */     GIR_RootConstrainSelectedInstOperands,
     /*  29631 */     // GIR_Coverage, 13454,
     /*  29631 */     GIR_EraseRootFromParent_Done,
     /*  29632 */   // Label 466: @29632
     /*  29632 */   GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(29688), // Rule ID 13466 //
     /*  29637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29652 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  29655 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  29660 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29664 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29675 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 735:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  29678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29686 */     GIR_RootConstrainSelectedInstOperands,
     /*  29687 */     // GIR_Coverage, 13466,
     /*  29687 */     GIR_EraseRootFromParent_Done,
     /*  29688 */   // Label 467: @29688
     /*  29688 */   GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(29755), // Rule ID 13706 //
     /*  29693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  29708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29717 */     // MIs[1] imm
     /*  29717 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29721 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29725 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29729 */     // MIs[2] Operand 1
     /*  29729 */     // No operand predicates
     /*  29729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29733 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29737 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29739 */     // (add:{ *:[v4i32] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  29742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29750 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29753 */     GIR_RootConstrainSelectedInstOperands,
     /*  29754 */     // GIR_Coverage, 13706,
     /*  29754 */     GIR_EraseRootFromParent_Done,
     /*  29755 */   // Label 468: @29755
     /*  29755 */   GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(29822), // Rule ID 13727 //
     /*  29760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  29775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29779 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29784 */     // MIs[1] imm
     /*  29784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29792 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29796 */     // MIs[2] Operand 1
     /*  29796 */     // No operand predicates
     /*  29796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29800 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29804 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29806 */     // (add:{ *:[v4i32] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  29809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29817 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29820 */     GIR_RootConstrainSelectedInstOperands,
     /*  29821 */     // GIR_Coverage, 13727,
     /*  29821 */     GIR_EraseRootFromParent_Done,
     /*  29822 */   // Label 469: @29822
     /*  29822 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(29891), // Rule ID 1367 //
     /*  29827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29846 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29849 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  29854 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29858 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  29862 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29874 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 669:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (SABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  29874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i32),
     /*  29877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29879 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29889 */     GIR_RootConstrainSelectedInstOperands,
     /*  29890 */     // GIR_Coverage, 1367,
     /*  29890 */     GIR_EraseRootFromParent_Done,
     /*  29891 */   // Label 470: @29891
     /*  29891 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(29960), // Rule ID 1490 //
     /*  29896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29915 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29918 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  29923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29927 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  29931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29943 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 734:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (UABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  29943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i32),
     /*  29946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29948 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29958 */     GIR_RootConstrainSelectedInstOperands,
     /*  29959 */     // GIR_Coverage, 1490,
     /*  29959 */     GIR_EraseRootFromParent_Done,
     /*  29960 */   // Label 471: @29960
     /*  29960 */   GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(30016), // Rule ID 995 //
     /*  29965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29984 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  29987 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  29992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30003 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 670:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  30006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30008 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  30014 */     GIR_RootConstrainSelectedInstOperands,
     /*  30015 */     // GIR_Coverage, 995,
     /*  30015 */     GIR_EraseRootFromParent_Done,
     /*  30016 */   // Label 472: @30016
     /*  30016 */   GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(30072), // Rule ID 1056 //
     /*  30021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  30040 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  30043 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  30048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  30052 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30059 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 735:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  30062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30064 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  30070 */     GIR_RootConstrainSelectedInstOperands,
     /*  30071 */     // GIR_Coverage, 1056,
     /*  30071 */     GIR_EraseRootFromParent_Done,
     /*  30072 */   // Label 473: @30072
     /*  30072 */   GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(30139), // Rule ID 2240 //
     /*  30077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  30096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30100 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30105 */     // MIs[1] imm
     /*  30105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  30109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  30113 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  30117 */     // MIs[2] Operand 1
     /*  30117 */     // No operand predicates
     /*  30117 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  30121 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30123 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  30123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  30126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30128 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30134 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  30137 */     GIR_RootConstrainSelectedInstOperands,
     /*  30138 */     // GIR_Coverage, 2240,
     /*  30138 */     GIR_EraseRootFromParent_Done,
     /*  30139 */   // Label 474: @30139
     /*  30139 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(30206), // Rule ID 2299 //
     /*  30144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  30163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30167 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30172 */     // MIs[1] imm
     /*  30172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  30176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  30180 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  30184 */     // MIs[2] Operand 1
     /*  30184 */     // No operand predicates
     /*  30184 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  30188 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30190 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  30190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  30193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30195 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30201 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  30204 */     GIR_RootConstrainSelectedInstOperands,
     /*  30205 */     // GIR_Coverage, 2299,
     /*  30205 */     GIR_EraseRootFromParent_Done,
     /*  30206 */   // Label 475: @30206
     /*  30206 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(30276), // Rule ID 6999 //
     /*  30211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  30223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30227 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30231 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30236 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  30249 */     // MIs[2] Rn
     /*  30249 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  30254 */     // MIs[2] Rm
     /*  30254 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  30259 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30261 */     // (add:{ *:[v4i32] } (AArch64uzp1:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm), (AArch64uzp2:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm))  =>  (ADDPv4i32:{ *:[v4i32] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rm)
     /*  30261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  30264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30274 */     GIR_RootConstrainSelectedInstOperands,
     /*  30275 */     // GIR_Coverage, 6999,
     /*  30275 */     GIR_EraseRootFromParent_Done,
     /*  30276 */   // Label 476: @30276
     /*  30276 */   GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(30346), // Rule ID 14091 //
     /*  30281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  30293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30297 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30301 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30306 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  30319 */     // MIs[2] Rn
     /*  30319 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  30324 */     // MIs[2] Rm
     /*  30324 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  30329 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30331 */     // (add:{ *:[v4i32] } (AArch64uzp2:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm), (AArch64uzp1:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm))  =>  (ADDPv4i32:{ *:[v4i32] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rm)
     /*  30331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  30334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30344 */     GIR_RootConstrainSelectedInstOperands,
     /*  30345 */     // GIR_Coverage, 14091,
     /*  30345 */     GIR_EraseRootFromParent_Done,
     /*  30346 */   // Label 477: @30346
     /*  30346 */   GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(30409), // Rule ID 1789 //
     /*  30351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30370 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30387 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30392 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30394 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  30397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  30407 */     GIR_RootConstrainSelectedInstOperands,
     /*  30408 */     // GIR_Coverage, 1789,
     /*  30408 */     GIR_EraseRootFromParent_Done,
     /*  30409 */   // Label 478: @30409
     /*  30409 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(30472), // Rule ID 1788 //
     /*  30414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30433 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30438 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30442 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30446 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30450 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30455 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30457 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  30460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  30470 */     GIR_RootConstrainSelectedInstOperands,
     /*  30471 */     // GIR_Coverage, 1788,
     /*  30471 */     GIR_EraseRootFromParent_Done,
     /*  30472 */   // Label 479: @30472
     /*  30472 */   GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(30535), // Rule ID 1714 //
     /*  30477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  30492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30496 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30501 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30505 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  30509 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30513 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30518 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30520 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i16_v4i32),
     /*  30523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  30533 */     GIR_RootConstrainSelectedInstOperands,
     /*  30534 */     // GIR_Coverage, 1714,
     /*  30534 */     GIR_EraseRootFromParent_Done,
     /*  30535 */   // Label 480: @30535
     /*  30535 */   GIM_Try, /*On fail goto*//*Label 481*/ GIMT_Encode4(30598), // Rule ID 1787 //
     /*  30540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30555 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30576 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30581 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30583 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  30586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  30596 */     GIR_RootConstrainSelectedInstOperands,
     /*  30597 */     // GIR_Coverage, 1787,
     /*  30597 */     GIR_EraseRootFromParent_Done,
     /*  30598 */   // Label 481: @30598
     /*  30598 */   GIM_Try, /*On fail goto*//*Label 482*/ GIMT_Encode4(30661), // Rule ID 1786 //
     /*  30603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30635 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30639 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30644 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30646 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  30649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  30659 */     GIR_RootConstrainSelectedInstOperands,
     /*  30660 */     // GIR_Coverage, 1786,
     /*  30660 */     GIR_EraseRootFromParent_Done,
     /*  30661 */   // Label 482: @30661
     /*  30661 */   GIM_Try, /*On fail goto*//*Label 483*/ GIMT_Encode4(30722), // Rule ID 13543 //
     /*  30666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  30681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30685 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30694 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30705 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  30708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30720 */     GIR_RootConstrainSelectedInstOperands,
     /*  30721 */     // GIR_Coverage, 13543,
     /*  30721 */     GIR_EraseRootFromParent_Done,
     /*  30722 */   // Label 483: @30722
     /*  30722 */   GIM_Try, /*On fail goto*//*Label 484*/ GIMT_Encode4(30783), // Rule ID 13577 //
     /*  30727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  30742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30746 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30750 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30755 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30766 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  30769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30781 */     GIR_RootConstrainSelectedInstOperands,
     /*  30782 */     // GIR_Coverage, 13577,
     /*  30782 */     GIR_EraseRootFromParent_Done,
     /*  30783 */   // Label 484: @30783
     /*  30783 */   GIM_Try, /*On fail goto*//*Label 485*/ GIMT_Encode4(30831), // Rule ID 13568 //
     /*  30788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30807 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30818 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  30825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30829 */     GIR_RootConstrainSelectedInstOperands,
     /*  30830 */     // GIR_Coverage, 13568,
     /*  30830 */     GIR_EraseRootFromParent_Done,
     /*  30831 */   // Label 485: @30831
     /*  30831 */   GIM_Try, /*On fail goto*//*Label 486*/ GIMT_Encode4(30879), // Rule ID 13453 //
     /*  30836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  30851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30855 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30866 */     // (add:{ *:[v4i32] } (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  30869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30877 */     GIR_RootConstrainSelectedInstOperands,
     /*  30878 */     // GIR_Coverage, 13453,
     /*  30878 */     GIR_EraseRootFromParent_Done,
     /*  30879 */   // Label 486: @30879
     /*  30879 */   GIM_Try, /*On fail goto*//*Label 487*/ GIMT_Encode4(30927), // Rule ID 13537 //
     /*  30884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  30899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30914 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (SADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  30917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  30921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30925 */     GIR_RootConstrainSelectedInstOperands,
     /*  30926 */     // GIR_Coverage, 13537,
     /*  30926 */     GIR_EraseRootFromParent_Done,
     /*  30927 */   // Label 487: @30927
     /*  30927 */   GIM_Try, /*On fail goto*//*Label 488*/ GIMT_Encode4(30975), // Rule ID 13465 //
     /*  30932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  30947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30951 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30962 */     // (add:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  30965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30973 */     GIR_RootConstrainSelectedInstOperands,
     /*  30974 */     // GIR_Coverage, 13465,
     /*  30974 */     GIR_EraseRootFromParent_Done,
     /*  30975 */   // Label 488: @30975
     /*  30975 */   GIM_Try, /*On fail goto*//*Label 489*/ GIMT_Encode4(31023), // Rule ID 13567 //
     /*  30980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30999 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31008 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31010 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  31010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  31013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  31015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  31017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  31021 */     GIR_RootConstrainSelectedInstOperands,
     /*  31022 */     // GIR_Coverage, 13567,
     /*  31022 */     GIR_EraseRootFromParent_Done,
     /*  31023 */   // Label 489: @31023
     /*  31023 */   GIM_Try, /*On fail goto*//*Label 490*/ GIMT_Encode4(31084), // Rule ID 1726 //
     /*  31028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31035 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  31047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  31051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  31055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31060 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31067 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  31067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  31070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31072 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  31082 */     GIR_RootConstrainSelectedInstOperands,
     /*  31083 */     // GIR_Coverage, 1726,
     /*  31083 */     GIR_EraseRootFromParent_Done,
     /*  31084 */   // Label 490: @31084
     /*  31084 */   GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(31145), // Rule ID 1816 //
     /*  31089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  31108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  31112 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  31116 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31128 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  31128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  31131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31133 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  31143 */     GIR_RootConstrainSelectedInstOperands,
     /*  31144 */     // GIR_Coverage, 1816,
     /*  31144 */     GIR_EraseRootFromParent_Done,
     /*  31145 */   // Label 491: @31145
     /*  31145 */   GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(31193), // Rule ID 1807 //
     /*  31150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  31169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  31173 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31178 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31180 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  31180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  31183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  31185 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  31187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  31191 */     GIR_RootConstrainSelectedInstOperands,
     /*  31192 */     // GIR_Coverage, 1807,
     /*  31192 */     GIR_EraseRootFromParent_Done,
     /*  31193 */   // Label 492: @31193
     /*  31193 */   GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(31241), // Rule ID 994 //
     /*  31198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  31217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31221 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31228 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  31228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  31231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31233 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31239 */     GIR_RootConstrainSelectedInstOperands,
     /*  31240 */     // GIR_Coverage, 994,
     /*  31240 */     GIR_EraseRootFromParent_Done,
     /*  31241 */   // Label 493: @31241
     /*  31241 */   GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(31289), // Rule ID 1720 //
     /*  31246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  31265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  31269 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31274 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31276 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  31276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  31279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  31281 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  31283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  31287 */     GIR_RootConstrainSelectedInstOperands,
     /*  31288 */     // GIR_Coverage, 1720,
     /*  31288 */     GIR_EraseRootFromParent_Done,
     /*  31289 */   // Label 494: @31289
     /*  31289 */   GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(31337), // Rule ID 1055 //
     /*  31294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  31313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31317 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31322 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31324 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  31324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  31327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31329 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31335 */     GIR_RootConstrainSelectedInstOperands,
     /*  31336 */     // GIR_Coverage, 1055,
     /*  31336 */     GIR_EraseRootFromParent_Done,
     /*  31337 */   // Label 495: @31337
     /*  31337 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(31385), // Rule ID 1806 //
     /*  31342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  31365 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31370 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31372 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  31372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  31375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  31377 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  31379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  31383 */     GIR_RootConstrainSelectedInstOperands,
     /*  31384 */     // GIR_Coverage, 1806,
     /*  31384 */     GIR_EraseRootFromParent_Done,
     /*  31385 */   // Label 496: @31385
     /*  31385 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(31412), // Rule ID 1105 //
     /*  31390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31405 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  31405 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
     /*  31410 */     GIR_RootConstrainSelectedInstOperands,
     /*  31411 */     // GIR_Coverage, 1105,
     /*  31411 */     GIR_Done,
     /*  31412 */   // Label 497: @31412
     /*  31412 */   GIM_Reject,
     /*  31413 */ // Label 416: @31413
     /*  31413 */ GIM_Reject,
     /*  31414 */ // Label 162: @31414
     /*  31414 */ GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(32263),
     /*  31419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31422 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31425 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(31558), // Rule ID 14096 //
     /*  31430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  31442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31450 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  31454 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31458 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  31462 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31467 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  31471 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  31475 */     // MIs[1] Operand 2
     /*  31475 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  31486 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  31490 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  31494 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31498 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  31502 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  31506 */     // MIs[5] Rn
     /*  31506 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  31511 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  31513 */     // (add:{ *:[v8i8] } (extract_subvector:{ *:[v8i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, (undef:{ *:[v16i8] })), 0:{ *:[i64] }), (trunc:{ *:[v8i8] } (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$Rn)))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /*  31513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  31516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  31520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  31525 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  31529 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  31533 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  31535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31540 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  31547 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31552 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31557 */     // GIR_Coverage, 14096,
     /*  31557 */     GIR_EraseRootFromParent_Done,
     /*  31558 */   // Label 499: @31558
     /*  31558 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(31691), // Rule ID 7004 //
     /*  31563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  31575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31579 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31583 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  31587 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31591 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31596 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  31600 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  31604 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31608 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  31612 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_UZP2),
     /*  31616 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  31620 */     // MIs[4] Rn
     /*  31620 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  31625 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  31629 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  31633 */     // MIs[3] Operand 2
     /*  31633 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  31644 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  31646 */     // (add:{ *:[v8i8] } (trunc:{ *:[v8i8] } (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$Rn)), (extract_subvector:{ *:[v8i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, (undef:{ *:[v16i8] })), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /*  31646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  31649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  31653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  31658 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  31662 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  31666 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  31668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31673 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  31680 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31685 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31690 */     // GIR_Coverage, 7004,
     /*  31690 */     GIR_EraseRootFromParent_Done,
     /*  31691 */   // Label 500: @31691
     /*  31691 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(31760), // Rule ID 13482 //
     /*  31696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31711 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31714 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31719 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31723 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31727 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31732 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31743 */     // (add:{ *:[v8i8] } (intrinsic_wo_chain:{ *:[v8i8] } 669:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V64:{ *:[v8i8] }:$Rd)  =>  (SABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i8),
     /*  31746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31758 */     GIR_RootConstrainSelectedInstOperands,
     /*  31759 */     // GIR_Coverage, 13482,
     /*  31759 */     GIR_EraseRootFromParent_Done,
     /*  31760 */   // Label 501: @31760
     /*  31760 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(31829), // Rule ID 13494 //
     /*  31765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31780 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31783 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31788 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31792 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31796 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31801 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31812 */     // (add:{ *:[v8i8] } (intrinsic_wo_chain:{ *:[v8i8] } 734:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V64:{ *:[v8i8] }:$Rd)  =>  (UABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i8),
     /*  31815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31827 */     GIR_RootConstrainSelectedInstOperands,
     /*  31828 */     // GIR_Coverage, 13494,
     /*  31828 */     GIR_EraseRootFromParent_Done,
     /*  31829 */   // Label 502: @31829
     /*  31829 */   GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(31896), // Rule ID 13696 //
     /*  31834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  31849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31858 */     // MIs[1] imm
     /*  31858 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31862 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31866 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31870 */     // MIs[2] Operand 1
     /*  31870 */     // No operand predicates
     /*  31870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31874 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31878 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31880 */     // (add:{ *:[v8i8] } (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  31883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31894 */     GIR_RootConstrainSelectedInstOperands,
     /*  31895 */     // GIR_Coverage, 13696,
     /*  31895 */     GIR_EraseRootFromParent_Done,
     /*  31896 */   // Label 503: @31896
     /*  31896 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(31963), // Rule ID 13717 //
     /*  31901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  31916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31925 */     // MIs[1] imm
     /*  31925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31933 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31937 */     // MIs[2] Operand 1
     /*  31937 */     // No operand predicates
     /*  31937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31941 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31945 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31947 */     // (add:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  31950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31958 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31961 */     GIR_RootConstrainSelectedInstOperands,
     /*  31962 */     // GIR_Coverage, 13717,
     /*  31962 */     GIR_EraseRootFromParent_Done,
     /*  31963 */   // Label 504: @31963
     /*  31963 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(32032), // Rule ID 1357 //
     /*  31968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31987 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31990 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31995 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31999 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32003 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32008 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32015 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 669:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i8),
     /*  32018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32020 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  32026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  32030 */     GIR_RootConstrainSelectedInstOperands,
     /*  32031 */     // GIR_Coverage, 1357,
     /*  32031 */     GIR_EraseRootFromParent_Done,
     /*  32032 */   // Label 505: @32032
     /*  32032 */   GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(32101), // Rule ID 1480 //
     /*  32037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32044 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32056 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  32059 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  32064 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32068 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32084 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 734:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i8),
     /*  32087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32089 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  32095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  32099 */     GIR_RootConstrainSelectedInstOperands,
     /*  32100 */     // GIR_Coverage, 1480,
     /*  32100 */     GIR_EraseRootFromParent_Done,
     /*  32101 */   // Label 506: @32101
     /*  32101 */   GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(32168), // Rule ID 2230 //
     /*  32106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  32125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32129 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32134 */     // MIs[1] imm
     /*  32134 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  32138 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  32142 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  32146 */     // MIs[2] Operand 1
     /*  32146 */     // No operand predicates
     /*  32146 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  32150 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32152 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  32152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  32155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32157 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32163 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  32166 */     GIR_RootConstrainSelectedInstOperands,
     /*  32167 */     // GIR_Coverage, 2230,
     /*  32167 */     GIR_EraseRootFromParent_Done,
     /*  32168 */   // Label 507: @32168
     /*  32168 */   GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(32235), // Rule ID 2289 //
     /*  32173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32180 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  32192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32196 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32201 */     // MIs[1] imm
     /*  32201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  32205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  32209 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  32213 */     // MIs[2] Operand 1
     /*  32213 */     // No operand predicates
     /*  32213 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  32217 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32219 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  32219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  32222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32224 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32230 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  32233 */     GIR_RootConstrainSelectedInstOperands,
     /*  32234 */     // GIR_Coverage, 2289,
     /*  32234 */     GIR_EraseRootFromParent_Done,
     /*  32235 */   // Label 508: @32235
     /*  32235 */   GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(32262), // Rule ID 1100 //
     /*  32240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32255 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32255 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv8i8),
     /*  32260 */     GIR_RootConstrainSelectedInstOperands,
     /*  32261 */     // GIR_Coverage, 1100,
     /*  32261 */     GIR_Done,
     /*  32262 */   // Label 509: @32262
     /*  32262 */   GIM_Reject,
     /*  32263 */ // Label 498: @32263
     /*  32263 */ GIM_Reject,
     /*  32264 */ // Label 163: @32264
     /*  32264 */ GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(35841),
     /*  32269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32272 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  32275 */   GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(32362), // Rule ID 13526 //
     /*  32280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32307 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32310 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  32315 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32319 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32327 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32329 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32336 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32343 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 669:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))), V128:{ *:[v8i16] }:$Rd)  =>  (SABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv16i8_v8i16),
     /*  32346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32360 */     GIR_RootConstrainSelectedInstOperands,
     /*  32361 */     // GIR_Coverage, 13526,
     /*  32361 */     GIR_EraseRootFromParent_Done,
     /*  32362 */   // Label 511: @32362
     /*  32362 */   GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(32449), // Rule ID 13554 //
     /*  32367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32394 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32397 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  32402 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32406 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32414 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32416 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32423 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32430 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 734:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))), V128:{ *:[v8i16] }:$Rd)  =>  (UABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv16i8_v8i16),
     /*  32433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32447 */     GIR_RootConstrainSelectedInstOperands,
     /*  32448 */     // GIR_Coverage, 13554,
     /*  32448 */     GIR_EraseRootFromParent_Done,
     /*  32449 */   // Label 512: @32449
     /*  32449 */   GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(32536), // Rule ID 1691 //
     /*  32454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32485 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32488 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  32493 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32497 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32501 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32503 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32510 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32517 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 669:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))))  =>  (SABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv16i8_v8i16),
     /*  32520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32522 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32534 */     GIR_RootConstrainSelectedInstOperands,
     /*  32535 */     // GIR_Coverage, 1691,
     /*  32535 */     GIR_EraseRootFromParent_Done,
     /*  32536 */   // Label 513: @32536
     /*  32536 */   GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(32623), // Rule ID 1769 //
     /*  32541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32572 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32575 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  32580 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32584 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32588 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32590 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32597 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32604 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 734:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))))  =>  (UABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv16i8_v8i16),
     /*  32607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32609 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32621 */     GIR_RootConstrainSelectedInstOperands,
     /*  32622 */     // GIR_Coverage, 1769,
     /*  32622 */     GIR_EraseRootFromParent_Done,
     /*  32623 */   // Label 514: @32623
     /*  32623 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(32692), // Rule ID 1785 //
     /*  32628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32655 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32659 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32661 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32668 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32675 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32690 */     GIR_RootConstrainSelectedInstOperands,
     /*  32691 */     // GIR_Coverage, 1785,
     /*  32691 */     GIR_EraseRootFromParent_Done,
     /*  32692 */   // Label 515: @32692
     /*  32692 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(32761), // Rule ID 1784 //
     /*  32697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32724 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32728 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32730 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32737 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32744 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32759 */     GIR_RootConstrainSelectedInstOperands,
     /*  32760 */     // GIR_Coverage, 1784,
     /*  32760 */     GIR_EraseRootFromParent_Done,
     /*  32761 */   // Label 516: @32761
     /*  32761 */   GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(32830), // Rule ID 1713 //
     /*  32766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  32781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  32793 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32797 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32799 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32806 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32813 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv16i8_v8i16),
     /*  32816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32828 */     GIR_RootConstrainSelectedInstOperands,
     /*  32829 */     // GIR_Coverage, 1713,
     /*  32829 */     GIR_EraseRootFromParent_Done,
     /*  32830 */   // Label 517: @32830
     /*  32830 */   GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(32899), // Rule ID 1783 //
     /*  32835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32854 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32858 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32862 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32866 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32868 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32875 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32882 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32897 */     GIR_RootConstrainSelectedInstOperands,
     /*  32898 */     // GIR_Coverage, 1783,
     /*  32898 */     GIR_EraseRootFromParent_Done,
     /*  32899 */   // Label 518: @32899
     /*  32899 */   GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(32968), // Rule ID 1782 //
     /*  32904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32931 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32935 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32937 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32944 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32951 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32966 */     GIR_RootConstrainSelectedInstOperands,
     /*  32967 */     // GIR_Coverage, 1782,
     /*  32967 */     GIR_EraseRootFromParent_Done,
     /*  32968 */   // Label 519: @32968
     /*  32968 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(33035), // Rule ID 13542 //
     /*  32973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  32988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33002 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33009 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33016 */     // (add:{ *:[v8i16] } (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (SMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv16i8_v8i16),
     /*  33019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  33028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  33033 */     GIR_RootConstrainSelectedInstOperands,
     /*  33034 */     // GIR_Coverage, 13542,
     /*  33034 */     GIR_EraseRootFromParent_Done,
     /*  33035 */   // Label 520: @33035
     /*  33035 */   GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(33102), // Rule ID 13576 //
     /*  33040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  33055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33059 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  33063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33069 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33076 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33083 */     // (add:{ *:[v8i16] } (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (UMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv16i8_v8i16),
     /*  33086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  33095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  33100 */     GIR_RootConstrainSelectedInstOperands,
     /*  33101 */     // GIR_Coverage, 13576,
     /*  33101 */     GIR_EraseRootFromParent_Done,
     /*  33102 */   // Label 521: @33102
     /*  33102 */   GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(33169), // Rule ID 1725 //
     /*  33107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  33126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33130 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  33134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33136 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33143 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33150 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv16i8_v8i16),
     /*  33153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33155 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  33162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  33167 */     GIR_RootConstrainSelectedInstOperands,
     /*  33168 */     // GIR_Coverage, 1725,
     /*  33168 */     GIR_EraseRootFromParent_Done,
     /*  33169 */   // Label 522: @33169
     /*  33169 */   GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(33236), // Rule ID 1815 //
     /*  33174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  33193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  33201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33203 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33210 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33217 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv16i8_v8i16),
     /*  33220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33222 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  33229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  33234 */     GIR_RootConstrainSelectedInstOperands,
     /*  33235 */     // GIR_Coverage, 1815,
     /*  33235 */     GIR_EraseRootFromParent_Done,
     /*  33236 */   // Label 523: @33236
     /*  33236 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(33317), // Rule ID 13524 //
     /*  33241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33268 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  33271 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  33276 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  33280 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  33284 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33289 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33298 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33300 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 669:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (SABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  33300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i8_v8i16),
     /*  33303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  33311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  33315 */     GIR_RootConstrainSelectedInstOperands,
     /*  33316 */     // GIR_Coverage, 13524,
     /*  33316 */     GIR_EraseRootFromParent_Done,
     /*  33317 */   // Label 524: @33317
     /*  33317 */   GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(33398), // Rule ID 13552 //
     /*  33322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33341 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33345 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33349 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  33352 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  33357 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  33361 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  33365 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33370 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33379 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33381 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 734:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (UABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  33381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i8_v8i16),
     /*  33384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  33392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  33396 */     GIR_RootConstrainSelectedInstOperands,
     /*  33397 */     // GIR_Coverage, 13552,
     /*  33397 */     GIR_EraseRootFromParent_Done,
     /*  33398 */   // Label 525: @33398
     /*  33398 */   GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(33479), // Rule ID 1689 //
     /*  33403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33430 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33434 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  33437 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  33442 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  33446 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  33450 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33455 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33460 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33462 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 669:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)))  =>  (SABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  33462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i8_v8i16),
     /*  33465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33467 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  33473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  33477 */     GIR_RootConstrainSelectedInstOperands,
     /*  33478 */     // GIR_Coverage, 1689,
     /*  33478 */     GIR_EraseRootFromParent_Done,
     /*  33479 */   // Label 526: @33479
     /*  33479 */   GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(33560), // Rule ID 1767 //
     /*  33484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33515 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  33518 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  33523 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  33527 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  33531 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33536 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33541 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33543 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 734:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)))  =>  (UABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  33543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i8_v8i16),
     /*  33546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33548 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  33554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  33558 */     GIR_RootConstrainSelectedInstOperands,
     /*  33559 */     // GIR_Coverage, 1767,
     /*  33559 */     GIR_EraseRootFromParent_Done,
     /*  33560 */   // Label 527: @33560
     /*  33560 */   GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(33611), // Rule ID 13566 //
     /*  33565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  33580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33590 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33597 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  33604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33609 */     GIR_RootConstrainSelectedInstOperands,
     /*  33610 */     // GIR_Coverage, 13566,
     /*  33610 */     GIR_EraseRootFromParent_Done,
     /*  33611 */   // Label 528: @33611
     /*  33611 */   GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(33662), // Rule ID 13536 //
     /*  33616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  33631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33641 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33648 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (SADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv16i8_v8i16),
     /*  33651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  33655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33660 */     GIR_RootConstrainSelectedInstOperands,
     /*  33661 */     // GIR_Coverage, 13536,
     /*  33661 */     GIR_EraseRootFromParent_Done,
     /*  33662 */   // Label 529: @33662
     /*  33662 */   GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(33713), // Rule ID 13565 //
     /*  33667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33692 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33699 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  33706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33711 */     GIR_RootConstrainSelectedInstOperands,
     /*  33712 */     // GIR_Coverage, 13565,
     /*  33712 */     GIR_EraseRootFromParent_Done,
     /*  33713 */   // Label 530: @33713
     /*  33713 */   GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(33764), // Rule ID 1805 //
     /*  33718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  33737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33743 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33750 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33755 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33762 */     GIR_RootConstrainSelectedInstOperands,
     /*  33763 */     // GIR_Coverage, 1805,
     /*  33763 */     GIR_EraseRootFromParent_Done,
     /*  33764 */   // Label 531: @33764
     /*  33764 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(33815), // Rule ID 1719 //
     /*  33769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  33788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33794 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33801 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv16i8_v8i16),
     /*  33804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33806 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33813 */     GIR_RootConstrainSelectedInstOperands,
     /*  33814 */     // GIR_Coverage, 1719,
     /*  33814 */     GIR_EraseRootFromParent_Done,
     /*  33815 */   // Label 532: @33815
     /*  33815 */   GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(33866), // Rule ID 1804 //
     /*  33820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33845 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33852 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33857 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33864 */     GIR_RootConstrainSelectedInstOperands,
     /*  33865 */     // GIR_Coverage, 1804,
     /*  33865 */     GIR_EraseRootFromParent_Done,
     /*  33866 */   // Label 533: @33866
     /*  33866 */   GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(33935), // Rule ID 13488 //
     /*  33871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33886 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33889 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  33894 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33898 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33902 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33907 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33916 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33918 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 669:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (SABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i16),
     /*  33921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33933 */     GIR_RootConstrainSelectedInstOperands,
     /*  33934 */     // GIR_Coverage, 13488,
     /*  33934 */     GIR_EraseRootFromParent_Done,
     /*  33935 */   // Label 534: @33935
     /*  33935 */   GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(34004), // Rule ID 13500 //
     /*  33940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33955 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33958 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  33963 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33967 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33971 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33987 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 734:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (UABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i16),
     /*  33990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  34002 */     GIR_RootConstrainSelectedInstOperands,
     /*  34003 */     // GIR_Coverage, 13500,
     /*  34003 */     GIR_EraseRootFromParent_Done,
     /*  34004 */   // Label 535: @34004
     /*  34004 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(34060), // Rule ID 13450 //
     /*  34009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  34024 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  34027 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  34032 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  34036 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34047 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 670:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  34047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  34050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  34058 */     GIR_RootConstrainSelectedInstOperands,
     /*  34059 */     // GIR_Coverage, 13450,
     /*  34059 */     GIR_EraseRootFromParent_Done,
     /*  34060 */   // Label 536: @34060
     /*  34060 */   GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(34116), // Rule ID 13462 //
     /*  34065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  34080 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  34083 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  34088 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  34092 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34103 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 735:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  34103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  34106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  34114 */     GIR_RootConstrainSelectedInstOperands,
     /*  34115 */     // GIR_Coverage, 13462,
     /*  34115 */     GIR_EraseRootFromParent_Done,
     /*  34116 */   // Label 537: @34116
     /*  34116 */   GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(34183), // Rule ID 13702 //
     /*  34121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  34136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34140 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34145 */     // MIs[1] imm
     /*  34145 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  34149 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  34153 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  34157 */     // MIs[2] Operand 1
     /*  34157 */     // No operand predicates
     /*  34157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34161 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  34165 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34167 */     // (add:{ *:[v8i16] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  34167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  34170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34178 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  34181 */     GIR_RootConstrainSelectedInstOperands,
     /*  34182 */     // GIR_Coverage, 13702,
     /*  34182 */     GIR_EraseRootFromParent_Done,
     /*  34183 */   // Label 538: @34183
     /*  34183 */   GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(34250), // Rule ID 13723 //
     /*  34188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  34203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34207 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34212 */     // MIs[1] imm
     /*  34212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  34216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  34220 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  34224 */     // MIs[2] Operand 1
     /*  34224 */     // No operand predicates
     /*  34224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34228 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  34232 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34234 */     // (add:{ *:[v8i16] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  34234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  34237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34245 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  34248 */     GIR_RootConstrainSelectedInstOperands,
     /*  34249 */     // GIR_Coverage, 13723,
     /*  34249 */     GIR_EraseRootFromParent_Done,
     /*  34250 */   // Label 539: @34250
     /*  34250 */   GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(34319), // Rule ID 1363 //
     /*  34255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  34274 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  34277 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  34282 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  34286 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  34290 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34295 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34302 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 669:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (SABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  34302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i16),
     /*  34305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34307 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  34313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  34317 */     GIR_RootConstrainSelectedInstOperands,
     /*  34318 */     // GIR_Coverage, 1363,
     /*  34318 */     GIR_EraseRootFromParent_Done,
     /*  34319 */   // Label 540: @34319
     /*  34319 */   GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(34388), // Rule ID 1486 //
     /*  34324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  34343 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  34346 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  34351 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  34355 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  34359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34364 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34371 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 734:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (UABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  34371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i16),
     /*  34374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34376 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  34382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  34386 */     GIR_RootConstrainSelectedInstOperands,
     /*  34387 */     // GIR_Coverage, 1486,
     /*  34387 */     GIR_EraseRootFromParent_Done,
     /*  34388 */   // Label 541: @34388
     /*  34388 */   GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(34444), // Rule ID 991 //
     /*  34393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  34412 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  34415 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  34420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  34424 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34431 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 670:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  34431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  34434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34436 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  34442 */     GIR_RootConstrainSelectedInstOperands,
     /*  34443 */     // GIR_Coverage, 991,
     /*  34443 */     GIR_EraseRootFromParent_Done,
     /*  34444 */   // Label 542: @34444
     /*  34444 */   GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(34500), // Rule ID 1052 //
     /*  34449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  34468 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  34471 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  34476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  34480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34487 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 735:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  34487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  34490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34492 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  34498 */     GIR_RootConstrainSelectedInstOperands,
     /*  34499 */     // GIR_Coverage, 1052,
     /*  34499 */     GIR_EraseRootFromParent_Done,
     /*  34500 */   // Label 543: @34500
     /*  34500 */   GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(34567), // Rule ID 2236 //
     /*  34505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34512 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  34524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34528 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34533 */     // MIs[1] imm
     /*  34533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  34537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  34541 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  34545 */     // MIs[2] Operand 1
     /*  34545 */     // No operand predicates
     /*  34545 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  34549 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34551 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  34551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  34554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34556 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34562 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  34565 */     GIR_RootConstrainSelectedInstOperands,
     /*  34566 */     // GIR_Coverage, 2236,
     /*  34566 */     GIR_EraseRootFromParent_Done,
     /*  34567 */   // Label 544: @34567
     /*  34567 */   GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(34634), // Rule ID 2295 //
     /*  34572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  34591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34600 */     // MIs[1] imm
     /*  34600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  34604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  34608 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  34612 */     // MIs[2] Operand 1
     /*  34612 */     // No operand predicates
     /*  34612 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  34616 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34618 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  34618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  34621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34623 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  34632 */     GIR_RootConstrainSelectedInstOperands,
     /*  34633 */     // GIR_Coverage, 2295,
     /*  34633 */     GIR_EraseRootFromParent_Done,
     /*  34634 */   // Label 545: @34634
     /*  34634 */   GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(34704), // Rule ID 7000 //
     /*  34639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  34651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34655 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  34659 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34664 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34669 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34673 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  34677 */     // MIs[2] Rn
     /*  34677 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  34682 */     // MIs[2] Rm
     /*  34682 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  34687 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34689 */     // (add:{ *:[v8i16] } (AArch64uzp1:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm), (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm))  =>  (ADDPv8i16:{ *:[v8i16] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rm)
     /*  34689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  34692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34702 */     GIR_RootConstrainSelectedInstOperands,
     /*  34703 */     // GIR_Coverage, 7000,
     /*  34703 */     GIR_EraseRootFromParent_Done,
     /*  34704 */   // Label 546: @34704
     /*  34704 */   GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(34774), // Rule ID 14092 //
     /*  34709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  34721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34725 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  34729 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34734 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  34747 */     // MIs[2] Rn
     /*  34747 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  34752 */     // MIs[2] Rm
     /*  34752 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  34757 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34759 */     // (add:{ *:[v8i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm), (AArch64uzp1:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm))  =>  (ADDPv8i16:{ *:[v8i16] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rm)
     /*  34759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  34762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34772 */     GIR_RootConstrainSelectedInstOperands,
     /*  34773 */     // GIR_Coverage, 14092,
     /*  34773 */     GIR_EraseRootFromParent_Done,
     /*  34774 */   // Label 547: @34774
     /*  34774 */   GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(34837), // Rule ID 1781 //
     /*  34779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34798 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34803 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34807 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34811 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34815 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34820 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34822 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34835 */     GIR_RootConstrainSelectedInstOperands,
     /*  34836 */     // GIR_Coverage, 1781,
     /*  34836 */     GIR_EraseRootFromParent_Done,
     /*  34837 */   // Label 548: @34837
     /*  34837 */   GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(34900), // Rule ID 1780 //
     /*  34842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34874 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34878 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34883 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34885 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34898 */     GIR_RootConstrainSelectedInstOperands,
     /*  34899 */     // GIR_Coverage, 1780,
     /*  34899 */     GIR_EraseRootFromParent_Done,
     /*  34900 */   // Label 549: @34900
     /*  34900 */   GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(34963), // Rule ID 1712 //
     /*  34905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  34920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34924 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  34937 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34941 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34946 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34948 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i8_v8i16),
     /*  34951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34961 */     GIR_RootConstrainSelectedInstOperands,
     /*  34962 */     // GIR_Coverage, 1712,
     /*  34962 */     GIR_EraseRootFromParent_Done,
     /*  34963 */   // Label 550: @34963
     /*  34963 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(35026), // Rule ID 1779 //
     /*  34968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34987 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  35000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35004 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35009 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35011 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  35014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  35024 */     GIR_RootConstrainSelectedInstOperands,
     /*  35025 */     // GIR_Coverage, 1779,
     /*  35025 */     GIR_EraseRootFromParent_Done,
     /*  35026 */   // Label 551: @35026
     /*  35026 */   GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(35089), // Rule ID 1778 //
     /*  35031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  35046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  35059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  35063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35067 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35072 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35074 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  35077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  35087 */     GIR_RootConstrainSelectedInstOperands,
     /*  35088 */     // GIR_Coverage, 1778,
     /*  35088 */     GIR_EraseRootFromParent_Done,
     /*  35089 */   // Label 552: @35089
     /*  35089 */   GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(35150), // Rule ID 13541 //
     /*  35094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  35109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  35117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35133 */     // (add:{ *:[v8i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (SMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  35136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  35148 */     GIR_RootConstrainSelectedInstOperands,
     /*  35149 */     // GIR_Coverage, 13541,
     /*  35149 */     GIR_EraseRootFromParent_Done,
     /*  35150 */   // Label 553: @35150
     /*  35150 */   GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(35211), // Rule ID 13575 //
     /*  35155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  35170 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35174 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  35178 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35183 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35194 */     // (add:{ *:[v8i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (UMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  35197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  35209 */     GIR_RootConstrainSelectedInstOperands,
     /*  35210 */     // GIR_Coverage, 13575,
     /*  35210 */     GIR_EraseRootFromParent_Done,
     /*  35211 */   // Label 554: @35211
     /*  35211 */   GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(35259), // Rule ID 13564 //
     /*  35216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  35231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35235 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35246 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  35249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  35253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35257 */     GIR_RootConstrainSelectedInstOperands,
     /*  35258 */     // GIR_Coverage, 13564,
     /*  35258 */     GIR_EraseRootFromParent_Done,
     /*  35259 */   // Label 555: @35259
     /*  35259 */   GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(35307), // Rule ID 13449 //
     /*  35264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  35279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35283 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35294 */     // (add:{ *:[v8i16] } (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  35294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  35297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35305 */     GIR_RootConstrainSelectedInstOperands,
     /*  35306 */     // GIR_Coverage, 13449,
     /*  35306 */     GIR_EraseRootFromParent_Done,
     /*  35307 */   // Label 556: @35307
     /*  35307 */   GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(35355), // Rule ID 13535 //
     /*  35312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  35327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35331 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35342 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (SADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  35345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  35349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35353 */     GIR_RootConstrainSelectedInstOperands,
     /*  35354 */     // GIR_Coverage, 13535,
     /*  35354 */     GIR_EraseRootFromParent_Done,
     /*  35355 */   // Label 557: @35355
     /*  35355 */   GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(35403), // Rule ID 13461 //
     /*  35360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  35375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35379 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35390 */     // (add:{ *:[v8i16] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  35390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  35393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35401 */     GIR_RootConstrainSelectedInstOperands,
     /*  35402 */     // GIR_Coverage, 13461,
     /*  35402 */     GIR_EraseRootFromParent_Done,
     /*  35403 */   // Label 558: @35403
     /*  35403 */   GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(35451), // Rule ID 13563 //
     /*  35408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  35423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35438 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  35441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  35445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35449 */     GIR_RootConstrainSelectedInstOperands,
     /*  35450 */     // GIR_Coverage, 13563,
     /*  35450 */     GIR_EraseRootFromParent_Done,
     /*  35451 */   // Label 559: @35451
     /*  35451 */   GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(35512), // Rule ID 1724 //
     /*  35456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  35475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35479 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  35483 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35495 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  35498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35500 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  35510 */     GIR_RootConstrainSelectedInstOperands,
     /*  35511 */     // GIR_Coverage, 1724,
     /*  35511 */     GIR_EraseRootFromParent_Done,
     /*  35512 */   // Label 560: @35512
     /*  35512 */   GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(35573), // Rule ID 1814 //
     /*  35517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  35536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35540 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  35544 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35556 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  35559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35561 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  35571 */     GIR_RootConstrainSelectedInstOperands,
     /*  35572 */     // GIR_Coverage, 1814,
     /*  35572 */     GIR_EraseRootFromParent_Done,
     /*  35573 */   // Label 561: @35573
     /*  35573 */   GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(35621), // Rule ID 1803 //
     /*  35578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  35597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35601 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35608 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  35611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35613 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35619 */     GIR_RootConstrainSelectedInstOperands,
     /*  35620 */     // GIR_Coverage, 1803,
     /*  35620 */     GIR_EraseRootFromParent_Done,
     /*  35621 */   // Label 562: @35621
     /*  35621 */   GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(35669), // Rule ID 990 //
     /*  35626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  35645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35654 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35656 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  35656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  35659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35661 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35667 */     GIR_RootConstrainSelectedInstOperands,
     /*  35668 */     // GIR_Coverage, 990,
     /*  35668 */     GIR_EraseRootFromParent_Done,
     /*  35669 */   // Label 563: @35669
     /*  35669 */   GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(35717), // Rule ID 1718 //
     /*  35674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  35693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35697 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35702 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35704 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  35707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35709 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35715 */     GIR_RootConstrainSelectedInstOperands,
     /*  35716 */     // GIR_Coverage, 1718,
     /*  35716 */     GIR_EraseRootFromParent_Done,
     /*  35717 */   // Label 564: @35717
     /*  35717 */   GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(35765), // Rule ID 1051 //
     /*  35722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  35741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35752 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  35752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  35755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35757 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35763 */     GIR_RootConstrainSelectedInstOperands,
     /*  35764 */     // GIR_Coverage, 1051,
     /*  35764 */     GIR_EraseRootFromParent_Done,
     /*  35765 */   // Label 565: @35765
     /*  35765 */   GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(35813), // Rule ID 1802 //
     /*  35770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  35789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35800 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  35803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35805 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35811 */     GIR_RootConstrainSelectedInstOperands,
     /*  35812 */     // GIR_Coverage, 1802,
     /*  35812 */     GIR_EraseRootFromParent_Done,
     /*  35813 */   // Label 566: @35813
     /*  35813 */   GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(35840), // Rule ID 1103 //
     /*  35818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35833 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  35833 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv8i16),
     /*  35838 */     GIR_RootConstrainSelectedInstOperands,
     /*  35839 */     // GIR_Coverage, 1103,
     /*  35839 */     GIR_Done,
     /*  35840 */   // Label 567: @35840
     /*  35840 */   GIM_Reject,
     /*  35841 */ // Label 510: @35841
     /*  35841 */ GIM_Reject,
     /*  35842 */ // Label 164: @35842
     /*  35842 */ GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(36565),
     /*  35847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35850 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35853 */   GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(35922), // Rule ID 13484 //
     /*  35858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35873 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35876 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  35881 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35885 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35894 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35905 */     // (add:{ *:[v16i8] } (intrinsic_wo_chain:{ *:[v16i8] } 669:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), V128:{ *:[v16i8] }:$Rd)  =>  (SABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv16i8),
     /*  35908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35920 */     GIR_RootConstrainSelectedInstOperands,
     /*  35921 */     // GIR_Coverage, 13484,
     /*  35921 */     GIR_EraseRootFromParent_Done,
     /*  35922 */   // Label 569: @35922
     /*  35922 */   GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(35991), // Rule ID 13496 //
     /*  35927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35942 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35945 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  35950 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35954 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35974 */     // (add:{ *:[v16i8] } (intrinsic_wo_chain:{ *:[v16i8] } 734:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), V128:{ *:[v16i8] }:$Rd)  =>  (UABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv16i8),
     /*  35977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35989 */     GIR_RootConstrainSelectedInstOperands,
     /*  35990 */     // GIR_Coverage, 13496,
     /*  35990 */     GIR_EraseRootFromParent_Done,
     /*  35991 */   // Label 570: @35991
     /*  35991 */   GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(36058), // Rule ID 13698 //
     /*  35996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  36011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  36015 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36020 */     // MIs[1] imm
     /*  36020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  36024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  36028 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  36032 */     // MIs[2] Operand 1
     /*  36032 */     // No operand predicates
     /*  36032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36036 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  36040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36042 */     // (add:{ *:[v16i8] } (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  36042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  36045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  36049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  36053 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  36056 */     GIR_RootConstrainSelectedInstOperands,
     /*  36057 */     // GIR_Coverage, 13698,
     /*  36057 */     GIR_EraseRootFromParent_Done,
     /*  36058 */   // Label 571: @36058
     /*  36058 */   GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(36125), // Rule ID 13719 //
     /*  36063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  36078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  36082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36087 */     // MIs[1] imm
     /*  36087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  36091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  36095 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  36099 */     // MIs[2] Operand 1
     /*  36099 */     // No operand predicates
     /*  36099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36103 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  36107 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36109 */     // (add:{ *:[v16i8] } (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  36109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  36112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  36116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  36120 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  36123 */     GIR_RootConstrainSelectedInstOperands,
     /*  36124 */     // GIR_Coverage, 13719,
     /*  36124 */     GIR_EraseRootFromParent_Done,
     /*  36125 */   // Label 572: @36125
     /*  36125 */   GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(36194), // Rule ID 1359 //
     /*  36130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  36149 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  36152 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  36157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  36161 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  36165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36170 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36177 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (intrinsic_wo_chain:{ *:[v16i8] } 669:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))  =>  (SABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  36177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv16i8),
     /*  36180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36182 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  36184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  36188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  36192 */     GIR_RootConstrainSelectedInstOperands,
     /*  36193 */     // GIR_Coverage, 1359,
     /*  36193 */     GIR_EraseRootFromParent_Done,
     /*  36194 */   // Label 573: @36194
     /*  36194 */   GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(36263), // Rule ID 1482 //
     /*  36199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  36218 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  36221 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  36226 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  36230 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  36234 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36246 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (intrinsic_wo_chain:{ *:[v16i8] } 734:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))  =>  (UABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  36246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv16i8),
     /*  36249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36251 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  36253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  36257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  36261 */     GIR_RootConstrainSelectedInstOperands,
     /*  36262 */     // GIR_Coverage, 1482,
     /*  36262 */     GIR_EraseRootFromParent_Done,
     /*  36263 */   // Label 574: @36263
     /*  36263 */   GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(36330), // Rule ID 2232 //
     /*  36268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  36287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  36291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36296 */     // MIs[1] imm
     /*  36296 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  36300 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  36304 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  36308 */     // MIs[2] Operand 1
     /*  36308 */     // No operand predicates
     /*  36308 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  36312 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36314 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  36314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  36317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36319 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  36321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  36325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  36328 */     GIR_RootConstrainSelectedInstOperands,
     /*  36329 */     // GIR_Coverage, 2232,
     /*  36329 */     GIR_EraseRootFromParent_Done,
     /*  36330 */   // Label 575: @36330
     /*  36330 */   GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(36397), // Rule ID 2291 //
     /*  36335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  36354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  36358 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36363 */     // MIs[1] imm
     /*  36363 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  36367 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  36371 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  36375 */     // MIs[2] Operand 1
     /*  36375 */     // No operand predicates
     /*  36375 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  36379 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36381 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  36381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  36384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36386 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  36388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  36392 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  36395 */     GIR_RootConstrainSelectedInstOperands,
     /*  36396 */     // GIR_Coverage, 2291,
     /*  36396 */     GIR_EraseRootFromParent_Done,
     /*  36397 */   // Label 576: @36397
     /*  36397 */   GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(36467), // Rule ID 7001 //
     /*  36402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  36414 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  36418 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  36422 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  36436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  36440 */     // MIs[2] Rn
     /*  36440 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  36445 */     // MIs[2] Rm
     /*  36445 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  36450 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36452 */     // (add:{ *:[v16i8] } (AArch64uzp1:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm), (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm))  =>  (ADDPv16i8:{ *:[v16i8] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm)
     /*  36452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  36455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  36461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  36465 */     GIR_RootConstrainSelectedInstOperands,
     /*  36466 */     // GIR_Coverage, 7001,
     /*  36466 */     GIR_EraseRootFromParent_Done,
     /*  36467 */   // Label 577: @36467
     /*  36467 */   GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(36537), // Rule ID 14093 //
     /*  36472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  36484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  36488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  36492 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36497 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  36506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  36510 */     // MIs[2] Rn
     /*  36510 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  36515 */     // MIs[2] Rm
     /*  36515 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  36520 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36522 */     // (add:{ *:[v16i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm), (AArch64uzp1:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm))  =>  (ADDPv16i8:{ *:[v16i8] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm)
     /*  36522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  36525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  36531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  36535 */     GIR_RootConstrainSelectedInstOperands,
     /*  36536 */     // GIR_Coverage, 14093,
     /*  36536 */     GIR_EraseRootFromParent_Done,
     /*  36537 */   // Label 578: @36537
     /*  36537 */   GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(36564), // Rule ID 1101 //
     /*  36542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36557 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  36557 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv16i8),
     /*  36562 */     GIR_RootConstrainSelectedInstOperands,
     /*  36563 */     // GIR_Coverage, 1101,
     /*  36563 */     GIR_Done,
     /*  36564 */   // Label 579: @36564
     /*  36564 */   GIM_Reject,
     /*  36565 */ // Label 568: @36565
     /*  36565 */ GIM_Reject,
     /*  36566 */ // Label 165: @36566
     /*  36566 */ GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(36937),
     /*  36571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36574 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  36581 */   GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(36643), // Rule ID 15280 //
     /*  36586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36601 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36613 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36617 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36628 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36630 */     // (add:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  36637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  36641 */     GIR_RootConstrainSelectedInstOperands,
     /*  36642 */     // GIR_Coverage, 15280,
     /*  36642 */     GIR_EraseRootFromParent_Done,
     /*  36643 */   // Label 581: @36643
     /*  36643 */   GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(36705), // Rule ID 15279 //
     /*  36648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36663 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36667 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  36671 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36675 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36679 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36690 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36692 */     // (add:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  36699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36703 */     GIR_RootConstrainSelectedInstOperands,
     /*  36704 */     // GIR_Coverage, 15279,
     /*  36704 */     GIR_EraseRootFromParent_Done,
     /*  36705 */   // Label 582: @36705
     /*  36705 */   GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(36767), // Rule ID 15278 //
     /*  36710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36725 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36737 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36741 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36752 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36754 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36759 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  36761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  36765 */     GIR_RootConstrainSelectedInstOperands,
     /*  36766 */     // GIR_Coverage, 15278,
     /*  36766 */     GIR_EraseRootFromParent_Done,
     /*  36767 */   // Label 583: @36767
     /*  36767 */   GIM_Try, /*On fail goto*//*Label 584*/ GIMT_Encode4(36829), // Rule ID 9007 //
     /*  36772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36787 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  36795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36799 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36803 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36814 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36816 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] })))  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36821 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  36823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36827 */     GIR_RootConstrainSelectedInstOperands,
     /*  36828 */     // GIR_Coverage, 9007,
     /*  36828 */     GIR_EraseRootFromParent_Done,
     /*  36829 */   // Label 584: @36829
     /*  36829 */   GIM_Try, /*On fail goto*//*Label 585*/ GIMT_Encode4(36875), // Rule ID 15281 //
     /*  36834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  36845 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36849 */     // MIs[1] Operand 2
     /*  36849 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  36860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36862 */     // (add:{ *:[nxv2i64] } (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i32:{ *:[Other] }), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_SXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_SXTW_ZZZ_D_0),
     /*  36865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  36869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36873 */     GIR_RootConstrainSelectedInstOperands,
     /*  36874 */     // GIR_Coverage, 15281,
     /*  36874 */     GIR_EraseRootFromParent_Done,
     /*  36875 */   // Label 585: @36875
     /*  36875 */   GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(36921), // Rule ID 9008 //
     /*  36880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  36891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36895 */     // MIs[1] Operand 2
     /*  36895 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  36906 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36908 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i32:{ *:[Other] }))  =>  (ADR_SXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_SXTW_ZZZ_D_0),
     /*  36911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36913 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  36915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36919 */     GIR_RootConstrainSelectedInstOperands,
     /*  36920 */     // GIR_Coverage, 9008,
     /*  36920 */     GIR_EraseRootFromParent_Done,
     /*  36921 */   // Label 586: @36921
     /*  36921 */   GIM_Try, /*On fail goto*//*Label 587*/ GIMT_Encode4(36936), // Rule ID 2776 //
     /*  36926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36929 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36929 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_D),
     /*  36934 */     GIR_RootConstrainSelectedInstOperands,
     /*  36935 */     // GIR_Coverage, 2776,
     /*  36935 */     GIR_Done,
     /*  36936 */   // Label 587: @36936
     /*  36936 */   GIM_Reject,
     /*  36937 */ // Label 580: @36937
     /*  36937 */ GIM_Reject,
     /*  36938 */ // Label 166: @36938
     /*  36938 */ GIM_Try, /*On fail goto*//*Label 588*/ GIMT_Encode4(36963), // Rule ID 2775 //
     /*  36943 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  36949 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  36952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  36956 */   // (add:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  36956 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_S),
     /*  36961 */   GIR_RootConstrainSelectedInstOperands,
     /*  36962 */   // GIR_Coverage, 2775,
     /*  36962 */   GIR_Done,
     /*  36963 */ // Label 588: @36963
     /*  36963 */ GIM_Reject,
     /*  36964 */ // Label 167: @36964
     /*  36964 */ GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(36989), // Rule ID 2774 //
     /*  36969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  36975 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  36978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  36982 */   // (add:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  36982 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_H),
     /*  36987 */   GIR_RootConstrainSelectedInstOperands,
     /*  36988 */   // GIR_Coverage, 2774,
     /*  36988 */   GIR_Done,
     /*  36989 */ // Label 589: @36989
     /*  36989 */ GIM_Reject,
     /*  36990 */ // Label 168: @36990
     /*  36990 */ GIM_Try, /*On fail goto*//*Label 590*/ GIMT_Encode4(37015), // Rule ID 2773 //
     /*  36995 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  37001 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  37004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  37008 */   // (add:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  37008 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_B),
     /*  37013 */   GIR_RootConstrainSelectedInstOperands,
     /*  37014 */   // GIR_Coverage, 2773,
     /*  37014 */   GIR_Done,
     /*  37015 */ // Label 590: @37015
     /*  37015 */ GIM_Reject,
     /*  37016 */ // Label 169: @37016
     /*  37016 */ GIM_Reject,
     /*  37017 */ // Label 1: @37017
     /*  37017 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 604*/ GIMT_Encode4(51868),
     /*  37028 */ /*GILLT_s32*//*Label 591*/ GIMT_Encode4(37116),
     /*  37032 */ /*GILLT_s64*//*Label 592*/ GIMT_Encode4(38598), GIMT_Encode4(0),
     /*  37040 */ /*GILLT_v2s32*//*Label 593*/ GIMT_Encode4(42504),
     /*  37044 */ /*GILLT_v2s64*//*Label 594*/ GIMT_Encode4(43995),
     /*  37048 */ /*GILLT_v4s16*//*Label 595*/ GIMT_Encode4(46455),
     /*  37052 */ /*GILLT_v4s32*//*Label 596*/ GIMT_Encode4(47946),
     /*  37056 */ /*GILLT_v8s8*//*Label 597*/ GIMT_Encode4(50406),
     /*  37060 */ /*GILLT_v8s16*//*Label 598*/ GIMT_Encode4(50481),
     /*  37064 */ /*GILLT_v16s8*//*Label 599*/ GIMT_Encode4(51689), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  37084 */ /*GILLT_nxv2s64*//*Label 600*/ GIMT_Encode4(51764), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  37096 */ /*GILLT_nxv4s32*//*Label 601*/ GIMT_Encode4(51790), GIMT_Encode4(0),
     /*  37104 */ /*GILLT_nxv8s16*//*Label 602*/ GIMT_Encode4(51816), GIMT_Encode4(0),
     /*  37112 */ /*GILLT_nxv16s8*//*Label 603*/ GIMT_Encode4(51842),
     /*  37116 */ // Label 591: @37116
     /*  37116 */ GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(38597),
     /*  37121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  37124 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  37127 */   GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(37279), // Rule ID 10054 //
     /*  37132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  37135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37163 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  37166 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*  37171 */     // MIs[2] pattern
     /*  37171 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  37174 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  37179 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37181 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  37181 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37184 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37188 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37193 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37195 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37198 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37202 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37207 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37210 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  37214 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37217 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37222 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37227 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37232 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37235 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECB_XPiI),
     /*  37239 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37244 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37247 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  37251 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  37254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37261 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37268 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37273 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37278 */     // GIR_Coverage, 10054,
     /*  37278 */     GIR_EraseRootFromParent_Done,
     /*  37279 */   // Label 606: @37279
     /*  37279 */   GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(37431), // Rule ID 10066 //
     /*  37284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  37287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37315 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  37318 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*  37323 */     // MIs[2] pattern
     /*  37323 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  37326 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  37331 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37333 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1344:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  37333 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37336 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37340 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37347 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37350 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37354 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37359 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37362 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  37366 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37369 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37374 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37379 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37384 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECH_XPiI),
     /*  37391 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37396 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37399 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  37403 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  37406 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37413 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37420 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37425 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37430 */     // GIR_Coverage, 10066,
     /*  37430 */     GIR_EraseRootFromParent_Done,
     /*  37431 */   // Label 607: @37431
     /*  37431 */   GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(37583), // Rule ID 10078 //
     /*  37436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  37439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37455 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37467 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  37470 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*  37475 */     // MIs[2] pattern
     /*  37475 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  37478 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  37483 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37485 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1350:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  37485 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37488 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37492 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37499 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37502 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37506 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37511 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37514 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  37518 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37521 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37526 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37531 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECW_XPiI),
     /*  37543 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37548 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37551 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  37555 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  37558 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37565 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37572 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37577 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37582 */     // GIR_Coverage, 10078,
     /*  37582 */     GIR_EraseRootFromParent_Done,
     /*  37583 */   // Label 608: @37583
     /*  37583 */   GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(37735), // Rule ID 10090 //
     /*  37588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  37591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37595 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37611 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37615 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37619 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  37622 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*  37627 */     // MIs[2] pattern
     /*  37627 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  37630 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  37635 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37637 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1343:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  37637 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37640 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37644 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37649 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37651 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37654 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37658 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37663 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37666 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  37670 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37673 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37678 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37683 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37688 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37691 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECD_XPiI),
     /*  37695 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37700 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37703 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  37707 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  37710 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37717 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37724 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37729 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37734 */     // GIR_Coverage, 10090,
     /*  37734 */     GIR_EraseRootFromParent_Done,
     /*  37735 */   // Label 609: @37735
     /*  37735 */   GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(37797), // Rule ID 3978 //
     /*  37740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37744 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  37748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  37756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  37760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  37764 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37776 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm))  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  37776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  37779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  37785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  37789 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37795 */     GIR_RootConstrainSelectedInstOperands,
     /*  37796 */     // GIR_Coverage, 3978,
     /*  37796 */     GIR_EraseRootFromParent_Done,
     /*  37797 */   // Label 610: @37797
     /*  37797 */   GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(37954), // Rule ID 10192 //
     /*  37802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37833 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37836 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37841 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  37845 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37847 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37852 */     // MIs[2] pred
     /*  37852 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37857 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37859 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37859 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37862 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37866 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37871 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37873 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37876 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37880 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37885 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37888 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37892 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37895 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37900 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37905 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37910 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37913 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_B),
     /*  37917 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37922 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37926 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37929 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37936 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37943 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37948 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37953 */     // GIR_Coverage, 10192,
     /*  37953 */     GIR_EraseRootFromParent_Done,
     /*  37954 */   // Label 611: @37954
     /*  37954 */   GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(38111), // Rule ID 10193 //
     /*  37959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37966 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37986 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37990 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37993 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37998 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  38002 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  38004 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  38009 */     // MIs[2] pred
     /*  38009 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  38014 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  38016 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  38016 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  38019 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  38023 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38028 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  38030 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  38033 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  38037 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38042 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  38045 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  38049 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  38052 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  38057 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  38062 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  38070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_H),
     /*  38074 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38079 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  38083 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38086 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38093 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  38100 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38105 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38110 */     // GIR_Coverage, 10193,
     /*  38110 */     GIR_EraseRootFromParent_Done,
     /*  38111 */   // Label 612: @38111
     /*  38111 */   GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(38268), // Rule ID 10194 //
     /*  38116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  38119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  38135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  38139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  38147 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  38150 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  38155 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  38159 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  38161 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  38166 */     // MIs[2] pred
     /*  38166 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  38171 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  38173 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  38173 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  38176 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  38180 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  38187 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  38190 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  38194 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38199 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  38202 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  38206 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  38209 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  38214 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  38219 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  38227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_S),
     /*  38231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38236 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  38240 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38243 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38250 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  38257 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38262 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38267 */     // GIR_Coverage, 10194,
     /*  38267 */     GIR_EraseRootFromParent_Done,
     /*  38268 */   // Label 613: @38268
     /*  38268 */   GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(38425), // Rule ID 10195 //
     /*  38273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  38276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  38292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  38296 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38300 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  38304 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  38307 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  38312 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  38316 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  38318 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  38323 */     // MIs[2] pred
     /*  38323 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  38328 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  38330 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  38330 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  38333 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  38337 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  38344 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  38347 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  38351 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38356 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  38359 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  38363 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  38366 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  38371 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  38376 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  38384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_D),
     /*  38388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38393 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  38397 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38407 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  38414 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38419 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38424 */     // GIR_Coverage, 10195,
     /*  38424 */     GIR_EraseRootFromParent_Done,
     /*  38425 */   // Label 614: @38425
     /*  38425 */   GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(38461), // Rule ID 3943 //
     /*  38430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  38438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*  38445 */     // (sub:{ *:[i32] } GPR32sp:{ *:[i32] }:$R2, arith_extended_reg32_i32:{ *:[i32] }:$R3)  =>  (SUBSWrx:{ *:[i32] }:{ *:[i32] } GPR32sp:{ *:[i32] }:$R2, arith_extended_reg32_i32:{ *:[i32] }:$R3)
     /*  38445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrx),
     /*  38448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38450 */     GIR_RootToRootCopy, /*OpIdx*/1, // R2
     /*  38452 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // R3
     /*  38456 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  38459 */     GIR_RootConstrainSelectedInstOperands,
     /*  38460 */     // GIR_Coverage, 3943,
     /*  38460 */     GIR_EraseRootFromParent_Done,
     /*  38461 */   // Label 615: @38461
     /*  38461 */   GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(38494), // Rule ID 3948 //
     /*  38466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  38470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*  38481 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (ADDWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*  38481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*  38484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38486 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  38488 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  38492 */     GIR_RootConstrainSelectedInstOperands,
     /*  38493 */     // GIR_Coverage, 3948,
     /*  38493 */     GIR_EraseRootFromParent_Done,
     /*  38494 */   // Label 616: @38494
     /*  38494 */   GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(38530), // Rule ID 3937 //
     /*  38499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  38507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*  38514 */     // (sub:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*  38514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*  38517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38519 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  38521 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  38525 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  38528 */     GIR_RootConstrainSelectedInstOperands,
     /*  38529 */     // GIR_Coverage, 3937,
     /*  38529 */     GIR_EraseRootFromParent_Done,
     /*  38530 */   // Label 617: @38530
     /*  38530 */   GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(38566), // Rule ID 3941 //
     /*  38535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*  38550 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm)  =>  (SUBSWrs:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm)
     /*  38550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrs),
     /*  38553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38555 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  38557 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm
     /*  38561 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  38564 */     GIR_RootConstrainSelectedInstOperands,
     /*  38565 */     // GIR_Coverage, 3941,
     /*  38565 */     GIR_EraseRootFromParent_Done,
     /*  38566 */   // Label 618: @38566
     /*  38566 */   GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(38596), // Rule ID 3939 //
     /*  38571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38583 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SUBSWrr:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  38583 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrr),
     /*  38588 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AArch64::NZCV), GIMT_Encode2(RegState::Dead),
     /*  38594 */     GIR_RootConstrainSelectedInstOperands,
     /*  38595 */     // GIR_Coverage, 3939,
     /*  38595 */     GIR_Done,
     /*  38596 */   // Label 619: @38596
     /*  38596 */   GIM_Reject,
     /*  38597 */ // Label 605: @38597
     /*  38597 */ GIM_Reject,
     /*  38598 */ // Label 592: @38598
     /*  38598 */ GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(42503),
     /*  38603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  38606 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  38609 */   GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(38745), // Rule ID 5441 //
     /*  38614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38630 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38634 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38638 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38642 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38647 */     // MIs[1] Operand 2
     /*  38647 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38658 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38662 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38666 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38670 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38674 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38678 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38682 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38687 */     // MIs[3] Operand 2
     /*  38687 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38698 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38700 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38712 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38716 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38727 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38734 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38739 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38744 */     // GIR_Coverage, 5441,
     /*  38744 */     GIR_EraseRootFromParent_Done,
     /*  38745 */   // Label 621: @38745
     /*  38745 */   GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(38881), // Rule ID 5440 //
     /*  38750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38770 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38774 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38778 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38783 */     // MIs[1] Operand 2
     /*  38783 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38794 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38798 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38802 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38806 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38810 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38814 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38818 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38823 */     // MIs[3] Operand 2
     /*  38823 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38834 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38836 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38848 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38852 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38856 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38863 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38870 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38875 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38880 */     // GIR_Coverage, 5440,
     /*  38880 */     GIR_EraseRootFromParent_Done,
     /*  38881 */   // Label 622: @38881
     /*  38881 */   GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(39017), // Rule ID 5450 //
     /*  38886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38910 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38914 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38919 */     // MIs[1] Operand 2
     /*  38919 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38930 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38934 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38938 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38942 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38946 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38950 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38954 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38959 */     // MIs[3] Operand 2
     /*  38959 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38970 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38972 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SSUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv2i32_v2i64),
     /*  38979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38984 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38988 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38992 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38999 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  39006 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39011 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39016 */     // GIR_Coverage, 5450,
     /*  39016 */     GIR_EraseRootFromParent_Done,
     /*  39017 */   // Label 623: @39017
     /*  39017 */   GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(39153), // Rule ID 5439 //
     /*  39022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  39038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39042 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39046 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  39050 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39055 */     // MIs[1] Operand 2
     /*  39055 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  39066 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  39070 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39074 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  39078 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  39082 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  39086 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  39090 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39095 */     // MIs[3] Operand 2
     /*  39095 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  39106 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  39108 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  39108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  39111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  39115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39120 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39124 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  39128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39135 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  39142 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39147 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39152 */     // GIR_Coverage, 5439,
     /*  39152 */     GIR_EraseRootFromParent_Done,
     /*  39153 */   // Label 624: @39153
     /*  39153 */   GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(39289), // Rule ID 5438 //
     /*  39158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39170 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  39174 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39178 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39182 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  39186 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39191 */     // MIs[1] Operand 2
     /*  39191 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  39202 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  39206 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39210 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  39214 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  39218 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39222 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  39226 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39231 */     // MIs[3] Operand 2
     /*  39231 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  39242 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  39244 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  39244 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  39247 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  39251 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39256 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39260 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  39264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39271 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  39278 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39283 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39288 */     // GIR_Coverage, 5438,
     /*  39288 */     GIR_EraseRootFromParent_Done,
     /*  39289 */   // Label 625: @39289
     /*  39289 */   GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(39426), // Rule ID 3995 //
     /*  39294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39298 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39314 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  39326 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  39330 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39335 */     // MIs[2] Operand 2
     /*  39335 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  39346 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39350 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39354 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  39358 */     // MIs[3] Operand 1
     /*  39358 */     // No operand predicates
     /*  39358 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39360 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  39360 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  39363 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39367 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39372 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39377 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  39379 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39382 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39386 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39391 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  39397 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39402 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39412 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39415 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  39418 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39424 */     GIR_RootConstrainSelectedInstOperands,
     /*  39425 */     // GIR_Coverage, 3995,
     /*  39425 */     GIR_EraseRootFromParent_Done,
     /*  39426 */   // Label 626: @39426
     /*  39426 */   GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(39525), // Rule ID 3993 //
     /*  39431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39435 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39451 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39463 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39467 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39472 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39476 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39480 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  39484 */     // MIs[3] Operand 1
     /*  39484 */     // No operand predicates
     /*  39484 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39486 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  39486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39498 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39503 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39517 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39523 */     GIR_RootConstrainSelectedInstOperands,
     /*  39524 */     // GIR_Coverage, 3993,
     /*  39524 */     GIR_EraseRootFromParent_Done,
     /*  39525 */   // Label 627: @39525
     /*  39525 */   GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(39624), // Rule ID 3994 //
     /*  39530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39534 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39550 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39558 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39562 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39566 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39571 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39575 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39579 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  39583 */     // MIs[3] Operand 1
     /*  39583 */     // No operand predicates
     /*  39583 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39585 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  39585 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39588 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39592 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39597 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39602 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39616 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39622 */     GIR_RootConstrainSelectedInstOperands,
     /*  39623 */     // GIR_Coverage, 3994,
     /*  39623 */     GIR_EraseRootFromParent_Done,
     /*  39624 */   // Label 628: @39624
     /*  39624 */   GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(39710), // Rule ID 3988 //
     /*  39629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39633 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39649 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39661 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39665 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39670 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39674 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39678 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39682 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39687 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39689 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  39689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39702 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39708 */     GIR_RootConstrainSelectedInstOperands,
     /*  39709 */     // GIR_Coverage, 3988,
     /*  39709 */     GIR_EraseRootFromParent_Done,
     /*  39710 */   // Label 629: @39710
     /*  39710 */   GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(39796), // Rule ID 3989 //
     /*  39715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39719 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39747 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39751 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39756 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39760 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39764 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39768 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39773 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39775 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  39775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39788 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39794 */     GIR_RootConstrainSelectedInstOperands,
     /*  39795 */     // GIR_Coverage, 3989,
     /*  39795 */     GIR_EraseRootFromParent_Done,
     /*  39796 */   // Label 630: @39796
     /*  39796 */   GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(39897), // Rule ID 4015 //
     /*  39801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39805 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39821 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39825 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  39830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  39834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39842 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39847 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  39849 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  39849 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39852 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39856 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39861 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  39867 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39872 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  39889 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39895 */     GIR_RootConstrainSelectedInstOperands,
     /*  39896 */     // GIR_Coverage, 4015,
     /*  39896 */     GIR_EraseRootFromParent_Done,
     /*  39897 */   // Label 631: @39897
     /*  39897 */   GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(39998), // Rule ID 13948 //
     /*  39902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39906 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39922 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39926 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39930 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39934 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39938 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39943 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  39948 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  39950 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm), GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn))  =>  (UMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  39950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39962 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  39968 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39973 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  39990 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39996 */     GIR_RootConstrainSelectedInstOperands,
     /*  39997 */     // GIR_Coverage, 13948,
     /*  39997 */     GIR_EraseRootFromParent_Done,
     /*  39998 */   // Label 632: @39998
     /*  39998 */   GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(40114), // Rule ID 4014 //
     /*  40003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40007 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  40011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  40019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  40023 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  40027 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  40032 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  40037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40039 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn, GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rm))  =>  (UMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }), XZR:{ *:[i64] })
     /*  40039 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  40042 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40046 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40051 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /*  40057 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  40062 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  40070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40074 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40079 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  40085 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  40090 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  40098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40100 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  40103 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  40106 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  40112 */     GIR_RootConstrainSelectedInstOperands,
     /*  40113 */     // GIR_Coverage, 4014,
     /*  40113 */     GIR_EraseRootFromParent_Done,
     /*  40114 */   // Label 633: @40114
     /*  40114 */   GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(40247), // Rule ID 4001 //
     /*  40119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  40135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  40139 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  40143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  40151 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  40155 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40160 */     // MIs[2] Operand 2
     /*  40160 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  40171 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  40175 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  40179 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  40183 */     // MIs[3] Operand 1
     /*  40183 */     // No operand predicates
     /*  40183 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  40185 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  40185 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  40188 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  40192 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40197 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  40202 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  40204 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  40207 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40211 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40216 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  40222 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  40227 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  40235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40237 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  40240 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  40243 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  40245 */     GIR_RootConstrainSelectedInstOperands,
     /*  40246 */     // GIR_Coverage, 4001,
     /*  40246 */     GIR_EraseRootFromParent_Done,
     /*  40247 */   // Label 634: @40247
     /*  40247 */   GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(40342), // Rule ID 3999 //
     /*  40252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  40268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  40272 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  40276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  40284 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  40288 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  40293 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  40297 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  40301 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  40305 */     // MIs[3] Operand 1
     /*  40305 */     // No operand predicates
     /*  40305 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  40307 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  40307 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  40310 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  40314 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40319 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  40324 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  40329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  40335 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  40338 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  40340 */     GIR_RootConstrainSelectedInstOperands,
     /*  40341 */     // GIR_Coverage, 3999,
     /*  40341 */     GIR_EraseRootFromParent_Done,
     /*  40342 */   // Label 635: @40342
     /*  40342 */   GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(40437), // Rule ID 4000 //
     /*  40347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  40363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  40367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  40371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  40379 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  40383 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  40388 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  40392 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  40396 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  40400 */     // MIs[3] Operand 1
     /*  40400 */     // No operand predicates
     /*  40400 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  40402 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  40402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  40405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  40409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40414 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  40419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  40424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  40430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  40433 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  40435 */     GIR_RootConstrainSelectedInstOperands,
     /*  40436 */     // GIR_Coverage, 4000,
     /*  40436 */     GIR_EraseRootFromParent_Done,
     /*  40437 */   // Label 636: @40437
     /*  40437 */   GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(40519), // Rule ID 124 //
     /*  40442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40446 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  40458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  40462 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  40466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40470 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  40474 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  40478 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  40483 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  40487 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  40491 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  40495 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  40500 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  40502 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*  40502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  40505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  40511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  40515 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  40517 */     GIR_RootConstrainSelectedInstOperands,
     /*  40518 */     // GIR_Coverage, 124,
     /*  40518 */     GIR_EraseRootFromParent_Done,
     /*  40519 */   // Label 637: @40519
     /*  40519 */   GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(40601), // Rule ID 126 //
     /*  40524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  40540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  40544 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  40548 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40552 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  40556 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  40560 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  40565 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  40569 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  40573 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  40577 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  40582 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  40584 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*  40584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  40587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  40593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  40597 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  40599 */     GIR_RootConstrainSelectedInstOperands,
     /*  40600 */     // GIR_Coverage, 126,
     /*  40600 */     GIR_EraseRootFromParent_Done,
     /*  40601 */   // Label 638: @40601
     /*  40601 */   GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(40663), // Rule ID 3979 //
     /*  40606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40610 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  40614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  40622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  40626 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  40630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40635 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40640 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40642 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm))  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  40642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  40645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  40651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  40655 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  40661 */     GIR_RootConstrainSelectedInstOperands,
     /*  40662 */     // GIR_Coverage, 3979,
     /*  40662 */     GIR_EraseRootFromParent_Done,
     /*  40663 */   // Label 639: @40663
     /*  40663 */   GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(40721), // Rule ID 10051 //
     /*  40668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  40671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  40687 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  40690 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*  40695 */     // MIs[1] pattern
     /*  40695 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  40698 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  40703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40705 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  40705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECB_XPiI),
     /*  40708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  40710 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  40712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  40716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  40719 */     GIR_RootConstrainSelectedInstOperands,
     /*  40720 */     // GIR_Coverage, 10051,
     /*  40720 */     GIR_EraseRootFromParent_Done,
     /*  40721 */   // Label 640: @40721
     /*  40721 */   GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(40779), // Rule ID 10063 //
     /*  40726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  40729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  40745 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  40748 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*  40753 */     // MIs[1] pattern
     /*  40753 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  40756 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  40761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40763 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1344:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  40763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECH_XPiI),
     /*  40766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  40768 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  40770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  40774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  40777 */     GIR_RootConstrainSelectedInstOperands,
     /*  40778 */     // GIR_Coverage, 10063,
     /*  40778 */     GIR_EraseRootFromParent_Done,
     /*  40779 */   // Label 641: @40779
     /*  40779 */   GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(40837), // Rule ID 10075 //
     /*  40784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  40787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  40803 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  40806 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*  40811 */     // MIs[1] pattern
     /*  40811 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  40814 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  40819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40821 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1350:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  40821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECW_XPiI),
     /*  40824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  40826 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  40828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  40832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  40835 */     GIR_RootConstrainSelectedInstOperands,
     /*  40836 */     // GIR_Coverage, 10075,
     /*  40836 */     GIR_EraseRootFromParent_Done,
     /*  40837 */   // Label 642: @40837
     /*  40837 */   GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(40895), // Rule ID 10087 //
     /*  40842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  40845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  40861 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  40864 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*  40869 */     // MIs[1] pattern
     /*  40869 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  40872 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  40877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40879 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1343:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  40879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECD_XPiI),
     /*  40882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  40884 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  40886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  40890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  40893 */     GIR_RootConstrainSelectedInstOperands,
     /*  40894 */     // GIR_Coverage, 10087,
     /*  40894 */     GIR_EraseRootFromParent_Done,
     /*  40895 */   // Label 643: @40895
     /*  40895 */   GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(40992), // Rule ID 4017 //
     /*  40900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40904 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  40916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  40920 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  40924 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  40929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  40933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  40937 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  40941 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  40946 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40948 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*  40948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  40951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40960 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  40966 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  40971 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  40979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40981 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  40984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  40988 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  40990 */     GIR_RootConstrainSelectedInstOperands,
     /*  40991 */     // GIR_Coverage, 4017,
     /*  40991 */     GIR_EraseRootFromParent_Done,
     /*  40992 */   // Label 644: @40992
     /*  40992 */   GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(41089), // Rule ID 13949 //
     /*  40997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41001 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  41013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  41017 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  41021 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41025 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41029 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  41033 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  41038 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  41043 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  41045 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm), GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn))  =>  (UMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*  41045 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  41048 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41052 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41057 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  41063 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  41068 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  41076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41078 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  41085 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  41087 */     GIR_RootConstrainSelectedInstOperands,
     /*  41088 */     // GIR_Coverage, 13949,
     /*  41088 */     GIR_EraseRootFromParent_Done,
     /*  41089 */   // Label 645: @41089
     /*  41089 */   GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(41252), // Rule ID 5405 //
     /*  41094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41098 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  41114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  41122 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41126 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41130 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41135 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41140 */     // MIs[1] Operand 2
     /*  41140 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41151 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  41153 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLSLv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  41153 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  41156 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41160 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41165 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  41167 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  41170 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  41174 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41179 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  41182 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  41186 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  41189 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41194 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41199 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41204 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  41207 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_v2i64),
     /*  41211 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41216 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  41219 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41223 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  41227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41234 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41241 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41246 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41251 */     // GIR_Coverage, 5405,
     /*  41251 */     GIR_EraseRootFromParent_Done,
     /*  41252 */   // Label 646: @41252
     /*  41252 */   GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(41415), // Rule ID 5402 //
     /*  41257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  41277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  41285 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41289 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41293 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41298 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41303 */     // MIs[1] Operand 2
     /*  41303 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41314 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  41316 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLSLv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  41316 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  41319 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41323 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41328 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  41330 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  41333 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  41337 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41342 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  41345 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  41349 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  41352 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41357 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41362 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  41370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_v2i64),
     /*  41374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41379 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  41382 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41386 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  41390 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41397 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41404 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41409 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41414 */     // GIR_Coverage, 5402,
     /*  41414 */     GIR_EraseRootFromParent_Done,
     /*  41415 */   // Label 647: @41415
     /*  41415 */   GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(41565), // Rule ID 5447 //
     /*  41420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  41440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41448 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41452 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41457 */     // MIs[1] Operand 2
     /*  41457 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41468 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  41470 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  41470 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  41473 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41477 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41482 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  41484 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  41487 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  41491 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41496 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  41499 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  41503 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  41506 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41511 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41516 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  41524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  41528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41533 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  41536 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  41540 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41547 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41554 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41559 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41564 */     // GIR_Coverage, 5447,
     /*  41564 */     GIR_EraseRootFromParent_Done,
     /*  41565 */   // Label 648: @41565
     /*  41565 */   GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(41715), // Rule ID 5453 //
     /*  41570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  41590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  41598 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41602 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41607 */     // MIs[1] Operand 2
     /*  41607 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41618 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  41620 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SSUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  41620 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  41623 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41627 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  41634 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  41637 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  41641 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41646 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  41649 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  41653 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  41656 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41661 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41666 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41671 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  41674 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv2i32_v2i64),
     /*  41678 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41683 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  41686 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  41690 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41697 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41704 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41709 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41714 */     // GIR_Coverage, 5453,
     /*  41714 */     GIR_EraseRootFromParent_Done,
     /*  41715 */   // Label 649: @41715
     /*  41715 */   GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(41865), // Rule ID 5446 //
     /*  41720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  41740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41752 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41757 */     // MIs[1] Operand 2
     /*  41757 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41768 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  41770 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  41770 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  41773 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41777 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  41784 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  41787 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  41791 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41796 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  41799 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  41803 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  41806 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41811 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41816 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41821 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  41824 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  41828 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41833 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  41836 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  41840 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41847 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41854 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41859 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41864 */     // GIR_Coverage, 5446,
     /*  41864 */     GIR_EraseRootFromParent_Done,
     /*  41865 */   // Label 650: @41865
     /*  41865 */   GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(41901), // Rule ID 3944 //
     /*  41870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  41878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  41885 */     // (sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$R2, arith_extended_reg32to64_i64:{ *:[i64] }:$R3)  =>  (SUBSXrx:{ *:[i64] }:{ *:[i32] } GPR64sp:{ *:[i64] }:$R2, arith_extended_reg32to64_i64:{ *:[i64] }:$R3)
     /*  41885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrx),
     /*  41888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41890 */     GIR_RootToRootCopy, /*OpIdx*/1, // R2
     /*  41892 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // R3
     /*  41896 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  41899 */     GIR_RootConstrainSelectedInstOperands,
     /*  41900 */     // GIR_Coverage, 3944,
     /*  41900 */     GIR_EraseRootFromParent_Done,
     /*  41901 */   // Label 651: @41901
     /*  41901 */   GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(41934), // Rule ID 3949 //
     /*  41906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  41910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  41921 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (ADDXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  41921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*  41924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41926 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41928 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  41932 */     GIR_RootConstrainSelectedInstOperands,
     /*  41933 */     // GIR_Coverage, 3949,
     /*  41933 */     GIR_EraseRootFromParent_Done,
     /*  41934 */   // Label 652: @41934
     /*  41934 */   GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(42046), // Rule ID 4016 //
     /*  41939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  41955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  41959 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  41963 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  41968 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  41973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41975 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn, GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rm))  =>  (UMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }), GPR64:{ *:[i64] }:$Ra)
     /*  41975 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  41978 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41982 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41987 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /*  41993 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  41998 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42003 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  42006 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42010 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42015 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  42021 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  42026 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  42034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42036 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42039 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  42042 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  42044 */     GIR_RootConstrainSelectedInstOperands,
     /*  42045 */     // GIR_Coverage, 4016,
     /*  42045 */     GIR_EraseRootFromParent_Done,
     /*  42046 */   // Label 653: @42046
     /*  42046 */   GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(42082), // Rule ID 3938 //
     /*  42051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  42059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*  42066 */     // (sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  42066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  42069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42071 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  42073 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  42077 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  42080 */     GIR_RootConstrainSelectedInstOperands,
     /*  42081 */     // GIR_Coverage, 3938,
     /*  42081 */     GIR_EraseRootFromParent_Done,
     /*  42082 */   // Label 654: @42082
     /*  42082 */   GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(42118), // Rule ID 3942 //
     /*  42087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  42102 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm)  =>  (SUBSXrs:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm)
     /*  42102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrs),
     /*  42105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42107 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  42109 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm
     /*  42113 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  42116 */     GIR_RootConstrainSelectedInstOperands,
     /*  42117 */     // GIR_Coverage, 3942,
     /*  42117 */     GIR_EraseRootFromParent_Done,
     /*  42118 */   // Label 655: @42118
     /*  42118 */   GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(42181), // Rule ID 10184 //
     /*  42123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  42126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42130 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42142 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42145 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  42150 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  42154 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  42156 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  42161 */     // MIs[1] pred
     /*  42161 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42168 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  42168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_B),
     /*  42171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  42173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  42177 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  42179 */     GIR_RootConstrainSelectedInstOperands,
     /*  42180 */     // GIR_Coverage, 10184,
     /*  42180 */     GIR_EraseRootFromParent_Done,
     /*  42181 */   // Label 656: @42181
     /*  42181 */   GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(42244), // Rule ID 10185 //
     /*  42186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  42189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42205 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42208 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  42213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  42217 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  42219 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  42224 */     // MIs[1] pred
     /*  42224 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42231 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  42231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_H),
     /*  42234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  42236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  42240 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  42242 */     GIR_RootConstrainSelectedInstOperands,
     /*  42243 */     // GIR_Coverage, 10185,
     /*  42243 */     GIR_EraseRootFromParent_Done,
     /*  42244 */   // Label 657: @42244
     /*  42244 */   GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(42307), // Rule ID 10186 //
     /*  42249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  42252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42268 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42271 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  42276 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  42280 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  42282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  42287 */     // MIs[1] pred
     /*  42287 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42294 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  42294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_S),
     /*  42297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  42299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  42303 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  42305 */     GIR_RootConstrainSelectedInstOperands,
     /*  42306 */     // GIR_Coverage, 10186,
     /*  42306 */     GIR_EraseRootFromParent_Done,
     /*  42307 */   // Label 658: @42307
     /*  42307 */   GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(42370), // Rule ID 10187 //
     /*  42312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  42315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42331 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42334 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  42339 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  42343 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  42345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  42350 */     // MIs[1] pred
     /*  42350 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42357 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  42357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_D),
     /*  42360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  42362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  42366 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  42368 */     GIR_RootConstrainSelectedInstOperands,
     /*  42369 */     // GIR_Coverage, 10187,
     /*  42369 */     GIR_EraseRootFromParent_Done,
     /*  42370 */   // Label 659: @42370
     /*  42370 */   GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(42409), // Rule ID 1655 //
     /*  42375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42386 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42392 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  42394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42400 */     // (sub:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (NEGv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /*  42400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv1i64),
     /*  42403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  42407 */     GIR_RootConstrainSelectedInstOperands,
     /*  42408 */     // GIR_Coverage, 1655,
     /*  42408 */     GIR_EraseRootFromParent_Done,
     /*  42409 */   // Label 660: @42409
     /*  42409 */   GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(42445), // Rule ID 5288 //
     /*  42414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42422 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42428 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  42430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42434 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42436 */     // (sub:{ *:[i64] } immAllZerosV:{ *:[i64] }, FPR64:{ *:[i64] }:$Rn)  =>  (NEGv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /*  42436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv1i64),
     /*  42439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  42443 */     GIR_RootConstrainSelectedInstOperands,
     /*  42444 */     // GIR_Coverage, 5288,
     /*  42444 */     GIR_EraseRootFromParent_Done,
     /*  42445 */   // Label 661: @42445
     /*  42445 */   GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(42472), // Rule ID 1644 //
     /*  42450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42465 */     // (sub:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  42465 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv1i64),
     /*  42470 */     GIR_RootConstrainSelectedInstOperands,
     /*  42471 */     // GIR_Coverage, 1644,
     /*  42471 */     GIR_Done,
     /*  42472 */   // Label 662: @42472
     /*  42472 */   GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(42502), // Rule ID 3940 //
     /*  42477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42489 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SUBSXrr:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  42489 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrr),
     /*  42494 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AArch64::NZCV), GIMT_Encode2(RegState::Dead),
     /*  42500 */     GIR_RootConstrainSelectedInstOperands,
     /*  42501 */     // GIR_Coverage, 3940,
     /*  42501 */     GIR_Done,
     /*  42502 */   // Label 663: @42502
     /*  42502 */   GIM_Reject,
     /*  42503 */ // Label 620: @42503
     /*  42503 */ GIM_Reject,
     /*  42504 */ // Label 593: @42504
     /*  42504 */ GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(43994),
     /*  42509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42512 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  42515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42519 */   GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(42651), // Rule ID 5437 //
     /*  42524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42544 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42548 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42553 */     // MIs[1] Operand 2
     /*  42553 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42564 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  42568 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42572 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42576 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  42580 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42584 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42588 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42593 */     // MIs[3] Operand 2
     /*  42593 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  42604 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  42606 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  42613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42618 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  42622 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  42626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42633 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42640 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42645 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42650 */     // GIR_Coverage, 5437,
     /*  42650 */     GIR_EraseRootFromParent_Done,
     /*  42651 */   // Label 665: @42651
     /*  42651 */   GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(42783), // Rule ID 5436 //
     /*  42656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42676 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42680 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42685 */     // MIs[1] Operand 2
     /*  42685 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42696 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  42700 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42704 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42708 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  42712 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  42716 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42720 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42725 */     // MIs[3] Operand 2
     /*  42725 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  42736 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  42738 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  42745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42750 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  42754 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  42758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42765 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42772 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42777 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42782 */     // GIR_Coverage, 5436,
     /*  42782 */     GIR_EraseRootFromParent_Done,
     /*  42783 */   // Label 666: @42783
     /*  42783 */   GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(42915), // Rule ID 5449 //
     /*  42788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  42808 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42812 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42817 */     // MIs[1] Operand 2
     /*  42817 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42828 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  42832 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42836 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42840 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  42844 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  42848 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42852 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42857 */     // MIs[3] Operand 2
     /*  42857 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  42868 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  42870 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SSUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i16_v4i32),
     /*  42877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42882 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  42886 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  42890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42897 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42904 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42909 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42914 */     // GIR_Coverage, 5449,
     /*  42914 */     GIR_EraseRootFromParent_Done,
     /*  42915 */   // Label 667: @42915
     /*  42915 */   GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(43047), // Rule ID 5435 //
     /*  42920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  42940 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42944 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42949 */     // MIs[1] Operand 2
     /*  42949 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42960 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  42964 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42968 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42972 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  42976 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42980 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42984 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42989 */     // MIs[3] Operand 2
     /*  42989 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  43000 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43002 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  43002 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43005 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  43009 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43014 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  43018 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  43022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43029 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43036 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43041 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43046 */     // GIR_Coverage, 5435,
     /*  43046 */     GIR_EraseRootFromParent_Done,
     /*  43047 */   // Label 668: @43047
     /*  43047 */   GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(43179), // Rule ID 5434 //
     /*  43052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43072 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  43076 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43081 */     // MIs[1] Operand 2
     /*  43081 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43092 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  43096 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43100 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43104 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  43108 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43112 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  43116 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43121 */     // MIs[3] Operand 2
     /*  43121 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  43132 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43134 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  43134 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43137 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  43141 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43146 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  43150 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  43154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43161 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43168 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43173 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43178 */     // GIR_Coverage, 5434,
     /*  43178 */     GIR_EraseRootFromParent_Done,
     /*  43179 */   // Label 669: @43179
     /*  43179 */   GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(43338), // Rule ID 5404 //
     /*  43184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43196 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43200 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43204 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  43208 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  43212 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  43216 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43221 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43226 */     // MIs[1] Operand 2
     /*  43226 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43237 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43239 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLSLv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  43239 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  43242 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43246 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43251 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  43253 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  43256 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43260 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43265 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  43268 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  43272 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  43275 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43280 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43285 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43290 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43293 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_v4i32),
     /*  43297 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43302 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43305 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  43309 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  43313 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43320 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43327 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43332 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43337 */     // GIR_Coverage, 5404,
     /*  43337 */     GIR_EraseRootFromParent_Done,
     /*  43338 */   // Label 670: @43338
     /*  43338 */   GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(43497), // Rule ID 5401 //
     /*  43343 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43355 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  43367 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  43371 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  43375 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43380 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43385 */     // MIs[1] Operand 2
     /*  43385 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43396 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43398 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLSLv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  43398 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  43401 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43405 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  43412 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  43415 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43419 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43424 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  43427 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  43431 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  43434 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43439 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43444 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_v4i32),
     /*  43456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43461 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43464 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  43468 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  43472 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43479 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43486 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43491 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43496 */     // GIR_Coverage, 5401,
     /*  43496 */     GIR_EraseRootFromParent_Done,
     /*  43497 */   // Label 671: @43497
     /*  43497 */   GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(43643), // Rule ID 5445 //
     /*  43502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43518 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43522 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43526 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  43530 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43535 */     // MIs[1] Operand 2
     /*  43535 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43546 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43548 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  43548 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  43551 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43555 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43560 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  43562 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  43565 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43569 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43574 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  43577 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  43581 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  43584 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43589 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43594 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43599 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43602 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  43606 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43611 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43614 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  43618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43625 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43632 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43637 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43642 */     // GIR_Coverage, 5445,
     /*  43642 */     GIR_EraseRootFromParent_Done,
     /*  43643 */   // Label 672: @43643
     /*  43643 */   GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(43789), // Rule ID 5452 //
     /*  43648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  43672 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  43676 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43681 */     // MIs[1] Operand 2
     /*  43681 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43692 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43694 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SSUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  43694 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  43697 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43701 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  43708 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  43711 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43715 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43720 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  43723 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  43727 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  43730 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43735 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43740 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43745 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i16_v4i32),
     /*  43752 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43757 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43760 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  43764 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43771 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43778 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43783 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43788 */     // GIR_Coverage, 5452,
     /*  43788 */     GIR_EraseRootFromParent_Done,
     /*  43789 */   // Label 673: @43789
     /*  43789 */   GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(43935), // Rule ID 5444 //
     /*  43794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43818 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  43822 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43827 */     // MIs[1] Operand 2
     /*  43827 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43838 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43840 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  43840 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  43843 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43847 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43852 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  43854 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  43857 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43861 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43866 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  43869 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  43873 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  43876 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43881 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43886 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43891 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43894 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  43898 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43903 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43906 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  43910 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43917 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43924 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43929 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43934 */     // GIR_Coverage, 5444,
     /*  43934 */     GIR_EraseRootFromParent_Done,
     /*  43935 */   // Label 674: @43935
     /*  43935 */   GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(43970), // Rule ID 969 //
     /*  43940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43947 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43953 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  43955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43961 */     // (sub:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn)  =>  (NEGv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /*  43961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv2i32),
     /*  43964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  43968 */     GIR_RootConstrainSelectedInstOperands,
     /*  43969 */     // GIR_Coverage, 969,
     /*  43969 */     GIR_EraseRootFromParent_Done,
     /*  43970 */   // Label 675: @43970
     /*  43970 */   GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(43993), // Rule ID 1476 //
     /*  43975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43986 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  43986 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv2i32),
     /*  43991 */     GIR_RootConstrainSelectedInstOperands,
     /*  43992 */     // GIR_Coverage, 1476,
     /*  43992 */     GIR_Done,
     /*  43993 */   // Label 676: @43993
     /*  43993 */   GIM_Reject,
     /*  43994 */ // Label 664: @43994
     /*  43994 */ GIM_Reject,
     /*  43995 */ // Label 594: @43995
     /*  43995 */ GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(46454),
     /*  44000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  44003 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  44006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44010 */   GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(44124), // Rule ID 2048 //
     /*  44015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44034 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44042 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  44046 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44050 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44054 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44058 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44062 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  44066 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44071 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  44075 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44079 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44083 */     // MIs[4] Operand 1
     /*  44083 */     // No operand predicates
     /*  44083 */     // MIs[2] Operand 2
     /*  44083 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  44094 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  44096 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44103 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_indexed),
     /*  44106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44108 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  44119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  44122 */     GIR_RootConstrainSelectedInstOperands,
     /*  44123 */     // GIR_Coverage, 2048,
     /*  44123 */     GIR_EraseRootFromParent_Done,
     /*  44124 */   // Label 678: @44124
     /*  44124 */   GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(44238), // Rule ID 13640 //
     /*  44129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  44160 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44164 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44168 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44172 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44176 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  44180 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44185 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  44189 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44193 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44197 */     // MIs[4] Operand 1
     /*  44197 */     // No operand predicates
     /*  44197 */     // MIs[2] Operand 2
     /*  44197 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  44208 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  44210 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44217 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (SMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_indexed),
     /*  44220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44222 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  44233 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  44236 */     GIR_RootConstrainSelectedInstOperands,
     /*  44237 */     // GIR_Coverage, 13640,
     /*  44237 */     GIR_EraseRootFromParent_Done,
     /*  44238 */   // Label 679: @44238
     /*  44238 */   GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(44352), // Rule ID 2100 //
     /*  44243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44262 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44270 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  44274 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44278 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44282 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44286 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44290 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  44294 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44299 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  44303 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44307 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44311 */     // MIs[4] Operand 1
     /*  44311 */     // No operand predicates
     /*  44311 */     // MIs[2] Operand 2
     /*  44311 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  44322 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  44324 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44331 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (UMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_indexed),
     /*  44334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44336 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  44347 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  44350 */     GIR_RootConstrainSelectedInstOperands,
     /*  44351 */     // GIR_Coverage, 2100,
     /*  44351 */     GIR_EraseRootFromParent_Done,
     /*  44352 */   // Label 680: @44352
     /*  44352 */   GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(44466), // Rule ID 13676 //
     /*  44357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44376 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  44388 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44392 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44396 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44400 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44404 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  44408 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44413 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  44417 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44421 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44425 */     // MIs[4] Operand 1
     /*  44425 */     // No operand predicates
     /*  44425 */     // MIs[2] Operand 2
     /*  44425 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  44436 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  44438 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44445 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (UMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_indexed),
     /*  44448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44450 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  44461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  44464 */     GIR_RootConstrainSelectedInstOperands,
     /*  44465 */     // GIR_Coverage, 13676,
     /*  44465 */     GIR_EraseRootFromParent_Done,
     /*  44466 */   // Label 681: @44466
     /*  44466 */   GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(44531), // Rule ID 1855 //
     /*  44471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44494 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44498 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44500 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44507 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44514 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  44517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44529 */     GIR_RootConstrainSelectedInstOperands,
     /*  44530 */     // GIR_Coverage, 1855,
     /*  44530 */     GIR_EraseRootFromParent_Done,
     /*  44531 */   // Label 682: @44531
     /*  44531 */   GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(44596), // Rule ID 1854 //
     /*  44536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44559 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44563 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44565 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44572 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44579 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  44582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44594 */     GIR_RootConstrainSelectedInstOperands,
     /*  44595 */     // GIR_Coverage, 1854,
     /*  44595 */     GIR_EraseRootFromParent_Done,
     /*  44596 */   // Label 683: @44596
     /*  44596 */   GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(44661), // Rule ID 1759 //
     /*  44601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44624 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44628 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44630 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44637 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44644 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SSUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i32_v2i64),
     /*  44647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44659 */     GIR_RootConstrainSelectedInstOperands,
     /*  44660 */     // GIR_Coverage, 1759,
     /*  44660 */     GIR_EraseRootFromParent_Done,
     /*  44661 */   // Label 684: @44661
     /*  44661 */   GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(44726), // Rule ID 1853 //
     /*  44666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44689 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44693 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44695 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44702 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44709 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  44712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44724 */     GIR_RootConstrainSelectedInstOperands,
     /*  44725 */     // GIR_Coverage, 1853,
     /*  44725 */     GIR_EraseRootFromParent_Done,
     /*  44726 */   // Label 685: @44726
     /*  44726 */   GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(44791), // Rule ID 1852 //
     /*  44731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44754 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44758 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44760 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44767 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44774 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  44777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44789 */     GIR_RootConstrainSelectedInstOperands,
     /*  44790 */     // GIR_Coverage, 1852,
     /*  44790 */     GIR_EraseRootFromParent_Done,
     /*  44791 */   // Label 686: @44791
     /*  44791 */   GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(44902), // Rule ID 13638 //
     /*  44796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44799 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44815 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44819 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44823 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  44827 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44831 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44835 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44839 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44843 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  44847 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44852 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  44856 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44860 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44864 */     // MIs[4] Operand 1
     /*  44864 */     // No operand predicates
     /*  44864 */     // MIs[2] Operand 2
     /*  44864 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  44875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44880 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  44882 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  44885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44887 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  44893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  44897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  44900 */     GIR_RootConstrainSelectedInstOperands,
     /*  44901 */     // GIR_Coverage, 13638,
     /*  44901 */     GIR_EraseRootFromParent_Done,
     /*  44902 */   // Label 687: @44902
     /*  44902 */   GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(45013), // Rule ID 2046 //
     /*  44907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44930 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44935 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44939 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  44943 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44947 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44951 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44955 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44959 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  44963 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44968 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  44972 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44976 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44980 */     // MIs[4] Operand 1
     /*  44980 */     // No operand predicates
     /*  44980 */     // MIs[2] Operand 2
     /*  44980 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  44991 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  44993 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  44996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44998 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  45008 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  45011 */     GIR_RootConstrainSelectedInstOperands,
     /*  45012 */     // GIR_Coverage, 2046,
     /*  45012 */     GIR_EraseRootFromParent_Done,
     /*  45013 */   // Label 688: @45013
     /*  45013 */   GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(45124), // Rule ID 13674 //
     /*  45018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  45033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  45041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45053 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  45057 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  45061 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45065 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  45069 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45074 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  45078 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45082 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  45086 */     // MIs[4] Operand 1
     /*  45086 */     // No operand predicates
     /*  45086 */     // MIs[2] Operand 2
     /*  45086 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  45097 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45102 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45104 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  45107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45109 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  45115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  45119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  45122 */     GIR_RootConstrainSelectedInstOperands,
     /*  45123 */     // GIR_Coverage, 13674,
     /*  45123 */     GIR_EraseRootFromParent_Done,
     /*  45124 */   // Label 689: @45124
     /*  45124 */   GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(45235), // Rule ID 2098 //
     /*  45129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  45144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  45152 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45157 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  45161 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45165 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45169 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  45173 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  45177 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45181 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  45185 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45190 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  45194 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45198 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  45202 */     // MIs[4] Operand 1
     /*  45202 */     // No operand predicates
     /*  45202 */     // MIs[2] Operand 2
     /*  45202 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  45213 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45215 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  45218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45220 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  45230 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  45233 */     GIR_RootConstrainSelectedInstOperands,
     /*  45234 */     // GIR_Coverage, 2098,
     /*  45234 */     GIR_EraseRootFromParent_Done,
     /*  45235 */   // Label 690: @45235
     /*  45235 */   GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(45298), // Rule ID 1735 //
     /*  45240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  45255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45259 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  45263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45265 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  45272 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  45279 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  45279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_v2i64),
     /*  45282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45284 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  45291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  45296 */     GIR_RootConstrainSelectedInstOperands,
     /*  45297 */     // GIR_Coverage, 1735,
     /*  45297 */     GIR_EraseRootFromParent_Done,
     /*  45298 */   // Label 691: @45298
     /*  45298 */   GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(45361), // Rule ID 1825 //
     /*  45303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  45318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45322 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  45326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45328 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  45335 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  45342 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  45342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_v2i64),
     /*  45345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45347 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  45354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  45359 */     GIR_RootConstrainSelectedInstOperands,
     /*  45360 */     // GIR_Coverage, 1825,
     /*  45360 */     GIR_EraseRootFromParent_Done,
     /*  45361 */   // Label 692: @45361
     /*  45361 */   GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(45449), // Rule ID 13639 //
     /*  45366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  45381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  45389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  45397 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45401 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  45405 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45410 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45414 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45418 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  45422 */     // MIs[3] Operand 1
     /*  45422 */     // No operand predicates
     /*  45422 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45427 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  45429 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  45432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45434 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  45440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  45444 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  45447 */     GIR_RootConstrainSelectedInstOperands,
     /*  45448 */     // GIR_Coverage, 13639,
     /*  45448 */     GIR_EraseRootFromParent_Done,
     /*  45449 */   // Label 693: @45449
     /*  45449 */   GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(45537), // Rule ID 2047 //
     /*  45454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  45469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45473 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  45477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  45486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  45490 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45494 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  45498 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45503 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45507 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45511 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  45515 */     // MIs[3] Operand 1
     /*  45515 */     // No operand predicates
     /*  45515 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  45517 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  45520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45522 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  45532 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  45535 */     GIR_RootConstrainSelectedInstOperands,
     /*  45536 */     // GIR_Coverage, 2047,
     /*  45536 */     GIR_EraseRootFromParent_Done,
     /*  45537 */   // Label 694: @45537
     /*  45537 */   GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(45625), // Rule ID 13675 //
     /*  45542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  45557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45561 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  45565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  45573 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45577 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  45581 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45586 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45590 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45594 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  45598 */     // MIs[3] Operand 1
     /*  45598 */     // No operand predicates
     /*  45598 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45603 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  45605 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  45608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45610 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  45616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  45620 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  45623 */     GIR_RootConstrainSelectedInstOperands,
     /*  45624 */     // GIR_Coverage, 13675,
     /*  45624 */     GIR_EraseRootFromParent_Done,
     /*  45625 */   // Label 695: @45625
     /*  45625 */   GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(45713), // Rule ID 2099 //
     /*  45630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  45645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45649 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  45653 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45658 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  45662 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  45666 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45670 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  45674 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45679 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45683 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45687 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  45691 */     // MIs[3] Operand 1
     /*  45691 */     // No operand predicates
     /*  45691 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  45693 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  45696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45698 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  45708 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  45711 */     GIR_RootConstrainSelectedInstOperands,
     /*  45712 */     // GIR_Coverage, 2099,
     /*  45712 */     GIR_EraseRootFromParent_Done,
     /*  45713 */   // Label 696: @45713
     /*  45713 */   GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(45760), // Rule ID 1867 //
     /*  45718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45739 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  45746 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  45746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i32_v2i64),
     /*  45749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45751 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  45758 */     GIR_RootConstrainSelectedInstOperands,
     /*  45759 */     // GIR_Coverage, 1867,
     /*  45759 */     GIR_EraseRootFromParent_Done,
     /*  45760 */   // Label 697: @45760
     /*  45760 */   GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(45807), // Rule ID 1765 //
     /*  45765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  45780 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45786 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  45793 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SSUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  45793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i32_v2i64),
     /*  45796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45798 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  45805 */     GIR_RootConstrainSelectedInstOperands,
     /*  45806 */     // GIR_Coverage, 1765,
     /*  45806 */     GIR_EraseRootFromParent_Done,
     /*  45807 */   // Label 698: @45807
     /*  45807 */   GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(45854), // Rule ID 1866 //
     /*  45812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45833 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  45840 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  45840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i32_v2i64),
     /*  45843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45845 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  45852 */     GIR_RootConstrainSelectedInstOperands,
     /*  45853 */     // GIR_Coverage, 1866,
     /*  45853 */     GIR_EraseRootFromParent_Done,
     /*  45854 */   // Label 699: @45854
     /*  45854 */   GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(45913), // Rule ID 1851 //
     /*  45859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45874 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  45883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45891 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45896 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  45898 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  45901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  45911 */     GIR_RootConstrainSelectedInstOperands,
     /*  45912 */     // GIR_Coverage, 1851,
     /*  45912 */     GIR_EraseRootFromParent_Done,
     /*  45913 */   // Label 700: @45913
     /*  45913 */   GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(45972), // Rule ID 1850 //
     /*  45918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  45942 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45946 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45950 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45955 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  45957 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  45960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  45970 */     GIR_RootConstrainSelectedInstOperands,
     /*  45971 */     // GIR_Coverage, 1850,
     /*  45971 */     GIR_EraseRootFromParent_Done,
     /*  45972 */   // Label 701: @45972
     /*  45972 */   GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(46031), // Rule ID 1758 //
     /*  45977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  45988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45992 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  46005 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  46009 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46014 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46016 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SSUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  46016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv2i32_v2i64),
     /*  46019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  46025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46029 */     GIR_RootConstrainSelectedInstOperands,
     /*  46030 */     // GIR_Coverage, 1758,
     /*  46030 */     GIR_EraseRootFromParent_Done,
     /*  46031 */   // Label 702: @46031
     /*  46031 */   GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(46090), // Rule ID 1849 //
     /*  46036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  46051 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46056 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46060 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46064 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  46068 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46073 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46075 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  46075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  46078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  46084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46088 */     GIR_RootConstrainSelectedInstOperands,
     /*  46089 */     // GIR_Coverage, 1849,
     /*  46089 */     GIR_EraseRootFromParent_Done,
     /*  46090 */   // Label 703: @46090
     /*  46090 */   GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(46149), // Rule ID 1848 //
     /*  46095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  46110 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46123 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  46127 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46132 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46134 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  46134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  46137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  46143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46147 */     GIR_RootConstrainSelectedInstOperands,
     /*  46148 */     // GIR_Coverage, 1848,
     /*  46148 */     GIR_EraseRootFromParent_Done,
     /*  46149 */   // Label 704: @46149
     /*  46149 */   GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(46184), // Rule ID 971 //
     /*  46154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46161 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46167 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  46169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46175 */     // (sub:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn)  =>  (NEGv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /*  46175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv2i64),
     /*  46178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46182 */     GIR_RootConstrainSelectedInstOperands,
     /*  46183 */     // GIR_Coverage, 971,
     /*  46183 */     GIR_EraseRootFromParent_Done,
     /*  46184 */   // Label 705: @46184
     /*  46184 */   GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(46241), // Rule ID 1734 //
     /*  46189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  46204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  46208 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  46212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46224 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  46224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_v2i64),
     /*  46227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46229 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  46231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  46235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  46239 */     GIR_RootConstrainSelectedInstOperands,
     /*  46240 */     // GIR_Coverage, 1734,
     /*  46240 */     GIR_EraseRootFromParent_Done,
     /*  46241 */   // Label 706: @46241
     /*  46241 */   GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(46298), // Rule ID 1824 //
     /*  46246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  46261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  46265 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  46269 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46281 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  46281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_v2i64),
     /*  46284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46286 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  46288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  46292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  46296 */     GIR_RootConstrainSelectedInstOperands,
     /*  46297 */     // GIR_Coverage, 1824,
     /*  46297 */     GIR_EraseRootFromParent_Done,
     /*  46298 */   // Label 707: @46298
     /*  46298 */   GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(46342), // Rule ID 1865 //
     /*  46303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  46322 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46329 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  46329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  46332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46334 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  46336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  46340 */     GIR_RootConstrainSelectedInstOperands,
     /*  46341 */     // GIR_Coverage, 1865,
     /*  46341 */     GIR_EraseRootFromParent_Done,
     /*  46342 */   // Label 708: @46342
     /*  46342 */   GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(46386), // Rule ID 1764 //
     /*  46347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  46362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  46366 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46373 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SSUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  46373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv2i32_v2i64),
     /*  46376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46378 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  46380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  46384 */     GIR_RootConstrainSelectedInstOperands,
     /*  46385 */     // GIR_Coverage, 1764,
     /*  46385 */     GIR_EraseRootFromParent_Done,
     /*  46386 */   // Label 709: @46386
     /*  46386 */   GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(46430), // Rule ID 1864 //
     /*  46391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  46410 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46417 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  46417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  46420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46422 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  46424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  46428 */     GIR_RootConstrainSelectedInstOperands,
     /*  46429 */     // GIR_Coverage, 1864,
     /*  46429 */     GIR_EraseRootFromParent_Done,
     /*  46430 */   // Label 710: @46430
     /*  46430 */   GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(46453), // Rule ID 1478 //
     /*  46435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46446 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  46446 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv2i64),
     /*  46451 */     GIR_RootConstrainSelectedInstOperands,
     /*  46452 */     // GIR_Coverage, 1478,
     /*  46452 */     GIR_Done,
     /*  46453 */   // Label 711: @46453
     /*  46453 */   GIM_Reject,
     /*  46454 */ // Label 677: @46454
     /*  46454 */ GIM_Reject,
     /*  46455 */ // Label 595: @46455
     /*  46455 */ GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(47945),
     /*  46460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46463 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  46466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46470 */   GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(46602), // Rule ID 5433 //
     /*  46475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46495 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46499 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46504 */     // MIs[1] Operand 2
     /*  46504 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46515 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  46519 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46523 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46527 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  46531 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46535 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46539 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46544 */     // MIs[3] Operand 2
     /*  46544 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  46555 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  46557 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46557 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  46564 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46569 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  46573 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  46577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46584 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46591 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46596 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46601 */     // GIR_Coverage, 5433,
     /*  46601 */     GIR_EraseRootFromParent_Done,
     /*  46602 */   // Label 713: @46602
     /*  46602 */   GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(46734), // Rule ID 5432 //
     /*  46607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46615 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46627 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46631 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46636 */     // MIs[1] Operand 2
     /*  46636 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46647 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  46651 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46655 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46659 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  46663 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46667 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46671 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46676 */     // MIs[3] Operand 2
     /*  46676 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  46687 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  46689 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46689 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46692 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  46696 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46701 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  46705 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  46709 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46716 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46723 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46728 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46733 */     // GIR_Coverage, 5432,
     /*  46733 */     GIR_EraseRootFromParent_Done,
     /*  46734 */   // Label 714: @46734
     /*  46734 */   GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(46866), // Rule ID 5448 //
     /*  46739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46747 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  46759 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46763 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46768 */     // MIs[1] Operand 2
     /*  46768 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46779 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  46783 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46787 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46791 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  46795 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  46799 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46803 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46808 */     // MIs[3] Operand 2
     /*  46808 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  46819 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  46821 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SSUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46821 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46824 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i8_v8i16),
     /*  46828 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46833 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  46837 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  46841 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46848 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46855 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46860 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46865 */     // GIR_Coverage, 5448,
     /*  46865 */     GIR_EraseRootFromParent_Done,
     /*  46866 */   // Label 715: @46866
     /*  46866 */   GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(46998), // Rule ID 5431 //
     /*  46871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46883 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46887 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46891 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46895 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46900 */     // MIs[1] Operand 2
     /*  46900 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46911 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  46915 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46919 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46923 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  46927 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46931 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46935 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46940 */     // MIs[3] Operand 2
     /*  46940 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  46951 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  46953 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46953 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46956 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  46960 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46965 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  46969 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  46973 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46980 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46987 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46992 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46997 */     // GIR_Coverage, 5431,
     /*  46997 */     GIR_EraseRootFromParent_Done,
     /*  46998 */   // Label 716: @46998
     /*  46998 */   GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(47130), // Rule ID 5430 //
     /*  47003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47023 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47027 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47032 */     // MIs[1] Operand 2
     /*  47032 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  47043 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  47047 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47051 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47055 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  47059 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47063 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47067 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47072 */     // MIs[3] Operand 2
     /*  47072 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  47083 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47085 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  47085 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  47088 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  47092 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47097 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  47101 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  47105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47112 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  47119 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47124 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47129 */     // GIR_Coverage, 5430,
     /*  47129 */     GIR_EraseRootFromParent_Done,
     /*  47130 */   // Label 717: @47130
     /*  47130 */   GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(47289), // Rule ID 5403 //
     /*  47135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47155 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  47159 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47163 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  47167 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47172 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47177 */     // MIs[1] Operand 2
     /*  47177 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  47188 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47190 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLSLv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  47190 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  47193 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  47197 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47202 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  47204 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  47207 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  47211 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47216 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  47219 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  47223 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  47226 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47231 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47236 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47241 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  47244 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i8_v8i16),
     /*  47248 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47253 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47256 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  47260 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  47264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47271 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  47278 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47283 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47288 */     // GIR_Coverage, 5403,
     /*  47288 */     GIR_EraseRootFromParent_Done,
     /*  47289 */   // Label 718: @47289
     /*  47289 */   GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(47448), // Rule ID 5400 //
     /*  47294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47310 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47314 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  47318 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47322 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  47326 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47331 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47336 */     // MIs[1] Operand 2
     /*  47336 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  47347 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47349 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLSLv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  47349 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  47352 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  47356 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47361 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  47363 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  47366 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  47370 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47375 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  47378 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  47382 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  47385 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47390 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47395 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47400 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  47403 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i8_v8i16),
     /*  47407 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47412 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47415 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  47419 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  47423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47430 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  47437 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47442 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47447 */     // GIR_Coverage, 5400,
     /*  47447 */     GIR_EraseRootFromParent_Done,
     /*  47448 */   // Label 719: @47448
     /*  47448 */   GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(47594), // Rule ID 5443 //
     /*  47453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47469 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47473 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47477 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47481 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47486 */     // MIs[1] Operand 2
     /*  47486 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  47497 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47499 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  47499 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  47502 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  47506 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47511 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  47513 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  47516 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  47520 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47525 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  47528 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  47532 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  47535 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47540 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47545 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  47553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  47557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47562 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47565 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  47569 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47576 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  47583 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47588 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47593 */     // GIR_Coverage, 5443,
     /*  47593 */     GIR_EraseRootFromParent_Done,
     /*  47594 */   // Label 720: @47594
     /*  47594 */   GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(47740), // Rule ID 5451 //
     /*  47599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  47623 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47627 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47632 */     // MIs[1] Operand 2
     /*  47632 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  47643 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47645 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SSUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  47645 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  47648 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  47652 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47657 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  47659 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  47662 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  47666 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47671 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  47674 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  47678 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  47681 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47686 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47691 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47696 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  47699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i8_v8i16),
     /*  47703 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47708 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47711 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  47715 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47722 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  47729 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47734 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47739 */     // GIR_Coverage, 5451,
     /*  47739 */     GIR_EraseRootFromParent_Done,
     /*  47740 */   // Label 721: @47740
     /*  47740 */   GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(47886), // Rule ID 5442 //
     /*  47745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47773 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47778 */     // MIs[1] Operand 2
     /*  47778 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  47789 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47791 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  47791 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  47794 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  47798 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  47805 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  47808 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  47812 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47817 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  47820 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  47824 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  47827 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47832 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47837 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  47845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  47849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47854 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47857 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  47861 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47868 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  47875 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47880 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47885 */     // GIR_Coverage, 5442,
     /*  47885 */     GIR_EraseRootFromParent_Done,
     /*  47886 */   // Label 722: @47886
     /*  47886 */   GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(47921), // Rule ID 967 //
     /*  47891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47898 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47904 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  47906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47912 */     // (sub:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn)  =>  (NEGv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /*  47912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv4i16),
     /*  47915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47919 */     GIR_RootConstrainSelectedInstOperands,
     /*  47920 */     // GIR_Coverage, 967,
     /*  47920 */     GIR_EraseRootFromParent_Done,
     /*  47921 */   // Label 723: @47921
     /*  47921 */   GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(47944), // Rule ID 1474 //
     /*  47926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47937 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  47937 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv4i16),
     /*  47942 */     GIR_RootConstrainSelectedInstOperands,
     /*  47943 */     // GIR_Coverage, 1474,
     /*  47943 */     GIR_Done,
     /*  47944 */   // Label 724: @47944
     /*  47944 */   GIM_Reject,
     /*  47945 */ // Label 712: @47945
     /*  47945 */ GIM_Reject,
     /*  47946 */ // Label 596: @47946
     /*  47946 */ GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(50405),
     /*  47951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47954 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47961 */   GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(48075), // Rule ID 2045 //
     /*  47966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  47981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47985 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47997 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48001 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  48005 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48009 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48013 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  48017 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48022 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  48026 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48030 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48034 */     // MIs[4] Operand 1
     /*  48034 */     // No operand predicates
     /*  48034 */     // MIs[2] Operand 2
     /*  48034 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  48045 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  48047 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48054 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_indexed),
     /*  48057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48059 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  48070 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  48073 */     GIR_RootConstrainSelectedInstOperands,
     /*  48074 */     // GIR_Coverage, 2045,
     /*  48074 */     GIR_EraseRootFromParent_Done,
     /*  48075 */   // Label 726: @48075
     /*  48075 */   GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(48189), // Rule ID 13637 //
     /*  48080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  48095 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48099 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  48107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  48111 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48115 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  48119 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48123 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48127 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  48131 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48136 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  48140 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48144 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48148 */     // MIs[4] Operand 1
     /*  48148 */     // No operand predicates
     /*  48148 */     // MIs[2] Operand 2
     /*  48148 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  48159 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  48161 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48168 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (SMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_indexed),
     /*  48171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48173 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  48184 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  48187 */     GIR_RootConstrainSelectedInstOperands,
     /*  48188 */     // GIR_Coverage, 13637,
     /*  48188 */     GIR_EraseRootFromParent_Done,
     /*  48189 */   // Label 727: @48189
     /*  48189 */   GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(48303), // Rule ID 2097 //
     /*  48194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  48221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  48225 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48229 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  48233 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48237 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48241 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  48245 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48250 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  48254 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48258 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48262 */     // MIs[4] Operand 1
     /*  48262 */     // No operand predicates
     /*  48262 */     // MIs[2] Operand 2
     /*  48262 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  48273 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  48275 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48282 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (UMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_indexed),
     /*  48285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48287 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  48298 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  48301 */     GIR_RootConstrainSelectedInstOperands,
     /*  48302 */     // GIR_Coverage, 2097,
     /*  48302 */     GIR_EraseRootFromParent_Done,
     /*  48303 */   // Label 728: @48303
     /*  48303 */   GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(48417), // Rule ID 13673 //
     /*  48308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48327 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  48335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  48339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48343 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  48347 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48351 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48355 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  48359 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48364 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  48368 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48372 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48376 */     // MIs[4] Operand 1
     /*  48376 */     // No operand predicates
     /*  48376 */     // MIs[2] Operand 2
     /*  48376 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  48387 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  48389 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48396 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (UMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_indexed),
     /*  48399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48401 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  48412 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  48415 */     GIR_RootConstrainSelectedInstOperands,
     /*  48416 */     // GIR_Coverage, 13673,
     /*  48416 */     GIR_EraseRootFromParent_Done,
     /*  48417 */   // Label 729: @48417
     /*  48417 */   GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(48482), // Rule ID 1847 //
     /*  48422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48437 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48441 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48445 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48449 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48451 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48458 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48465 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  48468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  48480 */     GIR_RootConstrainSelectedInstOperands,
     /*  48481 */     // GIR_Coverage, 1847,
     /*  48481 */     GIR_EraseRootFromParent_Done,
     /*  48482 */   // Label 730: @48482
     /*  48482 */   GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(48547), // Rule ID 1846 //
     /*  48487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48510 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48514 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48516 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48523 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48530 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  48533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  48545 */     GIR_RootConstrainSelectedInstOperands,
     /*  48546 */     // GIR_Coverage, 1846,
     /*  48546 */     GIR_EraseRootFromParent_Done,
     /*  48547 */   // Label 731: @48547
     /*  48547 */   GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(48612), // Rule ID 1757 //
     /*  48552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48575 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48579 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48581 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48588 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48595 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SSUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i16_v4i32),
     /*  48598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  48610 */     GIR_RootConstrainSelectedInstOperands,
     /*  48611 */     // GIR_Coverage, 1757,
     /*  48611 */     GIR_EraseRootFromParent_Done,
     /*  48612 */   // Label 732: @48612
     /*  48612 */   GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(48677), // Rule ID 1845 //
     /*  48617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48640 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48644 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48646 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48653 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48660 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  48663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  48675 */     GIR_RootConstrainSelectedInstOperands,
     /*  48676 */     // GIR_Coverage, 1845,
     /*  48676 */     GIR_EraseRootFromParent_Done,
     /*  48677 */   // Label 733: @48677
     /*  48677 */   GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(48742), // Rule ID 1844 //
     /*  48682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48697 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48701 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48705 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48709 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48711 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48718 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48725 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  48728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  48740 */     GIR_RootConstrainSelectedInstOperands,
     /*  48741 */     // GIR_Coverage, 1844,
     /*  48741 */     GIR_EraseRootFromParent_Done,
     /*  48742 */   // Label 734: @48742
     /*  48742 */   GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(48853), // Rule ID 13635 //
     /*  48747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  48762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48766 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  48774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  48778 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48782 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  48786 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48790 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48794 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  48798 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48803 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  48807 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48811 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48815 */     // MIs[4] Operand 1
     /*  48815 */     // No operand predicates
     /*  48815 */     // MIs[2] Operand 2
     /*  48815 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  48826 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48831 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  48833 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  48836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48838 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  48844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  48848 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  48851 */     GIR_RootConstrainSelectedInstOperands,
     /*  48852 */     // GIR_Coverage, 13635,
     /*  48852 */     GIR_EraseRootFromParent_Done,
     /*  48853 */   // Label 735: @48853
     /*  48853 */   GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(48964), // Rule ID 2043 //
     /*  48858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  48873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48881 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48886 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  48890 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  48894 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48898 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  48902 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48906 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48910 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  48914 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48919 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  48923 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48927 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48931 */     // MIs[4] Operand 1
     /*  48931 */     // No operand predicates
     /*  48931 */     // MIs[2] Operand 2
     /*  48931 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  48942 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  48944 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  48947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48949 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  48959 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  48962 */     GIR_RootConstrainSelectedInstOperands,
     /*  48963 */     // GIR_Coverage, 2043,
     /*  48963 */     GIR_EraseRootFromParent_Done,
     /*  48964 */   // Label 736: @48964
     /*  48964 */   GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(49075), // Rule ID 13671 //
     /*  48969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  48996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  49000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49004 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  49008 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  49012 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49016 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  49020 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  49025 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  49029 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49033 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  49037 */     // MIs[4] Operand 1
     /*  49037 */     // No operand predicates
     /*  49037 */     // MIs[2] Operand 2
     /*  49037 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  49048 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49053 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  49055 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  49058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49060 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  49066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  49070 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  49073 */     GIR_RootConstrainSelectedInstOperands,
     /*  49074 */     // GIR_Coverage, 13671,
     /*  49074 */     GIR_EraseRootFromParent_Done,
     /*  49075 */   // Label 737: @49075
     /*  49075 */   GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(49186), // Rule ID 2095 //
     /*  49080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  49095 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49099 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49103 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49108 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  49112 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  49116 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49120 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  49124 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  49128 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49132 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  49136 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  49141 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  49145 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49149 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  49153 */     // MIs[4] Operand 1
     /*  49153 */     // No operand predicates
     /*  49153 */     // MIs[2] Operand 2
     /*  49153 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  49164 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  49166 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  49169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49171 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  49181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  49184 */     GIR_RootConstrainSelectedInstOperands,
     /*  49185 */     // GIR_Coverage, 2095,
     /*  49185 */     GIR_EraseRootFromParent_Done,
     /*  49186 */   // Label 738: @49186
     /*  49186 */   GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(49249), // Rule ID 1733 //
     /*  49191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  49206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49210 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49216 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  49223 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  49230 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  49230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_v4i32),
     /*  49233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49235 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49247 */     GIR_RootConstrainSelectedInstOperands,
     /*  49248 */     // GIR_Coverage, 1733,
     /*  49248 */     GIR_EraseRootFromParent_Done,
     /*  49249 */   // Label 739: @49249
     /*  49249 */   GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(49312), // Rule ID 1823 //
     /*  49254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  49269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49273 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49279 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  49286 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  49293 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  49293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_v4i32),
     /*  49296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49298 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49310 */     GIR_RootConstrainSelectedInstOperands,
     /*  49311 */     // GIR_Coverage, 1823,
     /*  49311 */     GIR_EraseRootFromParent_Done,
     /*  49312 */   // Label 740: @49312
     /*  49312 */   GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(49400), // Rule ID 13636 //
     /*  49317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  49332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49336 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49340 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  49344 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  49348 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49352 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  49356 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  49361 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  49365 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49369 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  49373 */     // MIs[3] Operand 1
     /*  49373 */     // No operand predicates
     /*  49373 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49378 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  49380 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  49383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49385 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  49391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  49398 */     GIR_RootConstrainSelectedInstOperands,
     /*  49399 */     // GIR_Coverage, 13636,
     /*  49399 */     GIR_EraseRootFromParent_Done,
     /*  49400 */   // Label 741: @49400
     /*  49400 */   GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(49488), // Rule ID 2044 //
     /*  49405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  49420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49428 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  49437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  49441 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49445 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  49449 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  49454 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  49458 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49462 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  49466 */     // MIs[3] Operand 1
     /*  49466 */     // No operand predicates
     /*  49466 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  49468 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  49471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49473 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49483 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  49486 */     GIR_RootConstrainSelectedInstOperands,
     /*  49487 */     // GIR_Coverage, 2044,
     /*  49487 */     GIR_EraseRootFromParent_Done,
     /*  49488 */   // Label 742: @49488
     /*  49488 */   GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(49576), // Rule ID 13672 //
     /*  49493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  49508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49512 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  49520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  49524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49528 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  49532 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  49537 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  49541 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49545 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  49549 */     // MIs[3] Operand 1
     /*  49549 */     // No operand predicates
     /*  49549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49554 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  49556 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  49559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49561 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  49567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49571 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  49574 */     GIR_RootConstrainSelectedInstOperands,
     /*  49575 */     // GIR_Coverage, 13672,
     /*  49575 */     GIR_EraseRootFromParent_Done,
     /*  49576 */   // Label 743: @49576
     /*  49576 */   GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(49664), // Rule ID 2096 //
     /*  49581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  49596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49604 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  49613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  49617 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49621 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  49625 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  49630 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  49634 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49638 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  49642 */     // MIs[3] Operand 1
     /*  49642 */     // No operand predicates
     /*  49642 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  49644 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  49647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49649 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  49662 */     GIR_RootConstrainSelectedInstOperands,
     /*  49663 */     // GIR_Coverage, 2096,
     /*  49663 */     GIR_EraseRootFromParent_Done,
     /*  49664 */   // Label 744: @49664
     /*  49664 */   GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(49711), // Rule ID 1863 //
     /*  49669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49688 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49690 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  49697 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  49697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i16_v4i32),
     /*  49700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49702 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  49709 */     GIR_RootConstrainSelectedInstOperands,
     /*  49710 */     // GIR_Coverage, 1863,
     /*  49710 */     GIR_EraseRootFromParent_Done,
     /*  49711 */   // Label 745: @49711
     /*  49711 */   GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(49758), // Rule ID 1763 //
     /*  49716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49737 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  49744 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SSUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  49744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i16_v4i32),
     /*  49747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49749 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  49756 */     GIR_RootConstrainSelectedInstOperands,
     /*  49757 */     // GIR_Coverage, 1763,
     /*  49757 */     GIR_EraseRootFromParent_Done,
     /*  49758 */   // Label 746: @49758
     /*  49758 */   GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(49805), // Rule ID 1862 //
     /*  49763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49784 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  49791 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  49791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i16_v4i32),
     /*  49794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49796 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  49803 */     GIR_RootConstrainSelectedInstOperands,
     /*  49804 */     // GIR_Coverage, 1862,
     /*  49804 */     GIR_EraseRootFromParent_Done,
     /*  49805 */   // Label 747: @49805
     /*  49805 */   GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(49864), // Rule ID 1843 //
     /*  49810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49825 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49842 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49847 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49849 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  49852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49862 */     GIR_RootConstrainSelectedInstOperands,
     /*  49863 */     // GIR_Coverage, 1843,
     /*  49863 */     GIR_EraseRootFromParent_Done,
     /*  49864 */   // Label 748: @49864
     /*  49864 */   GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(49923), // Rule ID 1842 //
     /*  49869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49884 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49897 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49901 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49906 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49908 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  49911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49921 */     GIR_RootConstrainSelectedInstOperands,
     /*  49922 */     // GIR_Coverage, 1842,
     /*  49922 */     GIR_EraseRootFromParent_Done,
     /*  49923 */   // Label 749: @49923
     /*  49923 */   GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(49982), // Rule ID 1756 //
     /*  49928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49943 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49956 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49960 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49965 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49967 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SSUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i16_v4i32),
     /*  49970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49980 */     GIR_RootConstrainSelectedInstOperands,
     /*  49981 */     // GIR_Coverage, 1756,
     /*  49981 */     GIR_EraseRootFromParent_Done,
     /*  49982 */   // Label 750: @49982
     /*  49982 */   GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(50041), // Rule ID 1841 //
     /*  49987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  50002 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50015 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  50019 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50024 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50026 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  50026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  50029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  50039 */     GIR_RootConstrainSelectedInstOperands,
     /*  50040 */     // GIR_Coverage, 1841,
     /*  50040 */     GIR_EraseRootFromParent_Done,
     /*  50041 */   // Label 751: @50041
     /*  50041 */   GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(50100), // Rule ID 1840 //
     /*  50046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  50061 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50074 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  50078 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50083 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50085 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  50085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  50088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  50098 */     GIR_RootConstrainSelectedInstOperands,
     /*  50099 */     // GIR_Coverage, 1840,
     /*  50099 */     GIR_EraseRootFromParent_Done,
     /*  50100 */   // Label 752: @50100
     /*  50100 */   GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(50135), // Rule ID 970 //
     /*  50105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50112 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  50118 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  50120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50126 */     // (sub:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn)  =>  (NEGv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /*  50126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv4i32),
     /*  50129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  50133 */     GIR_RootConstrainSelectedInstOperands,
     /*  50134 */     // GIR_Coverage, 970,
     /*  50134 */     GIR_EraseRootFromParent_Done,
     /*  50135 */   // Label 753: @50135
     /*  50135 */   GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(50192), // Rule ID 1732 //
     /*  50140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  50155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  50159 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  50163 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50168 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50175 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  50175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_v4i32),
     /*  50178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50180 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  50182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  50190 */     GIR_RootConstrainSelectedInstOperands,
     /*  50191 */     // GIR_Coverage, 1732,
     /*  50191 */     GIR_EraseRootFromParent_Done,
     /*  50192 */   // Label 754: @50192
     /*  50192 */   GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(50249), // Rule ID 1822 //
     /*  50197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  50212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  50216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  50220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50230 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50232 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  50232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_v4i32),
     /*  50235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50237 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  50239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  50247 */     GIR_RootConstrainSelectedInstOperands,
     /*  50248 */     // GIR_Coverage, 1822,
     /*  50248 */     GIR_EraseRootFromParent_Done,
     /*  50249 */   // Label 755: @50249
     /*  50249 */   GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(50293), // Rule ID 1861 //
     /*  50254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  50273 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50280 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  50280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  50283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50285 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50291 */     GIR_RootConstrainSelectedInstOperands,
     /*  50292 */     // GIR_Coverage, 1861,
     /*  50292 */     GIR_EraseRootFromParent_Done,
     /*  50293 */   // Label 756: @50293
     /*  50293 */   GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(50337), // Rule ID 1762 //
     /*  50298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  50313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  50317 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50322 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50324 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SSUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  50324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i16_v4i32),
     /*  50327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50329 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50335 */     GIR_RootConstrainSelectedInstOperands,
     /*  50336 */     // GIR_Coverage, 1762,
     /*  50336 */     GIR_EraseRootFromParent_Done,
     /*  50337 */   // Label 757: @50337
     /*  50337 */   GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(50381), // Rule ID 1860 //
     /*  50342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  50361 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50368 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  50368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  50371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50373 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50379 */     GIR_RootConstrainSelectedInstOperands,
     /*  50380 */     // GIR_Coverage, 1860,
     /*  50380 */     GIR_EraseRootFromParent_Done,
     /*  50381 */   // Label 758: @50381
     /*  50381 */   GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(50404), // Rule ID 1477 //
     /*  50386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50397 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  50397 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv4i32),
     /*  50402 */     GIR_RootConstrainSelectedInstOperands,
     /*  50403 */     // GIR_Coverage, 1477,
     /*  50403 */     GIR_Done,
     /*  50404 */   // Label 759: @50404
     /*  50404 */   GIM_Reject,
     /*  50405 */ // Label 725: @50405
     /*  50405 */ GIM_Reject,
     /*  50406 */ // Label 597: @50406
     /*  50406 */ GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(50480),
     /*  50411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50414 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50421 */   GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(50456), // Rule ID 965 //
     /*  50426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50433 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  50439 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  50441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50447 */     // (sub:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn)  =>  (NEGv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /*  50447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv8i8),
     /*  50450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  50454 */     GIR_RootConstrainSelectedInstOperands,
     /*  50455 */     // GIR_Coverage, 965,
     /*  50455 */     GIR_EraseRootFromParent_Done,
     /*  50456 */   // Label 761: @50456
     /*  50456 */   GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(50479), // Rule ID 1472 //
     /*  50461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50472 */     // (sub:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50472 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv8i8),
     /*  50477 */     GIR_RootConstrainSelectedInstOperands,
     /*  50478 */     // GIR_Coverage, 1472,
     /*  50478 */     GIR_Done,
     /*  50479 */   // Label 762: @50479
     /*  50479 */   GIM_Reject,
     /*  50480 */ // Label 760: @50480
     /*  50480 */ GIM_Reject,
     /*  50481 */ // Label 598: @50481
     /*  50481 */ GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(51688),
     /*  50486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  50489 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  50492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50496 */   GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(50561), // Rule ID 1839 //
     /*  50501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50528 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50530 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50537 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50544 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  50544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  50547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  50554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  50559 */     GIR_RootConstrainSelectedInstOperands,
     /*  50560 */     // GIR_Coverage, 1839,
     /*  50560 */     GIR_EraseRootFromParent_Done,
     /*  50561 */   // Label 764: @50561
     /*  50561 */   GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(50626), // Rule ID 1838 //
     /*  50566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50589 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50593 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50595 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50602 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50609 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  50609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  50612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  50619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  50624 */     GIR_RootConstrainSelectedInstOperands,
     /*  50625 */     // GIR_Coverage, 1838,
     /*  50625 */     GIR_EraseRootFromParent_Done,
     /*  50626 */   // Label 765: @50626
     /*  50626 */   GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(50691), // Rule ID 1755 //
     /*  50631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  50642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50646 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50650 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  50654 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50658 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50660 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50667 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50674 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SSUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  50674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv16i8_v8i16),
     /*  50677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  50684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  50689 */     GIR_RootConstrainSelectedInstOperands,
     /*  50690 */     // GIR_Coverage, 1755,
     /*  50690 */     GIR_EraseRootFromParent_Done,
     /*  50691 */   // Label 766: @50691
     /*  50691 */   GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(50756), // Rule ID 1837 //
     /*  50696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50719 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50723 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50725 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50732 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50739 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  50739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  50742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  50749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  50754 */     GIR_RootConstrainSelectedInstOperands,
     /*  50755 */     // GIR_Coverage, 1837,
     /*  50755 */     GIR_EraseRootFromParent_Done,
     /*  50756 */   // Label 767: @50756
     /*  50756 */   GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(50821), // Rule ID 1836 //
     /*  50761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50776 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50780 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50784 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50788 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50790 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50797 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50804 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  50804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  50807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  50814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  50819 */     GIR_RootConstrainSelectedInstOperands,
     /*  50820 */     // GIR_Coverage, 1836,
     /*  50820 */     GIR_EraseRootFromParent_Done,
     /*  50821 */   // Label 768: @50821
     /*  50821 */   GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(50884), // Rule ID 1731 //
     /*  50826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50829 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  50841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50845 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50851 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50858 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50865 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SMLSLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  50865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv16i8_v8i16),
     /*  50868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50870 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  50872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  50877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  50882 */     GIR_RootConstrainSelectedInstOperands,
     /*  50883 */     // GIR_Coverage, 1731,
     /*  50883 */     GIR_EraseRootFromParent_Done,
     /*  50884 */   // Label 769: @50884
     /*  50884 */   GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(50947), // Rule ID 1821 //
     /*  50889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50892 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  50904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50908 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50914 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50921 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50928 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UMLSLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  50928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv16i8_v8i16),
     /*  50931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50933 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  50935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  50940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  50945 */     GIR_RootConstrainSelectedInstOperands,
     /*  50946 */     // GIR_Coverage, 1821,
     /*  50946 */     GIR_EraseRootFromParent_Done,
     /*  50947 */   // Label 770: @50947
     /*  50947 */   GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(50994), // Rule ID 1859 //
     /*  50952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50973 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50980 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  50980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv16i8_v8i16),
     /*  50983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50985 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  50992 */     GIR_RootConstrainSelectedInstOperands,
     /*  50993 */     // GIR_Coverage, 1859,
     /*  50993 */     GIR_EraseRootFromParent_Done,
     /*  50994 */   // Label 771: @50994
     /*  50994 */   GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(51041), // Rule ID 1761 //
     /*  50999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51020 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  51027 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SSUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  51027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv16i8_v8i16),
     /*  51030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51032 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  51039 */     GIR_RootConstrainSelectedInstOperands,
     /*  51040 */     // GIR_Coverage, 1761,
     /*  51040 */     GIR_EraseRootFromParent_Done,
     /*  51041 */   // Label 772: @51041
     /*  51041 */   GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(51088), // Rule ID 1858 //
     /*  51046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51067 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  51074 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  51074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv16i8_v8i16),
     /*  51077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51079 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  51086 */     GIR_RootConstrainSelectedInstOperands,
     /*  51087 */     // GIR_Coverage, 1858,
     /*  51087 */     GIR_EraseRootFromParent_Done,
     /*  51088 */   // Label 773: @51088
     /*  51088 */   GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(51147), // Rule ID 1835 //
     /*  51093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  51104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51108 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51113 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51117 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  51121 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51125 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51130 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51132 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  51132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  51135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51145 */     GIR_RootConstrainSelectedInstOperands,
     /*  51146 */     // GIR_Coverage, 1835,
     /*  51146 */     GIR_EraseRootFromParent_Done,
     /*  51147 */   // Label 774: @51147
     /*  51147 */   GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(51206), // Rule ID 1834 //
     /*  51152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  51163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51167 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51180 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51184 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51189 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51191 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  51191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  51194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51204 */     GIR_RootConstrainSelectedInstOperands,
     /*  51205 */     // GIR_Coverage, 1834,
     /*  51205 */     GIR_EraseRootFromParent_Done,
     /*  51206 */   // Label 775: @51206
     /*  51206 */   GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(51265), // Rule ID 1754 //
     /*  51211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51226 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51239 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51243 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51248 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51250 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SSUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  51250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i8_v8i16),
     /*  51253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51263 */     GIR_RootConstrainSelectedInstOperands,
     /*  51264 */     // GIR_Coverage, 1754,
     /*  51264 */     GIR_EraseRootFromParent_Done,
     /*  51265 */   // Label 776: @51265
     /*  51265 */   GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(51324), // Rule ID 1833 //
     /*  51270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51285 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  51298 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51302 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51307 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51309 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  51309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  51312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51322 */     GIR_RootConstrainSelectedInstOperands,
     /*  51323 */     // GIR_Coverage, 1833,
     /*  51323 */     GIR_EraseRootFromParent_Done,
     /*  51324 */   // Label 777: @51324
     /*  51324 */   GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(51383), // Rule ID 1832 //
     /*  51329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51344 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51349 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51353 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51357 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51361 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51366 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51368 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  51368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  51371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51381 */     GIR_RootConstrainSelectedInstOperands,
     /*  51382 */     // GIR_Coverage, 1832,
     /*  51382 */     GIR_EraseRootFromParent_Done,
     /*  51383 */   // Label 778: @51383
     /*  51383 */   GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(51418), // Rule ID 968 //
     /*  51388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51395 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  51401 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  51403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51409 */     // (sub:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn)  =>  (NEGv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /*  51409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv8i16),
     /*  51412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  51416 */     GIR_RootConstrainSelectedInstOperands,
     /*  51417 */     // GIR_Coverage, 968,
     /*  51417 */     GIR_EraseRootFromParent_Done,
     /*  51418 */   // Label 779: @51418
     /*  51418 */   GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(51475), // Rule ID 1730 //
     /*  51423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  51438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51442 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  51446 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51451 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51458 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SMLSLv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  51458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i8_v8i16),
     /*  51461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51463 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  51465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  51473 */     GIR_RootConstrainSelectedInstOperands,
     /*  51474 */     // GIR_Coverage, 1730,
     /*  51474 */     GIR_EraseRootFromParent_Done,
     /*  51475 */   // Label 780: @51475
     /*  51475 */   GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(51532), // Rule ID 1820 //
     /*  51480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  51495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51499 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  51503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51508 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51515 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UMLSLv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  51515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i8_v8i16),
     /*  51518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51520 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  51522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  51530 */     GIR_RootConstrainSelectedInstOperands,
     /*  51531 */     // GIR_Coverage, 1820,
     /*  51531 */     GIR_EraseRootFromParent_Done,
     /*  51532 */   // Label 781: @51532
     /*  51532 */   GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(51576), // Rule ID 1857 //
     /*  51537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  51552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51556 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51563 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  51563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  51566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51568 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  51574 */     GIR_RootConstrainSelectedInstOperands,
     /*  51575 */     // GIR_Coverage, 1857,
     /*  51575 */     GIR_EraseRootFromParent_Done,
     /*  51576 */   // Label 782: @51576
     /*  51576 */   GIM_Try, /*On fail goto*//*Label 783*/ GIMT_Encode4(51620), // Rule ID 1760 //
     /*  51581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51600 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51607 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SSUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  51607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i8_v8i16),
     /*  51610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51612 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  51618 */     GIR_RootConstrainSelectedInstOperands,
     /*  51619 */     // GIR_Coverage, 1760,
     /*  51619 */     GIR_EraseRootFromParent_Done,
     /*  51620 */   // Label 783: @51620
     /*  51620 */   GIM_Try, /*On fail goto*//*Label 784*/ GIMT_Encode4(51664), // Rule ID 1856 //
     /*  51625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51644 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51651 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  51651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  51654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51656 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  51662 */     GIR_RootConstrainSelectedInstOperands,
     /*  51663 */     // GIR_Coverage, 1856,
     /*  51663 */     GIR_EraseRootFromParent_Done,
     /*  51664 */   // Label 784: @51664
     /*  51664 */   GIM_Try, /*On fail goto*//*Label 785*/ GIMT_Encode4(51687), // Rule ID 1475 //
     /*  51669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51680 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  51680 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv8i16),
     /*  51685 */     GIR_RootConstrainSelectedInstOperands,
     /*  51686 */     // GIR_Coverage, 1475,
     /*  51686 */     GIR_Done,
     /*  51687 */   // Label 785: @51687
     /*  51687 */   GIM_Reject,
     /*  51688 */ // Label 763: @51688
     /*  51688 */ GIM_Reject,
     /*  51689 */ // Label 599: @51689
     /*  51689 */ GIM_Try, /*On fail goto*//*Label 786*/ GIMT_Encode4(51763),
     /*  51694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  51697 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  51700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51704 */   GIM_Try, /*On fail goto*//*Label 787*/ GIMT_Encode4(51739), // Rule ID 966 //
     /*  51709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51716 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  51722 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  51724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51730 */     // (sub:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn)  =>  (NEGv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /*  51730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv16i8),
     /*  51733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  51737 */     GIR_RootConstrainSelectedInstOperands,
     /*  51738 */     // GIR_Coverage, 966,
     /*  51738 */     GIR_EraseRootFromParent_Done,
     /*  51739 */   // Label 787: @51739
     /*  51739 */   GIM_Try, /*On fail goto*//*Label 788*/ GIMT_Encode4(51762), // Rule ID 1473 //
     /*  51744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51755 */     // (sub:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  51755 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv16i8),
     /*  51760 */     GIR_RootConstrainSelectedInstOperands,
     /*  51761 */     // GIR_Coverage, 1473,
     /*  51761 */     GIR_Done,
     /*  51762 */   // Label 788: @51762
     /*  51762 */   GIM_Reject,
     /*  51763 */ // Label 786: @51763
     /*  51763 */ GIM_Reject,
     /*  51764 */ // Label 600: @51764
     /*  51764 */ GIM_Try, /*On fail goto*//*Label 789*/ GIMT_Encode4(51789), // Rule ID 7529 //
     /*  51769 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  51772 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  51775 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  51778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  51782 */   // (sub:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  51782 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_D),
     /*  51787 */   GIR_RootConstrainSelectedInstOperands,
     /*  51788 */   // GIR_Coverage, 7529,
     /*  51788 */   GIR_Done,
     /*  51789 */ // Label 789: @51789
     /*  51789 */ GIM_Reject,
     /*  51790 */ // Label 601: @51790
     /*  51790 */ GIM_Try, /*On fail goto*//*Label 790*/ GIMT_Encode4(51815), // Rule ID 7528 //
     /*  51795 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  51798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  51801 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  51804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  51808 */   // (sub:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  51808 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_S),
     /*  51813 */   GIR_RootConstrainSelectedInstOperands,
     /*  51814 */   // GIR_Coverage, 7528,
     /*  51814 */   GIR_Done,
     /*  51815 */ // Label 790: @51815
     /*  51815 */ GIM_Reject,
     /*  51816 */ // Label 602: @51816
     /*  51816 */ GIM_Try, /*On fail goto*//*Label 791*/ GIMT_Encode4(51841), // Rule ID 7527 //
     /*  51821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  51824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  51827 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  51830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  51834 */   // (sub:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  51834 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_H),
     /*  51839 */   GIR_RootConstrainSelectedInstOperands,
     /*  51840 */   // GIR_Coverage, 7527,
     /*  51840 */   GIR_Done,
     /*  51841 */ // Label 791: @51841
     /*  51841 */ GIM_Reject,
     /*  51842 */ // Label 603: @51842
     /*  51842 */ GIM_Try, /*On fail goto*//*Label 792*/ GIMT_Encode4(51867), // Rule ID 7526 //
     /*  51847 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  51850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  51853 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  51856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  51860 */   // (sub:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  51860 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_B),
     /*  51865 */   GIR_RootConstrainSelectedInstOperands,
     /*  51866 */   // GIR_Coverage, 7526,
     /*  51866 */   GIR_Done,
     /*  51867 */ // Label 792: @51867
     /*  51867 */ GIM_Reject,
     /*  51868 */ // Label 604: @51868
     /*  51868 */ GIM_Reject,
     /*  51869 */ // Label 2: @51869
     /*  51869 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 801*/ GIMT_Encode4(54633),
     /*  51880 */ /*GILLT_s32*//*Label 793*/ GIMT_Encode4(51920),
     /*  51884 */ /*GILLT_s64*//*Label 794*/ GIMT_Encode4(52077), GIMT_Encode4(0),
     /*  51892 */ /*GILLT_v2s32*//*Label 795*/ GIMT_Encode4(53557), GIMT_Encode4(0),
     /*  51900 */ /*GILLT_v4s16*//*Label 796*/ GIMT_Encode4(53895),
     /*  51904 */ /*GILLT_v4s32*//*Label 797*/ GIMT_Encode4(54233),
     /*  51908 */ /*GILLT_v8s8*//*Label 798*/ GIMT_Encode4(54399),
     /*  51912 */ /*GILLT_v8s16*//*Label 799*/ GIMT_Encode4(54433),
     /*  51916 */ /*GILLT_v16s8*//*Label 800*/ GIMT_Encode4(54599),
     /*  51920 */ // Label 793: @51920
     /*  51920 */ GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(52076),
     /*  51925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  51928 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  51931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51935 */   GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(51990), // Rule ID 3980 //
     /*  51940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  51948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51952 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  51956 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  51960 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51971 */     // (mul:{ *:[i32] } (sub:{ *:[i32] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rn), GPR32:{ *:[i32] }:$Rm)  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  51971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  51974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  51980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  51982 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51988 */     GIR_RootConstrainSelectedInstOperands,
     /*  51989 */     // GIR_Coverage, 3980,
     /*  51989 */     GIR_EraseRootFromParent_Done,
     /*  51990 */   // Label 803: @51990
     /*  51990 */   GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(52045), // Rule ID 13929 //
     /*  51995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  52007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  52011 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  52015 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  52019 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52026 */     // (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, (sub:{ *:[i32] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rn))  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  52026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  52029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  52035 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  52037 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52043 */     GIR_RootConstrainSelectedInstOperands,
     /*  52044 */     // GIR_Coverage, 13929,
     /*  52044 */     GIR_EraseRootFromParent_Done,
     /*  52045 */   // Label 804: @52045
     /*  52045 */   GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(52075), // Rule ID 3976 //
     /*  52050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52058 */     // (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (MADDWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  52058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MADDWrrr),
     /*  52061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52063 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  52067 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52073 */     GIR_RootConstrainSelectedInstOperands,
     /*  52074 */     // GIR_Coverage, 3976,
     /*  52074 */     GIR_EraseRootFromParent_Done,
     /*  52075 */   // Label 805: @52075
     /*  52075 */   GIM_Reject,
     /*  52076 */ // Label 802: @52076
     /*  52076 */ GIM_Reject,
     /*  52077 */ // Label 794: @52077
     /*  52077 */ GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(53556),
     /*  52082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  52085 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  52088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52092 */   GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(52238), // Rule ID 3985 //
     /*  52097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  52105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  52109 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52113 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52118 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*  52129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  52133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  52137 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  52141 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  52145 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52150 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*  52161 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52163 */     // (mul:{ *:[i64] } (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] }), (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, 4294967295:{ *:[i64] }))  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }), XZR:{ *:[i64] })
     /*  52163 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  52166 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52170 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52175 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /*  52181 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52186 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52191 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52194 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52198 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52203 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  52209 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52214 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  52222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52224 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  52227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  52230 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52236 */     GIR_RootConstrainSelectedInstOperands,
     /*  52237 */     // GIR_Coverage, 3985,
     /*  52237 */     GIR_EraseRootFromParent_Done,
     /*  52238 */   // Label 807: @52238
     /*  52238 */   GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(52342), // Rule ID 3986 //
     /*  52243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  52251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  52255 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52259 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52264 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*  52275 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  52279 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  52283 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  52287 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52294 */     // (mul:{ *:[i64] } (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] }), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  52294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52306 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  52312 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52317 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  52325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  52330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  52334 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52340 */     GIR_RootConstrainSelectedInstOperands,
     /*  52341 */     // GIR_Coverage, 3986,
     /*  52341 */     GIR_EraseRootFromParent_Done,
     /*  52342 */   // Label 808: @52342
     /*  52342 */   GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(52446), // Rule ID 13932 //
     /*  52347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  52355 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  52359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  52368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  52372 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  52376 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  52380 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52385 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*  52396 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52398 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm), (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] }))  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  52398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52410 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  52416 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52421 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  52429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  52434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52438 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52444 */     GIR_RootConstrainSelectedInstOperands,
     /*  52445 */     // GIR_Coverage, 13932,
     /*  52445 */     GIR_EraseRootFromParent_Done,
     /*  52446 */   // Label 809: @52446
     /*  52446 */   GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(52501), // Rule ID 3981 //
     /*  52451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  52459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  52463 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52467 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  52471 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52482 */     // (mul:{ *:[i64] } (sub:{ *:[i64] } 0:{ *:[i64] }, GPR64:{ *:[i64] }:$Rn), GPR64:{ *:[i64] }:$Rm)  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  52482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  52485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  52491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  52493 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52499 */     GIR_RootConstrainSelectedInstOperands,
     /*  52500 */     // GIR_Coverage, 3981,
     /*  52500 */     GIR_EraseRootFromParent_Done,
     /*  52501 */   // Label 810: @52501
     /*  52501 */   GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(52556), // Rule ID 13930 //
     /*  52506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  52518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  52522 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52526 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  52530 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52537 */     // (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, (sub:{ *:[i64] } 0:{ *:[i64] }, GPR64:{ *:[i64] }:$Rn))  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  52537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  52540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  52546 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  52548 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52554 */     GIR_RootConstrainSelectedInstOperands,
     /*  52555 */     // GIR_Coverage, 13930,
     /*  52555 */     GIR_EraseRootFromParent_Done,
     /*  52556 */   // Label 811: @52556
     /*  52556 */   GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(52669), // Rule ID 3992 //
     /*  52561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  52569 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  52573 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52578 */     // MIs[1] Operand 2
     /*  52578 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  52589 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  52593 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52597 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  52601 */     // MIs[2] Operand 1
     /*  52601 */     // No operand predicates
     /*  52601 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52603 */     // (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C)  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  52603 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  52606 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  52610 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52615 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  52620 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  52622 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52625 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52629 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52634 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  52640 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52645 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  52653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52655 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  52658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  52661 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52667 */     GIR_RootConstrainSelectedInstOperands,
     /*  52668 */     // GIR_Coverage, 3992,
     /*  52668 */     GIR_EraseRootFromParent_Done,
     /*  52669 */   // Label 812: @52669
     /*  52669 */   GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(52744), // Rule ID 3990 //
     /*  52674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  52682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  52686 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  52695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52699 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  52703 */     // MIs[2] Operand 1
     /*  52703 */     // No operand predicates
     /*  52703 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52705 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  52705 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52708 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  52712 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52717 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  52722 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  52727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  52733 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  52736 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52742 */     GIR_RootConstrainSelectedInstOperands,
     /*  52743 */     // GIR_Coverage, 3990,
     /*  52743 */     GIR_EraseRootFromParent_Done,
     /*  52744 */   // Label 813: @52744
     /*  52744 */   GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(52819), // Rule ID 3991 //
     /*  52749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  52757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  52761 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  52770 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52774 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  52778 */     // MIs[2] Operand 1
     /*  52778 */     // No operand predicates
     /*  52778 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52780 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  52780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  52787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52792 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  52797 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  52802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  52808 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  52811 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52817 */     GIR_RootConstrainSelectedInstOperands,
     /*  52818 */     // GIR_Coverage, 3991,
     /*  52818 */     GIR_EraseRootFromParent_Done,
     /*  52819 */   // Label 814: @52819
     /*  52819 */   GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(52957), // Rule ID 3982 //
     /*  52824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  52832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  52836 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52841 */     // MIs[1] Operand 2
     /*  52841 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  52852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  52856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  52860 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  52864 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52869 */     // MIs[2] Operand 2
     /*  52869 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  52880 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52882 */     // (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, i32:{ *:[Other] }))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }), XZR:{ *:[i64] })
     /*  52882 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  52885 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52889 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52894 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /*  52900 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52905 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52910 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52913 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52917 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52922 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  52928 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52933 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  52941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52943 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  52946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  52949 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52955 */     GIR_RootConstrainSelectedInstOperands,
     /*  52956 */     // GIR_Coverage, 3982,
     /*  52956 */     GIR_EraseRootFromParent_Done,
     /*  52957 */   // Label 815: @52957
     /*  52957 */   GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(53057), // Rule ID 3983 //
     /*  52962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  52970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  52974 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52979 */     // MIs[1] Operand 2
     /*  52979 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  52990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  52994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  52998 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  53002 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53007 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53009 */     // (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  53009 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53012 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53016 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53021 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  53027 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53032 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  53040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53042 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  53049 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53055 */     GIR_RootConstrainSelectedInstOperands,
     /*  53056 */     // GIR_Coverage, 3983,
     /*  53056 */     GIR_EraseRootFromParent_Done,
     /*  53057 */   // Label 816: @53057
     /*  53057 */   GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(53157), // Rule ID 13931 //
     /*  53062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  53070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  53083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  53087 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  53091 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53096 */     // MIs[2] Operand 2
     /*  53096 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  53107 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53109 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm), (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  53109 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53112 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53116 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53121 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  53127 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53132 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  53140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53142 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53149 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53155 */     GIR_RootConstrainSelectedInstOperands,
     /*  53156 */     // GIR_Coverage, 13931,
     /*  53156 */     GIR_EraseRootFromParent_Done,
     /*  53157 */   // Label 817: @53157
     /*  53157 */   GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(53219), // Rule ID 3984 //
     /*  53162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  53170 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53174 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53179 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  53183 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  53187 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  53191 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53196 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53198 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  53198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  53201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  53207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  53211 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53217 */     GIR_RootConstrainSelectedInstOperands,
     /*  53218 */     // GIR_Coverage, 3984,
     /*  53218 */     GIR_EraseRootFromParent_Done,
     /*  53219 */   // Label 818: @53219
     /*  53219 */   GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(53281), // Rule ID 3987 //
     /*  53224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  53232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53236 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  53245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  53249 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  53253 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53258 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53260 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  53260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  53263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  53269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  53273 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53279 */     GIR_RootConstrainSelectedInstOperands,
     /*  53280 */     // GIR_Coverage, 3987,
     /*  53280 */     GIR_EraseRootFromParent_Done,
     /*  53281 */   // Label 819: @53281
     /*  53281 */   GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(53358), // Rule ID 4011 //
     /*  53286 */     GIM_CheckLeafOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  53291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  53299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53303 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53310 */     // (mul:{ *:[i64] } GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  53310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53322 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  53328 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53333 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  53341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53343 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53350 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53356 */     GIR_RootConstrainSelectedInstOperands,
     /*  53357 */     // GIR_Coverage, 4011,
     /*  53357 */     GIR_EraseRootFromParent_Done,
     /*  53358 */   // Label 820: @53358
     /*  53358 */   GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(53435), // Rule ID 13943 //
     /*  53363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  53371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53380 */     GIM_CheckLeafOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  53385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53387 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm), GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn)  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  53387 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53390 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53394 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53399 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  53405 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53410 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  53418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53427 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53433 */     GIR_RootConstrainSelectedInstOperands,
     /*  53434 */     // GIR_Coverage, 13943,
     /*  53434 */     GIR_EraseRootFromParent_Done,
     /*  53435 */   // Label 821: @53435
     /*  53435 */   GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(53525), // Rule ID 4010 //
     /*  53440 */     GIM_CheckLeafOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  53445 */     GIM_CheckLeafOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  53450 */     // (mul:{ *:[i64] } GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn, GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rm)  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }), XZR:{ *:[i64] })
     /*  53450 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  53453 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53457 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53462 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /*  53468 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53473 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53490 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  53496 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53501 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  53509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53511 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  53517 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53523 */     GIR_RootConstrainSelectedInstOperands,
     /*  53524 */     // GIR_Coverage, 4010,
     /*  53524 */     GIR_EraseRootFromParent_Done,
     /*  53525 */   // Label 822: @53525
     /*  53525 */   GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(53555), // Rule ID 3977 //
     /*  53530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53538 */     // (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (MADDXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  53538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MADDXrrr),
     /*  53541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53543 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  53547 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53553 */     GIR_RootConstrainSelectedInstOperands,
     /*  53554 */     // GIR_Coverage, 3977,
     /*  53554 */     GIR_EraseRootFromParent_Done,
     /*  53555 */   // Label 823: @53555
     /*  53555 */   GIM_Reject,
     /*  53556 */ // Label 806: @53556
     /*  53556 */ GIM_Reject,
     /*  53557 */ // Label 795: @53557
     /*  53557 */ GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(53894),
     /*  53562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  53565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  53572 */   GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(53658), // Rule ID 13614 //
     /*  53577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  53588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  53592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  53596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  53600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  53604 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  53608 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53613 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  53617 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53621 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  53625 */     // MIs[3] Operand 1
     /*  53625 */     // No operand predicates
     /*  53625 */     // MIs[1] Operand 2
     /*  53625 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  53636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  53640 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  53642 */     // (mul:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  53642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  53645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  53653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  53656 */     GIR_RootConstrainSelectedInstOperands,
     /*  53657 */     // GIR_Coverage, 13614,
     /*  53657 */     GIR_EraseRootFromParent_Done,
     /*  53658 */   // Label 825: @53658
     /*  53658 */   GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(53744), // Rule ID 2034 //
     /*  53663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  53670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  53678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  53682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  53686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  53690 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  53694 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  53698 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53703 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  53707 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53711 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  53715 */     // MIs[3] Operand 1
     /*  53715 */     // No operand predicates
     /*  53715 */     // MIs[1] Operand 2
     /*  53715 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  53726 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  53728 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  53728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  53731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53733 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  53739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  53742 */     GIR_RootConstrainSelectedInstOperands,
     /*  53743 */     // GIR_Coverage, 2034,
     /*  53743 */     GIR_EraseRootFromParent_Done,
     /*  53744 */   // Label 826: @53744
     /*  53744 */   GIM_Try, /*On fail goto*//*Label 827*/ GIMT_Encode4(53807), // Rule ID 13615 //
     /*  53749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  53760 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  53764 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53768 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53773 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53777 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53781 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  53785 */     // MIs[2] Operand 1
     /*  53785 */     // No operand predicates
     /*  53785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  53789 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53791 */     // (mul:{ *:[v2i32] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  53791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  53794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53802 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  53805 */     GIR_RootConstrainSelectedInstOperands,
     /*  53806 */     // GIR_Coverage, 13615,
     /*  53806 */     GIR_EraseRootFromParent_Done,
     /*  53807 */   // Label 827: @53807
     /*  53807 */   GIM_Try, /*On fail goto*//*Label 828*/ GIMT_Encode4(53870), // Rule ID 2035 //
     /*  53812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  53819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  53827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  53831 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53835 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53848 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  53852 */     // MIs[2] Operand 1
     /*  53852 */     // No operand predicates
     /*  53852 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53854 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  53854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  53857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53859 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53865 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  53868 */     GIR_RootConstrainSelectedInstOperands,
     /*  53869 */     // GIR_Coverage, 2035,
     /*  53869 */     GIR_EraseRootFromParent_Done,
     /*  53870 */   // Label 828: @53870
     /*  53870 */   GIM_Try, /*On fail goto*//*Label 829*/ GIMT_Encode4(53893), // Rule ID 1352 //
     /*  53875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  53882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  53886 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (MULv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  53886 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32),
     /*  53891 */     GIR_RootConstrainSelectedInstOperands,
     /*  53892 */     // GIR_Coverage, 1352,
     /*  53892 */     GIR_Done,
     /*  53893 */   // Label 829: @53893
     /*  53893 */   GIM_Reject,
     /*  53894 */ // Label 824: @53894
     /*  53894 */ GIM_Reject,
     /*  53895 */ // Label 796: @53895
     /*  53895 */ GIM_Try, /*On fail goto*//*Label 830*/ GIMT_Encode4(54232),
     /*  53900 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  53903 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  53910 */   GIM_Try, /*On fail goto*//*Label 831*/ GIMT_Encode4(53996), // Rule ID 13611 //
     /*  53915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  53926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  53930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  53934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  53938 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  53942 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  53946 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  53951 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  53955 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53959 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  53963 */     // MIs[3] Operand 1
     /*  53963 */     // No operand predicates
     /*  53963 */     // MIs[1] Operand 2
     /*  53963 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  53974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  53978 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  53980 */     // (mul:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  53980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  53983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  53991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  53994 */     GIR_RootConstrainSelectedInstOperands,
     /*  53995 */     // GIR_Coverage, 13611,
     /*  53995 */     GIR_EraseRootFromParent_Done,
     /*  53996 */   // Label 831: @53996
     /*  53996 */   GIM_Try, /*On fail goto*//*Label 832*/ GIMT_Encode4(54082), // Rule ID 2031 //
     /*  54001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  54016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  54020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  54028 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  54032 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  54036 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  54041 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  54045 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  54049 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  54053 */     // MIs[3] Operand 1
     /*  54053 */     // No operand predicates
     /*  54053 */     // MIs[1] Operand 2
     /*  54053 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  54064 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54066 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  54066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  54069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54071 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  54073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  54077 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  54080 */     GIR_RootConstrainSelectedInstOperands,
     /*  54081 */     // GIR_Coverage, 2031,
     /*  54081 */     GIR_EraseRootFromParent_Done,
     /*  54082 */   // Label 832: @54082
     /*  54082 */   GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(54145), // Rule ID 13612 //
     /*  54087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  54098 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  54102 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  54111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  54119 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  54123 */     // MIs[2] Operand 1
     /*  54123 */     // No operand predicates
     /*  54123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54127 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54129 */     // (mul:{ *:[v4i16] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  54129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  54132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  54136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  54140 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  54143 */     GIR_RootConstrainSelectedInstOperands,
     /*  54144 */     // GIR_Coverage, 13612,
     /*  54144 */     GIR_EraseRootFromParent_Done,
     /*  54145 */   // Label 833: @54145
     /*  54145 */   GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(54208), // Rule ID 2032 //
     /*  54150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  54165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  54169 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54173 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  54178 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54182 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  54186 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  54190 */     // MIs[2] Operand 1
     /*  54190 */     // No operand predicates
     /*  54190 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54192 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  54192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  54195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54197 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  54199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  54203 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  54206 */     GIR_RootConstrainSelectedInstOperands,
     /*  54207 */     // GIR_Coverage, 2032,
     /*  54207 */     GIR_EraseRootFromParent_Done,
     /*  54208 */   // Label 834: @54208
     /*  54208 */   GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(54231), // Rule ID 1350 //
     /*  54213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54224 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (MULv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  54224 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16),
     /*  54229 */     GIR_RootConstrainSelectedInstOperands,
     /*  54230 */     // GIR_Coverage, 1350,
     /*  54230 */     GIR_Done,
     /*  54231 */   // Label 835: @54231
     /*  54231 */   GIM_Reject,
     /*  54232 */ // Label 830: @54232
     /*  54232 */ GIM_Reject,
     /*  54233 */ // Label 797: @54233
     /*  54233 */ GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(54398),
     /*  54238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54241 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54248 */   GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(54311), // Rule ID 13616 //
     /*  54253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  54264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54272 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  54285 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  54289 */     // MIs[2] Operand 1
     /*  54289 */     // No operand predicates
     /*  54289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54293 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54295 */     // (mul:{ *:[v4i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4i32] }:$Rn)  =>  (MULv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  54295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32_indexed),
     /*  54298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  54302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  54306 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  54309 */     GIR_RootConstrainSelectedInstOperands,
     /*  54310 */     // GIR_Coverage, 13616,
     /*  54310 */     GIR_EraseRootFromParent_Done,
     /*  54311 */   // Label 837: @54311
     /*  54311 */   GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(54374), // Rule ID 2036 //
     /*  54316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  54331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54335 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54339 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  54352 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  54356 */     // MIs[2] Operand 1
     /*  54356 */     // No operand predicates
     /*  54356 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54358 */     // (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (MULv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  54358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32_indexed),
     /*  54361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54363 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  54365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  54369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  54372 */     GIR_RootConstrainSelectedInstOperands,
     /*  54373 */     // GIR_Coverage, 2036,
     /*  54373 */     GIR_EraseRootFromParent_Done,
     /*  54374 */   // Label 838: @54374
     /*  54374 */   GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(54397), // Rule ID 1353 //
     /*  54379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54390 */     // (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (MULv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  54390 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32),
     /*  54395 */     GIR_RootConstrainSelectedInstOperands,
     /*  54396 */     // GIR_Coverage, 1353,
     /*  54396 */     GIR_Done,
     /*  54397 */   // Label 839: @54397
     /*  54397 */   GIM_Reject,
     /*  54398 */ // Label 836: @54398
     /*  54398 */ GIM_Reject,
     /*  54399 */ // Label 798: @54399
     /*  54399 */ GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(54432), // Rule ID 1348 //
     /*  54404 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  54410 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  54413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54417 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54421 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54425 */   // (mul:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (MULv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  54425 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv8i8),
     /*  54430 */   GIR_RootConstrainSelectedInstOperands,
     /*  54431 */   // GIR_Coverage, 1348,
     /*  54431 */   GIR_Done,
     /*  54432 */ // Label 840: @54432
     /*  54432 */ GIM_Reject,
     /*  54433 */ // Label 799: @54433
     /*  54433 */ GIM_Try, /*On fail goto*//*Label 841*/ GIMT_Encode4(54598),
     /*  54438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  54441 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  54444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54448 */   GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(54511), // Rule ID 13613 //
     /*  54453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  54464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  54468 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54472 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  54477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  54485 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  54489 */     // MIs[2] Operand 1
     /*  54489 */     // No operand predicates
     /*  54489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54493 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54495 */     // (mul:{ *:[v8i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8i16] }:$Rn)  =>  (MULv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  54495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16_indexed),
     /*  54498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  54502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  54506 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  54509 */     GIR_RootConstrainSelectedInstOperands,
     /*  54510 */     // GIR_Coverage, 13613,
     /*  54510 */     GIR_EraseRootFromParent_Done,
     /*  54511 */   // Label 842: @54511
     /*  54511 */   GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(54574), // Rule ID 2033 //
     /*  54516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  54531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  54535 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54539 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  54544 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54548 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  54552 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  54556 */     // MIs[2] Operand 1
     /*  54556 */     // No operand predicates
     /*  54556 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54558 */     // (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (MULv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  54558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16_indexed),
     /*  54561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54563 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  54565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  54569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  54572 */     GIR_RootConstrainSelectedInstOperands,
     /*  54573 */     // GIR_Coverage, 2033,
     /*  54573 */     GIR_EraseRootFromParent_Done,
     /*  54574 */   // Label 843: @54574
     /*  54574 */   GIM_Try, /*On fail goto*//*Label 844*/ GIMT_Encode4(54597), // Rule ID 1351 //
     /*  54579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54590 */     // (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (MULv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  54590 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16),
     /*  54595 */     GIR_RootConstrainSelectedInstOperands,
     /*  54596 */     // GIR_Coverage, 1351,
     /*  54596 */     GIR_Done,
     /*  54597 */   // Label 844: @54597
     /*  54597 */   GIM_Reject,
     /*  54598 */ // Label 841: @54598
     /*  54598 */ GIM_Reject,
     /*  54599 */ // Label 800: @54599
     /*  54599 */ GIM_Try, /*On fail goto*//*Label 845*/ GIMT_Encode4(54632), // Rule ID 1349 //
     /*  54604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  54610 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  54613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54617 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54621 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54625 */   // (mul:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (MULv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  54625 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv16i8),
     /*  54630 */   GIR_RootConstrainSelectedInstOperands,
     /*  54631 */   // GIR_Coverage, 1349,
     /*  54631 */   GIR_Done,
     /*  54632 */ // Label 845: @54632
     /*  54632 */ GIM_Reject,
     /*  54633 */ // Label 801: @54633
     /*  54633 */ GIM_Reject,
     /*  54634 */ // Label 3: @54634
     /*  54634 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 848*/ GIMT_Encode4(54715),
     /*  54645 */ /*GILLT_s32*//*Label 846*/ GIMT_Encode4(54653),
     /*  54649 */ /*GILLT_s64*//*Label 847*/ GIMT_Encode4(54684),
     /*  54653 */ // Label 846: @54653
     /*  54653 */ GIM_Try, /*On fail goto*//*Label 849*/ GIMT_Encode4(54683), // Rule ID 117 //
     /*  54658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  54661 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  54664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54668 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54672 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54676 */   // (sdiv:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  54676 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDIVWr),
     /*  54681 */   GIR_RootConstrainSelectedInstOperands,
     /*  54682 */   // GIR_Coverage, 117,
     /*  54682 */   GIR_Done,
     /*  54683 */ // Label 849: @54683
     /*  54683 */ GIM_Reject,
     /*  54684 */ // Label 847: @54684
     /*  54684 */ GIM_Try, /*On fail goto*//*Label 850*/ GIMT_Encode4(54714), // Rule ID 118 //
     /*  54689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  54692 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  54695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54703 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54707 */   // (sdiv:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  54707 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDIVXr),
     /*  54712 */   GIR_RootConstrainSelectedInstOperands,
     /*  54713 */   // GIR_Coverage, 118,
     /*  54713 */   GIR_Done,
     /*  54714 */ // Label 850: @54714
     /*  54714 */ GIM_Reject,
     /*  54715 */ // Label 848: @54715
     /*  54715 */ GIM_Reject,
     /*  54716 */ // Label 4: @54716
     /*  54716 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 853*/ GIMT_Encode4(54797),
     /*  54727 */ /*GILLT_s32*//*Label 851*/ GIMT_Encode4(54735),
     /*  54731 */ /*GILLT_s64*//*Label 852*/ GIMT_Encode4(54766),
     /*  54735 */ // Label 851: @54735
     /*  54735 */ GIM_Try, /*On fail goto*//*Label 854*/ GIMT_Encode4(54765), // Rule ID 115 //
     /*  54740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  54743 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  54746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54750 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54754 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54758 */   // (udiv:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  54758 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDIVWr),
     /*  54763 */   GIR_RootConstrainSelectedInstOperands,
     /*  54764 */   // GIR_Coverage, 115,
     /*  54764 */   GIR_Done,
     /*  54765 */ // Label 854: @54765
     /*  54765 */ GIM_Reject,
     /*  54766 */ // Label 852: @54766
     /*  54766 */ GIM_Try, /*On fail goto*//*Label 855*/ GIMT_Encode4(54796), // Rule ID 116 //
     /*  54771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  54774 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  54777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54785 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54789 */   // (udiv:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  54789 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDIVXr),
     /*  54794 */   GIR_RootConstrainSelectedInstOperands,
     /*  54795 */   // GIR_Coverage, 116,
     /*  54795 */   GIR_Done,
     /*  54796 */ // Label 855: @54796
     /*  54796 */ GIM_Reject,
     /*  54797 */ // Label 853: @54797
     /*  54797 */ GIM_Reject,
     /*  54798 */ // Label 5: @54798
     /*  54798 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 874*/ GIMT_Encode4(62543),
     /*  54809 */ /*GILLT_s32*//*Label 856*/ GIMT_Encode4(54897),
     /*  54813 */ /*GILLT_s64*//*Label 857*/ GIMT_Encode4(55395), GIMT_Encode4(0),
     /*  54821 */ /*GILLT_v2s32*//*Label 858*/ GIMT_Encode4(56830),
     /*  54825 */ /*GILLT_v2s64*//*Label 859*/ GIMT_Encode4(56990),
     /*  54829 */ /*GILLT_v4s16*//*Label 860*/ GIMT_Encode4(57150),
     /*  54833 */ /*GILLT_v4s32*//*Label 861*/ GIMT_Encode4(57310),
     /*  54837 */ /*GILLT_v8s8*//*Label 862*/ GIMT_Encode4(57470),
     /*  54841 */ /*GILLT_v8s16*//*Label 863*/ GIMT_Encode4(57630),
     /*  54845 */ /*GILLT_v16s8*//*Label 864*/ GIMT_Encode4(57790),
     /*  54849 */ /*GILLT_nxv1s1*//*Label 865*/ GIMT_Encode4(57950),
     /*  54853 */ /*GILLT_nxv2s1*//*Label 866*/ GIMT_Encode4(58491), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  54865 */ /*GILLT_nxv2s64*//*Label 867*/ GIMT_Encode4(59032),
     /*  54869 */ /*GILLT_nxv4s1*//*Label 868*/ GIMT_Encode4(59504), GIMT_Encode4(0),
     /*  54877 */ /*GILLT_nxv4s32*//*Label 869*/ GIMT_Encode4(60045),
     /*  54881 */ /*GILLT_nxv8s1*//*Label 870*/ GIMT_Encode4(60517),
     /*  54885 */ /*GILLT_nxv8s16*//*Label 871*/ GIMT_Encode4(61058),
     /*  54889 */ /*GILLT_nxv16s1*//*Label 872*/ GIMT_Encode4(61530),
     /*  54893 */ /*GILLT_nxv16s8*//*Label 873*/ GIMT_Encode4(62071),
     /*  54897 */ // Label 856: @54897
     /*  54897 */ GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(55394),
     /*  54902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  54905 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  54908 */   GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(54963), // Rule ID 13369 //
     /*  54913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  54929 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  54933 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54943 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  54950 */     // (and:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (BICWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  54950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrs),
     /*  54953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  54957 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  54961 */     GIR_RootConstrainSelectedInstOperands,
     /*  54962 */     // GIR_Coverage, 13369,
     /*  54962 */     GIR_EraseRootFromParent_Done,
     /*  54963 */   // Label 876: @54963
     /*  54963 */   GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(55018), // Rule ID 162 //
     /*  54968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  54988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  54992 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54996 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54998 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  55005 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (BICWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  55005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrs),
     /*  55008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55010 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  55012 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  55016 */     GIR_RootConstrainSelectedInstOperands,
     /*  55017 */     // GIR_Coverage, 162,
     /*  55017 */     GIR_EraseRootFromParent_Done,
     /*  55018 */   // Label 877: @55018
     /*  55018 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(55087), // Rule ID 5702 //
     /*  55023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  55035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  55039 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  55043 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  55056 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /*  55060 */     // MIs[2] Operand 1
     /*  55060 */     // No operand predicates
     /*  55060 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  55071 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55073 */     // (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), 255:{ *:[i32] })  =>  (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /*  55073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /*  55076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  55082 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  55085 */     GIR_RootConstrainSelectedInstOperands,
     /*  55086 */     // GIR_Coverage, 5702,
     /*  55086 */     GIR_EraseRootFromParent_Done,
     /*  55087 */   // Label 878: @55087
     /*  55087 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(55156), // Rule ID 5703 //
     /*  55092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  55104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  55108 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  55112 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  55125 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  55129 */     // MIs[2] Operand 1
     /*  55129 */     // No operand predicates
     /*  55129 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  55140 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55142 */     // (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 65535:{ *:[i32] })  =>  (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /*  55142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /*  55145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  55151 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  55154 */     GIR_RootConstrainSelectedInstOperands,
     /*  55155 */     // GIR_Coverage, 5703,
     /*  55155 */     GIR_EraseRootFromParent_Done,
     /*  55156 */   // Label 879: @55156
     /*  55156 */   GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(55209), // Rule ID 13367 //
     /*  55161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  55177 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  55181 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55186 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  55190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  55196 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (BICWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  55196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrr),
     /*  55199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  55203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  55207 */     GIR_RootConstrainSelectedInstOperands,
     /*  55208 */     // GIR_Coverage, 13367,
     /*  55208 */     GIR_EraseRootFromParent_Done,
     /*  55209 */   // Label 880: @55209
     /*  55209 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(55262), // Rule ID 160 //
     /*  55214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  55234 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  55238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55243 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  55247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  55249 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (BICWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  55249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrr),
     /*  55252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55254 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  55256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  55260 */     GIR_RootConstrainSelectedInstOperands,
     /*  55261 */     // GIR_Coverage, 160,
     /*  55261 */     GIR_EraseRootFromParent_Done,
     /*  55262 */   // Label 881: @55262
     /*  55262 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(55303), // Rule ID 142 //
     /*  55267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  55271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  55283 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  55287 */     // MIs[1] Operand 1
     /*  55287 */     // No operand predicates
     /*  55287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  55289 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (ANDWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  55289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWri),
     /*  55292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55294 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  55296 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  55301 */     GIR_RootConstrainSelectedInstOperands,
     /*  55302 */     // GIR_Coverage, 142,
     /*  55302 */     GIR_EraseRootFromParent_Done,
     /*  55303 */   // Label 882: @55303
     /*  55303 */   GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(55336), // Rule ID 13365 //
     /*  55308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  55323 */     // (and:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ANDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  55323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWrs),
     /*  55326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  55330 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  55334 */     GIR_RootConstrainSelectedInstOperands,
     /*  55335 */     // GIR_Coverage, 13365,
     /*  55335 */     GIR_EraseRootFromParent_Done,
     /*  55336 */   // Label 883: @55336
     /*  55336 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(55369), // Rule ID 158 //
     /*  55341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  55356 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ANDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  55356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWrs),
     /*  55359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55361 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  55363 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  55367 */     GIR_RootConstrainSelectedInstOperands,
     /*  55368 */     // GIR_Coverage, 158,
     /*  55368 */     GIR_EraseRootFromParent_Done,
     /*  55369 */   // Label 884: @55369
     /*  55369 */   GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(55393), // Rule ID 156 //
     /*  55374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55386 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ANDWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  55386 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDWrr),
     /*  55391 */     GIR_RootConstrainSelectedInstOperands,
     /*  55392 */     // GIR_Coverage, 156,
     /*  55392 */     GIR_Done,
     /*  55393 */   // Label 885: @55393
     /*  55393 */   GIM_Reject,
     /*  55394 */ // Label 875: @55394
     /*  55394 */ GIM_Reject,
     /*  55395 */ // Label 857: @55395
     /*  55395 */ GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(56829),
     /*  55400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  55403 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  55406 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(55461), // Rule ID 13370 //
     /*  55411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  55427 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  55431 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  55435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  55441 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  55448 */     // (and:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (BICXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  55448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrs),
     /*  55451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  55455 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  55459 */     GIR_RootConstrainSelectedInstOperands,
     /*  55460 */     // GIR_Coverage, 13370,
     /*  55460 */     GIR_EraseRootFromParent_Done,
     /*  55461 */   // Label 887: @55461
     /*  55461 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(55516), // Rule ID 163 //
     /*  55466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  55486 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  55490 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  55494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  55496 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  55503 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (BICXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  55503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrs),
     /*  55506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55508 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  55510 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  55514 */     GIR_RootConstrainSelectedInstOperands,
     /*  55515 */     // GIR_Coverage, 163,
     /*  55515 */     GIR_EraseRootFromParent_Done,
     /*  55516 */   // Label 888: @55516
     /*  55516 */   GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(55629), // Rule ID 5704 //
     /*  55521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  55525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  55533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  55537 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55541 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  55545 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  55549 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  55553 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55558 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  55562 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  55566 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /*  55570 */     // MIs[3] Operand 1
     /*  55570 */     // No operand predicates
     /*  55570 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  55581 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55583 */     // (and:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)), 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), sub_32:{ *:[i32] })
     /*  55583 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  55586 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /*  55590 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55595 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  55599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // idx
     /*  55602 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  55604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  55607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  55612 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  55615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  55618 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  55623 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55628 */     // GIR_Coverage, 5704,
     /*  55628 */     GIR_EraseRootFromParent_Done,
     /*  55629 */   // Label 889: @55629
     /*  55629 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(55742), // Rule ID 5705 //
     /*  55634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  55638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  55646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  55650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  55658 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  55662 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  55666 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55671 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  55675 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  55679 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  55683 */     // MIs[3] Operand 1
     /*  55683 */     // No operand predicates
     /*  55683 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  55694 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55696 */     // (and:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), sub_32:{ *:[i32] })
     /*  55696 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  55699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /*  55703 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55708 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  55712 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // idx
     /*  55715 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  55717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  55720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  55725 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  55728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  55731 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  55736 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55741 */     // GIR_Coverage, 5705,
     /*  55741 */     GIR_EraseRootFromParent_Done,
     /*  55742 */   // Label 890: @55742
     /*  55742 */   GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(55841), // Rule ID 7178 //
     /*  55747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  55751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  55759 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  55762 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  55767 */     // MIs[1] addr
     /*  55767 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  55771 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  55776 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_1),
     /*  55780 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  55791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  55793 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 576:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_1>>, 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  55793 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  55796 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRB),
     /*  55800 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55805 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  55809 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  55814 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  55816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  55819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  55824 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  55827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  55830 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  55835 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55840 */     // GIR_Coverage, 7178,
     /*  55840 */     GIR_EraseRootFromParent_Done,
     /*  55841 */   // Label 891: @55841
     /*  55841 */   GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(55940), // Rule ID 7179 //
     /*  55846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  55850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  55858 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  55861 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  55866 */     // MIs[1] addr
     /*  55866 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  55870 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  55875 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_2),
     /*  55879 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  55890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  55892 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 576:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_2>>, 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  55892 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  55895 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRH),
     /*  55899 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55904 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  55908 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  55913 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  55915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  55918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  55923 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  55926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  55929 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  55934 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55939 */     // GIR_Coverage, 7179,
     /*  55939 */     GIR_EraseRootFromParent_Done,
     /*  55940 */   // Label 892: @55940
     /*  55940 */   GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(56039), // Rule ID 7180 //
     /*  55945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  55949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  55957 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  55960 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  55965 */     // MIs[1] addr
     /*  55965 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  55969 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  55974 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_4),
     /*  55978 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  55989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  55991 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 576:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_4>>, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  55991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  55994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRW),
     /*  55998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56003 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  56007 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  56012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  56014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  56017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  56022 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  56028 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  56033 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  56038 */     // GIR_Coverage, 7180,
     /*  56038 */     GIR_EraseRootFromParent_Done,
     /*  56039 */   // Label 893: @56039
     /*  56039 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(56138), // Rule ID 7185 //
     /*  56044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  56048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  56056 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  56059 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  56064 */     // MIs[1] addr
     /*  56064 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  56068 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  56073 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_1),
     /*  56077 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  56088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56090 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 573:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_1>>, 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  56090 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  56093 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRB),
     /*  56097 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56102 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  56106 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  56111 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  56113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  56116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  56121 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  56127 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  56132 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  56137 */     // GIR_Coverage, 7185,
     /*  56137 */     GIR_EraseRootFromParent_Done,
     /*  56138 */   // Label 894: @56138
     /*  56138 */   GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(56237), // Rule ID 7186 //
     /*  56143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  56147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  56155 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  56158 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  56163 */     // MIs[1] addr
     /*  56163 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  56167 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  56172 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_2),
     /*  56176 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  56187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56189 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 573:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_2>>, 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  56189 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  56192 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRH),
     /*  56196 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56201 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  56205 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  56210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  56212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  56215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  56220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  56226 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  56231 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  56236 */     // GIR_Coverage, 7186,
     /*  56236 */     GIR_EraseRootFromParent_Done,
     /*  56237 */   // Label 895: @56237
     /*  56237 */   GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(56336), // Rule ID 7187 //
     /*  56242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  56246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  56254 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  56257 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  56262 */     // MIs[1] addr
     /*  56262 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  56266 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  56271 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_4),
     /*  56275 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  56286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56288 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 573:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_4>>, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  56288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  56291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRW),
     /*  56295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56300 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  56304 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  56309 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  56311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  56314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  56319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  56325 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  56330 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  56335 */     // GIR_Coverage, 7187,
     /*  56335 */     GIR_EraseRootFromParent_Done,
     /*  56336 */   // Label 896: @56336
     /*  56336 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(56389), // Rule ID 13368 //
     /*  56341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  56357 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  56361 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56366 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  56370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56376 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (BICXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  56376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrr),
     /*  56379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  56383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  56387 */     GIR_RootConstrainSelectedInstOperands,
     /*  56388 */     // GIR_Coverage, 13368,
     /*  56388 */     GIR_EraseRootFromParent_Done,
     /*  56389 */   // Label 897: @56389
     /*  56389 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(56442), // Rule ID 161 //
     /*  56394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  56414 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  56418 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56423 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  56427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56429 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }))  =>  (BICXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  56429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrr),
     /*  56432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56434 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  56436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  56440 */     GIR_RootConstrainSelectedInstOperands,
     /*  56441 */     // GIR_Coverage, 161,
     /*  56441 */     GIR_EraseRootFromParent_Done,
     /*  56442 */   // Label 898: @56442
     /*  56442 */   GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(56542), // Rule ID 4029 //
     /*  56447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  56451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56455 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  56466 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (ORRWrr:{ *:[i32] } WZR:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  56466 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  56469 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  56473 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56478 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  56484 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  56489 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  56497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORRWrr),
     /*  56501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56506 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56512 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  56515 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  56517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  56520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  56525 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  56531 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  56536 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  56541 */     // GIR_Coverage, 4029,
     /*  56541 */     GIR_EraseRootFromParent_Done,
     /*  56542 */   // Label 899: @56542
     /*  56542 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(56583), // Rule ID 143 //
     /*  56547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  56551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  56563 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  56567 */     // MIs[1] Operand 1
     /*  56567 */     // No operand predicates
     /*  56567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56569 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (ANDXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  56569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXri),
     /*  56572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56574 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  56576 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  56581 */     GIR_RootConstrainSelectedInstOperands,
     /*  56582 */     // GIR_Coverage, 143,
     /*  56582 */     GIR_EraseRootFromParent_Done,
     /*  56583 */   // Label 900: @56583
     /*  56583 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(56616), // Rule ID 13366 //
     /*  56588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  56603 */     // (and:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ANDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  56603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXrs),
     /*  56606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  56610 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  56614 */     GIR_RootConstrainSelectedInstOperands,
     /*  56615 */     // GIR_Coverage, 13366,
     /*  56615 */     GIR_EraseRootFromParent_Done,
     /*  56616 */   // Label 901: @56616
     /*  56616 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(56649), // Rule ID 159 //
     /*  56621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  56636 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ANDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  56636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXrs),
     /*  56639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56641 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  56643 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  56647 */     GIR_RootConstrainSelectedInstOperands,
     /*  56648 */     // GIR_Coverage, 159,
     /*  56648 */     GIR_EraseRootFromParent_Done,
     /*  56649 */   // Label 902: @56649
     /*  56649 */   GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(56713), // Rule ID 14037 //
     /*  56654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  56673 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  56677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56686 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56692 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56698 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56700 */     // (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$LHS)  =>  (BICv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  56700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  56703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56705 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  56707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  56711 */     GIR_RootConstrainSelectedInstOperands,
     /*  56712 */     // GIR_Coverage, 14037,
     /*  56712 */     GIR_EraseRootFromParent_Done,
     /*  56713 */   // Label 903: @56713
     /*  56713 */   GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(56777), // Rule ID 5084 //
     /*  56718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  56741 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  56745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56750 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56754 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56760 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56762 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56764 */     // (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }))  =>  (BICv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  56764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  56767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56769 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  56771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  56775 */     GIR_RootConstrainSelectedInstOperands,
     /*  56776 */     // GIR_Coverage, 5084,
     /*  56776 */     GIR_EraseRootFromParent_Done,
     /*  56777 */   // Label 904: @56777
     /*  56777 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(56801), // Rule ID 157 //
     /*  56782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56794 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ANDXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  56794 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDXrr),
     /*  56799 */     GIR_RootConstrainSelectedInstOperands,
     /*  56800 */     // GIR_Coverage, 157,
     /*  56800 */     GIR_Done,
     /*  56801 */   // Label 905: @56801
     /*  56801 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(56828), // Rule ID 2480 //
     /*  56806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56821 */     // (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (ANDv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  56821 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  56826 */     GIR_RootConstrainSelectedInstOperands,
     /*  56827 */     // GIR_Coverage, 2480,
     /*  56827 */     GIR_Done,
     /*  56828 */   // Label 906: @56828
     /*  56828 */   GIM_Reject,
     /*  56829 */ // Label 886: @56829
     /*  56829 */ GIM_Reject,
     /*  56830 */ // Label 858: @56830
     /*  56830 */ GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(56989),
     /*  56835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  56838 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  56841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56845 */   GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(56905), // Rule ID 14036 //
     /*  56850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  56865 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  56869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56878 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56884 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56890 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56892 */     // (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$LHS)  =>  (BICv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  56892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  56895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56897 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  56899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  56903 */     GIR_RootConstrainSelectedInstOperands,
     /*  56904 */     // GIR_Coverage, 14036,
     /*  56904 */     GIR_EraseRootFromParent_Done,
     /*  56905 */   // Label 908: @56905
     /*  56905 */   GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(56965), // Rule ID 5083 //
     /*  56910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  56929 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  56933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56942 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56948 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56950 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56952 */     // (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }))  =>  (BICv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  56952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  56955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56957 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  56959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  56963 */     GIR_RootConstrainSelectedInstOperands,
     /*  56964 */     // GIR_Coverage, 5083,
     /*  56964 */     GIR_EraseRootFromParent_Done,
     /*  56965 */   // Label 909: @56965
     /*  56965 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(56988), // Rule ID 2479 //
     /*  56970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56981 */     // (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (ANDv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  56981 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  56986 */     GIR_RootConstrainSelectedInstOperands,
     /*  56987 */     // GIR_Coverage, 2479,
     /*  56987 */     GIR_Done,
     /*  56988 */   // Label 910: @56988
     /*  56988 */   GIM_Reject,
     /*  56989 */ // Label 907: @56989
     /*  56989 */ GIM_Reject,
     /*  56990 */ // Label 859: @56990
     /*  56990 */ GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(57149),
     /*  56995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  56998 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  57001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57005 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(57065), // Rule ID 14040 //
     /*  57010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  57025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  57029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57038 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57044 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57050 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57052 */     // (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$LHS)  =>  (BICv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  57052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  57055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57057 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  57059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  57063 */     GIR_RootConstrainSelectedInstOperands,
     /*  57064 */     // GIR_Coverage, 14040,
     /*  57064 */     GIR_EraseRootFromParent_Done,
     /*  57065 */   // Label 912: @57065
     /*  57065 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(57125), // Rule ID 5087 //
     /*  57070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  57089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  57093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57102 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57108 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57110 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57112 */     // (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }))  =>  (BICv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  57112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  57115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57117 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  57119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  57123 */     GIR_RootConstrainSelectedInstOperands,
     /*  57124 */     // GIR_Coverage, 5087,
     /*  57124 */     GIR_EraseRootFromParent_Done,
     /*  57125 */   // Label 913: @57125
     /*  57125 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(57148), // Rule ID 2483 //
     /*  57130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57141 */     // (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (ANDv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  57141 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  57146 */     GIR_RootConstrainSelectedInstOperands,
     /*  57147 */     // GIR_Coverage, 2483,
     /*  57147 */     GIR_Done,
     /*  57148 */   // Label 914: @57148
     /*  57148 */   GIM_Reject,
     /*  57149 */ // Label 911: @57149
     /*  57149 */ GIM_Reject,
     /*  57150 */ // Label 860: @57150
     /*  57150 */ GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(57309),
     /*  57155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  57158 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  57161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57165 */   GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(57225), // Rule ID 14035 //
     /*  57170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  57185 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  57189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57198 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57204 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57210 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57212 */     // (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$LHS)  =>  (BICv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  57212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  57215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57217 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  57219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  57223 */     GIR_RootConstrainSelectedInstOperands,
     /*  57224 */     // GIR_Coverage, 14035,
     /*  57224 */     GIR_EraseRootFromParent_Done,
     /*  57225 */   // Label 916: @57225
     /*  57225 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(57285), // Rule ID 5082 //
     /*  57230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  57249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  57253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57262 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57268 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57270 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57272 */     // (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }))  =>  (BICv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  57272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  57275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57277 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  57279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  57283 */     GIR_RootConstrainSelectedInstOperands,
     /*  57284 */     // GIR_Coverage, 5082,
     /*  57284 */     GIR_EraseRootFromParent_Done,
     /*  57285 */   // Label 917: @57285
     /*  57285 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(57308), // Rule ID 2478 //
     /*  57290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57301 */     // (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (ANDv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  57301 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  57306 */     GIR_RootConstrainSelectedInstOperands,
     /*  57307 */     // GIR_Coverage, 2478,
     /*  57307 */     GIR_Done,
     /*  57308 */   // Label 918: @57308
     /*  57308 */   GIM_Reject,
     /*  57309 */ // Label 915: @57309
     /*  57309 */ GIM_Reject,
     /*  57310 */ // Label 861: @57310
     /*  57310 */ GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(57469),
     /*  57315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57318 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57325 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(57385), // Rule ID 14039 //
     /*  57330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57345 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57349 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57358 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57364 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57370 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57372 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$LHS)  =>  (BICv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  57372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  57375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57377 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  57379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  57383 */     GIR_RootConstrainSelectedInstOperands,
     /*  57384 */     // GIR_Coverage, 14039,
     /*  57384 */     GIR_EraseRootFromParent_Done,
     /*  57385 */   // Label 920: @57385
     /*  57385 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(57445), // Rule ID 5086 //
     /*  57390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57409 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57422 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57428 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57430 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57432 */     // (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }))  =>  (BICv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  57432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  57435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57437 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  57439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  57443 */     GIR_RootConstrainSelectedInstOperands,
     /*  57444 */     // GIR_Coverage, 5086,
     /*  57444 */     GIR_EraseRootFromParent_Done,
     /*  57445 */   // Label 921: @57445
     /*  57445 */   GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(57468), // Rule ID 2482 //
     /*  57450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57461 */     // (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (ANDv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  57461 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  57466 */     GIR_RootConstrainSelectedInstOperands,
     /*  57467 */     // GIR_Coverage, 2482,
     /*  57467 */     GIR_Done,
     /*  57468 */   // Label 922: @57468
     /*  57468 */   GIM_Reject,
     /*  57469 */ // Label 919: @57469
     /*  57469 */ GIM_Reject,
     /*  57470 */ // Label 862: @57470
     /*  57470 */ GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(57629),
     /*  57475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  57478 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  57481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57485 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(57545), // Rule ID 13505 //
     /*  57490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  57505 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  57509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57518 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57524 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57530 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57532 */     // (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rn)  =>  (BICv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  57532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  57535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  57539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  57543 */     GIR_RootConstrainSelectedInstOperands,
     /*  57544 */     // GIR_Coverage, 13505,
     /*  57544 */     GIR_EraseRootFromParent_Done,
     /*  57545 */   // Label 924: @57545
     /*  57545 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(57605), // Rule ID 1597 //
     /*  57550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  57569 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  57573 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57578 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57582 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57588 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57590 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57592 */     // (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }))  =>  (BICv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  57592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  57595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57597 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  57599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  57603 */     GIR_RootConstrainSelectedInstOperands,
     /*  57604 */     // GIR_Coverage, 1597,
     /*  57604 */     GIR_EraseRootFromParent_Done,
     /*  57605 */   // Label 925: @57605
     /*  57605 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(57628), // Rule ID 1595 //
     /*  57610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57613 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57621 */     // (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ANDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  57621 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  57626 */     GIR_RootConstrainSelectedInstOperands,
     /*  57627 */     // GIR_Coverage, 1595,
     /*  57627 */     GIR_Done,
     /*  57628 */   // Label 926: @57628
     /*  57628 */   GIM_Reject,
     /*  57629 */ // Label 923: @57629
     /*  57629 */ GIM_Reject,
     /*  57630 */ // Label 863: @57630
     /*  57630 */ GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(57789),
     /*  57635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  57638 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  57641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57645 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(57705), // Rule ID 14038 //
     /*  57650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  57665 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  57669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57678 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57684 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57690 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57692 */     // (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$LHS)  =>  (BICv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  57692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  57695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57697 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  57699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  57703 */     GIR_RootConstrainSelectedInstOperands,
     /*  57704 */     // GIR_Coverage, 14038,
     /*  57704 */     GIR_EraseRootFromParent_Done,
     /*  57705 */   // Label 928: @57705
     /*  57705 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(57765), // Rule ID 5085 //
     /*  57710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  57729 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  57733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57742 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57748 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57750 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57752 */     // (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }))  =>  (BICv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  57752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  57755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57757 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  57759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  57763 */     GIR_RootConstrainSelectedInstOperands,
     /*  57764 */     // GIR_Coverage, 5085,
     /*  57764 */     GIR_EraseRootFromParent_Done,
     /*  57765 */   // Label 929: @57765
     /*  57765 */   GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(57788), // Rule ID 2481 //
     /*  57770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57781 */     // (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (ANDv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  57781 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  57786 */     GIR_RootConstrainSelectedInstOperands,
     /*  57787 */     // GIR_Coverage, 2481,
     /*  57787 */     GIR_Done,
     /*  57788 */   // Label 930: @57788
     /*  57788 */   GIM_Reject,
     /*  57789 */ // Label 927: @57789
     /*  57789 */ GIM_Reject,
     /*  57790 */ // Label 864: @57790
     /*  57790 */ GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(57949),
     /*  57795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  57798 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  57801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57805 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(57865), // Rule ID 13506 //
     /*  57810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  57825 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  57829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57838 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57844 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57850 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57852 */     // (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rn)  =>  (BICv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  57852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  57855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  57859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  57863 */     GIR_RootConstrainSelectedInstOperands,
     /*  57864 */     // GIR_Coverage, 13506,
     /*  57864 */     GIR_EraseRootFromParent_Done,
     /*  57865 */   // Label 932: @57865
     /*  57865 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(57925), // Rule ID 1598 //
     /*  57870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57873 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  57889 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  57893 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57902 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57908 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57910 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57912 */     // (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }))  =>  (BICv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  57912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  57915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57917 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  57919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  57923 */     GIR_RootConstrainSelectedInstOperands,
     /*  57924 */     // GIR_Coverage, 1598,
     /*  57924 */     GIR_EraseRootFromParent_Done,
     /*  57925 */   // Label 933: @57925
     /*  57925 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(57948), // Rule ID 1596 //
     /*  57930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57941 */     // (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ANDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  57941 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  57946 */     GIR_RootConstrainSelectedInstOperands,
     /*  57947 */     // GIR_Coverage, 1596,
     /*  57947 */     GIR_Done,
     /*  57948 */   // Label 934: @57948
     /*  57948 */   GIM_Reject,
     /*  57949 */ // Label 931: @57949
     /*  57949 */ GIM_Reject,
     /*  57950 */ // Label 865: @57950
     /*  57950 */ GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(58490),
     /*  57955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  57958 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  57961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  57965 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(58022), // Rule ID 15235 //
     /*  57970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  57985 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  57989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57997 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58001 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58005 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58007 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] }), nxv1i1:{ *:[nxv1i1] }:$Op2), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  58007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58020 */     GIR_RootConstrainSelectedInstOperands,
     /*  58021 */     // GIR_Coverage, 15235,
     /*  58021 */     GIR_EraseRootFromParent_Done,
     /*  58022 */   // Label 936: @58022
     /*  58022 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(58079), // Rule ID 15238 //
     /*  58027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  58042 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  58046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58054 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58058 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58062 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58064 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] }), nxv1i1:{ *:[nxv1i1] }:$Op2), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  58064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58077 */     GIR_RootConstrainSelectedInstOperands,
     /*  58078 */     // GIR_Coverage, 15238,
     /*  58078 */     GIR_EraseRootFromParent_Done,
     /*  58079 */   // Label 937: @58079
     /*  58079 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(58136), // Rule ID 15234 //
     /*  58084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58095 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  58099 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  58103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58111 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58115 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58119 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58121 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] })), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  58121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58134 */     GIR_RootConstrainSelectedInstOperands,
     /*  58135 */     // GIR_Coverage, 15234,
     /*  58135 */     GIR_EraseRootFromParent_Done,
     /*  58136 */   // Label 938: @58136
     /*  58136 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(58193), // Rule ID 15237 //
     /*  58141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  58156 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  58160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58168 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58172 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58176 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58178 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] })), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  58178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58191 */     GIR_RootConstrainSelectedInstOperands,
     /*  58192 */     // GIR_Coverage, 15237,
     /*  58192 */     GIR_EraseRootFromParent_Done,
     /*  58193 */   // Label 939: @58193
     /*  58193 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(58250), // Rule ID 15233 //
     /*  58198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  58213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  58217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58225 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58229 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58233 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58235 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] }), nxv1i1:{ *:[nxv1i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  58235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58240 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58242 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58248 */     GIR_RootConstrainSelectedInstOperands,
     /*  58249 */     // GIR_Coverage, 15233,
     /*  58249 */     GIR_EraseRootFromParent_Done,
     /*  58250 */   // Label 940: @58250
     /*  58250 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(58307), // Rule ID 15236 //
     /*  58255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  58270 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  58274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58282 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58286 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58290 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58292 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] }), nxv1i1:{ *:[nxv1i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  58292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58297 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58299 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58305 */     GIR_RootConstrainSelectedInstOperands,
     /*  58306 */     // GIR_Coverage, 15236,
     /*  58306 */     GIR_EraseRootFromParent_Done,
     /*  58307 */   // Label 941: @58307
     /*  58307 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(58364), // Rule ID 8546 //
     /*  58312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  58327 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  58331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58343 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58347 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58349 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  58349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58354 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58356 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58362 */     GIR_RootConstrainSelectedInstOperands,
     /*  58363 */     // GIR_Coverage, 8546,
     /*  58363 */     GIR_EraseRootFromParent_Done,
     /*  58364 */   // Label 942: @58364
     /*  58364 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(58421), // Rule ID 8547 //
     /*  58369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  58384 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  58388 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58392 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58396 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58400 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58404 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58406 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  58406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58411 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58413 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58419 */     GIR_RootConstrainSelectedInstOperands,
     /*  58420 */     // GIR_Coverage, 8547,
     /*  58420 */     GIR_EraseRootFromParent_Done,
     /*  58421 */   // Label 943: @58421
     /*  58421 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(58468), // Rule ID 10810 //
     /*  58426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  58433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  58437 */     // (and:{ *:[nxv1i1] } PPR:{ *:[nxv1i1] }:$Ps1, PPR:{ *:[nxv1i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv1i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv1i1] }:$Ps1, PPR:{ *:[nxv1i1] }:$Ps2)
     /*  58437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  58440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  58444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58449 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  58452 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  58454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  58457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58459 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58462 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  58464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  58466 */     GIR_RootConstrainSelectedInstOperands,
     /*  58467 */     // GIR_Coverage, 10810,
     /*  58467 */     GIR_EraseRootFromParent_Done,
     /*  58468 */   // Label 944: @58468
     /*  58468 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(58489), // Rule ID 2749 //
     /*  58473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58476 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  58476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  58479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58481 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58483 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  58487 */     GIR_RootConstrainSelectedInstOperands,
     /*  58488 */     // GIR_Coverage, 2749,
     /*  58488 */     GIR_EraseRootFromParent_Done,
     /*  58489 */   // Label 945: @58489
     /*  58489 */   GIM_Reject,
     /*  58490 */ // Label 935: @58490
     /*  58490 */ GIM_Reject,
     /*  58491 */ // Label 866: @58491
     /*  58491 */ GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(59031),
     /*  58496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  58499 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  58502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  58506 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(58563), // Rule ID 15226 //
     /*  58511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  58526 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  58530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58534 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58538 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58542 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58546 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58548 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] }), nxv2i1:{ *:[nxv2i1] }:$Op2), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  58548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58561 */     GIR_RootConstrainSelectedInstOperands,
     /*  58562 */     // GIR_Coverage, 15226,
     /*  58562 */     GIR_EraseRootFromParent_Done,
     /*  58563 */   // Label 947: @58563
     /*  58563 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(58620), // Rule ID 15229 //
     /*  58568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  58583 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  58587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58595 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58599 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58603 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58605 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] }), nxv2i1:{ *:[nxv2i1] }:$Op2), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  58605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58618 */     GIR_RootConstrainSelectedInstOperands,
     /*  58619 */     // GIR_Coverage, 15229,
     /*  58619 */     GIR_EraseRootFromParent_Done,
     /*  58620 */   // Label 948: @58620
     /*  58620 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(58677), // Rule ID 15225 //
     /*  58625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  58640 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  58644 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58648 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58652 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58656 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58660 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58662 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] })), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  58662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58675 */     GIR_RootConstrainSelectedInstOperands,
     /*  58676 */     // GIR_Coverage, 15225,
     /*  58676 */     GIR_EraseRootFromParent_Done,
     /*  58677 */   // Label 949: @58677
     /*  58677 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(58734), // Rule ID 15228 //
     /*  58682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  58697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  58701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58709 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58713 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58717 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58719 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] })), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  58719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58732 */     GIR_RootConstrainSelectedInstOperands,
     /*  58733 */     // GIR_Coverage, 15228,
     /*  58733 */     GIR_EraseRootFromParent_Done,
     /*  58734 */   // Label 950: @58734
     /*  58734 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(58791), // Rule ID 15224 //
     /*  58739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  58754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  58758 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58762 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58766 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58770 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58774 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58776 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] }), nxv2i1:{ *:[nxv2i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  58776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58781 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58783 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58789 */     GIR_RootConstrainSelectedInstOperands,
     /*  58790 */     // GIR_Coverage, 15224,
     /*  58790 */     GIR_EraseRootFromParent_Done,
     /*  58791 */   // Label 951: @58791
     /*  58791 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(58848), // Rule ID 15227 //
     /*  58796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  58811 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  58815 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58819 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58823 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58827 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58831 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58833 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] }), nxv2i1:{ *:[nxv2i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  58833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58838 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58840 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58846 */     GIR_RootConstrainSelectedInstOperands,
     /*  58847 */     // GIR_Coverage, 15227,
     /*  58847 */     GIR_EraseRootFromParent_Done,
     /*  58848 */   // Label 952: @58848
     /*  58848 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(58905), // Rule ID 8542 //
     /*  58853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  58868 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  58872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58880 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58884 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58888 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58890 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  58890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58895 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58897 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58903 */     GIR_RootConstrainSelectedInstOperands,
     /*  58904 */     // GIR_Coverage, 8542,
     /*  58904 */     GIR_EraseRootFromParent_Done,
     /*  58905 */   // Label 953: @58905
     /*  58905 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(58962), // Rule ID 8543 //
     /*  58910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  58925 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  58929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58937 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58941 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58945 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58947 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  58947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58952 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58954 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58960 */     GIR_RootConstrainSelectedInstOperands,
     /*  58961 */     // GIR_Coverage, 8543,
     /*  58961 */     GIR_EraseRootFromParent_Done,
     /*  58962 */   // Label 954: @58962
     /*  58962 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(59009), // Rule ID 10809 //
     /*  58967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  58974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  58978 */     // (and:{ *:[nxv2i1] } PPR:{ *:[nxv2i1] }:$Ps1, PPR:{ *:[nxv2i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv2i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv2i1] }:$Ps1, PPR:{ *:[nxv2i1] }:$Ps2)
     /*  58978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  58981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  58985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58990 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  58993 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  58995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  58998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59000 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  59003 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  59005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  59007 */     GIR_RootConstrainSelectedInstOperands,
     /*  59008 */     // GIR_Coverage, 10809,
     /*  59008 */     GIR_EraseRootFromParent_Done,
     /*  59009 */   // Label 955: @59009
     /*  59009 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(59030), // Rule ID 2748 //
     /*  59014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59017 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  59017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  59020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59022 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59024 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  59028 */     GIR_RootConstrainSelectedInstOperands,
     /*  59029 */     // GIR_Coverage, 2748,
     /*  59029 */     GIR_EraseRootFromParent_Done,
     /*  59030 */   // Label 956: @59030
     /*  59030 */   GIM_Reject,
     /*  59031 */ // Label 946: @59031
     /*  59031 */ GIM_Reject,
     /*  59032 */ // Label 867: @59032
     /*  59032 */ GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(59503),
     /*  59037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  59040 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  59043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  59047 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(59102), // Rule ID 15164 //
     /*  59052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  59067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  59071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59079 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59083 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59087 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59089 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  59089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59100 */     GIR_RootConstrainSelectedInstOperands,
     /*  59101 */     // GIR_Coverage, 15164,
     /*  59101 */     GIR_EraseRootFromParent_Done,
     /*  59102 */   // Label 958: @59102
     /*  59102 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(59157), // Rule ID 15167 //
     /*  59107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  59122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  59126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59134 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59138 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59142 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59144 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  59144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59155 */     GIR_RootConstrainSelectedInstOperands,
     /*  59156 */     // GIR_Coverage, 15167,
     /*  59156 */     GIR_EraseRootFromParent_Done,
     /*  59157 */   // Label 959: @59157
     /*  59157 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(59212), // Rule ID 15163 //
     /*  59162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  59177 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  59181 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59185 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59189 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59193 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59197 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59199 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  59199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59210 */     GIR_RootConstrainSelectedInstOperands,
     /*  59211 */     // GIR_Coverage, 15163,
     /*  59211 */     GIR_EraseRootFromParent_Done,
     /*  59212 */   // Label 960: @59212
     /*  59212 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(59267), // Rule ID 15166 //
     /*  59217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  59232 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  59236 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59240 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59244 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59248 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59252 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59254 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  59254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59265 */     GIR_RootConstrainSelectedInstOperands,
     /*  59266 */     // GIR_Coverage, 15166,
     /*  59266 */     GIR_EraseRootFromParent_Done,
     /*  59267 */   // Label 961: @59267
     /*  59267 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(59322), // Rule ID 15162 //
     /*  59272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  59287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  59291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59299 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59303 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59307 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59309 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  59309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59314 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59320 */     GIR_RootConstrainSelectedInstOperands,
     /*  59321 */     // GIR_Coverage, 15162,
     /*  59321 */     GIR_EraseRootFromParent_Done,
     /*  59322 */   // Label 962: @59322
     /*  59322 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(59377), // Rule ID 15165 //
     /*  59327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  59342 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  59346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59354 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59358 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59362 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59364 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  59364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59369 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59375 */     GIR_RootConstrainSelectedInstOperands,
     /*  59376 */     // GIR_Coverage, 15165,
     /*  59376 */     GIR_EraseRootFromParent_Done,
     /*  59377 */   // Label 963: @59377
     /*  59377 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(59432), // Rule ID 7566 //
     /*  59382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  59397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  59401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59409 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59413 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59417 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59419 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  59419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59424 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59430 */     GIR_RootConstrainSelectedInstOperands,
     /*  59431 */     // GIR_Coverage, 7566,
     /*  59431 */     GIR_EraseRootFromParent_Done,
     /*  59432 */   // Label 964: @59432
     /*  59432 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(59487), // Rule ID 7567 //
     /*  59437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  59452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  59456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59464 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59468 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59472 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59474 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  59474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59479 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59485 */     GIR_RootConstrainSelectedInstOperands,
     /*  59486 */     // GIR_Coverage, 7567,
     /*  59486 */     GIR_EraseRootFromParent_Done,
     /*  59487 */   // Label 965: @59487
     /*  59487 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(59502), // Rule ID 3157 //
     /*  59492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59495 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  59495 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  59500 */     GIR_RootConstrainSelectedInstOperands,
     /*  59501 */     // GIR_Coverage, 3157,
     /*  59501 */     GIR_Done,
     /*  59502 */   // Label 966: @59502
     /*  59502 */   GIM_Reject,
     /*  59503 */ // Label 957: @59503
     /*  59503 */ GIM_Reject,
     /*  59504 */ // Label 868: @59504
     /*  59504 */ GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(60044),
     /*  59509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  59512 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  59515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  59519 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(59576), // Rule ID 15217 //
     /*  59524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  59539 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  59543 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59547 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59551 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59555 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59559 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59561 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] }), nxv4i1:{ *:[nxv4i1] }:$Op2), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  59561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59574 */     GIR_RootConstrainSelectedInstOperands,
     /*  59575 */     // GIR_Coverage, 15217,
     /*  59575 */     GIR_EraseRootFromParent_Done,
     /*  59576 */   // Label 968: @59576
     /*  59576 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(59633), // Rule ID 15220 //
     /*  59581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59592 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  59596 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  59600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59608 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59612 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59616 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59618 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] }), nxv4i1:{ *:[nxv4i1] }:$Op2), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  59618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59631 */     GIR_RootConstrainSelectedInstOperands,
     /*  59632 */     // GIR_Coverage, 15220,
     /*  59632 */     GIR_EraseRootFromParent_Done,
     /*  59633 */   // Label 969: @59633
     /*  59633 */   GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(59690), // Rule ID 15216 //
     /*  59638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  59653 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  59657 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59661 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59665 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59669 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59673 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59675 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] })), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  59675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59688 */     GIR_RootConstrainSelectedInstOperands,
     /*  59689 */     // GIR_Coverage, 15216,
     /*  59689 */     GIR_EraseRootFromParent_Done,
     /*  59690 */   // Label 970: @59690
     /*  59690 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(59747), // Rule ID 15219 //
     /*  59695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  59710 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  59714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59722 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59726 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59730 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59732 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] })), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  59732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59745 */     GIR_RootConstrainSelectedInstOperands,
     /*  59746 */     // GIR_Coverage, 15219,
     /*  59746 */     GIR_EraseRootFromParent_Done,
     /*  59747 */   // Label 971: @59747
     /*  59747 */   GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(59804), // Rule ID 15215 //
     /*  59752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  59767 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  59771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59779 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59783 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59787 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59789 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] }), nxv4i1:{ *:[nxv4i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  59789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59794 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59796 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59802 */     GIR_RootConstrainSelectedInstOperands,
     /*  59803 */     // GIR_Coverage, 15215,
     /*  59803 */     GIR_EraseRootFromParent_Done,
     /*  59804 */   // Label 972: @59804
     /*  59804 */   GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(59861), // Rule ID 15218 //
     /*  59809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  59824 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  59828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59836 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59840 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59844 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59846 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] }), nxv4i1:{ *:[nxv4i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  59846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59851 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59853 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59859 */     GIR_RootConstrainSelectedInstOperands,
     /*  59860 */     // GIR_Coverage, 15218,
     /*  59860 */     GIR_EraseRootFromParent_Done,
     /*  59861 */   // Label 973: @59861
     /*  59861 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(59918), // Rule ID 8538 //
     /*  59866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  59881 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  59885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59893 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59897 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59901 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59903 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  59903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59908 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59910 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59916 */     GIR_RootConstrainSelectedInstOperands,
     /*  59917 */     // GIR_Coverage, 8538,
     /*  59917 */     GIR_EraseRootFromParent_Done,
     /*  59918 */   // Label 974: @59918
     /*  59918 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(59975), // Rule ID 8539 //
     /*  59923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  59938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  59942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59950 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59954 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59958 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59960 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  59960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59965 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59967 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59973 */     GIR_RootConstrainSelectedInstOperands,
     /*  59974 */     // GIR_Coverage, 8539,
     /*  59974 */     GIR_EraseRootFromParent_Done,
     /*  59975 */   // Label 975: @59975
     /*  59975 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(60022), // Rule ID 10808 //
     /*  59980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  59987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  59991 */     // (and:{ *:[nxv4i1] } PPR:{ *:[nxv4i1] }:$Ps1, PPR:{ *:[nxv4i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv4i1] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv4i1] }:$Ps1, PPR:{ *:[nxv4i1] }:$Ps2)
     /*  59991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  59994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /*  59998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60003 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  60006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  60011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60016 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  60018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  60020 */     GIR_RootConstrainSelectedInstOperands,
     /*  60021 */     // GIR_Coverage, 10808,
     /*  60021 */     GIR_EraseRootFromParent_Done,
     /*  60022 */   // Label 976: @60022
     /*  60022 */   GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(60043), // Rule ID 2747 //
     /*  60027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60030 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  60030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  60033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60035 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60037 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  60041 */     GIR_RootConstrainSelectedInstOperands,
     /*  60042 */     // GIR_Coverage, 2747,
     /*  60042 */     GIR_EraseRootFromParent_Done,
     /*  60043 */   // Label 977: @60043
     /*  60043 */   GIM_Reject,
     /*  60044 */ // Label 967: @60044
     /*  60044 */ GIM_Reject,
     /*  60045 */ // Label 869: @60045
     /*  60045 */ GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(60516),
     /*  60050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  60053 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  60056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  60060 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(60115), // Rule ID 15155 //
     /*  60065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  60080 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  60084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60092 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60096 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60100 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60102 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  60102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60113 */     GIR_RootConstrainSelectedInstOperands,
     /*  60114 */     // GIR_Coverage, 15155,
     /*  60114 */     GIR_EraseRootFromParent_Done,
     /*  60115 */   // Label 979: @60115
     /*  60115 */   GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(60170), // Rule ID 15158 //
     /*  60120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  60135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  60139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60147 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60151 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60155 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60157 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  60157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60168 */     GIR_RootConstrainSelectedInstOperands,
     /*  60169 */     // GIR_Coverage, 15158,
     /*  60169 */     GIR_EraseRootFromParent_Done,
     /*  60170 */   // Label 980: @60170
     /*  60170 */   GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(60225), // Rule ID 15154 //
     /*  60175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  60190 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  60194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60202 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60206 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60210 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60212 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  60212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60223 */     GIR_RootConstrainSelectedInstOperands,
     /*  60224 */     // GIR_Coverage, 15154,
     /*  60224 */     GIR_EraseRootFromParent_Done,
     /*  60225 */   // Label 981: @60225
     /*  60225 */   GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(60280), // Rule ID 15157 //
     /*  60230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  60245 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  60249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60257 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60261 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60265 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60267 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  60267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60278 */     GIR_RootConstrainSelectedInstOperands,
     /*  60279 */     // GIR_Coverage, 15157,
     /*  60279 */     GIR_EraseRootFromParent_Done,
     /*  60280 */   // Label 982: @60280
     /*  60280 */   GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(60335), // Rule ID 15153 //
     /*  60285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  60300 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  60304 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60308 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60312 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60316 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60320 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60322 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  60322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60327 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60333 */     GIR_RootConstrainSelectedInstOperands,
     /*  60334 */     // GIR_Coverage, 15153,
     /*  60334 */     GIR_EraseRootFromParent_Done,
     /*  60335 */   // Label 983: @60335
     /*  60335 */   GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(60390), // Rule ID 15156 //
     /*  60340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  60355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  60359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60367 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60371 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60375 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60377 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  60377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60382 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60388 */     GIR_RootConstrainSelectedInstOperands,
     /*  60389 */     // GIR_Coverage, 15156,
     /*  60389 */     GIR_EraseRootFromParent_Done,
     /*  60390 */   // Label 984: @60390
     /*  60390 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(60445), // Rule ID 7562 //
     /*  60395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  60410 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  60414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60422 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60426 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60430 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60432 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  60432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60437 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60443 */     GIR_RootConstrainSelectedInstOperands,
     /*  60444 */     // GIR_Coverage, 7562,
     /*  60444 */     GIR_EraseRootFromParent_Done,
     /*  60445 */   // Label 985: @60445
     /*  60445 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(60500), // Rule ID 7563 //
     /*  60450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  60465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  60469 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60473 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60477 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60481 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60485 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60487 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  60487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60492 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60498 */     GIR_RootConstrainSelectedInstOperands,
     /*  60499 */     // GIR_Coverage, 7563,
     /*  60499 */     GIR_EraseRootFromParent_Done,
     /*  60500 */   // Label 986: @60500
     /*  60500 */   GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(60515), // Rule ID 3156 //
     /*  60505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60508 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  60508 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  60513 */     GIR_RootConstrainSelectedInstOperands,
     /*  60514 */     // GIR_Coverage, 3156,
     /*  60514 */     GIR_Done,
     /*  60515 */   // Label 987: @60515
     /*  60515 */   GIM_Reject,
     /*  60516 */ // Label 978: @60516
     /*  60516 */ GIM_Reject,
     /*  60517 */ // Label 870: @60517
     /*  60517 */ GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(61057),
     /*  60522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  60525 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  60528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  60532 */   GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(60589), // Rule ID 15208 //
     /*  60537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  60552 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  60556 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60560 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60564 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60568 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60572 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60574 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] }), nxv8i1:{ *:[nxv8i1] }:$Op2), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  60574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60587 */     GIR_RootConstrainSelectedInstOperands,
     /*  60588 */     // GIR_Coverage, 15208,
     /*  60588 */     GIR_EraseRootFromParent_Done,
     /*  60589 */   // Label 989: @60589
     /*  60589 */   GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(60646), // Rule ID 15211 //
     /*  60594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  60609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  60613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60621 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60625 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60629 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60631 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] }), nxv8i1:{ *:[nxv8i1] }:$Op2), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  60631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60644 */     GIR_RootConstrainSelectedInstOperands,
     /*  60645 */     // GIR_Coverage, 15211,
     /*  60645 */     GIR_EraseRootFromParent_Done,
     /*  60646 */   // Label 990: @60646
     /*  60646 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(60703), // Rule ID 15207 //
     /*  60651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  60666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  60670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60678 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60682 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60686 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60688 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] })), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  60688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60701 */     GIR_RootConstrainSelectedInstOperands,
     /*  60702 */     // GIR_Coverage, 15207,
     /*  60702 */     GIR_EraseRootFromParent_Done,
     /*  60703 */   // Label 991: @60703
     /*  60703 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(60760), // Rule ID 15210 //
     /*  60708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  60723 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  60727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60735 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60739 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60743 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60745 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] })), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  60745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60758 */     GIR_RootConstrainSelectedInstOperands,
     /*  60759 */     // GIR_Coverage, 15210,
     /*  60759 */     GIR_EraseRootFromParent_Done,
     /*  60760 */   // Label 992: @60760
     /*  60760 */   GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(60817), // Rule ID 15206 //
     /*  60765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  60780 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  60784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60792 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60796 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60800 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60802 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] }), nxv8i1:{ *:[nxv8i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  60802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60807 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60809 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60815 */     GIR_RootConstrainSelectedInstOperands,
     /*  60816 */     // GIR_Coverage, 15206,
     /*  60816 */     GIR_EraseRootFromParent_Done,
     /*  60817 */   // Label 993: @60817
     /*  60817 */   GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(60874), // Rule ID 15209 //
     /*  60822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  60837 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  60841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60849 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60853 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60857 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60859 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] }), nxv8i1:{ *:[nxv8i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  60859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60864 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60866 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60872 */     GIR_RootConstrainSelectedInstOperands,
     /*  60873 */     // GIR_Coverage, 15209,
     /*  60873 */     GIR_EraseRootFromParent_Done,
     /*  60874 */   // Label 994: @60874
     /*  60874 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(60931), // Rule ID 8534 //
     /*  60879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  60894 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  60898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60902 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60906 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60910 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60914 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60916 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  60916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60921 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60923 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60929 */     GIR_RootConstrainSelectedInstOperands,
     /*  60930 */     // GIR_Coverage, 8534,
     /*  60930 */     GIR_EraseRootFromParent_Done,
     /*  60931 */   // Label 995: @60931
     /*  60931 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(60988), // Rule ID 8535 //
     /*  60936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  60951 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  60955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60963 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60967 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60971 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60973 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  60973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60978 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60980 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60986 */     GIR_RootConstrainSelectedInstOperands,
     /*  60987 */     // GIR_Coverage, 8535,
     /*  60987 */     GIR_EraseRootFromParent_Done,
     /*  60988 */   // Label 996: @60988
     /*  60988 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(61035), // Rule ID 10807 //
     /*  60993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  61000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  61004 */     // (and:{ *:[nxv8i1] } PPR:{ *:[nxv8i1] }:$Ps1, PPR:{ *:[nxv8i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv8i1] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv8i1] }:$Ps1, PPR:{ *:[nxv8i1] }:$Ps2)
     /*  61004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  61007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /*  61011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61016 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  61019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  61024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  61026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61029 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  61031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  61033 */     GIR_RootConstrainSelectedInstOperands,
     /*  61034 */     // GIR_Coverage, 10807,
     /*  61034 */     GIR_EraseRootFromParent_Done,
     /*  61035 */   // Label 997: @61035
     /*  61035 */   GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(61056), // Rule ID 2746 //
     /*  61040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61043 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  61043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  61046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  61048 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61050 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  61054 */     GIR_RootConstrainSelectedInstOperands,
     /*  61055 */     // GIR_Coverage, 2746,
     /*  61055 */     GIR_EraseRootFromParent_Done,
     /*  61056 */   // Label 998: @61056
     /*  61056 */   GIM_Reject,
     /*  61057 */ // Label 988: @61057
     /*  61057 */ GIM_Reject,
     /*  61058 */ // Label 871: @61058
     /*  61058 */ GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(61529),
     /*  61063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  61066 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  61069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  61073 */   GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(61128), // Rule ID 15146 //
     /*  61078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  61093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  61097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61105 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61109 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61113 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61115 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  61115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  61118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  61120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  61122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  61126 */     GIR_RootConstrainSelectedInstOperands,
     /*  61127 */     // GIR_Coverage, 15146,
     /*  61127 */     GIR_EraseRootFromParent_Done,
     /*  61128 */   // Label 1000: @61128
     /*  61128 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(61183), // Rule ID 15149 //
     /*  61133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  61148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  61152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61160 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61164 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61168 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61170 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  61170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  61173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  61175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  61177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  61181 */     GIR_RootConstrainSelectedInstOperands,
     /*  61182 */     // GIR_Coverage, 15149,
     /*  61182 */     GIR_EraseRootFromParent_Done,
     /*  61183 */   // Label 1001: @61183
     /*  61183 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(61238), // Rule ID 15145 //
     /*  61188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  61203 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  61207 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61211 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61215 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61219 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61223 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61225 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  61225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  61228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  61230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  61232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  61236 */     GIR_RootConstrainSelectedInstOperands,
     /*  61237 */     // GIR_Coverage, 15145,
     /*  61237 */     GIR_EraseRootFromParent_Done,
     /*  61238 */   // Label 1002: @61238
     /*  61238 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(61293), // Rule ID 15148 //
     /*  61243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  61258 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  61262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61266 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61270 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61274 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61278 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61280 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  61280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  61283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  61285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  61287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  61291 */     GIR_RootConstrainSelectedInstOperands,
     /*  61292 */     // GIR_Coverage, 15148,
     /*  61292 */     GIR_EraseRootFromParent_Done,
     /*  61293 */   // Label 1003: @61293
     /*  61293 */   GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(61348), // Rule ID 15144 //
     /*  61298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61309 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  61313 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  61317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61325 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61329 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61333 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61335 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  61335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  61338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  61340 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  61346 */     GIR_RootConstrainSelectedInstOperands,
     /*  61347 */     // GIR_Coverage, 15144,
     /*  61347 */     GIR_EraseRootFromParent_Done,
     /*  61348 */   // Label 1004: @61348
     /*  61348 */   GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(61403), // Rule ID 15147 //
     /*  61353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  61368 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  61372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61380 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61384 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61388 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61390 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  61390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  61393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  61395 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  61401 */     GIR_RootConstrainSelectedInstOperands,
     /*  61402 */     // GIR_Coverage, 15147,
     /*  61402 */     GIR_EraseRootFromParent_Done,
     /*  61403 */   // Label 1005: @61403
     /*  61403 */   GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(61458), // Rule ID 7558 //
     /*  61408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  61423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  61427 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61431 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61435 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61439 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61443 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61445 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  61445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  61448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  61450 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  61456 */     GIR_RootConstrainSelectedInstOperands,
     /*  61457 */     // GIR_Coverage, 7558,
     /*  61457 */     GIR_EraseRootFromParent_Done,
     /*  61458 */   // Label 1006: @61458
     /*  61458 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(61513), // Rule ID 7559 //
     /*  61463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  61478 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  61482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61490 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61494 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61498 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61500 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  61500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  61503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  61505 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  61511 */     GIR_RootConstrainSelectedInstOperands,
     /*  61512 */     // GIR_Coverage, 7559,
     /*  61512 */     GIR_EraseRootFromParent_Done,
     /*  61513 */   // Label 1007: @61513
     /*  61513 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(61528), // Rule ID 3155 //
     /*  61518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61521 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  61521 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  61526 */     GIR_RootConstrainSelectedInstOperands,
     /*  61527 */     // GIR_Coverage, 3155,
     /*  61527 */     GIR_Done,
     /*  61528 */   // Label 1008: @61528
     /*  61528 */   GIM_Reject,
     /*  61529 */ // Label 999: @61529
     /*  61529 */ GIM_Reject,
     /*  61530 */ // Label 872: @61530
     /*  61530 */ GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(62070),
     /*  61535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  61538 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  61541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  61545 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(61602), // Rule ID 15199 //
     /*  61550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  61565 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  61569 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61573 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61577 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61581 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61585 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61587 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] }), nxv16i1:{ *:[nxv16i1] }:$Op2), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  61587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  61590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  61592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  61594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  61596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  61600 */     GIR_RootConstrainSelectedInstOperands,
     /*  61601 */     // GIR_Coverage, 15199,
     /*  61601 */     GIR_EraseRootFromParent_Done,
     /*  61602 */   // Label 1010: @61602
     /*  61602 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(61659), // Rule ID 15202 //
     /*  61607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  61622 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  61626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61630 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61634 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61638 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61642 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61644 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] }), nxv16i1:{ *:[nxv16i1] }:$Op2), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  61644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  61647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  61649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  61651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  61653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  61657 */     GIR_RootConstrainSelectedInstOperands,
     /*  61658 */     // GIR_Coverage, 15202,
     /*  61658 */     GIR_EraseRootFromParent_Done,
     /*  61659 */   // Label 1011: @61659
     /*  61659 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(61716), // Rule ID 15198 //
     /*  61664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  61679 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  61683 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61687 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61691 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61695 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61699 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61701 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] })), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  61701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  61704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  61706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  61708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  61710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  61714 */     GIR_RootConstrainSelectedInstOperands,
     /*  61715 */     // GIR_Coverage, 15198,
     /*  61715 */     GIR_EraseRootFromParent_Done,
     /*  61716 */   // Label 1012: @61716
     /*  61716 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(61773), // Rule ID 15201 //
     /*  61721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  61736 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  61740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61752 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61756 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61758 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] })), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  61758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  61761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  61763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  61765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  61767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  61771 */     GIR_RootConstrainSelectedInstOperands,
     /*  61772 */     // GIR_Coverage, 15201,
     /*  61772 */     GIR_EraseRootFromParent_Done,
     /*  61773 */   // Label 1013: @61773
     /*  61773 */   GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(61830), // Rule ID 15197 //
     /*  61778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  61793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  61797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61805 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61809 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61813 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61815 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] }), nxv16i1:{ *:[nxv16i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  61815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  61818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  61820 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61822 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  61828 */     GIR_RootConstrainSelectedInstOperands,
     /*  61829 */     // GIR_Coverage, 15197,
     /*  61829 */     GIR_EraseRootFromParent_Done,
     /*  61830 */   // Label 1014: @61830
     /*  61830 */   GIM_Try, /*On fail goto*//*Label 1015*/ GIMT_Encode4(61887), // Rule ID 15200 //
     /*  61835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  61850 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  61854 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61858 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61862 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61866 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61870 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61872 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] }), nxv16i1:{ *:[nxv16i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  61872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  61875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  61877 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61879 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  61885 */     GIR_RootConstrainSelectedInstOperands,
     /*  61886 */     // GIR_Coverage, 15200,
     /*  61886 */     GIR_EraseRootFromParent_Done,
     /*  61887 */   // Label 1015: @61887
     /*  61887 */   GIM_Try, /*On fail goto*//*Label 1016*/ GIMT_Encode4(61944), // Rule ID 8530 //
     /*  61892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  61907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  61911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61919 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61923 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61927 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61929 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  61929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  61932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  61934 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61936 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  61942 */     GIR_RootConstrainSelectedInstOperands,
     /*  61943 */     // GIR_Coverage, 8530,
     /*  61943 */     GIR_EraseRootFromParent_Done,
     /*  61944 */   // Label 1016: @61944
     /*  61944 */   GIM_Try, /*On fail goto*//*Label 1017*/ GIMT_Encode4(62001), // Rule ID 8531 //
     /*  61949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  61964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  61968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61976 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61980 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61984 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61986 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  61986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  61989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  61991 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61993 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  61999 */     GIR_RootConstrainSelectedInstOperands,
     /*  62000 */     // GIR_Coverage, 8531,
     /*  62000 */     GIR_EraseRootFromParent_Done,
     /*  62001 */   // Label 1017: @62001
     /*  62001 */   GIM_Try, /*On fail goto*//*Label 1018*/ GIMT_Encode4(62048), // Rule ID 10806 //
     /*  62006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  62009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  62013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  62017 */     // (and:{ *:[nxv16i1] } PPR:{ *:[nxv16i1] }:$Ps1, PPR:{ *:[nxv16i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv16i1] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv16i1] }:$Ps1, PPR:{ *:[nxv16i1] }:$Ps2)
     /*  62017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  62020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /*  62024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62029 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  62032 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  62034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  62037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  62039 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62042 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  62044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  62046 */     GIR_RootConstrainSelectedInstOperands,
     /*  62047 */     // GIR_Coverage, 10806,
     /*  62047 */     GIR_EraseRootFromParent_Done,
     /*  62048 */   // Label 1018: @62048
     /*  62048 */   GIM_Try, /*On fail goto*//*Label 1019*/ GIMT_Encode4(62069), // Rule ID 2745 //
     /*  62053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  62056 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  62056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  62059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  62061 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  62063 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  62065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  62067 */     GIR_RootConstrainSelectedInstOperands,
     /*  62068 */     // GIR_Coverage, 2745,
     /*  62068 */     GIR_EraseRootFromParent_Done,
     /*  62069 */   // Label 1019: @62069
     /*  62069 */   GIM_Reject,
     /*  62070 */ // Label 1009: @62070
     /*  62070 */ GIM_Reject,
     /*  62071 */ // Label 873: @62071
     /*  62071 */ GIM_Try, /*On fail goto*//*Label 1020*/ GIMT_Encode4(62542),
     /*  62076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  62079 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  62082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  62086 */   GIM_Try, /*On fail goto*//*Label 1021*/ GIMT_Encode4(62141), // Rule ID 15137 //
     /*  62091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  62094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  62106 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  62110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62114 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  62118 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  62122 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  62126 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62128 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  62128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  62131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  62133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  62135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  62139 */     GIR_RootConstrainSelectedInstOperands,
     /*  62140 */     // GIR_Coverage, 15137,
     /*  62140 */     GIR_EraseRootFromParent_Done,
     /*  62141 */   // Label 1021: @62141
     /*  62141 */   GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(62196), // Rule ID 15140 //
     /*  62146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  62149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  62161 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  62165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  62173 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62177 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  62181 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62183 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  62183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  62186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  62188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  62190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  62194 */     GIR_RootConstrainSelectedInstOperands,
     /*  62195 */     // GIR_Coverage, 15140,
     /*  62195 */     GIR_EraseRootFromParent_Done,
     /*  62196 */   // Label 1022: @62196
     /*  62196 */   GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(62251), // Rule ID 15136 //
     /*  62201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  62204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  62216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  62220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  62228 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  62232 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  62236 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62238 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  62238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  62241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  62243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  62245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  62249 */     GIR_RootConstrainSelectedInstOperands,
     /*  62250 */     // GIR_Coverage, 15136,
     /*  62250 */     GIR_EraseRootFromParent_Done,
     /*  62251 */   // Label 1023: @62251
     /*  62251 */   GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(62306), // Rule ID 15139 //
     /*  62256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  62259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  62271 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  62275 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62279 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  62283 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62287 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  62291 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62293 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  62293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  62296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  62298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  62300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  62304 */     GIR_RootConstrainSelectedInstOperands,
     /*  62305 */     // GIR_Coverage, 15139,
     /*  62305 */     GIR_EraseRootFromParent_Done,
     /*  62306 */   // Label 1024: @62306
     /*  62306 */   GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(62361), // Rule ID 15135 //
     /*  62311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  62314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  62326 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  62330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  62338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  62342 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  62346 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62348 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  62348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  62351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  62353 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  62355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  62359 */     GIR_RootConstrainSelectedInstOperands,
     /*  62360 */     // GIR_Coverage, 15135,
     /*  62360 */     GIR_EraseRootFromParent_Done,
     /*  62361 */   // Label 1025: @62361
     /*  62361 */   GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(62416), // Rule ID 15138 //
     /*  62366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  62369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  62381 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  62385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  62393 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62397 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  62401 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62403 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  62403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  62406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  62408 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  62410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  62414 */     GIR_RootConstrainSelectedInstOperands,
     /*  62415 */     // GIR_Coverage, 15138,
     /*  62415 */     GIR_EraseRootFromParent_Done,
     /*  62416 */   // Label 1026: @62416
     /*  62416 */   GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(62471), // Rule ID 7554 //
     /*  62421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  62424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  62436 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  62440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  62448 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  62452 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  62456 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62458 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  62458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  62461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  62463 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  62465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  62469 */     GIR_RootConstrainSelectedInstOperands,
     /*  62470 */     // GIR_Coverage, 7554,
     /*  62470 */     GIR_EraseRootFromParent_Done,
     /*  62471 */   // Label 1027: @62471
     /*  62471 */   GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(62526), // Rule ID 7555 //
     /*  62476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  62479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  62491 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  62495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  62503 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62507 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  62511 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62513 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  62513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  62516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  62518 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  62520 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  62524 */     GIR_RootConstrainSelectedInstOperands,
     /*  62525 */     // GIR_Coverage, 7555,
     /*  62525 */     GIR_EraseRootFromParent_Done,
     /*  62526 */   // Label 1028: @62526
     /*  62526 */   GIM_Try, /*On fail goto*//*Label 1029*/ GIMT_Encode4(62541), // Rule ID 3154 //
     /*  62531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  62534 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  62534 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  62539 */     GIR_RootConstrainSelectedInstOperands,
     /*  62540 */     // GIR_Coverage, 3154,
     /*  62540 */     GIR_Done,
     /*  62541 */   // Label 1029: @62541
     /*  62541 */   GIM_Reject,
     /*  62542 */ // Label 1020: @62542
     /*  62542 */ GIM_Reject,
     /*  62543 */ // Label 874: @62543
     /*  62543 */ GIM_Reject,
     /*  62544 */ // Label 6: @62544
     /*  62544 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1048*/ GIMT_Encode4(87658),
     /*  62555 */ /*GILLT_s32*//*Label 1030*/ GIMT_Encode4(62643),
     /*  62559 */ /*GILLT_s64*//*Label 1031*/ GIMT_Encode4(63003), GIMT_Encode4(0),
     /*  62567 */ /*GILLT_v2s32*//*Label 1032*/ GIMT_Encode4(64902),
     /*  62571 */ /*GILLT_v2s64*//*Label 1033*/ GIMT_Encode4(66210),
     /*  62575 */ /*GILLT_v4s16*//*Label 1034*/ GIMT_Encode4(67518),
     /*  62579 */ /*GILLT_v4s32*//*Label 1035*/ GIMT_Encode4(68826),
     /*  62583 */ /*GILLT_v8s8*//*Label 1036*/ GIMT_Encode4(70134),
     /*  62587 */ /*GILLT_v8s16*//*Label 1037*/ GIMT_Encode4(71442),
     /*  62591 */ /*GILLT_v16s8*//*Label 1038*/ GIMT_Encode4(72750),
     /*  62595 */ /*GILLT_nxv1s1*//*Label 1039*/ GIMT_Encode4(74058),
     /*  62599 */ /*GILLT_nxv2s1*//*Label 1040*/ GIMT_Encode4(74090), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  62611 */ /*GILLT_nxv2s64*//*Label 1041*/ GIMT_Encode4(74122),
     /*  62615 */ /*GILLT_nxv4s1*//*Label 1042*/ GIMT_Encode4(77482), GIMT_Encode4(0),
     /*  62623 */ /*GILLT_nxv4s32*//*Label 1043*/ GIMT_Encode4(77514),
     /*  62627 */ /*GILLT_nxv8s1*//*Label 1044*/ GIMT_Encode4(80874),
     /*  62631 */ /*GILLT_nxv8s16*//*Label 1045*/ GIMT_Encode4(80906),
     /*  62635 */ /*GILLT_nxv16s1*//*Label 1046*/ GIMT_Encode4(84266),
     /*  62639 */ /*GILLT_nxv16s8*//*Label 1047*/ GIMT_Encode4(84298),
     /*  62643 */ // Label 1030: @62643
     /*  62643 */ GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(63002),
     /*  62648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  62651 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  62654 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(62709), // Rule ID 13389 //
     /*  62659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  62675 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  62679 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  62683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62689 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  62696 */     // (or:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (ORNWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  62696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrs),
     /*  62699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  62703 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  62707 */     GIR_RootConstrainSelectedInstOperands,
     /*  62708 */     // GIR_Coverage, 13389,
     /*  62708 */     GIR_EraseRootFromParent_Done,
     /*  62709 */   // Label 1050: @62709
     /*  62709 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(62764), // Rule ID 174 //
     /*  62714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  62734 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  62738 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  62742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62744 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  62751 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (ORNWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  62751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrs),
     /*  62754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62756 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  62758 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  62762 */     GIR_RootConstrainSelectedInstOperands,
     /*  62763 */     // GIR_Coverage, 174,
     /*  62763 */     GIR_EraseRootFromParent_Done,
     /*  62764 */   // Label 1051: @62764
     /*  62764 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(62805), // Rule ID 146 //
     /*  62769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  62773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62785 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  62789 */     // MIs[1] Operand 1
     /*  62789 */     // No operand predicates
     /*  62789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62791 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (ORRWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  62791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWri),
     /*  62794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62796 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  62798 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  62803 */     GIR_RootConstrainSelectedInstOperands,
     /*  62804 */     // GIR_Coverage, 146,
     /*  62804 */     GIR_EraseRootFromParent_Done,
     /*  62805 */   // Label 1052: @62805
     /*  62805 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(62838), // Rule ID 13391 //
     /*  62810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  62825 */     // (or:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ORRWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  62825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWrs),
     /*  62828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  62832 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  62836 */     GIR_RootConstrainSelectedInstOperands,
     /*  62837 */     // GIR_Coverage, 13391,
     /*  62837 */     GIR_EraseRootFromParent_Done,
     /*  62838 */   // Label 1053: @62838
     /*  62838 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(62871), // Rule ID 178 //
     /*  62843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  62858 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ORRWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  62858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWrs),
     /*  62861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62863 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  62865 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  62869 */     GIR_RootConstrainSelectedInstOperands,
     /*  62870 */     // GIR_Coverage, 178,
     /*  62870 */     GIR_EraseRootFromParent_Done,
     /*  62871 */   // Label 1054: @62871
     /*  62871 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(62924), // Rule ID 13387 //
     /*  62876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  62892 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  62896 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62901 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  62905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62911 */     // (or:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (ORNWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  62911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  62914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  62918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  62922 */     GIR_RootConstrainSelectedInstOperands,
     /*  62923 */     // GIR_Coverage, 13387,
     /*  62923 */     GIR_EraseRootFromParent_Done,
     /*  62924 */   // Label 1055: @62924
     /*  62924 */   GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(62977), // Rule ID 172 //
     /*  62929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  62949 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  62953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62958 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  62962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62964 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (ORNWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  62964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  62967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62969 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  62971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  62975 */     GIR_RootConstrainSelectedInstOperands,
     /*  62976 */     // GIR_Coverage, 172,
     /*  62976 */     GIR_EraseRootFromParent_Done,
     /*  62977 */   // Label 1056: @62977
     /*  62977 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(63001), // Rule ID 176 //
     /*  62982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62994 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ORRWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  62994 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRWrr),
     /*  62999 */     GIR_RootConstrainSelectedInstOperands,
     /*  63000 */     // GIR_Coverage, 176,
     /*  63000 */     GIR_Done,
     /*  63001 */   // Label 1057: @63001
     /*  63001 */   GIM_Reject,
     /*  63002 */ // Label 1049: @63002
     /*  63002 */ GIM_Reject,
     /*  63003 */ // Label 1031: @63003
     /*  63003 */ GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(64901),
     /*  63008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  63011 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  63014 */   GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(63136), // Rule ID 4042 //
     /*  63019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63035 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63039 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63043 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  63047 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  63051 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  63055 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63060 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  63064 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(71777214294589695),
     /*  63075 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  63079 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63083 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  63087 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  63091 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  63095 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  63099 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  63103 */     // MIs[4] Rn
     /*  63103 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63108 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  63112 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(-71777214294589696),
     /*  63123 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63125 */     // (or:{ *:[i64] } (and:{ *:[i64] } (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), 71777214294589695:{ *:[i64] }), (and:{ *:[i64] } (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), -71777214294589696:{ *:[i64] }))  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /*  63125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /*  63128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  63134 */     GIR_RootConstrainSelectedInstOperands,
     /*  63135 */     // GIR_Coverage, 4042,
     /*  63135 */     GIR_EraseRootFromParent_Done,
     /*  63136 */   // Label 1059: @63136
     /*  63136 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(63258), // Rule ID 13952 //
     /*  63141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  63169 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  63173 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  63177 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63182 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  63186 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(-71777214294589696),
     /*  63197 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  63201 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63205 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  63209 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  63213 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  63217 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  63221 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  63225 */     // MIs[4] Rn
     /*  63225 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63230 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  63234 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(71777214294589695),
     /*  63245 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63247 */     // (or:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), -71777214294589696:{ *:[i64] }), (and:{ *:[i64] } (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), 71777214294589695:{ *:[i64] }))  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /*  63247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /*  63250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  63256 */     GIR_RootConstrainSelectedInstOperands,
     /*  63257 */     // GIR_Coverage, 13952,
     /*  63257 */     GIR_EraseRootFromParent_Done,
     /*  63258 */   // Label 1060: @63258
     /*  63258 */   GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(63313), // Rule ID 13390 //
     /*  63263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63279 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63283 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  63287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63293 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  63300 */     // (or:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (ORNXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  63300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrs),
     /*  63303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  63307 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  63311 */     GIR_RootConstrainSelectedInstOperands,
     /*  63312 */     // GIR_Coverage, 13390,
     /*  63312 */     GIR_EraseRootFromParent_Done,
     /*  63313 */   // Label 1061: @63313
     /*  63313 */   GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(63368), // Rule ID 175 //
     /*  63318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63338 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63342 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  63346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63348 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  63355 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (ORNXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  63355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrs),
     /*  63358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63360 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  63362 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  63366 */     GIR_RootConstrainSelectedInstOperands,
     /*  63367 */     // GIR_Coverage, 175,
     /*  63367 */     GIR_EraseRootFromParent_Done,
     /*  63368 */   // Label 1062: @63368
     /*  63368 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(63477), // Rule ID 13749 //
     /*  63373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63392 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63404 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  63408 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  63412 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63417 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63421 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63427 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63434 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63438 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63442 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  63446 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63451 */     // MIs[4] LHS
     /*  63451 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63456 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63458 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  63458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  63471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  63475 */     GIR_RootConstrainSelectedInstOperands,
     /*  63476 */     // GIR_Coverage, 13749,
     /*  63476 */     GIR_EraseRootFromParent_Done,
     /*  63477 */   // Label 1063: @63477
     /*  63477 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(63586), // Rule ID 13748 //
     /*  63482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63501 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63513 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  63517 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  63521 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63526 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63530 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63536 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63538 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63543 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63547 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63551 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  63555 */     // MIs[4] LHS
     /*  63555 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63560 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63565 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63567 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  63567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  63580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  63584 */     GIR_RootConstrainSelectedInstOperands,
     /*  63585 */     // GIR_Coverage, 13748,
     /*  63585 */     GIR_EraseRootFromParent_Done,
     /*  63586 */   // Label 1064: @63586
     /*  63586 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(63695), // Rule ID 13751 //
     /*  63591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63610 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63614 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63627 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  63631 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  63635 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63640 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63644 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63650 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63652 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63656 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63660 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  63664 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63669 */     // MIs[4] LHS
     /*  63669 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63674 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63676 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  63676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  63689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63693 */     GIR_RootConstrainSelectedInstOperands,
     /*  63694 */     // GIR_Coverage, 13751,
     /*  63694 */     GIR_EraseRootFromParent_Done,
     /*  63695 */   // Label 1065: @63695
     /*  63695 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(63804), // Rule ID 13750 //
     /*  63700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63719 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  63740 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  63744 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63749 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63753 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63759 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63761 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63765 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63769 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  63773 */     // MIs[4] LHS
     /*  63773 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63778 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63783 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63785 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  63785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  63798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63802 */     GIR_RootConstrainSelectedInstOperands,
     /*  63803 */     // GIR_Coverage, 13750,
     /*  63803 */     GIR_EraseRootFromParent_Done,
     /*  63804 */   // Label 1066: @63804
     /*  63804 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(63913), // Rule ID 2474 //
     /*  63809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63828 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63832 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63837 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63842 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63846 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63850 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  63854 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  63858 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  63862 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63866 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  63870 */     // MIs[3] LHS
     /*  63870 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  63875 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  63879 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63885 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  63887 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63892 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63894 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS), (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  63894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  63903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  63907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  63911 */     GIR_RootConstrainSelectedInstOperands,
     /*  63912 */     // GIR_Coverage, 2474,
     /*  63912 */     GIR_EraseRootFromParent_Done,
     /*  63913 */   // Label 1067: @63913
     /*  63913 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(64022), // Rule ID 13746 //
     /*  63918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63937 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63941 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63959 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  63963 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  63967 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  63971 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63975 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  63979 */     // MIs[3] LHS
     /*  63979 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  63984 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  63988 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63994 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  63996 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64001 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64003 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS), (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  64003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  64006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  64012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  64016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  64020 */     GIR_RootConstrainSelectedInstOperands,
     /*  64021 */     // GIR_Coverage, 13746,
     /*  64021 */     GIR_EraseRootFromParent_Done,
     /*  64022 */   // Label 1068: @64022
     /*  64022 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(64131), // Rule ID 13745 //
     /*  64027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  64046 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  64050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64068 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  64072 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  64076 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64081 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64085 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64089 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  64093 */     // MIs[3] LHS
     /*  64093 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  64098 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64102 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64108 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64110 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64112 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  64112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  64115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  64121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  64125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  64129 */     GIR_RootConstrainSelectedInstOperands,
     /*  64130 */     // GIR_Coverage, 13745,
     /*  64130 */     GIR_EraseRootFromParent_Done,
     /*  64131 */   // Label 1069: @64131
     /*  64131 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(64240), // Rule ID 13747 //
     /*  64136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  64155 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  64159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64164 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64169 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64173 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64177 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  64181 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  64185 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64190 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64194 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64198 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  64202 */     // MIs[3] LHS
     /*  64202 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  64207 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64211 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64217 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64219 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64221 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  64221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  64224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  64230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  64234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  64238 */     GIR_RootConstrainSelectedInstOperands,
     /*  64239 */     // GIR_Coverage, 13747,
     /*  64239 */     GIR_EraseRootFromParent_Done,
     /*  64240 */   // Label 1070: @64240
     /*  64240 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(64281), // Rule ID 147 //
     /*  64245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  64249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64261 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  64265 */     // MIs[1] Operand 1
     /*  64265 */     // No operand predicates
     /*  64265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64267 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (ORRXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  64267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXri),
     /*  64270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64272 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  64274 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  64279 */     GIR_RootConstrainSelectedInstOperands,
     /*  64280 */     // GIR_Coverage, 147,
     /*  64280 */     GIR_EraseRootFromParent_Done,
     /*  64281 */   // Label 1071: @64281
     /*  64281 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(64314), // Rule ID 13392 //
     /*  64286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  64301 */     // (or:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ORRXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  64301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXrs),
     /*  64304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  64308 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  64312 */     GIR_RootConstrainSelectedInstOperands,
     /*  64313 */     // GIR_Coverage, 13392,
     /*  64313 */     GIR_EraseRootFromParent_Done,
     /*  64314 */   // Label 1072: @64314
     /*  64314 */   GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(64347), // Rule ID 179 //
     /*  64319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  64334 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ORRXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  64334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXrs),
     /*  64337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64339 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  64341 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  64345 */     GIR_RootConstrainSelectedInstOperands,
     /*  64346 */     // GIR_Coverage, 179,
     /*  64346 */     GIR_EraseRootFromParent_Done,
     /*  64347 */   // Label 1073: @64347
     /*  64347 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(64414), // Rule ID 13685 //
     /*  64352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  64367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  64371 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64376 */     // MIs[1] imm
     /*  64376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64384 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  64388 */     // MIs[2] Operand 1
     /*  64388 */     // No operand predicates
     /*  64388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64392 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64396 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64398 */     // (or:{ *:[v1i64] } (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  64401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  64405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64412 */     GIR_RootConstrainSelectedInstOperands,
     /*  64413 */     // GIR_Coverage, 13685,
     /*  64413 */     GIR_EraseRootFromParent_Done,
     /*  64414 */   // Label 1074: @64414
     /*  64414 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(64481), // Rule ID 13688 //
     /*  64419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  64434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  64438 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64443 */     // MIs[1] imm
     /*  64443 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64447 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64451 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  64455 */     // MIs[2] Operand 1
     /*  64455 */     // No operand predicates
     /*  64455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64459 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64463 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64465 */     // (or:{ *:[v1i64] } (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  64468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  64472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64476 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64479 */     GIR_RootConstrainSelectedInstOperands,
     /*  64480 */     // GIR_Coverage, 13688,
     /*  64480 */     GIR_EraseRootFromParent_Done,
     /*  64481 */   // Label 1075: @64481
     /*  64481 */   GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(64534), // Rule ID 13388 //
     /*  64486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  64502 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  64506 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64511 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  64515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64521 */     // (or:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (ORNXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  64521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  64524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  64528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  64532 */     GIR_RootConstrainSelectedInstOperands,
     /*  64533 */     // GIR_Coverage, 13388,
     /*  64533 */     GIR_EraseRootFromParent_Done,
     /*  64534 */   // Label 1076: @64534
     /*  64534 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(64601), // Rule ID 2122 //
     /*  64539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  64558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  64562 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64567 */     // MIs[1] imm
     /*  64567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64575 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  64579 */     // MIs[2] Operand 1
     /*  64579 */     // No operand predicates
     /*  64579 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64583 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64585 */     // (or:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  64588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64590 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  64592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64596 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64599 */     GIR_RootConstrainSelectedInstOperands,
     /*  64600 */     // GIR_Coverage, 2122,
     /*  64600 */     GIR_EraseRootFromParent_Done,
     /*  64601 */   // Label 1077: @64601
     /*  64601 */   GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(64668), // Rule ID 2131 //
     /*  64606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64613 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  64625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  64629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64634 */     // MIs[1] imm
     /*  64634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64638 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64642 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  64646 */     // MIs[2] Operand 1
     /*  64646 */     // No operand predicates
     /*  64646 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64650 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64652 */     // (or:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  64655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64657 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  64659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64663 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64666 */     GIR_RootConstrainSelectedInstOperands,
     /*  64667 */     // GIR_Coverage, 2131,
     /*  64667 */     GIR_EraseRootFromParent_Done,
     /*  64668 */   // Label 1078: @64668
     /*  64668 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(64721), // Rule ID 173 //
     /*  64673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  64693 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  64697 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64702 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  64706 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64708 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }))  =>  (ORNXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  64708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  64711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64713 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  64715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  64719 */     GIR_RootConstrainSelectedInstOperands,
     /*  64720 */     // GIR_Coverage, 173,
     /*  64720 */     GIR_EraseRootFromParent_Done,
     /*  64721 */   // Label 1079: @64721
     /*  64721 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(64785), // Rule ID 14043 //
     /*  64726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  64745 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  64749 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64758 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64764 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  64766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64770 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64772 */     // (or:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$LHS)  =>  (ORNv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  64772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  64775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64777 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  64779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64783 */     GIR_RootConstrainSelectedInstOperands,
     /*  64784 */     // GIR_Coverage, 14043,
     /*  64784 */     GIR_EraseRootFromParent_Done,
     /*  64785 */   // Label 1080: @64785
     /*  64785 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(64849), // Rule ID 5096 //
     /*  64790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  64813 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  64817 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64822 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64826 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64832 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  64834 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64836 */     // (or:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }))  =>  (ORNv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  64836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  64839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64841 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  64843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64847 */     GIR_RootConstrainSelectedInstOperands,
     /*  64848 */     // GIR_Coverage, 5096,
     /*  64848 */     GIR_EraseRootFromParent_Done,
     /*  64849 */   // Label 1081: @64849
     /*  64849 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(64873), // Rule ID 177 //
     /*  64854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64866 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ORRXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  64866 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRXrr),
     /*  64871 */     GIR_RootConstrainSelectedInstOperands,
     /*  64872 */     // GIR_Coverage, 177,
     /*  64872 */     GIR_Done,
     /*  64873 */   // Label 1082: @64873
     /*  64873 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(64900), // Rule ID 5102 //
     /*  64878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64893 */     // (or:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (ORRv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  64893 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  64898 */     GIR_RootConstrainSelectedInstOperands,
     /*  64899 */     // GIR_Coverage, 5102,
     /*  64899 */     GIR_Done,
     /*  64900 */   // Label 1083: @64900
     /*  64900 */   GIM_Reject,
     /*  64901 */ // Label 1058: @64901
     /*  64901 */ GIM_Reject,
     /*  64902 */ // Label 1032: @64902
     /*  64902 */ GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(66209),
     /*  64907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64910 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64913 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(65022), // Rule ID 13742 //
     /*  64918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64937 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64949 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64953 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64957 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64962 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64966 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64972 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64974 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64979 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64983 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64987 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64991 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64996 */     // MIs[4] LHS
     /*  64996 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65001 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65003 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  65003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  65012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  65016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  65020 */     GIR_RootConstrainSelectedInstOperands,
     /*  65021 */     // GIR_Coverage, 13742,
     /*  65021 */     GIR_EraseRootFromParent_Done,
     /*  65022 */   // Label 1085: @65022
     /*  65022 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(65131), // Rule ID 13741 //
     /*  65027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65046 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65058 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65062 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65066 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65071 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65075 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65081 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65083 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65088 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65092 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65096 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65100 */     // MIs[4] LHS
     /*  65100 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65105 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65110 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65112 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  65112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  65121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  65125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  65129 */     GIR_RootConstrainSelectedInstOperands,
     /*  65130 */     // GIR_Coverage, 13741,
     /*  65130 */     GIR_EraseRootFromParent_Done,
     /*  65131 */   // Label 1086: @65131
     /*  65131 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(65240), // Rule ID 13744 //
     /*  65136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65155 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65172 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65176 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65180 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65185 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65189 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65195 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65197 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65201 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65205 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65209 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65214 */     // MIs[4] LHS
     /*  65214 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65219 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65221 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  65221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  65230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  65234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65238 */     GIR_RootConstrainSelectedInstOperands,
     /*  65239 */     // GIR_Coverage, 13744,
     /*  65239 */     GIR_EraseRootFromParent_Done,
     /*  65240 */   // Label 1087: @65240
     /*  65240 */   GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(65349), // Rule ID 13743 //
     /*  65245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65264 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65268 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65281 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65285 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65289 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65294 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65298 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65304 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65306 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65310 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65314 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65318 */     // MIs[4] LHS
     /*  65318 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65323 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65328 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65330 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  65330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  65339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  65343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65347 */     GIR_RootConstrainSelectedInstOperands,
     /*  65348 */     // GIR_Coverage, 13743,
     /*  65348 */     GIR_EraseRootFromParent_Done,
     /*  65349 */   // Label 1088: @65349
     /*  65349 */   GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(65458), // Rule ID 2473 //
     /*  65354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65373 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65377 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65382 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65387 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65391 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65395 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65399 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65403 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  65407 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65411 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65415 */     // MIs[3] LHS
     /*  65415 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  65420 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65424 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65430 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65432 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65437 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65439 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS), (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  65439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  65448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  65452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  65456 */     GIR_RootConstrainSelectedInstOperands,
     /*  65457 */     // GIR_Coverage, 2473,
     /*  65457 */     GIR_EraseRootFromParent_Done,
     /*  65458 */   // Label 1089: @65458
     /*  65458 */   GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(65567), // Rule ID 13739 //
     /*  65463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65482 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65486 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65491 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65496 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65500 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65504 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65508 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65512 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  65516 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65520 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65524 */     // MIs[3] LHS
     /*  65524 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  65529 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65533 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65539 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65541 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65546 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65548 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS), (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  65548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  65557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  65561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  65565 */     GIR_RootConstrainSelectedInstOperands,
     /*  65566 */     // GIR_Coverage, 13739,
     /*  65566 */     GIR_EraseRootFromParent_Done,
     /*  65567 */   // Label 1090: @65567
     /*  65567 */   GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(65676), // Rule ID 13738 //
     /*  65572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65591 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65600 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65613 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65617 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65621 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65626 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65630 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65634 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65638 */     // MIs[3] LHS
     /*  65638 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  65643 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65647 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65653 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65655 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65657 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  65657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  65666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  65670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  65674 */     GIR_RootConstrainSelectedInstOperands,
     /*  65675 */     // GIR_Coverage, 13738,
     /*  65675 */     GIR_EraseRootFromParent_Done,
     /*  65676 */   // Label 1091: @65676
     /*  65676 */   GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(65785), // Rule ID 13740 //
     /*  65681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65700 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65709 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65722 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65726 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65730 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65735 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65739 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65743 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65747 */     // MIs[3] LHS
     /*  65747 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  65752 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65756 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65762 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65764 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65766 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  65766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  65775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  65779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  65783 */     GIR_RootConstrainSelectedInstOperands,
     /*  65784 */     // GIR_Coverage, 13740,
     /*  65784 */     GIR_EraseRootFromParent_Done,
     /*  65785 */   // Label 1092: @65785
     /*  65785 */   GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(65852), // Rule ID 13705 //
     /*  65790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  65805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65814 */     // MIs[1] imm
     /*  65814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65822 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  65826 */     // MIs[2] Operand 1
     /*  65826 */     // No operand predicates
     /*  65826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65830 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65834 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65836 */     // (or:{ *:[v2i32] } (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  65839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  65843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65850 */     GIR_RootConstrainSelectedInstOperands,
     /*  65851 */     // GIR_Coverage, 13705,
     /*  65851 */     GIR_EraseRootFromParent_Done,
     /*  65852 */   // Label 1093: @65852
     /*  65852 */   GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(65919), // Rule ID 13726 //
     /*  65857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  65872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65876 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65881 */     // MIs[1] imm
     /*  65881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65889 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  65893 */     // MIs[2] Operand 1
     /*  65893 */     // No operand predicates
     /*  65893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65897 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65901 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65903 */     // (or:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  65906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  65910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65914 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65917 */     GIR_RootConstrainSelectedInstOperands,
     /*  65918 */     // GIR_Coverage, 13726,
     /*  65918 */     GIR_EraseRootFromParent_Done,
     /*  65919 */   // Label 1094: @65919
     /*  65919 */   GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(65986), // Rule ID 2239 //
     /*  65924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  65943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65952 */     // MIs[1] imm
     /*  65952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65960 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  65964 */     // MIs[2] Operand 1
     /*  65964 */     // No operand predicates
     /*  65964 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65968 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65970 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  65973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65975 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  65977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65984 */     GIR_RootConstrainSelectedInstOperands,
     /*  65985 */     // GIR_Coverage, 2239,
     /*  65985 */     GIR_EraseRootFromParent_Done,
     /*  65986 */   // Label 1095: @65986
     /*  65986 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(66053), // Rule ID 2298 //
     /*  65991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  66006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  66010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  66014 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66019 */     // MIs[1] imm
     /*  66019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66027 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  66031 */     // MIs[2] Operand 1
     /*  66031 */     // No operand predicates
     /*  66031 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  66035 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66037 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  66037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  66040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66042 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  66044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66048 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  66051 */     GIR_RootConstrainSelectedInstOperands,
     /*  66052 */     // GIR_Coverage, 2298,
     /*  66052 */     GIR_EraseRootFromParent_Done,
     /*  66053 */   // Label 1096: @66053
     /*  66053 */   GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(66117), // Rule ID 14042 //
     /*  66058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  66077 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  66081 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66090 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66096 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  66098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66102 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66104 */     // (or:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$LHS)  =>  (ORNv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  66104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  66107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  66109 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  66111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  66115 */     GIR_RootConstrainSelectedInstOperands,
     /*  66116 */     // GIR_Coverage, 14042,
     /*  66116 */     GIR_EraseRootFromParent_Done,
     /*  66117 */   // Label 1097: @66117
     /*  66117 */   GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(66181), // Rule ID 5095 //
     /*  66122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  66137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  66145 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  66149 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66158 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66164 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  66166 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66168 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }))  =>  (ORNv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  66168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  66171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  66173 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  66175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  66179 */     GIR_RootConstrainSelectedInstOperands,
     /*  66180 */     // GIR_Coverage, 5095,
     /*  66180 */     GIR_EraseRootFromParent_Done,
     /*  66181 */   // Label 1098: @66181
     /*  66181 */   GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(66208), // Rule ID 5101 //
     /*  66186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66201 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (ORRv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  66201 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  66206 */     GIR_RootConstrainSelectedInstOperands,
     /*  66207 */     // GIR_Coverage, 5101,
     /*  66207 */     GIR_Done,
     /*  66208 */   // Label 1099: @66208
     /*  66208 */   GIM_Reject,
     /*  66209 */ // Label 1084: @66209
     /*  66209 */ GIM_Reject,
     /*  66210 */ // Label 1033: @66210
     /*  66210 */ GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(67517),
     /*  66215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66218 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66221 */   GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(66330), // Rule ID 13770 //
     /*  66226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66245 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66257 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66261 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66265 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66270 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66274 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66280 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66287 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66291 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66295 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66299 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66304 */     // MIs[4] LHS
     /*  66304 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66309 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66311 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  66311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  66314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  66324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  66328 */     GIR_RootConstrainSelectedInstOperands,
     /*  66329 */     // GIR_Coverage, 13770,
     /*  66329 */     GIR_EraseRootFromParent_Done,
     /*  66330 */   // Label 1101: @66330
     /*  66330 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(66439), // Rule ID 13769 //
     /*  66335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66354 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66366 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66370 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66374 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66379 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66383 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66389 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66396 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66400 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66404 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66408 */     // MIs[4] LHS
     /*  66408 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66413 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66418 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66420 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  66420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  66423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  66433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  66437 */     GIR_RootConstrainSelectedInstOperands,
     /*  66438 */     // GIR_Coverage, 13769,
     /*  66438 */     GIR_EraseRootFromParent_Done,
     /*  66439 */   // Label 1102: @66439
     /*  66439 */   GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(66548), // Rule ID 13772 //
     /*  66444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66463 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66480 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66484 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66488 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66493 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66497 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66503 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66505 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66509 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66513 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66517 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66522 */     // MIs[4] LHS
     /*  66522 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66527 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66529 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  66529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  66532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  66542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  66546 */     GIR_RootConstrainSelectedInstOperands,
     /*  66547 */     // GIR_Coverage, 13772,
     /*  66547 */     GIR_EraseRootFromParent_Done,
     /*  66548 */   // Label 1103: @66548
     /*  66548 */   GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(66657), // Rule ID 13771 //
     /*  66553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66572 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66589 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66593 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66597 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66602 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66606 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66612 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66614 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66618 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66622 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66626 */     // MIs[4] LHS
     /*  66626 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66631 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66636 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66638 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  66638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  66641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  66651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  66655 */     GIR_RootConstrainSelectedInstOperands,
     /*  66656 */     // GIR_Coverage, 13771,
     /*  66656 */     GIR_EraseRootFromParent_Done,
     /*  66657 */   // Label 1104: @66657
     /*  66657 */   GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(66766), // Rule ID 2477 //
     /*  66662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66685 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66690 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66703 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66707 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66711 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  66715 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66719 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66723 */     // MIs[3] LHS
     /*  66723 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  66728 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66732 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66738 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66740 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66745 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66747 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  66747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  66750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  66756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  66760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  66764 */     GIR_RootConstrainSelectedInstOperands,
     /*  66765 */     // GIR_Coverage, 2477,
     /*  66765 */     GIR_EraseRootFromParent_Done,
     /*  66766 */   // Label 1105: @66766
     /*  66766 */   GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(66875), // Rule ID 13767 //
     /*  66771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66812 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66816 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66820 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  66824 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66828 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66832 */     // MIs[3] LHS
     /*  66832 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  66837 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66841 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66847 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66849 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66854 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66856 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  66856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  66859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  66865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  66869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  66873 */     GIR_RootConstrainSelectedInstOperands,
     /*  66874 */     // GIR_Coverage, 13767,
     /*  66874 */     GIR_EraseRootFromParent_Done,
     /*  66875 */   // Label 1106: @66875
     /*  66875 */   GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(66984), // Rule ID 13766 //
     /*  66880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66899 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66908 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66913 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66917 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66921 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66925 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66929 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66934 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66938 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66942 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66946 */     // MIs[3] LHS
     /*  66946 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  66951 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66955 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66961 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66963 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66965 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  66965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  66968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  66974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  66978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  66982 */     GIR_RootConstrainSelectedInstOperands,
     /*  66983 */     // GIR_Coverage, 13766,
     /*  66983 */     GIR_EraseRootFromParent_Done,
     /*  66984 */   // Label 1107: @66984
     /*  66984 */   GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(67093), // Rule ID 13768 //
     /*  66989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  67008 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  67012 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67017 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67022 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67026 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67030 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  67034 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  67038 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67043 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67047 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67051 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  67055 */     // MIs[3] LHS
     /*  67055 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  67060 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67064 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67070 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67072 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67074 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  67074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  67083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  67087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  67091 */     GIR_RootConstrainSelectedInstOperands,
     /*  67092 */     // GIR_Coverage, 13768,
     /*  67092 */     GIR_EraseRootFromParent_Done,
     /*  67093 */   // Label 1108: @67093
     /*  67093 */   GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(67160), // Rule ID 13709 //
     /*  67098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  67113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  67117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67122 */     // MIs[1] imm
     /*  67122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67130 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  67134 */     // MIs[2] Operand 1
     /*  67134 */     // No operand predicates
     /*  67134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67138 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67142 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67144 */     // (or:{ *:[v2i64] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  67147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  67151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67155 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67158 */     GIR_RootConstrainSelectedInstOperands,
     /*  67159 */     // GIR_Coverage, 13709,
     /*  67159 */     GIR_EraseRootFromParent_Done,
     /*  67160 */   // Label 1109: @67160
     /*  67160 */   GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(67227), // Rule ID 13730 //
     /*  67165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  67180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  67184 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67189 */     // MIs[1] imm
     /*  67189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67197 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  67201 */     // MIs[2] Operand 1
     /*  67201 */     // No operand predicates
     /*  67201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67205 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67209 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67211 */     // (or:{ *:[v2i64] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  67214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  67218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67222 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67225 */     GIR_RootConstrainSelectedInstOperands,
     /*  67226 */     // GIR_Coverage, 13730,
     /*  67226 */     GIR_EraseRootFromParent_Done,
     /*  67227 */   // Label 1110: @67227
     /*  67227 */   GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(67294), // Rule ID 2243 //
     /*  67232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  67247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  67251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  67255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67260 */     // MIs[1] imm
     /*  67260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67268 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  67272 */     // MIs[2] Operand 1
     /*  67272 */     // No operand predicates
     /*  67272 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67276 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67278 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  67281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67283 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  67285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67289 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67292 */     GIR_RootConstrainSelectedInstOperands,
     /*  67293 */     // GIR_Coverage, 2243,
     /*  67293 */     GIR_EraseRootFromParent_Done,
     /*  67294 */   // Label 1111: @67294
     /*  67294 */   GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(67361), // Rule ID 2302 //
     /*  67299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  67314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  67318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  67322 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67327 */     // MIs[1] imm
     /*  67327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67331 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67335 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  67339 */     // MIs[2] Operand 1
     /*  67339 */     // No operand predicates
     /*  67339 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67343 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67345 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  67348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67350 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  67352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67356 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67359 */     GIR_RootConstrainSelectedInstOperands,
     /*  67360 */     // GIR_Coverage, 2302,
     /*  67360 */     GIR_EraseRootFromParent_Done,
     /*  67361 */   // Label 1112: @67361
     /*  67361 */   GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(67425), // Rule ID 14046 //
     /*  67366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  67385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  67389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67398 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67404 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  67406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67410 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67412 */     // (or:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$LHS)  =>  (ORNv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  67412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  67415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  67417 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  67419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67423 */     GIR_RootConstrainSelectedInstOperands,
     /*  67424 */     // GIR_Coverage, 14046,
     /*  67424 */     GIR_EraseRootFromParent_Done,
     /*  67425 */   // Label 1113: @67425
     /*  67425 */   GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(67489), // Rule ID 5099 //
     /*  67430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  67445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  67453 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  67457 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67466 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67472 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  67474 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67476 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }))  =>  (ORNv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  67476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  67479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  67481 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  67483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67487 */     GIR_RootConstrainSelectedInstOperands,
     /*  67488 */     // GIR_Coverage, 5099,
     /*  67488 */     GIR_EraseRootFromParent_Done,
     /*  67489 */   // Label 1114: @67489
     /*  67489 */   GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(67516), // Rule ID 5105 //
     /*  67494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67509 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (ORRv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  67509 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  67514 */     GIR_RootConstrainSelectedInstOperands,
     /*  67515 */     // GIR_Coverage, 5105,
     /*  67515 */     GIR_Done,
     /*  67516 */   // Label 1115: @67516
     /*  67516 */   GIM_Reject,
     /*  67517 */ // Label 1100: @67517
     /*  67517 */ GIM_Reject,
     /*  67518 */ // Label 1034: @67518
     /*  67518 */ GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(68825),
     /*  67523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67526 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67529 */   GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(67638), // Rule ID 13735 //
     /*  67534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67553 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67565 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67569 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67573 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67578 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67582 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67588 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67590 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67595 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67599 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67603 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67607 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67612 */     // MIs[4] LHS
     /*  67612 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67617 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67619 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  67619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  67622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  67632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  67636 */     GIR_RootConstrainSelectedInstOperands,
     /*  67637 */     // GIR_Coverage, 13735,
     /*  67637 */     GIR_EraseRootFromParent_Done,
     /*  67638 */   // Label 1117: @67638
     /*  67638 */   GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(67747), // Rule ID 13734 //
     /*  67643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67666 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67670 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67674 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67678 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67682 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67687 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67691 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67697 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67704 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67708 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67712 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67716 */     // MIs[4] LHS
     /*  67716 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67721 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67726 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67728 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  67728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  67731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  67741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  67745 */     GIR_RootConstrainSelectedInstOperands,
     /*  67746 */     // GIR_Coverage, 13734,
     /*  67746 */     GIR_EraseRootFromParent_Done,
     /*  67747 */   // Label 1118: @67747
     /*  67747 */   GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(67856), // Rule ID 13737 //
     /*  67752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67771 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67775 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67780 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67784 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67788 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67792 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67796 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67801 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67805 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67811 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67813 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67817 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67821 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67825 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67830 */     // MIs[4] LHS
     /*  67830 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67835 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67837 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  67837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  67840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  67850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67854 */     GIR_RootConstrainSelectedInstOperands,
     /*  67855 */     // GIR_Coverage, 13737,
     /*  67855 */     GIR_EraseRootFromParent_Done,
     /*  67856 */   // Label 1119: @67856
     /*  67856 */   GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(67965), // Rule ID 13736 //
     /*  67861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67884 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67897 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67901 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67905 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67910 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67914 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67920 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67922 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67926 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67930 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67934 */     // MIs[4] LHS
     /*  67934 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67939 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67944 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67946 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  67946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  67949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  67959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67963 */     GIR_RootConstrainSelectedInstOperands,
     /*  67964 */     // GIR_Coverage, 13736,
     /*  67964 */     GIR_EraseRootFromParent_Done,
     /*  67965 */   // Label 1120: @67965
     /*  67965 */   GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(68074), // Rule ID 2472 //
     /*  67970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67993 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67998 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68003 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68007 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68011 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68015 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68019 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  68023 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68027 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68031 */     // MIs[3] LHS
     /*  68031 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  68036 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68040 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68046 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68048 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68053 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68055 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS), (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  68055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  68064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  68068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  68072 */     GIR_RootConstrainSelectedInstOperands,
     /*  68073 */     // GIR_Coverage, 2472,
     /*  68073 */     GIR_EraseRootFromParent_Done,
     /*  68074 */   // Label 1121: @68074
     /*  68074 */   GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(68183), // Rule ID 13732 //
     /*  68079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68098 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68102 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68107 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68120 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68124 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68128 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  68132 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68136 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68140 */     // MIs[3] LHS
     /*  68140 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  68145 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68149 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68155 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68157 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68162 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68164 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS), (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  68164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  68173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  68177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  68181 */     GIR_RootConstrainSelectedInstOperands,
     /*  68182 */     // GIR_Coverage, 13732,
     /*  68182 */     GIR_EraseRootFromParent_Done,
     /*  68183 */   // Label 1122: @68183
     /*  68183 */   GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(68292), // Rule ID 13731 //
     /*  68188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68207 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68211 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68216 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68229 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68233 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68237 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68242 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68246 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68250 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68254 */     // MIs[3] LHS
     /*  68254 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  68259 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68263 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68269 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68271 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68273 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  68273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  68282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  68286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  68290 */     GIR_RootConstrainSelectedInstOperands,
     /*  68291 */     // GIR_Coverage, 13731,
     /*  68291 */     GIR_EraseRootFromParent_Done,
     /*  68292 */   // Label 1123: @68292
     /*  68292 */   GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(68401), // Rule ID 13733 //
     /*  68297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68325 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68342 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68346 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68351 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68355 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68359 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68363 */     // MIs[3] LHS
     /*  68363 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  68368 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68372 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68378 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68380 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68382 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  68382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  68391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  68395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  68399 */     GIR_RootConstrainSelectedInstOperands,
     /*  68400 */     // GIR_Coverage, 13733,
     /*  68400 */     GIR_EraseRootFromParent_Done,
     /*  68401 */   // Label 1124: @68401
     /*  68401 */   GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(68468), // Rule ID 13701 //
     /*  68406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  68421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68425 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68430 */     // MIs[1] imm
     /*  68430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68438 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  68442 */     // MIs[2] Operand 1
     /*  68442 */     // No operand predicates
     /*  68442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68446 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68450 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68452 */     // (or:{ *:[v4i16] } (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  68455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  68459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68463 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68466 */     GIR_RootConstrainSelectedInstOperands,
     /*  68467 */     // GIR_Coverage, 13701,
     /*  68467 */     GIR_EraseRootFromParent_Done,
     /*  68468 */   // Label 1125: @68468
     /*  68468 */   GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(68535), // Rule ID 13722 //
     /*  68473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  68488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68492 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68497 */     // MIs[1] imm
     /*  68497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68505 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  68509 */     // MIs[2] Operand 1
     /*  68509 */     // No operand predicates
     /*  68509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68513 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68517 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68519 */     // (or:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  68522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  68526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68530 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68533 */     GIR_RootConstrainSelectedInstOperands,
     /*  68534 */     // GIR_Coverage, 13722,
     /*  68534 */     GIR_EraseRootFromParent_Done,
     /*  68535 */   // Label 1126: @68535
     /*  68535 */   GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(68602), // Rule ID 2235 //
     /*  68540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  68555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  68559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68563 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68568 */     // MIs[1] imm
     /*  68568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68576 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  68580 */     // MIs[2] Operand 1
     /*  68580 */     // No operand predicates
     /*  68580 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68584 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68586 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  68589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68591 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  68593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68600 */     GIR_RootConstrainSelectedInstOperands,
     /*  68601 */     // GIR_Coverage, 2235,
     /*  68601 */     GIR_EraseRootFromParent_Done,
     /*  68602 */   // Label 1127: @68602
     /*  68602 */   GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(68669), // Rule ID 2294 //
     /*  68607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  68622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  68626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68635 */     // MIs[1] imm
     /*  68635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68643 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  68647 */     // MIs[2] Operand 1
     /*  68647 */     // No operand predicates
     /*  68647 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68651 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68653 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  68656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68658 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  68660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68664 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68667 */     GIR_RootConstrainSelectedInstOperands,
     /*  68668 */     // GIR_Coverage, 2294,
     /*  68668 */     GIR_EraseRootFromParent_Done,
     /*  68669 */   // Label 1128: @68669
     /*  68669 */   GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(68733), // Rule ID 14041 //
     /*  68674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68693 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68697 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68706 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68712 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  68714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68718 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68720 */     // (or:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$LHS)  =>  (ORNv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  68720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  68723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  68725 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  68727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  68731 */     GIR_RootConstrainSelectedInstOperands,
     /*  68732 */     // GIR_Coverage, 14041,
     /*  68732 */     GIR_EraseRootFromParent_Done,
     /*  68733 */   // Label 1129: @68733
     /*  68733 */   GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(68797), // Rule ID 5094 //
     /*  68738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  68753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68774 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68780 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  68782 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68784 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }))  =>  (ORNv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  68784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  68787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  68789 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  68791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  68795 */     GIR_RootConstrainSelectedInstOperands,
     /*  68796 */     // GIR_Coverage, 5094,
     /*  68796 */     GIR_EraseRootFromParent_Done,
     /*  68797 */   // Label 1130: @68797
     /*  68797 */   GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(68824), // Rule ID 5100 //
     /*  68802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68817 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (ORRv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  68817 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  68822 */     GIR_RootConstrainSelectedInstOperands,
     /*  68823 */     // GIR_Coverage, 5100,
     /*  68823 */     GIR_Done,
     /*  68824 */   // Label 1131: @68824
     /*  68824 */   GIM_Reject,
     /*  68825 */ // Label 1116: @68825
     /*  68825 */ GIM_Reject,
     /*  68826 */ // Label 1035: @68826
     /*  68826 */ GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(70133),
     /*  68831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68834 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68837 */   GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(68946), // Rule ID 13763 //
     /*  68842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68861 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68873 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68877 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68881 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68886 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68890 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68896 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68898 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68903 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68907 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68911 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68915 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68920 */     // MIs[4] LHS
     /*  68920 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68925 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68927 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  68927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  68930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  68936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  68940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  68944 */     GIR_RootConstrainSelectedInstOperands,
     /*  68945 */     // GIR_Coverage, 13763,
     /*  68945 */     GIR_EraseRootFromParent_Done,
     /*  68946 */   // Label 1133: @68946
     /*  68946 */   GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(69055), // Rule ID 13762 //
     /*  68951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68970 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68974 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68978 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68982 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68986 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68990 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68995 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68999 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69005 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  69007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69012 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  69016 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69020 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69024 */     // MIs[4] LHS
     /*  69024 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69029 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69034 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69036 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  69036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  69045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  69049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  69053 */     GIR_RootConstrainSelectedInstOperands,
     /*  69054 */     // GIR_Coverage, 13762,
     /*  69054 */     GIR_EraseRootFromParent_Done,
     /*  69055 */   // Label 1134: @69055
     /*  69055 */   GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(69164), // Rule ID 13765 //
     /*  69060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69079 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69083 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69096 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69100 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69104 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69109 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69113 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69119 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  69121 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  69125 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69129 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69133 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69138 */     // MIs[4] LHS
     /*  69138 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69143 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69145 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  69145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  69154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  69158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  69162 */     GIR_RootConstrainSelectedInstOperands,
     /*  69163 */     // GIR_Coverage, 13765,
     /*  69163 */     GIR_EraseRootFromParent_Done,
     /*  69164 */   // Label 1135: @69164
     /*  69164 */   GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(69273), // Rule ID 13764 //
     /*  69169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69188 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69205 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69209 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69213 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69218 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69222 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69228 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  69230 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  69234 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69238 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69242 */     // MIs[4] LHS
     /*  69242 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69247 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69252 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69254 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  69254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  69263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  69267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  69271 */     GIR_RootConstrainSelectedInstOperands,
     /*  69272 */     // GIR_Coverage, 13764,
     /*  69272 */     GIR_EraseRootFromParent_Done,
     /*  69273 */   // Label 1136: @69273
     /*  69273 */   GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(69382), // Rule ID 2476 //
     /*  69278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69297 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69301 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69306 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69319 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69323 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69327 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  69331 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69335 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69339 */     // MIs[3] LHS
     /*  69339 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  69344 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69348 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69354 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69356 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69361 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69363 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  69363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  69372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  69376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  69380 */     GIR_RootConstrainSelectedInstOperands,
     /*  69381 */     // GIR_Coverage, 2476,
     /*  69381 */     GIR_EraseRootFromParent_Done,
     /*  69382 */   // Label 1137: @69382
     /*  69382 */   GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(69491), // Rule ID 13760 //
     /*  69387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69406 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69410 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69415 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69432 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69436 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  69440 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69444 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69448 */     // MIs[3] LHS
     /*  69448 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  69453 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69457 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69463 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69465 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69470 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69472 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  69472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  69481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  69485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  69489 */     GIR_RootConstrainSelectedInstOperands,
     /*  69490 */     // GIR_Coverage, 13760,
     /*  69490 */     GIR_EraseRootFromParent_Done,
     /*  69491 */   // Label 1138: @69491
     /*  69491 */   GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(69600), // Rule ID 13759 //
     /*  69496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69515 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69524 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69529 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69533 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69537 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69541 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69545 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69550 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69554 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69558 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69562 */     // MIs[3] LHS
     /*  69562 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  69567 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69571 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69577 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69579 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69581 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  69581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  69590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  69594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  69598 */     GIR_RootConstrainSelectedInstOperands,
     /*  69599 */     // GIR_Coverage, 13759,
     /*  69599 */     GIR_EraseRootFromParent_Done,
     /*  69600 */   // Label 1139: @69600
     /*  69600 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(69709), // Rule ID 13761 //
     /*  69605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69624 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69633 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69638 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69642 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69646 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69650 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69654 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69659 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69663 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69667 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69671 */     // MIs[3] LHS
     /*  69671 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  69676 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69680 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69686 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69688 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69690 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  69690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  69699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  69703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  69707 */     GIR_RootConstrainSelectedInstOperands,
     /*  69708 */     // GIR_Coverage, 13761,
     /*  69708 */     GIR_EraseRootFromParent_Done,
     /*  69709 */   // Label 1140: @69709
     /*  69709 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(69776), // Rule ID 13707 //
     /*  69714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  69729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69738 */     // MIs[1] imm
     /*  69738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69742 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69746 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  69750 */     // MIs[2] Operand 1
     /*  69750 */     // No operand predicates
     /*  69750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69754 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69758 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69760 */     // (or:{ *:[v4i32] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  69763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  69767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69774 */     GIR_RootConstrainSelectedInstOperands,
     /*  69775 */     // GIR_Coverage, 13707,
     /*  69775 */     GIR_EraseRootFromParent_Done,
     /*  69776 */   // Label 1141: @69776
     /*  69776 */   GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(69843), // Rule ID 13728 //
     /*  69781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  69796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69805 */     // MIs[1] imm
     /*  69805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69813 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  69817 */     // MIs[2] Operand 1
     /*  69817 */     // No operand predicates
     /*  69817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69821 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69825 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69827 */     // (or:{ *:[v4i32] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  69830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  69834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69838 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69841 */     GIR_RootConstrainSelectedInstOperands,
     /*  69842 */     // GIR_Coverage, 13728,
     /*  69842 */     GIR_EraseRootFromParent_Done,
     /*  69843 */   // Label 1142: @69843
     /*  69843 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(69910), // Rule ID 2241 //
     /*  69848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  69867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69876 */     // MIs[1] imm
     /*  69876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69884 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  69888 */     // MIs[2] Operand 1
     /*  69888 */     // No operand predicates
     /*  69888 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69892 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69894 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  69897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69899 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  69901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69908 */     GIR_RootConstrainSelectedInstOperands,
     /*  69909 */     // GIR_Coverage, 2241,
     /*  69909 */     GIR_EraseRootFromParent_Done,
     /*  69910 */   // Label 1143: @69910
     /*  69910 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(69977), // Rule ID 2300 //
     /*  69915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  69934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69943 */     // MIs[1] imm
     /*  69943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69951 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  69955 */     // MIs[2] Operand 1
     /*  69955 */     // No operand predicates
     /*  69955 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69959 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69961 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  69964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69966 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  69968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69972 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69975 */     GIR_RootConstrainSelectedInstOperands,
     /*  69976 */     // GIR_Coverage, 2300,
     /*  69976 */     GIR_EraseRootFromParent_Done,
     /*  69977 */   // Label 1144: @69977
     /*  69977 */   GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(70041), // Rule ID 14045 //
     /*  69982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  70001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70005 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70010 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70014 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70020 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  70022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70026 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70028 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$LHS)  =>  (ORNv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  70028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  70031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70033 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  70035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  70039 */     GIR_RootConstrainSelectedInstOperands,
     /*  70040 */     // GIR_Coverage, 14045,
     /*  70040 */     GIR_EraseRootFromParent_Done,
     /*  70041 */   // Label 1145: @70041
     /*  70041 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(70105), // Rule ID 5098 //
     /*  70046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  70061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  70069 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70082 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70088 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  70090 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70092 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }))  =>  (ORNv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  70092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  70095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70097 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  70099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  70103 */     GIR_RootConstrainSelectedInstOperands,
     /*  70104 */     // GIR_Coverage, 5098,
     /*  70104 */     GIR_EraseRootFromParent_Done,
     /*  70105 */   // Label 1146: @70105
     /*  70105 */   GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(70132), // Rule ID 5104 //
     /*  70110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70125 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (ORRv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  70125 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  70130 */     GIR_RootConstrainSelectedInstOperands,
     /*  70131 */     // GIR_Coverage, 5104,
     /*  70131 */     GIR_Done,
     /*  70132 */   // Label 1147: @70132
     /*  70132 */   GIM_Reject,
     /*  70133 */ // Label 1132: @70133
     /*  70133 */ GIM_Reject,
     /*  70134 */ // Label 1036: @70134
     /*  70134 */ GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(71441),
     /*  70139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70142 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70145 */   GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(70254), // Rule ID 13513 //
     /*  70150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70169 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70185 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70189 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70194 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70198 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70204 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70211 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70215 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70219 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70223 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70228 */     // MIs[4] Rd
     /*  70228 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70233 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70235 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  70235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  70238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  70244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  70248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  70252 */     GIR_RootConstrainSelectedInstOperands,
     /*  70253 */     // GIR_Coverage, 13513,
     /*  70253 */     GIR_EraseRootFromParent_Done,
     /*  70254 */   // Label 1149: @70254
     /*  70254 */   GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(70363), // Rule ID 13512 //
     /*  70259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70278 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70282 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70286 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70290 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70294 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70298 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70303 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70307 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70313 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70315 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70320 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70324 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70328 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70332 */     // MIs[4] Rd
     /*  70332 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70337 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70342 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70344 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  70344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  70347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  70353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  70357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  70361 */     GIR_RootConstrainSelectedInstOperands,
     /*  70362 */     // GIR_Coverage, 13512,
     /*  70362 */     GIR_EraseRootFromParent_Done,
     /*  70363 */   // Label 1150: @70363
     /*  70363 */   GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(70472), // Rule ID 13515 //
     /*  70368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70387 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70404 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70408 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70412 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70417 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70421 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70427 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70429 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70433 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70437 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70441 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70446 */     // MIs[4] Rd
     /*  70446 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70451 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70453 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  70453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  70456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  70462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  70466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  70470 */     GIR_RootConstrainSelectedInstOperands,
     /*  70471 */     // GIR_Coverage, 13515,
     /*  70471 */     GIR_EraseRootFromParent_Done,
     /*  70472 */   // Label 1151: @70472
     /*  70472 */   GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(70581), // Rule ID 13514 //
     /*  70477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70500 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70513 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70517 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70521 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70526 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70530 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70536 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70538 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70542 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70546 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70550 */     // MIs[4] Rd
     /*  70550 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70555 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70560 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70562 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  70562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  70565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  70571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  70575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  70579 */     GIR_RootConstrainSelectedInstOperands,
     /*  70580 */     // GIR_Coverage, 13514,
     /*  70580 */     GIR_EraseRootFromParent_Done,
     /*  70581 */   // Label 1152: @70581
     /*  70581 */   GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(70690), // Rule ID 1605 //
     /*  70586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70605 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70614 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70627 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70631 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70635 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  70639 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70643 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70647 */     // MIs[3] Rd
     /*  70647 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  70652 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70656 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70662 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70664 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70669 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70671 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn), (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  70671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  70674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  70680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  70684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  70688 */     GIR_RootConstrainSelectedInstOperands,
     /*  70689 */     // GIR_Coverage, 1605,
     /*  70689 */     GIR_EraseRootFromParent_Done,
     /*  70690 */   // Label 1153: @70690
     /*  70690 */   GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(70799), // Rule ID 13510 //
     /*  70695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70710 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70714 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70718 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70740 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70744 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  70748 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70752 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70756 */     // MIs[3] Rd
     /*  70756 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  70761 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70765 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70771 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70773 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70778 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70780 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd), (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  70780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  70783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  70789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  70797 */     GIR_RootConstrainSelectedInstOperands,
     /*  70798 */     // GIR_Coverage, 13510,
     /*  70798 */     GIR_EraseRootFromParent_Done,
     /*  70799 */   // Label 1154: @70799
     /*  70799 */   GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(70908), // Rule ID 13509 //
     /*  70804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70823 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70827 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70832 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70837 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70841 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70845 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70849 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70853 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70858 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70862 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70866 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70870 */     // MIs[3] Rd
     /*  70870 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  70875 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70879 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70885 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70887 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70889 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  70889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  70892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  70898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  70902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  70906 */     GIR_RootConstrainSelectedInstOperands,
     /*  70907 */     // GIR_Coverage, 13509,
     /*  70907 */     GIR_EraseRootFromParent_Done,
     /*  70908 */   // Label 1155: @70908
     /*  70908 */   GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(71017), // Rule ID 13511 //
     /*  70913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70932 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70941 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70946 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70950 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70954 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70958 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70962 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70967 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70971 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70975 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70979 */     // MIs[3] Rd
     /*  70979 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  70984 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70988 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70994 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70996 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70998 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  70998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  71001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  71007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  71015 */     GIR_RootConstrainSelectedInstOperands,
     /*  71016 */     // GIR_Coverage, 13511,
     /*  71016 */     GIR_EraseRootFromParent_Done,
     /*  71017 */   // Label 1156: @71017
     /*  71017 */   GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(71084), // Rule ID 13697 //
     /*  71022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  71037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  71041 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71046 */     // MIs[1] imm
     /*  71046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71054 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  71058 */     // MIs[2] Operand 1
     /*  71058 */     // No operand predicates
     /*  71058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71062 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  71066 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71068 */     // (or:{ *:[v8i8] } (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  71068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  71071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  71075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  71082 */     GIR_RootConstrainSelectedInstOperands,
     /*  71083 */     // GIR_Coverage, 13697,
     /*  71083 */     GIR_EraseRootFromParent_Done,
     /*  71084 */   // Label 1157: @71084
     /*  71084 */   GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(71151), // Rule ID 13718 //
     /*  71089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  71104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  71108 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71113 */     // MIs[1] imm
     /*  71113 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71117 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71121 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  71125 */     // MIs[2] Operand 1
     /*  71125 */     // No operand predicates
     /*  71125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71129 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  71133 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71135 */     // (or:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  71135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  71138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  71142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71146 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  71149 */     GIR_RootConstrainSelectedInstOperands,
     /*  71150 */     // GIR_Coverage, 13718,
     /*  71150 */     GIR_EraseRootFromParent_Done,
     /*  71151 */   // Label 1158: @71151
     /*  71151 */   GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(71218), // Rule ID 2231 //
     /*  71156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  71175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  71179 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71184 */     // MIs[1] imm
     /*  71184 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71188 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71192 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  71196 */     // MIs[2] Operand 1
     /*  71196 */     // No operand predicates
     /*  71196 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  71200 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71202 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  71202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  71205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71207 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  71209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  71216 */     GIR_RootConstrainSelectedInstOperands,
     /*  71217 */     // GIR_Coverage, 2231,
     /*  71217 */     GIR_EraseRootFromParent_Done,
     /*  71218 */   // Label 1159: @71218
     /*  71218 */   GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(71285), // Rule ID 2290 //
     /*  71223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  71242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  71246 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71251 */     // MIs[1] imm
     /*  71251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71255 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71259 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  71263 */     // MIs[2] Operand 1
     /*  71263 */     // No operand predicates
     /*  71263 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  71267 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71269 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  71269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  71272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71274 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  71276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71280 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  71283 */     GIR_RootConstrainSelectedInstOperands,
     /*  71284 */     // GIR_Coverage, 2290,
     /*  71284 */     GIR_EraseRootFromParent_Done,
     /*  71285 */   // Label 1160: @71285
     /*  71285 */   GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(71349), // Rule ID 13507 //
     /*  71290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  71309 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  71313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71322 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71328 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  71330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71334 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71336 */     // (or:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rn)  =>  (ORNv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  71336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  71339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  71343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  71347 */     GIR_RootConstrainSelectedInstOperands,
     /*  71348 */     // GIR_Coverage, 13507,
     /*  71348 */     GIR_EraseRootFromParent_Done,
     /*  71349 */   // Label 1161: @71349
     /*  71349 */   GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(71413), // Rule ID 1601 //
     /*  71354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  71377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  71381 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71390 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71396 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  71398 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71400 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }))  =>  (ORNv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  71400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  71403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71405 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  71407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  71411 */     GIR_RootConstrainSelectedInstOperands,
     /*  71412 */     // GIR_Coverage, 1601,
     /*  71412 */     GIR_EraseRootFromParent_Done,
     /*  71413 */   // Label 1162: @71413
     /*  71413 */   GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(71440), // Rule ID 1603 //
     /*  71418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71433 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ORRv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  71433 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  71438 */     GIR_RootConstrainSelectedInstOperands,
     /*  71439 */     // GIR_Coverage, 1603,
     /*  71439 */     GIR_Done,
     /*  71440 */   // Label 1163: @71440
     /*  71440 */   GIM_Reject,
     /*  71441 */ // Label 1148: @71441
     /*  71441 */ GIM_Reject,
     /*  71442 */ // Label 1037: @71442
     /*  71442 */ GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(72749),
     /*  71447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71453 */   GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(71562), // Rule ID 13756 //
     /*  71458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71477 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71481 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71485 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71489 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71493 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71497 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71502 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71506 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71512 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71514 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71519 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71523 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71527 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71531 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71536 */     // MIs[4] LHS
     /*  71536 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71541 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71543 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  71543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  71552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  71556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  71560 */     GIR_RootConstrainSelectedInstOperands,
     /*  71561 */     // GIR_Coverage, 13756,
     /*  71561 */     GIR_EraseRootFromParent_Done,
     /*  71562 */   // Label 1165: @71562
     /*  71562 */   GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(71671), // Rule ID 13755 //
     /*  71567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71582 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71586 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71598 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71602 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71606 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71611 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71615 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71621 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71623 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71628 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71632 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71636 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71640 */     // MIs[4] LHS
     /*  71640 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71645 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71650 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71652 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  71652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  71661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  71665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  71669 */     GIR_RootConstrainSelectedInstOperands,
     /*  71670 */     // GIR_Coverage, 13755,
     /*  71670 */     GIR_EraseRootFromParent_Done,
     /*  71671 */   // Label 1166: @71671
     /*  71671 */   GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(71780), // Rule ID 13758 //
     /*  71676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71695 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71712 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71716 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71720 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71725 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71729 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71735 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71737 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71741 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71745 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71749 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71754 */     // MIs[4] LHS
     /*  71754 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71759 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71761 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  71761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  71770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  71774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  71778 */     GIR_RootConstrainSelectedInstOperands,
     /*  71779 */     // GIR_Coverage, 13758,
     /*  71779 */     GIR_EraseRootFromParent_Done,
     /*  71780 */   // Label 1167: @71780
     /*  71780 */   GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(71889), // Rule ID 13757 //
     /*  71785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71804 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71808 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71821 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71825 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71829 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71834 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71838 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71844 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71846 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71850 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71854 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71858 */     // MIs[4] LHS
     /*  71858 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71863 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71868 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71870 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  71870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  71879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  71883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  71887 */     GIR_RootConstrainSelectedInstOperands,
     /*  71888 */     // GIR_Coverage, 13757,
     /*  71888 */     GIR_EraseRootFromParent_Done,
     /*  71889 */   // Label 1168: @71889
     /*  71889 */   GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(71998), // Rule ID 2475 //
     /*  71894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71913 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71917 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71922 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  71931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71935 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71939 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71943 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  71947 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71951 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71955 */     // MIs[3] LHS
     /*  71955 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  71960 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  71964 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71970 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  71972 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71977 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71979 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  71979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  71988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  71992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  71996 */     GIR_RootConstrainSelectedInstOperands,
     /*  71997 */     // GIR_Coverage, 2475,
     /*  71997 */     GIR_EraseRootFromParent_Done,
     /*  71998 */   // Label 1169: @71998
     /*  71998 */   GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(72107), // Rule ID 13753 //
     /*  72003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72022 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72031 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  72040 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72044 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72048 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72052 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  72056 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72060 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72064 */     // MIs[3] LHS
     /*  72064 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  72069 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  72073 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72079 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  72081 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72086 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  72088 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  72088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  72091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  72097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  72101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  72105 */     GIR_RootConstrainSelectedInstOperands,
     /*  72106 */     // GIR_Coverage, 13753,
     /*  72106 */     GIR_EraseRootFromParent_Done,
     /*  72107 */   // Label 1170: @72107
     /*  72107 */   GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(72216), // Rule ID 13752 //
     /*  72112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72131 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72135 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72140 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72145 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  72149 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72153 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72157 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72161 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72166 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72170 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72174 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72178 */     // MIs[3] LHS
     /*  72178 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  72183 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  72187 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72193 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  72195 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  72197 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  72197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  72200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  72206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  72210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  72214 */     GIR_RootConstrainSelectedInstOperands,
     /*  72215 */     // GIR_Coverage, 13752,
     /*  72215 */     GIR_EraseRootFromParent_Done,
     /*  72216 */   // Label 1171: @72216
     /*  72216 */   GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(72325), // Rule ID 13754 //
     /*  72221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72240 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72244 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  72258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72262 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72266 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72270 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72275 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72279 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72283 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72287 */     // MIs[3] LHS
     /*  72287 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  72292 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  72296 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72302 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  72304 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  72306 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  72306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  72309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  72315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  72319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  72323 */     GIR_RootConstrainSelectedInstOperands,
     /*  72324 */     // GIR_Coverage, 13754,
     /*  72324 */     GIR_EraseRootFromParent_Done,
     /*  72325 */   // Label 1172: @72325
     /*  72325 */   GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(72392), // Rule ID 13703 //
     /*  72330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  72345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72349 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72354 */     // MIs[1] imm
     /*  72354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72362 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  72366 */     // MIs[2] Operand 1
     /*  72366 */     // No operand predicates
     /*  72366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72370 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  72374 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72376 */     // (or:{ *:[v8i16] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  72376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  72379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  72383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72390 */     GIR_RootConstrainSelectedInstOperands,
     /*  72391 */     // GIR_Coverage, 13703,
     /*  72391 */     GIR_EraseRootFromParent_Done,
     /*  72392 */   // Label 1173: @72392
     /*  72392 */   GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(72459), // Rule ID 13724 //
     /*  72397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  72412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72416 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72421 */     // MIs[1] imm
     /*  72421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72429 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  72433 */     // MIs[2] Operand 1
     /*  72433 */     // No operand predicates
     /*  72433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72437 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  72441 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72443 */     // (or:{ *:[v8i16] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  72443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  72446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  72450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72454 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72457 */     GIR_RootConstrainSelectedInstOperands,
     /*  72458 */     // GIR_Coverage, 13724,
     /*  72458 */     GIR_EraseRootFromParent_Done,
     /*  72459 */   // Label 1174: @72459
     /*  72459 */   GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(72526), // Rule ID 2237 //
     /*  72464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  72483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72487 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72492 */     // MIs[1] imm
     /*  72492 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72496 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72500 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  72504 */     // MIs[2] Operand 1
     /*  72504 */     // No operand predicates
     /*  72504 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  72508 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72510 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  72510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  72513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72515 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  72517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72524 */     GIR_RootConstrainSelectedInstOperands,
     /*  72525 */     // GIR_Coverage, 2237,
     /*  72525 */     GIR_EraseRootFromParent_Done,
     /*  72526 */   // Label 1175: @72526
     /*  72526 */   GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(72593), // Rule ID 2296 //
     /*  72531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72538 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  72550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72554 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72559 */     // MIs[1] imm
     /*  72559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72567 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  72571 */     // MIs[2] Operand 1
     /*  72571 */     // No operand predicates
     /*  72571 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  72575 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72577 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  72577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  72580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72582 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  72584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72588 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72591 */     GIR_RootConstrainSelectedInstOperands,
     /*  72592 */     // GIR_Coverage, 2296,
     /*  72592 */     GIR_EraseRootFromParent_Done,
     /*  72593 */   // Label 1176: @72593
     /*  72593 */   GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(72657), // Rule ID 14044 //
     /*  72598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72617 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72621 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72630 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72636 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  72638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72642 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72644 */     // (or:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$LHS)  =>  (ORNv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  72644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  72647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72649 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  72651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  72655 */     GIR_RootConstrainSelectedInstOperands,
     /*  72656 */     // GIR_Coverage, 14044,
     /*  72656 */     GIR_EraseRootFromParent_Done,
     /*  72657 */   // Label 1177: @72657
     /*  72657 */   GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(72721), // Rule ID 5097 //
     /*  72662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72685 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72698 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72704 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  72706 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72708 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }))  =>  (ORNv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  72708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  72711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72713 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  72715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  72719 */     GIR_RootConstrainSelectedInstOperands,
     /*  72720 */     // GIR_Coverage, 5097,
     /*  72720 */     GIR_EraseRootFromParent_Done,
     /*  72721 */   // Label 1178: @72721
     /*  72721 */   GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(72748), // Rule ID 5103 //
     /*  72726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72741 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (ORRv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  72741 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  72746 */     GIR_RootConstrainSelectedInstOperands,
     /*  72747 */     // GIR_Coverage, 5103,
     /*  72747 */     GIR_Done,
     /*  72748 */   // Label 1179: @72748
     /*  72748 */   GIM_Reject,
     /*  72749 */ // Label 1164: @72749
     /*  72749 */ GIM_Reject,
     /*  72750 */ // Label 1038: @72750
     /*  72750 */ GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(74057),
     /*  72755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72758 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72761 */   GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(72870), // Rule ID 13520 //
     /*  72766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72789 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72793 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72797 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72801 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72805 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72810 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72814 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72820 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72822 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72827 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  72831 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72835 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72839 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72844 */     // MIs[4] Rd
     /*  72844 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72849 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  72851 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  72851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  72854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  72860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  72864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  72868 */     GIR_RootConstrainSelectedInstOperands,
     /*  72869 */     // GIR_Coverage, 13520,
     /*  72869 */     GIR_EraseRootFromParent_Done,
     /*  72870 */   // Label 1181: @72870
     /*  72870 */   GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(72979), // Rule ID 13519 //
     /*  72875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72894 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72902 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72906 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72910 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72914 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72919 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72923 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72929 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72936 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  72940 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72944 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72948 */     // MIs[4] Rd
     /*  72948 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72953 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72958 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  72960 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  72960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  72963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  72969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  72973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  72977 */     GIR_RootConstrainSelectedInstOperands,
     /*  72978 */     // GIR_Coverage, 13519,
     /*  72978 */     GIR_EraseRootFromParent_Done,
     /*  72979 */   // Label 1182: @72979
     /*  72979 */   GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(73088), // Rule ID 13522 //
     /*  72984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73003 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73024 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73028 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73033 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73037 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73043 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73045 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  73049 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73053 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73057 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73062 */     // MIs[4] Rd
     /*  73062 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73067 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  73069 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  73069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  73072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  73074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  73078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  73082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  73086 */     GIR_RootConstrainSelectedInstOperands,
     /*  73087 */     // GIR_Coverage, 13522,
     /*  73087 */     GIR_EraseRootFromParent_Done,
     /*  73088 */   // Label 1183: @73088
     /*  73088 */   GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(73197), // Rule ID 13521 //
     /*  73093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73112 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73116 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73121 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73125 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73129 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73133 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73137 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73142 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73146 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73152 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73154 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  73158 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73162 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73166 */     // MIs[4] Rd
     /*  73166 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73171 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73176 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  73178 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  73178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  73181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  73183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  73187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  73191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  73195 */     GIR_RootConstrainSelectedInstOperands,
     /*  73196 */     // GIR_Coverage, 13521,
     /*  73196 */     GIR_EraseRootFromParent_Done,
     /*  73197 */   // Label 1184: @73197
     /*  73197 */   GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(73306), // Rule ID 1606 //
     /*  73202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73230 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  73239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73243 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73247 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73251 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  73255 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73259 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73263 */     // MIs[3] Rd
     /*  73263 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  73268 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  73272 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73278 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  73280 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73285 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  73287 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  73287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  73290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  73292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  73296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  73300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  73304 */     GIR_RootConstrainSelectedInstOperands,
     /*  73305 */     // GIR_Coverage, 1606,
     /*  73305 */     GIR_EraseRootFromParent_Done,
     /*  73306 */   // Label 1185: @73306
     /*  73306 */   GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(73415), // Rule ID 13517 //
     /*  73311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73330 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73339 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  73348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73356 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73360 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  73364 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73368 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73372 */     // MIs[3] Rd
     /*  73372 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  73377 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  73381 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73387 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  73389 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73394 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  73396 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  73396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  73399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  73401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  73405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  73413 */     GIR_RootConstrainSelectedInstOperands,
     /*  73414 */     // GIR_Coverage, 13517,
     /*  73414 */     GIR_EraseRootFromParent_Done,
     /*  73415 */   // Label 1186: @73415
     /*  73415 */   GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(73524), // Rule ID 13516 //
     /*  73420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73439 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73443 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73448 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73453 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  73457 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73461 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73465 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73469 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73474 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73478 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73482 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73486 */     // MIs[3] Rd
     /*  73486 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  73491 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  73495 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73501 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  73503 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  73505 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  73505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  73508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  73510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  73514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  73518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  73522 */     GIR_RootConstrainSelectedInstOperands,
     /*  73523 */     // GIR_Coverage, 13516,
     /*  73523 */     GIR_EraseRootFromParent_Done,
     /*  73524 */   // Label 1187: @73524
     /*  73524 */   GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(73633), // Rule ID 13518 //
     /*  73529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73548 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73552 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73557 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73562 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  73566 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73570 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73574 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73578 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73583 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73587 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73591 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73595 */     // MIs[3] Rd
     /*  73595 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  73600 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  73604 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73610 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  73612 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  73614 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  73614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  73617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  73619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  73623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  73631 */     GIR_RootConstrainSelectedInstOperands,
     /*  73632 */     // GIR_Coverage, 13518,
     /*  73632 */     GIR_EraseRootFromParent_Done,
     /*  73633 */   // Label 1188: @73633
     /*  73633 */   GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(73700), // Rule ID 13699 //
     /*  73638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  73653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73662 */     // MIs[1] imm
     /*  73662 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73666 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  73670 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  73674 */     // MIs[2] Operand 1
     /*  73674 */     // No operand predicates
     /*  73674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73678 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  73682 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73684 */     // (or:{ *:[v16i8] } (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  73684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  73687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  73689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  73691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73695 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  73698 */     GIR_RootConstrainSelectedInstOperands,
     /*  73699 */     // GIR_Coverage, 13699,
     /*  73699 */     GIR_EraseRootFromParent_Done,
     /*  73700 */   // Label 1189: @73700
     /*  73700 */   GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(73767), // Rule ID 13720 //
     /*  73705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  73720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73729 */     // MIs[1] imm
     /*  73729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  73737 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  73741 */     // MIs[2] Operand 1
     /*  73741 */     // No operand predicates
     /*  73741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73745 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  73749 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73751 */     // (or:{ *:[v16i8] } (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  73751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  73754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  73756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  73758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73762 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  73765 */     GIR_RootConstrainSelectedInstOperands,
     /*  73766 */     // GIR_Coverage, 13720,
     /*  73766 */     GIR_EraseRootFromParent_Done,
     /*  73767 */   // Label 1190: @73767
     /*  73767 */   GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(73834), // Rule ID 2233 //
     /*  73772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  73791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73795 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73800 */     // MIs[1] imm
     /*  73800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  73808 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  73812 */     // MIs[2] Operand 1
     /*  73812 */     // No operand predicates
     /*  73812 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  73816 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73818 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  73818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  73821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  73823 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  73825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  73832 */     GIR_RootConstrainSelectedInstOperands,
     /*  73833 */     // GIR_Coverage, 2233,
     /*  73833 */     GIR_EraseRootFromParent_Done,
     /*  73834 */   // Label 1191: @73834
     /*  73834 */   GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(73901), // Rule ID 2292 //
     /*  73839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  73858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73862 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73867 */     // MIs[1] imm
     /*  73867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  73875 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  73879 */     // MIs[2] Operand 1
     /*  73879 */     // No operand predicates
     /*  73879 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  73883 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73885 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  73885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  73888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  73890 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  73892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73896 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  73899 */     GIR_RootConstrainSelectedInstOperands,
     /*  73900 */     // GIR_Coverage, 2292,
     /*  73900 */     GIR_EraseRootFromParent_Done,
     /*  73901 */   // Label 1192: @73901
     /*  73901 */   GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(73965), // Rule ID 13508 //
     /*  73906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73925 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73929 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73938 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73944 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  73946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73950 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73952 */     // (or:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rn)  =>  (ORNv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  73952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  73955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  73959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  73963 */     GIR_RootConstrainSelectedInstOperands,
     /*  73964 */     // GIR_Coverage, 13508,
     /*  73964 */     GIR_EraseRootFromParent_Done,
     /*  73965 */   // Label 1193: @73965
     /*  73965 */   GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(74029), // Rule ID 1602 //
     /*  73970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73993 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73997 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74006 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74012 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  74014 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74016 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }))  =>  (ORNv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  74016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  74019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74021 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  74023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  74027 */     GIR_RootConstrainSelectedInstOperands,
     /*  74028 */     // GIR_Coverage, 1602,
     /*  74028 */     GIR_EraseRootFromParent_Done,
     /*  74029 */   // Label 1194: @74029
     /*  74029 */   GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(74056), // Rule ID 1604 //
     /*  74034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  74037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74049 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ORRv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  74049 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  74054 */     GIR_RootConstrainSelectedInstOperands,
     /*  74055 */     // GIR_Coverage, 1604,
     /*  74055 */     GIR_Done,
     /*  74056 */   // Label 1195: @74056
     /*  74056 */   GIM_Reject,
     /*  74057 */ // Label 1180: @74057
     /*  74057 */ GIM_Reject,
     /*  74058 */ // Label 1039: @74058
     /*  74058 */ GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(74089), // Rule ID 8569 //
     /*  74063 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  74066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  74069 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  74072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  74076 */   // (or:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  74076 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  74079 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  74081 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  74083 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  74085 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  74087 */   GIR_RootConstrainSelectedInstOperands,
     /*  74088 */   // GIR_Coverage, 8569,
     /*  74088 */   GIR_EraseRootFromParent_Done,
     /*  74089 */ // Label 1196: @74089
     /*  74089 */ GIM_Reject,
     /*  74090 */ // Label 1040: @74090
     /*  74090 */ GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(74121), // Rule ID 8568 //
     /*  74095 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  74098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  74101 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  74104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  74108 */   // (or:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  74108 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  74111 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  74113 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  74115 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  74117 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  74119 */   GIR_RootConstrainSelectedInstOperands,
     /*  74120 */   // GIR_Coverage, 8568,
     /*  74120 */   GIR_EraseRootFromParent_Done,
     /*  74121 */ // Label 1197: @74121
     /*  74121 */ GIM_Reject,
     /*  74122 */ // Label 1041: @74122
     /*  74122 */ GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(77481),
     /*  74127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74130 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  74137 */   GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(74255), // Rule ID 15879 //
     /*  74142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74169 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74173 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74177 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74181 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74187 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74189 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  74193 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74197 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74201 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74205 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  74209 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74215 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  74217 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  74221 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74225 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74229 */     // MIs[6] Op3
     /*  74229 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  74234 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  74236 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  74239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  74245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  74249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  74253 */     GIR_RootConstrainSelectedInstOperands,
     /*  74254 */     // GIR_Coverage, 15879,
     /*  74254 */     GIR_EraseRootFromParent_Done,
     /*  74255 */   // Label 1199: @74255
     /*  74255 */   GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(74373), // Rule ID 15881 //
     /*  74260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74275 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74287 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74291 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74295 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74299 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74305 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74307 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  74311 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74315 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74319 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74323 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  74327 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74333 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  74335 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  74339 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74343 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74347 */     // MIs[6] Op3
     /*  74347 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74352 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  74354 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  74357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  74363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  74367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74371 */     GIR_RootConstrainSelectedInstOperands,
     /*  74372 */     // GIR_Coverage, 15881,
     /*  74372 */     GIR_EraseRootFromParent_Done,
     /*  74373 */   // Label 1200: @74373
     /*  74373 */   GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(74491), // Rule ID 15878 //
     /*  74378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74393 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74397 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74401 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74405 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74409 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74413 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74417 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74423 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74425 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  74429 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74433 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74437 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74441 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  74445 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74451 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  74453 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  74457 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74461 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74465 */     // MIs[6] Op3
     /*  74465 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  74470 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  74472 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  74475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  74481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  74485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  74489 */     GIR_RootConstrainSelectedInstOperands,
     /*  74490 */     // GIR_Coverage, 15878,
     /*  74490 */     GIR_EraseRootFromParent_Done,
     /*  74491 */   // Label 1201: @74491
     /*  74491 */   GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(74609), // Rule ID 15880 //
     /*  74496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74511 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74523 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74527 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74531 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74535 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74541 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74543 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  74547 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74551 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74555 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74559 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  74563 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74569 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  74571 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  74575 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74579 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74583 */     // MIs[6] Op3
     /*  74583 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74588 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  74590 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  74593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  74599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  74603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74607 */     GIR_RootConstrainSelectedInstOperands,
     /*  74608 */     // GIR_Coverage, 15880,
     /*  74608 */     GIR_EraseRootFromParent_Done,
     /*  74609 */   // Label 1202: @74609
     /*  74609 */   GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(74727), // Rule ID 15826 //
     /*  74614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74629 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74641 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74645 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74649 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74653 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74659 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74661 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74665 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74669 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74673 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74677 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  74681 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74685 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74689 */     // MIs[5] Op3
     /*  74689 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  74694 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  74698 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74704 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  74706 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  74708 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  74711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  74717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  74721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  74725 */     GIR_RootConstrainSelectedInstOperands,
     /*  74726 */     // GIR_Coverage, 15826,
     /*  74726 */     GIR_EraseRootFromParent_Done,
     /*  74727 */   // Label 1203: @74727
     /*  74727 */   GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(74845), // Rule ID 15831 //
     /*  74732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74747 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74759 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74763 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74767 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74771 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74777 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74779 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74783 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74787 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74791 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  74795 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74799 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74803 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74807 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  74811 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74817 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  74819 */     // MIs[4] Op3
     /*  74819 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74824 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  74826 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  74829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  74835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  74839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74843 */     GIR_RootConstrainSelectedInstOperands,
     /*  74844 */     // GIR_Coverage, 15831,
     /*  74844 */     GIR_EraseRootFromParent_Done,
     /*  74845 */   // Label 1204: @74845
     /*  74845 */   GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(74963), // Rule ID 15832 //
     /*  74850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74865 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74869 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74873 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74877 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74881 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74885 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74889 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74895 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74897 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74901 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74905 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74909 */     // MIs[4] Op3
     /*  74909 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74914 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  74918 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74922 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74926 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74930 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  74934 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74940 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  74942 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  74944 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  74947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  74953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  74957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74961 */     GIR_RootConstrainSelectedInstOperands,
     /*  74962 */     // GIR_Coverage, 15832,
     /*  74962 */     GIR_EraseRootFromParent_Done,
     /*  74963 */   // Label 1205: @74963
     /*  74963 */   GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(75081), // Rule ID 12017 //
     /*  74968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74995 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74999 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75003 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75007 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75013 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75015 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75019 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75023 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75027 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75031 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  75035 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75039 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75043 */     // MIs[5] Op3
     /*  75043 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  75048 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  75052 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75058 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  75060 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  75062 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  75065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  75071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  75075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  75079 */     GIR_RootConstrainSelectedInstOperands,
     /*  75080 */     // GIR_Coverage, 12017,
     /*  75080 */     GIR_EraseRootFromParent_Done,
     /*  75081 */   // Label 1206: @75081
     /*  75081 */   GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(75199), // Rule ID 15828 //
     /*  75086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75101 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75113 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75117 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75121 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75125 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75131 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75133 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75137 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75141 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75145 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75149 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  75153 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75157 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75161 */     // MIs[5] Op3
     /*  75161 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  75166 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  75170 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75176 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  75178 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  75180 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  75183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  75189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  75193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  75197 */     GIR_RootConstrainSelectedInstOperands,
     /*  75198 */     // GIR_Coverage, 15828,
     /*  75198 */     GIR_EraseRootFromParent_Done,
     /*  75199 */   // Label 1207: @75199
     /*  75199 */   GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(75317), // Rule ID 15829 //
     /*  75204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75215 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75219 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75223 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75227 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75231 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75235 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75239 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75243 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75249 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75251 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75255 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75259 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75263 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  75267 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75271 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75275 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75279 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  75283 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75289 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  75291 */     // MIs[4] Op3
     /*  75291 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  75296 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  75298 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  75301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  75307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  75311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  75315 */     GIR_RootConstrainSelectedInstOperands,
     /*  75316 */     // GIR_Coverage, 15829,
     /*  75316 */     GIR_EraseRootFromParent_Done,
     /*  75317 */   // Label 1208: @75317
     /*  75317 */   GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(75435), // Rule ID 15830 //
     /*  75322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75337 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75341 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75345 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75349 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75353 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75357 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75361 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75367 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75369 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75373 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75377 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75381 */     // MIs[4] Op3
     /*  75381 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  75386 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  75390 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75394 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75398 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75402 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  75406 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75412 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  75414 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  75416 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  75419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  75425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  75429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  75433 */     GIR_RootConstrainSelectedInstOperands,
     /*  75434 */     // GIR_Coverage, 15830,
     /*  75434 */     GIR_EraseRootFromParent_Done,
     /*  75435 */   // Label 1209: @75435
     /*  75435 */   GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(75553), // Rule ID 15827 //
     /*  75440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75455 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75467 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75471 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75475 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75479 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75485 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75487 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75491 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75495 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75499 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75503 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  75507 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75511 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75515 */     // MIs[5] Op3
     /*  75515 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  75520 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  75524 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75530 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  75532 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  75534 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  75537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  75543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  75547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  75551 */     GIR_RootConstrainSelectedInstOperands,
     /*  75552 */     // GIR_Coverage, 15827,
     /*  75552 */     GIR_EraseRootFromParent_Done,
     /*  75553 */   // Label 1210: @75553
     /*  75553 */   GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(75671), // Rule ID 15875 //
     /*  75558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75569 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75573 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75585 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75589 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75593 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  75597 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75601 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75605 */     // MIs[3] Op3
     /*  75605 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  75610 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  75614 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75620 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75622 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  75626 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75630 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75634 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75638 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  75642 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75648 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  75650 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  75652 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  75655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  75661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  75665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  75669 */     GIR_RootConstrainSelectedInstOperands,
     /*  75670 */     // GIR_Coverage, 15875,
     /*  75670 */     GIR_EraseRootFromParent_Done,
     /*  75671 */   // Label 1211: @75671
     /*  75671 */   GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(75789), // Rule ID 15877 //
     /*  75676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75691 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75703 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75707 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75711 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  75715 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75719 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75723 */     // MIs[3] Op3
     /*  75723 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  75728 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  75732 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75738 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75740 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  75744 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75748 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75752 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75756 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  75760 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75766 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  75768 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  75770 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  75773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  75779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  75783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  75787 */     GIR_RootConstrainSelectedInstOperands,
     /*  75788 */     // GIR_Coverage, 15877,
     /*  75788 */     GIR_EraseRootFromParent_Done,
     /*  75789 */   // Label 1212: @75789
     /*  75789 */   GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(75907), // Rule ID 12028 //
     /*  75794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75809 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75821 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75825 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75829 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  75833 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75837 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75841 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75845 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  75849 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75855 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75857 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  75861 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75865 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75869 */     // MIs[5] Op3
     /*  75869 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  75874 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  75878 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75884 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  75886 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  75888 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  75891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  75897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  75901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  75905 */     GIR_RootConstrainSelectedInstOperands,
     /*  75906 */     // GIR_Coverage, 12028,
     /*  75906 */     GIR_EraseRootFromParent_Done,
     /*  75907 */   // Label 1213: @75907
     /*  75907 */   GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(76025), // Rule ID 15876 //
     /*  75912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75927 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75931 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75935 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75939 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75943 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75947 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  75951 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75955 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75959 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75963 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  75967 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75973 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75975 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  75979 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75983 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75987 */     // MIs[5] Op3
     /*  75987 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  75992 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  75996 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76002 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  76004 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  76006 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  76009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  76015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  76019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  76023 */     GIR_RootConstrainSelectedInstOperands,
     /*  76024 */     // GIR_Coverage, 15876,
     /*  76024 */     GIR_EraseRootFromParent_Done,
     /*  76025 */   // Label 1214: @76025
     /*  76025 */   GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(76115), // Rule ID 15804 //
     /*  76030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76045 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76049 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76053 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76057 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76061 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76065 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76069 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76075 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76077 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  76081 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76085 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76089 */     // MIs[4] Op3
     /*  76089 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76094 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76096 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  76099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  76105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  76109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  76113 */     GIR_RootConstrainSelectedInstOperands,
     /*  76114 */     // GIR_Coverage, 15804,
     /*  76114 */     GIR_EraseRootFromParent_Done,
     /*  76115 */   // Label 1215: @76115
     /*  76115 */   GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(76205), // Rule ID 15803 //
     /*  76120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76147 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76151 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76155 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76159 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76165 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76167 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  76171 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76175 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76179 */     // MIs[4] Op3
     /*  76179 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76184 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76186 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  76189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  76195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  76199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  76203 */     GIR_RootConstrainSelectedInstOperands,
     /*  76204 */     // GIR_Coverage, 15803,
     /*  76204 */     GIR_EraseRootFromParent_Done,
     /*  76205 */   // Label 1216: @76205
     /*  76205 */   GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(76295), // Rule ID 15802 //
     /*  76210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76225 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  76233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76237 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76241 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76245 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76249 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76255 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76257 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  76261 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76265 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76269 */     // MIs[4] Op3
     /*  76269 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76274 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76276 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  76279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  76285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  76289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  76293 */     GIR_RootConstrainSelectedInstOperands,
     /*  76294 */     // GIR_Coverage, 15802,
     /*  76294 */     GIR_EraseRootFromParent_Done,
     /*  76295 */   // Label 1217: @76295
     /*  76295 */   GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(76385), // Rule ID 15801 //
     /*  76300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76315 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  76323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76327 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76331 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76335 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76339 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76345 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76347 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  76351 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76355 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76359 */     // MIs[4] Op3
     /*  76359 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76364 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76366 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  76369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  76375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  76379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  76383 */     GIR_RootConstrainSelectedInstOperands,
     /*  76384 */     // GIR_Coverage, 15801,
     /*  76384 */     GIR_EraseRootFromParent_Done,
     /*  76385 */   // Label 1218: @76385
     /*  76385 */   GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(76475), // Rule ID 15798 //
     /*  76390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76405 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  76413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76417 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76421 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76425 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  76429 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76433 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76437 */     // MIs[3] Op3
     /*  76437 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  76442 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  76446 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76452 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  76454 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76456 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  76459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  76465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  76469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  76473 */     GIR_RootConstrainSelectedInstOperands,
     /*  76474 */     // GIR_Coverage, 15798,
     /*  76474 */     GIR_EraseRootFromParent_Done,
     /*  76475 */   // Label 1219: @76475
     /*  76475 */   GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(76565), // Rule ID 15800 //
     /*  76480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  76503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76507 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76511 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76515 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  76519 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76523 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76527 */     // MIs[3] Op3
     /*  76527 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  76532 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  76536 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76542 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  76544 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76546 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  76549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  76555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  76559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  76563 */     GIR_RootConstrainSelectedInstOperands,
     /*  76564 */     // GIR_Coverage, 15800,
     /*  76564 */     GIR_EraseRootFromParent_Done,
     /*  76565 */   // Label 1220: @76565
     /*  76565 */   GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(76655), // Rule ID 12009 //
     /*  76570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76585 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76589 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  76593 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76597 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76601 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76605 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76609 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76613 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76617 */     // MIs[3] Op3
     /*  76617 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  76622 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  76626 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76632 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  76634 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76636 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  76639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  76645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  76649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  76653 */     GIR_RootConstrainSelectedInstOperands,
     /*  76654 */     // GIR_Coverage, 12009,
     /*  76654 */     GIR_EraseRootFromParent_Done,
     /*  76655 */   // Label 1221: @76655
     /*  76655 */   GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(76745), // Rule ID 15799 //
     /*  76660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76675 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76679 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  76683 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76687 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76691 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76695 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76699 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76703 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76707 */     // MIs[3] Op3
     /*  76707 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  76712 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  76716 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76722 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  76724 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76726 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  76729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  76735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  76739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  76743 */     GIR_RootConstrainSelectedInstOperands,
     /*  76744 */     // GIR_Coverage, 15799,
     /*  76744 */     GIR_EraseRootFromParent_Done,
     /*  76745 */   // Label 1222: @76745
     /*  76745 */   GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(76835), // Rule ID 15882 //
     /*  76750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76765 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  76773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76777 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76781 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76785 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  76789 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  76793 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76797 */     // MIs[3] Op3
     /*  76797 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  76802 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  76806 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76812 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  76814 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76816 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] }))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  76819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  76825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  76829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  76833 */     GIR_RootConstrainSelectedInstOperands,
     /*  76834 */     // GIR_Coverage, 15882,
     /*  76834 */     GIR_EraseRootFromParent_Done,
     /*  76835 */   // Label 1223: @76835
     /*  76835 */   GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(76925), // Rule ID 15884 //
     /*  76840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76859 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  76863 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76867 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76871 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76875 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  76879 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  76883 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76887 */     // MIs[3] Op3
     /*  76887 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  76892 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  76896 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76902 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  76904 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76906 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] }))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  76909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  76915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  76919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  76923 */     GIR_RootConstrainSelectedInstOperands,
     /*  76924 */     // GIR_Coverage, 15884,
     /*  76924 */     GIR_EraseRootFromParent_Done,
     /*  76925 */   // Label 1224: @76925
     /*  76925 */   GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(77015), // Rule ID 12029 //
     /*  76930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76945 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76949 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  76953 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76957 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76961 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76965 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  76969 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  76973 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76977 */     // MIs[3] Op3
     /*  76977 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  76982 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  76986 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76992 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  76994 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76996 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3), immAllOnesV:{ *:[nxv2i64] }))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  76999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  77005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  77009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  77013 */     GIR_RootConstrainSelectedInstOperands,
     /*  77014 */     // GIR_Coverage, 12029,
     /*  77014 */     GIR_EraseRootFromParent_Done,
     /*  77015 */   // Label 1225: @77015
     /*  77015 */   GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(77105), // Rule ID 15883 //
     /*  77020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77035 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77039 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  77043 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77047 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77051 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77055 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  77059 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  77063 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77067 */     // MIs[3] Op3
     /*  77067 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  77072 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  77076 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77082 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  77084 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  77086 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3), immAllOnesV:{ *:[nxv2i64] }))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  77086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  77095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  77099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  77103 */     GIR_RootConstrainSelectedInstOperands,
     /*  77104 */     // GIR_Coverage, 15883,
     /*  77104 */     GIR_EraseRootFromParent_Done,
     /*  77105 */   // Label 1226: @77105
     /*  77105 */   GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(77195), // Rule ID 15886 //
     /*  77110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77125 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  77137 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77141 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77145 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77149 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77155 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77157 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  77161 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77165 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77169 */     // MIs[4] Op3
     /*  77169 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  77174 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  77176 */     // (or:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3), immAllOnesV:{ *:[nxv2i64] }), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  77176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  77185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  77189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  77193 */     GIR_RootConstrainSelectedInstOperands,
     /*  77194 */     // GIR_Coverage, 15886,
     /*  77194 */     GIR_EraseRootFromParent_Done,
     /*  77195 */   // Label 1227: @77195
     /*  77195 */   GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(77285), // Rule ID 15888 //
     /*  77200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77215 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77219 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77223 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  77227 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77231 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77235 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77239 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77245 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77247 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  77251 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77255 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77259 */     // MIs[4] Op3
     /*  77259 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77264 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  77266 */     // (or:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] }), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  77266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  77275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  77279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77283 */     GIR_RootConstrainSelectedInstOperands,
     /*  77284 */     // GIR_Coverage, 15888,
     /*  77284 */     GIR_EraseRootFromParent_Done,
     /*  77285 */   // Label 1228: @77285
     /*  77285 */   GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(77375), // Rule ID 15885 //
     /*  77290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77305 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  77317 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77321 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77325 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77329 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77335 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77337 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  77341 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77345 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77349 */     // MIs[4] Op3
     /*  77349 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  77354 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  77356 */     // (or:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3), immAllOnesV:{ *:[nxv2i64] }), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  77356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  77365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  77369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  77373 */     GIR_RootConstrainSelectedInstOperands,
     /*  77374 */     // GIR_Coverage, 15885,
     /*  77374 */     GIR_EraseRootFromParent_Done,
     /*  77375 */   // Label 1229: @77375
     /*  77375 */   GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(77465), // Rule ID 15887 //
     /*  77380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77395 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77399 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77403 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  77407 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77411 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77415 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77419 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77425 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77427 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  77431 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77435 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77439 */     // MIs[4] Op3
     /*  77439 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77444 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  77446 */     // (or:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] }), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  77446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  77455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  77459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77463 */     GIR_RootConstrainSelectedInstOperands,
     /*  77464 */     // GIR_Coverage, 15887,
     /*  77464 */     GIR_EraseRootFromParent_Done,
     /*  77465 */   // Label 1230: @77465
     /*  77465 */   GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(77480), // Rule ID 7549 //
     /*  77470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  77473 */     // (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  77473 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  77478 */     GIR_RootConstrainSelectedInstOperands,
     /*  77479 */     // GIR_Coverage, 7549,
     /*  77479 */     GIR_Done,
     /*  77480 */   // Label 1231: @77480
     /*  77480 */   GIM_Reject,
     /*  77481 */ // Label 1198: @77481
     /*  77481 */ GIM_Reject,
     /*  77482 */ // Label 1042: @77482
     /*  77482 */ GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(77513), // Rule ID 8567 //
     /*  77487 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  77490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  77493 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  77496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  77500 */   // (or:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  77500 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  77503 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  77505 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  77507 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  77509 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  77511 */   GIR_RootConstrainSelectedInstOperands,
     /*  77512 */   // GIR_Coverage, 8567,
     /*  77512 */   GIR_EraseRootFromParent_Done,
     /*  77513 */ // Label 1232: @77513
     /*  77513 */ GIM_Reject,
     /*  77514 */ // Label 1043: @77514
     /*  77514 */ GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(80873),
     /*  77519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77522 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  77529 */   GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(77647), // Rule ID 15865 //
     /*  77534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77549 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77561 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77565 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77569 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77573 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77579 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77581 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  77585 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77589 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77593 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77597 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  77601 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77607 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  77609 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  77613 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77617 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77621 */     // MIs[6] Op3
     /*  77621 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  77626 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  77628 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  77637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  77641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  77645 */     GIR_RootConstrainSelectedInstOperands,
     /*  77646 */     // GIR_Coverage, 15865,
     /*  77646 */     GIR_EraseRootFromParent_Done,
     /*  77647 */   // Label 1234: @77647
     /*  77647 */   GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(77765), // Rule ID 15867 //
     /*  77652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77667 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77679 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77683 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77687 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77691 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77697 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77699 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  77703 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77707 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77711 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77715 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  77719 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77725 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  77727 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  77731 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77735 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77739 */     // MIs[6] Op3
     /*  77739 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77744 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  77746 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  77755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  77759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77763 */     GIR_RootConstrainSelectedInstOperands,
     /*  77764 */     // GIR_Coverage, 15867,
     /*  77764 */     GIR_EraseRootFromParent_Done,
     /*  77765 */   // Label 1235: @77765
     /*  77765 */   GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(77883), // Rule ID 15864 //
     /*  77770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77789 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77793 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77797 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77801 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77805 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77809 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77815 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77817 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  77821 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77825 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77829 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77833 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  77837 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77843 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  77845 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  77849 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77853 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77857 */     // MIs[6] Op3
     /*  77857 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  77862 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  77864 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  77873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  77877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  77881 */     GIR_RootConstrainSelectedInstOperands,
     /*  77882 */     // GIR_Coverage, 15864,
     /*  77882 */     GIR_EraseRootFromParent_Done,
     /*  77883 */   // Label 1236: @77883
     /*  77883 */   GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(78001), // Rule ID 15866 //
     /*  77888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77903 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77915 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77919 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77923 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77927 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77933 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77935 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  77939 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77943 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77947 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77951 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  77955 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77961 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  77963 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  77967 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77971 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77975 */     // MIs[6] Op3
     /*  77975 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77980 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  77982 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  77991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  77995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77999 */     GIR_RootConstrainSelectedInstOperands,
     /*  78000 */     // GIR_Coverage, 15866,
     /*  78000 */     GIR_EraseRootFromParent_Done,
     /*  78001 */   // Label 1237: @78001
     /*  78001 */   GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(78119), // Rule ID 15819 //
     /*  78006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78033 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78037 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78041 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78045 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78051 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78053 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  78057 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78061 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78065 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78069 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  78073 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78077 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78081 */     // MIs[5] Op3
     /*  78081 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  78086 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  78090 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78096 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  78098 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  78100 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  78103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  78109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  78113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  78117 */     GIR_RootConstrainSelectedInstOperands,
     /*  78118 */     // GIR_Coverage, 15819,
     /*  78118 */     GIR_EraseRootFromParent_Done,
     /*  78119 */   // Label 1238: @78119
     /*  78119 */   GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(78237), // Rule ID 15824 //
     /*  78124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78139 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78151 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78155 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78159 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78163 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78169 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78171 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  78175 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78179 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78183 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  78187 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78191 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78195 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78199 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  78203 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78209 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  78211 */     // MIs[4] Op3
     /*  78211 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78216 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  78218 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  78221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  78227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78235 */     GIR_RootConstrainSelectedInstOperands,
     /*  78236 */     // GIR_Coverage, 15824,
     /*  78236 */     GIR_EraseRootFromParent_Done,
     /*  78237 */   // Label 1239: @78237
     /*  78237 */   GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(78355), // Rule ID 15825 //
     /*  78242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78257 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78269 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78273 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78277 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78281 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78287 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78289 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  78293 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78297 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78301 */     // MIs[4] Op3
     /*  78301 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78306 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  78310 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78314 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78318 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78322 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  78326 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78332 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  78334 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  78336 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  78339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  78345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78353 */     GIR_RootConstrainSelectedInstOperands,
     /*  78354 */     // GIR_Coverage, 15825,
     /*  78354 */     GIR_EraseRootFromParent_Done,
     /*  78355 */   // Label 1240: @78355
     /*  78355 */   GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(78473), // Rule ID 12015 //
     /*  78360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78387 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78391 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78395 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78399 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78405 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78407 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  78411 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78415 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78419 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78423 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  78427 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78431 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78435 */     // MIs[5] Op3
     /*  78435 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  78440 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  78444 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78450 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  78452 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  78454 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  78457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  78463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  78467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  78471 */     GIR_RootConstrainSelectedInstOperands,
     /*  78472 */     // GIR_Coverage, 12015,
     /*  78472 */     GIR_EraseRootFromParent_Done,
     /*  78473 */   // Label 1241: @78473
     /*  78473 */   GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(78591), // Rule ID 15821 //
     /*  78478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78493 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78505 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78509 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78513 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78517 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78523 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78525 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  78529 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78533 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78537 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78541 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  78545 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78549 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78553 */     // MIs[5] Op3
     /*  78553 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  78558 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  78562 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78568 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  78570 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  78572 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  78575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  78581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  78585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  78589 */     GIR_RootConstrainSelectedInstOperands,
     /*  78590 */     // GIR_Coverage, 15821,
     /*  78590 */     GIR_EraseRootFromParent_Done,
     /*  78591 */   // Label 1242: @78591
     /*  78591 */   GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(78709), // Rule ID 15822 //
     /*  78596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78611 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78623 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78627 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78631 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78635 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78641 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78643 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  78647 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78651 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78655 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  78659 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78663 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78667 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78671 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  78675 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78681 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  78683 */     // MIs[4] Op3
     /*  78683 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78688 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  78690 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  78693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  78699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78707 */     GIR_RootConstrainSelectedInstOperands,
     /*  78708 */     // GIR_Coverage, 15822,
     /*  78708 */     GIR_EraseRootFromParent_Done,
     /*  78709 */   // Label 1243: @78709
     /*  78709 */   GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(78827), // Rule ID 15823 //
     /*  78714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78729 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78733 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78737 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78741 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78745 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78749 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78753 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78759 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78761 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  78765 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78769 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78773 */     // MIs[4] Op3
     /*  78773 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78778 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  78782 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78786 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78790 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78794 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  78798 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78804 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  78806 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  78808 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  78811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  78817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78825 */     GIR_RootConstrainSelectedInstOperands,
     /*  78826 */     // GIR_Coverage, 15823,
     /*  78826 */     GIR_EraseRootFromParent_Done,
     /*  78827 */   // Label 1244: @78827
     /*  78827 */   GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(78945), // Rule ID 15820 //
     /*  78832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78851 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78859 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78863 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78867 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78871 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78877 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78879 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  78883 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78887 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78891 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78895 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  78899 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78903 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78907 */     // MIs[5] Op3
     /*  78907 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  78912 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  78916 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78922 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  78924 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  78926 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  78929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  78935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  78939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  78943 */     GIR_RootConstrainSelectedInstOperands,
     /*  78944 */     // GIR_Coverage, 15820,
     /*  78944 */     GIR_EraseRootFromParent_Done,
     /*  78945 */   // Label 1245: @78945
     /*  78945 */   GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(79063), // Rule ID 15861 //
     /*  78950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78965 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78969 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78973 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78977 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78981 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78985 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  78989 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78993 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78997 */     // MIs[3] Op3
     /*  78997 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  79002 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  79006 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79012 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  79014 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  79018 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79022 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79026 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79030 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  79034 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79040 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  79042 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  79044 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  79053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  79057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  79061 */     GIR_RootConstrainSelectedInstOperands,
     /*  79062 */     // GIR_Coverage, 15861,
     /*  79062 */     GIR_EraseRootFromParent_Done,
     /*  79063 */   // Label 1246: @79063
     /*  79063 */   GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(79181), // Rule ID 15863 //
     /*  79068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79083 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  79091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79095 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79099 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79103 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  79107 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79111 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79115 */     // MIs[3] Op3
     /*  79115 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  79120 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  79124 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79130 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  79132 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  79136 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79140 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79144 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79148 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  79152 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79158 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  79160 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  79162 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  79171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  79175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  79179 */     GIR_RootConstrainSelectedInstOperands,
     /*  79180 */     // GIR_Coverage, 15863,
     /*  79180 */     GIR_EraseRootFromParent_Done,
     /*  79181 */   // Label 1247: @79181
     /*  79181 */   GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(79299), // Rule ID 12025 //
     /*  79186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79201 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  79209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79213 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79217 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79221 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  79225 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79229 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79233 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79237 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  79241 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79247 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  79249 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  79253 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79257 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79261 */     // MIs[5] Op3
     /*  79261 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  79266 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  79270 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79276 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  79278 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  79280 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  79289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  79293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  79297 */     GIR_RootConstrainSelectedInstOperands,
     /*  79298 */     // GIR_Coverage, 12025,
     /*  79298 */     GIR_EraseRootFromParent_Done,
     /*  79299 */   // Label 1248: @79299
     /*  79299 */   GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(79417), // Rule ID 15862 //
     /*  79304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79319 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79323 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  79327 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79331 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79335 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79339 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  79343 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79347 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79351 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79355 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  79359 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79365 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  79367 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  79371 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79375 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79379 */     // MIs[5] Op3
     /*  79379 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  79384 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  79388 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79394 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  79396 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  79398 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  79407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  79411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  79415 */     GIR_RootConstrainSelectedInstOperands,
     /*  79416 */     // GIR_Coverage, 15862,
     /*  79416 */     GIR_EraseRootFromParent_Done,
     /*  79417 */   // Label 1249: @79417
     /*  79417 */   GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(79507), // Rule ID 15797 //
     /*  79422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79437 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79441 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79445 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79449 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79453 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79457 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79461 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79467 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79469 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  79473 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79477 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79481 */     // MIs[4] Op3
     /*  79481 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79486 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  79488 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  79491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  79497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  79501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79505 */     GIR_RootConstrainSelectedInstOperands,
     /*  79506 */     // GIR_Coverage, 15797,
     /*  79506 */     GIR_EraseRootFromParent_Done,
     /*  79507 */   // Label 1250: @79507
     /*  79507 */   GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(79597), // Rule ID 15796 //
     /*  79512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79527 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79531 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79535 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79539 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79543 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79547 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79551 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79557 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79559 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  79563 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79567 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79571 */     // MIs[4] Op3
     /*  79571 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79576 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  79578 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  79581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  79587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  79591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79595 */     GIR_RootConstrainSelectedInstOperands,
     /*  79596 */     // GIR_Coverage, 15796,
     /*  79596 */     GIR_EraseRootFromParent_Done,
     /*  79597 */   // Label 1251: @79597
     /*  79597 */   GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(79687), // Rule ID 15795 //
     /*  79602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79617 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79629 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79633 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79637 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79641 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79647 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79649 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  79653 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79657 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79661 */     // MIs[4] Op3
     /*  79661 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79666 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  79668 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  79671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  79677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  79681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79685 */     GIR_RootConstrainSelectedInstOperands,
     /*  79686 */     // GIR_Coverage, 15795,
     /*  79686 */     GIR_EraseRootFromParent_Done,
     /*  79687 */   // Label 1252: @79687
     /*  79687 */   GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(79777), // Rule ID 15794 //
     /*  79692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79707 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79719 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79723 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79727 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79731 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79737 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79739 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  79743 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79747 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79751 */     // MIs[4] Op3
     /*  79751 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79756 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  79758 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  79761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  79767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  79771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79775 */     GIR_RootConstrainSelectedInstOperands,
     /*  79776 */     // GIR_Coverage, 15794,
     /*  79776 */     GIR_EraseRootFromParent_Done,
     /*  79777 */   // Label 1253: @79777
     /*  79777 */   GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(79867), // Rule ID 15791 //
     /*  79782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79797 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  79805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79809 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79813 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79817 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  79821 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79825 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79829 */     // MIs[3] Op3
     /*  79829 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  79834 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  79838 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79844 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  79846 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  79848 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  79851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  79857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  79861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  79865 */     GIR_RootConstrainSelectedInstOperands,
     /*  79866 */     // GIR_Coverage, 15791,
     /*  79866 */     GIR_EraseRootFromParent_Done,
     /*  79867 */   // Label 1254: @79867
     /*  79867 */   GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(79957), // Rule ID 15793 //
     /*  79872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79887 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  79895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79899 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79903 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79907 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  79911 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79915 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79919 */     // MIs[3] Op3
     /*  79919 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  79924 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  79928 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79934 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  79936 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  79938 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  79941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  79947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  79951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  79955 */     GIR_RootConstrainSelectedInstOperands,
     /*  79956 */     // GIR_Coverage, 15793,
     /*  79956 */     GIR_EraseRootFromParent_Done,
     /*  79957 */   // Label 1255: @79957
     /*  79957 */   GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(80047), // Rule ID 12007 //
     /*  79962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79977 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  79985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79989 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79993 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79997 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  80001 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80005 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80009 */     // MIs[3] Op3
     /*  80009 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  80014 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  80018 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80024 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  80026 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  80028 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  80028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  80031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  80037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  80041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  80045 */     GIR_RootConstrainSelectedInstOperands,
     /*  80046 */     // GIR_Coverage, 12007,
     /*  80046 */     GIR_EraseRootFromParent_Done,
     /*  80047 */   // Label 1256: @80047
     /*  80047 */   GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(80137), // Rule ID 15792 //
     /*  80052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  80075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80079 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80083 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80087 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  80091 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80095 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80099 */     // MIs[3] Op3
     /*  80099 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  80104 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  80108 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80114 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  80116 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  80118 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  80118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  80121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  80127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  80131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  80135 */     GIR_RootConstrainSelectedInstOperands,
     /*  80136 */     // GIR_Coverage, 15792,
     /*  80136 */     GIR_EraseRootFromParent_Done,
     /*  80137 */   // Label 1257: @80137
     /*  80137 */   GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(80227), // Rule ID 15868 //
     /*  80142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  80165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80169 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80173 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80177 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  80181 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  80185 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80189 */     // MIs[3] Op3
     /*  80189 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  80194 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  80198 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80204 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  80206 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  80208 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] }))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  80208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  80211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  80217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  80221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  80225 */     GIR_RootConstrainSelectedInstOperands,
     /*  80226 */     // GIR_Coverage, 15868,
     /*  80226 */     GIR_EraseRootFromParent_Done,
     /*  80227 */   // Label 1258: @80227
     /*  80227 */   GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(80317), // Rule ID 15870 //
     /*  80232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80247 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  80255 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80259 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80263 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80267 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  80271 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  80275 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80279 */     // MIs[3] Op3
     /*  80279 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  80284 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  80288 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80294 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  80296 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  80298 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] }))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  80298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  80301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  80307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  80311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  80315 */     GIR_RootConstrainSelectedInstOperands,
     /*  80316 */     // GIR_Coverage, 15870,
     /*  80316 */     GIR_EraseRootFromParent_Done,
     /*  80317 */   // Label 1259: @80317
     /*  80317 */   GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(80407), // Rule ID 12026 //
     /*  80322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80337 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80341 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  80345 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80349 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80353 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80357 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  80361 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  80365 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80369 */     // MIs[3] Op3
     /*  80369 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  80374 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  80378 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80384 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  80386 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  80388 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3), immAllOnesV:{ *:[nxv4i32] }))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  80388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  80391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  80397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  80401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  80405 */     GIR_RootConstrainSelectedInstOperands,
     /*  80406 */     // GIR_Coverage, 12026,
     /*  80406 */     GIR_EraseRootFromParent_Done,
     /*  80407 */   // Label 1260: @80407
     /*  80407 */   GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(80497), // Rule ID 15869 //
     /*  80412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80427 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80431 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  80435 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80439 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80443 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80447 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  80451 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  80455 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80459 */     // MIs[3] Op3
     /*  80459 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  80464 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  80468 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80474 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  80476 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  80478 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3), immAllOnesV:{ *:[nxv4i32] }))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  80478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  80481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  80487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  80491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  80495 */     GIR_RootConstrainSelectedInstOperands,
     /*  80496 */     // GIR_Coverage, 15869,
     /*  80496 */     GIR_EraseRootFromParent_Done,
     /*  80497 */   // Label 1261: @80497
     /*  80497 */   GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(80587), // Rule ID 15872 //
     /*  80502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80517 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80521 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80525 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  80529 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80533 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80537 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  80541 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80547 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  80549 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  80553 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80557 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80561 */     // MIs[4] Op3
     /*  80561 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  80566 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  80568 */     // (or:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3), immAllOnesV:{ *:[nxv4i32] }), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  80568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  80571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  80577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  80581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  80585 */     GIR_RootConstrainSelectedInstOperands,
     /*  80586 */     // GIR_Coverage, 15872,
     /*  80586 */     GIR_EraseRootFromParent_Done,
     /*  80587 */   // Label 1262: @80587
     /*  80587 */   GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(80677), // Rule ID 15874 //
     /*  80592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80611 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80615 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  80619 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80623 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80627 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  80631 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80637 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  80639 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  80643 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80647 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80651 */     // MIs[4] Op3
     /*  80651 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80656 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  80658 */     // (or:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] }), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  80658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  80661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  80667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  80671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  80675 */     GIR_RootConstrainSelectedInstOperands,
     /*  80676 */     // GIR_Coverage, 15874,
     /*  80676 */     GIR_EraseRootFromParent_Done,
     /*  80677 */   // Label 1263: @80677
     /*  80677 */   GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(80767), // Rule ID 15871 //
     /*  80682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  80709 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80713 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80717 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  80721 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80727 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  80729 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  80733 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80737 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80741 */     // MIs[4] Op3
     /*  80741 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  80746 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  80748 */     // (or:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3), immAllOnesV:{ *:[nxv4i32] }), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  80748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  80751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  80757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  80761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  80765 */     GIR_RootConstrainSelectedInstOperands,
     /*  80766 */     // GIR_Coverage, 15871,
     /*  80766 */     GIR_EraseRootFromParent_Done,
     /*  80767 */   // Label 1264: @80767
     /*  80767 */   GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(80857), // Rule ID 15873 //
     /*  80772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80787 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  80799 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80803 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80807 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  80811 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80817 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  80819 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  80823 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80827 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80831 */     // MIs[4] Op3
     /*  80831 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80836 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  80838 */     // (or:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] }), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  80838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  80841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  80847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  80851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  80855 */     GIR_RootConstrainSelectedInstOperands,
     /*  80856 */     // GIR_Coverage, 15873,
     /*  80856 */     GIR_EraseRootFromParent_Done,
     /*  80857 */   // Label 1265: @80857
     /*  80857 */   GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(80872), // Rule ID 7548 //
     /*  80862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  80865 */     // (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  80865 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  80870 */     GIR_RootConstrainSelectedInstOperands,
     /*  80871 */     // GIR_Coverage, 7548,
     /*  80871 */     GIR_Done,
     /*  80872 */   // Label 1266: @80872
     /*  80872 */   GIM_Reject,
     /*  80873 */ // Label 1233: @80873
     /*  80873 */ GIM_Reject,
     /*  80874 */ // Label 1044: @80874
     /*  80874 */ GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(80905), // Rule ID 8566 //
     /*  80879 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  80882 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  80885 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  80888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  80892 */   // (or:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  80892 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  80895 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  80897 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  80899 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  80901 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  80903 */   GIR_RootConstrainSelectedInstOperands,
     /*  80904 */   // GIR_Coverage, 8566,
     /*  80904 */   GIR_EraseRootFromParent_Done,
     /*  80905 */ // Label 1267: @80905
     /*  80905 */ GIM_Reject,
     /*  80906 */ // Label 1045: @80906
     /*  80906 */ GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(84265),
     /*  80911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80914 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  80921 */   GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(81039), // Rule ID 15851 //
     /*  80926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80941 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80945 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80949 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80953 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80957 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80961 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  80965 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80971 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  80973 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  80977 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80981 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80985 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80989 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  80993 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80999 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  81001 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  81005 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81009 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81013 */     // MIs[6] Op3
     /*  81013 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  81018 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  81020 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  81023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  81029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  81033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  81037 */     GIR_RootConstrainSelectedInstOperands,
     /*  81038 */     // GIR_Coverage, 15851,
     /*  81038 */     GIR_EraseRootFromParent_Done,
     /*  81039 */   // Label 1269: @81039
     /*  81039 */   GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(81157), // Rule ID 15853 //
     /*  81044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81059 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81071 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81075 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81079 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81083 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81089 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  81091 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  81095 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81099 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81103 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81107 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  81111 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81117 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  81119 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  81123 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81127 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81131 */     // MIs[6] Op3
     /*  81131 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  81136 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  81138 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  81141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  81147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  81151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  81155 */     GIR_RootConstrainSelectedInstOperands,
     /*  81156 */     // GIR_Coverage, 15853,
     /*  81156 */     GIR_EraseRootFromParent_Done,
     /*  81157 */   // Label 1270: @81157
     /*  81157 */   GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(81275), // Rule ID 15850 //
     /*  81162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81177 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81181 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81185 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81189 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81193 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81197 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81201 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81207 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  81209 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  81213 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81217 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81221 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81225 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  81229 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81235 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  81237 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  81241 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81245 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81249 */     // MIs[6] Op3
     /*  81249 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  81254 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  81256 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  81259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  81265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  81269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  81273 */     GIR_RootConstrainSelectedInstOperands,
     /*  81274 */     // GIR_Coverage, 15850,
     /*  81274 */     GIR_EraseRootFromParent_Done,
     /*  81275 */   // Label 1271: @81275
     /*  81275 */   GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(81393), // Rule ID 15852 //
     /*  81280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81295 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81307 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81311 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81315 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81319 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81325 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  81327 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  81331 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81335 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81339 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81343 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  81347 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81353 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  81355 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  81359 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81363 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81367 */     // MIs[6] Op3
     /*  81367 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  81372 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  81374 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  81377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  81383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  81387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  81391 */     GIR_RootConstrainSelectedInstOperands,
     /*  81392 */     // GIR_Coverage, 15852,
     /*  81392 */     GIR_EraseRootFromParent_Done,
     /*  81393 */   // Label 1272: @81393
     /*  81393 */   GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(81511), // Rule ID 15812 //
     /*  81398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81417 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81421 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81425 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81429 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81433 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81437 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81443 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  81445 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  81449 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81453 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81457 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81461 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  81465 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81469 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81473 */     // MIs[5] Op3
     /*  81473 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  81478 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  81482 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81488 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  81490 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  81492 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  81495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  81501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  81505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  81509 */     GIR_RootConstrainSelectedInstOperands,
     /*  81510 */     // GIR_Coverage, 15812,
     /*  81510 */     GIR_EraseRootFromParent_Done,
     /*  81511 */   // Label 1273: @81511
     /*  81511 */   GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(81629), // Rule ID 15817 //
     /*  81516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81531 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81535 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81539 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81543 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81547 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81551 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81555 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81561 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  81563 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  81567 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81571 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81575 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  81579 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81583 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81587 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81591 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  81595 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81601 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  81603 */     // MIs[4] Op3
     /*  81603 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  81608 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  81610 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  81613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  81619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  81623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  81627 */     GIR_RootConstrainSelectedInstOperands,
     /*  81628 */     // GIR_Coverage, 15817,
     /*  81628 */     GIR_EraseRootFromParent_Done,
     /*  81629 */   // Label 1274: @81629
     /*  81629 */   GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(81747), // Rule ID 15818 //
     /*  81634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81649 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81661 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81665 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81669 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81673 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81679 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  81681 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  81685 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81689 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81693 */     // MIs[4] Op3
     /*  81693 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  81698 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  81702 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81706 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81710 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81714 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  81718 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81724 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  81726 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  81728 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  81731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  81737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  81741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  81745 */     GIR_RootConstrainSelectedInstOperands,
     /*  81746 */     // GIR_Coverage, 15818,
     /*  81746 */     GIR_EraseRootFromParent_Done,
     /*  81747 */   // Label 1275: @81747
     /*  81747 */   GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(81865), // Rule ID 12013 //
     /*  81752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81767 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81779 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81783 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81787 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81791 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81797 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  81799 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  81803 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81807 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81811 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81815 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  81819 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81823 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81827 */     // MIs[5] Op3
     /*  81827 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  81832 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  81836 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81842 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  81844 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  81846 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  81849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  81855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  81859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  81863 */     GIR_RootConstrainSelectedInstOperands,
     /*  81864 */     // GIR_Coverage, 12013,
     /*  81864 */     GIR_EraseRootFromParent_Done,
     /*  81865 */   // Label 1276: @81865
     /*  81865 */   GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(81983), // Rule ID 15814 //
     /*  81870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81885 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  81893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81897 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81901 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81905 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81909 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81915 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  81917 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  81921 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81925 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81929 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81933 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  81937 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81941 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81945 */     // MIs[5] Op3
     /*  81945 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  81950 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  81954 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81960 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  81962 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  81964 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  81967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  81973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  81977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  81981 */     GIR_RootConstrainSelectedInstOperands,
     /*  81982 */     // GIR_Coverage, 15814,
     /*  81982 */     GIR_EraseRootFromParent_Done,
     /*  81983 */   // Label 1277: @81983
     /*  81983 */   GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(82101), // Rule ID 15815 //
     /*  81988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82003 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  82011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82015 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82019 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82023 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  82027 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82033 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  82035 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  82039 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82043 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82047 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  82051 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82055 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82059 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82063 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  82067 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82073 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  82075 */     // MIs[4] Op3
     /*  82075 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  82080 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  82082 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  82085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  82091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  82095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  82099 */     GIR_RootConstrainSelectedInstOperands,
     /*  82100 */     // GIR_Coverage, 15815,
     /*  82100 */     GIR_EraseRootFromParent_Done,
     /*  82101 */   // Label 1278: @82101
     /*  82101 */   GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(82219), // Rule ID 15816 //
     /*  82106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  82129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82133 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82137 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82141 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  82145 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82151 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  82153 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  82157 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82161 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82165 */     // MIs[4] Op3
     /*  82165 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  82170 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  82174 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82178 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82182 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82186 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  82190 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82196 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  82198 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  82200 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  82203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  82209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  82213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  82217 */     GIR_RootConstrainSelectedInstOperands,
     /*  82218 */     // GIR_Coverage, 15816,
     /*  82218 */     GIR_EraseRootFromParent_Done,
     /*  82219 */   // Label 1279: @82219
     /*  82219 */   GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(82337), // Rule ID 15813 //
     /*  82224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82239 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82243 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  82247 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82251 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82255 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82259 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  82263 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82269 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  82271 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  82275 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82279 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82283 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82287 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  82291 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82295 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82299 */     // MIs[5] Op3
     /*  82299 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  82304 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  82308 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82314 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  82316 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  82318 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  82321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  82327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  82331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  82335 */     GIR_RootConstrainSelectedInstOperands,
     /*  82336 */     // GIR_Coverage, 15813,
     /*  82336 */     GIR_EraseRootFromParent_Done,
     /*  82337 */   // Label 1280: @82337
     /*  82337 */   GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(82455), // Rule ID 15847 //
     /*  82342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82357 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82361 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  82365 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82369 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82373 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82377 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  82381 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82385 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82389 */     // MIs[3] Op3
     /*  82389 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  82394 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  82398 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82404 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  82406 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  82410 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82414 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82418 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82422 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  82426 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82432 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  82434 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  82436 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  82445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  82449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  82453 */     GIR_RootConstrainSelectedInstOperands,
     /*  82454 */     // GIR_Coverage, 15847,
     /*  82454 */     GIR_EraseRootFromParent_Done,
     /*  82455 */   // Label 1281: @82455
     /*  82455 */   GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(82573), // Rule ID 15849 //
     /*  82460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82475 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82479 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  82483 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82487 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82491 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82495 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  82499 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82503 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82507 */     // MIs[3] Op3
     /*  82507 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  82512 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  82516 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82522 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  82524 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  82528 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82532 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82536 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82540 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  82544 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82550 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  82552 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  82554 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  82563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  82567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  82571 */     GIR_RootConstrainSelectedInstOperands,
     /*  82572 */     // GIR_Coverage, 15849,
     /*  82572 */     GIR_EraseRootFromParent_Done,
     /*  82573 */   // Label 1282: @82573
     /*  82573 */   GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(82691), // Rule ID 12022 //
     /*  82578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82593 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82597 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  82601 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82605 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82609 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82613 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  82617 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82621 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82625 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82629 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  82633 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82639 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  82641 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  82645 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82649 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82653 */     // MIs[5] Op3
     /*  82653 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  82658 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  82662 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82668 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  82670 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  82672 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  82681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  82685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  82689 */     GIR_RootConstrainSelectedInstOperands,
     /*  82690 */     // GIR_Coverage, 12022,
     /*  82690 */     GIR_EraseRootFromParent_Done,
     /*  82691 */   // Label 1283: @82691
     /*  82691 */   GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(82809), // Rule ID 15848 //
     /*  82696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82711 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82715 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  82719 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82723 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82727 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82731 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  82735 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82739 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82743 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82747 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  82751 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82757 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  82759 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  82763 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82767 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82771 */     // MIs[5] Op3
     /*  82771 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  82776 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  82780 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82786 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  82788 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  82790 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  82799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  82803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  82807 */     GIR_RootConstrainSelectedInstOperands,
     /*  82808 */     // GIR_Coverage, 15848,
     /*  82808 */     GIR_EraseRootFromParent_Done,
     /*  82809 */   // Label 1284: @82809
     /*  82809 */   GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(82899), // Rule ID 15790 //
     /*  82814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82829 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82833 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82837 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82841 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82845 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82849 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  82853 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82859 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  82861 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  82865 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82869 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82873 */     // MIs[4] Op3
     /*  82873 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  82878 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82880 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  82883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  82889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  82893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  82897 */     GIR_RootConstrainSelectedInstOperands,
     /*  82898 */     // GIR_Coverage, 15790,
     /*  82898 */     GIR_EraseRootFromParent_Done,
     /*  82899 */   // Label 1285: @82899
     /*  82899 */   GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(82989), // Rule ID 15789 //
     /*  82904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82919 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82931 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82935 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82939 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  82943 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82949 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  82951 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  82955 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82959 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82963 */     // MIs[4] Op3
     /*  82963 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  82968 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82970 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  82973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  82979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  82983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  82987 */     GIR_RootConstrainSelectedInstOperands,
     /*  82988 */     // GIR_Coverage, 15789,
     /*  82988 */     GIR_EraseRootFromParent_Done,
     /*  82989 */   // Label 1286: @82989
     /*  82989 */   GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(83079), // Rule ID 15788 //
     /*  82994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83009 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83013 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  83017 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83021 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83025 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83029 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83033 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83039 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  83041 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  83045 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83049 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83053 */     // MIs[4] Op3
     /*  83053 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  83058 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83060 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  83060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  83063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  83069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  83073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  83077 */     GIR_RootConstrainSelectedInstOperands,
     /*  83078 */     // GIR_Coverage, 15788,
     /*  83078 */     GIR_EraseRootFromParent_Done,
     /*  83079 */   // Label 1287: @83079
     /*  83079 */   GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(83169), // Rule ID 15787 //
     /*  83084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83095 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83099 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  83107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83111 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83115 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83119 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83123 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83129 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  83131 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  83135 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83139 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83143 */     // MIs[4] Op3
     /*  83143 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  83148 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83150 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  83150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  83153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  83159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  83163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  83167 */     GIR_RootConstrainSelectedInstOperands,
     /*  83168 */     // GIR_Coverage, 15787,
     /*  83168 */     GIR_EraseRootFromParent_Done,
     /*  83169 */   // Label 1288: @83169
     /*  83169 */   GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(83259), // Rule ID 15784 //
     /*  83174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83189 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83193 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  83197 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83201 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83205 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83209 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  83213 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83217 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83221 */     // MIs[3] Op3
     /*  83221 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  83226 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  83230 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83236 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  83238 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83240 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  83240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  83243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  83249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  83253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  83257 */     GIR_RootConstrainSelectedInstOperands,
     /*  83258 */     // GIR_Coverage, 15784,
     /*  83258 */     GIR_EraseRootFromParent_Done,
     /*  83259 */   // Label 1289: @83259
     /*  83259 */   GIM_Try, /*On fail goto*//*Label 1290*/ GIMT_Encode4(83349), // Rule ID 15786 //
     /*  83264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83279 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83283 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  83287 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83291 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83295 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83299 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  83303 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83307 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83311 */     // MIs[3] Op3
     /*  83311 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  83316 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  83320 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83326 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  83328 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83330 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  83330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  83333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  83339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  83343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  83347 */     GIR_RootConstrainSelectedInstOperands,
     /*  83348 */     // GIR_Coverage, 15786,
     /*  83348 */     GIR_EraseRootFromParent_Done,
     /*  83349 */   // Label 1290: @83349
     /*  83349 */   GIM_Try, /*On fail goto*//*Label 1291*/ GIMT_Encode4(83439), // Rule ID 12005 //
     /*  83354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83369 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83373 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  83377 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83381 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83385 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83389 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83393 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83397 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83401 */     // MIs[3] Op3
     /*  83401 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  83406 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  83410 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83416 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  83418 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83420 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  83420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  83423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  83429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  83433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  83437 */     GIR_RootConstrainSelectedInstOperands,
     /*  83438 */     // GIR_Coverage, 12005,
     /*  83438 */     GIR_EraseRootFromParent_Done,
     /*  83439 */   // Label 1291: @83439
     /*  83439 */   GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(83529), // Rule ID 15785 //
     /*  83444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83455 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83459 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  83467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83471 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83475 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83479 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83483 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83487 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83491 */     // MIs[3] Op3
     /*  83491 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  83496 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  83500 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83506 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  83508 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83510 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  83510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  83513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  83519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  83523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  83527 */     GIR_RootConstrainSelectedInstOperands,
     /*  83528 */     // GIR_Coverage, 15785,
     /*  83528 */     GIR_EraseRootFromParent_Done,
     /*  83529 */   // Label 1292: @83529
     /*  83529 */   GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(83619), // Rule ID 15854 //
     /*  83534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83549 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  83557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83561 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83565 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83569 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  83573 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  83577 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83581 */     // MIs[3] Op3
     /*  83581 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  83586 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  83590 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83596 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  83598 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83600 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] }))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  83600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  83603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  83609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  83613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  83617 */     GIR_RootConstrainSelectedInstOperands,
     /*  83618 */     // GIR_Coverage, 15854,
     /*  83618 */     GIR_EraseRootFromParent_Done,
     /*  83619 */   // Label 1293: @83619
     /*  83619 */   GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(83709), // Rule ID 15856 //
     /*  83624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83639 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  83647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83651 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83655 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83659 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  83663 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  83667 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83671 */     // MIs[3] Op3
     /*  83671 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  83676 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  83680 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83686 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  83688 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83690 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] }))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  83690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  83693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  83699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  83703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  83707 */     GIR_RootConstrainSelectedInstOperands,
     /*  83708 */     // GIR_Coverage, 15856,
     /*  83708 */     GIR_EraseRootFromParent_Done,
     /*  83709 */   // Label 1294: @83709
     /*  83709 */   GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(83799), // Rule ID 12023 //
     /*  83714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83729 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83733 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  83737 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83741 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83745 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83749 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  83753 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  83757 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83761 */     // MIs[3] Op3
     /*  83761 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  83766 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  83770 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83776 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  83778 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83780 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3), immAllOnesV:{ *:[nxv8i16] }))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  83780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  83783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  83789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  83793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  83797 */     GIR_RootConstrainSelectedInstOperands,
     /*  83798 */     // GIR_Coverage, 12023,
     /*  83798 */     GIR_EraseRootFromParent_Done,
     /*  83799 */   // Label 1295: @83799
     /*  83799 */   GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(83889), // Rule ID 15855 //
     /*  83804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83819 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83823 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  83827 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83831 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83835 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83839 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  83843 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  83847 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83851 */     // MIs[3] Op3
     /*  83851 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  83856 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  83860 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83866 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  83868 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83870 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3), immAllOnesV:{ *:[nxv8i16] }))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  83870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  83873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  83879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  83883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  83887 */     GIR_RootConstrainSelectedInstOperands,
     /*  83888 */     // GIR_Coverage, 15855,
     /*  83888 */     GIR_EraseRootFromParent_Done,
     /*  83889 */   // Label 1296: @83889
     /*  83889 */   GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(83979), // Rule ID 15858 //
     /*  83894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83909 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83913 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83917 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  83921 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83925 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83929 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  83933 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83939 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  83941 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  83945 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83949 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83953 */     // MIs[4] Op3
     /*  83953 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  83958 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83960 */     // (or:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3), immAllOnesV:{ *:[nxv8i16] }), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  83960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  83963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  83969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  83973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  83977 */     GIR_RootConstrainSelectedInstOperands,
     /*  83978 */     // GIR_Coverage, 15858,
     /*  83978 */     GIR_EraseRootFromParent_Done,
     /*  83979 */   // Label 1297: @83979
     /*  83979 */   GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(84069), // Rule ID 15860 //
     /*  83984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83999 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  84003 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84007 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  84011 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  84015 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  84019 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  84023 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84029 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84031 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  84035 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84039 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  84043 */     // MIs[4] Op3
     /*  84043 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  84048 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  84050 */     // (or:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] }), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  84050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  84053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  84059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  84063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  84067 */     GIR_RootConstrainSelectedInstOperands,
     /*  84068 */     // GIR_Coverage, 15860,
     /*  84068 */     GIR_EraseRootFromParent_Done,
     /*  84069 */   // Label 1298: @84069
     /*  84069 */   GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(84159), // Rule ID 15857 //
     /*  84074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  84089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  84093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  84101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  84105 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  84109 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  84113 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84119 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84121 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  84125 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84129 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  84133 */     // MIs[4] Op3
     /*  84133 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  84138 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  84140 */     // (or:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3), immAllOnesV:{ *:[nxv8i16] }), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  84140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  84143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  84149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  84153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  84157 */     GIR_RootConstrainSelectedInstOperands,
     /*  84158 */     // GIR_Coverage, 15857,
     /*  84158 */     GIR_EraseRootFromParent_Done,
     /*  84159 */   // Label 1299: @84159
     /*  84159 */   GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(84249), // Rule ID 15859 //
     /*  84164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  84179 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  84183 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84187 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  84191 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  84195 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  84199 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  84203 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84209 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84211 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  84215 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84219 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  84223 */     // MIs[4] Op3
     /*  84223 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  84228 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  84230 */     // (or:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] }), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  84230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  84233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  84239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  84243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  84247 */     GIR_RootConstrainSelectedInstOperands,
     /*  84248 */     // GIR_Coverage, 15859,
     /*  84248 */     GIR_EraseRootFromParent_Done,
     /*  84249 */   // Label 1300: @84249
     /*  84249 */   GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(84264), // Rule ID 7547 //
     /*  84254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  84257 */     // (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  84257 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  84262 */     GIR_RootConstrainSelectedInstOperands,
     /*  84263 */     // GIR_Coverage, 7547,
     /*  84263 */     GIR_Done,
     /*  84264 */   // Label 1301: @84264
     /*  84264 */   GIM_Reject,
     /*  84265 */ // Label 1268: @84265
     /*  84265 */ GIM_Reject,
     /*  84266 */ // Label 1046: @84266
     /*  84266 */ GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(84297), // Rule ID 8565 //
     /*  84271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  84274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  84277 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  84280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  84284 */   // (or:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  84284 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  84287 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  84289 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  84291 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  84293 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  84295 */   GIR_RootConstrainSelectedInstOperands,
     /*  84296 */   // GIR_Coverage, 8565,
     /*  84296 */   GIR_EraseRootFromParent_Done,
     /*  84297 */ // Label 1302: @84297
     /*  84297 */ GIM_Reject,
     /*  84298 */ // Label 1047: @84298
     /*  84298 */ GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(87657),
     /*  84303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84306 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  84313 */   GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(84431), // Rule ID 15837 //
     /*  84318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84333 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84337 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84341 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84345 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84349 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84353 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  84357 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84363 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84365 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  84369 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84373 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84377 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84381 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  84385 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84391 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  84393 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  84397 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84401 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84405 */     // MIs[6] Op3
     /*  84405 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  84410 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  84412 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  84415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  84421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  84425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  84429 */     GIR_RootConstrainSelectedInstOperands,
     /*  84430 */     // GIR_Coverage, 15837,
     /*  84430 */     GIR_EraseRootFromParent_Done,
     /*  84431 */   // Label 1304: @84431
     /*  84431 */   GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(84549), // Rule ID 15839 //
     /*  84436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84451 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84463 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84467 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84471 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  84475 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84481 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84483 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  84487 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84491 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84495 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84499 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  84503 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84509 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  84511 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  84515 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84519 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84523 */     // MIs[6] Op3
     /*  84523 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  84528 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  84530 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  84533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  84539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  84543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  84547 */     GIR_RootConstrainSelectedInstOperands,
     /*  84548 */     // GIR_Coverage, 15839,
     /*  84548 */     GIR_EraseRootFromParent_Done,
     /*  84549 */   // Label 1305: @84549
     /*  84549 */   GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(84667), // Rule ID 15836 //
     /*  84554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84569 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84581 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84585 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84589 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  84593 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84599 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84601 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  84605 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84609 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84613 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84617 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  84621 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84627 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  84629 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  84633 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84637 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84641 */     // MIs[6] Op3
     /*  84641 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  84646 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  84648 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  84651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  84657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  84661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  84665 */     GIR_RootConstrainSelectedInstOperands,
     /*  84666 */     // GIR_Coverage, 15836,
     /*  84666 */     GIR_EraseRootFromParent_Done,
     /*  84667 */   // Label 1306: @84667
     /*  84667 */   GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(84785), // Rule ID 15838 //
     /*  84672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84687 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84699 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84703 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84707 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  84711 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84717 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84719 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  84723 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84727 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84731 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84735 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  84739 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84745 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  84747 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  84751 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84755 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84759 */     // MIs[6] Op3
     /*  84759 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  84764 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  84766 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  84769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  84775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  84779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  84783 */     GIR_RootConstrainSelectedInstOperands,
     /*  84784 */     // GIR_Coverage, 15838,
     /*  84784 */     GIR_EraseRootFromParent_Done,
     /*  84785 */   // Label 1307: @84785
     /*  84785 */   GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(84903), // Rule ID 15805 //
     /*  84790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84801 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84805 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84809 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84813 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84817 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84821 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84825 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  84829 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84835 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84837 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  84841 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84845 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84849 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84853 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  84857 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84861 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84865 */     // MIs[5] Op3
     /*  84865 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  84870 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  84874 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84880 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  84882 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  84884 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  84887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  84893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  84897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  84901 */     GIR_RootConstrainSelectedInstOperands,
     /*  84902 */     // GIR_Coverage, 15805,
     /*  84902 */     GIR_EraseRootFromParent_Done,
     /*  84903 */   // Label 1308: @84903
     /*  84903 */   GIM_Try, /*On fail goto*//*Label 1309*/ GIMT_Encode4(85021), // Rule ID 15810 //
     /*  84908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84935 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84939 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84943 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  84947 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84953 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84955 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  84959 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84963 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84967 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  84971 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84975 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84979 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84983 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  84987 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84993 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  84995 */     // MIs[4] Op3
     /*  84995 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  85000 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  85002 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  85005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  85011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  85015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  85019 */     GIR_RootConstrainSelectedInstOperands,
     /*  85020 */     // GIR_Coverage, 15810,
     /*  85020 */     GIR_EraseRootFromParent_Done,
     /*  85021 */   // Label 1309: @85021
     /*  85021 */   GIM_Try, /*On fail goto*//*Label 1310*/ GIMT_Encode4(85139), // Rule ID 15811 //
     /*  85026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85041 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  85049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85053 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85057 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85061 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  85065 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85071 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  85073 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  85077 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85081 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85085 */     // MIs[4] Op3
     /*  85085 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  85090 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  85094 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85098 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85102 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85106 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  85110 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85116 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  85118 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  85120 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  85123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  85129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  85133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  85137 */     GIR_RootConstrainSelectedInstOperands,
     /*  85138 */     // GIR_Coverage, 15811,
     /*  85138 */     GIR_EraseRootFromParent_Done,
     /*  85139 */   // Label 1310: @85139
     /*  85139 */   GIM_Try, /*On fail goto*//*Label 1311*/ GIMT_Encode4(85257), // Rule ID 12011 //
     /*  85144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85159 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  85167 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85171 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85175 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85179 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  85183 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85189 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  85191 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  85195 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85199 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85203 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85207 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  85211 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85215 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85219 */     // MIs[5] Op3
     /*  85219 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  85224 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  85228 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85234 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  85236 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  85238 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  85241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  85247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  85251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  85255 */     GIR_RootConstrainSelectedInstOperands,
     /*  85256 */     // GIR_Coverage, 12011,
     /*  85256 */     GIR_EraseRootFromParent_Done,
     /*  85257 */   // Label 1311: @85257
     /*  85257 */   GIM_Try, /*On fail goto*//*Label 1312*/ GIMT_Encode4(85375), // Rule ID 15807 //
     /*  85262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85277 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  85285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85289 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85293 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85297 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  85301 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85307 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  85309 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  85313 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85317 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85321 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85325 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  85329 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85333 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85337 */     // MIs[5] Op3
     /*  85337 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  85342 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  85346 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85352 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  85354 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  85356 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  85359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  85365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  85369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  85373 */     GIR_RootConstrainSelectedInstOperands,
     /*  85374 */     // GIR_Coverage, 15807,
     /*  85374 */     GIR_EraseRootFromParent_Done,
     /*  85375 */   // Label 1312: @85375
     /*  85375 */   GIM_Try, /*On fail goto*//*Label 1313*/ GIMT_Encode4(85493), // Rule ID 15808 //
     /*  85380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85395 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85399 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  85403 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85407 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85411 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85415 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  85419 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85425 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  85427 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  85431 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85435 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85439 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  85443 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85447 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85451 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85455 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  85459 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85465 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  85467 */     // MIs[4] Op3
     /*  85467 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  85472 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  85474 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  85477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  85483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  85487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  85491 */     GIR_RootConstrainSelectedInstOperands,
     /*  85492 */     // GIR_Coverage, 15808,
     /*  85492 */     GIR_EraseRootFromParent_Done,
     /*  85493 */   // Label 1313: @85493
     /*  85493 */   GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(85611), // Rule ID 15809 //
     /*  85498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85513 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  85521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85525 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85529 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85533 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  85537 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85543 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  85545 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  85549 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85553 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85557 */     // MIs[4] Op3
     /*  85557 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  85562 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  85566 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85570 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85574 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85578 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  85582 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85588 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  85590 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  85592 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  85595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  85601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  85605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  85609 */     GIR_RootConstrainSelectedInstOperands,
     /*  85610 */     // GIR_Coverage, 15809,
     /*  85610 */     GIR_EraseRootFromParent_Done,
     /*  85611 */   // Label 1314: @85611
     /*  85611 */   GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(85729), // Rule ID 15806 //
     /*  85616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85631 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  85639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85643 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85647 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85651 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  85655 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85661 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  85663 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  85667 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85671 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85675 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85679 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  85683 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85687 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85691 */     // MIs[5] Op3
     /*  85691 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  85696 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  85700 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85706 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  85708 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  85710 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  85713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  85719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  85723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  85727 */     GIR_RootConstrainSelectedInstOperands,
     /*  85728 */     // GIR_Coverage, 15806,
     /*  85728 */     GIR_EraseRootFromParent_Done,
     /*  85729 */   // Label 1315: @85729
     /*  85729 */   GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(85847), // Rule ID 15833 //
     /*  85734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85749 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  85757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85761 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85765 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85769 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  85773 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85777 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85781 */     // MIs[3] Op3
     /*  85781 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  85786 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  85790 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85796 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  85798 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  85802 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85806 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85810 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85814 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  85818 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85824 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  85826 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  85828 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  85831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  85837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  85841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  85845 */     GIR_RootConstrainSelectedInstOperands,
     /*  85846 */     // GIR_Coverage, 15833,
     /*  85846 */     GIR_EraseRootFromParent_Done,
     /*  85847 */   // Label 1316: @85847
     /*  85847 */   GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(85965), // Rule ID 15835 //
     /*  85852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85871 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  85875 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85879 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85883 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85887 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  85891 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85895 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85899 */     // MIs[3] Op3
     /*  85899 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  85904 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  85908 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85914 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  85916 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  85920 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85924 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85928 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85932 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  85936 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85942 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  85944 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  85946 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  85949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  85955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  85959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  85963 */     GIR_RootConstrainSelectedInstOperands,
     /*  85964 */     // GIR_Coverage, 15835,
     /*  85964 */     GIR_EraseRootFromParent_Done,
     /*  85965 */   // Label 1317: @85965
     /*  85965 */   GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(86083), // Rule ID 12019 //
     /*  85970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85985 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  85993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85997 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86001 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86005 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  86009 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86013 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86017 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86021 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  86025 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86031 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  86033 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  86037 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86041 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86045 */     // MIs[5] Op3
     /*  86045 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  86050 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  86054 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86060 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  86062 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  86064 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  86067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  86073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  86077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  86081 */     GIR_RootConstrainSelectedInstOperands,
     /*  86082 */     // GIR_Coverage, 12019,
     /*  86082 */     GIR_EraseRootFromParent_Done,
     /*  86083 */   // Label 1318: @86083
     /*  86083 */   GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(86201), // Rule ID 15834 //
     /*  86088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  86091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  86111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86115 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86119 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86123 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  86127 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86131 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86135 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86139 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  86143 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86149 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  86151 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  86155 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86159 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86163 */     // MIs[5] Op3
     /*  86163 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  86168 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  86172 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86178 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  86180 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  86182 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  86185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  86191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  86195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  86199 */     GIR_RootConstrainSelectedInstOperands,
     /*  86200 */     // GIR_Coverage, 15834,
     /*  86200 */     GIR_EraseRootFromParent_Done,
     /*  86201 */   // Label 1319: @86201
     /*  86201 */   GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(86291), // Rule ID 15783 //
     /*  86206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  86209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86225 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  86229 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86233 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86237 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86241 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  86245 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86251 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  86253 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  86257 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86261 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86265 */     // MIs[4] Op3
     /*  86265 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  86270 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  86272 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  86275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  86281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  86285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  86289 */     GIR_RootConstrainSelectedInstOperands,
     /*  86290 */     // GIR_Coverage, 15783,
     /*  86290 */     GIR_EraseRootFromParent_Done,
     /*  86291 */   // Label 1320: @86291
     /*  86291 */   GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(86381), // Rule ID 15782 //
     /*  86296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  86299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86311 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  86319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86323 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86327 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86331 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  86335 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86341 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  86343 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  86347 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86351 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86355 */     // MIs[4] Op3
     /*  86355 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  86360 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  86362 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  86365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  86371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  86375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  86379 */     GIR_RootConstrainSelectedInstOperands,
     /*  86380 */     // GIR_Coverage, 15782,
     /*  86380 */     GIR_EraseRootFromParent_Done,
     /*  86381 */   // Label 1321: @86381
     /*  86381 */   GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(86471), // Rule ID 15781 //
     /*  86386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  86389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86405 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  86409 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86413 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86417 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86421 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  86425 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86431 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  86433 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  86437 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86441 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86445 */     // MIs[4] Op3
     /*  86445 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  86450 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  86452 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  86455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  86461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  86465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  86469 */     GIR_RootConstrainSelectedInstOperands,
     /*  86470 */     // GIR_Coverage, 15781,
     /*  86470 */     GIR_EraseRootFromParent_Done,
     /*  86471 */   // Label 1322: @86471
     /*  86471 */   GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(86561), // Rule ID 15780 //
     /*  86476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  86479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86491 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  86499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86503 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86507 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86511 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  86515 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86521 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  86523 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  86527 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86531 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86535 */     // MIs[4] Op3
     /*  86535 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  86540 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  86542 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  86545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  86551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  86555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  86559 */     GIR_RootConstrainSelectedInstOperands,
     /*  86560 */     // GIR_Coverage, 15780,
     /*  86560 */     GIR_EraseRootFromParent_Done,
     /*  86561 */   // Label 1323: @86561
     /*  86561 */   GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(86651), // Rule ID 15777 //
     /*  86566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  86569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86581 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86585 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  86589 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86593 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86597 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86601 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  86605 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86609 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86613 */     // MIs[3] Op3
     /*  86613 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  86618 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  86622 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86628 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  86630 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  86632 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  86635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  86641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  86645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  86649 */     GIR_RootConstrainSelectedInstOperands,
     /*  86650 */     // GIR_Coverage, 15777,
     /*  86650 */     GIR_EraseRootFromParent_Done,
     /*  86651 */   // Label 1324: @86651
     /*  86651 */   GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(86741), // Rule ID 15779 //
     /*  86656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  86659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86671 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  86679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86683 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86687 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86691 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  86695 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86699 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86703 */     // MIs[3] Op3
     /*  86703 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  86708 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  86712 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86718 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  86720 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  86722 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  86725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  86731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  86735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  86739 */     GIR_RootConstrainSelectedInstOperands,
     /*  86740 */     // GIR_Coverage, 15779,
     /*  86740 */     GIR_EraseRootFromParent_Done,
     /*  86741 */   // Label 1325: @86741
     /*  86741 */   GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(86831), // Rule ID 12003 //
     /*  86746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  86749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86765 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  86769 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86773 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86777 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86781 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  86785 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86789 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86793 */     // MIs[3] Op3
     /*  86793 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  86798 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  86802 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86808 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  86810 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  86812 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  86815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  86821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  86825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  86829 */     GIR_RootConstrainSelectedInstOperands,
     /*  86830 */     // GIR_Coverage, 12003,
     /*  86830 */     GIR_EraseRootFromParent_Done,
     /*  86831 */   // Label 1326: @86831
     /*  86831 */   GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(86921), // Rule ID 15778 //
     /*  86836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  86839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86851 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86855 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  86859 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86863 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86867 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86871 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  86875 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86879 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86883 */     // MIs[3] Op3
     /*  86883 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  86888 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  86892 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86898 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  86900 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  86902 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  86905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  86911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  86915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  86919 */     GIR_RootConstrainSelectedInstOperands,
     /*  86920 */     // GIR_Coverage, 15778,
     /*  86920 */     GIR_EraseRootFromParent_Done,
     /*  86921 */   // Label 1327: @86921
     /*  86921 */   GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(87011), // Rule ID 15840 //
     /*  86926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  86929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86941 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86945 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  86949 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86953 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86957 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86961 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  86965 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  86969 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86973 */     // MIs[3] Op3
     /*  86973 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  86978 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  86982 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86988 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  86990 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  86992 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] }))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  86995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  87001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  87005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  87009 */     GIR_RootConstrainSelectedInstOperands,
     /*  87010 */     // GIR_Coverage, 15840,
     /*  87010 */     GIR_EraseRootFromParent_Done,
     /*  87011 */   // Label 1328: @87011
     /*  87011 */   GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(87101), // Rule ID 15842 //
     /*  87016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  87019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  87027 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87031 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  87039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87043 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87047 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87051 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  87055 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  87059 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87063 */     // MIs[3] Op3
     /*  87063 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  87068 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  87072 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87078 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  87080 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  87082 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] }))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  87082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  87085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  87087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  87091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  87095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  87099 */     GIR_RootConstrainSelectedInstOperands,
     /*  87100 */     // GIR_Coverage, 15842,
     /*  87100 */     GIR_EraseRootFromParent_Done,
     /*  87101 */   // Label 1329: @87101
     /*  87101 */   GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(87191), // Rule ID 12020 //
     /*  87106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  87109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  87117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  87129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87133 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87137 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87141 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  87145 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  87149 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87153 */     // MIs[3] Op3
     /*  87153 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  87158 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  87162 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87168 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  87170 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  87172 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3), immAllOnesV:{ *:[nxv16i8] }))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  87172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  87175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  87177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  87181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  87185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  87189 */     GIR_RootConstrainSelectedInstOperands,
     /*  87190 */     // GIR_Coverage, 12020,
     /*  87190 */     GIR_EraseRootFromParent_Done,
     /*  87191 */   // Label 1330: @87191
     /*  87191 */   GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(87281), // Rule ID 15841 //
     /*  87196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  87199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  87207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  87219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87223 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87227 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87231 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  87235 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  87239 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87243 */     // MIs[3] Op3
     /*  87243 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  87248 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  87252 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87258 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  87260 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  87262 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3), immAllOnesV:{ *:[nxv16i8] }))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  87262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  87265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  87267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  87271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  87275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  87279 */     GIR_RootConstrainSelectedInstOperands,
     /*  87280 */     // GIR_Coverage, 15841,
     /*  87280 */     GIR_EraseRootFromParent_Done,
     /*  87281 */   // Label 1331: @87281
     /*  87281 */   GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(87371), // Rule ID 15844 //
     /*  87286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  87289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87301 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  87309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  87313 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87317 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87321 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  87325 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87331 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  87333 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  87337 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  87341 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87345 */     // MIs[4] Op3
     /*  87345 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  87350 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  87352 */     // (or:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3), immAllOnesV:{ *:[nxv16i8] }), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  87352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  87355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  87357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  87361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  87365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  87369 */     GIR_RootConstrainSelectedInstOperands,
     /*  87370 */     // GIR_Coverage, 15844,
     /*  87370 */     GIR_EraseRootFromParent_Done,
     /*  87371 */   // Label 1332: @87371
     /*  87371 */   GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(87461), // Rule ID 15846 //
     /*  87376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  87379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87391 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  87399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  87403 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87407 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87411 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  87415 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87421 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  87423 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  87427 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  87431 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87435 */     // MIs[4] Op3
     /*  87435 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  87440 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  87442 */     // (or:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] }), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  87442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  87445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  87447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  87451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  87455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  87459 */     GIR_RootConstrainSelectedInstOperands,
     /*  87460 */     // GIR_Coverage, 15846,
     /*  87460 */     GIR_EraseRootFromParent_Done,
     /*  87461 */   // Label 1333: @87461
     /*  87461 */   GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(87551), // Rule ID 15843 //
     /*  87466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  87469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87481 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  87489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  87493 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87497 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87501 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  87505 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87511 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  87513 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  87517 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  87521 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87525 */     // MIs[4] Op3
     /*  87525 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  87530 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  87532 */     // (or:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3), immAllOnesV:{ *:[nxv16i8] }), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  87532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  87535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  87537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  87541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  87545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  87549 */     GIR_RootConstrainSelectedInstOperands,
     /*  87550 */     // GIR_Coverage, 15843,
     /*  87550 */     GIR_EraseRootFromParent_Done,
     /*  87551 */   // Label 1334: @87551
     /*  87551 */   GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(87641), // Rule ID 15845 //
     /*  87556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  87559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87571 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  87579 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  87583 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87587 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87591 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  87595 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87601 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  87603 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  87607 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  87611 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87615 */     // MIs[4] Op3
     /*  87615 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  87620 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  87622 */     // (or:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] }), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  87622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  87625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  87627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  87631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  87635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  87639 */     GIR_RootConstrainSelectedInstOperands,
     /*  87640 */     // GIR_Coverage, 15845,
     /*  87640 */     GIR_EraseRootFromParent_Done,
     /*  87641 */   // Label 1335: @87641
     /*  87641 */   GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(87656), // Rule ID 7546 //
     /*  87646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  87649 */     // (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  87649 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  87654 */     GIR_RootConstrainSelectedInstOperands,
     /*  87655 */     // GIR_Coverage, 7546,
     /*  87655 */     GIR_Done,
     /*  87656 */   // Label 1336: @87656
     /*  87656 */   GIM_Reject,
     /*  87657 */ // Label 1303: @87657
     /*  87657 */ GIM_Reject,
     /*  87658 */ // Label 1048: @87658
     /*  87658 */ GIM_Reject,
     /*  87659 */ // Label 7: @87659
     /*  87659 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1355*/ GIMT_Encode4(98626),
     /*  87670 */ /*GILLT_s32*//*Label 1337*/ GIMT_Encode4(87758),
     /*  87674 */ /*GILLT_s64*//*Label 1338*/ GIMT_Encode4(88438), GIMT_Encode4(0),
     /*  87682 */ /*GILLT_v2s32*//*Label 1339*/ GIMT_Encode4(89281),
     /*  87686 */ /*GILLT_v2s64*//*Label 1340*/ GIMT_Encode4(89516),
     /*  87690 */ /*GILLT_v4s16*//*Label 1341*/ GIMT_Encode4(90205),
     /*  87694 */ /*GILLT_v4s32*//*Label 1342*/ GIMT_Encode4(90440),
     /*  87698 */ /*GILLT_v8s8*//*Label 1343*/ GIMT_Encode4(91129),
     /*  87702 */ /*GILLT_v8s16*//*Label 1344*/ GIMT_Encode4(91367),
     /*  87706 */ /*GILLT_v16s8*//*Label 1345*/ GIMT_Encode4(92056),
     /*  87710 */ /*GILLT_nxv1s1*//*Label 1346*/ GIMT_Encode4(92748),
     /*  87714 */ /*GILLT_nxv2s1*//*Label 1347*/ GIMT_Encode4(92798), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  87726 */ /*GILLT_nxv2s64*//*Label 1348*/ GIMT_Encode4(92848),
     /*  87730 */ /*GILLT_nxv4s1*//*Label 1349*/ GIMT_Encode4(94255), GIMT_Encode4(0),
     /*  87738 */ /*GILLT_nxv4s32*//*Label 1350*/ GIMT_Encode4(94305),
     /*  87742 */ /*GILLT_nxv8s1*//*Label 1351*/ GIMT_Encode4(95712),
     /*  87746 */ /*GILLT_nxv8s16*//*Label 1352*/ GIMT_Encode4(95762),
     /*  87750 */ /*GILLT_nxv16s1*//*Label 1353*/ GIMT_Encode4(97169),
     /*  87754 */ /*GILLT_nxv16s8*//*Label 1354*/ GIMT_Encode4(97219),
     /*  87758 */ // Label 1337: @87758
     /*  87758 */ GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(88437),
     /*  87763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  87766 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  87769 */   GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(87827), // Rule ID 13378 //
     /*  87774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  87778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  87790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  87794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  87799 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  87803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  87812 */     // (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }))  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  87812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  87815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  87821 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  87825 */     GIR_RootConstrainSelectedInstOperands,
     /*  87826 */     // GIR_Coverage, 13378,
     /*  87826 */     GIR_EraseRootFromParent_Done,
     /*  87827 */   // Label 1357: @87827
     /*  87827 */   GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(87882), // Rule ID 13377 //
     /*  87832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  87836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  87848 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  87852 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  87856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  87860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87862 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  87869 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  87869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  87872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  87876 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  87880 */     GIR_RootConstrainSelectedInstOperands,
     /*  87881 */     // GIR_Coverage, 13377,
     /*  87881 */     GIR_EraseRootFromParent_Done,
     /*  87882 */   // Label 1358: @87882
     /*  87882 */   GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(87940), // Rule ID 13375 //
     /*  87887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  87891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  87903 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  87907 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  87912 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  87916 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87918 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  87925 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn), -1:{ *:[i32] })  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  87925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  87928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  87934 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  87938 */     GIR_RootConstrainSelectedInstOperands,
     /*  87939 */     // GIR_Coverage, 13375,
     /*  87939 */     GIR_EraseRootFromParent_Done,
     /*  87940 */   // Label 1359: @87940
     /*  87940 */   GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(87998), // Rule ID 166 //
     /*  87945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  87949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  87961 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  87965 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  87970 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  87974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87976 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  87983 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift), -1:{ *:[i32] })  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  87983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  87986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  87992 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  87996 */     GIR_RootConstrainSelectedInstOperands,
     /*  87997 */     // GIR_Coverage, 166,
     /*  87997 */     GIR_EraseRootFromParent_Done,
     /*  87998 */   // Label 1360: @87998
     /*  87998 */   GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(88056), // Rule ID 13376 //
     /*  88003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  88019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  88023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88028 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  88032 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  88041 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }), logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  88041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  88044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  88050 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  88054 */     GIR_RootConstrainSelectedInstOperands,
     /*  88055 */     // GIR_Coverage, 13376,
     /*  88055 */     GIR_EraseRootFromParent_Done,
     /*  88056 */   // Label 1361: @88056
     /*  88056 */   GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(88111), // Rule ID 13379 //
     /*  88061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  88073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  88081 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  88085 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  88089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88091 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  88098 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  88098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  88101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88103 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  88105 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  88109 */     GIR_RootConstrainSelectedInstOperands,
     /*  88110 */     // GIR_Coverage, 13379,
     /*  88110 */     GIR_EraseRootFromParent_Done,
     /*  88111 */   // Label 1362: @88111
     /*  88111 */   GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(88152), // Rule ID 144 //
     /*  88116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  88120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  88128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88132 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  88136 */     // MIs[1] Operand 1
     /*  88136 */     // No operand predicates
     /*  88136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88138 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (EORWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  88138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWri),
     /*  88141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88143 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  88145 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  88150 */     GIR_RootConstrainSelectedInstOperands,
     /*  88151 */     // GIR_Coverage, 144,
     /*  88151 */     GIR_EraseRootFromParent_Done,
     /*  88152 */   // Label 1363: @88152
     /*  88152 */   GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(88185), // Rule ID 13385 //
     /*  88157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  88172 */     // (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (EORWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  88172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWrs),
     /*  88175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  88179 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  88183 */     GIR_RootConstrainSelectedInstOperands,
     /*  88184 */     // GIR_Coverage, 13385,
     /*  88184 */     GIR_EraseRootFromParent_Done,
     /*  88185 */   // Label 1364: @88185
     /*  88185 */   GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(88218), // Rule ID 170 //
     /*  88190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  88205 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (EORWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  88205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWrs),
     /*  88208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88210 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  88212 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  88216 */     GIR_RootConstrainSelectedInstOperands,
     /*  88217 */     // GIR_Coverage, 170,
     /*  88217 */     GIR_EraseRootFromParent_Done,
     /*  88218 */   // Label 1365: @88218
     /*  88218 */   GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(88271), // Rule ID 13371 //
     /*  88223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  88239 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  88243 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88248 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  88252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88258 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rm)  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  88258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  88261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  88267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  88269 */     GIR_RootConstrainSelectedInstOperands,
     /*  88270 */     // GIR_Coverage, 13371,
     /*  88270 */     GIR_EraseRootFromParent_Done,
     /*  88271 */   // Label 1366: @88271
     /*  88271 */   GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(88327), // Rule ID 164 //
     /*  88276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  88292 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  88296 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88301 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88306 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  88310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88312 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm), -1:{ *:[i32] })  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  88312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  88315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  88321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  88325 */     GIR_RootConstrainSelectedInstOperands,
     /*  88326 */     // GIR_Coverage, 164,
     /*  88326 */     GIR_EraseRootFromParent_Done,
     /*  88327 */   // Label 1367: @88327
     /*  88327 */   GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(88380), // Rule ID 13372 //
     /*  88332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  88344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  88352 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  88356 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88361 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  88365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88367 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }))  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  88367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  88370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  88376 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  88378 */     GIR_RootConstrainSelectedInstOperands,
     /*  88379 */     // GIR_Coverage, 13372,
     /*  88379 */     GIR_EraseRootFromParent_Done,
     /*  88380 */   // Label 1368: @88380
     /*  88380 */   GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(88412), // Rule ID 4027 //
     /*  88385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88393 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  88397 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Wm, -1:{ *:[i32] })  =>  (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Wm)
     /*  88397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  88400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88402 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88408 */     GIR_RootToRootCopy, /*OpIdx*/1, // Wm
     /*  88410 */     GIR_RootConstrainSelectedInstOperands,
     /*  88411 */     // GIR_Coverage, 4027,
     /*  88411 */     GIR_EraseRootFromParent_Done,
     /*  88412 */   // Label 1369: @88412
     /*  88412 */   GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(88436), // Rule ID 168 //
     /*  88417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88429 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (EORWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  88429 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORWrr),
     /*  88434 */     GIR_RootConstrainSelectedInstOperands,
     /*  88435 */     // GIR_Coverage, 168,
     /*  88435 */     GIR_Done,
     /*  88436 */   // Label 1370: @88436
     /*  88436 */   GIM_Reject,
     /*  88437 */ // Label 1356: @88437
     /*  88437 */ GIM_Reject,
     /*  88438 */ // Label 1338: @88438
     /*  88438 */ GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(89280),
     /*  88443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88446 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  88449 */   GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(88507), // Rule ID 13383 //
     /*  88454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  88462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  88470 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  88474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88479 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  88483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  88492 */     // (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }))  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  88492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  88495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  88501 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  88505 */     GIR_RootConstrainSelectedInstOperands,
     /*  88506 */     // GIR_Coverage, 13383,
     /*  88506 */     GIR_EraseRootFromParent_Done,
     /*  88507 */   // Label 1372: @88507
     /*  88507 */   GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(88562), // Rule ID 13382 //
     /*  88512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  88528 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  88532 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  88536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88542 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  88549 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  88549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  88552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  88556 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  88560 */     GIR_RootConstrainSelectedInstOperands,
     /*  88561 */     // GIR_Coverage, 13382,
     /*  88561 */     GIR_EraseRootFromParent_Done,
     /*  88562 */   // Label 1373: @88562
     /*  88562 */   GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(88620), // Rule ID 13380 //
     /*  88567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  88583 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  88587 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88592 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  88596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88598 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  88605 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn), -1:{ *:[i64] })  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  88605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  88608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  88614 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  88618 */     GIR_RootConstrainSelectedInstOperands,
     /*  88619 */     // GIR_Coverage, 13380,
     /*  88619 */     GIR_EraseRootFromParent_Done,
     /*  88620 */   // Label 1374: @88620
     /*  88620 */   GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(88678), // Rule ID 167 //
     /*  88625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  88641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  88645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88650 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  88654 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88656 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  88663 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift), -1:{ *:[i64] })  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  88663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  88666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  88672 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  88676 */     GIR_RootConstrainSelectedInstOperands,
     /*  88677 */     // GIR_Coverage, 167,
     /*  88677 */     GIR_EraseRootFromParent_Done,
     /*  88678 */   // Label 1375: @88678
     /*  88678 */   GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(88736), // Rule ID 13381 //
     /*  88683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  88699 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  88703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88708 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  88712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  88721 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }), logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  88721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  88724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  88730 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  88734 */     GIR_RootConstrainSelectedInstOperands,
     /*  88735 */     // GIR_Coverage, 13381,
     /*  88735 */     GIR_EraseRootFromParent_Done,
     /*  88736 */   // Label 1376: @88736
     /*  88736 */   GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(88791), // Rule ID 13384 //
     /*  88741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  88753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  88761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  88765 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  88769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88771 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  88778 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  88778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  88781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88783 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  88785 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  88789 */     GIR_RootConstrainSelectedInstOperands,
     /*  88790 */     // GIR_Coverage, 13384,
     /*  88790 */     GIR_EraseRootFromParent_Done,
     /*  88791 */   // Label 1377: @88791
     /*  88791 */   GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(88891), // Rule ID 1613 //
     /*  88796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  88799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  88811 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  88815 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  88819 */     // MIs[1] Operand 1
     /*  88819 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  88824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  88828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  88832 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  88836 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  88840 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88845 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88850 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  88854 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88860 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  88862 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  88866 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88872 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  88874 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  88876 */     // (xor:{ *:[v1i64] } (setcc:{ *:[v1i64] } (and:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm), immAllZerosV:{ *:[v1i64] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v1i64] })  =>  (CMTSTv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  88876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv1i64),
     /*  88879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  88885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  88889 */     GIR_RootConstrainSelectedInstOperands,
     /*  88890 */     // GIR_Coverage, 1613,
     /*  88890 */     GIR_EraseRootFromParent_Done,
     /*  88891 */   // Label 1378: @88891
     /*  88891 */   GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(88932), // Rule ID 145 //
     /*  88896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  88900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  88908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88912 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  88916 */     // MIs[1] Operand 1
     /*  88916 */     // No operand predicates
     /*  88916 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88918 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (EORXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  88918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXri),
     /*  88921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88923 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  88925 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  88930 */     GIR_RootConstrainSelectedInstOperands,
     /*  88931 */     // GIR_Coverage, 145,
     /*  88931 */     GIR_EraseRootFromParent_Done,
     /*  88932 */   // Label 1379: @88932
     /*  88932 */   GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(88965), // Rule ID 13386 //
     /*  88937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  88952 */     // (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (EORXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  88952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXrs),
     /*  88955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  88959 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  88963 */     GIR_RootConstrainSelectedInstOperands,
     /*  88964 */     // GIR_Coverage, 13386,
     /*  88964 */     GIR_EraseRootFromParent_Done,
     /*  88965 */   // Label 1380: @88965
     /*  88965 */   GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(88998), // Rule ID 171 //
     /*  88970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  88985 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (EORXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  88985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXrs),
     /*  88988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88990 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  88992 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  88996 */     GIR_RootConstrainSelectedInstOperands,
     /*  88997 */     // GIR_Coverage, 171,
     /*  88997 */     GIR_EraseRootFromParent_Done,
     /*  88998 */   // Label 1381: @88998
     /*  88998 */   GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(89051), // Rule ID 13373 //
     /*  89003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  89015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  89019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  89023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89028 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  89032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89038 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rm)  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  89038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  89041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  89047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  89049 */     GIR_RootConstrainSelectedInstOperands,
     /*  89050 */     // GIR_Coverage, 13373,
     /*  89050 */     GIR_EraseRootFromParent_Done,
     /*  89051 */   // Label 1382: @89051
     /*  89051 */   GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(89107), // Rule ID 165 //
     /*  89056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  89068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  89072 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  89076 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89081 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89086 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  89090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89092 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm), -1:{ *:[i64] })  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  89092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  89095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  89101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  89105 */     GIR_RootConstrainSelectedInstOperands,
     /*  89106 */     // GIR_Coverage, 165,
     /*  89106 */     GIR_EraseRootFromParent_Done,
     /*  89107 */   // Label 1383: @89107
     /*  89107 */   GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(89160), // Rule ID 13374 //
     /*  89112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  89124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  89128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  89132 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  89136 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89141 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  89145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89147 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }))  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  89147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  89150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  89156 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  89158 */     GIR_RootConstrainSelectedInstOperands,
     /*  89159 */     // GIR_Coverage, 13374,
     /*  89159 */     GIR_EraseRootFromParent_Done,
     /*  89160 */   // Label 1384: @89160
     /*  89160 */   GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(89192), // Rule ID 4028 //
     /*  89165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89173 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  89177 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Xm, -1:{ *:[i64] })  =>  (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Xm)
     /*  89177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  89180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89182 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89188 */     GIR_RootToRootCopy, /*OpIdx*/1, // Xm
     /*  89190 */     GIR_RootConstrainSelectedInstOperands,
     /*  89191 */     // GIR_Coverage, 4028,
     /*  89191 */     GIR_EraseRootFromParent_Done,
     /*  89192 */   // Label 1385: @89192
     /*  89192 */   GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(89228), // Rule ID 5012 //
     /*  89197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89201 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  89209 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89215 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  89217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89219 */     // (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, immAllOnesV:{ *:[v1i64] })  =>  (NOTv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn)
     /*  89219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  89222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89224 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  89226 */     GIR_RootConstrainSelectedInstOperands,
     /*  89227 */     // GIR_Coverage, 5012,
     /*  89227 */     GIR_EraseRootFromParent_Done,
     /*  89228 */   // Label 1386: @89228
     /*  89228 */   GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(89252), // Rule ID 169 //
     /*  89233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89245 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (EORXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  89245 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORXrr),
     /*  89250 */     GIR_RootConstrainSelectedInstOperands,
     /*  89251 */     // GIR_Coverage, 169,
     /*  89251 */     GIR_Done,
     /*  89252 */   // Label 1387: @89252
     /*  89252 */   GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(89279), // Rule ID 5090 //
     /*  89257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  89260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89272 */     // (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (EORv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  89272 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  89277 */     GIR_RootConstrainSelectedInstOperands,
     /*  89278 */     // GIR_Coverage, 5090,
     /*  89278 */     GIR_Done,
     /*  89279 */   // Label 1388: @89279
     /*  89279 */   GIM_Reject,
     /*  89280 */ // Label 1371: @89280
     /*  89280 */ GIM_Reject,
     /*  89281 */ // Label 1339: @89281
     /*  89281 */ GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(89515),
     /*  89286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89289 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  89292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89296 */   GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(89392), // Rule ID 1160 //
     /*  89301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  89304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  89312 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  89316 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  89320 */     // MIs[1] Operand 1
     /*  89320 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  89325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  89329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  89333 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89337 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  89341 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89346 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89351 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  89355 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89361 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  89363 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  89367 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89373 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  89375 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  89377 */     // (xor:{ *:[v2i32] } (setcc:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i32] })  =>  (CMTSTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  89377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i32),
     /*  89380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  89386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  89390 */     GIR_RootConstrainSelectedInstOperands,
     /*  89391 */     // GIR_Coverage, 1160,
     /*  89391 */     GIR_EraseRootFromParent_Done,
     /*  89392 */   // Label 1390: @89392
     /*  89392 */   GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(89459), // Rule ID 5059 //
     /*  89397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  89405 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  89409 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  89413 */     // MIs[1] Operand 1
     /*  89413 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  89418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  89422 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89428 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  89430 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  89434 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89440 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  89442 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89444 */     // (xor:{ *:[v2i32] } (setcc:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i32] })  =>  (CMTSTv2i32:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$Rn, v2i32:{ *:[v2i32] }:$Rn)
     /*  89444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i32),
     /*  89447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  89453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  89457 */     GIR_RootConstrainSelectedInstOperands,
     /*  89458 */     // GIR_Coverage, 5059,
     /*  89458 */     GIR_EraseRootFromParent_Done,
     /*  89459 */   // Label 1391: @89459
     /*  89459 */   GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(89491), // Rule ID 5010 //
     /*  89464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  89472 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89478 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  89480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89482 */     // (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllOnesV:{ *:[v2i32] })  =>  (NOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /*  89482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  89485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89487 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  89489 */     GIR_RootConstrainSelectedInstOperands,
     /*  89490 */     // GIR_Coverage, 5010,
     /*  89490 */     GIR_EraseRootFromParent_Done,
     /*  89491 */   // Label 1392: @89491
     /*  89491 */   GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(89514), // Rule ID 5089 //
     /*  89496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  89499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89507 */     // (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (EORv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  89507 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  89512 */     GIR_RootConstrainSelectedInstOperands,
     /*  89513 */     // GIR_Coverage, 5089,
     /*  89513 */     GIR_Done,
     /*  89514 */   // Label 1393: @89514
     /*  89514 */   GIM_Reject,
     /*  89515 */ // Label 1389: @89515
     /*  89515 */ GIM_Reject,
     /*  89516 */ // Label 1340: @89516
     /*  89516 */ GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(90204),
     /*  89521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89524 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  89527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89531 */   GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(89627), // Rule ID 1162 //
     /*  89536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  89539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  89547 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  89551 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  89555 */     // MIs[1] Operand 1
     /*  89555 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  89560 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  89564 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  89568 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89572 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  89576 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89581 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89586 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  89590 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89596 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  89598 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  89602 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89608 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  89610 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  89612 */     // (xor:{ *:[v2i64] } (setcc:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i64] })  =>  (CMTSTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  89612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i64),
     /*  89615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  89621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  89625 */     GIR_RootConstrainSelectedInstOperands,
     /*  89626 */     // GIR_Coverage, 1162,
     /*  89626 */     GIR_EraseRootFromParent_Done,
     /*  89627 */   // Label 1395: @89627
     /*  89627 */   GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(89694), // Rule ID 5061 //
     /*  89632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  89640 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  89644 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  89648 */     // MIs[1] Operand 1
     /*  89648 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  89653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  89657 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89663 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  89665 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  89669 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89675 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  89677 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89679 */     // (xor:{ *:[v2i64] } (setcc:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i64] })  =>  (CMTSTv2i64:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, v2i64:{ *:[v2i64] }:$Rn)
     /*  89679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i64),
     /*  89682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  89688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  89692 */     GIR_RootConstrainSelectedInstOperands,
     /*  89693 */     // GIR_Coverage, 5061,
     /*  89693 */     GIR_EraseRootFromParent_Done,
     /*  89694 */   // Label 1396: @89694
     /*  89694 */   GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(89779), // Rule ID 13921 //
     /*  89699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  89702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  89710 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89714 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  89718 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  89722 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  89726 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89730 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  89734 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89739 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  89743 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89749 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  89751 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89760 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89762 */     // (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$Vm), V128:{ *:[v2i64] }:$Vn)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  89762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  89765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  89767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  89769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  89773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  89777 */     GIR_RootConstrainSelectedInstOperands,
     /*  89778 */     // GIR_Coverage, 13921,
     /*  89778 */     GIR_EraseRootFromParent_Done,
     /*  89779 */   // Label 1397: @89779
     /*  89779 */   GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(89864), // Rule ID 13920 //
     /*  89784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  89787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  89795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89799 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  89803 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  89812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  89816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89820 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  89824 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89829 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  89833 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89839 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  89841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89845 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89847 */     // (xor:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] })), V128:{ *:[v2i64] }:$Vn)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  89847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  89850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  89852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  89854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  89858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  89862 */     GIR_RootConstrainSelectedInstOperands,
     /*  89863 */     // GIR_Coverage, 13920,
     /*  89863 */     GIR_EraseRootFromParent_Done,
     /*  89864 */   // Label 1398: @89864
     /*  89864 */   GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(89949), // Rule ID 13919 //
     /*  89869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  89872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  89880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  89884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89888 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  89892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  89896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  89900 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89904 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  89908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89913 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  89917 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89923 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  89925 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89930 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89932 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$Vm))  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  89932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  89935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  89937 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  89939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  89943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  89947 */     GIR_RootConstrainSelectedInstOperands,
     /*  89948 */     // GIR_Coverage, 13919,
     /*  89948 */     GIR_EraseRootFromParent_Done,
     /*  89949 */   // Label 1399: @89949
     /*  89949 */   GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(90034), // Rule ID 3855 //
     /*  89954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  89957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  89965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  89969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89973 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  89977 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  89986 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  89990 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89994 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  89998 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90003 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  90007 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90013 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90015 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90017 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] })))  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  90017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  90020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90022 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  90024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  90028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  90032 */     GIR_RootConstrainSelectedInstOperands,
     /*  90033 */     // GIR_Coverage, 3855,
     /*  90033 */     GIR_EraseRootFromParent_Done,
     /*  90034 */   // Label 1400: @90034
     /*  90034 */   GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(90066), // Rule ID 5013 //
     /*  90039 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  90047 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90053 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  90055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90057 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] })  =>  (NOTv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /*  90057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  90060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90062 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  90064 */     GIR_RootConstrainSelectedInstOperands,
     /*  90065 */     // GIR_Coverage, 5013,
     /*  90065 */     GIR_EraseRootFromParent_Done,
     /*  90066 */   // Label 1401: @90066
     /*  90066 */   GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(90123), // Rule ID 3851 //
     /*  90071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  90090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90095 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90104 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90106 */     // (xor:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm), V128:{ *:[v2i64] }:$Va)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  90106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  90109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  90115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  90119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  90121 */     GIR_RootConstrainSelectedInstOperands,
     /*  90122 */     // GIR_Coverage, 3851,
     /*  90122 */     GIR_EraseRootFromParent_Done,
     /*  90123 */   // Label 1402: @90123
     /*  90123 */   GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(90180), // Rule ID 13909 //
     /*  90128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  90139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90147 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  90151 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90156 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90163 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm))  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  90163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  90166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  90172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  90176 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  90178 */     GIR_RootConstrainSelectedInstOperands,
     /*  90179 */     // GIR_Coverage, 13909,
     /*  90179 */     GIR_EraseRootFromParent_Done,
     /*  90180 */   // Label 1403: @90180
     /*  90180 */   GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(90203), // Rule ID 5093 //
     /*  90185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  90188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90196 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (EORv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  90196 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  90201 */     GIR_RootConstrainSelectedInstOperands,
     /*  90202 */     // GIR_Coverage, 5093,
     /*  90202 */     GIR_Done,
     /*  90203 */   // Label 1404: @90203
     /*  90203 */   GIM_Reject,
     /*  90204 */ // Label 1394: @90204
     /*  90204 */ GIM_Reject,
     /*  90205 */ // Label 1341: @90205
     /*  90205 */ GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(90439),
     /*  90210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90213 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  90216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90220 */   GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(90316), // Rule ID 1158 //
     /*  90225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  90228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  90236 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  90240 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  90244 */     // MIs[1] Operand 1
     /*  90244 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  90249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  90253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90257 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90261 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  90265 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90270 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90275 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  90279 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90285 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  90287 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  90291 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90297 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  90299 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  90301 */     // (xor:{ *:[v4i16] } (setcc:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i16] })  =>  (CMTSTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  90301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i16),
     /*  90304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  90310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  90314 */     GIR_RootConstrainSelectedInstOperands,
     /*  90315 */     // GIR_Coverage, 1158,
     /*  90315 */     GIR_EraseRootFromParent_Done,
     /*  90316 */   // Label 1406: @90316
     /*  90316 */   GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(90383), // Rule ID 5057 //
     /*  90321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  90329 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  90333 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  90337 */     // MIs[1] Operand 1
     /*  90337 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  90342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  90346 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90352 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  90354 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  90358 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90364 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90366 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90368 */     // (xor:{ *:[v4i16] } (setcc:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i16] })  =>  (CMTSTv4i16:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$Rn, v4i16:{ *:[v4i16] }:$Rn)
     /*  90368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i16),
     /*  90371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  90377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  90381 */     GIR_RootConstrainSelectedInstOperands,
     /*  90382 */     // GIR_Coverage, 5057,
     /*  90382 */     GIR_EraseRootFromParent_Done,
     /*  90383 */   // Label 1407: @90383
     /*  90383 */   GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(90415), // Rule ID 5008 //
     /*  90388 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  90396 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90402 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  90404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90406 */     // (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllOnesV:{ *:[v4i16] })  =>  (NOTv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /*  90406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  90409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90411 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  90413 */     GIR_RootConstrainSelectedInstOperands,
     /*  90414 */     // GIR_Coverage, 5008,
     /*  90414 */     GIR_EraseRootFromParent_Done,
     /*  90415 */   // Label 1408: @90415
     /*  90415 */   GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(90438), // Rule ID 5088 //
     /*  90420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  90423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90431 */     // (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (EORv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  90431 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  90436 */     GIR_RootConstrainSelectedInstOperands,
     /*  90437 */     // GIR_Coverage, 5088,
     /*  90437 */     GIR_Done,
     /*  90438 */   // Label 1409: @90438
     /*  90438 */   GIM_Reject,
     /*  90439 */ // Label 1405: @90439
     /*  90439 */ GIM_Reject,
     /*  90440 */ // Label 1342: @90440
     /*  90440 */ GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(91128),
     /*  90445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90448 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  90451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90455 */   GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(90551), // Rule ID 1161 //
     /*  90460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  90463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  90471 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  90475 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90479 */     // MIs[1] Operand 1
     /*  90479 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  90484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  90488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90496 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  90500 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90505 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90510 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  90514 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90520 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  90522 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  90526 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90532 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  90534 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  90536 */     // (xor:{ *:[v4i32] } (setcc:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i32] })  =>  (CMTSTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  90536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i32),
     /*  90539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  90545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  90549 */     GIR_RootConstrainSelectedInstOperands,
     /*  90550 */     // GIR_Coverage, 1161,
     /*  90550 */     GIR_EraseRootFromParent_Done,
     /*  90551 */   // Label 1411: @90551
     /*  90551 */   GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(90618), // Rule ID 5060 //
     /*  90556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  90564 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  90568 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90572 */     // MIs[1] Operand 1
     /*  90572 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  90577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  90581 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90587 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  90589 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  90593 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90599 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90601 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90603 */     // (xor:{ *:[v4i32] } (setcc:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i32] })  =>  (CMTSTv4i32:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, v4i32:{ *:[v4i32] }:$Rn)
     /*  90603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i32),
     /*  90606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  90612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  90616 */     GIR_RootConstrainSelectedInstOperands,
     /*  90617 */     // GIR_Coverage, 5060,
     /*  90617 */     GIR_EraseRootFromParent_Done,
     /*  90618 */   // Label 1412: @90618
     /*  90618 */   GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(90703), // Rule ID 13918 //
     /*  90623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90638 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  90642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  90646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90650 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90654 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  90658 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90663 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  90667 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90673 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90675 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90684 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90686 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$Vm), V128:{ *:[v4i32] }:$Vn)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  90686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  90689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  90693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  90697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  90701 */     GIR_RootConstrainSelectedInstOperands,
     /*  90702 */     // GIR_Coverage, 13918,
     /*  90702 */     GIR_EraseRootFromParent_Done,
     /*  90703 */   // Label 1413: @90703
     /*  90703 */   GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(90788), // Rule ID 13917 //
     /*  90708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90723 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  90727 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90732 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  90736 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90740 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90744 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  90748 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90753 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  90757 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90763 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90769 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90771 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] })), V128:{ *:[v4i32] }:$Vn)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  90771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  90774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  90778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  90782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  90786 */     GIR_RootConstrainSelectedInstOperands,
     /*  90787 */     // GIR_Coverage, 13917,
     /*  90787 */     GIR_EraseRootFromParent_Done,
     /*  90788 */   // Label 1414: @90788
     /*  90788 */   GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(90873), // Rule ID 13916 //
     /*  90793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  90804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90812 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  90816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  90820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90824 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90828 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  90832 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90837 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  90841 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90847 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90849 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90854 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90856 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$Vm))  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  90856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  90859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90861 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  90863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  90867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  90871 */     GIR_RootConstrainSelectedInstOperands,
     /*  90872 */     // GIR_Coverage, 13916,
     /*  90872 */     GIR_EraseRootFromParent_Done,
     /*  90873 */   // Label 1415: @90873
     /*  90873 */   GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(90958), // Rule ID 3854 //
     /*  90878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  90889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90897 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  90901 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  90910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90914 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90918 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  90922 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90927 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  90931 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90937 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90939 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90941 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] })))  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  90941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  90944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90946 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  90948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  90952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  90956 */     GIR_RootConstrainSelectedInstOperands,
     /*  90957 */     // GIR_Coverage, 3854,
     /*  90957 */     GIR_EraseRootFromParent_Done,
     /*  90958 */   // Label 1416: @90958
     /*  90958 */   GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(90990), // Rule ID 5011 //
     /*  90963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  90971 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90977 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  90979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90981 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] })  =>  (NOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /*  90981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  90984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90986 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  90988 */     GIR_RootConstrainSelectedInstOperands,
     /*  90989 */     // GIR_Coverage, 5011,
     /*  90989 */     GIR_EraseRootFromParent_Done,
     /*  90990 */   // Label 1417: @90990
     /*  90990 */   GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(91047), // Rule ID 3850 //
     /*  90995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  91014 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91019 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91028 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91030 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm), V128:{ *:[v4i32] }:$Va)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  91030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  91033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  91035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  91039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  91043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  91045 */     GIR_RootConstrainSelectedInstOperands,
     /*  91046 */     // GIR_Coverage, 3850,
     /*  91046 */     GIR_EraseRootFromParent_Done,
     /*  91047 */   // Label 1418: @91047
     /*  91047 */   GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(91104), // Rule ID 13908 //
     /*  91052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  91055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  91063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91071 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  91075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91080 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91087 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm))  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  91087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  91090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  91092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  91096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  91100 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  91102 */     GIR_RootConstrainSelectedInstOperands,
     /*  91103 */     // GIR_Coverage, 13908,
     /*  91103 */     GIR_EraseRootFromParent_Done,
     /*  91104 */   // Label 1419: @91104
     /*  91104 */   GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(91127), // Rule ID 5092 //
     /*  91109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  91112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91120 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (EORv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  91120 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  91125 */     GIR_RootConstrainSelectedInstOperands,
     /*  91126 */     // GIR_Coverage, 5092,
     /*  91126 */     GIR_Done,
     /*  91127 */   // Label 1420: @91127
     /*  91127 */   GIM_Reject,
     /*  91128 */ // Label 1410: @91128
     /*  91128 */ GIM_Reject,
     /*  91129 */ // Label 1343: @91129
     /*  91129 */ GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(91366),
     /*  91134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  91137 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  91140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91144 */   GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(91240), // Rule ID 1156 //
     /*  91149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  91152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  91160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  91164 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  91168 */     // MIs[1] Operand 1
     /*  91168 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  91173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  91177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  91185 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  91189 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91194 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91199 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  91203 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91209 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  91211 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  91215 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91221 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  91223 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  91225 */     // (xor:{ *:[v8i8] } (setcc:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i8] })  =>  (CMTSTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  91225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i8),
     /*  91228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  91234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  91238 */     GIR_RootConstrainSelectedInstOperands,
     /*  91239 */     // GIR_Coverage, 1156,
     /*  91239 */     GIR_EraseRootFromParent_Done,
     /*  91240 */   // Label 1422: @91240
     /*  91240 */   GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(91307), // Rule ID 5055 //
     /*  91245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  91253 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  91257 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  91261 */     // MIs[1] Operand 1
     /*  91261 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  91266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  91270 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91276 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  91278 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  91282 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91288 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  91290 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  91292 */     // (xor:{ *:[v8i8] } (setcc:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i8] })  =>  (CMTSTv8i8:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rn)
     /*  91292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i8),
     /*  91295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  91301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  91305 */     GIR_RootConstrainSelectedInstOperands,
     /*  91306 */     // GIR_Coverage, 5055,
     /*  91306 */     GIR_EraseRootFromParent_Done,
     /*  91307 */   // Label 1423: @91307
     /*  91307 */   GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(91342), // Rule ID 972 //
     /*  91312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  91315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  91323 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91329 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  91331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91333 */     // (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllOnesV:{ *:[v8i8] })  =>  (NOTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /*  91333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  91336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91338 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  91340 */     GIR_RootConstrainSelectedInstOperands,
     /*  91341 */     // GIR_Coverage, 972,
     /*  91341 */     GIR_EraseRootFromParent_Done,
     /*  91342 */   // Label 1424: @91342
     /*  91342 */   GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(91365), // Rule ID 1599 //
     /*  91347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  91350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91358 */     // (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (EORv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  91358 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  91363 */     GIR_RootConstrainSelectedInstOperands,
     /*  91364 */     // GIR_Coverage, 1599,
     /*  91364 */     GIR_Done,
     /*  91365 */   // Label 1425: @91365
     /*  91365 */   GIM_Reject,
     /*  91366 */ // Label 1421: @91366
     /*  91366 */ GIM_Reject,
     /*  91367 */ // Label 1344: @91367
     /*  91367 */ GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(92055),
     /*  91372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91375 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91382 */   GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(91478), // Rule ID 1159 //
     /*  91387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  91390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  91398 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91402 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  91406 */     // MIs[1] Operand 1
     /*  91406 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  91411 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  91415 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91419 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91423 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91427 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91432 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91437 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  91441 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91447 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  91449 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  91453 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91459 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  91461 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  91463 */     // (xor:{ *:[v8i16] } (setcc:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i16] })  =>  (CMTSTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  91463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i16),
     /*  91466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  91472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  91476 */     GIR_RootConstrainSelectedInstOperands,
     /*  91477 */     // GIR_Coverage, 1159,
     /*  91477 */     GIR_EraseRootFromParent_Done,
     /*  91478 */   // Label 1427: @91478
     /*  91478 */   GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(91545), // Rule ID 5058 //
     /*  91483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  91491 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91495 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  91499 */     // MIs[1] Operand 1
     /*  91499 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  91504 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  91508 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91514 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  91516 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  91520 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91526 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  91528 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  91530 */     // (xor:{ *:[v8i16] } (setcc:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i16] })  =>  (CMTSTv8i16:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, v8i16:{ *:[v8i16] }:$Rn)
     /*  91530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i16),
     /*  91533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  91539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  91543 */     GIR_RootConstrainSelectedInstOperands,
     /*  91544 */     // GIR_Coverage, 5058,
     /*  91544 */     GIR_EraseRootFromParent_Done,
     /*  91545 */   // Label 1428: @91545
     /*  91545 */   GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(91630), // Rule ID 13915 //
     /*  91550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  91553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91565 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91569 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  91573 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91577 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91581 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91585 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91590 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  91594 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91600 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  91602 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91611 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  91613 */     // (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$Vm), V128:{ *:[v8i16] }:$Vn)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  91613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  91616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  91618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  91620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  91624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  91628 */     GIR_RootConstrainSelectedInstOperands,
     /*  91629 */     // GIR_Coverage, 13915,
     /*  91629 */     GIR_EraseRootFromParent_Done,
     /*  91630 */   // Label 1429: @91630
     /*  91630 */   GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(91715), // Rule ID 13914 //
     /*  91635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  91638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91650 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91654 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  91663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91667 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91671 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91675 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91680 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  91684 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91690 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  91692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91696 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  91698 */     // (xor:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] })), V128:{ *:[v8i16] }:$Vn)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  91698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  91701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  91703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  91705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  91709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  91713 */     GIR_RootConstrainSelectedInstOperands,
     /*  91714 */     // GIR_Coverage, 13914,
     /*  91714 */     GIR_EraseRootFromParent_Done,
     /*  91715 */   // Label 1430: @91715
     /*  91715 */   GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(91800), // Rule ID 13913 //
     /*  91720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  91723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  91731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91739 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  91747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91751 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91755 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91759 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91764 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  91768 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91774 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  91776 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91781 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  91783 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$Vm))  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  91783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  91786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  91788 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  91790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  91794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  91798 */     GIR_RootConstrainSelectedInstOperands,
     /*  91799 */     // GIR_Coverage, 13913,
     /*  91799 */     GIR_EraseRootFromParent_Done,
     /*  91800 */   // Label 1431: @91800
     /*  91800 */   GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(91885), // Rule ID 3853 //
     /*  91805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  91808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  91816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91824 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91828 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91833 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  91837 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91841 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91845 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91849 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91854 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  91858 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91864 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  91866 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  91868 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] })))  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  91868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  91871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  91873 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  91875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  91879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  91883 */     GIR_RootConstrainSelectedInstOperands,
     /*  91884 */     // GIR_Coverage, 3853,
     /*  91884 */     GIR_EraseRootFromParent_Done,
     /*  91885 */   // Label 1432: @91885
     /*  91885 */   GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(91917), // Rule ID 5009 //
     /*  91890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  91898 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91904 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  91906 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91908 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] })  =>  (NOTv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /*  91908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  91911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91913 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  91915 */     GIR_RootConstrainSelectedInstOperands,
     /*  91916 */     // GIR_Coverage, 5009,
     /*  91916 */     GIR_EraseRootFromParent_Done,
     /*  91917 */   // Label 1433: @91917
     /*  91917 */   GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(91974), // Rule ID 3849 //
     /*  91922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  91925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91937 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91941 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91957 */     // (xor:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm), V128:{ *:[v8i16] }:$Va)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  91957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  91960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  91962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  91966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  91970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  91972 */     GIR_RootConstrainSelectedInstOperands,
     /*  91973 */     // GIR_Coverage, 3849,
     /*  91973 */     GIR_EraseRootFromParent_Done,
     /*  91974 */   // Label 1434: @91974
     /*  91974 */   GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(92031), // Rule ID 13907 //
     /*  91979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  91982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  91990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  92002 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92014 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm))  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  92014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  92017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  92019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  92023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  92027 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  92029 */     GIR_RootConstrainSelectedInstOperands,
     /*  92030 */     // GIR_Coverage, 13907,
     /*  92030 */     GIR_EraseRootFromParent_Done,
     /*  92031 */   // Label 1435: @92031
     /*  92031 */   GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(92054), // Rule ID 5091 //
     /*  92036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  92039 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92047 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (EORv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  92047 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  92052 */     GIR_RootConstrainSelectedInstOperands,
     /*  92053 */     // GIR_Coverage, 5091,
     /*  92053 */     GIR_Done,
     /*  92054 */   // Label 1436: @92054
     /*  92054 */   GIM_Reject,
     /*  92055 */ // Label 1426: @92055
     /*  92055 */ GIM_Reject,
     /*  92056 */ // Label 1345: @92056
     /*  92056 */ GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(92747),
     /*  92061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92064 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92071 */   GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(92167), // Rule ID 1157 //
     /*  92076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  92079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  92087 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92091 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  92095 */     // MIs[1] Operand 1
     /*  92095 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  92100 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  92104 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92108 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92112 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92116 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92121 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92126 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  92130 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92136 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  92138 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  92142 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92148 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  92150 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  92152 */     // (xor:{ *:[v16i8] } (setcc:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v16i8] })  =>  (CMTSTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  92152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv16i8),
     /*  92155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  92161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  92165 */     GIR_RootConstrainSelectedInstOperands,
     /*  92166 */     // GIR_Coverage, 1157,
     /*  92166 */     GIR_EraseRootFromParent_Done,
     /*  92167 */   // Label 1438: @92167
     /*  92167 */   GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(92234), // Rule ID 5056 //
     /*  92172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  92180 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92184 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  92188 */     // MIs[1] Operand 1
     /*  92188 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  92193 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  92197 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92203 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  92205 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  92209 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92215 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  92217 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  92219 */     // (xor:{ *:[v16i8] } (setcc:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v16i8] })  =>  (CMTSTv16i8:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rn)
     /*  92219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv16i8),
     /*  92222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  92228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  92232 */     GIR_RootConstrainSelectedInstOperands,
     /*  92233 */     // GIR_Coverage, 5056,
     /*  92233 */     GIR_EraseRootFromParent_Done,
     /*  92234 */   // Label 1439: @92234
     /*  92234 */   GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(92319), // Rule ID 13912 //
     /*  92239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  92242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  92262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92266 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92270 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92274 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92279 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  92283 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92289 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  92291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92300 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  92302 */     // (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Vm), V128:{ *:[v16i8] }:$Vn)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  92302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  92305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  92307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  92309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  92313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  92317 */     GIR_RootConstrainSelectedInstOperands,
     /*  92318 */     // GIR_Coverage, 13912,
     /*  92318 */     GIR_EraseRootFromParent_Done,
     /*  92319 */   // Label 1440: @92319
     /*  92319 */   GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(92404), // Rule ID 13911 //
     /*  92324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  92327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92339 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92343 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  92352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92356 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92360 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92364 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92369 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  92373 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92379 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  92381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92385 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  92387 */     // (xor:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] })), V128:{ *:[v16i8] }:$Vn)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  92387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  92390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  92392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  92394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  92398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  92402 */     GIR_RootConstrainSelectedInstOperands,
     /*  92403 */     // GIR_Coverage, 13911,
     /*  92403 */     GIR_EraseRootFromParent_Done,
     /*  92404 */   // Label 1441: @92404
     /*  92404 */   GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(92489), // Rule ID 13910 //
     /*  92409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  92412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92428 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  92436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92440 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92444 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92448 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92453 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  92457 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92463 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  92465 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92470 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  92472 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Vm))  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  92472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  92475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  92477 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  92479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  92483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  92487 */     GIR_RootConstrainSelectedInstOperands,
     /*  92488 */     // GIR_Coverage, 13910,
     /*  92488 */     GIR_EraseRootFromParent_Done,
     /*  92489 */   // Label 1442: @92489
     /*  92489 */   GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(92574), // Rule ID 3852 //
     /*  92494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  92497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92513 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  92526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92530 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92534 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92538 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92543 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  92547 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92553 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  92555 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  92557 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] })))  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  92557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  92560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  92562 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  92564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  92568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  92572 */     GIR_RootConstrainSelectedInstOperands,
     /*  92573 */     // GIR_Coverage, 3852,
     /*  92573 */     GIR_EraseRootFromParent_Done,
     /*  92574 */   // Label 1443: @92574
     /*  92574 */   GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(92609), // Rule ID 973 //
     /*  92579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  92582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92590 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92596 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  92598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92600 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllOnesV:{ *:[v16i8] })  =>  (NOTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /*  92600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  92603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92605 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  92607 */     GIR_RootConstrainSelectedInstOperands,
     /*  92608 */     // GIR_Coverage, 973,
     /*  92608 */     GIR_EraseRootFromParent_Done,
     /*  92609 */   // Label 1444: @92609
     /*  92609 */   GIM_Try, /*On fail goto*//*Label 1445*/ GIMT_Encode4(92666), // Rule ID 3848 //
     /*  92614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  92617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92629 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92633 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92638 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92649 */     // (xor:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm), V128:{ *:[v16i8] }:$Va)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  92649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  92652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  92654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  92658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  92662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  92664 */     GIR_RootConstrainSelectedInstOperands,
     /*  92665 */     // GIR_Coverage, 3848,
     /*  92665 */     GIR_EraseRootFromParent_Done,
     /*  92666 */   // Label 1445: @92666
     /*  92666 */   GIM_Try, /*On fail goto*//*Label 1446*/ GIMT_Encode4(92723), // Rule ID 13906 //
     /*  92671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  92674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92690 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92694 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92706 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm))  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  92706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  92709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  92711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  92715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  92719 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  92721 */     GIR_RootConstrainSelectedInstOperands,
     /*  92722 */     // GIR_Coverage, 13906,
     /*  92722 */     GIR_EraseRootFromParent_Done,
     /*  92723 */   // Label 1446: @92723
     /*  92723 */   GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(92746), // Rule ID 1600 //
     /*  92728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  92731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92739 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (EORv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  92739 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  92744 */     GIR_RootConstrainSelectedInstOperands,
     /*  92745 */     // GIR_Coverage, 1600,
     /*  92745 */     GIR_Done,
     /*  92746 */   // Label 1447: @92746
     /*  92746 */   GIM_Reject,
     /*  92747 */ // Label 1437: @92747
     /*  92747 */ GIM_Reject,
     /*  92748 */ // Label 1346: @92748
     /*  92748 */ GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(92797), // Rule ID 8559 //
     /*  92753 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  92756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  92759 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  92762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  92766 */   // (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv1i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  92766 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  92769 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  92773 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  92778 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  92781 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  92783 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  92786 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  92788 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  92791 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  92793 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  92795 */   GIR_RootConstrainSelectedInstOperands,
     /*  92796 */   // GIR_Coverage, 8559,
     /*  92796 */   GIR_EraseRootFromParent_Done,
     /*  92797 */ // Label 1448: @92797
     /*  92797 */ GIM_Reject,
     /*  92798 */ // Label 1347: @92798
     /*  92798 */ GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(92847), // Rule ID 8558 //
     /*  92803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  92806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  92809 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  92812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  92816 */   // (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv2i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  92816 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  92819 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  92823 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  92828 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  92831 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  92833 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  92836 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  92838 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  92841 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  92843 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  92845 */   GIR_RootConstrainSelectedInstOperands,
     /*  92846 */   // GIR_Coverage, 8558,
     /*  92846 */   GIR_EraseRootFromParent_Done,
     /*  92847 */ // Label 1449: @92847
     /*  92847 */ GIM_Reject,
     /*  92848 */ // Label 1348: @92848
     /*  92848 */ GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(94254),
     /*  92853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92856 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92863 */   GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(92981), // Rule ID 15916 //
     /*  92868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  92871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  92879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92887 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  92891 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92895 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92899 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92903 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  92907 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92911 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92915 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92919 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  92923 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92929 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  92931 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  92935 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92939 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92943 */     // MIs[5] Op3
     /*  92943 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  92948 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  92952 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92958 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  92960 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  92962 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1)), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  92962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  92965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  92967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  92971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  92975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  92979 */     GIR_RootConstrainSelectedInstOperands,
     /*  92980 */     // GIR_Coverage, 15916,
     /*  92980 */     GIR_EraseRootFromParent_Done,
     /*  92981 */   // Label 1451: @92981
     /*  92981 */   GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(93099), // Rule ID 15915 //
     /*  92986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  92989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  92997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93013 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93017 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93021 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  93025 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93029 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93033 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93037 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  93041 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93047 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  93049 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  93053 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93057 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93061 */     // MIs[5] Op3
     /*  93061 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  93066 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93070 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93076 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93078 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93080 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3)), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  93080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  93089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  93093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  93097 */     GIR_RootConstrainSelectedInstOperands,
     /*  93098 */     // GIR_Coverage, 15915,
     /*  93098 */     GIR_EraseRootFromParent_Done,
     /*  93099 */   // Label 1452: @93099
     /*  93099 */   GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(93217), // Rule ID 15914 //
     /*  93104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  93115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93119 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93131 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93135 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93139 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  93143 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93147 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93151 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93155 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  93159 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93165 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  93167 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  93171 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93175 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93179 */     // MIs[5] Op3
     /*  93179 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  93184 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93188 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93194 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93196 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93198 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1)), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  93198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  93207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  93211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  93215 */     GIR_RootConstrainSelectedInstOperands,
     /*  93216 */     // GIR_Coverage, 15914,
     /*  93216 */     GIR_EraseRootFromParent_Done,
     /*  93217 */   // Label 1453: @93217
     /*  93217 */   GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(93335), // Rule ID 15913 //
     /*  93222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  93233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93237 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93249 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93253 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93257 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  93261 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93265 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93269 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93273 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  93277 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93283 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  93285 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  93289 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93293 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93297 */     // MIs[5] Op3
     /*  93297 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  93302 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93306 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93312 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93314 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93316 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3)), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  93316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  93325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  93329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  93333 */     GIR_RootConstrainSelectedInstOperands,
     /*  93334 */     // GIR_Coverage, 15913,
     /*  93334 */     GIR_EraseRootFromParent_Done,
     /*  93335 */   // Label 1454: @93335
     /*  93335 */   GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(93453), // Rule ID 15910 //
     /*  93340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  93351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93367 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93371 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93375 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  93379 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93383 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93387 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93391 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  93395 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93399 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93403 */     // MIs[4] Op3
     /*  93403 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  93408 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  93412 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93418 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  93420 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93424 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93430 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93432 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93434 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2)), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  93434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  93443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  93447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  93451 */     GIR_RootConstrainSelectedInstOperands,
     /*  93452 */     // GIR_Coverage, 15910,
     /*  93452 */     GIR_EraseRootFromParent_Done,
     /*  93453 */   // Label 1455: @93453
     /*  93453 */   GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(93571), // Rule ID 15912 //
     /*  93458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  93469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93473 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93485 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93489 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93493 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  93497 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93501 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93505 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93509 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  93513 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93517 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93521 */     // MIs[4] Op3
     /*  93521 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  93526 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  93530 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93536 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  93538 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93542 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93548 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93550 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93552 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2)), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  93552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  93561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  93565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  93569 */     GIR_RootConstrainSelectedInstOperands,
     /*  93570 */     // GIR_Coverage, 15912,
     /*  93570 */     GIR_EraseRootFromParent_Done,
     /*  93571 */   // Label 1456: @93571
     /*  93571 */   GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(93689), // Rule ID 12037 //
     /*  93576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  93587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93591 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93595 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93599 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93603 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93607 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93611 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  93615 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93619 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93623 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93627 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  93631 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93635 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93639 */     // MIs[4] Op3
     /*  93639 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  93644 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  93648 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93654 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  93656 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93660 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93666 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93668 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93670 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }))), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  93670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  93679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  93683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  93687 */     GIR_RootConstrainSelectedInstOperands,
     /*  93688 */     // GIR_Coverage, 12037,
     /*  93688 */     GIR_EraseRootFromParent_Done,
     /*  93689 */   // Label 1457: @93689
     /*  93689 */   GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(93807), // Rule ID 15911 //
     /*  93694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  93705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93709 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93717 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93721 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93725 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93729 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  93733 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93737 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93741 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93745 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  93749 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93753 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93757 */     // MIs[4] Op3
     /*  93757 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  93762 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  93766 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93772 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  93774 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93778 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93784 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93786 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93788 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }))), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  93788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  93797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  93801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  93805 */     GIR_RootConstrainSelectedInstOperands,
     /*  93806 */     // GIR_Coverage, 15911,
     /*  93806 */     GIR_EraseRootFromParent_Done,
     /*  93807 */   // Label 1458: @93807
     /*  93807 */   GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(93878), // Rule ID 15776 //
     /*  93812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93827 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93839 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93843 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93847 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  93851 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93857 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  93859 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  93861 */     // (xor:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  93861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  93864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  93868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  93872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  93876 */     GIR_RootConstrainSelectedInstOperands,
     /*  93877 */     // GIR_Coverage, 15776,
     /*  93877 */     GIR_EraseRootFromParent_Done,
     /*  93878 */   // Label 1459: @93878
     /*  93878 */   GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(93949), // Rule ID 15775 //
     /*  93883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93898 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  93906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93910 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93914 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93918 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  93922 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93928 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  93930 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  93932 */     // (xor:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  93932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  93935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  93939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  93943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  93947 */     GIR_RootConstrainSelectedInstOperands,
     /*  93948 */     // GIR_Coverage, 15775,
     /*  93948 */     GIR_EraseRootFromParent_Done,
     /*  93949 */   // Label 1460: @93949
     /*  93949 */   GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(94020), // Rule ID 15774 //
     /*  93954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  93961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93969 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93981 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93985 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93989 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  93993 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93999 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  94001 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  94003 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  94003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  94006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94008 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  94010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  94014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  94018 */     GIR_RootConstrainSelectedInstOperands,
     /*  94019 */     // GIR_Coverage, 15774,
     /*  94019 */     GIR_EraseRootFromParent_Done,
     /*  94020 */   // Label 1461: @94020
     /*  94020 */   GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(94091), // Rule ID 12001 //
     /*  94025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  94032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  94040 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  94044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  94048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94052 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  94056 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  94060 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  94064 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94070 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  94072 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  94074 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  94074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  94077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94079 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  94081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  94085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  94089 */     GIR_RootConstrainSelectedInstOperands,
     /*  94090 */     // GIR_Coverage, 12001,
     /*  94090 */     GIR_EraseRootFromParent_Done,
     /*  94091 */   // Label 1462: @94091
     /*  94091 */   GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(94152), // Rule ID 12036 //
     /*  94096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  94107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  94111 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  94115 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  94119 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  94123 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94129 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  94131 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  94133 */     // (xor:{ *:[nxv2i64] } (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  94133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  94142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  94146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  94150 */     GIR_RootConstrainSelectedInstOperands,
     /*  94151 */     // GIR_Coverage, 12036,
     /*  94151 */     GIR_EraseRootFromParent_Done,
     /*  94152 */   // Label 1463: @94152
     /*  94152 */   GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(94195), // Rule ID 13873 //
     /*  94157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  94172 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  94176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94178 */     // (xor:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  94178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  94181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  94187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  94191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  94193 */     GIR_RootConstrainSelectedInstOperands,
     /*  94194 */     // GIR_Coverage, 13873,
     /*  94194 */     GIR_EraseRootFromParent_Done,
     /*  94195 */   // Label 1464: @94195
     /*  94195 */   GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(94238), // Rule ID 3165 //
     /*  94200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  94207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  94215 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  94219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94221 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  94221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  94224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94226 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  94228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  94232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  94236 */     GIR_RootConstrainSelectedInstOperands,
     /*  94237 */     // GIR_Coverage, 3165,
     /*  94237 */     GIR_EraseRootFromParent_Done,
     /*  94238 */   // Label 1465: @94238
     /*  94238 */   GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(94253), // Rule ID 7553 //
     /*  94243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  94246 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  94246 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  94251 */     GIR_RootConstrainSelectedInstOperands,
     /*  94252 */     // GIR_Coverage, 7553,
     /*  94252 */     GIR_Done,
     /*  94253 */   // Label 1466: @94253
     /*  94253 */   GIM_Reject,
     /*  94254 */ // Label 1450: @94254
     /*  94254 */ GIM_Reject,
     /*  94255 */ // Label 1349: @94255
     /*  94255 */ GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(94304), // Rule ID 8557 //
     /*  94260 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  94263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  94266 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  94269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  94273 */   // (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv4i1] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  94273 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  94276 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /*  94280 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94285 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  94288 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94290 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  94293 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  94295 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94298 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  94300 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  94302 */   GIR_RootConstrainSelectedInstOperands,
     /*  94303 */   // GIR_Coverage, 8557,
     /*  94303 */   GIR_EraseRootFromParent_Done,
     /*  94304 */ // Label 1467: @94304
     /*  94304 */ GIM_Reject,
     /*  94305 */ // Label 1350: @94305
     /*  94305 */ GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(95711),
     /*  94310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94313 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94320 */   GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(94438), // Rule ID 15909 //
     /*  94325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  94336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94340 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  94348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94356 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94360 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  94364 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94368 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94372 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94376 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  94380 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94386 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  94388 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  94392 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94396 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94400 */     // MIs[5] Op3
     /*  94400 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  94405 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  94409 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94415 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  94417 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  94419 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1)), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  94419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  94428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  94432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  94436 */     GIR_RootConstrainSelectedInstOperands,
     /*  94437 */     // GIR_Coverage, 15909,
     /*  94437 */     GIR_EraseRootFromParent_Done,
     /*  94438 */   // Label 1469: @94438
     /*  94438 */   GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(94556), // Rule ID 15908 //
     /*  94443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  94454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  94466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94470 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94474 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94478 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  94482 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94486 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94490 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94494 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  94498 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94504 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  94506 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  94510 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94514 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94518 */     // MIs[5] Op3
     /*  94518 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  94523 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  94527 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94533 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  94535 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  94537 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3)), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  94537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  94546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  94550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  94554 */     GIR_RootConstrainSelectedInstOperands,
     /*  94555 */     // GIR_Coverage, 15908,
     /*  94555 */     GIR_EraseRootFromParent_Done,
     /*  94556 */   // Label 1470: @94556
     /*  94556 */   GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(94674), // Rule ID 15907 //
     /*  94561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  94572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  94584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94592 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94596 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  94600 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94604 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94608 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94612 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  94616 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94622 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  94624 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  94628 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94632 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94636 */     // MIs[5] Op3
     /*  94636 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  94641 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  94645 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94651 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  94653 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  94655 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1)), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  94655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  94664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  94668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  94672 */     GIR_RootConstrainSelectedInstOperands,
     /*  94673 */     // GIR_Coverage, 15907,
     /*  94673 */     GIR_EraseRootFromParent_Done,
     /*  94674 */   // Label 1471: @94674
     /*  94674 */   GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(94792), // Rule ID 15906 //
     /*  94679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  94690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94694 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  94702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94706 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94710 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94714 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  94718 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94722 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94726 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94730 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  94734 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94740 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  94742 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  94746 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94750 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94754 */     // MIs[5] Op3
     /*  94754 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  94759 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  94763 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94769 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  94771 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  94773 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3)), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  94773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  94782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  94786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  94790 */     GIR_RootConstrainSelectedInstOperands,
     /*  94791 */     // GIR_Coverage, 15906,
     /*  94791 */     GIR_EraseRootFromParent_Done,
     /*  94792 */   // Label 1472: @94792
     /*  94792 */   GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(94910), // Rule ID 15903 //
     /*  94797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  94808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94812 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  94820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94824 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94828 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94832 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  94836 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94840 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94844 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94848 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  94852 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94856 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94860 */     // MIs[4] Op3
     /*  94860 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  94865 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  94869 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94875 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  94877 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  94881 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94887 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  94889 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  94891 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2)), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  94891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  94900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  94904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  94908 */     GIR_RootConstrainSelectedInstOperands,
     /*  94909 */     // GIR_Coverage, 15903,
     /*  94909 */     GIR_EraseRootFromParent_Done,
     /*  94910 */   // Label 1473: @94910
     /*  94910 */   GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(95028), // Rule ID 15905 //
     /*  94915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  94926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  94938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94942 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94946 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94950 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  94954 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94958 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94962 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94966 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  94970 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94974 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94978 */     // MIs[4] Op3
     /*  94978 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  94983 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  94987 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94993 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  94995 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  94999 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95005 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  95007 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  95009 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2)), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  95009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  95012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  95018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  95022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  95026 */     GIR_RootConstrainSelectedInstOperands,
     /*  95027 */     // GIR_Coverage, 15905,
     /*  95027 */     GIR_EraseRootFromParent_Done,
     /*  95028 */   // Label 1474: @95028
     /*  95028 */   GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(95146), // Rule ID 12035 //
     /*  95033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  95044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  95056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95060 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95064 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95068 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  95072 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95076 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95080 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95084 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  95088 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95092 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95096 */     // MIs[4] Op3
     /*  95096 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  95101 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  95105 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95111 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  95113 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  95117 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95123 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  95125 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  95127 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }))), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  95127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  95130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  95136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  95140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  95144 */     GIR_RootConstrainSelectedInstOperands,
     /*  95145 */     // GIR_Coverage, 12035,
     /*  95145 */     GIR_EraseRootFromParent_Done,
     /*  95146 */   // Label 1475: @95146
     /*  95146 */   GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(95264), // Rule ID 15904 //
     /*  95151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  95162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95166 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  95174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95178 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95182 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95186 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  95190 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95194 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95198 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95202 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  95206 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95210 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95214 */     // MIs[4] Op3
     /*  95214 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  95219 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  95223 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95229 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  95231 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  95235 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95241 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  95243 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  95245 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }))), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  95245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  95248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  95254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  95258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  95262 */     GIR_RootConstrainSelectedInstOperands,
     /*  95263 */     // GIR_Coverage, 15904,
     /*  95263 */     GIR_EraseRootFromParent_Done,
     /*  95264 */   // Label 1476: @95264
     /*  95264 */   GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(95335), // Rule ID 15773 //
     /*  95269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95284 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95288 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  95292 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95296 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95300 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95304 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  95308 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95314 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  95316 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  95318 */     // (xor:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  95318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  95321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  95325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  95329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  95333 */     GIR_RootConstrainSelectedInstOperands,
     /*  95334 */     // GIR_Coverage, 15773,
     /*  95334 */     GIR_EraseRootFromParent_Done,
     /*  95335 */   // Label 1477: @95335
     /*  95335 */   GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(95406), // Rule ID 15772 //
     /*  95340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  95363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95367 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95371 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95375 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  95379 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95385 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  95387 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  95389 */     // (xor:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  95389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  95392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  95396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  95400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  95404 */     GIR_RootConstrainSelectedInstOperands,
     /*  95405 */     // GIR_Coverage, 15772,
     /*  95405 */     GIR_EraseRootFromParent_Done,
     /*  95406 */   // Label 1478: @95406
     /*  95406 */   GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(95477), // Rule ID 15771 //
     /*  95411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  95418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95426 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  95434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95438 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95442 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95446 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  95450 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95456 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  95458 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  95460 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  95460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  95463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95465 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  95467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  95471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  95475 */     GIR_RootConstrainSelectedInstOperands,
     /*  95476 */     // GIR_Coverage, 15771,
     /*  95476 */     GIR_EraseRootFromParent_Done,
     /*  95477 */   // Label 1479: @95477
     /*  95477 */   GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(95548), // Rule ID 11999 //
     /*  95482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  95489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95493 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95497 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95501 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  95505 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95509 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95513 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95517 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  95521 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95527 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  95529 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  95531 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  95531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  95534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95536 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  95538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  95542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  95546 */     GIR_RootConstrainSelectedInstOperands,
     /*  95547 */     // GIR_Coverage, 11999,
     /*  95547 */     GIR_EraseRootFromParent_Done,
     /*  95548 */   // Label 1480: @95548
     /*  95548 */   GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(95609), // Rule ID 12034 //
     /*  95553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  95564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95568 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95572 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  95576 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  95580 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95586 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  95588 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  95590 */     // (xor:{ *:[nxv4i32] } (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  95590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  95593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  95599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  95603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  95607 */     GIR_RootConstrainSelectedInstOperands,
     /*  95608 */     // GIR_Coverage, 12034,
     /*  95608 */     GIR_EraseRootFromParent_Done,
     /*  95609 */   // Label 1481: @95609
     /*  95609 */   GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(95652), // Rule ID 13872 //
     /*  95614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95629 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95635 */     // (xor:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  95635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  95638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  95644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  95648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  95650 */     GIR_RootConstrainSelectedInstOperands,
     /*  95651 */     // GIR_Coverage, 13872,
     /*  95651 */     GIR_EraseRootFromParent_Done,
     /*  95652 */   // Label 1482: @95652
     /*  95652 */   GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(95695), // Rule ID 3163 //
     /*  95657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  95664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95672 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95678 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  95678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  95681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95683 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  95685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  95689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  95693 */     GIR_RootConstrainSelectedInstOperands,
     /*  95694 */     // GIR_Coverage, 3163,
     /*  95694 */     GIR_EraseRootFromParent_Done,
     /*  95695 */   // Label 1483: @95695
     /*  95695 */   GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(95710), // Rule ID 7552 //
     /*  95700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  95703 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  95703 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  95708 */     GIR_RootConstrainSelectedInstOperands,
     /*  95709 */     // GIR_Coverage, 7552,
     /*  95709 */     GIR_Done,
     /*  95710 */   // Label 1484: @95710
     /*  95710 */   GIM_Reject,
     /*  95711 */ // Label 1468: @95711
     /*  95711 */ GIM_Reject,
     /*  95712 */ // Label 1351: @95712
     /*  95712 */ GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(95761), // Rule ID 8556 //
     /*  95717 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  95720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  95723 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  95726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  95730 */   // (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv8i1] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  95730 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  95733 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /*  95737 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95742 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  95745 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95747 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  95750 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  95752 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  95755 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  95757 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  95759 */   GIR_RootConstrainSelectedInstOperands,
     /*  95760 */   // GIR_Coverage, 8556,
     /*  95760 */   GIR_EraseRootFromParent_Done,
     /*  95761 */ // Label 1485: @95761
     /*  95761 */ GIM_Reject,
     /*  95762 */ // Label 1352: @95762
     /*  95762 */ GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(97168),
     /*  95767 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95770 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95777 */   GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(95895), // Rule ID 15902 //
     /*  95782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  95793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95797 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  95805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95809 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95813 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95817 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  95821 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95825 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95829 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95833 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  95837 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95843 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  95845 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  95849 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95853 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95857 */     // MIs[5] Op3
     /*  95857 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  95862 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  95866 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95872 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  95874 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  95876 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1)), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  95876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  95879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  95885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  95889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  95893 */     GIR_RootConstrainSelectedInstOperands,
     /*  95894 */     // GIR_Coverage, 15902,
     /*  95894 */     GIR_EraseRootFromParent_Done,
     /*  95895 */   // Label 1487: @95895
     /*  95895 */   GIM_Try, /*On fail goto*//*Label 1488*/ GIMT_Encode4(96013), // Rule ID 15901 //
     /*  95900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  95911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95915 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95919 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  95923 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95927 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95931 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95935 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  95939 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95943 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95947 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95951 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  95955 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95961 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  95963 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  95967 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95971 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95975 */     // MIs[5] Op3
     /*  95975 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  95980 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  95984 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95990 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  95992 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  95994 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3)), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  95994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  95997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  96003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  96007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  96011 */     GIR_RootConstrainSelectedInstOperands,
     /*  96012 */     // GIR_Coverage, 15901,
     /*  96012 */     GIR_EraseRootFromParent_Done,
     /*  96013 */   // Label 1488: @96013
     /*  96013 */   GIM_Try, /*On fail goto*//*Label 1489*/ GIMT_Encode4(96131), // Rule ID 15900 //
     /*  96018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  96029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96033 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96045 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96049 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96053 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  96057 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96061 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96065 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96069 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  96073 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96079 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  96081 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  96085 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96089 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96093 */     // MIs[5] Op3
     /*  96093 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  96098 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  96102 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96108 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  96110 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  96112 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1)), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  96112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  96115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  96121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  96125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  96129 */     GIR_RootConstrainSelectedInstOperands,
     /*  96130 */     // GIR_Coverage, 15900,
     /*  96130 */     GIR_EraseRootFromParent_Done,
     /*  96131 */   // Label 1489: @96131
     /*  96131 */   GIM_Try, /*On fail goto*//*Label 1490*/ GIMT_Encode4(96249), // Rule ID 15899 //
     /*  96136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  96147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96151 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96163 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96167 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96171 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  96175 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96179 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96183 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96187 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  96191 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96197 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  96199 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  96203 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96207 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96211 */     // MIs[5] Op3
     /*  96211 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  96216 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  96220 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96226 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  96228 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  96230 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3)), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  96230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  96233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  96239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  96243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  96247 */     GIR_RootConstrainSelectedInstOperands,
     /*  96248 */     // GIR_Coverage, 15899,
     /*  96248 */     GIR_EraseRootFromParent_Done,
     /*  96249 */   // Label 1490: @96249
     /*  96249 */   GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(96367), // Rule ID 15896 //
     /*  96254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  96265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96269 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96281 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96285 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96289 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  96293 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96297 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96301 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96305 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  96309 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96313 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96317 */     // MIs[4] Op3
     /*  96317 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  96322 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  96326 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96332 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  96334 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  96338 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96344 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  96346 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  96348 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2)), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  96348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  96351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  96357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  96361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  96365 */     GIR_RootConstrainSelectedInstOperands,
     /*  96366 */     // GIR_Coverage, 15896,
     /*  96366 */     GIR_EraseRootFromParent_Done,
     /*  96367 */   // Label 1491: @96367
     /*  96367 */   GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(96485), // Rule ID 15898 //
     /*  96372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  96383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96387 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96399 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96403 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96407 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  96411 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96415 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96419 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96423 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  96427 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96431 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96435 */     // MIs[4] Op3
     /*  96435 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  96440 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  96444 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96450 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  96452 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  96456 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96462 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  96464 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  96466 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2)), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  96466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  96469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  96475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  96479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  96483 */     GIR_RootConstrainSelectedInstOperands,
     /*  96484 */     // GIR_Coverage, 15898,
     /*  96484 */     GIR_EraseRootFromParent_Done,
     /*  96485 */   // Label 1492: @96485
     /*  96485 */   GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(96603), // Rule ID 12033 //
     /*  96490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  96501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96505 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96521 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96525 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  96529 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96533 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96537 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96541 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  96545 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96549 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96553 */     // MIs[4] Op3
     /*  96553 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  96558 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  96562 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96568 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  96570 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  96574 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96580 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  96582 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  96584 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }))), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  96584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  96587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  96593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  96597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  96601 */     GIR_RootConstrainSelectedInstOperands,
     /*  96602 */     // GIR_Coverage, 12033,
     /*  96602 */     GIR_EraseRootFromParent_Done,
     /*  96603 */   // Label 1493: @96603
     /*  96603 */   GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(96721), // Rule ID 15897 //
     /*  96608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  96619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96623 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96635 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96639 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96643 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  96647 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96651 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96655 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96659 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  96663 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96667 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96671 */     // MIs[4] Op3
     /*  96671 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  96676 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  96680 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96686 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  96688 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  96692 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96698 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  96700 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  96702 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }))), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  96702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  96705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  96711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  96715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  96719 */     GIR_RootConstrainSelectedInstOperands,
     /*  96720 */     // GIR_Coverage, 15897,
     /*  96720 */     GIR_EraseRootFromParent_Done,
     /*  96721 */   // Label 1494: @96721
     /*  96721 */   GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(96792), // Rule ID 15770 //
     /*  96726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96741 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96753 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96757 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96761 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  96765 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96771 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  96773 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  96775 */     // (xor:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  96775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  96778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  96782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  96786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  96790 */     GIR_RootConstrainSelectedInstOperands,
     /*  96791 */     // GIR_Coverage, 15770,
     /*  96791 */     GIR_EraseRootFromParent_Done,
     /*  96792 */   // Label 1495: @96792
     /*  96792 */   GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(96863), // Rule ID 15769 //
     /*  96797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96812 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  96820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96824 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96828 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96832 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  96836 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96842 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  96844 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  96846 */     // (xor:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  96846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  96849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  96853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  96857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  96861 */     GIR_RootConstrainSelectedInstOperands,
     /*  96862 */     // GIR_Coverage, 15769,
     /*  96862 */     GIR_EraseRootFromParent_Done,
     /*  96863 */   // Label 1496: @96863
     /*  96863 */   GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(96934), // Rule ID 15768 //
     /*  96868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  96875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96887 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96891 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96895 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96899 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96903 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  96907 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96913 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  96915 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  96917 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  96917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  96920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96922 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  96924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  96928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  96932 */     GIR_RootConstrainSelectedInstOperands,
     /*  96933 */     // GIR_Coverage, 15768,
     /*  96933 */     GIR_EraseRootFromParent_Done,
     /*  96934 */   // Label 1497: @96934
     /*  96934 */   GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(97005), // Rule ID 11997 //
     /*  96939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  96946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96954 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96958 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  96962 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96966 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96970 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96974 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  96978 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96984 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  96986 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  96988 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  96988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  96991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96993 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  96995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  96999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  97003 */     GIR_RootConstrainSelectedInstOperands,
     /*  97004 */     // GIR_Coverage, 11997,
     /*  97004 */     GIR_EraseRootFromParent_Done,
     /*  97005 */   // Label 1498: @97005
     /*  97005 */   GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(97066), // Rule ID 12032 //
     /*  97010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  97013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  97021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  97025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  97029 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  97033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  97037 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97043 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  97045 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  97047 */     // (xor:{ *:[nxv8i16] } (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  97047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  97050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  97052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  97056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  97060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  97064 */     GIR_RootConstrainSelectedInstOperands,
     /*  97065 */     // GIR_Coverage, 12032,
     /*  97065 */     GIR_EraseRootFromParent_Done,
     /*  97066 */   // Label 1499: @97066
     /*  97066 */   GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(97109), // Rule ID 13871 //
     /*  97071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  97074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  97082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  97086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  97090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97092 */     // (xor:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  97092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  97095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  97097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  97101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  97105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  97107 */     GIR_RootConstrainSelectedInstOperands,
     /*  97108 */     // GIR_Coverage, 13871,
     /*  97108 */     GIR_EraseRootFromParent_Done,
     /*  97109 */   // Label 1500: @97109
     /*  97109 */   GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(97152), // Rule ID 3161 //
     /*  97114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  97117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  97125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  97129 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  97133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97135 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  97135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  97138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  97140 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  97142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  97146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  97150 */     GIR_RootConstrainSelectedInstOperands,
     /*  97151 */     // GIR_Coverage, 3161,
     /*  97151 */     GIR_EraseRootFromParent_Done,
     /*  97152 */   // Label 1501: @97152
     /*  97152 */   GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(97167), // Rule ID 7551 //
     /*  97157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  97160 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  97160 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  97165 */     GIR_RootConstrainSelectedInstOperands,
     /*  97166 */     // GIR_Coverage, 7551,
     /*  97166 */     GIR_Done,
     /*  97167 */   // Label 1502: @97167
     /*  97167 */   GIM_Reject,
     /*  97168 */ // Label 1486: @97168
     /*  97168 */ GIM_Reject,
     /*  97169 */ // Label 1353: @97169
     /*  97169 */ GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(97218), // Rule ID 8555 //
     /*  97174 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  97177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  97180 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  97183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  97187 */   // (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv16i1] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  97187 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  97190 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /*  97194 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97199 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  97202 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  97204 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  97207 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  97209 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97212 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  97214 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  97216 */   GIR_RootConstrainSelectedInstOperands,
     /*  97217 */   // GIR_Coverage, 8555,
     /*  97217 */   GIR_EraseRootFromParent_Done,
     /*  97218 */ // Label 1503: @97218
     /*  97218 */ GIM_Reject,
     /*  97219 */ // Label 1354: @97219
     /*  97219 */ GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(98625),
     /*  97224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97227 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97234 */   GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(97352), // Rule ID 15895 //
     /*  97239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  97242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  97250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  97262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97266 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97270 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97274 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  97278 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  97282 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97286 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97290 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  97294 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97300 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  97302 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  97306 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97310 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97314 */     // MIs[5] Op3
     /*  97314 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  97319 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  97323 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97329 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  97331 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  97333 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1)), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  97333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  97336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  97338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  97342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  97346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  97350 */     GIR_RootConstrainSelectedInstOperands,
     /*  97351 */     // GIR_Coverage, 15895,
     /*  97351 */     GIR_EraseRootFromParent_Done,
     /*  97352 */   // Label 1505: @97352
     /*  97352 */   GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(97470), // Rule ID 15894 //
     /*  97357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  97360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  97368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97372 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  97380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97384 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97388 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97392 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  97396 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  97400 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97404 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97408 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  97412 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97418 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  97420 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  97424 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97428 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97432 */     // MIs[5] Op3
     /*  97432 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  97437 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  97441 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97447 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  97449 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  97451 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3)), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  97451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  97454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  97456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  97460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  97464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  97468 */     GIR_RootConstrainSelectedInstOperands,
     /*  97469 */     // GIR_Coverage, 15894,
     /*  97469 */     GIR_EraseRootFromParent_Done,
     /*  97470 */   // Label 1506: @97470
     /*  97470 */   GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(97588), // Rule ID 15893 //
     /*  97475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  97478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  97486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97490 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  97498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97502 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97506 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97510 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  97514 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  97518 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97522 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97526 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  97530 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97536 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  97538 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  97542 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97546 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97550 */     // MIs[5] Op3
     /*  97550 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  97555 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  97559 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97565 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  97567 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  97569 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1)), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  97569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  97572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  97574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  97578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  97582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  97586 */     GIR_RootConstrainSelectedInstOperands,
     /*  97587 */     // GIR_Coverage, 15893,
     /*  97587 */     GIR_EraseRootFromParent_Done,
     /*  97588 */   // Label 1507: @97588
     /*  97588 */   GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(97706), // Rule ID 15892 //
     /*  97593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  97596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  97604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97608 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  97616 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97620 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97624 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97628 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  97632 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  97636 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97640 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97644 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  97648 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97654 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  97656 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  97660 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97664 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97668 */     // MIs[5] Op3
     /*  97668 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  97673 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  97677 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97683 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  97685 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  97687 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3)), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  97687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  97690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  97692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  97696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  97700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  97704 */     GIR_RootConstrainSelectedInstOperands,
     /*  97705 */     // GIR_Coverage, 15892,
     /*  97705 */     GIR_EraseRootFromParent_Done,
     /*  97706 */   // Label 1508: @97706
     /*  97706 */   GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(97824), // Rule ID 15889 //
     /*  97711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  97714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  97722 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97726 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97730 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  97734 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97738 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97742 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97746 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  97750 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97754 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97758 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97762 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  97766 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  97770 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97774 */     // MIs[4] Op3
     /*  97774 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  97779 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  97783 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97789 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  97791 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  97795 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97801 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  97803 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  97805 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2)), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  97805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  97808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  97810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  97814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  97818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  97822 */     GIR_RootConstrainSelectedInstOperands,
     /*  97823 */     // GIR_Coverage, 15889,
     /*  97823 */     GIR_EraseRootFromParent_Done,
     /*  97824 */   // Label 1509: @97824
     /*  97824 */   GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(97942), // Rule ID 15891 //
     /*  97829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  97832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  97840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97844 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  97852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97856 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97860 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97864 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  97868 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97872 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97876 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97880 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  97884 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  97888 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97892 */     // MIs[4] Op3
     /*  97892 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  97897 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  97901 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97907 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  97909 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  97913 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97919 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  97921 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  97923 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2)), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  97923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  97926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  97928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  97932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  97936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  97940 */     GIR_RootConstrainSelectedInstOperands,
     /*  97941 */     // GIR_Coverage, 15891,
     /*  97941 */     GIR_EraseRootFromParent_Done,
     /*  97942 */   // Label 1510: @97942
     /*  97942 */   GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(98060), // Rule ID 12031 //
     /*  97947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  97950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  97958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97962 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  97970 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97974 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97978 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97982 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  97986 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97990 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97994 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97998 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  98002 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  98006 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98010 */     // MIs[4] Op3
     /*  98010 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  98015 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  98019 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  98025 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  98027 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  98031 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  98037 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  98039 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  98041 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }))), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  98041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  98044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  98046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  98050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  98054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  98058 */     GIR_RootConstrainSelectedInstOperands,
     /*  98059 */     // GIR_Coverage, 12031,
     /*  98059 */     GIR_EraseRootFromParent_Done,
     /*  98060 */   // Label 1511: @98060
     /*  98060 */   GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(98178), // Rule ID 15890 //
     /*  98065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  98068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  98076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98080 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  98088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  98092 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98096 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98100 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  98104 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  98108 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98112 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98116 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  98120 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  98124 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98128 */     // MIs[4] Op3
     /*  98128 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  98133 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  98137 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  98143 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  98145 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  98149 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  98155 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  98157 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  98159 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }))), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  98159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  98162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  98164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  98168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  98172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  98176 */     GIR_RootConstrainSelectedInstOperands,
     /*  98177 */     // GIR_Coverage, 15890,
     /*  98177 */     GIR_EraseRootFromParent_Done,
     /*  98178 */   // Label 1512: @98178
     /*  98178 */   GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(98249), // Rule ID 15767 //
     /*  98183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  98186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  98194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98198 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  98206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  98210 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98214 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98218 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  98222 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  98228 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  98230 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  98232 */     // (xor:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  98232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  98235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  98237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  98239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  98243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  98247 */     GIR_RootConstrainSelectedInstOperands,
     /*  98248 */     // GIR_Coverage, 15767,
     /*  98248 */     GIR_EraseRootFromParent_Done,
     /*  98249 */   // Label 1513: @98249
     /*  98249 */   GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(98320), // Rule ID 15766 //
     /*  98254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  98257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  98265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98269 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  98277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  98281 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98285 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98289 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  98293 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  98299 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  98301 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  98303 */     // (xor:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  98303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  98306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  98308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  98310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  98314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  98318 */     GIR_RootConstrainSelectedInstOperands,
     /*  98319 */     // GIR_Coverage, 15766,
     /*  98319 */     GIR_EraseRootFromParent_Done,
     /*  98320 */   // Label 1514: @98320
     /*  98320 */   GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(98391), // Rule ID 15765 //
     /*  98325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  98328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  98336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98340 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  98348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  98352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98356 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98360 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  98364 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  98370 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  98372 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  98374 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  98374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  98377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  98379 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  98381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  98385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  98389 */     GIR_RootConstrainSelectedInstOperands,
     /*  98390 */     // GIR_Coverage, 15765,
     /*  98390 */     GIR_EraseRootFromParent_Done,
     /*  98391 */   // Label 1515: @98391
     /*  98391 */   GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(98462), // Rule ID 11995 //
     /*  98396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  98399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  98407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98411 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98415 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  98419 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  98423 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98427 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98431 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  98435 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  98441 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  98443 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  98445 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  98445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  98448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  98450 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  98452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  98456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  98460 */     GIR_RootConstrainSelectedInstOperands,
     /*  98461 */     // GIR_Coverage, 11995,
     /*  98461 */     GIR_EraseRootFromParent_Done,
     /*  98462 */   // Label 1516: @98462
     /*  98462 */   GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(98523), // Rule ID 12030 //
     /*  98467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  98470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  98478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98482 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98486 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  98490 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  98494 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  98500 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  98502 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  98504 */     // (xor:{ *:[nxv16i8] } (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  98504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  98507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  98509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  98513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  98517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  98521 */     GIR_RootConstrainSelectedInstOperands,
     /*  98522 */     // GIR_Coverage, 12030,
     /*  98522 */     GIR_EraseRootFromParent_Done,
     /*  98523 */   // Label 1517: @98523
     /*  98523 */   GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(98566), // Rule ID 13870 //
     /*  98528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  98531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  98539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98543 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98549 */     // (xor:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  98549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  98552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  98554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  98558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  98562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  98564 */     GIR_RootConstrainSelectedInstOperands,
     /*  98565 */     // GIR_Coverage, 13870,
     /*  98565 */     GIR_EraseRootFromParent_Done,
     /*  98566 */   // Label 1518: @98566
     /*  98566 */   GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(98609), // Rule ID 3159 //
     /*  98571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  98574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  98582 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98586 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98590 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98592 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  98592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  98595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  98597 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  98599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  98603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  98607 */     GIR_RootConstrainSelectedInstOperands,
     /*  98608 */     // GIR_Coverage, 3159,
     /*  98608 */     GIR_EraseRootFromParent_Done,
     /*  98609 */   // Label 1519: @98609
     /*  98609 */   GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(98624), // Rule ID 7550 //
     /*  98614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  98617 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  98617 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  98622 */     GIR_RootConstrainSelectedInstOperands,
     /*  98623 */     // GIR_Coverage, 7550,
     /*  98623 */     GIR_Done,
     /*  98624 */   // Label 1520: @98624
     /*  98624 */   GIM_Reject,
     /*  98625 */ // Label 1504: @98625
     /*  98625 */ GIM_Reject,
     /*  98626 */ // Label 1355: @98626
     /*  98626 */ GIM_Reject,
     /*  98627 */ // Label 8: @98627
     /*  98627 */ GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(106150),
     /*  98632 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  98635 */   GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(23), /*)*//*default:*//*Label 1533*/ GIMT_Encode4(106149),
     /*  98646 */   /*GILLT_v2s64*//*Label 1522*/ GIMT_Encode4(98714), GIMT_Encode4(0),
     /*  98654 */   /*GILLT_v4s32*//*Label 1523*/ GIMT_Encode4(99235), GIMT_Encode4(0),
     /*  98662 */   /*GILLT_v8s16*//*Label 1524*/ GIMT_Encode4(101647),
     /*  98666 */   /*GILLT_v16s8*//*Label 1525*/ GIMT_Encode4(104056), GIMT_Encode4(0),
     /*  98674 */   /*GILLT_nxv2s1*//*Label 1526*/ GIMT_Encode4(105967), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  98690 */   /*GILLT_nxv4s1*//*Label 1527*/ GIMT_Encode4(105993),
     /*  98694 */   /*GILLT_nxv4s16*//*Label 1528*/ GIMT_Encode4(106019),
     /*  98698 */   /*GILLT_nxv4s32*//*Label 1529*/ GIMT_Encode4(106045),
     /*  98702 */   /*GILLT_nxv8s1*//*Label 1530*/ GIMT_Encode4(106071),
     /*  98706 */   /*GILLT_nxv8s16*//*Label 1531*/ GIMT_Encode4(106097),
     /*  98710 */   /*GILLT_nxv16s1*//*Label 1532*/ GIMT_Encode4(106123),
     /*  98714 */   // Label 1522: @98714
     /*  98714 */   GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(99234),
     /*  98719 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  98722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  98725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98733 */     GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(98795), // Rule ID 5848 //
     /*  98738 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98742 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  98748 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  98750 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98752 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v1i64] }:$Rn), dsub:{ *:[i32] })
     /*  98752 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  98755 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  98759 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98764 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98768 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98770 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  98773 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98775 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98778 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98781 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  98784 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98789 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98794 */       // GIR_Coverage, 5848,
     /*  98794 */       GIR_EraseRootFromParent_Done,
     /*  98795 */     // Label 1535: @98795
     /*  98795 */     GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(98857), // Rule ID 5852 //
     /*  98800 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98804 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  98810 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  98812 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98814 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v1f64] }:$Rn), dsub:{ *:[i32] })
     /*  98814 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  98817 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  98821 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98826 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98830 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98832 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  98835 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98837 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98840 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98843 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  98846 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98851 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98856 */       // GIR_Coverage, 5852,
     /*  98856 */       GIR_EraseRootFromParent_Done,
     /*  98857 */     // Label 1536: @98857
     /*  98857 */     GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(98915), // Rule ID 5849 //
     /*  98862 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98866 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  98870 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98872 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rn, (undef:{ *:[v1i64] }))  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] })
     /*  98872 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  98875 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  98879 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98884 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98886 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  98889 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98891 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98894 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  98896 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  98899 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98904 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98909 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98914 */       // GIR_Coverage, 5849,
     /*  98914 */       GIR_EraseRootFromParent_Done,
     /*  98915 */     // Label 1537: @98915
     /*  98915 */     GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(98973), // Rule ID 5853 //
     /*  98920 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98924 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  98928 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98930 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rn, (undef:{ *:[v1f64] }))  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] })
     /*  98930 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  98933 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  98937 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98942 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98944 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  98947 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98949 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98952 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  98954 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  98957 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98962 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98967 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98972 */       // GIR_Coverage, 5853,
     /*  98972 */       GIR_EraseRootFromParent_Done,
     /*  98973 */     // Label 1538: @98973
     /*  98973 */     GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(99103), // Rule ID 5847 //
     /*  98978 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98982 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn)  =>  (INSvi64lane:{ *:[v2i64] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1i64] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  98982 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  98985 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  98989 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98994 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  98996 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  98999 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99003 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99008 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  99011 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  99015 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  99018 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99023 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99028 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99033 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  99036 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99040 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99045 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99047 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99050 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99054 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99059 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  99062 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  99066 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99069 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99074 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99079 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99084 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  99087 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99089 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99092 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  99095 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  99098 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99101 */       GIR_RootConstrainSelectedInstOperands,
     /*  99102 */       // GIR_Coverage, 5847,
     /*  99102 */       GIR_EraseRootFromParent_Done,
     /*  99103 */     // Label 1539: @99103
     /*  99103 */     GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(99233), // Rule ID 5851 //
     /*  99108 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99112 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rd, V64:{ *:[v1f64] }:$Rn)  =>  (INSvi64lane:{ *:[v2f64] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1f64] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  99112 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  99115 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99119 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99124 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  99126 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  99129 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99133 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99138 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  99141 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  99145 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  99148 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99153 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99158 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99163 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  99166 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99170 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99175 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99177 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99180 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99184 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99189 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  99192 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  99196 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99199 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99204 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99209 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99214 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  99217 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99219 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99222 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  99225 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  99228 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99231 */       GIR_RootConstrainSelectedInstOperands,
     /*  99232 */       // GIR_Coverage, 5851,
     /*  99232 */       GIR_EraseRootFromParent_Done,
     /*  99233 */     // Label 1540: @99233
     /*  99233 */     GIM_Reject,
     /*  99234 */   // Label 1534: @99234
     /*  99234 */   GIM_Reject,
     /*  99235 */   // Label 1523: @99235
     /*  99235 */   GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(101646),
     /*  99240 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  99243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  99246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99250 */     GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(99379), // Rule ID 5471 //
     /*  99255 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99259 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99263 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  99267 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99271 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  99275 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  99279 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99283 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  99287 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  99291 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99295 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99299 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99304 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  99308 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  99314 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  99316 */       // MIs[2] Operand 2
     /*  99316 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  99327 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  99329 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /*  99329 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99332 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  99336 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99341 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  99344 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  99348 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99351 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99356 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99361 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  99364 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99366 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99369 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  99373 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  99377 */       GIR_RootConstrainSelectedInstOperands,
     /*  99378 */       // GIR_Coverage, 5471,
     /*  99378 */       GIR_EraseRootFromParent_Done,
     /*  99379 */     // Label 1542: @99379
     /*  99379 */     GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(99501), // Rule ID 5467 //
     /*  99384 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99388 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99392 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  99396 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99400 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  99404 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  99408 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99412 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  99416 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  99420 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99424 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99428 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99433 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99438 */       // MIs[2] Operand 2
     /*  99438 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  99449 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  99451 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (ADDHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  99451 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99454 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  99458 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99463 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  99466 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  99470 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99473 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99478 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99483 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v4i32),
     /*  99486 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99488 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99491 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  99495 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  99499 */       GIR_RootConstrainSelectedInstOperands,
     /*  99500 */       // GIR_Coverage, 5467,
     /*  99500 */       GIR_EraseRootFromParent_Done,
     /*  99501 */     // Label 1543: @99501
     /*  99501 */     GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(99623), // Rule ID 5469 //
     /*  99506 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99510 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99514 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  99518 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99522 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  99526 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  99530 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99534 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  99538 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  99542 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99546 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99550 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99555 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99560 */       // MIs[2] Operand 2
     /*  99560 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  99571 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  99573 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  99573 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99576 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  99580 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99585 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  99588 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  99592 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99595 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99600 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99605 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  99608 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99610 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99613 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  99617 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  99621 */       GIR_RootConstrainSelectedInstOperands,
     /*  99622 */       // GIR_Coverage, 5469,
     /*  99622 */       GIR_EraseRootFromParent_Done,
     /*  99623 */     // Label 1544: @99623
     /*  99623 */     GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(99725), // Rule ID 5617 //
     /*  99628 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99632 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  99636 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99640 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  99644 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  99648 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99652 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99657 */       // MIs[2] Operand 2
     /*  99657 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  99668 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  99672 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  99676 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99680 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  99684 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /*  99688 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99692 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99697 */       // MIs[4] Operand 2
     /*  99697 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(32),
     /*  99708 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  99710 */       // (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] })), (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, 32:{ *:[i32] })))  =>  (UZP2v4i32:{ *:[v4i32] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /*  99710 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /*  99713 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99715 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /*  99719 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /*  99723 */       GIR_RootConstrainSelectedInstOperands,
     /*  99724 */       // GIR_Coverage, 5617,
     /*  99724 */       GIR_EraseRootFromParent_Done,
     /*  99725 */     // Label 1545: @99725
     /*  99725 */     GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(99854), // Rule ID 6403 //
     /*  99730 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99734 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99738 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  99742 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  99745 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  99750 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99754 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  99758 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99763 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 32,
     /*  99767 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99769 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Vd, (intrinsic_wo_chain:{ *:[v2i32] } 667:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] }))  =>  (RADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Vn, (MOVIv2d_ns:{ *:[v2i64] } 0:{ *:[i32] }))
     /*  99769 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  99772 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /*  99776 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99781 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  99784 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  99786 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  99789 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99793 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99798 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99800 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99803 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99807 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99812 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  99815 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /*  99819 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99822 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99827 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99832 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99837 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v4i32),
     /*  99840 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99842 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99845 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /*  99849 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  99852 */       GIR_RootConstrainSelectedInstOperands,
     /*  99853 */       // GIR_Coverage, 6403,
     /*  99853 */       GIR_EraseRootFromParent_Done,
     /*  99854 */     // Label 1546: @99854
     /*  99854 */     GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(99896), // Rule ID 5858 //
     /*  99859 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  99866 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  99873 */       // (concat_vectors:{ *:[v4i32] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (INSvi64lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] })
     /*  99873 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  99876 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99878 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  99883 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99886 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99891 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  99894 */       GIR_RootConstrainSelectedInstOperands,
     /*  99895 */       // GIR_Coverage, 5858,
     /*  99895 */       GIR_EraseRootFromParent_Done,
     /*  99896 */     // Label 1547: @99896
     /*  99896 */     GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(99938), // Rule ID 5862 //
     /*  99901 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /*  99908 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /*  99915 */       // (concat_vectors:{ *:[v4f32] } (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn), (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm))  =>  (INSvi64lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] })
     /*  99915 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  99918 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99920 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  99925 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99928 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99933 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  99936 */       GIR_RootConstrainSelectedInstOperands,
     /*  99937 */       // GIR_Coverage, 5862,
     /*  99937 */       GIR_EraseRootFromParent_Done,
     /*  99938 */     // Label 1548: @99938
     /*  99938 */     GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(100061), // Rule ID 2574 //
     /*  99943 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99946 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99950 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99954 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  99958 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  99961 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  99966 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99970 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  99974 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99979 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  99983 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  99987 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  99991 */       // MIs[2] Operand 1
     /*  99991 */       // No operand predicates
     /*  99991 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  99993 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 667:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (RSHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /*  99993 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  99996 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100000 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100005 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100007 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100010 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 100014 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100019 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100022 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 100026 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100029 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100034 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100039 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100044 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv4i32_shift),
     /* 100047 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100049 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100052 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 100056 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 100059 */       GIR_RootConstrainSelectedInstOperands,
     /* 100060 */       // GIR_Coverage, 2574,
     /* 100060 */       GIR_EraseRootFromParent_Done,
     /* 100061 */     // Label 1549: @100061
     /* 100061 */     GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(100184), // Rule ID 6373 //
     /* 100066 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100069 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100073 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100077 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 100081 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 100085 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 100089 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /* 100093 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 100097 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100102 */       // MIs[2] imm
     /* 100102 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 100106 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 100110 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 100114 */       // MIs[3] Operand 1
     /* 100114 */       // No operand predicates
     /* 100114 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 100116 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)))  =>  (SHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /* 100116 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 100119 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100123 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100128 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100130 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100133 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 100137 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100142 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100145 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 100149 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100152 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100157 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100162 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100167 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i32_shift),
     /* 100170 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100172 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100175 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 100179 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /* 100182 */       GIR_RootConstrainSelectedInstOperands,
     /* 100183 */       // GIR_Coverage, 6373,
     /* 100183 */       GIR_EraseRootFromParent_Done,
     /* 100184 */     // Label 1550: @100184
     /* 100184 */     GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(100304), // Rule ID 6409 //
     /* 100189 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100193 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100197 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 100201 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 100205 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 100209 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 100213 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 100217 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100222 */       // MIs[2] imm
     /* 100222 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 100226 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 100230 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 100234 */       // MIs[3] Operand 1
     /* 100234 */       // No operand predicates
     /* 100234 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 100236 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)))  =>  (SHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /* 100236 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 100239 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100243 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100248 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100250 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100253 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 100257 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100262 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100265 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 100269 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100272 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100277 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100282 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100287 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i32_shift),
     /* 100290 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100292 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100295 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 100299 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /* 100302 */       GIR_RootConstrainSelectedInstOperands,
     /* 100303 */       // GIR_Coverage, 6409,
     /* 100303 */       GIR_EraseRootFromParent_Done,
     /* 100304 */     // Label 1551: @100304
     /* 100304 */     GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(100421), // Rule ID 2497 //
     /* 100309 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100312 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100316 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100320 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 100324 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 100327 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 100332 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 100336 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 100340 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100345 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100350 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100352 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 579:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (ADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 100352 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 100355 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100359 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100364 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100366 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100369 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 100373 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100378 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100381 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 100385 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100388 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100393 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100398 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100403 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v4i32),
     /* 100406 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100408 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100411 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 100415 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 100419 */       GIR_RootConstrainSelectedInstOperands,
     /* 100420 */       // GIR_Coverage, 2497,
     /* 100420 */       GIR_EraseRootFromParent_Done,
     /* 100421 */     // Label 1552: @100421
     /* 100421 */     GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(100538), // Rule ID 5387 //
     /* 100426 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100429 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100433 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100437 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 100441 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 100444 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 100449 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 100453 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 100457 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100462 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100467 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100469 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 100469 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 100472 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100476 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100481 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100483 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100486 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 100490 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100495 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100498 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 100502 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100505 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100510 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100515 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100520 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /* 100523 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100525 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100528 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 100532 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 100536 */       GIR_RootConstrainSelectedInstOperands,
     /* 100537 */       // GIR_Coverage, 5387,
     /* 100537 */       GIR_EraseRootFromParent_Done,
     /* 100538 */     // Label 1553: @100538
     /* 100538 */     GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(100655), // Rule ID 5390 //
     /* 100543 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100546 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100550 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100554 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 100558 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 100561 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 100566 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 100570 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 100574 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100579 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100584 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100586 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 666:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (RADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 100586 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 100589 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100593 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100598 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100600 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100603 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 100607 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100612 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100615 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 100619 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100622 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100627 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100632 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100637 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v4i32),
     /* 100640 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100642 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100645 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 100649 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 100653 */       GIR_RootConstrainSelectedInstOperands,
     /* 100654 */       // GIR_Coverage, 5390,
     /* 100654 */       GIR_EraseRootFromParent_Done,
     /* 100655 */     // Label 1554: @100655
     /* 100655 */     GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(100772), // Rule ID 5393 //
     /* 100660 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100663 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100667 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100671 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 100675 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 100678 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 100683 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 100687 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 100691 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100696 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100701 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100703 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 668:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (RSUBHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 100703 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 100706 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100710 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100715 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100717 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100720 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 100724 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100729 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100732 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 100736 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100739 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100744 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100749 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100754 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv2i64_v4i32),
     /* 100757 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100759 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100762 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 100766 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 100770 */       GIR_RootConstrainSelectedInstOperands,
     /* 100771 */       // GIR_Coverage, 5393,
     /* 100771 */       GIR_EraseRootFromParent_Done,
     /* 100772 */     // Label 1555: @100772
     /* 100772 */     GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(100876), // Rule ID 2493 //
     /* 100777 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100780 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100784 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100788 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 100792 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 100795 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtxn),
     /* 100800 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 100804 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100809 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100811 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, (intrinsic_wo_chain:{ *:[v2f32] } 601:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn))  =>  (FCVTXNv4f32:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rn)
     /* 100811 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 100814 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100818 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100823 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100825 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100828 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 100832 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100837 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100840 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 100844 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100847 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100852 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100857 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100862 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv4f32),
     /* 100865 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100867 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100870 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 100874 */       GIR_RootConstrainSelectedInstOperands,
     /* 100875 */       // GIR_Coverage, 2493,
     /* 100875 */       GIR_EraseRootFromParent_Done,
     /* 100876 */     // Label 1556: @100876
     /* 100876 */     GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(100932), // Rule ID 5550 //
     /* 100881 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100885 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 100889 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 100893 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100898 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 100902 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 100906 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 100910 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100915 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 100917 */       // (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn), (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vm))  =>  (UZP1v4i32:{ *:[v4i32] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 100917 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 100920 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100922 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 100926 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /* 100930 */       GIR_RootConstrainSelectedInstOperands,
     /* 100931 */       // GIR_Coverage, 5550,
     /* 100931 */       GIR_EraseRootFromParent_Done,
     /* 100932 */     // Label 1557: @100932
     /* 100932 */     GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(100998), // Rule ID 5856 //
     /* 100937 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100941 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100945 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 100951 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 100953 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100955 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /* 100955 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 100958 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /* 100962 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100967 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 100971 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 100973 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 100976 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100978 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100981 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100984 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 100987 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100992 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100997 */       // GIR_Coverage, 5856,
     /* 100997 */       GIR_EraseRootFromParent_Done,
     /* 100998 */     // Label 1558: @100998
     /* 100998 */     GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(101064), // Rule ID 5860 //
     /* 101003 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101007 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101011 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 101017 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 101019 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101021 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v2f32] }:$Rn), dsub:{ *:[i32] })
     /* 101021 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 101024 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /* 101028 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101033 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 101037 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 101039 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 101042 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101044 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101047 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101050 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 101053 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101058 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101063 */       // GIR_Coverage, 5860,
     /* 101063 */       GIR_EraseRootFromParent_Done,
     /* 101064 */     // Label 1559: @101064
     /* 101064 */     GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(101157), // Rule ID 4975 //
     /* 101069 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101073 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101077 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /* 101081 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 101085 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101090 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101092 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, (fpround:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn))  =>  (FCVTNv4i32:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rn)
     /* 101092 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 101095 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101099 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101104 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101106 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101109 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101113 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101118 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 101121 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101125 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101128 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101133 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101138 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101143 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i32),
     /* 101146 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101148 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101151 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 101155 */       GIR_RootConstrainSelectedInstOperands,
     /* 101156 */       // GIR_Coverage, 4975,
     /* 101156 */       GIR_EraseRootFromParent_Done,
     /* 101157 */     // Label 1560: @101157
     /* 101157 */     GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(101253), // Rule ID 5022 //
     /* 101162 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 101165 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101169 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101173 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 101177 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 101181 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101186 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101188 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn))  =>  (XTNv4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn)
     /* 101188 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 101191 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101195 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101200 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101202 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101205 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101209 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101214 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 101217 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101221 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101224 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101229 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101234 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101239 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i32),
     /* 101242 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101244 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101247 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 101251 */       GIR_RootConstrainSelectedInstOperands,
     /* 101252 */       // GIR_Coverage, 5022,
     /* 101252 */       GIR_EraseRootFromParent_Done,
     /* 101253 */     // Label 1561: @101253
     /* 101253 */     GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(101315), // Rule ID 5857 //
     /* 101258 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101262 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101266 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 101270 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101272 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rn, (undef:{ *:[v2i32] }))  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] })
     /* 101272 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 101275 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101279 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101284 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 101286 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101289 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101291 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101294 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101296 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 101299 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101304 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101309 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101314 */       // GIR_Coverage, 5857,
     /* 101314 */       GIR_EraseRootFromParent_Done,
     /* 101315 */     // Label 1562: @101315
     /* 101315 */     GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(101377), // Rule ID 5861 //
     /* 101320 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101324 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101328 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 101332 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101334 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rn, (undef:{ *:[v2f32] }))  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] })
     /* 101334 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 101337 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101341 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101346 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 101348 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101351 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101353 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101356 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101358 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 101361 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101366 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101371 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101376 */       // GIR_Coverage, 5861,
     /* 101376 */       GIR_EraseRootFromParent_Done,
     /* 101377 */     // Label 1563: @101377
     /* 101377 */     GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(101511), // Rule ID 5855 //
     /* 101382 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101386 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101390 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (INSvi64lane:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 101390 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 101393 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101397 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101402 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 101404 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 101407 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101411 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101416 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 101419 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 101423 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 101426 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101431 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101436 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101441 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 101444 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101448 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101453 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101455 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101458 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101462 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101467 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 101470 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101474 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101477 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101482 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101487 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101492 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 101495 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101497 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101500 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 101503 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 101506 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101509 */       GIR_RootConstrainSelectedInstOperands,
     /* 101510 */       // GIR_Coverage, 5855,
     /* 101510 */       GIR_EraseRootFromParent_Done,
     /* 101511 */     // Label 1564: @101511
     /* 101511 */     GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(101645), // Rule ID 5859 //
     /* 101516 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101520 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101524 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn)  =>  (INSvi64lane:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 101524 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 101527 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101531 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101536 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 101538 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 101541 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101545 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101550 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 101553 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 101557 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 101560 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101565 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101570 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101575 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 101578 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101582 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101587 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101589 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101592 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101596 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101601 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 101604 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101608 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101611 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101616 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101621 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101626 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 101629 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101631 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101634 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 101637 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 101640 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101643 */       GIR_RootConstrainSelectedInstOperands,
     /* 101644 */       // GIR_Coverage, 5859,
     /* 101644 */       GIR_EraseRootFromParent_Done,
     /* 101645 */     // Label 1565: @101645
     /* 101645 */     GIM_Reject,
     /* 101646 */   // Label 1541: @101646
     /* 101646 */   GIM_Reject,
     /* 101647 */   // Label 1524: @101647
     /* 101647 */   GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(104055),
     /* 101652 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 101655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 101658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101662 */     GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(101791), // Rule ID 5465 //
     /* 101667 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101671 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101675 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 101679 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101683 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 101687 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 101691 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101695 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 101699 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 101703 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101707 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 101711 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101716 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 101720 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 101726 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /* 101728 */       // MIs[2] Operand 2
     /* 101728 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /* 101739 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 101741 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 101741 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101744 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 101748 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101753 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 101756 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101760 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101763 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101768 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101773 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /* 101776 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101778 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101781 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /* 101785 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 101789 */       GIR_RootConstrainSelectedInstOperands,
     /* 101790 */       // GIR_Coverage, 5465,
     /* 101790 */       GIR_EraseRootFromParent_Done,
     /* 101791 */     // Label 1567: @101791
     /* 101791 */     GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(101913), // Rule ID 5461 //
     /* 101796 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101800 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101804 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 101808 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101812 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 101816 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 101820 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101824 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 101828 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 101832 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101836 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 101840 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101845 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101850 */       // MIs[2] Operand 2
     /* 101850 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /* 101861 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 101863 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (ADDHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 101863 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101866 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 101870 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101875 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 101878 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101882 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101885 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101890 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101895 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v8i16),
     /* 101898 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101900 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101903 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 101907 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /* 101911 */       GIR_RootConstrainSelectedInstOperands,
     /* 101912 */       // GIR_Coverage, 5461,
     /* 101912 */       GIR_EraseRootFromParent_Done,
     /* 101913 */     // Label 1568: @101913
     /* 101913 */     GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(102035), // Rule ID 5463 //
     /* 101918 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101922 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101926 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 101930 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101934 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 101938 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 101942 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101946 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 101950 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 101954 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101958 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 101962 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101967 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101972 */       // MIs[2] Operand 2
     /* 101972 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /* 101983 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 101985 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 101985 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101988 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 101992 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101997 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 102000 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102004 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102007 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102012 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102017 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /* 102020 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102022 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102025 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 102029 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /* 102033 */       GIR_RootConstrainSelectedInstOperands,
     /* 102034 */       // GIR_Coverage, 5463,
     /* 102034 */       GIR_EraseRootFromParent_Done,
     /* 102035 */     // Label 1569: @102035
     /* 102035 */     GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(102137), // Rule ID 5616 //
     /* 102040 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102044 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 102048 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102052 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 102056 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 102060 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102064 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102069 */       // MIs[2] Operand 2
     /* 102069 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /* 102080 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 102084 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 102088 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102092 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 102096 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /* 102100 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102104 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102109 */       // MIs[4] Operand 2
     /* 102109 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(16),
     /* 102120 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 102122 */       // (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] })), (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, 16:{ *:[i32] })))  =>  (UZP2v8i16:{ *:[v8i16] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 102122 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 102125 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 102127 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 102131 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /* 102135 */       GIR_RootConstrainSelectedInstOperands,
     /* 102136 */       // GIR_Coverage, 5616,
     /* 102136 */       GIR_EraseRootFromParent_Done,
     /* 102137 */     // Label 1570: @102137
     /* 102137 */     GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(102266), // Rule ID 6402 //
     /* 102142 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102146 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102150 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 102154 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 102157 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 102162 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 102166 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 102170 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102175 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 16,
     /* 102179 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102181 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Vd, (intrinsic_wo_chain:{ *:[v4i16] } 667:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] }))  =>  (RADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Vn, (MOVIv2d_ns:{ *:[v4i32] } 0:{ *:[i32] }))
     /* 102181 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 102184 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 102188 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102193 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 102196 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 102198 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 102201 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102205 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102210 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102212 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102215 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102219 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102224 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 102227 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /* 102231 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102234 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102239 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102244 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102249 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v8i16),
     /* 102252 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102254 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102257 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 102261 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 102264 */       GIR_RootConstrainSelectedInstOperands,
     /* 102265 */       // GIR_Coverage, 6402,
     /* 102265 */       GIR_EraseRootFromParent_Done,
     /* 102266 */     // Label 1571: @102266
     /* 102266 */     GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(102308), // Rule ID 5866 //
     /* 102271 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 102278 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 102285 */       // (concat_vectors:{ *:[v8i16] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (INSvi64lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] })
     /* 102285 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 102288 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102290 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 102295 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102298 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102303 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 102306 */       GIR_RootConstrainSelectedInstOperands,
     /* 102307 */       // GIR_Coverage, 5866,
     /* 102307 */       GIR_EraseRootFromParent_Done,
     /* 102308 */     // Label 1572: @102308
     /* 102308 */     GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(102350), // Rule ID 5870 //
     /* 102313 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /* 102320 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /* 102327 */       // (concat_vectors:{ *:[v8f16] } (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn), (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rm))  =>  (INSvi64lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] })
     /* 102327 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 102330 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102332 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 102337 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102340 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102345 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 102348 */       GIR_RootConstrainSelectedInstOperands,
     /* 102349 */       // GIR_Coverage, 5870,
     /* 102349 */       GIR_EraseRootFromParent_Done,
     /* 102350 */     // Label 1573: @102350
     /* 102350 */     GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(102473), // Rule ID 2572 //
     /* 102355 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102358 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102362 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102366 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 102370 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 102373 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 102378 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 102382 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 102386 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102391 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 102395 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 102399 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 102403 */       // MIs[2] Operand 1
     /* 102403 */       // No operand predicates
     /* 102403 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 102405 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 667:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (RSHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /* 102405 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 102408 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102412 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102417 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102419 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102422 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102426 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102431 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 102434 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102438 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102441 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102446 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102451 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102456 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv8i16_shift),
     /* 102459 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102461 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102464 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 102468 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 102471 */       GIR_RootConstrainSelectedInstOperands,
     /* 102472 */       // GIR_Coverage, 2572,
     /* 102472 */       GIR_EraseRootFromParent_Done,
     /* 102473 */     // Label 1574: @102473
     /* 102473 */     GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(102596), // Rule ID 6372 //
     /* 102478 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102481 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102485 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102489 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 102493 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102497 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 102501 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /* 102505 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102509 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102514 */       // MIs[2] imm
     /* 102514 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 102518 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 102522 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 102526 */       // MIs[3] Operand 1
     /* 102526 */       // No operand predicates
     /* 102526 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 102528 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)))  =>  (SHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /* 102528 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 102531 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102535 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102540 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102542 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102545 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102549 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102554 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 102557 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102561 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102564 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102569 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102574 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102579 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i16_shift),
     /* 102582 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102584 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102587 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 102591 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /* 102594 */       GIR_RootConstrainSelectedInstOperands,
     /* 102595 */       // GIR_Coverage, 6372,
     /* 102595 */       GIR_EraseRootFromParent_Done,
     /* 102596 */     // Label 1575: @102596
     /* 102596 */     GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(102716), // Rule ID 6408 //
     /* 102601 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102605 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102609 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 102613 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102617 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 102621 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 102625 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102629 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102634 */       // MIs[2] imm
     /* 102634 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 102638 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 102642 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 102646 */       // MIs[3] Operand 1
     /* 102646 */       // No operand predicates
     /* 102646 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 102648 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)))  =>  (SHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /* 102648 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 102651 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102655 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102660 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102662 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102665 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102669 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102674 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 102677 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102681 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102684 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102689 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102694 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102699 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i16_shift),
     /* 102702 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102704 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102707 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 102711 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /* 102714 */       GIR_RootConstrainSelectedInstOperands,
     /* 102715 */       // GIR_Coverage, 6408,
     /* 102715 */       GIR_EraseRootFromParent_Done,
     /* 102716 */     // Label 1576: @102716
     /* 102716 */     GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(102833), // Rule ID 2496 //
     /* 102721 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102724 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102728 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102732 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 102736 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 102739 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 102744 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 102748 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 102752 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102757 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102762 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102764 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 579:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (ADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 102764 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 102767 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102771 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102776 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102778 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102781 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102785 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102790 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 102793 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102797 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102800 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102805 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102810 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102815 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v8i16),
     /* 102818 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102820 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102823 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 102827 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 102831 */       GIR_RootConstrainSelectedInstOperands,
     /* 102832 */       // GIR_Coverage, 2496,
     /* 102832 */       GIR_EraseRootFromParent_Done,
     /* 102833 */     // Label 1577: @102833
     /* 102833 */     GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(102950), // Rule ID 5386 //
     /* 102838 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102841 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102845 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102849 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 102853 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 102856 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 102861 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 102865 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 102869 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102874 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102879 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102881 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 102881 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 102884 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102888 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102893 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102895 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102898 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102902 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102907 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 102910 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102914 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102917 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102922 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102927 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102932 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /* 102935 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102937 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102940 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 102944 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 102948 */       GIR_RootConstrainSelectedInstOperands,
     /* 102949 */       // GIR_Coverage, 5386,
     /* 102949 */       GIR_EraseRootFromParent_Done,
     /* 102950 */     // Label 1578: @102950
     /* 102950 */     GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(103067), // Rule ID 5389 //
     /* 102955 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102958 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102962 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102966 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 102970 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 102973 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 102978 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 102982 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 102986 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102991 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102996 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102998 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 666:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (RADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 102998 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103001 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103005 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103010 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103012 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103015 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103019 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103024 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103027 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 103031 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103034 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103039 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103044 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103049 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v8i16),
     /* 103052 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103054 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103057 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 103061 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 103065 */       GIR_RootConstrainSelectedInstOperands,
     /* 103066 */       // GIR_Coverage, 5389,
     /* 103066 */       GIR_EraseRootFromParent_Done,
     /* 103067 */     // Label 1579: @103067
     /* 103067 */     GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(103184), // Rule ID 5392 //
     /* 103072 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103075 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103079 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103083 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103087 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103090 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 103095 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 103099 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 103103 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103108 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103113 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103115 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 668:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (RSUBHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 103115 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103118 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103122 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103127 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103129 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103132 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103136 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103141 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103144 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 103148 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103151 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103156 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103161 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103166 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv4i32_v8i16),
     /* 103169 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103171 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103174 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 103178 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 103182 */       GIR_RootConstrainSelectedInstOperands,
     /* 103183 */       // GIR_Coverage, 5392,
     /* 103183 */       GIR_EraseRootFromParent_Done,
     /* 103184 */     // Label 1580: @103184
     /* 103184 */     GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(103285), // Rule ID 4969 //
     /* 103189 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103193 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103197 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103201 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 103204 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2hf),
     /* 103209 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 103213 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103218 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103220 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 774:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn))  =>  (FCVTNv8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rn)
     /* 103220 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103223 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103227 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103232 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103234 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103237 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103241 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103246 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103249 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 103253 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103256 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103261 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103266 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103271 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 103274 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103276 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103279 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 103283 */       GIR_RootConstrainSelectedInstOperands,
     /* 103284 */       // GIR_Coverage, 4969,
     /* 103284 */       GIR_EraseRootFromParent_Done,
     /* 103285 */     // Label 1581: @103285
     /* 103285 */     GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(103341), // Rule ID 5541 //
     /* 103290 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103294 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 103298 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 103302 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103307 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 103311 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 103315 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 103319 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103324 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 103326 */       // (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn), (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vm))  =>  (UZP1v8i16:{ *:[v8i16] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 103326 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 103329 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103331 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 103335 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /* 103339 */       GIR_RootConstrainSelectedInstOperands,
     /* 103340 */       // GIR_Coverage, 5541,
     /* 103340 */       GIR_EraseRootFromParent_Done,
     /* 103341 */     // Label 1582: @103341
     /* 103341 */     GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(103407), // Rule ID 5864 //
     /* 103346 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103350 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103354 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 103360 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 103362 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103364 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v4i16] }:$Rn), dsub:{ *:[i32] })
     /* 103364 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 103367 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /* 103371 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103376 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 103380 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103382 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103385 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103387 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103390 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103393 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 103396 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103401 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103406 */       // GIR_Coverage, 5864,
     /* 103406 */       GIR_EraseRootFromParent_Done,
     /* 103407 */     // Label 1583: @103407
     /* 103407 */     GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(103473), // Rule ID 5868 //
     /* 103412 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103416 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103420 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 103426 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 103428 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103430 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v4f16] }:$Rn), dsub:{ *:[i32] })
     /* 103430 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 103433 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /* 103437 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103442 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 103446 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103448 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103451 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103453 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103456 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103459 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 103462 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103467 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103472 */       // GIR_Coverage, 5868,
     /* 103472 */       GIR_EraseRootFromParent_Done,
     /* 103473 */     // Label 1584: @103473
     /* 103473 */     GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(103566), // Rule ID 4977 //
     /* 103478 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103482 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103486 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /* 103490 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 103494 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103499 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103501 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rd, (fpround:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn))  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rn)
     /* 103501 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103504 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103508 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103513 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103515 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103518 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103522 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103527 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103530 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 103534 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103537 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103542 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103547 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103552 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 103555 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103557 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103560 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 103564 */       GIR_RootConstrainSelectedInstOperands,
     /* 103565 */       // GIR_Coverage, 4977,
     /* 103565 */       GIR_EraseRootFromParent_Done,
     /* 103566 */     // Label 1585: @103566
     /* 103566 */     GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(103662), // Rule ID 5021 //
     /* 103571 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103574 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103578 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103582 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 103586 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 103590 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103595 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103597 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn))  =>  (XTNv8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn)
     /* 103597 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103600 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103604 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103609 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103611 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103614 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103618 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103623 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103626 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 103630 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103633 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103638 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103643 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103648 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i16),
     /* 103651 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103653 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103656 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 103660 */       GIR_RootConstrainSelectedInstOperands,
     /* 103661 */       // GIR_Coverage, 5021,
     /* 103661 */       GIR_EraseRootFromParent_Done,
     /* 103662 */     // Label 1586: @103662
     /* 103662 */     GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(103724), // Rule ID 5865 //
     /* 103667 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103671 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103675 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 103679 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103681 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rn, (undef:{ *:[v4i16] }))  =>  (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] })
     /* 103681 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 103684 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103688 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103693 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103695 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103698 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103700 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103703 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 103705 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 103708 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103713 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103718 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103723 */       // GIR_Coverage, 5865,
     /* 103723 */       GIR_EraseRootFromParent_Done,
     /* 103724 */     // Label 1587: @103724
     /* 103724 */     GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(103786), // Rule ID 5869 //
     /* 103729 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103733 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103737 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 103741 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103743 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rn, (undef:{ *:[v4f16] }))  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] })
     /* 103743 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 103746 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103750 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103755 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103757 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103760 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103762 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103765 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 103767 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 103770 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103775 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103780 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103785 */       // GIR_Coverage, 5869,
     /* 103785 */       GIR_EraseRootFromParent_Done,
     /* 103786 */     // Label 1588: @103786
     /* 103786 */     GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(103920), // Rule ID 5863 //
     /* 103791 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103795 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103799 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (INSvi64lane:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 103799 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 103802 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103806 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103811 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 103813 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 103816 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103820 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103825 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 103828 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 103832 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 103835 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103840 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103845 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103850 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103853 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103857 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103862 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103864 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103867 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103871 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103876 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103879 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 103883 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103886 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103891 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103896 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103901 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 103904 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103906 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103909 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 103912 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 103915 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103918 */       GIR_RootConstrainSelectedInstOperands,
     /* 103919 */       // GIR_Coverage, 5863,
     /* 103919 */       GIR_EraseRootFromParent_Done,
     /* 103920 */     // Label 1589: @103920
     /* 103920 */     GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(104054), // Rule ID 5867 //
     /* 103925 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103929 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103933 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn)  =>  (INSvi64lane:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 103933 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 103936 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103940 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103945 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 103947 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 103950 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103954 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103959 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 103962 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 103966 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 103969 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103974 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103979 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103984 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103987 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103991 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103996 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103998 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 104001 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104005 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104010 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 104013 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 104017 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 104020 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104025 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104030 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104035 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 104038 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104040 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104043 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 104046 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 104049 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104052 */       GIR_RootConstrainSelectedInstOperands,
     /* 104053 */       // GIR_Coverage, 5867,
     /* 104053 */       GIR_EraseRootFromParent_Done,
     /* 104054 */     // Label 1590: @104054
     /* 104054 */     GIM_Reject,
     /* 104055 */   // Label 1566: @104055
     /* 104055 */   GIM_Reject,
     /* 104056 */   // Label 1525: @104056
     /* 104056 */   GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(105966),
     /* 104061 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 104064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 104067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104071 */     GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(104200), // Rule ID 5459 //
     /* 104076 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104080 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 104084 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 104088 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104092 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 104096 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 104100 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104104 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 104108 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 104112 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104116 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 104120 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104125 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 104129 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 104135 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /* 104137 */       // MIs[2] Operand 2
     /* 104137 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 104148 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 104150 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 104150 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 104153 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 104157 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104162 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 104165 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 104169 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 104172 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104177 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104182 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /* 104185 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104187 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104190 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /* 104194 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 104198 */       GIR_RootConstrainSelectedInstOperands,
     /* 104199 */       // GIR_Coverage, 5459,
     /* 104199 */       GIR_EraseRootFromParent_Done,
     /* 104200 */     // Label 1592: @104200
     /* 104200 */     GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(104322), // Rule ID 5455 //
     /* 104205 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104209 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 104213 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 104217 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104221 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 104225 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 104229 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104233 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 104237 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 104241 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104245 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 104249 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104254 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104259 */       // MIs[2] Operand 2
     /* 104259 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 104270 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 104272 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (ADDHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 104272 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 104275 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 104279 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104284 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 104287 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 104291 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 104294 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104299 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104304 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v16i8),
     /* 104307 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104309 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104312 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 104316 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /* 104320 */       GIR_RootConstrainSelectedInstOperands,
     /* 104321 */       // GIR_Coverage, 5455,
     /* 104321 */       GIR_EraseRootFromParent_Done,
     /* 104322 */     // Label 1593: @104322
     /* 104322 */     GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(104444), // Rule ID 5457 //
     /* 104327 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104331 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 104335 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 104339 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104343 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 104347 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 104351 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104355 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 104359 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 104363 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104367 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 104371 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104376 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104381 */       // MIs[2] Operand 2
     /* 104381 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 104392 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 104394 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 104394 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 104397 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 104401 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104406 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 104409 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 104413 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 104416 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104421 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104426 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /* 104429 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104431 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104434 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 104438 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /* 104442 */       GIR_RootConstrainSelectedInstOperands,
     /* 104443 */       // GIR_Coverage, 5457,
     /* 104443 */       GIR_EraseRootFromParent_Done,
     /* 104444 */     // Label 1594: @104444
     /* 104444 */     GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(104546), // Rule ID 5615 //
     /* 104449 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104453 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 104457 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104461 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 104465 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 104469 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104473 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104478 */       // MIs[2] Operand 2
     /* 104478 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 104489 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 104493 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 104497 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104501 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 104505 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /* 104509 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104513 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104518 */       // MIs[4] Operand 2
     /* 104518 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(8),
     /* 104529 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 104531 */       // (concat_vectors:{ *:[v16i8] } (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] })), (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, 8:{ *:[i32] })))  =>  (UZP2v16i8:{ *:[v16i8] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 104531 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 104534 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 104536 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 104540 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /* 104544 */       GIR_RootConstrainSelectedInstOperands,
     /* 104545 */       // GIR_Coverage, 5615,
     /* 104545 */       GIR_EraseRootFromParent_Done,
     /* 104546 */     // Label 1595: @104546
     /* 104546 */     GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(104675), // Rule ID 6401 //
     /* 104551 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104555 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 104559 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 104563 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 104566 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 104571 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 104575 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 104579 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104584 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 8,
     /* 104588 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104590 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Vd, (intrinsic_wo_chain:{ *:[v8i8] } 667:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] }))  =>  (RADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Vn, (MOVIv2d_ns:{ *:[v8i16] } 0:{ *:[i32] }))
     /* 104590 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 104593 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 104597 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104602 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 104605 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 104607 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 104610 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104614 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104619 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104621 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 104624 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104628 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104633 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 104636 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /* 104640 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 104643 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104648 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104653 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104658 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v16i8),
     /* 104661 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104663 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104666 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 104670 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 104673 */       GIR_RootConstrainSelectedInstOperands,
     /* 104674 */       // GIR_Coverage, 6401,
     /* 104674 */       GIR_EraseRootFromParent_Done,
     /* 104675 */     // Label 1596: @104675
     /* 104675 */     GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(104717), // Rule ID 5874 //
     /* 104680 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 104687 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 104694 */       // (concat_vectors:{ *:[v16i8] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (INSvi64lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] })
     /* 104694 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 104697 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104699 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 104704 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104707 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104712 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 104715 */       GIR_RootConstrainSelectedInstOperands,
     /* 104716 */       // GIR_Coverage, 5874,
     /* 104716 */       GIR_EraseRootFromParent_Done,
     /* 104717 */     // Label 1597: @104717
     /* 104717 */     GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(104840), // Rule ID 2570 //
     /* 104722 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104725 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104729 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 104733 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 104737 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 104740 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 104745 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 104749 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 104753 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104758 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 104762 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 104766 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 104770 */       // MIs[2] Operand 1
     /* 104770 */       // No operand predicates
     /* 104770 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 104772 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 667:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (RSHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /* 104772 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 104775 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104779 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104784 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104786 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 104789 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104793 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104798 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 104801 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 104805 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 104808 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104813 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104818 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104823 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv16i8_shift),
     /* 104826 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104828 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104831 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 104835 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 104838 */       GIR_RootConstrainSelectedInstOperands,
     /* 104839 */       // GIR_Coverage, 2570,
     /* 104839 */       GIR_EraseRootFromParent_Done,
     /* 104840 */     // Label 1598: @104840
     /* 104840 */     GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(104963), // Rule ID 6371 //
     /* 104845 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104848 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104852 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 104856 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 104860 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104864 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 104868 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /* 104872 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104876 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104881 */       // MIs[2] imm
     /* 104881 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 104885 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 104889 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 104893 */       // MIs[3] Operand 1
     /* 104893 */       // No operand predicates
     /* 104893 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 104895 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)))  =>  (SHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /* 104895 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 104898 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104902 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104907 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104909 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 104912 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104916 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104921 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 104924 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 104928 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 104931 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104936 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104941 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104946 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv16i8_shift),
     /* 104949 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104951 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104954 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 104958 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /* 104961 */       GIR_RootConstrainSelectedInstOperands,
     /* 104962 */       // GIR_Coverage, 6371,
     /* 104962 */       GIR_EraseRootFromParent_Done,
     /* 104963 */     // Label 1599: @104963
     /* 104963 */     GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(105083), // Rule ID 6407 //
     /* 104968 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104972 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 104976 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 104980 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104984 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 104988 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 104992 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104996 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105001 */       // MIs[2] imm
     /* 105001 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 105005 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 105009 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 105013 */       // MIs[3] Operand 1
     /* 105013 */       // No operand predicates
     /* 105013 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 105015 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)))  =>  (SHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /* 105015 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 105018 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105022 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105027 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105029 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 105032 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105036 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105041 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 105044 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 105048 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 105051 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105056 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105061 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105066 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv16i8_shift),
     /* 105069 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105071 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105074 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 105078 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /* 105081 */       GIR_RootConstrainSelectedInstOperands,
     /* 105082 */       // GIR_Coverage, 6407,
     /* 105082 */       GIR_EraseRootFromParent_Done,
     /* 105083 */     // Label 1600: @105083
     /* 105083 */     GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(105200), // Rule ID 2495 //
     /* 105088 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105091 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105095 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105099 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 105103 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 105106 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 105111 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 105115 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 105119 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105124 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105129 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105131 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 579:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (ADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 105131 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 105134 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105138 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105143 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105145 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 105148 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105152 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105157 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 105160 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 105164 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 105167 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105172 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105177 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105182 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v16i8),
     /* 105185 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105187 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105190 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 105194 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 105198 */       GIR_RootConstrainSelectedInstOperands,
     /* 105199 */       // GIR_Coverage, 2495,
     /* 105199 */       GIR_EraseRootFromParent_Done,
     /* 105200 */     // Label 1601: @105200
     /* 105200 */     GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(105317), // Rule ID 5385 //
     /* 105205 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105208 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105212 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105216 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 105220 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 105223 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 105228 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 105232 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 105236 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105241 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105246 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105248 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 105248 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 105251 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105255 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105260 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105262 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 105265 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105269 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105274 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 105277 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 105281 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 105284 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105289 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105294 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105299 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /* 105302 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105304 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105307 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 105311 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 105315 */       GIR_RootConstrainSelectedInstOperands,
     /* 105316 */       // GIR_Coverage, 5385,
     /* 105316 */       GIR_EraseRootFromParent_Done,
     /* 105317 */     // Label 1602: @105317
     /* 105317 */     GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(105434), // Rule ID 5388 //
     /* 105322 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105325 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105329 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105333 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 105337 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 105340 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 105345 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 105349 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 105353 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105358 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105363 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105365 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 666:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (RADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 105365 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 105368 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105372 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105377 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105379 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 105382 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105386 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105391 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 105394 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 105398 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 105401 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105406 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105411 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105416 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v16i8),
     /* 105419 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105421 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105424 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 105428 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 105432 */       GIR_RootConstrainSelectedInstOperands,
     /* 105433 */       // GIR_Coverage, 5388,
     /* 105433 */       GIR_EraseRootFromParent_Done,
     /* 105434 */     // Label 1603: @105434
     /* 105434 */     GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(105551), // Rule ID 5391 //
     /* 105439 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105442 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105446 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105450 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 105454 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 105457 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 105462 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 105466 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 105470 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105475 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105480 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105482 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 668:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (RSUBHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 105482 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 105485 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105489 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105494 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105496 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 105499 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105503 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105508 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 105511 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 105515 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 105518 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105523 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105528 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105533 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv8i16_v16i8),
     /* 105536 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105538 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105541 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 105545 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 105549 */       GIR_RootConstrainSelectedInstOperands,
     /* 105550 */       // GIR_Coverage, 5391,
     /* 105550 */       GIR_EraseRootFromParent_Done,
     /* 105551 */     // Label 1604: @105551
     /* 105551 */     GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(105607), // Rule ID 5532 //
     /* 105556 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105560 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 105564 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 105568 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105573 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 105577 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 105581 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 105585 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105590 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 105592 */       // (concat_vectors:{ *:[v16i8] } (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vn), (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vm))  =>  (UZP1v16i8:{ *:[v16i8] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 105592 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v16i8),
     /* 105595 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 105597 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 105601 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /* 105605 */       GIR_RootConstrainSelectedInstOperands,
     /* 105606 */       // GIR_Coverage, 5532,
     /* 105606 */       GIR_EraseRootFromParent_Done,
     /* 105607 */     // Label 1605: @105607
     /* 105607 */     GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(105673), // Rule ID 5872 //
     /* 105612 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105616 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105620 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 105626 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 105628 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105630 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v8i8] }:$Rn), dsub:{ *:[i32] })
     /* 105630 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105633 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /* 105637 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105642 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 105646 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 105648 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 105651 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105653 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105656 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105659 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 105662 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105667 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105672 */       // GIR_Coverage, 5872,
     /* 105672 */       GIR_EraseRootFromParent_Done,
     /* 105673 */     // Label 1606: @105673
     /* 105673 */     GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(105769), // Rule ID 5020 //
     /* 105678 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105681 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105685 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105689 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 105693 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 105697 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105702 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105704 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn))  =>  (XTNv16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn)
     /* 105704 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 105707 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105711 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105716 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105718 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 105721 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105725 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105730 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 105733 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 105737 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 105740 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105745 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105750 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105755 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv16i8),
     /* 105758 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105760 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105763 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 105767 */       GIR_RootConstrainSelectedInstOperands,
     /* 105768 */       // GIR_Coverage, 5020,
     /* 105768 */       GIR_EraseRootFromParent_Done,
     /* 105769 */     // Label 1607: @105769
     /* 105769 */     GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(105831), // Rule ID 5873 //
     /* 105774 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105778 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105782 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 105786 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105788 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rn, (undef:{ *:[v8i8] }))  =>  (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] })
     /* 105788 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 105791 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105795 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105800 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 105802 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105805 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105807 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105810 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 105812 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 105815 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105820 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105825 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105830 */       // GIR_Coverage, 5873,
     /* 105830 */       GIR_EraseRootFromParent_Done,
     /* 105831 */     // Label 1608: @105831
     /* 105831 */     GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(105965), // Rule ID 5871 //
     /* 105836 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105840 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105844 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (INSvi64lane:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 105844 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 105847 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105851 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105856 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 105858 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 105861 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105865 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105870 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 105873 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 105877 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 105880 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105885 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105890 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105895 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 105898 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105902 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105907 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105909 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 105912 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105916 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105921 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 105924 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 105928 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 105931 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105936 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105941 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105946 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 105949 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105951 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105954 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 105957 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 105960 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105963 */       GIR_RootConstrainSelectedInstOperands,
     /* 105964 */       // GIR_Coverage, 5871,
     /* 105964 */       GIR_EraseRootFromParent_Done,
     /* 105965 */     // Label 1609: @105965
     /* 105965 */     GIM_Reject,
     /* 105966 */   // Label 1591: @105966
     /* 105966 */   GIM_Reject,
     /* 105967 */   // Label 1526: @105967
     /* 105967 */   GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(105992), // Rule ID 9186 //
     /* 105972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 105975 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 105978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 105981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 105985 */     // (concat_vectors:{ *:[nxv2i1] } nxv1i1:{ *:[nxv1i1] }:$p1, nxv1i1:{ *:[nxv1i1] }:$p2)  =>  (UZP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv1i1] }:$p1, ?:{ *:[nxv1i1] }:$p2)
     /* 105985 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /* 105990 */     GIR_RootConstrainSelectedInstOperands,
     /* 105991 */     // GIR_Coverage, 9186,
     /* 105991 */     GIR_Done,
     /* 105992 */   // Label 1610: @105992
     /* 105992 */   GIM_Reject,
     /* 105993 */   // Label 1527: @105993
     /* 105993 */   GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(106018), // Rule ID 9187 //
     /* 105998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 106001 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 106004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 106007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 106011 */     // (concat_vectors:{ *:[nxv4i1] } nxv2i1:{ *:[nxv2i1] }:$p1, nxv2i1:{ *:[nxv2i1] }:$p2)  =>  (UZP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv2i1] }:$p1, ?:{ *:[nxv2i1] }:$p2)
     /* 106011 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /* 106016 */     GIR_RootConstrainSelectedInstOperands,
     /* 106017 */     // GIR_Coverage, 9187,
     /* 106017 */     GIR_Done,
     /* 106018 */   // Label 1611: @106018
     /* 106018 */   GIM_Reject,
     /* 106019 */   // Label 1528: @106019
     /* 106019 */   GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(106044), // Rule ID 9190 //
     /* 106024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 106027 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 106030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 106033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 106037 */     // (concat_vectors:{ *:[nxv4f16] } nxv2f16:{ *:[nxv2f16] }:$v1, nxv2f16:{ *:[nxv2f16] }:$v2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv2f16] }:$v1, ?:{ *:[nxv2f16] }:$v2)
     /* 106037 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 106042 */     GIR_RootConstrainSelectedInstOperands,
     /* 106043 */     // GIR_Coverage, 9190,
     /* 106043 */     GIR_Done,
     /* 106044 */   // Label 1612: @106044
     /* 106044 */   GIM_Reject,
     /* 106045 */   // Label 1529: @106045
     /* 106045 */   GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(106070), // Rule ID 9192 //
     /* 106050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 106053 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 106056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 106059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 106063 */     // (concat_vectors:{ *:[nxv4f32] } nxv2f32:{ *:[nxv2f32] }:$v1, nxv2f32:{ *:[nxv2f32] }:$v2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv2f32] }:$v1, ?:{ *:[nxv2f32] }:$v2)
     /* 106063 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 106068 */     GIR_RootConstrainSelectedInstOperands,
     /* 106069 */     // GIR_Coverage, 9192,
     /* 106069 */     GIR_Done,
     /* 106070 */   // Label 1613: @106070
     /* 106070 */   GIM_Reject,
     /* 106071 */   // Label 1530: @106071
     /* 106071 */   GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(106096), // Rule ID 9188 //
     /* 106076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 106079 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 106082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 106085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 106089 */     // (concat_vectors:{ *:[nxv8i1] } nxv4i1:{ *:[nxv4i1] }:$p1, nxv4i1:{ *:[nxv4i1] }:$p2)  =>  (UZP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv4i1] }:$p1, ?:{ *:[nxv4i1] }:$p2)
     /* 106089 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /* 106094 */     GIR_RootConstrainSelectedInstOperands,
     /* 106095 */     // GIR_Coverage, 9188,
     /* 106095 */     GIR_Done,
     /* 106096 */   // Label 1614: @106096
     /* 106096 */   GIM_Reject,
     /* 106097 */   // Label 1531: @106097
     /* 106097 */   GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(106122), // Rule ID 9191 //
     /* 106102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 106105 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 106108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 106111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 106115 */     // (concat_vectors:{ *:[nxv8f16] } nxv4f16:{ *:[nxv4f16] }:$v1, nxv4f16:{ *:[nxv4f16] }:$v2)  =>  (UZP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv4f16] }:$v1, ?:{ *:[nxv4f16] }:$v2)
     /* 106115 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /* 106120 */     GIR_RootConstrainSelectedInstOperands,
     /* 106121 */     // GIR_Coverage, 9191,
     /* 106121 */     GIR_Done,
     /* 106122 */   // Label 1615: @106122
     /* 106122 */   GIM_Reject,
     /* 106123 */   // Label 1532: @106123
     /* 106123 */   GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(106148), // Rule ID 9189 //
     /* 106128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 106131 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 106134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 106137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 106141 */     // (concat_vectors:{ *:[nxv16i1] } nxv8i1:{ *:[nxv8i1] }:$p1, nxv8i1:{ *:[nxv8i1] }:$p2)  =>  (UZP1_PPP_B:{ *:[nxv16i1] } ?:{ *:[nxv8i1] }:$p1, ?:{ *:[nxv8i1] }:$p2)
     /* 106141 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_B),
     /* 106146 */     GIR_RootConstrainSelectedInstOperands,
     /* 106147 */     // GIR_Coverage, 9189,
     /* 106147 */     GIR_Done,
     /* 106148 */   // Label 1616: @106148
     /* 106148 */   GIM_Reject,
     /* 106149 */   // Label 1533: @106149
     /* 106149 */   GIM_Reject,
     /* 106150 */ // Label 1521: @106150
     /* 106150 */ GIM_Reject,
     /* 106151 */ // Label 9: @106151
     /* 106151 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1631*/ GIMT_Encode4(116232),
     /* 106162 */ /*GILLT_s32*//*Label 1617*/ GIMT_Encode4(106250),
     /* 106166 */ /*GILLT_s64*//*Label 1618*/ GIMT_Encode4(106753),
     /* 106170 */ /*GILLT_s128*//*Label 1619*/ GIMT_Encode4(108744),
     /* 106174 */ /*GILLT_v2s32*//*Label 1620*/ GIMT_Encode4(109390),
     /* 106178 */ /*GILLT_v2s64*//*Label 1621*/ GIMT_Encode4(110305),
     /* 106182 */ /*GILLT_v4s16*//*Label 1622*/ GIMT_Encode4(111074),
     /* 106186 */ /*GILLT_v4s32*//*Label 1623*/ GIMT_Encode4(111989),
     /* 106190 */ /*GILLT_v8s8*//*Label 1624*/ GIMT_Encode4(112834),
     /* 106194 */ /*GILLT_v8s16*//*Label 1625*/ GIMT_Encode4(113395),
     /* 106198 */ /*GILLT_v16s8*//*Label 1626*/ GIMT_Encode4(114240), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 106218 */ /*GILLT_nxv2s64*//*Label 1627*/ GIMT_Encode4(114692), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 106230 */ /*GILLT_nxv4s32*//*Label 1628*/ GIMT_Encode4(115141), GIMT_Encode4(0),
     /* 106238 */ /*GILLT_nxv8s16*//*Label 1629*/ GIMT_Encode4(115590), GIMT_Encode4(0),
     /* 106246 */ /*GILLT_nxv16s8*//*Label 1630*/ GIMT_Encode4(116039),
     /* 106250 */ // Label 1617: @106250
     /* 106250 */ GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(106752),
     /* 106255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 106258 */   GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(106332), // Rule ID 7138 //
     /* 106263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 106267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 106275 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106278 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 106282 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 106289 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 106292 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 106296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106298 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 106305 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15879>>)  =>  (LDRSroW:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 106305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 106308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106325 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 106330 */     GIR_RootConstrainSelectedInstOperands,
     /* 106331 */     // GIR_Coverage, 7138,
     /* 106331 */     GIR_EraseRootFromParent_Done,
     /* 106332 */   // Label 1633: @106332
     /* 106332 */   GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(106406), // Rule ID 7139 //
     /* 106337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 106341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 106349 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106352 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 106356 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 106363 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 106366 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 106370 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106372 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 106379 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15879>>)  =>  (LDRSroX:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 106379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 106382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106399 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 106404 */     GIR_RootConstrainSelectedInstOperands,
     /* 106405 */     // GIR_Coverage, 7139,
     /* 106405 */     GIR_EraseRootFromParent_Done,
     /* 106406 */   // Label 1634: @106406
     /* 106406 */   GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(106475), // Rule ID 7140 //
     /* 106411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 106415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 106423 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106426 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 106430 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 106437 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 106440 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 106444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106446 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 106453 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15879>>)  =>  (LDRSui:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 106453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 106456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106468 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 106473 */     GIR_RootConstrainSelectedInstOperands,
     /* 106474 */     // GIR_Coverage, 7140,
     /* 106474 */     GIR_EraseRootFromParent_Done,
     /* 106475 */   // Label 1635: @106475
     /* 106475 */   GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(106544), // Rule ID 7141 //
     /* 106480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 106484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 106492 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106495 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 106499 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 106506 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 106509 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 106513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106515 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 106522 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15879>>)  =>  (LDURSi:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 106522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 106525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 106542 */     GIR_RootConstrainSelectedInstOperands,
     /* 106543 */     // GIR_Coverage, 7141,
     /* 106543 */     GIR_EraseRootFromParent_Done,
     /* 106544 */   // Label 1636: @106544
     /* 106544 */   GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(106597), // Rule ID 5833 //
     /* 106549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 106553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 106561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 106565 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 106569 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 106573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106575 */     // (bitconvert:{ *:[f32] } (vector_extract:{ *:[i32] } v16i8:{ *:[v16i8] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v16i8] }:$src, bsub:{ *:[i32] })
     /* 106575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106580 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src
     /* 106586 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 106591 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 106596 */     // GIR_Coverage, 5833,
     /* 106596 */     GIR_EraseRootFromParent_Done,
     /* 106597 */   // Label 1637: @106597
     /* 106597 */   GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(106650), // Rule ID 5834 //
     /* 106602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 106606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 106614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 106618 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 106622 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 106626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106628 */     // (bitconvert:{ *:[f32] } (vector_extract:{ *:[i32] } v8i16:{ *:[v8i16] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v8i16] }:$src, hsub:{ *:[i32] })
     /* 106628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106633 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // src
     /* 106639 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 106644 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 106649 */     // GIR_Coverage, 5834,
     /* 106649 */     GIR_EraseRootFromParent_Done,
     /* 106650 */   // Label 1638: @106650
     /* 106650 */   GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(106703), // Rule ID 5835 //
     /* 106655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 106659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 106667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 106671 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 106675 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 106679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106681 */     // (bitconvert:{ *:[f32] } (vector_extract:{ *:[i32] } v4i32:{ *:[v4i32] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4i32] }:$src, ssub:{ *:[i32] })
     /* 106681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106686 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // src
     /* 106692 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 106697 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 106702 */     // GIR_Coverage, 5835,
     /* 106702 */     GIR_EraseRootFromParent_Done,
     /* 106703 */   // Label 1639: @106703
     /* 106703 */   GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(106727), // Rule ID 6743 //
     /* 106708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 106712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106716 */     // (bitconvert:{ *:[f32] } GPR32:{ *:[i32] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Xn, FPR32:{ *:[i32] })
     /* 106716 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106721 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 106726 */     // GIR_Coverage, 6743,
     /* 106726 */     GIR_Done,
     /* 106727 */   // Label 1640: @106727
     /* 106727 */   GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(106751), // Rule ID 6744 //
     /* 106732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 106740 */     // (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[i32] } FPR32:{ *:[f32] }:$Xn, GPR32:{ *:[i32] })
     /* 106740 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106745 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106750 */     // GIR_Coverage, 6744,
     /* 106750 */     GIR_Done,
     /* 106751 */   // Label 1641: @106751
     /* 106751 */   GIM_Reject,
     /* 106752 */ // Label 1632: @106752
     /* 106752 */ GIM_Reject,
     /* 106753 */ // Label 1618: @106753
     /* 106753 */ GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(106830), // Rule ID 7142 //
     /* 106758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106765 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106769 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 106773 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106776 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 106780 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 106787 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 106790 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 106794 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106796 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 106803 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15887>>)  =>  (LDRDroW:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 106803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 106806 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106808 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106813 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106818 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106823 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 106828 */   GIR_RootConstrainSelectedInstOperands,
     /* 106829 */   // GIR_Coverage, 7142,
     /* 106829 */   GIR_EraseRootFromParent_Done,
     /* 106830 */ // Label 1642: @106830
     /* 106830 */ GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(106907), // Rule ID 7143 //
     /* 106835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106842 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106846 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 106850 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106853 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 106857 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 106864 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 106867 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 106871 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106873 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 106880 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15887>>)  =>  (LDRDroX:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 106880 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 106883 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106885 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106890 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106895 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106900 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 106905 */   GIR_RootConstrainSelectedInstOperands,
     /* 106906 */   // GIR_Coverage, 7143,
     /* 106906 */   GIR_EraseRootFromParent_Done,
     /* 106907 */ // Label 1643: @106907
     /* 106907 */ GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(106979), // Rule ID 7144 //
     /* 106912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106919 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106923 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 106927 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106930 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 106934 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 106941 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 106944 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 106948 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106950 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 106957 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15887>>)  =>  (LDRDui:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 106957 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 106960 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106962 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106967 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106972 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 106977 */   GIR_RootConstrainSelectedInstOperands,
     /* 106978 */   // GIR_Coverage, 7144,
     /* 106978 */   GIR_EraseRootFromParent_Done,
     /* 106979 */ // Label 1644: @106979
     /* 106979 */ GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(107051), // Rule ID 7145 //
     /* 106984 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106991 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106995 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 106999 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 107002 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 107006 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 107013 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 107016 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 107020 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107022 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 107029 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15887>>)  =>  (LDURDi:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 107029 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 107032 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107034 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107039 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107044 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 107049 */   GIR_RootConstrainSelectedInstOperands,
     /* 107050 */   // GIR_Coverage, 7145,
     /* 107050 */   GIR_EraseRootFromParent_Done,
     /* 107051 */ // Label 1645: @107051
     /* 107051 */ GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(107107), // Rule ID 5836 //
     /* 107056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107063 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107067 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 107071 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 107075 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 107079 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 107083 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107085 */   // (bitconvert:{ *:[f64] } (vector_extract:{ *:[i64] } v2i64:{ *:[v2i64] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2i64] }:$src, dsub:{ *:[i32] })
     /* 107085 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107088 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107090 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
     /* 107096 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107101 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107106 */   // GIR_Coverage, 5836,
     /* 107106 */   GIR_EraseRootFromParent_Done,
     /* 107107 */ // Label 1646: @107107
     /* 107107 */ GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(107137), // Rule ID 6718 //
     /* 107112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 107118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107122 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107126 */   // (bitconvert:{ *:[i64] } V64:{ *:[v8i8] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v8i8] }:$Vn, GPR64:{ *:[i32] })
     /* 107126 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107131 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107136 */   // GIR_Coverage, 6718,
     /* 107136 */   GIR_Done,
     /* 107137 */ // Label 1647: @107137
     /* 107137 */ GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(107167), // Rule ID 6719 //
     /* 107142 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107152 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107156 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4i16] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4i16] }:$Vn, GPR64:{ *:[i32] })
     /* 107156 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107161 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107166 */   // GIR_Coverage, 6719,
     /* 107166 */   GIR_Done,
     /* 107167 */ // Label 1648: @107167
     /* 107167 */ GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(107197), // Rule ID 6720 //
     /* 107172 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 107178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107182 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107186 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2i32] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2i32] }:$Vn, GPR64:{ *:[i32] })
     /* 107186 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107191 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107196 */   // GIR_Coverage, 6720,
     /* 107196 */   GIR_Done,
     /* 107197 */ // Label 1649: @107197
     /* 107197 */ GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(107227), // Rule ID 6721 //
     /* 107202 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107212 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107216 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4f16] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4f16] }:$Vn, GPR64:{ *:[i32] })
     /* 107216 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107221 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107226 */   // GIR_Coverage, 6721,
     /* 107226 */   GIR_Done,
     /* 107227 */ // Label 1650: @107227
     /* 107227 */ GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(107257), // Rule ID 6722 //
     /* 107232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 107238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107242 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107246 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2f32] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2f32] }:$Vn, GPR64:{ *:[i32] })
     /* 107246 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107251 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107256 */   // GIR_Coverage, 6722,
     /* 107256 */   GIR_Done,
     /* 107257 */ // Label 1651: @107257
     /* 107257 */ GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(107287), // Rule ID 6723 //
     /* 107262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107276 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1f64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1f64] }:$Vn, GPR64:{ *:[i32] })
     /* 107276 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107281 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107286 */   // GIR_Coverage, 6723,
     /* 107286 */   GIR_Done,
     /* 107287 */ // Label 1652: @107287
     /* 107287 */ GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(107337), // Rule ID 6729 //
     /* 107292 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 107298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107302 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107306 */   // (bitconvert:{ *:[i64] } V64:{ *:[v8i8] }:$Vn)  =>  (REV64v8i8:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v8i8] }:$Vn, GPR64:{ *:[i32] }))
     /* 107306 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 107309 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107313 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107318 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /* 107322 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107327 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 107330 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 107332 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107335 */   GIR_RootConstrainSelectedInstOperands,
     /* 107336 */   // GIR_Coverage, 6729,
     /* 107336 */   GIR_EraseRootFromParent_Done,
     /* 107337 */ // Label 1653: @107337
     /* 107337 */ GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(107387), // Rule ID 6730 //
     /* 107342 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107352 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107356 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4i16] }:$Vn)  =>  (REV64v4i16:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4i16] }:$Vn, GPR64:{ *:[i32] }))
     /* 107356 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 107359 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107363 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107368 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /* 107372 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107377 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 107380 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 107382 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107385 */   GIR_RootConstrainSelectedInstOperands,
     /* 107386 */   // GIR_Coverage, 6730,
     /* 107386 */   GIR_EraseRootFromParent_Done,
     /* 107387 */ // Label 1654: @107387
     /* 107387 */ GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(107437), // Rule ID 6731 //
     /* 107392 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 107398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107402 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107406 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2i32] }:$Vn)  =>  (REV64v2i32:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2i32] }:$Vn, GPR64:{ *:[i32] }))
     /* 107406 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 107409 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107413 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107418 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /* 107422 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107427 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 107430 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 107432 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107435 */   GIR_RootConstrainSelectedInstOperands,
     /* 107436 */   // GIR_Coverage, 6731,
     /* 107436 */   GIR_EraseRootFromParent_Done,
     /* 107437 */ // Label 1655: @107437
     /* 107437 */ GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(107487), // Rule ID 6732 //
     /* 107442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107456 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4f16] }:$Vn)  =>  (REV64v4i16:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4f16] }:$Vn, GPR64:{ *:[i32] }))
     /* 107456 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 107459 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107463 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107468 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /* 107472 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107477 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 107480 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 107482 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107485 */   GIR_RootConstrainSelectedInstOperands,
     /* 107486 */   // GIR_Coverage, 6732,
     /* 107486 */   GIR_EraseRootFromParent_Done,
     /* 107487 */ // Label 1656: @107487
     /* 107487 */ GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(107537), // Rule ID 6733 //
     /* 107492 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 107498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107502 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107506 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2f32] }:$Vn)  =>  (REV64v2i32:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2f32] }:$Vn, GPR64:{ *:[i32] }))
     /* 107506 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 107509 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107513 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107518 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /* 107522 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107527 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 107530 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 107532 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107535 */   GIR_RootConstrainSelectedInstOperands,
     /* 107536 */   // GIR_Coverage, 6733,
     /* 107536 */   GIR_EraseRootFromParent_Done,
     /* 107537 */ // Label 1657: @107537
     /* 107537 */ GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(107564), // Rule ID 6734 //
     /* 107542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107549 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107553 */   // (bitconvert:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 107553 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107558 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107563 */   // GIR_Coverage, 6734,
     /* 107563 */   GIR_Done,
     /* 107564 */ // Label 1658: @107564
     /* 107564 */ GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(107591), // Rule ID 6735 //
     /* 107569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107580 */   // (bitconvert:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 107580 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107585 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107590 */   // GIR_Coverage, 6735,
     /* 107590 */   GIR_Done,
     /* 107591 */ // Label 1659: @107591
     /* 107591 */ GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(107618), // Rule ID 6736 //
     /* 107596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107603 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107607 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1i64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1i64] }:$Vn, GPR64:{ *:[i32] })
     /* 107607 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107612 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107617 */   // GIR_Coverage, 6736,
     /* 107617 */   GIR_Done,
     /* 107618 */ // Label 1660: @107618
     /* 107618 */ GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(107645), // Rule ID 6745 //
     /* 107623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107630 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107634 */   // (bitconvert:{ *:[f64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 107634 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107639 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107644 */   // GIR_Coverage, 6745,
     /* 107644 */   GIR_Done,
     /* 107645 */ // Label 1661: @107645
     /* 107645 */ GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(107672), // Rule ID 6746 //
     /* 107650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107657 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107661 */   // (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } FPR64:{ *:[f64] }:$Xn, GPR64:{ *:[i32] })
     /* 107661 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107666 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107671 */   // GIR_Coverage, 6746,
     /* 107671 */   GIR_Done,
     /* 107672 */ // Label 1662: @107672
     /* 107672 */ GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(107699), // Rule ID 6747 //
     /* 107677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107684 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107688 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1f64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1f64] }:$Vn, GPR64:{ *:[i32] })
     /* 107688 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107693 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107698 */   // GIR_Coverage, 6747,
     /* 107698 */   GIR_Done,
     /* 107699 */ // Label 1663: @107699
     /* 107699 */ GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(107731), // Rule ID 6748 //
     /* 107704 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 107710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107714 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107718 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 107718 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107721 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107723 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107725 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107730 */   // GIR_Coverage, 6748,
     /* 107730 */   GIR_EraseRootFromParent_Done,
     /* 107731 */ // Label 1664: @107731
     /* 107731 */ GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(107763), // Rule ID 6749 //
     /* 107736 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107746 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107750 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 107750 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107753 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107755 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107757 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107762 */   // GIR_Coverage, 6749,
     /* 107762 */   GIR_EraseRootFromParent_Done,
     /* 107763 */ // Label 1665: @107763
     /* 107763 */ GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(107795), // Rule ID 6750 //
     /* 107768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 107774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107778 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107782 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 107782 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107785 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107787 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107789 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107794 */   // GIR_Coverage, 6750,
     /* 107794 */   GIR_EraseRootFromParent_Done,
     /* 107795 */ // Label 1666: @107795
     /* 107795 */ GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(107827), // Rule ID 6751 //
     /* 107800 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107810 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107814 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 107814 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107817 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107819 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107821 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107826 */   // GIR_Coverage, 6751,
     /* 107826 */   GIR_EraseRootFromParent_Done,
     /* 107827 */ // Label 1667: @107827
     /* 107827 */ GIM_Try, /*On fail goto*//*Label 1668*/ GIMT_Encode4(107859), // Rule ID 6752 //
     /* 107832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 107838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107842 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107846 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 107846 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107849 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107851 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107853 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107858 */   // GIR_Coverage, 6752,
     /* 107858 */   GIR_EraseRootFromParent_Done,
     /* 107859 */ // Label 1668: @107859
     /* 107859 */ GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(107885), // Rule ID 6753 //
     /* 107864 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 107870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107874 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107878 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)
     /* 107878 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 107883 */   GIR_RootConstrainSelectedInstOperands,
     /* 107884 */   // GIR_Coverage, 6753,
     /* 107884 */   GIR_Done,
     /* 107885 */ // Label 1669: @107885
     /* 107885 */ GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(107911), // Rule ID 6754 //
     /* 107890 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107900 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107904 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)
     /* 107904 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 107909 */   GIR_RootConstrainSelectedInstOperands,
     /* 107910 */   // GIR_Coverage, 6754,
     /* 107910 */   GIR_Done,
     /* 107911 */ // Label 1670: @107911
     /* 107911 */ GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(107937), // Rule ID 6755 //
     /* 107916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 107922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107926 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107930 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)
     /* 107930 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 107935 */   GIR_RootConstrainSelectedInstOperands,
     /* 107936 */   // GIR_Coverage, 6755,
     /* 107936 */   GIR_Done,
     /* 107937 */ // Label 1671: @107937
     /* 107937 */ GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(107963), // Rule ID 6756 //
     /* 107942 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107956 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)
     /* 107956 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 107961 */   GIR_RootConstrainSelectedInstOperands,
     /* 107962 */   // GIR_Coverage, 6756,
     /* 107962 */   GIR_Done,
     /* 107963 */ // Label 1672: @107963
     /* 107963 */ GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(107989), // Rule ID 6757 //
     /* 107968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 107974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107982 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)
     /* 107982 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 107987 */   GIR_RootConstrainSelectedInstOperands,
     /* 107988 */   // GIR_Coverage, 6757,
     /* 107988 */   GIR_Done,
     /* 107989 */ // Label 1673: @107989
     /* 107989 */ GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(108018), // Rule ID 6758 //
     /* 107994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108001 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108005 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 108005 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108008 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108010 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108012 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108017 */   // GIR_Coverage, 6758,
     /* 108017 */   GIR_EraseRootFromParent_Done,
     /* 108018 */ // Label 1674: @108018
     /* 108018 */ GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(108047), // Rule ID 6759 //
     /* 108023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108030 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108034 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 108034 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108037 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108039 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108041 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108046 */   // GIR_Coverage, 6759,
     /* 108046 */   GIR_EraseRootFromParent_Done,
     /* 108047 */ // Label 1675: @108047
     /* 108047 */ GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(108079), // Rule ID 6813 //
     /* 108052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 108058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108062 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108066 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 108066 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108069 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108071 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108073 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108078 */   // GIR_Coverage, 6813,
     /* 108078 */   GIR_EraseRootFromParent_Done,
     /* 108079 */ // Label 1676: @108079
     /* 108079 */ GIM_Try, /*On fail goto*//*Label 1677*/ GIMT_Encode4(108111), // Rule ID 6814 //
     /* 108084 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108098 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 108098 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108101 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108103 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108105 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108110 */   // GIR_Coverage, 6814,
     /* 108110 */   GIR_EraseRootFromParent_Done,
     /* 108111 */ // Label 1677: @108111
     /* 108111 */ GIM_Try, /*On fail goto*//*Label 1678*/ GIMT_Encode4(108143), // Rule ID 6815 //
     /* 108116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 108122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108130 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 108130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108133 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108135 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108137 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108142 */   // GIR_Coverage, 6815,
     /* 108142 */   GIR_EraseRootFromParent_Done,
     /* 108143 */ // Label 1678: @108143
     /* 108143 */ GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(108175), // Rule ID 6816 //
     /* 108148 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 108154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108158 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108162 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 108162 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108165 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108167 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108169 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108174 */   // GIR_Coverage, 6816,
     /* 108174 */   GIR_EraseRootFromParent_Done,
     /* 108175 */ // Label 1679: @108175
     /* 108175 */ GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(108207), // Rule ID 6817 //
     /* 108180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108190 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108194 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 108194 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108197 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108199 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108201 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108206 */   // GIR_Coverage, 6817,
     /* 108206 */   GIR_EraseRootFromParent_Done,
     /* 108207 */ // Label 1680: @108207
     /* 108207 */ GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(108233), // Rule ID 6818 //
     /* 108212 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 108218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108222 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108226 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)
     /* 108226 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 108231 */   GIR_RootConstrainSelectedInstOperands,
     /* 108232 */   // GIR_Coverage, 6818,
     /* 108232 */   GIR_Done,
     /* 108233 */ // Label 1681: @108233
     /* 108233 */ GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(108259), // Rule ID 6819 //
     /* 108238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108248 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108252 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)
     /* 108252 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 108257 */   GIR_RootConstrainSelectedInstOperands,
     /* 108258 */   // GIR_Coverage, 6819,
     /* 108258 */   GIR_Done,
     /* 108259 */ // Label 1682: @108259
     /* 108259 */ GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(108285), // Rule ID 6820 //
     /* 108264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 108270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108274 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108278 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)
     /* 108278 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 108283 */   GIR_RootConstrainSelectedInstOperands,
     /* 108284 */   // GIR_Coverage, 6820,
     /* 108284 */   GIR_Done,
     /* 108285 */ // Label 1683: @108285
     /* 108285 */ GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(108311), // Rule ID 6821 //
     /* 108290 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 108296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108300 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108304 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)
     /* 108304 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 108309 */   GIR_RootConstrainSelectedInstOperands,
     /* 108310 */   // GIR_Coverage, 6821,
     /* 108310 */   GIR_Done,
     /* 108311 */ // Label 1684: @108311
     /* 108311 */ GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(108337), // Rule ID 6822 //
     /* 108316 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108319 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108326 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108330 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)
     /* 108330 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 108335 */   GIR_RootConstrainSelectedInstOperands,
     /* 108336 */   // GIR_Coverage, 6822,
     /* 108336 */   GIR_Done,
     /* 108337 */ // Label 1685: @108337
     /* 108337 */ GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(108366), // Rule ID 6823 //
     /* 108342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108349 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108353 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 108353 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108356 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108358 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108360 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108365 */   // GIR_Coverage, 6823,
     /* 108365 */   GIR_EraseRootFromParent_Done,
     /* 108366 */ // Label 1686: @108366
     /* 108366 */ GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(108395), // Rule ID 6824 //
     /* 108371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108382 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 108382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108385 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108387 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108389 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108394 */   // GIR_Coverage, 6824,
     /* 108394 */   GIR_EraseRootFromParent_Done,
     /* 108395 */ // Label 1687: @108395
     /* 108395 */ GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(108427), // Rule ID 6825 //
     /* 108400 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 108406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108410 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108414 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 108414 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108417 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108419 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108421 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108426 */   // GIR_Coverage, 6825,
     /* 108426 */   GIR_EraseRootFromParent_Done,
     /* 108427 */ // Label 1688: @108427
     /* 108427 */ GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(108459), // Rule ID 6826 //
     /* 108432 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108442 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108446 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 108446 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108449 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108451 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108453 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108458 */   // GIR_Coverage, 6826,
     /* 108458 */   GIR_EraseRootFromParent_Done,
     /* 108459 */ // Label 1689: @108459
     /* 108459 */ GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(108491), // Rule ID 6827 //
     /* 108464 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108467 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 108470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108474 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108478 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 108478 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108481 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108483 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108485 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108490 */   // GIR_Coverage, 6827,
     /* 108490 */   GIR_EraseRootFromParent_Done,
     /* 108491 */ // Label 1690: @108491
     /* 108491 */ GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(108523), // Rule ID 6828 //
     /* 108496 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 108502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108506 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108510 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 108510 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108513 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108515 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108517 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108522 */   // GIR_Coverage, 6828,
     /* 108522 */   GIR_EraseRootFromParent_Done,
     /* 108523 */ // Label 1691: @108523
     /* 108523 */ GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(108555), // Rule ID 6829 //
     /* 108528 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108538 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108542 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 108542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108545 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108547 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108549 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108554 */   // GIR_Coverage, 6829,
     /* 108554 */   GIR_EraseRootFromParent_Done,
     /* 108555 */ // Label 1692: @108555
     /* 108555 */ GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(108581), // Rule ID 6830 //
     /* 108560 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 108566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108574 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)
     /* 108574 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 108579 */   GIR_RootConstrainSelectedInstOperands,
     /* 108580 */   // GIR_Coverage, 6830,
     /* 108580 */   GIR_Done,
     /* 108581 */ // Label 1693: @108581
     /* 108581 */ GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(108607), // Rule ID 6831 //
     /* 108586 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108596 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108600 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)
     /* 108600 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 108605 */   GIR_RootConstrainSelectedInstOperands,
     /* 108606 */   // GIR_Coverage, 6831,
     /* 108606 */   GIR_Done,
     /* 108607 */ // Label 1694: @108607
     /* 108607 */ GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(108633), // Rule ID 6832 //
     /* 108612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 108618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108622 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108626 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)
     /* 108626 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 108631 */   GIR_RootConstrainSelectedInstOperands,
     /* 108632 */   // GIR_Coverage, 6832,
     /* 108632 */   GIR_Done,
     /* 108633 */ // Label 1695: @108633
     /* 108633 */ GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(108659), // Rule ID 6833 //
     /* 108638 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 108644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108648 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108652 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)
     /* 108652 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 108657 */   GIR_RootConstrainSelectedInstOperands,
     /* 108658 */   // GIR_Coverage, 6833,
     /* 108658 */   GIR_Done,
     /* 108659 */ // Label 1696: @108659
     /* 108659 */ GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(108685), // Rule ID 6834 //
     /* 108664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108678 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)
     /* 108678 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 108683 */   GIR_RootConstrainSelectedInstOperands,
     /* 108684 */   // GIR_Coverage, 6834,
     /* 108684 */   GIR_Done,
     /* 108685 */ // Label 1697: @108685
     /* 108685 */ GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(108714), // Rule ID 6835 //
     /* 108690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108697 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108701 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 108701 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108704 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108706 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108708 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108713 */   // GIR_Coverage, 6835,
     /* 108713 */   GIR_EraseRootFromParent_Done,
     /* 108714 */ // Label 1698: @108714
     /* 108714 */ GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(108743), // Rule ID 6836 //
     /* 108719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108726 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108730 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 108730 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108733 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108735 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108737 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108742 */   // GIR_Coverage, 6836,
     /* 108742 */   GIR_EraseRootFromParent_Done,
     /* 108743 */ // Label 1699: @108743
     /* 108743 */ GIM_Reject,
     /* 108744 */ // Label 1619: @108744
     /* 108744 */ GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(108776), // Rule ID 6850 //
     /* 108749 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 108755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108759 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108763 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 108763 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108766 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108768 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108770 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108775 */   // GIR_Coverage, 6850,
     /* 108775 */   GIR_EraseRootFromParent_Done,
     /* 108776 */ // Label 1700: @108776
     /* 108776 */ GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(108808), // Rule ID 6851 //
     /* 108781 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 108787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108791 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108795 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 108795 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108798 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108800 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108802 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108807 */   // GIR_Coverage, 6851,
     /* 108807 */   GIR_EraseRootFromParent_Done,
     /* 108808 */ // Label 1701: @108808
     /* 108808 */ GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(108840), // Rule ID 6852 //
     /* 108813 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108823 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108827 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 108827 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108830 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108832 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108834 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108839 */   // GIR_Coverage, 6852,
     /* 108839 */   GIR_EraseRootFromParent_Done,
     /* 108840 */ // Label 1702: @108840
     /* 108840 */ GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(108872), // Rule ID 6853 //
     /* 108845 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 108851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108855 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108859 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 108859 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108862 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108864 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108866 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108871 */   // GIR_Coverage, 6853,
     /* 108871 */   GIR_EraseRootFromParent_Done,
     /* 108872 */ // Label 1703: @108872
     /* 108872 */ GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(108904), // Rule ID 6854 //
     /* 108877 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 108883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108887 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108891 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 108891 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108894 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108896 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108898 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108903 */   // GIR_Coverage, 6854,
     /* 108903 */   GIR_EraseRootFromParent_Done,
     /* 108904 */ // Label 1704: @108904
     /* 108904 */ GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(108936), // Rule ID 6855 //
     /* 108909 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108919 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108923 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 108923 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108926 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108928 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108930 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108935 */   // GIR_Coverage, 6855,
     /* 108935 */   GIR_EraseRootFromParent_Done,
     /* 108936 */ // Label 1705: @108936
     /* 108936 */ GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(108968), // Rule ID 6856 //
     /* 108941 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 108947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108951 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108955 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 108955 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108958 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108960 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108962 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108967 */   // GIR_Coverage, 6856,
     /* 108967 */   GIR_EraseRootFromParent_Done,
     /* 108968 */ // Label 1706: @108968
     /* 108968 */ GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(109001), // Rule ID 6857 //
     /* 108973 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108976 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 108979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108983 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108987 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2i64] }:$src)  =>  (EXTv16i8:{ *:[f128] } FPR128:{ *:[v2i64] }:$src, FPR128:{ *:[v2i64] }:$src, 8:{ *:[i32] })
     /* 108987 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 108990 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 108992 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108994 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108996 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 108999 */   GIR_RootConstrainSelectedInstOperands,
     /* 109000 */   // GIR_Coverage, 6857,
     /* 109000 */   GIR_EraseRootFromParent_Done,
     /* 109001 */ // Label 1707: @109001
     /* 109001 */ GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(109072), // Rule ID 6858 //
     /* 109006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109020 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4i32] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4i32] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4i32] }:$src), 8:{ *:[i32] })
     /* 109020 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 109023 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 109027 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109032 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109036 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109038 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 109041 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 109045 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109050 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109054 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 109059 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 109061 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109064 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 109067 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 109070 */   GIR_RootConstrainSelectedInstOperands,
     /* 109071 */   // GIR_Coverage, 6858,
     /* 109071 */   GIR_EraseRootFromParent_Done,
     /* 109072 */ // Label 1708: @109072
     /* 109072 */ GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(109143), // Rule ID 6859 //
     /* 109077 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109087 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109091 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8i16] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8i16] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8i16] }:$src), 8:{ *:[i32] })
     /* 109091 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 109094 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 109098 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109103 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109107 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109109 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 109112 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 109116 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109121 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109125 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 109130 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 109132 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109135 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 109138 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 109141 */   GIR_RootConstrainSelectedInstOperands,
     /* 109142 */   // GIR_Coverage, 6859,
     /* 109142 */   GIR_EraseRootFromParent_Done,
     /* 109143 */ // Label 1709: @109143
     /* 109143 */ GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(109214), // Rule ID 6860 //
     /* 109148 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109158 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109162 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8f16] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8f16] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8f16] }:$src), 8:{ *:[i32] })
     /* 109162 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 109165 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 109169 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109174 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109178 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109180 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 109183 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 109187 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109192 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109196 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109198 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 109201 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 109203 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109206 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 109209 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 109212 */   GIR_RootConstrainSelectedInstOperands,
     /* 109213 */   // GIR_Coverage, 6860,
     /* 109213 */   GIR_EraseRootFromParent_Done,
     /* 109214 */ // Label 1710: @109214
     /* 109214 */ GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(109247), // Rule ID 6861 //
     /* 109219 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 109225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109229 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109233 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2f64] }:$src)  =>  (EXTv16i8:{ *:[f128] } FPR128:{ *:[v2f64] }:$src, FPR128:{ *:[v2f64] }:$src, 8:{ *:[i32] })
     /* 109233 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 109236 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 109238 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109240 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109242 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 109245 */   GIR_RootConstrainSelectedInstOperands,
     /* 109246 */   // GIR_Coverage, 6861,
     /* 109246 */   GIR_EraseRootFromParent_Done,
     /* 109247 */ // Label 1711: @109247
     /* 109247 */ GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(109318), // Rule ID 6862 //
     /* 109252 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109262 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109266 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4f32] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4f32] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4f32] }:$src), 8:{ *:[i32] })
     /* 109266 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 109269 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 109273 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109278 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109282 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109284 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 109287 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 109291 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109296 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109300 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109302 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 109305 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 109307 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109310 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 109313 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 109316 */   GIR_RootConstrainSelectedInstOperands,
     /* 109317 */   // GIR_Coverage, 6862,
     /* 109317 */   GIR_EraseRootFromParent_Done,
     /* 109318 */ // Label 1712: @109318
     /* 109318 */ GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(109389), // Rule ID 6863 //
     /* 109323 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 109329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109333 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109337 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v16i8] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v16i8:{ *:[f128] } FPR128:{ *:[v16i8] }:$src), (REV64v16i8:{ *:[f128] } FPR128:{ *:[v16i8] }:$src), 8:{ *:[i32] })
     /* 109337 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 109340 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 109344 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109349 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109353 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109355 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 109358 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 109362 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109367 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109371 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109373 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 109376 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 109378 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109381 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 109384 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 109387 */   GIR_RootConstrainSelectedInstOperands,
     /* 109388 */   // GIR_Coverage, 6863,
     /* 109388 */   GIR_EraseRootFromParent_Done,
     /* 109389 */ // Label 1713: @109389
     /* 109389 */ GIM_Reject,
     /* 109390 */ // Label 1620: @109390
     /* 109390 */ GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(109420), // Rule ID 6715 //
     /* 109395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109405 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109409 */   // (bitconvert:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 109409 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109414 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109419 */   // GIR_Coverage, 6715,
     /* 109419 */   GIR_Done,
     /* 109420 */ // Label 1714: @109420
     /* 109420 */ GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(109450), // Rule ID 6717 //
     /* 109425 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109435 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109439 */   // (bitconvert:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 109439 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109444 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109449 */   // GIR_Coverage, 6717,
     /* 109449 */   GIR_Done,
     /* 109450 */ // Label 1715: @109450
     /* 109450 */ GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(109500), // Rule ID 6726 //
     /* 109455 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109465 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109469 */   // (bitconvert:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v2i32:{ *:[v2i32] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /* 109469 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 109472 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109476 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109481 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /* 109485 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109490 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 109493 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 109495 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109498 */   GIR_RootConstrainSelectedInstOperands,
     /* 109499 */   // GIR_Coverage, 6726,
     /* 109499 */   GIR_EraseRootFromParent_Done,
     /* 109500 */ // Label 1716: @109500
     /* 109500 */ GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(109550), // Rule ID 6728 //
     /* 109505 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109515 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109519 */   // (bitconvert:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v2i32:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /* 109519 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 109522 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109526 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109531 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /* 109535 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109540 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 109543 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 109545 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109548 */   GIR_RootConstrainSelectedInstOperands,
     /* 109549 */   // GIR_Coverage, 6728,
     /* 109549 */   GIR_EraseRootFromParent_Done,
     /* 109550 */ // Label 1717: @109550
     /* 109550 */ GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(109582), // Rule ID 6760 //
     /* 109555 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109565 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109569 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 109569 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109572 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109574 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109576 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109581 */   // GIR_Coverage, 6760,
     /* 109581 */   GIR_EraseRootFromParent_Done,
     /* 109582 */ // Label 1718: @109582
     /* 109582 */ GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(109614), // Rule ID 6761 //
     /* 109587 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109597 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109601 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 109601 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109604 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109606 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109608 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109613 */   // GIR_Coverage, 6761,
     /* 109613 */   GIR_EraseRootFromParent_Done,
     /* 109614 */ // Label 1719: @109614
     /* 109614 */ GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(109646), // Rule ID 6762 //
     /* 109619 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 109625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109629 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109633 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 109633 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109636 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109638 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109640 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109645 */   // GIR_Coverage, 6762,
     /* 109645 */   GIR_EraseRootFromParent_Done,
     /* 109646 */ // Label 1720: @109646
     /* 109646 */ GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(109678), // Rule ID 6763 //
     /* 109651 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109661 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109665 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 109665 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109668 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109670 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109672 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109677 */   // GIR_Coverage, 6763,
     /* 109677 */   GIR_EraseRootFromParent_Done,
     /* 109678 */ // Label 1721: @109678
     /* 109678 */ GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(109710), // Rule ID 6764 //
     /* 109683 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109693 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109697 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 109697 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109700 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109702 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109704 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109709 */   // GIR_Coverage, 6764,
     /* 109709 */   GIR_EraseRootFromParent_Done,
     /* 109710 */ // Label 1722: @109710
     /* 109710 */ GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(109742), // Rule ID 6765 //
     /* 109715 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109725 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109729 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 109729 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109732 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109734 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109736 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109741 */   // GIR_Coverage, 6765,
     /* 109741 */   GIR_EraseRootFromParent_Done,
     /* 109742 */ // Label 1723: @109742
     /* 109742 */ GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(109768), // Rule ID 6766 //
     /* 109747 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109757 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109761 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)
     /* 109761 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 109766 */   GIR_RootConstrainSelectedInstOperands,
     /* 109767 */   // GIR_Coverage, 6766,
     /* 109767 */   GIR_Done,
     /* 109768 */ // Label 1724: @109768
     /* 109768 */ GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(109794), // Rule ID 6767 //
     /* 109773 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109783 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109787 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)  =>  (REV32v4i16:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)
     /* 109787 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 109792 */   GIR_RootConstrainSelectedInstOperands,
     /* 109793 */   // GIR_Coverage, 6767,
     /* 109793 */   GIR_Done,
     /* 109794 */ // Label 1725: @109794
     /* 109794 */ GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(109820), // Rule ID 6768 //
     /* 109799 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 109805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109809 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109813 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)  =>  (REV32v8i8:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)
     /* 109813 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 109818 */   GIR_RootConstrainSelectedInstOperands,
     /* 109819 */   // GIR_Coverage, 6768,
     /* 109819 */   GIR_Done,
     /* 109820 */ // Label 1726: @109820
     /* 109820 */ GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(109846), // Rule ID 6769 //
     /* 109825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109835 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109839 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)
     /* 109839 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 109844 */   GIR_RootConstrainSelectedInstOperands,
     /* 109845 */   // GIR_Coverage, 6769,
     /* 109845 */   GIR_Done,
     /* 109846 */ // Label 1727: @109846
     /* 109846 */ GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(109872), // Rule ID 6770 //
     /* 109851 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109865 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)
     /* 109865 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 109870 */   GIR_RootConstrainSelectedInstOperands,
     /* 109871 */   // GIR_Coverage, 6770,
     /* 109871 */   GIR_Done,
     /* 109872 */ // Label 1728: @109872
     /* 109872 */ GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(109898), // Rule ID 6771 //
     /* 109877 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109887 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109891 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)  =>  (REV32v4i16:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)
     /* 109891 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 109896 */   GIR_RootConstrainSelectedInstOperands,
     /* 109897 */   // GIR_Coverage, 6771,
     /* 109897 */   GIR_Done,
     /* 109898 */ // Label 1729: @109898
     /* 109898 */ GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(109927), // Rule ID 6772 //
     /* 109903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 109906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109910 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109914 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 109914 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109917 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109919 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109921 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109926 */   // GIR_Coverage, 6772,
     /* 109926 */   GIR_EraseRootFromParent_Done,
     /* 109927 */ // Label 1730: @109927
     /* 109927 */ GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(109959), // Rule ID 6837 //
     /* 109932 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109942 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109946 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 109946 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109949 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109951 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109953 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109958 */   // GIR_Coverage, 6837,
     /* 109958 */   GIR_EraseRootFromParent_Done,
     /* 109959 */ // Label 1731: @109959
     /* 109959 */ GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(109991), // Rule ID 6838 //
     /* 109964 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109974 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109978 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 109978 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109981 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109983 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109985 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109990 */   // GIR_Coverage, 6838,
     /* 109990 */   GIR_EraseRootFromParent_Done,
     /* 109991 */ // Label 1732: @109991
     /* 109991 */ GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(110023), // Rule ID 6839 //
     /* 109996 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 110002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110006 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110010 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 110010 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110013 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110015 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110017 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110022 */   // GIR_Coverage, 6839,
     /* 110022 */   GIR_EraseRootFromParent_Done,
     /* 110023 */ // Label 1733: @110023
     /* 110023 */ GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(110055), // Rule ID 6840 //
     /* 110028 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110038 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110042 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 110042 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110045 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110047 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110049 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110054 */   // GIR_Coverage, 6840,
     /* 110054 */   GIR_EraseRootFromParent_Done,
     /* 110055 */ // Label 1734: @110055
     /* 110055 */ GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(110087), // Rule ID 6841 //
     /* 110060 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110070 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110074 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 110074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110077 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110079 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110081 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110086 */   // GIR_Coverage, 6841,
     /* 110086 */   GIR_EraseRootFromParent_Done,
     /* 110087 */ // Label 1735: @110087
     /* 110087 */ GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(110119), // Rule ID 6842 //
     /* 110092 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 110098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110102 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110106 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 110106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110109 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110111 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110113 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110118 */   // GIR_Coverage, 6842,
     /* 110118 */   GIR_EraseRootFromParent_Done,
     /* 110119 */ // Label 1736: @110119
     /* 110119 */ GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(110145), // Rule ID 6843 //
     /* 110124 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110134 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110138 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)
     /* 110138 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 110143 */   GIR_RootConstrainSelectedInstOperands,
     /* 110144 */   // GIR_Coverage, 6843,
     /* 110144 */   GIR_Done,
     /* 110145 */ // Label 1737: @110145
     /* 110145 */ GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(110171), // Rule ID 6844 //
     /* 110150 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110153 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 110156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110160 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110164 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)  =>  (REV32v4i16:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)
     /* 110164 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 110169 */   GIR_RootConstrainSelectedInstOperands,
     /* 110170 */   // GIR_Coverage, 6844,
     /* 110170 */   GIR_Done,
     /* 110171 */ // Label 1738: @110171
     /* 110171 */ GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(110197), // Rule ID 6845 //
     /* 110176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 110182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110186 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110190 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)  =>  (REV32v8i8:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)
     /* 110190 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 110195 */   GIR_RootConstrainSelectedInstOperands,
     /* 110196 */   // GIR_Coverage, 6845,
     /* 110196 */   GIR_Done,
     /* 110197 */ // Label 1739: @110197
     /* 110197 */ GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(110223), // Rule ID 6846 //
     /* 110202 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110212 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110216 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)
     /* 110216 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 110221 */   GIR_RootConstrainSelectedInstOperands,
     /* 110222 */   // GIR_Coverage, 6846,
     /* 110222 */   GIR_Done,
     /* 110223 */ // Label 1740: @110223
     /* 110223 */ GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(110249), // Rule ID 6847 //
     /* 110228 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110238 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110242 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)
     /* 110242 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 110247 */   GIR_RootConstrainSelectedInstOperands,
     /* 110248 */   // GIR_Coverage, 6847,
     /* 110248 */   GIR_Done,
     /* 110249 */ // Label 1741: @110249
     /* 110249 */ GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(110275), // Rule ID 6848 //
     /* 110254 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 110260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110264 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110268 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)  =>  (REV32v4i16:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)
     /* 110268 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 110273 */   GIR_RootConstrainSelectedInstOperands,
     /* 110274 */   // GIR_Coverage, 6848,
     /* 110274 */   GIR_Done,
     /* 110275 */ // Label 1742: @110275
     /* 110275 */ GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(110304), // Rule ID 6849 //
     /* 110280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 110283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110291 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 110291 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110294 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110296 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110298 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110303 */   // GIR_Coverage, 6849,
     /* 110303 */   GIR_EraseRootFromParent_Done,
     /* 110304 */ // Label 1743: @110304
     /* 110304 */ GIM_Reject,
     /* 110305 */ // Label 1621: @110305
     /* 110305 */ GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(110337), // Rule ID 6864 //
     /* 110310 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 110316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110320 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110324 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 110324 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110327 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110329 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110331 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110336 */   // GIR_Coverage, 6864,
     /* 110336 */   GIR_EraseRootFromParent_Done,
     /* 110337 */ // Label 1744: @110337
     /* 110337 */ GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(110369), // Rule ID 6865 //
     /* 110342 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110352 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110356 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 110356 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110359 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110361 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110363 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110368 */   // GIR_Coverage, 6865,
     /* 110368 */   GIR_EraseRootFromParent_Done,
     /* 110369 */ // Label 1745: @110369
     /* 110369 */ GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(110401), // Rule ID 6866 //
     /* 110374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110388 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 110388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110391 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110393 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110395 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110400 */   // GIR_Coverage, 6866,
     /* 110400 */   GIR_EraseRootFromParent_Done,
     /* 110401 */ // Label 1746: @110401
     /* 110401 */ GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(110433), // Rule ID 6867 //
     /* 110406 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110416 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110420 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 110420 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110423 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110425 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110427 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110432 */   // GIR_Coverage, 6867,
     /* 110432 */   GIR_EraseRootFromParent_Done,
     /* 110433 */ // Label 1747: @110433
     /* 110433 */ GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(110465), // Rule ID 6868 //
     /* 110438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 110444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110448 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110452 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 110452 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110455 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110457 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110459 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110464 */   // GIR_Coverage, 6868,
     /* 110464 */   GIR_EraseRootFromParent_Done,
     /* 110465 */ // Label 1748: @110465
     /* 110465 */ GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(110497), // Rule ID 6869 //
     /* 110470 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110480 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110484 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 110484 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110487 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110489 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110491 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110496 */   // GIR_Coverage, 6869,
     /* 110496 */   GIR_EraseRootFromParent_Done,
     /* 110497 */ // Label 1749: @110497
     /* 110497 */ GIM_Try, /*On fail goto*//*Label 1750*/ GIMT_Encode4(110530), // Rule ID 6870 //
     /* 110502 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110505 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 110508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110512 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110516 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v2f64] } FPR128:{ *:[f128] }:$src, FPR128:{ *:[f128] }:$src, 8:{ *:[i32] })
     /* 110516 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 110519 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 110521 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110523 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110525 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 110528 */   GIR_RootConstrainSelectedInstOperands,
     /* 110529 */   // GIR_Coverage, 6870,
     /* 110529 */   GIR_EraseRootFromParent_Done,
     /* 110530 */ // Label 1750: @110530
     /* 110530 */ GIM_Try, /*On fail goto*//*Label 1751*/ GIMT_Encode4(110556), // Rule ID 6871 //
     /* 110535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110545 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110549 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)  =>  (REV64v4i32:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)
     /* 110549 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 110554 */   GIR_RootConstrainSelectedInstOperands,
     /* 110555 */   // GIR_Coverage, 6871,
     /* 110555 */   GIR_Done,
     /* 110556 */ // Label 1751: @110556
     /* 110556 */ GIM_Try, /*On fail goto*//*Label 1752*/ GIMT_Encode4(110582), // Rule ID 6872 //
     /* 110561 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110571 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110575 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)  =>  (REV64v8i16:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)
     /* 110575 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 110580 */   GIR_RootConstrainSelectedInstOperands,
     /* 110581 */   // GIR_Coverage, 6872,
     /* 110581 */   GIR_Done,
     /* 110582 */ // Label 1752: @110582
     /* 110582 */ GIM_Try, /*On fail goto*//*Label 1753*/ GIMT_Encode4(110608), // Rule ID 6873 //
     /* 110587 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110597 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110601 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)  =>  (REV64v8i16:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)
     /* 110601 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 110606 */   GIR_RootConstrainSelectedInstOperands,
     /* 110607 */   // GIR_Coverage, 6873,
     /* 110607 */   GIR_Done,
     /* 110608 */ // Label 1753: @110608
     /* 110608 */ GIM_Try, /*On fail goto*//*Label 1754*/ GIMT_Encode4(110634), // Rule ID 6874 //
     /* 110613 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 110619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110623 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110627 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)  =>  (REV64v16i8:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)
     /* 110627 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 110632 */   GIR_RootConstrainSelectedInstOperands,
     /* 110633 */   // GIR_Coverage, 6874,
     /* 110633 */   GIR_Done,
     /* 110634 */ // Label 1754: @110634
     /* 110634 */ GIM_Try, /*On fail goto*//*Label 1755*/ GIMT_Encode4(110660), // Rule ID 6875 //
     /* 110639 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110649 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110653 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)  =>  (REV64v4i32:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)
     /* 110653 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 110658 */   GIR_RootConstrainSelectedInstOperands,
     /* 110659 */   // GIR_Coverage, 6875,
     /* 110659 */   GIR_Done,
     /* 110660 */ // Label 1755: @110660
     /* 110660 */ GIM_Try, /*On fail goto*//*Label 1756*/ GIMT_Encode4(110689), // Rule ID 6876 //
     /* 110665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 110668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110672 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110676 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 110676 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110679 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110681 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110683 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110688 */   // GIR_Coverage, 6876,
     /* 110688 */   GIR_EraseRootFromParent_Done,
     /* 110689 */ // Label 1756: @110689
     /* 110689 */ GIM_Try, /*On fail goto*//*Label 1757*/ GIMT_Encode4(110721), // Rule ID 6890 //
     /* 110694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 110700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110708 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 110708 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110711 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110713 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110715 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110720 */   // GIR_Coverage, 6890,
     /* 110720 */   GIR_EraseRootFromParent_Done,
     /* 110721 */ // Label 1757: @110721
     /* 110721 */ GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(110753), // Rule ID 6891 //
     /* 110726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110736 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110740 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 110740 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110743 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110745 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110747 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110752 */   // GIR_Coverage, 6891,
     /* 110752 */   GIR_EraseRootFromParent_Done,
     /* 110753 */ // Label 1758: @110753
     /* 110753 */ GIM_Try, /*On fail goto*//*Label 1759*/ GIMT_Encode4(110785), // Rule ID 6892 //
     /* 110758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110768 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110772 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 110772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110775 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110777 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110779 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110784 */   // GIR_Coverage, 6892,
     /* 110784 */   GIR_EraseRootFromParent_Done,
     /* 110785 */ // Label 1759: @110785
     /* 110785 */ GIM_Try, /*On fail goto*//*Label 1760*/ GIMT_Encode4(110817), // Rule ID 6893 //
     /* 110790 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 110796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110800 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110804 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 110804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110807 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110809 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110811 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110816 */   // GIR_Coverage, 6893,
     /* 110816 */   GIR_EraseRootFromParent_Done,
     /* 110817 */ // Label 1760: @110817
     /* 110817 */ GIM_Try, /*On fail goto*//*Label 1761*/ GIMT_Encode4(110849), // Rule ID 6894 //
     /* 110822 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110832 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110836 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 110836 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110839 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110841 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110843 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110848 */   // GIR_Coverage, 6894,
     /* 110848 */   GIR_EraseRootFromParent_Done,
     /* 110849 */ // Label 1761: @110849
     /* 110849 */ GIM_Try, /*On fail goto*//*Label 1762*/ GIMT_Encode4(110881), // Rule ID 6895 //
     /* 110854 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110864 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110868 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 110868 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110871 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110873 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110875 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110880 */   // GIR_Coverage, 6895,
     /* 110880 */   GIR_EraseRootFromParent_Done,
     /* 110881 */ // Label 1762: @110881
     /* 110881 */ GIM_Try, /*On fail goto*//*Label 1763*/ GIMT_Encode4(110914), // Rule ID 6896 //
     /* 110886 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 110892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110900 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v2i64] } FPR128:{ *:[f128] }:$src, FPR128:{ *:[f128] }:$src, 8:{ *:[i32] })
     /* 110900 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 110903 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 110905 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110907 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110909 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 110912 */   GIR_RootConstrainSelectedInstOperands,
     /* 110913 */   // GIR_Coverage, 6896,
     /* 110913 */   GIR_EraseRootFromParent_Done,
     /* 110914 */ // Label 1763: @110914
     /* 110914 */ GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(110940), // Rule ID 6897 //
     /* 110919 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110933 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)  =>  (REV64v4i32:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)
     /* 110933 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 110938 */   GIR_RootConstrainSelectedInstOperands,
     /* 110939 */   // GIR_Coverage, 6897,
     /* 110939 */   GIR_Done,
     /* 110940 */ // Label 1764: @110940
     /* 110940 */ GIM_Try, /*On fail goto*//*Label 1765*/ GIMT_Encode4(110966), // Rule ID 6898 //
     /* 110945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110955 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110959 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)  =>  (REV64v8i16:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)
     /* 110959 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 110964 */   GIR_RootConstrainSelectedInstOperands,
     /* 110965 */   // GIR_Coverage, 6898,
     /* 110965 */   GIR_Done,
     /* 110966 */ // Label 1765: @110966
     /* 110966 */ GIM_Try, /*On fail goto*//*Label 1766*/ GIMT_Encode4(110992), // Rule ID 6899 //
     /* 110971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 110977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110981 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110985 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)  =>  (REV64v16i8:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)
     /* 110985 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 110990 */   GIR_RootConstrainSelectedInstOperands,
     /* 110991 */   // GIR_Coverage, 6899,
     /* 110991 */   GIR_Done,
     /* 110992 */ // Label 1766: @110992
     /* 110992 */ GIM_Try, /*On fail goto*//*Label 1767*/ GIMT_Encode4(111018), // Rule ID 6900 //
     /* 110997 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 111003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111007 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111011 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)  =>  (REV64v4i32:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)
     /* 111011 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 111016 */   GIR_RootConstrainSelectedInstOperands,
     /* 111017 */   // GIR_Coverage, 6900,
     /* 111017 */   GIR_Done,
     /* 111018 */ // Label 1767: @111018
     /* 111018 */ GIM_Try, /*On fail goto*//*Label 1768*/ GIMT_Encode4(111044), // Rule ID 6901 //
     /* 111023 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 111029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111033 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111037 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)  =>  (REV64v8i16:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)
     /* 111037 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 111042 */   GIR_RootConstrainSelectedInstOperands,
     /* 111043 */   // GIR_Coverage, 6901,
     /* 111043 */   GIR_Done,
     /* 111044 */ // Label 1768: @111044
     /* 111044 */ GIM_Try, /*On fail goto*//*Label 1769*/ GIMT_Encode4(111073), // Rule ID 6902 //
     /* 111049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 111052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111056 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111060 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 111060 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111063 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111065 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111067 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111072 */   // GIR_Coverage, 6902,
     /* 111072 */   GIR_EraseRootFromParent_Done,
     /* 111073 */ // Label 1769: @111073
     /* 111073 */ GIM_Reject,
     /* 111074 */ // Label 1622: @111074
     /* 111074 */ GIM_Try, /*On fail goto*//*Label 1770*/ GIMT_Encode4(111104), // Rule ID 6714 //
     /* 111079 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111089 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 111093 */   // (bitconvert:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 111093 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111098 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111103 */   // GIR_Coverage, 6714,
     /* 111103 */   GIR_Done,
     /* 111104 */ // Label 1770: @111104
     /* 111104 */ GIM_Try, /*On fail goto*//*Label 1771*/ GIMT_Encode4(111134), // Rule ID 6716 //
     /* 111109 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111112 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111119 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 111123 */   // (bitconvert:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 111123 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111128 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111133 */   // GIR_Coverage, 6716,
     /* 111133 */   GIR_Done,
     /* 111134 */ // Label 1771: @111134
     /* 111134 */ GIM_Try, /*On fail goto*//*Label 1772*/ GIMT_Encode4(111184), // Rule ID 6725 //
     /* 111139 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 111153 */   // (bitconvert:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v4i16:{ *:[v4i16] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /* 111153 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 111156 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111160 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111165 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /* 111169 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 111177 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 111179 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111182 */   GIR_RootConstrainSelectedInstOperands,
     /* 111183 */   // GIR_Coverage, 6725,
     /* 111183 */   GIR_EraseRootFromParent_Done,
     /* 111184 */ // Label 1772: @111184
     /* 111184 */ GIM_Try, /*On fail goto*//*Label 1773*/ GIMT_Encode4(111234), // Rule ID 6727 //
     /* 111189 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111199 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 111203 */   // (bitconvert:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v4i16:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /* 111203 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 111206 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111210 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111215 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /* 111219 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111224 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 111227 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 111229 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111232 */   GIR_RootConstrainSelectedInstOperands,
     /* 111233 */   // GIR_Coverage, 6727,
     /* 111233 */   GIR_EraseRootFromParent_Done,
     /* 111234 */ // Label 1773: @111234
     /* 111234 */ GIM_Try, /*On fail goto*//*Label 1774*/ GIMT_Encode4(111266), // Rule ID 6773 //
     /* 111239 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111249 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111253 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 111253 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111256 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111258 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111260 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111265 */   // GIR_Coverage, 6773,
     /* 111265 */   GIR_EraseRootFromParent_Done,
     /* 111266 */ // Label 1774: @111266
     /* 111266 */ GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(111298), // Rule ID 6774 //
     /* 111271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111285 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 111285 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111288 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111290 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111292 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111297 */   // GIR_Coverage, 6774,
     /* 111297 */   GIR_EraseRootFromParent_Done,
     /* 111298 */ // Label 1775: @111298
     /* 111298 */ GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(111330), // Rule ID 6775 //
     /* 111303 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 111309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111317 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 111317 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111320 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111322 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111324 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111329 */   // GIR_Coverage, 6775,
     /* 111329 */   GIR_EraseRootFromParent_Done,
     /* 111330 */ // Label 1776: @111330
     /* 111330 */ GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(111362), // Rule ID 6776 //
     /* 111335 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111345 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111349 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 111349 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111352 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111354 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111356 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111361 */   // GIR_Coverage, 6776,
     /* 111361 */   GIR_EraseRootFromParent_Done,
     /* 111362 */ // Label 1777: @111362
     /* 111362 */ GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(111394), // Rule ID 6777 //
     /* 111367 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111377 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111381 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 111381 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111384 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111386 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111388 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111393 */   // GIR_Coverage, 6777,
     /* 111393 */   GIR_EraseRootFromParent_Done,
     /* 111394 */ // Label 1778: @111394
     /* 111394 */ GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(111426), // Rule ID 6778 //
     /* 111399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111409 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111413 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 111413 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111416 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111418 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111420 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111425 */   // GIR_Coverage, 6778,
     /* 111425 */   GIR_EraseRootFromParent_Done,
     /* 111426 */ // Label 1779: @111426
     /* 111426 */ GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(111452), // Rule ID 6779 //
     /* 111431 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111441 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111445 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)
     /* 111445 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 111450 */   GIR_RootConstrainSelectedInstOperands,
     /* 111451 */   // GIR_Coverage, 6779,
     /* 111451 */   GIR_Done,
     /* 111452 */ // Label 1780: @111452
     /* 111452 */ GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(111478), // Rule ID 6780 //
     /* 111457 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111467 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111471 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v4i16:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)
     /* 111471 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 111476 */   GIR_RootConstrainSelectedInstOperands,
     /* 111477 */   // GIR_Coverage, 6780,
     /* 111477 */   GIR_Done,
     /* 111478 */ // Label 1781: @111478
     /* 111478 */ GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(111504), // Rule ID 6781 //
     /* 111483 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 111489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111493 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111497 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)  =>  (REV16v8i8:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)
     /* 111497 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 111502 */   GIR_RootConstrainSelectedInstOperands,
     /* 111503 */   // GIR_Coverage, 6781,
     /* 111503 */   GIR_Done,
     /* 111504 */ // Label 1782: @111504
     /* 111504 */ GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(111530), // Rule ID 6782 //
     /* 111509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111519 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111523 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)
     /* 111523 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 111528 */   GIR_RootConstrainSelectedInstOperands,
     /* 111529 */   // GIR_Coverage, 6782,
     /* 111529 */   GIR_Done,
     /* 111530 */ // Label 1783: @111530
     /* 111530 */ GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(111556), // Rule ID 6783 //
     /* 111535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111545 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111549 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v4i16:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)
     /* 111549 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 111554 */   GIR_RootConstrainSelectedInstOperands,
     /* 111555 */   // GIR_Coverage, 6783,
     /* 111555 */   GIR_Done,
     /* 111556 */ // Label 1784: @111556
     /* 111556 */ GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(111582), // Rule ID 6784 //
     /* 111561 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111571 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111575 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)
     /* 111575 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 111580 */   GIR_RootConstrainSelectedInstOperands,
     /* 111581 */   // GIR_Coverage, 6784,
     /* 111581 */   GIR_Done,
     /* 111582 */ // Label 1785: @111582
     /* 111582 */ GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(111611), // Rule ID 6785 //
     /* 111587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 111590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111594 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111598 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 111598 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111601 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111603 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111605 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111610 */   // GIR_Coverage, 6785,
     /* 111610 */   GIR_EraseRootFromParent_Done,
     /* 111611 */ // Label 1786: @111611
     /* 111611 */ GIM_Try, /*On fail goto*//*Label 1787*/ GIMT_Encode4(111643), // Rule ID 6786 //
     /* 111616 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111626 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111630 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 111630 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111633 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111635 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111637 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111642 */   // GIR_Coverage, 6786,
     /* 111642 */   GIR_EraseRootFromParent_Done,
     /* 111643 */ // Label 1787: @111643
     /* 111643 */ GIM_Try, /*On fail goto*//*Label 1788*/ GIMT_Encode4(111675), // Rule ID 6787 //
     /* 111648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111658 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111662 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 111662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111665 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111667 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111669 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111674 */   // GIR_Coverage, 6787,
     /* 111674 */   GIR_EraseRootFromParent_Done,
     /* 111675 */ // Label 1788: @111675
     /* 111675 */ GIM_Try, /*On fail goto*//*Label 1789*/ GIMT_Encode4(111707), // Rule ID 6788 //
     /* 111680 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 111686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111690 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111694 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 111694 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111697 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111699 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111701 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111706 */   // GIR_Coverage, 6788,
     /* 111706 */   GIR_EraseRootFromParent_Done,
     /* 111707 */ // Label 1789: @111707
     /* 111707 */ GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(111739), // Rule ID 6789 //
     /* 111712 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111722 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111726 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 111726 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111729 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111731 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111733 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111738 */   // GIR_Coverage, 6789,
     /* 111738 */   GIR_EraseRootFromParent_Done,
     /* 111739 */ // Label 1790: @111739
     /* 111739 */ GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(111771), // Rule ID 6790 //
     /* 111744 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111754 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111758 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 111758 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111761 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111763 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111765 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111770 */   // GIR_Coverage, 6790,
     /* 111770 */   GIR_EraseRootFromParent_Done,
     /* 111771 */ // Label 1791: @111771
     /* 111771 */ GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(111803), // Rule ID 6791 //
     /* 111776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111786 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111790 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 111790 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111793 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111795 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111797 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111802 */   // GIR_Coverage, 6791,
     /* 111802 */   GIR_EraseRootFromParent_Done,
     /* 111803 */ // Label 1792: @111803
     /* 111803 */ GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(111829), // Rule ID 6792 //
     /* 111808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111818 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111822 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)
     /* 111822 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 111827 */   GIR_RootConstrainSelectedInstOperands,
     /* 111828 */   // GIR_Coverage, 6792,
     /* 111828 */   GIR_Done,
     /* 111829 */ // Label 1793: @111829
     /* 111829 */ GIM_Try, /*On fail goto*//*Label 1794*/ GIMT_Encode4(111855), // Rule ID 6793 //
     /* 111834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111844 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111848 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v4i16:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)
     /* 111848 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 111853 */   GIR_RootConstrainSelectedInstOperands,
     /* 111854 */   // GIR_Coverage, 6793,
     /* 111854 */   GIR_Done,
     /* 111855 */ // Label 1794: @111855
     /* 111855 */ GIM_Try, /*On fail goto*//*Label 1795*/ GIMT_Encode4(111881), // Rule ID 6794 //
     /* 111860 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 111866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111870 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111874 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)  =>  (REV16v8i8:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)
     /* 111874 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 111879 */   GIR_RootConstrainSelectedInstOperands,
     /* 111880 */   // GIR_Coverage, 6794,
     /* 111880 */   GIR_Done,
     /* 111881 */ // Label 1795: @111881
     /* 111881 */ GIM_Try, /*On fail goto*//*Label 1796*/ GIMT_Encode4(111907), // Rule ID 6795 //
     /* 111886 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111900 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)
     /* 111900 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 111905 */   GIR_RootConstrainSelectedInstOperands,
     /* 111906 */   // GIR_Coverage, 6795,
     /* 111906 */   GIR_Done,
     /* 111907 */ // Label 1796: @111907
     /* 111907 */ GIM_Try, /*On fail goto*//*Label 1797*/ GIMT_Encode4(111933), // Rule ID 6796 //
     /* 111912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111922 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111926 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v4i16:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)
     /* 111926 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 111931 */   GIR_RootConstrainSelectedInstOperands,
     /* 111932 */   // GIR_Coverage, 6796,
     /* 111932 */   GIR_Done,
     /* 111933 */ // Label 1797: @111933
     /* 111933 */ GIM_Try, /*On fail goto*//*Label 1798*/ GIMT_Encode4(111959), // Rule ID 6797 //
     /* 111938 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111948 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111952 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)
     /* 111952 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 111957 */   GIR_RootConstrainSelectedInstOperands,
     /* 111958 */   // GIR_Coverage, 6797,
     /* 111958 */   GIR_Done,
     /* 111959 */ // Label 1798: @111959
     /* 111959 */ GIM_Try, /*On fail goto*//*Label 1799*/ GIMT_Encode4(111988), // Rule ID 6798 //
     /* 111964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 111967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111971 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111975 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 111975 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111978 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111980 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111982 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111987 */   // GIR_Coverage, 6798,
     /* 111987 */   GIR_EraseRootFromParent_Done,
     /* 111988 */ // Label 1799: @111988
     /* 111988 */ GIM_Reject,
     /* 111989 */ // Label 1623: @111989
     /* 111989 */ GIM_Try, /*On fail goto*//*Label 1800*/ GIMT_Encode4(112021), // Rule ID 6877 //
     /* 111994 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 112000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112004 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112008 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 112008 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112011 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112013 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112015 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112020 */   // GIR_Coverage, 6877,
     /* 112020 */   GIR_EraseRootFromParent_Done,
     /* 112021 */ // Label 1800: @112021
     /* 112021 */ GIM_Try, /*On fail goto*//*Label 1801*/ GIMT_Encode4(112053), // Rule ID 6878 //
     /* 112026 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112036 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112040 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 112040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112043 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112045 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112047 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112052 */   // GIR_Coverage, 6878,
     /* 112052 */   GIR_EraseRootFromParent_Done,
     /* 112053 */ // Label 1801: @112053
     /* 112053 */ GIM_Try, /*On fail goto*//*Label 1802*/ GIMT_Encode4(112085), // Rule ID 6879 //
     /* 112058 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112068 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112072 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 112072 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112075 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112077 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112079 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112084 */   // GIR_Coverage, 6879,
     /* 112084 */   GIR_EraseRootFromParent_Done,
     /* 112085 */ // Label 1802: @112085
     /* 112085 */ GIM_Try, /*On fail goto*//*Label 1803*/ GIMT_Encode4(112117), // Rule ID 6880 //
     /* 112090 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 112096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112100 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112104 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 112104 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112107 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112109 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112111 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112116 */   // GIR_Coverage, 6880,
     /* 112116 */   GIR_EraseRootFromParent_Done,
     /* 112117 */ // Label 1803: @112117
     /* 112117 */ GIM_Try, /*On fail goto*//*Label 1804*/ GIMT_Encode4(112149), // Rule ID 6881 //
     /* 112122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112132 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112136 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 112136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112139 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112141 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112143 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112148 */   // GIR_Coverage, 6881,
     /* 112148 */   GIR_EraseRootFromParent_Done,
     /* 112149 */ // Label 1804: @112149
     /* 112149 */ GIM_Try, /*On fail goto*//*Label 1805*/ GIMT_Encode4(112181), // Rule ID 6882 //
     /* 112154 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112164 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112168 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 112168 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112171 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112173 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112175 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112180 */   // GIR_Coverage, 6882,
     /* 112180 */   GIR_EraseRootFromParent_Done,
     /* 112181 */ // Label 1805: @112181
     /* 112181 */ GIM_Try, /*On fail goto*//*Label 1806*/ GIMT_Encode4(112252), // Rule ID 6883 //
     /* 112186 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 112192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112196 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112200 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v4f32] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /* 112200 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 112203 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 112207 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112212 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 112216 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112218 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 112221 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 112225 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112230 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 112234 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112236 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 112239 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 112241 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112244 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 112247 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 112250 */   GIR_RootConstrainSelectedInstOperands,
     /* 112251 */   // GIR_Coverage, 6883,
     /* 112251 */   GIR_EraseRootFromParent_Done,
     /* 112252 */ // Label 1806: @112252
     /* 112252 */ GIM_Try, /*On fail goto*//*Label 1807*/ GIMT_Encode4(112278), // Rule ID 6884 //
     /* 112257 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112267 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112271 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)  =>  (REV32v8i16:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)
     /* 112271 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 112276 */   GIR_RootConstrainSelectedInstOperands,
     /* 112277 */   // GIR_Coverage, 6884,
     /* 112277 */   GIR_Done,
     /* 112278 */ // Label 1807: @112278
     /* 112278 */ GIM_Try, /*On fail goto*//*Label 1808*/ GIMT_Encode4(112304), // Rule ID 6885 //
     /* 112283 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112293 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112297 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)  =>  (REV32v8i16:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)
     /* 112297 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 112302 */   GIR_RootConstrainSelectedInstOperands,
     /* 112303 */   // GIR_Coverage, 6885,
     /* 112303 */   GIR_Done,
     /* 112304 */ // Label 1808: @112304
     /* 112304 */ GIM_Try, /*On fail goto*//*Label 1809*/ GIMT_Encode4(112330), // Rule ID 6886 //
     /* 112309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 112315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112323 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)  =>  (REV32v16i8:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)
     /* 112323 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 112328 */   GIR_RootConstrainSelectedInstOperands,
     /* 112329 */   // GIR_Coverage, 6886,
     /* 112329 */   GIR_Done,
     /* 112330 */ // Label 1809: @112330
     /* 112330 */ GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(112356), // Rule ID 6887 //
     /* 112335 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112345 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112349 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v4i32:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)
     /* 112349 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 112354 */   GIR_RootConstrainSelectedInstOperands,
     /* 112355 */   // GIR_Coverage, 6887,
     /* 112355 */   GIR_Done,
     /* 112356 */ // Label 1810: @112356
     /* 112356 */ GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(112382), // Rule ID 6888 //
     /* 112361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112371 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112375 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v4i32:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)
     /* 112375 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 112380 */   GIR_RootConstrainSelectedInstOperands,
     /* 112381 */   // GIR_Coverage, 6888,
     /* 112381 */   GIR_Done,
     /* 112382 */ // Label 1811: @112382
     /* 112382 */ GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(112411), // Rule ID 6889 //
     /* 112387 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112394 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112398 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 112398 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112401 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112403 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112405 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112410 */   // GIR_Coverage, 6889,
     /* 112410 */   GIR_EraseRootFromParent_Done,
     /* 112411 */ // Label 1812: @112411
     /* 112411 */ GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(112443), // Rule ID 6903 //
     /* 112416 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 112422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112426 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112430 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 112430 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112433 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112435 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112437 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112442 */   // GIR_Coverage, 6903,
     /* 112442 */   GIR_EraseRootFromParent_Done,
     /* 112443 */ // Label 1813: @112443
     /* 112443 */ GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(112475), // Rule ID 6904 //
     /* 112448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112458 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112462 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 112462 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112465 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112467 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112469 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112474 */   // GIR_Coverage, 6904,
     /* 112474 */   GIR_EraseRootFromParent_Done,
     /* 112475 */ // Label 1814: @112475
     /* 112475 */ GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(112507), // Rule ID 6905 //
     /* 112480 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112483 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112490 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112494 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 112494 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112497 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112499 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112501 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112506 */   // GIR_Coverage, 6905,
     /* 112506 */   GIR_EraseRootFromParent_Done,
     /* 112507 */ // Label 1815: @112507
     /* 112507 */ GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(112539), // Rule ID 6906 //
     /* 112512 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 112518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112526 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 112526 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112529 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112531 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112533 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112538 */   // GIR_Coverage, 6906,
     /* 112538 */   GIR_EraseRootFromParent_Done,
     /* 112539 */ // Label 1816: @112539
     /* 112539 */ GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(112571), // Rule ID 6907 //
     /* 112544 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112554 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112558 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 112558 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112561 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112563 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112565 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112570 */   // GIR_Coverage, 6907,
     /* 112570 */   GIR_EraseRootFromParent_Done,
     /* 112571 */ // Label 1817: @112571
     /* 112571 */ GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(112603), // Rule ID 6908 //
     /* 112576 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112586 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112590 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 112590 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112593 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112595 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112597 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112602 */   // GIR_Coverage, 6908,
     /* 112602 */   GIR_EraseRootFromParent_Done,
     /* 112603 */ // Label 1818: @112603
     /* 112603 */ GIM_Try, /*On fail goto*//*Label 1819*/ GIMT_Encode4(112674), // Rule ID 6909 //
     /* 112608 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 112614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112618 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112622 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v4i32] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /* 112622 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 112625 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 112629 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112634 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 112638 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112640 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 112643 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 112647 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112652 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 112656 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112658 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 112661 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 112663 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112666 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 112669 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 112672 */   GIR_RootConstrainSelectedInstOperands,
     /* 112673 */   // GIR_Coverage, 6909,
     /* 112673 */   GIR_EraseRootFromParent_Done,
     /* 112674 */ // Label 1819: @112674
     /* 112674 */ GIM_Try, /*On fail goto*//*Label 1820*/ GIMT_Encode4(112700), // Rule ID 6910 //
     /* 112679 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112689 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112693 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v4i32:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)
     /* 112693 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 112698 */   GIR_RootConstrainSelectedInstOperands,
     /* 112699 */   // GIR_Coverage, 6910,
     /* 112699 */   GIR_Done,
     /* 112700 */ // Label 1820: @112700
     /* 112700 */ GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(112726), // Rule ID 6911 //
     /* 112705 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112715 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112719 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)  =>  (REV32v8i16:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)
     /* 112719 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 112724 */   GIR_RootConstrainSelectedInstOperands,
     /* 112725 */   // GIR_Coverage, 6911,
     /* 112725 */   GIR_Done,
     /* 112726 */ // Label 1821: @112726
     /* 112726 */ GIM_Try, /*On fail goto*//*Label 1822*/ GIMT_Encode4(112752), // Rule ID 6912 //
     /* 112731 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 112737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112741 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112745 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)  =>  (REV32v16i8:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)
     /* 112745 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 112750 */   GIR_RootConstrainSelectedInstOperands,
     /* 112751 */   // GIR_Coverage, 6912,
     /* 112751 */   GIR_Done,
     /* 112752 */ // Label 1822: @112752
     /* 112752 */ GIM_Try, /*On fail goto*//*Label 1823*/ GIMT_Encode4(112778), // Rule ID 6913 //
     /* 112757 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112767 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112771 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v4i32:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)
     /* 112771 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 112776 */   GIR_RootConstrainSelectedInstOperands,
     /* 112777 */   // GIR_Coverage, 6913,
     /* 112777 */   GIR_Done,
     /* 112778 */ // Label 1823: @112778
     /* 112778 */ GIM_Try, /*On fail goto*//*Label 1824*/ GIMT_Encode4(112804), // Rule ID 6914 //
     /* 112783 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112793 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112797 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)  =>  (REV32v8i16:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)
     /* 112797 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 112802 */   GIR_RootConstrainSelectedInstOperands,
     /* 112803 */   // GIR_Coverage, 6914,
     /* 112803 */   GIR_Done,
     /* 112804 */ // Label 1824: @112804
     /* 112804 */ GIM_Try, /*On fail goto*//*Label 1825*/ GIMT_Encode4(112833), // Rule ID 6915 //
     /* 112809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112816 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112820 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 112820 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112823 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112825 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112827 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112832 */   // GIR_Coverage, 6915,
     /* 112832 */   GIR_EraseRootFromParent_Done,
     /* 112833 */ // Label 1825: @112833
     /* 112833 */ GIM_Reject,
     /* 112834 */ // Label 1624: @112834
     /* 112834 */ GIM_Try, /*On fail goto*//*Label 1826*/ GIMT_Encode4(112908), // Rule ID 5710 //
     /* 112839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 112842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112846 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112850 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 112854 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 112858 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112863 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112865 */   // (bitconvert:{ *:[v8i8] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn))  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i32] }, (FMOVWSr:{ *:[f32] } GPR32:{ *:[i32] }:$Rn), ssub:{ *:[i32] })
     /* 112865 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 112868 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVWSr),
     /* 112872 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112877 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 112881 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112883 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 112886 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112888 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112891 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112894 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 112897 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112902 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 112907 */   // GIR_Coverage, 5710,
     /* 112907 */   GIR_EraseRootFromParent_Done,
     /* 112908 */ // Label 1826: @112908
     /* 112908 */ GIM_Try, /*On fail goto*//*Label 1827*/ GIMT_Encode4(112938), // Rule ID 6713 //
     /* 112913 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 112919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112923 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 112927 */   // (bitconvert:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 112927 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112932 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112937 */   // GIR_Coverage, 6713,
     /* 112937 */   GIR_Done,
     /* 112938 */ // Label 1827: @112938
     /* 112938 */ GIM_Try, /*On fail goto*//*Label 1828*/ GIMT_Encode4(112988), // Rule ID 6724 //
     /* 112943 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 112949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112953 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 112957 */   // (bitconvert:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v8i8:{ *:[v8i8] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /* 112957 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 112960 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112964 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112969 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /* 112973 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112978 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 112981 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 112983 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112986 */   GIR_RootConstrainSelectedInstOperands,
     /* 112987 */   // GIR_Coverage, 6724,
     /* 112987 */   GIR_EraseRootFromParent_Done,
     /* 112988 */ // Label 1828: @112988
     /* 112988 */ GIM_Try, /*On fail goto*//*Label 1829*/ GIMT_Encode4(113020), // Rule ID 6799 //
     /* 112993 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 112999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113003 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113007 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 113007 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113010 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113012 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113014 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113019 */   // GIR_Coverage, 6799,
     /* 113019 */   GIR_EraseRootFromParent_Done,
     /* 113020 */ // Label 1829: @113020
     /* 113020 */ GIM_Try, /*On fail goto*//*Label 1830*/ GIMT_Encode4(113052), // Rule ID 6800 //
     /* 113025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 113031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113039 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 113039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113042 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113044 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113046 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113051 */   // GIR_Coverage, 6800,
     /* 113051 */   GIR_EraseRootFromParent_Done,
     /* 113052 */ // Label 1830: @113052
     /* 113052 */ GIM_Try, /*On fail goto*//*Label 1831*/ GIMT_Encode4(113084), // Rule ID 6801 //
     /* 113057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 113063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113067 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113071 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 113071 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113074 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113076 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113078 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113083 */   // GIR_Coverage, 6801,
     /* 113083 */   GIR_EraseRootFromParent_Done,
     /* 113084 */ // Label 1831: @113084
     /* 113084 */ GIM_Try, /*On fail goto*//*Label 1832*/ GIMT_Encode4(113116), // Rule ID 6802 //
     /* 113089 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 113095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113099 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113103 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 113103 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113106 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113108 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113110 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113115 */   // GIR_Coverage, 6802,
     /* 113115 */   GIR_EraseRootFromParent_Done,
     /* 113116 */ // Label 1832: @113116
     /* 113116 */ GIM_Try, /*On fail goto*//*Label 1833*/ GIMT_Encode4(113148), // Rule ID 6803 //
     /* 113121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 113127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113131 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113135 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 113135 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113138 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113140 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113142 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113147 */   // GIR_Coverage, 6803,
     /* 113147 */   GIR_EraseRootFromParent_Done,
     /* 113148 */ // Label 1833: @113148
     /* 113148 */ GIM_Try, /*On fail goto*//*Label 1834*/ GIMT_Encode4(113180), // Rule ID 6804 //
     /* 113153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 113159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113163 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113167 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 113167 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113170 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113172 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113174 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113179 */   // GIR_Coverage, 6804,
     /* 113179 */   GIR_EraseRootFromParent_Done,
     /* 113180 */ // Label 1834: @113180
     /* 113180 */ GIM_Try, /*On fail goto*//*Label 1835*/ GIMT_Encode4(113212), // Rule ID 6805 //
     /* 113185 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 113191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113195 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113199 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 113199 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113202 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113204 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113206 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113211 */   // GIR_Coverage, 6805,
     /* 113211 */   GIR_EraseRootFromParent_Done,
     /* 113212 */ // Label 1835: @113212
     /* 113212 */ GIM_Try, /*On fail goto*//*Label 1836*/ GIMT_Encode4(113238), // Rule ID 6806 //
     /* 113217 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 113223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113227 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113231 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)
     /* 113231 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 113236 */   GIR_RootConstrainSelectedInstOperands,
     /* 113237 */   // GIR_Coverage, 6806,
     /* 113237 */   GIR_Done,
     /* 113238 */ // Label 1836: @113238
     /* 113238 */ GIM_Try, /*On fail goto*//*Label 1837*/ GIMT_Encode4(113264), // Rule ID 6807 //
     /* 113243 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 113249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113253 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113257 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v8i8:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)
     /* 113257 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 113262 */   GIR_RootConstrainSelectedInstOperands,
     /* 113263 */   // GIR_Coverage, 6807,
     /* 113263 */   GIR_Done,
     /* 113264 */ // Label 1837: @113264
     /* 113264 */ GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(113290), // Rule ID 6808 //
     /* 113269 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113272 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 113275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113279 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113283 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)  =>  (REV16v8i8:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)
     /* 113283 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 113288 */   GIR_RootConstrainSelectedInstOperands,
     /* 113289 */   // GIR_Coverage, 6808,
     /* 113289 */   GIR_Done,
     /* 113290 */ // Label 1838: @113290
     /* 113290 */ GIM_Try, /*On fail goto*//*Label 1839*/ GIMT_Encode4(113316), // Rule ID 6809 //
     /* 113295 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 113301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113305 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113309 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)
     /* 113309 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 113314 */   GIR_RootConstrainSelectedInstOperands,
     /* 113315 */   // GIR_Coverage, 6809,
     /* 113315 */   GIR_Done,
     /* 113316 */ // Label 1839: @113316
     /* 113316 */ GIM_Try, /*On fail goto*//*Label 1840*/ GIMT_Encode4(113342), // Rule ID 6810 //
     /* 113321 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 113327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113331 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113335 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v8i8:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)
     /* 113335 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 113340 */   GIR_RootConstrainSelectedInstOperands,
     /* 113341 */   // GIR_Coverage, 6810,
     /* 113341 */   GIR_Done,
     /* 113342 */ // Label 1840: @113342
     /* 113342 */ GIM_Try, /*On fail goto*//*Label 1841*/ GIMT_Encode4(113368), // Rule ID 6811 //
     /* 113347 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 113353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113357 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113361 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)
     /* 113361 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 113366 */   GIR_RootConstrainSelectedInstOperands,
     /* 113367 */   // GIR_Coverage, 6811,
     /* 113367 */   GIR_Done,
     /* 113368 */ // Label 1841: @113368
     /* 113368 */ GIM_Try, /*On fail goto*//*Label 1842*/ GIMT_Encode4(113394), // Rule ID 6812 //
     /* 113373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 113379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113387 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)  =>  (REV16v8i8:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)
     /* 113387 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 113392 */   GIR_RootConstrainSelectedInstOperands,
     /* 113393 */   // GIR_Coverage, 6812,
     /* 113393 */   GIR_Done,
     /* 113394 */ // Label 1842: @113394
     /* 113394 */ GIM_Reject,
     /* 113395 */ // Label 1625: @113395
     /* 113395 */ GIM_Try, /*On fail goto*//*Label 1843*/ GIMT_Encode4(113427), // Rule ID 6916 //
     /* 113400 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 113406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113410 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113414 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 113414 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113417 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113419 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113421 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113426 */   // GIR_Coverage, 6916,
     /* 113426 */   GIR_EraseRootFromParent_Done,
     /* 113427 */ // Label 1843: @113427
     /* 113427 */ GIM_Try, /*On fail goto*//*Label 1844*/ GIMT_Encode4(113459), // Rule ID 6917 //
     /* 113432 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 113438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113442 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113446 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 113446 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113449 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113451 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113453 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113458 */   // GIR_Coverage, 6917,
     /* 113458 */   GIR_EraseRootFromParent_Done,
     /* 113459 */ // Label 1844: @113459
     /* 113459 */ GIM_Try, /*On fail goto*//*Label 1845*/ GIMT_Encode4(113491), // Rule ID 6918 //
     /* 113464 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113467 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 113470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113474 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113478 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 113478 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113481 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113483 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113485 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113490 */   // GIR_Coverage, 6918,
     /* 113490 */   GIR_EraseRootFromParent_Done,
     /* 113491 */ // Label 1845: @113491
     /* 113491 */ GIM_Try, /*On fail goto*//*Label 1846*/ GIMT_Encode4(113523), // Rule ID 6919 //
     /* 113496 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 113502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113506 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113510 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 113510 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113513 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113515 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113517 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113522 */   // GIR_Coverage, 6919,
     /* 113522 */   GIR_EraseRootFromParent_Done,
     /* 113523 */ // Label 1846: @113523
     /* 113523 */ GIM_Try, /*On fail goto*//*Label 1847*/ GIMT_Encode4(113555), // Rule ID 6920 //
     /* 113528 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 113534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113538 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113542 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 113542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113545 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113547 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113549 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113554 */   // GIR_Coverage, 6920,
     /* 113554 */   GIR_EraseRootFromParent_Done,
     /* 113555 */ // Label 1847: @113555
     /* 113555 */ GIM_Try, /*On fail goto*//*Label 1848*/ GIMT_Encode4(113587), // Rule ID 6921 //
     /* 113560 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 113566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113574 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 113574 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113577 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113579 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113581 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113586 */   // GIR_Coverage, 6921,
     /* 113586 */   GIR_EraseRootFromParent_Done,
     /* 113587 */ // Label 1848: @113587
     /* 113587 */ GIM_Try, /*On fail goto*//*Label 1849*/ GIMT_Encode4(113658), // Rule ID 6922 //
     /* 113592 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 113598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113602 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113606 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v8i16] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /* 113606 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 113609 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 113613 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113618 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 113622 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113624 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 113627 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 113631 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113636 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 113640 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 113642 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 113645 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 113647 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113650 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 113653 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 113656 */   GIR_RootConstrainSelectedInstOperands,
     /* 113657 */   // GIR_Coverage, 6922,
     /* 113657 */   GIR_EraseRootFromParent_Done,
     /* 113658 */ // Label 1849: @113658
     /* 113658 */ GIM_Try, /*On fail goto*//*Label 1850*/ GIMT_Encode4(113684), // Rule ID 6923 //
     /* 113663 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 113669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113673 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113677 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v8i16:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)
     /* 113677 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 113682 */   GIR_RootConstrainSelectedInstOperands,
     /* 113683 */   // GIR_Coverage, 6923,
     /* 113683 */   GIR_Done,
     /* 113684 */ // Label 1850: @113684
     /* 113684 */ GIM_Try, /*On fail goto*//*Label 1851*/ GIMT_Encode4(113710), // Rule ID 6924 //
     /* 113689 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 113695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113703 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v8i16:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)
     /* 113703 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 113708 */   GIR_RootConstrainSelectedInstOperands,
     /* 113709 */   // GIR_Coverage, 6924,
     /* 113709 */   GIR_Done,
     /* 113710 */ // Label 1851: @113710
     /* 113710 */ GIM_Try, /*On fail goto*//*Label 1852*/ GIMT_Encode4(113736), // Rule ID 6925 //
     /* 113715 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 113721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113725 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113729 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)  =>  (REV16v16i8:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)
     /* 113729 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 113734 */   GIR_RootConstrainSelectedInstOperands,
     /* 113735 */   // GIR_Coverage, 6925,
     /* 113735 */   GIR_Done,
     /* 113736 */ // Label 1852: @113736
     /* 113736 */ GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(113762), // Rule ID 6926 //
     /* 113741 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 113747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113751 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113755 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v8i16:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)
     /* 113755 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 113760 */   GIR_RootConstrainSelectedInstOperands,
     /* 113761 */   // GIR_Coverage, 6926,
     /* 113761 */   GIR_Done,
     /* 113762 */ // Label 1853: @113762
     /* 113762 */ GIM_Try, /*On fail goto*//*Label 1854*/ GIMT_Encode4(113788), // Rule ID 6927 //
     /* 113767 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 113773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113777 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113781 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v8i16:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)
     /* 113781 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 113786 */   GIR_RootConstrainSelectedInstOperands,
     /* 113787 */   // GIR_Coverage, 6927,
     /* 113787 */   GIR_Done,
     /* 113788 */ // Label 1854: @113788
     /* 113788 */ GIM_Try, /*On fail goto*//*Label 1855*/ GIMT_Encode4(113817), // Rule ID 6928 //
     /* 113793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 113796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113800 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113804 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 113804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113807 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113809 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113811 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113816 */   // GIR_Coverage, 6928,
     /* 113816 */   GIR_EraseRootFromParent_Done,
     /* 113817 */ // Label 1855: @113817
     /* 113817 */ GIM_Try, /*On fail goto*//*Label 1856*/ GIMT_Encode4(113849), // Rule ID 6929 //
     /* 113822 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 113828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113832 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113836 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 113836 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113839 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113841 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113843 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113848 */   // GIR_Coverage, 6929,
     /* 113848 */   GIR_EraseRootFromParent_Done,
     /* 113849 */ // Label 1856: @113849
     /* 113849 */ GIM_Try, /*On fail goto*//*Label 1857*/ GIMT_Encode4(113881), // Rule ID 6930 //
     /* 113854 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 113860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113864 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113868 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 113868 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113871 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113873 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113875 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113880 */   // GIR_Coverage, 6930,
     /* 113880 */   GIR_EraseRootFromParent_Done,
     /* 113881 */ // Label 1857: @113881
     /* 113881 */ GIM_Try, /*On fail goto*//*Label 1858*/ GIMT_Encode4(113913), // Rule ID 6931 //
     /* 113886 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 113892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113900 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 113900 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113903 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113905 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113907 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113912 */   // GIR_Coverage, 6931,
     /* 113912 */   GIR_EraseRootFromParent_Done,
     /* 113913 */ // Label 1858: @113913
     /* 113913 */ GIM_Try, /*On fail goto*//*Label 1859*/ GIMT_Encode4(113945), // Rule ID 6932 //
     /* 113918 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 113924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113928 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113932 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 113932 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113935 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113937 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113939 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113944 */   // GIR_Coverage, 6932,
     /* 113944 */   GIR_EraseRootFromParent_Done,
     /* 113945 */ // Label 1859: @113945
     /* 113945 */ GIM_Try, /*On fail goto*//*Label 1860*/ GIMT_Encode4(113977), // Rule ID 6933 //
     /* 113950 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 113956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113960 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113964 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 113964 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113967 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113969 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113971 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113976 */   // GIR_Coverage, 6933,
     /* 113976 */   GIR_EraseRootFromParent_Done,
     /* 113977 */ // Label 1860: @113977
     /* 113977 */ GIM_Try, /*On fail goto*//*Label 1861*/ GIMT_Encode4(114009), // Rule ID 6934 //
     /* 113982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 113988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113996 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 113996 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113999 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114001 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114003 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114008 */   // GIR_Coverage, 6934,
     /* 114008 */   GIR_EraseRootFromParent_Done,
     /* 114009 */ // Label 1861: @114009
     /* 114009 */ GIM_Try, /*On fail goto*//*Label 1862*/ GIMT_Encode4(114080), // Rule ID 6935 //
     /* 114014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 114020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114024 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114028 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v8f16] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /* 114028 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 114031 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 114035 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114040 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 114044 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114046 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 114049 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 114053 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114058 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 114062 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114064 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 114067 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 114069 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114072 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 114075 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 114078 */   GIR_RootConstrainSelectedInstOperands,
     /* 114079 */   // GIR_Coverage, 6935,
     /* 114079 */   GIR_EraseRootFromParent_Done,
     /* 114080 */ // Label 1862: @114080
     /* 114080 */ GIM_Try, /*On fail goto*//*Label 1863*/ GIMT_Encode4(114106), // Rule ID 6936 //
     /* 114085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114095 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114099 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v8i16:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)
     /* 114099 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 114104 */   GIR_RootConstrainSelectedInstOperands,
     /* 114105 */   // GIR_Coverage, 6936,
     /* 114105 */   GIR_Done,
     /* 114106 */ // Label 1863: @114106
     /* 114106 */ GIM_Try, /*On fail goto*//*Label 1864*/ GIMT_Encode4(114132), // Rule ID 6937 //
     /* 114111 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114121 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114125 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v8i16:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)
     /* 114125 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 114130 */   GIR_RootConstrainSelectedInstOperands,
     /* 114131 */   // GIR_Coverage, 6937,
     /* 114131 */   GIR_Done,
     /* 114132 */ // Label 1864: @114132
     /* 114132 */ GIM_Try, /*On fail goto*//*Label 1865*/ GIMT_Encode4(114158), // Rule ID 6938 //
     /* 114137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 114143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114147 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114151 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)  =>  (REV16v16i8:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)
     /* 114151 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 114156 */   GIR_RootConstrainSelectedInstOperands,
     /* 114157 */   // GIR_Coverage, 6938,
     /* 114157 */   GIR_Done,
     /* 114158 */ // Label 1865: @114158
     /* 114158 */ GIM_Try, /*On fail goto*//*Label 1866*/ GIMT_Encode4(114184), // Rule ID 6939 //
     /* 114163 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114173 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114177 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v8i16:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)
     /* 114177 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 114182 */   GIR_RootConstrainSelectedInstOperands,
     /* 114183 */   // GIR_Coverage, 6939,
     /* 114183 */   GIR_Done,
     /* 114184 */ // Label 1866: @114184
     /* 114184 */ GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(114210), // Rule ID 6940 //
     /* 114189 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114199 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114203 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v8i16:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)
     /* 114203 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 114208 */   GIR_RootConstrainSelectedInstOperands,
     /* 114209 */   // GIR_Coverage, 6940,
     /* 114209 */   GIR_Done,
     /* 114210 */ // Label 1867: @114210
     /* 114210 */ GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(114239), // Rule ID 6941 //
     /* 114215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114222 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114226 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 114226 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114229 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114231 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114233 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114238 */   // GIR_Coverage, 6941,
     /* 114238 */   GIR_EraseRootFromParent_Done,
     /* 114239 */ // Label 1868: @114239
     /* 114239 */ GIM_Reject,
     /* 114240 */ // Label 1626: @114240
     /* 114240 */ GIM_Try, /*On fail goto*//*Label 1869*/ GIMT_Encode4(114272), // Rule ID 6942 //
     /* 114245 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 114248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 114251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114255 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114259 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 114259 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114262 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114264 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114266 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114271 */   // GIR_Coverage, 6942,
     /* 114271 */   GIR_EraseRootFromParent_Done,
     /* 114272 */ // Label 1869: @114272
     /* 114272 */ GIM_Try, /*On fail goto*//*Label 1870*/ GIMT_Encode4(114304), // Rule ID 6943 //
     /* 114277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 114280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114291 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 114291 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114294 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114296 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114298 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114303 */   // GIR_Coverage, 6943,
     /* 114303 */   GIR_EraseRootFromParent_Done,
     /* 114304 */ // Label 1870: @114304
     /* 114304 */ GIM_Try, /*On fail goto*//*Label 1871*/ GIMT_Encode4(114336), // Rule ID 6944 //
     /* 114309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 114312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114323 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 114323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114326 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114328 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114330 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114335 */   // GIR_Coverage, 6944,
     /* 114335 */   GIR_EraseRootFromParent_Done,
     /* 114336 */ // Label 1871: @114336
     /* 114336 */ GIM_Try, /*On fail goto*//*Label 1872*/ GIMT_Encode4(114368), // Rule ID 6945 //
     /* 114341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 114344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114351 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114355 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 114355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114358 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114360 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114362 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114367 */   // GIR_Coverage, 6945,
     /* 114367 */   GIR_EraseRootFromParent_Done,
     /* 114368 */ // Label 1872: @114368
     /* 114368 */ GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(114400), // Rule ID 6946 //
     /* 114373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 114376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114387 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 114387 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114390 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114392 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114394 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114399 */   // GIR_Coverage, 6946,
     /* 114399 */   GIR_EraseRootFromParent_Done,
     /* 114400 */ // Label 1873: @114400
     /* 114400 */ GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(114432), // Rule ID 6947 //
     /* 114405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 114408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114419 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 114419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114422 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114424 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114426 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114431 */   // GIR_Coverage, 6947,
     /* 114431 */   GIR_EraseRootFromParent_Done,
     /* 114432 */ // Label 1874: @114432
     /* 114432 */ GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(114464), // Rule ID 6948 //
     /* 114437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 114440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114447 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114451 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 114451 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114454 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114456 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114458 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114463 */   // GIR_Coverage, 6948,
     /* 114463 */   GIR_EraseRootFromParent_Done,
     /* 114464 */ // Label 1875: @114464
     /* 114464 */ GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(114535), // Rule ID 6949 //
     /* 114469 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 114475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114479 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114483 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v16i8] } (REV64v16i8:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v16i8:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /* 114483 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 114486 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 114490 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114495 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 114499 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114501 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 114504 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 114508 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114513 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 114517 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 114522 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 114524 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114527 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 114530 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 114533 */   GIR_RootConstrainSelectedInstOperands,
     /* 114534 */   // GIR_Coverage, 6949,
     /* 114534 */   GIR_EraseRootFromParent_Done,
     /* 114535 */ // Label 1876: @114535
     /* 114535 */ GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(114561), // Rule ID 6950 //
     /* 114540 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114550 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114554 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v16i8:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)
     /* 114554 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 114559 */   GIR_RootConstrainSelectedInstOperands,
     /* 114560 */   // GIR_Coverage, 6950,
     /* 114560 */   GIR_Done,
     /* 114561 */ // Label 1877: @114561
     /* 114561 */ GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(114587), // Rule ID 6951 //
     /* 114566 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114580 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v16i8:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)
     /* 114580 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 114585 */   GIR_RootConstrainSelectedInstOperands,
     /* 114586 */   // GIR_Coverage, 6951,
     /* 114586 */   GIR_Done,
     /* 114587 */ // Label 1878: @114587
     /* 114587 */ GIM_Try, /*On fail goto*//*Label 1879*/ GIMT_Encode4(114613), // Rule ID 6952 //
     /* 114592 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114602 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114606 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)  =>  (REV16v16i8:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)
     /* 114606 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 114611 */   GIR_RootConstrainSelectedInstOperands,
     /* 114612 */   // GIR_Coverage, 6952,
     /* 114612 */   GIR_Done,
     /* 114613 */ // Label 1879: @114613
     /* 114613 */ GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(114639), // Rule ID 6953 //
     /* 114618 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114628 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114632 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v16i8:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)
     /* 114632 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 114637 */   GIR_RootConstrainSelectedInstOperands,
     /* 114638 */   // GIR_Coverage, 6953,
     /* 114638 */   GIR_Done,
     /* 114639 */ // Label 1880: @114639
     /* 114639 */ GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(114665), // Rule ID 6954 //
     /* 114644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114654 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114658 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v16i8:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)
     /* 114658 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 114663 */   GIR_RootConstrainSelectedInstOperands,
     /* 114664 */   // GIR_Coverage, 6954,
     /* 114664 */   GIR_Done,
     /* 114665 */ // Label 1881: @114665
     /* 114665 */ GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(114691), // Rule ID 6955 //
     /* 114670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114680 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114684 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)  =>  (REV16v16i8:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)
     /* 114684 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 114689 */   GIR_RootConstrainSelectedInstOperands,
     /* 114690 */   // GIR_Coverage, 6955,
     /* 114690 */   GIR_Done,
     /* 114691 */ // Label 1882: @114691
     /* 114691 */ GIM_Reject,
     /* 114692 */ // Label 1627: @114692
     /* 114692 */ GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(114724), // Rule ID 10687 //
     /* 114697 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 114703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114707 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114711 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 114711 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114714 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114716 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114718 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114723 */   // GIR_Coverage, 10687,
     /* 114723 */   GIR_EraseRootFromParent_Done,
     /* 114724 */ // Label 1883: @114724
     /* 114724 */ GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(114756), // Rule ID 10688 //
     /* 114729 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 114735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114739 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114743 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 114743 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114746 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114748 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114750 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114755 */   // GIR_Coverage, 10688,
     /* 114755 */   GIR_EraseRootFromParent_Done,
     /* 114756 */ // Label 1884: @114756
     /* 114756 */ GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(114788), // Rule ID 10689 //
     /* 114761 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 114767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114771 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114775 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 114775 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114778 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114780 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114782 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114787 */   // GIR_Coverage, 10689,
     /* 114787 */   GIR_EraseRootFromParent_Done,
     /* 114788 */ // Label 1885: @114788
     /* 114788 */ GIM_Try, /*On fail goto*//*Label 1886*/ GIMT_Encode4(114820), // Rule ID 10690 //
     /* 114793 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 114799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114803 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114807 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 114807 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114810 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114812 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114814 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114819 */   // GIR_Coverage, 10690,
     /* 114819 */   GIR_EraseRootFromParent_Done,
     /* 114820 */ // Label 1886: @114820
     /* 114820 */ GIM_Try, /*On fail goto*//*Label 1887*/ GIMT_Encode4(114852), // Rule ID 10691 //
     /* 114825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 114831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114835 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114839 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 114839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114842 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114844 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114846 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114851 */   // GIR_Coverage, 10691,
     /* 114851 */   GIR_EraseRootFromParent_Done,
     /* 114852 */ // Label 1887: @114852
     /* 114852 */ GIM_Try, /*On fail goto*//*Label 1888*/ GIMT_Encode4(114884), // Rule ID 10692 //
     /* 114857 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114860 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 114863 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114867 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114871 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 114871 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114874 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114876 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114878 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114883 */   // GIR_Coverage, 10692,
     /* 114883 */   GIR_EraseRootFromParent_Done,
     /* 114884 */ // Label 1888: @114884
     /* 114884 */ GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(114916), // Rule ID 10705 //
     /* 114889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 114895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114899 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114903 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 114903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114906 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114908 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114910 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114915 */   // GIR_Coverage, 10705,
     /* 114915 */   GIR_EraseRootFromParent_Done,
     /* 114916 */ // Label 1889: @114916
     /* 114916 */ GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(114948), // Rule ID 10706 //
     /* 114921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 114927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114931 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114935 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 114935 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114938 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114940 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114942 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114947 */   // GIR_Coverage, 10706,
     /* 114947 */   GIR_EraseRootFromParent_Done,
     /* 114948 */ // Label 1890: @114948
     /* 114948 */ GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(114980), // Rule ID 10707 //
     /* 114953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 114959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114963 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114967 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 114967 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114970 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114972 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114974 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114979 */   // GIR_Coverage, 10707,
     /* 114979 */   GIR_EraseRootFromParent_Done,
     /* 114980 */ // Label 1891: @114980
     /* 114980 */ GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(115012), // Rule ID 10708 //
     /* 114985 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 114991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114995 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114999 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 114999 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115002 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115004 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115006 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115011 */   // GIR_Coverage, 10708,
     /* 115011 */   GIR_EraseRootFromParent_Done,
     /* 115012 */ // Label 1892: @115012
     /* 115012 */ GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(115044), // Rule ID 10709 //
     /* 115017 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 115023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115027 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115031 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 115031 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115034 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115036 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115038 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115043 */   // GIR_Coverage, 10709,
     /* 115043 */   GIR_EraseRootFromParent_Done,
     /* 115044 */ // Label 1893: @115044
     /* 115044 */ GIM_Try, /*On fail goto*//*Label 1894*/ GIMT_Encode4(115076), // Rule ID 10710 //
     /* 115049 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 115055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115059 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115063 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 115063 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115066 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115068 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115070 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115075 */   // GIR_Coverage, 10710,
     /* 115075 */   GIR_EraseRootFromParent_Done,
     /* 115076 */ // Label 1894: @115076
     /* 115076 */ GIM_Try, /*On fail goto*//*Label 1895*/ GIMT_Encode4(115108), // Rule ID 10715 //
     /* 115081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 115084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 115087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115091 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115095 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 115095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115098 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115100 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115102 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115107 */   // GIR_Coverage, 10715,
     /* 115107 */   GIR_EraseRootFromParent_Done,
     /* 115108 */ // Label 1895: @115108
     /* 115108 */ GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(115140), // Rule ID 10716 //
     /* 115113 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 115116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 115119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115123 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115127 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 115127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115130 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115132 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115134 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115139 */   // GIR_Coverage, 10716,
     /* 115139 */   GIR_EraseRootFromParent_Done,
     /* 115140 */ // Label 1896: @115140
     /* 115140 */ GIM_Reject,
     /* 115141 */ // Label 1628: @115141
     /* 115141 */ GIM_Try, /*On fail goto*//*Label 1897*/ GIMT_Encode4(115173), // Rule ID 10681 //
     /* 115146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 115152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115156 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115160 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 115160 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115163 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115165 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115167 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115172 */   // GIR_Coverage, 10681,
     /* 115172 */   GIR_EraseRootFromParent_Done,
     /* 115173 */ // Label 1897: @115173
     /* 115173 */ GIM_Try, /*On fail goto*//*Label 1898*/ GIMT_Encode4(115205), // Rule ID 10682 //
     /* 115178 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 115184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115188 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115192 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 115192 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115195 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115197 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115199 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115204 */   // GIR_Coverage, 10682,
     /* 115204 */   GIR_EraseRootFromParent_Done,
     /* 115205 */ // Label 1898: @115205
     /* 115205 */ GIM_Try, /*On fail goto*//*Label 1899*/ GIMT_Encode4(115237), // Rule ID 10683 //
     /* 115210 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 115216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115220 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115224 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 115224 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115227 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115229 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115231 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115236 */   // GIR_Coverage, 10683,
     /* 115236 */   GIR_EraseRootFromParent_Done,
     /* 115237 */ // Label 1899: @115237
     /* 115237 */ GIM_Try, /*On fail goto*//*Label 1900*/ GIMT_Encode4(115269), // Rule ID 10684 //
     /* 115242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 115248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115252 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115256 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 115256 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115259 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115261 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115263 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115268 */   // GIR_Coverage, 10684,
     /* 115268 */   GIR_EraseRootFromParent_Done,
     /* 115269 */ // Label 1900: @115269
     /* 115269 */ GIM_Try, /*On fail goto*//*Label 1901*/ GIMT_Encode4(115301), // Rule ID 10685 //
     /* 115274 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 115280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115284 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115288 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 115288 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115291 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115293 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115295 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115300 */   // GIR_Coverage, 10685,
     /* 115300 */   GIR_EraseRootFromParent_Done,
     /* 115301 */ // Label 1901: @115301
     /* 115301 */ GIM_Try, /*On fail goto*//*Label 1902*/ GIMT_Encode4(115333), // Rule ID 10686 //
     /* 115306 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 115312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115316 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115320 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 115320 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115323 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115325 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115327 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115332 */   // GIR_Coverage, 10686,
     /* 115332 */   GIR_EraseRootFromParent_Done,
     /* 115333 */ // Label 1902: @115333
     /* 115333 */ GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(115365), // Rule ID 10699 //
     /* 115338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 115344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115348 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115352 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 115352 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115355 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115357 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115359 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115364 */   // GIR_Coverage, 10699,
     /* 115364 */   GIR_EraseRootFromParent_Done,
     /* 115365 */ // Label 1903: @115365
     /* 115365 */ GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(115397), // Rule ID 10700 //
     /* 115370 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 115376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115380 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115384 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 115384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115387 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115389 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115391 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115396 */   // GIR_Coverage, 10700,
     /* 115396 */   GIR_EraseRootFromParent_Done,
     /* 115397 */ // Label 1904: @115397
     /* 115397 */ GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(115429), // Rule ID 10701 //
     /* 115402 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 115408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115412 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115416 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 115416 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115419 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115421 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115423 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115428 */   // GIR_Coverage, 10701,
     /* 115428 */   GIR_EraseRootFromParent_Done,
     /* 115429 */ // Label 1905: @115429
     /* 115429 */ GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(115461), // Rule ID 10702 //
     /* 115434 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 115440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115444 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115448 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 115448 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115451 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115453 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115455 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115460 */   // GIR_Coverage, 10702,
     /* 115460 */   GIR_EraseRootFromParent_Done,
     /* 115461 */ // Label 1906: @115461
     /* 115461 */ GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(115493), // Rule ID 10703 //
     /* 115466 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 115472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115476 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115480 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 115480 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115483 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115485 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115487 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115492 */   // GIR_Coverage, 10703,
     /* 115492 */   GIR_EraseRootFromParent_Done,
     /* 115493 */ // Label 1907: @115493
     /* 115493 */ GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(115525), // Rule ID 10704 //
     /* 115498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 115504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115508 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115512 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 115512 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115515 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115517 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115519 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115524 */   // GIR_Coverage, 10704,
     /* 115524 */   GIR_EraseRootFromParent_Done,
     /* 115525 */ // Label 1908: @115525
     /* 115525 */ GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(115557), // Rule ID 10713 //
     /* 115530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 115533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 115536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115540 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115544 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 115544 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115547 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115549 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115551 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115556 */   // GIR_Coverage, 10713,
     /* 115556 */   GIR_EraseRootFromParent_Done,
     /* 115557 */ // Label 1909: @115557
     /* 115557 */ GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(115589), // Rule ID 10714 //
     /* 115562 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 115565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 115568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115572 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115576 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 115576 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115579 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115581 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115583 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115588 */   // GIR_Coverage, 10714,
     /* 115588 */   GIR_EraseRootFromParent_Done,
     /* 115589 */ // Label 1910: @115589
     /* 115589 */ GIM_Reject,
     /* 115590 */ // Label 1629: @115590
     /* 115590 */ GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(115622), // Rule ID 10675 //
     /* 115595 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 115601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115605 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115609 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 115609 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115612 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115614 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115616 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115621 */   // GIR_Coverage, 10675,
     /* 115621 */   GIR_EraseRootFromParent_Done,
     /* 115622 */ // Label 1911: @115622
     /* 115622 */ GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(115654), // Rule ID 10676 //
     /* 115627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 115633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115637 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115641 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 115641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115644 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115646 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115648 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115653 */   // GIR_Coverage, 10676,
     /* 115653 */   GIR_EraseRootFromParent_Done,
     /* 115654 */ // Label 1912: @115654
     /* 115654 */ GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(115686), // Rule ID 10677 //
     /* 115659 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 115665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115669 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115673 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 115673 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115676 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115678 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115680 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115685 */   // GIR_Coverage, 10677,
     /* 115685 */   GIR_EraseRootFromParent_Done,
     /* 115686 */ // Label 1913: @115686
     /* 115686 */ GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(115718), // Rule ID 10678 //
     /* 115691 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 115697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115701 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115705 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 115705 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115708 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115710 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115712 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115717 */   // GIR_Coverage, 10678,
     /* 115717 */   GIR_EraseRootFromParent_Done,
     /* 115718 */ // Label 1914: @115718
     /* 115718 */ GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(115750), // Rule ID 10679 //
     /* 115723 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 115729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115733 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115737 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 115737 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115740 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115742 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115744 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115749 */   // GIR_Coverage, 10679,
     /* 115749 */   GIR_EraseRootFromParent_Done,
     /* 115750 */ // Label 1915: @115750
     /* 115750 */ GIM_Try, /*On fail goto*//*Label 1916*/ GIMT_Encode4(115782), // Rule ID 10680 //
     /* 115755 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 115761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115765 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115769 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 115769 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115772 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115774 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115776 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115781 */   // GIR_Coverage, 10680,
     /* 115781 */   GIR_EraseRootFromParent_Done,
     /* 115782 */ // Label 1916: @115782
     /* 115782 */ GIM_Try, /*On fail goto*//*Label 1917*/ GIMT_Encode4(115814), // Rule ID 10693 //
     /* 115787 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 115793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115797 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115801 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 115801 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115804 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115806 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115808 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115813 */   // GIR_Coverage, 10693,
     /* 115813 */   GIR_EraseRootFromParent_Done,
     /* 115814 */ // Label 1917: @115814
     /* 115814 */ GIM_Try, /*On fail goto*//*Label 1918*/ GIMT_Encode4(115846), // Rule ID 10694 //
     /* 115819 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 115825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115829 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115833 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 115833 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115836 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115838 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115840 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115845 */   // GIR_Coverage, 10694,
     /* 115845 */   GIR_EraseRootFromParent_Done,
     /* 115846 */ // Label 1918: @115846
     /* 115846 */ GIM_Try, /*On fail goto*//*Label 1919*/ GIMT_Encode4(115878), // Rule ID 10695 //
     /* 115851 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 115857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115865 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 115865 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115868 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115870 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115872 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115877 */   // GIR_Coverage, 10695,
     /* 115877 */   GIR_EraseRootFromParent_Done,
     /* 115878 */ // Label 1919: @115878
     /* 115878 */ GIM_Try, /*On fail goto*//*Label 1920*/ GIMT_Encode4(115910), // Rule ID 10696 //
     /* 115883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 115889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115893 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115897 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 115897 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115900 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115902 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115904 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115909 */   // GIR_Coverage, 10696,
     /* 115909 */   GIR_EraseRootFromParent_Done,
     /* 115910 */ // Label 1920: @115910
     /* 115910 */ GIM_Try, /*On fail goto*//*Label 1921*/ GIMT_Encode4(115942), // Rule ID 10697 //
     /* 115915 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 115921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115925 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115929 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 115929 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115932 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115934 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115936 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115941 */   // GIR_Coverage, 10697,
     /* 115941 */   GIR_EraseRootFromParent_Done,
     /* 115942 */ // Label 1921: @115942
     /* 115942 */ GIM_Try, /*On fail goto*//*Label 1922*/ GIMT_Encode4(115974), // Rule ID 10698 //
     /* 115947 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 115953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115957 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115961 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 115961 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115964 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115966 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115968 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115973 */   // GIR_Coverage, 10698,
     /* 115973 */   GIR_EraseRootFromParent_Done,
     /* 115974 */ // Label 1922: @115974
     /* 115974 */ GIM_Try, /*On fail goto*//*Label 1923*/ GIMT_Encode4(116006), // Rule ID 10711 //
     /* 115979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 115982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 115985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115989 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115993 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 115993 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115996 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115998 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116000 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116005 */   // GIR_Coverage, 10711,
     /* 116005 */   GIR_EraseRootFromParent_Done,
     /* 116006 */ // Label 1923: @116006
     /* 116006 */ GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(116038), // Rule ID 10712 //
     /* 116011 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 116014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 116017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116021 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116025 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 116025 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116028 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 116030 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116032 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116037 */   // GIR_Coverage, 10712,
     /* 116037 */   GIR_EraseRootFromParent_Done,
     /* 116038 */ // Label 1924: @116038
     /* 116038 */ GIM_Reject,
     /* 116039 */ // Label 1630: @116039
     /* 116039 */ GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(116071), // Rule ID 10669 //
     /* 116044 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 116047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 116050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116054 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116058 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /* 116058 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116061 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 116063 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116065 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116070 */   // GIR_Coverage, 10669,
     /* 116070 */   GIR_EraseRootFromParent_Done,
     /* 116071 */ // Label 1925: @116071
     /* 116071 */ GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(116103), // Rule ID 10670 //
     /* 116076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 116079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 116082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116086 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116090 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /* 116090 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116093 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 116095 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116097 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116102 */   // GIR_Coverage, 10670,
     /* 116102 */   GIR_EraseRootFromParent_Done,
     /* 116103 */ // Label 1926: @116103
     /* 116103 */ GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(116135), // Rule ID 10671 //
     /* 116108 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 116111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 116114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116122 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /* 116122 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116125 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 116127 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116129 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116134 */   // GIR_Coverage, 10671,
     /* 116134 */   GIR_EraseRootFromParent_Done,
     /* 116135 */ // Label 1927: @116135
     /* 116135 */ GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(116167), // Rule ID 10672 //
     /* 116140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 116143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 116146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116154 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /* 116154 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116157 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 116159 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116161 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116166 */   // GIR_Coverage, 10672,
     /* 116166 */   GIR_EraseRootFromParent_Done,
     /* 116167 */ // Label 1928: @116167
     /* 116167 */ GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(116199), // Rule ID 10673 //
     /* 116172 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 116175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 116178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116182 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116186 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /* 116186 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116189 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 116191 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116193 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116198 */   // GIR_Coverage, 10673,
     /* 116198 */   GIR_EraseRootFromParent_Done,
     /* 116199 */ // Label 1929: @116199
     /* 116199 */ GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(116231), // Rule ID 10674 //
     /* 116204 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 116207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 116210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116214 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116218 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /* 116218 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116221 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 116223 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116225 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116230 */   // GIR_Coverage, 10674,
     /* 116230 */   GIR_EraseRootFromParent_Done,
     /* 116231 */ // Label 1930: @116231
     /* 116231 */ GIM_Reject,
     /* 116232 */ // Label 1631: @116232
     /* 116232 */ GIM_Reject,
     /* 116233 */ // Label 10: @116233
     /* 116233 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1939*/ GIMT_Encode4(116723),
     /* 116244 */ /*GILLT_s16*//*Label 1931*/ GIMT_Encode4(116284),
     /* 116248 */ /*GILLT_s32*//*Label 1932*/ GIMT_Encode4(116315),
     /* 116252 */ /*GILLT_s64*//*Label 1933*/ GIMT_Encode4(116346), GIMT_Encode4(0),
     /* 116260 */ /*GILLT_v2s32*//*Label 1934*/ GIMT_Encode4(116377),
     /* 116264 */ /*GILLT_v2s64*//*Label 1935*/ GIMT_Encode4(116408),
     /* 116268 */ /*GILLT_v4s16*//*Label 1936*/ GIMT_Encode4(116439),
     /* 116272 */ /*GILLT_v4s32*//*Label 1937*/ GIMT_Encode4(116470), GIMT_Encode4(0),
     /* 116280 */ /*GILLT_v8s16*//*Label 1938*/ GIMT_Encode4(116501),
     /* 116284 */ // Label 1931: @116284
     /* 116284 */ GIM_Try, /*On fail goto*//*Label 1940*/ GIMT_Encode4(116314), // Rule ID 564 //
     /* 116289 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 116292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 116295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 116299 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 116303 */   // (ftrunc:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTZHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 116303 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZHr),
     /* 116308 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116312 */   GIR_RootConstrainSelectedInstOperands,
     /* 116313 */   // GIR_Coverage, 564,
     /* 116313 */   GIR_Done,
     /* 116314 */ // Label 1940: @116314
     /* 116314 */ GIM_Reject,
     /* 116315 */ // Label 1932: @116315
     /* 116315 */ GIM_Try, /*On fail goto*//*Label 1941*/ GIMT_Encode4(116345), // Rule ID 566 //
     /* 116320 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116334 */   // (ftrunc:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 116334 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZSr),
     /* 116339 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116343 */   GIR_RootConstrainSelectedInstOperands,
     /* 116344 */   // GIR_Coverage, 566,
     /* 116344 */   GIR_Done,
     /* 116345 */ // Label 1941: @116345
     /* 116345 */ GIM_Reject,
     /* 116346 */ // Label 1933: @116346
     /* 116346 */ GIM_Try, /*On fail goto*//*Label 1942*/ GIMT_Encode4(116376), // Rule ID 568 //
     /* 116351 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 116357 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116361 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116365 */   // (ftrunc:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 116365 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZDr),
     /* 116370 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116374 */   GIR_RootConstrainSelectedInstOperands,
     /* 116375 */   // GIR_Coverage, 568,
     /* 116375 */   GIR_Done,
     /* 116376 */ // Label 1942: @116376
     /* 116376 */ GIM_Reject,
     /* 116377 */ // Label 1934: @116377
     /* 116377 */ GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(116407), // Rule ID 933 //
     /* 116382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 116388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116392 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116396 */   // (ftrunc:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTZv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 116396 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv2f32),
     /* 116401 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116405 */   GIR_RootConstrainSelectedInstOperands,
     /* 116406 */   // GIR_Coverage, 933,
     /* 116406 */   GIR_Done,
     /* 116407 */ // Label 1943: @116407
     /* 116407 */ GIM_Reject,
     /* 116408 */ // Label 1935: @116408
     /* 116408 */ GIM_Try, /*On fail goto*//*Label 1944*/ GIMT_Encode4(116438), // Rule ID 937 //
     /* 116413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 116419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116423 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116427 */   // (ftrunc:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTZv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 116427 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv2f64),
     /* 116432 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116436 */   GIR_RootConstrainSelectedInstOperands,
     /* 116437 */   // GIR_Coverage, 937,
     /* 116437 */   GIR_Done,
     /* 116438 */ // Label 1944: @116438
     /* 116438 */ GIM_Reject,
     /* 116439 */ // Label 1936: @116439
     /* 116439 */ GIM_Try, /*On fail goto*//*Label 1945*/ GIMT_Encode4(116469), // Rule ID 929 //
     /* 116444 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 116447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 116450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116454 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116458 */   // (ftrunc:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTZv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 116458 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f16),
     /* 116463 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116467 */   GIR_RootConstrainSelectedInstOperands,
     /* 116468 */   // GIR_Coverage, 929,
     /* 116468 */   GIR_Done,
     /* 116469 */ // Label 1945: @116469
     /* 116469 */ GIM_Reject,
     /* 116470 */ // Label 1937: @116470
     /* 116470 */ GIM_Try, /*On fail goto*//*Label 1946*/ GIMT_Encode4(116500), // Rule ID 935 //
     /* 116475 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 116481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116485 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116489 */   // (ftrunc:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTZv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 116489 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /* 116494 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116498 */   GIR_RootConstrainSelectedInstOperands,
     /* 116499 */   // GIR_Coverage, 935,
     /* 116499 */   GIR_Done,
     /* 116500 */ // Label 1946: @116500
     /* 116500 */ GIM_Reject,
     /* 116501 */ // Label 1938: @116501
     /* 116501 */ GIM_Try, /*On fail goto*//*Label 1947*/ GIMT_Encode4(116722),
     /* 116506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 116509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116513 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116517 */   GIM_Try, /*On fail goto*//*Label 1948*/ GIMT_Encode4(116536), // Rule ID 931 //
     /* 116522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 116525 */     // (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTZv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 116525 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv8f16),
     /* 116530 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116534 */     GIR_RootConstrainSelectedInstOperands,
     /* 116535 */     // GIR_Coverage, 931,
     /* 116535 */     GIR_Done,
     /* 116536 */   // Label 1948: @116536
     /* 116536 */   GIM_Try, /*On fail goto*//*Label 1949*/ GIMT_Encode4(116721), // Rule ID 7080 //
     /* 116541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 116544 */     // (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTZv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTZv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 116544 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 116547 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 116551 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116556 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 116560 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 116562 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 116565 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /* 116569 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116574 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 116577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 116579 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 116582 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116586 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116591 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 116597 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116602 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116607 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 116610 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 116614 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116619 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 116622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 116624 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 116627 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /* 116631 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116636 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 116639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 116641 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 116644 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 116648 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116653 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 116656 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 116658 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 116661 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 116665 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 116675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 116679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116684 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 116687 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 116690 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 116693 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116698 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116703 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 116711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116716 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 116719 */     GIR_RootConstrainSelectedInstOperands,
     /* 116720 */     // GIR_Coverage, 7080,
     /* 116720 */     GIR_EraseRootFromParent_Done,
     /* 116721 */   // Label 1949: @116721
     /* 116721 */   GIM_Reject,
     /* 116722 */ // Label 1947: @116722
     /* 116722 */ GIM_Reject,
     /* 116723 */ // Label 1939: @116723
     /* 116723 */ GIM_Reject,
     /* 116724 */ // Label 11: @116724
     /* 116724 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1958*/ GIMT_Encode4(117214),
     /* 116735 */ /*GILLT_s16*//*Label 1950*/ GIMT_Encode4(116775),
     /* 116739 */ /*GILLT_s32*//*Label 1951*/ GIMT_Encode4(116806),
     /* 116743 */ /*GILLT_s64*//*Label 1952*/ GIMT_Encode4(116837), GIMT_Encode4(0),
     /* 116751 */ /*GILLT_v2s32*//*Label 1953*/ GIMT_Encode4(116868),
     /* 116755 */ /*GILLT_v2s64*//*Label 1954*/ GIMT_Encode4(116899),
     /* 116759 */ /*GILLT_v4s16*//*Label 1955*/ GIMT_Encode4(116930),
     /* 116763 */ /*GILLT_v4s32*//*Label 1956*/ GIMT_Encode4(116961), GIMT_Encode4(0),
     /* 116771 */ /*GILLT_v8s16*//*Label 1957*/ GIMT_Encode4(116992),
     /* 116775 */ // Label 1950: @116775
     /* 116775 */ GIM_Try, /*On fail goto*//*Label 1959*/ GIMT_Encode4(116805), // Rule ID 528 //
     /* 116780 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 116783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 116786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 116790 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 116794 */   // (fround:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTAHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 116794 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAHr),
     /* 116799 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116803 */   GIR_RootConstrainSelectedInstOperands,
     /* 116804 */   // GIR_Coverage, 528,
     /* 116804 */   GIR_Done,
     /* 116805 */ // Label 1959: @116805
     /* 116805 */ GIM_Reject,
     /* 116806 */ // Label 1951: @116806
     /* 116806 */ GIM_Try, /*On fail goto*//*Label 1960*/ GIMT_Encode4(116836), // Rule ID 530 //
     /* 116811 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116821 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116825 */   // (fround:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTASr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 116825 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTASr),
     /* 116830 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116834 */   GIR_RootConstrainSelectedInstOperands,
     /* 116835 */   // GIR_Coverage, 530,
     /* 116835 */   GIR_Done,
     /* 116836 */ // Label 1960: @116836
     /* 116836 */ GIM_Reject,
     /* 116837 */ // Label 1952: @116837
     /* 116837 */ GIM_Try, /*On fail goto*//*Label 1961*/ GIMT_Encode4(116867), // Rule ID 532 //
     /* 116842 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 116848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116852 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116856 */   // (fround:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTADr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 116856 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTADr),
     /* 116861 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116865 */   GIR_RootConstrainSelectedInstOperands,
     /* 116866 */   // GIR_Coverage, 532,
     /* 116866 */   GIR_Done,
     /* 116867 */ // Label 1961: @116867
     /* 116867 */ GIM_Reject,
     /* 116868 */ // Label 1953: @116868
     /* 116868 */ GIM_Try, /*On fail goto*//*Label 1962*/ GIMT_Encode4(116898), // Rule ID 873 //
     /* 116873 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 116879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116883 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116887 */   // (fround:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 116887 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv2f32),
     /* 116892 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116896 */   GIR_RootConstrainSelectedInstOperands,
     /* 116897 */   // GIR_Coverage, 873,
     /* 116897 */   GIR_Done,
     /* 116898 */ // Label 1962: @116898
     /* 116898 */ GIM_Reject,
     /* 116899 */ // Label 1954: @116899
     /* 116899 */ GIM_Try, /*On fail goto*//*Label 1963*/ GIMT_Encode4(116929), // Rule ID 877 //
     /* 116904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 116910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116918 */   // (fround:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 116918 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv2f64),
     /* 116923 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116927 */   GIR_RootConstrainSelectedInstOperands,
     /* 116928 */   // GIR_Coverage, 877,
     /* 116928 */   GIR_Done,
     /* 116929 */ // Label 1963: @116929
     /* 116929 */ GIM_Reject,
     /* 116930 */ // Label 1955: @116930
     /* 116930 */ GIM_Try, /*On fail goto*//*Label 1964*/ GIMT_Encode4(116960), // Rule ID 869 //
     /* 116935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 116938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 116941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116945 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116949 */   // (fround:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 116949 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f16),
     /* 116954 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116958 */   GIR_RootConstrainSelectedInstOperands,
     /* 116959 */   // GIR_Coverage, 869,
     /* 116959 */   GIR_Done,
     /* 116960 */ // Label 1964: @116960
     /* 116960 */ GIM_Reject,
     /* 116961 */ // Label 1956: @116961
     /* 116961 */ GIM_Try, /*On fail goto*//*Label 1965*/ GIMT_Encode4(116991), // Rule ID 875 //
     /* 116966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 116972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116980 */   // (fround:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 116980 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /* 116985 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116989 */   GIR_RootConstrainSelectedInstOperands,
     /* 116990 */   // GIR_Coverage, 875,
     /* 116990 */   GIR_Done,
     /* 116991 */ // Label 1965: @116991
     /* 116991 */ GIM_Reject,
     /* 116992 */ // Label 1957: @116992
     /* 116992 */ GIM_Try, /*On fail goto*//*Label 1966*/ GIMT_Encode4(117213),
     /* 116997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 117000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117004 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117008 */   GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(117027), // Rule ID 871 //
     /* 117013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 117016 */     // (fround:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 117016 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv8f16),
     /* 117021 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 117025 */     GIR_RootConstrainSelectedInstOperands,
     /* 117026 */     // GIR_Coverage, 871,
     /* 117026 */     GIR_Done,
     /* 117027 */   // Label 1967: @117027
     /* 117027 */   GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(117212), // Rule ID 7074 //
     /* 117032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 117035 */     // (fround:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTAv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTAv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 117035 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 117038 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 117042 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117047 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 117051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 117053 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 117056 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /* 117060 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117065 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 117068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 117070 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 117073 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117077 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117082 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 117088 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117093 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117098 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 117101 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 117105 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117110 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 117113 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 117115 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 117118 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /* 117122 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117127 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 117130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 117132 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 117135 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 117139 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117144 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 117147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 117149 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 117152 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117156 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 117166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 117170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117175 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 117178 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 117181 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 117184 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117189 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117194 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 117202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117207 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 117210 */     GIR_RootConstrainSelectedInstOperands,
     /* 117211 */     // GIR_Coverage, 7074,
     /* 117211 */     GIR_EraseRootFromParent_Done,
     /* 117212 */   // Label 1968: @117212
     /* 117212 */   GIM_Reject,
     /* 117213 */ // Label 1966: @117213
     /* 117213 */ GIM_Reject,
     /* 117214 */ // Label 1958: @117214
     /* 117214 */ GIM_Reject,
     /* 117215 */ // Label 12: @117215
     /* 117215 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 1971*/ GIMT_Encode4(117482),
     /* 117226 */ /*GILLT_s32*//*Label 1969*/ GIMT_Encode4(117234),
     /* 117230 */ /*GILLT_s64*//*Label 1970*/ GIMT_Encode4(117358),
     /* 117234 */ // Label 1969: @117234
     /* 117234 */ GIM_Try, /*On fail goto*//*Label 1972*/ GIMT_Encode4(117277), // Rule ID 4846 //
     /* 117239 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 117242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 117245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117249 */   // (lrint:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /* 117249 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 117252 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /* 117256 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117261 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 117265 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117267 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 117270 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 117272 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117275 */   GIR_RootConstrainSelectedInstOperands,
     /* 117276 */   // GIR_Coverage, 4846,
     /* 117276 */   GIR_EraseRootFromParent_Done,
     /* 117277 */ // Label 1972: @117277
     /* 117277 */ GIM_Try, /*On fail goto*//*Label 1973*/ GIMT_Encode4(117317), // Rule ID 4852 //
     /* 117282 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117289 */   // (lrint:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 117289 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117292 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /* 117296 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117301 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 117305 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117307 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 117310 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 117312 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117315 */   GIR_RootConstrainSelectedInstOperands,
     /* 117316 */   // GIR_Coverage, 4852,
     /* 117316 */   GIR_EraseRootFromParent_Done,
     /* 117317 */ // Label 1973: @117317
     /* 117317 */ GIM_Try, /*On fail goto*//*Label 1974*/ GIMT_Encode4(117357), // Rule ID 4854 //
     /* 117322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 117325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117329 */   // (lrint:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 117329 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 117332 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /* 117336 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117341 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 117345 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117347 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 117350 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 117352 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117355 */   GIR_RootConstrainSelectedInstOperands,
     /* 117356 */   // GIR_Coverage, 4854,
     /* 117356 */   GIR_EraseRootFromParent_Done,
     /* 117357 */ // Label 1974: @117357
     /* 117357 */ GIM_Reject,
     /* 117358 */ // Label 1970: @117358
     /* 117358 */ GIM_Try, /*On fail goto*//*Label 1975*/ GIMT_Encode4(117401), // Rule ID 4848 //
     /* 117363 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 117366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 117369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117373 */   // (lrint:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /* 117373 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 117376 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /* 117380 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117385 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 117389 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117391 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 117394 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 117396 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117399 */   GIR_RootConstrainSelectedInstOperands,
     /* 117400 */   // GIR_Coverage, 4848,
     /* 117400 */   GIR_EraseRootFromParent_Done,
     /* 117401 */ // Label 1975: @117401
     /* 117401 */ GIM_Try, /*On fail goto*//*Label 1976*/ GIMT_Encode4(117441), // Rule ID 4856 //
     /* 117406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117413 */   // (lrint:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 117413 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117416 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /* 117420 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117425 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 117429 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117431 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 117434 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 117436 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117439 */   GIR_RootConstrainSelectedInstOperands,
     /* 117440 */   // GIR_Coverage, 4856,
     /* 117440 */   GIR_EraseRootFromParent_Done,
     /* 117441 */ // Label 1976: @117441
     /* 117441 */ GIM_Try, /*On fail goto*//*Label 1977*/ GIMT_Encode4(117481), // Rule ID 4858 //
     /* 117446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 117449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117453 */   // (lrint:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 117453 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 117456 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /* 117460 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117465 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 117469 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117471 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 117474 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 117476 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117479 */   GIR_RootConstrainSelectedInstOperands,
     /* 117480 */   // GIR_Coverage, 4858,
     /* 117480 */   GIR_EraseRootFromParent_Done,
     /* 117481 */ // Label 1977: @117481
     /* 117481 */ GIM_Reject,
     /* 117482 */ // Label 1971: @117482
     /* 117482 */ GIM_Reject,
     /* 117483 */ // Label 13: @117483
     /* 117483 */ GIM_Try, /*On fail goto*//*Label 1978*/ GIMT_Encode4(117632),
     /* 117488 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 117491 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 1982*/ GIMT_Encode4(117631),
     /* 117502 */   /*GILLT_s16*//*Label 1979*/ GIMT_Encode4(117514),
     /* 117506 */   /*GILLT_s32*//*Label 1980*/ GIMT_Encode4(117555),
     /* 117510 */   /*GILLT_s64*//*Label 1981*/ GIMT_Encode4(117593),
     /* 117514 */   // Label 1979: @117514
     /* 117514 */   GIM_Try, /*On fail goto*//*Label 1983*/ GIMT_Encode4(117554), // Rule ID 4850 //
     /* 117519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 117522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117526 */     // (llrint:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /* 117526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 117529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /* 117533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117538 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 117542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 117547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 117549 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117552 */     GIR_RootConstrainSelectedInstOperands,
     /* 117553 */     // GIR_Coverage, 4850,
     /* 117553 */     GIR_EraseRootFromParent_Done,
     /* 117554 */   // Label 1983: @117554
     /* 117554 */   GIM_Reject,
     /* 117555 */   // Label 1980: @117555
     /* 117555 */   GIM_Try, /*On fail goto*//*Label 1984*/ GIMT_Encode4(117592), // Rule ID 4860 //
     /* 117560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117564 */     // (llrint:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 117564 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /* 117571 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117576 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 117580 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 117585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 117587 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117590 */     GIR_RootConstrainSelectedInstOperands,
     /* 117591 */     // GIR_Coverage, 4860,
     /* 117591 */     GIR_EraseRootFromParent_Done,
     /* 117592 */   // Label 1984: @117592
     /* 117592 */   GIM_Reject,
     /* 117593 */   // Label 1981: @117593
     /* 117593 */   GIM_Try, /*On fail goto*//*Label 1985*/ GIMT_Encode4(117630), // Rule ID 4862 //
     /* 117598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117602 */     // (llrint:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 117602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 117605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /* 117609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117614 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 117618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 117623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 117625 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117628 */     GIR_RootConstrainSelectedInstOperands,
     /* 117629 */     // GIR_Coverage, 4862,
     /* 117629 */     GIR_EraseRootFromParent_Done,
     /* 117630 */   // Label 1985: @117630
     /* 117630 */   GIM_Reject,
     /* 117631 */   // Label 1982: @117631
     /* 117631 */   GIM_Reject,
     /* 117632 */ // Label 1978: @117632
     /* 117632 */ GIM_Reject,
     /* 117633 */ // Label 14: @117633
     /* 117633 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1994*/ GIMT_Encode4(118123),
     /* 117644 */ /*GILLT_s16*//*Label 1986*/ GIMT_Encode4(117684),
     /* 117648 */ /*GILLT_s32*//*Label 1987*/ GIMT_Encode4(117715),
     /* 117652 */ /*GILLT_s64*//*Label 1988*/ GIMT_Encode4(117746), GIMT_Encode4(0),
     /* 117660 */ /*GILLT_v2s32*//*Label 1989*/ GIMT_Encode4(117777),
     /* 117664 */ /*GILLT_v2s64*//*Label 1990*/ GIMT_Encode4(117808),
     /* 117668 */ /*GILLT_v4s16*//*Label 1991*/ GIMT_Encode4(117839),
     /* 117672 */ /*GILLT_v4s32*//*Label 1992*/ GIMT_Encode4(117870), GIMT_Encode4(0),
     /* 117680 */ /*GILLT_v8s16*//*Label 1993*/ GIMT_Encode4(117901),
     /* 117684 */ // Label 1986: @117684
     /* 117684 */ GIM_Try, /*On fail goto*//*Label 1995*/ GIMT_Encode4(117714), // Rule ID 546 //
     /* 117689 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 117692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 117695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 117699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 117703 */   // (froundeven:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTNHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 117703 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNHr),
     /* 117708 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 117712 */   GIR_RootConstrainSelectedInstOperands,
     /* 117713 */   // GIR_Coverage, 546,
     /* 117713 */   GIR_Done,
     /* 117714 */ // Label 1995: @117714
     /* 117714 */ GIM_Reject,
     /* 117715 */ // Label 1987: @117715
     /* 117715 */ GIM_Try, /*On fail goto*//*Label 1996*/ GIMT_Encode4(117745), // Rule ID 548 //
     /* 117720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 117723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 117730 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 117734 */   // (froundeven:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTNSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 117734 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNSr),
     /* 117739 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 117743 */   GIR_RootConstrainSelectedInstOperands,
     /* 117744 */   // GIR_Coverage, 548,
     /* 117744 */   GIR_Done,
     /* 117745 */ // Label 1996: @117745
     /* 117745 */ GIM_Reject,
     /* 117746 */ // Label 1988: @117746
     /* 117746 */ GIM_Try, /*On fail goto*//*Label 1997*/ GIMT_Encode4(117776), // Rule ID 550 //
     /* 117751 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 117754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 117757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117761 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117765 */   // (froundeven:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTNDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 117765 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNDr),
     /* 117770 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 117774 */   GIR_RootConstrainSelectedInstOperands,
     /* 117775 */   // GIR_Coverage, 550,
     /* 117775 */   GIR_Done,
     /* 117776 */ // Label 1997: @117776
     /* 117776 */ GIM_Reject,
     /* 117777 */ // Label 1989: @117777
     /* 117777 */ GIM_Try, /*On fail goto*//*Label 1998*/ GIMT_Encode4(117807), // Rule ID 903 //
     /* 117782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 117785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 117788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117792 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117796 */   // (froundeven:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTNv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 117796 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv2f32),
     /* 117801 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 117805 */   GIR_RootConstrainSelectedInstOperands,
     /* 117806 */   // GIR_Coverage, 903,
     /* 117806 */   GIR_Done,
     /* 117807 */ // Label 1998: @117807
     /* 117807 */ GIM_Reject,
     /* 117808 */ // Label 1990: @117808
     /* 117808 */ GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(117838), // Rule ID 907 //
     /* 117813 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 117816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 117819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117823 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117827 */   // (froundeven:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTNv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 117827 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv2f64),
     /* 117832 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 117836 */   GIR_RootConstrainSelectedInstOperands,
     /* 117837 */   // GIR_Coverage, 907,
     /* 117837 */   GIR_Done,
     /* 117838 */ // Label 1999: @117838
     /* 117838 */ GIM_Reject,
     /* 117839 */ // Label 1991: @117839
     /* 117839 */ GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(117869), // Rule ID 899 //
     /* 117844 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 117847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 117850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117854 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117858 */   // (froundeven:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTNv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 117858 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f16),
     /* 117863 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 117867 */   GIR_RootConstrainSelectedInstOperands,
     /* 117868 */   // GIR_Coverage, 899,
     /* 117868 */   GIR_Done,
     /* 117869 */ // Label 2000: @117869
     /* 117869 */ GIM_Reject,
     /* 117870 */ // Label 1992: @117870
     /* 117870 */ GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(117900), // Rule ID 905 //
     /* 117875 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 117878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 117881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117885 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117889 */   // (froundeven:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTNv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 117889 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /* 117894 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 117898 */   GIR_RootConstrainSelectedInstOperands,
     /* 117899 */   // GIR_Coverage, 905,
     /* 117899 */   GIR_Done,
     /* 117900 */ // Label 2001: @117900
     /* 117900 */ GIM_Reject,
     /* 117901 */ // Label 1993: @117901
     /* 117901 */ GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(118122),
     /* 117906 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 117909 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117913 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117917 */   GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(117936), // Rule ID 901 //
     /* 117922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 117925 */     // (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTNv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 117925 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv8f16),
     /* 117930 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 117934 */     GIR_RootConstrainSelectedInstOperands,
     /* 117935 */     // GIR_Coverage, 901,
     /* 117935 */     GIR_Done,
     /* 117936 */   // Label 2003: @117936
     /* 117936 */   GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(118121), // Rule ID 7076 //
     /* 117941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 117944 */     // (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTNv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTNv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 117944 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 117947 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 117951 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117956 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 117960 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 117962 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 117965 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /* 117969 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117974 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 117977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 117979 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 117982 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117986 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117991 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 117997 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118002 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118007 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 118010 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 118014 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118019 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 118022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 118024 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 118027 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /* 118031 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118036 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 118039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 118041 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 118044 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 118048 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118053 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 118056 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118058 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 118061 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118065 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 118075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 118079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118084 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 118087 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 118090 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 118093 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118098 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118103 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 118111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118113 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118116 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 118119 */     GIR_RootConstrainSelectedInstOperands,
     /* 118120 */     // GIR_Coverage, 7076,
     /* 118120 */     GIR_EraseRootFromParent_Done,
     /* 118121 */   // Label 2004: @118121
     /* 118121 */   GIM_Reject,
     /* 118122 */ // Label 2002: @118122
     /* 118122 */ GIM_Reject,
     /* 118123 */ // Label 1994: @118123
     /* 118123 */ GIM_Reject,
     /* 118124 */ // Label 15: @118124
     /* 118124 */ GIM_Try, /*On fail goto*//*Label 2005*/ GIMT_Encode4(118156), // Rule ID 3929 //
     /* 118129 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 118132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 118136 */   // (readcyclecounter:{ *:[i64] })  =>  (MRS:{ *:[i64] }:{ *:[i32] } 57090:{ *:[i32] })
     /* 118136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS),
     /* 118139 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118141 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(57090),
     /* 118151 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 118154 */   GIR_RootConstrainSelectedInstOperands,
     /* 118155 */   // GIR_Coverage, 3929,
     /* 118155 */   GIR_EraseRootFromParent_Done,
     /* 118156 */ // Label 2005: @118156
     /* 118156 */ GIM_Reject,
     /* 118157 */ // Label 16: @118157
     /* 118157 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(24), /*)*//*default:*//*Label 2026*/ GIMT_Encode4(127094),
     /* 118168 */ /*GILLT_s8*//*Label 2006*/ GIMT_Encode4(118264),
     /* 118172 */ /*GILLT_s16*//*Label 2007*/ GIMT_Encode4(118440),
     /* 118176 */ /*GILLT_s32*//*Label 2008*/ GIMT_Encode4(118616),
     /* 118180 */ /*GILLT_s64*//*Label 2009*/ GIMT_Encode4(121010),
     /* 118184 */ /*GILLT_s128*//*Label 2010*/ GIMT_Encode4(123723),
     /* 118188 */ /*GILLT_v2s32*//*Label 2011*/ GIMT_Encode4(123932),
     /* 118192 */ /*GILLT_v2s64*//*Label 2012*/ GIMT_Encode4(124310),
     /* 118196 */ /*GILLT_v4s16*//*Label 2013*/ GIMT_Encode4(124688),
     /* 118200 */ /*GILLT_v4s32*//*Label 2014*/ GIMT_Encode4(125066),
     /* 118204 */ /*GILLT_v8s8*//*Label 2015*/ GIMT_Encode4(125444),
     /* 118208 */ /*GILLT_v8s16*//*Label 2016*/ GIMT_Encode4(125652),
     /* 118212 */ /*GILLT_v16s8*//*Label 2017*/ GIMT_Encode4(126030), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 118224 */ /*GILLT_nxv2s16*//*Label 2018*/ GIMT_Encode4(126238),
     /* 118228 */ /*GILLT_nxv2s32*//*Label 2019*/ GIMT_Encode4(126302),
     /* 118232 */ /*GILLT_nxv2s64*//*Label 2020*/ GIMT_Encode4(126366), GIMT_Encode4(0),
     /* 118240 */ /*GILLT_nxv4s16*//*Label 2021*/ GIMT_Encode4(126540),
     /* 118244 */ /*GILLT_nxv4s32*//*Label 2022*/ GIMT_Encode4(126604), GIMT_Encode4(0),
     /* 118252 */ /*GILLT_nxv8s16*//*Label 2023*/ GIMT_Encode4(126778),
     /* 118256 */ /*GILLT_nxv16s1*//*Label 2024*/ GIMT_Encode4(126952),
     /* 118260 */ /*GILLT_nxv16s8*//*Label 2025*/ GIMT_Encode4(126996),
     /* 118264 */ // Label 2006: @118264
     /* 118264 */ GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(118439),
     /* 118269 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118272 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 118280 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118284 */   GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(118325), // Rule ID 237 //
     /* 118289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 118299 */     // (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 118299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 118302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118323 */     GIR_RootConstrainSelectedInstOperands,
     /* 118324 */     // GIR_Coverage, 237,
     /* 118324 */     GIR_EraseRootFromParent_Done,
     /* 118325 */   // Label 2028: @118325
     /* 118325 */   GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(118366), // Rule ID 238 //
     /* 118330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 118340 */     // (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 118340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 118343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118360 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118364 */     GIR_RootConstrainSelectedInstOperands,
     /* 118365 */     // GIR_Coverage, 238,
     /* 118365 */     GIR_EraseRootFromParent_Done,
     /* 118366 */   // Label 2029: @118366
     /* 118366 */   GIM_Try, /*On fail goto*//*Label 2030*/ GIMT_Encode4(118402), // Rule ID 261 //
     /* 118371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 118381 */     // (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 118381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 118384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118396 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118400 */     GIR_RootConstrainSelectedInstOperands,
     /* 118401 */     // GIR_Coverage, 261,
     /* 118401 */     GIR_EraseRootFromParent_Done,
     /* 118402 */   // Label 2030: @118402
     /* 118402 */   GIM_Try, /*On fail goto*//*Label 2031*/ GIMT_Encode4(118438), // Rule ID 282 //
     /* 118407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 118417 */     // (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 118417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 118420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118432 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118436 */     GIR_RootConstrainSelectedInstOperands,
     /* 118437 */     // GIR_Coverage, 282,
     /* 118437 */     GIR_EraseRootFromParent_Done,
     /* 118438 */   // Label 2031: @118438
     /* 118438 */   GIM_Reject,
     /* 118439 */ // Label 2027: @118439
     /* 118439 */ GIM_Reject,
     /* 118440 */ // Label 2007: @118440
     /* 118440 */ GIM_Try, /*On fail goto*//*Label 2032*/ GIMT_Encode4(118615),
     /* 118445 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118448 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 118456 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118460 */   GIM_Try, /*On fail goto*//*Label 2033*/ GIMT_Encode4(118501), // Rule ID 239 //
     /* 118465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 118475 */     // (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHroW:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 118475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 118478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118495 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118499 */     GIR_RootConstrainSelectedInstOperands,
     /* 118500 */     // GIR_Coverage, 239,
     /* 118500 */     GIR_EraseRootFromParent_Done,
     /* 118501 */   // Label 2033: @118501
     /* 118501 */   GIM_Try, /*On fail goto*//*Label 2034*/ GIMT_Encode4(118542), // Rule ID 240 //
     /* 118506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 118516 */     // (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHroX:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 118516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 118519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118536 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118540 */     GIR_RootConstrainSelectedInstOperands,
     /* 118541 */     // GIR_Coverage, 240,
     /* 118541 */     GIR_EraseRootFromParent_Done,
     /* 118542 */   // Label 2034: @118542
     /* 118542 */   GIM_Try, /*On fail goto*//*Label 2035*/ GIMT_Encode4(118578), // Rule ID 262 //
     /* 118547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 118557 */     // (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHui:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 118557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 118560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118572 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118576 */     GIR_RootConstrainSelectedInstOperands,
     /* 118577 */     // GIR_Coverage, 262,
     /* 118577 */     GIR_EraseRootFromParent_Done,
     /* 118578 */   // Label 2035: @118578
     /* 118578 */   GIM_Try, /*On fail goto*//*Label 2036*/ GIMT_Encode4(118614), // Rule ID 283 //
     /* 118583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 118593 */     // (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURHi:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 118593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 118596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118608 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118612 */     GIR_RootConstrainSelectedInstOperands,
     /* 118613 */     // GIR_Coverage, 283,
     /* 118613 */     GIR_EraseRootFromParent_Done,
     /* 118614 */   // Label 2036: @118614
     /* 118614 */   GIM_Reject,
     /* 118615 */ // Label 2032: @118615
     /* 118615 */ GIM_Reject,
     /* 118616 */ // Label 2008: @118616
     /* 118616 */ GIM_Try, /*On fail goto*//*Label 2037*/ GIMT_Encode4(118669), // Rule ID 233 //
     /* 118621 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118624 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118632 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118636 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 118643 */   // (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 118643 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 118646 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118648 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118653 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118658 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118663 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118667 */   GIR_RootConstrainSelectedInstOperands,
     /* 118668 */   // GIR_Coverage, 233,
     /* 118668 */   GIR_EraseRootFromParent_Done,
     /* 118669 */ // Label 2037: @118669
     /* 118669 */ GIM_Try, /*On fail goto*//*Label 2038*/ GIMT_Encode4(118722), // Rule ID 234 //
     /* 118674 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118677 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118685 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118689 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 118696 */   // (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 118696 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 118699 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118701 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118706 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118711 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118716 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118720 */   GIR_RootConstrainSelectedInstOperands,
     /* 118721 */   // GIR_Coverage, 234,
     /* 118721 */   GIR_EraseRootFromParent_Done,
     /* 118722 */ // Label 2038: @118722
     /* 118722 */ GIM_Try, /*On fail goto*//*Label 2039*/ GIMT_Encode4(118778), // Rule ID 241 //
     /* 118727 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118730 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118733 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 118741 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118745 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 118752 */   // (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSroW:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 118752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 118755 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118757 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118762 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118767 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118772 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118776 */   GIR_RootConstrainSelectedInstOperands,
     /* 118777 */   // GIR_Coverage, 241,
     /* 118777 */   GIR_EraseRootFromParent_Done,
     /* 118778 */ // Label 2039: @118778
     /* 118778 */ GIM_Try, /*On fail goto*//*Label 2040*/ GIMT_Encode4(118834), // Rule ID 242 //
     /* 118783 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118786 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118789 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 118797 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118801 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 118808 */   // (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSroX:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 118808 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 118811 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118813 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118818 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118823 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118828 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118832 */   GIR_RootConstrainSelectedInstOperands,
     /* 118833 */   // GIR_Coverage, 242,
     /* 118833 */   GIR_EraseRootFromParent_Done,
     /* 118834 */ // Label 2040: @118834
     /* 118834 */ GIM_Try, /*On fail goto*//*Label 2041*/ GIMT_Encode4(118894), // Rule ID 4145 //
     /* 118839 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118842 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118846 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118857 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118861 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 118868 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 118868 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 118871 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118873 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118878 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118883 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118888 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118892 */   GIR_RootConstrainSelectedInstOperands,
     /* 118893 */   // GIR_Coverage, 4145,
     /* 118893 */   GIR_EraseRootFromParent_Done,
     /* 118894 */ // Label 2041: @118894
     /* 118894 */ GIM_Try, /*On fail goto*//*Label 2042*/ GIMT_Encode4(118954), // Rule ID 4146 //
     /* 118899 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118902 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118906 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118917 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118921 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 118928 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 118928 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 118931 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118933 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118938 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118943 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118948 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118952 */   GIR_RootConstrainSelectedInstOperands,
     /* 118953 */   // GIR_Coverage, 4146,
     /* 118953 */   GIR_EraseRootFromParent_Done,
     /* 118954 */ // Label 2042: @118954
     /* 118954 */ GIM_Try, /*On fail goto*//*Label 2043*/ GIMT_Encode4(119014), // Rule ID 4147 //
     /* 118959 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118962 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118966 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 118973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118977 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118981 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 118988 */   // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 118988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 118991 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118993 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118998 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119003 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119008 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119012 */   GIR_RootConstrainSelectedInstOperands,
     /* 119013 */   // GIR_Coverage, 4147,
     /* 119013 */   GIR_EraseRootFromParent_Done,
     /* 119014 */ // Label 2043: @119014
     /* 119014 */ GIM_Try, /*On fail goto*//*Label 2044*/ GIMT_Encode4(119074), // Rule ID 4148 //
     /* 119019 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119022 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119026 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 119033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119037 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119041 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 119048 */   // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 119048 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 119051 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119053 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119058 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119063 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119068 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119072 */   GIR_RootConstrainSelectedInstOperands,
     /* 119073 */   // GIR_Coverage, 4148,
     /* 119073 */   GIR_EraseRootFromParent_Done,
     /* 119074 */ // Label 2044: @119074
     /* 119074 */ GIM_Try, /*On fail goto*//*Label 2045*/ GIMT_Encode4(119134), // Rule ID 4149 //
     /* 119079 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119082 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119086 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 119093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119097 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119101 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 119108 */   // (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 119108 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 119111 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119113 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119118 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119123 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119128 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119132 */   GIR_RootConstrainSelectedInstOperands,
     /* 119133 */   // GIR_Coverage, 4149,
     /* 119133 */   GIR_EraseRootFromParent_Done,
     /* 119134 */ // Label 2045: @119134
     /* 119134 */ GIM_Try, /*On fail goto*//*Label 2046*/ GIMT_Encode4(119194), // Rule ID 4150 //
     /* 119139 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119142 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119146 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 119153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119157 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119161 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 119168 */   // (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 119168 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 119171 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119173 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119178 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119183 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119188 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119192 */   GIR_RootConstrainSelectedInstOperands,
     /* 119193 */   // GIR_Coverage, 4150,
     /* 119193 */   GIR_EraseRootFromParent_Done,
     /* 119194 */ // Label 2046: @119194
     /* 119194 */ GIM_Try, /*On fail goto*//*Label 2047*/ GIMT_Encode4(119242), // Rule ID 260 //
     /* 119199 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119202 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119210 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119214 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 119221 */   // (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 119221 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 119224 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119226 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119231 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119236 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119240 */   GIR_RootConstrainSelectedInstOperands,
     /* 119241 */   // GIR_Coverage, 260,
     /* 119241 */   GIR_EraseRootFromParent_Done,
     /* 119242 */ // Label 2047: @119242
     /* 119242 */ GIM_Try, /*On fail goto*//*Label 2048*/ GIMT_Encode4(119293), // Rule ID 263 //
     /* 119247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 119250 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119253 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 119261 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119265 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 119272 */   // (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSui:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 119272 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 119275 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119277 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119282 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119287 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119291 */   GIR_RootConstrainSelectedInstOperands,
     /* 119292 */   // GIR_Coverage, 263,
     /* 119292 */   GIR_EraseRootFromParent_Done,
     /* 119293 */ // Label 2048: @119293
     /* 119293 */ GIM_Try, /*On fail goto*//*Label 2049*/ GIMT_Encode4(119356), // Rule ID 7106 //
     /* 119298 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119301 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119305 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 119312 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119319 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119323 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 119330 */   // (atomic_load:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15863>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset)
     /* 119330 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 119333 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119335 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119340 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119345 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 119350 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119354 */   GIR_RootConstrainSelectedInstOperands,
     /* 119355 */   // GIR_Coverage, 7106,
     /* 119355 */   GIR_EraseRootFromParent_Done,
     /* 119356 */ // Label 2049: @119356
     /* 119356 */ GIM_Try, /*On fail goto*//*Label 2050*/ GIMT_Encode4(119419), // Rule ID 7108 //
     /* 119361 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119364 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119368 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 119375 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119382 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119386 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 119393 */   // (atomic_load:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15863>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset)
     /* 119393 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 119396 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119398 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119403 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119408 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 119413 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119417 */   GIR_RootConstrainSelectedInstOperands,
     /* 119418 */   // GIR_Coverage, 7108,
     /* 119418 */   GIR_EraseRootFromParent_Done,
     /* 119419 */ // Label 2050: @119419
     /* 119419 */ GIM_Try, /*On fail goto*//*Label 2051*/ GIMT_Encode4(119482), // Rule ID 7118 //
     /* 119424 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119427 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119431 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 119438 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119445 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119449 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 119456 */   // (atomic_load:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15871>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 119456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 119459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119461 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119466 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119471 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119476 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119480 */   GIR_RootConstrainSelectedInstOperands,
     /* 119481 */   // GIR_Coverage, 7118,
     /* 119481 */   GIR_EraseRootFromParent_Done,
     /* 119482 */ // Label 2051: @119482
     /* 119482 */ GIM_Try, /*On fail goto*//*Label 2052*/ GIMT_Encode4(119545), // Rule ID 7120 //
     /* 119487 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119490 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119494 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 119501 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119508 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119512 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 119519 */   // (atomic_load:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15871>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 119519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 119522 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119524 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119529 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119534 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119539 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119543 */   GIR_RootConstrainSelectedInstOperands,
     /* 119544 */   // GIR_Coverage, 7120,
     /* 119544 */   GIR_EraseRootFromParent_Done,
     /* 119545 */ // Label 2052: @119545
     /* 119545 */ GIM_Try, /*On fail goto*//*Label 2053*/ GIMT_Encode4(119608), // Rule ID 7128 //
     /* 119550 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119553 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119557 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 119564 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119571 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119575 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 119582 */   // (atomic_load:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15879>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 119582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 119585 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119587 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119592 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119597 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119602 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119606 */   GIR_RootConstrainSelectedInstOperands,
     /* 119607 */   // GIR_Coverage, 7128,
     /* 119607 */   GIR_EraseRootFromParent_Done,
     /* 119608 */ // Label 2053: @119608
     /* 119608 */ GIM_Try, /*On fail goto*//*Label 2054*/ GIMT_Encode4(119671), // Rule ID 7129 //
     /* 119613 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119616 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119620 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 119627 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119634 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119638 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 119645 */   // (atomic_load:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15879>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 119645 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 119648 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119650 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119655 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119660 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119665 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119669 */   GIR_RootConstrainSelectedInstOperands,
     /* 119670 */   // GIR_Coverage, 7129,
     /* 119670 */   GIR_EraseRootFromParent_Done,
     /* 119671 */ // Label 2054: @119671
     /* 119671 */ GIM_Try, /*On fail goto*//*Label 2055*/ GIMT_Encode4(119719), // Rule ID 281 //
     /* 119676 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119679 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119687 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119691 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 119698 */   // (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 119698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 119701 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119703 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119708 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119713 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119717 */   GIR_RootConstrainSelectedInstOperands,
     /* 119718 */   // GIR_Coverage, 281,
     /* 119718 */   GIR_EraseRootFromParent_Done,
     /* 119719 */ // Label 2055: @119719
     /* 119719 */ GIM_Try, /*On fail goto*//*Label 2056*/ GIMT_Encode4(119770), // Rule ID 284 //
     /* 119724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 119727 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119730 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 119738 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119742 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 119749 */   // (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURSi:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 119749 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 119752 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119754 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119759 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119764 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119768 */   GIR_RootConstrainSelectedInstOperands,
     /* 119769 */   // GIR_Coverage, 284,
     /* 119769 */   GIR_EraseRootFromParent_Done,
     /* 119770 */ // Label 2056: @119770
     /* 119770 */ GIM_Try, /*On fail goto*//*Label 2057*/ GIMT_Encode4(119825), // Rule ID 4172 //
     /* 119775 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119778 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119782 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 119789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119793 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119797 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 119804 */   // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 119804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 119807 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119809 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119814 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119819 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119823 */   GIR_RootConstrainSelectedInstOperands,
     /* 119824 */   // GIR_Coverage, 4172,
     /* 119824 */   GIR_EraseRootFromParent_Done,
     /* 119825 */ // Label 2057: @119825
     /* 119825 */ GIM_Try, /*On fail goto*//*Label 2058*/ GIMT_Encode4(119880), // Rule ID 4173 //
     /* 119830 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119833 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119837 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 119844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119848 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119852 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 119859 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 119859 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 119862 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119864 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119869 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119874 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119878 */   GIR_RootConstrainSelectedInstOperands,
     /* 119879 */   // GIR_Coverage, 4173,
     /* 119879 */   GIR_EraseRootFromParent_Done,
     /* 119880 */ // Label 2058: @119880
     /* 119880 */ GIM_Try, /*On fail goto*//*Label 2059*/ GIMT_Encode4(119935), // Rule ID 4174 //
     /* 119885 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119888 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119892 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 119899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119903 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119907 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 119914 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 119914 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 119917 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119919 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119924 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119929 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119933 */   GIR_RootConstrainSelectedInstOperands,
     /* 119934 */   // GIR_Coverage, 4174,
     /* 119934 */   GIR_EraseRootFromParent_Done,
     /* 119935 */ // Label 2059: @119935
     /* 119935 */ GIM_Try, /*On fail goto*//*Label 2060*/ GIMT_Encode4(119990), // Rule ID 4195 //
     /* 119940 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119943 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119947 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 119954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119958 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119962 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 119969 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 119969 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 119972 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119974 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119979 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119984 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119988 */   GIR_RootConstrainSelectedInstOperands,
     /* 119989 */   // GIR_Coverage, 4195,
     /* 119989 */   GIR_EraseRootFromParent_Done,
     /* 119990 */ // Label 2060: @119990
     /* 119990 */ GIM_Try, /*On fail goto*//*Label 2061*/ GIMT_Encode4(120045), // Rule ID 4196 //
     /* 119995 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119998 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120002 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 120009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120013 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120017 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 120024 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120024 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 120027 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120029 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120034 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120039 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120043 */   GIR_RootConstrainSelectedInstOperands,
     /* 120044 */   // GIR_Coverage, 4196,
     /* 120044 */   GIR_EraseRootFromParent_Done,
     /* 120045 */ // Label 2061: @120045
     /* 120045 */ GIM_Try, /*On fail goto*//*Label 2062*/ GIMT_Encode4(120100), // Rule ID 4197 //
     /* 120050 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120053 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120057 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 120064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120068 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120072 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 120079 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120079 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 120082 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120084 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120089 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120094 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120098 */   GIR_RootConstrainSelectedInstOperands,
     /* 120099 */   // GIR_Coverage, 4197,
     /* 120099 */   GIR_EraseRootFromParent_Done,
     /* 120100 */ // Label 2062: @120100
     /* 120100 */ GIM_Try, /*On fail goto*//*Label 2063*/ GIMT_Encode4(120158), // Rule ID 7110 //
     /* 120105 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120108 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120112 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 120119 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120126 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120130 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 120137 */   // (atomic_load:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15863>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 120137 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 120140 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120142 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120147 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120152 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120156 */   GIR_RootConstrainSelectedInstOperands,
     /* 120157 */   // GIR_Coverage, 7110,
     /* 120157 */   GIR_EraseRootFromParent_Done,
     /* 120158 */ // Label 2063: @120158
     /* 120158 */ GIM_Try, /*On fail goto*//*Label 2064*/ GIMT_Encode4(120216), // Rule ID 7112 //
     /* 120163 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120166 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120170 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 120177 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120184 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120188 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 120195 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15863>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120195 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 120198 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120200 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120205 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120210 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120214 */   GIR_RootConstrainSelectedInstOperands,
     /* 120215 */   // GIR_Coverage, 7112,
     /* 120215 */   GIR_EraseRootFromParent_Done,
     /* 120216 */ // Label 2064: @120216
     /* 120216 */ GIM_Try, /*On fail goto*//*Label 2065*/ GIMT_Encode4(120274), // Rule ID 7122 //
     /* 120221 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120224 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120228 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 120235 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120242 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120246 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 120253 */   // (atomic_load:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15871>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 120253 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 120256 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120258 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120263 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120268 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120272 */   GIR_RootConstrainSelectedInstOperands,
     /* 120273 */   // GIR_Coverage, 7122,
     /* 120273 */   GIR_EraseRootFromParent_Done,
     /* 120274 */ // Label 2065: @120274
     /* 120274 */ GIM_Try, /*On fail goto*//*Label 2066*/ GIMT_Encode4(120332), // Rule ID 7124 //
     /* 120279 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120282 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120286 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 120293 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120300 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120304 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 120311 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15871>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120311 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 120314 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120316 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120321 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120326 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120330 */   GIR_RootConstrainSelectedInstOperands,
     /* 120331 */   // GIR_Coverage, 7124,
     /* 120331 */   GIR_EraseRootFromParent_Done,
     /* 120332 */ // Label 2066: @120332
     /* 120332 */ GIM_Try, /*On fail goto*//*Label 2067*/ GIMT_Encode4(120390), // Rule ID 7130 //
     /* 120337 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120340 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120344 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 120351 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120358 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120362 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 120369 */   // (atomic_load:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15879>>  =>  (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 120369 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 120372 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120374 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120379 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120384 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120388 */   GIR_RootConstrainSelectedInstOperands,
     /* 120389 */   // GIR_Coverage, 7130,
     /* 120389 */   GIR_EraseRootFromParent_Done,
     /* 120390 */ // Label 2067: @120390
     /* 120390 */ GIM_Try, /*On fail goto*//*Label 2068*/ GIMT_Encode4(120448), // Rule ID 7131 //
     /* 120395 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120398 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120402 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 120409 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120416 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120420 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 120427 */   // (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15879>>  =>  (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120427 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 120430 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120432 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120437 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120442 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120446 */   GIR_RootConstrainSelectedInstOperands,
     /* 120447 */   // GIR_Coverage, 7131,
     /* 120447 */   GIR_EraseRootFromParent_Done,
     /* 120448 */ // Label 2068: @120448
     /* 120448 */ GIM_Try, /*On fail goto*//*Label 2069*/ GIMT_Encode4(120509), // Rule ID 7516 //
     /* 120453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 120456 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120459 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120463 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 120470 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120477 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120481 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 120488 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15852>>  =>  (LDAPURBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120488 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURBi),
     /* 120491 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120493 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120498 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120503 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120507 */   GIR_RootConstrainSelectedInstOperands,
     /* 120508 */   // GIR_Coverage, 7516,
     /* 120508 */   GIR_EraseRootFromParent_Done,
     /* 120509 */ // Label 2069: @120509
     /* 120509 */ GIM_Try, /*On fail goto*//*Label 2070*/ GIMT_Encode4(120570), // Rule ID 7518 //
     /* 120514 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 120517 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120520 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120524 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 120531 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120538 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120542 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 120549 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15854>>  =>  (LDAPURHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120549 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURHi),
     /* 120552 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120554 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120559 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120564 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120568 */   GIR_RootConstrainSelectedInstOperands,
     /* 120569 */   // GIR_Coverage, 7518,
     /* 120569 */   GIR_EraseRootFromParent_Done,
     /* 120570 */ // Label 2070: @120570
     /* 120570 */ GIM_Try, /*On fail goto*//*Label 2071*/ GIMT_Encode4(120631), // Rule ID 7520 //
     /* 120575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 120578 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120581 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120585 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 120592 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120599 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120603 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 120610 */   // (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15856>>  =>  (LDAPURi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120610 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURi),
     /* 120613 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120615 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120620 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120625 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120629 */   GIR_RootConstrainSelectedInstOperands,
     /* 120630 */   // GIR_Coverage, 7520,
     /* 120630 */   GIR_EraseRootFromParent_Done,
     /* 120631 */ // Label 2071: @120631
     /* 120631 */ GIM_Try, /*On fail goto*//*Label 2072*/ GIMT_Encode4(120675), // Rule ID 7096 //
     /* 120636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 120639 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120642 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120646 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 120653 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120660 */   // MIs[0] ptr
     /* 120660 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120664 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 120668 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15852>>  =>  (LDAPRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 120668 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRB),
     /* 120673 */   GIR_RootConstrainSelectedInstOperands,
     /* 120674 */   // GIR_Coverage, 7096,
     /* 120674 */   GIR_Done,
     /* 120675 */ // Label 2072: @120675
     /* 120675 */ GIM_Try, /*On fail goto*//*Label 2073*/ GIMT_Encode4(120719), // Rule ID 7098 //
     /* 120680 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 120683 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120686 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120690 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 120697 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120704 */   // MIs[0] ptr
     /* 120704 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120708 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 120712 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15854>>  =>  (LDAPRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 120712 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRH),
     /* 120717 */   GIR_RootConstrainSelectedInstOperands,
     /* 120718 */   // GIR_Coverage, 7098,
     /* 120718 */   GIR_Done,
     /* 120719 */ // Label 2073: @120719
     /* 120719 */ GIM_Try, /*On fail goto*//*Label 2074*/ GIMT_Encode4(120763), // Rule ID 7100 //
     /* 120724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 120727 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120730 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120734 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 120741 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120748 */   // MIs[0] ptr
     /* 120748 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120752 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 120756 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15856>>  =>  (LDAPRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 120756 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRW),
     /* 120761 */   GIR_RootConstrainSelectedInstOperands,
     /* 120762 */   // GIR_Coverage, 7100,
     /* 120762 */   GIR_Done,
     /* 120763 */ // Label 2074: @120763
     /* 120763 */ GIM_Try, /*On fail goto*//*Label 2075*/ GIMT_Encode4(120804), // Rule ID 7102 //
     /* 120768 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120771 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120775 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 120782 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 120785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120789 */   // MIs[0] ptr
     /* 120789 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120793 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 120797 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15860>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 120797 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 120802 */   GIR_RootConstrainSelectedInstOperands,
     /* 120803 */   // GIR_Coverage, 7102,
     /* 120803 */   GIR_Done,
     /* 120804 */ // Label 2075: @120804
     /* 120804 */ GIM_Try, /*On fail goto*//*Label 2076*/ GIMT_Encode4(120845), // Rule ID 7104 //
     /* 120809 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120812 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120816 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 120823 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120830 */   // MIs[0] ptr
     /* 120830 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 120838 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15852>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 120838 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 120843 */   GIR_RootConstrainSelectedInstOperands,
     /* 120844 */   // GIR_Coverage, 7104,
     /* 120844 */   GIR_Done,
     /* 120845 */ // Label 2076: @120845
     /* 120845 */ GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(120886), // Rule ID 7114 //
     /* 120850 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120853 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120857 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 120864 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 120867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120871 */   // MIs[0] ptr
     /* 120871 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120875 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 120879 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15868>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 120879 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 120884 */   GIR_RootConstrainSelectedInstOperands,
     /* 120885 */   // GIR_Coverage, 7114,
     /* 120885 */   GIR_Done,
     /* 120886 */ // Label 2077: @120886
     /* 120886 */ GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(120927), // Rule ID 7116 //
     /* 120891 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120894 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120898 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 120905 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120912 */   // MIs[0] ptr
     /* 120912 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120916 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 120920 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15854>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 120920 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 120925 */   GIR_RootConstrainSelectedInstOperands,
     /* 120926 */   // GIR_Coverage, 7116,
     /* 120926 */   GIR_Done,
     /* 120927 */ // Label 2078: @120927
     /* 120927 */ GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(120968), // Rule ID 7126 //
     /* 120932 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120935 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120939 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 120946 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 120949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120953 */   // MIs[0] ptr
     /* 120953 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120957 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 120961 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15876>>  =>  (LDARW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 120961 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARW),
     /* 120966 */   GIR_RootConstrainSelectedInstOperands,
     /* 120967 */   // GIR_Coverage, 7126,
     /* 120967 */   GIR_Done,
     /* 120968 */ // Label 2079: @120968
     /* 120968 */ GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(121009), // Rule ID 7127 //
     /* 120973 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120976 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120980 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 120987 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120994 */   // MIs[0] ptr
     /* 120994 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120998 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121002 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15856>>  =>  (LDARW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 121002 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARW),
     /* 121007 */   GIR_RootConstrainSelectedInstOperands,
     /* 121008 */   // GIR_Coverage, 7127,
     /* 121008 */   GIR_Done,
     /* 121009 */ // Label 2080: @121009
     /* 121009 */ GIM_Reject,
     /* 121010 */ // Label 2009: @121010
     /* 121010 */ GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(121063), // Rule ID 235 //
     /* 121015 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121018 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121026 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121030 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 121037 */   // (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 121037 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroW),
     /* 121040 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121042 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121047 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121052 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121057 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121061 */   GIR_RootConstrainSelectedInstOperands,
     /* 121062 */   // GIR_Coverage, 235,
     /* 121062 */   GIR_EraseRootFromParent_Done,
     /* 121063 */ // Label 2081: @121063
     /* 121063 */ GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(121116), // Rule ID 236 //
     /* 121068 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121071 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121079 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121083 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 121090 */   // (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 121090 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroX),
     /* 121093 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121095 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121100 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121105 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121110 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121114 */   GIR_RootConstrainSelectedInstOperands,
     /* 121115 */   // GIR_Coverage, 236,
     /* 121115 */   GIR_EraseRootFromParent_Done,
     /* 121116 */ // Label 2082: @121116
     /* 121116 */ GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(121172), // Rule ID 243 //
     /* 121121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 121124 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121127 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121135 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121139 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 121146 */   // (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 121146 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 121149 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121151 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121156 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121161 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121166 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121170 */   GIR_RootConstrainSelectedInstOperands,
     /* 121171 */   // GIR_Coverage, 243,
     /* 121171 */   GIR_EraseRootFromParent_Done,
     /* 121172 */ // Label 2083: @121172
     /* 121172 */ GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(121228), // Rule ID 244 //
     /* 121177 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 121180 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121183 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121191 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121195 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 121202 */   // (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 121202 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 121205 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121207 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121212 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121217 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121222 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121226 */   GIR_RootConstrainSelectedInstOperands,
     /* 121227 */   // GIR_Coverage, 244,
     /* 121227 */   GIR_EraseRootFromParent_Done,
     /* 121228 */ // Label 2084: @121228
     /* 121228 */ GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(121281), // Rule ID 4111 //
     /* 121233 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121236 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121244 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121248 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 121255 */   // (ld:{ *:[v1i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 121255 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 121258 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121260 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121265 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121270 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121275 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121279 */   GIR_RootConstrainSelectedInstOperands,
     /* 121280 */   // GIR_Coverage, 4111,
     /* 121280 */   GIR_EraseRootFromParent_Done,
     /* 121281 */ // Label 2085: @121281
     /* 121281 */ GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(121334), // Rule ID 4112 //
     /* 121286 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121289 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121297 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121301 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 121308 */   // (ld:{ *:[v1i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 121308 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 121311 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121313 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121318 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121323 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121328 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121332 */   GIR_RootConstrainSelectedInstOperands,
     /* 121333 */   // GIR_Coverage, 4112,
     /* 121333 */   GIR_EraseRootFromParent_Done,
     /* 121334 */ // Label 2086: @121334
     /* 121334 */ GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(121387), // Rule ID 4113 //
     /* 121339 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121342 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121350 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121354 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 121361 */   // (ld:{ *:[v1f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 121361 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 121364 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121366 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121371 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121376 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121381 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121385 */   GIR_RootConstrainSelectedInstOperands,
     /* 121386 */   // GIR_Coverage, 4113,
     /* 121386 */   GIR_EraseRootFromParent_Done,
     /* 121387 */ // Label 2087: @121387
     /* 121387 */ GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(121440), // Rule ID 4114 //
     /* 121392 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121395 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121403 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121407 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 121414 */   // (ld:{ *:[v1f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 121414 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 121417 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121419 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121424 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121429 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121434 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121438 */   GIR_RootConstrainSelectedInstOperands,
     /* 121439 */   // GIR_Coverage, 4114,
     /* 121439 */   GIR_EraseRootFromParent_Done,
     /* 121440 */ // Label 2088: @121440
     /* 121440 */ GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(121532), // Rule ID 4137 //
     /* 121445 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121448 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121452 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 121459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121463 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121467 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 121474 */   // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 121474 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121477 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 121481 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121486 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121491 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121496 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121501 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121505 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121507 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121510 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121512 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121515 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121518 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121521 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121526 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121531 */   // GIR_Coverage, 4137,
     /* 121531 */   GIR_EraseRootFromParent_Done,
     /* 121532 */ // Label 2089: @121532
     /* 121532 */ GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(121624), // Rule ID 4138 //
     /* 121537 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121540 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121544 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 121551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121555 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121559 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 121566 */   // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 121566 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121569 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 121573 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121578 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121583 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121588 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121593 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121597 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121599 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121602 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121604 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121607 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121610 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121613 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121618 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121623 */   // GIR_Coverage, 4138,
     /* 121623 */   GIR_EraseRootFromParent_Done,
     /* 121624 */ // Label 2090: @121624
     /* 121624 */ GIM_Try, /*On fail goto*//*Label 2091*/ GIMT_Encode4(121716), // Rule ID 4139 //
     /* 121629 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121632 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121636 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 121643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121647 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121651 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 121658 */   // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 121658 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121661 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 121665 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121670 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121675 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121680 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121685 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121689 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121691 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121694 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121696 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121699 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121702 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121705 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121710 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121715 */   // GIR_Coverage, 4139,
     /* 121715 */   GIR_EraseRootFromParent_Done,
     /* 121716 */ // Label 2091: @121716
     /* 121716 */ GIM_Try, /*On fail goto*//*Label 2092*/ GIMT_Encode4(121808), // Rule ID 4140 //
     /* 121721 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121724 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121728 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 121735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121739 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121743 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 121750 */   // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 121750 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121753 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 121757 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121762 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121767 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121772 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121777 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121781 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121783 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121786 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121788 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121791 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121794 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121797 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121802 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121807 */   // GIR_Coverage, 4140,
     /* 121807 */   GIR_EraseRootFromParent_Done,
     /* 121808 */ // Label 2092: @121808
     /* 121808 */ GIM_Try, /*On fail goto*//*Label 2093*/ GIMT_Encode4(121900), // Rule ID 4141 //
     /* 121813 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121816 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121820 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 121827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121831 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121835 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 121842 */   // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 121842 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121845 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 121849 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121854 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121859 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121864 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121869 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121873 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121875 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121878 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121880 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121883 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121886 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121889 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121894 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121899 */   // GIR_Coverage, 4141,
     /* 121899 */   GIR_EraseRootFromParent_Done,
     /* 121900 */ // Label 2093: @121900
     /* 121900 */ GIM_Try, /*On fail goto*//*Label 2094*/ GIMT_Encode4(121992), // Rule ID 4142 //
     /* 121905 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121908 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121912 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 121919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121923 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121927 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 121934 */   // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 121934 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121937 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 121941 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121946 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121951 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121956 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121961 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121965 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121967 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121970 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121972 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121975 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121978 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121981 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121986 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121991 */   // GIR_Coverage, 4142,
     /* 121991 */   GIR_EraseRootFromParent_Done,
     /* 121992 */ // Label 2094: @121992
     /* 121992 */ GIM_Try, /*On fail goto*//*Label 2095*/ GIMT_Encode4(122084), // Rule ID 4143 //
     /* 121997 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122000 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122004 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 122011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 122015 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122019 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 122026 */   // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 122026 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122029 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 122033 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122038 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122043 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122048 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122053 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122057 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 122059 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 122062 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122064 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122067 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122070 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 122073 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 122078 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122083 */   // GIR_Coverage, 4143,
     /* 122083 */   GIR_EraseRootFromParent_Done,
     /* 122084 */ // Label 2095: @122084
     /* 122084 */ GIM_Try, /*On fail goto*//*Label 2096*/ GIMT_Encode4(122176), // Rule ID 4144 //
     /* 122089 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122092 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122096 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 122103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 122107 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122111 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 122118 */   // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 122118 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122121 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 122125 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122130 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122135 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122140 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122145 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122149 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 122151 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 122154 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122156 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122159 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122162 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 122165 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 122170 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122175 */   // GIR_Coverage, 4144,
     /* 122175 */   GIR_EraseRootFromParent_Done,
     /* 122176 */ // Label 2096: @122176
     /* 122176 */ GIM_Try, /*On fail goto*//*Label 2097*/ GIMT_Encode4(122224), // Rule ID 259 //
     /* 122181 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122184 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122192 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122196 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 122203 */   // (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 122203 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXui),
     /* 122206 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122208 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122213 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122218 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122222 */   GIR_RootConstrainSelectedInstOperands,
     /* 122223 */   // GIR_Coverage, 259,
     /* 122223 */   GIR_EraseRootFromParent_Done,
     /* 122224 */ // Label 2097: @122224
     /* 122224 */ GIM_Try, /*On fail goto*//*Label 2098*/ GIMT_Encode4(122275), // Rule ID 264 //
     /* 122229 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 122232 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122235 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122243 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122247 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 122254 */   // (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 122254 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 122257 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122259 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122264 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122269 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122273 */   GIR_RootConstrainSelectedInstOperands,
     /* 122274 */   // GIR_Coverage, 264,
     /* 122274 */   GIR_EraseRootFromParent_Done,
     /* 122275 */ // Label 2098: @122275
     /* 122275 */ GIM_Try, /*On fail goto*//*Label 2099*/ GIMT_Encode4(122338), // Rule ID 7134 //
     /* 122280 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 122283 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122287 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 122294 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 122297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122301 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122305 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 122312 */   // (atomic_load:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15887>>  =>  (LDRXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 122312 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroW),
     /* 122315 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122317 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122322 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122327 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122332 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122336 */   GIR_RootConstrainSelectedInstOperands,
     /* 122337 */   // GIR_Coverage, 7134,
     /* 122337 */   GIR_EraseRootFromParent_Done,
     /* 122338 */ // Label 2099: @122338
     /* 122338 */ GIM_Try, /*On fail goto*//*Label 2100*/ GIMT_Encode4(122401), // Rule ID 7135 //
     /* 122343 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 122346 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122350 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 122357 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 122360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122364 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122368 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 122375 */   // (atomic_load:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15887>>  =>  (LDRXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 122375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroX),
     /* 122378 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122380 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122385 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122390 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122395 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122399 */   GIR_RootConstrainSelectedInstOperands,
     /* 122400 */   // GIR_Coverage, 7135,
     /* 122400 */   GIR_EraseRootFromParent_Done,
     /* 122401 */ // Label 2100: @122401
     /* 122401 */ GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(122449), // Rule ID 280 //
     /* 122406 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122409 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122417 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122421 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 122428 */   // (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 122428 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURXi),
     /* 122431 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122433 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122438 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122443 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122447 */   GIR_RootConstrainSelectedInstOperands,
     /* 122448 */   // GIR_Coverage, 280,
     /* 122448 */   GIR_EraseRootFromParent_Done,
     /* 122449 */ // Label 2101: @122449
     /* 122449 */ GIM_Try, /*On fail goto*//*Label 2102*/ GIMT_Encode4(122500), // Rule ID 285 //
     /* 122454 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 122457 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122460 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122468 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122472 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 122479 */   // (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 122479 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 122482 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122484 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122489 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122494 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122498 */   GIR_RootConstrainSelectedInstOperands,
     /* 122499 */   // GIR_Coverage, 285,
     /* 122499 */   GIR_EraseRootFromParent_Done,
     /* 122500 */ // Label 2102: @122500
     /* 122500 */ GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(122548), // Rule ID 4158 //
     /* 122505 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122508 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122516 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122520 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 122527 */   // (ld:{ *:[v1f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 122527 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 122530 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122532 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122537 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122542 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122546 */   GIR_RootConstrainSelectedInstOperands,
     /* 122547 */   // GIR_Coverage, 4158,
     /* 122547 */   GIR_EraseRootFromParent_Done,
     /* 122548 */ // Label 2103: @122548
     /* 122548 */ GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(122596), // Rule ID 4159 //
     /* 122553 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122556 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122564 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122568 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 122575 */   // (ld:{ *:[v1i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 122575 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 122578 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122580 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122585 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122590 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122594 */   GIR_RootConstrainSelectedInstOperands,
     /* 122595 */   // GIR_Coverage, 4159,
     /* 122595 */   GIR_EraseRootFromParent_Done,
     /* 122596 */ // Label 2104: @122596
     /* 122596 */ GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(122683), // Rule ID 4175 //
     /* 122601 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122604 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122608 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 122615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 122619 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122623 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 122630 */   // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 122630 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122633 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 122637 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122642 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122647 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122652 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122656 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 122658 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 122661 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122663 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122666 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122669 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 122672 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 122677 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122682 */   // GIR_Coverage, 4175,
     /* 122682 */   GIR_EraseRootFromParent_Done,
     /* 122683 */ // Label 2105: @122683
     /* 122683 */ GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(122770), // Rule ID 4176 //
     /* 122688 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122691 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122695 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 122702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 122706 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122710 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 122717 */   // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 122717 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122720 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 122724 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122729 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122734 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122739 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122743 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 122745 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 122748 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122750 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122753 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122756 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 122759 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 122764 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122769 */   // GIR_Coverage, 4176,
     /* 122769 */   GIR_EraseRootFromParent_Done,
     /* 122770 */ // Label 2106: @122770
     /* 122770 */ GIM_Try, /*On fail goto*//*Label 2107*/ GIMT_Encode4(122857), // Rule ID 4177 //
     /* 122775 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122778 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122782 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 122789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 122793 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122797 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 122804 */   // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 122804 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122807 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 122811 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122816 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122821 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122826 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122830 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 122832 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 122835 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122837 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122840 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122843 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 122846 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 122851 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122856 */   // GIR_Coverage, 4177,
     /* 122856 */   GIR_EraseRootFromParent_Done,
     /* 122857 */ // Label 2107: @122857
     /* 122857 */ GIM_Try, /*On fail goto*//*Label 2108*/ GIMT_Encode4(122944), // Rule ID 4178 //
     /* 122862 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122865 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122869 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 122876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 122880 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122884 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 122891 */   // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 122891 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122894 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 122898 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122903 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122908 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122913 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122917 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 122919 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 122922 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122924 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122927 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122930 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 122933 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 122938 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122943 */   // GIR_Coverage, 4178,
     /* 122943 */   GIR_EraseRootFromParent_Done,
     /* 122944 */ // Label 2108: @122944
     /* 122944 */ GIM_Try, /*On fail goto*//*Label 2109*/ GIMT_Encode4(122992), // Rule ID 4186 //
     /* 122949 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122952 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122960 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122964 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 122971 */   // (ld:{ *:[v1f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122971 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 122974 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122976 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122981 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122986 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122990 */   GIR_RootConstrainSelectedInstOperands,
     /* 122991 */   // GIR_Coverage, 4186,
     /* 122991 */   GIR_EraseRootFromParent_Done,
     /* 122992 */ // Label 2109: @122992
     /* 122992 */ GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(123040), // Rule ID 4187 //
     /* 122997 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123000 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123008 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123012 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 123019 */   // (ld:{ *:[v1i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123019 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 123022 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123024 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123029 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123034 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123038 */   GIR_RootConstrainSelectedInstOperands,
     /* 123039 */   // GIR_Coverage, 4187,
     /* 123039 */   GIR_EraseRootFromParent_Done,
     /* 123040 */ // Label 2110: @123040
     /* 123040 */ GIM_Try, /*On fail goto*//*Label 2111*/ GIMT_Encode4(123127), // Rule ID 4198 //
     /* 123045 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123048 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123052 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 123059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 123063 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123067 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 123074 */   // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 123074 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 123077 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 123081 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123086 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123091 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123096 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123100 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 123102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 123105 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123107 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123110 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123113 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 123116 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 123121 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123126 */   // GIR_Coverage, 4198,
     /* 123126 */   GIR_EraseRootFromParent_Done,
     /* 123127 */ // Label 2111: @123127
     /* 123127 */ GIM_Try, /*On fail goto*//*Label 2112*/ GIMT_Encode4(123214), // Rule ID 4199 //
     /* 123132 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123135 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123139 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 123146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 123150 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123154 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 123161 */   // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 123161 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 123164 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 123168 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123173 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123178 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123183 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123187 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 123189 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 123192 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123194 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123197 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123200 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 123203 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 123208 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123213 */   // GIR_Coverage, 4199,
     /* 123213 */   GIR_EraseRootFromParent_Done,
     /* 123214 */ // Label 2112: @123214
     /* 123214 */ GIM_Try, /*On fail goto*//*Label 2113*/ GIMT_Encode4(123301), // Rule ID 4200 //
     /* 123219 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123222 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123226 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 123233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 123237 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123241 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 123248 */   // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 123248 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 123251 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 123255 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123260 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123265 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123270 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123274 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 123276 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 123279 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123281 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123284 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123287 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 123290 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 123295 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123300 */   // GIR_Coverage, 4200,
     /* 123300 */   GIR_EraseRootFromParent_Done,
     /* 123301 */ // Label 2113: @123301
     /* 123301 */ GIM_Try, /*On fail goto*//*Label 2114*/ GIMT_Encode4(123388), // Rule ID 4201 //
     /* 123306 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123309 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123313 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 123320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 123324 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123328 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 123335 */   // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 123335 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 123338 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 123342 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123347 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123352 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123357 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123361 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 123363 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 123366 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123368 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123371 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123374 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 123377 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 123382 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123387 */   // GIR_Coverage, 4201,
     /* 123387 */   GIR_EraseRootFromParent_Done,
     /* 123388 */ // Label 2114: @123388
     /* 123388 */ GIM_Try, /*On fail goto*//*Label 2115*/ GIMT_Encode4(123446), // Rule ID 7136 //
     /* 123393 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 123396 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123400 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 123407 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 123410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123414 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123418 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 123425 */   // (atomic_load:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15887>>  =>  (LDRXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 123425 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXui),
     /* 123428 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123430 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123435 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123440 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123444 */   GIR_RootConstrainSelectedInstOperands,
     /* 123445 */   // GIR_Coverage, 7136,
     /* 123445 */   GIR_EraseRootFromParent_Done,
     /* 123446 */ // Label 2115: @123446
     /* 123446 */ GIM_Try, /*On fail goto*//*Label 2116*/ GIMT_Encode4(123504), // Rule ID 7137 //
     /* 123451 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 123454 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123458 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 123465 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 123468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123472 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123476 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 123483 */   // (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15887>>  =>  (LDURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123483 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURXi),
     /* 123486 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123488 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123493 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123498 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123502 */   GIR_RootConstrainSelectedInstOperands,
     /* 123503 */   // GIR_Coverage, 7137,
     /* 123503 */   GIR_EraseRootFromParent_Done,
     /* 123504 */ // Label 2116: @123504
     /* 123504 */ GIM_Try, /*On fail goto*//*Label 2117*/ GIMT_Encode4(123565), // Rule ID 7521 //
     /* 123509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 123512 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 123515 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123519 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 123526 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 123529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123533 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123537 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 123544 */   // (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15858>>  =>  (LDAPURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123544 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURXi),
     /* 123547 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123549 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123554 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123559 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123563 */   GIR_RootConstrainSelectedInstOperands,
     /* 123564 */   // GIR_Coverage, 7521,
     /* 123564 */   GIR_EraseRootFromParent_Done,
     /* 123565 */ // Label 2117: @123565
     /* 123565 */ GIM_Try, /*On fail goto*//*Label 2118*/ GIMT_Encode4(123596), // Rule ID 6463 //
     /* 123570 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123573 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123581 */   // MIs[0] Rn
     /* 123581 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123589 */   // (ld:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 123589 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev1d),
     /* 123594 */   GIR_RootConstrainSelectedInstOperands,
     /* 123595 */   // GIR_Coverage, 6463,
     /* 123595 */   GIR_Done,
     /* 123596 */ // Label 2118: @123596
     /* 123596 */ GIM_Try, /*On fail goto*//*Label 2119*/ GIMT_Encode4(123640), // Rule ID 7101 //
     /* 123601 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 123604 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 123607 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123611 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 123618 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 123621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123625 */   // MIs[0] ptr
     /* 123625 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123629 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123633 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15858>>  =>  (LDAPRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 123633 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRX),
     /* 123638 */   GIR_RootConstrainSelectedInstOperands,
     /* 123639 */   // GIR_Coverage, 7101,
     /* 123639 */   GIR_Done,
     /* 123640 */ // Label 2119: @123640
     /* 123640 */ GIM_Try, /*On fail goto*//*Label 2120*/ GIMT_Encode4(123681), // Rule ID 7132 //
     /* 123645 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 123648 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123652 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 123659 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 123662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123666 */   // MIs[0] ptr
     /* 123666 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123670 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123674 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15884>>  =>  (LDARX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 123674 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARX),
     /* 123679 */   GIR_RootConstrainSelectedInstOperands,
     /* 123680 */   // GIR_Coverage, 7132,
     /* 123680 */   GIR_Done,
     /* 123681 */ // Label 2120: @123681
     /* 123681 */ GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(123722), // Rule ID 7133 //
     /* 123686 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 123689 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123693 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 123700 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 123703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123707 */   // MIs[0] ptr
     /* 123707 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123715 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15858>>  =>  (LDARX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 123715 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARX),
     /* 123720 */   GIR_RootConstrainSelectedInstOperands,
     /* 123721 */   // GIR_Coverage, 7133,
     /* 123721 */   GIR_Done,
     /* 123722 */ // Label 2121: @123722
     /* 123722 */ GIM_Reject,
     /* 123723 */ // Label 2010: @123723
     /* 123723 */ GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(123931),
     /* 123728 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123731 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123739 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123743 */   GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(123784), // Rule ID 245 //
     /* 123748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 123751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 123758 */     // (ld:{ *:[f128] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 123758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 123761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123778 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123782 */     GIR_RootConstrainSelectedInstOperands,
     /* 123783 */     // GIR_Coverage, 245,
     /* 123783 */     GIR_EraseRootFromParent_Done,
     /* 123784 */   // Label 2123: @123784
     /* 123784 */   GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(123825), // Rule ID 246 //
     /* 123789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 123792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 123799 */     // (ld:{ *:[f128] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 123799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 123802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123819 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123823 */     GIR_RootConstrainSelectedInstOperands,
     /* 123824 */     // GIR_Coverage, 246,
     /* 123824 */     GIR_EraseRootFromParent_Done,
     /* 123825 */   // Label 2124: @123825
     /* 123825 */   GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(123861), // Rule ID 265 //
     /* 123830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 123833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 123840 */     // (ld:{ *:[f128] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 123840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 123843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123855 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123859 */     GIR_RootConstrainSelectedInstOperands,
     /* 123860 */     // GIR_Coverage, 265,
     /* 123860 */     GIR_EraseRootFromParent_Done,
     /* 123861 */   // Label 2125: @123861
     /* 123861 */   GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(123897), // Rule ID 286 //
     /* 123866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 123869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 123876 */     // (ld:{ *:[f128] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 123876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 123879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123891 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123895 */     GIR_RootConstrainSelectedInstOperands,
     /* 123896 */     // GIR_Coverage, 286,
     /* 123896 */     GIR_EraseRootFromParent_Done,
     /* 123897 */   // Label 2126: @123897
     /* 123897 */   GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(123930), // Rule ID 4167 //
     /* 123902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 123909 */     // (ld:{ *:[f128] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 123909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 123912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123928 */     GIR_RootConstrainSelectedInstOperands,
     /* 123929 */     // GIR_Coverage, 4167,
     /* 123929 */     GIR_EraseRootFromParent_Done,
     /* 123930 */   // Label 2127: @123930
     /* 123930 */   GIM_Reject,
     /* 123931 */ // Label 2122: @123931
     /* 123931 */ GIM_Reject,
     /* 123932 */ // Label 2011: @123932
     /* 123932 */ GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(124309),
     /* 123937 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123940 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123948 */   GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(123993), // Rule ID 4101 //
     /* 123953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123956 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 123967 */     // (ld:{ *:[v2i32] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 123967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 123970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123987 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123991 */     GIR_RootConstrainSelectedInstOperands,
     /* 123992 */     // GIR_Coverage, 4101,
     /* 123992 */     GIR_EraseRootFromParent_Done,
     /* 123993 */   // Label 2129: @123993
     /* 123993 */   GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(124038), // Rule ID 4102 //
     /* 123998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124001 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 124012 */     // (ld:{ *:[v2i32] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 124012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 124015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124032 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124036 */     GIR_RootConstrainSelectedInstOperands,
     /* 124037 */     // GIR_Coverage, 4102,
     /* 124037 */     GIR_EraseRootFromParent_Done,
     /* 124038 */   // Label 2130: @124038
     /* 124038 */   GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(124083), // Rule ID 4103 //
     /* 124043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124046 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 124057 */     // (ld:{ *:[v2f32] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 124057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 124060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124077 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124081 */     GIR_RootConstrainSelectedInstOperands,
     /* 124082 */     // GIR_Coverage, 4103,
     /* 124082 */     GIR_EraseRootFromParent_Done,
     /* 124083 */   // Label 2131: @124083
     /* 124083 */   GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(124128), // Rule ID 4104 //
     /* 124088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124091 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 124102 */     // (ld:{ *:[v2f32] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 124102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 124105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124122 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124126 */     GIR_RootConstrainSelectedInstOperands,
     /* 124127 */     // GIR_Coverage, 4104,
     /* 124127 */     GIR_EraseRootFromParent_Done,
     /* 124128 */   // Label 2132: @124128
     /* 124128 */   GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(124168), // Rule ID 4153 //
     /* 124133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124136 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 124147 */     // (ld:{ *:[v2f32] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 124147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 124150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124166 */     GIR_RootConstrainSelectedInstOperands,
     /* 124167 */     // GIR_Coverage, 4153,
     /* 124167 */     GIR_EraseRootFromParent_Done,
     /* 124168 */   // Label 2133: @124168
     /* 124168 */   GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(124208), // Rule ID 4156 //
     /* 124173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124176 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 124187 */     // (ld:{ *:[v2i32] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 124187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 124190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124202 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124206 */     GIR_RootConstrainSelectedInstOperands,
     /* 124207 */     // GIR_Coverage, 4156,
     /* 124207 */     GIR_EraseRootFromParent_Done,
     /* 124208 */   // Label 2134: @124208
     /* 124208 */   GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(124248), // Rule ID 4181 //
     /* 124213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124216 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 124227 */     // (ld:{ *:[v2f32] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 124230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124242 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124246 */     GIR_RootConstrainSelectedInstOperands,
     /* 124247 */     // GIR_Coverage, 4181,
     /* 124247 */     GIR_EraseRootFromParent_Done,
     /* 124248 */   // Label 2135: @124248
     /* 124248 */   GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(124288), // Rule ID 4182 //
     /* 124253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124256 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 124267 */     // (ld:{ *:[v2i32] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 124270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124282 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124286 */     GIR_RootConstrainSelectedInstOperands,
     /* 124287 */     // GIR_Coverage, 4182,
     /* 124287 */     GIR_EraseRootFromParent_Done,
     /* 124288 */   // Label 2136: @124288
     /* 124288 */   GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(124308), // Rule ID 6462 //
     /* 124293 */     // MIs[0] Rn
     /* 124293 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124297 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124301 */     // (ld:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 124301 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev2s),
     /* 124306 */     GIR_RootConstrainSelectedInstOperands,
     /* 124307 */     // GIR_Coverage, 6462,
     /* 124307 */     GIR_Done,
     /* 124308 */   // Label 2137: @124308
     /* 124308 */   GIM_Reject,
     /* 124309 */ // Label 2128: @124309
     /* 124309 */ GIM_Reject,
     /* 124310 */ // Label 2012: @124310
     /* 124310 */ GIM_Try, /*On fail goto*//*Label 2138*/ GIMT_Encode4(124687),
     /* 124315 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124318 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124326 */   GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(124371), // Rule ID 4115 //
     /* 124331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124334 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 124345 */     // (ld:{ *:[v2i64] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 124345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 124348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124365 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124369 */     GIR_RootConstrainSelectedInstOperands,
     /* 124370 */     // GIR_Coverage, 4115,
     /* 124370 */     GIR_EraseRootFromParent_Done,
     /* 124371 */   // Label 2139: @124371
     /* 124371 */   GIM_Try, /*On fail goto*//*Label 2140*/ GIMT_Encode4(124416), // Rule ID 4116 //
     /* 124376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124379 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 124390 */     // (ld:{ *:[v2i64] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 124390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 124393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124410 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124414 */     GIR_RootConstrainSelectedInstOperands,
     /* 124415 */     // GIR_Coverage, 4116,
     /* 124415 */     GIR_EraseRootFromParent_Done,
     /* 124416 */   // Label 2140: @124416
     /* 124416 */   GIM_Try, /*On fail goto*//*Label 2141*/ GIMT_Encode4(124461), // Rule ID 4117 //
     /* 124421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124424 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 124435 */     // (ld:{ *:[v2f64] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 124435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 124438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124459 */     GIR_RootConstrainSelectedInstOperands,
     /* 124460 */     // GIR_Coverage, 4117,
     /* 124460 */     GIR_EraseRootFromParent_Done,
     /* 124461 */   // Label 2141: @124461
     /* 124461 */   GIM_Try, /*On fail goto*//*Label 2142*/ GIMT_Encode4(124506), // Rule ID 4118 //
     /* 124466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124469 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 124480 */     // (ld:{ *:[v2f64] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 124480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 124483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124500 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124504 */     GIR_RootConstrainSelectedInstOperands,
     /* 124505 */     // GIR_Coverage, 4118,
     /* 124505 */     GIR_EraseRootFromParent_Done,
     /* 124506 */   // Label 2142: @124506
     /* 124506 */   GIM_Try, /*On fail goto*//*Label 2143*/ GIMT_Encode4(124546), // Rule ID 4161 //
     /* 124511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124514 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 124525 */     // (ld:{ *:[v2f64] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 124525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 124528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124540 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124544 */     GIR_RootConstrainSelectedInstOperands,
     /* 124545 */     // GIR_Coverage, 4161,
     /* 124545 */     GIR_EraseRootFromParent_Done,
     /* 124546 */   // Label 2143: @124546
     /* 124546 */   GIM_Try, /*On fail goto*//*Label 2144*/ GIMT_Encode4(124586), // Rule ID 4165 //
     /* 124551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124554 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 124565 */     // (ld:{ *:[v2i64] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 124565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 124568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124580 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124584 */     GIR_RootConstrainSelectedInstOperands,
     /* 124585 */     // GIR_Coverage, 4165,
     /* 124585 */     GIR_EraseRootFromParent_Done,
     /* 124586 */   // Label 2144: @124586
     /* 124586 */   GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(124626), // Rule ID 4188 //
     /* 124591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124594 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 124605 */     // (ld:{ *:[v2f64] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 124608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124620 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124624 */     GIR_RootConstrainSelectedInstOperands,
     /* 124625 */     // GIR_Coverage, 4188,
     /* 124625 */     GIR_EraseRootFromParent_Done,
     /* 124626 */   // Label 2145: @124626
     /* 124626 */   GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(124666), // Rule ID 4189 //
     /* 124631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124634 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 124645 */     // (ld:{ *:[v2i64] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 124648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124660 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124664 */     GIR_RootConstrainSelectedInstOperands,
     /* 124665 */     // GIR_Coverage, 4189,
     /* 124665 */     GIR_EraseRootFromParent_Done,
     /* 124666 */   // Label 2146: @124666
     /* 124666 */   GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(124686), // Rule ID 6459 //
     /* 124671 */     // MIs[0] Rn
     /* 124671 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124679 */     // (ld:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 124679 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev2d),
     /* 124684 */     GIR_RootConstrainSelectedInstOperands,
     /* 124685 */     // GIR_Coverage, 6459,
     /* 124685 */     GIR_Done,
     /* 124686 */   // Label 2147: @124686
     /* 124686 */   GIM_Reject,
     /* 124687 */ // Label 2138: @124687
     /* 124687 */ GIM_Reject,
     /* 124688 */ // Label 2013: @124688
     /* 124688 */ GIM_Try, /*On fail goto*//*Label 2148*/ GIMT_Encode4(125065),
     /* 124693 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124696 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 124704 */   GIM_Try, /*On fail goto*//*Label 2149*/ GIMT_Encode4(124749), // Rule ID 4107 //
     /* 124709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124712 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 124723 */     // (ld:{ *:[v4i16] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 124723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 124726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124743 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124747 */     GIR_RootConstrainSelectedInstOperands,
     /* 124748 */     // GIR_Coverage, 4107,
     /* 124748 */     GIR_EraseRootFromParent_Done,
     /* 124749 */   // Label 2149: @124749
     /* 124749 */   GIM_Try, /*On fail goto*//*Label 2150*/ GIMT_Encode4(124794), // Rule ID 4108 //
     /* 124754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124757 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 124768 */     // (ld:{ *:[v4i16] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 124768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 124771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124788 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124792 */     GIR_RootConstrainSelectedInstOperands,
     /* 124793 */     // GIR_Coverage, 4108,
     /* 124793 */     GIR_EraseRootFromParent_Done,
     /* 124794 */   // Label 2150: @124794
     /* 124794 */   GIM_Try, /*On fail goto*//*Label 2151*/ GIMT_Encode4(124839), // Rule ID 4109 //
     /* 124799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124802 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 124813 */     // (ld:{ *:[v4f16] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 124813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 124816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124833 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124837 */     GIR_RootConstrainSelectedInstOperands,
     /* 124838 */     // GIR_Coverage, 4109,
     /* 124838 */     GIR_EraseRootFromParent_Done,
     /* 124839 */   // Label 2151: @124839
     /* 124839 */   GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(124884), // Rule ID 4110 //
     /* 124844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124847 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 124858 */     // (ld:{ *:[v4f16] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 124858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 124861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124878 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124882 */     GIR_RootConstrainSelectedInstOperands,
     /* 124883 */     // GIR_Coverage, 4110,
     /* 124883 */     GIR_EraseRootFromParent_Done,
     /* 124884 */   // Label 2152: @124884
     /* 124884 */   GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(124924), // Rule ID 4155 //
     /* 124889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124892 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 124903 */     // (ld:{ *:[v4i16] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 124903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 124906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124918 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124922 */     GIR_RootConstrainSelectedInstOperands,
     /* 124923 */     // GIR_Coverage, 4155,
     /* 124923 */     GIR_EraseRootFromParent_Done,
     /* 124924 */   // Label 2153: @124924
     /* 124924 */   GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(124964), // Rule ID 4157 //
     /* 124929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124932 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 124943 */     // (ld:{ *:[v4f16] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 124943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 124946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124958 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124962 */     GIR_RootConstrainSelectedInstOperands,
     /* 124963 */     // GIR_Coverage, 4157,
     /* 124963 */     GIR_EraseRootFromParent_Done,
     /* 124964 */   // Label 2154: @124964
     /* 124964 */   GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(125004), // Rule ID 4183 //
     /* 124969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124972 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 124983 */     // (ld:{ *:[v4i16] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 124986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124998 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125002 */     GIR_RootConstrainSelectedInstOperands,
     /* 125003 */     // GIR_Coverage, 4183,
     /* 125003 */     GIR_EraseRootFromParent_Done,
     /* 125004 */   // Label 2155: @125004
     /* 125004 */   GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(125044), // Rule ID 4185 //
     /* 125009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125012 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 125023 */     // (ld:{ *:[v4f16] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 125023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 125026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125038 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125042 */     GIR_RootConstrainSelectedInstOperands,
     /* 125043 */     // GIR_Coverage, 4185,
     /* 125043 */     GIR_EraseRootFromParent_Done,
     /* 125044 */   // Label 2156: @125044
     /* 125044 */   GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(125064), // Rule ID 6461 //
     /* 125049 */     // MIs[0] Rn
     /* 125049 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125057 */     // (ld:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 125057 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev4h),
     /* 125062 */     GIR_RootConstrainSelectedInstOperands,
     /* 125063 */     // GIR_Coverage, 6461,
     /* 125063 */     GIR_Done,
     /* 125064 */   // Label 2157: @125064
     /* 125064 */   GIM_Reject,
     /* 125065 */ // Label 2148: @125065
     /* 125065 */ GIM_Reject,
     /* 125066 */ // Label 2014: @125066
     /* 125066 */ GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(125443),
     /* 125071 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125074 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 125082 */   GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(125127), // Rule ID 4119 //
     /* 125087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125090 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 125101 */     // (ld:{ *:[v4i32] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 125101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 125104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125121 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125125 */     GIR_RootConstrainSelectedInstOperands,
     /* 125126 */     // GIR_Coverage, 4119,
     /* 125126 */     GIR_EraseRootFromParent_Done,
     /* 125127 */   // Label 2159: @125127
     /* 125127 */   GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(125172), // Rule ID 4120 //
     /* 125132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125135 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 125146 */     // (ld:{ *:[v4i32] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 125146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 125149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125166 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125170 */     GIR_RootConstrainSelectedInstOperands,
     /* 125171 */     // GIR_Coverage, 4120,
     /* 125171 */     GIR_EraseRootFromParent_Done,
     /* 125172 */   // Label 2160: @125172
     /* 125172 */   GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(125217), // Rule ID 4121 //
     /* 125177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125180 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 125191 */     // (ld:{ *:[v4f32] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 125191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 125194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125211 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125215 */     GIR_RootConstrainSelectedInstOperands,
     /* 125216 */     // GIR_Coverage, 4121,
     /* 125216 */     GIR_EraseRootFromParent_Done,
     /* 125217 */   // Label 2161: @125217
     /* 125217 */   GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(125262), // Rule ID 4122 //
     /* 125222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125225 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 125236 */     // (ld:{ *:[v4f32] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 125236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 125239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125256 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125260 */     GIR_RootConstrainSelectedInstOperands,
     /* 125261 */     // GIR_Coverage, 4122,
     /* 125261 */     GIR_EraseRootFromParent_Done,
     /* 125262 */   // Label 2162: @125262
     /* 125262 */   GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(125302), // Rule ID 4160 //
     /* 125267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125270 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 125281 */     // (ld:{ *:[v4f32] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 125281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 125284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125300 */     GIR_RootConstrainSelectedInstOperands,
     /* 125301 */     // GIR_Coverage, 4160,
     /* 125301 */     GIR_EraseRootFromParent_Done,
     /* 125302 */   // Label 2163: @125302
     /* 125302 */   GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(125342), // Rule ID 4164 //
     /* 125307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125310 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 125321 */     // (ld:{ *:[v4i32] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 125321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 125324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125336 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125340 */     GIR_RootConstrainSelectedInstOperands,
     /* 125341 */     // GIR_Coverage, 4164,
     /* 125341 */     GIR_EraseRootFromParent_Done,
     /* 125342 */   // Label 2164: @125342
     /* 125342 */   GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(125382), // Rule ID 4190 //
     /* 125347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125350 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 125361 */     // (ld:{ *:[v4f32] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 125361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 125364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125380 */     GIR_RootConstrainSelectedInstOperands,
     /* 125381 */     // GIR_Coverage, 4190,
     /* 125381 */     GIR_EraseRootFromParent_Done,
     /* 125382 */   // Label 2165: @125382
     /* 125382 */   GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(125422), // Rule ID 4191 //
     /* 125387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125390 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 125401 */     // (ld:{ *:[v4i32] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 125401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 125404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125420 */     GIR_RootConstrainSelectedInstOperands,
     /* 125421 */     // GIR_Coverage, 4191,
     /* 125421 */     GIR_EraseRootFromParent_Done,
     /* 125422 */   // Label 2166: @125422
     /* 125422 */   GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(125442), // Rule ID 6458 //
     /* 125427 */     // MIs[0] Rn
     /* 125427 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125435 */     // (ld:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 125435 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev4s),
     /* 125440 */     GIR_RootConstrainSelectedInstOperands,
     /* 125441 */     // GIR_Coverage, 6458,
     /* 125441 */     GIR_Done,
     /* 125442 */   // Label 2167: @125442
     /* 125442 */   GIM_Reject,
     /* 125443 */ // Label 2158: @125443
     /* 125443 */ GIM_Reject,
     /* 125444 */ // Label 2015: @125444
     /* 125444 */ GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(125651),
     /* 125449 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125452 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 125460 */   GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(125505), // Rule ID 4105 //
     /* 125465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125468 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 125479 */     // (ld:{ *:[v8i8] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 125479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 125482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125499 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125503 */     GIR_RootConstrainSelectedInstOperands,
     /* 125504 */     // GIR_Coverage, 4105,
     /* 125504 */     GIR_EraseRootFromParent_Done,
     /* 125505 */   // Label 2169: @125505
     /* 125505 */   GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(125550), // Rule ID 4106 //
     /* 125510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125513 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 125524 */     // (ld:{ *:[v8i8] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 125524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 125527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125544 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125548 */     GIR_RootConstrainSelectedInstOperands,
     /* 125549 */     // GIR_Coverage, 4106,
     /* 125549 */     GIR_EraseRootFromParent_Done,
     /* 125550 */   // Label 2170: @125550
     /* 125550 */   GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(125590), // Rule ID 4154 //
     /* 125555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125558 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 125569 */     // (ld:{ *:[v8i8] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 125569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 125572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125584 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125588 */     GIR_RootConstrainSelectedInstOperands,
     /* 125589 */     // GIR_Coverage, 4154,
     /* 125589 */     GIR_EraseRootFromParent_Done,
     /* 125590 */   // Label 2171: @125590
     /* 125590 */   GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(125630), // Rule ID 4184 //
     /* 125595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125598 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 125609 */     // (ld:{ *:[v8i8] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 125609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 125612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125624 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125628 */     GIR_RootConstrainSelectedInstOperands,
     /* 125629 */     // GIR_Coverage, 4184,
     /* 125629 */     GIR_EraseRootFromParent_Done,
     /* 125630 */   // Label 2172: @125630
     /* 125630 */   GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(125650), // Rule ID 6460 //
     /* 125635 */     // MIs[0] Rn
     /* 125635 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125643 */     // (ld:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 125643 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev8b),
     /* 125648 */     GIR_RootConstrainSelectedInstOperands,
     /* 125649 */     // GIR_Coverage, 6460,
     /* 125649 */     GIR_Done,
     /* 125650 */   // Label 2173: @125650
     /* 125650 */   GIM_Reject,
     /* 125651 */ // Label 2168: @125651
     /* 125651 */ GIM_Reject,
     /* 125652 */ // Label 2016: @125652
     /* 125652 */ GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(126029),
     /* 125657 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125660 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 125668 */   GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(125713), // Rule ID 4123 //
     /* 125673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125676 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 125687 */     // (ld:{ *:[v8i16] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 125687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 125690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125711 */     GIR_RootConstrainSelectedInstOperands,
     /* 125712 */     // GIR_Coverage, 4123,
     /* 125712 */     GIR_EraseRootFromParent_Done,
     /* 125713 */   // Label 2175: @125713
     /* 125713 */   GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(125758), // Rule ID 4124 //
     /* 125718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125721 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 125732 */     // (ld:{ *:[v8i16] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 125732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 125735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125752 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125756 */     GIR_RootConstrainSelectedInstOperands,
     /* 125757 */     // GIR_Coverage, 4124,
     /* 125757 */     GIR_EraseRootFromParent_Done,
     /* 125758 */   // Label 2176: @125758
     /* 125758 */   GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(125803), // Rule ID 4125 //
     /* 125763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125766 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 125777 */     // (ld:{ *:[v8f16] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 125777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 125780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125797 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125801 */     GIR_RootConstrainSelectedInstOperands,
     /* 125802 */     // GIR_Coverage, 4125,
     /* 125802 */     GIR_EraseRootFromParent_Done,
     /* 125803 */   // Label 2177: @125803
     /* 125803 */   GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(125848), // Rule ID 4126 //
     /* 125808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125811 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 125822 */     // (ld:{ *:[v8f16] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 125822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 125825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125842 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125846 */     GIR_RootConstrainSelectedInstOperands,
     /* 125847 */     // GIR_Coverage, 4126,
     /* 125847 */     GIR_EraseRootFromParent_Done,
     /* 125848 */   // Label 2178: @125848
     /* 125848 */   GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(125888), // Rule ID 4163 //
     /* 125853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125856 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 125867 */     // (ld:{ *:[v8i16] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 125867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 125870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125882 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125886 */     GIR_RootConstrainSelectedInstOperands,
     /* 125887 */     // GIR_Coverage, 4163,
     /* 125887 */     GIR_EraseRootFromParent_Done,
     /* 125888 */   // Label 2179: @125888
     /* 125888 */   GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(125928), // Rule ID 4166 //
     /* 125893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125896 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 125907 */     // (ld:{ *:[v8f16] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 125907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 125910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125922 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125926 */     GIR_RootConstrainSelectedInstOperands,
     /* 125927 */     // GIR_Coverage, 4166,
     /* 125927 */     GIR_EraseRootFromParent_Done,
     /* 125928 */   // Label 2180: @125928
     /* 125928 */   GIM_Try, /*On fail goto*//*Label 2181*/ GIMT_Encode4(125968), // Rule ID 4192 //
     /* 125933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125936 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 125947 */     // (ld:{ *:[v8i16] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 125947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 125950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125962 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125966 */     GIR_RootConstrainSelectedInstOperands,
     /* 125967 */     // GIR_Coverage, 4192,
     /* 125967 */     GIR_EraseRootFromParent_Done,
     /* 125968 */   // Label 2181: @125968
     /* 125968 */   GIM_Try, /*On fail goto*//*Label 2182*/ GIMT_Encode4(126008), // Rule ID 4194 //
     /* 125973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125976 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 125987 */     // (ld:{ *:[v8f16] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 125987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 125990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126002 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126006 */     GIR_RootConstrainSelectedInstOperands,
     /* 126007 */     // GIR_Coverage, 4194,
     /* 126007 */     GIR_EraseRootFromParent_Done,
     /* 126008 */   // Label 2182: @126008
     /* 126008 */   GIM_Try, /*On fail goto*//*Label 2183*/ GIMT_Encode4(126028), // Rule ID 6457 //
     /* 126013 */     // MIs[0] Rn
     /* 126013 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126021 */     // (ld:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 126021 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev8h),
     /* 126026 */     GIR_RootConstrainSelectedInstOperands,
     /* 126027 */     // GIR_Coverage, 6457,
     /* 126027 */     GIR_Done,
     /* 126028 */   // Label 2183: @126028
     /* 126028 */   GIM_Reject,
     /* 126029 */ // Label 2174: @126029
     /* 126029 */ GIM_Reject,
     /* 126030 */ // Label 2017: @126030
     /* 126030 */ GIM_Try, /*On fail goto*//*Label 2184*/ GIMT_Encode4(126237),
     /* 126035 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126038 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 126042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 126046 */   GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(126091), // Rule ID 4127 //
     /* 126051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 126054 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 126065 */     // (ld:{ *:[v16i8] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 126065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 126068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126085 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126089 */     GIR_RootConstrainSelectedInstOperands,
     /* 126090 */     // GIR_Coverage, 4127,
     /* 126090 */     GIR_EraseRootFromParent_Done,
     /* 126091 */   // Label 2185: @126091
     /* 126091 */   GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(126136), // Rule ID 4128 //
     /* 126096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 126099 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 126110 */     // (ld:{ *:[v16i8] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 126110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 126113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126130 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126134 */     GIR_RootConstrainSelectedInstOperands,
     /* 126135 */     // GIR_Coverage, 4128,
     /* 126135 */     GIR_EraseRootFromParent_Done,
     /* 126136 */   // Label 2186: @126136
     /* 126136 */   GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(126176), // Rule ID 4162 //
     /* 126141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 126144 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 126155 */     // (ld:{ *:[v16i8] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 126155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 126158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126170 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126174 */     GIR_RootConstrainSelectedInstOperands,
     /* 126175 */     // GIR_Coverage, 4162,
     /* 126175 */     GIR_EraseRootFromParent_Done,
     /* 126176 */   // Label 2187: @126176
     /* 126176 */   GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(126216), // Rule ID 4193 //
     /* 126181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 126184 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 126195 */     // (ld:{ *:[v16i8] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 126195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 126198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126210 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126214 */     GIR_RootConstrainSelectedInstOperands,
     /* 126215 */     // GIR_Coverage, 4193,
     /* 126215 */     GIR_EraseRootFromParent_Done,
     /* 126216 */   // Label 2188: @126216
     /* 126216 */   GIM_Try, /*On fail goto*//*Label 2189*/ GIMT_Encode4(126236), // Rule ID 6456 //
     /* 126221 */     // MIs[0] Rn
     /* 126221 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126229 */     // (ld:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 126229 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev16b),
     /* 126234 */     GIR_RootConstrainSelectedInstOperands,
     /* 126235 */     // GIR_Coverage, 6456,
     /* 126235 */     GIR_Done,
     /* 126236 */   // Label 2189: @126236
     /* 126236 */   GIM_Reject,
     /* 126237 */ // Label 2184: @126237
     /* 126237 */ GIM_Reject,
     /* 126238 */ // Label 2018: @126238
     /* 126238 */ GIM_Try, /*On fail goto*//*Label 2190*/ GIMT_Encode4(126301), // Rule ID 11071 //
     /* 126243 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 126246 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126249 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 126253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 126257 */   // MIs[0] base
     /* 126257 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126261 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126265 */   // (ld:{ *:[nxv2f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_D_IMM:{ *:[nxv2f16] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126265 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 126268 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 126272 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126277 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 126280 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126282 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_D_IMM),
     /* 126285 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126287 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126290 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126292 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126295 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126299 */   GIR_RootConstrainSelectedInstOperands,
     /* 126300 */   // GIR_Coverage, 11071,
     /* 126300 */   GIR_EraseRootFromParent_Done,
     /* 126301 */ // Label 2190: @126301
     /* 126301 */ GIM_Reject,
     /* 126302 */ // Label 2019: @126302
     /* 126302 */ GIM_Try, /*On fail goto*//*Label 2191*/ GIMT_Encode4(126365), // Rule ID 11077 //
     /* 126307 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 126310 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126313 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 126317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 126321 */   // MIs[0] base
     /* 126321 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126325 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126329 */   // (ld:{ *:[nxv2f32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_D_IMM:{ *:[nxv2f32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126329 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 126332 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 126336 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126341 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 126344 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126346 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_D_IMM),
     /* 126349 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126351 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126354 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126356 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126359 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126363 */   GIR_RootConstrainSelectedInstOperands,
     /* 126364 */   // GIR_Coverage, 11077,
     /* 126364 */   GIR_EraseRootFromParent_Done,
     /* 126365 */ // Label 2191: @126365
     /* 126365 */ GIM_Reject,
     /* 126366 */ // Label 2020: @126366
     /* 126366 */ GIM_Try, /*On fail goto*//*Label 2192*/ GIMT_Encode4(126539),
     /* 126371 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126374 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 126378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 126382 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126386 */   GIM_Try, /*On fail goto*//*Label 2193*/ GIMT_Encode4(126434), // Rule ID 11062 //
     /* 126391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 126394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126398 */     // (ld:{ *:[nxv2i64] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1D_IMM:{ *:[nxv2i64] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 126401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 126405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126410 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 126413 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_IMM),
     /* 126418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126423 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126428 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126432 */     GIR_RootConstrainSelectedInstOperands,
     /* 126433 */     // GIR_Coverage, 11062,
     /* 126433 */     GIR_EraseRootFromParent_Done,
     /* 126434 */   // Label 2193: @126434
     /* 126434 */   GIM_Try, /*On fail goto*//*Label 2194*/ GIMT_Encode4(126482), // Rule ID 11080 //
     /* 126439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 126442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126446 */     // (ld:{ *:[nxv2f64] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1D_IMM:{ *:[nxv2f64] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126446 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 126449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 126453 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126458 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 126461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_IMM),
     /* 126466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126468 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126471 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126480 */     GIR_RootConstrainSelectedInstOperands,
     /* 126481 */     // GIR_Coverage, 11080,
     /* 126481 */     GIR_EraseRootFromParent_Done,
     /* 126482 */   // Label 2194: @126482
     /* 126482 */   GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(126510), // Rule ID 11107 //
     /* 126487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 126490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126494 */     // (ld:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 126497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126499 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126504 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126508 */     GIR_RootConstrainSelectedInstOperands,
     /* 126509 */     // GIR_Coverage, 11107,
     /* 126509 */     GIR_EraseRootFromParent_Done,
     /* 126510 */   // Label 2195: @126510
     /* 126510 */   GIM_Try, /*On fail goto*//*Label 2196*/ GIMT_Encode4(126538), // Rule ID 11119 //
     /* 126515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 126518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126522 */     // (ld:{ *:[nxv2f64] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv2f64] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 126525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126527 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126532 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126536 */     GIR_RootConstrainSelectedInstOperands,
     /* 126537 */     // GIR_Coverage, 11119,
     /* 126537 */     GIR_EraseRootFromParent_Done,
     /* 126538 */   // Label 2196: @126538
     /* 126538 */   GIM_Reject,
     /* 126539 */ // Label 2192: @126539
     /* 126539 */ GIM_Reject,
     /* 126540 */ // Label 2021: @126540
     /* 126540 */ GIM_Try, /*On fail goto*//*Label 2197*/ GIMT_Encode4(126603), // Rule ID 11068 //
     /* 126545 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 126548 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126551 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 126555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 126559 */   // MIs[0] base
     /* 126559 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126563 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126567 */   // (ld:{ *:[nxv4f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_S_IMM:{ *:[nxv4f16] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126567 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 126570 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 126574 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126579 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 126582 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126584 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_S_IMM),
     /* 126587 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126589 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126592 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126594 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126597 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126601 */   GIR_RootConstrainSelectedInstOperands,
     /* 126602 */   // GIR_Coverage, 11068,
     /* 126602 */   GIR_EraseRootFromParent_Done,
     /* 126603 */ // Label 2197: @126603
     /* 126603 */ GIM_Reject,
     /* 126604 */ // Label 2022: @126604
     /* 126604 */ GIM_Try, /*On fail goto*//*Label 2198*/ GIMT_Encode4(126777),
     /* 126609 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126612 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 126616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 126620 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126624 */   GIM_Try, /*On fail goto*//*Label 2199*/ GIMT_Encode4(126672), // Rule ID 11050 //
     /* 126629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 126632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126636 */     // (ld:{ *:[nxv4i32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_IMM:{ *:[nxv4i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 126639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 126643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126648 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 126651 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_IMM),
     /* 126656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126661 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126666 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126670 */     GIR_RootConstrainSelectedInstOperands,
     /* 126671 */     // GIR_Coverage, 11050,
     /* 126671 */     GIR_EraseRootFromParent_Done,
     /* 126672 */   // Label 2199: @126672
     /* 126672 */   GIM_Try, /*On fail goto*//*Label 2200*/ GIMT_Encode4(126720), // Rule ID 11074 //
     /* 126677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 126680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126684 */     // (ld:{ *:[nxv4f32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_IMM:{ *:[nxv4f32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 126687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 126691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126696 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 126699 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_IMM),
     /* 126704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126706 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126709 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126714 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126718 */     GIR_RootConstrainSelectedInstOperands,
     /* 126719 */     // GIR_Coverage, 11074,
     /* 126719 */     GIR_EraseRootFromParent_Done,
     /* 126720 */   // Label 2200: @126720
     /* 126720 */   GIM_Try, /*On fail goto*//*Label 2201*/ GIMT_Encode4(126748), // Rule ID 11103 //
     /* 126725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 126728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126732 */     // (ld:{ *:[nxv4i32] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv4i32] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 126735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126737 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126742 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126746 */     GIR_RootConstrainSelectedInstOperands,
     /* 126747 */     // GIR_Coverage, 11103,
     /* 126747 */     GIR_EraseRootFromParent_Done,
     /* 126748 */   // Label 2201: @126748
     /* 126748 */   GIM_Try, /*On fail goto*//*Label 2202*/ GIMT_Encode4(126776), // Rule ID 11115 //
     /* 126753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 126756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126760 */     // (ld:{ *:[nxv4f32] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv4f32] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 126763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126765 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126770 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126774 */     GIR_RootConstrainSelectedInstOperands,
     /* 126775 */     // GIR_Coverage, 11115,
     /* 126775 */     GIR_EraseRootFromParent_Done,
     /* 126776 */   // Label 2202: @126776
     /* 126776 */   GIM_Reject,
     /* 126777 */ // Label 2198: @126777
     /* 126777 */ GIM_Reject,
     /* 126778 */ // Label 2023: @126778
     /* 126778 */ GIM_Try, /*On fail goto*//*Label 2203*/ GIMT_Encode4(126951),
     /* 126783 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126786 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 126790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 126794 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126798 */   GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(126846), // Rule ID 11029 //
     /* 126803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 126806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126810 */     // (ld:{ *:[nxv8i16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_IMM:{ *:[nxv8i16] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126810 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 126813 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 126817 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126822 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 126825 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_IMM),
     /* 126830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126832 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126835 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126840 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126844 */     GIR_RootConstrainSelectedInstOperands,
     /* 126845 */     // GIR_Coverage, 11029,
     /* 126845 */     GIR_EraseRootFromParent_Done,
     /* 126846 */   // Label 2204: @126846
     /* 126846 */   GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(126894), // Rule ID 11065 //
     /* 126851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 126854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126858 */     // (ld:{ *:[nxv8f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_IMM:{ *:[nxv8f16] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 126861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 126865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126870 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 126873 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_IMM),
     /* 126878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126880 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126883 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126888 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126892 */     GIR_RootConstrainSelectedInstOperands,
     /* 126893 */     // GIR_Coverage, 11065,
     /* 126893 */     GIR_EraseRootFromParent_Done,
     /* 126894 */   // Label 2205: @126894
     /* 126894 */   GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(126922), // Rule ID 11099 //
     /* 126899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 126902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126906 */     // (ld:{ *:[nxv8i16] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv8i16] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 126909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126911 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126916 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126920 */     GIR_RootConstrainSelectedInstOperands,
     /* 126921 */     // GIR_Coverage, 11099,
     /* 126921 */     GIR_EraseRootFromParent_Done,
     /* 126922 */   // Label 2206: @126922
     /* 126922 */   GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(126950), // Rule ID 11111 //
     /* 126927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 126930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126934 */     // (ld:{ *:[nxv8f16] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv8f16] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 126937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126939 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126944 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126948 */     GIR_RootConstrainSelectedInstOperands,
     /* 126949 */     // GIR_Coverage, 11111,
     /* 126949 */     GIR_EraseRootFromParent_Done,
     /* 126950 */   // Label 2207: @126950
     /* 126950 */   GIM_Reject,
     /* 126951 */ // Label 2203: @126951
     /* 126951 */ GIM_Reject,
     /* 126952 */ // Label 2024: @126952
     /* 126952 */ GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(126995), // Rule ID 2431 //
     /* 126957 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 126960 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126963 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 126967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 126971 */   // MIs[0] base
     /* 126971 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126975 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126979 */   // (ld:{ *:[nxv16i1] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_PXI:{ *:[nxv16i1] } GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126979 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_PXI),
     /* 126982 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pt]
     /* 126984 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126986 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126989 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126993 */   GIR_RootConstrainSelectedInstOperands,
     /* 126994 */   // GIR_Coverage, 2431,
     /* 126994 */   GIR_EraseRootFromParent_Done,
     /* 126995 */ // Label 2208: @126995
     /* 126995 */ GIM_Reject,
     /* 126996 */ // Label 2025: @126996
     /* 126996 */ GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(127093),
     /* 127001 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127004 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 127008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 127012 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127016 */   GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(127064), // Rule ID 10997 //
     /* 127021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 127024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127028 */     // (ld:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1B_IMM:{ *:[nxv16i8] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 127028 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 127031 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 127035 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127040 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 127043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1B_IMM),
     /* 127048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 127050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127053 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 127055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127058 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127062 */     GIR_RootConstrainSelectedInstOperands,
     /* 127063 */     // GIR_Coverage, 10997,
     /* 127063 */     GIR_EraseRootFromParent_Done,
     /* 127064 */   // Label 2210: @127064
     /* 127064 */   GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(127092), // Rule ID 11095 //
     /* 127069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 127072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127076 */     // (ld:{ *:[nxv16i8] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv16i8] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 127076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 127079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 127081 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 127083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127086 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127090 */     GIR_RootConstrainSelectedInstOperands,
     /* 127091 */     // GIR_Coverage, 11095,
     /* 127091 */     GIR_EraseRootFromParent_Done,
     /* 127092 */   // Label 2211: @127092
     /* 127092 */   GIM_Reject,
     /* 127093 */ // Label 2209: @127093
     /* 127093 */ GIM_Reject,
     /* 127094 */ // Label 2026: @127094
     /* 127094 */ GIM_Reject,
     /* 127095 */ // Label 17: @127095
     /* 127095 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2214*/ GIMT_Encode4(128144),
     /* 127106 */ /*GILLT_s32*//*Label 2212*/ GIMT_Encode4(127114),
     /* 127110 */ /*GILLT_s64*//*Label 2213*/ GIMT_Encode4(127528),
     /* 127114 */ // Label 2212: @127114
     /* 127114 */ GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(127527),
     /* 127119 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127122 */   GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(127175), // Rule ID 247 //
     /* 127127 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127138 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 127149 */     // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 127149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWroW),
     /* 127152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 127169 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127173 */     GIR_RootConstrainSelectedInstOperands,
     /* 127174 */     // GIR_Coverage, 247,
     /* 127174 */     GIR_EraseRootFromParent_Done,
     /* 127175 */   // Label 2216: @127175
     /* 127175 */   GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(127228), // Rule ID 248 //
     /* 127180 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127191 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 127202 */     // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 127202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWroX),
     /* 127205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 127222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127226 */     GIR_RootConstrainSelectedInstOperands,
     /* 127227 */     // GIR_Coverage, 248,
     /* 127227 */     GIR_EraseRootFromParent_Done,
     /* 127228 */   // Label 2217: @127228
     /* 127228 */   GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(127281), // Rule ID 251 //
     /* 127233 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127244 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 127255 */     // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 127255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWroW),
     /* 127258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 127275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127279 */     GIR_RootConstrainSelectedInstOperands,
     /* 127280 */     // GIR_Coverage, 251,
     /* 127280 */     GIR_EraseRootFromParent_Done,
     /* 127281 */   // Label 2218: @127281
     /* 127281 */   GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(127334), // Rule ID 252 //
     /* 127286 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127297 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 127308 */     // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 127308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWroX),
     /* 127311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 127328 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127332 */     GIR_RootConstrainSelectedInstOperands,
     /* 127333 */     // GIR_Coverage, 252,
     /* 127333 */     GIR_EraseRootFromParent_Done,
     /* 127334 */   // Label 2219: @127334
     /* 127334 */   GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(127382), // Rule ID 268 //
     /* 127339 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127350 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 127361 */     // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 127361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWui),
     /* 127364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127380 */     GIR_RootConstrainSelectedInstOperands,
     /* 127381 */     // GIR_Coverage, 268,
     /* 127381 */     GIR_EraseRootFromParent_Done,
     /* 127382 */   // Label 2220: @127382
     /* 127382 */   GIM_Try, /*On fail goto*//*Label 2221*/ GIMT_Encode4(127430), // Rule ID 270 //
     /* 127387 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127398 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 127409 */     // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 127409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWui),
     /* 127412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127424 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127428 */     GIR_RootConstrainSelectedInstOperands,
     /* 127429 */     // GIR_Coverage, 270,
     /* 127429 */     GIR_EraseRootFromParent_Done,
     /* 127430 */   // Label 2221: @127430
     /* 127430 */   GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(127478), // Rule ID 289 //
     /* 127435 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127446 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 127457 */     // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDURSHWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 127457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSHWi),
     /* 127460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127472 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127476 */     GIR_RootConstrainSelectedInstOperands,
     /* 127477 */     // GIR_Coverage, 289,
     /* 127477 */     GIR_EraseRootFromParent_Done,
     /* 127478 */   // Label 2222: @127478
     /* 127478 */   GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(127526), // Rule ID 291 //
     /* 127483 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127494 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 127505 */     // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDURSBWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 127505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSBWi),
     /* 127508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127520 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127524 */     GIR_RootConstrainSelectedInstOperands,
     /* 127525 */     // GIR_Coverage, 291,
     /* 127525 */     GIR_EraseRootFromParent_Done,
     /* 127526 */   // Label 2223: @127526
     /* 127526 */   GIM_Reject,
     /* 127527 */ // Label 2215: @127527
     /* 127527 */ GIM_Reject,
     /* 127528 */ // Label 2213: @127528
     /* 127528 */ GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(128143),
     /* 127533 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127536 */   GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(127589), // Rule ID 249 //
     /* 127541 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127552 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 127563 */     // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 127563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXroW),
     /* 127566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 127583 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127587 */     GIR_RootConstrainSelectedInstOperands,
     /* 127588 */     // GIR_Coverage, 249,
     /* 127588 */     GIR_EraseRootFromParent_Done,
     /* 127589 */   // Label 2225: @127589
     /* 127589 */   GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(127642), // Rule ID 250 //
     /* 127594 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127605 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 127616 */     // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 127616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXroX),
     /* 127619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 127636 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127640 */     GIR_RootConstrainSelectedInstOperands,
     /* 127641 */     // GIR_Coverage, 250,
     /* 127641 */     GIR_EraseRootFromParent_Done,
     /* 127642 */   // Label 2226: @127642
     /* 127642 */   GIM_Try, /*On fail goto*//*Label 2227*/ GIMT_Encode4(127695), // Rule ID 253 //
     /* 127647 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127658 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 127669 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 127669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXroW),
     /* 127672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 127689 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127693 */     GIR_RootConstrainSelectedInstOperands,
     /* 127694 */     // GIR_Coverage, 253,
     /* 127694 */     GIR_EraseRootFromParent_Done,
     /* 127695 */   // Label 2227: @127695
     /* 127695 */   GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(127748), // Rule ID 254 //
     /* 127700 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127711 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 127722 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 127722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXroX),
     /* 127725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 127742 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127746 */     GIR_RootConstrainSelectedInstOperands,
     /* 127747 */     // GIR_Coverage, 254,
     /* 127747 */     GIR_EraseRootFromParent_Done,
     /* 127748 */   // Label 2228: @127748
     /* 127748 */   GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(127801), // Rule ID 255 //
     /* 127753 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127764 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 127775 */     // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 127775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWroW),
     /* 127778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 127795 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127799 */     GIR_RootConstrainSelectedInstOperands,
     /* 127800 */     // GIR_Coverage, 255,
     /* 127800 */     GIR_EraseRootFromParent_Done,
     /* 127801 */   // Label 2229: @127801
     /* 127801 */   GIM_Try, /*On fail goto*//*Label 2230*/ GIMT_Encode4(127854), // Rule ID 256 //
     /* 127806 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127817 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 127828 */     // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 127828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWroX),
     /* 127831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 127848 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127852 */     GIR_RootConstrainSelectedInstOperands,
     /* 127853 */     // GIR_Coverage, 256,
     /* 127853 */     GIR_EraseRootFromParent_Done,
     /* 127854 */   // Label 2230: @127854
     /* 127854 */   GIM_Try, /*On fail goto*//*Label 2231*/ GIMT_Encode4(127902), // Rule ID 269 //
     /* 127859 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127870 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 127881 */     // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 127881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXui),
     /* 127884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127900 */     GIR_RootConstrainSelectedInstOperands,
     /* 127901 */     // GIR_Coverage, 269,
     /* 127901 */     GIR_EraseRootFromParent_Done,
     /* 127902 */   // Label 2231: @127902
     /* 127902 */   GIM_Try, /*On fail goto*//*Label 2232*/ GIMT_Encode4(127950), // Rule ID 271 //
     /* 127907 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127918 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 127929 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 127929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXui),
     /* 127932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127944 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127948 */     GIR_RootConstrainSelectedInstOperands,
     /* 127949 */     // GIR_Coverage, 271,
     /* 127949 */     GIR_EraseRootFromParent_Done,
     /* 127950 */   // Label 2232: @127950
     /* 127950 */   GIM_Try, /*On fail goto*//*Label 2233*/ GIMT_Encode4(127998), // Rule ID 272 //
     /* 127955 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127966 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 127977 */     // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 127977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWui),
     /* 127980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127992 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127996 */     GIR_RootConstrainSelectedInstOperands,
     /* 127997 */     // GIR_Coverage, 272,
     /* 127997 */     GIR_EraseRootFromParent_Done,
     /* 127998 */   // Label 2233: @127998
     /* 127998 */   GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(128046), // Rule ID 290 //
     /* 128003 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128014 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 128025 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDURSHXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 128025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSHXi),
     /* 128028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128040 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128044 */     GIR_RootConstrainSelectedInstOperands,
     /* 128045 */     // GIR_Coverage, 290,
     /* 128045 */     GIR_EraseRootFromParent_Done,
     /* 128046 */   // Label 2234: @128046
     /* 128046 */   GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(128094), // Rule ID 292 //
     /* 128051 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128062 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 128073 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDURSBXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 128073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSBXi),
     /* 128076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128088 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128092 */     GIR_RootConstrainSelectedInstOperands,
     /* 128093 */     // GIR_Coverage, 292,
     /* 128093 */     GIR_EraseRootFromParent_Done,
     /* 128094 */   // Label 2235: @128094
     /* 128094 */   GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(128142), // Rule ID 293 //
     /* 128099 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128110 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 128121 */     // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDURSWi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 128121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSWi),
     /* 128124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128140 */     GIR_RootConstrainSelectedInstOperands,
     /* 128141 */     // GIR_Coverage, 293,
     /* 128141 */     GIR_EraseRootFromParent_Done,
     /* 128142 */   // Label 2236: @128142
     /* 128142 */   GIM_Reject,
     /* 128143 */ // Label 2224: @128143
     /* 128143 */ GIM_Reject,
     /* 128144 */ // Label 2214: @128144
     /* 128144 */ GIM_Reject,
     /* 128145 */ // Label 18: @128145
     /* 128145 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2239*/ GIMT_Encode4(131193),
     /* 128156 */ /*GILLT_s32*//*Label 2237*/ GIMT_Encode4(128164),
     /* 128160 */ /*GILLT_s64*//*Label 2238*/ GIMT_Encode4(129703),
     /* 128164 */ // Label 2237: @128164
     /* 128164 */ GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(128220), // Rule ID 229 //
     /* 128169 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128172 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128183 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128187 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 128194 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 128194 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 128197 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128199 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128204 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128209 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128214 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128218 */   GIR_RootConstrainSelectedInstOperands,
     /* 128219 */   // GIR_Coverage, 229,
     /* 128219 */   GIR_EraseRootFromParent_Done,
     /* 128220 */ // Label 2240: @128220
     /* 128220 */ GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(128276), // Rule ID 230 //
     /* 128225 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128228 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128239 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128243 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 128250 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 128250 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 128253 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128255 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128260 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128265 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128270 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128274 */   GIR_RootConstrainSelectedInstOperands,
     /* 128275 */   // GIR_Coverage, 230,
     /* 128275 */   GIR_EraseRootFromParent_Done,
     /* 128276 */ // Label 2241: @128276
     /* 128276 */ GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(128332), // Rule ID 231 //
     /* 128281 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128284 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128295 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128299 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 128306 */   // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 128306 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 128309 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128311 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128316 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128321 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128326 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128330 */   GIR_RootConstrainSelectedInstOperands,
     /* 128331 */   // GIR_Coverage, 231,
     /* 128331 */   GIR_EraseRootFromParent_Done,
     /* 128332 */ // Label 2242: @128332
     /* 128332 */ GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(128388), // Rule ID 232 //
     /* 128337 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128340 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128351 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128355 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 128362 */   // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 128362 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 128365 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128367 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128372 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128377 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128382 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128386 */   GIR_RootConstrainSelectedInstOperands,
     /* 128387 */   // GIR_Coverage, 232,
     /* 128387 */   GIR_EraseRootFromParent_Done,
     /* 128388 */ // Label 2243: @128388
     /* 128388 */ GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(128444), // Rule ID 4151 //
     /* 128393 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128396 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128407 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128411 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 128418 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 128418 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 128421 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128423 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128428 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128433 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128438 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128442 */   GIR_RootConstrainSelectedInstOperands,
     /* 128443 */   // GIR_Coverage, 4151,
     /* 128443 */   GIR_EraseRootFromParent_Done,
     /* 128444 */ // Label 2244: @128444
     /* 128444 */ GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(128500), // Rule ID 4152 //
     /* 128449 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128452 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128463 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128467 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 128474 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 128474 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 128477 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128479 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128484 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128489 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128494 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128498 */   GIR_RootConstrainSelectedInstOperands,
     /* 128499 */   // GIR_Coverage, 4152,
     /* 128499 */   GIR_EraseRootFromParent_Done,
     /* 128500 */ // Label 2245: @128500
     /* 128500 */ GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(128551), // Rule ID 266 //
     /* 128505 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128508 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128519 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128523 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 128530 */   // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 128530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 128533 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128535 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128540 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128545 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128549 */   GIR_RootConstrainSelectedInstOperands,
     /* 128550 */   // GIR_Coverage, 266,
     /* 128550 */   GIR_EraseRootFromParent_Done,
     /* 128551 */ // Label 2246: @128551
     /* 128551 */ GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(128602), // Rule ID 267 //
     /* 128556 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128559 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128570 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128574 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 128581 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 128581 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 128584 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128586 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128591 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128596 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128600 */   GIR_RootConstrainSelectedInstOperands,
     /* 128601 */   // GIR_Coverage, 267,
     /* 128601 */   GIR_EraseRootFromParent_Done,
     /* 128602 */ // Label 2247: @128602
     /* 128602 */ GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(128661), // Rule ID 7107 //
     /* 128607 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 128610 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128617 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128624 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128628 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 128635 */   // (atomic_load:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15863>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset)
     /* 128635 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 128638 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128640 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128645 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128650 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 128655 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128659 */   GIR_RootConstrainSelectedInstOperands,
     /* 128660 */   // GIR_Coverage, 7107,
     /* 128660 */   GIR_EraseRootFromParent_Done,
     /* 128661 */ // Label 2248: @128661
     /* 128661 */ GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(128720), // Rule ID 7109 //
     /* 128666 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 128669 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128676 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128683 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128687 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 128694 */   // (atomic_load:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15863>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset)
     /* 128694 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 128697 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128699 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128704 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128709 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 128714 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128718 */   GIR_RootConstrainSelectedInstOperands,
     /* 128719 */   // GIR_Coverage, 7109,
     /* 128719 */   GIR_EraseRootFromParent_Done,
     /* 128720 */ // Label 2249: @128720
     /* 128720 */ GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(128779), // Rule ID 7119 //
     /* 128725 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 128728 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128735 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128742 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128746 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 128753 */   // (atomic_load:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15871>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 128753 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 128756 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128758 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128763 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128768 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128773 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128777 */   GIR_RootConstrainSelectedInstOperands,
     /* 128778 */   // GIR_Coverage, 7119,
     /* 128778 */   GIR_EraseRootFromParent_Done,
     /* 128779 */ // Label 2250: @128779
     /* 128779 */ GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(128838), // Rule ID 7121 //
     /* 128784 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 128787 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128794 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128801 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128805 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 128812 */   // (atomic_load:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15871>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 128812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 128815 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128817 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128822 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128827 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128832 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128836 */   GIR_RootConstrainSelectedInstOperands,
     /* 128837 */   // GIR_Coverage, 7121,
     /* 128837 */   GIR_EraseRootFromParent_Done,
     /* 128838 */ // Label 2251: @128838
     /* 128838 */ GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(128889), // Rule ID 287 //
     /* 128843 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128846 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128857 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128861 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 128868 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 128868 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 128871 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128873 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128878 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128883 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128887 */   GIR_RootConstrainSelectedInstOperands,
     /* 128888 */   // GIR_Coverage, 287,
     /* 128888 */   GIR_EraseRootFromParent_Done,
     /* 128889 */ // Label 2252: @128889
     /* 128889 */ GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(128940), // Rule ID 288 //
     /* 128894 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128897 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128908 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128912 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 128919 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 128919 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 128922 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128924 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128929 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128934 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128938 */   GIR_RootConstrainSelectedInstOperands,
     /* 128939 */   // GIR_Coverage, 288,
     /* 128939 */   GIR_EraseRootFromParent_Done,
     /* 128940 */ // Label 2253: @128940
     /* 128940 */ GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(128991), // Rule ID 4170 //
     /* 128945 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128948 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128959 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128963 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 128970 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 128970 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 128973 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128975 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128980 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128985 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128989 */   GIR_RootConstrainSelectedInstOperands,
     /* 128990 */   // GIR_Coverage, 4170,
     /* 128990 */   GIR_EraseRootFromParent_Done,
     /* 128991 */ // Label 2254: @128991
     /* 128991 */ GIM_Try, /*On fail goto*//*Label 2255*/ GIMT_Encode4(129042), // Rule ID 4202 //
     /* 128996 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128999 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129010 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129014 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 129021 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 129021 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 129024 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129026 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129031 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129036 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129040 */   GIR_RootConstrainSelectedInstOperands,
     /* 129041 */   // GIR_Coverage, 4202,
     /* 129041 */   GIR_EraseRootFromParent_Done,
     /* 129042 */ // Label 2255: @129042
     /* 129042 */ GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(129093), // Rule ID 4203 //
     /* 129047 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129050 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129061 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129065 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 129072 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 129072 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 129075 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129077 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129082 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129087 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129091 */   GIR_RootConstrainSelectedInstOperands,
     /* 129092 */   // GIR_Coverage, 4203,
     /* 129092 */   GIR_EraseRootFromParent_Done,
     /* 129093 */ // Label 2256: @129093
     /* 129093 */ GIM_Try, /*On fail goto*//*Label 2257*/ GIMT_Encode4(129144), // Rule ID 4204 //
     /* 129098 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129101 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129112 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129116 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 129123 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 129123 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 129126 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129128 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129133 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129138 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129142 */   GIR_RootConstrainSelectedInstOperands,
     /* 129143 */   // GIR_Coverage, 4204,
     /* 129143 */   GIR_EraseRootFromParent_Done,
     /* 129144 */ // Label 2257: @129144
     /* 129144 */ GIM_Try, /*On fail goto*//*Label 2258*/ GIMT_Encode4(129198), // Rule ID 7111 //
     /* 129149 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 129152 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129159 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129166 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129170 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 129177 */   // (atomic_load:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15863>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 129177 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 129180 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129182 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129187 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129192 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129196 */   GIR_RootConstrainSelectedInstOperands,
     /* 129197 */   // GIR_Coverage, 7111,
     /* 129197 */   GIR_EraseRootFromParent_Done,
     /* 129198 */ // Label 2258: @129198
     /* 129198 */ GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(129252), // Rule ID 7113 //
     /* 129203 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 129206 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129213 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129220 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129224 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 129231 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15863>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 129231 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 129234 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129236 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129241 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129246 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129250 */   GIR_RootConstrainSelectedInstOperands,
     /* 129251 */   // GIR_Coverage, 7113,
     /* 129251 */   GIR_EraseRootFromParent_Done,
     /* 129252 */ // Label 2259: @129252
     /* 129252 */ GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(129306), // Rule ID 7123 //
     /* 129257 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 129260 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129267 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129274 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129278 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 129285 */   // (atomic_load:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15871>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 129285 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 129288 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129290 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129295 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129300 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129304 */   GIR_RootConstrainSelectedInstOperands,
     /* 129305 */   // GIR_Coverage, 7123,
     /* 129305 */   GIR_EraseRootFromParent_Done,
     /* 129306 */ // Label 2260: @129306
     /* 129306 */ GIM_Try, /*On fail goto*//*Label 2261*/ GIMT_Encode4(129360), // Rule ID 7125 //
     /* 129311 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 129314 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129321 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129328 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129332 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 129339 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15871>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 129339 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 129342 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129344 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129349 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129354 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129358 */   GIR_RootConstrainSelectedInstOperands,
     /* 129359 */   // GIR_Coverage, 7125,
     /* 129359 */   GIR_EraseRootFromParent_Done,
     /* 129360 */ // Label 2261: @129360
     /* 129360 */ GIM_Try, /*On fail goto*//*Label 2262*/ GIMT_Encode4(129417), // Rule ID 7517 //
     /* 129365 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 129368 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 129371 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129378 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129385 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129389 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 129396 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15852>>  =>  (LDAPURBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 129396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURBi),
     /* 129399 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129401 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129406 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129411 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129415 */   GIR_RootConstrainSelectedInstOperands,
     /* 129416 */   // GIR_Coverage, 7517,
     /* 129416 */   GIR_EraseRootFromParent_Done,
     /* 129417 */ // Label 2262: @129417
     /* 129417 */ GIM_Try, /*On fail goto*//*Label 2263*/ GIMT_Encode4(129474), // Rule ID 7519 //
     /* 129422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 129425 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 129428 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129435 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129442 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129446 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 129453 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15854>>  =>  (LDAPURHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 129453 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURHi),
     /* 129456 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129458 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129463 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129468 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129472 */   GIR_RootConstrainSelectedInstOperands,
     /* 129473 */   // GIR_Coverage, 7519,
     /* 129473 */   GIR_EraseRootFromParent_Done,
     /* 129474 */ // Label 2263: @129474
     /* 129474 */ GIM_Try, /*On fail goto*//*Label 2264*/ GIMT_Encode4(129514), // Rule ID 7097 //
     /* 129479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 129482 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 129485 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129492 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129499 */   // MIs[0] ptr
     /* 129499 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129503 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129507 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15852>>  =>  (LDAPRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 129507 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRB),
     /* 129512 */   GIR_RootConstrainSelectedInstOperands,
     /* 129513 */   // GIR_Coverage, 7097,
     /* 129513 */   GIR_Done,
     /* 129514 */ // Label 2264: @129514
     /* 129514 */ GIM_Try, /*On fail goto*//*Label 2265*/ GIMT_Encode4(129554), // Rule ID 7099 //
     /* 129519 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 129522 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 129525 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129532 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129539 */   // MIs[0] ptr
     /* 129539 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129543 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129547 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15854>>  =>  (LDAPRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 129547 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRH),
     /* 129552 */   GIR_RootConstrainSelectedInstOperands,
     /* 129553 */   // GIR_Coverage, 7099,
     /* 129553 */   GIR_Done,
     /* 129554 */ // Label 2265: @129554
     /* 129554 */ GIM_Try, /*On fail goto*//*Label 2266*/ GIMT_Encode4(129591), // Rule ID 7103 //
     /* 129559 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 129562 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129569 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 129572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129576 */   // MIs[0] ptr
     /* 129576 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129584 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15860>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 129584 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 129589 */   GIR_RootConstrainSelectedInstOperands,
     /* 129590 */   // GIR_Coverage, 7103,
     /* 129590 */   GIR_Done,
     /* 129591 */ // Label 2266: @129591
     /* 129591 */ GIM_Try, /*On fail goto*//*Label 2267*/ GIMT_Encode4(129628), // Rule ID 7105 //
     /* 129596 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 129599 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129606 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129613 */   // MIs[0] ptr
     /* 129613 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129617 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129621 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15852>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 129621 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 129626 */   GIR_RootConstrainSelectedInstOperands,
     /* 129627 */   // GIR_Coverage, 7105,
     /* 129627 */   GIR_Done,
     /* 129628 */ // Label 2267: @129628
     /* 129628 */ GIM_Try, /*On fail goto*//*Label 2268*/ GIMT_Encode4(129665), // Rule ID 7115 //
     /* 129633 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 129636 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129643 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 129646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129650 */   // MIs[0] ptr
     /* 129650 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129654 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129658 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15868>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 129658 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 129663 */   GIR_RootConstrainSelectedInstOperands,
     /* 129664 */   // GIR_Coverage, 7115,
     /* 129664 */   GIR_Done,
     /* 129665 */ // Label 2268: @129665
     /* 129665 */ GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(129702), // Rule ID 7117 //
     /* 129670 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 129673 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129680 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129687 */   // MIs[0] ptr
     /* 129687 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129691 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129695 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15854>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 129695 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 129700 */   GIR_RootConstrainSelectedInstOperands,
     /* 129701 */   // GIR_Coverage, 7117,
     /* 129701 */   GIR_Done,
     /* 129702 */ // Label 2269: @129702
     /* 129702 */ GIM_Reject,
     /* 129703 */ // Label 2238: @129703
     /* 129703 */ GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(131192),
     /* 129708 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129711 */   GIM_Try, /*On fail goto*//*Label 2271*/ GIMT_Encode4(129796), // Rule ID 4129 //
     /* 129716 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129727 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 129738 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 129738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 129745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 129760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 129765 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129769 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 129774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129779 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 129785 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129790 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129795 */     // GIR_Coverage, 4129,
     /* 129795 */     GIR_EraseRootFromParent_Done,
     /* 129796 */   // Label 2271: @129796
     /* 129796 */   GIM_Try, /*On fail goto*//*Label 2272*/ GIMT_Encode4(129881), // Rule ID 4130 //
     /* 129801 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129812 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 129823 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 129823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 129830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 129845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 129850 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 129859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 129870 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129875 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129880 */     // GIR_Coverage, 4130,
     /* 129880 */     GIR_EraseRootFromParent_Done,
     /* 129881 */   // Label 2272: @129881
     /* 129881 */   GIM_Try, /*On fail goto*//*Label 2273*/ GIMT_Encode4(129966), // Rule ID 4131 //
     /* 129886 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129897 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 129908 */     // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 129908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 129915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 129930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 129935 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129939 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 129944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129949 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 129955 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129960 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129965 */     // GIR_Coverage, 4131,
     /* 129965 */     GIR_EraseRootFromParent_Done,
     /* 129966 */   // Label 2273: @129966
     /* 129966 */   GIM_Try, /*On fail goto*//*Label 2274*/ GIMT_Encode4(130051), // Rule ID 4132 //
     /* 129971 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129982 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 129993 */     // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 129993 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129996 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 130000 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 130015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 130020 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130024 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 130029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130034 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 130040 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130045 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130050 */     // GIR_Coverage, 4132,
     /* 130050 */     GIR_EraseRootFromParent_Done,
     /* 130051 */   // Label 2274: @130051
     /* 130051 */   GIM_Try, /*On fail goto*//*Label 2275*/ GIMT_Encode4(130136), // Rule ID 4133 //
     /* 130056 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130067 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 130078 */     // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 130078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 130085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 130100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 130105 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 130114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 130125 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130130 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130135 */     // GIR_Coverage, 4133,
     /* 130135 */     GIR_EraseRootFromParent_Done,
     /* 130136 */   // Label 2275: @130136
     /* 130136 */   GIM_Try, /*On fail goto*//*Label 2276*/ GIMT_Encode4(130221), // Rule ID 4134 //
     /* 130141 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130152 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 130163 */     // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 130163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 130170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 130185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 130190 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 130199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 130210 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130215 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130220 */     // GIR_Coverage, 4134,
     /* 130220 */     GIR_EraseRootFromParent_Done,
     /* 130221 */   // Label 2276: @130221
     /* 130221 */   GIM_Try, /*On fail goto*//*Label 2277*/ GIMT_Encode4(130306), // Rule ID 4135 //
     /* 130226 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130237 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 130248 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 130248 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130251 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 130255 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 130270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 130275 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 130284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 130295 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130300 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130305 */     // GIR_Coverage, 4135,
     /* 130305 */     GIR_EraseRootFromParent_Done,
     /* 130306 */   // Label 2277: @130306
     /* 130306 */   GIM_Try, /*On fail goto*//*Label 2278*/ GIMT_Encode4(130391), // Rule ID 4136 //
     /* 130311 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130322 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 130333 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 130333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 130340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 130355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 130360 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 130369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130374 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 130380 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130385 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130390 */     // GIR_Coverage, 4136,
     /* 130390 */     GIR_EraseRootFromParent_Done,
     /* 130391 */   // Label 2278: @130391
     /* 130391 */   GIM_Try, /*On fail goto*//*Label 2279*/ GIMT_Encode4(130471), // Rule ID 4168 //
     /* 130396 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130407 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 130418 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 130418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 130425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130440 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 130449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 130460 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130465 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130470 */     // GIR_Coverage, 4168,
     /* 130470 */     GIR_EraseRootFromParent_Done,
     /* 130471 */   // Label 2279: @130471
     /* 130471 */   GIM_Try, /*On fail goto*//*Label 2280*/ GIMT_Encode4(130551), // Rule ID 4169 //
     /* 130476 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130487 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 130498 */     // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 130498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 130505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130520 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 130529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 130540 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130545 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130550 */     // GIR_Coverage, 4169,
     /* 130550 */     GIR_EraseRootFromParent_Done,
     /* 130551 */   // Label 2280: @130551
     /* 130551 */   GIM_Try, /*On fail goto*//*Label 2281*/ GIMT_Encode4(130631), // Rule ID 4171 //
     /* 130556 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130567 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 130578 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 130578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 130585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130600 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 130609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130614 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 130620 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130625 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130630 */     // GIR_Coverage, 4171,
     /* 130630 */     GIR_EraseRootFromParent_Done,
     /* 130631 */   // Label 2281: @130631
     /* 130631 */   GIM_Try, /*On fail goto*//*Label 2282*/ GIMT_Encode4(130711), // Rule ID 4179 //
     /* 130636 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130647 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 130658 */     // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 130658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 130665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130680 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 130689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 130700 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130705 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130710 */     // GIR_Coverage, 4179,
     /* 130710 */     GIR_EraseRootFromParent_Done,
     /* 130711 */   // Label 2282: @130711
     /* 130711 */   GIM_Try, /*On fail goto*//*Label 2283*/ GIMT_Encode4(130791), // Rule ID 4205 //
     /* 130716 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130727 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 130738 */     // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 130738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 130745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130760 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130764 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 130769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130774 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 130780 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130785 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130790 */     // GIR_Coverage, 4205,
     /* 130790 */     GIR_EraseRootFromParent_Done,
     /* 130791 */   // Label 2283: @130791
     /* 130791 */   GIM_Try, /*On fail goto*//*Label 2284*/ GIMT_Encode4(130871), // Rule ID 4206 //
     /* 130796 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130807 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 130818 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 130818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 130825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130840 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130844 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 130849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 130860 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130865 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130870 */     // GIR_Coverage, 4206,
     /* 130870 */     GIR_EraseRootFromParent_Done,
     /* 130871 */   // Label 2284: @130871
     /* 130871 */   GIM_Try, /*On fail goto*//*Label 2285*/ GIMT_Encode4(130951), // Rule ID 4207 //
     /* 130876 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130887 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 130898 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 130898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 130905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130920 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130924 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 130929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 130940 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130945 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130950 */     // GIR_Coverage, 4207,
     /* 130950 */     GIR_EraseRootFromParent_Done,
     /* 130951 */   // Label 2285: @130951
     /* 130951 */   GIM_Try, /*On fail goto*//*Label 2286*/ GIMT_Encode4(131031), // Rule ID 4208 //
     /* 130956 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130967 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 130978 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 130978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 130985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 131000 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 131009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131014 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 131020 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 131025 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131030 */     // GIR_Coverage, 4208,
     /* 131030 */     GIR_EraseRootFromParent_Done,
     /* 131031 */   // Label 2286: @131031
     /* 131031 */   GIM_Try, /*On fail goto*//*Label 2287*/ GIMT_Encode4(131111), // Rule ID 4209 //
     /* 131036 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 131047 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 131058 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 131058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 131065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 131080 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 131089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131094 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 131100 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 131105 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131110 */     // GIR_Coverage, 4209,
     /* 131110 */     GIR_EraseRootFromParent_Done,
     /* 131111 */   // Label 2287: @131111
     /* 131111 */   GIM_Try, /*On fail goto*//*Label 2288*/ GIMT_Encode4(131191), // Rule ID 4210 //
     /* 131116 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 131127 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 131138 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 131138 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131141 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 131145 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 131160 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 131169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 131180 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 131185 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131190 */     // GIR_Coverage, 4210,
     /* 131190 */     GIR_EraseRootFromParent_Done,
     /* 131191 */   // Label 2288: @131191
     /* 131191 */   GIM_Reject,
     /* 131192 */ // Label 2270: @131192
     /* 131192 */ GIM_Reject,
     /* 131193 */ // Label 2239: @131193
     /* 131193 */ GIM_Reject,
     /* 131194 */ // Label 19: @131194
     /* 131194 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(24), /*)*//*default:*//*Label 2309*/ GIMT_Encode4(144719),
     /* 131205 */ /*GILLT_s8*//*Label 2289*/ GIMT_Encode4(131301),
     /* 131209 */ /*GILLT_s16*//*Label 2290*/ GIMT_Encode4(131668),
     /* 131213 */ /*GILLT_s32*//*Label 2291*/ GIMT_Encode4(132807),
     /* 131217 */ /*GILLT_s64*//*Label 2292*/ GIMT_Encode4(137402),
     /* 131221 */ /*GILLT_s128*//*Label 2293*/ GIMT_Encode4(141171),
     /* 131225 */ /*GILLT_v2s32*//*Label 2294*/ GIMT_Encode4(141377),
     /* 131229 */ /*GILLT_v2s64*//*Label 2295*/ GIMT_Encode4(141783),
     /* 131233 */ /*GILLT_v4s16*//*Label 2296*/ GIMT_Encode4(142233),
     /* 131237 */ /*GILLT_v4s32*//*Label 2297*/ GIMT_Encode4(142639),
     /* 131241 */ /*GILLT_v8s8*//*Label 2298*/ GIMT_Encode4(143045),
     /* 131245 */ /*GILLT_v8s16*//*Label 2299*/ GIMT_Encode4(143265),
     /* 131249 */ /*GILLT_v16s8*//*Label 2300*/ GIMT_Encode4(143671), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 131261 */ /*GILLT_nxv2s16*//*Label 2301*/ GIMT_Encode4(143891),
     /* 131265 */ /*GILLT_nxv2s32*//*Label 2302*/ GIMT_Encode4(143951),
     /* 131269 */ /*GILLT_nxv2s64*//*Label 2303*/ GIMT_Encode4(144011), GIMT_Encode4(0),
     /* 131277 */ /*GILLT_nxv4s16*//*Label 2304*/ GIMT_Encode4(144181),
     /* 131281 */ /*GILLT_nxv4s32*//*Label 2305*/ GIMT_Encode4(144241), GIMT_Encode4(0),
     /* 131289 */ /*GILLT_nxv8s16*//*Label 2306*/ GIMT_Encode4(144411),
     /* 131293 */ /*GILLT_nxv16s1*//*Label 2307*/ GIMT_Encode4(144581),
     /* 131297 */ /*GILLT_nxv16s8*//*Label 2308*/ GIMT_Encode4(144625),
     /* 131301 */ // Label 2289: @131301
     /* 131301 */ GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(131667),
     /* 131306 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 131309 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 131313 */   GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(131381), // Rule ID 13330 //
     /* 131318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 131330 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131339 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 131343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 131347 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 131351 */     // MIs[2] Operand 1
     /* 131351 */     // No operand predicates
     /* 131351 */     // MIs[0] Rn
     /* 131351 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131359 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 131361 */     // (st (vector_extract:{ *:[i8] } VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i8 VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 131361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 131364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 131368 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 131371 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131373 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 131379 */     GIR_RootConstrainSelectedInstOperands,
     /* 131380 */     // GIR_Coverage, 13330,
     /* 131380 */     GIR_EraseRootFromParent_Done,
     /* 131381 */   // Label 2311: @131381
     /* 131381 */   GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(131480), // Rule ID 13331 //
     /* 131386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 131398 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131402 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 131407 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 131411 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 131415 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 131419 */     // MIs[2] Operand 1
     /* 131419 */     // No operand predicates
     /* 131419 */     // MIs[0] Rn
     /* 131419 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131427 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 131429 */     // (st (vector_extract:{ *:[i8] } VecListOne64:{ *:[v8i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i8 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 131429 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 131432 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 131436 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131441 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 131444 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 131448 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 131451 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131456 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 131461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 131464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 131470 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131472 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 131478 */     GIR_RootConstrainSelectedInstOperands,
     /* 131479 */     // GIR_Coverage, 13331,
     /* 131479 */     GIR_EraseRootFromParent_Done,
     /* 131480 */   // Label 2312: @131480
     /* 131480 */   GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(131529), // Rule ID 303 //
     /* 131485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 131488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 131492 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 131503 */     // (st FPR8Op:{ *:[i8] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBroW FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 131503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBroW),
     /* 131506 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 131508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 131518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 131523 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131527 */     GIR_RootConstrainSelectedInstOperands,
     /* 131528 */     // GIR_Coverage, 303,
     /* 131528 */     GIR_EraseRootFromParent_Done,
     /* 131529 */   // Label 2313: @131529
     /* 131529 */   GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(131578), // Rule ID 304 //
     /* 131534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 131537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 131541 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 131552 */     // (st FPR8Op:{ *:[i8] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBroX FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 131552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBroX),
     /* 131555 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 131557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 131567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 131572 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131576 */     GIR_RootConstrainSelectedInstOperands,
     /* 131577 */     // GIR_Coverage, 304,
     /* 131577 */     GIR_EraseRootFromParent_Done,
     /* 131578 */   // Label 2314: @131578
     /* 131578 */   GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(131622), // Rule ID 313 //
     /* 131583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 131586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 131590 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 131601 */     // (st FPR8Op:{ *:[i8] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBui FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 131601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBui),
     /* 131604 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 131606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 131616 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131620 */     GIR_RootConstrainSelectedInstOperands,
     /* 131621 */     // GIR_Coverage, 313,
     /* 131621 */     GIR_EraseRootFromParent_Done,
     /* 131622 */   // Label 2315: @131622
     /* 131622 */   GIM_Try, /*On fail goto*//*Label 2316*/ GIMT_Encode4(131666), // Rule ID 321 //
     /* 131627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 131630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 131634 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 131645 */     // (st FPR8Op:{ *:[i8] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURBi FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 131645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBi),
     /* 131648 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 131650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 131660 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131664 */     GIR_RootConstrainSelectedInstOperands,
     /* 131665 */     // GIR_Coverage, 321,
     /* 131665 */     GIR_EraseRootFromParent_Done,
     /* 131666 */   // Label 2316: @131666
     /* 131666 */   GIM_Reject,
     /* 131667 */ // Label 2310: @131667
     /* 131667 */ GIM_Reject,
     /* 131668 */ // Label 2290: @131668
     /* 131668 */ GIM_Try, /*On fail goto*//*Label 2317*/ GIMT_Encode4(132806),
     /* 131673 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 131676 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 131680 */   GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(131779), // Rule ID 4543 //
     /* 131685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 131697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131706 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 131710 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 131723 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 131723 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 131726 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131730 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131735 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 131741 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 131746 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 131754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 131767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 131772 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 131777 */     GIR_RootConstrainSelectedInstOperands,
     /* 131778 */     // GIR_Coverage, 4543,
     /* 131778 */     GIR_EraseRootFromParent_Done,
     /* 131779 */   // Label 2318: @131779
     /* 131779 */   GIM_Try, /*On fail goto*//*Label 2319*/ GIMT_Encode4(131878), // Rule ID 4544 //
     /* 131784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 131796 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131805 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 131809 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 131822 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 131822 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 131825 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131829 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131834 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 131840 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 131845 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 131853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 131866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 131871 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 131876 */     GIR_RootConstrainSelectedInstOperands,
     /* 131877 */     // GIR_Coverage, 4544,
     /* 131877 */     GIR_EraseRootFromParent_Done,
     /* 131878 */   // Label 2319: @131878
     /* 131878 */   GIM_Try, /*On fail goto*//*Label 2320*/ GIMT_Encode4(131977), // Rule ID 13328 //
     /* 131883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 131895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131899 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 131904 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 131908 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 131921 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 131921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 131924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131933 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 131939 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 131944 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 131949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 131952 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 131965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 131970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 131975 */     GIR_RootConstrainSelectedInstOperands,
     /* 131976 */     // GIR_Coverage, 13328,
     /* 131976 */     GIR_EraseRootFromParent_Done,
     /* 131977 */   // Label 2320: @131977
     /* 131977 */   GIM_Try, /*On fail goto*//*Label 2321*/ GIMT_Encode4(132076), // Rule ID 13329 //
     /* 131982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 131994 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131998 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132003 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132007 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 132020 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 132020 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 132023 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132027 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132032 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 132038 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 132043 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 132051 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 132064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 132069 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132074 */     GIR_RootConstrainSelectedInstOperands,
     /* 132075 */     // GIR_Coverage, 13329,
     /* 132075 */     GIR_EraseRootFromParent_Done,
     /* 132076 */   // Label 2321: @132076
     /* 132076 */   GIM_Try, /*On fail goto*//*Label 2322*/ GIMT_Encode4(132170), // Rule ID 4572 //
     /* 132081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 132093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132097 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132102 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132106 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 132119 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 132119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 132122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132131 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 132137 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 132142 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 132150 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132163 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132168 */     GIR_RootConstrainSelectedInstOperands,
     /* 132169 */     // GIR_Coverage, 4572,
     /* 132169 */     GIR_EraseRootFromParent_Done,
     /* 132170 */   // Label 2322: @132170
     /* 132170 */   GIM_Try, /*On fail goto*//*Label 2323*/ GIMT_Encode4(132264), // Rule ID 4599 //
     /* 132175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 132187 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132191 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132196 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132200 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 132213 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 132213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 132216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132225 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 132231 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 132236 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 132244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132257 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132262 */     GIR_RootConstrainSelectedInstOperands,
     /* 132263 */     // GIR_Coverage, 4599,
     /* 132263 */     GIR_EraseRootFromParent_Done,
     /* 132264 */   // Label 2323: @132264
     /* 132264 */   GIM_Try, /*On fail goto*//*Label 2324*/ GIMT_Encode4(132358), // Rule ID 13327 //
     /* 132269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 132281 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132285 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132290 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132294 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132298 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 132307 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 132307 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 132310 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132314 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132319 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 132325 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 132330 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 132338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132351 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132356 */     GIR_RootConstrainSelectedInstOperands,
     /* 132357 */     // GIR_Coverage, 13327,
     /* 132357 */     GIR_EraseRootFromParent_Done,
     /* 132358 */   // Label 2324: @132358
     /* 132358 */   GIM_Try, /*On fail goto*//*Label 2325*/ GIMT_Encode4(132452), // Rule ID 13333 //
     /* 132363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 132375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132379 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132384 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132388 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 132401 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 132401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 132404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132413 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 132419 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 132424 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 132432 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132445 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132450 */     GIR_RootConstrainSelectedInstOperands,
     /* 132451 */     // GIR_Coverage, 13333,
     /* 132451 */     GIR_EraseRootFromParent_Done,
     /* 132452 */   // Label 2325: @132452
     /* 132452 */   GIM_Try, /*On fail goto*//*Label 2326*/ GIMT_Encode4(132520), // Rule ID 6533 //
     /* 132457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 132469 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132473 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 132482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 132486 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 132490 */     // MIs[2] Operand 1
     /* 132490 */     // No operand predicates
     /* 132490 */     // MIs[0] Rn
     /* 132490 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132498 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 132500 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i16 VecListOne128:{ *:[v8f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 132500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 132503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 132507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 132510 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132512 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 132518 */     GIR_RootConstrainSelectedInstOperands,
     /* 132519 */     // GIR_Coverage, 6533,
     /* 132519 */     GIR_EraseRootFromParent_Done,
     /* 132520 */   // Label 2326: @132520
     /* 132520 */   GIM_Try, /*On fail goto*//*Label 2327*/ GIMT_Encode4(132619), // Rule ID 6538 //
     /* 132525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 132537 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132541 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 132550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 132554 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 132558 */     // MIs[2] Operand 1
     /* 132558 */     // No operand predicates
     /* 132558 */     // MIs[0] Rn
     /* 132558 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132566 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 132568 */     // (st (vector_extract:{ *:[f16] } VecListOne64:{ *:[v4f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i16 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4f16] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 132568 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 132571 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 132575 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132580 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 132583 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 132587 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 132590 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132595 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 132603 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132606 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 132609 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 132617 */     GIR_RootConstrainSelectedInstOperands,
     /* 132618 */     // GIR_Coverage, 6538,
     /* 132618 */     GIR_EraseRootFromParent_Done,
     /* 132619 */   // Label 2327: @132619
     /* 132619 */   GIM_Try, /*On fail goto*//*Label 2328*/ GIMT_Encode4(132668), // Rule ID 305 //
     /* 132624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 132627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 132631 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 132642 */     // (st FPR16Op:{ *:[f16] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 132642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 132645 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 132647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 132657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 132662 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132666 */     GIR_RootConstrainSelectedInstOperands,
     /* 132667 */     // GIR_Coverage, 305,
     /* 132667 */     GIR_EraseRootFromParent_Done,
     /* 132668 */   // Label 2328: @132668
     /* 132668 */   GIM_Try, /*On fail goto*//*Label 2329*/ GIMT_Encode4(132717), // Rule ID 306 //
     /* 132673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 132676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 132680 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 132691 */     // (st FPR16Op:{ *:[f16] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 132691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 132694 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 132696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 132706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 132711 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132715 */     GIR_RootConstrainSelectedInstOperands,
     /* 132716 */     // GIR_Coverage, 306,
     /* 132716 */     GIR_EraseRootFromParent_Done,
     /* 132717 */   // Label 2329: @132717
     /* 132717 */   GIM_Try, /*On fail goto*//*Label 2330*/ GIMT_Encode4(132761), // Rule ID 314 //
     /* 132722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 132725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 132729 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 132740 */     // (st FPR16Op:{ *:[f16] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 132740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 132743 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 132745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132755 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132759 */     GIR_RootConstrainSelectedInstOperands,
     /* 132760 */     // GIR_Coverage, 314,
     /* 132760 */     GIR_EraseRootFromParent_Done,
     /* 132761 */   // Label 2330: @132761
     /* 132761 */   GIM_Try, /*On fail goto*//*Label 2331*/ GIMT_Encode4(132805), // Rule ID 322 //
     /* 132766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 132769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 132773 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 132784 */     // (st FPR16Op:{ *:[f16] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 132784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 132787 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 132789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132803 */     GIR_RootConstrainSelectedInstOperands,
     /* 132804 */     // GIR_Coverage, 322,
     /* 132804 */     GIR_EraseRootFromParent_Done,
     /* 132805 */   // Label 2331: @132805
     /* 132805 */   GIM_Reject,
     /* 132806 */ // Label 2317: @132806
     /* 132806 */ GIM_Reject,
     /* 132807 */ // Label 2291: @132807
     /* 132807 */ GIM_Try, /*On fail goto*//*Label 2332*/ GIMT_Encode4(132920), // Rule ID 4541 //
     /* 132812 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 132815 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132819 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132826 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132830 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132834 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 132838 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132842 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132847 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132851 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132855 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132857 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 132864 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 132864 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 132867 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132871 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132876 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 132882 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 132887 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132892 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 132895 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132898 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132903 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 132908 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 132913 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132918 */   GIR_RootConstrainSelectedInstOperands,
     /* 132919 */   // GIR_Coverage, 4541,
     /* 132919 */   GIR_EraseRootFromParent_Done,
     /* 132920 */ // Label 2332: @132920
     /* 132920 */ GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(133033), // Rule ID 4542 //
     /* 132925 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 132928 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132932 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132939 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132943 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132947 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 132951 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132955 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132960 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132964 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132968 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132970 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 132977 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 132977 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 132980 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132984 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132989 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 132995 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 133000 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133005 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 133008 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133011 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133016 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 133021 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 133026 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 133031 */   GIR_RootConstrainSelectedInstOperands,
     /* 133032 */   // GIR_Coverage, 4542,
     /* 133032 */   GIR_EraseRootFromParent_Done,
     /* 133033 */ // Label 2333: @133033
     /* 133033 */ GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(133139), // Rule ID 4545 //
     /* 133038 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133041 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133045 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133049 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133053 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 133057 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133061 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133066 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 133070 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133074 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133076 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 133083 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 133083 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 133086 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133090 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133095 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 133101 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 133106 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133111 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 133114 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133117 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133122 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 133127 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 133132 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 133137 */   GIR_RootConstrainSelectedInstOperands,
     /* 133138 */   // GIR_Coverage, 4545,
     /* 133138 */   GIR_EraseRootFromParent_Done,
     /* 133139 */ // Label 2334: @133139
     /* 133139 */ GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(133245), // Rule ID 4546 //
     /* 133144 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133147 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133151 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133155 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133159 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 133163 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133167 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133172 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 133176 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133180 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133182 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 133189 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 133189 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 133192 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133196 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133201 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 133207 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 133212 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133217 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 133220 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133223 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133228 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 133233 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 133238 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 133243 */   GIR_RootConstrainSelectedInstOperands,
     /* 133244 */   // GIR_Coverage, 4546,
     /* 133244 */   GIR_EraseRootFromParent_Done,
     /* 133245 */ // Label 2335: @133245
     /* 133245 */ GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(133351), // Rule ID 4547 //
     /* 133250 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133253 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133257 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133261 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133265 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 133269 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133273 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133278 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 133282 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133286 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133288 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 133295 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 133295 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 133298 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133302 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133307 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 133313 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 133318 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 133326 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133329 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133334 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 133339 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 133344 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 133349 */   GIR_RootConstrainSelectedInstOperands,
     /* 133350 */   // GIR_Coverage, 4547,
     /* 133350 */   GIR_EraseRootFromParent_Done,
     /* 133351 */ // Label 2336: @133351
     /* 133351 */ GIM_Try, /*On fail goto*//*Label 2337*/ GIMT_Encode4(133457), // Rule ID 4548 //
     /* 133356 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133359 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133363 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133367 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133371 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 133375 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133379 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133384 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 133388 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133392 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133394 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 133401 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 133401 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 133404 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133408 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133413 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 133419 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 133424 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133429 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 133432 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133435 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133440 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 133445 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 133450 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 133455 */   GIR_RootConstrainSelectedInstOperands,
     /* 133456 */   // GIR_Coverage, 4548,
     /* 133456 */   GIR_EraseRootFromParent_Done,
     /* 133457 */ // Label 2337: @133457
     /* 133457 */ GIM_Try, /*On fail goto*//*Label 2338*/ GIMT_Encode4(133563), // Rule ID 13335 //
     /* 133462 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133465 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133469 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133473 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133477 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 133481 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133485 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133490 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 133494 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133498 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133500 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 133507 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 133507 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 133510 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133514 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133519 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 133525 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 133530 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 133538 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133541 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133546 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 133551 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 133556 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 133561 */   GIR_RootConstrainSelectedInstOperands,
     /* 133562 */   // GIR_Coverage, 13335,
     /* 133562 */   GIR_EraseRootFromParent_Done,
     /* 133563 */ // Label 2338: @133563
     /* 133563 */ GIM_Try, /*On fail goto*//*Label 2339*/ GIMT_Encode4(133669), // Rule ID 13336 //
     /* 133568 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133571 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133575 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133579 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133583 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 133587 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133591 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133596 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 133600 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133604 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133606 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 133613 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 133613 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 133616 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133620 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133625 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 133631 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 133636 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 133644 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133647 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133652 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 133657 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 133662 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 133667 */   GIR_RootConstrainSelectedInstOperands,
     /* 133668 */   // GIR_Coverage, 13336,
     /* 133668 */   GIR_EraseRootFromParent_Done,
     /* 133669 */ // Label 2339: @133669
     /* 133669 */ GIM_Try, /*On fail goto*//*Label 2340*/ GIMT_Encode4(133777), // Rule ID 4571 //
     /* 133674 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133677 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133681 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133688 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133692 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133696 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 133700 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133704 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133709 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 133713 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133717 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133719 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 133726 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 133726 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 133729 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133733 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133738 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 133744 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 133749 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133754 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 133757 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133760 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133765 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 133770 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 133775 */   GIR_RootConstrainSelectedInstOperands,
     /* 133776 */   // GIR_Coverage, 4571,
     /* 133776 */   GIR_EraseRootFromParent_Done,
     /* 133777 */ // Label 2340: @133777
     /* 133777 */ GIM_Try, /*On fail goto*//*Label 2341*/ GIMT_Encode4(133878), // Rule ID 4573 //
     /* 133782 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133785 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133789 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133793 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133797 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 133801 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133805 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133810 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 133814 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133818 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133820 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 133827 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 133827 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 133830 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133834 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133839 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 133845 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 133850 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133855 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 133858 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133861 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133866 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 133871 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 133876 */   GIR_RootConstrainSelectedInstOperands,
     /* 133877 */   // GIR_Coverage, 4573,
     /* 133877 */   GIR_EraseRootFromParent_Done,
     /* 133878 */ // Label 2341: @133878
     /* 133878 */ GIM_Try, /*On fail goto*//*Label 2342*/ GIMT_Encode4(133979), // Rule ID 4574 //
     /* 133883 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133886 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133890 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133894 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133898 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 133902 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133906 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133911 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 133915 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133919 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133921 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 133928 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 133928 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 133931 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133935 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133940 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 133946 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 133951 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133956 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 133959 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133962 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133967 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 133972 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 133977 */   GIR_RootConstrainSelectedInstOperands,
     /* 133978 */   // GIR_Coverage, 4574,
     /* 133978 */   GIR_EraseRootFromParent_Done,
     /* 133979 */ // Label 2342: @133979
     /* 133979 */ GIM_Try, /*On fail goto*//*Label 2343*/ GIMT_Encode4(134087), // Rule ID 4598 //
     /* 133984 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133987 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133991 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133998 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134002 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 134006 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 134010 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134014 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 134019 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 134023 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134027 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134029 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 134036 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 134036 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 134039 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134043 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134048 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 134054 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 134059 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 134064 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 134067 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134070 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134075 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134080 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 134085 */   GIR_RootConstrainSelectedInstOperands,
     /* 134086 */   // GIR_Coverage, 4598,
     /* 134086 */   GIR_EraseRootFromParent_Done,
     /* 134087 */ // Label 2343: @134087
     /* 134087 */ GIM_Try, /*On fail goto*//*Label 2344*/ GIMT_Encode4(134188), // Rule ID 4600 //
     /* 134092 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134095 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134099 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134103 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 134107 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 134111 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134115 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 134120 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 134124 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134128 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134130 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 134137 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 134137 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 134140 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134144 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134149 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 134155 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134160 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 134165 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 134168 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134171 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134176 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134181 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 134186 */   GIR_RootConstrainSelectedInstOperands,
     /* 134187 */   // GIR_Coverage, 4600,
     /* 134187 */   GIR_EraseRootFromParent_Done,
     /* 134188 */ // Label 2344: @134188
     /* 134188 */ GIM_Try, /*On fail goto*//*Label 2345*/ GIMT_Encode4(134289), // Rule ID 4601 //
     /* 134193 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134196 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134200 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134204 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 134208 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 134212 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134216 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 134221 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 134225 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134229 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134231 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 134238 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 134238 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 134241 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134245 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134250 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 134256 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134261 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 134266 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 134269 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134272 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134277 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134282 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 134287 */   GIR_RootConstrainSelectedInstOperands,
     /* 134288 */   // GIR_Coverage, 4601,
     /* 134288 */   GIR_EraseRootFromParent_Done,
     /* 134289 */ // Label 2345: @134289
     /* 134289 */ GIM_Try, /*On fail goto*//*Label 2346*/ GIMT_Encode4(134390), // Rule ID 13332 //
     /* 134294 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134297 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134301 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134305 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 134309 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 134313 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134317 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134322 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 134326 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134330 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134332 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 134339 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 134339 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 134342 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134346 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134351 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 134357 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134362 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134367 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 134370 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134373 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134378 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134383 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 134388 */   GIR_RootConstrainSelectedInstOperands,
     /* 134389 */   // GIR_Coverage, 13332,
     /* 134389 */   GIR_EraseRootFromParent_Done,
     /* 134390 */ // Label 2346: @134390
     /* 134390 */ GIM_Try, /*On fail goto*//*Label 2347*/ GIMT_Encode4(134491), // Rule ID 13334 //
     /* 134395 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134398 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134402 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134406 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 134410 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 134414 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134418 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134423 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 134427 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134431 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134433 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 134440 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 134440 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 134443 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134447 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134452 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 134458 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134463 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 134471 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134474 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134479 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134484 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 134489 */   GIR_RootConstrainSelectedInstOperands,
     /* 134490 */   // GIR_Coverage, 13334,
     /* 134490 */   GIR_EraseRootFromParent_Done,
     /* 134491 */ // Label 2347: @134491
     /* 134491 */ GIM_Try, /*On fail goto*//*Label 2348*/ GIMT_Encode4(134573), // Rule ID 6527 //
     /* 134496 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134499 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134503 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134510 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134514 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 134518 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 134522 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134526 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 134531 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 134535 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 134539 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 134543 */   // MIs[2] Operand 1
     /* 134543 */   // No operand predicates
     /* 134543 */   // MIs[0] Rn
     /* 134543 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134547 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134551 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 134553 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (ST1i8 VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 134553 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 134556 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 134560 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 134563 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134565 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 134571 */   GIR_RootConstrainSelectedInstOperands,
     /* 134572 */   // GIR_Coverage, 6527,
     /* 134572 */   GIR_EraseRootFromParent_Done,
     /* 134573 */ // Label 2348: @134573
     /* 134573 */ GIM_Try, /*On fail goto*//*Label 2349*/ GIMT_Encode4(134655), // Rule ID 6528 //
     /* 134578 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134581 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134585 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134592 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134596 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 134600 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 134604 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134608 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 134613 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 134617 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 134621 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 134625 */   // MIs[2] Operand 1
     /* 134625 */   // No operand predicates
     /* 134625 */   // MIs[0] Rn
     /* 134625 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134629 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134633 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 134635 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (ST1i16 VecListOne128:{ *:[v8i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 134635 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 134638 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 134642 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 134645 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134647 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 134653 */   GIR_RootConstrainSelectedInstOperands,
     /* 134654 */   // GIR_Coverage, 6528,
     /* 134654 */   GIR_EraseRootFromParent_Done,
     /* 134655 */ // Label 2349: @134655
     /* 134655 */ GIM_Try, /*On fail goto*//*Label 2350*/ GIMT_Encode4(134730), // Rule ID 6529 //
     /* 134660 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134663 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134667 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134671 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 134675 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 134679 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134683 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 134688 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 134692 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 134696 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 134700 */   // MIs[2] Operand 1
     /* 134700 */   // No operand predicates
     /* 134700 */   // MIs[0] Rn
     /* 134700 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134708 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 134710 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 VecListOne128:{ *:[v4i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 134710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 134713 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 134717 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 134720 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134722 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 134728 */   GIR_RootConstrainSelectedInstOperands,
     /* 134729 */   // GIR_Coverage, 6529,
     /* 134729 */   GIR_EraseRootFromParent_Done,
     /* 134730 */ // Label 2350: @134730
     /* 134730 */ GIM_Try, /*On fail goto*//*Label 2351*/ GIMT_Encode4(134805), // Rule ID 6530 //
     /* 134735 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134738 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134742 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134746 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 134750 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 134754 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134758 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 134763 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 134767 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 134771 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 134775 */   // MIs[2] Operand 1
     /* 134775 */   // No operand predicates
     /* 134775 */   // MIs[0] Rn
     /* 134775 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134779 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134783 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 134785 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 VecListOne128:{ *:[v4f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 134785 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 134788 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 134792 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 134795 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134797 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 134803 */   GIR_RootConstrainSelectedInstOperands,
     /* 134804 */   // GIR_Coverage, 6530,
     /* 134804 */   GIR_EraseRootFromParent_Done,
     /* 134805 */ // Label 2351: @134805
     /* 134805 */ GIM_Try, /*On fail goto*//*Label 2352*/ GIMT_Encode4(134918), // Rule ID 6534 //
     /* 134810 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134813 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134817 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134824 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134828 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 134832 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 134836 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134840 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134845 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 134849 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 134853 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 134857 */   // MIs[2] Operand 1
     /* 134857 */   // No operand predicates
     /* 134857 */   // MIs[0] Rn
     /* 134857 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134865 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 134867 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v8i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (ST1i8 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 134867 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 134870 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 134874 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134879 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 134882 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 134886 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 134889 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 134894 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134899 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 134902 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134905 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 134908 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134910 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 134916 */   GIR_RootConstrainSelectedInstOperands,
     /* 134917 */   // GIR_Coverage, 6534,
     /* 134917 */   GIR_EraseRootFromParent_Done,
     /* 134918 */ // Label 2352: @134918
     /* 134918 */ GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(135031), // Rule ID 6535 //
     /* 134923 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134926 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134930 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134937 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134941 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 134945 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 134949 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134953 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134958 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 134962 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 134966 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 134970 */   // MIs[2] Operand 1
     /* 134970 */   // No operand predicates
     /* 134970 */   // MIs[0] Rn
     /* 134970 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134974 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134978 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 134980 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v4i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (ST1i16 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4i16] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 134980 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 134983 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 134987 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134992 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 134995 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 134999 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 135002 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 135007 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135012 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 135015 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135018 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 135021 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135023 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 135029 */   GIR_RootConstrainSelectedInstOperands,
     /* 135030 */   // GIR_Coverage, 6535,
     /* 135030 */   GIR_EraseRootFromParent_Done,
     /* 135031 */ // Label 2353: @135031
     /* 135031 */ GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(135137), // Rule ID 6536 //
     /* 135036 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135039 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135043 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 135047 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 135051 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 135055 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 135059 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135064 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 135068 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 135072 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 135076 */   // MIs[2] Operand 1
     /* 135076 */   // No operand predicates
     /* 135076 */   // MIs[0] Rn
     /* 135076 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135080 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135084 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 135086 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2i32] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 135086 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 135089 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 135093 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135098 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 135101 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 135105 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 135108 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 135113 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 135121 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135124 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 135127 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135129 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 135135 */   GIR_RootConstrainSelectedInstOperands,
     /* 135136 */   // GIR_Coverage, 6536,
     /* 135136 */   GIR_EraseRootFromParent_Done,
     /* 135137 */ // Label 2354: @135137
     /* 135137 */ GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(135243), // Rule ID 6537 //
     /* 135142 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135145 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135149 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 135153 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 135157 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 135161 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 135165 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135170 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 135174 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 135178 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 135182 */   // MIs[2] Operand 1
     /* 135182 */   // No operand predicates
     /* 135182 */   // MIs[0] Rn
     /* 135182 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135186 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135190 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 135192 */   // (st (vector_extract:{ *:[f32] } VecListOne64:{ *:[v2f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2f32] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 135192 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 135195 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 135199 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135204 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 135207 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 135211 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 135214 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 135219 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135224 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 135227 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135230 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 135233 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135235 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 135241 */   GIR_RootConstrainSelectedInstOperands,
     /* 135242 */   // GIR_Coverage, 6537,
     /* 135242 */   GIR_EraseRootFromParent_Done,
     /* 135243 */ // Label 2355: @135243
     /* 135243 */ GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(135303), // Rule ID 295 //
     /* 135248 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135251 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135255 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135266 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135270 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 135277 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 135277 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 135280 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 135282 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135287 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 135292 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 135297 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135301 */   GIR_RootConstrainSelectedInstOperands,
     /* 135302 */   // GIR_Coverage, 295,
     /* 135302 */   GIR_EraseRootFromParent_Done,
     /* 135303 */ // Label 2356: @135303
     /* 135303 */ GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(135363), // Rule ID 296 //
     /* 135308 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135311 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135315 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135326 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135330 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 135337 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 135337 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 135340 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 135342 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135347 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 135352 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 135357 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135361 */   GIR_RootConstrainSelectedInstOperands,
     /* 135362 */   // GIR_Coverage, 296,
     /* 135362 */   GIR_EraseRootFromParent_Done,
     /* 135363 */ // Label 2357: @135363
     /* 135363 */ GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(135423), // Rule ID 297 //
     /* 135368 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135371 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135375 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135386 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135390 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 135397 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 135397 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 135400 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 135402 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135407 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 135412 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 135417 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135421 */   GIR_RootConstrainSelectedInstOperands,
     /* 135422 */   // GIR_Coverage, 297,
     /* 135422 */   GIR_EraseRootFromParent_Done,
     /* 135423 */ // Label 2358: @135423
     /* 135423 */ GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(135483), // Rule ID 298 //
     /* 135428 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135431 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135435 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135446 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135450 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 135457 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 135457 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 135460 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 135462 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135467 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 135472 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 135477 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135481 */   GIR_RootConstrainSelectedInstOperands,
     /* 135482 */   // GIR_Coverage, 298,
     /* 135482 */   GIR_EraseRootFromParent_Done,
     /* 135483 */ // Label 2359: @135483
     /* 135483 */ GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(135536), // Rule ID 299 //
     /* 135488 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135491 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135499 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135503 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 135510 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 135510 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 135513 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 135515 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135520 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 135525 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 135530 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135534 */   GIR_RootConstrainSelectedInstOperands,
     /* 135535 */   // GIR_Coverage, 299,
     /* 135535 */   GIR_EraseRootFromParent_Done,
     /* 135536 */ // Label 2360: @135536
     /* 135536 */ GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(135589), // Rule ID 300 //
     /* 135541 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135544 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135552 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135556 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 135563 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 135563 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 135566 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 135568 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135573 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 135578 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 135583 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135587 */   GIR_RootConstrainSelectedInstOperands,
     /* 135588 */   // GIR_Coverage, 300,
     /* 135588 */   GIR_EraseRootFromParent_Done,
     /* 135589 */ // Label 2361: @135589
     /* 135589 */ GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(135645), // Rule ID 307 //
     /* 135594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135597 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135600 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135608 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135612 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 135619 */   // (st FPR32Op:{ *:[f32] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 135619 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 135622 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 135624 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135629 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 135634 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 135639 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135643 */   GIR_RootConstrainSelectedInstOperands,
     /* 135644 */   // GIR_Coverage, 307,
     /* 135644 */   GIR_EraseRootFromParent_Done,
     /* 135645 */ // Label 2362: @135645
     /* 135645 */ GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(135701), // Rule ID 308 //
     /* 135650 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135653 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135656 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135664 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135668 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 135675 */   // (st FPR32Op:{ *:[f32] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 135675 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 135678 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 135680 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135685 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 135690 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 135695 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135699 */   GIR_RootConstrainSelectedInstOperands,
     /* 135700 */   // GIR_Coverage, 308,
     /* 135700 */   GIR_EraseRootFromParent_Done,
     /* 135701 */ // Label 2363: @135701
     /* 135701 */ GIM_Try, /*On fail goto*//*Label 2364*/ GIMT_Encode4(135753), // Rule ID 312 //
     /* 135706 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135709 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135717 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135721 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 135728 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 135728 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 135731 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 135737 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135742 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135747 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135751 */   GIR_RootConstrainSelectedInstOperands,
     /* 135752 */   // GIR_Coverage, 312,
     /* 135752 */   GIR_EraseRootFromParent_Done,
     /* 135753 */ // Label 2364: @135753
     /* 135753 */ GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(135804), // Rule ID 315 //
     /* 135758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135761 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135764 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135772 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135776 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 135783 */   // (st FPR32Op:{ *:[f32] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 135783 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 135786 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 135788 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135793 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135798 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135802 */   GIR_RootConstrainSelectedInstOperands,
     /* 135803 */   // GIR_Coverage, 315,
     /* 135803 */   GIR_EraseRootFromParent_Done,
     /* 135804 */ // Label 2365: @135804
     /* 135804 */ GIM_Try, /*On fail goto*//*Label 2366*/ GIMT_Encode4(135863), // Rule ID 317 //
     /* 135809 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135812 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135816 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135827 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135831 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 135838 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 135838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 135841 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 135847 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135852 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135857 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135861 */   GIR_RootConstrainSelectedInstOperands,
     /* 135862 */   // GIR_Coverage, 317,
     /* 135862 */   GIR_EraseRootFromParent_Done,
     /* 135863 */ // Label 2366: @135863
     /* 135863 */ GIM_Try, /*On fail goto*//*Label 2367*/ GIMT_Encode4(135922), // Rule ID 318 //
     /* 135868 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135871 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135875 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135886 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135890 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 135897 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 135897 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 135900 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 135906 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135911 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135916 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135920 */   GIR_RootConstrainSelectedInstOperands,
     /* 135921 */   // GIR_Coverage, 318,
     /* 135921 */   GIR_EraseRootFromParent_Done,
     /* 135922 */ // Label 2367: @135922
     /* 135922 */ GIM_Try, /*On fail goto*//*Label 2368*/ GIMT_Encode4(135999), // Rule ID 7166 //
     /* 135927 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135930 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135937 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135940 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 135944 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 135948 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 135952 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135957 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135961 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135963 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 135970 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15916>>  =>  (STRSroW FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 135970 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 135973 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 135977 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135982 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 135987 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 135992 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 135997 */   GIR_RootConstrainSelectedInstOperands,
     /* 135998 */   // GIR_Coverage, 7166,
     /* 135998 */   GIR_EraseRootFromParent_Done,
     /* 135999 */ // Label 2368: @135999
     /* 135999 */ GIM_Try, /*On fail goto*//*Label 2369*/ GIMT_Encode4(136076), // Rule ID 7167 //
     /* 136004 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 136007 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136014 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136017 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 136021 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 136025 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 136029 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 136034 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136038 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136040 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 136047 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15916>>  =>  (STRSroX FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 136047 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 136050 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 136054 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136059 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136064 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136069 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 136074 */   GIR_RootConstrainSelectedInstOperands,
     /* 136075 */   // GIR_Coverage, 7167,
     /* 136075 */   GIR_EraseRootFromParent_Done,
     /* 136076 */ // Label 2369: @136076
     /* 136076 */ GIM_Try, /*On fail goto*//*Label 2370*/ GIMT_Encode4(136135), // Rule ID 7147 //
     /* 136081 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 136084 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136091 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136098 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136102 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 136109 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15902>>  =>  (STRBBroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 136109 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 136112 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 136114 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136119 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136124 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136129 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136133 */   GIR_RootConstrainSelectedInstOperands,
     /* 136134 */   // GIR_Coverage, 7147,
     /* 136134 */   GIR_EraseRootFromParent_Done,
     /* 136135 */ // Label 2370: @136135
     /* 136135 */ GIM_Try, /*On fail goto*//*Label 2371*/ GIMT_Encode4(136194), // Rule ID 7148 //
     /* 136140 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 136143 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136150 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136157 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136161 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 136168 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15902>>  =>  (STRBBroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 136168 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 136171 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 136173 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136178 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136183 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136188 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136192 */   GIR_RootConstrainSelectedInstOperands,
     /* 136193 */   // GIR_Coverage, 7148,
     /* 136193 */   GIR_EraseRootFromParent_Done,
     /* 136194 */ // Label 2371: @136194
     /* 136194 */ GIM_Try, /*On fail goto*//*Label 2372*/ GIMT_Encode4(136253), // Rule ID 7152 //
     /* 136199 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 136202 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136209 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136216 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136220 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 136227 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15909>>  =>  (STRHHroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 136227 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 136230 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 136232 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136237 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136242 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136247 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136251 */   GIR_RootConstrainSelectedInstOperands,
     /* 136252 */   // GIR_Coverage, 7152,
     /* 136252 */   GIR_EraseRootFromParent_Done,
     /* 136253 */ // Label 2372: @136253
     /* 136253 */ GIM_Try, /*On fail goto*//*Label 2373*/ GIMT_Encode4(136312), // Rule ID 7153 //
     /* 136258 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 136261 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136268 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136275 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136279 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 136286 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15909>>  =>  (STRHHroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 136286 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 136289 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 136291 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136296 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136301 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136306 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136310 */   GIR_RootConstrainSelectedInstOperands,
     /* 136311 */   // GIR_Coverage, 7153,
     /* 136311 */   GIR_EraseRootFromParent_Done,
     /* 136312 */ // Label 2373: @136312
     /* 136312 */ GIM_Try, /*On fail goto*//*Label 2374*/ GIMT_Encode4(136371), // Rule ID 7157 //
     /* 136317 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 136320 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136327 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136334 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136338 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 136345 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15916>>  =>  (STRWroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 136345 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 136348 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 136350 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136355 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136360 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136365 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136369 */   GIR_RootConstrainSelectedInstOperands,
     /* 136370 */   // GIR_Coverage, 7157,
     /* 136370 */   GIR_EraseRootFromParent_Done,
     /* 136371 */ // Label 2374: @136371
     /* 136371 */ GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(136430), // Rule ID 7158 //
     /* 136376 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 136379 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136386 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136393 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136397 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 136404 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15916>>  =>  (STRWroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 136404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 136407 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 136409 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136414 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136419 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136424 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136428 */   GIR_RootConstrainSelectedInstOperands,
     /* 136429 */   // GIR_Coverage, 7158,
     /* 136429 */   GIR_EraseRootFromParent_Done,
     /* 136430 */ // Label 2375: @136430
     /* 136430 */ GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(136502), // Rule ID 7168 //
     /* 136435 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 136438 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136445 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136448 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 136452 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 136456 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 136460 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 136465 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136469 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136471 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 136478 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15916>>  =>  (STRSui FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 136478 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 136481 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 136485 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136490 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136495 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 136500 */   GIR_RootConstrainSelectedInstOperands,
     /* 136501 */   // GIR_Coverage, 7168,
     /* 136501 */   GIR_EraseRootFromParent_Done,
     /* 136502 */ // Label 2376: @136502
     /* 136502 */ GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(136574), // Rule ID 7169 //
     /* 136507 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 136510 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136517 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136520 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 136524 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 136528 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 136532 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 136537 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136541 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136543 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 136550 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15916>>  =>  (STURSi FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 136550 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 136553 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 136557 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136562 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136567 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 136572 */   GIR_RootConstrainSelectedInstOperands,
     /* 136573 */   // GIR_Coverage, 7169,
     /* 136573 */   GIR_EraseRootFromParent_Done,
     /* 136574 */ // Label 2377: @136574
     /* 136574 */ GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(136626), // Rule ID 320 //
     /* 136579 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136582 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136590 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136594 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 136601 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURWi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 136601 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 136604 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 136610 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136615 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136620 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136624 */   GIR_RootConstrainSelectedInstOperands,
     /* 136625 */   // GIR_Coverage, 320,
     /* 136625 */   GIR_EraseRootFromParent_Done,
     /* 136626 */ // Label 2378: @136626
     /* 136626 */ GIM_Try, /*On fail goto*//*Label 2379*/ GIMT_Encode4(136677), // Rule ID 323 //
     /* 136631 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 136634 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136637 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 136645 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136649 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 136656 */   // (st FPR32Op:{ *:[f32] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 136656 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 136659 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 136661 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136666 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136671 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136675 */   GIR_RootConstrainSelectedInstOperands,
     /* 136676 */   // GIR_Coverage, 323,
     /* 136676 */   GIR_EraseRootFromParent_Done,
     /* 136677 */ // Label 2379: @136677
     /* 136677 */ GIM_Try, /*On fail goto*//*Label 2380*/ GIMT_Encode4(136736), // Rule ID 326 //
     /* 136682 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136685 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136689 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136700 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136704 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 136711 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHHi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 136711 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 136714 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 136720 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136725 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136730 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136734 */   GIR_RootConstrainSelectedInstOperands,
     /* 136735 */   // GIR_Coverage, 326,
     /* 136735 */   GIR_EraseRootFromParent_Done,
     /* 136736 */ // Label 2380: @136736
     /* 136736 */ GIM_Try, /*On fail goto*//*Label 2381*/ GIMT_Encode4(136795), // Rule ID 327 //
     /* 136741 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136744 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136748 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136759 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136763 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 136770 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STURBBi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 136770 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 136773 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 136779 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136784 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136789 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136793 */   GIR_RootConstrainSelectedInstOperands,
     /* 136794 */   // GIR_Coverage, 327,
     /* 136794 */   GIR_EraseRootFromParent_Done,
     /* 136795 */ // Label 2381: @136795
     /* 136795 */ GIM_Try, /*On fail goto*//*Label 2382*/ GIMT_Encode4(136849), // Rule ID 7149 //
     /* 136800 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 136803 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136810 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136817 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136821 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 136828 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15902>>  =>  (STRBBui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 136828 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 136831 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 136833 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136838 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136843 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136847 */   GIR_RootConstrainSelectedInstOperands,
     /* 136848 */   // GIR_Coverage, 7149,
     /* 136848 */   GIR_EraseRootFromParent_Done,
     /* 136849 */ // Label 2382: @136849
     /* 136849 */ GIM_Try, /*On fail goto*//*Label 2383*/ GIMT_Encode4(136903), // Rule ID 7150 //
     /* 136854 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 136857 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136864 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136871 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136875 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 136882 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15902>>  =>  (STURBBi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 136882 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 136885 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 136887 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136892 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136897 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136901 */   GIR_RootConstrainSelectedInstOperands,
     /* 136902 */   // GIR_Coverage, 7150,
     /* 136902 */   GIR_EraseRootFromParent_Done,
     /* 136903 */ // Label 2383: @136903
     /* 136903 */ GIM_Try, /*On fail goto*//*Label 2384*/ GIMT_Encode4(136957), // Rule ID 7154 //
     /* 136908 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 136911 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136918 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136925 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136929 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 136936 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15909>>  =>  (STRHHui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 136936 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 136939 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 136941 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136946 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136951 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136955 */   GIR_RootConstrainSelectedInstOperands,
     /* 136956 */   // GIR_Coverage, 7154,
     /* 136956 */   GIR_EraseRootFromParent_Done,
     /* 136957 */ // Label 2384: @136957
     /* 136957 */ GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(137011), // Rule ID 7155 //
     /* 136962 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 136965 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136972 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136979 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136983 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 136990 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15909>>  =>  (STURHHi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 136990 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 136993 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 136995 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137000 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137005 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137009 */   GIR_RootConstrainSelectedInstOperands,
     /* 137010 */   // GIR_Coverage, 7155,
     /* 137010 */   GIR_EraseRootFromParent_Done,
     /* 137011 */ // Label 2385: @137011
     /* 137011 */ GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(137065), // Rule ID 7159 //
     /* 137016 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 137019 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 137026 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137033 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137037 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 137044 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15916>>  =>  (STRWui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 137044 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 137047 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 137049 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137054 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137059 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137063 */   GIR_RootConstrainSelectedInstOperands,
     /* 137064 */   // GIR_Coverage, 7159,
     /* 137064 */   GIR_EraseRootFromParent_Done,
     /* 137065 */ // Label 2386: @137065
     /* 137065 */ GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(137119), // Rule ID 7160 //
     /* 137070 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 137073 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 137080 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137087 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137091 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 137098 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15916>>  =>  (STURWi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 137098 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 137101 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 137103 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137108 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137113 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137117 */   GIR_RootConstrainSelectedInstOperands,
     /* 137118 */   // GIR_Coverage, 7160,
     /* 137118 */   GIR_EraseRootFromParent_Done,
     /* 137119 */ // Label 2387: @137119
     /* 137119 */ GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(137176), // Rule ID 7522 //
     /* 137124 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 137127 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 137130 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 137137 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137144 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137148 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 137155 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15900>>  =>  (STLURBi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 137155 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURBi),
     /* 137158 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 137160 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137165 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137170 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137174 */   GIR_RootConstrainSelectedInstOperands,
     /* 137175 */   // GIR_Coverage, 7522,
     /* 137175 */   GIR_EraseRootFromParent_Done,
     /* 137176 */ // Label 2388: @137176
     /* 137176 */ GIM_Try, /*On fail goto*//*Label 2389*/ GIMT_Encode4(137233), // Rule ID 7523 //
     /* 137181 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 137184 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 137187 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 137194 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137201 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137205 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 137212 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15907>>  =>  (STLURHi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 137212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURHi),
     /* 137215 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 137217 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137222 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137227 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137231 */   GIR_RootConstrainSelectedInstOperands,
     /* 137232 */   // GIR_Coverage, 7523,
     /* 137232 */   GIR_EraseRootFromParent_Done,
     /* 137233 */ // Label 2389: @137233
     /* 137233 */ GIM_Try, /*On fail goto*//*Label 2390*/ GIMT_Encode4(137290), // Rule ID 7524 //
     /* 137238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 137241 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 137244 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 137251 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137258 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137262 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 137269 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15914>>  =>  (STLURWi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 137269 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURWi),
     /* 137272 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 137274 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137279 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137284 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137288 */   GIR_RootConstrainSelectedInstOperands,
     /* 137289 */   // GIR_Coverage, 7524,
     /* 137289 */   GIR_EraseRootFromParent_Done,
     /* 137290 */ // Label 2390: @137290
     /* 137290 */ GIM_Try, /*On fail goto*//*Label 2391*/ GIMT_Encode4(137327), // Rule ID 7146 //
     /* 137295 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 137298 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 137305 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137312 */   // MIs[0] ptr
     /* 137312 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137316 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137320 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15900>>  =>  (STLRB GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 137320 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRB),
     /* 137325 */   GIR_RootConstrainSelectedInstOperands,
     /* 137326 */   // GIR_Coverage, 7146,
     /* 137326 */   GIR_Done,
     /* 137327 */ // Label 2391: @137327
     /* 137327 */ GIM_Try, /*On fail goto*//*Label 2392*/ GIMT_Encode4(137364), // Rule ID 7151 //
     /* 137332 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 137335 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 137342 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137349 */   // MIs[0] ptr
     /* 137349 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137353 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137357 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15907>>  =>  (STLRH GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 137357 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRH),
     /* 137362 */   GIR_RootConstrainSelectedInstOperands,
     /* 137363 */   // GIR_Coverage, 7151,
     /* 137363 */   GIR_Done,
     /* 137364 */ // Label 2392: @137364
     /* 137364 */ GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(137401), // Rule ID 7156 //
     /* 137369 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 137372 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 137379 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137386 */   // MIs[0] ptr
     /* 137386 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137390 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137394 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15914>>  =>  (STLRW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 137394 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRW),
     /* 137399 */   GIR_RootConstrainSelectedInstOperands,
     /* 137400 */   // GIR_Coverage, 7156,
     /* 137400 */   GIR_Done,
     /* 137401 */ // Label 2393: @137401
     /* 137401 */ GIM_Reject,
     /* 137402 */ // Label 2292: @137402
     /* 137402 */ GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(137508), // Rule ID 4549 //
     /* 137407 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137410 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137414 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 137418 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 137422 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 137426 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 137430 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137435 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 137439 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137443 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137445 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 137452 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 137452 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 137455 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137459 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137464 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 137470 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137475 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137480 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 137483 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137486 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137491 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137496 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137501 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 137506 */   GIR_RootConstrainSelectedInstOperands,
     /* 137507 */   // GIR_Coverage, 4549,
     /* 137507 */   GIR_EraseRootFromParent_Done,
     /* 137508 */ // Label 2394: @137508
     /* 137508 */ GIM_Try, /*On fail goto*//*Label 2395*/ GIMT_Encode4(137614), // Rule ID 4550 //
     /* 137513 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137516 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137520 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 137524 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 137528 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 137532 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 137536 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137541 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 137545 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137549 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137551 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 137558 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 137558 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 137561 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137565 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137570 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 137576 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137581 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137586 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 137589 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137592 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137597 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137602 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137607 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 137612 */   GIR_RootConstrainSelectedInstOperands,
     /* 137613 */   // GIR_Coverage, 4550,
     /* 137613 */   GIR_EraseRootFromParent_Done,
     /* 137614 */ // Label 2395: @137614
     /* 137614 */ GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(137720), // Rule ID 4551 //
     /* 137619 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137622 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137626 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 137630 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 137634 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 137638 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 137642 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137647 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 137651 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137655 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137657 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 137664 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 137664 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 137667 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137671 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137676 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 137682 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137687 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137692 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 137695 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137698 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137703 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137708 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137713 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 137718 */   GIR_RootConstrainSelectedInstOperands,
     /* 137719 */   // GIR_Coverage, 4551,
     /* 137719 */   GIR_EraseRootFromParent_Done,
     /* 137720 */ // Label 2396: @137720
     /* 137720 */ GIM_Try, /*On fail goto*//*Label 2397*/ GIMT_Encode4(137826), // Rule ID 4552 //
     /* 137725 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137728 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137732 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 137736 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 137740 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 137744 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 137748 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137753 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 137757 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137761 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137763 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 137770 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 137770 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 137773 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137777 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137782 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 137788 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137793 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 137801 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137804 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137809 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137814 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137819 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 137824 */   GIR_RootConstrainSelectedInstOperands,
     /* 137825 */   // GIR_Coverage, 4552,
     /* 137825 */   GIR_EraseRootFromParent_Done,
     /* 137826 */ // Label 2397: @137826
     /* 137826 */ GIM_Try, /*On fail goto*//*Label 2398*/ GIMT_Encode4(137927), // Rule ID 4575 //
     /* 137831 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137834 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137838 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 137842 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 137846 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 137850 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 137854 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137859 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 137863 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137867 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137869 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 137876 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 137876 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 137879 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137883 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137888 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 137894 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137899 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 137907 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137910 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137915 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137920 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 137925 */   GIR_RootConstrainSelectedInstOperands,
     /* 137926 */   // GIR_Coverage, 4575,
     /* 137926 */   GIR_EraseRootFromParent_Done,
     /* 137927 */ // Label 2398: @137927
     /* 137927 */ GIM_Try, /*On fail goto*//*Label 2399*/ GIMT_Encode4(138028), // Rule ID 4576 //
     /* 137932 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137935 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137939 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 137943 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 137947 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 137951 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 137955 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137960 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 137964 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137968 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137970 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 137977 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 137977 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 137980 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137984 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137989 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 137995 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138000 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138005 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 138008 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138011 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138016 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138021 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 138026 */   GIR_RootConstrainSelectedInstOperands,
     /* 138027 */   // GIR_Coverage, 4576,
     /* 138027 */   GIR_EraseRootFromParent_Done,
     /* 138028 */ // Label 2399: @138028
     /* 138028 */ GIM_Try, /*On fail goto*//*Label 2400*/ GIMT_Encode4(138129), // Rule ID 4602 //
     /* 138033 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138036 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138040 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 138044 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 138048 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 138052 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 138056 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138061 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 138065 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138069 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138071 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 138078 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 138078 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 138081 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138085 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138090 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 138096 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138101 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 138109 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138112 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138117 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138122 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 138127 */   GIR_RootConstrainSelectedInstOperands,
     /* 138128 */   // GIR_Coverage, 4602,
     /* 138128 */   GIR_EraseRootFromParent_Done,
     /* 138129 */ // Label 2400: @138129
     /* 138129 */ GIM_Try, /*On fail goto*//*Label 2401*/ GIMT_Encode4(138230), // Rule ID 4603 //
     /* 138134 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138137 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138141 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 138145 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 138149 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 138153 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 138157 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138162 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 138166 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138170 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138172 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 138179 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 138179 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 138182 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138186 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138191 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 138197 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138202 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138207 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 138210 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138213 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138218 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138223 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 138228 */   GIR_RootConstrainSelectedInstOperands,
     /* 138229 */   // GIR_Coverage, 4603,
     /* 138229 */   GIR_EraseRootFromParent_Done,
     /* 138230 */ // Label 2401: @138230
     /* 138230 */ GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(138305), // Rule ID 6531 //
     /* 138235 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138238 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138242 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 138246 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 138250 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 138254 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 138258 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138263 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 138267 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 138271 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 138275 */   // MIs[2] Operand 1
     /* 138275 */   // No operand predicates
     /* 138275 */   // MIs[0] Rn
     /* 138275 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138279 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 138283 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 138285 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i64 VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 138285 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i64),
     /* 138288 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 138292 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 138295 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138297 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 138303 */   GIR_RootConstrainSelectedInstOperands,
     /* 138304 */   // GIR_Coverage, 6531,
     /* 138304 */   GIR_EraseRootFromParent_Done,
     /* 138305 */ // Label 2402: @138305
     /* 138305 */ GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(138380), // Rule ID 6532 //
     /* 138310 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138313 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138317 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 138321 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 138325 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 138329 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 138333 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138338 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 138342 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 138346 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 138350 */   // MIs[2] Operand 1
     /* 138350 */   // No operand predicates
     /* 138350 */   // MIs[0] Rn
     /* 138350 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 138358 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 138360 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i64 VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 138360 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i64),
     /* 138363 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 138367 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 138370 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138372 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 138378 */   GIR_RootConstrainSelectedInstOperands,
     /* 138379 */   // GIR_Coverage, 6532,
     /* 138379 */   GIR_EraseRootFromParent_Done,
     /* 138380 */ // Label 2403: @138380
     /* 138380 */ GIM_Try, /*On fail goto*//*Label 2404*/ GIMT_Encode4(138433), // Rule ID 301 //
     /* 138385 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138388 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138396 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138400 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 138407 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXroW GPR64:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 138407 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroW),
     /* 138410 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 138412 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138417 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 138422 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 138427 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138431 */   GIR_RootConstrainSelectedInstOperands,
     /* 138432 */   // GIR_Coverage, 301,
     /* 138432 */   GIR_EraseRootFromParent_Done,
     /* 138433 */ // Label 2404: @138433
     /* 138433 */ GIM_Try, /*On fail goto*//*Label 2405*/ GIMT_Encode4(138486), // Rule ID 302 //
     /* 138438 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138441 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138449 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138453 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 138460 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXroX GPR64:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 138460 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroX),
     /* 138463 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 138465 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138470 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 138475 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 138480 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138484 */   GIR_RootConstrainSelectedInstOperands,
     /* 138485 */   // GIR_Coverage, 302,
     /* 138485 */   GIR_EraseRootFromParent_Done,
     /* 138486 */ // Label 2405: @138486
     /* 138486 */ GIM_Try, /*On fail goto*//*Label 2406*/ GIMT_Encode4(138542), // Rule ID 309 //
     /* 138491 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 138494 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138497 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138505 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138509 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 138516 */   // (st FPR64Op:{ *:[f64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 138516 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 138519 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 138521 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138526 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 138531 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 138536 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138540 */   GIR_RootConstrainSelectedInstOperands,
     /* 138541 */   // GIR_Coverage, 309,
     /* 138541 */   GIR_EraseRootFromParent_Done,
     /* 138542 */ // Label 2406: @138542
     /* 138542 */ GIM_Try, /*On fail goto*//*Label 2407*/ GIMT_Encode4(138598), // Rule ID 310 //
     /* 138547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 138550 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138553 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138561 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138565 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 138572 */   // (st FPR64Op:{ *:[f64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 138572 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 138575 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 138577 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138582 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 138587 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 138592 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138596 */   GIR_RootConstrainSelectedInstOperands,
     /* 138597 */   // GIR_Coverage, 310,
     /* 138597 */   GIR_EraseRootFromParent_Done,
     /* 138598 */ // Label 2407: @138598
     /* 138598 */ GIM_Try, /*On fail goto*//*Label 2408*/ GIMT_Encode4(138687), // Rule ID 4507 //
     /* 138603 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138606 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138610 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 138617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138621 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138625 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 138632 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 138632 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 138635 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138639 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138644 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 138650 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 138655 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138660 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 138663 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138666 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138671 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 138676 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 138681 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138685 */   GIR_RootConstrainSelectedInstOperands,
     /* 138686 */   // GIR_Coverage, 4507,
     /* 138686 */   GIR_EraseRootFromParent_Done,
     /* 138687 */ // Label 2408: @138687
     /* 138687 */ GIM_Try, /*On fail goto*//*Label 2409*/ GIMT_Encode4(138776), // Rule ID 4508 //
     /* 138692 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138695 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138699 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 138706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138710 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138714 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 138721 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 138721 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 138724 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138728 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138733 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 138739 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 138744 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138749 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 138752 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138755 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138760 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 138765 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 138770 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138774 */   GIR_RootConstrainSelectedInstOperands,
     /* 138775 */   // GIR_Coverage, 4508,
     /* 138775 */   GIR_EraseRootFromParent_Done,
     /* 138776 */ // Label 2409: @138776
     /* 138776 */ GIM_Try, /*On fail goto*//*Label 2410*/ GIMT_Encode4(138865), // Rule ID 4509 //
     /* 138781 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138784 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138788 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 138795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138799 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138803 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 138810 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 138810 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 138813 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138817 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138822 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 138828 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 138833 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 138841 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138844 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138849 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 138854 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 138859 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138863 */   GIR_RootConstrainSelectedInstOperands,
     /* 138864 */   // GIR_Coverage, 4509,
     /* 138864 */   GIR_EraseRootFromParent_Done,
     /* 138865 */ // Label 2410: @138865
     /* 138865 */ GIM_Try, /*On fail goto*//*Label 2411*/ GIMT_Encode4(138954), // Rule ID 4510 //
     /* 138870 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138873 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138877 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 138884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138888 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138892 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 138899 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 138899 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 138902 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138906 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138911 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 138917 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 138922 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138927 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 138930 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138933 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138938 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 138943 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 138948 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138952 */   GIR_RootConstrainSelectedInstOperands,
     /* 138953 */   // GIR_Coverage, 4510,
     /* 138953 */   GIR_EraseRootFromParent_Done,
     /* 138954 */ // Label 2411: @138954
     /* 138954 */ GIM_Try, /*On fail goto*//*Label 2412*/ GIMT_Encode4(139043), // Rule ID 4511 //
     /* 138959 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138962 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138966 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 138973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138977 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138981 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 138988 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 138988 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 138991 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138995 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139000 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 139006 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139011 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139016 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 139019 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139022 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139027 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139032 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 139037 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139041 */   GIR_RootConstrainSelectedInstOperands,
     /* 139042 */   // GIR_Coverage, 4511,
     /* 139042 */   GIR_EraseRootFromParent_Done,
     /* 139043 */ // Label 2412: @139043
     /* 139043 */ GIM_Try, /*On fail goto*//*Label 2413*/ GIMT_Encode4(139132), // Rule ID 4512 //
     /* 139048 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139051 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139055 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 139062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139066 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139070 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 139077 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 139077 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 139080 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139084 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139089 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 139095 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139100 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139105 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 139108 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139111 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139116 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139121 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 139126 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139130 */   GIR_RootConstrainSelectedInstOperands,
     /* 139131 */   // GIR_Coverage, 4512,
     /* 139131 */   GIR_EraseRootFromParent_Done,
     /* 139132 */ // Label 2413: @139132
     /* 139132 */ GIM_Try, /*On fail goto*//*Label 2414*/ GIMT_Encode4(139185), // Rule ID 4523 //
     /* 139137 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139140 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139148 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139152 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 139159 */   // (st FPR64:{ *:[v1i64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 139159 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 139162 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139164 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139169 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139174 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 139179 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139183 */   GIR_RootConstrainSelectedInstOperands,
     /* 139184 */   // GIR_Coverage, 4523,
     /* 139184 */   GIR_EraseRootFromParent_Done,
     /* 139185 */ // Label 2414: @139185
     /* 139185 */ GIM_Try, /*On fail goto*//*Label 2415*/ GIMT_Encode4(139238), // Rule ID 4524 //
     /* 139190 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139193 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139201 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139205 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 139212 */   // (st FPR64:{ *:[v1i64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 139212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 139215 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139217 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139222 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139227 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 139232 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139236 */   GIR_RootConstrainSelectedInstOperands,
     /* 139237 */   // GIR_Coverage, 4524,
     /* 139237 */   GIR_EraseRootFromParent_Done,
     /* 139238 */ // Label 2415: @139238
     /* 139238 */ GIM_Try, /*On fail goto*//*Label 2416*/ GIMT_Encode4(139291), // Rule ID 4525 //
     /* 139243 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139246 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139254 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139258 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 139265 */   // (st FPR64:{ *:[v1f64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 139265 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 139268 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139270 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139275 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139280 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 139285 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139289 */   GIR_RootConstrainSelectedInstOperands,
     /* 139290 */   // GIR_Coverage, 4525,
     /* 139290 */   GIR_EraseRootFromParent_Done,
     /* 139291 */ // Label 2416: @139291
     /* 139291 */ GIM_Try, /*On fail goto*//*Label 2417*/ GIMT_Encode4(139344), // Rule ID 4526 //
     /* 139296 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139299 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139307 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139311 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 139318 */   // (st FPR64:{ *:[v1f64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 139318 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 139321 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139323 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139328 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139333 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 139338 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139342 */   GIR_RootConstrainSelectedInstOperands,
     /* 139343 */   // GIR_Coverage, 4526,
     /* 139343 */   GIR_EraseRootFromParent_Done,
     /* 139344 */ // Label 2417: @139344
     /* 139344 */ GIM_Try, /*On fail goto*//*Label 2418*/ GIMT_Encode4(139396), // Rule ID 311 //
     /* 139349 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139352 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139360 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139364 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 139371 */   // (st GPR64z:{ *:[i64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXui GPR64z:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 139371 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXui),
     /* 139374 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::XZR), // Rt
     /* 139380 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139385 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139390 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139394 */   GIR_RootConstrainSelectedInstOperands,
     /* 139395 */   // GIR_Coverage, 311,
     /* 139395 */   GIR_EraseRootFromParent_Done,
     /* 139396 */ // Label 2418: @139396
     /* 139396 */ GIM_Try, /*On fail goto*//*Label 2419*/ GIMT_Encode4(139447), // Rule ID 316 //
     /* 139401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 139404 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139407 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139415 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139419 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 139426 */   // (st FPR64Op:{ *:[f64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 139426 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 139429 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139431 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139436 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139441 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139445 */   GIR_RootConstrainSelectedInstOperands,
     /* 139446 */   // GIR_Coverage, 316,
     /* 139446 */   GIR_EraseRootFromParent_Done,
     /* 139447 */ // Label 2419: @139447
     /* 139447 */ GIM_Try, /*On fail goto*//*Label 2420*/ GIMT_Encode4(139495), // Rule ID 4553 //
     /* 139452 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139455 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139463 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139467 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 139474 */   // (st FPR64:{ *:[v1i64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 139474 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 139477 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139479 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139484 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139489 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139493 */   GIR_RootConstrainSelectedInstOperands,
     /* 139494 */   // GIR_Coverage, 4553,
     /* 139494 */   GIR_EraseRootFromParent_Done,
     /* 139495 */ // Label 2420: @139495
     /* 139495 */ GIM_Try, /*On fail goto*//*Label 2421*/ GIMT_Encode4(139543), // Rule ID 4554 //
     /* 139500 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139503 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139511 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139515 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 139522 */   // (st FPR64:{ *:[v1f64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 139522 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 139525 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139527 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139532 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139537 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139541 */   GIR_RootConstrainSelectedInstOperands,
     /* 139542 */   // GIR_Coverage, 4554,
     /* 139542 */   GIR_EraseRootFromParent_Done,
     /* 139543 */ // Label 2421: @139543
     /* 139543 */ GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(139627), // Rule ID 4568 //
     /* 139548 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139551 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139555 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 139562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139566 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139570 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 139577 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 139577 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 139580 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139584 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139589 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 139595 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139600 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 139608 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139611 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139616 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139621 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139625 */   GIR_RootConstrainSelectedInstOperands,
     /* 139626 */   // GIR_Coverage, 4568,
     /* 139626 */   GIR_EraseRootFromParent_Done,
     /* 139627 */ // Label 2422: @139627
     /* 139627 */ GIM_Try, /*On fail goto*//*Label 2423*/ GIMT_Encode4(139711), // Rule ID 4569 //
     /* 139632 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139635 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139639 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 139646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139650 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139654 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 139661 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 139661 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 139664 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139668 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139673 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 139679 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139684 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139689 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 139692 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139695 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139700 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139705 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139709 */   GIR_RootConstrainSelectedInstOperands,
     /* 139710 */   // GIR_Coverage, 4569,
     /* 139710 */   GIR_EraseRootFromParent_Done,
     /* 139711 */ // Label 2423: @139711
     /* 139711 */ GIM_Try, /*On fail goto*//*Label 2424*/ GIMT_Encode4(139795), // Rule ID 4570 //
     /* 139716 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139719 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139723 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 139730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139734 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139738 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 139745 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 139745 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 139748 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139752 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139757 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 139763 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139768 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139773 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 139776 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139779 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139784 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139789 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139793 */   GIR_RootConstrainSelectedInstOperands,
     /* 139794 */   // GIR_Coverage, 4570,
     /* 139794 */   GIR_EraseRootFromParent_Done,
     /* 139795 */ // Label 2424: @139795
     /* 139795 */ GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(139872), // Rule ID 7170 //
     /* 139800 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 139803 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 139810 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 139813 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 139817 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 139821 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 139825 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139830 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139834 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139836 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 139843 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15923>>  =>  (STRDroW FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 139843 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 139846 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 139850 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139855 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139860 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 139865 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 139870 */   GIR_RootConstrainSelectedInstOperands,
     /* 139871 */   // GIR_Coverage, 7170,
     /* 139871 */   GIR_EraseRootFromParent_Done,
     /* 139872 */ // Label 2425: @139872
     /* 139872 */ GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(139949), // Rule ID 7171 //
     /* 139877 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 139880 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 139887 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 139890 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 139894 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 139898 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 139902 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139907 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139911 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139913 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 139920 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15923>>  =>  (STRDroX FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 139920 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 139923 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 139927 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139932 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139937 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 139942 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 139947 */   GIR_RootConstrainSelectedInstOperands,
     /* 139948 */   // GIR_Coverage, 7171,
     /* 139948 */   GIR_EraseRootFromParent_Done,
     /* 139949 */ // Label 2426: @139949
     /* 139949 */ GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(140008), // Rule ID 7162 //
     /* 139954 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 139957 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 139964 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 139967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139971 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139975 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 139982 */   // (atomic_store GPR64:{ *:[i64] }:$val, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15923>>  =>  (STRXroW GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 139982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroW),
     /* 139985 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 139987 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139992 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139997 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140002 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140006 */   GIR_RootConstrainSelectedInstOperands,
     /* 140007 */   // GIR_Coverage, 7162,
     /* 140007 */   GIR_EraseRootFromParent_Done,
     /* 140008 */ // Label 2427: @140008
     /* 140008 */ GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(140067), // Rule ID 7163 //
     /* 140013 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 140016 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 140023 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 140026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140030 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140034 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 140041 */   // (atomic_store GPR64:{ *:[i64] }:$val, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15923>>  =>  (STRXroX GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 140041 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroX),
     /* 140044 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 140046 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140051 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 140056 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140061 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140065 */   GIR_RootConstrainSelectedInstOperands,
     /* 140066 */   // GIR_Coverage, 7163,
     /* 140066 */   GIR_EraseRootFromParent_Done,
     /* 140067 */ // Label 2428: @140067
     /* 140067 */ GIM_Try, /*On fail goto*//*Label 2429*/ GIMT_Encode4(140139), // Rule ID 7172 //
     /* 140072 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 140075 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 140082 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 140085 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 140089 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 140093 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 140097 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140102 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140106 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140108 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 140115 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15923>>  =>  (STRDui FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 140115 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 140118 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 140122 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140127 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140132 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140137 */   GIR_RootConstrainSelectedInstOperands,
     /* 140138 */   // GIR_Coverage, 7172,
     /* 140138 */   GIR_EraseRootFromParent_Done,
     /* 140139 */ // Label 2429: @140139
     /* 140139 */ GIM_Try, /*On fail goto*//*Label 2430*/ GIMT_Encode4(140211), // Rule ID 7173 //
     /* 140144 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 140147 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 140154 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 140157 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 140161 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 140165 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 140169 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140174 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140178 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140180 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 140187 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15923>>  =>  (STURDi FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 140187 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 140190 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 140194 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140199 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140204 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140209 */   GIR_RootConstrainSelectedInstOperands,
     /* 140210 */   // GIR_Coverage, 7173,
     /* 140210 */   GIR_EraseRootFromParent_Done,
     /* 140211 */ // Label 2430: @140211
     /* 140211 */ GIM_Try, /*On fail goto*//*Label 2431*/ GIMT_Encode4(140308), // Rule ID 7514 //
     /* 140216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 140219 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 140222 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 140229 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 140232 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 140236 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 140240 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 140244 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 140248 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 140252 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 140256 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 140260 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140265 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 140269 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 140273 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 140277 */   // MIs[3] Operand 1
     /* 140277 */   // No operand predicates
     /* 140277 */   // MIs[0] Rn
     /* 140277 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 140285 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 140287 */   // (atomic_store (bitconvert:{ *:[i64] } (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15921>>  =>  (STL1 VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 140287 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 140290 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vt
     /* 140294 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 140297 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140299 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 140306 */   GIR_RootConstrainSelectedInstOperands,
     /* 140307 */   // GIR_Coverage, 7514,
     /* 140307 */   GIR_EraseRootFromParent_Done,
     /* 140308 */ // Label 2431: @140308
     /* 140308 */ GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(140360), // Rule ID 319 //
     /* 140313 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140316 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 140320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140324 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140328 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 140335 */   // (st GPR64z:{ *:[i64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURXi GPR64z:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 140335 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURXi),
     /* 140338 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::XZR), // Rt
     /* 140344 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140349 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140354 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140358 */   GIR_RootConstrainSelectedInstOperands,
     /* 140359 */   // GIR_Coverage, 319,
     /* 140359 */   GIR_EraseRootFromParent_Done,
     /* 140360 */ // Label 2432: @140360
     /* 140360 */ GIM_Try, /*On fail goto*//*Label 2433*/ GIMT_Encode4(140411), // Rule ID 324 //
     /* 140365 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140368 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140371 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 140375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140379 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140383 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 140390 */   // (st FPR64Op:{ *:[f64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 140390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 140393 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140395 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140400 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140405 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140409 */   GIR_RootConstrainSelectedInstOperands,
     /* 140410 */   // GIR_Coverage, 324,
     /* 140410 */   GIR_EraseRootFromParent_Done,
     /* 140411 */ // Label 2433: @140411
     /* 140411 */ GIM_Try, /*On fail goto*//*Label 2434*/ GIMT_Encode4(140465), // Rule ID 7164 //
     /* 140416 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 140419 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 140426 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 140429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140433 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140437 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 140444 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15923>>  =>  (STRXui GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 140444 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXui),
     /* 140447 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 140449 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140454 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140459 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140463 */   GIR_RootConstrainSelectedInstOperands,
     /* 140464 */   // GIR_Coverage, 7164,
     /* 140464 */   GIR_EraseRootFromParent_Done,
     /* 140465 */ // Label 2434: @140465
     /* 140465 */ GIM_Try, /*On fail goto*//*Label 2435*/ GIMT_Encode4(140519), // Rule ID 7165 //
     /* 140470 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 140473 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 140480 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 140483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140487 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140491 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 140498 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15923>>  =>  (STURXi GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 140498 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURXi),
     /* 140501 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 140503 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140508 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140513 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140517 */   GIR_RootConstrainSelectedInstOperands,
     /* 140518 */   // GIR_Coverage, 7165,
     /* 140518 */   GIR_EraseRootFromParent_Done,
     /* 140519 */ // Label 2435: @140519
     /* 140519 */ GIM_Try, /*On fail goto*//*Label 2436*/ GIMT_Encode4(140576), // Rule ID 7525 //
     /* 140524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 140527 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 140530 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 140537 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 140540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140544 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140548 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 140555 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15921>>  =>  (STLURXi GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 140555 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURXi),
     /* 140558 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 140560 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140565 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140570 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140574 */   GIR_RootConstrainSelectedInstOperands,
     /* 140575 */   // GIR_Coverage, 7525,
     /* 140575 */   GIR_EraseRootFromParent_Done,
     /* 140576 */ // Label 2436: @140576
     /* 140576 */ GIM_Try, /*On fail goto*//*Label 2437*/ GIMT_Encode4(140624), // Rule ID 4577 //
     /* 140581 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140584 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 140588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140592 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140596 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 140603 */   // (st FPR64:{ *:[v1f64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 140603 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 140606 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140608 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140613 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140618 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140622 */   GIR_RootConstrainSelectedInstOperands,
     /* 140623 */   // GIR_Coverage, 4577,
     /* 140623 */   GIR_EraseRootFromParent_Done,
     /* 140624 */ // Label 2437: @140624
     /* 140624 */ GIM_Try, /*On fail goto*//*Label 2438*/ GIMT_Encode4(140672), // Rule ID 4578 //
     /* 140629 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140632 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 140636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140640 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140644 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 140651 */   // (st FPR64:{ *:[v1i64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 140651 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 140654 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140656 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140661 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140666 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140670 */   GIR_RootConstrainSelectedInstOperands,
     /* 140671 */   // GIR_Coverage, 4578,
     /* 140671 */   GIR_EraseRootFromParent_Done,
     /* 140672 */ // Label 2438: @140672
     /* 140672 */ GIM_Try, /*On fail goto*//*Label 2439*/ GIMT_Encode4(140756), // Rule ID 4593 //
     /* 140677 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140680 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 140684 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 140691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140695 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140699 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 140706 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STURWi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 140706 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 140709 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 140713 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140718 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 140724 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140729 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140734 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 140737 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140740 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140745 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140750 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140754 */   GIR_RootConstrainSelectedInstOperands,
     /* 140755 */   // GIR_Coverage, 4593,
     /* 140755 */   GIR_EraseRootFromParent_Done,
     /* 140756 */ // Label 2439: @140756
     /* 140756 */ GIM_Try, /*On fail goto*//*Label 2440*/ GIMT_Encode4(140840), // Rule ID 4594 //
     /* 140761 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140764 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 140768 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 140775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140779 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140783 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 140790 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHHi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 140790 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 140793 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 140797 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140802 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 140808 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140813 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140818 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 140821 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140824 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140829 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140834 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140838 */   GIR_RootConstrainSelectedInstOperands,
     /* 140839 */   // GIR_Coverage, 4594,
     /* 140839 */   GIR_EraseRootFromParent_Done,
     /* 140840 */ // Label 2440: @140840
     /* 140840 */ GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(140924), // Rule ID 4595 //
     /* 140845 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140848 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 140852 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 140859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140863 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140867 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 140874 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STURBBi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 140874 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 140877 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 140881 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140886 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 140892 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140897 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 140905 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140908 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140913 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140918 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140922 */   GIR_RootConstrainSelectedInstOperands,
     /* 140923 */   // GIR_Coverage, 4595,
     /* 140923 */   GIR_EraseRootFromParent_Done,
     /* 140924 */ // Label 2441: @140924
     /* 140924 */ GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(141008), // Rule ID 7513 //
     /* 140929 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 140932 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 140935 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 140942 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 140945 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 140949 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 140953 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 140957 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 140961 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140966 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 140970 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 140974 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 140978 */   // MIs[2] Operand 1
     /* 140978 */   // No operand predicates
     /* 140978 */   // MIs[0] Rn
     /* 140978 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140982 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 140986 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 140988 */   // (atomic_store (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15921>>  =>  (STL1 VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 140988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 140991 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 140995 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 140998 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 141000 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 141006 */   GIR_RootConstrainSelectedInstOperands,
     /* 141007 */   // GIR_Coverage, 7513,
     /* 141007 */   GIR_EraseRootFromParent_Done,
     /* 141008 */ // Label 2442: @141008
     /* 141008 */ GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(141106), // Rule ID 7515 //
     /* 141013 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 141016 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 141019 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 141026 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 141029 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 141033 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 141037 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 141041 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141046 */   // MIs[0] Rn
     /* 141046 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141050 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 141054 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141056 */   // (atomic_store (bitconvert:{ *:[i64] } VecListOne64:{ *:[v1f64] }:$Vt), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15921>>  =>  (STL1 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, VecListOne64:{ *:[v1f64] }:$Vt, dsub:{ *:[i32] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn)
     /* 141056 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 141059 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 141063 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141068 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 141071 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 141075 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 141078 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141083 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141088 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 141091 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 141094 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141097 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 141099 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141104 */   GIR_RootConstrainSelectedInstOperands,
     /* 141105 */   // GIR_Coverage, 7515,
     /* 141105 */   GIR_EraseRootFromParent_Done,
     /* 141106 */ // Label 2443: @141106
     /* 141106 */ GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(141143), // Rule ID 7161 //
     /* 141111 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 141114 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 141121 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 141124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141128 */   // MIs[0] ptr
     /* 141128 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141132 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 141136 */   // (atomic_store GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15921>>  =>  (STLRX GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 141136 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRX),
     /* 141141 */   GIR_RootConstrainSelectedInstOperands,
     /* 141142 */   // GIR_Coverage, 7161,
     /* 141142 */   GIR_Done,
     /* 141143 */ // Label 2444: @141143
     /* 141143 */ GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(141170), // Rule ID 6471 //
     /* 141148 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141151 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 141155 */   // MIs[0] Rn
     /* 141155 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141159 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 141163 */   // (st v1i64:{ *:[v1i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev1d v1i64:{ *:[v1i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 141163 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev1d),
     /* 141168 */   GIR_RootConstrainSelectedInstOperands,
     /* 141169 */   // GIR_Coverage, 6471,
     /* 141169 */   GIR_Done,
     /* 141170 */ // Label 2445: @141170
     /* 141170 */ GIM_Reject,
     /* 141171 */ // Label 2293: @141171
     /* 141171 */ GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(141376),
     /* 141176 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141179 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 141183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141187 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141191 */   GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(141232), // Rule ID 4505 //
     /* 141196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSTRQro),
     /* 141199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 141206 */     // (st FPR128:{ *:[f128] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 141206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 141209 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141226 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141230 */     GIR_RootConstrainSelectedInstOperands,
     /* 141231 */     // GIR_Coverage, 4505,
     /* 141231 */     GIR_EraseRootFromParent_Done,
     /* 141232 */   // Label 2447: @141232
     /* 141232 */   GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(141273), // Rule ID 4506 //
     /* 141237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSTRQro),
     /* 141240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 141247 */     // (st FPR128:{ *:[f128] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 141247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 141250 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141267 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141271 */     GIR_RootConstrainSelectedInstOperands,
     /* 141272 */     // GIR_Coverage, 4506,
     /* 141272 */     GIR_EraseRootFromParent_Done,
     /* 141273 */   // Label 2448: @141273
     /* 141273 */   GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(141306), // Rule ID 4560 //
     /* 141278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 141285 */     // (st FPR128:{ *:[f128] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 141285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 141288 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141300 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141304 */     GIR_RootConstrainSelectedInstOperands,
     /* 141305 */     // GIR_Coverage, 4560,
     /* 141305 */     GIR_EraseRootFromParent_Done,
     /* 141306 */   // Label 2449: @141306
     /* 141306 */   GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(141339), // Rule ID 4584 //
     /* 141311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 141318 */     // (st FPR128:{ *:[f128] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 141318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 141321 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141333 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141337 */     GIR_RootConstrainSelectedInstOperands,
     /* 141338 */     // GIR_Coverage, 4584,
     /* 141338 */     GIR_EraseRootFromParent_Done,
     /* 141339 */   // Label 2450: @141339
     /* 141339 */   GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(141375), // Rule ID 325 //
     /* 141344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 141354 */     // (st FPR128Op:{ *:[f128] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128Op:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 141354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 141357 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141369 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141373 */     GIR_RootConstrainSelectedInstOperands,
     /* 141374 */     // GIR_Coverage, 325,
     /* 141374 */     GIR_EraseRootFromParent_Done,
     /* 141375 */   // Label 2451: @141375
     /* 141375 */   GIM_Reject,
     /* 141376 */ // Label 2446: @141376
     /* 141376 */ GIM_Reject,
     /* 141377 */ // Label 2294: @141377
     /* 141377 */ GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(141782),
     /* 141382 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141385 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 141389 */   GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(141438), // Rule ID 4513 //
     /* 141394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141401 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 141412 */     // (st FPR64:{ *:[v2i32] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 141412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 141415 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141432 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141436 */     GIR_RootConstrainSelectedInstOperands,
     /* 141437 */     // GIR_Coverage, 4513,
     /* 141437 */     GIR_EraseRootFromParent_Done,
     /* 141438 */   // Label 2453: @141438
     /* 141438 */   GIM_Try, /*On fail goto*//*Label 2454*/ GIMT_Encode4(141487), // Rule ID 4514 //
     /* 141443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141450 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 141461 */     // (st FPR64:{ *:[v2i32] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 141461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 141464 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141481 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141485 */     GIR_RootConstrainSelectedInstOperands,
     /* 141486 */     // GIR_Coverage, 4514,
     /* 141486 */     GIR_EraseRootFromParent_Done,
     /* 141487 */   // Label 2454: @141487
     /* 141487 */   GIM_Try, /*On fail goto*//*Label 2455*/ GIMT_Encode4(141536), // Rule ID 4515 //
     /* 141492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141499 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 141510 */     // (st FPR64:{ *:[v2f32] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 141510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 141513 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141530 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141534 */     GIR_RootConstrainSelectedInstOperands,
     /* 141535 */     // GIR_Coverage, 4515,
     /* 141535 */     GIR_EraseRootFromParent_Done,
     /* 141536 */   // Label 2455: @141536
     /* 141536 */   GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(141585), // Rule ID 4516 //
     /* 141541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141548 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 141559 */     // (st FPR64:{ *:[v2f32] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 141559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 141562 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141579 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141583 */     GIR_RootConstrainSelectedInstOperands,
     /* 141584 */     // GIR_Coverage, 4516,
     /* 141584 */     GIR_EraseRootFromParent_Done,
     /* 141585 */   // Label 2456: @141585
     /* 141585 */   GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(141629), // Rule ID 4555 //
     /* 141590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141597 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 141608 */     // (st FPR64:{ *:[v2f32] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 141608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 141611 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141623 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141627 */     GIR_RootConstrainSelectedInstOperands,
     /* 141628 */     // GIR_Coverage, 4555,
     /* 141628 */     GIR_EraseRootFromParent_Done,
     /* 141629 */   // Label 2457: @141629
     /* 141629 */   GIM_Try, /*On fail goto*//*Label 2458*/ GIMT_Encode4(141673), // Rule ID 4558 //
     /* 141634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141641 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 141652 */     // (st FPR64:{ *:[v2i32] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 141652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 141655 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141671 */     GIR_RootConstrainSelectedInstOperands,
     /* 141672 */     // GIR_Coverage, 4558,
     /* 141672 */     GIR_EraseRootFromParent_Done,
     /* 141673 */   // Label 2458: @141673
     /* 141673 */   GIM_Try, /*On fail goto*//*Label 2459*/ GIMT_Encode4(141717), // Rule ID 4579 //
     /* 141678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141685 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 141696 */     // (st FPR64:{ *:[v2f32] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 141696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 141699 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141711 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141715 */     GIR_RootConstrainSelectedInstOperands,
     /* 141716 */     // GIR_Coverage, 4579,
     /* 141716 */     GIR_EraseRootFromParent_Done,
     /* 141717 */   // Label 2459: @141717
     /* 141717 */   GIM_Try, /*On fail goto*//*Label 2460*/ GIMT_Encode4(141761), // Rule ID 4582 //
     /* 141722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141729 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 141740 */     // (st FPR64:{ *:[v2i32] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 141740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 141743 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141755 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141759 */     GIR_RootConstrainSelectedInstOperands,
     /* 141760 */     // GIR_Coverage, 4582,
     /* 141760 */     GIR_EraseRootFromParent_Done,
     /* 141761 */   // Label 2460: @141761
     /* 141761 */   GIM_Try, /*On fail goto*//*Label 2461*/ GIMT_Encode4(141781), // Rule ID 6470 //
     /* 141766 */     // MIs[0] Rn
     /* 141766 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 141774 */     // (st v2i32:{ *:[v2i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev2s v2i32:{ *:[v2i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 141774 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev2s),
     /* 141779 */     GIR_RootConstrainSelectedInstOperands,
     /* 141780 */     // GIR_Coverage, 6470,
     /* 141780 */     GIR_Done,
     /* 141781 */   // Label 2461: @141781
     /* 141781 */   GIM_Reject,
     /* 141782 */ // Label 2452: @141782
     /* 141782 */ GIM_Reject,
     /* 141783 */ // Label 2295: @141783
     /* 141783 */ GIM_Try, /*On fail goto*//*Label 2462*/ GIMT_Encode4(142232),
     /* 141788 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141791 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 141795 */   GIM_Try, /*On fail goto*//*Label 2463*/ GIMT_Encode4(141844), // Rule ID 4527 //
     /* 141800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 141803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141807 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 141818 */     // (st FPR128:{ *:[v2i64] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 141818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 141821 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141838 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141842 */     GIR_RootConstrainSelectedInstOperands,
     /* 141843 */     // GIR_Coverage, 4527,
     /* 141843 */     GIR_EraseRootFromParent_Done,
     /* 141844 */   // Label 2463: @141844
     /* 141844 */   GIM_Try, /*On fail goto*//*Label 2464*/ GIMT_Encode4(141893), // Rule ID 4528 //
     /* 141849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 141852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141856 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 141867 */     // (st FPR128:{ *:[v2i64] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 141867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 141870 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141887 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141891 */     GIR_RootConstrainSelectedInstOperands,
     /* 141892 */     // GIR_Coverage, 4528,
     /* 141892 */     GIR_EraseRootFromParent_Done,
     /* 141893 */   // Label 2464: @141893
     /* 141893 */   GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(141942), // Rule ID 4529 //
     /* 141898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 141901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141905 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 141916 */     // (st FPR128:{ *:[v2f64] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 141916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 141919 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141936 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141940 */     GIR_RootConstrainSelectedInstOperands,
     /* 141941 */     // GIR_Coverage, 4529,
     /* 141941 */     GIR_EraseRootFromParent_Done,
     /* 141942 */   // Label 2465: @141942
     /* 141942 */   GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(141991), // Rule ID 4530 //
     /* 141947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 141950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141954 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 141965 */     // (st FPR128:{ *:[v2f64] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 141965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 141968 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141989 */     GIR_RootConstrainSelectedInstOperands,
     /* 141990 */     // GIR_Coverage, 4530,
     /* 141990 */     GIR_EraseRootFromParent_Done,
     /* 141991 */   // Label 2466: @141991
     /* 141991 */   GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(142035), // Rule ID 4562 //
     /* 141996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142003 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 142014 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 142014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 142017 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142029 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142033 */     GIR_RootConstrainSelectedInstOperands,
     /* 142034 */     // GIR_Coverage, 4562,
     /* 142034 */     GIR_EraseRootFromParent_Done,
     /* 142035 */   // Label 2467: @142035
     /* 142035 */   GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(142079), // Rule ID 4566 //
     /* 142040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142047 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 142058 */     // (st FPR128:{ *:[v2i64] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 142058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 142061 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142073 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142077 */     GIR_RootConstrainSelectedInstOperands,
     /* 142078 */     // GIR_Coverage, 4566,
     /* 142078 */     GIR_EraseRootFromParent_Done,
     /* 142079 */   // Label 2468: @142079
     /* 142079 */   GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(142123), // Rule ID 4586 //
     /* 142084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142091 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 142102 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 142102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 142105 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142117 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142121 */     GIR_RootConstrainSelectedInstOperands,
     /* 142122 */     // GIR_Coverage, 4586,
     /* 142122 */     GIR_EraseRootFromParent_Done,
     /* 142123 */   // Label 2469: @142123
     /* 142123 */   GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(142167), // Rule ID 4590 //
     /* 142128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142135 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 142146 */     // (st FPR128:{ *:[v2i64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 142146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 142149 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142161 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142165 */     GIR_RootConstrainSelectedInstOperands,
     /* 142166 */     // GIR_Coverage, 4590,
     /* 142166 */     GIR_EraseRootFromParent_Done,
     /* 142167 */   // Label 2470: @142167
     /* 142167 */   GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(142211), // Rule ID 4591 //
     /* 142172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142179 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 142190 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 142190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 142193 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142205 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142209 */     GIR_RootConstrainSelectedInstOperands,
     /* 142210 */     // GIR_Coverage, 4591,
     /* 142210 */     GIR_EraseRootFromParent_Done,
     /* 142211 */   // Label 2471: @142211
     /* 142211 */   GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(142231), // Rule ID 6467 //
     /* 142216 */     // MIs[0] Rn
     /* 142216 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 142220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 142224 */     // (st v2i64:{ *:[v2i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev2d v2i64:{ *:[v2i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 142224 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev2d),
     /* 142229 */     GIR_RootConstrainSelectedInstOperands,
     /* 142230 */     // GIR_Coverage, 6467,
     /* 142230 */     GIR_Done,
     /* 142231 */   // Label 2472: @142231
     /* 142231 */   GIM_Reject,
     /* 142232 */ // Label 2462: @142232
     /* 142232 */ GIM_Reject,
     /* 142233 */ // Label 2296: @142233
     /* 142233 */ GIM_Try, /*On fail goto*//*Label 2473*/ GIMT_Encode4(142638),
     /* 142238 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142241 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 142245 */   GIM_Try, /*On fail goto*//*Label 2474*/ GIMT_Encode4(142294), // Rule ID 4517 //
     /* 142250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142257 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 142268 */     // (st FPR64:{ *:[v4i16] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 142268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 142271 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 142283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 142288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142292 */     GIR_RootConstrainSelectedInstOperands,
     /* 142293 */     // GIR_Coverage, 4517,
     /* 142293 */     GIR_EraseRootFromParent_Done,
     /* 142294 */   // Label 2474: @142294
     /* 142294 */   GIM_Try, /*On fail goto*//*Label 2475*/ GIMT_Encode4(142343), // Rule ID 4518 //
     /* 142299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142306 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 142317 */     // (st FPR64:{ *:[v4i16] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 142317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 142320 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 142332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 142337 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142341 */     GIR_RootConstrainSelectedInstOperands,
     /* 142342 */     // GIR_Coverage, 4518,
     /* 142342 */     GIR_EraseRootFromParent_Done,
     /* 142343 */   // Label 2475: @142343
     /* 142343 */   GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(142392), // Rule ID 4521 //
     /* 142348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142355 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 142366 */     // (st FPR64:{ *:[v4f16] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 142366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 142369 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 142381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 142386 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142390 */     GIR_RootConstrainSelectedInstOperands,
     /* 142391 */     // GIR_Coverage, 4521,
     /* 142391 */     GIR_EraseRootFromParent_Done,
     /* 142392 */   // Label 2476: @142392
     /* 142392 */   GIM_Try, /*On fail goto*//*Label 2477*/ GIMT_Encode4(142441), // Rule ID 4522 //
     /* 142397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142404 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 142415 */     // (st FPR64:{ *:[v4f16] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 142415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 142418 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 142430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 142435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142439 */     GIR_RootConstrainSelectedInstOperands,
     /* 142440 */     // GIR_Coverage, 4522,
     /* 142440 */     GIR_EraseRootFromParent_Done,
     /* 142441 */   // Label 2477: @142441
     /* 142441 */   GIM_Try, /*On fail goto*//*Label 2478*/ GIMT_Encode4(142485), // Rule ID 4557 //
     /* 142446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142453 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 142464 */     // (st FPR64:{ *:[v4i16] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 142464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 142467 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142483 */     GIR_RootConstrainSelectedInstOperands,
     /* 142484 */     // GIR_Coverage, 4557,
     /* 142484 */     GIR_EraseRootFromParent_Done,
     /* 142485 */   // Label 2478: @142485
     /* 142485 */   GIM_Try, /*On fail goto*//*Label 2479*/ GIMT_Encode4(142529), // Rule ID 4559 //
     /* 142490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142497 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 142508 */     // (st FPR64:{ *:[v4f16] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 142508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 142511 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142523 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142527 */     GIR_RootConstrainSelectedInstOperands,
     /* 142528 */     // GIR_Coverage, 4559,
     /* 142528 */     GIR_EraseRootFromParent_Done,
     /* 142529 */   // Label 2479: @142529
     /* 142529 */   GIM_Try, /*On fail goto*//*Label 2480*/ GIMT_Encode4(142573), // Rule ID 4581 //
     /* 142534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142541 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 142552 */     // (st FPR64:{ *:[v4i16] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 142552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 142555 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142567 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142571 */     GIR_RootConstrainSelectedInstOperands,
     /* 142572 */     // GIR_Coverage, 4581,
     /* 142572 */     GIR_EraseRootFromParent_Done,
     /* 142573 */   // Label 2480: @142573
     /* 142573 */   GIM_Try, /*On fail goto*//*Label 2481*/ GIMT_Encode4(142617), // Rule ID 4583 //
     /* 142578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142585 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 142596 */     // (st FPR64:{ *:[v4f16] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 142596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 142599 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142615 */     GIR_RootConstrainSelectedInstOperands,
     /* 142616 */     // GIR_Coverage, 4583,
     /* 142616 */     GIR_EraseRootFromParent_Done,
     /* 142617 */   // Label 2481: @142617
     /* 142617 */   GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(142637), // Rule ID 6469 //
     /* 142622 */     // MIs[0] Rn
     /* 142622 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 142626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 142630 */     // (st v4i16:{ *:[v4i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev4h v4i16:{ *:[v4i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 142630 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev4h),
     /* 142635 */     GIR_RootConstrainSelectedInstOperands,
     /* 142636 */     // GIR_Coverage, 6469,
     /* 142636 */     GIR_Done,
     /* 142637 */   // Label 2482: @142637
     /* 142637 */   GIM_Reject,
     /* 142638 */ // Label 2473: @142638
     /* 142638 */ GIM_Reject,
     /* 142639 */ // Label 2297: @142639
     /* 142639 */ GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(143044),
     /* 142644 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142647 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 142651 */   GIM_Try, /*On fail goto*//*Label 2484*/ GIMT_Encode4(142700), // Rule ID 4531 //
     /* 142656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 142659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142663 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 142674 */     // (st FPR128:{ *:[v4i32] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 142674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 142677 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 142689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 142694 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142698 */     GIR_RootConstrainSelectedInstOperands,
     /* 142699 */     // GIR_Coverage, 4531,
     /* 142699 */     GIR_EraseRootFromParent_Done,
     /* 142700 */   // Label 2484: @142700
     /* 142700 */   GIM_Try, /*On fail goto*//*Label 2485*/ GIMT_Encode4(142749), // Rule ID 4532 //
     /* 142705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 142708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142712 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 142723 */     // (st FPR128:{ *:[v4i32] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 142723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 142726 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 142738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 142743 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142747 */     GIR_RootConstrainSelectedInstOperands,
     /* 142748 */     // GIR_Coverage, 4532,
     /* 142748 */     GIR_EraseRootFromParent_Done,
     /* 142749 */   // Label 2485: @142749
     /* 142749 */   GIM_Try, /*On fail goto*//*Label 2486*/ GIMT_Encode4(142798), // Rule ID 4533 //
     /* 142754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 142757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142761 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 142772 */     // (st FPR128:{ *:[v4f32] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 142772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 142775 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 142787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 142792 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142796 */     GIR_RootConstrainSelectedInstOperands,
     /* 142797 */     // GIR_Coverage, 4533,
     /* 142797 */     GIR_EraseRootFromParent_Done,
     /* 142798 */   // Label 2486: @142798
     /* 142798 */   GIM_Try, /*On fail goto*//*Label 2487*/ GIMT_Encode4(142847), // Rule ID 4534 //
     /* 142803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 142806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142810 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 142821 */     // (st FPR128:{ *:[v4f32] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 142821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 142824 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 142836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 142841 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142845 */     GIR_RootConstrainSelectedInstOperands,
     /* 142846 */     // GIR_Coverage, 4534,
     /* 142846 */     GIR_EraseRootFromParent_Done,
     /* 142847 */   // Label 2487: @142847
     /* 142847 */   GIM_Try, /*On fail goto*//*Label 2488*/ GIMT_Encode4(142891), // Rule ID 4561 //
     /* 142852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142859 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 142870 */     // (st FPR128:{ *:[v4f32] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 142870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 142873 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142889 */     GIR_RootConstrainSelectedInstOperands,
     /* 142890 */     // GIR_Coverage, 4561,
     /* 142890 */     GIR_EraseRootFromParent_Done,
     /* 142891 */   // Label 2488: @142891
     /* 142891 */   GIM_Try, /*On fail goto*//*Label 2489*/ GIMT_Encode4(142935), // Rule ID 4565 //
     /* 142896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142903 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 142914 */     // (st FPR128:{ *:[v4i32] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 142914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 142917 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142929 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142933 */     GIR_RootConstrainSelectedInstOperands,
     /* 142934 */     // GIR_Coverage, 4565,
     /* 142934 */     GIR_EraseRootFromParent_Done,
     /* 142935 */   // Label 2489: @142935
     /* 142935 */   GIM_Try, /*On fail goto*//*Label 2490*/ GIMT_Encode4(142979), // Rule ID 4585 //
     /* 142940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142947 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 142958 */     // (st FPR128:{ *:[v4f32] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 142958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 142961 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142973 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142977 */     GIR_RootConstrainSelectedInstOperands,
     /* 142978 */     // GIR_Coverage, 4585,
     /* 142978 */     GIR_EraseRootFromParent_Done,
     /* 142979 */   // Label 2490: @142979
     /* 142979 */   GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(143023), // Rule ID 4589 //
     /* 142984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142991 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 143002 */     // (st FPR128:{ *:[v4i32] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 143002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 143005 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 143017 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143021 */     GIR_RootConstrainSelectedInstOperands,
     /* 143022 */     // GIR_Coverage, 4589,
     /* 143022 */     GIR_EraseRootFromParent_Done,
     /* 143023 */   // Label 2491: @143023
     /* 143023 */   GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(143043), // Rule ID 6466 //
     /* 143028 */     // MIs[0] Rn
     /* 143028 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143036 */     // (st v4i32:{ *:[v4i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev4s v4i32:{ *:[v4i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 143036 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev4s),
     /* 143041 */     GIR_RootConstrainSelectedInstOperands,
     /* 143042 */     // GIR_Coverage, 6466,
     /* 143042 */     GIR_Done,
     /* 143043 */   // Label 2492: @143043
     /* 143043 */   GIM_Reject,
     /* 143044 */ // Label 2483: @143044
     /* 143044 */ GIM_Reject,
     /* 143045 */ // Label 2298: @143045
     /* 143045 */ GIM_Try, /*On fail goto*//*Label 2493*/ GIMT_Encode4(143264),
     /* 143050 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143053 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 143057 */   GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(143106), // Rule ID 4519 //
     /* 143062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 143065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143069 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 143080 */     // (st FPR64:{ *:[v8i8] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 143080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 143083 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 143095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 143100 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143104 */     GIR_RootConstrainSelectedInstOperands,
     /* 143105 */     // GIR_Coverage, 4519,
     /* 143105 */     GIR_EraseRootFromParent_Done,
     /* 143106 */   // Label 2494: @143106
     /* 143106 */   GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(143155), // Rule ID 4520 //
     /* 143111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 143114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143118 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 143129 */     // (st FPR64:{ *:[v8i8] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 143129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 143132 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 143144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 143149 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143153 */     GIR_RootConstrainSelectedInstOperands,
     /* 143154 */     // GIR_Coverage, 4520,
     /* 143154 */     GIR_EraseRootFromParent_Done,
     /* 143155 */   // Label 2495: @143155
     /* 143155 */   GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(143199), // Rule ID 4556 //
     /* 143160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 143163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143167 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 143178 */     // (st FPR64:{ *:[v8i8] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 143178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 143181 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 143193 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143197 */     GIR_RootConstrainSelectedInstOperands,
     /* 143198 */     // GIR_Coverage, 4556,
     /* 143198 */     GIR_EraseRootFromParent_Done,
     /* 143199 */   // Label 2496: @143199
     /* 143199 */   GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(143243), // Rule ID 4580 //
     /* 143204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 143207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143211 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 143222 */     // (st FPR64:{ *:[v8i8] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 143222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 143225 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 143237 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143241 */     GIR_RootConstrainSelectedInstOperands,
     /* 143242 */     // GIR_Coverage, 4580,
     /* 143242 */     GIR_EraseRootFromParent_Done,
     /* 143243 */   // Label 2497: @143243
     /* 143243 */   GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(143263), // Rule ID 6468 //
     /* 143248 */     // MIs[0] Rn
     /* 143248 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143256 */     // (st v8i8:{ *:[v8i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev8b v8i8:{ *:[v8i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 143256 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev8b),
     /* 143261 */     GIR_RootConstrainSelectedInstOperands,
     /* 143262 */     // GIR_Coverage, 6468,
     /* 143262 */     GIR_Done,
     /* 143263 */   // Label 2498: @143263
     /* 143263 */   GIM_Reject,
     /* 143264 */ // Label 2493: @143264
     /* 143264 */ GIM_Reject,
     /* 143265 */ // Label 2299: @143265
     /* 143265 */ GIM_Try, /*On fail goto*//*Label 2499*/ GIMT_Encode4(143670),
     /* 143270 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143273 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 143277 */   GIM_Try, /*On fail goto*//*Label 2500*/ GIMT_Encode4(143326), // Rule ID 4535 //
     /* 143282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 143285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143289 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 143300 */     // (st FPR128:{ *:[v8i16] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 143300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 143303 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 143315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 143320 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143324 */     GIR_RootConstrainSelectedInstOperands,
     /* 143325 */     // GIR_Coverage, 4535,
     /* 143325 */     GIR_EraseRootFromParent_Done,
     /* 143326 */   // Label 2500: @143326
     /* 143326 */   GIM_Try, /*On fail goto*//*Label 2501*/ GIMT_Encode4(143375), // Rule ID 4536 //
     /* 143331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 143334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143338 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 143349 */     // (st FPR128:{ *:[v8i16] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 143349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 143352 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 143364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 143369 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143373 */     GIR_RootConstrainSelectedInstOperands,
     /* 143374 */     // GIR_Coverage, 4536,
     /* 143374 */     GIR_EraseRootFromParent_Done,
     /* 143375 */   // Label 2501: @143375
     /* 143375 */   GIM_Try, /*On fail goto*//*Label 2502*/ GIMT_Encode4(143424), // Rule ID 4539 //
     /* 143380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 143383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143387 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 143398 */     // (st FPR128:{ *:[v8f16] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 143398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 143401 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 143413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 143418 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143422 */     GIR_RootConstrainSelectedInstOperands,
     /* 143423 */     // GIR_Coverage, 4539,
     /* 143423 */     GIR_EraseRootFromParent_Done,
     /* 143424 */   // Label 2502: @143424
     /* 143424 */   GIM_Try, /*On fail goto*//*Label 2503*/ GIMT_Encode4(143473), // Rule ID 4540 //
     /* 143429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 143432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143436 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 143447 */     // (st FPR128:{ *:[v8f16] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 143447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 143450 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 143462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 143467 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143471 */     GIR_RootConstrainSelectedInstOperands,
     /* 143472 */     // GIR_Coverage, 4540,
     /* 143472 */     GIR_EraseRootFromParent_Done,
     /* 143473 */   // Label 2503: @143473
     /* 143473 */   GIM_Try, /*On fail goto*//*Label 2504*/ GIMT_Encode4(143517), // Rule ID 4564 //
     /* 143478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 143481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143485 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 143496 */     // (st FPR128:{ *:[v8i16] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 143496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 143499 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 143511 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143515 */     GIR_RootConstrainSelectedInstOperands,
     /* 143516 */     // GIR_Coverage, 4564,
     /* 143516 */     GIR_EraseRootFromParent_Done,
     /* 143517 */   // Label 2504: @143517
     /* 143517 */   GIM_Try, /*On fail goto*//*Label 2505*/ GIMT_Encode4(143561), // Rule ID 4567 //
     /* 143522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 143525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143529 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 143540 */     // (st FPR128:{ *:[v8f16] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 143540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 143543 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 143555 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143559 */     GIR_RootConstrainSelectedInstOperands,
     /* 143560 */     // GIR_Coverage, 4567,
     /* 143560 */     GIR_EraseRootFromParent_Done,
     /* 143561 */   // Label 2505: @143561
     /* 143561 */   GIM_Try, /*On fail goto*//*Label 2506*/ GIMT_Encode4(143605), // Rule ID 4588 //
     /* 143566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 143569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143573 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 143584 */     // (st FPR128:{ *:[v8i16] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 143584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 143587 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 143599 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143603 */     GIR_RootConstrainSelectedInstOperands,
     /* 143604 */     // GIR_Coverage, 4588,
     /* 143604 */     GIR_EraseRootFromParent_Done,
     /* 143605 */   // Label 2506: @143605
     /* 143605 */   GIM_Try, /*On fail goto*//*Label 2507*/ GIMT_Encode4(143649), // Rule ID 4592 //
     /* 143610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 143613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143617 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 143628 */     // (st FPR128:{ *:[v8f16] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 143628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 143631 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 143643 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143647 */     GIR_RootConstrainSelectedInstOperands,
     /* 143648 */     // GIR_Coverage, 4592,
     /* 143648 */     GIR_EraseRootFromParent_Done,
     /* 143649 */   // Label 2507: @143649
     /* 143649 */   GIM_Try, /*On fail goto*//*Label 2508*/ GIMT_Encode4(143669), // Rule ID 6465 //
     /* 143654 */     // MIs[0] Rn
     /* 143654 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143662 */     // (st v8i16:{ *:[v8i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev8h v8i16:{ *:[v8i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 143662 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev8h),
     /* 143667 */     GIR_RootConstrainSelectedInstOperands,
     /* 143668 */     // GIR_Coverage, 6465,
     /* 143668 */     GIR_Done,
     /* 143669 */   // Label 2508: @143669
     /* 143669 */   GIM_Reject,
     /* 143670 */ // Label 2499: @143670
     /* 143670 */ GIM_Reject,
     /* 143671 */ // Label 2300: @143671
     /* 143671 */ GIM_Try, /*On fail goto*//*Label 2509*/ GIMT_Encode4(143890),
     /* 143676 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143679 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 143683 */   GIM_Try, /*On fail goto*//*Label 2510*/ GIMT_Encode4(143732), // Rule ID 4537 //
     /* 143688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 143691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143695 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 143706 */     // (st FPR128:{ *:[v16i8] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 143706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 143709 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 143721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 143726 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143730 */     GIR_RootConstrainSelectedInstOperands,
     /* 143731 */     // GIR_Coverage, 4537,
     /* 143731 */     GIR_EraseRootFromParent_Done,
     /* 143732 */   // Label 2510: @143732
     /* 143732 */   GIM_Try, /*On fail goto*//*Label 2511*/ GIMT_Encode4(143781), // Rule ID 4538 //
     /* 143737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 143740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143744 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 143755 */     // (st FPR128:{ *:[v16i8] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 143755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 143758 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 143770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 143775 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143779 */     GIR_RootConstrainSelectedInstOperands,
     /* 143780 */     // GIR_Coverage, 4538,
     /* 143780 */     GIR_EraseRootFromParent_Done,
     /* 143781 */   // Label 2511: @143781
     /* 143781 */   GIM_Try, /*On fail goto*//*Label 2512*/ GIMT_Encode4(143825), // Rule ID 4563 //
     /* 143786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 143789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143793 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 143804 */     // (st FPR128:{ *:[v16i8] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 143804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 143807 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 143819 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143823 */     GIR_RootConstrainSelectedInstOperands,
     /* 143824 */     // GIR_Coverage, 4563,
     /* 143824 */     GIR_EraseRootFromParent_Done,
     /* 143825 */   // Label 2512: @143825
     /* 143825 */   GIM_Try, /*On fail goto*//*Label 2513*/ GIMT_Encode4(143869), // Rule ID 4587 //
     /* 143830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 143833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143837 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 143848 */     // (st FPR128:{ *:[v16i8] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 143848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 143851 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 143863 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143867 */     GIR_RootConstrainSelectedInstOperands,
     /* 143868 */     // GIR_Coverage, 4587,
     /* 143868 */     GIR_EraseRootFromParent_Done,
     /* 143869 */   // Label 2513: @143869
     /* 143869 */   GIM_Try, /*On fail goto*//*Label 2514*/ GIMT_Encode4(143889), // Rule ID 6464 //
     /* 143874 */     // MIs[0] Rn
     /* 143874 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143882 */     // (st v16i8:{ *:[v16i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev16b v16i8:{ *:[v16i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 143882 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev16b),
     /* 143887 */     GIR_RootConstrainSelectedInstOperands,
     /* 143888 */     // GIR_Coverage, 6464,
     /* 143888 */     GIR_Done,
     /* 143889 */   // Label 2514: @143889
     /* 143889 */   GIM_Reject,
     /* 143890 */ // Label 2509: @143890
     /* 143890 */ GIM_Reject,
     /* 143891 */ // Label 2301: @143891
     /* 143891 */ GIM_Try, /*On fail goto*//*Label 2515*/ GIMT_Encode4(143950), // Rule ID 10987 //
     /* 143896 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 143899 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143902 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 143906 */   // MIs[0] base
     /* 143906 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143910 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 143914 */   // (st nxv2f16:{ *:[nxv2f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_D_IMM ZPR:{ *:[nxv2f16] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 143914 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 143917 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 143921 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143926 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 143929 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 143931 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_D_IMM),
     /* 143934 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 143936 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143939 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 143941 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143944 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143948 */   GIR_RootConstrainSelectedInstOperands,
     /* 143949 */   // GIR_Coverage, 10987,
     /* 143949 */   GIR_EraseRootFromParent_Done,
     /* 143950 */ // Label 2515: @143950
     /* 143950 */ GIM_Reject,
     /* 143951 */ // Label 2302: @143951
     /* 143951 */ GIM_Try, /*On fail goto*//*Label 2516*/ GIMT_Encode4(144010), // Rule ID 10993 //
     /* 143956 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 143959 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143962 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 143966 */   // MIs[0] base
     /* 143966 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143970 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 143974 */   // (st nxv2f32:{ *:[nxv2f32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_D_IMM ZPR:{ *:[nxv2f32] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 143974 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 143977 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 143981 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143986 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 143989 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 143991 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_D_IMM),
     /* 143994 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 143996 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143999 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144001 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144004 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144008 */   GIR_RootConstrainSelectedInstOperands,
     /* 144009 */   // GIR_Coverage, 10993,
     /* 144009 */   GIR_EraseRootFromParent_Done,
     /* 144010 */ // Label 2516: @144010
     /* 144010 */ GIM_Reject,
     /* 144011 */ // Label 2303: @144011
     /* 144011 */ GIM_Try, /*On fail goto*//*Label 2517*/ GIMT_Encode4(144180),
     /* 144016 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144019 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 144023 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144027 */   GIM_Try, /*On fail goto*//*Label 2518*/ GIMT_Encode4(144075), // Rule ID 10978 //
     /* 144032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144035 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144039 */     // (st nxv2i64:{ *:[nxv2i64] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1D_IMM ZPR:{ *:[nxv2i64] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144039 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 144042 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 144046 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144051 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 144054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 144056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_IMM),
     /* 144059 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144064 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144069 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144073 */     GIR_RootConstrainSelectedInstOperands,
     /* 144074 */     // GIR_Coverage, 10978,
     /* 144074 */     GIR_EraseRootFromParent_Done,
     /* 144075 */   // Label 2518: @144075
     /* 144075 */   GIM_Try, /*On fail goto*//*Label 2519*/ GIMT_Encode4(144123), // Rule ID 10996 //
     /* 144080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144087 */     // (st nxv2f64:{ *:[nxv2f64] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1D_IMM ZPR:{ *:[nxv2f64] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 144090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 144094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144099 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 144102 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 144104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_IMM),
     /* 144107 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144112 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144117 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144121 */     GIR_RootConstrainSelectedInstOperands,
     /* 144122 */     // GIR_Coverage, 10996,
     /* 144122 */     GIR_EraseRootFromParent_Done,
     /* 144123 */   // Label 2519: @144123
     /* 144123 */   GIM_Try, /*On fail goto*//*Label 2520*/ GIMT_Encode4(144151), // Rule ID 11108 //
     /* 144128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 144131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144135 */     // (st nxv2i64:{ *:[nxv2i64] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv2i64] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 144138 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144140 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144145 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144149 */     GIR_RootConstrainSelectedInstOperands,
     /* 144150 */     // GIR_Coverage, 11108,
     /* 144150 */     GIR_EraseRootFromParent_Done,
     /* 144151 */   // Label 2520: @144151
     /* 144151 */   GIM_Try, /*On fail goto*//*Label 2521*/ GIMT_Encode4(144179), // Rule ID 11120 //
     /* 144156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 144159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144163 */     // (st nxv2f64:{ *:[nxv2f64] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv2f64] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 144166 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144168 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144173 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144177 */     GIR_RootConstrainSelectedInstOperands,
     /* 144178 */     // GIR_Coverage, 11120,
     /* 144178 */     GIR_EraseRootFromParent_Done,
     /* 144179 */   // Label 2521: @144179
     /* 144179 */   GIM_Reject,
     /* 144180 */ // Label 2517: @144180
     /* 144180 */ GIM_Reject,
     /* 144181 */ // Label 2304: @144181
     /* 144181 */ GIM_Try, /*On fail goto*//*Label 2522*/ GIMT_Encode4(144240), // Rule ID 10984 //
     /* 144186 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144189 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144192 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 144196 */   // MIs[0] base
     /* 144196 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144200 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144204 */   // (st nxv4f16:{ *:[nxv4f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_S_IMM ZPR:{ *:[nxv4f16] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144204 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 144207 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 144211 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144216 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 144219 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 144221 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_S_IMM),
     /* 144224 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144226 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144229 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144231 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144234 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144238 */   GIR_RootConstrainSelectedInstOperands,
     /* 144239 */   // GIR_Coverage, 10984,
     /* 144239 */   GIR_EraseRootFromParent_Done,
     /* 144240 */ // Label 2522: @144240
     /* 144240 */ GIM_Reject,
     /* 144241 */ // Label 2305: @144241
     /* 144241 */ GIM_Try, /*On fail goto*//*Label 2523*/ GIMT_Encode4(144410),
     /* 144246 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144249 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 144253 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144257 */   GIM_Try, /*On fail goto*//*Label 2524*/ GIMT_Encode4(144305), // Rule ID 10972 //
     /* 144262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144269 */     // (st nxv4i32:{ *:[nxv4i32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_IMM ZPR:{ *:[nxv4i32] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144269 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 144272 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 144276 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144281 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 144284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 144286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_IMM),
     /* 144289 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144291 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144294 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144299 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144303 */     GIR_RootConstrainSelectedInstOperands,
     /* 144304 */     // GIR_Coverage, 10972,
     /* 144304 */     GIR_EraseRootFromParent_Done,
     /* 144305 */   // Label 2524: @144305
     /* 144305 */   GIM_Try, /*On fail goto*//*Label 2525*/ GIMT_Encode4(144353), // Rule ID 10990 //
     /* 144310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144317 */     // (st nxv4f32:{ *:[nxv4f32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_IMM ZPR:{ *:[nxv4f32] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144317 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 144320 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 144324 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144329 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 144332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 144334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_IMM),
     /* 144337 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144342 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144347 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144351 */     GIR_RootConstrainSelectedInstOperands,
     /* 144352 */     // GIR_Coverage, 10990,
     /* 144352 */     GIR_EraseRootFromParent_Done,
     /* 144353 */   // Label 2525: @144353
     /* 144353 */   GIM_Try, /*On fail goto*//*Label 2526*/ GIMT_Encode4(144381), // Rule ID 11104 //
     /* 144358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 144361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144365 */     // (st nxv4i32:{ *:[nxv4i32] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv4i32] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 144368 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144370 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144375 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144379 */     GIR_RootConstrainSelectedInstOperands,
     /* 144380 */     // GIR_Coverage, 11104,
     /* 144380 */     GIR_EraseRootFromParent_Done,
     /* 144381 */   // Label 2526: @144381
     /* 144381 */   GIM_Try, /*On fail goto*//*Label 2527*/ GIMT_Encode4(144409), // Rule ID 11116 //
     /* 144386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 144389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144393 */     // (st nxv4f32:{ *:[nxv4f32] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv4f32] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 144396 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144398 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144403 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144407 */     GIR_RootConstrainSelectedInstOperands,
     /* 144408 */     // GIR_Coverage, 11116,
     /* 144408 */     GIR_EraseRootFromParent_Done,
     /* 144409 */   // Label 2527: @144409
     /* 144409 */   GIM_Reject,
     /* 144410 */ // Label 2523: @144410
     /* 144410 */ GIM_Reject,
     /* 144411 */ // Label 2306: @144411
     /* 144411 */ GIM_Try, /*On fail goto*//*Label 2528*/ GIMT_Encode4(144580),
     /* 144416 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144419 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 144423 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144427 */   GIM_Try, /*On fail goto*//*Label 2529*/ GIMT_Encode4(144475), // Rule ID 10963 //
     /* 144432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144439 */     // (st nxv8i16:{ *:[nxv8i16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_IMM ZPR:{ *:[nxv8i16] }:$val, (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 144442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 144446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144451 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 144454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 144456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_IMM),
     /* 144459 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144464 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144469 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144473 */     GIR_RootConstrainSelectedInstOperands,
     /* 144474 */     // GIR_Coverage, 10963,
     /* 144474 */     GIR_EraseRootFromParent_Done,
     /* 144475 */   // Label 2529: @144475
     /* 144475 */   GIM_Try, /*On fail goto*//*Label 2530*/ GIMT_Encode4(144523), // Rule ID 10981 //
     /* 144480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144487 */     // (st nxv8f16:{ *:[nxv8f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_IMM ZPR:{ *:[nxv8f16] }:$val, (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144487 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 144490 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 144494 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144499 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 144502 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 144504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_IMM),
     /* 144507 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144509 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144512 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144517 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144521 */     GIR_RootConstrainSelectedInstOperands,
     /* 144522 */     // GIR_Coverage, 10981,
     /* 144522 */     GIR_EraseRootFromParent_Done,
     /* 144523 */   // Label 2530: @144523
     /* 144523 */   GIM_Try, /*On fail goto*//*Label 2531*/ GIMT_Encode4(144551), // Rule ID 11100 //
     /* 144528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 144531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144535 */     // (st nxv8i16:{ *:[nxv8i16] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv8i16] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 144538 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144540 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144549 */     GIR_RootConstrainSelectedInstOperands,
     /* 144550 */     // GIR_Coverage, 11100,
     /* 144550 */     GIR_EraseRootFromParent_Done,
     /* 144551 */   // Label 2531: @144551
     /* 144551 */   GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(144579), // Rule ID 11112 //
     /* 144556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 144559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144563 */     // (st nxv8f16:{ *:[nxv8f16] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv8f16] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 144566 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144568 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144573 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144577 */     GIR_RootConstrainSelectedInstOperands,
     /* 144578 */     // GIR_Coverage, 11112,
     /* 144578 */     GIR_EraseRootFromParent_Done,
     /* 144579 */   // Label 2532: @144579
     /* 144579 */   GIM_Reject,
     /* 144580 */ // Label 2528: @144580
     /* 144580 */ GIM_Reject,
     /* 144581 */ // Label 2307: @144581
     /* 144581 */ GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(144624), // Rule ID 2433 //
     /* 144586 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144589 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144592 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 144596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 144600 */   // MIs[0] base
     /* 144600 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144604 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144608 */   // (st PPR:{ *:[nxv16i1] }:$Val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_PXI PPR:{ *:[nxv16i1] }:$Val, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_PXI),
     /* 144611 */   GIR_RootToRootCopy, /*OpIdx*/0, // Val
     /* 144613 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144615 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144618 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144622 */   GIR_RootConstrainSelectedInstOperands,
     /* 144623 */   // GIR_Coverage, 2433,
     /* 144623 */   GIR_EraseRootFromParent_Done,
     /* 144624 */ // Label 2533: @144624
     /* 144624 */ GIM_Reject,
     /* 144625 */ // Label 2308: @144625
     /* 144625 */ GIM_Try, /*On fail goto*//*Label 2534*/ GIMT_Encode4(144718),
     /* 144630 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144633 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 144637 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144641 */   GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(144689), // Rule ID 10949 //
     /* 144646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144653 */     // (st nxv16i8:{ *:[nxv16i8] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1B_IMM ZPR:{ *:[nxv16i8] }:$val, (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144653 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 144656 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 144660 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144665 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 144668 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 144670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1B_IMM),
     /* 144673 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144675 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144678 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144683 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144687 */     GIR_RootConstrainSelectedInstOperands,
     /* 144688 */     // GIR_Coverage, 10949,
     /* 144688 */     GIR_EraseRootFromParent_Done,
     /* 144689 */   // Label 2535: @144689
     /* 144689 */   GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(144717), // Rule ID 11096 //
     /* 144694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 144697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144701 */     // (st nxv16i8:{ *:[nxv16i8] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv16i8] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 144704 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144706 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144711 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144715 */     GIR_RootConstrainSelectedInstOperands,
     /* 144716 */     // GIR_Coverage, 11096,
     /* 144716 */     GIR_EraseRootFromParent_Done,
     /* 144717 */   // Label 2536: @144717
     /* 144717 */   GIM_Reject,
     /* 144718 */ // Label 2534: @144718
     /* 144718 */ GIM_Reject,
     /* 144719 */ // Label 2309: @144719
     /* 144719 */ GIM_Reject,
     /* 144720 */ // Label 20: @144720
     /* 144720 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2539*/ GIMT_Encode4(146070),
     /* 144731 */ /*GILLT_s32*//*Label 2537*/ GIMT_Encode4(144739),
     /* 144735 */ /*GILLT_s64*//*Label 2538*/ GIMT_Encode4(145757),
     /* 144739 */ // Label 2537: @144739
     /* 144739 */ GIM_Try, /*On fail goto*//*Label 2540*/ GIMT_Encode4(145756),
     /* 144744 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 144747 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 144750 */   GIM_Try, /*On fail goto*//*Label 2541*/ GIMT_Encode4(144805), // Rule ID 7384 //
     /* 144755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144758 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 144765 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 144768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144772 */     // MIs[0] Rn
     /* 144772 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144788 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (CASW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 144788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASW),
     /* 144791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 144793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 144795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 144797 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144803 */     GIR_RootConstrainSelectedInstOperands,
     /* 144804 */     // GIR_Coverage, 7384,
     /* 144804 */     GIR_EraseRootFromParent_Done,
     /* 144805 */   // Label 2541: @144805
     /* 144805 */   GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(144860), // Rule ID 7385 //
     /* 144810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144813 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 144820 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 144823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144827 */     // MIs[0] Rn
     /* 144827 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144843 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (CASAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 144843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAW),
     /* 144846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 144848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 144850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 144852 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144854 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144858 */     GIR_RootConstrainSelectedInstOperands,
     /* 144859 */     // GIR_Coverage, 7385,
     /* 144859 */     GIR_EraseRootFromParent_Done,
     /* 144860 */   // Label 2542: @144860
     /* 144860 */   GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(144915), // Rule ID 7386 //
     /* 144865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144868 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 144875 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 144878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144882 */     // MIs[0] Rn
     /* 144882 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144898 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (CASLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 144898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLW),
     /* 144901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 144903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 144905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 144907 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144909 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144913 */     GIR_RootConstrainSelectedInstOperands,
     /* 144914 */     // GIR_Coverage, 7386,
     /* 144914 */     GIR_EraseRootFromParent_Done,
     /* 144915 */   // Label 2543: @144915
     /* 144915 */   GIM_Try, /*On fail goto*//*Label 2544*/ GIMT_Encode4(144970), // Rule ID 7387 //
     /* 144920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144923 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 144930 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 144933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144937 */     // MIs[0] Rn
     /* 144937 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144941 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144953 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (CASALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 144953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALW),
     /* 144956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 144958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 144960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 144962 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144968 */     GIR_RootConstrainSelectedInstOperands,
     /* 144969 */     // GIR_Coverage, 7387,
     /* 144969 */     GIR_EraseRootFromParent_Done,
     /* 144970 */   // Label 2544: @144970
     /* 144970 */   GIM_Try, /*On fail goto*//*Label 2545*/ GIMT_Encode4(145025), // Rule ID 7388 //
     /* 144975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144978 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 144985 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 144988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144992 */     // MIs[0] Rn
     /* 144992 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145008 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (CASALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALW),
     /* 145011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145015 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145017 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145019 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145023 */     GIR_RootConstrainSelectedInstOperands,
     /* 145024 */     // GIR_Coverage, 7388,
     /* 145024 */     GIR_EraseRootFromParent_Done,
     /* 145025 */   // Label 2545: @145025
     /* 145025 */   GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(145080), // Rule ID 7389 //
     /* 145030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145033 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145040 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 145043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145047 */     // MIs[0] Rn
     /* 145047 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145063 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (CASH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASH),
     /* 145066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145072 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145074 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145078 */     GIR_RootConstrainSelectedInstOperands,
     /* 145079 */     // GIR_Coverage, 7389,
     /* 145079 */     GIR_EraseRootFromParent_Done,
     /* 145080 */   // Label 2546: @145080
     /* 145080 */   GIM_Try, /*On fail goto*//*Label 2547*/ GIMT_Encode4(145135), // Rule ID 7390 //
     /* 145085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145088 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145095 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 145098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145102 */     // MIs[0] Rn
     /* 145102 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145118 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (CASAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAH),
     /* 145121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145127 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145129 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145133 */     GIR_RootConstrainSelectedInstOperands,
     /* 145134 */     // GIR_Coverage, 7390,
     /* 145134 */     GIR_EraseRootFromParent_Done,
     /* 145135 */   // Label 2547: @145135
     /* 145135 */   GIM_Try, /*On fail goto*//*Label 2548*/ GIMT_Encode4(145190), // Rule ID 7391 //
     /* 145140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145143 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145150 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 145153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145157 */     // MIs[0] Rn
     /* 145157 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145173 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (CASLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLH),
     /* 145176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145182 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145184 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145188 */     GIR_RootConstrainSelectedInstOperands,
     /* 145189 */     // GIR_Coverage, 7391,
     /* 145189 */     GIR_EraseRootFromParent_Done,
     /* 145190 */   // Label 2548: @145190
     /* 145190 */   GIM_Try, /*On fail goto*//*Label 2549*/ GIMT_Encode4(145245), // Rule ID 7392 //
     /* 145195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145198 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145205 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 145208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145212 */     // MIs[0] Rn
     /* 145212 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145228 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (CASALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALH),
     /* 145231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145237 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145239 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145243 */     GIR_RootConstrainSelectedInstOperands,
     /* 145244 */     // GIR_Coverage, 7392,
     /* 145244 */     GIR_EraseRootFromParent_Done,
     /* 145245 */   // Label 2549: @145245
     /* 145245 */   GIM_Try, /*On fail goto*//*Label 2550*/ GIMT_Encode4(145300), // Rule ID 7393 //
     /* 145250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145253 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145260 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 145263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145267 */     // MIs[0] Rn
     /* 145267 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145283 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (CASALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALH),
     /* 145286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145292 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145294 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145298 */     GIR_RootConstrainSelectedInstOperands,
     /* 145299 */     // GIR_Coverage, 7393,
     /* 145299 */     GIR_EraseRootFromParent_Done,
     /* 145300 */   // Label 2550: @145300
     /* 145300 */   GIM_Try, /*On fail goto*//*Label 2551*/ GIMT_Encode4(145355), // Rule ID 7394 //
     /* 145305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145308 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145315 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 145318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145322 */     // MIs[0] Rn
     /* 145322 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145338 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (CASB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASB),
     /* 145341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145345 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145347 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145349 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145353 */     GIR_RootConstrainSelectedInstOperands,
     /* 145354 */     // GIR_Coverage, 7394,
     /* 145354 */     GIR_EraseRootFromParent_Done,
     /* 145355 */   // Label 2551: @145355
     /* 145355 */   GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(145410), // Rule ID 7395 //
     /* 145360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145363 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145370 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 145373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145377 */     // MIs[0] Rn
     /* 145377 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145393 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (CASAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAB),
     /* 145396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145402 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145404 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145408 */     GIR_RootConstrainSelectedInstOperands,
     /* 145409 */     // GIR_Coverage, 7395,
     /* 145409 */     GIR_EraseRootFromParent_Done,
     /* 145410 */   // Label 2552: @145410
     /* 145410 */   GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(145465), // Rule ID 7396 //
     /* 145415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145418 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145425 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 145428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145432 */     // MIs[0] Rn
     /* 145432 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145448 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (CASLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLB),
     /* 145451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145455 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145457 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145459 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145463 */     GIR_RootConstrainSelectedInstOperands,
     /* 145464 */     // GIR_Coverage, 7396,
     /* 145464 */     GIR_EraseRootFromParent_Done,
     /* 145465 */   // Label 2553: @145465
     /* 145465 */   GIM_Try, /*On fail goto*//*Label 2554*/ GIMT_Encode4(145520), // Rule ID 7397 //
     /* 145470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145473 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145480 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 145483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145487 */     // MIs[0] Rn
     /* 145487 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145503 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (CASALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALB),
     /* 145506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145512 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145514 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145518 */     GIR_RootConstrainSelectedInstOperands,
     /* 145519 */     // GIR_Coverage, 7397,
     /* 145519 */     GIR_EraseRootFromParent_Done,
     /* 145520 */   // Label 2554: @145520
     /* 145520 */   GIM_Try, /*On fail goto*//*Label 2555*/ GIMT_Encode4(145575), // Rule ID 7398 //
     /* 145525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145528 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145535 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 145538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145542 */     // MIs[0] Rn
     /* 145542 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145558 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (CASALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALB),
     /* 145561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145567 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145569 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145573 */     GIR_RootConstrainSelectedInstOperands,
     /* 145574 */     // GIR_Coverage, 7398,
     /* 145574 */     GIR_EraseRootFromParent_Done,
     /* 145575 */   // Label 2555: @145575
     /* 145575 */   GIM_Try, /*On fail goto*//*Label 2556*/ GIMT_Encode4(145635), // Rule ID 13259 //
     /* 145580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 145583 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145594 */     // MIs[0] addr
     /* 145594 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145610 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>>  =>  (CMP_SWAP_8:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 145610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 145613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_8),
     /* 145616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145618 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 145623 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 145625 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 145627 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 145629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145633 */     GIR_RootConstrainSelectedInstOperands,
     /* 145634 */     // GIR_Coverage, 13259,
     /* 145634 */     GIR_EraseRootFromParent_Done,
     /* 145635 */   // Label 2556: @145635
     /* 145635 */   GIM_Try, /*On fail goto*//*Label 2557*/ GIMT_Encode4(145695), // Rule ID 13260 //
     /* 145640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 145643 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145654 */     // MIs[0] addr
     /* 145654 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145670 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>>  =>  (CMP_SWAP_16:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 145670 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 145673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_16),
     /* 145676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145678 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 145683 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 145685 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 145687 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 145689 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145693 */     GIR_RootConstrainSelectedInstOperands,
     /* 145694 */     // GIR_Coverage, 13260,
     /* 145694 */     GIR_EraseRootFromParent_Done,
     /* 145695 */   // Label 2557: @145695
     /* 145695 */   GIM_Try, /*On fail goto*//*Label 2558*/ GIMT_Encode4(145755), // Rule ID 13261 //
     /* 145700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 145703 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 145710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145714 */     // MIs[0] addr
     /* 145714 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145730 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>>  =>  (CMP_SWAP_32:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 145730 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 145733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_32),
     /* 145736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145738 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 145743 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 145745 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 145747 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 145749 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145753 */     GIR_RootConstrainSelectedInstOperands,
     /* 145754 */     // GIR_Coverage, 13261,
     /* 145754 */     GIR_EraseRootFromParent_Done,
     /* 145755 */   // Label 2558: @145755
     /* 145755 */   GIM_Reject,
     /* 145756 */ // Label 2540: @145756
     /* 145756 */ GIM_Reject,
     /* 145757 */ // Label 2538: @145757
     /* 145757 */ GIM_Try, /*On fail goto*//*Label 2559*/ GIMT_Encode4(146069),
     /* 145762 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 145765 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 145768 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 145775 */   GIM_Try, /*On fail goto*//*Label 2560*/ GIMT_Encode4(145823), // Rule ID 2585 //
     /* 145780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145783 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 145786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145790 */     // MIs[0] Rn
     /* 145790 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145806 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_monotonic>>  =>  (CASX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASX),
     /* 145809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145815 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145817 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145821 */     GIR_RootConstrainSelectedInstOperands,
     /* 145822 */     // GIR_Coverage, 2585,
     /* 145822 */     GIR_EraseRootFromParent_Done,
     /* 145823 */   // Label 2560: @145823
     /* 145823 */   GIM_Try, /*On fail goto*//*Label 2561*/ GIMT_Encode4(145871), // Rule ID 2586 //
     /* 145828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145831 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 145834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145838 */     // MIs[0] Rn
     /* 145838 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145854 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acquire>>  =>  (CASAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAX),
     /* 145857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145861 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145863 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145865 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145869 */     GIR_RootConstrainSelectedInstOperands,
     /* 145870 */     // GIR_Coverage, 2586,
     /* 145870 */     GIR_EraseRootFromParent_Done,
     /* 145871 */   // Label 2561: @145871
     /* 145871 */   GIM_Try, /*On fail goto*//*Label 2562*/ GIMT_Encode4(145919), // Rule ID 2587 //
     /* 145876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145879 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 145882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145886 */     // MIs[0] Rn
     /* 145886 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145902 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_release>>  =>  (CASLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLX),
     /* 145905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145911 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145913 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145917 */     GIR_RootConstrainSelectedInstOperands,
     /* 145918 */     // GIR_Coverage, 2587,
     /* 145918 */     GIR_EraseRootFromParent_Done,
     /* 145919 */   // Label 2562: @145919
     /* 145919 */   GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(145967), // Rule ID 2588 //
     /* 145924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145927 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 145930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145934 */     // MIs[0] Rn
     /* 145934 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145950 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acq_rel>>  =>  (CASALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALX),
     /* 145953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145957 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145959 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145961 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145965 */     GIR_RootConstrainSelectedInstOperands,
     /* 145966 */     // GIR_Coverage, 2588,
     /* 145966 */     GIR_EraseRootFromParent_Done,
     /* 145967 */   // Label 2563: @145967
     /* 145967 */   GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(146015), // Rule ID 2589 //
     /* 145972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145975 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 145978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145982 */     // MIs[0] Rn
     /* 145982 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145998 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_seq_cst>>  =>  (CASALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALX),
     /* 146001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 146003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 146005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 146007 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146009 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146013 */     GIR_RootConstrainSelectedInstOperands,
     /* 146014 */     // GIR_Coverage, 2589,
     /* 146014 */     GIR_EraseRootFromParent_Done,
     /* 146015 */   // Label 2564: @146015
     /* 146015 */   GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(146068), // Rule ID 13262 //
     /* 146020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 146023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146027 */     // MIs[0] addr
     /* 146027 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146043 */     // (atomic_cmp_swap:{ *:[i64] } GPR64:{ *:[i64] }:$addr, GPR64:{ *:[i64] }:$desired, GPR64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>>  =>  (CMP_SWAP_64:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR64:{ *:[i64] }:$desired, GPR64:{ *:[i64] }:$new)
     /* 146043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 146046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_64),
     /* 146049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146051 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 146056 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 146058 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 146060 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 146062 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146066 */     GIR_RootConstrainSelectedInstOperands,
     /* 146067 */     // GIR_Coverage, 13262,
     /* 146067 */     GIR_EraseRootFromParent_Done,
     /* 146068 */   // Label 2565: @146068
     /* 146068 */   GIM_Reject,
     /* 146069 */ // Label 2559: @146069
     /* 146069 */ GIM_Reject,
     /* 146070 */ // Label 2539: @146070
     /* 146070 */ GIM_Reject,
     /* 146071 */ // Label 21: @146071
     /* 146071 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2568*/ GIMT_Encode4(147062),
     /* 146082 */ /*GILLT_s32*//*Label 2566*/ GIMT_Encode4(146090),
     /* 146086 */ /*GILLT_s64*//*Label 2567*/ GIMT_Encode4(146835),
     /* 146090 */ // Label 2566: @146090
     /* 146090 */ GIM_Try, /*On fail goto*//*Label 2569*/ GIMT_Encode4(146834),
     /* 146095 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 146098 */   GIM_Try, /*On fail goto*//*Label 2570*/ GIMT_Encode4(146147), // Rule ID 7369 //
     /* 146103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146106 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 146113 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 146116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146120 */     // MIs[0] Rn
     /* 146120 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146132 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (SWPW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPW),
     /* 146135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146139 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146141 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146145 */     GIR_RootConstrainSelectedInstOperands,
     /* 146146 */     // GIR_Coverage, 7369,
     /* 146146 */     GIR_EraseRootFromParent_Done,
     /* 146147 */   // Label 2570: @146147
     /* 146147 */   GIM_Try, /*On fail goto*//*Label 2571*/ GIMT_Encode4(146196), // Rule ID 7370 //
     /* 146152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146155 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 146162 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 146165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146169 */     // MIs[0] Rn
     /* 146169 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146181 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (SWPAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAW),
     /* 146184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146188 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146190 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146194 */     GIR_RootConstrainSelectedInstOperands,
     /* 146195 */     // GIR_Coverage, 7370,
     /* 146195 */     GIR_EraseRootFromParent_Done,
     /* 146196 */   // Label 2571: @146196
     /* 146196 */   GIM_Try, /*On fail goto*//*Label 2572*/ GIMT_Encode4(146245), // Rule ID 7371 //
     /* 146201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146204 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 146211 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 146214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146218 */     // MIs[0] Rn
     /* 146218 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146230 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (SWPLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLW),
     /* 146233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146237 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146239 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146243 */     GIR_RootConstrainSelectedInstOperands,
     /* 146244 */     // GIR_Coverage, 7371,
     /* 146244 */     GIR_EraseRootFromParent_Done,
     /* 146245 */   // Label 2572: @146245
     /* 146245 */   GIM_Try, /*On fail goto*//*Label 2573*/ GIMT_Encode4(146294), // Rule ID 7372 //
     /* 146250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146253 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 146260 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 146263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146267 */     // MIs[0] Rn
     /* 146267 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146279 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (SWPALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALW),
     /* 146282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146286 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146292 */     GIR_RootConstrainSelectedInstOperands,
     /* 146293 */     // GIR_Coverage, 7372,
     /* 146293 */     GIR_EraseRootFromParent_Done,
     /* 146294 */   // Label 2573: @146294
     /* 146294 */   GIM_Try, /*On fail goto*//*Label 2574*/ GIMT_Encode4(146343), // Rule ID 7373 //
     /* 146299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146302 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 146309 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 146312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146316 */     // MIs[0] Rn
     /* 146316 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146328 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (SWPALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALW),
     /* 146331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146335 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146337 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146341 */     GIR_RootConstrainSelectedInstOperands,
     /* 146342 */     // GIR_Coverage, 7373,
     /* 146342 */     GIR_EraseRootFromParent_Done,
     /* 146343 */   // Label 2574: @146343
     /* 146343 */   GIM_Try, /*On fail goto*//*Label 2575*/ GIMT_Encode4(146392), // Rule ID 7374 //
     /* 146348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146351 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146358 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 146361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146365 */     // MIs[0] Rn
     /* 146365 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146377 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (SWPH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPH),
     /* 146380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146384 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146386 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146390 */     GIR_RootConstrainSelectedInstOperands,
     /* 146391 */     // GIR_Coverage, 7374,
     /* 146391 */     GIR_EraseRootFromParent_Done,
     /* 146392 */   // Label 2575: @146392
     /* 146392 */   GIM_Try, /*On fail goto*//*Label 2576*/ GIMT_Encode4(146441), // Rule ID 7375 //
     /* 146397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146400 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146407 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 146410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146414 */     // MIs[0] Rn
     /* 146414 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146426 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (SWPAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAH),
     /* 146429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146433 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146439 */     GIR_RootConstrainSelectedInstOperands,
     /* 146440 */     // GIR_Coverage, 7375,
     /* 146440 */     GIR_EraseRootFromParent_Done,
     /* 146441 */   // Label 2576: @146441
     /* 146441 */   GIM_Try, /*On fail goto*//*Label 2577*/ GIMT_Encode4(146490), // Rule ID 7376 //
     /* 146446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146449 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146456 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 146459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146463 */     // MIs[0] Rn
     /* 146463 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146475 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (SWPLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLH),
     /* 146478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146482 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146484 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146488 */     GIR_RootConstrainSelectedInstOperands,
     /* 146489 */     // GIR_Coverage, 7376,
     /* 146489 */     GIR_EraseRootFromParent_Done,
     /* 146490 */   // Label 2577: @146490
     /* 146490 */   GIM_Try, /*On fail goto*//*Label 2578*/ GIMT_Encode4(146539), // Rule ID 7377 //
     /* 146495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146498 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146505 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 146508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146512 */     // MIs[0] Rn
     /* 146512 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146524 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (SWPALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALH),
     /* 146527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146531 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146533 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146537 */     GIR_RootConstrainSelectedInstOperands,
     /* 146538 */     // GIR_Coverage, 7377,
     /* 146538 */     GIR_EraseRootFromParent_Done,
     /* 146539 */   // Label 2578: @146539
     /* 146539 */   GIM_Try, /*On fail goto*//*Label 2579*/ GIMT_Encode4(146588), // Rule ID 7378 //
     /* 146544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146547 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146554 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 146557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146561 */     // MIs[0] Rn
     /* 146561 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146573 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (SWPALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALH),
     /* 146576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146580 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146582 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146586 */     GIR_RootConstrainSelectedInstOperands,
     /* 146587 */     // GIR_Coverage, 7378,
     /* 146587 */     GIR_EraseRootFromParent_Done,
     /* 146588 */   // Label 2579: @146588
     /* 146588 */   GIM_Try, /*On fail goto*//*Label 2580*/ GIMT_Encode4(146637), // Rule ID 7379 //
     /* 146593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146596 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146603 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 146606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146610 */     // MIs[0] Rn
     /* 146610 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146622 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (SWPB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPB),
     /* 146625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146629 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146631 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146635 */     GIR_RootConstrainSelectedInstOperands,
     /* 146636 */     // GIR_Coverage, 7379,
     /* 146636 */     GIR_EraseRootFromParent_Done,
     /* 146637 */   // Label 2580: @146637
     /* 146637 */   GIM_Try, /*On fail goto*//*Label 2581*/ GIMT_Encode4(146686), // Rule ID 7380 //
     /* 146642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146645 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146652 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 146655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146659 */     // MIs[0] Rn
     /* 146659 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146671 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (SWPAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAB),
     /* 146674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146678 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146684 */     GIR_RootConstrainSelectedInstOperands,
     /* 146685 */     // GIR_Coverage, 7380,
     /* 146685 */     GIR_EraseRootFromParent_Done,
     /* 146686 */   // Label 2581: @146686
     /* 146686 */   GIM_Try, /*On fail goto*//*Label 2582*/ GIMT_Encode4(146735), // Rule ID 7381 //
     /* 146691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146694 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146701 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 146704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146708 */     // MIs[0] Rn
     /* 146708 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146720 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (SWPLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLB),
     /* 146723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146727 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146729 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146733 */     GIR_RootConstrainSelectedInstOperands,
     /* 146734 */     // GIR_Coverage, 7381,
     /* 146734 */     GIR_EraseRootFromParent_Done,
     /* 146735 */   // Label 2582: @146735
     /* 146735 */   GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(146784), // Rule ID 7382 //
     /* 146740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146743 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146750 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 146753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146757 */     // MIs[0] Rn
     /* 146757 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146769 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (SWPALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALB),
     /* 146772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146776 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146778 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146782 */     GIR_RootConstrainSelectedInstOperands,
     /* 146783 */     // GIR_Coverage, 7382,
     /* 146783 */     GIR_EraseRootFromParent_Done,
     /* 146784 */   // Label 2583: @146784
     /* 146784 */   GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(146833), // Rule ID 7383 //
     /* 146789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146792 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146799 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 146802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146806 */     // MIs[0] Rn
     /* 146806 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146818 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (SWPALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALB),
     /* 146821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146825 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146827 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146831 */     GIR_RootConstrainSelectedInstOperands,
     /* 146832 */     // GIR_Coverage, 7383,
     /* 146832 */     GIR_EraseRootFromParent_Done,
     /* 146833 */   // Label 2584: @146833
     /* 146833 */   GIM_Reject,
     /* 146834 */ // Label 2569: @146834
     /* 146834 */ GIM_Reject,
     /* 146835 */ // Label 2567: @146835
     /* 146835 */ GIM_Try, /*On fail goto*//*Label 2585*/ GIMT_Encode4(147061),
     /* 146840 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146843 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 146850 */   GIM_Try, /*On fail goto*//*Label 2586*/ GIMT_Encode4(146892), // Rule ID 7364 //
     /* 146855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146858 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 146861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146865 */     // MIs[0] Rn
     /* 146865 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146877 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_monotonic>>  =>  (SWPX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPX),
     /* 146880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146884 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146886 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146890 */     GIR_RootConstrainSelectedInstOperands,
     /* 146891 */     // GIR_Coverage, 7364,
     /* 146891 */     GIR_EraseRootFromParent_Done,
     /* 146892 */   // Label 2586: @146892
     /* 146892 */   GIM_Try, /*On fail goto*//*Label 2587*/ GIMT_Encode4(146934), // Rule ID 7365 //
     /* 146897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146900 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 146903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146907 */     // MIs[0] Rn
     /* 146907 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146919 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acquire>>  =>  (SWPAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAX),
     /* 146922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146926 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146932 */     GIR_RootConstrainSelectedInstOperands,
     /* 146933 */     // GIR_Coverage, 7365,
     /* 146933 */     GIR_EraseRootFromParent_Done,
     /* 146934 */   // Label 2587: @146934
     /* 146934 */   GIM_Try, /*On fail goto*//*Label 2588*/ GIMT_Encode4(146976), // Rule ID 7366 //
     /* 146939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146942 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 146945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146949 */     // MIs[0] Rn
     /* 146949 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146961 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_release>>  =>  (SWPLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLX),
     /* 146964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146968 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146974 */     GIR_RootConstrainSelectedInstOperands,
     /* 146975 */     // GIR_Coverage, 7366,
     /* 146975 */     GIR_EraseRootFromParent_Done,
     /* 146976 */   // Label 2588: @146976
     /* 146976 */   GIM_Try, /*On fail goto*//*Label 2589*/ GIMT_Encode4(147018), // Rule ID 7367 //
     /* 146981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146984 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 146987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146991 */     // MIs[0] Rn
     /* 146991 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147003 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acq_rel>>  =>  (SWPALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALX),
     /* 147006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147010 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147012 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147016 */     GIR_RootConstrainSelectedInstOperands,
     /* 147017 */     // GIR_Coverage, 7367,
     /* 147017 */     GIR_EraseRootFromParent_Done,
     /* 147018 */   // Label 2589: @147018
     /* 147018 */   GIM_Try, /*On fail goto*//*Label 2590*/ GIMT_Encode4(147060), // Rule ID 7368 //
     /* 147023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147026 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 147029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147033 */     // MIs[0] Rn
     /* 147033 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147045 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_seq_cst>>  =>  (SWPALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALX),
     /* 147048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147052 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147054 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147058 */     GIR_RootConstrainSelectedInstOperands,
     /* 147059 */     // GIR_Coverage, 7368,
     /* 147059 */     GIR_EraseRootFromParent_Done,
     /* 147060 */   // Label 2590: @147060
     /* 147060 */   GIM_Reject,
     /* 147061 */ // Label 2585: @147061
     /* 147061 */ GIM_Reject,
     /* 147062 */ // Label 2568: @147062
     /* 147062 */ GIM_Reject,
     /* 147063 */ // Label 22: @147063
     /* 147063 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2593*/ GIMT_Encode4(148054),
     /* 147074 */ /*GILLT_s32*//*Label 2591*/ GIMT_Encode4(147082),
     /* 147078 */ /*GILLT_s64*//*Label 2592*/ GIMT_Encode4(147827),
     /* 147082 */ // Label 2591: @147082
     /* 147082 */ GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(147826),
     /* 147087 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 147090 */   GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(147139), // Rule ID 7209 //
     /* 147095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147098 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 147105 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 147108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147112 */     // MIs[0] Rn
     /* 147112 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147124 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (LDADDW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDW),
     /* 147127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147131 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147133 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147137 */     GIR_RootConstrainSelectedInstOperands,
     /* 147138 */     // GIR_Coverage, 7209,
     /* 147138 */     GIR_EraseRootFromParent_Done,
     /* 147139 */   // Label 2595: @147139
     /* 147139 */   GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(147188), // Rule ID 7210 //
     /* 147144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147147 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 147154 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 147157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147161 */     // MIs[0] Rn
     /* 147161 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147173 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (LDADDAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAW),
     /* 147176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147180 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147182 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147186 */     GIR_RootConstrainSelectedInstOperands,
     /* 147187 */     // GIR_Coverage, 7210,
     /* 147187 */     GIR_EraseRootFromParent_Done,
     /* 147188 */   // Label 2596: @147188
     /* 147188 */   GIM_Try, /*On fail goto*//*Label 2597*/ GIMT_Encode4(147237), // Rule ID 7211 //
     /* 147193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147196 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 147203 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 147206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147210 */     // MIs[0] Rn
     /* 147210 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147222 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (LDADDLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLW),
     /* 147225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147229 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147235 */     GIR_RootConstrainSelectedInstOperands,
     /* 147236 */     // GIR_Coverage, 7211,
     /* 147236 */     GIR_EraseRootFromParent_Done,
     /* 147237 */   // Label 2597: @147237
     /* 147237 */   GIM_Try, /*On fail goto*//*Label 2598*/ GIMT_Encode4(147286), // Rule ID 7212 //
     /* 147242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147245 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 147252 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 147255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147259 */     // MIs[0] Rn
     /* 147259 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147271 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (LDADDALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 147274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147278 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147284 */     GIR_RootConstrainSelectedInstOperands,
     /* 147285 */     // GIR_Coverage, 7212,
     /* 147285 */     GIR_EraseRootFromParent_Done,
     /* 147286 */   // Label 2598: @147286
     /* 147286 */   GIM_Try, /*On fail goto*//*Label 2599*/ GIMT_Encode4(147335), // Rule ID 7213 //
     /* 147291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147294 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 147301 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 147304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147308 */     // MIs[0] Rn
     /* 147308 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147320 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (LDADDALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 147323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147327 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147329 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147333 */     GIR_RootConstrainSelectedInstOperands,
     /* 147334 */     // GIR_Coverage, 7213,
     /* 147334 */     GIR_EraseRootFromParent_Done,
     /* 147335 */   // Label 2599: @147335
     /* 147335 */   GIM_Try, /*On fail goto*//*Label 2600*/ GIMT_Encode4(147384), // Rule ID 7214 //
     /* 147340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147343 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 147350 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 147353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147357 */     // MIs[0] Rn
     /* 147357 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147369 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (LDADDH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDH),
     /* 147372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147376 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147378 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147382 */     GIR_RootConstrainSelectedInstOperands,
     /* 147383 */     // GIR_Coverage, 7214,
     /* 147383 */     GIR_EraseRootFromParent_Done,
     /* 147384 */   // Label 2600: @147384
     /* 147384 */   GIM_Try, /*On fail goto*//*Label 2601*/ GIMT_Encode4(147433), // Rule ID 7215 //
     /* 147389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147392 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 147399 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 147402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147406 */     // MIs[0] Rn
     /* 147406 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147418 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (LDADDAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAH),
     /* 147421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147425 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147427 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147431 */     GIR_RootConstrainSelectedInstOperands,
     /* 147432 */     // GIR_Coverage, 7215,
     /* 147432 */     GIR_EraseRootFromParent_Done,
     /* 147433 */   // Label 2601: @147433
     /* 147433 */   GIM_Try, /*On fail goto*//*Label 2602*/ GIMT_Encode4(147482), // Rule ID 7216 //
     /* 147438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147441 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 147448 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 147451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147455 */     // MIs[0] Rn
     /* 147455 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147467 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (LDADDLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLH),
     /* 147470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147474 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147480 */     GIR_RootConstrainSelectedInstOperands,
     /* 147481 */     // GIR_Coverage, 7216,
     /* 147481 */     GIR_EraseRootFromParent_Done,
     /* 147482 */   // Label 2602: @147482
     /* 147482 */   GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(147531), // Rule ID 7217 //
     /* 147487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147490 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 147497 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 147500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147504 */     // MIs[0] Rn
     /* 147504 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147516 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (LDADDALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 147519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147523 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147525 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147529 */     GIR_RootConstrainSelectedInstOperands,
     /* 147530 */     // GIR_Coverage, 7217,
     /* 147530 */     GIR_EraseRootFromParent_Done,
     /* 147531 */   // Label 2603: @147531
     /* 147531 */   GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(147580), // Rule ID 7218 //
     /* 147536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147539 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 147546 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 147549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147553 */     // MIs[0] Rn
     /* 147553 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147565 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (LDADDALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 147568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147572 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147574 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147578 */     GIR_RootConstrainSelectedInstOperands,
     /* 147579 */     // GIR_Coverage, 7218,
     /* 147579 */     GIR_EraseRootFromParent_Done,
     /* 147580 */   // Label 2604: @147580
     /* 147580 */   GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(147629), // Rule ID 7219 //
     /* 147585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147588 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147595 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 147598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147602 */     // MIs[0] Rn
     /* 147602 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147614 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (LDADDB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDB),
     /* 147617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147621 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147623 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147627 */     GIR_RootConstrainSelectedInstOperands,
     /* 147628 */     // GIR_Coverage, 7219,
     /* 147628 */     GIR_EraseRootFromParent_Done,
     /* 147629 */   // Label 2605: @147629
     /* 147629 */   GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(147678), // Rule ID 7220 //
     /* 147634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147637 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147644 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 147647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147651 */     // MIs[0] Rn
     /* 147651 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147663 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (LDADDAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAB),
     /* 147666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147670 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147672 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147676 */     GIR_RootConstrainSelectedInstOperands,
     /* 147677 */     // GIR_Coverage, 7220,
     /* 147677 */     GIR_EraseRootFromParent_Done,
     /* 147678 */   // Label 2606: @147678
     /* 147678 */   GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(147727), // Rule ID 7221 //
     /* 147683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147686 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147693 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 147696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147700 */     // MIs[0] Rn
     /* 147700 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147712 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (LDADDLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLB),
     /* 147715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147719 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147721 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147725 */     GIR_RootConstrainSelectedInstOperands,
     /* 147726 */     // GIR_Coverage, 7221,
     /* 147726 */     GIR_EraseRootFromParent_Done,
     /* 147727 */   // Label 2607: @147727
     /* 147727 */   GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(147776), // Rule ID 7222 //
     /* 147732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147735 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147742 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 147745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147749 */     // MIs[0] Rn
     /* 147749 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147761 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (LDADDALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 147764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147768 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147770 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147774 */     GIR_RootConstrainSelectedInstOperands,
     /* 147775 */     // GIR_Coverage, 7222,
     /* 147775 */     GIR_EraseRootFromParent_Done,
     /* 147776 */   // Label 2608: @147776
     /* 147776 */   GIM_Try, /*On fail goto*//*Label 2609*/ GIMT_Encode4(147825), // Rule ID 7223 //
     /* 147781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147784 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147791 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 147794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147798 */     // MIs[0] Rn
     /* 147798 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147810 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (LDADDALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 147813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147817 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147819 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147823 */     GIR_RootConstrainSelectedInstOperands,
     /* 147824 */     // GIR_Coverage, 7223,
     /* 147824 */     GIR_EraseRootFromParent_Done,
     /* 147825 */   // Label 2609: @147825
     /* 147825 */   GIM_Reject,
     /* 147826 */ // Label 2594: @147826
     /* 147826 */ GIM_Reject,
     /* 147827 */ // Label 2592: @147827
     /* 147827 */ GIM_Try, /*On fail goto*//*Label 2610*/ GIMT_Encode4(148053),
     /* 147832 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147835 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 147842 */   GIM_Try, /*On fail goto*//*Label 2611*/ GIMT_Encode4(147884), // Rule ID 2575 //
     /* 147847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147850 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 147853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147857 */     // MIs[0] Rn
     /* 147857 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147869 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_monotonic>>  =>  (LDADDX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDX),
     /* 147872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147876 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147878 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147882 */     GIR_RootConstrainSelectedInstOperands,
     /* 147883 */     // GIR_Coverage, 2575,
     /* 147883 */     GIR_EraseRootFromParent_Done,
     /* 147884 */   // Label 2611: @147884
     /* 147884 */   GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(147926), // Rule ID 2576 //
     /* 147889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147892 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 147895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147899 */     // MIs[0] Rn
     /* 147899 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147911 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acquire>>  =>  (LDADDAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAX),
     /* 147914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147918 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147920 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147924 */     GIR_RootConstrainSelectedInstOperands,
     /* 147925 */     // GIR_Coverage, 2576,
     /* 147925 */     GIR_EraseRootFromParent_Done,
     /* 147926 */   // Label 2612: @147926
     /* 147926 */   GIM_Try, /*On fail goto*//*Label 2613*/ GIMT_Encode4(147968), // Rule ID 2577 //
     /* 147931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147934 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 147937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147941 */     // MIs[0] Rn
     /* 147941 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147953 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_release>>  =>  (LDADDLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLX),
     /* 147956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147960 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147962 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147966 */     GIR_RootConstrainSelectedInstOperands,
     /* 147967 */     // GIR_Coverage, 2577,
     /* 147967 */     GIR_EraseRootFromParent_Done,
     /* 147968 */   // Label 2613: @147968
     /* 147968 */   GIM_Try, /*On fail goto*//*Label 2614*/ GIMT_Encode4(148010), // Rule ID 2578 //
     /* 147973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147976 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 147979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147983 */     // MIs[0] Rn
     /* 147983 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147995 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acq_rel>>  =>  (LDADDALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 147998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 148002 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148004 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148008 */     GIR_RootConstrainSelectedInstOperands,
     /* 148009 */     // GIR_Coverage, 2578,
     /* 148009 */     GIR_EraseRootFromParent_Done,
     /* 148010 */   // Label 2614: @148010
     /* 148010 */   GIM_Try, /*On fail goto*//*Label 2615*/ GIMT_Encode4(148052), // Rule ID 2579 //
     /* 148015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148018 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 148021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 148025 */     // MIs[0] Rn
     /* 148025 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 148037 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_seq_cst>>  =>  (LDADDALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 148037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 148040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 148044 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148046 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148050 */     GIR_RootConstrainSelectedInstOperands,
     /* 148051 */     // GIR_Coverage, 2579,
     /* 148051 */     GIR_EraseRootFromParent_Done,
     /* 148052 */   // Label 2615: @148052
     /* 148052 */   GIM_Reject,
     /* 148053 */ // Label 2610: @148053
     /* 148053 */ GIM_Reject,
     /* 148054 */ // Label 2593: @148054
     /* 148054 */ GIM_Reject,
     /* 148055 */ // Label 23: @148055
     /* 148055 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2618*/ GIMT_Encode4(149546),
     /* 148066 */ /*GILLT_s32*//*Label 2616*/ GIMT_Encode4(148074),
     /* 148070 */ /*GILLT_s64*//*Label 2617*/ GIMT_Encode4(149194),
     /* 148074 */ // Label 2616: @148074
     /* 148074 */ GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(149193),
     /* 148079 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 148082 */   GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(148156), // Rule ID 7404 //
     /* 148087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148090 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148097 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 148100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148104 */     // MIs[0] Rn
     /* 148104 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148116 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_monotonic>>  =>  (LDADDW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 148123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148128 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148134 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDW),
     /* 148143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148148 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148150 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148154 */     GIR_RootConstrainSelectedInstOperands,
     /* 148155 */     // GIR_Coverage, 7404,
     /* 148155 */     GIR_EraseRootFromParent_Done,
     /* 148156 */   // Label 2620: @148156
     /* 148156 */   GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(148230), // Rule ID 7405 //
     /* 148161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148164 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148171 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 148174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148178 */     // MIs[0] Rn
     /* 148178 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148190 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_acquire>>  =>  (LDADDAW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 148197 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148202 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148208 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148212 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAW),
     /* 148217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148222 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148228 */     GIR_RootConstrainSelectedInstOperands,
     /* 148229 */     // GIR_Coverage, 7405,
     /* 148229 */     GIR_EraseRootFromParent_Done,
     /* 148230 */   // Label 2621: @148230
     /* 148230 */   GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(148304), // Rule ID 7406 //
     /* 148235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148238 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148245 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 148248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148252 */     // MIs[0] Rn
     /* 148252 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148264 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_release>>  =>  (LDADDLW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 148271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148276 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148282 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLW),
     /* 148291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148293 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148296 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148298 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148302 */     GIR_RootConstrainSelectedInstOperands,
     /* 148303 */     // GIR_Coverage, 7406,
     /* 148303 */     GIR_EraseRootFromParent_Done,
     /* 148304 */   // Label 2622: @148304
     /* 148304 */   GIM_Try, /*On fail goto*//*Label 2623*/ GIMT_Encode4(148378), // Rule ID 7407 //
     /* 148309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148312 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148319 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 148322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148326 */     // MIs[0] Rn
     /* 148326 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148338 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_acq_rel>>  =>  (LDADDALW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 148345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148350 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148356 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 148365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148370 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148372 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148376 */     GIR_RootConstrainSelectedInstOperands,
     /* 148377 */     // GIR_Coverage, 7407,
     /* 148377 */     GIR_EraseRootFromParent_Done,
     /* 148378 */   // Label 2623: @148378
     /* 148378 */   GIM_Try, /*On fail goto*//*Label 2624*/ GIMT_Encode4(148452), // Rule ID 7408 //
     /* 148383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148386 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148393 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 148396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148400 */     // MIs[0] Rn
     /* 148400 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148412 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_seq_cst>>  =>  (LDADDALW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 148419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148424 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148430 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148434 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 148439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148444 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148446 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148450 */     GIR_RootConstrainSelectedInstOperands,
     /* 148451 */     // GIR_Coverage, 7408,
     /* 148451 */     GIR_EraseRootFromParent_Done,
     /* 148452 */   // Label 2624: @148452
     /* 148452 */   GIM_Try, /*On fail goto*//*Label 2625*/ GIMT_Encode4(148526), // Rule ID 7409 //
     /* 148457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148460 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148467 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 148470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148474 */     // MIs[0] Rn
     /* 148474 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148486 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_monotonic>>  =>  (LDADDH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 148493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148498 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148504 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDH),
     /* 148513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148518 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148520 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148524 */     GIR_RootConstrainSelectedInstOperands,
     /* 148525 */     // GIR_Coverage, 7409,
     /* 148525 */     GIR_EraseRootFromParent_Done,
     /* 148526 */   // Label 2625: @148526
     /* 148526 */   GIM_Try, /*On fail goto*//*Label 2626*/ GIMT_Encode4(148600), // Rule ID 7410 //
     /* 148531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148534 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148541 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 148544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148548 */     // MIs[0] Rn
     /* 148548 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148560 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_acquire>>  =>  (LDADDAH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148560 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148563 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 148567 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148572 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148578 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAH),
     /* 148587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148592 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148594 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148598 */     GIR_RootConstrainSelectedInstOperands,
     /* 148599 */     // GIR_Coverage, 7410,
     /* 148599 */     GIR_EraseRootFromParent_Done,
     /* 148600 */   // Label 2626: @148600
     /* 148600 */   GIM_Try, /*On fail goto*//*Label 2627*/ GIMT_Encode4(148674), // Rule ID 7411 //
     /* 148605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148608 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148615 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 148618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148622 */     // MIs[0] Rn
     /* 148622 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148634 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_release>>  =>  (LDADDLH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 148641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148646 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148652 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148656 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLH),
     /* 148661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148663 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148666 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148668 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148672 */     GIR_RootConstrainSelectedInstOperands,
     /* 148673 */     // GIR_Coverage, 7411,
     /* 148673 */     GIR_EraseRootFromParent_Done,
     /* 148674 */   // Label 2627: @148674
     /* 148674 */   GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(148748), // Rule ID 7412 //
     /* 148679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148682 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148689 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 148692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148696 */     // MIs[0] Rn
     /* 148696 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148708 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_acq_rel>>  =>  (LDADDALH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 148715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148720 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148726 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148730 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 148735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148737 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148740 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148742 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148746 */     GIR_RootConstrainSelectedInstOperands,
     /* 148747 */     // GIR_Coverage, 7412,
     /* 148747 */     GIR_EraseRootFromParent_Done,
     /* 148748 */   // Label 2628: @148748
     /* 148748 */   GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(148822), // Rule ID 7413 //
     /* 148753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148756 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148763 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 148766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148770 */     // MIs[0] Rn
     /* 148770 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148782 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_seq_cst>>  =>  (LDADDALH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148782 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148785 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 148789 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148794 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148800 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 148809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148814 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148816 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148820 */     GIR_RootConstrainSelectedInstOperands,
     /* 148821 */     // GIR_Coverage, 7413,
     /* 148821 */     GIR_EraseRootFromParent_Done,
     /* 148822 */   // Label 2629: @148822
     /* 148822 */   GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(148896), // Rule ID 7414 //
     /* 148827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148830 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148837 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 148840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148844 */     // MIs[0] Rn
     /* 148844 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148856 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_monotonic>>  =>  (LDADDB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148856 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148859 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 148863 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148868 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148874 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148878 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDB),
     /* 148883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148885 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148888 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148890 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148894 */     GIR_RootConstrainSelectedInstOperands,
     /* 148895 */     // GIR_Coverage, 7414,
     /* 148895 */     GIR_EraseRootFromParent_Done,
     /* 148896 */   // Label 2630: @148896
     /* 148896 */   GIM_Try, /*On fail goto*//*Label 2631*/ GIMT_Encode4(148970), // Rule ID 7415 //
     /* 148901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148904 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148911 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 148914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148918 */     // MIs[0] Rn
     /* 148918 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148930 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_acquire>>  =>  (LDADDAB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148933 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 148937 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148942 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148948 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148952 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAB),
     /* 148957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148962 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148968 */     GIR_RootConstrainSelectedInstOperands,
     /* 148969 */     // GIR_Coverage, 7415,
     /* 148969 */     GIR_EraseRootFromParent_Done,
     /* 148970 */   // Label 2631: @148970
     /* 148970 */   GIM_Try, /*On fail goto*//*Label 2632*/ GIMT_Encode4(149044), // Rule ID 7416 //
     /* 148975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148978 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148985 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 148988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148992 */     // MIs[0] Rn
     /* 148992 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149004 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_release>>  =>  (LDADDLB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 149007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 149011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149016 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149022 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149026 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLB),
     /* 149031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149033 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149036 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149038 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149042 */     GIR_RootConstrainSelectedInstOperands,
     /* 149043 */     // GIR_Coverage, 7416,
     /* 149043 */     GIR_EraseRootFromParent_Done,
     /* 149044 */   // Label 2632: @149044
     /* 149044 */   GIM_Try, /*On fail goto*//*Label 2633*/ GIMT_Encode4(149118), // Rule ID 7417 //
     /* 149049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149052 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 149059 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 149062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149066 */     // MIs[0] Rn
     /* 149066 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149078 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_acq_rel>>  =>  (LDADDALB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 149081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 149085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149090 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149096 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149100 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 149105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149110 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149112 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149116 */     GIR_RootConstrainSelectedInstOperands,
     /* 149117 */     // GIR_Coverage, 7417,
     /* 149117 */     GIR_EraseRootFromParent_Done,
     /* 149118 */   // Label 2633: @149118
     /* 149118 */   GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(149192), // Rule ID 7418 //
     /* 149123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149126 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 149133 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 149136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149140 */     // MIs[0] Rn
     /* 149140 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149152 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_seq_cst>>  =>  (LDADDALB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 149155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 149159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149164 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149170 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 149179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149184 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149186 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149190 */     GIR_RootConstrainSelectedInstOperands,
     /* 149191 */     // GIR_Coverage, 7418,
     /* 149191 */     GIR_EraseRootFromParent_Done,
     /* 149192 */   // Label 2634: @149192
     /* 149192 */   GIM_Reject,
     /* 149193 */ // Label 2619: @149193
     /* 149193 */ GIM_Reject,
     /* 149194 */ // Label 2617: @149194
     /* 149194 */ GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(149545),
     /* 149199 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 149202 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 149209 */   GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(149276), // Rule ID 7399 //
     /* 149214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149217 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 149220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149224 */     // MIs[0] Rn
     /* 149224 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149236 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_monotonic>>  =>  (LDADDX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149236 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 149239 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 149243 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149248 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149254 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149258 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDX),
     /* 149263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149265 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149268 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149270 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149274 */     GIR_RootConstrainSelectedInstOperands,
     /* 149275 */     // GIR_Coverage, 7399,
     /* 149275 */     GIR_EraseRootFromParent_Done,
     /* 149276 */   // Label 2636: @149276
     /* 149276 */   GIM_Try, /*On fail goto*//*Label 2637*/ GIMT_Encode4(149343), // Rule ID 7400 //
     /* 149281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149284 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 149287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149291 */     // MIs[0] Rn
     /* 149291 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149303 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_acquire>>  =>  (LDADDAX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149303 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 149306 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 149310 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149315 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149321 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149325 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAX),
     /* 149330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149332 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149335 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149337 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149341 */     GIR_RootConstrainSelectedInstOperands,
     /* 149342 */     // GIR_Coverage, 7400,
     /* 149342 */     GIR_EraseRootFromParent_Done,
     /* 149343 */   // Label 2637: @149343
     /* 149343 */   GIM_Try, /*On fail goto*//*Label 2638*/ GIMT_Encode4(149410), // Rule ID 7401 //
     /* 149348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149351 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 149354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149358 */     // MIs[0] Rn
     /* 149358 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149370 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_release>>  =>  (LDADDLX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 149373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 149377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149382 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149388 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149392 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLX),
     /* 149397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149399 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149402 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149404 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149408 */     GIR_RootConstrainSelectedInstOperands,
     /* 149409 */     // GIR_Coverage, 7401,
     /* 149409 */     GIR_EraseRootFromParent_Done,
     /* 149410 */   // Label 2638: @149410
     /* 149410 */   GIM_Try, /*On fail goto*//*Label 2639*/ GIMT_Encode4(149477), // Rule ID 7402 //
     /* 149415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149418 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 149421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149425 */     // MIs[0] Rn
     /* 149425 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149437 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_acq_rel>>  =>  (LDADDALX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 149440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 149444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149449 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149455 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 149464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149466 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149469 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149471 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149475 */     GIR_RootConstrainSelectedInstOperands,
     /* 149476 */     // GIR_Coverage, 7402,
     /* 149476 */     GIR_EraseRootFromParent_Done,
     /* 149477 */   // Label 2639: @149477
     /* 149477 */   GIM_Try, /*On fail goto*//*Label 2640*/ GIMT_Encode4(149544), // Rule ID 7403 //
     /* 149482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149485 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 149488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149492 */     // MIs[0] Rn
     /* 149492 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149504 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_seq_cst>>  =>  (LDADDALX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 149507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 149511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149516 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149522 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149526 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 149531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149533 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149536 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149538 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149542 */     GIR_RootConstrainSelectedInstOperands,
     /* 149543 */     // GIR_Coverage, 7403,
     /* 149543 */     GIR_EraseRootFromParent_Done,
     /* 149544 */   // Label 2640: @149544
     /* 149544 */   GIM_Reject,
     /* 149545 */ // Label 2635: @149545
     /* 149545 */ GIM_Reject,
     /* 149546 */ // Label 2618: @149546
     /* 149546 */ GIM_Reject,
     /* 149547 */ // Label 24: @149547
     /* 149547 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2643*/ GIMT_Encode4(151038),
     /* 149558 */ /*GILLT_s32*//*Label 2641*/ GIMT_Encode4(149566),
     /* 149562 */ /*GILLT_s64*//*Label 2642*/ GIMT_Encode4(150686),
     /* 149566 */ // Label 2641: @149566
     /* 149566 */ GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(150685),
     /* 149571 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 149574 */   GIM_Try, /*On fail goto*//*Label 2645*/ GIMT_Encode4(149648), // Rule ID 7424 //
     /* 149579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149582 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 149589 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 149592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149596 */     // MIs[0] Rn
     /* 149596 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149608 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (LDCLRW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149608 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 149611 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 149615 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149620 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149626 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149630 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRW),
     /* 149635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149637 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149640 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149646 */     GIR_RootConstrainSelectedInstOperands,
     /* 149647 */     // GIR_Coverage, 7424,
     /* 149647 */     GIR_EraseRootFromParent_Done,
     /* 149648 */   // Label 2645: @149648
     /* 149648 */   GIM_Try, /*On fail goto*//*Label 2646*/ GIMT_Encode4(149722), // Rule ID 7425 //
     /* 149653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149656 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 149663 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 149666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149670 */     // MIs[0] Rn
     /* 149670 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149682 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (LDCLRAW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 149685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 149689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149694 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149700 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAW),
     /* 149709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149714 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149716 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149720 */     GIR_RootConstrainSelectedInstOperands,
     /* 149721 */     // GIR_Coverage, 7425,
     /* 149721 */     GIR_EraseRootFromParent_Done,
     /* 149722 */   // Label 2646: @149722
     /* 149722 */   GIM_Try, /*On fail goto*//*Label 2647*/ GIMT_Encode4(149796), // Rule ID 7426 //
     /* 149727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149730 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 149737 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 149740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149744 */     // MIs[0] Rn
     /* 149744 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149756 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (LDCLRLW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 149759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 149763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149768 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149774 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLW),
     /* 149783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149785 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149788 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149790 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149794 */     GIR_RootConstrainSelectedInstOperands,
     /* 149795 */     // GIR_Coverage, 7426,
     /* 149795 */     GIR_EraseRootFromParent_Done,
     /* 149796 */   // Label 2647: @149796
     /* 149796 */   GIM_Try, /*On fail goto*//*Label 2648*/ GIMT_Encode4(149870), // Rule ID 7427 //
     /* 149801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149804 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 149811 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 149814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149818 */     // MIs[0] Rn
     /* 149818 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149830 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (LDCLRALW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 149833 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 149837 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149842 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149848 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149852 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALW),
     /* 149857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149862 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149864 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149868 */     GIR_RootConstrainSelectedInstOperands,
     /* 149869 */     // GIR_Coverage, 7427,
     /* 149869 */     GIR_EraseRootFromParent_Done,
     /* 149870 */   // Label 2648: @149870
     /* 149870 */   GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(149944), // Rule ID 7428 //
     /* 149875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149878 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 149885 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 149888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149892 */     // MIs[0] Rn
     /* 149892 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149904 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (LDCLRALW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149904 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 149907 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 149911 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149916 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149922 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149926 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALW),
     /* 149931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149933 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149936 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149938 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149942 */     GIR_RootConstrainSelectedInstOperands,
     /* 149943 */     // GIR_Coverage, 7428,
     /* 149943 */     GIR_EraseRootFromParent_Done,
     /* 149944 */   // Label 2649: @149944
     /* 149944 */   GIM_Try, /*On fail goto*//*Label 2650*/ GIMT_Encode4(150018), // Rule ID 7429 //
     /* 149949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149952 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 149959 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 149962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149966 */     // MIs[0] Rn
     /* 149966 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149978 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (LDCLRH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 149981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 149985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149990 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149996 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRH),
     /* 150005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150007 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150010 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150012 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150016 */     GIR_RootConstrainSelectedInstOperands,
     /* 150017 */     // GIR_Coverage, 7429,
     /* 150017 */     GIR_EraseRootFromParent_Done,
     /* 150018 */   // Label 2650: @150018
     /* 150018 */   GIM_Try, /*On fail goto*//*Label 2651*/ GIMT_Encode4(150092), // Rule ID 7430 //
     /* 150023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150026 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150033 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 150036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150040 */     // MIs[0] Rn
     /* 150040 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150044 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150052 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (LDCLRAH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 150055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 150059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150064 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150070 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150074 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAH),
     /* 150079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150081 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150084 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150086 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150090 */     GIR_RootConstrainSelectedInstOperands,
     /* 150091 */     // GIR_Coverage, 7430,
     /* 150091 */     GIR_EraseRootFromParent_Done,
     /* 150092 */   // Label 2651: @150092
     /* 150092 */   GIM_Try, /*On fail goto*//*Label 2652*/ GIMT_Encode4(150166), // Rule ID 7431 //
     /* 150097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150100 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150107 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 150110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150114 */     // MIs[0] Rn
     /* 150114 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150126 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (LDCLRLH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 150129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 150133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150138 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150144 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150148 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLH),
     /* 150153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150158 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150160 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150164 */     GIR_RootConstrainSelectedInstOperands,
     /* 150165 */     // GIR_Coverage, 7431,
     /* 150165 */     GIR_EraseRootFromParent_Done,
     /* 150166 */   // Label 2652: @150166
     /* 150166 */   GIM_Try, /*On fail goto*//*Label 2653*/ GIMT_Encode4(150240), // Rule ID 7432 //
     /* 150171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150174 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150181 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 150184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150188 */     // MIs[0] Rn
     /* 150188 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150200 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (LDCLRALH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150200 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 150203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 150207 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150212 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150218 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150222 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALH),
     /* 150227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150229 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150232 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150234 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150238 */     GIR_RootConstrainSelectedInstOperands,
     /* 150239 */     // GIR_Coverage, 7432,
     /* 150239 */     GIR_EraseRootFromParent_Done,
     /* 150240 */   // Label 2653: @150240
     /* 150240 */   GIM_Try, /*On fail goto*//*Label 2654*/ GIMT_Encode4(150314), // Rule ID 7433 //
     /* 150245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150248 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150255 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 150258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150262 */     // MIs[0] Rn
     /* 150262 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150274 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (LDCLRALH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 150277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 150281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150286 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150292 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALH),
     /* 150301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150306 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150312 */     GIR_RootConstrainSelectedInstOperands,
     /* 150313 */     // GIR_Coverage, 7433,
     /* 150313 */     GIR_EraseRootFromParent_Done,
     /* 150314 */   // Label 2654: @150314
     /* 150314 */   GIM_Try, /*On fail goto*//*Label 2655*/ GIMT_Encode4(150388), // Rule ID 7434 //
     /* 150319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150322 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150329 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 150332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150336 */     // MIs[0] Rn
     /* 150336 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150348 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (LDCLRB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150348 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 150351 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 150355 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150360 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150366 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150370 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRB),
     /* 150375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150377 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150380 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150382 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150386 */     GIR_RootConstrainSelectedInstOperands,
     /* 150387 */     // GIR_Coverage, 7434,
     /* 150387 */     GIR_EraseRootFromParent_Done,
     /* 150388 */   // Label 2655: @150388
     /* 150388 */   GIM_Try, /*On fail goto*//*Label 2656*/ GIMT_Encode4(150462), // Rule ID 7435 //
     /* 150393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150396 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150403 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 150406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150410 */     // MIs[0] Rn
     /* 150410 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150414 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150422 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (LDCLRAB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150422 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 150425 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 150429 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150434 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150440 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAB),
     /* 150449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150454 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150456 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150460 */     GIR_RootConstrainSelectedInstOperands,
     /* 150461 */     // GIR_Coverage, 7435,
     /* 150461 */     GIR_EraseRootFromParent_Done,
     /* 150462 */   // Label 2656: @150462
     /* 150462 */   GIM_Try, /*On fail goto*//*Label 2657*/ GIMT_Encode4(150536), // Rule ID 7436 //
     /* 150467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150470 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150477 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 150480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150484 */     // MIs[0] Rn
     /* 150484 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150496 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (LDCLRLB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 150499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 150503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150508 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150514 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLB),
     /* 150523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150525 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150528 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150530 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150534 */     GIR_RootConstrainSelectedInstOperands,
     /* 150535 */     // GIR_Coverage, 7436,
     /* 150535 */     GIR_EraseRootFromParent_Done,
     /* 150536 */   // Label 2657: @150536
     /* 150536 */   GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(150610), // Rule ID 7437 //
     /* 150541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150544 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150551 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 150554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150558 */     // MIs[0] Rn
     /* 150558 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150570 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (LDCLRALB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 150573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 150577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150582 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150588 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALB),
     /* 150597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150602 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150604 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150608 */     GIR_RootConstrainSelectedInstOperands,
     /* 150609 */     // GIR_Coverage, 7437,
     /* 150609 */     GIR_EraseRootFromParent_Done,
     /* 150610 */   // Label 2658: @150610
     /* 150610 */   GIM_Try, /*On fail goto*//*Label 2659*/ GIMT_Encode4(150684), // Rule ID 7438 //
     /* 150615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150618 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150625 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 150628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150632 */     // MIs[0] Rn
     /* 150632 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150644 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (LDCLRALB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 150647 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 150651 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150656 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150662 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150666 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALB),
     /* 150671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150673 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150676 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150678 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150682 */     GIR_RootConstrainSelectedInstOperands,
     /* 150683 */     // GIR_Coverage, 7438,
     /* 150683 */     GIR_EraseRootFromParent_Done,
     /* 150684 */   // Label 2659: @150684
     /* 150684 */   GIM_Reject,
     /* 150685 */ // Label 2644: @150685
     /* 150685 */ GIM_Reject,
     /* 150686 */ // Label 2642: @150686
     /* 150686 */ GIM_Try, /*On fail goto*//*Label 2660*/ GIMT_Encode4(151037),
     /* 150691 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 150694 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 150701 */   GIM_Try, /*On fail goto*//*Label 2661*/ GIMT_Encode4(150768), // Rule ID 7419 //
     /* 150706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150709 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 150712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150716 */     // MIs[0] Rn
     /* 150716 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150728 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_monotonic>>  =>  (LDCLRX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150728 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 150731 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 150735 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150740 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150746 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150750 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRX),
     /* 150755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150757 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150760 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150762 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150766 */     GIR_RootConstrainSelectedInstOperands,
     /* 150767 */     // GIR_Coverage, 7419,
     /* 150767 */     GIR_EraseRootFromParent_Done,
     /* 150768 */   // Label 2661: @150768
     /* 150768 */   GIM_Try, /*On fail goto*//*Label 2662*/ GIMT_Encode4(150835), // Rule ID 7420 //
     /* 150773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150776 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 150779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150783 */     // MIs[0] Rn
     /* 150783 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150795 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acquire>>  =>  (LDCLRAX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150795 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 150798 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 150802 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150807 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150813 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150817 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAX),
     /* 150822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150824 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150827 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150829 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150833 */     GIR_RootConstrainSelectedInstOperands,
     /* 150834 */     // GIR_Coverage, 7420,
     /* 150834 */     GIR_EraseRootFromParent_Done,
     /* 150835 */   // Label 2662: @150835
     /* 150835 */   GIM_Try, /*On fail goto*//*Label 2663*/ GIMT_Encode4(150902), // Rule ID 7421 //
     /* 150840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150843 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 150846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150850 */     // MIs[0] Rn
     /* 150850 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150862 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_release>>  =>  (LDCLRLX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 150865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 150869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150874 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150880 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150884 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLX),
     /* 150889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150894 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150900 */     GIR_RootConstrainSelectedInstOperands,
     /* 150901 */     // GIR_Coverage, 7421,
     /* 150901 */     GIR_EraseRootFromParent_Done,
     /* 150902 */   // Label 2663: @150902
     /* 150902 */   GIM_Try, /*On fail goto*//*Label 2664*/ GIMT_Encode4(150969), // Rule ID 7422 //
     /* 150907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150910 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 150913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150917 */     // MIs[0] Rn
     /* 150917 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150929 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acq_rel>>  =>  (LDCLRALX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150929 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 150932 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 150936 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150941 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150947 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150951 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALX),
     /* 150956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150958 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150961 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150963 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150967 */     GIR_RootConstrainSelectedInstOperands,
     /* 150968 */     // GIR_Coverage, 7422,
     /* 150968 */     GIR_EraseRootFromParent_Done,
     /* 150969 */   // Label 2664: @150969
     /* 150969 */   GIM_Try, /*On fail goto*//*Label 2665*/ GIMT_Encode4(151036), // Rule ID 7423 //
     /* 150974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150977 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 150980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150984 */     // MIs[0] Rn
     /* 150984 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150996 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_seq_cst>>  =>  (LDCLRALX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150996 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 150999 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 151003 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151008 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 151014 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 151018 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 151020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALX),
     /* 151023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151025 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151028 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151030 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151034 */     GIR_RootConstrainSelectedInstOperands,
     /* 151035 */     // GIR_Coverage, 7423,
     /* 151035 */     GIR_EraseRootFromParent_Done,
     /* 151036 */   // Label 2665: @151036
     /* 151036 */   GIM_Reject,
     /* 151037 */ // Label 2660: @151037
     /* 151037 */ GIM_Reject,
     /* 151038 */ // Label 2643: @151038
     /* 151038 */ GIM_Reject,
     /* 151039 */ // Label 25: @151039
     /* 151039 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2668*/ GIMT_Encode4(152030),
     /* 151050 */ /*GILLT_s32*//*Label 2666*/ GIMT_Encode4(151058),
     /* 151054 */ /*GILLT_s64*//*Label 2667*/ GIMT_Encode4(151803),
     /* 151058 */ // Label 2666: @151058
     /* 151058 */ GIM_Try, /*On fail goto*//*Label 2669*/ GIMT_Encode4(151802),
     /* 151063 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 151066 */   GIM_Try, /*On fail goto*//*Label 2670*/ GIMT_Encode4(151115), // Rule ID 7229 //
     /* 151071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151074 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 151081 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 151084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151088 */     // MIs[0] Rn
     /* 151088 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151100 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (LDSETW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETW),
     /* 151103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151107 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151109 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151113 */     GIR_RootConstrainSelectedInstOperands,
     /* 151114 */     // GIR_Coverage, 7229,
     /* 151114 */     GIR_EraseRootFromParent_Done,
     /* 151115 */   // Label 2670: @151115
     /* 151115 */   GIM_Try, /*On fail goto*//*Label 2671*/ GIMT_Encode4(151164), // Rule ID 7230 //
     /* 151120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151123 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 151130 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 151133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151137 */     // MIs[0] Rn
     /* 151137 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151149 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (LDSETAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAW),
     /* 151152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151156 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151158 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151162 */     GIR_RootConstrainSelectedInstOperands,
     /* 151163 */     // GIR_Coverage, 7230,
     /* 151163 */     GIR_EraseRootFromParent_Done,
     /* 151164 */   // Label 2671: @151164
     /* 151164 */   GIM_Try, /*On fail goto*//*Label 2672*/ GIMT_Encode4(151213), // Rule ID 7231 //
     /* 151169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151172 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 151179 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 151182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151186 */     // MIs[0] Rn
     /* 151186 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151198 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (LDSETLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLW),
     /* 151201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151205 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151207 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151211 */     GIR_RootConstrainSelectedInstOperands,
     /* 151212 */     // GIR_Coverage, 7231,
     /* 151212 */     GIR_EraseRootFromParent_Done,
     /* 151213 */   // Label 2672: @151213
     /* 151213 */   GIM_Try, /*On fail goto*//*Label 2673*/ GIMT_Encode4(151262), // Rule ID 7232 //
     /* 151218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151221 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 151228 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 151231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151235 */     // MIs[0] Rn
     /* 151235 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151247 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (LDSETALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALW),
     /* 151250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151254 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151256 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151260 */     GIR_RootConstrainSelectedInstOperands,
     /* 151261 */     // GIR_Coverage, 7232,
     /* 151261 */     GIR_EraseRootFromParent_Done,
     /* 151262 */   // Label 2673: @151262
     /* 151262 */   GIM_Try, /*On fail goto*//*Label 2674*/ GIMT_Encode4(151311), // Rule ID 7233 //
     /* 151267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151270 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 151277 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 151280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151284 */     // MIs[0] Rn
     /* 151284 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151296 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (LDSETALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALW),
     /* 151299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151303 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151305 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151309 */     GIR_RootConstrainSelectedInstOperands,
     /* 151310 */     // GIR_Coverage, 7233,
     /* 151310 */     GIR_EraseRootFromParent_Done,
     /* 151311 */   // Label 2674: @151311
     /* 151311 */   GIM_Try, /*On fail goto*//*Label 2675*/ GIMT_Encode4(151360), // Rule ID 7234 //
     /* 151316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151319 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151326 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 151329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151333 */     // MIs[0] Rn
     /* 151333 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151345 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (LDSETH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETH),
     /* 151348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151352 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151358 */     GIR_RootConstrainSelectedInstOperands,
     /* 151359 */     // GIR_Coverage, 7234,
     /* 151359 */     GIR_EraseRootFromParent_Done,
     /* 151360 */   // Label 2675: @151360
     /* 151360 */   GIM_Try, /*On fail goto*//*Label 2676*/ GIMT_Encode4(151409), // Rule ID 7235 //
     /* 151365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151368 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151375 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 151378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151382 */     // MIs[0] Rn
     /* 151382 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151394 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (LDSETAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAH),
     /* 151397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151401 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151403 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151407 */     GIR_RootConstrainSelectedInstOperands,
     /* 151408 */     // GIR_Coverage, 7235,
     /* 151408 */     GIR_EraseRootFromParent_Done,
     /* 151409 */   // Label 2676: @151409
     /* 151409 */   GIM_Try, /*On fail goto*//*Label 2677*/ GIMT_Encode4(151458), // Rule ID 7236 //
     /* 151414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151417 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151424 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 151427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151431 */     // MIs[0] Rn
     /* 151431 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151443 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (LDSETLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLH),
     /* 151446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151450 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151452 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151456 */     GIR_RootConstrainSelectedInstOperands,
     /* 151457 */     // GIR_Coverage, 7236,
     /* 151457 */     GIR_EraseRootFromParent_Done,
     /* 151458 */   // Label 2677: @151458
     /* 151458 */   GIM_Try, /*On fail goto*//*Label 2678*/ GIMT_Encode4(151507), // Rule ID 7237 //
     /* 151463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151466 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151473 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 151476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151480 */     // MIs[0] Rn
     /* 151480 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151492 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (LDSETALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALH),
     /* 151495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151499 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151501 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151505 */     GIR_RootConstrainSelectedInstOperands,
     /* 151506 */     // GIR_Coverage, 7237,
     /* 151506 */     GIR_EraseRootFromParent_Done,
     /* 151507 */   // Label 2678: @151507
     /* 151507 */   GIM_Try, /*On fail goto*//*Label 2679*/ GIMT_Encode4(151556), // Rule ID 7238 //
     /* 151512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151515 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151522 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 151525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151529 */     // MIs[0] Rn
     /* 151529 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151541 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (LDSETALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALH),
     /* 151544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151548 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151550 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151554 */     GIR_RootConstrainSelectedInstOperands,
     /* 151555 */     // GIR_Coverage, 7238,
     /* 151555 */     GIR_EraseRootFromParent_Done,
     /* 151556 */   // Label 2679: @151556
     /* 151556 */   GIM_Try, /*On fail goto*//*Label 2680*/ GIMT_Encode4(151605), // Rule ID 7239 //
     /* 151561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151564 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151571 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 151574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151578 */     // MIs[0] Rn
     /* 151578 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151590 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (LDSETB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETB),
     /* 151593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151597 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151599 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151603 */     GIR_RootConstrainSelectedInstOperands,
     /* 151604 */     // GIR_Coverage, 7239,
     /* 151604 */     GIR_EraseRootFromParent_Done,
     /* 151605 */   // Label 2680: @151605
     /* 151605 */   GIM_Try, /*On fail goto*//*Label 2681*/ GIMT_Encode4(151654), // Rule ID 7240 //
     /* 151610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151613 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151620 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 151623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151627 */     // MIs[0] Rn
     /* 151627 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151639 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (LDSETAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAB),
     /* 151642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151646 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151648 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151652 */     GIR_RootConstrainSelectedInstOperands,
     /* 151653 */     // GIR_Coverage, 7240,
     /* 151653 */     GIR_EraseRootFromParent_Done,
     /* 151654 */   // Label 2681: @151654
     /* 151654 */   GIM_Try, /*On fail goto*//*Label 2682*/ GIMT_Encode4(151703), // Rule ID 7241 //
     /* 151659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151662 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151669 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 151672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151676 */     // MIs[0] Rn
     /* 151676 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151688 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (LDSETLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLB),
     /* 151691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151695 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151697 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151701 */     GIR_RootConstrainSelectedInstOperands,
     /* 151702 */     // GIR_Coverage, 7241,
     /* 151702 */     GIR_EraseRootFromParent_Done,
     /* 151703 */   // Label 2682: @151703
     /* 151703 */   GIM_Try, /*On fail goto*//*Label 2683*/ GIMT_Encode4(151752), // Rule ID 7242 //
     /* 151708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151711 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151718 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 151721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151725 */     // MIs[0] Rn
     /* 151725 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151737 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (LDSETALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALB),
     /* 151740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151744 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151746 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151750 */     GIR_RootConstrainSelectedInstOperands,
     /* 151751 */     // GIR_Coverage, 7242,
     /* 151751 */     GIR_EraseRootFromParent_Done,
     /* 151752 */   // Label 2683: @151752
     /* 151752 */   GIM_Try, /*On fail goto*//*Label 2684*/ GIMT_Encode4(151801), // Rule ID 7243 //
     /* 151757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151760 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151767 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 151770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151774 */     // MIs[0] Rn
     /* 151774 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151786 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (LDSETALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALB),
     /* 151789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151793 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151795 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151799 */     GIR_RootConstrainSelectedInstOperands,
     /* 151800 */     // GIR_Coverage, 7243,
     /* 151800 */     GIR_EraseRootFromParent_Done,
     /* 151801 */   // Label 2684: @151801
     /* 151801 */   GIM_Reject,
     /* 151802 */ // Label 2669: @151802
     /* 151802 */ GIM_Reject,
     /* 151803 */ // Label 2667: @151803
     /* 151803 */ GIM_Try, /*On fail goto*//*Label 2685*/ GIMT_Encode4(152029),
     /* 151808 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 151811 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 151818 */   GIM_Try, /*On fail goto*//*Label 2686*/ GIMT_Encode4(151860), // Rule ID 7224 //
     /* 151823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151826 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 151829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151833 */     // MIs[0] Rn
     /* 151833 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151845 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_monotonic>>  =>  (LDSETX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETX),
     /* 151848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151852 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151854 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151858 */     GIR_RootConstrainSelectedInstOperands,
     /* 151859 */     // GIR_Coverage, 7224,
     /* 151859 */     GIR_EraseRootFromParent_Done,
     /* 151860 */   // Label 2686: @151860
     /* 151860 */   GIM_Try, /*On fail goto*//*Label 2687*/ GIMT_Encode4(151902), // Rule ID 7225 //
     /* 151865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151868 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 151871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151875 */     // MIs[0] Rn
     /* 151875 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151887 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acquire>>  =>  (LDSETAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAX),
     /* 151890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151894 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151900 */     GIR_RootConstrainSelectedInstOperands,
     /* 151901 */     // GIR_Coverage, 7225,
     /* 151901 */     GIR_EraseRootFromParent_Done,
     /* 151902 */   // Label 2687: @151902
     /* 151902 */   GIM_Try, /*On fail goto*//*Label 2688*/ GIMT_Encode4(151944), // Rule ID 7226 //
     /* 151907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151910 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 151913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151917 */     // MIs[0] Rn
     /* 151917 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151929 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_release>>  =>  (LDSETLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLX),
     /* 151932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151936 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151938 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151942 */     GIR_RootConstrainSelectedInstOperands,
     /* 151943 */     // GIR_Coverage, 7226,
     /* 151943 */     GIR_EraseRootFromParent_Done,
     /* 151944 */   // Label 2688: @151944
     /* 151944 */   GIM_Try, /*On fail goto*//*Label 2689*/ GIMT_Encode4(151986), // Rule ID 7227 //
     /* 151949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151952 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 151955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151959 */     // MIs[0] Rn
     /* 151959 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151971 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acq_rel>>  =>  (LDSETALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALX),
     /* 151974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151978 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151980 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151984 */     GIR_RootConstrainSelectedInstOperands,
     /* 151985 */     // GIR_Coverage, 7227,
     /* 151985 */     GIR_EraseRootFromParent_Done,
     /* 151986 */   // Label 2689: @151986
     /* 151986 */   GIM_Try, /*On fail goto*//*Label 2690*/ GIMT_Encode4(152028), // Rule ID 7228 //
     /* 151991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151994 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 151997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152001 */     // MIs[0] Rn
     /* 152001 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152013 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_seq_cst>>  =>  (LDSETALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALX),
     /* 152016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152020 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152022 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152026 */     GIR_RootConstrainSelectedInstOperands,
     /* 152027 */     // GIR_Coverage, 7228,
     /* 152027 */     GIR_EraseRootFromParent_Done,
     /* 152028 */   // Label 2690: @152028
     /* 152028 */   GIM_Reject,
     /* 152029 */ // Label 2685: @152029
     /* 152029 */ GIM_Reject,
     /* 152030 */ // Label 2668: @152030
     /* 152030 */ GIM_Reject,
     /* 152031 */ // Label 26: @152031
     /* 152031 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2693*/ GIMT_Encode4(153022),
     /* 152042 */ /*GILLT_s32*//*Label 2691*/ GIMT_Encode4(152050),
     /* 152046 */ /*GILLT_s64*//*Label 2692*/ GIMT_Encode4(152795),
     /* 152050 */ // Label 2691: @152050
     /* 152050 */ GIM_Try, /*On fail goto*//*Label 2694*/ GIMT_Encode4(152794),
     /* 152055 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152058 */   GIM_Try, /*On fail goto*//*Label 2695*/ GIMT_Encode4(152107), // Rule ID 7249 //
     /* 152063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152066 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 152073 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 152076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152080 */     // MIs[0] Rn
     /* 152080 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152092 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (LDEORW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORW),
     /* 152095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152099 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152101 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152105 */     GIR_RootConstrainSelectedInstOperands,
     /* 152106 */     // GIR_Coverage, 7249,
     /* 152106 */     GIR_EraseRootFromParent_Done,
     /* 152107 */   // Label 2695: @152107
     /* 152107 */   GIM_Try, /*On fail goto*//*Label 2696*/ GIMT_Encode4(152156), // Rule ID 7250 //
     /* 152112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152115 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 152122 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 152125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152129 */     // MIs[0] Rn
     /* 152129 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152141 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (LDEORAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAW),
     /* 152144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152148 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152150 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152154 */     GIR_RootConstrainSelectedInstOperands,
     /* 152155 */     // GIR_Coverage, 7250,
     /* 152155 */     GIR_EraseRootFromParent_Done,
     /* 152156 */   // Label 2696: @152156
     /* 152156 */   GIM_Try, /*On fail goto*//*Label 2697*/ GIMT_Encode4(152205), // Rule ID 7251 //
     /* 152161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152164 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 152171 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 152174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152178 */     // MIs[0] Rn
     /* 152178 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152190 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (LDEORLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLW),
     /* 152193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152197 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152199 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152203 */     GIR_RootConstrainSelectedInstOperands,
     /* 152204 */     // GIR_Coverage, 7251,
     /* 152204 */     GIR_EraseRootFromParent_Done,
     /* 152205 */   // Label 2697: @152205
     /* 152205 */   GIM_Try, /*On fail goto*//*Label 2698*/ GIMT_Encode4(152254), // Rule ID 7252 //
     /* 152210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152213 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 152220 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 152223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152227 */     // MIs[0] Rn
     /* 152227 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152239 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (LDEORALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALW),
     /* 152242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152246 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152248 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152252 */     GIR_RootConstrainSelectedInstOperands,
     /* 152253 */     // GIR_Coverage, 7252,
     /* 152253 */     GIR_EraseRootFromParent_Done,
     /* 152254 */   // Label 2698: @152254
     /* 152254 */   GIM_Try, /*On fail goto*//*Label 2699*/ GIMT_Encode4(152303), // Rule ID 7253 //
     /* 152259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152262 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 152269 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 152272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152276 */     // MIs[0] Rn
     /* 152276 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152288 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (LDEORALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALW),
     /* 152291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152295 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152297 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152301 */     GIR_RootConstrainSelectedInstOperands,
     /* 152302 */     // GIR_Coverage, 7253,
     /* 152302 */     GIR_EraseRootFromParent_Done,
     /* 152303 */   // Label 2699: @152303
     /* 152303 */   GIM_Try, /*On fail goto*//*Label 2700*/ GIMT_Encode4(152352), // Rule ID 7254 //
     /* 152308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152311 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152318 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 152321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152325 */     // MIs[0] Rn
     /* 152325 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152337 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (LDEORH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORH),
     /* 152340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152344 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152346 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152350 */     GIR_RootConstrainSelectedInstOperands,
     /* 152351 */     // GIR_Coverage, 7254,
     /* 152351 */     GIR_EraseRootFromParent_Done,
     /* 152352 */   // Label 2700: @152352
     /* 152352 */   GIM_Try, /*On fail goto*//*Label 2701*/ GIMT_Encode4(152401), // Rule ID 7255 //
     /* 152357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152360 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152367 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 152370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152374 */     // MIs[0] Rn
     /* 152374 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152386 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (LDEORAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAH),
     /* 152389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152393 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152395 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152399 */     GIR_RootConstrainSelectedInstOperands,
     /* 152400 */     // GIR_Coverage, 7255,
     /* 152400 */     GIR_EraseRootFromParent_Done,
     /* 152401 */   // Label 2701: @152401
     /* 152401 */   GIM_Try, /*On fail goto*//*Label 2702*/ GIMT_Encode4(152450), // Rule ID 7256 //
     /* 152406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152409 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152416 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 152419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152423 */     // MIs[0] Rn
     /* 152423 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152435 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (LDEORLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLH),
     /* 152438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152442 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152444 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152448 */     GIR_RootConstrainSelectedInstOperands,
     /* 152449 */     // GIR_Coverage, 7256,
     /* 152449 */     GIR_EraseRootFromParent_Done,
     /* 152450 */   // Label 2702: @152450
     /* 152450 */   GIM_Try, /*On fail goto*//*Label 2703*/ GIMT_Encode4(152499), // Rule ID 7257 //
     /* 152455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152458 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152465 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 152468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152472 */     // MIs[0] Rn
     /* 152472 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152484 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (LDEORALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALH),
     /* 152487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152491 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152493 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152497 */     GIR_RootConstrainSelectedInstOperands,
     /* 152498 */     // GIR_Coverage, 7257,
     /* 152498 */     GIR_EraseRootFromParent_Done,
     /* 152499 */   // Label 2703: @152499
     /* 152499 */   GIM_Try, /*On fail goto*//*Label 2704*/ GIMT_Encode4(152548), // Rule ID 7258 //
     /* 152504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152507 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152514 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 152517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152521 */     // MIs[0] Rn
     /* 152521 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152533 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (LDEORALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALH),
     /* 152536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152540 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152542 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152546 */     GIR_RootConstrainSelectedInstOperands,
     /* 152547 */     // GIR_Coverage, 7258,
     /* 152547 */     GIR_EraseRootFromParent_Done,
     /* 152548 */   // Label 2704: @152548
     /* 152548 */   GIM_Try, /*On fail goto*//*Label 2705*/ GIMT_Encode4(152597), // Rule ID 7259 //
     /* 152553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152556 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152563 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 152566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152570 */     // MIs[0] Rn
     /* 152570 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152582 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (LDEORB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORB),
     /* 152585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152589 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152591 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152595 */     GIR_RootConstrainSelectedInstOperands,
     /* 152596 */     // GIR_Coverage, 7259,
     /* 152596 */     GIR_EraseRootFromParent_Done,
     /* 152597 */   // Label 2705: @152597
     /* 152597 */   GIM_Try, /*On fail goto*//*Label 2706*/ GIMT_Encode4(152646), // Rule ID 7260 //
     /* 152602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152605 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152612 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 152615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152619 */     // MIs[0] Rn
     /* 152619 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152631 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (LDEORAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAB),
     /* 152634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152638 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152640 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152644 */     GIR_RootConstrainSelectedInstOperands,
     /* 152645 */     // GIR_Coverage, 7260,
     /* 152645 */     GIR_EraseRootFromParent_Done,
     /* 152646 */   // Label 2706: @152646
     /* 152646 */   GIM_Try, /*On fail goto*//*Label 2707*/ GIMT_Encode4(152695), // Rule ID 7261 //
     /* 152651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152654 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152661 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 152664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152668 */     // MIs[0] Rn
     /* 152668 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152680 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (LDEORLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLB),
     /* 152683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152687 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152689 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152693 */     GIR_RootConstrainSelectedInstOperands,
     /* 152694 */     // GIR_Coverage, 7261,
     /* 152694 */     GIR_EraseRootFromParent_Done,
     /* 152695 */   // Label 2707: @152695
     /* 152695 */   GIM_Try, /*On fail goto*//*Label 2708*/ GIMT_Encode4(152744), // Rule ID 7262 //
     /* 152700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152703 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152710 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 152713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152717 */     // MIs[0] Rn
     /* 152717 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152729 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (LDEORALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALB),
     /* 152732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152736 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152738 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152742 */     GIR_RootConstrainSelectedInstOperands,
     /* 152743 */     // GIR_Coverage, 7262,
     /* 152743 */     GIR_EraseRootFromParent_Done,
     /* 152744 */   // Label 2708: @152744
     /* 152744 */   GIM_Try, /*On fail goto*//*Label 2709*/ GIMT_Encode4(152793), // Rule ID 7263 //
     /* 152749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152752 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152759 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 152762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152766 */     // MIs[0] Rn
     /* 152766 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152778 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (LDEORALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALB),
     /* 152781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152785 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152787 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152791 */     GIR_RootConstrainSelectedInstOperands,
     /* 152792 */     // GIR_Coverage, 7263,
     /* 152792 */     GIR_EraseRootFromParent_Done,
     /* 152793 */   // Label 2709: @152793
     /* 152793 */   GIM_Reject,
     /* 152794 */ // Label 2694: @152794
     /* 152794 */ GIM_Reject,
     /* 152795 */ // Label 2692: @152795
     /* 152795 */ GIM_Try, /*On fail goto*//*Label 2710*/ GIMT_Encode4(153021),
     /* 152800 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 152803 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 152810 */   GIM_Try, /*On fail goto*//*Label 2711*/ GIMT_Encode4(152852), // Rule ID 7244 //
     /* 152815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152818 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 152821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152825 */     // MIs[0] Rn
     /* 152825 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152829 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152837 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_monotonic>>  =>  (LDEORX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORX),
     /* 152840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152844 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152850 */     GIR_RootConstrainSelectedInstOperands,
     /* 152851 */     // GIR_Coverage, 7244,
     /* 152851 */     GIR_EraseRootFromParent_Done,
     /* 152852 */   // Label 2711: @152852
     /* 152852 */   GIM_Try, /*On fail goto*//*Label 2712*/ GIMT_Encode4(152894), // Rule ID 7245 //
     /* 152857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152860 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 152863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152867 */     // MIs[0] Rn
     /* 152867 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152879 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acquire>>  =>  (LDEORAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAX),
     /* 152882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152886 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152888 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152892 */     GIR_RootConstrainSelectedInstOperands,
     /* 152893 */     // GIR_Coverage, 7245,
     /* 152893 */     GIR_EraseRootFromParent_Done,
     /* 152894 */   // Label 2712: @152894
     /* 152894 */   GIM_Try, /*On fail goto*//*Label 2713*/ GIMT_Encode4(152936), // Rule ID 7246 //
     /* 152899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152902 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 152905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152909 */     // MIs[0] Rn
     /* 152909 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152921 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_release>>  =>  (LDEORLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLX),
     /* 152924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152928 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152930 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152934 */     GIR_RootConstrainSelectedInstOperands,
     /* 152935 */     // GIR_Coverage, 7246,
     /* 152935 */     GIR_EraseRootFromParent_Done,
     /* 152936 */   // Label 2713: @152936
     /* 152936 */   GIM_Try, /*On fail goto*//*Label 2714*/ GIMT_Encode4(152978), // Rule ID 7247 //
     /* 152941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152944 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 152947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152951 */     // MIs[0] Rn
     /* 152951 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152963 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acq_rel>>  =>  (LDEORALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALX),
     /* 152966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152970 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152972 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152976 */     GIR_RootConstrainSelectedInstOperands,
     /* 152977 */     // GIR_Coverage, 7247,
     /* 152977 */     GIR_EraseRootFromParent_Done,
     /* 152978 */   // Label 2714: @152978
     /* 152978 */   GIM_Try, /*On fail goto*//*Label 2715*/ GIMT_Encode4(153020), // Rule ID 7248 //
     /* 152983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152986 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 152989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152993 */     // MIs[0] Rn
     /* 152993 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153005 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_seq_cst>>  =>  (LDEORALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALX),
     /* 153008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153012 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153018 */     GIR_RootConstrainSelectedInstOperands,
     /* 153019 */     // GIR_Coverage, 7248,
     /* 153019 */     GIR_EraseRootFromParent_Done,
     /* 153020 */   // Label 2715: @153020
     /* 153020 */   GIM_Reject,
     /* 153021 */ // Label 2710: @153021
     /* 153021 */ GIM_Reject,
     /* 153022 */ // Label 2693: @153022
     /* 153022 */ GIM_Reject,
     /* 153023 */ // Label 27: @153023
     /* 153023 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2718*/ GIMT_Encode4(154014),
     /* 153034 */ /*GILLT_s32*//*Label 2716*/ GIMT_Encode4(153042),
     /* 153038 */ /*GILLT_s64*//*Label 2717*/ GIMT_Encode4(153787),
     /* 153042 */ // Label 2716: @153042
     /* 153042 */ GIM_Try, /*On fail goto*//*Label 2719*/ GIMT_Encode4(153786),
     /* 153047 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 153050 */   GIM_Try, /*On fail goto*//*Label 2720*/ GIMT_Encode4(153099), // Rule ID 7289 //
     /* 153055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153058 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153065 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 153068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153072 */     // MIs[0] Rn
     /* 153072 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153084 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (LDSMAXW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXW),
     /* 153087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153091 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153093 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153097 */     GIR_RootConstrainSelectedInstOperands,
     /* 153098 */     // GIR_Coverage, 7289,
     /* 153098 */     GIR_EraseRootFromParent_Done,
     /* 153099 */   // Label 2720: @153099
     /* 153099 */   GIM_Try, /*On fail goto*//*Label 2721*/ GIMT_Encode4(153148), // Rule ID 7290 //
     /* 153104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153107 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153114 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 153117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153121 */     // MIs[0] Rn
     /* 153121 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153133 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (LDSMAXAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAW),
     /* 153136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153140 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153142 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153146 */     GIR_RootConstrainSelectedInstOperands,
     /* 153147 */     // GIR_Coverage, 7290,
     /* 153147 */     GIR_EraseRootFromParent_Done,
     /* 153148 */   // Label 2721: @153148
     /* 153148 */   GIM_Try, /*On fail goto*//*Label 2722*/ GIMT_Encode4(153197), // Rule ID 7291 //
     /* 153153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153156 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153163 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 153166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153170 */     // MIs[0] Rn
     /* 153170 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153182 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (LDSMAXLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLW),
     /* 153185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153189 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153191 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153195 */     GIR_RootConstrainSelectedInstOperands,
     /* 153196 */     // GIR_Coverage, 7291,
     /* 153196 */     GIR_EraseRootFromParent_Done,
     /* 153197 */   // Label 2722: @153197
     /* 153197 */   GIM_Try, /*On fail goto*//*Label 2723*/ GIMT_Encode4(153246), // Rule ID 7292 //
     /* 153202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153205 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153212 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 153215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153219 */     // MIs[0] Rn
     /* 153219 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153231 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (LDSMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALW),
     /* 153234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153238 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153240 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153244 */     GIR_RootConstrainSelectedInstOperands,
     /* 153245 */     // GIR_Coverage, 7292,
     /* 153245 */     GIR_EraseRootFromParent_Done,
     /* 153246 */   // Label 2723: @153246
     /* 153246 */   GIM_Try, /*On fail goto*//*Label 2724*/ GIMT_Encode4(153295), // Rule ID 7293 //
     /* 153251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153254 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153261 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 153264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153268 */     // MIs[0] Rn
     /* 153268 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153280 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (LDSMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALW),
     /* 153283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153287 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153289 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153293 */     GIR_RootConstrainSelectedInstOperands,
     /* 153294 */     // GIR_Coverage, 7293,
     /* 153294 */     GIR_EraseRootFromParent_Done,
     /* 153295 */   // Label 2724: @153295
     /* 153295 */   GIM_Try, /*On fail goto*//*Label 2725*/ GIMT_Encode4(153344), // Rule ID 7294 //
     /* 153300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153303 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153310 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 153313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153317 */     // MIs[0] Rn
     /* 153317 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153329 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (LDSMAXH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXH),
     /* 153332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153336 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153338 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153342 */     GIR_RootConstrainSelectedInstOperands,
     /* 153343 */     // GIR_Coverage, 7294,
     /* 153343 */     GIR_EraseRootFromParent_Done,
     /* 153344 */   // Label 2725: @153344
     /* 153344 */   GIM_Try, /*On fail goto*//*Label 2726*/ GIMT_Encode4(153393), // Rule ID 7295 //
     /* 153349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153352 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153359 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 153362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153366 */     // MIs[0] Rn
     /* 153366 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153378 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (LDSMAXAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAH),
     /* 153381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153385 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153387 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153391 */     GIR_RootConstrainSelectedInstOperands,
     /* 153392 */     // GIR_Coverage, 7295,
     /* 153392 */     GIR_EraseRootFromParent_Done,
     /* 153393 */   // Label 2726: @153393
     /* 153393 */   GIM_Try, /*On fail goto*//*Label 2727*/ GIMT_Encode4(153442), // Rule ID 7296 //
     /* 153398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153401 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153408 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 153411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153415 */     // MIs[0] Rn
     /* 153415 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153427 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (LDSMAXLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLH),
     /* 153430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153434 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153440 */     GIR_RootConstrainSelectedInstOperands,
     /* 153441 */     // GIR_Coverage, 7296,
     /* 153441 */     GIR_EraseRootFromParent_Done,
     /* 153442 */   // Label 2727: @153442
     /* 153442 */   GIM_Try, /*On fail goto*//*Label 2728*/ GIMT_Encode4(153491), // Rule ID 7297 //
     /* 153447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153450 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153457 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 153460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153464 */     // MIs[0] Rn
     /* 153464 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153476 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (LDSMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALH),
     /* 153479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153483 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153485 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153489 */     GIR_RootConstrainSelectedInstOperands,
     /* 153490 */     // GIR_Coverage, 7297,
     /* 153490 */     GIR_EraseRootFromParent_Done,
     /* 153491 */   // Label 2728: @153491
     /* 153491 */   GIM_Try, /*On fail goto*//*Label 2729*/ GIMT_Encode4(153540), // Rule ID 7298 //
     /* 153496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153499 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153506 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 153509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153513 */     // MIs[0] Rn
     /* 153513 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153525 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (LDSMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALH),
     /* 153528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153532 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153534 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153538 */     GIR_RootConstrainSelectedInstOperands,
     /* 153539 */     // GIR_Coverage, 7298,
     /* 153539 */     GIR_EraseRootFromParent_Done,
     /* 153540 */   // Label 2729: @153540
     /* 153540 */   GIM_Try, /*On fail goto*//*Label 2730*/ GIMT_Encode4(153589), // Rule ID 7299 //
     /* 153545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153548 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153555 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 153558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153562 */     // MIs[0] Rn
     /* 153562 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153574 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (LDSMAXB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXB),
     /* 153577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153581 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153583 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153587 */     GIR_RootConstrainSelectedInstOperands,
     /* 153588 */     // GIR_Coverage, 7299,
     /* 153588 */     GIR_EraseRootFromParent_Done,
     /* 153589 */   // Label 2730: @153589
     /* 153589 */   GIM_Try, /*On fail goto*//*Label 2731*/ GIMT_Encode4(153638), // Rule ID 7300 //
     /* 153594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153597 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153604 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 153607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153611 */     // MIs[0] Rn
     /* 153611 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153623 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (LDSMAXAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAB),
     /* 153626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153630 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153632 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153636 */     GIR_RootConstrainSelectedInstOperands,
     /* 153637 */     // GIR_Coverage, 7300,
     /* 153637 */     GIR_EraseRootFromParent_Done,
     /* 153638 */   // Label 2731: @153638
     /* 153638 */   GIM_Try, /*On fail goto*//*Label 2732*/ GIMT_Encode4(153687), // Rule ID 7301 //
     /* 153643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153646 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153653 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 153656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153660 */     // MIs[0] Rn
     /* 153660 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153672 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (LDSMAXLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLB),
     /* 153675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153679 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153681 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153685 */     GIR_RootConstrainSelectedInstOperands,
     /* 153686 */     // GIR_Coverage, 7301,
     /* 153686 */     GIR_EraseRootFromParent_Done,
     /* 153687 */   // Label 2732: @153687
     /* 153687 */   GIM_Try, /*On fail goto*//*Label 2733*/ GIMT_Encode4(153736), // Rule ID 7302 //
     /* 153692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153695 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153702 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 153705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153709 */     // MIs[0] Rn
     /* 153709 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153721 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (LDSMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALB),
     /* 153724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153728 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153730 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153734 */     GIR_RootConstrainSelectedInstOperands,
     /* 153735 */     // GIR_Coverage, 7302,
     /* 153735 */     GIR_EraseRootFromParent_Done,
     /* 153736 */   // Label 2733: @153736
     /* 153736 */   GIM_Try, /*On fail goto*//*Label 2734*/ GIMT_Encode4(153785), // Rule ID 7303 //
     /* 153741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153744 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153751 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 153754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153758 */     // MIs[0] Rn
     /* 153758 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153770 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (LDSMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALB),
     /* 153773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153777 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153783 */     GIR_RootConstrainSelectedInstOperands,
     /* 153784 */     // GIR_Coverage, 7303,
     /* 153784 */     GIR_EraseRootFromParent_Done,
     /* 153785 */   // Label 2734: @153785
     /* 153785 */   GIM_Reject,
     /* 153786 */ // Label 2719: @153786
     /* 153786 */ GIM_Reject,
     /* 153787 */ // Label 2717: @153787
     /* 153787 */ GIM_Try, /*On fail goto*//*Label 2735*/ GIMT_Encode4(154013),
     /* 153792 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 153795 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 153802 */   GIM_Try, /*On fail goto*//*Label 2736*/ GIMT_Encode4(153844), // Rule ID 7284 //
     /* 153807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153810 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 153813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153817 */     // MIs[0] Rn
     /* 153817 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153829 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_monotonic>>  =>  (LDSMAXX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXX),
     /* 153832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153836 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153838 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153842 */     GIR_RootConstrainSelectedInstOperands,
     /* 153843 */     // GIR_Coverage, 7284,
     /* 153843 */     GIR_EraseRootFromParent_Done,
     /* 153844 */   // Label 2736: @153844
     /* 153844 */   GIM_Try, /*On fail goto*//*Label 2737*/ GIMT_Encode4(153886), // Rule ID 7285 //
     /* 153849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153852 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 153855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153859 */     // MIs[0] Rn
     /* 153859 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153871 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acquire>>  =>  (LDSMAXAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAX),
     /* 153874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153878 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153884 */     GIR_RootConstrainSelectedInstOperands,
     /* 153885 */     // GIR_Coverage, 7285,
     /* 153885 */     GIR_EraseRootFromParent_Done,
     /* 153886 */   // Label 2737: @153886
     /* 153886 */   GIM_Try, /*On fail goto*//*Label 2738*/ GIMT_Encode4(153928), // Rule ID 7286 //
     /* 153891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153894 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 153897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153901 */     // MIs[0] Rn
     /* 153901 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153905 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153913 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_release>>  =>  (LDSMAXLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLX),
     /* 153916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153920 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153922 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153926 */     GIR_RootConstrainSelectedInstOperands,
     /* 153927 */     // GIR_Coverage, 7286,
     /* 153927 */     GIR_EraseRootFromParent_Done,
     /* 153928 */   // Label 2738: @153928
     /* 153928 */   GIM_Try, /*On fail goto*//*Label 2739*/ GIMT_Encode4(153970), // Rule ID 7287 //
     /* 153933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153936 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 153939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153943 */     // MIs[0] Rn
     /* 153943 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153955 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acq_rel>>  =>  (LDSMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALX),
     /* 153958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153962 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153968 */     GIR_RootConstrainSelectedInstOperands,
     /* 153969 */     // GIR_Coverage, 7287,
     /* 153969 */     GIR_EraseRootFromParent_Done,
     /* 153970 */   // Label 2739: @153970
     /* 153970 */   GIM_Try, /*On fail goto*//*Label 2740*/ GIMT_Encode4(154012), // Rule ID 7288 //
     /* 153975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153978 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 153981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153985 */     // MIs[0] Rn
     /* 153985 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153989 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153997 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_seq_cst>>  =>  (LDSMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALX),
     /* 154000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154004 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154006 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154010 */     GIR_RootConstrainSelectedInstOperands,
     /* 154011 */     // GIR_Coverage, 7288,
     /* 154011 */     GIR_EraseRootFromParent_Done,
     /* 154012 */   // Label 2740: @154012
     /* 154012 */   GIM_Reject,
     /* 154013 */ // Label 2735: @154013
     /* 154013 */ GIM_Reject,
     /* 154014 */ // Label 2718: @154014
     /* 154014 */ GIM_Reject,
     /* 154015 */ // Label 28: @154015
     /* 154015 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2743*/ GIMT_Encode4(155006),
     /* 154026 */ /*GILLT_s32*//*Label 2741*/ GIMT_Encode4(154034),
     /* 154030 */ /*GILLT_s64*//*Label 2742*/ GIMT_Encode4(154779),
     /* 154034 */ // Label 2741: @154034
     /* 154034 */ GIM_Try, /*On fail goto*//*Label 2744*/ GIMT_Encode4(154778),
     /* 154039 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 154042 */   GIM_Try, /*On fail goto*//*Label 2745*/ GIMT_Encode4(154091), // Rule ID 7309 //
     /* 154047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154050 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154057 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 154060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154064 */     // MIs[0] Rn
     /* 154064 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154076 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (LDSMINW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINW),
     /* 154079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154083 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154085 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154089 */     GIR_RootConstrainSelectedInstOperands,
     /* 154090 */     // GIR_Coverage, 7309,
     /* 154090 */     GIR_EraseRootFromParent_Done,
     /* 154091 */   // Label 2745: @154091
     /* 154091 */   GIM_Try, /*On fail goto*//*Label 2746*/ GIMT_Encode4(154140), // Rule ID 7310 //
     /* 154096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154099 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154106 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 154109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154113 */     // MIs[0] Rn
     /* 154113 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154125 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (LDSMINAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAW),
     /* 154128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154132 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154138 */     GIR_RootConstrainSelectedInstOperands,
     /* 154139 */     // GIR_Coverage, 7310,
     /* 154139 */     GIR_EraseRootFromParent_Done,
     /* 154140 */   // Label 2746: @154140
     /* 154140 */   GIM_Try, /*On fail goto*//*Label 2747*/ GIMT_Encode4(154189), // Rule ID 7311 //
     /* 154145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154148 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154155 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 154158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154162 */     // MIs[0] Rn
     /* 154162 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154174 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (LDSMINLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLW),
     /* 154177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154181 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154183 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154187 */     GIR_RootConstrainSelectedInstOperands,
     /* 154188 */     // GIR_Coverage, 7311,
     /* 154188 */     GIR_EraseRootFromParent_Done,
     /* 154189 */   // Label 2747: @154189
     /* 154189 */   GIM_Try, /*On fail goto*//*Label 2748*/ GIMT_Encode4(154238), // Rule ID 7312 //
     /* 154194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154197 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154204 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 154207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154211 */     // MIs[0] Rn
     /* 154211 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154223 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (LDSMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALW),
     /* 154226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154230 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154232 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154236 */     GIR_RootConstrainSelectedInstOperands,
     /* 154237 */     // GIR_Coverage, 7312,
     /* 154237 */     GIR_EraseRootFromParent_Done,
     /* 154238 */   // Label 2748: @154238
     /* 154238 */   GIM_Try, /*On fail goto*//*Label 2749*/ GIMT_Encode4(154287), // Rule ID 7313 //
     /* 154243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154246 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154253 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 154256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154260 */     // MIs[0] Rn
     /* 154260 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154272 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (LDSMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALW),
     /* 154275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154279 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154281 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154285 */     GIR_RootConstrainSelectedInstOperands,
     /* 154286 */     // GIR_Coverage, 7313,
     /* 154286 */     GIR_EraseRootFromParent_Done,
     /* 154287 */   // Label 2749: @154287
     /* 154287 */   GIM_Try, /*On fail goto*//*Label 2750*/ GIMT_Encode4(154336), // Rule ID 7314 //
     /* 154292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154295 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154302 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 154305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154309 */     // MIs[0] Rn
     /* 154309 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154321 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (LDSMINH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINH),
     /* 154324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154328 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154330 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154334 */     GIR_RootConstrainSelectedInstOperands,
     /* 154335 */     // GIR_Coverage, 7314,
     /* 154335 */     GIR_EraseRootFromParent_Done,
     /* 154336 */   // Label 2750: @154336
     /* 154336 */   GIM_Try, /*On fail goto*//*Label 2751*/ GIMT_Encode4(154385), // Rule ID 7315 //
     /* 154341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154344 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154351 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 154354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154358 */     // MIs[0] Rn
     /* 154358 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154370 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (LDSMINAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAH),
     /* 154373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154377 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154379 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154383 */     GIR_RootConstrainSelectedInstOperands,
     /* 154384 */     // GIR_Coverage, 7315,
     /* 154384 */     GIR_EraseRootFromParent_Done,
     /* 154385 */   // Label 2751: @154385
     /* 154385 */   GIM_Try, /*On fail goto*//*Label 2752*/ GIMT_Encode4(154434), // Rule ID 7316 //
     /* 154390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154393 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154400 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 154403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154407 */     // MIs[0] Rn
     /* 154407 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154419 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (LDSMINLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLH),
     /* 154422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154426 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154428 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154432 */     GIR_RootConstrainSelectedInstOperands,
     /* 154433 */     // GIR_Coverage, 7316,
     /* 154433 */     GIR_EraseRootFromParent_Done,
     /* 154434 */   // Label 2752: @154434
     /* 154434 */   GIM_Try, /*On fail goto*//*Label 2753*/ GIMT_Encode4(154483), // Rule ID 7317 //
     /* 154439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154442 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154449 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 154452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154456 */     // MIs[0] Rn
     /* 154456 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154468 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (LDSMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALH),
     /* 154471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154475 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154477 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154481 */     GIR_RootConstrainSelectedInstOperands,
     /* 154482 */     // GIR_Coverage, 7317,
     /* 154482 */     GIR_EraseRootFromParent_Done,
     /* 154483 */   // Label 2753: @154483
     /* 154483 */   GIM_Try, /*On fail goto*//*Label 2754*/ GIMT_Encode4(154532), // Rule ID 7318 //
     /* 154488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154491 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154498 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 154501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154505 */     // MIs[0] Rn
     /* 154505 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154517 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (LDSMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALH),
     /* 154520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154524 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154526 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154530 */     GIR_RootConstrainSelectedInstOperands,
     /* 154531 */     // GIR_Coverage, 7318,
     /* 154531 */     GIR_EraseRootFromParent_Done,
     /* 154532 */   // Label 2754: @154532
     /* 154532 */   GIM_Try, /*On fail goto*//*Label 2755*/ GIMT_Encode4(154581), // Rule ID 7319 //
     /* 154537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154540 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 154547 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 154550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154554 */     // MIs[0] Rn
     /* 154554 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154566 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (LDSMINB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINB),
     /* 154569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154573 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154575 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154579 */     GIR_RootConstrainSelectedInstOperands,
     /* 154580 */     // GIR_Coverage, 7319,
     /* 154580 */     GIR_EraseRootFromParent_Done,
     /* 154581 */   // Label 2755: @154581
     /* 154581 */   GIM_Try, /*On fail goto*//*Label 2756*/ GIMT_Encode4(154630), // Rule ID 7320 //
     /* 154586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154589 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 154596 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 154599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154603 */     // MIs[0] Rn
     /* 154603 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154615 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (LDSMINAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAB),
     /* 154618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154622 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154624 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154628 */     GIR_RootConstrainSelectedInstOperands,
     /* 154629 */     // GIR_Coverage, 7320,
     /* 154629 */     GIR_EraseRootFromParent_Done,
     /* 154630 */   // Label 2756: @154630
     /* 154630 */   GIM_Try, /*On fail goto*//*Label 2757*/ GIMT_Encode4(154679), // Rule ID 7321 //
     /* 154635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154638 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 154645 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 154648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154652 */     // MIs[0] Rn
     /* 154652 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154664 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (LDSMINLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLB),
     /* 154667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154671 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154677 */     GIR_RootConstrainSelectedInstOperands,
     /* 154678 */     // GIR_Coverage, 7321,
     /* 154678 */     GIR_EraseRootFromParent_Done,
     /* 154679 */   // Label 2757: @154679
     /* 154679 */   GIM_Try, /*On fail goto*//*Label 2758*/ GIMT_Encode4(154728), // Rule ID 7322 //
     /* 154684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154687 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 154694 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 154697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154701 */     // MIs[0] Rn
     /* 154701 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154713 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (LDSMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALB),
     /* 154716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154720 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154722 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154726 */     GIR_RootConstrainSelectedInstOperands,
     /* 154727 */     // GIR_Coverage, 7322,
     /* 154727 */     GIR_EraseRootFromParent_Done,
     /* 154728 */   // Label 2758: @154728
     /* 154728 */   GIM_Try, /*On fail goto*//*Label 2759*/ GIMT_Encode4(154777), // Rule ID 7323 //
     /* 154733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154736 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 154743 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 154746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154750 */     // MIs[0] Rn
     /* 154750 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154762 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (LDSMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALB),
     /* 154765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154769 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154771 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154775 */     GIR_RootConstrainSelectedInstOperands,
     /* 154776 */     // GIR_Coverage, 7323,
     /* 154776 */     GIR_EraseRootFromParent_Done,
     /* 154777 */   // Label 2759: @154777
     /* 154777 */   GIM_Reject,
     /* 154778 */ // Label 2744: @154778
     /* 154778 */ GIM_Reject,
     /* 154779 */ // Label 2742: @154779
     /* 154779 */ GIM_Try, /*On fail goto*//*Label 2760*/ GIMT_Encode4(155005),
     /* 154784 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 154787 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 154794 */   GIM_Try, /*On fail goto*//*Label 2761*/ GIMT_Encode4(154836), // Rule ID 7304 //
     /* 154799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154802 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 154805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154809 */     // MIs[0] Rn
     /* 154809 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154821 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_monotonic>>  =>  (LDSMINX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINX),
     /* 154824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154828 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154830 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154834 */     GIR_RootConstrainSelectedInstOperands,
     /* 154835 */     // GIR_Coverage, 7304,
     /* 154835 */     GIR_EraseRootFromParent_Done,
     /* 154836 */   // Label 2761: @154836
     /* 154836 */   GIM_Try, /*On fail goto*//*Label 2762*/ GIMT_Encode4(154878), // Rule ID 7305 //
     /* 154841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154844 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 154847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154851 */     // MIs[0] Rn
     /* 154851 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154863 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acquire>>  =>  (LDSMINAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAX),
     /* 154866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154870 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154872 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154876 */     GIR_RootConstrainSelectedInstOperands,
     /* 154877 */     // GIR_Coverage, 7305,
     /* 154877 */     GIR_EraseRootFromParent_Done,
     /* 154878 */   // Label 2762: @154878
     /* 154878 */   GIM_Try, /*On fail goto*//*Label 2763*/ GIMT_Encode4(154920), // Rule ID 7306 //
     /* 154883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154886 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 154889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154893 */     // MIs[0] Rn
     /* 154893 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154905 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_release>>  =>  (LDSMINLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLX),
     /* 154908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154912 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154918 */     GIR_RootConstrainSelectedInstOperands,
     /* 154919 */     // GIR_Coverage, 7306,
     /* 154919 */     GIR_EraseRootFromParent_Done,
     /* 154920 */   // Label 2763: @154920
     /* 154920 */   GIM_Try, /*On fail goto*//*Label 2764*/ GIMT_Encode4(154962), // Rule ID 7307 //
     /* 154925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154928 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 154931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154935 */     // MIs[0] Rn
     /* 154935 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154947 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acq_rel>>  =>  (LDSMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALX),
     /* 154950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154954 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154956 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154960 */     GIR_RootConstrainSelectedInstOperands,
     /* 154961 */     // GIR_Coverage, 7307,
     /* 154961 */     GIR_EraseRootFromParent_Done,
     /* 154962 */   // Label 2764: @154962
     /* 154962 */   GIM_Try, /*On fail goto*//*Label 2765*/ GIMT_Encode4(155004), // Rule ID 7308 //
     /* 154967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154970 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 154973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154977 */     // MIs[0] Rn
     /* 154977 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154989 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_seq_cst>>  =>  (LDSMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALX),
     /* 154992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154996 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154998 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155002 */     GIR_RootConstrainSelectedInstOperands,
     /* 155003 */     // GIR_Coverage, 7308,
     /* 155003 */     GIR_EraseRootFromParent_Done,
     /* 155004 */   // Label 2765: @155004
     /* 155004 */   GIM_Reject,
     /* 155005 */ // Label 2760: @155005
     /* 155005 */ GIM_Reject,
     /* 155006 */ // Label 2743: @155006
     /* 155006 */ GIM_Reject,
     /* 155007 */ // Label 29: @155007
     /* 155007 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2768*/ GIMT_Encode4(155998),
     /* 155018 */ /*GILLT_s32*//*Label 2766*/ GIMT_Encode4(155026),
     /* 155022 */ /*GILLT_s64*//*Label 2767*/ GIMT_Encode4(155771),
     /* 155026 */ // Label 2766: @155026
     /* 155026 */ GIM_Try, /*On fail goto*//*Label 2769*/ GIMT_Encode4(155770),
     /* 155031 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 155034 */   GIM_Try, /*On fail goto*//*Label 2770*/ GIMT_Encode4(155083), // Rule ID 7329 //
     /* 155039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155042 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 155049 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 155052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155056 */     // MIs[0] Rn
     /* 155056 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155068 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (LDUMAXW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXW),
     /* 155071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155075 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155077 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155081 */     GIR_RootConstrainSelectedInstOperands,
     /* 155082 */     // GIR_Coverage, 7329,
     /* 155082 */     GIR_EraseRootFromParent_Done,
     /* 155083 */   // Label 2770: @155083
     /* 155083 */   GIM_Try, /*On fail goto*//*Label 2771*/ GIMT_Encode4(155132), // Rule ID 7330 //
     /* 155088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155091 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 155098 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 155101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155105 */     // MIs[0] Rn
     /* 155105 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155117 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (LDUMAXAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAW),
     /* 155120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155124 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155126 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155130 */     GIR_RootConstrainSelectedInstOperands,
     /* 155131 */     // GIR_Coverage, 7330,
     /* 155131 */     GIR_EraseRootFromParent_Done,
     /* 155132 */   // Label 2771: @155132
     /* 155132 */   GIM_Try, /*On fail goto*//*Label 2772*/ GIMT_Encode4(155181), // Rule ID 7331 //
     /* 155137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155140 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 155147 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 155150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155154 */     // MIs[0] Rn
     /* 155154 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155166 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (LDUMAXLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLW),
     /* 155169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155173 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155175 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155179 */     GIR_RootConstrainSelectedInstOperands,
     /* 155180 */     // GIR_Coverage, 7331,
     /* 155180 */     GIR_EraseRootFromParent_Done,
     /* 155181 */   // Label 2772: @155181
     /* 155181 */   GIM_Try, /*On fail goto*//*Label 2773*/ GIMT_Encode4(155230), // Rule ID 7332 //
     /* 155186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155189 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 155196 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 155199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155203 */     // MIs[0] Rn
     /* 155203 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155215 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (LDUMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALW),
     /* 155218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155222 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155228 */     GIR_RootConstrainSelectedInstOperands,
     /* 155229 */     // GIR_Coverage, 7332,
     /* 155229 */     GIR_EraseRootFromParent_Done,
     /* 155230 */   // Label 2773: @155230
     /* 155230 */   GIM_Try, /*On fail goto*//*Label 2774*/ GIMT_Encode4(155279), // Rule ID 7333 //
     /* 155235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155238 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 155245 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 155248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155252 */     // MIs[0] Rn
     /* 155252 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155264 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (LDUMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALW),
     /* 155267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155271 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155273 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155277 */     GIR_RootConstrainSelectedInstOperands,
     /* 155278 */     // GIR_Coverage, 7333,
     /* 155278 */     GIR_EraseRootFromParent_Done,
     /* 155279 */   // Label 2774: @155279
     /* 155279 */   GIM_Try, /*On fail goto*//*Label 2775*/ GIMT_Encode4(155328), // Rule ID 7334 //
     /* 155284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155287 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 155294 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 155297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155301 */     // MIs[0] Rn
     /* 155301 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155313 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (LDUMAXH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXH),
     /* 155316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155320 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155322 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155326 */     GIR_RootConstrainSelectedInstOperands,
     /* 155327 */     // GIR_Coverage, 7334,
     /* 155327 */     GIR_EraseRootFromParent_Done,
     /* 155328 */   // Label 2775: @155328
     /* 155328 */   GIM_Try, /*On fail goto*//*Label 2776*/ GIMT_Encode4(155377), // Rule ID 7335 //
     /* 155333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155336 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 155343 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 155346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155350 */     // MIs[0] Rn
     /* 155350 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155362 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (LDUMAXAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAH),
     /* 155365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155369 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155371 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155375 */     GIR_RootConstrainSelectedInstOperands,
     /* 155376 */     // GIR_Coverage, 7335,
     /* 155376 */     GIR_EraseRootFromParent_Done,
     /* 155377 */   // Label 2776: @155377
     /* 155377 */   GIM_Try, /*On fail goto*//*Label 2777*/ GIMT_Encode4(155426), // Rule ID 7336 //
     /* 155382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155385 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 155392 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 155395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155399 */     // MIs[0] Rn
     /* 155399 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155403 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155411 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (LDUMAXLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLH),
     /* 155414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155418 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155420 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155424 */     GIR_RootConstrainSelectedInstOperands,
     /* 155425 */     // GIR_Coverage, 7336,
     /* 155425 */     GIR_EraseRootFromParent_Done,
     /* 155426 */   // Label 2777: @155426
     /* 155426 */   GIM_Try, /*On fail goto*//*Label 2778*/ GIMT_Encode4(155475), // Rule ID 7337 //
     /* 155431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155434 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 155441 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 155444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155448 */     // MIs[0] Rn
     /* 155448 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155460 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (LDUMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALH),
     /* 155463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155467 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155469 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155473 */     GIR_RootConstrainSelectedInstOperands,
     /* 155474 */     // GIR_Coverage, 7337,
     /* 155474 */     GIR_EraseRootFromParent_Done,
     /* 155475 */   // Label 2778: @155475
     /* 155475 */   GIM_Try, /*On fail goto*//*Label 2779*/ GIMT_Encode4(155524), // Rule ID 7338 //
     /* 155480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155483 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 155490 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 155493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155497 */     // MIs[0] Rn
     /* 155497 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155509 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (LDUMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALH),
     /* 155512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155516 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155518 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155522 */     GIR_RootConstrainSelectedInstOperands,
     /* 155523 */     // GIR_Coverage, 7338,
     /* 155523 */     GIR_EraseRootFromParent_Done,
     /* 155524 */   // Label 2779: @155524
     /* 155524 */   GIM_Try, /*On fail goto*//*Label 2780*/ GIMT_Encode4(155573), // Rule ID 7339 //
     /* 155529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155532 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 155539 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 155542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155546 */     // MIs[0] Rn
     /* 155546 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155558 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (LDUMAXB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXB),
     /* 155561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155565 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155567 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155571 */     GIR_RootConstrainSelectedInstOperands,
     /* 155572 */     // GIR_Coverage, 7339,
     /* 155572 */     GIR_EraseRootFromParent_Done,
     /* 155573 */   // Label 2780: @155573
     /* 155573 */   GIM_Try, /*On fail goto*//*Label 2781*/ GIMT_Encode4(155622), // Rule ID 7340 //
     /* 155578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155581 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 155588 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 155591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155595 */     // MIs[0] Rn
     /* 155595 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155607 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (LDUMAXAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAB),
     /* 155610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155614 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155616 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155620 */     GIR_RootConstrainSelectedInstOperands,
     /* 155621 */     // GIR_Coverage, 7340,
     /* 155621 */     GIR_EraseRootFromParent_Done,
     /* 155622 */   // Label 2781: @155622
     /* 155622 */   GIM_Try, /*On fail goto*//*Label 2782*/ GIMT_Encode4(155671), // Rule ID 7341 //
     /* 155627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155630 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 155637 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 155640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155644 */     // MIs[0] Rn
     /* 155644 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155656 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (LDUMAXLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLB),
     /* 155659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155663 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155665 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155669 */     GIR_RootConstrainSelectedInstOperands,
     /* 155670 */     // GIR_Coverage, 7341,
     /* 155670 */     GIR_EraseRootFromParent_Done,
     /* 155671 */   // Label 2782: @155671
     /* 155671 */   GIM_Try, /*On fail goto*//*Label 2783*/ GIMT_Encode4(155720), // Rule ID 7342 //
     /* 155676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155679 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 155686 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 155689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155693 */     // MIs[0] Rn
     /* 155693 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155705 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (LDUMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALB),
     /* 155708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155712 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155714 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155718 */     GIR_RootConstrainSelectedInstOperands,
     /* 155719 */     // GIR_Coverage, 7342,
     /* 155719 */     GIR_EraseRootFromParent_Done,
     /* 155720 */   // Label 2783: @155720
     /* 155720 */   GIM_Try, /*On fail goto*//*Label 2784*/ GIMT_Encode4(155769), // Rule ID 7343 //
     /* 155725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155728 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 155735 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 155738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155742 */     // MIs[0] Rn
     /* 155742 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155754 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (LDUMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALB),
     /* 155757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155761 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155763 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155767 */     GIR_RootConstrainSelectedInstOperands,
     /* 155768 */     // GIR_Coverage, 7343,
     /* 155768 */     GIR_EraseRootFromParent_Done,
     /* 155769 */   // Label 2784: @155769
     /* 155769 */   GIM_Reject,
     /* 155770 */ // Label 2769: @155770
     /* 155770 */ GIM_Reject,
     /* 155771 */ // Label 2767: @155771
     /* 155771 */ GIM_Try, /*On fail goto*//*Label 2785*/ GIMT_Encode4(155997),
     /* 155776 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 155779 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 155786 */   GIM_Try, /*On fail goto*//*Label 2786*/ GIMT_Encode4(155828), // Rule ID 7324 //
     /* 155791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155794 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 155797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155801 */     // MIs[0] Rn
     /* 155801 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155813 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_monotonic>>  =>  (LDUMAXX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXX),
     /* 155816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155820 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155822 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155826 */     GIR_RootConstrainSelectedInstOperands,
     /* 155827 */     // GIR_Coverage, 7324,
     /* 155827 */     GIR_EraseRootFromParent_Done,
     /* 155828 */   // Label 2786: @155828
     /* 155828 */   GIM_Try, /*On fail goto*//*Label 2787*/ GIMT_Encode4(155870), // Rule ID 7325 //
     /* 155833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155836 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 155839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155843 */     // MIs[0] Rn
     /* 155843 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155855 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acquire>>  =>  (LDUMAXAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAX),
     /* 155858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155860 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155862 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155864 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155868 */     GIR_RootConstrainSelectedInstOperands,
     /* 155869 */     // GIR_Coverage, 7325,
     /* 155869 */     GIR_EraseRootFromParent_Done,
     /* 155870 */   // Label 2787: @155870
     /* 155870 */   GIM_Try, /*On fail goto*//*Label 2788*/ GIMT_Encode4(155912), // Rule ID 7326 //
     /* 155875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155878 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 155881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155885 */     // MIs[0] Rn
     /* 155885 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155897 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_release>>  =>  (LDUMAXLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLX),
     /* 155900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155904 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155906 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155910 */     GIR_RootConstrainSelectedInstOperands,
     /* 155911 */     // GIR_Coverage, 7326,
     /* 155911 */     GIR_EraseRootFromParent_Done,
     /* 155912 */   // Label 2788: @155912
     /* 155912 */   GIM_Try, /*On fail goto*//*Label 2789*/ GIMT_Encode4(155954), // Rule ID 7327 //
     /* 155917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155920 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 155923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155927 */     // MIs[0] Rn
     /* 155927 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155939 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acq_rel>>  =>  (LDUMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALX),
     /* 155942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155946 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155948 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155952 */     GIR_RootConstrainSelectedInstOperands,
     /* 155953 */     // GIR_Coverage, 7327,
     /* 155953 */     GIR_EraseRootFromParent_Done,
     /* 155954 */   // Label 2789: @155954
     /* 155954 */   GIM_Try, /*On fail goto*//*Label 2790*/ GIMT_Encode4(155996), // Rule ID 7328 //
     /* 155959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155962 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 155965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155969 */     // MIs[0] Rn
     /* 155969 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155981 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_seq_cst>>  =>  (LDUMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALX),
     /* 155984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155988 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155990 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155994 */     GIR_RootConstrainSelectedInstOperands,
     /* 155995 */     // GIR_Coverage, 7328,
     /* 155995 */     GIR_EraseRootFromParent_Done,
     /* 155996 */   // Label 2790: @155996
     /* 155996 */   GIM_Reject,
     /* 155997 */ // Label 2785: @155997
     /* 155997 */ GIM_Reject,
     /* 155998 */ // Label 2768: @155998
     /* 155998 */ GIM_Reject,
     /* 155999 */ // Label 30: @155999
     /* 155999 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2793*/ GIMT_Encode4(156990),
     /* 156010 */ /*GILLT_s32*//*Label 2791*/ GIMT_Encode4(156018),
     /* 156014 */ /*GILLT_s64*//*Label 2792*/ GIMT_Encode4(156763),
     /* 156018 */ // Label 2791: @156018
     /* 156018 */ GIM_Try, /*On fail goto*//*Label 2794*/ GIMT_Encode4(156762),
     /* 156023 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 156026 */   GIM_Try, /*On fail goto*//*Label 2795*/ GIMT_Encode4(156075), // Rule ID 7349 //
     /* 156031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156034 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 156041 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 156044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156048 */     // MIs[0] Rn
     /* 156048 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156060 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (LDUMINW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINW),
     /* 156063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156067 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156069 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156073 */     GIR_RootConstrainSelectedInstOperands,
     /* 156074 */     // GIR_Coverage, 7349,
     /* 156074 */     GIR_EraseRootFromParent_Done,
     /* 156075 */   // Label 2795: @156075
     /* 156075 */   GIM_Try, /*On fail goto*//*Label 2796*/ GIMT_Encode4(156124), // Rule ID 7350 //
     /* 156080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156083 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 156090 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 156093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156097 */     // MIs[0] Rn
     /* 156097 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156101 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156109 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (LDUMINAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAW),
     /* 156112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156116 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156118 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156122 */     GIR_RootConstrainSelectedInstOperands,
     /* 156123 */     // GIR_Coverage, 7350,
     /* 156123 */     GIR_EraseRootFromParent_Done,
     /* 156124 */   // Label 2796: @156124
     /* 156124 */   GIM_Try, /*On fail goto*//*Label 2797*/ GIMT_Encode4(156173), // Rule ID 7351 //
     /* 156129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156132 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 156139 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 156142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156146 */     // MIs[0] Rn
     /* 156146 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156158 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (LDUMINLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLW),
     /* 156161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156165 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156167 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156171 */     GIR_RootConstrainSelectedInstOperands,
     /* 156172 */     // GIR_Coverage, 7351,
     /* 156172 */     GIR_EraseRootFromParent_Done,
     /* 156173 */   // Label 2797: @156173
     /* 156173 */   GIM_Try, /*On fail goto*//*Label 2798*/ GIMT_Encode4(156222), // Rule ID 7352 //
     /* 156178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156181 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 156188 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 156191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156195 */     // MIs[0] Rn
     /* 156195 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156199 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156207 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (LDUMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALW),
     /* 156210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156214 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156216 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156220 */     GIR_RootConstrainSelectedInstOperands,
     /* 156221 */     // GIR_Coverage, 7352,
     /* 156221 */     GIR_EraseRootFromParent_Done,
     /* 156222 */   // Label 2798: @156222
     /* 156222 */   GIM_Try, /*On fail goto*//*Label 2799*/ GIMT_Encode4(156271), // Rule ID 7353 //
     /* 156227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156230 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 156237 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 156240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156244 */     // MIs[0] Rn
     /* 156244 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156248 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156256 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (LDUMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALW),
     /* 156259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156263 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156265 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156269 */     GIR_RootConstrainSelectedInstOperands,
     /* 156270 */     // GIR_Coverage, 7353,
     /* 156270 */     GIR_EraseRootFromParent_Done,
     /* 156271 */   // Label 2799: @156271
     /* 156271 */   GIM_Try, /*On fail goto*//*Label 2800*/ GIMT_Encode4(156320), // Rule ID 7354 //
     /* 156276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156279 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 156286 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 156289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156293 */     // MIs[0] Rn
     /* 156293 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156297 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156305 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (LDUMINH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINH),
     /* 156308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156312 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156314 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156318 */     GIR_RootConstrainSelectedInstOperands,
     /* 156319 */     // GIR_Coverage, 7354,
     /* 156319 */     GIR_EraseRootFromParent_Done,
     /* 156320 */   // Label 2800: @156320
     /* 156320 */   GIM_Try, /*On fail goto*//*Label 2801*/ GIMT_Encode4(156369), // Rule ID 7355 //
     /* 156325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156328 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 156335 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 156338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156342 */     // MIs[0] Rn
     /* 156342 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156354 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (LDUMINAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAH),
     /* 156357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156361 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156363 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156367 */     GIR_RootConstrainSelectedInstOperands,
     /* 156368 */     // GIR_Coverage, 7355,
     /* 156368 */     GIR_EraseRootFromParent_Done,
     /* 156369 */   // Label 2801: @156369
     /* 156369 */   GIM_Try, /*On fail goto*//*Label 2802*/ GIMT_Encode4(156418), // Rule ID 7356 //
     /* 156374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156377 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 156384 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 156387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156391 */     // MIs[0] Rn
     /* 156391 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156403 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (LDUMINLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLH),
     /* 156406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156410 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156412 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156416 */     GIR_RootConstrainSelectedInstOperands,
     /* 156417 */     // GIR_Coverage, 7356,
     /* 156417 */     GIR_EraseRootFromParent_Done,
     /* 156418 */   // Label 2802: @156418
     /* 156418 */   GIM_Try, /*On fail goto*//*Label 2803*/ GIMT_Encode4(156467), // Rule ID 7357 //
     /* 156423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156426 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 156433 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 156436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156440 */     // MIs[0] Rn
     /* 156440 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156452 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (LDUMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALH),
     /* 156455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156459 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156461 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156465 */     GIR_RootConstrainSelectedInstOperands,
     /* 156466 */     // GIR_Coverage, 7357,
     /* 156466 */     GIR_EraseRootFromParent_Done,
     /* 156467 */   // Label 2803: @156467
     /* 156467 */   GIM_Try, /*On fail goto*//*Label 2804*/ GIMT_Encode4(156516), // Rule ID 7358 //
     /* 156472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156475 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 156482 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 156485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156489 */     // MIs[0] Rn
     /* 156489 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156501 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (LDUMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALH),
     /* 156504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156508 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156510 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156514 */     GIR_RootConstrainSelectedInstOperands,
     /* 156515 */     // GIR_Coverage, 7358,
     /* 156515 */     GIR_EraseRootFromParent_Done,
     /* 156516 */   // Label 2804: @156516
     /* 156516 */   GIM_Try, /*On fail goto*//*Label 2805*/ GIMT_Encode4(156565), // Rule ID 7359 //
     /* 156521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156524 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 156531 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 156534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156538 */     // MIs[0] Rn
     /* 156538 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156550 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (LDUMINB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINB),
     /* 156553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156557 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156563 */     GIR_RootConstrainSelectedInstOperands,
     /* 156564 */     // GIR_Coverage, 7359,
     /* 156564 */     GIR_EraseRootFromParent_Done,
     /* 156565 */   // Label 2805: @156565
     /* 156565 */   GIM_Try, /*On fail goto*//*Label 2806*/ GIMT_Encode4(156614), // Rule ID 7360 //
     /* 156570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156573 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 156580 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 156583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156587 */     // MIs[0] Rn
     /* 156587 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156599 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (LDUMINAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAB),
     /* 156602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156606 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156608 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156612 */     GIR_RootConstrainSelectedInstOperands,
     /* 156613 */     // GIR_Coverage, 7360,
     /* 156613 */     GIR_EraseRootFromParent_Done,
     /* 156614 */   // Label 2806: @156614
     /* 156614 */   GIM_Try, /*On fail goto*//*Label 2807*/ GIMT_Encode4(156663), // Rule ID 7361 //
     /* 156619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156622 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 156629 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 156632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156636 */     // MIs[0] Rn
     /* 156636 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156648 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (LDUMINLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLB),
     /* 156651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156655 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156657 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156661 */     GIR_RootConstrainSelectedInstOperands,
     /* 156662 */     // GIR_Coverage, 7361,
     /* 156662 */     GIR_EraseRootFromParent_Done,
     /* 156663 */   // Label 2807: @156663
     /* 156663 */   GIM_Try, /*On fail goto*//*Label 2808*/ GIMT_Encode4(156712), // Rule ID 7362 //
     /* 156668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156671 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 156678 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 156681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156685 */     // MIs[0] Rn
     /* 156685 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156697 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (LDUMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALB),
     /* 156700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156704 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156706 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156710 */     GIR_RootConstrainSelectedInstOperands,
     /* 156711 */     // GIR_Coverage, 7362,
     /* 156711 */     GIR_EraseRootFromParent_Done,
     /* 156712 */   // Label 2808: @156712
     /* 156712 */   GIM_Try, /*On fail goto*//*Label 2809*/ GIMT_Encode4(156761), // Rule ID 7363 //
     /* 156717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156720 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 156727 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 156730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156734 */     // MIs[0] Rn
     /* 156734 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156746 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (LDUMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALB),
     /* 156749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156753 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156755 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156759 */     GIR_RootConstrainSelectedInstOperands,
     /* 156760 */     // GIR_Coverage, 7363,
     /* 156760 */     GIR_EraseRootFromParent_Done,
     /* 156761 */   // Label 2809: @156761
     /* 156761 */   GIM_Reject,
     /* 156762 */ // Label 2794: @156762
     /* 156762 */ GIM_Reject,
     /* 156763 */ // Label 2792: @156763
     /* 156763 */ GIM_Try, /*On fail goto*//*Label 2810*/ GIMT_Encode4(156989),
     /* 156768 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156771 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 156778 */   GIM_Try, /*On fail goto*//*Label 2811*/ GIMT_Encode4(156820), // Rule ID 7344 //
     /* 156783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156786 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 156789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 156793 */     // MIs[0] Rn
     /* 156793 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 156805 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_monotonic>>  =>  (LDUMINX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINX),
     /* 156808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156812 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156818 */     GIR_RootConstrainSelectedInstOperands,
     /* 156819 */     // GIR_Coverage, 7344,
     /* 156819 */     GIR_EraseRootFromParent_Done,
     /* 156820 */   // Label 2811: @156820
     /* 156820 */   GIM_Try, /*On fail goto*//*Label 2812*/ GIMT_Encode4(156862), // Rule ID 7345 //
     /* 156825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156828 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 156831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 156835 */     // MIs[0] Rn
     /* 156835 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 156847 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acquire>>  =>  (LDUMINAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAX),
     /* 156850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156854 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156856 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156860 */     GIR_RootConstrainSelectedInstOperands,
     /* 156861 */     // GIR_Coverage, 7345,
     /* 156861 */     GIR_EraseRootFromParent_Done,
     /* 156862 */   // Label 2812: @156862
     /* 156862 */   GIM_Try, /*On fail goto*//*Label 2813*/ GIMT_Encode4(156904), // Rule ID 7346 //
     /* 156867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156870 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 156873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 156877 */     // MIs[0] Rn
     /* 156877 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 156889 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_release>>  =>  (LDUMINLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLX),
     /* 156892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156896 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156898 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156902 */     GIR_RootConstrainSelectedInstOperands,
     /* 156903 */     // GIR_Coverage, 7346,
     /* 156903 */     GIR_EraseRootFromParent_Done,
     /* 156904 */   // Label 2813: @156904
     /* 156904 */   GIM_Try, /*On fail goto*//*Label 2814*/ GIMT_Encode4(156946), // Rule ID 7347 //
     /* 156909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156912 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 156915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 156919 */     // MIs[0] Rn
     /* 156919 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 156931 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acq_rel>>  =>  (LDUMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALX),
     /* 156934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156938 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156940 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156944 */     GIR_RootConstrainSelectedInstOperands,
     /* 156945 */     // GIR_Coverage, 7347,
     /* 156945 */     GIR_EraseRootFromParent_Done,
     /* 156946 */   // Label 2814: @156946
     /* 156946 */   GIM_Try, /*On fail goto*//*Label 2815*/ GIMT_Encode4(156988), // Rule ID 7348 //
     /* 156951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156954 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 156957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 156961 */     // MIs[0] Rn
     /* 156961 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 156973 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_seq_cst>>  =>  (LDUMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALX),
     /* 156976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156980 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156982 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156986 */     GIR_RootConstrainSelectedInstOperands,
     /* 156987 */     // GIR_Coverage, 7348,
     /* 156987 */     GIR_EraseRootFromParent_Done,
     /* 156988 */   // Label 2815: @156988
     /* 156988 */   GIM_Reject,
     /* 156989 */ // Label 2810: @156989
     /* 156989 */ GIM_Reject,
     /* 156990 */ // Label 2793: @156990
     /* 156990 */ GIM_Reject,
     /* 156991 */ // Label 31: @156991
     /* 156991 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2819*/ GIMT_Encode4(157695),
     /* 157002 */ /*GILLT_s16*//*Label 2816*/ GIMT_Encode4(157014),
     /* 157006 */ /*GILLT_s32*//*Label 2817*/ GIMT_Encode4(157241),
     /* 157010 */ /*GILLT_s64*//*Label 2818*/ GIMT_Encode4(157468),
     /* 157014 */ // Label 2816: @157014
     /* 157014 */ GIM_Try, /*On fail goto*//*Label 2820*/ GIMT_Encode4(157240),
     /* 157019 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 157022 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 157029 */   GIM_Try, /*On fail goto*//*Label 2821*/ GIMT_Encode4(157071), // Rule ID 2580 //
     /* 157034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157037 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 157040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157044 */     // MIs[0] Rn
     /* 157044 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157056 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_monotonic>>  =>  (LDFADDH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDH),
     /* 157059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157063 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157065 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157069 */     GIR_RootConstrainSelectedInstOperands,
     /* 157070 */     // GIR_Coverage, 2580,
     /* 157070 */     GIR_EraseRootFromParent_Done,
     /* 157071 */   // Label 2821: @157071
     /* 157071 */   GIM_Try, /*On fail goto*//*Label 2822*/ GIMT_Encode4(157113), // Rule ID 2581 //
     /* 157076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157079 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 157082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157086 */     // MIs[0] Rn
     /* 157086 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157098 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_acquire>>  =>  (LDFADDAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAH),
     /* 157101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157105 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157107 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157111 */     GIR_RootConstrainSelectedInstOperands,
     /* 157112 */     // GIR_Coverage, 2581,
     /* 157112 */     GIR_EraseRootFromParent_Done,
     /* 157113 */   // Label 2822: @157113
     /* 157113 */   GIM_Try, /*On fail goto*//*Label 2823*/ GIMT_Encode4(157155), // Rule ID 2582 //
     /* 157118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157121 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 157124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157128 */     // MIs[0] Rn
     /* 157128 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157140 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_release>>  =>  (LDFADDLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLH),
     /* 157143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157147 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157149 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157153 */     GIR_RootConstrainSelectedInstOperands,
     /* 157154 */     // GIR_Coverage, 2582,
     /* 157154 */     GIR_EraseRootFromParent_Done,
     /* 157155 */   // Label 2823: @157155
     /* 157155 */   GIM_Try, /*On fail goto*//*Label 2824*/ GIMT_Encode4(157197), // Rule ID 2583 //
     /* 157160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157163 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 157166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157170 */     // MIs[0] Rn
     /* 157170 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157182 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_acq_rel>>  =>  (LDFADDALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALH),
     /* 157185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157189 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157191 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157195 */     GIR_RootConstrainSelectedInstOperands,
     /* 157196 */     // GIR_Coverage, 2583,
     /* 157196 */     GIR_EraseRootFromParent_Done,
     /* 157197 */   // Label 2824: @157197
     /* 157197 */   GIM_Try, /*On fail goto*//*Label 2825*/ GIMT_Encode4(157239), // Rule ID 2584 //
     /* 157202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157205 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 157208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157212 */     // MIs[0] Rn
     /* 157212 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157224 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_seq_cst>>  =>  (LDFADDALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALH),
     /* 157227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157231 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157233 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157237 */     GIR_RootConstrainSelectedInstOperands,
     /* 157238 */     // GIR_Coverage, 2584,
     /* 157238 */     GIR_EraseRootFromParent_Done,
     /* 157239 */   // Label 2825: @157239
     /* 157239 */   GIM_Reject,
     /* 157240 */ // Label 2820: @157240
     /* 157240 */ GIM_Reject,
     /* 157241 */ // Label 2817: @157241
     /* 157241 */ GIM_Try, /*On fail goto*//*Label 2826*/ GIMT_Encode4(157467),
     /* 157246 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 157249 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 157256 */   GIM_Try, /*On fail goto*//*Label 2827*/ GIMT_Encode4(157298), // Rule ID 7439 //
     /* 157261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157264 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 157267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157271 */     // MIs[0] Rn
     /* 157271 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157283 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_monotonic>>  =>  (LDFADDS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDS),
     /* 157286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157290 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157292 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157296 */     GIR_RootConstrainSelectedInstOperands,
     /* 157297 */     // GIR_Coverage, 7439,
     /* 157297 */     GIR_EraseRootFromParent_Done,
     /* 157298 */   // Label 2827: @157298
     /* 157298 */   GIM_Try, /*On fail goto*//*Label 2828*/ GIMT_Encode4(157340), // Rule ID 7440 //
     /* 157303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157306 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 157309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157313 */     // MIs[0] Rn
     /* 157313 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157325 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_acquire>>  =>  (LDFADDAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAS),
     /* 157328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157332 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157334 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157338 */     GIR_RootConstrainSelectedInstOperands,
     /* 157339 */     // GIR_Coverage, 7440,
     /* 157339 */     GIR_EraseRootFromParent_Done,
     /* 157340 */   // Label 2828: @157340
     /* 157340 */   GIM_Try, /*On fail goto*//*Label 2829*/ GIMT_Encode4(157382), // Rule ID 7441 //
     /* 157345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157348 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 157351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157355 */     // MIs[0] Rn
     /* 157355 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157367 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_release>>  =>  (LDFADDLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLS),
     /* 157370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157374 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157380 */     GIR_RootConstrainSelectedInstOperands,
     /* 157381 */     // GIR_Coverage, 7441,
     /* 157381 */     GIR_EraseRootFromParent_Done,
     /* 157382 */   // Label 2829: @157382
     /* 157382 */   GIM_Try, /*On fail goto*//*Label 2830*/ GIMT_Encode4(157424), // Rule ID 7442 //
     /* 157387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157390 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 157393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157397 */     // MIs[0] Rn
     /* 157397 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157409 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_acq_rel>>  =>  (LDFADDALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALS),
     /* 157412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157416 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157418 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157422 */     GIR_RootConstrainSelectedInstOperands,
     /* 157423 */     // GIR_Coverage, 7442,
     /* 157423 */     GIR_EraseRootFromParent_Done,
     /* 157424 */   // Label 2830: @157424
     /* 157424 */   GIM_Try, /*On fail goto*//*Label 2831*/ GIMT_Encode4(157466), // Rule ID 7443 //
     /* 157429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157432 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 157435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157439 */     // MIs[0] Rn
     /* 157439 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157451 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_seq_cst>>  =>  (LDFADDALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALS),
     /* 157454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157458 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157460 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157464 */     GIR_RootConstrainSelectedInstOperands,
     /* 157465 */     // GIR_Coverage, 7443,
     /* 157465 */     GIR_EraseRootFromParent_Done,
     /* 157466 */   // Label 2831: @157466
     /* 157466 */   GIM_Reject,
     /* 157467 */ // Label 2826: @157467
     /* 157467 */ GIM_Reject,
     /* 157468 */ // Label 2818: @157468
     /* 157468 */ GIM_Try, /*On fail goto*//*Label 2832*/ GIMT_Encode4(157694),
     /* 157473 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 157476 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 157483 */   GIM_Try, /*On fail goto*//*Label 2833*/ GIMT_Encode4(157525), // Rule ID 7444 //
     /* 157488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157491 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 157494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157498 */     // MIs[0] Rn
     /* 157498 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157510 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_monotonic>>  =>  (LDFADDD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDD),
     /* 157513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157517 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157519 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157523 */     GIR_RootConstrainSelectedInstOperands,
     /* 157524 */     // GIR_Coverage, 7444,
     /* 157524 */     GIR_EraseRootFromParent_Done,
     /* 157525 */   // Label 2833: @157525
     /* 157525 */   GIM_Try, /*On fail goto*//*Label 2834*/ GIMT_Encode4(157567), // Rule ID 7445 //
     /* 157530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157533 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 157536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157540 */     // MIs[0] Rn
     /* 157540 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157552 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_acquire>>  =>  (LDFADDAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAD),
     /* 157555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157559 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157561 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157565 */     GIR_RootConstrainSelectedInstOperands,
     /* 157566 */     // GIR_Coverage, 7445,
     /* 157566 */     GIR_EraseRootFromParent_Done,
     /* 157567 */   // Label 2834: @157567
     /* 157567 */   GIM_Try, /*On fail goto*//*Label 2835*/ GIMT_Encode4(157609), // Rule ID 7446 //
     /* 157572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157575 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 157578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157582 */     // MIs[0] Rn
     /* 157582 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157594 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_release>>  =>  (LDFADDLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLD),
     /* 157597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157601 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157607 */     GIR_RootConstrainSelectedInstOperands,
     /* 157608 */     // GIR_Coverage, 7446,
     /* 157608 */     GIR_EraseRootFromParent_Done,
     /* 157609 */   // Label 2835: @157609
     /* 157609 */   GIM_Try, /*On fail goto*//*Label 2836*/ GIMT_Encode4(157651), // Rule ID 7447 //
     /* 157614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157617 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 157620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157624 */     // MIs[0] Rn
     /* 157624 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157636 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_acq_rel>>  =>  (LDFADDALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALD),
     /* 157639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157643 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157645 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157649 */     GIR_RootConstrainSelectedInstOperands,
     /* 157650 */     // GIR_Coverage, 7447,
     /* 157650 */     GIR_EraseRootFromParent_Done,
     /* 157651 */   // Label 2836: @157651
     /* 157651 */   GIM_Try, /*On fail goto*//*Label 2837*/ GIMT_Encode4(157693), // Rule ID 7448 //
     /* 157656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157659 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 157662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157666 */     // MIs[0] Rn
     /* 157666 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157678 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_seq_cst>>  =>  (LDFADDALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALD),
     /* 157681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157685 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157687 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157691 */     GIR_RootConstrainSelectedInstOperands,
     /* 157692 */     // GIR_Coverage, 7448,
     /* 157692 */     GIR_EraseRootFromParent_Done,
     /* 157693 */   // Label 2837: @157693
     /* 157693 */   GIM_Reject,
     /* 157694 */ // Label 2832: @157694
     /* 157694 */ GIM_Reject,
     /* 157695 */ // Label 2819: @157695
     /* 157695 */ GIM_Reject,
     /* 157696 */ // Label 32: @157696
     /* 157696 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2841*/ GIMT_Encode4(158400),
     /* 157707 */ /*GILLT_s16*//*Label 2838*/ GIMT_Encode4(157719),
     /* 157711 */ /*GILLT_s32*//*Label 2839*/ GIMT_Encode4(157946),
     /* 157715 */ /*GILLT_s64*//*Label 2840*/ GIMT_Encode4(158173),
     /* 157719 */ // Label 2838: @157719
     /* 157719 */ GIM_Try, /*On fail goto*//*Label 2842*/ GIMT_Encode4(157945),
     /* 157724 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 157727 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 157734 */   GIM_Try, /*On fail goto*//*Label 2843*/ GIMT_Encode4(157776), // Rule ID 7449 //
     /* 157739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157742 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 157745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157749 */     // MIs[0] Rn
     /* 157749 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157761 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_monotonic>>  =>  (LDFMAXNMH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMH),
     /* 157764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157768 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157770 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157774 */     GIR_RootConstrainSelectedInstOperands,
     /* 157775 */     // GIR_Coverage, 7449,
     /* 157775 */     GIR_EraseRootFromParent_Done,
     /* 157776 */   // Label 2843: @157776
     /* 157776 */   GIM_Try, /*On fail goto*//*Label 2844*/ GIMT_Encode4(157818), // Rule ID 7450 //
     /* 157781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157784 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 157787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157791 */     // MIs[0] Rn
     /* 157791 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157803 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_acquire>>  =>  (LDFMAXNMAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAH),
     /* 157806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157810 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157812 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157816 */     GIR_RootConstrainSelectedInstOperands,
     /* 157817 */     // GIR_Coverage, 7450,
     /* 157817 */     GIR_EraseRootFromParent_Done,
     /* 157818 */   // Label 2844: @157818
     /* 157818 */   GIM_Try, /*On fail goto*//*Label 2845*/ GIMT_Encode4(157860), // Rule ID 7451 //
     /* 157823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157826 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 157829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157833 */     // MIs[0] Rn
     /* 157833 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157845 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_release>>  =>  (LDFMAXNMLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLH),
     /* 157848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157852 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157854 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157858 */     GIR_RootConstrainSelectedInstOperands,
     /* 157859 */     // GIR_Coverage, 7451,
     /* 157859 */     GIR_EraseRootFromParent_Done,
     /* 157860 */   // Label 2845: @157860
     /* 157860 */   GIM_Try, /*On fail goto*//*Label 2846*/ GIMT_Encode4(157902), // Rule ID 7452 //
     /* 157865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157868 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 157871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157875 */     // MIs[0] Rn
     /* 157875 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157887 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_acq_rel>>  =>  (LDFMAXNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALH),
     /* 157890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157894 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157900 */     GIR_RootConstrainSelectedInstOperands,
     /* 157901 */     // GIR_Coverage, 7452,
     /* 157901 */     GIR_EraseRootFromParent_Done,
     /* 157902 */   // Label 2846: @157902
     /* 157902 */   GIM_Try, /*On fail goto*//*Label 2847*/ GIMT_Encode4(157944), // Rule ID 7453 //
     /* 157907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157910 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 157913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157917 */     // MIs[0] Rn
     /* 157917 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157929 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_seq_cst>>  =>  (LDFMAXNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALH),
     /* 157932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157936 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157938 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157942 */     GIR_RootConstrainSelectedInstOperands,
     /* 157943 */     // GIR_Coverage, 7453,
     /* 157943 */     GIR_EraseRootFromParent_Done,
     /* 157944 */   // Label 2847: @157944
     /* 157944 */   GIM_Reject,
     /* 157945 */ // Label 2842: @157945
     /* 157945 */ GIM_Reject,
     /* 157946 */ // Label 2839: @157946
     /* 157946 */ GIM_Try, /*On fail goto*//*Label 2848*/ GIMT_Encode4(158172),
     /* 157951 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 157954 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 157961 */   GIM_Try, /*On fail goto*//*Label 2849*/ GIMT_Encode4(158003), // Rule ID 7454 //
     /* 157966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157969 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 157972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157976 */     // MIs[0] Rn
     /* 157976 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157988 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_monotonic>>  =>  (LDFMAXNMS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMS),
     /* 157991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157995 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157997 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158001 */     GIR_RootConstrainSelectedInstOperands,
     /* 158002 */     // GIR_Coverage, 7454,
     /* 158002 */     GIR_EraseRootFromParent_Done,
     /* 158003 */   // Label 2849: @158003
     /* 158003 */   GIM_Try, /*On fail goto*//*Label 2850*/ GIMT_Encode4(158045), // Rule ID 7455 //
     /* 158008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158011 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 158014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158018 */     // MIs[0] Rn
     /* 158018 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158030 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_acquire>>  =>  (LDFMAXNMAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAS),
     /* 158033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158037 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158039 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158043 */     GIR_RootConstrainSelectedInstOperands,
     /* 158044 */     // GIR_Coverage, 7455,
     /* 158044 */     GIR_EraseRootFromParent_Done,
     /* 158045 */   // Label 2850: @158045
     /* 158045 */   GIM_Try, /*On fail goto*//*Label 2851*/ GIMT_Encode4(158087), // Rule ID 7456 //
     /* 158050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158053 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 158056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158060 */     // MIs[0] Rn
     /* 158060 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158072 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_release>>  =>  (LDFMAXNMLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLS),
     /* 158075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158079 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158081 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158085 */     GIR_RootConstrainSelectedInstOperands,
     /* 158086 */     // GIR_Coverage, 7456,
     /* 158086 */     GIR_EraseRootFromParent_Done,
     /* 158087 */   // Label 2851: @158087
     /* 158087 */   GIM_Try, /*On fail goto*//*Label 2852*/ GIMT_Encode4(158129), // Rule ID 7457 //
     /* 158092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158095 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 158098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158102 */     // MIs[0] Rn
     /* 158102 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158114 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_acq_rel>>  =>  (LDFMAXNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALS),
     /* 158117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158121 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158127 */     GIR_RootConstrainSelectedInstOperands,
     /* 158128 */     // GIR_Coverage, 7457,
     /* 158128 */     GIR_EraseRootFromParent_Done,
     /* 158129 */   // Label 2852: @158129
     /* 158129 */   GIM_Try, /*On fail goto*//*Label 2853*/ GIMT_Encode4(158171), // Rule ID 7458 //
     /* 158134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158137 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 158140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158144 */     // MIs[0] Rn
     /* 158144 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158156 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_seq_cst>>  =>  (LDFMAXNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALS),
     /* 158159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158163 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158165 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158169 */     GIR_RootConstrainSelectedInstOperands,
     /* 158170 */     // GIR_Coverage, 7458,
     /* 158170 */     GIR_EraseRootFromParent_Done,
     /* 158171 */   // Label 2853: @158171
     /* 158171 */   GIM_Reject,
     /* 158172 */ // Label 2848: @158172
     /* 158172 */ GIM_Reject,
     /* 158173 */ // Label 2840: @158173
     /* 158173 */ GIM_Try, /*On fail goto*//*Label 2854*/ GIMT_Encode4(158399),
     /* 158178 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 158181 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 158188 */   GIM_Try, /*On fail goto*//*Label 2855*/ GIMT_Encode4(158230), // Rule ID 7459 //
     /* 158193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158196 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 158199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158203 */     // MIs[0] Rn
     /* 158203 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158215 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_monotonic>>  =>  (LDFMAXNMD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMD),
     /* 158218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158222 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158228 */     GIR_RootConstrainSelectedInstOperands,
     /* 158229 */     // GIR_Coverage, 7459,
     /* 158229 */     GIR_EraseRootFromParent_Done,
     /* 158230 */   // Label 2855: @158230
     /* 158230 */   GIM_Try, /*On fail goto*//*Label 2856*/ GIMT_Encode4(158272), // Rule ID 7460 //
     /* 158235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158238 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 158241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158245 */     // MIs[0] Rn
     /* 158245 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158257 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_acquire>>  =>  (LDFMAXNMAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAD),
     /* 158260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158264 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158266 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158270 */     GIR_RootConstrainSelectedInstOperands,
     /* 158271 */     // GIR_Coverage, 7460,
     /* 158271 */     GIR_EraseRootFromParent_Done,
     /* 158272 */   // Label 2856: @158272
     /* 158272 */   GIM_Try, /*On fail goto*//*Label 2857*/ GIMT_Encode4(158314), // Rule ID 7461 //
     /* 158277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158280 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 158283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158287 */     // MIs[0] Rn
     /* 158287 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158299 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_release>>  =>  (LDFMAXNMLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLD),
     /* 158302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158306 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158312 */     GIR_RootConstrainSelectedInstOperands,
     /* 158313 */     // GIR_Coverage, 7461,
     /* 158313 */     GIR_EraseRootFromParent_Done,
     /* 158314 */   // Label 2857: @158314
     /* 158314 */   GIM_Try, /*On fail goto*//*Label 2858*/ GIMT_Encode4(158356), // Rule ID 7462 //
     /* 158319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158322 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 158325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158329 */     // MIs[0] Rn
     /* 158329 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158341 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_acq_rel>>  =>  (LDFMAXNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALD),
     /* 158344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158348 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158350 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158354 */     GIR_RootConstrainSelectedInstOperands,
     /* 158355 */     // GIR_Coverage, 7462,
     /* 158355 */     GIR_EraseRootFromParent_Done,
     /* 158356 */   // Label 2858: @158356
     /* 158356 */   GIM_Try, /*On fail goto*//*Label 2859*/ GIMT_Encode4(158398), // Rule ID 7463 //
     /* 158361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158364 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 158367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158371 */     // MIs[0] Rn
     /* 158371 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158383 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_seq_cst>>  =>  (LDFMAXNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALD),
     /* 158386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158390 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158392 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158396 */     GIR_RootConstrainSelectedInstOperands,
     /* 158397 */     // GIR_Coverage, 7463,
     /* 158397 */     GIR_EraseRootFromParent_Done,
     /* 158398 */   // Label 2859: @158398
     /* 158398 */   GIM_Reject,
     /* 158399 */ // Label 2854: @158399
     /* 158399 */ GIM_Reject,
     /* 158400 */ // Label 2841: @158400
     /* 158400 */ GIM_Reject,
     /* 158401 */ // Label 33: @158401
     /* 158401 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2863*/ GIMT_Encode4(159105),
     /* 158412 */ /*GILLT_s16*//*Label 2860*/ GIMT_Encode4(158424),
     /* 158416 */ /*GILLT_s32*//*Label 2861*/ GIMT_Encode4(158651),
     /* 158420 */ /*GILLT_s64*//*Label 2862*/ GIMT_Encode4(158878),
     /* 158424 */ // Label 2860: @158424
     /* 158424 */ GIM_Try, /*On fail goto*//*Label 2864*/ GIMT_Encode4(158650),
     /* 158429 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 158432 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 158439 */   GIM_Try, /*On fail goto*//*Label 2865*/ GIMT_Encode4(158481), // Rule ID 7464 //
     /* 158444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158447 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 158450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158454 */     // MIs[0] Rn
     /* 158454 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158466 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_monotonic>>  =>  (LDFMINNMH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMH),
     /* 158469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158473 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158475 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158479 */     GIR_RootConstrainSelectedInstOperands,
     /* 158480 */     // GIR_Coverage, 7464,
     /* 158480 */     GIR_EraseRootFromParent_Done,
     /* 158481 */   // Label 2865: @158481
     /* 158481 */   GIM_Try, /*On fail goto*//*Label 2866*/ GIMT_Encode4(158523), // Rule ID 7465 //
     /* 158486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158489 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 158492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158496 */     // MIs[0] Rn
     /* 158496 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158508 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_acquire>>  =>  (LDFMINNMAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAH),
     /* 158511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158515 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158517 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158521 */     GIR_RootConstrainSelectedInstOperands,
     /* 158522 */     // GIR_Coverage, 7465,
     /* 158522 */     GIR_EraseRootFromParent_Done,
     /* 158523 */   // Label 2866: @158523
     /* 158523 */   GIM_Try, /*On fail goto*//*Label 2867*/ GIMT_Encode4(158565), // Rule ID 7466 //
     /* 158528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158531 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 158534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158538 */     // MIs[0] Rn
     /* 158538 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158550 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_release>>  =>  (LDFMINNMLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLH),
     /* 158553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158557 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158563 */     GIR_RootConstrainSelectedInstOperands,
     /* 158564 */     // GIR_Coverage, 7466,
     /* 158564 */     GIR_EraseRootFromParent_Done,
     /* 158565 */   // Label 2867: @158565
     /* 158565 */   GIM_Try, /*On fail goto*//*Label 2868*/ GIMT_Encode4(158607), // Rule ID 7467 //
     /* 158570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158573 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 158576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158580 */     // MIs[0] Rn
     /* 158580 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158592 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_acq_rel>>  =>  (LDFMINNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALH),
     /* 158595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158599 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158601 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158605 */     GIR_RootConstrainSelectedInstOperands,
     /* 158606 */     // GIR_Coverage, 7467,
     /* 158606 */     GIR_EraseRootFromParent_Done,
     /* 158607 */   // Label 2868: @158607
     /* 158607 */   GIM_Try, /*On fail goto*//*Label 2869*/ GIMT_Encode4(158649), // Rule ID 7468 //
     /* 158612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158615 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 158618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158622 */     // MIs[0] Rn
     /* 158622 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158634 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_seq_cst>>  =>  (LDFMINNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALH),
     /* 158637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158641 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158643 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158647 */     GIR_RootConstrainSelectedInstOperands,
     /* 158648 */     // GIR_Coverage, 7468,
     /* 158648 */     GIR_EraseRootFromParent_Done,
     /* 158649 */   // Label 2869: @158649
     /* 158649 */   GIM_Reject,
     /* 158650 */ // Label 2864: @158650
     /* 158650 */ GIM_Reject,
     /* 158651 */ // Label 2861: @158651
     /* 158651 */ GIM_Try, /*On fail goto*//*Label 2870*/ GIMT_Encode4(158877),
     /* 158656 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 158659 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 158666 */   GIM_Try, /*On fail goto*//*Label 2871*/ GIMT_Encode4(158708), // Rule ID 7469 //
     /* 158671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158674 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 158677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158681 */     // MIs[0] Rn
     /* 158681 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158693 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_monotonic>>  =>  (LDFMINNMS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMS),
     /* 158696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158700 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158702 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158706 */     GIR_RootConstrainSelectedInstOperands,
     /* 158707 */     // GIR_Coverage, 7469,
     /* 158707 */     GIR_EraseRootFromParent_Done,
     /* 158708 */   // Label 2871: @158708
     /* 158708 */   GIM_Try, /*On fail goto*//*Label 2872*/ GIMT_Encode4(158750), // Rule ID 7470 //
     /* 158713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158716 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 158719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158723 */     // MIs[0] Rn
     /* 158723 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158735 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_acquire>>  =>  (LDFMINNMAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAS),
     /* 158738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158742 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158744 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158748 */     GIR_RootConstrainSelectedInstOperands,
     /* 158749 */     // GIR_Coverage, 7470,
     /* 158749 */     GIR_EraseRootFromParent_Done,
     /* 158750 */   // Label 2872: @158750
     /* 158750 */   GIM_Try, /*On fail goto*//*Label 2873*/ GIMT_Encode4(158792), // Rule ID 7471 //
     /* 158755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158758 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 158761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158765 */     // MIs[0] Rn
     /* 158765 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158777 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_release>>  =>  (LDFMINNMLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLS),
     /* 158780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158784 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158786 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158790 */     GIR_RootConstrainSelectedInstOperands,
     /* 158791 */     // GIR_Coverage, 7471,
     /* 158791 */     GIR_EraseRootFromParent_Done,
     /* 158792 */   // Label 2873: @158792
     /* 158792 */   GIM_Try, /*On fail goto*//*Label 2874*/ GIMT_Encode4(158834), // Rule ID 7472 //
     /* 158797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158800 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 158803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158807 */     // MIs[0] Rn
     /* 158807 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158819 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_acq_rel>>  =>  (LDFMINNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALS),
     /* 158822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158826 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158828 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158832 */     GIR_RootConstrainSelectedInstOperands,
     /* 158833 */     // GIR_Coverage, 7472,
     /* 158833 */     GIR_EraseRootFromParent_Done,
     /* 158834 */   // Label 2874: @158834
     /* 158834 */   GIM_Try, /*On fail goto*//*Label 2875*/ GIMT_Encode4(158876), // Rule ID 7473 //
     /* 158839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158842 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 158845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158849 */     // MIs[0] Rn
     /* 158849 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158861 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_seq_cst>>  =>  (LDFMINNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALS),
     /* 158864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158868 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158870 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158874 */     GIR_RootConstrainSelectedInstOperands,
     /* 158875 */     // GIR_Coverage, 7473,
     /* 158875 */     GIR_EraseRootFromParent_Done,
     /* 158876 */   // Label 2875: @158876
     /* 158876 */   GIM_Reject,
     /* 158877 */ // Label 2870: @158877
     /* 158877 */ GIM_Reject,
     /* 158878 */ // Label 2862: @158878
     /* 158878 */ GIM_Try, /*On fail goto*//*Label 2876*/ GIMT_Encode4(159104),
     /* 158883 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 158886 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 158893 */   GIM_Try, /*On fail goto*//*Label 2877*/ GIMT_Encode4(158935), // Rule ID 7474 //
     /* 158898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158901 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 158904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158908 */     // MIs[0] Rn
     /* 158908 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158920 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_monotonic>>  =>  (LDFMINNMD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMD),
     /* 158923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158927 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158929 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158933 */     GIR_RootConstrainSelectedInstOperands,
     /* 158934 */     // GIR_Coverage, 7474,
     /* 158934 */     GIR_EraseRootFromParent_Done,
     /* 158935 */   // Label 2877: @158935
     /* 158935 */   GIM_Try, /*On fail goto*//*Label 2878*/ GIMT_Encode4(158977), // Rule ID 7475 //
     /* 158940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158943 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 158946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158950 */     // MIs[0] Rn
     /* 158950 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158962 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_acquire>>  =>  (LDFMINNMAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAD),
     /* 158965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158969 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158971 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158975 */     GIR_RootConstrainSelectedInstOperands,
     /* 158976 */     // GIR_Coverage, 7475,
     /* 158976 */     GIR_EraseRootFromParent_Done,
     /* 158977 */   // Label 2878: @158977
     /* 158977 */   GIM_Try, /*On fail goto*//*Label 2879*/ GIMT_Encode4(159019), // Rule ID 7476 //
     /* 158982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158985 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 158988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158992 */     // MIs[0] Rn
     /* 158992 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159004 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_release>>  =>  (LDFMINNMLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLD),
     /* 159007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159011 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159017 */     GIR_RootConstrainSelectedInstOperands,
     /* 159018 */     // GIR_Coverage, 7476,
     /* 159018 */     GIR_EraseRootFromParent_Done,
     /* 159019 */   // Label 2879: @159019
     /* 159019 */   GIM_Try, /*On fail goto*//*Label 2880*/ GIMT_Encode4(159061), // Rule ID 7477 //
     /* 159024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159027 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 159030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159034 */     // MIs[0] Rn
     /* 159034 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159038 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159046 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_acq_rel>>  =>  (LDFMINNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALD),
     /* 159049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159053 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159055 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159059 */     GIR_RootConstrainSelectedInstOperands,
     /* 159060 */     // GIR_Coverage, 7477,
     /* 159060 */     GIR_EraseRootFromParent_Done,
     /* 159061 */   // Label 2880: @159061
     /* 159061 */   GIM_Try, /*On fail goto*//*Label 2881*/ GIMT_Encode4(159103), // Rule ID 7478 //
     /* 159066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159069 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 159072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159076 */     // MIs[0] Rn
     /* 159076 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159088 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_seq_cst>>  =>  (LDFMINNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALD),
     /* 159091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159095 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159097 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159101 */     GIR_RootConstrainSelectedInstOperands,
     /* 159102 */     // GIR_Coverage, 7478,
     /* 159102 */     GIR_EraseRootFromParent_Done,
     /* 159103 */   // Label 2881: @159103
     /* 159103 */   GIM_Reject,
     /* 159104 */ // Label 2876: @159104
     /* 159104 */ GIM_Reject,
     /* 159105 */ // Label 2863: @159105
     /* 159105 */ GIM_Reject,
     /* 159106 */ // Label 34: @159106
     /* 159106 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2885*/ GIMT_Encode4(159810),
     /* 159117 */ /*GILLT_s16*//*Label 2882*/ GIMT_Encode4(159129),
     /* 159121 */ /*GILLT_s32*//*Label 2883*/ GIMT_Encode4(159356),
     /* 159125 */ /*GILLT_s64*//*Label 2884*/ GIMT_Encode4(159583),
     /* 159129 */ // Label 2882: @159129
     /* 159129 */ GIM_Try, /*On fail goto*//*Label 2886*/ GIMT_Encode4(159355),
     /* 159134 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 159137 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 159144 */   GIM_Try, /*On fail goto*//*Label 2887*/ GIMT_Encode4(159186), // Rule ID 7479 //
     /* 159149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159152 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 159155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159159 */     // MIs[0] Rn
     /* 159159 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159171 */     // (atomic_load_fmaximum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f16>><<P:Predicate_atomic_load_fmaximum_f16_monotonic>>  =>  (LDFMAXH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXH),
     /* 159174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159178 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159180 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159184 */     GIR_RootConstrainSelectedInstOperands,
     /* 159185 */     // GIR_Coverage, 7479,
     /* 159185 */     GIR_EraseRootFromParent_Done,
     /* 159186 */   // Label 2887: @159186
     /* 159186 */   GIM_Try, /*On fail goto*//*Label 2888*/ GIMT_Encode4(159228), // Rule ID 7480 //
     /* 159191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159194 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 159197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159201 */     // MIs[0] Rn
     /* 159201 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159213 */     // (atomic_load_fmaximum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f16>><<P:Predicate_atomic_load_fmaximum_f16_acquire>>  =>  (LDFMAXAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXAH),
     /* 159216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159220 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159226 */     GIR_RootConstrainSelectedInstOperands,
     /* 159227 */     // GIR_Coverage, 7480,
     /* 159227 */     GIR_EraseRootFromParent_Done,
     /* 159228 */   // Label 2888: @159228
     /* 159228 */   GIM_Try, /*On fail goto*//*Label 2889*/ GIMT_Encode4(159270), // Rule ID 7481 //
     /* 159233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159236 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 159239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159243 */     // MIs[0] Rn
     /* 159243 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159255 */     // (atomic_load_fmaximum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f16>><<P:Predicate_atomic_load_fmaximum_f16_release>>  =>  (LDFMAXLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXLH),
     /* 159258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159262 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159264 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159268 */     GIR_RootConstrainSelectedInstOperands,
     /* 159269 */     // GIR_Coverage, 7481,
     /* 159269 */     GIR_EraseRootFromParent_Done,
     /* 159270 */   // Label 2889: @159270
     /* 159270 */   GIM_Try, /*On fail goto*//*Label 2890*/ GIMT_Encode4(159312), // Rule ID 7482 //
     /* 159275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159278 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 159281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159285 */     // MIs[0] Rn
     /* 159285 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159289 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159297 */     // (atomic_load_fmaximum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f16>><<P:Predicate_atomic_load_fmaximum_f16_acq_rel>>  =>  (LDFMAXALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALH),
     /* 159300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159304 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159310 */     GIR_RootConstrainSelectedInstOperands,
     /* 159311 */     // GIR_Coverage, 7482,
     /* 159311 */     GIR_EraseRootFromParent_Done,
     /* 159312 */   // Label 2890: @159312
     /* 159312 */   GIM_Try, /*On fail goto*//*Label 2891*/ GIMT_Encode4(159354), // Rule ID 7483 //
     /* 159317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159320 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 159323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159327 */     // MIs[0] Rn
     /* 159327 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159339 */     // (atomic_load_fmaximum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f16>><<P:Predicate_atomic_load_fmaximum_f16_seq_cst>>  =>  (LDFMAXALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALH),
     /* 159342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159346 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159348 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159352 */     GIR_RootConstrainSelectedInstOperands,
     /* 159353 */     // GIR_Coverage, 7483,
     /* 159353 */     GIR_EraseRootFromParent_Done,
     /* 159354 */   // Label 2891: @159354
     /* 159354 */   GIM_Reject,
     /* 159355 */ // Label 2886: @159355
     /* 159355 */ GIM_Reject,
     /* 159356 */ // Label 2883: @159356
     /* 159356 */ GIM_Try, /*On fail goto*//*Label 2892*/ GIMT_Encode4(159582),
     /* 159361 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 159364 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 159371 */   GIM_Try, /*On fail goto*//*Label 2893*/ GIMT_Encode4(159413), // Rule ID 7484 //
     /* 159376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159379 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 159382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159386 */     // MIs[0] Rn
     /* 159386 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159398 */     // (atomic_load_fmaximum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f32>><<P:Predicate_atomic_load_fmaximum_f32_monotonic>>  =>  (LDFMAXS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXS),
     /* 159401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159405 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159407 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159411 */     GIR_RootConstrainSelectedInstOperands,
     /* 159412 */     // GIR_Coverage, 7484,
     /* 159412 */     GIR_EraseRootFromParent_Done,
     /* 159413 */   // Label 2893: @159413
     /* 159413 */   GIM_Try, /*On fail goto*//*Label 2894*/ GIMT_Encode4(159455), // Rule ID 7485 //
     /* 159418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159421 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 159424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159428 */     // MIs[0] Rn
     /* 159428 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159440 */     // (atomic_load_fmaximum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f32>><<P:Predicate_atomic_load_fmaximum_f32_acquire>>  =>  (LDFMAXAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXAS),
     /* 159443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159447 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159449 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159453 */     GIR_RootConstrainSelectedInstOperands,
     /* 159454 */     // GIR_Coverage, 7485,
     /* 159454 */     GIR_EraseRootFromParent_Done,
     /* 159455 */   // Label 2894: @159455
     /* 159455 */   GIM_Try, /*On fail goto*//*Label 2895*/ GIMT_Encode4(159497), // Rule ID 7486 //
     /* 159460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159463 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 159466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159470 */     // MIs[0] Rn
     /* 159470 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159482 */     // (atomic_load_fmaximum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f32>><<P:Predicate_atomic_load_fmaximum_f32_release>>  =>  (LDFMAXLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXLS),
     /* 159485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159489 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159491 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159495 */     GIR_RootConstrainSelectedInstOperands,
     /* 159496 */     // GIR_Coverage, 7486,
     /* 159496 */     GIR_EraseRootFromParent_Done,
     /* 159497 */   // Label 2895: @159497
     /* 159497 */   GIM_Try, /*On fail goto*//*Label 2896*/ GIMT_Encode4(159539), // Rule ID 7487 //
     /* 159502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159505 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 159508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159512 */     // MIs[0] Rn
     /* 159512 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159524 */     // (atomic_load_fmaximum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f32>><<P:Predicate_atomic_load_fmaximum_f32_acq_rel>>  =>  (LDFMAXALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALS),
     /* 159527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159531 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159533 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159537 */     GIR_RootConstrainSelectedInstOperands,
     /* 159538 */     // GIR_Coverage, 7487,
     /* 159538 */     GIR_EraseRootFromParent_Done,
     /* 159539 */   // Label 2896: @159539
     /* 159539 */   GIM_Try, /*On fail goto*//*Label 2897*/ GIMT_Encode4(159581), // Rule ID 7488 //
     /* 159544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159547 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 159550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159554 */     // MIs[0] Rn
     /* 159554 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159566 */     // (atomic_load_fmaximum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f32>><<P:Predicate_atomic_load_fmaximum_f32_seq_cst>>  =>  (LDFMAXALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALS),
     /* 159569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159573 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159575 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159579 */     GIR_RootConstrainSelectedInstOperands,
     /* 159580 */     // GIR_Coverage, 7488,
     /* 159580 */     GIR_EraseRootFromParent_Done,
     /* 159581 */   // Label 2897: @159581
     /* 159581 */   GIM_Reject,
     /* 159582 */ // Label 2892: @159582
     /* 159582 */ GIM_Reject,
     /* 159583 */ // Label 2884: @159583
     /* 159583 */ GIM_Try, /*On fail goto*//*Label 2898*/ GIMT_Encode4(159809),
     /* 159588 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159591 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 159598 */   GIM_Try, /*On fail goto*//*Label 2899*/ GIMT_Encode4(159640), // Rule ID 7489 //
     /* 159603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159606 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 159609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159613 */     // MIs[0] Rn
     /* 159613 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159625 */     // (atomic_load_fmaximum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f64>><<P:Predicate_atomic_load_fmaximum_f64_monotonic>>  =>  (LDFMAXD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXD),
     /* 159628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159632 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159634 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159638 */     GIR_RootConstrainSelectedInstOperands,
     /* 159639 */     // GIR_Coverage, 7489,
     /* 159639 */     GIR_EraseRootFromParent_Done,
     /* 159640 */   // Label 2899: @159640
     /* 159640 */   GIM_Try, /*On fail goto*//*Label 2900*/ GIMT_Encode4(159682), // Rule ID 7490 //
     /* 159645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159648 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 159651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159655 */     // MIs[0] Rn
     /* 159655 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159667 */     // (atomic_load_fmaximum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f64>><<P:Predicate_atomic_load_fmaximum_f64_acquire>>  =>  (LDFMAXAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXAD),
     /* 159670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159674 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159676 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159680 */     GIR_RootConstrainSelectedInstOperands,
     /* 159681 */     // GIR_Coverage, 7490,
     /* 159681 */     GIR_EraseRootFromParent_Done,
     /* 159682 */   // Label 2900: @159682
     /* 159682 */   GIM_Try, /*On fail goto*//*Label 2901*/ GIMT_Encode4(159724), // Rule ID 7491 //
     /* 159687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159690 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 159693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159697 */     // MIs[0] Rn
     /* 159697 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159709 */     // (atomic_load_fmaximum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f64>><<P:Predicate_atomic_load_fmaximum_f64_release>>  =>  (LDFMAXLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXLD),
     /* 159712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159716 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159718 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159722 */     GIR_RootConstrainSelectedInstOperands,
     /* 159723 */     // GIR_Coverage, 7491,
     /* 159723 */     GIR_EraseRootFromParent_Done,
     /* 159724 */   // Label 2901: @159724
     /* 159724 */   GIM_Try, /*On fail goto*//*Label 2902*/ GIMT_Encode4(159766), // Rule ID 7492 //
     /* 159729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159732 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 159735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159739 */     // MIs[0] Rn
     /* 159739 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159751 */     // (atomic_load_fmaximum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f64>><<P:Predicate_atomic_load_fmaximum_f64_acq_rel>>  =>  (LDFMAXALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALD),
     /* 159754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159758 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159760 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159764 */     GIR_RootConstrainSelectedInstOperands,
     /* 159765 */     // GIR_Coverage, 7492,
     /* 159765 */     GIR_EraseRootFromParent_Done,
     /* 159766 */   // Label 2902: @159766
     /* 159766 */   GIM_Try, /*On fail goto*//*Label 2903*/ GIMT_Encode4(159808), // Rule ID 7493 //
     /* 159771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159774 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 159777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159781 */     // MIs[0] Rn
     /* 159781 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159793 */     // (atomic_load_fmaximum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f64>><<P:Predicate_atomic_load_fmaximum_f64_seq_cst>>  =>  (LDFMAXALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALD),
     /* 159796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159800 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159802 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159806 */     GIR_RootConstrainSelectedInstOperands,
     /* 159807 */     // GIR_Coverage, 7493,
     /* 159807 */     GIR_EraseRootFromParent_Done,
     /* 159808 */   // Label 2903: @159808
     /* 159808 */   GIM_Reject,
     /* 159809 */ // Label 2898: @159809
     /* 159809 */ GIM_Reject,
     /* 159810 */ // Label 2885: @159810
     /* 159810 */ GIM_Reject,
     /* 159811 */ // Label 35: @159811
     /* 159811 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2907*/ GIMT_Encode4(160515),
     /* 159822 */ /*GILLT_s16*//*Label 2904*/ GIMT_Encode4(159834),
     /* 159826 */ /*GILLT_s32*//*Label 2905*/ GIMT_Encode4(160061),
     /* 159830 */ /*GILLT_s64*//*Label 2906*/ GIMT_Encode4(160288),
     /* 159834 */ // Label 2904: @159834
     /* 159834 */ GIM_Try, /*On fail goto*//*Label 2908*/ GIMT_Encode4(160060),
     /* 159839 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 159842 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 159849 */   GIM_Try, /*On fail goto*//*Label 2909*/ GIMT_Encode4(159891), // Rule ID 7494 //
     /* 159854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159857 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 159860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159864 */     // MIs[0] Rn
     /* 159864 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159876 */     // (atomic_load_fminimum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fminimum_f16>><<P:Predicate_atomic_load_fminimum_f16_monotonic>>  =>  (LDFMINH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINH),
     /* 159879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159883 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159889 */     GIR_RootConstrainSelectedInstOperands,
     /* 159890 */     // GIR_Coverage, 7494,
     /* 159890 */     GIR_EraseRootFromParent_Done,
     /* 159891 */   // Label 2909: @159891
     /* 159891 */   GIM_Try, /*On fail goto*//*Label 2910*/ GIMT_Encode4(159933), // Rule ID 7495 //
     /* 159896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159899 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 159902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159906 */     // MIs[0] Rn
     /* 159906 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159918 */     // (atomic_load_fminimum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fminimum_f16>><<P:Predicate_atomic_load_fminimum_f16_acquire>>  =>  (LDFMINAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINAH),
     /* 159921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159925 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159927 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159931 */     GIR_RootConstrainSelectedInstOperands,
     /* 159932 */     // GIR_Coverage, 7495,
     /* 159932 */     GIR_EraseRootFromParent_Done,
     /* 159933 */   // Label 2910: @159933
     /* 159933 */   GIM_Try, /*On fail goto*//*Label 2911*/ GIMT_Encode4(159975), // Rule ID 7496 //
     /* 159938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159941 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 159944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159948 */     // MIs[0] Rn
     /* 159948 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159960 */     // (atomic_load_fminimum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fminimum_f16>><<P:Predicate_atomic_load_fminimum_f16_release>>  =>  (LDFMINLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINLH),
     /* 159963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159967 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159969 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159973 */     GIR_RootConstrainSelectedInstOperands,
     /* 159974 */     // GIR_Coverage, 7496,
     /* 159974 */     GIR_EraseRootFromParent_Done,
     /* 159975 */   // Label 2911: @159975
     /* 159975 */   GIM_Try, /*On fail goto*//*Label 2912*/ GIMT_Encode4(160017), // Rule ID 7497 //
     /* 159980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159983 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 159986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159990 */     // MIs[0] Rn
     /* 159990 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160002 */     // (atomic_load_fminimum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fminimum_f16>><<P:Predicate_atomic_load_fminimum_f16_acq_rel>>  =>  (LDFMINALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALH),
     /* 160005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160009 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160011 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160015 */     GIR_RootConstrainSelectedInstOperands,
     /* 160016 */     // GIR_Coverage, 7497,
     /* 160016 */     GIR_EraseRootFromParent_Done,
     /* 160017 */   // Label 2912: @160017
     /* 160017 */   GIM_Try, /*On fail goto*//*Label 2913*/ GIMT_Encode4(160059), // Rule ID 7498 //
     /* 160022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160025 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 160028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160032 */     // MIs[0] Rn
     /* 160032 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160044 */     // (atomic_load_fminimum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fminimum_f16>><<P:Predicate_atomic_load_fminimum_f16_seq_cst>>  =>  (LDFMINALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALH),
     /* 160047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160051 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160053 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160057 */     GIR_RootConstrainSelectedInstOperands,
     /* 160058 */     // GIR_Coverage, 7498,
     /* 160058 */     GIR_EraseRootFromParent_Done,
     /* 160059 */   // Label 2913: @160059
     /* 160059 */   GIM_Reject,
     /* 160060 */ // Label 2908: @160060
     /* 160060 */ GIM_Reject,
     /* 160061 */ // Label 2905: @160061
     /* 160061 */ GIM_Try, /*On fail goto*//*Label 2914*/ GIMT_Encode4(160287),
     /* 160066 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160069 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 160076 */   GIM_Try, /*On fail goto*//*Label 2915*/ GIMT_Encode4(160118), // Rule ID 7499 //
     /* 160081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160084 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 160087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160091 */     // MIs[0] Rn
     /* 160091 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160103 */     // (atomic_load_fminimum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fminimum_f32>><<P:Predicate_atomic_load_fminimum_f32_monotonic>>  =>  (LDFMINS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINS),
     /* 160106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160110 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160112 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160116 */     GIR_RootConstrainSelectedInstOperands,
     /* 160117 */     // GIR_Coverage, 7499,
     /* 160117 */     GIR_EraseRootFromParent_Done,
     /* 160118 */   // Label 2915: @160118
     /* 160118 */   GIM_Try, /*On fail goto*//*Label 2916*/ GIMT_Encode4(160160), // Rule ID 7500 //
     /* 160123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160126 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 160129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160133 */     // MIs[0] Rn
     /* 160133 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160145 */     // (atomic_load_fminimum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fminimum_f32>><<P:Predicate_atomic_load_fminimum_f32_acquire>>  =>  (LDFMINAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINAS),
     /* 160148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160152 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160154 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160158 */     GIR_RootConstrainSelectedInstOperands,
     /* 160159 */     // GIR_Coverage, 7500,
     /* 160159 */     GIR_EraseRootFromParent_Done,
     /* 160160 */   // Label 2916: @160160
     /* 160160 */   GIM_Try, /*On fail goto*//*Label 2917*/ GIMT_Encode4(160202), // Rule ID 7501 //
     /* 160165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160168 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 160171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160175 */     // MIs[0] Rn
     /* 160175 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160187 */     // (atomic_load_fminimum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fminimum_f32>><<P:Predicate_atomic_load_fminimum_f32_release>>  =>  (LDFMINLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINLS),
     /* 160190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160194 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160200 */     GIR_RootConstrainSelectedInstOperands,
     /* 160201 */     // GIR_Coverage, 7501,
     /* 160201 */     GIR_EraseRootFromParent_Done,
     /* 160202 */   // Label 2917: @160202
     /* 160202 */   GIM_Try, /*On fail goto*//*Label 2918*/ GIMT_Encode4(160244), // Rule ID 7502 //
     /* 160207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160210 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 160213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160217 */     // MIs[0] Rn
     /* 160217 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160229 */     // (atomic_load_fminimum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fminimum_f32>><<P:Predicate_atomic_load_fminimum_f32_acq_rel>>  =>  (LDFMINALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALS),
     /* 160232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160236 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160242 */     GIR_RootConstrainSelectedInstOperands,
     /* 160243 */     // GIR_Coverage, 7502,
     /* 160243 */     GIR_EraseRootFromParent_Done,
     /* 160244 */   // Label 2918: @160244
     /* 160244 */   GIM_Try, /*On fail goto*//*Label 2919*/ GIMT_Encode4(160286), // Rule ID 7503 //
     /* 160249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160252 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 160255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160259 */     // MIs[0] Rn
     /* 160259 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160271 */     // (atomic_load_fminimum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fminimum_f32>><<P:Predicate_atomic_load_fminimum_f32_seq_cst>>  =>  (LDFMINALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALS),
     /* 160274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160278 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160284 */     GIR_RootConstrainSelectedInstOperands,
     /* 160285 */     // GIR_Coverage, 7503,
     /* 160285 */     GIR_EraseRootFromParent_Done,
     /* 160286 */   // Label 2919: @160286
     /* 160286 */   GIM_Reject,
     /* 160287 */ // Label 2914: @160287
     /* 160287 */ GIM_Reject,
     /* 160288 */ // Label 2906: @160288
     /* 160288 */ GIM_Try, /*On fail goto*//*Label 2920*/ GIMT_Encode4(160514),
     /* 160293 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160296 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 160303 */   GIM_Try, /*On fail goto*//*Label 2921*/ GIMT_Encode4(160345), // Rule ID 7504 //
     /* 160308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160311 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 160314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160318 */     // MIs[0] Rn
     /* 160318 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160330 */     // (atomic_load_fminimum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fminimum_f64>><<P:Predicate_atomic_load_fminimum_f64_monotonic>>  =>  (LDFMIND:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMIND),
     /* 160333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160335 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160337 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160343 */     GIR_RootConstrainSelectedInstOperands,
     /* 160344 */     // GIR_Coverage, 7504,
     /* 160344 */     GIR_EraseRootFromParent_Done,
     /* 160345 */   // Label 2921: @160345
     /* 160345 */   GIM_Try, /*On fail goto*//*Label 2922*/ GIMT_Encode4(160387), // Rule ID 7505 //
     /* 160350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160353 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 160356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160360 */     // MIs[0] Rn
     /* 160360 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160372 */     // (atomic_load_fminimum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fminimum_f64>><<P:Predicate_atomic_load_fminimum_f64_acquire>>  =>  (LDFMINAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINAD),
     /* 160375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160379 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160381 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160385 */     GIR_RootConstrainSelectedInstOperands,
     /* 160386 */     // GIR_Coverage, 7505,
     /* 160386 */     GIR_EraseRootFromParent_Done,
     /* 160387 */   // Label 2922: @160387
     /* 160387 */   GIM_Try, /*On fail goto*//*Label 2923*/ GIMT_Encode4(160429), // Rule ID 7506 //
     /* 160392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160395 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 160398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160402 */     // MIs[0] Rn
     /* 160402 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160414 */     // (atomic_load_fminimum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fminimum_f64>><<P:Predicate_atomic_load_fminimum_f64_release>>  =>  (LDFMINLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINLD),
     /* 160417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160421 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160423 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160427 */     GIR_RootConstrainSelectedInstOperands,
     /* 160428 */     // GIR_Coverage, 7506,
     /* 160428 */     GIR_EraseRootFromParent_Done,
     /* 160429 */   // Label 2923: @160429
     /* 160429 */   GIM_Try, /*On fail goto*//*Label 2924*/ GIMT_Encode4(160471), // Rule ID 7507 //
     /* 160434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160437 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 160440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160444 */     // MIs[0] Rn
     /* 160444 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160456 */     // (atomic_load_fminimum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fminimum_f64>><<P:Predicate_atomic_load_fminimum_f64_acq_rel>>  =>  (LDFMINALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALD),
     /* 160459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160463 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160469 */     GIR_RootConstrainSelectedInstOperands,
     /* 160470 */     // GIR_Coverage, 7507,
     /* 160470 */     GIR_EraseRootFromParent_Done,
     /* 160471 */   // Label 2924: @160471
     /* 160471 */   GIM_Try, /*On fail goto*//*Label 2925*/ GIMT_Encode4(160513), // Rule ID 7508 //
     /* 160476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160479 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 160482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160486 */     // MIs[0] Rn
     /* 160486 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160498 */     // (atomic_load_fminimum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fminimum_f64>><<P:Predicate_atomic_load_fminimum_f64_seq_cst>>  =>  (LDFMINALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALD),
     /* 160501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160505 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160507 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160511 */     GIR_RootConstrainSelectedInstOperands,
     /* 160512 */     // GIR_Coverage, 7508,
     /* 160512 */     GIR_EraseRootFromParent_Done,
     /* 160513 */   // Label 2925: @160513
     /* 160513 */   GIM_Reject,
     /* 160514 */ // Label 2920: @160514
     /* 160514 */ GIM_Reject,
     /* 160515 */ // Label 2907: @160515
     /* 160515 */ GIM_Reject,
     /* 160516 */ // Label 36: @160516
     /* 160516 */ GIM_Try, /*On fail goto*//*Label 2926*/ GIMT_Encode4(160543), // Rule ID 7094 //
     /* 160521 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160524 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 4,
     /* 160528 */   // MIs[0] Operand 1
     /* 160528 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 160531 */   // (atomic_fence 4:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (DMB 9:{ *:[i32] })
     /* 160531 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 160534 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 160537 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160541 */   GIR_RootConstrainSelectedInstOperands,
     /* 160542 */   // GIR_Coverage, 7094,
     /* 160542 */   GIR_EraseRootFromParent_Done,
     /* 160543 */ // Label 2926: @160543
     /* 160543 */ GIM_Try, /*On fail goto*//*Label 2927*/ GIMT_Encode4(160566), // Rule ID 7095 //
     /* 160548 */   // MIs[0] Operand 0
     /* 160548 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 160551 */   // MIs[0] Operand 1
     /* 160551 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 160554 */   // (atomic_fence (timm:{ *:[iPTR] }), (timm:{ *:[iPTR] }))  =>  (DMB 11:{ *:[i32] })
     /* 160554 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 160557 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/11,
     /* 160560 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160564 */   GIR_RootConstrainSelectedInstOperands,
     /* 160565 */   // GIR_Coverage, 7095,
     /* 160565 */   GIR_EraseRootFromParent_Done,
     /* 160566 */ // Label 2927: @160566
     /* 160566 */ GIM_Reject,
     /* 160567 */ // Label 37: @160567
     /* 160567 */ GIM_Try, /*On fail goto*//*Label 2928*/ GIMT_Encode4(173094),
     /* 160572 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 160575 */   GIM_Try, /*On fail goto*//*Label 2929*/ GIMT_Encode4(160666), // Rule ID 6567 //
     /* 160580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFuseAES),
     /* 160583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesmc),
     /* 160588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 160591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 160594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 160606 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 160609 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aese),
     /* 160614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 160618 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 160622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160634 */     // (intrinsic_wo_chain:{ *:[v16i8] } 524:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[v16i8] } 522:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))  =>  (AESMCrrTied:{ *:[v16i8] } (AESErr:{ *:[v16i8] } V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))
     /* 160634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 160637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::AESErr),
     /* 160641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160646 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 160650 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /* 160654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 160656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMCrrTied),
     /* 160659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160664 */     GIR_RootConstrainSelectedInstOperands,
     /* 160665 */     // GIR_Coverage, 6567,
     /* 160665 */     GIR_EraseRootFromParent_Done,
     /* 160666 */   // Label 2929: @160666
     /* 160666 */   GIM_Try, /*On fail goto*//*Label 2930*/ GIMT_Encode4(160757), // Rule ID 6568 //
     /* 160671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFuseAES),
     /* 160674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesimc),
     /* 160679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 160682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 160685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 160697 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 160700 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesd),
     /* 160705 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 160709 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 160713 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160718 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160725 */     // (intrinsic_wo_chain:{ *:[v16i8] } 523:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[v16i8] } 521:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))  =>  (AESIMCrrTied:{ *:[v16i8] } (AESDrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))
     /* 160725 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 160728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::AESDrr),
     /* 160732 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160737 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 160741 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /* 160745 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 160747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMCrrTied),
     /* 160750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160752 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160755 */     GIR_RootConstrainSelectedInstOperands,
     /* 160756 */     // GIR_Coverage, 6568,
     /* 160756 */     GIR_EraseRootFromParent_Done,
     /* 160757 */   // Label 2930: @160757
     /* 160757 */   GIM_Try, /*On fail goto*//*Label 2931*/ GIMT_Encode4(160818), // Rule ID 4959 //
     /* 160762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvthf2fp),
     /* 160767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 160770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 160773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 160785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 160789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160794 */     // MIs[1] Operand 2
     /* 160794 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 160805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160807 */     // (intrinsic_wo_chain:{ *:[v4f32] } 777:{ *:[iPTR] }, (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }))  =>  (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8i16] }:$Rn)
     /* 160807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 160810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 160816 */     GIR_RootConstrainSelectedInstOperands,
     /* 160817 */     // GIR_Coverage, 4959,
     /* 160817 */     GIR_EraseRootFromParent_Done,
     /* 160818 */   // Label 2931: @160818
     /* 160818 */   GIM_Try, /*On fail goto*//*Label 2932*/ GIMT_Encode4(160858), // Rule ID 2647 //
     /* 160823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 160826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /* 160831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160838 */     // MIs[0] pattern
     /* 160838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 160841 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 160846 */     // (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTB_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 160846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTB_XPiI),
     /* 160849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160851 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 160853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 160856 */     GIR_RootConstrainSelectedInstOperands,
     /* 160857 */     // GIR_Coverage, 2647,
     /* 160857 */     GIR_EraseRootFromParent_Done,
     /* 160858 */   // Label 2932: @160858
     /* 160858 */   GIM_Try, /*On fail goto*//*Label 2933*/ GIMT_Encode4(160898), // Rule ID 10040 //
     /* 160863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 160866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /* 160871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160878 */     // MIs[0] pattern
     /* 160878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 160881 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 160886 */     // (intrinsic_wo_chain:{ *:[i64] } 1344:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTH_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 160886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTH_XPiI),
     /* 160889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160891 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 160893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 160896 */     GIR_RootConstrainSelectedInstOperands,
     /* 160897 */     // GIR_Coverage, 10040,
     /* 160897 */     GIR_EraseRootFromParent_Done,
     /* 160898 */   // Label 2933: @160898
     /* 160898 */   GIM_Try, /*On fail goto*//*Label 2934*/ GIMT_Encode4(160938), // Rule ID 10043 //
     /* 160903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 160906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /* 160911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160918 */     // MIs[0] pattern
     /* 160918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 160921 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 160926 */     // (intrinsic_wo_chain:{ *:[i64] } 1350:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTW_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 160926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTW_XPiI),
     /* 160929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160931 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 160933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 160936 */     GIR_RootConstrainSelectedInstOperands,
     /* 160937 */     // GIR_Coverage, 10043,
     /* 160937 */     GIR_EraseRootFromParent_Done,
     /* 160938 */   // Label 2934: @160938
     /* 160938 */   GIM_Try, /*On fail goto*//*Label 2935*/ GIMT_Encode4(160978), // Rule ID 10046 //
     /* 160943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 160946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /* 160951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160958 */     // MIs[0] pattern
     /* 160958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 160961 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 160966 */     // (intrinsic_wo_chain:{ *:[i64] } 1343:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTD_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 160966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTD_XPiI),
     /* 160969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160971 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 160973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 160976 */     GIR_RootConstrainSelectedInstOperands,
     /* 160977 */     // GIR_Coverage, 10046,
     /* 160977 */     GIR_EraseRootFromParent_Done,
     /* 160978 */   // Label 2935: @160978
     /* 160978 */   GIM_Try, /*On fail goto*//*Label 2936*/ GIMT_Encode4(161017), // Rule ID 66 //
     /* 160983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasJS),
     /* 160986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_fjcvtzs),
     /* 160991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161005 */     // (intrinsic_wo_chain:{ *:[i32] } 556:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FJCVTZS:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 161005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FJCVTZS),
     /* 161008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161012 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 161015 */     GIR_RootConstrainSelectedInstOperands,
     /* 161016 */     // GIR_Coverage, 66,
     /* 161016 */     GIR_EraseRootFromParent_Done,
     /* 161017 */   // Label 2936: @161017
     /* 161017 */   GIM_Try, /*On fail goto*//*Label 2937*/ GIMT_Encode4(161053), // Rule ID 346 //
     /* 161022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 161025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 161030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161044 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTASUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 161044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWHr),
     /* 161047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161051 */     GIR_RootConstrainSelectedInstOperands,
     /* 161052 */     // GIR_Coverage, 346,
     /* 161052 */     GIR_EraseRootFromParent_Done,
     /* 161053 */   // Label 2937: @161053
     /* 161053 */   GIM_Try, /*On fail goto*//*Label 2938*/ GIMT_Encode4(161089), // Rule ID 347 //
     /* 161058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 161061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 161066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161080 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 161080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 161083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161087 */     GIR_RootConstrainSelectedInstOperands,
     /* 161088 */     // GIR_Coverage, 347,
     /* 161088 */     GIR_EraseRootFromParent_Done,
     /* 161089 */   // Label 2938: @161089
     /* 161089 */   GIM_Try, /*On fail goto*//*Label 2939*/ GIMT_Encode4(161125), // Rule ID 348 //
     /* 161094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 161102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161116 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTASUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 161116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 161119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161123 */     GIR_RootConstrainSelectedInstOperands,
     /* 161124 */     // GIR_Coverage, 348,
     /* 161124 */     GIR_EraseRootFromParent_Done,
     /* 161125 */   // Label 2939: @161125
     /* 161125 */   GIM_Try, /*On fail goto*//*Label 2940*/ GIMT_Encode4(161161), // Rule ID 349 //
     /* 161130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 161138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161152 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 161152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 161155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161159 */     GIR_RootConstrainSelectedInstOperands,
     /* 161160 */     // GIR_Coverage, 349,
     /* 161160 */     GIR_EraseRootFromParent_Done,
     /* 161161 */   // Label 2940: @161161
     /* 161161 */   GIM_Try, /*On fail goto*//*Label 2941*/ GIMT_Encode4(161197), // Rule ID 350 //
     /* 161166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 161174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161188 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTASUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 161188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 161191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161195 */     GIR_RootConstrainSelectedInstOperands,
     /* 161196 */     // GIR_Coverage, 350,
     /* 161196 */     GIR_EraseRootFromParent_Done,
     /* 161197 */   // Label 2941: @161197
     /* 161197 */   GIM_Try, /*On fail goto*//*Label 2942*/ GIMT_Encode4(161233), // Rule ID 351 //
     /* 161202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 161210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161224 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 161224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 161227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161231 */     GIR_RootConstrainSelectedInstOperands,
     /* 161232 */     // GIR_Coverage, 351,
     /* 161232 */     GIR_EraseRootFromParent_Done,
     /* 161233 */   // Label 2942: @161233
     /* 161233 */   GIM_Try, /*On fail goto*//*Label 2943*/ GIMT_Encode4(161269), // Rule ID 352 //
     /* 161238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 161241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 161246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161260 */     // (intrinsic_wo_chain:{ *:[i32] } 594:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTAUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 161260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWHr),
     /* 161263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161267 */     GIR_RootConstrainSelectedInstOperands,
     /* 161268 */     // GIR_Coverage, 352,
     /* 161268 */     GIR_EraseRootFromParent_Done,
     /* 161269 */   // Label 2943: @161269
     /* 161269 */   GIM_Try, /*On fail goto*//*Label 2944*/ GIMT_Encode4(161305), // Rule ID 353 //
     /* 161274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 161277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 161282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161296 */     // (intrinsic_wo_chain:{ *:[i64] } 594:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTAUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 161296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXHr),
     /* 161299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161303 */     GIR_RootConstrainSelectedInstOperands,
     /* 161304 */     // GIR_Coverage, 353,
     /* 161304 */     GIR_EraseRootFromParent_Done,
     /* 161305 */   // Label 2944: @161305
     /* 161305 */   GIM_Try, /*On fail goto*//*Label 2945*/ GIMT_Encode4(161341), // Rule ID 354 //
     /* 161310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 161318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161332 */     // (intrinsic_wo_chain:{ *:[i32] } 594:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTAUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 161332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWSr),
     /* 161335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161339 */     GIR_RootConstrainSelectedInstOperands,
     /* 161340 */     // GIR_Coverage, 354,
     /* 161340 */     GIR_EraseRootFromParent_Done,
     /* 161341 */   // Label 2945: @161341
     /* 161341 */   GIM_Try, /*On fail goto*//*Label 2946*/ GIMT_Encode4(161377), // Rule ID 355 //
     /* 161346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 161354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161368 */     // (intrinsic_wo_chain:{ *:[i64] } 594:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTAUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 161368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXSr),
     /* 161371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161375 */     GIR_RootConstrainSelectedInstOperands,
     /* 161376 */     // GIR_Coverage, 355,
     /* 161376 */     GIR_EraseRootFromParent_Done,
     /* 161377 */   // Label 2946: @161377
     /* 161377 */   GIM_Try, /*On fail goto*//*Label 2947*/ GIMT_Encode4(161413), // Rule ID 356 //
     /* 161382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 161390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161404 */     // (intrinsic_wo_chain:{ *:[i32] } 594:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTAUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 161404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWDr),
     /* 161407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161411 */     GIR_RootConstrainSelectedInstOperands,
     /* 161412 */     // GIR_Coverage, 356,
     /* 161412 */     GIR_EraseRootFromParent_Done,
     /* 161413 */   // Label 2947: @161413
     /* 161413 */   GIM_Try, /*On fail goto*//*Label 2948*/ GIMT_Encode4(161449), // Rule ID 357 //
     /* 161418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 161426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161440 */     // (intrinsic_wo_chain:{ *:[i64] } 594:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTAUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 161440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXDr),
     /* 161443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161447 */     GIR_RootConstrainSelectedInstOperands,
     /* 161448 */     // GIR_Coverage, 357,
     /* 161448 */     GIR_EraseRootFromParent_Done,
     /* 161449 */   // Label 2948: @161449
     /* 161449 */   GIM_Try, /*On fail goto*//*Label 2949*/ GIMT_Encode4(161485), // Rule ID 358 //
     /* 161454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 161457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 161462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161476 */     // (intrinsic_wo_chain:{ *:[i32] } 595:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 161476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWHr),
     /* 161479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161483 */     GIR_RootConstrainSelectedInstOperands,
     /* 161484 */     // GIR_Coverage, 358,
     /* 161484 */     GIR_EraseRootFromParent_Done,
     /* 161485 */   // Label 2949: @161485
     /* 161485 */   GIM_Try, /*On fail goto*//*Label 2950*/ GIMT_Encode4(161521), // Rule ID 359 //
     /* 161490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 161493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 161498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161512 */     // (intrinsic_wo_chain:{ *:[i64] } 595:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 161512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXHr),
     /* 161515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161519 */     GIR_RootConstrainSelectedInstOperands,
     /* 161520 */     // GIR_Coverage, 359,
     /* 161520 */     GIR_EraseRootFromParent_Done,
     /* 161521 */   // Label 2950: @161521
     /* 161521 */   GIM_Try, /*On fail goto*//*Label 2951*/ GIMT_Encode4(161557), // Rule ID 360 //
     /* 161526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 161534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161548 */     // (intrinsic_wo_chain:{ *:[i32] } 595:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 161548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWSr),
     /* 161551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161555 */     GIR_RootConstrainSelectedInstOperands,
     /* 161556 */     // GIR_Coverage, 360,
     /* 161556 */     GIR_EraseRootFromParent_Done,
     /* 161557 */   // Label 2951: @161557
     /* 161557 */   GIM_Try, /*On fail goto*//*Label 2952*/ GIMT_Encode4(161593), // Rule ID 361 //
     /* 161562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 161570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161584 */     // (intrinsic_wo_chain:{ *:[i64] } 595:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 161584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXSr),
     /* 161587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161591 */     GIR_RootConstrainSelectedInstOperands,
     /* 161592 */     // GIR_Coverage, 361,
     /* 161592 */     GIR_EraseRootFromParent_Done,
     /* 161593 */   // Label 2952: @161593
     /* 161593 */   GIM_Try, /*On fail goto*//*Label 2953*/ GIMT_Encode4(161629), // Rule ID 362 //
     /* 161598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 161606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161620 */     // (intrinsic_wo_chain:{ *:[i32] } 595:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 161620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWDr),
     /* 161623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161627 */     GIR_RootConstrainSelectedInstOperands,
     /* 161628 */     // GIR_Coverage, 362,
     /* 161628 */     GIR_EraseRootFromParent_Done,
     /* 161629 */   // Label 2953: @161629
     /* 161629 */   GIM_Try, /*On fail goto*//*Label 2954*/ GIMT_Encode4(161665), // Rule ID 363 //
     /* 161634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 161642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161656 */     // (intrinsic_wo_chain:{ *:[i64] } 595:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 161656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXDr),
     /* 161659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161663 */     GIR_RootConstrainSelectedInstOperands,
     /* 161664 */     // GIR_Coverage, 363,
     /* 161664 */     GIR_EraseRootFromParent_Done,
     /* 161665 */   // Label 2954: @161665
     /* 161665 */   GIM_Try, /*On fail goto*//*Label 2955*/ GIMT_Encode4(161701), // Rule ID 364 //
     /* 161670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 161673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 161678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161692 */     // (intrinsic_wo_chain:{ *:[i32] } 596:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 161692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWHr),
     /* 161695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161699 */     GIR_RootConstrainSelectedInstOperands,
     /* 161700 */     // GIR_Coverage, 364,
     /* 161700 */     GIR_EraseRootFromParent_Done,
     /* 161701 */   // Label 2955: @161701
     /* 161701 */   GIM_Try, /*On fail goto*//*Label 2956*/ GIMT_Encode4(161737), // Rule ID 365 //
     /* 161706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 161709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 161714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161728 */     // (intrinsic_wo_chain:{ *:[i64] } 596:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 161728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXHr),
     /* 161731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161735 */     GIR_RootConstrainSelectedInstOperands,
     /* 161736 */     // GIR_Coverage, 365,
     /* 161736 */     GIR_EraseRootFromParent_Done,
     /* 161737 */   // Label 2956: @161737
     /* 161737 */   GIM_Try, /*On fail goto*//*Label 2957*/ GIMT_Encode4(161773), // Rule ID 366 //
     /* 161742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 161750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161764 */     // (intrinsic_wo_chain:{ *:[i32] } 596:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 161764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWSr),
     /* 161767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161771 */     GIR_RootConstrainSelectedInstOperands,
     /* 161772 */     // GIR_Coverage, 366,
     /* 161772 */     GIR_EraseRootFromParent_Done,
     /* 161773 */   // Label 2957: @161773
     /* 161773 */   GIM_Try, /*On fail goto*//*Label 2958*/ GIMT_Encode4(161809), // Rule ID 367 //
     /* 161778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 161786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161800 */     // (intrinsic_wo_chain:{ *:[i64] } 596:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 161800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXSr),
     /* 161803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161807 */     GIR_RootConstrainSelectedInstOperands,
     /* 161808 */     // GIR_Coverage, 367,
     /* 161808 */     GIR_EraseRootFromParent_Done,
     /* 161809 */   // Label 2958: @161809
     /* 161809 */   GIM_Try, /*On fail goto*//*Label 2959*/ GIMT_Encode4(161845), // Rule ID 368 //
     /* 161814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 161822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161836 */     // (intrinsic_wo_chain:{ *:[i32] } 596:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 161836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWDr),
     /* 161839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161843 */     GIR_RootConstrainSelectedInstOperands,
     /* 161844 */     // GIR_Coverage, 368,
     /* 161844 */     GIR_EraseRootFromParent_Done,
     /* 161845 */   // Label 2959: @161845
     /* 161845 */   GIM_Try, /*On fail goto*//*Label 2960*/ GIMT_Encode4(161881), // Rule ID 369 //
     /* 161850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 161858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161872 */     // (intrinsic_wo_chain:{ *:[i64] } 596:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 161872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXDr),
     /* 161875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161879 */     GIR_RootConstrainSelectedInstOperands,
     /* 161880 */     // GIR_Coverage, 369,
     /* 161880 */     GIR_EraseRootFromParent_Done,
     /* 161881 */   // Label 2960: @161881
     /* 161881 */   GIM_Try, /*On fail goto*//*Label 2961*/ GIMT_Encode4(161917), // Rule ID 370 //
     /* 161886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 161889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 161894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161908 */     // (intrinsic_wo_chain:{ *:[i32] } 597:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 161908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWHr),
     /* 161911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161915 */     GIR_RootConstrainSelectedInstOperands,
     /* 161916 */     // GIR_Coverage, 370,
     /* 161916 */     GIR_EraseRootFromParent_Done,
     /* 161917 */   // Label 2961: @161917
     /* 161917 */   GIM_Try, /*On fail goto*//*Label 2962*/ GIMT_Encode4(161953), // Rule ID 371 //
     /* 161922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 161925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 161930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161944 */     // (intrinsic_wo_chain:{ *:[i64] } 597:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 161944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXHr),
     /* 161947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161951 */     GIR_RootConstrainSelectedInstOperands,
     /* 161952 */     // GIR_Coverage, 371,
     /* 161952 */     GIR_EraseRootFromParent_Done,
     /* 161953 */   // Label 2962: @161953
     /* 161953 */   GIM_Try, /*On fail goto*//*Label 2963*/ GIMT_Encode4(161989), // Rule ID 372 //
     /* 161958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 161966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161980 */     // (intrinsic_wo_chain:{ *:[i32] } 597:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 161980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWSr),
     /* 161983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161987 */     GIR_RootConstrainSelectedInstOperands,
     /* 161988 */     // GIR_Coverage, 372,
     /* 161988 */     GIR_EraseRootFromParent_Done,
     /* 161989 */   // Label 2963: @161989
     /* 161989 */   GIM_Try, /*On fail goto*//*Label 2964*/ GIMT_Encode4(162025), // Rule ID 373 //
     /* 161994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 162002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162016 */     // (intrinsic_wo_chain:{ *:[i64] } 597:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 162016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXSr),
     /* 162019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162023 */     GIR_RootConstrainSelectedInstOperands,
     /* 162024 */     // GIR_Coverage, 373,
     /* 162024 */     GIR_EraseRootFromParent_Done,
     /* 162025 */   // Label 2964: @162025
     /* 162025 */   GIM_Try, /*On fail goto*//*Label 2965*/ GIMT_Encode4(162061), // Rule ID 374 //
     /* 162030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 162038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 162048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162052 */     // (intrinsic_wo_chain:{ *:[i32] } 597:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 162052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWDr),
     /* 162055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162059 */     GIR_RootConstrainSelectedInstOperands,
     /* 162060 */     // GIR_Coverage, 374,
     /* 162060 */     GIR_EraseRootFromParent_Done,
     /* 162061 */   // Label 2965: @162061
     /* 162061 */   GIM_Try, /*On fail goto*//*Label 2966*/ GIMT_Encode4(162097), // Rule ID 375 //
     /* 162066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 162074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162088 */     // (intrinsic_wo_chain:{ *:[i64] } 597:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 162088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXDr),
     /* 162091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162095 */     GIR_RootConstrainSelectedInstOperands,
     /* 162096 */     // GIR_Coverage, 375,
     /* 162096 */     GIR_EraseRootFromParent_Done,
     /* 162097 */   // Label 2966: @162097
     /* 162097 */   GIM_Try, /*On fail goto*//*Label 2967*/ GIMT_Encode4(162133), // Rule ID 376 //
     /* 162102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 162105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 162110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 162116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 162120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 162124 */     // (intrinsic_wo_chain:{ *:[i32] } 598:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 162124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWHr),
     /* 162127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162131 */     GIR_RootConstrainSelectedInstOperands,
     /* 162132 */     // GIR_Coverage, 376,
     /* 162132 */     GIR_EraseRootFromParent_Done,
     /* 162133 */   // Label 2967: @162133
     /* 162133 */   GIM_Try, /*On fail goto*//*Label 2968*/ GIMT_Encode4(162169), // Rule ID 377 //
     /* 162138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 162141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 162146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 162152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 162160 */     // (intrinsic_wo_chain:{ *:[i64] } 598:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 162160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXHr),
     /* 162163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162167 */     GIR_RootConstrainSelectedInstOperands,
     /* 162168 */     // GIR_Coverage, 377,
     /* 162168 */     GIR_EraseRootFromParent_Done,
     /* 162169 */   // Label 2968: @162169
     /* 162169 */   GIM_Try, /*On fail goto*//*Label 2969*/ GIMT_Encode4(162205), // Rule ID 378 //
     /* 162174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 162182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 162192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162196 */     // (intrinsic_wo_chain:{ *:[i32] } 598:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 162196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWSr),
     /* 162199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162203 */     GIR_RootConstrainSelectedInstOperands,
     /* 162204 */     // GIR_Coverage, 378,
     /* 162204 */     GIR_EraseRootFromParent_Done,
     /* 162205 */   // Label 2969: @162205
     /* 162205 */   GIM_Try, /*On fail goto*//*Label 2970*/ GIMT_Encode4(162241), // Rule ID 379 //
     /* 162210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 162218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162232 */     // (intrinsic_wo_chain:{ *:[i64] } 598:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 162232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXSr),
     /* 162235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162239 */     GIR_RootConstrainSelectedInstOperands,
     /* 162240 */     // GIR_Coverage, 379,
     /* 162240 */     GIR_EraseRootFromParent_Done,
     /* 162241 */   // Label 2970: @162241
     /* 162241 */   GIM_Try, /*On fail goto*//*Label 2971*/ GIMT_Encode4(162277), // Rule ID 380 //
     /* 162246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 162254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 162264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162268 */     // (intrinsic_wo_chain:{ *:[i32] } 598:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 162268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWDr),
     /* 162271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162275 */     GIR_RootConstrainSelectedInstOperands,
     /* 162276 */     // GIR_Coverage, 380,
     /* 162276 */     GIR_EraseRootFromParent_Done,
     /* 162277 */   // Label 2971: @162277
     /* 162277 */   GIM_Try, /*On fail goto*//*Label 2972*/ GIMT_Encode4(162313), // Rule ID 381 //
     /* 162282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 162290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162304 */     // (intrinsic_wo_chain:{ *:[i64] } 598:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 162304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXDr),
     /* 162307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162311 */     GIR_RootConstrainSelectedInstOperands,
     /* 162312 */     // GIR_Coverage, 381,
     /* 162312 */     GIR_EraseRootFromParent_Done,
     /* 162313 */   // Label 2972: @162313
     /* 162313 */   GIM_Try, /*On fail goto*//*Label 2973*/ GIMT_Encode4(162349), // Rule ID 382 //
     /* 162318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 162321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 162326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 162332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 162336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 162340 */     // (intrinsic_wo_chain:{ *:[i32] } 599:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 162340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWHr),
     /* 162343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162347 */     GIR_RootConstrainSelectedInstOperands,
     /* 162348 */     // GIR_Coverage, 382,
     /* 162348 */     GIR_EraseRootFromParent_Done,
     /* 162349 */   // Label 2973: @162349
     /* 162349 */   GIM_Try, /*On fail goto*//*Label 2974*/ GIMT_Encode4(162385), // Rule ID 383 //
     /* 162354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 162357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 162362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 162368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 162376 */     // (intrinsic_wo_chain:{ *:[i64] } 599:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 162376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXHr),
     /* 162379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162383 */     GIR_RootConstrainSelectedInstOperands,
     /* 162384 */     // GIR_Coverage, 383,
     /* 162384 */     GIR_EraseRootFromParent_Done,
     /* 162385 */   // Label 2974: @162385
     /* 162385 */   GIM_Try, /*On fail goto*//*Label 2975*/ GIMT_Encode4(162421), // Rule ID 384 //
     /* 162390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 162398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 162408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162412 */     // (intrinsic_wo_chain:{ *:[i32] } 599:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 162412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWSr),
     /* 162415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162419 */     GIR_RootConstrainSelectedInstOperands,
     /* 162420 */     // GIR_Coverage, 384,
     /* 162420 */     GIR_EraseRootFromParent_Done,
     /* 162421 */   // Label 2975: @162421
     /* 162421 */   GIM_Try, /*On fail goto*//*Label 2976*/ GIMT_Encode4(162457), // Rule ID 385 //
     /* 162426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 162434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162448 */     // (intrinsic_wo_chain:{ *:[i64] } 599:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 162448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXSr),
     /* 162451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162455 */     GIR_RootConstrainSelectedInstOperands,
     /* 162456 */     // GIR_Coverage, 385,
     /* 162456 */     GIR_EraseRootFromParent_Done,
     /* 162457 */   // Label 2976: @162457
     /* 162457 */   GIM_Try, /*On fail goto*//*Label 2977*/ GIMT_Encode4(162493), // Rule ID 386 //
     /* 162462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 162470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 162480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162484 */     // (intrinsic_wo_chain:{ *:[i32] } 599:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 162484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWDr),
     /* 162487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162491 */     GIR_RootConstrainSelectedInstOperands,
     /* 162492 */     // GIR_Coverage, 386,
     /* 162492 */     GIR_EraseRootFromParent_Done,
     /* 162493 */   // Label 2977: @162493
     /* 162493 */   GIM_Try, /*On fail goto*//*Label 2978*/ GIMT_Encode4(162529), // Rule ID 387 //
     /* 162498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 162506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162520 */     // (intrinsic_wo_chain:{ *:[i64] } 599:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 162520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXDr),
     /* 162523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162527 */     GIR_RootConstrainSelectedInstOperands,
     /* 162528 */     // GIR_Coverage, 387,
     /* 162528 */     GIR_EraseRootFromParent_Done,
     /* 162529 */   // Label 2978: @162529
     /* 162529 */   GIM_Try, /*On fail goto*//*Label 2979*/ GIMT_Encode4(162565), // Rule ID 388 //
     /* 162534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 162537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 162542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 162548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 162552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 162556 */     // (intrinsic_wo_chain:{ *:[i32] } 600:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 162556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWHr),
     /* 162559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162563 */     GIR_RootConstrainSelectedInstOperands,
     /* 162564 */     // GIR_Coverage, 388,
     /* 162564 */     GIR_EraseRootFromParent_Done,
     /* 162565 */   // Label 2979: @162565
     /* 162565 */   GIM_Try, /*On fail goto*//*Label 2980*/ GIMT_Encode4(162601), // Rule ID 389 //
     /* 162570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 162573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 162578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 162584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 162592 */     // (intrinsic_wo_chain:{ *:[i64] } 600:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 162592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXHr),
     /* 162595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162599 */     GIR_RootConstrainSelectedInstOperands,
     /* 162600 */     // GIR_Coverage, 389,
     /* 162600 */     GIR_EraseRootFromParent_Done,
     /* 162601 */   // Label 2980: @162601
     /* 162601 */   GIM_Try, /*On fail goto*//*Label 2981*/ GIMT_Encode4(162637), // Rule ID 390 //
     /* 162606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 162614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 162624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162628 */     // (intrinsic_wo_chain:{ *:[i32] } 600:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 162628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWSr),
     /* 162631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162635 */     GIR_RootConstrainSelectedInstOperands,
     /* 162636 */     // GIR_Coverage, 390,
     /* 162636 */     GIR_EraseRootFromParent_Done,
     /* 162637 */   // Label 2981: @162637
     /* 162637 */   GIM_Try, /*On fail goto*//*Label 2982*/ GIMT_Encode4(162673), // Rule ID 391 //
     /* 162642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 162650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162664 */     // (intrinsic_wo_chain:{ *:[i64] } 600:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 162664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXSr),
     /* 162667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162671 */     GIR_RootConstrainSelectedInstOperands,
     /* 162672 */     // GIR_Coverage, 391,
     /* 162672 */     GIR_EraseRootFromParent_Done,
     /* 162673 */   // Label 2982: @162673
     /* 162673 */   GIM_Try, /*On fail goto*//*Label 2983*/ GIMT_Encode4(162709), // Rule ID 392 //
     /* 162678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 162686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 162696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162700 */     // (intrinsic_wo_chain:{ *:[i32] } 600:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 162700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWDr),
     /* 162703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162707 */     GIR_RootConstrainSelectedInstOperands,
     /* 162708 */     // GIR_Coverage, 392,
     /* 162708 */     GIR_EraseRootFromParent_Done,
     /* 162709 */   // Label 2983: @162709
     /* 162709 */   GIM_Try, /*On fail goto*//*Label 2984*/ GIMT_Encode4(162745), // Rule ID 393 //
     /* 162714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 162722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162736 */     // (intrinsic_wo_chain:{ *:[i64] } 600:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 162736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXDr),
     /* 162739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162743 */     GIR_RootConstrainSelectedInstOperands,
     /* 162744 */     // GIR_Coverage, 393,
     /* 162744 */     GIR_EraseRootFromParent_Done,
     /* 162745 */   // Label 2984: @162745
     /* 162745 */   GIM_Try, /*On fail goto*//*Label 2985*/ GIMT_Encode4(162781), // Rule ID 575 //
     /* 162750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 162753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32z),
     /* 162758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162772 */     // (intrinsic_wo_chain:{ *:[f32] } 558:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT32ZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 162772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZSr),
     /* 162775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162779 */     GIR_RootConstrainSelectedInstOperands,
     /* 162780 */     // GIR_Coverage, 575,
     /* 162780 */     GIR_EraseRootFromParent_Done,
     /* 162781 */   // Label 2985: @162781
     /* 162781 */   GIM_Try, /*On fail goto*//*Label 2986*/ GIMT_Encode4(162817), // Rule ID 576 //
     /* 162786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 162789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32z),
     /* 162794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162808 */     // (intrinsic_wo_chain:{ *:[f64] } 558:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT32ZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 162808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZDr),
     /* 162811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162815 */     GIR_RootConstrainSelectedInstOperands,
     /* 162816 */     // GIR_Coverage, 576,
     /* 162816 */     GIR_EraseRootFromParent_Done,
     /* 162817 */   // Label 2986: @162817
     /* 162817 */   GIM_Try, /*On fail goto*//*Label 2987*/ GIMT_Encode4(162853), // Rule ID 577 //
     /* 162822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 162825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64z),
     /* 162830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162844 */     // (intrinsic_wo_chain:{ *:[f32] } 560:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT64ZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 162844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZSr),
     /* 162847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162851 */     GIR_RootConstrainSelectedInstOperands,
     /* 162852 */     // GIR_Coverage, 577,
     /* 162852 */     GIR_EraseRootFromParent_Done,
     /* 162853 */   // Label 2987: @162853
     /* 162853 */   GIM_Try, /*On fail goto*//*Label 2988*/ GIMT_Encode4(162889), // Rule ID 578 //
     /* 162858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 162861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64z),
     /* 162866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162880 */     // (intrinsic_wo_chain:{ *:[f64] } 560:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT64ZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 162880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZDr),
     /* 162883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162887 */     GIR_RootConstrainSelectedInstOperands,
     /* 162888 */     // GIR_Coverage, 578,
     /* 162888 */     GIR_EraseRootFromParent_Done,
     /* 162889 */   // Label 2988: @162889
     /* 162889 */   GIM_Try, /*On fail goto*//*Label 2989*/ GIMT_Encode4(162925), // Rule ID 579 //
     /* 162894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 162897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32x),
     /* 162902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162916 */     // (intrinsic_wo_chain:{ *:[f32] } 557:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT32XSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 162916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XSr),
     /* 162919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162923 */     GIR_RootConstrainSelectedInstOperands,
     /* 162924 */     // GIR_Coverage, 579,
     /* 162924 */     GIR_EraseRootFromParent_Done,
     /* 162925 */   // Label 2989: @162925
     /* 162925 */   GIM_Try, /*On fail goto*//*Label 2990*/ GIMT_Encode4(162961), // Rule ID 580 //
     /* 162930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 162933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32x),
     /* 162938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162952 */     // (intrinsic_wo_chain:{ *:[f64] } 557:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT32XDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 162952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XDr),
     /* 162955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162959 */     GIR_RootConstrainSelectedInstOperands,
     /* 162960 */     // GIR_Coverage, 580,
     /* 162960 */     GIR_EraseRootFromParent_Done,
     /* 162961 */   // Label 2990: @162961
     /* 162961 */   GIM_Try, /*On fail goto*//*Label 2991*/ GIMT_Encode4(162997), // Rule ID 581 //
     /* 162966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 162969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64x),
     /* 162974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162988 */     // (intrinsic_wo_chain:{ *:[f32] } 559:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT64XSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 162988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XSr),
     /* 162991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162995 */     GIR_RootConstrainSelectedInstOperands,
     /* 162996 */     // GIR_Coverage, 581,
     /* 162996 */     GIR_EraseRootFromParent_Done,
     /* 162997 */   // Label 2991: @162997
     /* 162997 */   GIM_Try, /*On fail goto*//*Label 2992*/ GIMT_Encode4(163033), // Rule ID 582 //
     /* 163002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64x),
     /* 163010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 163013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163024 */     // (intrinsic_wo_chain:{ *:[f64] } 559:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT64XDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 163024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XDr),
     /* 163027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163031 */     GIR_RootConstrainSelectedInstOperands,
     /* 163032 */     // GIR_Coverage, 582,
     /* 163032 */     GIR_EraseRootFromParent_Done,
     /* 163033 */   // Label 2992: @163033
     /* 163033 */   GIM_Try, /*On fail goto*//*Label 2993*/ GIMT_Encode4(163069), // Rule ID 710 //
     /* 163038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 163046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 163049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 163052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163060 */     // (intrinsic_wo_chain:{ *:[v8i8] } 585:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (CLSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 163060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv8i8),
     /* 163063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163067 */     GIR_RootConstrainSelectedInstOperands,
     /* 163068 */     // GIR_Coverage, 710,
     /* 163068 */     GIR_EraseRootFromParent_Done,
     /* 163069 */   // Label 2993: @163069
     /* 163069 */   GIM_Try, /*On fail goto*//*Label 2994*/ GIMT_Encode4(163105), // Rule ID 711 //
     /* 163074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 163082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 163085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 163088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163096 */     // (intrinsic_wo_chain:{ *:[v16i8] } 585:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (CLSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 163096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv16i8),
     /* 163099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163103 */     GIR_RootConstrainSelectedInstOperands,
     /* 163104 */     // GIR_Coverage, 711,
     /* 163104 */     GIR_EraseRootFromParent_Done,
     /* 163105 */   // Label 2994: @163105
     /* 163105 */   GIM_Try, /*On fail goto*//*Label 2995*/ GIMT_Encode4(163141), // Rule ID 712 //
     /* 163110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 163118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 163121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 163124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163132 */     // (intrinsic_wo_chain:{ *:[v4i16] } 585:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (CLSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 163132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv4i16),
     /* 163135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163139 */     GIR_RootConstrainSelectedInstOperands,
     /* 163140 */     // GIR_Coverage, 712,
     /* 163140 */     GIR_EraseRootFromParent_Done,
     /* 163141 */   // Label 2995: @163141
     /* 163141 */   GIM_Try, /*On fail goto*//*Label 2996*/ GIMT_Encode4(163177), // Rule ID 713 //
     /* 163146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 163154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 163157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 163160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163168 */     // (intrinsic_wo_chain:{ *:[v8i16] } 585:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (CLSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 163168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv8i16),
     /* 163171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163175 */     GIR_RootConstrainSelectedInstOperands,
     /* 163176 */     // GIR_Coverage, 713,
     /* 163176 */     GIR_EraseRootFromParent_Done,
     /* 163177 */   // Label 2996: @163177
     /* 163177 */   GIM_Try, /*On fail goto*//*Label 2997*/ GIMT_Encode4(163213), // Rule ID 714 //
     /* 163182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 163190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163204 */     // (intrinsic_wo_chain:{ *:[v2i32] } 585:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (CLSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 163204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv2i32),
     /* 163207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163211 */     GIR_RootConstrainSelectedInstOperands,
     /* 163212 */     // GIR_Coverage, 714,
     /* 163212 */     GIR_EraseRootFromParent_Done,
     /* 163213 */   // Label 2997: @163213
     /* 163213 */   GIM_Try, /*On fail goto*//*Label 2998*/ GIMT_Encode4(163249), // Rule ID 715 //
     /* 163218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 163226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163240 */     // (intrinsic_wo_chain:{ *:[v4i32] } 585:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (CLSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 163240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv4i32),
     /* 163243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163247 */     GIR_RootConstrainSelectedInstOperands,
     /* 163248 */     // GIR_Coverage, 715,
     /* 163248 */     GIR_EraseRootFromParent_Done,
     /* 163249 */   // Label 2998: @163249
     /* 163249 */   GIM_Try, /*On fail goto*//*Label 2999*/ GIMT_Encode4(163285), // Rule ID 796 //
     /* 163254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 163262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 163265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 163268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163276 */     // (intrinsic_wo_chain:{ *:[v4i16] } 593:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTASv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 163276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv4f16),
     /* 163279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163283 */     GIR_RootConstrainSelectedInstOperands,
     /* 163284 */     // GIR_Coverage, 796,
     /* 163284 */     GIR_EraseRootFromParent_Done,
     /* 163285 */   // Label 2999: @163285
     /* 163285 */   GIM_Try, /*On fail goto*//*Label 3000*/ GIMT_Encode4(163321), // Rule ID 797 //
     /* 163290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 163298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 163301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 163304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163312 */     // (intrinsic_wo_chain:{ *:[v8i16] } 593:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTASv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 163312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv8f16),
     /* 163315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163319 */     GIR_RootConstrainSelectedInstOperands,
     /* 163320 */     // GIR_Coverage, 797,
     /* 163320 */     GIR_EraseRootFromParent_Done,
     /* 163321 */   // Label 3000: @163321
     /* 163321 */   GIM_Try, /*On fail goto*//*Label 3001*/ GIMT_Encode4(163357), // Rule ID 798 //
     /* 163326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 163334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163348 */     // (intrinsic_wo_chain:{ *:[v2i32] } 593:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTASv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 163348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv2f32),
     /* 163351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163355 */     GIR_RootConstrainSelectedInstOperands,
     /* 163356 */     // GIR_Coverage, 798,
     /* 163356 */     GIR_EraseRootFromParent_Done,
     /* 163357 */   // Label 3001: @163357
     /* 163357 */   GIM_Try, /*On fail goto*//*Label 3002*/ GIMT_Encode4(163393), // Rule ID 799 //
     /* 163362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 163370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163384 */     // (intrinsic_wo_chain:{ *:[v4i32] } 593:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTASv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 163384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv4f32),
     /* 163387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163391 */     GIR_RootConstrainSelectedInstOperands,
     /* 163392 */     // GIR_Coverage, 799,
     /* 163392 */     GIR_EraseRootFromParent_Done,
     /* 163393 */   // Label 3002: @163393
     /* 163393 */   GIM_Try, /*On fail goto*//*Label 3003*/ GIMT_Encode4(163429), // Rule ID 800 //
     /* 163398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 163406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163420 */     // (intrinsic_wo_chain:{ *:[v2i64] } 593:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTASv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 163420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv2f64),
     /* 163423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163427 */     GIR_RootConstrainSelectedInstOperands,
     /* 163428 */     // GIR_Coverage, 800,
     /* 163428 */     GIR_EraseRootFromParent_Done,
     /* 163429 */   // Label 3003: @163429
     /* 163429 */   GIM_Try, /*On fail goto*//*Label 3004*/ GIMT_Encode4(163465), // Rule ID 801 //
     /* 163434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 163442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 163445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 163448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163456 */     // (intrinsic_wo_chain:{ *:[v4i16] } 594:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTAUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 163456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv4f16),
     /* 163459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163463 */     GIR_RootConstrainSelectedInstOperands,
     /* 163464 */     // GIR_Coverage, 801,
     /* 163464 */     GIR_EraseRootFromParent_Done,
     /* 163465 */   // Label 3004: @163465
     /* 163465 */   GIM_Try, /*On fail goto*//*Label 3005*/ GIMT_Encode4(163501), // Rule ID 802 //
     /* 163470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 163478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 163481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 163484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163492 */     // (intrinsic_wo_chain:{ *:[v8i16] } 594:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTAUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 163492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv8f16),
     /* 163495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163499 */     GIR_RootConstrainSelectedInstOperands,
     /* 163500 */     // GIR_Coverage, 802,
     /* 163500 */     GIR_EraseRootFromParent_Done,
     /* 163501 */   // Label 3005: @163501
     /* 163501 */   GIM_Try, /*On fail goto*//*Label 3006*/ GIMT_Encode4(163537), // Rule ID 803 //
     /* 163506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 163514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163528 */     // (intrinsic_wo_chain:{ *:[v2i32] } 594:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTAUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 163528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv2f32),
     /* 163531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163535 */     GIR_RootConstrainSelectedInstOperands,
     /* 163536 */     // GIR_Coverage, 803,
     /* 163536 */     GIR_EraseRootFromParent_Done,
     /* 163537 */   // Label 3006: @163537
     /* 163537 */   GIM_Try, /*On fail goto*//*Label 3007*/ GIMT_Encode4(163573), // Rule ID 804 //
     /* 163542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 163550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163564 */     // (intrinsic_wo_chain:{ *:[v4i32] } 594:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTAUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 163564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv4f32),
     /* 163567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163571 */     GIR_RootConstrainSelectedInstOperands,
     /* 163572 */     // GIR_Coverage, 804,
     /* 163572 */     GIR_EraseRootFromParent_Done,
     /* 163573 */   // Label 3007: @163573
     /* 163573 */   GIM_Try, /*On fail goto*//*Label 3008*/ GIMT_Encode4(163609), // Rule ID 805 //
     /* 163578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 163586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163600 */     // (intrinsic_wo_chain:{ *:[v2i64] } 594:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTAUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 163600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv2f64),
     /* 163603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163607 */     GIR_RootConstrainSelectedInstOperands,
     /* 163608 */     // GIR_Coverage, 805,
     /* 163608 */     GIR_EraseRootFromParent_Done,
     /* 163609 */   // Label 3008: @163609
     /* 163609 */   GIM_Try, /*On fail goto*//*Label 3009*/ GIMT_Encode4(163645), // Rule ID 806 //
     /* 163614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 163622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 163625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 163628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163636 */     // (intrinsic_wo_chain:{ *:[v4i16] } 595:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTMSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 163636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv4f16),
     /* 163639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163643 */     GIR_RootConstrainSelectedInstOperands,
     /* 163644 */     // GIR_Coverage, 806,
     /* 163644 */     GIR_EraseRootFromParent_Done,
     /* 163645 */   // Label 3009: @163645
     /* 163645 */   GIM_Try, /*On fail goto*//*Label 3010*/ GIMT_Encode4(163681), // Rule ID 807 //
     /* 163650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 163658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 163661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 163664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163672 */     // (intrinsic_wo_chain:{ *:[v8i16] } 595:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTMSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 163672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv8f16),
     /* 163675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163679 */     GIR_RootConstrainSelectedInstOperands,
     /* 163680 */     // GIR_Coverage, 807,
     /* 163680 */     GIR_EraseRootFromParent_Done,
     /* 163681 */   // Label 3010: @163681
     /* 163681 */   GIM_Try, /*On fail goto*//*Label 3011*/ GIMT_Encode4(163717), // Rule ID 808 //
     /* 163686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 163694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163708 */     // (intrinsic_wo_chain:{ *:[v2i32] } 595:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTMSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 163708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv2f32),
     /* 163711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163715 */     GIR_RootConstrainSelectedInstOperands,
     /* 163716 */     // GIR_Coverage, 808,
     /* 163716 */     GIR_EraseRootFromParent_Done,
     /* 163717 */   // Label 3011: @163717
     /* 163717 */   GIM_Try, /*On fail goto*//*Label 3012*/ GIMT_Encode4(163753), // Rule ID 809 //
     /* 163722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 163730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163744 */     // (intrinsic_wo_chain:{ *:[v4i32] } 595:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTMSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 163744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv4f32),
     /* 163747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163751 */     GIR_RootConstrainSelectedInstOperands,
     /* 163752 */     // GIR_Coverage, 809,
     /* 163752 */     GIR_EraseRootFromParent_Done,
     /* 163753 */   // Label 3012: @163753
     /* 163753 */   GIM_Try, /*On fail goto*//*Label 3013*/ GIMT_Encode4(163789), // Rule ID 810 //
     /* 163758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 163766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163780 */     // (intrinsic_wo_chain:{ *:[v2i64] } 595:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTMSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 163780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv2f64),
     /* 163783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163787 */     GIR_RootConstrainSelectedInstOperands,
     /* 163788 */     // GIR_Coverage, 810,
     /* 163788 */     GIR_EraseRootFromParent_Done,
     /* 163789 */   // Label 3013: @163789
     /* 163789 */   GIM_Try, /*On fail goto*//*Label 3014*/ GIMT_Encode4(163825), // Rule ID 811 //
     /* 163794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 163802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 163805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 163808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163816 */     // (intrinsic_wo_chain:{ *:[v4i16] } 596:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTMUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 163816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv4f16),
     /* 163819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163823 */     GIR_RootConstrainSelectedInstOperands,
     /* 163824 */     // GIR_Coverage, 811,
     /* 163824 */     GIR_EraseRootFromParent_Done,
     /* 163825 */   // Label 3014: @163825
     /* 163825 */   GIM_Try, /*On fail goto*//*Label 3015*/ GIMT_Encode4(163861), // Rule ID 812 //
     /* 163830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 163838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 163841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 163844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163852 */     // (intrinsic_wo_chain:{ *:[v8i16] } 596:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTMUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 163852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv8f16),
     /* 163855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163859 */     GIR_RootConstrainSelectedInstOperands,
     /* 163860 */     // GIR_Coverage, 812,
     /* 163860 */     GIR_EraseRootFromParent_Done,
     /* 163861 */   // Label 3015: @163861
     /* 163861 */   GIM_Try, /*On fail goto*//*Label 3016*/ GIMT_Encode4(163897), // Rule ID 813 //
     /* 163866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 163874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163888 */     // (intrinsic_wo_chain:{ *:[v2i32] } 596:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTMUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 163888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv2f32),
     /* 163891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163895 */     GIR_RootConstrainSelectedInstOperands,
     /* 163896 */     // GIR_Coverage, 813,
     /* 163896 */     GIR_EraseRootFromParent_Done,
     /* 163897 */   // Label 3016: @163897
     /* 163897 */   GIM_Try, /*On fail goto*//*Label 3017*/ GIMT_Encode4(163933), // Rule ID 814 //
     /* 163902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 163910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163924 */     // (intrinsic_wo_chain:{ *:[v4i32] } 596:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTMUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 163924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv4f32),
     /* 163927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163931 */     GIR_RootConstrainSelectedInstOperands,
     /* 163932 */     // GIR_Coverage, 814,
     /* 163932 */     GIR_EraseRootFromParent_Done,
     /* 163933 */   // Label 3017: @163933
     /* 163933 */   GIM_Try, /*On fail goto*//*Label 3018*/ GIMT_Encode4(163969), // Rule ID 815 //
     /* 163938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 163946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163960 */     // (intrinsic_wo_chain:{ *:[v2i64] } 596:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTMUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 163960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv2f64),
     /* 163963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163967 */     GIR_RootConstrainSelectedInstOperands,
     /* 163968 */     // GIR_Coverage, 815,
     /* 163968 */     GIR_EraseRootFromParent_Done,
     /* 163969 */   // Label 3018: @163969
     /* 163969 */   GIM_Try, /*On fail goto*//*Label 3019*/ GIMT_Encode4(164005), // Rule ID 816 //
     /* 163974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 163982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 163985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 163988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163996 */     // (intrinsic_wo_chain:{ *:[v4i16] } 597:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTNSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 163996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv4f16),
     /* 163999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164003 */     GIR_RootConstrainSelectedInstOperands,
     /* 164004 */     // GIR_Coverage, 816,
     /* 164004 */     GIR_EraseRootFromParent_Done,
     /* 164005 */   // Label 3019: @164005
     /* 164005 */   GIM_Try, /*On fail goto*//*Label 3020*/ GIMT_Encode4(164041), // Rule ID 817 //
     /* 164010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 164018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164032 */     // (intrinsic_wo_chain:{ *:[v8i16] } 597:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 164032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv8f16),
     /* 164035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164039 */     GIR_RootConstrainSelectedInstOperands,
     /* 164040 */     // GIR_Coverage, 817,
     /* 164040 */     GIR_EraseRootFromParent_Done,
     /* 164041 */   // Label 3020: @164041
     /* 164041 */   GIM_Try, /*On fail goto*//*Label 3021*/ GIMT_Encode4(164077), // Rule ID 818 //
     /* 164046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 164054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164068 */     // (intrinsic_wo_chain:{ *:[v2i32] } 597:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTNSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 164068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv2f32),
     /* 164071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164075 */     GIR_RootConstrainSelectedInstOperands,
     /* 164076 */     // GIR_Coverage, 818,
     /* 164076 */     GIR_EraseRootFromParent_Done,
     /* 164077 */   // Label 3021: @164077
     /* 164077 */   GIM_Try, /*On fail goto*//*Label 3022*/ GIMT_Encode4(164113), // Rule ID 819 //
     /* 164082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 164090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164104 */     // (intrinsic_wo_chain:{ *:[v4i32] } 597:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 164104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv4f32),
     /* 164107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164111 */     GIR_RootConstrainSelectedInstOperands,
     /* 164112 */     // GIR_Coverage, 819,
     /* 164112 */     GIR_EraseRootFromParent_Done,
     /* 164113 */   // Label 3022: @164113
     /* 164113 */   GIM_Try, /*On fail goto*//*Label 3023*/ GIMT_Encode4(164149), // Rule ID 820 //
     /* 164118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 164126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164140 */     // (intrinsic_wo_chain:{ *:[v2i64] } 597:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 164140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv2f64),
     /* 164143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164147 */     GIR_RootConstrainSelectedInstOperands,
     /* 164148 */     // GIR_Coverage, 820,
     /* 164148 */     GIR_EraseRootFromParent_Done,
     /* 164149 */   // Label 3023: @164149
     /* 164149 */   GIM_Try, /*On fail goto*//*Label 3024*/ GIMT_Encode4(164185), // Rule ID 821 //
     /* 164154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 164162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 164168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164176 */     // (intrinsic_wo_chain:{ *:[v4i16] } 598:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTNUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 164176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv4f16),
     /* 164179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164183 */     GIR_RootConstrainSelectedInstOperands,
     /* 164184 */     // GIR_Coverage, 821,
     /* 164184 */     GIR_EraseRootFromParent_Done,
     /* 164185 */   // Label 3024: @164185
     /* 164185 */   GIM_Try, /*On fail goto*//*Label 3025*/ GIMT_Encode4(164221), // Rule ID 822 //
     /* 164190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 164198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164212 */     // (intrinsic_wo_chain:{ *:[v8i16] } 598:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 164212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv8f16),
     /* 164215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164219 */     GIR_RootConstrainSelectedInstOperands,
     /* 164220 */     // GIR_Coverage, 822,
     /* 164220 */     GIR_EraseRootFromParent_Done,
     /* 164221 */   // Label 3025: @164221
     /* 164221 */   GIM_Try, /*On fail goto*//*Label 3026*/ GIMT_Encode4(164257), // Rule ID 823 //
     /* 164226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 164234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164248 */     // (intrinsic_wo_chain:{ *:[v2i32] } 598:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTNUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 164248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv2f32),
     /* 164251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164255 */     GIR_RootConstrainSelectedInstOperands,
     /* 164256 */     // GIR_Coverage, 823,
     /* 164256 */     GIR_EraseRootFromParent_Done,
     /* 164257 */   // Label 3026: @164257
     /* 164257 */   GIM_Try, /*On fail goto*//*Label 3027*/ GIMT_Encode4(164293), // Rule ID 824 //
     /* 164262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 164270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164284 */     // (intrinsic_wo_chain:{ *:[v4i32] } 598:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 164284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv4f32),
     /* 164287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164291 */     GIR_RootConstrainSelectedInstOperands,
     /* 164292 */     // GIR_Coverage, 824,
     /* 164292 */     GIR_EraseRootFromParent_Done,
     /* 164293 */   // Label 3027: @164293
     /* 164293 */   GIM_Try, /*On fail goto*//*Label 3028*/ GIMT_Encode4(164329), // Rule ID 825 //
     /* 164298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 164306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164320 */     // (intrinsic_wo_chain:{ *:[v2i64] } 598:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 164320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv2f64),
     /* 164323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164327 */     GIR_RootConstrainSelectedInstOperands,
     /* 164328 */     // GIR_Coverage, 825,
     /* 164328 */     GIR_EraseRootFromParent_Done,
     /* 164329 */   // Label 3028: @164329
     /* 164329 */   GIM_Try, /*On fail goto*//*Label 3029*/ GIMT_Encode4(164365), // Rule ID 826 //
     /* 164334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 164342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 164348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164356 */     // (intrinsic_wo_chain:{ *:[v4i16] } 599:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTPSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 164356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv4f16),
     /* 164359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164363 */     GIR_RootConstrainSelectedInstOperands,
     /* 164364 */     // GIR_Coverage, 826,
     /* 164364 */     GIR_EraseRootFromParent_Done,
     /* 164365 */   // Label 3029: @164365
     /* 164365 */   GIM_Try, /*On fail goto*//*Label 3030*/ GIMT_Encode4(164401), // Rule ID 827 //
     /* 164370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 164378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164392 */     // (intrinsic_wo_chain:{ *:[v8i16] } 599:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTPSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 164392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv8f16),
     /* 164395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164399 */     GIR_RootConstrainSelectedInstOperands,
     /* 164400 */     // GIR_Coverage, 827,
     /* 164400 */     GIR_EraseRootFromParent_Done,
     /* 164401 */   // Label 3030: @164401
     /* 164401 */   GIM_Try, /*On fail goto*//*Label 3031*/ GIMT_Encode4(164437), // Rule ID 828 //
     /* 164406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 164414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164428 */     // (intrinsic_wo_chain:{ *:[v2i32] } 599:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTPSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 164428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv2f32),
     /* 164431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164435 */     GIR_RootConstrainSelectedInstOperands,
     /* 164436 */     // GIR_Coverage, 828,
     /* 164436 */     GIR_EraseRootFromParent_Done,
     /* 164437 */   // Label 3031: @164437
     /* 164437 */   GIM_Try, /*On fail goto*//*Label 3032*/ GIMT_Encode4(164473), // Rule ID 829 //
     /* 164442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 164450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164464 */     // (intrinsic_wo_chain:{ *:[v4i32] } 599:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTPSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 164464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv4f32),
     /* 164467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164471 */     GIR_RootConstrainSelectedInstOperands,
     /* 164472 */     // GIR_Coverage, 829,
     /* 164472 */     GIR_EraseRootFromParent_Done,
     /* 164473 */   // Label 3032: @164473
     /* 164473 */   GIM_Try, /*On fail goto*//*Label 3033*/ GIMT_Encode4(164509), // Rule ID 830 //
     /* 164478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 164486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164500 */     // (intrinsic_wo_chain:{ *:[v2i64] } 599:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTPSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 164500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv2f64),
     /* 164503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164507 */     GIR_RootConstrainSelectedInstOperands,
     /* 164508 */     // GIR_Coverage, 830,
     /* 164508 */     GIR_EraseRootFromParent_Done,
     /* 164509 */   // Label 3033: @164509
     /* 164509 */   GIM_Try, /*On fail goto*//*Label 3034*/ GIMT_Encode4(164545), // Rule ID 831 //
     /* 164514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 164522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 164528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164536 */     // (intrinsic_wo_chain:{ *:[v4i16] } 600:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTPUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 164536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv4f16),
     /* 164539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164543 */     GIR_RootConstrainSelectedInstOperands,
     /* 164544 */     // GIR_Coverage, 831,
     /* 164544 */     GIR_EraseRootFromParent_Done,
     /* 164545 */   // Label 3034: @164545
     /* 164545 */   GIM_Try, /*On fail goto*//*Label 3035*/ GIMT_Encode4(164581), // Rule ID 832 //
     /* 164550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 164558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164572 */     // (intrinsic_wo_chain:{ *:[v8i16] } 600:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTPUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 164572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv8f16),
     /* 164575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164579 */     GIR_RootConstrainSelectedInstOperands,
     /* 164580 */     // GIR_Coverage, 832,
     /* 164580 */     GIR_EraseRootFromParent_Done,
     /* 164581 */   // Label 3035: @164581
     /* 164581 */   GIM_Try, /*On fail goto*//*Label 3036*/ GIMT_Encode4(164617), // Rule ID 833 //
     /* 164586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 164594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164608 */     // (intrinsic_wo_chain:{ *:[v2i32] } 600:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTPUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 164608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv2f32),
     /* 164611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164615 */     GIR_RootConstrainSelectedInstOperands,
     /* 164616 */     // GIR_Coverage, 833,
     /* 164616 */     GIR_EraseRootFromParent_Done,
     /* 164617 */   // Label 3036: @164617
     /* 164617 */   GIM_Try, /*On fail goto*//*Label 3037*/ GIMT_Encode4(164653), // Rule ID 834 //
     /* 164622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 164630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164644 */     // (intrinsic_wo_chain:{ *:[v4i32] } 600:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTPUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 164644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv4f32),
     /* 164647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164651 */     GIR_RootConstrainSelectedInstOperands,
     /* 164652 */     // GIR_Coverage, 834,
     /* 164652 */     GIR_EraseRootFromParent_Done,
     /* 164653 */   // Label 3037: @164653
     /* 164653 */   GIM_Try, /*On fail goto*//*Label 3038*/ GIMT_Encode4(164689), // Rule ID 835 //
     /* 164658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 164666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164680 */     // (intrinsic_wo_chain:{ *:[v2i64] } 600:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTPUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 164680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv2f64),
     /* 164683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164687 */     GIR_RootConstrainSelectedInstOperands,
     /* 164688 */     // GIR_Coverage, 835,
     /* 164688 */     GIR_EraseRootFromParent_Done,
     /* 164689 */   // Label 3038: @164689
     /* 164689 */   GIM_Try, /*On fail goto*//*Label 3039*/ GIMT_Encode4(164725), // Rule ID 836 //
     /* 164694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtxn),
     /* 164702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164716 */     // (intrinsic_wo_chain:{ *:[v2f32] } 601:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTXNv2f32:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)
     /* 164716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv2f32),
     /* 164719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164723 */     GIR_RootConstrainSelectedInstOperands,
     /* 164724 */     // GIR_Coverage, 836,
     /* 164724 */     GIR_EraseRootFromParent_Done,
     /* 164725 */   // Label 3039: @164725
     /* 164725 */   GIM_Try, /*On fail goto*//*Label 3040*/ GIMT_Encode4(164761), // Rule ID 863 //
     /* 164730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 164738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 164744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164752 */     // (intrinsic_wo_chain:{ *:[v4f16] } 642:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FRECPEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 164752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv4f16),
     /* 164755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164759 */     GIR_RootConstrainSelectedInstOperands,
     /* 164760 */     // GIR_Coverage, 863,
     /* 164760 */     GIR_EraseRootFromParent_Done,
     /* 164761 */   // Label 3040: @164761
     /* 164761 */   GIM_Try, /*On fail goto*//*Label 3041*/ GIMT_Encode4(164797), // Rule ID 864 //
     /* 164766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 164774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164788 */     // (intrinsic_wo_chain:{ *:[v8f16] } 642:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FRECPEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 164788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv8f16),
     /* 164791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164795 */     GIR_RootConstrainSelectedInstOperands,
     /* 164796 */     // GIR_Coverage, 864,
     /* 164796 */     GIR_EraseRootFromParent_Done,
     /* 164797 */   // Label 3041: @164797
     /* 164797 */   GIM_Try, /*On fail goto*//*Label 3042*/ GIMT_Encode4(164833), // Rule ID 865 //
     /* 164802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 164810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164824 */     // (intrinsic_wo_chain:{ *:[v2f32] } 642:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRECPEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 164824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv2f32),
     /* 164827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164831 */     GIR_RootConstrainSelectedInstOperands,
     /* 164832 */     // GIR_Coverage, 865,
     /* 164832 */     GIR_EraseRootFromParent_Done,
     /* 164833 */   // Label 3042: @164833
     /* 164833 */   GIM_Try, /*On fail goto*//*Label 3043*/ GIMT_Encode4(164869), // Rule ID 866 //
     /* 164838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 164846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164860 */     // (intrinsic_wo_chain:{ *:[v4f32] } 642:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRECPEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 164860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv4f32),
     /* 164863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164867 */     GIR_RootConstrainSelectedInstOperands,
     /* 164868 */     // GIR_Coverage, 866,
     /* 164868 */     GIR_EraseRootFromParent_Done,
     /* 164869 */   // Label 3043: @164869
     /* 164869 */   GIM_Try, /*On fail goto*//*Label 3044*/ GIMT_Encode4(164905), // Rule ID 867 //
     /* 164874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 164882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164896 */     // (intrinsic_wo_chain:{ *:[v2f64] } 642:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRECPEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 164896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv2f64),
     /* 164899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164903 */     GIR_RootConstrainSelectedInstOperands,
     /* 164904 */     // GIR_Coverage, 867,
     /* 164904 */     GIR_EraseRootFromParent_Done,
     /* 164905 */   // Label 3044: @164905
     /* 164905 */   GIM_Try, /*On fail goto*//*Label 3045*/ GIMT_Encode4(164941), // Rule ID 938 //
     /* 164910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 164913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 164918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164932 */     // (intrinsic_wo_chain:{ *:[v2f32] } 646:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT32Zv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 164932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv2f32),
     /* 164935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164939 */     GIR_RootConstrainSelectedInstOperands,
     /* 164940 */     // GIR_Coverage, 938,
     /* 164940 */     GIR_EraseRootFromParent_Done,
     /* 164941 */   // Label 3045: @164941
     /* 164941 */   GIM_Try, /*On fail goto*//*Label 3046*/ GIMT_Encode4(164977), // Rule ID 939 //
     /* 164946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 164949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 164954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164968 */     // (intrinsic_wo_chain:{ *:[v4f32] } 646:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT32Zv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 164968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv4f32),
     /* 164971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164975 */     GIR_RootConstrainSelectedInstOperands,
     /* 164976 */     // GIR_Coverage, 939,
     /* 164976 */     GIR_EraseRootFromParent_Done,
     /* 164977 */   // Label 3046: @164977
     /* 164977 */   GIM_Try, /*On fail goto*//*Label 3047*/ GIMT_Encode4(165013), // Rule ID 940 //
     /* 164982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 164985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 164990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165004 */     // (intrinsic_wo_chain:{ *:[v2f64] } 646:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT32Zv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 165004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv2f64),
     /* 165007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165011 */     GIR_RootConstrainSelectedInstOperands,
     /* 165012 */     // GIR_Coverage, 940,
     /* 165012 */     GIR_EraseRootFromParent_Done,
     /* 165013 */   // Label 3047: @165013
     /* 165013 */   GIM_Try, /*On fail goto*//*Label 3048*/ GIMT_Encode4(165049), // Rule ID 941 //
     /* 165018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 165021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 165026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 165029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 165032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165040 */     // (intrinsic_wo_chain:{ *:[v2f32] } 648:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT64Zv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 165040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv2f32),
     /* 165043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165047 */     GIR_RootConstrainSelectedInstOperands,
     /* 165048 */     // GIR_Coverage, 941,
     /* 165048 */     GIR_EraseRootFromParent_Done,
     /* 165049 */   // Label 3048: @165049
     /* 165049 */   GIM_Try, /*On fail goto*//*Label 3049*/ GIMT_Encode4(165085), // Rule ID 942 //
     /* 165054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 165057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 165062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 165065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165076 */     // (intrinsic_wo_chain:{ *:[v4f32] } 648:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT64Zv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 165076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv4f32),
     /* 165079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165083 */     GIR_RootConstrainSelectedInstOperands,
     /* 165084 */     // GIR_Coverage, 942,
     /* 165084 */     GIR_EraseRootFromParent_Done,
     /* 165085 */   // Label 3049: @165085
     /* 165085 */   GIM_Try, /*On fail goto*//*Label 3050*/ GIMT_Encode4(165121), // Rule ID 943 //
     /* 165090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 165093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 165098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 165101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 165104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165112 */     // (intrinsic_wo_chain:{ *:[v2f64] } 648:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT64Zv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 165112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv2f64),
     /* 165115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165119 */     GIR_RootConstrainSelectedInstOperands,
     /* 165120 */     // GIR_Coverage, 943,
     /* 165120 */     GIR_EraseRootFromParent_Done,
     /* 165121 */   // Label 3050: @165121
     /* 165121 */   GIM_Try, /*On fail goto*//*Label 3051*/ GIMT_Encode4(165157), // Rule ID 944 //
     /* 165126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 165129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 165134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 165137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 165140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165148 */     // (intrinsic_wo_chain:{ *:[v2f32] } 645:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT32Xv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 165148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv2f32),
     /* 165151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165155 */     GIR_RootConstrainSelectedInstOperands,
     /* 165156 */     // GIR_Coverage, 944,
     /* 165156 */     GIR_EraseRootFromParent_Done,
     /* 165157 */   // Label 3051: @165157
     /* 165157 */   GIM_Try, /*On fail goto*//*Label 3052*/ GIMT_Encode4(165193), // Rule ID 945 //
     /* 165162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 165165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 165170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 165173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165184 */     // (intrinsic_wo_chain:{ *:[v4f32] } 645:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT32Xv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 165184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv4f32),
     /* 165187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165191 */     GIR_RootConstrainSelectedInstOperands,
     /* 165192 */     // GIR_Coverage, 945,
     /* 165192 */     GIR_EraseRootFromParent_Done,
     /* 165193 */   // Label 3052: @165193
     /* 165193 */   GIM_Try, /*On fail goto*//*Label 3053*/ GIMT_Encode4(165229), // Rule ID 946 //
     /* 165198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 165201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 165206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 165209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 165212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165220 */     // (intrinsic_wo_chain:{ *:[v2f64] } 645:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT32Xv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 165220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv2f64),
     /* 165223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165227 */     GIR_RootConstrainSelectedInstOperands,
     /* 165228 */     // GIR_Coverage, 946,
     /* 165228 */     GIR_EraseRootFromParent_Done,
     /* 165229 */   // Label 3053: @165229
     /* 165229 */   GIM_Try, /*On fail goto*//*Label 3054*/ GIMT_Encode4(165265), // Rule ID 947 //
     /* 165234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 165237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 165242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 165245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 165248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165256 */     // (intrinsic_wo_chain:{ *:[v2f32] } 647:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT64Xv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 165256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv2f32),
     /* 165259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165263 */     GIR_RootConstrainSelectedInstOperands,
     /* 165264 */     // GIR_Coverage, 947,
     /* 165264 */     GIR_EraseRootFromParent_Done,
     /* 165265 */   // Label 3054: @165265
     /* 165265 */   GIM_Try, /*On fail goto*//*Label 3055*/ GIMT_Encode4(165301), // Rule ID 948 //
     /* 165270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 165273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 165278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 165281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165292 */     // (intrinsic_wo_chain:{ *:[v4f32] } 647:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT64Xv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 165292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv4f32),
     /* 165295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165299 */     GIR_RootConstrainSelectedInstOperands,
     /* 165300 */     // GIR_Coverage, 948,
     /* 165300 */     GIR_EraseRootFromParent_Done,
     /* 165301 */   // Label 3055: @165301
     /* 165301 */   GIM_Try, /*On fail goto*//*Label 3056*/ GIMT_Encode4(165337), // Rule ID 949 //
     /* 165306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 165309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 165314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 165317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 165320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165328 */     // (intrinsic_wo_chain:{ *:[v2f64] } 647:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT64Xv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 165328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv2f64),
     /* 165331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165335 */     GIR_RootConstrainSelectedInstOperands,
     /* 165336 */     // GIR_Coverage, 949,
     /* 165336 */     GIR_EraseRootFromParent_Done,
     /* 165337 */   // Label 3056: @165337
     /* 165337 */   GIM_Try, /*On fail goto*//*Label 3057*/ GIMT_Encode4(165373), // Rule ID 950 //
     /* 165342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 165350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 165353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 165356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165364 */     // (intrinsic_wo_chain:{ *:[v4f16] } 649:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FRSQRTEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 165364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv4f16),
     /* 165367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165371 */     GIR_RootConstrainSelectedInstOperands,
     /* 165372 */     // GIR_Coverage, 950,
     /* 165372 */     GIR_EraseRootFromParent_Done,
     /* 165373 */   // Label 3057: @165373
     /* 165373 */   GIM_Try, /*On fail goto*//*Label 3058*/ GIMT_Encode4(165409), // Rule ID 951 //
     /* 165378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 165386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 165389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 165392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165400 */     // (intrinsic_wo_chain:{ *:[v8f16] } 649:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FRSQRTEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 165400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv8f16),
     /* 165403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165407 */     GIR_RootConstrainSelectedInstOperands,
     /* 165408 */     // GIR_Coverage, 951,
     /* 165408 */     GIR_EraseRootFromParent_Done,
     /* 165409 */   // Label 3058: @165409
     /* 165409 */   GIM_Try, /*On fail goto*//*Label 3059*/ GIMT_Encode4(165445), // Rule ID 952 //
     /* 165414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 165422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 165425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 165428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165436 */     // (intrinsic_wo_chain:{ *:[v2f32] } 649:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRSQRTEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 165436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv2f32),
     /* 165439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165443 */     GIR_RootConstrainSelectedInstOperands,
     /* 165444 */     // GIR_Coverage, 952,
     /* 165444 */     GIR_EraseRootFromParent_Done,
     /* 165445 */   // Label 3059: @165445
     /* 165445 */   GIM_Try, /*On fail goto*//*Label 3060*/ GIMT_Encode4(165481), // Rule ID 953 //
     /* 165450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 165458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 165461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165472 */     // (intrinsic_wo_chain:{ *:[v4f32] } 649:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRSQRTEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 165472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv4f32),
     /* 165475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165479 */     GIR_RootConstrainSelectedInstOperands,
     /* 165480 */     // GIR_Coverage, 953,
     /* 165480 */     GIR_EraseRootFromParent_Done,
     /* 165481 */   // Label 3060: @165481
     /* 165481 */   GIM_Try, /*On fail goto*//*Label 3061*/ GIMT_Encode4(165517), // Rule ID 954 //
     /* 165486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 165494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 165497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 165500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165508 */     // (intrinsic_wo_chain:{ *:[v2f64] } 649:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRSQRTEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 165508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv2f64),
     /* 165511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165515 */     GIR_RootConstrainSelectedInstOperands,
     /* 165516 */     // GIR_Coverage, 954,
     /* 165516 */     GIR_EraseRootFromParent_Done,
     /* 165517 */   // Label 3061: @165517
     /* 165517 */   GIM_Try, /*On fail goto*//*Label 3062*/ GIMT_Encode4(165553), // Rule ID 1001 //
     /* 165522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 165530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 165533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 165536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165544 */     // (intrinsic_wo_chain:{ *:[v4i16] } 670:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 165544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i8_v4i16),
     /* 165547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165551 */     GIR_RootConstrainSelectedInstOperands,
     /* 165552 */     // GIR_Coverage, 1001,
     /* 165552 */     GIR_EraseRootFromParent_Done,
     /* 165553 */   // Label 3062: @165553
     /* 165553 */   GIM_Try, /*On fail goto*//*Label 3063*/ GIMT_Encode4(165589), // Rule ID 1003 //
     /* 165558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 165566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 165569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 165572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165580 */     // (intrinsic_wo_chain:{ *:[v8i16] } 670:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 165580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv16i8_v8i16),
     /* 165583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165587 */     GIR_RootConstrainSelectedInstOperands,
     /* 165588 */     // GIR_Coverage, 1003,
     /* 165588 */     GIR_EraseRootFromParent_Done,
     /* 165589 */   // Label 3063: @165589
     /* 165589 */   GIM_Try, /*On fail goto*//*Label 3064*/ GIMT_Encode4(165625), // Rule ID 1005 //
     /* 165594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 165602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 165605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 165608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165616 */     // (intrinsic_wo_chain:{ *:[v2i32] } 670:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 165616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i16_v2i32),
     /* 165619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165623 */     GIR_RootConstrainSelectedInstOperands,
     /* 165624 */     // GIR_Coverage, 1005,
     /* 165624 */     GIR_EraseRootFromParent_Done,
     /* 165625 */   // Label 3064: @165625
     /* 165625 */   GIM_Try, /*On fail goto*//*Label 3065*/ GIMT_Encode4(165661), // Rule ID 1007 //
     /* 165630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 165638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 165641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 165644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165652 */     // (intrinsic_wo_chain:{ *:[v4i32] } 670:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 165652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i16_v4i32),
     /* 165655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165659 */     GIR_RootConstrainSelectedInstOperands,
     /* 165660 */     // GIR_Coverage, 1007,
     /* 165660 */     GIR_EraseRootFromParent_Done,
     /* 165661 */   // Label 3065: @165661
     /* 165661 */   GIM_Try, /*On fail goto*//*Label 3066*/ GIMT_Encode4(165697), // Rule ID 1009 //
     /* 165666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 165674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 165677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 165680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165688 */     // (intrinsic_wo_chain:{ *:[v1i64] } 670:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 165688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 165691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165695 */     GIR_RootConstrainSelectedInstOperands,
     /* 165696 */     // GIR_Coverage, 1009,
     /* 165696 */     GIR_EraseRootFromParent_Done,
     /* 165697 */   // Label 3066: @165697
     /* 165697 */   GIM_Try, /*On fail goto*//*Label 3067*/ GIMT_Encode4(165733), // Rule ID 1011 //
     /* 165702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 165710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 165713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165724 */     // (intrinsic_wo_chain:{ *:[v2i64] } 670:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 165724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i32_v2i64),
     /* 165727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165731 */     GIR_RootConstrainSelectedInstOperands,
     /* 165732 */     // GIR_Coverage, 1011,
     /* 165732 */     GIR_EraseRootFromParent_Done,
     /* 165733 */   // Label 3067: @165733
     /* 165733 */   GIM_Try, /*On fail goto*//*Label 3068*/ GIMT_Encode4(165769), // Rule ID 1022 //
     /* 165738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 165746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 165749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 165752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165760 */     // (intrinsic_wo_chain:{ *:[v8i8] } 688:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SQABSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 165760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv8i8),
     /* 165763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165767 */     GIR_RootConstrainSelectedInstOperands,
     /* 165768 */     // GIR_Coverage, 1022,
     /* 165768 */     GIR_EraseRootFromParent_Done,
     /* 165769 */   // Label 3068: @165769
     /* 165769 */   GIM_Try, /*On fail goto*//*Label 3069*/ GIMT_Encode4(165805), // Rule ID 1023 //
     /* 165774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 165782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 165785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 165788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165796 */     // (intrinsic_wo_chain:{ *:[v16i8] } 688:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SQABSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 165796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv16i8),
     /* 165799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165803 */     GIR_RootConstrainSelectedInstOperands,
     /* 165804 */     // GIR_Coverage, 1023,
     /* 165804 */     GIR_EraseRootFromParent_Done,
     /* 165805 */   // Label 3069: @165805
     /* 165805 */   GIM_Try, /*On fail goto*//*Label 3070*/ GIMT_Encode4(165841), // Rule ID 1024 //
     /* 165810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 165818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 165821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 165824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165832 */     // (intrinsic_wo_chain:{ *:[v4i16] } 688:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SQABSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 165832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv4i16),
     /* 165835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165839 */     GIR_RootConstrainSelectedInstOperands,
     /* 165840 */     // GIR_Coverage, 1024,
     /* 165840 */     GIR_EraseRootFromParent_Done,
     /* 165841 */   // Label 3070: @165841
     /* 165841 */   GIM_Try, /*On fail goto*//*Label 3071*/ GIMT_Encode4(165877), // Rule ID 1025 //
     /* 165846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 165854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 165857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 165860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165868 */     // (intrinsic_wo_chain:{ *:[v8i16] } 688:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SQABSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 165868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv8i16),
     /* 165871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165875 */     GIR_RootConstrainSelectedInstOperands,
     /* 165876 */     // GIR_Coverage, 1025,
     /* 165876 */     GIR_EraseRootFromParent_Done,
     /* 165877 */   // Label 3071: @165877
     /* 165877 */   GIM_Try, /*On fail goto*//*Label 3072*/ GIMT_Encode4(165913), // Rule ID 1026 //
     /* 165882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 165890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 165893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 165896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165904 */     // (intrinsic_wo_chain:{ *:[v2i32] } 688:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SQABSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 165904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv2i32),
     /* 165907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165911 */     GIR_RootConstrainSelectedInstOperands,
     /* 165912 */     // GIR_Coverage, 1026,
     /* 165912 */     GIR_EraseRootFromParent_Done,
     /* 165913 */   // Label 3072: @165913
     /* 165913 */   GIM_Try, /*On fail goto*//*Label 3073*/ GIMT_Encode4(165949), // Rule ID 1027 //
     /* 165918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 165926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 165929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165940 */     // (intrinsic_wo_chain:{ *:[v4i32] } 688:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SQABSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 165940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv4i32),
     /* 165943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165947 */     GIR_RootConstrainSelectedInstOperands,
     /* 165948 */     // GIR_Coverage, 1027,
     /* 165948 */     GIR_EraseRootFromParent_Done,
     /* 165949 */   // Label 3073: @165949
     /* 165949 */   GIM_Try, /*On fail goto*//*Label 3074*/ GIMT_Encode4(165985), // Rule ID 1028 //
     /* 165954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 165962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 165965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 165968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165976 */     // (intrinsic_wo_chain:{ *:[v2i64] } 688:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (SQABSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 165976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv2i64),
     /* 165979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165983 */     GIR_RootConstrainSelectedInstOperands,
     /* 165984 */     // GIR_Coverage, 1028,
     /* 165984 */     GIR_EraseRootFromParent_Done,
     /* 165985 */   // Label 3074: @165985
     /* 165985 */   GIM_Try, /*On fail goto*//*Label 3075*/ GIMT_Encode4(166021), // Rule ID 1029 //
     /* 165990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 165998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 166001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 166004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166012 */     // (intrinsic_wo_chain:{ *:[v8i8] } 695:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SQNEGv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 166012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv8i8),
     /* 166015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166019 */     GIR_RootConstrainSelectedInstOperands,
     /* 166020 */     // GIR_Coverage, 1029,
     /* 166020 */     GIR_EraseRootFromParent_Done,
     /* 166021 */   // Label 3075: @166021
     /* 166021 */   GIM_Try, /*On fail goto*//*Label 3076*/ GIMT_Encode4(166057), // Rule ID 1030 //
     /* 166026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 166034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 166037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 166040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166048 */     // (intrinsic_wo_chain:{ *:[v16i8] } 695:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SQNEGv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 166048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv16i8),
     /* 166051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166055 */     GIR_RootConstrainSelectedInstOperands,
     /* 166056 */     // GIR_Coverage, 1030,
     /* 166056 */     GIR_EraseRootFromParent_Done,
     /* 166057 */   // Label 3076: @166057
     /* 166057 */   GIM_Try, /*On fail goto*//*Label 3077*/ GIMT_Encode4(166093), // Rule ID 1031 //
     /* 166062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 166070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 166073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 166076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166084 */     // (intrinsic_wo_chain:{ *:[v4i16] } 695:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SQNEGv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 166084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv4i16),
     /* 166087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166091 */     GIR_RootConstrainSelectedInstOperands,
     /* 166092 */     // GIR_Coverage, 1031,
     /* 166092 */     GIR_EraseRootFromParent_Done,
     /* 166093 */   // Label 3077: @166093
     /* 166093 */   GIM_Try, /*On fail goto*//*Label 3078*/ GIMT_Encode4(166129), // Rule ID 1032 //
     /* 166098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 166106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 166109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 166112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166120 */     // (intrinsic_wo_chain:{ *:[v8i16] } 695:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SQNEGv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 166120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv8i16),
     /* 166123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166127 */     GIR_RootConstrainSelectedInstOperands,
     /* 166128 */     // GIR_Coverage, 1032,
     /* 166128 */     GIR_EraseRootFromParent_Done,
     /* 166129 */   // Label 3078: @166129
     /* 166129 */   GIM_Try, /*On fail goto*//*Label 3079*/ GIMT_Encode4(166165), // Rule ID 1033 //
     /* 166134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 166142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 166145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166156 */     // (intrinsic_wo_chain:{ *:[v2i32] } 695:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SQNEGv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 166156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv2i32),
     /* 166159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166163 */     GIR_RootConstrainSelectedInstOperands,
     /* 166164 */     // GIR_Coverage, 1033,
     /* 166164 */     GIR_EraseRootFromParent_Done,
     /* 166165 */   // Label 3079: @166165
     /* 166165 */   GIM_Try, /*On fail goto*//*Label 3080*/ GIMT_Encode4(166201), // Rule ID 1034 //
     /* 166170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 166178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166192 */     // (intrinsic_wo_chain:{ *:[v4i32] } 695:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SQNEGv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 166192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv4i32),
     /* 166195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166199 */     GIR_RootConstrainSelectedInstOperands,
     /* 166200 */     // GIR_Coverage, 1034,
     /* 166200 */     GIR_EraseRootFromParent_Done,
     /* 166201 */   // Label 3080: @166201
     /* 166201 */   GIM_Try, /*On fail goto*//*Label 3081*/ GIMT_Encode4(166237), // Rule ID 1035 //
     /* 166206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 166214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 166217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 166220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166228 */     // (intrinsic_wo_chain:{ *:[v2i64] } 695:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (SQNEGv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 166228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv2i64),
     /* 166231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166235 */     GIR_RootConstrainSelectedInstOperands,
     /* 166236 */     // GIR_Coverage, 1035,
     /* 166236 */     GIR_EraseRootFromParent_Done,
     /* 166237 */   // Label 3081: @166237
     /* 166237 */   GIM_Try, /*On fail goto*//*Label 3082*/ GIMT_Encode4(166273), // Rule ID 1062 //
     /* 166242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 166250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 166253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 166256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166264 */     // (intrinsic_wo_chain:{ *:[v4i16] } 735:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 166264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i8_v4i16),
     /* 166267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166271 */     GIR_RootConstrainSelectedInstOperands,
     /* 166272 */     // GIR_Coverage, 1062,
     /* 166272 */     GIR_EraseRootFromParent_Done,
     /* 166273 */   // Label 3082: @166273
     /* 166273 */   GIM_Try, /*On fail goto*//*Label 3083*/ GIMT_Encode4(166309), // Rule ID 1064 //
     /* 166278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 166286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 166289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 166292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166300 */     // (intrinsic_wo_chain:{ *:[v8i16] } 735:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 166300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv16i8_v8i16),
     /* 166303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166307 */     GIR_RootConstrainSelectedInstOperands,
     /* 166308 */     // GIR_Coverage, 1064,
     /* 166308 */     GIR_EraseRootFromParent_Done,
     /* 166309 */   // Label 3083: @166309
     /* 166309 */   GIM_Try, /*On fail goto*//*Label 3084*/ GIMT_Encode4(166345), // Rule ID 1066 //
     /* 166314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 166322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 166325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 166328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166336 */     // (intrinsic_wo_chain:{ *:[v2i32] } 735:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 166336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i16_v2i32),
     /* 166339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166343 */     GIR_RootConstrainSelectedInstOperands,
     /* 166344 */     // GIR_Coverage, 1066,
     /* 166344 */     GIR_EraseRootFromParent_Done,
     /* 166345 */   // Label 3084: @166345
     /* 166345 */   GIM_Try, /*On fail goto*//*Label 3085*/ GIMT_Encode4(166381), // Rule ID 1068 //
     /* 166350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 166358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 166364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166372 */     // (intrinsic_wo_chain:{ *:[v4i32] } 735:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 166372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i16_v4i32),
     /* 166375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166379 */     GIR_RootConstrainSelectedInstOperands,
     /* 166380 */     // GIR_Coverage, 1068,
     /* 166380 */     GIR_EraseRootFromParent_Done,
     /* 166381 */   // Label 3085: @166381
     /* 166381 */   GIM_Try, /*On fail goto*//*Label 3086*/ GIMT_Encode4(166417), // Rule ID 1070 //
     /* 166386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 166394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166408 */     // (intrinsic_wo_chain:{ *:[v1i64] } 735:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (UADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 166408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 166411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166415 */     GIR_RootConstrainSelectedInstOperands,
     /* 166416 */     // GIR_Coverage, 1070,
     /* 166416 */     GIR_EraseRootFromParent_Done,
     /* 166417 */   // Label 3086: @166417
     /* 166417 */   GIM_Try, /*On fail goto*//*Label 3087*/ GIMT_Encode4(166453), // Rule ID 1072 //
     /* 166422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 166430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 166433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166444 */     // (intrinsic_wo_chain:{ *:[v2i64] } 735:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (UADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 166444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i32_v2i64),
     /* 166447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166451 */     GIR_RootConstrainSelectedInstOperands,
     /* 166452 */     // GIR_Coverage, 1072,
     /* 166452 */     GIR_EraseRootFromParent_Done,
     /* 166453 */   // Label 3087: @166453
     /* 166453 */   GIM_Try, /*On fail goto*//*Label 3088*/ GIMT_Encode4(166489), // Rule ID 1086 //
     /* 166458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urecpe),
     /* 166466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 166469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166480 */     // (intrinsic_wo_chain:{ *:[v2i32] } 756:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (URECPEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 166480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPEv2i32),
     /* 166483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166487 */     GIR_RootConstrainSelectedInstOperands,
     /* 166488 */     // GIR_Coverage, 1086,
     /* 166488 */     GIR_EraseRootFromParent_Done,
     /* 166489 */   // Label 3088: @166489
     /* 166489 */   GIM_Try, /*On fail goto*//*Label 3089*/ GIMT_Encode4(166525), // Rule ID 1087 //
     /* 166494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urecpe),
     /* 166502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166516 */     // (intrinsic_wo_chain:{ *:[v4i32] } 756:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (URECPEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 166516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPEv4i32),
     /* 166519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166523 */     GIR_RootConstrainSelectedInstOperands,
     /* 166524 */     // GIR_Coverage, 1087,
     /* 166524 */     GIR_EraseRootFromParent_Done,
     /* 166525 */   // Label 3089: @166525
     /* 166525 */   GIM_Try, /*On fail goto*//*Label 3090*/ GIMT_Encode4(166561), // Rule ID 1088 //
     /* 166530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ursqrte),
     /* 166538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 166541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166552 */     // (intrinsic_wo_chain:{ *:[v2i32] } 759:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (URSQRTEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 166552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTEv2i32),
     /* 166555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166559 */     GIR_RootConstrainSelectedInstOperands,
     /* 166560 */     // GIR_Coverage, 1088,
     /* 166560 */     GIR_EraseRootFromParent_Done,
     /* 166561 */   // Label 3090: @166561
     /* 166561 */   GIM_Try, /*On fail goto*//*Label 3091*/ GIMT_Encode4(166597), // Rule ID 1089 //
     /* 166566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ursqrte),
     /* 166574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166588 */     // (intrinsic_wo_chain:{ *:[v4i32] } 759:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (URSQRTEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 166588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTEv4i32),
     /* 166591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166595 */     GIR_RootConstrainSelectedInstOperands,
     /* 166596 */     // GIR_Coverage, 1089,
     /* 166596 */     GIR_EraseRootFromParent_Done,
     /* 166597 */   // Label 3091: @166597
     /* 166597 */   GIM_Try, /*On fail goto*//*Label 3092*/ GIMT_Encode4(166633), // Rule ID 1653 //
     /* 166602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fcvtxn),
     /* 166610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 166613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 166620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166624 */     // (intrinsic_wo_chain:{ *:[f32] } 796:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTXNv1i64:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 166624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv1i64),
     /* 166627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166631 */     GIR_RootConstrainSelectedInstOperands,
     /* 166632 */     // GIR_Coverage, 1653,
     /* 166632 */     GIR_EraseRootFromParent_Done,
     /* 166633 */   // Label 3092: @166633
     /* 166633 */   GIM_Try, /*On fail goto*//*Label 3093*/ GIMT_Encode4(166669), // Rule ID 1659 //
     /* 166638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 166646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166660 */     // (intrinsic_wo_chain:{ *:[i64] } 688:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn)  =>  (SQABSv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 166660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i64),
     /* 166663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166667 */     GIR_RootConstrainSelectedInstOperands,
     /* 166668 */     // GIR_Coverage, 1659,
     /* 166668 */     GIR_EraseRootFromParent_Done,
     /* 166669 */   // Label 3093: @166669
     /* 166669 */   GIM_Try, /*On fail goto*//*Label 3094*/ GIMT_Encode4(166705), // Rule ID 1660 //
     /* 166674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 166682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 166685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 166688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 166692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 166696 */     // (intrinsic_wo_chain:{ *:[i32] } 688:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SQABSv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 166696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i32),
     /* 166699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166703 */     GIR_RootConstrainSelectedInstOperands,
     /* 166704 */     // GIR_Coverage, 1660,
     /* 166704 */     GIR_EraseRootFromParent_Done,
     /* 166705 */   // Label 3094: @166705
     /* 166705 */   GIM_Try, /*On fail goto*//*Label 3095*/ GIMT_Encode4(166741), // Rule ID 1661 //
     /* 166710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 166718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166732 */     // (intrinsic_wo_chain:{ *:[i64] } 695:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn)  =>  (SQNEGv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 166732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i64),
     /* 166735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166739 */     GIR_RootConstrainSelectedInstOperands,
     /* 166740 */     // GIR_Coverage, 1661,
     /* 166740 */     GIR_EraseRootFromParent_Done,
     /* 166741 */   // Label 3095: @166741
     /* 166741 */   GIM_Try, /*On fail goto*//*Label 3096*/ GIMT_Encode4(166777), // Rule ID 1662 //
     /* 166746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 166754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 166757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 166760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 166764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 166768 */     // (intrinsic_wo_chain:{ *:[i32] } 695:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SQNEGv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 166768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i32),
     /* 166771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166775 */     GIR_RootConstrainSelectedInstOperands,
     /* 166776 */     // GIR_Coverage, 1662,
     /* 166776 */     GIR_EraseRootFromParent_Done,
     /* 166777 */   // Label 3096: @166777
     /* 166777 */   GIM_Try, /*On fail goto*//*Label 3097*/ GIMT_Encode4(166813), // Rule ID 1663 //
     /* 166782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_sqxtn),
     /* 166790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 166793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 166800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166804 */     // (intrinsic_wo_chain:{ *:[f32] } 673:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (SQXTNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 166804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNv1i32),
     /* 166807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166811 */     GIR_RootConstrainSelectedInstOperands,
     /* 166812 */     // GIR_Coverage, 1663,
     /* 166812 */     GIR_EraseRootFromParent_Done,
     /* 166813 */   // Label 3097: @166813
     /* 166813 */   GIM_Try, /*On fail goto*//*Label 3098*/ GIMT_Encode4(166849), // Rule ID 1664 //
     /* 166818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_sqxtun),
     /* 166826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 166829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 166836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166840 */     // (intrinsic_wo_chain:{ *:[f32] } 674:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (SQXTUNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 166840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNv1i32),
     /* 166843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166847 */     GIR_RootConstrainSelectedInstOperands,
     /* 166848 */     // GIR_Coverage, 1664,
     /* 166848 */     GIR_EraseRootFromParent_Done,
     /* 166849 */   // Label 3098: @166849
     /* 166849 */   GIM_Try, /*On fail goto*//*Label 3099*/ GIMT_Encode4(166885), // Rule ID 1670 //
     /* 166854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_uqxtn),
     /* 166862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 166865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 166872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166876 */     // (intrinsic_wo_chain:{ *:[f32] } 675:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (UQXTNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 166876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNv1i32),
     /* 166879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166883 */     GIR_RootConstrainSelectedInstOperands,
     /* 166884 */     // GIR_Coverage, 1670,
     /* 166884 */     GIR_EraseRootFromParent_Done,
     /* 166885 */   // Label 3099: @166885
     /* 166885 */   GIM_Try, /*On fail goto*//*Label 3100*/ GIMT_Encode4(166921), // Rule ID 1943 //
     /* 166890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 166893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 166898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 166901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 166904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 166908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166912 */     // (intrinsic_wo_chain:{ *:[f16] } 607:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMAXNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 166912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i16v),
     /* 166915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166919 */     GIR_RootConstrainSelectedInstOperands,
     /* 166920 */     // GIR_Coverage, 1943,
     /* 166920 */     GIR_EraseRootFromParent_Done,
     /* 166921 */   // Label 3100: @166921
     /* 166921 */   GIM_Try, /*On fail goto*//*Label 3101*/ GIMT_Encode4(166957), // Rule ID 1945 //
     /* 166926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 166929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 166934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 166937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 166940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 166944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166948 */     // (intrinsic_wo_chain:{ *:[f16] } 607:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMAXNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 166948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv8i16v),
     /* 166951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166955 */     GIR_RootConstrainSelectedInstOperands,
     /* 166956 */     // GIR_Coverage, 1945,
     /* 166956 */     GIR_EraseRootFromParent_Done,
     /* 166957 */   // Label 3101: @166957
     /* 166957 */   GIM_Try, /*On fail goto*//*Label 3102*/ GIMT_Encode4(166993), // Rule ID 1947 //
     /* 166962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 166970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 166973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 166980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166984 */     // (intrinsic_wo_chain:{ *:[f32] } 607:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMAXNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 166984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i32v),
     /* 166987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166991 */     GIR_RootConstrainSelectedInstOperands,
     /* 166992 */     // GIR_Coverage, 1947,
     /* 166992 */     GIR_EraseRootFromParent_Done,
     /* 166993 */   // Label 3102: @166993
     /* 166993 */   GIM_Try, /*On fail goto*//*Label 3103*/ GIMT_Encode4(167029), // Rule ID 1949 //
     /* 166998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 167001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 167006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 167009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 167012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167020 */     // (intrinsic_wo_chain:{ *:[f16] } 609:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMAXVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 167020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i16v),
     /* 167023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167027 */     GIR_RootConstrainSelectedInstOperands,
     /* 167028 */     // GIR_Coverage, 1949,
     /* 167028 */     GIR_EraseRootFromParent_Done,
     /* 167029 */   // Label 3103: @167029
     /* 167029 */   GIM_Try, /*On fail goto*//*Label 3104*/ GIMT_Encode4(167065), // Rule ID 1951 //
     /* 167034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 167037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 167042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 167045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 167048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167056 */     // (intrinsic_wo_chain:{ *:[f16] } 609:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMAXVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 167056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv8i16v),
     /* 167059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167063 */     GIR_RootConstrainSelectedInstOperands,
     /* 167064 */     // GIR_Coverage, 1951,
     /* 167064 */     GIR_EraseRootFromParent_Done,
     /* 167065 */   // Label 3104: @167065
     /* 167065 */   GIM_Try, /*On fail goto*//*Label 3105*/ GIMT_Encode4(167101), // Rule ID 1953 //
     /* 167070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 167078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 167084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167092 */     // (intrinsic_wo_chain:{ *:[f32] } 609:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMAXVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 167092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i32v),
     /* 167095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167099 */     GIR_RootConstrainSelectedInstOperands,
     /* 167100 */     // GIR_Coverage, 1953,
     /* 167100 */     GIR_EraseRootFromParent_Done,
     /* 167101 */   // Label 3105: @167101
     /* 167101 */   GIM_Try, /*On fail goto*//*Label 3106*/ GIMT_Encode4(167137), // Rule ID 1955 //
     /* 167106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 167109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 167114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 167117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 167120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167128 */     // (intrinsic_wo_chain:{ *:[f16] } 613:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 167128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i16v),
     /* 167131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167135 */     GIR_RootConstrainSelectedInstOperands,
     /* 167136 */     // GIR_Coverage, 1955,
     /* 167136 */     GIR_EraseRootFromParent_Done,
     /* 167137 */   // Label 3106: @167137
     /* 167137 */   GIM_Try, /*On fail goto*//*Label 3107*/ GIMT_Encode4(167173), // Rule ID 1957 //
     /* 167142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 167145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 167150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 167153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 167156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167164 */     // (intrinsic_wo_chain:{ *:[f16] } 613:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 167164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv8i16v),
     /* 167167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167171 */     GIR_RootConstrainSelectedInstOperands,
     /* 167172 */     // GIR_Coverage, 1957,
     /* 167172 */     GIR_EraseRootFromParent_Done,
     /* 167173 */   // Label 3107: @167173
     /* 167173 */   GIM_Try, /*On fail goto*//*Label 3108*/ GIMT_Encode4(167209), // Rule ID 1959 //
     /* 167178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 167186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 167192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167200 */     // (intrinsic_wo_chain:{ *:[f32] } 613:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 167200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i32v),
     /* 167203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167207 */     GIR_RootConstrainSelectedInstOperands,
     /* 167208 */     // GIR_Coverage, 1959,
     /* 167208 */     GIR_EraseRootFromParent_Done,
     /* 167209 */   // Label 3108: @167209
     /* 167209 */   GIM_Try, /*On fail goto*//*Label 3109*/ GIMT_Encode4(167245), // Rule ID 1961 //
     /* 167214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 167217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 167222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 167225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 167228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167236 */     // (intrinsic_wo_chain:{ *:[f16] } 615:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMINVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 167236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i16v),
     /* 167239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167243 */     GIR_RootConstrainSelectedInstOperands,
     /* 167244 */     // GIR_Coverage, 1961,
     /* 167244 */     GIR_EraseRootFromParent_Done,
     /* 167245 */   // Label 3109: @167245
     /* 167245 */   GIM_Try, /*On fail goto*//*Label 3110*/ GIMT_Encode4(167281), // Rule ID 1963 //
     /* 167250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 167253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 167258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 167261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 167264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167272 */     // (intrinsic_wo_chain:{ *:[f16] } 615:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMINVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 167272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv8i16v),
     /* 167275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167279 */     GIR_RootConstrainSelectedInstOperands,
     /* 167280 */     // GIR_Coverage, 1963,
     /* 167280 */     GIR_EraseRootFromParent_Done,
     /* 167281 */   // Label 3110: @167281
     /* 167281 */   GIM_Try, /*On fail goto*//*Label 3111*/ GIMT_Encode4(167317), // Rule ID 1965 //
     /* 167286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 167294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 167300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167308 */     // (intrinsic_wo_chain:{ *:[f32] } 615:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMINVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 167308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i32v),
     /* 167311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167315 */     GIR_RootConstrainSelectedInstOperands,
     /* 167316 */     // GIR_Coverage, 1965,
     /* 167316 */     GIR_EraseRootFromParent_Done,
     /* 167317 */   // Label 3111: @167317
     /* 167317 */   GIM_Try, /*On fail goto*//*Label 3112*/ GIMT_Encode4(167353), // Rule ID 2305 //
     /* 167322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 167325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesmc),
     /* 167330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 167333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 167336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167344 */     // (intrinsic_wo_chain:{ *:[v16i8] } 524:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (AESMCrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 167344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMCrr),
     /* 167347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167351 */     GIR_RootConstrainSelectedInstOperands,
     /* 167352 */     // GIR_Coverage, 2305,
     /* 167352 */     GIR_EraseRootFromParent_Done,
     /* 167353 */   // Label 3112: @167353
     /* 167353 */   GIM_Try, /*On fail goto*//*Label 3113*/ GIMT_Encode4(167389), // Rule ID 2306 //
     /* 167358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 167361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesimc),
     /* 167366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 167369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 167372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167380 */     // (intrinsic_wo_chain:{ *:[v16i8] } 523:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (AESIMCrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 167380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMCrr),
     /* 167383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167387 */     GIR_RootConstrainSelectedInstOperands,
     /* 167388 */     // GIR_Coverage, 2306,
     /* 167388 */     GIR_EraseRootFromParent_Done,
     /* 167389 */   // Label 3113: @167389
     /* 167389 */   GIM_Try, /*On fail goto*//*Label 3114*/ GIMT_Encode4(167425), // Rule ID 2314 //
     /* 167394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 167397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1h),
     /* 167402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167416 */     // (intrinsic_wo_chain:{ *:[i32] } 531:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SHA1Hrr:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 167416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Hrr),
     /* 167419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167423 */     GIR_RootConstrainSelectedInstOperands,
     /* 167424 */     // GIR_Coverage, 2314,
     /* 167424 */     GIR_EraseRootFromParent_Done,
     /* 167425 */   // Label 3114: @167425
     /* 167425 */   GIM_Try, /*On fail goto*//*Label 3115*/ GIMT_Encode4(167461), // Rule ID 2511 //
     /* 167430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 167438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 167444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167452 */     // (intrinsic_wo_chain:{ *:[v1i64] } 688:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (SQABSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 167452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i64),
     /* 167455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167459 */     GIR_RootConstrainSelectedInstOperands,
     /* 167460 */     // GIR_Coverage, 2511,
     /* 167460 */     GIR_EraseRootFromParent_Done,
     /* 167461 */   // Label 3115: @167461
     /* 167461 */   GIM_Try, /*On fail goto*//*Label 3116*/ GIMT_Encode4(167500), // Rule ID 3567 //
     /* 167466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 167469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 167474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 167477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 167480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 167484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167488 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1637:{ *:[iPTR] }, ZPRAny:{ *:[nxv16i8] }:$Zn)  =>  (PMOV_PZI_B:{ *:[nxv16i1] } ZPRAny:{ *:[nxv16i8] }:$Zn, 0:{ *:[i32] })
     /* 167488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_B),
     /* 167491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 167493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 167495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167498 */     GIR_RootConstrainSelectedInstOperands,
     /* 167499 */     // GIR_Coverage, 3567,
     /* 167499 */     GIR_EraseRootFromParent_Done,
     /* 167500 */   // Label 3116: @167500
     /* 167500 */   GIM_Try, /*On fail goto*//*Label 3117*/ GIMT_Encode4(167539), // Rule ID 3568 //
     /* 167505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 167508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 167513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 167516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 167519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 167523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167527 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1637:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zn)  =>  (PMOV_PZI_H:{ *:[nxv8i1] } ZPRAny:{ *:[nxv8i16] }:$Zn, 0:{ *:[i32] })
     /* 167527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_H),
     /* 167530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 167532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 167534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167537 */     GIR_RootConstrainSelectedInstOperands,
     /* 167538 */     // GIR_Coverage, 3568,
     /* 167538 */     GIR_EraseRootFromParent_Done,
     /* 167539 */   // Label 3117: @167539
     /* 167539 */   GIM_Try, /*On fail goto*//*Label 3118*/ GIMT_Encode4(167578), // Rule ID 3569 //
     /* 167544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 167547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 167552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 167555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 167558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 167562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167566 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1637:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zn)  =>  (PMOV_PZI_S:{ *:[nxv4i1] } ZPRAny:{ *:[nxv4i32] }:$Zn, 0:{ *:[i32] })
     /* 167566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_S),
     /* 167569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 167571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 167573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167576 */     GIR_RootConstrainSelectedInstOperands,
     /* 167577 */     // GIR_Coverage, 3569,
     /* 167577 */     GIR_EraseRootFromParent_Done,
     /* 167578 */   // Label 3118: @167578
     /* 167578 */   GIM_Try, /*On fail goto*//*Label 3119*/ GIMT_Encode4(167617), // Rule ID 3570 //
     /* 167583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 167586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 167591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 167594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 167597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 167601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167605 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1637:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zn)  =>  (PMOV_PZI_D:{ *:[nxv2i1] } ZPRAny:{ *:[nxv2i64] }:$Zn, 0:{ *:[i32] })
     /* 167605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_D),
     /* 167608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 167610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 167612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167615 */     GIR_RootConstrainSelectedInstOperands,
     /* 167616 */     // GIR_Coverage, 3570,
     /* 167616 */     GIR_EraseRootFromParent_Done,
     /* 167617 */   // Label 3119: @167617
     /* 167617 */   GIM_Try, /*On fail goto*//*Label 3120*/ GIMT_Encode4(167673), // Rule ID 3574 //
     /* 167622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 167625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 167630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 167633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 167636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 167644 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1639:{ *:[iPTR] }, PPR8:{ *:[nxv16i1] }:$Pn)  =>  (PMOV_ZIP_B:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i64] }, PPR8:{ *:[nxv16i1] }:$Pn)
     /* 167644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 167647 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 167651 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167656 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 167658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_B),
     /* 167661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167663 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 167671 */     GIR_RootConstrainSelectedInstOperands,
     /* 167672 */     // GIR_Coverage, 3574,
     /* 167672 */     GIR_EraseRootFromParent_Done,
     /* 167673 */   // Label 3120: @167673
     /* 167673 */   GIM_Try, /*On fail goto*//*Label 3121*/ GIMT_Encode4(167729), // Rule ID 3575 //
     /* 167678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 167681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 167686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 167689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 167692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 167700 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1639:{ *:[iPTR] }, PPR16:{ *:[nxv8i1] }:$Pn)  =>  (PMOV_ZIP_H:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR16:{ *:[nxv8i1] }:$Pn)
     /* 167700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 167703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 167707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 167714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_H),
     /* 167717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167719 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 167727 */     GIR_RootConstrainSelectedInstOperands,
     /* 167728 */     // GIR_Coverage, 3575,
     /* 167728 */     GIR_EraseRootFromParent_Done,
     /* 167729 */   // Label 3121: @167729
     /* 167729 */   GIM_Try, /*On fail goto*//*Label 3122*/ GIMT_Encode4(167785), // Rule ID 3576 //
     /* 167734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 167737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 167742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 167745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 167748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 167756 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1639:{ *:[iPTR] }, PPR32:{ *:[nxv4i1] }:$Pn)  =>  (PMOV_ZIP_S:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR32:{ *:[nxv4i1] }:$Pn)
     /* 167756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 167759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 167763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 167770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_S),
     /* 167773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 167783 */     GIR_RootConstrainSelectedInstOperands,
     /* 167784 */     // GIR_Coverage, 3576,
     /* 167784 */     GIR_EraseRootFromParent_Done,
     /* 167785 */   // Label 3122: @167785
     /* 167785 */   GIM_Try, /*On fail goto*//*Label 3123*/ GIMT_Encode4(167841), // Rule ID 3577 //
     /* 167790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 167793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 167798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 167801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 167804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 167812 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1639:{ *:[iPTR] }, PPR64:{ *:[nxv2i1] }:$Pn)  =>  (PMOV_ZIP_D:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR64:{ *:[nxv2i1] }:$Pn)
     /* 167812 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 167815 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 167819 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167824 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 167826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_D),
     /* 167829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167831 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 167839 */     GIR_RootConstrainSelectedInstOperands,
     /* 167840 */     // GIR_Coverage, 3577,
     /* 167840 */     GIR_EraseRootFromParent_Done,
     /* 167841 */   // Label 3123: @167841
     /* 167841 */   GIM_Try, /*On fail goto*//*Label 3124*/ GIMT_Encode4(167874), // Rule ID 4034 //
     /* 167846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_cls),
     /* 167851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167865 */     // (intrinsic_wo_chain:{ *:[i32] } 511:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn)  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 167865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 167868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167872 */     GIR_RootConstrainSelectedInstOperands,
     /* 167873 */     // GIR_Coverage, 4034,
     /* 167873 */     GIR_EraseRootFromParent_Done,
     /* 167874 */   // Label 3124: @167874
     /* 167874 */   GIM_Try, /*On fail goto*//*Label 3125*/ GIMT_Encode4(167939), // Rule ID 4035 //
     /* 167879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_cls64),
     /* 167884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 167890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 167898 */     // (intrinsic_wo_chain:{ *:[i32] } 512:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rm)  =>  (EXTRACT_SUBREG:{ *:[i32] } (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rm), sub_32:{ *:[i32] })
     /* 167898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 167901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 167905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167910 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 167914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 167916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 167919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167921 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /* 167928 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167933 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 167938 */     // GIR_Coverage, 4035,
     /* 167938 */     GIR_EraseRootFromParent_Done,
     /* 167939 */   // Label 3125: @167939
     /* 167939 */   GIM_Try, /*On fail goto*//*Label 3126*/ GIMT_Encode4(167972), // Rule ID 4841 //
     /* 167944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 167949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 167955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167963 */     // (intrinsic_wo_chain:{ *:[v1f64] } 646:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT32ZDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 167963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZDr),
     /* 167966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167970 */     GIR_RootConstrainSelectedInstOperands,
     /* 167971 */     // GIR_Coverage, 4841,
     /* 167971 */     GIR_EraseRootFromParent_Done,
     /* 167972 */   // Label 3126: @167972
     /* 167972 */   GIM_Try, /*On fail goto*//*Label 3127*/ GIMT_Encode4(168005), // Rule ID 4842 //
     /* 167977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 167982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 167988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167996 */     // (intrinsic_wo_chain:{ *:[v1f64] } 648:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT64ZDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 167996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZDr),
     /* 167999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168003 */     GIR_RootConstrainSelectedInstOperands,
     /* 168004 */     // GIR_Coverage, 4842,
     /* 168004 */     GIR_EraseRootFromParent_Done,
     /* 168005 */   // Label 3127: @168005
     /* 168005 */   GIM_Try, /*On fail goto*//*Label 3128*/ GIMT_Encode4(168038), // Rule ID 4843 //
     /* 168010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 168015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168029 */     // (intrinsic_wo_chain:{ *:[v1f64] } 645:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT32XDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XDr),
     /* 168032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168036 */     GIR_RootConstrainSelectedInstOperands,
     /* 168037 */     // GIR_Coverage, 4843,
     /* 168037 */     GIR_EraseRootFromParent_Done,
     /* 168038 */   // Label 3128: @168038
     /* 168038 */   GIM_Try, /*On fail goto*//*Label 3129*/ GIMT_Encode4(168071), // Rule ID 4844 //
     /* 168043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 168048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168062 */     // (intrinsic_wo_chain:{ *:[v1f64] } 647:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT64XDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XDr),
     /* 168065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168069 */     GIR_RootConstrainSelectedInstOperands,
     /* 168070 */     // GIR_Coverage, 4844,
     /* 168070 */     GIR_EraseRootFromParent_Done,
     /* 168071 */   // Label 3129: @168071
     /* 168071 */   GIM_Try, /*On fail goto*//*Label 3130*/ GIMT_Encode4(168104), // Rule ID 4958 //
     /* 168076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvthf2fp),
     /* 168081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 168084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168095 */     // (intrinsic_wo_chain:{ *:[v4f32] } 777:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (FCVTLv4i16:{ *:[v4f32] } V64:{ *:[v4i16] }:$Rn)
     /* 168095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 168098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168102 */     GIR_RootConstrainSelectedInstOperands,
     /* 168103 */     // GIR_Coverage, 4958,
     /* 168103 */     GIR_EraseRootFromParent_Done,
     /* 168104 */   // Label 3130: @168104
     /* 168104 */   GIM_Try, /*On fail goto*//*Label 3131*/ GIMT_Encode4(168137), // Rule ID 4968 //
     /* 168109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2hf),
     /* 168114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 168117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168128 */     // (intrinsic_wo_chain:{ *:[v4i16] } 774:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNv4i16:{ *:[v4i16] } V128:{ *:[v4f32] }:$Rn)
     /* 168128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 168131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168135 */     GIR_RootConstrainSelectedInstOperands,
     /* 168136 */     // GIR_Coverage, 4968,
     /* 168136 */     GIR_EraseRootFromParent_Done,
     /* 168137 */   // Label 3131: @168137
     /* 168137 */   GIM_Try, /*On fail goto*//*Label 3132*/ GIMT_Encode4(168173), // Rule ID 5289 //
     /* 168142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 168150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168164 */     // (intrinsic_wo_chain:{ *:[v1i64] } 695:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (SQNEGv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 168164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i64),
     /* 168167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168171 */     GIR_RootConstrainSelectedInstOperands,
     /* 168172 */     // GIR_Coverage, 5289,
     /* 168172 */     GIR_EraseRootFromParent_Done,
     /* 168173 */   // Label 3132: @168173
     /* 168173 */   GIM_Try, /*On fail goto*//*Label 3133*/ GIMT_Encode4(168206), // Rule ID 5292 //
     /* 168178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 168183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168197 */     // (intrinsic_wo_chain:{ *:[v1i64] } 593:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTASv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv1i64),
     /* 168200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168204 */     GIR_RootConstrainSelectedInstOperands,
     /* 168205 */     // GIR_Coverage, 5292,
     /* 168205 */     GIR_EraseRootFromParent_Done,
     /* 168206 */   // Label 3133: @168206
     /* 168206 */   GIM_Try, /*On fail goto*//*Label 3134*/ GIMT_Encode4(168239), // Rule ID 5293 //
     /* 168211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 168216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168230 */     // (intrinsic_wo_chain:{ *:[v1i64] } 594:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTAUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv1i64),
     /* 168233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168237 */     GIR_RootConstrainSelectedInstOperands,
     /* 168238 */     // GIR_Coverage, 5293,
     /* 168238 */     GIR_EraseRootFromParent_Done,
     /* 168239 */   // Label 3134: @168239
     /* 168239 */   GIM_Try, /*On fail goto*//*Label 3135*/ GIMT_Encode4(168272), // Rule ID 5294 //
     /* 168244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 168249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168263 */     // (intrinsic_wo_chain:{ *:[v1i64] } 595:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTMSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv1i64),
     /* 168266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168270 */     GIR_RootConstrainSelectedInstOperands,
     /* 168271 */     // GIR_Coverage, 5294,
     /* 168271 */     GIR_EraseRootFromParent_Done,
     /* 168272 */   // Label 3135: @168272
     /* 168272 */   GIM_Try, /*On fail goto*//*Label 3136*/ GIMT_Encode4(168305), // Rule ID 5295 //
     /* 168277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 168282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168296 */     // (intrinsic_wo_chain:{ *:[v1i64] } 596:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTMUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv1i64),
     /* 168299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168303 */     GIR_RootConstrainSelectedInstOperands,
     /* 168304 */     // GIR_Coverage, 5295,
     /* 168304 */     GIR_EraseRootFromParent_Done,
     /* 168305 */   // Label 3136: @168305
     /* 168305 */   GIM_Try, /*On fail goto*//*Label 3137*/ GIMT_Encode4(168338), // Rule ID 5296 //
     /* 168310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 168315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168329 */     // (intrinsic_wo_chain:{ *:[v1i64] } 597:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTNSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv1i64),
     /* 168332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168336 */     GIR_RootConstrainSelectedInstOperands,
     /* 168337 */     // GIR_Coverage, 5296,
     /* 168337 */     GIR_EraseRootFromParent_Done,
     /* 168338 */   // Label 3137: @168338
     /* 168338 */   GIM_Try, /*On fail goto*//*Label 3138*/ GIMT_Encode4(168371), // Rule ID 5297 //
     /* 168343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 168348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168362 */     // (intrinsic_wo_chain:{ *:[v1i64] } 598:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTNUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv1i64),
     /* 168365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168369 */     GIR_RootConstrainSelectedInstOperands,
     /* 168370 */     // GIR_Coverage, 5297,
     /* 168370 */     GIR_EraseRootFromParent_Done,
     /* 168371 */   // Label 3138: @168371
     /* 168371 */   GIM_Try, /*On fail goto*//*Label 3139*/ GIMT_Encode4(168404), // Rule ID 5298 //
     /* 168376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 168381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168395 */     // (intrinsic_wo_chain:{ *:[v1i64] } 599:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTPSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv1i64),
     /* 168398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168402 */     GIR_RootConstrainSelectedInstOperands,
     /* 168403 */     // GIR_Coverage, 5298,
     /* 168403 */     GIR_EraseRootFromParent_Done,
     /* 168404 */   // Label 3139: @168404
     /* 168404 */   GIM_Try, /*On fail goto*//*Label 3140*/ GIMT_Encode4(168437), // Rule ID 5299 //
     /* 168409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 168414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168428 */     // (intrinsic_wo_chain:{ *:[v1i64] } 600:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTPUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv1i64),
     /* 168431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168435 */     GIR_RootConstrainSelectedInstOperands,
     /* 168436 */     // GIR_Coverage, 5299,
     /* 168436 */     GIR_EraseRootFromParent_Done,
     /* 168437 */   // Label 3140: @168437
     /* 168437 */   GIM_Try, /*On fail goto*//*Label 3141*/ GIMT_Encode4(168470), // Rule ID 5300 //
     /* 168442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 168447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168461 */     // (intrinsic_wo_chain:{ *:[v1i64] } 602:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTZSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i64),
     /* 168464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168466 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168468 */     GIR_RootConstrainSelectedInstOperands,
     /* 168469 */     // GIR_Coverage, 5300,
     /* 168469 */     GIR_EraseRootFromParent_Done,
     /* 168470 */   // Label 3141: @168470
     /* 168470 */   GIM_Try, /*On fail goto*//*Label 3142*/ GIMT_Encode4(168503), // Rule ID 5301 //
     /* 168475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 168480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168494 */     // (intrinsic_wo_chain:{ *:[v1i64] } 603:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTZUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i64),
     /* 168497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168501 */     GIR_RootConstrainSelectedInstOperands,
     /* 168502 */     // GIR_Coverage, 5301,
     /* 168502 */     GIR_EraseRootFromParent_Done,
     /* 168503 */   // Label 3142: @168503
     /* 168503 */   GIM_Try, /*On fail goto*//*Label 3143*/ GIMT_Encode4(168536), // Rule ID 5302 //
     /* 168508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 168513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 168516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 168519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 168523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 168527 */     // (intrinsic_wo_chain:{ *:[f16] } 642:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRECPEv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 168527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1f16),
     /* 168530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168534 */     GIR_RootConstrainSelectedInstOperands,
     /* 168535 */     // GIR_Coverage, 5302,
     /* 168535 */     GIR_EraseRootFromParent_Done,
     /* 168536 */   // Label 3143: @168536
     /* 168536 */   GIM_Try, /*On fail goto*//*Label 3144*/ GIMT_Encode4(168569), // Rule ID 5303 //
     /* 168541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 168546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 168549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 168552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168560 */     // (intrinsic_wo_chain:{ *:[f32] } 642:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRECPEv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 168560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i32),
     /* 168563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168567 */     GIR_RootConstrainSelectedInstOperands,
     /* 168568 */     // GIR_Coverage, 5303,
     /* 168568 */     GIR_EraseRootFromParent_Done,
     /* 168569 */   // Label 3144: @168569
     /* 168569 */   GIM_Try, /*On fail goto*//*Label 3145*/ GIMT_Encode4(168602), // Rule ID 5304 //
     /* 168574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 168579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168593 */     // (intrinsic_wo_chain:{ *:[f64] } 642:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRECPEv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 168593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i64),
     /* 168596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168600 */     GIR_RootConstrainSelectedInstOperands,
     /* 168601 */     // GIR_Coverage, 5304,
     /* 168601 */     GIR_EraseRootFromParent_Done,
     /* 168602 */   // Label 3145: @168602
     /* 168602 */   GIM_Try, /*On fail goto*//*Label 3146*/ GIMT_Encode4(168635), // Rule ID 5305 //
     /* 168607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 168612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168626 */     // (intrinsic_wo_chain:{ *:[v1f64] } 642:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRECPEv1i64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i64),
     /* 168629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168633 */     GIR_RootConstrainSelectedInstOperands,
     /* 168634 */     // GIR_Coverage, 5305,
     /* 168634 */     GIR_EraseRootFromParent_Done,
     /* 168635 */   // Label 3146: @168635
     /* 168635 */   GIM_Try, /*On fail goto*//*Label 3147*/ GIMT_Encode4(168668), // Rule ID 5317 //
     /* 168640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 168645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 168648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 168651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 168655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 168659 */     // (intrinsic_wo_chain:{ *:[f16] } 644:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRECPXv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 168659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1f16),
     /* 168662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168666 */     GIR_RootConstrainSelectedInstOperands,
     /* 168667 */     // GIR_Coverage, 5317,
     /* 168667 */     GIR_EraseRootFromParent_Done,
     /* 168668 */   // Label 3147: @168668
     /* 168668 */   GIM_Try, /*On fail goto*//*Label 3148*/ GIMT_Encode4(168701), // Rule ID 5318 //
     /* 168673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 168678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 168681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 168684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168692 */     // (intrinsic_wo_chain:{ *:[f32] } 644:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRECPXv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 168692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1i32),
     /* 168695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168699 */     GIR_RootConstrainSelectedInstOperands,
     /* 168700 */     // GIR_Coverage, 5318,
     /* 168700 */     GIR_EraseRootFromParent_Done,
     /* 168701 */   // Label 3148: @168701
     /* 168701 */   GIM_Try, /*On fail goto*//*Label 3149*/ GIMT_Encode4(168734), // Rule ID 5319 //
     /* 168706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 168711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168725 */     // (intrinsic_wo_chain:{ *:[f64] } 644:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRECPXv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 168725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1i64),
     /* 168728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168732 */     GIR_RootConstrainSelectedInstOperands,
     /* 168733 */     // GIR_Coverage, 5319,
     /* 168733 */     GIR_EraseRootFromParent_Done,
     /* 168734 */   // Label 3149: @168734
     /* 168734 */   GIM_Try, /*On fail goto*//*Label 3150*/ GIMT_Encode4(168767), // Rule ID 5320 //
     /* 168739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 168744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 168747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 168750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 168754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 168758 */     // (intrinsic_wo_chain:{ *:[f16] } 649:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRSQRTEv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 168758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1f16),
     /* 168761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168765 */     GIR_RootConstrainSelectedInstOperands,
     /* 168766 */     // GIR_Coverage, 5320,
     /* 168766 */     GIR_EraseRootFromParent_Done,
     /* 168767 */   // Label 3150: @168767
     /* 168767 */   GIM_Try, /*On fail goto*//*Label 3151*/ GIMT_Encode4(168800), // Rule ID 5321 //
     /* 168772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 168777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 168780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 168783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168791 */     // (intrinsic_wo_chain:{ *:[f32] } 649:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRSQRTEv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 168791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i32),
     /* 168794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168798 */     GIR_RootConstrainSelectedInstOperands,
     /* 168799 */     // GIR_Coverage, 5321,
     /* 168799 */     GIR_EraseRootFromParent_Done,
     /* 168800 */   // Label 3151: @168800
     /* 168800 */   GIM_Try, /*On fail goto*//*Label 3152*/ GIMT_Encode4(168833), // Rule ID 5322 //
     /* 168805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 168810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168824 */     // (intrinsic_wo_chain:{ *:[f64] } 649:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRSQRTEv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 168824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i64),
     /* 168827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168831 */     GIR_RootConstrainSelectedInstOperands,
     /* 168832 */     // GIR_Coverage, 5322,
     /* 168832 */     GIR_EraseRootFromParent_Done,
     /* 168833 */   // Label 3152: @168833
     /* 168833 */   GIM_Try, /*On fail goto*//*Label 3153*/ GIMT_Encode4(168866), // Rule ID 5323 //
     /* 168838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 168843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168857 */     // (intrinsic_wo_chain:{ *:[v1f64] } 649:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRSQRTEv1i64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i64),
     /* 168860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168864 */     GIR_RootConstrainSelectedInstOperands,
     /* 168865 */     // GIR_Coverage, 5323,
     /* 168865 */     GIR_EraseRootFromParent_Done,
     /* 168866 */   // Label 3153: @168866
     /* 168866 */   GIM_Try, /*On fail goto*//*Label 3154*/ GIMT_Encode4(168899), // Rule ID 5653 //
     /* 168871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 168876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 168879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168890 */     // (intrinsic_wo_chain:{ *:[f32] } 590:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 168890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 168893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168897 */     GIR_RootConstrainSelectedInstOperands,
     /* 168898 */     // GIR_Coverage, 5653,
     /* 168898 */     GIR_EraseRootFromParent_Done,
     /* 168899 */   // Label 3154: @168899
     /* 168899 */   GIM_Try, /*On fail goto*//*Label 3155*/ GIMT_Encode4(168984), // Rule ID 5654 //
     /* 168904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 168909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 168912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168923 */     // (intrinsic_wo_chain:{ *:[f32] } 590:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv4f32:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] }))
     /* 168923 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 168926 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 168930 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168935 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 168939 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 168943 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 168945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 168948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168957 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 168964 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168969 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 168977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 168982 */     GIR_RootConstrainSelectedInstOperands,
     /* 168983 */     // GIR_Coverage, 5654,
     /* 168983 */     GIR_EraseRootFromParent_Done,
     /* 168984 */   // Label 3155: @168984
     /* 168984 */   GIM_Try, /*On fail goto*//*Label 3156*/ GIMT_Encode4(169017), // Rule ID 5655 //
     /* 168989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 168994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169008 */     // (intrinsic_wo_chain:{ *:[f64] } 590:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FADDPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 169008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 169011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169015 */     GIR_RootConstrainSelectedInstOperands,
     /* 169016 */     // GIR_Coverage, 5655,
     /* 169016 */     GIR_EraseRootFromParent_Done,
     /* 169017 */   // Label 3156: @169017
     /* 169017 */   GIM_Try, /*On fail goto*//*Label 3157*/ GIMT_Encode4(169050), // Rule ID 5657 //
     /* 169022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 169027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169041 */     // (intrinsic_wo_chain:{ *:[f32] } 607:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMAXNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 169041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i32p),
     /* 169044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169048 */     GIR_RootConstrainSelectedInstOperands,
     /* 169049 */     // GIR_Coverage, 5657,
     /* 169049 */     GIR_EraseRootFromParent_Done,
     /* 169050 */   // Label 3157: @169050
     /* 169050 */   GIM_Try, /*On fail goto*//*Label 3158*/ GIMT_Encode4(169083), // Rule ID 5659 //
     /* 169055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 169060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 169063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169074 */     // (intrinsic_wo_chain:{ *:[f64] } 607:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMAXNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 169074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i64p),
     /* 169077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169081 */     GIR_RootConstrainSelectedInstOperands,
     /* 169082 */     // GIR_Coverage, 5659,
     /* 169082 */     GIR_EraseRootFromParent_Done,
     /* 169083 */   // Label 3158: @169083
     /* 169083 */   GIM_Try, /*On fail goto*//*Label 3159*/ GIMT_Encode4(169116), // Rule ID 5661 //
     /* 169088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 169093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169107 */     // (intrinsic_wo_chain:{ *:[f32] } 609:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMAXPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 169107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i32p),
     /* 169110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169114 */     GIR_RootConstrainSelectedInstOperands,
     /* 169115 */     // GIR_Coverage, 5661,
     /* 169115 */     GIR_EraseRootFromParent_Done,
     /* 169116 */   // Label 3159: @169116
     /* 169116 */   GIM_Try, /*On fail goto*//*Label 3160*/ GIMT_Encode4(169149), // Rule ID 5663 //
     /* 169121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 169126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 169129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169140 */     // (intrinsic_wo_chain:{ *:[f64] } 609:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMAXPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 169140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i64p),
     /* 169143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169147 */     GIR_RootConstrainSelectedInstOperands,
     /* 169148 */     // GIR_Coverage, 5663,
     /* 169148 */     GIR_EraseRootFromParent_Done,
     /* 169149 */   // Label 3160: @169149
     /* 169149 */   GIM_Try, /*On fail goto*//*Label 3161*/ GIMT_Encode4(169182), // Rule ID 5665 //
     /* 169154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 169159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169173 */     // (intrinsic_wo_chain:{ *:[f32] } 613:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 169173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i32p),
     /* 169176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169180 */     GIR_RootConstrainSelectedInstOperands,
     /* 169181 */     // GIR_Coverage, 5665,
     /* 169181 */     GIR_EraseRootFromParent_Done,
     /* 169182 */   // Label 3161: @169182
     /* 169182 */   GIM_Try, /*On fail goto*//*Label 3162*/ GIMT_Encode4(169215), // Rule ID 5667 //
     /* 169187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 169192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 169195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169206 */     // (intrinsic_wo_chain:{ *:[f64] } 613:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 169206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i64p),
     /* 169209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169213 */     GIR_RootConstrainSelectedInstOperands,
     /* 169214 */     // GIR_Coverage, 5667,
     /* 169214 */     GIR_EraseRootFromParent_Done,
     /* 169215 */   // Label 3162: @169215
     /* 169215 */   GIM_Try, /*On fail goto*//*Label 3163*/ GIMT_Encode4(169248), // Rule ID 5669 //
     /* 169220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 169225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169239 */     // (intrinsic_wo_chain:{ *:[f32] } 615:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMINPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 169239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i32p),
     /* 169242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169246 */     GIR_RootConstrainSelectedInstOperands,
     /* 169247 */     // GIR_Coverage, 5669,
     /* 169247 */     GIR_EraseRootFromParent_Done,
     /* 169248 */   // Label 3163: @169248
     /* 169248 */   GIM_Try, /*On fail goto*//*Label 3164*/ GIMT_Encode4(169281), // Rule ID 5671 //
     /* 169253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 169258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 169261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169272 */     // (intrinsic_wo_chain:{ *:[f64] } 615:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMINPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 169272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i64p),
     /* 169275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169279 */     GIR_RootConstrainSelectedInstOperands,
     /* 169280 */     // GIR_Coverage, 5671,
     /* 169280 */     GIR_EraseRootFromParent_Done,
     /* 169281 */   // Label 3164: @169281
     /* 169281 */   GIM_Try, /*On fail goto*//*Label 3165*/ GIMT_Encode4(169314), // Rule ID 13266 //
     /* 169286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 169291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 169294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 169297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 169301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169305 */     // (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 169305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 169308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169312 */     GIR_RootConstrainSelectedInstOperands,
     /* 169313 */     // GIR_Coverage, 13266,
     /* 169313 */     GIR_EraseRootFromParent_Done,
     /* 169314 */   // Label 3165: @169314
     /* 169314 */   GIM_Try, /*On fail goto*//*Label 3166*/ GIMT_Encode4(169347), // Rule ID 13268 //
     /* 169319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 169324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 169327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 169330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 169334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169338 */     // (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 169338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 169341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169345 */     GIR_RootConstrainSelectedInstOperands,
     /* 169346 */     // GIR_Coverage, 13268,
     /* 169346 */     GIR_EraseRootFromParent_Done,
     /* 169347 */   // Label 3166: @169347
     /* 169347 */   GIM_Try, /*On fail goto*//*Label 3167*/ GIMT_Encode4(169380), // Rule ID 13270 //
     /* 169352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 169357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 169360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 169367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169371 */     // (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 169371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 169374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169378 */     GIR_RootConstrainSelectedInstOperands,
     /* 169379 */     // GIR_Coverage, 13270,
     /* 169379 */     GIR_EraseRootFromParent_Done,
     /* 169380 */   // Label 3167: @169380
     /* 169380 */   GIM_Try, /*On fail goto*//*Label 3168*/ GIMT_Encode4(169413), // Rule ID 13272 //
     /* 169385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 169390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 169393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 169400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169404 */     // (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 169404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 169407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169411 */     GIR_RootConstrainSelectedInstOperands,
     /* 169412 */     // GIR_Coverage, 13272,
     /* 169412 */     GIR_EraseRootFromParent_Done,
     /* 169413 */   // Label 3168: @169413
     /* 169413 */   GIM_Try, /*On fail goto*//*Label 3169*/ GIMT_Encode4(169528), // Rule ID 13273 //
     /* 169418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 169423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169437 */     // (intrinsic_wo_chain:{ *:[i32] } 672:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 169437 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 169440 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 169444 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169449 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 169453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 169455 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 169458 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 169462 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169467 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 169469 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 169472 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 169476 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169481 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169484 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169487 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 169490 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169495 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169500 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169510 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 169517 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169522 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169527 */     // GIR_Coverage, 13273,
     /* 169527 */     GIR_EraseRootFromParent_Done,
     /* 169528 */   // Label 3169: @169528
     /* 169528 */   GIM_Try, /*On fail goto*//*Label 3170*/ GIMT_Encode4(169561), // Rule ID 13275 //
     /* 169533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 169538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 169541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 169544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 169548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169552 */     // (intrinsic_wo_chain:{ *:[i8] } 737:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 169552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 169555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169559 */     GIR_RootConstrainSelectedInstOperands,
     /* 169560 */     // GIR_Coverage, 13275,
     /* 169560 */     GIR_EraseRootFromParent_Done,
     /* 169561 */   // Label 3170: @169561
     /* 169561 */   GIM_Try, /*On fail goto*//*Label 3171*/ GIMT_Encode4(169594), // Rule ID 13277 //
     /* 169566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 169571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 169574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 169577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 169581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169585 */     // (intrinsic_wo_chain:{ *:[i8] } 737:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 169585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 169588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169592 */     GIR_RootConstrainSelectedInstOperands,
     /* 169593 */     // GIR_Coverage, 13277,
     /* 169593 */     GIR_EraseRootFromParent_Done,
     /* 169594 */   // Label 3171: @169594
     /* 169594 */   GIM_Try, /*On fail goto*//*Label 3172*/ GIMT_Encode4(169627), // Rule ID 13279 //
     /* 169599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 169604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 169607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 169614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169618 */     // (intrinsic_wo_chain:{ *:[i16] } 737:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 169618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 169621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169625 */     GIR_RootConstrainSelectedInstOperands,
     /* 169626 */     // GIR_Coverage, 13279,
     /* 169626 */     GIR_EraseRootFromParent_Done,
     /* 169627 */   // Label 3172: @169627
     /* 169627 */   GIM_Try, /*On fail goto*//*Label 3173*/ GIMT_Encode4(169660), // Rule ID 13281 //
     /* 169632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 169637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 169640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 169647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169651 */     // (intrinsic_wo_chain:{ *:[i16] } 737:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 169651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 169654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169658 */     GIR_RootConstrainSelectedInstOperands,
     /* 169659 */     // GIR_Coverage, 13281,
     /* 169659 */     GIR_EraseRootFromParent_Done,
     /* 169660 */   // Label 3173: @169660
     /* 169660 */   GIM_Try, /*On fail goto*//*Label 3174*/ GIMT_Encode4(169775), // Rule ID 13282 //
     /* 169665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 169670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169684 */     // (intrinsic_wo_chain:{ *:[i32] } 737:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 169684 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 169687 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 169691 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169696 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 169700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 169702 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 169705 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 169709 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 169716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 169719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 169723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169728 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169731 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169734 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 169737 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169742 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169747 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169757 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 169764 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169769 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169774 */     // GIR_Coverage, 13282,
     /* 169774 */     GIR_EraseRootFromParent_Done,
     /* 169775 */   // Label 3174: @169775
     /* 169775 */   GIM_Try, /*On fail goto*//*Label 3175*/ GIMT_Encode4(169894), // Rule ID 13283 //
     /* 169780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 169785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169799 */     // (intrinsic_wo_chain:{ *:[i32] } 672:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 169799 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 169802 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 169806 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169811 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 169815 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 169819 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 169821 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 169824 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 169828 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169833 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 169835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 169838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 169842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169847 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169850 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169853 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 169856 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169861 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169866 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169876 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 169883 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169888 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169893 */     // GIR_Coverage, 13283,
     /* 169893 */     GIR_EraseRootFromParent_Done,
     /* 169894 */   // Label 3175: @169894
     /* 169894 */   GIM_Try, /*On fail goto*//*Label 3176*/ GIMT_Encode4(170009), // Rule ID 13284 //
     /* 169899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 169904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 169907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169918 */     // (intrinsic_wo_chain:{ *:[i64] } 672:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn), dsub:{ *:[i32] }), dsub:{ *:[i32] })
     /* 169918 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 169921 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 169925 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169930 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 169934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 169936 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 169939 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 169943 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 169950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 169953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 169957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169962 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169965 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169968 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 169971 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169976 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169981 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169991 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 169998 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170003 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170008 */     // GIR_Coverage, 13284,
     /* 170008 */     GIR_EraseRootFromParent_Done,
     /* 170009 */   // Label 3176: @170009
     /* 170009 */   GIM_Try, /*On fail goto*//*Label 3177*/ GIMT_Encode4(170128), // Rule ID 13285 //
     /* 170014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 170019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170033 */     // (intrinsic_wo_chain:{ *:[i32] } 737:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 170033 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 170036 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 170040 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170045 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 170049 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 170053 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 170055 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 170058 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 170062 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170067 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 170069 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 170072 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 170076 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170081 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 170084 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 170087 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 170090 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170095 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170100 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170110 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 170117 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170122 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170127 */     // GIR_Coverage, 13285,
     /* 170127 */     GIR_EraseRootFromParent_Done,
     /* 170128 */   // Label 3177: @170128
     /* 170128 */   GIM_Try, /*On fail goto*//*Label 3178*/ GIMT_Encode4(170243), // Rule ID 13286 //
     /* 170133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 170138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 170141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170152 */     // (intrinsic_wo_chain:{ *:[i64] } 737:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn), dsub:{ *:[i32] }), dsub:{ *:[i32] })
     /* 170152 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 170155 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 170159 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170164 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 170168 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 170170 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 170173 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 170177 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170182 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 170184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 170187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 170191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170196 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 170199 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 170202 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 170205 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170210 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170215 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170225 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 170232 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170237 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170242 */     // GIR_Coverage, 13286,
     /* 170242 */     GIR_EraseRootFromParent_Done,
     /* 170243 */   // Label 3178: @170243
     /* 170243 */   GIM_Try, /*On fail goto*//*Label 3179*/ GIMT_Encode4(170276), // Rule ID 13288 //
     /* 170248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 170253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 170256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 170259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 170263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170267 */     // (intrinsic_wo_chain:{ *:[i8] } 682:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 170267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 170270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170274 */     GIR_RootConstrainSelectedInstOperands,
     /* 170275 */     // GIR_Coverage, 13288,
     /* 170275 */     GIR_EraseRootFromParent_Done,
     /* 170276 */   // Label 3179: @170276
     /* 170276 */   GIM_Try, /*On fail goto*//*Label 3180*/ GIMT_Encode4(170309), // Rule ID 13290 //
     /* 170281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 170286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 170289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 170296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170300 */     // (intrinsic_wo_chain:{ *:[i8] } 682:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 170300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 170303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170307 */     GIR_RootConstrainSelectedInstOperands,
     /* 170308 */     // GIR_Coverage, 13290,
     /* 170308 */     GIR_EraseRootFromParent_Done,
     /* 170309 */   // Label 3180: @170309
     /* 170309 */   GIM_Try, /*On fail goto*//*Label 3181*/ GIMT_Encode4(170342), // Rule ID 13292 //
     /* 170314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 170319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 170322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 170325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 170329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170333 */     // (intrinsic_wo_chain:{ *:[i16] } 682:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 170333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 170336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170340 */     GIR_RootConstrainSelectedInstOperands,
     /* 170341 */     // GIR_Coverage, 13292,
     /* 170341 */     GIR_EraseRootFromParent_Done,
     /* 170342 */   // Label 3181: @170342
     /* 170342 */   GIM_Try, /*On fail goto*//*Label 3182*/ GIMT_Encode4(170375), // Rule ID 13294 //
     /* 170347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 170352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 170355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 170362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170366 */     // (intrinsic_wo_chain:{ *:[i16] } 682:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 170366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 170369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170373 */     GIR_RootConstrainSelectedInstOperands,
     /* 170374 */     // GIR_Coverage, 13294,
     /* 170374 */     GIR_EraseRootFromParent_Done,
     /* 170375 */   // Label 3182: @170375
     /* 170375 */   GIM_Try, /*On fail goto*//*Label 3183*/ GIMT_Encode4(170490), // Rule ID 13295 //
     /* 170380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 170385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170399 */     // (intrinsic_wo_chain:{ *:[i32] } 682:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 170399 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 170402 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i32v),
     /* 170406 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170411 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 170415 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 170417 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 170420 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 170424 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170429 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 170431 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 170434 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 170438 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170443 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 170446 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 170449 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 170452 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170457 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170462 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170472 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 170479 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170484 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170489 */     // GIR_Coverage, 13295,
     /* 170489 */     GIR_EraseRootFromParent_Done,
     /* 170490 */   // Label 3183: @170490
     /* 170490 */   GIM_Try, /*On fail goto*//*Label 3184*/ GIMT_Encode4(170609), // Rule ID 13296 //
     /* 170495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 170500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170514 */     // (intrinsic_wo_chain:{ *:[i32] } 682:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 170514 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 170517 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 170521 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170526 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 170530 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 170534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 170536 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 170539 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 170543 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170548 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 170550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 170553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 170557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170562 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 170565 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 170568 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 170571 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170576 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170581 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170591 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 170598 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170603 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170608 */     // GIR_Coverage, 13296,
     /* 170608 */     GIR_EraseRootFromParent_Done,
     /* 170609 */   // Label 3184: @170609
     /* 170609 */   GIM_Try, /*On fail goto*//*Label 3185*/ GIMT_Encode4(170642), // Rule ID 13298 //
     /* 170614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 170619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 170622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 170625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 170629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170633 */     // (intrinsic_wo_chain:{ *:[i8] } 685:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 170633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 170636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170640 */     GIR_RootConstrainSelectedInstOperands,
     /* 170641 */     // GIR_Coverage, 13298,
     /* 170641 */     GIR_EraseRootFromParent_Done,
     /* 170642 */   // Label 3185: @170642
     /* 170642 */   GIM_Try, /*On fail goto*//*Label 3186*/ GIMT_Encode4(170675), // Rule ID 13300 //
     /* 170647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 170652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 170655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 170662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170666 */     // (intrinsic_wo_chain:{ *:[i8] } 685:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 170666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 170669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170673 */     GIR_RootConstrainSelectedInstOperands,
     /* 170674 */     // GIR_Coverage, 13300,
     /* 170674 */     GIR_EraseRootFromParent_Done,
     /* 170675 */   // Label 3186: @170675
     /* 170675 */   GIM_Try, /*On fail goto*//*Label 3187*/ GIMT_Encode4(170708), // Rule ID 13302 //
     /* 170680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 170685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 170688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 170691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 170695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170699 */     // (intrinsic_wo_chain:{ *:[i16] } 685:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 170699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 170702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170706 */     GIR_RootConstrainSelectedInstOperands,
     /* 170707 */     // GIR_Coverage, 13302,
     /* 170707 */     GIR_EraseRootFromParent_Done,
     /* 170708 */   // Label 3187: @170708
     /* 170708 */   GIM_Try, /*On fail goto*//*Label 3188*/ GIMT_Encode4(170741), // Rule ID 13304 //
     /* 170713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 170718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 170721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 170728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170732 */     // (intrinsic_wo_chain:{ *:[i16] } 685:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 170732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 170735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170739 */     GIR_RootConstrainSelectedInstOperands,
     /* 170740 */     // GIR_Coverage, 13304,
     /* 170740 */     GIR_EraseRootFromParent_Done,
     /* 170741 */   // Label 3188: @170741
     /* 170741 */   GIM_Try, /*On fail goto*//*Label 3189*/ GIMT_Encode4(170856), // Rule ID 13305 //
     /* 170746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 170751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170765 */     // (intrinsic_wo_chain:{ *:[i32] } 685:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 170765 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 170768 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i32v),
     /* 170772 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170777 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 170781 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 170783 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 170786 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 170790 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 170797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 170800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 170804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170809 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 170812 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 170815 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 170818 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170823 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170828 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170838 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 170845 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170850 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170855 */     // GIR_Coverage, 13305,
     /* 170855 */     GIR_EraseRootFromParent_Done,
     /* 170856 */   // Label 3189: @170856
     /* 170856 */   GIM_Try, /*On fail goto*//*Label 3190*/ GIMT_Encode4(170975), // Rule ID 13306 //
     /* 170861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 170866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170880 */     // (intrinsic_wo_chain:{ *:[i32] } 685:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 170880 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 170883 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 170887 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170892 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 170896 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 170900 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 170902 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 170905 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 170909 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 170916 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 170919 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 170923 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170928 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 170931 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 170934 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 170937 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170942 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170947 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170957 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 170964 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170969 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170974 */     // GIR_Coverage, 13306,
     /* 170974 */     GIR_EraseRootFromParent_Done,
     /* 170975 */   // Label 3190: @170975
     /* 170975 */   GIM_Try, /*On fail goto*//*Label 3191*/ GIMT_Encode4(171008), // Rule ID 13308 //
     /* 170980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 170985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 170988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 170991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 170995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170999 */     // (intrinsic_wo_chain:{ *:[i8] } 743:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 170999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 171002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171006 */     GIR_RootConstrainSelectedInstOperands,
     /* 171007 */     // GIR_Coverage, 13308,
     /* 171007 */     GIR_EraseRootFromParent_Done,
     /* 171008 */   // Label 3191: @171008
     /* 171008 */   GIM_Try, /*On fail goto*//*Label 3192*/ GIMT_Encode4(171041), // Rule ID 13310 //
     /* 171013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 171018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 171021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 171024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 171028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171032 */     // (intrinsic_wo_chain:{ *:[i8] } 743:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 171032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 171035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171039 */     GIR_RootConstrainSelectedInstOperands,
     /* 171040 */     // GIR_Coverage, 13310,
     /* 171040 */     GIR_EraseRootFromParent_Done,
     /* 171041 */   // Label 3192: @171041
     /* 171041 */   GIM_Try, /*On fail goto*//*Label 3193*/ GIMT_Encode4(171074), // Rule ID 13312 //
     /* 171046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 171051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 171054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171065 */     // (intrinsic_wo_chain:{ *:[i16] } 743:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 171065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 171068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171072 */     GIR_RootConstrainSelectedInstOperands,
     /* 171073 */     // GIR_Coverage, 13312,
     /* 171073 */     GIR_EraseRootFromParent_Done,
     /* 171074 */   // Label 3193: @171074
     /* 171074 */   GIM_Try, /*On fail goto*//*Label 3194*/ GIMT_Encode4(171107), // Rule ID 13314 //
     /* 171079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 171084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 171087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171098 */     // (intrinsic_wo_chain:{ *:[i16] } 743:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 171098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 171101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171105 */     GIR_RootConstrainSelectedInstOperands,
     /* 171106 */     // GIR_Coverage, 13314,
     /* 171106 */     GIR_EraseRootFromParent_Done,
     /* 171107 */   // Label 3194: @171107
     /* 171107 */   GIM_Try, /*On fail goto*//*Label 3195*/ GIMT_Encode4(171222), // Rule ID 13315 //
     /* 171112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 171117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 171120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171131 */     // (intrinsic_wo_chain:{ *:[i32] } 743:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 171131 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 171134 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i32v),
     /* 171138 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171143 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 171147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 171149 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 171152 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 171156 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 171163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 171166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 171170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171175 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 171178 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 171181 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 171184 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171189 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171194 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 171202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171204 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 171211 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171216 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171221 */     // GIR_Coverage, 13315,
     /* 171221 */     GIR_EraseRootFromParent_Done,
     /* 171222 */   // Label 3195: @171222
     /* 171222 */   GIM_Try, /*On fail goto*//*Label 3196*/ GIMT_Encode4(171341), // Rule ID 13316 //
     /* 171227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 171232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 171235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171246 */     // (intrinsic_wo_chain:{ *:[i32] } 743:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 171246 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 171249 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 171253 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171258 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 171262 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 171266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 171268 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 171271 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 171275 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 171282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 171285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 171289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171294 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 171297 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 171300 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 171303 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171308 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171313 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 171321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171323 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 171330 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171335 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171340 */     // GIR_Coverage, 13316,
     /* 171340 */     GIR_EraseRootFromParent_Done,
     /* 171341 */   // Label 3196: @171341
     /* 171341 */   GIM_Try, /*On fail goto*//*Label 3197*/ GIMT_Encode4(171374), // Rule ID 13318 //
     /* 171346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 171351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 171354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 171357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 171361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171365 */     // (intrinsic_wo_chain:{ *:[i8] } 746:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 171365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 171368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171372 */     GIR_RootConstrainSelectedInstOperands,
     /* 171373 */     // GIR_Coverage, 13318,
     /* 171373 */     GIR_EraseRootFromParent_Done,
     /* 171374 */   // Label 3197: @171374
     /* 171374 */   GIM_Try, /*On fail goto*//*Label 3198*/ GIMT_Encode4(171407), // Rule ID 13320 //
     /* 171379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 171384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 171387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 171390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 171394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171398 */     // (intrinsic_wo_chain:{ *:[i8] } 746:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 171398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 171401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171405 */     GIR_RootConstrainSelectedInstOperands,
     /* 171406 */     // GIR_Coverage, 13320,
     /* 171406 */     GIR_EraseRootFromParent_Done,
     /* 171407 */   // Label 3198: @171407
     /* 171407 */   GIM_Try, /*On fail goto*//*Label 3199*/ GIMT_Encode4(171440), // Rule ID 13322 //
     /* 171412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 171417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 171420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171431 */     // (intrinsic_wo_chain:{ *:[i16] } 746:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 171431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 171434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171438 */     GIR_RootConstrainSelectedInstOperands,
     /* 171439 */     // GIR_Coverage, 13322,
     /* 171439 */     GIR_EraseRootFromParent_Done,
     /* 171440 */   // Label 3199: @171440
     /* 171440 */   GIM_Try, /*On fail goto*//*Label 3200*/ GIMT_Encode4(171473), // Rule ID 13324 //
     /* 171445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 171450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 171453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171464 */     // (intrinsic_wo_chain:{ *:[i16] } 746:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 171464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 171467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171471 */     GIR_RootConstrainSelectedInstOperands,
     /* 171472 */     // GIR_Coverage, 13324,
     /* 171472 */     GIR_EraseRootFromParent_Done,
     /* 171473 */   // Label 3200: @171473
     /* 171473 */   GIM_Try, /*On fail goto*//*Label 3201*/ GIMT_Encode4(171588), // Rule ID 13325 //
     /* 171478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 171483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 171486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171497 */     // (intrinsic_wo_chain:{ *:[i32] } 746:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 171497 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 171500 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i32v),
     /* 171504 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171509 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 171513 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 171515 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 171518 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 171522 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171527 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 171529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 171532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 171536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171541 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 171544 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 171547 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 171550 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171555 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171560 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 171568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171570 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 171577 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171582 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171587 */     // GIR_Coverage, 13325,
     /* 171587 */     GIR_EraseRootFromParent_Done,
     /* 171588 */   // Label 3201: @171588
     /* 171588 */   GIM_Try, /*On fail goto*//*Label 3202*/ GIMT_Encode4(171707), // Rule ID 13326 //
     /* 171593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 171598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 171601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171612 */     // (intrinsic_wo_chain:{ *:[i32] } 746:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 171612 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 171615 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 171619 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171624 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 171628 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 171632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 171634 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 171637 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 171641 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 171648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 171651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 171655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171660 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 171663 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 171666 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 171669 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171674 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171679 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 171687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171689 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 171696 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171701 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171706 */     // GIR_Coverage, 13326,
     /* 171706 */     GIR_EraseRootFromParent_Done,
     /* 171707 */   // Label 3202: @171707
     /* 171707 */   GIM_Try, /*On fail goto*//*Label 3203*/ GIMT_Encode4(171739), // Rule ID 2393 //
     /* 171712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 171715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b16),
     /* 171720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 171723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 171726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 171730 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1679:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 171730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_H),
     /* 171733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 171735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 171737 */     GIR_RootConstrainSelectedInstOperands,
     /* 171738 */     // GIR_Coverage, 2393,
     /* 171738 */     GIR_EraseRootFromParent_Done,
     /* 171739 */   // Label 3203: @171739
     /* 171739 */   GIM_Try, /*On fail goto*//*Label 3204*/ GIMT_Encode4(171771), // Rule ID 2394 //
     /* 171744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 171747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b32),
     /* 171752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 171755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 171758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 171762 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1680:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 171762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_S),
     /* 171765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 171767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 171769 */     GIR_RootConstrainSelectedInstOperands,
     /* 171770 */     // GIR_Coverage, 2394,
     /* 171770 */     GIR_EraseRootFromParent_Done,
     /* 171771 */   // Label 3204: @171771
     /* 171771 */   GIM_Try, /*On fail goto*//*Label 3205*/ GIMT_Encode4(171803), // Rule ID 2395 //
     /* 171776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 171779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b64),
     /* 171784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 171787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 171790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 171794 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1681:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 171794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_D),
     /* 171797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 171799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 171801 */     GIR_RootConstrainSelectedInstOperands,
     /* 171802 */     // GIR_Coverage, 2395,
     /* 171802 */     GIR_EraseRootFromParent_Done,
     /* 171803 */   // Label 3205: @171803
     /* 171803 */   GIM_Try, /*On fail goto*//*Label 3206*/ GIMT_Encode4(171835), // Rule ID 3104 //
     /* 171808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 171811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 171816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 171819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 171822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 171826 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1861:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (SQXTNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 171826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_B),
     /* 171829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 171831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171833 */     GIR_RootConstrainSelectedInstOperands,
     /* 171834 */     // GIR_Coverage, 3104,
     /* 171834 */     GIR_EraseRootFromParent_Done,
     /* 171835 */   // Label 3206: @171835
     /* 171835 */   GIM_Try, /*On fail goto*//*Label 3207*/ GIMT_Encode4(171867), // Rule ID 3105 //
     /* 171840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 171843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 171848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 171851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 171854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 171858 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1861:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (SQXTNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 171858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_H),
     /* 171861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 171863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171865 */     GIR_RootConstrainSelectedInstOperands,
     /* 171866 */     // GIR_Coverage, 3105,
     /* 171866 */     GIR_EraseRootFromParent_Done,
     /* 171867 */   // Label 3207: @171867
     /* 171867 */   GIM_Try, /*On fail goto*//*Label 3208*/ GIMT_Encode4(171899), // Rule ID 3106 //
     /* 171872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 171875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 171880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 171883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 171886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 171890 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1861:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (SQXTNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 171890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_S),
     /* 171893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 171895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171897 */     GIR_RootConstrainSelectedInstOperands,
     /* 171898 */     // GIR_Coverage, 3106,
     /* 171898 */     GIR_EraseRootFromParent_Done,
     /* 171899 */   // Label 3208: @171899
     /* 171899 */   GIM_Try, /*On fail goto*//*Label 3209*/ GIMT_Encode4(171931), // Rule ID 3360 //
     /* 171904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 171907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 171912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 171915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 171918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 171922 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1671:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv8i1] } ?:{ *:[nxv16i1] }:$Op1)
     /* 171922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 171925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 171927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171929 */     GIR_RootConstrainSelectedInstOperands,
     /* 171930 */     // GIR_Coverage, 3360,
     /* 171930 */     GIR_EraseRootFromParent_Done,
     /* 171931 */   // Label 3209: @171931
     /* 171931 */   GIM_Try, /*On fail goto*//*Label 3210*/ GIMT_Encode4(171963), // Rule ID 3361 //
     /* 171936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 171939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 171944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 171947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 171950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 171954 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1671:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv4i1] } ?:{ *:[nxv8i1] }:$Op1)
     /* 171954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 171957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 171959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171961 */     GIR_RootConstrainSelectedInstOperands,
     /* 171962 */     // GIR_Coverage, 3361,
     /* 171962 */     GIR_EraseRootFromParent_Done,
     /* 171963 */   // Label 3210: @171963
     /* 171963 */   GIM_Try, /*On fail goto*//*Label 3211*/ GIMT_Encode4(171995), // Rule ID 3362 //
     /* 171968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 171971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 171976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 171979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 171982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 171986 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1671:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv2i1] } ?:{ *:[nxv4i1] }:$Op1)
     /* 171986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 171989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 171991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171993 */     GIR_RootConstrainSelectedInstOperands,
     /* 171994 */     // GIR_Coverage, 3362,
     /* 171994 */     GIR_EraseRootFromParent_Done,
     /* 171995 */   // Label 3211: @171995
     /* 171995 */   GIM_Try, /*On fail goto*//*Label 3212*/ GIMT_Encode4(172027), // Rule ID 3444 //
     /* 172000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA),
     /* 172003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 172008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 172011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 172014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 172018 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1432:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (FEXPA_ZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i16] }:$Op1)
     /* 172018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_H),
     /* 172021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 172023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 172025 */     GIR_RootConstrainSelectedInstOperands,
     /* 172026 */     // GIR_Coverage, 3444,
     /* 172026 */     GIR_EraseRootFromParent_Done,
     /* 172027 */   // Label 3212: @172027
     /* 172027 */   GIM_Try, /*On fail goto*//*Label 3213*/ GIMT_Encode4(172059), // Rule ID 3445 //
     /* 172032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA),
     /* 172035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 172040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 172043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 172046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 172050 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1432:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (FEXPA_ZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i32] }:$Op1)
     /* 172050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_S),
     /* 172053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 172055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 172057 */     GIR_RootConstrainSelectedInstOperands,
     /* 172058 */     // GIR_Coverage, 3445,
     /* 172058 */     GIR_EraseRootFromParent_Done,
     /* 172059 */   // Label 3213: @172059
     /* 172059 */   GIM_Try, /*On fail goto*//*Label 3214*/ GIMT_Encode4(172091), // Rule ID 3446 //
     /* 172064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA),
     /* 172067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 172072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 172075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 172078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 172082 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1432:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (FEXPA_ZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i64] }:$Op1)
     /* 172082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_D),
     /* 172085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 172087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 172089 */     GIR_RootConstrainSelectedInstOperands,
     /* 172090 */     // GIR_Coverage, 3446,
     /* 172090 */     GIR_EraseRootFromParent_Done,
     /* 172091 */   // Label 3214: @172091
     /* 172091 */   GIM_Try, /*On fail goto*//*Label 3215*/ GIMT_Encode4(172123), // Rule ID 3471 //
     /* 172096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_AES_HasSVEAES),
     /* 172099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesmc),
     /* 172104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 172107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 172110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 172114 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1271:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (AESMC_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1)
     /* 172114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMC_ZZ_B),
     /* 172117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 172119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 172121 */     GIR_RootConstrainSelectedInstOperands,
     /* 172122 */     // GIR_Coverage, 3471,
     /* 172122 */     GIR_EraseRootFromParent_Done,
     /* 172123 */   // Label 3215: @172123
     /* 172123 */   GIM_Try, /*On fail goto*//*Label 3216*/ GIMT_Encode4(172155), // Rule ID 4686 //
     /* 172128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 172131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 172136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 172139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 172142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 172146 */     // (intrinsic_wo_chain:{ *:[i32] } 602:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } ?:{ *:[f16] }:$Rn)
     /* 172146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 172149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172153 */     GIR_RootConstrainSelectedInstOperands,
     /* 172154 */     // GIR_Coverage, 4686,
     /* 172154 */     GIR_EraseRootFromParent_Done,
     /* 172155 */   // Label 3216: @172155
     /* 172155 */   GIM_Try, /*On fail goto*//*Label 3217*/ GIMT_Encode4(172187), // Rule ID 4687 //
     /* 172160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 172163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 172168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 172174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 172178 */     // (intrinsic_wo_chain:{ *:[i64] } 602:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } ?:{ *:[f16] }:$Rn)
     /* 172178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 172181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172185 */     GIR_RootConstrainSelectedInstOperands,
     /* 172186 */     // GIR_Coverage, 4687,
     /* 172186 */     GIR_EraseRootFromParent_Done,
     /* 172187 */   // Label 3217: @172187
     /* 172187 */   GIM_Try, /*On fail goto*//*Label 3218*/ GIMT_Encode4(172216), // Rule ID 4688 //
     /* 172192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 172197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 172200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 172203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 172207 */     // (intrinsic_wo_chain:{ *:[i32] } 602:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } ?:{ *:[f32] }:$Rn)
     /* 172207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 172210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172214 */     GIR_RootConstrainSelectedInstOperands,
     /* 172215 */     // GIR_Coverage, 4688,
     /* 172215 */     GIR_EraseRootFromParent_Done,
     /* 172216 */   // Label 3218: @172216
     /* 172216 */   GIM_Try, /*On fail goto*//*Label 3219*/ GIMT_Encode4(172245), // Rule ID 4689 //
     /* 172221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 172226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 172232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 172236 */     // (intrinsic_wo_chain:{ *:[i64] } 602:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } ?:{ *:[f32] }:$Rn)
     /* 172236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 172239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172243 */     GIR_RootConstrainSelectedInstOperands,
     /* 172244 */     // GIR_Coverage, 4689,
     /* 172244 */     GIR_EraseRootFromParent_Done,
     /* 172245 */   // Label 3219: @172245
     /* 172245 */   GIM_Try, /*On fail goto*//*Label 3220*/ GIMT_Encode4(172274), // Rule ID 4690 //
     /* 172250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 172255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 172258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 172265 */     // (intrinsic_wo_chain:{ *:[i32] } 602:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } ?:{ *:[f64] }:$Rn)
     /* 172265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 172268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172272 */     GIR_RootConstrainSelectedInstOperands,
     /* 172273 */     // GIR_Coverage, 4690,
     /* 172273 */     GIR_EraseRootFromParent_Done,
     /* 172274 */   // Label 3220: @172274
     /* 172274 */   GIM_Try, /*On fail goto*//*Label 3221*/ GIMT_Encode4(172303), // Rule ID 4691 //
     /* 172279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 172284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 172294 */     // (intrinsic_wo_chain:{ *:[i64] } 602:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } ?:{ *:[f64] }:$Rn)
     /* 172294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 172297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172301 */     GIR_RootConstrainSelectedInstOperands,
     /* 172302 */     // GIR_Coverage, 4691,
     /* 172302 */     GIR_EraseRootFromParent_Done,
     /* 172303 */   // Label 3221: @172303
     /* 172303 */   GIM_Try, /*On fail goto*//*Label 3222*/ GIMT_Encode4(172335), // Rule ID 4698 //
     /* 172308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 172311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 172316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 172319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 172322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 172326 */     // (intrinsic_wo_chain:{ *:[i32] } 603:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } ?:{ *:[f16] }:$Rn)
     /* 172326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 172329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172333 */     GIR_RootConstrainSelectedInstOperands,
     /* 172334 */     // GIR_Coverage, 4698,
     /* 172334 */     GIR_EraseRootFromParent_Done,
     /* 172335 */   // Label 3222: @172335
     /* 172335 */   GIM_Try, /*On fail goto*//*Label 3223*/ GIMT_Encode4(172367), // Rule ID 4699 //
     /* 172340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 172343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 172348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 172354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 172358 */     // (intrinsic_wo_chain:{ *:[i64] } 603:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } ?:{ *:[f16] }:$Rn)
     /* 172358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 172361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172365 */     GIR_RootConstrainSelectedInstOperands,
     /* 172366 */     // GIR_Coverage, 4699,
     /* 172366 */     GIR_EraseRootFromParent_Done,
     /* 172367 */   // Label 3223: @172367
     /* 172367 */   GIM_Try, /*On fail goto*//*Label 3224*/ GIMT_Encode4(172396), // Rule ID 4700 //
     /* 172372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 172377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 172380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 172383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 172387 */     // (intrinsic_wo_chain:{ *:[i32] } 603:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } ?:{ *:[f32] }:$Rn)
     /* 172387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 172390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172394 */     GIR_RootConstrainSelectedInstOperands,
     /* 172395 */     // GIR_Coverage, 4700,
     /* 172395 */     GIR_EraseRootFromParent_Done,
     /* 172396 */   // Label 3224: @172396
     /* 172396 */   GIM_Try, /*On fail goto*//*Label 3225*/ GIMT_Encode4(172425), // Rule ID 4701 //
     /* 172401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 172406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 172412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 172416 */     // (intrinsic_wo_chain:{ *:[i64] } 603:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } ?:{ *:[f32] }:$Rn)
     /* 172416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 172419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172423 */     GIR_RootConstrainSelectedInstOperands,
     /* 172424 */     // GIR_Coverage, 4701,
     /* 172424 */     GIR_EraseRootFromParent_Done,
     /* 172425 */   // Label 3225: @172425
     /* 172425 */   GIM_Try, /*On fail goto*//*Label 3226*/ GIMT_Encode4(172454), // Rule ID 4702 //
     /* 172430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 172435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 172438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 172445 */     // (intrinsic_wo_chain:{ *:[i32] } 603:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } ?:{ *:[f64] }:$Rn)
     /* 172445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 172448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172452 */     GIR_RootConstrainSelectedInstOperands,
     /* 172453 */     // GIR_Coverage, 4702,
     /* 172453 */     GIR_EraseRootFromParent_Done,
     /* 172454 */   // Label 3226: @172454
     /* 172454 */   GIM_Try, /*On fail goto*//*Label 3227*/ GIMT_Encode4(172483), // Rule ID 4703 //
     /* 172459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 172464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 172474 */     // (intrinsic_wo_chain:{ *:[i64] } 603:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } ?:{ *:[f64] }:$Rn)
     /* 172474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 172477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172481 */     GIR_RootConstrainSelectedInstOperands,
     /* 172482 */     // GIR_Coverage, 4703,
     /* 172482 */     GIR_EraseRootFromParent_Done,
     /* 172483 */   // Label 3227: @172483
     /* 172483 */   GIM_Try, /*On fail goto*//*Label 3228*/ GIMT_Encode4(172512), // Rule ID 4998 //
     /* 172488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 172493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172503 */     // (intrinsic_wo_chain:{ *:[v4i16] } 602:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } ?:{ *:[v4f16] }:$Rn)
     /* 172503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 172506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172510 */     GIR_RootConstrainSelectedInstOperands,
     /* 172511 */     // GIR_Coverage, 4998,
     /* 172511 */     GIR_EraseRootFromParent_Done,
     /* 172512 */   // Label 3228: @172512
     /* 172512 */   GIM_Try, /*On fail goto*//*Label 3229*/ GIMT_Encode4(172541), // Rule ID 4999 //
     /* 172517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 172522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 172525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 172528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172532 */     // (intrinsic_wo_chain:{ *:[v8i16] } 602:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } ?:{ *:[v8f16] }:$Rn)
     /* 172532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 172535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172539 */     GIR_RootConstrainSelectedInstOperands,
     /* 172540 */     // GIR_Coverage, 4999,
     /* 172540 */     GIR_EraseRootFromParent_Done,
     /* 172541 */   // Label 3229: @172541
     /* 172541 */   GIM_Try, /*On fail goto*//*Label 3230*/ GIMT_Encode4(172570), // Rule ID 5000 //
     /* 172546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 172551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 172554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172561 */     // (intrinsic_wo_chain:{ *:[v2i32] } 602:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } ?:{ *:[v2f32] }:$Rn)
     /* 172561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 172564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172568 */     GIR_RootConstrainSelectedInstOperands,
     /* 172569 */     // GIR_Coverage, 5000,
     /* 172569 */     GIR_EraseRootFromParent_Done,
     /* 172570 */   // Label 3230: @172570
     /* 172570 */   GIM_Try, /*On fail goto*//*Label 3231*/ GIMT_Encode4(172599), // Rule ID 5001 //
     /* 172575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 172580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 172583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172590 */     // (intrinsic_wo_chain:{ *:[v4i32] } 602:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } ?:{ *:[v4f32] }:$Rn)
     /* 172590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 172593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172597 */     GIR_RootConstrainSelectedInstOperands,
     /* 172598 */     // GIR_Coverage, 5001,
     /* 172598 */     GIR_EraseRootFromParent_Done,
     /* 172599 */   // Label 3231: @172599
     /* 172599 */   GIM_Try, /*On fail goto*//*Label 3232*/ GIMT_Encode4(172628), // Rule ID 5002 //
     /* 172604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 172609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 172612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 172615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172619 */     // (intrinsic_wo_chain:{ *:[v2i64] } 602:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } ?:{ *:[v2f64] }:$Rn)
     /* 172619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 172622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172626 */     GIR_RootConstrainSelectedInstOperands,
     /* 172627 */     // GIR_Coverage, 5002,
     /* 172627 */     GIR_EraseRootFromParent_Done,
     /* 172628 */   // Label 3232: @172628
     /* 172628 */   GIM_Try, /*On fail goto*//*Label 3233*/ GIMT_Encode4(172657), // Rule ID 5003 //
     /* 172633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 172638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172648 */     // (intrinsic_wo_chain:{ *:[v4i16] } 603:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } ?:{ *:[v4f16] }:$Rn)
     /* 172648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 172651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172655 */     GIR_RootConstrainSelectedInstOperands,
     /* 172656 */     // GIR_Coverage, 5003,
     /* 172656 */     GIR_EraseRootFromParent_Done,
     /* 172657 */   // Label 3233: @172657
     /* 172657 */   GIM_Try, /*On fail goto*//*Label 3234*/ GIMT_Encode4(172686), // Rule ID 5004 //
     /* 172662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 172667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 172670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 172673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172677 */     // (intrinsic_wo_chain:{ *:[v8i16] } 603:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } ?:{ *:[v8f16] }:$Rn)
     /* 172677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 172680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172684 */     GIR_RootConstrainSelectedInstOperands,
     /* 172685 */     // GIR_Coverage, 5004,
     /* 172685 */     GIR_EraseRootFromParent_Done,
     /* 172686 */   // Label 3234: @172686
     /* 172686 */   GIM_Try, /*On fail goto*//*Label 3235*/ GIMT_Encode4(172715), // Rule ID 5005 //
     /* 172691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 172696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 172699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172706 */     // (intrinsic_wo_chain:{ *:[v2i32] } 603:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } ?:{ *:[v2f32] }:$Rn)
     /* 172706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 172709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172713 */     GIR_RootConstrainSelectedInstOperands,
     /* 172714 */     // GIR_Coverage, 5005,
     /* 172714 */     GIR_EraseRootFromParent_Done,
     /* 172715 */   // Label 3235: @172715
     /* 172715 */   GIM_Try, /*On fail goto*//*Label 3236*/ GIMT_Encode4(172744), // Rule ID 5006 //
     /* 172720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 172725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 172728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172735 */     // (intrinsic_wo_chain:{ *:[v4i32] } 603:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } ?:{ *:[v4f32] }:$Rn)
     /* 172735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 172738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172742 */     GIR_RootConstrainSelectedInstOperands,
     /* 172743 */     // GIR_Coverage, 5006,
     /* 172743 */     GIR_EraseRootFromParent_Done,
     /* 172744 */   // Label 3236: @172744
     /* 172744 */   GIM_Try, /*On fail goto*//*Label 3237*/ GIMT_Encode4(172773), // Rule ID 5007 //
     /* 172749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 172754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 172757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 172760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172764 */     // (intrinsic_wo_chain:{ *:[v2i64] } 603:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } ?:{ *:[v2f64] }:$Rn)
     /* 172764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 172767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172771 */     GIR_RootConstrainSelectedInstOperands,
     /* 172772 */     // GIR_Coverage, 5007,
     /* 172772 */     GIR_EraseRootFromParent_Done,
     /* 172773 */   // Label 3237: @172773
     /* 172773 */   GIM_Try, /*On fail goto*//*Label 3238*/ GIMT_Encode4(172805), // Rule ID 8518 //
     /* 172778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 172781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 172786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 172789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 172792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 172796 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1670:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv8i1] } ?:{ *:[nxv16i1] }:$Op1)
     /* 172796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 172799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 172801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 172803 */     GIR_RootConstrainSelectedInstOperands,
     /* 172804 */     // GIR_Coverage, 8518,
     /* 172804 */     GIR_EraseRootFromParent_Done,
     /* 172805 */   // Label 3238: @172805
     /* 172805 */   GIM_Try, /*On fail goto*//*Label 3239*/ GIMT_Encode4(172837), // Rule ID 8519 //
     /* 172810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 172813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 172818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 172821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 172824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 172828 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1670:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv4i1] } ?:{ *:[nxv8i1] }:$Op1)
     /* 172828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 172831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 172833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 172835 */     GIR_RootConstrainSelectedInstOperands,
     /* 172836 */     // GIR_Coverage, 8519,
     /* 172836 */     GIR_EraseRootFromParent_Done,
     /* 172837 */   // Label 3239: @172837
     /* 172837 */   GIM_Try, /*On fail goto*//*Label 3240*/ GIMT_Encode4(172869), // Rule ID 8520 //
     /* 172842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 172845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 172850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 172853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 172856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 172860 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1670:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv2i1] } ?:{ *:[nxv4i1] }:$Op1)
     /* 172860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 172863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 172865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 172867 */     GIR_RootConstrainSelectedInstOperands,
     /* 172868 */     // GIR_Coverage, 8520,
     /* 172868 */     GIR_EraseRootFromParent_Done,
     /* 172869 */   // Label 3240: @172869
     /* 172869 */   GIM_Try, /*On fail goto*//*Label 3241*/ GIMT_Encode4(172901), // Rule ID 11941 //
     /* 172874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 172877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 172882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 172885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 172888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 172892 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2054:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (UQXTNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 172892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_B),
     /* 172895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 172897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 172899 */     GIR_RootConstrainSelectedInstOperands,
     /* 172900 */     // GIR_Coverage, 11941,
     /* 172900 */     GIR_EraseRootFromParent_Done,
     /* 172901 */   // Label 3241: @172901
     /* 172901 */   GIM_Try, /*On fail goto*//*Label 3242*/ GIMT_Encode4(172933), // Rule ID 11942 //
     /* 172906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 172909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 172914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 172917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 172920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 172924 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2054:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (UQXTNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 172924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_H),
     /* 172927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 172929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 172931 */     GIR_RootConstrainSelectedInstOperands,
     /* 172932 */     // GIR_Coverage, 11942,
     /* 172932 */     GIR_EraseRootFromParent_Done,
     /* 172933 */   // Label 3242: @172933
     /* 172933 */   GIM_Try, /*On fail goto*//*Label 3243*/ GIMT_Encode4(172965), // Rule ID 11943 //
     /* 172938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 172941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 172946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 172949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 172952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 172956 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2054:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (UQXTNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 172956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_S),
     /* 172959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 172961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 172963 */     GIR_RootConstrainSelectedInstOperands,
     /* 172964 */     // GIR_Coverage, 11943,
     /* 172964 */     GIR_EraseRootFromParent_Done,
     /* 172965 */   // Label 3243: @172965
     /* 172965 */   GIM_Try, /*On fail goto*//*Label 3244*/ GIMT_Encode4(172997), // Rule ID 11944 //
     /* 172970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 172973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 172978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 172981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 172984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 172988 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1863:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (SQXTUNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 172988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_B),
     /* 172991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 172993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 172995 */     GIR_RootConstrainSelectedInstOperands,
     /* 172996 */     // GIR_Coverage, 11944,
     /* 172996 */     GIR_EraseRootFromParent_Done,
     /* 172997 */   // Label 3244: @172997
     /* 172997 */   GIM_Try, /*On fail goto*//*Label 3245*/ GIMT_Encode4(173029), // Rule ID 11945 //
     /* 173002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 173005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 173010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 173013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 173016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 173020 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1863:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (SQXTUNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 173020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_H),
     /* 173023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 173025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 173027 */     GIR_RootConstrainSelectedInstOperands,
     /* 173028 */     // GIR_Coverage, 11945,
     /* 173028 */     GIR_EraseRootFromParent_Done,
     /* 173029 */   // Label 3245: @173029
     /* 173029 */   GIM_Try, /*On fail goto*//*Label 3246*/ GIMT_Encode4(173061), // Rule ID 11946 //
     /* 173034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 173037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 173042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 173045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 173048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 173052 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1863:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (SQXTUNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 173052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_S),
     /* 173055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 173057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 173059 */     GIR_RootConstrainSelectedInstOperands,
     /* 173060 */     // GIR_Coverage, 11946,
     /* 173060 */     GIR_EraseRootFromParent_Done,
     /* 173061 */   // Label 3246: @173061
     /* 173061 */   GIM_Try, /*On fail goto*//*Label 3247*/ GIMT_Encode4(173093), // Rule ID 12112 //
     /* 173066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_AES_HasSVEAES),
     /* 173069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesimc),
     /* 173074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 173077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 173080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 173084 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1270:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (AESIMC_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1)
     /* 173084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMC_ZZ_B),
     /* 173087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 173089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 173091 */     GIR_RootConstrainSelectedInstOperands,
     /* 173092 */     // GIR_Coverage, 12112,
     /* 173092 */     GIR_EraseRootFromParent_Done,
     /* 173093 */   // Label 3247: @173093
     /* 173093 */   GIM_Reject,
     /* 173094 */ // Label 2928: @173094
     /* 173094 */ GIM_Try, /*On fail goto*//*Label 3248*/ GIMT_Encode4(215531),
     /* 173099 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 173102 */   GIM_Try, /*On fail goto*//*Label 3249*/ GIMT_Encode4(173286), // Rule ID 2564 //
     /* 173107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 173115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 173118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 173121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 173124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 173136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 173140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 173144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 173148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 173152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 173156 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 173159 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 173164 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173168 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173172 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173177 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 173181 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 173185 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 173189 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 173193 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 173197 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 173201 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 173205 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 173210 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /* 173214 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 173218 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 173222 */     // MIs[5] Operand 1
     /* 173222 */     // No operand predicates
     /* 173222 */     // MIs[3] Operand 2
     /* 173222 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /* 173233 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 173237 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /* 173239 */     // (intrinsic_wo_chain:{ *:[i32] } 689:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 173239 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 173242 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 173246 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173251 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 173257 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 173262 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 173270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 173274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 173277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /* 173281 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/5, // idx
     /* 173284 */     GIR_RootConstrainSelectedInstOperands,
     /* 173285 */     // GIR_Coverage, 2564,
     /* 173285 */     GIR_EraseRootFromParent_Done,
     /* 173286 */   // Label 3249: @173286
     /* 173286 */   GIM_Try, /*On fail goto*//*Label 3250*/ GIMT_Encode4(173470), // Rule ID 6327 //
     /* 173291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 173299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 173302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 173305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 173308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 173320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 173324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 173328 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 173332 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 173336 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 173340 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 173343 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 173348 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173352 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173356 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173361 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 173365 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 173369 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 173373 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 173377 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 173381 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 173385 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 173389 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 173394 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /* 173398 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 173402 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 173406 */     // MIs[5] Operand 1
     /* 173406 */     // No operand predicates
     /* 173406 */     // MIs[3] Operand 2
     /* 173406 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /* 173417 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 173421 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /* 173423 */     // (intrinsic_wo_chain:{ *:[i32] } 708:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 173423 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 173426 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 173430 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173435 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 173441 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 173446 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 173454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 173458 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 173461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /* 173465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/5, // idx
     /* 173468 */     GIR_RootConstrainSelectedInstOperands,
     /* 173469 */     // GIR_Coverage, 6327,
     /* 173469 */     GIR_EraseRootFromParent_Done,
     /* 173470 */   // Label 3250: @173470
     /* 173470 */   GIM_Try, /*On fail goto*//*Label 3251*/ GIMT_Encode4(173631), // Rule ID 2565 //
     /* 173475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 173483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 173486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 173489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 173492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 173504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 173508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 173512 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 173516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 173520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 173524 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 173527 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 173532 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173536 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173540 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173545 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 173549 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 173553 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 173557 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 173561 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 173566 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 173570 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 173574 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 173578 */     // MIs[4] Operand 1
     /* 173578 */     // No operand predicates
     /* 173578 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 173582 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 173584 */     // (intrinsic_wo_chain:{ *:[i32] } 689:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 173584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 173587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 173591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173596 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 173602 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 173607 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 173615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 173619 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 173622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 173626 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 173629 */     GIR_RootConstrainSelectedInstOperands,
     /* 173630 */     // GIR_Coverage, 2565,
     /* 173630 */     GIR_EraseRootFromParent_Done,
     /* 173631 */   // Label 3251: @173631
     /* 173631 */   GIM_Try, /*On fail goto*//*Label 3252*/ GIMT_Encode4(173792), // Rule ID 6328 //
     /* 173636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 173644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 173647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 173650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 173653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 173665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 173669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 173673 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 173677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 173681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 173685 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 173688 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 173693 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173697 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173701 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173706 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 173710 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 173714 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 173718 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 173722 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 173727 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 173731 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 173735 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 173739 */     // MIs[4] Operand 1
     /* 173739 */     // No operand predicates
     /* 173739 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 173743 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 173745 */     // (intrinsic_wo_chain:{ *:[i32] } 708:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 173745 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 173748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 173752 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173757 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 173763 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 173768 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 173776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 173780 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 173783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 173787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 173790 */     GIR_RootConstrainSelectedInstOperands,
     /* 173791 */     // GIR_Coverage, 6328,
     /* 173791 */     GIR_EraseRootFromParent_Done,
     /* 173792 */   // Label 3252: @173792
     /* 173792 */   GIM_Try, /*On fail goto*//*Label 3253*/ GIMT_Encode4(173902), // Rule ID 2085 //
     /* 173797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 173805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 173808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 173822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 173826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 173830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 173834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 173838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 173842 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 173846 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 173851 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 173855 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 173859 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 173863 */     // MIs[3] Operand 1
     /* 173863 */     // No operand predicates
     /* 173863 */     // MIs[1] Operand 2
     /* 173863 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 173874 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 173876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 173883 */     // (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (SQDMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 173883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv8i16_indexed),
     /* 173886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 173893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 173897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 173900 */     GIR_RootConstrainSelectedInstOperands,
     /* 173901 */     // GIR_Coverage, 2085,
     /* 173901 */     GIR_EraseRootFromParent_Done,
     /* 173902 */   // Label 3253: @173902
     /* 173902 */   GIM_Try, /*On fail goto*//*Label 3254*/ GIMT_Encode4(174012), // Rule ID 2088 //
     /* 173907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 173915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 173918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 173921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 173924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 173932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 173936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 173940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 173944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 173948 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 173952 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 173956 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173961 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 173965 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 173969 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 173973 */     // MIs[3] Operand 1
     /* 173973 */     // No operand predicates
     /* 173973 */     // MIs[1] Operand 2
     /* 173973 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 173984 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 173986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 173993 */     // (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (SQDMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 173993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i32_indexed),
     /* 173996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 174003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 174007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 174010 */     GIR_RootConstrainSelectedInstOperands,
     /* 174011 */     // GIR_Coverage, 2088,
     /* 174011 */     GIR_EraseRootFromParent_Done,
     /* 174012 */   // Label 3254: @174012
     /* 174012 */   GIM_Try, /*On fail goto*//*Label 3255*/ GIMT_Encode4(174134), // Rule ID 6989 //
     /* 174017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 174022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 174025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 174028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 174031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 174039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 174047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174052 */     // MIs[1] Operand 2
     /* 174052 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 174063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 174067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174071 */     // MIs[2] Rn
     /* 174071 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 174076 */     // MIs[2] Operand 2
     /* 174076 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 174087 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 174089 */     // (intrinsic_wo_chain:{ *:[v2i32] } 580:{ *:[iPTR] }, (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 174089 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 174092 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /* 174096 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174101 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174105 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174116 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 174123 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174128 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174133 */     // GIR_Coverage, 6989,
     /* 174133 */     GIR_EraseRootFromParent_Done,
     /* 174134 */   // Label 3255: @174134
     /* 174134 */   GIM_Try, /*On fail goto*//*Label 3256*/ GIMT_Encode4(174256), // Rule ID 6991 //
     /* 174139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 174144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 174161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 174169 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174174 */     // MIs[1] Operand 2
     /* 174174 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 174185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 174189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174193 */     // MIs[2] Rn
     /* 174193 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 174198 */     // MIs[2] Operand 2
     /* 174198 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 174209 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 174211 */     // (intrinsic_wo_chain:{ *:[v4i16] } 580:{ *:[iPTR] }, (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /* 174211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 174214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /* 174218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174223 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174227 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174231 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174238 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 174245 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174250 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174255 */     // GIR_Coverage, 6991,
     /* 174255 */     GIR_EraseRootFromParent_Done,
     /* 174256 */   // Label 3256: @174256
     /* 174256 */   GIM_Try, /*On fail goto*//*Label 3257*/ GIMT_Encode4(174378), // Rule ID 6993 //
     /* 174261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 174266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 174269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 174272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 174275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 174283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 174291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174296 */     // MIs[1] Operand 2
     /* 174296 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 174307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 174311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174315 */     // MIs[2] Rn
     /* 174315 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 174320 */     // MIs[2] Operand 2
     /* 174320 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 174331 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 174333 */     // (intrinsic_wo_chain:{ *:[v8i8] } 580:{ *:[iPTR] }, (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /* 174333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 174336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /* 174340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174345 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174349 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174353 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174360 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 174367 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174372 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174377 */     // GIR_Coverage, 6993,
     /* 174377 */     GIR_EraseRootFromParent_Done,
     /* 174378 */   // Label 3257: @174378
     /* 174378 */   GIM_Try, /*On fail goto*//*Label 3258*/ GIMT_Encode4(174500), // Rule ID 6995 //
     /* 174383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 174388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 174391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 174394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 174397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 174405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 174413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174418 */     // MIs[1] Operand 2
     /* 174418 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 174429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 174433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174437 */     // MIs[2] Rn
     /* 174437 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 174442 */     // MIs[2] Operand 2
     /* 174442 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 174453 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 174455 */     // (intrinsic_wo_chain:{ *:[v2f32] } 589:{ *:[iPTR] }, (extract_subvector:{ *:[v2f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2f32] } FPR128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (FADDPv4f32:{ *:[f128] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] })
     /* 174455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 174458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 174462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174467 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174471 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174475 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174482 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 174489 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174494 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174499 */     // GIR_Coverage, 6995,
     /* 174499 */     GIR_EraseRootFromParent_Done,
     /* 174500 */   // Label 3258: @174500
     /* 174500 */   GIM_Try, /*On fail goto*//*Label 3259*/ GIMT_Encode4(174622), // Rule ID 6997 //
     /* 174505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 174510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 174527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 174535 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174540 */     // MIs[1] Operand 2
     /* 174540 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 174551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 174555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174559 */     // MIs[2] Rn
     /* 174559 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 174564 */     // MIs[2] Operand 2
     /* 174564 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 174575 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 174577 */     // (intrinsic_wo_chain:{ *:[v4f16] } 589:{ *:[iPTR] }, (extract_subvector:{ *:[v4f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4f16] } FPR128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (FADDPv8f16:{ *:[f128] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rn), dsub:{ *:[i32] })
     /* 174577 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 174580 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 174584 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174589 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174593 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174597 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174604 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 174611 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174616 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174621 */     // GIR_Coverage, 6997,
     /* 174621 */     GIR_EraseRootFromParent_Done,
     /* 174622 */   // Label 3259: @174622
     /* 174622 */   GIM_Try, /*On fail goto*//*Label 3260*/ GIMT_Encode4(174805), // Rule ID 2563 //
     /* 174627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 174635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 174638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 174641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 174644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 174656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 174660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 174664 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 174668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 174672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 174676 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 174679 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 174684 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174688 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174692 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174697 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174702 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 174706 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 174708 */     // (intrinsic_wo_chain:{ *:[i32] } 689:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v4i16] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 174708 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 174711 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174715 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 174722 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 174725 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 174729 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174734 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 174737 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /* 174741 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 174744 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174749 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174754 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 174762 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174766 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174771 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 174777 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 174782 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 174790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 174794 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174797 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 174800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174803 */     GIR_RootConstrainSelectedInstOperands,
     /* 174804 */     // GIR_Coverage, 2563,
     /* 174804 */     GIR_EraseRootFromParent_Done,
     /* 174805 */   // Label 3260: @174805
     /* 174805 */   GIM_Try, /*On fail goto*//*Label 3261*/ GIMT_Encode4(174988), // Rule ID 6326 //
     /* 174810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 174818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 174821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 174824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 174827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 174839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 174843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 174847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 174851 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 174855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 174859 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 174862 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 174867 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174871 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174875 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174880 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174885 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 174889 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 174891 */     // (intrinsic_wo_chain:{ *:[i32] } 708:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v4i16] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 174891 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 174894 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174898 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174903 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 174905 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 174908 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 174912 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174917 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 174920 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /* 174924 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 174927 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174932 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174937 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 174945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174954 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 174960 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 174965 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 174973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 174977 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174980 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 174983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174986 */     GIR_RootConstrainSelectedInstOperands,
     /* 174987 */     // GIR_Coverage, 6326,
     /* 174987 */     GIR_EraseRootFromParent_Done,
     /* 174988 */   // Label 3261: @174988
     /* 174988 */   GIM_Try, /*On fail goto*//*Label 3262*/ GIMT_Encode4(175092), // Rule ID 13581 //
     /* 174993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 174996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 175004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 175007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 175010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 175018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 175022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 175026 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 175030 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 175034 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 175038 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 175042 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 175047 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 175051 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175055 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 175059 */     // MIs[3] Operand 1
     /* 175059 */     // No operand predicates
     /* 175059 */     // MIs[1] Operand 2
     /* 175059 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 175070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175074 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175076 */     // (intrinsic_wo_chain:{ *:[v4f16] } 620:{ *:[iPTR] }, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 175076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 175079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 175083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 175087 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 175090 */     GIR_RootConstrainSelectedInstOperands,
     /* 175091 */     // GIR_Coverage, 13581,
     /* 175091 */     GIR_EraseRootFromParent_Done,
     /* 175092 */   // Label 3262: @175092
     /* 175092 */   GIM_Try, /*On fail goto*//*Label 3263*/ GIMT_Encode4(175196), // Rule ID 13584 //
     /* 175097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 175108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 175111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 175114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 175122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 175126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 175134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 175138 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175142 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 175146 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175151 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 175155 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175159 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 175163 */     // MIs[3] Operand 1
     /* 175163 */     // No operand predicates
     /* 175163 */     // MIs[1] Operand 2
     /* 175163 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 175174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175178 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175180 */     // (intrinsic_wo_chain:{ *:[v2f32] } 620:{ *:[iPTR] }, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 175180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 175183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 175187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 175191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 175194 */     GIR_RootConstrainSelectedInstOperands,
     /* 175195 */     // GIR_Coverage, 13584,
     /* 175195 */     GIR_EraseRootFromParent_Done,
     /* 175196 */   // Label 3263: @175196
     /* 175196 */   GIM_Try, /*On fail goto*//*Label 3264*/ GIMT_Encode4(175327), // Rule ID 2520 //
     /* 175201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 175204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 175212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 175215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 175218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 175222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 175226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 175234 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 175238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175243 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 175247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 175251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175255 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 175259 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 175263 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175268 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 175272 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175276 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 175280 */     // MIs[3] Operand 1
     /* 175280 */     // No operand predicates
     /* 175280 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175282 */     // (intrinsic_wo_chain:{ *:[f16] } 620:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 175282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 175285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 175289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175294 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 175300 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 175305 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 175313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175315 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 175322 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 175325 */     GIR_RootConstrainSelectedInstOperands,
     /* 175326 */     // GIR_Coverage, 2520,
     /* 175326 */     GIR_EraseRootFromParent_Done,
     /* 175327 */   // Label 3264: @175327
     /* 175327 */   GIM_Try, /*On fail goto*//*Label 3265*/ GIMT_Encode4(175458), // Rule ID 2521 //
     /* 175332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 175343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 175346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 175349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 175357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175365 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 175369 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175374 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 175378 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 175382 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175386 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175390 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 175394 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175399 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 175403 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175407 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 175411 */     // MIs[3] Operand 1
     /* 175411 */     // No operand predicates
     /* 175411 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175413 */     // (intrinsic_wo_chain:{ *:[f32] } 620:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 175413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 175416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 175420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175425 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 175431 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175436 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 175444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175446 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 175453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 175456 */     GIR_RootConstrainSelectedInstOperands,
     /* 175457 */     // GIR_Coverage, 2521,
     /* 175457 */     GIR_EraseRootFromParent_Done,
     /* 175458 */   // Label 3265: @175458
     /* 175458 */   GIM_Try, /*On fail goto*//*Label 3266*/ GIMT_Encode4(175589), // Rule ID 2522 //
     /* 175463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 175474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 175477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 175480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 175488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 175496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 175500 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175505 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 175509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 175513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 175521 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 175525 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175530 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 175534 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175538 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 175542 */     // MIs[3] Operand 1
     /* 175542 */     // No operand predicates
     /* 175542 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175544 */     // (intrinsic_wo_chain:{ *:[f64] } 620:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 175544 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 175547 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 175551 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175556 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 175562 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175567 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 175575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175577 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 175584 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 175587 */     GIR_RootConstrainSelectedInstOperands,
     /* 175588 */     // GIR_Coverage, 2522,
     /* 175588 */     GIR_EraseRootFromParent_Done,
     /* 175589 */   // Label 3266: @175589
     /* 175589 */   GIM_Try, /*On fail goto*//*Label 3267*/ GIMT_Encode4(175720), // Rule ID 13773 //
     /* 175594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 175597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 175605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 175608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 175611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 175615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 175619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175623 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 175627 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 175631 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175636 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 175640 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175644 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 175648 */     // MIs[2] Operand 1
     /* 175648 */     // No operand predicates
     /* 175648 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 175652 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175656 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 175660 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 175664 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175669 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 175673 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175675 */     // (intrinsic_wo_chain:{ *:[f16] } 620:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 175675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 175678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 175682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175687 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 175693 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 175698 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 175706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175708 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 175715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 175718 */     GIR_RootConstrainSelectedInstOperands,
     /* 175719 */     // GIR_Coverage, 13773,
     /* 175719 */     GIR_EraseRootFromParent_Done,
     /* 175720 */   // Label 3267: @175720
     /* 175720 */   GIM_Try, /*On fail goto*//*Label 3268*/ GIMT_Encode4(175851), // Rule ID 13774 //
     /* 175725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 175736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 175739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 175742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 175750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175758 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 175762 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175767 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 175771 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175775 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 175779 */     // MIs[2] Operand 1
     /* 175779 */     // No operand predicates
     /* 175779 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 175783 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175787 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175791 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 175795 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175800 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 175804 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175806 */     // (intrinsic_wo_chain:{ *:[f32] } 620:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 175806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 175809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 175813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175818 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 175824 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175829 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 175837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175839 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 175846 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 175849 */     GIR_RootConstrainSelectedInstOperands,
     /* 175850 */     // GIR_Coverage, 13774,
     /* 175850 */     GIR_EraseRootFromParent_Done,
     /* 175851 */   // Label 3268: @175851
     /* 175851 */   GIM_Try, /*On fail goto*//*Label 3269*/ GIMT_Encode4(175982), // Rule ID 13775 //
     /* 175856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 175867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 175870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 175873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 175881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 175889 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 175893 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 175902 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175906 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 175910 */     // MIs[2] Operand 1
     /* 175910 */     // No operand predicates
     /* 175910 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 175914 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175918 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 175922 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 175926 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175931 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 175935 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175937 */     // (intrinsic_wo_chain:{ *:[f64] } 620:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 175937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 175940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 175944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175949 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 175955 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175960 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 175968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 175977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 175980 */     GIR_RootConstrainSelectedInstOperands,
     /* 175981 */     // GIR_Coverage, 13775,
     /* 175981 */     GIR_EraseRootFromParent_Done,
     /* 175982 */   // Label 3269: @175982
     /* 175982 */   GIM_Try, /*On fail goto*//*Label 3270*/ GIMT_Encode4(176096), // Rule ID 2061 //
     /* 175987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 175995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 175998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 176020 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 176023 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 176028 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 176032 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 176036 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 176045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 176049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176053 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176057 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176062 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176066 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176070 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 176074 */     // MIs[3] Operand 1
     /* 176074 */     // No operand predicates
     /* 176074 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176076 */     // (intrinsic_wo_chain:{ *:[i64] } 689:{ *:[iPTR] }, FPR64Op:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 694:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLALv1i64_indexed:{ *:[i64] } FPR64Op:{ *:[i64] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i64_indexed),
     /* 176079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 176083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 176087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 176091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 176094 */     GIR_RootConstrainSelectedInstOperands,
     /* 176095 */     // GIR_Coverage, 2061,
     /* 176095 */     GIR_EraseRootFromParent_Done,
     /* 176096 */   // Label 3270: @176096
     /* 176096 */   GIM_Try, /*On fail goto*//*Label 3271*/ GIMT_Encode4(176210), // Rule ID 2068 //
     /* 176101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 176109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 176134 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 176137 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 176142 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 176146 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 176150 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 176159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 176163 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176167 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176171 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176176 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176180 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176184 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 176188 */     // MIs[3] Operand 1
     /* 176188 */     // No operand predicates
     /* 176188 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176190 */     // (intrinsic_wo_chain:{ *:[i64] } 708:{ *:[iPTR] }, FPR64Op:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 694:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLSLv1i64_indexed:{ *:[i64] } FPR64Op:{ *:[i64] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i64_indexed),
     /* 176193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 176197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 176201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 176205 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 176208 */     GIR_RootConstrainSelectedInstOperands,
     /* 176209 */     // GIR_Coverage, 2068,
     /* 176209 */     GIR_EraseRootFromParent_Done,
     /* 176210 */   // Label 3271: @176210
     /* 176210 */   GIM_Try, /*On fail goto*//*Label 3272*/ GIMT_Encode4(176314), // Rule ID 1987 //
     /* 176215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 176218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 176223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 176226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 176248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 176256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 176260 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176264 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176268 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 176273 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176277 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176281 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 176285 */     // MIs[3] Operand 1
     /* 176285 */     // No operand predicates
     /* 176285 */     // MIs[1] Operand 2
     /* 176285 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 176296 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176298 */     // (intrinsic_wo_chain:{ *:[v4f16] } 620:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 176301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 176309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 176312 */     GIR_RootConstrainSelectedInstOperands,
     /* 176313 */     // GIR_Coverage, 1987,
     /* 176313 */     GIR_EraseRootFromParent_Done,
     /* 176314 */   // Label 3272: @176314
     /* 176314 */   GIM_Try, /*On fail goto*//*Label 3273*/ GIMT_Encode4(176418), // Rule ID 2017 //
     /* 176319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 176327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 176330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 176352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176356 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 176360 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 176364 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176368 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176372 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 176377 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176381 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176385 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 176389 */     // MIs[3] Operand 1
     /* 176389 */     // No operand predicates
     /* 176389 */     // MIs[1] Operand 2
     /* 176389 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 176400 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176402 */     // (intrinsic_wo_chain:{ *:[v4i16] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16_indexed),
     /* 176405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 176413 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 176416 */     GIR_RootConstrainSelectedInstOperands,
     /* 176417 */     // GIR_Coverage, 2017,
     /* 176417 */     GIR_EraseRootFromParent_Done,
     /* 176418 */   // Label 3273: @176418
     /* 176418 */   GIM_Try, /*On fail goto*//*Label 3274*/ GIMT_Encode4(176522), // Rule ID 2024 //
     /* 176423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 176431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 176434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 176456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 176464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 176468 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176472 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176476 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 176481 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176485 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176489 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 176493 */     // MIs[3] Operand 1
     /* 176493 */     // No operand predicates
     /* 176493 */     // MIs[1] Operand 2
     /* 176493 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 176504 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176506 */     // (intrinsic_wo_chain:{ *:[v4i16] } 698:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16_indexed),
     /* 176509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 176517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 176520 */     GIR_RootConstrainSelectedInstOperands,
     /* 176521 */     // GIR_Coverage, 2024,
     /* 176521 */     GIR_EraseRootFromParent_Done,
     /* 176522 */   // Label 3274: @176522
     /* 176522 */   GIM_Try, /*On fail goto*//*Label 3275*/ GIMT_Encode4(176626), // Rule ID 2083 //
     /* 176527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 176535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 176538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 176560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 176568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 176572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176576 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176580 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 176585 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176589 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176593 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 176597 */     // MIs[3] Operand 1
     /* 176597 */     // No operand predicates
     /* 176597 */     // MIs[1] Operand 2
     /* 176597 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 176608 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176610 */     // (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_indexed),
     /* 176613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 176621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 176624 */     GIR_RootConstrainSelectedInstOperands,
     /* 176625 */     // GIR_Coverage, 2083,
     /* 176625 */     GIR_EraseRootFromParent_Done,
     /* 176626 */   // Label 3275: @176626
     /* 176626 */   GIM_Try, /*On fail goto*//*Label 3276*/ GIMT_Encode4(176730), // Rule ID 1990 //
     /* 176631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 176639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 176642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 176645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 176648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 176664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 176672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 176676 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176680 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176684 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176689 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176693 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176697 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 176701 */     // MIs[3] Operand 1
     /* 176701 */     // No operand predicates
     /* 176701 */     // MIs[1] Operand 2
     /* 176701 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 176712 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176714 */     // (intrinsic_wo_chain:{ *:[v2f32] } 620:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 176717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 176725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 176728 */     GIR_RootConstrainSelectedInstOperands,
     /* 176729 */     // GIR_Coverage, 1990,
     /* 176729 */     GIR_EraseRootFromParent_Done,
     /* 176730 */   // Label 3276: @176730
     /* 176730 */   GIM_Try, /*On fail goto*//*Label 3277*/ GIMT_Encode4(176834), // Rule ID 2020 //
     /* 176735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 176743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 176746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 176749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 176752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 176768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 176776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 176780 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176784 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176788 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176793 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176797 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176801 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 176805 */     // MIs[3] Operand 1
     /* 176805 */     // No operand predicates
     /* 176805 */     // MIs[1] Operand 2
     /* 176805 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 176816 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176818 */     // (intrinsic_wo_chain:{ *:[v2i32] } 690:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32_indexed),
     /* 176821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 176829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 176832 */     GIR_RootConstrainSelectedInstOperands,
     /* 176833 */     // GIR_Coverage, 2020,
     /* 176833 */     GIR_EraseRootFromParent_Done,
     /* 176834 */   // Label 3277: @176834
     /* 176834 */   GIM_Try, /*On fail goto*//*Label 3278*/ GIMT_Encode4(176938), // Rule ID 2027 //
     /* 176839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 176847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 176850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 176853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 176856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 176872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 176880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 176884 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176888 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176892 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176897 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176901 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176905 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 176909 */     // MIs[3] Operand 1
     /* 176909 */     // No operand predicates
     /* 176909 */     // MIs[1] Operand 2
     /* 176909 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 176920 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176922 */     // (intrinsic_wo_chain:{ *:[v2i32] } 698:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32_indexed),
     /* 176925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 176933 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 176936 */     GIR_RootConstrainSelectedInstOperands,
     /* 176937 */     // GIR_Coverage, 2027,
     /* 176937 */     GIR_EraseRootFromParent_Done,
     /* 176938 */   // Label 3278: @176938
     /* 176938 */   GIM_Try, /*On fail goto*//*Label 3279*/ GIMT_Encode4(177042), // Rule ID 2086 //
     /* 176943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 176951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 176954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 176957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 176960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 176976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 176984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 176988 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176992 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176996 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177001 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 177005 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 177009 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 177013 */     // MIs[3] Operand 1
     /* 177013 */     // No operand predicates
     /* 177013 */     // MIs[1] Operand 2
     /* 177013 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 177024 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 177026 */     // (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 177026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_indexed),
     /* 177029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 177037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 177040 */     GIR_RootConstrainSelectedInstOperands,
     /* 177041 */     // GIR_Coverage, 2086,
     /* 177041 */     GIR_EraseRootFromParent_Done,
     /* 177042 */   // Label 3279: @177042
     /* 177042 */   GIM_Try, /*On fail goto*//*Label 3280*/ GIMT_Encode4(177099), // Rule ID 1751 //
     /* 177047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 177055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 177058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 177061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 177064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 177075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 177082 */     // (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (SQDMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 177082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv8i16_v4i32),
     /* 177085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 177092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 177097 */     GIR_RootConstrainSelectedInstOperands,
     /* 177098 */     // GIR_Coverage, 1751,
     /* 177098 */     GIR_EraseRootFromParent_Done,
     /* 177099 */   // Label 3280: @177099
     /* 177099 */   GIM_Try, /*On fail goto*//*Label 3281*/ GIMT_Encode4(177156), // Rule ID 1753 //
     /* 177104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 177112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 177115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 177118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 177121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 177132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 177139 */     // (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (SQDMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 177139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i32_v2i64),
     /* 177142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 177149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 177154 */     GIR_RootConstrainSelectedInstOperands,
     /* 177155 */     // GIR_Coverage, 1753,
     /* 177155 */     GIR_EraseRootFromParent_Done,
     /* 177156 */   // Label 3281: @177156
     /* 177156 */   GIM_Try, /*On fail goto*//*Label 3282*/ GIMT_Encode4(177266), // Rule ID 6345 //
     /* 177161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 177166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 177169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 177175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 177183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 177187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 177191 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 177195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177200 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 177211 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 177215 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 177219 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 177223 */     // MIs[2] Operand 1
     /* 177223 */     // No operand predicates
     /* 177223 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 177225 */     // (intrinsic_wo_chain:{ *:[f16] } 776:{ *:[iPTR] }, (and:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 177225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 177228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177237 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 177243 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177248 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 177256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177258 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 177264 */     GIR_RootConstrainSelectedInstOperands,
     /* 177265 */     // GIR_Coverage, 6345,
     /* 177265 */     GIR_EraseRootFromParent_Done,
     /* 177266 */   // Label 3282: @177266
     /* 177266 */   GIM_Try, /*On fail goto*//*Label 3283*/ GIMT_Encode4(177363), // Rule ID 14047 //
     /* 177271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 177274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 177279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 177282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 177285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 177288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 177296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 177300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 177304 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 177308 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177313 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 177317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177323 */     // (intrinsic_wo_chain:{ *:[f16] } 620:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 177323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 177326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177335 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 177341 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177346 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 177354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 177358 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177361 */     GIR_RootConstrainSelectedInstOperands,
     /* 177362 */     // GIR_Coverage, 14047,
     /* 177362 */     GIR_EraseRootFromParent_Done,
     /* 177363 */   // Label 3283: @177363
     /* 177363 */   GIM_Try, /*On fail goto*//*Label 3284*/ GIMT_Encode4(177460), // Rule ID 14048 //
     /* 177368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 177371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 177376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 177385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 177393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 177397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 177401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 177405 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177410 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 177414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177420 */     // (intrinsic_wo_chain:{ *:[f32] } 620:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 177420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 177423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177432 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 177438 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177443 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 177451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 177455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177458 */     GIR_RootConstrainSelectedInstOperands,
     /* 177459 */     // GIR_Coverage, 14048,
     /* 177459 */     GIR_EraseRootFromParent_Done,
     /* 177460 */   // Label 3284: @177460
     /* 177460 */   GIM_Try, /*On fail goto*//*Label 3285*/ GIMT_Encode4(177557), // Rule ID 14049 //
     /* 177465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 177468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 177473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 177490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 177494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 177498 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 177502 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177507 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 177511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177517 */     // (intrinsic_wo_chain:{ *:[f64] } 620:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 177517 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 177520 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177524 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177529 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 177535 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177540 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 177548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 177552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177555 */     GIR_RootConstrainSelectedInstOperands,
     /* 177556 */     // GIR_Coverage, 14049,
     /* 177556 */     GIR_EraseRootFromParent_Done,
     /* 177557 */   // Label 3285: @177557
     /* 177557 */   GIM_Try, /*On fail goto*//*Label 3286*/ GIMT_Encode4(177637), // Rule ID 5277 //
     /* 177562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 177567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 177588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 177592 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 177595 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 177600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 177604 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 177608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177620 */     // (intrinsic_wo_chain:{ *:[i64] } 689:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 694:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm))  =>  (SQDMLALi32:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 177620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALi32),
     /* 177623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 177627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 177631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 177635 */     GIR_RootConstrainSelectedInstOperands,
     /* 177636 */     // GIR_Coverage, 5277,
     /* 177636 */     GIR_EraseRootFromParent_Done,
     /* 177637 */   // Label 3286: @177637
     /* 177637 */   GIM_Try, /*On fail goto*//*Label 3287*/ GIMT_Encode4(177717), // Rule ID 5278 //
     /* 177642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 177647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 177668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 177672 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 177675 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 177680 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 177684 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 177688 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177700 */     // (intrinsic_wo_chain:{ *:[i64] } 708:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 694:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm))  =>  (SQDMLSLi32:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 177700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLi32),
     /* 177703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 177707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 177711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 177715 */     GIR_RootConstrainSelectedInstOperands,
     /* 177716 */     // GIR_Coverage, 5278,
     /* 177716 */     GIR_EraseRootFromParent_Done,
     /* 177717 */   // Label 3287: @177717
     /* 177717 */   GIM_Try, /*On fail goto*//*Label 3288*/ GIMT_Encode4(177814), // Rule ID 5274 //
     /* 177722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 177725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 177730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 177733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 177736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 177739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 177751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 177755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 177759 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 177763 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177768 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 177772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177774 */     // (intrinsic_wo_chain:{ *:[f16] } 620:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 177774 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 177777 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177781 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177786 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 177792 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177797 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 177805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177809 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177812 */     GIR_RootConstrainSelectedInstOperands,
     /* 177813 */     // GIR_Coverage, 5274,
     /* 177813 */     GIR_EraseRootFromParent_Done,
     /* 177814 */   // Label 3288: @177814
     /* 177814 */   GIM_Try, /*On fail goto*//*Label 3289*/ GIMT_Encode4(177911), // Rule ID 5275 //
     /* 177819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 177822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 177827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 177836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 177848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 177852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 177856 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 177860 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177865 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 177869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177871 */     // (intrinsic_wo_chain:{ *:[f32] } 620:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 177871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 177874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177883 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 177889 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177894 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 177902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177909 */     GIR_RootConstrainSelectedInstOperands,
     /* 177910 */     // GIR_Coverage, 5275,
     /* 177910 */     GIR_EraseRootFromParent_Done,
     /* 177911 */   // Label 3289: @177911
     /* 177911 */   GIM_Try, /*On fail goto*//*Label 3290*/ GIMT_Encode4(178008), // Rule ID 5276 //
     /* 177916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 177919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 177924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 177945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 177949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 177953 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 177957 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177962 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 177966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177968 */     // (intrinsic_wo_chain:{ *:[f64] } 620:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 177968 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 177971 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177975 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177980 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 177986 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177991 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 177999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178003 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178006 */     GIR_RootConstrainSelectedInstOperands,
     /* 178007 */     // GIR_Coverage, 5276,
     /* 178007 */     GIR_EraseRootFromParent_Done,
     /* 178008 */   // Label 3290: @178008
     /* 178008 */   GIM_Try, /*On fail goto*//*Label 3291*/ GIMT_Encode4(178089), // Rule ID 13582 //
     /* 178013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 178016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 178024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 178027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 178030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 178038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 178042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 178046 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 178055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178063 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 178067 */     // MIs[2] Operand 1
     /* 178067 */     // No operand predicates
     /* 178067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178071 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178073 */     // (intrinsic_wo_chain:{ *:[v4f16] } 620:{ *:[iPTR] }, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 178076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178084 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178087 */     GIR_RootConstrainSelectedInstOperands,
     /* 178088 */     // GIR_Coverage, 13582,
     /* 178088 */     GIR_EraseRootFromParent_Done,
     /* 178089 */   // Label 3291: @178089
     /* 178089 */   GIM_Try, /*On fail goto*//*Label 3292*/ GIMT_Encode4(178170), // Rule ID 13583 //
     /* 178094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 178097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 178105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 178108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 178111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 178119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 178123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 178127 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178131 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 178136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178144 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 178148 */     // MIs[2] Operand 1
     /* 178148 */     // No operand predicates
     /* 178148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178152 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178154 */     // (intrinsic_wo_chain:{ *:[v8f16] } 620:{ *:[iPTR] }, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULXv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8i16_indexed),
     /* 178157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178168 */     GIR_RootConstrainSelectedInstOperands,
     /* 178169 */     // GIR_Coverage, 13583,
     /* 178169 */     GIR_EraseRootFromParent_Done,
     /* 178170 */   // Label 3292: @178170
     /* 178170 */   GIM_Try, /*On fail goto*//*Label 3293*/ GIMT_Encode4(178251), // Rule ID 13585 //
     /* 178175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 178186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 178189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 178192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 178200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 178204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 178208 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178225 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 178229 */     // MIs[2] Operand 1
     /* 178229 */     // No operand predicates
     /* 178229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178233 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178235 */     // (intrinsic_wo_chain:{ *:[v2f32] } 620:{ *:[iPTR] }, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 178238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178246 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178249 */     GIR_RootConstrainSelectedInstOperands,
     /* 178250 */     // GIR_Coverage, 13585,
     /* 178250 */     GIR_EraseRootFromParent_Done,
     /* 178251 */   // Label 3293: @178251
     /* 178251 */   GIM_Try, /*On fail goto*//*Label 3294*/ GIMT_Encode4(178332), // Rule ID 13586 //
     /* 178256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 178267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 178270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 178273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 178281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 178285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 178289 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178306 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 178310 */     // MIs[2] Operand 1
     /* 178310 */     // No operand predicates
     /* 178310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178314 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178316 */     // (intrinsic_wo_chain:{ *:[v4f32] } 620:{ *:[iPTR] }, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULXv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i32_indexed),
     /* 178319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178327 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178330 */     GIR_RootConstrainSelectedInstOperands,
     /* 178331 */     // GIR_Coverage, 13586,
     /* 178331 */     GIR_EraseRootFromParent_Done,
     /* 178332 */   // Label 3294: @178332
     /* 178332 */   GIM_Try, /*On fail goto*//*Label 3295*/ GIMT_Encode4(178413), // Rule ID 13587 //
     /* 178337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 178348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 178351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 178354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 178362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 178366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 178370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178374 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178387 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 178391 */     // MIs[2] Operand 1
     /* 178391 */     // No operand predicates
     /* 178391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178395 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178397 */     // (intrinsic_wo_chain:{ *:[v2f64] } 620:{ *:[iPTR] }, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULXv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i64_indexed),
     /* 178400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178408 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178411 */     GIR_RootConstrainSelectedInstOperands,
     /* 178412 */     // GIR_Coverage, 13587,
     /* 178412 */     GIR_EraseRootFromParent_Done,
     /* 178413 */   // Label 3295: @178413
     /* 178413 */   GIM_Try, /*On fail goto*//*Label 3296*/ GIMT_Encode4(178494), // Rule ID 13588 //
     /* 178418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 178421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 178429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 178432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 178435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 178439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 178443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 178447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 178451 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178455 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 178460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178468 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 178472 */     // MIs[2] Operand 1
     /* 178472 */     // No operand predicates
     /* 178472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 178476 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178478 */     // (intrinsic_wo_chain:{ *:[f16] } 620:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULXv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 178481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178489 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178492 */     GIR_RootConstrainSelectedInstOperands,
     /* 178493 */     // GIR_Coverage, 13588,
     /* 178493 */     GIR_EraseRootFromParent_Done,
     /* 178494 */   // Label 3296: @178494
     /* 178494 */   GIM_Try, /*On fail goto*//*Label 3297*/ GIMT_Encode4(178575), // Rule ID 13589 //
     /* 178499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 178510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 178524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 178528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 178532 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178536 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178549 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 178553 */     // MIs[2] Operand 1
     /* 178553 */     // No operand predicates
     /* 178553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178557 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178559 */     // (intrinsic_wo_chain:{ *:[f32] } 620:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULXv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 178562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178570 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178573 */     GIR_RootConstrainSelectedInstOperands,
     /* 178574 */     // GIR_Coverage, 13589,
     /* 178574 */     GIR_EraseRootFromParent_Done,
     /* 178575 */   // Label 3297: @178575
     /* 178575 */   GIM_Try, /*On fail goto*//*Label 3298*/ GIMT_Encode4(178656), // Rule ID 13590 //
     /* 178580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 178605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 178609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 178613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178617 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178630 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 178634 */     // MIs[2] Operand 1
     /* 178634 */     // No operand predicates
     /* 178634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178638 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178640 */     // (intrinsic_wo_chain:{ *:[f64] } 620:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULXv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 178643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178651 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178654 */     GIR_RootConstrainSelectedInstOperands,
     /* 178655 */     // GIR_Coverage, 13590,
     /* 178655 */     GIR_EraseRootFromParent_Done,
     /* 178656 */   // Label 3298: @178656
     /* 178656 */   GIM_Try, /*On fail goto*//*Label 3299*/ GIMT_Encode4(178762), // Rule ID 6342 //
     /* 178661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 178666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 178669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 178679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 178683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 178687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 178691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178696 */     // MIs[1] Operand 2
     /* 178696 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 178707 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 178711 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178715 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 178719 */     // MIs[2] Operand 1
     /* 178719 */     // No operand predicates
     /* 178719 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178721 */     // (intrinsic_wo_chain:{ *:[f16] } 775:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 178721 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 178724 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 178728 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178733 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 178739 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 178744 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 178752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178757 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 178760 */     GIR_RootConstrainSelectedInstOperands,
     /* 178761 */     // GIR_Coverage, 6342,
     /* 178761 */     GIR_EraseRootFromParent_Done,
     /* 178762 */   // Label 3299: @178762
     /* 178762 */   GIM_Try, /*On fail goto*//*Label 3300*/ GIMT_Encode4(178843), // Rule ID 1988 //
     /* 178767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 178770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 178778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 178781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 178784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 178800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 178804 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178808 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 178813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178821 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 178825 */     // MIs[2] Operand 1
     /* 178825 */     // No operand predicates
     /* 178825 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178827 */     // (intrinsic_wo_chain:{ *:[v4f16] } 620:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 178830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178838 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178841 */     GIR_RootConstrainSelectedInstOperands,
     /* 178842 */     // GIR_Coverage, 1988,
     /* 178842 */     GIR_EraseRootFromParent_Done,
     /* 178843 */   // Label 3300: @178843
     /* 178843 */   GIM_Try, /*On fail goto*//*Label 3301*/ GIMT_Encode4(178924), // Rule ID 1989 //
     /* 178848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 178851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 178859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 178862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 178865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 178881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 178885 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 178894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178902 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 178906 */     // MIs[2] Operand 1
     /* 178906 */     // No operand predicates
     /* 178906 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178908 */     // (intrinsic_wo_chain:{ *:[v8f16] } 620:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8i16_indexed),
     /* 178911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178919 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178922 */     GIR_RootConstrainSelectedInstOperands,
     /* 178923 */     // GIR_Coverage, 1989,
     /* 178923 */     GIR_EraseRootFromParent_Done,
     /* 178924 */   // Label 3301: @178924
     /* 178924 */   GIM_Try, /*On fail goto*//*Label 3302*/ GIMT_Encode4(179005), // Rule ID 2018 //
     /* 178929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 178937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 178940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 178943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 178946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 178962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 178966 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178970 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 178975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178983 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 178987 */     // MIs[2] Operand 1
     /* 178987 */     // No operand predicates
     /* 178987 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178989 */     // (intrinsic_wo_chain:{ *:[v4i16] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16_indexed),
     /* 178992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179000 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179003 */     GIR_RootConstrainSelectedInstOperands,
     /* 179004 */     // GIR_Coverage, 2018,
     /* 179004 */     GIR_EraseRootFromParent_Done,
     /* 179005 */   // Label 3302: @179005
     /* 179005 */   GIM_Try, /*On fail goto*//*Label 3303*/ GIMT_Encode4(179086), // Rule ID 2019 //
     /* 179010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 179018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 179021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 179024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 179027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 179043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 179047 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179051 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 179056 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179060 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179064 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 179068 */     // MIs[2] Operand 1
     /* 179068 */     // No operand predicates
     /* 179068 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179070 */     // (intrinsic_wo_chain:{ *:[v8i16] } 690:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv8i16_indexed),
     /* 179073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179084 */     GIR_RootConstrainSelectedInstOperands,
     /* 179085 */     // GIR_Coverage, 2019,
     /* 179085 */     GIR_EraseRootFromParent_Done,
     /* 179086 */   // Label 3303: @179086
     /* 179086 */   GIM_Try, /*On fail goto*//*Label 3304*/ GIMT_Encode4(179167), // Rule ID 2025 //
     /* 179091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 179099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 179102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 179105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 179108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 179124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 179128 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 179137 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179141 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179145 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 179149 */     // MIs[2] Operand 1
     /* 179149 */     // No operand predicates
     /* 179149 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179151 */     // (intrinsic_wo_chain:{ *:[v4i16] } 698:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16_indexed),
     /* 179154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179162 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179165 */     GIR_RootConstrainSelectedInstOperands,
     /* 179166 */     // GIR_Coverage, 2025,
     /* 179166 */     GIR_EraseRootFromParent_Done,
     /* 179167 */   // Label 3304: @179167
     /* 179167 */   GIM_Try, /*On fail goto*//*Label 3305*/ GIMT_Encode4(179248), // Rule ID 2026 //
     /* 179172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 179180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 179183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 179186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 179189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 179205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 179209 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179213 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 179218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179226 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 179230 */     // MIs[2] Operand 1
     /* 179230 */     // No operand predicates
     /* 179230 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179232 */     // (intrinsic_wo_chain:{ *:[v8i16] } 698:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMULHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv8i16_indexed),
     /* 179235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179246 */     GIR_RootConstrainSelectedInstOperands,
     /* 179247 */     // GIR_Coverage, 2026,
     /* 179247 */     GIR_EraseRootFromParent_Done,
     /* 179248 */   // Label 3305: @179248
     /* 179248 */   GIM_Try, /*On fail goto*//*Label 3306*/ GIMT_Encode4(179329), // Rule ID 2084 //
     /* 179253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 179261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 179264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 179267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 179270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 179286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 179290 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179294 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 179299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179307 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 179311 */     // MIs[2] Operand 1
     /* 179311 */     // No operand predicates
     /* 179311 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179313 */     // (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_indexed),
     /* 179316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179324 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179327 */     GIR_RootConstrainSelectedInstOperands,
     /* 179328 */     // GIR_Coverage, 2084,
     /* 179328 */     GIR_EraseRootFromParent_Done,
     /* 179329 */   // Label 3306: @179329
     /* 179329 */   GIM_Try, /*On fail goto*//*Label 3307*/ GIMT_Encode4(179410), // Rule ID 1991 //
     /* 179334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 179342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 179345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 179348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 179351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 179367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179371 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179388 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 179392 */     // MIs[2] Operand 1
     /* 179392 */     // No operand predicates
     /* 179392 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179394 */     // (intrinsic_wo_chain:{ *:[v2f32] } 620:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 179397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179408 */     GIR_RootConstrainSelectedInstOperands,
     /* 179409 */     // GIR_Coverage, 1991,
     /* 179409 */     GIR_EraseRootFromParent_Done,
     /* 179410 */   // Label 3307: @179410
     /* 179410 */   GIM_Try, /*On fail goto*//*Label 3308*/ GIMT_Encode4(179491), // Rule ID 1992 //
     /* 179415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 179423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 179426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 179429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 179432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 179448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179456 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179469 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 179473 */     // MIs[2] Operand 1
     /* 179473 */     // No operand predicates
     /* 179473 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179475 */     // (intrinsic_wo_chain:{ *:[v4f32] } 620:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i32_indexed),
     /* 179478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179486 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179489 */     GIR_RootConstrainSelectedInstOperands,
     /* 179490 */     // GIR_Coverage, 1992,
     /* 179490 */     GIR_EraseRootFromParent_Done,
     /* 179491 */   // Label 3308: @179491
     /* 179491 */   GIM_Try, /*On fail goto*//*Label 3309*/ GIMT_Encode4(179572), // Rule ID 2021 //
     /* 179496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 179504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 179507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 179510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 179513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 179529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179533 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179542 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179546 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179550 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 179554 */     // MIs[2] Operand 1
     /* 179554 */     // No operand predicates
     /* 179554 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179556 */     // (intrinsic_wo_chain:{ *:[v2i32] } 690:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32_indexed),
     /* 179559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179567 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179570 */     GIR_RootConstrainSelectedInstOperands,
     /* 179571 */     // GIR_Coverage, 2021,
     /* 179571 */     GIR_EraseRootFromParent_Done,
     /* 179572 */   // Label 3309: @179572
     /* 179572 */   GIM_Try, /*On fail goto*//*Label 3310*/ GIMT_Encode4(179653), // Rule ID 2022 //
     /* 179577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 179585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 179588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 179591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 179594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 179610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179618 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179623 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179627 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179631 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 179635 */     // MIs[2] Operand 1
     /* 179635 */     // No operand predicates
     /* 179635 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179637 */     // (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i32_indexed),
     /* 179640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179648 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179651 */     GIR_RootConstrainSelectedInstOperands,
     /* 179652 */     // GIR_Coverage, 2022,
     /* 179652 */     GIR_EraseRootFromParent_Done,
     /* 179653 */   // Label 3310: @179653
     /* 179653 */   GIM_Try, /*On fail goto*//*Label 3311*/ GIMT_Encode4(179734), // Rule ID 2028 //
     /* 179658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 179666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 179669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 179672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 179675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 179691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179695 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179712 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 179716 */     // MIs[2] Operand 1
     /* 179716 */     // No operand predicates
     /* 179716 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179718 */     // (intrinsic_wo_chain:{ *:[v2i32] } 698:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32_indexed),
     /* 179721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179725 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179729 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179732 */     GIR_RootConstrainSelectedInstOperands,
     /* 179733 */     // GIR_Coverage, 2028,
     /* 179733 */     GIR_EraseRootFromParent_Done,
     /* 179734 */   // Label 3311: @179734
     /* 179734 */   GIM_Try, /*On fail goto*//*Label 3312*/ GIMT_Encode4(179815), // Rule ID 2029 //
     /* 179739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 179747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 179750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 179753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 179756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 179772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179776 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179793 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 179797 */     // MIs[2] Operand 1
     /* 179797 */     // No operand predicates
     /* 179797 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179799 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i32_indexed),
     /* 179802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179810 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179813 */     GIR_RootConstrainSelectedInstOperands,
     /* 179814 */     // GIR_Coverage, 2029,
     /* 179814 */     GIR_EraseRootFromParent_Done,
     /* 179815 */   // Label 3312: @179815
     /* 179815 */   GIM_Try, /*On fail goto*//*Label 3313*/ GIMT_Encode4(179896), // Rule ID 2087 //
     /* 179820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 179828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 179831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 179834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 179837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 179853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179857 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179874 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 179878 */     // MIs[2] Operand 1
     /* 179878 */     // No operand predicates
     /* 179878 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179880 */     // (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_indexed),
     /* 179883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179894 */     GIR_RootConstrainSelectedInstOperands,
     /* 179895 */     // GIR_Coverage, 2087,
     /* 179895 */     GIR_EraseRootFromParent_Done,
     /* 179896 */   // Label 3313: @179896
     /* 179896 */   GIM_Try, /*On fail goto*//*Label 3314*/ GIMT_Encode4(179977), // Rule ID 1993 //
     /* 179901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 179909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 179912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 179915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 179918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 179934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 179938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179942 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179955 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 179959 */     // MIs[2] Operand 1
     /* 179959 */     // No operand predicates
     /* 179959 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179961 */     // (intrinsic_wo_chain:{ *:[v2f64] } 620:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i64_indexed),
     /* 179964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179972 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179975 */     GIR_RootConstrainSelectedInstOperands,
     /* 179976 */     // GIR_Coverage, 1993,
     /* 179976 */     GIR_EraseRootFromParent_Done,
     /* 179977 */   // Label 3314: @179977
     /* 179977 */   GIM_Try, /*On fail goto*//*Label 3315*/ GIMT_Encode4(180058), // Rule ID 1994 //
     /* 179982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 179985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 179990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 179993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 179996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 179999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 180003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 180007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 180015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 180019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 180028 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180032 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180036 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 180040 */     // MIs[2] Operand 1
     /* 180040 */     // No operand predicates
     /* 180040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180042 */     // (intrinsic_wo_chain:{ *:[f16] } 620:{ *:[iPTR] }, FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 180042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 180045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 180053 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180056 */     GIR_RootConstrainSelectedInstOperands,
     /* 180057 */     // GIR_Coverage, 1994,
     /* 180057 */     GIR_EraseRootFromParent_Done,
     /* 180058 */   // Label 3315: @180058
     /* 180058 */   GIM_Try, /*On fail goto*//*Label 3316*/ GIMT_Encode4(180139), // Rule ID 1995 //
     /* 180063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 180071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 180096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 180100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180113 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180117 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 180121 */     // MIs[2] Operand 1
     /* 180121 */     // No operand predicates
     /* 180121 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180123 */     // (intrinsic_wo_chain:{ *:[f32] } 620:{ *:[iPTR] }, FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 180123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 180126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 180134 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180137 */     GIR_RootConstrainSelectedInstOperands,
     /* 180138 */     // GIR_Coverage, 1995,
     /* 180138 */     GIR_EraseRootFromParent_Done,
     /* 180139 */   // Label 3316: @180139
     /* 180139 */   GIM_Try, /*On fail goto*//*Label 3317*/ GIMT_Encode4(180220), // Rule ID 1996 //
     /* 180144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 180152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 180177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 180181 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180185 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180198 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 180202 */     // MIs[2] Operand 1
     /* 180202 */     // No operand predicates
     /* 180202 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180204 */     // (intrinsic_wo_chain:{ *:[f64] } 620:{ *:[iPTR] }, FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 180204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 180207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 180215 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180218 */     GIR_RootConstrainSelectedInstOperands,
     /* 180219 */     // GIR_Coverage, 1996,
     /* 180219 */     GIR_EraseRootFromParent_Done,
     /* 180220 */   // Label 3317: @180220
     /* 180220 */   GIM_Try, /*On fail goto*//*Label 3318*/ GIMT_Encode4(180301), // Rule ID 2023 //
     /* 180225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 180233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 180258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 180262 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180266 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180279 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 180283 */     // MIs[2] Operand 1
     /* 180283 */     // No operand predicates
     /* 180283 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180285 */     // (intrinsic_wo_chain:{ *:[i32] } 690:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 180285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv1i32_indexed),
     /* 180288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 180296 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180299 */     GIR_RootConstrainSelectedInstOperands,
     /* 180300 */     // GIR_Coverage, 2023,
     /* 180300 */     GIR_EraseRootFromParent_Done,
     /* 180301 */   // Label 3318: @180301
     /* 180301 */   GIM_Try, /*On fail goto*//*Label 3319*/ GIMT_Encode4(180382), // Rule ID 2030 //
     /* 180306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 180314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 180339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 180343 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180347 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180360 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 180364 */     // MIs[2] Operand 1
     /* 180364 */     // No operand predicates
     /* 180364 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180366 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 180366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv1i32_indexed),
     /* 180369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 180377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180380 */     GIR_RootConstrainSelectedInstOperands,
     /* 180381 */     // GIR_Coverage, 2030,
     /* 180381 */     GIR_EraseRootFromParent_Done,
     /* 180382 */   // Label 3319: @180382
     /* 180382 */   GIM_Try, /*On fail goto*//*Label 3320*/ GIMT_Encode4(180460), // Rule ID 6329 //
     /* 180387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 180392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 180417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 180421 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180425 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180438 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 180442 */     // MIs[2] Operand 1
     /* 180442 */     // No operand predicates
     /* 180442 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180444 */     // (intrinsic_wo_chain:{ *:[i64] } 694:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Vm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULLv1i64_indexed:{ *:[i64] } FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Vm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 180444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv1i64_indexed),
     /* 180447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /* 180455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180458 */     GIR_RootConstrainSelectedInstOperands,
     /* 180459 */     // GIR_Coverage, 6329,
     /* 180459 */     GIR_EraseRootFromParent_Done,
     /* 180460 */   // Label 3320: @180460
     /* 180460 */   GIM_Try, /*On fail goto*//*Label 3321*/ GIMT_Encode4(180520), // Rule ID 6395 //
     /* 180465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 180470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 180473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 180476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180487 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /* 180491 */     // (intrinsic_wo_chain:{ *:[v8i8] } 667:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] })  =>  (RADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vn, (MOVIv2d_ns:{ *:[v8i16] } 0:{ *:[i32] }))
     /* 180491 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 180494 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 180498 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180503 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 180506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 180508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v8i8),
     /* 180511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 180515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 180518 */     GIR_RootConstrainSelectedInstOperands,
     /* 180519 */     // GIR_Coverage, 6395,
     /* 180519 */     GIR_EraseRootFromParent_Done,
     /* 180520 */   // Label 3321: @180520
     /* 180520 */   GIM_Try, /*On fail goto*//*Label 3322*/ GIMT_Encode4(180580), // Rule ID 6396 //
     /* 180525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 180530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 180533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 180536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180547 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /* 180551 */     // (intrinsic_wo_chain:{ *:[v4i16] } 667:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] })  =>  (RADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn, (MOVIv2d_ns:{ *:[v4i32] } 0:{ *:[i32] }))
     /* 180551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 180554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 180558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180563 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 180566 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 180568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v4i16),
     /* 180571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 180575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 180578 */     GIR_RootConstrainSelectedInstOperands,
     /* 180579 */     // GIR_Coverage, 6396,
     /* 180579 */     GIR_EraseRootFromParent_Done,
     /* 180580 */   // Label 3322: @180580
     /* 180580 */   GIM_Try, /*On fail goto*//*Label 3323*/ GIMT_Encode4(180640), // Rule ID 6397 //
     /* 180585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 180590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 180593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 180596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180607 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 32,
     /* 180611 */     // (intrinsic_wo_chain:{ *:[v2i32] } 667:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] })  =>  (RADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn, (MOVIv2d_ns:{ *:[v2i64] } 0:{ *:[i32] }))
     /* 180611 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 180614 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 180618 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180623 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 180626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 180628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v2i32),
     /* 180631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 180635 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 180638 */     GIR_RootConstrainSelectedInstOperands,
     /* 180639 */     // GIR_Coverage, 6397,
     /* 180639 */     GIR_EraseRootFromParent_Done,
     /* 180640 */   // Label 3323: @180640
     /* 180640 */   GIM_Try, /*On fail goto*//*Label 3324*/ GIMT_Encode4(180687), // Rule ID 3922 //
     /* 180645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 180648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 180653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180667 */     // MIs[0] Operand 3
     /* 180667 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 180678 */     // (intrinsic_wo_chain:{ *:[i64] } 302:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] })  =>  (XPACI:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 180678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACI),
     /* 180681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 180685 */     GIR_RootConstrainSelectedInstOperands,
     /* 180686 */     // GIR_Coverage, 3922,
     /* 180686 */     GIR_EraseRootFromParent_Done,
     /* 180687 */   // Label 3324: @180687
     /* 180687 */   GIM_Try, /*On fail goto*//*Label 3325*/ GIMT_Encode4(180734), // Rule ID 3923 //
     /* 180692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 180695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 180700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180714 */     // MIs[0] Operand 3
     /* 180714 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 180725 */     // (intrinsic_wo_chain:{ *:[i64] } 302:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] })  =>  (XPACI:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 180725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACI),
     /* 180728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 180732 */     GIR_RootConstrainSelectedInstOperands,
     /* 180733 */     // GIR_Coverage, 3923,
     /* 180733 */     GIR_EraseRootFromParent_Done,
     /* 180734 */   // Label 3325: @180734
     /* 180734 */   GIM_Try, /*On fail goto*//*Label 3326*/ GIMT_Encode4(180781), // Rule ID 3924 //
     /* 180739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 180742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 180747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180761 */     // MIs[0] Operand 3
     /* 180761 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 180772 */     // (intrinsic_wo_chain:{ *:[i64] } 302:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] })  =>  (XPACD:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 180772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACD),
     /* 180775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 180779 */     GIR_RootConstrainSelectedInstOperands,
     /* 180780 */     // GIR_Coverage, 3924,
     /* 180780 */     GIR_EraseRootFromParent_Done,
     /* 180781 */   // Label 3326: @180781
     /* 180781 */   GIM_Try, /*On fail goto*//*Label 3327*/ GIMT_Encode4(180828), // Rule ID 3925 //
     /* 180786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 180789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 180794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180808 */     // MIs[0] Operand 3
     /* 180808 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 180819 */     // (intrinsic_wo_chain:{ *:[i64] } 302:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] })  =>  (XPACD:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 180819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACD),
     /* 180822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 180826 */     GIR_RootConstrainSelectedInstOperands,
     /* 180827 */     // GIR_Coverage, 3925,
     /* 180827 */     GIR_EraseRootFromParent_Done,
     /* 180828 */   // Label 3327: @180828
     /* 180828 */   GIM_Try, /*On fail goto*//*Label 3328*/ GIMT_Encode4(180874), // Rule ID 3563 //
     /* 180833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 180836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 180841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 180844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 180847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180855 */     // MIs[0] Idx
     /* 180855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 180858 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_0),
     /* 180863 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1636:{ *:[iPTR] }, ZPRAny:{ *:[nxv16i8] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_0>>:$Idx)  =>  (PMOV_PZI_B:{ *:[nxv16i1] } ZPRAny:{ *:[nxv16i8] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_0>>:$Idx)
     /* 180863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_B),
     /* 180866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 180868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 180870 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 180872 */     GIR_RootConstrainSelectedInstOperands,
     /* 180873 */     // GIR_Coverage, 3563,
     /* 180873 */     GIR_EraseRootFromParent_Done,
     /* 180874 */   // Label 3328: @180874
     /* 180874 */   GIM_Try, /*On fail goto*//*Label 3329*/ GIMT_Encode4(180920), // Rule ID 3564 //
     /* 180879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 180882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 180887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 180890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 180893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180901 */     // MIs[0] Idx
     /* 180901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 180904 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 180909 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1636:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Idx)  =>  (PMOV_PZI_H:{ *:[nxv8i1] } ZPRAny:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Idx)
     /* 180909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_H),
     /* 180912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 180914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 180916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 180918 */     GIR_RootConstrainSelectedInstOperands,
     /* 180919 */     // GIR_Coverage, 3564,
     /* 180919 */     GIR_EraseRootFromParent_Done,
     /* 180920 */   // Label 3329: @180920
     /* 180920 */   GIM_Try, /*On fail goto*//*Label 3330*/ GIMT_Encode4(180966), // Rule ID 3565 //
     /* 180925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 180928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 180933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 180936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 180939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180947 */     // MIs[0] Idx
     /* 180947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 180950 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 180955 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1636:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Idx)  =>  (PMOV_PZI_S:{ *:[nxv4i1] } ZPRAny:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Idx)
     /* 180955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_S),
     /* 180958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 180960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 180962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 180964 */     GIR_RootConstrainSelectedInstOperands,
     /* 180965 */     // GIR_Coverage, 3565,
     /* 180965 */     GIR_EraseRootFromParent_Done,
     /* 180966 */   // Label 3330: @180966
     /* 180966 */   GIM_Try, /*On fail goto*//*Label 3331*/ GIMT_Encode4(181012), // Rule ID 3566 //
     /* 180971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 180974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 180979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 180982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 180985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180993 */     // MIs[0] Idx
     /* 180993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 180996 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 181001 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1636:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Idx)  =>  (PMOV_PZI_D:{ *:[nxv2i1] } ZPRAny:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Idx)
     /* 181001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_D),
     /* 181004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 181006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 181008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 181010 */     GIR_RootConstrainSelectedInstOperands,
     /* 181011 */     // GIR_Coverage, 3566,
     /* 181011 */     GIR_EraseRootFromParent_Done,
     /* 181012 */   // Label 3331: @181012
     /* 181012 */   GIM_Try, /*On fail goto*//*Label 3332*/ GIMT_Encode4(181068), // Rule ID 2109 //
     /* 181017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshrn),
     /* 181025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181050 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 181054 */     // MIs[1] Operand 1
     /* 181054 */     // No operand predicates
     /* 181054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181056 */     // (intrinsic_wo_chain:{ *:[i32] } 702:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQRSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 181056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNs),
     /* 181059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181063 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181066 */     GIR_RootConstrainSelectedInstOperands,
     /* 181067 */     // GIR_Coverage, 2109,
     /* 181067 */     GIR_EraseRootFromParent_Done,
     /* 181068 */   // Label 3332: @181068
     /* 181068 */   GIM_Try, /*On fail goto*//*Label 3333*/ GIMT_Encode4(181124), // Rule ID 2110 //
     /* 181073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshrun),
     /* 181081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181106 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 181110 */     // MIs[1] Operand 1
     /* 181110 */     // No operand predicates
     /* 181110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181112 */     // (intrinsic_wo_chain:{ *:[i32] } 703:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQRSHRUNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 181112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNs),
     /* 181115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181122 */     GIR_RootConstrainSelectedInstOperands,
     /* 181123 */     // GIR_Coverage, 2110,
     /* 181123 */     GIR_EraseRootFromParent_Done,
     /* 181124 */   // Label 3333: @181124
     /* 181124 */   GIM_Try, /*On fail goto*//*Label 3334*/ GIMT_Encode4(181180), // Rule ID 2115 //
     /* 181129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshrn),
     /* 181137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181162 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 181166 */     // MIs[1] Operand 1
     /* 181166 */     // No operand predicates
     /* 181166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181168 */     // (intrinsic_wo_chain:{ *:[i32] } 706:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 181168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNs),
     /* 181171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181175 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181178 */     GIR_RootConstrainSelectedInstOperands,
     /* 181179 */     // GIR_Coverage, 2115,
     /* 181179 */     GIR_EraseRootFromParent_Done,
     /* 181180 */   // Label 3334: @181180
     /* 181180 */   GIM_Try, /*On fail goto*//*Label 3335*/ GIMT_Encode4(181236), // Rule ID 2116 //
     /* 181185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshrun),
     /* 181193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181218 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 181222 */     // MIs[1] Operand 1
     /* 181222 */     // No operand predicates
     /* 181222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181224 */     // (intrinsic_wo_chain:{ *:[i32] } 707:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQSHRUNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 181224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNs),
     /* 181227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181234 */     GIR_RootConstrainSelectedInstOperands,
     /* 181235 */     // GIR_Coverage, 2116,
     /* 181235 */     GIR_EraseRootFromParent_Done,
     /* 181236 */   // Label 3335: @181236
     /* 181236 */   GIM_Try, /*On fail goto*//*Label 3336*/ GIMT_Encode4(181292), // Rule ID 2123 //
     /* 181241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshrn),
     /* 181249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181274 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 181278 */     // MIs[1] Operand 1
     /* 181278 */     // No operand predicates
     /* 181278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181280 */     // (intrinsic_wo_chain:{ *:[i32] } 751:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UQRSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 181280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNs),
     /* 181283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181287 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181290 */     GIR_RootConstrainSelectedInstOperands,
     /* 181291 */     // GIR_Coverage, 2123,
     /* 181291 */     GIR_EraseRootFromParent_Done,
     /* 181292 */   // Label 3336: @181292
     /* 181292 */   GIM_Try, /*On fail goto*//*Label 3337*/ GIMT_Encode4(181348), // Rule ID 2126 //
     /* 181297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshrn),
     /* 181305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181330 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 181334 */     // MIs[1] Operand 1
     /* 181334 */     // No operand predicates
     /* 181334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181336 */     // (intrinsic_wo_chain:{ *:[i32] } 753:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UQSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 181336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNs),
     /* 181339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181343 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181346 */     GIR_RootConstrainSelectedInstOperands,
     /* 181347 */     // GIR_Coverage, 2126,
     /* 181347 */     GIR_EraseRootFromParent_Done,
     /* 181348 */   // Label 3337: @181348
     /* 181348 */   GIM_Try, /*On fail goto*//*Label 3338*/ GIMT_Encode4(181404), // Rule ID 2148 //
     /* 181353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 181361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 181364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 181367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181386 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 181390 */     // MIs[1] Operand 1
     /* 181390 */     // No operand predicates
     /* 181390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181392 */     // (intrinsic_wo_chain:{ *:[v8i8] } 667:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)  =>  (RSHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 181392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv8i8_shift),
     /* 181395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181402 */     GIR_RootConstrainSelectedInstOperands,
     /* 181403 */     // GIR_Coverage, 2148,
     /* 181403 */     GIR_EraseRootFromParent_Done,
     /* 181404 */   // Label 3338: @181404
     /* 181404 */   GIM_Try, /*On fail goto*//*Label 3339*/ GIMT_Encode4(181460), // Rule ID 2150 //
     /* 181409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 181417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 181420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 181423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181442 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 181446 */     // MIs[1] Operand 1
     /* 181446 */     // No operand predicates
     /* 181446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181448 */     // (intrinsic_wo_chain:{ *:[v4i16] } 667:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)  =>  (RSHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 181448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv4i16_shift),
     /* 181451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181458 */     GIR_RootConstrainSelectedInstOperands,
     /* 181459 */     // GIR_Coverage, 2150,
     /* 181459 */     GIR_EraseRootFromParent_Done,
     /* 181460 */   // Label 3339: @181460
     /* 181460 */   GIM_Try, /*On fail goto*//*Label 3340*/ GIMT_Encode4(181516), // Rule ID 2152 //
     /* 181465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 181473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 181476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 181479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181498 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 181502 */     // MIs[1] Operand 1
     /* 181502 */     // No operand predicates
     /* 181502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181504 */     // (intrinsic_wo_chain:{ *:[v2i32] } 667:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)  =>  (RSHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 181504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv2i32_shift),
     /* 181507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181514 */     GIR_RootConstrainSelectedInstOperands,
     /* 181515 */     // GIR_Coverage, 2152,
     /* 181515 */     GIR_EraseRootFromParent_Done,
     /* 181516 */   // Label 3340: @181516
     /* 181516 */   GIM_Try, /*On fail goto*//*Label 3341*/ GIMT_Encode4(181569), // Rule ID 6330 //
     /* 181521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 181526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 181532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181551 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 181555 */     // MIs[1] Operand 1
     /* 181555 */     // No operand predicates
     /* 181555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181557 */     // (intrinsic_wo_chain:{ *:[i32] } 772:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (FCVTZSs:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 181557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSs),
     /* 181560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181564 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181567 */     GIR_RootConstrainSelectedInstOperands,
     /* 181568 */     // GIR_Coverage, 6330,
     /* 181568 */     GIR_EraseRootFromParent_Done,
     /* 181569 */   // Label 3341: @181569
     /* 181569 */   GIM_Try, /*On fail goto*//*Label 3342*/ GIMT_Encode4(181622), // Rule ID 6331 //
     /* 181574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 181579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 181585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181604 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 181608 */     // MIs[1] Operand 1
     /* 181608 */     // No operand predicates
     /* 181608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181610 */     // (intrinsic_wo_chain:{ *:[i32] } 773:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (FCVTZUs:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 181610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUs),
     /* 181613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181617 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181620 */     GIR_RootConstrainSelectedInstOperands,
     /* 181621 */     // GIR_Coverage, 6331,
     /* 181621 */     GIR_EraseRootFromParent_Done,
     /* 181622 */   // Label 3342: @181622
     /* 181622 */   GIM_Try, /*On fail goto*//*Label 3343*/ GIMT_Encode4(181675), // Rule ID 6332 //
     /* 181627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 181632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181657 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 181661 */     // MIs[1] Operand 1
     /* 181661 */     // No operand predicates
     /* 181661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181663 */     // (intrinsic_wo_chain:{ *:[i64] } 772:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZSd:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 181663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSd),
     /* 181666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181670 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181673 */     GIR_RootConstrainSelectedInstOperands,
     /* 181674 */     // GIR_Coverage, 6332,
     /* 181674 */     GIR_EraseRootFromParent_Done,
     /* 181675 */   // Label 3343: @181675
     /* 181675 */   GIM_Try, /*On fail goto*//*Label 3344*/ GIMT_Encode4(181728), // Rule ID 6333 //
     /* 181680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 181685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181710 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 181714 */     // MIs[1] Operand 1
     /* 181714 */     // No operand predicates
     /* 181714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181716 */     // (intrinsic_wo_chain:{ *:[i64] } 773:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZUd:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 181716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUd),
     /* 181719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181723 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181726 */     GIR_RootConstrainSelectedInstOperands,
     /* 181727 */     // GIR_Coverage, 6333,
     /* 181727 */     GIR_EraseRootFromParent_Done,
     /* 181728 */   // Label 3344: @181728
     /* 181728 */   GIM_Try, /*On fail goto*//*Label 3345*/ GIMT_Encode4(181781), // Rule ID 6334 //
     /* 181733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 181738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181763 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 181767 */     // MIs[1] Operand 1
     /* 181767 */     // No operand predicates
     /* 181767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181769 */     // (intrinsic_wo_chain:{ *:[v1i64] } 772:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZSd:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 181769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSd),
     /* 181772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181776 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181779 */     GIR_RootConstrainSelectedInstOperands,
     /* 181780 */     // GIR_Coverage, 6334,
     /* 181780 */     GIR_EraseRootFromParent_Done,
     /* 181781 */   // Label 3345: @181781
     /* 181781 */   GIM_Try, /*On fail goto*//*Label 3346*/ GIMT_Encode4(181834), // Rule ID 6335 //
     /* 181786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 181791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181816 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 181820 */     // MIs[1] Operand 1
     /* 181820 */     // No operand predicates
     /* 181820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181822 */     // (intrinsic_wo_chain:{ *:[v1i64] } 773:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZUd:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 181822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUd),
     /* 181825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181832 */     GIR_RootConstrainSelectedInstOperands,
     /* 181833 */     // GIR_Coverage, 6335,
     /* 181833 */     GIR_EraseRootFromParent_Done,
     /* 181834 */   // Label 3346: @181834
     /* 181834 */   GIM_Try, /*On fail goto*//*Label 3347*/ GIMT_Encode4(181887), // Rule ID 6336 //
     /* 181839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 181844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 181850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181869 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 181873 */     // MIs[1] Operand 1
     /* 181873 */     // No operand predicates
     /* 181873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181875 */     // (intrinsic_wo_chain:{ *:[f32] } 776:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UCVTFs:{ *:[f32] } FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 181875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFs),
     /* 181878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181882 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181885 */     GIR_RootConstrainSelectedInstOperands,
     /* 181886 */     // GIR_Coverage, 6336,
     /* 181886 */     GIR_EraseRootFromParent_Done,
     /* 181887 */   // Label 3347: @181887
     /* 181887 */   GIM_Try, /*On fail goto*//*Label 3348*/ GIMT_Encode4(181940), // Rule ID 6337 //
     /* 181892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 181897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181922 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 181926 */     // MIs[1] Operand 1
     /* 181926 */     // No operand predicates
     /* 181926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181928 */     // (intrinsic_wo_chain:{ *:[f64] } 776:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (UCVTFd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 181928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFd),
     /* 181931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181938 */     GIR_RootConstrainSelectedInstOperands,
     /* 181939 */     // GIR_Coverage, 6337,
     /* 181939 */     GIR_EraseRootFromParent_Done,
     /* 181940 */   // Label 3348: @181940
     /* 181940 */   GIM_Try, /*On fail goto*//*Label 3349*/ GIMT_Encode4(181993), // Rule ID 6338 //
     /* 181945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 181950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181975 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 181979 */     // MIs[1] Operand 1
     /* 181979 */     // No operand predicates
     /* 181979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181981 */     // (intrinsic_wo_chain:{ *:[v1f64] } 775:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SCVTFd:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 181981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFd),
     /* 181984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181988 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181991 */     GIR_RootConstrainSelectedInstOperands,
     /* 181992 */     // GIR_Coverage, 6338,
     /* 181992 */     GIR_EraseRootFromParent_Done,
     /* 181993 */   // Label 3349: @181993
     /* 181993 */   GIM_Try, /*On fail goto*//*Label 3350*/ GIMT_Encode4(182046), // Rule ID 6339 //
     /* 181998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 182003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182028 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 182032 */     // MIs[1] Operand 1
     /* 182032 */     // No operand predicates
     /* 182032 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182034 */     // (intrinsic_wo_chain:{ *:[f64] } 775:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SCVTFd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 182034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFd),
     /* 182037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182044 */     GIR_RootConstrainSelectedInstOperands,
     /* 182045 */     // GIR_Coverage, 6339,
     /* 182045 */     GIR_EraseRootFromParent_Done,
     /* 182046 */   // Label 3350: @182046
     /* 182046 */   GIM_Try, /*On fail goto*//*Label 3351*/ GIMT_Encode4(182099), // Rule ID 6340 //
     /* 182051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 182056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182081 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 182085 */     // MIs[1] Operand 1
     /* 182085 */     // No operand predicates
     /* 182085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182087 */     // (intrinsic_wo_chain:{ *:[v1f64] } 776:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (UCVTFd:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 182087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFd),
     /* 182090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182094 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182097 */     GIR_RootConstrainSelectedInstOperands,
     /* 182098 */     // GIR_Coverage, 6340,
     /* 182098 */     GIR_EraseRootFromParent_Done,
     /* 182099 */   // Label 3351: @182099
     /* 182099 */   GIM_Try, /*On fail goto*//*Label 3352*/ GIMT_Encode4(182152), // Rule ID 6341 //
     /* 182104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 182109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182134 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 182138 */     // MIs[1] Operand 1
     /* 182138 */     // No operand predicates
     /* 182138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182140 */     // (intrinsic_wo_chain:{ *:[f32] } 775:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SCVTFs:{ *:[f32] } FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 182140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFs),
     /* 182143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182150 */     GIR_RootConstrainSelectedInstOperands,
     /* 182151 */     // GIR_Coverage, 6341,
     /* 182151 */     GIR_EraseRootFromParent_Done,
     /* 182152 */   // Label 3352: @182152
     /* 182152 */   GIM_Try, /*On fail goto*//*Label 3353*/ GIMT_Encode4(182234), // Rule ID 6343 //
     /* 182157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 182162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 182165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182187 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 182191 */     // MIs[1] Operand 1
     /* 182191 */     // No operand predicates
     /* 182191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182193 */     // (intrinsic_wo_chain:{ *:[f16] } 775:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 182193 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 182196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 182200 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182205 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 182211 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182216 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 182224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182226 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 182229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182232 */     GIR_RootConstrainSelectedInstOperands,
     /* 182233 */     // GIR_Coverage, 6343,
     /* 182233 */     GIR_EraseRootFromParent_Done,
     /* 182234 */   // Label 3353: @182234
     /* 182234 */   GIM_Try, /*On fail goto*//*Label 3354*/ GIMT_Encode4(182316), // Rule ID 6344 //
     /* 182239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 182244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 182247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182269 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 182273 */     // MIs[1] Operand 1
     /* 182273 */     // No operand predicates
     /* 182273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182275 */     // (intrinsic_wo_chain:{ *:[f16] } 775:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 182275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 182278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 182282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182287 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 182293 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182298 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 182306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182308 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 182311 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182314 */     GIR_RootConstrainSelectedInstOperands,
     /* 182315 */     // GIR_Coverage, 6344,
     /* 182315 */     GIR_EraseRootFromParent_Done,
     /* 182316 */   // Label 3354: @182316
     /* 182316 */   GIM_Try, /*On fail goto*//*Label 3355*/ GIMT_Encode4(182398), // Rule ID 6346 //
     /* 182321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 182326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 182329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182351 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 182355 */     // MIs[1] Operand 1
     /* 182355 */     // No operand predicates
     /* 182355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182357 */     // (intrinsic_wo_chain:{ *:[f16] } 776:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 182357 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 182360 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 182364 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182369 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 182375 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182380 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 182388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182390 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 182393 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182396 */     GIR_RootConstrainSelectedInstOperands,
     /* 182397 */     // GIR_Coverage, 6346,
     /* 182397 */     GIR_EraseRootFromParent_Done,
     /* 182398 */   // Label 3355: @182398
     /* 182398 */   GIM_Try, /*On fail goto*//*Label 3356*/ GIMT_Encode4(182480), // Rule ID 6347 //
     /* 182403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 182408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 182411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182433 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 182437 */     // MIs[1] Operand 1
     /* 182437 */     // No operand predicates
     /* 182437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182439 */     // (intrinsic_wo_chain:{ *:[f16] } 776:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 182439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 182442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 182446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182451 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 182457 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182462 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 182470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 182475 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182478 */     GIR_RootConstrainSelectedInstOperands,
     /* 182479 */     // GIR_Coverage, 6347,
     /* 182479 */     GIR_EraseRootFromParent_Done,
     /* 182480 */   // Label 3356: @182480
     /* 182480 */   GIM_Try, /*On fail goto*//*Label 3357*/ GIMT_Encode4(182586), // Rule ID 6348 //
     /* 182485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 182490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 182496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182515 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 182519 */     // MIs[1] Operand 1
     /* 182519 */     // No operand predicates
     /* 182519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182521 */     // (intrinsic_wo_chain:{ *:[i32] } 772:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FCVTZSh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), hsub:{ *:[i32] })
     /* 182521 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 182524 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSh),
     /* 182528 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182533 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 182537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 182540 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 182542 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 182545 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 182549 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 182556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 182559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182561 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 182564 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 182567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 182570 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182575 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182580 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182585 */     // GIR_Coverage, 6348,
     /* 182585 */     GIR_EraseRootFromParent_Done,
     /* 182586 */   // Label 3357: @182586
     /* 182586 */   GIM_Try, /*On fail goto*//*Label 3358*/ GIMT_Encode4(182692), // Rule ID 6349 //
     /* 182591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 182596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 182602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182621 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 182625 */     // MIs[1] Operand 1
     /* 182625 */     // No operand predicates
     /* 182625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182627 */     // (intrinsic_wo_chain:{ *:[i64] } 772:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (FCVTZSh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), hsub:{ *:[i32] })
     /* 182627 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 182630 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSh),
     /* 182634 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182639 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 182643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 182646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 182648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 182651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 182655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 182662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 182665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 182670 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 182673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 182676 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182681 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182686 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182691 */     // GIR_Coverage, 6349,
     /* 182691 */     GIR_EraseRootFromParent_Done,
     /* 182692 */   // Label 3358: @182692
     /* 182692 */   GIM_Try, /*On fail goto*//*Label 3359*/ GIMT_Encode4(182798), // Rule ID 6350 //
     /* 182697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 182702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 182708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182727 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 182731 */     // MIs[1] Operand 1
     /* 182731 */     // No operand predicates
     /* 182731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182733 */     // (intrinsic_wo_chain:{ *:[i32] } 773:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FCVTZUh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), hsub:{ *:[i32] })
     /* 182733 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 182736 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUh),
     /* 182740 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182745 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 182749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 182752 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 182754 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 182757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 182761 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182766 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 182768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 182771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182773 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 182776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 182779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 182782 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182787 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182792 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182797 */     // GIR_Coverage, 6350,
     /* 182797 */     GIR_EraseRootFromParent_Done,
     /* 182798 */   // Label 3359: @182798
     /* 182798 */   GIM_Try, /*On fail goto*//*Label 3360*/ GIMT_Encode4(182904), // Rule ID 6351 //
     /* 182803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 182808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 182814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182833 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 182837 */     // MIs[1] Operand 1
     /* 182837 */     // No operand predicates
     /* 182837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182839 */     // (intrinsic_wo_chain:{ *:[i64] } 773:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (FCVTZUh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), hsub:{ *:[i32] })
     /* 182839 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 182842 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUh),
     /* 182846 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182851 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 182855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 182858 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 182860 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 182863 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 182867 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182872 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 182874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 182877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 182882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 182885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 182888 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182893 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182898 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182903 */     // GIR_Coverage, 6351,
     /* 182903 */     GIR_EraseRootFromParent_Done,
     /* 182904 */   // Label 3360: @182904
     /* 182904 */   GIM_Try, /*On fail goto*//*Label 3361*/ GIMT_Encode4(182962), // Rule ID 7050 //
     /* 182909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_blend),
     /* 182914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 182927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 182931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182939 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64_0_65535),
     /* 182943 */     // MIs[1] Operand 1
     /* 182943 */     // No operand predicates
     /* 182943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182945 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_imm64_0_65535>>:$imm)  =>  (MOVKXi:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm64_0_65535>>:$imm), 48:{ *:[i32] })
     /* 182945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVKXi),
     /* 182948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 182952 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // imm
     /* 182957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 182960 */     GIR_RootConstrainSelectedInstOperands,
     /* 182961 */     // GIR_Coverage, 7050,
     /* 182961 */     GIR_EraseRootFromParent_Done,
     /* 182962 */   // Label 3361: @182962
     /* 182962 */   GIM_Try, /*On fail goto*//*Label 3362*/ GIMT_Encode4(183004), // Rule ID 3056 //
     /* 182967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 182975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 182978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 182981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182985 */     // MIs[0] Op2
     /* 182985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182988 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 182993 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1874:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (SSHLLB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 182993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_H),
     /* 182996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183002 */     GIR_RootConstrainSelectedInstOperands,
     /* 183003 */     // GIR_Coverage, 3056,
     /* 183003 */     GIR_EraseRootFromParent_Done,
     /* 183004 */   // Label 3362: @183004
     /* 183004 */   GIM_Try, /*On fail goto*//*Label 3363*/ GIMT_Encode4(183046), // Rule ID 3057 //
     /* 183009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 183017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183027 */     // MIs[0] Op2
     /* 183027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183030 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 183035 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1874:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (SSHLLB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 183035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_S),
     /* 183038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183044 */     GIR_RootConstrainSelectedInstOperands,
     /* 183045 */     // GIR_Coverage, 3057,
     /* 183045 */     GIR_EraseRootFromParent_Done,
     /* 183046 */   // Label 3363: @183046
     /* 183046 */   GIM_Try, /*On fail goto*//*Label 3364*/ GIMT_Encode4(183088), // Rule ID 3058 //
     /* 183051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 183059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 183062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183069 */     // MIs[0] Op2
     /* 183069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183072 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 183077 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1874:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (SSHLLB_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 183077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_D),
     /* 183080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183086 */     GIR_RootConstrainSelectedInstOperands,
     /* 183087 */     // GIR_Coverage, 3058,
     /* 183087 */     GIR_EraseRootFromParent_Done,
     /* 183088 */   // Label 3364: @183088
     /* 183088 */   GIM_Try, /*On fail goto*//*Label 3365*/ GIMT_Encode4(183130), // Rule ID 3092 //
     /* 183093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 183101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 183104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183111 */     // MIs[0] Op2
     /* 183111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183114 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 183119 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1855:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQSHRUNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 183119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_B),
     /* 183122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183128 */     GIR_RootConstrainSelectedInstOperands,
     /* 183129 */     // GIR_Coverage, 3092,
     /* 183129 */     GIR_EraseRootFromParent_Done,
     /* 183130 */   // Label 3365: @183130
     /* 183130 */   GIM_Try, /*On fail goto*//*Label 3366*/ GIMT_Encode4(183172), // Rule ID 3093 //
     /* 183135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 183143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183153 */     // MIs[0] Op2
     /* 183153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183156 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 183161 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1855:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQSHRUNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 183161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_H),
     /* 183164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183170 */     GIR_RootConstrainSelectedInstOperands,
     /* 183171 */     // GIR_Coverage, 3093,
     /* 183171 */     GIR_EraseRootFromParent_Done,
     /* 183172 */   // Label 3366: @183172
     /* 183172 */   GIM_Try, /*On fail goto*//*Label 3367*/ GIMT_Encode4(183214), // Rule ID 3094 //
     /* 183177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 183185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183195 */     // MIs[0] Op2
     /* 183195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183198 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 183203 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1855:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQSHRUNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 183203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_S),
     /* 183206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183212 */     GIR_RootConstrainSelectedInstOperands,
     /* 183213 */     // GIR_Coverage, 3094,
     /* 183213 */     GIR_EraseRootFromParent_Done,
     /* 183214 */   // Label 3367: @183214
     /* 183214 */   GIM_Try, /*On fail goto*//*Label 3368*/ GIMT_Encode4(183256), // Rule ID 3549 //
     /* 183219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 183222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 183227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 183230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 183233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183237 */     // MIs[0] Op2
     /* 183237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183240 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 183245 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1355:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Op2)  =>  (DUPQ_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Op2)
     /* 183245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_B),
     /* 183248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183254 */     GIR_RootConstrainSelectedInstOperands,
     /* 183255 */     // GIR_Coverage, 3549,
     /* 183255 */     GIR_EraseRootFromParent_Done,
     /* 183256 */   // Label 3368: @183256
     /* 183256 */   GIM_Try, /*On fail goto*//*Label 3369*/ GIMT_Encode4(183298), // Rule ID 3550 //
     /* 183261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 183264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 183269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183279 */     // MIs[0] Op2
     /* 183279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183282 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 183287 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1355:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)  =>  (DUPQ_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)
     /* 183287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_H),
     /* 183290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183296 */     GIR_RootConstrainSelectedInstOperands,
     /* 183297 */     // GIR_Coverage, 3550,
     /* 183297 */     GIR_EraseRootFromParent_Done,
     /* 183298 */   // Label 3369: @183298
     /* 183298 */   GIM_Try, /*On fail goto*//*Label 3370*/ GIMT_Encode4(183340), // Rule ID 3551 //
     /* 183303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 183306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 183311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183321 */     // MIs[0] Op2
     /* 183321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183324 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 183329 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1355:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)  =>  (DUPQ_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)
     /* 183329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_S),
     /* 183332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183336 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183338 */     GIR_RootConstrainSelectedInstOperands,
     /* 183339 */     // GIR_Coverage, 3551,
     /* 183339 */     GIR_EraseRootFromParent_Done,
     /* 183340 */   // Label 3370: @183340
     /* 183340 */   GIM_Try, /*On fail goto*//*Label 3371*/ GIMT_Encode4(183382), // Rule ID 3552 //
     /* 183345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 183348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 183353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 183356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183363 */     // MIs[0] Op2
     /* 183363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183366 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 183371 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1355:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)  =>  (DUPQ_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)
     /* 183371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_D),
     /* 183374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183380 */     GIR_RootConstrainSelectedInstOperands,
     /* 183381 */     // GIR_Coverage, 3552,
     /* 183381 */     GIR_EraseRootFromParent_Done,
     /* 183382 */   // Label 3371: @183382
     /* 183382 */   GIM_Try, /*On fail goto*//*Label 3372*/ GIMT_Encode4(183424), // Rule ID 3553 //
     /* 183387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 183390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 183395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183405 */     // MIs[0] Op2
     /* 183405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183408 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 183413 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1355:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)  =>  (DUPQ_ZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)
     /* 183413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_H),
     /* 183416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183422 */     GIR_RootConstrainSelectedInstOperands,
     /* 183423 */     // GIR_Coverage, 3553,
     /* 183423 */     GIR_EraseRootFromParent_Done,
     /* 183424 */   // Label 3372: @183424
     /* 183424 */   GIM_Try, /*On fail goto*//*Label 3373*/ GIMT_Encode4(183466), // Rule ID 3554 //
     /* 183429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 183432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 183437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183447 */     // MIs[0] Op2
     /* 183447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183450 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 183455 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1355:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)  =>  (DUPQ_ZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)
     /* 183455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_S),
     /* 183458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183462 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183464 */     GIR_RootConstrainSelectedInstOperands,
     /* 183465 */     // GIR_Coverage, 3554,
     /* 183465 */     GIR_EraseRootFromParent_Done,
     /* 183466 */   // Label 3373: @183466
     /* 183466 */   GIM_Try, /*On fail goto*//*Label 3374*/ GIMT_Encode4(183508), // Rule ID 3555 //
     /* 183471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 183474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 183479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 183482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183489 */     // MIs[0] Op2
     /* 183489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183492 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 183497 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1355:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)  =>  (DUPQ_ZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)
     /* 183497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_D),
     /* 183500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183506 */     GIR_RootConstrainSelectedInstOperands,
     /* 183507 */     // GIR_Coverage, 3555,
     /* 183507 */     GIR_EraseRootFromParent_Done,
     /* 183508 */   // Label 3374: @183508
     /* 183508 */   GIM_Try, /*On fail goto*//*Label 3375*/ GIMT_Encode4(183550), // Rule ID 11878 //
     /* 183513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 183521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 183524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183531 */     // MIs[0] Op2
     /* 183531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183534 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 183539 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1849:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQRSHRUNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 183539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_B),
     /* 183542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183548 */     GIR_RootConstrainSelectedInstOperands,
     /* 183549 */     // GIR_Coverage, 11878,
     /* 183549 */     GIR_EraseRootFromParent_Done,
     /* 183550 */   // Label 3375: @183550
     /* 183550 */   GIM_Try, /*On fail goto*//*Label 3376*/ GIMT_Encode4(183592), // Rule ID 11879 //
     /* 183555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 183563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183573 */     // MIs[0] Op2
     /* 183573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183576 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 183581 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1849:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQRSHRUNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 183581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_H),
     /* 183584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183590 */     GIR_RootConstrainSelectedInstOperands,
     /* 183591 */     // GIR_Coverage, 11879,
     /* 183591 */     GIR_EraseRootFromParent_Done,
     /* 183592 */   // Label 3376: @183592
     /* 183592 */   GIM_Try, /*On fail goto*//*Label 3377*/ GIMT_Encode4(183634), // Rule ID 11880 //
     /* 183597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 183605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183615 */     // MIs[0] Op2
     /* 183615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183618 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 183623 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1849:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQRSHRUNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 183623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_S),
     /* 183626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183632 */     GIR_RootConstrainSelectedInstOperands,
     /* 183633 */     // GIR_Coverage, 11880,
     /* 183633 */     GIR_EraseRootFromParent_Done,
     /* 183634 */   // Label 3377: @183634
     /* 183634 */   GIM_Try, /*On fail goto*//*Label 3378*/ GIMT_Encode4(183676), // Rule ID 11881 //
     /* 183639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 183647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 183650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183657 */     // MIs[0] Op2
     /* 183657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183660 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 183665 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1728:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 183665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_B),
     /* 183668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183674 */     GIR_RootConstrainSelectedInstOperands,
     /* 183675 */     // GIR_Coverage, 11881,
     /* 183675 */     GIR_EraseRootFromParent_Done,
     /* 183676 */   // Label 3378: @183676
     /* 183676 */   GIM_Try, /*On fail goto*//*Label 3379*/ GIMT_Encode4(183718), // Rule ID 11882 //
     /* 183681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 183689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183699 */     // MIs[0] Op2
     /* 183699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183702 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 183707 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1728:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 183707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_H),
     /* 183710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183716 */     GIR_RootConstrainSelectedInstOperands,
     /* 183717 */     // GIR_Coverage, 11882,
     /* 183717 */     GIR_EraseRootFromParent_Done,
     /* 183718 */   // Label 3379: @183718
     /* 183718 */   GIM_Try, /*On fail goto*//*Label 3380*/ GIMT_Encode4(183760), // Rule ID 11883 //
     /* 183723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 183731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183741 */     // MIs[0] Op2
     /* 183741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183744 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 183749 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1728:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 183749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_S),
     /* 183752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183758 */     GIR_RootConstrainSelectedInstOperands,
     /* 183759 */     // GIR_Coverage, 11883,
     /* 183759 */     GIR_EraseRootFromParent_Done,
     /* 183760 */   // Label 3380: @183760
     /* 183760 */   GIM_Try, /*On fail goto*//*Label 3381*/ GIMT_Encode4(183802), // Rule ID 11885 //
     /* 183765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 183773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 183776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183783 */     // MIs[0] Op2
     /* 183783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183786 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 183791 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1686:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (RSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 183791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_B),
     /* 183794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183800 */     GIR_RootConstrainSelectedInstOperands,
     /* 183801 */     // GIR_Coverage, 11885,
     /* 183801 */     GIR_EraseRootFromParent_Done,
     /* 183802 */   // Label 3381: @183802
     /* 183802 */   GIM_Try, /*On fail goto*//*Label 3382*/ GIMT_Encode4(183844), // Rule ID 11887 //
     /* 183807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 183815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183825 */     // MIs[0] Op2
     /* 183825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183828 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 183833 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1686:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (RSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 183833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_H),
     /* 183836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183842 */     GIR_RootConstrainSelectedInstOperands,
     /* 183843 */     // GIR_Coverage, 11887,
     /* 183843 */     GIR_EraseRootFromParent_Done,
     /* 183844 */   // Label 3382: @183844
     /* 183844 */   GIM_Try, /*On fail goto*//*Label 3383*/ GIMT_Encode4(183886), // Rule ID 11889 //
     /* 183849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 183857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183867 */     // MIs[0] Op2
     /* 183867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183870 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 183875 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1686:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (RSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 183875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_S),
     /* 183878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183884 */     GIR_RootConstrainSelectedInstOperands,
     /* 183885 */     // GIR_Coverage, 11889,
     /* 183885 */     GIR_EraseRootFromParent_Done,
     /* 183886 */   // Label 3383: @183886
     /* 183886 */   GIM_Try, /*On fail goto*//*Label 3384*/ GIMT_Encode4(183928), // Rule ID 11890 //
     /* 183891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 183899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 183902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183909 */     // MIs[0] Op2
     /* 183909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183912 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 183917 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1853:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 183917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_B),
     /* 183920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183926 */     GIR_RootConstrainSelectedInstOperands,
     /* 183927 */     // GIR_Coverage, 11890,
     /* 183927 */     GIR_EraseRootFromParent_Done,
     /* 183928 */   // Label 3384: @183928
     /* 183928 */   GIM_Try, /*On fail goto*//*Label 3385*/ GIMT_Encode4(183970), // Rule ID 11891 //
     /* 183933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 183941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183951 */     // MIs[0] Op2
     /* 183951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183954 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 183959 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1853:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 183959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_H),
     /* 183962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183968 */     GIR_RootConstrainSelectedInstOperands,
     /* 183969 */     // GIR_Coverage, 11891,
     /* 183969 */     GIR_EraseRootFromParent_Done,
     /* 183970 */   // Label 3385: @183970
     /* 183970 */   GIM_Try, /*On fail goto*//*Label 3386*/ GIMT_Encode4(184012), // Rule ID 11892 //
     /* 183975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 183983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183993 */     // MIs[0] Op2
     /* 183993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183996 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 184001 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1853:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 184001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_S),
     /* 184004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184010 */     GIR_RootConstrainSelectedInstOperands,
     /* 184011 */     // GIR_Coverage, 11892,
     /* 184011 */     GIR_EraseRootFromParent_Done,
     /* 184012 */   // Label 3386: @184012
     /* 184012 */   GIM_Try, /*On fail goto*//*Label 3387*/ GIMT_Encode4(184054), // Rule ID 11893 //
     /* 184017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 184025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 184028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184035 */     // MIs[0] Op2
     /* 184035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184038 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 184043 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1843:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQRSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 184043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_B),
     /* 184046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184052 */     GIR_RootConstrainSelectedInstOperands,
     /* 184053 */     // GIR_Coverage, 11893,
     /* 184053 */     GIR_EraseRootFromParent_Done,
     /* 184054 */   // Label 3387: @184054
     /* 184054 */   GIM_Try, /*On fail goto*//*Label 3388*/ GIMT_Encode4(184096), // Rule ID 11894 //
     /* 184059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 184067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184077 */     // MIs[0] Op2
     /* 184077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184080 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 184085 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1843:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQRSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 184085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_H),
     /* 184088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184094 */     GIR_RootConstrainSelectedInstOperands,
     /* 184095 */     // GIR_Coverage, 11894,
     /* 184095 */     GIR_EraseRootFromParent_Done,
     /* 184096 */   // Label 3388: @184096
     /* 184096 */   GIM_Try, /*On fail goto*//*Label 3389*/ GIMT_Encode4(184138), // Rule ID 11895 //
     /* 184101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 184109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184119 */     // MIs[0] Op2
     /* 184119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184122 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 184127 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1843:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQRSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 184127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_S),
     /* 184130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184136 */     GIR_RootConstrainSelectedInstOperands,
     /* 184137 */     // GIR_Coverage, 11895,
     /* 184137 */     GIR_EraseRootFromParent_Done,
     /* 184138 */   // Label 3389: @184138
     /* 184138 */   GIM_Try, /*On fail goto*//*Label 3390*/ GIMT_Encode4(184180), // Rule ID 11896 //
     /* 184143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 184151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 184154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184161 */     // MIs[0] Op2
     /* 184161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184164 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 184169 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2048:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (UQSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 184169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_B),
     /* 184172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184178 */     GIR_RootConstrainSelectedInstOperands,
     /* 184179 */     // GIR_Coverage, 11896,
     /* 184179 */     GIR_EraseRootFromParent_Done,
     /* 184180 */   // Label 3390: @184180
     /* 184180 */   GIM_Try, /*On fail goto*//*Label 3391*/ GIMT_Encode4(184222), // Rule ID 11897 //
     /* 184185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 184193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184203 */     // MIs[0] Op2
     /* 184203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184206 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 184211 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2048:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (UQSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 184211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_H),
     /* 184214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184220 */     GIR_RootConstrainSelectedInstOperands,
     /* 184221 */     // GIR_Coverage, 11897,
     /* 184221 */     GIR_EraseRootFromParent_Done,
     /* 184222 */   // Label 3391: @184222
     /* 184222 */   GIM_Try, /*On fail goto*//*Label 3392*/ GIMT_Encode4(184264), // Rule ID 11898 //
     /* 184227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 184235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184245 */     // MIs[0] Op2
     /* 184245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184248 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 184253 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2048:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (UQSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 184253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_S),
     /* 184256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184262 */     GIR_RootConstrainSelectedInstOperands,
     /* 184263 */     // GIR_Coverage, 11898,
     /* 184263 */     GIR_EraseRootFromParent_Done,
     /* 184264 */   // Label 3392: @184264
     /* 184264 */   GIM_Try, /*On fail goto*//*Label 3393*/ GIMT_Encode4(184306), // Rule ID 11899 //
     /* 184269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 184277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 184280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184287 */     // MIs[0] Op2
     /* 184287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184290 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 184295 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2045:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (UQRSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 184295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_B),
     /* 184298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184304 */     GIR_RootConstrainSelectedInstOperands,
     /* 184305 */     // GIR_Coverage, 11899,
     /* 184305 */     GIR_EraseRootFromParent_Done,
     /* 184306 */   // Label 3393: @184306
     /* 184306 */   GIM_Try, /*On fail goto*//*Label 3394*/ GIMT_Encode4(184348), // Rule ID 11900 //
     /* 184311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 184319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184329 */     // MIs[0] Op2
     /* 184329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184332 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 184337 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2045:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (UQRSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 184337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_H),
     /* 184340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184346 */     GIR_RootConstrainSelectedInstOperands,
     /* 184347 */     // GIR_Coverage, 11900,
     /* 184347 */     GIR_EraseRootFromParent_Done,
     /* 184348 */   // Label 3394: @184348
     /* 184348 */   GIM_Try, /*On fail goto*//*Label 3395*/ GIMT_Encode4(184390), // Rule ID 11901 //
     /* 184353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 184361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184371 */     // MIs[0] Op2
     /* 184371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184374 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 184379 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2045:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (UQRSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 184379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_S),
     /* 184382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184386 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184388 */     GIR_RootConstrainSelectedInstOperands,
     /* 184389 */     // GIR_Coverage, 11901,
     /* 184389 */     GIR_EraseRootFromParent_Done,
     /* 184390 */   // Label 3395: @184390
     /* 184390 */   GIM_Try, /*On fail goto*//*Label 3396*/ GIMT_Encode4(184432), // Rule ID 11959 //
     /* 184395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 184403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 184409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184413 */     // MIs[0] Op2
     /* 184413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184416 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 184421 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1875:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (SSHLLT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 184421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_H),
     /* 184424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184430 */     GIR_RootConstrainSelectedInstOperands,
     /* 184431 */     // GIR_Coverage, 11959,
     /* 184431 */     GIR_EraseRootFromParent_Done,
     /* 184432 */   // Label 3396: @184432
     /* 184432 */   GIM_Try, /*On fail goto*//*Label 3397*/ GIMT_Encode4(184474), // Rule ID 11960 //
     /* 184437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 184445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184455 */     // MIs[0] Op2
     /* 184455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184458 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 184463 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1875:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (SSHLLT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 184463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_S),
     /* 184466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184472 */     GIR_RootConstrainSelectedInstOperands,
     /* 184473 */     // GIR_Coverage, 11960,
     /* 184473 */     GIR_EraseRootFromParent_Done,
     /* 184474 */   // Label 3397: @184474
     /* 184474 */   GIM_Try, /*On fail goto*//*Label 3398*/ GIMT_Encode4(184516), // Rule ID 11961 //
     /* 184479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 184487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184497 */     // MIs[0] Op2
     /* 184497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184500 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 184505 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1875:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (SSHLLT_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 184505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_D),
     /* 184508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184514 */     GIR_RootConstrainSelectedInstOperands,
     /* 184515 */     // GIR_Coverage, 11961,
     /* 184515 */     GIR_EraseRootFromParent_Done,
     /* 184516 */   // Label 3398: @184516
     /* 184516 */   GIM_Try, /*On fail goto*//*Label 3399*/ GIMT_Encode4(184558), // Rule ID 11962 //
     /* 184521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 184529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 184535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184539 */     // MIs[0] Op2
     /* 184539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184542 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 184547 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2068:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (USHLLB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 184547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_H),
     /* 184550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184556 */     GIR_RootConstrainSelectedInstOperands,
     /* 184557 */     // GIR_Coverage, 11962,
     /* 184557 */     GIR_EraseRootFromParent_Done,
     /* 184558 */   // Label 3399: @184558
     /* 184558 */   GIM_Try, /*On fail goto*//*Label 3400*/ GIMT_Encode4(184600), // Rule ID 11963 //
     /* 184563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 184571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184581 */     // MIs[0] Op2
     /* 184581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184584 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 184589 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2068:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (USHLLB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 184589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_S),
     /* 184592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184596 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184598 */     GIR_RootConstrainSelectedInstOperands,
     /* 184599 */     // GIR_Coverage, 11963,
     /* 184599 */     GIR_EraseRootFromParent_Done,
     /* 184600 */   // Label 3400: @184600
     /* 184600 */   GIM_Try, /*On fail goto*//*Label 3401*/ GIMT_Encode4(184642), // Rule ID 11964 //
     /* 184605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 184613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184623 */     // MIs[0] Op2
     /* 184623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184626 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 184631 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2068:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (USHLLB_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 184631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_D),
     /* 184634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184640 */     GIR_RootConstrainSelectedInstOperands,
     /* 184641 */     // GIR_Coverage, 11964,
     /* 184641 */     GIR_EraseRootFromParent_Done,
     /* 184642 */   // Label 3401: @184642
     /* 184642 */   GIM_Try, /*On fail goto*//*Label 3402*/ GIMT_Encode4(184684), // Rule ID 11965 //
     /* 184647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 184655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 184661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184665 */     // MIs[0] Op2
     /* 184665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184668 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 184673 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2069:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (USHLLT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 184673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_H),
     /* 184676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184682 */     GIR_RootConstrainSelectedInstOperands,
     /* 184683 */     // GIR_Coverage, 11965,
     /* 184683 */     GIR_EraseRootFromParent_Done,
     /* 184684 */   // Label 3402: @184684
     /* 184684 */   GIM_Try, /*On fail goto*//*Label 3403*/ GIMT_Encode4(184726), // Rule ID 11966 //
     /* 184689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 184697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184707 */     // MIs[0] Op2
     /* 184707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184710 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 184715 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2069:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (USHLLT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 184715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_S),
     /* 184718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184724 */     GIR_RootConstrainSelectedInstOperands,
     /* 184725 */     // GIR_Coverage, 11966,
     /* 184725 */     GIR_EraseRootFromParent_Done,
     /* 184726 */   // Label 3403: @184726
     /* 184726 */   GIM_Try, /*On fail goto*//*Label 3404*/ GIMT_Encode4(184768), // Rule ID 11967 //
     /* 184731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 184739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184749 */     // MIs[0] Op2
     /* 184749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184752 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 184757 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2069:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (USHLLT_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 184757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_D),
     /* 184760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184766 */     GIR_RootConstrainSelectedInstOperands,
     /* 184767 */     // GIR_Coverage, 11967,
     /* 184767 */     GIR_EraseRootFromParent_Done,
     /* 184768 */   // Label 3404: @184768
     /* 184768 */   GIM_Try, /*On fail goto*//*Label 3405*/ GIMT_Encode4(184820), // Rule ID 2132 //
     /* 184773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 184776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 184781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 184784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 184787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 184802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 184806 */     // MIs[1] Operand 1
     /* 184806 */     // No operand predicates
     /* 184806 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184808 */     // (intrinsic_wo_chain:{ *:[v4i16] } 772:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv4i16_shift:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 184808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4i16_shift),
     /* 184811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184815 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 184818 */     GIR_RootConstrainSelectedInstOperands,
     /* 184819 */     // GIR_Coverage, 2132,
     /* 184819 */     GIR_EraseRootFromParent_Done,
     /* 184820 */   // Label 3405: @184820
     /* 184820 */   GIM_Try, /*On fail goto*//*Label 3406*/ GIMT_Encode4(184872), // Rule ID 2133 //
     /* 184825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 184828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 184833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 184836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 184839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 184846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 184850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 184854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 184858 */     // MIs[1] Operand 1
     /* 184858 */     // No operand predicates
     /* 184858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184860 */     // (intrinsic_wo_chain:{ *:[v8i16] } 772:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv8i16_shift:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 184860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8i16_shift),
     /* 184863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 184870 */     GIR_RootConstrainSelectedInstOperands,
     /* 184871 */     // GIR_Coverage, 2133,
     /* 184871 */     GIR_EraseRootFromParent_Done,
     /* 184872 */   // Label 3406: @184872
     /* 184872 */   GIM_Try, /*On fail goto*//*Label 3407*/ GIMT_Encode4(184924), // Rule ID 2134 //
     /* 184877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 184885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 184888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 184891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 184906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 184910 */     // MIs[1] Operand 1
     /* 184910 */     // No operand predicates
     /* 184910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184912 */     // (intrinsic_wo_chain:{ *:[v2i32] } 772:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv2i32_shift:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 184912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2i32_shift),
     /* 184915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184919 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 184922 */     GIR_RootConstrainSelectedInstOperands,
     /* 184923 */     // GIR_Coverage, 2134,
     /* 184923 */     GIR_EraseRootFromParent_Done,
     /* 184924 */   // Label 3407: @184924
     /* 184924 */   GIM_Try, /*On fail goto*//*Label 3408*/ GIMT_Encode4(184976), // Rule ID 2135 //
     /* 184929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 184937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 184940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 184943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 184950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 184954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 184958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 184962 */     // MIs[1] Operand 1
     /* 184962 */     // No operand predicates
     /* 184962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184964 */     // (intrinsic_wo_chain:{ *:[v4i32] } 772:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv4i32_shift:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 184964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4i32_shift),
     /* 184967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184971 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 184974 */     GIR_RootConstrainSelectedInstOperands,
     /* 184975 */     // GIR_Coverage, 2135,
     /* 184975 */     GIR_EraseRootFromParent_Done,
     /* 184976 */   // Label 3408: @184976
     /* 184976 */   GIM_Try, /*On fail goto*//*Label 3409*/ GIMT_Encode4(185028), // Rule ID 2136 //
     /* 184981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 184989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 184992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 184995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185014 */     // MIs[1] Operand 1
     /* 185014 */     // No operand predicates
     /* 185014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185016 */     // (intrinsic_wo_chain:{ *:[v2i64] } 772:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv2i64_shift:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2i64_shift),
     /* 185019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185023 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185026 */     GIR_RootConstrainSelectedInstOperands,
     /* 185027 */     // GIR_Coverage, 2136,
     /* 185027 */     GIR_EraseRootFromParent_Done,
     /* 185028 */   // Label 3409: @185028
     /* 185028 */   GIM_Try, /*On fail goto*//*Label 3410*/ GIMT_Encode4(185080), // Rule ID 2137 //
     /* 185033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 185036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 185041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 185044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 185047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185066 */     // MIs[1] Operand 1
     /* 185066 */     // No operand predicates
     /* 185066 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185068 */     // (intrinsic_wo_chain:{ *:[v4i16] } 773:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv4i16_shift:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4i16_shift),
     /* 185071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185075 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185078 */     GIR_RootConstrainSelectedInstOperands,
     /* 185079 */     // GIR_Coverage, 2137,
     /* 185079 */     GIR_EraseRootFromParent_Done,
     /* 185080 */   // Label 3410: @185080
     /* 185080 */   GIM_Try, /*On fail goto*//*Label 3411*/ GIMT_Encode4(185132), // Rule ID 2138 //
     /* 185085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 185088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 185093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 185096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 185099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185118 */     // MIs[1] Operand 1
     /* 185118 */     // No operand predicates
     /* 185118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185120 */     // (intrinsic_wo_chain:{ *:[v8i16] } 773:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv8i16_shift:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8i16_shift),
     /* 185123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185130 */     GIR_RootConstrainSelectedInstOperands,
     /* 185131 */     // GIR_Coverage, 2138,
     /* 185131 */     GIR_EraseRootFromParent_Done,
     /* 185132 */   // Label 3411: @185132
     /* 185132 */   GIM_Try, /*On fail goto*//*Label 3412*/ GIMT_Encode4(185184), // Rule ID 2139 //
     /* 185137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 185145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 185148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 185151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185170 */     // MIs[1] Operand 1
     /* 185170 */     // No operand predicates
     /* 185170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185172 */     // (intrinsic_wo_chain:{ *:[v2i32] } 773:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv2i32_shift:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2i32_shift),
     /* 185175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185182 */     GIR_RootConstrainSelectedInstOperands,
     /* 185183 */     // GIR_Coverage, 2139,
     /* 185183 */     GIR_EraseRootFromParent_Done,
     /* 185184 */   // Label 3412: @185184
     /* 185184 */   GIM_Try, /*On fail goto*//*Label 3413*/ GIMT_Encode4(185236), // Rule ID 2140 //
     /* 185189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 185197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 185200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 185203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185222 */     // MIs[1] Operand 1
     /* 185222 */     // No operand predicates
     /* 185222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185224 */     // (intrinsic_wo_chain:{ *:[v4i32] } 773:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv4i32_shift:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4i32_shift),
     /* 185227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185234 */     GIR_RootConstrainSelectedInstOperands,
     /* 185235 */     // GIR_Coverage, 2140,
     /* 185235 */     GIR_EraseRootFromParent_Done,
     /* 185236 */   // Label 3413: @185236
     /* 185236 */   GIM_Try, /*On fail goto*//*Label 3414*/ GIMT_Encode4(185288), // Rule ID 2141 //
     /* 185241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 185249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 185252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 185255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185274 */     // MIs[1] Operand 1
     /* 185274 */     // No operand predicates
     /* 185274 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185276 */     // (intrinsic_wo_chain:{ *:[v2i64] } 773:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv2i64_shift:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2i64_shift),
     /* 185279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185286 */     GIR_RootConstrainSelectedInstOperands,
     /* 185287 */     // GIR_Coverage, 2141,
     /* 185287 */     GIR_EraseRootFromParent_Done,
     /* 185288 */   // Label 3414: @185288
     /* 185288 */   GIM_Try, /*On fail goto*//*Label 3415*/ GIMT_Encode4(185340), // Rule ID 2142 //
     /* 185293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 185296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 185301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 185304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 185307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185326 */     // MIs[1] Operand 1
     /* 185326 */     // No operand predicates
     /* 185326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185328 */     // (intrinsic_wo_chain:{ *:[v4f16] } 775:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv4i16_shift:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4i16_shift),
     /* 185331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185338 */     GIR_RootConstrainSelectedInstOperands,
     /* 185339 */     // GIR_Coverage, 2142,
     /* 185339 */     GIR_EraseRootFromParent_Done,
     /* 185340 */   // Label 3415: @185340
     /* 185340 */   GIM_Try, /*On fail goto*//*Label 3416*/ GIMT_Encode4(185392), // Rule ID 2143 //
     /* 185345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 185348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 185353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 185356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 185359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185378 */     // MIs[1] Operand 1
     /* 185378 */     // No operand predicates
     /* 185378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185380 */     // (intrinsic_wo_chain:{ *:[v8f16] } 775:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv8i16_shift:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv8i16_shift),
     /* 185383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185390 */     GIR_RootConstrainSelectedInstOperands,
     /* 185391 */     // GIR_Coverage, 2143,
     /* 185391 */     GIR_EraseRootFromParent_Done,
     /* 185392 */   // Label 3416: @185392
     /* 185392 */   GIM_Try, /*On fail goto*//*Label 3417*/ GIMT_Encode4(185444), // Rule ID 2144 //
     /* 185397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 185405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 185408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 185411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185430 */     // MIs[1] Operand 1
     /* 185430 */     // No operand predicates
     /* 185430 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185432 */     // (intrinsic_wo_chain:{ *:[v2f32] } 775:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv2i32_shift:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2i32_shift),
     /* 185435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185442 */     GIR_RootConstrainSelectedInstOperands,
     /* 185443 */     // GIR_Coverage, 2144,
     /* 185443 */     GIR_EraseRootFromParent_Done,
     /* 185444 */   // Label 3417: @185444
     /* 185444 */   GIM_Try, /*On fail goto*//*Label 3418*/ GIMT_Encode4(185496), // Rule ID 2145 //
     /* 185449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 185457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 185460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 185463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185482 */     // MIs[1] Operand 1
     /* 185482 */     // No operand predicates
     /* 185482 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185484 */     // (intrinsic_wo_chain:{ *:[v4f32] } 775:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv4i32_shift:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4i32_shift),
     /* 185487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185494 */     GIR_RootConstrainSelectedInstOperands,
     /* 185495 */     // GIR_Coverage, 2145,
     /* 185495 */     GIR_EraseRootFromParent_Done,
     /* 185496 */   // Label 3418: @185496
     /* 185496 */   GIM_Try, /*On fail goto*//*Label 3419*/ GIMT_Encode4(185548), // Rule ID 2146 //
     /* 185501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 185509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 185512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 185515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185534 */     // MIs[1] Operand 1
     /* 185534 */     // No operand predicates
     /* 185534 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185536 */     // (intrinsic_wo_chain:{ *:[v2f64] } 775:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv2i64_shift:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2i64_shift),
     /* 185539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185546 */     GIR_RootConstrainSelectedInstOperands,
     /* 185547 */     // GIR_Coverage, 2146,
     /* 185547 */     GIR_EraseRootFromParent_Done,
     /* 185548 */   // Label 3419: @185548
     /* 185548 */   GIM_Try, /*On fail goto*//*Label 3420*/ GIMT_Encode4(185600), // Rule ID 2244 //
     /* 185553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 185556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 185561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 185564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 185567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185586 */     // MIs[1] Operand 1
     /* 185586 */     // No operand predicates
     /* 185586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185588 */     // (intrinsic_wo_chain:{ *:[v4f16] } 776:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv4i16_shift:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4i16_shift),
     /* 185591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185598 */     GIR_RootConstrainSelectedInstOperands,
     /* 185599 */     // GIR_Coverage, 2244,
     /* 185599 */     GIR_EraseRootFromParent_Done,
     /* 185600 */   // Label 3420: @185600
     /* 185600 */   GIM_Try, /*On fail goto*//*Label 3421*/ GIMT_Encode4(185652), // Rule ID 2245 //
     /* 185605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 185608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 185613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 185616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 185619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185638 */     // MIs[1] Operand 1
     /* 185638 */     // No operand predicates
     /* 185638 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185640 */     // (intrinsic_wo_chain:{ *:[v8f16] } 776:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv8i16_shift:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv8i16_shift),
     /* 185643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185647 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185650 */     GIR_RootConstrainSelectedInstOperands,
     /* 185651 */     // GIR_Coverage, 2245,
     /* 185651 */     GIR_EraseRootFromParent_Done,
     /* 185652 */   // Label 3421: @185652
     /* 185652 */   GIM_Try, /*On fail goto*//*Label 3422*/ GIMT_Encode4(185704), // Rule ID 2246 //
     /* 185657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 185665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 185668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 185671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185690 */     // MIs[1] Operand 1
     /* 185690 */     // No operand predicates
     /* 185690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185692 */     // (intrinsic_wo_chain:{ *:[v2f32] } 776:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv2i32_shift:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2i32_shift),
     /* 185695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185702 */     GIR_RootConstrainSelectedInstOperands,
     /* 185703 */     // GIR_Coverage, 2246,
     /* 185703 */     GIR_EraseRootFromParent_Done,
     /* 185704 */   // Label 3422: @185704
     /* 185704 */   GIM_Try, /*On fail goto*//*Label 3423*/ GIMT_Encode4(185756), // Rule ID 2247 //
     /* 185709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 185717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 185720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 185723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185742 */     // MIs[1] Operand 1
     /* 185742 */     // No operand predicates
     /* 185742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185744 */     // (intrinsic_wo_chain:{ *:[v4f32] } 776:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv4i32_shift:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4i32_shift),
     /* 185747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185754 */     GIR_RootConstrainSelectedInstOperands,
     /* 185755 */     // GIR_Coverage, 2247,
     /* 185755 */     GIR_EraseRootFromParent_Done,
     /* 185756 */   // Label 3423: @185756
     /* 185756 */   GIM_Try, /*On fail goto*//*Label 3424*/ GIMT_Encode4(185808), // Rule ID 2248 //
     /* 185761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 185769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 185772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 185775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185794 */     // MIs[1] Operand 1
     /* 185794 */     // No operand predicates
     /* 185794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185796 */     // (intrinsic_wo_chain:{ *:[v2f64] } 776:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv2i64_shift:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2i64_shift),
     /* 185799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185806 */     GIR_RootConstrainSelectedInstOperands,
     /* 185807 */     // GIR_Coverage, 2248,
     /* 185807 */     GIR_EraseRootFromParent_Done,
     /* 185808 */   // Label 3424: @185808
     /* 185808 */   GIM_Try, /*On fail goto*//*Label 3425*/ GIMT_Encode4(185853), // Rule ID 63 //
     /* 185813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 185816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign_generic),
     /* 185821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 185824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 185827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 185830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 185842 */     // (intrinsic_wo_chain:{ *:[i64] } 301:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)  =>  (PACGA:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)
     /* 185842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACGA),
     /* 185845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185849 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 185851 */     GIR_RootConstrainSelectedInstOperands,
     /* 185852 */     // GIR_Coverage, 63,
     /* 185852 */     GIR_EraseRootFromParent_Done,
     /* 185853 */   // Label 3425: @185853
     /* 185853 */   GIM_Try, /*On fail goto*//*Label 3426*/ GIMT_Encode4(185898), // Rule ID 129 //
     /* 185858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 185861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32b),
     /* 185866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 185869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 185872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 185879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 185883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 185887 */     // (intrinsic_wo_chain:{ *:[i32] } 513:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Brr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 185887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Brr),
     /* 185890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 185896 */     GIR_RootConstrainSelectedInstOperands,
     /* 185897 */     // GIR_Coverage, 129,
     /* 185897 */     GIR_EraseRootFromParent_Done,
     /* 185898 */   // Label 3426: @185898
     /* 185898 */   GIM_Try, /*On fail goto*//*Label 3427*/ GIMT_Encode4(185943), // Rule ID 130 //
     /* 185903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 185906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32h),
     /* 185911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 185914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 185917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 185924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 185928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 185932 */     // (intrinsic_wo_chain:{ *:[i32] } 518:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Hrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 185932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Hrr),
     /* 185935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 185941 */     GIR_RootConstrainSelectedInstOperands,
     /* 185942 */     // GIR_Coverage, 130,
     /* 185942 */     GIR_EraseRootFromParent_Done,
     /* 185943 */   // Label 3427: @185943
     /* 185943 */   GIM_Try, /*On fail goto*//*Label 3428*/ GIMT_Encode4(185988), // Rule ID 131 //
     /* 185948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 185951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32w),
     /* 185956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 185959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 185962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 185969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 185973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 185977 */     // (intrinsic_wo_chain:{ *:[i32] } 519:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Wrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 185977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Wrr),
     /* 185980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185984 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 185986 */     GIR_RootConstrainSelectedInstOperands,
     /* 185987 */     // GIR_Coverage, 131,
     /* 185987 */     GIR_EraseRootFromParent_Done,
     /* 185988 */   // Label 3428: @185988
     /* 185988 */   GIM_Try, /*On fail goto*//*Label 3429*/ GIMT_Encode4(186033), // Rule ID 132 //
     /* 185993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 185996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32x),
     /* 186001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 186004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 186010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 186022 */     // (intrinsic_wo_chain:{ *:[i32] } 520:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (CRC32Xrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 186022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Xrr),
     /* 186025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186031 */     GIR_RootConstrainSelectedInstOperands,
     /* 186032 */     // GIR_Coverage, 132,
     /* 186032 */     GIR_EraseRootFromParent_Done,
     /* 186033 */   // Label 3429: @186033
     /* 186033 */   GIM_Try, /*On fail goto*//*Label 3430*/ GIMT_Encode4(186078), // Rule ID 133 //
     /* 186038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 186041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cb),
     /* 186046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 186049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186067 */     // (intrinsic_wo_chain:{ *:[i32] } 514:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CBrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 186067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CBrr),
     /* 186070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186076 */     GIR_RootConstrainSelectedInstOperands,
     /* 186077 */     // GIR_Coverage, 133,
     /* 186077 */     GIR_EraseRootFromParent_Done,
     /* 186078 */   // Label 3430: @186078
     /* 186078 */   GIM_Try, /*On fail goto*//*Label 3431*/ GIMT_Encode4(186123), // Rule ID 134 //
     /* 186083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 186086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32ch),
     /* 186091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 186094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186112 */     // (intrinsic_wo_chain:{ *:[i32] } 515:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CHrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 186112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CHrr),
     /* 186115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186119 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186121 */     GIR_RootConstrainSelectedInstOperands,
     /* 186122 */     // GIR_Coverage, 134,
     /* 186122 */     GIR_EraseRootFromParent_Done,
     /* 186123 */   // Label 3431: @186123
     /* 186123 */   GIM_Try, /*On fail goto*//*Label 3432*/ GIMT_Encode4(186168), // Rule ID 135 //
     /* 186128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 186131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cw),
     /* 186136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 186139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186157 */     // (intrinsic_wo_chain:{ *:[i32] } 516:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 186157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CWrr),
     /* 186160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186164 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186166 */     GIR_RootConstrainSelectedInstOperands,
     /* 186167 */     // GIR_Coverage, 135,
     /* 186167 */     GIR_EraseRootFromParent_Done,
     /* 186168 */   // Label 3432: @186168
     /* 186168 */   GIM_Try, /*On fail goto*//*Label 3433*/ GIMT_Encode4(186213), // Rule ID 136 //
     /* 186173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 186176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cx),
     /* 186181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 186184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 186190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 186202 */     // (intrinsic_wo_chain:{ *:[i32] } 517:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (CRC32CXrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 186202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CXrr),
     /* 186205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186211 */     GIR_RootConstrainSelectedInstOperands,
     /* 186212 */     // GIR_Coverage, 136,
     /* 186212 */     GIR_EraseRootFromParent_Done,
     /* 186213 */   // Label 3433: @186213
     /* 186213 */   GIM_Try, /*On fail goto*//*Label 3434*/ GIMT_Encode4(186258), // Rule ID 1042 //
     /* 186218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 186226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 186229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 186232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 186235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186247 */     // (intrinsic_wo_chain:{ *:[v8i8] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (SUQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /* 186247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv8i8),
     /* 186250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186256 */     GIR_RootConstrainSelectedInstOperands,
     /* 186257 */     // GIR_Coverage, 1042,
     /* 186257 */     GIR_EraseRootFromParent_Done,
     /* 186258 */   // Label 3434: @186258
     /* 186258 */   GIM_Try, /*On fail goto*//*Label 3435*/ GIMT_Encode4(186303), // Rule ID 1043 //
     /* 186263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 186271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 186274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 186277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 186280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186292 */     // (intrinsic_wo_chain:{ *:[v16i8] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (SUQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 186292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv16i8),
     /* 186295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186301 */     GIR_RootConstrainSelectedInstOperands,
     /* 186302 */     // GIR_Coverage, 1043,
     /* 186302 */     GIR_EraseRootFromParent_Done,
     /* 186303 */   // Label 3435: @186303
     /* 186303 */   GIM_Try, /*On fail goto*//*Label 3436*/ GIMT_Encode4(186348), // Rule ID 1044 //
     /* 186308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 186316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 186319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 186322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 186325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186337 */     // (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (SUQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /* 186337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv4i16),
     /* 186340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186346 */     GIR_RootConstrainSelectedInstOperands,
     /* 186347 */     // GIR_Coverage, 1044,
     /* 186347 */     GIR_EraseRootFromParent_Done,
     /* 186348 */   // Label 3436: @186348
     /* 186348 */   GIM_Try, /*On fail goto*//*Label 3437*/ GIMT_Encode4(186393), // Rule ID 1045 //
     /* 186353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 186361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 186364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 186367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 186370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186382 */     // (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)  =>  (SUQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /* 186382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv8i16),
     /* 186385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186391 */     GIR_RootConstrainSelectedInstOperands,
     /* 186392 */     // GIR_Coverage, 1045,
     /* 186392 */     GIR_EraseRootFromParent_Done,
     /* 186393 */   // Label 3437: @186393
     /* 186393 */   GIM_Try, /*On fail goto*//*Label 3438*/ GIMT_Encode4(186438), // Rule ID 1046 //
     /* 186398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 186406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 186409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 186412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 186415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186427 */     // (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (SUQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /* 186427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv2i32),
     /* 186430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186436 */     GIR_RootConstrainSelectedInstOperands,
     /* 186437 */     // GIR_Coverage, 1046,
     /* 186437 */     GIR_EraseRootFromParent_Done,
     /* 186438 */   // Label 3438: @186438
     /* 186438 */   GIM_Try, /*On fail goto*//*Label 3439*/ GIMT_Encode4(186483), // Rule ID 1047 //
     /* 186443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 186451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 186454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 186457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 186460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186472 */     // (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SUQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 186472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv4i32),
     /* 186475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186481 */     GIR_RootConstrainSelectedInstOperands,
     /* 186482 */     // GIR_Coverage, 1047,
     /* 186482 */     GIR_EraseRootFromParent_Done,
     /* 186483 */   // Label 3439: @186483
     /* 186483 */   GIM_Try, /*On fail goto*//*Label 3440*/ GIMT_Encode4(186528), // Rule ID 1048 //
     /* 186488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 186496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 186499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 186502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 186505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186517 */     // (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)  =>  (SUQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)
     /* 186517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv2i64),
     /* 186520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186526 */     GIR_RootConstrainSelectedInstOperands,
     /* 186527 */     // GIR_Coverage, 1048,
     /* 186527 */     GIR_EraseRootFromParent_Done,
     /* 186528 */   // Label 3440: @186528
     /* 186528 */   GIM_Try, /*On fail goto*//*Label 3441*/ GIMT_Encode4(186573), // Rule ID 1090 //
     /* 186533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 186541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 186544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 186547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 186550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186562 */     // (intrinsic_wo_chain:{ *:[v8i8] } 764:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (USQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /* 186562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv8i8),
     /* 186565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186571 */     GIR_RootConstrainSelectedInstOperands,
     /* 186572 */     // GIR_Coverage, 1090,
     /* 186572 */     GIR_EraseRootFromParent_Done,
     /* 186573 */   // Label 3441: @186573
     /* 186573 */   GIM_Try, /*On fail goto*//*Label 3442*/ GIMT_Encode4(186618), // Rule ID 1091 //
     /* 186578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 186586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 186589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 186592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 186595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186607 */     // (intrinsic_wo_chain:{ *:[v16i8] } 764:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (USQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 186607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv16i8),
     /* 186610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186614 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186616 */     GIR_RootConstrainSelectedInstOperands,
     /* 186617 */     // GIR_Coverage, 1091,
     /* 186617 */     GIR_EraseRootFromParent_Done,
     /* 186618 */   // Label 3442: @186618
     /* 186618 */   GIM_Try, /*On fail goto*//*Label 3443*/ GIMT_Encode4(186663), // Rule ID 1092 //
     /* 186623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 186631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 186634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 186637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 186640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186652 */     // (intrinsic_wo_chain:{ *:[v4i16] } 764:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (USQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /* 186652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv4i16),
     /* 186655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186661 */     GIR_RootConstrainSelectedInstOperands,
     /* 186662 */     // GIR_Coverage, 1092,
     /* 186662 */     GIR_EraseRootFromParent_Done,
     /* 186663 */   // Label 3443: @186663
     /* 186663 */   GIM_Try, /*On fail goto*//*Label 3444*/ GIMT_Encode4(186708), // Rule ID 1093 //
     /* 186668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 186676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 186679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 186682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 186685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186697 */     // (intrinsic_wo_chain:{ *:[v8i16] } 764:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)  =>  (USQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /* 186697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv8i16),
     /* 186700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186706 */     GIR_RootConstrainSelectedInstOperands,
     /* 186707 */     // GIR_Coverage, 1093,
     /* 186707 */     GIR_EraseRootFromParent_Done,
     /* 186708 */   // Label 3444: @186708
     /* 186708 */   GIM_Try, /*On fail goto*//*Label 3445*/ GIMT_Encode4(186753), // Rule ID 1094 //
     /* 186713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 186721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 186724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 186727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 186730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186742 */     // (intrinsic_wo_chain:{ *:[v2i32] } 764:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (USQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /* 186742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv2i32),
     /* 186745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186749 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186751 */     GIR_RootConstrainSelectedInstOperands,
     /* 186752 */     // GIR_Coverage, 1094,
     /* 186752 */     GIR_EraseRootFromParent_Done,
     /* 186753 */   // Label 3445: @186753
     /* 186753 */   GIM_Try, /*On fail goto*//*Label 3446*/ GIMT_Encode4(186798), // Rule ID 1095 //
     /* 186758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 186766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 186769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 186772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 186775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186787 */     // (intrinsic_wo_chain:{ *:[v4i32] } 764:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (USQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 186787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv4i32),
     /* 186790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186794 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186796 */     GIR_RootConstrainSelectedInstOperands,
     /* 186797 */     // GIR_Coverage, 1095,
     /* 186797 */     GIR_EraseRootFromParent_Done,
     /* 186798 */   // Label 3446: @186798
     /* 186798 */   GIM_Try, /*On fail goto*//*Label 3447*/ GIMT_Encode4(186843), // Rule ID 1096 //
     /* 186803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 186811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 186814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 186817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 186820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186832 */     // (intrinsic_wo_chain:{ *:[v2i64] } 764:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)  =>  (USQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)
     /* 186832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv2i64),
     /* 186835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186841 */     GIR_RootConstrainSelectedInstOperands,
     /* 186842 */     // GIR_Coverage, 1096,
     /* 186842 */     GIR_EraseRootFromParent_Done,
     /* 186843 */   // Label 3447: @186843
     /* 186843 */   GIM_Try, /*On fail goto*//*Label 3448*/ GIMT_Encode4(186888), // Rule ID 1108 //
     /* 186848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 186856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 186859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 186862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 186865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186877 */     // (intrinsic_wo_chain:{ *:[v8i8] } 580:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ADDPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 186877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i8),
     /* 186880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186886 */     GIR_RootConstrainSelectedInstOperands,
     /* 186887 */     // GIR_Coverage, 1108,
     /* 186887 */     GIR_EraseRootFromParent_Done,
     /* 186888 */   // Label 3448: @186888
     /* 186888 */   GIM_Try, /*On fail goto*//*Label 3449*/ GIMT_Encode4(186933), // Rule ID 1110 //
     /* 186893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 186901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 186904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 186907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 186910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186922 */     // (intrinsic_wo_chain:{ *:[v16i8] } 580:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ADDPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 186922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /* 186925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186931 */     GIR_RootConstrainSelectedInstOperands,
     /* 186932 */     // GIR_Coverage, 1110,
     /* 186932 */     GIR_EraseRootFromParent_Done,
     /* 186933 */   // Label 3449: @186933
     /* 186933 */   GIM_Try, /*On fail goto*//*Label 3450*/ GIMT_Encode4(186978), // Rule ID 1112 //
     /* 186938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 186946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 186949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 186952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 186955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186967 */     // (intrinsic_wo_chain:{ *:[v4i16] } 580:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ADDPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 186967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i16),
     /* 186970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186976 */     GIR_RootConstrainSelectedInstOperands,
     /* 186977 */     // GIR_Coverage, 1112,
     /* 186977 */     GIR_EraseRootFromParent_Done,
     /* 186978 */   // Label 3450: @186978
     /* 186978 */   GIM_Try, /*On fail goto*//*Label 3451*/ GIMT_Encode4(187023), // Rule ID 1114 //
     /* 186983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 186991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 186994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 186997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 187000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187012 */     // (intrinsic_wo_chain:{ *:[v8i16] } 580:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 187012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /* 187015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187021 */     GIR_RootConstrainSelectedInstOperands,
     /* 187022 */     // GIR_Coverage, 1114,
     /* 187022 */     GIR_EraseRootFromParent_Done,
     /* 187023 */   // Label 3451: @187023
     /* 187023 */   GIM_Try, /*On fail goto*//*Label 3452*/ GIMT_Encode4(187068), // Rule ID 1116 //
     /* 187028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 187036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 187039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 187042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 187045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187057 */     // (intrinsic_wo_chain:{ *:[v2i32] } 580:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ADDPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 187057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 187060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187066 */     GIR_RootConstrainSelectedInstOperands,
     /* 187067 */     // GIR_Coverage, 1116,
     /* 187067 */     GIR_EraseRootFromParent_Done,
     /* 187068 */   // Label 3452: @187068
     /* 187068 */   GIM_Try, /*On fail goto*//*Label 3453*/ GIMT_Encode4(187113), // Rule ID 1118 //
     /* 187073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 187081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 187084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 187087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 187090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187102 */     // (intrinsic_wo_chain:{ *:[v4i32] } 580:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 187102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /* 187105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187111 */     GIR_RootConstrainSelectedInstOperands,
     /* 187112 */     // GIR_Coverage, 1118,
     /* 187112 */     GIR_EraseRootFromParent_Done,
     /* 187113 */   // Label 3453: @187113
     /* 187113 */   GIM_Try, /*On fail goto*//*Label 3454*/ GIMT_Encode4(187158), // Rule ID 1120 //
     /* 187118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 187126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 187129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 187132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 187135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187147 */     // (intrinsic_wo_chain:{ *:[v2i64] } 580:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDPv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 187147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /* 187150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187156 */     GIR_RootConstrainSelectedInstOperands,
     /* 187157 */     // GIR_Coverage, 1120,
     /* 187157 */     GIR_EraseRootFromParent_Done,
     /* 187158 */   // Label 3454: @187158
     /* 187158 */   GIM_Try, /*On fail goto*//*Label 3455*/ GIMT_Encode4(187203), // Rule ID 1163 //
     /* 187163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 187171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 187174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 187177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 187180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187192 */     // (intrinsic_wo_chain:{ *:[v4f16] } 586:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FABDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 187192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f16),
     /* 187195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187201 */     GIR_RootConstrainSelectedInstOperands,
     /* 187202 */     // GIR_Coverage, 1163,
     /* 187202 */     GIR_EraseRootFromParent_Done,
     /* 187203 */   // Label 3455: @187203
     /* 187203 */   GIM_Try, /*On fail goto*//*Label 3456*/ GIMT_Encode4(187248), // Rule ID 1164 //
     /* 187208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 187216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 187219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 187222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 187225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187237 */     // (intrinsic_wo_chain:{ *:[v8f16] } 586:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FABDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 187237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv8f16),
     /* 187240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187246 */     GIR_RootConstrainSelectedInstOperands,
     /* 187247 */     // GIR_Coverage, 1164,
     /* 187247 */     GIR_EraseRootFromParent_Done,
     /* 187248 */   // Label 3456: @187248
     /* 187248 */   GIM_Try, /*On fail goto*//*Label 3457*/ GIMT_Encode4(187293), // Rule ID 1165 //
     /* 187253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 187261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 187264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 187267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 187270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187282 */     // (intrinsic_wo_chain:{ *:[v2f32] } 586:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FABDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 187282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f32),
     /* 187285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187291 */     GIR_RootConstrainSelectedInstOperands,
     /* 187292 */     // GIR_Coverage, 1165,
     /* 187292 */     GIR_EraseRootFromParent_Done,
     /* 187293 */   // Label 3457: @187293
     /* 187293 */   GIM_Try, /*On fail goto*//*Label 3458*/ GIMT_Encode4(187338), // Rule ID 1166 //
     /* 187298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 187306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 187309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 187312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 187315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187327 */     // (intrinsic_wo_chain:{ *:[v4f32] } 586:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FABDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 187327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f32),
     /* 187330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187336 */     GIR_RootConstrainSelectedInstOperands,
     /* 187337 */     // GIR_Coverage, 1166,
     /* 187337 */     GIR_EraseRootFromParent_Done,
     /* 187338 */   // Label 3458: @187338
     /* 187338 */   GIM_Try, /*On fail goto*//*Label 3459*/ GIMT_Encode4(187383), // Rule ID 1167 //
     /* 187343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 187351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 187354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 187357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 187360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187372 */     // (intrinsic_wo_chain:{ *:[v2f64] } 586:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FABDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 187372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f64),
     /* 187375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187381 */     GIR_RootConstrainSelectedInstOperands,
     /* 187382 */     // GIR_Coverage, 1167,
     /* 187382 */     GIR_EraseRootFromParent_Done,
     /* 187383 */   // Label 3459: @187383
     /* 187383 */   GIM_Try, /*On fail goto*//*Label 3460*/ GIMT_Encode4(187428), // Rule ID 1169 //
     /* 187388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 187396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 187399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 187402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 187405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187417 */     // (intrinsic_wo_chain:{ *:[v4i16] } 587:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FACGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 187417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f16),
     /* 187420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187426 */     GIR_RootConstrainSelectedInstOperands,
     /* 187427 */     // GIR_Coverage, 1169,
     /* 187427 */     GIR_EraseRootFromParent_Done,
     /* 187428 */   // Label 3460: @187428
     /* 187428 */   GIM_Try, /*On fail goto*//*Label 3461*/ GIMT_Encode4(187473), // Rule ID 1171 //
     /* 187433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 187441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 187444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 187447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 187450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187462 */     // (intrinsic_wo_chain:{ *:[v8i16] } 587:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FACGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 187462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv8f16),
     /* 187465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187471 */     GIR_RootConstrainSelectedInstOperands,
     /* 187472 */     // GIR_Coverage, 1171,
     /* 187472 */     GIR_EraseRootFromParent_Done,
     /* 187473 */   // Label 3461: @187473
     /* 187473 */   GIM_Try, /*On fail goto*//*Label 3462*/ GIMT_Encode4(187518), // Rule ID 1173 //
     /* 187478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 187486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 187489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 187492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 187495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187507 */     // (intrinsic_wo_chain:{ *:[v2i32] } 587:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FACGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 187507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f32),
     /* 187510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187516 */     GIR_RootConstrainSelectedInstOperands,
     /* 187517 */     // GIR_Coverage, 1173,
     /* 187517 */     GIR_EraseRootFromParent_Done,
     /* 187518 */   // Label 3462: @187518
     /* 187518 */   GIM_Try, /*On fail goto*//*Label 3463*/ GIMT_Encode4(187563), // Rule ID 1175 //
     /* 187523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 187531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 187534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 187537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 187540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187552 */     // (intrinsic_wo_chain:{ *:[v4i32] } 587:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FACGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 187552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f32),
     /* 187555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187561 */     GIR_RootConstrainSelectedInstOperands,
     /* 187562 */     // GIR_Coverage, 1175,
     /* 187562 */     GIR_EraseRootFromParent_Done,
     /* 187563 */   // Label 3463: @187563
     /* 187563 */   GIM_Try, /*On fail goto*//*Label 3464*/ GIMT_Encode4(187608), // Rule ID 1177 //
     /* 187568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 187576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 187579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 187582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 187585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187597 */     // (intrinsic_wo_chain:{ *:[v2i64] } 587:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FACGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 187597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f64),
     /* 187600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187606 */     GIR_RootConstrainSelectedInstOperands,
     /* 187607 */     // GIR_Coverage, 1177,
     /* 187607 */     GIR_EraseRootFromParent_Done,
     /* 187608 */   // Label 3464: @187608
     /* 187608 */   GIM_Try, /*On fail goto*//*Label 3465*/ GIMT_Encode4(187653), // Rule ID 1179 //
     /* 187613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 187621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 187624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 187627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 187630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187642 */     // (intrinsic_wo_chain:{ *:[v4i16] } 588:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FACGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 187642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f16),
     /* 187645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187651 */     GIR_RootConstrainSelectedInstOperands,
     /* 187652 */     // GIR_Coverage, 1179,
     /* 187652 */     GIR_EraseRootFromParent_Done,
     /* 187653 */   // Label 3465: @187653
     /* 187653 */   GIM_Try, /*On fail goto*//*Label 3466*/ GIMT_Encode4(187698), // Rule ID 1181 //
     /* 187658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 187666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 187669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 187672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 187675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187687 */     // (intrinsic_wo_chain:{ *:[v8i16] } 588:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FACGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 187687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv8f16),
     /* 187690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187696 */     GIR_RootConstrainSelectedInstOperands,
     /* 187697 */     // GIR_Coverage, 1181,
     /* 187697 */     GIR_EraseRootFromParent_Done,
     /* 187698 */   // Label 3466: @187698
     /* 187698 */   GIM_Try, /*On fail goto*//*Label 3467*/ GIMT_Encode4(187743), // Rule ID 1183 //
     /* 187703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 187711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 187714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 187717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 187720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187732 */     // (intrinsic_wo_chain:{ *:[v2i32] } 588:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FACGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 187732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f32),
     /* 187735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187739 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187741 */     GIR_RootConstrainSelectedInstOperands,
     /* 187742 */     // GIR_Coverage, 1183,
     /* 187742 */     GIR_EraseRootFromParent_Done,
     /* 187743 */   // Label 3467: @187743
     /* 187743 */   GIM_Try, /*On fail goto*//*Label 3468*/ GIMT_Encode4(187788), // Rule ID 1185 //
     /* 187748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 187756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 187759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 187762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 187765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187777 */     // (intrinsic_wo_chain:{ *:[v4i32] } 588:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FACGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 187777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f32),
     /* 187780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187786 */     GIR_RootConstrainSelectedInstOperands,
     /* 187787 */     // GIR_Coverage, 1185,
     /* 187787 */     GIR_EraseRootFromParent_Done,
     /* 187788 */   // Label 3468: @187788
     /* 187788 */   GIM_Try, /*On fail goto*//*Label 3469*/ GIMT_Encode4(187833), // Rule ID 1187 //
     /* 187793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 187801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 187804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 187807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 187810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187822 */     // (intrinsic_wo_chain:{ *:[v2i64] } 588:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FACGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 187822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f64),
     /* 187825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187831 */     GIR_RootConstrainSelectedInstOperands,
     /* 187832 */     // GIR_Coverage, 1187,
     /* 187832 */     GIR_EraseRootFromParent_Done,
     /* 187833 */   // Label 3469: @187833
     /* 187833 */   GIM_Try, /*On fail goto*//*Label 3470*/ GIMT_Encode4(187878), // Rule ID 1189 //
     /* 187838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 187846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 187849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 187852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 187855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187867 */     // (intrinsic_wo_chain:{ *:[v4f16] } 589:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 187867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f16),
     /* 187870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187874 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187876 */     GIR_RootConstrainSelectedInstOperands,
     /* 187877 */     // GIR_Coverage, 1189,
     /* 187877 */     GIR_EraseRootFromParent_Done,
     /* 187878 */   // Label 3470: @187878
     /* 187878 */   GIM_Try, /*On fail goto*//*Label 3471*/ GIMT_Encode4(187923), // Rule ID 1191 //
     /* 187883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 187891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 187894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 187897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 187900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187912 */     // (intrinsic_wo_chain:{ *:[v8f16] } 589:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 187912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 187915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187921 */     GIR_RootConstrainSelectedInstOperands,
     /* 187922 */     // GIR_Coverage, 1191,
     /* 187922 */     GIR_EraseRootFromParent_Done,
     /* 187923 */   // Label 3471: @187923
     /* 187923 */   GIM_Try, /*On fail goto*//*Label 3472*/ GIMT_Encode4(187968), // Rule ID 1193 //
     /* 187928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 187936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 187939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 187942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 187945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187957 */     // (intrinsic_wo_chain:{ *:[v2f32] } 589:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 187957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f32),
     /* 187960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187966 */     GIR_RootConstrainSelectedInstOperands,
     /* 187967 */     // GIR_Coverage, 1193,
     /* 187967 */     GIR_EraseRootFromParent_Done,
     /* 187968 */   // Label 3472: @187968
     /* 187968 */   GIM_Try, /*On fail goto*//*Label 3473*/ GIMT_Encode4(188013), // Rule ID 1195 //
     /* 187973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 187981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 187984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 187987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 187990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188002 */     // (intrinsic_wo_chain:{ *:[v4f32] } 589:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 188002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 188005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188009 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188011 */     GIR_RootConstrainSelectedInstOperands,
     /* 188012 */     // GIR_Coverage, 1195,
     /* 188012 */     GIR_EraseRootFromParent_Done,
     /* 188013 */   // Label 3473: @188013
     /* 188013 */   GIM_Try, /*On fail goto*//*Label 3474*/ GIMT_Encode4(188058), // Rule ID 1197 //
     /* 188018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 188026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 188029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 188032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 188035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188047 */     // (intrinsic_wo_chain:{ *:[v2f64] } 589:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 188047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 188050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188056 */     GIR_RootConstrainSelectedInstOperands,
     /* 188057 */     // GIR_Coverage, 1197,
     /* 188057 */     GIR_EraseRootFromParent_Done,
     /* 188058 */   // Label 3474: @188058
     /* 188058 */   GIM_Try, /*On fail goto*//*Label 3475*/ GIMT_Encode4(188103), // Rule ID 1233 //
     /* 188063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 188071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 188074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 188077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 188080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188092 */     // (intrinsic_wo_chain:{ *:[v4f16] } 606:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 188092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv4f16),
     /* 188095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188101 */     GIR_RootConstrainSelectedInstOperands,
     /* 188102 */     // GIR_Coverage, 1233,
     /* 188102 */     GIR_EraseRootFromParent_Done,
     /* 188103 */   // Label 3475: @188103
     /* 188103 */   GIM_Try, /*On fail goto*//*Label 3476*/ GIMT_Encode4(188148), // Rule ID 1234 //
     /* 188108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 188116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 188119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 188122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 188125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188137 */     // (intrinsic_wo_chain:{ *:[v8f16] } 606:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 188137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv8f16),
     /* 188140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188146 */     GIR_RootConstrainSelectedInstOperands,
     /* 188147 */     // GIR_Coverage, 1234,
     /* 188147 */     GIR_EraseRootFromParent_Done,
     /* 188148 */   // Label 3476: @188148
     /* 188148 */   GIM_Try, /*On fail goto*//*Label 3477*/ GIMT_Encode4(188193), // Rule ID 1235 //
     /* 188153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 188161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 188164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 188167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 188170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188182 */     // (intrinsic_wo_chain:{ *:[v2f32] } 606:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 188182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2f32),
     /* 188185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188191 */     GIR_RootConstrainSelectedInstOperands,
     /* 188192 */     // GIR_Coverage, 1235,
     /* 188192 */     GIR_EraseRootFromParent_Done,
     /* 188193 */   // Label 3477: @188193
     /* 188193 */   GIM_Try, /*On fail goto*//*Label 3478*/ GIMT_Encode4(188238), // Rule ID 1236 //
     /* 188198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 188206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 188209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 188212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 188215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188227 */     // (intrinsic_wo_chain:{ *:[v4f32] } 606:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 188227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv4f32),
     /* 188230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188236 */     GIR_RootConstrainSelectedInstOperands,
     /* 188237 */     // GIR_Coverage, 1236,
     /* 188237 */     GIR_EraseRootFromParent_Done,
     /* 188238 */   // Label 3478: @188238
     /* 188238 */   GIM_Try, /*On fail goto*//*Label 3479*/ GIMT_Encode4(188283), // Rule ID 1237 //
     /* 188243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 188251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 188254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 188257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 188260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188272 */     // (intrinsic_wo_chain:{ *:[v2f64] } 606:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 188272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2f64),
     /* 188275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188281 */     GIR_RootConstrainSelectedInstOperands,
     /* 188282 */     // GIR_Coverage, 1237,
     /* 188282 */     GIR_EraseRootFromParent_Done,
     /* 188283 */   // Label 3479: @188283
     /* 188283 */   GIM_Try, /*On fail goto*//*Label 3480*/ GIMT_Encode4(188328), // Rule ID 1248 //
     /* 188288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 188296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 188299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 188302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 188305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188317 */     // (intrinsic_wo_chain:{ *:[v4f16] } 608:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 188317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv4f16),
     /* 188320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188326 */     GIR_RootConstrainSelectedInstOperands,
     /* 188327 */     // GIR_Coverage, 1248,
     /* 188327 */     GIR_EraseRootFromParent_Done,
     /* 188328 */   // Label 3480: @188328
     /* 188328 */   GIM_Try, /*On fail goto*//*Label 3481*/ GIMT_Encode4(188373), // Rule ID 1249 //
     /* 188333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 188341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 188344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 188347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 188350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188362 */     // (intrinsic_wo_chain:{ *:[v8f16] } 608:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 188362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv8f16),
     /* 188365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188371 */     GIR_RootConstrainSelectedInstOperands,
     /* 188372 */     // GIR_Coverage, 1249,
     /* 188372 */     GIR_EraseRootFromParent_Done,
     /* 188373 */   // Label 3481: @188373
     /* 188373 */   GIM_Try, /*On fail goto*//*Label 3482*/ GIMT_Encode4(188418), // Rule ID 1250 //
     /* 188378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 188386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 188389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 188392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 188395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188407 */     // (intrinsic_wo_chain:{ *:[v2f32] } 608:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 188407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2f32),
     /* 188410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188416 */     GIR_RootConstrainSelectedInstOperands,
     /* 188417 */     // GIR_Coverage, 1250,
     /* 188417 */     GIR_EraseRootFromParent_Done,
     /* 188418 */   // Label 3482: @188418
     /* 188418 */   GIM_Try, /*On fail goto*//*Label 3483*/ GIMT_Encode4(188463), // Rule ID 1251 //
     /* 188423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 188431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 188434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 188437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 188440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188452 */     // (intrinsic_wo_chain:{ *:[v4f32] } 608:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 188452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv4f32),
     /* 188455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188461 */     GIR_RootConstrainSelectedInstOperands,
     /* 188462 */     // GIR_Coverage, 1251,
     /* 188462 */     GIR_EraseRootFromParent_Done,
     /* 188463 */   // Label 3483: @188463
     /* 188463 */   GIM_Try, /*On fail goto*//*Label 3484*/ GIMT_Encode4(188508), // Rule ID 1252 //
     /* 188468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 188476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 188479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 188482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 188485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188497 */     // (intrinsic_wo_chain:{ *:[v2f64] } 608:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 188497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2f64),
     /* 188500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188506 */     GIR_RootConstrainSelectedInstOperands,
     /* 188507 */     // GIR_Coverage, 1252,
     /* 188507 */     GIR_EraseRootFromParent_Done,
     /* 188508 */   // Label 3484: @188508
     /* 188508 */   GIM_Try, /*On fail goto*//*Label 3485*/ GIMT_Encode4(188553), // Rule ID 1263 //
     /* 188513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 188521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 188524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 188527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 188530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188542 */     // (intrinsic_wo_chain:{ *:[v4f16] } 612:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 188542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv4f16),
     /* 188545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188549 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188551 */     GIR_RootConstrainSelectedInstOperands,
     /* 188552 */     // GIR_Coverage, 1263,
     /* 188552 */     GIR_EraseRootFromParent_Done,
     /* 188553 */   // Label 3485: @188553
     /* 188553 */   GIM_Try, /*On fail goto*//*Label 3486*/ GIMT_Encode4(188598), // Rule ID 1264 //
     /* 188558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 188566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 188569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 188572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 188575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188587 */     // (intrinsic_wo_chain:{ *:[v8f16] } 612:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 188587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv8f16),
     /* 188590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188596 */     GIR_RootConstrainSelectedInstOperands,
     /* 188597 */     // GIR_Coverage, 1264,
     /* 188597 */     GIR_EraseRootFromParent_Done,
     /* 188598 */   // Label 3486: @188598
     /* 188598 */   GIM_Try, /*On fail goto*//*Label 3487*/ GIMT_Encode4(188643), // Rule ID 1265 //
     /* 188603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 188611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 188614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 188617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 188620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188632 */     // (intrinsic_wo_chain:{ *:[v2f32] } 612:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 188632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2f32),
     /* 188635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188641 */     GIR_RootConstrainSelectedInstOperands,
     /* 188642 */     // GIR_Coverage, 1265,
     /* 188642 */     GIR_EraseRootFromParent_Done,
     /* 188643 */   // Label 3487: @188643
     /* 188643 */   GIM_Try, /*On fail goto*//*Label 3488*/ GIMT_Encode4(188688), // Rule ID 1266 //
     /* 188648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 188656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 188659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 188662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 188665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188677 */     // (intrinsic_wo_chain:{ *:[v4f32] } 612:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 188677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv4f32),
     /* 188680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188686 */     GIR_RootConstrainSelectedInstOperands,
     /* 188687 */     // GIR_Coverage, 1266,
     /* 188687 */     GIR_EraseRootFromParent_Done,
     /* 188688 */   // Label 3488: @188688
     /* 188688 */   GIM_Try, /*On fail goto*//*Label 3489*/ GIMT_Encode4(188733), // Rule ID 1267 //
     /* 188693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 188701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 188704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 188707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 188710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188722 */     // (intrinsic_wo_chain:{ *:[v2f64] } 612:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 188722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2f64),
     /* 188725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188731 */     GIR_RootConstrainSelectedInstOperands,
     /* 188732 */     // GIR_Coverage, 1267,
     /* 188732 */     GIR_EraseRootFromParent_Done,
     /* 188733 */   // Label 3489: @188733
     /* 188733 */   GIM_Try, /*On fail goto*//*Label 3490*/ GIMT_Encode4(188778), // Rule ID 1278 //
     /* 188738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 188746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 188749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 188752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 188755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188767 */     // (intrinsic_wo_chain:{ *:[v4f16] } 614:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 188767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv4f16),
     /* 188770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188776 */     GIR_RootConstrainSelectedInstOperands,
     /* 188777 */     // GIR_Coverage, 1278,
     /* 188777 */     GIR_EraseRootFromParent_Done,
     /* 188778 */   // Label 3490: @188778
     /* 188778 */   GIM_Try, /*On fail goto*//*Label 3491*/ GIMT_Encode4(188823), // Rule ID 1279 //
     /* 188783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 188791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 188794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 188797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 188800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188812 */     // (intrinsic_wo_chain:{ *:[v8f16] } 614:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 188812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv8f16),
     /* 188815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188819 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188821 */     GIR_RootConstrainSelectedInstOperands,
     /* 188822 */     // GIR_Coverage, 1279,
     /* 188822 */     GIR_EraseRootFromParent_Done,
     /* 188823 */   // Label 3491: @188823
     /* 188823 */   GIM_Try, /*On fail goto*//*Label 3492*/ GIMT_Encode4(188868), // Rule ID 1280 //
     /* 188828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 188836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 188839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 188842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 188845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188857 */     // (intrinsic_wo_chain:{ *:[v2f32] } 614:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 188857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2f32),
     /* 188860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188866 */     GIR_RootConstrainSelectedInstOperands,
     /* 188867 */     // GIR_Coverage, 1280,
     /* 188867 */     GIR_EraseRootFromParent_Done,
     /* 188868 */   // Label 3492: @188868
     /* 188868 */   GIM_Try, /*On fail goto*//*Label 3493*/ GIMT_Encode4(188913), // Rule ID 1281 //
     /* 188873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 188881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 188884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 188887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 188890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188902 */     // (intrinsic_wo_chain:{ *:[v4f32] } 614:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 188902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv4f32),
     /* 188905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188911 */     GIR_RootConstrainSelectedInstOperands,
     /* 188912 */     // GIR_Coverage, 1281,
     /* 188912 */     GIR_EraseRootFromParent_Done,
     /* 188913 */   // Label 3493: @188913
     /* 188913 */   GIM_Try, /*On fail goto*//*Label 3494*/ GIMT_Encode4(188958), // Rule ID 1282 //
     /* 188918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 188926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 188929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 188932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 188935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188947 */     // (intrinsic_wo_chain:{ *:[v2f64] } 614:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 188947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2f64),
     /* 188950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188956 */     GIR_RootConstrainSelectedInstOperands,
     /* 188957 */     // GIR_Coverage, 1282,
     /* 188957 */     GIR_EraseRootFromParent_Done,
     /* 188958 */   // Label 3494: @188958
     /* 188958 */   GIM_Try, /*On fail goto*//*Label 3495*/ GIMT_Encode4(189003), // Rule ID 1313 //
     /* 188963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 188971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 188974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 188977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 188980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188992 */     // (intrinsic_wo_chain:{ *:[v4f16] } 620:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 188992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4f16),
     /* 188995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188999 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189001 */     GIR_RootConstrainSelectedInstOperands,
     /* 189002 */     // GIR_Coverage, 1313,
     /* 189002 */     GIR_EraseRootFromParent_Done,
     /* 189003 */   // Label 3495: @189003
     /* 189003 */   GIM_Try, /*On fail goto*//*Label 3496*/ GIMT_Encode4(189048), // Rule ID 1314 //
     /* 189008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 189011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 189016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 189019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 189022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 189025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189037 */     // (intrinsic_wo_chain:{ *:[v8f16] } 620:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 189037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8f16),
     /* 189040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189046 */     GIR_RootConstrainSelectedInstOperands,
     /* 189047 */     // GIR_Coverage, 1314,
     /* 189047 */     GIR_EraseRootFromParent_Done,
     /* 189048 */   // Label 3496: @189048
     /* 189048 */   GIM_Try, /*On fail goto*//*Label 3497*/ GIMT_Encode4(189093), // Rule ID 1315 //
     /* 189053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 189061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 189064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 189067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 189070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189082 */     // (intrinsic_wo_chain:{ *:[v2f32] } 620:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 189082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2f32),
     /* 189085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189091 */     GIR_RootConstrainSelectedInstOperands,
     /* 189092 */     // GIR_Coverage, 1315,
     /* 189092 */     GIR_EraseRootFromParent_Done,
     /* 189093 */   // Label 3497: @189093
     /* 189093 */   GIM_Try, /*On fail goto*//*Label 3498*/ GIMT_Encode4(189138), // Rule ID 1316 //
     /* 189098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 189106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 189109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 189112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 189115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189127 */     // (intrinsic_wo_chain:{ *:[v4f32] } 620:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 189127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4f32),
     /* 189130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189136 */     GIR_RootConstrainSelectedInstOperands,
     /* 189137 */     // GIR_Coverage, 1316,
     /* 189137 */     GIR_EraseRootFromParent_Done,
     /* 189138 */   // Label 3498: @189138
     /* 189138 */   GIM_Try, /*On fail goto*//*Label 3499*/ GIMT_Encode4(189183), // Rule ID 1317 //
     /* 189143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 189151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 189154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 189157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 189160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189172 */     // (intrinsic_wo_chain:{ *:[v2f64] } 620:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 189172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2f64),
     /* 189175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189181 */     GIR_RootConstrainSelectedInstOperands,
     /* 189182 */     // GIR_Coverage, 1317,
     /* 189182 */     GIR_EraseRootFromParent_Done,
     /* 189183 */   // Label 3499: @189183
     /* 189183 */   GIM_Try, /*On fail goto*//*Label 3500*/ GIMT_Encode4(189228), // Rule ID 1328 //
     /* 189188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 189191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 189196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 189199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 189202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 189205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189217 */     // (intrinsic_wo_chain:{ *:[v4f16] } 643:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FRECPSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 189217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv4f16),
     /* 189220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189224 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189226 */     GIR_RootConstrainSelectedInstOperands,
     /* 189227 */     // GIR_Coverage, 1328,
     /* 189227 */     GIR_EraseRootFromParent_Done,
     /* 189228 */   // Label 3500: @189228
     /* 189228 */   GIM_Try, /*On fail goto*//*Label 3501*/ GIMT_Encode4(189273), // Rule ID 1329 //
     /* 189233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 189236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 189241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 189244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 189247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 189250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189262 */     // (intrinsic_wo_chain:{ *:[v8f16] } 643:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FRECPSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 189262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv8f16),
     /* 189265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189271 */     GIR_RootConstrainSelectedInstOperands,
     /* 189272 */     // GIR_Coverage, 1329,
     /* 189272 */     GIR_EraseRootFromParent_Done,
     /* 189273 */   // Label 3501: @189273
     /* 189273 */   GIM_Try, /*On fail goto*//*Label 3502*/ GIMT_Encode4(189318), // Rule ID 1330 //
     /* 189278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 189286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 189289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 189292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 189295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189307 */     // (intrinsic_wo_chain:{ *:[v2f32] } 643:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FRECPSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 189307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv2f32),
     /* 189310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189316 */     GIR_RootConstrainSelectedInstOperands,
     /* 189317 */     // GIR_Coverage, 1330,
     /* 189317 */     GIR_EraseRootFromParent_Done,
     /* 189318 */   // Label 3502: @189318
     /* 189318 */   GIM_Try, /*On fail goto*//*Label 3503*/ GIMT_Encode4(189363), // Rule ID 1331 //
     /* 189323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 189331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 189334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 189337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 189340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189352 */     // (intrinsic_wo_chain:{ *:[v4f32] } 643:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FRECPSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 189352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv4f32),
     /* 189355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189359 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189361 */     GIR_RootConstrainSelectedInstOperands,
     /* 189362 */     // GIR_Coverage, 1331,
     /* 189362 */     GIR_EraseRootFromParent_Done,
     /* 189363 */   // Label 3503: @189363
     /* 189363 */   GIM_Try, /*On fail goto*//*Label 3504*/ GIMT_Encode4(189408), // Rule ID 1332 //
     /* 189368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 189376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 189379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 189382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 189385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189397 */     // (intrinsic_wo_chain:{ *:[v2f64] } 643:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FRECPSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 189397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv2f64),
     /* 189400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189406 */     GIR_RootConstrainSelectedInstOperands,
     /* 189407 */     // GIR_Coverage, 1332,
     /* 189407 */     GIR_EraseRootFromParent_Done,
     /* 189408 */   // Label 3504: @189408
     /* 189408 */   GIM_Try, /*On fail goto*//*Label 3505*/ GIMT_Encode4(189453), // Rule ID 1333 //
     /* 189413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 189416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 189421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 189424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 189427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 189430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189442 */     // (intrinsic_wo_chain:{ *:[v4f16] } 650:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FRSQRTSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 189442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv4f16),
     /* 189445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189449 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189451 */     GIR_RootConstrainSelectedInstOperands,
     /* 189452 */     // GIR_Coverage, 1333,
     /* 189452 */     GIR_EraseRootFromParent_Done,
     /* 189453 */   // Label 3505: @189453
     /* 189453 */   GIM_Try, /*On fail goto*//*Label 3506*/ GIMT_Encode4(189498), // Rule ID 1334 //
     /* 189458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 189461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 189466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 189469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 189472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 189475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189487 */     // (intrinsic_wo_chain:{ *:[v8f16] } 650:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FRSQRTSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 189487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv8f16),
     /* 189490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189494 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189496 */     GIR_RootConstrainSelectedInstOperands,
     /* 189497 */     // GIR_Coverage, 1334,
     /* 189497 */     GIR_EraseRootFromParent_Done,
     /* 189498 */   // Label 3506: @189498
     /* 189498 */   GIM_Try, /*On fail goto*//*Label 3507*/ GIMT_Encode4(189543), // Rule ID 1335 //
     /* 189503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 189511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 189514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 189517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 189520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189532 */     // (intrinsic_wo_chain:{ *:[v2f32] } 650:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FRSQRTSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 189532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv2f32),
     /* 189535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189541 */     GIR_RootConstrainSelectedInstOperands,
     /* 189542 */     // GIR_Coverage, 1335,
     /* 189542 */     GIR_EraseRootFromParent_Done,
     /* 189543 */   // Label 3507: @189543
     /* 189543 */   GIM_Try, /*On fail goto*//*Label 3508*/ GIMT_Encode4(189588), // Rule ID 1336 //
     /* 189548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 189556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 189559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 189562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 189565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189577 */     // (intrinsic_wo_chain:{ *:[v4f32] } 650:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FRSQRTSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 189577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv4f32),
     /* 189580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189586 */     GIR_RootConstrainSelectedInstOperands,
     /* 189587 */     // GIR_Coverage, 1336,
     /* 189587 */     GIR_EraseRootFromParent_Done,
     /* 189588 */   // Label 3508: @189588
     /* 189588 */   GIM_Try, /*On fail goto*//*Label 3509*/ GIMT_Encode4(189633), // Rule ID 1337 //
     /* 189593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 189601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 189604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 189607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 189610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189622 */     // (intrinsic_wo_chain:{ *:[v2f64] } 650:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FRSQRTSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 189622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv2f64),
     /* 189625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189631 */     GIR_RootConstrainSelectedInstOperands,
     /* 189632 */     // GIR_Coverage, 1337,
     /* 189632 */     GIR_EraseRootFromParent_Done,
     /* 189633 */   // Label 3509: @189633
     /* 189633 */   GIM_Try, /*On fail goto*//*Label 3510*/ GIMT_Encode4(189678), // Rule ID 1354 //
     /* 189638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_pmul),
     /* 189646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 189649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 189652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 189655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189667 */     // (intrinsic_wo_chain:{ *:[v8i8] } 663:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (PMULv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 189667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULv8i8),
     /* 189670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189676 */     GIR_RootConstrainSelectedInstOperands,
     /* 189677 */     // GIR_Coverage, 1354,
     /* 189677 */     GIR_EraseRootFromParent_Done,
     /* 189678 */   // Label 3510: @189678
     /* 189678 */   GIM_Try, /*On fail goto*//*Label 3511*/ GIMT_Encode4(189723), // Rule ID 1355 //
     /* 189683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_pmul),
     /* 189691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 189694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 189697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 189700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189712 */     // (intrinsic_wo_chain:{ *:[v16i8] } 663:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (PMULv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 189712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULv16i8),
     /* 189715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189721 */     GIR_RootConstrainSelectedInstOperands,
     /* 189722 */     // GIR_Coverage, 1355,
     /* 189722 */     GIR_EraseRootFromParent_Done,
     /* 189723 */   // Label 3511: @189723
     /* 189723 */   GIM_Try, /*On fail goto*//*Label 3512*/ GIMT_Encode4(189768), // Rule ID 1369 //
     /* 189728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 189736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 189739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 189742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 189745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189757 */     // (intrinsic_wo_chain:{ *:[v8i8] } 669:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SABDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 189757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv8i8),
     /* 189760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189766 */     GIR_RootConstrainSelectedInstOperands,
     /* 189767 */     // GIR_Coverage, 1369,
     /* 189767 */     GIR_EraseRootFromParent_Done,
     /* 189768 */   // Label 3512: @189768
     /* 189768 */   GIM_Try, /*On fail goto*//*Label 3513*/ GIMT_Encode4(189813), // Rule ID 1371 //
     /* 189773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 189781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 189784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 189787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 189790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189802 */     // (intrinsic_wo_chain:{ *:[v16i8] } 669:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SABDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 189802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv16i8),
     /* 189805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189811 */     GIR_RootConstrainSelectedInstOperands,
     /* 189812 */     // GIR_Coverage, 1371,
     /* 189812 */     GIR_EraseRootFromParent_Done,
     /* 189813 */   // Label 3513: @189813
     /* 189813 */   GIM_Try, /*On fail goto*//*Label 3514*/ GIMT_Encode4(189858), // Rule ID 1373 //
     /* 189818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 189826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 189829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 189832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 189835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189847 */     // (intrinsic_wo_chain:{ *:[v4i16] } 669:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SABDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 189847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv4i16),
     /* 189850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189854 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189856 */     GIR_RootConstrainSelectedInstOperands,
     /* 189857 */     // GIR_Coverage, 1373,
     /* 189857 */     GIR_EraseRootFromParent_Done,
     /* 189858 */   // Label 3514: @189858
     /* 189858 */   GIM_Try, /*On fail goto*//*Label 3515*/ GIMT_Encode4(189903), // Rule ID 1375 //
     /* 189863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 189871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 189874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 189877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 189880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189892 */     // (intrinsic_wo_chain:{ *:[v8i16] } 669:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SABDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 189892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv8i16),
     /* 189895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189899 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189901 */     GIR_RootConstrainSelectedInstOperands,
     /* 189902 */     // GIR_Coverage, 1375,
     /* 189902 */     GIR_EraseRootFromParent_Done,
     /* 189903 */   // Label 3515: @189903
     /* 189903 */   GIM_Try, /*On fail goto*//*Label 3516*/ GIMT_Encode4(189948), // Rule ID 1377 //
     /* 189908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 189916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 189919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 189922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 189925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189937 */     // (intrinsic_wo_chain:{ *:[v2i32] } 669:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SABDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 189937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv2i32),
     /* 189940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189946 */     GIR_RootConstrainSelectedInstOperands,
     /* 189947 */     // GIR_Coverage, 1377,
     /* 189947 */     GIR_EraseRootFromParent_Done,
     /* 189948 */   // Label 3516: @189948
     /* 189948 */   GIM_Try, /*On fail goto*//*Label 3517*/ GIMT_Encode4(189993), // Rule ID 1379 //
     /* 189953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 189961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 189964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 189967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 189970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189982 */     // (intrinsic_wo_chain:{ *:[v4i32] } 669:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SABDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 189982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv4i32),
     /* 189985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189991 */     GIR_RootConstrainSelectedInstOperands,
     /* 189992 */     // GIR_Coverage, 1379,
     /* 189992 */     GIR_EraseRootFromParent_Done,
     /* 189993 */   // Label 3517: @189993
     /* 189993 */   GIM_Try, /*On fail goto*//*Label 3518*/ GIMT_Encode4(190038), // Rule ID 1386 //
     /* 189998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 190006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 190009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 190012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 190015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190027 */     // (intrinsic_wo_chain:{ *:[v8i8] } 679:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SHSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 190027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv8i8),
     /* 190030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190036 */     GIR_RootConstrainSelectedInstOperands,
     /* 190037 */     // GIR_Coverage, 1386,
     /* 190037 */     GIR_EraseRootFromParent_Done,
     /* 190038 */   // Label 3518: @190038
     /* 190038 */   GIM_Try, /*On fail goto*//*Label 3519*/ GIMT_Encode4(190083), // Rule ID 1387 //
     /* 190043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 190051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 190054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 190057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 190060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190072 */     // (intrinsic_wo_chain:{ *:[v16i8] } 679:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SHSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 190072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv16i8),
     /* 190075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190081 */     GIR_RootConstrainSelectedInstOperands,
     /* 190082 */     // GIR_Coverage, 1387,
     /* 190082 */     GIR_EraseRootFromParent_Done,
     /* 190083 */   // Label 3519: @190083
     /* 190083 */   GIM_Try, /*On fail goto*//*Label 3520*/ GIMT_Encode4(190128), // Rule ID 1388 //
     /* 190088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 190096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 190099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 190102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 190105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190117 */     // (intrinsic_wo_chain:{ *:[v4i16] } 679:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SHSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 190117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv4i16),
     /* 190120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190126 */     GIR_RootConstrainSelectedInstOperands,
     /* 190127 */     // GIR_Coverage, 1388,
     /* 190127 */     GIR_EraseRootFromParent_Done,
     /* 190128 */   // Label 3520: @190128
     /* 190128 */   GIM_Try, /*On fail goto*//*Label 3521*/ GIMT_Encode4(190173), // Rule ID 1389 //
     /* 190133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 190141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 190144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 190147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 190150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190162 */     // (intrinsic_wo_chain:{ *:[v8i16] } 679:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SHSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 190162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv8i16),
     /* 190165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190171 */     GIR_RootConstrainSelectedInstOperands,
     /* 190172 */     // GIR_Coverage, 1389,
     /* 190172 */     GIR_EraseRootFromParent_Done,
     /* 190173 */   // Label 3521: @190173
     /* 190173 */   GIM_Try, /*On fail goto*//*Label 3522*/ GIMT_Encode4(190218), // Rule ID 1390 //
     /* 190178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 190186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 190189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 190192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 190195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190207 */     // (intrinsic_wo_chain:{ *:[v2i32] } 679:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SHSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 190207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv2i32),
     /* 190210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190216 */     GIR_RootConstrainSelectedInstOperands,
     /* 190217 */     // GIR_Coverage, 1390,
     /* 190217 */     GIR_EraseRootFromParent_Done,
     /* 190218 */   // Label 3522: @190218
     /* 190218 */   GIM_Try, /*On fail goto*//*Label 3523*/ GIMT_Encode4(190263), // Rule ID 1391 //
     /* 190223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 190231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 190234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 190237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 190240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190252 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 190252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv4i32),
     /* 190255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190259 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190261 */     GIR_RootConstrainSelectedInstOperands,
     /* 190262 */     // GIR_Coverage, 1391,
     /* 190262 */     GIR_EraseRootFromParent_Done,
     /* 190263 */   // Label 3523: @190263
     /* 190263 */   GIM_Try, /*On fail goto*//*Label 3524*/ GIMT_Encode4(190308), // Rule ID 1392 //
     /* 190268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 190276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 190279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 190282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 190285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190297 */     // (intrinsic_wo_chain:{ *:[v8i8] } 681:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMAXPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 190297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv8i8),
     /* 190300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190306 */     GIR_RootConstrainSelectedInstOperands,
     /* 190307 */     // GIR_Coverage, 1392,
     /* 190307 */     GIR_EraseRootFromParent_Done,
     /* 190308 */   // Label 3524: @190308
     /* 190308 */   GIM_Try, /*On fail goto*//*Label 3525*/ GIMT_Encode4(190353), // Rule ID 1393 //
     /* 190313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 190321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 190324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 190327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 190330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190342 */     // (intrinsic_wo_chain:{ *:[v16i8] } 681:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMAXPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 190342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv16i8),
     /* 190345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190351 */     GIR_RootConstrainSelectedInstOperands,
     /* 190352 */     // GIR_Coverage, 1393,
     /* 190352 */     GIR_EraseRootFromParent_Done,
     /* 190353 */   // Label 3525: @190353
     /* 190353 */   GIM_Try, /*On fail goto*//*Label 3526*/ GIMT_Encode4(190398), // Rule ID 1394 //
     /* 190358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 190366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 190369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 190372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 190375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190387 */     // (intrinsic_wo_chain:{ *:[v4i16] } 681:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMAXPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 190387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv4i16),
     /* 190390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190396 */     GIR_RootConstrainSelectedInstOperands,
     /* 190397 */     // GIR_Coverage, 1394,
     /* 190397 */     GIR_EraseRootFromParent_Done,
     /* 190398 */   // Label 3526: @190398
     /* 190398 */   GIM_Try, /*On fail goto*//*Label 3527*/ GIMT_Encode4(190443), // Rule ID 1395 //
     /* 190403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 190411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 190414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 190417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 190420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190432 */     // (intrinsic_wo_chain:{ *:[v8i16] } 681:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMAXPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 190432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv8i16),
     /* 190435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190441 */     GIR_RootConstrainSelectedInstOperands,
     /* 190442 */     // GIR_Coverage, 1395,
     /* 190442 */     GIR_EraseRootFromParent_Done,
     /* 190443 */   // Label 3527: @190443
     /* 190443 */   GIM_Try, /*On fail goto*//*Label 3528*/ GIMT_Encode4(190488), // Rule ID 1396 //
     /* 190448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 190456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 190459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 190462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 190465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190477 */     // (intrinsic_wo_chain:{ *:[v2i32] } 681:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMAXPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 190477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 190480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190484 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190486 */     GIR_RootConstrainSelectedInstOperands,
     /* 190487 */     // GIR_Coverage, 1396,
     /* 190487 */     GIR_EraseRootFromParent_Done,
     /* 190488 */   // Label 3528: @190488
     /* 190488 */   GIM_Try, /*On fail goto*//*Label 3529*/ GIMT_Encode4(190533), // Rule ID 1397 //
     /* 190493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 190501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 190504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 190507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 190510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190522 */     // (intrinsic_wo_chain:{ *:[v4i32] } 681:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMAXPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 190522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv4i32),
     /* 190525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190531 */     GIR_RootConstrainSelectedInstOperands,
     /* 190532 */     // GIR_Coverage, 1397,
     /* 190532 */     GIR_EraseRootFromParent_Done,
     /* 190533 */   // Label 3529: @190533
     /* 190533 */   GIM_Try, /*On fail goto*//*Label 3530*/ GIMT_Encode4(190578), // Rule ID 1404 //
     /* 190538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 190546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 190549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 190552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 190555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190567 */     // (intrinsic_wo_chain:{ *:[v8i8] } 684:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMINPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 190567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv8i8),
     /* 190570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190576 */     GIR_RootConstrainSelectedInstOperands,
     /* 190577 */     // GIR_Coverage, 1404,
     /* 190577 */     GIR_EraseRootFromParent_Done,
     /* 190578 */   // Label 3530: @190578
     /* 190578 */   GIM_Try, /*On fail goto*//*Label 3531*/ GIMT_Encode4(190623), // Rule ID 1405 //
     /* 190583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 190591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 190594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 190597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 190600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190612 */     // (intrinsic_wo_chain:{ *:[v16i8] } 684:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMINPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 190612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv16i8),
     /* 190615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190621 */     GIR_RootConstrainSelectedInstOperands,
     /* 190622 */     // GIR_Coverage, 1405,
     /* 190622 */     GIR_EraseRootFromParent_Done,
     /* 190623 */   // Label 3531: @190623
     /* 190623 */   GIM_Try, /*On fail goto*//*Label 3532*/ GIMT_Encode4(190668), // Rule ID 1406 //
     /* 190628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 190636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 190639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 190642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 190645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190657 */     // (intrinsic_wo_chain:{ *:[v4i16] } 684:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMINPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 190657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv4i16),
     /* 190660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190666 */     GIR_RootConstrainSelectedInstOperands,
     /* 190667 */     // GIR_Coverage, 1406,
     /* 190667 */     GIR_EraseRootFromParent_Done,
     /* 190668 */   // Label 3532: @190668
     /* 190668 */   GIM_Try, /*On fail goto*//*Label 3533*/ GIMT_Encode4(190713), // Rule ID 1407 //
     /* 190673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 190681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 190684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 190687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 190690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190702 */     // (intrinsic_wo_chain:{ *:[v8i16] } 684:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMINPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 190702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv8i16),
     /* 190705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190711 */     GIR_RootConstrainSelectedInstOperands,
     /* 190712 */     // GIR_Coverage, 1407,
     /* 190712 */     GIR_EraseRootFromParent_Done,
     /* 190713 */   // Label 3533: @190713
     /* 190713 */   GIM_Try, /*On fail goto*//*Label 3534*/ GIMT_Encode4(190758), // Rule ID 1408 //
     /* 190718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 190726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 190729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 190732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 190735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190747 */     // (intrinsic_wo_chain:{ *:[v2i32] } 684:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMINPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 190747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 190750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190756 */     GIR_RootConstrainSelectedInstOperands,
     /* 190757 */     // GIR_Coverage, 1408,
     /* 190757 */     GIR_EraseRootFromParent_Done,
     /* 190758 */   // Label 3534: @190758
     /* 190758 */   GIM_Try, /*On fail goto*//*Label 3535*/ GIMT_Encode4(190803), // Rule ID 1409 //
     /* 190763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 190771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 190774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 190777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 190780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190792 */     // (intrinsic_wo_chain:{ *:[v4i32] } 684:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMINPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 190792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv4i32),
     /* 190795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190799 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190801 */     GIR_RootConstrainSelectedInstOperands,
     /* 190802 */     // GIR_Coverage, 1409,
     /* 190802 */     GIR_EraseRootFromParent_Done,
     /* 190803 */   // Label 3535: @190803
     /* 190803 */   GIM_Try, /*On fail goto*//*Label 3536*/ GIMT_Encode4(190848), // Rule ID 1423 //
     /* 190808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 190816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 190819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 190822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 190825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190837 */     // (intrinsic_wo_chain:{ *:[v4i16] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQDMULHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 190837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16),
     /* 190840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190844 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190846 */     GIR_RootConstrainSelectedInstOperands,
     /* 190847 */     // GIR_Coverage, 1423,
     /* 190847 */     GIR_EraseRootFromParent_Done,
     /* 190848 */   // Label 3536: @190848
     /* 190848 */   GIM_Try, /*On fail goto*//*Label 3537*/ GIMT_Encode4(190893), // Rule ID 1424 //
     /* 190853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 190861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 190864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 190867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 190870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190882 */     // (intrinsic_wo_chain:{ *:[v8i16] } 690:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQDMULHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 190882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv8i16),
     /* 190885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190891 */     GIR_RootConstrainSelectedInstOperands,
     /* 190892 */     // GIR_Coverage, 1424,
     /* 190892 */     GIR_EraseRootFromParent_Done,
     /* 190893 */   // Label 3537: @190893
     /* 190893 */   GIM_Try, /*On fail goto*//*Label 3538*/ GIMT_Encode4(190938), // Rule ID 1425 //
     /* 190898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 190906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 190909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 190912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 190915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190927 */     // (intrinsic_wo_chain:{ *:[v2i32] } 690:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQDMULHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 190927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32),
     /* 190930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190936 */     GIR_RootConstrainSelectedInstOperands,
     /* 190937 */     // GIR_Coverage, 1425,
     /* 190937 */     GIR_EraseRootFromParent_Done,
     /* 190938 */   // Label 3538: @190938
     /* 190938 */   GIM_Try, /*On fail goto*//*Label 3539*/ GIMT_Encode4(190983), // Rule ID 1426 //
     /* 190943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 190951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 190954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 190957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 190960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190972 */     // (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQDMULHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 190972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i32),
     /* 190975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190981 */     GIR_RootConstrainSelectedInstOperands,
     /* 190982 */     // GIR_Coverage, 1426,
     /* 190982 */     GIR_EraseRootFromParent_Done,
     /* 190983 */   // Label 3539: @190983
     /* 190983 */   GIM_Try, /*On fail goto*//*Label 3540*/ GIMT_Encode4(191028), // Rule ID 1427 //
     /* 190988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 190996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 190999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 191002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 191005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191017 */     // (intrinsic_wo_chain:{ *:[v4i16] } 698:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMULHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 191017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16),
     /* 191020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191026 */     GIR_RootConstrainSelectedInstOperands,
     /* 191027 */     // GIR_Coverage, 1427,
     /* 191027 */     GIR_EraseRootFromParent_Done,
     /* 191028 */   // Label 3540: @191028
     /* 191028 */   GIM_Try, /*On fail goto*//*Label 3541*/ GIMT_Encode4(191073), // Rule ID 1428 //
     /* 191033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 191041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 191044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 191047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 191050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191062 */     // (intrinsic_wo_chain:{ *:[v8i16] } 698:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMULHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 191062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv8i16),
     /* 191065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191071 */     GIR_RootConstrainSelectedInstOperands,
     /* 191072 */     // GIR_Coverage, 1428,
     /* 191072 */     GIR_EraseRootFromParent_Done,
     /* 191073 */   // Label 3541: @191073
     /* 191073 */   GIM_Try, /*On fail goto*//*Label 3542*/ GIMT_Encode4(191118), // Rule ID 1429 //
     /* 191078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 191086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 191089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 191092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 191095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191107 */     // (intrinsic_wo_chain:{ *:[v2i32] } 698:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMULHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 191107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32),
     /* 191110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191114 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191116 */     GIR_RootConstrainSelectedInstOperands,
     /* 191117 */     // GIR_Coverage, 1429,
     /* 191117 */     GIR_EraseRootFromParent_Done,
     /* 191118 */   // Label 3542: @191118
     /* 191118 */   GIM_Try, /*On fail goto*//*Label 3543*/ GIMT_Encode4(191163), // Rule ID 1430 //
     /* 191123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 191131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 191134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 191137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 191140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191152 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMULHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 191152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i32),
     /* 191155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191161 */     GIR_RootConstrainSelectedInstOperands,
     /* 191162 */     // GIR_Coverage, 1430,
     /* 191162 */     GIR_EraseRootFromParent_Done,
     /* 191163 */   // Label 3543: @191163
     /* 191163 */   GIM_Try, /*On fail goto*//*Label 3544*/ GIMT_Encode4(191208), // Rule ID 1431 //
     /* 191168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 191176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 191179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 191182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 191185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191197 */     // (intrinsic_wo_chain:{ *:[v8i8] } 701:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 191197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv8i8),
     /* 191200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191206 */     GIR_RootConstrainSelectedInstOperands,
     /* 191207 */     // GIR_Coverage, 1431,
     /* 191207 */     GIR_EraseRootFromParent_Done,
     /* 191208 */   // Label 3544: @191208
     /* 191208 */   GIM_Try, /*On fail goto*//*Label 3545*/ GIMT_Encode4(191253), // Rule ID 1432 //
     /* 191213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 191221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 191224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 191227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 191230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191242 */     // (intrinsic_wo_chain:{ *:[v16i8] } 701:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 191242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv16i8),
     /* 191245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191251 */     GIR_RootConstrainSelectedInstOperands,
     /* 191252 */     // GIR_Coverage, 1432,
     /* 191252 */     GIR_EraseRootFromParent_Done,
     /* 191253 */   // Label 3545: @191253
     /* 191253 */   GIM_Try, /*On fail goto*//*Label 3546*/ GIMT_Encode4(191298), // Rule ID 1433 //
     /* 191258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 191266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 191269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 191272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 191275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191287 */     // (intrinsic_wo_chain:{ *:[v4i16] } 701:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 191287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv4i16),
     /* 191290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191296 */     GIR_RootConstrainSelectedInstOperands,
     /* 191297 */     // GIR_Coverage, 1433,
     /* 191297 */     GIR_EraseRootFromParent_Done,
     /* 191298 */   // Label 3546: @191298
     /* 191298 */   GIM_Try, /*On fail goto*//*Label 3547*/ GIMT_Encode4(191343), // Rule ID 1434 //
     /* 191303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 191311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 191314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 191317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 191320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191332 */     // (intrinsic_wo_chain:{ *:[v8i16] } 701:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 191332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv8i16),
     /* 191335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191339 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191341 */     GIR_RootConstrainSelectedInstOperands,
     /* 191342 */     // GIR_Coverage, 1434,
     /* 191342 */     GIR_EraseRootFromParent_Done,
     /* 191343 */   // Label 3547: @191343
     /* 191343 */   GIM_Try, /*On fail goto*//*Label 3548*/ GIMT_Encode4(191388), // Rule ID 1435 //
     /* 191348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 191356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 191359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 191362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 191365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191377 */     // (intrinsic_wo_chain:{ *:[v2i32] } 701:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 191377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv2i32),
     /* 191380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191384 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191386 */     GIR_RootConstrainSelectedInstOperands,
     /* 191387 */     // GIR_Coverage, 1435,
     /* 191387 */     GIR_EraseRootFromParent_Done,
     /* 191388 */   // Label 3548: @191388
     /* 191388 */   GIM_Try, /*On fail goto*//*Label 3549*/ GIMT_Encode4(191433), // Rule ID 1436 //
     /* 191393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 191401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 191404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 191407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 191410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191422 */     // (intrinsic_wo_chain:{ *:[v4i32] } 701:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 191422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv4i32),
     /* 191425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191431 */     GIR_RootConstrainSelectedInstOperands,
     /* 191432 */     // GIR_Coverage, 1436,
     /* 191432 */     GIR_EraseRootFromParent_Done,
     /* 191433 */   // Label 3549: @191433
     /* 191433 */   GIM_Try, /*On fail goto*//*Label 3550*/ GIMT_Encode4(191478), // Rule ID 1437 //
     /* 191438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 191446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 191449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 191452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 191455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191467 */     // (intrinsic_wo_chain:{ *:[v2i64] } 701:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 191467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv2i64),
     /* 191470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191476 */     GIR_RootConstrainSelectedInstOperands,
     /* 191477 */     // GIR_Coverage, 1437,
     /* 191477 */     GIR_EraseRootFromParent_Done,
     /* 191478 */   // Label 3550: @191478
     /* 191478 */   GIM_Try, /*On fail goto*//*Label 3551*/ GIMT_Encode4(191523), // Rule ID 1438 //
     /* 191483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 191491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 191494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 191497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 191500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191512 */     // (intrinsic_wo_chain:{ *:[v8i8] } 704:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 191512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv8i8),
     /* 191515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191519 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191521 */     GIR_RootConstrainSelectedInstOperands,
     /* 191522 */     // GIR_Coverage, 1438,
     /* 191522 */     GIR_EraseRootFromParent_Done,
     /* 191523 */   // Label 3551: @191523
     /* 191523 */   GIM_Try, /*On fail goto*//*Label 3552*/ GIMT_Encode4(191568), // Rule ID 1439 //
     /* 191528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 191536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 191539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 191542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 191545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191557 */     // (intrinsic_wo_chain:{ *:[v16i8] } 704:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 191557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv16i8),
     /* 191560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191566 */     GIR_RootConstrainSelectedInstOperands,
     /* 191567 */     // GIR_Coverage, 1439,
     /* 191567 */     GIR_EraseRootFromParent_Done,
     /* 191568 */   // Label 3552: @191568
     /* 191568 */   GIM_Try, /*On fail goto*//*Label 3553*/ GIMT_Encode4(191613), // Rule ID 1440 //
     /* 191573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 191581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 191584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 191587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 191590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191602 */     // (intrinsic_wo_chain:{ *:[v4i16] } 704:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 191602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv4i16),
     /* 191605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191609 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191611 */     GIR_RootConstrainSelectedInstOperands,
     /* 191612 */     // GIR_Coverage, 1440,
     /* 191612 */     GIR_EraseRootFromParent_Done,
     /* 191613 */   // Label 3553: @191613
     /* 191613 */   GIM_Try, /*On fail goto*//*Label 3554*/ GIMT_Encode4(191658), // Rule ID 1441 //
     /* 191618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 191626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 191629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 191632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 191635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191647 */     // (intrinsic_wo_chain:{ *:[v8i16] } 704:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 191647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv8i16),
     /* 191650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191656 */     GIR_RootConstrainSelectedInstOperands,
     /* 191657 */     // GIR_Coverage, 1441,
     /* 191657 */     GIR_EraseRootFromParent_Done,
     /* 191658 */   // Label 3554: @191658
     /* 191658 */   GIM_Try, /*On fail goto*//*Label 3555*/ GIMT_Encode4(191703), // Rule ID 1442 //
     /* 191663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 191671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 191674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 191677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 191680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191692 */     // (intrinsic_wo_chain:{ *:[v2i32] } 704:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 191692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv2i32),
     /* 191695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191701 */     GIR_RootConstrainSelectedInstOperands,
     /* 191702 */     // GIR_Coverage, 1442,
     /* 191702 */     GIR_EraseRootFromParent_Done,
     /* 191703 */   // Label 3555: @191703
     /* 191703 */   GIM_Try, /*On fail goto*//*Label 3556*/ GIMT_Encode4(191748), // Rule ID 1443 //
     /* 191708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 191716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 191719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 191722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 191725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191737 */     // (intrinsic_wo_chain:{ *:[v4i32] } 704:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 191737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv4i32),
     /* 191740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191746 */     GIR_RootConstrainSelectedInstOperands,
     /* 191747 */     // GIR_Coverage, 1443,
     /* 191747 */     GIR_EraseRootFromParent_Done,
     /* 191748 */   // Label 3556: @191748
     /* 191748 */   GIM_Try, /*On fail goto*//*Label 3557*/ GIMT_Encode4(191793), // Rule ID 1444 //
     /* 191753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 191761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 191764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 191767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 191770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191782 */     // (intrinsic_wo_chain:{ *:[v2i64] } 704:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 191782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv2i64),
     /* 191785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191791 */     GIR_RootConstrainSelectedInstOperands,
     /* 191792 */     // GIR_Coverage, 1444,
     /* 191792 */     GIR_EraseRootFromParent_Done,
     /* 191793 */   // Label 3557: @191793
     /* 191793 */   GIM_Try, /*On fail goto*//*Label 3558*/ GIMT_Encode4(191838), // Rule ID 1458 //
     /* 191798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 191806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 191809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 191812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 191815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191827 */     // (intrinsic_wo_chain:{ *:[v8i8] } 712:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 191827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv8i8),
     /* 191830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191836 */     GIR_RootConstrainSelectedInstOperands,
     /* 191837 */     // GIR_Coverage, 1458,
     /* 191837 */     GIR_EraseRootFromParent_Done,
     /* 191838 */   // Label 3558: @191838
     /* 191838 */   GIM_Try, /*On fail goto*//*Label 3559*/ GIMT_Encode4(191883), // Rule ID 1459 //
     /* 191843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 191851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 191854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 191857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 191860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191872 */     // (intrinsic_wo_chain:{ *:[v16i8] } 712:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 191872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv16i8),
     /* 191875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191881 */     GIR_RootConstrainSelectedInstOperands,
     /* 191882 */     // GIR_Coverage, 1459,
     /* 191882 */     GIR_EraseRootFromParent_Done,
     /* 191883 */   // Label 3559: @191883
     /* 191883 */   GIM_Try, /*On fail goto*//*Label 3560*/ GIMT_Encode4(191928), // Rule ID 1460 //
     /* 191888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 191896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 191899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 191902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 191905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191917 */     // (intrinsic_wo_chain:{ *:[v4i16] } 712:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 191917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv4i16),
     /* 191920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191926 */     GIR_RootConstrainSelectedInstOperands,
     /* 191927 */     // GIR_Coverage, 1460,
     /* 191927 */     GIR_EraseRootFromParent_Done,
     /* 191928 */   // Label 3560: @191928
     /* 191928 */   GIM_Try, /*On fail goto*//*Label 3561*/ GIMT_Encode4(191973), // Rule ID 1461 //
     /* 191933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 191941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 191944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 191947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 191950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191962 */     // (intrinsic_wo_chain:{ *:[v8i16] } 712:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 191962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv8i16),
     /* 191965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191971 */     GIR_RootConstrainSelectedInstOperands,
     /* 191972 */     // GIR_Coverage, 1461,
     /* 191972 */     GIR_EraseRootFromParent_Done,
     /* 191973 */   // Label 3561: @191973
     /* 191973 */   GIM_Try, /*On fail goto*//*Label 3562*/ GIMT_Encode4(192018), // Rule ID 1462 //
     /* 191978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 191986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 191989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 191992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 191995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192007 */     // (intrinsic_wo_chain:{ *:[v2i32] } 712:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 192007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv2i32),
     /* 192010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192014 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192016 */     GIR_RootConstrainSelectedInstOperands,
     /* 192017 */     // GIR_Coverage, 1462,
     /* 192017 */     GIR_EraseRootFromParent_Done,
     /* 192018 */   // Label 3562: @192018
     /* 192018 */   GIM_Try, /*On fail goto*//*Label 3563*/ GIMT_Encode4(192063), // Rule ID 1463 //
     /* 192023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 192031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 192034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 192037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 192040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192052 */     // (intrinsic_wo_chain:{ *:[v4i32] } 712:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 192052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv4i32),
     /* 192055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192059 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192061 */     GIR_RootConstrainSelectedInstOperands,
     /* 192062 */     // GIR_Coverage, 1463,
     /* 192062 */     GIR_EraseRootFromParent_Done,
     /* 192063 */   // Label 3563: @192063
     /* 192063 */   GIM_Try, /*On fail goto*//*Label 3564*/ GIMT_Encode4(192108), // Rule ID 1464 //
     /* 192068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 192076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 192079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 192082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 192085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192097 */     // (intrinsic_wo_chain:{ *:[v2i64] } 712:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 192097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv2i64),
     /* 192100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192106 */     GIR_RootConstrainSelectedInstOperands,
     /* 192107 */     // GIR_Coverage, 1464,
     /* 192107 */     GIR_EraseRootFromParent_Done,
     /* 192108 */   // Label 3564: @192108
     /* 192108 */   GIM_Try, /*On fail goto*//*Label 3565*/ GIMT_Encode4(192153), // Rule ID 1465 //
     /* 192113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 192121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 192124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 192127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 192130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192142 */     // (intrinsic_wo_chain:{ *:[v8i8] } 713:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 192142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv8i8),
     /* 192145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192149 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192151 */     GIR_RootConstrainSelectedInstOperands,
     /* 192152 */     // GIR_Coverage, 1465,
     /* 192152 */     GIR_EraseRootFromParent_Done,
     /* 192153 */   // Label 3565: @192153
     /* 192153 */   GIM_Try, /*On fail goto*//*Label 3566*/ GIMT_Encode4(192198), // Rule ID 1466 //
     /* 192158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 192166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 192169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 192172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 192175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192187 */     // (intrinsic_wo_chain:{ *:[v16i8] } 713:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 192187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv16i8),
     /* 192190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192194 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192196 */     GIR_RootConstrainSelectedInstOperands,
     /* 192197 */     // GIR_Coverage, 1466,
     /* 192197 */     GIR_EraseRootFromParent_Done,
     /* 192198 */   // Label 3566: @192198
     /* 192198 */   GIM_Try, /*On fail goto*//*Label 3567*/ GIMT_Encode4(192243), // Rule ID 1467 //
     /* 192203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 192211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 192214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 192217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 192220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192232 */     // (intrinsic_wo_chain:{ *:[v4i16] } 713:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 192232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv4i16),
     /* 192235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192239 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192241 */     GIR_RootConstrainSelectedInstOperands,
     /* 192242 */     // GIR_Coverage, 1467,
     /* 192242 */     GIR_EraseRootFromParent_Done,
     /* 192243 */   // Label 3567: @192243
     /* 192243 */   GIM_Try, /*On fail goto*//*Label 3568*/ GIMT_Encode4(192288), // Rule ID 1468 //
     /* 192248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 192256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 192259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 192262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 192265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192277 */     // (intrinsic_wo_chain:{ *:[v8i16] } 713:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 192277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv8i16),
     /* 192280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192284 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192286 */     GIR_RootConstrainSelectedInstOperands,
     /* 192287 */     // GIR_Coverage, 1468,
     /* 192287 */     GIR_EraseRootFromParent_Done,
     /* 192288 */   // Label 3568: @192288
     /* 192288 */   GIM_Try, /*On fail goto*//*Label 3569*/ GIMT_Encode4(192333), // Rule ID 1469 //
     /* 192293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 192301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 192304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 192307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 192310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192322 */     // (intrinsic_wo_chain:{ *:[v2i32] } 713:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 192322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv2i32),
     /* 192325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192331 */     GIR_RootConstrainSelectedInstOperands,
     /* 192332 */     // GIR_Coverage, 1469,
     /* 192332 */     GIR_EraseRootFromParent_Done,
     /* 192333 */   // Label 3569: @192333
     /* 192333 */   GIM_Try, /*On fail goto*//*Label 3570*/ GIMT_Encode4(192378), // Rule ID 1470 //
     /* 192338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 192346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 192349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 192352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 192355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192367 */     // (intrinsic_wo_chain:{ *:[v4i32] } 713:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 192367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv4i32),
     /* 192370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192374 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192376 */     GIR_RootConstrainSelectedInstOperands,
     /* 192377 */     // GIR_Coverage, 1470,
     /* 192377 */     GIR_EraseRootFromParent_Done,
     /* 192378 */   // Label 3570: @192378
     /* 192378 */   GIM_Try, /*On fail goto*//*Label 3571*/ GIMT_Encode4(192423), // Rule ID 1471 //
     /* 192383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 192391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 192394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 192397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 192400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192412 */     // (intrinsic_wo_chain:{ *:[v2i64] } 713:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 192412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv2i64),
     /* 192415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192421 */     GIR_RootConstrainSelectedInstOperands,
     /* 192422 */     // GIR_Coverage, 1471,
     /* 192422 */     GIR_EraseRootFromParent_Done,
     /* 192423 */   // Label 3571: @192423
     /* 192423 */   GIM_Try, /*On fail goto*//*Label 3572*/ GIMT_Encode4(192468), // Rule ID 1492 //
     /* 192428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 192436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 192439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 192442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 192445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192457 */     // (intrinsic_wo_chain:{ *:[v8i8] } 734:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UABDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 192457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv8i8),
     /* 192460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192466 */     GIR_RootConstrainSelectedInstOperands,
     /* 192467 */     // GIR_Coverage, 1492,
     /* 192467 */     GIR_EraseRootFromParent_Done,
     /* 192468 */   // Label 3572: @192468
     /* 192468 */   GIM_Try, /*On fail goto*//*Label 3573*/ GIMT_Encode4(192513), // Rule ID 1494 //
     /* 192473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 192481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 192484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 192487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 192490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192502 */     // (intrinsic_wo_chain:{ *:[v16i8] } 734:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UABDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 192502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv16i8),
     /* 192505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192511 */     GIR_RootConstrainSelectedInstOperands,
     /* 192512 */     // GIR_Coverage, 1494,
     /* 192512 */     GIR_EraseRootFromParent_Done,
     /* 192513 */   // Label 3573: @192513
     /* 192513 */   GIM_Try, /*On fail goto*//*Label 3574*/ GIMT_Encode4(192558), // Rule ID 1496 //
     /* 192518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 192526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 192529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 192532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 192535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192547 */     // (intrinsic_wo_chain:{ *:[v4i16] } 734:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UABDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 192547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv4i16),
     /* 192550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192556 */     GIR_RootConstrainSelectedInstOperands,
     /* 192557 */     // GIR_Coverage, 1496,
     /* 192557 */     GIR_EraseRootFromParent_Done,
     /* 192558 */   // Label 3574: @192558
     /* 192558 */   GIM_Try, /*On fail goto*//*Label 3575*/ GIMT_Encode4(192603), // Rule ID 1498 //
     /* 192563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 192571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 192574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 192577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 192580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192592 */     // (intrinsic_wo_chain:{ *:[v8i16] } 734:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UABDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 192592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv8i16),
     /* 192595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192599 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192601 */     GIR_RootConstrainSelectedInstOperands,
     /* 192602 */     // GIR_Coverage, 1498,
     /* 192602 */     GIR_EraseRootFromParent_Done,
     /* 192603 */   // Label 3575: @192603
     /* 192603 */   GIM_Try, /*On fail goto*//*Label 3576*/ GIMT_Encode4(192648), // Rule ID 1500 //
     /* 192608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 192616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 192619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 192622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 192625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192637 */     // (intrinsic_wo_chain:{ *:[v2i32] } 734:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UABDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 192637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv2i32),
     /* 192640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192644 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192646 */     GIR_RootConstrainSelectedInstOperands,
     /* 192647 */     // GIR_Coverage, 1500,
     /* 192647 */     GIR_EraseRootFromParent_Done,
     /* 192648 */   // Label 3576: @192648
     /* 192648 */   GIM_Try, /*On fail goto*//*Label 3577*/ GIMT_Encode4(192693), // Rule ID 1502 //
     /* 192653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 192661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 192664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 192667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 192670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192682 */     // (intrinsic_wo_chain:{ *:[v4i32] } 734:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UABDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 192682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv4i32),
     /* 192685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192689 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192691 */     GIR_RootConstrainSelectedInstOperands,
     /* 192692 */     // GIR_Coverage, 1502,
     /* 192692 */     GIR_EraseRootFromParent_Done,
     /* 192693 */   // Label 3577: @192693
     /* 192693 */   GIM_Try, /*On fail goto*//*Label 3578*/ GIMT_Encode4(192738), // Rule ID 1509 //
     /* 192698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 192706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 192709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 192712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 192715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192727 */     // (intrinsic_wo_chain:{ *:[v8i8] } 740:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UHSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 192727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv8i8),
     /* 192730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192736 */     GIR_RootConstrainSelectedInstOperands,
     /* 192737 */     // GIR_Coverage, 1509,
     /* 192737 */     GIR_EraseRootFromParent_Done,
     /* 192738 */   // Label 3578: @192738
     /* 192738 */   GIM_Try, /*On fail goto*//*Label 3579*/ GIMT_Encode4(192783), // Rule ID 1510 //
     /* 192743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 192751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 192754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 192757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 192760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192772 */     // (intrinsic_wo_chain:{ *:[v16i8] } 740:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UHSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 192772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv16i8),
     /* 192775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192779 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192781 */     GIR_RootConstrainSelectedInstOperands,
     /* 192782 */     // GIR_Coverage, 1510,
     /* 192782 */     GIR_EraseRootFromParent_Done,
     /* 192783 */   // Label 3579: @192783
     /* 192783 */   GIM_Try, /*On fail goto*//*Label 3580*/ GIMT_Encode4(192828), // Rule ID 1511 //
     /* 192788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 192796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 192799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 192802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 192805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192817 */     // (intrinsic_wo_chain:{ *:[v4i16] } 740:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UHSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 192817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv4i16),
     /* 192820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192826 */     GIR_RootConstrainSelectedInstOperands,
     /* 192827 */     // GIR_Coverage, 1511,
     /* 192827 */     GIR_EraseRootFromParent_Done,
     /* 192828 */   // Label 3580: @192828
     /* 192828 */   GIM_Try, /*On fail goto*//*Label 3581*/ GIMT_Encode4(192873), // Rule ID 1512 //
     /* 192833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 192841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 192844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 192847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 192850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192862 */     // (intrinsic_wo_chain:{ *:[v8i16] } 740:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UHSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 192862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv8i16),
     /* 192865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192869 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192871 */     GIR_RootConstrainSelectedInstOperands,
     /* 192872 */     // GIR_Coverage, 1512,
     /* 192872 */     GIR_EraseRootFromParent_Done,
     /* 192873 */   // Label 3581: @192873
     /* 192873 */   GIM_Try, /*On fail goto*//*Label 3582*/ GIMT_Encode4(192918), // Rule ID 1513 //
     /* 192878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 192886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 192889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 192892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 192895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192907 */     // (intrinsic_wo_chain:{ *:[v2i32] } 740:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UHSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 192907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv2i32),
     /* 192910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192916 */     GIR_RootConstrainSelectedInstOperands,
     /* 192917 */     // GIR_Coverage, 1513,
     /* 192917 */     GIR_EraseRootFromParent_Done,
     /* 192918 */   // Label 3582: @192918
     /* 192918 */   GIM_Try, /*On fail goto*//*Label 3583*/ GIMT_Encode4(192963), // Rule ID 1514 //
     /* 192923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 192931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 192934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 192937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 192940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192952 */     // (intrinsic_wo_chain:{ *:[v4i32] } 740:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UHSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 192952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv4i32),
     /* 192955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192959 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192961 */     GIR_RootConstrainSelectedInstOperands,
     /* 192962 */     // GIR_Coverage, 1514,
     /* 192962 */     GIR_EraseRootFromParent_Done,
     /* 192963 */   // Label 3583: @192963
     /* 192963 */   GIM_Try, /*On fail goto*//*Label 3584*/ GIMT_Encode4(193008), // Rule ID 1515 //
     /* 192968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 192976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 192979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 192982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 192985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192997 */     // (intrinsic_wo_chain:{ *:[v8i8] } 742:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMAXPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 192997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv8i8),
     /* 193000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193006 */     GIR_RootConstrainSelectedInstOperands,
     /* 193007 */     // GIR_Coverage, 1515,
     /* 193007 */     GIR_EraseRootFromParent_Done,
     /* 193008 */   // Label 3584: @193008
     /* 193008 */   GIM_Try, /*On fail goto*//*Label 3585*/ GIMT_Encode4(193053), // Rule ID 1516 //
     /* 193013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 193021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 193024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 193027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 193030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193042 */     // (intrinsic_wo_chain:{ *:[v16i8] } 742:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMAXPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 193042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv16i8),
     /* 193045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193049 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193051 */     GIR_RootConstrainSelectedInstOperands,
     /* 193052 */     // GIR_Coverage, 1516,
     /* 193052 */     GIR_EraseRootFromParent_Done,
     /* 193053 */   // Label 3585: @193053
     /* 193053 */   GIM_Try, /*On fail goto*//*Label 3586*/ GIMT_Encode4(193098), // Rule ID 1517 //
     /* 193058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 193066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 193069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 193072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 193075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193087 */     // (intrinsic_wo_chain:{ *:[v4i16] } 742:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMAXPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 193087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv4i16),
     /* 193090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193096 */     GIR_RootConstrainSelectedInstOperands,
     /* 193097 */     // GIR_Coverage, 1517,
     /* 193097 */     GIR_EraseRootFromParent_Done,
     /* 193098 */   // Label 3586: @193098
     /* 193098 */   GIM_Try, /*On fail goto*//*Label 3587*/ GIMT_Encode4(193143), // Rule ID 1518 //
     /* 193103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 193111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 193114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 193117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 193120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193132 */     // (intrinsic_wo_chain:{ *:[v8i16] } 742:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMAXPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 193132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv8i16),
     /* 193135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193141 */     GIR_RootConstrainSelectedInstOperands,
     /* 193142 */     // GIR_Coverage, 1518,
     /* 193142 */     GIR_EraseRootFromParent_Done,
     /* 193143 */   // Label 3587: @193143
     /* 193143 */   GIM_Try, /*On fail goto*//*Label 3588*/ GIMT_Encode4(193188), // Rule ID 1519 //
     /* 193148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 193156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 193159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 193162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 193165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193177 */     // (intrinsic_wo_chain:{ *:[v2i32] } 742:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMAXPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 193177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 193180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193186 */     GIR_RootConstrainSelectedInstOperands,
     /* 193187 */     // GIR_Coverage, 1519,
     /* 193187 */     GIR_EraseRootFromParent_Done,
     /* 193188 */   // Label 3588: @193188
     /* 193188 */   GIM_Try, /*On fail goto*//*Label 3589*/ GIMT_Encode4(193233), // Rule ID 1520 //
     /* 193193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 193201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 193204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 193207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 193210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193222 */     // (intrinsic_wo_chain:{ *:[v4i32] } 742:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMAXPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 193222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv4i32),
     /* 193225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193231 */     GIR_RootConstrainSelectedInstOperands,
     /* 193232 */     // GIR_Coverage, 1520,
     /* 193232 */     GIR_EraseRootFromParent_Done,
     /* 193233 */   // Label 3589: @193233
     /* 193233 */   GIM_Try, /*On fail goto*//*Label 3590*/ GIMT_Encode4(193278), // Rule ID 1527 //
     /* 193238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 193246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 193249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 193252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 193255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193267 */     // (intrinsic_wo_chain:{ *:[v8i8] } 745:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMINPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 193267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv8i8),
     /* 193270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193274 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193276 */     GIR_RootConstrainSelectedInstOperands,
     /* 193277 */     // GIR_Coverage, 1527,
     /* 193277 */     GIR_EraseRootFromParent_Done,
     /* 193278 */   // Label 3590: @193278
     /* 193278 */   GIM_Try, /*On fail goto*//*Label 3591*/ GIMT_Encode4(193323), // Rule ID 1528 //
     /* 193283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 193291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 193294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 193297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 193300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193312 */     // (intrinsic_wo_chain:{ *:[v16i8] } 745:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMINPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 193312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv16i8),
     /* 193315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193319 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193321 */     GIR_RootConstrainSelectedInstOperands,
     /* 193322 */     // GIR_Coverage, 1528,
     /* 193322 */     GIR_EraseRootFromParent_Done,
     /* 193323 */   // Label 3591: @193323
     /* 193323 */   GIM_Try, /*On fail goto*//*Label 3592*/ GIMT_Encode4(193368), // Rule ID 1529 //
     /* 193328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 193336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 193339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 193342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 193345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193357 */     // (intrinsic_wo_chain:{ *:[v4i16] } 745:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMINPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 193357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv4i16),
     /* 193360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193366 */     GIR_RootConstrainSelectedInstOperands,
     /* 193367 */     // GIR_Coverage, 1529,
     /* 193367 */     GIR_EraseRootFromParent_Done,
     /* 193368 */   // Label 3592: @193368
     /* 193368 */   GIM_Try, /*On fail goto*//*Label 3593*/ GIMT_Encode4(193413), // Rule ID 1530 //
     /* 193373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 193381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 193384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 193387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 193390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193402 */     // (intrinsic_wo_chain:{ *:[v8i16] } 745:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMINPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 193402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv8i16),
     /* 193405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193411 */     GIR_RootConstrainSelectedInstOperands,
     /* 193412 */     // GIR_Coverage, 1530,
     /* 193412 */     GIR_EraseRootFromParent_Done,
     /* 193413 */   // Label 3593: @193413
     /* 193413 */   GIM_Try, /*On fail goto*//*Label 3594*/ GIMT_Encode4(193458), // Rule ID 1531 //
     /* 193418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 193426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 193429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 193432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 193435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193447 */     // (intrinsic_wo_chain:{ *:[v2i32] } 745:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMINPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 193447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 193450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193454 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193456 */     GIR_RootConstrainSelectedInstOperands,
     /* 193457 */     // GIR_Coverage, 1531,
     /* 193457 */     GIR_EraseRootFromParent_Done,
     /* 193458 */   // Label 3594: @193458
     /* 193458 */   GIM_Try, /*On fail goto*//*Label 3595*/ GIMT_Encode4(193503), // Rule ID 1532 //
     /* 193463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 193471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 193474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 193477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 193480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193492 */     // (intrinsic_wo_chain:{ *:[v4i32] } 745:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMINPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 193492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv4i32),
     /* 193495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193499 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193501 */     GIR_RootConstrainSelectedInstOperands,
     /* 193502 */     // GIR_Coverage, 1532,
     /* 193502 */     GIR_EraseRootFromParent_Done,
     /* 193503 */   // Label 3595: @193503
     /* 193503 */   GIM_Try, /*On fail goto*//*Label 3596*/ GIMT_Encode4(193548), // Rule ID 1546 //
     /* 193508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 193516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 193519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 193522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 193525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193537 */     // (intrinsic_wo_chain:{ *:[v8i8] } 750:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 193537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv8i8),
     /* 193540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193546 */     GIR_RootConstrainSelectedInstOperands,
     /* 193547 */     // GIR_Coverage, 1546,
     /* 193547 */     GIR_EraseRootFromParent_Done,
     /* 193548 */   // Label 3596: @193548
     /* 193548 */   GIM_Try, /*On fail goto*//*Label 3597*/ GIMT_Encode4(193593), // Rule ID 1547 //
     /* 193553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 193561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 193564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 193567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 193570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193582 */     // (intrinsic_wo_chain:{ *:[v16i8] } 750:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 193582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv16i8),
     /* 193585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193591 */     GIR_RootConstrainSelectedInstOperands,
     /* 193592 */     // GIR_Coverage, 1547,
     /* 193592 */     GIR_EraseRootFromParent_Done,
     /* 193593 */   // Label 3597: @193593
     /* 193593 */   GIM_Try, /*On fail goto*//*Label 3598*/ GIMT_Encode4(193638), // Rule ID 1548 //
     /* 193598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 193606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 193609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 193612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 193615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193627 */     // (intrinsic_wo_chain:{ *:[v4i16] } 750:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 193627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv4i16),
     /* 193630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193636 */     GIR_RootConstrainSelectedInstOperands,
     /* 193637 */     // GIR_Coverage, 1548,
     /* 193637 */     GIR_EraseRootFromParent_Done,
     /* 193638 */   // Label 3598: @193638
     /* 193638 */   GIM_Try, /*On fail goto*//*Label 3599*/ GIMT_Encode4(193683), // Rule ID 1549 //
     /* 193643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 193651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 193654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 193657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 193660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193672 */     // (intrinsic_wo_chain:{ *:[v8i16] } 750:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 193672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv8i16),
     /* 193675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193679 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193681 */     GIR_RootConstrainSelectedInstOperands,
     /* 193682 */     // GIR_Coverage, 1549,
     /* 193682 */     GIR_EraseRootFromParent_Done,
     /* 193683 */   // Label 3599: @193683
     /* 193683 */   GIM_Try, /*On fail goto*//*Label 3600*/ GIMT_Encode4(193728), // Rule ID 1550 //
     /* 193688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 193696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 193699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 193702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 193705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193717 */     // (intrinsic_wo_chain:{ *:[v2i32] } 750:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 193717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv2i32),
     /* 193720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193726 */     GIR_RootConstrainSelectedInstOperands,
     /* 193727 */     // GIR_Coverage, 1550,
     /* 193727 */     GIR_EraseRootFromParent_Done,
     /* 193728 */   // Label 3600: @193728
     /* 193728 */   GIM_Try, /*On fail goto*//*Label 3601*/ GIMT_Encode4(193773), // Rule ID 1551 //
     /* 193733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 193741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 193744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 193747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 193750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193762 */     // (intrinsic_wo_chain:{ *:[v4i32] } 750:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 193762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv4i32),
     /* 193765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193771 */     GIR_RootConstrainSelectedInstOperands,
     /* 193772 */     // GIR_Coverage, 1551,
     /* 193772 */     GIR_EraseRootFromParent_Done,
     /* 193773 */   // Label 3601: @193773
     /* 193773 */   GIM_Try, /*On fail goto*//*Label 3602*/ GIMT_Encode4(193818), // Rule ID 1552 //
     /* 193778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 193786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 193789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 193792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 193795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193807 */     // (intrinsic_wo_chain:{ *:[v2i64] } 750:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 193807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv2i64),
     /* 193810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193816 */     GIR_RootConstrainSelectedInstOperands,
     /* 193817 */     // GIR_Coverage, 1552,
     /* 193817 */     GIR_EraseRootFromParent_Done,
     /* 193818 */   // Label 3602: @193818
     /* 193818 */   GIM_Try, /*On fail goto*//*Label 3603*/ GIMT_Encode4(193863), // Rule ID 1553 //
     /* 193823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 193831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 193834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 193837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 193840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193852 */     // (intrinsic_wo_chain:{ *:[v8i8] } 752:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 193852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv8i8),
     /* 193855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193861 */     GIR_RootConstrainSelectedInstOperands,
     /* 193862 */     // GIR_Coverage, 1553,
     /* 193862 */     GIR_EraseRootFromParent_Done,
     /* 193863 */   // Label 3603: @193863
     /* 193863 */   GIM_Try, /*On fail goto*//*Label 3604*/ GIMT_Encode4(193908), // Rule ID 1554 //
     /* 193868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 193876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 193879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 193882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 193885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193897 */     // (intrinsic_wo_chain:{ *:[v16i8] } 752:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 193897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv16i8),
     /* 193900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193904 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193906 */     GIR_RootConstrainSelectedInstOperands,
     /* 193907 */     // GIR_Coverage, 1554,
     /* 193907 */     GIR_EraseRootFromParent_Done,
     /* 193908 */   // Label 3604: @193908
     /* 193908 */   GIM_Try, /*On fail goto*//*Label 3605*/ GIMT_Encode4(193953), // Rule ID 1555 //
     /* 193913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 193921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 193924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 193927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 193930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193942 */     // (intrinsic_wo_chain:{ *:[v4i16] } 752:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 193942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv4i16),
     /* 193945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193951 */     GIR_RootConstrainSelectedInstOperands,
     /* 193952 */     // GIR_Coverage, 1555,
     /* 193952 */     GIR_EraseRootFromParent_Done,
     /* 193953 */   // Label 3605: @193953
     /* 193953 */   GIM_Try, /*On fail goto*//*Label 3606*/ GIMT_Encode4(193998), // Rule ID 1556 //
     /* 193958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 193966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 193969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 193972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 193975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193987 */     // (intrinsic_wo_chain:{ *:[v8i16] } 752:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 193987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv8i16),
     /* 193990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193996 */     GIR_RootConstrainSelectedInstOperands,
     /* 193997 */     // GIR_Coverage, 1556,
     /* 193997 */     GIR_EraseRootFromParent_Done,
     /* 193998 */   // Label 3606: @193998
     /* 193998 */   GIM_Try, /*On fail goto*//*Label 3607*/ GIMT_Encode4(194043), // Rule ID 1557 //
     /* 194003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 194011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 194014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 194017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 194020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194032 */     // (intrinsic_wo_chain:{ *:[v2i32] } 752:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 194032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv2i32),
     /* 194035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194041 */     GIR_RootConstrainSelectedInstOperands,
     /* 194042 */     // GIR_Coverage, 1557,
     /* 194042 */     GIR_EraseRootFromParent_Done,
     /* 194043 */   // Label 3607: @194043
     /* 194043 */   GIM_Try, /*On fail goto*//*Label 3608*/ GIMT_Encode4(194088), // Rule ID 1558 //
     /* 194048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 194056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 194059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 194062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 194065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194077 */     // (intrinsic_wo_chain:{ *:[v4i32] } 752:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 194077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv4i32),
     /* 194080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194086 */     GIR_RootConstrainSelectedInstOperands,
     /* 194087 */     // GIR_Coverage, 1558,
     /* 194087 */     GIR_EraseRootFromParent_Done,
     /* 194088 */   // Label 3608: @194088
     /* 194088 */   GIM_Try, /*On fail goto*//*Label 3609*/ GIMT_Encode4(194133), // Rule ID 1559 //
     /* 194093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 194101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 194104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 194107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 194110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194122 */     // (intrinsic_wo_chain:{ *:[v2i64] } 752:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 194122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv2i64),
     /* 194125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194129 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194131 */     GIR_RootConstrainSelectedInstOperands,
     /* 194132 */     // GIR_Coverage, 1559,
     /* 194132 */     GIR_EraseRootFromParent_Done,
     /* 194133 */   // Label 3609: @194133
     /* 194133 */   GIM_Try, /*On fail goto*//*Label 3610*/ GIMT_Encode4(194178), // Rule ID 1573 //
     /* 194138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 194146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 194149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 194152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 194155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194167 */     // (intrinsic_wo_chain:{ *:[v8i8] } 758:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (URSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 194167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv8i8),
     /* 194170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194176 */     GIR_RootConstrainSelectedInstOperands,
     /* 194177 */     // GIR_Coverage, 1573,
     /* 194177 */     GIR_EraseRootFromParent_Done,
     /* 194178 */   // Label 3610: @194178
     /* 194178 */   GIM_Try, /*On fail goto*//*Label 3611*/ GIMT_Encode4(194223), // Rule ID 1574 //
     /* 194183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 194191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 194194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 194197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 194200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194212 */     // (intrinsic_wo_chain:{ *:[v16i8] } 758:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (URSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 194212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv16i8),
     /* 194215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194221 */     GIR_RootConstrainSelectedInstOperands,
     /* 194222 */     // GIR_Coverage, 1574,
     /* 194222 */     GIR_EraseRootFromParent_Done,
     /* 194223 */   // Label 3611: @194223
     /* 194223 */   GIM_Try, /*On fail goto*//*Label 3612*/ GIMT_Encode4(194268), // Rule ID 1575 //
     /* 194228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 194236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 194239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 194242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 194245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194257 */     // (intrinsic_wo_chain:{ *:[v4i16] } 758:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (URSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 194257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv4i16),
     /* 194260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194266 */     GIR_RootConstrainSelectedInstOperands,
     /* 194267 */     // GIR_Coverage, 1575,
     /* 194267 */     GIR_EraseRootFromParent_Done,
     /* 194268 */   // Label 3612: @194268
     /* 194268 */   GIM_Try, /*On fail goto*//*Label 3613*/ GIMT_Encode4(194313), // Rule ID 1576 //
     /* 194273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 194281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 194284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 194287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 194290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194302 */     // (intrinsic_wo_chain:{ *:[v8i16] } 758:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (URSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 194302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv8i16),
     /* 194305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194309 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194311 */     GIR_RootConstrainSelectedInstOperands,
     /* 194312 */     // GIR_Coverage, 1576,
     /* 194312 */     GIR_EraseRootFromParent_Done,
     /* 194313 */   // Label 3613: @194313
     /* 194313 */   GIM_Try, /*On fail goto*//*Label 3614*/ GIMT_Encode4(194358), // Rule ID 1577 //
     /* 194318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 194326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 194329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 194332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 194335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194347 */     // (intrinsic_wo_chain:{ *:[v2i32] } 758:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (URSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 194347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv2i32),
     /* 194350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194356 */     GIR_RootConstrainSelectedInstOperands,
     /* 194357 */     // GIR_Coverage, 1577,
     /* 194357 */     GIR_EraseRootFromParent_Done,
     /* 194358 */   // Label 3614: @194358
     /* 194358 */   GIM_Try, /*On fail goto*//*Label 3615*/ GIMT_Encode4(194403), // Rule ID 1578 //
     /* 194363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 194371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 194374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 194377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 194380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194392 */     // (intrinsic_wo_chain:{ *:[v4i32] } 758:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (URSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 194392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv4i32),
     /* 194395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194401 */     GIR_RootConstrainSelectedInstOperands,
     /* 194402 */     // GIR_Coverage, 1578,
     /* 194402 */     GIR_EraseRootFromParent_Done,
     /* 194403 */   // Label 3615: @194403
     /* 194403 */   GIM_Try, /*On fail goto*//*Label 3616*/ GIMT_Encode4(194448), // Rule ID 1579 //
     /* 194408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 194416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 194419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 194422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 194425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194437 */     // (intrinsic_wo_chain:{ *:[v2i64] } 758:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (URSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 194437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv2i64),
     /* 194440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194446 */     GIR_RootConstrainSelectedInstOperands,
     /* 194447 */     // GIR_Coverage, 1579,
     /* 194447 */     GIR_EraseRootFromParent_Done,
     /* 194448 */   // Label 3616: @194448
     /* 194448 */   GIM_Try, /*On fail goto*//*Label 3617*/ GIMT_Encode4(194493), // Rule ID 1580 //
     /* 194453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 194461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 194464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 194467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 194470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194482 */     // (intrinsic_wo_chain:{ *:[v8i8] } 761:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (USHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 194482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv8i8),
     /* 194485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194491 */     GIR_RootConstrainSelectedInstOperands,
     /* 194492 */     // GIR_Coverage, 1580,
     /* 194492 */     GIR_EraseRootFromParent_Done,
     /* 194493 */   // Label 3617: @194493
     /* 194493 */   GIM_Try, /*On fail goto*//*Label 3618*/ GIMT_Encode4(194538), // Rule ID 1581 //
     /* 194498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 194506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 194509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 194512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 194515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194527 */     // (intrinsic_wo_chain:{ *:[v16i8] } 761:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (USHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 194527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv16i8),
     /* 194530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194534 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194536 */     GIR_RootConstrainSelectedInstOperands,
     /* 194537 */     // GIR_Coverage, 1581,
     /* 194537 */     GIR_EraseRootFromParent_Done,
     /* 194538 */   // Label 3618: @194538
     /* 194538 */   GIM_Try, /*On fail goto*//*Label 3619*/ GIMT_Encode4(194583), // Rule ID 1582 //
     /* 194543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 194551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 194554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 194557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 194560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194572 */     // (intrinsic_wo_chain:{ *:[v4i16] } 761:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (USHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 194572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv4i16),
     /* 194575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194579 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194581 */     GIR_RootConstrainSelectedInstOperands,
     /* 194582 */     // GIR_Coverage, 1582,
     /* 194582 */     GIR_EraseRootFromParent_Done,
     /* 194583 */   // Label 3619: @194583
     /* 194583 */   GIM_Try, /*On fail goto*//*Label 3620*/ GIMT_Encode4(194628), // Rule ID 1583 //
     /* 194588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 194596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 194599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 194602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 194605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194617 */     // (intrinsic_wo_chain:{ *:[v8i16] } 761:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (USHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 194617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv8i16),
     /* 194620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194626 */     GIR_RootConstrainSelectedInstOperands,
     /* 194627 */     // GIR_Coverage, 1583,
     /* 194627 */     GIR_EraseRootFromParent_Done,
     /* 194628 */   // Label 3620: @194628
     /* 194628 */   GIM_Try, /*On fail goto*//*Label 3621*/ GIMT_Encode4(194673), // Rule ID 1584 //
     /* 194633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 194641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 194644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 194647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 194650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194662 */     // (intrinsic_wo_chain:{ *:[v2i32] } 761:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (USHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 194662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv2i32),
     /* 194665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194669 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194671 */     GIR_RootConstrainSelectedInstOperands,
     /* 194672 */     // GIR_Coverage, 1584,
     /* 194672 */     GIR_EraseRootFromParent_Done,
     /* 194673 */   // Label 3621: @194673
     /* 194673 */   GIM_Try, /*On fail goto*//*Label 3622*/ GIMT_Encode4(194718), // Rule ID 1585 //
     /* 194678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 194686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 194689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 194692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 194695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194707 */     // (intrinsic_wo_chain:{ *:[v4i32] } 761:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (USHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 194707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv4i32),
     /* 194710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194716 */     GIR_RootConstrainSelectedInstOperands,
     /* 194717 */     // GIR_Coverage, 1585,
     /* 194717 */     GIR_EraseRootFromParent_Done,
     /* 194718 */   // Label 3622: @194718
     /* 194718 */   GIM_Try, /*On fail goto*//*Label 3623*/ GIMT_Encode4(194763), // Rule ID 1586 //
     /* 194723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 194731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 194734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 194737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 194740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194752 */     // (intrinsic_wo_chain:{ *:[v2i64] } 761:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (USHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 194752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv2i64),
     /* 194755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194761 */     GIR_RootConstrainSelectedInstOperands,
     /* 194762 */     // GIR_Coverage, 1586,
     /* 194762 */     GIR_EraseRootFromParent_Done,
     /* 194763 */   // Label 3623: @194763
     /* 194763 */   GIM_Try, /*On fail goto*//*Label 3624*/ GIMT_Encode4(194808), // Rule ID 1614 //
     /* 194768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 194776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194797 */     // (intrinsic_wo_chain:{ *:[f64] } 795:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FABD64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 194797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 194800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194804 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194806 */     GIR_RootConstrainSelectedInstOperands,
     /* 194807 */     // GIR_Coverage, 1614,
     /* 194807 */     GIR_EraseRootFromParent_Done,
     /* 194808 */   // Label 3624: @194808
     /* 194808 */   GIM_Try, /*On fail goto*//*Label 3625*/ GIMT_Encode4(194853), // Rule ID 1615 //
     /* 194813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 194821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 194824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 194834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 194838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 194842 */     // (intrinsic_wo_chain:{ *:[f32] } 795:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FABD32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 194842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD32),
     /* 194845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194849 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194851 */     GIR_RootConstrainSelectedInstOperands,
     /* 194852 */     // GIR_Coverage, 1615,
     /* 194852 */     GIR_EraseRootFromParent_Done,
     /* 194853 */   // Label 3625: @194853
     /* 194853 */   GIM_Try, /*On fail goto*//*Label 3626*/ GIMT_Encode4(194898), // Rule ID 1616 //
     /* 194858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 194861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 194866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 194869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 194872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 194875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 194879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 194883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 194887 */     // (intrinsic_wo_chain:{ *:[f16] } 795:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FABD16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 194887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD16),
     /* 194890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194896 */     GIR_RootConstrainSelectedInstOperands,
     /* 194897 */     // GIR_Coverage, 1616,
     /* 194897 */     GIR_EraseRootFromParent_Done,
     /* 194898 */   // Label 3626: @194898
     /* 194898 */   GIM_Try, /*On fail goto*//*Label 3627*/ GIMT_Encode4(194943), // Rule ID 1617 //
     /* 194903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 194911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194932 */     // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FACGE64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 194932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE64),
     /* 194935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194941 */     GIR_RootConstrainSelectedInstOperands,
     /* 194942 */     // GIR_Coverage, 1617,
     /* 194942 */     GIR_EraseRootFromParent_Done,
     /* 194943 */   // Label 3627: @194943
     /* 194943 */   GIM_Try, /*On fail goto*//*Label 3628*/ GIMT_Encode4(194988), // Rule ID 1618 //
     /* 194948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 194956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 194959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 194969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 194973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 194977 */     // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FACGE32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 194977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE32),
     /* 194980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194984 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194986 */     GIR_RootConstrainSelectedInstOperands,
     /* 194987 */     // GIR_Coverage, 1618,
     /* 194987 */     GIR_EraseRootFromParent_Done,
     /* 194988 */   // Label 3628: @194988
     /* 194988 */   GIM_Try, /*On fail goto*//*Label 3629*/ GIMT_Encode4(195033), // Rule ID 1619 //
     /* 194993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 195001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195022 */     // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FACGT64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 195022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT64),
     /* 195025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195031 */     GIR_RootConstrainSelectedInstOperands,
     /* 195032 */     // GIR_Coverage, 1619,
     /* 195032 */     GIR_EraseRootFromParent_Done,
     /* 195033 */   // Label 3629: @195033
     /* 195033 */   GIM_Try, /*On fail goto*//*Label 3630*/ GIMT_Encode4(195078), // Rule ID 1620 //
     /* 195038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 195046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 195049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 195055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195067 */     // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FACGT32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 195067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT32),
     /* 195070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195076 */     GIR_RootConstrainSelectedInstOperands,
     /* 195077 */     // GIR_Coverage, 1620,
     /* 195077 */     GIR_EraseRootFromParent_Done,
     /* 195078 */   // Label 3630: @195078
     /* 195078 */   GIM_Try, /*On fail goto*//*Label 3631*/ GIMT_Encode4(195123), // Rule ID 1627 //
     /* 195083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 195086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 195091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195112 */     // (intrinsic_wo_chain:{ *:[f64] } 620:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 195112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 195115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195119 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195121 */     GIR_RootConstrainSelectedInstOperands,
     /* 195122 */     // GIR_Coverage, 1627,
     /* 195122 */     GIR_EraseRootFromParent_Done,
     /* 195123 */   // Label 3631: @195123
     /* 195123 */   GIM_Try, /*On fail goto*//*Label 3632*/ GIMT_Encode4(195168), // Rule ID 1628 //
     /* 195128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 195131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 195136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 195139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 195145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195157 */     // (intrinsic_wo_chain:{ *:[f32] } 620:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 195157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 195160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195164 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195166 */     GIR_RootConstrainSelectedInstOperands,
     /* 195167 */     // GIR_Coverage, 1628,
     /* 195167 */     GIR_EraseRootFromParent_Done,
     /* 195168 */   // Label 3632: @195168
     /* 195168 */   GIM_Try, /*On fail goto*//*Label 3633*/ GIMT_Encode4(195213), // Rule ID 1629 //
     /* 195173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 195176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 195181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 195184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 195187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 195190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 195194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 195198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 195202 */     // (intrinsic_wo_chain:{ *:[f16] } 620:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 195202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 195205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195211 */     GIR_RootConstrainSelectedInstOperands,
     /* 195212 */     // GIR_Coverage, 1629,
     /* 195212 */     GIR_EraseRootFromParent_Done,
     /* 195213 */   // Label 3633: @195213
     /* 195213 */   GIM_Try, /*On fail goto*//*Label 3634*/ GIMT_Encode4(195258), // Rule ID 1630 //
     /* 195218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 195221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 195226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195247 */     // (intrinsic_wo_chain:{ *:[f64] } 643:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FRECPS64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 195247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS64),
     /* 195250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195256 */     GIR_RootConstrainSelectedInstOperands,
     /* 195257 */     // GIR_Coverage, 1630,
     /* 195257 */     GIR_EraseRootFromParent_Done,
     /* 195258 */   // Label 3634: @195258
     /* 195258 */   GIM_Try, /*On fail goto*//*Label 3635*/ GIMT_Encode4(195303), // Rule ID 1631 //
     /* 195263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 195266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 195271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 195274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 195280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195292 */     // (intrinsic_wo_chain:{ *:[f32] } 643:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FRECPS32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 195292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS32),
     /* 195295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195301 */     GIR_RootConstrainSelectedInstOperands,
     /* 195302 */     // GIR_Coverage, 1631,
     /* 195302 */     GIR_EraseRootFromParent_Done,
     /* 195303 */   // Label 3635: @195303
     /* 195303 */   GIM_Try, /*On fail goto*//*Label 3636*/ GIMT_Encode4(195348), // Rule ID 1632 //
     /* 195308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 195311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 195316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 195319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 195322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 195325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 195329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 195333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 195337 */     // (intrinsic_wo_chain:{ *:[f16] } 643:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FRECPS16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 195337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS16),
     /* 195340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195346 */     GIR_RootConstrainSelectedInstOperands,
     /* 195347 */     // GIR_Coverage, 1632,
     /* 195347 */     GIR_EraseRootFromParent_Done,
     /* 195348 */   // Label 3636: @195348
     /* 195348 */   GIM_Try, /*On fail goto*//*Label 3637*/ GIMT_Encode4(195393), // Rule ID 1633 //
     /* 195353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 195356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 195361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195382 */     // (intrinsic_wo_chain:{ *:[f64] } 650:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FRSQRTS64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 195382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS64),
     /* 195385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195391 */     GIR_RootConstrainSelectedInstOperands,
     /* 195392 */     // GIR_Coverage, 1633,
     /* 195392 */     GIR_EraseRootFromParent_Done,
     /* 195393 */   // Label 3637: @195393
     /* 195393 */   GIM_Try, /*On fail goto*//*Label 3638*/ GIMT_Encode4(195438), // Rule ID 1634 //
     /* 195398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 195401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 195406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 195409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 195415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195427 */     // (intrinsic_wo_chain:{ *:[f32] } 650:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FRSQRTS32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 195427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS32),
     /* 195430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195436 */     GIR_RootConstrainSelectedInstOperands,
     /* 195437 */     // GIR_Coverage, 1634,
     /* 195437 */     GIR_EraseRootFromParent_Done,
     /* 195438 */   // Label 3638: @195438
     /* 195438 */   GIM_Try, /*On fail goto*//*Label 3639*/ GIMT_Encode4(195483), // Rule ID 1635 //
     /* 195443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 195446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 195451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 195454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 195457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 195460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 195464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 195468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 195472 */     // (intrinsic_wo_chain:{ *:[f16] } 650:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FRSQRTS16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 195472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS16),
     /* 195475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195481 */     GIR_RootConstrainSelectedInstOperands,
     /* 195482 */     // GIR_Coverage, 1635,
     /* 195482 */     GIR_EraseRootFromParent_Done,
     /* 195483 */   // Label 3639: @195483
     /* 195483 */   GIM_Try, /*On fail goto*//*Label 3640*/ GIMT_Encode4(195528), // Rule ID 1637 //
     /* 195488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 195496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 195499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 195505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195517 */     // (intrinsic_wo_chain:{ *:[i32] } 690:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQDMULHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 195517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv1i32),
     /* 195520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195526 */     GIR_RootConstrainSelectedInstOperands,
     /* 195527 */     // GIR_Coverage, 1637,
     /* 195527 */     GIR_EraseRootFromParent_Done,
     /* 195528 */   // Label 3640: @195528
     /* 195528 */   GIM_Try, /*On fail goto*//*Label 3641*/ GIMT_Encode4(195573), // Rule ID 1638 //
     /* 195533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 195541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 195544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 195550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195562 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMULHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 195562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv1i32),
     /* 195565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195571 */     GIR_RootConstrainSelectedInstOperands,
     /* 195572 */     // GIR_Coverage, 1638,
     /* 195572 */     GIR_EraseRootFromParent_Done,
     /* 195573 */   // Label 3641: @195573
     /* 195573 */   GIM_Try, /*On fail goto*//*Label 3642*/ GIMT_Encode4(195618), // Rule ID 1639 //
     /* 195578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 195586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195607 */     // (intrinsic_wo_chain:{ *:[v1i64] } 701:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 195607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i64),
     /* 195610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195614 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195616 */     GIR_RootConstrainSelectedInstOperands,
     /* 195617 */     // GIR_Coverage, 1639,
     /* 195617 */     GIR_EraseRootFromParent_Done,
     /* 195618 */   // Label 3642: @195618
     /* 195618 */   GIM_Try, /*On fail goto*//*Label 3643*/ GIMT_Encode4(195663), // Rule ID 1640 //
     /* 195623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 195631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195652 */     // (intrinsic_wo_chain:{ *:[v1i64] } 704:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 195652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i64),
     /* 195655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195661 */     GIR_RootConstrainSelectedInstOperands,
     /* 195662 */     // GIR_Coverage, 1640,
     /* 195662 */     GIR_EraseRootFromParent_Done,
     /* 195663 */   // Label 3643: @195663
     /* 195663 */   GIM_Try, /*On fail goto*//*Label 3644*/ GIMT_Encode4(195708), // Rule ID 1642 //
     /* 195668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 195676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195697 */     // (intrinsic_wo_chain:{ *:[v1i64] } 712:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 195697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv1i64),
     /* 195700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195706 */     GIR_RootConstrainSelectedInstOperands,
     /* 195707 */     // GIR_Coverage, 1642,
     /* 195707 */     GIR_EraseRootFromParent_Done,
     /* 195708 */   // Label 3644: @195708
     /* 195708 */   GIM_Try, /*On fail goto*//*Label 3645*/ GIMT_Encode4(195753), // Rule ID 1643 //
     /* 195713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 195721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195742 */     // (intrinsic_wo_chain:{ *:[v1i64] } 713:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 195742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv1i64),
     /* 195745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195749 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195751 */     GIR_RootConstrainSelectedInstOperands,
     /* 195752 */     // GIR_Coverage, 1643,
     /* 195752 */     GIR_EraseRootFromParent_Done,
     /* 195753 */   // Label 3645: @195753
     /* 195753 */   GIM_Try, /*On fail goto*//*Label 3646*/ GIMT_Encode4(195798), // Rule ID 1646 //
     /* 195758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 195766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195787 */     // (intrinsic_wo_chain:{ *:[v1i64] } 750:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 195787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i64),
     /* 195790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195794 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195796 */     GIR_RootConstrainSelectedInstOperands,
     /* 195797 */     // GIR_Coverage, 1646,
     /* 195797 */     GIR_EraseRootFromParent_Done,
     /* 195798 */   // Label 3646: @195798
     /* 195798 */   GIM_Try, /*On fail goto*//*Label 3647*/ GIMT_Encode4(195843), // Rule ID 1647 //
     /* 195803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 195811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195832 */     // (intrinsic_wo_chain:{ *:[v1i64] } 752:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 195832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i64),
     /* 195835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195841 */     GIR_RootConstrainSelectedInstOperands,
     /* 195842 */     // GIR_Coverage, 1647,
     /* 195842 */     GIR_EraseRootFromParent_Done,
     /* 195843 */   // Label 3647: @195843
     /* 195843 */   GIM_Try, /*On fail goto*//*Label 3648*/ GIMT_Encode4(195888), // Rule ID 1649 //
     /* 195848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 195856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195877 */     // (intrinsic_wo_chain:{ *:[v1i64] } 758:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (URSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 195877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv1i64),
     /* 195880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195886 */     GIR_RootConstrainSelectedInstOperands,
     /* 195887 */     // GIR_Coverage, 1649,
     /* 195887 */     GIR_EraseRootFromParent_Done,
     /* 195888 */   // Label 3648: @195888
     /* 195888 */   GIM_Try, /*On fail goto*//*Label 3649*/ GIMT_Encode4(195933), // Rule ID 1650 //
     /* 195893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 195901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195922 */     // (intrinsic_wo_chain:{ *:[v1i64] } 761:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (USHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 195922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv1i64),
     /* 195925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195931 */     GIR_RootConstrainSelectedInstOperands,
     /* 195932 */     // GIR_Coverage, 1650,
     /* 195932 */     GIR_EraseRootFromParent_Done,
     /* 195933 */   // Label 3649: @195933
     /* 195933 */   GIM_Try, /*On fail goto*//*Label 3650*/ GIMT_Encode4(195978), // Rule ID 1651 //
     /* 195938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 195946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 195955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195967 */     // (intrinsic_wo_chain:{ *:[i64] } 694:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQDMULLi32:{ *:[i64] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 195967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLi32),
     /* 195970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195976 */     GIR_RootConstrainSelectedInstOperands,
     /* 195977 */     // GIR_Coverage, 1651,
     /* 195977 */     GIR_EraseRootFromParent_Done,
     /* 195978 */   // Label 3650: @195978
     /* 195978 */   GIM_Try, /*On fail goto*//*Label 3651*/ GIMT_Encode4(196023), // Rule ID 1665 //
     /* 195983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 195991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 196000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196012 */     // (intrinsic_wo_chain:{ *:[i64] } 725:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)  =>  (SUQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)
     /* 196012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i64),
     /* 196015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196021 */     GIR_RootConstrainSelectedInstOperands,
     /* 196022 */     // GIR_Coverage, 1665,
     /* 196022 */     GIR_EraseRootFromParent_Done,
     /* 196023 */   // Label 3651: @196023
     /* 196023 */   GIM_Try, /*On fail goto*//*Label 3652*/ GIMT_Encode4(196068), // Rule ID 1666 //
     /* 196028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 196036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 196039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 196045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 196049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 196053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 196057 */     // (intrinsic_wo_chain:{ *:[i32] } 725:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)  =>  (SUQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)
     /* 196057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i32),
     /* 196060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196066 */     GIR_RootConstrainSelectedInstOperands,
     /* 196067 */     // GIR_Coverage, 1666,
     /* 196067 */     GIR_EraseRootFromParent_Done,
     /* 196068 */   // Label 3652: @196068
     /* 196068 */   GIM_Try, /*On fail goto*//*Label 3653*/ GIMT_Encode4(196113), // Rule ID 1671 //
     /* 196073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 196081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 196084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 196087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 196090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196102 */     // (intrinsic_wo_chain:{ *:[i64] } 764:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)  =>  (USQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)
     /* 196102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i64),
     /* 196105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196111 */     GIR_RootConstrainSelectedInstOperands,
     /* 196112 */     // GIR_Coverage, 1671,
     /* 196112 */     GIR_EraseRootFromParent_Done,
     /* 196113 */   // Label 3653: @196113
     /* 196113 */   GIM_Try, /*On fail goto*//*Label 3654*/ GIMT_Encode4(196158), // Rule ID 1672 //
     /* 196118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 196126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 196129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 196135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 196139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 196143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 196147 */     // (intrinsic_wo_chain:{ *:[i32] } 764:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)  =>  (USQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)
     /* 196147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i32),
     /* 196150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196156 */     GIR_RootConstrainSelectedInstOperands,
     /* 196157 */     // GIR_Coverage, 1672,
     /* 196157 */     GIR_EraseRootFromParent_Done,
     /* 196158 */   // Label 3654: @196158
     /* 196158 */   GIM_Try, /*On fail goto*//*Label 3655*/ GIMT_Encode4(196203), // Rule ID 1673 //
     /* 196163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 196171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 196174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 196177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 196180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196192 */     // (intrinsic_wo_chain:{ *:[v8i8] } 579:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 196192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v8i8),
     /* 196195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196201 */     GIR_RootConstrainSelectedInstOperands,
     /* 196202 */     // GIR_Coverage, 1673,
     /* 196202 */     GIR_EraseRootFromParent_Done,
     /* 196203 */   // Label 3655: @196203
     /* 196203 */   GIM_Try, /*On fail goto*//*Label 3656*/ GIMT_Encode4(196248), // Rule ID 1674 //
     /* 196208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 196216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 196219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 196222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 196225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196237 */     // (intrinsic_wo_chain:{ *:[v4i16] } 579:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 196237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v4i16),
     /* 196240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196246 */     GIR_RootConstrainSelectedInstOperands,
     /* 196247 */     // GIR_Coverage, 1674,
     /* 196247 */     GIR_EraseRootFromParent_Done,
     /* 196248 */   // Label 3656: @196248
     /* 196248 */   GIM_Try, /*On fail goto*//*Label 3657*/ GIMT_Encode4(196293), // Rule ID 1675 //
     /* 196253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 196261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 196264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 196267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 196270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196282 */     // (intrinsic_wo_chain:{ *:[v2i32] } 579:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 196282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v2i32),
     /* 196285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196291 */     GIR_RootConstrainSelectedInstOperands,
     /* 196292 */     // GIR_Coverage, 1675,
     /* 196292 */     GIR_EraseRootFromParent_Done,
     /* 196293 */   // Label 3657: @196293
     /* 196293 */   GIM_Try, /*On fail goto*//*Label 3658*/ GIMT_Encode4(196338), // Rule ID 1676 //
     /* 196298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 196306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 196309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 196312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 196315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196327 */     // (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 196327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 196330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196336 */     GIR_RootConstrainSelectedInstOperands,
     /* 196337 */     // GIR_Coverage, 1676,
     /* 196337 */     GIR_EraseRootFromParent_Done,
     /* 196338 */   // Label 3658: @196338
     /* 196338 */   GIM_Try, /*On fail goto*//*Label 3659*/ GIMT_Encode4(196383), // Rule ID 1677 //
     /* 196343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 196351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 196354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 196357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 196360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196372 */     // (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 196372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 196375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196381 */     GIR_RootConstrainSelectedInstOperands,
     /* 196382 */     // GIR_Coverage, 1677,
     /* 196382 */     GIR_EraseRootFromParent_Done,
     /* 196383 */   // Label 3659: @196383
     /* 196383 */   GIM_Try, /*On fail goto*//*Label 3660*/ GIMT_Encode4(196428), // Rule ID 1678 //
     /* 196388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 196396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 196399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 196402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 196405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196417 */     // (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 196417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 196420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196426 */     GIR_RootConstrainSelectedInstOperands,
     /* 196427 */     // GIR_Coverage, 1678,
     /* 196427 */     GIR_EraseRootFromParent_Done,
     /* 196428 */   // Label 3660: @196428
     /* 196428 */   GIM_Try, /*On fail goto*//*Label 3661*/ GIMT_Encode4(196473), // Rule ID 1679 //
     /* 196433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 196441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 196444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 196447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 196450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196462 */     // (intrinsic_wo_chain:{ *:[v8i8] } 666:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (RADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 196462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v8i8),
     /* 196465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196471 */     GIR_RootConstrainSelectedInstOperands,
     /* 196472 */     // GIR_Coverage, 1679,
     /* 196472 */     GIR_EraseRootFromParent_Done,
     /* 196473 */   // Label 3661: @196473
     /* 196473 */   GIM_Try, /*On fail goto*//*Label 3662*/ GIMT_Encode4(196518), // Rule ID 1680 //
     /* 196478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 196486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 196489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 196492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 196495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196507 */     // (intrinsic_wo_chain:{ *:[v4i16] } 666:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (RADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 196507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v4i16),
     /* 196510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196516 */     GIR_RootConstrainSelectedInstOperands,
     /* 196517 */     // GIR_Coverage, 1680,
     /* 196517 */     GIR_EraseRootFromParent_Done,
     /* 196518 */   // Label 3662: @196518
     /* 196518 */   GIM_Try, /*On fail goto*//*Label 3663*/ GIMT_Encode4(196563), // Rule ID 1681 //
     /* 196523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 196531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 196534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 196537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 196540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196552 */     // (intrinsic_wo_chain:{ *:[v2i32] } 666:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (RADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 196552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v2i32),
     /* 196555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196561 */     GIR_RootConstrainSelectedInstOperands,
     /* 196562 */     // GIR_Coverage, 1681,
     /* 196562 */     GIR_EraseRootFromParent_Done,
     /* 196563 */   // Label 3663: @196563
     /* 196563 */   GIM_Try, /*On fail goto*//*Label 3664*/ GIMT_Encode4(196608), // Rule ID 1682 //
     /* 196568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 196576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 196579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 196582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 196585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196597 */     // (intrinsic_wo_chain:{ *:[v8i8] } 668:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (RSUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 196597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv8i16_v8i8),
     /* 196600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196606 */     GIR_RootConstrainSelectedInstOperands,
     /* 196607 */     // GIR_Coverage, 1682,
     /* 196607 */     GIR_EraseRootFromParent_Done,
     /* 196608 */   // Label 3664: @196608
     /* 196608 */   GIM_Try, /*On fail goto*//*Label 3665*/ GIMT_Encode4(196653), // Rule ID 1683 //
     /* 196613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 196621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 196624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 196627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 196630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196642 */     // (intrinsic_wo_chain:{ *:[v4i16] } 668:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (RSUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 196642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv4i32_v4i16),
     /* 196645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196651 */     GIR_RootConstrainSelectedInstOperands,
     /* 196652 */     // GIR_Coverage, 1683,
     /* 196652 */     GIR_EraseRootFromParent_Done,
     /* 196653 */   // Label 3665: @196653
     /* 196653 */   GIM_Try, /*On fail goto*//*Label 3666*/ GIMT_Encode4(196698), // Rule ID 1684 //
     /* 196658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 196666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 196669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 196672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 196675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196687 */     // (intrinsic_wo_chain:{ *:[v2i32] } 668:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (RSUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 196687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv2i64_v2i32),
     /* 196690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196696 */     GIR_RootConstrainSelectedInstOperands,
     /* 196697 */     // GIR_Coverage, 1684,
     /* 196697 */     GIR_EraseRootFromParent_Done,
     /* 196698 */   // Label 3666: @196698
     /* 196698 */   GIM_Try, /*On fail goto*//*Label 3667*/ GIMT_Encode4(196743), // Rule ID 1750 //
     /* 196703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 196711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 196717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 196720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196732 */     // (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQDMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 196732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_v4i32),
     /* 196735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196739 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196741 */     GIR_RootConstrainSelectedInstOperands,
     /* 196742 */     // GIR_Coverage, 1750,
     /* 196742 */     GIR_EraseRootFromParent_Done,
     /* 196743 */   // Label 3667: @196743
     /* 196743 */   GIM_Try, /*On fail goto*//*Label 3668*/ GIMT_Encode4(196788), // Rule ID 1752 //
     /* 196748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 196756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 196759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 196762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 196765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196777 */     // (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQDMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 196777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_v2i64),
     /* 196780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196786 */     GIR_RootConstrainSelectedInstOperands,
     /* 196787 */     // GIR_Coverage, 1752,
     /* 196787 */     GIR_EraseRootFromParent_Done,
     /* 196788 */   // Label 3668: @196788
     /* 196788 */   GIM_Try, /*On fail goto*//*Label 3669*/ GIMT_Encode4(196833), // Rule ID 2303 //
     /* 196793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 196796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aese),
     /* 196801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 196804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 196807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 196810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196822 */     // (intrinsic_wo_chain:{ *:[v16i8] } 522:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (AESErr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 196822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESErr),
     /* 196825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196831 */     GIR_RootConstrainSelectedInstOperands,
     /* 196832 */     // GIR_Coverage, 2303,
     /* 196832 */     GIR_EraseRootFromParent_Done,
     /* 196833 */   // Label 3669: @196833
     /* 196833 */   GIM_Try, /*On fail goto*//*Label 3670*/ GIMT_Encode4(196878), // Rule ID 2304 //
     /* 196838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 196841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesd),
     /* 196846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 196849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 196852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 196855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196867 */     // (intrinsic_wo_chain:{ *:[v16i8] } 521:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (AESDrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 196867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESDrr),
     /* 196870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196874 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196876 */     GIR_RootConstrainSelectedInstOperands,
     /* 196877 */     // GIR_Coverage, 2304,
     /* 196877 */     GIR_EraseRootFromParent_Done,
     /* 196878 */   // Label 3670: @196878
     /* 196878 */   GIM_Try, /*On fail goto*//*Label 3671*/ GIMT_Encode4(196923), // Rule ID 2315 //
     /* 196883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 196886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1su1),
     /* 196891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 196897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 196900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196912 */     // (intrinsic_wo_chain:{ *:[v4i32] } 535:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SHA1SU1rr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 196912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1SU1rr),
     /* 196915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196921 */     GIR_RootConstrainSelectedInstOperands,
     /* 196922 */     // GIR_Coverage, 2315,
     /* 196922 */     GIR_EraseRootFromParent_Done,
     /* 196923 */   // Label 3671: @196923
     /* 196923 */   GIM_Try, /*On fail goto*//*Label 3672*/ GIMT_Encode4(196968), // Rule ID 2316 //
     /* 196928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 196931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256su0),
     /* 196936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 196942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 196945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196957 */     // (intrinsic_wo_chain:{ *:[v4i32] } 538:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SHA256SU0rr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 196957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256SU0rr),
     /* 196960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196966 */     GIR_RootConstrainSelectedInstOperands,
     /* 196967 */     // GIR_Coverage, 2316,
     /* 196967 */     GIR_EraseRootFromParent_Done,
     /* 196968 */   // Label 3672: @196968
     /* 196968 */   GIM_Try, /*On fail goto*//*Label 3673*/ GIMT_Encode4(197013), // Rule ID 2339 //
     /* 196973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 196976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 196981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 196984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 196987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 196990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197002 */     // (intrinsic_wo_chain:{ *:[v4f16] } 641:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (FSCALEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 197002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv4f16),
     /* 197005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197009 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197011 */     GIR_RootConstrainSelectedInstOperands,
     /* 197012 */     // GIR_Coverage, 2339,
     /* 197012 */     GIR_EraseRootFromParent_Done,
     /* 197013 */   // Label 3673: @197013
     /* 197013 */   GIM_Try, /*On fail goto*//*Label 3674*/ GIMT_Encode4(197058), // Rule ID 2340 //
     /* 197018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 197021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 197026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 197029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 197032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 197035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197047 */     // (intrinsic_wo_chain:{ *:[v8f16] } 641:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (FSCALEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 197047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv8f16),
     /* 197050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197056 */     GIR_RootConstrainSelectedInstOperands,
     /* 197057 */     // GIR_Coverage, 2340,
     /* 197057 */     GIR_EraseRootFromParent_Done,
     /* 197058 */   // Label 3674: @197058
     /* 197058 */   GIM_Try, /*On fail goto*//*Label 3675*/ GIMT_Encode4(197103), // Rule ID 2341 //
     /* 197063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 197066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 197071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 197074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 197077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 197080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197092 */     // (intrinsic_wo_chain:{ *:[v2f32] } 641:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (FSCALEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 197092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv2f32),
     /* 197095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197101 */     GIR_RootConstrainSelectedInstOperands,
     /* 197102 */     // GIR_Coverage, 2341,
     /* 197102 */     GIR_EraseRootFromParent_Done,
     /* 197103 */   // Label 3675: @197103
     /* 197103 */   GIM_Try, /*On fail goto*//*Label 3676*/ GIMT_Encode4(197148), // Rule ID 2342 //
     /* 197108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 197111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 197116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 197119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 197122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 197125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197137 */     // (intrinsic_wo_chain:{ *:[v4f32] } 641:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (FSCALEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 197137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv4f32),
     /* 197140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197146 */     GIR_RootConstrainSelectedInstOperands,
     /* 197147 */     // GIR_Coverage, 2342,
     /* 197147 */     GIR_EraseRootFromParent_Done,
     /* 197148 */   // Label 3676: @197148
     /* 197148 */   GIM_Try, /*On fail goto*//*Label 3677*/ GIMT_Encode4(197193), // Rule ID 2343 //
     /* 197153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 197156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 197161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 197164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 197167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 197170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197182 */     // (intrinsic_wo_chain:{ *:[v2f64] } 641:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (FSCALEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 197182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv2f64),
     /* 197185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197191 */     GIR_RootConstrainSelectedInstOperands,
     /* 197192 */     // GIR_Coverage, 2343,
     /* 197192 */     GIR_EraseRootFromParent_Done,
     /* 197193 */   // Label 3677: @197193
     /* 197193 */   GIM_Try, /*On fail goto*//*Label 3678*/ GIMT_Encode4(197238), // Rule ID 2344 //
     /* 197198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 197201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 197206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 197209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 197212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 197215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197227 */     // (intrinsic_wo_chain:{ *:[v4f16] } 591:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FAMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 197227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f16),
     /* 197230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197236 */     GIR_RootConstrainSelectedInstOperands,
     /* 197237 */     // GIR_Coverage, 2344,
     /* 197237 */     GIR_EraseRootFromParent_Done,
     /* 197238 */   // Label 3678: @197238
     /* 197238 */   GIM_Try, /*On fail goto*//*Label 3679*/ GIMT_Encode4(197283), // Rule ID 2347 //
     /* 197243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 197246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 197251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 197254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 197257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 197260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197272 */     // (intrinsic_wo_chain:{ *:[v8f16] } 591:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FAMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 197272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv8f16),
     /* 197275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197281 */     GIR_RootConstrainSelectedInstOperands,
     /* 197282 */     // GIR_Coverage, 2347,
     /* 197282 */     GIR_EraseRootFromParent_Done,
     /* 197283 */   // Label 3679: @197283
     /* 197283 */   GIM_Try, /*On fail goto*//*Label 3680*/ GIMT_Encode4(197328), // Rule ID 2350 //
     /* 197288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 197291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 197296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 197299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 197302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 197305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197317 */     // (intrinsic_wo_chain:{ *:[v2f32] } 591:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FAMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 197317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f32),
     /* 197320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197326 */     GIR_RootConstrainSelectedInstOperands,
     /* 197327 */     // GIR_Coverage, 2350,
     /* 197327 */     GIR_EraseRootFromParent_Done,
     /* 197328 */   // Label 3680: @197328
     /* 197328 */   GIM_Try, /*On fail goto*//*Label 3681*/ GIMT_Encode4(197373), // Rule ID 2353 //
     /* 197333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 197336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 197341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 197344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 197347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 197350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197362 */     // (intrinsic_wo_chain:{ *:[v4f32] } 591:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FAMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 197362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f32),
     /* 197365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197371 */     GIR_RootConstrainSelectedInstOperands,
     /* 197372 */     // GIR_Coverage, 2353,
     /* 197372 */     GIR_EraseRootFromParent_Done,
     /* 197373 */   // Label 3681: @197373
     /* 197373 */   GIM_Try, /*On fail goto*//*Label 3682*/ GIMT_Encode4(197418), // Rule ID 2356 //
     /* 197378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 197381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 197386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 197389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 197392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 197395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197407 */     // (intrinsic_wo_chain:{ *:[v2f64] } 591:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FAMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 197407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f64),
     /* 197410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197416 */     GIR_RootConstrainSelectedInstOperands,
     /* 197417 */     // GIR_Coverage, 2356,
     /* 197417 */     GIR_EraseRootFromParent_Done,
     /* 197418 */   // Label 3682: @197418
     /* 197418 */   GIM_Try, /*On fail goto*//*Label 3683*/ GIMT_Encode4(197463), // Rule ID 2359 //
     /* 197423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 197426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 197431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 197434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 197437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 197440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197452 */     // (intrinsic_wo_chain:{ *:[v4f16] } 592:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FAMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 197452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f16),
     /* 197455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197461 */     GIR_RootConstrainSelectedInstOperands,
     /* 197462 */     // GIR_Coverage, 2359,
     /* 197462 */     GIR_EraseRootFromParent_Done,
     /* 197463 */   // Label 3683: @197463
     /* 197463 */   GIM_Try, /*On fail goto*//*Label 3684*/ GIMT_Encode4(197508), // Rule ID 2362 //
     /* 197468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 197471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 197476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 197479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 197482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 197485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197497 */     // (intrinsic_wo_chain:{ *:[v8f16] } 592:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FAMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 197497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv8f16),
     /* 197500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197506 */     GIR_RootConstrainSelectedInstOperands,
     /* 197507 */     // GIR_Coverage, 2362,
     /* 197507 */     GIR_EraseRootFromParent_Done,
     /* 197508 */   // Label 3684: @197508
     /* 197508 */   GIM_Try, /*On fail goto*//*Label 3685*/ GIMT_Encode4(197553), // Rule ID 2365 //
     /* 197513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 197516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 197521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 197524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 197527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 197530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197542 */     // (intrinsic_wo_chain:{ *:[v2f32] } 592:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FAMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 197542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f32),
     /* 197545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197549 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197551 */     GIR_RootConstrainSelectedInstOperands,
     /* 197552 */     // GIR_Coverage, 2365,
     /* 197552 */     GIR_EraseRootFromParent_Done,
     /* 197553 */   // Label 3685: @197553
     /* 197553 */   GIM_Try, /*On fail goto*//*Label 3686*/ GIMT_Encode4(197598), // Rule ID 2368 //
     /* 197558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 197561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 197566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 197569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 197572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 197575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197587 */     // (intrinsic_wo_chain:{ *:[v4f32] } 592:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FAMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 197587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f32),
     /* 197590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197596 */     GIR_RootConstrainSelectedInstOperands,
     /* 197597 */     // GIR_Coverage, 2368,
     /* 197597 */     GIR_EraseRootFromParent_Done,
     /* 197598 */   // Label 3686: @197598
     /* 197598 */   GIM_Try, /*On fail goto*//*Label 3687*/ GIMT_Encode4(197643), // Rule ID 2371 //
     /* 197603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 197606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 197611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 197614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 197617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 197620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197632 */     // (intrinsic_wo_chain:{ *:[v2f64] } 592:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FAMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 197632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f64),
     /* 197635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197641 */     GIR_RootConstrainSelectedInstOperands,
     /* 197642 */     // GIR_Coverage, 2371,
     /* 197642 */     GIR_EraseRootFromParent_Done,
     /* 197643 */   // Label 3687: @197643
     /* 197643 */   GIM_Try, /*On fail goto*//*Label 3688*/ GIMT_Encode4(197688), // Rule ID 2423 //
     /* 197648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_AES_HasSVEAES),
     /* 197651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aese),
     /* 197656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 197659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 197662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 197665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197677 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1269:{ *:[iPTR] }, ZPR8:{ *:[nxv16i8] }:$_Zdn, ZPR8:{ *:[nxv16i8] }:$Zm)  =>  (AESE_ZZZ_B:{ *:[nxv16i8] } ZPR8:{ *:[nxv16i8] }:$_Zdn, ZPR8:{ *:[nxv16i8] }:$Zm)
     /* 197677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESE_ZZZ_B),
     /* 197680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 197682 */     GIR_RootToRootCopy, /*OpIdx*/2, // _Zdn
     /* 197684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 197686 */     GIR_RootConstrainSelectedInstOperands,
     /* 197687 */     // GIR_Coverage, 2423,
     /* 197687 */     GIR_EraseRootFromParent_Done,
     /* 197688 */   // Label 3688: @197688
     /* 197688 */   GIM_Try, /*On fail goto*//*Label 3689*/ GIMT_Encode4(197733), // Rule ID 2424 //
     /* 197693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_AES_HasSVEAES),
     /* 197696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesd),
     /* 197701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 197704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 197707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 197710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197722 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1268:{ *:[iPTR] }, ZPR8:{ *:[nxv16i8] }:$_Zdn, ZPR8:{ *:[nxv16i8] }:$Zm)  =>  (AESD_ZZZ_B:{ *:[nxv16i8] } ZPR8:{ *:[nxv16i8] }:$_Zdn, ZPR8:{ *:[nxv16i8] }:$Zm)
     /* 197722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESD_ZZZ_B),
     /* 197725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 197727 */     GIR_RootToRootCopy, /*OpIdx*/2, // _Zdn
     /* 197729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 197731 */     GIR_RootConstrainSelectedInstOperands,
     /* 197732 */     // GIR_Coverage, 2424,
     /* 197732 */     GIR_EraseRootFromParent_Done,
     /* 197733 */   // Label 3689: @197733
     /* 197733 */   GIM_Try, /*On fail goto*//*Label 3690*/ GIMT_Encode4(197778), // Rule ID 2425 //
     /* 197738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SM4),
     /* 197741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sm4e),
     /* 197746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 197749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 197752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 197755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197767 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1733:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$_Zdn, ZPR32:{ *:[nxv4i32] }:$Zm)  =>  (SM4E_ZZZ_S:{ *:[nxv4i32] } ZPR32:{ *:[nxv4i32] }:$_Zdn, ZPR32:{ *:[nxv4i32] }:$Zm)
     /* 197767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4E_ZZZ_S),
     /* 197770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 197772 */     GIR_RootToRootCopy, /*OpIdx*/2, // _Zdn
     /* 197774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 197776 */     GIR_RootConstrainSelectedInstOperands,
     /* 197777 */     // GIR_Coverage, 2425,
     /* 197777 */     GIR_EraseRootFromParent_Done,
     /* 197778 */   // Label 3690: @197778
     /* 197778 */   GIM_Try, /*On fail goto*//*Label 3691*/ GIMT_Encode4(197823), // Rule ID 2504 //
     /* 197783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 197791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197812 */     // (intrinsic_wo_chain:{ *:[i64] } 689:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 197812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i64),
     /* 197815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197819 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197821 */     GIR_RootConstrainSelectedInstOperands,
     /* 197822 */     // GIR_Coverage, 2504,
     /* 197822 */     GIR_EraseRootFromParent_Done,
     /* 197823 */   // Label 3691: @197823
     /* 197823 */   GIM_Try, /*On fail goto*//*Label 3692*/ GIMT_Encode4(197868), // Rule ID 2505 //
     /* 197828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 197836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 197839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 197842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 197845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197857 */     // (intrinsic_wo_chain:{ *:[i32] } 689:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 197857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i32),
     /* 197860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197866 */     GIR_RootConstrainSelectedInstOperands,
     /* 197867 */     // GIR_Coverage, 2505,
     /* 197867 */     GIR_EraseRootFromParent_Done,
     /* 197868 */   // Label 3692: @197868
     /* 197868 */   GIM_Try, /*On fail goto*//*Label 3693*/ GIMT_Encode4(197913), // Rule ID 2506 //
     /* 197873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 197881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197902 */     // (intrinsic_wo_chain:{ *:[v1f64] } 795:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FABD64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 197902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 197905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197911 */     GIR_RootConstrainSelectedInstOperands,
     /* 197912 */     // GIR_Coverage, 2506,
     /* 197912 */     GIR_EraseRootFromParent_Done,
     /* 197913 */   // Label 3693: @197913
     /* 197913 */   GIM_Try, /*On fail goto*//*Label 3694*/ GIMT_Encode4(197958), // Rule ID 2507 //
     /* 197918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 197926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197947 */     // (intrinsic_wo_chain:{ *:[v1i64] } 587:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FACGE64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 197947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE64),
     /* 197950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197956 */     GIR_RootConstrainSelectedInstOperands,
     /* 197957 */     // GIR_Coverage, 2507,
     /* 197957 */     GIR_EraseRootFromParent_Done,
     /* 197958 */   // Label 3694: @197958
     /* 197958 */   GIM_Try, /*On fail goto*//*Label 3695*/ GIMT_Encode4(198003), // Rule ID 2512 //
     /* 197963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 197971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197992 */     // (intrinsic_wo_chain:{ *:[v1i64] } 725:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)  =>  (SUQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)
     /* 197992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i64),
     /* 197995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 197999 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198001 */     GIR_RootConstrainSelectedInstOperands,
     /* 198002 */     // GIR_Coverage, 2512,
     /* 198002 */     GIR_EraseRootFromParent_Done,
     /* 198003 */   // Label 3695: @198003
     /* 198003 */   GIM_Try, /*On fail goto*//*Label 3696*/ GIMT_Encode4(198048), // Rule ID 2630 //
     /* 198008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 198016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 198019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 198022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 198025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 198029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 198033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198037 */     // (intrinsic_wo_chain:{ *:[i32] } 2035:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQINCP_WP_B:{ *:[i32] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 198037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_B),
     /* 198040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 198042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 198044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198046 */     GIR_RootConstrainSelectedInstOperands,
     /* 198047 */     // GIR_Coverage, 2630,
     /* 198047 */     GIR_EraseRootFromParent_Done,
     /* 198048 */   // Label 3696: @198048
     /* 198048 */   GIM_Try, /*On fail goto*//*Label 3697*/ GIMT_Encode4(198093), // Rule ID 2631 //
     /* 198053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 198061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 198064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 198067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 198070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 198074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 198078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198082 */     // (intrinsic_wo_chain:{ *:[i32] } 2035:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQINCP_WP_H:{ *:[i32] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 198082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_H),
     /* 198085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 198087 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 198089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198091 */     GIR_RootConstrainSelectedInstOperands,
     /* 198092 */     // GIR_Coverage, 2631,
     /* 198092 */     GIR_EraseRootFromParent_Done,
     /* 198093 */   // Label 3697: @198093
     /* 198093 */   GIM_Try, /*On fail goto*//*Label 3698*/ GIMT_Encode4(198138), // Rule ID 2632 //
     /* 198098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 198106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 198109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 198112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 198115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 198119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 198123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198127 */     // (intrinsic_wo_chain:{ *:[i32] } 2035:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQINCP_WP_S:{ *:[i32] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 198127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_S),
     /* 198130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 198132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 198134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198136 */     GIR_RootConstrainSelectedInstOperands,
     /* 198137 */     // GIR_Coverage, 2632,
     /* 198137 */     GIR_EraseRootFromParent_Done,
     /* 198138 */   // Label 3698: @198138
     /* 198138 */   GIM_Try, /*On fail goto*//*Label 3699*/ GIMT_Encode4(198183), // Rule ID 2633 //
     /* 198143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 198151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 198154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 198157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 198160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 198164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 198168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198172 */     // (intrinsic_wo_chain:{ *:[i32] } 2035:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQINCP_WP_D:{ *:[i32] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 198172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_D),
     /* 198175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 198177 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 198179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198181 */     GIR_RootConstrainSelectedInstOperands,
     /* 198182 */     // GIR_Coverage, 2633,
     /* 198182 */     GIR_EraseRootFromParent_Done,
     /* 198183 */   // Label 3699: @198183
     /* 198183 */   GIM_Try, /*On fail goto*//*Label 3700*/ GIMT_Encode4(198228), // Rule ID 2634 //
     /* 198188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 198196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 198205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 198209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 198213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198217 */     // (intrinsic_wo_chain:{ *:[i64] } 1825:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (SQINCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 198217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_B),
     /* 198220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 198222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 198224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198226 */     GIR_RootConstrainSelectedInstOperands,
     /* 198227 */     // GIR_Coverage, 2634,
     /* 198227 */     GIR_EraseRootFromParent_Done,
     /* 198228 */   // Label 3700: @198228
     /* 198228 */   GIM_Try, /*On fail goto*//*Label 3701*/ GIMT_Encode4(198273), // Rule ID 2635 //
     /* 198233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 198241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 198250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 198254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 198258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198262 */     // (intrinsic_wo_chain:{ *:[i64] } 1825:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (SQINCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 198262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_H),
     /* 198265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 198267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 198269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198271 */     GIR_RootConstrainSelectedInstOperands,
     /* 198272 */     // GIR_Coverage, 2635,
     /* 198272 */     GIR_EraseRootFromParent_Done,
     /* 198273 */   // Label 3701: @198273
     /* 198273 */   GIM_Try, /*On fail goto*//*Label 3702*/ GIMT_Encode4(198318), // Rule ID 2636 //
     /* 198278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 198286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 198295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 198299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 198303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198307 */     // (intrinsic_wo_chain:{ *:[i64] } 1825:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (SQINCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 198307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_S),
     /* 198310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 198312 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 198314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198316 */     GIR_RootConstrainSelectedInstOperands,
     /* 198317 */     // GIR_Coverage, 2636,
     /* 198317 */     GIR_EraseRootFromParent_Done,
     /* 198318 */   // Label 3702: @198318
     /* 198318 */   GIM_Try, /*On fail goto*//*Label 3703*/ GIMT_Encode4(198363), // Rule ID 2637 //
     /* 198323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 198331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 198340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 198344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 198348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198352 */     // (intrinsic_wo_chain:{ *:[i64] } 1825:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (SQINCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 198352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_D),
     /* 198355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 198357 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 198359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198361 */     GIR_RootConstrainSelectedInstOperands,
     /* 198362 */     // GIR_Coverage, 2637,
     /* 198362 */     GIR_EraseRootFromParent_Done,
     /* 198363 */   // Label 3703: @198363
     /* 198363 */   GIM_Try, /*On fail goto*//*Label 3704*/ GIMT_Encode4(198408), // Rule ID 3840 //
     /* 198368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 198371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512su0),
     /* 198376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 198379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 198382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 198385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198397 */     // (intrinsic_wo_chain:{ *:[v2i64] } 542:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512SU0:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 198397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512SU0),
     /* 198400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 198402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 198404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 198406 */     GIR_RootConstrainSelectedInstOperands,
     /* 198407 */     // GIR_Coverage, 3840,
     /* 198407 */     GIR_EraseRootFromParent_Done,
     /* 198408 */   // Label 3704: @198408
     /* 198408 */   GIM_Try, /*On fail goto*//*Label 3705*/ GIMT_Encode4(198453), // Rule ID 3868 //
     /* 198413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 198416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_rax1),
     /* 198421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 198424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 198427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 198430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198442 */     // (intrinsic_wo_chain:{ *:[v2i64] } 529:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (RAX1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 198442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RAX1),
     /* 198445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 198449 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 198451 */     GIR_RootConstrainSelectedInstOperands,
     /* 198452 */     // GIR_Coverage, 3868,
     /* 198452 */     GIR_EraseRootFromParent_Done,
     /* 198453 */   // Label 3705: @198453
     /* 198453 */   GIM_Try, /*On fail goto*//*Label 3706*/ GIMT_Encode4(198498), // Rule ID 3878 //
     /* 198458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 198461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm4ekey),
     /* 198466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 198469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 198472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 198475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198487 */     // (intrinsic_wo_chain:{ *:[v4i32] } 552:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM4ENCKEY:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 198487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4ENCKEY),
     /* 198490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 198494 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 198496 */     GIR_RootConstrainSelectedInstOperands,
     /* 198497 */     // GIR_Coverage, 3878,
     /* 198497 */     GIR_EraseRootFromParent_Done,
     /* 198498 */   // Label 3706: @198498
     /* 198498 */   GIM_Try, /*On fail goto*//*Label 3707*/ GIMT_Encode4(198543), // Rule ID 3879 //
     /* 198503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 198506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm4e),
     /* 198511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 198514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 198517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 198520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198532 */     // (intrinsic_wo_chain:{ *:[v4i32] } 551:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM4E:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 198532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4E),
     /* 198535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 198537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 198539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 198541 */     GIR_RootConstrainSelectedInstOperands,
     /* 198542 */     // GIR_Coverage, 3879,
     /* 198542 */     GIR_EraseRootFromParent_Done,
     /* 198543 */   // Label 3707: @198543
     /* 198543 */   GIM_Try, /*On fail goto*//*Label 3708*/ GIMT_Encode4(198591), // Rule ID 3880 //
     /* 198548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 198551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 198556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 198559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 198562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 198565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198577 */     // (intrinsic_wo_chain:{ *:[v4f16] } 766:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /* 198577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f16),
     /* 198580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198589 */     GIR_RootConstrainSelectedInstOperands,
     /* 198590 */     // GIR_Coverage, 3880,
     /* 198590 */     GIR_EraseRootFromParent_Done,
     /* 198591 */   // Label 3708: @198591
     /* 198591 */   GIM_Try, /*On fail goto*//*Label 3709*/ GIMT_Encode4(198639), // Rule ID 3881 //
     /* 198596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 198599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 198604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 198607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 198610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 198613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198625 */     // (intrinsic_wo_chain:{ *:[v4f16] } 765:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /* 198625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f16),
     /* 198628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198632 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198637 */     GIR_RootConstrainSelectedInstOperands,
     /* 198638 */     // GIR_Coverage, 3881,
     /* 198638 */     GIR_EraseRootFromParent_Done,
     /* 198639 */   // Label 3709: @198639
     /* 198639 */   GIM_Try, /*On fail goto*//*Label 3710*/ GIMT_Encode4(198687), // Rule ID 3882 //
     /* 198644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 198647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 198652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 198655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 198658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 198661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198673 */     // (intrinsic_wo_chain:{ *:[v8f16] } 766:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /* 198673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv8f16),
     /* 198676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198685 */     GIR_RootConstrainSelectedInstOperands,
     /* 198686 */     // GIR_Coverage, 3882,
     /* 198686 */     GIR_EraseRootFromParent_Done,
     /* 198687 */   // Label 3710: @198687
     /* 198687 */   GIM_Try, /*On fail goto*//*Label 3711*/ GIMT_Encode4(198735), // Rule ID 3883 //
     /* 198692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 198695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 198700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 198703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 198706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 198709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198721 */     // (intrinsic_wo_chain:{ *:[v8f16] } 765:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /* 198721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv8f16),
     /* 198724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198728 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198733 */     GIR_RootConstrainSelectedInstOperands,
     /* 198734 */     // GIR_Coverage, 3883,
     /* 198734 */     GIR_EraseRootFromParent_Done,
     /* 198735 */   // Label 3711: @198735
     /* 198735 */   GIM_Try, /*On fail goto*//*Label 3712*/ GIMT_Encode4(198783), // Rule ID 3884 //
     /* 198740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 198743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 198748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 198751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 198754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 198757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198769 */     // (intrinsic_wo_chain:{ *:[v2f32] } 766:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /* 198769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f32),
     /* 198772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198776 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198781 */     GIR_RootConstrainSelectedInstOperands,
     /* 198782 */     // GIR_Coverage, 3884,
     /* 198782 */     GIR_EraseRootFromParent_Done,
     /* 198783 */   // Label 3712: @198783
     /* 198783 */   GIM_Try, /*On fail goto*//*Label 3713*/ GIMT_Encode4(198831), // Rule ID 3885 //
     /* 198788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 198791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 198796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 198799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 198802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 198805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198817 */     // (intrinsic_wo_chain:{ *:[v2f32] } 765:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /* 198817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f32),
     /* 198820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198829 */     GIR_RootConstrainSelectedInstOperands,
     /* 198830 */     // GIR_Coverage, 3885,
     /* 198830 */     GIR_EraseRootFromParent_Done,
     /* 198831 */   // Label 3713: @198831
     /* 198831 */   GIM_Try, /*On fail goto*//*Label 3714*/ GIMT_Encode4(198879), // Rule ID 3886 //
     /* 198836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 198839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 198844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 198847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 198850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 198853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198865 */     // (intrinsic_wo_chain:{ *:[v4f32] } 766:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /* 198865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f32),
     /* 198868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198877 */     GIR_RootConstrainSelectedInstOperands,
     /* 198878 */     // GIR_Coverage, 3886,
     /* 198878 */     GIR_EraseRootFromParent_Done,
     /* 198879 */   // Label 3714: @198879
     /* 198879 */   GIM_Try, /*On fail goto*//*Label 3715*/ GIMT_Encode4(198927), // Rule ID 3887 //
     /* 198884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 198887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 198892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 198895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 198898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 198901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198913 */     // (intrinsic_wo_chain:{ *:[v4f32] } 765:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /* 198913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f32),
     /* 198916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198925 */     GIR_RootConstrainSelectedInstOperands,
     /* 198926 */     // GIR_Coverage, 3887,
     /* 198926 */     GIR_EraseRootFromParent_Done,
     /* 198927 */   // Label 3715: @198927
     /* 198927 */   GIM_Try, /*On fail goto*//*Label 3716*/ GIMT_Encode4(198975), // Rule ID 3888 //
     /* 198932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 198935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 198940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 198943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 198946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 198949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198961 */     // (intrinsic_wo_chain:{ *:[v2f64] } 766:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, 0:{ *:[i32] })
     /* 198961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f64),
     /* 198964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198973 */     GIR_RootConstrainSelectedInstOperands,
     /* 198974 */     // GIR_Coverage, 3888,
     /* 198974 */     GIR_EraseRootFromParent_Done,
     /* 198975 */   // Label 3716: @198975
     /* 198975 */   GIM_Try, /*On fail goto*//*Label 3717*/ GIMT_Encode4(199023), // Rule ID 3889 //
     /* 198980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 198983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 198988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 198991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 198994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 198997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199009 */     // (intrinsic_wo_chain:{ *:[v2f64] } 765:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, 1:{ *:[i32] })
     /* 199009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f64),
     /* 199012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199021 */     GIR_RootConstrainSelectedInstOperands,
     /* 199022 */     // GIR_Coverage, 3889,
     /* 199022 */     GIR_EraseRootFromParent_Done,
     /* 199023 */   // Label 3717: @199023
     /* 199023 */   GIM_Try, /*On fail goto*//*Label 3718*/ GIMT_Encode4(199065), // Rule ID 3954 //
     /* 199028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_udiv),
     /* 199033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 199036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 199039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 199042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 199046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 199050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 199054 */     // (intrinsic_wo_chain:{ *:[i32] } 2179:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 199054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVWr),
     /* 199057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199063 */     GIR_RootConstrainSelectedInstOperands,
     /* 199064 */     // GIR_Coverage, 3954,
     /* 199064 */     GIR_EraseRootFromParent_Done,
     /* 199065 */   // Label 3718: @199065
     /* 199065 */   GIM_Try, /*On fail goto*//*Label 3719*/ GIMT_Encode4(199107), // Rule ID 3955 //
     /* 199070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_udiv),
     /* 199075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199096 */     // (intrinsic_wo_chain:{ *:[i64] } 2179:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 199096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVXr),
     /* 199099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199105 */     GIR_RootConstrainSelectedInstOperands,
     /* 199106 */     // GIR_Coverage, 3955,
     /* 199106 */     GIR_EraseRootFromParent_Done,
     /* 199107 */   // Label 3719: @199107
     /* 199107 */   GIM_Try, /*On fail goto*//*Label 3720*/ GIMT_Encode4(199149), // Rule ID 3956 //
     /* 199112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sdiv),
     /* 199117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 199120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 199123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 199126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 199130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 199134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 199138 */     // (intrinsic_wo_chain:{ *:[i32] } 789:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 199138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVWr),
     /* 199141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199147 */     GIR_RootConstrainSelectedInstOperands,
     /* 199148 */     // GIR_Coverage, 3956,
     /* 199148 */     GIR_EraseRootFromParent_Done,
     /* 199149 */   // Label 3720: @199149
     /* 199149 */   GIM_Try, /*On fail goto*//*Label 3721*/ GIMT_Encode4(199191), // Rule ID 3957 //
     /* 199154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sdiv),
     /* 199159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199180 */     // (intrinsic_wo_chain:{ *:[i64] } 789:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 199180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVXr),
     /* 199183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199189 */     GIR_RootConstrainSelectedInstOperands,
     /* 199190 */     // GIR_Coverage, 3957,
     /* 199190 */     GIR_EraseRootFromParent_Done,
     /* 199191 */   // Label 3721: @199191
     /* 199191 */   GIM_Try, /*On fail goto*//*Label 3722*/ GIMT_Encode4(199233), // Rule ID 5247 //
     /* 199196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 199201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199222 */     // (intrinsic_wo_chain:{ *:[v1f64] } 586:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FABD64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 199222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 199225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199231 */     GIR_RootConstrainSelectedInstOperands,
     /* 199232 */     // GIR_Coverage, 5247,
     /* 199232 */     GIR_EraseRootFromParent_Done,
     /* 199233 */   // Label 3722: @199233
     /* 199233 */   GIM_Try, /*On fail goto*//*Label 3723*/ GIMT_Encode4(199278), // Rule ID 5251 //
     /* 199238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 199246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199267 */     // (intrinsic_wo_chain:{ *:[v1i64] } 588:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FACGT64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 199267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT64),
     /* 199270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199274 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199276 */     GIR_RootConstrainSelectedInstOperands,
     /* 199277 */     // GIR_Coverage, 5251,
     /* 199277 */     GIR_EraseRootFromParent_Done,
     /* 199278 */   // Label 3723: @199278
     /* 199278 */   GIM_Try, /*On fail goto*//*Label 3724*/ GIMT_Encode4(199323), // Rule ID 5255 //
     /* 199283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 199291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199312 */     // (intrinsic_wo_chain:{ *:[v1f64] } 620:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMULX64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 199312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 199315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199319 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199321 */     GIR_RootConstrainSelectedInstOperands,
     /* 199322 */     // GIR_Coverage, 5255,
     /* 199322 */     GIR_EraseRootFromParent_Done,
     /* 199323 */   // Label 3724: @199323
     /* 199323 */   GIM_Try, /*On fail goto*//*Label 3725*/ GIMT_Encode4(199368), // Rule ID 5256 //
     /* 199328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 199336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199357 */     // (intrinsic_wo_chain:{ *:[v1f64] } 643:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FRECPS64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 199357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS64),
     /* 199360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199366 */     GIR_RootConstrainSelectedInstOperands,
     /* 199367 */     // GIR_Coverage, 5256,
     /* 199367 */     GIR_EraseRootFromParent_Done,
     /* 199368 */   // Label 3725: @199368
     /* 199368 */   GIM_Try, /*On fail goto*//*Label 3726*/ GIMT_Encode4(199413), // Rule ID 5257 //
     /* 199373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 199381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199402 */     // (intrinsic_wo_chain:{ *:[v1f64] } 650:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FRSQRTS64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 199402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS64),
     /* 199405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199411 */     GIR_RootConstrainSelectedInstOperands,
     /* 199412 */     // GIR_Coverage, 5257,
     /* 199412 */     GIR_EraseRootFromParent_Done,
     /* 199413 */   // Label 3726: @199413
     /* 199413 */   GIM_Try, /*On fail goto*//*Label 3727*/ GIMT_Encode4(199458), // Rule ID 5258 //
     /* 199418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 199426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199447 */     // (intrinsic_wo_chain:{ *:[i64] } 701:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 199447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i64),
     /* 199450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199454 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199456 */     GIR_RootConstrainSelectedInstOperands,
     /* 199457 */     // GIR_Coverage, 5258,
     /* 199457 */     GIR_EraseRootFromParent_Done,
     /* 199458 */   // Label 3727: @199458
     /* 199458 */   GIM_Try, /*On fail goto*//*Label 3728*/ GIMT_Encode4(199503), // Rule ID 5259 //
     /* 199463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 199471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 199474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 199477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 199480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199492 */     // (intrinsic_wo_chain:{ *:[i32] } 701:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 199492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i32),
     /* 199495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199499 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199501 */     GIR_RootConstrainSelectedInstOperands,
     /* 199502 */     // GIR_Coverage, 5259,
     /* 199502 */     GIR_EraseRootFromParent_Done,
     /* 199503 */   // Label 3728: @199503
     /* 199503 */   GIM_Try, /*On fail goto*//*Label 3729*/ GIMT_Encode4(199548), // Rule ID 5260 //
     /* 199508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 199516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199537 */     // (intrinsic_wo_chain:{ *:[i64] } 704:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 199537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i64),
     /* 199540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199546 */     GIR_RootConstrainSelectedInstOperands,
     /* 199547 */     // GIR_Coverage, 5260,
     /* 199547 */     GIR_EraseRootFromParent_Done,
     /* 199548 */   // Label 3729: @199548
     /* 199548 */   GIM_Try, /*On fail goto*//*Label 3730*/ GIMT_Encode4(199593), // Rule ID 5261 //
     /* 199553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 199561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 199564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 199567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 199570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199582 */     // (intrinsic_wo_chain:{ *:[i32] } 704:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 199582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i32),
     /* 199585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199591 */     GIR_RootConstrainSelectedInstOperands,
     /* 199592 */     // GIR_Coverage, 5261,
     /* 199592 */     GIR_EraseRootFromParent_Done,
     /* 199593 */   // Label 3730: @199593
     /* 199593 */   GIM_Try, /*On fail goto*//*Label 3731*/ GIMT_Encode4(199638), // Rule ID 5262 //
     /* 199598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 199606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199627 */     // (intrinsic_wo_chain:{ *:[i64] } 708:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQSUBv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 199627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i64),
     /* 199630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199636 */     GIR_RootConstrainSelectedInstOperands,
     /* 199637 */     // GIR_Coverage, 5262,
     /* 199637 */     GIR_EraseRootFromParent_Done,
     /* 199638 */   // Label 3731: @199638
     /* 199638 */   GIM_Try, /*On fail goto*//*Label 3732*/ GIMT_Encode4(199683), // Rule ID 5263 //
     /* 199643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 199651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 199654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 199657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 199660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199672 */     // (intrinsic_wo_chain:{ *:[i32] } 708:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQSUBv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 199672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i32),
     /* 199675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199679 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199681 */     GIR_RootConstrainSelectedInstOperands,
     /* 199682 */     // GIR_Coverage, 5263,
     /* 199682 */     GIR_EraseRootFromParent_Done,
     /* 199683 */   // Label 3732: @199683
     /* 199683 */   GIM_Try, /*On fail goto*//*Label 3733*/ GIMT_Encode4(199728), // Rule ID 5264 //
     /* 199688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 199696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199717 */     // (intrinsic_wo_chain:{ *:[i64] } 749:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 199717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i64),
     /* 199720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199726 */     GIR_RootConstrainSelectedInstOperands,
     /* 199727 */     // GIR_Coverage, 5264,
     /* 199727 */     GIR_EraseRootFromParent_Done,
     /* 199728 */   // Label 3733: @199728
     /* 199728 */   GIM_Try, /*On fail goto*//*Label 3734*/ GIMT_Encode4(199773), // Rule ID 5265 //
     /* 199733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 199741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 199744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 199747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 199750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199762 */     // (intrinsic_wo_chain:{ *:[i32] } 749:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 199762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i32),
     /* 199765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199771 */     GIR_RootConstrainSelectedInstOperands,
     /* 199772 */     // GIR_Coverage, 5265,
     /* 199772 */     GIR_EraseRootFromParent_Done,
     /* 199773 */   // Label 3734: @199773
     /* 199773 */   GIM_Try, /*On fail goto*//*Label 3735*/ GIMT_Encode4(199818), // Rule ID 5266 //
     /* 199778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 199786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199807 */     // (intrinsic_wo_chain:{ *:[i64] } 750:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 199807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i64),
     /* 199810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199816 */     GIR_RootConstrainSelectedInstOperands,
     /* 199817 */     // GIR_Coverage, 5266,
     /* 199817 */     GIR_EraseRootFromParent_Done,
     /* 199818 */   // Label 3735: @199818
     /* 199818 */   GIM_Try, /*On fail goto*//*Label 3736*/ GIMT_Encode4(199863), // Rule ID 5267 //
     /* 199823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 199831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 199834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 199837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 199840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199852 */     // (intrinsic_wo_chain:{ *:[i32] } 750:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQRSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 199852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i32),
     /* 199855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199861 */     GIR_RootConstrainSelectedInstOperands,
     /* 199862 */     // GIR_Coverage, 5267,
     /* 199862 */     GIR_EraseRootFromParent_Done,
     /* 199863 */   // Label 3736: @199863
     /* 199863 */   GIM_Try, /*On fail goto*//*Label 3737*/ GIMT_Encode4(199908), // Rule ID 5268 //
     /* 199868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 199876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199897 */     // (intrinsic_wo_chain:{ *:[i64] } 752:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 199897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i64),
     /* 199900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199904 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199906 */     GIR_RootConstrainSelectedInstOperands,
     /* 199907 */     // GIR_Coverage, 5268,
     /* 199907 */     GIR_EraseRootFromParent_Done,
     /* 199908 */   // Label 3737: @199908
     /* 199908 */   GIM_Try, /*On fail goto*//*Label 3738*/ GIMT_Encode4(199953), // Rule ID 5269 //
     /* 199913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 199921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 199924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 199927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 199930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199942 */     // (intrinsic_wo_chain:{ *:[i32] } 752:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 199942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i32),
     /* 199945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199951 */     GIR_RootConstrainSelectedInstOperands,
     /* 199952 */     // GIR_Coverage, 5269,
     /* 199952 */     GIR_EraseRootFromParent_Done,
     /* 199953 */   // Label 3738: @199953
     /* 199953 */   GIM_Try, /*On fail goto*//*Label 3739*/ GIMT_Encode4(199998), // Rule ID 5270 //
     /* 199958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 199966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199987 */     // (intrinsic_wo_chain:{ *:[i64] } 754:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQSUBv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 199987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i64),
     /* 199990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199996 */     GIR_RootConstrainSelectedInstOperands,
     /* 199997 */     // GIR_Coverage, 5270,
     /* 199997 */     GIR_EraseRootFromParent_Done,
     /* 199998 */   // Label 3739: @199998
     /* 199998 */   GIM_Try, /*On fail goto*//*Label 3740*/ GIMT_Encode4(200043), // Rule ID 5271 //
     /* 200003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 200006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 200011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 200014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 200017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 200020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200032 */     // (intrinsic_wo_chain:{ *:[i32] } 754:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQSUBv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 200032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i32),
     /* 200035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 200041 */     GIR_RootConstrainSelectedInstOperands,
     /* 200042 */     // GIR_Coverage, 5271,
     /* 200042 */     GIR_EraseRootFromParent_Done,
     /* 200043 */   // Label 3740: @200043
     /* 200043 */   GIM_Try, /*On fail goto*//*Label 3741*/ GIMT_Encode4(200088), // Rule ID 5290 //
     /* 200048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 200051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 200056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 200065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200077 */     // (intrinsic_wo_chain:{ *:[v1i64] } 764:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)  =>  (USQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)
     /* 200077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i64),
     /* 200080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 200086 */     GIR_RootConstrainSelectedInstOperands,
     /* 200087 */     // GIR_Coverage, 5290,
     /* 200087 */     GIR_EraseRootFromParent_Done,
     /* 200088 */   // Label 3741: @200088
     /* 200088 */   GIM_Try, /*On fail goto*//*Label 3742*/ GIMT_Encode4(200130), // Rule ID 5624 //
     /* 200093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbl1),
     /* 200098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 200101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 200104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 200107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200119 */     // (intrinsic_wo_chain:{ *:[v8i8] } 726:{ *:[iPTR] }, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)  =>  (TBLv8i8One:{ *:[v8i8] } VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)
     /* 200119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLv8i8One),
     /* 200122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 200124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ri
     /* 200128 */     GIR_RootConstrainSelectedInstOperands,
     /* 200129 */     // GIR_Coverage, 5624,
     /* 200129 */     GIR_EraseRootFromParent_Done,
     /* 200130 */   // Label 3742: @200130
     /* 200130 */   GIM_Try, /*On fail goto*//*Label 3743*/ GIMT_Encode4(200172), // Rule ID 5625 //
     /* 200135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbl1),
     /* 200140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 200143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 200146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 200149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200161 */     // (intrinsic_wo_chain:{ *:[v16i8] } 726:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)  =>  (TBLv16i8One:{ *:[v16i8] } V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)
     /* 200161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLv16i8One),
     /* 200164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 200166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ri
     /* 200168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 200170 */     GIR_RootConstrainSelectedInstOperands,
     /* 200171 */     // GIR_Coverage, 5625,
     /* 200171 */     GIR_EraseRootFromParent_Done,
     /* 200172 */   // Label 3743: @200172
     /* 200172 */   GIM_Try, /*On fail goto*//*Label 3744*/ GIMT_Encode4(200269), // Rule ID 6352 //
     /* 200177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 200182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 200185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 200188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 200191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 200199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 200203 */     // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FACGE16:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm), hsub:{ *:[i32] })
     /* 200203 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 200206 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FACGE16),
     /* 200210 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200215 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 200219 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 200223 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 200225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 200228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 200232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 200239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 200242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 200247 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 200250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 200253 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200258 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200263 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 200268 */     // GIR_Coverage, 6352,
     /* 200268 */     GIR_EraseRootFromParent_Done,
     /* 200269 */   // Label 3744: @200269
     /* 200269 */   GIM_Try, /*On fail goto*//*Label 3745*/ GIMT_Encode4(200366), // Rule ID 6353 //
     /* 200274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 200279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 200282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 200285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 200288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 200296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 200300 */     // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FACGT16:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm), hsub:{ *:[i32] })
     /* 200300 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 200303 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FACGT16),
     /* 200307 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200312 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 200316 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 200320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 200322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 200325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 200329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 200336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 200339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 200344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 200347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 200350 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200355 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200360 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 200365 */     // GIR_Coverage, 6353,
     /* 200365 */     GIR_EraseRootFromParent_Done,
     /* 200366 */   // Label 3745: @200366
     /* 200366 */   GIM_Try, /*On fail goto*//*Label 3746*/ GIMT_Encode4(200408), // Rule ID 7008 //
     /* 200371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 200376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 200385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200397 */     // (intrinsic_wo_chain:{ *:[i64] } 713:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 200397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv1i64),
     /* 200400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 200406 */     GIR_RootConstrainSelectedInstOperands,
     /* 200407 */     // GIR_Coverage, 7008,
     /* 200407 */     GIR_EraseRootFromParent_Done,
     /* 200408 */   // Label 3746: @200408
     /* 200408 */   GIM_Try, /*On fail goto*//*Label 3747*/ GIMT_Encode4(200450), // Rule ID 7009 //
     /* 200413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 200418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 200427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200439 */     // (intrinsic_wo_chain:{ *:[i64] } 761:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (USHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 200439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv1i64),
     /* 200442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 200448 */     GIR_RootConstrainSelectedInstOperands,
     /* 200449 */     // GIR_Coverage, 7009,
     /* 200449 */     GIR_EraseRootFromParent_Done,
     /* 200450 */   // Label 3747: @200450
     /* 200450 */   GIM_Try, /*On fail goto*//*Label 3748*/ GIMT_Encode4(200492), // Rule ID 7010 //
     /* 200455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 200460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 200469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200481 */     // (intrinsic_wo_chain:{ *:[i64] } 712:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 200481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv1i64),
     /* 200484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 200490 */     GIR_RootConstrainSelectedInstOperands,
     /* 200491 */     // GIR_Coverage, 7010,
     /* 200491 */     GIR_EraseRootFromParent_Done,
     /* 200492 */   // Label 3748: @200492
     /* 200492 */   GIM_Try, /*On fail goto*//*Label 3749*/ GIMT_Encode4(200534), // Rule ID 7011 //
     /* 200497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 200502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 200511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200523 */     // (intrinsic_wo_chain:{ *:[i64] } 758:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (URSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 200523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv1i64),
     /* 200526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 200532 */     GIR_RootConstrainSelectedInstOperands,
     /* 200533 */     // GIR_Coverage, 7011,
     /* 200533 */     GIR_EraseRootFromParent_Done,
     /* 200534 */   // Label 3749: @200534
     /* 200534 */   GIM_Try, /*On fail goto*//*Label 3750*/ GIMT_Encode4(200582), // Rule ID 7051 //
     /* 200539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_blend),
     /* 200544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 200553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200565 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, GPR64:{ *:[i64] }:$Rn)  =>  (BFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64:{ *:[i64] }:$Rn, 16:{ *:[i64] }, 15:{ *:[i64] })
     /* 200565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMXri),
     /* 200568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200572 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 200574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 200577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 200580 */     GIR_RootConstrainSelectedInstOperands,
     /* 200581 */     // GIR_Coverage, 7051,
     /* 200581 */     GIR_EraseRootFromParent_Done,
     /* 200582 */   // Label 3750: @200582
     /* 200582 */   GIM_Try, /*On fail goto*//*Label 3751*/ GIMT_Encode4(200627), // Rule ID 10140 //
     /* 200587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 200595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 200604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200616 */     // (intrinsic_wo_chain:{ *:[i64] } 2036:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQINCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 200616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_B),
     /* 200619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 200623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200625 */     GIR_RootConstrainSelectedInstOperands,
     /* 200626 */     // GIR_Coverage, 10140,
     /* 200626 */     GIR_EraseRootFromParent_Done,
     /* 200627 */   // Label 3751: @200627
     /* 200627 */   GIM_Try, /*On fail goto*//*Label 3752*/ GIMT_Encode4(200672), // Rule ID 10141 //
     /* 200632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 200640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 200649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200661 */     // (intrinsic_wo_chain:{ *:[i64] } 2036:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQINCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 200661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_H),
     /* 200664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 200668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200670 */     GIR_RootConstrainSelectedInstOperands,
     /* 200671 */     // GIR_Coverage, 10141,
     /* 200671 */     GIR_EraseRootFromParent_Done,
     /* 200672 */   // Label 3752: @200672
     /* 200672 */   GIM_Try, /*On fail goto*//*Label 3753*/ GIMT_Encode4(200717), // Rule ID 10142 //
     /* 200677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 200685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 200694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200706 */     // (intrinsic_wo_chain:{ *:[i64] } 2036:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQINCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 200706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_S),
     /* 200709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 200713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200715 */     GIR_RootConstrainSelectedInstOperands,
     /* 200716 */     // GIR_Coverage, 10142,
     /* 200716 */     GIR_EraseRootFromParent_Done,
     /* 200717 */   // Label 3753: @200717
     /* 200717 */   GIM_Try, /*On fail goto*//*Label 3754*/ GIMT_Encode4(200762), // Rule ID 10143 //
     /* 200722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 200730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 200739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200751 */     // (intrinsic_wo_chain:{ *:[i64] } 2036:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQINCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 200751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_D),
     /* 200754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 200758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200760 */     GIR_RootConstrainSelectedInstOperands,
     /* 200761 */     // GIR_Coverage, 10143,
     /* 200761 */     GIR_EraseRootFromParent_Done,
     /* 200762 */   // Label 3754: @200762
     /* 200762 */   GIM_Try, /*On fail goto*//*Label 3755*/ GIMT_Encode4(200807), // Rule ID 10152 //
     /* 200767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 200775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 200784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200796 */     // (intrinsic_wo_chain:{ *:[i64] } 1791:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (SQDECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 200796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_B),
     /* 200799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200801 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 200803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200805 */     GIR_RootConstrainSelectedInstOperands,
     /* 200806 */     // GIR_Coverage, 10152,
     /* 200806 */     GIR_EraseRootFromParent_Done,
     /* 200807 */   // Label 3755: @200807
     /* 200807 */   GIM_Try, /*On fail goto*//*Label 3756*/ GIMT_Encode4(200852), // Rule ID 10153 //
     /* 200812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 200820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 200829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200841 */     // (intrinsic_wo_chain:{ *:[i64] } 1791:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (SQDECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 200841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_H),
     /* 200844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200846 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 200848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200850 */     GIR_RootConstrainSelectedInstOperands,
     /* 200851 */     // GIR_Coverage, 10153,
     /* 200851 */     GIR_EraseRootFromParent_Done,
     /* 200852 */   // Label 3756: @200852
     /* 200852 */   GIM_Try, /*On fail goto*//*Label 3757*/ GIMT_Encode4(200897), // Rule ID 10154 //
     /* 200857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 200865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 200874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200886 */     // (intrinsic_wo_chain:{ *:[i64] } 1791:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (SQDECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 200886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_S),
     /* 200889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200891 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 200893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200895 */     GIR_RootConstrainSelectedInstOperands,
     /* 200896 */     // GIR_Coverage, 10154,
     /* 200896 */     GIR_EraseRootFromParent_Done,
     /* 200897 */   // Label 3757: @200897
     /* 200897 */   GIM_Try, /*On fail goto*//*Label 3758*/ GIMT_Encode4(200942), // Rule ID 10155 //
     /* 200902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 200910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 200919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200931 */     // (intrinsic_wo_chain:{ *:[i64] } 1791:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (SQDECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 200931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_D),
     /* 200934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 200938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200940 */     GIR_RootConstrainSelectedInstOperands,
     /* 200941 */     // GIR_Coverage, 10155,
     /* 200941 */     GIR_EraseRootFromParent_Done,
     /* 200942 */   // Label 3758: @200942
     /* 200942 */   GIM_Try, /*On fail goto*//*Label 3759*/ GIMT_Encode4(200987), // Rule ID 10156 //
     /* 200947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 200955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 200958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 200961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 200964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200976 */     // (intrinsic_wo_chain:{ *:[i32] } 2021:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQDECP_WP_B:{ *:[i32] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 200976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_B),
     /* 200979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200981 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 200983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200985 */     GIR_RootConstrainSelectedInstOperands,
     /* 200986 */     // GIR_Coverage, 10156,
     /* 200986 */     GIR_EraseRootFromParent_Done,
     /* 200987 */   // Label 3759: @200987
     /* 200987 */   GIM_Try, /*On fail goto*//*Label 3760*/ GIMT_Encode4(201032), // Rule ID 10157 //
     /* 200992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 201000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 201009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201021 */     // (intrinsic_wo_chain:{ *:[i32] } 2021:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQDECP_WP_H:{ *:[i32] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 201021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_H),
     /* 201024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 201028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201030 */     GIR_RootConstrainSelectedInstOperands,
     /* 201031 */     // GIR_Coverage, 10157,
     /* 201031 */     GIR_EraseRootFromParent_Done,
     /* 201032 */   // Label 3760: @201032
     /* 201032 */   GIM_Try, /*On fail goto*//*Label 3761*/ GIMT_Encode4(201077), // Rule ID 10158 //
     /* 201037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 201045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 201054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201066 */     // (intrinsic_wo_chain:{ *:[i32] } 2021:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQDECP_WP_S:{ *:[i32] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 201066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_S),
     /* 201069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201071 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 201073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201075 */     GIR_RootConstrainSelectedInstOperands,
     /* 201076 */     // GIR_Coverage, 10158,
     /* 201076 */     GIR_EraseRootFromParent_Done,
     /* 201077 */   // Label 3761: @201077
     /* 201077 */   GIM_Try, /*On fail goto*//*Label 3762*/ GIMT_Encode4(201122), // Rule ID 10159 //
     /* 201082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 201090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 201099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201111 */     // (intrinsic_wo_chain:{ *:[i32] } 2021:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQDECP_WP_D:{ *:[i32] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 201111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_D),
     /* 201114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 201118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201120 */     GIR_RootConstrainSelectedInstOperands,
     /* 201121 */     // GIR_Coverage, 10159,
     /* 201121 */     GIR_EraseRootFromParent_Done,
     /* 201122 */   // Label 3762: @201122
     /* 201122 */   GIM_Try, /*On fail goto*//*Label 3763*/ GIMT_Encode4(201167), // Rule ID 10160 //
     /* 201127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 201135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201156 */     // (intrinsic_wo_chain:{ *:[i64] } 2022:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQDECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 201156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_B),
     /* 201159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 201163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201165 */     GIR_RootConstrainSelectedInstOperands,
     /* 201166 */     // GIR_Coverage, 10160,
     /* 201166 */     GIR_EraseRootFromParent_Done,
     /* 201167 */   // Label 3763: @201167
     /* 201167 */   GIM_Try, /*On fail goto*//*Label 3764*/ GIMT_Encode4(201212), // Rule ID 10161 //
     /* 201172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 201180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 201189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201201 */     // (intrinsic_wo_chain:{ *:[i64] } 2022:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQDECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 201201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_H),
     /* 201204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 201208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201210 */     GIR_RootConstrainSelectedInstOperands,
     /* 201211 */     // GIR_Coverage, 10161,
     /* 201211 */     GIR_EraseRootFromParent_Done,
     /* 201212 */   // Label 3764: @201212
     /* 201212 */   GIM_Try, /*On fail goto*//*Label 3765*/ GIMT_Encode4(201257), // Rule ID 10162 //
     /* 201217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 201225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 201234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201246 */     // (intrinsic_wo_chain:{ *:[i64] } 2022:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQDECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 201246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_S),
     /* 201249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 201253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201255 */     GIR_RootConstrainSelectedInstOperands,
     /* 201256 */     // GIR_Coverage, 10162,
     /* 201256 */     GIR_EraseRootFromParent_Done,
     /* 201257 */   // Label 3765: @201257
     /* 201257 */   GIM_Try, /*On fail goto*//*Label 3766*/ GIMT_Encode4(201302), // Rule ID 10163 //
     /* 201262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 201270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 201279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201291 */     // (intrinsic_wo_chain:{ *:[i64] } 2022:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQDECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 201291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_D),
     /* 201294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 201298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201300 */     GIR_RootConstrainSelectedInstOperands,
     /* 201301 */     // GIR_Coverage, 10163,
     /* 201301 */     GIR_EraseRootFromParent_Done,
     /* 201302 */   // Label 3766: @201302
     /* 201302 */   GIM_Try, /*On fail goto*//*Label 3767*/ GIMT_Encode4(201348), // Rule ID 138 //
     /* 201307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 201310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_gmi),
     /* 201315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 201321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201325 */     // MIs[0] Rn
     /* 201325 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 201329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 201333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201337 */     // (intrinsic_wo_chain:{ *:[i64] } 565:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (GMI:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 201337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::GMI),
     /* 201340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201346 */     GIR_RootConstrainSelectedInstOperands,
     /* 201347 */     // GIR_Coverage, 138,
     /* 201347 */     GIR_EraseRootFromParent_Done,
     /* 201348 */   // Label 3767: @201348
     /* 201348 */   GIM_Try, /*On fail goto*//*Label 3768*/ GIMT_Encode4(201395), // Rule ID 139 //
     /* 201353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 201356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_subp),
     /* 201361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201368 */     // MIs[0] Rn
     /* 201368 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 201372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 201376 */     // MIs[0] Rm
     /* 201376 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 201380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 201384 */     // (intrinsic_wo_chain:{ *:[i64] } 1252:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)  =>  (SUBP:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)
     /* 201384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBP),
     /* 201387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201393 */     GIR_RootConstrainSelectedInstOperands,
     /* 201394 */     // GIR_Coverage, 139,
     /* 201394 */     GIR_EraseRootFromParent_Done,
     /* 201395 */   // Label 3768: @201395
     /* 201395 */   GIM_Try, /*On fail goto*//*Label 3769*/ GIMT_Encode4(201432), // Rule ID 2399 //
     /* 201400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b16),
     /* 201408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201421 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2161:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_H),
     /* 201424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201430 */     GIR_RootConstrainSelectedInstOperands,
     /* 201431 */     // GIR_Coverage, 2399,
     /* 201431 */     GIR_EraseRootFromParent_Done,
     /* 201432 */   // Label 3769: @201432
     /* 201432 */   GIM_Try, /*On fail goto*//*Label 3770*/ GIMT_Encode4(201469), // Rule ID 2400 //
     /* 201437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b32),
     /* 201445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201458 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2162:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_S),
     /* 201461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201467 */     GIR_RootConstrainSelectedInstOperands,
     /* 201468 */     // GIR_Coverage, 2400,
     /* 201468 */     GIR_EraseRootFromParent_Done,
     /* 201469 */   // Label 3770: @201469
     /* 201469 */   GIM_Try, /*On fail goto*//*Label 3771*/ GIMT_Encode4(201506), // Rule ID 2401 //
     /* 201474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b64),
     /* 201482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201495 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2163:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_D),
     /* 201498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201502 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201504 */     GIR_RootConstrainSelectedInstOperands,
     /* 201505 */     // GIR_Coverage, 2401,
     /* 201505 */     GIR_EraseRootFromParent_Done,
     /* 201506 */   // Label 3771: @201506
     /* 201506 */   GIM_Try, /*On fail goto*//*Label 3772*/ GIMT_Encode4(201543), // Rule ID 2403 //
     /* 201511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b16),
     /* 201519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201532 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2166:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_H),
     /* 201535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201541 */     GIR_RootConstrainSelectedInstOperands,
     /* 201542 */     // GIR_Coverage, 2403,
     /* 201542 */     GIR_EraseRootFromParent_Done,
     /* 201543 */   // Label 3772: @201543
     /* 201543 */   GIM_Try, /*On fail goto*//*Label 3773*/ GIMT_Encode4(201580), // Rule ID 2404 //
     /* 201548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b32),
     /* 201556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201569 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2167:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_S),
     /* 201572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201576 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201578 */     GIR_RootConstrainSelectedInstOperands,
     /* 201579 */     // GIR_Coverage, 2404,
     /* 201579 */     GIR_EraseRootFromParent_Done,
     /* 201580 */   // Label 3773: @201580
     /* 201580 */   GIM_Try, /*On fail goto*//*Label 3774*/ GIMT_Encode4(201617), // Rule ID 2405 //
     /* 201585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b64),
     /* 201593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201606 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2168:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_D),
     /* 201609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201615 */     GIR_RootConstrainSelectedInstOperands,
     /* 201616 */     // GIR_Coverage, 2405,
     /* 201616 */     GIR_EraseRootFromParent_Done,
     /* 201617 */   // Label 3774: @201617
     /* 201617 */   GIM_Try, /*On fail goto*//*Label 3775*/ GIMT_Encode4(201654), // Rule ID 2407 //
     /* 201622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b16),
     /* 201630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201643 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2087:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /* 201646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201652 */     GIR_RootConstrainSelectedInstOperands,
     /* 201653 */     // GIR_Coverage, 2407,
     /* 201653 */     GIR_EraseRootFromParent_Done,
     /* 201654 */   // Label 3775: @201654
     /* 201654 */   GIM_Try, /*On fail goto*//*Label 3776*/ GIMT_Encode4(201691), // Rule ID 2408 //
     /* 201659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b32),
     /* 201667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201680 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2088:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /* 201683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201687 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201689 */     GIR_RootConstrainSelectedInstOperands,
     /* 201690 */     // GIR_Coverage, 2408,
     /* 201690 */     GIR_EraseRootFromParent_Done,
     /* 201691 */   // Label 3776: @201691
     /* 201691 */   GIM_Try, /*On fail goto*//*Label 3777*/ GIMT_Encode4(201728), // Rule ID 2409 //
     /* 201696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b64),
     /* 201704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201717 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2089:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /* 201720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201726 */     GIR_RootConstrainSelectedInstOperands,
     /* 201727 */     // GIR_Coverage, 2409,
     /* 201727 */     GIR_EraseRootFromParent_Done,
     /* 201728 */   // Label 3777: @201728
     /* 201728 */   GIM_Try, /*On fail goto*//*Label 3778*/ GIMT_Encode4(201765), // Rule ID 2411 //
     /* 201733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b16),
     /* 201741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201754 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2092:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_H),
     /* 201757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201763 */     GIR_RootConstrainSelectedInstOperands,
     /* 201764 */     // GIR_Coverage, 2411,
     /* 201764 */     GIR_EraseRootFromParent_Done,
     /* 201765 */   // Label 3778: @201765
     /* 201765 */   GIM_Try, /*On fail goto*//*Label 3779*/ GIMT_Encode4(201802), // Rule ID 2412 //
     /* 201770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b32),
     /* 201778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201791 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2093:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_S),
     /* 201794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201800 */     GIR_RootConstrainSelectedInstOperands,
     /* 201801 */     // GIR_Coverage, 2412,
     /* 201801 */     GIR_EraseRootFromParent_Done,
     /* 201802 */   // Label 3779: @201802
     /* 201802 */   GIM_Try, /*On fail goto*//*Label 3780*/ GIMT_Encode4(201839), // Rule ID 2413 //
     /* 201807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b64),
     /* 201815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201828 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2094:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_D),
     /* 201831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201837 */     GIR_RootConstrainSelectedInstOperands,
     /* 201838 */     // GIR_Coverage, 2413,
     /* 201838 */     GIR_EraseRootFromParent_Done,
     /* 201839 */   // Label 3780: @201839
     /* 201839 */   GIM_Try, /*On fail goto*//*Label 3781*/ GIMT_Encode4(201876), // Rule ID 2415 //
     /* 201844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b16),
     /* 201852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201865 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1931:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_H),
     /* 201868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201874 */     GIR_RootConstrainSelectedInstOperands,
     /* 201875 */     // GIR_Coverage, 2415,
     /* 201875 */     GIR_EraseRootFromParent_Done,
     /* 201876 */   // Label 3781: @201876
     /* 201876 */   GIM_Try, /*On fail goto*//*Label 3782*/ GIMT_Encode4(201913), // Rule ID 2416 //
     /* 201881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b32),
     /* 201889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201902 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1932:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_S),
     /* 201905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201911 */     GIR_RootConstrainSelectedInstOperands,
     /* 201912 */     // GIR_Coverage, 2416,
     /* 201912 */     GIR_EraseRootFromParent_Done,
     /* 201913 */   // Label 3782: @201913
     /* 201913 */   GIM_Try, /*On fail goto*//*Label 3783*/ GIMT_Encode4(201950), // Rule ID 2417 //
     /* 201918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b64),
     /* 201926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201939 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1933:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_D),
     /* 201942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201946 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201948 */     GIR_RootConstrainSelectedInstOperands,
     /* 201949 */     // GIR_Coverage, 2417,
     /* 201949 */     GIR_EraseRootFromParent_Done,
     /* 201950 */   // Label 3783: @201950
     /* 201950 */   GIM_Try, /*On fail goto*//*Label 3784*/ GIMT_Encode4(201987), // Rule ID 2419 //
     /* 201955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b16),
     /* 201963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201976 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1936:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_H),
     /* 201979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201985 */     GIR_RootConstrainSelectedInstOperands,
     /* 201986 */     // GIR_Coverage, 2419,
     /* 201986 */     GIR_EraseRootFromParent_Done,
     /* 201987 */   // Label 3784: @201987
     /* 201987 */   GIM_Try, /*On fail goto*//*Label 3785*/ GIMT_Encode4(202024), // Rule ID 2420 //
     /* 201992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b32),
     /* 202000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 202003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 202006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 202009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202013 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1937:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 202013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_S),
     /* 202016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 202018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 202020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 202022 */     GIR_RootConstrainSelectedInstOperands,
     /* 202023 */     // GIR_Coverage, 2420,
     /* 202023 */     GIR_EraseRootFromParent_Done,
     /* 202024 */   // Label 3785: @202024
     /* 202024 */   GIM_Try, /*On fail goto*//*Label 3786*/ GIMT_Encode4(202061), // Rule ID 2421 //
     /* 202029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b64),
     /* 202037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 202040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 202043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 202046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202050 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1938:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 202050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_D),
     /* 202053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 202055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 202057 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 202059 */     GIR_RootConstrainSelectedInstOperands,
     /* 202060 */     // GIR_Coverage, 2421,
     /* 202060 */     GIR_EraseRootFromParent_Done,
     /* 202061 */   // Label 3786: @202061
     /* 202061 */   GIM_Try, /*On fail goto*//*Label 3787*/ GIMT_Encode4(202098), // Rule ID 2422 //
     /* 202066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 202069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histseg),
     /* 202074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 202077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 202080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 202083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202087 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1556:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (HISTSEG_ZZZ:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)
     /* 202087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTSEG_ZZZ),
     /* 202090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 202094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 202096 */     GIR_RootConstrainSelectedInstOperands,
     /* 202097 */     // GIR_Coverage, 2422,
     /* 202097 */     GIR_EraseRootFromParent_Done,
     /* 202098 */   // Label 3787: @202098
     /* 202098 */   GIM_Try, /*On fail goto*//*Label 3788*/ GIMT_Encode4(202138), // Rule ID 2617 //
     /* 202103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pfirst),
     /* 202111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 202114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 202117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 202120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202124 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1635:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (PFIRST_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 202124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PFIRST_B),
     /* 202127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 202129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202133 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 202136 */     GIR_RootConstrainSelectedInstOperands,
     /* 202137 */     // GIR_Coverage, 2617,
     /* 202137 */     GIR_EraseRootFromParent_Done,
     /* 202138 */   // Label 3788: @202138
     /* 202138 */   GIM_Try, /*On fail goto*//*Label 3789*/ GIMT_Encode4(202178), // Rule ID 2618 //
     /* 202143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 202151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 202154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 202157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 202160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202164 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1643:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (PNEXT_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 202164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_B),
     /* 202167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 202169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202173 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 202176 */     GIR_RootConstrainSelectedInstOperands,
     /* 202177 */     // GIR_Coverage, 2618,
     /* 202177 */     GIR_EraseRootFromParent_Done,
     /* 202178 */   // Label 3789: @202178
     /* 202178 */   GIM_Try, /*On fail goto*//*Label 3790*/ GIMT_Encode4(202218), // Rule ID 2619 //
     /* 202183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 202191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 202194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 202197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 202200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202204 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1643:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (PNEXT_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 202204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_H),
     /* 202207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 202209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202211 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202213 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 202216 */     GIR_RootConstrainSelectedInstOperands,
     /* 202217 */     // GIR_Coverage, 2619,
     /* 202217 */     GIR_EraseRootFromParent_Done,
     /* 202218 */   // Label 3790: @202218
     /* 202218 */   GIM_Try, /*On fail goto*//*Label 3791*/ GIMT_Encode4(202258), // Rule ID 2620 //
     /* 202223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 202231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 202234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 202237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 202240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202244 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1643:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (PNEXT_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 202244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_S),
     /* 202247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 202249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202253 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 202256 */     GIR_RootConstrainSelectedInstOperands,
     /* 202257 */     // GIR_Coverage, 2620,
     /* 202257 */     GIR_EraseRootFromParent_Done,
     /* 202258 */   // Label 3791: @202258
     /* 202258 */   GIM_Try, /*On fail goto*//*Label 3792*/ GIMT_Encode4(202298), // Rule ID 2621 //
     /* 202263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 202271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 202274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 202277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 202280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202284 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1643:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (PNEXT_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 202284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_D),
     /* 202287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 202289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202291 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202293 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 202296 */     GIR_RootConstrainSelectedInstOperands,
     /* 202297 */     // GIR_Coverage, 2621,
     /* 202297 */     GIR_EraseRootFromParent_Done,
     /* 202298 */   // Label 3792: @202298
     /* 202298 */   GIM_Try, /*On fail goto*//*Label 3793*/ GIMT_Encode4(202335), // Rule ID 2638 //
     /* 202303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 202311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 202314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 202317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 202320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202324 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1823:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SQINCP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 202324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_H),
     /* 202327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202331 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202333 */     GIR_RootConstrainSelectedInstOperands,
     /* 202334 */     // GIR_Coverage, 2638,
     /* 202334 */     GIR_EraseRootFromParent_Done,
     /* 202335 */   // Label 3793: @202335
     /* 202335 */   GIM_Try, /*On fail goto*//*Label 3794*/ GIMT_Encode4(202372), // Rule ID 2639 //
     /* 202340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 202348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 202357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202361 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1823:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SQINCP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 202361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_S),
     /* 202364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202370 */     GIR_RootConstrainSelectedInstOperands,
     /* 202371 */     // GIR_Coverage, 2639,
     /* 202371 */     GIR_EraseRootFromParent_Done,
     /* 202372 */   // Label 3794: @202372
     /* 202372 */   GIM_Try, /*On fail goto*//*Label 3795*/ GIMT_Encode4(202409), // Rule ID 2640 //
     /* 202377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 202385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 202391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 202394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202398 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1823:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SQINCP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 202398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_D),
     /* 202401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202407 */     GIR_RootConstrainSelectedInstOperands,
     /* 202408 */     // GIR_Coverage, 2640,
     /* 202408 */     GIR_EraseRootFromParent_Done,
     /* 202409 */   // Label 3795: @202409
     /* 202409 */   GIM_Try, /*On fail goto*//*Label 3796*/ GIMT_Encode4(202446), // Rule ID 2641 //
     /* 202414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 202422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 202428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 202431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202435 */     // (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (CNTP_XPP_B:{ *:[i64] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 202435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_B),
     /* 202438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 202440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202442 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202444 */     GIR_RootConstrainSelectedInstOperands,
     /* 202445 */     // GIR_Coverage, 2641,
     /* 202445 */     GIR_EraseRootFromParent_Done,
     /* 202446 */   // Label 3796: @202446
     /* 202446 */   GIM_Try, /*On fail goto*//*Label 3797*/ GIMT_Encode4(202483), // Rule ID 2642 //
     /* 202451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 202459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 202465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 202468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202472 */     // (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (CNTP_XPP_H:{ *:[i64] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 202472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_H),
     /* 202475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 202477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202481 */     GIR_RootConstrainSelectedInstOperands,
     /* 202482 */     // GIR_Coverage, 2642,
     /* 202482 */     GIR_EraseRootFromParent_Done,
     /* 202483 */   // Label 3797: @202483
     /* 202483 */   GIM_Try, /*On fail goto*//*Label 3798*/ GIMT_Encode4(202520), // Rule ID 2643 //
     /* 202488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 202496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 202502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 202505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202509 */     // (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (CNTP_XPP_S:{ *:[i64] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 202509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_S),
     /* 202512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 202514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202518 */     GIR_RootConstrainSelectedInstOperands,
     /* 202519 */     // GIR_Coverage, 2643,
     /* 202519 */     GIR_EraseRootFromParent_Done,
     /* 202520 */   // Label 3798: @202520
     /* 202520 */   GIM_Try, /*On fail goto*//*Label 3799*/ GIMT_Encode4(202557), // Rule ID 2644 //
     /* 202525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 202533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 202539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 202542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202546 */     // (intrinsic_wo_chain:{ *:[i64] } 1345:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (CNTP_XPP_D:{ *:[i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 202546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_D),
     /* 202549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 202551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202555 */     GIR_RootConstrainSelectedInstOperands,
     /* 202556 */     // GIR_Coverage, 2644,
     /* 202556 */     GIR_EraseRootFromParent_Done,
     /* 202557 */   // Label 3799: @202557
     /* 202557 */   GIM_Try, /*On fail goto*//*Label 3800*/ GIMT_Encode4(202594), // Rule ID 2822 //
     /* 202562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 202565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 202570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 202573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 202576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 202579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202583 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1553:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (FTSMUL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 202583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_H),
     /* 202586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202592 */     GIR_RootConstrainSelectedInstOperands,
     /* 202593 */     // GIR_Coverage, 2822,
     /* 202593 */     GIR_EraseRootFromParent_Done,
     /* 202594 */   // Label 3800: @202594
     /* 202594 */   GIM_Try, /*On fail goto*//*Label 3801*/ GIMT_Encode4(202631), // Rule ID 2823 //
     /* 202599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 202602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 202607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 202616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202620 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1553:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (FTSMUL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 202620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_S),
     /* 202623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202629 */     GIR_RootConstrainSelectedInstOperands,
     /* 202630 */     // GIR_Coverage, 2823,
     /* 202630 */     GIR_EraseRootFromParent_Done,
     /* 202631 */   // Label 3801: @202631
     /* 202631 */   GIM_Try, /*On fail goto*//*Label 3802*/ GIMT_Encode4(202668), // Rule ID 2824 //
     /* 202636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 202639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 202644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 202650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 202653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202657 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1553:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (FTSMUL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 202657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_D),
     /* 202660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202666 */     GIR_RootConstrainSelectedInstOperands,
     /* 202667 */     // GIR_Coverage, 2824,
     /* 202667 */     GIR_EraseRootFromParent_Done,
     /* 202668 */   // Label 3802: @202668
     /* 202668 */   GIM_Try, /*On fail goto*//*Label 3803*/ GIMT_Encode4(202705), // Rule ID 3010 //
     /* 202673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 202681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 202684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 202687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 202690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202694 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1805:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 202694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_B),
     /* 202697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202701 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202703 */     GIR_RootConstrainSelectedInstOperands,
     /* 202704 */     // GIR_Coverage, 3010,
     /* 202704 */     GIR_EraseRootFromParent_Done,
     /* 202705 */   // Label 3803: @202705
     /* 202705 */   GIM_Try, /*On fail goto*//*Label 3804*/ GIMT_Encode4(202742), // Rule ID 3011 //
     /* 202710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 202718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 202721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 202724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 202727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202731 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1805:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 202731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_H),
     /* 202734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202740 */     GIR_RootConstrainSelectedInstOperands,
     /* 202741 */     // GIR_Coverage, 3011,
     /* 202741 */     GIR_EraseRootFromParent_Done,
     /* 202742 */   // Label 3804: @202742
     /* 202742 */   GIM_Try, /*On fail goto*//*Label 3805*/ GIMT_Encode4(202779), // Rule ID 3012 //
     /* 202747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 202755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 202764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202768 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1805:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 202768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_S),
     /* 202771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202777 */     GIR_RootConstrainSelectedInstOperands,
     /* 202778 */     // GIR_Coverage, 3012,
     /* 202778 */     GIR_EraseRootFromParent_Done,
     /* 202779 */   // Label 3805: @202779
     /* 202779 */   GIM_Try, /*On fail goto*//*Label 3806*/ GIMT_Encode4(202816), // Rule ID 3013 //
     /* 202784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 202792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 202798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 202801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202805 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1805:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQDMULH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 202805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_D),
     /* 202808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202812 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202814 */     GIR_RootConstrainSelectedInstOperands,
     /* 202815 */     // GIR_Coverage, 3013,
     /* 202815 */     GIR_EraseRootFromParent_Done,
     /* 202816 */   // Label 3806: @202816
     /* 202816 */   GIM_Try, /*On fail goto*//*Label 3807*/ GIMT_Encode4(202853), // Rule ID 3014 //
     /* 202821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmul),
     /* 202829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 202832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 202835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 202838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202842 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1640:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMUL_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 202842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMUL_ZZZ_B),
     /* 202845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202849 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202851 */     GIR_RootConstrainSelectedInstOperands,
     /* 202852 */     // GIR_Coverage, 3014,
     /* 202852 */     GIR_EraseRootFromParent_Done,
     /* 202853 */   // Label 3807: @202853
     /* 202853 */   GIM_Try, /*On fail goto*//*Label 3808*/ GIMT_Encode4(202890), // Rule ID 3036 //
     /* 202858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 202866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 202869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 202872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 202875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202879 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1698:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 202879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_H),
     /* 202882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202888 */     GIR_RootConstrainSelectedInstOperands,
     /* 202889 */     // GIR_Coverage, 3036,
     /* 202889 */     GIR_EraseRootFromParent_Done,
     /* 202890 */   // Label 3808: @202890
     /* 202890 */   GIM_Try, /*On fail goto*//*Label 3809*/ GIMT_Encode4(202927), // Rule ID 3037 //
     /* 202895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 202903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 202909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 202912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202916 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1698:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 202916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_S),
     /* 202919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202925 */     GIR_RootConstrainSelectedInstOperands,
     /* 202926 */     // GIR_Coverage, 3037,
     /* 202926 */     GIR_EraseRootFromParent_Done,
     /* 202927 */   // Label 3809: @202927
     /* 202927 */   GIM_Try, /*On fail goto*//*Label 3810*/ GIMT_Encode4(202964), // Rule ID 3038 //
     /* 202932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 202940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 202949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202953 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1698:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 202953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_D),
     /* 202956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202962 */     GIR_RootConstrainSelectedInstOperands,
     /* 202963 */     // GIR_Coverage, 3038,
     /* 202963 */     GIR_EraseRootFromParent_Done,
     /* 202964 */   // Label 3810: @202964
     /* 202964 */   GIM_Try, /*On fail goto*//*Label 3811*/ GIMT_Encode4(203001), // Rule ID 3042 //
     /* 202969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_AES_HasSVEAES),
     /* 202972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 202977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 202983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 202986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202990 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1641:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (PMULLB_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 202990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_Q),
     /* 202993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202999 */     GIR_RootConstrainSelectedInstOperands,
     /* 203000 */     // GIR_Coverage, 3042,
     /* 203000 */     GIR_EraseRootFromParent_Done,
     /* 203001 */   // Label 3811: @203001
     /* 203001 */   GIM_Try, /*On fail goto*//*Label 3812*/ GIMT_Encode4(203038), // Rule ID 3043 //
     /* 203006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 203014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 203017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 203020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 203023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203027 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1641:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMULLB_ZZZ_H:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 203027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_H),
     /* 203030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203036 */     GIR_RootConstrainSelectedInstOperands,
     /* 203037 */     // GIR_Coverage, 3043,
     /* 203037 */     GIR_EraseRootFromParent_Done,
     /* 203038 */   // Label 3812: @203038
     /* 203038 */   GIM_Try, /*On fail goto*//*Label 3813*/ GIMT_Encode4(203075), // Rule ID 3044 //
     /* 203043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 203051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203064 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1641:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (PMULLB_ZZZ_D:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 203064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_D),
     /* 203067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203071 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203073 */     GIR_RootConstrainSelectedInstOperands,
     /* 203074 */     // GIR_Coverage, 3044,
     /* 203074 */     GIR_EraseRootFromParent_Done,
     /* 203075 */   // Label 3813: @203075
     /* 203075 */   GIM_Try, /*On fail goto*//*Label 3814*/ GIMT_Encode4(203112), // Rule ID 3045 //
     /* 203080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 203083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 203088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 203091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 203094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 203097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203101 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1283:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BEXT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 203101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_B),
     /* 203104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203110 */     GIR_RootConstrainSelectedInstOperands,
     /* 203111 */     // GIR_Coverage, 3045,
     /* 203111 */     GIR_EraseRootFromParent_Done,
     /* 203112 */   // Label 3814: @203112
     /* 203112 */   GIM_Try, /*On fail goto*//*Label 3815*/ GIMT_Encode4(203149), // Rule ID 3046 //
     /* 203117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 203120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 203125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203138 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1283:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BEXT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 203138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_H),
     /* 203141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203147 */     GIR_RootConstrainSelectedInstOperands,
     /* 203148 */     // GIR_Coverage, 3046,
     /* 203148 */     GIR_EraseRootFromParent_Done,
     /* 203149 */   // Label 3815: @203149
     /* 203149 */   GIM_Try, /*On fail goto*//*Label 3816*/ GIMT_Encode4(203186), // Rule ID 3047 //
     /* 203154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 203157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 203162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203175 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1283:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BEXT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 203175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_S),
     /* 203178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203184 */     GIR_RootConstrainSelectedInstOperands,
     /* 203185 */     // GIR_Coverage, 3047,
     /* 203185 */     GIR_EraseRootFromParent_Done,
     /* 203186 */   // Label 3816: @203186
     /* 203186 */   GIM_Try, /*On fail goto*//*Label 3817*/ GIMT_Encode4(203223), // Rule ID 3048 //
     /* 203191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 203194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 203199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 203205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203212 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1283:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BEXT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 203212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_D),
     /* 203215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203221 */     GIR_RootConstrainSelectedInstOperands,
     /* 203222 */     // GIR_Coverage, 3048,
     /* 203222 */     GIR_EraseRootFromParent_Done,
     /* 203223 */   // Label 3817: @203223
     /* 203223 */   GIM_Try, /*On fail goto*//*Label 3818*/ GIMT_Encode4(203260), // Rule ID 3049 //
     /* 203228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 203236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 203242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 203245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203249 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1699:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 203249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_H),
     /* 203252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203258 */     GIR_RootConstrainSelectedInstOperands,
     /* 203259 */     // GIR_Coverage, 3049,
     /* 203259 */     GIR_EraseRootFromParent_Done,
     /* 203260 */   // Label 3818: @203260
     /* 203260 */   GIM_Try, /*On fail goto*//*Label 3819*/ GIMT_Encode4(203297), // Rule ID 3050 //
     /* 203265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 203273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203286 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1699:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 203286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_S),
     /* 203289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203295 */     GIR_RootConstrainSelectedInstOperands,
     /* 203296 */     // GIR_Coverage, 3050,
     /* 203296 */     GIR_EraseRootFromParent_Done,
     /* 203297 */   // Label 3819: @203297
     /* 203297 */   GIM_Try, /*On fail goto*//*Label 3820*/ GIMT_Encode4(203334), // Rule ID 3051 //
     /* 203302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 203310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203323 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1699:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 203323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_D),
     /* 203326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203332 */     GIR_RootConstrainSelectedInstOperands,
     /* 203333 */     // GIR_Coverage, 3051,
     /* 203333 */     GIR_EraseRootFromParent_Done,
     /* 203334 */   // Label 3820: @203334
     /* 203334 */   GIM_Try, /*On fail goto*//*Label 3821*/ GIMT_Encode4(203371), // Rule ID 3098 //
     /* 203339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 203347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 203350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203360 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1260:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADDHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 203360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_B),
     /* 203363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203369 */     GIR_RootConstrainSelectedInstOperands,
     /* 203370 */     // GIR_Coverage, 3098,
     /* 203370 */     GIR_EraseRootFromParent_Done,
     /* 203371 */   // Label 3821: @203371
     /* 203371 */   GIM_Try, /*On fail goto*//*Label 3822*/ GIMT_Encode4(203408), // Rule ID 3099 //
     /* 203376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 203384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203397 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1260:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADDHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 203397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_H),
     /* 203400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203406 */     GIR_RootConstrainSelectedInstOperands,
     /* 203407 */     // GIR_Coverage, 3099,
     /* 203407 */     GIR_EraseRootFromParent_Done,
     /* 203408 */   // Label 3822: @203408
     /* 203408 */   GIM_Try, /*On fail goto*//*Label 3823*/ GIMT_Encode4(203445), // Rule ID 3100 //
     /* 203413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 203421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 203427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203434 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1260:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADDHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 203434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_S),
     /* 203437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203441 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203443 */     GIR_RootConstrainSelectedInstOperands,
     /* 203444 */     // GIR_Coverage, 3100,
     /* 203444 */     GIR_EraseRootFromParent_Done,
     /* 203445 */   // Label 3823: @203445
     /* 203445 */   GIM_Try, /*On fail goto*//*Label 3824*/ GIMT_Encode4(203482), // Rule ID 3107 //
     /* 203450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 203458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 203461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 203464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203471 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1862:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQXTNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 203471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_B),
     /* 203474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203480 */     GIR_RootConstrainSelectedInstOperands,
     /* 203481 */     // GIR_Coverage, 3107,
     /* 203481 */     GIR_EraseRootFromParent_Done,
     /* 203482 */   // Label 3824: @203482
     /* 203482 */   GIM_Try, /*On fail goto*//*Label 3825*/ GIMT_Encode4(203519), // Rule ID 3108 //
     /* 203487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 203495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203508 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1862:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQXTNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 203508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_H),
     /* 203511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203517 */     GIR_RootConstrainSelectedInstOperands,
     /* 203518 */     // GIR_Coverage, 3108,
     /* 203518 */     GIR_EraseRootFromParent_Done,
     /* 203519 */   // Label 3825: @203519
     /* 203519 */   GIM_Try, /*On fail goto*//*Label 3826*/ GIMT_Encode4(203556), // Rule ID 3109 //
     /* 203524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 203532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203545 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1862:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQXTNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 203545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_S),
     /* 203548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203554 */     GIR_RootConstrainSelectedInstOperands,
     /* 203555 */     // GIR_Coverage, 3109,
     /* 203555 */     GIR_EraseRootFromParent_Done,
     /* 203556 */   // Label 3826: @203556
     /* 203556 */   GIM_Try, /*On fail goto*//*Label 3827*/ GIMT_Encode4(203596), // Rule ID 3213 //
     /* 203561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 203569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 203572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 203575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 203578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203582 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2142:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 203582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_B),
     /* 203585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203591 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 203594 */     GIR_RootConstrainSelectedInstOperands,
     /* 203595 */     // GIR_Coverage, 3213,
     /* 203595 */     GIR_EraseRootFromParent_Done,
     /* 203596 */   // Label 3827: @203596
     /* 203596 */   GIM_Try, /*On fail goto*//*Label 3828*/ GIMT_Encode4(203636), // Rule ID 3214 //
     /* 203601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 203609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 203612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 203615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 203618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203622 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2142:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 203622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_H),
     /* 203625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203631 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 203634 */     GIR_RootConstrainSelectedInstOperands,
     /* 203635 */     // GIR_Coverage, 3214,
     /* 203635 */     GIR_EraseRootFromParent_Done,
     /* 203636 */   // Label 3828: @203636
     /* 203636 */   GIM_Try, /*On fail goto*//*Label 3829*/ GIMT_Encode4(203676), // Rule ID 3215 //
     /* 203641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 203649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 203652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 203655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 203658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203662 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2142:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 203662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_S),
     /* 203665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203669 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203671 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 203674 */     GIR_RootConstrainSelectedInstOperands,
     /* 203675 */     // GIR_Coverage, 3215,
     /* 203675 */     GIR_EraseRootFromParent_Done,
     /* 203676 */   // Label 3829: @203676
     /* 203676 */   GIM_Try, /*On fail goto*//*Label 3830*/ GIMT_Encode4(203716), // Rule ID 3216 //
     /* 203681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 203689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 203692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 203695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 203698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203702 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2142:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 203702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_D),
     /* 203705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203711 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 203714 */     GIR_RootConstrainSelectedInstOperands,
     /* 203715 */     // GIR_Coverage, 3216,
     /* 203715 */     GIR_EraseRootFromParent_Done,
     /* 203716 */   // Label 3830: @203716
     /* 203716 */   GIM_Try, /*On fail goto*//*Label 3831*/ GIMT_Encode4(203756), // Rule ID 3221 //
     /* 203721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 203729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 203732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 203735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 203738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203742 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2142:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 203742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_B),
     /* 203745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203749 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203751 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 203754 */     GIR_RootConstrainSelectedInstOperands,
     /* 203755 */     // GIR_Coverage, 3221,
     /* 203755 */     GIR_EraseRootFromParent_Done,
     /* 203756 */   // Label 3831: @203756
     /* 203756 */   GIM_Try, /*On fail goto*//*Label 3832*/ GIMT_Encode4(203796), // Rule ID 3222 //
     /* 203761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 203769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 203772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 203775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 203778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203782 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2142:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 203782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_H),
     /* 203785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203791 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 203794 */     GIR_RootConstrainSelectedInstOperands,
     /* 203795 */     // GIR_Coverage, 3222,
     /* 203795 */     GIR_EraseRootFromParent_Done,
     /* 203796 */   // Label 3832: @203796
     /* 203796 */   GIM_Try, /*On fail goto*//*Label 3833*/ GIMT_Encode4(203836), // Rule ID 3223 //
     /* 203801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 203809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 203812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 203815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 203818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203822 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2142:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 203822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_S),
     /* 203825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203831 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 203834 */     GIR_RootConstrainSelectedInstOperands,
     /* 203835 */     // GIR_Coverage, 3223,
     /* 203835 */     GIR_EraseRootFromParent_Done,
     /* 203836 */   // Label 3833: @203836
     /* 203836 */   GIM_Try, /*On fail goto*//*Label 3834*/ GIMT_Encode4(203876), // Rule ID 3224 //
     /* 203841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 203849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 203852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 203855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 203858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203862 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2142:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 203862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_D),
     /* 203865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203869 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203871 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 203874 */     GIR_RootConstrainSelectedInstOperands,
     /* 203875 */     // GIR_Coverage, 3224,
     /* 203875 */     GIR_EraseRootFromParent_Done,
     /* 203876 */   // Label 3834: @203876
     /* 203876 */   GIM_Try, /*On fail goto*//*Label 3835*/ GIMT_Encode4(203913), // Rule ID 3413 //
     /* 203881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 203884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 203889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 203895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203902 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1351:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (COMPACT_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 203902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_S),
     /* 203905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203911 */     GIR_RootConstrainSelectedInstOperands,
     /* 203912 */     // GIR_Coverage, 3413,
     /* 203912 */     GIR_EraseRootFromParent_Done,
     /* 203913 */   // Label 3835: @203913
     /* 203913 */   GIM_Try, /*On fail goto*//*Label 3836*/ GIMT_Encode4(203950), // Rule ID 3414 //
     /* 203918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 203921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 203926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 203932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203939 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1351:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (COMPACT_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 203939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_S),
     /* 203942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203946 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203948 */     GIR_RootConstrainSelectedInstOperands,
     /* 203949 */     // GIR_Coverage, 3414,
     /* 203949 */     GIR_EraseRootFromParent_Done,
     /* 203950 */   // Label 3836: @203950
     /* 203950 */   GIM_Try, /*On fail goto*//*Label 3837*/ GIMT_Encode4(203987), // Rule ID 3415 //
     /* 203955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 203958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 203963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 203969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203976 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1351:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (COMPACT_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 203976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_D),
     /* 203979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203985 */     GIR_RootConstrainSelectedInstOperands,
     /* 203986 */     // GIR_Coverage, 3415,
     /* 203986 */     GIR_EraseRootFromParent_Done,
     /* 203987 */   // Label 3837: @203987
     /* 203987 */   GIM_Try, /*On fail goto*//*Label 3838*/ GIMT_Encode4(204024), // Rule ID 3416 //
     /* 203992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 203995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 204000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 204006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204013 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1351:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (COMPACT_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 204013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_D),
     /* 204016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204022 */     GIR_RootConstrainSelectedInstOperands,
     /* 204023 */     // GIR_Coverage, 3416,
     /* 204023 */     GIR_EraseRootFromParent_Done,
     /* 204024 */   // Label 3838: @204024
     /* 204024 */   GIM_Try, /*On fail goto*//*Label 3839*/ GIMT_Encode4(204061), // Rule ID 3417 //
     /* 204029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2p2_or_SME2p2),
     /* 204032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 204037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 204040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 204043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 204046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204050 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1351:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (COMPACT_ZPZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 204050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_B),
     /* 204053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204057 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204059 */     GIR_RootConstrainSelectedInstOperands,
     /* 204060 */     // GIR_Coverage, 3417,
     /* 204060 */     GIR_EraseRootFromParent_Done,
     /* 204061 */   // Label 3839: @204061
     /* 204061 */   GIM_Try, /*On fail goto*//*Label 3840*/ GIMT_Encode4(204098), // Rule ID 3418 //
     /* 204066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2p2_or_SME2p2),
     /* 204069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 204074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 204080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204087 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1351:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (COMPACT_ZPZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 204087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_H),
     /* 204090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204096 */     GIR_RootConstrainSelectedInstOperands,
     /* 204097 */     // GIR_Coverage, 3418,
     /* 204097 */     GIR_EraseRootFromParent_Done,
     /* 204098 */   // Label 3840: @204098
     /* 204098 */   GIM_Try, /*On fail goto*//*Label 3841*/ GIMT_Encode4(204135), // Rule ID 3419 //
     /* 204103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2p2_or_SME2p2),
     /* 204106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 204111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 204117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204124 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1351:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (COMPACT_ZPZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 204124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_H),
     /* 204127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204133 */     GIR_RootConstrainSelectedInstOperands,
     /* 204134 */     // GIR_Coverage, 3419,
     /* 204134 */     GIR_EraseRootFromParent_Done,
     /* 204135 */   // Label 3841: @204135
     /* 204135 */   GIM_Try, /*On fail goto*//*Label 3842*/ GIMT_Encode4(204172), // Rule ID 3441 //
     /* 204140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 204143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 204148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 204154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204161 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1554:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (FTSSEL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 204161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_H),
     /* 204164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204170 */     GIR_RootConstrainSelectedInstOperands,
     /* 204171 */     // GIR_Coverage, 3441,
     /* 204171 */     GIR_EraseRootFromParent_Done,
     /* 204172 */   // Label 3842: @204172
     /* 204172 */   GIM_Try, /*On fail goto*//*Label 3843*/ GIMT_Encode4(204209), // Rule ID 3442 //
     /* 204177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 204180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 204185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204198 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1554:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (FTSSEL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 204198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_S),
     /* 204201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204207 */     GIR_RootConstrainSelectedInstOperands,
     /* 204208 */     // GIR_Coverage, 3442,
     /* 204208 */     GIR_EraseRootFromParent_Done,
     /* 204209 */   // Label 3843: @204209
     /* 204209 */   GIM_Try, /*On fail goto*//*Label 3844*/ GIMT_Encode4(204246), // Rule ID 3443 //
     /* 204214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 204217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 204222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 204228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204235 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1554:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (FTSSEL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 204235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_D),
     /* 204238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204244 */     GIR_RootConstrainSelectedInstOperands,
     /* 204245 */     // GIR_Coverage, 3443,
     /* 204245 */     GIR_EraseRootFromParent_Done,
     /* 204246 */   // Label 3844: @204246
     /* 204246 */   GIM_Try, /*On fail goto*//*Label 3845*/ GIMT_Encode4(204283), // Rule ID 3465 //
     /* 204251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brka_z),
     /* 204259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 204262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 204265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 204268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204272 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1304:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (BRKA_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 204272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKA_PPzP),
     /* 204275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 204277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204281 */     GIR_RootConstrainSelectedInstOperands,
     /* 204282 */     // GIR_Coverage, 3465,
     /* 204282 */     GIR_EraseRootFromParent_Done,
     /* 204283 */   // Label 3845: @204283
     /* 204283 */   GIM_Try, /*On fail goto*//*Label 3846*/ GIMT_Encode4(204320), // Rule ID 3470 //
     /* 204288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SM4),
     /* 204291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sm4ekey),
     /* 204296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204309 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1734:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SM4EKEY_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 204309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4EKEY_ZZZ_S),
     /* 204312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204316 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204318 */     GIR_RootConstrainSelectedInstOperands,
     /* 204319 */     // GIR_Coverage, 3470,
     /* 204319 */     GIR_EraseRootFromParent_Done,
     /* 204320 */   // Label 3846: @204320
     /* 204320 */   GIM_Try, /*On fail goto*//*Label 3847*/ GIMT_Encode4(204357), // Rule ID 3479 //
     /* 204325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 204328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 204333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 204336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 204339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 204342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204346 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2164:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 204346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 204349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204355 */     GIR_RootConstrainSelectedInstOperands,
     /* 204356 */     // GIR_Coverage, 3479,
     /* 204356 */     GIR_EraseRootFromParent_Done,
     /* 204357 */   // Label 3847: @204357
     /* 204357 */   GIM_Try, /*On fail goto*//*Label 3848*/ GIMT_Encode4(204394), // Rule ID 3480 //
     /* 204362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 204365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 204370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 204376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204383 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2164:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 204383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 204386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204392 */     GIR_RootConstrainSelectedInstOperands,
     /* 204393 */     // GIR_Coverage, 3480,
     /* 204393 */     GIR_EraseRootFromParent_Done,
     /* 204394 */   // Label 3848: @204394
     /* 204394 */   GIM_Try, /*On fail goto*//*Label 3849*/ GIMT_Encode4(204431), // Rule ID 3481 //
     /* 204399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 204402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 204407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 204413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204420 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2164:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 204420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 204423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204427 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204429 */     GIR_RootConstrainSelectedInstOperands,
     /* 204430 */     // GIR_Coverage, 3481,
     /* 204430 */     GIR_EraseRootFromParent_Done,
     /* 204431 */   // Label 3849: @204431
     /* 204431 */   GIM_Try, /*On fail goto*//*Label 3850*/ GIMT_Encode4(204468), // Rule ID 3482 //
     /* 204436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 204439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 204444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204457 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2164:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 204457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 204460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204466 */     GIR_RootConstrainSelectedInstOperands,
     /* 204467 */     // GIR_Coverage, 3482,
     /* 204467 */     GIR_EraseRootFromParent_Done,
     /* 204468 */   // Label 3850: @204468
     /* 204468 */   GIM_Try, /*On fail goto*//*Label 3851*/ GIMT_Encode4(204505), // Rule ID 3483 //
     /* 204473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 204476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 204481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204494 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2164:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 204494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 204497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204503 */     GIR_RootConstrainSelectedInstOperands,
     /* 204504 */     // GIR_Coverage, 3483,
     /* 204504 */     GIR_EraseRootFromParent_Done,
     /* 204505 */   // Label 3851: @204505
     /* 204505 */   GIM_Try, /*On fail goto*//*Label 3852*/ GIMT_Encode4(204542), // Rule ID 3484 //
     /* 204510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 204513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 204518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 204524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204531 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2164:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 204531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 204534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204540 */     GIR_RootConstrainSelectedInstOperands,
     /* 204541 */     // GIR_Coverage, 3484,
     /* 204541 */     GIR_EraseRootFromParent_Done,
     /* 204542 */   // Label 3852: @204542
     /* 204542 */   GIM_Try, /*On fail goto*//*Label 3853*/ GIMT_Encode4(204579), // Rule ID 3485 //
     /* 204547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 204550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 204555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 204561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204568 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2164:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 204568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 204571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204577 */     GIR_RootConstrainSelectedInstOperands,
     /* 204578 */     // GIR_Coverage, 3485,
     /* 204578 */     GIR_EraseRootFromParent_Done,
     /* 204579 */   // Label 3853: @204579
     /* 204579 */   GIM_Try, /*On fail goto*//*Label 3854*/ GIMT_Encode4(204616), // Rule ID 3546 //
     /* 204584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 204587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 204592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 204595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 204598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204605 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1377:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FADDQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 204605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_H),
     /* 204608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 204610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204614 */     GIR_RootConstrainSelectedInstOperands,
     /* 204615 */     // GIR_Coverage, 3546,
     /* 204615 */     GIR_EraseRootFromParent_Done,
     /* 204616 */   // Label 3854: @204616
     /* 204616 */   GIM_Try, /*On fail goto*//*Label 3855*/ GIMT_Encode4(204653), // Rule ID 3547 //
     /* 204621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 204624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 204629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 204632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 204635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204642 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1377:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FADDQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 204642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_S),
     /* 204645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 204647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204651 */     GIR_RootConstrainSelectedInstOperands,
     /* 204652 */     // GIR_Coverage, 3547,
     /* 204652 */     GIR_EraseRootFromParent_Done,
     /* 204653 */   // Label 3855: @204653
     /* 204653 */   GIM_Try, /*On fail goto*//*Label 3856*/ GIMT_Encode4(204690), // Rule ID 3548 //
     /* 204658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 204661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 204666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 204669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 204672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204679 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1377:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FADDQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 204679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_D),
     /* 204682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 204684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204686 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204688 */     GIR_RootConstrainSelectedInstOperands,
     /* 204689 */     // GIR_Coverage, 3548,
     /* 204689 */     GIR_EraseRootFromParent_Done,
     /* 204690 */   // Label 3856: @204690
     /* 204690 */   GIM_Try, /*On fail goto*//*Label 3857*/ GIMT_Encode4(204727), // Rule ID 3578 //
     /* 204695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 204698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 204703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 204706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 204709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 204712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204716 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1628:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ORQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 204716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_B),
     /* 204719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 204721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204725 */     GIR_RootConstrainSelectedInstOperands,
     /* 204726 */     // GIR_Coverage, 3578,
     /* 204726 */     GIR_EraseRootFromParent_Done,
     /* 204727 */   // Label 3857: @204727
     /* 204727 */   GIM_Try, /*On fail goto*//*Label 3858*/ GIMT_Encode4(204764), // Rule ID 3579 //
     /* 204732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 204735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 204740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 204743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 204746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204753 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1628:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ORQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 204753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_H),
     /* 204756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 204758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204762 */     GIR_RootConstrainSelectedInstOperands,
     /* 204763 */     // GIR_Coverage, 3579,
     /* 204763 */     GIR_EraseRootFromParent_Done,
     /* 204764 */   // Label 3858: @204764
     /* 204764 */   GIM_Try, /*On fail goto*//*Label 3859*/ GIMT_Encode4(204801), // Rule ID 3580 //
     /* 204769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 204772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 204777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 204780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 204783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204790 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1628:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ORQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 204790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_S),
     /* 204793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 204795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204797 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204799 */     GIR_RootConstrainSelectedInstOperands,
     /* 204800 */     // GIR_Coverage, 3580,
     /* 204800 */     GIR_EraseRootFromParent_Done,
     /* 204801 */   // Label 3859: @204801
     /* 204801 */   GIM_Try, /*On fail goto*//*Label 3860*/ GIMT_Encode4(204838), // Rule ID 3581 //
     /* 204806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 204809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 204814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 204817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 204820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204827 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1628:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ORQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 204827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_D),
     /* 204830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 204832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204836 */     GIR_RootConstrainSelectedInstOperands,
     /* 204837 */     // GIR_Coverage, 3581,
     /* 204837 */     GIR_EraseRootFromParent_Done,
     /* 204838 */   // Label 3860: @204838
     /* 204838 */   GIM_Try, /*On fail goto*//*Label 3861*/ GIMT_Encode4(204875), // Rule ID 3582 //
     /* 204843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 204846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 204851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 204854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 204857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 204860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204864 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2172:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIPQ1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 204864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_B),
     /* 204867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204873 */     GIR_RootConstrainSelectedInstOperands,
     /* 204874 */     // GIR_Coverage, 3582,
     /* 204874 */     GIR_EraseRootFromParent_Done,
     /* 204875 */   // Label 3861: @204875
     /* 204875 */   GIM_Try, /*On fail goto*//*Label 3862*/ GIMT_Encode4(204912), // Rule ID 3583 //
     /* 204880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 204883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 204888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 204894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204901 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2172:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIPQ1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 204901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_H),
     /* 204904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204910 */     GIR_RootConstrainSelectedInstOperands,
     /* 204911 */     // GIR_Coverage, 3583,
     /* 204911 */     GIR_EraseRootFromParent_Done,
     /* 204912 */   // Label 3862: @204912
     /* 204912 */   GIM_Try, /*On fail goto*//*Label 3863*/ GIMT_Encode4(204949), // Rule ID 3584 //
     /* 204917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 204920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 204925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204938 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2172:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIPQ1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 204938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_S),
     /* 204941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204947 */     GIR_RootConstrainSelectedInstOperands,
     /* 204948 */     // GIR_Coverage, 3584,
     /* 204948 */     GIR_EraseRootFromParent_Done,
     /* 204949 */   // Label 3863: @204949
     /* 204949 */   GIM_Try, /*On fail goto*//*Label 3864*/ GIMT_Encode4(204986), // Rule ID 3585 //
     /* 204954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 204957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 204962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 204968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204975 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2172:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIPQ1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 204975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_D),
     /* 204978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204984 */     GIR_RootConstrainSelectedInstOperands,
     /* 204985 */     // GIR_Coverage, 3585,
     /* 204985 */     GIR_EraseRootFromParent_Done,
     /* 204986 */   // Label 3864: @204986
     /* 204986 */   GIM_Try, /*On fail goto*//*Label 3865*/ GIMT_Encode4(205023), // Rule ID 3586 //
     /* 204991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 204994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 204999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205012 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2172:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIPQ1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 205012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_H),
     /* 205015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205021 */     GIR_RootConstrainSelectedInstOperands,
     /* 205022 */     // GIR_Coverage, 3586,
     /* 205022 */     GIR_EraseRootFromParent_Done,
     /* 205023 */   // Label 3865: @205023
     /* 205023 */   GIM_Try, /*On fail goto*//*Label 3866*/ GIMT_Encode4(205060), // Rule ID 3587 //
     /* 205028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 205031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 205036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205049 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2172:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIPQ1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 205049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_S),
     /* 205052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205056 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205058 */     GIR_RootConstrainSelectedInstOperands,
     /* 205059 */     // GIR_Coverage, 3587,
     /* 205059 */     GIR_EraseRootFromParent_Done,
     /* 205060 */   // Label 3866: @205060
     /* 205060 */   GIM_Try, /*On fail goto*//*Label 3867*/ GIMT_Encode4(205097), // Rule ID 3588 //
     /* 205065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 205068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 205073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205086 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2172:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIPQ1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 205086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_D),
     /* 205089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205095 */     GIR_RootConstrainSelectedInstOperands,
     /* 205096 */     // GIR_Coverage, 3588,
     /* 205096 */     GIR_EraseRootFromParent_Done,
     /* 205097 */   // Label 3867: @205097
     /* 205097 */   GIM_Try, /*On fail goto*//*Label 3868*/ GIMT_Encode4(205134), // Rule ID 3589 //
     /* 205102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 205105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 205110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 205113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 205116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 205119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205123 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1927:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TBLQ_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 205123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_B),
     /* 205126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205130 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205132 */     GIR_RootConstrainSelectedInstOperands,
     /* 205133 */     // GIR_Coverage, 3589,
     /* 205133 */     GIR_EraseRootFromParent_Done,
     /* 205134 */   // Label 3868: @205134
     /* 205134 */   GIM_Try, /*On fail goto*//*Label 3869*/ GIMT_Encode4(205171), // Rule ID 3590 //
     /* 205139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 205142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 205147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205160 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1927:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TBLQ_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 205160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_H),
     /* 205163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205169 */     GIR_RootConstrainSelectedInstOperands,
     /* 205170 */     // GIR_Coverage, 3590,
     /* 205170 */     GIR_EraseRootFromParent_Done,
     /* 205171 */   // Label 3869: @205171
     /* 205171 */   GIM_Try, /*On fail goto*//*Label 3870*/ GIMT_Encode4(205208), // Rule ID 3591 //
     /* 205176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 205179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 205184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205197 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1927:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TBLQ_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 205197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_S),
     /* 205200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205206 */     GIR_RootConstrainSelectedInstOperands,
     /* 205207 */     // GIR_Coverage, 3591,
     /* 205207 */     GIR_EraseRootFromParent_Done,
     /* 205208 */   // Label 3870: @205208
     /* 205208 */   GIM_Try, /*On fail goto*//*Label 3871*/ GIMT_Encode4(205245), // Rule ID 3592 //
     /* 205213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 205216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 205221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205234 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1927:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TBLQ_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 205234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_D),
     /* 205237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205241 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205243 */     GIR_RootConstrainSelectedInstOperands,
     /* 205244 */     // GIR_Coverage, 3592,
     /* 205244 */     GIR_EraseRootFromParent_Done,
     /* 205245 */   // Label 3871: @205245
     /* 205245 */   GIM_Try, /*On fail goto*//*Label 3872*/ GIMT_Encode4(205282), // Rule ID 3593 //
     /* 205250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 205253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 205258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205271 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1927:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TBLQ_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 205271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_H),
     /* 205274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205280 */     GIR_RootConstrainSelectedInstOperands,
     /* 205281 */     // GIR_Coverage, 3593,
     /* 205281 */     GIR_EraseRootFromParent_Done,
     /* 205282 */   // Label 3872: @205282
     /* 205282 */   GIM_Try, /*On fail goto*//*Label 3873*/ GIMT_Encode4(205319), // Rule ID 3594 //
     /* 205287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 205290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 205295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205308 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1927:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TBLQ_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 205308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_S),
     /* 205311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205317 */     GIR_RootConstrainSelectedInstOperands,
     /* 205318 */     // GIR_Coverage, 3594,
     /* 205318 */     GIR_EraseRootFromParent_Done,
     /* 205319 */   // Label 3873: @205319
     /* 205319 */   GIM_Try, /*On fail goto*//*Label 3874*/ GIMT_Encode4(205356), // Rule ID 3595 //
     /* 205324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 205327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 205332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205345 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1927:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TBLQ_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 205345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_D),
     /* 205348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205354 */     GIR_RootConstrainSelectedInstOperands,
     /* 205355 */     // GIR_Coverage, 3595,
     /* 205355 */     GIR_EraseRootFromParent_Done,
     /* 205356 */   // Label 3874: @205356
     /* 205356 */   GIM_Try, /*On fail goto*//*Label 3875*/ GIMT_Encode4(205393), // Rule ID 8523 //
     /* 205361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkb_z),
     /* 205369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 205372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 205375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 205378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 205382 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1306:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (BRKB_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 205382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKB_PPzP),
     /* 205385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 205387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205391 */     GIR_RootConstrainSelectedInstOperands,
     /* 205392 */     // GIR_Coverage, 8523,
     /* 205392 */     GIR_EraseRootFromParent_Done,
     /* 205393 */   // Label 3875: @205393
     /* 205393 */   GIM_Try, /*On fail goto*//*Label 3876*/ GIMT_Encode4(205430), // Rule ID 8999 //
     /* 205398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 205401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrb),
     /* 205406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205419 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1264:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_0:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 205419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_0),
     /* 205422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205426 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205428 */     GIR_RootConstrainSelectedInstOperands,
     /* 205429 */     // GIR_Coverage, 8999,
     /* 205429 */     GIR_EraseRootFromParent_Done,
     /* 205430 */   // Label 3876: @205430
     /* 205430 */   GIM_Try, /*On fail goto*//*Label 3877*/ GIMT_Encode4(205467), // Rule ID 9000 //
     /* 205435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 205438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrh),
     /* 205443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205456 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1266:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_1:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 205456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_1),
     /* 205459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205465 */     GIR_RootConstrainSelectedInstOperands,
     /* 205466 */     // GIR_Coverage, 9000,
     /* 205466 */     GIR_EraseRootFromParent_Done,
     /* 205467 */   // Label 3877: @205467
     /* 205467 */   GIM_Try, /*On fail goto*//*Label 3878*/ GIMT_Encode4(205504), // Rule ID 9001 //
     /* 205472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 205475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrw),
     /* 205480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205493 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1267:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_2:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 205493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_2),
     /* 205496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205502 */     GIR_RootConstrainSelectedInstOperands,
     /* 205503 */     // GIR_Coverage, 9001,
     /* 205503 */     GIR_EraseRootFromParent_Done,
     /* 205504 */   // Label 3878: @205504
     /* 205504 */   GIM_Try, /*On fail goto*//*Label 3879*/ GIMT_Encode4(205541), // Rule ID 9002 //
     /* 205509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 205512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrd),
     /* 205517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205530 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1265:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_3:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 205530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_3),
     /* 205533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205539 */     GIR_RootConstrainSelectedInstOperands,
     /* 205540 */     // GIR_Coverage, 9002,
     /* 205540 */     GIR_EraseRootFromParent_Done,
     /* 205541 */   // Label 3879: @205541
     /* 205541 */   GIM_Try, /*On fail goto*//*Label 3880*/ GIMT_Encode4(205578), // Rule ID 9003 //
     /* 205546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 205549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrb),
     /* 205554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205567 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1264:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 205567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_0),
     /* 205570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205576 */     GIR_RootConstrainSelectedInstOperands,
     /* 205577 */     // GIR_Coverage, 9003,
     /* 205577 */     GIR_EraseRootFromParent_Done,
     /* 205578 */   // Label 3880: @205578
     /* 205578 */   GIM_Try, /*On fail goto*//*Label 3881*/ GIMT_Encode4(205615), // Rule ID 9004 //
     /* 205583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 205586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrh),
     /* 205591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205604 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1266:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_1:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 205604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_1),
     /* 205607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205611 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205613 */     GIR_RootConstrainSelectedInstOperands,
     /* 205614 */     // GIR_Coverage, 9004,
     /* 205614 */     GIR_EraseRootFromParent_Done,
     /* 205615 */   // Label 3881: @205615
     /* 205615 */   GIM_Try, /*On fail goto*//*Label 3882*/ GIMT_Encode4(205652), // Rule ID 9005 //
     /* 205620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 205623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrw),
     /* 205628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205641 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1267:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_2:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 205641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_2),
     /* 205644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205650 */     GIR_RootConstrainSelectedInstOperands,
     /* 205651 */     // GIR_Coverage, 9005,
     /* 205651 */     GIR_EraseRootFromParent_Done,
     /* 205652 */   // Label 3882: @205652
     /* 205652 */   GIM_Try, /*On fail goto*//*Label 3883*/ GIMT_Encode4(205689), // Rule ID 9006 //
     /* 205657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 205660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrd),
     /* 205665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205678 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1265:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_3:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 205678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_3),
     /* 205681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205687 */     GIR_RootConstrainSelectedInstOperands,
     /* 205688 */     // GIR_Coverage, 9006,
     /* 205688 */     GIR_EraseRootFromParent_Done,
     /* 205689 */   // Label 3883: @205689
     /* 205689 */   GIM_Try, /*On fail goto*//*Label 3884*/ GIMT_Encode4(205729), // Rule ID 10006 //
     /* 205694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 205702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 205705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 205708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 205711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 205715 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2124:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 205715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_B),
     /* 205718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 205720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205724 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 205727 */     GIR_RootConstrainSelectedInstOperands,
     /* 205728 */     // GIR_Coverage, 10006,
     /* 205728 */     GIR_EraseRootFromParent_Done,
     /* 205729 */   // Label 3884: @205729
     /* 205729 */   GIM_Try, /*On fail goto*//*Label 3885*/ GIMT_Encode4(205769), // Rule ID 10007 //
     /* 205734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 205742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 205745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 205748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 205751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 205755 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2124:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 205755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_H),
     /* 205758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 205760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205762 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205764 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 205767 */     GIR_RootConstrainSelectedInstOperands,
     /* 205768 */     // GIR_Coverage, 10007,
     /* 205768 */     GIR_EraseRootFromParent_Done,
     /* 205769 */   // Label 3885: @205769
     /* 205769 */   GIM_Try, /*On fail goto*//*Label 3886*/ GIMT_Encode4(205809), // Rule ID 10008 //
     /* 205774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 205782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 205785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 205788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 205791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 205795 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2124:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 205795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_S),
     /* 205798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 205800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205802 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205804 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 205807 */     GIR_RootConstrainSelectedInstOperands,
     /* 205808 */     // GIR_Coverage, 10008,
     /* 205808 */     GIR_EraseRootFromParent_Done,
     /* 205809 */   // Label 3886: @205809
     /* 205809 */   GIM_Try, /*On fail goto*//*Label 3887*/ GIMT_Encode4(205849), // Rule ID 10009 //
     /* 205814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 205822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 205825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 205828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 205831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 205835 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2124:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 205835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_D),
     /* 205838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 205840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205844 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 205847 */     GIR_RootConstrainSelectedInstOperands,
     /* 205848 */     // GIR_Coverage, 10009,
     /* 205848 */     GIR_EraseRootFromParent_Done,
     /* 205849 */   // Label 3887: @205849
     /* 205849 */   GIM_Try, /*On fail goto*//*Label 3888*/ GIMT_Encode4(205889), // Rule ID 10018 //
     /* 205854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 205862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 205865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 205868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 205871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 205875 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2136:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 205875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_B),
     /* 205878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 205880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205884 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 205887 */     GIR_RootConstrainSelectedInstOperands,
     /* 205888 */     // GIR_Coverage, 10018,
     /* 205888 */     GIR_EraseRootFromParent_Done,
     /* 205889 */   // Label 3888: @205889
     /* 205889 */   GIM_Try, /*On fail goto*//*Label 3889*/ GIMT_Encode4(205929), // Rule ID 10019 //
     /* 205894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 205902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 205905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 205908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 205911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 205915 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2136:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 205915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_H),
     /* 205918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 205920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205924 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 205927 */     GIR_RootConstrainSelectedInstOperands,
     /* 205928 */     // GIR_Coverage, 10019,
     /* 205928 */     GIR_EraseRootFromParent_Done,
     /* 205929 */   // Label 3889: @205929
     /* 205929 */   GIM_Try, /*On fail goto*//*Label 3890*/ GIMT_Encode4(205969), // Rule ID 10020 //
     /* 205934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 205942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 205945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 205948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 205951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 205955 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2136:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 205955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_S),
     /* 205958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 205960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205964 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 205967 */     GIR_RootConstrainSelectedInstOperands,
     /* 205968 */     // GIR_Coverage, 10020,
     /* 205968 */     GIR_EraseRootFromParent_Done,
     /* 205969 */   // Label 3890: @205969
     /* 205969 */   GIM_Try, /*On fail goto*//*Label 3891*/ GIMT_Encode4(206009), // Rule ID 10021 //
     /* 205974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 205982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 205985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 205988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 205991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 205995 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2136:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 205995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_D),
     /* 205998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 206000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206004 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 206007 */     GIR_RootConstrainSelectedInstOperands,
     /* 206008 */     // GIR_Coverage, 10021,
     /* 206008 */     GIR_EraseRootFromParent_Done,
     /* 206009 */   // Label 3891: @206009
     /* 206009 */   GIM_Try, /*On fail goto*//*Label 3892*/ GIMT_Encode4(206049), // Rule ID 10022 //
     /* 206014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 206022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 206025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 206028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 206031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 206035 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2124:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 206035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_B),
     /* 206038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 206040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206044 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 206047 */     GIR_RootConstrainSelectedInstOperands,
     /* 206048 */     // GIR_Coverage, 10022,
     /* 206048 */     GIR_EraseRootFromParent_Done,
     /* 206049 */   // Label 3892: @206049
     /* 206049 */   GIM_Try, /*On fail goto*//*Label 3893*/ GIMT_Encode4(206089), // Rule ID 10023 //
     /* 206054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 206062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 206065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 206068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 206071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 206075 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2124:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 206075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_H),
     /* 206078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 206080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206082 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206084 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 206087 */     GIR_RootConstrainSelectedInstOperands,
     /* 206088 */     // GIR_Coverage, 10023,
     /* 206088 */     GIR_EraseRootFromParent_Done,
     /* 206089 */   // Label 3893: @206089
     /* 206089 */   GIM_Try, /*On fail goto*//*Label 3894*/ GIMT_Encode4(206129), // Rule ID 10024 //
     /* 206094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 206102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 206105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 206108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 206111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 206115 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2124:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 206115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_S),
     /* 206118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 206120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206122 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206124 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 206127 */     GIR_RootConstrainSelectedInstOperands,
     /* 206128 */     // GIR_Coverage, 10024,
     /* 206128 */     GIR_EraseRootFromParent_Done,
     /* 206129 */   // Label 3894: @206129
     /* 206129 */   GIM_Try, /*On fail goto*//*Label 3895*/ GIMT_Encode4(206169), // Rule ID 10025 //
     /* 206134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 206142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 206145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 206148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 206151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 206155 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2124:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 206155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_D),
     /* 206158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 206160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206164 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 206167 */     GIR_RootConstrainSelectedInstOperands,
     /* 206168 */     // GIR_Coverage, 10025,
     /* 206168 */     GIR_EraseRootFromParent_Done,
     /* 206169 */   // Label 3895: @206169
     /* 206169 */   GIM_Try, /*On fail goto*//*Label 3896*/ GIMT_Encode4(206209), // Rule ID 10034 //
     /* 206174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 206182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 206185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 206188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 206191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 206195 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2136:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 206195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_B),
     /* 206198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 206200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206202 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206204 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 206207 */     GIR_RootConstrainSelectedInstOperands,
     /* 206208 */     // GIR_Coverage, 10034,
     /* 206208 */     GIR_EraseRootFromParent_Done,
     /* 206209 */   // Label 3896: @206209
     /* 206209 */   GIM_Try, /*On fail goto*//*Label 3897*/ GIMT_Encode4(206249), // Rule ID 10035 //
     /* 206214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 206222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 206225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 206228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 206231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 206235 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2136:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 206235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 206238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 206240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206244 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 206247 */     GIR_RootConstrainSelectedInstOperands,
     /* 206248 */     // GIR_Coverage, 10035,
     /* 206248 */     GIR_EraseRootFromParent_Done,
     /* 206249 */   // Label 3897: @206249
     /* 206249 */   GIM_Try, /*On fail goto*//*Label 3898*/ GIMT_Encode4(206289), // Rule ID 10036 //
     /* 206254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 206262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 206265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 206268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 206271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 206275 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2136:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 206275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 206278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 206280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206284 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 206287 */     GIR_RootConstrainSelectedInstOperands,
     /* 206288 */     // GIR_Coverage, 10036,
     /* 206288 */     GIR_EraseRootFromParent_Done,
     /* 206289 */   // Label 3898: @206289
     /* 206289 */   GIM_Try, /*On fail goto*//*Label 3899*/ GIMT_Encode4(206329), // Rule ID 10037 //
     /* 206294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 206302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 206305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 206308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 206311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 206315 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2136:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 206315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 206318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 206320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206322 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206324 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 206327 */     GIR_RootConstrainSelectedInstOperands,
     /* 206328 */     // GIR_Coverage, 10037,
     /* 206328 */     GIR_EraseRootFromParent_Done,
     /* 206329 */   // Label 3899: @206329
     /* 206329 */   GIM_Try, /*On fail goto*//*Label 3900*/ GIMT_Encode4(206366), // Rule ID 10196 //
     /* 206334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 206342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 206351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206355 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2034:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UQINCP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 206355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_H),
     /* 206358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206364 */     GIR_RootConstrainSelectedInstOperands,
     /* 206365 */     // GIR_Coverage, 10196,
     /* 206365 */     GIR_EraseRootFromParent_Done,
     /* 206366 */   // Label 3900: @206366
     /* 206366 */   GIM_Try, /*On fail goto*//*Label 3901*/ GIMT_Encode4(206403), // Rule ID 10197 //
     /* 206371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 206379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 206388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206392 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2034:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UQINCP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 206392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_S),
     /* 206395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206401 */     GIR_RootConstrainSelectedInstOperands,
     /* 206402 */     // GIR_Coverage, 10197,
     /* 206402 */     GIR_EraseRootFromParent_Done,
     /* 206403 */   // Label 3901: @206403
     /* 206403 */   GIM_Try, /*On fail goto*//*Label 3902*/ GIMT_Encode4(206440), // Rule ID 10198 //
     /* 206408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 206416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 206422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 206425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206429 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2034:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UQINCP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 206429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_D),
     /* 206432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206438 */     GIR_RootConstrainSelectedInstOperands,
     /* 206439 */     // GIR_Coverage, 10198,
     /* 206439 */     GIR_EraseRootFromParent_Done,
     /* 206440 */   // Label 3902: @206440
     /* 206440 */   GIM_Try, /*On fail goto*//*Label 3903*/ GIMT_Encode4(206477), // Rule ID 10199 //
     /* 206445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 206453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 206462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206466 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1789:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SQDECP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 206466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_H),
     /* 206469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206475 */     GIR_RootConstrainSelectedInstOperands,
     /* 206476 */     // GIR_Coverage, 10199,
     /* 206476 */     GIR_EraseRootFromParent_Done,
     /* 206477 */   // Label 3903: @206477
     /* 206477 */   GIM_Try, /*On fail goto*//*Label 3904*/ GIMT_Encode4(206514), // Rule ID 10200 //
     /* 206482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 206490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 206499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206503 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1789:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SQDECP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 206503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_S),
     /* 206506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206512 */     GIR_RootConstrainSelectedInstOperands,
     /* 206513 */     // GIR_Coverage, 10200,
     /* 206513 */     GIR_EraseRootFromParent_Done,
     /* 206514 */   // Label 3904: @206514
     /* 206514 */   GIM_Try, /*On fail goto*//*Label 3905*/ GIMT_Encode4(206551), // Rule ID 10201 //
     /* 206519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 206527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 206533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 206536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206540 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1789:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SQDECP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 206540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_D),
     /* 206543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206547 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206549 */     GIR_RootConstrainSelectedInstOperands,
     /* 206550 */     // GIR_Coverage, 10201,
     /* 206550 */     GIR_EraseRootFromParent_Done,
     /* 206551 */   // Label 3905: @206551
     /* 206551 */   GIM_Try, /*On fail goto*//*Label 3906*/ GIMT_Encode4(206588), // Rule ID 10202 //
     /* 206556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 206564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 206573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206577 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2020:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UQDECP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 206577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_H),
     /* 206580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206586 */     GIR_RootConstrainSelectedInstOperands,
     /* 206587 */     // GIR_Coverage, 10202,
     /* 206587 */     GIR_EraseRootFromParent_Done,
     /* 206588 */   // Label 3906: @206588
     /* 206588 */   GIM_Try, /*On fail goto*//*Label 3907*/ GIMT_Encode4(206625), // Rule ID 10203 //
     /* 206593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 206601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 206610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206614 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2020:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UQDECP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 206614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_S),
     /* 206617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206623 */     GIR_RootConstrainSelectedInstOperands,
     /* 206624 */     // GIR_Coverage, 10203,
     /* 206624 */     GIR_EraseRootFromParent_Done,
     /* 206625 */   // Label 3907: @206625
     /* 206625 */   GIM_Try, /*On fail goto*//*Label 3908*/ GIMT_Encode4(206662), // Rule ID 10204 //
     /* 206630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 206638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 206644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 206647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206651 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2020:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UQDECP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 206651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_D),
     /* 206654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206660 */     GIR_RootConstrainSelectedInstOperands,
     /* 206661 */     // GIR_Coverage, 10204,
     /* 206661 */     GIR_EraseRootFromParent_Done,
     /* 206662 */   // Label 3908: @206662
     /* 206662 */   GIM_Try, /*On fail goto*//*Label 3909*/ GIMT_Encode4(206699), // Rule ID 11392 //
     /* 206667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 206675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 206678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 206681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 206684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206688 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2169:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 206688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 206691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206695 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206697 */     GIR_RootConstrainSelectedInstOperands,
     /* 206698 */     // GIR_Coverage, 11392,
     /* 206698 */     GIR_EraseRootFromParent_Done,
     /* 206699 */   // Label 3909: @206699
     /* 206699 */   GIM_Try, /*On fail goto*//*Label 3910*/ GIMT_Encode4(206736), // Rule ID 11393 //
     /* 206704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 206712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206725 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2169:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 206725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 206728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206732 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206734 */     GIR_RootConstrainSelectedInstOperands,
     /* 206735 */     // GIR_Coverage, 11393,
     /* 206735 */     GIR_EraseRootFromParent_Done,
     /* 206736 */   // Label 3910: @206736
     /* 206736 */   GIM_Try, /*On fail goto*//*Label 3911*/ GIMT_Encode4(206773), // Rule ID 11394 //
     /* 206741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 206749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206762 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2169:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 206762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 206765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206771 */     GIR_RootConstrainSelectedInstOperands,
     /* 206772 */     // GIR_Coverage, 11394,
     /* 206772 */     GIR_EraseRootFromParent_Done,
     /* 206773 */   // Label 3911: @206773
     /* 206773 */   GIM_Try, /*On fail goto*//*Label 3912*/ GIMT_Encode4(206810), // Rule ID 11395 //
     /* 206778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 206786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206799 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2169:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 206799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 206802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206806 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206808 */     GIR_RootConstrainSelectedInstOperands,
     /* 206809 */     // GIR_Coverage, 11395,
     /* 206809 */     GIR_EraseRootFromParent_Done,
     /* 206810 */   // Label 3912: @206810
     /* 206810 */   GIM_Try, /*On fail goto*//*Label 3913*/ GIMT_Encode4(206847), // Rule ID 11396 //
     /* 206815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 206823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206836 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2169:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 206836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 206839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206845 */     GIR_RootConstrainSelectedInstOperands,
     /* 206846 */     // GIR_Coverage, 11396,
     /* 206846 */     GIR_EraseRootFromParent_Done,
     /* 206847 */   // Label 3913: @206847
     /* 206847 */   GIM_Try, /*On fail goto*//*Label 3914*/ GIMT_Encode4(206884), // Rule ID 11397 //
     /* 206852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 206860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 206866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206873 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2169:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 206873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 206876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206882 */     GIR_RootConstrainSelectedInstOperands,
     /* 206883 */     // GIR_Coverage, 11397,
     /* 206883 */     GIR_EraseRootFromParent_Done,
     /* 206884 */   // Label 3914: @206884
     /* 206884 */   GIM_Try, /*On fail goto*//*Label 3915*/ GIMT_Encode4(206921), // Rule ID 11398 //
     /* 206889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 206897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 206903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206910 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2169:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 206910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 206913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206917 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206919 */     GIR_RootConstrainSelectedInstOperands,
     /* 206920 */     // GIR_Coverage, 11398,
     /* 206920 */     GIR_EraseRootFromParent_Done,
     /* 206921 */   // Label 3915: @206921
     /* 206921 */   GIM_Try, /*On fail goto*//*Label 3916*/ GIMT_Encode4(206958), // Rule ID 11399 //
     /* 206926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 206934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 206937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 206940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 206943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206947 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2090:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 206947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 206950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206956 */     GIR_RootConstrainSelectedInstOperands,
     /* 206957 */     // GIR_Coverage, 11399,
     /* 206957 */     GIR_EraseRootFromParent_Done,
     /* 206958 */   // Label 3916: @206958
     /* 206958 */   GIM_Try, /*On fail goto*//*Label 3917*/ GIMT_Encode4(206995), // Rule ID 11400 //
     /* 206963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 206971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206984 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2090:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 206984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 206987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206993 */     GIR_RootConstrainSelectedInstOperands,
     /* 206994 */     // GIR_Coverage, 11400,
     /* 206994 */     GIR_EraseRootFromParent_Done,
     /* 206995 */   // Label 3917: @206995
     /* 206995 */   GIM_Try, /*On fail goto*//*Label 3918*/ GIMT_Encode4(207032), // Rule ID 11401 //
     /* 207000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 207008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207021 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2090:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 207021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 207024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207030 */     GIR_RootConstrainSelectedInstOperands,
     /* 207031 */     // GIR_Coverage, 11401,
     /* 207031 */     GIR_EraseRootFromParent_Done,
     /* 207032 */   // Label 3918: @207032
     /* 207032 */   GIM_Try, /*On fail goto*//*Label 3919*/ GIMT_Encode4(207069), // Rule ID 11402 //
     /* 207037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 207045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207058 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2090:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 207061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207067 */     GIR_RootConstrainSelectedInstOperands,
     /* 207068 */     // GIR_Coverage, 11402,
     /* 207068 */     GIR_EraseRootFromParent_Done,
     /* 207069 */   // Label 3919: @207069
     /* 207069 */   GIM_Try, /*On fail goto*//*Label 3920*/ GIMT_Encode4(207106), // Rule ID 11403 //
     /* 207074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 207082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207095 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2090:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 207095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 207098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207104 */     GIR_RootConstrainSelectedInstOperands,
     /* 207105 */     // GIR_Coverage, 11403,
     /* 207105 */     GIR_EraseRootFromParent_Done,
     /* 207106 */   // Label 3920: @207106
     /* 207106 */   GIM_Try, /*On fail goto*//*Label 3921*/ GIMT_Encode4(207143), // Rule ID 11404 //
     /* 207111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 207119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207132 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2090:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 207132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 207135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207141 */     GIR_RootConstrainSelectedInstOperands,
     /* 207142 */     // GIR_Coverage, 11404,
     /* 207142 */     GIR_EraseRootFromParent_Done,
     /* 207143 */   // Label 3921: @207143
     /* 207143 */   GIM_Try, /*On fail goto*//*Label 3922*/ GIMT_Encode4(207180), // Rule ID 11405 //
     /* 207148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 207156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207169 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2090:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 207169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 207172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207178 */     GIR_RootConstrainSelectedInstOperands,
     /* 207179 */     // GIR_Coverage, 11405,
     /* 207179 */     GIR_EraseRootFromParent_Done,
     /* 207180 */   // Label 3922: @207180
     /* 207180 */   GIM_Try, /*On fail goto*//*Label 3923*/ GIMT_Encode4(207217), // Rule ID 11406 //
     /* 207185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 207193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 207196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 207199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 207202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207206 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2095:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 207206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 207209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207215 */     GIR_RootConstrainSelectedInstOperands,
     /* 207216 */     // GIR_Coverage, 11406,
     /* 207216 */     GIR_EraseRootFromParent_Done,
     /* 207217 */   // Label 3923: @207217
     /* 207217 */   GIM_Try, /*On fail goto*//*Label 3924*/ GIMT_Encode4(207254), // Rule ID 11407 //
     /* 207222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 207230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207243 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2095:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 207243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 207246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207252 */     GIR_RootConstrainSelectedInstOperands,
     /* 207253 */     // GIR_Coverage, 11407,
     /* 207253 */     GIR_EraseRootFromParent_Done,
     /* 207254 */   // Label 3924: @207254
     /* 207254 */   GIM_Try, /*On fail goto*//*Label 3925*/ GIMT_Encode4(207291), // Rule ID 11408 //
     /* 207259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 207267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207280 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2095:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 207280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 207283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207287 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207289 */     GIR_RootConstrainSelectedInstOperands,
     /* 207290 */     // GIR_Coverage, 11408,
     /* 207290 */     GIR_EraseRootFromParent_Done,
     /* 207291 */   // Label 3925: @207291
     /* 207291 */   GIM_Try, /*On fail goto*//*Label 3926*/ GIMT_Encode4(207328), // Rule ID 11409 //
     /* 207296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 207304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207317 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2095:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 207320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207326 */     GIR_RootConstrainSelectedInstOperands,
     /* 207327 */     // GIR_Coverage, 11409,
     /* 207327 */     GIR_EraseRootFromParent_Done,
     /* 207328 */   // Label 3926: @207328
     /* 207328 */   GIM_Try, /*On fail goto*//*Label 3927*/ GIMT_Encode4(207365), // Rule ID 11410 //
     /* 207333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 207341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207354 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2095:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 207354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 207357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207361 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207363 */     GIR_RootConstrainSelectedInstOperands,
     /* 207364 */     // GIR_Coverage, 11410,
     /* 207364 */     GIR_EraseRootFromParent_Done,
     /* 207365 */   // Label 3927: @207365
     /* 207365 */   GIM_Try, /*On fail goto*//*Label 3928*/ GIMT_Encode4(207402), // Rule ID 11411 //
     /* 207370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 207378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207391 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2095:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 207391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 207394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207400 */     GIR_RootConstrainSelectedInstOperands,
     /* 207401 */     // GIR_Coverage, 11411,
     /* 207401 */     GIR_EraseRootFromParent_Done,
     /* 207402 */   // Label 3928: @207402
     /* 207402 */   GIM_Try, /*On fail goto*//*Label 3929*/ GIMT_Encode4(207439), // Rule ID 11412 //
     /* 207407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 207415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207428 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2095:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 207428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 207431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207435 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207437 */     GIR_RootConstrainSelectedInstOperands,
     /* 207438 */     // GIR_Coverage, 11412,
     /* 207438 */     GIR_EraseRootFromParent_Done,
     /* 207439 */   // Label 3929: @207439
     /* 207439 */   GIM_Try, /*On fail goto*//*Label 3930*/ GIMT_Encode4(207476), // Rule ID 11413 //
     /* 207444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 207452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 207455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 207458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 207461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207465 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1934:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 207465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 207468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207474 */     GIR_RootConstrainSelectedInstOperands,
     /* 207475 */     // GIR_Coverage, 11413,
     /* 207475 */     GIR_EraseRootFromParent_Done,
     /* 207476 */   // Label 3930: @207476
     /* 207476 */   GIM_Try, /*On fail goto*//*Label 3931*/ GIMT_Encode4(207513), // Rule ID 11414 //
     /* 207481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 207489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207502 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1934:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 207502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 207505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207511 */     GIR_RootConstrainSelectedInstOperands,
     /* 207512 */     // GIR_Coverage, 11414,
     /* 207512 */     GIR_EraseRootFromParent_Done,
     /* 207513 */   // Label 3931: @207513
     /* 207513 */   GIM_Try, /*On fail goto*//*Label 3932*/ GIMT_Encode4(207550), // Rule ID 11415 //
     /* 207518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 207526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207539 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1934:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 207539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 207542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207548 */     GIR_RootConstrainSelectedInstOperands,
     /* 207549 */     // GIR_Coverage, 11415,
     /* 207549 */     GIR_EraseRootFromParent_Done,
     /* 207550 */   // Label 3932: @207550
     /* 207550 */   GIM_Try, /*On fail goto*//*Label 3933*/ GIMT_Encode4(207587), // Rule ID 11416 //
     /* 207555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 207563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207576 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1934:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 207579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207585 */     GIR_RootConstrainSelectedInstOperands,
     /* 207586 */     // GIR_Coverage, 11416,
     /* 207586 */     GIR_EraseRootFromParent_Done,
     /* 207587 */   // Label 3933: @207587
     /* 207587 */   GIM_Try, /*On fail goto*//*Label 3934*/ GIMT_Encode4(207624), // Rule ID 11417 //
     /* 207592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 207600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207613 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1934:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 207613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 207616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207622 */     GIR_RootConstrainSelectedInstOperands,
     /* 207623 */     // GIR_Coverage, 11417,
     /* 207623 */     GIR_EraseRootFromParent_Done,
     /* 207624 */   // Label 3934: @207624
     /* 207624 */   GIM_Try, /*On fail goto*//*Label 3935*/ GIMT_Encode4(207661), // Rule ID 11418 //
     /* 207629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 207637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207650 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1934:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 207650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 207653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207659 */     GIR_RootConstrainSelectedInstOperands,
     /* 207660 */     // GIR_Coverage, 11418,
     /* 207660 */     GIR_EraseRootFromParent_Done,
     /* 207661 */   // Label 3935: @207661
     /* 207661 */   GIM_Try, /*On fail goto*//*Label 3936*/ GIMT_Encode4(207698), // Rule ID 11419 //
     /* 207666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 207674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207687 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1934:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 207687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 207690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207696 */     GIR_RootConstrainSelectedInstOperands,
     /* 207697 */     // GIR_Coverage, 11419,
     /* 207697 */     GIR_EraseRootFromParent_Done,
     /* 207698 */   // Label 3936: @207698
     /* 207698 */   GIM_Try, /*On fail goto*//*Label 3937*/ GIMT_Encode4(207735), // Rule ID 11420 //
     /* 207703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 207711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 207714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 207717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 207720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207724 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1939:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 207724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 207727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207733 */     GIR_RootConstrainSelectedInstOperands,
     /* 207734 */     // GIR_Coverage, 11420,
     /* 207734 */     GIR_EraseRootFromParent_Done,
     /* 207735 */   // Label 3937: @207735
     /* 207735 */   GIM_Try, /*On fail goto*//*Label 3938*/ GIMT_Encode4(207772), // Rule ID 11421 //
     /* 207740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 207748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207761 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1939:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 207761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 207764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207770 */     GIR_RootConstrainSelectedInstOperands,
     /* 207771 */     // GIR_Coverage, 11421,
     /* 207771 */     GIR_EraseRootFromParent_Done,
     /* 207772 */   // Label 3938: @207772
     /* 207772 */   GIM_Try, /*On fail goto*//*Label 3939*/ GIMT_Encode4(207809), // Rule ID 11422 //
     /* 207777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 207785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207798 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1939:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 207798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 207801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207805 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207807 */     GIR_RootConstrainSelectedInstOperands,
     /* 207808 */     // GIR_Coverage, 11422,
     /* 207808 */     GIR_EraseRootFromParent_Done,
     /* 207809 */   // Label 3939: @207809
     /* 207809 */   GIM_Try, /*On fail goto*//*Label 3940*/ GIMT_Encode4(207846), // Rule ID 11423 //
     /* 207814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 207822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207835 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1939:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 207838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207844 */     GIR_RootConstrainSelectedInstOperands,
     /* 207845 */     // GIR_Coverage, 11423,
     /* 207845 */     GIR_EraseRootFromParent_Done,
     /* 207846 */   // Label 3940: @207846
     /* 207846 */   GIM_Try, /*On fail goto*//*Label 3941*/ GIMT_Encode4(207883), // Rule ID 11424 //
     /* 207851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 207859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207872 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1939:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 207872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 207875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207881 */     GIR_RootConstrainSelectedInstOperands,
     /* 207882 */     // GIR_Coverage, 11424,
     /* 207882 */     GIR_EraseRootFromParent_Done,
     /* 207883 */   // Label 3941: @207883
     /* 207883 */   GIM_Try, /*On fail goto*//*Label 3942*/ GIMT_Encode4(207920), // Rule ID 11425 //
     /* 207888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 207896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207909 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1939:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 207909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 207912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207918 */     GIR_RootConstrainSelectedInstOperands,
     /* 207919 */     // GIR_Coverage, 11425,
     /* 207919 */     GIR_EraseRootFromParent_Done,
     /* 207920 */   // Label 3942: @207920
     /* 207920 */   GIM_Try, /*On fail goto*//*Label 3943*/ GIMT_Encode4(207957), // Rule ID 11426 //
     /* 207925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 207933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207946 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1939:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 207946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 207949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207955 */     GIR_RootConstrainSelectedInstOperands,
     /* 207956 */     // GIR_Coverage, 11426,
     /* 207956 */     GIR_EraseRootFromParent_Done,
     /* 207957 */   // Label 3943: @207957
     /* 207957 */   GIM_Try, /*On fail goto*//*Label 3944*/ GIMT_Encode4(207994), // Rule ID 11446 //
     /* 207962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 207970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 207973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 207976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 207979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207983 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1836:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQRDMULH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 207983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_B),
     /* 207986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207992 */     GIR_RootConstrainSelectedInstOperands,
     /* 207993 */     // GIR_Coverage, 11446,
     /* 207993 */     GIR_EraseRootFromParent_Done,
     /* 207994 */   // Label 3944: @207994
     /* 207994 */   GIM_Try, /*On fail goto*//*Label 3945*/ GIMT_Encode4(208031), // Rule ID 11447 //
     /* 207999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 208007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208020 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1836:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQRDMULH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_H),
     /* 208023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208029 */     GIR_RootConstrainSelectedInstOperands,
     /* 208030 */     // GIR_Coverage, 11447,
     /* 208030 */     GIR_EraseRootFromParent_Done,
     /* 208031 */   // Label 3945: @208031
     /* 208031 */   GIM_Try, /*On fail goto*//*Label 3946*/ GIMT_Encode4(208068), // Rule ID 11448 //
     /* 208036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 208044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208057 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1836:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQRDMULH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_S),
     /* 208060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208066 */     GIR_RootConstrainSelectedInstOperands,
     /* 208067 */     // GIR_Coverage, 11448,
     /* 208067 */     GIR_EraseRootFromParent_Done,
     /* 208068 */   // Label 3946: @208068
     /* 208068 */   GIM_Try, /*On fail goto*//*Label 3947*/ GIMT_Encode4(208105), // Rule ID 11449 //
     /* 208073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 208081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 208087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 208090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208094 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1836:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQRDMULH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 208094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_D),
     /* 208097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208101 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208103 */     GIR_RootConstrainSelectedInstOperands,
     /* 208104 */     // GIR_Coverage, 11449,
     /* 208104 */     GIR_EraseRootFromParent_Done,
     /* 208105 */   // Label 3947: @208105
     /* 208105 */   GIM_Try, /*On fail goto*//*Label 3948*/ GIMT_Encode4(208142), // Rule ID 11737 //
     /* 208110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 208118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208131 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1700:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_H),
     /* 208134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208140 */     GIR_RootConstrainSelectedInstOperands,
     /* 208141 */     // GIR_Coverage, 11737,
     /* 208141 */     GIR_EraseRootFromParent_Done,
     /* 208142 */   // Label 3948: @208142
     /* 208142 */   GIM_Try, /*On fail goto*//*Label 3949*/ GIMT_Encode4(208179), // Rule ID 11738 //
     /* 208147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 208155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208168 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1700:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_S),
     /* 208171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208177 */     GIR_RootConstrainSelectedInstOperands,
     /* 208178 */     // GIR_Coverage, 11738,
     /* 208178 */     GIR_EraseRootFromParent_Done,
     /* 208179 */   // Label 3949: @208179
     /* 208179 */   GIM_Try, /*On fail goto*//*Label 3950*/ GIMT_Encode4(208216), // Rule ID 11739 //
     /* 208184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 208192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208205 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1700:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_D),
     /* 208208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208214 */     GIR_RootConstrainSelectedInstOperands,
     /* 208215 */     // GIR_Coverage, 11739,
     /* 208215 */     GIR_EraseRootFromParent_Done,
     /* 208216 */   // Label 3950: @208216
     /* 208216 */   GIM_Try, /*On fail goto*//*Label 3951*/ GIMT_Encode4(208253), // Rule ID 11740 //
     /* 208221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 208229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208242 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1948:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UADDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_H),
     /* 208245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208251 */     GIR_RootConstrainSelectedInstOperands,
     /* 208252 */     // GIR_Coverage, 11740,
     /* 208252 */     GIR_EraseRootFromParent_Done,
     /* 208253 */   // Label 3951: @208253
     /* 208253 */   GIM_Try, /*On fail goto*//*Label 3952*/ GIMT_Encode4(208290), // Rule ID 11741 //
     /* 208258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 208266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208279 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1948:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UADDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_S),
     /* 208282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208288 */     GIR_RootConstrainSelectedInstOperands,
     /* 208289 */     // GIR_Coverage, 11741,
     /* 208289 */     GIR_EraseRootFromParent_Done,
     /* 208290 */   // Label 3952: @208290
     /* 208290 */   GIM_Try, /*On fail goto*//*Label 3953*/ GIMT_Encode4(208327), // Rule ID 11742 //
     /* 208295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 208303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208316 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1948:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UADDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_D),
     /* 208319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208325 */     GIR_RootConstrainSelectedInstOperands,
     /* 208326 */     // GIR_Coverage, 11742,
     /* 208326 */     GIR_EraseRootFromParent_Done,
     /* 208327 */   // Label 3953: @208327
     /* 208327 */   GIM_Try, /*On fail goto*//*Label 3954*/ GIMT_Encode4(208364), // Rule ID 11743 //
     /* 208332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 208340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208353 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1949:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UADDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_H),
     /* 208356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208362 */     GIR_RootConstrainSelectedInstOperands,
     /* 208363 */     // GIR_Coverage, 11743,
     /* 208363 */     GIR_EraseRootFromParent_Done,
     /* 208364 */   // Label 3954: @208364
     /* 208364 */   GIM_Try, /*On fail goto*//*Label 3955*/ GIMT_Encode4(208401), // Rule ID 11744 //
     /* 208369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 208377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208390 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1949:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UADDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_S),
     /* 208393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208399 */     GIR_RootConstrainSelectedInstOperands,
     /* 208400 */     // GIR_Coverage, 11744,
     /* 208400 */     GIR_EraseRootFromParent_Done,
     /* 208401 */   // Label 3955: @208401
     /* 208401 */   GIM_Try, /*On fail goto*//*Label 3956*/ GIMT_Encode4(208438), // Rule ID 11745 //
     /* 208406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 208414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208427 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1949:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UADDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_D),
     /* 208430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208436 */     GIR_RootConstrainSelectedInstOperands,
     /* 208437 */     // GIR_Coverage, 11745,
     /* 208437 */     GIR_EraseRootFromParent_Done,
     /* 208438 */   // Label 3956: @208438
     /* 208438 */   GIM_Try, /*On fail goto*//*Label 3957*/ GIMT_Encode4(208475), // Rule ID 11746 //
     /* 208443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 208451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208464 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1877:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_H),
     /* 208467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208473 */     GIR_RootConstrainSelectedInstOperands,
     /* 208474 */     // GIR_Coverage, 11746,
     /* 208474 */     GIR_EraseRootFromParent_Done,
     /* 208475 */   // Label 3957: @208475
     /* 208475 */   GIM_Try, /*On fail goto*//*Label 3958*/ GIMT_Encode4(208512), // Rule ID 11747 //
     /* 208480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 208488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208501 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1877:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_S),
     /* 208504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208508 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208510 */     GIR_RootConstrainSelectedInstOperands,
     /* 208511 */     // GIR_Coverage, 11747,
     /* 208511 */     GIR_EraseRootFromParent_Done,
     /* 208512 */   // Label 3958: @208512
     /* 208512 */   GIM_Try, /*On fail goto*//*Label 3959*/ GIMT_Encode4(208549), // Rule ID 11748 //
     /* 208517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 208525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208538 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1877:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_D),
     /* 208541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208545 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208547 */     GIR_RootConstrainSelectedInstOperands,
     /* 208548 */     // GIR_Coverage, 11748,
     /* 208548 */     GIR_EraseRootFromParent_Done,
     /* 208549 */   // Label 3959: @208549
     /* 208549 */   GIM_Try, /*On fail goto*//*Label 3960*/ GIMT_Encode4(208586), // Rule ID 11749 //
     /* 208554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 208562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208575 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1879:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_H),
     /* 208578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208584 */     GIR_RootConstrainSelectedInstOperands,
     /* 208585 */     // GIR_Coverage, 11749,
     /* 208585 */     GIR_EraseRootFromParent_Done,
     /* 208586 */   // Label 3960: @208586
     /* 208586 */   GIM_Try, /*On fail goto*//*Label 3961*/ GIMT_Encode4(208623), // Rule ID 11750 //
     /* 208591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 208599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208612 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1879:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_S),
     /* 208615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208621 */     GIR_RootConstrainSelectedInstOperands,
     /* 208622 */     // GIR_Coverage, 11750,
     /* 208622 */     GIR_EraseRootFromParent_Done,
     /* 208623 */   // Label 3961: @208623
     /* 208623 */   GIM_Try, /*On fail goto*//*Label 3962*/ GIMT_Encode4(208660), // Rule ID 11751 //
     /* 208628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 208636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208649 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1879:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_D),
     /* 208652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208656 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208658 */     GIR_RootConstrainSelectedInstOperands,
     /* 208659 */     // GIR_Coverage, 11751,
     /* 208659 */     GIR_EraseRootFromParent_Done,
     /* 208660 */   // Label 3962: @208660
     /* 208660 */   GIM_Try, /*On fail goto*//*Label 3963*/ GIMT_Encode4(208697), // Rule ID 11752 //
     /* 208665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 208673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208686 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2073:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_H),
     /* 208689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208693 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208695 */     GIR_RootConstrainSelectedInstOperands,
     /* 208696 */     // GIR_Coverage, 11752,
     /* 208696 */     GIR_EraseRootFromParent_Done,
     /* 208697 */   // Label 3963: @208697
     /* 208697 */   GIM_Try, /*On fail goto*//*Label 3964*/ GIMT_Encode4(208734), // Rule ID 11753 //
     /* 208702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 208710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208723 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2073:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_S),
     /* 208726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208732 */     GIR_RootConstrainSelectedInstOperands,
     /* 208733 */     // GIR_Coverage, 11753,
     /* 208733 */     GIR_EraseRootFromParent_Done,
     /* 208734 */   // Label 3964: @208734
     /* 208734 */   GIM_Try, /*On fail goto*//*Label 3965*/ GIMT_Encode4(208771), // Rule ID 11754 //
     /* 208739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 208747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208760 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2073:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_D),
     /* 208763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208767 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208769 */     GIR_RootConstrainSelectedInstOperands,
     /* 208770 */     // GIR_Coverage, 11754,
     /* 208770 */     GIR_EraseRootFromParent_Done,
     /* 208771 */   // Label 3965: @208771
     /* 208771 */   GIM_Try, /*On fail goto*//*Label 3966*/ GIMT_Encode4(208808), // Rule ID 11755 //
     /* 208776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 208784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208797 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2074:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_H),
     /* 208800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208804 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208806 */     GIR_RootConstrainSelectedInstOperands,
     /* 208807 */     // GIR_Coverage, 11755,
     /* 208807 */     GIR_EraseRootFromParent_Done,
     /* 208808 */   // Label 3966: @208808
     /* 208808 */   GIM_Try, /*On fail goto*//*Label 3967*/ GIMT_Encode4(208845), // Rule ID 11756 //
     /* 208813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 208821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208834 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2074:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_S),
     /* 208837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208841 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208843 */     GIR_RootConstrainSelectedInstOperands,
     /* 208844 */     // GIR_Coverage, 11756,
     /* 208844 */     GIR_EraseRootFromParent_Done,
     /* 208845 */   // Label 3967: @208845
     /* 208845 */   GIM_Try, /*On fail goto*//*Label 3968*/ GIMT_Encode4(208882), // Rule ID 11757 //
     /* 208850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 208858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208871 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2074:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_D),
     /* 208874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208880 */     GIR_RootConstrainSelectedInstOperands,
     /* 208881 */     // GIR_Coverage, 11757,
     /* 208881 */     GIR_EraseRootFromParent_Done,
     /* 208882 */   // Label 3968: @208882
     /* 208882 */   GIM_Try, /*On fail goto*//*Label 3969*/ GIMT_Encode4(208919), // Rule ID 11758 //
     /* 208887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 208895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208908 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1695:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SABDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_H),
     /* 208911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208917 */     GIR_RootConstrainSelectedInstOperands,
     /* 208918 */     // GIR_Coverage, 11758,
     /* 208918 */     GIR_EraseRootFromParent_Done,
     /* 208919 */   // Label 3969: @208919
     /* 208919 */   GIM_Try, /*On fail goto*//*Label 3970*/ GIMT_Encode4(208956), // Rule ID 11759 //
     /* 208924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 208932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208945 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1695:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SABDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_S),
     /* 208948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208954 */     GIR_RootConstrainSelectedInstOperands,
     /* 208955 */     // GIR_Coverage, 11759,
     /* 208955 */     GIR_EraseRootFromParent_Done,
     /* 208956 */   // Label 3970: @208956
     /* 208956 */   GIM_Try, /*On fail goto*//*Label 3971*/ GIMT_Encode4(208993), // Rule ID 11760 //
     /* 208961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 208969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208982 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1695:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SABDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_D),
     /* 208985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208991 */     GIR_RootConstrainSelectedInstOperands,
     /* 208992 */     // GIR_Coverage, 11760,
     /* 208992 */     GIR_EraseRootFromParent_Done,
     /* 208993 */   // Label 3971: @208993
     /* 208993 */   GIM_Try, /*On fail goto*//*Label 3972*/ GIMT_Encode4(209030), // Rule ID 11761 //
     /* 208998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 209006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209019 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1696:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SABDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_H),
     /* 209022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209028 */     GIR_RootConstrainSelectedInstOperands,
     /* 209029 */     // GIR_Coverage, 11761,
     /* 209029 */     GIR_EraseRootFromParent_Done,
     /* 209030 */   // Label 3972: @209030
     /* 209030 */   GIM_Try, /*On fail goto*//*Label 3973*/ GIMT_Encode4(209067), // Rule ID 11762 //
     /* 209035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 209043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209056 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1696:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SABDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_S),
     /* 209059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209065 */     GIR_RootConstrainSelectedInstOperands,
     /* 209066 */     // GIR_Coverage, 11762,
     /* 209066 */     GIR_EraseRootFromParent_Done,
     /* 209067 */   // Label 3973: @209067
     /* 209067 */   GIM_Try, /*On fail goto*//*Label 3974*/ GIMT_Encode4(209104), // Rule ID 11763 //
     /* 209072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 209080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209093 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1696:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SABDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_D),
     /* 209096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209102 */     GIR_RootConstrainSelectedInstOperands,
     /* 209103 */     // GIR_Coverage, 11763,
     /* 209103 */     GIR_EraseRootFromParent_Done,
     /* 209104 */   // Label 3974: @209104
     /* 209104 */   GIM_Try, /*On fail goto*//*Label 3975*/ GIMT_Encode4(209141), // Rule ID 11764 //
     /* 209109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 209117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209130 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1945:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UABDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_H),
     /* 209133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209139 */     GIR_RootConstrainSelectedInstOperands,
     /* 209140 */     // GIR_Coverage, 11764,
     /* 209140 */     GIR_EraseRootFromParent_Done,
     /* 209141 */   // Label 3975: @209141
     /* 209141 */   GIM_Try, /*On fail goto*//*Label 3976*/ GIMT_Encode4(209178), // Rule ID 11765 //
     /* 209146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 209154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209167 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1945:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UABDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_S),
     /* 209170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209176 */     GIR_RootConstrainSelectedInstOperands,
     /* 209177 */     // GIR_Coverage, 11765,
     /* 209177 */     GIR_EraseRootFromParent_Done,
     /* 209178 */   // Label 3976: @209178
     /* 209178 */   GIM_Try, /*On fail goto*//*Label 3977*/ GIMT_Encode4(209215), // Rule ID 11766 //
     /* 209183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 209191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209204 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1945:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UABDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_D),
     /* 209207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209211 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209213 */     GIR_RootConstrainSelectedInstOperands,
     /* 209214 */     // GIR_Coverage, 11766,
     /* 209214 */     GIR_EraseRootFromParent_Done,
     /* 209215 */   // Label 3977: @209215
     /* 209215 */   GIM_Try, /*On fail goto*//*Label 3978*/ GIMT_Encode4(209252), // Rule ID 11767 //
     /* 209220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 209228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209241 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1946:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UABDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_H),
     /* 209244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209250 */     GIR_RootConstrainSelectedInstOperands,
     /* 209251 */     // GIR_Coverage, 11767,
     /* 209251 */     GIR_EraseRootFromParent_Done,
     /* 209252 */   // Label 3978: @209252
     /* 209252 */   GIM_Try, /*On fail goto*//*Label 3979*/ GIMT_Encode4(209289), // Rule ID 11768 //
     /* 209257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 209265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209278 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1946:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UABDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_S),
     /* 209281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209287 */     GIR_RootConstrainSelectedInstOperands,
     /* 209288 */     // GIR_Coverage, 11768,
     /* 209288 */     GIR_EraseRootFromParent_Done,
     /* 209289 */   // Label 3979: @209289
     /* 209289 */   GIM_Try, /*On fail goto*//*Label 3980*/ GIMT_Encode4(209326), // Rule ID 11769 //
     /* 209294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 209302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209315 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1946:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UABDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_D),
     /* 209318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209322 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209324 */     GIR_RootConstrainSelectedInstOperands,
     /* 209325 */     // GIR_Coverage, 11769,
     /* 209325 */     GIR_EraseRootFromParent_Done,
     /* 209326 */   // Label 3980: @209326
     /* 209326 */   GIM_Try, /*On fail goto*//*Label 3981*/ GIMT_Encode4(209363), // Rule ID 11779 //
     /* 209331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 209339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209352 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1881:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBWB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_H),
     /* 209355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209359 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209361 */     GIR_RootConstrainSelectedInstOperands,
     /* 209362 */     // GIR_Coverage, 11779,
     /* 209362 */     GIR_EraseRootFromParent_Done,
     /* 209363 */   // Label 3981: @209363
     /* 209363 */   GIM_Try, /*On fail goto*//*Label 3982*/ GIMT_Encode4(209400), // Rule ID 11780 //
     /* 209368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 209376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209389 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1881:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBWB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_S),
     /* 209392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209396 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209398 */     GIR_RootConstrainSelectedInstOperands,
     /* 209399 */     // GIR_Coverage, 11780,
     /* 209399 */     GIR_EraseRootFromParent_Done,
     /* 209400 */   // Label 3982: @209400
     /* 209400 */   GIM_Try, /*On fail goto*//*Label 3983*/ GIMT_Encode4(209437), // Rule ID 11781 //
     /* 209405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 209413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209426 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1881:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBWB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_D),
     /* 209429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209435 */     GIR_RootConstrainSelectedInstOperands,
     /* 209436 */     // GIR_Coverage, 11781,
     /* 209436 */     GIR_EraseRootFromParent_Done,
     /* 209437 */   // Label 3983: @209437
     /* 209437 */   GIM_Try, /*On fail goto*//*Label 3984*/ GIMT_Encode4(209474), // Rule ID 11782 //
     /* 209442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 209450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209463 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1882:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBWT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_H),
     /* 209466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209472 */     GIR_RootConstrainSelectedInstOperands,
     /* 209473 */     // GIR_Coverage, 11782,
     /* 209473 */     GIR_EraseRootFromParent_Done,
     /* 209474 */   // Label 3984: @209474
     /* 209474 */   GIM_Try, /*On fail goto*//*Label 3985*/ GIMT_Encode4(209511), // Rule ID 11783 //
     /* 209479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 209487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209500 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1882:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBWT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_S),
     /* 209503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209507 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209509 */     GIR_RootConstrainSelectedInstOperands,
     /* 209510 */     // GIR_Coverage, 11783,
     /* 209510 */     GIR_EraseRootFromParent_Done,
     /* 209511 */   // Label 3985: @209511
     /* 209511 */   GIM_Try, /*On fail goto*//*Label 3986*/ GIMT_Encode4(209548), // Rule ID 11784 //
     /* 209516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 209524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209537 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1882:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBWT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_D),
     /* 209540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209546 */     GIR_RootConstrainSelectedInstOperands,
     /* 209547 */     // GIR_Coverage, 11784,
     /* 209547 */     GIR_EraseRootFromParent_Done,
     /* 209548 */   // Label 3986: @209548
     /* 209548 */   GIM_Try, /*On fail goto*//*Label 3987*/ GIMT_Encode4(209585), // Rule ID 11785 //
     /* 209553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 209561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209574 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2075:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBWB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_H),
     /* 209577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209581 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209583 */     GIR_RootConstrainSelectedInstOperands,
     /* 209584 */     // GIR_Coverage, 11785,
     /* 209584 */     GIR_EraseRootFromParent_Done,
     /* 209585 */   // Label 3987: @209585
     /* 209585 */   GIM_Try, /*On fail goto*//*Label 3988*/ GIMT_Encode4(209622), // Rule ID 11786 //
     /* 209590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 209598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209611 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2075:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBWB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_S),
     /* 209614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209618 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209620 */     GIR_RootConstrainSelectedInstOperands,
     /* 209621 */     // GIR_Coverage, 11786,
     /* 209621 */     GIR_EraseRootFromParent_Done,
     /* 209622 */   // Label 3988: @209622
     /* 209622 */   GIM_Try, /*On fail goto*//*Label 3989*/ GIMT_Encode4(209659), // Rule ID 11787 //
     /* 209627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 209635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209648 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2075:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBWB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_D),
     /* 209651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209655 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209657 */     GIR_RootConstrainSelectedInstOperands,
     /* 209658 */     // GIR_Coverage, 11787,
     /* 209658 */     GIR_EraseRootFromParent_Done,
     /* 209659 */   // Label 3989: @209659
     /* 209659 */   GIM_Try, /*On fail goto*//*Label 3990*/ GIMT_Encode4(209696), // Rule ID 11788 //
     /* 209664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 209672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209685 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2076:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBWT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_H),
     /* 209688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209692 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209694 */     GIR_RootConstrainSelectedInstOperands,
     /* 209695 */     // GIR_Coverage, 11788,
     /* 209695 */     GIR_EraseRootFromParent_Done,
     /* 209696 */   // Label 3990: @209696
     /* 209696 */   GIM_Try, /*On fail goto*//*Label 3991*/ GIMT_Encode4(209733), // Rule ID 11789 //
     /* 209701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 209709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209722 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2076:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBWT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_S),
     /* 209725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209731 */     GIR_RootConstrainSelectedInstOperands,
     /* 209732 */     // GIR_Coverage, 11789,
     /* 209732 */     GIR_EraseRootFromParent_Done,
     /* 209733 */   // Label 3991: @209733
     /* 209733 */   GIM_Try, /*On fail goto*//*Label 3992*/ GIMT_Encode4(209770), // Rule ID 11790 //
     /* 209738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 209746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209759 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2076:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBWT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_D),
     /* 209762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209766 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209768 */     GIR_RootConstrainSelectedInstOperands,
     /* 209769 */     // GIR_Coverage, 11790,
     /* 209769 */     GIR_EraseRootFromParent_Done,
     /* 209770 */   // Label 3992: @209770
     /* 209770 */   GIM_Try, /*On fail goto*//*Label 3993*/ GIMT_Encode4(209807), // Rule ID 11803 //
     /* 209775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 209783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209796 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1811:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_H),
     /* 209799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209805 */     GIR_RootConstrainSelectedInstOperands,
     /* 209806 */     // GIR_Coverage, 11803,
     /* 209806 */     GIR_EraseRootFromParent_Done,
     /* 209807 */   // Label 3993: @209807
     /* 209807 */   GIM_Try, /*On fail goto*//*Label 3994*/ GIMT_Encode4(209844), // Rule ID 11804 //
     /* 209812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 209820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209833 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1811:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_S),
     /* 209836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209842 */     GIR_RootConstrainSelectedInstOperands,
     /* 209843 */     // GIR_Coverage, 11804,
     /* 209843 */     GIR_EraseRootFromParent_Done,
     /* 209844 */   // Label 3994: @209844
     /* 209844 */   GIM_Try, /*On fail goto*//*Label 3995*/ GIMT_Encode4(209881), // Rule ID 11805 //
     /* 209849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 209857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209870 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1811:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_D),
     /* 209873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209879 */     GIR_RootConstrainSelectedInstOperands,
     /* 209880 */     // GIR_Coverage, 11805,
     /* 209880 */     GIR_EraseRootFromParent_Done,
     /* 209881 */   // Label 3995: @209881
     /* 209881 */   GIM_Try, /*On fail goto*//*Label 3996*/ GIMT_Encode4(209918), // Rule ID 11806 //
     /* 209886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 209894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209907 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1813:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_H),
     /* 209910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209916 */     GIR_RootConstrainSelectedInstOperands,
     /* 209917 */     // GIR_Coverage, 11806,
     /* 209917 */     GIR_EraseRootFromParent_Done,
     /* 209918 */   // Label 3996: @209918
     /* 209918 */   GIM_Try, /*On fail goto*//*Label 3997*/ GIMT_Encode4(209955), // Rule ID 11807 //
     /* 209923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 209931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209944 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1813:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_S),
     /* 209947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209953 */     GIR_RootConstrainSelectedInstOperands,
     /* 209954 */     // GIR_Coverage, 11807,
     /* 209954 */     GIR_EraseRootFromParent_Done,
     /* 209955 */   // Label 3997: @209955
     /* 209955 */   GIM_Try, /*On fail goto*//*Label 3998*/ GIMT_Encode4(209992), // Rule ID 11808 //
     /* 209960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 209968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209981 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1813:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_D),
     /* 209984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209990 */     GIR_RootConstrainSelectedInstOperands,
     /* 209991 */     // GIR_Coverage, 11808,
     /* 209991 */     GIR_EraseRootFromParent_Done,
     /* 209992 */   // Label 3998: @209992
     /* 209992 */   GIM_Try, /*On fail goto*//*Label 3999*/ GIMT_Encode4(210029), // Rule ID 11809 //
     /* 209997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 210005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210018 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1764:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 210018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_H),
     /* 210021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210025 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210027 */     GIR_RootConstrainSelectedInstOperands,
     /* 210028 */     // GIR_Coverage, 11809,
     /* 210028 */     GIR_EraseRootFromParent_Done,
     /* 210029 */   // Label 3999: @210029
     /* 210029 */   GIM_Try, /*On fail goto*//*Label 4000*/ GIMT_Encode4(210066), // Rule ID 11810 //
     /* 210034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 210042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210055 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1764:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_S),
     /* 210058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210064 */     GIR_RootConstrainSelectedInstOperands,
     /* 210065 */     // GIR_Coverage, 11810,
     /* 210065 */     GIR_EraseRootFromParent_Done,
     /* 210066 */   // Label 4000: @210066
     /* 210066 */   GIM_Try, /*On fail goto*//*Label 4001*/ GIMT_Encode4(210103), // Rule ID 11811 //
     /* 210071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 210079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210092 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1764:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_D),
     /* 210095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210101 */     GIR_RootConstrainSelectedInstOperands,
     /* 210102 */     // GIR_Coverage, 11811,
     /* 210102 */     GIR_EraseRootFromParent_Done,
     /* 210103 */   // Label 4001: @210103
     /* 210103 */   GIM_Try, /*On fail goto*//*Label 4002*/ GIMT_Encode4(210140), // Rule ID 11812 //
     /* 210108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 210116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210129 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1766:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 210129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_H),
     /* 210132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210138 */     GIR_RootConstrainSelectedInstOperands,
     /* 210139 */     // GIR_Coverage, 11812,
     /* 210139 */     GIR_EraseRootFromParent_Done,
     /* 210140 */   // Label 4002: @210140
     /* 210140 */   GIM_Try, /*On fail goto*//*Label 4003*/ GIMT_Encode4(210177), // Rule ID 11813 //
     /* 210145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 210153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210166 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1766:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_S),
     /* 210169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210175 */     GIR_RootConstrainSelectedInstOperands,
     /* 210176 */     // GIR_Coverage, 11813,
     /* 210176 */     GIR_EraseRootFromParent_Done,
     /* 210177 */   // Label 4003: @210177
     /* 210177 */   GIM_Try, /*On fail goto*//*Label 4004*/ GIMT_Encode4(210214), // Rule ID 11814 //
     /* 210182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 210190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210203 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1766:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_D),
     /* 210206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210212 */     GIR_RootConstrainSelectedInstOperands,
     /* 210213 */     // GIR_Coverage, 11814,
     /* 210213 */     GIR_EraseRootFromParent_Done,
     /* 210214 */   // Label 4004: @210214
     /* 210214 */   GIM_Try, /*On fail goto*//*Label 4005*/ GIMT_Encode4(210251), // Rule ID 11815 //
     /* 210219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 210227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210240 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2002:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 210240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_H),
     /* 210243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210247 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210249 */     GIR_RootConstrainSelectedInstOperands,
     /* 210250 */     // GIR_Coverage, 11815,
     /* 210250 */     GIR_EraseRootFromParent_Done,
     /* 210251 */   // Label 4005: @210251
     /* 210251 */   GIM_Try, /*On fail goto*//*Label 4006*/ GIMT_Encode4(210288), // Rule ID 11816 //
     /* 210256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 210264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210277 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2002:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_S),
     /* 210280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210284 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210286 */     GIR_RootConstrainSelectedInstOperands,
     /* 210287 */     // GIR_Coverage, 11816,
     /* 210287 */     GIR_EraseRootFromParent_Done,
     /* 210288 */   // Label 4006: @210288
     /* 210288 */   GIM_Try, /*On fail goto*//*Label 4007*/ GIMT_Encode4(210325), // Rule ID 11817 //
     /* 210293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 210301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210314 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2002:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_D),
     /* 210317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210323 */     GIR_RootConstrainSelectedInstOperands,
     /* 210324 */     // GIR_Coverage, 11817,
     /* 210324 */     GIR_EraseRootFromParent_Done,
     /* 210325 */   // Label 4007: @210325
     /* 210325 */   GIM_Try, /*On fail goto*//*Label 4008*/ GIMT_Encode4(210362), // Rule ID 11818 //
     /* 210330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 210338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210351 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2004:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 210351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_H),
     /* 210354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210358 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210360 */     GIR_RootConstrainSelectedInstOperands,
     /* 210361 */     // GIR_Coverage, 11818,
     /* 210361 */     GIR_EraseRootFromParent_Done,
     /* 210362 */   // Label 4008: @210362
     /* 210362 */   GIM_Try, /*On fail goto*//*Label 4009*/ GIMT_Encode4(210399), // Rule ID 11819 //
     /* 210367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 210375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210388 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2004:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_S),
     /* 210391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210395 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210397 */     GIR_RootConstrainSelectedInstOperands,
     /* 210398 */     // GIR_Coverage, 11819,
     /* 210398 */     GIR_EraseRootFromParent_Done,
     /* 210399 */   // Label 4009: @210399
     /* 210399 */   GIM_Try, /*On fail goto*//*Label 4010*/ GIMT_Encode4(210436), // Rule ID 11820 //
     /* 210404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 210412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210425 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2004:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_D),
     /* 210428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210432 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210434 */     GIR_RootConstrainSelectedInstOperands,
     /* 210435 */     // GIR_Coverage, 11820,
     /* 210435 */     GIR_EraseRootFromParent_Done,
     /* 210436 */   // Label 4010: @210436
     /* 210436 */   GIM_Try, /*On fail goto*//*Label 4011*/ GIMT_Encode4(210473), // Rule ID 11821 //
     /* 210441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 210449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 210452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210462 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1642:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMULLT_ZZZ_H:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 210462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_H),
     /* 210465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210471 */     GIR_RootConstrainSelectedInstOperands,
     /* 210472 */     // GIR_Coverage, 11821,
     /* 210472 */     GIR_EraseRootFromParent_Done,
     /* 210473 */   // Label 4011: @210473
     /* 210473 */   GIM_Try, /*On fail goto*//*Label 4012*/ GIMT_Encode4(210510), // Rule ID 11822 //
     /* 210478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 210486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210499 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1642:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (PMULLT_ZZZ_D:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_D),
     /* 210502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210508 */     GIR_RootConstrainSelectedInstOperands,
     /* 210509 */     // GIR_Coverage, 11822,
     /* 210509 */     GIR_EraseRootFromParent_Done,
     /* 210510 */   // Label 4012: @210510
     /* 210510 */   GIM_Try, /*On fail goto*//*Label 4013*/ GIMT_Encode4(210547), // Rule ID 11923 //
     /* 210515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 210523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 210526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210536 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1672:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (RADDHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_B),
     /* 210539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210545 */     GIR_RootConstrainSelectedInstOperands,
     /* 210546 */     // GIR_Coverage, 11923,
     /* 210546 */     GIR_EraseRootFromParent_Done,
     /* 210547 */   // Label 4013: @210547
     /* 210547 */   GIM_Try, /*On fail goto*//*Label 4014*/ GIMT_Encode4(210584), // Rule ID 11924 //
     /* 210552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 210560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210573 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1672:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (RADDHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_H),
     /* 210576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210582 */     GIR_RootConstrainSelectedInstOperands,
     /* 210583 */     // GIR_Coverage, 11924,
     /* 210583 */     GIR_EraseRootFromParent_Done,
     /* 210584 */   // Label 4014: @210584
     /* 210584 */   GIM_Try, /*On fail goto*//*Label 4015*/ GIMT_Encode4(210621), // Rule ID 11925 //
     /* 210589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 210597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 210603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 210606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210610 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1672:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RADDHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 210610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_S),
     /* 210613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210617 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210619 */     GIR_RootConstrainSelectedInstOperands,
     /* 210620 */     // GIR_Coverage, 11925,
     /* 210620 */     GIR_EraseRootFromParent_Done,
     /* 210621 */   // Label 4015: @210621
     /* 210621 */   GIM_Try, /*On fail goto*//*Label 4016*/ GIMT_Encode4(210658), // Rule ID 11926 //
     /* 210626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 210634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 210637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210647 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1913:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUBHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_B),
     /* 210650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210656 */     GIR_RootConstrainSelectedInstOperands,
     /* 210657 */     // GIR_Coverage, 11926,
     /* 210657 */     GIR_EraseRootFromParent_Done,
     /* 210658 */   // Label 4016: @210658
     /* 210658 */   GIM_Try, /*On fail goto*//*Label 4017*/ GIMT_Encode4(210695), // Rule ID 11927 //
     /* 210663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 210671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210684 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1913:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUBHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_H),
     /* 210687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210693 */     GIR_RootConstrainSelectedInstOperands,
     /* 210694 */     // GIR_Coverage, 11927,
     /* 210694 */     GIR_EraseRootFromParent_Done,
     /* 210695 */   // Label 4017: @210695
     /* 210695 */   GIM_Try, /*On fail goto*//*Label 4018*/ GIMT_Encode4(210732), // Rule ID 11928 //
     /* 210700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 210708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 210714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 210717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210721 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1913:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUBHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 210721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_S),
     /* 210724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210728 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210730 */     GIR_RootConstrainSelectedInstOperands,
     /* 210731 */     // GIR_Coverage, 11928,
     /* 210731 */     GIR_EraseRootFromParent_Done,
     /* 210732 */   // Label 4018: @210732
     /* 210732 */   GIM_Try, /*On fail goto*//*Label 4019*/ GIMT_Encode4(210769), // Rule ID 11929 //
     /* 210737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 210745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 210748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210758 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1688:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (RSUBHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_B),
     /* 210761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210765 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210767 */     GIR_RootConstrainSelectedInstOperands,
     /* 210768 */     // GIR_Coverage, 11929,
     /* 210768 */     GIR_EraseRootFromParent_Done,
     /* 210769 */   // Label 4019: @210769
     /* 210769 */   GIM_Try, /*On fail goto*//*Label 4020*/ GIMT_Encode4(210806), // Rule ID 11930 //
     /* 210774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 210782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210795 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1688:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (RSUBHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_H),
     /* 210798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210802 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210804 */     GIR_RootConstrainSelectedInstOperands,
     /* 210805 */     // GIR_Coverage, 11930,
     /* 210805 */     GIR_EraseRootFromParent_Done,
     /* 210806 */   // Label 4020: @210806
     /* 210806 */   GIM_Try, /*On fail goto*//*Label 4021*/ GIMT_Encode4(210843), // Rule ID 11931 //
     /* 210811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 210819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 210825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 210828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210832 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1688:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RSUBHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 210832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_S),
     /* 210835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210841 */     GIR_RootConstrainSelectedInstOperands,
     /* 210842 */     // GIR_Coverage, 11931,
     /* 210842 */     GIR_EraseRootFromParent_Done,
     /* 210843 */   // Label 4021: @210843
     /* 210843 */   GIM_Try, /*On fail goto*//*Label 4022*/ GIMT_Encode4(210880), // Rule ID 11947 //
     /* 210848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 210856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 210859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210869 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2055:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQXTNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_B),
     /* 210872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210878 */     GIR_RootConstrainSelectedInstOperands,
     /* 210879 */     // GIR_Coverage, 11947,
     /* 210879 */     GIR_EraseRootFromParent_Done,
     /* 210880 */   // Label 4022: @210880
     /* 210880 */   GIM_Try, /*On fail goto*//*Label 4023*/ GIMT_Encode4(210917), // Rule ID 11948 //
     /* 210885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 210893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210906 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2055:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQXTNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_H),
     /* 210909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210913 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210915 */     GIR_RootConstrainSelectedInstOperands,
     /* 210916 */     // GIR_Coverage, 11948,
     /* 210916 */     GIR_EraseRootFromParent_Done,
     /* 210917 */   // Label 4023: @210917
     /* 210917 */   GIM_Try, /*On fail goto*//*Label 4024*/ GIMT_Encode4(210954), // Rule ID 11949 //
     /* 210922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 210930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 210939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210943 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2055:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQXTNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 210943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_S),
     /* 210946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210950 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210952 */     GIR_RootConstrainSelectedInstOperands,
     /* 210953 */     // GIR_Coverage, 11949,
     /* 210953 */     GIR_EraseRootFromParent_Done,
     /* 210954 */   // Label 4024: @210954
     /* 210954 */   GIM_Try, /*On fail goto*//*Label 4025*/ GIMT_Encode4(210991), // Rule ID 11950 //
     /* 210959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 210967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 210970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210980 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1864:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQXTUNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_B),
     /* 210983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210987 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210989 */     GIR_RootConstrainSelectedInstOperands,
     /* 210990 */     // GIR_Coverage, 11950,
     /* 210990 */     GIR_EraseRootFromParent_Done,
     /* 210991 */   // Label 4025: @210991
     /* 210991 */   GIM_Try, /*On fail goto*//*Label 4026*/ GIMT_Encode4(211028), // Rule ID 11951 //
     /* 210996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 211004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211017 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1864:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQXTUNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 211017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_H),
     /* 211020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211026 */     GIR_RootConstrainSelectedInstOperands,
     /* 211027 */     // GIR_Coverage, 11951,
     /* 211027 */     GIR_EraseRootFromParent_Done,
     /* 211028 */   // Label 4026: @211028
     /* 211028 */   GIM_Try, /*On fail goto*//*Label 4027*/ GIMT_Encode4(211065), // Rule ID 11952 //
     /* 211033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 211041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211054 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1864:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQXTUNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 211054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_S),
     /* 211057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211063 */     GIR_RootConstrainSelectedInstOperands,
     /* 211064 */     // GIR_Coverage, 11952,
     /* 211064 */     GIR_EraseRootFromParent_Done,
     /* 211065 */   // Label 4027: @211065
     /* 211065 */   GIM_Try, /*On fail goto*//*Label 4028*/ GIMT_Encode4(211102), // Rule ID 11968 //
     /* 211070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 211078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211091 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1878:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 211091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_H),
     /* 211094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211098 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211100 */     GIR_RootConstrainSelectedInstOperands,
     /* 211101 */     // GIR_Coverage, 11968,
     /* 211101 */     GIR_EraseRootFromParent_Done,
     /* 211102 */   // Label 4028: @211102
     /* 211102 */   GIM_Try, /*On fail goto*//*Label 4029*/ GIMT_Encode4(211139), // Rule ID 11969 //
     /* 211107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 211115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211128 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1878:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 211128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_S),
     /* 211131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211137 */     GIR_RootConstrainSelectedInstOperands,
     /* 211138 */     // GIR_Coverage, 11969,
     /* 211138 */     GIR_EraseRootFromParent_Done,
     /* 211139 */   // Label 4029: @211139
     /* 211139 */   GIM_Try, /*On fail goto*//*Label 4030*/ GIMT_Encode4(211176), // Rule ID 11970 //
     /* 211144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 211152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211165 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1878:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 211165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_D),
     /* 211168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211170 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211172 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211174 */     GIR_RootConstrainSelectedInstOperands,
     /* 211175 */     // GIR_Coverage, 11970,
     /* 211175 */     GIR_EraseRootFromParent_Done,
     /* 211176 */   // Label 4030: @211176
     /* 211176 */   GIM_Try, /*On fail goto*//*Label 4031*/ GIMT_Encode4(211213), // Rule ID 11971 //
     /* 211181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 211189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211202 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1880:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLTB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 211202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_H),
     /* 211205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211211 */     GIR_RootConstrainSelectedInstOperands,
     /* 211212 */     // GIR_Coverage, 11971,
     /* 211212 */     GIR_EraseRootFromParent_Done,
     /* 211213 */   // Label 4031: @211213
     /* 211213 */   GIM_Try, /*On fail goto*//*Label 4032*/ GIMT_Encode4(211250), // Rule ID 11972 //
     /* 211218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 211226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211239 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1880:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLTB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 211239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_S),
     /* 211242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211246 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211248 */     GIR_RootConstrainSelectedInstOperands,
     /* 211249 */     // GIR_Coverage, 11972,
     /* 211249 */     GIR_EraseRootFromParent_Done,
     /* 211250 */   // Label 4032: @211250
     /* 211250 */   GIM_Try, /*On fail goto*//*Label 4033*/ GIMT_Encode4(211287), // Rule ID 11973 //
     /* 211255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 211263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211276 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1880:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLTB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 211276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_D),
     /* 211279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211285 */     GIR_RootConstrainSelectedInstOperands,
     /* 211286 */     // GIR_Coverage, 11973,
     /* 211286 */     GIR_EraseRootFromParent_Done,
     /* 211287 */   // Label 4033: @211287
     /* 211287 */   GIM_Try, /*On fail goto*//*Label 4034*/ GIMT_Encode4(211327), // Rule ID 12060 //
     /* 211292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 211300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 211303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211313 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2100:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_B),
     /* 211316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211320 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211322 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211325 */     GIR_RootConstrainSelectedInstOperands,
     /* 211326 */     // GIR_Coverage, 12060,
     /* 211326 */     GIR_EraseRootFromParent_Done,
     /* 211327 */   // Label 4034: @211327
     /* 211327 */   GIM_Try, /*On fail goto*//*Label 4035*/ GIMT_Encode4(211367), // Rule ID 12061 //
     /* 211332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 211340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 211343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211353 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2100:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_H),
     /* 211356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211362 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211365 */     GIR_RootConstrainSelectedInstOperands,
     /* 211366 */     // GIR_Coverage, 12061,
     /* 211366 */     GIR_EraseRootFromParent_Done,
     /* 211367 */   // Label 4035: @211367
     /* 211367 */   GIM_Try, /*On fail goto*//*Label 4036*/ GIMT_Encode4(211407), // Rule ID 12062 //
     /* 211372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 211380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 211383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211393 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2100:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_S),
     /* 211396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211402 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211405 */     GIR_RootConstrainSelectedInstOperands,
     /* 211406 */     // GIR_Coverage, 12062,
     /* 211406 */     GIR_EraseRootFromParent_Done,
     /* 211407 */   // Label 4036: @211407
     /* 211407 */   GIM_Try, /*On fail goto*//*Label 4037*/ GIMT_Encode4(211447), // Rule ID 12063 //
     /* 211412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 211420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 211423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211433 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2100:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_D),
     /* 211436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211442 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211445 */     GIR_RootConstrainSelectedInstOperands,
     /* 211446 */     // GIR_Coverage, 12063,
     /* 211446 */     GIR_EraseRootFromParent_Done,
     /* 211447 */   // Label 4037: @211447
     /* 211447 */   GIM_Try, /*On fail goto*//*Label 4038*/ GIMT_Encode4(211487), // Rule ID 12064 //
     /* 211452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 211460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 211463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211473 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2106:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_B),
     /* 211476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211482 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211485 */     GIR_RootConstrainSelectedInstOperands,
     /* 211486 */     // GIR_Coverage, 12064,
     /* 211486 */     GIR_EraseRootFromParent_Done,
     /* 211487 */   // Label 4038: @211487
     /* 211487 */   GIM_Try, /*On fail goto*//*Label 4039*/ GIMT_Encode4(211527), // Rule ID 12065 //
     /* 211492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 211500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 211503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211513 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2106:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_H),
     /* 211516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211522 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211525 */     GIR_RootConstrainSelectedInstOperands,
     /* 211526 */     // GIR_Coverage, 12065,
     /* 211526 */     GIR_EraseRootFromParent_Done,
     /* 211527 */   // Label 4039: @211527
     /* 211527 */   GIM_Try, /*On fail goto*//*Label 4040*/ GIMT_Encode4(211567), // Rule ID 12066 //
     /* 211532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 211540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 211543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211553 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2106:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_S),
     /* 211556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211562 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211565 */     GIR_RootConstrainSelectedInstOperands,
     /* 211566 */     // GIR_Coverage, 12066,
     /* 211566 */     GIR_EraseRootFromParent_Done,
     /* 211567 */   // Label 4040: @211567
     /* 211567 */   GIM_Try, /*On fail goto*//*Label 4041*/ GIMT_Encode4(211607), // Rule ID 12067 //
     /* 211572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 211580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 211583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211593 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2106:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_D),
     /* 211596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211602 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211605 */     GIR_RootConstrainSelectedInstOperands,
     /* 211606 */     // GIR_Coverage, 12067,
     /* 211606 */     GIR_EraseRootFromParent_Done,
     /* 211607 */   // Label 4041: @211607
     /* 211607 */   GIM_Try, /*On fail goto*//*Label 4042*/ GIMT_Encode4(211647), // Rule ID 12072 //
     /* 211612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 211620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 211623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211633 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2118:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_B),
     /* 211636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211642 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211645 */     GIR_RootConstrainSelectedInstOperands,
     /* 211646 */     // GIR_Coverage, 12072,
     /* 211646 */     GIR_EraseRootFromParent_Done,
     /* 211647 */   // Label 4042: @211647
     /* 211647 */   GIM_Try, /*On fail goto*//*Label 4043*/ GIMT_Encode4(211687), // Rule ID 12073 //
     /* 211652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 211660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 211663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211673 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2118:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_H),
     /* 211676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211682 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211685 */     GIR_RootConstrainSelectedInstOperands,
     /* 211686 */     // GIR_Coverage, 12073,
     /* 211686 */     GIR_EraseRootFromParent_Done,
     /* 211687 */   // Label 4043: @211687
     /* 211687 */   GIM_Try, /*On fail goto*//*Label 4044*/ GIMT_Encode4(211727), // Rule ID 12074 //
     /* 211692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 211700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 211703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211713 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2118:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_S),
     /* 211716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211720 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211722 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211725 */     GIR_RootConstrainSelectedInstOperands,
     /* 211726 */     // GIR_Coverage, 12074,
     /* 211726 */     GIR_EraseRootFromParent_Done,
     /* 211727 */   // Label 4044: @211727
     /* 211727 */   GIM_Try, /*On fail goto*//*Label 4045*/ GIMT_Encode4(211767), // Rule ID 12075 //
     /* 211732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 211740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 211743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211753 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2118:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_D),
     /* 211756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211762 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211765 */     GIR_RootConstrainSelectedInstOperands,
     /* 211766 */     // GIR_Coverage, 12075,
     /* 211766 */     GIR_EraseRootFromParent_Done,
     /* 211767 */   // Label 4045: @211767
     /* 211767 */   GIM_Try, /*On fail goto*//*Label 4046*/ GIMT_Encode4(211807), // Rule ID 12076 //
     /* 211772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 211780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 211783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211793 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2112:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_B),
     /* 211796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211802 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211805 */     GIR_RootConstrainSelectedInstOperands,
     /* 211806 */     // GIR_Coverage, 12076,
     /* 211806 */     GIR_EraseRootFromParent_Done,
     /* 211807 */   // Label 4046: @211807
     /* 211807 */   GIM_Try, /*On fail goto*//*Label 4047*/ GIMT_Encode4(211847), // Rule ID 12077 //
     /* 211812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 211820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 211823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211833 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2112:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_H),
     /* 211836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211842 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211845 */     GIR_RootConstrainSelectedInstOperands,
     /* 211846 */     // GIR_Coverage, 12077,
     /* 211846 */     GIR_EraseRootFromParent_Done,
     /* 211847 */   // Label 4047: @211847
     /* 211847 */   GIM_Try, /*On fail goto*//*Label 4048*/ GIMT_Encode4(211887), // Rule ID 12078 //
     /* 211852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 211860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 211863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211873 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2112:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_S),
     /* 211876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211882 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211885 */     GIR_RootConstrainSelectedInstOperands,
     /* 211886 */     // GIR_Coverage, 12078,
     /* 211886 */     GIR_EraseRootFromParent_Done,
     /* 211887 */   // Label 4048: @211887
     /* 211887 */   GIM_Try, /*On fail goto*//*Label 4049*/ GIMT_Encode4(211927), // Rule ID 12079 //
     /* 211892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 211900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 211903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211913 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2112:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_D),
     /* 211916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211922 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211925 */     GIR_RootConstrainSelectedInstOperands,
     /* 211926 */     // GIR_Coverage, 12079,
     /* 211926 */     GIR_EraseRootFromParent_Done,
     /* 211927 */   // Label 4049: @211927
     /* 211927 */   GIM_Try, /*On fail goto*//*Label 4050*/ GIMT_Encode4(211967), // Rule ID 12084 //
     /* 211932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 211940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 211943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 211946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 211949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211953 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2100:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 211953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_B),
     /* 211956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211962 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211965 */     GIR_RootConstrainSelectedInstOperands,
     /* 211966 */     // GIR_Coverage, 12084,
     /* 211966 */     GIR_EraseRootFromParent_Done,
     /* 211967 */   // Label 4050: @211967
     /* 211967 */   GIM_Try, /*On fail goto*//*Label 4051*/ GIMT_Encode4(212007), // Rule ID 12085 //
     /* 211972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 211980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 211983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 211986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 211989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211993 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2100:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 211993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_H),
     /* 211996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212002 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212005 */     GIR_RootConstrainSelectedInstOperands,
     /* 212006 */     // GIR_Coverage, 12085,
     /* 212006 */     GIR_EraseRootFromParent_Done,
     /* 212007 */   // Label 4051: @212007
     /* 212007 */   GIM_Try, /*On fail goto*//*Label 4052*/ GIMT_Encode4(212047), // Rule ID 12086 //
     /* 212012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 212020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 212023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212033 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2100:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_S),
     /* 212036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212042 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212045 */     GIR_RootConstrainSelectedInstOperands,
     /* 212046 */     // GIR_Coverage, 12086,
     /* 212046 */     GIR_EraseRootFromParent_Done,
     /* 212047 */   // Label 4052: @212047
     /* 212047 */   GIM_Try, /*On fail goto*//*Label 4053*/ GIMT_Encode4(212087), // Rule ID 12087 //
     /* 212052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 212060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 212063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212073 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2100:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_D),
     /* 212076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212082 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212085 */     GIR_RootConstrainSelectedInstOperands,
     /* 212086 */     // GIR_Coverage, 12087,
     /* 212086 */     GIR_EraseRootFromParent_Done,
     /* 212087 */   // Label 4053: @212087
     /* 212087 */   GIM_Try, /*On fail goto*//*Label 4054*/ GIMT_Encode4(212127), // Rule ID 12088 //
     /* 212092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 212100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 212103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212113 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2106:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_B),
     /* 212116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212122 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212125 */     GIR_RootConstrainSelectedInstOperands,
     /* 212126 */     // GIR_Coverage, 12088,
     /* 212126 */     GIR_EraseRootFromParent_Done,
     /* 212127 */   // Label 4054: @212127
     /* 212127 */   GIM_Try, /*On fail goto*//*Label 4055*/ GIMT_Encode4(212167), // Rule ID 12089 //
     /* 212132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 212140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 212143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212153 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2106:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_H),
     /* 212156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212162 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212165 */     GIR_RootConstrainSelectedInstOperands,
     /* 212166 */     // GIR_Coverage, 12089,
     /* 212166 */     GIR_EraseRootFromParent_Done,
     /* 212167 */   // Label 4055: @212167
     /* 212167 */   GIM_Try, /*On fail goto*//*Label 4056*/ GIMT_Encode4(212207), // Rule ID 12090 //
     /* 212172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 212180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 212183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212193 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2106:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_S),
     /* 212196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212202 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212205 */     GIR_RootConstrainSelectedInstOperands,
     /* 212206 */     // GIR_Coverage, 12090,
     /* 212206 */     GIR_EraseRootFromParent_Done,
     /* 212207 */   // Label 4056: @212207
     /* 212207 */   GIM_Try, /*On fail goto*//*Label 4057*/ GIMT_Encode4(212247), // Rule ID 12091 //
     /* 212212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 212220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 212223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212233 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2106:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_D),
     /* 212236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212242 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212245 */     GIR_RootConstrainSelectedInstOperands,
     /* 212246 */     // GIR_Coverage, 12091,
     /* 212246 */     GIR_EraseRootFromParent_Done,
     /* 212247 */   // Label 4057: @212247
     /* 212247 */   GIM_Try, /*On fail goto*//*Label 4058*/ GIMT_Encode4(212287), // Rule ID 12096 //
     /* 212252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 212260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 212263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212273 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2118:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_B),
     /* 212276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212282 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212285 */     GIR_RootConstrainSelectedInstOperands,
     /* 212286 */     // GIR_Coverage, 12096,
     /* 212286 */     GIR_EraseRootFromParent_Done,
     /* 212287 */   // Label 4058: @212287
     /* 212287 */   GIM_Try, /*On fail goto*//*Label 4059*/ GIMT_Encode4(212327), // Rule ID 12097 //
     /* 212292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 212300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 212303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212313 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2118:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_H),
     /* 212316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212320 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212322 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212325 */     GIR_RootConstrainSelectedInstOperands,
     /* 212326 */     // GIR_Coverage, 12097,
     /* 212326 */     GIR_EraseRootFromParent_Done,
     /* 212327 */   // Label 4059: @212327
     /* 212327 */   GIM_Try, /*On fail goto*//*Label 4060*/ GIMT_Encode4(212367), // Rule ID 12098 //
     /* 212332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 212340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 212343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212353 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2118:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_S),
     /* 212356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212362 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212365 */     GIR_RootConstrainSelectedInstOperands,
     /* 212366 */     // GIR_Coverage, 12098,
     /* 212366 */     GIR_EraseRootFromParent_Done,
     /* 212367 */   // Label 4060: @212367
     /* 212367 */   GIM_Try, /*On fail goto*//*Label 4061*/ GIMT_Encode4(212407), // Rule ID 12099 //
     /* 212372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 212380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 212383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212393 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2118:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_D),
     /* 212396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212402 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212405 */     GIR_RootConstrainSelectedInstOperands,
     /* 212406 */     // GIR_Coverage, 12099,
     /* 212406 */     GIR_EraseRootFromParent_Done,
     /* 212407 */   // Label 4061: @212407
     /* 212407 */   GIM_Try, /*On fail goto*//*Label 4062*/ GIMT_Encode4(212447), // Rule ID 12100 //
     /* 212412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 212420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 212423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212433 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2112:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_B),
     /* 212436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212442 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212445 */     GIR_RootConstrainSelectedInstOperands,
     /* 212446 */     // GIR_Coverage, 12100,
     /* 212446 */     GIR_EraseRootFromParent_Done,
     /* 212447 */   // Label 4062: @212447
     /* 212447 */   GIM_Try, /*On fail goto*//*Label 4063*/ GIMT_Encode4(212487), // Rule ID 12101 //
     /* 212452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 212460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 212463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212473 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2112:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_H),
     /* 212476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212482 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212485 */     GIR_RootConstrainSelectedInstOperands,
     /* 212486 */     // GIR_Coverage, 12101,
     /* 212486 */     GIR_EraseRootFromParent_Done,
     /* 212487 */   // Label 4063: @212487
     /* 212487 */   GIM_Try, /*On fail goto*//*Label 4064*/ GIMT_Encode4(212527), // Rule ID 12102 //
     /* 212492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 212500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 212503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212513 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2112:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_S),
     /* 212516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212522 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212525 */     GIR_RootConstrainSelectedInstOperands,
     /* 212526 */     // GIR_Coverage, 12102,
     /* 212526 */     GIR_EraseRootFromParent_Done,
     /* 212527 */   // Label 4064: @212527
     /* 212527 */   GIM_Try, /*On fail goto*//*Label 4065*/ GIMT_Encode4(212567), // Rule ID 12103 //
     /* 212532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 212540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 212543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212553 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2112:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_D),
     /* 212556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212562 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212565 */     GIR_RootConstrainSelectedInstOperands,
     /* 212566 */     // GIR_Coverage, 12103,
     /* 212566 */     GIR_EraseRootFromParent_Done,
     /* 212567 */   // Label 4065: @212567
     /* 212567 */   GIM_Try, /*On fail goto*//*Label 4066*/ GIMT_Encode4(212604), // Rule ID 12113 //
     /* 212572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_AES_HasSVEAES),
     /* 212575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 212580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 212586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212593 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1642:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (PMULLT_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 212593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_Q),
     /* 212596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212602 */     GIR_RootConstrainSelectedInstOperands,
     /* 212603 */     // GIR_Coverage, 12113,
     /* 212603 */     GIR_EraseRootFromParent_Done,
     /* 212604 */   // Label 4066: @212604
     /* 212604 */   GIM_Try, /*On fail goto*//*Label 4067*/ GIMT_Encode4(212641), // Rule ID 12114 //
     /* 212609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p1_HasSVESHA3),
     /* 212612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rax1),
     /* 212617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 212623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212630 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1674:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RAX1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 212630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RAX1_ZZZ_D),
     /* 212633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212637 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212639 */     GIR_RootConstrainSelectedInstOperands,
     /* 212640 */     // GIR_Coverage, 12114,
     /* 212640 */     GIR_EraseRootFromParent_Done,
     /* 212641 */   // Label 4067: @212641
     /* 212641 */   GIM_Try, /*On fail goto*//*Label 4068*/ GIMT_Encode4(212678), // Rule ID 12115 //
     /* 212646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 212649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 212654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 212663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212667 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1282:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BDEP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 212667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_B),
     /* 212670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212676 */     GIR_RootConstrainSelectedInstOperands,
     /* 212677 */     // GIR_Coverage, 12115,
     /* 212677 */     GIR_EraseRootFromParent_Done,
     /* 212678 */   // Label 4068: @212678
     /* 212678 */   GIM_Try, /*On fail goto*//*Label 4069*/ GIMT_Encode4(212715), // Rule ID 12116 //
     /* 212683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 212686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 212691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212704 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1282:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BDEP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 212704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_H),
     /* 212707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212713 */     GIR_RootConstrainSelectedInstOperands,
     /* 212714 */     // GIR_Coverage, 12116,
     /* 212714 */     GIR_EraseRootFromParent_Done,
     /* 212715 */   // Label 4069: @212715
     /* 212715 */   GIM_Try, /*On fail goto*//*Label 4070*/ GIMT_Encode4(212752), // Rule ID 12117 //
     /* 212720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 212723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 212728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212741 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1282:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BDEP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_S),
     /* 212744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212750 */     GIR_RootConstrainSelectedInstOperands,
     /* 212751 */     // GIR_Coverage, 12117,
     /* 212751 */     GIR_EraseRootFromParent_Done,
     /* 212752 */   // Label 4070: @212752
     /* 212752 */   GIM_Try, /*On fail goto*//*Label 4071*/ GIMT_Encode4(212789), // Rule ID 12118 //
     /* 212757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 212760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 212765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 212771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212778 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1282:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BDEP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 212778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_D),
     /* 212781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212785 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212787 */     GIR_RootConstrainSelectedInstOperands,
     /* 212788 */     // GIR_Coverage, 12118,
     /* 212788 */     GIR_EraseRootFromParent_Done,
     /* 212789 */   // Label 4071: @212789
     /* 212789 */   GIM_Try, /*On fail goto*//*Label 4072*/ GIMT_Encode4(212826), // Rule ID 12119 //
     /* 212794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 212797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 212802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 212811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212815 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1299:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BGRP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 212815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_B),
     /* 212818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212824 */     GIR_RootConstrainSelectedInstOperands,
     /* 212825 */     // GIR_Coverage, 12119,
     /* 212825 */     GIR_EraseRootFromParent_Done,
     /* 212826 */   // Label 4072: @212826
     /* 212826 */   GIM_Try, /*On fail goto*//*Label 4073*/ GIMT_Encode4(212863), // Rule ID 12120 //
     /* 212831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 212834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 212839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212852 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1299:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BGRP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 212852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_H),
     /* 212855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212861 */     GIR_RootConstrainSelectedInstOperands,
     /* 212862 */     // GIR_Coverage, 12120,
     /* 212862 */     GIR_EraseRootFromParent_Done,
     /* 212863 */   // Label 4073: @212863
     /* 212863 */   GIM_Try, /*On fail goto*//*Label 4074*/ GIMT_Encode4(212900), // Rule ID 12121 //
     /* 212868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 212871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 212876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212889 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1299:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BGRP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_S),
     /* 212892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212896 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212898 */     GIR_RootConstrainSelectedInstOperands,
     /* 212899 */     // GIR_Coverage, 12121,
     /* 212899 */     GIR_EraseRootFromParent_Done,
     /* 212900 */   // Label 4074: @212900
     /* 212900 */   GIM_Try, /*On fail goto*//*Label 4075*/ GIMT_Encode4(212937), // Rule ID 12122 //
     /* 212905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 212908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 212913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 212919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212926 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1299:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BGRP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 212926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_D),
     /* 212929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212933 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212935 */     GIR_RootConstrainSelectedInstOperands,
     /* 212936 */     // GIR_Coverage, 12122,
     /* 212936 */     GIR_EraseRootFromParent_Done,
     /* 212937 */   // Label 4075: @212937
     /* 212937 */   GIM_Try, /*On fail goto*//*Label 4076*/ GIMT_Encode4(212974), // Rule ID 12236 //
     /* 212942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 212950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 212953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 212956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212963 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1448:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMAXNMQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 212963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_H),
     /* 212966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212972 */     GIR_RootConstrainSelectedInstOperands,
     /* 212973 */     // GIR_Coverage, 12236,
     /* 212973 */     GIR_EraseRootFromParent_Done,
     /* 212974 */   // Label 4076: @212974
     /* 212974 */   GIM_Try, /*On fail goto*//*Label 4077*/ GIMT_Encode4(213011), // Rule ID 12237 //
     /* 212979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 212987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 212990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 212993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213000 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1448:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMAXNMQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 213000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_S),
     /* 213003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213007 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213009 */     GIR_RootConstrainSelectedInstOperands,
     /* 213010 */     // GIR_Coverage, 12237,
     /* 213010 */     GIR_EraseRootFromParent_Done,
     /* 213011 */   // Label 4077: @213011
     /* 213011 */   GIM_Try, /*On fail goto*//*Label 4078*/ GIMT_Encode4(213048), // Rule ID 12238 //
     /* 213016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 213024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 213027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 213030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213037 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1448:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMAXNMQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 213037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_D),
     /* 213040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213046 */     GIR_RootConstrainSelectedInstOperands,
     /* 213047 */     // GIR_Coverage, 12238,
     /* 213047 */     GIR_EraseRootFromParent_Done,
     /* 213048 */   // Label 4078: @213048
     /* 213048 */   GIM_Try, /*On fail goto*//*Label 4079*/ GIMT_Encode4(213085), // Rule ID 12239 //
     /* 213053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 213061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 213064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 213067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213074 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1466:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMINNMQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 213074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_H),
     /* 213077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213083 */     GIR_RootConstrainSelectedInstOperands,
     /* 213084 */     // GIR_Coverage, 12239,
     /* 213084 */     GIR_EraseRootFromParent_Done,
     /* 213085 */   // Label 4079: @213085
     /* 213085 */   GIM_Try, /*On fail goto*//*Label 4080*/ GIMT_Encode4(213122), // Rule ID 12240 //
     /* 213090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 213098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 213101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 213104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213111 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1466:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMINNMQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 213111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_S),
     /* 213114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213118 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213120 */     GIR_RootConstrainSelectedInstOperands,
     /* 213121 */     // GIR_Coverage, 12240,
     /* 213121 */     GIR_EraseRootFromParent_Done,
     /* 213122 */   // Label 4080: @213122
     /* 213122 */   GIM_Try, /*On fail goto*//*Label 4081*/ GIMT_Encode4(213159), // Rule ID 12241 //
     /* 213127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 213135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 213138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 213141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213148 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1466:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMINNMQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 213148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_D),
     /* 213151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213155 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213157 */     GIR_RootConstrainSelectedInstOperands,
     /* 213158 */     // GIR_Coverage, 12241,
     /* 213158 */     GIR_EraseRootFromParent_Done,
     /* 213159 */   // Label 4081: @213159
     /* 213159 */   GIM_Try, /*On fail goto*//*Label 4082*/ GIMT_Encode4(213196), // Rule ID 12242 //
     /* 213164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 213172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 213175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 213178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213185 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1451:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMAXQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 213185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_H),
     /* 213188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213194 */     GIR_RootConstrainSelectedInstOperands,
     /* 213195 */     // GIR_Coverage, 12242,
     /* 213195 */     GIR_EraseRootFromParent_Done,
     /* 213196 */   // Label 4082: @213196
     /* 213196 */   GIM_Try, /*On fail goto*//*Label 4083*/ GIMT_Encode4(213233), // Rule ID 12243 //
     /* 213201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 213209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 213212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 213215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213222 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1451:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMAXQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 213222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_S),
     /* 213225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213231 */     GIR_RootConstrainSelectedInstOperands,
     /* 213232 */     // GIR_Coverage, 12243,
     /* 213232 */     GIR_EraseRootFromParent_Done,
     /* 213233 */   // Label 4083: @213233
     /* 213233 */   GIM_Try, /*On fail goto*//*Label 4084*/ GIMT_Encode4(213270), // Rule ID 12244 //
     /* 213238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 213246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 213249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 213252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213259 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1451:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMAXQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 213259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_D),
     /* 213262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213268 */     GIR_RootConstrainSelectedInstOperands,
     /* 213269 */     // GIR_Coverage, 12244,
     /* 213269 */     GIR_EraseRootFromParent_Done,
     /* 213270 */   // Label 4084: @213270
     /* 213270 */   GIM_Try, /*On fail goto*//*Label 4085*/ GIMT_Encode4(213307), // Rule ID 12245 //
     /* 213275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 213283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 213286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 213289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213296 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1469:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMINQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 213296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_H),
     /* 213299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213305 */     GIR_RootConstrainSelectedInstOperands,
     /* 213306 */     // GIR_Coverage, 12245,
     /* 213306 */     GIR_EraseRootFromParent_Done,
     /* 213307 */   // Label 4085: @213307
     /* 213307 */   GIM_Try, /*On fail goto*//*Label 4086*/ GIMT_Encode4(213344), // Rule ID 12246 //
     /* 213312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 213320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 213323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 213326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213333 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1469:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMINQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 213333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_S),
     /* 213336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213340 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213342 */     GIR_RootConstrainSelectedInstOperands,
     /* 213343 */     // GIR_Coverage, 12246,
     /* 213343 */     GIR_EraseRootFromParent_Done,
     /* 213344 */   // Label 4086: @213344
     /* 213344 */   GIM_Try, /*On fail goto*//*Label 4087*/ GIMT_Encode4(213381), // Rule ID 12247 //
     /* 213349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 213357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 213360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 213363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213370 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1469:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMINQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 213370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_D),
     /* 213373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213377 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213379 */     GIR_RootConstrainSelectedInstOperands,
     /* 213380 */     // GIR_Coverage, 12247,
     /* 213380 */     GIR_EraseRootFromParent_Done,
     /* 213381 */   // Label 4087: @213381
     /* 213381 */   GIM_Try, /*On fail goto*//*Label 4088*/ GIMT_Encode4(213418), // Rule ID 12248 //
     /* 213386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 213394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 213397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 213400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 213403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213407 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1363:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (EORQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 213407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_B),
     /* 213410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213416 */     GIR_RootConstrainSelectedInstOperands,
     /* 213417 */     // GIR_Coverage, 12248,
     /* 213417 */     GIR_EraseRootFromParent_Done,
     /* 213418 */   // Label 4088: @213418
     /* 213418 */   GIM_Try, /*On fail goto*//*Label 4089*/ GIMT_Encode4(213455), // Rule ID 12249 //
     /* 213423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 213431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 213434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 213437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213444 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1363:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (EORQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 213444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_H),
     /* 213447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213451 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213453 */     GIR_RootConstrainSelectedInstOperands,
     /* 213454 */     // GIR_Coverage, 12249,
     /* 213454 */     GIR_EraseRootFromParent_Done,
     /* 213455 */   // Label 4089: @213455
     /* 213455 */   GIM_Try, /*On fail goto*//*Label 4090*/ GIMT_Encode4(213492), // Rule ID 12250 //
     /* 213460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 213468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 213471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 213474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213481 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1363:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (EORQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 213481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_S),
     /* 213484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213490 */     GIR_RootConstrainSelectedInstOperands,
     /* 213491 */     // GIR_Coverage, 12250,
     /* 213491 */     GIR_EraseRootFromParent_Done,
     /* 213492 */   // Label 4090: @213492
     /* 213492 */   GIM_Try, /*On fail goto*//*Label 4091*/ GIMT_Encode4(213529), // Rule ID 12251 //
     /* 213497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 213505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 213508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 213511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213518 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1363:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (EORQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 213518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_D),
     /* 213521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213525 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213527 */     GIR_RootConstrainSelectedInstOperands,
     /* 213528 */     // GIR_Coverage, 12251,
     /* 213528 */     GIR_EraseRootFromParent_Done,
     /* 213529 */   // Label 4091: @213529
     /* 213529 */   GIM_Try, /*On fail goto*//*Label 4092*/ GIMT_Encode4(213566), // Rule ID 12252 //
     /* 213534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 213542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 213545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 213548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 213551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213555 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1275:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ANDQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 213555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_B),
     /* 213558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213564 */     GIR_RootConstrainSelectedInstOperands,
     /* 213565 */     // GIR_Coverage, 12252,
     /* 213565 */     GIR_EraseRootFromParent_Done,
     /* 213566 */   // Label 4092: @213566
     /* 213566 */   GIM_Try, /*On fail goto*//*Label 4093*/ GIMT_Encode4(213603), // Rule ID 12253 //
     /* 213571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 213579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 213582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 213585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213592 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1275:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ANDQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 213592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_H),
     /* 213595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213599 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213601 */     GIR_RootConstrainSelectedInstOperands,
     /* 213602 */     // GIR_Coverage, 12253,
     /* 213602 */     GIR_EraseRootFromParent_Done,
     /* 213603 */   // Label 4093: @213603
     /* 213603 */   GIM_Try, /*On fail goto*//*Label 4094*/ GIMT_Encode4(213640), // Rule ID 12254 //
     /* 213608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 213616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 213619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 213622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213629 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1275:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ANDQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 213629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_S),
     /* 213632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213638 */     GIR_RootConstrainSelectedInstOperands,
     /* 213639 */     // GIR_Coverage, 12254,
     /* 213639 */     GIR_EraseRootFromParent_Done,
     /* 213640 */   // Label 4094: @213640
     /* 213640 */   GIM_Try, /*On fail goto*//*Label 4095*/ GIMT_Encode4(213677), // Rule ID 12255 //
     /* 213645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 213653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 213656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 213659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213666 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1275:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ANDQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 213666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_D),
     /* 213669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213673 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213675 */     GIR_RootConstrainSelectedInstOperands,
     /* 213676 */     // GIR_Coverage, 12255,
     /* 213676 */     GIR_EraseRootFromParent_Done,
     /* 213677 */   // Label 4095: @213677
     /* 213677 */   GIM_Try, /*On fail goto*//*Label 4096*/ GIMT_Encode4(213714), // Rule ID 12256 //
     /* 213682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 213690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 213693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 213696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 213699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213703 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1263:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ADDQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 213703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_B),
     /* 213706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213712 */     GIR_RootConstrainSelectedInstOperands,
     /* 213713 */     // GIR_Coverage, 12256,
     /* 213713 */     GIR_EraseRootFromParent_Done,
     /* 213714 */   // Label 4096: @213714
     /* 213714 */   GIM_Try, /*On fail goto*//*Label 4097*/ GIMT_Encode4(213751), // Rule ID 12257 //
     /* 213719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 213727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 213730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 213733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213740 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1263:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADDQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 213740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_H),
     /* 213743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213747 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213749 */     GIR_RootConstrainSelectedInstOperands,
     /* 213750 */     // GIR_Coverage, 12257,
     /* 213750 */     GIR_EraseRootFromParent_Done,
     /* 213751 */   // Label 4097: @213751
     /* 213751 */   GIM_Try, /*On fail goto*//*Label 4098*/ GIMT_Encode4(213788), // Rule ID 12258 //
     /* 213756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 213764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 213767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 213770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213777 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1263:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADDQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 213777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_S),
     /* 213780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213786 */     GIR_RootConstrainSelectedInstOperands,
     /* 213787 */     // GIR_Coverage, 12258,
     /* 213787 */     GIR_EraseRootFromParent_Done,
     /* 213788 */   // Label 4098: @213788
     /* 213788 */   GIM_Try, /*On fail goto*//*Label 4099*/ GIMT_Encode4(213825), // Rule ID 12259 //
     /* 213793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 213801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 213804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 213807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213814 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1263:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADDQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 213814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_D),
     /* 213817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213823 */     GIR_RootConstrainSelectedInstOperands,
     /* 213824 */     // GIR_Coverage, 12259,
     /* 213824 */     GIR_EraseRootFromParent_Done,
     /* 213825 */   // Label 4099: @213825
     /* 213825 */   GIM_Try, /*On fail goto*//*Label 4100*/ GIMT_Encode4(213862), // Rule ID 12260 //
     /* 213830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 213838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 213841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 213844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 213847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213851 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1742:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMAXQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 213851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_B),
     /* 213854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213860 */     GIR_RootConstrainSelectedInstOperands,
     /* 213861 */     // GIR_Coverage, 12260,
     /* 213861 */     GIR_EraseRootFromParent_Done,
     /* 213862 */   // Label 4100: @213862
     /* 213862 */   GIM_Try, /*On fail goto*//*Label 4101*/ GIMT_Encode4(213899), // Rule ID 12261 //
     /* 213867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 213875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 213878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 213881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213888 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1742:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMAXQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 213888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_H),
     /* 213891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213897 */     GIR_RootConstrainSelectedInstOperands,
     /* 213898 */     // GIR_Coverage, 12261,
     /* 213898 */     GIR_EraseRootFromParent_Done,
     /* 213899 */   // Label 4101: @213899
     /* 213899 */   GIM_Try, /*On fail goto*//*Label 4102*/ GIMT_Encode4(213936), // Rule ID 12262 //
     /* 213904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 213912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 213915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 213918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213925 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1742:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMAXQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 213925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_S),
     /* 213928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213932 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213934 */     GIR_RootConstrainSelectedInstOperands,
     /* 213935 */     // GIR_Coverage, 12262,
     /* 213935 */     GIR_EraseRootFromParent_Done,
     /* 213936 */   // Label 4102: @213936
     /* 213936 */   GIM_Try, /*On fail goto*//*Label 4103*/ GIMT_Encode4(213973), // Rule ID 12263 //
     /* 213941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 213949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 213952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 213955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213962 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1742:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SMAXQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 213962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_D),
     /* 213965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213971 */     GIR_RootConstrainSelectedInstOperands,
     /* 213972 */     // GIR_Coverage, 12263,
     /* 213972 */     GIR_EraseRootFromParent_Done,
     /* 213973 */   // Label 4103: @213973
     /* 213973 */   GIM_Try, /*On fail goto*//*Label 4104*/ GIMT_Encode4(214010), // Rule ID 12264 //
     /* 213978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 213986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 213989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 213992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 213995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213999 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1980:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMAXQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 213999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_B),
     /* 214002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214008 */     GIR_RootConstrainSelectedInstOperands,
     /* 214009 */     // GIR_Coverage, 12264,
     /* 214009 */     GIR_EraseRootFromParent_Done,
     /* 214010 */   // Label 4104: @214010
     /* 214010 */   GIM_Try, /*On fail goto*//*Label 4105*/ GIMT_Encode4(214047), // Rule ID 12265 //
     /* 214015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 214023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 214026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 214029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214036 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1980:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMAXQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 214036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_H),
     /* 214039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214043 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214045 */     GIR_RootConstrainSelectedInstOperands,
     /* 214046 */     // GIR_Coverage, 12265,
     /* 214046 */     GIR_EraseRootFromParent_Done,
     /* 214047 */   // Label 4105: @214047
     /* 214047 */   GIM_Try, /*On fail goto*//*Label 4106*/ GIMT_Encode4(214084), // Rule ID 12266 //
     /* 214052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 214060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 214066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214073 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1980:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMAXQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 214073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_S),
     /* 214076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214082 */     GIR_RootConstrainSelectedInstOperands,
     /* 214083 */     // GIR_Coverage, 12266,
     /* 214083 */     GIR_EraseRootFromParent_Done,
     /* 214084 */   // Label 4106: @214084
     /* 214084 */   GIM_Try, /*On fail goto*//*Label 4107*/ GIMT_Encode4(214121), // Rule ID 12267 //
     /* 214089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 214097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 214100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 214103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214110 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1980:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UMAXQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 214110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_D),
     /* 214113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214117 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214119 */     GIR_RootConstrainSelectedInstOperands,
     /* 214120 */     // GIR_Coverage, 12267,
     /* 214120 */     GIR_EraseRootFromParent_Done,
     /* 214121 */   // Label 4107: @214121
     /* 214121 */   GIM_Try, /*On fail goto*//*Label 4108*/ GIMT_Encode4(214158), // Rule ID 12268 //
     /* 214126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 214134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 214137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 214140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 214143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214147 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1751:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMINQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 214147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_B),
     /* 214150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214156 */     GIR_RootConstrainSelectedInstOperands,
     /* 214157 */     // GIR_Coverage, 12268,
     /* 214157 */     GIR_EraseRootFromParent_Done,
     /* 214158 */   // Label 4108: @214158
     /* 214158 */   GIM_Try, /*On fail goto*//*Label 4109*/ GIMT_Encode4(214195), // Rule ID 12269 //
     /* 214163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 214171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 214174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 214177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214184 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1751:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMINQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 214184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_H),
     /* 214187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214191 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214193 */     GIR_RootConstrainSelectedInstOperands,
     /* 214194 */     // GIR_Coverage, 12269,
     /* 214194 */     GIR_EraseRootFromParent_Done,
     /* 214195 */   // Label 4109: @214195
     /* 214195 */   GIM_Try, /*On fail goto*//*Label 4110*/ GIMT_Encode4(214232), // Rule ID 12270 //
     /* 214200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 214208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 214214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214221 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1751:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMINQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 214221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_S),
     /* 214224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214228 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214230 */     GIR_RootConstrainSelectedInstOperands,
     /* 214231 */     // GIR_Coverage, 12270,
     /* 214231 */     GIR_EraseRootFromParent_Done,
     /* 214232 */   // Label 4110: @214232
     /* 214232 */   GIM_Try, /*On fail goto*//*Label 4111*/ GIMT_Encode4(214269), // Rule ID 12271 //
     /* 214237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 214245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 214248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 214251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214258 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1751:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SMINQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 214258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_D),
     /* 214261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214267 */     GIR_RootConstrainSelectedInstOperands,
     /* 214268 */     // GIR_Coverage, 12271,
     /* 214268 */     GIR_EraseRootFromParent_Done,
     /* 214269 */   // Label 4111: @214269
     /* 214269 */   GIM_Try, /*On fail goto*//*Label 4112*/ GIMT_Encode4(214306), // Rule ID 12272 //
     /* 214274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 214282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 214285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 214288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 214291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214295 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1989:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMINQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 214295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_B),
     /* 214298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214304 */     GIR_RootConstrainSelectedInstOperands,
     /* 214305 */     // GIR_Coverage, 12272,
     /* 214305 */     GIR_EraseRootFromParent_Done,
     /* 214306 */   // Label 4112: @214306
     /* 214306 */   GIM_Try, /*On fail goto*//*Label 4113*/ GIMT_Encode4(214343), // Rule ID 12273 //
     /* 214311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 214319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 214322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 214325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214332 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1989:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMINQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 214332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_H),
     /* 214335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214339 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214341 */     GIR_RootConstrainSelectedInstOperands,
     /* 214342 */     // GIR_Coverage, 12273,
     /* 214342 */     GIR_EraseRootFromParent_Done,
     /* 214343 */   // Label 4113: @214343
     /* 214343 */   GIM_Try, /*On fail goto*//*Label 4114*/ GIMT_Encode4(214380), // Rule ID 12274 //
     /* 214348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 214356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 214362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214369 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1989:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMINQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 214369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_S),
     /* 214372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214376 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214378 */     GIR_RootConstrainSelectedInstOperands,
     /* 214379 */     // GIR_Coverage, 12274,
     /* 214379 */     GIR_EraseRootFromParent_Done,
     /* 214380 */   // Label 4114: @214380
     /* 214380 */   GIM_Try, /*On fail goto*//*Label 4115*/ GIMT_Encode4(214417), // Rule ID 12275 //
     /* 214385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 214393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 214396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 214399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214406 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1989:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UMINQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 214406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_D),
     /* 214409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214413 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214415 */     GIR_RootConstrainSelectedInstOperands,
     /* 214416 */     // GIR_Coverage, 12275,
     /* 214416 */     GIR_EraseRootFromParent_Done,
     /* 214417 */   // Label 4115: @214417
     /* 214417 */   GIM_Try, /*On fail goto*//*Label 4116*/ GIMT_Encode4(214454), // Rule ID 12276 //
     /* 214422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 214430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 214433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 214436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 214439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214443 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2173:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIPQ2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 214443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_B),
     /* 214446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214452 */     GIR_RootConstrainSelectedInstOperands,
     /* 214453 */     // GIR_Coverage, 12276,
     /* 214453 */     GIR_EraseRootFromParent_Done,
     /* 214454 */   // Label 4116: @214454
     /* 214454 */   GIM_Try, /*On fail goto*//*Label 4117*/ GIMT_Encode4(214491), // Rule ID 12277 //
     /* 214459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 214467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214480 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2173:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIPQ2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 214480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_H),
     /* 214483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214489 */     GIR_RootConstrainSelectedInstOperands,
     /* 214490 */     // GIR_Coverage, 12277,
     /* 214490 */     GIR_EraseRootFromParent_Done,
     /* 214491 */   // Label 4117: @214491
     /* 214491 */   GIM_Try, /*On fail goto*//*Label 4118*/ GIMT_Encode4(214528), // Rule ID 12278 //
     /* 214496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 214504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214517 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2173:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIPQ2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 214517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_S),
     /* 214520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214526 */     GIR_RootConstrainSelectedInstOperands,
     /* 214527 */     // GIR_Coverage, 12278,
     /* 214527 */     GIR_EraseRootFromParent_Done,
     /* 214528 */   // Label 4118: @214528
     /* 214528 */   GIM_Try, /*On fail goto*//*Label 4119*/ GIMT_Encode4(214565), // Rule ID 12279 //
     /* 214533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 214541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 214544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 214547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214554 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2173:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIPQ2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 214554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_D),
     /* 214557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214561 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214563 */     GIR_RootConstrainSelectedInstOperands,
     /* 214564 */     // GIR_Coverage, 12279,
     /* 214564 */     GIR_EraseRootFromParent_Done,
     /* 214565 */   // Label 4119: @214565
     /* 214565 */   GIM_Try, /*On fail goto*//*Label 4120*/ GIMT_Encode4(214602), // Rule ID 12280 //
     /* 214570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 214578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214591 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2173:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIPQ2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 214591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_H),
     /* 214594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214600 */     GIR_RootConstrainSelectedInstOperands,
     /* 214601 */     // GIR_Coverage, 12280,
     /* 214601 */     GIR_EraseRootFromParent_Done,
     /* 214602 */   // Label 4120: @214602
     /* 214602 */   GIM_Try, /*On fail goto*//*Label 4121*/ GIMT_Encode4(214639), // Rule ID 12281 //
     /* 214607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 214615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214628 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2173:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIPQ2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 214628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_S),
     /* 214631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214637 */     GIR_RootConstrainSelectedInstOperands,
     /* 214638 */     // GIR_Coverage, 12281,
     /* 214638 */     GIR_EraseRootFromParent_Done,
     /* 214639 */   // Label 4121: @214639
     /* 214639 */   GIM_Try, /*On fail goto*//*Label 4122*/ GIMT_Encode4(214676), // Rule ID 12282 //
     /* 214644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 214652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 214655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 214658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214665 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2173:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIPQ2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 214665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_D),
     /* 214668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214674 */     GIR_RootConstrainSelectedInstOperands,
     /* 214675 */     // GIR_Coverage, 12282,
     /* 214675 */     GIR_EraseRootFromParent_Done,
     /* 214676 */   // Label 4122: @214676
     /* 214676 */   GIM_Try, /*On fail goto*//*Label 4123*/ GIMT_Encode4(214713), // Rule ID 12283 //
     /* 214681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 214689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 214692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 214695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 214698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214702 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2098:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZPQ1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 214702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_B),
     /* 214705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214711 */     GIR_RootConstrainSelectedInstOperands,
     /* 214712 */     // GIR_Coverage, 12283,
     /* 214712 */     GIR_EraseRootFromParent_Done,
     /* 214713 */   // Label 4123: @214713
     /* 214713 */   GIM_Try, /*On fail goto*//*Label 4124*/ GIMT_Encode4(214750), // Rule ID 12284 //
     /* 214718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 214726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214739 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2098:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZPQ1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 214739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_H),
     /* 214742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214746 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214748 */     GIR_RootConstrainSelectedInstOperands,
     /* 214749 */     // GIR_Coverage, 12284,
     /* 214749 */     GIR_EraseRootFromParent_Done,
     /* 214750 */   // Label 4124: @214750
     /* 214750 */   GIM_Try, /*On fail goto*//*Label 4125*/ GIMT_Encode4(214787), // Rule ID 12285 //
     /* 214755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 214763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214776 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2098:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZPQ1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 214776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_S),
     /* 214779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214785 */     GIR_RootConstrainSelectedInstOperands,
     /* 214786 */     // GIR_Coverage, 12285,
     /* 214786 */     GIR_EraseRootFromParent_Done,
     /* 214787 */   // Label 4125: @214787
     /* 214787 */   GIM_Try, /*On fail goto*//*Label 4126*/ GIMT_Encode4(214824), // Rule ID 12286 //
     /* 214792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 214800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 214803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 214806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214813 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2098:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZPQ1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 214813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_D),
     /* 214816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214820 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214822 */     GIR_RootConstrainSelectedInstOperands,
     /* 214823 */     // GIR_Coverage, 12286,
     /* 214823 */     GIR_EraseRootFromParent_Done,
     /* 214824 */   // Label 4126: @214824
     /* 214824 */   GIM_Try, /*On fail goto*//*Label 4127*/ GIMT_Encode4(214861), // Rule ID 12287 //
     /* 214829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 214837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214850 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2098:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZPQ1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 214850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_H),
     /* 214853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214857 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214859 */     GIR_RootConstrainSelectedInstOperands,
     /* 214860 */     // GIR_Coverage, 12287,
     /* 214860 */     GIR_EraseRootFromParent_Done,
     /* 214861 */   // Label 4127: @214861
     /* 214861 */   GIM_Try, /*On fail goto*//*Label 4128*/ GIMT_Encode4(214898), // Rule ID 12288 //
     /* 214866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 214874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214887 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2098:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZPQ1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 214887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_S),
     /* 214890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214896 */     GIR_RootConstrainSelectedInstOperands,
     /* 214897 */     // GIR_Coverage, 12288,
     /* 214897 */     GIR_EraseRootFromParent_Done,
     /* 214898 */   // Label 4128: @214898
     /* 214898 */   GIM_Try, /*On fail goto*//*Label 4129*/ GIMT_Encode4(214935), // Rule ID 12289 //
     /* 214903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 214911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 214914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 214917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214924 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2098:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZPQ1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 214924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_D),
     /* 214927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214931 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214933 */     GIR_RootConstrainSelectedInstOperands,
     /* 214934 */     // GIR_Coverage, 12289,
     /* 214934 */     GIR_EraseRootFromParent_Done,
     /* 214935 */   // Label 4129: @214935
     /* 214935 */   GIM_Try, /*On fail goto*//*Label 4130*/ GIMT_Encode4(214972), // Rule ID 12290 //
     /* 214940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 214948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 214951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 214954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 214957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214961 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2099:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZPQ2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 214961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_B),
     /* 214964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214970 */     GIR_RootConstrainSelectedInstOperands,
     /* 214971 */     // GIR_Coverage, 12290,
     /* 214971 */     GIR_EraseRootFromParent_Done,
     /* 214972 */   // Label 4130: @214972
     /* 214972 */   GIM_Try, /*On fail goto*//*Label 4131*/ GIMT_Encode4(215009), // Rule ID 12291 //
     /* 214977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 214985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214998 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2099:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZPQ2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 214998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_H),
     /* 215001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215007 */     GIR_RootConstrainSelectedInstOperands,
     /* 215008 */     // GIR_Coverage, 12291,
     /* 215008 */     GIR_EraseRootFromParent_Done,
     /* 215009 */   // Label 4131: @215009
     /* 215009 */   GIM_Try, /*On fail goto*//*Label 4132*/ GIMT_Encode4(215046), // Rule ID 12292 //
     /* 215014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 215022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 215025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 215028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 215031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215035 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2099:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZPQ2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 215035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_S),
     /* 215038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215044 */     GIR_RootConstrainSelectedInstOperands,
     /* 215045 */     // GIR_Coverage, 12292,
     /* 215045 */     GIR_EraseRootFromParent_Done,
     /* 215046 */   // Label 4132: @215046
     /* 215046 */   GIM_Try, /*On fail goto*//*Label 4133*/ GIMT_Encode4(215083), // Rule ID 12293 //
     /* 215051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 215059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 215062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 215065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 215068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215072 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2099:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZPQ2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 215072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_D),
     /* 215075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215081 */     GIR_RootConstrainSelectedInstOperands,
     /* 215082 */     // GIR_Coverage, 12293,
     /* 215082 */     GIR_EraseRootFromParent_Done,
     /* 215083 */   // Label 4133: @215083
     /* 215083 */   GIM_Try, /*On fail goto*//*Label 4134*/ GIMT_Encode4(215120), // Rule ID 12294 //
     /* 215088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 215096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 215099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 215102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 215105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215109 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2099:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZPQ2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 215109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_H),
     /* 215112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215118 */     GIR_RootConstrainSelectedInstOperands,
     /* 215119 */     // GIR_Coverage, 12294,
     /* 215119 */     GIR_EraseRootFromParent_Done,
     /* 215120 */   // Label 4134: @215120
     /* 215120 */   GIM_Try, /*On fail goto*//*Label 4135*/ GIMT_Encode4(215157), // Rule ID 12295 //
     /* 215125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 215133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 215136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 215139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 215142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215146 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2099:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZPQ2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 215146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_S),
     /* 215149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215155 */     GIR_RootConstrainSelectedInstOperands,
     /* 215156 */     // GIR_Coverage, 12295,
     /* 215156 */     GIR_EraseRootFromParent_Done,
     /* 215157 */   // Label 4135: @215157
     /* 215157 */   GIM_Try, /*On fail goto*//*Label 4136*/ GIMT_Encode4(215194), // Rule ID 12296 //
     /* 215162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 215170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 215173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 215176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 215179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215183 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2099:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZPQ2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 215183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_D),
     /* 215186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215190 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215192 */     GIR_RootConstrainSelectedInstOperands,
     /* 215193 */     // GIR_Coverage, 12296,
     /* 215193 */     GIR_EraseRootFromParent_Done,
     /* 215194 */   // Label 4136: @215194
     /* 215194 */   GIM_Try, /*On fail goto*//*Label 4137*/ GIMT_Encode4(215236), // Rule ID 3229 //
     /* 215199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_b),
     /* 215207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 215210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215214 */     // MIs[0] Op1
     /* 215214 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 215218 */     // MIs[0] Op2
     /* 215218 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 215222 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2152:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 215222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_B),
     /* 215225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215231 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 215234 */     GIR_RootConstrainSelectedInstOperands,
     /* 215235 */     // GIR_Coverage, 3229,
     /* 215235 */     GIR_EraseRootFromParent_Done,
     /* 215236 */   // Label 4137: @215236
     /* 215236 */   GIM_Try, /*On fail goto*//*Label 4138*/ GIMT_Encode4(215278), // Rule ID 3230 //
     /* 215241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_h),
     /* 215249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 215252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215256 */     // MIs[0] Op1
     /* 215256 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 215260 */     // MIs[0] Op2
     /* 215260 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 215264 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2154:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 215264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_H),
     /* 215267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215271 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215273 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 215276 */     GIR_RootConstrainSelectedInstOperands,
     /* 215277 */     // GIR_Coverage, 3230,
     /* 215277 */     GIR_EraseRootFromParent_Done,
     /* 215278 */   // Label 4138: @215278
     /* 215278 */   GIM_Try, /*On fail goto*//*Label 4139*/ GIMT_Encode4(215320), // Rule ID 3231 //
     /* 215283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_s),
     /* 215291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 215294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215298 */     // MIs[0] Op1
     /* 215298 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 215302 */     // MIs[0] Op2
     /* 215302 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 215306 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2155:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 215306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_S),
     /* 215309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215315 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 215318 */     GIR_RootConstrainSelectedInstOperands,
     /* 215319 */     // GIR_Coverage, 3231,
     /* 215319 */     GIR_EraseRootFromParent_Done,
     /* 215320 */   // Label 4139: @215320
     /* 215320 */   GIM_Try, /*On fail goto*//*Label 4140*/ GIMT_Encode4(215362), // Rule ID 3232 //
     /* 215325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_d),
     /* 215333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 215336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215340 */     // MIs[0] Op1
     /* 215340 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 215344 */     // MIs[0] Op2
     /* 215344 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 215348 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2153:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 215348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_D),
     /* 215351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215357 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 215360 */     GIR_RootConstrainSelectedInstOperands,
     /* 215361 */     // GIR_Coverage, 3232,
     /* 215361 */     GIR_EraseRootFromParent_Done,
     /* 215362 */   // Label 4140: @215362
     /* 215362 */   GIM_Try, /*On fail goto*//*Label 4141*/ GIMT_Encode4(215404), // Rule ID 12108 //
     /* 215367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_b),
     /* 215375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 215378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215382 */     // MIs[0] Op1
     /* 215382 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 215386 */     // MIs[0] Op2
     /* 215386 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 215390 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2148:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 215390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_B),
     /* 215393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215399 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 215402 */     GIR_RootConstrainSelectedInstOperands,
     /* 215403 */     // GIR_Coverage, 12108,
     /* 215403 */     GIR_EraseRootFromParent_Done,
     /* 215404 */   // Label 4141: @215404
     /* 215404 */   GIM_Try, /*On fail goto*//*Label 4142*/ GIMT_Encode4(215446), // Rule ID 12109 //
     /* 215409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_h),
     /* 215417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 215420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215424 */     // MIs[0] Op1
     /* 215424 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 215428 */     // MIs[0] Op2
     /* 215428 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 215432 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2150:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 215432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_H),
     /* 215435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215441 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 215444 */     GIR_RootConstrainSelectedInstOperands,
     /* 215445 */     // GIR_Coverage, 12109,
     /* 215445 */     GIR_EraseRootFromParent_Done,
     /* 215446 */   // Label 4142: @215446
     /* 215446 */   GIM_Try, /*On fail goto*//*Label 4143*/ GIMT_Encode4(215488), // Rule ID 12110 //
     /* 215451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_s),
     /* 215459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 215462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215466 */     // MIs[0] Op1
     /* 215466 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 215470 */     // MIs[0] Op2
     /* 215470 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 215474 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2151:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 215474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_S),
     /* 215477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215481 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215483 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 215486 */     GIR_RootConstrainSelectedInstOperands,
     /* 215487 */     // GIR_Coverage, 12110,
     /* 215487 */     GIR_EraseRootFromParent_Done,
     /* 215488 */   // Label 4143: @215488
     /* 215488 */   GIM_Try, /*On fail goto*//*Label 4144*/ GIMT_Encode4(215530), // Rule ID 12111 //
     /* 215493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_d),
     /* 215501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 215504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215508 */     // MIs[0] Op1
     /* 215508 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 215512 */     // MIs[0] Op2
     /* 215512 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 215516 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2149:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 215516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_D),
     /* 215519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215525 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 215528 */     GIR_RootConstrainSelectedInstOperands,
     /* 215529 */     // GIR_Coverage, 12111,
     /* 215529 */     GIR_EraseRootFromParent_Done,
     /* 215530 */   // Label 4144: @215530
     /* 215530 */   GIM_Reject,
     /* 215531 */ // Label 3248: @215531
     /* 215531 */ GIM_Try, /*On fail goto*//*Label 4145*/ GIMT_Encode4(258642),
     /* 215536 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 215539 */   GIM_Try, /*On fail goto*//*Label 4146*/ GIMT_Encode4(215652), // Rule ID 2069 //
     /* 215544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 215547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 215552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 215555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 215558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 215561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 215564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 215580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 215584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 215588 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 215592 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 215596 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 215600 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 215604 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 215609 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 215613 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 215617 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 215621 */     // MIs[3] Operand 1
     /* 215621 */     // No operand predicates
     /* 215621 */     // MIs[1] Operand 2
     /* 215621 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 215632 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 215634 */     // (intrinsic_wo_chain:{ *:[v4i16] } 696:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLAHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 215634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16_indexed),
     /* 215637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215641 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 215647 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 215650 */     GIR_RootConstrainSelectedInstOperands,
     /* 215651 */     // GIR_Coverage, 2069,
     /* 215651 */     GIR_EraseRootFromParent_Done,
     /* 215652 */   // Label 4146: @215652
     /* 215652 */   GIM_Try, /*On fail goto*//*Label 4147*/ GIMT_Encode4(215765), // Rule ID 2076 //
     /* 215657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 215660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 215665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 215668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 215671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 215674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 215677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 215693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 215697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 215701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 215705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 215709 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 215713 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 215717 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 215722 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 215726 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 215730 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 215734 */     // MIs[3] Operand 1
     /* 215734 */     // No operand predicates
     /* 215734 */     // MIs[1] Operand 2
     /* 215734 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 215745 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 215747 */     // (intrinsic_wo_chain:{ *:[v4i16] } 697:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLSHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 215747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16_indexed),
     /* 215750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 215760 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 215763 */     GIR_RootConstrainSelectedInstOperands,
     /* 215764 */     // GIR_Coverage, 2076,
     /* 215764 */     GIR_EraseRootFromParent_Done,
     /* 215765 */   // Label 4147: @215765
     /* 215765 */   GIM_Try, /*On fail goto*//*Label 4148*/ GIMT_Encode4(215878), // Rule ID 2072 //
     /* 215770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 215773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 215778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 215781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 215784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 215787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 215790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 215806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 215810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 215814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 215818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 215822 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 215826 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 215830 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215835 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 215839 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 215843 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 215847 */     // MIs[3] Operand 1
     /* 215847 */     // No operand predicates
     /* 215847 */     // MIs[1] Operand 2
     /* 215847 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 215858 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 215860 */     // (intrinsic_wo_chain:{ *:[v2i32] } 696:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLAHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 215860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32_indexed),
     /* 215863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 215873 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 215876 */     GIR_RootConstrainSelectedInstOperands,
     /* 215877 */     // GIR_Coverage, 2072,
     /* 215877 */     GIR_EraseRootFromParent_Done,
     /* 215878 */   // Label 4148: @215878
     /* 215878 */   GIM_Try, /*On fail goto*//*Label 4149*/ GIMT_Encode4(215991), // Rule ID 2079 //
     /* 215883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 215886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 215891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 215894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 215897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 215900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 215903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 215919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 215923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 215927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 215931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 215935 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 215939 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 215943 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215948 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 215952 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 215956 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 215960 */     // MIs[3] Operand 1
     /* 215960 */     // No operand predicates
     /* 215960 */     // MIs[1] Operand 2
     /* 215960 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 215971 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 215973 */     // (intrinsic_wo_chain:{ *:[v2i32] } 697:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLSHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 215973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32_indexed),
     /* 215976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215980 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 215986 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 215989 */     GIR_RootConstrainSelectedInstOperands,
     /* 215990 */     // GIR_Coverage, 2079,
     /* 215990 */     GIR_EraseRootFromParent_Done,
     /* 215991 */   // Label 4149: @215991
     /* 215991 */   GIM_Try, /*On fail goto*//*Label 4150*/ GIMT_Encode4(216096), // Rule ID 3894 //
     /* 215996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 215999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 216004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 216007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 216010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 216013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 216016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 216032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 216036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 216040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 216044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 216048 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 216052 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 216056 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216061 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 216065 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 216069 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 216073 */     // MIs[3] Operand 1
     /* 216073 */     // No operand predicates
     /* 216073 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 216075 */     // (intrinsic_wo_chain:{ *:[v4f16] } 767:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 216075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 216078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216082 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 216088 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 216091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216094 */     GIR_RootConstrainSelectedInstOperands,
     /* 216095 */     // GIR_Coverage, 3894,
     /* 216095 */     GIR_EraseRootFromParent_Done,
     /* 216096 */   // Label 4150: @216096
     /* 216096 */   GIM_Try, /*On fail goto*//*Label 4151*/ GIMT_Encode4(216201), // Rule ID 3895 //
     /* 216101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 216109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 216112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 216115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 216118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 216121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 216137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 216141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 216145 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 216149 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 216153 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 216157 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 216161 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216166 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 216170 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 216174 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 216178 */     // MIs[3] Operand 1
     /* 216178 */     // No operand predicates
     /* 216178 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 216180 */     // (intrinsic_wo_chain:{ *:[v4f16] } 770:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 216180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 216183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 216193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 216196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 216199 */     GIR_RootConstrainSelectedInstOperands,
     /* 216200 */     // GIR_Coverage, 3895,
     /* 216200 */     GIR_EraseRootFromParent_Done,
     /* 216201 */   // Label 4151: @216201
     /* 216201 */   GIM_Try, /*On fail goto*//*Label 4152*/ GIMT_Encode4(216306), // Rule ID 3896 //
     /* 216206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 216214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 216217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 216220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 216223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 216226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 216242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 216246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 216250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 216254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 216258 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 216262 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 216266 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216271 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 216275 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 216279 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 216283 */     // MIs[3] Operand 1
     /* 216283 */     // No operand predicates
     /* 216283 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 216285 */     // (intrinsic_wo_chain:{ *:[v4f16] } 768:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 216285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 216288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216292 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 216298 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 216301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 216304 */     GIR_RootConstrainSelectedInstOperands,
     /* 216305 */     // GIR_Coverage, 3896,
     /* 216305 */     GIR_EraseRootFromParent_Done,
     /* 216306 */   // Label 4152: @216306
     /* 216306 */   GIM_Try, /*On fail goto*//*Label 4153*/ GIMT_Encode4(216411), // Rule ID 3897 //
     /* 216311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 216319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 216322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 216325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 216328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 216331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 216347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 216351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 216355 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 216359 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 216363 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 216367 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 216371 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216376 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 216380 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 216384 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 216388 */     // MIs[3] Operand 1
     /* 216388 */     // No operand predicates
     /* 216388 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 216390 */     // (intrinsic_wo_chain:{ *:[v4f16] } 769:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 216390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 216393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 216403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 216406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 216409 */     GIR_RootConstrainSelectedInstOperands,
     /* 216410 */     // GIR_Coverage, 3897,
     /* 216410 */     GIR_EraseRootFromParent_Done,
     /* 216411 */   // Label 4153: @216411
     /* 216411 */   GIM_Try, /*On fail goto*//*Label 4154*/ GIMT_Encode4(216516), // Rule ID 3902 //
     /* 216416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 216424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 216430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 216452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 216456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 216460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 216464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 216468 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 216472 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 216476 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216481 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 216485 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 216489 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 216493 */     // MIs[3] Operand 1
     /* 216493 */     // No operand predicates
     /* 216493 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 216495 */     // (intrinsic_wo_chain:{ *:[v8f16] } 767:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 216495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 216498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216502 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 216508 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 216511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216514 */     GIR_RootConstrainSelectedInstOperands,
     /* 216515 */     // GIR_Coverage, 3902,
     /* 216515 */     GIR_EraseRootFromParent_Done,
     /* 216516 */   // Label 4154: @216516
     /* 216516 */   GIM_Try, /*On fail goto*//*Label 4155*/ GIMT_Encode4(216621), // Rule ID 3903 //
     /* 216521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 216529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 216535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 216557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 216561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 216565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 216569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 216573 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 216577 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 216581 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216586 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 216590 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 216594 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 216598 */     // MIs[3] Operand 1
     /* 216598 */     // No operand predicates
     /* 216598 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 216600 */     // (intrinsic_wo_chain:{ *:[v8f16] } 770:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 216600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 216603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 216613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 216616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 216619 */     GIR_RootConstrainSelectedInstOperands,
     /* 216620 */     // GIR_Coverage, 3903,
     /* 216620 */     GIR_EraseRootFromParent_Done,
     /* 216621 */   // Label 4155: @216621
     /* 216621 */   GIM_Try, /*On fail goto*//*Label 4156*/ GIMT_Encode4(216726), // Rule ID 3904 //
     /* 216626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 216634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 216640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 216662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 216666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 216670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 216674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 216678 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 216682 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 216686 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216691 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 216695 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 216699 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 216703 */     // MIs[3] Operand 1
     /* 216703 */     // No operand predicates
     /* 216703 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 216705 */     // (intrinsic_wo_chain:{ *:[v8f16] } 768:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 216705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 216708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216712 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 216718 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 216721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 216724 */     GIR_RootConstrainSelectedInstOperands,
     /* 216725 */     // GIR_Coverage, 3904,
     /* 216725 */     GIR_EraseRootFromParent_Done,
     /* 216726 */   // Label 4156: @216726
     /* 216726 */   GIM_Try, /*On fail goto*//*Label 4157*/ GIMT_Encode4(216831), // Rule ID 3905 //
     /* 216731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 216739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 216745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 216767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 216771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 216775 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 216779 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 216783 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 216787 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 216791 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216796 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 216800 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 216804 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 216808 */     // MIs[3] Operand 1
     /* 216808 */     // No operand predicates
     /* 216808 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 216810 */     // (intrinsic_wo_chain:{ *:[v8f16] } 769:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 216810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 216813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216817 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 216823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 216826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 216829 */     GIR_RootConstrainSelectedInstOperands,
     /* 216830 */     // GIR_Coverage, 3905,
     /* 216830 */     GIR_EraseRootFromParent_Done,
     /* 216831 */   // Label 4157: @216831
     /* 216831 */   GIM_Try, /*On fail goto*//*Label 4158*/ GIMT_Encode4(216936), // Rule ID 3918 //
     /* 216836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 216839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 216844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 216853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 216856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 216872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 216876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 216880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 216884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 216888 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 216892 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 216896 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216901 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 216905 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 216909 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 216913 */     // MIs[3] Operand 1
     /* 216913 */     // No operand predicates
     /* 216913 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 216915 */     // (intrinsic_wo_chain:{ *:[v4f32] } 767:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 216915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 216918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 216928 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 216931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216934 */     GIR_RootConstrainSelectedInstOperands,
     /* 216935 */     // GIR_Coverage, 3918,
     /* 216935 */     GIR_EraseRootFromParent_Done,
     /* 216936 */   // Label 4158: @216936
     /* 216936 */   GIM_Try, /*On fail goto*//*Label 4159*/ GIMT_Encode4(217041), // Rule ID 3919 //
     /* 216941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 216944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 216949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 216958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 216961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 216977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 216981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 216985 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 216989 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 216993 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 216997 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 217001 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217006 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 217010 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 217014 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 217018 */     // MIs[3] Operand 1
     /* 217018 */     // No operand predicates
     /* 217018 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 217020 */     // (intrinsic_wo_chain:{ *:[v4f32] } 770:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 217020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 217023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 217033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 217036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 217039 */     GIR_RootConstrainSelectedInstOperands,
     /* 217040 */     // GIR_Coverage, 3919,
     /* 217040 */     GIR_EraseRootFromParent_Done,
     /* 217041 */   // Label 4159: @217041
     /* 217041 */   GIM_Try, /*On fail goto*//*Label 4160*/ GIMT_Encode4(217146), // Rule ID 3920 //
     /* 217046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 217054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 217057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 217063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 217066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 217082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 217086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 217090 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 217094 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 217098 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 217102 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 217106 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217111 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 217115 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 217119 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 217123 */     // MIs[3] Operand 1
     /* 217123 */     // No operand predicates
     /* 217123 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 217125 */     // (intrinsic_wo_chain:{ *:[v4f32] } 768:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 217125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 217128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 217138 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 217141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 217144 */     GIR_RootConstrainSelectedInstOperands,
     /* 217145 */     // GIR_Coverage, 3920,
     /* 217145 */     GIR_EraseRootFromParent_Done,
     /* 217146 */   // Label 4160: @217146
     /* 217146 */   GIM_Try, /*On fail goto*//*Label 4161*/ GIMT_Encode4(217251), // Rule ID 3921 //
     /* 217151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 217159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 217162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 217168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 217171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 217187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 217191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 217195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 217199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 217203 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 217207 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 217211 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217216 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 217220 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 217224 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 217228 */     // MIs[3] Operand 1
     /* 217228 */     // No operand predicates
     /* 217228 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 217230 */     // (intrinsic_wo_chain:{ *:[v4f32] } 769:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 217230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 217233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217237 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 217243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 217246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 217249 */     GIR_RootConstrainSelectedInstOperands,
     /* 217250 */     // GIR_Coverage, 3921,
     /* 217250 */     GIR_EraseRootFromParent_Done,
     /* 217251 */   // Label 4161: @217251
     /* 217251 */   GIM_Try, /*On fail goto*//*Label 4162*/ GIMT_Encode4(217305), // Rule ID 59 //
     /* 217256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 217259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 217264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 217267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 217270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 217273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217281 */     // MIs[0] Operand 3
     /* 217281 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 217292 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 217296 */     // (intrinsic_wo_chain:{ *:[i64] } 300:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACIZA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 217296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIZA),
     /* 217299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217303 */     GIR_RootConstrainSelectedInstOperands,
     /* 217304 */     // GIR_Coverage, 59,
     /* 217304 */     GIR_EraseRootFromParent_Done,
     /* 217305 */   // Label 4162: @217305
     /* 217305 */   GIM_Try, /*On fail goto*//*Label 4163*/ GIMT_Encode4(217359), // Rule ID 60 //
     /* 217310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 217313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 217318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 217321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 217324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 217327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217335 */     // MIs[0] Operand 3
     /* 217335 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 217346 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 217350 */     // (intrinsic_wo_chain:{ *:[i64] } 300:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACDZA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 217350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDZA),
     /* 217353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217357 */     GIR_RootConstrainSelectedInstOperands,
     /* 217358 */     // GIR_Coverage, 60,
     /* 217358 */     GIR_EraseRootFromParent_Done,
     /* 217359 */   // Label 4163: @217359
     /* 217359 */   GIM_Try, /*On fail goto*//*Label 4164*/ GIMT_Encode4(217413), // Rule ID 61 //
     /* 217364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 217367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 217372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 217375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 217378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 217381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217389 */     // MIs[0] Operand 3
     /* 217389 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 217400 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 217404 */     // (intrinsic_wo_chain:{ *:[i64] } 300:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACIZB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 217404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIZB),
     /* 217407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217411 */     GIR_RootConstrainSelectedInstOperands,
     /* 217412 */     // GIR_Coverage, 61,
     /* 217412 */     GIR_EraseRootFromParent_Done,
     /* 217413 */   // Label 4164: @217413
     /* 217413 */   GIM_Try, /*On fail goto*//*Label 4165*/ GIMT_Encode4(217467), // Rule ID 62 //
     /* 217418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 217421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 217426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 217429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 217432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 217435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217443 */     // MIs[0] Operand 3
     /* 217443 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 217454 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 217458 */     // (intrinsic_wo_chain:{ *:[i64] } 300:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACDZB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 217458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDZB),
     /* 217461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217465 */     GIR_RootConstrainSelectedInstOperands,
     /* 217466 */     // GIR_Coverage, 62,
     /* 217466 */     GIR_EraseRootFromParent_Done,
     /* 217467 */   // Label 4165: @217467
     /* 217467 */   GIM_Try, /*On fail goto*//*Label 4166*/ GIMT_Encode4(217523), // Rule ID 2648 //
     /* 217472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqinch),
     /* 217480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 217483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 217486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217494 */     // MIs[0] pattern
     /* 217494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217497 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217502 */     // MIs[0] imm4
     /* 217502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217505 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217510 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1820:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCH_ZPiI),
     /* 217513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 217517 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217519 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217521 */     GIR_RootConstrainSelectedInstOperands,
     /* 217522 */     // GIR_Coverage, 2648,
     /* 217522 */     GIR_EraseRootFromParent_Done,
     /* 217523 */   // Label 4166: @217523
     /* 217523 */   GIM_Try, /*On fail goto*//*Label 4167*/ GIMT_Encode4(217579), // Rule ID 2657 //
     /* 217528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincb_n32),
     /* 217536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 217539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 217542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 217546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 217550 */     // MIs[0] pattern
     /* 217550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217553 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217558 */     // MIs[0] imm4
     /* 217558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217561 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217566 */     // (intrinsic_wo_chain:{ *:[i32] } 2026:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCB_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCB_WPiI),
     /* 217569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 217571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 217573 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217575 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217577 */     GIR_RootConstrainSelectedInstOperands,
     /* 217578 */     // GIR_Coverage, 2657,
     /* 217578 */     GIR_EraseRootFromParent_Done,
     /* 217579 */   // Label 4167: @217579
     /* 217579 */   GIM_Try, /*On fail goto*//*Label 4168*/ GIMT_Encode4(217635), // Rule ID 2658 //
     /* 217584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincb_n64),
     /* 217592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 217595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 217598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217606 */     // MIs[0] pattern
     /* 217606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217609 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217614 */     // MIs[0] imm4
     /* 217614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217617 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217622 */     // (intrinsic_wo_chain:{ *:[i64] } 1816:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCB_XPiI),
     /* 217625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 217627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 217629 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217631 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217633 */     GIR_RootConstrainSelectedInstOperands,
     /* 217634 */     // GIR_Coverage, 2658,
     /* 217634 */     GIR_EraseRootFromParent_Done,
     /* 217635 */   // Label 4168: @217635
     /* 217635 */   GIM_Try, /*On fail goto*//*Label 4169*/ GIMT_Encode4(217691), // Rule ID 10095 //
     /* 217640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecb_n32),
     /* 217648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 217651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 217654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 217658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 217662 */     // MIs[0] pattern
     /* 217662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217665 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217670 */     // MIs[0] imm4
     /* 217670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217673 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217678 */     // (intrinsic_wo_chain:{ *:[i32] } 2012:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECB_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECB_WPiI),
     /* 217681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 217683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 217685 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217687 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217689 */     GIR_RootConstrainSelectedInstOperands,
     /* 217690 */     // GIR_Coverage, 10095,
     /* 217690 */     GIR_EraseRootFromParent_Done,
     /* 217691 */   // Label 4169: @217691
     /* 217691 */   GIM_Try, /*On fail goto*//*Label 4170*/ GIMT_Encode4(217747), // Rule ID 10096 //
     /* 217696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincb_n64),
     /* 217704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 217707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 217710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217718 */     // MIs[0] pattern
     /* 217718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217721 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217726 */     // MIs[0] imm4
     /* 217726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217729 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217734 */     // (intrinsic_wo_chain:{ *:[i64] } 2027:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCB_XPiI),
     /* 217737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 217739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 217741 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217743 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217745 */     GIR_RootConstrainSelectedInstOperands,
     /* 217746 */     // GIR_Coverage, 10096,
     /* 217746 */     GIR_EraseRootFromParent_Done,
     /* 217747 */   // Label 4170: @217747
     /* 217747 */   GIM_Try, /*On fail goto*//*Label 4171*/ GIMT_Encode4(217803), // Rule ID 10097 //
     /* 217752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecb_n64),
     /* 217760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 217763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 217766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217774 */     // MIs[0] pattern
     /* 217774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217777 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217782 */     // MIs[0] imm4
     /* 217782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217785 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217790 */     // (intrinsic_wo_chain:{ *:[i64] } 1782:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECB_XPiI),
     /* 217793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 217795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 217797 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217799 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217801 */     GIR_RootConstrainSelectedInstOperands,
     /* 217802 */     // GIR_Coverage, 10097,
     /* 217802 */     GIR_EraseRootFromParent_Done,
     /* 217803 */   // Label 4171: @217803
     /* 217803 */   GIM_Try, /*On fail goto*//*Label 4172*/ GIMT_Encode4(217859), // Rule ID 10098 //
     /* 217808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecb_n64),
     /* 217816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 217819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 217822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217830 */     // MIs[0] pattern
     /* 217830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217833 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217838 */     // MIs[0] imm4
     /* 217838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217841 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217846 */     // (intrinsic_wo_chain:{ *:[i64] } 2013:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECB_XPiI),
     /* 217849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 217851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 217853 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217855 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217857 */     GIR_RootConstrainSelectedInstOperands,
     /* 217858 */     // GIR_Coverage, 10098,
     /* 217858 */     GIR_EraseRootFromParent_Done,
     /* 217859 */   // Label 4172: @217859
     /* 217859 */   GIM_Try, /*On fail goto*//*Label 4173*/ GIMT_Encode4(217915), // Rule ID 10101 //
     /* 217864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch_n32),
     /* 217872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 217875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 217878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 217882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 217886 */     // MIs[0] pattern
     /* 217886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217889 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217894 */     // MIs[0] imm4
     /* 217894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217897 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217902 */     // (intrinsic_wo_chain:{ *:[i32] } 2032:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_WPiI),
     /* 217905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 217907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 217909 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217911 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217913 */     GIR_RootConstrainSelectedInstOperands,
     /* 217914 */     // GIR_Coverage, 10101,
     /* 217914 */     GIR_EraseRootFromParent_Done,
     /* 217915 */   // Label 4173: @217915
     /* 217915 */   GIM_Try, /*On fail goto*//*Label 4174*/ GIMT_Encode4(217971), // Rule ID 10104 //
     /* 217920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech_n32),
     /* 217928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 217931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 217934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 217938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 217942 */     // MIs[0] pattern
     /* 217942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217945 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217950 */     // MIs[0] imm4
     /* 217950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217953 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217958 */     // (intrinsic_wo_chain:{ *:[i32] } 2018:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_WPiI),
     /* 217961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 217963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 217965 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217967 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217969 */     GIR_RootConstrainSelectedInstOperands,
     /* 217970 */     // GIR_Coverage, 10104,
     /* 217970 */     GIR_EraseRootFromParent_Done,
     /* 217971 */   // Label 4174: @217971
     /* 217971 */   GIM_Try, /*On fail goto*//*Label 4175*/ GIMT_Encode4(218027), // Rule ID 10105 //
     /* 217976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqinch_n64),
     /* 217984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 217987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 217990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217998 */     // MIs[0] pattern
     /* 217998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218001 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218006 */     // MIs[0] imm4
     /* 218006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218009 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218014 */     // (intrinsic_wo_chain:{ *:[i64] } 1822:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCH_XPiI),
     /* 218017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218021 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218023 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218025 */     GIR_RootConstrainSelectedInstOperands,
     /* 218026 */     // GIR_Coverage, 10105,
     /* 218026 */     GIR_EraseRootFromParent_Done,
     /* 218027 */   // Label 4175: @218027
     /* 218027 */   GIM_Try, /*On fail goto*//*Label 4176*/ GIMT_Encode4(218083), // Rule ID 10106 //
     /* 218032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch_n64),
     /* 218040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 218043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 218046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218054 */     // MIs[0] pattern
     /* 218054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218057 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218062 */     // MIs[0] imm4
     /* 218062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218065 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218070 */     // (intrinsic_wo_chain:{ *:[i64] } 2033:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_XPiI),
     /* 218073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218077 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218079 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218081 */     GIR_RootConstrainSelectedInstOperands,
     /* 218082 */     // GIR_Coverage, 10106,
     /* 218082 */     GIR_EraseRootFromParent_Done,
     /* 218083 */   // Label 4176: @218083
     /* 218083 */   GIM_Try, /*On fail goto*//*Label 4177*/ GIMT_Encode4(218139), // Rule ID 10107 //
     /* 218088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdech_n64),
     /* 218096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 218099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 218102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218110 */     // MIs[0] pattern
     /* 218110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218113 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218118 */     // MIs[0] imm4
     /* 218118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218121 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218126 */     // (intrinsic_wo_chain:{ *:[i64] } 1788:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECH_XPiI),
     /* 218129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218133 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218135 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218137 */     GIR_RootConstrainSelectedInstOperands,
     /* 218138 */     // GIR_Coverage, 10107,
     /* 218138 */     GIR_EraseRootFromParent_Done,
     /* 218139 */   // Label 4177: @218139
     /* 218139 */   GIM_Try, /*On fail goto*//*Label 4178*/ GIMT_Encode4(218195), // Rule ID 10108 //
     /* 218144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech_n64),
     /* 218152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 218155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 218158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218166 */     // MIs[0] pattern
     /* 218166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218169 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218174 */     // MIs[0] imm4
     /* 218174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218177 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218182 */     // (intrinsic_wo_chain:{ *:[i64] } 2019:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_XPiI),
     /* 218185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218189 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218191 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218193 */     GIR_RootConstrainSelectedInstOperands,
     /* 218194 */     // GIR_Coverage, 10108,
     /* 218194 */     GIR_EraseRootFromParent_Done,
     /* 218195 */   // Label 4178: @218195
     /* 218195 */   GIM_Try, /*On fail goto*//*Label 4179*/ GIMT_Encode4(218251), // Rule ID 10111 //
     /* 218200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw_n32),
     /* 218208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 218211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 218214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 218218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 218222 */     // MIs[0] pattern
     /* 218222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218225 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218230 */     // MIs[0] imm4
     /* 218230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218233 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218238 */     // (intrinsic_wo_chain:{ *:[i32] } 2038:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_WPiI),
     /* 218241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218245 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218247 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218249 */     GIR_RootConstrainSelectedInstOperands,
     /* 218250 */     // GIR_Coverage, 10111,
     /* 218250 */     GIR_EraseRootFromParent_Done,
     /* 218251 */   // Label 4179: @218251
     /* 218251 */   GIM_Try, /*On fail goto*//*Label 4180*/ GIMT_Encode4(218307), // Rule ID 10114 //
     /* 218256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw_n32),
     /* 218264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 218267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 218270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 218274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 218278 */     // MIs[0] pattern
     /* 218278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218281 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218286 */     // MIs[0] imm4
     /* 218286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218289 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218294 */     // (intrinsic_wo_chain:{ *:[i32] } 2024:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_WPiI),
     /* 218297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218301 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218303 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218305 */     GIR_RootConstrainSelectedInstOperands,
     /* 218306 */     // GIR_Coverage, 10114,
     /* 218306 */     GIR_EraseRootFromParent_Done,
     /* 218307 */   // Label 4180: @218307
     /* 218307 */   GIM_Try, /*On fail goto*//*Label 4181*/ GIMT_Encode4(218363), // Rule ID 10115 //
     /* 218312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincw_n64),
     /* 218320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 218323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 218326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218334 */     // MIs[0] pattern
     /* 218334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218337 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218342 */     // MIs[0] imm4
     /* 218342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218345 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218350 */     // (intrinsic_wo_chain:{ *:[i64] } 1828:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCW_XPiI),
     /* 218353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218357 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218359 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218361 */     GIR_RootConstrainSelectedInstOperands,
     /* 218362 */     // GIR_Coverage, 10115,
     /* 218362 */     GIR_EraseRootFromParent_Done,
     /* 218363 */   // Label 4181: @218363
     /* 218363 */   GIM_Try, /*On fail goto*//*Label 4182*/ GIMT_Encode4(218419), // Rule ID 10116 //
     /* 218368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw_n64),
     /* 218376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 218379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 218382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218390 */     // MIs[0] pattern
     /* 218390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218393 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218398 */     // MIs[0] imm4
     /* 218398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218401 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218406 */     // (intrinsic_wo_chain:{ *:[i64] } 2039:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_XPiI),
     /* 218409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218413 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218415 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218417 */     GIR_RootConstrainSelectedInstOperands,
     /* 218418 */     // GIR_Coverage, 10116,
     /* 218418 */     GIR_EraseRootFromParent_Done,
     /* 218419 */   // Label 4182: @218419
     /* 218419 */   GIM_Try, /*On fail goto*//*Label 4183*/ GIMT_Encode4(218475), // Rule ID 10117 //
     /* 218424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecw_n64),
     /* 218432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 218435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 218438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218446 */     // MIs[0] pattern
     /* 218446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218449 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218454 */     // MIs[0] imm4
     /* 218454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218457 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218462 */     // (intrinsic_wo_chain:{ *:[i64] } 1794:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECW_XPiI),
     /* 218465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218469 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218471 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218473 */     GIR_RootConstrainSelectedInstOperands,
     /* 218474 */     // GIR_Coverage, 10117,
     /* 218474 */     GIR_EraseRootFromParent_Done,
     /* 218475 */   // Label 4183: @218475
     /* 218475 */   GIM_Try, /*On fail goto*//*Label 4184*/ GIMT_Encode4(218531), // Rule ID 10118 //
     /* 218480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw_n64),
     /* 218488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 218491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 218494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218502 */     // MIs[0] pattern
     /* 218502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218505 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218510 */     // MIs[0] imm4
     /* 218510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218513 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218518 */     // (intrinsic_wo_chain:{ *:[i64] } 2025:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_XPiI),
     /* 218521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218525 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218527 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218529 */     GIR_RootConstrainSelectedInstOperands,
     /* 218530 */     // GIR_Coverage, 10118,
     /* 218530 */     GIR_EraseRootFromParent_Done,
     /* 218531 */   // Label 4184: @218531
     /* 218531 */   GIM_Try, /*On fail goto*//*Label 4185*/ GIMT_Encode4(218587), // Rule ID 10121 //
     /* 218536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd_n32),
     /* 218544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 218547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 218550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 218554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 218558 */     // MIs[0] pattern
     /* 218558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218561 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218566 */     // MIs[0] imm4
     /* 218566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218569 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218574 */     // (intrinsic_wo_chain:{ *:[i32] } 2029:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_WPiI),
     /* 218577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218581 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218583 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218585 */     GIR_RootConstrainSelectedInstOperands,
     /* 218586 */     // GIR_Coverage, 10121,
     /* 218586 */     GIR_EraseRootFromParent_Done,
     /* 218587 */   // Label 4185: @218587
     /* 218587 */   GIM_Try, /*On fail goto*//*Label 4186*/ GIMT_Encode4(218643), // Rule ID 10124 //
     /* 218592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd_n32),
     /* 218600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 218603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 218606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 218610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 218614 */     // MIs[0] pattern
     /* 218614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218617 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218622 */     // MIs[0] imm4
     /* 218622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218625 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218630 */     // (intrinsic_wo_chain:{ *:[i32] } 2015:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_WPiI),
     /* 218633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218637 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218639 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218641 */     GIR_RootConstrainSelectedInstOperands,
     /* 218642 */     // GIR_Coverage, 10124,
     /* 218642 */     GIR_EraseRootFromParent_Done,
     /* 218643 */   // Label 4186: @218643
     /* 218643 */   GIM_Try, /*On fail goto*//*Label 4187*/ GIMT_Encode4(218699), // Rule ID 10125 //
     /* 218648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincd_n64),
     /* 218656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 218659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 218662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218670 */     // MIs[0] pattern
     /* 218670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218673 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218678 */     // MIs[0] imm4
     /* 218678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218681 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218686 */     // (intrinsic_wo_chain:{ *:[i64] } 1819:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCD_XPiI),
     /* 218689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218693 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218695 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218697 */     GIR_RootConstrainSelectedInstOperands,
     /* 218698 */     // GIR_Coverage, 10125,
     /* 218698 */     GIR_EraseRootFromParent_Done,
     /* 218699 */   // Label 4187: @218699
     /* 218699 */   GIM_Try, /*On fail goto*//*Label 4188*/ GIMT_Encode4(218755), // Rule ID 10126 //
     /* 218704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd_n64),
     /* 218712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 218715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 218718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218726 */     // MIs[0] pattern
     /* 218726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218729 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218734 */     // MIs[0] imm4
     /* 218734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218737 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218742 */     // (intrinsic_wo_chain:{ *:[i64] } 2030:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_XPiI),
     /* 218745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218749 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218751 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218753 */     GIR_RootConstrainSelectedInstOperands,
     /* 218754 */     // GIR_Coverage, 10126,
     /* 218754 */     GIR_EraseRootFromParent_Done,
     /* 218755 */   // Label 4188: @218755
     /* 218755 */   GIM_Try, /*On fail goto*//*Label 4189*/ GIMT_Encode4(218811), // Rule ID 10127 //
     /* 218760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecd_n64),
     /* 218768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 218771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 218774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218782 */     // MIs[0] pattern
     /* 218782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218785 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218790 */     // MIs[0] imm4
     /* 218790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218793 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218798 */     // (intrinsic_wo_chain:{ *:[i64] } 1785:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECD_XPiI),
     /* 218801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218805 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218807 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218809 */     GIR_RootConstrainSelectedInstOperands,
     /* 218810 */     // GIR_Coverage, 10127,
     /* 218810 */     GIR_EraseRootFromParent_Done,
     /* 218811 */   // Label 4189: @218811
     /* 218811 */   GIM_Try, /*On fail goto*//*Label 4190*/ GIMT_Encode4(218867), // Rule ID 10128 //
     /* 218816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd_n64),
     /* 218824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 218827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 218830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218838 */     // MIs[0] pattern
     /* 218838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218841 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218846 */     // MIs[0] imm4
     /* 218846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218849 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218854 */     // (intrinsic_wo_chain:{ *:[i64] } 2016:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_XPiI),
     /* 218857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218861 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218863 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218865 */     GIR_RootConstrainSelectedInstOperands,
     /* 218866 */     // GIR_Coverage, 10128,
     /* 218866 */     GIR_EraseRootFromParent_Done,
     /* 218867 */   // Label 4190: @218867
     /* 218867 */   GIM_Try, /*On fail goto*//*Label 4191*/ GIMT_Encode4(218923), // Rule ID 10129 //
     /* 218872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch),
     /* 218880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 218886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218894 */     // MIs[0] pattern
     /* 218894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218897 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218902 */     // MIs[0] imm4
     /* 218902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218905 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218910 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2031:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_ZPiI),
     /* 218913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 218917 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218919 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218921 */     GIR_RootConstrainSelectedInstOperands,
     /* 218922 */     // GIR_Coverage, 10129,
     /* 218922 */     GIR_EraseRootFromParent_Done,
     /* 218923 */   // Label 4191: @218923
     /* 218923 */   GIM_Try, /*On fail goto*//*Label 4192*/ GIMT_Encode4(218979), // Rule ID 10130 //
     /* 218928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdech),
     /* 218936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 218942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218950 */     // MIs[0] pattern
     /* 218950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218953 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218958 */     // MIs[0] imm4
     /* 218958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218961 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218966 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1786:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECH_ZPiI),
     /* 218969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 218973 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218975 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218977 */     GIR_RootConstrainSelectedInstOperands,
     /* 218978 */     // GIR_Coverage, 10130,
     /* 218978 */     GIR_EraseRootFromParent_Done,
     /* 218979 */   // Label 4192: @218979
     /* 218979 */   GIM_Try, /*On fail goto*//*Label 4193*/ GIMT_Encode4(219035), // Rule ID 10131 //
     /* 218984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech),
     /* 218992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 218998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219006 */     // MIs[0] pattern
     /* 219006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219009 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219014 */     // MIs[0] imm4
     /* 219014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219017 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219022 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2017:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_ZPiI),
     /* 219025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 219029 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219031 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219033 */     GIR_RootConstrainSelectedInstOperands,
     /* 219034 */     // GIR_Coverage, 10131,
     /* 219034 */     GIR_EraseRootFromParent_Done,
     /* 219035 */   // Label 4193: @219035
     /* 219035 */   GIM_Try, /*On fail goto*//*Label 4194*/ GIMT_Encode4(219091), // Rule ID 10132 //
     /* 219040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincw),
     /* 219048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219062 */     // MIs[0] pattern
     /* 219062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219065 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219070 */     // MIs[0] imm4
     /* 219070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219073 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219078 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1826:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCW_ZPiI),
     /* 219081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 219085 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219087 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219089 */     GIR_RootConstrainSelectedInstOperands,
     /* 219090 */     // GIR_Coverage, 10132,
     /* 219090 */     GIR_EraseRootFromParent_Done,
     /* 219091 */   // Label 4194: @219091
     /* 219091 */   GIM_Try, /*On fail goto*//*Label 4195*/ GIMT_Encode4(219147), // Rule ID 10133 //
     /* 219096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw),
     /* 219104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219118 */     // MIs[0] pattern
     /* 219118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219121 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219126 */     // MIs[0] imm4
     /* 219126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219129 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219134 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2037:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_ZPiI),
     /* 219137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 219141 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219143 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219145 */     GIR_RootConstrainSelectedInstOperands,
     /* 219146 */     // GIR_Coverage, 10133,
     /* 219146 */     GIR_EraseRootFromParent_Done,
     /* 219147 */   // Label 4195: @219147
     /* 219147 */   GIM_Try, /*On fail goto*//*Label 4196*/ GIMT_Encode4(219203), // Rule ID 10134 //
     /* 219152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecw),
     /* 219160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219174 */     // MIs[0] pattern
     /* 219174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219177 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219182 */     // MIs[0] imm4
     /* 219182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219185 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219190 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1792:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECW_ZPiI),
     /* 219193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 219197 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219199 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219201 */     GIR_RootConstrainSelectedInstOperands,
     /* 219202 */     // GIR_Coverage, 10134,
     /* 219202 */     GIR_EraseRootFromParent_Done,
     /* 219203 */   // Label 4196: @219203
     /* 219203 */   GIM_Try, /*On fail goto*//*Label 4197*/ GIMT_Encode4(219259), // Rule ID 10135 //
     /* 219208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw),
     /* 219216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219230 */     // MIs[0] pattern
     /* 219230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219233 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219238 */     // MIs[0] imm4
     /* 219238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219241 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219246 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2023:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_ZPiI),
     /* 219249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 219253 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219255 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219257 */     GIR_RootConstrainSelectedInstOperands,
     /* 219258 */     // GIR_Coverage, 10135,
     /* 219258 */     GIR_EraseRootFromParent_Done,
     /* 219259 */   // Label 4197: @219259
     /* 219259 */   GIM_Try, /*On fail goto*//*Label 4198*/ GIMT_Encode4(219315), // Rule ID 10136 //
     /* 219264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincd),
     /* 219272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 219278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219286 */     // MIs[0] pattern
     /* 219286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219289 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219294 */     // MIs[0] imm4
     /* 219294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219297 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219302 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1817:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCD_ZPiI),
     /* 219305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 219309 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219311 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219313 */     GIR_RootConstrainSelectedInstOperands,
     /* 219314 */     // GIR_Coverage, 10136,
     /* 219314 */     GIR_EraseRootFromParent_Done,
     /* 219315 */   // Label 4198: @219315
     /* 219315 */   GIM_Try, /*On fail goto*//*Label 4199*/ GIMT_Encode4(219371), // Rule ID 10137 //
     /* 219320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd),
     /* 219328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 219334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219342 */     // MIs[0] pattern
     /* 219342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219345 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219350 */     // MIs[0] imm4
     /* 219350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219353 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219358 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2028:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_ZPiI),
     /* 219361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 219365 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219367 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219369 */     GIR_RootConstrainSelectedInstOperands,
     /* 219370 */     // GIR_Coverage, 10137,
     /* 219370 */     GIR_EraseRootFromParent_Done,
     /* 219371 */   // Label 4199: @219371
     /* 219371 */   GIM_Try, /*On fail goto*//*Label 4200*/ GIMT_Encode4(219427), // Rule ID 10138 //
     /* 219376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecd),
     /* 219384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 219390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219398 */     // MIs[0] pattern
     /* 219398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219401 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219406 */     // MIs[0] imm4
     /* 219406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219409 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219414 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1783:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECD_ZPiI),
     /* 219417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 219421 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219423 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219425 */     GIR_RootConstrainSelectedInstOperands,
     /* 219426 */     // GIR_Coverage, 10138,
     /* 219426 */     GIR_EraseRootFromParent_Done,
     /* 219427 */   // Label 4200: @219427
     /* 219427 */   GIM_Try, /*On fail goto*//*Label 4201*/ GIMT_Encode4(219483), // Rule ID 10139 //
     /* 219432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd),
     /* 219440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 219446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219454 */     // MIs[0] pattern
     /* 219454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219457 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219462 */     // MIs[0] imm4
     /* 219462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219465 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219470 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2014:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_ZPiI),
     /* 219473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 219477 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219479 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219481 */     GIR_RootConstrainSelectedInstOperands,
     /* 219482 */     // GIR_Coverage, 10139,
     /* 219482 */     GIR_EraseRootFromParent_Done,
     /* 219483 */   // Label 4201: @219483
     /* 219483 */   GIM_Try, /*On fail goto*//*Label 4202*/ GIMT_Encode4(219573), // Rule ID 47 //
     /* 219488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 219491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 219496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 219499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 219502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 219505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 219508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 219528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 219532 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 219536 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 219541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 219545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 219549 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 219553 */     // MIs[2] Operand 1
     /* 219553 */     // No operand predicates
     /* 219553 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 219555 */     // (intrinsic_wo_chain:{ *:[v2f32] } 616:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLALlanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 219555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALlanev4f16),
     /* 219558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 219568 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 219571 */     GIR_RootConstrainSelectedInstOperands,
     /* 219572 */     // GIR_Coverage, 47,
     /* 219572 */     GIR_EraseRootFromParent_Done,
     /* 219573 */   // Label 4202: @219573
     /* 219573 */   GIM_Try, /*On fail goto*//*Label 4203*/ GIMT_Encode4(219663), // Rule ID 48 //
     /* 219578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 219581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 219586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 219589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 219592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 219595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 219598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 219618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 219622 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 219626 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 219631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 219635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 219639 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 219643 */     // MIs[2] Operand 1
     /* 219643 */     // No operand predicates
     /* 219643 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 219645 */     // (intrinsic_wo_chain:{ *:[v4f32] } 616:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLALlanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 219645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALlanev8f16),
     /* 219648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219650 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219652 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 219658 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 219661 */     GIR_RootConstrainSelectedInstOperands,
     /* 219662 */     // GIR_Coverage, 48,
     /* 219662 */     GIR_EraseRootFromParent_Done,
     /* 219663 */   // Label 4203: @219663
     /* 219663 */   GIM_Try, /*On fail goto*//*Label 4204*/ GIMT_Encode4(219753), // Rule ID 49 //
     /* 219668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 219671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 219676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 219679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 219682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 219685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 219688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 219708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 219712 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 219716 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 219721 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 219725 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 219729 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 219733 */     // MIs[2] Operand 1
     /* 219733 */     // No operand predicates
     /* 219733 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 219735 */     // (intrinsic_wo_chain:{ *:[v2f32] } 618:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSLlanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 219735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLlanev4f16),
     /* 219738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 219748 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 219751 */     GIR_RootConstrainSelectedInstOperands,
     /* 219752 */     // GIR_Coverage, 49,
     /* 219752 */     GIR_EraseRootFromParent_Done,
     /* 219753 */   // Label 4204: @219753
     /* 219753 */   GIM_Try, /*On fail goto*//*Label 4205*/ GIMT_Encode4(219843), // Rule ID 50 //
     /* 219758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 219761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 219766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 219769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 219772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 219775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 219778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 219798 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 219802 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 219806 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 219811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 219815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 219819 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 219823 */     // MIs[2] Operand 1
     /* 219823 */     // No operand predicates
     /* 219823 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 219825 */     // (intrinsic_wo_chain:{ *:[v4f32] } 618:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSLlanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 219825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLlanev8f16),
     /* 219828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219832 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 219838 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 219841 */     GIR_RootConstrainSelectedInstOperands,
     /* 219842 */     // GIR_Coverage, 50,
     /* 219842 */     GIR_EraseRootFromParent_Done,
     /* 219843 */   // Label 4205: @219843
     /* 219843 */   GIM_Try, /*On fail goto*//*Label 4206*/ GIMT_Encode4(219933), // Rule ID 51 //
     /* 219848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 219851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 219856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 219859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 219862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 219865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 219868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 219888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 219892 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 219896 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 219901 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 219905 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 219909 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 219913 */     // MIs[2] Operand 1
     /* 219913 */     // No operand predicates
     /* 219913 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 219915 */     // (intrinsic_wo_chain:{ *:[v2f32] } 617:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLAL2lanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 219915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2lanev4f16),
     /* 219918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 219928 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 219931 */     GIR_RootConstrainSelectedInstOperands,
     /* 219932 */     // GIR_Coverage, 51,
     /* 219932 */     GIR_EraseRootFromParent_Done,
     /* 219933 */   // Label 4206: @219933
     /* 219933 */   GIM_Try, /*On fail goto*//*Label 4207*/ GIMT_Encode4(220023), // Rule ID 52 //
     /* 219938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 219941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 219946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 219949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 219952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 219955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 219958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 219978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 219982 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 219986 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 219991 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 219995 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 219999 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 220003 */     // MIs[2] Operand 1
     /* 220003 */     // No operand predicates
     /* 220003 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220005 */     // (intrinsic_wo_chain:{ *:[v4f32] } 617:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLAL2lanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 220005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2lanev8f16),
     /* 220008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220012 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 220018 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 220021 */     GIR_RootConstrainSelectedInstOperands,
     /* 220022 */     // GIR_Coverage, 52,
     /* 220022 */     GIR_EraseRootFromParent_Done,
     /* 220023 */   // Label 4207: @220023
     /* 220023 */   GIM_Try, /*On fail goto*//*Label 4208*/ GIMT_Encode4(220113), // Rule ID 53 //
     /* 220028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 220031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 220036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 220039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 220042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 220045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 220048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 220068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 220072 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 220076 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 220081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 220085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 220089 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 220093 */     // MIs[2] Operand 1
     /* 220093 */     // No operand predicates
     /* 220093 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220095 */     // (intrinsic_wo_chain:{ *:[v2f32] } 619:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSL2lanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 220095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2lanev4f16),
     /* 220098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 220108 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 220111 */     GIR_RootConstrainSelectedInstOperands,
     /* 220112 */     // GIR_Coverage, 53,
     /* 220112 */     GIR_EraseRootFromParent_Done,
     /* 220113 */   // Label 4208: @220113
     /* 220113 */   GIM_Try, /*On fail goto*//*Label 4209*/ GIMT_Encode4(220203), // Rule ID 54 //
     /* 220118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 220121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 220126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 220129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 220132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 220135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 220138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 220158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 220162 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 220166 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 220171 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 220175 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 220179 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 220183 */     // MIs[2] Operand 1
     /* 220183 */     // No operand predicates
     /* 220183 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220185 */     // (intrinsic_wo_chain:{ *:[v4f32] } 619:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSL2lanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 220185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2lanev8f16),
     /* 220188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 220198 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 220201 */     GIR_RootConstrainSelectedInstOperands,
     /* 220202 */     // GIR_Coverage, 54,
     /* 220202 */     GIR_EraseRootFromParent_Done,
     /* 220203 */   // Label 4209: @220203
     /* 220203 */   GIM_Try, /*On fail goto*//*Label 4210*/ GIMT_Encode4(220293), // Rule ID 2070 //
     /* 220208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 220211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 220216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 220219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 220222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 220225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 220228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 220248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 220252 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 220256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 220261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 220265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 220269 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 220273 */     // MIs[2] Operand 1
     /* 220273 */     // No operand predicates
     /* 220273 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220275 */     // (intrinsic_wo_chain:{ *:[v4i16] } 696:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLAHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 220275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16_indexed),
     /* 220278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 220288 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 220291 */     GIR_RootConstrainSelectedInstOperands,
     /* 220292 */     // GIR_Coverage, 2070,
     /* 220292 */     GIR_EraseRootFromParent_Done,
     /* 220293 */   // Label 4210: @220293
     /* 220293 */   GIM_Try, /*On fail goto*//*Label 4211*/ GIMT_Encode4(220383), // Rule ID 2071 //
     /* 220298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 220301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 220306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 220309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 220312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 220315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 220318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 220338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 220342 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 220346 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 220351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 220355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 220359 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 220363 */     // MIs[2] Operand 1
     /* 220363 */     // No operand predicates
     /* 220363 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220365 */     // (intrinsic_wo_chain:{ *:[v8i16] } 696:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLAHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 220365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv8i16_indexed),
     /* 220368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 220378 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 220381 */     GIR_RootConstrainSelectedInstOperands,
     /* 220382 */     // GIR_Coverage, 2071,
     /* 220382 */     GIR_EraseRootFromParent_Done,
     /* 220383 */   // Label 4211: @220383
     /* 220383 */   GIM_Try, /*On fail goto*//*Label 4212*/ GIMT_Encode4(220473), // Rule ID 2077 //
     /* 220388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 220391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 220396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 220399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 220402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 220405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 220408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 220428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 220432 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 220436 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 220441 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 220445 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 220449 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 220453 */     // MIs[2] Operand 1
     /* 220453 */     // No operand predicates
     /* 220453 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220455 */     // (intrinsic_wo_chain:{ *:[v4i16] } 697:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLSHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 220455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16_indexed),
     /* 220458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220462 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 220468 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 220471 */     GIR_RootConstrainSelectedInstOperands,
     /* 220472 */     // GIR_Coverage, 2077,
     /* 220472 */     GIR_EraseRootFromParent_Done,
     /* 220473 */   // Label 4212: @220473
     /* 220473 */   GIM_Try, /*On fail goto*//*Label 4213*/ GIMT_Encode4(220563), // Rule ID 2078 //
     /* 220478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 220481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 220486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 220489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 220492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 220495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 220498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 220518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 220522 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 220526 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 220531 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 220535 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 220539 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 220543 */     // MIs[2] Operand 1
     /* 220543 */     // No operand predicates
     /* 220543 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220545 */     // (intrinsic_wo_chain:{ *:[v8i16] } 697:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLSHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 220545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv8i16_indexed),
     /* 220548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 220558 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 220561 */     GIR_RootConstrainSelectedInstOperands,
     /* 220562 */     // GIR_Coverage, 2078,
     /* 220562 */     GIR_EraseRootFromParent_Done,
     /* 220563 */   // Label 4213: @220563
     /* 220563 */   GIM_Try, /*On fail goto*//*Label 4214*/ GIMT_Encode4(220653), // Rule ID 2073 //
     /* 220568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 220571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 220576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 220579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 220582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 220585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 220588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 220608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 220612 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 220616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 220625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 220629 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 220633 */     // MIs[2] Operand 1
     /* 220633 */     // No operand predicates
     /* 220633 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220635 */     // (intrinsic_wo_chain:{ *:[v2i32] } 696:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 220635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32_indexed),
     /* 220638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220642 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 220648 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 220651 */     GIR_RootConstrainSelectedInstOperands,
     /* 220652 */     // GIR_Coverage, 2073,
     /* 220652 */     GIR_EraseRootFromParent_Done,
     /* 220653 */   // Label 4214: @220653
     /* 220653 */   GIM_Try, /*On fail goto*//*Label 4215*/ GIMT_Encode4(220743), // Rule ID 2074 //
     /* 220658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 220661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 220666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 220669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 220672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 220675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 220678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 220698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 220702 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 220706 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 220715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 220719 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 220723 */     // MIs[2] Operand 1
     /* 220723 */     // No operand predicates
     /* 220723 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220725 */     // (intrinsic_wo_chain:{ *:[v4i32] } 696:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 220725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i32_indexed),
     /* 220728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220732 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 220738 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 220741 */     GIR_RootConstrainSelectedInstOperands,
     /* 220742 */     // GIR_Coverage, 2074,
     /* 220742 */     GIR_EraseRootFromParent_Done,
     /* 220743 */   // Label 4215: @220743
     /* 220743 */   GIM_Try, /*On fail goto*//*Label 4216*/ GIMT_Encode4(220833), // Rule ID 2080 //
     /* 220748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 220751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 220756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 220759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 220762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 220765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 220768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 220788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 220792 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 220796 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 220805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 220809 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 220813 */     // MIs[2] Operand 1
     /* 220813 */     // No operand predicates
     /* 220813 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220815 */     // (intrinsic_wo_chain:{ *:[v2i32] } 697:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 220815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32_indexed),
     /* 220818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 220828 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 220831 */     GIR_RootConstrainSelectedInstOperands,
     /* 220832 */     // GIR_Coverage, 2080,
     /* 220832 */     GIR_EraseRootFromParent_Done,
     /* 220833 */   // Label 4216: @220833
     /* 220833 */   GIM_Try, /*On fail goto*//*Label 4217*/ GIMT_Encode4(220923), // Rule ID 2081 //
     /* 220838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 220841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 220846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 220849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 220852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 220855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 220858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 220878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 220882 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 220886 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 220895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 220899 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 220903 */     // MIs[2] Operand 1
     /* 220903 */     // No operand predicates
     /* 220903 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220905 */     // (intrinsic_wo_chain:{ *:[v4i32] } 697:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 220905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i32_indexed),
     /* 220908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220912 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 220918 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 220921 */     GIR_RootConstrainSelectedInstOperands,
     /* 220922 */     // GIR_Coverage, 2081,
     /* 220922 */     GIR_EraseRootFromParent_Done,
     /* 220923 */   // Label 4217: @220923
     /* 220923 */   GIM_Try, /*On fail goto*//*Label 4218*/ GIMT_Encode4(221013), // Rule ID 2075 //
     /* 220928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 220931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 220936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 220939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 220942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 220945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 220948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 220952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 220956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 220960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 220968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 220972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 220976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 220985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 220989 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 220993 */     // MIs[2] Operand 1
     /* 220993 */     // No operand predicates
     /* 220993 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220995 */     // (intrinsic_wo_chain:{ *:[i32] } 696:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 220995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv1i32_indexed),
     /* 220998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 221002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 221004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 221008 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 221011 */     GIR_RootConstrainSelectedInstOperands,
     /* 221012 */     // GIR_Coverage, 2075,
     /* 221012 */     GIR_EraseRootFromParent_Done,
     /* 221013 */   // Label 4218: @221013
     /* 221013 */   GIM_Try, /*On fail goto*//*Label 4219*/ GIMT_Encode4(221103), // Rule ID 2082 //
     /* 221018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 221021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 221026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 221029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 221032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 221035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 221038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 221042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 221046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 221050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 221058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 221062 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 221066 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 221071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 221075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 221079 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 221083 */     // MIs[2] Operand 1
     /* 221083 */     // No operand predicates
     /* 221083 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221085 */     // (intrinsic_wo_chain:{ *:[i32] } 697:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 221085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv1i32_indexed),
     /* 221088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 221092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 221094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 221098 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 221101 */     GIR_RootConstrainSelectedInstOperands,
     /* 221102 */     // GIR_Coverage, 2082,
     /* 221102 */     GIR_EraseRootFromParent_Done,
     /* 221103 */   // Label 4219: @221103
     /* 221103 */   GIM_Try, /*On fail goto*//*Label 4220*/ GIMT_Encode4(221180), // Rule ID 2777 //
     /* 221108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 221116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221148 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 221152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221160 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 221164 */     // MIs[2] Operand 1
     /* 221164 */     // No operand predicates
     /* 221164 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221166 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1373:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 221166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_H),
     /* 221169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221178 */     GIR_RootConstrainSelectedInstOperands,
     /* 221179 */     // GIR_Coverage, 2777,
     /* 221179 */     GIR_EraseRootFromParent_Done,
     /* 221180 */   // Label 4220: @221180
     /* 221180 */   GIM_Try, /*On fail goto*//*Label 4221*/ GIMT_Encode4(221257), // Rule ID 2778 //
     /* 221185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 221193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 221229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221237 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 221241 */     // MIs[2] Operand 1
     /* 221241 */     // No operand predicates
     /* 221241 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221243 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1373:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 221243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_H),
     /* 221246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221255 */     GIR_RootConstrainSelectedInstOperands,
     /* 221256 */     // GIR_Coverage, 2778,
     /* 221256 */     GIR_EraseRootFromParent_Done,
     /* 221257 */   // Label 4221: @221257
     /* 221257 */   GIM_Try, /*On fail goto*//*Label 4222*/ GIMT_Encode4(221334), // Rule ID 2779 //
     /* 221262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 221270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 221306 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221310 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221314 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 221318 */     // MIs[2] Operand 1
     /* 221318 */     // No operand predicates
     /* 221318 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221320 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1373:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 221320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_S),
     /* 221323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221327 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221332 */     GIR_RootConstrainSelectedInstOperands,
     /* 221333 */     // GIR_Coverage, 2779,
     /* 221333 */     GIR_EraseRootFromParent_Done,
     /* 221334 */   // Label 4222: @221334
     /* 221334 */   GIM_Try, /*On fail goto*//*Label 4223*/ GIMT_Encode4(221411), // Rule ID 2780 //
     /* 221339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 221347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 221383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221391 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 221395 */     // MIs[2] Operand 1
     /* 221395 */     // No operand predicates
     /* 221395 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221397 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1373:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 221397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_S),
     /* 221400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221409 */     GIR_RootConstrainSelectedInstOperands,
     /* 221410 */     // GIR_Coverage, 2780,
     /* 221410 */     GIR_EraseRootFromParent_Done,
     /* 221411 */   // Label 4223: @221411
     /* 221411 */   GIM_Try, /*On fail goto*//*Label 4224*/ GIMT_Encode4(221488), // Rule ID 2781 //
     /* 221416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 221424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 221460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221468 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 221472 */     // MIs[2] Operand 1
     /* 221472 */     // No operand predicates
     /* 221472 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221474 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1373:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 221474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_D),
     /* 221477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221481 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221486 */     GIR_RootConstrainSelectedInstOperands,
     /* 221487 */     // GIR_Coverage, 2781,
     /* 221487 */     GIR_EraseRootFromParent_Done,
     /* 221488 */   // Label 4224: @221488
     /* 221488 */   GIM_Try, /*On fail goto*//*Label 4225*/ GIMT_Encode4(221565), // Rule ID 2782 //
     /* 221493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 221501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 221537 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221541 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221545 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 221549 */     // MIs[2] Operand 1
     /* 221549 */     // No operand predicates
     /* 221549 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221551 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1373:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 221551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_D),
     /* 221554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221563 */     GIR_RootConstrainSelectedInstOperands,
     /* 221564 */     // GIR_Coverage, 2782,
     /* 221564 */     GIR_EraseRootFromParent_Done,
     /* 221565 */   // Label 4225: @221565
     /* 221565 */   GIM_Try, /*On fail goto*//*Label 4226*/ GIMT_Encode4(221642), // Rule ID 7957 //
     /* 221570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 221578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 221614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221618 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221622 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 221626 */     // MIs[2] Operand 1
     /* 221626 */     // No operand predicates
     /* 221626 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221628 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1549:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 221628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_H),
     /* 221631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221640 */     GIR_RootConstrainSelectedInstOperands,
     /* 221641 */     // GIR_Coverage, 7957,
     /* 221641 */     GIR_EraseRootFromParent_Done,
     /* 221642 */   // Label 4226: @221642
     /* 221642 */   GIM_Try, /*On fail goto*//*Label 4227*/ GIMT_Encode4(221719), // Rule ID 7958 //
     /* 221647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 221655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 221691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221699 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 221703 */     // MIs[2] Operand 1
     /* 221703 */     // No operand predicates
     /* 221703 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221705 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1549:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 221705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_H),
     /* 221708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221712 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221717 */     GIR_RootConstrainSelectedInstOperands,
     /* 221718 */     // GIR_Coverage, 7958,
     /* 221718 */     GIR_EraseRootFromParent_Done,
     /* 221719 */   // Label 4227: @221719
     /* 221719 */   GIM_Try, /*On fail goto*//*Label 4228*/ GIMT_Encode4(221796), // Rule ID 7959 //
     /* 221724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 221732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 221768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221776 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 221780 */     // MIs[2] Operand 1
     /* 221780 */     // No operand predicates
     /* 221780 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221782 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1549:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 221782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_S),
     /* 221785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221794 */     GIR_RootConstrainSelectedInstOperands,
     /* 221795 */     // GIR_Coverage, 7959,
     /* 221795 */     GIR_EraseRootFromParent_Done,
     /* 221796 */   // Label 4228: @221796
     /* 221796 */   GIM_Try, /*On fail goto*//*Label 4229*/ GIMT_Encode4(221873), // Rule ID 7960 //
     /* 221801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 221809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 221845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221853 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 221857 */     // MIs[2] Operand 1
     /* 221857 */     // No operand predicates
     /* 221857 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221859 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1549:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 221859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_S),
     /* 221862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221871 */     GIR_RootConstrainSelectedInstOperands,
     /* 221872 */     // GIR_Coverage, 7960,
     /* 221872 */     GIR_EraseRootFromParent_Done,
     /* 221873 */   // Label 4229: @221873
     /* 221873 */   GIM_Try, /*On fail goto*//*Label 4230*/ GIMT_Encode4(221950), // Rule ID 7961 //
     /* 221878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 221886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 221922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221926 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221930 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 221934 */     // MIs[2] Operand 1
     /* 221934 */     // No operand predicates
     /* 221934 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221936 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1549:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 221936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_D),
     /* 221939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221948 */     GIR_RootConstrainSelectedInstOperands,
     /* 221949 */     // GIR_Coverage, 7961,
     /* 221949 */     GIR_EraseRootFromParent_Done,
     /* 221950 */   // Label 4230: @221950
     /* 221950 */   GIM_Try, /*On fail goto*//*Label 4231*/ GIMT_Encode4(222027), // Rule ID 7962 //
     /* 221955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 221963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 221999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222007 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 222011 */     // MIs[2] Operand 1
     /* 222011 */     // No operand predicates
     /* 222011 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222013 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1549:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 222013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_D),
     /* 222016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222025 */     GIR_RootConstrainSelectedInstOperands,
     /* 222026 */     // GIR_Coverage, 7962,
     /* 222026 */     GIR_EraseRootFromParent_Done,
     /* 222027 */   // Label 4231: @222027
     /* 222027 */   GIM_Try, /*On fail goto*//*Label 4232*/ GIMT_Encode4(222104), // Rule ID 7963 //
     /* 222032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 222040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 222076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222084 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 222088 */     // MIs[2] Operand 1
     /* 222088 */     // No operand predicates
     /* 222088 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222090 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1487:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 222090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_H),
     /* 222093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222097 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222102 */     GIR_RootConstrainSelectedInstOperands,
     /* 222103 */     // GIR_Coverage, 7963,
     /* 222103 */     GIR_EraseRootFromParent_Done,
     /* 222104 */   // Label 4232: @222104
     /* 222104 */   GIM_Try, /*On fail goto*//*Label 4233*/ GIMT_Encode4(222181), // Rule ID 7964 //
     /* 222109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 222117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 222153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222161 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 222165 */     // MIs[2] Operand 1
     /* 222165 */     // No operand predicates
     /* 222165 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222167 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1487:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 222167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_H),
     /* 222170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222179 */     GIR_RootConstrainSelectedInstOperands,
     /* 222180 */     // GIR_Coverage, 7964,
     /* 222180 */     GIR_EraseRootFromParent_Done,
     /* 222181 */   // Label 4233: @222181
     /* 222181 */   GIM_Try, /*On fail goto*//*Label 4234*/ GIMT_Encode4(222258), // Rule ID 7965 //
     /* 222186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 222194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 222230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222238 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 222242 */     // MIs[2] Operand 1
     /* 222242 */     // No operand predicates
     /* 222242 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222244 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1487:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 222244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_S),
     /* 222247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222256 */     GIR_RootConstrainSelectedInstOperands,
     /* 222257 */     // GIR_Coverage, 7965,
     /* 222257 */     GIR_EraseRootFromParent_Done,
     /* 222258 */   // Label 4234: @222258
     /* 222258 */   GIM_Try, /*On fail goto*//*Label 4235*/ GIMT_Encode4(222335), // Rule ID 7966 //
     /* 222263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 222271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 222307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222315 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 222319 */     // MIs[2] Operand 1
     /* 222319 */     // No operand predicates
     /* 222319 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222321 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1487:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 222321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_S),
     /* 222324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222333 */     GIR_RootConstrainSelectedInstOperands,
     /* 222334 */     // GIR_Coverage, 7966,
     /* 222334 */     GIR_EraseRootFromParent_Done,
     /* 222335 */   // Label 4235: @222335
     /* 222335 */   GIM_Try, /*On fail goto*//*Label 4236*/ GIMT_Encode4(222412), // Rule ID 7967 //
     /* 222340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 222348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 222384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222392 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 222396 */     // MIs[2] Operand 1
     /* 222396 */     // No operand predicates
     /* 222396 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222398 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1487:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 222398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_D),
     /* 222401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222410 */     GIR_RootConstrainSelectedInstOperands,
     /* 222411 */     // GIR_Coverage, 7967,
     /* 222411 */     GIR_EraseRootFromParent_Done,
     /* 222412 */   // Label 4236: @222412
     /* 222412 */   GIM_Try, /*On fail goto*//*Label 4237*/ GIMT_Encode4(222489), // Rule ID 7968 //
     /* 222417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 222425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 222461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222469 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 222473 */     // MIs[2] Operand 1
     /* 222473 */     // No operand predicates
     /* 222473 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222475 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1487:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 222475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_D),
     /* 222478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222487 */     GIR_RootConstrainSelectedInstOperands,
     /* 222488 */     // GIR_Coverage, 7968,
     /* 222488 */     GIR_EraseRootFromParent_Done,
     /* 222489 */   // Label 4237: @222489
     /* 222489 */   GIM_Try, /*On fail goto*//*Label 4238*/ GIMT_Encode4(222566), // Rule ID 7969 //
     /* 222494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 222502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 222538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222546 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 222550 */     // MIs[2] Operand 1
     /* 222550 */     // No operand predicates
     /* 222550 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222552 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1551:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 222552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_H),
     /* 222555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222564 */     GIR_RootConstrainSelectedInstOperands,
     /* 222565 */     // GIR_Coverage, 7969,
     /* 222565 */     GIR_EraseRootFromParent_Done,
     /* 222566 */   // Label 4238: @222566
     /* 222566 */   GIM_Try, /*On fail goto*//*Label 4239*/ GIMT_Encode4(222643), // Rule ID 7970 //
     /* 222571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 222579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 222615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222623 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 222627 */     // MIs[2] Operand 1
     /* 222627 */     // No operand predicates
     /* 222627 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222629 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1551:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 222629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_H),
     /* 222632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222641 */     GIR_RootConstrainSelectedInstOperands,
     /* 222642 */     // GIR_Coverage, 7970,
     /* 222642 */     GIR_EraseRootFromParent_Done,
     /* 222643 */   // Label 4239: @222643
     /* 222643 */   GIM_Try, /*On fail goto*//*Label 4240*/ GIMT_Encode4(222720), // Rule ID 7971 //
     /* 222648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 222656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 222692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222700 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 222704 */     // MIs[2] Operand 1
     /* 222704 */     // No operand predicates
     /* 222704 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222706 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1551:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 222706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_S),
     /* 222709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222713 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222718 */     GIR_RootConstrainSelectedInstOperands,
     /* 222719 */     // GIR_Coverage, 7971,
     /* 222719 */     GIR_EraseRootFromParent_Done,
     /* 222720 */   // Label 4240: @222720
     /* 222720 */   GIM_Try, /*On fail goto*//*Label 4241*/ GIMT_Encode4(222797), // Rule ID 7972 //
     /* 222725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 222733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 222769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222777 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 222781 */     // MIs[2] Operand 1
     /* 222781 */     // No operand predicates
     /* 222781 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222783 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1551:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 222783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_S),
     /* 222786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222795 */     GIR_RootConstrainSelectedInstOperands,
     /* 222796 */     // GIR_Coverage, 7972,
     /* 222796 */     GIR_EraseRootFromParent_Done,
     /* 222797 */   // Label 4241: @222797
     /* 222797 */   GIM_Try, /*On fail goto*//*Label 4242*/ GIMT_Encode4(222874), // Rule ID 7973 //
     /* 222802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 222810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 222846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222854 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 222858 */     // MIs[2] Operand 1
     /* 222858 */     // No operand predicates
     /* 222858 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222860 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1551:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 222860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_D),
     /* 222863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222872 */     GIR_RootConstrainSelectedInstOperands,
     /* 222873 */     // GIR_Coverage, 7973,
     /* 222873 */     GIR_EraseRootFromParent_Done,
     /* 222874 */   // Label 4242: @222874
     /* 222874 */   GIM_Try, /*On fail goto*//*Label 4243*/ GIMT_Encode4(222951), // Rule ID 7974 //
     /* 222879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 222887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 222923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222931 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 222935 */     // MIs[2] Operand 1
     /* 222935 */     // No operand predicates
     /* 222935 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222937 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1551:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 222937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_D),
     /* 222940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222949 */     GIR_RootConstrainSelectedInstOperands,
     /* 222950 */     // GIR_Coverage, 7974,
     /* 222950 */     GIR_EraseRootFromParent_Done,
     /* 222951 */   // Label 4243: @222951
     /* 222951 */   GIM_Try, /*On fail goto*//*Label 4244*/ GIMT_Encode4(223028), // Rule ID 7975 //
     /* 222956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 222964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 223000 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223004 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223008 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 223012 */     // MIs[2] Operand 1
     /* 223012 */     // No operand predicates
     /* 223012 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223014 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1441:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 223014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_H),
     /* 223017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223026 */     GIR_RootConstrainSelectedInstOperands,
     /* 223027 */     // GIR_Coverage, 7975,
     /* 223027 */     GIR_EraseRootFromParent_Done,
     /* 223028 */   // Label 4244: @223028
     /* 223028 */   GIM_Try, /*On fail goto*//*Label 4245*/ GIMT_Encode4(223105), // Rule ID 7976 //
     /* 223033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 223041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 223077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223085 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 223089 */     // MIs[2] Operand 1
     /* 223089 */     // No operand predicates
     /* 223089 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223091 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1441:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 223091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_H),
     /* 223094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223098 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223103 */     GIR_RootConstrainSelectedInstOperands,
     /* 223104 */     // GIR_Coverage, 7976,
     /* 223104 */     GIR_EraseRootFromParent_Done,
     /* 223105 */   // Label 4245: @223105
     /* 223105 */   GIM_Try, /*On fail goto*//*Label 4246*/ GIMT_Encode4(223182), // Rule ID 7977 //
     /* 223110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 223118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 223154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223162 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 223166 */     // MIs[2] Operand 1
     /* 223166 */     // No operand predicates
     /* 223166 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223168 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1441:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 223168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_S),
     /* 223171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223180 */     GIR_RootConstrainSelectedInstOperands,
     /* 223181 */     // GIR_Coverage, 7977,
     /* 223181 */     GIR_EraseRootFromParent_Done,
     /* 223182 */   // Label 4246: @223182
     /* 223182 */   GIM_Try, /*On fail goto*//*Label 4247*/ GIMT_Encode4(223259), // Rule ID 7978 //
     /* 223187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 223195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 223231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223239 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 223243 */     // MIs[2] Operand 1
     /* 223243 */     // No operand predicates
     /* 223243 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223245 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1441:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 223245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_S),
     /* 223248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223257 */     GIR_RootConstrainSelectedInstOperands,
     /* 223258 */     // GIR_Coverage, 7978,
     /* 223258 */     GIR_EraseRootFromParent_Done,
     /* 223259 */   // Label 4247: @223259
     /* 223259 */   GIM_Try, /*On fail goto*//*Label 4248*/ GIMT_Encode4(223336), // Rule ID 7979 //
     /* 223264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 223272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 223308 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223312 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223316 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 223320 */     // MIs[2] Operand 1
     /* 223320 */     // No operand predicates
     /* 223320 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223322 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1441:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 223322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_D),
     /* 223325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223334 */     GIR_RootConstrainSelectedInstOperands,
     /* 223335 */     // GIR_Coverage, 7979,
     /* 223335 */     GIR_EraseRootFromParent_Done,
     /* 223336 */   // Label 4248: @223336
     /* 223336 */   GIM_Try, /*On fail goto*//*Label 4249*/ GIMT_Encode4(223413), // Rule ID 7980 //
     /* 223341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 223349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 223385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223393 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 223397 */     // MIs[2] Operand 1
     /* 223397 */     // No operand predicates
     /* 223397 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223399 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1441:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 223399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_D),
     /* 223402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223411 */     GIR_RootConstrainSelectedInstOperands,
     /* 223412 */     // GIR_Coverage, 7980,
     /* 223412 */     GIR_EraseRootFromParent_Done,
     /* 223413 */   // Label 4249: @223413
     /* 223413 */   GIM_Try, /*On fail goto*//*Label 4250*/ GIMT_Encode4(223490), // Rule ID 7981 //
     /* 223418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 223426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 223462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223470 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 223474 */     // MIs[2] Operand 1
     /* 223474 */     // No operand predicates
     /* 223474 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223476 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1459:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 223476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_H),
     /* 223479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223488 */     GIR_RootConstrainSelectedInstOperands,
     /* 223489 */     // GIR_Coverage, 7981,
     /* 223489 */     GIR_EraseRootFromParent_Done,
     /* 223490 */   // Label 4250: @223490
     /* 223490 */   GIM_Try, /*On fail goto*//*Label 4251*/ GIMT_Encode4(223567), // Rule ID 7982 //
     /* 223495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 223503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 223539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223547 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 223551 */     // MIs[2] Operand 1
     /* 223551 */     // No operand predicates
     /* 223551 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223553 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1459:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 223553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_H),
     /* 223556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223565 */     GIR_RootConstrainSelectedInstOperands,
     /* 223566 */     // GIR_Coverage, 7982,
     /* 223566 */     GIR_EraseRootFromParent_Done,
     /* 223567 */   // Label 4251: @223567
     /* 223567 */   GIM_Try, /*On fail goto*//*Label 4252*/ GIMT_Encode4(223644), // Rule ID 7983 //
     /* 223572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 223580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 223616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223624 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 223628 */     // MIs[2] Operand 1
     /* 223628 */     // No operand predicates
     /* 223628 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223630 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1459:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 223630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_S),
     /* 223633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223637 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223642 */     GIR_RootConstrainSelectedInstOperands,
     /* 223643 */     // GIR_Coverage, 7983,
     /* 223643 */     GIR_EraseRootFromParent_Done,
     /* 223644 */   // Label 4252: @223644
     /* 223644 */   GIM_Try, /*On fail goto*//*Label 4253*/ GIMT_Encode4(223721), // Rule ID 7984 //
     /* 223649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 223657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 223693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223701 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 223705 */     // MIs[2] Operand 1
     /* 223705 */     // No operand predicates
     /* 223705 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223707 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1459:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 223707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_S),
     /* 223710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223719 */     GIR_RootConstrainSelectedInstOperands,
     /* 223720 */     // GIR_Coverage, 7984,
     /* 223720 */     GIR_EraseRootFromParent_Done,
     /* 223721 */   // Label 4253: @223721
     /* 223721 */   GIM_Try, /*On fail goto*//*Label 4254*/ GIMT_Encode4(223798), // Rule ID 7985 //
     /* 223726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 223734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 223770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223778 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 223782 */     // MIs[2] Operand 1
     /* 223782 */     // No operand predicates
     /* 223782 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223784 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1459:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 223784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_D),
     /* 223787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223791 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223796 */     GIR_RootConstrainSelectedInstOperands,
     /* 223797 */     // GIR_Coverage, 7985,
     /* 223797 */     GIR_EraseRootFromParent_Done,
     /* 223798 */   // Label 4254: @223798
     /* 223798 */   GIM_Try, /*On fail goto*//*Label 4255*/ GIMT_Encode4(223875), // Rule ID 7986 //
     /* 223803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 223811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 223847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223855 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 223859 */     // MIs[2] Operand 1
     /* 223859 */     // No operand predicates
     /* 223859 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223861 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1459:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 223861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_D),
     /* 223864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223873 */     GIR_RootConstrainSelectedInstOperands,
     /* 223874 */     // GIR_Coverage, 7986,
     /* 223874 */     GIR_EraseRootFromParent_Done,
     /* 223875 */   // Label 4255: @223875
     /* 223875 */   GIM_Try, /*On fail goto*//*Label 4256*/ GIMT_Encode4(223952), // Rule ID 7987 //
     /* 223880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 223888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 223924 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223928 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223932 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 223936 */     // MIs[2] Operand 1
     /* 223936 */     // No operand predicates
     /* 223936 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223938 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1435:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 223938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_H),
     /* 223941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223950 */     GIR_RootConstrainSelectedInstOperands,
     /* 223951 */     // GIR_Coverage, 7987,
     /* 223951 */     GIR_EraseRootFromParent_Done,
     /* 223952 */   // Label 4256: @223952
     /* 223952 */   GIM_Try, /*On fail goto*//*Label 4257*/ GIMT_Encode4(224029), // Rule ID 7988 //
     /* 223957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 223965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 224001 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224005 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224009 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 224013 */     // MIs[2] Operand 1
     /* 224013 */     // No operand predicates
     /* 224013 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224015 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1435:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 224015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_H),
     /* 224018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224022 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224027 */     GIR_RootConstrainSelectedInstOperands,
     /* 224028 */     // GIR_Coverage, 7988,
     /* 224028 */     GIR_EraseRootFromParent_Done,
     /* 224029 */   // Label 4257: @224029
     /* 224029 */   GIM_Try, /*On fail goto*//*Label 4258*/ GIMT_Encode4(224106), // Rule ID 7989 //
     /* 224034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 224042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 224078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224086 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 224090 */     // MIs[2] Operand 1
     /* 224090 */     // No operand predicates
     /* 224090 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224092 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1435:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 224092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_S),
     /* 224095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224104 */     GIR_RootConstrainSelectedInstOperands,
     /* 224105 */     // GIR_Coverage, 7989,
     /* 224105 */     GIR_EraseRootFromParent_Done,
     /* 224106 */   // Label 4258: @224106
     /* 224106 */   GIM_Try, /*On fail goto*//*Label 4259*/ GIMT_Encode4(224183), // Rule ID 7990 //
     /* 224111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 224119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 224155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224163 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 224167 */     // MIs[2] Operand 1
     /* 224167 */     // No operand predicates
     /* 224167 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224169 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1435:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 224169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_S),
     /* 224172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224181 */     GIR_RootConstrainSelectedInstOperands,
     /* 224182 */     // GIR_Coverage, 7990,
     /* 224182 */     GIR_EraseRootFromParent_Done,
     /* 224183 */   // Label 4259: @224183
     /* 224183 */   GIM_Try, /*On fail goto*//*Label 4260*/ GIMT_Encode4(224260), // Rule ID 7991 //
     /* 224188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 224196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 224232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224240 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 224244 */     // MIs[2] Operand 1
     /* 224244 */     // No operand predicates
     /* 224244 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224246 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1435:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 224246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_D),
     /* 224249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224258 */     GIR_RootConstrainSelectedInstOperands,
     /* 224259 */     // GIR_Coverage, 7991,
     /* 224259 */     GIR_EraseRootFromParent_Done,
     /* 224260 */   // Label 4260: @224260
     /* 224260 */   GIM_Try, /*On fail goto*//*Label 4261*/ GIMT_Encode4(224337), // Rule ID 7992 //
     /* 224265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 224273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 224309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224317 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 224321 */     // MIs[2] Operand 1
     /* 224321 */     // No operand predicates
     /* 224321 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224323 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1435:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 224323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_D),
     /* 224326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224335 */     GIR_RootConstrainSelectedInstOperands,
     /* 224336 */     // GIR_Coverage, 7992,
     /* 224336 */     GIR_EraseRootFromParent_Done,
     /* 224337 */   // Label 4261: @224337
     /* 224337 */   GIM_Try, /*On fail goto*//*Label 4262*/ GIMT_Encode4(224414), // Rule ID 7993 //
     /* 224342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 224350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 224386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224394 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 224398 */     // MIs[2] Operand 1
     /* 224398 */     // No operand predicates
     /* 224398 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224400 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1453:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 224400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_H),
     /* 224403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224412 */     GIR_RootConstrainSelectedInstOperands,
     /* 224413 */     // GIR_Coverage, 7993,
     /* 224413 */     GIR_EraseRootFromParent_Done,
     /* 224414 */   // Label 4262: @224414
     /* 224414 */   GIM_Try, /*On fail goto*//*Label 4263*/ GIMT_Encode4(224491), // Rule ID 7994 //
     /* 224419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 224427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 224463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224471 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 224475 */     // MIs[2] Operand 1
     /* 224475 */     // No operand predicates
     /* 224475 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224477 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1453:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 224477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_H),
     /* 224480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224484 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224489 */     GIR_RootConstrainSelectedInstOperands,
     /* 224490 */     // GIR_Coverage, 7994,
     /* 224490 */     GIR_EraseRootFromParent_Done,
     /* 224491 */   // Label 4263: @224491
     /* 224491 */   GIM_Try, /*On fail goto*//*Label 4264*/ GIMT_Encode4(224568), // Rule ID 7995 //
     /* 224496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 224504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 224540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224548 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 224552 */     // MIs[2] Operand 1
     /* 224552 */     // No operand predicates
     /* 224552 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224554 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1453:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 224554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_S),
     /* 224557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224561 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224566 */     GIR_RootConstrainSelectedInstOperands,
     /* 224567 */     // GIR_Coverage, 7995,
     /* 224567 */     GIR_EraseRootFromParent_Done,
     /* 224568 */   // Label 4264: @224568
     /* 224568 */   GIM_Try, /*On fail goto*//*Label 4265*/ GIMT_Encode4(224645), // Rule ID 7996 //
     /* 224573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 224581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 224617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224625 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 224629 */     // MIs[2] Operand 1
     /* 224629 */     // No operand predicates
     /* 224629 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224631 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1453:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 224631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_S),
     /* 224634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224643 */     GIR_RootConstrainSelectedInstOperands,
     /* 224644 */     // GIR_Coverage, 7996,
     /* 224644 */     GIR_EraseRootFromParent_Done,
     /* 224645 */   // Label 4265: @224645
     /* 224645 */   GIM_Try, /*On fail goto*//*Label 4266*/ GIMT_Encode4(224722), // Rule ID 7997 //
     /* 224650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 224658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 224694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224702 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 224706 */     // MIs[2] Operand 1
     /* 224706 */     // No operand predicates
     /* 224706 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224708 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1453:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 224708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_D),
     /* 224711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224715 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224720 */     GIR_RootConstrainSelectedInstOperands,
     /* 224721 */     // GIR_Coverage, 7997,
     /* 224721 */     GIR_EraseRootFromParent_Done,
     /* 224722 */   // Label 4266: @224722
     /* 224722 */   GIM_Try, /*On fail goto*//*Label 4267*/ GIMT_Encode4(224799), // Rule ID 7998 //
     /* 224727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 224735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 224771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224779 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 224783 */     // MIs[2] Operand 1
     /* 224783 */     // No operand predicates
     /* 224783 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224785 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1453:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 224785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_D),
     /* 224788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224797 */     GIR_RootConstrainSelectedInstOperands,
     /* 224798 */     // GIR_Coverage, 7998,
     /* 224798 */     GIR_EraseRootFromParent_Done,
     /* 224799 */   // Label 4267: @224799
     /* 224799 */   GIM_Try, /*On fail goto*//*Label 4268*/ GIMT_Encode4(224855), // Rule ID 55 //
     /* 224804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 224807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 224812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 224815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 224818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 224821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 224825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 224829 */     // MIs[0] Operand 3
     /* 224829 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 224840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 224844 */     // (intrinsic_wo_chain:{ *:[i64] } 300:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACIA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 224844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIA),
     /* 224847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 224851 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 224853 */     GIR_RootConstrainSelectedInstOperands,
     /* 224854 */     // GIR_Coverage, 55,
     /* 224854 */     GIR_EraseRootFromParent_Done,
     /* 224855 */   // Label 4268: @224855
     /* 224855 */   GIM_Try, /*On fail goto*//*Label 4269*/ GIMT_Encode4(224911), // Rule ID 56 //
     /* 224860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 224863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 224868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 224871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 224874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 224877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 224881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 224885 */     // MIs[0] Operand 3
     /* 224885 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 224896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 224900 */     // (intrinsic_wo_chain:{ *:[i64] } 300:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACIB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 224900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIB),
     /* 224903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 224907 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 224909 */     GIR_RootConstrainSelectedInstOperands,
     /* 224910 */     // GIR_Coverage, 56,
     /* 224910 */     GIR_EraseRootFromParent_Done,
     /* 224911 */   // Label 4269: @224911
     /* 224911 */   GIM_Try, /*On fail goto*//*Label 4270*/ GIMT_Encode4(224967), // Rule ID 57 //
     /* 224916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 224919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 224924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 224927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 224930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 224933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 224937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 224941 */     // MIs[0] Operand 3
     /* 224941 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 224952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 224956 */     // (intrinsic_wo_chain:{ *:[i64] } 300:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACDA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 224956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDA),
     /* 224959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 224963 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 224965 */     GIR_RootConstrainSelectedInstOperands,
     /* 224966 */     // GIR_Coverage, 57,
     /* 224966 */     GIR_EraseRootFromParent_Done,
     /* 224967 */   // Label 4270: @224967
     /* 224967 */   GIM_Try, /*On fail goto*//*Label 4271*/ GIMT_Encode4(225023), // Rule ID 58 //
     /* 224972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 224975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 224980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 224983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 224986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 224989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 224993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 224997 */     // MIs[0] Operand 3
     /* 224997 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 225008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 225012 */     // (intrinsic_wo_chain:{ *:[i64] } 300:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACDB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 225012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDB),
     /* 225015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 225019 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 225021 */     GIR_RootConstrainSelectedInstOperands,
     /* 225022 */     // GIR_Coverage, 58,
     /* 225022 */     GIR_EraseRootFromParent_Done,
     /* 225023 */   // Label 4271: @225023
     /* 225023 */   GIM_Try, /*On fail goto*//*Label 4272*/ GIMT_Encode4(225078), // Rule ID 2795 //
     /* 225028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 225031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 225036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225057 */     // MIs[0] imm
     /* 225057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225060 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 225065 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1552:{ *:[iPTR] }, ZPR16:{ *:[nxv8f16] }:$Zn, ZPR16:{ *:[nxv8f16] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_H:{ *:[nxv8f16] } ZPR16:{ *:[nxv8f16] }:$Zn, ZPR16:{ *:[nxv8f16] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 225065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_H),
     /* 225068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 225072 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 225074 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 225076 */     GIR_RootConstrainSelectedInstOperands,
     /* 225077 */     // GIR_Coverage, 2795,
     /* 225077 */     GIR_EraseRootFromParent_Done,
     /* 225078 */   // Label 4272: @225078
     /* 225078 */   GIM_Try, /*On fail goto*//*Label 4273*/ GIMT_Encode4(225133), // Rule ID 2796 //
     /* 225083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 225086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 225091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225112 */     // MIs[0] imm
     /* 225112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225115 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 225120 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1552:{ *:[iPTR] }, ZPR32:{ *:[nxv4f32] }:$Zn, ZPR32:{ *:[nxv4f32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_S:{ *:[nxv4f32] } ZPR32:{ *:[nxv4f32] }:$Zn, ZPR32:{ *:[nxv4f32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 225120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_S),
     /* 225123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 225127 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 225129 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 225131 */     GIR_RootConstrainSelectedInstOperands,
     /* 225132 */     // GIR_Coverage, 2796,
     /* 225132 */     GIR_EraseRootFromParent_Done,
     /* 225133 */   // Label 4273: @225133
     /* 225133 */   GIM_Try, /*On fail goto*//*Label 4274*/ GIMT_Encode4(225188), // Rule ID 2797 //
     /* 225138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 225141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 225146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 225152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225167 */     // MIs[0] imm
     /* 225167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225170 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 225175 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1552:{ *:[iPTR] }, ZPR64:{ *:[nxv2f64] }:$Zn, ZPR64:{ *:[nxv2f64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_D:{ *:[nxv2f64] } ZPR64:{ *:[nxv2f64] }:$Zn, ZPR64:{ *:[nxv2f64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 225175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_D),
     /* 225178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 225182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 225184 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 225186 */     GIR_RootConstrainSelectedInstOperands,
     /* 225187 */     // GIR_Coverage, 2797,
     /* 225187 */     GIR_EraseRootFromParent_Done,
     /* 225188 */   // Label 4274: @225188
     /* 225188 */   GIM_Try, /*On fail goto*//*Label 4275*/ GIMT_Encode4(225243), // Rule ID 3571 //
     /* 225193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 225196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 225201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 225210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 225222 */     // MIs[0] Idx
     /* 225222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225225 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_1),
     /* 225230 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1638:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zd, PPR16:{ *:[nxv8i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_1>>:$Idx)  =>  (PMOV_ZIP_H:{ *:[nxv8i16] } ZPRAny:{ *:[nxv8i16] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_1>>:$Idx, PPR16:{ *:[nxv8i1] }:$Pn)
     /* 225230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_H),
     /* 225233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 225237 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 225239 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 225241 */     GIR_RootConstrainSelectedInstOperands,
     /* 225242 */     // GIR_Coverage, 3571,
     /* 225242 */     GIR_EraseRootFromParent_Done,
     /* 225243 */   // Label 4275: @225243
     /* 225243 */   GIM_Try, /*On fail goto*//*Label 4276*/ GIMT_Encode4(225298), // Rule ID 3572 //
     /* 225248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 225251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 225256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 225265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 225277 */     // MIs[0] Idx
     /* 225277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225280 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_3),
     /* 225285 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1638:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zd, PPR32:{ *:[nxv4i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_3>>:$Idx)  =>  (PMOV_ZIP_S:{ *:[nxv4i32] } ZPRAny:{ *:[nxv4i32] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_3>>:$Idx, PPR32:{ *:[nxv4i1] }:$Pn)
     /* 225285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_S),
     /* 225288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 225292 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 225294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 225296 */     GIR_RootConstrainSelectedInstOperands,
     /* 225297 */     // GIR_Coverage, 3572,
     /* 225297 */     GIR_EraseRootFromParent_Done,
     /* 225298 */   // Label 4276: @225298
     /* 225298 */   GIM_Try, /*On fail goto*//*Label 4277*/ GIMT_Encode4(225353), // Rule ID 3573 //
     /* 225303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 225306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 225311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 225317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 225320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 225332 */     // MIs[0] Idx
     /* 225332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225335 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_7),
     /* 225340 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1638:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zd, PPR64:{ *:[nxv2i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_7>>:$Idx)  =>  (PMOV_ZIP_D:{ *:[nxv2i64] } ZPRAny:{ *:[nxv2i64] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_7>>:$Idx, PPR64:{ *:[nxv2i1] }:$Pn)
     /* 225340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_D),
     /* 225343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 225347 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 225349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 225351 */     GIR_RootConstrainSelectedInstOperands,
     /* 225352 */     // GIR_Coverage, 3573,
     /* 225352 */     GIR_EraseRootFromParent_Done,
     /* 225353 */   // Label 4277: @225353
     /* 225353 */   GIM_Try, /*On fail goto*//*Label 4278*/ GIMT_Encode4(225408), // Rule ID 3869 //
     /* 225358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 225361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_xar),
     /* 225366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 225369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 225372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 225375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 225379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 225383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 225387 */     // MIs[0] imm
     /* 225387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225390 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm0_63),
     /* 225395 */     // (intrinsic_wo_chain:{ *:[v2i64] } 553:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_timm0_63>>:$imm)  =>  (XAR:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_timm0_63>>:$imm)
     /* 225395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR),
     /* 225398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 225400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 225402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 225404 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 225406 */     GIR_RootConstrainSelectedInstOperands,
     /* 225407 */     // GIR_Coverage, 3869,
     /* 225407 */     GIR_EraseRootFromParent_Done,
     /* 225408 */   // Label 4278: @225408
     /* 225408 */   GIM_Try, /*On fail goto*//*Label 4279*/ GIMT_Encode4(225455), // Rule ID 2858 //
     /* 225413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 225421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225434 */     // MIs[0] idx
     /* 225434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225437 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 225442 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1488:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMUL_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 225442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_H),
     /* 225445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225449 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225451 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 225453 */     GIR_RootConstrainSelectedInstOperands,
     /* 225454 */     // GIR_Coverage, 2858,
     /* 225454 */     GIR_EraseRootFromParent_Done,
     /* 225455 */   // Label 4279: @225455
     /* 225455 */   GIM_Try, /*On fail goto*//*Label 4280*/ GIMT_Encode4(225502), // Rule ID 2862 //
     /* 225460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 225468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225481 */     // MIs[0] idx
     /* 225481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225484 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 225489 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1488:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMUL_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 225489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_S),
     /* 225492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225496 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225498 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 225500 */     GIR_RootConstrainSelectedInstOperands,
     /* 225501 */     // GIR_Coverage, 2862,
     /* 225501 */     GIR_EraseRootFromParent_Done,
     /* 225502 */   // Label 4280: @225502
     /* 225502 */   GIM_Try, /*On fail goto*//*Label 4281*/ GIMT_Encode4(225549), // Rule ID 2866 //
     /* 225507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 225515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 225521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225528 */     // MIs[0] idx
     /* 225528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225531 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 225536 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1488:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMUL_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 225536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_D),
     /* 225539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225545 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 225547 */     GIR_RootConstrainSelectedInstOperands,
     /* 225548 */     // GIR_Coverage, 2866,
     /* 225548 */     GIR_EraseRootFromParent_Done,
     /* 225549 */   // Label 4281: @225549
     /* 225549 */   GIM_Try, /*On fail goto*//*Label 4282*/ GIMT_Encode4(225596), // Rule ID 3015 //
     /* 225554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 225562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225575 */     // MIs[0] Op3
     /* 225575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225578 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 225583 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1619:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (MUL_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 225583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_H),
     /* 225586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225592 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225594 */     GIR_RootConstrainSelectedInstOperands,
     /* 225595 */     // GIR_Coverage, 3015,
     /* 225595 */     GIR_EraseRootFromParent_Done,
     /* 225596 */   // Label 4282: @225596
     /* 225596 */   GIM_Try, /*On fail goto*//*Label 4283*/ GIMT_Encode4(225643), // Rule ID 3016 //
     /* 225601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 225609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225622 */     // MIs[0] Op3
     /* 225622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225625 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 225630 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1619:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (MUL_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 225630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_S),
     /* 225633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225637 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225639 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225641 */     GIR_RootConstrainSelectedInstOperands,
     /* 225642 */     // GIR_Coverage, 3016,
     /* 225642 */     GIR_EraseRootFromParent_Done,
     /* 225643 */   // Label 4283: @225643
     /* 225643 */   GIM_Try, /*On fail goto*//*Label 4284*/ GIMT_Encode4(225690), // Rule ID 3017 //
     /* 225648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 225656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 225662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225669 */     // MIs[0] Op3
     /* 225669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225672 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 225677 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1619:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (MUL_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 225677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_D),
     /* 225680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225686 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225688 */     GIR_RootConstrainSelectedInstOperands,
     /* 225689 */     // GIR_Coverage, 3017,
     /* 225689 */     GIR_EraseRootFromParent_Done,
     /* 225690 */   // Label 4284: @225690
     /* 225690 */   GIM_Try, /*On fail goto*//*Label 4285*/ GIMT_Encode4(225737), // Rule ID 3018 //
     /* 225695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb_lane),
     /* 225703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225716 */     // MIs[0] Op3
     /* 225716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225719 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 225724 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1765:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 225724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZI_S),
     /* 225727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225733 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225735 */     GIR_RootConstrainSelectedInstOperands,
     /* 225736 */     // GIR_Coverage, 3018,
     /* 225736 */     GIR_EraseRootFromParent_Done,
     /* 225737 */   // Label 4285: @225737
     /* 225737 */   GIM_Try, /*On fail goto*//*Label 4286*/ GIMT_Encode4(225784), // Rule ID 3019 //
     /* 225742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb_lane),
     /* 225750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225763 */     // MIs[0] Op3
     /* 225763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225766 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 225771 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1765:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 225771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZI_D),
     /* 225774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225778 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225780 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225782 */     GIR_RootConstrainSelectedInstOperands,
     /* 225783 */     // GIR_Coverage, 3019,
     /* 225783 */     GIR_EraseRootFromParent_Done,
     /* 225784 */   // Label 4286: @225784
     /* 225784 */   GIM_Try, /*On fail goto*//*Label 4287*/ GIMT_Encode4(225831), // Rule ID 3067 //
     /* 225789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 225797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 225800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 225803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 225806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225810 */     // MIs[0] Op3
     /* 225810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225813 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 225818 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1876:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 225818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_B),
     /* 225821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225827 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225829 */     GIR_RootConstrainSelectedInstOperands,
     /* 225830 */     // GIR_Coverage, 3067,
     /* 225830 */     GIR_EraseRootFromParent_Done,
     /* 225831 */   // Label 4287: @225831
     /* 225831 */   GIM_Try, /*On fail goto*//*Label 4288*/ GIMT_Encode4(225878), // Rule ID 3069 //
     /* 225836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 225844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225857 */     // MIs[0] Op3
     /* 225857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225860 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 225865 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1876:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 225865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_H),
     /* 225868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225874 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225876 */     GIR_RootConstrainSelectedInstOperands,
     /* 225877 */     // GIR_Coverage, 3069,
     /* 225877 */     GIR_EraseRootFromParent_Done,
     /* 225878 */   // Label 4288: @225878
     /* 225878 */   GIM_Try, /*On fail goto*//*Label 4289*/ GIMT_Encode4(225925), // Rule ID 3071 //
     /* 225883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 225891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225904 */     // MIs[0] Op3
     /* 225904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225907 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 225912 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1876:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 225912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_S),
     /* 225915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225921 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225923 */     GIR_RootConstrainSelectedInstOperands,
     /* 225924 */     // GIR_Coverage, 3071,
     /* 225924 */     GIR_EraseRootFromParent_Done,
     /* 225925 */   // Label 4289: @225925
     /* 225925 */   GIM_Try, /*On fail goto*//*Label 4290*/ GIMT_Encode4(225972), // Rule ID 3073 //
     /* 225930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 225938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 225944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225951 */     // MIs[0] Op3
     /* 225951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225954 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 225959 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1876:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 225959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_D),
     /* 225962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225968 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225970 */     GIR_RootConstrainSelectedInstOperands,
     /* 225971 */     // GIR_Coverage, 3073,
     /* 225971 */     GIR_EraseRootFromParent_Done,
     /* 225972 */   // Label 4290: @225972
     /* 225972 */   GIM_Try, /*On fail goto*//*Label 4291*/ GIMT_Encode4(226019), // Rule ID 3095 //
     /* 225977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 225985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 225988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 225991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225998 */     // MIs[0] Op3
     /* 225998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226001 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 226006 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1856:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQSHRUNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 226006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_B),
     /* 226009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226015 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226017 */     GIR_RootConstrainSelectedInstOperands,
     /* 226018 */     // GIR_Coverage, 3095,
     /* 226018 */     GIR_EraseRootFromParent_Done,
     /* 226019 */   // Label 4291: @226019
     /* 226019 */   GIM_Try, /*On fail goto*//*Label 4292*/ GIMT_Encode4(226066), // Rule ID 3096 //
     /* 226024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 226032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226045 */     // MIs[0] Op3
     /* 226045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226048 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 226053 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1856:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQSHRUNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 226053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_H),
     /* 226056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226060 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226062 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226064 */     GIR_RootConstrainSelectedInstOperands,
     /* 226065 */     // GIR_Coverage, 3096,
     /* 226065 */     GIR_EraseRootFromParent_Done,
     /* 226066 */   // Label 4292: @226066
     /* 226066 */   GIM_Try, /*On fail goto*//*Label 4293*/ GIMT_Encode4(226113), // Rule ID 3097 //
     /* 226071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 226079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 226085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226092 */     // MIs[0] Op3
     /* 226092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226095 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 226100 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1856:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQSHRUNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 226100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_S),
     /* 226103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226109 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226111 */     GIR_RootConstrainSelectedInstOperands,
     /* 226112 */     // GIR_Coverage, 3097,
     /* 226112 */     GIR_EraseRootFromParent_Done,
     /* 226113 */   // Label 4293: @226113
     /* 226113 */   GIM_Try, /*On fail goto*//*Label 4294*/ GIMT_Encode4(226160), // Rule ID 3166 //
     /* 226118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 226126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 226132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226139 */     // MIs[0] Op3
     /* 226139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226142 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 226147 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2157:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (XAR_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 226147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_B),
     /* 226150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226156 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226158 */     GIR_RootConstrainSelectedInstOperands,
     /* 226159 */     // GIR_Coverage, 3166,
     /* 226159 */     GIR_EraseRootFromParent_Done,
     /* 226160 */   // Label 4294: @226160
     /* 226160 */   GIM_Try, /*On fail goto*//*Label 4295*/ GIMT_Encode4(226207), // Rule ID 3167 //
     /* 226165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 226173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226186 */     // MIs[0] Op3
     /* 226186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226189 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 226194 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2157:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (XAR_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 226194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_H),
     /* 226197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226201 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226203 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226205 */     GIR_RootConstrainSelectedInstOperands,
     /* 226206 */     // GIR_Coverage, 3167,
     /* 226206 */     GIR_EraseRootFromParent_Done,
     /* 226207 */   // Label 4295: @226207
     /* 226207 */   GIM_Try, /*On fail goto*//*Label 4296*/ GIMT_Encode4(226254), // Rule ID 3168 //
     /* 226212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 226220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 226226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226233 */     // MIs[0] Op3
     /* 226233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226236 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 226241 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2157:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (XAR_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 226241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_S),
     /* 226244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226250 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226252 */     GIR_RootConstrainSelectedInstOperands,
     /* 226253 */     // GIR_Coverage, 3168,
     /* 226253 */     GIR_EraseRootFromParent_Done,
     /* 226254 */   // Label 4296: @226254
     /* 226254 */   GIM_Try, /*On fail goto*//*Label 4297*/ GIMT_Encode4(226301), // Rule ID 3169 //
     /* 226259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 226267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 226273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226280 */     // MIs[0] Op3
     /* 226280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226283 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 226288 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2157:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (XAR_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 226288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_D),
     /* 226291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226297 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226299 */     GIR_RootConstrainSelectedInstOperands,
     /* 226300 */     // GIR_Coverage, 3169,
     /* 226300 */     GIR_EraseRootFromParent_Done,
     /* 226301 */   // Label 4297: @226301
     /* 226301 */   GIM_Try, /*On fail goto*//*Label 4298*/ GIMT_Encode4(226348), // Rule ID 3556 //
     /* 226306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 226309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_extq),
     /* 226314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 226320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226327 */     // MIs[0] Op3
     /* 226327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226330 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_15),
     /* 226335 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1367:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_15>>:$Op3)  =>  (EXTQ_ZZI:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_15>>:$Op3)
     /* 226335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTQ_ZZI),
     /* 226338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226342 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226344 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226346 */     GIR_RootConstrainSelectedInstOperands,
     /* 226347 */     // GIR_Coverage, 3556,
     /* 226347 */     GIR_EraseRootFromParent_Done,
     /* 226348 */   // Label 4298: @226348
     /* 226348 */   GIM_Try, /*On fail goto*//*Label 4299*/ GIMT_Encode4(226395), // Rule ID 3604 //
     /* 226353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 226356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 226361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 226367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226374 */     // MIs[0] Op3
     /* 226374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226377 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 226382 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1606:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI2_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 226382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_B),
     /* 226385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226391 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226393 */     GIR_RootConstrainSelectedInstOperands,
     /* 226394 */     // GIR_Coverage, 3604,
     /* 226394 */     GIR_EraseRootFromParent_Done,
     /* 226395 */   // Label 4299: @226395
     /* 226395 */   GIM_Try, /*On fail goto*//*Label 4300*/ GIMT_Encode4(226442), // Rule ID 3605 //
     /* 226400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 226403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 226408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226421 */     // MIs[0] Op3
     /* 226421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226424 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 226429 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1606:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)  =>  (LUTI2_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)
     /* 226429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_H),
     /* 226432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226438 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226440 */     GIR_RootConstrainSelectedInstOperands,
     /* 226441 */     // GIR_Coverage, 3605,
     /* 226441 */     GIR_EraseRootFromParent_Done,
     /* 226442 */   // Label 4300: @226442
     /* 226442 */   GIM_Try, /*On fail goto*//*Label 4301*/ GIMT_Encode4(226489), // Rule ID 3606 //
     /* 226447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 226450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 226455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226468 */     // MIs[0] Op3
     /* 226468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226471 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 226476 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1606:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)  =>  (LUTI2_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)
     /* 226476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_H),
     /* 226479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226485 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226487 */     GIR_RootConstrainSelectedInstOperands,
     /* 226488 */     // GIR_Coverage, 3606,
     /* 226488 */     GIR_EraseRootFromParent_Done,
     /* 226489 */   // Label 4301: @226489
     /* 226489 */   GIM_Try, /*On fail goto*//*Label 4302*/ GIMT_Encode4(226536), // Rule ID 3607 //
     /* 226494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 226497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 226502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 226508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226515 */     // MIs[0] Op3
     /* 226515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226518 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 226523 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1607:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Op3)  =>  (LUTI4_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Op3)
     /* 226523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_B),
     /* 226526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226532 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226534 */     GIR_RootConstrainSelectedInstOperands,
     /* 226535 */     // GIR_Coverage, 3607,
     /* 226535 */     GIR_EraseRootFromParent_Done,
     /* 226536 */   // Label 4302: @226536
     /* 226536 */   GIM_Try, /*On fail goto*//*Label 4303*/ GIMT_Encode4(226583), // Rule ID 3608 //
     /* 226541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 226544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 226549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226562 */     // MIs[0] Op3
     /* 226562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226565 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 226570 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1607:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI4_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 226570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_H),
     /* 226573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226579 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226581 */     GIR_RootConstrainSelectedInstOperands,
     /* 226582 */     // GIR_Coverage, 3608,
     /* 226582 */     GIR_EraseRootFromParent_Done,
     /* 226583 */   // Label 4303: @226583
     /* 226583 */   GIM_Try, /*On fail goto*//*Label 4304*/ GIMT_Encode4(226630), // Rule ID 3609 //
     /* 226588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 226591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 226596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226609 */     // MIs[0] Op3
     /* 226609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226612 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 226617 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1607:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI4_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 226617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_H),
     /* 226620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226626 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226628 */     GIR_RootConstrainSelectedInstOperands,
     /* 226629 */     // GIR_Coverage, 3609,
     /* 226629 */     GIR_EraseRootFromParent_Done,
     /* 226630 */   // Label 4304: @226630
     /* 226630 */   GIM_Try, /*On fail goto*//*Label 4305*/ GIMT_Encode4(226677), // Rule ID 11440 //
     /* 226635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 226643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226656 */     // MIs[0] Op3
     /* 226656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226659 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 226664 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1806:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 226664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_H),
     /* 226667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226671 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226673 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226675 */     GIR_RootConstrainSelectedInstOperands,
     /* 226676 */     // GIR_Coverage, 11440,
     /* 226676 */     GIR_EraseRootFromParent_Done,
     /* 226677 */   // Label 4305: @226677
     /* 226677 */   GIM_Try, /*On fail goto*//*Label 4306*/ GIMT_Encode4(226724), // Rule ID 11441 //
     /* 226682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 226690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 226696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226703 */     // MIs[0] Op3
     /* 226703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226706 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 226711 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1806:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 226711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_S),
     /* 226714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226720 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226722 */     GIR_RootConstrainSelectedInstOperands,
     /* 226723 */     // GIR_Coverage, 11441,
     /* 226723 */     GIR_EraseRootFromParent_Done,
     /* 226724 */   // Label 4306: @226724
     /* 226724 */   GIM_Try, /*On fail goto*//*Label 4307*/ GIMT_Encode4(226771), // Rule ID 11442 //
     /* 226729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 226737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 226743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226750 */     // MIs[0] Op3
     /* 226750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226753 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 226758 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1806:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 226758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_D),
     /* 226761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226765 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226767 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226769 */     GIR_RootConstrainSelectedInstOperands,
     /* 226770 */     // GIR_Coverage, 11442,
     /* 226770 */     GIR_EraseRootFromParent_Done,
     /* 226771 */   // Label 4307: @226771
     /* 226771 */   GIM_Try, /*On fail goto*//*Label 4308*/ GIMT_Encode4(226818), // Rule ID 11443 //
     /* 226776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 226784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226797 */     // MIs[0] Op3
     /* 226797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226800 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 226805 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1837:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 226805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_H),
     /* 226808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226812 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226814 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226816 */     GIR_RootConstrainSelectedInstOperands,
     /* 226817 */     // GIR_Coverage, 11443,
     /* 226817 */     GIR_EraseRootFromParent_Done,
     /* 226818 */   // Label 4308: @226818
     /* 226818 */   GIM_Try, /*On fail goto*//*Label 4309*/ GIMT_Encode4(226865), // Rule ID 11444 //
     /* 226823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 226831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 226837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226844 */     // MIs[0] Op3
     /* 226844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226847 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 226852 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1837:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 226852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_S),
     /* 226855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226861 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226863 */     GIR_RootConstrainSelectedInstOperands,
     /* 226864 */     // GIR_Coverage, 11444,
     /* 226864 */     GIR_EraseRootFromParent_Done,
     /* 226865 */   // Label 4309: @226865
     /* 226865 */   GIM_Try, /*On fail goto*//*Label 4310*/ GIMT_Encode4(226912), // Rule ID 11445 //
     /* 226870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 226878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 226884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226891 */     // MIs[0] Op3
     /* 226891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226894 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 226899 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1837:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 226899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_D),
     /* 226902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226908 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226910 */     GIR_RootConstrainSelectedInstOperands,
     /* 226911 */     // GIR_Coverage, 11445,
     /* 226911 */     GIR_EraseRootFromParent_Done,
     /* 226912 */   // Label 4310: @226912
     /* 226912 */   GIM_Try, /*On fail goto*//*Label 4311*/ GIMT_Encode4(226959), // Rule ID 11468 //
     /* 226917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt_lane),
     /* 226925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226938 */     // MIs[0] Op3
     /* 226938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226941 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 226946 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1767:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 226946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZI_S),
     /* 226949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226955 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226957 */     GIR_RootConstrainSelectedInstOperands,
     /* 226958 */     // GIR_Coverage, 11468,
     /* 226958 */     GIR_EraseRootFromParent_Done,
     /* 226959 */   // Label 4311: @226959
     /* 226959 */   GIM_Try, /*On fail goto*//*Label 4312*/ GIMT_Encode4(227006), // Rule ID 11469 //
     /* 226964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt_lane),
     /* 226972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 226978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226985 */     // MIs[0] Op3
     /* 226985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226988 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 226993 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1767:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 226993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZI_D),
     /* 226996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227002 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227004 */     GIR_RootConstrainSelectedInstOperands,
     /* 227005 */     // GIR_Coverage, 11469,
     /* 227005 */     GIR_EraseRootFromParent_Done,
     /* 227006 */   // Label 4312: @227006
     /* 227006 */   GIM_Try, /*On fail goto*//*Label 4313*/ GIMT_Encode4(227053), // Rule ID 11470 //
     /* 227011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb_lane),
     /* 227019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 227025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227032 */     // MIs[0] Op3
     /* 227032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227035 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 227040 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2003:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (UMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 227040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZI_S),
     /* 227043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227047 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227049 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227051 */     GIR_RootConstrainSelectedInstOperands,
     /* 227052 */     // GIR_Coverage, 11470,
     /* 227052 */     GIR_EraseRootFromParent_Done,
     /* 227053 */   // Label 4313: @227053
     /* 227053 */   GIM_Try, /*On fail goto*//*Label 4314*/ GIMT_Encode4(227100), // Rule ID 11471 //
     /* 227058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb_lane),
     /* 227066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227079 */     // MIs[0] Op3
     /* 227079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227082 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 227087 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2003:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (UMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 227087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZI_D),
     /* 227090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227096 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227098 */     GIR_RootConstrainSelectedInstOperands,
     /* 227099 */     // GIR_Coverage, 11471,
     /* 227099 */     GIR_EraseRootFromParent_Done,
     /* 227100 */   // Label 4314: @227100
     /* 227100 */   GIM_Try, /*On fail goto*//*Label 4315*/ GIMT_Encode4(227147), // Rule ID 11472 //
     /* 227105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt_lane),
     /* 227113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 227119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227126 */     // MIs[0] Op3
     /* 227126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227129 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 227134 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2005:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (UMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 227134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZI_S),
     /* 227137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227143 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227145 */     GIR_RootConstrainSelectedInstOperands,
     /* 227146 */     // GIR_Coverage, 11472,
     /* 227146 */     GIR_EraseRootFromParent_Done,
     /* 227147 */   // Label 4315: @227147
     /* 227147 */   GIM_Try, /*On fail goto*//*Label 4316*/ GIMT_Encode4(227194), // Rule ID 11473 //
     /* 227152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt_lane),
     /* 227160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227173 */     // MIs[0] Op3
     /* 227173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227176 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 227181 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2005:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (UMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 227181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZI_D),
     /* 227184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227190 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227192 */     GIR_RootConstrainSelectedInstOperands,
     /* 227193 */     // GIR_Coverage, 11473,
     /* 227193 */     GIR_EraseRootFromParent_Done,
     /* 227194 */   // Label 4316: @227194
     /* 227194 */   GIM_Try, /*On fail goto*//*Label 4317*/ GIMT_Encode4(227241), // Rule ID 11474 //
     /* 227199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb_lane),
     /* 227207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 227213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227220 */     // MIs[0] Op3
     /* 227220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227223 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 227228 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1812:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 227228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZI_S),
     /* 227231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227237 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227239 */     GIR_RootConstrainSelectedInstOperands,
     /* 227240 */     // GIR_Coverage, 11474,
     /* 227240 */     GIR_EraseRootFromParent_Done,
     /* 227241 */   // Label 4317: @227241
     /* 227241 */   GIM_Try, /*On fail goto*//*Label 4318*/ GIMT_Encode4(227288), // Rule ID 11475 //
     /* 227246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb_lane),
     /* 227254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227267 */     // MIs[0] Op3
     /* 227267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227270 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 227275 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1812:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 227275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZI_D),
     /* 227278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227284 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227286 */     GIR_RootConstrainSelectedInstOperands,
     /* 227287 */     // GIR_Coverage, 11475,
     /* 227287 */     GIR_EraseRootFromParent_Done,
     /* 227288 */   // Label 4318: @227288
     /* 227288 */   GIM_Try, /*On fail goto*//*Label 4319*/ GIMT_Encode4(227335), // Rule ID 11476 //
     /* 227293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt_lane),
     /* 227301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 227307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227314 */     // MIs[0] Op3
     /* 227314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227317 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 227322 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1814:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 227322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZI_S),
     /* 227325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227331 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227333 */     GIR_RootConstrainSelectedInstOperands,
     /* 227334 */     // GIR_Coverage, 11476,
     /* 227334 */     GIR_EraseRootFromParent_Done,
     /* 227335 */   // Label 4319: @227335
     /* 227335 */   GIM_Try, /*On fail goto*//*Label 4320*/ GIMT_Encode4(227382), // Rule ID 11477 //
     /* 227340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt_lane),
     /* 227348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227361 */     // MIs[0] Op3
     /* 227361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227364 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 227369 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1814:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 227369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZI_D),
     /* 227372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227376 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227378 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227380 */     GIR_RootConstrainSelectedInstOperands,
     /* 227381 */     // GIR_Coverage, 11477,
     /* 227381 */     GIR_EraseRootFromParent_Done,
     /* 227382 */   // Label 4320: @227382
     /* 227382 */   GIM_Try, /*On fail goto*//*Label 4321*/ GIMT_Encode4(227429), // Rule ID 11721 //
     /* 227387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 227395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227408 */     // MIs[0] Op3
     /* 227408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227411 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 227416 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1872:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SRSHR_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 227416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_B),
     /* 227419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227425 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227427 */     GIR_RootConstrainSelectedInstOperands,
     /* 227428 */     // GIR_Coverage, 11721,
     /* 227428 */     GIR_EraseRootFromParent_Done,
     /* 227429 */   // Label 4321: @227429
     /* 227429 */   GIM_Try, /*On fail goto*//*Label 4322*/ GIMT_Encode4(227476), // Rule ID 11722 //
     /* 227434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 227442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227455 */     // MIs[0] Op3
     /* 227455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227458 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 227463 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1872:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SRSHR_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 227463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_H),
     /* 227466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227472 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227474 */     GIR_RootConstrainSelectedInstOperands,
     /* 227475 */     // GIR_Coverage, 11722,
     /* 227475 */     GIR_EraseRootFromParent_Done,
     /* 227476 */   // Label 4322: @227476
     /* 227476 */   GIM_Try, /*On fail goto*//*Label 4323*/ GIMT_Encode4(227523), // Rule ID 11723 //
     /* 227481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 227489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227502 */     // MIs[0] Op3
     /* 227502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227505 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 227510 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1872:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SRSHR_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 227510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_S),
     /* 227513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227519 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227521 */     GIR_RootConstrainSelectedInstOperands,
     /* 227522 */     // GIR_Coverage, 11723,
     /* 227522 */     GIR_EraseRootFromParent_Done,
     /* 227523 */   // Label 4323: @227523
     /* 227523 */   GIM_Try, /*On fail goto*//*Label 4324*/ GIMT_Encode4(227570), // Rule ID 11724 //
     /* 227528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 227536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227549 */     // MIs[0] Op3
     /* 227549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227552 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 227557 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1872:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SRSHR_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 227557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_D),
     /* 227560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227566 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227568 */     GIR_RootConstrainSelectedInstOperands,
     /* 227569 */     // GIR_Coverage, 11724,
     /* 227569 */     GIR_EraseRootFromParent_Done,
     /* 227570 */   // Label 4324: @227570
     /* 227570 */   GIM_Try, /*On fail goto*//*Label 4325*/ GIMT_Encode4(227617), // Rule ID 11725 //
     /* 227575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 227583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227596 */     // MIs[0] Op3
     /* 227596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227599 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 227604 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2063:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (URSHR_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 227604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_B),
     /* 227607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227611 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227613 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227615 */     GIR_RootConstrainSelectedInstOperands,
     /* 227616 */     // GIR_Coverage, 11725,
     /* 227616 */     GIR_EraseRootFromParent_Done,
     /* 227617 */   // Label 4325: @227617
     /* 227617 */   GIM_Try, /*On fail goto*//*Label 4326*/ GIMT_Encode4(227664), // Rule ID 11727 //
     /* 227622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 227630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227643 */     // MIs[0] Op3
     /* 227643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227646 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 227651 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2063:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (URSHR_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 227651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_H),
     /* 227654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227660 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227662 */     GIR_RootConstrainSelectedInstOperands,
     /* 227663 */     // GIR_Coverage, 11727,
     /* 227663 */     GIR_EraseRootFromParent_Done,
     /* 227664 */   // Label 4326: @227664
     /* 227664 */   GIM_Try, /*On fail goto*//*Label 4327*/ GIMT_Encode4(227711), // Rule ID 11729 //
     /* 227669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 227677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227690 */     // MIs[0] Op3
     /* 227690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227693 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 227698 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2063:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (URSHR_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 227698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_S),
     /* 227701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227707 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227709 */     GIR_RootConstrainSelectedInstOperands,
     /* 227710 */     // GIR_Coverage, 11729,
     /* 227710 */     GIR_EraseRootFromParent_Done,
     /* 227711 */   // Label 4327: @227711
     /* 227711 */   GIM_Try, /*On fail goto*//*Label 4328*/ GIMT_Encode4(227758), // Rule ID 11731 //
     /* 227716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 227724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227737 */     // MIs[0] Op3
     /* 227737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227740 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 227745 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2063:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (URSHR_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 227745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_D),
     /* 227748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227754 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227756 */     GIR_RootConstrainSelectedInstOperands,
     /* 227757 */     // GIR_Coverage, 11731,
     /* 227757 */     GIR_EraseRootFromParent_Done,
     /* 227758 */   // Label 4328: @227758
     /* 227758 */   GIM_Try, /*On fail goto*//*Label 4329*/ GIMT_Encode4(227805), // Rule ID 11733 //
     /* 227763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 227771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227784 */     // MIs[0] Op3
     /* 227784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227787 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 227792 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1852:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op3)  =>  (SQSHLU_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op3)
     /* 227792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_B),
     /* 227795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227799 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227801 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227803 */     GIR_RootConstrainSelectedInstOperands,
     /* 227804 */     // GIR_Coverage, 11733,
     /* 227804 */     GIR_EraseRootFromParent_Done,
     /* 227805 */   // Label 4329: @227805
     /* 227805 */   GIM_Try, /*On fail goto*//*Label 4330*/ GIMT_Encode4(227852), // Rule ID 11734 //
     /* 227810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 227818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227831 */     // MIs[0] Op3
     /* 227831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227834 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 227839 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1852:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op3)  =>  (SQSHLU_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op3)
     /* 227839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_H),
     /* 227842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227846 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227848 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227850 */     GIR_RootConstrainSelectedInstOperands,
     /* 227851 */     // GIR_Coverage, 11734,
     /* 227851 */     GIR_EraseRootFromParent_Done,
     /* 227852 */   // Label 4330: @227852
     /* 227852 */   GIM_Try, /*On fail goto*//*Label 4331*/ GIMT_Encode4(227899), // Rule ID 11735 //
     /* 227857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 227865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227878 */     // MIs[0] Op3
     /* 227878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227881 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 227886 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1852:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op3)  =>  (SQSHLU_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op3)
     /* 227886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_S),
     /* 227889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227895 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227897 */     GIR_RootConstrainSelectedInstOperands,
     /* 227898 */     // GIR_Coverage, 11735,
     /* 227898 */     GIR_EraseRootFromParent_Done,
     /* 227899 */   // Label 4331: @227899
     /* 227899 */   GIM_Try, /*On fail goto*//*Label 4332*/ GIMT_Encode4(227946), // Rule ID 11736 //
     /* 227904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 227912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227925 */     // MIs[0] Op3
     /* 227925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227928 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL64),
     /* 227933 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1852:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL64>>:$Op3)  =>  (SQSHLU_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL64>>:$Op3)
     /* 227933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_D),
     /* 227936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227942 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227944 */     GIR_RootConstrainSelectedInstOperands,
     /* 227945 */     // GIR_Coverage, 11736,
     /* 227945 */     GIR_EraseRootFromParent_Done,
     /* 227946 */   // Label 4332: @227946
     /* 227946 */   GIM_Try, /*On fail goto*//*Label 4333*/ GIMT_Encode4(227993), // Rule ID 11823 //
     /* 227951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 227959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 227965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227972 */     // MIs[0] Op3
     /* 227972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227975 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 227980 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2072:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (USRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 227980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_B),
     /* 227983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 227985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227987 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227989 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227991 */     GIR_RootConstrainSelectedInstOperands,
     /* 227992 */     // GIR_Coverage, 11823,
     /* 227992 */     GIR_EraseRootFromParent_Done,
     /* 227993 */   // Label 4333: @227993
     /* 227993 */   GIM_Try, /*On fail goto*//*Label 4334*/ GIMT_Encode4(228040), // Rule ID 11825 //
     /* 227998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 228006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228019 */     // MIs[0] Op3
     /* 228019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228022 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 228027 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2072:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (USRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 228027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_H),
     /* 228030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228036 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228038 */     GIR_RootConstrainSelectedInstOperands,
     /* 228039 */     // GIR_Coverage, 11825,
     /* 228039 */     GIR_EraseRootFromParent_Done,
     /* 228040 */   // Label 4334: @228040
     /* 228040 */   GIM_Try, /*On fail goto*//*Label 4335*/ GIMT_Encode4(228087), // Rule ID 11827 //
     /* 228045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 228053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228066 */     // MIs[0] Op3
     /* 228066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228069 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 228074 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2072:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (USRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 228074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_S),
     /* 228077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228083 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228085 */     GIR_RootConstrainSelectedInstOperands,
     /* 228086 */     // GIR_Coverage, 11827,
     /* 228086 */     GIR_EraseRootFromParent_Done,
     /* 228087 */   // Label 4335: @228087
     /* 228087 */   GIM_Try, /*On fail goto*//*Label 4336*/ GIMT_Encode4(228134), // Rule ID 11829 //
     /* 228092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 228100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 228106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228113 */     // MIs[0] Op3
     /* 228113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228116 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 228121 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2072:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (USRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 228121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_D),
     /* 228124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228130 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228132 */     GIR_RootConstrainSelectedInstOperands,
     /* 228133 */     // GIR_Coverage, 11829,
     /* 228133 */     GIR_EraseRootFromParent_Done,
     /* 228134 */   // Label 4336: @228134
     /* 228134 */   GIM_Try, /*On fail goto*//*Label 4337*/ GIMT_Encode4(228181), // Rule ID 11831 //
     /* 228139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 228147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 228153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228160 */     // MIs[0] Op3
     /* 228160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228163 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 228168 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1873:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SRSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 228168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_B),
     /* 228171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228177 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228179 */     GIR_RootConstrainSelectedInstOperands,
     /* 228180 */     // GIR_Coverage, 11831,
     /* 228180 */     GIR_EraseRootFromParent_Done,
     /* 228181 */   // Label 4337: @228181
     /* 228181 */   GIM_Try, /*On fail goto*//*Label 4338*/ GIMT_Encode4(228228), // Rule ID 11832 //
     /* 228186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 228194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228207 */     // MIs[0] Op3
     /* 228207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228210 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 228215 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1873:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SRSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 228215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_H),
     /* 228218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228224 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228226 */     GIR_RootConstrainSelectedInstOperands,
     /* 228227 */     // GIR_Coverage, 11832,
     /* 228227 */     GIR_EraseRootFromParent_Done,
     /* 228228 */   // Label 4338: @228228
     /* 228228 */   GIM_Try, /*On fail goto*//*Label 4339*/ GIMT_Encode4(228275), // Rule ID 11833 //
     /* 228233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 228241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228254 */     // MIs[0] Op3
     /* 228254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228257 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 228262 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1873:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SRSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 228262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_S),
     /* 228265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228271 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228273 */     GIR_RootConstrainSelectedInstOperands,
     /* 228274 */     // GIR_Coverage, 11833,
     /* 228274 */     GIR_EraseRootFromParent_Done,
     /* 228275 */   // Label 4339: @228275
     /* 228275 */   GIM_Try, /*On fail goto*//*Label 4340*/ GIMT_Encode4(228322), // Rule ID 11834 //
     /* 228280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 228288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 228294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228301 */     // MIs[0] Op3
     /* 228301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228304 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 228309 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1873:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SRSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 228309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_D),
     /* 228312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228316 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228318 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228320 */     GIR_RootConstrainSelectedInstOperands,
     /* 228321 */     // GIR_Coverage, 11834,
     /* 228321 */     GIR_EraseRootFromParent_Done,
     /* 228322 */   // Label 4340: @228322
     /* 228322 */   GIM_Try, /*On fail goto*//*Label 4341*/ GIMT_Encode4(228369), // Rule ID 11839 //
     /* 228327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 228335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 228341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228348 */     // MIs[0] Op3
     /* 228348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228351 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 228356 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2065:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (URSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 228356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_B),
     /* 228359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228365 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228367 */     GIR_RootConstrainSelectedInstOperands,
     /* 228368 */     // GIR_Coverage, 11839,
     /* 228368 */     GIR_EraseRootFromParent_Done,
     /* 228369 */   // Label 4341: @228369
     /* 228369 */   GIM_Try, /*On fail goto*//*Label 4342*/ GIMT_Encode4(228416), // Rule ID 11840 //
     /* 228374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 228382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228395 */     // MIs[0] Op3
     /* 228395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228398 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 228403 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2065:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (URSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 228403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_H),
     /* 228406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228412 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228414 */     GIR_RootConstrainSelectedInstOperands,
     /* 228415 */     // GIR_Coverage, 11840,
     /* 228415 */     GIR_EraseRootFromParent_Done,
     /* 228416 */   // Label 4342: @228416
     /* 228416 */   GIM_Try, /*On fail goto*//*Label 4343*/ GIMT_Encode4(228463), // Rule ID 11841 //
     /* 228421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 228429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228442 */     // MIs[0] Op3
     /* 228442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228445 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 228450 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2065:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (URSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 228450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_S),
     /* 228453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228459 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228461 */     GIR_RootConstrainSelectedInstOperands,
     /* 228462 */     // GIR_Coverage, 11841,
     /* 228462 */     GIR_EraseRootFromParent_Done,
     /* 228463 */   // Label 4343: @228463
     /* 228463 */   GIM_Try, /*On fail goto*//*Label 4344*/ GIMT_Encode4(228510), // Rule ID 11842 //
     /* 228468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 228476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 228482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228489 */     // MIs[0] Op3
     /* 228489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228492 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 228497 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2065:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (URSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 228497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_D),
     /* 228500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228506 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228508 */     GIR_RootConstrainSelectedInstOperands,
     /* 228509 */     // GIR_Coverage, 11842,
     /* 228509 */     GIR_EraseRootFromParent_Done,
     /* 228510 */   // Label 4344: @228510
     /* 228510 */   GIM_Try, /*On fail goto*//*Label 4345*/ GIMT_Encode4(228557), // Rule ID 11902 //
     /* 228515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 228523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 228529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228536 */     // MIs[0] Op3
     /* 228536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228539 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 228544 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1850:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQRSHRUNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 228544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_B),
     /* 228547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228551 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228553 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228555 */     GIR_RootConstrainSelectedInstOperands,
     /* 228556 */     // GIR_Coverage, 11902,
     /* 228556 */     GIR_EraseRootFromParent_Done,
     /* 228557 */   // Label 4345: @228557
     /* 228557 */   GIM_Try, /*On fail goto*//*Label 4346*/ GIMT_Encode4(228604), // Rule ID 11903 //
     /* 228562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 228570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228583 */     // MIs[0] Op3
     /* 228583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228586 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 228591 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1850:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQRSHRUNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 228591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_H),
     /* 228594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228600 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228602 */     GIR_RootConstrainSelectedInstOperands,
     /* 228603 */     // GIR_Coverage, 11903,
     /* 228603 */     GIR_EraseRootFromParent_Done,
     /* 228604 */   // Label 4346: @228604
     /* 228604 */   GIM_Try, /*On fail goto*//*Label 4347*/ GIMT_Encode4(228651), // Rule ID 11904 //
     /* 228609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 228617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228630 */     // MIs[0] Op3
     /* 228630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228633 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 228638 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1850:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQRSHRUNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 228638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_S),
     /* 228641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228647 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228649 */     GIR_RootConstrainSelectedInstOperands,
     /* 228650 */     // GIR_Coverage, 11904,
     /* 228650 */     GIR_EraseRootFromParent_Done,
     /* 228651 */   // Label 4347: @228651
     /* 228651 */   GIM_Try, /*On fail goto*//*Label 4348*/ GIMT_Encode4(228698), // Rule ID 11905 //
     /* 228656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 228664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 228670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228677 */     // MIs[0] Op3
     /* 228677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228680 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 228685 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1729:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 228685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_B),
     /* 228688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228692 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228694 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228696 */     GIR_RootConstrainSelectedInstOperands,
     /* 228697 */     // GIR_Coverage, 11905,
     /* 228697 */     GIR_EraseRootFromParent_Done,
     /* 228698 */   // Label 4348: @228698
     /* 228698 */   GIM_Try, /*On fail goto*//*Label 4349*/ GIMT_Encode4(228745), // Rule ID 11906 //
     /* 228703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 228711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228724 */     // MIs[0] Op3
     /* 228724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228727 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 228732 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1729:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 228732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_H),
     /* 228735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228739 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228741 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228743 */     GIR_RootConstrainSelectedInstOperands,
     /* 228744 */     // GIR_Coverage, 11906,
     /* 228744 */     GIR_EraseRootFromParent_Done,
     /* 228745 */   // Label 4349: @228745
     /* 228745 */   GIM_Try, /*On fail goto*//*Label 4350*/ GIMT_Encode4(228792), // Rule ID 11907 //
     /* 228750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 228758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228771 */     // MIs[0] Op3
     /* 228771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228774 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 228779 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1729:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 228779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_S),
     /* 228782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228786 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228788 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228790 */     GIR_RootConstrainSelectedInstOperands,
     /* 228791 */     // GIR_Coverage, 11907,
     /* 228791 */     GIR_EraseRootFromParent_Done,
     /* 228792 */   // Label 4350: @228792
     /* 228792 */   GIM_Try, /*On fail goto*//*Label 4351*/ GIMT_Encode4(228839), // Rule ID 11908 //
     /* 228797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 228805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 228811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228818 */     // MIs[0] Op3
     /* 228818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228821 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 228826 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1687:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (RSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 228826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_B),
     /* 228829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228835 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228837 */     GIR_RootConstrainSelectedInstOperands,
     /* 228838 */     // GIR_Coverage, 11908,
     /* 228838 */     GIR_EraseRootFromParent_Done,
     /* 228839 */   // Label 4351: @228839
     /* 228839 */   GIM_Try, /*On fail goto*//*Label 4352*/ GIMT_Encode4(228886), // Rule ID 11909 //
     /* 228844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 228852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228865 */     // MIs[0] Op3
     /* 228865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228868 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 228873 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1687:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (RSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 228873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_H),
     /* 228876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228882 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228884 */     GIR_RootConstrainSelectedInstOperands,
     /* 228885 */     // GIR_Coverage, 11909,
     /* 228885 */     GIR_EraseRootFromParent_Done,
     /* 228886 */   // Label 4352: @228886
     /* 228886 */   GIM_Try, /*On fail goto*//*Label 4353*/ GIMT_Encode4(228933), // Rule ID 11910 //
     /* 228891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 228899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228912 */     // MIs[0] Op3
     /* 228912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228915 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 228920 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1687:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (RSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 228920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_S),
     /* 228923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228929 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228931 */     GIR_RootConstrainSelectedInstOperands,
     /* 228932 */     // GIR_Coverage, 11910,
     /* 228932 */     GIR_EraseRootFromParent_Done,
     /* 228933 */   // Label 4353: @228933
     /* 228933 */   GIM_Try, /*On fail goto*//*Label 4354*/ GIMT_Encode4(228980), // Rule ID 11911 //
     /* 228938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 228946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 228952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228959 */     // MIs[0] Op3
     /* 228959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228962 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 228967 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1854:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 228967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_B),
     /* 228970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228976 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228978 */     GIR_RootConstrainSelectedInstOperands,
     /* 228979 */     // GIR_Coverage, 11911,
     /* 228979 */     GIR_EraseRootFromParent_Done,
     /* 228980 */   // Label 4354: @228980
     /* 228980 */   GIM_Try, /*On fail goto*//*Label 4355*/ GIMT_Encode4(229027), // Rule ID 11912 //
     /* 228985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 228993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229006 */     // MIs[0] Op3
     /* 229006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229009 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 229014 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1854:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 229014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_H),
     /* 229017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229023 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229025 */     GIR_RootConstrainSelectedInstOperands,
     /* 229026 */     // GIR_Coverage, 11912,
     /* 229026 */     GIR_EraseRootFromParent_Done,
     /* 229027 */   // Label 4355: @229027
     /* 229027 */   GIM_Try, /*On fail goto*//*Label 4356*/ GIMT_Encode4(229074), // Rule ID 11913 //
     /* 229032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 229040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229053 */     // MIs[0] Op3
     /* 229053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229056 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 229061 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1854:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 229061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_S),
     /* 229064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229070 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229072 */     GIR_RootConstrainSelectedInstOperands,
     /* 229073 */     // GIR_Coverage, 11913,
     /* 229073 */     GIR_EraseRootFromParent_Done,
     /* 229074 */   // Label 4356: @229074
     /* 229074 */   GIM_Try, /*On fail goto*//*Label 4357*/ GIMT_Encode4(229121), // Rule ID 11914 //
     /* 229079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 229087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 229093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229100 */     // MIs[0] Op3
     /* 229100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229103 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 229108 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1844:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQRSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 229108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_B),
     /* 229111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229117 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229119 */     GIR_RootConstrainSelectedInstOperands,
     /* 229120 */     // GIR_Coverage, 11914,
     /* 229120 */     GIR_EraseRootFromParent_Done,
     /* 229121 */   // Label 4357: @229121
     /* 229121 */   GIM_Try, /*On fail goto*//*Label 4358*/ GIMT_Encode4(229168), // Rule ID 11915 //
     /* 229126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 229134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229147 */     // MIs[0] Op3
     /* 229147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229150 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 229155 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1844:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQRSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 229155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_H),
     /* 229158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229164 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229166 */     GIR_RootConstrainSelectedInstOperands,
     /* 229167 */     // GIR_Coverage, 11915,
     /* 229167 */     GIR_EraseRootFromParent_Done,
     /* 229168 */   // Label 4358: @229168
     /* 229168 */   GIM_Try, /*On fail goto*//*Label 4359*/ GIMT_Encode4(229215), // Rule ID 11916 //
     /* 229173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 229181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229194 */     // MIs[0] Op3
     /* 229194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229197 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 229202 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1844:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQRSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 229202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_S),
     /* 229205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229211 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229213 */     GIR_RootConstrainSelectedInstOperands,
     /* 229214 */     // GIR_Coverage, 11916,
     /* 229214 */     GIR_EraseRootFromParent_Done,
     /* 229215 */   // Label 4359: @229215
     /* 229215 */   GIM_Try, /*On fail goto*//*Label 4360*/ GIMT_Encode4(229262), // Rule ID 11917 //
     /* 229220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 229228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 229234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229241 */     // MIs[0] Op3
     /* 229241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229244 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 229249 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2049:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (UQSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 229249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_B),
     /* 229252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229258 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229260 */     GIR_RootConstrainSelectedInstOperands,
     /* 229261 */     // GIR_Coverage, 11917,
     /* 229261 */     GIR_EraseRootFromParent_Done,
     /* 229262 */   // Label 4360: @229262
     /* 229262 */   GIM_Try, /*On fail goto*//*Label 4361*/ GIMT_Encode4(229309), // Rule ID 11918 //
     /* 229267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 229275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229288 */     // MIs[0] Op3
     /* 229288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229291 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 229296 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2049:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (UQSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 229296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_H),
     /* 229299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229305 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229307 */     GIR_RootConstrainSelectedInstOperands,
     /* 229308 */     // GIR_Coverage, 11918,
     /* 229308 */     GIR_EraseRootFromParent_Done,
     /* 229309 */   // Label 4361: @229309
     /* 229309 */   GIM_Try, /*On fail goto*//*Label 4362*/ GIMT_Encode4(229356), // Rule ID 11919 //
     /* 229314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 229322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229335 */     // MIs[0] Op3
     /* 229335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229338 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 229343 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2049:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (UQSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 229343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_S),
     /* 229346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229350 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229352 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229354 */     GIR_RootConstrainSelectedInstOperands,
     /* 229355 */     // GIR_Coverage, 11919,
     /* 229355 */     GIR_EraseRootFromParent_Done,
     /* 229356 */   // Label 4362: @229356
     /* 229356 */   GIM_Try, /*On fail goto*//*Label 4363*/ GIMT_Encode4(229403), // Rule ID 11920 //
     /* 229361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 229369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 229375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229382 */     // MIs[0] Op3
     /* 229382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229385 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 229390 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2046:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (UQRSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 229390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_B),
     /* 229393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229399 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229401 */     GIR_RootConstrainSelectedInstOperands,
     /* 229402 */     // GIR_Coverage, 11920,
     /* 229402 */     GIR_EraseRootFromParent_Done,
     /* 229403 */   // Label 4363: @229403
     /* 229403 */   GIM_Try, /*On fail goto*//*Label 4364*/ GIMT_Encode4(229450), // Rule ID 11921 //
     /* 229408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 229416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229429 */     // MIs[0] Op3
     /* 229429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229432 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 229437 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2046:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (UQRSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 229437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_H),
     /* 229440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229446 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229448 */     GIR_RootConstrainSelectedInstOperands,
     /* 229449 */     // GIR_Coverage, 11921,
     /* 229449 */     GIR_EraseRootFromParent_Done,
     /* 229450 */   // Label 4364: @229450
     /* 229450 */   GIM_Try, /*On fail goto*//*Label 4365*/ GIMT_Encode4(229497), // Rule ID 11922 //
     /* 229455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 229463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229476 */     // MIs[0] Op3
     /* 229476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229479 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 229484 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2046:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (UQRSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 229484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_S),
     /* 229487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229491 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229493 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229495 */     GIR_RootConstrainSelectedInstOperands,
     /* 229496 */     // GIR_Coverage, 11922,
     /* 229496 */     GIR_EraseRootFromParent_Done,
     /* 229497 */   // Label 4365: @229497
     /* 229497 */   GIM_Try, /*On fail goto*//*Label 4366*/ GIMT_Encode4(229564), // Rule ID 2600 //
     /* 229502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urecpe),
     /* 229510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 229519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 229530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 229534 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229536 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2056:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (URECPE_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 229536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 229539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 229543 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 229548 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 229550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPE_ZPmZ_S_UNDEF),
     /* 229553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 229558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 229560 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 229562 */     GIR_RootConstrainSelectedInstOperands,
     /* 229563 */     // GIR_Coverage, 2600,
     /* 229563 */     GIR_EraseRootFromParent_Done,
     /* 229564 */   // Label 4366: @229564
     /* 229564 */   GIM_Try, /*On fail goto*//*Label 4367*/ GIMT_Encode4(229631), // Rule ID 7796 //
     /* 229569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 229577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 229583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 229586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 229589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 229597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 229601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229603 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1320:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CLS_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 229603 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 229606 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 229610 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 229615 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 229617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_B_UNDEF),
     /* 229620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229622 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 229625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 229627 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 229629 */     GIR_RootConstrainSelectedInstOperands,
     /* 229630 */     // GIR_Coverage, 7796,
     /* 229630 */     GIR_EraseRootFromParent_Done,
     /* 229631 */   // Label 4367: @229631
     /* 229631 */   GIM_Try, /*On fail goto*//*Label 4368*/ GIMT_Encode4(229698), // Rule ID 7798 //
     /* 229636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 229644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 229653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 229664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 229668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229670 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1320:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CLS_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 229670 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 229673 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 229677 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 229682 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 229684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_H_UNDEF),
     /* 229687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229689 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 229692 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 229694 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 229696 */     GIR_RootConstrainSelectedInstOperands,
     /* 229697 */     // GIR_Coverage, 7798,
     /* 229697 */     GIR_EraseRootFromParent_Done,
     /* 229698 */   // Label 4368: @229698
     /* 229698 */   GIM_Try, /*On fail goto*//*Label 4369*/ GIMT_Encode4(229765), // Rule ID 7800 //
     /* 229703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 229711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 229720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 229731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 229735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229737 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1320:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CLS_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 229737 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 229740 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 229744 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 229749 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 229751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_S_UNDEF),
     /* 229754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 229759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 229761 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 229763 */     GIR_RootConstrainSelectedInstOperands,
     /* 229764 */     // GIR_Coverage, 7800,
     /* 229764 */     GIR_EraseRootFromParent_Done,
     /* 229765 */   // Label 4369: @229765
     /* 229765 */   GIM_Try, /*On fail goto*//*Label 4370*/ GIMT_Encode4(229832), // Rule ID 7802 //
     /* 229770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 229778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 229784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 229798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 229802 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229804 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1320:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CLS_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 229804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 229807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 229811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 229816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 229818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_D_UNDEF),
     /* 229821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 229826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 229828 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 229830 */     GIR_RootConstrainSelectedInstOperands,
     /* 229831 */     // GIR_Coverage, 7802,
     /* 229831 */     GIR_EraseRootFromParent_Done,
     /* 229832 */   // Label 4370: @229832
     /* 229832 */   GIM_Try, /*On fail goto*//*Label 4371*/ GIMT_Encode4(229899), // Rule ID 7832 //
     /* 229837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 229845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 229851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 229854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 229857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 229865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 229869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229871 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1340:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CNOT_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 229871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 229874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 229878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 229883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 229885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_B_UNDEF),
     /* 229888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 229893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 229895 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 229897 */     GIR_RootConstrainSelectedInstOperands,
     /* 229898 */     // GIR_Coverage, 7832,
     /* 229898 */     GIR_EraseRootFromParent_Done,
     /* 229899 */   // Label 4371: @229899
     /* 229899 */   GIM_Try, /*On fail goto*//*Label 4372*/ GIMT_Encode4(229966), // Rule ID 7834 //
     /* 229904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 229912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 229921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 229932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 229936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229938 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1340:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CNOT_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 229938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 229941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 229945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 229950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 229952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_H_UNDEF),
     /* 229955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 229960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 229962 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 229964 */     GIR_RootConstrainSelectedInstOperands,
     /* 229965 */     // GIR_Coverage, 7834,
     /* 229965 */     GIR_EraseRootFromParent_Done,
     /* 229966 */   // Label 4372: @229966
     /* 229966 */   GIM_Try, /*On fail goto*//*Label 4373*/ GIMT_Encode4(230033), // Rule ID 7836 //
     /* 229971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 229979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 229988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 229999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230005 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1340:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CNOT_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 230005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_S_UNDEF),
     /* 230022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230029 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230031 */     GIR_RootConstrainSelectedInstOperands,
     /* 230032 */     // GIR_Coverage, 7836,
     /* 230032 */     GIR_EraseRootFromParent_Done,
     /* 230033 */   // Label 4373: @230033
     /* 230033 */   GIM_Try, /*On fail goto*//*Label 4374*/ GIMT_Encode4(230100), // Rule ID 7838 //
     /* 230038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 230046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 230055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230070 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230072 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1340:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CNOT_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 230072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_D_UNDEF),
     /* 230089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230096 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230098 */     GIR_RootConstrainSelectedInstOperands,
     /* 230099 */     // GIR_Coverage, 7838,
     /* 230099 */     GIR_EraseRootFromParent_Done,
     /* 230100 */   // Label 4374: @230100
     /* 230100 */   GIM_Try, /*On fail goto*//*Label 4375*/ GIMT_Encode4(230167), // Rule ID 7844 //
     /* 230105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 230113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 230116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 230119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 230122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230139 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1626:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (NOT_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 230139 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230142 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230146 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230151 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_B_UNDEF),
     /* 230156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230158 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230163 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230165 */     GIR_RootConstrainSelectedInstOperands,
     /* 230166 */     // GIR_Coverage, 7844,
     /* 230166 */     GIR_EraseRootFromParent_Done,
     /* 230167 */   // Label 4375: @230167
     /* 230167 */   GIM_Try, /*On fail goto*//*Label 4376*/ GIMT_Encode4(230234), // Rule ID 7846 //
     /* 230172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 230180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 230189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230206 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1626:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (NOT_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 230206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_H_UNDEF),
     /* 230223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230225 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230228 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230230 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230232 */     GIR_RootConstrainSelectedInstOperands,
     /* 230233 */     // GIR_Coverage, 7846,
     /* 230233 */     GIR_EraseRootFromParent_Done,
     /* 230234 */   // Label 4376: @230234
     /* 230234 */   GIM_Try, /*On fail goto*//*Label 4377*/ GIMT_Encode4(230301), // Rule ID 7848 //
     /* 230239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 230247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 230256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230273 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1626:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (NOT_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 230273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230285 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_S_UNDEF),
     /* 230290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230297 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230299 */     GIR_RootConstrainSelectedInstOperands,
     /* 230300 */     // GIR_Coverage, 7848,
     /* 230300 */     GIR_EraseRootFromParent_Done,
     /* 230301 */   // Label 4377: @230301
     /* 230301 */   GIM_Try, /*On fail goto*//*Label 4378*/ GIMT_Encode4(230368), // Rule ID 7850 //
     /* 230306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 230314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 230323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230340 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1626:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (NOT_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 230340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_D_UNDEF),
     /* 230357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230364 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230366 */     GIR_RootConstrainSelectedInstOperands,
     /* 230367 */     // GIR_Coverage, 7850,
     /* 230367 */     GIR_EraseRootFromParent_Done,
     /* 230368 */   // Label 4378: @230368
     /* 230368 */   GIM_Try, /*On fail goto*//*Label 4379*/ GIMT_Encode4(230435), // Rule ID 11603 //
     /* 230373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursqrte),
     /* 230381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 230390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230407 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2064:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (URSQRTE_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 230407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTE_ZPmZ_S_UNDEF),
     /* 230424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230431 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230433 */     GIR_RootConstrainSelectedInstOperands,
     /* 230434 */     // GIR_Coverage, 11603,
     /* 230434 */     GIR_EraseRootFromParent_Done,
     /* 230435 */   // Label 4379: @230435
     /* 230435 */   GIM_Try, /*On fail goto*//*Label 4380*/ GIMT_Encode4(230502), // Rule ID 11605 //
     /* 230440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 230448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 230451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 230454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 230457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230472 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230474 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1769:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQABS_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 230474 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230477 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230481 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230486 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_B_UNDEF),
     /* 230491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230493 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230496 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230498 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230500 */     GIR_RootConstrainSelectedInstOperands,
     /* 230501 */     // GIR_Coverage, 11605,
     /* 230501 */     GIR_EraseRootFromParent_Done,
     /* 230502 */   // Label 4380: @230502
     /* 230502 */   GIM_Try, /*On fail goto*//*Label 4381*/ GIMT_Encode4(230569), // Rule ID 11607 //
     /* 230507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 230515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 230524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230541 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1769:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQABS_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 230541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_H_UNDEF),
     /* 230558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230565 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230567 */     GIR_RootConstrainSelectedInstOperands,
     /* 230568 */     // GIR_Coverage, 11607,
     /* 230568 */     GIR_EraseRootFromParent_Done,
     /* 230569 */   // Label 4381: @230569
     /* 230569 */   GIM_Try, /*On fail goto*//*Label 4382*/ GIMT_Encode4(230636), // Rule ID 11609 //
     /* 230574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 230582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 230591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230608 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1769:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQABS_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 230608 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230611 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230615 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230620 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_S_UNDEF),
     /* 230625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230632 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230634 */     GIR_RootConstrainSelectedInstOperands,
     /* 230635 */     // GIR_Coverage, 11609,
     /* 230635 */     GIR_EraseRootFromParent_Done,
     /* 230636 */   // Label 4382: @230636
     /* 230636 */   GIM_Try, /*On fail goto*//*Label 4383*/ GIMT_Encode4(230703), // Rule ID 11611 //
     /* 230641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 230649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 230658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230675 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1769:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQABS_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 230675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230687 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_D_UNDEF),
     /* 230692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230699 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230701 */     GIR_RootConstrainSelectedInstOperands,
     /* 230702 */     // GIR_Coverage, 11611,
     /* 230702 */     GIR_EraseRootFromParent_Done,
     /* 230703 */   // Label 4383: @230703
     /* 230703 */   GIM_Try, /*On fail goto*//*Label 4384*/ GIMT_Encode4(230770), // Rule ID 11617 //
     /* 230708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 230716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 230719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 230722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 230725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230740 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230742 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1829:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQNEG_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 230742 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230745 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230749 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230754 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_B_UNDEF),
     /* 230759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230761 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230766 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230768 */     GIR_RootConstrainSelectedInstOperands,
     /* 230769 */     // GIR_Coverage, 11617,
     /* 230769 */     GIR_EraseRootFromParent_Done,
     /* 230770 */   // Label 4384: @230770
     /* 230770 */   GIM_Try, /*On fail goto*//*Label 4385*/ GIMT_Encode4(230837), // Rule ID 11619 //
     /* 230775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 230783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 230792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230809 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1829:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQNEG_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 230809 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230816 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_H_UNDEF),
     /* 230826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230828 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230831 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230833 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230835 */     GIR_RootConstrainSelectedInstOperands,
     /* 230836 */     // GIR_Coverage, 11619,
     /* 230836 */     GIR_EraseRootFromParent_Done,
     /* 230837 */   // Label 4385: @230837
     /* 230837 */   GIM_Try, /*On fail goto*//*Label 4386*/ GIMT_Encode4(230904), // Rule ID 11621 //
     /* 230842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 230850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 230859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230876 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1829:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQNEG_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 230876 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230879 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230883 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230888 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_S_UNDEF),
     /* 230893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230895 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230900 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230902 */     GIR_RootConstrainSelectedInstOperands,
     /* 230903 */     // GIR_Coverage, 11621,
     /* 230903 */     GIR_EraseRootFromParent_Done,
     /* 230904 */   // Label 4386: @230904
     /* 230904 */   GIM_Try, /*On fail goto*//*Label 4387*/ GIMT_Encode4(230971), // Rule ID 11623 //
     /* 230909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 230917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 230926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230943 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1829:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQNEG_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 230943 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230946 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230950 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230955 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_D_UNDEF),
     /* 230960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230962 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230965 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230967 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230969 */     GIR_RootConstrainSelectedInstOperands,
     /* 230970 */     // GIR_Coverage, 11623,
     /* 230970 */     GIR_EraseRootFromParent_Done,
     /* 230971 */   // Label 4387: @230971
     /* 230971 */   GIM_Try, /*On fail goto*//*Label 4388*/ GIMT_Encode4(231025), // Rule ID 30 //
     /* 230976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 230979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smmla),
     /* 230984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 230987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 230990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 230993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 230996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231012 */     // (intrinsic_wo_chain:{ *:[v4i32] } 686:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 231012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMMLA),
     /* 231015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231021 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231023 */     GIR_RootConstrainSelectedInstOperands,
     /* 231024 */     // GIR_Coverage, 30,
     /* 231024 */     GIR_EraseRootFromParent_Done,
     /* 231025 */   // Label 4388: @231025
     /* 231025 */   GIM_Try, /*On fail goto*//*Label 4389*/ GIMT_Encode4(231079), // Rule ID 31 //
     /* 231030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 231033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ummla),
     /* 231038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 231041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 231044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 231047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 231050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231066 */     // (intrinsic_wo_chain:{ *:[v4i32] } 747:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 231066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMMLA),
     /* 231069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231075 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231077 */     GIR_RootConstrainSelectedInstOperands,
     /* 231078 */     // GIR_Coverage, 31,
     /* 231078 */     GIR_EraseRootFromParent_Done,
     /* 231079 */   // Label 4389: @231079
     /* 231079 */   GIM_Try, /*On fail goto*//*Label 4390*/ GIMT_Encode4(231133), // Rule ID 32 //
     /* 231084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 231087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usmmla),
     /* 231092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 231095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 231098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 231101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 231104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231120 */     // (intrinsic_wo_chain:{ *:[v4i32] } 763:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (USMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 231120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMMLA),
     /* 231123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231127 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231129 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231131 */     GIR_RootConstrainSelectedInstOperands,
     /* 231132 */     // GIR_Coverage, 32,
     /* 231132 */     GIR_EraseRootFromParent_Done,
     /* 231133 */   // Label 4390: @231133
     /* 231133 */   GIM_Try, /*On fail goto*//*Label 4391*/ GIMT_Encode4(231187), // Rule ID 39 //
     /* 231138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 231141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 231146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 231149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 231152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 231155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 231158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231174 */     // (intrinsic_wo_chain:{ *:[v2f32] } 616:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLALv4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 231174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALv4f16),
     /* 231177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231183 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231185 */     GIR_RootConstrainSelectedInstOperands,
     /* 231186 */     // GIR_Coverage, 39,
     /* 231186 */     GIR_EraseRootFromParent_Done,
     /* 231187 */   // Label 4391: @231187
     /* 231187 */   GIM_Try, /*On fail goto*//*Label 4392*/ GIMT_Encode4(231241), // Rule ID 40 //
     /* 231192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 231195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 231200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 231203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 231206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 231209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 231212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231228 */     // (intrinsic_wo_chain:{ *:[v4f32] } 616:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLALv8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 231228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALv8f16),
     /* 231231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231237 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231239 */     GIR_RootConstrainSelectedInstOperands,
     /* 231240 */     // GIR_Coverage, 40,
     /* 231240 */     GIR_EraseRootFromParent_Done,
     /* 231241 */   // Label 4392: @231241
     /* 231241 */   GIM_Try, /*On fail goto*//*Label 4393*/ GIMT_Encode4(231295), // Rule ID 41 //
     /* 231246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 231249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 231254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 231257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 231260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 231263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 231266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231282 */     // (intrinsic_wo_chain:{ *:[v2f32] } 618:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLSLv4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 231282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLv4f16),
     /* 231285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231291 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231293 */     GIR_RootConstrainSelectedInstOperands,
     /* 231294 */     // GIR_Coverage, 41,
     /* 231294 */     GIR_EraseRootFromParent_Done,
     /* 231295 */   // Label 4393: @231295
     /* 231295 */   GIM_Try, /*On fail goto*//*Label 4394*/ GIMT_Encode4(231349), // Rule ID 42 //
     /* 231300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 231303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 231308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 231311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 231314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 231317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 231320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231336 */     // (intrinsic_wo_chain:{ *:[v4f32] } 618:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLSLv8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 231336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLv8f16),
     /* 231339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231343 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231345 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231347 */     GIR_RootConstrainSelectedInstOperands,
     /* 231348 */     // GIR_Coverage, 42,
     /* 231348 */     GIR_EraseRootFromParent_Done,
     /* 231349 */   // Label 4394: @231349
     /* 231349 */   GIM_Try, /*On fail goto*//*Label 4395*/ GIMT_Encode4(231403), // Rule ID 43 //
     /* 231354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 231357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 231362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 231365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 231368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 231371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 231374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231390 */     // (intrinsic_wo_chain:{ *:[v2f32] } 617:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLAL2v4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 231390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2v4f16),
     /* 231393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231399 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231401 */     GIR_RootConstrainSelectedInstOperands,
     /* 231402 */     // GIR_Coverage, 43,
     /* 231402 */     GIR_EraseRootFromParent_Done,
     /* 231403 */   // Label 4395: @231403
     /* 231403 */   GIM_Try, /*On fail goto*//*Label 4396*/ GIMT_Encode4(231457), // Rule ID 44 //
     /* 231408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 231411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 231416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 231419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 231422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 231425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 231428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231444 */     // (intrinsic_wo_chain:{ *:[v4f32] } 617:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLAL2v8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 231444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2v8f16),
     /* 231447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231451 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231453 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231455 */     GIR_RootConstrainSelectedInstOperands,
     /* 231456 */     // GIR_Coverage, 44,
     /* 231456 */     GIR_EraseRootFromParent_Done,
     /* 231457 */   // Label 4396: @231457
     /* 231457 */   GIM_Try, /*On fail goto*//*Label 4397*/ GIMT_Encode4(231511), // Rule ID 45 //
     /* 231462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 231465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 231470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 231473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 231476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 231479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 231482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231498 */     // (intrinsic_wo_chain:{ *:[v2f32] } 619:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLSL2v4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 231498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2v4f16),
     /* 231501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231505 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231507 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231509 */     GIR_RootConstrainSelectedInstOperands,
     /* 231510 */     // GIR_Coverage, 45,
     /* 231510 */     GIR_EraseRootFromParent_Done,
     /* 231511 */   // Label 4397: @231511
     /* 231511 */   GIM_Try, /*On fail goto*//*Label 4398*/ GIMT_Encode4(231565), // Rule ID 46 //
     /* 231516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 231519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 231524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 231527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 231530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 231533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 231536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231552 */     // (intrinsic_wo_chain:{ *:[v4f32] } 619:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLSL2v8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 231552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2v8f16),
     /* 231555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231561 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231563 */     GIR_RootConstrainSelectedInstOperands,
     /* 231564 */     // GIR_Coverage, 46,
     /* 231564 */     GIR_EraseRootFromParent_Done,
     /* 231565 */   // Label 4398: @231565
     /* 231565 */   GIM_Try, /*On fail goto*//*Label 4399*/ GIMT_Encode4(231619), // Rule ID 1587 //
     /* 231570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 231573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 231578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 231581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 231584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 231587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 231590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231606 */     // (intrinsic_wo_chain:{ *:[v4i16] } 696:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMLAHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 231606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16),
     /* 231609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231615 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231617 */     GIR_RootConstrainSelectedInstOperands,
     /* 231618 */     // GIR_Coverage, 1587,
     /* 231618 */     GIR_EraseRootFromParent_Done,
     /* 231619 */   // Label 4399: @231619
     /* 231619 */   GIM_Try, /*On fail goto*//*Label 4400*/ GIMT_Encode4(231673), // Rule ID 1588 //
     /* 231624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 231627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 231632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 231635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 231638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 231641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 231644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231660 */     // (intrinsic_wo_chain:{ *:[v8i16] } 696:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMLAHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 231660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv8i16),
     /* 231663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231669 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231671 */     GIR_RootConstrainSelectedInstOperands,
     /* 231672 */     // GIR_Coverage, 1588,
     /* 231672 */     GIR_EraseRootFromParent_Done,
     /* 231673 */   // Label 4400: @231673
     /* 231673 */   GIM_Try, /*On fail goto*//*Label 4401*/ GIMT_Encode4(231727), // Rule ID 1589 //
     /* 231678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 231681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 231686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 231689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 231692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 231695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 231698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231714 */     // (intrinsic_wo_chain:{ *:[v2i32] } 696:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMLAHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 231714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32),
     /* 231717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231721 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231723 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231725 */     GIR_RootConstrainSelectedInstOperands,
     /* 231726 */     // GIR_Coverage, 1589,
     /* 231726 */     GIR_EraseRootFromParent_Done,
     /* 231727 */   // Label 4401: @231727
     /* 231727 */   GIM_Try, /*On fail goto*//*Label 4402*/ GIMT_Encode4(231781), // Rule ID 1590 //
     /* 231732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 231735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 231740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 231743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 231746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 231749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 231752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231768 */     // (intrinsic_wo_chain:{ *:[v4i32] } 696:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMLAHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 231768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i32),
     /* 231771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231777 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231779 */     GIR_RootConstrainSelectedInstOperands,
     /* 231780 */     // GIR_Coverage, 1590,
     /* 231780 */     GIR_EraseRootFromParent_Done,
     /* 231781 */   // Label 4402: @231781
     /* 231781 */   GIM_Try, /*On fail goto*//*Label 4403*/ GIMT_Encode4(231835), // Rule ID 1591 //
     /* 231786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 231789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 231794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 231797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 231800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 231803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 231806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231822 */     // (intrinsic_wo_chain:{ *:[v4i16] } 697:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMLSHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 231822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16),
     /* 231825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231831 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231833 */     GIR_RootConstrainSelectedInstOperands,
     /* 231834 */     // GIR_Coverage, 1591,
     /* 231834 */     GIR_EraseRootFromParent_Done,
     /* 231835 */   // Label 4403: @231835
     /* 231835 */   GIM_Try, /*On fail goto*//*Label 4404*/ GIMT_Encode4(231889), // Rule ID 1592 //
     /* 231840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 231843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 231848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 231851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 231854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 231857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 231860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231876 */     // (intrinsic_wo_chain:{ *:[v8i16] } 697:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMLSHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 231876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv8i16),
     /* 231879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231883 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231885 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231887 */     GIR_RootConstrainSelectedInstOperands,
     /* 231888 */     // GIR_Coverage, 1592,
     /* 231888 */     GIR_EraseRootFromParent_Done,
     /* 231889 */   // Label 4404: @231889
     /* 231889 */   GIM_Try, /*On fail goto*//*Label 4405*/ GIMT_Encode4(231943), // Rule ID 1593 //
     /* 231894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 231897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 231902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 231905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 231908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 231911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 231914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231930 */     // (intrinsic_wo_chain:{ *:[v2i32] } 697:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMLSHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 231930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32),
     /* 231933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231937 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231939 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231941 */     GIR_RootConstrainSelectedInstOperands,
     /* 231942 */     // GIR_Coverage, 1593,
     /* 231942 */     GIR_EraseRootFromParent_Done,
     /* 231943 */   // Label 4405: @231943
     /* 231943 */   GIM_Try, /*On fail goto*//*Label 4406*/ GIMT_Encode4(231997), // Rule ID 1594 //
     /* 231948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 231951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 231956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 231959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 231962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 231965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 231968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231984 */     // (intrinsic_wo_chain:{ *:[v4i32] } 697:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMLSHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 231984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i32),
     /* 231987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231993 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231995 */     GIR_RootConstrainSelectedInstOperands,
     /* 231996 */     // GIR_Coverage, 1594,
     /* 231996 */     GIR_EraseRootFromParent_Done,
     /* 231997 */   // Label 4406: @231997
     /* 231997 */   GIM_Try, /*On fail goto*//*Label 4407*/ GIMT_Encode4(232051), // Rule ID 2307 //
     /* 232002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 232005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1c),
     /* 232010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 232013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 232016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 232019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 232022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 232034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232038 */     // (intrinsic_wo_chain:{ *:[v4i32] } 530:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Crrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 232038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Crrr),
     /* 232041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232047 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232049 */     GIR_RootConstrainSelectedInstOperands,
     /* 232050 */     // GIR_Coverage, 2307,
     /* 232050 */     GIR_EraseRootFromParent_Done,
     /* 232051 */   // Label 4407: @232051
     /* 232051 */   GIM_Try, /*On fail goto*//*Label 4408*/ GIMT_Encode4(232105), // Rule ID 2308 //
     /* 232056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 232059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1p),
     /* 232064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 232067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 232070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 232073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 232076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 232088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232092 */     // (intrinsic_wo_chain:{ *:[v4i32] } 533:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Prrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 232092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Prrr),
     /* 232095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232101 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232103 */     GIR_RootConstrainSelectedInstOperands,
     /* 232104 */     // GIR_Coverage, 2308,
     /* 232104 */     GIR_EraseRootFromParent_Done,
     /* 232105 */   // Label 4408: @232105
     /* 232105 */   GIM_Try, /*On fail goto*//*Label 4409*/ GIMT_Encode4(232159), // Rule ID 2309 //
     /* 232110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 232113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1m),
     /* 232118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 232121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 232124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 232127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 232130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 232142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232146 */     // (intrinsic_wo_chain:{ *:[v4i32] } 532:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Mrrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 232146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Mrrr),
     /* 232149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232155 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232157 */     GIR_RootConstrainSelectedInstOperands,
     /* 232158 */     // GIR_Coverage, 2309,
     /* 232158 */     GIR_EraseRootFromParent_Done,
     /* 232159 */   // Label 4409: @232159
     /* 232159 */   GIM_Try, /*On fail goto*//*Label 4410*/ GIMT_Encode4(232213), // Rule ID 2310 //
     /* 232164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 232167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1su0),
     /* 232172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 232175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 232178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 232181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 232184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232200 */     // (intrinsic_wo_chain:{ *:[v4i32] } 534:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1SU0rrr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 232200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1SU0rrr),
     /* 232203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232207 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232209 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232211 */     GIR_RootConstrainSelectedInstOperands,
     /* 232212 */     // GIR_Coverage, 2310,
     /* 232212 */     GIR_EraseRootFromParent_Done,
     /* 232213 */   // Label 4410: @232213
     /* 232213 */   GIM_Try, /*On fail goto*//*Label 4411*/ GIMT_Encode4(232267), // Rule ID 2311 //
     /* 232218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 232221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256h),
     /* 232226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 232229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 232232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 232235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 232238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232254 */     // (intrinsic_wo_chain:{ *:[v4i32] } 536:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256Hrrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 232254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256Hrrr),
     /* 232257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232261 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232263 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232265 */     GIR_RootConstrainSelectedInstOperands,
     /* 232266 */     // GIR_Coverage, 2311,
     /* 232266 */     GIR_EraseRootFromParent_Done,
     /* 232267 */   // Label 4411: @232267
     /* 232267 */   GIM_Try, /*On fail goto*//*Label 4412*/ GIMT_Encode4(232321), // Rule ID 2312 //
     /* 232272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 232275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256h2),
     /* 232280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 232283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 232286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 232289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 232292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232308 */     // (intrinsic_wo_chain:{ *:[v4i32] } 537:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256H2rrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 232308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256H2rrr),
     /* 232311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232317 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232319 */     GIR_RootConstrainSelectedInstOperands,
     /* 232320 */     // GIR_Coverage, 2312,
     /* 232320 */     GIR_EraseRootFromParent_Done,
     /* 232321 */   // Label 4412: @232321
     /* 232321 */   GIM_Try, /*On fail goto*//*Label 4413*/ GIMT_Encode4(232375), // Rule ID 2313 //
     /* 232326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 232329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256su1),
     /* 232334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 232337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 232340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 232343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 232346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232362 */     // (intrinsic_wo_chain:{ *:[v4i32] } 539:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256SU1rrr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 232362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256SU1rrr),
     /* 232365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232371 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232373 */     GIR_RootConstrainSelectedInstOperands,
     /* 232374 */     // GIR_Coverage, 2313,
     /* 232374 */     GIR_EraseRootFromParent_Done,
     /* 232375 */   // Label 4413: @232375
     /* 232375 */   GIM_Try, /*On fail goto*//*Label 4414*/ GIMT_Encode4(232432), // Rule ID 3659 //
     /* 232380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 232383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 232388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 232391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 232397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 232400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 232404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 232408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 232412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 232416 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1661:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR8:{ *:[nxv16i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_B:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 232416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_B),
     /* 232419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 232421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 232423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 232425 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 232427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 232430 */     GIR_RootConstrainSelectedInstOperands,
     /* 232431 */     // GIR_Coverage, 3659,
     /* 232431 */     GIR_EraseRootFromParent_Done,
     /* 232432 */   // Label 4414: @232432
     /* 232432 */   GIM_Try, /*On fail goto*//*Label 4415*/ GIMT_Encode4(232489), // Rule ID 3660 //
     /* 232437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 232440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 232445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 232448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 232454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 232457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 232461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 232465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 232469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 232473 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1661:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR16:{ *:[nxv8i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_H:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 232473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_H),
     /* 232476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 232478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 232480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 232482 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 232484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 232487 */     GIR_RootConstrainSelectedInstOperands,
     /* 232488 */     // GIR_Coverage, 3660,
     /* 232488 */     GIR_EraseRootFromParent_Done,
     /* 232489 */   // Label 4415: @232489
     /* 232489 */   GIM_Try, /*On fail goto*//*Label 4416*/ GIMT_Encode4(232546), // Rule ID 3661 //
     /* 232494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 232497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 232502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 232505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 232511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 232514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 232518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 232522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 232526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 232530 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1661:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR32:{ *:[nxv4i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_S:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 232530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_S),
     /* 232533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 232535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 232537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 232539 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 232541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 232544 */     GIR_RootConstrainSelectedInstOperands,
     /* 232545 */     // GIR_Coverage, 3661,
     /* 232545 */     GIR_EraseRootFromParent_Done,
     /* 232546 */   // Label 4416: @232546
     /* 232546 */   GIM_Try, /*On fail goto*//*Label 4417*/ GIMT_Encode4(232603), // Rule ID 3662 //
     /* 232551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 232554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 232559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 232562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 232568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 232571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 232575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 232579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 232583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 232587 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1661:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR64:{ *:[nxv2i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_D:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 232587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_D),
     /* 232590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 232592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 232594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 232596 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 232598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 232601 */     GIR_RootConstrainSelectedInstOperands,
     /* 232602 */     // GIR_Coverage, 3662,
     /* 232602 */     GIR_EraseRootFromParent_Done,
     /* 232603 */   // Label 4417: @232603
     /* 232603 */   GIM_Try, /*On fail goto*//*Label 4418*/ GIMT_Encode4(232657), // Rule ID 3841 //
     /* 232608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 232611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512h),
     /* 232616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 232619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 232622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 232625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 232628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232644 */     // (intrinsic_wo_chain:{ *:[v2i64] } 540:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512H:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 232644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512H),
     /* 232647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 232649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 232651 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 232653 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 232655 */     GIR_RootConstrainSelectedInstOperands,
     /* 232656 */     // GIR_Coverage, 3841,
     /* 232656 */     GIR_EraseRootFromParent_Done,
     /* 232657 */   // Label 4418: @232657
     /* 232657 */   GIM_Try, /*On fail goto*//*Label 4419*/ GIMT_Encode4(232711), // Rule ID 3842 //
     /* 232662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 232665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512h2),
     /* 232670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 232673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 232676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 232679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 232682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232698 */     // (intrinsic_wo_chain:{ *:[v2i64] } 541:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512H2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 232698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512H2),
     /* 232701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 232703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 232705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 232707 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 232709 */     GIR_RootConstrainSelectedInstOperands,
     /* 232710 */     // GIR_Coverage, 3842,
     /* 232710 */     GIR_EraseRootFromParent_Done,
     /* 232711 */   // Label 4419: @232711
     /* 232711 */   GIM_Try, /*On fail goto*//*Label 4420*/ GIMT_Encode4(232765), // Rule ID 3843 //
     /* 232716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 232719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512su1),
     /* 232724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 232727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 232730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 232733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 232736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232752 */     // (intrinsic_wo_chain:{ *:[v2i64] } 543:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512SU1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 232752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512SU1),
     /* 232755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 232757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 232759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 232761 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 232763 */     GIR_RootConstrainSelectedInstOperands,
     /* 232764 */     // GIR_Coverage, 3843,
     /* 232764 */     GIR_EraseRootFromParent_Done,
     /* 232765 */   // Label 4420: @232765
     /* 232765 */   GIM_Try, /*On fail goto*//*Label 4421*/ GIMT_Encode4(232819), // Rule ID 3844 //
     /* 232770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 232773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 232778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 232781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 232784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 232787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 232790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232806 */     // (intrinsic_wo_chain:{ *:[v16i8] } 528:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 232806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 232809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 232811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 232813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 232815 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 232817 */     GIR_RootConstrainSelectedInstOperands,
     /* 232818 */     // GIR_Coverage, 3844,
     /* 232818 */     GIR_EraseRootFromParent_Done,
     /* 232819 */   // Label 4421: @232819
     /* 232819 */   GIM_Try, /*On fail goto*//*Label 4422*/ GIMT_Encode4(232873), // Rule ID 3845 //
     /* 232824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 232827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 232832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 232835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 232838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 232841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 232844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232860 */     // (intrinsic_wo_chain:{ *:[v8i16] } 528:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 232860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 232863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 232865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 232867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 232869 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 232871 */     GIR_RootConstrainSelectedInstOperands,
     /* 232872 */     // GIR_Coverage, 3845,
     /* 232872 */     GIR_EraseRootFromParent_Done,
     /* 232873 */   // Label 4422: @232873
     /* 232873 */   GIM_Try, /*On fail goto*//*Label 4423*/ GIMT_Encode4(232927), // Rule ID 3846 //
     /* 232878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 232881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 232886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 232889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 232892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 232895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 232898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232914 */     // (intrinsic_wo_chain:{ *:[v4i32] } 528:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 232914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 232917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 232919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 232921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 232923 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 232925 */     GIR_RootConstrainSelectedInstOperands,
     /* 232926 */     // GIR_Coverage, 3846,
     /* 232926 */     GIR_EraseRootFromParent_Done,
     /* 232927 */   // Label 4423: @232927
     /* 232927 */   GIM_Try, /*On fail goto*//*Label 4424*/ GIMT_Encode4(232981), // Rule ID 3847 //
     /* 232932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 232935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 232940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 232943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 232946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 232949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 232952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232968 */     // (intrinsic_wo_chain:{ *:[v2i64] } 528:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 232968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 232971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 232973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 232975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 232977 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 232979 */     GIR_RootConstrainSelectedInstOperands,
     /* 232980 */     // GIR_Coverage, 3847,
     /* 232980 */     GIR_EraseRootFromParent_Done,
     /* 232981 */   // Label 4424: @232981
     /* 232981 */   GIM_Try, /*On fail goto*//*Label 4425*/ GIMT_Encode4(233035), // Rule ID 3856 //
     /* 232986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 232989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 232994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 232997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 233000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 233003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 233006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233022 */     // (intrinsic_wo_chain:{ *:[v16i8] } 526:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 233022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 233025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233031 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233033 */     GIR_RootConstrainSelectedInstOperands,
     /* 233034 */     // GIR_Coverage, 3856,
     /* 233034 */     GIR_EraseRootFromParent_Done,
     /* 233035 */   // Label 4425: @233035
     /* 233035 */   GIM_Try, /*On fail goto*//*Label 4426*/ GIMT_Encode4(233089), // Rule ID 3857 //
     /* 233040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 233043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 233048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 233051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 233054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 233057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 233060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233076 */     // (intrinsic_wo_chain:{ *:[v8i16] } 526:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 233076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 233079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233085 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233087 */     GIR_RootConstrainSelectedInstOperands,
     /* 233088 */     // GIR_Coverage, 3857,
     /* 233088 */     GIR_EraseRootFromParent_Done,
     /* 233089 */   // Label 4426: @233089
     /* 233089 */   GIM_Try, /*On fail goto*//*Label 4427*/ GIMT_Encode4(233143), // Rule ID 3858 //
     /* 233094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 233097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 233102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 233105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 233108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 233111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 233114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233130 */     // (intrinsic_wo_chain:{ *:[v4i32] } 526:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 233130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 233133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233139 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233141 */     GIR_RootConstrainSelectedInstOperands,
     /* 233142 */     // GIR_Coverage, 3858,
     /* 233142 */     GIR_EraseRootFromParent_Done,
     /* 233143 */   // Label 4427: @233143
     /* 233143 */   GIM_Try, /*On fail goto*//*Label 4428*/ GIMT_Encode4(233197), // Rule ID 3859 //
     /* 233148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 233151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 233156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 233159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 233162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 233165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 233168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233184 */     // (intrinsic_wo_chain:{ *:[v2i64] } 526:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 233184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 233187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233191 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233193 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233195 */     GIR_RootConstrainSelectedInstOperands,
     /* 233196 */     // GIR_Coverage, 3859,
     /* 233196 */     GIR_EraseRootFromParent_Done,
     /* 233197 */   // Label 4428: @233197
     /* 233197 */   GIM_Try, /*On fail goto*//*Label 4429*/ GIMT_Encode4(233251), // Rule ID 3860 //
     /* 233202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 233205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 233210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 233213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 233216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 233219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 233222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233238 */     // (intrinsic_wo_chain:{ *:[v16i8] } 527:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 233238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 233241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233247 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233249 */     GIR_RootConstrainSelectedInstOperands,
     /* 233250 */     // GIR_Coverage, 3860,
     /* 233250 */     GIR_EraseRootFromParent_Done,
     /* 233251 */   // Label 4429: @233251
     /* 233251 */   GIM_Try, /*On fail goto*//*Label 4430*/ GIMT_Encode4(233305), // Rule ID 3861 //
     /* 233256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 233259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 233264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 233267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 233270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 233273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 233276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233292 */     // (intrinsic_wo_chain:{ *:[v8i16] } 527:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 233292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 233295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233301 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233303 */     GIR_RootConstrainSelectedInstOperands,
     /* 233304 */     // GIR_Coverage, 3861,
     /* 233304 */     GIR_EraseRootFromParent_Done,
     /* 233305 */   // Label 4430: @233305
     /* 233305 */   GIM_Try, /*On fail goto*//*Label 4431*/ GIMT_Encode4(233359), // Rule ID 3862 //
     /* 233310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 233313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 233318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 233321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 233324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 233327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 233330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233346 */     // (intrinsic_wo_chain:{ *:[v4i32] } 527:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 233346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 233349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233355 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233357 */     GIR_RootConstrainSelectedInstOperands,
     /* 233358 */     // GIR_Coverage, 3862,
     /* 233358 */     GIR_EraseRootFromParent_Done,
     /* 233359 */   // Label 4431: @233359
     /* 233359 */   GIM_Try, /*On fail goto*//*Label 4432*/ GIMT_Encode4(233413), // Rule ID 3863 //
     /* 233364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 233367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 233372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 233375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 233378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 233381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 233384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233400 */     // (intrinsic_wo_chain:{ *:[v2i64] } 527:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 233400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 233403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233409 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233411 */     GIR_RootConstrainSelectedInstOperands,
     /* 233412 */     // GIR_Coverage, 3863,
     /* 233412 */     GIR_EraseRootFromParent_Done,
     /* 233413 */   // Label 4432: @233413
     /* 233413 */   GIM_Try, /*On fail goto*//*Label 4433*/ GIMT_Encode4(233467), // Rule ID 3864 //
     /* 233418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 233421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 233426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 233429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 233432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 233435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 233438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233454 */     // (intrinsic_wo_chain:{ *:[v16i8] } 525:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 233454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 233457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233461 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233463 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233465 */     GIR_RootConstrainSelectedInstOperands,
     /* 233466 */     // GIR_Coverage, 3864,
     /* 233466 */     GIR_EraseRootFromParent_Done,
     /* 233467 */   // Label 4433: @233467
     /* 233467 */   GIM_Try, /*On fail goto*//*Label 4434*/ GIMT_Encode4(233521), // Rule ID 3865 //
     /* 233472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 233475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 233480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 233483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 233486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 233489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 233492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233508 */     // (intrinsic_wo_chain:{ *:[v8i16] } 525:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 233508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 233511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233517 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233519 */     GIR_RootConstrainSelectedInstOperands,
     /* 233520 */     // GIR_Coverage, 3865,
     /* 233520 */     GIR_EraseRootFromParent_Done,
     /* 233521 */   // Label 4434: @233521
     /* 233521 */   GIM_Try, /*On fail goto*//*Label 4435*/ GIMT_Encode4(233575), // Rule ID 3866 //
     /* 233526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 233529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 233534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 233537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 233540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 233543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 233546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233562 */     // (intrinsic_wo_chain:{ *:[v4i32] } 525:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 233562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 233565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233571 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233573 */     GIR_RootConstrainSelectedInstOperands,
     /* 233574 */     // GIR_Coverage, 3866,
     /* 233574 */     GIR_EraseRootFromParent_Done,
     /* 233575 */   // Label 4435: @233575
     /* 233575 */   GIM_Try, /*On fail goto*//*Label 4436*/ GIMT_Encode4(233629), // Rule ID 3867 //
     /* 233580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 233583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 233588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 233591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 233594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 233597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 233600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233616 */     // (intrinsic_wo_chain:{ *:[v2i64] } 525:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 233616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 233619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233625 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233627 */     GIR_RootConstrainSelectedInstOperands,
     /* 233628 */     // GIR_Coverage, 3867,
     /* 233628 */     GIR_EraseRootFromParent_Done,
     /* 233629 */   // Label 4436: @233629
     /* 233629 */   GIM_Try, /*On fail goto*//*Label 4437*/ GIMT_Encode4(233683), // Rule ID 3871 //
     /* 233634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 233637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3ss1),
     /* 233642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 233645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 233648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 233651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 233654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233670 */     // (intrinsic_wo_chain:{ *:[v4i32] } 546:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)  =>  (SM3SS1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /* 233670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3SS1),
     /* 233673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 233677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 233679 */     GIR_RootToRootCopy, /*OpIdx*/4, // Va
     /* 233681 */     GIR_RootConstrainSelectedInstOperands,
     /* 233682 */     // GIR_Coverage, 3871,
     /* 233682 */     GIR_EraseRootFromParent_Done,
     /* 233683 */   // Label 4437: @233683
     /* 233683 */   GIM_Try, /*On fail goto*//*Label 4438*/ GIMT_Encode4(233737), // Rule ID 3872 //
     /* 233688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 233691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3partw1),
     /* 233696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 233699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 233702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 233705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 233708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233724 */     // (intrinsic_wo_chain:{ *:[v4i32] } 544:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM3PARTW1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 233724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3PARTW1),
     /* 233727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 233729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233733 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233735 */     GIR_RootConstrainSelectedInstOperands,
     /* 233736 */     // GIR_Coverage, 3872,
     /* 233736 */     GIR_EraseRootFromParent_Done,
     /* 233737 */   // Label 4438: @233737
     /* 233737 */   GIM_Try, /*On fail goto*//*Label 4439*/ GIMT_Encode4(233791), // Rule ID 3873 //
     /* 233742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 233745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3partw2),
     /* 233750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 233753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 233756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 233759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 233762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233778 */     // (intrinsic_wo_chain:{ *:[v4i32] } 545:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM3PARTW2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 233778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3PARTW2),
     /* 233781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 233783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233785 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233787 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233789 */     GIR_RootConstrainSelectedInstOperands,
     /* 233790 */     // GIR_Coverage, 3873,
     /* 233790 */     GIR_EraseRootFromParent_Done,
     /* 233791 */   // Label 4439: @233791
     /* 233791 */   GIM_Try, /*On fail goto*//*Label 4440*/ GIMT_Encode4(233848), // Rule ID 3890 //
     /* 233796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 233799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 233804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 233807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 233810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 233813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 233816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233832 */     // (intrinsic_wo_chain:{ *:[v4f16] } 767:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /* 233832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 233835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233841 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233846 */     GIR_RootConstrainSelectedInstOperands,
     /* 233847 */     // GIR_Coverage, 3890,
     /* 233847 */     GIR_EraseRootFromParent_Done,
     /* 233848 */   // Label 4440: @233848
     /* 233848 */   GIM_Try, /*On fail goto*//*Label 4441*/ GIMT_Encode4(233905), // Rule ID 3891 //
     /* 233853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 233856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 233861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 233864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 233867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 233870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 233873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233889 */     // (intrinsic_wo_chain:{ *:[v4f16] } 770:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /* 233889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 233892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233896 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233898 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 233903 */     GIR_RootConstrainSelectedInstOperands,
     /* 233904 */     // GIR_Coverage, 3891,
     /* 233904 */     GIR_EraseRootFromParent_Done,
     /* 233905 */   // Label 4441: @233905
     /* 233905 */   GIM_Try, /*On fail goto*//*Label 4442*/ GIMT_Encode4(233962), // Rule ID 3892 //
     /* 233910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 233913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 233918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 233921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 233924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 233927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 233930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233946 */     // (intrinsic_wo_chain:{ *:[v4f16] } 768:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 2:{ *:[i32] })
     /* 233946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 233949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233955 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 233960 */     GIR_RootConstrainSelectedInstOperands,
     /* 233961 */     // GIR_Coverage, 3892,
     /* 233961 */     GIR_EraseRootFromParent_Done,
     /* 233962 */   // Label 4442: @233962
     /* 233962 */   GIM_Try, /*On fail goto*//*Label 4443*/ GIMT_Encode4(234019), // Rule ID 3893 //
     /* 233967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 233970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 233975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 233978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 233981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 233984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 233987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234003 */     // (intrinsic_wo_chain:{ *:[v4f16] } 769:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 3:{ *:[i32] })
     /* 234003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 234006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234012 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 234017 */     GIR_RootConstrainSelectedInstOperands,
     /* 234018 */     // GIR_Coverage, 3893,
     /* 234018 */     GIR_EraseRootFromParent_Done,
     /* 234019 */   // Label 4443: @234019
     /* 234019 */   GIM_Try, /*On fail goto*//*Label 4444*/ GIMT_Encode4(234076), // Rule ID 3898 //
     /* 234024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 234027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 234032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 234035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 234038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 234041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 234044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234060 */     // (intrinsic_wo_chain:{ *:[v8f16] } 767:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /* 234060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 234063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234069 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234074 */     GIR_RootConstrainSelectedInstOperands,
     /* 234075 */     // GIR_Coverage, 3898,
     /* 234075 */     GIR_EraseRootFromParent_Done,
     /* 234076 */   // Label 4444: @234076
     /* 234076 */   GIM_Try, /*On fail goto*//*Label 4445*/ GIMT_Encode4(234133), // Rule ID 3899 //
     /* 234081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 234084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 234089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 234092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 234095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 234098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 234101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234117 */     // (intrinsic_wo_chain:{ *:[v8f16] } 770:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /* 234117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 234120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234126 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 234131 */     GIR_RootConstrainSelectedInstOperands,
     /* 234132 */     // GIR_Coverage, 3899,
     /* 234132 */     GIR_EraseRootFromParent_Done,
     /* 234133 */   // Label 4445: @234133
     /* 234133 */   GIM_Try, /*On fail goto*//*Label 4446*/ GIMT_Encode4(234190), // Rule ID 3900 //
     /* 234138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 234141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 234146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 234149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 234152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 234155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 234158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234174 */     // (intrinsic_wo_chain:{ *:[v8f16] } 768:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 2:{ *:[i32] })
     /* 234174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 234177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234183 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 234188 */     GIR_RootConstrainSelectedInstOperands,
     /* 234189 */     // GIR_Coverage, 3900,
     /* 234189 */     GIR_EraseRootFromParent_Done,
     /* 234190 */   // Label 4446: @234190
     /* 234190 */   GIM_Try, /*On fail goto*//*Label 4447*/ GIMT_Encode4(234247), // Rule ID 3901 //
     /* 234195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 234198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 234203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 234206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 234209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 234212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 234215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234231 */     // (intrinsic_wo_chain:{ *:[v8f16] } 769:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 3:{ *:[i32] })
     /* 234231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 234234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234240 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 234245 */     GIR_RootConstrainSelectedInstOperands,
     /* 234246 */     // GIR_Coverage, 3901,
     /* 234246 */     GIR_EraseRootFromParent_Done,
     /* 234247 */   // Label 4447: @234247
     /* 234247 */   GIM_Try, /*On fail goto*//*Label 4448*/ GIMT_Encode4(234304), // Rule ID 3906 //
     /* 234252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 234255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 234260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 234263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 234266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 234269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 234272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234288 */     // (intrinsic_wo_chain:{ *:[v2f32] } 767:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /* 234288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 234291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234297 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234302 */     GIR_RootConstrainSelectedInstOperands,
     /* 234303 */     // GIR_Coverage, 3906,
     /* 234303 */     GIR_EraseRootFromParent_Done,
     /* 234304 */   // Label 4448: @234304
     /* 234304 */   GIM_Try, /*On fail goto*//*Label 4449*/ GIMT_Encode4(234361), // Rule ID 3907 //
     /* 234309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 234312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 234317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 234320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 234323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 234326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 234329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234345 */     // (intrinsic_wo_chain:{ *:[v2f32] } 770:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /* 234345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 234348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234354 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 234359 */     GIR_RootConstrainSelectedInstOperands,
     /* 234360 */     // GIR_Coverage, 3907,
     /* 234360 */     GIR_EraseRootFromParent_Done,
     /* 234361 */   // Label 4449: @234361
     /* 234361 */   GIM_Try, /*On fail goto*//*Label 4450*/ GIMT_Encode4(234418), // Rule ID 3908 //
     /* 234366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 234369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 234374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 234377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 234380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 234383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 234386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234402 */     // (intrinsic_wo_chain:{ *:[v2f32] } 768:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 2:{ *:[i32] })
     /* 234402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 234405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234411 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 234416 */     GIR_RootConstrainSelectedInstOperands,
     /* 234417 */     // GIR_Coverage, 3908,
     /* 234417 */     GIR_EraseRootFromParent_Done,
     /* 234418 */   // Label 4450: @234418
     /* 234418 */   GIM_Try, /*On fail goto*//*Label 4451*/ GIMT_Encode4(234475), // Rule ID 3909 //
     /* 234423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 234426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 234431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 234434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 234437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 234440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 234443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234459 */     // (intrinsic_wo_chain:{ *:[v2f32] } 769:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 3:{ *:[i32] })
     /* 234459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 234462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234468 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 234473 */     GIR_RootConstrainSelectedInstOperands,
     /* 234474 */     // GIR_Coverage, 3909,
     /* 234474 */     GIR_EraseRootFromParent_Done,
     /* 234475 */   // Label 4451: @234475
     /* 234475 */   GIM_Try, /*On fail goto*//*Label 4452*/ GIMT_Encode4(234532), // Rule ID 3910 //
     /* 234480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 234483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 234488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 234491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 234494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 234497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 234500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234516 */     // (intrinsic_wo_chain:{ *:[v4f32] } 767:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /* 234516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 234519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234525 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234530 */     GIR_RootConstrainSelectedInstOperands,
     /* 234531 */     // GIR_Coverage, 3910,
     /* 234531 */     GIR_EraseRootFromParent_Done,
     /* 234532 */   // Label 4452: @234532
     /* 234532 */   GIM_Try, /*On fail goto*//*Label 4453*/ GIMT_Encode4(234589), // Rule ID 3911 //
     /* 234537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 234540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 234545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 234548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 234551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 234554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 234557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234573 */     // (intrinsic_wo_chain:{ *:[v4f32] } 770:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /* 234573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 234576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234582 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 234587 */     GIR_RootConstrainSelectedInstOperands,
     /* 234588 */     // GIR_Coverage, 3911,
     /* 234588 */     GIR_EraseRootFromParent_Done,
     /* 234589 */   // Label 4453: @234589
     /* 234589 */   GIM_Try, /*On fail goto*//*Label 4454*/ GIMT_Encode4(234646), // Rule ID 3912 //
     /* 234594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 234597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 234602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 234605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 234608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 234611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 234614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234630 */     // (intrinsic_wo_chain:{ *:[v4f32] } 768:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 2:{ *:[i32] })
     /* 234630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 234633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234637 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234639 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 234644 */     GIR_RootConstrainSelectedInstOperands,
     /* 234645 */     // GIR_Coverage, 3912,
     /* 234645 */     GIR_EraseRootFromParent_Done,
     /* 234646 */   // Label 4454: @234646
     /* 234646 */   GIM_Try, /*On fail goto*//*Label 4455*/ GIMT_Encode4(234703), // Rule ID 3913 //
     /* 234651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 234654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 234659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 234662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 234665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 234668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 234671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234687 */     // (intrinsic_wo_chain:{ *:[v4f32] } 769:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 3:{ *:[i32] })
     /* 234687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 234690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234696 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 234701 */     GIR_RootConstrainSelectedInstOperands,
     /* 234702 */     // GIR_Coverage, 3913,
     /* 234702 */     GIR_EraseRootFromParent_Done,
     /* 234703 */   // Label 4455: @234703
     /* 234703 */   GIM_Try, /*On fail goto*//*Label 4456*/ GIMT_Encode4(234760), // Rule ID 3914 //
     /* 234708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 234711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 234716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 234719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 234722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 234725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 234728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234744 */     // (intrinsic_wo_chain:{ *:[v2f64] } 767:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 0:{ *:[i32] })
     /* 234744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 234747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234753 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234758 */     GIR_RootConstrainSelectedInstOperands,
     /* 234759 */     // GIR_Coverage, 3914,
     /* 234759 */     GIR_EraseRootFromParent_Done,
     /* 234760 */   // Label 4456: @234760
     /* 234760 */   GIM_Try, /*On fail goto*//*Label 4457*/ GIMT_Encode4(234817), // Rule ID 3915 //
     /* 234765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 234768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 234773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 234776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 234779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 234782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 234785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234801 */     // (intrinsic_wo_chain:{ *:[v2f64] } 770:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 1:{ *:[i32] })
     /* 234801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 234804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234810 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 234815 */     GIR_RootConstrainSelectedInstOperands,
     /* 234816 */     // GIR_Coverage, 3915,
     /* 234816 */     GIR_EraseRootFromParent_Done,
     /* 234817 */   // Label 4457: @234817
     /* 234817 */   GIM_Try, /*On fail goto*//*Label 4458*/ GIMT_Encode4(234874), // Rule ID 3916 //
     /* 234822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 234825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 234830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 234833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 234836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 234839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 234842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234858 */     // (intrinsic_wo_chain:{ *:[v2f64] } 768:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 2:{ *:[i32] })
     /* 234858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 234861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234867 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 234872 */     GIR_RootConstrainSelectedInstOperands,
     /* 234873 */     // GIR_Coverage, 3916,
     /* 234873 */     GIR_EraseRootFromParent_Done,
     /* 234874 */   // Label 4458: @234874
     /* 234874 */   GIM_Try, /*On fail goto*//*Label 4459*/ GIMT_Encode4(234931), // Rule ID 3917 //
     /* 234879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 234882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 234887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 234890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 234893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 234896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 234899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234915 */     // (intrinsic_wo_chain:{ *:[v2f64] } 769:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 3:{ *:[i32] })
     /* 234915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 234918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234924 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 234929 */     GIR_RootConstrainSelectedInstOperands,
     /* 234930 */     // GIR_Coverage, 3917,
     /* 234930 */     GIR_EraseRootFromParent_Done,
     /* 234931 */   // Label 4459: @234931
     /* 234931 */   GIM_Try, /*On fail goto*//*Label 4460*/ GIMT_Encode4(234985), // Rule ID 5272 //
     /* 234936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDM),
     /* 234939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 234944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 234947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 234950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 234953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 234956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 234960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 234964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 234968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 234972 */     // (intrinsic_wo_chain:{ *:[i32] } 696:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMLAHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 234972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv1i32),
     /* 234975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234981 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234983 */     GIR_RootConstrainSelectedInstOperands,
     /* 234984 */     // GIR_Coverage, 5272,
     /* 234984 */     GIR_EraseRootFromParent_Done,
     /* 234985 */   // Label 4460: @234985
     /* 234985 */   GIM_Try, /*On fail goto*//*Label 4461*/ GIMT_Encode4(235039), // Rule ID 5273 //
     /* 234990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDM),
     /* 234993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 234998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 235001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 235004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 235007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 235010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 235014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 235018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 235022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 235026 */     // (intrinsic_wo_chain:{ *:[i32] } 697:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMLSHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 235026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv1i32),
     /* 235029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 235033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 235035 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 235037 */     GIR_RootConstrainSelectedInstOperands,
     /* 235038 */     // GIR_Coverage, 5273,
     /* 235038 */     GIR_EraseRootFromParent_Done,
     /* 235039 */   // Label 4461: @235039
     /* 235039 */   GIM_Try, /*On fail goto*//*Label 4462*/ GIMT_Encode4(235090), // Rule ID 5626 //
     /* 235044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbx1),
     /* 235049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 235052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 235055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 235058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 235061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 235065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 235069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 235077 */     // (intrinsic_wo_chain:{ *:[v8i8] } 730:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)  =>  (TBXv8i8One:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)
     /* 235077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXv8i8One),
     /* 235080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 235084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 235086 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ri
     /* 235088 */     GIR_RootConstrainSelectedInstOperands,
     /* 235089 */     // GIR_Coverage, 5626,
     /* 235089 */     GIR_EraseRootFromParent_Done,
     /* 235090 */   // Label 4462: @235090
     /* 235090 */   GIM_Try, /*On fail goto*//*Label 4463*/ GIMT_Encode4(235141), // Rule ID 5627 //
     /* 235095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbx1),
     /* 235100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 235103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 235106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 235109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 235112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235128 */     // (intrinsic_wo_chain:{ *:[v16i8] } 730:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)  =>  (TBXv16i8One:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)
     /* 235128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXv16i8One),
     /* 235131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 235135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ri
     /* 235137 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 235139 */     GIR_RootConstrainSelectedInstOperands,
     /* 235140 */     // GIR_Coverage, 5627,
     /* 235140 */     GIR_EraseRootFromParent_Done,
     /* 235141 */   // Label 4463: @235141
     /* 235141 */   GIM_Try, /*On fail goto*//*Label 4464*/ GIMT_Encode4(235183), // Rule ID 2695 //
     /* 235146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 235154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 235160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235170 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1928:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (TBX_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_B),
     /* 235173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235177 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235179 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235181 */     GIR_RootConstrainSelectedInstOperands,
     /* 235182 */     // GIR_Coverage, 2695,
     /* 235182 */     GIR_EraseRootFromParent_Done,
     /* 235183 */   // Label 4464: @235183
     /* 235183 */   GIM_Try, /*On fail goto*//*Label 4465*/ GIMT_Encode4(235225), // Rule ID 2696 //
     /* 235188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 235196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 235202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235212 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1928:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBX_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_H),
     /* 235215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235221 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235223 */     GIR_RootConstrainSelectedInstOperands,
     /* 235224 */     // GIR_Coverage, 2696,
     /* 235224 */     GIR_EraseRootFromParent_Done,
     /* 235225 */   // Label 4465: @235225
     /* 235225 */   GIM_Try, /*On fail goto*//*Label 4466*/ GIMT_Encode4(235267), // Rule ID 2697 //
     /* 235230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 235238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 235244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235254 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1928:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBX_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_S),
     /* 235257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235261 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235263 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235265 */     GIR_RootConstrainSelectedInstOperands,
     /* 235266 */     // GIR_Coverage, 2697,
     /* 235266 */     GIR_EraseRootFromParent_Done,
     /* 235267 */   // Label 4466: @235267
     /* 235267 */   GIM_Try, /*On fail goto*//*Label 4467*/ GIMT_Encode4(235309), // Rule ID 2698 //
     /* 235272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 235280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 235286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235296 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1928:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBX_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_D),
     /* 235299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235305 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235307 */     GIR_RootConstrainSelectedInstOperands,
     /* 235308 */     // GIR_Coverage, 2698,
     /* 235308 */     GIR_EraseRootFromParent_Done,
     /* 235309 */   // Label 4467: @235309
     /* 235309 */   GIM_Try, /*On fail goto*//*Label 4468*/ GIMT_Encode4(235351), // Rule ID 2699 //
     /* 235314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 235322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 235328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235338 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1928:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBX_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_H),
     /* 235341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235345 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235347 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235349 */     GIR_RootConstrainSelectedInstOperands,
     /* 235350 */     // GIR_Coverage, 2699,
     /* 235350 */     GIR_EraseRootFromParent_Done,
     /* 235351 */   // Label 4468: @235351
     /* 235351 */   GIM_Try, /*On fail goto*//*Label 4469*/ GIMT_Encode4(235393), // Rule ID 2700 //
     /* 235356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 235364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 235370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235380 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1928:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBX_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_S),
     /* 235383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235387 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235389 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235391 */     GIR_RootConstrainSelectedInstOperands,
     /* 235392 */     // GIR_Coverage, 2700,
     /* 235392 */     GIR_EraseRootFromParent_Done,
     /* 235393 */   // Label 4469: @235393
     /* 235393 */   GIM_Try, /*On fail goto*//*Label 4470*/ GIMT_Encode4(235435), // Rule ID 2701 //
     /* 235398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 235406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 235412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235422 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1928:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBX_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_D),
     /* 235425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235431 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235433 */     GIR_RootConstrainSelectedInstOperands,
     /* 235434 */     // GIR_Coverage, 2701,
     /* 235434 */     GIR_EraseRootFromParent_Done,
     /* 235435 */   // Label 4470: @235435
     /* 235435 */   GIM_Try, /*On fail goto*//*Label 4471*/ GIMT_Encode4(235477), // Rule ID 2740 //
     /* 235440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 235443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 235448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 235451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 235457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 235460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 235464 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1274:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 235464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 235467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 235469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235473 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235475 */     GIR_RootConstrainSelectedInstOperands,
     /* 235476 */     // GIR_Coverage, 2740,
     /* 235476 */     GIR_EraseRootFromParent_Done,
     /* 235477 */   // Label 4471: @235477
     /* 235477 */   GIM_Try, /*On fail goto*//*Label 4472*/ GIMT_Encode4(235519), // Rule ID 2741 //
     /* 235482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 235485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 235490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 235493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 235499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 235502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 235506 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1274:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 235506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 235509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 235511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235513 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235515 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235517 */     GIR_RootConstrainSelectedInstOperands,
     /* 235518 */     // GIR_Coverage, 2741,
     /* 235518 */     GIR_EraseRootFromParent_Done,
     /* 235519 */   // Label 4472: @235519
     /* 235519 */   GIM_Try, /*On fail goto*//*Label 4473*/ GIMT_Encode4(235561), // Rule ID 2742 //
     /* 235524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 235527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 235532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 235535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 235541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 235544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 235548 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1274:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 235548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 235551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 235553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235555 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235557 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235559 */     GIR_RootConstrainSelectedInstOperands,
     /* 235560 */     // GIR_Coverage, 2742,
     /* 235560 */     GIR_EraseRootFromParent_Done,
     /* 235561 */   // Label 4473: @235561
     /* 235561 */   GIM_Try, /*On fail goto*//*Label 4474*/ GIMT_Encode4(235603), // Rule ID 2743 //
     /* 235566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 235569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 235574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 235577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 235583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 235586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 235590 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1274:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 235590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 235593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 235595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235597 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235599 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235601 */     GIR_RootConstrainSelectedInstOperands,
     /* 235602 */     // GIR_Coverage, 2743,
     /* 235602 */     GIR_EraseRootFromParent_Done,
     /* 235603 */   // Label 4474: @235603
     /* 235603 */   GIM_Try, /*On fail goto*//*Label 4475*/ GIMT_Encode4(235645), // Rule ID 2744 //
     /* 235608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 235611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 235616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 235619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 235622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 235625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 235628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 235632 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1274:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 235632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 235635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 235637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235641 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235643 */     GIR_RootConstrainSelectedInstOperands,
     /* 235644 */     // GIR_Coverage, 2744,
     /* 235644 */     GIR_EraseRootFromParent_Done,
     /* 235645 */   // Label 4475: @235645
     /* 235645 */   GIM_Try, /*On fail goto*//*Label 4476*/ GIMT_Encode4(235687), // Rule ID 2783 //
     /* 235650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 235653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 235658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235674 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1373:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FADD_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 235674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_H),
     /* 235677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235681 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235683 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235685 */     GIR_RootConstrainSelectedInstOperands,
     /* 235686 */     // GIR_Coverage, 2783,
     /* 235686 */     GIR_EraseRootFromParent_Done,
     /* 235687 */   // Label 4476: @235687
     /* 235687 */   GIM_Try, /*On fail goto*//*Label 4477*/ GIMT_Encode4(235729), // Rule ID 2785 //
     /* 235692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 235695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 235700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235716 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1373:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FADD_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 235716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_S),
     /* 235719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235725 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235727 */     GIR_RootConstrainSelectedInstOperands,
     /* 235728 */     // GIR_Coverage, 2785,
     /* 235728 */     GIR_EraseRootFromParent_Done,
     /* 235729 */   // Label 4477: @235729
     /* 235729 */   GIM_Try, /*On fail goto*//*Label 4478*/ GIMT_Encode4(235771), // Rule ID 2787 //
     /* 235734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 235737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 235742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235758 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1373:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FADD_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 235758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_D),
     /* 235761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235765 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235767 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235769 */     GIR_RootConstrainSelectedInstOperands,
     /* 235770 */     // GIR_Coverage, 2787,
     /* 235770 */     GIR_EraseRootFromParent_Done,
     /* 235771 */   // Label 4478: @235771
     /* 235771 */   GIM_Try, /*On fail goto*//*Label 4479*/ GIMT_Encode4(235813), // Rule ID 2789 //
     /* 235776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 235779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 235784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235800 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1547:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (FSCALE_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_H),
     /* 235803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235807 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235809 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235811 */     GIR_RootConstrainSelectedInstOperands,
     /* 235812 */     // GIR_Coverage, 2789,
     /* 235812 */     GIR_EraseRootFromParent_Done,
     /* 235813 */   // Label 4479: @235813
     /* 235813 */   GIM_Try, /*On fail goto*//*Label 4480*/ GIMT_Encode4(235855), // Rule ID 2790 //
     /* 235818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 235821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 235826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235842 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1547:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (FSCALE_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_S),
     /* 235845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235849 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235851 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235853 */     GIR_RootConstrainSelectedInstOperands,
     /* 235854 */     // GIR_Coverage, 2790,
     /* 235854 */     GIR_EraseRootFromParent_Done,
     /* 235855 */   // Label 4480: @235855
     /* 235855 */   GIM_Try, /*On fail goto*//*Label 4481*/ GIMT_Encode4(235897), // Rule ID 2791 //
     /* 235860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 235863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 235868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235884 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1547:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (FSCALE_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_D),
     /* 235887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235891 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235893 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235895 */     GIR_RootConstrainSelectedInstOperands,
     /* 235896 */     // GIR_Coverage, 2791,
     /* 235896 */     GIR_EraseRootFromParent_Done,
     /* 235897 */   // Label 4481: @235897
     /* 235897 */   GIM_Try, /*On fail goto*//*Label 4482*/ GIMT_Encode4(235939), // Rule ID 2875 //
     /* 235902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtnt_f16f32),
     /* 235910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 235916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 235919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235926 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1409:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTNT_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 235926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNT_ZPmZ_StoH),
     /* 235929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235933 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235935 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235937 */     GIR_RootConstrainSelectedInstOperands,
     /* 235938 */     // GIR_Coverage, 2875,
     /* 235938 */     GIR_EraseRootFromParent_Done,
     /* 235939 */   // Label 4482: @235939
     /* 235939 */   GIM_Try, /*On fail goto*//*Label 4483*/ GIMT_Encode4(235981), // Rule ID 2876 //
     /* 235944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtnt_f32f64),
     /* 235952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 235958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 235961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235968 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1410:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTNT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 235968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNT_ZPmZ_DtoS),
     /* 235971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235977 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235979 */     GIR_RootConstrainSelectedInstOperands,
     /* 235980 */     // GIR_Coverage, 2876,
     /* 235980 */     GIR_EraseRootFromParent_Done,
     /* 235981 */   // Label 4483: @235981
     /* 235981 */   GIM_Try, /*On fail goto*//*Label 4484*/ GIMT_Encode4(236023), // Rule ID 2877 //
     /* 235986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtlt_f32f16),
     /* 235994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 236003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236010 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1405:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTLT_ZPmZ_HtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 236010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLT_ZPmZ_HtoS),
     /* 236013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236017 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236019 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236021 */     GIR_RootConstrainSelectedInstOperands,
     /* 236022 */     // GIR_Coverage, 2877,
     /* 236022 */     GIR_EraseRootFromParent_Done,
     /* 236023 */   // Label 4484: @236023
     /* 236023 */   GIM_Try, /*On fail goto*//*Label 4485*/ GIMT_Encode4(236065), // Rule ID 2878 //
     /* 236028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtlt_f64f32),
     /* 236036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 236042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 236045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236052 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1406:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTLT_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 236052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLT_ZPmZ_StoD),
     /* 236055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236059 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236061 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236063 */     GIR_RootConstrainSelectedInstOperands,
     /* 236064 */     // GIR_Coverage, 2878,
     /* 236064 */     GIR_EraseRootFromParent_Done,
     /* 236065 */   // Label 4485: @236065
     /* 236065 */   GIM_Try, /*On fail goto*//*Label 4486*/ GIMT_Encode4(236107), // Rule ID 2879 //
     /* 236070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtxnt_f32f64),
     /* 236078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 236087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236094 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1412:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTXNT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 236094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNT_ZPmZ_DtoS),
     /* 236097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236101 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236103 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236105 */     GIR_RootConstrainSelectedInstOperands,
     /* 236106 */     // GIR_Coverage, 2879,
     /* 236106 */     GIR_EraseRootFromParent_Done,
     /* 236107 */   // Label 4486: @236107
     /* 236107 */   GIM_Try, /*On fail goto*//*Label 4487*/ GIMT_Encode4(236149), // Rule ID 2880 //
     /* 236112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 236120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236136 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1376:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FADDP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 236136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_H),
     /* 236139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236143 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236145 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236147 */     GIR_RootConstrainSelectedInstOperands,
     /* 236148 */     // GIR_Coverage, 2880,
     /* 236148 */     GIR_EraseRootFromParent_Done,
     /* 236149 */   // Label 4487: @236149
     /* 236149 */   GIM_Try, /*On fail goto*//*Label 4488*/ GIMT_Encode4(236191), // Rule ID 2881 //
     /* 236154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 236162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236178 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1376:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FADDP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 236178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_S),
     /* 236181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236187 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236189 */     GIR_RootConstrainSelectedInstOperands,
     /* 236190 */     // GIR_Coverage, 2881,
     /* 236190 */     GIR_EraseRootFromParent_Done,
     /* 236191 */   // Label 4488: @236191
     /* 236191 */   GIM_Try, /*On fail goto*//*Label 4489*/ GIMT_Encode4(236233), // Rule ID 2882 //
     /* 236196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 236204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236220 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1376:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FADDP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 236220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_D),
     /* 236223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236227 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236229 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236231 */     GIR_RootConstrainSelectedInstOperands,
     /* 236232 */     // GIR_Coverage, 2882,
     /* 236232 */     GIR_EraseRootFromParent_Done,
     /* 236233 */   // Label 4489: @236233
     /* 236233 */   GIM_Try, /*On fail goto*//*Label 4490*/ GIMT_Encode4(236275), // Rule ID 2893 //
     /* 236238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f32f16),
     /* 236246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 236255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236262 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1398:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVT_ZPmZ_HtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 236262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_HtoS),
     /* 236265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236271 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236273 */     GIR_RootConstrainSelectedInstOperands,
     /* 236274 */     // GIR_Coverage, 2893,
     /* 236274 */     GIR_EraseRootFromParent_Done,
     /* 236275 */   // Label 4490: @236275
     /* 236275 */   GIM_Try, /*On fail goto*//*Label 4491*/ GIMT_Encode4(236317), // Rule ID 2895 //
     /* 236280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f16f32),
     /* 236288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 236294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 236297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236304 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1396:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVT_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 236304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_StoH),
     /* 236307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236311 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236313 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236315 */     GIR_RootConstrainSelectedInstOperands,
     /* 236316 */     // GIR_Coverage, 2895,
     /* 236316 */     GIR_EraseRootFromParent_Done,
     /* 236317 */   // Label 4491: @236317
     /* 236317 */   GIM_Try, /*On fail goto*//*Label 4492*/ GIMT_Encode4(236359), // Rule ID 2903 //
     /* 236322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 236330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 236336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 236339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236346 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1433:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FLOGB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 236346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_H),
     /* 236349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236355 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236357 */     GIR_RootConstrainSelectedInstOperands,
     /* 236358 */     // GIR_Coverage, 2903,
     /* 236358 */     GIR_EraseRootFromParent_Done,
     /* 236359 */   // Label 4492: @236359
     /* 236359 */   GIM_Try, /*On fail goto*//*Label 4493*/ GIMT_Encode4(236401), // Rule ID 2904 //
     /* 236364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 236372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 236381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236388 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1433:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FLOGB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 236388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_S),
     /* 236391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236395 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236397 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236399 */     GIR_RootConstrainSelectedInstOperands,
     /* 236400 */     // GIR_Coverage, 2904,
     /* 236400 */     GIR_EraseRootFromParent_Done,
     /* 236401 */   // Label 4493: @236401
     /* 236401 */   GIM_Try, /*On fail goto*//*Label 4494*/ GIMT_Encode4(236443), // Rule ID 2905 //
     /* 236406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 236414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 236420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 236423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236430 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1433:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FLOGB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 236430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_D),
     /* 236433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236437 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236439 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236441 */     GIR_RootConstrainSelectedInstOperands,
     /* 236442 */     // GIR_Coverage, 2905,
     /* 236442 */     GIR_EraseRootFromParent_Done,
     /* 236443 */   // Label 4494: @236443
     /* 236443 */   GIM_Try, /*On fail goto*//*Label 4495*/ GIMT_Encode4(236485), // Rule ID 2909 //
     /* 236448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtx_f32f64),
     /* 236456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 236465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236472 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1411:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTX_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 236472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTX_ZPmZ_DtoS),
     /* 236475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236481 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236483 */     GIR_RootConstrainSelectedInstOperands,
     /* 236484 */     // GIR_Coverage, 2909,
     /* 236484 */     GIR_EraseRootFromParent_Done,
     /* 236485 */   // Label 4495: @236485
     /* 236485 */   GIM_Try, /*On fail goto*//*Label 4496*/ GIMT_Encode4(236527), // Rule ID 2954 //
     /* 236490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdiv),
     /* 236498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236514 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1716:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SDIV_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIV_ZPmZ_S),
     /* 236517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236521 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236523 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236525 */     GIR_RootConstrainSelectedInstOperands,
     /* 236526 */     // GIR_Coverage, 2954,
     /* 236526 */     GIR_EraseRootFromParent_Done,
     /* 236527 */   // Label 4496: @236527
     /* 236527 */   GIM_Try, /*On fail goto*//*Label 4497*/ GIMT_Encode4(236569), // Rule ID 2955 //
     /* 236532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdiv),
     /* 236540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236556 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1716:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SDIV_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIV_ZPmZ_D),
     /* 236559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236565 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236567 */     GIR_RootConstrainSelectedInstOperands,
     /* 236568 */     // GIR_Coverage, 2955,
     /* 236568 */     GIR_EraseRootFromParent_Done,
     /* 236569 */   // Label 4497: @236569
     /* 236569 */   GIM_Try, /*On fail goto*//*Label 4498*/ GIMT_Encode4(236611), // Rule ID 2984 //
     /* 236574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 236582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 236588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236598 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1832:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRDMLAH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_B),
     /* 236601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236603 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236605 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236607 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236609 */     GIR_RootConstrainSelectedInstOperands,
     /* 236610 */     // GIR_Coverage, 2984,
     /* 236610 */     GIR_EraseRootFromParent_Done,
     /* 236611 */   // Label 4498: @236611
     /* 236611 */   GIM_Try, /*On fail goto*//*Label 4499*/ GIMT_Encode4(236653), // Rule ID 2985 //
     /* 236616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 236624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 236630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236640 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1832:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRDMLAH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_H),
     /* 236643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236647 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236649 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236651 */     GIR_RootConstrainSelectedInstOperands,
     /* 236652 */     // GIR_Coverage, 2985,
     /* 236652 */     GIR_EraseRootFromParent_Done,
     /* 236653 */   // Label 4499: @236653
     /* 236653 */   GIM_Try, /*On fail goto*//*Label 4500*/ GIMT_Encode4(236695), // Rule ID 2986 //
     /* 236658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 236666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236682 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1832:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRDMLAH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_S),
     /* 236685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236689 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236691 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236693 */     GIR_RootConstrainSelectedInstOperands,
     /* 236694 */     // GIR_Coverage, 2986,
     /* 236694 */     GIR_EraseRootFromParent_Done,
     /* 236695 */   // Label 4500: @236695
     /* 236695 */   GIM_Try, /*On fail goto*//*Label 4501*/ GIMT_Encode4(236737), // Rule ID 2987 //
     /* 236700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 236708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 236714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236724 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1832:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRDMLAH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_D),
     /* 236727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236733 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236735 */     GIR_RootConstrainSelectedInstOperands,
     /* 236736 */     // GIR_Coverage, 2987,
     /* 236736 */     GIR_EraseRootFromParent_Done,
     /* 236737 */   // Label 4501: @236737
     /* 236737 */   GIM_Try, /*On fail goto*//*Label 4502*/ GIMT_Encode4(236779), // Rule ID 2988 //
     /* 236742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 236750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 236756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236766 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1753:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_H),
     /* 236769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236773 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236775 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236777 */     GIR_RootConstrainSelectedInstOperands,
     /* 236778 */     // GIR_Coverage, 2988,
     /* 236778 */     GIR_EraseRootFromParent_Done,
     /* 236779 */   // Label 4502: @236779
     /* 236779 */   GIM_Try, /*On fail goto*//*Label 4503*/ GIMT_Encode4(236821), // Rule ID 2989 //
     /* 236784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 236792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236808 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1753:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_S),
     /* 236811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236815 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236817 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236819 */     GIR_RootConstrainSelectedInstOperands,
     /* 236820 */     // GIR_Coverage, 2989,
     /* 236820 */     GIR_EraseRootFromParent_Done,
     /* 236821 */   // Label 4503: @236821
     /* 236821 */   GIM_Try, /*On fail goto*//*Label 4504*/ GIMT_Encode4(236863), // Rule ID 2990 //
     /* 236826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 236834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 236840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236850 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1753:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_D),
     /* 236853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236857 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236859 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236861 */     GIR_RootConstrainSelectedInstOperands,
     /* 236862 */     // GIR_Coverage, 2990,
     /* 236862 */     GIR_EraseRootFromParent_Done,
     /* 236863 */   // Label 4504: @236863
     /* 236863 */   GIM_Try, /*On fail goto*//*Label 4505*/ GIMT_Encode4(236905), // Rule ID 3020 //
     /* 236868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 236876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 236882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236892 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1727:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_B),
     /* 236895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236899 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236901 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236903 */     GIR_RootConstrainSelectedInstOperands,
     /* 236904 */     // GIR_Coverage, 3020,
     /* 236904 */     GIR_EraseRootFromParent_Done,
     /* 236905 */   // Label 4505: @236905
     /* 236905 */   GIM_Try, /*On fail goto*//*Label 4506*/ GIMT_Encode4(236947), // Rule ID 3022 //
     /* 236910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 236918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236934 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1727:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_H),
     /* 236937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236941 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236943 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236945 */     GIR_RootConstrainSelectedInstOperands,
     /* 236946 */     // GIR_Coverage, 3022,
     /* 236946 */     GIR_EraseRootFromParent_Done,
     /* 236947 */   // Label 4506: @236947
     /* 236947 */   GIM_Try, /*On fail goto*//*Label 4507*/ GIMT_Encode4(236989), // Rule ID 3024 //
     /* 236952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 236960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236976 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1727:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_S),
     /* 236979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236985 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236987 */     GIR_RootConstrainSelectedInstOperands,
     /* 236988 */     // GIR_Coverage, 3024,
     /* 236988 */     GIR_EraseRootFromParent_Done,
     /* 236989 */   // Label 4507: @236989
     /* 236989 */   GIM_Try, /*On fail goto*//*Label 4508*/ GIMT_Encode4(237031), // Rule ID 3026 //
     /* 236994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 237002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 237008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237018 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1727:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_D),
     /* 237021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237025 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237027 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237029 */     GIR_RootConstrainSelectedInstOperands,
     /* 237030 */     // GIR_Coverage, 3026,
     /* 237030 */     GIR_EraseRootFromParent_Done,
     /* 237031 */   // Label 4508: @237031
     /* 237031 */   GIM_Try, /*On fail goto*//*Label 4509*/ GIMT_Encode4(237073), // Rule ID 3028 //
     /* 237036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 237044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 237050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237060 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1697:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SADALP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_H),
     /* 237063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237069 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237071 */     GIR_RootConstrainSelectedInstOperands,
     /* 237072 */     // GIR_Coverage, 3028,
     /* 237072 */     GIR_EraseRootFromParent_Done,
     /* 237073 */   // Label 4509: @237073
     /* 237073 */   GIM_Try, /*On fail goto*//*Label 4510*/ GIMT_Encode4(237115), // Rule ID 3029 //
     /* 237078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 237086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 237092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237102 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1697:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SADALP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_S),
     /* 237105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237111 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237113 */     GIR_RootConstrainSelectedInstOperands,
     /* 237114 */     // GIR_Coverage, 3029,
     /* 237114 */     GIR_EraseRootFromParent_Done,
     /* 237115 */   // Label 4510: @237115
     /* 237115 */   GIM_Try, /*On fail goto*//*Label 4511*/ GIMT_Encode4(237157), // Rule ID 3030 //
     /* 237120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 237128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 237134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237144 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1697:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SADALP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_D),
     /* 237147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237153 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237155 */     GIR_RootConstrainSelectedInstOperands,
     /* 237156 */     // GIR_Coverage, 3030,
     /* 237156 */     GIR_EraseRootFromParent_Done,
     /* 237157 */   // Label 4511: @237157
     /* 237157 */   GIM_Try, /*On fail goto*//*Label 4512*/ GIMT_Encode4(237199), // Rule ID 3031 //
     /* 237162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urecpe),
     /* 237170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 237179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237186 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2056:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URECPE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPE_ZPmZ_S),
     /* 237189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237195 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237197 */     GIR_RootConstrainSelectedInstOperands,
     /* 237198 */     // GIR_Coverage, 3031,
     /* 237198 */     GIR_EraseRootFromParent_Done,
     /* 237199 */   // Label 4512: @237199
     /* 237199 */   GIM_Try, /*On fail goto*//*Label 4513*/ GIMT_Encode4(237241), // Rule ID 3032 //
     /* 237204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 237212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 237218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 237221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237228 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1769:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQABS_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_B),
     /* 237231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237237 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237239 */     GIR_RootConstrainSelectedInstOperands,
     /* 237240 */     // GIR_Coverage, 3032,
     /* 237240 */     GIR_EraseRootFromParent_Done,
     /* 237241 */   // Label 4513: @237241
     /* 237241 */   GIM_Try, /*On fail goto*//*Label 4514*/ GIMT_Encode4(237283), // Rule ID 3033 //
     /* 237246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 237254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 237263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237270 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1769:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQABS_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_H),
     /* 237273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237277 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237279 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237281 */     GIR_RootConstrainSelectedInstOperands,
     /* 237282 */     // GIR_Coverage, 3033,
     /* 237282 */     GIR_EraseRootFromParent_Done,
     /* 237283 */   // Label 4514: @237283
     /* 237283 */   GIM_Try, /*On fail goto*//*Label 4515*/ GIMT_Encode4(237325), // Rule ID 3034 //
     /* 237288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 237296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 237305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237312 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1769:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQABS_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_S),
     /* 237315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237319 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237321 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237323 */     GIR_RootConstrainSelectedInstOperands,
     /* 237324 */     // GIR_Coverage, 3034,
     /* 237324 */     GIR_EraseRootFromParent_Done,
     /* 237325 */   // Label 4515: @237325
     /* 237325 */   GIM_Try, /*On fail goto*//*Label 4516*/ GIMT_Encode4(237367), // Rule ID 3035 //
     /* 237330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 237338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 237347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237354 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1769:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQABS_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_D),
     /* 237357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237361 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237363 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237365 */     GIR_RootConstrainSelectedInstOperands,
     /* 237366 */     // GIR_Coverage, 3035,
     /* 237366 */     GIR_EraseRootFromParent_Done,
     /* 237367 */   // Label 4516: @237367
     /* 237367 */   GIM_Try, /*On fail goto*//*Label 4517*/ GIMT_Encode4(237409), // Rule ID 3052 //
     /* 237372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 237380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 237386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237396 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1362:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EORBT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_B),
     /* 237399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237405 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237407 */     GIR_RootConstrainSelectedInstOperands,
     /* 237408 */     // GIR_Coverage, 3052,
     /* 237408 */     GIR_EraseRootFromParent_Done,
     /* 237409 */   // Label 4517: @237409
     /* 237409 */   GIM_Try, /*On fail goto*//*Label 4518*/ GIMT_Encode4(237451), // Rule ID 3053 //
     /* 237414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 237422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237438 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1362:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EORBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_H),
     /* 237441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237447 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237449 */     GIR_RootConstrainSelectedInstOperands,
     /* 237450 */     // GIR_Coverage, 3053,
     /* 237450 */     GIR_EraseRootFromParent_Done,
     /* 237451 */   // Label 4518: @237451
     /* 237451 */   GIM_Try, /*On fail goto*//*Label 4519*/ GIMT_Encode4(237493), // Rule ID 3054 //
     /* 237456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 237464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237480 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1362:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EORBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_S),
     /* 237483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237489 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237491 */     GIR_RootConstrainSelectedInstOperands,
     /* 237492 */     // GIR_Coverage, 3054,
     /* 237492 */     GIR_EraseRootFromParent_Done,
     /* 237493 */   // Label 4519: @237493
     /* 237493 */   GIM_Try, /*On fail goto*//*Label 4520*/ GIMT_Encode4(237535), // Rule ID 3055 //
     /* 237498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 237506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237522 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1362:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EORBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_D),
     /* 237525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237531 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237533 */     GIR_RootConstrainSelectedInstOperands,
     /* 237534 */     // GIR_Coverage, 3055,
     /* 237534 */     GIR_EraseRootFromParent_Done,
     /* 237535 */   // Label 4520: @237535
     /* 237535 */   GIM_Try, /*On fail goto*//*Label 4521*/ GIMT_Encode4(237577), // Rule ID 3079 //
     /* 237540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 237548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 237554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237564 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1690:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABA_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_B),
     /* 237567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237571 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237573 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237575 */     GIR_RootConstrainSelectedInstOperands,
     /* 237576 */     // GIR_Coverage, 3079,
     /* 237576 */     GIR_EraseRootFromParent_Done,
     /* 237577 */   // Label 4521: @237577
     /* 237577 */   GIM_Try, /*On fail goto*//*Label 4522*/ GIMT_Encode4(237619), // Rule ID 3081 //
     /* 237582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 237590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237606 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1690:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABA_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_H),
     /* 237609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237615 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237617 */     GIR_RootConstrainSelectedInstOperands,
     /* 237618 */     // GIR_Coverage, 3081,
     /* 237618 */     GIR_EraseRootFromParent_Done,
     /* 237619 */   // Label 4522: @237619
     /* 237619 */   GIM_Try, /*On fail goto*//*Label 4523*/ GIMT_Encode4(237661), // Rule ID 3083 //
     /* 237624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 237632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237648 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1690:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABA_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_S),
     /* 237651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237655 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237657 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237659 */     GIR_RootConstrainSelectedInstOperands,
     /* 237660 */     // GIR_Coverage, 3083,
     /* 237660 */     GIR_EraseRootFromParent_Done,
     /* 237661 */   // Label 4523: @237661
     /* 237661 */   GIM_Try, /*On fail goto*//*Label 4524*/ GIMT_Encode4(237703), // Rule ID 3085 //
     /* 237666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 237674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237690 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1690:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SABA_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_D),
     /* 237693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237699 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237701 */     GIR_RootConstrainSelectedInstOperands,
     /* 237702 */     // GIR_Coverage, 3085,
     /* 237702 */     GIR_EraseRootFromParent_Done,
     /* 237703 */   // Label 4524: @237703
     /* 237703 */   GIM_Try, /*On fail goto*//*Label 4525*/ GIMT_Encode4(237745), // Rule ID 3087 //
     /* 237708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 237716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237732 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1691:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_H),
     /* 237735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237739 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237741 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237743 */     GIR_RootConstrainSelectedInstOperands,
     /* 237744 */     // GIR_Coverage, 3087,
     /* 237744 */     GIR_EraseRootFromParent_Done,
     /* 237745 */   // Label 4525: @237745
     /* 237745 */   GIM_Try, /*On fail goto*//*Label 4526*/ GIMT_Encode4(237787), // Rule ID 3088 //
     /* 237750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 237758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237774 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1691:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_S),
     /* 237777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237781 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237783 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237785 */     GIR_RootConstrainSelectedInstOperands,
     /* 237786 */     // GIR_Coverage, 3088,
     /* 237786 */     GIR_EraseRootFromParent_Done,
     /* 237787 */   // Label 4526: @237787
     /* 237787 */   GIM_Try, /*On fail goto*//*Label 4527*/ GIMT_Encode4(237829), // Rule ID 3089 //
     /* 237792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 237800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237816 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1691:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_D),
     /* 237819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237825 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237827 */     GIR_RootConstrainSelectedInstOperands,
     /* 237828 */     // GIR_Coverage, 3089,
     /* 237828 */     GIR_EraseRootFromParent_Done,
     /* 237829 */   // Label 4527: @237829
     /* 237829 */   GIM_Try, /*On fail goto*//*Label 4528*/ GIMT_Encode4(237871), // Rule ID 3090 //
     /* 237834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclb),
     /* 237842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237858 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1254:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADCLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLB_ZZZ_S),
     /* 237861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237867 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237869 */     GIR_RootConstrainSelectedInstOperands,
     /* 237870 */     // GIR_Coverage, 3090,
     /* 237870 */     GIR_EraseRootFromParent_Done,
     /* 237871 */   // Label 4528: @237871
     /* 237871 */   GIM_Try, /*On fail goto*//*Label 4529*/ GIMT_Encode4(237913), // Rule ID 3091 //
     /* 237876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclb),
     /* 237884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237900 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1254:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADCLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLB_ZZZ_D),
     /* 237903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237907 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237909 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237911 */     GIR_RootConstrainSelectedInstOperands,
     /* 237912 */     // GIR_Coverage, 3091,
     /* 237912 */     GIR_EraseRootFromParent_Done,
     /* 237913 */   // Label 4529: @237913
     /* 237913 */   GIM_Try, /*On fail goto*//*Label 4530*/ GIMT_Encode4(237955), // Rule ID 3101 //
     /* 237918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 237926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 237932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237942 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1261:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ADDHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_B),
     /* 237945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237951 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237953 */     GIR_RootConstrainSelectedInstOperands,
     /* 237954 */     // GIR_Coverage, 3101,
     /* 237954 */     GIR_EraseRootFromParent_Done,
     /* 237955 */   // Label 4530: @237955
     /* 237955 */   GIM_Try, /*On fail goto*//*Label 4531*/ GIMT_Encode4(237997), // Rule ID 3102 //
     /* 237960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 237968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237984 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1261:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADDHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_H),
     /* 237987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237993 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237995 */     GIR_RootConstrainSelectedInstOperands,
     /* 237996 */     // GIR_Coverage, 3102,
     /* 237996 */     GIR_EraseRootFromParent_Done,
     /* 237997 */   // Label 4531: @237997
     /* 237997 */   GIM_Try, /*On fail goto*//*Label 4532*/ GIMT_Encode4(238039), // Rule ID 3103 //
     /* 238002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 238010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238026 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1261:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADDHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_S),
     /* 238029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238035 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238037 */     GIR_RootConstrainSelectedInstOperands,
     /* 238038 */     // GIR_Coverage, 3103,
     /* 238038 */     GIR_EraseRootFromParent_Done,
     /* 238039 */   // Label 4532: @238039
     /* 238039 */   GIM_Try, /*On fail goto*//*Label 4533*/ GIMT_Encode4(238081), // Rule ID 3120 //
     /* 238044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 238052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 238058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 238061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238068 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1320:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CLS_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 238068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_B),
     /* 238071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 238075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 238077 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 238079 */     GIR_RootConstrainSelectedInstOperands,
     /* 238080 */     // GIR_Coverage, 3120,
     /* 238080 */     GIR_EraseRootFromParent_Done,
     /* 238081 */   // Label 4533: @238081
     /* 238081 */   GIM_Try, /*On fail goto*//*Label 4534*/ GIMT_Encode4(238123), // Rule ID 3121 //
     /* 238086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 238094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 238100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 238103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238110 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1320:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CLS_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 238110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_H),
     /* 238113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 238117 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 238119 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 238121 */     GIR_RootConstrainSelectedInstOperands,
     /* 238122 */     // GIR_Coverage, 3121,
     /* 238122 */     GIR_EraseRootFromParent_Done,
     /* 238123 */   // Label 4534: @238123
     /* 238123 */   GIM_Try, /*On fail goto*//*Label 4535*/ GIMT_Encode4(238165), // Rule ID 3122 //
     /* 238128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 238136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 238145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238152 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1320:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CLS_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 238152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_S),
     /* 238155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 238159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 238161 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 238163 */     GIR_RootConstrainSelectedInstOperands,
     /* 238164 */     // GIR_Coverage, 3122,
     /* 238164 */     GIR_EraseRootFromParent_Done,
     /* 238165 */   // Label 4535: @238165
     /* 238165 */   GIM_Try, /*On fail goto*//*Label 4536*/ GIMT_Encode4(238207), // Rule ID 3123 //
     /* 238170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 238178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 238187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238194 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1320:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CLS_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 238194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_D),
     /* 238197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 238201 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 238203 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 238205 */     GIR_RootConstrainSelectedInstOperands,
     /* 238206 */     // GIR_Coverage, 3123,
     /* 238206 */     GIR_EraseRootFromParent_Done,
     /* 238207 */   // Label 4536: @238207
     /* 238207 */   GIM_Try, /*On fail goto*//*Label 4537*/ GIMT_Encode4(238249), // Rule ID 3158 //
     /* 238212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 238220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 238226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238236 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1361:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 238239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238245 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238247 */     GIR_RootConstrainSelectedInstOperands,
     /* 238248 */     // GIR_Coverage, 3158,
     /* 238248 */     GIR_EraseRootFromParent_Done,
     /* 238249 */   // Label 4537: @238249
     /* 238249 */   GIM_Try, /*On fail goto*//*Label 4538*/ GIMT_Encode4(238291), // Rule ID 3160 //
     /* 238254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 238262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 238268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238278 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1361:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 238281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238287 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238289 */     GIR_RootConstrainSelectedInstOperands,
     /* 238290 */     // GIR_Coverage, 3160,
     /* 238290 */     GIR_EraseRootFromParent_Done,
     /* 238291 */   // Label 4538: @238291
     /* 238291 */   GIM_Try, /*On fail goto*//*Label 4539*/ GIMT_Encode4(238333), // Rule ID 3162 //
     /* 238296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 238304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238320 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1361:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 238323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238327 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238329 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238331 */     GIR_RootConstrainSelectedInstOperands,
     /* 238332 */     // GIR_Coverage, 3162,
     /* 238332 */     GIR_EraseRootFromParent_Done,
     /* 238333 */   // Label 4539: @238333
     /* 238333 */   GIM_Try, /*On fail goto*//*Label 4540*/ GIMT_Encode4(238375), // Rule ID 3164 //
     /* 238338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 238346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238362 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1361:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 238365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238371 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238373 */     GIR_RootConstrainSelectedInstOperands,
     /* 238374 */     // GIR_Coverage, 3164,
     /* 238374 */     GIR_EraseRootFromParent_Done,
     /* 238375 */   // Label 4540: @238375
     /* 238375 */   GIM_Try, /*On fail goto*//*Label 4541*/ GIMT_Encode4(238420), // Rule ID 3203 //
     /* 238380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 238388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 238391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 238394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 238404 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1325:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_B),
     /* 238407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 238409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238413 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238415 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 238418 */     GIR_RootConstrainSelectedInstOperands,
     /* 238419 */     // GIR_Coverage, 3203,
     /* 238419 */     GIR_EraseRootFromParent_Done,
     /* 238420 */   // Label 4541: @238420
     /* 238420 */   GIM_Try, /*On fail goto*//*Label 4542*/ GIMT_Encode4(238465), // Rule ID 3204 //
     /* 238425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 238433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 238436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 238449 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1325:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_H),
     /* 238452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 238454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238458 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238460 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 238463 */     GIR_RootConstrainSelectedInstOperands,
     /* 238464 */     // GIR_Coverage, 3204,
     /* 238464 */     GIR_EraseRootFromParent_Done,
     /* 238465 */   // Label 4542: @238465
     /* 238465 */   GIM_Try, /*On fail goto*//*Label 4543*/ GIMT_Encode4(238510), // Rule ID 3205 //
     /* 238470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 238478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 238481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 238494 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1325:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_S),
     /* 238497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 238499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238503 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238505 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 238508 */     GIR_RootConstrainSelectedInstOperands,
     /* 238509 */     // GIR_Coverage, 3205,
     /* 238509 */     GIR_EraseRootFromParent_Done,
     /* 238510 */   // Label 4543: @238510
     /* 238510 */   GIM_Try, /*On fail goto*//*Label 4544*/ GIMT_Encode4(238555), // Rule ID 3206 //
     /* 238515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 238523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 238526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 238529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 238539 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1327:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_B),
     /* 238542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 238544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238548 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238550 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 238553 */     GIR_RootConstrainSelectedInstOperands,
     /* 238554 */     // GIR_Coverage, 3206,
     /* 238554 */     GIR_EraseRootFromParent_Done,
     /* 238555 */   // Label 4544: @238555
     /* 238555 */   GIM_Try, /*On fail goto*//*Label 4545*/ GIMT_Encode4(238600), // Rule ID 3207 //
     /* 238560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 238568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 238571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 238584 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1327:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_H),
     /* 238587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 238589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238591 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238593 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238595 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 238598 */     GIR_RootConstrainSelectedInstOperands,
     /* 238599 */     // GIR_Coverage, 3207,
     /* 238599 */     GIR_EraseRootFromParent_Done,
     /* 238600 */   // Label 4545: @238600
     /* 238600 */   GIM_Try, /*On fail goto*//*Label 4546*/ GIMT_Encode4(238645), // Rule ID 3208 //
     /* 238605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 238613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 238616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 238629 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1327:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_S),
     /* 238632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 238634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238638 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238640 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 238643 */     GIR_RootConstrainSelectedInstOperands,
     /* 238644 */     // GIR_Coverage, 3208,
     /* 238644 */     GIR_EraseRootFromParent_Done,
     /* 238645 */   // Label 4546: @238645
     /* 238645 */   GIM_Try, /*On fail goto*//*Label 4547*/ GIMT_Encode4(238687), // Rule ID 3263 //
     /* 238650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 238658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 238661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 238674 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1371:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FACGE_PPzZZ_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 238674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_H),
     /* 238677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 238679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238681 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238683 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238685 */     GIR_RootConstrainSelectedInstOperands,
     /* 238686 */     // GIR_Coverage, 3263,
     /* 238686 */     GIR_EraseRootFromParent_Done,
     /* 238687 */   // Label 4547: @238687
     /* 238687 */   GIM_Try, /*On fail goto*//*Label 4548*/ GIMT_Encode4(238729), // Rule ID 3264 //
     /* 238692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 238700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 238703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 238716 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1371:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FACGE_PPzZZ_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 238716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_S),
     /* 238719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 238721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238725 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238727 */     GIR_RootConstrainSelectedInstOperands,
     /* 238728 */     // GIR_Coverage, 3264,
     /* 238728 */     GIR_EraseRootFromParent_Done,
     /* 238729 */   // Label 4548: @238729
     /* 238729 */   GIM_Try, /*On fail goto*//*Label 4549*/ GIMT_Encode4(238771), // Rule ID 3265 //
     /* 238734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 238742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 238745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 238748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 238758 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1371:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FACGE_PPzZZ_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 238758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_D),
     /* 238761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 238763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238765 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238767 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238769 */     GIR_RootConstrainSelectedInstOperands,
     /* 238770 */     // GIR_Coverage, 3265,
     /* 238770 */     GIR_EraseRootFromParent_Done,
     /* 238771 */   // Label 4549: @238771
     /* 238771 */   GIM_Try, /*On fail goto*//*Label 4550*/ GIMT_Encode4(238813), // Rule ID 3317 //
     /* 238776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 238784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 238790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238800 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1277:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (ASR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_B),
     /* 238803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238807 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238809 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238811 */     GIR_RootConstrainSelectedInstOperands,
     /* 238812 */     // GIR_Coverage, 3317,
     /* 238812 */     GIR_EraseRootFromParent_Done,
     /* 238813 */   // Label 4550: @238813
     /* 238813 */   GIM_Try, /*On fail goto*//*Label 4551*/ GIMT_Encode4(238855), // Rule ID 3318 //
     /* 238818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 238826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238842 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1277:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ASR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_H),
     /* 238845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238849 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238851 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238853 */     GIR_RootConstrainSelectedInstOperands,
     /* 238854 */     // GIR_Coverage, 3318,
     /* 238854 */     GIR_EraseRootFromParent_Done,
     /* 238855 */   // Label 4551: @238855
     /* 238855 */   GIM_Try, /*On fail goto*//*Label 4552*/ GIMT_Encode4(238897), // Rule ID 3319 //
     /* 238860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 238868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238884 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1277:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ASR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_S),
     /* 238887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238891 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238893 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238895 */     GIR_RootConstrainSelectedInstOperands,
     /* 238896 */     // GIR_Coverage, 3319,
     /* 238896 */     GIR_EraseRootFromParent_Done,
     /* 238897 */   // Label 4552: @238897
     /* 238897 */   GIM_Try, /*On fail goto*//*Label 4553*/ GIMT_Encode4(238939), // Rule ID 3320 //
     /* 238902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 238910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 238916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238926 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1277:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_D),
     /* 238929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238933 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238935 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238937 */     GIR_RootConstrainSelectedInstOperands,
     /* 238938 */     // GIR_Coverage, 3320,
     /* 238938 */     GIR_EraseRootFromParent_Done,
     /* 238939 */   // Label 4553: @238939
     /* 238939 */   GIM_Try, /*On fail goto*//*Label 4554*/ GIMT_Encode4(238981), // Rule ID 3329 //
     /* 238944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 238952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 238958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238968 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1279:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_B),
     /* 238971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238977 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238979 */     GIR_RootConstrainSelectedInstOperands,
     /* 238980 */     // GIR_Coverage, 3329,
     /* 238980 */     GIR_EraseRootFromParent_Done,
     /* 238981 */   // Label 4554: @238981
     /* 238981 */   GIM_Try, /*On fail goto*//*Label 4555*/ GIMT_Encode4(239023), // Rule ID 3330 //
     /* 238986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 238994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 239000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239010 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1279:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_H),
     /* 239013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239017 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239019 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239021 */     GIR_RootConstrainSelectedInstOperands,
     /* 239022 */     // GIR_Coverage, 3330,
     /* 239022 */     GIR_EraseRootFromParent_Done,
     /* 239023 */   // Label 4555: @239023
     /* 239023 */   GIM_Try, /*On fail goto*//*Label 4556*/ GIMT_Encode4(239065), // Rule ID 3331 //
     /* 239028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 239036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 239042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239052 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1279:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_S),
     /* 239055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239059 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239061 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239063 */     GIR_RootConstrainSelectedInstOperands,
     /* 239064 */     // GIR_Coverage, 3331,
     /* 239064 */     GIR_EraseRootFromParent_Done,
     /* 239065 */   // Label 4556: @239065
     /* 239065 */   GIM_Try, /*On fail goto*//*Label 4557*/ GIMT_Encode4(239107), // Rule ID 3370 //
     /* 239070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 239078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 239084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239094 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1316:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (CLASTA_ZPZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_B),
     /* 239097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239101 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239103 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239105 */     GIR_RootConstrainSelectedInstOperands,
     /* 239106 */     // GIR_Coverage, 3370,
     /* 239106 */     GIR_EraseRootFromParent_Done,
     /* 239107 */   // Label 4557: @239107
     /* 239107 */   GIM_Try, /*On fail goto*//*Label 4558*/ GIMT_Encode4(239149), // Rule ID 3371 //
     /* 239112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 239120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 239126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239136 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1316:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (CLASTA_ZPZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_H),
     /* 239139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239143 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239145 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239147 */     GIR_RootConstrainSelectedInstOperands,
     /* 239148 */     // GIR_Coverage, 3371,
     /* 239148 */     GIR_EraseRootFromParent_Done,
     /* 239149 */   // Label 4558: @239149
     /* 239149 */   GIM_Try, /*On fail goto*//*Label 4559*/ GIMT_Encode4(239191), // Rule ID 3372 //
     /* 239154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 239162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 239168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239178 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1316:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (CLASTA_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_S),
     /* 239181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239187 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239189 */     GIR_RootConstrainSelectedInstOperands,
     /* 239190 */     // GIR_Coverage, 3372,
     /* 239190 */     GIR_EraseRootFromParent_Done,
     /* 239191 */   // Label 4559: @239191
     /* 239191 */   GIM_Try, /*On fail goto*//*Label 4560*/ GIMT_Encode4(239233), // Rule ID 3373 //
     /* 239196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 239204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 239210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239220 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1316:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CLASTA_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_D),
     /* 239223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239227 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239229 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239231 */     GIR_RootConstrainSelectedInstOperands,
     /* 239232 */     // GIR_Coverage, 3373,
     /* 239232 */     GIR_EraseRootFromParent_Done,
     /* 239233 */   // Label 4560: @239233
     /* 239233 */   GIM_Try, /*On fail goto*//*Label 4561*/ GIMT_Encode4(239275), // Rule ID 3374 //
     /* 239238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 239246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 239252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239262 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1316:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (CLASTA_ZPZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 239262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_H),
     /* 239265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239271 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239273 */     GIR_RootConstrainSelectedInstOperands,
     /* 239274 */     // GIR_Coverage, 3374,
     /* 239274 */     GIR_EraseRootFromParent_Done,
     /* 239275 */   // Label 4561: @239275
     /* 239275 */   GIM_Try, /*On fail goto*//*Label 4562*/ GIMT_Encode4(239317), // Rule ID 3375 //
     /* 239280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 239288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 239294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239304 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1316:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (CLASTA_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 239304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_S),
     /* 239307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239311 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239313 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239315 */     GIR_RootConstrainSelectedInstOperands,
     /* 239316 */     // GIR_Coverage, 3375,
     /* 239316 */     GIR_EraseRootFromParent_Done,
     /* 239317 */   // Label 4562: @239317
     /* 239317 */   GIM_Try, /*On fail goto*//*Label 4563*/ GIMT_Encode4(239359), // Rule ID 3376 //
     /* 239322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 239330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 239336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239346 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1316:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (CLASTA_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 239346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_D),
     /* 239349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239355 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239357 */     GIR_RootConstrainSelectedInstOperands,
     /* 239358 */     // GIR_Coverage, 3376,
     /* 239358 */     GIR_EraseRootFromParent_Done,
     /* 239359 */   // Label 4563: @239359
     /* 239359 */   GIM_Try, /*On fail goto*//*Label 4564*/ GIMT_Encode4(239401), // Rule ID 3462 //
     /* 239364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkpa_z),
     /* 239372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 239375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 239378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 239381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 239384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 239388 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1308:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKPA_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 239388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKPA_PPzPP),
     /* 239391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 239393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239395 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239397 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239399 */     GIR_RootConstrainSelectedInstOperands,
     /* 239400 */     // GIR_Coverage, 3462,
     /* 239400 */     GIR_EraseRootFromParent_Done,
     /* 239401 */   // Label 4564: @239401
     /* 239401 */   GIM_Try, /*On fail goto*//*Label 4565*/ GIMT_Encode4(239443), // Rule ID 3463 //
     /* 239406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkn_z),
     /* 239414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 239417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 239420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 239423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 239426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 239430 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1307:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKN_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 239430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKN_PPzP),
     /* 239433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdm]
     /* 239435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239437 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239439 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239441 */     GIR_RootConstrainSelectedInstOperands,
     /* 239442 */     // GIR_Coverage, 3463,
     /* 239442 */     GIR_EraseRootFromParent_Done,
     /* 239443 */   // Label 4565: @239443
     /* 239443 */   GIM_Try, /*On fail goto*//*Label 4566*/ GIMT_Encode4(239485), // Rule ID 3464 //
     /* 239448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brka),
     /* 239456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 239459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 239462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 239465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 239468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 239472 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1303:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKA_PPmP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 239472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKA_PPmP),
     /* 239475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 239477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239481 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239483 */     GIR_RootConstrainSelectedInstOperands,
     /* 239484 */     // GIR_Coverage, 3464,
     /* 239484 */     GIR_EraseRootFromParent_Done,
     /* 239485 */   // Label 4566: @239485
     /* 239485 */   GIM_Try, /*On fail goto*//*Label 4567*/ GIMT_Encode4(239530), // Rule ID 3466 //
     /* 239490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 239493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_match),
     /* 239498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 239501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 239504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 239514 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1610:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (MATCH_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MATCH_PPzZZ_B),
     /* 239517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 239519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239521 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239523 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239525 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 239528 */     GIR_RootConstrainSelectedInstOperands,
     /* 239529 */     // GIR_Coverage, 3466,
     /* 239529 */     GIR_EraseRootFromParent_Done,
     /* 239530 */   // Label 4567: @239530
     /* 239530 */   GIM_Try, /*On fail goto*//*Label 4568*/ GIMT_Encode4(239575), // Rule ID 3467 //
     /* 239535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 239538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_match),
     /* 239543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 239546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 239549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 239559 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1610:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (MATCH_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MATCH_PPzZZ_H),
     /* 239562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 239564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239566 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239568 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239570 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 239573 */     GIR_RootConstrainSelectedInstOperands,
     /* 239574 */     // GIR_Coverage, 3467,
     /* 239574 */     GIR_EraseRootFromParent_Done,
     /* 239575 */   // Label 4568: @239575
     /* 239575 */   GIM_Try, /*On fail goto*//*Label 4569*/ GIMT_Encode4(239617), // Rule ID 3468 //
     /* 239580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 239583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histcnt),
     /* 239588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 239594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239604 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1555:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (HISTCNT_ZPzZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTCNT_ZPzZZ_S),
     /* 239607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239611 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239613 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239615 */     GIR_RootConstrainSelectedInstOperands,
     /* 239616 */     // GIR_Coverage, 3468,
     /* 239616 */     GIR_EraseRootFromParent_Done,
     /* 239617 */   // Label 4569: @239617
     /* 239617 */   GIM_Try, /*On fail goto*//*Label 4570*/ GIMT_Encode4(239659), // Rule ID 3469 //
     /* 239622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 239625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histcnt),
     /* 239630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 239636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239646 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1555:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (HISTCNT_ZPzZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTCNT_ZPzZZ_D),
     /* 239649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239655 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239657 */     GIR_RootConstrainSelectedInstOperands,
     /* 239658 */     // GIR_Coverage, 3469,
     /* 239658 */     GIR_EraseRootFromParent_Done,
     /* 239659 */   // Label 4570: @239659
     /* 239659 */   GIM_Try, /*On fail goto*//*Label 4571*/ GIMT_Encode4(239701), // Rule ID 3473 //
     /* 239664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 239667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smmla),
     /* 239672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239688 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1761:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMMLA_ZZZ),
     /* 239691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239695 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239697 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239699 */     GIR_RootConstrainSelectedInstOperands,
     /* 239700 */     // GIR_Coverage, 3473,
     /* 239700 */     GIR_EraseRootFromParent_Done,
     /* 239701 */   // Label 4571: @239701
     /* 239701 */   GIM_Try, /*On fail goto*//*Label 4572*/ GIMT_Encode4(239743), // Rule ID 3518 //
     /* 239706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 239709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 239714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239730 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1384:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCLAMP_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 239730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_H),
     /* 239733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239737 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239739 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239741 */     GIR_RootConstrainSelectedInstOperands,
     /* 239742 */     // GIR_Coverage, 3518,
     /* 239742 */     GIR_EraseRootFromParent_Done,
     /* 239743 */   // Label 4572: @239743
     /* 239743 */   GIM_Try, /*On fail goto*//*Label 4573*/ GIMT_Encode4(239785), // Rule ID 3520 //
     /* 239748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 239751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 239756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239772 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1384:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCLAMP_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 239772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_S),
     /* 239775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239779 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239781 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239783 */     GIR_RootConstrainSelectedInstOperands,
     /* 239784 */     // GIR_Coverage, 3520,
     /* 239784 */     GIR_EraseRootFromParent_Done,
     /* 239785 */   // Label 4573: @239785
     /* 239785 */   GIM_Try, /*On fail goto*//*Label 4574*/ GIMT_Encode4(239827), // Rule ID 3522 //
     /* 239790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 239793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 239798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239814 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1384:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCLAMP_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 239814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_D),
     /* 239817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239823 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239825 */     GIR_RootConstrainSelectedInstOperands,
     /* 239826 */     // GIR_Coverage, 3522,
     /* 239826 */     GIR_EraseRootFromParent_Done,
     /* 239827 */   // Label 4574: @239827
     /* 239827 */   GIM_Try, /*On fail goto*//*Label 4575*/ GIMT_Encode4(239869), // Rule ID 3524 //
     /* 239832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 239835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_x2),
     /* 239840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239856 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1722:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SDOT_ZZZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_HtoS),
     /* 239859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239865 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239867 */     GIR_RootConstrainSelectedInstOperands,
     /* 239868 */     // GIR_Coverage, 3524,
     /* 239868 */     GIR_EraseRootFromParent_Done,
     /* 239869 */   // Label 4575: @239869
     /* 239869 */   GIM_Try, /*On fail goto*//*Label 4576*/ GIMT_Encode4(239911), // Rule ID 3651 //
     /* 239874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 239877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 239882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 239888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239898 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1706:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SCLAMP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_B),
     /* 239901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239907 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239909 */     GIR_RootConstrainSelectedInstOperands,
     /* 239910 */     // GIR_Coverage, 3651,
     /* 239910 */     GIR_EraseRootFromParent_Done,
     /* 239911 */   // Label 4576: @239911
     /* 239911 */   GIM_Try, /*On fail goto*//*Label 4577*/ GIMT_Encode4(239953), // Rule ID 3653 //
     /* 239916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 239919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 239924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239940 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1706:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SCLAMP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_H),
     /* 239943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239947 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239949 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239951 */     GIR_RootConstrainSelectedInstOperands,
     /* 239952 */     // GIR_Coverage, 3653,
     /* 239952 */     GIR_EraseRootFromParent_Done,
     /* 239953 */   // Label 4577: @239953
     /* 239953 */   GIM_Try, /*On fail goto*//*Label 4578*/ GIMT_Encode4(239995), // Rule ID 3655 //
     /* 239958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 239961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 239966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239982 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1706:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCLAMP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_S),
     /* 239985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239991 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239993 */     GIR_RootConstrainSelectedInstOperands,
     /* 239994 */     // GIR_Coverage, 3655,
     /* 239994 */     GIR_EraseRootFromParent_Done,
     /* 239995 */   // Label 4578: @239995
     /* 239995 */   GIM_Try, /*On fail goto*//*Label 4579*/ GIMT_Encode4(240037), // Rule ID 3657 //
     /* 240000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 240003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 240008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 240014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240024 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1706:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCLAMP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_D),
     /* 240027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240031 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240033 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240035 */     GIR_RootConstrainSelectedInstOperands,
     /* 240036 */     // GIR_Coverage, 3657,
     /* 240036 */     GIR_EraseRootFromParent_Done,
     /* 240037 */   // Label 4579: @240037
     /* 240037 */   GIM_Try, /*On fail goto*//*Label 4580*/ GIMT_Encode4(240079), // Rule ID 7578 //
     /* 240042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 240050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 240053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 240056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 240059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 240062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240066 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1915:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 240066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_B),
     /* 240069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240075 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240077 */     GIR_RootConstrainSelectedInstOperands,
     /* 240078 */     // GIR_Coverage, 7578,
     /* 240078 */     GIR_EraseRootFromParent_Done,
     /* 240079 */   // Label 4580: @240079
     /* 240079 */   GIM_Try, /*On fail goto*//*Label 4581*/ GIMT_Encode4(240121), // Rule ID 7580 //
     /* 240084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 240092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240108 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1915:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 240108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_H),
     /* 240111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240117 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240119 */     GIR_RootConstrainSelectedInstOperands,
     /* 240120 */     // GIR_Coverage, 7580,
     /* 240120 */     GIR_EraseRootFromParent_Done,
     /* 240121 */   // Label 4581: @240121
     /* 240121 */   GIM_Try, /*On fail goto*//*Label 4582*/ GIMT_Encode4(240163), // Rule ID 7582 //
     /* 240126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 240134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240150 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1915:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_S),
     /* 240153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240155 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240157 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240159 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240161 */     GIR_RootConstrainSelectedInstOperands,
     /* 240162 */     // GIR_Coverage, 7582,
     /* 240162 */     GIR_EraseRootFromParent_Done,
     /* 240163 */   // Label 4582: @240163
     /* 240163 */   GIM_Try, /*On fail goto*//*Label 4583*/ GIMT_Encode4(240205), // Rule ID 7584 //
     /* 240168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 240176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240192 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1915:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_D),
     /* 240195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240201 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240203 */     GIR_RootConstrainSelectedInstOperands,
     /* 240204 */     // GIR_Coverage, 7584,
     /* 240204 */     GIR_EraseRootFromParent_Done,
     /* 240205 */   // Label 4583: @240205
     /* 240205 */   GIM_Try, /*On fail goto*//*Label 4584*/ GIMT_Encode4(240247), // Rule ID 7602 //
     /* 240210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 240218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 240221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 240224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 240227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 240230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240234 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1300:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BIC_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 240234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_B),
     /* 240237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240241 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240243 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240245 */     GIR_RootConstrainSelectedInstOperands,
     /* 240246 */     // GIR_Coverage, 7602,
     /* 240246 */     GIR_EraseRootFromParent_Done,
     /* 240247 */   // Label 4584: @240247
     /* 240247 */   GIM_Try, /*On fail goto*//*Label 4585*/ GIMT_Encode4(240289), // Rule ID 7603 //
     /* 240252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 240260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240276 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1300:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BIC_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 240276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_H),
     /* 240279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240285 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240287 */     GIR_RootConstrainSelectedInstOperands,
     /* 240288 */     // GIR_Coverage, 7603,
     /* 240288 */     GIR_EraseRootFromParent_Done,
     /* 240289 */   // Label 4585: @240289
     /* 240289 */   GIM_Try, /*On fail goto*//*Label 4586*/ GIMT_Encode4(240331), // Rule ID 7604 //
     /* 240294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 240302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240318 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1300:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BIC_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_S),
     /* 240321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240327 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240329 */     GIR_RootConstrainSelectedInstOperands,
     /* 240330 */     // GIR_Coverage, 7604,
     /* 240330 */     GIR_EraseRootFromParent_Done,
     /* 240331 */   // Label 4586: @240331
     /* 240331 */   GIM_Try, /*On fail goto*//*Label 4587*/ GIMT_Encode4(240373), // Rule ID 7605 //
     /* 240336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 240344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240360 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1300:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BIC_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_D),
     /* 240363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240369 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240371 */     GIR_RootConstrainSelectedInstOperands,
     /* 240372 */     // GIR_Coverage, 7605,
     /* 240372 */     GIR_EraseRootFromParent_Done,
     /* 240373 */   // Label 4587: @240373
     /* 240373 */   GIM_Try, /*On fail goto*//*Label 4588*/ GIMT_Encode4(240415), // Rule ID 7718 //
     /* 240378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 240386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 240389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 240392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 240395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 240398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240402 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1762:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMULH_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 240402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_B),
     /* 240405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240411 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240413 */     GIR_RootConstrainSelectedInstOperands,
     /* 240414 */     // GIR_Coverage, 7718,
     /* 240414 */     GIR_EraseRootFromParent_Done,
     /* 240415 */   // Label 4588: @240415
     /* 240415 */   GIM_Try, /*On fail goto*//*Label 4589*/ GIMT_Encode4(240457), // Rule ID 7719 //
     /* 240420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 240428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240444 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1762:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMULH_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 240444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_H),
     /* 240447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240451 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240453 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240455 */     GIR_RootConstrainSelectedInstOperands,
     /* 240456 */     // GIR_Coverage, 7719,
     /* 240456 */     GIR_EraseRootFromParent_Done,
     /* 240457 */   // Label 4589: @240457
     /* 240457 */   GIM_Try, /*On fail goto*//*Label 4590*/ GIMT_Encode4(240499), // Rule ID 7720 //
     /* 240462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 240470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240486 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1762:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMULH_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_S),
     /* 240489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240493 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240495 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240497 */     GIR_RootConstrainSelectedInstOperands,
     /* 240498 */     // GIR_Coverage, 7720,
     /* 240498 */     GIR_EraseRootFromParent_Done,
     /* 240499 */   // Label 4590: @240499
     /* 240499 */   GIM_Try, /*On fail goto*//*Label 4591*/ GIMT_Encode4(240541), // Rule ID 7721 //
     /* 240504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 240512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240528 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1762:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMULH_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_D),
     /* 240531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240535 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240537 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240539 */     GIR_RootConstrainSelectedInstOperands,
     /* 240540 */     // GIR_Coverage, 7721,
     /* 240540 */     GIR_EraseRootFromParent_Done,
     /* 240541 */   // Label 4591: @240541
     /* 240541 */   GIM_Try, /*On fail goto*//*Label 4592*/ GIMT_Encode4(240583), // Rule ID 7722 //
     /* 240546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 240554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 240557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 240560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 240563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 240566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240570 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2000:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMULH_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 240570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_B),
     /* 240573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240579 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240581 */     GIR_RootConstrainSelectedInstOperands,
     /* 240582 */     // GIR_Coverage, 7722,
     /* 240582 */     GIR_EraseRootFromParent_Done,
     /* 240583 */   // Label 4592: @240583
     /* 240583 */   GIM_Try, /*On fail goto*//*Label 4593*/ GIMT_Encode4(240625), // Rule ID 7723 //
     /* 240588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 240596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240612 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2000:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMULH_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 240612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_H),
     /* 240615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240621 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240623 */     GIR_RootConstrainSelectedInstOperands,
     /* 240624 */     // GIR_Coverage, 7723,
     /* 240624 */     GIR_EraseRootFromParent_Done,
     /* 240625 */   // Label 4593: @240625
     /* 240625 */   GIM_Try, /*On fail goto*//*Label 4594*/ GIMT_Encode4(240667), // Rule ID 7724 //
     /* 240630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 240638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240654 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2000:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMULH_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_S),
     /* 240657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240661 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240663 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240665 */     GIR_RootConstrainSelectedInstOperands,
     /* 240666 */     // GIR_Coverage, 7724,
     /* 240666 */     GIR_EraseRootFromParent_Done,
     /* 240667 */   // Label 4594: @240667
     /* 240667 */   GIM_Try, /*On fail goto*//*Label 4595*/ GIMT_Encode4(240709), // Rule ID 7725 //
     /* 240672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 240680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240696 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2000:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMULH_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_D),
     /* 240699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240705 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240707 */     GIR_RootConstrainSelectedInstOperands,
     /* 240708 */     // GIR_Coverage, 7725,
     /* 240708 */     GIR_EraseRootFromParent_Done,
     /* 240709 */   // Label 4595: @240709
     /* 240709 */   GIM_Try, /*On fail goto*//*Label 4596*/ GIMT_Encode4(240751), // Rule ID 7734 //
     /* 240714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udiv),
     /* 240722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240738 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1963:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UDIV_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIV_ZPmZ_S),
     /* 240741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240745 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240747 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240749 */     GIR_RootConstrainSelectedInstOperands,
     /* 240750 */     // GIR_Coverage, 7734,
     /* 240750 */     GIR_EraseRootFromParent_Done,
     /* 240751 */   // Label 4596: @240751
     /* 240751 */   GIM_Try, /*On fail goto*//*Label 4597*/ GIMT_Encode4(240793), // Rule ID 7735 //
     /* 240756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udiv),
     /* 240764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240780 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1963:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UDIV_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIV_ZPmZ_D),
     /* 240783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240787 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240789 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240791 */     GIR_RootConstrainSelectedInstOperands,
     /* 240792 */     // GIR_Coverage, 7735,
     /* 240792 */     GIR_EraseRootFromParent_Done,
     /* 240793 */   // Label 4597: @240793
     /* 240793 */   GIM_Try, /*On fail goto*//*Label 4598*/ GIMT_Encode4(240835), // Rule ID 7736 //
     /* 240798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdivr),
     /* 240806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240822 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1718:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SDIVR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVR_ZPmZ_S),
     /* 240825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240831 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240833 */     GIR_RootConstrainSelectedInstOperands,
     /* 240834 */     // GIR_Coverage, 7736,
     /* 240834 */     GIR_EraseRootFromParent_Done,
     /* 240835 */   // Label 4598: @240835
     /* 240835 */   GIM_Try, /*On fail goto*//*Label 4599*/ GIMT_Encode4(240877), // Rule ID 7737 //
     /* 240840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdivr),
     /* 240848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240864 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1718:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SDIVR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVR_ZPmZ_D),
     /* 240867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240873 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240875 */     GIR_RootConstrainSelectedInstOperands,
     /* 240876 */     // GIR_Coverage, 7737,
     /* 240876 */     GIR_EraseRootFromParent_Done,
     /* 240877 */   // Label 4599: @240877
     /* 240877 */   GIM_Try, /*On fail goto*//*Label 4600*/ GIMT_Encode4(240919), // Rule ID 7738 //
     /* 240882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udivr),
     /* 240890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240906 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1965:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UDIVR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVR_ZPmZ_S),
     /* 240909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240913 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240915 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240917 */     GIR_RootConstrainSelectedInstOperands,
     /* 240918 */     // GIR_Coverage, 7738,
     /* 240918 */     GIR_EraseRootFromParent_Done,
     /* 240919 */   // Label 4600: @240919
     /* 240919 */   GIM_Try, /*On fail goto*//*Label 4601*/ GIMT_Encode4(240961), // Rule ID 7739 //
     /* 240924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udivr),
     /* 240932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240948 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1965:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UDIVR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVR_ZPmZ_D),
     /* 240951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240957 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240959 */     GIR_RootConstrainSelectedInstOperands,
     /* 240960 */     // GIR_Coverage, 7739,
     /* 240960 */     GIR_EraseRootFromParent_Done,
     /* 240961 */   // Label 4601: @240961
     /* 240961 */   GIM_Try, /*On fail goto*//*Label 4602*/ GIMT_Encode4(241003), // Rule ID 7828 //
     /* 240966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 240974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 240977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 240980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 240983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 240986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240990 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1340:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CNOT_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 240990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_B),
     /* 240993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 240997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 240999 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 241001 */     GIR_RootConstrainSelectedInstOperands,
     /* 241002 */     // GIR_Coverage, 7828,
     /* 241002 */     GIR_EraseRootFromParent_Done,
     /* 241003 */   // Label 4602: @241003
     /* 241003 */   GIM_Try, /*On fail goto*//*Label 4603*/ GIMT_Encode4(241045), // Rule ID 7829 //
     /* 241008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 241016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 241022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 241025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241032 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1340:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CNOT_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 241032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_H),
     /* 241035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 241039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 241041 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 241043 */     GIR_RootConstrainSelectedInstOperands,
     /* 241044 */     // GIR_Coverage, 7829,
     /* 241044 */     GIR_EraseRootFromParent_Done,
     /* 241045 */   // Label 4603: @241045
     /* 241045 */   GIM_Try, /*On fail goto*//*Label 4604*/ GIMT_Encode4(241087), // Rule ID 7830 //
     /* 241050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 241058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 241064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 241067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241074 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1340:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CNOT_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 241074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_S),
     /* 241077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 241081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 241083 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 241085 */     GIR_RootConstrainSelectedInstOperands,
     /* 241086 */     // GIR_Coverage, 7830,
     /* 241086 */     GIR_EraseRootFromParent_Done,
     /* 241087 */   // Label 4604: @241087
     /* 241087 */   GIM_Try, /*On fail goto*//*Label 4605*/ GIMT_Encode4(241129), // Rule ID 7831 //
     /* 241092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 241100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 241106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 241109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241116 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1340:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CNOT_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 241116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_D),
     /* 241119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 241123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 241125 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 241127 */     GIR_RootConstrainSelectedInstOperands,
     /* 241128 */     // GIR_Coverage, 7831,
     /* 241128 */     GIR_EraseRootFromParent_Done,
     /* 241129 */   // Label 4605: @241129
     /* 241129 */   GIM_Try, /*On fail goto*//*Label 4606*/ GIMT_Encode4(241171), // Rule ID 7840 //
     /* 241134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 241142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 241145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 241148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 241151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 241154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241158 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1626:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (NOT_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 241158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_B),
     /* 241161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 241165 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 241167 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 241169 */     GIR_RootConstrainSelectedInstOperands,
     /* 241170 */     // GIR_Coverage, 7840,
     /* 241170 */     GIR_EraseRootFromParent_Done,
     /* 241171 */   // Label 4606: @241171
     /* 241171 */   GIM_Try, /*On fail goto*//*Label 4607*/ GIMT_Encode4(241213), // Rule ID 7841 //
     /* 241176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 241184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 241190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 241193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241200 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1626:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (NOT_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 241200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_H),
     /* 241203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 241207 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 241209 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 241211 */     GIR_RootConstrainSelectedInstOperands,
     /* 241212 */     // GIR_Coverage, 7841,
     /* 241212 */     GIR_EraseRootFromParent_Done,
     /* 241213 */   // Label 4607: @241213
     /* 241213 */   GIM_Try, /*On fail goto*//*Label 4608*/ GIMT_Encode4(241255), // Rule ID 7842 //
     /* 241218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 241226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 241232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 241235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241242 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1626:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (NOT_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 241242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_S),
     /* 241245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 241249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 241251 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 241253 */     GIR_RootConstrainSelectedInstOperands,
     /* 241254 */     // GIR_Coverage, 7842,
     /* 241254 */     GIR_EraseRootFromParent_Done,
     /* 241255 */   // Label 4608: @241255
     /* 241255 */   GIM_Try, /*On fail goto*//*Label 4609*/ GIMT_Encode4(241297), // Rule ID 7843 //
     /* 241260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 241268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 241274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 241277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241284 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1626:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (NOT_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 241284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_D),
     /* 241287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 241291 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 241293 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 241295 */     GIR_RootConstrainSelectedInstOperands,
     /* 241296 */     // GIR_Coverage, 7843,
     /* 241296 */     GIR_EraseRootFromParent_Done,
     /* 241297 */   // Label 4609: @241297
     /* 241297 */   GIM_Try, /*On fail goto*//*Label 4610*/ GIMT_Encode4(241339), // Rule ID 7922 //
     /* 241302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 241310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 241313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 241316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 241319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 241322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241326 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1693:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 241326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_B),
     /* 241329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241335 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241337 */     GIR_RootConstrainSelectedInstOperands,
     /* 241338 */     // GIR_Coverage, 7922,
     /* 241338 */     GIR_EraseRootFromParent_Done,
     /* 241339 */   // Label 4610: @241339
     /* 241339 */   GIM_Try, /*On fail goto*//*Label 4611*/ GIMT_Encode4(241381), // Rule ID 7923 //
     /* 241344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 241352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241368 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1693:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 241368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_H),
     /* 241371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241377 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241379 */     GIR_RootConstrainSelectedInstOperands,
     /* 241380 */     // GIR_Coverage, 7923,
     /* 241380 */     GIR_EraseRootFromParent_Done,
     /* 241381 */   // Label 4611: @241381
     /* 241381 */   GIM_Try, /*On fail goto*//*Label 4612*/ GIMT_Encode4(241423), // Rule ID 7924 //
     /* 241386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 241394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241410 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1693:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 241410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_S),
     /* 241413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241417 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241419 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241421 */     GIR_RootConstrainSelectedInstOperands,
     /* 241422 */     // GIR_Coverage, 7924,
     /* 241422 */     GIR_EraseRootFromParent_Done,
     /* 241423 */   // Label 4612: @241423
     /* 241423 */   GIM_Try, /*On fail goto*//*Label 4613*/ GIMT_Encode4(241465), // Rule ID 7925 //
     /* 241428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 241436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241452 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1693:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SABD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 241452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_D),
     /* 241455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241461 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241463 */     GIR_RootConstrainSelectedInstOperands,
     /* 241464 */     // GIR_Coverage, 7925,
     /* 241464 */     GIR_EraseRootFromParent_Done,
     /* 241465 */   // Label 4613: @241465
     /* 241465 */   GIM_Try, /*On fail goto*//*Label 4614*/ GIMT_Encode4(241507), // Rule ID 7926 //
     /* 241470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 241478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 241481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 241484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 241487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 241490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241494 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1943:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 241494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_B),
     /* 241497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241503 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241505 */     GIR_RootConstrainSelectedInstOperands,
     /* 241506 */     // GIR_Coverage, 7926,
     /* 241506 */     GIR_EraseRootFromParent_Done,
     /* 241507 */   // Label 4614: @241507
     /* 241507 */   GIM_Try, /*On fail goto*//*Label 4615*/ GIMT_Encode4(241549), // Rule ID 7927 //
     /* 241512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 241520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241536 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1943:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 241536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_H),
     /* 241539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241545 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241547 */     GIR_RootConstrainSelectedInstOperands,
     /* 241548 */     // GIR_Coverage, 7927,
     /* 241548 */     GIR_EraseRootFromParent_Done,
     /* 241549 */   // Label 4615: @241549
     /* 241549 */   GIM_Try, /*On fail goto*//*Label 4616*/ GIMT_Encode4(241591), // Rule ID 7928 //
     /* 241554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 241562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241578 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1943:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 241578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_S),
     /* 241581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241587 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241589 */     GIR_RootConstrainSelectedInstOperands,
     /* 241590 */     // GIR_Coverage, 7928,
     /* 241590 */     GIR_EraseRootFromParent_Done,
     /* 241591 */   // Label 4616: @241591
     /* 241591 */   GIM_Try, /*On fail goto*//*Label 4617*/ GIMT_Encode4(241633), // Rule ID 7929 //
     /* 241596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 241604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241620 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1943:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UABD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 241620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_D),
     /* 241623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241629 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241631 */     GIR_RootConstrainSelectedInstOperands,
     /* 241632 */     // GIR_Coverage, 7929,
     /* 241632 */     GIR_EraseRootFromParent_Done,
     /* 241633 */   // Label 4617: @241633
     /* 241633 */   GIM_Try, /*On fail goto*//*Label 4618*/ GIMT_Encode4(241675), // Rule ID 8125 //
     /* 241638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 241646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241662 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1549:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FSUB_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 241662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_H),
     /* 241665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241669 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241671 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241673 */     GIR_RootConstrainSelectedInstOperands,
     /* 241674 */     // GIR_Coverage, 8125,
     /* 241674 */     GIR_EraseRootFromParent_Done,
     /* 241675 */   // Label 4618: @241675
     /* 241675 */   GIM_Try, /*On fail goto*//*Label 4619*/ GIMT_Encode4(241717), // Rule ID 8127 //
     /* 241680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 241688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241704 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1549:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FSUB_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 241704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_S),
     /* 241707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241713 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241715 */     GIR_RootConstrainSelectedInstOperands,
     /* 241716 */     // GIR_Coverage, 8127,
     /* 241716 */     GIR_EraseRootFromParent_Done,
     /* 241717 */   // Label 4619: @241717
     /* 241717 */   GIM_Try, /*On fail goto*//*Label 4620*/ GIMT_Encode4(241759), // Rule ID 8129 //
     /* 241722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 241730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241746 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1549:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FSUB_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 241746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_D),
     /* 241749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241755 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241757 */     GIR_RootConstrainSelectedInstOperands,
     /* 241758 */     // GIR_Coverage, 8129,
     /* 241758 */     GIR_EraseRootFromParent_Done,
     /* 241759 */   // Label 4620: @241759
     /* 241759 */   GIM_Try, /*On fail goto*//*Label 4621*/ GIMT_Encode4(241801), // Rule ID 8137 //
     /* 241764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 241772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241788 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1551:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FSUBR_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 241788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_H),
     /* 241791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241797 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241799 */     GIR_RootConstrainSelectedInstOperands,
     /* 241800 */     // GIR_Coverage, 8137,
     /* 241800 */     GIR_EraseRootFromParent_Done,
     /* 241801 */   // Label 4621: @241801
     /* 241801 */   GIM_Try, /*On fail goto*//*Label 4622*/ GIMT_Encode4(241843), // Rule ID 8139 //
     /* 241806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 241814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241830 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1551:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FSUBR_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 241830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_S),
     /* 241833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241839 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241841 */     GIR_RootConstrainSelectedInstOperands,
     /* 241842 */     // GIR_Coverage, 8139,
     /* 241842 */     GIR_EraseRootFromParent_Done,
     /* 241843 */   // Label 4622: @241843
     /* 241843 */   GIM_Try, /*On fail goto*//*Label 4623*/ GIMT_Encode4(241885), // Rule ID 8141 //
     /* 241848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 241856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241872 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1551:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FSUBR_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 241872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_D),
     /* 241875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241881 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241883 */     GIR_RootConstrainSelectedInstOperands,
     /* 241884 */     // GIR_Coverage, 8141,
     /* 241884 */     GIR_EraseRootFromParent_Done,
     /* 241885 */   // Label 4623: @241885
     /* 241885 */   GIM_Try, /*On fail goto*//*Label 4624*/ GIMT_Encode4(241927), // Rule ID 8179 //
     /* 241890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 241898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241914 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1368:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FABD_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 241914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_H),
     /* 241917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241923 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241925 */     GIR_RootConstrainSelectedInstOperands,
     /* 241926 */     // GIR_Coverage, 8179,
     /* 241926 */     GIR_EraseRootFromParent_Done,
     /* 241927 */   // Label 4624: @241927
     /* 241927 */   GIM_Try, /*On fail goto*//*Label 4625*/ GIMT_Encode4(241969), // Rule ID 8180 //
     /* 241932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 241940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241956 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1368:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FABD_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 241956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_S),
     /* 241959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241965 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241967 */     GIR_RootConstrainSelectedInstOperands,
     /* 241968 */     // GIR_Coverage, 8180,
     /* 241968 */     GIR_EraseRootFromParent_Done,
     /* 241969 */   // Label 4625: @241969
     /* 241969 */   GIM_Try, /*On fail goto*//*Label 4626*/ GIMT_Encode4(242011), // Rule ID 8181 //
     /* 241974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 241982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241998 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1368:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FABD_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 241998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_D),
     /* 242001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242007 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242009 */     GIR_RootConstrainSelectedInstOperands,
     /* 242010 */     // GIR_Coverage, 8181,
     /* 242010 */     GIR_EraseRootFromParent_Done,
     /* 242011 */   // Label 4626: @242011
     /* 242011 */   GIM_Try, /*On fail goto*//*Label 4627*/ GIMT_Encode4(242053), // Rule ID 8182 //
     /* 242016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 242024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242040 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1490:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMULX_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 242040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_H),
     /* 242043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242047 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242049 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242051 */     GIR_RootConstrainSelectedInstOperands,
     /* 242052 */     // GIR_Coverage, 8182,
     /* 242052 */     GIR_EraseRootFromParent_Done,
     /* 242053 */   // Label 4627: @242053
     /* 242053 */   GIM_Try, /*On fail goto*//*Label 4628*/ GIMT_Encode4(242095), // Rule ID 8183 //
     /* 242058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 242066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242082 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1490:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMULX_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 242082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_S),
     /* 242085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242091 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242093 */     GIR_RootConstrainSelectedInstOperands,
     /* 242094 */     // GIR_Coverage, 8183,
     /* 242094 */     GIR_EraseRootFromParent_Done,
     /* 242095 */   // Label 4628: @242095
     /* 242095 */   GIM_Try, /*On fail goto*//*Label 4629*/ GIMT_Encode4(242137), // Rule ID 8184 //
     /* 242100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 242108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242124 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1490:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMULX_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 242124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_D),
     /* 242127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242133 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242135 */     GIR_RootConstrainSelectedInstOperands,
     /* 242136 */     // GIR_Coverage, 8184,
     /* 242136 */     GIR_EraseRootFromParent_Done,
     /* 242137 */   // Label 4629: @242137
     /* 242137 */   GIM_Try, /*On fail goto*//*Label 4630*/ GIMT_Encode4(242179), // Rule ID 8185 //
     /* 242142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 242150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242166 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1429:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDIVR_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 242166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_H),
     /* 242169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242175 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242177 */     GIR_RootConstrainSelectedInstOperands,
     /* 242178 */     // GIR_Coverage, 8185,
     /* 242178 */     GIR_EraseRootFromParent_Done,
     /* 242179 */   // Label 4630: @242179
     /* 242179 */   GIM_Try, /*On fail goto*//*Label 4631*/ GIMT_Encode4(242221), // Rule ID 8186 //
     /* 242184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 242192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242208 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1429:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FDIVR_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 242208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_S),
     /* 242211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242217 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242219 */     GIR_RootConstrainSelectedInstOperands,
     /* 242220 */     // GIR_Coverage, 8186,
     /* 242220 */     GIR_EraseRootFromParent_Done,
     /* 242221 */   // Label 4631: @242221
     /* 242221 */   GIM_Try, /*On fail goto*//*Label 4632*/ GIMT_Encode4(242263), // Rule ID 8187 //
     /* 242226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 242234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242250 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1429:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FDIVR_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 242250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_D),
     /* 242253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242259 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242261 */     GIR_RootConstrainSelectedInstOperands,
     /* 242262 */     // GIR_Coverage, 8187,
     /* 242262 */     GIR_EraseRootFromParent_Done,
     /* 242263 */   // Label 4632: @242263
     /* 242263 */   GIM_Try, /*On fail goto*//*Label 4633*/ GIMT_Encode4(242305), // Rule ID 8188 //
     /* 242268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 242276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242292 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1427:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDIV_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 242292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_H),
     /* 242295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242301 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242303 */     GIR_RootConstrainSelectedInstOperands,
     /* 242304 */     // GIR_Coverage, 8188,
     /* 242304 */     GIR_EraseRootFromParent_Done,
     /* 242305 */   // Label 4633: @242305
     /* 242305 */   GIM_Try, /*On fail goto*//*Label 4634*/ GIMT_Encode4(242347), // Rule ID 8189 //
     /* 242310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 242318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242334 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1427:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FDIV_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 242334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_S),
     /* 242337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242341 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242343 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242345 */     GIR_RootConstrainSelectedInstOperands,
     /* 242346 */     // GIR_Coverage, 8189,
     /* 242346 */     GIR_EraseRootFromParent_Done,
     /* 242347 */   // Label 4634: @242347
     /* 242347 */   GIM_Try, /*On fail goto*//*Label 4635*/ GIMT_Encode4(242389), // Rule ID 8190 //
     /* 242352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 242360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242376 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1427:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FDIV_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 242376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_D),
     /* 242379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242385 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242387 */     GIR_RootConstrainSelectedInstOperands,
     /* 242388 */     // GIR_Coverage, 8190,
     /* 242388 */     GIR_EraseRootFromParent_Done,
     /* 242389 */   // Label 4635: @242389
     /* 242389 */   GIM_Try, /*On fail goto*//*Label 4636*/ GIMT_Encode4(242431), // Rule ID 8227 //
     /* 242394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 242402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242418 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1369:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 242418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 242421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242425 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242427 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242429 */     GIR_RootConstrainSelectedInstOperands,
     /* 242430 */     // GIR_Coverage, 8227,
     /* 242430 */     GIR_EraseRootFromParent_Done,
     /* 242431 */   // Label 4636: @242431
     /* 242431 */   GIM_Try, /*On fail goto*//*Label 4637*/ GIMT_Encode4(242473), // Rule ID 8229 //
     /* 242436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 242444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 242447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 242453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 242456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242460 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1369:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 242460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 242463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242469 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242471 */     GIR_RootConstrainSelectedInstOperands,
     /* 242472 */     // GIR_Coverage, 8229,
     /* 242472 */     GIR_EraseRootFromParent_Done,
     /* 242473 */   // Label 4637: @242473
     /* 242473 */   GIM_Try, /*On fail goto*//*Label 4638*/ GIMT_Encode4(242515), // Rule ID 8231 //
     /* 242478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 242486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 242489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 242495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 242498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242502 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1369:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 242502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 242505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242511 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242513 */     GIR_RootConstrainSelectedInstOperands,
     /* 242514 */     // GIR_Coverage, 8231,
     /* 242514 */     GIR_EraseRootFromParent_Done,
     /* 242515 */   // Label 4638: @242515
     /* 242515 */   GIM_Try, /*On fail goto*//*Label 4639*/ GIMT_Encode4(242557), // Rule ID 8233 //
     /* 242520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 242528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242544 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1369:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FABD_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 242544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_S_UNDEF),
     /* 242547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242551 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242553 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242555 */     GIR_RootConstrainSelectedInstOperands,
     /* 242556 */     // GIR_Coverage, 8233,
     /* 242556 */     GIR_EraseRootFromParent_Done,
     /* 242557 */   // Label 4639: @242557
     /* 242557 */   GIM_Try, /*On fail goto*//*Label 4640*/ GIMT_Encode4(242599), // Rule ID 8235 //
     /* 242562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 242570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 242573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 242579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 242582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242586 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1369:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FABD_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 242586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_S_UNDEF),
     /* 242589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242595 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242597 */     GIR_RootConstrainSelectedInstOperands,
     /* 242598 */     // GIR_Coverage, 8235,
     /* 242598 */     GIR_EraseRootFromParent_Done,
     /* 242599 */   // Label 4640: @242599
     /* 242599 */   GIM_Try, /*On fail goto*//*Label 4641*/ GIMT_Encode4(242641), // Rule ID 8237 //
     /* 242604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 242612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242628 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1369:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FABD_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 242628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_D_UNDEF),
     /* 242631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242637 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242639 */     GIR_RootConstrainSelectedInstOperands,
     /* 242640 */     // GIR_Coverage, 8237,
     /* 242640 */     GIR_EraseRootFromParent_Done,
     /* 242641 */   // Label 4641: @242641
     /* 242641 */   GIM_Try, /*On fail goto*//*Label 4642*/ GIMT_Encode4(242683), // Rule ID 8239 //
     /* 242646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 242654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242670 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1491:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 242670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 242673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242679 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242681 */     GIR_RootConstrainSelectedInstOperands,
     /* 242682 */     // GIR_Coverage, 8239,
     /* 242682 */     GIR_EraseRootFromParent_Done,
     /* 242683 */   // Label 4642: @242683
     /* 242683 */   GIM_Try, /*On fail goto*//*Label 4643*/ GIMT_Encode4(242725), // Rule ID 8240 //
     /* 242688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 242696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 242699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 242705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 242708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242712 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1491:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 242712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 242715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242721 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242723 */     GIR_RootConstrainSelectedInstOperands,
     /* 242724 */     // GIR_Coverage, 8240,
     /* 242724 */     GIR_EraseRootFromParent_Done,
     /* 242725 */   // Label 4643: @242725
     /* 242725 */   GIM_Try, /*On fail goto*//*Label 4644*/ GIMT_Encode4(242767), // Rule ID 8241 //
     /* 242730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 242738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 242741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 242747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 242750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242754 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1491:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 242754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 242757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242763 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242765 */     GIR_RootConstrainSelectedInstOperands,
     /* 242766 */     // GIR_Coverage, 8241,
     /* 242766 */     GIR_EraseRootFromParent_Done,
     /* 242767 */   // Label 4644: @242767
     /* 242767 */   GIM_Try, /*On fail goto*//*Label 4645*/ GIMT_Encode4(242809), // Rule ID 8242 //
     /* 242772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 242780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242796 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1491:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMULX_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 242796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_S_UNDEF),
     /* 242799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242805 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242807 */     GIR_RootConstrainSelectedInstOperands,
     /* 242808 */     // GIR_Coverage, 8242,
     /* 242808 */     GIR_EraseRootFromParent_Done,
     /* 242809 */   // Label 4645: @242809
     /* 242809 */   GIM_Try, /*On fail goto*//*Label 4646*/ GIMT_Encode4(242851), // Rule ID 8243 //
     /* 242814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 242822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 242825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 242831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 242834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242838 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1491:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FMULX_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 242838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_S_UNDEF),
     /* 242841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242845 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242847 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242849 */     GIR_RootConstrainSelectedInstOperands,
     /* 242850 */     // GIR_Coverage, 8243,
     /* 242850 */     GIR_EraseRootFromParent_Done,
     /* 242851 */   // Label 4646: @242851
     /* 242851 */   GIM_Try, /*On fail goto*//*Label 4647*/ GIMT_Encode4(242893), // Rule ID 8244 //
     /* 242856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 242864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242880 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1491:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMULX_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 242880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_D_UNDEF),
     /* 242883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242887 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242889 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242891 */     GIR_RootConstrainSelectedInstOperands,
     /* 242892 */     // GIR_Coverage, 8244,
     /* 242892 */     GIR_EraseRootFromParent_Done,
     /* 242893 */   // Label 4647: @242893
     /* 242893 */   GIM_Try, /*On fail goto*//*Label 4648*/ GIMT_Encode4(242935), // Rule ID 8522 //
     /* 242898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkpb_z),
     /* 242906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 242909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 242912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 242915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 242918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 242922 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1309:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKPB_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 242922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKPB_PPzPP),
     /* 242925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 242927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242931 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242933 */     GIR_RootConstrainSelectedInstOperands,
     /* 242934 */     // GIR_Coverage, 8522,
     /* 242934 */     GIR_EraseRootFromParent_Done,
     /* 242935 */   // Label 4648: @242935
     /* 242935 */   GIM_Try, /*On fail goto*//*Label 4649*/ GIMT_Encode4(242977), // Rule ID 8524 //
     /* 242940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkb),
     /* 242948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 242951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 242954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 242957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 242960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 242964 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1305:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKB_PPmP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 242964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKB_PPmP),
     /* 242967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 242969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242973 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242975 */     GIR_RootConstrainSelectedInstOperands,
     /* 242976 */     // GIR_Coverage, 8524,
     /* 242976 */     GIR_EraseRootFromParent_Done,
     /* 242977 */   // Label 4649: @242977
     /* 242977 */   GIM_Try, /*On fail goto*//*Label 4650*/ GIMT_Encode4(243019), // Rule ID 8525 //
     /* 242982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 242990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 242993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 242996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 242999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 243002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243006 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1302:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 243006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 243009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243015 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243017 */     GIR_RootConstrainSelectedInstOperands,
     /* 243018 */     // GIR_Coverage, 8525,
     /* 243018 */     GIR_EraseRootFromParent_Done,
     /* 243019 */   // Label 4650: @243019
     /* 243019 */   GIM_Try, /*On fail goto*//*Label 4651*/ GIMT_Encode4(243061), // Rule ID 8526 //
     /* 243024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 243032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 243035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 243041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 243044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243048 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1302:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 243048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 243051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243057 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243059 */     GIR_RootConstrainSelectedInstOperands,
     /* 243060 */     // GIR_Coverage, 8526,
     /* 243060 */     GIR_EraseRootFromParent_Done,
     /* 243061 */   // Label 4651: @243061
     /* 243061 */   GIM_Try, /*On fail goto*//*Label 4652*/ GIMT_Encode4(243103), // Rule ID 8527 //
     /* 243066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 243074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 243077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 243083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 243086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243090 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1302:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 243090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 243093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243097 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243099 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243101 */     GIR_RootConstrainSelectedInstOperands,
     /* 243102 */     // GIR_Coverage, 8527,
     /* 243102 */     GIR_EraseRootFromParent_Done,
     /* 243103 */   // Label 4652: @243103
     /* 243103 */   GIM_Try, /*On fail goto*//*Label 4653*/ GIMT_Encode4(243145), // Rule ID 8528 //
     /* 243108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 243116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 243119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 243125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 243128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243132 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1302:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 243132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 243135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243141 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243143 */     GIR_RootConstrainSelectedInstOperands,
     /* 243144 */     // GIR_Coverage, 8528,
     /* 243144 */     GIR_EraseRootFromParent_Done,
     /* 243145 */   // Label 4653: @243145
     /* 243145 */   GIM_Try, /*On fail goto*//*Label 4654*/ GIMT_Encode4(243187), // Rule ID 8529 //
     /* 243150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 243158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 243161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 243164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 243167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 243170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243174 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1302:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 243174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 243177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243183 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243185 */     GIR_RootConstrainSelectedInstOperands,
     /* 243186 */     // GIR_Coverage, 8529,
     /* 243186 */     GIR_EraseRootFromParent_Done,
     /* 243187 */   // Label 4654: @243187
     /* 243187 */   GIM_Try, /*On fail goto*//*Label 4655*/ GIMT_Encode4(243229), // Rule ID 8550 //
     /* 243192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 243200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 243203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 243206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 243209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 243212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243216 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1360:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 243216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 243219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243225 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243227 */     GIR_RootConstrainSelectedInstOperands,
     /* 243228 */     // GIR_Coverage, 8550,
     /* 243228 */     GIR_EraseRootFromParent_Done,
     /* 243229 */   // Label 4655: @243229
     /* 243229 */   GIM_Try, /*On fail goto*//*Label 4656*/ GIMT_Encode4(243271), // Rule ID 8551 //
     /* 243234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 243242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 243245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 243251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 243254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243258 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1360:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 243258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 243261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243267 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243269 */     GIR_RootConstrainSelectedInstOperands,
     /* 243270 */     // GIR_Coverage, 8551,
     /* 243270 */     GIR_EraseRootFromParent_Done,
     /* 243271 */   // Label 4656: @243271
     /* 243271 */   GIM_Try, /*On fail goto*//*Label 4657*/ GIMT_Encode4(243313), // Rule ID 8552 //
     /* 243276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 243284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 243287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 243293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 243296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243300 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1360:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 243300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 243303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243307 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243309 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243311 */     GIR_RootConstrainSelectedInstOperands,
     /* 243312 */     // GIR_Coverage, 8552,
     /* 243312 */     GIR_EraseRootFromParent_Done,
     /* 243313 */   // Label 4657: @243313
     /* 243313 */   GIM_Try, /*On fail goto*//*Label 4658*/ GIMT_Encode4(243355), // Rule ID 8553 //
     /* 243318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 243326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 243329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 243335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 243338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243342 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1360:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 243342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 243345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243351 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243353 */     GIR_RootConstrainSelectedInstOperands,
     /* 243354 */     // GIR_Coverage, 8553,
     /* 243354 */     GIR_EraseRootFromParent_Done,
     /* 243355 */   // Label 4658: @243355
     /* 243355 */   GIM_Try, /*On fail goto*//*Label 4659*/ GIMT_Encode4(243397), // Rule ID 8554 //
     /* 243360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 243368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 243371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 243374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 243377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 243380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243384 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1360:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 243384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 243387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243393 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243395 */     GIR_RootConstrainSelectedInstOperands,
     /* 243396 */     // GIR_Coverage, 8554,
     /* 243396 */     GIR_EraseRootFromParent_Done,
     /* 243397 */   // Label 4659: @243397
     /* 243397 */   GIM_Try, /*On fail goto*//*Label 4660*/ GIMT_Encode4(243439), // Rule ID 8570 //
     /* 243402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 243410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 243413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 243416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 243419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 243422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243426 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1631:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 243426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 243429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243435 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243437 */     GIR_RootConstrainSelectedInstOperands,
     /* 243438 */     // GIR_Coverage, 8570,
     /* 243438 */     GIR_EraseRootFromParent_Done,
     /* 243439 */   // Label 4660: @243439
     /* 243439 */   GIM_Try, /*On fail goto*//*Label 4661*/ GIMT_Encode4(243481), // Rule ID 8571 //
     /* 243444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 243452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 243455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 243461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 243464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243468 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1631:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 243468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 243471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243477 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243479 */     GIR_RootConstrainSelectedInstOperands,
     /* 243480 */     // GIR_Coverage, 8571,
     /* 243480 */     GIR_EraseRootFromParent_Done,
     /* 243481 */   // Label 4661: @243481
     /* 243481 */   GIM_Try, /*On fail goto*//*Label 4662*/ GIMT_Encode4(243523), // Rule ID 8572 //
     /* 243486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 243494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 243497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 243503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 243506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243510 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1631:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 243510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 243513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243519 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243521 */     GIR_RootConstrainSelectedInstOperands,
     /* 243522 */     // GIR_Coverage, 8572,
     /* 243522 */     GIR_EraseRootFromParent_Done,
     /* 243523 */   // Label 4662: @243523
     /* 243523 */   GIM_Try, /*On fail goto*//*Label 4663*/ GIMT_Encode4(243565), // Rule ID 8573 //
     /* 243528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 243536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 243539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 243545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 243548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243552 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1631:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 243552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 243555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243561 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243563 */     GIR_RootConstrainSelectedInstOperands,
     /* 243564 */     // GIR_Coverage, 8573,
     /* 243564 */     GIR_EraseRootFromParent_Done,
     /* 243565 */   // Label 4663: @243565
     /* 243565 */   GIM_Try, /*On fail goto*//*Label 4664*/ GIMT_Encode4(243607), // Rule ID 8574 //
     /* 243570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 243578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 243581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 243584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 243587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 243590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243594 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1631:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 243594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 243597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243603 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243605 */     GIR_RootConstrainSelectedInstOperands,
     /* 243606 */     // GIR_Coverage, 8574,
     /* 243606 */     GIR_EraseRootFromParent_Done,
     /* 243607 */   // Label 4664: @243607
     /* 243607 */   GIM_Try, /*On fail goto*//*Label 4665*/ GIMT_Encode4(243649), // Rule ID 8575 //
     /* 243612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 243620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 243623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 243626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 243629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 243632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243636 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1627:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 243636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 243639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243645 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243647 */     GIR_RootConstrainSelectedInstOperands,
     /* 243648 */     // GIR_Coverage, 8575,
     /* 243648 */     GIR_EraseRootFromParent_Done,
     /* 243649 */   // Label 4665: @243649
     /* 243649 */   GIM_Try, /*On fail goto*//*Label 4666*/ GIMT_Encode4(243691), // Rule ID 8576 //
     /* 243654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 243662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 243665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 243671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 243674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243678 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1627:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 243678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 243681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243687 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243689 */     GIR_RootConstrainSelectedInstOperands,
     /* 243690 */     // GIR_Coverage, 8576,
     /* 243690 */     GIR_EraseRootFromParent_Done,
     /* 243691 */   // Label 4666: @243691
     /* 243691 */   GIM_Try, /*On fail goto*//*Label 4667*/ GIMT_Encode4(243733), // Rule ID 8577 //
     /* 243696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 243704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 243707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 243713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 243716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243720 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1627:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 243720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 243723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243727 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243729 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243731 */     GIR_RootConstrainSelectedInstOperands,
     /* 243732 */     // GIR_Coverage, 8577,
     /* 243732 */     GIR_EraseRootFromParent_Done,
     /* 243733 */   // Label 4667: @243733
     /* 243733 */   GIM_Try, /*On fail goto*//*Label 4668*/ GIMT_Encode4(243775), // Rule ID 8578 //
     /* 243738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 243746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 243749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 243755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 243758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243762 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1627:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 243762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 243765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243771 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243773 */     GIR_RootConstrainSelectedInstOperands,
     /* 243774 */     // GIR_Coverage, 8578,
     /* 243774 */     GIR_EraseRootFromParent_Done,
     /* 243775 */   // Label 4668: @243775
     /* 243775 */   GIM_Try, /*On fail goto*//*Label 4669*/ GIMT_Encode4(243817), // Rule ID 8579 //
     /* 243780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 243788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 243791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 243794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 243797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 243800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243804 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1627:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 243804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 243807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243811 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243813 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243815 */     GIR_RootConstrainSelectedInstOperands,
     /* 243816 */     // GIR_Coverage, 8579,
     /* 243816 */     GIR_EraseRootFromParent_Done,
     /* 243817 */   // Label 4669: @243817
     /* 243817 */   GIM_Try, /*On fail goto*//*Label 4670*/ GIMT_Encode4(243859), // Rule ID 8580 //
     /* 243822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 243830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 243833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 243836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 243839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 243842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243846 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1625:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 243846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 243849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243855 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243857 */     GIR_RootConstrainSelectedInstOperands,
     /* 243858 */     // GIR_Coverage, 8580,
     /* 243858 */     GIR_EraseRootFromParent_Done,
     /* 243859 */   // Label 4670: @243859
     /* 243859 */   GIM_Try, /*On fail goto*//*Label 4671*/ GIMT_Encode4(243901), // Rule ID 8581 //
     /* 243864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 243872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 243875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 243881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 243884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243888 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1625:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 243888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 243891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243897 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243899 */     GIR_RootConstrainSelectedInstOperands,
     /* 243900 */     // GIR_Coverage, 8581,
     /* 243900 */     GIR_EraseRootFromParent_Done,
     /* 243901 */   // Label 4671: @243901
     /* 243901 */   GIM_Try, /*On fail goto*//*Label 4672*/ GIMT_Encode4(243943), // Rule ID 8582 //
     /* 243906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 243914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 243917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 243923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 243926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243930 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1625:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 243930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 243933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243937 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243939 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243941 */     GIR_RootConstrainSelectedInstOperands,
     /* 243942 */     // GIR_Coverage, 8582,
     /* 243942 */     GIR_EraseRootFromParent_Done,
     /* 243943 */   // Label 4672: @243943
     /* 243943 */   GIM_Try, /*On fail goto*//*Label 4673*/ GIMT_Encode4(243985), // Rule ID 8583 //
     /* 243948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 243956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 243959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 243965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 243968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243972 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1625:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 243972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 243975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243981 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243983 */     GIR_RootConstrainSelectedInstOperands,
     /* 243984 */     // GIR_Coverage, 8583,
     /* 243984 */     GIR_EraseRootFromParent_Done,
     /* 243985 */   // Label 4673: @243985
     /* 243985 */   GIM_Try, /*On fail goto*//*Label 4674*/ GIMT_Encode4(244027), // Rule ID 8584 //
     /* 243990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 243998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 244001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 244004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 244007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 244010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 244014 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1625:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 244014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 244017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244023 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244025 */     GIR_RootConstrainSelectedInstOperands,
     /* 244026 */     // GIR_Coverage, 8584,
     /* 244026 */     GIR_EraseRootFromParent_Done,
     /* 244027 */   // Label 4674: @244027
     /* 244027 */   GIM_Try, /*On fail goto*//*Label 4675*/ GIMT_Encode4(244069), // Rule ID 8585 //
     /* 244032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 244040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 244043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 244046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 244049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 244052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 244056 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1621:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 244056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 244059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244065 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244067 */     GIR_RootConstrainSelectedInstOperands,
     /* 244068 */     // GIR_Coverage, 8585,
     /* 244068 */     GIR_EraseRootFromParent_Done,
     /* 244069 */   // Label 4675: @244069
     /* 244069 */   GIM_Try, /*On fail goto*//*Label 4676*/ GIMT_Encode4(244111), // Rule ID 8586 //
     /* 244074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 244082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 244085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 244091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 244094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 244098 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1621:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 244098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 244101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244107 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244109 */     GIR_RootConstrainSelectedInstOperands,
     /* 244110 */     // GIR_Coverage, 8586,
     /* 244110 */     GIR_EraseRootFromParent_Done,
     /* 244111 */   // Label 4676: @244111
     /* 244111 */   GIM_Try, /*On fail goto*//*Label 4677*/ GIMT_Encode4(244153), // Rule ID 8587 //
     /* 244116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 244124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 244127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 244133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 244136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 244140 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1621:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 244140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 244143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244147 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244149 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244151 */     GIR_RootConstrainSelectedInstOperands,
     /* 244152 */     // GIR_Coverage, 8587,
     /* 244152 */     GIR_EraseRootFromParent_Done,
     /* 244153 */   // Label 4677: @244153
     /* 244153 */   GIM_Try, /*On fail goto*//*Label 4678*/ GIMT_Encode4(244195), // Rule ID 8588 //
     /* 244158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 244166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 244169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 244175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 244178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 244182 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1621:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 244182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 244185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244191 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244193 */     GIR_RootConstrainSelectedInstOperands,
     /* 244194 */     // GIR_Coverage, 8588,
     /* 244194 */     GIR_EraseRootFromParent_Done,
     /* 244195 */   // Label 4678: @244195
     /* 244195 */   GIM_Try, /*On fail goto*//*Label 4679*/ GIMT_Encode4(244237), // Rule ID 8589 //
     /* 244200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 244208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 244211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 244214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 244217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 244220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 244224 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1621:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 244224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 244227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244233 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244235 */     GIR_RootConstrainSelectedInstOperands,
     /* 244236 */     // GIR_Coverage, 8589,
     /* 244236 */     GIR_EraseRootFromParent_Done,
     /* 244237 */   // Label 4679: @244237
     /* 244237 */   GIM_Try, /*On fail goto*//*Label 4680*/ GIMT_Encode4(244279), // Rule ID 8597 //
     /* 244242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 244250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 244253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 244256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 244259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 244262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244266 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1318:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (CLASTB_ZPZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 244266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_B),
     /* 244269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244273 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244275 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244277 */     GIR_RootConstrainSelectedInstOperands,
     /* 244278 */     // GIR_Coverage, 8597,
     /* 244278 */     GIR_EraseRootFromParent_Done,
     /* 244279 */   // Label 4680: @244279
     /* 244279 */   GIM_Try, /*On fail goto*//*Label 4681*/ GIMT_Encode4(244321), // Rule ID 8598 //
     /* 244284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 244292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244308 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1318:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (CLASTB_ZPZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 244308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_H),
     /* 244311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244317 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244319 */     GIR_RootConstrainSelectedInstOperands,
     /* 244320 */     // GIR_Coverage, 8598,
     /* 244320 */     GIR_EraseRootFromParent_Done,
     /* 244321 */   // Label 4681: @244321
     /* 244321 */   GIM_Try, /*On fail goto*//*Label 4682*/ GIMT_Encode4(244363), // Rule ID 8599 //
     /* 244326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 244334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244350 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1318:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (CLASTB_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 244350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_S),
     /* 244353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244357 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244359 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244361 */     GIR_RootConstrainSelectedInstOperands,
     /* 244362 */     // GIR_Coverage, 8599,
     /* 244362 */     GIR_EraseRootFromParent_Done,
     /* 244363 */   // Label 4682: @244363
     /* 244363 */   GIM_Try, /*On fail goto*//*Label 4683*/ GIMT_Encode4(244405), // Rule ID 8600 //
     /* 244368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 244376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244392 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1318:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CLASTB_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_D),
     /* 244395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244401 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244403 */     GIR_RootConstrainSelectedInstOperands,
     /* 244404 */     // GIR_Coverage, 8600,
     /* 244404 */     GIR_EraseRootFromParent_Done,
     /* 244405 */   // Label 4683: @244405
     /* 244405 */   GIM_Try, /*On fail goto*//*Label 4684*/ GIMT_Encode4(244447), // Rule ID 8601 //
     /* 244410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 244418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244434 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1318:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (CLASTB_ZPZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 244434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_H),
     /* 244437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244441 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244443 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244445 */     GIR_RootConstrainSelectedInstOperands,
     /* 244446 */     // GIR_Coverage, 8601,
     /* 244446 */     GIR_EraseRootFromParent_Done,
     /* 244447 */   // Label 4684: @244447
     /* 244447 */   GIM_Try, /*On fail goto*//*Label 4685*/ GIMT_Encode4(244489), // Rule ID 8602 //
     /* 244452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 244460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244476 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1318:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (CLASTB_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 244476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_S),
     /* 244479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244485 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244487 */     GIR_RootConstrainSelectedInstOperands,
     /* 244488 */     // GIR_Coverage, 8602,
     /* 244488 */     GIR_EraseRootFromParent_Done,
     /* 244489 */   // Label 4685: @244489
     /* 244489 */   GIM_Try, /*On fail goto*//*Label 4686*/ GIMT_Encode4(244531), // Rule ID 8603 //
     /* 244494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 244502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244518 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1318:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (CLASTB_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 244518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_D),
     /* 244521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244525 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244527 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244529 */     GIR_RootConstrainSelectedInstOperands,
     /* 244530 */     // GIR_Coverage, 8603,
     /* 244530 */     GIR_EraseRootFromParent_Done,
     /* 244531 */   // Label 4686: @244531
     /* 244531 */   GIM_Try, /*On fail goto*//*Label 4687*/ GIMT_Encode4(244576), // Rule ID 9299 //
     /* 244536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 244544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 244547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 244550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 244553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244560 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1339:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_B),
     /* 244563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244567 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244569 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244571 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 244574 */     GIR_RootConstrainSelectedInstOperands,
     /* 244575 */     // GIR_Coverage, 9299,
     /* 244575 */     GIR_EraseRootFromParent_Done,
     /* 244576 */   // Label 4687: @244576
     /* 244576 */   GIM_Try, /*On fail goto*//*Label 4688*/ GIMT_Encode4(244621), // Rule ID 9300 //
     /* 244581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 244589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 244592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244605 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1339:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_H),
     /* 244608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244614 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244616 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 244619 */     GIR_RootConstrainSelectedInstOperands,
     /* 244620 */     // GIR_Coverage, 9300,
     /* 244620 */     GIR_EraseRootFromParent_Done,
     /* 244621 */   // Label 4688: @244621
     /* 244621 */   GIM_Try, /*On fail goto*//*Label 4689*/ GIMT_Encode4(244666), // Rule ID 9301 //
     /* 244626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 244634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 244637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244650 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1339:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_S),
     /* 244653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244659 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244661 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 244664 */     GIR_RootConstrainSelectedInstOperands,
     /* 244665 */     // GIR_Coverage, 9301,
     /* 244665 */     GIR_EraseRootFromParent_Done,
     /* 244666 */   // Label 4689: @244666
     /* 244666 */   GIM_Try, /*On fail goto*//*Label 4690*/ GIMT_Encode4(244711), // Rule ID 9302 //
     /* 244671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 244679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 244682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 244685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 244688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244695 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1329:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_B),
     /* 244698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244702 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244704 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244706 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 244709 */     GIR_RootConstrainSelectedInstOperands,
     /* 244710 */     // GIR_Coverage, 9302,
     /* 244710 */     GIR_EraseRootFromParent_Done,
     /* 244711 */   // Label 4690: @244711
     /* 244711 */   GIM_Try, /*On fail goto*//*Label 4691*/ GIMT_Encode4(244756), // Rule ID 9303 //
     /* 244716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 244724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 244727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244740 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1329:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_H),
     /* 244743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244747 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244749 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244751 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 244754 */     GIR_RootConstrainSelectedInstOperands,
     /* 244755 */     // GIR_Coverage, 9303,
     /* 244755 */     GIR_EraseRootFromParent_Done,
     /* 244756 */   // Label 4691: @244756
     /* 244756 */   GIM_Try, /*On fail goto*//*Label 4692*/ GIMT_Encode4(244801), // Rule ID 9304 //
     /* 244761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 244769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 244772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244785 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1329:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_S),
     /* 244788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244794 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244796 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 244799 */     GIR_RootConstrainSelectedInstOperands,
     /* 244800 */     // GIR_Coverage, 9304,
     /* 244800 */     GIR_EraseRootFromParent_Done,
     /* 244801 */   // Label 4692: @244801
     /* 244801 */   GIM_Try, /*On fail goto*//*Label 4693*/ GIMT_Encode4(244846), // Rule ID 9305 //
     /* 244806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 244814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 244817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 244820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 244823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244830 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1337:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_B),
     /* 244833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244839 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244841 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 244844 */     GIR_RootConstrainSelectedInstOperands,
     /* 244845 */     // GIR_Coverage, 9305,
     /* 244845 */     GIR_EraseRootFromParent_Done,
     /* 244846 */   // Label 4693: @244846
     /* 244846 */   GIM_Try, /*On fail goto*//*Label 4694*/ GIMT_Encode4(244891), // Rule ID 9306 //
     /* 244851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 244859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 244862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244875 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1337:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_H),
     /* 244878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244884 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244886 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 244889 */     GIR_RootConstrainSelectedInstOperands,
     /* 244890 */     // GIR_Coverage, 9306,
     /* 244890 */     GIR_EraseRootFromParent_Done,
     /* 244891 */   // Label 4694: @244891
     /* 244891 */   GIM_Try, /*On fail goto*//*Label 4695*/ GIMT_Encode4(244936), // Rule ID 9307 //
     /* 244896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 244904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 244907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244920 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1337:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_S),
     /* 244923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244929 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244931 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 244934 */     GIR_RootConstrainSelectedInstOperands,
     /* 244935 */     // GIR_Coverage, 9307,
     /* 244935 */     GIR_EraseRootFromParent_Done,
     /* 244936 */   // Label 4695: @244936
     /* 244936 */   GIM_Try, /*On fail goto*//*Label 4696*/ GIMT_Encode4(244981), // Rule ID 9308 //
     /* 244941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 244949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 244952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 244955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 244958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244965 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1334:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_B),
     /* 244968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244972 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244974 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244976 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 244979 */     GIR_RootConstrainSelectedInstOperands,
     /* 244980 */     // GIR_Coverage, 9308,
     /* 244980 */     GIR_EraseRootFromParent_Done,
     /* 244981 */   // Label 4696: @244981
     /* 244981 */   GIM_Try, /*On fail goto*//*Label 4697*/ GIMT_Encode4(245026), // Rule ID 9309 //
     /* 244986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 244994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 244997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 245000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245010 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1334:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_H),
     /* 245013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245017 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245019 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245021 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245024 */     GIR_RootConstrainSelectedInstOperands,
     /* 245025 */     // GIR_Coverage, 9309,
     /* 245025 */     GIR_EraseRootFromParent_Done,
     /* 245026 */   // Label 4697: @245026
     /* 245026 */   GIM_Try, /*On fail goto*//*Label 4698*/ GIMT_Encode4(245071), // Rule ID 9310 //
     /* 245031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 245039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 245042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 245045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245055 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1334:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_S),
     /* 245058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245064 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245066 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245069 */     GIR_RootConstrainSelectedInstOperands,
     /* 245070 */     // GIR_Coverage, 9310,
     /* 245070 */     GIR_EraseRootFromParent_Done,
     /* 245071 */   // Label 4698: @245071
     /* 245071 */   GIM_Try, /*On fail goto*//*Label 4699*/ GIMT_Encode4(245116), // Rule ID 9311 //
     /* 245076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 245084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 245087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 245090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 245093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245100 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1333:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_B),
     /* 245103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245109 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245111 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245114 */     GIR_RootConstrainSelectedInstOperands,
     /* 245115 */     // GIR_Coverage, 9311,
     /* 245115 */     GIR_EraseRootFromParent_Done,
     /* 245116 */   // Label 4699: @245116
     /* 245116 */   GIM_Try, /*On fail goto*//*Label 4700*/ GIMT_Encode4(245161), // Rule ID 9312 //
     /* 245121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 245129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 245132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 245135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245145 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1333:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_H),
     /* 245148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245152 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245154 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245156 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245159 */     GIR_RootConstrainSelectedInstOperands,
     /* 245160 */     // GIR_Coverage, 9312,
     /* 245160 */     GIR_EraseRootFromParent_Done,
     /* 245161 */   // Label 4700: @245161
     /* 245161 */   GIM_Try, /*On fail goto*//*Label 4701*/ GIMT_Encode4(245206), // Rule ID 9313 //
     /* 245166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 245174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 245177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 245180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245190 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1333:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_S),
     /* 245193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245197 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245199 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245201 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245204 */     GIR_RootConstrainSelectedInstOperands,
     /* 245205 */     // GIR_Coverage, 9313,
     /* 245205 */     GIR_EraseRootFromParent_Done,
     /* 245206 */   // Label 4701: @245206
     /* 245206 */   GIM_Try, /*On fail goto*//*Label 4702*/ GIMT_Encode4(245251), // Rule ID 9314 //
     /* 245211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 245219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 245222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 245225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 245228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245235 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1331:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_B),
     /* 245238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245244 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245246 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245249 */     GIR_RootConstrainSelectedInstOperands,
     /* 245250 */     // GIR_Coverage, 9314,
     /* 245250 */     GIR_EraseRootFromParent_Done,
     /* 245251 */   // Label 4702: @245251
     /* 245251 */   GIM_Try, /*On fail goto*//*Label 4703*/ GIMT_Encode4(245296), // Rule ID 9315 //
     /* 245256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 245264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 245267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 245270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245280 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1331:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_H),
     /* 245283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245287 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245289 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245291 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245294 */     GIR_RootConstrainSelectedInstOperands,
     /* 245295 */     // GIR_Coverage, 9315,
     /* 245295 */     GIR_EraseRootFromParent_Done,
     /* 245296 */   // Label 4703: @245296
     /* 245296 */   GIM_Try, /*On fail goto*//*Label 4704*/ GIMT_Encode4(245341), // Rule ID 9316 //
     /* 245301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 245309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 245312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 245315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245325 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1331:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_S),
     /* 245328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245332 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245334 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245336 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245339 */     GIR_RootConstrainSelectedInstOperands,
     /* 245340 */     // GIR_Coverage, 9316,
     /* 245340 */     GIR_EraseRootFromParent_Done,
     /* 245341 */   // Label 4704: @245341
     /* 245341 */   GIM_Try, /*On fail goto*//*Label 4705*/ GIMT_Encode4(245386), // Rule ID 9317 //
     /* 245346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 245354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 245357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 245360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 245363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245370 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1335:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_B),
     /* 245373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245377 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245379 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245381 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245384 */     GIR_RootConstrainSelectedInstOperands,
     /* 245385 */     // GIR_Coverage, 9317,
     /* 245385 */     GIR_EraseRootFromParent_Done,
     /* 245386 */   // Label 4705: @245386
     /* 245386 */   GIM_Try, /*On fail goto*//*Label 4706*/ GIMT_Encode4(245431), // Rule ID 9318 //
     /* 245391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 245399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 245402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 245405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245415 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1335:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_H),
     /* 245418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245424 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245426 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245429 */     GIR_RootConstrainSelectedInstOperands,
     /* 245430 */     // GIR_Coverage, 9318,
     /* 245430 */     GIR_EraseRootFromParent_Done,
     /* 245431 */   // Label 4706: @245431
     /* 245431 */   GIM_Try, /*On fail goto*//*Label 4707*/ GIMT_Encode4(245476), // Rule ID 9319 //
     /* 245436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 245444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 245447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 245450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245460 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1335:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_S),
     /* 245463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245469 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245471 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245474 */     GIR_RootConstrainSelectedInstOperands,
     /* 245475 */     // GIR_Coverage, 9319,
     /* 245475 */     GIR_EraseRootFromParent_Done,
     /* 245476 */   // Label 4707: @245476
     /* 245476 */   GIM_Try, /*On fail goto*//*Label 4708*/ GIMT_Encode4(245521), // Rule ID 9320 //
     /* 245481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 245489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 245492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 245495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 245498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245505 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1336:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_B),
     /* 245508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245514 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245516 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245519 */     GIR_RootConstrainSelectedInstOperands,
     /* 245520 */     // GIR_Coverage, 9320,
     /* 245520 */     GIR_EraseRootFromParent_Done,
     /* 245521 */   // Label 4708: @245521
     /* 245521 */   GIM_Try, /*On fail goto*//*Label 4709*/ GIMT_Encode4(245566), // Rule ID 9321 //
     /* 245526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 245534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 245537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 245540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245550 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1336:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_H),
     /* 245553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245557 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245559 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245561 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245564 */     GIR_RootConstrainSelectedInstOperands,
     /* 245565 */     // GIR_Coverage, 9321,
     /* 245565 */     GIR_EraseRootFromParent_Done,
     /* 245566 */   // Label 4709: @245566
     /* 245566 */   GIM_Try, /*On fail goto*//*Label 4710*/ GIMT_Encode4(245611), // Rule ID 9322 //
     /* 245571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 245579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 245582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 245585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245595 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1336:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_S),
     /* 245598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245602 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245604 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245606 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245609 */     GIR_RootConstrainSelectedInstOperands,
     /* 245610 */     // GIR_Coverage, 9322,
     /* 245610 */     GIR_EraseRootFromParent_Done,
     /* 245611 */   // Label 4710: @245611
     /* 245611 */   GIM_Try, /*On fail goto*//*Label 4711*/ GIMT_Encode4(245653), // Rule ID 9719 //
     /* 245616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 245624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 245627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 245630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245640 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1372:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FACGT_PPzZZ_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 245640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_H),
     /* 245643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245647 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245649 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245651 */     GIR_RootConstrainSelectedInstOperands,
     /* 245652 */     // GIR_Coverage, 9719,
     /* 245652 */     GIR_EraseRootFromParent_Done,
     /* 245653 */   // Label 4711: @245653
     /* 245653 */   GIM_Try, /*On fail goto*//*Label 4712*/ GIMT_Encode4(245695), // Rule ID 9720 //
     /* 245658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 245666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 245669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 245672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245682 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1372:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FACGT_PPzZZ_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 245682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_S),
     /* 245685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245689 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245691 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245693 */     GIR_RootConstrainSelectedInstOperands,
     /* 245694 */     // GIR_Coverage, 9720,
     /* 245694 */     GIR_EraseRootFromParent_Done,
     /* 245695 */   // Label 4712: @245695
     /* 245695 */   GIM_Try, /*On fail goto*//*Label 4713*/ GIMT_Encode4(245737), // Rule ID 9721 //
     /* 245700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 245708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 245711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 245714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 245717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245724 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1372:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FACGT_PPzZZ_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 245724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_D),
     /* 245727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245733 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245735 */     GIR_RootConstrainSelectedInstOperands,
     /* 245736 */     // GIR_Coverage, 9721,
     /* 245736 */     GIR_EraseRootFromParent_Done,
     /* 245737 */   // Label 4713: @245737
     /* 245737 */   GIM_Try, /*On fail goto*//*Label 4714*/ GIMT_Encode4(245779), // Rule ID 10259 //
     /* 245742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 245750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 245753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 245756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 245759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 245762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245766 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1603:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (LSR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 245766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_B),
     /* 245769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 245771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245773 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245775 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245777 */     GIR_RootConstrainSelectedInstOperands,
     /* 245778 */     // GIR_Coverage, 10259,
     /* 245778 */     GIR_EraseRootFromParent_Done,
     /* 245779 */   // Label 4714: @245779
     /* 245779 */   GIM_Try, /*On fail goto*//*Label 4715*/ GIMT_Encode4(245821), // Rule ID 10260 //
     /* 245784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 245792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 245795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 245798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245808 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1603:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (LSR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 245808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_H),
     /* 245811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 245813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245815 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245817 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245819 */     GIR_RootConstrainSelectedInstOperands,
     /* 245820 */     // GIR_Coverage, 10260,
     /* 245820 */     GIR_EraseRootFromParent_Done,
     /* 245821 */   // Label 4715: @245821
     /* 245821 */   GIM_Try, /*On fail goto*//*Label 4716*/ GIMT_Encode4(245863), // Rule ID 10261 //
     /* 245826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 245834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 245840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245850 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1603:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (LSR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 245850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_S),
     /* 245853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 245855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245857 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245859 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245861 */     GIR_RootConstrainSelectedInstOperands,
     /* 245862 */     // GIR_Coverage, 10261,
     /* 245862 */     GIR_EraseRootFromParent_Done,
     /* 245863 */   // Label 4716: @245863
     /* 245863 */   GIM_Try, /*On fail goto*//*Label 4717*/ GIMT_Encode4(245905), // Rule ID 10262 //
     /* 245868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 245876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 245882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 245885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245892 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1603:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_D),
     /* 245895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 245897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245899 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245901 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245903 */     GIR_RootConstrainSelectedInstOperands,
     /* 245904 */     // GIR_Coverage, 10262,
     /* 245904 */     GIR_EraseRootFromParent_Done,
     /* 245905 */   // Label 4717: @245905
     /* 245905 */   GIM_Try, /*On fail goto*//*Label 4718*/ GIMT_Encode4(245947), // Rule ID 10263 //
     /* 245910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 245918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 245921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 245924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 245927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 245930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245934 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1600:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (LSL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 245934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_B),
     /* 245937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 245939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245941 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245943 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245945 */     GIR_RootConstrainSelectedInstOperands,
     /* 245946 */     // GIR_Coverage, 10263,
     /* 245946 */     GIR_EraseRootFromParent_Done,
     /* 245947 */   // Label 4718: @245947
     /* 245947 */   GIM_Try, /*On fail goto*//*Label 4719*/ GIMT_Encode4(245989), // Rule ID 10264 //
     /* 245952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 245960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 245963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 245966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245976 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1600:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (LSL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 245976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_H),
     /* 245979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 245981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245985 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245987 */     GIR_RootConstrainSelectedInstOperands,
     /* 245988 */     // GIR_Coverage, 10264,
     /* 245988 */     GIR_EraseRootFromParent_Done,
     /* 245989 */   // Label 4719: @245989
     /* 245989 */   GIM_Try, /*On fail goto*//*Label 4720*/ GIMT_Encode4(246031), // Rule ID 10265 //
     /* 245994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 246002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246018 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1600:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (LSL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 246018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_S),
     /* 246021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246025 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246027 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246029 */     GIR_RootConstrainSelectedInstOperands,
     /* 246030 */     // GIR_Coverage, 10265,
     /* 246030 */     GIR_EraseRootFromParent_Done,
     /* 246031 */   // Label 4720: @246031
     /* 246031 */   GIM_Try, /*On fail goto*//*Label 4721*/ GIMT_Encode4(246073), // Rule ID 10266 //
     /* 246036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 246044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 246050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 246053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246060 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1600:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_D),
     /* 246063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246069 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246071 */     GIR_RootConstrainSelectedInstOperands,
     /* 246072 */     // GIR_Coverage, 10266,
     /* 246072 */     GIR_EraseRootFromParent_Done,
     /* 246073 */   // Label 4721: @246073
     /* 246073 */   GIM_Try, /*On fail goto*//*Label 4722*/ GIMT_Encode4(246115), // Rule ID 10279 //
     /* 246078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 246086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 246089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 246092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246102 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1605:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_B),
     /* 246105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246111 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246113 */     GIR_RootConstrainSelectedInstOperands,
     /* 246114 */     // GIR_Coverage, 10279,
     /* 246114 */     GIR_EraseRootFromParent_Done,
     /* 246115 */   // Label 4722: @246115
     /* 246115 */   GIM_Try, /*On fail goto*//*Label 4723*/ GIMT_Encode4(246157), // Rule ID 10280 //
     /* 246120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 246128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 246134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246144 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1605:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_H),
     /* 246147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246153 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246155 */     GIR_RootConstrainSelectedInstOperands,
     /* 246156 */     // GIR_Coverage, 10280,
     /* 246156 */     GIR_EraseRootFromParent_Done,
     /* 246157 */   // Label 4723: @246157
     /* 246157 */   GIM_Try, /*On fail goto*//*Label 4724*/ GIMT_Encode4(246199), // Rule ID 10281 //
     /* 246162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 246170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246186 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1605:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_S),
     /* 246189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246195 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246197 */     GIR_RootConstrainSelectedInstOperands,
     /* 246198 */     // GIR_Coverage, 10281,
     /* 246198 */     GIR_EraseRootFromParent_Done,
     /* 246199 */   // Label 4724: @246199
     /* 246199 */   GIM_Try, /*On fail goto*//*Label 4725*/ GIMT_Encode4(246241), // Rule ID 10282 //
     /* 246204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 246212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 246215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 246218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246228 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1602:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_B),
     /* 246231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246237 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246239 */     GIR_RootConstrainSelectedInstOperands,
     /* 246240 */     // GIR_Coverage, 10282,
     /* 246240 */     GIR_EraseRootFromParent_Done,
     /* 246241 */   // Label 4725: @246241
     /* 246241 */   GIM_Try, /*On fail goto*//*Label 4726*/ GIMT_Encode4(246283), // Rule ID 10283 //
     /* 246246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 246254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 246260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246270 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1602:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_H),
     /* 246273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246277 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246279 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246281 */     GIR_RootConstrainSelectedInstOperands,
     /* 246282 */     // GIR_Coverage, 10283,
     /* 246282 */     GIR_EraseRootFromParent_Done,
     /* 246283 */   // Label 4726: @246283
     /* 246283 */   GIM_Try, /*On fail goto*//*Label 4727*/ GIMT_Encode4(246325), // Rule ID 10284 //
     /* 246288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 246296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246312 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1602:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_S),
     /* 246315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246319 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246321 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246323 */     GIR_RootConstrainSelectedInstOperands,
     /* 246324 */     // GIR_Coverage, 10284,
     /* 246324 */     GIR_EraseRootFromParent_Done,
     /* 246325 */   // Label 4727: @246325
     /* 246325 */   GIM_Try, /*On fail goto*//*Label 4728*/ GIMT_Encode4(246367), // Rule ID 10311 //
     /* 246330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f16f64),
     /* 246338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 246344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246354 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1397:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVT_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 246354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_DtoH),
     /* 246357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246361 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246363 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246365 */     GIR_RootConstrainSelectedInstOperands,
     /* 246366 */     // GIR_Coverage, 10311,
     /* 246366 */     GIR_EraseRootFromParent_Done,
     /* 246367 */   // Label 4728: @246367
     /* 246367 */   GIM_Try, /*On fail goto*//*Label 4729*/ GIMT_Encode4(246409), // Rule ID 10315 //
     /* 246372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f64f16),
     /* 246380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246396 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1400:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVT_ZPmZ_HtoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 246396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_HtoD),
     /* 246399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246405 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246407 */     GIR_RootConstrainSelectedInstOperands,
     /* 246408 */     // GIR_Coverage, 10315,
     /* 246408 */     GIR_EraseRootFromParent_Done,
     /* 246409 */   // Label 4729: @246409
     /* 246409 */   GIM_Try, /*On fail goto*//*Label 4730*/ GIMT_Encode4(246451), // Rule ID 10319 //
     /* 246414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f32f64),
     /* 246422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246438 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1399:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 246438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_DtoS),
     /* 246441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246447 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246449 */     GIR_RootConstrainSelectedInstOperands,
     /* 246450 */     // GIR_Coverage, 10319,
     /* 246450 */     GIR_EraseRootFromParent_Done,
     /* 246451 */   // Label 4730: @246451
     /* 246451 */   GIM_Try, /*On fail goto*//*Label 4731*/ GIMT_Encode4(246493), // Rule ID 10323 //
     /* 246456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f64f32),
     /* 246464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246480 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1401:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVT_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 246480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_StoD),
     /* 246483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246489 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246491 */     GIR_RootConstrainSelectedInstOperands,
     /* 246492 */     // GIR_Coverage, 10323,
     /* 246492 */     GIR_EraseRootFromParent_Done,
     /* 246493 */   // Label 4731: @246493
     /* 246493 */   GIM_Try, /*On fail goto*//*Label 4732*/ GIMT_Encode4(246535), // Rule ID 10327 //
     /* 246498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f64i32),
     /* 246506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246522 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1713:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCVTF_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 246522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_StoD),
     /* 246525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246531 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246533 */     GIR_RootConstrainSelectedInstOperands,
     /* 246534 */     // GIR_Coverage, 10327,
     /* 246534 */     GIR_EraseRootFromParent_Done,
     /* 246535 */   // Label 4732: @246535
     /* 246535 */   GIM_Try, /*On fail goto*//*Label 4733*/ GIMT_Encode4(246577), // Rule ID 10328 //
     /* 246540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f64i32),
     /* 246548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246564 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1960:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCVTF_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 246564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_StoD),
     /* 246567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246571 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246573 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246575 */     GIR_RootConstrainSelectedInstOperands,
     /* 246576 */     // GIR_Coverage, 10328,
     /* 246576 */     GIR_EraseRootFromParent_Done,
     /* 246577 */   // Label 4733: @246577
     /* 246577 */   GIM_Try, /*On fail goto*//*Label 4734*/ GIMT_Encode4(246619), // Rule ID 10329 //
     /* 246582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f16i32),
     /* 246590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 246596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 246599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246606 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1957:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCVTF_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 246606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_StoH),
     /* 246609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246615 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246617 */     GIR_RootConstrainSelectedInstOperands,
     /* 246618 */     // GIR_Coverage, 10329,
     /* 246618 */     GIR_EraseRootFromParent_Done,
     /* 246619 */   // Label 4734: @246619
     /* 246619 */   GIM_Try, /*On fail goto*//*Label 4735*/ GIMT_Encode4(246661), // Rule ID 10333 //
     /* 246624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f32i64),
     /* 246632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246648 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1712:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCVTF_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_DtoS),
     /* 246651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246655 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246657 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246659 */     GIR_RootConstrainSelectedInstOperands,
     /* 246660 */     // GIR_Coverage, 10333,
     /* 246660 */     GIR_EraseRootFromParent_Done,
     /* 246661 */   // Label 4735: @246661
     /* 246661 */   GIM_Try, /*On fail goto*//*Label 4736*/ GIMT_Encode4(246703), // Rule ID 10337 //
     /* 246666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f16i32),
     /* 246674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 246680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 246683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246690 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1710:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCVTF_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 246690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_StoH),
     /* 246693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246699 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246701 */     GIR_RootConstrainSelectedInstOperands,
     /* 246702 */     // GIR_Coverage, 10337,
     /* 246702 */     GIR_EraseRootFromParent_Done,
     /* 246703 */   // Label 4736: @246703
     /* 246703 */   GIM_Try, /*On fail goto*//*Label 4737*/ GIMT_Encode4(246745), // Rule ID 10341 //
     /* 246708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f16i64),
     /* 246716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 246722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246732 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1711:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCVTF_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_DtoH),
     /* 246735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246739 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246741 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246743 */     GIR_RootConstrainSelectedInstOperands,
     /* 246744 */     // GIR_Coverage, 10341,
     /* 246744 */     GIR_EraseRootFromParent_Done,
     /* 246745 */   // Label 4737: @246745
     /* 246745 */   GIM_Try, /*On fail goto*//*Label 4738*/ GIMT_Encode4(246787), // Rule ID 10345 //
     /* 246750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f32i64),
     /* 246758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246774 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1959:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCVTF_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_DtoS),
     /* 246777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246781 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246783 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246785 */     GIR_RootConstrainSelectedInstOperands,
     /* 246786 */     // GIR_Coverage, 10345,
     /* 246786 */     GIR_EraseRootFromParent_Done,
     /* 246787 */   // Label 4738: @246787
     /* 246787 */   GIM_Try, /*On fail goto*//*Label 4739*/ GIMT_Encode4(246829), // Rule ID 10349 //
     /* 246792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f16i64),
     /* 246800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 246806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246816 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1958:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCVTF_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_DtoH),
     /* 246819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246825 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246827 */     GIR_RootConstrainSelectedInstOperands,
     /* 246828 */     // GIR_Coverage, 10349,
     /* 246828 */     GIR_EraseRootFromParent_Done,
     /* 246829 */   // Label 4739: @246829
     /* 246829 */   GIM_Try, /*On fail goto*//*Label 4740*/ GIMT_Encode4(246871), // Rule ID 10359 //
     /* 246834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i32f64),
     /* 246842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246858 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1415:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTZS_ZPmZ_DtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 246858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_DtoS),
     /* 246861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246867 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246869 */     GIR_RootConstrainSelectedInstOperands,
     /* 246870 */     // GIR_Coverage, 10359,
     /* 246870 */     GIR_EraseRootFromParent_Done,
     /* 246871 */   // Label 4740: @246871
     /* 246871 */   GIM_Try, /*On fail goto*//*Label 4741*/ GIMT_Encode4(246913), // Rule ID 10360 //
     /* 246876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i32f64),
     /* 246884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246900 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1422:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTZU_ZPmZ_DtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 246900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_DtoS),
     /* 246903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246907 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246909 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246911 */     GIR_RootConstrainSelectedInstOperands,
     /* 246912 */     // GIR_Coverage, 10360,
     /* 246912 */     GIR_EraseRootFromParent_Done,
     /* 246913 */   // Label 4741: @246913
     /* 246913 */   GIM_Try, /*On fail goto*//*Label 4742*/ GIMT_Encode4(246955), // Rule ID 10361 //
     /* 246918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i64f32),
     /* 246926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246942 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1417:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTZS_ZPmZ_StoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 246942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_StoD),
     /* 246945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246951 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246953 */     GIR_RootConstrainSelectedInstOperands,
     /* 246954 */     // GIR_Coverage, 10361,
     /* 246954 */     GIR_EraseRootFromParent_Done,
     /* 246955 */   // Label 4742: @246955
     /* 246955 */   GIM_Try, /*On fail goto*//*Label 4743*/ GIMT_Encode4(246997), // Rule ID 10365 //
     /* 246960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i32f16),
     /* 246968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 246977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246984 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1414:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZS_ZPmZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 246984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_HtoS),
     /* 246987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246993 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246995 */     GIR_RootConstrainSelectedInstOperands,
     /* 246996 */     // GIR_Coverage, 10365,
     /* 246996 */     GIR_EraseRootFromParent_Done,
     /* 246997 */   // Label 4743: @246997
     /* 246997 */   GIM_Try, /*On fail goto*//*Label 4744*/ GIMT_Encode4(247039), // Rule ID 10369 //
     /* 247002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i64f16),
     /* 247010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 247019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247026 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1416:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZS_ZPmZ_HtoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 247026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_HtoD),
     /* 247029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 247031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247035 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247037 */     GIR_RootConstrainSelectedInstOperands,
     /* 247038 */     // GIR_Coverage, 10369,
     /* 247038 */     GIR_EraseRootFromParent_Done,
     /* 247039 */   // Label 4744: @247039
     /* 247039 */   GIM_Try, /*On fail goto*//*Label 4745*/ GIMT_Encode4(247081), // Rule ID 10373 //
     /* 247044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i32f16),
     /* 247052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 247061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247068 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1421:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZU_ZPmZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 247068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_HtoS),
     /* 247071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 247073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247077 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247079 */     GIR_RootConstrainSelectedInstOperands,
     /* 247080 */     // GIR_Coverage, 10373,
     /* 247080 */     GIR_EraseRootFromParent_Done,
     /* 247081 */   // Label 4745: @247081
     /* 247081 */   GIM_Try, /*On fail goto*//*Label 4746*/ GIMT_Encode4(247123), // Rule ID 10377 //
     /* 247086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i64f16),
     /* 247094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 247103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247110 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1423:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZU_ZPmZ_HtoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 247110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_HtoD),
     /* 247113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 247115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247117 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247119 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247121 */     GIR_RootConstrainSelectedInstOperands,
     /* 247122 */     // GIR_Coverage, 10377,
     /* 247122 */     GIR_EraseRootFromParent_Done,
     /* 247123 */   // Label 4746: @247123
     /* 247123 */   GIM_Try, /*On fail goto*//*Label 4747*/ GIMT_Encode4(247165), // Rule ID 10381 //
     /* 247128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i64f32),
     /* 247136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 247145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247152 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1424:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTZU_ZPmZ_StoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 247152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_StoD),
     /* 247155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 247157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247161 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247163 */     GIR_RootConstrainSelectedInstOperands,
     /* 247164 */     // GIR_Coverage, 10381,
     /* 247164 */     GIR_EraseRootFromParent_Done,
     /* 247165 */   // Label 4747: @247165
     /* 247165 */   GIM_Try, /*On fail goto*//*Label 4748*/ GIMT_Encode4(247207), // Rule ID 11378 //
     /* 247170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 247173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ummla),
     /* 247178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 247190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247194 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1999:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 247194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMMLA_ZZZ),
     /* 247197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247201 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247203 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247205 */     GIR_RootConstrainSelectedInstOperands,
     /* 247206 */     // GIR_Coverage, 11378,
     /* 247206 */     GIR_EraseRootFromParent_Done,
     /* 247207 */   // Label 4748: @247207
     /* 247207 */   GIM_Try, /*On fail goto*//*Label 4749*/ GIMT_Encode4(247249), // Rule ID 11379 //
     /* 247212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 247215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usmmla),
     /* 247220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 247232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247236 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2070:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (USMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 247236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMMLA_ZZZ),
     /* 247239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247245 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247247 */     GIR_RootConstrainSelectedInstOperands,
     /* 247248 */     // GIR_Coverage, 11379,
     /* 247248 */     GIR_EraseRootFromParent_Done,
     /* 247249 */   // Label 4749: @247249
     /* 247249 */   GIM_Try, /*On fail goto*//*Label 4750*/ GIMT_Encode4(247291), // Rule ID 11381 //
     /* 247254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP32_HasSVE),
     /* 247257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmmla),
     /* 247262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247278 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1485:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMMLA_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 247278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMMLA_ZZZ_S),
     /* 247281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247287 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247289 */     GIR_RootConstrainSelectedInstOperands,
     /* 247290 */     // GIR_Coverage, 11381,
     /* 247290 */     GIR_EraseRootFromParent_Done,
     /* 247291 */   // Label 4750: @247291
     /* 247291 */   GIM_Try, /*On fail goto*//*Label 4751*/ GIMT_Encode4(247333), // Rule ID 11382 //
     /* 247296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE),
     /* 247299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmmla),
     /* 247304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 247313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247320 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1485:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMMLA_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 247320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMMLA_ZZZ_D),
     /* 247323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247327 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247329 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247331 */     GIR_RootConstrainSelectedInstOperands,
     /* 247332 */     // GIR_Coverage, 11382,
     /* 247332 */     GIR_EraseRootFromParent_Done,
     /* 247333 */   // Label 4751: @247333
     /* 247333 */   GIM_Try, /*On fail goto*//*Label 4752*/ GIMT_Encode4(247375), // Rule ID 11436 //
     /* 247338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 247346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 247349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 247352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 247358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247362 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1834:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRDMLSH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 247362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_B),
     /* 247365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247371 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247373 */     GIR_RootConstrainSelectedInstOperands,
     /* 247374 */     // GIR_Coverage, 11436,
     /* 247374 */     GIR_EraseRootFromParent_Done,
     /* 247375 */   // Label 4752: @247375
     /* 247375 */   GIM_Try, /*On fail goto*//*Label 4753*/ GIMT_Encode4(247417), // Rule ID 11437 //
     /* 247380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 247388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 247394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247404 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1834:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRDMLSH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 247404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_H),
     /* 247407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247413 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247415 */     GIR_RootConstrainSelectedInstOperands,
     /* 247416 */     // GIR_Coverage, 11437,
     /* 247416 */     GIR_EraseRootFromParent_Done,
     /* 247417 */   // Label 4753: @247417
     /* 247417 */   GIM_Try, /*On fail goto*//*Label 4754*/ GIMT_Encode4(247459), // Rule ID 11438 //
     /* 247422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 247430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247446 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1834:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRDMLSH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 247446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_S),
     /* 247449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247455 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247457 */     GIR_RootConstrainSelectedInstOperands,
     /* 247458 */     // GIR_Coverage, 11438,
     /* 247458 */     GIR_EraseRootFromParent_Done,
     /* 247459 */   // Label 4754: @247459
     /* 247459 */   GIM_Try, /*On fail goto*//*Label 4755*/ GIMT_Encode4(247501), // Rule ID 11439 //
     /* 247464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 247472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 247481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247488 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1834:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRDMLSH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 247488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_D),
     /* 247491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247495 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247497 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247499 */     GIR_RootConstrainSelectedInstOperands,
     /* 247500 */     // GIR_Coverage, 11439,
     /* 247500 */     GIR_EraseRootFromParent_Done,
     /* 247501 */   // Label 4755: @247501
     /* 247501 */   GIM_Try, /*On fail goto*//*Label 4756*/ GIMT_Encode4(247543), // Rule ID 11492 //
     /* 247506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 247514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 247520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 247526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247530 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1755:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 247530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_H),
     /* 247533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247539 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247541 */     GIR_RootConstrainSelectedInstOperands,
     /* 247542 */     // GIR_Coverage, 11492,
     /* 247542 */     GIR_EraseRootFromParent_Done,
     /* 247543 */   // Label 4756: @247543
     /* 247543 */   GIM_Try, /*On fail goto*//*Label 4757*/ GIMT_Encode4(247585), // Rule ID 11493 //
     /* 247548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 247556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247572 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1755:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 247572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_S),
     /* 247575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247579 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247581 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247583 */     GIR_RootConstrainSelectedInstOperands,
     /* 247584 */     // GIR_Coverage, 11493,
     /* 247584 */     GIR_EraseRootFromParent_Done,
     /* 247585 */   // Label 4757: @247585
     /* 247585 */   GIM_Try, /*On fail goto*//*Label 4758*/ GIMT_Encode4(247627), // Rule ID 11494 //
     /* 247590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 247598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247614 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1755:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 247614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_D),
     /* 247617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247623 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247625 */     GIR_RootConstrainSelectedInstOperands,
     /* 247626 */     // GIR_Coverage, 11494,
     /* 247626 */     GIR_EraseRootFromParent_Done,
     /* 247627 */   // Label 4758: @247627
     /* 247627 */   GIM_Try, /*On fail goto*//*Label 4759*/ GIMT_Encode4(247669), // Rule ID 11495 //
     /* 247632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 247640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 247646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 247652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247656 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1991:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 247656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_H),
     /* 247659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247665 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247667 */     GIR_RootConstrainSelectedInstOperands,
     /* 247668 */     // GIR_Coverage, 11495,
     /* 247668 */     GIR_EraseRootFromParent_Done,
     /* 247669 */   // Label 4759: @247669
     /* 247669 */   GIM_Try, /*On fail goto*//*Label 4760*/ GIMT_Encode4(247711), // Rule ID 11496 //
     /* 247674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 247682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247698 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1991:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 247698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_S),
     /* 247701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247707 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247709 */     GIR_RootConstrainSelectedInstOperands,
     /* 247710 */     // GIR_Coverage, 11496,
     /* 247710 */     GIR_EraseRootFromParent_Done,
     /* 247711 */   // Label 4760: @247711
     /* 247711 */   GIM_Try, /*On fail goto*//*Label 4761*/ GIMT_Encode4(247753), // Rule ID 11497 //
     /* 247716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 247724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247740 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1991:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 247740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_D),
     /* 247743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247747 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247749 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247751 */     GIR_RootConstrainSelectedInstOperands,
     /* 247752 */     // GIR_Coverage, 11497,
     /* 247752 */     GIR_EraseRootFromParent_Done,
     /* 247753 */   // Label 4761: @247753
     /* 247753 */   GIM_Try, /*On fail goto*//*Label 4762*/ GIMT_Encode4(247795), // Rule ID 11498 //
     /* 247758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 247766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 247772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 247778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247782 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1993:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 247782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_H),
     /* 247785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247791 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247793 */     GIR_RootConstrainSelectedInstOperands,
     /* 247794 */     // GIR_Coverage, 11498,
     /* 247794 */     GIR_EraseRootFromParent_Done,
     /* 247795 */   // Label 4762: @247795
     /* 247795 */   GIM_Try, /*On fail goto*//*Label 4763*/ GIMT_Encode4(247837), // Rule ID 11499 //
     /* 247800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 247808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247824 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1993:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 247824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_S),
     /* 247827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247831 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247833 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247835 */     GIR_RootConstrainSelectedInstOperands,
     /* 247836 */     // GIR_Coverage, 11499,
     /* 247836 */     GIR_EraseRootFromParent_Done,
     /* 247837 */   // Label 4763: @247837
     /* 247837 */   GIM_Try, /*On fail goto*//*Label 4764*/ GIMT_Encode4(247879), // Rule ID 11500 //
     /* 247842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 247850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247866 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1993:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 247866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_D),
     /* 247869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247873 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247875 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247877 */     GIR_RootConstrainSelectedInstOperands,
     /* 247878 */     // GIR_Coverage, 11500,
     /* 247878 */     GIR_EraseRootFromParent_Done,
     /* 247879 */   // Label 4764: @247879
     /* 247879 */   GIM_Try, /*On fail goto*//*Label 4765*/ GIMT_Encode4(247921), // Rule ID 11501 //
     /* 247884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 247892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 247898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 247904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247908 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1757:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 247908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_H),
     /* 247911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247917 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247919 */     GIR_RootConstrainSelectedInstOperands,
     /* 247920 */     // GIR_Coverage, 11501,
     /* 247920 */     GIR_EraseRootFromParent_Done,
     /* 247921 */   // Label 4765: @247921
     /* 247921 */   GIM_Try, /*On fail goto*//*Label 4766*/ GIMT_Encode4(247963), // Rule ID 11502 //
     /* 247926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 247934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247950 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1757:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 247950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_S),
     /* 247953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247957 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247959 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247961 */     GIR_RootConstrainSelectedInstOperands,
     /* 247962 */     // GIR_Coverage, 11502,
     /* 247962 */     GIR_EraseRootFromParent_Done,
     /* 247963 */   // Label 4766: @247963
     /* 247963 */   GIM_Try, /*On fail goto*//*Label 4767*/ GIMT_Encode4(248005), // Rule ID 11503 //
     /* 247968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 247976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247992 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1757:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 247992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_D),
     /* 247995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247999 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248001 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248003 */     GIR_RootConstrainSelectedInstOperands,
     /* 248004 */     // GIR_Coverage, 11503,
     /* 248004 */     GIR_EraseRootFromParent_Done,
     /* 248005 */   // Label 4767: @248005
     /* 248005 */   GIM_Try, /*On fail goto*//*Label 4768*/ GIMT_Encode4(248047), // Rule ID 11504 //
     /* 248010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 248018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 248024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248034 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1759:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 248034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_H),
     /* 248037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248041 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248043 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248045 */     GIR_RootConstrainSelectedInstOperands,
     /* 248046 */     // GIR_Coverage, 11504,
     /* 248046 */     GIR_EraseRootFromParent_Done,
     /* 248047 */   // Label 4768: @248047
     /* 248047 */   GIM_Try, /*On fail goto*//*Label 4769*/ GIMT_Encode4(248089), // Rule ID 11505 //
     /* 248052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 248060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248076 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1759:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 248076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_S),
     /* 248079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248085 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248087 */     GIR_RootConstrainSelectedInstOperands,
     /* 248088 */     // GIR_Coverage, 11505,
     /* 248088 */     GIR_EraseRootFromParent_Done,
     /* 248089 */   // Label 4769: @248089
     /* 248089 */   GIM_Try, /*On fail goto*//*Label 4770*/ GIMT_Encode4(248131), // Rule ID 11506 //
     /* 248094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 248102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 248108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248118 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1759:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_D),
     /* 248121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248127 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248129 */     GIR_RootConstrainSelectedInstOperands,
     /* 248130 */     // GIR_Coverage, 11506,
     /* 248130 */     GIR_EraseRootFromParent_Done,
     /* 248131 */   // Label 4770: @248131
     /* 248131 */   GIM_Try, /*On fail goto*//*Label 4771*/ GIMT_Encode4(248173), // Rule ID 11507 //
     /* 248136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 248144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 248150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248160 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1995:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 248160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_H),
     /* 248163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248169 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248171 */     GIR_RootConstrainSelectedInstOperands,
     /* 248172 */     // GIR_Coverage, 11507,
     /* 248172 */     GIR_EraseRootFromParent_Done,
     /* 248173 */   // Label 4771: @248173
     /* 248173 */   GIM_Try, /*On fail goto*//*Label 4772*/ GIMT_Encode4(248215), // Rule ID 11508 //
     /* 248178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 248186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248202 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1995:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 248202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_S),
     /* 248205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248211 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248213 */     GIR_RootConstrainSelectedInstOperands,
     /* 248214 */     // GIR_Coverage, 11508,
     /* 248214 */     GIR_EraseRootFromParent_Done,
     /* 248215 */   // Label 4772: @248215
     /* 248215 */   GIM_Try, /*On fail goto*//*Label 4773*/ GIMT_Encode4(248257), // Rule ID 11509 //
     /* 248220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 248228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 248234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248244 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1995:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_D),
     /* 248247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248253 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248255 */     GIR_RootConstrainSelectedInstOperands,
     /* 248256 */     // GIR_Coverage, 11509,
     /* 248256 */     GIR_EraseRootFromParent_Done,
     /* 248257 */   // Label 4773: @248257
     /* 248257 */   GIM_Try, /*On fail goto*//*Label 4774*/ GIMT_Encode4(248299), // Rule ID 11510 //
     /* 248262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 248270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 248276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248286 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1997:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 248286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_H),
     /* 248289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248295 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248297 */     GIR_RootConstrainSelectedInstOperands,
     /* 248298 */     // GIR_Coverage, 11510,
     /* 248298 */     GIR_EraseRootFromParent_Done,
     /* 248299 */   // Label 4774: @248299
     /* 248299 */   GIM_Try, /*On fail goto*//*Label 4775*/ GIMT_Encode4(248341), // Rule ID 11511 //
     /* 248304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 248312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248328 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1997:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 248328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_S),
     /* 248331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248335 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248337 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248339 */     GIR_RootConstrainSelectedInstOperands,
     /* 248340 */     // GIR_Coverage, 11511,
     /* 248340 */     GIR_EraseRootFromParent_Done,
     /* 248341 */   // Label 4775: @248341
     /* 248341 */   GIM_Try, /*On fail goto*//*Label 4776*/ GIMT_Encode4(248383), // Rule ID 11512 //
     /* 248346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 248354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 248360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248370 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1997:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_D),
     /* 248373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248377 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248379 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248381 */     GIR_RootConstrainSelectedInstOperands,
     /* 248382 */     // GIR_Coverage, 11512,
     /* 248382 */     GIR_EraseRootFromParent_Done,
     /* 248383 */   // Label 4776: @248383
     /* 248383 */   GIM_Try, /*On fail goto*//*Label 4777*/ GIMT_Encode4(248425), // Rule ID 11521 //
     /* 248388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 248396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 248402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248412 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1795:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 248412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_H),
     /* 248415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248421 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248423 */     GIR_RootConstrainSelectedInstOperands,
     /* 248424 */     // GIR_Coverage, 11521,
     /* 248424 */     GIR_EraseRootFromParent_Done,
     /* 248425 */   // Label 4777: @248425
     /* 248425 */   GIM_Try, /*On fail goto*//*Label 4778*/ GIMT_Encode4(248467), // Rule ID 11522 //
     /* 248430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 248438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248454 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1795:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 248454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_S),
     /* 248457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248461 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248463 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248465 */     GIR_RootConstrainSelectedInstOperands,
     /* 248466 */     // GIR_Coverage, 11522,
     /* 248466 */     GIR_EraseRootFromParent_Done,
     /* 248467 */   // Label 4778: @248467
     /* 248467 */   GIM_Try, /*On fail goto*//*Label 4779*/ GIMT_Encode4(248509), // Rule ID 11523 //
     /* 248472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 248480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 248486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248496 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1795:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_D),
     /* 248499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248503 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248505 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248507 */     GIR_RootConstrainSelectedInstOperands,
     /* 248508 */     // GIR_Coverage, 11523,
     /* 248508 */     GIR_EraseRootFromParent_Done,
     /* 248509 */   // Label 4779: @248509
     /* 248509 */   GIM_Try, /*On fail goto*//*Label 4780*/ GIMT_Encode4(248551), // Rule ID 11524 //
     /* 248514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 248522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 248528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248538 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1798:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 248538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_H),
     /* 248541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248545 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248547 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248549 */     GIR_RootConstrainSelectedInstOperands,
     /* 248550 */     // GIR_Coverage, 11524,
     /* 248550 */     GIR_EraseRootFromParent_Done,
     /* 248551 */   // Label 4780: @248551
     /* 248551 */   GIM_Try, /*On fail goto*//*Label 4781*/ GIMT_Encode4(248593), // Rule ID 11525 //
     /* 248556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 248564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248580 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1798:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 248580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_S),
     /* 248583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248587 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248589 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248591 */     GIR_RootConstrainSelectedInstOperands,
     /* 248592 */     // GIR_Coverage, 11525,
     /* 248592 */     GIR_EraseRootFromParent_Done,
     /* 248593 */   // Label 4781: @248593
     /* 248593 */   GIM_Try, /*On fail goto*//*Label 4782*/ GIMT_Encode4(248635), // Rule ID 11526 //
     /* 248598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 248606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 248612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248622 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1798:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_D),
     /* 248625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248631 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248633 */     GIR_RootConstrainSelectedInstOperands,
     /* 248634 */     // GIR_Coverage, 11526,
     /* 248634 */     GIR_EraseRootFromParent_Done,
     /* 248635 */   // Label 4782: @248635
     /* 248635 */   GIM_Try, /*On fail goto*//*Label 4783*/ GIMT_Encode4(248677), // Rule ID 11527 //
     /* 248640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 248648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 248654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248664 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1800:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 248664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_H),
     /* 248667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248671 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248673 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248675 */     GIR_RootConstrainSelectedInstOperands,
     /* 248676 */     // GIR_Coverage, 11527,
     /* 248676 */     GIR_EraseRootFromParent_Done,
     /* 248677 */   // Label 4783: @248677
     /* 248677 */   GIM_Try, /*On fail goto*//*Label 4784*/ GIMT_Encode4(248719), // Rule ID 11528 //
     /* 248682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 248690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248706 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1800:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 248706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_S),
     /* 248709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248713 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248715 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248717 */     GIR_RootConstrainSelectedInstOperands,
     /* 248718 */     // GIR_Coverage, 11528,
     /* 248718 */     GIR_EraseRootFromParent_Done,
     /* 248719 */   // Label 4784: @248719
     /* 248719 */   GIM_Try, /*On fail goto*//*Label 4785*/ GIMT_Encode4(248761), // Rule ID 11529 //
     /* 248724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 248732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 248738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248748 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1800:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_D),
     /* 248751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248757 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248759 */     GIR_RootConstrainSelectedInstOperands,
     /* 248760 */     // GIR_Coverage, 11529,
     /* 248760 */     GIR_EraseRootFromParent_Done,
     /* 248761 */   // Label 4785: @248761
     /* 248761 */   GIM_Try, /*On fail goto*//*Label 4786*/ GIMT_Encode4(248803), // Rule ID 11530 //
     /* 248766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 248774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 248780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248790 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1803:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 248790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_H),
     /* 248793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248797 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248799 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248801 */     GIR_RootConstrainSelectedInstOperands,
     /* 248802 */     // GIR_Coverage, 11530,
     /* 248802 */     GIR_EraseRootFromParent_Done,
     /* 248803 */   // Label 4786: @248803
     /* 248803 */   GIM_Try, /*On fail goto*//*Label 4787*/ GIMT_Encode4(248845), // Rule ID 11531 //
     /* 248808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 248816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248832 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1803:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 248832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_S),
     /* 248835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248841 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248843 */     GIR_RootConstrainSelectedInstOperands,
     /* 248844 */     // GIR_Coverage, 11531,
     /* 248844 */     GIR_EraseRootFromParent_Done,
     /* 248845 */   // Label 4787: @248845
     /* 248845 */   GIM_Try, /*On fail goto*//*Label 4788*/ GIMT_Encode4(248887), // Rule ID 11532 //
     /* 248850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 248858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 248864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248874 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1803:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_D),
     /* 248877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248881 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248883 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248885 */     GIR_RootConstrainSelectedInstOperands,
     /* 248886 */     // GIR_Coverage, 11532,
     /* 248886 */     GIR_EraseRootFromParent_Done,
     /* 248887 */   // Label 4788: @248887
     /* 248887 */   GIM_Try, /*On fail goto*//*Label 4789*/ GIMT_Encode4(248929), // Rule ID 11533 //
     /* 248892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 248900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 248906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248916 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1797:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 248916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_H),
     /* 248919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248925 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248927 */     GIR_RootConstrainSelectedInstOperands,
     /* 248928 */     // GIR_Coverage, 11533,
     /* 248928 */     GIR_EraseRootFromParent_Done,
     /* 248929 */   // Label 4789: @248929
     /* 248929 */   GIM_Try, /*On fail goto*//*Label 4790*/ GIMT_Encode4(248971), // Rule ID 11534 //
     /* 248934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 248942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248958 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1797:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 248958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_S),
     /* 248961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248965 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248967 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248969 */     GIR_RootConstrainSelectedInstOperands,
     /* 248970 */     // GIR_Coverage, 11534,
     /* 248970 */     GIR_EraseRootFromParent_Done,
     /* 248971 */   // Label 4790: @248971
     /* 248971 */   GIM_Try, /*On fail goto*//*Label 4791*/ GIMT_Encode4(249013), // Rule ID 11535 //
     /* 248976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 248984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 248990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249000 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1797:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 249000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_D),
     /* 249003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249007 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249009 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249011 */     GIR_RootConstrainSelectedInstOperands,
     /* 249012 */     // GIR_Coverage, 11535,
     /* 249012 */     GIR_EraseRootFromParent_Done,
     /* 249013 */   // Label 4791: @249013
     /* 249013 */   GIM_Try, /*On fail goto*//*Label 4792*/ GIMT_Encode4(249055), // Rule ID 11536 //
     /* 249018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 249026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 249032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249042 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1802:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 249042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_H),
     /* 249045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249049 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249051 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249053 */     GIR_RootConstrainSelectedInstOperands,
     /* 249054 */     // GIR_Coverage, 11536,
     /* 249054 */     GIR_EraseRootFromParent_Done,
     /* 249055 */   // Label 4792: @249055
     /* 249055 */   GIM_Try, /*On fail goto*//*Label 4793*/ GIMT_Encode4(249097), // Rule ID 11537 //
     /* 249060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 249068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 249074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249084 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1802:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 249084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_S),
     /* 249087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249091 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249093 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249095 */     GIR_RootConstrainSelectedInstOperands,
     /* 249096 */     // GIR_Coverage, 11537,
     /* 249096 */     GIR_EraseRootFromParent_Done,
     /* 249097 */   // Label 4793: @249097
     /* 249097 */   GIM_Try, /*On fail goto*//*Label 4794*/ GIMT_Encode4(249139), // Rule ID 11538 //
     /* 249102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 249110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 249116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249126 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1802:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 249126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_D),
     /* 249129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249133 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249135 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249137 */     GIR_RootConstrainSelectedInstOperands,
     /* 249138 */     // GIR_Coverage, 11538,
     /* 249138 */     GIR_EraseRootFromParent_Done,
     /* 249139 */   // Label 4794: @249139
     /* 249139 */   GIM_Try, /*On fail goto*//*Label 4795*/ GIMT_Encode4(249181), // Rule ID 11539 //
     /* 249144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 249152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 249155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 249158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249168 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1970:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 249168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_B),
     /* 249171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249177 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249179 */     GIR_RootConstrainSelectedInstOperands,
     /* 249180 */     // GIR_Coverage, 11539,
     /* 249180 */     GIR_EraseRootFromParent_Done,
     /* 249181 */   // Label 4795: @249181
     /* 249181 */   GIM_Try, /*On fail goto*//*Label 4796*/ GIMT_Encode4(249223), // Rule ID 11541 //
     /* 249186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 249194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 249200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249210 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1970:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 249210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_H),
     /* 249213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249217 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249219 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249221 */     GIR_RootConstrainSelectedInstOperands,
     /* 249222 */     // GIR_Coverage, 11541,
     /* 249222 */     GIR_EraseRootFromParent_Done,
     /* 249223 */   // Label 4796: @249223
     /* 249223 */   GIM_Try, /*On fail goto*//*Label 4797*/ GIMT_Encode4(249265), // Rule ID 11543 //
     /* 249228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 249236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249252 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1970:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 249252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_S),
     /* 249255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249259 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249261 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249263 */     GIR_RootConstrainSelectedInstOperands,
     /* 249264 */     // GIR_Coverage, 11543,
     /* 249264 */     GIR_EraseRootFromParent_Done,
     /* 249265 */   // Label 4797: @249265
     /* 249265 */   GIM_Try, /*On fail goto*//*Label 4798*/ GIMT_Encode4(249307), // Rule ID 11545 //
     /* 249270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 249278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249294 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1970:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 249294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_D),
     /* 249297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249301 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249303 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249305 */     GIR_RootConstrainSelectedInstOperands,
     /* 249306 */     // GIR_Coverage, 11545,
     /* 249306 */     GIR_EraseRootFromParent_Done,
     /* 249307 */   // Label 4798: @249307
     /* 249307 */   GIM_Try, /*On fail goto*//*Label 4799*/ GIMT_Encode4(249349), // Rule ID 11547 //
     /* 249312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 249320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 249323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 249326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249336 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1730:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 249336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_B),
     /* 249339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249343 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249345 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249347 */     GIR_RootConstrainSelectedInstOperands,
     /* 249348 */     // GIR_Coverage, 11547,
     /* 249348 */     GIR_EraseRootFromParent_Done,
     /* 249349 */   // Label 4799: @249349
     /* 249349 */   GIM_Try, /*On fail goto*//*Label 4800*/ GIMT_Encode4(249391), // Rule ID 11548 //
     /* 249354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 249362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 249368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249378 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1730:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 249378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_H),
     /* 249381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249385 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249387 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249389 */     GIR_RootConstrainSelectedInstOperands,
     /* 249390 */     // GIR_Coverage, 11548,
     /* 249390 */     GIR_EraseRootFromParent_Done,
     /* 249391 */   // Label 4800: @249391
     /* 249391 */   GIM_Try, /*On fail goto*//*Label 4801*/ GIMT_Encode4(249433), // Rule ID 11549 //
     /* 249396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 249404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249420 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1730:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 249420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_S),
     /* 249423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249427 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249429 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249431 */     GIR_RootConstrainSelectedInstOperands,
     /* 249432 */     // GIR_Coverage, 11549,
     /* 249432 */     GIR_EraseRootFromParent_Done,
     /* 249433 */   // Label 4801: @249433
     /* 249433 */   GIM_Try, /*On fail goto*//*Label 4802*/ GIMT_Encode4(249475), // Rule ID 11550 //
     /* 249438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 249446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249462 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1730:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 249462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_D),
     /* 249465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249471 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249473 */     GIR_RootConstrainSelectedInstOperands,
     /* 249474 */     // GIR_Coverage, 11550,
     /* 249474 */     GIR_EraseRootFromParent_Done,
     /* 249475 */   // Label 4802: @249475
     /* 249475 */   GIM_Try, /*On fail goto*//*Label 4803*/ GIMT_Encode4(249517), // Rule ID 11551 //
     /* 249480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 249488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 249491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 249494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249504 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1971:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 249504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_B),
     /* 249507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249513 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249515 */     GIR_RootConstrainSelectedInstOperands,
     /* 249516 */     // GIR_Coverage, 11551,
     /* 249516 */     GIR_EraseRootFromParent_Done,
     /* 249517 */   // Label 4803: @249517
     /* 249517 */   GIM_Try, /*On fail goto*//*Label 4804*/ GIMT_Encode4(249559), // Rule ID 11552 //
     /* 249522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 249530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 249536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249546 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1971:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 249546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_H),
     /* 249549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249555 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249557 */     GIR_RootConstrainSelectedInstOperands,
     /* 249558 */     // GIR_Coverage, 11552,
     /* 249558 */     GIR_EraseRootFromParent_Done,
     /* 249559 */   // Label 4804: @249559
     /* 249559 */   GIM_Try, /*On fail goto*//*Label 4805*/ GIMT_Encode4(249601), // Rule ID 11553 //
     /* 249564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 249572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249588 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1971:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 249588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_S),
     /* 249591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249597 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249599 */     GIR_RootConstrainSelectedInstOperands,
     /* 249600 */     // GIR_Coverage, 11553,
     /* 249600 */     GIR_EraseRootFromParent_Done,
     /* 249601 */   // Label 4805: @249601
     /* 249601 */   GIM_Try, /*On fail goto*//*Label 4806*/ GIMT_Encode4(249643), // Rule ID 11554 //
     /* 249606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 249614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249630 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1971:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 249630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_D),
     /* 249633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249637 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249639 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249641 */     GIR_RootConstrainSelectedInstOperands,
     /* 249642 */     // GIR_Coverage, 11554,
     /* 249642 */     GIR_EraseRootFromParent_Done,
     /* 249643 */   // Label 4806: @249643
     /* 249643 */   GIM_Try, /*On fail goto*//*Label 4807*/ GIMT_Encode4(249685), // Rule ID 11555 //
     /* 249648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 249656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 249659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 249662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249672 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1865:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SRHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 249672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_B),
     /* 249675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249679 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249681 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249683 */     GIR_RootConstrainSelectedInstOperands,
     /* 249684 */     // GIR_Coverage, 11555,
     /* 249684 */     GIR_EraseRootFromParent_Done,
     /* 249685 */   // Label 4807: @249685
     /* 249685 */   GIM_Try, /*On fail goto*//*Label 4808*/ GIMT_Encode4(249727), // Rule ID 11557 //
     /* 249690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 249698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 249704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249714 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1865:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SRHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 249714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_H),
     /* 249717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249721 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249723 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249725 */     GIR_RootConstrainSelectedInstOperands,
     /* 249726 */     // GIR_Coverage, 11557,
     /* 249726 */     GIR_EraseRootFromParent_Done,
     /* 249727 */   // Label 4808: @249727
     /* 249727 */   GIM_Try, /*On fail goto*//*Label 4809*/ GIMT_Encode4(249769), // Rule ID 11559 //
     /* 249732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 249740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249756 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1865:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SRHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 249756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_S),
     /* 249759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249763 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249765 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249767 */     GIR_RootConstrainSelectedInstOperands,
     /* 249768 */     // GIR_Coverage, 11559,
     /* 249768 */     GIR_EraseRootFromParent_Done,
     /* 249769 */   // Label 4809: @249769
     /* 249769 */   GIM_Try, /*On fail goto*//*Label 4810*/ GIMT_Encode4(249811), // Rule ID 11561 //
     /* 249774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 249782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249798 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1865:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SRHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 249798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_D),
     /* 249801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249805 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249807 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249809 */     GIR_RootConstrainSelectedInstOperands,
     /* 249810 */     // GIR_Coverage, 11561,
     /* 249810 */     GIR_EraseRootFromParent_Done,
     /* 249811 */   // Label 4810: @249811
     /* 249811 */   GIM_Try, /*On fail goto*//*Label 4811*/ GIMT_Encode4(249853), // Rule ID 11563 //
     /* 249816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 249824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 249827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 249830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249840 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2057:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (URHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 249840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_B),
     /* 249843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249849 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249851 */     GIR_RootConstrainSelectedInstOperands,
     /* 249852 */     // GIR_Coverage, 11563,
     /* 249852 */     GIR_EraseRootFromParent_Done,
     /* 249853 */   // Label 4811: @249853
     /* 249853 */   GIM_Try, /*On fail goto*//*Label 4812*/ GIMT_Encode4(249895), // Rule ID 11565 //
     /* 249858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 249866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 249872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249882 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2057:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (URHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 249882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_H),
     /* 249885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249891 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249893 */     GIR_RootConstrainSelectedInstOperands,
     /* 249894 */     // GIR_Coverage, 11565,
     /* 249894 */     GIR_EraseRootFromParent_Done,
     /* 249895 */   // Label 4812: @249895
     /* 249895 */   GIM_Try, /*On fail goto*//*Label 4813*/ GIMT_Encode4(249937), // Rule ID 11567 //
     /* 249900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 249908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249924 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2057:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 249924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_S),
     /* 249927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249931 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249933 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249935 */     GIR_RootConstrainSelectedInstOperands,
     /* 249936 */     // GIR_Coverage, 11567,
     /* 249936 */     GIR_EraseRootFromParent_Done,
     /* 249937 */   // Label 4813: @249937
     /* 249937 */   GIM_Try, /*On fail goto*//*Label 4814*/ GIMT_Encode4(249979), // Rule ID 11569 //
     /* 249942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 249950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249966 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2057:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (URHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 249966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_D),
     /* 249969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249973 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249975 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249977 */     GIR_RootConstrainSelectedInstOperands,
     /* 249978 */     // GIR_Coverage, 11569,
     /* 249978 */     GIR_EraseRootFromParent_Done,
     /* 249979 */   // Label 4814: @249979
     /* 249979 */   GIM_Try, /*On fail goto*//*Label 4815*/ GIMT_Encode4(250021), // Rule ID 11571 //
     /* 249984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 249992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 249995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 249998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250008 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1731:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_B),
     /* 250011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250015 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250017 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250019 */     GIR_RootConstrainSelectedInstOperands,
     /* 250020 */     // GIR_Coverage, 11571,
     /* 250020 */     GIR_EraseRootFromParent_Done,
     /* 250021 */   // Label 4815: @250021
     /* 250021 */   GIM_Try, /*On fail goto*//*Label 4816*/ GIMT_Encode4(250063), // Rule ID 11572 //
     /* 250026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 250034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 250040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250050 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1731:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_H),
     /* 250053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250057 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250059 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250061 */     GIR_RootConstrainSelectedInstOperands,
     /* 250062 */     // GIR_Coverage, 11572,
     /* 250062 */     GIR_EraseRootFromParent_Done,
     /* 250063 */   // Label 4816: @250063
     /* 250063 */   GIM_Try, /*On fail goto*//*Label 4817*/ GIMT_Encode4(250105), // Rule ID 11573 //
     /* 250068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 250076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250092 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1731:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_S),
     /* 250095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250101 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250103 */     GIR_RootConstrainSelectedInstOperands,
     /* 250104 */     // GIR_Coverage, 11573,
     /* 250104 */     GIR_EraseRootFromParent_Done,
     /* 250105 */   // Label 4817: @250105
     /* 250105 */   GIM_Try, /*On fail goto*//*Label 4818*/ GIMT_Encode4(250147), // Rule ID 11574 //
     /* 250110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 250118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 250130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250134 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1731:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 250134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_D),
     /* 250137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250143 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250145 */     GIR_RootConstrainSelectedInstOperands,
     /* 250146 */     // GIR_Coverage, 11574,
     /* 250146 */     GIR_EraseRootFromParent_Done,
     /* 250147 */   // Label 4818: @250147
     /* 250147 */   GIM_Try, /*On fail goto*//*Label 4819*/ GIMT_Encode4(250189), // Rule ID 11575 //
     /* 250152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 250160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 250163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 250166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250176 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1972:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_B),
     /* 250179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250185 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250187 */     GIR_RootConstrainSelectedInstOperands,
     /* 250188 */     // GIR_Coverage, 11575,
     /* 250188 */     GIR_EraseRootFromParent_Done,
     /* 250189 */   // Label 4819: @250189
     /* 250189 */   GIM_Try, /*On fail goto*//*Label 4820*/ GIMT_Encode4(250231), // Rule ID 11576 //
     /* 250194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 250202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 250208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250218 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1972:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_H),
     /* 250221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250225 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250227 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250229 */     GIR_RootConstrainSelectedInstOperands,
     /* 250230 */     // GIR_Coverage, 11576,
     /* 250230 */     GIR_EraseRootFromParent_Done,
     /* 250231 */   // Label 4820: @250231
     /* 250231 */   GIM_Try, /*On fail goto*//*Label 4821*/ GIMT_Encode4(250273), // Rule ID 11577 //
     /* 250236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 250244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250260 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1972:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_S),
     /* 250263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250269 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250271 */     GIR_RootConstrainSelectedInstOperands,
     /* 250272 */     // GIR_Coverage, 11577,
     /* 250272 */     GIR_EraseRootFromParent_Done,
     /* 250273 */   // Label 4821: @250273
     /* 250273 */   GIM_Try, /*On fail goto*//*Label 4822*/ GIMT_Encode4(250315), // Rule ID 11578 //
     /* 250278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 250286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 250298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250302 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1972:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 250302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_D),
     /* 250305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250309 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250311 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250313 */     GIR_RootConstrainSelectedInstOperands,
     /* 250314 */     // GIR_Coverage, 11578,
     /* 250314 */     GIR_EraseRootFromParent_Done,
     /* 250315 */   // Label 4822: @250315
     /* 250315 */   GIM_Try, /*On fail goto*//*Label 4823*/ GIMT_Encode4(250357), // Rule ID 11579 //
     /* 250320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 250328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 250334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250344 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1947:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UADALP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_H),
     /* 250347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250351 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250353 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250355 */     GIR_RootConstrainSelectedInstOperands,
     /* 250356 */     // GIR_Coverage, 11579,
     /* 250356 */     GIR_EraseRootFromParent_Done,
     /* 250357 */   // Label 4823: @250357
     /* 250357 */   GIM_Try, /*On fail goto*//*Label 4824*/ GIMT_Encode4(250399), // Rule ID 11580 //
     /* 250362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 250370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250386 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1947:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UADALP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_S),
     /* 250389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250395 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250397 */     GIR_RootConstrainSelectedInstOperands,
     /* 250398 */     // GIR_Coverage, 11580,
     /* 250398 */     GIR_EraseRootFromParent_Done,
     /* 250399 */   // Label 4824: @250399
     /* 250399 */   GIM_Try, /*On fail goto*//*Label 4825*/ GIMT_Encode4(250441), // Rule ID 11581 //
     /* 250404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 250412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250428 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1947:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UADALP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_D),
     /* 250431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250435 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250437 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250439 */     GIR_RootConstrainSelectedInstOperands,
     /* 250440 */     // GIR_Coverage, 11581,
     /* 250440 */     GIR_EraseRootFromParent_Done,
     /* 250441 */   // Label 4825: @250441
     /* 250441 */   GIM_Try, /*On fail goto*//*Label 4826*/ GIMT_Encode4(250483), // Rule ID 11582 //
     /* 250446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 250454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 250457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 250460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250470 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1262:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (ADDP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_B),
     /* 250473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250479 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250481 */     GIR_RootConstrainSelectedInstOperands,
     /* 250482 */     // GIR_Coverage, 11582,
     /* 250482 */     GIR_EraseRootFromParent_Done,
     /* 250483 */   // Label 4826: @250483
     /* 250483 */   GIM_Try, /*On fail goto*//*Label 4827*/ GIMT_Encode4(250525), // Rule ID 11583 //
     /* 250488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 250496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 250502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250512 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1262:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ADDP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_H),
     /* 250515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250519 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250521 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250523 */     GIR_RootConstrainSelectedInstOperands,
     /* 250524 */     // GIR_Coverage, 11583,
     /* 250524 */     GIR_EraseRootFromParent_Done,
     /* 250525 */   // Label 4827: @250525
     /* 250525 */   GIM_Try, /*On fail goto*//*Label 4828*/ GIMT_Encode4(250567), // Rule ID 11584 //
     /* 250530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 250538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250554 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1262:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADDP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_S),
     /* 250557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250561 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250563 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250565 */     GIR_RootConstrainSelectedInstOperands,
     /* 250566 */     // GIR_Coverage, 11584,
     /* 250566 */     GIR_EraseRootFromParent_Done,
     /* 250567 */   // Label 4828: @250567
     /* 250567 */   GIM_Try, /*On fail goto*//*Label 4829*/ GIMT_Encode4(250609), // Rule ID 11585 //
     /* 250572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 250580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 250592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250596 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1262:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADDP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 250596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_D),
     /* 250599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250605 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250607 */     GIR_RootConstrainSelectedInstOperands,
     /* 250608 */     // GIR_Coverage, 11585,
     /* 250608 */     GIR_EraseRootFromParent_Done,
     /* 250609 */   // Label 4829: @250609
     /* 250609 */   GIM_Try, /*On fail goto*//*Label 4830*/ GIMT_Encode4(250651), // Rule ID 11586 //
     /* 250614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 250622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 250625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 250628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250638 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1741:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMAXP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_B),
     /* 250641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250647 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250649 */     GIR_RootConstrainSelectedInstOperands,
     /* 250650 */     // GIR_Coverage, 11586,
     /* 250650 */     GIR_EraseRootFromParent_Done,
     /* 250651 */   // Label 4830: @250651
     /* 250651 */   GIM_Try, /*On fail goto*//*Label 4831*/ GIMT_Encode4(250693), // Rule ID 11587 //
     /* 250656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 250664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 250670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250680 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1741:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMAXP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_H),
     /* 250683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250687 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250689 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250691 */     GIR_RootConstrainSelectedInstOperands,
     /* 250692 */     // GIR_Coverage, 11587,
     /* 250692 */     GIR_EraseRootFromParent_Done,
     /* 250693 */   // Label 4831: @250693
     /* 250693 */   GIM_Try, /*On fail goto*//*Label 4832*/ GIMT_Encode4(250735), // Rule ID 11588 //
     /* 250698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 250706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250722 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1741:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMAXP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_S),
     /* 250725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250731 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250733 */     GIR_RootConstrainSelectedInstOperands,
     /* 250734 */     // GIR_Coverage, 11588,
     /* 250734 */     GIR_EraseRootFromParent_Done,
     /* 250735 */   // Label 4832: @250735
     /* 250735 */   GIM_Try, /*On fail goto*//*Label 4833*/ GIMT_Encode4(250777), // Rule ID 11589 //
     /* 250740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 250748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 250760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250764 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1741:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMAXP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 250764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_D),
     /* 250767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250771 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250773 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250775 */     GIR_RootConstrainSelectedInstOperands,
     /* 250776 */     // GIR_Coverage, 11589,
     /* 250776 */     GIR_EraseRootFromParent_Done,
     /* 250777 */   // Label 4833: @250777
     /* 250777 */   GIM_Try, /*On fail goto*//*Label 4834*/ GIMT_Encode4(250819), // Rule ID 11590 //
     /* 250782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 250790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 250793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 250796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250806 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1979:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMAXP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_B),
     /* 250809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250815 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250817 */     GIR_RootConstrainSelectedInstOperands,
     /* 250818 */     // GIR_Coverage, 11590,
     /* 250818 */     GIR_EraseRootFromParent_Done,
     /* 250819 */   // Label 4834: @250819
     /* 250819 */   GIM_Try, /*On fail goto*//*Label 4835*/ GIMT_Encode4(250861), // Rule ID 11591 //
     /* 250824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 250832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 250838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250848 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1979:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMAXP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_H),
     /* 250851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250855 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250857 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250859 */     GIR_RootConstrainSelectedInstOperands,
     /* 250860 */     // GIR_Coverage, 11591,
     /* 250860 */     GIR_EraseRootFromParent_Done,
     /* 250861 */   // Label 4835: @250861
     /* 250861 */   GIM_Try, /*On fail goto*//*Label 4836*/ GIMT_Encode4(250903), // Rule ID 11592 //
     /* 250866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 250874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250890 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1979:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMAXP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_S),
     /* 250893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250897 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250899 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250901 */     GIR_RootConstrainSelectedInstOperands,
     /* 250902 */     // GIR_Coverage, 11592,
     /* 250902 */     GIR_EraseRootFromParent_Done,
     /* 250903 */   // Label 4836: @250903
     /* 250903 */   GIM_Try, /*On fail goto*//*Label 4837*/ GIMT_Encode4(250945), // Rule ID 11593 //
     /* 250908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 250916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 250928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250932 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1979:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMAXP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 250932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_D),
     /* 250935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250941 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250943 */     GIR_RootConstrainSelectedInstOperands,
     /* 250944 */     // GIR_Coverage, 11593,
     /* 250944 */     GIR_EraseRootFromParent_Done,
     /* 250945 */   // Label 4837: @250945
     /* 250945 */   GIM_Try, /*On fail goto*//*Label 4838*/ GIMT_Encode4(250987), // Rule ID 11594 //
     /* 250950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 250958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 250961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 250964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250974 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1750:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMINP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_B),
     /* 250977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250981 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250983 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250985 */     GIR_RootConstrainSelectedInstOperands,
     /* 250986 */     // GIR_Coverage, 11594,
     /* 250986 */     GIR_EraseRootFromParent_Done,
     /* 250987 */   // Label 4838: @250987
     /* 250987 */   GIM_Try, /*On fail goto*//*Label 4839*/ GIMT_Encode4(251029), // Rule ID 11595 //
     /* 250992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 251000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251016 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1750:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMINP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 251016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_H),
     /* 251019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251025 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251027 */     GIR_RootConstrainSelectedInstOperands,
     /* 251028 */     // GIR_Coverage, 11595,
     /* 251028 */     GIR_EraseRootFromParent_Done,
     /* 251029 */   // Label 4839: @251029
     /* 251029 */   GIM_Try, /*On fail goto*//*Label 4840*/ GIMT_Encode4(251071), // Rule ID 11596 //
     /* 251034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 251042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251058 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1750:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMINP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_S),
     /* 251061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251067 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251069 */     GIR_RootConstrainSelectedInstOperands,
     /* 251070 */     // GIR_Coverage, 11596,
     /* 251070 */     GIR_EraseRootFromParent_Done,
     /* 251071 */   // Label 4840: @251071
     /* 251071 */   GIM_Try, /*On fail goto*//*Label 4841*/ GIMT_Encode4(251113), // Rule ID 11597 //
     /* 251076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 251084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251100 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1750:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMINP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 251100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_D),
     /* 251103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251109 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251111 */     GIR_RootConstrainSelectedInstOperands,
     /* 251112 */     // GIR_Coverage, 11597,
     /* 251112 */     GIR_EraseRootFromParent_Done,
     /* 251113 */   // Label 4841: @251113
     /* 251113 */   GIM_Try, /*On fail goto*//*Label 4842*/ GIMT_Encode4(251155), // Rule ID 11598 //
     /* 251118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 251126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 251129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251142 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1988:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMINP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 251142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_B),
     /* 251145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251149 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251151 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251153 */     GIR_RootConstrainSelectedInstOperands,
     /* 251154 */     // GIR_Coverage, 11598,
     /* 251154 */     GIR_EraseRootFromParent_Done,
     /* 251155 */   // Label 4842: @251155
     /* 251155 */   GIM_Try, /*On fail goto*//*Label 4843*/ GIMT_Encode4(251197), // Rule ID 11599 //
     /* 251160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 251168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251184 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1988:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMINP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 251184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_H),
     /* 251187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251191 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251193 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251195 */     GIR_RootConstrainSelectedInstOperands,
     /* 251196 */     // GIR_Coverage, 11599,
     /* 251196 */     GIR_EraseRootFromParent_Done,
     /* 251197 */   // Label 4843: @251197
     /* 251197 */   GIM_Try, /*On fail goto*//*Label 4844*/ GIMT_Encode4(251239), // Rule ID 11600 //
     /* 251202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 251210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251226 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1988:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMINP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_S),
     /* 251229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251233 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251235 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251237 */     GIR_RootConstrainSelectedInstOperands,
     /* 251238 */     // GIR_Coverage, 11600,
     /* 251238 */     GIR_EraseRootFromParent_Done,
     /* 251239 */   // Label 4844: @251239
     /* 251239 */   GIM_Try, /*On fail goto*//*Label 4845*/ GIMT_Encode4(251281), // Rule ID 11601 //
     /* 251244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 251252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251268 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1988:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMINP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 251268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_D),
     /* 251271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251277 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251279 */     GIR_RootConstrainSelectedInstOperands,
     /* 251280 */     // GIR_Coverage, 11601,
     /* 251280 */     GIR_EraseRootFromParent_Done,
     /* 251281 */   // Label 4845: @251281
     /* 251281 */   GIM_Try, /*On fail goto*//*Label 4846*/ GIMT_Encode4(251323), // Rule ID 11602 //
     /* 251286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursqrte),
     /* 251294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 251300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 251303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251310 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2064:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URSQRTE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTE_ZPmZ_S),
     /* 251313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251317 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251319 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251321 */     GIR_RootConstrainSelectedInstOperands,
     /* 251322 */     // GIR_Coverage, 11602,
     /* 251322 */     GIR_EraseRootFromParent_Done,
     /* 251323 */   // Label 4846: @251323
     /* 251323 */   GIM_Try, /*On fail goto*//*Label 4847*/ GIMT_Encode4(251365), // Rule ID 11613 //
     /* 251328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 251336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 251339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 251342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 251345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251352 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1829:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQNEG_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 251352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_B),
     /* 251355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251359 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251361 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251363 */     GIR_RootConstrainSelectedInstOperands,
     /* 251364 */     // GIR_Coverage, 11613,
     /* 251364 */     GIR_EraseRootFromParent_Done,
     /* 251365 */   // Label 4847: @251365
     /* 251365 */   GIM_Try, /*On fail goto*//*Label 4848*/ GIMT_Encode4(251407), // Rule ID 11614 //
     /* 251370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 251378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 251384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 251387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251394 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1829:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQNEG_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 251394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_H),
     /* 251397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251401 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251403 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251405 */     GIR_RootConstrainSelectedInstOperands,
     /* 251406 */     // GIR_Coverage, 11614,
     /* 251406 */     GIR_EraseRootFromParent_Done,
     /* 251407 */   // Label 4848: @251407
     /* 251407 */   GIM_Try, /*On fail goto*//*Label 4849*/ GIMT_Encode4(251449), // Rule ID 11615 //
     /* 251412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 251420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 251426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 251429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251436 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1829:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQNEG_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_S),
     /* 251439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251443 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251445 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251447 */     GIR_RootConstrainSelectedInstOperands,
     /* 251448 */     // GIR_Coverage, 11615,
     /* 251448 */     GIR_EraseRootFromParent_Done,
     /* 251449 */   // Label 4849: @251449
     /* 251449 */   GIM_Try, /*On fail goto*//*Label 4850*/ GIMT_Encode4(251491), // Rule ID 11616 //
     /* 251454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 251462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 251468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 251471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251478 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1829:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQNEG_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 251478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_D),
     /* 251481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251487 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251489 */     GIR_RootConstrainSelectedInstOperands,
     /* 251490 */     // GIR_Coverage, 11616,
     /* 251490 */     GIR_EraseRootFromParent_Done,
     /* 251491 */   // Label 4850: @251491
     /* 251491 */   GIM_Try, /*On fail goto*//*Label 4851*/ GIMT_Encode4(251533), // Rule ID 11625 //
     /* 251496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 251504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 251507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251520 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1770:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 251520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_B),
     /* 251523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251527 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251529 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251531 */     GIR_RootConstrainSelectedInstOperands,
     /* 251532 */     // GIR_Coverage, 11625,
     /* 251532 */     GIR_EraseRootFromParent_Done,
     /* 251533 */   // Label 4851: @251533
     /* 251533 */   GIM_Try, /*On fail goto*//*Label 4852*/ GIMT_Encode4(251575), // Rule ID 11626 //
     /* 251538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 251546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251562 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1770:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 251562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_H),
     /* 251565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251571 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251573 */     GIR_RootConstrainSelectedInstOperands,
     /* 251574 */     // GIR_Coverage, 11626,
     /* 251574 */     GIR_EraseRootFromParent_Done,
     /* 251575 */   // Label 4852: @251575
     /* 251575 */   GIM_Try, /*On fail goto*//*Label 4853*/ GIMT_Encode4(251617), // Rule ID 11627 //
     /* 251580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 251588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251604 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1770:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_S),
     /* 251607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251611 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251613 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251615 */     GIR_RootConstrainSelectedInstOperands,
     /* 251616 */     // GIR_Coverage, 11627,
     /* 251616 */     GIR_EraseRootFromParent_Done,
     /* 251617 */   // Label 4853: @251617
     /* 251617 */   GIM_Try, /*On fail goto*//*Label 4854*/ GIMT_Encode4(251659), // Rule ID 11628 //
     /* 251622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 251630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251646 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1770:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 251646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_D),
     /* 251649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251655 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251657 */     GIR_RootConstrainSelectedInstOperands,
     /* 251658 */     // GIR_Coverage, 11628,
     /* 251658 */     GIR_EraseRootFromParent_Done,
     /* 251659 */   // Label 4854: @251659
     /* 251659 */   GIM_Try, /*On fail goto*//*Label 4855*/ GIMT_Encode4(251701), // Rule ID 11629 //
     /* 251664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 251672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 251675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251688 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2006:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 251688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_B),
     /* 251691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251695 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251697 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251699 */     GIR_RootConstrainSelectedInstOperands,
     /* 251700 */     // GIR_Coverage, 11629,
     /* 251700 */     GIR_EraseRootFromParent_Done,
     /* 251701 */   // Label 4855: @251701
     /* 251701 */   GIM_Try, /*On fail goto*//*Label 4856*/ GIMT_Encode4(251743), // Rule ID 11630 //
     /* 251706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 251714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251730 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2006:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 251730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_H),
     /* 251733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251737 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251739 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251741 */     GIR_RootConstrainSelectedInstOperands,
     /* 251742 */     // GIR_Coverage, 11630,
     /* 251742 */     GIR_EraseRootFromParent_Done,
     /* 251743 */   // Label 4856: @251743
     /* 251743 */   GIM_Try, /*On fail goto*//*Label 4857*/ GIMT_Encode4(251785), // Rule ID 11631 //
     /* 251748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 251756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251772 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2006:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_S),
     /* 251775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251779 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251781 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251783 */     GIR_RootConstrainSelectedInstOperands,
     /* 251784 */     // GIR_Coverage, 11631,
     /* 251784 */     GIR_EraseRootFromParent_Done,
     /* 251785 */   // Label 4857: @251785
     /* 251785 */   GIM_Try, /*On fail goto*//*Label 4858*/ GIMT_Encode4(251827), // Rule ID 11632 //
     /* 251790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 251798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251814 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2006:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 251814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_D),
     /* 251817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251823 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251825 */     GIR_RootConstrainSelectedInstOperands,
     /* 251826 */     // GIR_Coverage, 11632,
     /* 251826 */     GIR_EraseRootFromParent_Done,
     /* 251827 */   // Label 4858: @251827
     /* 251827 */   GIM_Try, /*On fail goto*//*Label 4859*/ GIMT_Encode4(251869), // Rule ID 11633 //
     /* 251832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 251840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 251843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251856 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1857:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 251856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_B),
     /* 251859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251865 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251867 */     GIR_RootConstrainSelectedInstOperands,
     /* 251868 */     // GIR_Coverage, 11633,
     /* 251868 */     GIR_EraseRootFromParent_Done,
     /* 251869 */   // Label 4859: @251869
     /* 251869 */   GIM_Try, /*On fail goto*//*Label 4860*/ GIMT_Encode4(251911), // Rule ID 11634 //
     /* 251874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 251882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251898 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1857:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 251898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_H),
     /* 251901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251907 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251909 */     GIR_RootConstrainSelectedInstOperands,
     /* 251910 */     // GIR_Coverage, 11634,
     /* 251910 */     GIR_EraseRootFromParent_Done,
     /* 251911 */   // Label 4860: @251911
     /* 251911 */   GIM_Try, /*On fail goto*//*Label 4861*/ GIMT_Encode4(251953), // Rule ID 11635 //
     /* 251916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 251924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251940 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1857:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_S),
     /* 251943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251947 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251949 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251951 */     GIR_RootConstrainSelectedInstOperands,
     /* 251952 */     // GIR_Coverage, 11635,
     /* 251952 */     GIR_EraseRootFromParent_Done,
     /* 251953 */   // Label 4861: @251953
     /* 251953 */   GIM_Try, /*On fail goto*//*Label 4862*/ GIMT_Encode4(251995), // Rule ID 11636 //
     /* 251958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 251966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251982 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1857:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 251982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_D),
     /* 251985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251991 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251993 */     GIR_RootConstrainSelectedInstOperands,
     /* 251994 */     // GIR_Coverage, 11636,
     /* 251994 */     GIR_EraseRootFromParent_Done,
     /* 251995 */   // Label 4862: @251995
     /* 251995 */   GIM_Try, /*On fail goto*//*Label 4863*/ GIMT_Encode4(252037), // Rule ID 11637 //
     /* 252000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 252008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 252011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252024 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2050:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_B),
     /* 252027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252031 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252033 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252035 */     GIR_RootConstrainSelectedInstOperands,
     /* 252036 */     // GIR_Coverage, 11637,
     /* 252036 */     GIR_EraseRootFromParent_Done,
     /* 252037 */   // Label 4863: @252037
     /* 252037 */   GIM_Try, /*On fail goto*//*Label 4864*/ GIMT_Encode4(252079), // Rule ID 11638 //
     /* 252042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 252050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252066 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2050:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 252066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_H),
     /* 252069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252075 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252077 */     GIR_RootConstrainSelectedInstOperands,
     /* 252078 */     // GIR_Coverage, 11638,
     /* 252078 */     GIR_EraseRootFromParent_Done,
     /* 252079 */   // Label 4864: @252079
     /* 252079 */   GIM_Try, /*On fail goto*//*Label 4865*/ GIMT_Encode4(252121), // Rule ID 11639 //
     /* 252084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 252092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 252098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252108 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2050:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_S),
     /* 252111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252117 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252119 */     GIR_RootConstrainSelectedInstOperands,
     /* 252120 */     // GIR_Coverage, 11639,
     /* 252120 */     GIR_EraseRootFromParent_Done,
     /* 252121 */   // Label 4865: @252121
     /* 252121 */   GIM_Try, /*On fail goto*//*Label 4866*/ GIMT_Encode4(252163), // Rule ID 11640 //
     /* 252126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 252134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 252140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 252143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 252146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252150 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2050:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 252150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_D),
     /* 252153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252155 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252157 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252159 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252161 */     GIR_RootConstrainSelectedInstOperands,
     /* 252162 */     // GIR_Coverage, 11640,
     /* 252162 */     GIR_EraseRootFromParent_Done,
     /* 252163 */   // Label 4866: @252163
     /* 252163 */   GIM_Try, /*On fail goto*//*Label 4867*/ GIMT_Encode4(252205), // Rule ID 11641 //
     /* 252168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 252176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 252179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252192 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1921:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SUQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_B),
     /* 252195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252201 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252203 */     GIR_RootConstrainSelectedInstOperands,
     /* 252204 */     // GIR_Coverage, 11641,
     /* 252204 */     GIR_EraseRootFromParent_Done,
     /* 252205 */   // Label 4867: @252205
     /* 252205 */   GIM_Try, /*On fail goto*//*Label 4868*/ GIMT_Encode4(252247), // Rule ID 11642 //
     /* 252210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 252218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252234 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1921:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 252234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_H),
     /* 252237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252241 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252243 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252245 */     GIR_RootConstrainSelectedInstOperands,
     /* 252246 */     // GIR_Coverage, 11642,
     /* 252246 */     GIR_EraseRootFromParent_Done,
     /* 252247 */   // Label 4868: @252247
     /* 252247 */   GIM_Try, /*On fail goto*//*Label 4869*/ GIMT_Encode4(252289), // Rule ID 11643 //
     /* 252252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 252260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 252266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252276 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1921:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_S),
     /* 252279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252285 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252287 */     GIR_RootConstrainSelectedInstOperands,
     /* 252288 */     // GIR_Coverage, 11643,
     /* 252288 */     GIR_EraseRootFromParent_Done,
     /* 252289 */   // Label 4869: @252289
     /* 252289 */   GIM_Try, /*On fail goto*//*Label 4870*/ GIMT_Encode4(252331), // Rule ID 11644 //
     /* 252294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 252302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 252308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 252311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 252314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252318 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1921:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 252318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_D),
     /* 252321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252327 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252329 */     GIR_RootConstrainSelectedInstOperands,
     /* 252330 */     // GIR_Coverage, 11644,
     /* 252330 */     GIR_EraseRootFromParent_Done,
     /* 252331 */   // Label 4870: @252331
     /* 252331 */   GIM_Try, /*On fail goto*//*Label 4871*/ GIMT_Encode4(252373), // Rule ID 11645 //
     /* 252336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 252344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 252347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252360 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2071:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (USQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_B),
     /* 252363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252369 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252371 */     GIR_RootConstrainSelectedInstOperands,
     /* 252372 */     // GIR_Coverage, 11645,
     /* 252372 */     GIR_EraseRootFromParent_Done,
     /* 252373 */   // Label 4871: @252373
     /* 252373 */   GIM_Try, /*On fail goto*//*Label 4872*/ GIMT_Encode4(252415), // Rule ID 11646 //
     /* 252378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 252386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252402 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2071:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (USQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 252402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_H),
     /* 252405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252411 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252413 */     GIR_RootConstrainSelectedInstOperands,
     /* 252414 */     // GIR_Coverage, 11646,
     /* 252414 */     GIR_EraseRootFromParent_Done,
     /* 252415 */   // Label 4872: @252415
     /* 252415 */   GIM_Try, /*On fail goto*//*Label 4873*/ GIMT_Encode4(252457), // Rule ID 11647 //
     /* 252420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 252428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 252434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252444 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2071:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (USQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_S),
     /* 252447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252451 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252453 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252455 */     GIR_RootConstrainSelectedInstOperands,
     /* 252456 */     // GIR_Coverage, 11647,
     /* 252456 */     GIR_EraseRootFromParent_Done,
     /* 252457 */   // Label 4873: @252457
     /* 252457 */   GIM_Try, /*On fail goto*//*Label 4874*/ GIMT_Encode4(252499), // Rule ID 11648 //
     /* 252462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 252470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 252476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 252479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 252482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252486 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2071:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (USQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 252486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_D),
     /* 252489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252493 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252495 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252497 */     GIR_RootConstrainSelectedInstOperands,
     /* 252498 */     // GIR_Coverage, 11648,
     /* 252498 */     GIR_EraseRootFromParent_Done,
     /* 252499 */   // Label 4874: @252499
     /* 252499 */   GIM_Try, /*On fail goto*//*Label 4875*/ GIMT_Encode4(252541), // Rule ID 11649 //
     /* 252504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 252512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 252515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252528 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1860:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_B),
     /* 252531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252535 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252537 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252539 */     GIR_RootConstrainSelectedInstOperands,
     /* 252540 */     // GIR_Coverage, 11649,
     /* 252540 */     GIR_EraseRootFromParent_Done,
     /* 252541 */   // Label 4875: @252541
     /* 252541 */   GIM_Try, /*On fail goto*//*Label 4876*/ GIMT_Encode4(252583), // Rule ID 11650 //
     /* 252546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 252554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252570 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1860:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 252570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_H),
     /* 252573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252579 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252581 */     GIR_RootConstrainSelectedInstOperands,
     /* 252582 */     // GIR_Coverage, 11650,
     /* 252582 */     GIR_EraseRootFromParent_Done,
     /* 252583 */   // Label 4876: @252583
     /* 252583 */   GIM_Try, /*On fail goto*//*Label 4877*/ GIMT_Encode4(252625), // Rule ID 11651 //
     /* 252588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 252596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 252602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252612 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1860:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_S),
     /* 252615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252621 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252623 */     GIR_RootConstrainSelectedInstOperands,
     /* 252624 */     // GIR_Coverage, 11651,
     /* 252624 */     GIR_EraseRootFromParent_Done,
     /* 252625 */   // Label 4877: @252625
     /* 252625 */   GIM_Try, /*On fail goto*//*Label 4878*/ GIMT_Encode4(252667), // Rule ID 11652 //
     /* 252630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 252638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 252644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 252647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 252650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252654 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1860:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 252654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_D),
     /* 252657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252661 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252663 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252665 */     GIR_RootConstrainSelectedInstOperands,
     /* 252666 */     // GIR_Coverage, 11652,
     /* 252666 */     GIR_EraseRootFromParent_Done,
     /* 252667 */   // Label 4878: @252667
     /* 252667 */   GIM_Try, /*On fail goto*//*Label 4879*/ GIMT_Encode4(252709), // Rule ID 11653 //
     /* 252672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 252680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 252683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252696 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2053:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_B),
     /* 252699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252705 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252707 */     GIR_RootConstrainSelectedInstOperands,
     /* 252708 */     // GIR_Coverage, 11653,
     /* 252708 */     GIR_EraseRootFromParent_Done,
     /* 252709 */   // Label 4879: @252709
     /* 252709 */   GIM_Try, /*On fail goto*//*Label 4880*/ GIMT_Encode4(252751), // Rule ID 11654 //
     /* 252714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 252722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252738 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2053:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 252738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_H),
     /* 252741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252745 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252747 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252749 */     GIR_RootConstrainSelectedInstOperands,
     /* 252750 */     // GIR_Coverage, 11654,
     /* 252750 */     GIR_EraseRootFromParent_Done,
     /* 252751 */   // Label 4880: @252751
     /* 252751 */   GIM_Try, /*On fail goto*//*Label 4881*/ GIMT_Encode4(252793), // Rule ID 11655 //
     /* 252756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 252764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 252770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252780 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2053:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_S),
     /* 252783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252787 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252789 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252791 */     GIR_RootConstrainSelectedInstOperands,
     /* 252792 */     // GIR_Coverage, 11655,
     /* 252792 */     GIR_EraseRootFromParent_Done,
     /* 252793 */   // Label 4881: @252793
     /* 252793 */   GIM_Try, /*On fail goto*//*Label 4882*/ GIMT_Encode4(252835), // Rule ID 11656 //
     /* 252798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 252806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 252812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 252815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 252818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252822 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2053:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 252822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_D),
     /* 252825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252831 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252833 */     GIR_RootConstrainSelectedInstOperands,
     /* 252834 */     // GIR_Coverage, 11656,
     /* 252834 */     GIR_EraseRootFromParent_Done,
     /* 252835 */   // Label 4882: @252835
     /* 252835 */   GIM_Try, /*On fail goto*//*Label 4883*/ GIMT_Encode4(252877), // Rule ID 11657 //
     /* 252840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 252848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 252851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252864 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1867:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_B),
     /* 252867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252873 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252875 */     GIR_RootConstrainSelectedInstOperands,
     /* 252876 */     // GIR_Coverage, 11657,
     /* 252876 */     GIR_EraseRootFromParent_Done,
     /* 252877 */   // Label 4883: @252877
     /* 252877 */   GIM_Try, /*On fail goto*//*Label 4884*/ GIMT_Encode4(252919), // Rule ID 11658 //
     /* 252882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 252890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252906 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1867:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 252906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_H),
     /* 252909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252913 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252915 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252917 */     GIR_RootConstrainSelectedInstOperands,
     /* 252918 */     // GIR_Coverage, 11658,
     /* 252918 */     GIR_EraseRootFromParent_Done,
     /* 252919 */   // Label 4884: @252919
     /* 252919 */   GIM_Try, /*On fail goto*//*Label 4885*/ GIMT_Encode4(252961), // Rule ID 11659 //
     /* 252924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 252932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 252938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252948 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1867:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_S),
     /* 252951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252957 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252959 */     GIR_RootConstrainSelectedInstOperands,
     /* 252960 */     // GIR_Coverage, 11659,
     /* 252960 */     GIR_EraseRootFromParent_Done,
     /* 252961 */   // Label 4885: @252961
     /* 252961 */   GIM_Try, /*On fail goto*//*Label 4886*/ GIMT_Encode4(253003), // Rule ID 11660 //
     /* 252966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 252974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 252980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 252983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 252986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252990 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1867:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 252990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_D),
     /* 252993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252999 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253001 */     GIR_RootConstrainSelectedInstOperands,
     /* 253002 */     // GIR_Coverage, 11660,
     /* 253002 */     GIR_EraseRootFromParent_Done,
     /* 253003 */   // Label 4886: @253003
     /* 253003 */   GIM_Try, /*On fail goto*//*Label 4887*/ GIMT_Encode4(253045), // Rule ID 11661 //
     /* 253008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 253016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 253019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 253022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253032 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2058:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (URSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 253032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_B),
     /* 253035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253041 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253043 */     GIR_RootConstrainSelectedInstOperands,
     /* 253044 */     // GIR_Coverage, 11661,
     /* 253044 */     GIR_EraseRootFromParent_Done,
     /* 253045 */   // Label 4887: @253045
     /* 253045 */   GIM_Try, /*On fail goto*//*Label 4888*/ GIMT_Encode4(253087), // Rule ID 11662 //
     /* 253050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 253058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 253064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253074 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2058:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (URSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 253074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_H),
     /* 253077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253083 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253085 */     GIR_RootConstrainSelectedInstOperands,
     /* 253086 */     // GIR_Coverage, 11662,
     /* 253086 */     GIR_EraseRootFromParent_Done,
     /* 253087 */   // Label 4888: @253087
     /* 253087 */   GIM_Try, /*On fail goto*//*Label 4889*/ GIMT_Encode4(253129), // Rule ID 11663 //
     /* 253092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 253100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 253106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253116 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2058:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 253116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_S),
     /* 253119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253125 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253127 */     GIR_RootConstrainSelectedInstOperands,
     /* 253128 */     // GIR_Coverage, 11663,
     /* 253128 */     GIR_EraseRootFromParent_Done,
     /* 253129 */   // Label 4889: @253129
     /* 253129 */   GIM_Try, /*On fail goto*//*Label 4890*/ GIMT_Encode4(253171), // Rule ID 11664 //
     /* 253134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 253142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 253145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 253148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253158 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2058:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (URSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 253158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_D),
     /* 253161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253165 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253167 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253169 */     GIR_RootConstrainSelectedInstOperands,
     /* 253170 */     // GIR_Coverage, 11664,
     /* 253170 */     GIR_EraseRootFromParent_Done,
     /* 253171 */   // Label 4890: @253171
     /* 253171 */   GIM_Try, /*On fail goto*//*Label 4891*/ GIMT_Encode4(253213), // Rule ID 11665 //
     /* 253176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 253184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 253187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 253190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253200 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1851:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 253200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_B),
     /* 253203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253207 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253209 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253211 */     GIR_RootConstrainSelectedInstOperands,
     /* 253212 */     // GIR_Coverage, 11665,
     /* 253212 */     GIR_EraseRootFromParent_Done,
     /* 253213 */   // Label 4891: @253213
     /* 253213 */   GIM_Try, /*On fail goto*//*Label 4892*/ GIMT_Encode4(253255), // Rule ID 11666 //
     /* 253218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 253226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 253232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253242 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1851:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 253242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_H),
     /* 253245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253251 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253253 */     GIR_RootConstrainSelectedInstOperands,
     /* 253254 */     // GIR_Coverage, 11666,
     /* 253254 */     GIR_EraseRootFromParent_Done,
     /* 253255 */   // Label 4892: @253255
     /* 253255 */   GIM_Try, /*On fail goto*//*Label 4893*/ GIMT_Encode4(253297), // Rule ID 11667 //
     /* 253260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 253268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 253274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253284 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1851:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 253284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_S),
     /* 253287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253291 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253293 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253295 */     GIR_RootConstrainSelectedInstOperands,
     /* 253296 */     // GIR_Coverage, 11667,
     /* 253296 */     GIR_EraseRootFromParent_Done,
     /* 253297 */   // Label 4893: @253297
     /* 253297 */   GIM_Try, /*On fail goto*//*Label 4894*/ GIMT_Encode4(253339), // Rule ID 11668 //
     /* 253302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 253310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 253313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 253316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253326 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1851:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 253326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_D),
     /* 253329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253335 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253337 */     GIR_RootConstrainSelectedInstOperands,
     /* 253338 */     // GIR_Coverage, 11668,
     /* 253338 */     GIR_EraseRootFromParent_Done,
     /* 253339 */   // Label 4894: @253339
     /* 253339 */   GIM_Try, /*On fail goto*//*Label 4895*/ GIMT_Encode4(253381), // Rule ID 11669 //
     /* 253344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 253352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 253355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 253358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253368 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2047:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 253368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_B),
     /* 253371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253377 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253379 */     GIR_RootConstrainSelectedInstOperands,
     /* 253380 */     // GIR_Coverage, 11669,
     /* 253380 */     GIR_EraseRootFromParent_Done,
     /* 253381 */   // Label 4895: @253381
     /* 253381 */   GIM_Try, /*On fail goto*//*Label 4896*/ GIMT_Encode4(253423), // Rule ID 11670 //
     /* 253386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 253394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 253400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253410 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2047:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 253410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_H),
     /* 253413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253417 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253419 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253421 */     GIR_RootConstrainSelectedInstOperands,
     /* 253422 */     // GIR_Coverage, 11670,
     /* 253422 */     GIR_EraseRootFromParent_Done,
     /* 253423 */   // Label 4896: @253423
     /* 253423 */   GIM_Try, /*On fail goto*//*Label 4897*/ GIMT_Encode4(253465), // Rule ID 11671 //
     /* 253428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 253436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 253442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253452 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2047:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 253452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_S),
     /* 253455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253461 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253463 */     GIR_RootConstrainSelectedInstOperands,
     /* 253464 */     // GIR_Coverage, 11671,
     /* 253464 */     GIR_EraseRootFromParent_Done,
     /* 253465 */   // Label 4897: @253465
     /* 253465 */   GIM_Try, /*On fail goto*//*Label 4898*/ GIMT_Encode4(253507), // Rule ID 11672 //
     /* 253470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 253478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 253481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 253484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253494 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2047:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 253494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_D),
     /* 253497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253503 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253505 */     GIR_RootConstrainSelectedInstOperands,
     /* 253506 */     // GIR_Coverage, 11672,
     /* 253506 */     GIR_EraseRootFromParent_Done,
     /* 253507 */   // Label 4898: @253507
     /* 253507 */   GIM_Try, /*On fail goto*//*Label 4899*/ GIMT_Encode4(253549), // Rule ID 11673 //
     /* 253512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 253520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 253523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 253526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253536 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1838:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 253536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_B),
     /* 253539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253545 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253547 */     GIR_RootConstrainSelectedInstOperands,
     /* 253548 */     // GIR_Coverage, 11673,
     /* 253548 */     GIR_EraseRootFromParent_Done,
     /* 253549 */   // Label 4899: @253549
     /* 253549 */   GIM_Try, /*On fail goto*//*Label 4900*/ GIMT_Encode4(253591), // Rule ID 11674 //
     /* 253554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 253562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 253568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253578 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1838:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 253578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_H),
     /* 253581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253587 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253589 */     GIR_RootConstrainSelectedInstOperands,
     /* 253590 */     // GIR_Coverage, 11674,
     /* 253590 */     GIR_EraseRootFromParent_Done,
     /* 253591 */   // Label 4900: @253591
     /* 253591 */   GIM_Try, /*On fail goto*//*Label 4901*/ GIMT_Encode4(253633), // Rule ID 11675 //
     /* 253596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 253604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 253610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253620 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1838:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 253620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_S),
     /* 253623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253629 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253631 */     GIR_RootConstrainSelectedInstOperands,
     /* 253632 */     // GIR_Coverage, 11675,
     /* 253632 */     GIR_EraseRootFromParent_Done,
     /* 253633 */   // Label 4901: @253633
     /* 253633 */   GIM_Try, /*On fail goto*//*Label 4902*/ GIMT_Encode4(253675), // Rule ID 11676 //
     /* 253638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 253646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 253649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 253652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253662 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1838:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 253662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_D),
     /* 253665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253669 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253671 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253673 */     GIR_RootConstrainSelectedInstOperands,
     /* 253674 */     // GIR_Coverage, 11676,
     /* 253674 */     GIR_EraseRootFromParent_Done,
     /* 253675 */   // Label 4902: @253675
     /* 253675 */   GIM_Try, /*On fail goto*//*Label 4903*/ GIMT_Encode4(253717), // Rule ID 11677 //
     /* 253680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 253688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 253691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 253694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253704 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2040:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 253704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_B),
     /* 253707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253713 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253715 */     GIR_RootConstrainSelectedInstOperands,
     /* 253716 */     // GIR_Coverage, 11677,
     /* 253716 */     GIR_EraseRootFromParent_Done,
     /* 253717 */   // Label 4903: @253717
     /* 253717 */   GIM_Try, /*On fail goto*//*Label 4904*/ GIMT_Encode4(253759), // Rule ID 11678 //
     /* 253722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 253730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 253736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253746 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2040:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 253746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_H),
     /* 253749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253755 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253757 */     GIR_RootConstrainSelectedInstOperands,
     /* 253758 */     // GIR_Coverage, 11678,
     /* 253758 */     GIR_EraseRootFromParent_Done,
     /* 253759 */   // Label 4904: @253759
     /* 253759 */   GIM_Try, /*On fail goto*//*Label 4905*/ GIMT_Encode4(253801), // Rule ID 11679 //
     /* 253764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 253772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 253778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253788 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2040:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 253788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_S),
     /* 253791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253797 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253799 */     GIR_RootConstrainSelectedInstOperands,
     /* 253800 */     // GIR_Coverage, 11679,
     /* 253800 */     GIR_EraseRootFromParent_Done,
     /* 253801 */   // Label 4905: @253801
     /* 253801 */   GIM_Try, /*On fail goto*//*Label 4906*/ GIMT_Encode4(253843), // Rule ID 11680 //
     /* 253806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 253814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 253817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 253820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253830 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2040:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 253830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_D),
     /* 253833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253839 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253841 */     GIR_RootConstrainSelectedInstOperands,
     /* 253842 */     // GIR_Coverage, 11680,
     /* 253842 */     GIR_EraseRootFromParent_Done,
     /* 253843 */   // Label 4906: @253843
     /* 253843 */   GIM_Try, /*On fail goto*//*Label 4907*/ GIMT_Encode4(253885), // Rule ID 11855 //
     /* 253848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 253856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 253859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 253862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253872 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1940:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABA_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 253872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_B),
     /* 253875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 253877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253881 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253883 */     GIR_RootConstrainSelectedInstOperands,
     /* 253884 */     // GIR_Coverage, 11855,
     /* 253884 */     GIR_EraseRootFromParent_Done,
     /* 253885 */   // Label 4907: @253885
     /* 253885 */   GIM_Try, /*On fail goto*//*Label 4908*/ GIMT_Encode4(253927), // Rule ID 11857 //
     /* 253890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 253898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253914 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1940:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABA_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 253914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_H),
     /* 253917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 253919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253923 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253925 */     GIR_RootConstrainSelectedInstOperands,
     /* 253926 */     // GIR_Coverage, 11857,
     /* 253926 */     GIR_EraseRootFromParent_Done,
     /* 253927 */   // Label 4908: @253927
     /* 253927 */   GIM_Try, /*On fail goto*//*Label 4909*/ GIMT_Encode4(253969), // Rule ID 11859 //
     /* 253932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 253940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 253946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253956 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1940:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABA_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 253956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_S),
     /* 253959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 253961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253965 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253967 */     GIR_RootConstrainSelectedInstOperands,
     /* 253968 */     // GIR_Coverage, 11859,
     /* 253968 */     GIR_EraseRootFromParent_Done,
     /* 253969 */   // Label 4909: @253969
     /* 253969 */   GIM_Try, /*On fail goto*//*Label 4910*/ GIMT_Encode4(254011), // Rule ID 11861 //
     /* 253974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 253982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 253985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 253988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253998 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1940:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UABA_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 253998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_D),
     /* 254001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254007 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254009 */     GIR_RootConstrainSelectedInstOperands,
     /* 254010 */     // GIR_Coverage, 11861,
     /* 254010 */     GIR_EraseRootFromParent_Done,
     /* 254011 */   // Label 4910: @254011
     /* 254011 */   GIM_Try, /*On fail goto*//*Label 4911*/ GIMT_Encode4(254053), // Rule ID 11863 //
     /* 254016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 254024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 254027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 254030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 254033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 254036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254040 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1692:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 254040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_H),
     /* 254043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254047 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254049 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254051 */     GIR_RootConstrainSelectedInstOperands,
     /* 254052 */     // GIR_Coverage, 11863,
     /* 254052 */     GIR_EraseRootFromParent_Done,
     /* 254053 */   // Label 4911: @254053
     /* 254053 */   GIM_Try, /*On fail goto*//*Label 4912*/ GIMT_Encode4(254095), // Rule ID 11864 //
     /* 254058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 254066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254082 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1692:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 254082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_S),
     /* 254085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254091 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254093 */     GIR_RootConstrainSelectedInstOperands,
     /* 254094 */     // GIR_Coverage, 11864,
     /* 254094 */     GIR_EraseRootFromParent_Done,
     /* 254095 */   // Label 4912: @254095
     /* 254095 */   GIM_Try, /*On fail goto*//*Label 4913*/ GIMT_Encode4(254137), // Rule ID 11865 //
     /* 254100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 254108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 254114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254124 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1692:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_D),
     /* 254127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254133 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254135 */     GIR_RootConstrainSelectedInstOperands,
     /* 254136 */     // GIR_Coverage, 11865,
     /* 254136 */     GIR_EraseRootFromParent_Done,
     /* 254137 */   // Label 4913: @254137
     /* 254137 */   GIM_Try, /*On fail goto*//*Label 4914*/ GIMT_Encode4(254179), // Rule ID 11866 //
     /* 254142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 254150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 254153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 254156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 254159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 254162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254166 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1941:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 254166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_H),
     /* 254169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254175 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254177 */     GIR_RootConstrainSelectedInstOperands,
     /* 254178 */     // GIR_Coverage, 11866,
     /* 254178 */     GIR_EraseRootFromParent_Done,
     /* 254179 */   // Label 4914: @254179
     /* 254179 */   GIM_Try, /*On fail goto*//*Label 4915*/ GIMT_Encode4(254221), // Rule ID 11867 //
     /* 254184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 254192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254208 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1941:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 254208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_S),
     /* 254211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254217 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254219 */     GIR_RootConstrainSelectedInstOperands,
     /* 254220 */     // GIR_Coverage, 11867,
     /* 254220 */     GIR_EraseRootFromParent_Done,
     /* 254221 */   // Label 4915: @254221
     /* 254221 */   GIM_Try, /*On fail goto*//*Label 4916*/ GIMT_Encode4(254263), // Rule ID 11868 //
     /* 254226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 254234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 254240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254250 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1941:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_D),
     /* 254253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254259 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254261 */     GIR_RootConstrainSelectedInstOperands,
     /* 254262 */     // GIR_Coverage, 11868,
     /* 254262 */     GIR_EraseRootFromParent_Done,
     /* 254263 */   // Label 4916: @254263
     /* 254263 */   GIM_Try, /*On fail goto*//*Label 4917*/ GIMT_Encode4(254305), // Rule ID 11869 //
     /* 254268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 254276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 254279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 254282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 254285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 254288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254292 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1942:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 254292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_H),
     /* 254295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254301 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254303 */     GIR_RootConstrainSelectedInstOperands,
     /* 254304 */     // GIR_Coverage, 11869,
     /* 254304 */     GIR_EraseRootFromParent_Done,
     /* 254305 */   // Label 4917: @254305
     /* 254305 */   GIM_Try, /*On fail goto*//*Label 4918*/ GIMT_Encode4(254347), // Rule ID 11870 //
     /* 254310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 254318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254334 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1942:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 254334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_S),
     /* 254337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254341 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254343 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254345 */     GIR_RootConstrainSelectedInstOperands,
     /* 254346 */     // GIR_Coverage, 11870,
     /* 254346 */     GIR_EraseRootFromParent_Done,
     /* 254347 */   // Label 4918: @254347
     /* 254347 */   GIM_Try, /*On fail goto*//*Label 4919*/ GIMT_Encode4(254389), // Rule ID 11871 //
     /* 254352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 254360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 254366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254376 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1942:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_D),
     /* 254379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254385 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254387 */     GIR_RootConstrainSelectedInstOperands,
     /* 254388 */     // GIR_Coverage, 11871,
     /* 254388 */     GIR_EraseRootFromParent_Done,
     /* 254389 */   // Label 4919: @254389
     /* 254389 */   GIM_Try, /*On fail goto*//*Label 4920*/ GIMT_Encode4(254431), // Rule ID 11872 //
     /* 254394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclt),
     /* 254402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254418 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1255:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADCLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLT_ZZZ_S),
     /* 254421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254425 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254427 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254429 */     GIR_RootConstrainSelectedInstOperands,
     /* 254430 */     // GIR_Coverage, 11872,
     /* 254430 */     GIR_EraseRootFromParent_Done,
     /* 254431 */   // Label 4920: @254431
     /* 254431 */   GIM_Try, /*On fail goto*//*Label 4921*/ GIMT_Encode4(254473), // Rule ID 11873 //
     /* 254436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclt),
     /* 254444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 254450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 254456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254460 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1255:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADCLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 254460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLT_ZZZ_D),
     /* 254463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254469 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254471 */     GIR_RootConstrainSelectedInstOperands,
     /* 254472 */     // GIR_Coverage, 11873,
     /* 254472 */     GIR_EraseRootFromParent_Done,
     /* 254473 */   // Label 4921: @254473
     /* 254473 */   GIM_Try, /*On fail goto*//*Label 4922*/ GIMT_Encode4(254515), // Rule ID 11874 //
     /* 254478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclb),
     /* 254486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254502 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1704:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SBCLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLB_ZZZ_S),
     /* 254505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254511 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254513 */     GIR_RootConstrainSelectedInstOperands,
     /* 254514 */     // GIR_Coverage, 11874,
     /* 254514 */     GIR_EraseRootFromParent_Done,
     /* 254515 */   // Label 4922: @254515
     /* 254515 */   GIM_Try, /*On fail goto*//*Label 4923*/ GIMT_Encode4(254557), // Rule ID 11875 //
     /* 254520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclb),
     /* 254528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 254534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 254540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254544 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1704:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SBCLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 254544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLB_ZZZ_D),
     /* 254547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254551 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254553 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254555 */     GIR_RootConstrainSelectedInstOperands,
     /* 254556 */     // GIR_Coverage, 11875,
     /* 254556 */     GIR_EraseRootFromParent_Done,
     /* 254557 */   // Label 4923: @254557
     /* 254557 */   GIM_Try, /*On fail goto*//*Label 4924*/ GIMT_Encode4(254599), // Rule ID 11876 //
     /* 254562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclt),
     /* 254570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254586 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1705:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SBCLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLT_ZZZ_S),
     /* 254589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254595 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254597 */     GIR_RootConstrainSelectedInstOperands,
     /* 254598 */     // GIR_Coverage, 11876,
     /* 254598 */     GIR_EraseRootFromParent_Done,
     /* 254599 */   // Label 4924: @254599
     /* 254599 */   GIM_Try, /*On fail goto*//*Label 4925*/ GIMT_Encode4(254641), // Rule ID 11877 //
     /* 254604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclt),
     /* 254612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 254618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 254624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254628 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1705:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SBCLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 254628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLT_ZZZ_D),
     /* 254631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254637 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254639 */     GIR_RootConstrainSelectedInstOperands,
     /* 254640 */     // GIR_Coverage, 11877,
     /* 254640 */     GIR_EraseRootFromParent_Done,
     /* 254641 */   // Label 4925: @254641
     /* 254641 */   GIM_Try, /*On fail goto*//*Label 4926*/ GIMT_Encode4(254683), // Rule ID 11932 //
     /* 254646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 254654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 254657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 254660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254670 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1673:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (RADDHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 254670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_B),
     /* 254673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 254675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254679 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254681 */     GIR_RootConstrainSelectedInstOperands,
     /* 254682 */     // GIR_Coverage, 11932,
     /* 254682 */     GIR_EraseRootFromParent_Done,
     /* 254683 */   // Label 4926: @254683
     /* 254683 */   GIM_Try, /*On fail goto*//*Label 4927*/ GIMT_Encode4(254725), // Rule ID 11933 //
     /* 254688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 254696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 254699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 254702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254712 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1673:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (RADDHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_H),
     /* 254715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 254717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254721 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254723 */     GIR_RootConstrainSelectedInstOperands,
     /* 254724 */     // GIR_Coverage, 11933,
     /* 254724 */     GIR_EraseRootFromParent_Done,
     /* 254725 */   // Label 4927: @254725
     /* 254725 */   GIM_Try, /*On fail goto*//*Label 4928*/ GIMT_Encode4(254767), // Rule ID 11934 //
     /* 254730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 254738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 254750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254754 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1673:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (RADDHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 254754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_S),
     /* 254757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 254759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254763 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254765 */     GIR_RootConstrainSelectedInstOperands,
     /* 254766 */     // GIR_Coverage, 11934,
     /* 254766 */     GIR_EraseRootFromParent_Done,
     /* 254767 */   // Label 4928: @254767
     /* 254767 */   GIM_Try, /*On fail goto*//*Label 4929*/ GIMT_Encode4(254809), // Rule ID 11935 //
     /* 254772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 254780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 254783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 254786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254796 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1914:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUBHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 254796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_B),
     /* 254799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 254801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254805 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254807 */     GIR_RootConstrainSelectedInstOperands,
     /* 254808 */     // GIR_Coverage, 11935,
     /* 254808 */     GIR_EraseRootFromParent_Done,
     /* 254809 */   // Label 4929: @254809
     /* 254809 */   GIM_Try, /*On fail goto*//*Label 4930*/ GIMT_Encode4(254851), // Rule ID 11936 //
     /* 254814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 254822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 254825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 254828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254838 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1914:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUBHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_H),
     /* 254841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 254843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254845 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254847 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254849 */     GIR_RootConstrainSelectedInstOperands,
     /* 254850 */     // GIR_Coverage, 11936,
     /* 254850 */     GIR_EraseRootFromParent_Done,
     /* 254851 */   // Label 4930: @254851
     /* 254851 */   GIM_Try, /*On fail goto*//*Label 4931*/ GIMT_Encode4(254893), // Rule ID 11937 //
     /* 254856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 254864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 254876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254880 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1914:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUBHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 254880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_S),
     /* 254883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 254885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254887 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254889 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254891 */     GIR_RootConstrainSelectedInstOperands,
     /* 254892 */     // GIR_Coverage, 11937,
     /* 254892 */     GIR_EraseRootFromParent_Done,
     /* 254893 */   // Label 4931: @254893
     /* 254893 */   GIM_Try, /*On fail goto*//*Label 4932*/ GIMT_Encode4(254935), // Rule ID 11938 //
     /* 254898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 254906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 254909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 254912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254922 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1689:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (RSUBHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 254922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_B),
     /* 254925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 254927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254931 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254933 */     GIR_RootConstrainSelectedInstOperands,
     /* 254934 */     // GIR_Coverage, 11938,
     /* 254934 */     GIR_EraseRootFromParent_Done,
     /* 254935 */   // Label 4932: @254935
     /* 254935 */   GIM_Try, /*On fail goto*//*Label 4933*/ GIMT_Encode4(254977), // Rule ID 11939 //
     /* 254940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 254948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 254951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 254954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254964 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1689:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (RSUBHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_H),
     /* 254967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 254969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254973 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254975 */     GIR_RootConstrainSelectedInstOperands,
     /* 254976 */     // GIR_Coverage, 11939,
     /* 254976 */     GIR_EraseRootFromParent_Done,
     /* 254977 */   // Label 4933: @254977
     /* 254977 */   GIM_Try, /*On fail goto*//*Label 4934*/ GIMT_Encode4(255019), // Rule ID 11940 //
     /* 254982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 254990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255006 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1689:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (RSUBHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 255006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_S),
     /* 255009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255015 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255017 */     GIR_RootConstrainSelectedInstOperands,
     /* 255018 */     // GIR_Coverage, 11940,
     /* 255018 */     GIR_EraseRootFromParent_Done,
     /* 255019 */   // Label 4934: @255019
     /* 255019 */   GIM_Try, /*On fail goto*//*Label 4935*/ GIMT_Encode4(255064), // Rule ID 11953 //
     /* 255024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 255027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nmatch),
     /* 255032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 255035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 255038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 255041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 255044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 255048 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1624:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (NMATCH_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 255048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NMATCH_PPzZZ_B),
     /* 255051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 255053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255057 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255059 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 255062 */     GIR_RootConstrainSelectedInstOperands,
     /* 255063 */     // GIR_Coverage, 11953,
     /* 255063 */     GIR_EraseRootFromParent_Done,
     /* 255064 */   // Label 4935: @255064
     /* 255064 */   GIM_Try, /*On fail goto*//*Label 4936*/ GIMT_Encode4(255109), // Rule ID 11954 //
     /* 255069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 255072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nmatch),
     /* 255077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 255080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 255083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 255093 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1624:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (NMATCH_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 255093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NMATCH_PPzZZ_H),
     /* 255096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 255098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255102 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255104 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 255107 */     GIR_RootConstrainSelectedInstOperands,
     /* 255108 */     // GIR_Coverage, 11954,
     /* 255108 */     GIR_EraseRootFromParent_Done,
     /* 255109 */   // Label 4936: @255109
     /* 255109 */   GIM_Try, /*On fail goto*//*Label 4937*/ GIMT_Encode4(255151), // Rule ID 11955 //
     /* 255114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 255122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 255125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 255128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 255131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 255134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255138 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1364:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EORTB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 255138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_B),
     /* 255141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255147 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255149 */     GIR_RootConstrainSelectedInstOperands,
     /* 255150 */     // GIR_Coverage, 11955,
     /* 255150 */     GIR_EraseRootFromParent_Done,
     /* 255151 */   // Label 4937: @255151
     /* 255151 */   GIM_Try, /*On fail goto*//*Label 4938*/ GIMT_Encode4(255193), // Rule ID 11956 //
     /* 255156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 255164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 255167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 255170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255180 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1364:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EORTB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 255180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_H),
     /* 255183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255189 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255191 */     GIR_RootConstrainSelectedInstOperands,
     /* 255192 */     // GIR_Coverage, 11956,
     /* 255192 */     GIR_EraseRootFromParent_Done,
     /* 255193 */   // Label 4938: @255193
     /* 255193 */   GIM_Try, /*On fail goto*//*Label 4939*/ GIMT_Encode4(255235), // Rule ID 11957 //
     /* 255198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 255206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 255212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255222 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1364:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EORTB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 255222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_S),
     /* 255225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255231 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255233 */     GIR_RootConstrainSelectedInstOperands,
     /* 255234 */     // GIR_Coverage, 11957,
     /* 255234 */     GIR_EraseRootFromParent_Done,
     /* 255235 */   // Label 4939: @255235
     /* 255235 */   GIM_Try, /*On fail goto*//*Label 4940*/ GIMT_Encode4(255277), // Rule ID 11958 //
     /* 255240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 255248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 255251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 255254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255264 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1364:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EORTB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 255264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_D),
     /* 255267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255271 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255273 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255275 */     GIR_RootConstrainSelectedInstOperands,
     /* 255276 */     // GIR_Coverage, 11958,
     /* 255276 */     GIR_EraseRootFromParent_Done,
     /* 255277 */   // Label 4940: @255277
     /* 255277 */   GIM_Try, /*On fail goto*//*Label 4941*/ GIMT_Encode4(255319), // Rule ID 11974 //
     /* 255282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 255290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 255293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 255296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255306 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1447:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMAXNMP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 255306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_H),
     /* 255309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255315 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255317 */     GIR_RootConstrainSelectedInstOperands,
     /* 255318 */     // GIR_Coverage, 11974,
     /* 255318 */     GIR_EraseRootFromParent_Done,
     /* 255319 */   // Label 4941: @255319
     /* 255319 */   GIM_Try, /*On fail goto*//*Label 4942*/ GIMT_Encode4(255361), // Rule ID 11975 //
     /* 255324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 255332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 255338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255348 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1447:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMAXNMP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 255348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_S),
     /* 255351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255357 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255359 */     GIR_RootConstrainSelectedInstOperands,
     /* 255360 */     // GIR_Coverage, 11975,
     /* 255360 */     GIR_EraseRootFromParent_Done,
     /* 255361 */   // Label 4942: @255361
     /* 255361 */   GIM_Try, /*On fail goto*//*Label 4943*/ GIMT_Encode4(255403), // Rule ID 11976 //
     /* 255366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 255374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 255377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 255380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255390 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1447:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMAXNMP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 255390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_D),
     /* 255393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255399 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255401 */     GIR_RootConstrainSelectedInstOperands,
     /* 255402 */     // GIR_Coverage, 11976,
     /* 255402 */     GIR_EraseRootFromParent_Done,
     /* 255403 */   // Label 4943: @255403
     /* 255403 */   GIM_Try, /*On fail goto*//*Label 4944*/ GIMT_Encode4(255445), // Rule ID 11977 //
     /* 255408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 255416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 255419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 255422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255432 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1465:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMINNMP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 255432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_H),
     /* 255435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255441 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255443 */     GIR_RootConstrainSelectedInstOperands,
     /* 255444 */     // GIR_Coverage, 11977,
     /* 255444 */     GIR_EraseRootFromParent_Done,
     /* 255445 */   // Label 4944: @255445
     /* 255445 */   GIM_Try, /*On fail goto*//*Label 4945*/ GIMT_Encode4(255487), // Rule ID 11978 //
     /* 255450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 255458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 255464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255474 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1465:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMINNMP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 255474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_S),
     /* 255477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255481 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255483 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255485 */     GIR_RootConstrainSelectedInstOperands,
     /* 255486 */     // GIR_Coverage, 11978,
     /* 255486 */     GIR_EraseRootFromParent_Done,
     /* 255487 */   // Label 4945: @255487
     /* 255487 */   GIM_Try, /*On fail goto*//*Label 4946*/ GIMT_Encode4(255529), // Rule ID 11979 //
     /* 255492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 255500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 255503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 255506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255516 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1465:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMINNMP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 255516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_D),
     /* 255519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255525 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255527 */     GIR_RootConstrainSelectedInstOperands,
     /* 255528 */     // GIR_Coverage, 11979,
     /* 255528 */     GIR_EraseRootFromParent_Done,
     /* 255529 */   // Label 4946: @255529
     /* 255529 */   GIM_Try, /*On fail goto*//*Label 4947*/ GIMT_Encode4(255571), // Rule ID 11980 //
     /* 255534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 255542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 255545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 255548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255558 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1450:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMAXP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 255558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_H),
     /* 255561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255567 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255569 */     GIR_RootConstrainSelectedInstOperands,
     /* 255570 */     // GIR_Coverage, 11980,
     /* 255570 */     GIR_EraseRootFromParent_Done,
     /* 255571 */   // Label 4947: @255571
     /* 255571 */   GIM_Try, /*On fail goto*//*Label 4948*/ GIMT_Encode4(255613), // Rule ID 11981 //
     /* 255576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 255584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 255590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255600 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1450:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMAXP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 255600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_S),
     /* 255603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255609 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255611 */     GIR_RootConstrainSelectedInstOperands,
     /* 255612 */     // GIR_Coverage, 11981,
     /* 255612 */     GIR_EraseRootFromParent_Done,
     /* 255613 */   // Label 4948: @255613
     /* 255613 */   GIM_Try, /*On fail goto*//*Label 4949*/ GIMT_Encode4(255655), // Rule ID 11982 //
     /* 255618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 255626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 255629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 255632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255642 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1450:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMAXP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 255642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_D),
     /* 255645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255651 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255653 */     GIR_RootConstrainSelectedInstOperands,
     /* 255654 */     // GIR_Coverage, 11982,
     /* 255654 */     GIR_EraseRootFromParent_Done,
     /* 255655 */   // Label 4949: @255655
     /* 255655 */   GIM_Try, /*On fail goto*//*Label 4950*/ GIMT_Encode4(255697), // Rule ID 11983 //
     /* 255660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 255668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 255671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 255674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255684 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1468:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMINP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 255684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_H),
     /* 255687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255693 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255695 */     GIR_RootConstrainSelectedInstOperands,
     /* 255696 */     // GIR_Coverage, 11983,
     /* 255696 */     GIR_EraseRootFromParent_Done,
     /* 255697 */   // Label 4950: @255697
     /* 255697 */   GIM_Try, /*On fail goto*//*Label 4951*/ GIMT_Encode4(255739), // Rule ID 11984 //
     /* 255702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 255710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 255716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255726 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1468:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMINP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 255726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_S),
     /* 255729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255735 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255737 */     GIR_RootConstrainSelectedInstOperands,
     /* 255738 */     // GIR_Coverage, 11984,
     /* 255738 */     GIR_EraseRootFromParent_Done,
     /* 255739 */   // Label 4951: @255739
     /* 255739 */   GIM_Try, /*On fail goto*//*Label 4952*/ GIMT_Encode4(255781), // Rule ID 11985 //
     /* 255744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 255752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 255755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 255758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255768 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1468:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMINP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 255768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_D),
     /* 255771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255777 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255779 */     GIR_RootConstrainSelectedInstOperands,
     /* 255780 */     // GIR_Coverage, 11985,
     /* 255780 */     GIR_EraseRootFromParent_Done,
     /* 255781 */   // Label 4952: @255781
     /* 255781 */   GIM_Try, /*On fail goto*//*Label 4953*/ GIMT_Encode4(255823), // Rule ID 11990 //
     /* 255786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalb),
     /* 255794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 255800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255810 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1474:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLALB_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 255810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZ_SHH),
     /* 255813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 255815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255817 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255819 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255821 */     GIR_RootConstrainSelectedInstOperands,
     /* 255822 */     // GIR_Coverage, 11990,
     /* 255822 */     GIR_EraseRootFromParent_Done,
     /* 255823 */   // Label 4953: @255823
     /* 255823 */   GIM_Try, /*On fail goto*//*Label 4954*/ GIMT_Encode4(255865), // Rule ID 11991 //
     /* 255828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalt),
     /* 255836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 255842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255852 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1476:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLALT_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 255852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZ_SHH),
     /* 255855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 255857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255861 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255863 */     GIR_RootConstrainSelectedInstOperands,
     /* 255864 */     // GIR_Coverage, 11991,
     /* 255864 */     GIR_EraseRootFromParent_Done,
     /* 255865 */   // Label 4954: @255865
     /* 255865 */   GIM_Try, /*On fail goto*//*Label 4955*/ GIMT_Encode4(255907), // Rule ID 11992 //
     /* 255870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslb),
     /* 255878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 255884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255894 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1481:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLSLB_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 255894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLB_ZZZ_SHH),
     /* 255897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 255899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255901 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255903 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255905 */     GIR_RootConstrainSelectedInstOperands,
     /* 255906 */     // GIR_Coverage, 11992,
     /* 255906 */     GIR_EraseRootFromParent_Done,
     /* 255907 */   // Label 4955: @255907
     /* 255907 */   GIM_Try, /*On fail goto*//*Label 4956*/ GIMT_Encode4(255949), // Rule ID 11993 //
     /* 255912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslt),
     /* 255920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 255926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255936 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1483:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLSLT_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 255936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLT_ZZZ_SHH),
     /* 255939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 255941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255945 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255947 */     GIR_RootConstrainSelectedInstOperands,
     /* 255948 */     // GIR_Coverage, 11993,
     /* 255948 */     GIR_EraseRootFromParent_Done,
     /* 255949 */   // Label 4956: @255949
     /* 255949 */   GIM_Try, /*On fail goto*//*Label 4957*/ GIMT_Encode4(255991), // Rule ID 11994 //
     /* 255954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 255962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 255965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 255968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 255971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 255974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255978 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1281:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 255978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 255981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255985 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255987 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255989 */     GIR_RootConstrainSelectedInstOperands,
     /* 255990 */     // GIR_Coverage, 11994,
     /* 255990 */     GIR_EraseRootFromParent_Done,
     /* 255991 */   // Label 4957: @255991
     /* 255991 */   GIM_Try, /*On fail goto*//*Label 4958*/ GIMT_Encode4(256033), // Rule ID 11996 //
     /* 255996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 256004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 256007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 256010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 256013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 256016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256020 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1281:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 256020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 256023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 256025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256029 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256031 */     GIR_RootConstrainSelectedInstOperands,
     /* 256032 */     // GIR_Coverage, 11996,
     /* 256032 */     GIR_EraseRootFromParent_Done,
     /* 256033 */   // Label 4958: @256033
     /* 256033 */   GIM_Try, /*On fail goto*//*Label 4959*/ GIMT_Encode4(256075), // Rule ID 11998 //
     /* 256038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 256046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 256052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 256058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256062 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1281:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 256062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 256065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 256067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256071 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256073 */     GIR_RootConstrainSelectedInstOperands,
     /* 256074 */     // GIR_Coverage, 11998,
     /* 256074 */     GIR_EraseRootFromParent_Done,
     /* 256075 */   // Label 4959: @256075
     /* 256075 */   GIM_Try, /*On fail goto*//*Label 4960*/ GIMT_Encode4(256117), // Rule ID 12000 //
     /* 256080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 256088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 256091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 256094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 256100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256104 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1281:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 256104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 256107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 256109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256111 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256113 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256115 */     GIR_RootConstrainSelectedInstOperands,
     /* 256116 */     // GIR_Coverage, 12000,
     /* 256116 */     GIR_EraseRootFromParent_Done,
     /* 256117 */   // Label 4960: @256117
     /* 256117 */   GIM_Try, /*On fail goto*//*Label 4961*/ GIMT_Encode4(256159), // Rule ID 12124 //
     /* 256122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 256125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 256130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 256133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 256136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 256139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 256142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256146 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1953:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UCLAMP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 256146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_B),
     /* 256149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256155 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256157 */     GIR_RootConstrainSelectedInstOperands,
     /* 256158 */     // GIR_Coverage, 12124,
     /* 256158 */     GIR_EraseRootFromParent_Done,
     /* 256159 */   // Label 4961: @256159
     /* 256159 */   GIM_Try, /*On fail goto*//*Label 4962*/ GIMT_Encode4(256201), // Rule ID 12126 //
     /* 256164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 256167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 256172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 256175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 256178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 256181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 256184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256188 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1953:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UCLAMP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 256188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_H),
     /* 256191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256195 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256197 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256199 */     GIR_RootConstrainSelectedInstOperands,
     /* 256200 */     // GIR_Coverage, 12126,
     /* 256200 */     GIR_EraseRootFromParent_Done,
     /* 256201 */   // Label 4962: @256201
     /* 256201 */   GIM_Try, /*On fail goto*//*Label 4963*/ GIMT_Encode4(256243), // Rule ID 12128 //
     /* 256206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 256209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 256214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 256220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 256226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256230 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1953:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCLAMP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 256230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_S),
     /* 256233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256237 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256239 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256241 */     GIR_RootConstrainSelectedInstOperands,
     /* 256242 */     // GIR_Coverage, 12128,
     /* 256242 */     GIR_EraseRootFromParent_Done,
     /* 256243 */   // Label 4963: @256243
     /* 256243 */   GIM_Try, /*On fail goto*//*Label 4964*/ GIMT_Encode4(256285), // Rule ID 12130 //
     /* 256248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 256251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 256256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 256259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 256262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 256268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256272 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1953:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCLAMP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 256272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_D),
     /* 256275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256281 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256283 */     GIR_RootConstrainSelectedInstOperands,
     /* 256284 */     // GIR_Coverage, 12130,
     /* 256284 */     GIR_EraseRootFromParent_Done,
     /* 256285 */   // Label 4964: @256285
     /* 256285 */   GIM_Try, /*On fail goto*//*Label 4965*/ GIMT_Encode4(256327), // Rule ID 12132 //
     /* 256290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 256293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdot_x2),
     /* 256298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 256304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 256307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 256310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256314 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1431:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDOT_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 256314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_S),
     /* 256317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256323 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256325 */     GIR_RootConstrainSelectedInstOperands,
     /* 256326 */     // GIR_Coverage, 12132,
     /* 256326 */     GIR_EraseRootFromParent_Done,
     /* 256327 */   // Label 4965: @256327
     /* 256327 */   GIM_Try, /*On fail goto*//*Label 4966*/ GIMT_Encode4(256369), // Rule ID 12134 //
     /* 256332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 256335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_x2),
     /* 256340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 256346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 256349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 256352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256356 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1969:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UDOT_ZZZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 256356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_HtoS),
     /* 256359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256365 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256367 */     GIR_RootConstrainSelectedInstOperands,
     /* 256368 */     // GIR_Coverage, 12134,
     /* 256368 */     GIR_EraseRootFromParent_Done,
     /* 256369 */   // Label 4966: @256369
     /* 256369 */   GIM_Try, /*On fail goto*//*Label 4967*/ GIMT_Encode4(256411), // Rule ID 12297 //
     /* 256374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 256377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 256382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 256385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 256388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 256391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 256394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256398 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1929:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (TBXQ_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 256398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_B),
     /* 256401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256407 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256409 */     GIR_RootConstrainSelectedInstOperands,
     /* 256410 */     // GIR_Coverage, 12297,
     /* 256410 */     GIR_EraseRootFromParent_Done,
     /* 256411 */   // Label 4967: @256411
     /* 256411 */   GIM_Try, /*On fail goto*//*Label 4968*/ GIMT_Encode4(256453), // Rule ID 12298 //
     /* 256416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 256419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 256424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 256427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 256430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 256433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 256436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256440 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1929:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBXQ_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 256440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_H),
     /* 256443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256447 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256449 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256451 */     GIR_RootConstrainSelectedInstOperands,
     /* 256452 */     // GIR_Coverage, 12298,
     /* 256452 */     GIR_EraseRootFromParent_Done,
     /* 256453 */   // Label 4968: @256453
     /* 256453 */   GIM_Try, /*On fail goto*//*Label 4969*/ GIMT_Encode4(256495), // Rule ID 12299 //
     /* 256458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 256461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 256466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 256472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 256478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256482 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1929:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBXQ_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 256482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_S),
     /* 256485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256491 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256493 */     GIR_RootConstrainSelectedInstOperands,
     /* 256494 */     // GIR_Coverage, 12299,
     /* 256494 */     GIR_EraseRootFromParent_Done,
     /* 256495 */   // Label 4969: @256495
     /* 256495 */   GIM_Try, /*On fail goto*//*Label 4970*/ GIMT_Encode4(256537), // Rule ID 12300 //
     /* 256500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 256503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 256508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 256511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 256514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 256520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256524 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1929:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBXQ_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 256524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_D),
     /* 256527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256531 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256533 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256535 */     GIR_RootConstrainSelectedInstOperands,
     /* 256536 */     // GIR_Coverage, 12300,
     /* 256536 */     GIR_EraseRootFromParent_Done,
     /* 256537 */   // Label 4970: @256537
     /* 256537 */   GIM_Try, /*On fail goto*//*Label 4971*/ GIMT_Encode4(256579), // Rule ID 12301 //
     /* 256542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 256545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 256550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 256553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 256556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 256559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 256562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256566 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1929:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBXQ_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 256566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_H),
     /* 256569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256575 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256577 */     GIR_RootConstrainSelectedInstOperands,
     /* 256578 */     // GIR_Coverage, 12301,
     /* 256578 */     GIR_EraseRootFromParent_Done,
     /* 256579 */   // Label 4971: @256579
     /* 256579 */   GIM_Try, /*On fail goto*//*Label 4972*/ GIMT_Encode4(256621), // Rule ID 12302 //
     /* 256584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 256587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 256592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 256598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 256604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256608 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1929:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBXQ_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 256608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_S),
     /* 256611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256615 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256617 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256619 */     GIR_RootConstrainSelectedInstOperands,
     /* 256620 */     // GIR_Coverage, 12302,
     /* 256620 */     GIR_EraseRootFromParent_Done,
     /* 256621 */   // Label 4972: @256621
     /* 256621 */   GIM_Try, /*On fail goto*//*Label 4973*/ GIMT_Encode4(256663), // Rule ID 12303 //
     /* 256626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 256629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 256634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 256637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 256640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 256646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256650 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1929:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBXQ_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 256650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_D),
     /* 256653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256659 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256661 */     GIR_RootConstrainSelectedInstOperands,
     /* 256662 */     // GIR_Coverage, 12303,
     /* 256662 */     GIR_EraseRootFromParent_Done,
     /* 256663 */   // Label 4973: @256663
     /* 256663 */   GIM_Try, /*On fail goto*//*Label 4974*/ GIMT_Encode4(256705), // Rule ID 12648 //
     /* 256668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 256671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 256676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 256679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 256682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 256685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 256688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256692 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1381:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMIN_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 256692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_H),
     /* 256695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 256697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256701 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256703 */     GIR_RootConstrainSelectedInstOperands,
     /* 256704 */     // GIR_Coverage, 12648,
     /* 256704 */     GIR_EraseRootFromParent_Done,
     /* 256705 */   // Label 4974: @256705
     /* 256705 */   GIM_Try, /*On fail goto*//*Label 4975*/ GIMT_Encode4(256747), // Rule ID 12649 //
     /* 256710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 256713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 256718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 256724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 256730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256734 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1381:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMIN_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 256734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_S),
     /* 256737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 256739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256741 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256743 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256745 */     GIR_RootConstrainSelectedInstOperands,
     /* 256746 */     // GIR_Coverage, 12649,
     /* 256746 */     GIR_EraseRootFromParent_Done,
     /* 256747 */   // Label 4975: @256747
     /* 256747 */   GIM_Try, /*On fail goto*//*Label 4976*/ GIMT_Encode4(256789), // Rule ID 12650 //
     /* 256752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 256755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 256760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 256763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 256766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 256772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256776 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1381:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMIN_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 256776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_D),
     /* 256779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 256781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256785 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256787 */     GIR_RootConstrainSelectedInstOperands,
     /* 256788 */     // GIR_Coverage, 12650,
     /* 256788 */     GIR_EraseRootFromParent_Done,
     /* 256789 */   // Label 4976: @256789
     /* 256789 */   GIM_Try, /*On fail goto*//*Label 4977*/ GIMT_Encode4(256831), // Rule ID 12651 //
     /* 256794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 256797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 256802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 256805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 256808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 256811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 256814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256818 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1379:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMAX_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 256818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_H),
     /* 256821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 256823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256827 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256829 */     GIR_RootConstrainSelectedInstOperands,
     /* 256830 */     // GIR_Coverage, 12651,
     /* 256830 */     GIR_EraseRootFromParent_Done,
     /* 256831 */   // Label 4977: @256831
     /* 256831 */   GIM_Try, /*On fail goto*//*Label 4978*/ GIMT_Encode4(256873), // Rule ID 12652 //
     /* 256836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 256839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 256844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 256850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 256856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256860 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1379:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMAX_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 256860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_S),
     /* 256863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 256865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256869 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256871 */     GIR_RootConstrainSelectedInstOperands,
     /* 256872 */     // GIR_Coverage, 12652,
     /* 256872 */     GIR_EraseRootFromParent_Done,
     /* 256873 */   // Label 4978: @256873
     /* 256873 */   GIM_Try, /*On fail goto*//*Label 4979*/ GIMT_Encode4(256915), // Rule ID 12653 //
     /* 256878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 256881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 256886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 256889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 256892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 256898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256902 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1379:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMAX_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 256902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_D),
     /* 256905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 256907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256911 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256913 */     GIR_RootConstrainSelectedInstOperands,
     /* 256914 */     // GIR_Coverage, 12653,
     /* 256914 */     GIR_EraseRootFromParent_Done,
     /* 256915 */   // Label 4979: @256915
     /* 256915 */   GIM_Try, /*On fail goto*//*Label 4980*/ GIMT_Encode4(256957), // Rule ID 12654 //
     /* 256920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 256923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 256928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 256931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 256934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 256937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 256940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256944 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1380:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 256944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 256947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256953 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256955 */     GIR_RootConstrainSelectedInstOperands,
     /* 256956 */     // GIR_Coverage, 12654,
     /* 256956 */     GIR_EraseRootFromParent_Done,
     /* 256957 */   // Label 4980: @256957
     /* 256957 */   GIM_Try, /*On fail goto*//*Label 4981*/ GIMT_Encode4(256999), // Rule ID 12657 //
     /* 256962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 256965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 256970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 256973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 256976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 256979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 256982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256986 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1380:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 256986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 256989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256993 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256995 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256997 */     GIR_RootConstrainSelectedInstOperands,
     /* 256998 */     // GIR_Coverage, 12657,
     /* 256998 */     GIR_EraseRootFromParent_Done,
     /* 256999 */   // Label 4981: @256999
     /* 256999 */   GIM_Try, /*On fail goto*//*Label 4982*/ GIMT_Encode4(257041), // Rule ID 12660 //
     /* 257004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 257007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 257012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 257015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 257018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 257021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 257024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257028 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1380:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 257028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 257031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257037 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257039 */     GIR_RootConstrainSelectedInstOperands,
     /* 257040 */     // GIR_Coverage, 12660,
     /* 257040 */     GIR_EraseRootFromParent_Done,
     /* 257041 */   // Label 4982: @257041
     /* 257041 */   GIM_Try, /*On fail goto*//*Label 4983*/ GIMT_Encode4(257083), // Rule ID 12663 //
     /* 257046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 257049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 257054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 257057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 257060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 257063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 257066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257070 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1380:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMAX_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 257070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_S_UNDEF),
     /* 257073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257079 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257081 */     GIR_RootConstrainSelectedInstOperands,
     /* 257082 */     // GIR_Coverage, 12663,
     /* 257082 */     GIR_EraseRootFromParent_Done,
     /* 257083 */   // Label 4983: @257083
     /* 257083 */   GIM_Try, /*On fail goto*//*Label 4984*/ GIMT_Encode4(257125), // Rule ID 12666 //
     /* 257088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 257091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 257096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 257099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 257102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 257105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 257108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257112 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1380:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FAMAX_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 257112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_S_UNDEF),
     /* 257115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257119 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257121 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257123 */     GIR_RootConstrainSelectedInstOperands,
     /* 257124 */     // GIR_Coverage, 12666,
     /* 257124 */     GIR_EraseRootFromParent_Done,
     /* 257125 */   // Label 4984: @257125
     /* 257125 */   GIM_Try, /*On fail goto*//*Label 4985*/ GIMT_Encode4(257167), // Rule ID 12669 //
     /* 257130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 257133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 257138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 257141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 257144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 257147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 257150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257154 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1380:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMAX_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 257154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_D_UNDEF),
     /* 257157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257163 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257165 */     GIR_RootConstrainSelectedInstOperands,
     /* 257166 */     // GIR_Coverage, 12669,
     /* 257166 */     GIR_EraseRootFromParent_Done,
     /* 257167 */   // Label 4985: @257167
     /* 257167 */   GIM_Try, /*On fail goto*//*Label 4986*/ GIMT_Encode4(257209), // Rule ID 12672 //
     /* 257172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 257175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 257180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 257183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 257186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 257189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 257192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257196 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1382:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 257196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 257199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257205 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257207 */     GIR_RootConstrainSelectedInstOperands,
     /* 257208 */     // GIR_Coverage, 12672,
     /* 257208 */     GIR_EraseRootFromParent_Done,
     /* 257209 */   // Label 4986: @257209
     /* 257209 */   GIM_Try, /*On fail goto*//*Label 4987*/ GIMT_Encode4(257251), // Rule ID 12675 //
     /* 257214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 257217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 257222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 257225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 257228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 257231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 257234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257238 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1382:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 257238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 257241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257247 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257249 */     GIR_RootConstrainSelectedInstOperands,
     /* 257250 */     // GIR_Coverage, 12675,
     /* 257250 */     GIR_EraseRootFromParent_Done,
     /* 257251 */   // Label 4987: @257251
     /* 257251 */   GIM_Try, /*On fail goto*//*Label 4988*/ GIMT_Encode4(257293), // Rule ID 12678 //
     /* 257256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 257259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 257264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 257267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 257270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 257273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 257276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257280 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1382:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 257280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 257283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257287 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257289 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257291 */     GIR_RootConstrainSelectedInstOperands,
     /* 257292 */     // GIR_Coverage, 12678,
     /* 257292 */     GIR_EraseRootFromParent_Done,
     /* 257293 */   // Label 4988: @257293
     /* 257293 */   GIM_Try, /*On fail goto*//*Label 4989*/ GIMT_Encode4(257335), // Rule ID 12681 //
     /* 257298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 257301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 257306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 257309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 257312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 257315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 257318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257322 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1382:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMIN_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 257322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_S_UNDEF),
     /* 257325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257331 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257333 */     GIR_RootConstrainSelectedInstOperands,
     /* 257334 */     // GIR_Coverage, 12681,
     /* 257334 */     GIR_EraseRootFromParent_Done,
     /* 257335 */   // Label 4989: @257335
     /* 257335 */   GIM_Try, /*On fail goto*//*Label 4990*/ GIMT_Encode4(257377), // Rule ID 12684 //
     /* 257340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 257343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 257348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 257351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 257354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 257357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 257360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257364 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1382:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FAMIN_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 257364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_S_UNDEF),
     /* 257367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257371 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257373 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257375 */     GIR_RootConstrainSelectedInstOperands,
     /* 257376 */     // GIR_Coverage, 12684,
     /* 257376 */     GIR_EraseRootFromParent_Done,
     /* 257377 */   // Label 4990: @257377
     /* 257377 */   GIM_Try, /*On fail goto*//*Label 4991*/ GIMT_Encode4(257419), // Rule ID 12687 //
     /* 257382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 257385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 257390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 257393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 257396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 257399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 257402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257406 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1382:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMIN_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 257406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_D_UNDEF),
     /* 257409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257413 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257415 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257417 */     GIR_RootConstrainSelectedInstOperands,
     /* 257418 */     // GIR_Coverage, 12687,
     /* 257418 */     GIR_EraseRootFromParent_Done,
     /* 257419 */   // Label 4991: @257419
     /* 257419 */   GIM_Try, /*On fail goto*//*Label 4992*/ GIMT_Encode4(257562), // Rule ID 5628 //
     /* 257424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 257427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 257432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 257435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 257438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 257441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257445 */     // MIs[0] idx
     /* 257445 */     // No operand predicates
     /* 257445 */     // (intrinsic_wo_chain:{ *:[v16i8] } 778:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 257445 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 257448 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 257452 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257457 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 257459 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 257462 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 257466 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257471 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 257474 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 257478 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 257481 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257486 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257491 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257496 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 257499 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 257503 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 257510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 257513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 257517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257522 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 257525 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 257529 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 257532 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257537 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257542 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 257550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 257555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 257558 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 257560 */     GIR_RootConstrainSelectedInstOperands,
     /* 257561 */     // GIR_Coverage, 5628,
     /* 257561 */     GIR_EraseRootFromParent_Done,
     /* 257562 */   // Label 4992: @257562
     /* 257562 */   GIM_Try, /*On fail goto*//*Label 4993*/ GIMT_Encode4(257653), // Rule ID 5629 //
     /* 257567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 257570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 257575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 257578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 257581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 257584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257588 */     // MIs[0] idx
     /* 257588 */     // No operand predicates
     /* 257588 */     // (intrinsic_wo_chain:{ *:[v16i8] } 779:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 257588 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 257591 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 257595 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 257602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 257605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 257609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257614 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 257617 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 257621 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 257624 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257629 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257634 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 257642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257644 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 257647 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 257649 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 257651 */     GIR_RootConstrainSelectedInstOperands,
     /* 257652 */     // GIR_Coverage, 5629,
     /* 257652 */     GIR_EraseRootFromParent_Done,
     /* 257653 */   // Label 4993: @257653
     /* 257653 */   GIM_Try, /*On fail goto*//*Label 4994*/ GIMT_Encode4(257744), // Rule ID 5630 //
     /* 257658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 257661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 257666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 257669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 257672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 257675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257679 */     // MIs[0] idx
     /* 257679 */     // No operand predicates
     /* 257679 */     // (intrinsic_wo_chain:{ *:[v16i8] } 778:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 257679 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 257682 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 257686 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257691 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 257693 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 257696 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 257700 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257705 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 257708 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 257712 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 257715 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257720 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257725 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 257733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 257737 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 257740 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 257742 */     GIR_RootConstrainSelectedInstOperands,
     /* 257743 */     // GIR_Coverage, 5630,
     /* 257743 */     GIR_EraseRootFromParent_Done,
     /* 257744 */   // Label 4994: @257744
     /* 257744 */   GIM_Try, /*On fail goto*//*Label 4995*/ GIMT_Encode4(257783), // Rule ID 5631 //
     /* 257749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 257752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 257757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 257760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 257763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 257766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257770 */     // MIs[0] idx
     /* 257770 */     // No operand predicates
     /* 257770 */     // (intrinsic_wo_chain:{ *:[v16i8] } 779:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 257770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 257773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 257777 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 257779 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 257781 */     GIR_RootConstrainSelectedInstOperands,
     /* 257782 */     // GIR_Coverage, 5631,
     /* 257782 */     GIR_EraseRootFromParent_Done,
     /* 257783 */   // Label 4995: @257783
     /* 257783 */   GIM_Try, /*On fail goto*//*Label 4996*/ GIMT_Encode4(257926), // Rule ID 5632 //
     /* 257788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 257791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 257796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 257799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 257802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 257805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257809 */     // MIs[0] idx
     /* 257809 */     // No operand predicates
     /* 257809 */     // (intrinsic_wo_chain:{ *:[v8i16] } 778:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 257809 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 257812 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 257816 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 257823 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 257826 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 257830 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257835 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 257838 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 257842 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 257845 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257850 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257855 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257860 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 257863 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 257867 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257872 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 257874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 257877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 257881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257886 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 257889 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 257893 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 257896 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257901 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257906 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 257914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 257919 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 257922 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 257924 */     GIR_RootConstrainSelectedInstOperands,
     /* 257925 */     // GIR_Coverage, 5632,
     /* 257925 */     GIR_EraseRootFromParent_Done,
     /* 257926 */   // Label 4996: @257926
     /* 257926 */   GIM_Try, /*On fail goto*//*Label 4997*/ GIMT_Encode4(258017), // Rule ID 5633 //
     /* 257931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 257934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 257939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 257942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 257945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 257948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257952 */     // MIs[0] idx
     /* 257952 */     // No operand predicates
     /* 257952 */     // (intrinsic_wo_chain:{ *:[v8i16] } 779:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 257952 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 257955 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 257959 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 257966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 257969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 257973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257978 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 257981 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 257985 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 257988 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257993 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257998 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 258003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 258006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258008 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 258013 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 258015 */     GIR_RootConstrainSelectedInstOperands,
     /* 258016 */     // GIR_Coverage, 5633,
     /* 258016 */     GIR_EraseRootFromParent_Done,
     /* 258017 */   // Label 4997: @258017
     /* 258017 */   GIM_Try, /*On fail goto*//*Label 4998*/ GIMT_Encode4(258108), // Rule ID 5634 //
     /* 258022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 258025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 258030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 258033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 258036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 258039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258043 */     // MIs[0] idx
     /* 258043 */     // No operand predicates
     /* 258043 */     // (intrinsic_wo_chain:{ *:[v8i16] } 778:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 258043 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 258046 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 258050 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258055 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 258057 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 258060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 258064 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258069 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 258072 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 258076 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 258079 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258084 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258089 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 258094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 258097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258101 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258104 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 258106 */     GIR_RootConstrainSelectedInstOperands,
     /* 258107 */     // GIR_Coverage, 5634,
     /* 258107 */     GIR_EraseRootFromParent_Done,
     /* 258108 */   // Label 4998: @258108
     /* 258108 */   GIM_Try, /*On fail goto*//*Label 4999*/ GIMT_Encode4(258147), // Rule ID 5635 //
     /* 258113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 258116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 258121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 258124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 258127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 258130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258134 */     // MIs[0] idx
     /* 258134 */     // No operand predicates
     /* 258134 */     // (intrinsic_wo_chain:{ *:[v8i16] } 779:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 258134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 258137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 258143 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 258145 */     GIR_RootConstrainSelectedInstOperands,
     /* 258146 */     // GIR_Coverage, 5635,
     /* 258146 */     GIR_EraseRootFromParent_Done,
     /* 258147 */   // Label 4999: @258147
     /* 258147 */   GIM_Try, /*On fail goto*//*Label 5000*/ GIMT_Encode4(258290), // Rule ID 5636 //
     /* 258152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 258155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 258160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 258163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 258166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 258169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258173 */     // MIs[0] idx
     /* 258173 */     // No operand predicates
     /* 258173 */     // (intrinsic_wo_chain:{ *:[v8f16] } 778:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 258173 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 258176 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 258180 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 258187 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 258190 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 258194 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258199 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 258202 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 258206 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 258209 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258214 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258219 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 258224 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 258227 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 258231 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 258238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 258241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 258245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258250 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 258253 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 258257 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 258260 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258265 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258270 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 258275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 258278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 258286 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 258288 */     GIR_RootConstrainSelectedInstOperands,
     /* 258289 */     // GIR_Coverage, 5636,
     /* 258289 */     GIR_EraseRootFromParent_Done,
     /* 258290 */   // Label 5000: @258290
     /* 258290 */   GIM_Try, /*On fail goto*//*Label 5001*/ GIMT_Encode4(258381), // Rule ID 5637 //
     /* 258295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 258298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 258303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 258306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 258309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 258312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258316 */     // MIs[0] idx
     /* 258316 */     // No operand predicates
     /* 258316 */     // (intrinsic_wo_chain:{ *:[v8f16] } 779:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 258316 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 258319 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 258323 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258328 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 258330 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 258333 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 258337 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258342 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 258345 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 258349 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 258352 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258357 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258362 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 258367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 258370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 258377 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 258379 */     GIR_RootConstrainSelectedInstOperands,
     /* 258380 */     // GIR_Coverage, 5637,
     /* 258380 */     GIR_EraseRootFromParent_Done,
     /* 258381 */   // Label 5001: @258381
     /* 258381 */   GIM_Try, /*On fail goto*//*Label 5002*/ GIMT_Encode4(258472), // Rule ID 5638 //
     /* 258386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 258389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 258394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 258397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 258400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 258403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258407 */     // MIs[0] idx
     /* 258407 */     // No operand predicates
     /* 258407 */     // (intrinsic_wo_chain:{ *:[v8f16] } 778:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 258407 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 258410 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 258414 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 258421 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 258424 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 258428 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258433 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 258436 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 258440 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 258443 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258448 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258453 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 258458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 258461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258465 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258468 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 258470 */     GIR_RootConstrainSelectedInstOperands,
     /* 258471 */     // GIR_Coverage, 5638,
     /* 258471 */     GIR_EraseRootFromParent_Done,
     /* 258472 */   // Label 5002: @258472
     /* 258472 */   GIM_Try, /*On fail goto*//*Label 5003*/ GIMT_Encode4(258511), // Rule ID 5639 //
     /* 258477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 258480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 258485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 258488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 258491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 258494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258498 */     // MIs[0] idx
     /* 258498 */     // No operand predicates
     /* 258498 */     // (intrinsic_wo_chain:{ *:[v8f16] } 779:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 258498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 258501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258505 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 258507 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 258509 */     GIR_RootConstrainSelectedInstOperands,
     /* 258510 */     // GIR_Coverage, 5639,
     /* 258510 */     GIR_EraseRootFromParent_Done,
     /* 258511 */   // Label 5003: @258511
     /* 258511 */   GIM_Try, /*On fail goto*//*Label 5004*/ GIMT_Encode4(258550), // Rule ID 5640 //
     /* 258516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 258519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti4q_laneq),
     /* 258524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 258527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 258530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 258533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258537 */     // MIs[0] idx
     /* 258537 */     // No operand predicates
     /* 258537 */     // (intrinsic_wo_chain:{ *:[v16i8] } 782:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT4_B:{ *:[v16i8] } VecListOne16b:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 258537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT4_B),
     /* 258540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 258546 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 258548 */     GIR_RootConstrainSelectedInstOperands,
     /* 258549 */     // GIR_Coverage, 5640,
     /* 258549 */     GIR_EraseRootFromParent_Done,
     /* 258550 */   // Label 5004: @258550
     /* 258550 */   GIM_Try, /*On fail goto*//*Label 5005*/ GIMT_Encode4(258641), // Rule ID 5641 //
     /* 258555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 258558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti4q_lane),
     /* 258563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 258566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 258569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 258572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258576 */     // MIs[0] idx
     /* 258576 */     // No operand predicates
     /* 258576 */     // (intrinsic_wo_chain:{ *:[v16i8] } 780:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT4_B:{ *:[v16i8] } VecListOne16b:{ *:[v16i8] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 258576 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 258579 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 258583 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 258590 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 258593 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 258597 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258602 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 258605 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 258609 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 258612 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258617 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258622 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 258627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT4_B),
     /* 258630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258634 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258637 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 258639 */     GIR_RootConstrainSelectedInstOperands,
     /* 258640 */     // GIR_Coverage, 5641,
     /* 258640 */     GIR_EraseRootFromParent_Done,
     /* 258641 */   // Label 5005: @258641
     /* 258641 */   GIM_Reject,
     /* 258642 */ // Label 4145: @258642
     /* 258642 */ GIM_Try, /*On fail goto*//*Label 5006*/ GIMT_Encode4(265753),
     /* 258647 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 258650 */   GIM_Try, /*On fail goto*//*Label 5007*/ GIMT_Encode4(258697), // Rule ID 2976 //
     /* 258655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 258663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 258666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 258669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 258672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 258675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 258678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258682 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1613:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLA_ZPZZZ_B_UNDEF:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 258682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_B_UNDEF),
     /* 258685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258689 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258691 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258693 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 258695 */     GIR_RootConstrainSelectedInstOperands,
     /* 258696 */     // GIR_Coverage, 2976,
     /* 258696 */     GIR_EraseRootFromParent_Done,
     /* 258697 */   // Label 5007: @258697
     /* 258697 */   GIM_Try, /*On fail goto*//*Label 5008*/ GIMT_Encode4(258744), // Rule ID 2978 //
     /* 258702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 258710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 258713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 258716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 258719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 258725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258729 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1613:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLA_ZPZZZ_H_UNDEF:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 258729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_H_UNDEF),
     /* 258732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258736 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258738 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258740 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 258742 */     GIR_RootConstrainSelectedInstOperands,
     /* 258743 */     // GIR_Coverage, 2978,
     /* 258743 */     GIR_EraseRootFromParent_Done,
     /* 258744 */   // Label 5008: @258744
     /* 258744 */   GIM_Try, /*On fail goto*//*Label 5009*/ GIMT_Encode4(258791), // Rule ID 2980 //
     /* 258749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 258757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 258760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 258763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 258766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 258769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 258772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258776 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1613:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLA_ZPZZZ_S_UNDEF:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 258776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_S_UNDEF),
     /* 258779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258785 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258787 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 258789 */     GIR_RootConstrainSelectedInstOperands,
     /* 258790 */     // GIR_Coverage, 2980,
     /* 258790 */     GIR_EraseRootFromParent_Done,
     /* 258791 */   // Label 5009: @258791
     /* 258791 */   GIM_Try, /*On fail goto*//*Label 5010*/ GIMT_Encode4(258838), // Rule ID 2982 //
     /* 258796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 258804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 258807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 258810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 258813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 258816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 258819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258823 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1613:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLA_ZPZZZ_D_UNDEF:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 258823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_D_UNDEF),
     /* 258826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258832 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258834 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 258836 */     GIR_RootConstrainSelectedInstOperands,
     /* 258837 */     // GIR_Coverage, 2982,
     /* 258837 */     GIR_EraseRootFromParent_Done,
     /* 258838 */   // Label 5010: @258838
     /* 258838 */   GIM_Try, /*On fail goto*//*Label 5011*/ GIMT_Encode4(258885), // Rule ID 7674 //
     /* 258843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 258851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 258854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 258857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 258860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 258863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 258866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258870 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1616:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLS_ZPZZZ_B_UNDEF:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 258870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_B_UNDEF),
     /* 258873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258879 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258881 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 258883 */     GIR_RootConstrainSelectedInstOperands,
     /* 258884 */     // GIR_Coverage, 7674,
     /* 258884 */     GIR_EraseRootFromParent_Done,
     /* 258885 */   // Label 5011: @258885
     /* 258885 */   GIM_Try, /*On fail goto*//*Label 5012*/ GIMT_Encode4(258932), // Rule ID 7676 //
     /* 258890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 258898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 258901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 258904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 258907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 258913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258917 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1616:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLS_ZPZZZ_H_UNDEF:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 258917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_H_UNDEF),
     /* 258920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258926 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258928 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 258930 */     GIR_RootConstrainSelectedInstOperands,
     /* 258931 */     // GIR_Coverage, 7676,
     /* 258931 */     GIR_EraseRootFromParent_Done,
     /* 258932 */   // Label 5012: @258932
     /* 258932 */   GIM_Try, /*On fail goto*//*Label 5013*/ GIMT_Encode4(258979), // Rule ID 7678 //
     /* 258937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 258945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 258948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 258951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 258954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 258957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 258960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258964 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1616:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLS_ZPZZZ_S_UNDEF:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 258964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_S_UNDEF),
     /* 258967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258973 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258975 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 258977 */     GIR_RootConstrainSelectedInstOperands,
     /* 258978 */     // GIR_Coverage, 7678,
     /* 258978 */     GIR_EraseRootFromParent_Done,
     /* 258979 */   // Label 5013: @258979
     /* 258979 */   GIM_Try, /*On fail goto*//*Label 5014*/ GIMT_Encode4(259026), // Rule ID 7680 //
     /* 258984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 258992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 258995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 258998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 259001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 259004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 259007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259011 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1616:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLS_ZPZZZ_D_UNDEF:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 259011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_D_UNDEF),
     /* 259014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 259016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259020 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259022 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259024 */     GIR_RootConstrainSelectedInstOperands,
     /* 259025 */     // GIR_Coverage, 7680,
     /* 259025 */     GIR_EraseRootFromParent_Done,
     /* 259026 */   // Label 5014: @259026
     /* 259026 */   GIM_Try, /*On fail goto*//*Label 5015*/ GIMT_Encode4(259106), // Rule ID 5750 //
     /* 259031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 259036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 259039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 259042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 259045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 259048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 259051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 259063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 259067 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 259071 */     // MIs[1] Operand 1
     /* 259071 */     // No operand predicates
     /* 259071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 259079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 259083 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 259087 */     // MIs[2] Operand 1
     /* 259087 */     // No operand predicates
     /* 259087 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 259089 */     // (intrinsic_wo_chain:{ *:[v16i8] } 771:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, V128:{ *:[v16i8] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, V128:{ *:[v16i8] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2)
     /* 259089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 259092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 259096 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 259099 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 259101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 259104 */     GIR_RootConstrainSelectedInstOperands,
     /* 259105 */     // GIR_Coverage, 5750,
     /* 259105 */     GIR_EraseRootFromParent_Done,
     /* 259106 */   // Label 5015: @259106
     /* 259106 */   GIM_Try, /*On fail goto*//*Label 5016*/ GIMT_Encode4(259186), // Rule ID 5751 //
     /* 259111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 259116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 259119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 259122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 259125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 259128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 259131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 259143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 259147 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 259151 */     // MIs[1] Operand 1
     /* 259151 */     // No operand predicates
     /* 259151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 259159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 259163 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 259167 */     // MIs[2] Operand 1
     /* 259167 */     // No operand predicates
     /* 259167 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 259169 */     // (intrinsic_wo_chain:{ *:[v8i16] } 771:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, V128:{ *:[v8i16] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, V128:{ *:[v8i16] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2)
     /* 259169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 259172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 259176 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 259179 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 259181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 259184 */     GIR_RootConstrainSelectedInstOperands,
     /* 259185 */     // GIR_Coverage, 5751,
     /* 259185 */     GIR_EraseRootFromParent_Done,
     /* 259186 */   // Label 5016: @259186
     /* 259186 */   GIM_Try, /*On fail goto*//*Label 5017*/ GIMT_Encode4(259266), // Rule ID 5752 //
     /* 259191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 259196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 259199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 259202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 259205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 259208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 259211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 259223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 259227 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 259231 */     // MIs[1] Operand 1
     /* 259231 */     // No operand predicates
     /* 259231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 259239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 259243 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 259247 */     // MIs[2] Operand 1
     /* 259247 */     // No operand predicates
     /* 259247 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 259249 */     // (intrinsic_wo_chain:{ *:[v4i32] } 771:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, V128:{ *:[v4i32] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, V128:{ *:[v4i32] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2)
     /* 259249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 259252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 259256 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 259259 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 259261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 259264 */     GIR_RootConstrainSelectedInstOperands,
     /* 259265 */     // GIR_Coverage, 5752,
     /* 259265 */     GIR_EraseRootFromParent_Done,
     /* 259266 */   // Label 5017: @259266
     /* 259266 */   GIM_Try, /*On fail goto*//*Label 5018*/ GIMT_Encode4(259346), // Rule ID 5753 //
     /* 259271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 259276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 259279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 259282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 259285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 259288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 259291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 259303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 259307 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 259311 */     // MIs[1] Operand 1
     /* 259311 */     // No operand predicates
     /* 259311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 259319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 259323 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 259327 */     // MIs[2] Operand 1
     /* 259327 */     // No operand predicates
     /* 259327 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 259329 */     // (intrinsic_wo_chain:{ *:[v2i64] } 771:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, V128:{ *:[v2i64] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, V128:{ *:[v2i64] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2)
     /* 259329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 259332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 259336 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 259339 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 259341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 259344 */     GIR_RootConstrainSelectedInstOperands,
     /* 259345 */     // GIR_Coverage, 5753,
     /* 259345 */     GIR_EraseRootFromParent_Done,
     /* 259346 */   // Label 5018: @259346
     /* 259346 */   GIM_Try, /*On fail goto*//*Label 5019*/ GIMT_Encode4(259410), // Rule ID 3874 //
     /* 259351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 259354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt1a),
     /* 259359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 259362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 259365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 259368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 259371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259387 */     // MIs[0] imm
     /* 259387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259390 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 259395 */     // (intrinsic_wo_chain:{ *:[v4i32] } 547:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT1A:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 259395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT1A),
     /* 259398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 259400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 259402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 259404 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 259406 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 259408 */     GIR_RootConstrainSelectedInstOperands,
     /* 259409 */     // GIR_Coverage, 3874,
     /* 259409 */     GIR_EraseRootFromParent_Done,
     /* 259410 */   // Label 5019: @259410
     /* 259410 */   GIM_Try, /*On fail goto*//*Label 5020*/ GIMT_Encode4(259474), // Rule ID 3875 //
     /* 259415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 259418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt1b),
     /* 259423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 259426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 259429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 259432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 259435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259451 */     // MIs[0] imm
     /* 259451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259454 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 259459 */     // (intrinsic_wo_chain:{ *:[v4i32] } 548:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT1B:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 259459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT1B),
     /* 259462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 259464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 259466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 259468 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 259470 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 259472 */     GIR_RootConstrainSelectedInstOperands,
     /* 259473 */     // GIR_Coverage, 3875,
     /* 259473 */     GIR_EraseRootFromParent_Done,
     /* 259474 */   // Label 5020: @259474
     /* 259474 */   GIM_Try, /*On fail goto*//*Label 5021*/ GIMT_Encode4(259538), // Rule ID 3876 //
     /* 259479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 259482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt2a),
     /* 259487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 259490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 259493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 259496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 259499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259515 */     // MIs[0] imm
     /* 259515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259518 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 259523 */     // (intrinsic_wo_chain:{ *:[v4i32] } 549:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT2A:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 259523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT2A),
     /* 259526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 259528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 259530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 259532 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 259534 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 259536 */     GIR_RootConstrainSelectedInstOperands,
     /* 259537 */     // GIR_Coverage, 3876,
     /* 259537 */     GIR_EraseRootFromParent_Done,
     /* 259538 */   // Label 5021: @259538
     /* 259538 */   GIM_Try, /*On fail goto*//*Label 5022*/ GIMT_Encode4(259602), // Rule ID 3877 //
     /* 259543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 259546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt2b),
     /* 259551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 259554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 259557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 259560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 259563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259579 */     // MIs[0] imm
     /* 259579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259582 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 259587 */     // (intrinsic_wo_chain:{ *:[v4i32] } 550:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT2B:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 259587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT2B),
     /* 259590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 259592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 259594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 259596 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 259598 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 259600 */     GIR_RootConstrainSelectedInstOperands,
     /* 259601 */     // GIR_Coverage, 3877,
     /* 259601 */     GIR_EraseRootFromParent_Done,
     /* 259602 */   // Label 5022: @259602
     /* 259602 */   GIM_Try, /*On fail goto*//*Label 5023*/ GIMT_Encode4(259654), // Rule ID 2848 //
     /* 259607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 259610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 259615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 259618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 259621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 259624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259631 */     // MIs[0] idx
     /* 259631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259634 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 259639 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1472:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMLA_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 259639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_H),
     /* 259642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259648 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259650 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 259652 */     GIR_RootConstrainSelectedInstOperands,
     /* 259653 */     // GIR_Coverage, 2848,
     /* 259653 */     GIR_EraseRootFromParent_Done,
     /* 259654 */   // Label 5023: @259654
     /* 259654 */   GIM_Try, /*On fail goto*//*Label 5024*/ GIMT_Encode4(259706), // Rule ID 2851 //
     /* 259659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 259662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 259667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 259670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 259673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 259676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 259679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259683 */     // MIs[0] idx
     /* 259683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259686 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 259691 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1472:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMLA_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 259691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_S),
     /* 259694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259700 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259702 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 259704 */     GIR_RootConstrainSelectedInstOperands,
     /* 259705 */     // GIR_Coverage, 2851,
     /* 259705 */     GIR_EraseRootFromParent_Done,
     /* 259706 */   // Label 5024: @259706
     /* 259706 */   GIM_Try, /*On fail goto*//*Label 5025*/ GIMT_Encode4(259758), // Rule ID 2854 //
     /* 259711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 259714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 259719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 259722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 259725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 259728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 259731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259735 */     // MIs[0] idx
     /* 259735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259738 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 259743 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1472:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMLA_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 259743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_D),
     /* 259746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259752 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259754 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 259756 */     GIR_RootConstrainSelectedInstOperands,
     /* 259757 */     // GIR_Coverage, 2854,
     /* 259757 */     GIR_EraseRootFromParent_Done,
     /* 259758 */   // Label 5025: @259758
     /* 259758 */   GIM_Try, /*On fail goto*//*Label 5026*/ GIMT_Encode4(259810), // Rule ID 2991 //
     /* 259763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 259771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 259774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 259777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 259780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259787 */     // MIs[0] Op4
     /* 259787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259790 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 259795 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1612:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (MLA_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 259795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_H),
     /* 259798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259802 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259804 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259806 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259808 */     GIR_RootConstrainSelectedInstOperands,
     /* 259809 */     // GIR_Coverage, 2991,
     /* 259809 */     GIR_EraseRootFromParent_Done,
     /* 259810 */   // Label 5026: @259810
     /* 259810 */   GIM_Try, /*On fail goto*//*Label 5027*/ GIMT_Encode4(259862), // Rule ID 2992 //
     /* 259815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 259823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 259826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 259829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 259832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 259835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259839 */     // MIs[0] Op4
     /* 259839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259842 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 259847 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1612:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (MLA_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 259847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_S),
     /* 259850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259854 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259856 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259858 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259860 */     GIR_RootConstrainSelectedInstOperands,
     /* 259861 */     // GIR_Coverage, 2992,
     /* 259861 */     GIR_EraseRootFromParent_Done,
     /* 259862 */   // Label 5027: @259862
     /* 259862 */   GIM_Try, /*On fail goto*//*Label 5028*/ GIMT_Encode4(259914), // Rule ID 2993 //
     /* 259867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 259875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 259878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 259881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 259884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 259887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259891 */     // MIs[0] Op4
     /* 259891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259894 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 259899 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1612:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (MLA_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 259899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_D),
     /* 259902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259908 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259910 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259912 */     GIR_RootConstrainSelectedInstOperands,
     /* 259913 */     // GIR_Coverage, 2993,
     /* 259913 */     GIR_EraseRootFromParent_Done,
     /* 259914 */   // Label 5028: @259914
     /* 259914 */   GIM_Try, /*On fail goto*//*Label 5029*/ GIMT_Encode4(259966), // Rule ID 2994 //
     /* 259919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb_lane),
     /* 259927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 259930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 259933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 259936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259943 */     // MIs[0] Op4
     /* 259943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259946 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 259951 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1754:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 259951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZI_S),
     /* 259954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259958 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259960 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259962 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259964 */     GIR_RootConstrainSelectedInstOperands,
     /* 259965 */     // GIR_Coverage, 2994,
     /* 259965 */     GIR_EraseRootFromParent_Done,
     /* 259966 */   // Label 5029: @259966
     /* 259966 */   GIM_Try, /*On fail goto*//*Label 5030*/ GIMT_Encode4(260018), // Rule ID 2995 //
     /* 259971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb_lane),
     /* 259979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 259982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 259985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 259988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 259991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259995 */     // MIs[0] Op4
     /* 259995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259998 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260003 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1754:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 260003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZI_D),
     /* 260006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260012 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260014 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260016 */     GIR_RootConstrainSelectedInstOperands,
     /* 260017 */     // GIR_Coverage, 2995,
     /* 260017 */     GIR_EraseRootFromParent_Done,
     /* 260018 */   // Label 5030: @260018
     /* 260018 */   GIM_Try, /*On fail goto*//*Label 5031*/ GIMT_Encode4(260070), // Rule ID 2998 //
     /* 260023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 260026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane),
     /* 260031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260047 */     // MIs[0] Op4
     /* 260047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260050 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260055 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1720:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SDOT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 260055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_S),
     /* 260058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260064 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260066 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260068 */     GIR_RootConstrainSelectedInstOperands,
     /* 260069 */     // GIR_Coverage, 2998,
     /* 260069 */     GIR_EraseRootFromParent_Done,
     /* 260070 */   // Label 5031: @260070
     /* 260070 */   GIM_Try, /*On fail goto*//*Label 5032*/ GIMT_Encode4(260122), // Rule ID 2999 //
     /* 260075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 260078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane),
     /* 260083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 260086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 260089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260099 */     // MIs[0] Op4
     /* 260099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260102 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 260107 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1720:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SDOT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 260107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_D),
     /* 260110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260114 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260116 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260118 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260120 */     GIR_RootConstrainSelectedInstOperands,
     /* 260121 */     // GIR_Coverage, 2999,
     /* 260121 */     GIR_EraseRootFromParent_Done,
     /* 260122 */   // Label 5032: @260122
     /* 260122 */   GIM_Try, /*On fail goto*//*Label 5033*/ GIMT_Encode4(260174), // Rule ID 3475 //
     /* 260127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE_or_SME),
     /* 260130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usdot_lane),
     /* 260135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260151 */     // MIs[0] Op4
     /* 260151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260154 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260159 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2067:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (USDOT_ZZZI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 260159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USDOT_ZZZI),
     /* 260162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260166 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260168 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260170 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260172 */     GIR_RootConstrainSelectedInstOperands,
     /* 260173 */     // GIR_Coverage, 3475,
     /* 260173 */     GIR_EraseRootFromParent_Done,
     /* 260174 */   // Label 5033: @260174
     /* 260174 */   GIM_Try, /*On fail goto*//*Label 5034*/ GIMT_Encode4(260226), // Rule ID 3525 //
     /* 260179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 260182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane_x2),
     /* 260187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260203 */     // MIs[0] Op4
     /* 260203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260206 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260211 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1721:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SDOT_ZZZI_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 260211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_HtoS),
     /* 260214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260220 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260222 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260224 */     GIR_RootConstrainSelectedInstOperands,
     /* 260225 */     // GIR_Coverage, 3525,
     /* 260225 */     GIR_EraseRootFromParent_Done,
     /* 260226 */   // Label 5034: @260226
     /* 260226 */   GIM_Try, /*On fail goto*//*Label 5035*/ GIMT_Encode4(260278), // Rule ID 7748 //
     /* 260231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 260234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane),
     /* 260239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260255 */     // MIs[0] Op4
     /* 260255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260258 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260263 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1967:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UDOT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 260263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_S),
     /* 260266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260270 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260272 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260274 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260276 */     GIR_RootConstrainSelectedInstOperands,
     /* 260277 */     // GIR_Coverage, 7748,
     /* 260277 */     GIR_EraseRootFromParent_Done,
     /* 260278 */   // Label 5035: @260278
     /* 260278 */   GIM_Try, /*On fail goto*//*Label 5036*/ GIMT_Encode4(260330), // Rule ID 7749 //
     /* 260283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 260286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane),
     /* 260291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 260294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 260297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260307 */     // MIs[0] Op4
     /* 260307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260310 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 260315 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1967:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (UDOT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 260315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_D),
     /* 260318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260322 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260324 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260326 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260328 */     GIR_RootConstrainSelectedInstOperands,
     /* 260329 */     // GIR_Coverage, 7749,
     /* 260329 */     GIR_EraseRootFromParent_Done,
     /* 260330 */   // Label 5036: @260330
     /* 260330 */   GIM_Try, /*On fail goto*//*Label 5037*/ GIMT_Encode4(260382), // Rule ID 8394 //
     /* 260335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 260338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 260343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 260346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 260349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260359 */     // MIs[0] idx
     /* 260359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260362 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 260367 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1479:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMLS_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 260367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_H),
     /* 260370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260374 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260376 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260378 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 260380 */     GIR_RootConstrainSelectedInstOperands,
     /* 260381 */     // GIR_Coverage, 8394,
     /* 260381 */     GIR_EraseRootFromParent_Done,
     /* 260382 */   // Label 5037: @260382
     /* 260382 */   GIM_Try, /*On fail goto*//*Label 5038*/ GIMT_Encode4(260434), // Rule ID 8397 //
     /* 260387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 260390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 260395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 260404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 260407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260411 */     // MIs[0] idx
     /* 260411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260414 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260419 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1479:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMLS_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 260419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_S),
     /* 260422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260426 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260428 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260430 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 260432 */     GIR_RootConstrainSelectedInstOperands,
     /* 260433 */     // GIR_Coverage, 8397,
     /* 260433 */     GIR_EraseRootFromParent_Done,
     /* 260434 */   // Label 5038: @260434
     /* 260434 */   GIM_Try, /*On fail goto*//*Label 5039*/ GIMT_Encode4(260486), // Rule ID 8400 //
     /* 260439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 260442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 260447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 260450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 260453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 260456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 260459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260463 */     // MIs[0] idx
     /* 260463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260466 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 260471 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1479:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMLS_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 260471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_D),
     /* 260474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260480 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260482 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 260484 */     GIR_RootConstrainSelectedInstOperands,
     /* 260485 */     // GIR_Coverage, 8400,
     /* 260485 */     GIR_EraseRootFromParent_Done,
     /* 260486 */   // Label 5039: @260486
     /* 260486 */   GIM_Try, /*On fail goto*//*Label 5040*/ GIMT_Encode4(260538), // Rule ID 11380 //
     /* 260491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE_or_SME),
     /* 260494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sudot_lane),
     /* 260499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260515 */     // MIs[0] Op4
     /* 260515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260518 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260523 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1916:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SUDOT_ZZZI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 260523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUDOT_ZZZI),
     /* 260526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260532 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260534 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260536 */     GIR_RootConstrainSelectedInstOperands,
     /* 260537 */     // GIR_Coverage, 11380,
     /* 260537 */     GIR_EraseRootFromParent_Done,
     /* 260538 */   // Label 5040: @260538
     /* 260538 */   GIM_Try, /*On fail goto*//*Label 5041*/ GIMT_Encode4(260590), // Rule ID 11427 //
     /* 260543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 260551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 260554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 260557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260567 */     // MIs[0] Op4
     /* 260567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260570 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 260575 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1615:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (MLS_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 260575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_H),
     /* 260578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260584 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260586 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260588 */     GIR_RootConstrainSelectedInstOperands,
     /* 260589 */     // GIR_Coverage, 11427,
     /* 260589 */     GIR_EraseRootFromParent_Done,
     /* 260590 */   // Label 5041: @260590
     /* 260590 */   GIM_Try, /*On fail goto*//*Label 5042*/ GIMT_Encode4(260642), // Rule ID 11428 //
     /* 260595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 260603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 260612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 260615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260619 */     // MIs[0] Op4
     /* 260619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260622 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260627 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1615:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (MLS_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 260627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_S),
     /* 260630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260636 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260638 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260640 */     GIR_RootConstrainSelectedInstOperands,
     /* 260641 */     // GIR_Coverage, 11428,
     /* 260641 */     GIR_EraseRootFromParent_Done,
     /* 260642 */   // Label 5042: @260642
     /* 260642 */   GIM_Try, /*On fail goto*//*Label 5043*/ GIMT_Encode4(260694), // Rule ID 11429 //
     /* 260647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 260655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 260658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 260661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 260664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 260667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260671 */     // MIs[0] Op4
     /* 260671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260674 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 260679 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1615:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (MLS_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 260679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_D),
     /* 260682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260686 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260688 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260690 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260692 */     GIR_RootConstrainSelectedInstOperands,
     /* 260693 */     // GIR_Coverage, 11429,
     /* 260693 */     GIR_EraseRootFromParent_Done,
     /* 260694 */   // Label 5043: @260694
     /* 260694 */   GIM_Try, /*On fail goto*//*Label 5044*/ GIMT_Encode4(260746), // Rule ID 11430 //
     /* 260699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 260707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 260710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 260713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260723 */     // MIs[0] Op4
     /* 260723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260726 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 260731 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1833:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 260731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_H),
     /* 260734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260740 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260742 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260744 */     GIR_RootConstrainSelectedInstOperands,
     /* 260745 */     // GIR_Coverage, 11430,
     /* 260745 */     GIR_EraseRootFromParent_Done,
     /* 260746 */   // Label 5044: @260746
     /* 260746 */   GIM_Try, /*On fail goto*//*Label 5045*/ GIMT_Encode4(260798), // Rule ID 11431 //
     /* 260751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 260759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 260768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 260771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260775 */     // MIs[0] Op4
     /* 260775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260778 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260783 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1833:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 260783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_S),
     /* 260786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260792 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260794 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260796 */     GIR_RootConstrainSelectedInstOperands,
     /* 260797 */     // GIR_Coverage, 11431,
     /* 260797 */     GIR_EraseRootFromParent_Done,
     /* 260798 */   // Label 5045: @260798
     /* 260798 */   GIM_Try, /*On fail goto*//*Label 5046*/ GIMT_Encode4(260850), // Rule ID 11432 //
     /* 260803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 260811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 260814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 260817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 260820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 260823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260827 */     // MIs[0] Op4
     /* 260827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260830 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 260835 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1833:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 260835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_D),
     /* 260838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260844 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260846 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260848 */     GIR_RootConstrainSelectedInstOperands,
     /* 260849 */     // GIR_Coverage, 11432,
     /* 260849 */     GIR_EraseRootFromParent_Done,
     /* 260850 */   // Label 5046: @260850
     /* 260850 */   GIM_Try, /*On fail goto*//*Label 5047*/ GIMT_Encode4(260902), // Rule ID 11433 //
     /* 260855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 260863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 260866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 260869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260879 */     // MIs[0] Op4
     /* 260879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260882 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 260887 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1835:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 260887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_H),
     /* 260890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260896 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260898 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260900 */     GIR_RootConstrainSelectedInstOperands,
     /* 260901 */     // GIR_Coverage, 11433,
     /* 260901 */     GIR_EraseRootFromParent_Done,
     /* 260902 */   // Label 5047: @260902
     /* 260902 */   GIM_Try, /*On fail goto*//*Label 5048*/ GIMT_Encode4(260954), // Rule ID 11434 //
     /* 260907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 260915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 260924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 260927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260931 */     // MIs[0] Op4
     /* 260931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260934 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260939 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1835:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 260939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_S),
     /* 260942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260946 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260948 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260950 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260952 */     GIR_RootConstrainSelectedInstOperands,
     /* 260953 */     // GIR_Coverage, 11434,
     /* 260953 */     GIR_EraseRootFromParent_Done,
     /* 260954 */   // Label 5048: @260954
     /* 260954 */   GIM_Try, /*On fail goto*//*Label 5049*/ GIMT_Encode4(261006), // Rule ID 11435 //
     /* 260959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 260967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 260970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 260973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 260976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 260979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260983 */     // MIs[0] Op4
     /* 260983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260986 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 260991 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1835:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 260991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_D),
     /* 260994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261000 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261002 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261004 */     GIR_RootConstrainSelectedInstOperands,
     /* 261005 */     // GIR_Coverage, 11435,
     /* 261005 */     GIR_EraseRootFromParent_Done,
     /* 261006 */   // Label 5049: @261006
     /* 261006 */   GIM_Try, /*On fail goto*//*Label 5050*/ GIMT_Encode4(261058), // Rule ID 11478 //
     /* 261011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt_lane),
     /* 261019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 261025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261035 */     // MIs[0] Op4
     /* 261035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261038 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 261043 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1756:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 261043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZI_S),
     /* 261046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261052 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261054 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261056 */     GIR_RootConstrainSelectedInstOperands,
     /* 261057 */     // GIR_Coverage, 11478,
     /* 261057 */     GIR_EraseRootFromParent_Done,
     /* 261058 */   // Label 5050: @261058
     /* 261058 */   GIM_Try, /*On fail goto*//*Label 5051*/ GIMT_Encode4(261110), // Rule ID 11479 //
     /* 261063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt_lane),
     /* 261071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 261077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261087 */     // MIs[0] Op4
     /* 261087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261090 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 261095 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1756:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 261095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZI_D),
     /* 261098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261104 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261106 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261108 */     GIR_RootConstrainSelectedInstOperands,
     /* 261109 */     // GIR_Coverage, 11479,
     /* 261109 */     GIR_EraseRootFromParent_Done,
     /* 261110 */   // Label 5051: @261110
     /* 261110 */   GIM_Try, /*On fail goto*//*Label 5052*/ GIMT_Encode4(261162), // Rule ID 11480 //
     /* 261115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb_lane),
     /* 261123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 261129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261139 */     // MIs[0] Op4
     /* 261139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261142 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 261147 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1992:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 261147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZI_S),
     /* 261150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261156 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261158 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261160 */     GIR_RootConstrainSelectedInstOperands,
     /* 261161 */     // GIR_Coverage, 11480,
     /* 261161 */     GIR_EraseRootFromParent_Done,
     /* 261162 */   // Label 5052: @261162
     /* 261162 */   GIM_Try, /*On fail goto*//*Label 5053*/ GIMT_Encode4(261214), // Rule ID 11481 //
     /* 261167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb_lane),
     /* 261175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 261181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261191 */     // MIs[0] Op4
     /* 261191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261194 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 261199 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1992:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 261199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZI_D),
     /* 261202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261208 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261210 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261212 */     GIR_RootConstrainSelectedInstOperands,
     /* 261213 */     // GIR_Coverage, 11481,
     /* 261213 */     GIR_EraseRootFromParent_Done,
     /* 261214 */   // Label 5053: @261214
     /* 261214 */   GIM_Try, /*On fail goto*//*Label 5054*/ GIMT_Encode4(261266), // Rule ID 11482 //
     /* 261219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt_lane),
     /* 261227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 261233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261243 */     // MIs[0] Op4
     /* 261243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261246 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 261251 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1994:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 261251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZI_S),
     /* 261254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261260 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261262 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261264 */     GIR_RootConstrainSelectedInstOperands,
     /* 261265 */     // GIR_Coverage, 11482,
     /* 261265 */     GIR_EraseRootFromParent_Done,
     /* 261266 */   // Label 5054: @261266
     /* 261266 */   GIM_Try, /*On fail goto*//*Label 5055*/ GIMT_Encode4(261318), // Rule ID 11483 //
     /* 261271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt_lane),
     /* 261279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 261285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261295 */     // MIs[0] Op4
     /* 261295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261298 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 261303 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1994:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 261303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZI_D),
     /* 261306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261312 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261314 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261316 */     GIR_RootConstrainSelectedInstOperands,
     /* 261317 */     // GIR_Coverage, 11483,
     /* 261317 */     GIR_EraseRootFromParent_Done,
     /* 261318 */   // Label 5055: @261318
     /* 261318 */   GIM_Try, /*On fail goto*//*Label 5056*/ GIMT_Encode4(261370), // Rule ID 11484 //
     /* 261323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb_lane),
     /* 261331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 261337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261347 */     // MIs[0] Op4
     /* 261347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261350 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 261355 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1758:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 261355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZI_S),
     /* 261358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261364 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261366 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261368 */     GIR_RootConstrainSelectedInstOperands,
     /* 261369 */     // GIR_Coverage, 11484,
     /* 261369 */     GIR_EraseRootFromParent_Done,
     /* 261370 */   // Label 5056: @261370
     /* 261370 */   GIM_Try, /*On fail goto*//*Label 5057*/ GIMT_Encode4(261422), // Rule ID 11485 //
     /* 261375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb_lane),
     /* 261383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 261389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261399 */     // MIs[0] Op4
     /* 261399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261402 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 261407 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1758:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 261407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZI_D),
     /* 261410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261416 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261418 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261420 */     GIR_RootConstrainSelectedInstOperands,
     /* 261421 */     // GIR_Coverage, 11485,
     /* 261421 */     GIR_EraseRootFromParent_Done,
     /* 261422 */   // Label 5057: @261422
     /* 261422 */   GIM_Try, /*On fail goto*//*Label 5058*/ GIMT_Encode4(261474), // Rule ID 11486 //
     /* 261427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt_lane),
     /* 261435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 261441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261451 */     // MIs[0] Op4
     /* 261451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261454 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 261459 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1760:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 261459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZI_S),
     /* 261462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261468 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261470 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261472 */     GIR_RootConstrainSelectedInstOperands,
     /* 261473 */     // GIR_Coverage, 11486,
     /* 261473 */     GIR_EraseRootFromParent_Done,
     /* 261474 */   // Label 5058: @261474
     /* 261474 */   GIM_Try, /*On fail goto*//*Label 5059*/ GIMT_Encode4(261526), // Rule ID 11487 //
     /* 261479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt_lane),
     /* 261487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 261493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261503 */     // MIs[0] Op4
     /* 261503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261506 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 261511 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1760:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 261511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZI_D),
     /* 261514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261520 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261522 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261524 */     GIR_RootConstrainSelectedInstOperands,
     /* 261525 */     // GIR_Coverage, 11487,
     /* 261525 */     GIR_EraseRootFromParent_Done,
     /* 261526 */   // Label 5059: @261526
     /* 261526 */   GIM_Try, /*On fail goto*//*Label 5060*/ GIMT_Encode4(261578), // Rule ID 11488 //
     /* 261531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb_lane),
     /* 261539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 261545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261555 */     // MIs[0] Op4
     /* 261555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261558 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 261563 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1996:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 261563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZI_S),
     /* 261566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261572 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261574 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261576 */     GIR_RootConstrainSelectedInstOperands,
     /* 261577 */     // GIR_Coverage, 11488,
     /* 261577 */     GIR_EraseRootFromParent_Done,
     /* 261578 */   // Label 5060: @261578
     /* 261578 */   GIM_Try, /*On fail goto*//*Label 5061*/ GIMT_Encode4(261630), // Rule ID 11489 //
     /* 261583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb_lane),
     /* 261591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 261597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261607 */     // MIs[0] Op4
     /* 261607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261610 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 261615 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1996:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 261615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZI_D),
     /* 261618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261622 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261624 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261626 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261628 */     GIR_RootConstrainSelectedInstOperands,
     /* 261629 */     // GIR_Coverage, 11489,
     /* 261629 */     GIR_EraseRootFromParent_Done,
     /* 261630 */   // Label 5061: @261630
     /* 261630 */   GIM_Try, /*On fail goto*//*Label 5062*/ GIMT_Encode4(261682), // Rule ID 11490 //
     /* 261635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt_lane),
     /* 261643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 261649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261659 */     // MIs[0] Op4
     /* 261659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261662 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 261667 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1998:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 261667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZI_S),
     /* 261670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261676 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261678 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261680 */     GIR_RootConstrainSelectedInstOperands,
     /* 261681 */     // GIR_Coverage, 11490,
     /* 261681 */     GIR_EraseRootFromParent_Done,
     /* 261682 */   // Label 5062: @261682
     /* 261682 */   GIM_Try, /*On fail goto*//*Label 5063*/ GIMT_Encode4(261734), // Rule ID 11491 //
     /* 261687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt_lane),
     /* 261695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 261701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261711 */     // MIs[0] Op4
     /* 261711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261714 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 261719 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1998:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 261719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZI_D),
     /* 261722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261726 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261728 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261730 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261732 */     GIR_RootConstrainSelectedInstOperands,
     /* 261733 */     // GIR_Coverage, 11491,
     /* 261733 */     GIR_EraseRootFromParent_Done,
     /* 261734 */   // Label 5063: @261734
     /* 261734 */   GIM_Try, /*On fail goto*//*Label 5064*/ GIMT_Encode4(261786), // Rule ID 11513 //
     /* 261739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb_lane),
     /* 261747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 261753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261763 */     // MIs[0] Op4
     /* 261763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261766 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 261771 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1796:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 261771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZI_S),
     /* 261774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261778 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261780 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261782 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261784 */     GIR_RootConstrainSelectedInstOperands,
     /* 261785 */     // GIR_Coverage, 11513,
     /* 261785 */     GIR_EraseRootFromParent_Done,
     /* 261786 */   // Label 5064: @261786
     /* 261786 */   GIM_Try, /*On fail goto*//*Label 5065*/ GIMT_Encode4(261838), // Rule ID 11514 //
     /* 261791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb_lane),
     /* 261799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 261805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261815 */     // MIs[0] Op4
     /* 261815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261818 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 261823 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1796:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 261823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZI_D),
     /* 261826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261832 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261834 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261836 */     GIR_RootConstrainSelectedInstOperands,
     /* 261837 */     // GIR_Coverage, 11514,
     /* 261837 */     GIR_EraseRootFromParent_Done,
     /* 261838 */   // Label 5065: @261838
     /* 261838 */   GIM_Try, /*On fail goto*//*Label 5066*/ GIMT_Encode4(261890), // Rule ID 11515 //
     /* 261843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt_lane),
     /* 261851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 261857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261867 */     // MIs[0] Op4
     /* 261867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261870 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 261875 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1799:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 261875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZI_S),
     /* 261878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261884 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261886 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261888 */     GIR_RootConstrainSelectedInstOperands,
     /* 261889 */     // GIR_Coverage, 11515,
     /* 261889 */     GIR_EraseRootFromParent_Done,
     /* 261890 */   // Label 5066: @261890
     /* 261890 */   GIM_Try, /*On fail goto*//*Label 5067*/ GIMT_Encode4(261942), // Rule ID 11516 //
     /* 261895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt_lane),
     /* 261903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 261909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261919 */     // MIs[0] Op4
     /* 261919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261922 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 261927 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1799:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 261927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZI_D),
     /* 261930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261936 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261938 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261940 */     GIR_RootConstrainSelectedInstOperands,
     /* 261941 */     // GIR_Coverage, 11516,
     /* 261941 */     GIR_EraseRootFromParent_Done,
     /* 261942 */   // Label 5067: @261942
     /* 261942 */   GIM_Try, /*On fail goto*//*Label 5068*/ GIMT_Encode4(261994), // Rule ID 11517 //
     /* 261947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb_lane),
     /* 261955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 261961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261971 */     // MIs[0] Op4
     /* 261971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261974 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 261979 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1801:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 261979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZI_S),
     /* 261982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261988 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261990 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261992 */     GIR_RootConstrainSelectedInstOperands,
     /* 261993 */     // GIR_Coverage, 11517,
     /* 261993 */     GIR_EraseRootFromParent_Done,
     /* 261994 */   // Label 5068: @261994
     /* 261994 */   GIM_Try, /*On fail goto*//*Label 5069*/ GIMT_Encode4(262046), // Rule ID 11518 //
     /* 261999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 262002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb_lane),
     /* 262007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 262010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 262013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 262016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 262019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262023 */     // MIs[0] Op4
     /* 262023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262026 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 262031 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1801:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 262031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZI_D),
     /* 262034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262040 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262042 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262044 */     GIR_RootConstrainSelectedInstOperands,
     /* 262045 */     // GIR_Coverage, 11518,
     /* 262045 */     GIR_EraseRootFromParent_Done,
     /* 262046 */   // Label 5069: @262046
     /* 262046 */   GIM_Try, /*On fail goto*//*Label 5070*/ GIMT_Encode4(262098), // Rule ID 11519 //
     /* 262051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 262054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt_lane),
     /* 262059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262075 */     // MIs[0] Op4
     /* 262075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262078 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 262083 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1804:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 262083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZI_S),
     /* 262086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262092 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262094 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262096 */     GIR_RootConstrainSelectedInstOperands,
     /* 262097 */     // GIR_Coverage, 11519,
     /* 262097 */     GIR_EraseRootFromParent_Done,
     /* 262098 */   // Label 5070: @262098
     /* 262098 */   GIM_Try, /*On fail goto*//*Label 5071*/ GIMT_Encode4(262150), // Rule ID 11520 //
     /* 262103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 262106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt_lane),
     /* 262111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 262114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 262117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 262120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 262123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262127 */     // MIs[0] Op4
     /* 262127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262130 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 262135 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1804:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 262135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZI_D),
     /* 262138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262144 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262146 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262148 */     GIR_RootConstrainSelectedInstOperands,
     /* 262149 */     // GIR_Coverage, 11520,
     /* 262149 */     GIR_EraseRootFromParent_Done,
     /* 262150 */   // Label 5071: @262150
     /* 262150 */   GIM_Try, /*On fail goto*//*Label 5072*/ GIMT_Encode4(262202), // Rule ID 11986 //
     /* 262155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 262158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalb_lane),
     /* 262163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262179 */     // MIs[0] Op4
     /* 262179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262182 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 262187 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1475:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLALB_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 262187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZI_SHH),
     /* 262190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262194 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262196 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262198 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262200 */     GIR_RootConstrainSelectedInstOperands,
     /* 262201 */     // GIR_Coverage, 11986,
     /* 262201 */     GIR_EraseRootFromParent_Done,
     /* 262202 */   // Label 5072: @262202
     /* 262202 */   GIM_Try, /*On fail goto*//*Label 5073*/ GIMT_Encode4(262254), // Rule ID 11987 //
     /* 262207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 262210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalt_lane),
     /* 262215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262231 */     // MIs[0] Op4
     /* 262231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262234 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 262239 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1477:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLALT_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 262239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZI_SHH),
     /* 262242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262246 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262248 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262250 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262252 */     GIR_RootConstrainSelectedInstOperands,
     /* 262253 */     // GIR_Coverage, 11987,
     /* 262253 */     GIR_EraseRootFromParent_Done,
     /* 262254 */   // Label 5073: @262254
     /* 262254 */   GIM_Try, /*On fail goto*//*Label 5074*/ GIMT_Encode4(262306), // Rule ID 11988 //
     /* 262259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 262262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslb_lane),
     /* 262267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262283 */     // MIs[0] Op4
     /* 262283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262286 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 262291 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1482:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLSLB_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 262291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLB_ZZZI_SHH),
     /* 262294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262298 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262300 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262302 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262304 */     GIR_RootConstrainSelectedInstOperands,
     /* 262305 */     // GIR_Coverage, 11988,
     /* 262305 */     GIR_EraseRootFromParent_Done,
     /* 262306 */   // Label 5074: @262306
     /* 262306 */   GIM_Try, /*On fail goto*//*Label 5075*/ GIMT_Encode4(262358), // Rule ID 11989 //
     /* 262311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 262314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslt_lane),
     /* 262319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262335 */     // MIs[0] Op4
     /* 262335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262338 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 262343 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1484:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLSLT_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 262343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLT_ZZZI_SHH),
     /* 262346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262350 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262352 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262354 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262356 */     GIR_RootConstrainSelectedInstOperands,
     /* 262357 */     // GIR_Coverage, 11989,
     /* 262357 */     GIR_EraseRootFromParent_Done,
     /* 262358 */   // Label 5075: @262358
     /* 262358 */   GIM_Try, /*On fail goto*//*Label 5076*/ GIMT_Encode4(262410), // Rule ID 12133 //
     /* 262363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 262366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdot_lane_x2),
     /* 262371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262387 */     // MIs[0] Op4
     /* 262387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262390 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 262395 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1430:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (FDOT_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 262395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_S),
     /* 262398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262404 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262406 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262408 */     GIR_RootConstrainSelectedInstOperands,
     /* 262409 */     // GIR_Coverage, 12133,
     /* 262409 */     GIR_EraseRootFromParent_Done,
     /* 262410 */   // Label 5076: @262410
     /* 262410 */   GIM_Try, /*On fail goto*//*Label 5077*/ GIMT_Encode4(262462), // Rule ID 12135 //
     /* 262415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 262418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane_x2),
     /* 262423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262439 */     // MIs[0] Op4
     /* 262439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262442 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 262447 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1968:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UDOT_ZZZI_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 262447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_HtoS),
     /* 262450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262454 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262456 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262458 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262460 */     GIR_RootConstrainSelectedInstOperands,
     /* 262461 */     // GIR_Coverage, 12135,
     /* 262461 */     GIR_EraseRootFromParent_Done,
     /* 262462 */   // Label 5077: @262462
     /* 262462 */   GIM_Try, /*On fail goto*//*Label 5078*/ GIMT_Encode4(262509), // Rule ID 2825 //
     /* 262467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 262475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 262478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 262481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 262490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262494 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1471:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 262494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 262497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262503 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262505 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262507 */     GIR_RootConstrainSelectedInstOperands,
     /* 262508 */     // GIR_Coverage, 2825,
     /* 262508 */     GIR_EraseRootFromParent_Done,
     /* 262509 */   // Label 5078: @262509
     /* 262509 */   GIM_Try, /*On fail goto*//*Label 5079*/ GIMT_Encode4(262556), // Rule ID 2828 //
     /* 262514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 262522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 262525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 262528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 262531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 262534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 262537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262541 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1471:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 262541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 262544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262550 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262552 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262554 */     GIR_RootConstrainSelectedInstOperands,
     /* 262555 */     // GIR_Coverage, 2828,
     /* 262555 */     GIR_EraseRootFromParent_Done,
     /* 262556 */   // Label 5079: @262556
     /* 262556 */   GIM_Try, /*On fail goto*//*Label 5080*/ GIMT_Encode4(262603), // Rule ID 2831 //
     /* 262561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 262569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 262572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 262575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 262578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 262581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 262584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262588 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1471:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 262588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 262591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262597 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262599 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262601 */     GIR_RootConstrainSelectedInstOperands,
     /* 262602 */     // GIR_Coverage, 2831,
     /* 262602 */     GIR_EraseRootFromParent_Done,
     /* 262603 */   // Label 5080: @262603
     /* 262603 */   GIM_Try, /*On fail goto*//*Label 5081*/ GIMT_Encode4(262650), // Rule ID 2834 //
     /* 262608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 262616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 262622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 262625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 262628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 262631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262635 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1471:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLA_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 262635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_S),
     /* 262638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262642 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262644 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262646 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262648 */     GIR_RootConstrainSelectedInstOperands,
     /* 262649 */     // GIR_Coverage, 2834,
     /* 262649 */     GIR_EraseRootFromParent_Done,
     /* 262650 */   // Label 5081: @262650
     /* 262650 */   GIM_Try, /*On fail goto*//*Label 5082*/ GIMT_Encode4(262697), // Rule ID 2837 //
     /* 262655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 262663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 262666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 262669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 262672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 262675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 262678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262682 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1471:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLA_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 262682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_S),
     /* 262685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262689 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262691 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262693 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262695 */     GIR_RootConstrainSelectedInstOperands,
     /* 262696 */     // GIR_Coverage, 2837,
     /* 262696 */     GIR_EraseRootFromParent_Done,
     /* 262697 */   // Label 5082: @262697
     /* 262697 */   GIM_Try, /*On fail goto*//*Label 5083*/ GIMT_Encode4(262744), // Rule ID 2840 //
     /* 262702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 262710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 262713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 262716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 262719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 262722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 262725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262729 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1471:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLA_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 262729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_D),
     /* 262732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262736 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262738 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262740 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262742 */     GIR_RootConstrainSelectedInstOperands,
     /* 262743 */     // GIR_Coverage, 2840,
     /* 262743 */     GIR_EraseRootFromParent_Done,
     /* 262744 */   // Label 5083: @262744
     /* 262744 */   GIM_Try, /*On fail goto*//*Label 5084*/ GIMT_Encode4(262791), // Rule ID 2843 //
     /* 262749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 262757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 262760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 262763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 262772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262776 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1434:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMAD_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 262776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_H),
     /* 262779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 262781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262785 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262787 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262789 */     GIR_RootConstrainSelectedInstOperands,
     /* 262790 */     // GIR_Coverage, 2843,
     /* 262790 */     GIR_EraseRootFromParent_Done,
     /* 262791 */   // Label 5084: @262791
     /* 262791 */   GIM_Try, /*On fail goto*//*Label 5085*/ GIMT_Encode4(262838), // Rule ID 2844 //
     /* 262796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 262804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 262810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 262813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 262816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 262819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262823 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1434:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMAD_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 262823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_S),
     /* 262826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 262828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262832 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262834 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262836 */     GIR_RootConstrainSelectedInstOperands,
     /* 262837 */     // GIR_Coverage, 2844,
     /* 262837 */     GIR_EraseRootFromParent_Done,
     /* 262838 */   // Label 5085: @262838
     /* 262838 */   GIM_Try, /*On fail goto*//*Label 5086*/ GIMT_Encode4(262885), // Rule ID 2845 //
     /* 262843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 262851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 262854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 262857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 262860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 262863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 262866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262870 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1434:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMAD_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 262870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_D),
     /* 262873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 262875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262879 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262881 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262883 */     GIR_RootConstrainSelectedInstOperands,
     /* 262884 */     // GIR_Coverage, 2845,
     /* 262884 */     GIR_EraseRootFromParent_Done,
     /* 262885 */   // Label 5086: @262885
     /* 262885 */   GIM_Try, /*On fail goto*//*Label 5087*/ GIMT_Encode4(262932), // Rule ID 2956 //
     /* 262890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 262898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 262901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 262904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 262907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 262910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 262913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262917 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1609:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MAD_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 262917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_B),
     /* 262920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 262922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262926 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262928 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262930 */     GIR_RootConstrainSelectedInstOperands,
     /* 262931 */     // GIR_Coverage, 2956,
     /* 262931 */     GIR_EraseRootFromParent_Done,
     /* 262932 */   // Label 5087: @262932
     /* 262932 */   GIM_Try, /*On fail goto*//*Label 5088*/ GIMT_Encode4(262979), // Rule ID 2959 //
     /* 262937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 262945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 262948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 262951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 262960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262964 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1609:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MAD_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 262964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_H),
     /* 262967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 262969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262973 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262975 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262977 */     GIR_RootConstrainSelectedInstOperands,
     /* 262978 */     // GIR_Coverage, 2959,
     /* 262978 */     GIR_EraseRootFromParent_Done,
     /* 262979 */   // Label 5088: @262979
     /* 262979 */   GIM_Try, /*On fail goto*//*Label 5089*/ GIMT_Encode4(263026), // Rule ID 2962 //
     /* 262984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 262992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 262998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 263001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 263004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 263007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263011 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1609:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MAD_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 263011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_S),
     /* 263014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 263016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263020 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263022 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263024 */     GIR_RootConstrainSelectedInstOperands,
     /* 263025 */     // GIR_Coverage, 2962,
     /* 263025 */     GIR_EraseRootFromParent_Done,
     /* 263026 */   // Label 5089: @263026
     /* 263026 */   GIM_Try, /*On fail goto*//*Label 5090*/ GIMT_Encode4(263073), // Rule ID 2965 //
     /* 263031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 263039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 263042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 263045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 263048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 263051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 263054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263058 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1609:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MAD_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 263058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_D),
     /* 263061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 263063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263067 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263069 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263071 */     GIR_RootConstrainSelectedInstOperands,
     /* 263072 */     // GIR_Coverage, 2965,
     /* 263072 */     GIR_EraseRootFromParent_Done,
     /* 263073 */   // Label 5090: @263073
     /* 263073 */   GIM_Try, /*On fail goto*//*Label 5091*/ GIMT_Encode4(263120), // Rule ID 2968 //
     /* 263078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 263086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 263089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 263092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 263095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 263098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 263101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263105 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1611:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLA_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 263105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_B),
     /* 263108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263112 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263114 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263116 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263118 */     GIR_RootConstrainSelectedInstOperands,
     /* 263119 */     // GIR_Coverage, 2968,
     /* 263119 */     GIR_EraseRootFromParent_Done,
     /* 263120 */   // Label 5091: @263120
     /* 263120 */   GIM_Try, /*On fail goto*//*Label 5092*/ GIMT_Encode4(263167), // Rule ID 2970 //
     /* 263125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 263133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 263136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 263139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 263142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 263145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 263148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263152 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1611:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLA_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 263152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_H),
     /* 263155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263161 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263163 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263165 */     GIR_RootConstrainSelectedInstOperands,
     /* 263166 */     // GIR_Coverage, 2970,
     /* 263166 */     GIR_EraseRootFromParent_Done,
     /* 263167 */   // Label 5092: @263167
     /* 263167 */   GIM_Try, /*On fail goto*//*Label 5093*/ GIMT_Encode4(263214), // Rule ID 2972 //
     /* 263172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 263180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 263183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 263186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 263189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 263192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 263195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263199 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1611:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLA_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 263199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_S),
     /* 263202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263208 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263210 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263212 */     GIR_RootConstrainSelectedInstOperands,
     /* 263213 */     // GIR_Coverage, 2972,
     /* 263213 */     GIR_EraseRootFromParent_Done,
     /* 263214 */   // Label 5093: @263214
     /* 263214 */   GIM_Try, /*On fail goto*//*Label 5094*/ GIMT_Encode4(263261), // Rule ID 2974 //
     /* 263219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 263227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 263230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 263233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 263236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 263239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 263242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263246 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1611:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLA_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 263246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_D),
     /* 263249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263255 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263257 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263259 */     GIR_RootConstrainSelectedInstOperands,
     /* 263260 */     // GIR_Coverage, 2974,
     /* 263260 */     GIR_EraseRootFromParent_Done,
     /* 263261 */   // Label 5094: @263261
     /* 263261 */   GIM_Try, /*On fail goto*//*Label 5095*/ GIMT_Encode4(263308), // Rule ID 7654 //
     /* 263266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 263274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 263277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 263280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 263283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 263286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 263289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263293 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1617:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MSB_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 263293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_B),
     /* 263296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 263298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263300 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263302 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263304 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263306 */     GIR_RootConstrainSelectedInstOperands,
     /* 263307 */     // GIR_Coverage, 7654,
     /* 263307 */     GIR_EraseRootFromParent_Done,
     /* 263308 */   // Label 5095: @263308
     /* 263308 */   GIM_Try, /*On fail goto*//*Label 5096*/ GIMT_Encode4(263355), // Rule ID 7657 //
     /* 263313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 263321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 263324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 263327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 263330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 263333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 263336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263340 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1617:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MSB_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 263340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_H),
     /* 263343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 263345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263349 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263351 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263353 */     GIR_RootConstrainSelectedInstOperands,
     /* 263354 */     // GIR_Coverage, 7657,
     /* 263354 */     GIR_EraseRootFromParent_Done,
     /* 263355 */   // Label 5096: @263355
     /* 263355 */   GIM_Try, /*On fail goto*//*Label 5097*/ GIMT_Encode4(263402), // Rule ID 7660 //
     /* 263360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 263368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 263371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 263374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 263377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 263380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 263383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263387 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1617:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MSB_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 263387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_S),
     /* 263390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 263392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263396 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263398 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263400 */     GIR_RootConstrainSelectedInstOperands,
     /* 263401 */     // GIR_Coverage, 7660,
     /* 263401 */     GIR_EraseRootFromParent_Done,
     /* 263402 */   // Label 5097: @263402
     /* 263402 */   GIM_Try, /*On fail goto*//*Label 5098*/ GIMT_Encode4(263449), // Rule ID 7663 //
     /* 263407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 263415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 263418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 263421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 263424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 263427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 263430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263434 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1617:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MSB_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 263434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_D),
     /* 263437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 263439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263441 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263443 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263445 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263447 */     GIR_RootConstrainSelectedInstOperands,
     /* 263448 */     // GIR_Coverage, 7663,
     /* 263448 */     GIR_EraseRootFromParent_Done,
     /* 263449 */   // Label 5098: @263449
     /* 263449 */   GIM_Try, /*On fail goto*//*Label 5099*/ GIMT_Encode4(263496), // Rule ID 7666 //
     /* 263454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 263462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 263465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 263468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 263471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 263474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 263477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263481 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1614:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLS_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 263481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_B),
     /* 263484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263490 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263492 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263494 */     GIR_RootConstrainSelectedInstOperands,
     /* 263495 */     // GIR_Coverage, 7666,
     /* 263495 */     GIR_EraseRootFromParent_Done,
     /* 263496 */   // Label 5099: @263496
     /* 263496 */   GIM_Try, /*On fail goto*//*Label 5100*/ GIMT_Encode4(263543), // Rule ID 7668 //
     /* 263501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 263509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 263512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 263515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 263518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 263521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 263524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263528 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1614:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLS_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 263528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_H),
     /* 263531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263535 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263537 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263539 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263541 */     GIR_RootConstrainSelectedInstOperands,
     /* 263542 */     // GIR_Coverage, 7668,
     /* 263542 */     GIR_EraseRootFromParent_Done,
     /* 263543 */   // Label 5100: @263543
     /* 263543 */   GIM_Try, /*On fail goto*//*Label 5101*/ GIMT_Encode4(263590), // Rule ID 7670 //
     /* 263548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 263556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 263559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 263562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 263565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 263568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 263571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263575 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1614:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLS_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 263575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_S),
     /* 263578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263584 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263586 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263588 */     GIR_RootConstrainSelectedInstOperands,
     /* 263589 */     // GIR_Coverage, 7670,
     /* 263589 */     GIR_EraseRootFromParent_Done,
     /* 263590 */   // Label 5101: @263590
     /* 263590 */   GIM_Try, /*On fail goto*//*Label 5102*/ GIMT_Encode4(263637), // Rule ID 7672 //
     /* 263595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 263603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 263606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 263609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 263612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 263615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 263618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263622 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1614:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLS_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 263622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_D),
     /* 263625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263631 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263633 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263635 */     GIR_RootConstrainSelectedInstOperands,
     /* 263636 */     // GIR_Coverage, 7672,
     /* 263636 */     GIR_EraseRootFromParent_Done,
     /* 263637 */   // Label 5102: @263637
     /* 263637 */   GIM_Try, /*On fail goto*//*Label 5103*/ GIMT_Encode4(263684), // Rule ID 8305 //
     /* 263642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 263650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 263653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 263656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 263659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 263662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 263665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263669 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1478:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 263669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 263672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263676 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263678 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263680 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263682 */     GIR_RootConstrainSelectedInstOperands,
     /* 263683 */     // GIR_Coverage, 8305,
     /* 263683 */     GIR_EraseRootFromParent_Done,
     /* 263684 */   // Label 5103: @263684
     /* 263684 */   GIM_Try, /*On fail goto*//*Label 5104*/ GIMT_Encode4(263731), // Rule ID 8308 //
     /* 263689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 263697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 263700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 263703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 263706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 263709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 263712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263716 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1478:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 263716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 263719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263725 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263727 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263729 */     GIR_RootConstrainSelectedInstOperands,
     /* 263730 */     // GIR_Coverage, 8308,
     /* 263730 */     GIR_EraseRootFromParent_Done,
     /* 263731 */   // Label 5104: @263731
     /* 263731 */   GIM_Try, /*On fail goto*//*Label 5105*/ GIMT_Encode4(263778), // Rule ID 8311 //
     /* 263736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 263744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 263747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 263750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 263753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 263756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 263759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263763 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1478:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 263763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 263766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263770 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263772 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263774 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263776 */     GIR_RootConstrainSelectedInstOperands,
     /* 263777 */     // GIR_Coverage, 8311,
     /* 263777 */     GIR_EraseRootFromParent_Done,
     /* 263778 */   // Label 5105: @263778
     /* 263778 */   GIM_Try, /*On fail goto*//*Label 5106*/ GIMT_Encode4(263825), // Rule ID 8314 //
     /* 263783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 263791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 263794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 263797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 263800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 263803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 263806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263810 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1478:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLS_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 263810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_S),
     /* 263813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263817 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263819 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263821 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263823 */     GIR_RootConstrainSelectedInstOperands,
     /* 263824 */     // GIR_Coverage, 8314,
     /* 263824 */     GIR_EraseRootFromParent_Done,
     /* 263825 */   // Label 5106: @263825
     /* 263825 */   GIM_Try, /*On fail goto*//*Label 5107*/ GIMT_Encode4(263872), // Rule ID 8317 //
     /* 263830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 263838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 263841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 263844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 263847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 263850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 263853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263857 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1478:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLS_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 263857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_S),
     /* 263860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263866 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263868 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263870 */     GIR_RootConstrainSelectedInstOperands,
     /* 263871 */     // GIR_Coverage, 8317,
     /* 263871 */     GIR_EraseRootFromParent_Done,
     /* 263872 */   // Label 5107: @263872
     /* 263872 */   GIM_Try, /*On fail goto*//*Label 5108*/ GIMT_Encode4(263919), // Rule ID 8320 //
     /* 263877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 263885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 263888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 263891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 263894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 263897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 263900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263904 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1478:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLS_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 263904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_D),
     /* 263907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263911 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263913 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263915 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263917 */     GIR_RootConstrainSelectedInstOperands,
     /* 263918 */     // GIR_Coverage, 8320,
     /* 263918 */     GIR_EraseRootFromParent_Done,
     /* 263919 */   // Label 5108: @263919
     /* 263919 */   GIM_Try, /*On fail goto*//*Label 5109*/ GIMT_Encode4(263966), // Rule ID 8323 //
     /* 263924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 263932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 263935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 263938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 263941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 263944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 263947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263951 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1494:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 263951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 263954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263958 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263960 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263962 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263964 */     GIR_RootConstrainSelectedInstOperands,
     /* 263965 */     // GIR_Coverage, 8323,
     /* 263965 */     GIR_EraseRootFromParent_Done,
     /* 263966 */   // Label 5109: @263966
     /* 263966 */   GIM_Try, /*On fail goto*//*Label 5110*/ GIMT_Encode4(264013), // Rule ID 8324 //
     /* 263971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 263979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 263982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 263985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 263988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 263991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 263994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263998 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1494:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 263998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 264001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264007 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264009 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264011 */     GIR_RootConstrainSelectedInstOperands,
     /* 264012 */     // GIR_Coverage, 8324,
     /* 264012 */     GIR_EraseRootFromParent_Done,
     /* 264013 */   // Label 5110: @264013
     /* 264013 */   GIM_Try, /*On fail goto*//*Label 5111*/ GIMT_Encode4(264060), // Rule ID 8325 //
     /* 264018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 264026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 264029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 264032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 264035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 264038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 264041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264045 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1494:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 264045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 264048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264052 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264054 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264056 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264058 */     GIR_RootConstrainSelectedInstOperands,
     /* 264059 */     // GIR_Coverage, 8325,
     /* 264059 */     GIR_EraseRootFromParent_Done,
     /* 264060 */   // Label 5111: @264060
     /* 264060 */   GIM_Try, /*On fail goto*//*Label 5112*/ GIMT_Encode4(264107), // Rule ID 8326 //
     /* 264065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 264073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 264076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 264079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 264082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 264085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 264088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264092 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1494:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLA_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 264092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_S),
     /* 264095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264101 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264103 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264105 */     GIR_RootConstrainSelectedInstOperands,
     /* 264106 */     // GIR_Coverage, 8326,
     /* 264106 */     GIR_EraseRootFromParent_Done,
     /* 264107 */   // Label 5112: @264107
     /* 264107 */   GIM_Try, /*On fail goto*//*Label 5113*/ GIMT_Encode4(264154), // Rule ID 8327 //
     /* 264112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 264120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 264123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 264126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 264129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 264132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 264135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264139 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1494:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLA_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 264139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_S),
     /* 264142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264146 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264148 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264150 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264152 */     GIR_RootConstrainSelectedInstOperands,
     /* 264153 */     // GIR_Coverage, 8327,
     /* 264153 */     GIR_EraseRootFromParent_Done,
     /* 264154 */   // Label 5113: @264154
     /* 264154 */   GIM_Try, /*On fail goto*//*Label 5114*/ GIMT_Encode4(264201), // Rule ID 8328 //
     /* 264159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 264167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 264170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 264173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 264176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 264179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 264182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264186 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1494:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLA_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 264186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_D),
     /* 264189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264195 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264197 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264199 */     GIR_RootConstrainSelectedInstOperands,
     /* 264200 */     // GIR_Coverage, 8328,
     /* 264200 */     GIR_EraseRootFromParent_Done,
     /* 264201 */   // Label 5114: @264201
     /* 264201 */   GIM_Try, /*On fail goto*//*Label 5115*/ GIMT_Encode4(264248), // Rule ID 8329 //
     /* 264206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 264214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 264217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 264220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 264223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 264226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 264229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264233 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1496:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 264233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 264236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264242 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264244 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264246 */     GIR_RootConstrainSelectedInstOperands,
     /* 264247 */     // GIR_Coverage, 8329,
     /* 264247 */     GIR_EraseRootFromParent_Done,
     /* 264248 */   // Label 5115: @264248
     /* 264248 */   GIM_Try, /*On fail goto*//*Label 5116*/ GIMT_Encode4(264295), // Rule ID 8330 //
     /* 264253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 264261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 264264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 264267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 264270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 264273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 264276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264280 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1496:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 264280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 264283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264287 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264289 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264291 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264293 */     GIR_RootConstrainSelectedInstOperands,
     /* 264294 */     // GIR_Coverage, 8330,
     /* 264294 */     GIR_EraseRootFromParent_Done,
     /* 264295 */   // Label 5116: @264295
     /* 264295 */   GIM_Try, /*On fail goto*//*Label 5117*/ GIMT_Encode4(264342), // Rule ID 8331 //
     /* 264300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 264308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 264311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 264314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 264317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 264320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 264323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264327 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1496:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 264327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 264330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264336 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264338 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264340 */     GIR_RootConstrainSelectedInstOperands,
     /* 264341 */     // GIR_Coverage, 8331,
     /* 264341 */     GIR_EraseRootFromParent_Done,
     /* 264342 */   // Label 5117: @264342
     /* 264342 */   GIM_Try, /*On fail goto*//*Label 5118*/ GIMT_Encode4(264389), // Rule ID 8332 //
     /* 264347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 264355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 264358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 264361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 264364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 264367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 264370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264374 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1496:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLS_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 264374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_S),
     /* 264377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264383 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264385 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264387 */     GIR_RootConstrainSelectedInstOperands,
     /* 264388 */     // GIR_Coverage, 8332,
     /* 264388 */     GIR_EraseRootFromParent_Done,
     /* 264389 */   // Label 5118: @264389
     /* 264389 */   GIM_Try, /*On fail goto*//*Label 5119*/ GIMT_Encode4(264436), // Rule ID 8333 //
     /* 264394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 264402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 264405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 264408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 264411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 264414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 264417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264421 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1496:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLS_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 264421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_S),
     /* 264424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264430 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264432 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264434 */     GIR_RootConstrainSelectedInstOperands,
     /* 264435 */     // GIR_Coverage, 8333,
     /* 264435 */     GIR_EraseRootFromParent_Done,
     /* 264436 */   // Label 5119: @264436
     /* 264436 */   GIM_Try, /*On fail goto*//*Label 5120*/ GIMT_Encode4(264483), // Rule ID 8334 //
     /* 264441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 264449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 264452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 264455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 264458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 264461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 264464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264468 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1496:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLS_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 264468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_D),
     /* 264471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264477 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264479 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264481 */     GIR_RootConstrainSelectedInstOperands,
     /* 264482 */     // GIR_Coverage, 8334,
     /* 264482 */     GIR_EraseRootFromParent_Done,
     /* 264483 */   // Label 5120: @264483
     /* 264483 */   GIM_Try, /*On fail goto*//*Label 5121*/ GIMT_Encode4(264530), // Rule ID 8335 //
     /* 264488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 264496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 264499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 264502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 264505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 264508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 264511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264515 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1486:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMSB_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 264515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_H),
     /* 264518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 264520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264522 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264524 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264526 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264528 */     GIR_RootConstrainSelectedInstOperands,
     /* 264529 */     // GIR_Coverage, 8335,
     /* 264529 */     GIR_EraseRootFromParent_Done,
     /* 264530 */   // Label 5121: @264530
     /* 264530 */   GIM_Try, /*On fail goto*//*Label 5122*/ GIMT_Encode4(264577), // Rule ID 8336 //
     /* 264535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 264543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 264546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 264549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 264552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 264555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 264558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264562 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1486:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMSB_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 264562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_S),
     /* 264565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 264567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264571 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264573 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264575 */     GIR_RootConstrainSelectedInstOperands,
     /* 264576 */     // GIR_Coverage, 8336,
     /* 264576 */     GIR_EraseRootFromParent_Done,
     /* 264577 */   // Label 5122: @264577
     /* 264577 */   GIM_Try, /*On fail goto*//*Label 5123*/ GIMT_Encode4(264624), // Rule ID 8337 //
     /* 264582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 264590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 264593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 264596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 264599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 264602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 264605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264609 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1486:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMSB_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 264609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_D),
     /* 264612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 264614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264616 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264618 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264620 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264622 */     GIR_RootConstrainSelectedInstOperands,
     /* 264623 */     // GIR_Coverage, 8337,
     /* 264623 */     GIR_EraseRootFromParent_Done,
     /* 264624 */   // Label 5123: @264624
     /* 264624 */   GIM_Try, /*On fail goto*//*Label 5124*/ GIMT_Encode4(264671), // Rule ID 8338 //
     /* 264629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 264637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 264640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 264643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 264646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 264649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 264652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264656 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1493:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMAD_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 264656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_H),
     /* 264659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 264661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264665 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264667 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264669 */     GIR_RootConstrainSelectedInstOperands,
     /* 264670 */     // GIR_Coverage, 8338,
     /* 264670 */     GIR_EraseRootFromParent_Done,
     /* 264671 */   // Label 5124: @264671
     /* 264671 */   GIM_Try, /*On fail goto*//*Label 5125*/ GIMT_Encode4(264718), // Rule ID 8339 //
     /* 264676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 264684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 264687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 264690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 264693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 264696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 264699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264703 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1493:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMAD_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 264703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_S),
     /* 264706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 264708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264712 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264714 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264716 */     GIR_RootConstrainSelectedInstOperands,
     /* 264717 */     // GIR_Coverage, 8339,
     /* 264717 */     GIR_EraseRootFromParent_Done,
     /* 264718 */   // Label 5125: @264718
     /* 264718 */   GIM_Try, /*On fail goto*//*Label 5126*/ GIMT_Encode4(264765), // Rule ID 8340 //
     /* 264723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 264731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 264734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 264737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 264740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 264743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 264746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264750 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1493:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMAD_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 264750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_D),
     /* 264753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 264755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264757 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264759 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264761 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264763 */     GIR_RootConstrainSelectedInstOperands,
     /* 264764 */     // GIR_Coverage, 8340,
     /* 264764 */     GIR_EraseRootFromParent_Done,
     /* 264765 */   // Label 5126: @264765
     /* 264765 */   GIM_Try, /*On fail goto*//*Label 5127*/ GIMT_Encode4(264812), // Rule ID 8341 //
     /* 264770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 264778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 264781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 264784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 264787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 264790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 264793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264797 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1498:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMSB_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 264797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_H),
     /* 264800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 264802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264804 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264806 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264808 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264810 */     GIR_RootConstrainSelectedInstOperands,
     /* 264811 */     // GIR_Coverage, 8341,
     /* 264811 */     GIR_EraseRootFromParent_Done,
     /* 264812 */   // Label 5127: @264812
     /* 264812 */   GIM_Try, /*On fail goto*//*Label 5128*/ GIMT_Encode4(264859), // Rule ID 8342 //
     /* 264817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 264825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 264828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 264831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 264834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 264837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 264840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264844 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1498:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMSB_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 264844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_S),
     /* 264847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 264849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264851 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264853 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264855 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264857 */     GIR_RootConstrainSelectedInstOperands,
     /* 264858 */     // GIR_Coverage, 8342,
     /* 264858 */     GIR_EraseRootFromParent_Done,
     /* 264859 */   // Label 5128: @264859
     /* 264859 */   GIM_Try, /*On fail goto*//*Label 5129*/ GIMT_Encode4(264906), // Rule ID 8343 //
     /* 264864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 264872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 264875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 264878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 264881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 264884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 264887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264891 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1498:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMSB_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 264891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_D),
     /* 264894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 264896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264900 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264902 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264904 */     GIR_RootConstrainSelectedInstOperands,
     /* 264905 */     // GIR_Coverage, 8343,
     /* 264905 */     GIR_EraseRootFromParent_Done,
     /* 264906 */   // Label 5129: @264906
     /* 264906 */   GIM_Try, /*On fail goto*//*Label 5130*/ GIMT_Encode4(264953), // Rule ID 8344 //
     /* 264911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 264919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 264922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 264925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 264928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 264931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 264934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264938 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1480:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 264938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 264941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 264943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264947 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264949 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264951 */     GIR_RootConstrainSelectedInstOperands,
     /* 264952 */     // GIR_Coverage, 8344,
     /* 264952 */     GIR_EraseRootFromParent_Done,
     /* 264953 */   // Label 5130: @264953
     /* 264953 */   GIM_Try, /*On fail goto*//*Label 5131*/ GIMT_Encode4(265000), // Rule ID 8347 //
     /* 264958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 264966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 264969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 264972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 264975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 264978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 264981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264985 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1480:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 264985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 264988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 264990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264992 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264994 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264996 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264998 */     GIR_RootConstrainSelectedInstOperands,
     /* 264999 */     // GIR_Coverage, 8347,
     /* 264999 */     GIR_EraseRootFromParent_Done,
     /* 265000 */   // Label 5131: @265000
     /* 265000 */   GIM_Try, /*On fail goto*//*Label 5132*/ GIMT_Encode4(265047), // Rule ID 8350 //
     /* 265005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 265013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 265016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 265019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 265022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 265025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 265028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265032 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1480:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 265032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 265035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265041 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265043 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265045 */     GIR_RootConstrainSelectedInstOperands,
     /* 265046 */     // GIR_Coverage, 8350,
     /* 265046 */     GIR_EraseRootFromParent_Done,
     /* 265047 */   // Label 5132: @265047
     /* 265047 */   GIM_Try, /*On fail goto*//*Label 5133*/ GIMT_Encode4(265094), // Rule ID 8353 //
     /* 265052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 265060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 265063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 265066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 265069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 265072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 265075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265079 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1480:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLS_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 265079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_S_UNDEF),
     /* 265082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265088 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265090 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265092 */     GIR_RootConstrainSelectedInstOperands,
     /* 265093 */     // GIR_Coverage, 8353,
     /* 265093 */     GIR_EraseRootFromParent_Done,
     /* 265094 */   // Label 5133: @265094
     /* 265094 */   GIM_Try, /*On fail goto*//*Label 5134*/ GIMT_Encode4(265141), // Rule ID 8356 //
     /* 265099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 265107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 265110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 265113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 265116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 265119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 265122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265126 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1480:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLS_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 265126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_S_UNDEF),
     /* 265129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265133 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265135 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265137 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265139 */     GIR_RootConstrainSelectedInstOperands,
     /* 265140 */     // GIR_Coverage, 8356,
     /* 265140 */     GIR_EraseRootFromParent_Done,
     /* 265141 */   // Label 5134: @265141
     /* 265141 */   GIM_Try, /*On fail goto*//*Label 5135*/ GIMT_Encode4(265188), // Rule ID 8359 //
     /* 265146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 265154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 265157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 265160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 265163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 265166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 265169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265173 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1480:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLS_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 265173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_D_UNDEF),
     /* 265176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265182 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265184 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265186 */     GIR_RootConstrainSelectedInstOperands,
     /* 265187 */     // GIR_Coverage, 8359,
     /* 265187 */     GIR_EraseRootFromParent_Done,
     /* 265188 */   // Label 5135: @265188
     /* 265188 */   GIM_Try, /*On fail goto*//*Label 5136*/ GIMT_Encode4(265235), // Rule ID 8362 //
     /* 265193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 265201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 265204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 265207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 265210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 265213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 265216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265220 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1495:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 265220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 265223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265227 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265229 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265231 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265233 */     GIR_RootConstrainSelectedInstOperands,
     /* 265234 */     // GIR_Coverage, 8362,
     /* 265234 */     GIR_EraseRootFromParent_Done,
     /* 265235 */   // Label 5136: @265235
     /* 265235 */   GIM_Try, /*On fail goto*//*Label 5137*/ GIMT_Encode4(265282), // Rule ID 8365 //
     /* 265240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 265248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 265251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 265254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 265257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 265260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 265263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265267 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1495:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 265267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 265270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265274 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265276 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265278 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265280 */     GIR_RootConstrainSelectedInstOperands,
     /* 265281 */     // GIR_Coverage, 8365,
     /* 265281 */     GIR_EraseRootFromParent_Done,
     /* 265282 */   // Label 5137: @265282
     /* 265282 */   GIM_Try, /*On fail goto*//*Label 5138*/ GIMT_Encode4(265329), // Rule ID 8368 //
     /* 265287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 265295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 265298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 265301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 265304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 265307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 265310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265314 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1495:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 265314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 265317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265323 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265325 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265327 */     GIR_RootConstrainSelectedInstOperands,
     /* 265328 */     // GIR_Coverage, 8368,
     /* 265328 */     GIR_EraseRootFromParent_Done,
     /* 265329 */   // Label 5138: @265329
     /* 265329 */   GIM_Try, /*On fail goto*//*Label 5139*/ GIMT_Encode4(265376), // Rule ID 8371 //
     /* 265334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 265342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 265345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 265348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 265351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 265354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 265357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265361 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1495:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLA_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 265361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_S_UNDEF),
     /* 265364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265370 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265372 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265374 */     GIR_RootConstrainSelectedInstOperands,
     /* 265375 */     // GIR_Coverage, 8371,
     /* 265375 */     GIR_EraseRootFromParent_Done,
     /* 265376 */   // Label 5139: @265376
     /* 265376 */   GIM_Try, /*On fail goto*//*Label 5140*/ GIMT_Encode4(265423), // Rule ID 8374 //
     /* 265381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 265389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 265392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 265395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 265398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 265401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 265404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265408 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1495:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLA_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 265408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_S_UNDEF),
     /* 265411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265415 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265417 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265419 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265421 */     GIR_RootConstrainSelectedInstOperands,
     /* 265422 */     // GIR_Coverage, 8374,
     /* 265422 */     GIR_EraseRootFromParent_Done,
     /* 265423 */   // Label 5140: @265423
     /* 265423 */   GIM_Try, /*On fail goto*//*Label 5141*/ GIMT_Encode4(265470), // Rule ID 8377 //
     /* 265428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 265436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 265439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 265442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 265445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 265448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 265451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265455 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1495:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLA_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 265455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_D_UNDEF),
     /* 265458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265462 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265464 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265466 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265468 */     GIR_RootConstrainSelectedInstOperands,
     /* 265469 */     // GIR_Coverage, 8377,
     /* 265469 */     GIR_EraseRootFromParent_Done,
     /* 265470 */   // Label 5141: @265470
     /* 265470 */   GIM_Try, /*On fail goto*//*Label 5142*/ GIMT_Encode4(265517), // Rule ID 8380 //
     /* 265475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 265483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 265486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 265489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 265492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 265495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 265498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265502 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1497:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 265502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 265505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265511 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265513 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265515 */     GIR_RootConstrainSelectedInstOperands,
     /* 265516 */     // GIR_Coverage, 8380,
     /* 265516 */     GIR_EraseRootFromParent_Done,
     /* 265517 */   // Label 5142: @265517
     /* 265517 */   GIM_Try, /*On fail goto*//*Label 5143*/ GIMT_Encode4(265564), // Rule ID 8382 //
     /* 265522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 265530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 265533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 265536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 265539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 265542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 265545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265549 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1497:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 265549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 265552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265558 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265560 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265562 */     GIR_RootConstrainSelectedInstOperands,
     /* 265563 */     // GIR_Coverage, 8382,
     /* 265563 */     GIR_EraseRootFromParent_Done,
     /* 265564 */   // Label 5143: @265564
     /* 265564 */   GIM_Try, /*On fail goto*//*Label 5144*/ GIMT_Encode4(265611), // Rule ID 8384 //
     /* 265569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 265577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 265580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 265583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 265586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 265589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 265592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265596 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1497:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 265596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 265599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265605 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265607 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265609 */     GIR_RootConstrainSelectedInstOperands,
     /* 265610 */     // GIR_Coverage, 8384,
     /* 265610 */     GIR_EraseRootFromParent_Done,
     /* 265611 */   // Label 5144: @265611
     /* 265611 */   GIM_Try, /*On fail goto*//*Label 5145*/ GIMT_Encode4(265658), // Rule ID 8386 //
     /* 265616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 265624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 265627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 265630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 265633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 265636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 265639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265643 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1497:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLS_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 265643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_S_UNDEF),
     /* 265646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265652 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265654 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265656 */     GIR_RootConstrainSelectedInstOperands,
     /* 265657 */     // GIR_Coverage, 8386,
     /* 265657 */     GIR_EraseRootFromParent_Done,
     /* 265658 */   // Label 5145: @265658
     /* 265658 */   GIM_Try, /*On fail goto*//*Label 5146*/ GIMT_Encode4(265705), // Rule ID 8388 //
     /* 265663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 265671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 265674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 265677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 265680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 265683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 265686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265690 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1497:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLS_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 265690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_S_UNDEF),
     /* 265693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265699 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265701 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265703 */     GIR_RootConstrainSelectedInstOperands,
     /* 265704 */     // GIR_Coverage, 8388,
     /* 265704 */     GIR_EraseRootFromParent_Done,
     /* 265705 */   // Label 5146: @265705
     /* 265705 */   GIM_Try, /*On fail goto*//*Label 5147*/ GIMT_Encode4(265752), // Rule ID 8390 //
     /* 265710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 265718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 265721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 265724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 265727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 265730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 265733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265737 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1497:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLS_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 265737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_D_UNDEF),
     /* 265740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265746 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265748 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265750 */     GIR_RootConstrainSelectedInstOperands,
     /* 265751 */     // GIR_Coverage, 8390,
     /* 265751 */     GIR_EraseRootFromParent_Done,
     /* 265752 */   // Label 5147: @265752
     /* 265752 */   GIM_Reject,
     /* 265753 */ // Label 5006: @265753
     /* 265753 */ GIM_Reject,
     /* 265754 */ // Label 38: @265754
     /* 265754 */ GIM_Try, /*On fail goto*//*Label 5148*/ GIMT_Encode4(265832),
     /* 265759 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /* 265762 */   GIM_Try, /*On fail goto*//*Label 5149*/ GIMT_Encode4(265784), // Rule ID 78 //
     /* 265767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 265770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_tcommit),
     /* 265775 */     // (intrinsic_void 2176:{ *:[iPTR] })  =>  (TCOMMIT)
     /* 265775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TCOMMIT),
     /* 265778 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 265782 */     GIR_RootConstrainSelectedInstOperands,
     /* 265783 */     // GIR_Coverage, 78,
     /* 265783 */     GIR_EraseRootFromParent_Done,
     /* 265784 */   // Label 5149: @265784
     /* 265784 */   GIM_Try, /*On fail goto*//*Label 5150*/ GIMT_Encode4(265809), // Rule ID 2386 //
     /* 265789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 265792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_setffr),
     /* 265797 */     // (intrinsic_void 1726:{ *:[iPTR] })  =>  (SETFFR:{ *:[i64] })
     /* 265797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SETFFR),
     /* 265800 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FFR*/0,
     /* 265803 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 265807 */     GIR_RootConstrainSelectedInstOperands,
     /* 265808 */     // GIR_Coverage, 2386,
     /* 265808 */     GIR_EraseRootFromParent_Done,
     /* 265809 */   // Label 5150: @265809
     /* 265809 */   GIM_Try, /*On fail goto*//*Label 5151*/ GIMT_Encode4(265831), // Rule ID 7208 //
     /* 265814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_clrex),
     /* 265819 */     // (intrinsic_void 510:{ *:[iPTR] })  =>  (CLREX 15:{ *:[i64] })
     /* 265819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLREX),
     /* 265822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 265825 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 265829 */     GIR_RootConstrainSelectedInstOperands,
     /* 265830 */     // GIR_Coverage, 7208,
     /* 265830 */     GIR_EraseRootFromParent_Done,
     /* 265831 */   // Label 5151: @265831
     /* 265831 */   GIM_Reject,
     /* 265832 */ // Label 5148: @265832
     /* 265832 */ GIM_Try, /*On fail goto*//*Label 5152*/ GIMT_Encode4(266432),
     /* 265837 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /* 265840 */   GIM_Try, /*On fail goto*//*Label 5153*/ GIMT_Encode4(265872), // Rule ID 79 //
     /* 265845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 265848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_tcancel),
     /* 265853 */     // MIs[0] imm
     /* 265853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 265856 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm64_0_65535),
     /* 265861 */     // (intrinsic_void 2175:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_timm64_0_65535>>:$imm)  =>  (TCANCEL (timm:{ *:[i64] }):$imm)
     /* 265861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TCANCEL),
     /* 265864 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 265866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 265870 */     GIR_RootConstrainSelectedInstOperands,
     /* 265871 */     // GIR_Coverage, 79,
     /* 265871 */     GIR_EraseRootFromParent_Done,
     /* 265872 */   // Label 5153: @265872
     /* 265872 */   GIM_Try, /*On fail goto*//*Label 5154*/ GIMT_Encode4(265897), // Rule ID 227 //
     /* 265877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_break),
     /* 265882 */     // MIs[0] imm
     /* 265882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 265885 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_65535),
     /* 265890 */     // (intrinsic_void 508:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_65535>>:$imm)  =>  (BRK (timm:{ *:[i32] }):$imm)
     /* 265890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 265893 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 265895 */     GIR_RootConstrainSelectedInstOperands,
     /* 265896 */     // GIR_Coverage, 227,
     /* 265896 */     GIR_EraseRootFromParent_Done,
     /* 265897 */   // Label 5154: @265897
     /* 265897 */   GIM_Try, /*On fail goto*//*Label 5155*/ GIMT_Encode4(265922), // Rule ID 228 //
     /* 265902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_hlt),
     /* 265907 */     // MIs[0] imm
     /* 265907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 265910 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_65535),
     /* 265915 */     // (intrinsic_void 567:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_65535>>:$imm)  =>  (HLT (timm:{ *:[i32] }):$imm)
     /* 265915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HLT),
     /* 265918 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 265920 */     GIR_RootConstrainSelectedInstOperands,
     /* 265921 */     // GIR_Coverage, 228,
     /* 265921 */     GIR_EraseRootFromParent_Done,
     /* 265922 */   // Label 5155: @265922
     /* 265922 */   GIM_Try, /*On fail goto*//*Label 5156*/ GIMT_Encode4(265954), // Rule ID 3643 //
     /* 265927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 265930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_zero),
     /* 265935 */     // MIs[0] imm
     /* 265935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 265938 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_255),
     /* 265943 */     // (intrinsic_void 1232:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_255>>:$imm)  =>  (ZERO_M_PSEUDO (timm:{ *:[i32] })<<P:Predicate_timm32_0_255>>:$imm)
     /* 265943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZERO_M_PSEUDO),
     /* 265946 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 265948 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 265952 */     GIR_RootConstrainSelectedInstOperands,
     /* 265953 */     // GIR_Coverage, 3643,
     /* 265953 */     GIR_EraseRootFromParent_Done,
     /* 265954 */   // Label 5156: @265954
     /* 265954 */   GIM_Try, /*On fail goto*//*Label 5157*/ GIMT_Encode4(265994), // Rule ID 16 //
     /* 265959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_hint),
     /* 265964 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 265967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265975 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_127),
     /* 265979 */     // MIs[1] Operand 1
     /* 265979 */     // No operand predicates
     /* 265979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265981 */     // (intrinsic_void 566:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_127>>:$imm)  =>  (HINT (imm:{ *:[i32] }):$imm)
     /* 265981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HINT),
     /* 265984 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 265987 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 265992 */     GIR_RootConstrainSelectedInstOperands,
     /* 265993 */     // GIR_Coverage, 16,
     /* 265993 */     GIR_EraseRootFromParent_Done,
     /* 265994 */   // Label 5157: @265994
     /* 265994 */   GIM_Try, /*On fail goto*//*Label 5158*/ GIMT_Encode4(266034), // Rule ID 17 //
     /* 265999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_dmb),
     /* 266004 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 266007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 266015 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 266019 */     // MIs[1] Operand 1
     /* 266019 */     // No operand predicates
     /* 266019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266021 */     // (intrinsic_void 554:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (DMB (imm:{ *:[i32] }):$CRm)
     /* 266021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 266024 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 266027 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 266032 */     GIR_RootConstrainSelectedInstOperands,
     /* 266033 */     // GIR_Coverage, 17,
     /* 266033 */     GIR_EraseRootFromParent_Done,
     /* 266034 */   // Label 5158: @266034
     /* 266034 */   GIM_Try, /*On fail goto*//*Label 5159*/ GIMT_Encode4(266074), // Rule ID 18 //
     /* 266039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_dsb),
     /* 266044 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 266047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 266055 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 266059 */     // MIs[1] Operand 1
     /* 266059 */     // No operand predicates
     /* 266059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266061 */     // (intrinsic_void 555:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (DSB (imm:{ *:[i32] }):$CRm)
     /* 266061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DSB),
     /* 266064 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 266067 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 266072 */     GIR_RootConstrainSelectedInstOperands,
     /* 266073 */     // GIR_Coverage, 18,
     /* 266073 */     GIR_EraseRootFromParent_Done,
     /* 266074 */   // Label 5159: @266074
     /* 266074 */   GIM_Try, /*On fail goto*//*Label 5160*/ GIMT_Encode4(266114), // Rule ID 19 //
     /* 266079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_isb),
     /* 266084 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 266087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 266095 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 266099 */     // MIs[1] Operand 1
     /* 266099 */     // No operand predicates
     /* 266099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266101 */     // (intrinsic_void 570:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (ISB (imm:{ *:[i32] }):$CRm)
     /* 266101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ISB),
     /* 266104 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 266107 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 266112 */     GIR_RootConstrainSelectedInstOperands,
     /* 266113 */     // GIR_Coverage, 19,
     /* 266113 */     GIR_EraseRootFromParent_Done,
     /* 266114 */   // Label 5160: @266114
     /* 266114 */   GIM_Try, /*On fail goto*//*Label 5161*/ GIMT_Encode4(266138), // Rule ID 72 //
     /* 266119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_get_fpcr),
     /* 266124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 266127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266131 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] })  =>  (MRS_FPCR:{ *:[i64] })
     /* 266131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS_FPCR),
     /* 266134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 266136 */     GIR_RootConstrainSelectedInstOperands,
     /* 266137 */     // GIR_Coverage, 72,
     /* 266137 */     GIR_EraseRootFromParent_Done,
     /* 266138 */   // Label 5161: @266138
     /* 266138 */   GIM_Try, /*On fail goto*//*Label 5162*/ GIMT_Encode4(266162), // Rule ID 74 //
     /* 266143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_get_fpsr),
     /* 266148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 266151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266155 */     // (intrinsic_w_chain:{ *:[i64] } 564:{ *:[iPTR] })  =>  (MRS_FPSR:{ *:[i64] })
     /* 266155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS_FPSR),
     /* 266158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 266160 */     GIR_RootConstrainSelectedInstOperands,
     /* 266161 */     // GIR_Coverage, 74,
     /* 266161 */     GIR_EraseRootFromParent_Done,
     /* 266162 */   // Label 5162: @266162
     /* 266162 */   GIM_Try, /*On fail goto*//*Label 5163*/ GIMT_Encode4(266193), // Rule ID 77 //
     /* 266167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 266170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_tstart),
     /* 266175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 266178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266182 */     // (intrinsic_w_chain:{ *:[i64] } 2177:{ *:[iPTR] })  =>  (TSTART:{ *:[i64] })
     /* 266182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TSTART),
     /* 266185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 266187 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266191 */     GIR_RootConstrainSelectedInstOperands,
     /* 266192 */     // GIR_Coverage, 77,
     /* 266192 */     GIR_EraseRootFromParent_Done,
     /* 266193 */   // Label 5163: @266193
     /* 266193 */   GIM_Try, /*On fail goto*//*Label 5164*/ GIMT_Encode4(266220), // Rule ID 80 //
     /* 266198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 266201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ttest),
     /* 266206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 266209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266213 */     // (intrinsic_w_chain:{ *:[i64] } 2178:{ *:[iPTR] })  =>  (TTEST:{ *:[i64] })
     /* 266213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TTEST),
     /* 266216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 266218 */     GIR_RootConstrainSelectedInstOperands,
     /* 266219 */     // GIR_Coverage, 80,
     /* 266219 */     GIR_EraseRootFromParent_Done,
     /* 266220 */   // Label 5164: @266220
     /* 266220 */   GIM_Try, /*On fail goto*//*Label 5165*/ GIMT_Encode4(266251), // Rule ID 2385 //
     /* 266225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 266228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rdffr),
     /* 266233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 266236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 266240 */     // (intrinsic_w_chain:{ *:[nxv16i1] } 1676:{ *:[iPTR] })  =>  (RDFFR_P:{ *:[nxv16i1] })
     /* 266240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RDFFR_P),
     /* 266243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 266245 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266249 */     GIR_RootConstrainSelectedInstOperands,
     /* 266250 */     // GIR_Coverage, 2385,
     /* 266250 */     GIR_EraseRootFromParent_Done,
     /* 266251 */   // Label 5165: @266251
     /* 266251 */   GIM_Try, /*On fail goto*//*Label 5166*/ GIMT_Encode4(266291), // Rule ID 12919 //
     /* 266256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 266259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sme_get_tpidr2),
     /* 266264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 266267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266271 */     // (intrinsic_w_chain:{ *:[i64] } 901:{ *:[iPTR] })  =>  (MRS:{ *:[i64] }:{ *:[i32] } 56965:{ *:[i32] })
     /* 266271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS),
     /* 266274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 266276 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(56965),
     /* 266286 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 266289 */     GIR_RootConstrainSelectedInstOperands,
     /* 266290 */     // GIR_Coverage, 12919,
     /* 266290 */     GIR_EraseRootFromParent_Done,
     /* 266291 */   // Label 5166: @266291
     /* 266291 */   GIM_Try, /*On fail goto*//*Label 5167*/ GIMT_Encode4(266325), // Rule ID 2387 //
     /* 266296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 266299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_wrffr),
     /* 266304 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 266307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 266311 */     // (intrinsic_void 2156:{ *:[iPTR] }, PPR8:{ *:[nxv16i1] }:$Pn)  =>  (WRFFR:{ *:[i64] } PPR8:{ *:[nxv16i1] }:$Pn)
     /* 266311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WRFFR),
     /* 266314 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pn
     /* 266316 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FFR*/0,
     /* 266319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266323 */     GIR_RootConstrainSelectedInstOperands,
     /* 266324 */     // GIR_Coverage, 2387,
     /* 266324 */     GIR_EraseRootFromParent_Done,
     /* 266325 */   // Label 5167: @266325
     /* 266325 */   GIM_Try, /*On fail goto*//*Label 5168*/ GIMT_Encode4(266348), // Rule ID 73 //
     /* 266330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpcr),
     /* 266335 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 266338 */     // (intrinsic_void 790:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPCR i64:{ *:[i64] }:$val)
     /* 266338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPCR),
     /* 266341 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 266343 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPCR*/0,
     /* 266346 */     GIR_RootConstrainSelectedInstOperands,
     /* 266347 */     // GIR_Coverage, 73,
     /* 266347 */     GIR_EraseRootFromParent_Done,
     /* 266348 */   // Label 5168: @266348
     /* 266348 */   GIM_Try, /*On fail goto*//*Label 5169*/ GIMT_Encode4(266371), // Rule ID 75 //
     /* 266353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpsr),
     /* 266358 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 266361 */     // (intrinsic_void 792:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPSR i64:{ *:[i64] }:$val)
     /* 266361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPSR),
     /* 266364 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 266366 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPSR*/0,
     /* 266369 */     GIR_RootConstrainSelectedInstOperands,
     /* 266370 */     // GIR_Coverage, 75,
     /* 266370 */     GIR_EraseRootFromParent_Done,
     /* 266371 */   // Label 5169: @266371
     /* 266371 */   GIM_Try, /*On fail goto*//*Label 5170*/ GIMT_Encode4(266398), // Rule ID 76 //
     /* 266376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpmr),
     /* 266381 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 266384 */     // (intrinsic_void 791:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPMR i64:{ *:[i64] }:$val)
     /* 266384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPMR),
     /* 266387 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 266389 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPMR*/0,
     /* 266392 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266396 */     GIR_RootConstrainSelectedInstOperands,
     /* 266397 */     // GIR_Coverage, 76,
     /* 266397 */     GIR_EraseRootFromParent_Done,
     /* 266398 */   // Label 5170: @266398
     /* 266398 */   GIM_Try, /*On fail goto*//*Label 5171*/ GIMT_Encode4(266431), // Rule ID 12918 //
     /* 266403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 266406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_set_tpidr2),
     /* 266411 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 266414 */     // (intrinsic_void 976:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR 56965:{ *:[i32] }, GPR64:{ *:[i64] }:$val)
     /* 266414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR),
     /* 266417 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(56965),
     /* 266427 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 266429 */     GIR_RootConstrainSelectedInstOperands,
     /* 266430 */     // GIR_Coverage, 12918,
     /* 266430 */     GIR_EraseRootFromParent_Done,
     /* 266431 */   // Label 5171: @266431
     /* 266431 */   GIM_Reject,
     /* 266432 */ // Label 5152: @266432
     /* 266432 */ GIM_Try, /*On fail goto*//*Label 5172*/ GIMT_Encode4(267403),
     /* 266437 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 266440 */   GIM_Try, /*On fail goto*//*Label 5173*/ GIMT_Encode4(266516), // Rule ID 7174 //
     /* 266445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 266450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 266453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266457 */     // MIs[0] addr
     /* 266457 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 266461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 266465 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_1),
     /* 266469 */     // (intrinsic_w_chain:{ *:[i64] } 576:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 266469 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266472 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRB),
     /* 266476 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266481 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 266485 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266489 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 266491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 266494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 266496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266499 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 266505 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266510 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266515 */     // GIR_Coverage, 7174,
     /* 266515 */     GIR_EraseRootFromParent_Done,
     /* 266516 */   // Label 5173: @266516
     /* 266516 */   GIM_Try, /*On fail goto*//*Label 5174*/ GIMT_Encode4(266592), // Rule ID 7175 //
     /* 266521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 266526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 266529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266533 */     // MIs[0] addr
     /* 266533 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 266537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 266541 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_2),
     /* 266545 */     // (intrinsic_w_chain:{ *:[i64] } 576:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_2>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 266545 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266548 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRH),
     /* 266552 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266557 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 266561 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266565 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 266567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 266570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 266572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 266581 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266586 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266591 */     // GIR_Coverage, 7175,
     /* 266591 */     GIR_EraseRootFromParent_Done,
     /* 266592 */   // Label 5174: @266592
     /* 266592 */   GIM_Try, /*On fail goto*//*Label 5175*/ GIMT_Encode4(266668), // Rule ID 7176 //
     /* 266597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 266602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 266605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266609 */     // MIs[0] addr
     /* 266609 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 266613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 266617 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_4),
     /* 266621 */     // (intrinsic_w_chain:{ *:[i64] } 576:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_4>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 266621 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266624 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRW),
     /* 266628 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266633 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 266637 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266641 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 266643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 266646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 266648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266651 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 266657 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266662 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266667 */     // GIR_Coverage, 7176,
     /* 266667 */     GIR_EraseRootFromParent_Done,
     /* 266668 */   // Label 5175: @266668
     /* 266668 */   GIM_Try, /*On fail goto*//*Label 5176*/ GIMT_Encode4(266710), // Rule ID 7177 //
     /* 266673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 266678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 266681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266685 */     // MIs[0] addr
     /* 266685 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 266689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 266693 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_8),
     /* 266697 */     // (intrinsic_w_chain:{ *:[i64] } 576:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_8>>  =>  (LDXRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$addr)
     /* 266697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDXRX),
     /* 266700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 266702 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 266704 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266708 */     GIR_RootConstrainSelectedInstOperands,
     /* 266709 */     // GIR_Coverage, 7177,
     /* 266709 */     GIR_EraseRootFromParent_Done,
     /* 266710 */   // Label 5176: @266710
     /* 266710 */   GIM_Try, /*On fail goto*//*Label 5177*/ GIMT_Encode4(266786), // Rule ID 7181 //
     /* 266715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 266720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 266723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266727 */     // MIs[0] addr
     /* 266727 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 266731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 266735 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_1),
     /* 266739 */     // (intrinsic_w_chain:{ *:[i64] } 573:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 266739 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266742 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRB),
     /* 266746 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266751 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 266755 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266759 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 266761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 266764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 266766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266769 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 266775 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266780 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266785 */     // GIR_Coverage, 7181,
     /* 266785 */     GIR_EraseRootFromParent_Done,
     /* 266786 */   // Label 5177: @266786
     /* 266786 */   GIM_Try, /*On fail goto*//*Label 5178*/ GIMT_Encode4(266862), // Rule ID 7182 //
     /* 266791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 266796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 266799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266803 */     // MIs[0] addr
     /* 266803 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 266807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 266811 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_2),
     /* 266815 */     // (intrinsic_w_chain:{ *:[i64] } 573:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_2>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 266815 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266818 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRH),
     /* 266822 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266827 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 266831 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266835 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 266837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 266840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 266842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 266851 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266856 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266861 */     // GIR_Coverage, 7182,
     /* 266861 */     GIR_EraseRootFromParent_Done,
     /* 266862 */   // Label 5178: @266862
     /* 266862 */   GIM_Try, /*On fail goto*//*Label 5179*/ GIMT_Encode4(266938), // Rule ID 7183 //
     /* 266867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 266872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 266875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266879 */     // MIs[0] addr
     /* 266879 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 266883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 266887 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_4),
     /* 266891 */     // (intrinsic_w_chain:{ *:[i64] } 573:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_4>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 266891 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266894 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRW),
     /* 266898 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266903 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 266907 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266911 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 266913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 266916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 266918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266921 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 266927 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266932 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266937 */     // GIR_Coverage, 7183,
     /* 266937 */     GIR_EraseRootFromParent_Done,
     /* 266938 */   // Label 5179: @266938
     /* 266938 */   GIM_Try, /*On fail goto*//*Label 5180*/ GIMT_Encode4(266980), // Rule ID 7184 //
     /* 266943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 266948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 266951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266955 */     // MIs[0] addr
     /* 266955 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 266959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 266963 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_8),
     /* 266967 */     // (intrinsic_w_chain:{ *:[i64] } 573:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_8>>  =>  (LDAXRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$addr)
     /* 266967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAXRX),
     /* 266970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 266972 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 266974 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266978 */     GIR_RootConstrainSelectedInstOperands,
     /* 266979 */     // GIR_Coverage, 7184,
     /* 266979 */     GIR_EraseRootFromParent_Done,
     /* 266980 */   // Label 5180: @266980
     /* 266980 */   GIM_Try, /*On fail goto*//*Label 5181*/ GIMT_Encode4(267020), // Rule ID 20 //
     /* 266985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGCS),
     /* 266988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_gcspopm),
     /* 266993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 266996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 266999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 267003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 267007 */     // (intrinsic_w_chain:{ *:[i64] } 561:{ *:[iPTR] }, GPR64:{ *:[i64] }:$src)  =>  (GCSPOPM:{ *:[i64] } GPR64:{ *:[i64] }:$src)
     /* 267007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::GCSPOPM),
     /* 267010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 267012 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 267014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267018 */     GIR_RootConstrainSelectedInstOperands,
     /* 267019 */     // GIR_Coverage, 20,
     /* 267019 */     GIR_EraseRootFromParent_Done,
     /* 267020 */   // Label 5181: @267020
     /* 267020 */   GIM_Try, /*On fail goto*//*Label 5182*/ GIMT_Encode4(267060), // Rule ID 2384 //
     /* 267025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 267028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rdffr_z),
     /* 267033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 267036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 267039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 267043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 267047 */     // (intrinsic_w_chain:{ *:[nxv16i1] } 1677:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (RDFFR_PPz:{ *:[nxv16i1] } PPRAny:{ *:[nxv16i1] }:$Pg)
     /* 267047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RDFFR_PPz),
     /* 267050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 267052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 267054 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267058 */     GIR_RootConstrainSelectedInstOperands,
     /* 267059 */     // GIR_Coverage, 2384,
     /* 267059 */     GIR_EraseRootFromParent_Done,
     /* 267060 */   // Label 5182: @267060
     /* 267060 */   GIM_Try, /*On fail goto*//*Label 5183*/ GIMT_Encode4(267100), // Rule ID 2491 //
     /* 267065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 267068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl1),
     /* 267073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 267076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 267079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267087 */     // (intrinsic_w_chain:{ *:[v8f16] } 621:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (F1CVTL:{ *:[v8f16] } V64:{ *:[v8i8] }:$Rn)
     /* 267087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTL),
     /* 267090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267094 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267098 */     GIR_RootConstrainSelectedInstOperands,
     /* 267099 */     // GIR_Coverage, 2491,
     /* 267099 */     GIR_EraseRootFromParent_Done,
     /* 267100 */   // Label 5183: @267100
     /* 267100 */   GIM_Try, /*On fail goto*//*Label 5184*/ GIMT_Encode4(267140), // Rule ID 2492 //
     /* 267105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 267108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl1),
     /* 267113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 267116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 267119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267127 */     // (intrinsic_w_chain:{ *:[v8f16] } 621:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (F1CVTL2:{ *:[v8f16] } V128:{ *:[v16i8] }:$Rn)
     /* 267127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTL2),
     /* 267130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267138 */     GIR_RootConstrainSelectedInstOperands,
     /* 267139 */     // GIR_Coverage, 2492,
     /* 267139 */     GIR_EraseRootFromParent_Done,
     /* 267140 */   // Label 5184: @267140
     /* 267140 */   GIM_Try, /*On fail goto*//*Label 5185*/ GIMT_Encode4(267180), // Rule ID 7055 //
     /* 267145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 267148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl2),
     /* 267153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 267156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 267159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267167 */     // (intrinsic_w_chain:{ *:[v8f16] } 622:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (F2CVTL:{ *:[v8f16] } V64:{ *:[v8i8] }:$Rn)
     /* 267167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTL),
     /* 267170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267174 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267178 */     GIR_RootConstrainSelectedInstOperands,
     /* 267179 */     // GIR_Coverage, 7055,
     /* 267179 */     GIR_EraseRootFromParent_Done,
     /* 267180 */   // Label 5185: @267180
     /* 267180 */   GIM_Try, /*On fail goto*//*Label 5186*/ GIMT_Encode4(267220), // Rule ID 7056 //
     /* 267185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 267188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl2),
     /* 267193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 267196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 267199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267207 */     // (intrinsic_w_chain:{ *:[v8f16] } 622:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (F2CVTL2:{ *:[v8f16] } V128:{ *:[v16i8] }:$Rn)
     /* 267207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTL2),
     /* 267210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267214 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267218 */     GIR_RootConstrainSelectedInstOperands,
     /* 267219 */     // GIR_Coverage, 7056,
     /* 267219 */     GIR_EraseRootFromParent_Done,
     /* 267220 */   // Label 5186: @267220
     /* 267220 */   GIM_Try, /*On fail goto*//*Label 5187*/ GIMT_Encode4(267256), // Rule ID 3596 //
     /* 267225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 267228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvt1),
     /* 267233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 267236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 267239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267243 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1501:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F1CVT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 267243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVT_ZZ_BtoH),
     /* 267246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267250 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267254 */     GIR_RootConstrainSelectedInstOperands,
     /* 267255 */     // GIR_Coverage, 3596,
     /* 267255 */     GIR_EraseRootFromParent_Done,
     /* 267256 */   // Label 5187: @267256
     /* 267256 */   GIM_Try, /*On fail goto*//*Label 5188*/ GIMT_Encode4(267294), // Rule ID 4026 //
     /* 267261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 267264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_irg_sp),
     /* 267269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 267272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 267275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 267279 */     // (intrinsic_w_chain:{ *:[i64] } 569:{ *:[iPTR] }, i64:{ *:[i64] }:$Rm)  =>  (IRGstack:{ *:[i64] } SP:{ *:[i64] }, i64:{ *:[i64] }:$Rm)
     /* 267279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::IRGstack),
     /* 267282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267284 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::SP), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 267290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 267292 */     GIR_RootConstrainSelectedInstOperands,
     /* 267293 */     // GIR_Coverage, 4026,
     /* 267293 */     GIR_EraseRootFromParent_Done,
     /* 267294 */   // Label 5188: @267294
     /* 267294 */   GIM_Try, /*On fail goto*//*Label 5189*/ GIMT_Encode4(267330), // Rule ID 12644 //
     /* 267299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 267302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvt2),
     /* 267307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 267310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 267313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267317 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1503:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F2CVT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 267317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVT_ZZ_BtoH),
     /* 267320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267324 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267328 */     GIR_RootConstrainSelectedInstOperands,
     /* 267329 */     // GIR_Coverage, 12644,
     /* 267329 */     GIR_EraseRootFromParent_Done,
     /* 267330 */   // Label 5189: @267330
     /* 267330 */   GIM_Try, /*On fail goto*//*Label 5190*/ GIMT_Encode4(267366), // Rule ID 12645 //
     /* 267335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 267338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvtlt1),
     /* 267343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 267346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 267349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267353 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1507:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F1CVTLT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 267353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTLT_ZZ_BtoH),
     /* 267356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267360 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267364 */     GIR_RootConstrainSelectedInstOperands,
     /* 267365 */     // GIR_Coverage, 12645,
     /* 267365 */     GIR_EraseRootFromParent_Done,
     /* 267366 */   // Label 5190: @267366
     /* 267366 */   GIM_Try, /*On fail goto*//*Label 5191*/ GIMT_Encode4(267402), // Rule ID 12646 //
     /* 267371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 267374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvtlt2),
     /* 267379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 267382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 267385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267389 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1508:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F2CVTLT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 267389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTLT_ZZ_BtoH),
     /* 267392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267396 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267400 */     GIR_RootConstrainSelectedInstOperands,
     /* 267401 */     // GIR_Coverage, 12646,
     /* 267401 */     GIR_EraseRootFromParent_Done,
     /* 267402 */   // Label 5191: @267402
     /* 267402 */   GIM_Reject,
     /* 267403 */ // Label 5172: @267403
     /* 267403 */ GIM_Try, /*On fail goto*//*Label 5192*/ GIMT_Encode4(271571),
     /* 267408 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 267411 */   GIM_Try, /*On fail goto*//*Label 5193*/ GIMT_Encode4(267508), // Rule ID 7192 //
     /* 267416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 267421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 267424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 267427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 267439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 267443 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 267447 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 267451 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 267455 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 267459 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267464 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(255),
     /* 267475 */     // MIs[0] addr
     /* 267475 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 267479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 267483 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 267487 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 267489 */     // (intrinsic_w_chain:{ *:[i32] } 1251:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 255:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 267489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 267492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 267494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 267498 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 267500 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 267506 */     GIR_RootConstrainSelectedInstOperands,
     /* 267507 */     // GIR_Coverage, 7192,
     /* 267507 */     GIR_EraseRootFromParent_Done,
     /* 267508 */   // Label 5193: @267508
     /* 267508 */   GIM_Try, /*On fail goto*//*Label 5194*/ GIMT_Encode4(267605), // Rule ID 7193 //
     /* 267513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 267518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 267521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 267524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 267536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 267540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 267544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 267548 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 267552 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 267556 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267561 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /* 267572 */     // MIs[0] addr
     /* 267572 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 267576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 267580 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 267584 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 267586 */     // (intrinsic_w_chain:{ *:[i32] } 1251:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 65535:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 267586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 267589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 267591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 267595 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 267597 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 267603 */     GIR_RootConstrainSelectedInstOperands,
     /* 267604 */     // GIR_Coverage, 7193,
     /* 267604 */     GIR_EraseRootFromParent_Done,
     /* 267605 */   // Label 5194: @267605
     /* 267605 */   GIM_Try, /*On fail goto*//*Label 5195*/ GIMT_Encode4(267702), // Rule ID 7202 //
     /* 267610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 267615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 267618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 267621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 267633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 267637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 267641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 267645 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 267649 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 267653 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267658 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(255),
     /* 267669 */     // MIs[0] addr
     /* 267669 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 267673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 267677 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 267681 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 267683 */     // (intrinsic_w_chain:{ *:[i32] } 1249:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 255:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 267683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 267686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 267688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 267692 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 267694 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 267700 */     GIR_RootConstrainSelectedInstOperands,
     /* 267701 */     // GIR_Coverage, 7202,
     /* 267701 */     GIR_EraseRootFromParent_Done,
     /* 267702 */   // Label 5195: @267702
     /* 267702 */   GIM_Try, /*On fail goto*//*Label 5196*/ GIMT_Encode4(267799), // Rule ID 7203 //
     /* 267707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 267712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 267715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 267718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 267730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 267734 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 267738 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 267742 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 267746 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 267750 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267755 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /* 267766 */     // MIs[0] addr
     /* 267766 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 267770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 267774 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 267778 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 267780 */     // (intrinsic_w_chain:{ *:[i32] } 1249:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 65535:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 267780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 267783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 267785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 267789 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 267791 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 267797 */     GIR_RootConstrainSelectedInstOperands,
     /* 267798 */     // GIR_Coverage, 7203,
     /* 267798 */     GIR_EraseRootFromParent_Done,
     /* 267799 */   // Label 5196: @267799
     /* 267799 */   GIM_Try, /*On fail goto*//*Label 5197*/ GIMT_Encode4(267910), // Rule ID 7195 //
     /* 267804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 267809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 267812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 267815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 267827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 267831 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 267835 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 267840 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /* 267851 */     // MIs[0] addr
     /* 267851 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 267855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 267859 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 267863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267865 */     // (intrinsic_w_chain:{ *:[i32] } 1251:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 255:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 267865 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 267868 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267872 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267877 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 267883 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267888 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 267893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 267896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 267898 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267901 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 267903 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 267908 */     GIR_RootConstrainSelectedInstOperands,
     /* 267909 */     // GIR_Coverage, 7195,
     /* 267909 */     GIR_EraseRootFromParent_Done,
     /* 267910 */   // Label 5197: @267910
     /* 267910 */   GIM_Try, /*On fail goto*//*Label 5198*/ GIMT_Encode4(268021), // Rule ID 7196 //
     /* 267915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 267920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 267923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 267926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 267938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 267942 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 267946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 267951 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 267962 */     // MIs[0] addr
     /* 267962 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 267966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 267970 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 267974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267976 */     // (intrinsic_w_chain:{ *:[i32] } 1251:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 65535:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 267976 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 267979 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267983 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267988 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 267994 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267999 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 268007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 268009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268012 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 268014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 268019 */     GIR_RootConstrainSelectedInstOperands,
     /* 268020 */     // GIR_Coverage, 7196,
     /* 268020 */     GIR_EraseRootFromParent_Done,
     /* 268021 */   // Label 5198: @268021
     /* 268021 */   GIM_Try, /*On fail goto*//*Label 5199*/ GIMT_Encode4(268132), // Rule ID 7197 //
     /* 268026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 268031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 268034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 268037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 268049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 268053 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 268057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268062 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 268073 */     // MIs[0] addr
     /* 268073 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 268077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 268081 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 268085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268087 */     // (intrinsic_w_chain:{ *:[i32] } 1251:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 4294967295:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 268087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 268090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268099 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 268105 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268110 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 268118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 268120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268123 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 268125 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 268130 */     GIR_RootConstrainSelectedInstOperands,
     /* 268131 */     // GIR_Coverage, 7197,
     /* 268131 */     GIR_EraseRootFromParent_Done,
     /* 268132 */   // Label 5199: @268132
     /* 268132 */   GIM_Try, /*On fail goto*//*Label 5200*/ GIMT_Encode4(268243), // Rule ID 7205 //
     /* 268137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 268142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 268145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 268148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 268160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 268164 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 268168 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268173 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /* 268184 */     // MIs[0] addr
     /* 268184 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 268188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 268192 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 268196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268198 */     // (intrinsic_w_chain:{ *:[i32] } 1249:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 255:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 268198 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 268201 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268205 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268210 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 268216 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268221 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 268229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 268231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268234 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 268236 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 268241 */     GIR_RootConstrainSelectedInstOperands,
     /* 268242 */     // GIR_Coverage, 7205,
     /* 268242 */     GIR_EraseRootFromParent_Done,
     /* 268243 */   // Label 5200: @268243
     /* 268243 */   GIM_Try, /*On fail goto*//*Label 5201*/ GIMT_Encode4(268354), // Rule ID 7206 //
     /* 268248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 268253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 268256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 268259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 268271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 268275 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 268279 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268284 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 268295 */     // MIs[0] addr
     /* 268295 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 268299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 268303 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 268307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268309 */     // (intrinsic_w_chain:{ *:[i32] } 1249:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 65535:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 268309 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 268312 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268316 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268321 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 268327 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268332 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 268340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 268342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268345 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 268347 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 268352 */     GIR_RootConstrainSelectedInstOperands,
     /* 268353 */     // GIR_Coverage, 7206,
     /* 268353 */     GIR_EraseRootFromParent_Done,
     /* 268354 */   // Label 5201: @268354
     /* 268354 */   GIM_Try, /*On fail goto*//*Label 5202*/ GIMT_Encode4(268465), // Rule ID 7207 //
     /* 268359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 268364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 268367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 268370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 268382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 268386 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 268390 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268395 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 268406 */     // MIs[0] addr
     /* 268406 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 268410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 268414 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 268418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268420 */     // (intrinsic_w_chain:{ *:[i32] } 1249:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 4294967295:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 268420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 268423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268432 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 268438 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268443 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 268451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 268453 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268456 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 268458 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 268463 */     GIR_RootConstrainSelectedInstOperands,
     /* 268464 */     // GIR_Coverage, 7207,
     /* 268464 */     GIR_EraseRootFromParent_Done,
     /* 268465 */   // Label 5202: @268465
     /* 268465 */   GIM_Try, /*On fail goto*//*Label 5203*/ GIMT_Encode4(268516), // Rule ID 70 //
     /* 268470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_fixedshadow),
     /* 268475 */     // MIs[0] ptr
     /* 268475 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 268479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 268483 */     // MIs[0] accessinfo
     /* 268483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 268486 */     // MIs[0] fixed_shadow
     /* 268486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 268489 */     // (intrinsic_void 194:{ *:[iPTR] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)  =>  (HWASAN_CHECK_MEMACCESS_FIXEDSHADOW:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)
     /* 268489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_FIXEDSHADOW),
     /* 268492 */     GIR_RootToRootCopy, /*OpIdx*/1, // ptr
     /* 268494 */     GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
     /* 268496 */     GIR_RootToRootCopy, /*OpIdx*/3, // fixed_shadow
     /* 268498 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 268501 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 268504 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 268507 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 268510 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268514 */     GIR_RootConstrainSelectedInstOperands,
     /* 268515 */     // GIR_Coverage, 70,
     /* 268515 */     GIR_EraseRootFromParent_Done,
     /* 268516 */   // Label 5203: @268516
     /* 268516 */   GIM_Try, /*On fail goto*//*Label 5204*/ GIMT_Encode4(268567), // Rule ID 71 //
     /* 268521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules_fixedshadow),
     /* 268526 */     // MIs[0] ptr
     /* 268526 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 268530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 268534 */     // MIs[0] accessinfo
     /* 268534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 268537 */     // MIs[0] fixed_shadow
     /* 268537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 268540 */     // (intrinsic_void 196:{ *:[iPTR] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES_FIXEDSHADOW:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)
     /* 268540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_SHORTGRANULES_FIXEDSHADOW),
     /* 268543 */     GIR_RootToRootCopy, /*OpIdx*/1, // ptr
     /* 268545 */     GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
     /* 268547 */     GIR_RootToRootCopy, /*OpIdx*/3, // fixed_shadow
     /* 268549 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 268552 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 268555 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 268558 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 268561 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268565 */     GIR_RootConstrainSelectedInstOperands,
     /* 268566 */     // GIR_Coverage, 71,
     /* 268566 */     GIR_EraseRootFromParent_Done,
     /* 268567 */   // Label 5204: @268567
     /* 268567 */   GIM_Try, /*On fail goto*//*Label 5205*/ GIMT_Encode4(268636), // Rule ID 7194 //
     /* 268572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 268577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 268580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 268583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 268595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 268599 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268604 */     // MIs[0] addr
     /* 268604 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 268608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 268612 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 268616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268618 */     // (intrinsic_w_chain:{ *:[i32] } 1251:{ *:[iPTR] }, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$val), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 268618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 268621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 268623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 268627 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 268629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 268634 */     GIR_RootConstrainSelectedInstOperands,
     /* 268635 */     // GIR_Coverage, 7194,
     /* 268635 */     GIR_EraseRootFromParent_Done,
     /* 268636 */   // Label 5205: @268636
     /* 268636 */   GIM_Try, /*On fail goto*//*Label 5206*/ GIMT_Encode4(268705), // Rule ID 7204 //
     /* 268641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 268646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 268649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 268652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 268664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 268668 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268673 */     // MIs[0] addr
     /* 268673 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 268677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 268681 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 268685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268687 */     // (intrinsic_w_chain:{ *:[i32] } 1249:{ *:[iPTR] }, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$val), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 268687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 268690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 268692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 268696 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 268698 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 268703 */     GIR_RootConstrainSelectedInstOperands,
     /* 268704 */     // GIR_Coverage, 7204,
     /* 268704 */     GIR_EraseRootFromParent_Done,
     /* 268705 */   // Label 5206: @268705
     /* 268705 */   GIM_Try, /*On fail goto*//*Label 5207*/ GIMT_Encode4(268747), // Rule ID 3620 //
     /* 268710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 268713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4a_wide_1x1),
     /* 268718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 268721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 268724 */     // MIs[0] tile
     /* 268724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 268727 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 268732 */     // (intrinsic_void 1025:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 268732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4A_MZZ_BToS_PSEUDO),
     /* 268735 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 268737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 268739 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 268741 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268745 */     GIR_RootConstrainSelectedInstOperands,
     /* 268746 */     // GIR_Coverage, 3620,
     /* 268746 */     GIR_EraseRootFromParent_Done,
     /* 268747 */   // Label 5207: @268747
     /* 268747 */   GIM_Try, /*On fail goto*//*Label 5208*/ GIMT_Encode4(268789), // Rule ID 3624 //
     /* 268752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 268755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4a_wide_1x1),
     /* 268760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 268763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 268766 */     // MIs[0] tile
     /* 268766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 268769 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 268774 */     // (intrinsic_void 1025:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4A_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 268774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4A_MZZ_HToS_PSEUDO),
     /* 268777 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 268779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 268781 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 268783 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268787 */     GIR_RootConstrainSelectedInstOperands,
     /* 268788 */     // GIR_Coverage, 3624,
     /* 268788 */     GIR_EraseRootFromParent_Done,
     /* 268789 */   // Label 5208: @268789
     /* 268789 */   GIM_Try, /*On fail goto*//*Label 5209*/ GIMT_Encode4(268831), // Rule ID 3628 //
     /* 268794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 268797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4a_za64_wide_1x1),
     /* 268802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 268805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 268808 */     // MIs[0] tile
     /* 268808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 268811 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 268816 */     // (intrinsic_void 1029:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 268816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4A_MZZ_HtoD_PSEUDO),
     /* 268819 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 268821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 268823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 268825 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268829 */     GIR_RootConstrainSelectedInstOperands,
     /* 268830 */     // GIR_Coverage, 3628,
     /* 268830 */     GIR_EraseRootFromParent_Done,
     /* 268831 */   // Label 5209: @268831
     /* 268831 */   GIM_Try, /*On fail goto*//*Label 5210*/ GIMT_Encode4(268873), // Rule ID 3798 //
     /* 268836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_HasSME_MOP4),
     /* 268839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_1x1),
     /* 268844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 268847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 268850 */     // MIs[0] tile
     /* 268850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 268853 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 268858 */     // (intrinsic_void 922:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4A_MZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 268858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_H_PSEUDO),
     /* 268861 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 268863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 268865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 268867 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268871 */     GIR_RootConstrainSelectedInstOperands,
     /* 268872 */     // GIR_Coverage, 3798,
     /* 268872 */     GIR_EraseRootFromParent_Done,
     /* 268873 */   // Label 5210: @268873
     /* 268873 */   GIM_Try, /*On fail goto*//*Label 5211*/ GIMT_Encode4(268915), // Rule ID 3802 //
     /* 268878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F32_HasSME_MOP4),
     /* 268881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmop4a_za32_1x1),
     /* 268886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 268889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 268892 */     // MIs[0] tile
     /* 268892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 268895 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 268900 */     // (intrinsic_void 885:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOP4A_MZZ_BtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 268900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_BtoS_PSEUDO),
     /* 268903 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 268905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 268907 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 268909 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268913 */     GIR_RootConstrainSelectedInstOperands,
     /* 268914 */     // GIR_Coverage, 3802,
     /* 268914 */     GIR_EraseRootFromParent_Done,
     /* 268915 */   // Label 5211: @268915
     /* 268915 */   GIM_Try, /*On fail goto*//*Label 5212*/ GIMT_Encode4(268957), // Rule ID 3806 //
     /* 268920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 268923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_1x1),
     /* 268928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 268931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 268934 */     // MIs[0] tile
     /* 268934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 268937 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 268942 */     // (intrinsic_void 922:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOP4A_MZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 268942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_S_PSEUDO),
     /* 268945 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 268947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 268949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 268951 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268955 */     GIR_RootConstrainSelectedInstOperands,
     /* 268956 */     // GIR_Coverage, 3806,
     /* 268956 */     GIR_EraseRootFromParent_Done,
     /* 268957 */   // Label 5212: @268957
     /* 268957 */   GIM_Try, /*On fail goto*//*Label 5213*/ GIMT_Encode4(268999), // Rule ID 3810 //
     /* 268962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64_HasSME_MOP4),
     /* 268965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_1x1),
     /* 268970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 268973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 268976 */     // MIs[0] tile
     /* 268976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 268979 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 268984 */     // (intrinsic_void 922:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOP4A_MZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 268984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_D_PSEUDO),
     /* 268987 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 268989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 268991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 268993 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268997 */     GIR_RootConstrainSelectedInstOperands,
     /* 268998 */     // GIR_Coverage, 3810,
     /* 268998 */     GIR_EraseRootFromParent_Done,
     /* 268999 */   // Label 5213: @268999
     /* 268999 */   GIM_Try, /*On fail goto*//*Label 5214*/ GIMT_Encode4(269041), // Rule ID 3814 //
     /* 269004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_wide_1x1),
     /* 269012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269018 */     // MIs[0] tile
     /* 269018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269021 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269026 */     // (intrinsic_void 926:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4A_MZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 269026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_HtoS_PSEUDO),
     /* 269029 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269035 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269039 */     GIR_RootConstrainSelectedInstOperands,
     /* 269040 */     // GIR_Coverage, 3814,
     /* 269040 */     GIR_EraseRootFromParent_Done,
     /* 269041 */   // Label 5214: @269041
     /* 269041 */   GIM_Try, /*On fail goto*//*Label 5215*/ GIMT_Encode4(269083), // Rule ID 3818 //
     /* 269046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F16_HasSME_MOP4),
     /* 269049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmop4a_za16_1x1),
     /* 269054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 269057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 269060 */     // MIs[0] tile
     /* 269060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269063 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 269068 */     // (intrinsic_void 881:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOP4A_MZZ_BtoH_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 269068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_BtoH_PSEUDO),
     /* 269071 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269077 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269081 */     GIR_RootConstrainSelectedInstOperands,
     /* 269082 */     // GIR_Coverage, 3818,
     /* 269082 */     GIR_EraseRootFromParent_Done,
     /* 269083 */   // Label 5215: @269083
     /* 269083 */   GIM_Try, /*On fail goto*//*Label 5216*/ GIMT_Encode4(269125), // Rule ID 12723 //
     /* 269088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4s_wide_1x1),
     /* 269096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 269099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 269102 */     // MIs[0] tile
     /* 269102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269105 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269110 */     // (intrinsic_void 1033:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 269110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4S_MZZ_BToS_PSEUDO),
     /* 269113 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269117 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269119 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269123 */     GIR_RootConstrainSelectedInstOperands,
     /* 269124 */     // GIR_Coverage, 12723,
     /* 269124 */     GIR_EraseRootFromParent_Done,
     /* 269125 */   // Label 5216: @269125
     /* 269125 */   GIM_Try, /*On fail goto*//*Label 5217*/ GIMT_Encode4(269167), // Rule ID 12727 //
     /* 269130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4a_wide_1x1),
     /* 269138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 269141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 269144 */     // MIs[0] tile
     /* 269144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269147 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269152 */     // (intrinsic_void 1077:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 269152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4A_MZZ_BToS_PSEUDO),
     /* 269155 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269161 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269165 */     GIR_RootConstrainSelectedInstOperands,
     /* 269166 */     // GIR_Coverage, 12727,
     /* 269166 */     GIR_EraseRootFromParent_Done,
     /* 269167 */   // Label 5217: @269167
     /* 269167 */   GIM_Try, /*On fail goto*//*Label 5218*/ GIMT_Encode4(269209), // Rule ID 12731 //
     /* 269172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4s_wide_1x1),
     /* 269180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 269183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 269186 */     // MIs[0] tile
     /* 269186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269189 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269194 */     // (intrinsic_void 1085:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 269194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4S_MZZ_BToS_PSEUDO),
     /* 269197 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269201 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269203 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269207 */     GIR_RootConstrainSelectedInstOperands,
     /* 269208 */     // GIR_Coverage, 12731,
     /* 269208 */     GIR_EraseRootFromParent_Done,
     /* 269209 */   // Label 5218: @269209
     /* 269209 */   GIM_Try, /*On fail goto*//*Label 5219*/ GIMT_Encode4(269251), // Rule ID 12735 //
     /* 269214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4a_wide_1x1),
     /* 269222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 269225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 269228 */     // MIs[0] tile
     /* 269228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269231 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269236 */     // (intrinsic_void 1194:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 269236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4A_MZZ_BToS_PSEUDO),
     /* 269239 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269245 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269249 */     GIR_RootConstrainSelectedInstOperands,
     /* 269250 */     // GIR_Coverage, 12735,
     /* 269250 */     GIR_EraseRootFromParent_Done,
     /* 269251 */   // Label 5219: @269251
     /* 269251 */   GIM_Try, /*On fail goto*//*Label 5220*/ GIMT_Encode4(269293), // Rule ID 12739 //
     /* 269256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4s_wide_1x1),
     /* 269264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 269267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 269270 */     // MIs[0] tile
     /* 269270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269273 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269278 */     // (intrinsic_void 1202:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 269278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4S_MZZ_BToS_PSEUDO),
     /* 269281 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269287 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269291 */     GIR_RootConstrainSelectedInstOperands,
     /* 269292 */     // GIR_Coverage, 12739,
     /* 269292 */     GIR_EraseRootFromParent_Done,
     /* 269293 */   // Label 5220: @269293
     /* 269293 */   GIM_Try, /*On fail goto*//*Label 5221*/ GIMT_Encode4(269335), // Rule ID 12743 //
     /* 269298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4a_wide_1x1),
     /* 269306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 269309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 269312 */     // MIs[0] tile
     /* 269312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269315 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269320 */     // (intrinsic_void 1160:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 269320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4A_MZZ_BToS_PSEUDO),
     /* 269323 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269327 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269329 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269333 */     GIR_RootConstrainSelectedInstOperands,
     /* 269334 */     // GIR_Coverage, 12743,
     /* 269334 */     GIR_EraseRootFromParent_Done,
     /* 269335 */   // Label 5221: @269335
     /* 269335 */   GIM_Try, /*On fail goto*//*Label 5222*/ GIMT_Encode4(269377), // Rule ID 12747 //
     /* 269340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4s_wide_1x1),
     /* 269348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 269351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 269354 */     // MIs[0] tile
     /* 269354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269357 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269362 */     // (intrinsic_void 1168:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 269362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4S_MZZ_BToS_PSEUDO),
     /* 269365 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269371 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269375 */     GIR_RootConstrainSelectedInstOperands,
     /* 269376 */     // GIR_Coverage, 12747,
     /* 269376 */     GIR_EraseRootFromParent_Done,
     /* 269377 */   // Label 5222: @269377
     /* 269377 */   GIM_Try, /*On fail goto*//*Label 5223*/ GIMT_Encode4(269419), // Rule ID 12751 //
     /* 269382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4s_wide_1x1),
     /* 269390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269396 */     // MIs[0] tile
     /* 269396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269399 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269404 */     // (intrinsic_void 1033:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4S_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 269404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4S_MZZ_HToS_PSEUDO),
     /* 269407 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269413 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269417 */     GIR_RootConstrainSelectedInstOperands,
     /* 269418 */     // GIR_Coverage, 12751,
     /* 269418 */     GIR_EraseRootFromParent_Done,
     /* 269419 */   // Label 5223: @269419
     /* 269419 */   GIM_Try, /*On fail goto*//*Label 5224*/ GIMT_Encode4(269461), // Rule ID 12755 //
     /* 269424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4a_wide_1x1),
     /* 269432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269438 */     // MIs[0] tile
     /* 269438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269441 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269446 */     // (intrinsic_void 1160:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4A_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 269446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4A_MZZ_HToS_PSEUDO),
     /* 269449 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269459 */     GIR_RootConstrainSelectedInstOperands,
     /* 269460 */     // GIR_Coverage, 12755,
     /* 269460 */     GIR_EraseRootFromParent_Done,
     /* 269461 */   // Label 5224: @269461
     /* 269461 */   GIM_Try, /*On fail goto*//*Label 5225*/ GIMT_Encode4(269503), // Rule ID 12759 //
     /* 269466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4s_wide_1x1),
     /* 269474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269480 */     // MIs[0] tile
     /* 269480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269483 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269488 */     // (intrinsic_void 1168:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4S_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 269488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4S_MZZ_HToS_PSEUDO),
     /* 269491 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269495 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269497 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269501 */     GIR_RootConstrainSelectedInstOperands,
     /* 269502 */     // GIR_Coverage, 12759,
     /* 269502 */     GIR_EraseRootFromParent_Done,
     /* 269503 */   // Label 5225: @269503
     /* 269503 */   GIM_Try, /*On fail goto*//*Label 5226*/ GIMT_Encode4(269545), // Rule ID 12763 //
     /* 269508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 269511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4s_za64_wide_1x1),
     /* 269516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269522 */     // MIs[0] tile
     /* 269522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269525 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 269530 */     // (intrinsic_void 1037:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 269530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4S_MZZ_HtoD_PSEUDO),
     /* 269533 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269539 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269543 */     GIR_RootConstrainSelectedInstOperands,
     /* 269544 */     // GIR_Coverage, 12763,
     /* 269544 */     GIR_EraseRootFromParent_Done,
     /* 269545 */   // Label 5226: @269545
     /* 269545 */   GIM_Try, /*On fail goto*//*Label 5227*/ GIMT_Encode4(269587), // Rule ID 12767 //
     /* 269550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 269553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4a_za64_wide_1x1),
     /* 269558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269564 */     // MIs[0] tile
     /* 269564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269567 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 269572 */     // (intrinsic_void 1081:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 269572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4A_MZZ_HtoD_PSEUDO),
     /* 269575 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269579 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269581 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269585 */     GIR_RootConstrainSelectedInstOperands,
     /* 269586 */     // GIR_Coverage, 12767,
     /* 269586 */     GIR_EraseRootFromParent_Done,
     /* 269587 */   // Label 5227: @269587
     /* 269587 */   GIM_Try, /*On fail goto*//*Label 5228*/ GIMT_Encode4(269629), // Rule ID 12771 //
     /* 269592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 269595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4s_za64_wide_1x1),
     /* 269600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269606 */     // MIs[0] tile
     /* 269606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269609 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 269614 */     // (intrinsic_void 1089:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 269614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4S_MZZ_HtoD_PSEUDO),
     /* 269617 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269623 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269627 */     GIR_RootConstrainSelectedInstOperands,
     /* 269628 */     // GIR_Coverage, 12771,
     /* 269628 */     GIR_EraseRootFromParent_Done,
     /* 269629 */   // Label 5228: @269629
     /* 269629 */   GIM_Try, /*On fail goto*//*Label 5229*/ GIMT_Encode4(269671), // Rule ID 12775 //
     /* 269634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 269637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4a_za64_wide_1x1),
     /* 269642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269648 */     // MIs[0] tile
     /* 269648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269651 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 269656 */     // (intrinsic_void 1164:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 269656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4A_MZZ_HtoD_PSEUDO),
     /* 269659 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269665 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269669 */     GIR_RootConstrainSelectedInstOperands,
     /* 269670 */     // GIR_Coverage, 12775,
     /* 269670 */     GIR_EraseRootFromParent_Done,
     /* 269671 */   // Label 5229: @269671
     /* 269671 */   GIM_Try, /*On fail goto*//*Label 5230*/ GIMT_Encode4(269713), // Rule ID 12779 //
     /* 269676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 269679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4s_za64_wide_1x1),
     /* 269684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269690 */     // MIs[0] tile
     /* 269690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269693 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 269698 */     // (intrinsic_void 1172:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 269698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4S_MZZ_HtoD_PSEUDO),
     /* 269701 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269711 */     GIR_RootConstrainSelectedInstOperands,
     /* 269712 */     // GIR_Coverage, 12779,
     /* 269712 */     GIR_EraseRootFromParent_Done,
     /* 269713 */   // Label 5230: @269713
     /* 269713 */   GIM_Try, /*On fail goto*//*Label 5231*/ GIMT_Encode4(269755), // Rule ID 12783 //
     /* 269718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 269721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4a_za64_wide_1x1),
     /* 269726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269732 */     // MIs[0] tile
     /* 269732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269735 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 269740 */     // (intrinsic_void 1198:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 269740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4A_MZZ_HtoD_PSEUDO),
     /* 269743 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269747 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269749 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269753 */     GIR_RootConstrainSelectedInstOperands,
     /* 269754 */     // GIR_Coverage, 12783,
     /* 269754 */     GIR_EraseRootFromParent_Done,
     /* 269755 */   // Label 5231: @269755
     /* 269755 */   GIM_Try, /*On fail goto*//*Label 5232*/ GIMT_Encode4(269797), // Rule ID 12787 //
     /* 269760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 269763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4s_za64_wide_1x1),
     /* 269768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269774 */     // MIs[0] tile
     /* 269774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269777 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 269782 */     // (intrinsic_void 1206:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 269782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4S_MZZ_HtoD_PSEUDO),
     /* 269785 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269791 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269795 */     GIR_RootConstrainSelectedInstOperands,
     /* 269796 */     // GIR_Coverage, 12787,
     /* 269796 */     GIR_EraseRootFromParent_Done,
     /* 269797 */   // Label 5232: @269797
     /* 269797 */   GIM_Try, /*On fail goto*//*Label 5233*/ GIMT_Encode4(269839), // Rule ID 13242 //
     /* 269802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_wide_1x1),
     /* 269810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269816 */     // MIs[0] tile
     /* 269816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269819 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269824 */     // (intrinsic_void 934:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4S_MZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 269824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_HtoS_PSEUDO),
     /* 269827 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269831 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269833 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269837 */     GIR_RootConstrainSelectedInstOperands,
     /* 269838 */     // GIR_Coverage, 13242,
     /* 269838 */     GIR_EraseRootFromParent_Done,
     /* 269839 */   // Label 5233: @269839
     /* 269839 */   GIM_Try, /*On fail goto*//*Label 5234*/ GIMT_Encode4(269881), // Rule ID 13246 //
     /* 269844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_1x1),
     /* 269852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 269855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 269858 */     // MIs[0] tile
     /* 269858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269861 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269866 */     // (intrinsic_void 930:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOP4S_MZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 269866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_S_PSEUDO),
     /* 269869 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269873 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269875 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269879 */     GIR_RootConstrainSelectedInstOperands,
     /* 269880 */     // GIR_Coverage, 13246,
     /* 269880 */     GIR_EraseRootFromParent_Done,
     /* 269881 */   // Label 5234: @269881
     /* 269881 */   GIM_Try, /*On fail goto*//*Label 5235*/ GIMT_Encode4(269923), // Rule ID 13250 //
     /* 269886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_HasSME_MOP4),
     /* 269889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_1x1),
     /* 269894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269900 */     // MIs[0] tile
     /* 269900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269903 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 269908 */     // (intrinsic_void 930:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4S_MZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 269908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_H_PSEUDO),
     /* 269911 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269917 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269921 */     GIR_RootConstrainSelectedInstOperands,
     /* 269922 */     // GIR_Coverage, 13250,
     /* 269922 */     GIR_EraseRootFromParent_Done,
     /* 269923 */   // Label 5235: @269923
     /* 269923 */   GIM_Try, /*On fail goto*//*Label 5236*/ GIMT_Encode4(269965), // Rule ID 13254 //
     /* 269928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64_HasSME_MOP4),
     /* 269931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_1x1),
     /* 269936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 269939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 269942 */     // MIs[0] tile
     /* 269942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269945 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 269950 */     // (intrinsic_void 930:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOP4S_MZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 269950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_D_PSEUDO),
     /* 269953 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269957 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269959 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269963 */     GIR_RootConstrainSelectedInstOperands,
     /* 269964 */     // GIR_Coverage, 13254,
     /* 269964 */     GIR_EraseRootFromParent_Done,
     /* 269965 */   // Label 5236: @269965
     /* 269965 */   GIM_Try, /*On fail goto*//*Label 5237*/ GIMT_Encode4(270019), // Rule ID 8966 //
     /* 269970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 269978 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 269981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 269985 */     // MIs[0] base
     /* 269985 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 269989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269993 */     // MIs[0] prfop
     /* 269993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 269996 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 270001 */     // (intrinsic_void 1644:{ *:[iPTR] }, PPR_3b:{ *:[nxv16i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv16i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 270001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_PRI),
     /* 270004 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 270006 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 270008 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 270010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 270013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270017 */     GIR_RootConstrainSelectedInstOperands,
     /* 270018 */     // GIR_Coverage, 8966,
     /* 270018 */     GIR_EraseRootFromParent_Done,
     /* 270019 */   // Label 5237: @270019
     /* 270019 */   GIM_Try, /*On fail goto*//*Label 5238*/ GIMT_Encode4(270073), // Rule ID 8969 //
     /* 270024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 270027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 270032 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 270035 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270039 */     // MIs[0] base
     /* 270039 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 270043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270047 */     // MIs[0] prfop
     /* 270047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 270050 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 270055 */     // (intrinsic_void 1644:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv8i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 270055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_PRI),
     /* 270058 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 270060 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 270062 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 270064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 270067 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270071 */     GIR_RootConstrainSelectedInstOperands,
     /* 270072 */     // GIR_Coverage, 8969,
     /* 270072 */     GIR_EraseRootFromParent_Done,
     /* 270073 */   // Label 5238: @270073
     /* 270073 */   GIM_Try, /*On fail goto*//*Label 5239*/ GIMT_Encode4(270127), // Rule ID 8972 //
     /* 270078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 270081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 270086 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 270089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270093 */     // MIs[0] base
     /* 270093 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 270097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270101 */     // MIs[0] prfop
     /* 270101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 270104 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 270109 */     // (intrinsic_void 1644:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv4i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 270109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_PRI),
     /* 270112 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 270114 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 270116 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 270118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 270121 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270125 */     GIR_RootConstrainSelectedInstOperands,
     /* 270126 */     // GIR_Coverage, 8972,
     /* 270126 */     GIR_EraseRootFromParent_Done,
     /* 270127 */   // Label 5239: @270127
     /* 270127 */   GIM_Try, /*On fail goto*//*Label 5240*/ GIMT_Encode4(270181), // Rule ID 8975 //
     /* 270132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 270135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 270140 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 270143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270147 */     // MIs[0] base
     /* 270147 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 270151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270155 */     // MIs[0] prfop
     /* 270155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 270158 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 270163 */     // (intrinsic_void 1644:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv2i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 270163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_PRI),
     /* 270166 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 270168 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 270170 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 270172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 270175 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270179 */     GIR_RootConstrainSelectedInstOperands,
     /* 270180 */     // GIR_Coverage, 8975,
     /* 270180 */     GIR_EraseRootFromParent_Done,
     /* 270181 */   // Label 5240: @270181
     /* 270181 */   GIM_Try, /*On fail goto*//*Label 5241*/ GIMT_Encode4(270235), // Rule ID 15 //
     /* 270186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_space),
     /* 270191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 270194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 270197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 270200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270212 */     // MIs[1] Operand 1
     /* 270212 */     // No operand predicates
     /* 270212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270218 */     // (intrinsic_w_chain:{ *:[i64] } 1242:{ *:[iPTR] }, (imm:{ *:[i32] }):$size, GPR64:{ *:[i64] }:$Rn)  =>  (SPACE:{ *:[i64] } (imm:{ *:[i32] }):$size, GPR64:{ *:[i64] }:$Rn)
     /* 270218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SPACE),
     /* 270221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // size
     /* 270226 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 270228 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 270233 */     GIR_RootConstrainSelectedInstOperands,
     /* 270234 */     // GIR_Coverage, 15,
     /* 270234 */     GIR_EraseRootFromParent_Done,
     /* 270235 */   // Label 5241: @270235
     /* 270235 */   GIM_Try, /*On fail goto*//*Label 5242*/ GIMT_Encode4(270303), // Rule ID 68 //
     /* 270240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess),
     /* 270245 */     // MIs[0] Operand 1
     /* 270245 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 270249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64_with_sub_32_in_MatrixIndexGPR32_8_11RegClassID),
     /* 270253 */     // MIs[0] ptr
     /* 270253 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 270257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 270261 */     // MIs[0] accessinfo
     /* 270261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 270264 */     // (intrinsic_void 193:{ *:[iPTR] }, X9:{ *:[i64] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
     /* 270264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270268 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::X9), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270274 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X9
     /* 270278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS),
     /* 270281 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 270283 */     GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
     /* 270285 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 270288 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 270291 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 270294 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 270297 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270301 */     GIR_RootConstrainSelectedInstOperands,
     /* 270302 */     // GIR_Coverage, 68,
     /* 270302 */     GIR_EraseRootFromParent_Done,
     /* 270303 */   // Label 5242: @270303
     /* 270303 */   GIM_Try, /*On fail goto*//*Label 5243*/ GIMT_Encode4(270371), // Rule ID 69 //
     /* 270308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules),
     /* 270313 */     // MIs[0] Operand 1
     /* 270313 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 270317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64common_and_GPR64noipRegClassID),
     /* 270321 */     // MIs[0] ptr
     /* 270321 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 270325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 270329 */     // MIs[0] accessinfo
     /* 270329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 270332 */     // (intrinsic_void 195:{ *:[iPTR] }, X20:{ *:[i64] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
     /* 270332 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270336 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::X20), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270342 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X20
     /* 270346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_SHORTGRANULES),
     /* 270349 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 270351 */     GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
     /* 270353 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 270356 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 270359 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 270362 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 270365 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270369 */     GIR_RootConstrainSelectedInstOperands,
     /* 270370 */     // GIR_Coverage, 69,
     /* 270370 */     GIR_EraseRootFromParent_Done,
     /* 270371 */   // Label 5243: @270371
     /* 270371 */   GIM_Try, /*On fail goto*//*Label 5244*/ GIMT_Encode4(270451), // Rule ID 7188 //
     /* 270376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 270381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 270384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270395 */     // MIs[0] addr
     /* 270395 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 270399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270403 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 270407 */     // (intrinsic_w_chain:{ *:[i32] } 1251:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 270407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 270410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270419 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 270425 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270430 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 270438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 270440 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270443 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 270445 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270449 */     GIR_RootConstrainSelectedInstOperands,
     /* 270450 */     // GIR_Coverage, 7188,
     /* 270450 */     GIR_EraseRootFromParent_Done,
     /* 270451 */   // Label 5244: @270451
     /* 270451 */   GIM_Try, /*On fail goto*//*Label 5245*/ GIMT_Encode4(270531), // Rule ID 7189 //
     /* 270456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 270461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 270464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270475 */     // MIs[0] addr
     /* 270475 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 270479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270483 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 270487 */     // (intrinsic_w_chain:{ *:[i32] } 1251:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 270487 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 270490 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270494 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270499 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 270505 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270510 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 270518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 270520 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270523 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 270525 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270529 */     GIR_RootConstrainSelectedInstOperands,
     /* 270530 */     // GIR_Coverage, 7189,
     /* 270530 */     GIR_EraseRootFromParent_Done,
     /* 270531 */   // Label 5245: @270531
     /* 270531 */   GIM_Try, /*On fail goto*//*Label 5246*/ GIMT_Encode4(270611), // Rule ID 7190 //
     /* 270536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 270541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 270544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270555 */     // MIs[0] addr
     /* 270555 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 270559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270563 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 270567 */     // (intrinsic_w_chain:{ *:[i32] } 1251:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 270567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 270570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270579 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 270585 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270590 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 270598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 270600 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270603 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 270605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270609 */     GIR_RootConstrainSelectedInstOperands,
     /* 270610 */     // GIR_Coverage, 7190,
     /* 270610 */     GIR_EraseRootFromParent_Done,
     /* 270611 */   // Label 5246: @270611
     /* 270611 */   GIM_Try, /*On fail goto*//*Label 5247*/ GIMT_Encode4(270662), // Rule ID 7191 //
     /* 270616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 270621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 270624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270635 */     // MIs[0] addr
     /* 270635 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 270639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270643 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_8),
     /* 270647 */     // (intrinsic_w_chain:{ *:[i32] } 1251:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_8>>  =>  (STXRX:{ *:[i32] } GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 270647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRX),
     /* 270650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 270652 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /* 270654 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 270656 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270660 */     GIR_RootConstrainSelectedInstOperands,
     /* 270661 */     // GIR_Coverage, 7191,
     /* 270661 */     GIR_EraseRootFromParent_Done,
     /* 270662 */   // Label 5247: @270662
     /* 270662 */   GIM_Try, /*On fail goto*//*Label 5248*/ GIMT_Encode4(270742), // Rule ID 7198 //
     /* 270667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 270672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 270675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270686 */     // MIs[0] addr
     /* 270686 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 270690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270694 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 270698 */     // (intrinsic_w_chain:{ *:[i32] } 1249:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 270698 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 270701 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270705 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270710 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 270716 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270721 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 270729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 270731 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270734 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 270736 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270740 */     GIR_RootConstrainSelectedInstOperands,
     /* 270741 */     // GIR_Coverage, 7198,
     /* 270741 */     GIR_EraseRootFromParent_Done,
     /* 270742 */   // Label 5248: @270742
     /* 270742 */   GIM_Try, /*On fail goto*//*Label 5249*/ GIMT_Encode4(270822), // Rule ID 7199 //
     /* 270747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 270752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 270755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270766 */     // MIs[0] addr
     /* 270766 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 270770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270774 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 270778 */     // (intrinsic_w_chain:{ *:[i32] } 1249:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 270778 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 270781 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270785 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270790 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 270796 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270801 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 270809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 270811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270814 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 270816 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270820 */     GIR_RootConstrainSelectedInstOperands,
     /* 270821 */     // GIR_Coverage, 7199,
     /* 270821 */     GIR_EraseRootFromParent_Done,
     /* 270822 */   // Label 5249: @270822
     /* 270822 */   GIM_Try, /*On fail goto*//*Label 5250*/ GIMT_Encode4(270902), // Rule ID 7200 //
     /* 270827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 270832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 270835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270846 */     // MIs[0] addr
     /* 270846 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 270850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270854 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 270858 */     // (intrinsic_w_chain:{ *:[i32] } 1249:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 270858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 270861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270870 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 270876 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270881 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 270889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 270891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270894 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 270896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270900 */     GIR_RootConstrainSelectedInstOperands,
     /* 270901 */     // GIR_Coverage, 7200,
     /* 270901 */     GIR_EraseRootFromParent_Done,
     /* 270902 */   // Label 5250: @270902
     /* 270902 */   GIM_Try, /*On fail goto*//*Label 5251*/ GIMT_Encode4(270953), // Rule ID 7201 //
     /* 270907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 270912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 270915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270926 */     // MIs[0] addr
     /* 270926 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 270930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270934 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_8),
     /* 270938 */     // (intrinsic_w_chain:{ *:[i32] } 1249:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_8>>  =>  (STLXRX:{ *:[i32] } GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 270938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRX),
     /* 270941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 270943 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /* 270945 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 270947 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270951 */     GIR_RootConstrainSelectedInstOperands,
     /* 270952 */     // GIR_Coverage, 7201,
     /* 270952 */     GIR_EraseRootFromParent_Done,
     /* 270953 */   // Label 5251: @270953
     /* 270953 */   GIM_Try, /*On fail goto*//*Label 5252*/ GIMT_Encode4(271002), // Rule ID 2484 //
     /* 270958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 270961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 270966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 270969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 270972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 270975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270987 */     // (intrinsic_w_chain:{ *:[v8i8] } 623:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCVTN_F16v8f8:{ *:[v8i8] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 270987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F16v8f8),
     /* 270990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 270994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 270996 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271000 */     GIR_RootConstrainSelectedInstOperands,
     /* 271001 */     // GIR_Coverage, 2484,
     /* 271001 */     GIR_EraseRootFromParent_Done,
     /* 271002 */   // Label 5252: @271002
     /* 271002 */   GIM_Try, /*On fail goto*//*Label 5253*/ GIMT_Encode4(271051), // Rule ID 2485 //
     /* 271007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 271010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 271015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 271018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 271021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 271024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271036 */     // (intrinsic_w_chain:{ *:[v16i8] } 623:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTN_F16v16f8:{ *:[v16i8] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 271036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F16v16f8),
     /* 271039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271043 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 271045 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271049 */     GIR_RootConstrainSelectedInstOperands,
     /* 271050 */     // GIR_Coverage, 2485,
     /* 271050 */     GIR_EraseRootFromParent_Done,
     /* 271051 */   // Label 5253: @271051
     /* 271051 */   GIM_Try, /*On fail goto*//*Label 5254*/ GIMT_Encode4(271100), // Rule ID 2486 //
     /* 271056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 271059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 271064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 271067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 271070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 271073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271085 */     // (intrinsic_w_chain:{ *:[v8i8] } 623:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCVTN_F32v8f8:{ *:[v8i8] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 271085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F32v8f8),
     /* 271088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 271094 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271098 */     GIR_RootConstrainSelectedInstOperands,
     /* 271099 */     // GIR_Coverage, 2486,
     /* 271099 */     GIR_EraseRootFromParent_Done,
     /* 271100 */   // Label 5254: @271100
     /* 271100 */   GIM_Try, /*On fail goto*//*Label 5255*/ GIMT_Encode4(271153), // Rule ID 8852 //
     /* 271105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1uwq),
     /* 271113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 271116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 271119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271127 */     // MIs[0] base
     /* 271127 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 271131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271135 */     // (intrinsic_w_chain:{ *:[nxv4i32] } 1577:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1W_Q_IMM:{ *:[nxv4i32] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 271135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_Q_IMM),
     /* 271138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 271140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 271142 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 271144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 271147 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271151 */     GIR_RootConstrainSelectedInstOperands,
     /* 271152 */     // GIR_Coverage, 8852,
     /* 271152 */     GIR_EraseRootFromParent_Done,
     /* 271153 */   // Label 5255: @271153
     /* 271153 */   GIM_Try, /*On fail goto*//*Label 5256*/ GIMT_Encode4(271206), // Rule ID 8855 //
     /* 271158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1uwq),
     /* 271166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 271169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 271172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271180 */     // MIs[0] base
     /* 271180 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 271184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271188 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1577:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1W_Q_IMM:{ *:[nxv4f32] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 271188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_Q_IMM),
     /* 271191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 271193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 271195 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 271197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 271200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271204 */     GIR_RootConstrainSelectedInstOperands,
     /* 271205 */     // GIR_Coverage, 8855,
     /* 271205 */     GIR_EraseRootFromParent_Done,
     /* 271206 */   // Label 5256: @271206
     /* 271206 */   GIM_Try, /*On fail goto*//*Label 5257*/ GIMT_Encode4(271259), // Rule ID 8864 //
     /* 271211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1udq),
     /* 271219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 271222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 271225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271233 */     // MIs[0] base
     /* 271233 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 271237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271241 */     // (intrinsic_w_chain:{ *:[nxv2i64] } 1576:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1D_Q_IMM:{ *:[nxv2i64] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 271241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_Q_IMM),
     /* 271244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 271246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 271248 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 271250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 271253 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271257 */     GIR_RootConstrainSelectedInstOperands,
     /* 271258 */     // GIR_Coverage, 8864,
     /* 271258 */     GIR_EraseRootFromParent_Done,
     /* 271259 */   // Label 5257: @271259
     /* 271259 */   GIM_Try, /*On fail goto*//*Label 5258*/ GIMT_Encode4(271312), // Rule ID 8867 //
     /* 271264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1udq),
     /* 271272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 271275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 271278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271286 */     // MIs[0] base
     /* 271286 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 271290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271294 */     // (intrinsic_w_chain:{ *:[nxv2f64] } 1576:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1D_Q_IMM:{ *:[nxv2f64] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 271294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_Q_IMM),
     /* 271297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 271299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 271301 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 271303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 271306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271310 */     GIR_RootConstrainSelectedInstOperands,
     /* 271311 */     // GIR_Coverage, 8867,
     /* 271311 */     GIR_EraseRootFromParent_Done,
     /* 271312 */   // Label 5258: @271312
     /* 271312 */   GIM_Try, /*On fail goto*//*Label 5259*/ GIMT_Encode4(271358), // Rule ID 137 //
     /* 271317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 271320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_irg),
     /* 271325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 271328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 271331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271335 */     // MIs[0] Rn
     /* 271335 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 271339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271347 */     // (intrinsic_w_chain:{ *:[i64] } 568:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (IRG:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 271347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::IRG),
     /* 271350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 271356 */     GIR_RootConstrainSelectedInstOperands,
     /* 271357 */     // GIR_Coverage, 137,
     /* 271357 */     GIR_EraseRootFromParent_Done,
     /* 271358 */   // Label 5259: @271358
     /* 271358 */   GIM_Try, /*On fail goto*//*Label 5260*/ GIMT_Encode4(271411), // Rule ID 8858 //
     /* 271363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1wq),
     /* 271371 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 271374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 271377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271385 */     // MIs[0] base
     /* 271385 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 271389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271393 */     // (intrinsic_void 1897:{ *:[iPTR] }, ZPR128:{ *:[nxv4i32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1W_Q_IMM Z_q:{ *:[nxv4i32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 271393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_Q_IMM),
     /* 271396 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 271398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 271400 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 271402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 271405 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271409 */     GIR_RootConstrainSelectedInstOperands,
     /* 271410 */     // GIR_Coverage, 8858,
     /* 271410 */     GIR_EraseRootFromParent_Done,
     /* 271411 */   // Label 5260: @271411
     /* 271411 */   GIM_Try, /*On fail goto*//*Label 5261*/ GIMT_Encode4(271464), // Rule ID 8861 //
     /* 271416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1wq),
     /* 271424 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 271427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 271430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271438 */     // MIs[0] base
     /* 271438 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 271442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271446 */     // (intrinsic_void 1897:{ *:[iPTR] }, ZPR128:{ *:[nxv4f32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1W_Q_IMM Z_q:{ *:[nxv4f32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 271446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_Q_IMM),
     /* 271449 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 271451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 271453 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 271455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 271458 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271462 */     GIR_RootConstrainSelectedInstOperands,
     /* 271463 */     // GIR_Coverage, 8861,
     /* 271463 */     GIR_EraseRootFromParent_Done,
     /* 271464 */   // Label 5261: @271464
     /* 271464 */   GIM_Try, /*On fail goto*//*Label 5262*/ GIMT_Encode4(271517), // Rule ID 8870 //
     /* 271469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1dq),
     /* 271477 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 271480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 271483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271491 */     // MIs[0] base
     /* 271491 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 271495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271499 */     // (intrinsic_void 1893:{ *:[iPTR] }, ZPR128:{ *:[nxv2i64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1D_Q_IMM Z_q:{ *:[nxv2i64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 271499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_Q_IMM),
     /* 271502 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 271504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 271506 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 271508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 271511 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271515 */     GIR_RootConstrainSelectedInstOperands,
     /* 271516 */     // GIR_Coverage, 8870,
     /* 271516 */     GIR_EraseRootFromParent_Done,
     /* 271517 */   // Label 5262: @271517
     /* 271517 */   GIM_Try, /*On fail goto*//*Label 5263*/ GIMT_Encode4(271570), // Rule ID 8873 //
     /* 271522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1dq),
     /* 271530 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 271533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 271536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271544 */     // MIs[0] base
     /* 271544 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 271548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271552 */     // (intrinsic_void 1893:{ *:[iPTR] }, ZPR128:{ *:[nxv2f64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1D_Q_IMM Z_q:{ *:[nxv2f64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 271552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_Q_IMM),
     /* 271555 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 271557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 271559 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 271561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 271564 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271568 */     GIR_RootConstrainSelectedInstOperands,
     /* 271569 */     // GIR_Coverage, 8873,
     /* 271569 */     GIR_EraseRootFromParent_Done,
     /* 271570 */   // Label 5263: @271570
     /* 271570 */   GIM_Reject,
     /* 271571 */ // Label 5192: @271571
     /* 271571 */ GIM_Try, /*On fail goto*//*Label 5264*/ GIMT_Encode4(274276),
     /* 271576 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 271579 */   GIM_Try, /*On fail goto*//*Label 5265*/ GIMT_Encode4(271650), // Rule ID 3427 //
     /* 271584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 271587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_scalar_offset),
     /* 271592 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 271595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 271598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 271601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 271613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 271617 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 271621 */     // MIs[1] Operand 1
     /* 271621 */     // No operand predicates
     /* 271621 */     // MIs[0] prfop
     /* 271621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 271624 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 271629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271631 */     // (intrinsic_void 1646:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR32:{ *:[nxv4i32] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_PZI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR32:{ *:[nxv4i32] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 271631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_PZI),
     /* 271634 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 271636 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 271638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271640 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 271643 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 271648 */     GIR_RootConstrainSelectedInstOperands,
     /* 271649 */     // GIR_Coverage, 3427,
     /* 271649 */     GIR_EraseRootFromParent_Done,
     /* 271650 */   // Label 5265: @271650
     /* 271650 */   GIM_Try, /*On fail goto*//*Label 5266*/ GIMT_Encode4(271721), // Rule ID 3440 //
     /* 271655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 271658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_scalar_offset),
     /* 271663 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 271666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 271669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 271672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 271684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 271688 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 271692 */     // MIs[1] Operand 1
     /* 271692 */     // No operand predicates
     /* 271692 */     // MIs[0] prfop
     /* 271692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 271695 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 271700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271702 */     // (intrinsic_void 1646:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR32:{ *:[nxv2i64] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_PZI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR32:{ *:[nxv2i64] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 271702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_PZI),
     /* 271705 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 271707 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 271709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271711 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 271714 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 271719 */     GIR_RootConstrainSelectedInstOperands,
     /* 271720 */     // GIR_Coverage, 3440,
     /* 271720 */     GIR_EraseRootFromParent_Done,
     /* 271721 */   // Label 5266: @271721
     /* 271721 */   GIM_Try, /*On fail goto*//*Label 5267*/ GIMT_Encode4(271780), // Rule ID 3632 //
     /* 271726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 271729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addha),
     /* 271734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 271737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 271740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 271743 */     // MIs[0] tile
     /* 271743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271746 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 271751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271763 */     // (intrinsic_void 807:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$pn, PPR3bAny:{ *:[nxv4i1] }:$pm, ZPR32:{ *:[nxv4i32] }:$zn)  =>  (ADDHA_MPPZ_S_PSEUDO_S (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, ?:{ *:[nxv4i1] }:$pn, ?:{ *:[nxv4i1] }:$pm, ?:{ *:[nxv4i32] }:$zn)
     /* 271763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHA_MPPZ_S_PSEUDO_S),
     /* 271766 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271768 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 271770 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 271772 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 271774 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271778 */     GIR_RootConstrainSelectedInstOperands,
     /* 271779 */     // GIR_Coverage, 3632,
     /* 271779 */     GIR_EraseRootFromParent_Done,
     /* 271780 */   // Label 5267: @271780
     /* 271780 */   GIM_Try, /*On fail goto*//*Label 5268*/ GIMT_Encode4(271839), // Rule ID 3633 //
     /* 271785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 271788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addha),
     /* 271793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 271796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 271799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 271802 */     // MIs[0] tile
     /* 271802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271805 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 271810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271822 */     // (intrinsic_void 807:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$pn, PPR3bAny:{ *:[nxv2i1] }:$pm, ZPR64:{ *:[nxv2i64] }:$zn)  =>  (ADDHA_MPPZ_D_PSEUDO_D (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, ?:{ *:[nxv2i1] }:$pn, ?:{ *:[nxv2i1] }:$pm, ?:{ *:[nxv2i64] }:$zn)
     /* 271822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHA_MPPZ_D_PSEUDO_D),
     /* 271825 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271827 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 271829 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 271831 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 271833 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271837 */     GIR_RootConstrainSelectedInstOperands,
     /* 271838 */     // GIR_Coverage, 3633,
     /* 271838 */     GIR_EraseRootFromParent_Done,
     /* 271839 */   // Label 5268: @271839
     /* 271839 */   GIM_Try, /*On fail goto*//*Label 5269*/ GIMT_Encode4(271898), // Rule ID 12704 //
     /* 271844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 271847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addva),
     /* 271852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 271855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 271858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 271861 */     // MIs[0] tile
     /* 271861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271864 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 271869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271881 */     // (intrinsic_void 808:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$pn, PPR3bAny:{ *:[nxv4i1] }:$pm, ZPR32:{ *:[nxv4i32] }:$zn)  =>  (ADDVA_MPPZ_S_PSEUDO_S (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, ?:{ *:[nxv4i1] }:$pn, ?:{ *:[nxv4i1] }:$pm, ?:{ *:[nxv4i32] }:$zn)
     /* 271881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVA_MPPZ_S_PSEUDO_S),
     /* 271884 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271886 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 271888 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 271890 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 271892 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271896 */     GIR_RootConstrainSelectedInstOperands,
     /* 271897 */     // GIR_Coverage, 12704,
     /* 271897 */     GIR_EraseRootFromParent_Done,
     /* 271898 */   // Label 5269: @271898
     /* 271898 */   GIM_Try, /*On fail goto*//*Label 5270*/ GIMT_Encode4(271957), // Rule ID 12705 //
     /* 271903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 271906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addva),
     /* 271911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 271914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 271917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 271920 */     // MIs[0] tile
     /* 271920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271923 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 271928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271940 */     // (intrinsic_void 808:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$pn, PPR3bAny:{ *:[nxv2i1] }:$pm, ZPR64:{ *:[nxv2i64] }:$zn)  =>  (ADDVA_MPPZ_D_PSEUDO_D (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, ?:{ *:[nxv2i1] }:$pn, ?:{ *:[nxv2i1] }:$pm, ?:{ *:[nxv2i64] }:$zn)
     /* 271940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVA_MPPZ_D_PSEUDO_D),
     /* 271943 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271945 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 271947 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 271949 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 271951 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271955 */     GIR_RootConstrainSelectedInstOperands,
     /* 271956 */     // GIR_Coverage, 12705,
     /* 271956 */     GIR_EraseRootFromParent_Done,
     /* 271957 */   // Label 5270: @271957
     /* 271957 */   GIM_Try, /*On fail goto*//*Label 5271*/ GIMT_Encode4(272017), // Rule ID 3425 //
     /* 271962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 271965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_uxtw_index),
     /* 271970 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 271973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 271976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271980 */     // MIs[0] Rn
     /* 271980 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 271984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271992 */     // MIs[0] prfop
     /* 271992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 271995 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272000 */     // (intrinsic_void 1648:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW8Only:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW8Only:{ *:[nxv4i32] }:$Zm)
     /* 272000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_UXTW_SCALED),
     /* 272003 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272005 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272009 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272011 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272015 */     GIR_RootConstrainSelectedInstOperands,
     /* 272016 */     // GIR_Coverage, 3425,
     /* 272016 */     GIR_EraseRootFromParent_Done,
     /* 272017 */   // Label 5271: @272017
     /* 272017 */   GIM_Try, /*On fail goto*//*Label 5272*/ GIMT_Encode4(272077), // Rule ID 3426 //
     /* 272022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_sxtw_index),
     /* 272030 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 272033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 272036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272040 */     // MIs[0] Rn
     /* 272040 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272052 */     // MIs[0] prfop
     /* 272052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272055 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272060 */     // (intrinsic_void 1647:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW8Only:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW8Only:{ *:[nxv4i32] }:$Zm)
     /* 272060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_SXTW_SCALED),
     /* 272063 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272065 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272071 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272075 */     GIR_RootConstrainSelectedInstOperands,
     /* 272076 */     // GIR_Coverage, 3426,
     /* 272076 */     GIR_EraseRootFromParent_Done,
     /* 272077 */   // Label 5272: @272077
     /* 272077 */   GIM_Try, /*On fail goto*//*Label 5273*/ GIMT_Encode4(272137), // Rule ID 3437 //
     /* 272082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_uxtw_index),
     /* 272090 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 272093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 272096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272100 */     // MIs[0] Rn
     /* 272100 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272112 */     // MIs[0] prfop
     /* 272112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272115 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272120 */     // (intrinsic_void 1648:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW8Only:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW8Only:{ *:[nxv2i64] }:$Zm)
     /* 272120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_UXTW_SCALED),
     /* 272123 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272125 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272129 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272135 */     GIR_RootConstrainSelectedInstOperands,
     /* 272136 */     // GIR_Coverage, 3437,
     /* 272136 */     GIR_EraseRootFromParent_Done,
     /* 272137 */   // Label 5273: @272137
     /* 272137 */   GIM_Try, /*On fail goto*//*Label 5274*/ GIMT_Encode4(272197), // Rule ID 3438 //
     /* 272142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_sxtw_index),
     /* 272150 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 272153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 272156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272160 */     // MIs[0] Rn
     /* 272160 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272172 */     // MIs[0] prfop
     /* 272172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272175 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272180 */     // (intrinsic_void 1647:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW8Only:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW8Only:{ *:[nxv2i64] }:$Zm)
     /* 272180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_SXTW_SCALED),
     /* 272183 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272185 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272191 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272195 */     GIR_RootConstrainSelectedInstOperands,
     /* 272196 */     // GIR_Coverage, 3438,
     /* 272196 */     GIR_EraseRootFromParent_Done,
     /* 272197 */   // Label 5274: @272197
     /* 272197 */   GIM_Try, /*On fail goto*//*Label 5275*/ GIMT_Encode4(272257), // Rule ID 3439 //
     /* 272202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_index),
     /* 272210 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 272213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 272216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272220 */     // MIs[0] Rn
     /* 272220 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272232 */     // MIs[0] prfop
     /* 272232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272235 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272240 */     // (intrinsic_void 1645:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL8:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL8:{ *:[nxv2i64] }:$Zm)
     /* 272240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_SCALED),
     /* 272243 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272245 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272251 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272255 */     GIR_RootConstrainSelectedInstOperands,
     /* 272256 */     // GIR_Coverage, 3439,
     /* 272256 */     GIR_EraseRootFromParent_Done,
     /* 272257 */   // Label 5275: @272257
     /* 272257 */   GIM_Try, /*On fail goto*//*Label 5276*/ GIMT_Encode4(272317), // Rule ID 8978 //
     /* 272262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_uxtw_index),
     /* 272270 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 272273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 272276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272280 */     // MIs[0] Rn
     /* 272280 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272292 */     // MIs[0] prfop
     /* 272292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272295 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272300 */     // (intrinsic_void 1656:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW16:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW16:{ *:[nxv4i32] }:$Zm)
     /* 272300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_S_UXTW_SCALED),
     /* 272303 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272305 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272309 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272311 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272315 */     GIR_RootConstrainSelectedInstOperands,
     /* 272316 */     // GIR_Coverage, 8978,
     /* 272316 */     GIR_EraseRootFromParent_Done,
     /* 272317 */   // Label 5276: @272317
     /* 272317 */   GIM_Try, /*On fail goto*//*Label 5277*/ GIMT_Encode4(272377), // Rule ID 8979 //
     /* 272322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_sxtw_index),
     /* 272330 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 272333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 272336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272340 */     // MIs[0] Rn
     /* 272340 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272352 */     // MIs[0] prfop
     /* 272352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272355 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272360 */     // (intrinsic_void 1655:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW16:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW16:{ *:[nxv4i32] }:$Zm)
     /* 272360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_S_SXTW_SCALED),
     /* 272363 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272365 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272371 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272375 */     GIR_RootConstrainSelectedInstOperands,
     /* 272376 */     // GIR_Coverage, 8979,
     /* 272376 */     GIR_EraseRootFromParent_Done,
     /* 272377 */   // Label 5277: @272377
     /* 272377 */   GIM_Try, /*On fail goto*//*Label 5278*/ GIMT_Encode4(272437), // Rule ID 8980 //
     /* 272382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_uxtw_index),
     /* 272390 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 272393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 272396 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272400 */     // MIs[0] Rn
     /* 272400 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272412 */     // MIs[0] prfop
     /* 272412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272415 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272420 */     // (intrinsic_void 1660:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW32:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW32:{ *:[nxv4i32] }:$Zm)
     /* 272420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_S_UXTW_SCALED),
     /* 272423 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272425 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272431 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272435 */     GIR_RootConstrainSelectedInstOperands,
     /* 272436 */     // GIR_Coverage, 8980,
     /* 272436 */     GIR_EraseRootFromParent_Done,
     /* 272437 */   // Label 5278: @272437
     /* 272437 */   GIM_Try, /*On fail goto*//*Label 5279*/ GIMT_Encode4(272497), // Rule ID 8981 //
     /* 272442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_sxtw_index),
     /* 272450 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 272453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 272456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272460 */     // MIs[0] Rn
     /* 272460 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272472 */     // MIs[0] prfop
     /* 272472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272475 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272480 */     // (intrinsic_void 1659:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW32:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW32:{ *:[nxv4i32] }:$Zm)
     /* 272480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_S_SXTW_SCALED),
     /* 272483 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272485 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272491 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272495 */     GIR_RootConstrainSelectedInstOperands,
     /* 272496 */     // GIR_Coverage, 8981,
     /* 272496 */     GIR_EraseRootFromParent_Done,
     /* 272497 */   // Label 5279: @272497
     /* 272497 */   GIM_Try, /*On fail goto*//*Label 5280*/ GIMT_Encode4(272557), // Rule ID 8982 //
     /* 272502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_uxtw_index),
     /* 272510 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 272513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 272516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272520 */     // MIs[0] Rn
     /* 272520 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272532 */     // MIs[0] prfop
     /* 272532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272535 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272540 */     // (intrinsic_void 1652:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW64:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW64:{ *:[nxv4i32] }:$Zm)
     /* 272540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_S_UXTW_SCALED),
     /* 272543 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272545 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272549 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272555 */     GIR_RootConstrainSelectedInstOperands,
     /* 272556 */     // GIR_Coverage, 8982,
     /* 272556 */     GIR_EraseRootFromParent_Done,
     /* 272557 */   // Label 5280: @272557
     /* 272557 */   GIM_Try, /*On fail goto*//*Label 5281*/ GIMT_Encode4(272617), // Rule ID 8983 //
     /* 272562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_sxtw_index),
     /* 272570 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 272573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 272576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272580 */     // MIs[0] Rn
     /* 272580 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272592 */     // MIs[0] prfop
     /* 272592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272595 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272600 */     // (intrinsic_void 1651:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW64:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW64:{ *:[nxv4i32] }:$Zm)
     /* 272600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_S_SXTW_SCALED),
     /* 272603 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272605 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272609 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272615 */     GIR_RootConstrainSelectedInstOperands,
     /* 272616 */     // GIR_Coverage, 8983,
     /* 272616 */     GIR_EraseRootFromParent_Done,
     /* 272617 */   // Label 5281: @272617
     /* 272617 */   GIM_Try, /*On fail goto*//*Label 5282*/ GIMT_Encode4(272677), // Rule ID 8984 //
     /* 272622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_uxtw_index),
     /* 272630 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 272633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 272636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272640 */     // MIs[0] Rn
     /* 272640 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272652 */     // MIs[0] prfop
     /* 272652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272655 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272660 */     // (intrinsic_void 1656:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW16:{ *:[nxv2i64] }:$Zm)
     /* 272660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_UXTW_SCALED),
     /* 272663 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272665 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272669 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272671 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272675 */     GIR_RootConstrainSelectedInstOperands,
     /* 272676 */     // GIR_Coverage, 8984,
     /* 272676 */     GIR_EraseRootFromParent_Done,
     /* 272677 */   // Label 5282: @272677
     /* 272677 */   GIM_Try, /*On fail goto*//*Label 5283*/ GIMT_Encode4(272737), // Rule ID 8985 //
     /* 272682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_sxtw_index),
     /* 272690 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 272693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 272696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272700 */     // MIs[0] Rn
     /* 272700 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272712 */     // MIs[0] prfop
     /* 272712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272715 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272720 */     // (intrinsic_void 1655:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW16:{ *:[nxv2i64] }:$Zm)
     /* 272720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_SXTW_SCALED),
     /* 272723 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272725 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272731 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272735 */     GIR_RootConstrainSelectedInstOperands,
     /* 272736 */     // GIR_Coverage, 8985,
     /* 272736 */     GIR_EraseRootFromParent_Done,
     /* 272737 */   // Label 5283: @272737
     /* 272737 */   GIM_Try, /*On fail goto*//*Label 5284*/ GIMT_Encode4(272797), // Rule ID 8986 //
     /* 272742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_uxtw_index),
     /* 272750 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 272753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 272756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272760 */     // MIs[0] Rn
     /* 272760 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272772 */     // MIs[0] prfop
     /* 272772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272775 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272780 */     // (intrinsic_void 1660:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW32:{ *:[nxv2i64] }:$Zm)
     /* 272780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_UXTW_SCALED),
     /* 272783 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272785 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272791 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272795 */     GIR_RootConstrainSelectedInstOperands,
     /* 272796 */     // GIR_Coverage, 8986,
     /* 272796 */     GIR_EraseRootFromParent_Done,
     /* 272797 */   // Label 5284: @272797
     /* 272797 */   GIM_Try, /*On fail goto*//*Label 5285*/ GIMT_Encode4(272857), // Rule ID 8987 //
     /* 272802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_sxtw_index),
     /* 272810 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 272813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 272816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272820 */     // MIs[0] Rn
     /* 272820 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272832 */     // MIs[0] prfop
     /* 272832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272835 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272840 */     // (intrinsic_void 1659:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW32:{ *:[nxv2i64] }:$Zm)
     /* 272840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_SXTW_SCALED),
     /* 272843 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272845 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272849 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272851 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272855 */     GIR_RootConstrainSelectedInstOperands,
     /* 272856 */     // GIR_Coverage, 8987,
     /* 272856 */     GIR_EraseRootFromParent_Done,
     /* 272857 */   // Label 5285: @272857
     /* 272857 */   GIM_Try, /*On fail goto*//*Label 5286*/ GIMT_Encode4(272917), // Rule ID 8988 //
     /* 272862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_uxtw_index),
     /* 272870 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 272873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 272876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272880 */     // MIs[0] Rn
     /* 272880 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272892 */     // MIs[0] prfop
     /* 272892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272895 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272900 */     // (intrinsic_void 1652:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW64:{ *:[nxv2i64] }:$Zm)
     /* 272900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_UXTW_SCALED),
     /* 272903 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272905 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272911 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272915 */     GIR_RootConstrainSelectedInstOperands,
     /* 272916 */     // GIR_Coverage, 8988,
     /* 272916 */     GIR_EraseRootFromParent_Done,
     /* 272917 */   // Label 5286: @272917
     /* 272917 */   GIM_Try, /*On fail goto*//*Label 5287*/ GIMT_Encode4(272977), // Rule ID 8989 //
     /* 272922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_sxtw_index),
     /* 272930 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 272933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 272936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272940 */     // MIs[0] Rn
     /* 272940 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272952 */     // MIs[0] prfop
     /* 272952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272955 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272960 */     // (intrinsic_void 1651:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW64:{ *:[nxv2i64] }:$Zm)
     /* 272960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_SXTW_SCALED),
     /* 272963 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272965 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272971 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272975 */     GIR_RootConstrainSelectedInstOperands,
     /* 272976 */     // GIR_Coverage, 8989,
     /* 272976 */     GIR_EraseRootFromParent_Done,
     /* 272977 */   // Label 5287: @272977
     /* 272977 */   GIM_Try, /*On fail goto*//*Label 5288*/ GIMT_Encode4(273037), // Rule ID 8990 //
     /* 272982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_index),
     /* 272990 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 272993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 272996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273000 */     // MIs[0] Rn
     /* 273000 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 273004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 273008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273012 */     // MIs[0] prfop
     /* 273012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 273015 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 273020 */     // (intrinsic_void 1653:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL16:{ *:[nxv2i64] }:$Zm)
     /* 273020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_SCALED),
     /* 273023 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 273025 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 273027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 273031 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273035 */     GIR_RootConstrainSelectedInstOperands,
     /* 273036 */     // GIR_Coverage, 8990,
     /* 273036 */     GIR_EraseRootFromParent_Done,
     /* 273037 */   // Label 5288: @273037
     /* 273037 */   GIM_Try, /*On fail goto*//*Label 5289*/ GIMT_Encode4(273097), // Rule ID 8991 //
     /* 273042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 273045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_index),
     /* 273050 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 273053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 273056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273060 */     // MIs[0] Rn
     /* 273060 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 273064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 273068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273072 */     // MIs[0] prfop
     /* 273072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 273075 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 273080 */     // (intrinsic_void 1657:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL32:{ *:[nxv2i64] }:$Zm)
     /* 273080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_SCALED),
     /* 273083 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 273085 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 273087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 273091 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273095 */     GIR_RootConstrainSelectedInstOperands,
     /* 273096 */     // GIR_Coverage, 8991,
     /* 273096 */     GIR_EraseRootFromParent_Done,
     /* 273097 */   // Label 5289: @273097
     /* 273097 */   GIM_Try, /*On fail goto*//*Label 5290*/ GIMT_Encode4(273157), // Rule ID 8992 //
     /* 273102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 273105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_index),
     /* 273110 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 273113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 273116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273120 */     // MIs[0] Rn
     /* 273120 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 273124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 273128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273132 */     // MIs[0] prfop
     /* 273132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 273135 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 273140 */     // (intrinsic_void 1649:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL64:{ *:[nxv2i64] }:$Zm)
     /* 273140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_SCALED),
     /* 273143 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 273145 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 273147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273149 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 273151 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273155 */     GIR_RootConstrainSelectedInstOperands,
     /* 273156 */     // GIR_Coverage, 8992,
     /* 273156 */     GIR_EraseRootFromParent_Done,
     /* 273157 */   // Label 5290: @273157
     /* 273157 */   GIM_Try, /*On fail goto*//*Label 5291*/ GIMT_Encode4(273215), // Rule ID 2374 //
     /* 273162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 273165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalb),
     /* 273170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 273173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 273176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 273179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 273182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273198 */     // (intrinsic_w_chain:{ *:[v8f16] } 629:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 273198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALBv8f16),
     /* 273201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273207 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273209 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273213 */     GIR_RootConstrainSelectedInstOperands,
     /* 273214 */     // GIR_Coverage, 2374,
     /* 273214 */     GIR_EraseRootFromParent_Done,
     /* 273215 */   // Label 5291: @273215
     /* 273215 */   GIM_Try, /*On fail goto*//*Label 5292*/ GIMT_Encode4(273273), // Rule ID 2375 //
     /* 273220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 273223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalt),
     /* 273228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 273231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 273234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 273237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 273240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273256 */     // (intrinsic_w_chain:{ *:[v8f16] } 639:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 273256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALTv8f16),
     /* 273259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273265 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273267 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273271 */     GIR_RootConstrainSelectedInstOperands,
     /* 273272 */     // GIR_Coverage, 2375,
     /* 273272 */     GIR_EraseRootFromParent_Done,
     /* 273273 */   // Label 5292: @273273
     /* 273273 */   GIM_Try, /*On fail goto*//*Label 5293*/ GIMT_Encode4(273331), // Rule ID 2376 //
     /* 273278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 273281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbb),
     /* 273286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 273289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 273295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 273298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273314 */     // (intrinsic_w_chain:{ *:[v4f32] } 631:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLBBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 273314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBBv4f32),
     /* 273317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273323 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273325 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273329 */     GIR_RootConstrainSelectedInstOperands,
     /* 273330 */     // GIR_Coverage, 2376,
     /* 273330 */     GIR_EraseRootFromParent_Done,
     /* 273331 */   // Label 5293: @273331
     /* 273331 */   GIM_Try, /*On fail goto*//*Label 5294*/ GIMT_Encode4(273389), // Rule ID 2377 //
     /* 273336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 273339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbt),
     /* 273344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 273347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 273353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 273356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273372 */     // (intrinsic_w_chain:{ *:[v4f32] } 633:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLBTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 273372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBTv4f32),
     /* 273375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273381 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273383 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273387 */     GIR_RootConstrainSelectedInstOperands,
     /* 273388 */     // GIR_Coverage, 2377,
     /* 273388 */     GIR_EraseRootFromParent_Done,
     /* 273389 */   // Label 5294: @273389
     /* 273389 */   GIM_Try, /*On fail goto*//*Label 5295*/ GIMT_Encode4(273447), // Rule ID 2378 //
     /* 273394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 273397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltb),
     /* 273402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 273405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 273411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 273414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273430 */     // (intrinsic_w_chain:{ *:[v4f32] } 635:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLTBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 273430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTBv4f32),
     /* 273433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273437 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273439 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273441 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273445 */     GIR_RootConstrainSelectedInstOperands,
     /* 273446 */     // GIR_Coverage, 2378,
     /* 273446 */     GIR_EraseRootFromParent_Done,
     /* 273447 */   // Label 5295: @273447
     /* 273447 */   GIM_Try, /*On fail goto*//*Label 5296*/ GIMT_Encode4(273505), // Rule ID 2379 //
     /* 273452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 273455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltt),
     /* 273460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 273463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 273469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 273472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273488 */     // (intrinsic_w_chain:{ *:[v4f32] } 637:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLTTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 273488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTTv4f32),
     /* 273491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273495 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273497 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273499 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273503 */     GIR_RootConstrainSelectedInstOperands,
     /* 273504 */     // GIR_Coverage, 2379,
     /* 273504 */     GIR_EraseRootFromParent_Done,
     /* 273505 */   // Label 5296: @273505
     /* 273505 */   GIM_Try, /*On fail goto*//*Label 5297*/ GIMT_Encode4(273563), // Rule ID 2380 //
     /* 273510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 273513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2),
     /* 273518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 273521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 273524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 273527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 273530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273546 */     // (intrinsic_w_chain:{ *:[v4f16] } 625:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (FDOTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 273546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv4f16),
     /* 273549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273555 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273557 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273561 */     GIR_RootConstrainSelectedInstOperands,
     /* 273562 */     // GIR_Coverage, 2380,
     /* 273562 */     GIR_EraseRootFromParent_Done,
     /* 273563 */   // Label 5297: @273563
     /* 273563 */   GIM_Try, /*On fail goto*//*Label 5298*/ GIMT_Encode4(273621), // Rule ID 2381 //
     /* 273568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 273571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2),
     /* 273576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 273579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 273582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 273585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 273588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273604 */     // (intrinsic_w_chain:{ *:[v8f16] } 625:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FDOTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 273604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv8f16),
     /* 273607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273611 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273613 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273615 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273619 */     GIR_RootConstrainSelectedInstOperands,
     /* 273620 */     // GIR_Coverage, 2381,
     /* 273620 */     GIR_EraseRootFromParent_Done,
     /* 273621 */   // Label 5298: @273621
     /* 273621 */   GIM_Try, /*On fail goto*//*Label 5299*/ GIMT_Encode4(273679), // Rule ID 2382 //
     /* 273626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 273629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4),
     /* 273634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 273637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 273640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 273643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 273646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273662 */     // (intrinsic_w_chain:{ *:[v2f32] } 627:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (FDOTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 273662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv2f32),
     /* 273665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273669 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273671 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273677 */     GIR_RootConstrainSelectedInstOperands,
     /* 273678 */     // GIR_Coverage, 2382,
     /* 273678 */     GIR_EraseRootFromParent_Done,
     /* 273679 */   // Label 5299: @273679
     /* 273679 */   GIM_Try, /*On fail goto*//*Label 5300*/ GIMT_Encode4(273737), // Rule ID 2383 //
     /* 273684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 273687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4),
     /* 273692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 273695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 273701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 273704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273720 */     // (intrinsic_w_chain:{ *:[v4f32] } 627:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FDOTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 273720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv4f32),
     /* 273723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273727 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273729 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273731 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273735 */     GIR_RootConstrainSelectedInstOperands,
     /* 273736 */     // GIR_Coverage, 2383,
     /* 273736 */     GIR_EraseRootFromParent_Done,
     /* 273737 */   // Label 5300: @273737
     /* 273737 */   GIM_Try, /*On fail goto*//*Label 5301*/ GIMT_Encode4(273795), // Rule ID 2487 //
     /* 273742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 273745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn2),
     /* 273750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 273753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 273756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 273759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 273762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273778 */     // (intrinsic_w_chain:{ *:[v16i8] } 624:{ *:[iPTR] }, V128:{ *:[v16i8] }:$_Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCVTN_F322v16f8:{ *:[v16i8] } V128:{ *:[v16i8] }:$_Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 273778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F322v16f8),
     /* 273781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273783 */     GIR_RootToRootCopy, /*OpIdx*/2, // _Rd
     /* 273785 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273787 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273789 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273793 */     GIR_RootConstrainSelectedInstOperands,
     /* 273794 */     // GIR_Coverage, 2487,
     /* 273794 */     GIR_EraseRootFromParent_Done,
     /* 273795 */   // Label 5301: @273795
     /* 273795 */   GIM_Try, /*On fail goto*//*Label 5302*/ GIMT_Encode4(273851), // Rule ID 13263 //
     /* 273800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxp),
     /* 273805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 273808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 273811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 273814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273826 */     // MIs[0] addr
     /* 273826 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/4, /*SizeInBits*/64,
     /* 273830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273834 */     // (intrinsic_w_chain:{ *:[i32] } 1248:{ *:[iPTR] }, GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)  =>  (STLXPX:{ *:[i32] } GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)
     /* 273834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXPX),
     /* 273837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 273839 */     GIR_RootToRootCopy, /*OpIdx*/2, // lo
     /* 273841 */     GIR_RootToRootCopy, /*OpIdx*/3, // hi
     /* 273843 */     GIR_RootToRootCopy, /*OpIdx*/4, // addr
     /* 273845 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273849 */     GIR_RootConstrainSelectedInstOperands,
     /* 273850 */     // GIR_Coverage, 13263,
     /* 273850 */     GIR_EraseRootFromParent_Done,
     /* 273851 */   // Label 5302: @273851
     /* 273851 */   GIM_Try, /*On fail goto*//*Label 5303*/ GIMT_Encode4(273907), // Rule ID 13264 //
     /* 273856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxp),
     /* 273861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 273864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 273867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 273870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273882 */     // MIs[0] addr
     /* 273882 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/4, /*SizeInBits*/64,
     /* 273886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273890 */     // (intrinsic_w_chain:{ *:[i32] } 1250:{ *:[iPTR] }, GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)  =>  (STXPX:{ *:[i32] } GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)
     /* 273890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXPX),
     /* 273893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 273895 */     GIR_RootToRootCopy, /*OpIdx*/2, // lo
     /* 273897 */     GIR_RootToRootCopy, /*OpIdx*/3, // hi
     /* 273899 */     GIR_RootToRootCopy, /*OpIdx*/4, // addr
     /* 273901 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273905 */     GIR_RootConstrainSelectedInstOperands,
     /* 273906 */     // GIR_Coverage, 13264,
     /* 273906 */     GIR_EraseRootFromParent_Done,
     /* 273907 */   // Label 5303: @273907
     /* 273907 */   GIM_Try, /*On fail goto*//*Label 5304*/ GIMT_Encode4(273953), // Rule ID 3472 //
     /* 273912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT2),
     /* 273915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot),
     /* 273920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 273923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 273926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 273929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 273932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273936 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1513:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FDOT_ZZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 273936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_BtoH),
     /* 273939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 273941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 273943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 273945 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 273947 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273951 */     GIR_RootConstrainSelectedInstOperands,
     /* 273952 */     // GIR_Coverage, 3472,
     /* 273952 */     GIR_EraseRootFromParent_Done,
     /* 273953 */   // Label 5304: @273953
     /* 273953 */   GIM_Try, /*On fail goto*//*Label 5305*/ GIMT_Encode4(273999), // Rule ID 3600 //
     /* 273958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 273961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalb),
     /* 273966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 273969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 273972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 273975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 273978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273982 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1515:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALB_ZZZ:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 273982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZ),
     /* 273985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 273987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 273989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 273991 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 273993 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273997 */     GIR_RootConstrainSelectedInstOperands,
     /* 273998 */     // GIR_Coverage, 3600,
     /* 273998 */     GIR_EraseRootFromParent_Done,
     /* 273999 */   // Label 5305: @273999
     /* 273999 */   GIM_Try, /*On fail goto*//*Label 5306*/ GIMT_Encode4(274045), // Rule ID 12691 //
     /* 274004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 274007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalt),
     /* 274012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 274015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 274018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 274021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 274024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274028 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1525:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALT_ZZZ:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 274028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZ),
     /* 274031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 274033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 274035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 274037 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 274039 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274043 */     GIR_RootConstrainSelectedInstOperands,
     /* 274044 */     // GIR_Coverage, 12691,
     /* 274044 */     GIR_EraseRootFromParent_Done,
     /* 274045 */   // Label 5306: @274045
     /* 274045 */   GIM_Try, /*On fail goto*//*Label 5307*/ GIMT_Encode4(274091), // Rule ID 12695 //
     /* 274050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 274053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbb),
     /* 274058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 274061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 274064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 274067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 274070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274074 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1517:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLBB_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 274074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBB_ZZZ),
     /* 274077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 274079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 274081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 274083 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 274085 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274089 */     GIR_RootConstrainSelectedInstOperands,
     /* 274090 */     // GIR_Coverage, 12695,
     /* 274090 */     GIR_EraseRootFromParent_Done,
     /* 274091 */   // Label 5307: @274091
     /* 274091 */   GIM_Try, /*On fail goto*//*Label 5308*/ GIMT_Encode4(274137), // Rule ID 12696 //
     /* 274096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 274099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbt),
     /* 274104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 274107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 274110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 274113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 274116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274120 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1519:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLBT_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 274120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBT_ZZZ),
     /* 274123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 274125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 274127 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 274129 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 274131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274135 */     GIR_RootConstrainSelectedInstOperands,
     /* 274136 */     // GIR_Coverage, 12696,
     /* 274136 */     GIR_EraseRootFromParent_Done,
     /* 274137 */   // Label 5308: @274137
     /* 274137 */   GIM_Try, /*On fail goto*//*Label 5309*/ GIMT_Encode4(274183), // Rule ID 12697 //
     /* 274142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 274145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltb),
     /* 274150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 274153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 274156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 274159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 274162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274166 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1521:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLTB_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 274166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTB_ZZZ),
     /* 274169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 274171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 274173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 274175 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 274177 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274181 */     GIR_RootConstrainSelectedInstOperands,
     /* 274182 */     // GIR_Coverage, 12697,
     /* 274182 */     GIR_EraseRootFromParent_Done,
     /* 274183 */   // Label 5309: @274183
     /* 274183 */   GIM_Try, /*On fail goto*//*Label 5310*/ GIMT_Encode4(274229), // Rule ID 12698 //
     /* 274188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 274191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltt),
     /* 274196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 274199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 274202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 274205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 274208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274212 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1523:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLTT_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 274212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTT_ZZZ),
     /* 274215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 274217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 274219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 274221 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 274223 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274227 */     GIR_RootConstrainSelectedInstOperands,
     /* 274228 */     // GIR_Coverage, 12698,
     /* 274228 */     GIR_EraseRootFromParent_Done,
     /* 274229 */   // Label 5310: @274229
     /* 274229 */   GIM_Try, /*On fail goto*//*Label 5311*/ GIMT_Encode4(274275), // Rule ID 12699 //
     /* 274234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT4),
     /* 274237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot),
     /* 274242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 274245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 274248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 274251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 274254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274258 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1513:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FDOT_ZZZ_BtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 274258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_BtoS),
     /* 274261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 274263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 274265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 274267 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 274269 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274273 */     GIR_RootConstrainSelectedInstOperands,
     /* 274274 */     // GIR_Coverage, 12699,
     /* 274274 */     GIR_EraseRootFromParent_Done,
     /* 274275 */   // Label 5311: @274275
     /* 274275 */   GIM_Reject,
     /* 274276 */ // Label 5264: @274276
     /* 274276 */ GIM_Try, /*On fail goto*//*Label 5312*/ GIMT_Encode4(277269),
     /* 274281 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 274284 */   GIM_Try, /*On fail goto*//*Label 5313*/ GIMT_Encode4(274352), // Rule ID 2514 //
     /* 274289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 274292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalb_lane),
     /* 274297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 274300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 274303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 274306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 274309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 274325 */     // MIs[0] Idx
     /* 274325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 274328 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 274333 */     // (intrinsic_w_chain:{ *:[v8f16] } 630:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALBlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 274333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALBlanev8f16),
     /* 274336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 274338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 274340 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274342 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 274344 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 274346 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274350 */     GIR_RootConstrainSelectedInstOperands,
     /* 274351 */     // GIR_Coverage, 2514,
     /* 274351 */     GIR_EraseRootFromParent_Done,
     /* 274352 */   // Label 5313: @274352
     /* 274352 */   GIM_Try, /*On fail goto*//*Label 5314*/ GIMT_Encode4(274420), // Rule ID 2515 //
     /* 274357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 274360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbb_lane),
     /* 274365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 274368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 274371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 274374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 274377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 274393 */     // MIs[0] Idx
     /* 274393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 274396 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 274401 */     // (intrinsic_w_chain:{ *:[v4f32] } 632:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLBBlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 274401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBBlanev4f32),
     /* 274404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 274406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 274408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274410 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 274412 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 274414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274418 */     GIR_RootConstrainSelectedInstOperands,
     /* 274419 */     // GIR_Coverage, 2515,
     /* 274419 */     GIR_EraseRootFromParent_Done,
     /* 274420 */   // Label 5314: @274420
     /* 274420 */   GIM_Try, /*On fail goto*//*Label 5315*/ GIMT_Encode4(274488), // Rule ID 2516 //
     /* 274425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 274428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4_lane),
     /* 274433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 274436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 274439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 274442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 274445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274461 */     // MIs[0] Idx
     /* 274461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 274464 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 274469 */     // (intrinsic_w_chain:{ *:[v2f32] } 628:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Idx)  =>  (FDOTlanev2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v8i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 274469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev2f32),
     /* 274472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 274474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 274476 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274478 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 274480 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 274482 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274486 */     GIR_RootConstrainSelectedInstOperands,
     /* 274487 */     // GIR_Coverage, 2516,
     /* 274487 */     GIR_EraseRootFromParent_Done,
     /* 274488 */   // Label 5315: @274488
     /* 274488 */   GIM_Try, /*On fail goto*//*Label 5316*/ GIMT_Encode4(274556), // Rule ID 2517 //
     /* 274493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 274496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4_lane),
     /* 274501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 274504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 274507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 274510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 274513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274529 */     // MIs[0] Idx
     /* 274529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 274532 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 274537 */     // (intrinsic_w_chain:{ *:[v4f32] } 628:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Idx)  =>  (FDOTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 274537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev4f32),
     /* 274540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 274542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 274544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274546 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 274548 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 274550 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274554 */     GIR_RootConstrainSelectedInstOperands,
     /* 274555 */     // GIR_Coverage, 2517,
     /* 274555 */     GIR_EraseRootFromParent_Done,
     /* 274556 */   // Label 5316: @274556
     /* 274556 */   GIM_Try, /*On fail goto*//*Label 5317*/ GIMT_Encode4(274624), // Rule ID 2518 //
     /* 274561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 274564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2_lane),
     /* 274569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 274572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 274575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 274578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 274581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 274597 */     // MIs[0] Idx
     /* 274597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 274600 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 274605 */     // (intrinsic_w_chain:{ *:[v4f16] } 626:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128_lo:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Idx)  =>  (FDOTlanev4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v8i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 274605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev4f16),
     /* 274608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 274610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 274612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274614 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 274616 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 274618 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274622 */     GIR_RootConstrainSelectedInstOperands,
     /* 274623 */     // GIR_Coverage, 2518,
     /* 274623 */     GIR_EraseRootFromParent_Done,
     /* 274624 */   // Label 5317: @274624
     /* 274624 */   GIM_Try, /*On fail goto*//*Label 5318*/ GIMT_Encode4(274692), // Rule ID 2519 //
     /* 274629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 274632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2_lane),
     /* 274637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 274640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 274643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 274646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 274649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 274665 */     // MIs[0] Idx
     /* 274665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 274668 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 274673 */     // (intrinsic_w_chain:{ *:[v8f16] } 626:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_lo:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Idx)  =>  (FDOTlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 274673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev8f16),
     /* 274676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 274678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 274680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274682 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 274684 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 274686 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274690 */     GIR_RootConstrainSelectedInstOperands,
     /* 274691 */     // GIR_Coverage, 2519,
     /* 274691 */     GIR_EraseRootFromParent_Done,
     /* 274692 */   // Label 5318: @274692
     /* 274692 */   GIM_Try, /*On fail goto*//*Label 5319*/ GIMT_Encode4(274760), // Rule ID 7057 //
     /* 274697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 274700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalt_lane),
     /* 274705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 274708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 274711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 274714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 274717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 274733 */     // MIs[0] Idx
     /* 274733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 274736 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 274741 */     // (intrinsic_w_chain:{ *:[v8f16] } 640:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALTlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 274741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALTlanev8f16),
     /* 274744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 274746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 274748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274750 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 274752 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 274754 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274758 */     GIR_RootConstrainSelectedInstOperands,
     /* 274759 */     // GIR_Coverage, 7057,
     /* 274759 */     GIR_EraseRootFromParent_Done,
     /* 274760 */   // Label 5319: @274760
     /* 274760 */   GIM_Try, /*On fail goto*//*Label 5320*/ GIMT_Encode4(274828), // Rule ID 7058 //
     /* 274765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 274768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbt_lane),
     /* 274773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 274776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 274779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 274782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 274785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 274801 */     // MIs[0] Idx
     /* 274801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 274804 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 274809 */     // (intrinsic_w_chain:{ *:[v4f32] } 634:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLBTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 274809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBTlanev4f32),
     /* 274812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 274814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 274816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274818 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 274820 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 274822 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274826 */     GIR_RootConstrainSelectedInstOperands,
     /* 274827 */     // GIR_Coverage, 7058,
     /* 274827 */     GIR_EraseRootFromParent_Done,
     /* 274828 */   // Label 5320: @274828
     /* 274828 */   GIM_Try, /*On fail goto*//*Label 5321*/ GIMT_Encode4(274896), // Rule ID 7059 //
     /* 274833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 274836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltb_lane),
     /* 274841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 274844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 274847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 274850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 274853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 274869 */     // MIs[0] Idx
     /* 274869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 274872 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 274877 */     // (intrinsic_w_chain:{ *:[v4f32] } 636:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLTBlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 274877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTBlanev4f32),
     /* 274880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 274882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 274884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274886 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 274888 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 274890 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274894 */     GIR_RootConstrainSelectedInstOperands,
     /* 274895 */     // GIR_Coverage, 7059,
     /* 274895 */     GIR_EraseRootFromParent_Done,
     /* 274896 */   // Label 5321: @274896
     /* 274896 */   GIM_Try, /*On fail goto*//*Label 5322*/ GIMT_Encode4(274964), // Rule ID 7060 //
     /* 274901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 274904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltt_lane),
     /* 274909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 274912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 274915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 274918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 274921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 274937 */     // MIs[0] Idx
     /* 274937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 274940 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 274945 */     // (intrinsic_w_chain:{ *:[v4f32] } 638:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLTTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 274945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTTlanev4f32),
     /* 274948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 274950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 274952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274954 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 274956 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 274958 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274962 */     GIR_RootConstrainSelectedInstOperands,
     /* 274963 */     // GIR_Coverage, 7060,
     /* 274963 */     GIR_EraseRootFromParent_Done,
     /* 274964 */   // Label 5322: @274964
     /* 274964 */   GIM_Try, /*On fail goto*//*Label 5323*/ GIMT_Encode4(275024), // Rule ID 3612 //
     /* 274969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 274972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 274977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 274980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 274983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 274986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 274989 */     // MIs[0] tile
     /* 274989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 274992 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 274997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275005 */     // (intrinsic_void 938:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 275005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_S_PSEUDO),
     /* 275008 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275012 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275014 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275016 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275018 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275022 */     GIR_RootConstrainSelectedInstOperands,
     /* 275023 */     // GIR_Coverage, 3612,
     /* 275023 */     GIR_EraseRootFromParent_Done,
     /* 275024 */   // Label 5323: @275024
     /* 275024 */   GIM_Try, /*On fail goto*//*Label 5324*/ GIMT_Encode4(275084), // Rule ID 3613 //
     /* 275029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F32),
     /* 275032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmopa_za32),
     /* 275037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 275040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 275043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 275046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 275049 */     // MIs[0] tile
     /* 275049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275052 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 275057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275065 */     // (intrinsic_void 890:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOPA_MPPZZ_BtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 275065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_BtoS_PSEUDO),
     /* 275068 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275072 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275074 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275076 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275078 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275082 */     GIR_RootConstrainSelectedInstOperands,
     /* 275083 */     // GIR_Coverage, 3613,
     /* 275083 */     GIR_EraseRootFromParent_Done,
     /* 275084 */   // Label 5324: @275084
     /* 275084 */   GIM_Try, /*On fail goto*//*Label 5325*/ GIMT_Encode4(275144), // Rule ID 3614 //
     /* 275089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64),
     /* 275092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 275097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 275100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 275103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 275106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 275109 */     // MIs[0] tile
     /* 275109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275112 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 275117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275125 */     // (intrinsic_void 938:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$Pn, PPR3bAny:{ *:[nxv2i1] }:$Pm, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 275125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_D_PSEUDO),
     /* 275128 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275134 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275136 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275138 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275142 */     GIR_RootConstrainSelectedInstOperands,
     /* 275143 */     // GIR_Coverage, 3614,
     /* 275143 */     GIR_EraseRootFromParent_Done,
     /* 275144 */   // Label 5325: @275144
     /* 275144 */   GIM_Try, /*On fail goto*//*Label 5326*/ GIMT_Encode4(275204), // Rule ID 3615 //
     /* 275149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F16),
     /* 275152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmopa_za16),
     /* 275157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 275160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 275163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 275166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 275169 */     // MIs[0] tile
     /* 275169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275172 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 275177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275185 */     // (intrinsic_void 889:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOPA_MPPZZ_BtoH_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 275185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_BtoH_PSEUDO),
     /* 275188 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275194 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275196 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275198 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275202 */     GIR_RootConstrainSelectedInstOperands,
     /* 275203 */     // GIR_Coverage, 3615,
     /* 275203 */     GIR_EraseRootFromParent_Done,
     /* 275204 */   // Label 5326: @275204
     /* 275204 */   GIM_Try, /*On fail goto*//*Label 5327*/ GIMT_Encode4(275264), // Rule ID 3616 //
     /* 275209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16),
     /* 275212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 275217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 275220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 275223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 275226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 275229 */     // MIs[0] tile
     /* 275229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275232 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 275237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275245 */     // (intrinsic_void 938:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPA_MPPZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 275245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_H_PSEUDO),
     /* 275248 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275254 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275256 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275258 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275262 */     GIR_RootConstrainSelectedInstOperands,
     /* 275263 */     // GIR_Coverage, 3616,
     /* 275263 */     GIR_EraseRootFromParent_Done,
     /* 275264 */   // Label 5327: @275264
     /* 275264 */   GIM_Try, /*On fail goto*//*Label 5328*/ GIMT_Encode4(275324), // Rule ID 3617 //
     /* 275269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 275272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_wide),
     /* 275277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 275280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 275283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 275286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 275289 */     // MIs[0] tile
     /* 275289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275292 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 275297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275305 */     // (intrinsic_void 1041:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 275305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_S_PSEUDO),
     /* 275308 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275312 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275314 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275316 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275318 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275322 */     GIR_RootConstrainSelectedInstOperands,
     /* 275323 */     // GIR_Coverage, 3617,
     /* 275323 */     GIR_EraseRootFromParent_Done,
     /* 275324 */   // Label 5328: @275324
     /* 275324 */   GIM_Try, /*On fail goto*//*Label 5329*/ GIMT_Encode4(275384), // Rule ID 3618 //
     /* 275329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 275332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_wide),
     /* 275337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 275340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 275343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 275346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 275349 */     // MIs[0] tile
     /* 275349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275352 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 275357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275365 */     // (intrinsic_void 1041:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 275365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_D_PSEUDO),
     /* 275368 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275374 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275376 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275378 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275382 */     GIR_RootConstrainSelectedInstOperands,
     /* 275383 */     // GIR_Coverage, 3618,
     /* 275383 */     GIR_EraseRootFromParent_Done,
     /* 275384 */   // Label 5329: @275384
     /* 275384 */   GIM_Try, /*On fail goto*//*Label 5330*/ GIMT_Encode4(275444), // Rule ID 3619 //
     /* 275389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 275392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa_wide),
     /* 275397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 275400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 275403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 275406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 275409 */     // MIs[0] tile
     /* 275409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275412 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 275417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275425 */     // (intrinsic_void 940:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPAL_MPPZZ_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 275425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPAL_MPPZZ_PSEUDO),
     /* 275428 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275432 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275434 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275436 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275438 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275442 */     GIR_RootConstrainSelectedInstOperands,
     /* 275443 */     // GIR_Coverage, 3619,
     /* 275443 */     GIR_EraseRootFromParent_Done,
     /* 275444 */   // Label 5330: @275444
     /* 275444 */   GIM_Try, /*On fail goto*//*Label 5331*/ GIMT_Encode4(275504), // Rule ID 3713 //
     /* 275449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 275452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_za32),
     /* 275457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 275460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 275463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 275466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 275469 */     // MIs[0] tile
     /* 275469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275472 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 275477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275485 */     // (intrinsic_void 1042:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPA_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 275485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_HtoS_PSEUDO),
     /* 275488 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275490 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275492 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275494 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275496 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275498 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275502 */     GIR_RootConstrainSelectedInstOperands,
     /* 275503 */     // GIR_Coverage, 3713,
     /* 275503 */     GIR_EraseRootFromParent_Done,
     /* 275504 */   // Label 5331: @275504
     /* 275504 */   GIM_Try, /*On fail goto*//*Label 5332*/ GIMT_Encode4(275564), // Rule ID 3714 //
     /* 275509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 275512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_bmopa_za32),
     /* 275517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 275520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 275523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 275526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 275529 */     // MIs[0] tile
     /* 275529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275532 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 275537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275545 */     // (intrinsic_void 809:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4i32:{ *:[nxv4i32] }:$Zn, nxv4i32:{ *:[nxv4i32] }:$Zm)  =>  (BMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4i32] }:$Zn, ?:{ *:[nxv4i32] }:$Zm)
     /* 275545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BMOPA_MPPZZ_S_PSEUDO),
     /* 275548 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275554 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275556 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275558 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275562 */     GIR_RootConstrainSelectedInstOperands,
     /* 275563 */     // GIR_Coverage, 3714,
     /* 275563 */     GIR_EraseRootFromParent_Done,
     /* 275564 */   // Label 5332: @275564
     /* 275564 */   GIM_Try, /*On fail goto*//*Label 5333*/ GIMT_Encode4(275624), // Rule ID 12706 //
     /* 275569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 275572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 275577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 275580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 275583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 275586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 275589 */     // MIs[0] tile
     /* 275589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275592 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 275597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275605 */     // (intrinsic_void 941:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 275605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_S_PSEUDO),
     /* 275608 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275614 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275616 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275618 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275622 */     GIR_RootConstrainSelectedInstOperands,
     /* 275623 */     // GIR_Coverage, 12706,
     /* 275623 */     GIR_EraseRootFromParent_Done,
     /* 275624 */   // Label 5333: @275624
     /* 275624 */   GIM_Try, /*On fail goto*//*Label 5334*/ GIMT_Encode4(275684), // Rule ID 12707 //
     /* 275629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64),
     /* 275632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 275637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 275640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 275643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 275646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 275649 */     // MIs[0] tile
     /* 275649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275652 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 275657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275665 */     // (intrinsic_void 941:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$Pn, PPR3bAny:{ *:[nxv2i1] }:$Pm, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 275665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_D_PSEUDO),
     /* 275668 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275674 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275676 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275678 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275682 */     GIR_RootConstrainSelectedInstOperands,
     /* 275683 */     // GIR_Coverage, 12707,
     /* 275683 */     GIR_EraseRootFromParent_Done,
     /* 275684 */   // Label 5334: @275684
     /* 275684 */   GIM_Try, /*On fail goto*//*Label 5335*/ GIMT_Encode4(275744), // Rule ID 12708 //
     /* 275689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 275692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops_wide),
     /* 275697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 275700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 275703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 275706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 275709 */     // MIs[0] tile
     /* 275709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275712 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 275717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275725 */     // (intrinsic_void 943:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPSL_MPPZZ_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 275725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPSL_MPPZZ_PSEUDO),
     /* 275728 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275732 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275734 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275736 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275738 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275742 */     GIR_RootConstrainSelectedInstOperands,
     /* 275743 */     // GIR_Coverage, 12708,
     /* 275743 */     GIR_EraseRootFromParent_Done,
     /* 275744 */   // Label 5335: @275744
     /* 275744 */   GIM_Try, /*On fail goto*//*Label 5336*/ GIMT_Encode4(275804), // Rule ID 12709 //
     /* 275749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 275752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_wide),
     /* 275757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 275760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 275763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 275766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 275769 */     // MIs[0] tile
     /* 275769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275772 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 275777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275785 */     // (intrinsic_void 1043:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 275785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_S_PSEUDO),
     /* 275788 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275794 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275796 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275798 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275802 */     GIR_RootConstrainSelectedInstOperands,
     /* 275803 */     // GIR_Coverage, 12709,
     /* 275803 */     GIR_EraseRootFromParent_Done,
     /* 275804 */   // Label 5336: @275804
     /* 275804 */   GIM_Try, /*On fail goto*//*Label 5337*/ GIMT_Encode4(275864), // Rule ID 12710 //
     /* 275809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 275812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_wide),
     /* 275817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 275820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 275823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 275826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 275829 */     // MIs[0] tile
     /* 275829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275832 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 275837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275845 */     // (intrinsic_void 1176:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 275845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_S_PSEUDO),
     /* 275848 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275854 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275856 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275858 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275862 */     GIR_RootConstrainSelectedInstOperands,
     /* 275863 */     // GIR_Coverage, 12710,
     /* 275863 */     GIR_EraseRootFromParent_Done,
     /* 275864 */   // Label 5337: @275864
     /* 275864 */   GIM_Try, /*On fail goto*//*Label 5338*/ GIMT_Encode4(275924), // Rule ID 12711 //
     /* 275869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 275872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_wide),
     /* 275877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 275880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 275883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 275886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 275889 */     // MIs[0] tile
     /* 275889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275892 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 275897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275905 */     // (intrinsic_void 1178:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 275905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_S_PSEUDO),
     /* 275908 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275912 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275914 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275916 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275918 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275922 */     GIR_RootConstrainSelectedInstOperands,
     /* 275923 */     // GIR_Coverage, 12711,
     /* 275923 */     GIR_EraseRootFromParent_Done,
     /* 275924 */   // Label 5338: @275924
     /* 275924 */   GIM_Try, /*On fail goto*//*Label 5339*/ GIMT_Encode4(275984), // Rule ID 12712 //
     /* 275929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 275932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumopa_wide),
     /* 275937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 275940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 275943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 275946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 275949 */     // MIs[0] tile
     /* 275949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275952 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 275957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275965 */     // (intrinsic_void 1093:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 275965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPA_MPPZZ_S_PSEUDO),
     /* 275968 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275972 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275974 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275976 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275978 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275982 */     GIR_RootConstrainSelectedInstOperands,
     /* 275983 */     // GIR_Coverage, 12712,
     /* 275983 */     GIR_EraseRootFromParent_Done,
     /* 275984 */   // Label 5339: @275984
     /* 275984 */   GIM_Try, /*On fail goto*//*Label 5340*/ GIMT_Encode4(276044), // Rule ID 12713 //
     /* 275989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 275992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumops_wide),
     /* 275997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 276000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 276003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 276006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 276009 */     // MIs[0] tile
     /* 276009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276012 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 276017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276025 */     // (intrinsic_void 1094:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 276025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPS_MPPZZ_S_PSEUDO),
     /* 276028 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276034 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276036 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276038 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276042 */     GIR_RootConstrainSelectedInstOperands,
     /* 276043 */     // GIR_Coverage, 12713,
     /* 276043 */     GIR_EraseRootFromParent_Done,
     /* 276044 */   // Label 5340: @276044
     /* 276044 */   GIM_Try, /*On fail goto*//*Label 5341*/ GIMT_Encode4(276104), // Rule ID 12714 //
     /* 276049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 276052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmopa_wide),
     /* 276057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 276060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 276063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 276066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 276069 */     // MIs[0] tile
     /* 276069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276072 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 276077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276085 */     // (intrinsic_void 1210:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 276085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPA_MPPZZ_S_PSEUDO),
     /* 276088 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276094 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276096 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276098 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276102 */     GIR_RootConstrainSelectedInstOperands,
     /* 276103 */     // GIR_Coverage, 12714,
     /* 276103 */     GIR_EraseRootFromParent_Done,
     /* 276104 */   // Label 5341: @276104
     /* 276104 */   GIM_Try, /*On fail goto*//*Label 5342*/ GIMT_Encode4(276164), // Rule ID 12715 //
     /* 276109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 276112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmops_wide),
     /* 276117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 276120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 276123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 276126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 276129 */     // MIs[0] tile
     /* 276129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276132 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 276137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276145 */     // (intrinsic_void 1211:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 276145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPS_MPPZZ_S_PSEUDO),
     /* 276148 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276152 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276154 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276156 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276158 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276162 */     GIR_RootConstrainSelectedInstOperands,
     /* 276163 */     // GIR_Coverage, 12715,
     /* 276163 */     GIR_EraseRootFromParent_Done,
     /* 276164 */   // Label 5342: @276164
     /* 276164 */   GIM_Try, /*On fail goto*//*Label 5343*/ GIMT_Encode4(276224), // Rule ID 12716 //
     /* 276169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 276172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_wide),
     /* 276177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 276180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 276183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 276186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 276189 */     // MIs[0] tile
     /* 276189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276192 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 276197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276205 */     // (intrinsic_void 1043:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 276205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_D_PSEUDO),
     /* 276208 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276214 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276216 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276218 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276222 */     GIR_RootConstrainSelectedInstOperands,
     /* 276223 */     // GIR_Coverage, 12716,
     /* 276223 */     GIR_EraseRootFromParent_Done,
     /* 276224 */   // Label 5343: @276224
     /* 276224 */   GIM_Try, /*On fail goto*//*Label 5344*/ GIMT_Encode4(276284), // Rule ID 12717 //
     /* 276229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 276232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_wide),
     /* 276237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 276240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 276243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 276246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 276249 */     // MIs[0] tile
     /* 276249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276252 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 276257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276265 */     // (intrinsic_void 1176:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 276265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_D_PSEUDO),
     /* 276268 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276272 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276274 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276276 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276278 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276282 */     GIR_RootConstrainSelectedInstOperands,
     /* 276283 */     // GIR_Coverage, 12717,
     /* 276283 */     GIR_EraseRootFromParent_Done,
     /* 276284 */   // Label 5344: @276284
     /* 276284 */   GIM_Try, /*On fail goto*//*Label 5345*/ GIMT_Encode4(276344), // Rule ID 12718 //
     /* 276289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 276292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_wide),
     /* 276297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 276300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 276303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 276306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 276309 */     // MIs[0] tile
     /* 276309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276312 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 276317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276325 */     // (intrinsic_void 1178:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 276325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_D_PSEUDO),
     /* 276328 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276332 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276334 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276336 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276338 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276342 */     GIR_RootConstrainSelectedInstOperands,
     /* 276343 */     // GIR_Coverage, 12718,
     /* 276343 */     GIR_EraseRootFromParent_Done,
     /* 276344 */   // Label 5345: @276344
     /* 276344 */   GIM_Try, /*On fail goto*//*Label 5346*/ GIMT_Encode4(276404), // Rule ID 12719 //
     /* 276349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 276352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumopa_wide),
     /* 276357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 276360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 276363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 276366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 276369 */     // MIs[0] tile
     /* 276369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276372 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 276377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276385 */     // (intrinsic_void 1093:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 276385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPA_MPPZZ_D_PSEUDO),
     /* 276388 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276390 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276392 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276394 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276396 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276398 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276402 */     GIR_RootConstrainSelectedInstOperands,
     /* 276403 */     // GIR_Coverage, 12719,
     /* 276403 */     GIR_EraseRootFromParent_Done,
     /* 276404 */   // Label 5346: @276404
     /* 276404 */   GIM_Try, /*On fail goto*//*Label 5347*/ GIMT_Encode4(276464), // Rule ID 12720 //
     /* 276409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 276412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumops_wide),
     /* 276417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 276420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 276423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 276426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 276429 */     // MIs[0] tile
     /* 276429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276432 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 276437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276445 */     // (intrinsic_void 1094:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 276445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPS_MPPZZ_D_PSEUDO),
     /* 276448 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276452 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276454 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276456 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276458 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276462 */     GIR_RootConstrainSelectedInstOperands,
     /* 276463 */     // GIR_Coverage, 12720,
     /* 276463 */     GIR_EraseRootFromParent_Done,
     /* 276464 */   // Label 5347: @276464
     /* 276464 */   GIM_Try, /*On fail goto*//*Label 5348*/ GIMT_Encode4(276524), // Rule ID 12721 //
     /* 276469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 276472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmopa_wide),
     /* 276477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 276480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 276483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 276486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 276489 */     // MIs[0] tile
     /* 276489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276492 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 276497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276505 */     // (intrinsic_void 1210:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 276505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPA_MPPZZ_D_PSEUDO),
     /* 276508 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276514 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276516 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276518 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276522 */     GIR_RootConstrainSelectedInstOperands,
     /* 276523 */     // GIR_Coverage, 12721,
     /* 276523 */     GIR_EraseRootFromParent_Done,
     /* 276524 */   // Label 5348: @276524
     /* 276524 */   GIM_Try, /*On fail goto*//*Label 5349*/ GIMT_Encode4(276584), // Rule ID 12722 //
     /* 276529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 276532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmops_wide),
     /* 276537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 276540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 276543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 276546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 276549 */     // MIs[0] tile
     /* 276549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276552 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 276557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276565 */     // (intrinsic_void 1211:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 276565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPS_MPPZZ_D_PSEUDO),
     /* 276568 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276572 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276574 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276576 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276578 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276582 */     GIR_RootConstrainSelectedInstOperands,
     /* 276583 */     // GIR_Coverage, 12722,
     /* 276583 */     GIR_EraseRootFromParent_Done,
     /* 276584 */   // Label 5349: @276584
     /* 276584 */   GIM_Try, /*On fail goto*//*Label 5350*/ GIMT_Encode4(276644), // Rule ID 13096 //
     /* 276589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 276592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_bmops_za32),
     /* 276597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 276600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 276603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 276606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 276609 */     // MIs[0] tile
     /* 276609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276612 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 276617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276625 */     // (intrinsic_void 810:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4i32:{ *:[nxv4i32] }:$Zn, nxv4i32:{ *:[nxv4i32] }:$Zm)  =>  (BMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4i32] }:$Zn, ?:{ *:[nxv4i32] }:$Zm)
     /* 276625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BMOPS_MPPZZ_S_PSEUDO),
     /* 276628 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276632 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276634 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276636 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276638 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276642 */     GIR_RootConstrainSelectedInstOperands,
     /* 276643 */     // GIR_Coverage, 13096,
     /* 276643 */     GIR_EraseRootFromParent_Done,
     /* 276644 */   // Label 5350: @276644
     /* 276644 */   GIM_Try, /*On fail goto*//*Label 5351*/ GIMT_Encode4(276704), // Rule ID 13097 //
     /* 276649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 276652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_za32),
     /* 276657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 276660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 276663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 276666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 276669 */     // MIs[0] tile
     /* 276669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276672 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 276677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276685 */     // (intrinsic_void 1044:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPS_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 276685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_HtoS_PSEUDO),
     /* 276688 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276692 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276694 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276696 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276698 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276702 */     GIR_RootConstrainSelectedInstOperands,
     /* 276703 */     // GIR_Coverage, 13097,
     /* 276703 */     GIR_EraseRootFromParent_Done,
     /* 276704 */   // Label 5351: @276704
     /* 276704 */   GIM_Try, /*On fail goto*//*Label 5352*/ GIMT_Encode4(276764), // Rule ID 13098 //
     /* 276709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 276712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_za32),
     /* 276717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 276720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 276723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 276726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 276729 */     // MIs[0] tile
     /* 276729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276732 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 276737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276745 */     // (intrinsic_void 1177:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPA_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 276745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_HtoS_PSEUDO),
     /* 276748 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276754 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276756 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276758 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276762 */     GIR_RootConstrainSelectedInstOperands,
     /* 276763 */     // GIR_Coverage, 13098,
     /* 276763 */     GIR_EraseRootFromParent_Done,
     /* 276764 */   // Label 5352: @276764
     /* 276764 */   GIM_Try, /*On fail goto*//*Label 5353*/ GIMT_Encode4(276824), // Rule ID 13099 //
     /* 276769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 276772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_za32),
     /* 276777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 276780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 276783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 276786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 276789 */     // MIs[0] tile
     /* 276789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276792 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 276797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276805 */     // (intrinsic_void 1179:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPS_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 276805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_HtoS_PSEUDO),
     /* 276808 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276812 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276814 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276816 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276818 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276822 */     GIR_RootConstrainSelectedInstOperands,
     /* 276823 */     // GIR_Coverage, 13099,
     /* 276823 */     GIR_EraseRootFromParent_Done,
     /* 276824 */   // Label 5353: @276824
     /* 276824 */   GIM_Try, /*On fail goto*//*Label 5354*/ GIMT_Encode4(276884), // Rule ID 13210 //
     /* 276829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16),
     /* 276832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 276837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 276840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 276843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 276846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 276849 */     // MIs[0] tile
     /* 276849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276852 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 276857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276865 */     // (intrinsic_void 941:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPS_MPPZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 276865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_H_PSEUDO),
     /* 276868 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276874 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276876 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276878 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276882 */     GIR_RootConstrainSelectedInstOperands,
     /* 276883 */     // GIR_Coverage, 13210,
     /* 276883 */     GIR_EraseRootFromParent_Done,
     /* 276884 */   // Label 5354: @276884
     /* 276884 */   GIM_Try, /*On fail goto*//*Label 5355*/ GIMT_Encode4(276932), // Rule ID 3599 //
     /* 276889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 276892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalb_lane),
     /* 276897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 276900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 276903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 276906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 276909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 276913 */     // MIs[0] Op4
     /* 276913 */     // No operand predicates
     /* 276913 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1516:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALB_ZZZI:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 276913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZI),
     /* 276916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 276918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 276920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 276922 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 276924 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 276926 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276930 */     GIR_RootConstrainSelectedInstOperands,
     /* 276931 */     // GIR_Coverage, 3599,
     /* 276931 */     GIR_EraseRootFromParent_Done,
     /* 276932 */   // Label 5355: @276932
     /* 276932 */   GIM_Try, /*On fail goto*//*Label 5356*/ GIMT_Encode4(276980), // Rule ID 3601 //
     /* 276937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 276940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbb_lane),
     /* 276945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 276948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 276951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 276954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 276957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 276961 */     // MIs[0] Op4
     /* 276961 */     // No operand predicates
     /* 276961 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1518:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLBB_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 276961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBB_ZZZI),
     /* 276964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 276966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 276968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 276970 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 276972 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 276974 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276978 */     GIR_RootConstrainSelectedInstOperands,
     /* 276979 */     // GIR_Coverage, 3601,
     /* 276979 */     GIR_EraseRootFromParent_Done,
     /* 276980 */   // Label 5356: @276980
     /* 276980 */   GIM_Try, /*On fail goto*//*Label 5357*/ GIMT_Encode4(277028), // Rule ID 3602 //
     /* 276985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT2),
     /* 276988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot_lane),
     /* 276993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 276996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 276999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 277002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 277005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 277009 */     // MIs[0] Op4
     /* 277009 */     // No operand predicates
     /* 277009 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1514:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FDOT_ZZZI_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 277009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_BtoH),
     /* 277012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 277014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 277016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 277018 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 277020 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 277022 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277026 */     GIR_RootConstrainSelectedInstOperands,
     /* 277027 */     // GIR_Coverage, 3602,
     /* 277027 */     GIR_EraseRootFromParent_Done,
     /* 277028 */   // Label 5357: @277028
     /* 277028 */   GIM_Try, /*On fail goto*//*Label 5358*/ GIMT_Encode4(277076), // Rule ID 3603 //
     /* 277033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT4),
     /* 277036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot_lane),
     /* 277041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 277044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 277047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 277050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 277053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 277057 */     // MIs[0] Op4
     /* 277057 */     // No operand predicates
     /* 277057 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1514:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FDOT_ZZZI_BtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 277057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_BtoS),
     /* 277060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 277062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 277064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 277066 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 277068 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 277070 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277074 */     GIR_RootConstrainSelectedInstOperands,
     /* 277075 */     // GIR_Coverage, 3603,
     /* 277075 */     GIR_EraseRootFromParent_Done,
     /* 277076 */   // Label 5358: @277076
     /* 277076 */   GIM_Try, /*On fail goto*//*Label 5359*/ GIMT_Encode4(277124), // Rule ID 12690 //
     /* 277081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 277084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalt_lane),
     /* 277089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 277092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 277095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 277098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 277101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 277105 */     // MIs[0] Op4
     /* 277105 */     // No operand predicates
     /* 277105 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1526:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALT_ZZZI:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 277105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZI),
     /* 277108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 277110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 277112 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 277114 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 277116 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 277118 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277122 */     GIR_RootConstrainSelectedInstOperands,
     /* 277123 */     // GIR_Coverage, 12690,
     /* 277123 */     GIR_EraseRootFromParent_Done,
     /* 277124 */   // Label 5359: @277124
     /* 277124 */   GIM_Try, /*On fail goto*//*Label 5360*/ GIMT_Encode4(277172), // Rule ID 12692 //
     /* 277129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 277132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbt_lane),
     /* 277137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 277140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 277143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 277146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 277149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 277153 */     // MIs[0] Op4
     /* 277153 */     // No operand predicates
     /* 277153 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1520:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLBT_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 277153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBT_ZZZI),
     /* 277156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 277158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 277160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 277162 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 277164 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 277166 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277170 */     GIR_RootConstrainSelectedInstOperands,
     /* 277171 */     // GIR_Coverage, 12692,
     /* 277171 */     GIR_EraseRootFromParent_Done,
     /* 277172 */   // Label 5360: @277172
     /* 277172 */   GIM_Try, /*On fail goto*//*Label 5361*/ GIMT_Encode4(277220), // Rule ID 12693 //
     /* 277177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 277180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltb_lane),
     /* 277185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 277188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 277191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 277194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 277197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 277201 */     // MIs[0] Op4
     /* 277201 */     // No operand predicates
     /* 277201 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1522:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLTB_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 277201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTB_ZZZI),
     /* 277204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 277206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 277208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 277210 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 277212 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 277214 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277218 */     GIR_RootConstrainSelectedInstOperands,
     /* 277219 */     // GIR_Coverage, 12693,
     /* 277219 */     GIR_EraseRootFromParent_Done,
     /* 277220 */   // Label 5361: @277220
     /* 277220 */   GIM_Try, /*On fail goto*//*Label 5362*/ GIMT_Encode4(277268), // Rule ID 12694 //
     /* 277225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 277228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltt_lane),
     /* 277233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 277236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 277239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 277242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 277245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 277249 */     // MIs[0] Op4
     /* 277249 */     // No operand predicates
     /* 277249 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1524:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLTT_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 277249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTT_ZZZI),
     /* 277252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 277254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 277256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 277258 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 277260 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 277262 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277266 */     GIR_RootConstrainSelectedInstOperands,
     /* 277267 */     // GIR_Coverage, 12694,
     /* 277267 */     GIR_EraseRootFromParent_Done,
     /* 277268 */   // Label 5362: @277268
     /* 277268 */   GIM_Reject,
     /* 277269 */ // Label 5312: @277269
     /* 277269 */ GIM_Reject,
     /* 277270 */ // Label 39: @277270
     /* 277270 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 5367*/ GIMT_Encode4(277559),
     /* 277281 */ /*GILLT_s64*//*Label 5363*/ GIMT_Encode4(277313), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 277293 */ /*GILLT_v2s64*//*Label 5364*/ GIMT_Encode4(277373), GIMT_Encode4(0),
     /* 277301 */ /*GILLT_v4s32*//*Label 5365*/ GIMT_Encode4(277435), GIMT_Encode4(0),
     /* 277309 */ /*GILLT_v8s16*//*Label 5366*/ GIMT_Encode4(277497),
     /* 277313 */ // Label 5363: @277313
     /* 277313 */ GIM_Try, /*On fail goto*//*Label 5368*/ GIMT_Encode4(277372), // Rule ID 6569 //
     /* 277318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 277321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 277325 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 277329 */   // (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] })
     /* 277329 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 277332 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 277336 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277341 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 277343 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 277346 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 277348 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 277351 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 277353 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 277356 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 277361 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 277366 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 277371 */   // GIR_Coverage, 6569,
     /* 277371 */   GIR_EraseRootFromParent_Done,
     /* 277372 */ // Label 5368: @277372
     /* 277372 */ GIM_Reject,
     /* 277373 */ // Label 5364: @277373
     /* 277373 */ GIM_Try, /*On fail goto*//*Label 5369*/ GIMT_Encode4(277434),
     /* 277378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 277381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277385 */   GIM_Try, /*On fail goto*//*Label 5370*/ GIMT_Encode4(277412), // Rule ID 6431 //
     /* 277390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 277397 */     // (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (USHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 277397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i32_shift),
     /* 277400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 277407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277410 */     GIR_RootConstrainSelectedInstOperands,
     /* 277411 */     // GIR_Coverage, 6431,
     /* 277411 */     GIR_EraseRootFromParent_Done,
     /* 277412 */   // Label 5370: @277412
     /* 277412 */   GIM_Try, /*On fail goto*//*Label 5371*/ GIMT_Encode4(277433), // Rule ID 6424 //
     /* 277417 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277421 */     // (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 277421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 277424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277426 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 277428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277431 */     GIR_RootConstrainSelectedInstOperands,
     /* 277432 */     // GIR_Coverage, 6424,
     /* 277432 */     GIR_EraseRootFromParent_Done,
     /* 277433 */   // Label 5371: @277433
     /* 277433 */   GIM_Reject,
     /* 277434 */ // Label 5369: @277434
     /* 277434 */ GIM_Reject,
     /* 277435 */ // Label 5365: @277435
     /* 277435 */ GIM_Try, /*On fail goto*//*Label 5372*/ GIMT_Encode4(277496),
     /* 277440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 277443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277447 */   GIM_Try, /*On fail goto*//*Label 5373*/ GIMT_Encode4(277474), // Rule ID 6428 //
     /* 277452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 277459 */     // (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (USHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 277459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i16_shift),
     /* 277462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 277469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277472 */     GIR_RootConstrainSelectedInstOperands,
     /* 277473 */     // GIR_Coverage, 6428,
     /* 277473 */     GIR_EraseRootFromParent_Done,
     /* 277474 */   // Label 5373: @277474
     /* 277474 */   GIM_Try, /*On fail goto*//*Label 5374*/ GIMT_Encode4(277495), // Rule ID 6421 //
     /* 277479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277483 */     // (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 277483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 277486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277488 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 277490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277493 */     GIR_RootConstrainSelectedInstOperands,
     /* 277494 */     // GIR_Coverage, 6421,
     /* 277494 */     GIR_EraseRootFromParent_Done,
     /* 277495 */   // Label 5374: @277495
     /* 277495 */   GIM_Reject,
     /* 277496 */ // Label 5372: @277496
     /* 277496 */ GIM_Reject,
     /* 277497 */ // Label 5366: @277497
     /* 277497 */ GIM_Try, /*On fail goto*//*Label 5375*/ GIMT_Encode4(277558),
     /* 277502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 277505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277509 */   GIM_Try, /*On fail goto*//*Label 5376*/ GIMT_Encode4(277536), // Rule ID 6425 //
     /* 277514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 277521 */     // (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (USHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 277521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv16i8_shift),
     /* 277524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 277531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277534 */     GIR_RootConstrainSelectedInstOperands,
     /* 277535 */     // GIR_Coverage, 6425,
     /* 277535 */     GIR_EraseRootFromParent_Done,
     /* 277536 */   // Label 5376: @277536
     /* 277536 */   GIM_Try, /*On fail goto*//*Label 5377*/ GIMT_Encode4(277557), // Rule ID 6418 //
     /* 277541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277545 */     // (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 277545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 277548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277550 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 277552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277555 */     GIR_RootConstrainSelectedInstOperands,
     /* 277556 */     // GIR_Coverage, 6418,
     /* 277556 */     GIR_EraseRootFromParent_Done,
     /* 277557 */   // Label 5377: @277557
     /* 277557 */   GIM_Reject,
     /* 277558 */ // Label 5375: @277558
     /* 277558 */ GIM_Reject,
     /* 277559 */ // Label 5367: @277559
     /* 277559 */ GIM_Reject,
     /* 277560 */ // Label 40: @277560
     /* 277560 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(10), /*)*//*default:*//*Label 5382*/ GIMT_Encode4(278996),
     /* 277571 */ /*GILLT_s32*//*Label 5378*/ GIMT_Encode4(277603), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 277583 */ /*GILLT_v2s32*//*Label 5379*/ GIMT_Encode4(277642), GIMT_Encode4(0),
     /* 277591 */ /*GILLT_v4s16*//*Label 5380*/ GIMT_Encode4(277998), GIMT_Encode4(0),
     /* 277599 */ /*GILLT_v8s8*//*Label 5381*/ GIMT_Encode4(278497),
     /* 277603 */ // Label 5378: @277603
     /* 277603 */ GIM_Try, /*On fail goto*//*Label 5383*/ GIMT_Encode4(277641), // Rule ID 6590 //
     /* 277608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 277611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 277615 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 277619 */   // (trunc:{ *:[i32] } GPR64sp:{ *:[i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i32] } GPR64sp:{ *:[i64] }:$src, sub_32:{ *:[i32] })
     /* 277619 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 277622 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 277624 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // src
     /* 277630 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 277635 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 277640 */   // GIR_Coverage, 6590,
     /* 277640 */   GIR_EraseRootFromParent_Done,
     /* 277641 */ // Label 5383: @277641
     /* 277641 */ GIM_Reject,
     /* 277642 */ // Label 5379: @277642
     /* 277642 */ GIM_Try, /*On fail goto*//*Label 5384*/ GIMT_Encode4(277997),
     /* 277647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 277650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277654 */   GIM_Try, /*On fail goto*//*Label 5385*/ GIMT_Encode4(277732), // Rule ID 5470 //
     /* 277659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 277667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 277671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 277675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 277679 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 277683 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 277687 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277692 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 277696 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277702 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 277704 */     // MIs[1] Operand 2
     /* 277704 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 277715 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 277717 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 277717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 277720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 277726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 277730 */     GIR_RootConstrainSelectedInstOperands,
     /* 277731 */     // GIR_Coverage, 5470,
     /* 277731 */     GIR_EraseRootFromParent_Done,
     /* 277732 */   // Label 5385: @277732
     /* 277732 */   GIM_Try, /*On fail goto*//*Label 5386*/ GIMT_Encode4(277803), // Rule ID 5466 //
     /* 277737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 277745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 277749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 277753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 277757 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 277761 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 277765 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277770 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277775 */     // MIs[1] Operand 2
     /* 277775 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 277786 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 277788 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (ADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 277788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v2i32),
     /* 277791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 277797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 277801 */     GIR_RootConstrainSelectedInstOperands,
     /* 277802 */     // GIR_Coverage, 5466,
     /* 277802 */     GIR_EraseRootFromParent_Done,
     /* 277803 */   // Label 5386: @277803
     /* 277803 */   GIM_Try, /*On fail goto*//*Label 5387*/ GIMT_Encode4(277874), // Rule ID 5468 //
     /* 277808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 277816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 277820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 277824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 277828 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 277832 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 277836 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277841 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277846 */     // MIs[1] Operand 2
     /* 277846 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 277857 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 277859 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 277859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 277862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 277868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 277872 */     GIR_RootConstrainSelectedInstOperands,
     /* 277873 */     // GIR_Coverage, 5468,
     /* 277873 */     GIR_EraseRootFromParent_Done,
     /* 277874 */   // Label 5387: @277874
     /* 277874 */   GIM_Try, /*On fail goto*//*Label 5388*/ GIMT_Encode4(277927), // Rule ID 2162 //
     /* 277879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 277890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 277894 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277899 */     // MIs[1] imm
     /* 277899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 277903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 277907 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 277911 */     // MIs[2] Operand 1
     /* 277911 */     // No operand predicates
     /* 277911 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 277913 */     // (trunc:{ *:[v2i32] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (SHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 277913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv2i32_shift),
     /* 277916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 277922 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 277925 */     GIR_RootConstrainSelectedInstOperands,
     /* 277926 */     // GIR_Coverage, 2162,
     /* 277926 */     GIR_EraseRootFromParent_Done,
     /* 277927 */   // Label 5388: @277927
     /* 277927 */   GIM_Try, /*On fail goto*//*Label 5389*/ GIMT_Encode4(277977), // Rule ID 6406 //
     /* 277932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 277940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 277944 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277949 */     // MIs[1] imm
     /* 277949 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 277953 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 277957 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 277961 */     // MIs[2] Operand 1
     /* 277961 */     // No operand predicates
     /* 277961 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 277963 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (SHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /* 277963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv2i32_shift),
     /* 277966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 277972 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 277975 */     GIR_RootConstrainSelectedInstOperands,
     /* 277976 */     // GIR_Coverage, 6406,
     /* 277976 */     GIR_EraseRootFromParent_Done,
     /* 277977 */   // Label 5389: @277977
     /* 277977 */   GIM_Try, /*On fail goto*//*Label 5390*/ GIMT_Encode4(277996), // Rule ID 1099 //
     /* 277982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277985 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277989 */     // (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn)  =>  (XTNv2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn)
     /* 277989 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv2i32),
     /* 277994 */     GIR_RootConstrainSelectedInstOperands,
     /* 277995 */     // GIR_Coverage, 1099,
     /* 277995 */     GIR_Done,
     /* 277996 */   // Label 5390: @277996
     /* 277996 */   GIM_Reject,
     /* 277997 */ // Label 5384: @277997
     /* 277997 */ GIM_Reject,
     /* 277998 */ // Label 5380: @277998
     /* 277998 */ GIM_Try, /*On fail goto*//*Label 5391*/ GIMT_Encode4(278496),
     /* 278003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278010 */   GIM_Try, /*On fail goto*//*Label 5392*/ GIMT_Encode4(278088), // Rule ID 5464 //
     /* 278015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 278023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 278031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 278035 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278039 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 278043 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278048 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 278052 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278058 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 278060 */     // MIs[1] Operand 2
     /* 278060 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 278071 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 278073 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 278073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 278076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 278082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 278086 */     GIR_RootConstrainSelectedInstOperands,
     /* 278087 */     // GIR_Coverage, 5464,
     /* 278087 */     GIR_EraseRootFromParent_Done,
     /* 278088 */   // Label 5392: @278088
     /* 278088 */   GIM_Try, /*On fail goto*//*Label 5393*/ GIMT_Encode4(278159), // Rule ID 5460 //
     /* 278093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 278101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 278109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 278113 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278117 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 278121 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278126 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278131 */     // MIs[1] Operand 2
     /* 278131 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 278142 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278144 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (ADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 278144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v4i16),
     /* 278147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 278153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 278157 */     GIR_RootConstrainSelectedInstOperands,
     /* 278158 */     // GIR_Coverage, 5460,
     /* 278158 */     GIR_EraseRootFromParent_Done,
     /* 278159 */   // Label 5393: @278159
     /* 278159 */   GIM_Try, /*On fail goto*//*Label 5394*/ GIMT_Encode4(278230), // Rule ID 5462 //
     /* 278164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 278172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 278180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 278184 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278188 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 278192 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278197 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278202 */     // MIs[1] Operand 2
     /* 278202 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 278213 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278215 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 278215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 278218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 278224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 278228 */     GIR_RootConstrainSelectedInstOperands,
     /* 278229 */     // GIR_Coverage, 5462,
     /* 278229 */     GIR_EraseRootFromParent_Done,
     /* 278230 */   // Label 5394: @278230
     /* 278230 */   GIM_Try, /*On fail goto*//*Label 5395*/ GIMT_Encode4(278322), // Rule ID 5586 //
     /* 278235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 278243 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 278246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 278250 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 278254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 278258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 278262 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 278266 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278271 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 278275 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 278279 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 278283 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278288 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 278290 */     // (trunc:{ *:[v4i16] } (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn), (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vm)))  =>  (XTNv4i16:{ *:[v4i16] } (UZP1v4i32:{ *:[f128] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm))
     /* 278290 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 278293 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 278297 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278302 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 278306 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, // Vm
     /* 278310 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 278312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i16),
     /* 278315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278317 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278320 */     GIR_RootConstrainSelectedInstOperands,
     /* 278321 */     // GIR_Coverage, 5586,
     /* 278321 */     GIR_EraseRootFromParent_Done,
     /* 278322 */   // Label 5395: @278322
     /* 278322 */   GIM_Try, /*On fail goto*//*Label 5396*/ GIMT_Encode4(278375), // Rule ID 2161 //
     /* 278327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 278338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278342 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278347 */     // MIs[1] imm
     /* 278347 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 278351 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 278355 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 278359 */     // MIs[2] Operand 1
     /* 278359 */     // No operand predicates
     /* 278359 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278361 */     // (trunc:{ *:[v4i16] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (SHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 278361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i16_shift),
     /* 278364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 278370 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 278373 */     GIR_RootConstrainSelectedInstOperands,
     /* 278374 */     // GIR_Coverage, 2161,
     /* 278374 */     GIR_EraseRootFromParent_Done,
     /* 278375 */   // Label 5396: @278375
     /* 278375 */   GIM_Try, /*On fail goto*//*Label 5397*/ GIMT_Encode4(278425), // Rule ID 6405 //
     /* 278380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 278388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278392 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278397 */     // MIs[1] imm
     /* 278397 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 278401 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 278405 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 278409 */     // MIs[2] Operand 1
     /* 278409 */     // No operand predicates
     /* 278409 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278411 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (SHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /* 278411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i16_shift),
     /* 278414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 278420 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 278423 */     GIR_RootConstrainSelectedInstOperands,
     /* 278424 */     // GIR_Coverage, 6405,
     /* 278424 */     GIR_EraseRootFromParent_Done,
     /* 278425 */   // Label 5397: @278425
     /* 278425 */   GIM_Try, /*On fail goto*//*Label 5398*/ GIMT_Encode4(278476), // Rule ID 5614 //
     /* 278430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 278438 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 278441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 278445 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 278449 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278454 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278461 */     // (trunc:{ *:[v4i16] } (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vm))  =>  (UZP1v4i16:{ *:[v4i16] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vm)
     /* 278461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 278464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 278470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 278474 */     GIR_RootConstrainSelectedInstOperands,
     /* 278475 */     // GIR_Coverage, 5614,
     /* 278475 */     GIR_EraseRootFromParent_Done,
     /* 278476 */   // Label 5398: @278476
     /* 278476 */   GIM_Try, /*On fail goto*//*Label 5399*/ GIMT_Encode4(278495), // Rule ID 1098 //
     /* 278481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278488 */     // (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn)  =>  (XTNv4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn)
     /* 278488 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i16),
     /* 278493 */     GIR_RootConstrainSelectedInstOperands,
     /* 278494 */     // GIR_Coverage, 1098,
     /* 278494 */     GIR_Done,
     /* 278495 */   // Label 5399: @278495
     /* 278495 */   GIM_Reject,
     /* 278496 */ // Label 5391: @278496
     /* 278496 */ GIM_Reject,
     /* 278497 */ // Label 5381: @278497
     /* 278497 */ GIM_Try, /*On fail goto*//*Label 5400*/ GIMT_Encode4(278995),
     /* 278502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278509 */   GIM_Try, /*On fail goto*//*Label 5401*/ GIMT_Encode4(278587), // Rule ID 5458 //
     /* 278514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 278522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 278530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 278534 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278538 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 278542 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278547 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 278551 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278557 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 278559 */     // MIs[1] Operand 2
     /* 278559 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 278570 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 278572 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 278572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 278575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 278581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 278585 */     GIR_RootConstrainSelectedInstOperands,
     /* 278586 */     // GIR_Coverage, 5458,
     /* 278586 */     GIR_EraseRootFromParent_Done,
     /* 278587 */   // Label 5401: @278587
     /* 278587 */   GIM_Try, /*On fail goto*//*Label 5402*/ GIMT_Encode4(278658), // Rule ID 5454 //
     /* 278592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 278600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 278608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 278612 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278616 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 278620 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278625 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278630 */     // MIs[1] Operand 2
     /* 278630 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 278641 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278643 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (ADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 278643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v8i8),
     /* 278646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 278652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 278656 */     GIR_RootConstrainSelectedInstOperands,
     /* 278657 */     // GIR_Coverage, 5454,
     /* 278657 */     GIR_EraseRootFromParent_Done,
     /* 278658 */   // Label 5402: @278658
     /* 278658 */   GIM_Try, /*On fail goto*//*Label 5403*/ GIMT_Encode4(278729), // Rule ID 5456 //
     /* 278663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 278671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 278679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 278683 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278687 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 278691 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278696 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278701 */     // MIs[1] Operand 2
     /* 278701 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 278712 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278714 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 278714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 278717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 278723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 278727 */     GIR_RootConstrainSelectedInstOperands,
     /* 278728 */     // GIR_Coverage, 5456,
     /* 278728 */     GIR_EraseRootFromParent_Done,
     /* 278729 */   // Label 5403: @278729
     /* 278729 */   GIM_Try, /*On fail goto*//*Label 5404*/ GIMT_Encode4(278821), // Rule ID 5559 //
     /* 278734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 278742 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 278745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 278749 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 278753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 278757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 278761 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278765 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278770 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 278774 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 278778 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278782 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278787 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 278789 */     // (trunc:{ *:[v8i8] } (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn), (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vm)))  =>  (XTNv8i8:{ *:[v8i8] } (UZP1v8i16:{ *:[f128] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm))
     /* 278789 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 278792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 278796 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278801 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 278805 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, // Vm
     /* 278809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 278811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i8),
     /* 278814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278819 */     GIR_RootConstrainSelectedInstOperands,
     /* 278820 */     // GIR_Coverage, 5559,
     /* 278820 */     GIR_EraseRootFromParent_Done,
     /* 278821 */   // Label 5404: @278821
     /* 278821 */   GIM_Try, /*On fail goto*//*Label 5405*/ GIMT_Encode4(278874), // Rule ID 2160 //
     /* 278826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 278837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278846 */     // MIs[1] imm
     /* 278846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 278850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 278854 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 278858 */     // MIs[2] Operand 1
     /* 278858 */     // No operand predicates
     /* 278858 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278860 */     // (trunc:{ *:[v8i8] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (SHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 278860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i8_shift),
     /* 278863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 278869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 278872 */     GIR_RootConstrainSelectedInstOperands,
     /* 278873 */     // GIR_Coverage, 2160,
     /* 278873 */     GIR_EraseRootFromParent_Done,
     /* 278874 */   // Label 5405: @278874
     /* 278874 */   GIM_Try, /*On fail goto*//*Label 5406*/ GIMT_Encode4(278924), // Rule ID 6404 //
     /* 278879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 278887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278896 */     // MIs[1] imm
     /* 278896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 278900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 278904 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 278908 */     // MIs[2] Operand 1
     /* 278908 */     // No operand predicates
     /* 278908 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278910 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (SHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /* 278910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i8_shift),
     /* 278913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 278919 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 278922 */     GIR_RootConstrainSelectedInstOperands,
     /* 278923 */     // GIR_Coverage, 6404,
     /* 278923 */     GIR_EraseRootFromParent_Done,
     /* 278924 */   // Label 5406: @278924
     /* 278924 */   GIM_Try, /*On fail goto*//*Label 5407*/ GIMT_Encode4(278975), // Rule ID 5613 //
     /* 278929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 278937 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 278940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 278944 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 278948 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278960 */     // (trunc:{ *:[v8i8] } (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vm))  =>  (UZP1v8i8:{ *:[v8i8] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vm)
     /* 278960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i8),
     /* 278963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 278969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 278973 */     GIR_RootConstrainSelectedInstOperands,
     /* 278974 */     // GIR_Coverage, 5613,
     /* 278974 */     GIR_EraseRootFromParent_Done,
     /* 278975 */   // Label 5407: @278975
     /* 278975 */   GIM_Try, /*On fail goto*//*Label 5408*/ GIMT_Encode4(278994), // Rule ID 1097 //
     /* 278980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278987 */     // (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn)  =>  (XTNv8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn)
     /* 278987 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i8),
     /* 278992 */     GIR_RootConstrainSelectedInstOperands,
     /* 278993 */     // GIR_Coverage, 1097,
     /* 278993 */     GIR_Done,
     /* 278994 */   // Label 5408: @278994
     /* 278994 */   GIM_Reject,
     /* 278995 */ // Label 5400: @278995
     /* 278995 */ GIM_Reject,
     /* 278996 */ // Label 5382: @278996
     /* 278996 */ GIM_Reject,
     /* 278997 */ // Label 41: @278997
     /* 278997 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5411*/ GIMT_Encode4(279116),
     /* 279008 */ /*GILLT_s32*//*Label 5409*/ GIMT_Encode4(279016),
     /* 279012 */ /*GILLT_s64*//*Label 5410*/ GIMT_Encode4(279036),
     /* 279016 */ // Label 5409: @279016
     /* 279016 */ GIM_Try, /*On fail goto*//*Label 5412*/ GIMT_Encode4(279035), // Rule ID 81 //
     /* 279021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 279025 */   // MIs[0] Operand 1
     /* 279025 */   // No operand predicates
     /* 279025 */   // (imm:{ *:[i32] }):$src  =>  (MOVi32imm:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /* 279025 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /* 279028 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 279030 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 279033 */   GIR_RootConstrainSelectedInstOperands,
     /* 279034 */   // GIR_Coverage, 81,
     /* 279034 */   GIR_EraseRootFromParent_Done,
     /* 279035 */ // Label 5412: @279035
     /* 279035 */ GIM_Reject,
     /* 279036 */ // Label 5410: @279036
     /* 279036 */ GIM_Try, /*On fail goto*//*Label 5413*/ GIMT_Encode4(279096), // Rule ID 3930 //
     /* 279041 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptimizedGISelOrOtherSelector),
     /* 279044 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /* 279048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 279052 */   // MIs[0] Operand 1
     /* 279052 */   // No operand predicates
     /* 279052 */   // (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$src  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$src)), sub_32:{ *:[i32] })
     /* 279052 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 279055 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /* 279059 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279064 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // src
     /* 279069 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 279071 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 279074 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 279076 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279079 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279082 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 279085 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 279090 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 279095 */   // GIR_Coverage, 3930,
     /* 279095 */   GIR_EraseRootFromParent_Done,
     /* 279096 */ // Label 5413: @279096
     /* 279096 */ GIM_Try, /*On fail goto*//*Label 5414*/ GIMT_Encode4(279115), // Rule ID 82 //
     /* 279101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 279105 */   // MIs[0] Operand 1
     /* 279105 */   // No operand predicates
     /* 279105 */   // (imm:{ *:[i64] }):$src  =>  (MOVi64imm:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 279105 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVi64imm),
     /* 279108 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 279110 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 279113 */   GIR_RootConstrainSelectedInstOperands,
     /* 279114 */   // GIR_Coverage, 82,
     /* 279114 */   GIR_EraseRootFromParent_Done,
     /* 279115 */ // Label 5414: @279115
     /* 279115 */ GIM_Reject,
     /* 279116 */ // Label 5411: @279116
     /* 279116 */ GIM_Reject,
     /* 279117 */ // Label 42: @279117
     /* 279117 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 5418*/ GIMT_Encode4(279357),
     /* 279128 */ /*GILLT_s16*//*Label 5415*/ GIMT_Encode4(279140),
     /* 279132 */ /*GILLT_s32*//*Label 5416*/ GIMT_Encode4(279192),
     /* 279136 */ /*GILLT_s64*//*Label 5417*/ GIMT_Encode4(279305),
     /* 279140 */ // Label 5415: @279140
     /* 279140 */ GIM_Try, /*On fail goto*//*Label 5419*/ GIMT_Encode4(279163), // Rule ID 506 //
     /* 279145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 279148 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 279152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279156 */   // MIs[0] Operand 1
     /* 279156 */   // No operand predicates
     /* 279156 */   // (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>  =>  (FMOVH0:{ *:[f16] })
     /* 279156 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVH0),
     /* 279159 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279161 */   GIR_RootConstrainSelectedInstOperands,
     /* 279162 */   // GIR_Coverage, 506,
     /* 279162 */   GIR_EraseRootFromParent_Done,
     /* 279163 */ // Label 5419: @279163
     /* 279163 */ GIM_Try, /*On fail goto*//*Label 5420*/ GIMT_Encode4(279191), // Rule ID 688 //
     /* 279168 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 279171 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 279175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279179 */   // MIs[0] Operand 1
     /* 279179 */   // No operand predicates
     /* 279179 */   // (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm  =>  (FMOVHi:{ *:[f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] }):$imm))
     /* 279179 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVHi),
     /* 279182 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279184 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm
     /* 279189 */   GIR_RootConstrainSelectedInstOperands,
     /* 279190 */   // GIR_Coverage, 688,
     /* 279190 */   GIR_EraseRootFromParent_Done,
     /* 279191 */ // Label 5420: @279191
     /* 279191 */ GIM_Reject,
     /* 279192 */ // Label 5416: @279192
     /* 279192 */ GIM_Try, /*On fail goto*//*Label 5421*/ GIMT_Encode4(279215), // Rule ID 507 //
     /* 279197 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 279200 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 279204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 279208 */   // MIs[0] Operand 1
     /* 279208 */   // No operand predicates
     /* 279208 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>  =>  (FMOVS0:{ *:[f32] })
     /* 279208 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVS0),
     /* 279211 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279213 */   GIR_RootConstrainSelectedInstOperands,
     /* 279214 */   // GIR_Coverage, 507,
     /* 279214 */   GIR_EraseRootFromParent_Done,
     /* 279215 */ // Label 5421: @279215
     /* 279215 */ GIM_Try, /*On fail goto*//*Label 5422*/ GIMT_Encode4(279243), // Rule ID 689 //
     /* 279220 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 279223 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 279227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 279231 */   // MIs[0] Operand 1
     /* 279231 */   // No operand predicates
     /* 279231 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm  =>  (FMOVSi:{ *:[f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] }):$imm))
     /* 279231 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVSi),
     /* 279234 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279236 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm
     /* 279241 */   GIR_RootConstrainSelectedInstOperands,
     /* 279242 */   // GIR_Coverage, 689,
     /* 279242 */   GIR_EraseRootFromParent_Done,
     /* 279243 */ // Label 5422: @279243
     /* 279243 */ GIM_Try, /*On fail goto*//*Label 5423*/ GIMT_Encode4(279304), // Rule ID 6093 //
     /* 279248 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279251 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4),
     /* 279255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 279259 */   // MIs[0] Operand 1
     /* 279259 */   // No operand predicates
     /* 279259 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm32SIMDModImmType4>><<X:fpimm32SIMDModImmType4XForm>>:$in  =>  (EXTRACT_SUBREG:{ *:[f32] } (MOVIv2i32:{ *:[i64] } (fpimm32SIMDModImmType4XForm:{ *:[i32] } f32:{ *:[f32] }:$in), 24:{ *:[i32] }), ssub:{ *:[i32] })
     /* 279259 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 279262 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2i32),
     /* 279266 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279271 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32SIMDModImmType4), // in
     /* 279276 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/24,
     /* 279279 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 279281 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 279284 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 279286 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 279293 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 279298 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279303 */   // GIR_Coverage, 6093,
     /* 279303 */   GIR_EraseRootFromParent_Done,
     /* 279304 */ // Label 5423: @279304
     /* 279304 */ GIM_Reject,
     /* 279305 */ // Label 5417: @279305
     /* 279305 */ GIM_Try, /*On fail goto*//*Label 5424*/ GIMT_Encode4(279328), // Rule ID 508 //
     /* 279310 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 279313 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 279317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279321 */   // MIs[0] Operand 1
     /* 279321 */   // No operand predicates
     /* 279321 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>  =>  (FMOVD0:{ *:[f64] })
     /* 279321 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVD0),
     /* 279324 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279326 */   GIR_RootConstrainSelectedInstOperands,
     /* 279327 */   // GIR_Coverage, 508,
     /* 279327 */   GIR_EraseRootFromParent_Done,
     /* 279328 */ // Label 5424: @279328
     /* 279328 */ GIM_Try, /*On fail goto*//*Label 5425*/ GIMT_Encode4(279356), // Rule ID 690 //
     /* 279333 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 279336 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 279340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279344 */   // MIs[0] Operand 1
     /* 279344 */   // No operand predicates
     /* 279344 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm  =>  (FMOVDi:{ *:[f64] } (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] }):$imm))
     /* 279344 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVDi),
     /* 279347 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279349 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm
     /* 279354 */   GIR_RootConstrainSelectedInstOperands,
     /* 279355 */   // GIR_Coverage, 690,
     /* 279355 */   GIR_EraseRootFromParent_Done,
     /* 279356 */ // Label 5425: @279356
     /* 279356 */ GIM_Reject,
     /* 279357 */ // Label 5418: @279357
     /* 279357 */ GIM_Reject,
     /* 279358 */ // Label 43: @279358
     /* 279358 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5431*/ GIMT_Encode4(281255),
     /* 279369 */ /*GILLT_s32*//*Label 5426*/ GIMT_Encode4(279405),
     /* 279373 */ /*GILLT_s64*//*Label 5427*/ GIMT_Encode4(280846), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 279385 */ /*GILLT_v2s64*//*Label 5428*/ GIMT_Encode4(281069), GIMT_Encode4(0),
     /* 279393 */ /*GILLT_v4s32*//*Label 5429*/ GIMT_Encode4(281131), GIMT_Encode4(0),
     /* 279401 */ /*GILLT_v8s16*//*Label 5430*/ GIMT_Encode4(281193),
     /* 279405 */ // Label 5426: @279405
     /* 279405 */ GIM_Try, /*On fail goto*//*Label 5432*/ GIMT_Encode4(279525), // Rule ID 13265 //
     /* 279410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 279413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 279417 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279421 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 279425 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 279428 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 279433 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 279437 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279442 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279444 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 279444 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 279447 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 279451 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279456 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 279460 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 279462 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 279465 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 279469 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279474 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 279476 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 279479 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 279483 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279488 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 279491 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 279494 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 279497 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279502 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279507 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 279512 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 279515 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279517 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279520 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279523 */   GIR_RootConstrainSelectedInstOperands,
     /* 279524 */   // GIR_Coverage, 13265,
     /* 279524 */   GIR_EraseRootFromParent_Done,
     /* 279525 */ // Label 5432: @279525
     /* 279525 */ GIM_Try, /*On fail goto*//*Label 5433*/ GIMT_Encode4(279645), // Rule ID 13267 //
     /* 279530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 279533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 279537 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279541 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 279545 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 279548 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 279553 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 279557 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279562 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279564 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 279564 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 279567 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 279571 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279576 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 279580 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 279582 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 279585 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 279589 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279594 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 279596 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 279599 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 279603 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279608 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 279611 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 279614 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 279617 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279622 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279627 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 279632 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 279635 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279637 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279640 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279643 */   GIR_RootConstrainSelectedInstOperands,
     /* 279644 */   // GIR_Coverage, 13267,
     /* 279644 */   GIR_EraseRootFromParent_Done,
     /* 279645 */ // Label 5433: @279645
     /* 279645 */ GIM_Try, /*On fail goto*//*Label 5434*/ GIMT_Encode4(279765), // Rule ID 13269 //
     /* 279650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 279653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 279657 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279661 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 279665 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 279668 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 279673 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 279677 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279682 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279684 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 279684 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 279687 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 279691 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279696 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 279700 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 279702 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 279705 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 279709 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279714 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 279716 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 279719 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 279723 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279728 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 279731 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 279734 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 279737 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279742 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279747 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 279755 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279757 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279760 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279763 */   GIR_RootConstrainSelectedInstOperands,
     /* 279764 */   // GIR_Coverage, 13269,
     /* 279764 */   GIR_EraseRootFromParent_Done,
     /* 279765 */ // Label 5434: @279765
     /* 279765 */ GIM_Try, /*On fail goto*//*Label 5435*/ GIMT_Encode4(279885), // Rule ID 13271 //
     /* 279770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 279773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 279777 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279781 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 279785 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 279788 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 279793 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 279797 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279802 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279804 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 279804 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 279807 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 279811 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279816 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 279820 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 279822 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 279825 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 279829 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279834 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 279836 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 279839 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 279843 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279848 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 279851 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 279854 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 279857 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279862 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279867 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 279875 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279877 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279880 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279883 */   GIR_RootConstrainSelectedInstOperands,
     /* 279884 */   // GIR_Coverage, 13271,
     /* 279884 */   GIR_EraseRootFromParent_Done,
     /* 279885 */ // Label 5435: @279885
     /* 279885 */ GIM_Try, /*On fail goto*//*Label 5436*/ GIMT_Encode4(280005), // Rule ID 13287 //
     /* 279890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 279893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 279897 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279901 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 279905 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 279908 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 279913 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 279917 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279922 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279924 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 682:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 279924 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 279927 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 279931 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279936 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 279940 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 279942 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 279945 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 279949 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279954 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 279956 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 279959 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 279963 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279968 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 279971 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 279974 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 279977 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279982 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279987 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 279992 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 279995 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279997 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280000 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280003 */   GIR_RootConstrainSelectedInstOperands,
     /* 280004 */   // GIR_Coverage, 13287,
     /* 280004 */   GIR_EraseRootFromParent_Done,
     /* 280005 */ // Label 5436: @280005
     /* 280005 */ GIM_Try, /*On fail goto*//*Label 5437*/ GIMT_Encode4(280125), // Rule ID 13289 //
     /* 280010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 280013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 280017 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280021 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 280025 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 280028 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 280033 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 280037 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280042 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280044 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 682:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 280044 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 280047 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 280051 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280056 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 280060 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 280062 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 280065 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 280069 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280074 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 280076 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 280079 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 280083 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280088 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 280091 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 280094 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 280097 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280102 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280107 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 280112 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 280115 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280117 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280120 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280123 */   GIR_RootConstrainSelectedInstOperands,
     /* 280124 */   // GIR_Coverage, 13289,
     /* 280124 */   GIR_EraseRootFromParent_Done,
     /* 280125 */ // Label 5437: @280125
     /* 280125 */ GIM_Try, /*On fail goto*//*Label 5438*/ GIMT_Encode4(280245), // Rule ID 13291 //
     /* 280130 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 280133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 280137 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280141 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 280145 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 280148 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 280153 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 280157 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280162 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280164 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 682:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 280164 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 280167 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 280171 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280176 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 280180 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 280182 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 280185 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 280189 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280194 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 280196 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 280199 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 280203 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280208 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 280211 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 280214 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 280217 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280222 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280227 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280232 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 280235 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280237 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280240 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280243 */   GIR_RootConstrainSelectedInstOperands,
     /* 280244 */   // GIR_Coverage, 13291,
     /* 280244 */   GIR_EraseRootFromParent_Done,
     /* 280245 */ // Label 5438: @280245
     /* 280245 */ GIM_Try, /*On fail goto*//*Label 5439*/ GIMT_Encode4(280365), // Rule ID 13293 //
     /* 280250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 280253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 280257 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280261 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 280265 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 280268 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 280273 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 280277 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280282 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280284 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 682:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 280284 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 280287 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 280291 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280296 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 280300 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 280302 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 280305 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 280309 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280314 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 280316 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 280319 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 280323 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280328 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 280331 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 280334 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 280337 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280342 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280347 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280352 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 280355 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280357 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280360 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280363 */   GIR_RootConstrainSelectedInstOperands,
     /* 280364 */   // GIR_Coverage, 13293,
     /* 280364 */   GIR_EraseRootFromParent_Done,
     /* 280365 */ // Label 5439: @280365
     /* 280365 */ GIM_Try, /*On fail goto*//*Label 5440*/ GIMT_Encode4(280485), // Rule ID 13297 //
     /* 280370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 280373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 280377 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280381 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 280385 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 280388 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 280393 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 280397 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280402 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280404 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 685:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 280404 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 280407 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 280411 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280416 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 280420 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 280422 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 280425 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 280429 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280434 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 280436 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 280439 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 280443 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280448 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 280451 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 280454 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 280457 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280462 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280467 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 280472 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 280475 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280477 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280480 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280483 */   GIR_RootConstrainSelectedInstOperands,
     /* 280484 */   // GIR_Coverage, 13297,
     /* 280484 */   GIR_EraseRootFromParent_Done,
     /* 280485 */ // Label 5440: @280485
     /* 280485 */ GIM_Try, /*On fail goto*//*Label 5441*/ GIMT_Encode4(280605), // Rule ID 13299 //
     /* 280490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 280493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 280497 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280501 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 280505 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 280508 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 280513 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 280517 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280522 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280524 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 685:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 280524 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 280527 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 280531 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280536 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 280540 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 280542 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 280545 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 280549 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280554 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 280556 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 280559 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 280563 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280568 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 280571 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 280574 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 280577 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280582 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280587 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 280592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 280595 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280597 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280600 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280603 */   GIR_RootConstrainSelectedInstOperands,
     /* 280604 */   // GIR_Coverage, 13299,
     /* 280604 */   GIR_EraseRootFromParent_Done,
     /* 280605 */ // Label 5441: @280605
     /* 280605 */ GIM_Try, /*On fail goto*//*Label 5442*/ GIMT_Encode4(280725), // Rule ID 13301 //
     /* 280610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 280613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 280617 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280621 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 280625 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 280628 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 280633 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 280637 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280642 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280644 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 685:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 280644 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 280647 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 280651 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280656 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 280660 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 280662 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 280665 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 280669 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280674 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 280676 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 280679 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 280683 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280688 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 280691 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 280694 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 280697 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280702 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280707 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280712 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 280715 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280717 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280720 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280723 */   GIR_RootConstrainSelectedInstOperands,
     /* 280724 */   // GIR_Coverage, 13301,
     /* 280724 */   GIR_EraseRootFromParent_Done,
     /* 280725 */ // Label 5442: @280725
     /* 280725 */ GIM_Try, /*On fail goto*//*Label 5443*/ GIMT_Encode4(280845), // Rule ID 13303 //
     /* 280730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 280733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 280737 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280741 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 280745 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 280748 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 280753 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 280757 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280762 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280764 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 685:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 280764 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 280767 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 280771 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280776 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 280780 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 280782 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 280785 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 280789 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280794 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 280796 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 280799 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 280803 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280808 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 280811 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 280814 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 280817 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280822 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280827 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280832 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 280835 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280837 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280840 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280843 */   GIR_RootConstrainSelectedInstOperands,
     /* 280844 */   // GIR_Coverage, 13303,
     /* 280844 */   GIR_EraseRootFromParent_Done,
     /* 280845 */ // Label 5443: @280845
     /* 280845 */ GIM_Reject,
     /* 280846 */ // Label 5427: @280846
     /* 280846 */ GIM_Try, /*On fail goto*//*Label 5444*/ GIMT_Encode4(281068),
     /* 280851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 280854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 280858 */   GIM_Try, /*On fail goto*//*Label 5445*/ GIMT_Encode4(280912), // Rule ID 5699 //
     /* 280863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 280875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 280879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 280888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280892 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 280896 */     // MIs[2] Operand 1
     /* 280896 */     // No operand predicates
     /* 280896 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280898 */     // (sext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SMOVvi32to64:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 280898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi32to64),
     /* 280901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 280907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 280910 */     GIR_RootConstrainSelectedInstOperands,
     /* 280911 */     // GIR_Coverage, 5699,
     /* 280911 */     GIR_EraseRootFromParent_Done,
     /* 280912 */   // Label 5445: @280912
     /* 280912 */   GIM_Try, /*On fail goto*//*Label 5446*/ GIMT_Encode4(280991), // Rule ID 11347 //
     /* 280917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 280932 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 280936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 280940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280944 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 280948 */     // MIs[2] Operand 1
     /* 280948 */     // No operand predicates
     /* 280948 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280950 */     // (sext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index))  =>  (SMOVvi32to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)
     /* 280950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 280953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280962 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 280968 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280973 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi32to64),
     /* 280981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280986 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 280989 */     GIR_RootConstrainSelectedInstOperands,
     /* 280990 */     // GIR_Coverage, 11347,
     /* 280990 */     GIR_EraseRootFromParent_Done,
     /* 280991 */   // Label 5446: @280991
     /* 280991 */   GIM_Try, /*On fail goto*//*Label 5447*/ GIMT_Encode4(281067), // Rule ID 6571 //
     /* 280996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 281000 */     // (sext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (SBFMXri:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] }), 0:{ *:[i64] }, 31:{ *:[i64] })
     /* 281000 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 281003 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 281007 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 281014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 281017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 281021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281026 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 281029 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 281033 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 281036 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 281041 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 281046 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 281051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 281054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281056 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 281065 */     GIR_RootConstrainSelectedInstOperands,
     /* 281066 */     // GIR_Coverage, 6571,
     /* 281066 */     GIR_EraseRootFromParent_Done,
     /* 281067 */   // Label 5447: @281067
     /* 281067 */   GIM_Reject,
     /* 281068 */ // Label 5444: @281068
     /* 281068 */ GIM_Reject,
     /* 281069 */ // Label 5428: @281069
     /* 281069 */ GIM_Try, /*On fail goto*//*Label 5448*/ GIMT_Encode4(281130),
     /* 281074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 281077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281081 */   GIM_Try, /*On fail goto*//*Label 5449*/ GIMT_Encode4(281108), // Rule ID 6433 //
     /* 281086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 281093 */     // (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (SSHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 281093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i32_shift),
     /* 281096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 281103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281106 */     GIR_RootConstrainSelectedInstOperands,
     /* 281107 */     // GIR_Coverage, 6433,
     /* 281107 */     GIR_EraseRootFromParent_Done,
     /* 281108 */   // Label 5449: @281108
     /* 281108 */   GIM_Try, /*On fail goto*//*Label 5450*/ GIMT_Encode4(281129), // Rule ID 6422 //
     /* 281113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281117 */     // (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (SSHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 281117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 281120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281122 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 281124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281127 */     GIR_RootConstrainSelectedInstOperands,
     /* 281128 */     // GIR_Coverage, 6422,
     /* 281128 */     GIR_EraseRootFromParent_Done,
     /* 281129 */   // Label 5450: @281129
     /* 281129 */   GIM_Reject,
     /* 281130 */ // Label 5448: @281130
     /* 281130 */ GIM_Reject,
     /* 281131 */ // Label 5429: @281131
     /* 281131 */ GIM_Try, /*On fail goto*//*Label 5451*/ GIMT_Encode4(281192),
     /* 281136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 281139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281143 */   GIM_Try, /*On fail goto*//*Label 5452*/ GIMT_Encode4(281170), // Rule ID 6430 //
     /* 281148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 281155 */     // (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (SSHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 281155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i16_shift),
     /* 281158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 281165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281168 */     GIR_RootConstrainSelectedInstOperands,
     /* 281169 */     // GIR_Coverage, 6430,
     /* 281169 */     GIR_EraseRootFromParent_Done,
     /* 281170 */   // Label 5452: @281170
     /* 281170 */   GIM_Try, /*On fail goto*//*Label 5453*/ GIMT_Encode4(281191), // Rule ID 6419 //
     /* 281175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281179 */     // (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SSHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 281179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 281182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281184 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 281186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281189 */     GIR_RootConstrainSelectedInstOperands,
     /* 281190 */     // GIR_Coverage, 6419,
     /* 281190 */     GIR_EraseRootFromParent_Done,
     /* 281191 */   // Label 5453: @281191
     /* 281191 */   GIM_Reject,
     /* 281192 */ // Label 5451: @281192
     /* 281192 */ GIM_Reject,
     /* 281193 */ // Label 5430: @281193
     /* 281193 */ GIM_Try, /*On fail goto*//*Label 5454*/ GIMT_Encode4(281254),
     /* 281198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 281201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281205 */   GIM_Try, /*On fail goto*//*Label 5455*/ GIMT_Encode4(281232), // Rule ID 6427 //
     /* 281210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 281217 */     // (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (SSHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 281217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv16i8_shift),
     /* 281220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 281227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281230 */     GIR_RootConstrainSelectedInstOperands,
     /* 281231 */     // GIR_Coverage, 6427,
     /* 281231 */     GIR_EraseRootFromParent_Done,
     /* 281232 */   // Label 5455: @281232
     /* 281232 */   GIM_Try, /*On fail goto*//*Label 5456*/ GIMT_Encode4(281253), // Rule ID 6416 //
     /* 281237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281241 */     // (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (SSHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 281241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 281244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281246 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 281248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281251 */     GIR_RootConstrainSelectedInstOperands,
     /* 281252 */     // GIR_Coverage, 6416,
     /* 281252 */     GIR_EraseRootFromParent_Done,
     /* 281253 */   // Label 5456: @281253
     /* 281253 */   GIM_Reject,
     /* 281254 */ // Label 5454: @281254
     /* 281254 */ GIM_Reject,
     /* 281255 */ // Label 5431: @281255
     /* 281255 */ GIM_Reject,
     /* 281256 */ // Label 44: @281256
     /* 281256 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(22), /*)*//*default:*//*Label 5462*/ GIMT_Encode4(282909),
     /* 281267 */ /*GILLT_s32*//*Label 5457*/ GIMT_Encode4(281347),
     /* 281271 */ /*GILLT_s64*//*Label 5458*/ GIMT_Encode4(281841), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 281323 */ /*GILLT_nxv2s64*//*Label 5459*/ GIMT_Encode4(282483), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 281335 */ /*GILLT_nxv4s32*//*Label 5460*/ GIMT_Encode4(282692), GIMT_Encode4(0),
     /* 281343 */ /*GILLT_nxv8s16*//*Label 5461*/ GIMT_Encode4(282836),
     /* 281347 */ // Label 5457: @281347
     /* 281347 */ GIM_Try, /*On fail goto*//*Label 5463*/ GIMT_Encode4(281840),
     /* 281352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 281355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 281359 */   GIM_Try, /*On fail goto*//*Label 5464*/ GIMT_Encode4(281424), // Rule ID 5694 //
     /* 281364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 281376 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 281380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281393 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 281397 */     // MIs[2] Operand 1
     /* 281397 */     // No operand predicates
     /* 281397 */     // MIs[0] Operand 2
     /* 281397 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 281408 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281410 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), i8:{ *:[Other] })  =>  (SMOVvi8to32:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 281410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 281413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 281419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 281422 */     GIR_RootConstrainSelectedInstOperands,
     /* 281423 */     // GIR_Coverage, 5694,
     /* 281423 */     GIR_EraseRootFromParent_Done,
     /* 281424 */   // Label 5464: @281424
     /* 281424 */   GIM_Try, /*On fail goto*//*Label 5465*/ GIMT_Encode4(281489), // Rule ID 5696 //
     /* 281429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281437 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281441 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 281445 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281458 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 281462 */     // MIs[2] Operand 1
     /* 281462 */     // No operand predicates
     /* 281462 */     // MIs[0] Operand 2
     /* 281462 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 281473 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281475 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 281475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 281478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 281484 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 281487 */     GIR_RootConstrainSelectedInstOperands,
     /* 281488 */     // GIR_Coverage, 5696,
     /* 281488 */     GIR_EraseRootFromParent_Done,
     /* 281489 */   // Label 5465: @281489
     /* 281489 */   GIM_Try, /*On fail goto*//*Label 5466*/ GIMT_Encode4(281554), // Rule ID 5698 //
     /* 281494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281506 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 281510 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281523 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 281527 */     // MIs[2] Operand 1
     /* 281527 */     // No operand predicates
     /* 281527 */     // MIs[0] Operand 2
     /* 281527 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 281538 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281540 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 281540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 281543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 281549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 281552 */     GIR_RootConstrainSelectedInstOperands,
     /* 281553 */     // GIR_Coverage, 5698,
     /* 281553 */     GIR_EraseRootFromParent_Done,
     /* 281554 */   // Label 5466: @281554
     /* 281554 */   GIM_Try, /*On fail goto*//*Label 5467*/ GIMT_Encode4(281644), // Rule ID 11343 //
     /* 281559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 281574 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 281578 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281582 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281586 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 281590 */     // MIs[2] Operand 1
     /* 281590 */     // No operand predicates
     /* 281590 */     // MIs[0] Operand 2
     /* 281590 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 281601 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281603 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index), i8:{ *:[Other] })  =>  (SMOVvi8to32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 281603 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 281606 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281610 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281615 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 281621 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281626 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 281631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 281634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281636 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 281642 */     GIR_RootConstrainSelectedInstOperands,
     /* 281643 */     // GIR_Coverage, 11343,
     /* 281643 */     GIR_EraseRootFromParent_Done,
     /* 281644 */   // Label 5467: @281644
     /* 281644 */   GIM_Try, /*On fail goto*//*Label 5468*/ GIMT_Encode4(281734), // Rule ID 11345 //
     /* 281649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 281664 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 281668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281676 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 281680 */     // MIs[2] Operand 1
     /* 281680 */     // No operand predicates
     /* 281680 */     // MIs[0] Operand 2
     /* 281680 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 281691 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281693 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 281693 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 281696 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281700 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281705 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 281711 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281716 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 281721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 281724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281729 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 281732 */     GIR_RootConstrainSelectedInstOperands,
     /* 281733 */     // GIR_Coverage, 11345,
     /* 281733 */     GIR_EraseRootFromParent_Done,
     /* 281734 */   // Label 5468: @281734
     /* 281734 */   GIM_Try, /*On fail goto*//*Label 5469*/ GIMT_Encode4(281769), // Rule ID 6576 //
     /* 281739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 281743 */     // MIs[0] Operand 2
     /* 281743 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 281754 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i16:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 15:{ *:[i64] })
     /* 281754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 281757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281759 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 281761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 281767 */     GIR_RootConstrainSelectedInstOperands,
     /* 281768 */     // GIR_Coverage, 6576,
     /* 281768 */     GIR_EraseRootFromParent_Done,
     /* 281769 */   // Label 5469: @281769
     /* 281769 */   GIM_Try, /*On fail goto*//*Label 5470*/ GIMT_Encode4(281804), // Rule ID 6577 //
     /* 281774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 281778 */     // MIs[0] Operand 2
     /* 281778 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 281789 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i8:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 7:{ *:[i64] })
     /* 281789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 281792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281794 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 281796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 281802 */     GIR_RootConstrainSelectedInstOperands,
     /* 281803 */     // GIR_Coverage, 6577,
     /* 281803 */     GIR_EraseRootFromParent_Done,
     /* 281804 */   // Label 5470: @281804
     /* 281804 */   GIM_Try, /*On fail goto*//*Label 5471*/ GIMT_Encode4(281839), // Rule ID 6578 //
     /* 281809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 281813 */     // MIs[0] Operand 2
     /* 281813 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 281824 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i1:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 281824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 281827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281829 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 281831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281837 */     GIR_RootConstrainSelectedInstOperands,
     /* 281838 */     // GIR_Coverage, 6578,
     /* 281838 */     GIR_EraseRootFromParent_Done,
     /* 281839 */   // Label 5471: @281839
     /* 281839 */   GIM_Reject,
     /* 281840 */ // Label 5463: @281840
     /* 281840 */ GIM_Reject,
     /* 281841 */ // Label 5458: @281841
     /* 281841 */ GIM_Try, /*On fail goto*//*Label 5472*/ GIMT_Encode4(282482),
     /* 281846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 281849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 281853 */   GIM_Try, /*On fail goto*//*Label 5473*/ GIMT_Encode4(281930), // Rule ID 5700 //
     /* 281858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 281866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 281870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 281874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281878 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 281882 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 281886 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281891 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 281895 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281899 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 281903 */     // MIs[3] Operand 1
     /* 281903 */     // No operand predicates
     /* 281903 */     // MIs[0] Operand 2
     /* 281903 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 281914 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 281916 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 281916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 281919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 281925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 281928 */     GIR_RootConstrainSelectedInstOperands,
     /* 281929 */     // GIR_Coverage, 5700,
     /* 281929 */     GIR_EraseRootFromParent_Done,
     /* 281930 */   // Label 5473: @281930
     /* 281930 */   GIM_Try, /*On fail goto*//*Label 5474*/ GIMT_Encode4(282007), // Rule ID 5701 //
     /* 281935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 281943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 281947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 281951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281955 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281959 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 281963 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281968 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 281972 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281976 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 281980 */     // MIs[3] Operand 1
     /* 281980 */     // No operand predicates
     /* 281980 */     // MIs[0] Operand 2
     /* 281980 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 281991 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 281993 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 281993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 281996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 282002 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 282005 */     GIR_RootConstrainSelectedInstOperands,
     /* 282006 */     // GIR_Coverage, 5701,
     /* 282006 */     GIR_EraseRootFromParent_Done,
     /* 282007 */   // Label 5474: @282007
     /* 282007 */   GIM_Try, /*On fail goto*//*Label 5475*/ GIMT_Encode4(282109), // Rule ID 11344 //
     /* 282012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 282023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 282027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 282031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282035 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 282039 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 282043 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 282047 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282051 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 282055 */     // MIs[3] Operand 1
     /* 282055 */     // No operand predicates
     /* 282055 */     // MIs[0] Operand 2
     /* 282055 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 282066 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 282068 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 282068 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 282071 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282075 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282080 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 282086 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282091 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 282099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282101 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282104 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // index
     /* 282107 */     GIR_RootConstrainSelectedInstOperands,
     /* 282108 */     // GIR_Coverage, 11344,
     /* 282108 */     GIR_EraseRootFromParent_Done,
     /* 282109 */   // Label 5475: @282109
     /* 282109 */   GIM_Try, /*On fail goto*//*Label 5476*/ GIMT_Encode4(282211), // Rule ID 11346 //
     /* 282114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 282125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 282129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 282133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282137 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 282141 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 282145 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 282149 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282153 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 282157 */     // MIs[3] Operand 1
     /* 282157 */     // No operand predicates
     /* 282157 */     // MIs[0] Operand 2
     /* 282157 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 282168 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 282170 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 282170 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 282173 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282177 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282182 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 282188 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282193 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 282201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282203 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282206 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // index
     /* 282209 */     GIR_RootConstrainSelectedInstOperands,
     /* 282210 */     // GIR_Coverage, 11346,
     /* 282210 */     GIR_EraseRootFromParent_Done,
     /* 282211 */   // Label 5476: @282211
     /* 282211 */   GIM_Try, /*On fail goto*//*Label 5477*/ GIMT_Encode4(282276), // Rule ID 5695 //
     /* 282216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282224 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 282228 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 282232 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282237 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 282241 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282245 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 282249 */     // MIs[2] Operand 1
     /* 282249 */     // No operand predicates
     /* 282249 */     // MIs[0] Operand 2
     /* 282249 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 282260 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282262 */     // (sext_inreg:{ *:[i64] } (vector_extract:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 282262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 282265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 282271 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 282274 */     GIR_RootConstrainSelectedInstOperands,
     /* 282275 */     // GIR_Coverage, 5695,
     /* 282275 */     GIR_EraseRootFromParent_Done,
     /* 282276 */   // Label 5477: @282276
     /* 282276 */   GIM_Try, /*On fail goto*//*Label 5478*/ GIMT_Encode4(282341), // Rule ID 5697 //
     /* 282281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282289 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 282293 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 282297 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 282306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282310 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 282314 */     // MIs[2] Operand 1
     /* 282314 */     // No operand predicates
     /* 282314 */     // MIs[0] Operand 2
     /* 282314 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 282325 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282327 */     // (sext_inreg:{ *:[i64] } (vector_extract:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 282327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 282330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 282336 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 282339 */     GIR_RootConstrainSelectedInstOperands,
     /* 282340 */     // GIR_Coverage, 5697,
     /* 282340 */     GIR_EraseRootFromParent_Done,
     /* 282341 */   // Label 5478: @282341
     /* 282341 */   GIM_Try, /*On fail goto*//*Label 5479*/ GIMT_Encode4(282376), // Rule ID 6572 //
     /* 282346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 282350 */     // MIs[0] Operand 2
     /* 282350 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 282361 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i32:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 31:{ *:[i64] })
     /* 282361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 282364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282366 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 282368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 282374 */     GIR_RootConstrainSelectedInstOperands,
     /* 282375 */     // GIR_Coverage, 6572,
     /* 282375 */     GIR_EraseRootFromParent_Done,
     /* 282376 */   // Label 5479: @282376
     /* 282376 */   GIM_Try, /*On fail goto*//*Label 5480*/ GIMT_Encode4(282411), // Rule ID 6573 //
     /* 282381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 282385 */     // MIs[0] Operand 2
     /* 282385 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 282396 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i16:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 15:{ *:[i64] })
     /* 282396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 282399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282401 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 282403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 282409 */     GIR_RootConstrainSelectedInstOperands,
     /* 282410 */     // GIR_Coverage, 6573,
     /* 282410 */     GIR_EraseRootFromParent_Done,
     /* 282411 */   // Label 5480: @282411
     /* 282411 */   GIM_Try, /*On fail goto*//*Label 5481*/ GIMT_Encode4(282446), // Rule ID 6574 //
     /* 282416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 282420 */     // MIs[0] Operand 2
     /* 282420 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 282431 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i8:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 7:{ *:[i64] })
     /* 282431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 282434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282436 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 282438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 282444 */     GIR_RootConstrainSelectedInstOperands,
     /* 282445 */     // GIR_Coverage, 6574,
     /* 282445 */     GIR_EraseRootFromParent_Done,
     /* 282446 */   // Label 5481: @282446
     /* 282446 */   GIM_Try, /*On fail goto*//*Label 5482*/ GIMT_Encode4(282481), // Rule ID 6575 //
     /* 282451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 282455 */     // MIs[0] Operand 2
     /* 282455 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 282466 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i1:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 282466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 282469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282471 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 282473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282479 */     GIR_RootConstrainSelectedInstOperands,
     /* 282480 */     // GIR_Coverage, 6575,
     /* 282480 */     GIR_EraseRootFromParent_Done,
     /* 282481 */   // Label 5482: @282481
     /* 282481 */   GIM_Reject,
     /* 282482 */ // Label 5472: @282482
     /* 282482 */ GIM_Reject,
     /* 282483 */ // Label 5459: @282483
     /* 282483 */ GIM_Try, /*On fail goto*//*Label 5483*/ GIMT_Encode4(282691),
     /* 282488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 282491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282495 */   GIM_Try, /*On fail goto*//*Label 5484*/ GIMT_Encode4(282560), // Rule ID 10615 //
     /* 282500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282503 */     // MIs[0] Operand 2
     /* 282503 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 282514 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i32:{ *:[Other] })  =>  (SXTW_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 282514 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 282517 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 282521 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282526 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 282529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 282531 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 282534 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282538 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282543 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 282545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTW_ZPmZ_D_UNDEF),
     /* 282548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 282550 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282553 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 282556 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 282558 */     GIR_RootConstrainSelectedInstOperands,
     /* 282559 */     // GIR_Coverage, 10615,
     /* 282559 */     GIR_EraseRootFromParent_Done,
     /* 282560 */   // Label 5484: @282560
     /* 282560 */   GIM_Try, /*On fail goto*//*Label 5485*/ GIMT_Encode4(282625), // Rule ID 10616 //
     /* 282565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282568 */     // MIs[0] Operand 2
     /* 282568 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 282579 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i16:{ *:[Other] })  =>  (SXTH_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 282579 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 282582 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 282586 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282591 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 282594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 282596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 282599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 282610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTH_ZPmZ_D_UNDEF),
     /* 282613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 282615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 282621 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 282623 */     GIR_RootConstrainSelectedInstOperands,
     /* 282624 */     // GIR_Coverage, 10616,
     /* 282624 */     GIR_EraseRootFromParent_Done,
     /* 282625 */   // Label 5485: @282625
     /* 282625 */   GIM_Try, /*On fail goto*//*Label 5486*/ GIMT_Encode4(282690), // Rule ID 10617 //
     /* 282630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282633 */     // MIs[0] Operand 2
     /* 282633 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 282644 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i8:{ *:[Other] })  =>  (SXTB_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 282644 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 282647 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 282651 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282656 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 282659 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 282661 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 282664 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282668 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282673 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 282675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_D_UNDEF),
     /* 282678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 282680 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282683 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 282686 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 282688 */     GIR_RootConstrainSelectedInstOperands,
     /* 282689 */     // GIR_Coverage, 10617,
     /* 282689 */     GIR_EraseRootFromParent_Done,
     /* 282690 */   // Label 5486: @282690
     /* 282690 */   GIM_Reject,
     /* 282691 */ // Label 5483: @282691
     /* 282691 */ GIM_Reject,
     /* 282692 */ // Label 5460: @282692
     /* 282692 */ GIM_Try, /*On fail goto*//*Label 5487*/ GIMT_Encode4(282835),
     /* 282697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 282700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282704 */   GIM_Try, /*On fail goto*//*Label 5488*/ GIMT_Encode4(282769), // Rule ID 10618 //
     /* 282709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282712 */     // MIs[0] Operand 2
     /* 282712 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 282723 */     // (sext_inreg:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, nxv4i16:{ *:[Other] })  =>  (SXTH_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv4i32] }:$Zs)
     /* 282723 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 282726 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 282730 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282735 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 282738 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 282740 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 282743 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282747 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282752 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 282754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTH_ZPmZ_S_UNDEF),
     /* 282757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 282759 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282762 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 282765 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 282767 */     GIR_RootConstrainSelectedInstOperands,
     /* 282768 */     // GIR_Coverage, 10618,
     /* 282768 */     GIR_EraseRootFromParent_Done,
     /* 282769 */   // Label 5488: @282769
     /* 282769 */   GIM_Try, /*On fail goto*//*Label 5489*/ GIMT_Encode4(282834), // Rule ID 10619 //
     /* 282774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282777 */     // MIs[0] Operand 2
     /* 282777 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 282788 */     // (sext_inreg:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, nxv4i8:{ *:[Other] })  =>  (SXTB_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv4i32] }:$Zs)
     /* 282788 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 282791 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 282795 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282800 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 282803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 282805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 282808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282817 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 282819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_S_UNDEF),
     /* 282822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 282824 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282827 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 282830 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 282832 */     GIR_RootConstrainSelectedInstOperands,
     /* 282833 */     // GIR_Coverage, 10619,
     /* 282833 */     GIR_EraseRootFromParent_Done,
     /* 282834 */   // Label 5489: @282834
     /* 282834 */   GIM_Reject,
     /* 282835 */ // Label 5487: @282835
     /* 282835 */ GIM_Reject,
     /* 282836 */ // Label 5461: @282836
     /* 282836 */ GIM_Try, /*On fail goto*//*Label 5490*/ GIMT_Encode4(282908), // Rule ID 10620 //
     /* 282841 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 282847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282851 */   // MIs[0] Operand 2
     /* 282851 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 282862 */   // (sext_inreg:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Zs, nxv8i8:{ *:[Other] })  =>  (SXTB_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv8i16] }:$Zs)
     /* 282862 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 282865 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 282869 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282874 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 282877 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 282879 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 282882 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282886 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282891 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 282893 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_H_UNDEF),
     /* 282896 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 282898 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282901 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 282904 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 282906 */   GIR_RootConstrainSelectedInstOperands,
     /* 282907 */   // GIR_Coverage, 10620,
     /* 282907 */   GIR_EraseRootFromParent_Done,
     /* 282908 */ // Label 5490: @282908
     /* 282908 */ GIM_Reject,
     /* 282909 */ // Label 5462: @282909
     /* 282909 */ GIM_Reject,
     /* 282910 */ // Label 45: @282910
     /* 282910 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5495*/ GIMT_Encode4(285688),
     /* 282921 */ /*GILLT_s32*//*Label 5491*/ GIMT_Encode4(282957), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 282937 */ /*GILLT_v2s64*//*Label 5492*/ GIMT_Encode4(284758), GIMT_Encode4(0),
     /* 282945 */ /*GILLT_v4s32*//*Label 5493*/ GIMT_Encode4(285068), GIMT_Encode4(0),
     /* 282953 */ /*GILLT_v8s16*//*Label 5494*/ GIMT_Encode4(285378),
     /* 282957 */ // Label 5491: @282957
     /* 282957 */ GIM_Try, /*On fail goto*//*Label 5496*/ GIMT_Encode4(283107), // Rule ID 13274 //
     /* 282962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 282965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 282969 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282973 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 282977 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 282980 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 282985 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 282989 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282994 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282996 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 737:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 282996 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 282999 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 283003 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283008 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 283012 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 283014 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 283017 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 283021 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283026 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 283028 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 283031 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 283035 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283040 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 283043 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 283046 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 283049 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283054 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283059 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 283064 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283067 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283071 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283076 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 283083 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283088 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283093 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283096 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 283098 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283101 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283106 */   // GIR_Coverage, 13274,
     /* 283106 */   GIR_EraseRootFromParent_Done,
     /* 283107 */ // Label 5496: @283107
     /* 283107 */ GIM_Try, /*On fail goto*//*Label 5497*/ GIMT_Encode4(283257), // Rule ID 13276 //
     /* 283112 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 283115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283119 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283123 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 283127 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 283130 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 283135 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 283139 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283144 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283146 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 737:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 283146 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 283149 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 283153 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283158 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 283162 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 283164 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 283167 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 283171 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283176 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 283178 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 283181 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 283185 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283190 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 283193 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 283196 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 283199 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283204 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283209 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 283214 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283217 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283221 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283226 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 283233 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283238 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283243 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283246 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 283248 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283251 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283256 */   // GIR_Coverage, 13276,
     /* 283256 */   GIR_EraseRootFromParent_Done,
     /* 283257 */ // Label 5497: @283257
     /* 283257 */ GIM_Try, /*On fail goto*//*Label 5498*/ GIMT_Encode4(283407), // Rule ID 13278 //
     /* 283262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 283265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283269 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283273 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 283277 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 283280 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 283285 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 283289 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283294 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283296 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 737:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 283296 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 283299 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 283303 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283308 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 283312 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 283314 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 283317 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 283321 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283326 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 283328 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 283331 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 283335 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283340 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 283343 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 283346 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 283349 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283354 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283359 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283364 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283367 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283371 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283376 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 283383 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283388 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283393 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283396 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 283398 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283401 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283406 */   // GIR_Coverage, 13278,
     /* 283406 */   GIR_EraseRootFromParent_Done,
     /* 283407 */ // Label 5498: @283407
     /* 283407 */ GIM_Try, /*On fail goto*//*Label 5499*/ GIMT_Encode4(283557), // Rule ID 13280 //
     /* 283412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 283415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283419 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283423 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 283427 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 283430 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 283435 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 283439 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283444 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283446 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 737:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 283446 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 283449 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 283453 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283458 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 283462 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 283464 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 283467 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 283471 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283476 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 283478 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 283481 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 283485 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283490 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 283493 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 283496 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 283499 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283504 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283509 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283514 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283517 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283521 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283526 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 283533 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283538 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283543 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283546 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 283548 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283551 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283556 */   // GIR_Coverage, 13280,
     /* 283556 */   GIR_EraseRootFromParent_Done,
     /* 283557 */ // Label 5499: @283557
     /* 283557 */ GIM_Try, /*On fail goto*//*Label 5500*/ GIMT_Encode4(283707), // Rule ID 13307 //
     /* 283562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 283565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283569 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283573 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 283577 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 283580 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 283585 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 283589 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283594 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283596 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 743:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 283596 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 283599 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 283603 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283608 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 283612 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 283614 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 283617 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 283621 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283626 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 283628 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 283631 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 283635 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283640 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 283643 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 283646 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 283649 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283654 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283659 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 283664 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283667 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283671 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283676 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 283683 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283688 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283693 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283696 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 283698 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283701 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283706 */   // GIR_Coverage, 13307,
     /* 283706 */   GIR_EraseRootFromParent_Done,
     /* 283707 */ // Label 5500: @283707
     /* 283707 */ GIM_Try, /*On fail goto*//*Label 5501*/ GIMT_Encode4(283857), // Rule ID 13309 //
     /* 283712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 283715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283719 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283723 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 283727 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 283730 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 283735 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 283739 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283744 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283746 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 743:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 283746 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 283749 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 283753 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283758 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 283762 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 283764 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 283767 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 283771 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283776 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 283778 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 283781 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 283785 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283790 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 283793 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 283796 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 283799 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283804 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283809 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 283814 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283817 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283821 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283826 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 283833 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283838 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283843 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283846 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 283848 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283851 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283856 */   // GIR_Coverage, 13309,
     /* 283856 */   GIR_EraseRootFromParent_Done,
     /* 283857 */ // Label 5501: @283857
     /* 283857 */ GIM_Try, /*On fail goto*//*Label 5502*/ GIMT_Encode4(284007), // Rule ID 13311 //
     /* 283862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 283865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283869 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283873 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 283877 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 283880 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 283885 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 283889 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283894 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283896 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 743:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 283896 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 283899 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 283903 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283908 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 283912 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 283914 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 283917 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 283921 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283926 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 283928 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 283931 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 283935 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283940 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 283943 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 283946 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 283949 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283954 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283959 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283964 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283967 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283971 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283976 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 283983 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283988 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283993 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283996 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 283998 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284001 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284006 */   // GIR_Coverage, 13311,
     /* 284006 */   GIR_EraseRootFromParent_Done,
     /* 284007 */ // Label 5502: @284007
     /* 284007 */ GIM_Try, /*On fail goto*//*Label 5503*/ GIMT_Encode4(284157), // Rule ID 13313 //
     /* 284012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 284015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284019 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284023 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 284027 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 284030 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 284035 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 284039 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284044 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284046 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 743:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 284046 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 284049 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 284053 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284058 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 284062 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 284064 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 284067 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 284071 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284076 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 284078 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 284081 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 284085 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284090 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 284093 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 284096 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 284099 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284104 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284109 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284114 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 284117 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284121 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284126 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 284133 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284138 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284143 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284146 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284148 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284151 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284156 */   // GIR_Coverage, 13313,
     /* 284156 */   GIR_EraseRootFromParent_Done,
     /* 284157 */ // Label 5503: @284157
     /* 284157 */ GIM_Try, /*On fail goto*//*Label 5504*/ GIMT_Encode4(284307), // Rule ID 13317 //
     /* 284162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 284165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284169 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284173 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 284177 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 284180 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 284185 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 284189 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284194 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284196 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 746:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 284196 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 284199 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 284203 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284208 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 284212 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 284214 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 284217 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 284221 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284226 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 284228 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 284231 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 284235 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284240 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 284243 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 284246 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 284249 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284254 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284259 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 284264 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 284267 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284271 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284276 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 284283 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284288 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284293 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284296 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284298 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284301 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284306 */   // GIR_Coverage, 13317,
     /* 284306 */   GIR_EraseRootFromParent_Done,
     /* 284307 */ // Label 5504: @284307
     /* 284307 */ GIM_Try, /*On fail goto*//*Label 5505*/ GIMT_Encode4(284457), // Rule ID 13319 //
     /* 284312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 284315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284319 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284323 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 284327 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 284330 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 284335 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 284339 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284344 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284346 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 746:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 284346 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 284349 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 284353 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284358 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 284362 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 284364 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 284367 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 284371 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284376 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 284378 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 284381 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 284385 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284390 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 284393 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 284396 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 284399 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284404 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284409 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 284414 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 284417 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284421 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284426 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 284433 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284438 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284443 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284446 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284448 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284451 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284456 */   // GIR_Coverage, 13319,
     /* 284456 */   GIR_EraseRootFromParent_Done,
     /* 284457 */ // Label 5505: @284457
     /* 284457 */ GIM_Try, /*On fail goto*//*Label 5506*/ GIMT_Encode4(284607), // Rule ID 13321 //
     /* 284462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 284465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284469 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284473 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 284477 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 284480 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 284485 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 284489 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284494 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284496 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 746:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 284496 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 284499 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 284503 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284508 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 284512 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 284514 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 284517 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 284521 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284526 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 284528 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 284531 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 284535 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284540 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 284543 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 284546 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 284549 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284554 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284559 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284564 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 284567 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284571 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284576 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 284583 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284588 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284593 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284596 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284598 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284601 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284606 */   // GIR_Coverage, 13321,
     /* 284606 */   GIR_EraseRootFromParent_Done,
     /* 284607 */ // Label 5506: @284607
     /* 284607 */ GIM_Try, /*On fail goto*//*Label 5507*/ GIMT_Encode4(284757), // Rule ID 13323 //
     /* 284612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 284615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284619 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284623 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 284627 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 284630 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 284635 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 284639 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284644 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284646 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 746:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 284646 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 284649 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 284653 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284658 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 284662 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 284664 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 284667 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 284671 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284676 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 284678 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 284681 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 284685 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284690 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 284693 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 284696 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 284699 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284704 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284709 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284714 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 284717 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284721 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284726 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 284733 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284738 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284743 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284746 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284748 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284751 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284756 */   // GIR_Coverage, 13323,
     /* 284756 */   GIR_EraseRootFromParent_Done,
     /* 284757 */ // Label 5507: @284757
     /* 284757 */ GIM_Reject,
     /* 284758 */ // Label 5492: @284758
     /* 284758 */ GIM_Try, /*On fail goto*//*Label 5508*/ GIMT_Encode4(285067),
     /* 284763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 284766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284770 */   GIM_Try, /*On fail goto*//*Label 5509*/ GIMT_Encode4(284835), // Rule ID 702 //
     /* 284775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 284786 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 284789 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 284794 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 284798 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 284802 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284804 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 284811 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 284818 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 734:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 284818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i32_v2i64),
     /* 284821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 284828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 284833 */     GIR_RootConstrainSelectedInstOperands,
     /* 284834 */     // GIR_Coverage, 702,
     /* 284834 */     GIR_EraseRootFromParent_Done,
     /* 284835 */   // Label 5509: @284835
     /* 284835 */   GIM_Try, /*On fail goto*//*Label 5510*/ GIMT_Encode4(284900), // Rule ID 1711 //
     /* 284840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 284851 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 284854 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 284859 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 284863 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 284867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284869 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 284876 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 284883 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 669:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 284883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv4i32_v2i64),
     /* 284886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 284893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 284898 */     GIR_RootConstrainSelectedInstOperands,
     /* 284899 */     // GIR_Coverage, 1711,
     /* 284899 */     GIR_EraseRootFromParent_Done,
     /* 284900 */   // Label 5510: @284900
     /* 284900 */   GIM_Try, /*On fail goto*//*Label 5511*/ GIMT_Encode4(284959), // Rule ID 700 //
     /* 284905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 284916 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 284919 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 284924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 284928 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 284932 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284942 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284944 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 734:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 284944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv2i32_v2i64),
     /* 284947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 284953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 284957 */     GIR_RootConstrainSelectedInstOperands,
     /* 284958 */     // GIR_Coverage, 700,
     /* 284958 */     GIR_EraseRootFromParent_Done,
     /* 284959 */   // Label 5511: @284959
     /* 284959 */   GIM_Try, /*On fail goto*//*Label 5512*/ GIMT_Encode4(285018), // Rule ID 1709 //
     /* 284964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 284975 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 284978 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 284983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 284987 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 284991 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285003 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 669:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 285003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv2i32_v2i64),
     /* 285006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 285012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 285016 */     GIR_RootConstrainSelectedInstOperands,
     /* 285017 */     // GIR_Coverage, 1709,
     /* 285017 */     GIR_EraseRootFromParent_Done,
     /* 285018 */   // Label 5512: @285018
     /* 285018 */   GIM_Try, /*On fail goto*//*Label 5513*/ GIMT_Encode4(285045), // Rule ID 6432 //
     /* 285023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 285030 */     // (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (USHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 285030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i32_shift),
     /* 285033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 285040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 285043 */     GIR_RootConstrainSelectedInstOperands,
     /* 285044 */     // GIR_Coverage, 6432,
     /* 285044 */     GIR_EraseRootFromParent_Done,
     /* 285045 */   // Label 5513: @285045
     /* 285045 */   GIM_Try, /*On fail goto*//*Label 5514*/ GIMT_Encode4(285066), // Rule ID 6423 //
     /* 285050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285054 */     // (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 285054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 285057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285059 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 285064 */     GIR_RootConstrainSelectedInstOperands,
     /* 285065 */     // GIR_Coverage, 6423,
     /* 285065 */     GIR_EraseRootFromParent_Done,
     /* 285066 */   // Label 5514: @285066
     /* 285066 */   GIM_Reject,
     /* 285067 */ // Label 5508: @285067
     /* 285067 */ GIM_Reject,
     /* 285068 */ // Label 5493: @285068
     /* 285068 */ GIM_Try, /*On fail goto*//*Label 5515*/ GIMT_Encode4(285377),
     /* 285073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 285076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285080 */   GIM_Try, /*On fail goto*//*Label 5516*/ GIMT_Encode4(285145), // Rule ID 698 //
     /* 285085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 285096 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 285099 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 285104 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 285108 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 285112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285114 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 285121 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 285128 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 734:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 285128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i16_v4i32),
     /* 285131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 285138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 285143 */     GIR_RootConstrainSelectedInstOperands,
     /* 285144 */     // GIR_Coverage, 698,
     /* 285144 */     GIR_EraseRootFromParent_Done,
     /* 285145 */   // Label 5516: @285145
     /* 285145 */   GIM_Try, /*On fail goto*//*Label 5517*/ GIMT_Encode4(285210), // Rule ID 1707 //
     /* 285150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 285161 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 285164 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 285169 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 285173 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 285177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285179 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 285186 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 285193 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 669:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 285193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv8i16_v4i32),
     /* 285196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 285203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 285208 */     GIR_RootConstrainSelectedInstOperands,
     /* 285209 */     // GIR_Coverage, 1707,
     /* 285209 */     GIR_EraseRootFromParent_Done,
     /* 285210 */   // Label 5517: @285210
     /* 285210 */   GIM_Try, /*On fail goto*//*Label 5518*/ GIMT_Encode4(285269), // Rule ID 696 //
     /* 285215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 285226 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 285229 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 285234 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 285238 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 285242 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285247 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285252 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285254 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 734:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 285254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i16_v4i32),
     /* 285257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 285263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 285267 */     GIR_RootConstrainSelectedInstOperands,
     /* 285268 */     // GIR_Coverage, 696,
     /* 285268 */     GIR_EraseRootFromParent_Done,
     /* 285269 */   // Label 5518: @285269
     /* 285269 */   GIM_Try, /*On fail goto*//*Label 5519*/ GIMT_Encode4(285328), // Rule ID 1705 //
     /* 285274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 285285 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 285288 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 285293 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 285297 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 285301 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285306 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285313 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 669:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 285313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv4i16_v4i32),
     /* 285316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 285322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 285326 */     GIR_RootConstrainSelectedInstOperands,
     /* 285327 */     // GIR_Coverage, 1705,
     /* 285327 */     GIR_EraseRootFromParent_Done,
     /* 285328 */   // Label 5519: @285328
     /* 285328 */   GIM_Try, /*On fail goto*//*Label 5520*/ GIMT_Encode4(285355), // Rule ID 6429 //
     /* 285333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 285340 */     // (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (USHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 285340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i16_shift),
     /* 285343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 285350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 285353 */     GIR_RootConstrainSelectedInstOperands,
     /* 285354 */     // GIR_Coverage, 6429,
     /* 285354 */     GIR_EraseRootFromParent_Done,
     /* 285355 */   // Label 5520: @285355
     /* 285355 */   GIM_Try, /*On fail goto*//*Label 5521*/ GIMT_Encode4(285376), // Rule ID 6420 //
     /* 285360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285364 */     // (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 285364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 285367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285369 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 285374 */     GIR_RootConstrainSelectedInstOperands,
     /* 285375 */     // GIR_Coverage, 6420,
     /* 285375 */     GIR_EraseRootFromParent_Done,
     /* 285376 */   // Label 5521: @285376
     /* 285376 */   GIM_Reject,
     /* 285377 */ // Label 5515: @285377
     /* 285377 */ GIM_Reject,
     /* 285378 */ // Label 5494: @285378
     /* 285378 */ GIM_Try, /*On fail goto*//*Label 5522*/ GIMT_Encode4(285687),
     /* 285383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 285386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285390 */   GIM_Try, /*On fail goto*//*Label 5523*/ GIMT_Encode4(285455), // Rule ID 694 //
     /* 285395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 285406 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 285409 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 285414 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 285418 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 285422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285424 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 285431 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 285438 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 734:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 285438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv16i8_v8i16),
     /* 285441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 285448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 285453 */     GIR_RootConstrainSelectedInstOperands,
     /* 285454 */     // GIR_Coverage, 694,
     /* 285454 */     GIR_EraseRootFromParent_Done,
     /* 285455 */   // Label 5523: @285455
     /* 285455 */   GIM_Try, /*On fail goto*//*Label 5524*/ GIMT_Encode4(285520), // Rule ID 1703 //
     /* 285460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 285471 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 285474 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 285479 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 285483 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 285487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285489 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 285496 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 285503 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 669:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 285503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv16i8_v8i16),
     /* 285506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 285513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 285518 */     GIR_RootConstrainSelectedInstOperands,
     /* 285519 */     // GIR_Coverage, 1703,
     /* 285519 */     GIR_EraseRootFromParent_Done,
     /* 285520 */   // Label 5524: @285520
     /* 285520 */   GIM_Try, /*On fail goto*//*Label 5525*/ GIMT_Encode4(285579), // Rule ID 692 //
     /* 285525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 285536 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 285539 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 285544 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 285548 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 285552 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285557 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285564 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 734:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 285564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i8_v8i16),
     /* 285567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 285573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 285577 */     GIR_RootConstrainSelectedInstOperands,
     /* 285578 */     // GIR_Coverage, 692,
     /* 285578 */     GIR_EraseRootFromParent_Done,
     /* 285579 */   // Label 5525: @285579
     /* 285579 */   GIM_Try, /*On fail goto*//*Label 5526*/ GIMT_Encode4(285638), // Rule ID 1701 //
     /* 285584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 285595 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 285598 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 285603 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 285607 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 285611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285623 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 669:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 285623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv8i8_v8i16),
     /* 285626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 285632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 285636 */     GIR_RootConstrainSelectedInstOperands,
     /* 285637 */     // GIR_Coverage, 1701,
     /* 285637 */     GIR_EraseRootFromParent_Done,
     /* 285638 */   // Label 5526: @285638
     /* 285638 */   GIM_Try, /*On fail goto*//*Label 5527*/ GIMT_Encode4(285665), // Rule ID 6426 //
     /* 285643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 285650 */     // (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (USHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 285650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv16i8_shift),
     /* 285653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 285660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 285663 */     GIR_RootConstrainSelectedInstOperands,
     /* 285664 */     // GIR_Coverage, 6426,
     /* 285664 */     GIR_EraseRootFromParent_Done,
     /* 285665 */   // Label 5527: @285665
     /* 285665 */   GIM_Try, /*On fail goto*//*Label 5528*/ GIMT_Encode4(285686), // Rule ID 6417 //
     /* 285670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285674 */     // (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 285674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 285677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285679 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 285684 */     GIR_RootConstrainSelectedInstOperands,
     /* 285685 */     // GIR_Coverage, 6417,
     /* 285685 */     GIR_EraseRootFromParent_Done,
     /* 285686 */   // Label 5528: @285686
     /* 285686 */   GIM_Reject,
     /* 285687 */ // Label 5522: @285687
     /* 285687 */ GIM_Reject,
     /* 285688 */ // Label 5495: @285688
     /* 285688 */ GIM_Reject,
     /* 285689 */ // Label 46: @285689
     /* 285689 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5534*/ GIMT_Encode4(286513),
     /* 285700 */ /*GILLT_s32*//*Label 5529*/ GIMT_Encode4(285736),
     /* 285704 */ /*GILLT_s64*//*Label 5530*/ GIMT_Encode4(285913), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 285716 */ /*GILLT_v2s64*//*Label 5531*/ GIMT_Encode4(286086), GIMT_Encode4(0),
     /* 285724 */ /*GILLT_v4s32*//*Label 5532*/ GIMT_Encode4(286231), GIMT_Encode4(0),
     /* 285732 */ /*GILLT_v8s16*//*Label 5533*/ GIMT_Encode4(286372),
     /* 285736 */ // Label 5529: @285736
     /* 285736 */ GIM_Try, /*On fail goto*//*Label 5535*/ GIMT_Encode4(285912),
     /* 285741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 285744 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 285747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285751 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285755 */   GIM_Try, /*On fail goto*//*Label 5536*/ GIMT_Encode4(285792), // Rule ID 3960 //
     /* 285760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 285768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285779 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 285779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 285782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285784 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 285790 */     GIR_RootConstrainSelectedInstOperands,
     /* 285791 */     // GIR_Coverage, 3960,
     /* 285791 */     GIR_EraseRootFromParent_Done,
     /* 285792 */   // Label 5536: @285792
     /* 285792 */   GIM_Try, /*On fail goto*//*Label 5537*/ GIMT_Encode4(285829), // Rule ID 3961 //
     /* 285797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 285805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285816 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 285816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 285819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285821 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 285827 */     GIR_RootConstrainSelectedInstOperands,
     /* 285828 */     // GIR_Coverage, 3961,
     /* 285828 */     GIR_EraseRootFromParent_Done,
     /* 285829 */   // Label 5537: @285829
     /* 285829 */   GIM_Try, /*On fail goto*//*Label 5538*/ GIMT_Encode4(285866), // Rule ID 3959 //
     /* 285834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 285842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285846 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285853 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 285853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 285856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285858 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 285864 */     GIR_RootConstrainSelectedInstOperands,
     /* 285865 */     // GIR_Coverage, 3959,
     /* 285865 */     GIR_EraseRootFromParent_Done,
     /* 285866 */   // Label 5538: @285866
     /* 285866 */   GIM_Try, /*On fail goto*//*Label 5539*/ GIMT_Encode4(285911), // Rule ID 3958 //
     /* 285871 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i64:{ *:[i64] }:$Rm)  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }))
     /* 285871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 285874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285883 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /* 285889 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285894 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 285899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 285902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285904 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285909 */     GIR_RootConstrainSelectedInstOperands,
     /* 285910 */     // GIR_Coverage, 3958,
     /* 285910 */     GIR_EraseRootFromParent_Done,
     /* 285911 */   // Label 5539: @285911
     /* 285911 */   GIM_Reject,
     /* 285912 */ // Label 5535: @285912
     /* 285912 */ GIM_Reject,
     /* 285913 */ // Label 5530: @285913
     /* 285913 */ GIM_Try, /*On fail goto*//*Label 5540*/ GIMT_Encode4(286085),
     /* 285918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 285921 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 285924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 285928 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 285932 */   GIM_Try, /*On fail goto*//*Label 5541*/ GIMT_Encode4(286000), // Rule ID 3962 //
     /* 285937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 285945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285949 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285954 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285956 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 285956 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 285959 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 285963 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285968 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 285971 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 285975 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 285978 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 285983 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 285991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285993 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285995 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285998 */     GIR_RootConstrainSelectedInstOperands,
     /* 285999 */     // GIR_Coverage, 3962,
     /* 285999 */     GIR_EraseRootFromParent_Done,
     /* 286000 */   // Label 5541: @286000
     /* 286000 */   GIM_Try, /*On fail goto*//*Label 5542*/ GIMT_Encode4(286068), // Rule ID 3963 //
     /* 286005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 286013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286017 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286024 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 286024 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286027 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 286031 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286036 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 286039 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286043 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 286046 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 286051 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 286059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286061 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286066 */     GIR_RootConstrainSelectedInstOperands,
     /* 286067 */     // GIR_Coverage, 3963,
     /* 286067 */     GIR_EraseRootFromParent_Done,
     /* 286068 */   // Label 5542: @286068
     /* 286068 */   GIM_Try, /*On fail goto*//*Label 5543*/ GIMT_Encode4(286084), // Rule ID 120 //
     /* 286073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286077 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 286077 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 286082 */     GIR_RootConstrainSelectedInstOperands,
     /* 286083 */     // GIR_Coverage, 120,
     /* 286083 */     GIR_Done,
     /* 286084 */   // Label 5543: @286084
     /* 286084 */   GIM_Reject,
     /* 286085 */ // Label 5540: @286085
     /* 286085 */ GIM_Reject,
     /* 286086 */ // Label 5531: @286086
     /* 286086 */ GIM_Try, /*On fail goto*//*Label 5544*/ GIMT_Encode4(286230),
     /* 286091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286094 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 286097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286101 */   GIM_Try, /*On fail goto*//*Label 5545*/ GIMT_Encode4(286165), // Rule ID 6415 //
     /* 286106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 286114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 286118 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 286131 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 286135 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 286139 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286143 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 286147 */     // MIs[3] Operand 1
     /* 286147 */     // No operand predicates
     /* 286147 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 286149 */     // (shl:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), (AArch64dup:{ *:[v2i64] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))  =>  (SSHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))
     /* 286149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 286152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286158 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // size
     /* 286163 */     GIR_RootConstrainSelectedInstOperands,
     /* 286164 */     // GIR_Coverage, 6415,
     /* 286164 */     GIR_EraseRootFromParent_Done,
     /* 286165 */   // Label 5545: @286165
     /* 286165 */   GIM_Try, /*On fail goto*//*Label 5546*/ GIMT_Encode4(286229), // Rule ID 6412 //
     /* 286170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 286178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 286182 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286187 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286191 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 286195 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 286199 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 286203 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286207 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 286211 */     // MIs[3] Operand 1
     /* 286211 */     // No operand predicates
     /* 286211 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 286213 */     // (shl:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), (AArch64dup:{ *:[v2i64] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))
     /* 286213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 286216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286222 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // size
     /* 286227 */     GIR_RootConstrainSelectedInstOperands,
     /* 286228 */     // GIR_Coverage, 6412,
     /* 286228 */     GIR_EraseRootFromParent_Done,
     /* 286229 */   // Label 5546: @286229
     /* 286229 */   GIM_Reject,
     /* 286230 */ // Label 5544: @286230
     /* 286230 */ GIM_Reject,
     /* 286231 */ // Label 5532: @286231
     /* 286231 */ GIM_Try, /*On fail goto*//*Label 5547*/ GIMT_Encode4(286371),
     /* 286236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286239 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 286242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286246 */   GIM_Try, /*On fail goto*//*Label 5548*/ GIMT_Encode4(286308), // Rule ID 6414 //
     /* 286251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 286259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 286263 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286268 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286272 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 286276 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 286280 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 286284 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286288 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 286292 */     // MIs[3] Operand 1
     /* 286292 */     // No operand predicates
     /* 286292 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 286294 */     // (shl:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), (AArch64dup:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size))  =>  (SSHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size)
     /* 286294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 286297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286303 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 286306 */     GIR_RootConstrainSelectedInstOperands,
     /* 286307 */     // GIR_Coverage, 6414,
     /* 286307 */     GIR_EraseRootFromParent_Done,
     /* 286308 */   // Label 5548: @286308
     /* 286308 */   GIM_Try, /*On fail goto*//*Label 5549*/ GIMT_Encode4(286370), // Rule ID 6411 //
     /* 286313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 286321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 286325 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 286338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 286342 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 286346 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286350 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 286354 */     // MIs[3] Operand 1
     /* 286354 */     // No operand predicates
     /* 286354 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 286356 */     // (shl:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), (AArch64dup:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size))  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size)
     /* 286356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 286359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 286368 */     GIR_RootConstrainSelectedInstOperands,
     /* 286369 */     // GIR_Coverage, 6411,
     /* 286369 */     GIR_EraseRootFromParent_Done,
     /* 286370 */   // Label 5549: @286370
     /* 286370 */   GIM_Reject,
     /* 286371 */ // Label 5547: @286371
     /* 286371 */ GIM_Reject,
     /* 286372 */ // Label 5533: @286372
     /* 286372 */ GIM_Try, /*On fail goto*//*Label 5550*/ GIMT_Encode4(286512),
     /* 286377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 286380 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 286383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286387 */   GIM_Try, /*On fail goto*//*Label 5551*/ GIMT_Encode4(286449), // Rule ID 6413 //
     /* 286392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 286400 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 286404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 286417 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 286421 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 286425 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286429 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_7),
     /* 286433 */     // MIs[3] Operand 1
     /* 286433 */     // No operand predicates
     /* 286433 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 286435 */     // (shl:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), (AArch64dup:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size))  =>  (SSHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size)
     /* 286435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 286438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286444 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 286447 */     GIR_RootConstrainSelectedInstOperands,
     /* 286448 */     // GIR_Coverage, 6413,
     /* 286448 */     GIR_EraseRootFromParent_Done,
     /* 286449 */   // Label 5551: @286449
     /* 286449 */   GIM_Try, /*On fail goto*//*Label 5552*/ GIMT_Encode4(286511), // Rule ID 6410 //
     /* 286454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 286462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 286466 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286471 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286475 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 286479 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 286483 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 286487 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286491 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_7),
     /* 286495 */     // MIs[3] Operand 1
     /* 286495 */     // No operand predicates
     /* 286495 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 286497 */     // (shl:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), (AArch64dup:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size))  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size)
     /* 286497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 286500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286506 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 286509 */     GIR_RootConstrainSelectedInstOperands,
     /* 286510 */     // GIR_Coverage, 6410,
     /* 286510 */     GIR_EraseRootFromParent_Done,
     /* 286511 */   // Label 5552: @286511
     /* 286511 */   GIM_Reject,
     /* 286512 */ // Label 5550: @286512
     /* 286512 */ GIM_Reject,
     /* 286513 */ // Label 5534: @286513
     /* 286513 */ GIM_Reject,
     /* 286514 */ // Label 47: @286514
     /* 286514 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5555*/ GIMT_Encode4(287057),
     /* 286525 */ /*GILLT_s32*//*Label 5553*/ GIMT_Encode4(286533),
     /* 286529 */ /*GILLT_s64*//*Label 5554*/ GIMT_Encode4(286799),
     /* 286533 */ // Label 5553: @286533
     /* 286533 */ GIM_Try, /*On fail goto*//*Label 5556*/ GIMT_Encode4(286798),
     /* 286538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 286541 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 286544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286548 */   GIM_Try, /*On fail goto*//*Label 5557*/ GIMT_Encode4(286587), // Rule ID 4038 //
     /* 286553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 286561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286565 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top16Zero),
     /* 286570 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 286574 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286576 */     // (srl:{ *:[i32] } (bswap:{ *:[i32] } GPR32:{ *:[i32] }<<P:Predicate_top16Zero>>:$Rn), 16:{ *:[i64] })  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 286576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 286579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 286585 */     GIR_RootConstrainSelectedInstOperands,
     /* 286586 */     // GIR_Coverage, 4038,
     /* 286586 */     GIR_EraseRootFromParent_Done,
     /* 286587 */   // Label 5557: @286587
     /* 286587 */   GIM_Try, /*On fail goto*//*Label 5558*/ GIMT_Encode4(286625), // Rule ID 4049 //
     /* 286592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286604 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 286608 */     // MIs[1] Operand 1
     /* 286608 */     // No operand predicates
     /* 286608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286610 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (UBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 286610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UBFMWri),
     /* 286613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286615 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286617 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 286620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 286623 */     GIR_RootConstrainSelectedInstOperands,
     /* 286624 */     // GIR_Coverage, 4049,
     /* 286624 */     GIR_EraseRootFromParent_Done,
     /* 286625 */   // Label 5558: @286625
     /* 286625 */   GIM_Try, /*On fail goto*//*Label 5559*/ GIMT_Encode4(286666), // Rule ID 3966 //
     /* 286630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 286642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286646 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286653 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 286653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 286656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286658 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286664 */     GIR_RootConstrainSelectedInstOperands,
     /* 286665 */     // GIR_Coverage, 3966,
     /* 286665 */     GIR_EraseRootFromParent_Done,
     /* 286666 */   // Label 5559: @286666
     /* 286666 */   GIM_Try, /*On fail goto*//*Label 5560*/ GIMT_Encode4(286707), // Rule ID 3967 //
     /* 286671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 286683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286694 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 286694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 286697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286699 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286705 */     GIR_RootConstrainSelectedInstOperands,
     /* 286706 */     // GIR_Coverage, 3967,
     /* 286706 */     GIR_EraseRootFromParent_Done,
     /* 286707 */   // Label 5560: @286707
     /* 286707 */   GIM_Try, /*On fail goto*//*Label 5561*/ GIMT_Encode4(286748), // Rule ID 3965 //
     /* 286712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 286724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286735 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 286735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 286738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286740 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286746 */     GIR_RootConstrainSelectedInstOperands,
     /* 286747 */     // GIR_Coverage, 3965,
     /* 286747 */     GIR_EraseRootFromParent_Done,
     /* 286748 */   // Label 5561: @286748
     /* 286748 */   GIM_Try, /*On fail goto*//*Label 5562*/ GIMT_Encode4(286797), // Rule ID 3964 //
     /* 286753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286757 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i64:{ *:[i64] }:$Rm)  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }))
     /* 286757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 286760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286769 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /* 286775 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286780 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 286788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286790 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286795 */     GIR_RootConstrainSelectedInstOperands,
     /* 286796 */     // GIR_Coverage, 3964,
     /* 286796 */     GIR_EraseRootFromParent_Done,
     /* 286797 */   // Label 5562: @286797
     /* 286797 */   GIM_Reject,
     /* 286798 */ // Label 5556: @286798
     /* 286798 */ GIM_Reject,
     /* 286799 */ // Label 5554: @286799
     /* 286799 */ GIM_Try, /*On fail goto*//*Label 5563*/ GIMT_Encode4(287056),
     /* 286804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 286807 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 286810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286814 */   GIM_Try, /*On fail goto*//*Label 5564*/ GIMT_Encode4(286853), // Rule ID 4039 //
     /* 286819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 286827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 286831 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /* 286836 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 286840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286842 */     // (srl:{ *:[i64] } (bswap:{ *:[i64] } GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn), 32:{ *:[i64] })  =>  (REV32Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 286842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV32Xr),
     /* 286845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 286851 */     GIR_RootConstrainSelectedInstOperands,
     /* 286852 */     // GIR_Coverage, 4039,
     /* 286852 */     GIR_EraseRootFromParent_Done,
     /* 286853 */   // Label 5564: @286853
     /* 286853 */   GIM_Try, /*On fail goto*//*Label 5565*/ GIMT_Encode4(286891), // Rule ID 4050 //
     /* 286858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286870 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 286874 */     // MIs[1] Operand 1
     /* 286874 */     // No operand predicates
     /* 286874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286876 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (UBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm, 63:{ *:[i64] })
     /* 286876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UBFMXri),
     /* 286879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286881 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 286886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 286889 */     GIR_RootConstrainSelectedInstOperands,
     /* 286890 */     // GIR_Coverage, 4050,
     /* 286890 */     GIR_EraseRootFromParent_Done,
     /* 286891 */   // Label 5565: @286891
     /* 286891 */   GIM_Try, /*On fail goto*//*Label 5566*/ GIMT_Encode4(286963), // Rule ID 3968 //
     /* 286896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 286908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286912 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286919 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 286919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 286926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286931 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 286934 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286938 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 286941 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 286946 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 286954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286956 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286958 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286961 */     GIR_RootConstrainSelectedInstOperands,
     /* 286962 */     // GIR_Coverage, 3968,
     /* 286962 */     GIR_EraseRootFromParent_Done,
     /* 286963 */   // Label 5566: @286963
     /* 286963 */   GIM_Try, /*On fail goto*//*Label 5567*/ GIMT_Encode4(287035), // Rule ID 3969 //
     /* 286968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 286980 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286984 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286991 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 286991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 286998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287003 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 287006 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287010 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 287013 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 287018 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 287026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287028 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287030 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287033 */     GIR_RootConstrainSelectedInstOperands,
     /* 287034 */     // GIR_Coverage, 3969,
     /* 287034 */     GIR_EraseRootFromParent_Done,
     /* 287035 */   // Label 5567: @287035
     /* 287035 */   GIM_Try, /*On fail goto*//*Label 5568*/ GIMT_Encode4(287055), // Rule ID 121 //
     /* 287040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287048 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 287048 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 287053 */     GIR_RootConstrainSelectedInstOperands,
     /* 287054 */     // GIR_Coverage, 121,
     /* 287054 */     GIR_Done,
     /* 287055 */   // Label 5568: @287055
     /* 287055 */   GIM_Reject,
     /* 287056 */ // Label 5563: @287056
     /* 287056 */ GIM_Reject,
     /* 287057 */ // Label 5555: @287057
     /* 287057 */ GIM_Reject,
     /* 287058 */ // Label 48: @287058
     /* 287058 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5571*/ GIMT_Encode4(287882),
     /* 287069 */ /*GILLT_s32*//*Label 5569*/ GIMT_Encode4(287077),
     /* 287073 */ /*GILLT_s64*//*Label 5570*/ GIMT_Encode4(287432),
     /* 287077 */ // Label 5569: @287077
     /* 287077 */ GIM_Try, /*On fail goto*//*Label 5572*/ GIMT_Encode4(287431),
     /* 287082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 287085 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 287088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287092 */   GIM_Try, /*On fail goto*//*Label 5573*/ GIMT_Encode4(287156), // Rule ID 6585 //
     /* 287097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 287105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287114 */     // MIs[1] Operand 2
     /* 287114 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 287125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 287129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287133 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /* 287137 */     // MIs[2] Operand 1
     /* 287137 */     // No operand predicates
     /* 287137 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287139 */     // (sra:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i8:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm, 7:{ *:[i64] })
     /* 287139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 287142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 287148 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 287151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 287154 */     GIR_RootConstrainSelectedInstOperands,
     /* 287155 */     // GIR_Coverage, 6585,
     /* 287155 */     GIR_EraseRootFromParent_Done,
     /* 287156 */   // Label 5573: @287156
     /* 287156 */   GIM_Try, /*On fail goto*//*Label 5574*/ GIMT_Encode4(287220), // Rule ID 6587 //
     /* 287161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 287169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287173 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287178 */     // MIs[1] Operand 2
     /* 287178 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 287189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 287193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287197 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /* 287201 */     // MIs[2] Operand 1
     /* 287201 */     // No operand predicates
     /* 287201 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287203 */     // (sra:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm, 15:{ *:[i64] })
     /* 287203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 287206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 287212 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 287215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 287218 */     GIR_RootConstrainSelectedInstOperands,
     /* 287219 */     // GIR_Coverage, 6587,
     /* 287219 */     GIR_EraseRootFromParent_Done,
     /* 287220 */   // Label 5574: @287220
     /* 287220 */   GIM_Try, /*On fail goto*//*Label 5575*/ GIMT_Encode4(287258), // Rule ID 4047 //
     /* 287225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287237 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 287241 */     // MIs[1] Operand 1
     /* 287241 */     // No operand predicates
     /* 287241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287243 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 287243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 287246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287248 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287250 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 287253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 287256 */     GIR_RootConstrainSelectedInstOperands,
     /* 287257 */     // GIR_Coverage, 4047,
     /* 287257 */     GIR_EraseRootFromParent_Done,
     /* 287258 */   // Label 5575: @287258
     /* 287258 */   GIM_Try, /*On fail goto*//*Label 5576*/ GIMT_Encode4(287299), // Rule ID 2438 //
     /* 287263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 287275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287279 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287286 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 287286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 287289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287291 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287297 */     GIR_RootConstrainSelectedInstOperands,
     /* 287298 */     // GIR_Coverage, 2438,
     /* 287298 */     GIR_EraseRootFromParent_Done,
     /* 287299 */   // Label 5576: @287299
     /* 287299 */   GIM_Try, /*On fail goto*//*Label 5577*/ GIMT_Encode4(287340), // Rule ID 2439 //
     /* 287304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 287316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287327 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 287327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 287330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287332 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287338 */     GIR_RootConstrainSelectedInstOperands,
     /* 287339 */     // GIR_Coverage, 2439,
     /* 287339 */     GIR_EraseRootFromParent_Done,
     /* 287340 */   // Label 5577: @287340
     /* 287340 */   GIM_Try, /*On fail goto*//*Label 5578*/ GIMT_Encode4(287381), // Rule ID 2437 //
     /* 287345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 287357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287361 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287368 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 287368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 287371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287373 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287379 */     GIR_RootConstrainSelectedInstOperands,
     /* 287380 */     // GIR_Coverage, 2437,
     /* 287380 */     GIR_EraseRootFromParent_Done,
     /* 287381 */   // Label 5578: @287381
     /* 287381 */   GIM_Try, /*On fail goto*//*Label 5579*/ GIMT_Encode4(287430), // Rule ID 2436 //
     /* 287386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287390 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i64:{ *:[i64] }:$Rm)  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }))
     /* 287390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 287393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287402 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /* 287408 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287413 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 287421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287423 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287428 */     GIR_RootConstrainSelectedInstOperands,
     /* 287429 */     // GIR_Coverage, 2436,
     /* 287429 */     GIR_EraseRootFromParent_Done,
     /* 287430 */   // Label 5579: @287430
     /* 287430 */   GIM_Reject,
     /* 287431 */ // Label 5572: @287431
     /* 287431 */ GIM_Reject,
     /* 287432 */ // Label 5570: @287432
     /* 287432 */ GIM_Try, /*On fail goto*//*Label 5580*/ GIMT_Encode4(287881),
     /* 287437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 287440 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 287443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287447 */   GIM_Try, /*On fail goto*//*Label 5581*/ GIMT_Encode4(287511), // Rule ID 6586 //
     /* 287452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 287460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 287464 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287469 */     // MIs[1] Operand 2
     /* 287469 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 287480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 287484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287488 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /* 287492 */     // MIs[2] Operand 1
     /* 287492 */     // No operand predicates
     /* 287492 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287494 */     // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i8:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm, 7:{ *:[i64] })
     /* 287494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 287497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 287503 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 287506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 287509 */     GIR_RootConstrainSelectedInstOperands,
     /* 287510 */     // GIR_Coverage, 6586,
     /* 287510 */     GIR_EraseRootFromParent_Done,
     /* 287511 */   // Label 5581: @287511
     /* 287511 */   GIM_Try, /*On fail goto*//*Label 5582*/ GIMT_Encode4(287575), // Rule ID 6588 //
     /* 287516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 287524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 287528 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287533 */     // MIs[1] Operand 2
     /* 287533 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 287544 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 287548 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287552 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /* 287556 */     // MIs[2] Operand 1
     /* 287556 */     // No operand predicates
     /* 287556 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287558 */     // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm, 15:{ *:[i64] })
     /* 287558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 287561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 287567 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 287570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 287573 */     GIR_RootConstrainSelectedInstOperands,
     /* 287574 */     // GIR_Coverage, 6588,
     /* 287574 */     GIR_EraseRootFromParent_Done,
     /* 287575 */   // Label 5582: @287575
     /* 287575 */   GIM_Try, /*On fail goto*//*Label 5583*/ GIMT_Encode4(287678), // Rule ID 6589 //
     /* 287580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 287588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287592 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287597 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 287601 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287605 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 287609 */     // MIs[2] Operand 1
     /* 287609 */     // No operand predicates
     /* 287609 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287611 */     // (sra:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (SBFMXri:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 287611 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 287614 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 287618 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287623 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 287625 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 287628 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 287632 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287637 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 287640 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 287644 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 287647 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 287652 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 287657 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 287665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287670 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 287673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 287676 */     GIR_RootConstrainSelectedInstOperands,
     /* 287677 */     // GIR_Coverage, 6589,
     /* 287677 */     GIR_EraseRootFromParent_Done,
     /* 287678 */   // Label 5583: @287678
     /* 287678 */   GIM_Try, /*On fail goto*//*Label 5584*/ GIMT_Encode4(287716), // Rule ID 4048 //
     /* 287683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287695 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 287699 */     // MIs[1] Operand 1
     /* 287699 */     // No operand predicates
     /* 287699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287701 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm, 63:{ *:[i64] })
     /* 287701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 287704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287706 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287708 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 287711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 287714 */     GIR_RootConstrainSelectedInstOperands,
     /* 287715 */     // GIR_Coverage, 4048,
     /* 287715 */     GIR_EraseRootFromParent_Done,
     /* 287716 */   // Label 5584: @287716
     /* 287716 */   GIM_Try, /*On fail goto*//*Label 5585*/ GIMT_Encode4(287788), // Rule ID 2440 //
     /* 287721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 287733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287737 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287744 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 287744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 287747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 287751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287756 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 287759 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287763 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 287766 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 287771 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 287779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287781 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287786 */     GIR_RootConstrainSelectedInstOperands,
     /* 287787 */     // GIR_Coverage, 2440,
     /* 287787 */     GIR_EraseRootFromParent_Done,
     /* 287788 */   // Label 5585: @287788
     /* 287788 */   GIM_Try, /*On fail goto*//*Label 5586*/ GIMT_Encode4(287860), // Rule ID 2441 //
     /* 287793 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 287805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287816 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 287816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 287819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 287823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287828 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 287831 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287835 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 287838 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 287843 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 287851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287853 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287858 */     GIR_RootConstrainSelectedInstOperands,
     /* 287859 */     // GIR_Coverage, 2441,
     /* 287859 */     GIR_EraseRootFromParent_Done,
     /* 287860 */   // Label 5586: @287860
     /* 287860 */   GIM_Try, /*On fail goto*//*Label 5587*/ GIMT_Encode4(287880), // Rule ID 119 //
     /* 287865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287873 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 287873 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 287878 */     GIR_RootConstrainSelectedInstOperands,
     /* 287879 */     // GIR_Coverage, 119,
     /* 287879 */     GIR_Done,
     /* 287880 */   // Label 5587: @287880
     /* 287880 */   GIM_Reject,
     /* 287881 */ // Label 5580: @287881
     /* 287881 */ GIM_Reject,
     /* 287882 */ // Label 5571: @287882
     /* 287882 */ GIM_Reject,
     /* 287883 */ // Label 49: @287883
     /* 287883 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5590*/ GIMT_Encode4(288012),
     /* 287894 */ /*GILLT_s32*//*Label 5588*/ GIMT_Encode4(287902),
     /* 287898 */ /*GILLT_s64*//*Label 5589*/ GIMT_Encode4(287957),
     /* 287902 */ // Label 5588: @287902
     /* 287902 */ GIM_Try, /*On fail goto*//*Label 5591*/ GIMT_Encode4(287956), // Rule ID 188 //
     /* 287907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 287910 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 287913 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 287916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287920 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287924 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287928 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 287932 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287936 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 287940 */   // MIs[1] Operand 1
     /* 287940 */   // No operand predicates
     /* 287940 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287942 */   // (fshr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (EXTRWrri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] }):$imm)
     /* 287942 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRWrri),
     /* 287945 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287947 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287949 */   GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 287951 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 287954 */   GIR_RootConstrainSelectedInstOperands,
     /* 287955 */   // GIR_Coverage, 188,
     /* 287955 */   GIR_EraseRootFromParent_Done,
     /* 287956 */ // Label 5591: @287956
     /* 287956 */ GIM_Reject,
     /* 287957 */ // Label 5589: @287957
     /* 287957 */ GIM_Try, /*On fail goto*//*Label 5592*/ GIMT_Encode4(288011), // Rule ID 189 //
     /* 287962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 287965 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 287968 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 287971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287975 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287979 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287983 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 287987 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287991 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 287995 */   // MIs[1] Operand 1
     /* 287995 */   // No operand predicates
     /* 287995 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287997 */   // (fshr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (EXTRXrri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, (imm:{ *:[i64] }):$imm)
     /* 287997 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRXrri),
     /* 288000 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288002 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288004 */   GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 288006 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 288009 */   GIR_RootConstrainSelectedInstOperands,
     /* 288010 */   // GIR_Coverage, 189,
     /* 288010 */   GIR_EraseRootFromParent_Done,
     /* 288011 */ // Label 5592: @288011
     /* 288011 */ GIM_Reject,
     /* 288012 */ // Label 5590: @288012
     /* 288012 */ GIM_Reject,
     /* 288013 */ // Label 50: @288013
     /* 288013 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5595*/ GIMT_Encode4(288554),
     /* 288024 */ /*GILLT_s32*//*Label 5593*/ GIMT_Encode4(288032),
     /* 288028 */ /*GILLT_s64*//*Label 5594*/ GIMT_Encode4(288297),
     /* 288032 */ // Label 5593: @288032
     /* 288032 */ GIM_Try, /*On fail goto*//*Label 5596*/ GIMT_Encode4(288296),
     /* 288037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 288040 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 288043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288047 */   GIM_Try, /*On fail goto*//*Label 5597*/ GIMT_Encode4(288086), // Rule ID 184 //
     /* 288052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 288060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288064 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288069 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 288073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288075 */     // (rotr:{ *:[i32] } (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$Rn), 16:{ *:[i64] })  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 288075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 288078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 288084 */     GIR_RootConstrainSelectedInstOperands,
     /* 288085 */     // GIR_Coverage, 184,
     /* 288085 */     GIR_EraseRootFromParent_Done,
     /* 288086 */   // Label 5597: @288086
     /* 288086 */   GIM_Try, /*On fail goto*//*Label 5598*/ GIMT_Encode4(288123), // Rule ID 4043 //
     /* 288091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288103 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 288107 */     // MIs[1] Operand 1
     /* 288107 */     // No operand predicates
     /* 288107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288109 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (EXTRWrri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 288109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRWrri),
     /* 288112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288114 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288116 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288118 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 288121 */     GIR_RootConstrainSelectedInstOperands,
     /* 288122 */     // GIR_Coverage, 4043,
     /* 288122 */     GIR_EraseRootFromParent_Done,
     /* 288123 */   // Label 5598: @288123
     /* 288123 */   GIM_Try, /*On fail goto*//*Label 5599*/ GIMT_Encode4(288164), // Rule ID 3972 //
     /* 288128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 288140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288151 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 288151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 288154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288156 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288162 */     GIR_RootConstrainSelectedInstOperands,
     /* 288163 */     // GIR_Coverage, 3972,
     /* 288163 */     GIR_EraseRootFromParent_Done,
     /* 288164 */   // Label 5599: @288164
     /* 288164 */   GIM_Try, /*On fail goto*//*Label 5600*/ GIMT_Encode4(288205), // Rule ID 3973 //
     /* 288169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 288181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288185 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288190 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288192 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 288192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 288195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288197 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288203 */     GIR_RootConstrainSelectedInstOperands,
     /* 288204 */     // GIR_Coverage, 3973,
     /* 288204 */     GIR_EraseRootFromParent_Done,
     /* 288205 */   // Label 5600: @288205
     /* 288205 */   GIM_Try, /*On fail goto*//*Label 5601*/ GIMT_Encode4(288246), // Rule ID 3971 //
     /* 288210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 288222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288226 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288233 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 288233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 288236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288238 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288244 */     GIR_RootConstrainSelectedInstOperands,
     /* 288245 */     // GIR_Coverage, 3971,
     /* 288245 */     GIR_EraseRootFromParent_Done,
     /* 288246 */   // Label 5601: @288246
     /* 288246 */   GIM_Try, /*On fail goto*//*Label 5602*/ GIMT_Encode4(288295), // Rule ID 3970 //
     /* 288251 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288255 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i64:{ *:[i64] }:$Rm)  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }))
     /* 288255 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 288258 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 288262 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288267 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /* 288273 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288278 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 288283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 288286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288288 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288290 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288293 */     GIR_RootConstrainSelectedInstOperands,
     /* 288294 */     // GIR_Coverage, 3970,
     /* 288294 */     GIR_EraseRootFromParent_Done,
     /* 288295 */   // Label 5602: @288295
     /* 288295 */   GIM_Reject,
     /* 288296 */ // Label 5596: @288296
     /* 288296 */ GIM_Reject,
     /* 288297 */ // Label 5594: @288297
     /* 288297 */ GIM_Try, /*On fail goto*//*Label 5603*/ GIMT_Encode4(288553),
     /* 288302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 288305 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 288308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 288312 */   GIM_Try, /*On fail goto*//*Label 5604*/ GIMT_Encode4(288351), // Rule ID 187 //
     /* 288317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 288325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 288329 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 288334 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 288338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288340 */     // (rotr:{ *:[i64] } (bswap:{ *:[i64] } GPR64:{ *:[i64] }:$Rn), 32:{ *:[i64] })  =>  (REV32Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 288340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV32Xr),
     /* 288343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 288349 */     GIR_RootConstrainSelectedInstOperands,
     /* 288350 */     // GIR_Coverage, 187,
     /* 288350 */     GIR_EraseRootFromParent_Done,
     /* 288351 */   // Label 5604: @288351
     /* 288351 */   GIM_Try, /*On fail goto*//*Label 5605*/ GIMT_Encode4(288388), // Rule ID 4044 //
     /* 288356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 288360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288368 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 288372 */     // MIs[1] Operand 1
     /* 288372 */     // No operand predicates
     /* 288372 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288374 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (EXTRXrri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)
     /* 288374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRXrri),
     /* 288377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288379 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288381 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288383 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 288386 */     GIR_RootConstrainSelectedInstOperands,
     /* 288387 */     // GIR_Coverage, 4044,
     /* 288387 */     GIR_EraseRootFromParent_Done,
     /* 288388 */   // Label 5605: @288388
     /* 288388 */   GIM_Try, /*On fail goto*//*Label 5606*/ GIMT_Encode4(288460), // Rule ID 3974 //
     /* 288393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 288397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 288405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288416 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 288416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 288419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 288423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288428 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 288431 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288435 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 288438 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 288443 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 288451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288453 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288458 */     GIR_RootConstrainSelectedInstOperands,
     /* 288459 */     // GIR_Coverage, 3974,
     /* 288459 */     GIR_EraseRootFromParent_Done,
     /* 288460 */   // Label 5606: @288460
     /* 288460 */   GIM_Try, /*On fail goto*//*Label 5607*/ GIMT_Encode4(288532), // Rule ID 3975 //
     /* 288465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 288469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 288477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288481 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288488 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 288488 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 288491 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 288495 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288500 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 288503 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288507 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 288510 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 288515 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 288523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288525 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288530 */     GIR_RootConstrainSelectedInstOperands,
     /* 288531 */     // GIR_Coverage, 3975,
     /* 288531 */     GIR_EraseRootFromParent_Done,
     /* 288532 */   // Label 5607: @288532
     /* 288532 */   GIM_Try, /*On fail goto*//*Label 5608*/ GIMT_Encode4(288552), // Rule ID 122 //
     /* 288537 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 288541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 288545 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 288545 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 288550 */     GIR_RootConstrainSelectedInstOperands,
     /* 288551 */     // GIR_Coverage, 122,
     /* 288551 */     GIR_Done,
     /* 288552 */   // Label 5608: @288552
     /* 288552 */   GIM_Reject,
     /* 288553 */ // Label 5603: @288553
     /* 288553 */ GIM_Reject,
     /* 288554 */ // Label 5595: @288554
     /* 288554 */ GIM_Reject,
     /* 288555 */ // Label 51: @288555
     /* 288555 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5617*/ GIMT_Encode4(296331),
     /* 288566 */ /*GILLT_s64*//*Label 5609*/ GIMT_Encode4(288602), GIMT_Encode4(0),
     /* 288574 */ /*GILLT_v2s32*//*Label 5610*/ GIMT_Encode4(288995),
     /* 288578 */ /*GILLT_v2s64*//*Label 5611*/ GIMT_Encode4(290043),
     /* 288582 */ /*GILLT_v4s16*//*Label 5612*/ GIMT_Encode4(291091),
     /* 288586 */ /*GILLT_v4s32*//*Label 5613*/ GIMT_Encode4(292139),
     /* 288590 */ /*GILLT_v8s8*//*Label 5614*/ GIMT_Encode4(293187),
     /* 288594 */ /*GILLT_v8s16*//*Label 5615*/ GIMT_Encode4(294235),
     /* 288598 */ /*GILLT_v16s8*//*Label 5616*/ GIMT_Encode4(295283),
     /* 288602 */ // Label 5609: @288602
     /* 288602 */ GIM_Try, /*On fail goto*//*Label 5618*/ GIMT_Encode4(288994),
     /* 288607 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 288610 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 288613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288617 */   GIM_Try, /*On fail goto*//*Label 5619*/ GIMT_Encode4(288653), // Rule ID 5282 //
     /* 288622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288625 */     // MIs[0] Operand 1
     /* 288625 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 288630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288634 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288640 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 288642 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288644 */     // (setcc:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, v1i64:{ *:[v1i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 288644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv1i64rz),
     /* 288647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 288651 */     GIR_RootConstrainSelectedInstOperands,
     /* 288652 */     // GIR_Coverage, 5282,
     /* 288652 */     GIR_EraseRootFromParent_Done,
     /* 288653 */   // Label 5619: @288653
     /* 288653 */   GIM_Try, /*On fail goto*//*Label 5620*/ GIMT_Encode4(288689), // Rule ID 5283 //
     /* 288658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288661 */     // MIs[0] Operand 1
     /* 288661 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 288666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288670 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288676 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 288678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288680 */     // (setcc:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, v1i64:{ *:[v1i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 288680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv1i64rz),
     /* 288683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 288687 */     GIR_RootConstrainSelectedInstOperands,
     /* 288688 */     // GIR_Coverage, 5283,
     /* 288688 */     GIR_EraseRootFromParent_Done,
     /* 288689 */   // Label 5620: @288689
     /* 288689 */   GIM_Try, /*On fail goto*//*Label 5621*/ GIMT_Encode4(288725), // Rule ID 2508 //
     /* 288694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288697 */     // MIs[0] Operand 1
     /* 288697 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 288702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 288706 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288712 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 288714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288716 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 288716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv1i64rz),
     /* 288719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288723 */     GIR_RootConstrainSelectedInstOperands,
     /* 288724 */     // GIR_Coverage, 2508,
     /* 288724 */     GIR_EraseRootFromParent_Done,
     /* 288725 */   // Label 5621: @288725
     /* 288725 */   GIM_Try, /*On fail goto*//*Label 5622*/ GIMT_Encode4(288761), // Rule ID 5279 //
     /* 288730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288733 */     // MIs[0] Operand 1
     /* 288733 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 288738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 288742 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288748 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 288750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288752 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] }, SETGE:{ *:[Other] })  =>  (CMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 288752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv1i64rz),
     /* 288755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288759 */     GIR_RootConstrainSelectedInstOperands,
     /* 288760 */     // GIR_Coverage, 5279,
     /* 288760 */     GIR_EraseRootFromParent_Done,
     /* 288761 */   // Label 5622: @288761
     /* 288761 */   GIM_Try, /*On fail goto*//*Label 5623*/ GIMT_Encode4(288797), // Rule ID 5280 //
     /* 288766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288769 */     // MIs[0] Operand 1
     /* 288769 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 288774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 288778 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288784 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 288786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288788 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllOnesV:{ *:[v1i64] }, SETGT:{ *:[Other] })  =>  (CMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 288788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv1i64rz),
     /* 288791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288795 */     GIR_RootConstrainSelectedInstOperands,
     /* 288796 */     // GIR_Coverage, 5280,
     /* 288796 */     GIR_EraseRootFromParent_Done,
     /* 288797 */   // Label 5623: @288797
     /* 288797 */   GIM_Try, /*On fail goto*//*Label 5624*/ GIMT_Encode4(288833), // Rule ID 5281 //
     /* 288802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288805 */     // MIs[0] Operand 1
     /* 288805 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 288810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 288814 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288820 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 288822 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288824 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] }, SETGT:{ *:[Other] })  =>  (CMGTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 288824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv1i64rz),
     /* 288827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288831 */     GIR_RootConstrainSelectedInstOperands,
     /* 288832 */     // GIR_Coverage, 5281,
     /* 288832 */     GIR_EraseRootFromParent_Done,
     /* 288833 */   // Label 5624: @288833
     /* 288833 */   GIM_Try, /*On fail goto*//*Label 5625*/ GIMT_Encode4(288865), // Rule ID 1608 //
     /* 288838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288841 */     // MIs[0] Operand 1
     /* 288841 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 288846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288854 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 288854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv1i64),
     /* 288857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288861 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 288863 */     GIR_RootConstrainSelectedInstOperands,
     /* 288864 */     // GIR_Coverage, 1608,
     /* 288864 */     GIR_EraseRootFromParent_Done,
     /* 288865 */   // Label 5625: @288865
     /* 288865 */   GIM_Try, /*On fail goto*//*Label 5626*/ GIMT_Encode4(288897), // Rule ID 1609 //
     /* 288870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288873 */     // MIs[0] Operand 1
     /* 288873 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 288878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288886 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 288886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv1i64),
     /* 288889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 288895 */     GIR_RootConstrainSelectedInstOperands,
     /* 288896 */     // GIR_Coverage, 1609,
     /* 288896 */     GIR_EraseRootFromParent_Done,
     /* 288897 */   // Label 5626: @288897
     /* 288897 */   GIM_Try, /*On fail goto*//*Label 5627*/ GIMT_Encode4(288929), // Rule ID 1610 //
     /* 288902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288905 */     // MIs[0] Operand 1
     /* 288905 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 288910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288918 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 288918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv1i64),
     /* 288921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288925 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 288927 */     GIR_RootConstrainSelectedInstOperands,
     /* 288928 */     // GIR_Coverage, 1610,
     /* 288928 */     GIR_EraseRootFromParent_Done,
     /* 288929 */   // Label 5627: @288929
     /* 288929 */   GIM_Try, /*On fail goto*//*Label 5628*/ GIMT_Encode4(288961), // Rule ID 1611 //
     /* 288934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288937 */     // MIs[0] Operand 1
     /* 288937 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 288942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288950 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 288950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv1i64),
     /* 288953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288957 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 288959 */     GIR_RootConstrainSelectedInstOperands,
     /* 288960 */     // GIR_Coverage, 1611,
     /* 288960 */     GIR_EraseRootFromParent_Done,
     /* 288961 */   // Label 5628: @288961
     /* 288961 */   GIM_Try, /*On fail goto*//*Label 5629*/ GIMT_Encode4(288993), // Rule ID 1612 //
     /* 288966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288969 */     // MIs[0] Operand 1
     /* 288969 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 288974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288982 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 288982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv1i64),
     /* 288985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 288991 */     GIR_RootConstrainSelectedInstOperands,
     /* 288992 */     // GIR_Coverage, 1612,
     /* 288992 */     GIR_EraseRootFromParent_Done,
     /* 288993 */   // Label 5629: @288993
     /* 288993 */   GIM_Reject,
     /* 288994 */ // Label 5618: @288994
     /* 288994 */ GIM_Reject,
     /* 288995 */ // Label 5610: @288995
     /* 288995 */ GIM_Try, /*On fail goto*//*Label 5630*/ GIMT_Encode4(290042),
     /* 289000 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 289003 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 289006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289010 */   GIM_Try, /*On fail goto*//*Label 5631*/ GIMT_Encode4(289050), // Rule ID 754 //
     /* 289015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289018 */     // MIs[0] Operand 1
     /* 289018 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 289023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289027 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289033 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289041 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 289044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289046 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 289048 */     GIR_RootConstrainSelectedInstOperands,
     /* 289049 */     // GIR_Coverage, 754,
     /* 289049 */     GIR_EraseRootFromParent_Done,
     /* 289050 */   // Label 5631: @289050
     /* 289050 */   GIM_Try, /*On fail goto*//*Label 5632*/ GIMT_Encode4(289090), // Rule ID 761 //
     /* 289055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289058 */     // MIs[0] Operand 1
     /* 289058 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 289063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289067 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289073 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289081 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 289084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 289088 */     GIR_RootConstrainSelectedInstOperands,
     /* 289089 */     // GIR_Coverage, 761,
     /* 289089 */     GIR_EraseRootFromParent_Done,
     /* 289090 */   // Label 5632: @289090
     /* 289090 */   GIM_Try, /*On fail goto*//*Label 5633*/ GIMT_Encode4(289127), // Rule ID 5216 //
     /* 289095 */     // MIs[0] Operand 1
     /* 289095 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 289100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289104 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289110 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289118 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 289121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 289125 */     GIR_RootConstrainSelectedInstOperands,
     /* 289126 */     // GIR_Coverage, 5216,
     /* 289126 */     GIR_EraseRootFromParent_Done,
     /* 289127 */   // Label 5633: @289127
     /* 289127 */   GIM_Try, /*On fail goto*//*Label 5634*/ GIMT_Encode4(289164), // Rule ID 5223 //
     /* 289132 */     // MIs[0] Operand 1
     /* 289132 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 289137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289141 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289147 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289155 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 289158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 289162 */     GIR_RootConstrainSelectedInstOperands,
     /* 289163 */     // GIR_Coverage, 5223,
     /* 289163 */     GIR_EraseRootFromParent_Done,
     /* 289164 */   // Label 5634: @289164
     /* 289164 */   GIM_Try, /*On fail goto*//*Label 5635*/ GIMT_Encode4(289201), // Rule ID 5230 //
     /* 289169 */     // MIs[0] Operand 1
     /* 289169 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 289174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289178 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289184 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289190 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289192 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 289195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289197 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 289199 */     GIR_RootConstrainSelectedInstOperands,
     /* 289200 */     // GIR_Coverage, 5230,
     /* 289200 */     GIR_EraseRootFromParent_Done,
     /* 289201 */   // Label 5635: @289201
     /* 289201 */   GIM_Try, /*On fail goto*//*Label 5636*/ GIMT_Encode4(289238), // Rule ID 5237 //
     /* 289206 */     // MIs[0] Operand 1
     /* 289206 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 289211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289215 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289221 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289229 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 289232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 289236 */     GIR_RootConstrainSelectedInstOperands,
     /* 289237 */     // GIR_Coverage, 5237,
     /* 289237 */     GIR_EraseRootFromParent_Done,
     /* 289238 */   // Label 5636: @289238
     /* 289238 */   GIM_Try, /*On fail goto*//*Label 5637*/ GIMT_Encode4(289275), // Rule ID 5244 //
     /* 289243 */     // MIs[0] Operand 1
     /* 289243 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 289248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289252 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289258 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289266 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 289269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289271 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 289273 */     GIR_RootConstrainSelectedInstOperands,
     /* 289274 */     // GIR_Coverage, 5244,
     /* 289274 */     GIR_EraseRootFromParent_Done,
     /* 289275 */   // Label 5637: @289275
     /* 289275 */   GIM_Try, /*On fail goto*//*Label 5638*/ GIMT_Encode4(289315), // Rule ID 726 //
     /* 289280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289283 */     // MIs[0] Operand 1
     /* 289283 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 289288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289296 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289302 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289306 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 289309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289313 */     GIR_RootConstrainSelectedInstOperands,
     /* 289314 */     // GIR_Coverage, 726,
     /* 289314 */     GIR_EraseRootFromParent_Done,
     /* 289315 */   // Label 5638: @289315
     /* 289315 */   GIM_Try, /*On fail goto*//*Label 5639*/ GIMT_Encode4(289355), // Rule ID 737 //
     /* 289320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289323 */     // MIs[0] Operand 1
     /* 289323 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 289328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289336 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289342 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289346 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 289349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289353 */     GIR_RootConstrainSelectedInstOperands,
     /* 289354 */     // GIR_Coverage, 737,
     /* 289354 */     GIR_EraseRootFromParent_Done,
     /* 289355 */   // Label 5639: @289355
     /* 289355 */   GIM_Try, /*On fail goto*//*Label 5640*/ GIMT_Encode4(289395), // Rule ID 738 //
     /* 289360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289363 */     // MIs[0] Operand 1
     /* 289363 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 289368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289376 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289382 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 289384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289386 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllOnesV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 289389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289393 */     GIR_RootConstrainSelectedInstOperands,
     /* 289394 */     // GIR_Coverage, 738,
     /* 289394 */     GIR_EraseRootFromParent_Done,
     /* 289395 */   // Label 5640: @289395
     /* 289395 */   GIM_Try, /*On fail goto*//*Label 5641*/ GIMT_Encode4(289435), // Rule ID 747 //
     /* 289400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289403 */     // MIs[0] Operand 1
     /* 289403 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 289408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289416 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289422 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289426 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 289429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289433 */     GIR_RootConstrainSelectedInstOperands,
     /* 289434 */     // GIR_Coverage, 747,
     /* 289434 */     GIR_EraseRootFromParent_Done,
     /* 289435 */   // Label 5641: @289435
     /* 289435 */   GIM_Try, /*On fail goto*//*Label 5642*/ GIMT_Encode4(289472), // Rule ID 5181 //
     /* 289440 */     // MIs[0] Operand 1
     /* 289440 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 289445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289453 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289459 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289463 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 289466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289470 */     GIR_RootConstrainSelectedInstOperands,
     /* 289471 */     // GIR_Coverage, 5181,
     /* 289471 */     GIR_EraseRootFromParent_Done,
     /* 289472 */   // Label 5642: @289472
     /* 289472 */   GIM_Try, /*On fail goto*//*Label 5643*/ GIMT_Encode4(289509), // Rule ID 5188 //
     /* 289477 */     // MIs[0] Operand 1
     /* 289477 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 289482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289490 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289496 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289500 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 289503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289507 */     GIR_RootConstrainSelectedInstOperands,
     /* 289508 */     // GIR_Coverage, 5188,
     /* 289508 */     GIR_EraseRootFromParent_Done,
     /* 289509 */   // Label 5643: @289509
     /* 289509 */   GIM_Try, /*On fail goto*//*Label 5644*/ GIMT_Encode4(289546), // Rule ID 5195 //
     /* 289514 */     // MIs[0] Operand 1
     /* 289514 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 289519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289527 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289533 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289537 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 289540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289544 */     GIR_RootConstrainSelectedInstOperands,
     /* 289545 */     // GIR_Coverage, 5195,
     /* 289545 */     GIR_EraseRootFromParent_Done,
     /* 289546 */   // Label 5644: @289546
     /* 289546 */   GIM_Try, /*On fail goto*//*Label 5645*/ GIMT_Encode4(289583), // Rule ID 5202 //
     /* 289551 */     // MIs[0] Operand 1
     /* 289551 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 289556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289564 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289570 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289574 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETLT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 289577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289581 */     GIR_RootConstrainSelectedInstOperands,
     /* 289582 */     // GIR_Coverage, 5202,
     /* 289582 */     GIR_EraseRootFromParent_Done,
     /* 289583 */   // Label 5645: @289583
     /* 289583 */   GIM_Try, /*On fail goto*//*Label 5646*/ GIMT_Encode4(289620), // Rule ID 5209 //
     /* 289588 */     // MIs[0] Operand 1
     /* 289588 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 289593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289601 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289607 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289611 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETLE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 289614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289618 */     GIR_RootConstrainSelectedInstOperands,
     /* 289619 */     // GIR_Coverage, 5209,
     /* 289619 */     GIR_EraseRootFromParent_Done,
     /* 289620 */   // Label 5646: @289620
     /* 289620 */   GIM_Try, /*On fail goto*//*Label 5647*/ GIMT_Encode4(289652), // Rule ID 1125 //
     /* 289625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289628 */     // MIs[0] Operand 1
     /* 289628 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 289633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289641 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 289641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32),
     /* 289644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289650 */     GIR_RootConstrainSelectedInstOperands,
     /* 289651 */     // GIR_Coverage, 1125,
     /* 289651 */     GIR_EraseRootFromParent_Done,
     /* 289652 */   // Label 5647: @289652
     /* 289652 */   GIM_Try, /*On fail goto*//*Label 5648*/ GIMT_Encode4(289684), // Rule ID 1132 //
     /* 289657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289660 */     // MIs[0] Operand 1
     /* 289660 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 289665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289673 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 289673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 289676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289682 */     GIR_RootConstrainSelectedInstOperands,
     /* 289683 */     // GIR_Coverage, 1132,
     /* 289683 */     GIR_EraseRootFromParent_Done,
     /* 289684 */   // Label 5648: @289684
     /* 289684 */   GIM_Try, /*On fail goto*//*Label 5649*/ GIMT_Encode4(289716), // Rule ID 1139 //
     /* 289689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289692 */     // MIs[0] Operand 1
     /* 289692 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 289697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289705 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 289705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 289708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289712 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289714 */     GIR_RootConstrainSelectedInstOperands,
     /* 289715 */     // GIR_Coverage, 1139,
     /* 289715 */     GIR_EraseRootFromParent_Done,
     /* 289716 */   // Label 5649: @289716
     /* 289716 */   GIM_Try, /*On fail goto*//*Label 5650*/ GIMT_Encode4(289748), // Rule ID 1146 //
     /* 289721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289724 */     // MIs[0] Operand 1
     /* 289724 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 289729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289737 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 289737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 289740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289746 */     GIR_RootConstrainSelectedInstOperands,
     /* 289747 */     // GIR_Coverage, 1146,
     /* 289747 */     GIR_EraseRootFromParent_Done,
     /* 289748 */   // Label 5650: @289748
     /* 289748 */   GIM_Try, /*On fail goto*//*Label 5651*/ GIMT_Encode4(289780), // Rule ID 1153 //
     /* 289753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289756 */     // MIs[0] Operand 1
     /* 289756 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 289761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289769 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 289769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 289772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289776 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289778 */     GIR_RootConstrainSelectedInstOperands,
     /* 289779 */     // GIR_Coverage, 1153,
     /* 289779 */     GIR_EraseRootFromParent_Done,
     /* 289780 */   // Label 5651: @289780
     /* 289780 */   GIM_Try, /*On fail goto*//*Label 5652*/ GIMT_Encode4(289809), // Rule ID 5118 //
     /* 289785 */     // MIs[0] Operand 1
     /* 289785 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 289790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289798 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 289798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32),
     /* 289801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289805 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289807 */     GIR_RootConstrainSelectedInstOperands,
     /* 289808 */     // GIR_Coverage, 5118,
     /* 289808 */     GIR_EraseRootFromParent_Done,
     /* 289809 */   // Label 5652: @289809
     /* 289809 */   GIM_Try, /*On fail goto*//*Label 5653*/ GIMT_Encode4(289838), // Rule ID 5125 //
     /* 289814 */     // MIs[0] Operand 1
     /* 289814 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 289819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289827 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 289827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 289830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289836 */     GIR_RootConstrainSelectedInstOperands,
     /* 289837 */     // GIR_Coverage, 5125,
     /* 289837 */     GIR_EraseRootFromParent_Done,
     /* 289838 */   // Label 5653: @289838
     /* 289838 */   GIM_Try, /*On fail goto*//*Label 5654*/ GIMT_Encode4(289867), // Rule ID 5132 //
     /* 289843 */     // MIs[0] Operand 1
     /* 289843 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 289848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289856 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 289856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 289859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289865 */     GIR_RootConstrainSelectedInstOperands,
     /* 289866 */     // GIR_Coverage, 5132,
     /* 289866 */     GIR_EraseRootFromParent_Done,
     /* 289867 */   // Label 5654: @289867
     /* 289867 */   GIM_Try, /*On fail goto*//*Label 5655*/ GIMT_Encode4(289896), // Rule ID 5139 //
     /* 289872 */     // MIs[0] Operand 1
     /* 289872 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 289877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289885 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 289885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 289888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289892 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289894 */     GIR_RootConstrainSelectedInstOperands,
     /* 289895 */     // GIR_Coverage, 5139,
     /* 289895 */     GIR_EraseRootFromParent_Done,
     /* 289896 */   // Label 5655: @289896
     /* 289896 */   GIM_Try, /*On fail goto*//*Label 5656*/ GIMT_Encode4(289925), // Rule ID 5146 //
     /* 289901 */     // MIs[0] Operand 1
     /* 289901 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 289906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289914 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 289914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 289917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289923 */     GIR_RootConstrainSelectedInstOperands,
     /* 289924 */     // GIR_Coverage, 5146,
     /* 289924 */     GIR_EraseRootFromParent_Done,
     /* 289925 */   // Label 5656: @289925
     /* 289925 */   GIM_Try, /*On fail goto*//*Label 5657*/ GIMT_Encode4(289954), // Rule ID 5153 //
     /* 289930 */     // MIs[0] Operand 1
     /* 289930 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 289935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289943 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 289943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 289946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289952 */     GIR_RootConstrainSelectedInstOperands,
     /* 289953 */     // GIR_Coverage, 5153,
     /* 289953 */     GIR_EraseRootFromParent_Done,
     /* 289954 */   // Label 5657: @289954
     /* 289954 */   GIM_Try, /*On fail goto*//*Label 5658*/ GIMT_Encode4(289983), // Rule ID 5160 //
     /* 289959 */     // MIs[0] Operand 1
     /* 289959 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 289964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289972 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 289972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 289975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289977 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289981 */     GIR_RootConstrainSelectedInstOperands,
     /* 289982 */     // GIR_Coverage, 5160,
     /* 289982 */     GIR_EraseRootFromParent_Done,
     /* 289983 */   // Label 5658: @289983
     /* 289983 */   GIM_Try, /*On fail goto*//*Label 5659*/ GIMT_Encode4(290012), // Rule ID 5167 //
     /* 289988 */     // MIs[0] Operand 1
     /* 289988 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 289993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290001 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 290001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 290004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290010 */     GIR_RootConstrainSelectedInstOperands,
     /* 290011 */     // GIR_Coverage, 5167,
     /* 290011 */     GIR_EraseRootFromParent_Done,
     /* 290012 */   // Label 5659: @290012
     /* 290012 */   GIM_Try, /*On fail goto*//*Label 5660*/ GIMT_Encode4(290041), // Rule ID 5174 //
     /* 290017 */     // MIs[0] Operand 1
     /* 290017 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 290022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290030 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 290030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 290033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290039 */     GIR_RootConstrainSelectedInstOperands,
     /* 290040 */     // GIR_Coverage, 5174,
     /* 290040 */     GIR_EraseRootFromParent_Done,
     /* 290041 */   // Label 5660: @290041
     /* 290041 */   GIM_Reject,
     /* 290042 */ // Label 5630: @290042
     /* 290042 */ GIM_Reject,
     /* 290043 */ // Label 5611: @290043
     /* 290043 */ GIM_Try, /*On fail goto*//*Label 5661*/ GIMT_Encode4(291090),
     /* 290048 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 290051 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 290054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290058 */   GIM_Try, /*On fail goto*//*Label 5662*/ GIMT_Encode4(290098), // Rule ID 756 //
     /* 290063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290066 */     // MIs[0] Operand 1
     /* 290066 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 290071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290075 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290081 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290089 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 290092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 290096 */     GIR_RootConstrainSelectedInstOperands,
     /* 290097 */     // GIR_Coverage, 756,
     /* 290097 */     GIR_EraseRootFromParent_Done,
     /* 290098 */   // Label 5662: @290098
     /* 290098 */   GIM_Try, /*On fail goto*//*Label 5663*/ GIMT_Encode4(290138), // Rule ID 763 //
     /* 290103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290106 */     // MIs[0] Operand 1
     /* 290106 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 290111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290115 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290121 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290129 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 290132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 290136 */     GIR_RootConstrainSelectedInstOperands,
     /* 290137 */     // GIR_Coverage, 763,
     /* 290137 */     GIR_EraseRootFromParent_Done,
     /* 290138 */   // Label 5663: @290138
     /* 290138 */   GIM_Try, /*On fail goto*//*Label 5664*/ GIMT_Encode4(290175), // Rule ID 5218 //
     /* 290143 */     // MIs[0] Operand 1
     /* 290143 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 290148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290152 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290158 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290166 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 290169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 290173 */     GIR_RootConstrainSelectedInstOperands,
     /* 290174 */     // GIR_Coverage, 5218,
     /* 290174 */     GIR_EraseRootFromParent_Done,
     /* 290175 */   // Label 5664: @290175
     /* 290175 */   GIM_Try, /*On fail goto*//*Label 5665*/ GIMT_Encode4(290212), // Rule ID 5225 //
     /* 290180 */     // MIs[0] Operand 1
     /* 290180 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 290185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290189 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290195 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290203 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 290206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 290210 */     GIR_RootConstrainSelectedInstOperands,
     /* 290211 */     // GIR_Coverage, 5225,
     /* 290211 */     GIR_EraseRootFromParent_Done,
     /* 290212 */   // Label 5665: @290212
     /* 290212 */   GIM_Try, /*On fail goto*//*Label 5666*/ GIMT_Encode4(290249), // Rule ID 5232 //
     /* 290217 */     // MIs[0] Operand 1
     /* 290217 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 290222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290226 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290232 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290240 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 290243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 290247 */     GIR_RootConstrainSelectedInstOperands,
     /* 290248 */     // GIR_Coverage, 5232,
     /* 290248 */     GIR_EraseRootFromParent_Done,
     /* 290249 */   // Label 5666: @290249
     /* 290249 */   GIM_Try, /*On fail goto*//*Label 5667*/ GIMT_Encode4(290286), // Rule ID 5239 //
     /* 290254 */     // MIs[0] Operand 1
     /* 290254 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 290259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290263 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290269 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290277 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 290280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 290284 */     GIR_RootConstrainSelectedInstOperands,
     /* 290285 */     // GIR_Coverage, 5239,
     /* 290285 */     GIR_EraseRootFromParent_Done,
     /* 290286 */   // Label 5667: @290286
     /* 290286 */   GIM_Try, /*On fail goto*//*Label 5668*/ GIMT_Encode4(290323), // Rule ID 5246 //
     /* 290291 */     // MIs[0] Operand 1
     /* 290291 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 290296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290300 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290306 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290314 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 290317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290319 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 290321 */     GIR_RootConstrainSelectedInstOperands,
     /* 290322 */     // GIR_Coverage, 5246,
     /* 290322 */     GIR_EraseRootFromParent_Done,
     /* 290323 */   // Label 5668: @290323
     /* 290323 */   GIM_Try, /*On fail goto*//*Label 5669*/ GIMT_Encode4(290363), // Rule ID 728 //
     /* 290328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290331 */     // MIs[0] Operand 1
     /* 290331 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 290336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290344 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290350 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290354 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 290357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290361 */     GIR_RootConstrainSelectedInstOperands,
     /* 290362 */     // GIR_Coverage, 728,
     /* 290362 */     GIR_EraseRootFromParent_Done,
     /* 290363 */   // Label 5669: @290363
     /* 290363 */   GIM_Try, /*On fail goto*//*Label 5670*/ GIMT_Encode4(290403), // Rule ID 741 //
     /* 290368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290371 */     // MIs[0] Operand 1
     /* 290371 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 290376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290384 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290390 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290394 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 290397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290401 */     GIR_RootConstrainSelectedInstOperands,
     /* 290402 */     // GIR_Coverage, 741,
     /* 290402 */     GIR_EraseRootFromParent_Done,
     /* 290403 */   // Label 5670: @290403
     /* 290403 */   GIM_Try, /*On fail goto*//*Label 5671*/ GIMT_Encode4(290443), // Rule ID 742 //
     /* 290408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290411 */     // MIs[0] Operand 1
     /* 290411 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 290416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290424 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290430 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 290432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290434 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 290437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290441 */     GIR_RootConstrainSelectedInstOperands,
     /* 290442 */     // GIR_Coverage, 742,
     /* 290442 */     GIR_EraseRootFromParent_Done,
     /* 290443 */   // Label 5671: @290443
     /* 290443 */   GIM_Try, /*On fail goto*//*Label 5672*/ GIMT_Encode4(290483), // Rule ID 749 //
     /* 290448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290451 */     // MIs[0] Operand 1
     /* 290451 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 290456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290464 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290470 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290472 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290474 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 290477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290481 */     GIR_RootConstrainSelectedInstOperands,
     /* 290482 */     // GIR_Coverage, 749,
     /* 290482 */     GIR_EraseRootFromParent_Done,
     /* 290483 */   // Label 5672: @290483
     /* 290483 */   GIM_Try, /*On fail goto*//*Label 5673*/ GIMT_Encode4(290520), // Rule ID 5183 //
     /* 290488 */     // MIs[0] Operand 1
     /* 290488 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 290493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290501 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290507 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290511 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 290514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290518 */     GIR_RootConstrainSelectedInstOperands,
     /* 290519 */     // GIR_Coverage, 5183,
     /* 290519 */     GIR_EraseRootFromParent_Done,
     /* 290520 */   // Label 5673: @290520
     /* 290520 */   GIM_Try, /*On fail goto*//*Label 5674*/ GIMT_Encode4(290557), // Rule ID 5190 //
     /* 290525 */     // MIs[0] Operand 1
     /* 290525 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 290530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290538 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290544 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290548 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 290551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290555 */     GIR_RootConstrainSelectedInstOperands,
     /* 290556 */     // GIR_Coverage, 5190,
     /* 290556 */     GIR_EraseRootFromParent_Done,
     /* 290557 */   // Label 5674: @290557
     /* 290557 */   GIM_Try, /*On fail goto*//*Label 5675*/ GIMT_Encode4(290594), // Rule ID 5197 //
     /* 290562 */     // MIs[0] Operand 1
     /* 290562 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 290567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290575 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290581 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290585 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 290588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290592 */     GIR_RootConstrainSelectedInstOperands,
     /* 290593 */     // GIR_Coverage, 5197,
     /* 290593 */     GIR_EraseRootFromParent_Done,
     /* 290594 */   // Label 5675: @290594
     /* 290594 */   GIM_Try, /*On fail goto*//*Label 5676*/ GIMT_Encode4(290631), // Rule ID 5204 //
     /* 290599 */     // MIs[0] Operand 1
     /* 290599 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 290604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290612 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290618 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290622 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETLT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 290625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290629 */     GIR_RootConstrainSelectedInstOperands,
     /* 290630 */     // GIR_Coverage, 5204,
     /* 290630 */     GIR_EraseRootFromParent_Done,
     /* 290631 */   // Label 5676: @290631
     /* 290631 */   GIM_Try, /*On fail goto*//*Label 5677*/ GIMT_Encode4(290668), // Rule ID 5211 //
     /* 290636 */     // MIs[0] Operand 1
     /* 290636 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 290641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290649 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290655 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290659 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETLE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 290662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290666 */     GIR_RootConstrainSelectedInstOperands,
     /* 290667 */     // GIR_Coverage, 5211,
     /* 290667 */     GIR_EraseRootFromParent_Done,
     /* 290668 */   // Label 5677: @290668
     /* 290668 */   GIM_Try, /*On fail goto*//*Label 5678*/ GIMT_Encode4(290700), // Rule ID 1127 //
     /* 290673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290676 */     // MIs[0] Operand 1
     /* 290676 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 290681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290689 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 290689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64),
     /* 290692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290698 */     GIR_RootConstrainSelectedInstOperands,
     /* 290699 */     // GIR_Coverage, 1127,
     /* 290699 */     GIR_EraseRootFromParent_Done,
     /* 290700 */   // Label 5678: @290700
     /* 290700 */   GIM_Try, /*On fail goto*//*Label 5679*/ GIMT_Encode4(290732), // Rule ID 1134 //
     /* 290705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290708 */     // MIs[0] Operand 1
     /* 290708 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 290713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290721 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 290721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 290724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290728 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290730 */     GIR_RootConstrainSelectedInstOperands,
     /* 290731 */     // GIR_Coverage, 1134,
     /* 290731 */     GIR_EraseRootFromParent_Done,
     /* 290732 */   // Label 5679: @290732
     /* 290732 */   GIM_Try, /*On fail goto*//*Label 5680*/ GIMT_Encode4(290764), // Rule ID 1141 //
     /* 290737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290740 */     // MIs[0] Operand 1
     /* 290740 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 290745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290753 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 290753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 290756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290762 */     GIR_RootConstrainSelectedInstOperands,
     /* 290763 */     // GIR_Coverage, 1141,
     /* 290763 */     GIR_EraseRootFromParent_Done,
     /* 290764 */   // Label 5680: @290764
     /* 290764 */   GIM_Try, /*On fail goto*//*Label 5681*/ GIMT_Encode4(290796), // Rule ID 1148 //
     /* 290769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290772 */     // MIs[0] Operand 1
     /* 290772 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 290777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290785 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 290785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 290788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290794 */     GIR_RootConstrainSelectedInstOperands,
     /* 290795 */     // GIR_Coverage, 1148,
     /* 290795 */     GIR_EraseRootFromParent_Done,
     /* 290796 */   // Label 5681: @290796
     /* 290796 */   GIM_Try, /*On fail goto*//*Label 5682*/ GIMT_Encode4(290828), // Rule ID 1155 //
     /* 290801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290804 */     // MIs[0] Operand 1
     /* 290804 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 290809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290817 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 290817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 290820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290826 */     GIR_RootConstrainSelectedInstOperands,
     /* 290827 */     // GIR_Coverage, 1155,
     /* 290827 */     GIR_EraseRootFromParent_Done,
     /* 290828 */   // Label 5682: @290828
     /* 290828 */   GIM_Try, /*On fail goto*//*Label 5683*/ GIMT_Encode4(290857), // Rule ID 5120 //
     /* 290833 */     // MIs[0] Operand 1
     /* 290833 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 290838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290846 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 290846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64),
     /* 290849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290855 */     GIR_RootConstrainSelectedInstOperands,
     /* 290856 */     // GIR_Coverage, 5120,
     /* 290856 */     GIR_EraseRootFromParent_Done,
     /* 290857 */   // Label 5683: @290857
     /* 290857 */   GIM_Try, /*On fail goto*//*Label 5684*/ GIMT_Encode4(290886), // Rule ID 5127 //
     /* 290862 */     // MIs[0] Operand 1
     /* 290862 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 290867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290875 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 290875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 290878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290884 */     GIR_RootConstrainSelectedInstOperands,
     /* 290885 */     // GIR_Coverage, 5127,
     /* 290885 */     GIR_EraseRootFromParent_Done,
     /* 290886 */   // Label 5684: @290886
     /* 290886 */   GIM_Try, /*On fail goto*//*Label 5685*/ GIMT_Encode4(290915), // Rule ID 5134 //
     /* 290891 */     // MIs[0] Operand 1
     /* 290891 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 290896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290904 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 290904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 290907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290911 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290913 */     GIR_RootConstrainSelectedInstOperands,
     /* 290914 */     // GIR_Coverage, 5134,
     /* 290914 */     GIR_EraseRootFromParent_Done,
     /* 290915 */   // Label 5685: @290915
     /* 290915 */   GIM_Try, /*On fail goto*//*Label 5686*/ GIMT_Encode4(290944), // Rule ID 5141 //
     /* 290920 */     // MIs[0] Operand 1
     /* 290920 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 290925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290933 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 290933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 290936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290942 */     GIR_RootConstrainSelectedInstOperands,
     /* 290943 */     // GIR_Coverage, 5141,
     /* 290943 */     GIR_EraseRootFromParent_Done,
     /* 290944 */   // Label 5686: @290944
     /* 290944 */   GIM_Try, /*On fail goto*//*Label 5687*/ GIMT_Encode4(290973), // Rule ID 5148 //
     /* 290949 */     // MIs[0] Operand 1
     /* 290949 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 290954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290962 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 290962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 290965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290971 */     GIR_RootConstrainSelectedInstOperands,
     /* 290972 */     // GIR_Coverage, 5148,
     /* 290972 */     GIR_EraseRootFromParent_Done,
     /* 290973 */   // Label 5687: @290973
     /* 290973 */   GIM_Try, /*On fail goto*//*Label 5688*/ GIMT_Encode4(291002), // Rule ID 5155 //
     /* 290978 */     // MIs[0] Operand 1
     /* 290978 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 290983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290991 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 290991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 290994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291000 */     GIR_RootConstrainSelectedInstOperands,
     /* 291001 */     // GIR_Coverage, 5155,
     /* 291001 */     GIR_EraseRootFromParent_Done,
     /* 291002 */   // Label 5688: @291002
     /* 291002 */   GIM_Try, /*On fail goto*//*Label 5689*/ GIMT_Encode4(291031), // Rule ID 5162 //
     /* 291007 */     // MIs[0] Operand 1
     /* 291007 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 291012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291020 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 291020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 291023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291025 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291029 */     GIR_RootConstrainSelectedInstOperands,
     /* 291030 */     // GIR_Coverage, 5162,
     /* 291030 */     GIR_EraseRootFromParent_Done,
     /* 291031 */   // Label 5689: @291031
     /* 291031 */   GIM_Try, /*On fail goto*//*Label 5690*/ GIMT_Encode4(291060), // Rule ID 5169 //
     /* 291036 */     // MIs[0] Operand 1
     /* 291036 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 291041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291049 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 291049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 291052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291058 */     GIR_RootConstrainSelectedInstOperands,
     /* 291059 */     // GIR_Coverage, 5169,
     /* 291059 */     GIR_EraseRootFromParent_Done,
     /* 291060 */   // Label 5690: @291060
     /* 291060 */   GIM_Try, /*On fail goto*//*Label 5691*/ GIMT_Encode4(291089), // Rule ID 5176 //
     /* 291065 */     // MIs[0] Operand 1
     /* 291065 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 291070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291078 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 291078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 291081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291087 */     GIR_RootConstrainSelectedInstOperands,
     /* 291088 */     // GIR_Coverage, 5176,
     /* 291088 */     GIR_EraseRootFromParent_Done,
     /* 291089 */   // Label 5691: @291089
     /* 291089 */   GIM_Reject,
     /* 291090 */ // Label 5661: @291090
     /* 291090 */ GIM_Reject,
     /* 291091 */ // Label 5612: @291091
     /* 291091 */ GIM_Try, /*On fail goto*//*Label 5692*/ GIMT_Encode4(292138),
     /* 291096 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 291099 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 291102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291106 */   GIM_Try, /*On fail goto*//*Label 5693*/ GIMT_Encode4(291146), // Rule ID 752 //
     /* 291111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291114 */     // MIs[0] Operand 1
     /* 291114 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 291119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291123 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291129 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291137 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 291140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291144 */     GIR_RootConstrainSelectedInstOperands,
     /* 291145 */     // GIR_Coverage, 752,
     /* 291145 */     GIR_EraseRootFromParent_Done,
     /* 291146 */   // Label 5693: @291146
     /* 291146 */   GIM_Try, /*On fail goto*//*Label 5694*/ GIMT_Encode4(291186), // Rule ID 759 //
     /* 291151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291154 */     // MIs[0] Operand 1
     /* 291154 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291163 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291169 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291177 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 291180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291184 */     GIR_RootConstrainSelectedInstOperands,
     /* 291185 */     // GIR_Coverage, 759,
     /* 291185 */     GIR_EraseRootFromParent_Done,
     /* 291186 */   // Label 5694: @291186
     /* 291186 */   GIM_Try, /*On fail goto*//*Label 5695*/ GIMT_Encode4(291223), // Rule ID 5214 //
     /* 291191 */     // MIs[0] Operand 1
     /* 291191 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 291196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291200 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291206 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291214 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 291217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291221 */     GIR_RootConstrainSelectedInstOperands,
     /* 291222 */     // GIR_Coverage, 5214,
     /* 291222 */     GIR_EraseRootFromParent_Done,
     /* 291223 */   // Label 5695: @291223
     /* 291223 */   GIM_Try, /*On fail goto*//*Label 5696*/ GIMT_Encode4(291260), // Rule ID 5221 //
     /* 291228 */     // MIs[0] Operand 1
     /* 291228 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291237 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291243 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291251 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 291254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291258 */     GIR_RootConstrainSelectedInstOperands,
     /* 291259 */     // GIR_Coverage, 5221,
     /* 291259 */     GIR_EraseRootFromParent_Done,
     /* 291260 */   // Label 5696: @291260
     /* 291260 */   GIM_Try, /*On fail goto*//*Label 5697*/ GIMT_Encode4(291297), // Rule ID 5228 //
     /* 291265 */     // MIs[0] Operand 1
     /* 291265 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 291270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291274 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291280 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291288 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 291291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291295 */     GIR_RootConstrainSelectedInstOperands,
     /* 291296 */     // GIR_Coverage, 5228,
     /* 291296 */     GIR_EraseRootFromParent_Done,
     /* 291297 */   // Label 5697: @291297
     /* 291297 */   GIM_Try, /*On fail goto*//*Label 5698*/ GIMT_Encode4(291334), // Rule ID 5235 //
     /* 291302 */     // MIs[0] Operand 1
     /* 291302 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 291307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291311 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291317 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291325 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 291328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291332 */     GIR_RootConstrainSelectedInstOperands,
     /* 291333 */     // GIR_Coverage, 5235,
     /* 291333 */     GIR_EraseRootFromParent_Done,
     /* 291334 */   // Label 5698: @291334
     /* 291334 */   GIM_Try, /*On fail goto*//*Label 5699*/ GIMT_Encode4(291371), // Rule ID 5242 //
     /* 291339 */     // MIs[0] Operand 1
     /* 291339 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 291344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291348 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291354 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291362 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 291365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291369 */     GIR_RootConstrainSelectedInstOperands,
     /* 291370 */     // GIR_Coverage, 5242,
     /* 291370 */     GIR_EraseRootFromParent_Done,
     /* 291371 */   // Label 5699: @291371
     /* 291371 */   GIM_Try, /*On fail goto*//*Label 5700*/ GIMT_Encode4(291411), // Rule ID 724 //
     /* 291376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291379 */     // MIs[0] Operand 1
     /* 291379 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 291384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291392 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291398 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291402 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 291405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291409 */     GIR_RootConstrainSelectedInstOperands,
     /* 291410 */     // GIR_Coverage, 724,
     /* 291410 */     GIR_EraseRootFromParent_Done,
     /* 291411 */   // Label 5700: @291411
     /* 291411 */   GIM_Try, /*On fail goto*//*Label 5701*/ GIMT_Encode4(291451), // Rule ID 733 //
     /* 291416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291419 */     // MIs[0] Operand 1
     /* 291419 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 291424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291432 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291438 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291442 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 291445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291449 */     GIR_RootConstrainSelectedInstOperands,
     /* 291450 */     // GIR_Coverage, 733,
     /* 291450 */     GIR_EraseRootFromParent_Done,
     /* 291451 */   // Label 5701: @291451
     /* 291451 */   GIM_Try, /*On fail goto*//*Label 5702*/ GIMT_Encode4(291491), // Rule ID 734 //
     /* 291456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291459 */     // MIs[0] Operand 1
     /* 291459 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291472 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291478 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 291480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291482 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllOnesV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 291485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291489 */     GIR_RootConstrainSelectedInstOperands,
     /* 291490 */     // GIR_Coverage, 734,
     /* 291490 */     GIR_EraseRootFromParent_Done,
     /* 291491 */   // Label 5702: @291491
     /* 291491 */   GIM_Try, /*On fail goto*//*Label 5703*/ GIMT_Encode4(291531), // Rule ID 745 //
     /* 291496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291499 */     // MIs[0] Operand 1
     /* 291499 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291512 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291518 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291522 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 291525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291529 */     GIR_RootConstrainSelectedInstOperands,
     /* 291530 */     // GIR_Coverage, 745,
     /* 291530 */     GIR_EraseRootFromParent_Done,
     /* 291531 */   // Label 5703: @291531
     /* 291531 */   GIM_Try, /*On fail goto*//*Label 5704*/ GIMT_Encode4(291568), // Rule ID 5179 //
     /* 291536 */     // MIs[0] Operand 1
     /* 291536 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 291541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291549 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291555 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291559 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 291562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291566 */     GIR_RootConstrainSelectedInstOperands,
     /* 291567 */     // GIR_Coverage, 5179,
     /* 291567 */     GIR_EraseRootFromParent_Done,
     /* 291568 */   // Label 5704: @291568
     /* 291568 */   GIM_Try, /*On fail goto*//*Label 5705*/ GIMT_Encode4(291605), // Rule ID 5186 //
     /* 291573 */     // MIs[0] Operand 1
     /* 291573 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291586 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291592 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291594 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291596 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 291599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291603 */     GIR_RootConstrainSelectedInstOperands,
     /* 291604 */     // GIR_Coverage, 5186,
     /* 291604 */     GIR_EraseRootFromParent_Done,
     /* 291605 */   // Label 5705: @291605
     /* 291605 */   GIM_Try, /*On fail goto*//*Label 5706*/ GIMT_Encode4(291642), // Rule ID 5193 //
     /* 291610 */     // MIs[0] Operand 1
     /* 291610 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 291615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291623 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291629 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291633 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 291636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291640 */     GIR_RootConstrainSelectedInstOperands,
     /* 291641 */     // GIR_Coverage, 5193,
     /* 291641 */     GIR_EraseRootFromParent_Done,
     /* 291642 */   // Label 5706: @291642
     /* 291642 */   GIM_Try, /*On fail goto*//*Label 5707*/ GIMT_Encode4(291679), // Rule ID 5200 //
     /* 291647 */     // MIs[0] Operand 1
     /* 291647 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 291652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291660 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291666 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291670 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETLT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 291673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291677 */     GIR_RootConstrainSelectedInstOperands,
     /* 291678 */     // GIR_Coverage, 5200,
     /* 291678 */     GIR_EraseRootFromParent_Done,
     /* 291679 */   // Label 5707: @291679
     /* 291679 */   GIM_Try, /*On fail goto*//*Label 5708*/ GIMT_Encode4(291716), // Rule ID 5207 //
     /* 291684 */     // MIs[0] Operand 1
     /* 291684 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 291689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291697 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291703 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291707 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETLE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 291710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291714 */     GIR_RootConstrainSelectedInstOperands,
     /* 291715 */     // GIR_Coverage, 5207,
     /* 291715 */     GIR_EraseRootFromParent_Done,
     /* 291716 */   // Label 5708: @291716
     /* 291716 */   GIM_Try, /*On fail goto*//*Label 5709*/ GIMT_Encode4(291748), // Rule ID 1123 //
     /* 291721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291724 */     // MIs[0] Operand 1
     /* 291724 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 291729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291737 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 291737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16),
     /* 291740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291746 */     GIR_RootConstrainSelectedInstOperands,
     /* 291747 */     // GIR_Coverage, 1123,
     /* 291747 */     GIR_EraseRootFromParent_Done,
     /* 291748 */   // Label 5709: @291748
     /* 291748 */   GIM_Try, /*On fail goto*//*Label 5710*/ GIMT_Encode4(291780), // Rule ID 1130 //
     /* 291753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291756 */     // MIs[0] Operand 1
     /* 291756 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 291761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291769 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 291769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 291772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291776 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291778 */     GIR_RootConstrainSelectedInstOperands,
     /* 291779 */     // GIR_Coverage, 1130,
     /* 291779 */     GIR_EraseRootFromParent_Done,
     /* 291780 */   // Label 5710: @291780
     /* 291780 */   GIM_Try, /*On fail goto*//*Label 5711*/ GIMT_Encode4(291812), // Rule ID 1137 //
     /* 291785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291788 */     // MIs[0] Operand 1
     /* 291788 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291801 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 291801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 291804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291810 */     GIR_RootConstrainSelectedInstOperands,
     /* 291811 */     // GIR_Coverage, 1137,
     /* 291811 */     GIR_EraseRootFromParent_Done,
     /* 291812 */   // Label 5711: @291812
     /* 291812 */   GIM_Try, /*On fail goto*//*Label 5712*/ GIMT_Encode4(291844), // Rule ID 1144 //
     /* 291817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291820 */     // MIs[0] Operand 1
     /* 291820 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 291825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291833 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 291833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 291836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291842 */     GIR_RootConstrainSelectedInstOperands,
     /* 291843 */     // GIR_Coverage, 1144,
     /* 291843 */     GIR_EraseRootFromParent_Done,
     /* 291844 */   // Label 5712: @291844
     /* 291844 */   GIM_Try, /*On fail goto*//*Label 5713*/ GIMT_Encode4(291876), // Rule ID 1151 //
     /* 291849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291852 */     // MIs[0] Operand 1
     /* 291852 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 291857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291865 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 291865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 291868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291874 */     GIR_RootConstrainSelectedInstOperands,
     /* 291875 */     // GIR_Coverage, 1151,
     /* 291875 */     GIR_EraseRootFromParent_Done,
     /* 291876 */   // Label 5713: @291876
     /* 291876 */   GIM_Try, /*On fail goto*//*Label 5714*/ GIMT_Encode4(291905), // Rule ID 5116 //
     /* 291881 */     // MIs[0] Operand 1
     /* 291881 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 291886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291894 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 291894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16),
     /* 291897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291901 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291903 */     GIR_RootConstrainSelectedInstOperands,
     /* 291904 */     // GIR_Coverage, 5116,
     /* 291904 */     GIR_EraseRootFromParent_Done,
     /* 291905 */   // Label 5714: @291905
     /* 291905 */   GIM_Try, /*On fail goto*//*Label 5715*/ GIMT_Encode4(291934), // Rule ID 5123 //
     /* 291910 */     // MIs[0] Operand 1
     /* 291910 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291923 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 291923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 291926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291930 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291932 */     GIR_RootConstrainSelectedInstOperands,
     /* 291933 */     // GIR_Coverage, 5123,
     /* 291933 */     GIR_EraseRootFromParent_Done,
     /* 291934 */   // Label 5715: @291934
     /* 291934 */   GIM_Try, /*On fail goto*//*Label 5716*/ GIMT_Encode4(291963), // Rule ID 5130 //
     /* 291939 */     // MIs[0] Operand 1
     /* 291939 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 291944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291952 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 291952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 291955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291959 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291961 */     GIR_RootConstrainSelectedInstOperands,
     /* 291962 */     // GIR_Coverage, 5130,
     /* 291962 */     GIR_EraseRootFromParent_Done,
     /* 291963 */   // Label 5716: @291963
     /* 291963 */   GIM_Try, /*On fail goto*//*Label 5717*/ GIMT_Encode4(291992), // Rule ID 5137 //
     /* 291968 */     // MIs[0] Operand 1
     /* 291968 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 291973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291981 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 291981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 291984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291990 */     GIR_RootConstrainSelectedInstOperands,
     /* 291991 */     // GIR_Coverage, 5137,
     /* 291991 */     GIR_EraseRootFromParent_Done,
     /* 291992 */   // Label 5717: @291992
     /* 291992 */   GIM_Try, /*On fail goto*//*Label 5718*/ GIMT_Encode4(292021), // Rule ID 5144 //
     /* 291997 */     // MIs[0] Operand 1
     /* 291997 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 292002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292010 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 292010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 292013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292017 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292019 */     GIR_RootConstrainSelectedInstOperands,
     /* 292020 */     // GIR_Coverage, 5144,
     /* 292020 */     GIR_EraseRootFromParent_Done,
     /* 292021 */   // Label 5718: @292021
     /* 292021 */   GIM_Try, /*On fail goto*//*Label 5719*/ GIMT_Encode4(292050), // Rule ID 5151 //
     /* 292026 */     // MIs[0] Operand 1
     /* 292026 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 292031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292039 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 292039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 292042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292048 */     GIR_RootConstrainSelectedInstOperands,
     /* 292049 */     // GIR_Coverage, 5151,
     /* 292049 */     GIR_EraseRootFromParent_Done,
     /* 292050 */   // Label 5719: @292050
     /* 292050 */   GIM_Try, /*On fail goto*//*Label 5720*/ GIMT_Encode4(292079), // Rule ID 5158 //
     /* 292055 */     // MIs[0] Operand 1
     /* 292055 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 292060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292068 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 292068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 292071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292077 */     GIR_RootConstrainSelectedInstOperands,
     /* 292078 */     // GIR_Coverage, 5158,
     /* 292078 */     GIR_EraseRootFromParent_Done,
     /* 292079 */   // Label 5720: @292079
     /* 292079 */   GIM_Try, /*On fail goto*//*Label 5721*/ GIMT_Encode4(292108), // Rule ID 5165 //
     /* 292084 */     // MIs[0] Operand 1
     /* 292084 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 292089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292097 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 292097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 292100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292106 */     GIR_RootConstrainSelectedInstOperands,
     /* 292107 */     // GIR_Coverage, 5165,
     /* 292107 */     GIR_EraseRootFromParent_Done,
     /* 292108 */   // Label 5721: @292108
     /* 292108 */   GIM_Try, /*On fail goto*//*Label 5722*/ GIMT_Encode4(292137), // Rule ID 5172 //
     /* 292113 */     // MIs[0] Operand 1
     /* 292113 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 292118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292126 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 292126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 292129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292135 */     GIR_RootConstrainSelectedInstOperands,
     /* 292136 */     // GIR_Coverage, 5172,
     /* 292136 */     GIR_EraseRootFromParent_Done,
     /* 292137 */   // Label 5722: @292137
     /* 292137 */   GIM_Reject,
     /* 292138 */ // Label 5692: @292138
     /* 292138 */ GIM_Reject,
     /* 292139 */ // Label 5613: @292139
     /* 292139 */ GIM_Try, /*On fail goto*//*Label 5723*/ GIMT_Encode4(293186),
     /* 292144 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 292147 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 292150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292154 */   GIM_Try, /*On fail goto*//*Label 5724*/ GIMT_Encode4(292194), // Rule ID 755 //
     /* 292159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292162 */     // MIs[0] Operand 1
     /* 292162 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 292167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292171 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292177 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292185 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 292188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292190 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292192 */     GIR_RootConstrainSelectedInstOperands,
     /* 292193 */     // GIR_Coverage, 755,
     /* 292193 */     GIR_EraseRootFromParent_Done,
     /* 292194 */   // Label 5724: @292194
     /* 292194 */   GIM_Try, /*On fail goto*//*Label 5725*/ GIMT_Encode4(292234), // Rule ID 762 //
     /* 292199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292202 */     // MIs[0] Operand 1
     /* 292202 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292211 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292217 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292225 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 292228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292232 */     GIR_RootConstrainSelectedInstOperands,
     /* 292233 */     // GIR_Coverage, 762,
     /* 292233 */     GIR_EraseRootFromParent_Done,
     /* 292234 */   // Label 5725: @292234
     /* 292234 */   GIM_Try, /*On fail goto*//*Label 5726*/ GIMT_Encode4(292271), // Rule ID 5217 //
     /* 292239 */     // MIs[0] Operand 1
     /* 292239 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 292244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292248 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292254 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292262 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 292265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292269 */     GIR_RootConstrainSelectedInstOperands,
     /* 292270 */     // GIR_Coverage, 5217,
     /* 292270 */     GIR_EraseRootFromParent_Done,
     /* 292271 */   // Label 5726: @292271
     /* 292271 */   GIM_Try, /*On fail goto*//*Label 5727*/ GIMT_Encode4(292308), // Rule ID 5224 //
     /* 292276 */     // MIs[0] Operand 1
     /* 292276 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292285 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292291 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292299 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 292302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292306 */     GIR_RootConstrainSelectedInstOperands,
     /* 292307 */     // GIR_Coverage, 5224,
     /* 292307 */     GIR_EraseRootFromParent_Done,
     /* 292308 */   // Label 5727: @292308
     /* 292308 */   GIM_Try, /*On fail goto*//*Label 5728*/ GIMT_Encode4(292345), // Rule ID 5231 //
     /* 292313 */     // MIs[0] Operand 1
     /* 292313 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 292318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292322 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292328 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292336 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 292339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292341 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292343 */     GIR_RootConstrainSelectedInstOperands,
     /* 292344 */     // GIR_Coverage, 5231,
     /* 292344 */     GIR_EraseRootFromParent_Done,
     /* 292345 */   // Label 5728: @292345
     /* 292345 */   GIM_Try, /*On fail goto*//*Label 5729*/ GIMT_Encode4(292382), // Rule ID 5238 //
     /* 292350 */     // MIs[0] Operand 1
     /* 292350 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 292355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292359 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292365 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292373 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 292376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292380 */     GIR_RootConstrainSelectedInstOperands,
     /* 292381 */     // GIR_Coverage, 5238,
     /* 292381 */     GIR_EraseRootFromParent_Done,
     /* 292382 */   // Label 5729: @292382
     /* 292382 */   GIM_Try, /*On fail goto*//*Label 5730*/ GIMT_Encode4(292419), // Rule ID 5245 //
     /* 292387 */     // MIs[0] Operand 1
     /* 292387 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 292392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292396 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292402 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292408 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292410 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 292413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292415 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292417 */     GIR_RootConstrainSelectedInstOperands,
     /* 292418 */     // GIR_Coverage, 5245,
     /* 292418 */     GIR_EraseRootFromParent_Done,
     /* 292419 */   // Label 5730: @292419
     /* 292419 */   GIM_Try, /*On fail goto*//*Label 5731*/ GIMT_Encode4(292459), // Rule ID 727 //
     /* 292424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292427 */     // MIs[0] Operand 1
     /* 292427 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 292432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292440 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292446 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292448 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292450 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 292453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292457 */     GIR_RootConstrainSelectedInstOperands,
     /* 292458 */     // GIR_Coverage, 727,
     /* 292458 */     GIR_EraseRootFromParent_Done,
     /* 292459 */   // Label 5731: @292459
     /* 292459 */   GIM_Try, /*On fail goto*//*Label 5732*/ GIMT_Encode4(292499), // Rule ID 739 //
     /* 292464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292467 */     // MIs[0] Operand 1
     /* 292467 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 292472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292480 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292486 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292488 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292490 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 292493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292497 */     GIR_RootConstrainSelectedInstOperands,
     /* 292498 */     // GIR_Coverage, 739,
     /* 292498 */     GIR_EraseRootFromParent_Done,
     /* 292499 */   // Label 5732: @292499
     /* 292499 */   GIM_Try, /*On fail goto*//*Label 5733*/ GIMT_Encode4(292539), // Rule ID 740 //
     /* 292504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292507 */     // MIs[0] Operand 1
     /* 292507 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292520 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292526 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 292528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292530 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 292533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292537 */     GIR_RootConstrainSelectedInstOperands,
     /* 292538 */     // GIR_Coverage, 740,
     /* 292538 */     GIR_EraseRootFromParent_Done,
     /* 292539 */   // Label 5733: @292539
     /* 292539 */   GIM_Try, /*On fail goto*//*Label 5734*/ GIMT_Encode4(292579), // Rule ID 748 //
     /* 292544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292547 */     // MIs[0] Operand 1
     /* 292547 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292560 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292566 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292570 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 292573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292577 */     GIR_RootConstrainSelectedInstOperands,
     /* 292578 */     // GIR_Coverage, 748,
     /* 292578 */     GIR_EraseRootFromParent_Done,
     /* 292579 */   // Label 5734: @292579
     /* 292579 */   GIM_Try, /*On fail goto*//*Label 5735*/ GIMT_Encode4(292616), // Rule ID 5182 //
     /* 292584 */     // MIs[0] Operand 1
     /* 292584 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 292589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292597 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292603 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292607 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 292610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292614 */     GIR_RootConstrainSelectedInstOperands,
     /* 292615 */     // GIR_Coverage, 5182,
     /* 292615 */     GIR_EraseRootFromParent_Done,
     /* 292616 */   // Label 5735: @292616
     /* 292616 */   GIM_Try, /*On fail goto*//*Label 5736*/ GIMT_Encode4(292653), // Rule ID 5189 //
     /* 292621 */     // MIs[0] Operand 1
     /* 292621 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292634 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292640 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292642 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292644 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 292647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292651 */     GIR_RootConstrainSelectedInstOperands,
     /* 292652 */     // GIR_Coverage, 5189,
     /* 292652 */     GIR_EraseRootFromParent_Done,
     /* 292653 */   // Label 5736: @292653
     /* 292653 */   GIM_Try, /*On fail goto*//*Label 5737*/ GIMT_Encode4(292690), // Rule ID 5196 //
     /* 292658 */     // MIs[0] Operand 1
     /* 292658 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 292663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292671 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292677 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292681 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 292684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292688 */     GIR_RootConstrainSelectedInstOperands,
     /* 292689 */     // GIR_Coverage, 5196,
     /* 292689 */     GIR_EraseRootFromParent_Done,
     /* 292690 */   // Label 5737: @292690
     /* 292690 */   GIM_Try, /*On fail goto*//*Label 5738*/ GIMT_Encode4(292727), // Rule ID 5203 //
     /* 292695 */     // MIs[0] Operand 1
     /* 292695 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 292700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292708 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292714 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292718 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETLT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 292721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292725 */     GIR_RootConstrainSelectedInstOperands,
     /* 292726 */     // GIR_Coverage, 5203,
     /* 292726 */     GIR_EraseRootFromParent_Done,
     /* 292727 */   // Label 5738: @292727
     /* 292727 */   GIM_Try, /*On fail goto*//*Label 5739*/ GIMT_Encode4(292764), // Rule ID 5210 //
     /* 292732 */     // MIs[0] Operand 1
     /* 292732 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 292737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292745 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292751 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292755 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETLE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 292758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292762 */     GIR_RootConstrainSelectedInstOperands,
     /* 292763 */     // GIR_Coverage, 5210,
     /* 292763 */     GIR_EraseRootFromParent_Done,
     /* 292764 */   // Label 5739: @292764
     /* 292764 */   GIM_Try, /*On fail goto*//*Label 5740*/ GIMT_Encode4(292796), // Rule ID 1126 //
     /* 292769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292772 */     // MIs[0] Operand 1
     /* 292772 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 292777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292785 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 292785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32),
     /* 292788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292794 */     GIR_RootConstrainSelectedInstOperands,
     /* 292795 */     // GIR_Coverage, 1126,
     /* 292795 */     GIR_EraseRootFromParent_Done,
     /* 292796 */   // Label 5740: @292796
     /* 292796 */   GIM_Try, /*On fail goto*//*Label 5741*/ GIMT_Encode4(292828), // Rule ID 1133 //
     /* 292801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292804 */     // MIs[0] Operand 1
     /* 292804 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 292809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292817 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 292817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 292820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292826 */     GIR_RootConstrainSelectedInstOperands,
     /* 292827 */     // GIR_Coverage, 1133,
     /* 292827 */     GIR_EraseRootFromParent_Done,
     /* 292828 */   // Label 5741: @292828
     /* 292828 */   GIM_Try, /*On fail goto*//*Label 5742*/ GIMT_Encode4(292860), // Rule ID 1140 //
     /* 292833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292836 */     // MIs[0] Operand 1
     /* 292836 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292849 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 292849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 292852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292858 */     GIR_RootConstrainSelectedInstOperands,
     /* 292859 */     // GIR_Coverage, 1140,
     /* 292859 */     GIR_EraseRootFromParent_Done,
     /* 292860 */   // Label 5742: @292860
     /* 292860 */   GIM_Try, /*On fail goto*//*Label 5743*/ GIMT_Encode4(292892), // Rule ID 1147 //
     /* 292865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292868 */     // MIs[0] Operand 1
     /* 292868 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 292873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292881 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 292881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 292884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292888 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292890 */     GIR_RootConstrainSelectedInstOperands,
     /* 292891 */     // GIR_Coverage, 1147,
     /* 292891 */     GIR_EraseRootFromParent_Done,
     /* 292892 */   // Label 5743: @292892
     /* 292892 */   GIM_Try, /*On fail goto*//*Label 5744*/ GIMT_Encode4(292924), // Rule ID 1154 //
     /* 292897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292900 */     // MIs[0] Operand 1
     /* 292900 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 292905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292913 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 292913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 292916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292922 */     GIR_RootConstrainSelectedInstOperands,
     /* 292923 */     // GIR_Coverage, 1154,
     /* 292923 */     GIR_EraseRootFromParent_Done,
     /* 292924 */   // Label 5744: @292924
     /* 292924 */   GIM_Try, /*On fail goto*//*Label 5745*/ GIMT_Encode4(292953), // Rule ID 5119 //
     /* 292929 */     // MIs[0] Operand 1
     /* 292929 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 292934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292942 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 292942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32),
     /* 292945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292951 */     GIR_RootConstrainSelectedInstOperands,
     /* 292952 */     // GIR_Coverage, 5119,
     /* 292952 */     GIR_EraseRootFromParent_Done,
     /* 292953 */   // Label 5745: @292953
     /* 292953 */   GIM_Try, /*On fail goto*//*Label 5746*/ GIMT_Encode4(292982), // Rule ID 5126 //
     /* 292958 */     // MIs[0] Operand 1
     /* 292958 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292971 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 292971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 292974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292980 */     GIR_RootConstrainSelectedInstOperands,
     /* 292981 */     // GIR_Coverage, 5126,
     /* 292981 */     GIR_EraseRootFromParent_Done,
     /* 292982 */   // Label 5746: @292982
     /* 292982 */   GIM_Try, /*On fail goto*//*Label 5747*/ GIMT_Encode4(293011), // Rule ID 5133 //
     /* 292987 */     // MIs[0] Operand 1
     /* 292987 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 292992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293000 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 293000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 293003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293007 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293009 */     GIR_RootConstrainSelectedInstOperands,
     /* 293010 */     // GIR_Coverage, 5133,
     /* 293010 */     GIR_EraseRootFromParent_Done,
     /* 293011 */   // Label 5747: @293011
     /* 293011 */   GIM_Try, /*On fail goto*//*Label 5748*/ GIMT_Encode4(293040), // Rule ID 5140 //
     /* 293016 */     // MIs[0] Operand 1
     /* 293016 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 293021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293029 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 293029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 293032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293036 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293038 */     GIR_RootConstrainSelectedInstOperands,
     /* 293039 */     // GIR_Coverage, 5140,
     /* 293039 */     GIR_EraseRootFromParent_Done,
     /* 293040 */   // Label 5748: @293040
     /* 293040 */   GIM_Try, /*On fail goto*//*Label 5749*/ GIMT_Encode4(293069), // Rule ID 5147 //
     /* 293045 */     // MIs[0] Operand 1
     /* 293045 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 293050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293058 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 293058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 293061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293067 */     GIR_RootConstrainSelectedInstOperands,
     /* 293068 */     // GIR_Coverage, 5147,
     /* 293068 */     GIR_EraseRootFromParent_Done,
     /* 293069 */   // Label 5749: @293069
     /* 293069 */   GIM_Try, /*On fail goto*//*Label 5750*/ GIMT_Encode4(293098), // Rule ID 5154 //
     /* 293074 */     // MIs[0] Operand 1
     /* 293074 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 293079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293087 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 293087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 293090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293096 */     GIR_RootConstrainSelectedInstOperands,
     /* 293097 */     // GIR_Coverage, 5154,
     /* 293097 */     GIR_EraseRootFromParent_Done,
     /* 293098 */   // Label 5750: @293098
     /* 293098 */   GIM_Try, /*On fail goto*//*Label 5751*/ GIMT_Encode4(293127), // Rule ID 5161 //
     /* 293103 */     // MIs[0] Operand 1
     /* 293103 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 293108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293116 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 293116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 293119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293121 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293125 */     GIR_RootConstrainSelectedInstOperands,
     /* 293126 */     // GIR_Coverage, 5161,
     /* 293126 */     GIR_EraseRootFromParent_Done,
     /* 293127 */   // Label 5751: @293127
     /* 293127 */   GIM_Try, /*On fail goto*//*Label 5752*/ GIMT_Encode4(293156), // Rule ID 5168 //
     /* 293132 */     // MIs[0] Operand 1
     /* 293132 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 293137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293145 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 293145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 293148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293154 */     GIR_RootConstrainSelectedInstOperands,
     /* 293155 */     // GIR_Coverage, 5168,
     /* 293155 */     GIR_EraseRootFromParent_Done,
     /* 293156 */   // Label 5752: @293156
     /* 293156 */   GIM_Try, /*On fail goto*//*Label 5753*/ GIMT_Encode4(293185), // Rule ID 5175 //
     /* 293161 */     // MIs[0] Operand 1
     /* 293161 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 293166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293174 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 293174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 293177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293183 */     GIR_RootConstrainSelectedInstOperands,
     /* 293184 */     // GIR_Coverage, 5175,
     /* 293184 */     GIR_EraseRootFromParent_Done,
     /* 293185 */   // Label 5753: @293185
     /* 293185 */   GIM_Reject,
     /* 293186 */ // Label 5723: @293186
     /* 293186 */ GIM_Reject,
     /* 293187 */ // Label 5614: @293187
     /* 293187 */ GIM_Try, /*On fail goto*//*Label 5754*/ GIMT_Encode4(294234),
     /* 293192 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 293195 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 293198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293202 */   GIM_Try, /*On fail goto*//*Label 5755*/ GIMT_Encode4(293242), // Rule ID 750 //
     /* 293207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293210 */     // MIs[0] Operand 1
     /* 293210 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 293215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293219 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293225 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293233 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 293236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293240 */     GIR_RootConstrainSelectedInstOperands,
     /* 293241 */     // GIR_Coverage, 750,
     /* 293241 */     GIR_EraseRootFromParent_Done,
     /* 293242 */   // Label 5755: @293242
     /* 293242 */   GIM_Try, /*On fail goto*//*Label 5756*/ GIMT_Encode4(293282), // Rule ID 757 //
     /* 293247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293250 */     // MIs[0] Operand 1
     /* 293250 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293259 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293265 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293273 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 293276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293280 */     GIR_RootConstrainSelectedInstOperands,
     /* 293281 */     // GIR_Coverage, 757,
     /* 293281 */     GIR_EraseRootFromParent_Done,
     /* 293282 */   // Label 5756: @293282
     /* 293282 */   GIM_Try, /*On fail goto*//*Label 5757*/ GIMT_Encode4(293319), // Rule ID 5212 //
     /* 293287 */     // MIs[0] Operand 1
     /* 293287 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 293292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293296 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293302 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293310 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 293313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293317 */     GIR_RootConstrainSelectedInstOperands,
     /* 293318 */     // GIR_Coverage, 5212,
     /* 293318 */     GIR_EraseRootFromParent_Done,
     /* 293319 */   // Label 5757: @293319
     /* 293319 */   GIM_Try, /*On fail goto*//*Label 5758*/ GIMT_Encode4(293356), // Rule ID 5219 //
     /* 293324 */     // MIs[0] Operand 1
     /* 293324 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293333 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293339 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293347 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 293350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293354 */     GIR_RootConstrainSelectedInstOperands,
     /* 293355 */     // GIR_Coverage, 5219,
     /* 293355 */     GIR_EraseRootFromParent_Done,
     /* 293356 */   // Label 5758: @293356
     /* 293356 */   GIM_Try, /*On fail goto*//*Label 5759*/ GIMT_Encode4(293393), // Rule ID 5226 //
     /* 293361 */     // MIs[0] Operand 1
     /* 293361 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 293366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293370 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293376 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293382 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293384 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 293387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293391 */     GIR_RootConstrainSelectedInstOperands,
     /* 293392 */     // GIR_Coverage, 5226,
     /* 293392 */     GIR_EraseRootFromParent_Done,
     /* 293393 */   // Label 5759: @293393
     /* 293393 */   GIM_Try, /*On fail goto*//*Label 5760*/ GIMT_Encode4(293430), // Rule ID 5233 //
     /* 293398 */     // MIs[0] Operand 1
     /* 293398 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 293403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293407 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293413 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293421 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 293424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293426 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293428 */     GIR_RootConstrainSelectedInstOperands,
     /* 293429 */     // GIR_Coverage, 5233,
     /* 293429 */     GIR_EraseRootFromParent_Done,
     /* 293430 */   // Label 5760: @293430
     /* 293430 */   GIM_Try, /*On fail goto*//*Label 5761*/ GIMT_Encode4(293467), // Rule ID 5240 //
     /* 293435 */     // MIs[0] Operand 1
     /* 293435 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 293440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293444 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293450 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293458 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 293461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293465 */     GIR_RootConstrainSelectedInstOperands,
     /* 293466 */     // GIR_Coverage, 5240,
     /* 293466 */     GIR_EraseRootFromParent_Done,
     /* 293467 */   // Label 5761: @293467
     /* 293467 */   GIM_Try, /*On fail goto*//*Label 5762*/ GIMT_Encode4(293507), // Rule ID 722 //
     /* 293472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293475 */     // MIs[0] Operand 1
     /* 293475 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 293480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293488 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293494 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293498 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 293501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293505 */     GIR_RootConstrainSelectedInstOperands,
     /* 293506 */     // GIR_Coverage, 722,
     /* 293506 */     GIR_EraseRootFromParent_Done,
     /* 293507 */   // Label 5762: @293507
     /* 293507 */   GIM_Try, /*On fail goto*//*Label 5763*/ GIMT_Encode4(293547), // Rule ID 729 //
     /* 293512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293515 */     // MIs[0] Operand 1
     /* 293515 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 293520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293528 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293534 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293538 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 293541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293545 */     GIR_RootConstrainSelectedInstOperands,
     /* 293546 */     // GIR_Coverage, 729,
     /* 293546 */     GIR_EraseRootFromParent_Done,
     /* 293547 */   // Label 5763: @293547
     /* 293547 */   GIM_Try, /*On fail goto*//*Label 5764*/ GIMT_Encode4(293587), // Rule ID 730 //
     /* 293552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293555 */     // MIs[0] Operand 1
     /* 293555 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293568 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293574 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 293576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293578 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllOnesV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 293581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293585 */     GIR_RootConstrainSelectedInstOperands,
     /* 293586 */     // GIR_Coverage, 730,
     /* 293586 */     GIR_EraseRootFromParent_Done,
     /* 293587 */   // Label 5764: @293587
     /* 293587 */   GIM_Try, /*On fail goto*//*Label 5765*/ GIMT_Encode4(293627), // Rule ID 743 //
     /* 293592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293595 */     // MIs[0] Operand 1
     /* 293595 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293608 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293614 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293618 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 293621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293625 */     GIR_RootConstrainSelectedInstOperands,
     /* 293626 */     // GIR_Coverage, 743,
     /* 293626 */     GIR_EraseRootFromParent_Done,
     /* 293627 */   // Label 5765: @293627
     /* 293627 */   GIM_Try, /*On fail goto*//*Label 5766*/ GIMT_Encode4(293664), // Rule ID 5177 //
     /* 293632 */     // MIs[0] Operand 1
     /* 293632 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 293637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293645 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293651 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293655 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 293658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293662 */     GIR_RootConstrainSelectedInstOperands,
     /* 293663 */     // GIR_Coverage, 5177,
     /* 293663 */     GIR_EraseRootFromParent_Done,
     /* 293664 */   // Label 5766: @293664
     /* 293664 */   GIM_Try, /*On fail goto*//*Label 5767*/ GIMT_Encode4(293701), // Rule ID 5184 //
     /* 293669 */     // MIs[0] Operand 1
     /* 293669 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293682 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293688 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293692 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 293695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293699 */     GIR_RootConstrainSelectedInstOperands,
     /* 293700 */     // GIR_Coverage, 5184,
     /* 293700 */     GIR_EraseRootFromParent_Done,
     /* 293701 */   // Label 5767: @293701
     /* 293701 */   GIM_Try, /*On fail goto*//*Label 5768*/ GIMT_Encode4(293738), // Rule ID 5191 //
     /* 293706 */     // MIs[0] Operand 1
     /* 293706 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 293711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293719 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293725 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293729 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 293732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293736 */     GIR_RootConstrainSelectedInstOperands,
     /* 293737 */     // GIR_Coverage, 5191,
     /* 293737 */     GIR_EraseRootFromParent_Done,
     /* 293738 */   // Label 5768: @293738
     /* 293738 */   GIM_Try, /*On fail goto*//*Label 5769*/ GIMT_Encode4(293775), // Rule ID 5198 //
     /* 293743 */     // MIs[0] Operand 1
     /* 293743 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 293748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293756 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293762 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293766 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETLT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 293769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293773 */     GIR_RootConstrainSelectedInstOperands,
     /* 293774 */     // GIR_Coverage, 5198,
     /* 293774 */     GIR_EraseRootFromParent_Done,
     /* 293775 */   // Label 5769: @293775
     /* 293775 */   GIM_Try, /*On fail goto*//*Label 5770*/ GIMT_Encode4(293812), // Rule ID 5205 //
     /* 293780 */     // MIs[0] Operand 1
     /* 293780 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 293785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293793 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293799 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293803 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETLE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 293806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293810 */     GIR_RootConstrainSelectedInstOperands,
     /* 293811 */     // GIR_Coverage, 5205,
     /* 293811 */     GIR_EraseRootFromParent_Done,
     /* 293812 */   // Label 5770: @293812
     /* 293812 */   GIM_Try, /*On fail goto*//*Label 5771*/ GIMT_Encode4(293844), // Rule ID 1121 //
     /* 293817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293820 */     // MIs[0] Operand 1
     /* 293820 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 293825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293833 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 293833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8),
     /* 293836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293842 */     GIR_RootConstrainSelectedInstOperands,
     /* 293843 */     // GIR_Coverage, 1121,
     /* 293843 */     GIR_EraseRootFromParent_Done,
     /* 293844 */   // Label 5771: @293844
     /* 293844 */   GIM_Try, /*On fail goto*//*Label 5772*/ GIMT_Encode4(293876), // Rule ID 1128 //
     /* 293849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293852 */     // MIs[0] Operand 1
     /* 293852 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 293857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293865 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 293865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 293868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293874 */     GIR_RootConstrainSelectedInstOperands,
     /* 293875 */     // GIR_Coverage, 1128,
     /* 293875 */     GIR_EraseRootFromParent_Done,
     /* 293876 */   // Label 5772: @293876
     /* 293876 */   GIM_Try, /*On fail goto*//*Label 5773*/ GIMT_Encode4(293908), // Rule ID 1135 //
     /* 293881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293884 */     // MIs[0] Operand 1
     /* 293884 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293897 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 293897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 293900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293904 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293906 */     GIR_RootConstrainSelectedInstOperands,
     /* 293907 */     // GIR_Coverage, 1135,
     /* 293907 */     GIR_EraseRootFromParent_Done,
     /* 293908 */   // Label 5773: @293908
     /* 293908 */   GIM_Try, /*On fail goto*//*Label 5774*/ GIMT_Encode4(293940), // Rule ID 1142 //
     /* 293913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293916 */     // MIs[0] Operand 1
     /* 293916 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 293921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293929 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 293929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 293932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293938 */     GIR_RootConstrainSelectedInstOperands,
     /* 293939 */     // GIR_Coverage, 1142,
     /* 293939 */     GIR_EraseRootFromParent_Done,
     /* 293940 */   // Label 5774: @293940
     /* 293940 */   GIM_Try, /*On fail goto*//*Label 5775*/ GIMT_Encode4(293972), // Rule ID 1149 //
     /* 293945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293948 */     // MIs[0] Operand 1
     /* 293948 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 293953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293961 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 293961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 293964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293970 */     GIR_RootConstrainSelectedInstOperands,
     /* 293971 */     // GIR_Coverage, 1149,
     /* 293971 */     GIR_EraseRootFromParent_Done,
     /* 293972 */   // Label 5775: @293972
     /* 293972 */   GIM_Try, /*On fail goto*//*Label 5776*/ GIMT_Encode4(294001), // Rule ID 5114 //
     /* 293977 */     // MIs[0] Operand 1
     /* 293977 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 293982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293990 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 293990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8),
     /* 293993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293999 */     GIR_RootConstrainSelectedInstOperands,
     /* 294000 */     // GIR_Coverage, 5114,
     /* 294000 */     GIR_EraseRootFromParent_Done,
     /* 294001 */   // Label 5776: @294001
     /* 294001 */   GIM_Try, /*On fail goto*//*Label 5777*/ GIMT_Encode4(294030), // Rule ID 5121 //
     /* 294006 */     // MIs[0] Operand 1
     /* 294006 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 294011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294019 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 294019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 294022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294028 */     GIR_RootConstrainSelectedInstOperands,
     /* 294029 */     // GIR_Coverage, 5121,
     /* 294029 */     GIR_EraseRootFromParent_Done,
     /* 294030 */   // Label 5777: @294030
     /* 294030 */   GIM_Try, /*On fail goto*//*Label 5778*/ GIMT_Encode4(294059), // Rule ID 5128 //
     /* 294035 */     // MIs[0] Operand 1
     /* 294035 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 294040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294048 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 294048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 294051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294057 */     GIR_RootConstrainSelectedInstOperands,
     /* 294058 */     // GIR_Coverage, 5128,
     /* 294058 */     GIR_EraseRootFromParent_Done,
     /* 294059 */   // Label 5778: @294059
     /* 294059 */   GIM_Try, /*On fail goto*//*Label 5779*/ GIMT_Encode4(294088), // Rule ID 5135 //
     /* 294064 */     // MIs[0] Operand 1
     /* 294064 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 294069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294077 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 294077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 294080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294086 */     GIR_RootConstrainSelectedInstOperands,
     /* 294087 */     // GIR_Coverage, 5135,
     /* 294087 */     GIR_EraseRootFromParent_Done,
     /* 294088 */   // Label 5779: @294088
     /* 294088 */   GIM_Try, /*On fail goto*//*Label 5780*/ GIMT_Encode4(294117), // Rule ID 5142 //
     /* 294093 */     // MIs[0] Operand 1
     /* 294093 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 294098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294106 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 294106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 294109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294113 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294115 */     GIR_RootConstrainSelectedInstOperands,
     /* 294116 */     // GIR_Coverage, 5142,
     /* 294116 */     GIR_EraseRootFromParent_Done,
     /* 294117 */   // Label 5780: @294117
     /* 294117 */   GIM_Try, /*On fail goto*//*Label 5781*/ GIMT_Encode4(294146), // Rule ID 5149 //
     /* 294122 */     // MIs[0] Operand 1
     /* 294122 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 294127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294135 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 294135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 294138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294140 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294144 */     GIR_RootConstrainSelectedInstOperands,
     /* 294145 */     // GIR_Coverage, 5149,
     /* 294145 */     GIR_EraseRootFromParent_Done,
     /* 294146 */   // Label 5781: @294146
     /* 294146 */   GIM_Try, /*On fail goto*//*Label 5782*/ GIMT_Encode4(294175), // Rule ID 5156 //
     /* 294151 */     // MIs[0] Operand 1
     /* 294151 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 294156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294164 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 294164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 294167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294173 */     GIR_RootConstrainSelectedInstOperands,
     /* 294174 */     // GIR_Coverage, 5156,
     /* 294174 */     GIR_EraseRootFromParent_Done,
     /* 294175 */   // Label 5782: @294175
     /* 294175 */   GIM_Try, /*On fail goto*//*Label 5783*/ GIMT_Encode4(294204), // Rule ID 5163 //
     /* 294180 */     // MIs[0] Operand 1
     /* 294180 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 294185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294193 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 294193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 294196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294202 */     GIR_RootConstrainSelectedInstOperands,
     /* 294203 */     // GIR_Coverage, 5163,
     /* 294203 */     GIR_EraseRootFromParent_Done,
     /* 294204 */   // Label 5783: @294204
     /* 294204 */   GIM_Try, /*On fail goto*//*Label 5784*/ GIMT_Encode4(294233), // Rule ID 5170 //
     /* 294209 */     // MIs[0] Operand 1
     /* 294209 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 294214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294222 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 294222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 294225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294227 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294231 */     GIR_RootConstrainSelectedInstOperands,
     /* 294232 */     // GIR_Coverage, 5170,
     /* 294232 */     GIR_EraseRootFromParent_Done,
     /* 294233 */   // Label 5784: @294233
     /* 294233 */   GIM_Reject,
     /* 294234 */ // Label 5754: @294234
     /* 294234 */ GIM_Reject,
     /* 294235 */ // Label 5615: @294235
     /* 294235 */ GIM_Try, /*On fail goto*//*Label 5785*/ GIMT_Encode4(295282),
     /* 294240 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 294243 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 294246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294250 */   GIM_Try, /*On fail goto*//*Label 5786*/ GIMT_Encode4(294290), // Rule ID 753 //
     /* 294255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294258 */     // MIs[0] Operand 1
     /* 294258 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 294263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294267 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294273 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294281 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 294284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 294288 */     GIR_RootConstrainSelectedInstOperands,
     /* 294289 */     // GIR_Coverage, 753,
     /* 294289 */     GIR_EraseRootFromParent_Done,
     /* 294290 */   // Label 5786: @294290
     /* 294290 */   GIM_Try, /*On fail goto*//*Label 5787*/ GIMT_Encode4(294330), // Rule ID 760 //
     /* 294295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294298 */     // MIs[0] Operand 1
     /* 294298 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 294303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294307 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294313 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294321 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 294324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 294328 */     GIR_RootConstrainSelectedInstOperands,
     /* 294329 */     // GIR_Coverage, 760,
     /* 294329 */     GIR_EraseRootFromParent_Done,
     /* 294330 */   // Label 5787: @294330
     /* 294330 */   GIM_Try, /*On fail goto*//*Label 5788*/ GIMT_Encode4(294367), // Rule ID 5215 //
     /* 294335 */     // MIs[0] Operand 1
     /* 294335 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 294340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294344 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294350 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294356 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294358 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 294361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 294365 */     GIR_RootConstrainSelectedInstOperands,
     /* 294366 */     // GIR_Coverage, 5215,
     /* 294366 */     GIR_EraseRootFromParent_Done,
     /* 294367 */   // Label 5788: @294367
     /* 294367 */   GIM_Try, /*On fail goto*//*Label 5789*/ GIMT_Encode4(294404), // Rule ID 5222 //
     /* 294372 */     // MIs[0] Operand 1
     /* 294372 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 294377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294381 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294387 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294395 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 294398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 294402 */     GIR_RootConstrainSelectedInstOperands,
     /* 294403 */     // GIR_Coverage, 5222,
     /* 294403 */     GIR_EraseRootFromParent_Done,
     /* 294404 */   // Label 5789: @294404
     /* 294404 */   GIM_Try, /*On fail goto*//*Label 5790*/ GIMT_Encode4(294441), // Rule ID 5229 //
     /* 294409 */     // MIs[0] Operand 1
     /* 294409 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 294414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294418 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294424 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294430 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294432 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 294435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294437 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 294439 */     GIR_RootConstrainSelectedInstOperands,
     /* 294440 */     // GIR_Coverage, 5229,
     /* 294440 */     GIR_EraseRootFromParent_Done,
     /* 294441 */   // Label 5790: @294441
     /* 294441 */   GIM_Try, /*On fail goto*//*Label 5791*/ GIMT_Encode4(294478), // Rule ID 5236 //
     /* 294446 */     // MIs[0] Operand 1
     /* 294446 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 294451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294455 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294461 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294469 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 294472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 294476 */     GIR_RootConstrainSelectedInstOperands,
     /* 294477 */     // GIR_Coverage, 5236,
     /* 294477 */     GIR_EraseRootFromParent_Done,
     /* 294478 */   // Label 5791: @294478
     /* 294478 */   GIM_Try, /*On fail goto*//*Label 5792*/ GIMT_Encode4(294515), // Rule ID 5243 //
     /* 294483 */     // MIs[0] Operand 1
     /* 294483 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 294488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294492 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294498 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294506 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 294509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 294513 */     GIR_RootConstrainSelectedInstOperands,
     /* 294514 */     // GIR_Coverage, 5243,
     /* 294514 */     GIR_EraseRootFromParent_Done,
     /* 294515 */   // Label 5792: @294515
     /* 294515 */   GIM_Try, /*On fail goto*//*Label 5793*/ GIMT_Encode4(294555), // Rule ID 725 //
     /* 294520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294523 */     // MIs[0] Operand 1
     /* 294523 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 294528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294536 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294542 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294544 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294546 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 294549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294553 */     GIR_RootConstrainSelectedInstOperands,
     /* 294554 */     // GIR_Coverage, 725,
     /* 294554 */     GIR_EraseRootFromParent_Done,
     /* 294555 */   // Label 5793: @294555
     /* 294555 */   GIM_Try, /*On fail goto*//*Label 5794*/ GIMT_Encode4(294595), // Rule ID 735 //
     /* 294560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294563 */     // MIs[0] Operand 1
     /* 294563 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 294568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294576 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294582 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294586 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 294589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294593 */     GIR_RootConstrainSelectedInstOperands,
     /* 294594 */     // GIR_Coverage, 735,
     /* 294594 */     GIR_EraseRootFromParent_Done,
     /* 294595 */   // Label 5794: @294595
     /* 294595 */   GIM_Try, /*On fail goto*//*Label 5795*/ GIMT_Encode4(294635), // Rule ID 736 //
     /* 294600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294603 */     // MIs[0] Operand 1
     /* 294603 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 294608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294616 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294622 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 294624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294626 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 294629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294633 */     GIR_RootConstrainSelectedInstOperands,
     /* 294634 */     // GIR_Coverage, 736,
     /* 294634 */     GIR_EraseRootFromParent_Done,
     /* 294635 */   // Label 5795: @294635
     /* 294635 */   GIM_Try, /*On fail goto*//*Label 5796*/ GIMT_Encode4(294675), // Rule ID 746 //
     /* 294640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294643 */     // MIs[0] Operand 1
     /* 294643 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 294648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294656 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294662 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294666 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 294669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294673 */     GIR_RootConstrainSelectedInstOperands,
     /* 294674 */     // GIR_Coverage, 746,
     /* 294674 */     GIR_EraseRootFromParent_Done,
     /* 294675 */   // Label 5796: @294675
     /* 294675 */   GIM_Try, /*On fail goto*//*Label 5797*/ GIMT_Encode4(294712), // Rule ID 5180 //
     /* 294680 */     // MIs[0] Operand 1
     /* 294680 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 294685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294693 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294699 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294703 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 294706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294710 */     GIR_RootConstrainSelectedInstOperands,
     /* 294711 */     // GIR_Coverage, 5180,
     /* 294711 */     GIR_EraseRootFromParent_Done,
     /* 294712 */   // Label 5797: @294712
     /* 294712 */   GIM_Try, /*On fail goto*//*Label 5798*/ GIMT_Encode4(294749), // Rule ID 5187 //
     /* 294717 */     // MIs[0] Operand 1
     /* 294717 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 294722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294730 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294736 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294740 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 294743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294747 */     GIR_RootConstrainSelectedInstOperands,
     /* 294748 */     // GIR_Coverage, 5187,
     /* 294748 */     GIR_EraseRootFromParent_Done,
     /* 294749 */   // Label 5798: @294749
     /* 294749 */   GIM_Try, /*On fail goto*//*Label 5799*/ GIMT_Encode4(294786), // Rule ID 5194 //
     /* 294754 */     // MIs[0] Operand 1
     /* 294754 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 294759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294767 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294773 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294777 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 294780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294784 */     GIR_RootConstrainSelectedInstOperands,
     /* 294785 */     // GIR_Coverage, 5194,
     /* 294785 */     GIR_EraseRootFromParent_Done,
     /* 294786 */   // Label 5799: @294786
     /* 294786 */   GIM_Try, /*On fail goto*//*Label 5800*/ GIMT_Encode4(294823), // Rule ID 5201 //
     /* 294791 */     // MIs[0] Operand 1
     /* 294791 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 294796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294804 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294810 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294814 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETLT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 294817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294821 */     GIR_RootConstrainSelectedInstOperands,
     /* 294822 */     // GIR_Coverage, 5201,
     /* 294822 */     GIR_EraseRootFromParent_Done,
     /* 294823 */   // Label 5800: @294823
     /* 294823 */   GIM_Try, /*On fail goto*//*Label 5801*/ GIMT_Encode4(294860), // Rule ID 5208 //
     /* 294828 */     // MIs[0] Operand 1
     /* 294828 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 294833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294841 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294847 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294851 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETLE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 294854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294858 */     GIR_RootConstrainSelectedInstOperands,
     /* 294859 */     // GIR_Coverage, 5208,
     /* 294859 */     GIR_EraseRootFromParent_Done,
     /* 294860 */   // Label 5801: @294860
     /* 294860 */   GIM_Try, /*On fail goto*//*Label 5802*/ GIMT_Encode4(294892), // Rule ID 1124 //
     /* 294865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294868 */     // MIs[0] Operand 1
     /* 294868 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 294873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294881 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 294881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16),
     /* 294884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294888 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294890 */     GIR_RootConstrainSelectedInstOperands,
     /* 294891 */     // GIR_Coverage, 1124,
     /* 294891 */     GIR_EraseRootFromParent_Done,
     /* 294892 */   // Label 5802: @294892
     /* 294892 */   GIM_Try, /*On fail goto*//*Label 5803*/ GIMT_Encode4(294924), // Rule ID 1131 //
     /* 294897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294900 */     // MIs[0] Operand 1
     /* 294900 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 294905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294913 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 294913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 294916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294922 */     GIR_RootConstrainSelectedInstOperands,
     /* 294923 */     // GIR_Coverage, 1131,
     /* 294923 */     GIR_EraseRootFromParent_Done,
     /* 294924 */   // Label 5803: @294924
     /* 294924 */   GIM_Try, /*On fail goto*//*Label 5804*/ GIMT_Encode4(294956), // Rule ID 1138 //
     /* 294929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294932 */     // MIs[0] Operand 1
     /* 294932 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 294937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294945 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 294945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 294948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294954 */     GIR_RootConstrainSelectedInstOperands,
     /* 294955 */     // GIR_Coverage, 1138,
     /* 294955 */     GIR_EraseRootFromParent_Done,
     /* 294956 */   // Label 5804: @294956
     /* 294956 */   GIM_Try, /*On fail goto*//*Label 5805*/ GIMT_Encode4(294988), // Rule ID 1145 //
     /* 294961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294964 */     // MIs[0] Operand 1
     /* 294964 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 294969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294977 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 294977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 294980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294984 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294986 */     GIR_RootConstrainSelectedInstOperands,
     /* 294987 */     // GIR_Coverage, 1145,
     /* 294987 */     GIR_EraseRootFromParent_Done,
     /* 294988 */   // Label 5805: @294988
     /* 294988 */   GIM_Try, /*On fail goto*//*Label 5806*/ GIMT_Encode4(295020), // Rule ID 1152 //
     /* 294993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294996 */     // MIs[0] Operand 1
     /* 294996 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 295001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295009 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 295009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 295012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295018 */     GIR_RootConstrainSelectedInstOperands,
     /* 295019 */     // GIR_Coverage, 1152,
     /* 295019 */     GIR_EraseRootFromParent_Done,
     /* 295020 */   // Label 5806: @295020
     /* 295020 */   GIM_Try, /*On fail goto*//*Label 5807*/ GIMT_Encode4(295049), // Rule ID 5117 //
     /* 295025 */     // MIs[0] Operand 1
     /* 295025 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 295030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295038 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 295038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16),
     /* 295041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295047 */     GIR_RootConstrainSelectedInstOperands,
     /* 295048 */     // GIR_Coverage, 5117,
     /* 295048 */     GIR_EraseRootFromParent_Done,
     /* 295049 */   // Label 5807: @295049
     /* 295049 */   GIM_Try, /*On fail goto*//*Label 5808*/ GIMT_Encode4(295078), // Rule ID 5124 //
     /* 295054 */     // MIs[0] Operand 1
     /* 295054 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 295059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295067 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 295067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 295070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295076 */     GIR_RootConstrainSelectedInstOperands,
     /* 295077 */     // GIR_Coverage, 5124,
     /* 295077 */     GIR_EraseRootFromParent_Done,
     /* 295078 */   // Label 5808: @295078
     /* 295078 */   GIM_Try, /*On fail goto*//*Label 5809*/ GIMT_Encode4(295107), // Rule ID 5131 //
     /* 295083 */     // MIs[0] Operand 1
     /* 295083 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 295088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295096 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 295096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 295099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295105 */     GIR_RootConstrainSelectedInstOperands,
     /* 295106 */     // GIR_Coverage, 5131,
     /* 295106 */     GIR_EraseRootFromParent_Done,
     /* 295107 */   // Label 5809: @295107
     /* 295107 */   GIM_Try, /*On fail goto*//*Label 5810*/ GIMT_Encode4(295136), // Rule ID 5138 //
     /* 295112 */     // MIs[0] Operand 1
     /* 295112 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 295117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295125 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 295125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 295128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295134 */     GIR_RootConstrainSelectedInstOperands,
     /* 295135 */     // GIR_Coverage, 5138,
     /* 295135 */     GIR_EraseRootFromParent_Done,
     /* 295136 */   // Label 5810: @295136
     /* 295136 */   GIM_Try, /*On fail goto*//*Label 5811*/ GIMT_Encode4(295165), // Rule ID 5145 //
     /* 295141 */     // MIs[0] Operand 1
     /* 295141 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 295146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295154 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 295154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 295157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295163 */     GIR_RootConstrainSelectedInstOperands,
     /* 295164 */     // GIR_Coverage, 5145,
     /* 295164 */     GIR_EraseRootFromParent_Done,
     /* 295165 */   // Label 5811: @295165
     /* 295165 */   GIM_Try, /*On fail goto*//*Label 5812*/ GIMT_Encode4(295194), // Rule ID 5152 //
     /* 295170 */     // MIs[0] Operand 1
     /* 295170 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 295175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295183 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 295183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 295186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295192 */     GIR_RootConstrainSelectedInstOperands,
     /* 295193 */     // GIR_Coverage, 5152,
     /* 295193 */     GIR_EraseRootFromParent_Done,
     /* 295194 */   // Label 5812: @295194
     /* 295194 */   GIM_Try, /*On fail goto*//*Label 5813*/ GIMT_Encode4(295223), // Rule ID 5159 //
     /* 295199 */     // MIs[0] Operand 1
     /* 295199 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 295204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295212 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 295212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 295215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295217 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295219 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295221 */     GIR_RootConstrainSelectedInstOperands,
     /* 295222 */     // GIR_Coverage, 5159,
     /* 295222 */     GIR_EraseRootFromParent_Done,
     /* 295223 */   // Label 5813: @295223
     /* 295223 */   GIM_Try, /*On fail goto*//*Label 5814*/ GIMT_Encode4(295252), // Rule ID 5166 //
     /* 295228 */     // MIs[0] Operand 1
     /* 295228 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 295233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295241 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 295241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 295244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295246 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295250 */     GIR_RootConstrainSelectedInstOperands,
     /* 295251 */     // GIR_Coverage, 5166,
     /* 295251 */     GIR_EraseRootFromParent_Done,
     /* 295252 */   // Label 5814: @295252
     /* 295252 */   GIM_Try, /*On fail goto*//*Label 5815*/ GIMT_Encode4(295281), // Rule ID 5173 //
     /* 295257 */     // MIs[0] Operand 1
     /* 295257 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 295262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295270 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 295270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 295273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295279 */     GIR_RootConstrainSelectedInstOperands,
     /* 295280 */     // GIR_Coverage, 5173,
     /* 295280 */     GIR_EraseRootFromParent_Done,
     /* 295281 */   // Label 5815: @295281
     /* 295281 */   GIM_Reject,
     /* 295282 */ // Label 5785: @295282
     /* 295282 */ GIM_Reject,
     /* 295283 */ // Label 5616: @295283
     /* 295283 */ GIM_Try, /*On fail goto*//*Label 5816*/ GIMT_Encode4(296330),
     /* 295288 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 295291 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 295294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295298 */   GIM_Try, /*On fail goto*//*Label 5817*/ GIMT_Encode4(295338), // Rule ID 751 //
     /* 295303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295306 */     // MIs[0] Operand 1
     /* 295306 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 295311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295315 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295321 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295329 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 295332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 295336 */     GIR_RootConstrainSelectedInstOperands,
     /* 295337 */     // GIR_Coverage, 751,
     /* 295337 */     GIR_EraseRootFromParent_Done,
     /* 295338 */   // Label 5817: @295338
     /* 295338 */   GIM_Try, /*On fail goto*//*Label 5818*/ GIMT_Encode4(295378), // Rule ID 758 //
     /* 295343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295346 */     // MIs[0] Operand 1
     /* 295346 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 295351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295355 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295361 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295369 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 295372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295374 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 295376 */     GIR_RootConstrainSelectedInstOperands,
     /* 295377 */     // GIR_Coverage, 758,
     /* 295377 */     GIR_EraseRootFromParent_Done,
     /* 295378 */   // Label 5818: @295378
     /* 295378 */   GIM_Try, /*On fail goto*//*Label 5819*/ GIMT_Encode4(295415), // Rule ID 5213 //
     /* 295383 */     // MIs[0] Operand 1
     /* 295383 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 295388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295392 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295398 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295406 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 295409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 295413 */     GIR_RootConstrainSelectedInstOperands,
     /* 295414 */     // GIR_Coverage, 5213,
     /* 295414 */     GIR_EraseRootFromParent_Done,
     /* 295415 */   // Label 5819: @295415
     /* 295415 */   GIM_Try, /*On fail goto*//*Label 5820*/ GIMT_Encode4(295452), // Rule ID 5220 //
     /* 295420 */     // MIs[0] Operand 1
     /* 295420 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 295425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295429 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295435 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295443 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 295446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 295450 */     GIR_RootConstrainSelectedInstOperands,
     /* 295451 */     // GIR_Coverage, 5220,
     /* 295451 */     GIR_EraseRootFromParent_Done,
     /* 295452 */   // Label 5820: @295452
     /* 295452 */   GIM_Try, /*On fail goto*//*Label 5821*/ GIMT_Encode4(295489), // Rule ID 5227 //
     /* 295457 */     // MIs[0] Operand 1
     /* 295457 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 295462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295466 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295472 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295478 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295480 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 295483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 295487 */     GIR_RootConstrainSelectedInstOperands,
     /* 295488 */     // GIR_Coverage, 5227,
     /* 295488 */     GIR_EraseRootFromParent_Done,
     /* 295489 */   // Label 5821: @295489
     /* 295489 */   GIM_Try, /*On fail goto*//*Label 5822*/ GIMT_Encode4(295526), // Rule ID 5234 //
     /* 295494 */     // MIs[0] Operand 1
     /* 295494 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 295499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295503 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295509 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295517 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 295520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295522 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 295524 */     GIR_RootConstrainSelectedInstOperands,
     /* 295525 */     // GIR_Coverage, 5234,
     /* 295525 */     GIR_EraseRootFromParent_Done,
     /* 295526 */   // Label 5822: @295526
     /* 295526 */   GIM_Try, /*On fail goto*//*Label 5823*/ GIMT_Encode4(295563), // Rule ID 5241 //
     /* 295531 */     // MIs[0] Operand 1
     /* 295531 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 295536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295540 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295546 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295554 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 295557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 295561 */     GIR_RootConstrainSelectedInstOperands,
     /* 295562 */     // GIR_Coverage, 5241,
     /* 295562 */     GIR_EraseRootFromParent_Done,
     /* 295563 */   // Label 5823: @295563
     /* 295563 */   GIM_Try, /*On fail goto*//*Label 5824*/ GIMT_Encode4(295603), // Rule ID 723 //
     /* 295568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295571 */     // MIs[0] Operand 1
     /* 295571 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 295576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295584 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295590 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295594 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 295597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295601 */     GIR_RootConstrainSelectedInstOperands,
     /* 295602 */     // GIR_Coverage, 723,
     /* 295602 */     GIR_EraseRootFromParent_Done,
     /* 295603 */   // Label 5824: @295603
     /* 295603 */   GIM_Try, /*On fail goto*//*Label 5825*/ GIMT_Encode4(295643), // Rule ID 731 //
     /* 295608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295611 */     // MIs[0] Operand 1
     /* 295611 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 295616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295624 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295630 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295634 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 295637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295641 */     GIR_RootConstrainSelectedInstOperands,
     /* 295642 */     // GIR_Coverage, 731,
     /* 295642 */     GIR_EraseRootFromParent_Done,
     /* 295643 */   // Label 5825: @295643
     /* 295643 */   GIM_Try, /*On fail goto*//*Label 5826*/ GIMT_Encode4(295683), // Rule ID 732 //
     /* 295648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295651 */     // MIs[0] Operand 1
     /* 295651 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 295656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295664 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295670 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 295672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295674 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllOnesV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 295677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295681 */     GIR_RootConstrainSelectedInstOperands,
     /* 295682 */     // GIR_Coverage, 732,
     /* 295682 */     GIR_EraseRootFromParent_Done,
     /* 295683 */   // Label 5826: @295683
     /* 295683 */   GIM_Try, /*On fail goto*//*Label 5827*/ GIMT_Encode4(295723), // Rule ID 744 //
     /* 295688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295691 */     // MIs[0] Operand 1
     /* 295691 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 295696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295704 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295710 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295714 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 295717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295721 */     GIR_RootConstrainSelectedInstOperands,
     /* 295722 */     // GIR_Coverage, 744,
     /* 295722 */     GIR_EraseRootFromParent_Done,
     /* 295723 */   // Label 5827: @295723
     /* 295723 */   GIM_Try, /*On fail goto*//*Label 5828*/ GIMT_Encode4(295760), // Rule ID 5178 //
     /* 295728 */     // MIs[0] Operand 1
     /* 295728 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 295733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295741 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295747 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295751 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 295754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295758 */     GIR_RootConstrainSelectedInstOperands,
     /* 295759 */     // GIR_Coverage, 5178,
     /* 295759 */     GIR_EraseRootFromParent_Done,
     /* 295760 */   // Label 5828: @295760
     /* 295760 */   GIM_Try, /*On fail goto*//*Label 5829*/ GIMT_Encode4(295797), // Rule ID 5185 //
     /* 295765 */     // MIs[0] Operand 1
     /* 295765 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 295770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295778 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295784 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295788 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 295791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295795 */     GIR_RootConstrainSelectedInstOperands,
     /* 295796 */     // GIR_Coverage, 5185,
     /* 295796 */     GIR_EraseRootFromParent_Done,
     /* 295797 */   // Label 5829: @295797
     /* 295797 */   GIM_Try, /*On fail goto*//*Label 5830*/ GIMT_Encode4(295834), // Rule ID 5192 //
     /* 295802 */     // MIs[0] Operand 1
     /* 295802 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 295807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295815 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295821 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295825 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 295828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295832 */     GIR_RootConstrainSelectedInstOperands,
     /* 295833 */     // GIR_Coverage, 5192,
     /* 295833 */     GIR_EraseRootFromParent_Done,
     /* 295834 */   // Label 5830: @295834
     /* 295834 */   GIM_Try, /*On fail goto*//*Label 5831*/ GIMT_Encode4(295871), // Rule ID 5199 //
     /* 295839 */     // MIs[0] Operand 1
     /* 295839 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 295844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295852 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295858 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295862 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETLT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 295865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295869 */     GIR_RootConstrainSelectedInstOperands,
     /* 295870 */     // GIR_Coverage, 5199,
     /* 295870 */     GIR_EraseRootFromParent_Done,
     /* 295871 */   // Label 5831: @295871
     /* 295871 */   GIM_Try, /*On fail goto*//*Label 5832*/ GIMT_Encode4(295908), // Rule ID 5206 //
     /* 295876 */     // MIs[0] Operand 1
     /* 295876 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 295881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295889 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295895 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295899 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETLE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 295902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295906 */     GIR_RootConstrainSelectedInstOperands,
     /* 295907 */     // GIR_Coverage, 5206,
     /* 295907 */     GIR_EraseRootFromParent_Done,
     /* 295908 */   // Label 5832: @295908
     /* 295908 */   GIM_Try, /*On fail goto*//*Label 5833*/ GIMT_Encode4(295940), // Rule ID 1122 //
     /* 295913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295916 */     // MIs[0] Operand 1
     /* 295916 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 295921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295929 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 295929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8),
     /* 295932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295938 */     GIR_RootConstrainSelectedInstOperands,
     /* 295939 */     // GIR_Coverage, 1122,
     /* 295939 */     GIR_EraseRootFromParent_Done,
     /* 295940 */   // Label 5833: @295940
     /* 295940 */   GIM_Try, /*On fail goto*//*Label 5834*/ GIMT_Encode4(295972), // Rule ID 1129 //
     /* 295945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295948 */     // MIs[0] Operand 1
     /* 295948 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 295953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295961 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 295961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 295964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295970 */     GIR_RootConstrainSelectedInstOperands,
     /* 295971 */     // GIR_Coverage, 1129,
     /* 295971 */     GIR_EraseRootFromParent_Done,
     /* 295972 */   // Label 5834: @295972
     /* 295972 */   GIM_Try, /*On fail goto*//*Label 5835*/ GIMT_Encode4(296004), // Rule ID 1136 //
     /* 295977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295980 */     // MIs[0] Operand 1
     /* 295980 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 295985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295993 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 295993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 295996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296002 */     GIR_RootConstrainSelectedInstOperands,
     /* 296003 */     // GIR_Coverage, 1136,
     /* 296003 */     GIR_EraseRootFromParent_Done,
     /* 296004 */   // Label 5835: @296004
     /* 296004 */   GIM_Try, /*On fail goto*//*Label 5836*/ GIMT_Encode4(296036), // Rule ID 1143 //
     /* 296009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296012 */     // MIs[0] Operand 1
     /* 296012 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 296017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296025 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 296025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 296028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296034 */     GIR_RootConstrainSelectedInstOperands,
     /* 296035 */     // GIR_Coverage, 1143,
     /* 296035 */     GIR_EraseRootFromParent_Done,
     /* 296036 */   // Label 5836: @296036
     /* 296036 */   GIM_Try, /*On fail goto*//*Label 5837*/ GIMT_Encode4(296068), // Rule ID 1150 //
     /* 296041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296044 */     // MIs[0] Operand 1
     /* 296044 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 296049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296057 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 296057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 296060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296066 */     GIR_RootConstrainSelectedInstOperands,
     /* 296067 */     // GIR_Coverage, 1150,
     /* 296067 */     GIR_EraseRootFromParent_Done,
     /* 296068 */   // Label 5837: @296068
     /* 296068 */   GIM_Try, /*On fail goto*//*Label 5838*/ GIMT_Encode4(296097), // Rule ID 5115 //
     /* 296073 */     // MIs[0] Operand 1
     /* 296073 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 296078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296086 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 296086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8),
     /* 296089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296095 */     GIR_RootConstrainSelectedInstOperands,
     /* 296096 */     // GIR_Coverage, 5115,
     /* 296096 */     GIR_EraseRootFromParent_Done,
     /* 296097 */   // Label 5838: @296097
     /* 296097 */   GIM_Try, /*On fail goto*//*Label 5839*/ GIMT_Encode4(296126), // Rule ID 5122 //
     /* 296102 */     // MIs[0] Operand 1
     /* 296102 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 296107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296115 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 296115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 296118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296122 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296124 */     GIR_RootConstrainSelectedInstOperands,
     /* 296125 */     // GIR_Coverage, 5122,
     /* 296125 */     GIR_EraseRootFromParent_Done,
     /* 296126 */   // Label 5839: @296126
     /* 296126 */   GIM_Try, /*On fail goto*//*Label 5840*/ GIMT_Encode4(296155), // Rule ID 5129 //
     /* 296131 */     // MIs[0] Operand 1
     /* 296131 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 296136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296144 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 296144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 296147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296153 */     GIR_RootConstrainSelectedInstOperands,
     /* 296154 */     // GIR_Coverage, 5129,
     /* 296154 */     GIR_EraseRootFromParent_Done,
     /* 296155 */   // Label 5840: @296155
     /* 296155 */   GIM_Try, /*On fail goto*//*Label 5841*/ GIMT_Encode4(296184), // Rule ID 5136 //
     /* 296160 */     // MIs[0] Operand 1
     /* 296160 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 296165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296173 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 296173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 296176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296182 */     GIR_RootConstrainSelectedInstOperands,
     /* 296183 */     // GIR_Coverage, 5136,
     /* 296183 */     GIR_EraseRootFromParent_Done,
     /* 296184 */   // Label 5841: @296184
     /* 296184 */   GIM_Try, /*On fail goto*//*Label 5842*/ GIMT_Encode4(296213), // Rule ID 5143 //
     /* 296189 */     // MIs[0] Operand 1
     /* 296189 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 296194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296202 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 296202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 296205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296211 */     GIR_RootConstrainSelectedInstOperands,
     /* 296212 */     // GIR_Coverage, 5143,
     /* 296212 */     GIR_EraseRootFromParent_Done,
     /* 296213 */   // Label 5842: @296213
     /* 296213 */   GIM_Try, /*On fail goto*//*Label 5843*/ GIMT_Encode4(296242), // Rule ID 5150 //
     /* 296218 */     // MIs[0] Operand 1
     /* 296218 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 296223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296231 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 296231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 296234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296240 */     GIR_RootConstrainSelectedInstOperands,
     /* 296241 */     // GIR_Coverage, 5150,
     /* 296241 */     GIR_EraseRootFromParent_Done,
     /* 296242 */   // Label 5843: @296242
     /* 296242 */   GIM_Try, /*On fail goto*//*Label 5844*/ GIMT_Encode4(296271), // Rule ID 5157 //
     /* 296247 */     // MIs[0] Operand 1
     /* 296247 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 296252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296260 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 296260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 296263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296269 */     GIR_RootConstrainSelectedInstOperands,
     /* 296270 */     // GIR_Coverage, 5157,
     /* 296270 */     GIR_EraseRootFromParent_Done,
     /* 296271 */   // Label 5844: @296271
     /* 296271 */   GIM_Try, /*On fail goto*//*Label 5845*/ GIMT_Encode4(296300), // Rule ID 5164 //
     /* 296276 */     // MIs[0] Operand 1
     /* 296276 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 296281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296289 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 296289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 296292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296298 */     GIR_RootConstrainSelectedInstOperands,
     /* 296299 */     // GIR_Coverage, 5164,
     /* 296299 */     GIR_EraseRootFromParent_Done,
     /* 296300 */   // Label 5845: @296300
     /* 296300 */   GIM_Try, /*On fail goto*//*Label 5846*/ GIMT_Encode4(296329), // Rule ID 5171 //
     /* 296305 */     // MIs[0] Operand 1
     /* 296305 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 296310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296318 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 296318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 296321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296327 */     GIR_RootConstrainSelectedInstOperands,
     /* 296328 */     // GIR_Coverage, 5171,
     /* 296328 */     GIR_EraseRootFromParent_Done,
     /* 296329 */   // Label 5846: @296329
     /* 296329 */   GIM_Reject,
     /* 296330 */ // Label 5816: @296330
     /* 296330 */ GIM_Reject,
     /* 296331 */ // Label 5617: @296331
     /* 296331 */ GIM_Reject,
     /* 296332 */ // Label 52: @296332
     /* 296332 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(12), GIMT_Encode2(24), /*)*//*default:*//*Label 5859*/ GIMT_Encode4(297376),
     /* 296343 */ /*GILLT_nxv1s1*//*Label 5847*/ GIMT_Encode4(296391),
     /* 296347 */ /*GILLT_nxv2s1*//*Label 5848*/ GIMT_Encode4(296420),
     /* 296351 */ /*GILLT_nxv2s16*//*Label 5849*/ GIMT_Encode4(296449),
     /* 296355 */ /*GILLT_nxv2s32*//*Label 5850*/ GIMT_Encode4(296534),
     /* 296359 */ /*GILLT_nxv2s64*//*Label 5851*/ GIMT_Encode4(296619),
     /* 296363 */ /*GILLT_nxv4s1*//*Label 5852*/ GIMT_Encode4(296785),
     /* 296367 */ /*GILLT_nxv4s16*//*Label 5853*/ GIMT_Encode4(296814),
     /* 296371 */ /*GILLT_nxv4s32*//*Label 5854*/ GIMT_Encode4(296899),
     /* 296375 */ /*GILLT_nxv8s1*//*Label 5855*/ GIMT_Encode4(297065),
     /* 296379 */ /*GILLT_nxv8s16*//*Label 5856*/ GIMT_Encode4(297094),
     /* 296383 */ /*GILLT_nxv16s1*//*Label 5857*/ GIMT_Encode4(297260),
     /* 296387 */ /*GILLT_nxv16s8*//*Label 5858*/ GIMT_Encode4(297289),
     /* 296391 */ // Label 5847: @296391
     /* 296391 */ GIM_Try, /*On fail goto*//*Label 5860*/ GIMT_Encode4(296419), // Rule ID 8564 //
     /* 296396 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 296402 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 296405 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 296408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 296412 */   // (vselect:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 296412 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 296417 */   GIR_RootConstrainSelectedInstOperands,
     /* 296418 */   // GIR_Coverage, 8564,
     /* 296418 */   GIR_Done,
     /* 296419 */ // Label 5860: @296419
     /* 296419 */ GIM_Reject,
     /* 296420 */ // Label 5848: @296420
     /* 296420 */ GIM_Try, /*On fail goto*//*Label 5861*/ GIMT_Encode4(296448), // Rule ID 8563 //
     /* 296425 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 296431 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 296434 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 296437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 296441 */   // (vselect:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 296441 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 296446 */   GIR_RootConstrainSelectedInstOperands,
     /* 296447 */   // GIR_Coverage, 8563,
     /* 296447 */   GIR_Done,
     /* 296448 */ // Label 5861: @296448
     /* 296448 */ GIM_Reject,
     /* 296449 */ // Label 5849: @296449
     /* 296449 */ GIM_Try, /*On fail goto*//*Label 5862*/ GIMT_Encode4(296533),
     /* 296454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 296457 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 296460 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 296463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 296467 */   GIM_Try, /*On fail goto*//*Label 5863*/ GIMT_Encode4(296517), // Rule ID 3172 //
     /* 296472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 296483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 296487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 296495 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 296499 */     // MIs[2] Operand 1
     /* 296499 */     // No operand predicates
     /* 296499 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 296501 */     // (vselect:{ *:[nxv2f16] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv2f16:{ *:[nxv2f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 296501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 296504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 296506 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 296508 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 296510 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 296515 */     GIR_RootConstrainSelectedInstOperands,
     /* 296516 */     // GIR_Coverage, 3172,
     /* 296516 */     GIR_EraseRootFromParent_Done,
     /* 296517 */   // Label 5863: @296517
     /* 296517 */   GIM_Try, /*On fail goto*//*Label 5864*/ GIMT_Encode4(296532), // Rule ID 2737 //
     /* 296522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296525 */     // (vselect:{ *:[nxv2f16] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 296525 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 296530 */     GIR_RootConstrainSelectedInstOperands,
     /* 296531 */     // GIR_Coverage, 2737,
     /* 296531 */     GIR_Done,
     /* 296532 */   // Label 5864: @296532
     /* 296532 */   GIM_Reject,
     /* 296533 */ // Label 5862: @296533
     /* 296533 */ GIM_Reject,
     /* 296534 */ // Label 5850: @296534
     /* 296534 */ GIM_Try, /*On fail goto*//*Label 5865*/ GIMT_Encode4(296618),
     /* 296539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 296542 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 296545 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 296548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 296552 */   GIM_Try, /*On fail goto*//*Label 5866*/ GIMT_Encode4(296602), // Rule ID 3174 //
     /* 296557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 296568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 296572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 296580 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 296584 */     // MIs[2] Operand 1
     /* 296584 */     // No operand predicates
     /* 296584 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 296586 */     // (vselect:{ *:[nxv2f32] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8), nxv2f32:{ *:[nxv2f32] }:$zd)  =>  (FCPY_ZPmI_S:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 296586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_S),
     /* 296589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 296591 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 296593 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 296595 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 296600 */     GIR_RootConstrainSelectedInstOperands,
     /* 296601 */     // GIR_Coverage, 3174,
     /* 296601 */     GIR_EraseRootFromParent_Done,
     /* 296602 */   // Label 5866: @296602
     /* 296602 */   GIM_Try, /*On fail goto*//*Label 5867*/ GIMT_Encode4(296617), // Rule ID 2738 //
     /* 296607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296610 */     // (vselect:{ *:[nxv2f32] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 296610 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 296615 */     GIR_RootConstrainSelectedInstOperands,
     /* 296616 */     // GIR_Coverage, 2738,
     /* 296616 */     GIR_Done,
     /* 296617 */   // Label 5867: @296617
     /* 296617 */   GIM_Reject,
     /* 296618 */ // Label 5865: @296618
     /* 296618 */ GIM_Reject,
     /* 296619 */ // Label 5851: @296619
     /* 296619 */ GIM_Try, /*On fail goto*//*Label 5868*/ GIMT_Encode4(296784),
     /* 296624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 296627 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 296630 */   GIM_Try, /*On fail goto*//*Label 5869*/ GIMT_Encode4(296687), // Rule ID 3175 //
     /* 296635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 296641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 296645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 296653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 296657 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296661 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 296665 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 296669 */     // MIs[2] Operand 1
     /* 296669 */     // No operand predicates
     /* 296669 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 296671 */     // (vselect:{ *:[nxv2f64] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm8), nxv2f64:{ *:[nxv2f64] }:$zd)  =>  (FCPY_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>>:$imm8))
     /* 296671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_D),
     /* 296674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 296676 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 296678 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 296680 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm8
     /* 296685 */     GIR_RootConstrainSelectedInstOperands,
     /* 296686 */     // GIR_Coverage, 3175,
     /* 296686 */     GIR_EraseRootFromParent_Done,
     /* 296687 */   // Label 5869: @296687
     /* 296687 */   GIM_Try, /*On fail goto*//*Label 5870*/ GIMT_Encode4(296739), // Rule ID 7585 //
     /* 296692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 296699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 296707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 296711 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 296715 */     // MIs[0] Op2
     /* 296715 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 296720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296722 */     // (vselect:{ *:[nxv2i64] } nxv2i1:{ *:[nxv2i1] }:$Op1, (sub:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 296722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_D),
     /* 296725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 296727 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 296729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 296733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 296737 */     GIR_RootConstrainSelectedInstOperands,
     /* 296738 */     // GIR_Coverage, 7585,
     /* 296738 */     GIR_EraseRootFromParent_Done,
     /* 296739 */   // Label 5870: @296739
     /* 296739 */   GIM_Try, /*On fail goto*//*Label 5871*/ GIMT_Encode4(296761), // Rule ID 2733 //
     /* 296744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 296750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 296754 */     // (vselect:{ *:[nxv2i64] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 296754 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 296759 */     GIR_RootConstrainSelectedInstOperands,
     /* 296760 */     // GIR_Coverage, 2733,
     /* 296760 */     GIR_Done,
     /* 296761 */   // Label 5871: @296761
     /* 296761 */   GIM_Try, /*On fail goto*//*Label 5872*/ GIMT_Encode4(296783), // Rule ID 2739 //
     /* 296766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 296772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 296776 */     // (vselect:{ *:[nxv2f64] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 296776 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 296781 */     GIR_RootConstrainSelectedInstOperands,
     /* 296782 */     // GIR_Coverage, 2739,
     /* 296782 */     GIR_Done,
     /* 296783 */   // Label 5872: @296783
     /* 296783 */   GIM_Reject,
     /* 296784 */ // Label 5868: @296784
     /* 296784 */ GIM_Reject,
     /* 296785 */ // Label 5852: @296785
     /* 296785 */ GIM_Try, /*On fail goto*//*Label 5873*/ GIMT_Encode4(296813), // Rule ID 8562 //
     /* 296790 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 296796 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 296799 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 296802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 296806 */   // (vselect:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 296806 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 296811 */   GIR_RootConstrainSelectedInstOperands,
     /* 296812 */   // GIR_Coverage, 8562,
     /* 296812 */   GIR_Done,
     /* 296813 */ // Label 5873: @296813
     /* 296813 */ GIM_Reject,
     /* 296814 */ // Label 5853: @296814
     /* 296814 */ GIM_Try, /*On fail goto*//*Label 5874*/ GIMT_Encode4(296898),
     /* 296819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 296822 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 296825 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 296828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 296832 */   GIM_Try, /*On fail goto*//*Label 5875*/ GIMT_Encode4(296882), // Rule ID 3171 //
     /* 296837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 296848 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 296852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 296860 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 296864 */     // MIs[2] Operand 1
     /* 296864 */     // No operand predicates
     /* 296864 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 296866 */     // (vselect:{ *:[nxv4f16] } nxv4i1:{ *:[nxv4i1] }:$pg, (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv4f16:{ *:[nxv4f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$zd, ?:{ *:[nxv4i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 296866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 296869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 296871 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 296873 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 296875 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 296880 */     GIR_RootConstrainSelectedInstOperands,
     /* 296881 */     // GIR_Coverage, 3171,
     /* 296881 */     GIR_EraseRootFromParent_Done,
     /* 296882 */   // Label 5875: @296882
     /* 296882 */   GIM_Try, /*On fail goto*//*Label 5876*/ GIMT_Encode4(296897), // Rule ID 2735 //
     /* 296887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296890 */     // (vselect:{ *:[nxv4f16] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 296890 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 296895 */     GIR_RootConstrainSelectedInstOperands,
     /* 296896 */     // GIR_Coverage, 2735,
     /* 296896 */     GIR_Done,
     /* 296897 */   // Label 5876: @296897
     /* 296897 */   GIM_Reject,
     /* 296898 */ // Label 5874: @296898
     /* 296898 */ GIM_Reject,
     /* 296899 */ // Label 5854: @296899
     /* 296899 */ GIM_Try, /*On fail goto*//*Label 5877*/ GIMT_Encode4(297064),
     /* 296904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 296907 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 296910 */   GIM_Try, /*On fail goto*//*Label 5878*/ GIMT_Encode4(296967), // Rule ID 3173 //
     /* 296915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 296921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 296925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 296933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 296937 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296941 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 296945 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 296949 */     // MIs[2] Operand 1
     /* 296949 */     // No operand predicates
     /* 296949 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 296951 */     // (vselect:{ *:[nxv4f32] } nxv4i1:{ *:[nxv4i1] }:$pg, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8), nxv4f32:{ *:[nxv4f32] }:$zd)  =>  (FCPY_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$zd, ?:{ *:[nxv4i1] }:$pg, (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 296951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_S),
     /* 296954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 296956 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 296958 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 296960 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 296965 */     GIR_RootConstrainSelectedInstOperands,
     /* 296966 */     // GIR_Coverage, 3173,
     /* 296966 */     GIR_EraseRootFromParent_Done,
     /* 296967 */   // Label 5878: @296967
     /* 296967 */   GIM_Try, /*On fail goto*//*Label 5879*/ GIMT_Encode4(297019), // Rule ID 7583 //
     /* 296972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 296979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 296987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 296991 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 296995 */     // MIs[0] Op2
     /* 296995 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 297000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297002 */     // (vselect:{ *:[nxv4i32] } nxv4i1:{ *:[nxv4i1] }:$Op1, (sub:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 297002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_S),
     /* 297005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 297007 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 297009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 297013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 297017 */     GIR_RootConstrainSelectedInstOperands,
     /* 297018 */     // GIR_Coverage, 7583,
     /* 297018 */     GIR_EraseRootFromParent_Done,
     /* 297019 */   // Label 5879: @297019
     /* 297019 */   GIM_Try, /*On fail goto*//*Label 5880*/ GIMT_Encode4(297041), // Rule ID 2732 //
     /* 297024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 297030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 297034 */     // (vselect:{ *:[nxv4i32] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 297034 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 297039 */     GIR_RootConstrainSelectedInstOperands,
     /* 297040 */     // GIR_Coverage, 2732,
     /* 297040 */     GIR_Done,
     /* 297041 */   // Label 5880: @297041
     /* 297041 */   GIM_Try, /*On fail goto*//*Label 5881*/ GIMT_Encode4(297063), // Rule ID 2736 //
     /* 297046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 297052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 297056 */     // (vselect:{ *:[nxv4f32] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 297056 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 297061 */     GIR_RootConstrainSelectedInstOperands,
     /* 297062 */     // GIR_Coverage, 2736,
     /* 297062 */     GIR_Done,
     /* 297063 */   // Label 5881: @297063
     /* 297063 */   GIM_Reject,
     /* 297064 */ // Label 5877: @297064
     /* 297064 */ GIM_Reject,
     /* 297065 */ // Label 5855: @297065
     /* 297065 */ GIM_Try, /*On fail goto*//*Label 5882*/ GIMT_Encode4(297093), // Rule ID 8561 //
     /* 297070 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 297076 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 297079 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 297082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 297086 */   // (vselect:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 297086 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 297091 */   GIR_RootConstrainSelectedInstOperands,
     /* 297092 */   // GIR_Coverage, 8561,
     /* 297092 */   GIR_Done,
     /* 297093 */ // Label 5882: @297093
     /* 297093 */ GIM_Reject,
     /* 297094 */ // Label 5856: @297094
     /* 297094 */ GIM_Try, /*On fail goto*//*Label 5883*/ GIMT_Encode4(297259),
     /* 297099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 297102 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 297105 */   GIM_Try, /*On fail goto*//*Label 5884*/ GIMT_Encode4(297162), // Rule ID 3170 //
     /* 297110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 297116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 297120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 297128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 297132 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297136 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 297140 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 297144 */     // MIs[2] Operand 1
     /* 297144 */     // No operand predicates
     /* 297144 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297146 */     // (vselect:{ *:[nxv8f16] } nxv8i1:{ *:[nxv8i1] }:$pg, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv8f16:{ *:[nxv8f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$zd, ?:{ *:[nxv8i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 297146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 297149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 297151 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 297153 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 297155 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 297160 */     GIR_RootConstrainSelectedInstOperands,
     /* 297161 */     // GIR_Coverage, 3170,
     /* 297161 */     GIR_EraseRootFromParent_Done,
     /* 297162 */   // Label 5884: @297162
     /* 297162 */   GIM_Try, /*On fail goto*//*Label 5885*/ GIMT_Encode4(297214), // Rule ID 7581 //
     /* 297167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 297174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 297182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 297186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 297190 */     // MIs[0] Op2
     /* 297190 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 297195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297197 */     // (vselect:{ *:[nxv8i16] } nxv8i1:{ *:[nxv8i1] }:$Op1, (sub:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 297197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_H),
     /* 297200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 297202 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 297204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 297208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 297212 */     GIR_RootConstrainSelectedInstOperands,
     /* 297213 */     // GIR_Coverage, 7581,
     /* 297213 */     GIR_EraseRootFromParent_Done,
     /* 297214 */   // Label 5885: @297214
     /* 297214 */   GIM_Try, /*On fail goto*//*Label 5886*/ GIMT_Encode4(297236), // Rule ID 2731 //
     /* 297219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 297225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 297229 */     // (vselect:{ *:[nxv8i16] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SEL_ZPZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 297229 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_H),
     /* 297234 */     GIR_RootConstrainSelectedInstOperands,
     /* 297235 */     // GIR_Coverage, 2731,
     /* 297235 */     GIR_Done,
     /* 297236 */   // Label 5886: @297236
     /* 297236 */   GIM_Try, /*On fail goto*//*Label 5887*/ GIMT_Encode4(297258), // Rule ID 2734 //
     /* 297241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 297247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 297251 */     // (vselect:{ *:[nxv8f16] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (SEL_ZPZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 297251 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_H),
     /* 297256 */     GIR_RootConstrainSelectedInstOperands,
     /* 297257 */     // GIR_Coverage, 2734,
     /* 297257 */     GIR_Done,
     /* 297258 */   // Label 5887: @297258
     /* 297258 */   GIM_Reject,
     /* 297259 */ // Label 5883: @297259
     /* 297259 */ GIM_Reject,
     /* 297260 */ // Label 5857: @297260
     /* 297260 */ GIM_Try, /*On fail goto*//*Label 5888*/ GIMT_Encode4(297288), // Rule ID 8560 //
     /* 297265 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 297271 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 297274 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 297277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 297281 */   // (vselect:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 297281 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 297286 */   GIR_RootConstrainSelectedInstOperands,
     /* 297287 */   // GIR_Coverage, 8560,
     /* 297287 */   GIR_Done,
     /* 297288 */ // Label 5888: @297288
     /* 297288 */ GIM_Reject,
     /* 297289 */ // Label 5858: @297289
     /* 297289 */ GIM_Try, /*On fail goto*//*Label 5889*/ GIMT_Encode4(297375),
     /* 297294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 297297 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 297300 */   GIM_Try, /*On fail goto*//*Label 5890*/ GIMT_Encode4(297352), // Rule ID 7579 //
     /* 297305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 297312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 297320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 297324 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 297328 */     // MIs[0] Op2
     /* 297328 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 297333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297335 */     // (vselect:{ *:[nxv16i8] } nxv16i1:{ *:[nxv16i1] }:$Op1, (sub:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 297335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_B),
     /* 297338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 297340 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 297342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 297346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 297350 */     GIR_RootConstrainSelectedInstOperands,
     /* 297351 */     // GIR_Coverage, 7579,
     /* 297351 */     GIR_EraseRootFromParent_Done,
     /* 297352 */   // Label 5890: @297352
     /* 297352 */   GIM_Try, /*On fail goto*//*Label 5891*/ GIMT_Encode4(297374), // Rule ID 2730 //
     /* 297357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 297363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 297367 */     // (vselect:{ *:[nxv16i8] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SEL_ZPZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 297367 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_B),
     /* 297372 */     GIR_RootConstrainSelectedInstOperands,
     /* 297373 */     // GIR_Coverage, 2730,
     /* 297373 */     GIR_Done,
     /* 297374 */   // Label 5891: @297374
     /* 297374 */   GIM_Reject,
     /* 297375 */ // Label 5889: @297375
     /* 297375 */ GIM_Reject,
     /* 297376 */ // Label 5859: @297376
     /* 297376 */ GIM_Reject,
     /* 297377 */ // Label 53: @297377
     /* 297377 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5896*/ GIMT_Encode4(297860),
     /* 297388 */ /*GILLT_s64*//*Label 5892*/ GIMT_Encode4(297424), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 297408 */ /*GILLT_v4s32*//*Label 5893*/ GIMT_Encode4(297455), GIMT_Encode4(0),
     /* 297416 */ /*GILLT_v8s16*//*Label 5894*/ GIMT_Encode4(297590),
     /* 297420 */ /*GILLT_v16s8*//*Label 5895*/ GIMT_Encode4(297725),
     /* 297424 */ // Label 5892: @297424
     /* 297424 */ GIM_Try, /*On fail goto*//*Label 5897*/ GIMT_Encode4(297454), // Rule ID 128 //
     /* 297429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 297432 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 297435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 297439 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 297443 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 297447 */   // (mulhu:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMULHrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 297447 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULHrr),
     /* 297452 */   GIR_RootConstrainSelectedInstOperands,
     /* 297453 */   // GIR_Coverage, 128,
     /* 297453 */   GIR_Done,
     /* 297454 */ // Label 5897: @297454
     /* 297454 */ GIM_Reject,
     /* 297455 */ // Label 5893: @297455
     /* 297455 */ GIM_Try, /*On fail goto*//*Label 5898*/ GIMT_Encode4(297589), // Rule ID 6599 //
     /* 297460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297463 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 297466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297470 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297474 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297478 */   // (mulhu:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } (UMULLv2i32_v2i64:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rm, dsub:{ *:[i32] })), (UMULLv4i32_v2i64:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))
     /* 297478 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 297481 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_v2i64),
     /* 297485 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297490 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 297494 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 297498 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 297500 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 297503 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297507 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297512 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 297518 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297523 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297528 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 297531 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297535 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297540 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 297546 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297551 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297556 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 297559 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_v2i64),
     /* 297563 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297568 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 297571 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 297574 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 297576 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 297579 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297581 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297584 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 297587 */   GIR_RootConstrainSelectedInstOperands,
     /* 297588 */   // GIR_Coverage, 6599,
     /* 297588 */   GIR_EraseRootFromParent_Done,
     /* 297589 */ // Label 5898: @297589
     /* 297589 */ GIM_Reject,
     /* 297590 */ // Label 5894: @297590
     /* 297590 */ GIM_Try, /*On fail goto*//*Label 5899*/ GIMT_Encode4(297724), // Rule ID 6598 //
     /* 297595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 297598 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 297601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297605 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297609 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297613 */   // (mulhu:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } (UMULLv4i16_v4i32:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rm, dsub:{ *:[i32] })), (UMULLv8i16_v4i32:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))
     /* 297613 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 297616 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_v4i32),
     /* 297620 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297625 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 297629 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 297633 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 297635 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 297638 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297642 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297647 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 297653 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297658 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297663 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 297666 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297670 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297675 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 297681 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297686 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297691 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 297694 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_v4i32),
     /* 297698 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297703 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 297706 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 297709 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 297711 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 297714 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297716 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297719 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 297722 */   GIR_RootConstrainSelectedInstOperands,
     /* 297723 */   // GIR_Coverage, 6598,
     /* 297723 */   GIR_EraseRootFromParent_Done,
     /* 297724 */ // Label 5899: @297724
     /* 297724 */ GIM_Reject,
     /* 297725 */ // Label 5895: @297725
     /* 297725 */ GIM_Try, /*On fail goto*//*Label 5900*/ GIMT_Encode4(297859), // Rule ID 6597 //
     /* 297730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 297733 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 297736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297744 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297748 */   // (mulhu:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } (UMULLv8i8_v8i16:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rm, dsub:{ *:[i32] })), (UMULLv16i8_v8i16:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))
     /* 297748 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 297751 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv16i8_v8i16),
     /* 297755 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297760 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 297764 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 297768 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 297770 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 297773 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297777 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297782 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 297788 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297793 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297798 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 297801 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297805 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297810 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 297816 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297821 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297826 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 297829 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i8_v8i16),
     /* 297833 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297838 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 297841 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 297844 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 297846 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 297849 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297851 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297854 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 297857 */   GIR_RootConstrainSelectedInstOperands,
     /* 297858 */   // GIR_Coverage, 6597,
     /* 297858 */   GIR_EraseRootFromParent_Done,
     /* 297859 */ // Label 5900: @297859
     /* 297859 */ GIM_Reject,
     /* 297860 */ // Label 5896: @297860
     /* 297860 */ GIM_Reject,
     /* 297861 */ // Label 54: @297861
     /* 297861 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5905*/ GIMT_Encode4(298344),
     /* 297872 */ /*GILLT_s64*//*Label 5901*/ GIMT_Encode4(297908), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 297892 */ /*GILLT_v4s32*//*Label 5902*/ GIMT_Encode4(297939), GIMT_Encode4(0),
     /* 297900 */ /*GILLT_v8s16*//*Label 5903*/ GIMT_Encode4(298074),
     /* 297904 */ /*GILLT_v16s8*//*Label 5904*/ GIMT_Encode4(298209),
     /* 297908 */ // Label 5901: @297908
     /* 297908 */ GIM_Try, /*On fail goto*//*Label 5906*/ GIMT_Encode4(297938), // Rule ID 127 //
     /* 297913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 297916 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 297919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 297923 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 297927 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 297931 */   // (mulhs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMULHrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 297931 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULHrr),
     /* 297936 */   GIR_RootConstrainSelectedInstOperands,
     /* 297937 */   // GIR_Coverage, 127,
     /* 297937 */   GIR_Done,
     /* 297938 */ // Label 5906: @297938
     /* 297938 */ GIM_Reject,
     /* 297939 */ // Label 5902: @297939
     /* 297939 */ GIM_Try, /*On fail goto*//*Label 5907*/ GIMT_Encode4(298073), // Rule ID 6596 //
     /* 297944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297947 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 297950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297954 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297958 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297962 */   // (mulhs:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } (SMULLv2i32_v2i64:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rm, dsub:{ *:[i32] })), (SMULLv4i32_v2i64:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))
     /* 297962 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 297965 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_v2i64),
     /* 297969 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297974 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 297978 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 297982 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 297984 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 297987 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297991 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297996 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 298002 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298007 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298012 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 298015 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298019 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298024 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 298030 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298035 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298040 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 298043 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_v2i64),
     /* 298047 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298052 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 298055 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 298058 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 298060 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 298063 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298065 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298068 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 298071 */   GIR_RootConstrainSelectedInstOperands,
     /* 298072 */   // GIR_Coverage, 6596,
     /* 298072 */   GIR_EraseRootFromParent_Done,
     /* 298073 */ // Label 5907: @298073
     /* 298073 */ GIM_Reject,
     /* 298074 */ // Label 5903: @298074
     /* 298074 */ GIM_Try, /*On fail goto*//*Label 5908*/ GIMT_Encode4(298208), // Rule ID 6595 //
     /* 298079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 298082 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 298085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298089 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298093 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298097 */   // (mulhs:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } (SMULLv4i16_v4i32:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rm, dsub:{ *:[i32] })), (SMULLv8i16_v4i32:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))
     /* 298097 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 298100 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_v4i32),
     /* 298104 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298109 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 298113 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 298117 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 298119 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 298122 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298126 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298131 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 298137 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298142 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298147 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 298150 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298154 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298159 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 298165 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298170 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298175 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 298178 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_v4i32),
     /* 298182 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298187 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 298190 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 298193 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 298195 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 298198 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298200 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298203 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 298206 */   GIR_RootConstrainSelectedInstOperands,
     /* 298207 */   // GIR_Coverage, 6595,
     /* 298207 */   GIR_EraseRootFromParent_Done,
     /* 298208 */ // Label 5908: @298208
     /* 298208 */ GIM_Reject,
     /* 298209 */ // Label 5904: @298209
     /* 298209 */ GIM_Try, /*On fail goto*//*Label 5909*/ GIMT_Encode4(298343), // Rule ID 6594 //
     /* 298214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 298217 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 298220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298224 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298228 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298232 */   // (mulhs:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } (SMULLv8i8_v8i16:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rm, dsub:{ *:[i32] })), (SMULLv16i8_v8i16:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))
     /* 298232 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 298235 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv16i8_v8i16),
     /* 298239 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298244 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 298248 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 298252 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 298254 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 298257 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298261 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298266 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 298272 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298277 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298282 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 298285 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298289 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298294 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 298300 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298305 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298310 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 298313 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i8_v8i16),
     /* 298317 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298322 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 298325 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 298328 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 298330 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 298333 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298335 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298338 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 298341 */   GIR_RootConstrainSelectedInstOperands,
     /* 298342 */   // GIR_Coverage, 6594,
     /* 298342 */   GIR_EraseRootFromParent_Done,
     /* 298343 */ // Label 5909: @298343
     /* 298343 */ GIM_Reject,
     /* 298344 */ // Label 5905: @298344
     /* 298344 */ GIM_Reject,
     /* 298345 */ // Label 55: @298345
     /* 298345 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 5922*/ GIMT_Encode4(298816),
     /* 298356 */ /*GILLT_s64*//*Label 5910*/ GIMT_Encode4(298440), GIMT_Encode4(0),
     /* 298364 */ /*GILLT_v2s32*//*Label 5911*/ GIMT_Encode4(298474),
     /* 298368 */ /*GILLT_v2s64*//*Label 5912*/ GIMT_Encode4(298508),
     /* 298372 */ /*GILLT_v4s16*//*Label 5913*/ GIMT_Encode4(298542),
     /* 298376 */ /*GILLT_v4s32*//*Label 5914*/ GIMT_Encode4(298576),
     /* 298380 */ /*GILLT_v8s8*//*Label 5915*/ GIMT_Encode4(298610),
     /* 298384 */ /*GILLT_v8s16*//*Label 5916*/ GIMT_Encode4(298644),
     /* 298388 */ /*GILLT_v16s8*//*Label 5917*/ GIMT_Encode4(298678), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 298408 */ /*GILLT_nxv2s64*//*Label 5918*/ GIMT_Encode4(298712), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 298420 */ /*GILLT_nxv4s32*//*Label 5919*/ GIMT_Encode4(298738), GIMT_Encode4(0),
     /* 298428 */ /*GILLT_nxv8s16*//*Label 5920*/ GIMT_Encode4(298764), GIMT_Encode4(0),
     /* 298436 */ /*GILLT_nxv16s8*//*Label 5921*/ GIMT_Encode4(298790),
     /* 298440 */ // Label 5910: @298440
     /* 298440 */ GIM_Try, /*On fail goto*//*Label 5923*/ GIMT_Encode4(298473), // Rule ID 1645 //
     /* 298445 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 298451 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 298454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298458 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298462 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298466 */   // (uaddsat:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 298466 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i64),
     /* 298471 */   GIR_RootConstrainSelectedInstOperands,
     /* 298472 */   // GIR_Coverage, 1645,
     /* 298472 */   GIR_Done,
     /* 298473 */ // Label 5923: @298473
     /* 298473 */ GIM_Reject,
     /* 298474 */ // Label 5911: @298474
     /* 298474 */ GIM_Try, /*On fail goto*//*Label 5924*/ GIMT_Encode4(298507), // Rule ID 1543 //
     /* 298479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 298485 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 298488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298492 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298496 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298500 */   // (uaddsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 298500 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i32),
     /* 298505 */   GIR_RootConstrainSelectedInstOperands,
     /* 298506 */   // GIR_Coverage, 1543,
     /* 298506 */   GIR_Done,
     /* 298507 */ // Label 5924: @298507
     /* 298507 */ GIM_Reject,
     /* 298508 */ // Label 5912: @298508
     /* 298508 */ GIM_Try, /*On fail goto*//*Label 5925*/ GIMT_Encode4(298541), // Rule ID 1545 //
     /* 298513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298519 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 298522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298530 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298534 */   // (uaddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 298534 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i64),
     /* 298539 */   GIR_RootConstrainSelectedInstOperands,
     /* 298540 */   // GIR_Coverage, 1545,
     /* 298540 */   GIR_Done,
     /* 298541 */ // Label 5925: @298541
     /* 298541 */ GIM_Reject,
     /* 298542 */ // Label 5913: @298542
     /* 298542 */ GIM_Try, /*On fail goto*//*Label 5926*/ GIMT_Encode4(298575), // Rule ID 1541 //
     /* 298547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 298553 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 298556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298560 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298564 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298568 */   // (uaddsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 298568 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i16),
     /* 298573 */   GIR_RootConstrainSelectedInstOperands,
     /* 298574 */   // GIR_Coverage, 1541,
     /* 298574 */   GIR_Done,
     /* 298575 */ // Label 5926: @298575
     /* 298575 */ GIM_Reject,
     /* 298576 */ // Label 5914: @298576
     /* 298576 */ GIM_Try, /*On fail goto*//*Label 5927*/ GIMT_Encode4(298609), // Rule ID 1544 //
     /* 298581 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 298587 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 298590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298594 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298598 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298602 */   // (uaddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 298602 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i32),
     /* 298607 */   GIR_RootConstrainSelectedInstOperands,
     /* 298608 */   // GIR_Coverage, 1544,
     /* 298608 */   GIR_Done,
     /* 298609 */ // Label 5927: @298609
     /* 298609 */ GIM_Reject,
     /* 298610 */ // Label 5915: @298610
     /* 298610 */ GIM_Try, /*On fail goto*//*Label 5928*/ GIMT_Encode4(298643), // Rule ID 1539 //
     /* 298615 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 298621 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 298624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298628 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298632 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298636 */   // (uaddsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 298636 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i8),
     /* 298641 */   GIR_RootConstrainSelectedInstOperands,
     /* 298642 */   // GIR_Coverage, 1539,
     /* 298642 */   GIR_Done,
     /* 298643 */ // Label 5928: @298643
     /* 298643 */ GIM_Reject,
     /* 298644 */ // Label 5916: @298644
     /* 298644 */ GIM_Try, /*On fail goto*//*Label 5929*/ GIMT_Encode4(298677), // Rule ID 1542 //
     /* 298649 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 298655 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 298658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298662 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298666 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298670 */   // (uaddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 298670 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i16),
     /* 298675 */   GIR_RootConstrainSelectedInstOperands,
     /* 298676 */   // GIR_Coverage, 1542,
     /* 298676 */   GIR_Done,
     /* 298677 */ // Label 5929: @298677
     /* 298677 */ GIM_Reject,
     /* 298678 */ // Label 5917: @298678
     /* 298678 */ GIM_Try, /*On fail goto*//*Label 5930*/ GIMT_Encode4(298711), // Rule ID 1540 //
     /* 298683 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 298689 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 298692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298700 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298704 */   // (uaddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 298704 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv16i8),
     /* 298709 */   GIR_RootConstrainSelectedInstOperands,
     /* 298710 */   // GIR_Coverage, 1540,
     /* 298710 */   GIR_Done,
     /* 298711 */ // Label 5930: @298711
     /* 298711 */ GIM_Reject,
     /* 298712 */ // Label 5918: @298712
     /* 298712 */ GIM_Try, /*On fail goto*//*Label 5931*/ GIMT_Encode4(298737), // Rule ID 7537 //
     /* 298717 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 298720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 298723 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 298726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 298730 */   // (uaddsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 298730 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_D),
     /* 298735 */   GIR_RootConstrainSelectedInstOperands,
     /* 298736 */   // GIR_Coverage, 7537,
     /* 298736 */   GIR_Done,
     /* 298737 */ // Label 5931: @298737
     /* 298737 */ GIM_Reject,
     /* 298738 */ // Label 5919: @298738
     /* 298738 */ GIM_Try, /*On fail goto*//*Label 5932*/ GIMT_Encode4(298763), // Rule ID 7536 //
     /* 298743 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 298746 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 298749 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 298752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 298756 */   // (uaddsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 298756 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_S),
     /* 298761 */   GIR_RootConstrainSelectedInstOperands,
     /* 298762 */   // GIR_Coverage, 7536,
     /* 298762 */   GIR_Done,
     /* 298763 */ // Label 5932: @298763
     /* 298763 */ GIM_Reject,
     /* 298764 */ // Label 5920: @298764
     /* 298764 */ GIM_Try, /*On fail goto*//*Label 5933*/ GIMT_Encode4(298789), // Rule ID 7535 //
     /* 298769 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 298772 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 298775 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 298778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 298782 */   // (uaddsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 298782 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_H),
     /* 298787 */   GIR_RootConstrainSelectedInstOperands,
     /* 298788 */   // GIR_Coverage, 7535,
     /* 298788 */   GIR_Done,
     /* 298789 */ // Label 5933: @298789
     /* 298789 */ GIM_Reject,
     /* 298790 */ // Label 5921: @298790
     /* 298790 */ GIM_Try, /*On fail goto*//*Label 5934*/ GIMT_Encode4(298815), // Rule ID 7534 //
     /* 298795 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 298798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 298801 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 298804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 298808 */   // (uaddsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UQADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 298808 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_B),
     /* 298813 */   GIR_RootConstrainSelectedInstOperands,
     /* 298814 */   // GIR_Coverage, 7534,
     /* 298814 */   GIR_Done,
     /* 298815 */ // Label 5934: @298815
     /* 298815 */ GIM_Reject,
     /* 298816 */ // Label 5922: @298816
     /* 298816 */ GIM_Reject,
     /* 298817 */ // Label 56: @298817
     /* 298817 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 5947*/ GIMT_Encode4(301192),
     /* 298828 */ /*GILLT_s64*//*Label 5935*/ GIMT_Encode4(298912), GIMT_Encode4(0),
     /* 298836 */ /*GILLT_v2s32*//*Label 5936*/ GIMT_Encode4(298946),
     /* 298840 */ /*GILLT_v2s64*//*Label 5937*/ GIMT_Encode4(298980),
     /* 298844 */ /*GILLT_v4s16*//*Label 5938*/ GIMT_Encode4(299966),
     /* 298848 */ /*GILLT_v4s32*//*Label 5939*/ GIMT_Encode4(300000),
     /* 298852 */ /*GILLT_v8s8*//*Label 5940*/ GIMT_Encode4(300986),
     /* 298856 */ /*GILLT_v8s16*//*Label 5941*/ GIMT_Encode4(301020),
     /* 298860 */ /*GILLT_v16s8*//*Label 5942*/ GIMT_Encode4(301054), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 298880 */ /*GILLT_nxv2s64*//*Label 5943*/ GIMT_Encode4(301088), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 298892 */ /*GILLT_nxv4s32*//*Label 5944*/ GIMT_Encode4(301114), GIMT_Encode4(0),
     /* 298900 */ /*GILLT_nxv8s16*//*Label 5945*/ GIMT_Encode4(301140), GIMT_Encode4(0),
     /* 298908 */ /*GILLT_nxv16s8*//*Label 5946*/ GIMT_Encode4(301166),
     /* 298912 */ // Label 5935: @298912
     /* 298912 */ GIM_Try, /*On fail goto*//*Label 5948*/ GIMT_Encode4(298945), // Rule ID 1636 //
     /* 298917 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 298923 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 298926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298934 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298938 */   // (saddsat:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 298938 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i64),
     /* 298943 */   GIR_RootConstrainSelectedInstOperands,
     /* 298944 */   // GIR_Coverage, 1636,
     /* 298944 */   GIR_Done,
     /* 298945 */ // Label 5948: @298945
     /* 298945 */ GIM_Reject,
     /* 298946 */ // Label 5936: @298946
     /* 298946 */ GIM_Try, /*On fail goto*//*Label 5949*/ GIMT_Encode4(298979), // Rule ID 1420 //
     /* 298951 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 298957 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 298960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298964 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298968 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298972 */   // (saddsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 298972 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i32),
     /* 298977 */   GIR_RootConstrainSelectedInstOperands,
     /* 298978 */   // GIR_Coverage, 1420,
     /* 298978 */   GIR_Done,
     /* 298979 */ // Label 5949: @298979
     /* 298979 */ GIM_Reject,
     /* 298980 */ // Label 5937: @298980
     /* 298980 */ GIM_Try, /*On fail goto*//*Label 5950*/ GIMT_Encode4(299965),
     /* 298985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298988 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 298991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298995 */   GIM_Try, /*On fail goto*//*Label 5951*/ GIMT_Encode4(299117), // Rule ID 13652 //
     /* 299000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 299011 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 299014 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 299019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 299023 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 299027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 299031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 299035 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299039 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 299043 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299047 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299051 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 299055 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299060 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 299064 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299068 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299072 */     // MIs[4] Operand 1
     /* 299072 */     // No operand predicates
     /* 299072 */     // MIs[2] Operand 2
     /* 299072 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 299083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299087 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 299089 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 299096 */     // (saddsat:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SQDMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 299096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_indexed),
     /* 299099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 299103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 299108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 299112 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 299115 */     GIR_RootConstrainSelectedInstOperands,
     /* 299116 */     // GIR_Coverage, 13652,
     /* 299116 */     GIR_EraseRootFromParent_Done,
     /* 299117 */   // Label 5951: @299117
     /* 299117 */   GIM_Try, /*On fail goto*//*Label 5952*/ GIMT_Encode4(299239), // Rule ID 2060 //
     /* 299122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 299137 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 299140 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 299145 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 299149 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 299153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 299157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 299161 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299165 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 299169 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299173 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299177 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 299181 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299186 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 299190 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299194 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299198 */     // MIs[4] Operand 1
     /* 299198 */     // No operand predicates
     /* 299198 */     // MIs[2] Operand 2
     /* 299198 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 299209 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 299211 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 299218 */     // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SQDMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 299218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_indexed),
     /* 299221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299223 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 299225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 299230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 299234 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 299237 */     GIR_RootConstrainSelectedInstOperands,
     /* 299238 */     // GIR_Coverage, 2060,
     /* 299238 */     GIR_EraseRootFromParent_Done,
     /* 299239 */   // Label 5952: @299239
     /* 299239 */   GIM_Try, /*On fail goto*//*Label 5953*/ GIMT_Encode4(299358), // Rule ID 13650 //
     /* 299244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 299255 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 299258 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 299263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 299267 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 299271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 299280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 299284 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299288 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 299292 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299296 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299300 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 299304 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299309 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 299313 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299317 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299321 */     // MIs[4] Operand 1
     /* 299321 */     // No operand predicates
     /* 299321 */     // MIs[2] Operand 2
     /* 299321 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 299332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299336 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 299338 */     // (saddsat:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 299338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 299341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 299345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 299349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 299353 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 299356 */     GIR_RootConstrainSelectedInstOperands,
     /* 299357 */     // GIR_Coverage, 13650,
     /* 299357 */     GIR_EraseRootFromParent_Done,
     /* 299358 */   // Label 5953: @299358
     /* 299358 */   GIM_Try, /*On fail goto*//*Label 5954*/ GIMT_Encode4(299477), // Rule ID 2058 //
     /* 299363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 299378 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 299381 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 299386 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 299390 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 299394 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299399 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 299403 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 299407 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299411 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 299415 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299419 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299423 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 299427 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299432 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 299436 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299440 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299444 */     // MIs[4] Operand 1
     /* 299444 */     // No operand predicates
     /* 299444 */     // MIs[2] Operand 2
     /* 299444 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 299455 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 299457 */     // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 299457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 299460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299462 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 299464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 299468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 299472 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 299475 */     GIR_RootConstrainSelectedInstOperands,
     /* 299476 */     // GIR_Coverage, 2058,
     /* 299476 */     GIR_EraseRootFromParent_Done,
     /* 299477 */   // Label 5954: @299477
     /* 299477 */   GIM_Try, /*On fail goto*//*Label 5955*/ GIMT_Encode4(299548), // Rule ID 13550 //
     /* 299482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 299493 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 299496 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 299501 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 299505 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 299509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299515 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 299522 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 299529 */     // (saddsat:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (SQDMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 299529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_v2i64),
     /* 299532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 299536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 299541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 299546 */     GIR_RootConstrainSelectedInstOperands,
     /* 299547 */     // GIR_Coverage, 13550,
     /* 299547 */     GIR_EraseRootFromParent_Done,
     /* 299548 */   // Label 5955: @299548
     /* 299548 */   GIM_Try, /*On fail goto*//*Label 5956*/ GIMT_Encode4(299619), // Rule ID 1745 //
     /* 299553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 299568 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 299571 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 299576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 299580 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 299584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299586 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 299593 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 299600 */     // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SQDMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 299600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_v2i64),
     /* 299603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299605 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 299607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 299612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 299617 */     GIR_RootConstrainSelectedInstOperands,
     /* 299618 */     // GIR_Coverage, 1745,
     /* 299618 */     GIR_EraseRootFromParent_Done,
     /* 299619 */   // Label 5956: @299619
     /* 299619 */   GIM_Try, /*On fail goto*//*Label 5957*/ GIMT_Encode4(299715), // Rule ID 13651 //
     /* 299624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 299635 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 299638 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 299643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 299647 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 299651 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 299660 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299664 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299668 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 299672 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299677 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 299681 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299685 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299689 */     // MIs[3] Operand 1
     /* 299689 */     // No operand predicates
     /* 299689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299693 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299695 */     // (saddsat:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v2i64] }:$Rd)  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 299695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 299698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 299702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 299706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 299710 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 299713 */     GIR_RootConstrainSelectedInstOperands,
     /* 299714 */     // GIR_Coverage, 13651,
     /* 299714 */     GIR_EraseRootFromParent_Done,
     /* 299715 */   // Label 5957: @299715
     /* 299715 */   GIM_Try, /*On fail goto*//*Label 5958*/ GIMT_Encode4(299811), // Rule ID 2059 //
     /* 299720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 299735 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 299738 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 299743 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 299747 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 299751 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 299760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299764 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299768 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 299772 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299777 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 299781 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299785 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299789 */     // MIs[3] Operand 1
     /* 299789 */     // No operand predicates
     /* 299789 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299791 */     // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 299791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 299794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299796 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 299798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 299802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 299806 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 299809 */     GIR_RootConstrainSelectedInstOperands,
     /* 299810 */     // GIR_Coverage, 2059,
     /* 299810 */     GIR_EraseRootFromParent_Done,
     /* 299811 */   // Label 5958: @299811
     /* 299811 */   GIM_Try, /*On fail goto*//*Label 5959*/ GIMT_Encode4(299876), // Rule ID 13549 //
     /* 299816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 299827 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 299830 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 299835 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 299839 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 299843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299859 */     // (saddsat:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rd)  =>  (SQDMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 299859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_v2i64),
     /* 299862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 299866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 299870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 299874 */     GIR_RootConstrainSelectedInstOperands,
     /* 299875 */     // GIR_Coverage, 13549,
     /* 299875 */     GIR_EraseRootFromParent_Done,
     /* 299876 */   // Label 5959: @299876
     /* 299876 */   GIM_Try, /*On fail goto*//*Label 5960*/ GIMT_Encode4(299941), // Rule ID 1744 //
     /* 299881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 299896 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 299899 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 299904 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 299908 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 299912 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299917 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299924 */     // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SQDMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 299924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_v2i64),
     /* 299927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299929 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 299931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 299935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 299939 */     GIR_RootConstrainSelectedInstOperands,
     /* 299940 */     // GIR_Coverage, 1744,
     /* 299940 */     GIR_EraseRootFromParent_Done,
     /* 299941 */   // Label 5960: @299941
     /* 299941 */   GIM_Try, /*On fail goto*//*Label 5961*/ GIMT_Encode4(299964), // Rule ID 1422 //
     /* 299946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299957 */     // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 299957 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i64),
     /* 299962 */     GIR_RootConstrainSelectedInstOperands,
     /* 299963 */     // GIR_Coverage, 1422,
     /* 299963 */     GIR_Done,
     /* 299964 */   // Label 5961: @299964
     /* 299964 */   GIM_Reject,
     /* 299965 */ // Label 5950: @299965
     /* 299965 */ GIM_Reject,
     /* 299966 */ // Label 5938: @299966
     /* 299966 */ GIM_Try, /*On fail goto*//*Label 5962*/ GIMT_Encode4(299999), // Rule ID 1418 //
     /* 299971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 299977 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 299980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299988 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299992 */   // (saddsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 299992 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i16),
     /* 299997 */   GIR_RootConstrainSelectedInstOperands,
     /* 299998 */   // GIR_Coverage, 1418,
     /* 299998 */   GIR_Done,
     /* 299999 */ // Label 5962: @299999
     /* 299999 */ GIM_Reject,
     /* 300000 */ // Label 5939: @300000
     /* 300000 */ GIM_Try, /*On fail goto*//*Label 5963*/ GIMT_Encode4(300985),
     /* 300005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300008 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 300011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300015 */   GIM_Try, /*On fail goto*//*Label 5964*/ GIMT_Encode4(300137), // Rule ID 13649 //
     /* 300020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300031 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300034 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300039 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 300043 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 300047 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 300051 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 300055 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300059 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 300063 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 300067 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300071 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 300075 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 300080 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 300084 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300088 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 300092 */     // MIs[4] Operand 1
     /* 300092 */     // No operand predicates
     /* 300092 */     // MIs[2] Operand 2
     /* 300092 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 300103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300107 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 300109 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 300116 */     // (saddsat:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SQDMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 300116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_indexed),
     /* 300119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 300123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 300128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 300132 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 300135 */     GIR_RootConstrainSelectedInstOperands,
     /* 300136 */     // GIR_Coverage, 13649,
     /* 300136 */     GIR_EraseRootFromParent_Done,
     /* 300137 */   // Label 5964: @300137
     /* 300137 */   GIM_Try, /*On fail goto*//*Label 5965*/ GIMT_Encode4(300259), // Rule ID 2057 //
     /* 300142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300157 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300160 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300165 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 300169 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 300173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 300177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 300181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300185 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 300189 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 300193 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300197 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 300201 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 300206 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 300210 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300214 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 300218 */     // MIs[4] Operand 1
     /* 300218 */     // No operand predicates
     /* 300218 */     // MIs[2] Operand 2
     /* 300218 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 300229 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 300231 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 300238 */     // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SQDMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 300238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_indexed),
     /* 300241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300243 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 300245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 300250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 300254 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 300257 */     GIR_RootConstrainSelectedInstOperands,
     /* 300258 */     // GIR_Coverage, 2057,
     /* 300258 */     GIR_EraseRootFromParent_Done,
     /* 300259 */   // Label 5965: @300259
     /* 300259 */   GIM_Try, /*On fail goto*//*Label 5966*/ GIMT_Encode4(300378), // Rule ID 13647 //
     /* 300264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300275 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300278 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300283 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 300287 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 300291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300296 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 300300 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 300304 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300308 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 300312 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 300316 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300320 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 300324 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 300329 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 300333 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300337 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 300341 */     // MIs[4] Operand 1
     /* 300341 */     // No operand predicates
     /* 300341 */     // MIs[2] Operand 2
     /* 300341 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 300352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300356 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 300358 */     // (saddsat:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 300358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 300361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 300365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 300369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 300373 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 300376 */     GIR_RootConstrainSelectedInstOperands,
     /* 300377 */     // GIR_Coverage, 13647,
     /* 300377 */     GIR_EraseRootFromParent_Done,
     /* 300378 */   // Label 5966: @300378
     /* 300378 */   GIM_Try, /*On fail goto*//*Label 5967*/ GIMT_Encode4(300497), // Rule ID 2055 //
     /* 300383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300398 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300401 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300406 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 300410 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 300414 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300419 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 300423 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 300427 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300431 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 300435 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 300439 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300443 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 300447 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 300452 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 300456 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300460 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 300464 */     // MIs[4] Operand 1
     /* 300464 */     // No operand predicates
     /* 300464 */     // MIs[2] Operand 2
     /* 300464 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 300475 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 300477 */     // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 300477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 300480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300482 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 300484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 300488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 300492 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 300495 */     GIR_RootConstrainSelectedInstOperands,
     /* 300496 */     // GIR_Coverage, 2055,
     /* 300496 */     GIR_EraseRootFromParent_Done,
     /* 300497 */   // Label 5967: @300497
     /* 300497 */   GIM_Try, /*On fail goto*//*Label 5968*/ GIMT_Encode4(300568), // Rule ID 13548 //
     /* 300502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300513 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300516 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300521 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 300525 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 300529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300535 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 300542 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 300549 */     // (saddsat:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (SQDMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 300549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_v4i32),
     /* 300552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 300556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 300561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 300566 */     GIR_RootConstrainSelectedInstOperands,
     /* 300567 */     // GIR_Coverage, 13548,
     /* 300567 */     GIR_EraseRootFromParent_Done,
     /* 300568 */   // Label 5968: @300568
     /* 300568 */   GIM_Try, /*On fail goto*//*Label 5969*/ GIMT_Encode4(300639), // Rule ID 1743 //
     /* 300573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300588 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300591 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300596 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 300600 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 300604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300606 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 300613 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 300620 */     // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SQDMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 300620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_v4i32),
     /* 300623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300625 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 300627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 300632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 300637 */     GIR_RootConstrainSelectedInstOperands,
     /* 300638 */     // GIR_Coverage, 1743,
     /* 300638 */     GIR_EraseRootFromParent_Done,
     /* 300639 */   // Label 5969: @300639
     /* 300639 */   GIM_Try, /*On fail goto*//*Label 5970*/ GIMT_Encode4(300735), // Rule ID 13648 //
     /* 300644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300655 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300658 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300663 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 300667 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 300671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300676 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 300680 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 300684 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300688 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 300692 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 300697 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 300701 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300705 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 300709 */     // MIs[3] Operand 1
     /* 300709 */     // No operand predicates
     /* 300709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300713 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 300715 */     // (saddsat:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v4i32] }:$Rd)  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 300715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 300718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 300722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 300726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300730 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 300733 */     GIR_RootConstrainSelectedInstOperands,
     /* 300734 */     // GIR_Coverage, 13648,
     /* 300734 */     GIR_EraseRootFromParent_Done,
     /* 300735 */   // Label 5970: @300735
     /* 300735 */   GIM_Try, /*On fail goto*//*Label 5971*/ GIMT_Encode4(300831), // Rule ID 2056 //
     /* 300740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300755 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300758 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300763 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 300767 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 300771 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300776 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 300780 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 300784 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300788 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 300792 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 300797 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 300801 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300805 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 300809 */     // MIs[3] Operand 1
     /* 300809 */     // No operand predicates
     /* 300809 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 300811 */     // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 300811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 300814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300816 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 300818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 300822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300826 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 300829 */     GIR_RootConstrainSelectedInstOperands,
     /* 300830 */     // GIR_Coverage, 2056,
     /* 300830 */     GIR_EraseRootFromParent_Done,
     /* 300831 */   // Label 5971: @300831
     /* 300831 */   GIM_Try, /*On fail goto*//*Label 5972*/ GIMT_Encode4(300896), // Rule ID 13547 //
     /* 300836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300847 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300850 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 300859 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 300863 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300879 */     // (saddsat:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (SQDMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 300879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_v4i32),
     /* 300882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 300886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 300890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 300894 */     GIR_RootConstrainSelectedInstOperands,
     /* 300895 */     // GIR_Coverage, 13547,
     /* 300895 */     GIR_EraseRootFromParent_Done,
     /* 300896 */   // Label 5972: @300896
     /* 300896 */   GIM_Try, /*On fail goto*//*Label 5973*/ GIMT_Encode4(300961), // Rule ID 1742 //
     /* 300901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300904 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300916 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300919 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 300928 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 300932 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300942 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300944 */     // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SQDMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 300944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_v4i32),
     /* 300947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300949 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 300951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 300955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 300959 */     GIR_RootConstrainSelectedInstOperands,
     /* 300960 */     // GIR_Coverage, 1742,
     /* 300960 */     GIR_EraseRootFromParent_Done,
     /* 300961 */   // Label 5973: @300961
     /* 300961 */   GIM_Try, /*On fail goto*//*Label 5974*/ GIMT_Encode4(300984), // Rule ID 1421 //
     /* 300966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300977 */     // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 300977 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i32),
     /* 300982 */     GIR_RootConstrainSelectedInstOperands,
     /* 300983 */     // GIR_Coverage, 1421,
     /* 300983 */     GIR_Done,
     /* 300984 */   // Label 5974: @300984
     /* 300984 */   GIM_Reject,
     /* 300985 */ // Label 5963: @300985
     /* 300985 */ GIM_Reject,
     /* 300986 */ // Label 5940: @300986
     /* 300986 */ GIM_Try, /*On fail goto*//*Label 5975*/ GIMT_Encode4(301019), // Rule ID 1416 //
     /* 300991 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 300997 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 301000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301004 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301008 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301012 */   // (saddsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 301012 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i8),
     /* 301017 */   GIR_RootConstrainSelectedInstOperands,
     /* 301018 */   // GIR_Coverage, 1416,
     /* 301018 */   GIR_Done,
     /* 301019 */ // Label 5975: @301019
     /* 301019 */ GIM_Reject,
     /* 301020 */ // Label 5941: @301020
     /* 301020 */ GIM_Try, /*On fail goto*//*Label 5976*/ GIMT_Encode4(301053), // Rule ID 1419 //
     /* 301025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 301031 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 301034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301038 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301042 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301046 */   // (saddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 301046 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i16),
     /* 301051 */   GIR_RootConstrainSelectedInstOperands,
     /* 301052 */   // GIR_Coverage, 1419,
     /* 301052 */   GIR_Done,
     /* 301053 */ // Label 5976: @301053
     /* 301053 */ GIM_Reject,
     /* 301054 */ // Label 5942: @301054
     /* 301054 */ GIM_Try, /*On fail goto*//*Label 5977*/ GIMT_Encode4(301087), // Rule ID 1417 //
     /* 301059 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 301065 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 301068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301072 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301076 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301080 */   // (saddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 301080 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv16i8),
     /* 301085 */   GIR_RootConstrainSelectedInstOperands,
     /* 301086 */   // GIR_Coverage, 1417,
     /* 301086 */   GIR_Done,
     /* 301087 */ // Label 5977: @301087
     /* 301087 */ GIM_Reject,
     /* 301088 */ // Label 5943: @301088
     /* 301088 */ GIM_Try, /*On fail goto*//*Label 5978*/ GIMT_Encode4(301113), // Rule ID 7533 //
     /* 301093 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 301099 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 301102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301106 */   // (saddsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 301106 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_D),
     /* 301111 */   GIR_RootConstrainSelectedInstOperands,
     /* 301112 */   // GIR_Coverage, 7533,
     /* 301112 */   GIR_Done,
     /* 301113 */ // Label 5978: @301113
     /* 301113 */ GIM_Reject,
     /* 301114 */ // Label 5944: @301114
     /* 301114 */ GIM_Try, /*On fail goto*//*Label 5979*/ GIMT_Encode4(301139), // Rule ID 7532 //
     /* 301119 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 301125 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 301128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301132 */   // (saddsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 301132 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_S),
     /* 301137 */   GIR_RootConstrainSelectedInstOperands,
     /* 301138 */   // GIR_Coverage, 7532,
     /* 301138 */   GIR_Done,
     /* 301139 */ // Label 5979: @301139
     /* 301139 */ GIM_Reject,
     /* 301140 */ // Label 5945: @301140
     /* 301140 */ GIM_Try, /*On fail goto*//*Label 5980*/ GIMT_Encode4(301165), // Rule ID 7531 //
     /* 301145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 301151 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 301154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301158 */   // (saddsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 301158 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_H),
     /* 301163 */   GIR_RootConstrainSelectedInstOperands,
     /* 301164 */   // GIR_Coverage, 7531,
     /* 301164 */   GIR_Done,
     /* 301165 */ // Label 5980: @301165
     /* 301165 */ GIM_Reject,
     /* 301166 */ // Label 5946: @301166
     /* 301166 */ GIM_Try, /*On fail goto*//*Label 5981*/ GIMT_Encode4(301191), // Rule ID 7530 //
     /* 301171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 301177 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 301180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301184 */   // (saddsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 301184 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_B),
     /* 301189 */   GIR_RootConstrainSelectedInstOperands,
     /* 301190 */   // GIR_Coverage, 7530,
     /* 301190 */   GIR_Done,
     /* 301191 */ // Label 5981: @301191
     /* 301191 */ GIM_Reject,
     /* 301192 */ // Label 5947: @301192
     /* 301192 */ GIM_Reject,
     /* 301193 */ // Label 57: @301193
     /* 301193 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 5994*/ GIMT_Encode4(301664),
     /* 301204 */ /*GILLT_s64*//*Label 5982*/ GIMT_Encode4(301288), GIMT_Encode4(0),
     /* 301212 */ /*GILLT_v2s32*//*Label 5983*/ GIMT_Encode4(301322),
     /* 301216 */ /*GILLT_v2s64*//*Label 5984*/ GIMT_Encode4(301356),
     /* 301220 */ /*GILLT_v4s16*//*Label 5985*/ GIMT_Encode4(301390),
     /* 301224 */ /*GILLT_v4s32*//*Label 5986*/ GIMT_Encode4(301424),
     /* 301228 */ /*GILLT_v8s8*//*Label 5987*/ GIMT_Encode4(301458),
     /* 301232 */ /*GILLT_v8s16*//*Label 5988*/ GIMT_Encode4(301492),
     /* 301236 */ /*GILLT_v16s8*//*Label 5989*/ GIMT_Encode4(301526), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 301256 */ /*GILLT_nxv2s64*//*Label 5990*/ GIMT_Encode4(301560), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 301268 */ /*GILLT_nxv4s32*//*Label 5991*/ GIMT_Encode4(301586), GIMT_Encode4(0),
     /* 301276 */ /*GILLT_nxv8s16*//*Label 5992*/ GIMT_Encode4(301612), GIMT_Encode4(0),
     /* 301284 */ /*GILLT_nxv16s8*//*Label 5993*/ GIMT_Encode4(301638),
     /* 301288 */ // Label 5982: @301288
     /* 301288 */ GIM_Try, /*On fail goto*//*Label 5995*/ GIMT_Encode4(301321), // Rule ID 1648 //
     /* 301293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 301299 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 301302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301306 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301310 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301314 */   // (usubsat:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQSUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 301314 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i64),
     /* 301319 */   GIR_RootConstrainSelectedInstOperands,
     /* 301320 */   // GIR_Coverage, 1648,
     /* 301320 */   GIR_Done,
     /* 301321 */ // Label 5995: @301321
     /* 301321 */ GIM_Reject,
     /* 301322 */ // Label 5983: @301322
     /* 301322 */ GIM_Try, /*On fail goto*//*Label 5996*/ GIMT_Encode4(301355), // Rule ID 1564 //
     /* 301327 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301330 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 301333 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 301336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301340 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301344 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301348 */   // (usubsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 301348 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i32),
     /* 301353 */   GIR_RootConstrainSelectedInstOperands,
     /* 301354 */   // GIR_Coverage, 1564,
     /* 301354 */   GIR_Done,
     /* 301355 */ // Label 5996: @301355
     /* 301355 */ GIM_Reject,
     /* 301356 */ // Label 5984: @301356
     /* 301356 */ GIM_Try, /*On fail goto*//*Label 5997*/ GIMT_Encode4(301389), // Rule ID 1566 //
     /* 301361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301367 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 301370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301374 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301378 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301382 */   // (usubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 301382 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i64),
     /* 301387 */   GIR_RootConstrainSelectedInstOperands,
     /* 301388 */   // GIR_Coverage, 1566,
     /* 301388 */   GIR_Done,
     /* 301389 */ // Label 5997: @301389
     /* 301389 */ GIM_Reject,
     /* 301390 */ // Label 5985: @301390
     /* 301390 */ GIM_Try, /*On fail goto*//*Label 5998*/ GIMT_Encode4(301423), // Rule ID 1562 //
     /* 301395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 301401 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 301404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301412 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301416 */   // (usubsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 301416 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i16),
     /* 301421 */   GIR_RootConstrainSelectedInstOperands,
     /* 301422 */   // GIR_Coverage, 1562,
     /* 301422 */   GIR_Done,
     /* 301423 */ // Label 5998: @301423
     /* 301423 */ GIM_Reject,
     /* 301424 */ // Label 5986: @301424
     /* 301424 */ GIM_Try, /*On fail goto*//*Label 5999*/ GIMT_Encode4(301457), // Rule ID 1565 //
     /* 301429 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 301435 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 301438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301442 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301446 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301450 */   // (usubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 301450 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i32),
     /* 301455 */   GIR_RootConstrainSelectedInstOperands,
     /* 301456 */   // GIR_Coverage, 1565,
     /* 301456 */   GIR_Done,
     /* 301457 */ // Label 5999: @301457
     /* 301457 */ GIM_Reject,
     /* 301458 */ // Label 5987: @301458
     /* 301458 */ GIM_Try, /*On fail goto*//*Label 6000*/ GIMT_Encode4(301491), // Rule ID 1560 //
     /* 301463 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 301469 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 301472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301476 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301480 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301484 */   // (usubsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 301484 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i8),
     /* 301489 */   GIR_RootConstrainSelectedInstOperands,
     /* 301490 */   // GIR_Coverage, 1560,
     /* 301490 */   GIR_Done,
     /* 301491 */ // Label 6000: @301491
     /* 301491 */ GIM_Reject,
     /* 301492 */ // Label 5988: @301492
     /* 301492 */ GIM_Try, /*On fail goto*//*Label 6001*/ GIMT_Encode4(301525), // Rule ID 1563 //
     /* 301497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 301503 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 301506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301510 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301514 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301518 */   // (usubsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 301518 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i16),
     /* 301523 */   GIR_RootConstrainSelectedInstOperands,
     /* 301524 */   // GIR_Coverage, 1563,
     /* 301524 */   GIR_Done,
     /* 301525 */ // Label 6001: @301525
     /* 301525 */ GIM_Reject,
     /* 301526 */ // Label 5989: @301526
     /* 301526 */ GIM_Try, /*On fail goto*//*Label 6002*/ GIMT_Encode4(301559), // Rule ID 1561 //
     /* 301531 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 301537 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 301540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301544 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301548 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301552 */   // (usubsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 301552 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv16i8),
     /* 301557 */   GIR_RootConstrainSelectedInstOperands,
     /* 301558 */   // GIR_Coverage, 1561,
     /* 301558 */   GIR_Done,
     /* 301559 */ // Label 6002: @301559
     /* 301559 */ GIM_Reject,
     /* 301560 */ // Label 5990: @301560
     /* 301560 */ GIM_Try, /*On fail goto*//*Label 6003*/ GIMT_Encode4(301585), // Rule ID 7545 //
     /* 301565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 301571 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 301574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301578 */   // (usubsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQSUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 301578 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_D),
     /* 301583 */   GIR_RootConstrainSelectedInstOperands,
     /* 301584 */   // GIR_Coverage, 7545,
     /* 301584 */   GIR_Done,
     /* 301585 */ // Label 6003: @301585
     /* 301585 */ GIM_Reject,
     /* 301586 */ // Label 5991: @301586
     /* 301586 */ GIM_Try, /*On fail goto*//*Label 6004*/ GIMT_Encode4(301611), // Rule ID 7544 //
     /* 301591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 301597 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 301600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301604 */   // (usubsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQSUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 301604 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_S),
     /* 301609 */   GIR_RootConstrainSelectedInstOperands,
     /* 301610 */   // GIR_Coverage, 7544,
     /* 301610 */   GIR_Done,
     /* 301611 */ // Label 6004: @301611
     /* 301611 */ GIM_Reject,
     /* 301612 */ // Label 5992: @301612
     /* 301612 */ GIM_Try, /*On fail goto*//*Label 6005*/ GIMT_Encode4(301637), // Rule ID 7543 //
     /* 301617 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 301623 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 301626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301630 */   // (usubsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQSUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 301630 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_H),
     /* 301635 */   GIR_RootConstrainSelectedInstOperands,
     /* 301636 */   // GIR_Coverage, 7543,
     /* 301636 */   GIR_Done,
     /* 301637 */ // Label 6005: @301637
     /* 301637 */ GIM_Reject,
     /* 301638 */ // Label 5993: @301638
     /* 301638 */ GIM_Try, /*On fail goto*//*Label 6006*/ GIMT_Encode4(301663), // Rule ID 7542 //
     /* 301643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 301649 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 301652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301656 */   // (usubsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UQSUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 301656 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_B),
     /* 301661 */   GIR_RootConstrainSelectedInstOperands,
     /* 301662 */   // GIR_Coverage, 7542,
     /* 301662 */   GIR_Done,
     /* 301663 */ // Label 6006: @301663
     /* 301663 */ GIM_Reject,
     /* 301664 */ // Label 5994: @301664
     /* 301664 */ GIM_Reject,
     /* 301665 */ // Label 58: @301665
     /* 301665 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 6019*/ GIMT_Encode4(303054),
     /* 301676 */ /*GILLT_s64*//*Label 6007*/ GIMT_Encode4(301760), GIMT_Encode4(0),
     /* 301684 */ /*GILLT_v2s32*//*Label 6008*/ GIMT_Encode4(301794),
     /* 301688 */ /*GILLT_v2s64*//*Label 6009*/ GIMT_Encode4(301828),
     /* 301692 */ /*GILLT_v4s16*//*Label 6010*/ GIMT_Encode4(302321),
     /* 301696 */ /*GILLT_v4s32*//*Label 6011*/ GIMT_Encode4(302355),
     /* 301700 */ /*GILLT_v8s8*//*Label 6012*/ GIMT_Encode4(302848),
     /* 301704 */ /*GILLT_v8s16*//*Label 6013*/ GIMT_Encode4(302882),
     /* 301708 */ /*GILLT_v16s8*//*Label 6014*/ GIMT_Encode4(302916), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 301728 */ /*GILLT_nxv2s64*//*Label 6015*/ GIMT_Encode4(302950), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 301740 */ /*GILLT_nxv4s32*//*Label 6016*/ GIMT_Encode4(302976), GIMT_Encode4(0),
     /* 301748 */ /*GILLT_nxv8s16*//*Label 6017*/ GIMT_Encode4(303002), GIMT_Encode4(0),
     /* 301756 */ /*GILLT_nxv16s8*//*Label 6018*/ GIMT_Encode4(303028),
     /* 301760 */ // Label 6007: @301760
     /* 301760 */ GIM_Try, /*On fail goto*//*Label 6020*/ GIMT_Encode4(301793), // Rule ID 1641 //
     /* 301765 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 301771 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 301774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301778 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301782 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301786 */   // (ssubsat:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQSUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 301786 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i64),
     /* 301791 */   GIR_RootConstrainSelectedInstOperands,
     /* 301792 */   // GIR_Coverage, 1641,
     /* 301792 */   GIR_Done,
     /* 301793 */ // Label 6020: @301793
     /* 301793 */ GIM_Reject,
     /* 301794 */ // Label 6008: @301794
     /* 301794 */ GIM_Try, /*On fail goto*//*Label 6021*/ GIMT_Encode4(301827), // Rule ID 1449 //
     /* 301799 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 301805 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 301808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301812 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301816 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301820 */   // (ssubsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 301820 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i32),
     /* 301825 */   GIR_RootConstrainSelectedInstOperands,
     /* 301826 */   // GIR_Coverage, 1449,
     /* 301826 */   GIR_Done,
     /* 301827 */ // Label 6021: @301827
     /* 301827 */ GIM_Reject,
     /* 301828 */ // Label 6009: @301828
     /* 301828 */ GIM_Try, /*On fail goto*//*Label 6022*/ GIMT_Encode4(302320),
     /* 301833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301836 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 301839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301843 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301847 */   GIM_Try, /*On fail goto*//*Label 6023*/ GIMT_Encode4(301965), // Rule ID 2067 //
     /* 301852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 301859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 301863 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 301866 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 301871 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 301875 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 301879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 301883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 301887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 301891 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 301895 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 301899 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 301903 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 301907 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301912 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 301916 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 301920 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 301924 */     // MIs[4] Operand 1
     /* 301924 */     // No operand predicates
     /* 301924 */     // MIs[2] Operand 2
     /* 301924 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 301935 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 301937 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 301944 */     // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SQDMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 301944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i32_indexed),
     /* 301947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301949 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 301951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 301956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 301960 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 301963 */     GIR_RootConstrainSelectedInstOperands,
     /* 301964 */     // GIR_Coverage, 2067,
     /* 301964 */     GIR_EraseRootFromParent_Done,
     /* 301965 */   // Label 6023: @301965
     /* 301965 */   GIM_Try, /*On fail goto*//*Label 6024*/ GIMT_Encode4(302080), // Rule ID 2065 //
     /* 301970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 301977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 301981 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 301984 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 301989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 301993 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 301997 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 302006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 302010 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 302014 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 302018 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 302022 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 302026 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 302030 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302035 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 302039 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302043 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 302047 */     // MIs[4] Operand 1
     /* 302047 */     // No operand predicates
     /* 302047 */     // MIs[2] Operand 2
     /* 302047 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 302058 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 302060 */     // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 302060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_indexed),
     /* 302063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302065 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 302067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 302071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 302075 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 302078 */     GIR_RootConstrainSelectedInstOperands,
     /* 302079 */     // GIR_Coverage, 2065,
     /* 302079 */     GIR_EraseRootFromParent_Done,
     /* 302080 */   // Label 6024: @302080
     /* 302080 */   GIM_Try, /*On fail goto*//*Label 6025*/ GIMT_Encode4(302147), // Rule ID 1749 //
     /* 302085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 302096 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 302099 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 302104 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 302108 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 302112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302114 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 302121 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 302128 */     // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SQDMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 302128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i32_v2i64),
     /* 302131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302133 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 302135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 302140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 302145 */     GIR_RootConstrainSelectedInstOperands,
     /* 302146 */     // GIR_Coverage, 1749,
     /* 302146 */     GIR_EraseRootFromParent_Done,
     /* 302147 */   // Label 6025: @302147
     /* 302147 */   GIM_Try, /*On fail goto*//*Label 6026*/ GIMT_Encode4(302239), // Rule ID 2066 //
     /* 302152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 302163 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 302166 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 302171 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 302175 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 302179 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302184 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 302188 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 302192 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 302196 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302200 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302205 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 302209 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302213 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 302217 */     // MIs[3] Operand 1
     /* 302217 */     // No operand predicates
     /* 302217 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 302219 */     // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 302219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_indexed),
     /* 302222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302224 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 302226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 302230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302234 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 302237 */     GIR_RootConstrainSelectedInstOperands,
     /* 302238 */     // GIR_Coverage, 2066,
     /* 302238 */     GIR_EraseRootFromParent_Done,
     /* 302239 */   // Label 6026: @302239
     /* 302239 */   GIM_Try, /*On fail goto*//*Label 6027*/ GIMT_Encode4(302300), // Rule ID 1748 //
     /* 302244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 302255 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 302258 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 302263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 302267 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 302271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302283 */     // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 693:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SQDMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 302283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_v2i64),
     /* 302286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302288 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 302290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 302294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 302298 */     GIR_RootConstrainSelectedInstOperands,
     /* 302299 */     // GIR_Coverage, 1748,
     /* 302299 */     GIR_EraseRootFromParent_Done,
     /* 302300 */   // Label 6027: @302300
     /* 302300 */   GIM_Try, /*On fail goto*//*Label 6028*/ GIMT_Encode4(302319), // Rule ID 1451 //
     /* 302305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302312 */     // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 302312 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i64),
     /* 302317 */     GIR_RootConstrainSelectedInstOperands,
     /* 302318 */     // GIR_Coverage, 1451,
     /* 302318 */     GIR_Done,
     /* 302319 */   // Label 6028: @302319
     /* 302319 */   GIM_Reject,
     /* 302320 */ // Label 6022: @302320
     /* 302320 */ GIM_Reject,
     /* 302321 */ // Label 6010: @302321
     /* 302321 */ GIM_Try, /*On fail goto*//*Label 6029*/ GIMT_Encode4(302354), // Rule ID 1447 //
     /* 302326 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 302332 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 302335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302339 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302343 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302347 */   // (ssubsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 302347 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i16),
     /* 302352 */   GIR_RootConstrainSelectedInstOperands,
     /* 302353 */   // GIR_Coverage, 1447,
     /* 302353 */   GIR_Done,
     /* 302354 */ // Label 6029: @302354
     /* 302354 */ GIM_Reject,
     /* 302355 */ // Label 6011: @302355
     /* 302355 */ GIM_Try, /*On fail goto*//*Label 6030*/ GIMT_Encode4(302847),
     /* 302360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 302363 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 302366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302370 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302374 */   GIM_Try, /*On fail goto*//*Label 6031*/ GIMT_Encode4(302492), // Rule ID 2064 //
     /* 302379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 302390 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 302393 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 302398 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 302402 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 302406 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 302410 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 302414 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302418 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 302422 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 302426 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302430 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 302434 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 302439 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 302443 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302447 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 302451 */     // MIs[4] Operand 1
     /* 302451 */     // No operand predicates
     /* 302451 */     // MIs[2] Operand 2
     /* 302451 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 302462 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 302464 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 302471 */     // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SQDMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 302471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv8i16_indexed),
     /* 302474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302476 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 302478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 302483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 302487 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 302490 */     GIR_RootConstrainSelectedInstOperands,
     /* 302491 */     // GIR_Coverage, 2064,
     /* 302491 */     GIR_EraseRootFromParent_Done,
     /* 302492 */   // Label 6031: @302492
     /* 302492 */   GIM_Try, /*On fail goto*//*Label 6032*/ GIMT_Encode4(302607), // Rule ID 2062 //
     /* 302497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 302508 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 302511 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 302516 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 302520 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 302524 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302529 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 302533 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 302537 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302541 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 302545 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 302549 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302553 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 302557 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 302562 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 302566 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302570 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 302574 */     // MIs[4] Operand 1
     /* 302574 */     // No operand predicates
     /* 302574 */     // MIs[2] Operand 2
     /* 302574 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 302585 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 302587 */     // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 302587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_indexed),
     /* 302590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302592 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 302594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 302598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 302602 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 302605 */     GIR_RootConstrainSelectedInstOperands,
     /* 302606 */     // GIR_Coverage, 2062,
     /* 302606 */     GIR_EraseRootFromParent_Done,
     /* 302607 */   // Label 6032: @302607
     /* 302607 */   GIM_Try, /*On fail goto*//*Label 6033*/ GIMT_Encode4(302674), // Rule ID 1747 //
     /* 302612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 302623 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 302626 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 302631 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 302635 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 302639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302641 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 302648 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 302655 */     // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SQDMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 302655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv8i16_v4i32),
     /* 302658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302660 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 302662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 302667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 302672 */     GIR_RootConstrainSelectedInstOperands,
     /* 302673 */     // GIR_Coverage, 1747,
     /* 302673 */     GIR_EraseRootFromParent_Done,
     /* 302674 */   // Label 6033: @302674
     /* 302674 */   GIM_Try, /*On fail goto*//*Label 6034*/ GIMT_Encode4(302766), // Rule ID 2063 //
     /* 302679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 302690 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 302693 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 302698 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 302702 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 302706 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 302715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 302719 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302723 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302727 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 302732 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 302736 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302740 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 302744 */     // MIs[3] Operand 1
     /* 302744 */     // No operand predicates
     /* 302744 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 302746 */     // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SQDMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 302746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_indexed),
     /* 302749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302751 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 302753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 302757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 302764 */     GIR_RootConstrainSelectedInstOperands,
     /* 302765 */     // GIR_Coverage, 2063,
     /* 302765 */     GIR_EraseRootFromParent_Done,
     /* 302766 */   // Label 6034: @302766
     /* 302766 */   GIM_Try, /*On fail goto*//*Label 6035*/ GIMT_Encode4(302827), // Rule ID 1746 //
     /* 302771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 302782 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 302785 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 302790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 302794 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 302798 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302803 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302810 */     // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SQDMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 302810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_v4i32),
     /* 302813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302815 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 302817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 302821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 302825 */     GIR_RootConstrainSelectedInstOperands,
     /* 302826 */     // GIR_Coverage, 1746,
     /* 302826 */     GIR_EraseRootFromParent_Done,
     /* 302827 */   // Label 6035: @302827
     /* 302827 */   GIM_Try, /*On fail goto*//*Label 6036*/ GIMT_Encode4(302846), // Rule ID 1450 //
     /* 302832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302839 */     // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 302839 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i32),
     /* 302844 */     GIR_RootConstrainSelectedInstOperands,
     /* 302845 */     // GIR_Coverage, 1450,
     /* 302845 */     GIR_Done,
     /* 302846 */   // Label 6036: @302846
     /* 302846 */   GIM_Reject,
     /* 302847 */ // Label 6030: @302847
     /* 302847 */ GIM_Reject,
     /* 302848 */ // Label 6012: @302848
     /* 302848 */ GIM_Try, /*On fail goto*//*Label 6037*/ GIMT_Encode4(302881), // Rule ID 1445 //
     /* 302853 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302856 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 302859 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 302862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302870 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302874 */   // (ssubsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 302874 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i8),
     /* 302879 */   GIR_RootConstrainSelectedInstOperands,
     /* 302880 */   // GIR_Coverage, 1445,
     /* 302880 */   GIR_Done,
     /* 302881 */ // Label 6037: @302881
     /* 302881 */ GIM_Reject,
     /* 302882 */ // Label 6013: @302882
     /* 302882 */ GIM_Try, /*On fail goto*//*Label 6038*/ GIMT_Encode4(302915), // Rule ID 1448 //
     /* 302887 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302893 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 302896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302900 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302904 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302908 */   // (ssubsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 302908 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i16),
     /* 302913 */   GIR_RootConstrainSelectedInstOperands,
     /* 302914 */   // GIR_Coverage, 1448,
     /* 302914 */   GIR_Done,
     /* 302915 */ // Label 6038: @302915
     /* 302915 */ GIM_Reject,
     /* 302916 */ // Label 6014: @302916
     /* 302916 */ GIM_Try, /*On fail goto*//*Label 6039*/ GIMT_Encode4(302949), // Rule ID 1446 //
     /* 302921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 302927 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 302930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302934 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302938 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302942 */   // (ssubsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 302942 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv16i8),
     /* 302947 */   GIR_RootConstrainSelectedInstOperands,
     /* 302948 */   // GIR_Coverage, 1446,
     /* 302948 */   GIR_Done,
     /* 302949 */ // Label 6039: @302949
     /* 302949 */ GIM_Reject,
     /* 302950 */ // Label 6015: @302950
     /* 302950 */ GIM_Try, /*On fail goto*//*Label 6040*/ GIMT_Encode4(302975), // Rule ID 7541 //
     /* 302955 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 302958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 302961 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 302964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 302968 */   // (ssubsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQSUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 302968 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_D),
     /* 302973 */   GIR_RootConstrainSelectedInstOperands,
     /* 302974 */   // GIR_Coverage, 7541,
     /* 302974 */   GIR_Done,
     /* 302975 */ // Label 6040: @302975
     /* 302975 */ GIM_Reject,
     /* 302976 */ // Label 6016: @302976
     /* 302976 */ GIM_Try, /*On fail goto*//*Label 6041*/ GIMT_Encode4(303001), // Rule ID 7540 //
     /* 302981 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 302984 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 302987 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 302990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 302994 */   // (ssubsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQSUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 302994 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_S),
     /* 302999 */   GIR_RootConstrainSelectedInstOperands,
     /* 303000 */   // GIR_Coverage, 7540,
     /* 303000 */   GIR_Done,
     /* 303001 */ // Label 6041: @303001
     /* 303001 */ GIM_Reject,
     /* 303002 */ // Label 6017: @303002
     /* 303002 */ GIM_Try, /*On fail goto*//*Label 6042*/ GIMT_Encode4(303027), // Rule ID 7539 //
     /* 303007 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 303010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 303013 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 303016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 303020 */   // (ssubsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQSUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 303020 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_H),
     /* 303025 */   GIR_RootConstrainSelectedInstOperands,
     /* 303026 */   // GIR_Coverage, 7539,
     /* 303026 */   GIR_Done,
     /* 303027 */ // Label 6042: @303027
     /* 303027 */ GIM_Reject,
     /* 303028 */ // Label 6018: @303028
     /* 303028 */ GIM_Try, /*On fail goto*//*Label 6043*/ GIMT_Encode4(303053), // Rule ID 7538 //
     /* 303033 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 303036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 303039 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 303042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 303046 */   // (ssubsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQSUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 303046 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_B),
     /* 303051 */   GIR_RootConstrainSelectedInstOperands,
     /* 303052 */   // GIR_Coverage, 7538,
     /* 303052 */   GIR_Done,
     /* 303053 */ // Label 6043: @303053
     /* 303053 */ GIM_Reject,
     /* 303054 */ // Label 6019: @303054
     /* 303054 */ GIM_Reject,
     /* 303055 */ // Label 59: @303055
     /* 303055 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 6055*/ GIMT_Encode4(304852),
     /* 303066 */ /*GILLT_s16*//*Label 6044*/ GIMT_Encode4(303150),
     /* 303070 */ /*GILLT_s32*//*Label 6045*/ GIMT_Encode4(303376),
     /* 303074 */ /*GILLT_s64*//*Label 6046*/ GIMT_Encode4(303730), GIMT_Encode4(0),
     /* 303082 */ /*GILLT_v2s32*//*Label 6047*/ GIMT_Encode4(303902),
     /* 303086 */ /*GILLT_v2s64*//*Label 6048*/ GIMT_Encode4(303940),
     /* 303090 */ /*GILLT_v4s16*//*Label 6049*/ GIMT_Encode4(304116),
     /* 303094 */ /*GILLT_v4s32*//*Label 6050*/ GIMT_Encode4(304154), GIMT_Encode4(0),
     /* 303102 */ /*GILLT_v8s16*//*Label 6051*/ GIMT_Encode4(304330), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 303126 */ /*GILLT_nxv2s64*//*Label 6052*/ GIMT_Encode4(304774), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 303138 */ /*GILLT_nxv4s32*//*Label 6053*/ GIMT_Encode4(304800), GIMT_Encode4(0),
     /* 303146 */ /*GILLT_nxv8s16*//*Label 6054*/ GIMT_Encode4(304826),
     /* 303150 */ // Label 6044: @303150
     /* 303150 */ GIM_Try, /*On fail goto*//*Label 6056*/ GIMT_Encode4(303375),
     /* 303155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 303158 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 303161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303165 */   GIM_Try, /*On fail goto*//*Label 6057*/ GIMT_Encode4(303256), // Rule ID 6987 //
     /* 303170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 303182 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303186 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303191 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 303195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303203 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303207 */     // MIs[2] Rn
     /* 303207 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 303212 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 303216 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303218 */     // (fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 303218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 303221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303230 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 303236 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303241 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 303249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303254 */     GIR_RootConstrainSelectedInstOperands,
     /* 303255 */     // GIR_Coverage, 6987,
     /* 303255 */     GIR_EraseRootFromParent_Done,
     /* 303256 */   // Label 6057: @303256
     /* 303256 */   GIM_Try, /*On fail goto*//*Label 6058*/ GIMT_Encode4(303347), // Rule ID 14089 //
     /* 303261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 303273 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303277 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303282 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 303286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303294 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303298 */     // MIs[2] Rn
     /* 303298 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 303303 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 303307 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303309 */     // (fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 303309 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 303312 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303316 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303321 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 303327 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303332 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 303340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303345 */     GIR_RootConstrainSelectedInstOperands,
     /* 303346 */     // GIR_Coverage, 14089,
     /* 303346 */     GIR_EraseRootFromParent_Done,
     /* 303347 */   // Label 6058: @303347
     /* 303347 */   GIM_Try, /*On fail goto*//*Label 6059*/ GIMT_Encode4(303374), // Rule ID 584 //
     /* 303352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 303355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303363 */     // (fadd:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FADDHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 303363 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDHrr),
     /* 303368 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303372 */     GIR_RootConstrainSelectedInstOperands,
     /* 303373 */     // GIR_Coverage, 584,
     /* 303373 */     GIR_Done,
     /* 303374 */   // Label 6059: @303374
     /* 303374 */   GIM_Reject,
     /* 303375 */ // Label 6056: @303375
     /* 303375 */ GIM_Reject,
     /* 303376 */ // Label 6045: @303376
     /* 303376 */ GIM_Try, /*On fail goto*//*Label 6060*/ GIMT_Encode4(303729),
     /* 303381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 303384 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 303387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303391 */   GIM_Try, /*On fail goto*//*Label 6061*/ GIMT_Encode4(303482), // Rule ID 6985 //
     /* 303396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303412 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303417 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 303421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303429 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303433 */     // MIs[2] Rn
     /* 303433 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 303438 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 303442 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303444 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 303444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 303447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303456 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 303462 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303467 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 303475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303477 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303480 */     GIR_RootConstrainSelectedInstOperands,
     /* 303481 */     // GIR_Coverage, 6985,
     /* 303481 */     GIR_EraseRootFromParent_Done,
     /* 303482 */   // Label 6061: @303482
     /* 303482 */   GIM_Try, /*On fail goto*//*Label 6062*/ GIMT_Encode4(303546), // Rule ID 13258 //
     /* 303487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 303499 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303508 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 303512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303520 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303524 */     // MIs[2] Rn
     /* 303524 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 303529 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 303533 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303535 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn)
     /* 303535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 303538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303544 */     GIR_RootConstrainSelectedInstOperands,
     /* 303545 */     // GIR_Coverage, 13258,
     /* 303545 */     GIR_EraseRootFromParent_Done,
     /* 303546 */   // Label 6062: @303546
     /* 303546 */   GIM_Try, /*On fail goto*//*Label 6063*/ GIMT_Encode4(303637), // Rule ID 14087 //
     /* 303551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303563 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303572 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 303576 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303580 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303584 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303588 */     // MIs[2] Rn
     /* 303588 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 303593 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 303597 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303599 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 303599 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 303602 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303606 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303611 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 303617 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303622 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 303630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303635 */     GIR_RootConstrainSelectedInstOperands,
     /* 303636 */     // GIR_Coverage, 14087,
     /* 303636 */     GIR_EraseRootFromParent_Done,
     /* 303637 */   // Label 6063: @303637
     /* 303637 */   GIM_Try, /*On fail goto*//*Label 6064*/ GIMT_Encode4(303701), // Rule ID 15917 //
     /* 303642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303650 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 303654 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303658 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303663 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 303667 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303671 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303675 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303679 */     // MIs[2] Rn
     /* 303679 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 303684 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 303688 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303690 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn)
     /* 303690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 303693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303699 */     GIR_RootConstrainSelectedInstOperands,
     /* 303700 */     // GIR_Coverage, 15917,
     /* 303700 */     GIR_EraseRootFromParent_Done,
     /* 303701 */   // Label 6064: @303701
     /* 303701 */   GIM_Try, /*On fail goto*//*Label 6065*/ GIMT_Encode4(303728), // Rule ID 586 //
     /* 303706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 303709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303717 */     // (fadd:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FADDSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 303717 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDSrr),
     /* 303722 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303726 */     GIR_RootConstrainSelectedInstOperands,
     /* 303727 */     // GIR_Coverage, 586,
     /* 303727 */     GIR_Done,
     /* 303728 */   // Label 6065: @303728
     /* 303728 */   GIM_Reject,
     /* 303729 */ // Label 6060: @303729
     /* 303729 */ GIM_Reject,
     /* 303730 */ // Label 6046: @303730
     /* 303730 */ GIM_Try, /*On fail goto*//*Label 6066*/ GIMT_Encode4(303901),
     /* 303735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 303738 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 303741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303745 */   GIM_Try, /*On fail goto*//*Label 6067*/ GIMT_Encode4(303809), // Rule ID 6983 //
     /* 303750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303762 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303766 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303771 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 303775 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303779 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303783 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303787 */     // MIs[2] Rn
     /* 303787 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 303792 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 303796 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303798 */     // (fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 303798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 303801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303807 */     GIR_RootConstrainSelectedInstOperands,
     /* 303808 */     // GIR_Coverage, 6983,
     /* 303808 */     GIR_EraseRootFromParent_Done,
     /* 303809 */   // Label 6067: @303809
     /* 303809 */   GIM_Try, /*On fail goto*//*Label 6068*/ GIMT_Encode4(303873), // Rule ID 14085 //
     /* 303814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303826 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303830 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303835 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 303839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303847 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303851 */     // MIs[2] Rn
     /* 303851 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 303856 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 303860 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303862 */     // (fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 303862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 303865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303871 */     GIR_RootConstrainSelectedInstOperands,
     /* 303872 */     // GIR_Coverage, 14085,
     /* 303872 */     GIR_EraseRootFromParent_Done,
     /* 303873 */   // Label 6068: @303873
     /* 303873 */   GIM_Try, /*On fail goto*//*Label 6069*/ GIMT_Encode4(303900), // Rule ID 588 //
     /* 303878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 303881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303889 */     // (fadd:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FADDDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 303889 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDDrr),
     /* 303894 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303898 */     GIR_RootConstrainSelectedInstOperands,
     /* 303899 */     // GIR_Coverage, 588,
     /* 303899 */     GIR_Done,
     /* 303900 */   // Label 6069: @303900
     /* 303900 */   GIM_Reject,
     /* 303901 */ // Label 6066: @303901
     /* 303901 */ GIM_Reject,
     /* 303902 */ // Label 6047: @303902
     /* 303902 */ GIM_Try, /*On fail goto*//*Label 6070*/ GIMT_Encode4(303939), // Rule ID 1203 //
     /* 303907 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 303913 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 303916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303920 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303924 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303928 */   // (fadd:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 303928 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f32),
     /* 303933 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303937 */   GIR_RootConstrainSelectedInstOperands,
     /* 303938 */   // GIR_Coverage, 1203,
     /* 303938 */   GIR_Done,
     /* 303939 */ // Label 6070: @303939
     /* 303939 */ GIM_Reject,
     /* 303940 */ // Label 6048: @303940
     /* 303940 */ GIM_Try, /*On fail goto*//*Label 6071*/ GIMT_Encode4(304115),
     /* 303945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303948 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 303951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303955 */   GIM_Try, /*On fail goto*//*Label 6072*/ GIMT_Encode4(304021), // Rule ID 7005 //
     /* 303960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /* 303968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 303976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303981 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303986 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303990 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP2),
     /* 303994 */     // MIs[2] Rn
     /* 303994 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 303999 */     // MIs[2] Rm
     /* 303999 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 304004 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304006 */     // (fadd:{ *:[v2f64] } (AArch64zip1:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm), (AArch64zip2:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm))  =>  (FADDPv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm)
     /* 304006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 304009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 304019 */     GIR_RootConstrainSelectedInstOperands,
     /* 304020 */     // GIR_Coverage, 7005,
     /* 304020 */     GIR_EraseRootFromParent_Done,
     /* 304021 */   // Label 6072: @304021
     /* 304021 */   GIM_Try, /*On fail goto*//*Label 6073*/ GIMT_Encode4(304087), // Rule ID 14097 //
     /* 304026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /* 304034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 304038 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 304042 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 304056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP1),
     /* 304060 */     // MIs[2] Rn
     /* 304060 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 304065 */     // MIs[2] Rm
     /* 304065 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 304070 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304072 */     // (fadd:{ *:[v2f64] } (AArch64zip2:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm), (AArch64zip1:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm))  =>  (FADDPv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm)
     /* 304072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 304075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 304085 */     GIR_RootConstrainSelectedInstOperands,
     /* 304086 */     // GIR_Coverage, 14097,
     /* 304086 */     GIR_EraseRootFromParent_Done,
     /* 304087 */   // Label 6073: @304087
     /* 304087 */   GIM_Try, /*On fail goto*//*Label 6074*/ GIMT_Encode4(304114), // Rule ID 1207 //
     /* 304092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304103 */     // (fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 304103 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f64),
     /* 304108 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304112 */     GIR_RootConstrainSelectedInstOperands,
     /* 304113 */     // GIR_Coverage, 1207,
     /* 304113 */     GIR_Done,
     /* 304114 */   // Label 6074: @304114
     /* 304114 */   GIM_Reject,
     /* 304115 */ // Label 6071: @304115
     /* 304115 */ GIM_Reject,
     /* 304116 */ // Label 6049: @304116
     /* 304116 */ GIM_Try, /*On fail goto*//*Label 6075*/ GIMT_Encode4(304153), // Rule ID 1199 //
     /* 304121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 304124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 304127 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 304130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304134 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304138 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304142 */   // (fadd:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 304142 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f16),
     /* 304147 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304151 */   GIR_RootConstrainSelectedInstOperands,
     /* 304152 */   // GIR_Coverage, 1199,
     /* 304152 */   GIR_Done,
     /* 304153 */ // Label 6075: @304153
     /* 304153 */ GIM_Reject,
     /* 304154 */ // Label 6050: @304154
     /* 304154 */ GIM_Try, /*On fail goto*//*Label 6076*/ GIMT_Encode4(304329),
     /* 304159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304162 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 304165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304169 */   GIM_Try, /*On fail goto*//*Label 6077*/ GIMT_Encode4(304235), // Rule ID 7006 //
     /* 304174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /* 304182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 304190 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304200 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 304204 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /* 304208 */     // MIs[2] Rn
     /* 304208 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 304213 */     // MIs[2] Rm
     /* 304213 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 304218 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304220 */     // (fadd:{ *:[v4f32] } (AArch64uzp1:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm), (AArch64uzp2:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm))  =>  (FADDPv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm)
     /* 304220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 304223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 304233 */     GIR_RootConstrainSelectedInstOperands,
     /* 304234 */     // GIR_Coverage, 7006,
     /* 304234 */     GIR_EraseRootFromParent_Done,
     /* 304235 */   // Label 6077: @304235
     /* 304235 */   GIM_Try, /*On fail goto*//*Label 6078*/ GIMT_Encode4(304301), // Rule ID 14098 //
     /* 304240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /* 304248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304252 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 304256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304261 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 304270 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /* 304274 */     // MIs[2] Rn
     /* 304274 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 304279 */     // MIs[2] Rm
     /* 304279 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 304284 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304286 */     // (fadd:{ *:[v4f32] } (AArch64uzp2:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm), (AArch64uzp1:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm))  =>  (FADDPv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm)
     /* 304286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 304289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 304299 */     GIR_RootConstrainSelectedInstOperands,
     /* 304300 */     // GIR_Coverage, 14098,
     /* 304300 */     GIR_EraseRootFromParent_Done,
     /* 304301 */   // Label 6078: @304301
     /* 304301 */   GIM_Try, /*On fail goto*//*Label 6079*/ GIMT_Encode4(304328), // Rule ID 1205 //
     /* 304306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304309 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304317 */     // (fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 304317 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 304322 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304326 */     GIR_RootConstrainSelectedInstOperands,
     /* 304327 */     // GIR_Coverage, 1205,
     /* 304327 */     GIR_Done,
     /* 304328 */   // Label 6079: @304328
     /* 304328 */   GIM_Reject,
     /* 304329 */ // Label 6076: @304329
     /* 304329 */ GIM_Reject,
     /* 304330 */ // Label 6051: @304330
     /* 304330 */ GIM_Try, /*On fail goto*//*Label 6080*/ GIMT_Encode4(304773),
     /* 304335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304338 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 304341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304345 */   GIM_Try, /*On fail goto*//*Label 6081*/ GIMT_Encode4(304414), // Rule ID 7007 //
     /* 304350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 304353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /* 304361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304365 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 304369 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304374 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 304383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /* 304387 */     // MIs[2] Rn
     /* 304387 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 304392 */     // MIs[2] Rm
     /* 304392 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 304397 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304399 */     // (fadd:{ *:[v8f16] } (AArch64uzp1:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm), (AArch64uzp2:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm))  =>  (FADDPv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm)
     /* 304399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 304402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 304412 */     GIR_RootConstrainSelectedInstOperands,
     /* 304413 */     // GIR_Coverage, 7007,
     /* 304413 */     GIR_EraseRootFromParent_Done,
     /* 304414 */   // Label 6081: @304414
     /* 304414 */   GIM_Try, /*On fail goto*//*Label 6082*/ GIMT_Encode4(304483), // Rule ID 14099 //
     /* 304419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 304422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /* 304430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304434 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 304438 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304443 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304448 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 304452 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /* 304456 */     // MIs[2] Rn
     /* 304456 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 304461 */     // MIs[2] Rm
     /* 304461 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 304466 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304468 */     // (fadd:{ *:[v8f16] } (AArch64uzp2:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm), (AArch64uzp1:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm))  =>  (FADDPv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm)
     /* 304468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 304471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 304481 */     GIR_RootConstrainSelectedInstOperands,
     /* 304482 */     // GIR_Coverage, 14099,
     /* 304482 */     GIR_EraseRootFromParent_Done,
     /* 304483 */   // Label 6082: @304483
     /* 304483 */   GIM_Try, /*On fail goto*//*Label 6083*/ GIMT_Encode4(304510), // Rule ID 1201 //
     /* 304488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 304491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304499 */     // (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 304499 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv8f16),
     /* 304504 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304508 */     GIR_RootConstrainSelectedInstOperands,
     /* 304509 */     // GIR_Coverage, 1201,
     /* 304509 */     GIR_Done,
     /* 304510 */   // Label 6083: @304510
     /* 304510 */   GIM_Try, /*On fail goto*//*Label 6084*/ GIMT_Encode4(304772), // Rule ID 7082 //
     /* 304515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 304518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304526 */     // (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FADDv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FADDv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 304526 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 304529 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 304533 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304538 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 304542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 304544 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 304547 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 304551 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304556 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 304560 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 304562 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 304565 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 304569 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304574 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 304577 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 304580 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 304582 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 304585 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304589 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304594 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 304600 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304605 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304610 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 304613 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 304617 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304622 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 304625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 304627 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 304630 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304634 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304639 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 304645 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304650 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304655 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 304658 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 304662 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304667 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 304670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 304672 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 304675 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 304679 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304684 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 304687 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 304690 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 304692 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 304695 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 304699 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304704 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 304707 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 304709 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 304712 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 304716 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304721 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 304723 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 304726 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 304730 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304735 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 304738 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 304741 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 304744 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304749 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304754 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 304762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304764 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304767 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 304770 */     GIR_RootConstrainSelectedInstOperands,
     /* 304771 */     // GIR_Coverage, 7082,
     /* 304771 */     GIR_EraseRootFromParent_Done,
     /* 304772 */   // Label 6084: @304772
     /* 304772 */   GIM_Reject,
     /* 304773 */ // Label 6080: @304773
     /* 304773 */ GIM_Reject,
     /* 304774 */ // Label 6052: @304774
     /* 304774 */ GIM_Try, /*On fail goto*//*Label 6085*/ GIMT_Encode4(304799), // Rule ID 2820 //
     /* 304779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 304782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 304785 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 304788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 304792 */   // (fadd:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FADD_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 304792 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_D),
     /* 304797 */   GIR_RootConstrainSelectedInstOperands,
     /* 304798 */   // GIR_Coverage, 2820,
     /* 304798 */   GIR_Done,
     /* 304799 */ // Label 6085: @304799
     /* 304799 */ GIM_Reject,
     /* 304800 */ // Label 6053: @304800
     /* 304800 */ GIM_Try, /*On fail goto*//*Label 6086*/ GIMT_Encode4(304825), // Rule ID 2818 //
     /* 304805 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 304808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 304811 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 304814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 304818 */   // (fadd:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FADD_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 304818 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_S),
     /* 304823 */   GIR_RootConstrainSelectedInstOperands,
     /* 304824 */   // GIR_Coverage, 2818,
     /* 304824 */   GIR_Done,
     /* 304825 */ // Label 6086: @304825
     /* 304825 */ GIM_Reject,
     /* 304826 */ // Label 6054: @304826
     /* 304826 */ GIM_Try, /*On fail goto*//*Label 6087*/ GIMT_Encode4(304851), // Rule ID 2816 //
     /* 304831 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 304834 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 304837 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 304840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 304844 */   // (fadd:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FADD_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 304844 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_H),
     /* 304849 */   GIR_RootConstrainSelectedInstOperands,
     /* 304850 */   // GIR_Coverage, 2816,
     /* 304850 */   GIR_Done,
     /* 304851 */ // Label 6087: @304851
     /* 304851 */ GIM_Reject,
     /* 304852 */ // Label 6055: @304852
     /* 304852 */ GIM_Reject,
     /* 304853 */ // Label 60: @304853
     /* 304853 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 6099*/ GIMT_Encode4(305590),
     /* 304864 */ /*GILLT_s16*//*Label 6088*/ GIMT_Encode4(304948),
     /* 304868 */ /*GILLT_s32*//*Label 6089*/ GIMT_Encode4(304986),
     /* 304872 */ /*GILLT_s64*//*Label 6090*/ GIMT_Encode4(305024), GIMT_Encode4(0),
     /* 304880 */ /*GILLT_v2s32*//*Label 6091*/ GIMT_Encode4(305062),
     /* 304884 */ /*GILLT_v2s64*//*Label 6092*/ GIMT_Encode4(305100),
     /* 304888 */ /*GILLT_v4s16*//*Label 6093*/ GIMT_Encode4(305138),
     /* 304892 */ /*GILLT_v4s32*//*Label 6094*/ GIMT_Encode4(305176), GIMT_Encode4(0),
     /* 304900 */ /*GILLT_v8s16*//*Label 6095*/ GIMT_Encode4(305214), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 304924 */ /*GILLT_nxv2s64*//*Label 6096*/ GIMT_Encode4(305512), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 304936 */ /*GILLT_nxv4s32*//*Label 6097*/ GIMT_Encode4(305538), GIMT_Encode4(0),
     /* 304944 */ /*GILLT_nxv8s16*//*Label 6098*/ GIMT_Encode4(305564),
     /* 304948 */ // Label 6088: @304948
     /* 304948 */ GIM_Try, /*On fail goto*//*Label 6100*/ GIMT_Encode4(304985), // Rule ID 632 //
     /* 304953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 304956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 304959 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 304962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304966 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304970 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304974 */   // (fsub:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FSUBHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 304974 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBHrr),
     /* 304979 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304983 */   GIR_RootConstrainSelectedInstOperands,
     /* 304984 */   // GIR_Coverage, 632,
     /* 304984 */   GIR_Done,
     /* 304985 */ // Label 6100: @304985
     /* 304985 */ GIM_Reject,
     /* 304986 */ // Label 6089: @304986
     /* 304986 */ GIM_Try, /*On fail goto*//*Label 6101*/ GIMT_Encode4(305023), // Rule ID 634 //
     /* 304991 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 304994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304997 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 305000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305004 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305008 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305012 */   // (fsub:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FSUBSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 305012 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBSrr),
     /* 305017 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 305021 */   GIR_RootConstrainSelectedInstOperands,
     /* 305022 */   // GIR_Coverage, 634,
     /* 305022 */   GIR_Done,
     /* 305023 */ // Label 6101: @305023
     /* 305023 */ GIM_Reject,
     /* 305024 */ // Label 6090: @305024
     /* 305024 */ GIM_Try, /*On fail goto*//*Label 6102*/ GIMT_Encode4(305061), // Rule ID 636 //
     /* 305029 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 305032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 305035 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 305038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305046 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305050 */   // (fsub:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FSUBDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 305050 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBDrr),
     /* 305055 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 305059 */   GIR_RootConstrainSelectedInstOperands,
     /* 305060 */   // GIR_Coverage, 636,
     /* 305060 */   GIR_Done,
     /* 305061 */ // Label 6102: @305061
     /* 305061 */ GIM_Reject,
     /* 305062 */ // Label 6091: @305062
     /* 305062 */ GIM_Try, /*On fail goto*//*Label 6103*/ GIMT_Encode4(305099), // Rule ID 1343 //
     /* 305067 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 305073 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 305076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305080 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305084 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305088 */   // (fsub:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FSUBv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 305088 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f32),
     /* 305093 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 305097 */   GIR_RootConstrainSelectedInstOperands,
     /* 305098 */   // GIR_Coverage, 1343,
     /* 305098 */   GIR_Done,
     /* 305099 */ // Label 6103: @305099
     /* 305099 */ GIM_Reject,
     /* 305100 */ // Label 6092: @305100
     /* 305100 */ GIM_Try, /*On fail goto*//*Label 6104*/ GIMT_Encode4(305137), // Rule ID 1347 //
     /* 305105 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 305111 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 305114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305122 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305126 */   // (fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FSUBv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 305126 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f64),
     /* 305131 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 305135 */   GIR_RootConstrainSelectedInstOperands,
     /* 305136 */   // GIR_Coverage, 1347,
     /* 305136 */   GIR_Done,
     /* 305137 */ // Label 6104: @305137
     /* 305137 */ GIM_Reject,
     /* 305138 */ // Label 6093: @305138
     /* 305138 */ GIM_Try, /*On fail goto*//*Label 6105*/ GIMT_Encode4(305175), // Rule ID 1339 //
     /* 305143 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 305149 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 305152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305156 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305160 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305164 */   // (fsub:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FSUBv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 305164 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f16),
     /* 305169 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 305173 */   GIR_RootConstrainSelectedInstOperands,
     /* 305174 */   // GIR_Coverage, 1339,
     /* 305174 */   GIR_Done,
     /* 305175 */ // Label 6105: @305175
     /* 305175 */ GIM_Reject,
     /* 305176 */ // Label 6094: @305176
     /* 305176 */ GIM_Try, /*On fail goto*//*Label 6106*/ GIMT_Encode4(305213), // Rule ID 1345 //
     /* 305181 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 305187 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 305190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305194 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305198 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305202 */   // (fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FSUBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 305202 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 305207 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 305211 */   GIR_RootConstrainSelectedInstOperands,
     /* 305212 */   // GIR_Coverage, 1345,
     /* 305212 */   GIR_Done,
     /* 305213 */ // Label 6106: @305213
     /* 305213 */ GIM_Reject,
     /* 305214 */ // Label 6095: @305214
     /* 305214 */ GIM_Try, /*On fail goto*//*Label 6107*/ GIMT_Encode4(305511),
     /* 305219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305222 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 305225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305229 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305233 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305237 */   GIM_Try, /*On fail goto*//*Label 6108*/ GIMT_Encode4(305256), // Rule ID 1341 //
     /* 305242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305245 */     // (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FSUBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 305245 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv8f16),
     /* 305250 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 305254 */     GIR_RootConstrainSelectedInstOperands,
     /* 305255 */     // GIR_Coverage, 1341,
     /* 305255 */     GIR_Done,
     /* 305256 */   // Label 6108: @305256
     /* 305256 */   GIM_Try, /*On fail goto*//*Label 6109*/ GIMT_Encode4(305510), // Rule ID 7088 //
     /* 305261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 305264 */     // (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FSUBv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FSUBv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 305264 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 305267 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 305271 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305276 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 305280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 305282 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 305285 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 305289 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305294 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 305298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 305300 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 305303 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 305307 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305312 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 305315 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 305318 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 305320 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 305323 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305327 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305332 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 305338 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305343 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305348 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 305351 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 305355 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305360 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 305363 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 305365 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 305368 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305372 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305377 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 305383 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305388 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305393 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 305396 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 305400 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305405 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 305408 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 305410 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 305413 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 305417 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305422 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 305425 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 305428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 305430 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 305433 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 305437 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305442 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 305445 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 305447 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 305450 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 305454 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 305461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 305464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 305468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305473 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 305476 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 305479 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 305482 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305487 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305492 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 305500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305505 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 305508 */     GIR_RootConstrainSelectedInstOperands,
     /* 305509 */     // GIR_Coverage, 7088,
     /* 305509 */     GIR_EraseRootFromParent_Done,
     /* 305510 */   // Label 6109: @305510
     /* 305510 */   GIM_Reject,
     /* 305511 */ // Label 6107: @305511
     /* 305511 */ GIM_Reject,
     /* 305512 */ // Label 6096: @305512
     /* 305512 */ GIM_Try, /*On fail goto*//*Label 6110*/ GIMT_Encode4(305537), // Rule ID 8288 //
     /* 305517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 305520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 305523 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 305526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 305530 */   // (fsub:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FSUB_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 305530 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_D),
     /* 305535 */   GIR_RootConstrainSelectedInstOperands,
     /* 305536 */   // GIR_Coverage, 8288,
     /* 305536 */   GIR_Done,
     /* 305537 */ // Label 6110: @305537
     /* 305537 */ GIM_Reject,
     /* 305538 */ // Label 6097: @305538
     /* 305538 */ GIM_Try, /*On fail goto*//*Label 6111*/ GIMT_Encode4(305563), // Rule ID 8286 //
     /* 305543 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 305546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 305549 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 305552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 305556 */   // (fsub:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FSUB_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 305556 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_S),
     /* 305561 */   GIR_RootConstrainSelectedInstOperands,
     /* 305562 */   // GIR_Coverage, 8286,
     /* 305562 */   GIR_Done,
     /* 305563 */ // Label 6111: @305563
     /* 305563 */ GIM_Reject,
     /* 305564 */ // Label 6098: @305564
     /* 305564 */ GIM_Try, /*On fail goto*//*Label 6112*/ GIMT_Encode4(305589), // Rule ID 8284 //
     /* 305569 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 305572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 305575 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 305578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 305582 */   // (fsub:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FSUB_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 305582 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_H),
     /* 305587 */   GIR_RootConstrainSelectedInstOperands,
     /* 305588 */   // GIR_Coverage, 8284,
     /* 305588 */   GIR_Done,
     /* 305589 */ // Label 6112: @305589
     /* 305589 */ GIM_Reject,
     /* 305590 */ // Label 6099: @305590
     /* 305590 */ GIM_Reject,
     /* 305591 */ // Label 61: @305591
     /* 305591 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 6124*/ GIMT_Encode4(310206),
     /* 305602 */ /*GILLT_s16*//*Label 6113*/ GIMT_Encode4(305686),
     /* 305606 */ /*GILLT_s32*//*Label 6114*/ GIMT_Encode4(306328),
     /* 305610 */ /*GILLT_s64*//*Label 6115*/ GIMT_Encode4(306958), GIMT_Encode4(0),
     /* 305618 */ /*GILLT_v2s32*//*Label 6116*/ GIMT_Encode4(307588),
     /* 305622 */ /*GILLT_v2s64*//*Label 6117*/ GIMT_Encode4(308118),
     /* 305626 */ /*GILLT_v4s16*//*Label 6118*/ GIMT_Encode4(308476),
     /* 305630 */ /*GILLT_v4s32*//*Label 6119*/ GIMT_Encode4(308818), GIMT_Encode4(0),
     /* 305638 */ /*GILLT_v8s16*//*Label 6120*/ GIMT_Encode4(309176), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 305662 */ /*GILLT_nxv2s64*//*Label 6121*/ GIMT_Encode4(309608), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 305674 */ /*GILLT_nxv4s32*//*Label 6122*/ GIMT_Encode4(309922), GIMT_Encode4(0),
     /* 305682 */ /*GILLT_nxv8s16*//*Label 6123*/ GIMT_Encode4(310064),
     /* 305686 */ // Label 6113: @305686
     /* 305686 */ GIM_Try, /*On fail goto*//*Label 6125*/ GIMT_Encode4(306327),
     /* 305691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 305694 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 305697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305701 */   GIM_Try, /*On fail goto*//*Label 6126*/ GIMT_Encode4(305814), // Rule ID 6307 //
     /* 305706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305721 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305725 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305730 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 305734 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 305738 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305742 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305746 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 305750 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305755 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 305759 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305763 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 305767 */     // MIs[3] Operand 1
     /* 305767 */     // No operand predicates
     /* 305767 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 305769 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 305769 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 305772 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305776 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305781 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 305787 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305792 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 305800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 305809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 305812 */     GIR_RootConstrainSelectedInstOperands,
     /* 305813 */     // GIR_Coverage, 6307,
     /* 305813 */     GIR_EraseRootFromParent_Done,
     /* 305814 */   // Label 6126: @305814
     /* 305814 */   GIM_Try, /*On fail goto*//*Label 6127*/ GIMT_Encode4(305927), // Rule ID 14066 //
     /* 305819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305834 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305838 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 305847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305851 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 305855 */     // MIs[2] Operand 1
     /* 305855 */     // No operand predicates
     /* 305855 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 305859 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305863 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305867 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 305871 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305876 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 305880 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 305882 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 305882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 305885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305894 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 305900 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305905 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 305913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305915 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305922 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 305925 */     GIR_RootConstrainSelectedInstOperands,
     /* 305926 */     // GIR_Coverage, 14066,
     /* 305926 */     GIR_EraseRootFromParent_Done,
     /* 305927 */   // Label 6127: @305927
     /* 305927 */   GIM_Try, /*On fail goto*//*Label 6128*/ GIMT_Encode4(306006), // Rule ID 14000 //
     /* 305932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 305935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305947 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305951 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305956 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 305960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305966 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 305966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 305969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305978 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 305984 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305989 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 305997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306004 */     GIR_RootConstrainSelectedInstOperands,
     /* 306005 */     // GIR_Coverage, 14000,
     /* 306005 */     GIR_EraseRootFromParent_Done,
     /* 306006 */   // Label 6128: @306006
     /* 306006 */   GIM_Try, /*On fail goto*//*Label 6129*/ GIMT_Encode4(306085), // Rule ID 4864 //
     /* 306011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 306014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306030 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306034 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306039 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 306043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306045 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 306045 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 306048 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306052 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306057 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 306063 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306068 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 306076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306078 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 306080 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306083 */     GIR_RootConstrainSelectedInstOperands,
     /* 306084 */     // GIR_Coverage, 4864,
     /* 306084 */     GIR_EraseRootFromParent_Done,
     /* 306085 */   // Label 6129: @306085
     /* 306085 */   GIM_Try, /*On fail goto*//*Label 6130*/ GIMT_Encode4(306148), // Rule ID 13606 //
     /* 306090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306105 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 306114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 306118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306122 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 306126 */     // MIs[2] Operand 1
     /* 306126 */     // No operand predicates
     /* 306126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306130 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306132 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 306132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 306135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 306146 */     GIR_RootConstrainSelectedInstOperands,
     /* 306147 */     // GIR_Coverage, 13606,
     /* 306147 */     GIR_EraseRootFromParent_Done,
     /* 306148 */   // Label 6130: @306148
     /* 306148 */   GIM_Try, /*On fail goto*//*Label 6131*/ GIMT_Encode4(306211), // Rule ID 2012 //
     /* 306153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306172 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306176 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 306181 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 306185 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306189 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 306193 */     // MIs[2] Operand 1
     /* 306193 */     // No operand predicates
     /* 306193 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306195 */     // (fmul:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 306195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 306198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306200 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 306202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306206 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 306209 */     GIR_RootConstrainSelectedInstOperands,
     /* 306210 */     // GIR_Coverage, 2012,
     /* 306210 */     GIR_EraseRootFromParent_Done,
     /* 306211 */   // Label 6131: @306211
     /* 306211 */   GIM_Try, /*On fail goto*//*Label 6132*/ GIMT_Encode4(306255), // Rule ID 4869 //
     /* 306216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 306219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 306231 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306242 */     // (fmul:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$a), FPR16:{ *:[f16] }:$b)  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 306242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 306245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 306251 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 306253 */     GIR_RootConstrainSelectedInstOperands,
     /* 306254 */     // GIR_Coverage, 4869,
     /* 306254 */     GIR_EraseRootFromParent_Done,
     /* 306255 */   // Label 6132: @306255
     /* 306255 */   GIM_Try, /*On fail goto*//*Label 6133*/ GIMT_Encode4(306299), // Rule ID 14005 //
     /* 306260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 306263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 306279 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306286 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$b, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$a))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 306286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 306289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 306295 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 306297 */     GIR_RootConstrainSelectedInstOperands,
     /* 306298 */     // GIR_Coverage, 14005,
     /* 306298 */     GIR_EraseRootFromParent_Done,
     /* 306299 */   // Label 6133: @306299
     /* 306299 */   GIM_Try, /*On fail goto*//*Label 6134*/ GIMT_Encode4(306326), // Rule ID 620 //
     /* 306304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 306307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306315 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 306315 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 306320 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306324 */     GIR_RootConstrainSelectedInstOperands,
     /* 306325 */     // GIR_Coverage, 620,
     /* 306325 */     GIR_Done,
     /* 306326 */   // Label 6134: @306326
     /* 306326 */   GIM_Reject,
     /* 306327 */ // Label 6125: @306327
     /* 306327 */ GIM_Reject,
     /* 306328 */ // Label 6114: @306328
     /* 306328 */ GIM_Try, /*On fail goto*//*Label 6135*/ GIMT_Encode4(306957),
     /* 306333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 306336 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 306339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306343 */   GIM_Try, /*On fail goto*//*Label 6136*/ GIMT_Encode4(306456), // Rule ID 6309 //
     /* 306348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306363 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306367 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306372 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 306376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 306380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306384 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306388 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 306392 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306397 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 306401 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306405 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 306409 */     // MIs[3] Operand 1
     /* 306409 */     // No operand predicates
     /* 306409 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 306411 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 306411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 306414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306423 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 306429 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306434 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 306442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306444 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 306451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 306454 */     GIR_RootConstrainSelectedInstOperands,
     /* 306455 */     // GIR_Coverage, 6309,
     /* 306455 */     GIR_EraseRootFromParent_Done,
     /* 306456 */   // Label 6136: @306456
     /* 306456 */   GIM_Try, /*On fail goto*//*Label 6137*/ GIMT_Encode4(306569), // Rule ID 14068 //
     /* 306461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 306489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306493 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 306497 */     // MIs[2] Operand 1
     /* 306497 */     // No operand predicates
     /* 306497 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 306501 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306505 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306509 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 306513 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306518 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 306522 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 306524 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 306524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 306527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306536 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 306542 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306547 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 306555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306564 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 306567 */     GIR_RootConstrainSelectedInstOperands,
     /* 306568 */     // GIR_Coverage, 14068,
     /* 306568 */     GIR_EraseRootFromParent_Done,
     /* 306569 */   // Label 6137: @306569
     /* 306569 */   GIM_Try, /*On fail goto*//*Label 6138*/ GIMT_Encode4(306645), // Rule ID 14002 //
     /* 306574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306582 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306586 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306590 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306595 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 306599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306605 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 306605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 306608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306617 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 306623 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306628 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 306636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306640 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306643 */     GIR_RootConstrainSelectedInstOperands,
     /* 306644 */     // GIR_Coverage, 14002,
     /* 306644 */     GIR_EraseRootFromParent_Done,
     /* 306645 */   // Label 6138: @306645
     /* 306645 */   GIM_Try, /*On fail goto*//*Label 6139*/ GIMT_Encode4(306721), // Rule ID 4866 //
     /* 306650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306670 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306675 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 306679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306681 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 306681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 306684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306693 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 306699 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306704 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 306712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306714 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 306716 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306719 */     GIR_RootConstrainSelectedInstOperands,
     /* 306720 */     // GIR_Coverage, 4866,
     /* 306720 */     GIR_EraseRootFromParent_Done,
     /* 306721 */   // Label 6139: @306721
     /* 306721 */   GIM_Try, /*On fail goto*//*Label 6140*/ GIMT_Encode4(306784), // Rule ID 13608 //
     /* 306726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306741 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306750 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 306754 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306758 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 306762 */     // MIs[2] Operand 1
     /* 306762 */     // No operand predicates
     /* 306762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306766 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306768 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 306768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 306771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 306782 */     GIR_RootConstrainSelectedInstOperands,
     /* 306783 */     // GIR_Coverage, 13608,
     /* 306783 */     GIR_EraseRootFromParent_Done,
     /* 306784 */   // Label 6140: @306784
     /* 306784 */   GIM_Try, /*On fail goto*//*Label 6141*/ GIMT_Encode4(306847), // Rule ID 2014 //
     /* 306789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 306821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306825 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 306829 */     // MIs[2] Operand 1
     /* 306829 */     // No operand predicates
     /* 306829 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306831 */     // (fmul:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 306831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 306834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306836 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 306838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 306845 */     GIR_RootConstrainSelectedInstOperands,
     /* 306846 */     // GIR_Coverage, 2014,
     /* 306846 */     GIR_EraseRootFromParent_Done,
     /* 306847 */   // Label 6141: @306847
     /* 306847 */   GIM_Try, /*On fail goto*//*Label 6142*/ GIMT_Encode4(306888), // Rule ID 4870 //
     /* 306852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 306864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306875 */     // (fmul:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$a), FPR32:{ *:[f32] }:$b)  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 306875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 306878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 306884 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 306886 */     GIR_RootConstrainSelectedInstOperands,
     /* 306887 */     // GIR_Coverage, 4870,
     /* 306887 */     GIR_EraseRootFromParent_Done,
     /* 306888 */   // Label 6142: @306888
     /* 306888 */   GIM_Try, /*On fail goto*//*Label 6143*/ GIMT_Encode4(306929), // Rule ID 14006 //
     /* 306893 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 306909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306916 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$b, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$a))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 306916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 306919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 306925 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 306927 */     GIR_RootConstrainSelectedInstOperands,
     /* 306928 */     // GIR_Coverage, 14006,
     /* 306928 */     GIR_EraseRootFromParent_Done,
     /* 306929 */   // Label 6143: @306929
     /* 306929 */   GIM_Try, /*On fail goto*//*Label 6144*/ GIMT_Encode4(306956), // Rule ID 622 //
     /* 306934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 306937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306945 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 306945 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 306950 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306954 */     GIR_RootConstrainSelectedInstOperands,
     /* 306955 */     // GIR_Coverage, 622,
     /* 306955 */     GIR_Done,
     /* 306956 */   // Label 6144: @306956
     /* 306956 */   GIM_Reject,
     /* 306957 */ // Label 6135: @306957
     /* 306957 */ GIM_Reject,
     /* 306958 */ // Label 6115: @306958
     /* 306958 */ GIM_Try, /*On fail goto*//*Label 6145*/ GIMT_Encode4(307587),
     /* 306963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 306966 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 306969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306973 */   GIM_Try, /*On fail goto*//*Label 6146*/ GIMT_Encode4(307086), // Rule ID 6311 //
     /* 306978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 306993 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306997 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307002 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 307006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 307010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307014 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 307018 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 307022 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307027 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 307031 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307035 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 307039 */     // MIs[3] Operand 1
     /* 307039 */     // No operand predicates
     /* 307039 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 307041 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 307041 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 307044 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307048 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307053 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 307059 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307064 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 307072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 307081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 307084 */     GIR_RootConstrainSelectedInstOperands,
     /* 307085 */     // GIR_Coverage, 6311,
     /* 307085 */     GIR_EraseRootFromParent_Done,
     /* 307086 */   // Label 6146: @307086
     /* 307086 */   GIM_Try, /*On fail goto*//*Label 6147*/ GIMT_Encode4(307199), // Rule ID 14070 //
     /* 307091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 307106 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307110 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307123 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 307127 */     // MIs[2] Operand 1
     /* 307127 */     // No operand predicates
     /* 307127 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 307131 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307135 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 307139 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 307143 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307148 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 307152 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 307154 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 307154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 307157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307166 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 307172 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307177 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 307185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307194 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 307197 */     GIR_RootConstrainSelectedInstOperands,
     /* 307198 */     // GIR_Coverage, 14070,
     /* 307198 */     GIR_EraseRootFromParent_Done,
     /* 307199 */   // Label 6147: @307199
     /* 307199 */   GIM_Try, /*On fail goto*//*Label 6148*/ GIMT_Encode4(307275), // Rule ID 14004 //
     /* 307204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 307216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307225 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 307229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307235 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 307235 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 307238 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307242 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307247 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 307253 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307258 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 307266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 307270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307273 */     GIR_RootConstrainSelectedInstOperands,
     /* 307274 */     // GIR_Coverage, 14004,
     /* 307274 */     GIR_EraseRootFromParent_Done,
     /* 307275 */   // Label 6148: @307275
     /* 307275 */   GIM_Try, /*On fail goto*//*Label 6149*/ GIMT_Encode4(307351), // Rule ID 4868 //
     /* 307280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 307296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307305 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 307309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307311 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 307311 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 307314 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307318 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307323 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 307329 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307334 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 307342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307344 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 307346 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307349 */     GIR_RootConstrainSelectedInstOperands,
     /* 307350 */     // GIR_Coverage, 4868,
     /* 307350 */     GIR_EraseRootFromParent_Done,
     /* 307351 */   // Label 6149: @307351
     /* 307351 */   GIM_Try, /*On fail goto*//*Label 6150*/ GIMT_Encode4(307414), // Rule ID 13610 //
     /* 307356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 307371 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307388 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 307392 */     // MIs[2] Operand 1
     /* 307392 */     // No operand predicates
     /* 307392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307396 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307398 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 307398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 307401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 307405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 307412 */     GIR_RootConstrainSelectedInstOperands,
     /* 307413 */     // GIR_Coverage, 13610,
     /* 307413 */     GIR_EraseRootFromParent_Done,
     /* 307414 */   // Label 6150: @307414
     /* 307414 */   GIM_Try, /*On fail goto*//*Label 6151*/ GIMT_Encode4(307477), // Rule ID 2016 //
     /* 307419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 307438 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307442 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307455 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 307459 */     // MIs[2] Operand 1
     /* 307459 */     // No operand predicates
     /* 307459 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307461 */     // (fmul:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 307461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 307464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307466 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 307468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307472 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 307475 */     GIR_RootConstrainSelectedInstOperands,
     /* 307476 */     // GIR_Coverage, 2016,
     /* 307476 */     GIR_EraseRootFromParent_Done,
     /* 307477 */   // Label 6151: @307477
     /* 307477 */   GIM_Try, /*On fail goto*//*Label 6152*/ GIMT_Encode4(307518), // Rule ID 4871 //
     /* 307482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 307490 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 307494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307505 */     // (fmul:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$a), FPR64:{ *:[f64] }:$b)  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 307505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 307508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 307514 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 307516 */     GIR_RootConstrainSelectedInstOperands,
     /* 307517 */     // GIR_Coverage, 4871,
     /* 307517 */     GIR_EraseRootFromParent_Done,
     /* 307518 */   // Label 6152: @307518
     /* 307518 */   GIM_Try, /*On fail goto*//*Label 6153*/ GIMT_Encode4(307559), // Rule ID 14007 //
     /* 307523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 307535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 307539 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307544 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307546 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$b, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$a))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 307546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 307549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 307555 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 307557 */     GIR_RootConstrainSelectedInstOperands,
     /* 307558 */     // GIR_Coverage, 14007,
     /* 307558 */     GIR_EraseRootFromParent_Done,
     /* 307559 */   // Label 6153: @307559
     /* 307559 */   GIM_Try, /*On fail goto*//*Label 6154*/ GIMT_Encode4(307586), // Rule ID 624 //
     /* 307564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 307567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307575 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 307575 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 307580 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 307584 */     GIR_RootConstrainSelectedInstOperands,
     /* 307585 */     // GIR_Coverage, 624,
     /* 307585 */     GIR_Done,
     /* 307586 */   // Label 6154: @307586
     /* 307586 */   GIM_Reject,
     /* 307587 */ // Label 6145: @307587
     /* 307587 */ GIM_Reject,
     /* 307588 */ // Label 6116: @307588
     /* 307588 */ GIM_Try, /*On fail goto*//*Label 6155*/ GIMT_Encode4(308117),
     /* 307593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 307596 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 307599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307603 */   GIM_Try, /*On fail goto*//*Label 6156*/ GIMT_Encode4(307689), // Rule ID 13599 //
     /* 307608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 307619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 307623 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 307627 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 307631 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 307635 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 307639 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307644 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 307648 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307652 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 307656 */     // MIs[3] Operand 1
     /* 307656 */     // No operand predicates
     /* 307656 */     // MIs[1] Operand 2
     /* 307656 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 307667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307671 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 307673 */     // (fmul:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 307673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 307676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 307680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 307684 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 307687 */     GIR_RootConstrainSelectedInstOperands,
     /* 307688 */     // GIR_Coverage, 13599,
     /* 307688 */     GIR_EraseRootFromParent_Done,
     /* 307689 */   // Label 6156: @307689
     /* 307689 */   GIM_Try, /*On fail goto*//*Label 6157*/ GIMT_Encode4(307775), // Rule ID 2005 //
     /* 307694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 307709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 307713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 307717 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 307721 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 307725 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 307729 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307734 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 307738 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307742 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 307746 */     // MIs[3] Operand 1
     /* 307746 */     // No operand predicates
     /* 307746 */     // MIs[1] Operand 2
     /* 307746 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 307757 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 307759 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 307759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 307762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307764 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 307766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 307770 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 307773 */     GIR_RootConstrainSelectedInstOperands,
     /* 307774 */     // GIR_Coverage, 2005,
     /* 307774 */     GIR_EraseRootFromParent_Done,
     /* 307775 */   // Label 6157: @307775
     /* 307775 */   GIM_Try, /*On fail goto*//*Label 6158*/ GIMT_Encode4(307838), // Rule ID 13600 //
     /* 307780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 307791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 307795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307812 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 307816 */     // MIs[2] Operand 1
     /* 307816 */     // No operand predicates
     /* 307816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307820 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307822 */     // (fmul:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 307822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 307825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 307829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307833 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 307836 */     GIR_RootConstrainSelectedInstOperands,
     /* 307837 */     // GIR_Coverage, 13600,
     /* 307837 */     GIR_EraseRootFromParent_Done,
     /* 307838 */   // Label 6158: @307838
     /* 307838 */   GIM_Try, /*On fail goto*//*Label 6159*/ GIMT_Encode4(307901), // Rule ID 2006 //
     /* 307843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 307858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 307862 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307866 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307871 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307875 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307879 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 307883 */     // MIs[2] Operand 1
     /* 307883 */     // No operand predicates
     /* 307883 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307885 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 307885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 307888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307890 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 307892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307896 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 307899 */     GIR_RootConstrainSelectedInstOperands,
     /* 307900 */     // GIR_Coverage, 2006,
     /* 307900 */     GIR_EraseRootFromParent_Done,
     /* 307901 */   // Label 6159: @307901
     /* 307901 */   GIM_Try, /*On fail goto*//*Label 6160*/ GIMT_Encode4(307995), // Rule ID 14072 //
     /* 307906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 307914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 307918 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307929 */     // (fmul:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 307929 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 307932 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 307936 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307941 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 307943 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 307946 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 307950 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307955 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 307958 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307962 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 307965 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307970 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307975 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 307983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 307987 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307993 */     GIR_RootConstrainSelectedInstOperands,
     /* 307994 */     // GIR_Coverage, 14072,
     /* 307994 */     GIR_EraseRootFromParent_Done,
     /* 307995 */   // Label 6160: @307995
     /* 307995 */   GIM_Try, /*On fail goto*//*Label 6161*/ GIMT_Encode4(308089), // Rule ID 6313 //
     /* 308000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 308008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 308012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 308016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308023 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 308023 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 308026 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 308030 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 308037 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 308040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 308044 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308049 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 308052 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308056 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 308059 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308064 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308069 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 308077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308079 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 308081 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308087 */     GIR_RootConstrainSelectedInstOperands,
     /* 308088 */     // GIR_Coverage, 6313,
     /* 308088 */     GIR_EraseRootFromParent_Done,
     /* 308089 */   // Label 6161: @308089
     /* 308089 */   GIM_Try, /*On fail goto*//*Label 6162*/ GIMT_Encode4(308116), // Rule ID 1323 //
     /* 308094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 308097 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308105 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 308105 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f32),
     /* 308110 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 308114 */     GIR_RootConstrainSelectedInstOperands,
     /* 308115 */     // GIR_Coverage, 1323,
     /* 308115 */     GIR_Done,
     /* 308116 */   // Label 6162: @308116
     /* 308116 */   GIM_Reject,
     /* 308117 */ // Label 6155: @308117
     /* 308117 */ GIM_Reject,
     /* 308118 */ // Label 6117: @308118
     /* 308118 */ GIM_Try, /*On fail goto*//*Label 6163*/ GIMT_Encode4(308475),
     /* 308123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 308126 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 308129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308133 */   GIM_Try, /*On fail goto*//*Label 6164*/ GIMT_Encode4(308196), // Rule ID 13604 //
     /* 308138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 308141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 308149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 308153 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 308157 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 308166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 308170 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 308174 */     // MIs[2] Operand 1
     /* 308174 */     // No operand predicates
     /* 308174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308178 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308180 */     // (fmul:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 308180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 308183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 308187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 308194 */     GIR_RootConstrainSelectedInstOperands,
     /* 308195 */     // GIR_Coverage, 13604,
     /* 308195 */     GIR_EraseRootFromParent_Done,
     /* 308196 */   // Label 6164: @308196
     /* 308196 */   GIM_Try, /*On fail goto*//*Label 6165*/ GIMT_Encode4(308259), // Rule ID 2010 //
     /* 308201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 308204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 308212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 308216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 308220 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 308224 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 308233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 308237 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 308241 */     // MIs[2] Operand 1
     /* 308241 */     // No operand predicates
     /* 308241 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308243 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 308243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 308246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308248 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 308250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308254 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 308257 */     GIR_RootConstrainSelectedInstOperands,
     /* 308258 */     // GIR_Coverage, 2010,
     /* 308258 */     GIR_EraseRootFromParent_Done,
     /* 308259 */   // Label 6165: @308259
     /* 308259 */   GIM_Try, /*On fail goto*//*Label 6166*/ GIMT_Encode4(308353), // Rule ID 14076 //
     /* 308264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 308272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 308276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308287 */     // (fmul:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 308287 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 308290 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 308294 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308299 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 308301 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 308304 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 308308 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308313 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 308316 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308320 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 308323 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308328 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308333 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 308341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 308345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308351 */     GIR_RootConstrainSelectedInstOperands,
     /* 308352 */     // GIR_Coverage, 14076,
     /* 308352 */     GIR_EraseRootFromParent_Done,
     /* 308353 */   // Label 6166: @308353
     /* 308353 */   GIM_Try, /*On fail goto*//*Label 6167*/ GIMT_Encode4(308447), // Rule ID 6317 //
     /* 308358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 308366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 308370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 308374 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308381 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 308381 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 308384 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 308388 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 308395 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 308398 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 308402 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308407 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 308410 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308414 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 308417 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308422 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308427 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 308435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308437 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 308439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308445 */     GIR_RootConstrainSelectedInstOperands,
     /* 308446 */     // GIR_Coverage, 6317,
     /* 308446 */     GIR_EraseRootFromParent_Done,
     /* 308447 */   // Label 6167: @308447
     /* 308447 */   GIM_Try, /*On fail goto*//*Label 6168*/ GIMT_Encode4(308474), // Rule ID 1327 //
     /* 308452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 308455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308463 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 308463 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f64),
     /* 308468 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 308472 */     GIR_RootConstrainSelectedInstOperands,
     /* 308473 */     // GIR_Coverage, 1327,
     /* 308473 */     GIR_Done,
     /* 308474 */   // Label 6168: @308474
     /* 308474 */   GIM_Reject,
     /* 308475 */ // Label 6163: @308475
     /* 308475 */ GIM_Reject,
     /* 308476 */ // Label 6118: @308476
     /* 308476 */ GIM_Try, /*On fail goto*//*Label 6169*/ GIMT_Encode4(308817),
     /* 308481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 308484 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 308487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308491 */   GIM_Try, /*On fail goto*//*Label 6170*/ GIMT_Encode4(308577), // Rule ID 13593 //
     /* 308496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 308507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308511 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 308515 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 308519 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308523 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 308527 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 308532 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 308536 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 308540 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 308544 */     // MIs[3] Operand 1
     /* 308544 */     // No operand predicates
     /* 308544 */     // MIs[1] Operand 2
     /* 308544 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 308555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308559 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 308561 */     // (fmul:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 308561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 308564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 308568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 308572 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 308575 */     GIR_RootConstrainSelectedInstOperands,
     /* 308576 */     // GIR_Coverage, 13593,
     /* 308576 */     GIR_EraseRootFromParent_Done,
     /* 308577 */   // Label 6170: @308577
     /* 308577 */   GIM_Try, /*On fail goto*//*Label 6171*/ GIMT_Encode4(308663), // Rule ID 1999 //
     /* 308582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 308593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 308597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308601 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 308605 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 308609 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308613 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 308617 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 308622 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 308626 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 308630 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 308634 */     // MIs[3] Operand 1
     /* 308634 */     // No operand predicates
     /* 308634 */     // MIs[1] Operand 2
     /* 308634 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 308645 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 308647 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 308647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 308650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308652 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 308654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 308658 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 308661 */     GIR_RootConstrainSelectedInstOperands,
     /* 308662 */     // GIR_Coverage, 1999,
     /* 308662 */     GIR_EraseRootFromParent_Done,
     /* 308663 */   // Label 6171: @308663
     /* 308663 */   GIM_Try, /*On fail goto*//*Label 6172*/ GIMT_Encode4(308726), // Rule ID 13594 //
     /* 308668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 308679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308683 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 308687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 308692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 308696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 308700 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 308704 */     // MIs[2] Operand 1
     /* 308704 */     // No operand predicates
     /* 308704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308708 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308710 */     // (fmul:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 308710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 308713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 308717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 308724 */     GIR_RootConstrainSelectedInstOperands,
     /* 308725 */     // GIR_Coverage, 13594,
     /* 308725 */     GIR_EraseRootFromParent_Done,
     /* 308726 */   // Label 6172: @308726
     /* 308726 */   GIM_Try, /*On fail goto*//*Label 6173*/ GIMT_Encode4(308789), // Rule ID 2000 //
     /* 308731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 308742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 308746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308750 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 308754 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 308759 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 308763 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 308767 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 308771 */     // MIs[2] Operand 1
     /* 308771 */     // No operand predicates
     /* 308771 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308773 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 308773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 308776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308778 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 308780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308784 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 308787 */     GIR_RootConstrainSelectedInstOperands,
     /* 308788 */     // GIR_Coverage, 2000,
     /* 308788 */     GIR_EraseRootFromParent_Done,
     /* 308789 */   // Label 6173: @308789
     /* 308789 */   GIM_Try, /*On fail goto*//*Label 6174*/ GIMT_Encode4(308816), // Rule ID 1319 //
     /* 308794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308805 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 308805 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f16),
     /* 308810 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 308814 */     GIR_RootConstrainSelectedInstOperands,
     /* 308815 */     // GIR_Coverage, 1319,
     /* 308815 */     GIR_Done,
     /* 308816 */   // Label 6174: @308816
     /* 308816 */   GIM_Reject,
     /* 308817 */ // Label 6169: @308817
     /* 308817 */ GIM_Reject,
     /* 308818 */ // Label 6119: @308818
     /* 308818 */ GIM_Try, /*On fail goto*//*Label 6175*/ GIMT_Encode4(309175),
     /* 308823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 308826 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 308829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308833 */   GIM_Try, /*On fail goto*//*Label 6176*/ GIMT_Encode4(308896), // Rule ID 13602 //
     /* 308838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 308841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 308849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 308853 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 308857 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 308866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 308870 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 308874 */     // MIs[2] Operand 1
     /* 308874 */     // No operand predicates
     /* 308874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308878 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308880 */     // (fmul:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 308880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 308883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 308887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 308894 */     GIR_RootConstrainSelectedInstOperands,
     /* 308895 */     // GIR_Coverage, 13602,
     /* 308895 */     GIR_EraseRootFromParent_Done,
     /* 308896 */   // Label 6176: @308896
     /* 308896 */   GIM_Try, /*On fail goto*//*Label 6177*/ GIMT_Encode4(308959), // Rule ID 2008 //
     /* 308901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 308904 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 308912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 308916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 308920 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 308924 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 308933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 308937 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 308941 */     // MIs[2] Operand 1
     /* 308941 */     // No operand predicates
     /* 308941 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308943 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 308943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 308946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308948 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 308950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308954 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 308957 */     GIR_RootConstrainSelectedInstOperands,
     /* 308958 */     // GIR_Coverage, 2008,
     /* 308958 */     GIR_EraseRootFromParent_Done,
     /* 308959 */   // Label 6177: @308959
     /* 308959 */   GIM_Try, /*On fail goto*//*Label 6178*/ GIMT_Encode4(309053), // Rule ID 14074 //
     /* 308964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 308972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 308976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308987 */     // (fmul:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 308987 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 308990 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 308994 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308999 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 309001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 309004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 309008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309013 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 309016 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 309020 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 309023 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309028 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309033 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 309041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 309045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309051 */     GIR_RootConstrainSelectedInstOperands,
     /* 309052 */     // GIR_Coverage, 14074,
     /* 309052 */     GIR_EraseRootFromParent_Done,
     /* 309053 */   // Label 6178: @309053
     /* 309053 */   GIM_Try, /*On fail goto*//*Label 6179*/ GIMT_Encode4(309147), // Rule ID 6315 //
     /* 309058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 309066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 309070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 309074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309081 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 309081 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 309084 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 309088 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309093 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 309095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 309098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 309102 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309107 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 309110 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 309114 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 309117 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309122 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309127 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 309135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309137 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 309139 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309145 */     GIR_RootConstrainSelectedInstOperands,
     /* 309146 */     // GIR_Coverage, 6315,
     /* 309146 */     GIR_EraseRootFromParent_Done,
     /* 309147 */   // Label 6179: @309147
     /* 309147 */   GIM_Try, /*On fail goto*//*Label 6180*/ GIMT_Encode4(309174), // Rule ID 1325 //
     /* 309152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 309155 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309163 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 309163 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 309168 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 309172 */     GIR_RootConstrainSelectedInstOperands,
     /* 309173 */     // GIR_Coverage, 1325,
     /* 309173 */     GIR_Done,
     /* 309174 */   // Label 6180: @309174
     /* 309174 */   GIM_Reject,
     /* 309175 */ // Label 6175: @309175
     /* 309175 */ GIM_Reject,
     /* 309176 */ // Label 6120: @309176
     /* 309176 */ GIM_Try, /*On fail goto*//*Label 6181*/ GIMT_Encode4(309607),
     /* 309181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309184 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 309187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309191 */   GIM_Try, /*On fail goto*//*Label 6182*/ GIMT_Encode4(309254), // Rule ID 13596 //
     /* 309196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 309199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 309207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 309220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 309224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 309228 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 309232 */     // MIs[2] Operand 1
     /* 309232 */     // No operand predicates
     /* 309232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309236 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309238 */     // (fmul:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 309238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 309241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 309245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 309249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 309252 */     GIR_RootConstrainSelectedInstOperands,
     /* 309253 */     // GIR_Coverage, 13596,
     /* 309253 */     GIR_EraseRootFromParent_Done,
     /* 309254 */   // Label 6182: @309254
     /* 309254 */   GIM_Try, /*On fail goto*//*Label 6183*/ GIMT_Encode4(309317), // Rule ID 2002 //
     /* 309259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 309262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 309270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 309274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309278 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 309287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 309291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 309295 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 309299 */     // MIs[2] Operand 1
     /* 309299 */     // No operand predicates
     /* 309299 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309301 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 309301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 309304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309306 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 309308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 309312 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 309315 */     GIR_RootConstrainSelectedInstOperands,
     /* 309316 */     // GIR_Coverage, 2002,
     /* 309316 */     GIR_EraseRootFromParent_Done,
     /* 309317 */   // Label 6183: @309317
     /* 309317 */   GIM_Try, /*On fail goto*//*Label 6184*/ GIMT_Encode4(309344), // Rule ID 1321 //
     /* 309322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 309325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309333 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 309333 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv8f16),
     /* 309338 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 309342 */     GIR_RootConstrainSelectedInstOperands,
     /* 309343 */     // GIR_Coverage, 1321,
     /* 309343 */     GIR_Done,
     /* 309344 */   // Label 6184: @309344
     /* 309344 */   GIM_Try, /*On fail goto*//*Label 6185*/ GIMT_Encode4(309606), // Rule ID 7086 //
     /* 309349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 309352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309360 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FMULv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FMULv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 309360 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 309363 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 309367 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309372 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 309376 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 309378 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 309381 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 309385 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309390 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 309394 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 309396 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 309399 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 309403 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309408 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 309411 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 309414 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 309416 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 309419 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309423 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309428 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 309434 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309439 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309444 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 309447 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 309451 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309456 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 309459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 309461 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 309464 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309468 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309473 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 309479 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309484 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309489 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 309492 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 309496 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309501 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 309504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 309506 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 309509 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 309513 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309518 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 309521 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 309524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 309526 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 309529 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 309533 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309538 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 309541 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 309543 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 309546 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 309550 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309555 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 309557 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 309560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 309564 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309569 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 309572 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 309575 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 309578 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309583 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309588 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 309596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 309598 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 309604 */     GIR_RootConstrainSelectedInstOperands,
     /* 309605 */     // GIR_Coverage, 7086,
     /* 309605 */     GIR_EraseRootFromParent_Done,
     /* 309606 */   // Label 6185: @309606
     /* 309606 */   GIM_Reject,
     /* 309607 */ // Label 6181: @309607
     /* 309607 */ GIM_Reject,
     /* 309608 */ // Label 6121: @309608
     /* 309608 */ GIM_Try, /*On fail goto*//*Label 6186*/ GIMT_Encode4(309921),
     /* 309613 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 309616 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 309619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 309623 */   GIM_Try, /*On fail goto*//*Label 6187*/ GIMT_Encode4(309678), // Rule ID 13829 //
     /* 309628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 309631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 309639 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 309642 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 309647 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 309651 */     // MIs[1] idx
     /* 309651 */     GIM_CheckIsImm, /*MI*/1, /*Op*/3,
     /* 309654 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 309659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309661 */     // (fmul:{ *:[nxv2f64] } (intrinsic_wo_chain:{ *:[nxv2f64] } 1355:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx), nxv2f64:{ *:[nxv2f64] }:$Op1)  =>  (FMUL_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 309661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_D),
     /* 309664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 309666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 309668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 309672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // idx
     /* 309676 */     GIR_RootConstrainSelectedInstOperands,
     /* 309677 */     // GIR_Coverage, 13829,
     /* 309677 */     GIR_EraseRootFromParent_Done,
     /* 309678 */   // Label 6187: @309678
     /* 309678 */   GIM_Try, /*On fail goto*//*Label 6188*/ GIMT_Encode4(309733), // Rule ID 2863 //
     /* 309683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 309686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 309690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 309694 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 309697 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 309702 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 309706 */     // MIs[1] idx
     /* 309706 */     GIM_CheckIsImm, /*MI*/1, /*Op*/3,
     /* 309709 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 309714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309716 */     // (fmul:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, (intrinsic_wo_chain:{ *:[nxv2f64] } 1355:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx))  =>  (FMUL_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 309716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_D),
     /* 309719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 309721 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 309723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 309727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // idx
     /* 309731 */     GIR_RootConstrainSelectedInstOperands,
     /* 309732 */     // GIR_Coverage, 2863,
     /* 309732 */     GIR_EraseRootFromParent_Done,
     /* 309733 */   // Label 6188: @309733
     /* 309733 */   GIM_Try, /*On fail goto*//*Label 6189*/ GIMT_Encode4(309776), // Rule ID 15195 //
     /* 309738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 309741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_TRN1),
     /* 309749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 309753 */     // MIs[1] R
     /* 309753 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 309758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309760 */     // (fmul:{ *:[nxv2f64] } (AArch64trn1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$R, nxv2f64:{ *:[nxv2f64] }:$R), nxv2f64:{ *:[nxv2f64] }:$L)  =>  (FMUL_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$L, ?:{ *:[nxv2f64] }:$R, 0:{ *:[i32] })
     /* 309760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_D),
     /* 309763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 309765 */     GIR_RootToRootCopy, /*OpIdx*/2, // L
     /* 309767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // R
     /* 309771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309774 */     GIR_RootConstrainSelectedInstOperands,
     /* 309775 */     // GIR_Coverage, 15195,
     /* 309775 */     GIR_EraseRootFromParent_Done,
     /* 309776 */   // Label 6189: @309776
     /* 309776 */   GIM_Try, /*On fail goto*//*Label 6190*/ GIMT_Encode4(309819), // Rule ID 15196 //
     /* 309781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 309784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_TRN2),
     /* 309792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 309796 */     // MIs[1] R
     /* 309796 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 309801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309803 */     // (fmul:{ *:[nxv2f64] } (AArch64trn2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$R, nxv2f64:{ *:[nxv2f64] }:$R), nxv2f64:{ *:[nxv2f64] }:$L)  =>  (FMUL_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$L, ?:{ *:[nxv2f64] }:$R, 1:{ *:[i32] })
     /* 309803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_D),
     /* 309806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 309808 */     GIR_RootToRootCopy, /*OpIdx*/2, // L
     /* 309810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // R
     /* 309814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 309817 */     GIR_RootConstrainSelectedInstOperands,
     /* 309818 */     // GIR_Coverage, 15196,
     /* 309818 */     GIR_EraseRootFromParent_Done,
     /* 309819 */   // Label 6190: @309819
     /* 309819 */   GIM_Try, /*On fail goto*//*Label 6191*/ GIMT_Encode4(309862), // Rule ID 8401 //
     /* 309824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 309827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 309831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_TRN1),
     /* 309835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 309839 */     // MIs[1] R
     /* 309839 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 309844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309846 */     // (fmul:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$L, (AArch64trn1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$R, nxv2f64:{ *:[nxv2f64] }:$R))  =>  (FMUL_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$L, ?:{ *:[nxv2f64] }:$R, 0:{ *:[i32] })
     /* 309846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_D),
     /* 309849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 309851 */     GIR_RootToRootCopy, /*OpIdx*/1, // L
     /* 309853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // R
     /* 309857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309860 */     GIR_RootConstrainSelectedInstOperands,
     /* 309861 */     // GIR_Coverage, 8401,
     /* 309861 */     GIR_EraseRootFromParent_Done,
     /* 309862 */   // Label 6191: @309862
     /* 309862 */   GIM_Try, /*On fail goto*//*Label 6192*/ GIMT_Encode4(309905), // Rule ID 8404 //
     /* 309867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 309870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 309874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_TRN2),
     /* 309878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 309882 */     // MIs[1] R
     /* 309882 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 309887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309889 */     // (fmul:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$L, (AArch64trn2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$R, nxv2f64:{ *:[nxv2f64] }:$R))  =>  (FMUL_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$L, ?:{ *:[nxv2f64] }:$R, 1:{ *:[i32] })
     /* 309889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_D),
     /* 309892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 309894 */     GIR_RootToRootCopy, /*OpIdx*/1, // L
     /* 309896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // R
     /* 309900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 309903 */     GIR_RootConstrainSelectedInstOperands,
     /* 309904 */     // GIR_Coverage, 8404,
     /* 309904 */     GIR_EraseRootFromParent_Done,
     /* 309905 */   // Label 6192: @309905
     /* 309905 */   GIM_Try, /*On fail goto*//*Label 6193*/ GIMT_Encode4(309920), // Rule ID 8296 //
     /* 309910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 309913 */     // (fmul:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMUL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 309913 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_D),
     /* 309918 */     GIR_RootConstrainSelectedInstOperands,
     /* 309919 */     // GIR_Coverage, 8296,
     /* 309919 */     GIR_Done,
     /* 309920 */   // Label 6193: @309920
     /* 309920 */   GIM_Reject,
     /* 309921 */ // Label 6186: @309921
     /* 309921 */ GIM_Reject,
     /* 309922 */ // Label 6122: @309922
     /* 309922 */ GIM_Try, /*On fail goto*//*Label 6194*/ GIMT_Encode4(310063),
     /* 309927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 309930 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 309933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 309937 */   GIM_Try, /*On fail goto*//*Label 6195*/ GIMT_Encode4(309992), // Rule ID 13828 //
     /* 309942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 309945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 309953 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 309956 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 309961 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 309965 */     // MIs[1] idx
     /* 309965 */     GIM_CheckIsImm, /*MI*/1, /*Op*/3,
     /* 309968 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 309973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309975 */     // (fmul:{ *:[nxv4f32] } (intrinsic_wo_chain:{ *:[nxv4f32] } 1355:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx), nxv4f32:{ *:[nxv4f32] }:$Op1)  =>  (FMUL_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 309975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_S),
     /* 309978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 309980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 309982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 309986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // idx
     /* 309990 */     GIR_RootConstrainSelectedInstOperands,
     /* 309991 */     // GIR_Coverage, 13828,
     /* 309991 */     GIR_EraseRootFromParent_Done,
     /* 309992 */   // Label 6195: @309992
     /* 309992 */   GIM_Try, /*On fail goto*//*Label 6196*/ GIMT_Encode4(310047), // Rule ID 2859 //
     /* 309997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 310000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 310004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 310008 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 310011 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 310016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 310020 */     // MIs[1] idx
     /* 310020 */     GIM_CheckIsImm, /*MI*/1, /*Op*/3,
     /* 310023 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 310028 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310030 */     // (fmul:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, (intrinsic_wo_chain:{ *:[nxv4f32] } 1355:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx))  =>  (FMUL_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 310030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_S),
     /* 310033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 310035 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 310037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 310041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // idx
     /* 310045 */     GIR_RootConstrainSelectedInstOperands,
     /* 310046 */     // GIR_Coverage, 2859,
     /* 310046 */     GIR_EraseRootFromParent_Done,
     /* 310047 */   // Label 6196: @310047
     /* 310047 */   GIM_Try, /*On fail goto*//*Label 6197*/ GIMT_Encode4(310062), // Rule ID 8293 //
     /* 310052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 310055 */     // (fmul:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMUL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 310055 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_S),
     /* 310060 */     GIR_RootConstrainSelectedInstOperands,
     /* 310061 */     // GIR_Coverage, 8293,
     /* 310061 */     GIR_Done,
     /* 310062 */   // Label 6197: @310062
     /* 310062 */   GIM_Reject,
     /* 310063 */ // Label 6194: @310063
     /* 310063 */ GIM_Reject,
     /* 310064 */ // Label 6123: @310064
     /* 310064 */ GIM_Try, /*On fail goto*//*Label 6198*/ GIMT_Encode4(310205),
     /* 310069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 310072 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 310075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 310079 */   GIM_Try, /*On fail goto*//*Label 6199*/ GIMT_Encode4(310134), // Rule ID 13827 //
     /* 310084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 310087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 310095 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 310098 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 310103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 310107 */     // MIs[1] idx
     /* 310107 */     GIM_CheckIsImm, /*MI*/1, /*Op*/3,
     /* 310110 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 310115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310117 */     // (fmul:{ *:[nxv8f16] } (intrinsic_wo_chain:{ *:[nxv8f16] } 1355:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx), nxv8f16:{ *:[nxv8f16] }:$Op1)  =>  (FMUL_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 310117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_H),
     /* 310120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 310122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 310124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 310128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // idx
     /* 310132 */     GIR_RootConstrainSelectedInstOperands,
     /* 310133 */     // GIR_Coverage, 13827,
     /* 310133 */     GIR_EraseRootFromParent_Done,
     /* 310134 */   // Label 6199: @310134
     /* 310134 */   GIM_Try, /*On fail goto*//*Label 6200*/ GIMT_Encode4(310189), // Rule ID 2855 //
     /* 310139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 310142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 310146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 310150 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 310153 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 310158 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 310162 */     // MIs[1] idx
     /* 310162 */     GIM_CheckIsImm, /*MI*/1, /*Op*/3,
     /* 310165 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 310170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310172 */     // (fmul:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, (intrinsic_wo_chain:{ *:[nxv8f16] } 1355:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx))  =>  (FMUL_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 310172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_H),
     /* 310175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 310177 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 310179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 310183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // idx
     /* 310187 */     GIR_RootConstrainSelectedInstOperands,
     /* 310188 */     // GIR_Coverage, 2855,
     /* 310188 */     GIR_EraseRootFromParent_Done,
     /* 310189 */   // Label 6200: @310189
     /* 310189 */   GIM_Try, /*On fail goto*//*Label 6201*/ GIMT_Encode4(310204), // Rule ID 8290 //
     /* 310194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 310197 */     // (fmul:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMUL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 310197 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_H),
     /* 310202 */     GIR_RootConstrainSelectedInstOperands,
     /* 310203 */     // GIR_Coverage, 8290,
     /* 310203 */     GIR_Done,
     /* 310204 */   // Label 6201: @310204
     /* 310204 */   GIM_Reject,
     /* 310205 */ // Label 6198: @310205
     /* 310205 */ GIM_Reject,
     /* 310206 */ // Label 6124: @310206
     /* 310206 */ GIM_Reject,
     /* 310207 */ // Label 62: @310207
     /* 310207 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6210*/ GIMT_Encode4(326479),
     /* 310218 */ /*GILLT_s16*//*Label 6202*/ GIMT_Encode4(310258),
     /* 310222 */ /*GILLT_s32*//*Label 6203*/ GIMT_Encode4(313262),
     /* 310226 */ /*GILLT_s64*//*Label 6204*/ GIMT_Encode4(316410), GIMT_Encode4(0),
     /* 310234 */ /*GILLT_v2s32*//*Label 6205*/ GIMT_Encode4(319558),
     /* 310238 */ /*GILLT_v2s64*//*Label 6206*/ GIMT_Encode4(321079),
     /* 310242 */ /*GILLT_v4s16*//*Label 6207*/ GIMT_Encode4(322600),
     /* 310246 */ /*GILLT_v4s32*//*Label 6208*/ GIMT_Encode4(323779), GIMT_Encode4(0),
     /* 310254 */ /*GILLT_v8s16*//*Label 6209*/ GIMT_Encode4(325300),
     /* 310258 */ // Label 6202: @310258
     /* 310258 */ GIM_Try, /*On fail goto*//*Label 6211*/ GIMT_Encode4(313261),
     /* 310263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 310266 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 310269 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 310272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310276 */   GIM_Try, /*On fail goto*//*Label 6212*/ GIMT_Encode4(310426), // Rule ID 4926 //
     /* 310281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310305 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 310309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 310313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310317 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310321 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 310325 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310330 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 310334 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 310338 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310342 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 310346 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310351 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 310353 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 310353 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 310356 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310360 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310365 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 310371 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310376 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310393 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 310399 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310404 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 310412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310414 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 310420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 310424 */     GIR_RootConstrainSelectedInstOperands,
     /* 310425 */     // GIR_Coverage, 4926,
     /* 310425 */     GIR_EraseRootFromParent_Done,
     /* 310426 */   // Label 6212: @310426
     /* 310426 */   GIM_Try, /*On fail goto*//*Label 6213*/ GIMT_Encode4(310573), // Rule ID 4890 //
     /* 310431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310446 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310450 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310455 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 310459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 310463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310467 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 310471 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 310475 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310479 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310483 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 310487 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310492 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 310496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310500 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 310502 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 310502 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 310505 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310509 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310514 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 310520 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310525 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310530 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310533 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310537 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310542 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 310548 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310553 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 310561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310563 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310566 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 310569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 310571 */     GIR_RootConstrainSelectedInstOperands,
     /* 310572 */     // GIR_Coverage, 4890,
     /* 310572 */     GIR_EraseRootFromParent_Done,
     /* 310573 */   // Label 6213: @310573
     /* 310573 */   GIM_Try, /*On fail goto*//*Label 6214*/ GIMT_Encode4(310720), // Rule ID 14013 //
     /* 310578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310593 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 310597 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310601 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310605 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 310609 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310614 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 310618 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 310622 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310626 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310630 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 310634 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310639 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 310643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310647 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 310649 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 310649 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 310652 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310656 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310661 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 310667 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310672 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310677 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310680 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310684 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310689 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 310695 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310700 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 310708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 310716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 310718 */     GIR_RootConstrainSelectedInstOperands,
     /* 310719 */     // GIR_Coverage, 14013,
     /* 310719 */     GIR_EraseRootFromParent_Done,
     /* 310720 */   // Label 6214: @310720
     /* 310720 */   GIM_Try, /*On fail goto*//*Label 6215*/ GIMT_Encode4(310851), // Rule ID 6145 //
     /* 310725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310740 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310744 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310749 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 310753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 310757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310761 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 310765 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 310769 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310773 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310777 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 310781 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 310786 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 310790 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 310794 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 310798 */     // MIs[4] Operand 1
     /* 310798 */     // No operand predicates
     /* 310798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310802 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 310804 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 310804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310816 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 310822 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310827 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 310835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 310837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 310839 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 310846 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 310849 */     GIR_RootConstrainSelectedInstOperands,
     /* 310850 */     // GIR_Coverage, 6145,
     /* 310850 */     GIR_EraseRootFromParent_Done,
     /* 310851 */   // Label 6215: @310851
     /* 310851 */   GIM_Try, /*On fail goto*//*Label 6216*/ GIMT_Encode4(310982), // Rule ID 6177 //
     /* 310856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310871 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 310880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 310884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 310888 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 310892 */     // MIs[2] Operand 1
     /* 310892 */     // No operand predicates
     /* 310892 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 310896 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310900 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 310904 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 310908 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310912 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310916 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 310920 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310925 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 310929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310933 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 310935 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 310935 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310938 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310942 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310947 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 310953 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310958 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 310966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 310968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 310970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 310977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 310980 */     GIR_RootConstrainSelectedInstOperands,
     /* 310981 */     // GIR_Coverage, 6177,
     /* 310981 */     GIR_EraseRootFromParent_Done,
     /* 310982 */   // Label 6216: @310982
     /* 310982 */   GIM_Try, /*On fail goto*//*Label 6217*/ GIMT_Encode4(311113), // Rule ID 6241 //
     /* 310987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 311006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311010 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311014 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 311018 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311023 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 311027 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 311031 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311035 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311039 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 311043 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 311048 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 311052 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 311056 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 311060 */     // MIs[4] Operand 1
     /* 311060 */     // No operand predicates
     /* 311060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311064 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 311066 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 311066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 311069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311078 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 311084 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311089 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 311097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 311099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 311101 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 311108 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 311111 */     GIR_RootConstrainSelectedInstOperands,
     /* 311112 */     // GIR_Coverage, 6241,
     /* 311112 */     GIR_EraseRootFromParent_Done,
     /* 311113 */   // Label 6217: @311113
     /* 311113 */   GIM_Try, /*On fail goto*//*Label 6218*/ GIMT_Encode4(311244), // Rule ID 6209 //
     /* 311118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 311137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311141 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311145 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 311149 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 311154 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 311158 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 311162 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 311166 */     // MIs[3] Operand 1
     /* 311166 */     // No operand predicates
     /* 311166 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 311170 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311174 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311178 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 311182 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311187 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 311191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311195 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 311197 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 311197 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 311200 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311204 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311209 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 311215 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311220 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 311228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 311230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 311232 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 311239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 311242 */     GIR_RootConstrainSelectedInstOperands,
     /* 311243 */     // GIR_Coverage, 6209,
     /* 311243 */     GIR_EraseRootFromParent_Done,
     /* 311244 */   // Label 6218: @311244
     /* 311244 */   GIM_Try, /*On fail goto*//*Label 6219*/ GIMT_Encode4(311379), // Rule ID 2459 //
     /* 311249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 311252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311264 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 311268 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311273 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 311277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 311281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311285 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311289 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 311293 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311298 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 311302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311306 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 311308 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 311308 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 311311 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311315 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311320 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 311326 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311331 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311336 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 311339 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311343 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311348 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 311354 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311359 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 311367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 311375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 311377 */     GIR_RootConstrainSelectedInstOperands,
     /* 311378 */     // GIR_Coverage, 2459,
     /* 311378 */     GIR_EraseRootFromParent_Done,
     /* 311379 */   // Label 6219: @311379
     /* 311379 */   GIM_Try, /*On fail goto*//*Label 6220*/ GIMT_Encode4(311498), // Rule ID 6113 //
     /* 311384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311395 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311399 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 311403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311408 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 311412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 311416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311424 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 311428 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 311433 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 311437 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 311441 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 311445 */     // MIs[3] Operand 1
     /* 311445 */     // No operand predicates
     /* 311445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311449 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 311451 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 311451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 311454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311463 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 311469 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311474 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 311482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 311484 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 311486 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 311493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 311496 */     GIR_RootConstrainSelectedInstOperands,
     /* 311497 */     // GIR_Coverage, 6113,
     /* 311497 */     GIR_EraseRootFromParent_Done,
     /* 311498 */   // Label 6220: @311498
     /* 311498 */   GIM_Try, /*On fail goto*//*Label 6221*/ GIMT_Encode4(311617), // Rule ID 2534 //
     /* 311503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311518 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 311522 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 311527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 311531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 311535 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 311539 */     // MIs[2] Operand 1
     /* 311539 */     // No operand predicates
     /* 311539 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 311543 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311547 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311551 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 311555 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311560 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 311564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311568 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 311570 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 311570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 311573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311582 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 311588 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311593 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 311601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 311603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 311605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 311612 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 311615 */     GIR_RootConstrainSelectedInstOperands,
     /* 311616 */     // GIR_Coverage, 2534,
     /* 311616 */     GIR_EraseRootFromParent_Done,
     /* 311617 */   // Label 6221: @311617
     /* 311617 */   GIM_Try, /*On fail goto*//*Label 6222*/ GIMT_Encode4(311717), // Rule ID 4888 //
     /* 311622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 311625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311637 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 311641 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311646 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 311650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 311654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311658 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 311662 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311671 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 311673 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 311673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 311676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311685 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 311691 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311696 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 311704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311706 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 311713 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 311715 */     GIR_RootConstrainSelectedInstOperands,
     /* 311716 */     // GIR_Coverage, 4888,
     /* 311716 */     GIR_EraseRootFromParent_Done,
     /* 311717 */   // Label 6222: @311717
     /* 311717 */   GIM_Try, /*On fail goto*//*Label 6223*/ GIMT_Encode4(311817), // Rule ID 4924 //
     /* 311722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 311725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311737 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 311741 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311746 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 311750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 311758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311762 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 311766 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311771 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 311773 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 311773 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 311776 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311780 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311785 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 311791 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311796 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 311804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 311811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 311815 */     GIR_RootConstrainSelectedInstOperands,
     /* 311816 */     // GIR_Coverage, 4924,
     /* 311816 */     GIR_EraseRootFromParent_Done,
     /* 311817 */   // Label 6223: @311817
     /* 311817 */   GIM_Try, /*On fail goto*//*Label 6224*/ GIMT_Encode4(311914), // Rule ID 14009 //
     /* 311822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 311825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311837 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 311841 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311845 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311849 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 311853 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311858 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 311862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311870 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 311872 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 311872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 311875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311879 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311884 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 311890 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311895 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 311903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 311907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 311912 */     GIR_RootConstrainSelectedInstOperands,
     /* 311913 */     // GIR_Coverage, 14009,
     /* 311913 */     GIR_EraseRootFromParent_Done,
     /* 311914 */   // Label 6224: @311914
     /* 311914 */   GIM_Try, /*On fail goto*//*Label 6225*/ GIMT_Encode4(312014), // Rule ID 14011 //
     /* 311919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 311922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311934 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311939 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 311943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311947 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311951 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 311955 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311960 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 311964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311968 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 311970 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 311970 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 311973 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311977 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311982 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 311988 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311993 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 312001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312003 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 312010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 312012 */     GIR_RootConstrainSelectedInstOperands,
     /* 312013 */     // GIR_Coverage, 14011,
     /* 312013 */     GIR_EraseRootFromParent_Done,
     /* 312014 */   // Label 6225: @312014
     /* 312014 */   GIM_Try, /*On fail goto*//*Label 6226*/ GIMT_Encode4(312114), // Rule ID 4922 //
     /* 312019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 312022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 312030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 312038 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312042 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312047 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 312051 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 312055 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312059 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 312063 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312068 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 312070 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 312070 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 312073 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312077 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312082 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 312088 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312093 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 312101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312103 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 312105 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 312112 */     GIR_RootConstrainSelectedInstOperands,
     /* 312113 */     // GIR_Coverage, 4922,
     /* 312113 */     GIR_EraseRootFromParent_Done,
     /* 312114 */   // Label 6226: @312114
     /* 312114 */   GIM_Try, /*On fail goto*//*Label 6227*/ GIMT_Encode4(312211), // Rule ID 4886 //
     /* 312119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 312122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 312130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 312138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 312142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312146 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 312150 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 312154 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312159 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 312163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312167 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 312169 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 312169 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 312172 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312176 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312181 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 312187 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312192 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 312200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312202 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 312204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312207 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 312209 */     GIR_RootConstrainSelectedInstOperands,
     /* 312210 */     // GIR_Coverage, 4886,
     /* 312210 */     GIR_EraseRootFromParent_Done,
     /* 312211 */   // Label 6227: @312211
     /* 312211 */   GIM_Try, /*On fail goto*//*Label 6228*/ GIMT_Encode4(312295), // Rule ID 6175 //
     /* 312216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 312231 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312235 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 312240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 312244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 312248 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 312252 */     // MIs[2] Operand 1
     /* 312252 */     // No operand predicates
     /* 312252 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 312256 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312260 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 312264 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312273 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 312275 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 312275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 312278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 312280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 312282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 312286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 312290 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 312293 */     GIR_RootConstrainSelectedInstOperands,
     /* 312294 */     // GIR_Coverage, 6175,
     /* 312294 */     GIR_EraseRootFromParent_Done,
     /* 312295 */   // Label 6228: @312295
     /* 312295 */   GIM_Try, /*On fail goto*//*Label 6229*/ GIMT_Encode4(312376), // Rule ID 6207 //
     /* 312300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 312315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 312319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312323 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 312327 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 312331 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 312336 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 312340 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 312344 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 312348 */     // MIs[3] Operand 1
     /* 312348 */     // No operand predicates
     /* 312348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312356 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 312358 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 312358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 312361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 312363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 312365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 312367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 312371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 312374 */     GIR_RootConstrainSelectedInstOperands,
     /* 312375 */     // GIR_Coverage, 6207,
     /* 312375 */     GIR_EraseRootFromParent_Done,
     /* 312376 */   // Label 6229: @312376
     /* 312376 */   GIM_Try, /*On fail goto*//*Label 6230*/ GIMT_Encode4(312460), // Rule ID 6239 //
     /* 312381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 312396 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 312405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312409 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 312413 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 312417 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 312422 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 312426 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 312430 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 312434 */     // MIs[3] Operand 1
     /* 312434 */     // No operand predicates
     /* 312434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312438 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 312440 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 312440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 312443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 312445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 312447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 312455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 312458 */     GIR_RootConstrainSelectedInstOperands,
     /* 312459 */     // GIR_Coverage, 6239,
     /* 312459 */     GIR_EraseRootFromParent_Done,
     /* 312460 */   // Label 6230: @312460
     /* 312460 */   GIM_Try, /*On fail goto*//*Label 6231*/ GIMT_Encode4(312541), // Rule ID 6143 //
     /* 312465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 312476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 312484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 312488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 312496 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 312500 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 312505 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 312509 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 312513 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 312517 */     // MIs[3] Operand 1
     /* 312517 */     // No operand predicates
     /* 312517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312521 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 312523 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 312523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 312526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 312528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 312530 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 312532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 312536 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 312539 */     GIR_RootConstrainSelectedInstOperands,
     /* 312540 */     // GIR_Coverage, 6143,
     /* 312540 */     GIR_EraseRootFromParent_Done,
     /* 312541 */   // Label 6231: @312541
     /* 312541 */   GIM_Try, /*On fail goto*//*Label 6232*/ GIMT_Encode4(312626), // Rule ID 2457 //
     /* 312546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 312549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 312561 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312565 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312570 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 312574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312582 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312584 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 312584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 312587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312596 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 312602 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312607 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 312615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 312622 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 312624 */     GIR_RootConstrainSelectedInstOperands,
     /* 312625 */     // GIR_Coverage, 2457,
     /* 312625 */     GIR_EraseRootFromParent_Done,
     /* 312626 */   // Label 6232: @312626
     /* 312626 */   GIM_Try, /*On fail goto*//*Label 6233*/ GIMT_Encode4(312711), // Rule ID 2455 //
     /* 312631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 312634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 312642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 312650 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312654 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312659 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 312663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312669 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 312669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 312672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312681 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 312687 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312692 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 312700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312702 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 312704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312707 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 312709 */     GIR_RootConstrainSelectedInstOperands,
     /* 312710 */     // GIR_Coverage, 2455,
     /* 312710 */     GIR_EraseRootFromParent_Done,
     /* 312711 */   // Label 6233: @312711
     /* 312711 */   GIM_Try, /*On fail goto*//*Label 6234*/ GIMT_Encode4(312780), // Rule ID 2532 //
     /* 312716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 312731 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312735 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 312740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 312744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 312748 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 312752 */     // MIs[2] Operand 1
     /* 312752 */     // No operand predicates
     /* 312752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312760 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 312762 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 312762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 312765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 312767 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 312769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 312771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 312775 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 312778 */     GIR_RootConstrainSelectedInstOperands,
     /* 312779 */     // GIR_Coverage, 2532,
     /* 312779 */     GIR_EraseRootFromParent_Done,
     /* 312780 */   // Label 6234: @312780
     /* 312780 */   GIM_Try, /*On fail goto*//*Label 6235*/ GIMT_Encode4(312849), // Rule ID 6111 //
     /* 312785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 312796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 312804 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312808 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 312813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 312817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 312821 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 312825 */     // MIs[2] Operand 1
     /* 312825 */     // No operand predicates
     /* 312825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312829 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 312831 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 312831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 312834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 312836 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 312838 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 312840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 312844 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 312847 */     GIR_RootConstrainSelectedInstOperands,
     /* 312848 */     // GIR_Coverage, 6111,
     /* 312848 */     GIR_EraseRootFromParent_Done,
     /* 312849 */   // Label 6235: @312849
     /* 312849 */   GIM_Try, /*On fail goto*//*Label 6236*/ GIMT_Encode4(312914), // Rule ID 4942 //
     /* 312854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 312869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 312882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312886 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 312890 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312895 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 312897 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 312897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 312900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 312908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 312912 */     GIR_RootConstrainSelectedInstOperands,
     /* 312913 */     // GIR_Coverage, 4942,
     /* 312913 */     GIR_EraseRootFromParent_Done,
     /* 312914 */   // Label 6236: @312914
     /* 312914 */   GIM_Try, /*On fail goto*//*Label 6237*/ GIMT_Encode4(312979), // Rule ID 14029 //
     /* 312919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 312930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 312938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 312947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312951 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 312955 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312960 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 312962 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 312962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 312965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312971 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 312973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 312977 */     GIR_RootConstrainSelectedInstOperands,
     /* 312978 */     // GIR_Coverage, 14029,
     /* 312978 */     GIR_EraseRootFromParent_Done,
     /* 312979 */   // Label 6237: @312979
     /* 312979 */   GIM_Try, /*On fail goto*//*Label 6238*/ GIMT_Encode4(313029), // Rule ID 4939 //
     /* 312984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 312999 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313014 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 313014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 313017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 313025 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 313027 */     GIR_RootConstrainSelectedInstOperands,
     /* 313028 */     // GIR_Coverage, 4939,
     /* 313028 */     GIR_EraseRootFromParent_Done,
     /* 313029 */   // Label 6238: @313029
     /* 313029 */   GIM_Try, /*On fail goto*//*Label 6239*/ GIMT_Encode4(313079), // Rule ID 13442 //
     /* 313034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 313037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 313049 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313064 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 313064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 313067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 313071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 313075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 313077 */     GIR_RootConstrainSelectedInstOperands,
     /* 313078 */     // GIR_Coverage, 13442,
     /* 313078 */     GIR_EraseRootFromParent_Done,
     /* 313079 */   // Label 6239: @313079
     /* 313079 */   GIM_Try, /*On fail goto*//*Label 6240*/ GIMT_Encode4(313129), // Rule ID 644 //
     /* 313084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 313087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 313095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 313103 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313114 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 313114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 313117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313119 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 313121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 313125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 313127 */     GIR_RootConstrainSelectedInstOperands,
     /* 313128 */     // GIR_Coverage, 644,
     /* 313128 */     GIR_EraseRootFromParent_Done,
     /* 313129 */   // Label 6240: @313129
     /* 313129 */   GIM_Try, /*On fail goto*//*Label 6241*/ GIMT_Encode4(313179), // Rule ID 14026 //
     /* 313134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 313137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 313145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 313153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313164 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 313164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 313167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313173 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 313175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 313177 */     GIR_RootConstrainSelectedInstOperands,
     /* 313178 */     // GIR_Coverage, 14026,
     /* 313178 */     GIR_EraseRootFromParent_Done,
     /* 313179 */   // Label 6241: @313179
     /* 313179 */   GIM_Try, /*On fail goto*//*Label 6242*/ GIMT_Encode4(313229), // Rule ID 656 //
     /* 313184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 313187 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 313199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 313207 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313214 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 313214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 313217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313219 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 313221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 313223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 313227 */     GIR_RootConstrainSelectedInstOperands,
     /* 313228 */     // GIR_Coverage, 656,
     /* 313228 */     GIR_EraseRootFromParent_Done,
     /* 313229 */   // Label 6242: @313229
     /* 313229 */   GIM_Try, /*On fail goto*//*Label 6243*/ GIMT_Encode4(313260), // Rule ID 638 //
     /* 313234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 313237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313249 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 313249 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 313254 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313258 */     GIR_RootConstrainSelectedInstOperands,
     /* 313259 */     // GIR_Coverage, 638,
     /* 313259 */     GIR_Done,
     /* 313260 */   // Label 6243: @313260
     /* 313260 */   GIM_Reject,
     /* 313261 */ // Label 6211: @313261
     /* 313261 */ GIM_Reject,
     /* 313262 */ // Label 6203: @313262
     /* 313262 */ GIM_Try, /*On fail goto*//*Label 6244*/ GIMT_Encode4(316409),
     /* 313267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313270 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 313273 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 313276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313280 */   GIM_Try, /*On fail goto*//*Label 6245*/ GIMT_Encode4(313430), // Rule ID 4932 //
     /* 313285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 313288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313300 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 313304 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313309 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 313313 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313317 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313321 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313325 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 313329 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313334 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 313338 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 313342 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313346 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 313350 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313355 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313357 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 313357 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 313360 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313364 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313369 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 313375 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313380 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313385 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313388 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313392 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313397 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 313403 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313408 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 313416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313418 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313421 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 313424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 313428 */     GIR_RootConstrainSelectedInstOperands,
     /* 313429 */     // GIR_Coverage, 4932,
     /* 313429 */     GIR_EraseRootFromParent_Done,
     /* 313430 */   // Label 6245: @313430
     /* 313430 */   GIM_Try, /*On fail goto*//*Label 6246*/ GIMT_Encode4(313577), // Rule ID 4896 //
     /* 313435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 313438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313450 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 313454 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313459 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 313463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313471 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 313475 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 313479 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313483 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313487 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 313491 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313496 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 313500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313504 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313506 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 313506 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 313509 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313513 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313518 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 313524 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313529 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313546 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 313552 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313557 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 313565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313567 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313570 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 313573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 313575 */     GIR_RootConstrainSelectedInstOperands,
     /* 313576 */     // GIR_Coverage, 4896,
     /* 313576 */     GIR_EraseRootFromParent_Done,
     /* 313577 */   // Label 6246: @313577
     /* 313577 */   GIM_Try, /*On fail goto*//*Label 6247*/ GIMT_Encode4(313724), // Rule ID 14019 //
     /* 313582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 313585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313597 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 313601 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313605 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313609 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 313613 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313618 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 313622 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 313626 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313630 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313634 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 313638 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313643 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 313647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313651 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313653 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 313653 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 313656 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313660 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313665 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 313671 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313676 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313693 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 313699 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313704 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 313712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313714 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313717 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 313720 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 313722 */     GIR_RootConstrainSelectedInstOperands,
     /* 313723 */     // GIR_Coverage, 14019,
     /* 313723 */     GIR_EraseRootFromParent_Done,
     /* 313724 */   // Label 6247: @313724
     /* 313724 */   GIM_Try, /*On fail goto*//*Label 6248*/ GIMT_Encode4(313855), // Rule ID 6161 //
     /* 313729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313744 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 313748 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313753 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 313757 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313761 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313765 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 313769 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 313773 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313777 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313781 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 313785 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313790 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 313794 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 313798 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 313802 */     // MIs[4] Operand 1
     /* 313802 */     // No operand predicates
     /* 313802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313806 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 313808 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 313808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313820 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 313826 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313831 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 313839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 313841 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 313843 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 313850 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 313853 */     GIR_RootConstrainSelectedInstOperands,
     /* 313854 */     // GIR_Coverage, 6161,
     /* 313854 */     GIR_EraseRootFromParent_Done,
     /* 313855 */   // Label 6248: @313855
     /* 313855 */   GIM_Try, /*On fail goto*//*Label 6249*/ GIMT_Encode4(313986), // Rule ID 6193 //
     /* 313860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 313879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 313888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 313892 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 313896 */     // MIs[2] Operand 1
     /* 313896 */     // No operand predicates
     /* 313896 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 313900 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313904 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 313908 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 313912 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313916 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313920 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 313924 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313929 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 313933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313937 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 313939 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 313939 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313942 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313946 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313951 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 313957 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313962 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 313970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 313972 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 313974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 313981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 313984 */     GIR_RootConstrainSelectedInstOperands,
     /* 313985 */     // GIR_Coverage, 6193,
     /* 313985 */     GIR_EraseRootFromParent_Done,
     /* 313986 */   // Label 6249: @313986
     /* 313986 */   GIM_Try, /*On fail goto*//*Label 6250*/ GIMT_Encode4(314117), // Rule ID 6257 //
     /* 313991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 314010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314014 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314018 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 314022 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314027 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 314031 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 314035 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314039 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314043 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 314047 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314052 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 314056 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 314060 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 314064 */     // MIs[4] Operand 1
     /* 314064 */     // No operand predicates
     /* 314064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314068 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 314070 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 314070 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314073 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314077 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314082 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 314088 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314093 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 314101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 314103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 314105 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 314112 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 314115 */     GIR_RootConstrainSelectedInstOperands,
     /* 314116 */     // GIR_Coverage, 6257,
     /* 314116 */     GIR_EraseRootFromParent_Done,
     /* 314117 */   // Label 6250: @314117
     /* 314117 */   GIM_Try, /*On fail goto*//*Label 6251*/ GIMT_Encode4(314248), // Rule ID 6225 //
     /* 314122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314137 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 314141 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314145 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314149 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 314153 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314158 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 314162 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 314166 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 314170 */     // MIs[3] Operand 1
     /* 314170 */     // No operand predicates
     /* 314170 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 314174 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314178 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314182 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 314186 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314191 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 314195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314199 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 314201 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 314201 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314204 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314208 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314213 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 314219 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314224 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 314232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 314234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 314236 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 314243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 314246 */     GIR_RootConstrainSelectedInstOperands,
     /* 314247 */     // GIR_Coverage, 6225,
     /* 314247 */     GIR_EraseRootFromParent_Done,
     /* 314248 */   // Label 6251: @314248
     /* 314248 */   GIM_Try, /*On fail goto*//*Label 6252*/ GIMT_Encode4(314383), // Rule ID 2465 //
     /* 314253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 314272 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314277 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 314281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314289 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314293 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 314297 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314302 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 314306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314310 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 314312 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 314312 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 314315 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314319 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314324 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 314330 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314335 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314352 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 314358 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314363 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 314371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314373 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314376 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 314379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 314381 */     GIR_RootConstrainSelectedInstOperands,
     /* 314382 */     // GIR_Coverage, 2465,
     /* 314382 */     GIR_EraseRootFromParent_Done,
     /* 314383 */   // Label 6252: @314383
     /* 314383 */   GIM_Try, /*On fail goto*//*Label 6253*/ GIMT_Encode4(314502), // Rule ID 6129 //
     /* 314388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314403 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 314407 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314412 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 314416 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314420 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314424 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314428 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 314432 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314437 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 314441 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 314445 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 314449 */     // MIs[3] Operand 1
     /* 314449 */     // No operand predicates
     /* 314449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314453 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314455 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 314455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314467 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 314473 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314478 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 314486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 314488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 314490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 314497 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 314500 */     GIR_RootConstrainSelectedInstOperands,
     /* 314501 */     // GIR_Coverage, 6129,
     /* 314501 */     GIR_EraseRootFromParent_Done,
     /* 314502 */   // Label 6253: @314502
     /* 314502 */   GIM_Try, /*On fail goto*//*Label 6254*/ GIMT_Encode4(314621), // Rule ID 2550 //
     /* 314507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314522 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 314526 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314531 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 314535 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 314539 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 314543 */     // MIs[2] Operand 1
     /* 314543 */     // No operand predicates
     /* 314543 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 314547 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314551 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314555 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 314559 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314564 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 314568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314572 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314574 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 314574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314586 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 314592 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314597 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 314605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 314607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 314609 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 314616 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 314619 */     GIR_RootConstrainSelectedInstOperands,
     /* 314620 */     // GIR_Coverage, 2550,
     /* 314620 */     GIR_EraseRootFromParent_Done,
     /* 314621 */   // Label 6254: @314621
     /* 314621 */   GIM_Try, /*On fail goto*//*Label 6255*/ GIMT_Encode4(314721), // Rule ID 4894 //
     /* 314626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 314645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314650 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 314654 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314658 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314662 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 314666 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314675 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 314677 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 314677 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314680 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314684 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314689 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 314695 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314700 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 314708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 314717 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 314719 */     GIR_RootConstrainSelectedInstOperands,
     /* 314720 */     // GIR_Coverage, 4894,
     /* 314720 */     GIR_EraseRootFromParent_Done,
     /* 314721 */   // Label 6255: @314721
     /* 314721 */   GIM_Try, /*On fail goto*//*Label 6256*/ GIMT_Encode4(314821), // Rule ID 4930 //
     /* 314726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314741 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 314745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314750 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 314754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314758 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 314762 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314766 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 314770 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314775 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 314777 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 314777 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314780 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314784 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314789 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 314795 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314800 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 314808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314810 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 314815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 314819 */     GIR_RootConstrainSelectedInstOperands,
     /* 314820 */     // GIR_Coverage, 4930,
     /* 314820 */     GIR_EraseRootFromParent_Done,
     /* 314821 */   // Label 6256: @314821
     /* 314821 */   GIM_Try, /*On fail goto*//*Label 6257*/ GIMT_Encode4(314918), // Rule ID 14015 //
     /* 314826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 314845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314849 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314853 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 314857 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314862 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 314866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314874 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 314876 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 314876 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314879 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314883 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314888 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 314894 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314899 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 314907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 314911 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 314916 */     GIR_RootConstrainSelectedInstOperands,
     /* 314917 */     // GIR_Coverage, 14015,
     /* 314917 */     GIR_EraseRootFromParent_Done,
     /* 314918 */   // Label 6257: @314918
     /* 314918 */   GIM_Try, /*On fail goto*//*Label 6258*/ GIMT_Encode4(315018), // Rule ID 14017 //
     /* 314923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314951 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314955 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 314959 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314964 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 314968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314972 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 314974 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 314974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314986 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 314992 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314997 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 315005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315007 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 315014 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 315016 */     GIR_RootConstrainSelectedInstOperands,
     /* 315017 */     // GIR_Coverage, 14017,
     /* 315017 */     GIR_EraseRootFromParent_Done,
     /* 315018 */   // Label 6258: @315018
     /* 315018 */   GIM_Try, /*On fail goto*//*Label 6259*/ GIMT_Encode4(315118), // Rule ID 4928 //
     /* 315023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 315034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315042 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315046 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315051 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 315055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 315059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 315067 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315072 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 315074 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 315074 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 315077 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315081 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315086 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 315092 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315097 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 315105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315107 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 315109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 315116 */     GIR_RootConstrainSelectedInstOperands,
     /* 315117 */     // GIR_Coverage, 4928,
     /* 315117 */     GIR_EraseRootFromParent_Done,
     /* 315118 */   // Label 6259: @315118
     /* 315118 */   GIM_Try, /*On fail goto*//*Label 6260*/ GIMT_Encode4(315215), // Rule ID 4892 //
     /* 315123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 315134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 315142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 315146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315150 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315154 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 315158 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315163 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 315167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315171 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 315173 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 315173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 315176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315185 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 315191 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315196 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 315204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315206 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 315208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315211 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 315213 */     GIR_RootConstrainSelectedInstOperands,
     /* 315214 */     // GIR_Coverage, 4892,
     /* 315214 */     GIR_EraseRootFromParent_Done,
     /* 315215 */   // Label 6260: @315215
     /* 315215 */   GIM_Try, /*On fail goto*//*Label 6261*/ GIMT_Encode4(315293), // Rule ID 6279 //
     /* 315220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315232 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315236 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 315240 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315244 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315248 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315253 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 315257 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 315261 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 315265 */     // MIs[3] Operand 1
     /* 315265 */     // No operand predicates
     /* 315265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315273 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 315275 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 315275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 315278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 315280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 315282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 315284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 315288 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 315291 */     GIR_RootConstrainSelectedInstOperands,
     /* 315292 */     // GIR_Coverage, 6279,
     /* 315292 */     GIR_EraseRootFromParent_Done,
     /* 315293 */   // Label 6261: @315293
     /* 315293 */   GIM_Try, /*On fail goto*//*Label 6262*/ GIMT_Encode4(315377), // Rule ID 6191 //
     /* 315298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315309 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315313 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315317 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315322 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 315326 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 315330 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 315334 */     // MIs[2] Operand 1
     /* 315334 */     // No operand predicates
     /* 315334 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 315338 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315342 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 315346 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315355 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 315357 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 315357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 315360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 315362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 315364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 315368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 315372 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 315375 */     GIR_RootConstrainSelectedInstOperands,
     /* 315376 */     // GIR_Coverage, 6191,
     /* 315376 */     GIR_EraseRootFromParent_Done,
     /* 315377 */   // Label 6262: @315377
     /* 315377 */   GIM_Try, /*On fail goto*//*Label 6263*/ GIMT_Encode4(315458), // Rule ID 6223 //
     /* 315382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 315397 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 315401 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315405 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315409 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 315413 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315418 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 315422 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 315426 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 315430 */     // MIs[3] Operand 1
     /* 315430 */     // No operand predicates
     /* 315430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315438 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 315440 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 315440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 315443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 315445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 315447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 315449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 315453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 315456 */     GIR_RootConstrainSelectedInstOperands,
     /* 315457 */     // GIR_Coverage, 6223,
     /* 315457 */     GIR_EraseRootFromParent_Done,
     /* 315458 */   // Label 6263: @315458
     /* 315458 */   GIM_Try, /*On fail goto*//*Label 6264*/ GIMT_Encode4(315542), // Rule ID 6255 //
     /* 315463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 315478 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315483 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 315487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315491 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315495 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 315499 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315504 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 315508 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 315512 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 315516 */     // MIs[3] Operand 1
     /* 315516 */     // No operand predicates
     /* 315516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315520 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 315522 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 315522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 315525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 315527 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 315529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 315533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 315537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 315540 */     GIR_RootConstrainSelectedInstOperands,
     /* 315541 */     // GIR_Coverage, 6255,
     /* 315541 */     GIR_EraseRootFromParent_Done,
     /* 315542 */   // Label 6264: @315542
     /* 315542 */   GIM_Try, /*On fail goto*//*Label 6265*/ GIMT_Encode4(315620), // Rule ID 6301 //
     /* 315547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 315555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315563 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 315571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315575 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315579 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315584 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 315588 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 315592 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 315596 */     // MIs[3] Operand 1
     /* 315596 */     // No operand predicates
     /* 315596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315600 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 315602 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 315602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 315605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 315607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 315609 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 315611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 315615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 315618 */     GIR_RootConstrainSelectedInstOperands,
     /* 315619 */     // GIR_Coverage, 6301,
     /* 315619 */     GIR_EraseRootFromParent_Done,
     /* 315620 */   // Label 6265: @315620
     /* 315620 */   GIM_Try, /*On fail goto*//*Label 6266*/ GIMT_Encode4(315701), // Rule ID 6159 //
     /* 315625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 315636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 315644 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 315648 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315652 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315656 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 315660 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315665 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 315669 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 315673 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 315677 */     // MIs[3] Operand 1
     /* 315677 */     // No operand predicates
     /* 315677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315681 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 315683 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 315683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 315686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 315688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 315690 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 315692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 315696 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 315699 */     GIR_RootConstrainSelectedInstOperands,
     /* 315700 */     // GIR_Coverage, 6159,
     /* 315700 */     GIR_EraseRootFromParent_Done,
     /* 315701 */   // Label 6266: @315701
     /* 315701 */   GIM_Try, /*On fail goto*//*Label 6267*/ GIMT_Encode4(315786), // Rule ID 2463 //
     /* 315706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315721 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315725 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315730 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 315734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315744 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 315744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 315747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315756 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 315762 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315767 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 315775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 315782 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 315784 */     GIR_RootConstrainSelectedInstOperands,
     /* 315785 */     // GIR_Coverage, 2463,
     /* 315785 */     GIR_EraseRootFromParent_Done,
     /* 315786 */   // Label 6267: @315786
     /* 315786 */   GIM_Try, /*On fail goto*//*Label 6268*/ GIMT_Encode4(315871), // Rule ID 2461 //
     /* 315791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 315802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315810 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315814 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315819 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 315823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315829 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 315829 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 315832 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315836 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315841 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 315847 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315852 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 315860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315862 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 315864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 315869 */     GIR_RootConstrainSelectedInstOperands,
     /* 315870 */     // GIR_Coverage, 2461,
     /* 315870 */     GIR_EraseRootFromParent_Done,
     /* 315871 */   // Label 6268: @315871
     /* 315871 */   GIM_Try, /*On fail goto*//*Label 6269*/ GIMT_Encode4(315940), // Rule ID 2548 //
     /* 315876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315891 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315895 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 315904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 315908 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 315912 */     // MIs[2] Operand 1
     /* 315912 */     // No operand predicates
     /* 315912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315920 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 315922 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 315922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 315925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 315927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 315929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 315931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 315935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 315938 */     GIR_RootConstrainSelectedInstOperands,
     /* 315939 */     // GIR_Coverage, 2548,
     /* 315939 */     GIR_EraseRootFromParent_Done,
     /* 315940 */   // Label 6269: @315940
     /* 315940 */   GIM_Try, /*On fail goto*//*Label 6270*/ GIMT_Encode4(316009), // Rule ID 6127 //
     /* 315945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 315956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 315977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 315981 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 315985 */     // MIs[2] Operand 1
     /* 315985 */     // No operand predicates
     /* 315985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315989 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 315991 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 315991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 315994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 315996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 315998 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 316000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 316004 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 316007 */     GIR_RootConstrainSelectedInstOperands,
     /* 316008 */     // GIR_Coverage, 6127,
     /* 316008 */     GIR_EraseRootFromParent_Done,
     /* 316009 */   // Label 6270: @316009
     /* 316009 */   GIM_Try, /*On fail goto*//*Label 6271*/ GIMT_Encode4(316071), // Rule ID 4943 //
     /* 316014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 316026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 316039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316043 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 316047 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316052 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 316054 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 316054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 316057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 316063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 316065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 316069 */     GIR_RootConstrainSelectedInstOperands,
     /* 316070 */     // GIR_Coverage, 4943,
     /* 316070 */     GIR_EraseRootFromParent_Done,
     /* 316071 */   // Label 6271: @316071
     /* 316071 */   GIM_Try, /*On fail goto*//*Label 6272*/ GIMT_Encode4(316133), // Rule ID 14030 //
     /* 316076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 316084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 316092 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 316101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316105 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 316109 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316114 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 316116 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 316116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 316119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 316125 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 316127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 316131 */     GIR_RootConstrainSelectedInstOperands,
     /* 316132 */     // GIR_Coverage, 14030,
     /* 316132 */     GIR_EraseRootFromParent_Done,
     /* 316133 */   // Label 6272: @316133
     /* 316133 */   GIM_Try, /*On fail goto*//*Label 6273*/ GIMT_Encode4(316180), // Rule ID 4940 //
     /* 316138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 316150 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316165 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 316165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 316168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 316174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 316176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 316178 */     GIR_RootConstrainSelectedInstOperands,
     /* 316179 */     // GIR_Coverage, 4940,
     /* 316179 */     GIR_EraseRootFromParent_Done,
     /* 316180 */   // Label 6273: @316180
     /* 316180 */   GIM_Try, /*On fail goto*//*Label 6274*/ GIMT_Encode4(316230), // Rule ID 13444 //
     /* 316185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316196 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 316200 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316215 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 316215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 316218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 316222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 316226 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 316228 */     GIR_RootConstrainSelectedInstOperands,
     /* 316229 */     // GIR_Coverage, 13444,
     /* 316229 */     GIR_EraseRootFromParent_Done,
     /* 316230 */   // Label 6274: @316230
     /* 316230 */   GIM_Try, /*On fail goto*//*Label 6275*/ GIMT_Encode4(316280), // Rule ID 646 //
     /* 316235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 316246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 316254 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316265 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 316265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 316268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316270 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 316272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 316276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 316278 */     GIR_RootConstrainSelectedInstOperands,
     /* 316279 */     // GIR_Coverage, 646,
     /* 316279 */     GIR_EraseRootFromParent_Done,
     /* 316280 */   // Label 6275: @316280
     /* 316280 */   GIM_Try, /*On fail goto*//*Label 6276*/ GIMT_Encode4(316327), // Rule ID 14027 //
     /* 316285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 316293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 316301 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316312 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 316312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 316315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 316321 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 316323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 316325 */     GIR_RootConstrainSelectedInstOperands,
     /* 316326 */     // GIR_Coverage, 14027,
     /* 316326 */     GIR_EraseRootFromParent_Done,
     /* 316327 */   // Label 6276: @316327
     /* 316327 */   GIM_Try, /*On fail goto*//*Label 6277*/ GIMT_Encode4(316377), // Rule ID 658 //
     /* 316332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 316347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 316355 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316362 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 316362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 316365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316367 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 316369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 316371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 316375 */     GIR_RootConstrainSelectedInstOperands,
     /* 316376 */     // GIR_Coverage, 658,
     /* 316376 */     GIR_EraseRootFromParent_Done,
     /* 316377 */   // Label 6277: @316377
     /* 316377 */   GIM_Try, /*On fail goto*//*Label 6278*/ GIMT_Encode4(316408), // Rule ID 640 //
     /* 316382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316385 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316397 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 316397 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 316402 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316406 */     GIR_RootConstrainSelectedInstOperands,
     /* 316407 */     // GIR_Coverage, 640,
     /* 316407 */     GIR_Done,
     /* 316408 */   // Label 6278: @316408
     /* 316408 */   GIM_Reject,
     /* 316409 */ // Label 6244: @316409
     /* 316409 */ GIM_Reject,
     /* 316410 */ // Label 6204: @316410
     /* 316410 */ GIM_Try, /*On fail goto*//*Label 6279*/ GIMT_Encode4(319557),
     /* 316415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 316418 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 316421 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 316424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316428 */   GIM_Try, /*On fail goto*//*Label 6280*/ GIMT_Encode4(316578), // Rule ID 4938 //
     /* 316433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316448 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 316452 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316457 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 316461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 316465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316469 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316473 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 316477 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316482 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 316486 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 316490 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316494 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 316498 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316503 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316505 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 316505 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 316508 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316512 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316517 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 316523 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316528 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316533 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316536 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316540 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316545 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 316551 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316556 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 316564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316566 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 316572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 316576 */     GIR_RootConstrainSelectedInstOperands,
     /* 316577 */     // GIR_Coverage, 4938,
     /* 316577 */     GIR_EraseRootFromParent_Done,
     /* 316578 */   // Label 6280: @316578
     /* 316578 */   GIM_Try, /*On fail goto*//*Label 6281*/ GIMT_Encode4(316725), // Rule ID 4902 //
     /* 316583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316598 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 316602 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316607 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 316611 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 316615 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316619 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 316623 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 316627 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316631 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316635 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 316639 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316644 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 316648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316652 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316654 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 316654 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 316657 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316661 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316666 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 316672 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316677 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316694 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 316700 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316705 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 316713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316715 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316718 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 316721 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 316723 */     GIR_RootConstrainSelectedInstOperands,
     /* 316724 */     // GIR_Coverage, 4902,
     /* 316724 */     GIR_EraseRootFromParent_Done,
     /* 316725 */   // Label 6281: @316725
     /* 316725 */   GIM_Try, /*On fail goto*//*Label 6282*/ GIMT_Encode4(316872), // Rule ID 14025 //
     /* 316730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 316745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 316749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316753 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316757 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 316761 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316766 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 316770 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 316774 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316778 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316782 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 316786 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316791 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 316795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316799 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316801 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 316801 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 316804 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316808 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316813 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 316819 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316824 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316829 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316832 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316836 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316841 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 316847 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316852 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 316860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316862 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316865 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 316868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 316870 */     GIR_RootConstrainSelectedInstOperands,
     /* 316871 */     // GIR_Coverage, 14025,
     /* 316871 */     GIR_EraseRootFromParent_Done,
     /* 316872 */   // Label 6282: @316872
     /* 316872 */   GIM_Try, /*On fail goto*//*Label 6283*/ GIMT_Encode4(317003), // Rule ID 6165 //
     /* 316877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316892 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 316896 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316901 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 316905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 316909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 316917 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 316921 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316925 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316929 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 316933 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316938 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 316942 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 316946 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 316950 */     // MIs[4] Operand 1
     /* 316950 */     // No operand predicates
     /* 316950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316954 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 316956 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 316956 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316959 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316963 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316968 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 316974 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316979 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 316987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 316989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 316991 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 316998 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 317001 */     GIR_RootConstrainSelectedInstOperands,
     /* 317002 */     // GIR_Coverage, 6165,
     /* 317002 */     GIR_EraseRootFromParent_Done,
     /* 317003 */   // Label 6283: @317003
     /* 317003 */   GIM_Try, /*On fail goto*//*Label 6284*/ GIMT_Encode4(317134), // Rule ID 6197 //
     /* 317008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317023 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317027 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317032 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 317036 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 317040 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 317044 */     // MIs[2] Operand 1
     /* 317044 */     // No operand predicates
     /* 317044 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 317048 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317052 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 317056 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 317060 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317064 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317068 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 317072 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317077 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 317081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317085 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 317087 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 317087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 317090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317099 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 317105 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317110 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 317118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 317122 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 317129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 317132 */     GIR_RootConstrainSelectedInstOperands,
     /* 317133 */     // GIR_Coverage, 6197,
     /* 317133 */     GIR_EraseRootFromParent_Done,
     /* 317134 */   // Label 6284: @317134
     /* 317134 */   GIM_Try, /*On fail goto*//*Label 6285*/ GIMT_Encode4(317265), // Rule ID 6261 //
     /* 317139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 317154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 317158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317162 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317166 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 317170 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317175 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 317179 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 317183 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317187 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317191 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 317195 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317200 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 317204 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 317208 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 317212 */     // MIs[4] Operand 1
     /* 317212 */     // No operand predicates
     /* 317212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317216 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 317218 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 317218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 317221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317230 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 317236 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317241 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 317249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 317253 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 317260 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 317263 */     GIR_RootConstrainSelectedInstOperands,
     /* 317264 */     // GIR_Coverage, 6261,
     /* 317264 */     GIR_EraseRootFromParent_Done,
     /* 317265 */   // Label 6285: @317265
     /* 317265 */   GIM_Try, /*On fail goto*//*Label 6286*/ GIMT_Encode4(317396), // Rule ID 6229 //
     /* 317270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 317285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 317289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317293 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317297 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 317301 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317306 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 317310 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 317314 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 317318 */     // MIs[3] Operand 1
     /* 317318 */     // No operand predicates
     /* 317318 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 317322 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317326 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317330 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 317334 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317339 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 317343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317347 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 317349 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 317349 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 317352 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317356 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317361 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 317367 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317372 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 317380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317382 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 317384 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 317391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 317394 */     GIR_RootConstrainSelectedInstOperands,
     /* 317395 */     // GIR_Coverage, 6229,
     /* 317395 */     GIR_EraseRootFromParent_Done,
     /* 317396 */   // Label 6286: @317396
     /* 317396 */   GIM_Try, /*On fail goto*//*Label 6287*/ GIMT_Encode4(317531), // Rule ID 2471 //
     /* 317401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 317404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317416 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317420 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317425 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 317429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 317433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317437 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317441 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 317445 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317450 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 317454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317458 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 317460 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 317460 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 317463 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317467 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317472 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 317478 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317483 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317488 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 317491 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317495 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317500 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 317506 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317511 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 317519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317521 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317524 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 317527 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 317529 */     GIR_RootConstrainSelectedInstOperands,
     /* 317530 */     // GIR_Coverage, 2471,
     /* 317530 */     GIR_EraseRootFromParent_Done,
     /* 317531 */   // Label 6287: @317531
     /* 317531 */   GIM_Try, /*On fail goto*//*Label 6288*/ GIMT_Encode4(317650), // Rule ID 6133 //
     /* 317536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317560 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 317564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 317568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317576 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 317580 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317585 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 317589 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 317593 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 317597 */     // MIs[3] Operand 1
     /* 317597 */     // No operand predicates
     /* 317597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317601 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317603 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 317603 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 317606 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317610 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317615 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 317621 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317626 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 317634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 317638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 317645 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 317648 */     GIR_RootConstrainSelectedInstOperands,
     /* 317649 */     // GIR_Coverage, 6133,
     /* 317649 */     GIR_EraseRootFromParent_Done,
     /* 317650 */   // Label 6288: @317650
     /* 317650 */   GIM_Try, /*On fail goto*//*Label 6289*/ GIMT_Encode4(317769), // Rule ID 2554 //
     /* 317655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317670 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317674 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317679 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 317683 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 317687 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 317691 */     // MIs[2] Operand 1
     /* 317691 */     // No operand predicates
     /* 317691 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 317695 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317699 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317703 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 317707 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317712 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 317716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317720 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317722 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 317722 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 317725 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317729 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317734 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 317740 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317745 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 317753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 317757 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 317764 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 317767 */     GIR_RootConstrainSelectedInstOperands,
     /* 317768 */     // GIR_Coverage, 2554,
     /* 317768 */     GIR_EraseRootFromParent_Done,
     /* 317769 */   // Label 6289: @317769
     /* 317769 */   GIM_Try, /*On fail goto*//*Label 6290*/ GIMT_Encode4(317869), // Rule ID 4900 //
     /* 317774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 317777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317798 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 317802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 317806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 317814 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317823 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 317825 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 317825 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 317828 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317832 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317837 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 317843 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317848 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 317856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317858 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 317865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 317867 */     GIR_RootConstrainSelectedInstOperands,
     /* 317868 */     // GIR_Coverage, 4900,
     /* 317868 */     GIR_EraseRootFromParent_Done,
     /* 317869 */   // Label 6290: @317869
     /* 317869 */   GIM_Try, /*On fail goto*//*Label 6291*/ GIMT_Encode4(317969), // Rule ID 4936 //
     /* 317874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 317877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317889 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317893 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317898 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 317902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 317910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317914 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 317918 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317923 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 317925 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 317925 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 317928 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317932 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317937 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 317943 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317948 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 317956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317958 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 317963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 317967 */     GIR_RootConstrainSelectedInstOperands,
     /* 317968 */     // GIR_Coverage, 4936,
     /* 317968 */     GIR_EraseRootFromParent_Done,
     /* 317969 */   // Label 6291: @317969
     /* 317969 */   GIM_Try, /*On fail goto*//*Label 6292*/ GIMT_Encode4(318066), // Rule ID 14021 //
     /* 317974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 317977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 317989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 317993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317997 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318001 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 318005 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318010 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 318014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318022 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 318024 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 318024 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 318027 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318031 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318036 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 318042 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318047 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 318055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 318059 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 318064 */     GIR_RootConstrainSelectedInstOperands,
     /* 318065 */     // GIR_Coverage, 14021,
     /* 318065 */     GIR_EraseRootFromParent_Done,
     /* 318066 */   // Label 6292: @318066
     /* 318066 */   GIM_Try, /*On fail goto*//*Label 6293*/ GIMT_Encode4(318166), // Rule ID 14023 //
     /* 318071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 318074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 318086 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318091 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 318095 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 318099 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318103 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 318107 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318112 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 318116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318120 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 318122 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 318122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 318125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318134 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 318140 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318145 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 318153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 318162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 318164 */     GIR_RootConstrainSelectedInstOperands,
     /* 318165 */     // GIR_Coverage, 14023,
     /* 318165 */     GIR_EraseRootFromParent_Done,
     /* 318166 */   // Label 6293: @318166
     /* 318166 */   GIM_Try, /*On fail goto*//*Label 6294*/ GIMT_Encode4(318266), // Rule ID 4934 //
     /* 318171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 318174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 318182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 318186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318190 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 318194 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318199 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 318203 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 318207 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318211 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 318215 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318220 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 318222 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 318222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 318225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318234 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 318240 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318245 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 318253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318255 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318257 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 318264 */     GIR_RootConstrainSelectedInstOperands,
     /* 318265 */     // GIR_Coverage, 4934,
     /* 318265 */     GIR_EraseRootFromParent_Done,
     /* 318266 */   // Label 6294: @318266
     /* 318266 */   GIM_Try, /*On fail goto*//*Label 6295*/ GIMT_Encode4(318363), // Rule ID 4898 //
     /* 318271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 318274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 318282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 318290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 318294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 318298 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318302 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 318306 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318311 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 318315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318319 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 318321 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 318321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 318324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318333 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 318339 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318344 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 318352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318354 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318356 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318359 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 318361 */     GIR_RootConstrainSelectedInstOperands,
     /* 318362 */     // GIR_Coverage, 4898,
     /* 318362 */     GIR_EraseRootFromParent_Done,
     /* 318363 */   // Label 6295: @318363
     /* 318363 */   GIM_Try, /*On fail goto*//*Label 6296*/ GIMT_Encode4(318441), // Rule ID 6283 //
     /* 318368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 318376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318380 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 318384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 318388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318392 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318396 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318401 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 318405 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 318409 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 318413 */     // MIs[3] Operand 1
     /* 318413 */     // No operand predicates
     /* 318413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318421 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318423 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 318423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 318426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 318432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 318436 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 318439 */     GIR_RootConstrainSelectedInstOperands,
     /* 318440 */     // GIR_Coverage, 6283,
     /* 318440 */     GIR_EraseRootFromParent_Done,
     /* 318441 */   // Label 6296: @318441
     /* 318441 */   GIM_Try, /*On fail goto*//*Label 6297*/ GIMT_Encode4(318525), // Rule ID 6195 //
     /* 318446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 318457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318461 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 318465 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318470 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 318474 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 318478 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 318482 */     // MIs[2] Operand 1
     /* 318482 */     // No operand predicates
     /* 318482 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 318486 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318490 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 318494 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318503 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318505 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 318505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 318508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 318516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 318520 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 318523 */     GIR_RootConstrainSelectedInstOperands,
     /* 318524 */     // GIR_Coverage, 6195,
     /* 318524 */     GIR_EraseRootFromParent_Done,
     /* 318525 */   // Label 6297: @318525
     /* 318525 */   GIM_Try, /*On fail goto*//*Label 6298*/ GIMT_Encode4(318606), // Rule ID 6227 //
     /* 318530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 318545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 318549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 318553 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318557 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 318561 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318566 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 318570 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 318574 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 318578 */     // MIs[3] Operand 1
     /* 318578 */     // No operand predicates
     /* 318578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318586 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318588 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 318588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 318591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 318597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 318601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 318604 */     GIR_RootConstrainSelectedInstOperands,
     /* 318605 */     // GIR_Coverage, 6227,
     /* 318605 */     GIR_EraseRootFromParent_Done,
     /* 318606 */   // Label 6298: @318606
     /* 318606 */   GIM_Try, /*On fail goto*//*Label 6299*/ GIMT_Encode4(318690), // Rule ID 6259 //
     /* 318611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 318626 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 318635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 318639 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318643 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 318647 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318652 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 318656 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 318660 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 318664 */     // MIs[3] Operand 1
     /* 318664 */     // No operand predicates
     /* 318664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318668 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318670 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 318670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 318673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 318681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 318685 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 318688 */     GIR_RootConstrainSelectedInstOperands,
     /* 318689 */     // GIR_Coverage, 6259,
     /* 318689 */     GIR_EraseRootFromParent_Done,
     /* 318690 */   // Label 6299: @318690
     /* 318690 */   GIM_Try, /*On fail goto*//*Label 6300*/ GIMT_Encode4(318768), // Rule ID 6305 //
     /* 318695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 318703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 318707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318711 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 318715 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 318719 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318723 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318727 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318732 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 318736 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 318740 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 318744 */     // MIs[3] Operand 1
     /* 318744 */     // No operand predicates
     /* 318744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318748 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318750 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 318750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 318753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318757 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 318763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 318766 */     GIR_RootConstrainSelectedInstOperands,
     /* 318767 */     // GIR_Coverage, 6305,
     /* 318767 */     GIR_EraseRootFromParent_Done,
     /* 318768 */   // Label 6300: @318768
     /* 318768 */   GIM_Try, /*On fail goto*//*Label 6301*/ GIMT_Encode4(318849), // Rule ID 6163 //
     /* 318773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 318784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 318792 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 318796 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 318800 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318804 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 318808 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318813 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 318817 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 318821 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 318825 */     // MIs[3] Operand 1
     /* 318825 */     // No operand predicates
     /* 318825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318829 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318831 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 318831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 318834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318836 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318838 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 318844 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 318847 */     GIR_RootConstrainSelectedInstOperands,
     /* 318848 */     // GIR_Coverage, 6163,
     /* 318848 */     GIR_EraseRootFromParent_Done,
     /* 318849 */   // Label 6301: @318849
     /* 318849 */   GIM_Try, /*On fail goto*//*Label 6302*/ GIMT_Encode4(318934), // Rule ID 2469 //
     /* 318854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 318857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 318865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318869 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 318873 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318878 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 318882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318892 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 318892 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 318895 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318899 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318904 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 318910 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318915 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 318923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318925 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 318930 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 318932 */     GIR_RootConstrainSelectedInstOperands,
     /* 318933 */     // GIR_Coverage, 2469,
     /* 318933 */     GIR_EraseRootFromParent_Done,
     /* 318934 */   // Label 6302: @318934
     /* 318934 */   GIM_Try, /*On fail goto*//*Label 6303*/ GIMT_Encode4(319019), // Rule ID 2467 //
     /* 318939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 318942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 318950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 318954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318958 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 318962 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318967 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 318971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318977 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 318977 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 318980 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318984 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318989 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 318995 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319000 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 319008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319010 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 319012 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319015 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 319017 */     GIR_RootConstrainSelectedInstOperands,
     /* 319018 */     // GIR_Coverage, 2467,
     /* 319018 */     GIR_EraseRootFromParent_Done,
     /* 319019 */   // Label 6303: @319019
     /* 319019 */   GIM_Try, /*On fail goto*//*Label 6304*/ GIMT_Encode4(319088), // Rule ID 2552 //
     /* 319024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 319035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319039 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 319043 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 319052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 319056 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 319060 */     // MIs[2] Operand 1
     /* 319060 */     // No operand predicates
     /* 319060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319068 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 319070 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 319070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 319073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 319079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 319083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 319086 */     GIR_RootConstrainSelectedInstOperands,
     /* 319087 */     // GIR_Coverage, 2552,
     /* 319087 */     GIR_EraseRootFromParent_Done,
     /* 319088 */   // Label 6304: @319088
     /* 319088 */   GIM_Try, /*On fail goto*//*Label 6305*/ GIMT_Encode4(319157), // Rule ID 6131 //
     /* 319093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 319104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 319108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319112 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 319116 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319121 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 319125 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 319129 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 319133 */     // MIs[2] Operand 1
     /* 319133 */     // No operand predicates
     /* 319133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319137 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 319139 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 319139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 319142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319146 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 319148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 319152 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 319155 */     GIR_RootConstrainSelectedInstOperands,
     /* 319156 */     // GIR_Coverage, 6131,
     /* 319156 */     GIR_EraseRootFromParent_Done,
     /* 319157 */   // Label 6305: @319157
     /* 319157 */   GIM_Try, /*On fail goto*//*Label 6306*/ GIMT_Encode4(319219), // Rule ID 4944 //
     /* 319162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319170 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 319174 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319183 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 319187 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319191 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 319195 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319200 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 319202 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 319202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 319205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 319211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 319213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 319217 */     GIR_RootConstrainSelectedInstOperands,
     /* 319218 */     // GIR_Coverage, 4944,
     /* 319218 */     GIR_EraseRootFromParent_Done,
     /* 319219 */   // Label 6306: @319219
     /* 319219 */   GIM_Try, /*On fail goto*//*Label 6307*/ GIMT_Encode4(319281), // Rule ID 14031 //
     /* 319224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 319232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 319240 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319245 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 319249 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319253 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 319257 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319262 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 319264 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 319264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 319267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 319273 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 319275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 319279 */     GIR_RootConstrainSelectedInstOperands,
     /* 319280 */     // GIR_Coverage, 14031,
     /* 319280 */     GIR_EraseRootFromParent_Done,
     /* 319281 */   // Label 6307: @319281
     /* 319281 */   GIM_Try, /*On fail goto*//*Label 6308*/ GIMT_Encode4(319328), // Rule ID 4941 //
     /* 319286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 319298 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319313 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 319313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 319316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 319322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 319324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 319326 */     GIR_RootConstrainSelectedInstOperands,
     /* 319327 */     // GIR_Coverage, 4941,
     /* 319327 */     GIR_EraseRootFromParent_Done,
     /* 319328 */   // Label 6308: @319328
     /* 319328 */   GIM_Try, /*On fail goto*//*Label 6309*/ GIMT_Encode4(319378), // Rule ID 13446 //
     /* 319333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 319336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 319348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319363 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 319363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 319366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 319370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 319374 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 319376 */     GIR_RootConstrainSelectedInstOperands,
     /* 319377 */     // GIR_Coverage, 13446,
     /* 319377 */     GIR_EraseRootFromParent_Done,
     /* 319378 */   // Label 6309: @319378
     /* 319378 */   GIM_Try, /*On fail goto*//*Label 6310*/ GIMT_Encode4(319428), // Rule ID 648 //
     /* 319383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 319386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 319394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319398 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 319402 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319413 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 319413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 319416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319418 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 319420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 319424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 319426 */     GIR_RootConstrainSelectedInstOperands,
     /* 319427 */     // GIR_Coverage, 648,
     /* 319427 */     GIR_EraseRootFromParent_Done,
     /* 319428 */   // Label 6310: @319428
     /* 319428 */   GIM_Try, /*On fail goto*//*Label 6311*/ GIMT_Encode4(319475), // Rule ID 14028 //
     /* 319433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 319441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 319449 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319460 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 319460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 319463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 319469 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 319471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 319473 */     GIR_RootConstrainSelectedInstOperands,
     /* 319474 */     // GIR_Coverage, 14028,
     /* 319474 */     GIR_EraseRootFromParent_Done,
     /* 319475 */   // Label 6311: @319475
     /* 319475 */   GIM_Try, /*On fail goto*//*Label 6312*/ GIMT_Encode4(319525), // Rule ID 660 //
     /* 319480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 319483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 319495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 319503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319508 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319510 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 319510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 319513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319515 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 319517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 319519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 319523 */     GIR_RootConstrainSelectedInstOperands,
     /* 319524 */     // GIR_Coverage, 660,
     /* 319524 */     GIR_EraseRootFromParent_Done,
     /* 319525 */   // Label 6312: @319525
     /* 319525 */   GIM_Try, /*On fail goto*//*Label 6313*/ GIMT_Encode4(319556), // Rule ID 642 //
     /* 319530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 319533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319545 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 319545 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 319550 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 319554 */     GIR_RootConstrainSelectedInstOperands,
     /* 319555 */     // GIR_Coverage, 642,
     /* 319555 */     GIR_Done,
     /* 319556 */   // Label 6313: @319556
     /* 319556 */   GIM_Reject,
     /* 319557 */ // Label 6279: @319557
     /* 319557 */ GIM_Reject,
     /* 319558 */ // Label 6205: @319558
     /* 319558 */ GIM_Try, /*On fail goto*//*Label 6314*/ GIMT_Encode4(321078),
     /* 319563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 319566 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 319569 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 319572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319576 */   GIM_Try, /*On fail goto*//*Label 6315*/ GIMT_Encode4(319654), // Rule ID 6263 //
     /* 319581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 319589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 319593 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 319597 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 319601 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319605 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 319609 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319614 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 319618 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 319622 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 319626 */     // MIs[3] Operand 1
     /* 319626 */     // No operand predicates
     /* 319626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319634 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319636 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 319636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 319639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319641 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 319645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 319649 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 319652 */     GIR_RootConstrainSelectedInstOperands,
     /* 319653 */     // GIR_Coverage, 6263,
     /* 319653 */     GIR_EraseRootFromParent_Done,
     /* 319654 */   // Label 6315: @319654
     /* 319654 */   GIM_Try, /*On fail goto*//*Label 6316*/ GIMT_Encode4(319738), // Rule ID 6179 //
     /* 319659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 319670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 319674 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 319678 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319683 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 319687 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 319691 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 319695 */     // MIs[2] Operand 1
     /* 319695 */     // No operand predicates
     /* 319695 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 319699 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319703 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 319707 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319716 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319718 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 319718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 319721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319725 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 319729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 319733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 319736 */     GIR_RootConstrainSelectedInstOperands,
     /* 319737 */     // GIR_Coverage, 6179,
     /* 319737 */     GIR_EraseRootFromParent_Done,
     /* 319738 */   // Label 6316: @319738
     /* 319738 */   GIM_Try, /*On fail goto*//*Label 6317*/ GIMT_Encode4(319819), // Rule ID 6211 //
     /* 319743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 319758 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 319762 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 319766 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 319770 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 319774 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319779 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 319783 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 319787 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 319791 */     // MIs[3] Operand 1
     /* 319791 */     // No operand predicates
     /* 319791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319799 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319801 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 319801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 319804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319806 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 319810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 319814 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 319817 */     GIR_RootConstrainSelectedInstOperands,
     /* 319818 */     // GIR_Coverage, 6211,
     /* 319818 */     GIR_EraseRootFromParent_Done,
     /* 319819 */   // Label 6317: @319819
     /* 319819 */   GIM_Try, /*On fail goto*//*Label 6318*/ GIMT_Encode4(319903), // Rule ID 6243 //
     /* 319824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 319839 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319844 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 319848 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 319852 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 319856 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 319860 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319865 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 319869 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 319873 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 319877 */     // MIs[3] Operand 1
     /* 319877 */     // No operand predicates
     /* 319877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319881 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319883 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 319883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 319886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319888 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 319894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 319898 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 319901 */     GIR_RootConstrainSelectedInstOperands,
     /* 319902 */     // GIR_Coverage, 6243,
     /* 319902 */     GIR_EraseRootFromParent_Done,
     /* 319903 */   // Label 6318: @319903
     /* 319903 */   GIM_Try, /*On fail goto*//*Label 6319*/ GIMT_Encode4(319981), // Rule ID 6285 //
     /* 319908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 319916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 319920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 319924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 319928 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 319932 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319936 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 319940 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319945 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 319949 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 319953 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 319957 */     // MIs[3] Operand 1
     /* 319957 */     // No operand predicates
     /* 319957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319961 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319963 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 319963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 319966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319970 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 319972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 319976 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 319979 */     GIR_RootConstrainSelectedInstOperands,
     /* 319980 */     // GIR_Coverage, 6285,
     /* 319980 */     GIR_EraseRootFromParent_Done,
     /* 319981 */   // Label 6319: @319981
     /* 319981 */   GIM_Try, /*On fail goto*//*Label 6320*/ GIMT_Encode4(320062), // Rule ID 6147 //
     /* 319986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319989 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 319997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 320005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 320009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 320013 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 320017 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 320021 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320026 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 320030 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 320034 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 320038 */     // MIs[3] Operand 1
     /* 320038 */     // No operand predicates
     /* 320038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320042 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320044 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 320044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 320047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320049 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320051 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 320053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320057 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 320060 */     GIR_RootConstrainSelectedInstOperands,
     /* 320061 */     // GIR_Coverage, 6147,
     /* 320061 */     GIR_EraseRootFromParent_Done,
     /* 320062 */   // Label 6320: @320062
     /* 320062 */   GIM_Try, /*On fail goto*//*Label 6321*/ GIMT_Encode4(320131), // Rule ID 2536 //
     /* 320067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 320078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 320082 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 320086 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320091 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 320095 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 320099 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 320103 */     // MIs[2] Operand 1
     /* 320103 */     // No operand predicates
     /* 320103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320111 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 320113 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 320113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 320116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320118 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 320122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 320126 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 320129 */     GIR_RootConstrainSelectedInstOperands,
     /* 320130 */     // GIR_Coverage, 2536,
     /* 320130 */     GIR_EraseRootFromParent_Done,
     /* 320131 */   // Label 6321: @320131
     /* 320131 */   GIM_Try, /*On fail goto*//*Label 6322*/ GIMT_Encode4(320200), // Rule ID 6115 //
     /* 320136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 320147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 320151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 320155 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 320159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 320168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 320172 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 320176 */     // MIs[2] Operand 1
     /* 320176 */     // No operand predicates
     /* 320176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320180 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 320182 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 320182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 320185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320189 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 320191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 320195 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 320198 */     GIR_RootConstrainSelectedInstOperands,
     /* 320199 */     // GIR_Coverage, 6115,
     /* 320199 */     GIR_EraseRootFromParent_Done,
     /* 320200 */   // Label 6322: @320200
     /* 320200 */   GIM_Try, /*On fail goto*//*Label 6323*/ GIMT_Encode4(320293), // Rule ID 6267 //
     /* 320205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 320213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 320217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 320221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320225 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 320229 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320242 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 320244 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 320244 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 320247 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 320251 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320256 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 320259 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320263 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 320266 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320271 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 320279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320281 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 320285 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320291 */     GIR_RootConstrainSelectedInstOperands,
     /* 320292 */     // GIR_Coverage, 6267,
     /* 320292 */     GIR_EraseRootFromParent_Done,
     /* 320293 */   // Label 6323: @320293
     /* 320293 */   GIM_Try, /*On fail goto*//*Label 6324*/ GIMT_Encode4(320392), // Rule ID 6181 //
     /* 320298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 320309 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 320313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 320322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320326 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 320330 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320339 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 320341 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 320341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 320344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 320348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320353 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 320356 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 320360 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 320363 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320368 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 320376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 320384 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320390 */     GIR_RootConstrainSelectedInstOperands,
     /* 320391 */     // GIR_Coverage, 6181,
     /* 320391 */     GIR_EraseRootFromParent_Done,
     /* 320392 */   // Label 6324: @320392
     /* 320392 */   GIM_Try, /*On fail goto*//*Label 6325*/ GIMT_Encode4(320488), // Rule ID 6213 //
     /* 320397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 320412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 320416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 320420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 320424 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320437 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 320439 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 320439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 320442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 320446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320451 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 320454 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320458 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 320461 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320466 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 320474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320476 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 320480 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320486 */     GIR_RootConstrainSelectedInstOperands,
     /* 320487 */     // GIR_Coverage, 6213,
     /* 320487 */     GIR_EraseRootFromParent_Done,
     /* 320488 */   // Label 6325: @320488
     /* 320488 */   GIM_Try, /*On fail goto*//*Label 6326*/ GIMT_Encode4(320587), // Rule ID 6245 //
     /* 320493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 320508 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320513 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 320517 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 320521 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 320525 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320534 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 320536 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 320536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 320539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 320543 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320548 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 320551 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320555 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 320558 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320563 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 320571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 320579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320585 */     GIR_RootConstrainSelectedInstOperands,
     /* 320586 */     // GIR_Coverage, 6245,
     /* 320586 */     GIR_EraseRootFromParent_Done,
     /* 320587 */   // Label 6326: @320587
     /* 320587 */   GIM_Try, /*On fail goto*//*Label 6327*/ GIMT_Encode4(320680), // Rule ID 6289 //
     /* 320592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 320600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 320604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 320608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 320612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320616 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 320620 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320629 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 320631 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 320631 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 320634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 320638 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320643 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 320646 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320650 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 320653 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320658 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 320666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320670 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 320672 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320678 */     GIR_RootConstrainSelectedInstOperands,
     /* 320679 */     // GIR_Coverage, 6289,
     /* 320679 */     GIR_EraseRootFromParent_Done,
     /* 320680 */   // Label 6327: @320680
     /* 320680 */   GIM_Try, /*On fail goto*//*Label 6328*/ GIMT_Encode4(320776), // Rule ID 6149 //
     /* 320685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320688 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 320696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 320704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 320708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 320712 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 320716 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320725 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 320727 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 320727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 320730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 320734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320739 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 320742 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320746 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 320749 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320754 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 320762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320766 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 320768 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320774 */     GIR_RootConstrainSelectedInstOperands,
     /* 320775 */     // GIR_Coverage, 6149,
     /* 320775 */     GIR_EraseRootFromParent_Done,
     /* 320776 */   // Label 6328: @320776
     /* 320776 */   GIM_Try, /*On fail goto*//*Label 6329*/ GIMT_Encode4(320860), // Rule ID 2538 //
     /* 320781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 320792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 320796 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320811 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 320811 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 320814 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 320818 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320823 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 320826 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 320830 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 320833 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320838 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 320846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 320852 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320858 */     GIR_RootConstrainSelectedInstOperands,
     /* 320859 */     // GIR_Coverage, 2538,
     /* 320859 */     GIR_EraseRootFromParent_Done,
     /* 320860 */   // Label 6329: @320860
     /* 320860 */   GIM_Try, /*On fail goto*//*Label 6330*/ GIMT_Encode4(320910), // Rule ID 13476 //
     /* 320865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 320880 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320895 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 320895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 320898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320900 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 320904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 320908 */     GIR_RootConstrainSelectedInstOperands,
     /* 320909 */     // GIR_Coverage, 13476,
     /* 320909 */     GIR_EraseRootFromParent_Done,
     /* 320910 */   // Label 6330: @320910
     /* 320910 */   GIM_Try, /*On fail goto*//*Label 6331*/ GIMT_Encode4(320994), // Rule ID 6117 //
     /* 320915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 320926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 320930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 320934 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320945 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 320945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 320948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 320952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320957 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 320960 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 320964 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 320967 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320972 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 320980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320984 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 320986 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320992 */     GIR_RootConstrainSelectedInstOperands,
     /* 320993 */     // GIR_Coverage, 6117,
     /* 320993 */     GIR_EraseRootFromParent_Done,
     /* 320994 */   // Label 6331: @320994
     /* 320994 */   GIM_Try, /*On fail goto*//*Label 6332*/ GIMT_Encode4(321044), // Rule ID 1308 //
     /* 320999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 321010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 321018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321029 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 321029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 321032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321036 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 321038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 321042 */     GIR_RootConstrainSelectedInstOperands,
     /* 321043 */     // GIR_Coverage, 1308,
     /* 321043 */     GIR_EraseRootFromParent_Done,
     /* 321044 */   // Label 6332: @321044
     /* 321044 */   GIM_Try, /*On fail goto*//*Label 6333*/ GIMT_Encode4(321077), // Rule ID 1298 //
     /* 321049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321064 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 321064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f32),
     /* 321067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 321073 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 321075 */     GIR_RootConstrainSelectedInstOperands,
     /* 321076 */     // GIR_Coverage, 1298,
     /* 321076 */     GIR_EraseRootFromParent_Done,
     /* 321077 */   // Label 6333: @321077
     /* 321077 */   GIM_Reject,
     /* 321078 */ // Label 6314: @321078
     /* 321078 */ GIM_Reject,
     /* 321079 */ // Label 6206: @321079
     /* 321079 */ GIM_Try, /*On fail goto*//*Label 6334*/ GIMT_Encode4(322599),
     /* 321084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321087 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 321090 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 321093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321097 */   GIM_Try, /*On fail goto*//*Label 6335*/ GIMT_Encode4(321175), // Rule ID 6275 //
     /* 321102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 321110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321114 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 321118 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 321122 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321126 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321130 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321135 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 321139 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 321143 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 321147 */     // MIs[3] Operand 1
     /* 321147 */     // No operand predicates
     /* 321147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321155 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321157 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 321157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 321160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 321166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321170 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 321173 */     GIR_RootConstrainSelectedInstOperands,
     /* 321174 */     // GIR_Coverage, 6275,
     /* 321174 */     GIR_EraseRootFromParent_Done,
     /* 321175 */   // Label 6335: @321175
     /* 321175 */   GIM_Try, /*On fail goto*//*Label 6336*/ GIMT_Encode4(321259), // Rule ID 6187 //
     /* 321180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 321191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321195 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 321199 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321204 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 321208 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 321212 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 321216 */     // MIs[2] Operand 1
     /* 321216 */     // No operand predicates
     /* 321216 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 321220 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321224 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321228 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321237 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321239 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 321239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 321242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 321250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 321254 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 321257 */     GIR_RootConstrainSelectedInstOperands,
     /* 321258 */     // GIR_Coverage, 6187,
     /* 321258 */     GIR_EraseRootFromParent_Done,
     /* 321259 */   // Label 6336: @321259
     /* 321259 */   GIM_Try, /*On fail goto*//*Label 6337*/ GIMT_Encode4(321340), // Rule ID 6219 //
     /* 321264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 321283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 321287 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321291 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 321295 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321300 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 321304 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 321308 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 321312 */     // MIs[3] Operand 1
     /* 321312 */     // No operand predicates
     /* 321312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321320 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321322 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 321322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 321325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321327 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 321331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 321338 */     GIR_RootConstrainSelectedInstOperands,
     /* 321339 */     // GIR_Coverage, 6219,
     /* 321339 */     GIR_EraseRootFromParent_Done,
     /* 321340 */   // Label 6337: @321340
     /* 321340 */   GIM_Try, /*On fail goto*//*Label 6338*/ GIMT_Encode4(321424), // Rule ID 6251 //
     /* 321345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321360 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321365 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 321369 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 321373 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321377 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 321381 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321386 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 321390 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 321394 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 321398 */     // MIs[3] Operand 1
     /* 321398 */     // No operand predicates
     /* 321398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321402 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321404 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 321404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 321407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 321415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 321422 */     GIR_RootConstrainSelectedInstOperands,
     /* 321423 */     // GIR_Coverage, 6251,
     /* 321423 */     GIR_EraseRootFromParent_Done,
     /* 321424 */   // Label 6338: @321424
     /* 321424 */   GIM_Try, /*On fail goto*//*Label 6339*/ GIMT_Encode4(321502), // Rule ID 6297 //
     /* 321429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 321437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 321441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321445 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 321449 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 321453 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321457 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321461 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321466 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 321470 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 321474 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 321478 */     // MIs[3] Operand 1
     /* 321478 */     // No operand predicates
     /* 321478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321482 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321484 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 321484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 321487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321491 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 321493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321497 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 321500 */     GIR_RootConstrainSelectedInstOperands,
     /* 321501 */     // GIR_Coverage, 6297,
     /* 321501 */     GIR_EraseRootFromParent_Done,
     /* 321502 */   // Label 6339: @321502
     /* 321502 */   GIM_Try, /*On fail goto*//*Label 6340*/ GIMT_Encode4(321583), // Rule ID 6155 //
     /* 321507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 321518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 321530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 321534 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321538 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 321542 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321547 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 321551 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 321555 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 321559 */     // MIs[3] Operand 1
     /* 321559 */     // No operand predicates
     /* 321559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321563 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321565 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 321565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 321568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321572 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 321574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321578 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 321581 */     GIR_RootConstrainSelectedInstOperands,
     /* 321582 */     // GIR_Coverage, 6155,
     /* 321582 */     GIR_EraseRootFromParent_Done,
     /* 321583 */   // Label 6340: @321583
     /* 321583 */   GIM_Try, /*On fail goto*//*Label 6341*/ GIMT_Encode4(321652), // Rule ID 2544 //
     /* 321588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 321599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321603 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 321607 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 321616 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 321620 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 321624 */     // MIs[2] Operand 1
     /* 321624 */     // No operand predicates
     /* 321624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321632 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 321634 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 321634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 321637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 321643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 321647 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 321650 */     GIR_RootConstrainSelectedInstOperands,
     /* 321651 */     // GIR_Coverage, 2544,
     /* 321651 */     GIR_EraseRootFromParent_Done,
     /* 321652 */   // Label 6341: @321652
     /* 321652 */   GIM_Try, /*On fail goto*//*Label 6342*/ GIMT_Encode4(321721), // Rule ID 6123 //
     /* 321657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 321668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 321672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 321680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 321689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 321693 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 321697 */     // MIs[2] Operand 1
     /* 321697 */     // No operand predicates
     /* 321697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321701 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 321703 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 321703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 321706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321708 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321710 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 321712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 321716 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 321719 */     GIR_RootConstrainSelectedInstOperands,
     /* 321720 */     // GIR_Coverage, 6123,
     /* 321720 */     GIR_EraseRootFromParent_Done,
     /* 321721 */   // Label 6342: @321721
     /* 321721 */   GIM_Try, /*On fail goto*//*Label 6343*/ GIMT_Encode4(321814), // Rule ID 6277 //
     /* 321726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 321734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 321738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 321742 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321746 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 321750 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321763 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 321765 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 321765 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 321768 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 321772 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321777 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 321780 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321784 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 321787 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321792 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 321800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321802 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 321806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321812 */     GIR_RootConstrainSelectedInstOperands,
     /* 321813 */     // GIR_Coverage, 6277,
     /* 321813 */     GIR_EraseRootFromParent_Done,
     /* 321814 */   // Label 6343: @321814
     /* 321814 */   GIM_Try, /*On fail goto*//*Label 6344*/ GIMT_Encode4(321913), // Rule ID 6189 //
     /* 321819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 321830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 321834 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 321843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321847 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321851 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321860 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 321862 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 321862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 321865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 321869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321874 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 321877 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 321881 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 321884 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321889 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 321897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321899 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 321905 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321911 */     GIR_RootConstrainSelectedInstOperands,
     /* 321912 */     // GIR_Coverage, 6189,
     /* 321912 */     GIR_EraseRootFromParent_Done,
     /* 321913 */   // Label 6344: @321913
     /* 321913 */   GIM_Try, /*On fail goto*//*Label 6345*/ GIMT_Encode4(322009), // Rule ID 6221 //
     /* 321918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321933 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 321937 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 321941 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 321945 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321958 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 321960 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 321960 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 321963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 321967 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321972 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 321975 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321979 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 321982 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321987 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 321995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 322001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322007 */     GIR_RootConstrainSelectedInstOperands,
     /* 322008 */     // GIR_Coverage, 6221,
     /* 322008 */     GIR_EraseRootFromParent_Done,
     /* 322009 */   // Label 6345: @322009
     /* 322009 */   GIM_Try, /*On fail goto*//*Label 6346*/ GIMT_Encode4(322108), // Rule ID 6253 //
     /* 322014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 322029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 322038 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 322042 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 322046 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322055 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 322057 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 322057 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 322060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322064 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322069 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 322072 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 322076 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 322079 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322084 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 322092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 322100 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322106 */     GIR_RootConstrainSelectedInstOperands,
     /* 322107 */     // GIR_Coverage, 6253,
     /* 322107 */     GIR_EraseRootFromParent_Done,
     /* 322108 */   // Label 6346: @322108
     /* 322108 */   GIM_Try, /*On fail goto*//*Label 6347*/ GIMT_Encode4(322201), // Rule ID 6299 //
     /* 322113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 322121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 322125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 322129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 322133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322137 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 322141 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322150 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 322152 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 322152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 322155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322164 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 322167 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 322171 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 322174 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322179 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 322187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322191 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322193 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322199 */     GIR_RootConstrainSelectedInstOperands,
     /* 322200 */     // GIR_Coverage, 6299,
     /* 322200 */     GIR_EraseRootFromParent_Done,
     /* 322201 */   // Label 6347: @322201
     /* 322201 */   GIM_Try, /*On fail goto*//*Label 6348*/ GIMT_Encode4(322297), // Rule ID 6157 //
     /* 322206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 322217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 322225 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 322229 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 322233 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 322237 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322246 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 322248 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 322248 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 322251 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322255 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322260 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 322263 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 322267 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 322270 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322275 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 322283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322287 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322295 */     GIR_RootConstrainSelectedInstOperands,
     /* 322296 */     // GIR_Coverage, 6157,
     /* 322296 */     GIR_EraseRootFromParent_Done,
     /* 322297 */   // Label 6348: @322297
     /* 322297 */   GIM_Try, /*On fail goto*//*Label 6349*/ GIMT_Encode4(322381), // Rule ID 2546 //
     /* 322302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 322313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 322317 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322330 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322332 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 322332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 322335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322344 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 322347 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 322351 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 322354 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322359 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 322367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 322373 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322379 */     GIR_RootConstrainSelectedInstOperands,
     /* 322380 */     // GIR_Coverage, 2546,
     /* 322380 */     GIR_EraseRootFromParent_Done,
     /* 322381 */   // Label 6349: @322381
     /* 322381 */   GIM_Try, /*On fail goto*//*Label 6350*/ GIMT_Encode4(322431), // Rule ID 13480 //
     /* 322386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 322401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322416 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 322416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 322419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322421 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 322425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 322429 */     GIR_RootConstrainSelectedInstOperands,
     /* 322430 */     // GIR_Coverage, 13480,
     /* 322430 */     GIR_EraseRootFromParent_Done,
     /* 322431 */   // Label 6350: @322431
     /* 322431 */   GIM_Try, /*On fail goto*//*Label 6351*/ GIMT_Encode4(322515), // Rule ID 6125 //
     /* 322436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 322447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 322451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 322455 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322466 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 322466 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 322469 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322473 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322478 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 322481 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 322485 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 322488 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322493 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 322501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322503 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322505 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322507 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322513 */     GIR_RootConstrainSelectedInstOperands,
     /* 322514 */     // GIR_Coverage, 6125,
     /* 322514 */     GIR_EraseRootFromParent_Done,
     /* 322515 */   // Label 6351: @322515
     /* 322515 */   GIM_Try, /*On fail goto*//*Label 6352*/ GIMT_Encode4(322565), // Rule ID 1312 //
     /* 322520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 322531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 322539 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322550 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 322550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 322553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322555 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322557 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 322563 */     GIR_RootConstrainSelectedInstOperands,
     /* 322564 */     // GIR_Coverage, 1312,
     /* 322564 */     GIR_EraseRootFromParent_Done,
     /* 322565 */   // Label 6352: @322565
     /* 322565 */   GIM_Try, /*On fail goto*//*Label 6353*/ GIMT_Encode4(322598), // Rule ID 1302 //
     /* 322570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322585 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 322585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f64),
     /* 322588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 322594 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 322596 */     GIR_RootConstrainSelectedInstOperands,
     /* 322597 */     // GIR_Coverage, 1302,
     /* 322597 */     GIR_EraseRootFromParent_Done,
     /* 322598 */   // Label 6353: @322598
     /* 322598 */   GIM_Reject,
     /* 322599 */ // Label 6334: @322599
     /* 322599 */ GIM_Reject,
     /* 322600 */ // Label 6207: @322600
     /* 322600 */ GIM_Try, /*On fail goto*//*Label 6354*/ GIMT_Encode4(323778),
     /* 322605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 322608 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 322611 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 322614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322618 */   GIM_Try, /*On fail goto*//*Label 6355*/ GIMT_Encode4(322702), // Rule ID 6171 //
     /* 322623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 322634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 322638 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 322642 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 322647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 322651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322655 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 322659 */     // MIs[2] Operand 1
     /* 322659 */     // No operand predicates
     /* 322659 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 322663 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322667 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 322671 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322680 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322682 */     // (fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 322682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 322685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322687 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 322693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 322697 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 322700 */     GIR_RootConstrainSelectedInstOperands,
     /* 322701 */     // GIR_Coverage, 6171,
     /* 322701 */     GIR_EraseRootFromParent_Done,
     /* 322702 */   // Label 6355: @322702
     /* 322702 */   GIM_Try, /*On fail goto*//*Label 6356*/ GIMT_Encode4(322783), // Rule ID 6203 //
     /* 322707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 322722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 322726 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 322730 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 322734 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 322738 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 322743 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 322747 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322751 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 322755 */     // MIs[3] Operand 1
     /* 322755 */     // No operand predicates
     /* 322755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322763 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322765 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 322765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 322768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322770 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 322774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 322778 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 322781 */     GIR_RootConstrainSelectedInstOperands,
     /* 322782 */     // GIR_Coverage, 6203,
     /* 322782 */     GIR_EraseRootFromParent_Done,
     /* 322783 */   // Label 6356: @322783
     /* 322783 */   GIM_Try, /*On fail goto*//*Label 6357*/ GIMT_Encode4(322867), // Rule ID 6235 //
     /* 322788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 322803 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 322812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 322816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 322820 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 322824 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 322829 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 322833 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322837 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 322841 */     // MIs[3] Operand 1
     /* 322841 */     // No operand predicates
     /* 322841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322845 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322847 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 322847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 322850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 322858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 322862 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 322865 */     GIR_RootConstrainSelectedInstOperands,
     /* 322866 */     // GIR_Coverage, 6235,
     /* 322866 */     GIR_EraseRootFromParent_Done,
     /* 322867 */   // Label 6357: @322867
     /* 322867 */   GIM_Try, /*On fail goto*//*Label 6358*/ GIMT_Encode4(322948), // Rule ID 6139 //
     /* 322872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 322883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 322891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 322895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 322899 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 322903 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 322907 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 322912 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 322916 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322920 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 322924 */     // MIs[3] Operand 1
     /* 322924 */     // No operand predicates
     /* 322924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322928 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322930 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 322930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 322933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322935 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322937 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 322943 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 322946 */     GIR_RootConstrainSelectedInstOperands,
     /* 322947 */     // GIR_Coverage, 6139,
     /* 322947 */     GIR_EraseRootFromParent_Done,
     /* 322948 */   // Label 6358: @322948
     /* 322948 */   GIM_Try, /*On fail goto*//*Label 6359*/ GIMT_Encode4(323017), // Rule ID 2528 //
     /* 322953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 322964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 322968 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 322972 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 322977 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 322981 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322985 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 322989 */     // MIs[2] Operand 1
     /* 322989 */     // No operand predicates
     /* 322989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322997 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 322999 */     // (fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 322999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 323002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 323008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323012 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 323015 */     GIR_RootConstrainSelectedInstOperands,
     /* 323016 */     // GIR_Coverage, 2528,
     /* 323016 */     GIR_EraseRootFromParent_Done,
     /* 323017 */   // Label 6359: @323017
     /* 323017 */   GIM_Try, /*On fail goto*//*Label 6360*/ GIMT_Encode4(323086), // Rule ID 6107 //
     /* 323022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 323033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 323037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323041 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 323045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 323050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 323054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323058 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 323062 */     // MIs[2] Operand 1
     /* 323062 */     // No operand predicates
     /* 323062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323066 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323068 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 323068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 323071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323075 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 323077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 323084 */     GIR_RootConstrainSelectedInstOperands,
     /* 323085 */     // GIR_Coverage, 6107,
     /* 323085 */     GIR_EraseRootFromParent_Done,
     /* 323086 */   // Label 6360: @323086
     /* 323086 */   GIM_Try, /*On fail goto*//*Label 6361*/ GIMT_Encode4(323185), // Rule ID 6173 //
     /* 323091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 323102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 323106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 323111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 323115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323119 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 323123 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323132 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323134 */     // (fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 323134 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 323137 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323141 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323146 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 323149 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323153 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 323156 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323161 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 323166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 323169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 323177 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323183 */     GIR_RootConstrainSelectedInstOperands,
     /* 323184 */     // GIR_Coverage, 6173,
     /* 323184 */     GIR_EraseRootFromParent_Done,
     /* 323185 */   // Label 6361: @323185
     /* 323185 */   GIM_Try, /*On fail goto*//*Label 6362*/ GIMT_Encode4(323281), // Rule ID 6205 //
     /* 323190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 323205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 323209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 323213 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 323217 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 323222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323230 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323232 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 323232 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 323235 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323239 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323244 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 323247 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 323251 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 323254 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323259 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 323264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 323267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 323273 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323279 */     GIR_RootConstrainSelectedInstOperands,
     /* 323280 */     // GIR_Coverage, 6205,
     /* 323280 */     GIR_EraseRootFromParent_Done,
     /* 323281 */   // Label 6362: @323281
     /* 323281 */   GIM_Try, /*On fail goto*//*Label 6363*/ GIMT_Encode4(323380), // Rule ID 6237 //
     /* 323286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 323301 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323306 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 323310 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 323314 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 323318 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 323323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323327 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323329 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 323329 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 323332 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323336 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323341 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 323344 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 323348 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 323351 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323356 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 323361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 323364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323366 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 323372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323378 */     GIR_RootConstrainSelectedInstOperands,
     /* 323379 */     // GIR_Coverage, 6237,
     /* 323379 */     GIR_EraseRootFromParent_Done,
     /* 323380 */   // Label 6363: @323380
     /* 323380 */   GIM_Try, /*On fail goto*//*Label 6364*/ GIMT_Encode4(323476), // Rule ID 6141 //
     /* 323385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323388 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 323396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323400 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 323404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 323408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 323412 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 323416 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 323421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323425 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323427 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 323427 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 323430 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323434 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323439 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 323442 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 323446 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 323449 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323454 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 323459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 323462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323466 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 323468 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323474 */     GIR_RootConstrainSelectedInstOperands,
     /* 323475 */     // GIR_Coverage, 6141,
     /* 323475 */     GIR_EraseRootFromParent_Done,
     /* 323476 */   // Label 6364: @323476
     /* 323476 */   GIM_Try, /*On fail goto*//*Label 6365*/ GIMT_Encode4(323560), // Rule ID 2530 //
     /* 323481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 323492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 323496 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 323501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323511 */     // (fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 323511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 323514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323523 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 323526 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323530 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 323533 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323538 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 323543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 323546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 323552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323558 */     GIR_RootConstrainSelectedInstOperands,
     /* 323559 */     // GIR_Coverage, 2530,
     /* 323559 */     GIR_EraseRootFromParent_Done,
     /* 323560 */   // Label 6365: @323560
     /* 323560 */   GIM_Try, /*On fail goto*//*Label 6366*/ GIMT_Encode4(323610), // Rule ID 13472 //
     /* 323565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 323580 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323595 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 323595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 323598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 323604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323608 */     GIR_RootConstrainSelectedInstOperands,
     /* 323609 */     // GIR_Coverage, 13472,
     /* 323609 */     GIR_EraseRootFromParent_Done,
     /* 323610 */   // Label 6366: @323610
     /* 323610 */   GIM_Try, /*On fail goto*//*Label 6367*/ GIMT_Encode4(323694), // Rule ID 6109 //
     /* 323615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 323626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 323630 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 323634 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 323639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323645 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 323645 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 323648 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323652 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323657 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 323660 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323664 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 323667 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323672 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 323677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 323680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323682 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323684 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 323686 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323692 */     GIR_RootConstrainSelectedInstOperands,
     /* 323693 */     // GIR_Coverage, 6109,
     /* 323693 */     GIR_EraseRootFromParent_Done,
     /* 323694 */   // Label 6367: @323694
     /* 323694 */   GIM_Try, /*On fail goto*//*Label 6368*/ GIMT_Encode4(323744), // Rule ID 1304 //
     /* 323699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 323710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 323718 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323729 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 323729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 323732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323736 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 323738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323742 */     GIR_RootConstrainSelectedInstOperands,
     /* 323743 */     // GIR_Coverage, 1304,
     /* 323743 */     GIR_EraseRootFromParent_Done,
     /* 323744 */   // Label 6368: @323744
     /* 323744 */   GIM_Try, /*On fail goto*//*Label 6369*/ GIMT_Encode4(323777), // Rule ID 1294 //
     /* 323749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323764 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 323764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f16),
     /* 323767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 323773 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 323775 */     GIR_RootConstrainSelectedInstOperands,
     /* 323776 */     // GIR_Coverage, 1294,
     /* 323776 */     GIR_EraseRootFromParent_Done,
     /* 323777 */   // Label 6369: @323777
     /* 323777 */   GIM_Reject,
     /* 323778 */ // Label 6354: @323778
     /* 323778 */ GIM_Reject,
     /* 323779 */ // Label 6208: @323779
     /* 323779 */ GIM_Try, /*On fail goto*//*Label 6370*/ GIMT_Encode4(325299),
     /* 323784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323787 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 323790 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 323793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323797 */   GIM_Try, /*On fail goto*//*Label 6371*/ GIMT_Encode4(323875), // Rule ID 6269 //
     /* 323802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 323810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323814 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 323818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 323822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323826 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323830 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323835 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 323839 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323843 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 323847 */     // MIs[3] Operand 1
     /* 323847 */     // No operand predicates
     /* 323847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323855 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323857 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 323857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 323860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323862 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 323866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 323870 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 323873 */     GIR_RootConstrainSelectedInstOperands,
     /* 323874 */     // GIR_Coverage, 6269,
     /* 323874 */     GIR_EraseRootFromParent_Done,
     /* 323875 */   // Label 6371: @323875
     /* 323875 */   GIM_Try, /*On fail goto*//*Label 6372*/ GIMT_Encode4(323959), // Rule ID 6183 //
     /* 323880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 323891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 323899 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323904 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 323908 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323912 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 323916 */     // MIs[2] Operand 1
     /* 323916 */     // No operand predicates
     /* 323916 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 323920 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323924 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323928 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323937 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323939 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 323939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 323942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 323950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323954 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 323957 */     GIR_RootConstrainSelectedInstOperands,
     /* 323958 */     // GIR_Coverage, 6183,
     /* 323958 */     GIR_EraseRootFromParent_Done,
     /* 323959 */   // Label 6372: @323959
     /* 323959 */   GIM_Try, /*On fail goto*//*Label 6373*/ GIMT_Encode4(324040), // Rule ID 6215 //
     /* 323964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 323983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 323987 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323991 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 323995 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324000 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 324004 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 324008 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 324012 */     // MIs[3] Operand 1
     /* 324012 */     // No operand predicates
     /* 324012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324020 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 324022 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 324022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 324025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 324031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324035 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 324038 */     GIR_RootConstrainSelectedInstOperands,
     /* 324039 */     // GIR_Coverage, 6215,
     /* 324039 */     GIR_EraseRootFromParent_Done,
     /* 324040 */   // Label 6373: @324040
     /* 324040 */   GIM_Try, /*On fail goto*//*Label 6374*/ GIMT_Encode4(324124), // Rule ID 6247 //
     /* 324045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324060 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324065 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324069 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 324073 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324077 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 324081 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324086 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 324090 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 324094 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 324098 */     // MIs[3] Operand 1
     /* 324098 */     // No operand predicates
     /* 324098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324102 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 324104 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 324104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 324107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 324115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 324122 */     GIR_RootConstrainSelectedInstOperands,
     /* 324123 */     // GIR_Coverage, 6247,
     /* 324123 */     GIR_EraseRootFromParent_Done,
     /* 324124 */   // Label 6374: @324124
     /* 324124 */   GIM_Try, /*On fail goto*//*Label 6375*/ GIMT_Encode4(324202), // Rule ID 6291 //
     /* 324129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 324137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 324141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324145 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 324149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 324153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324157 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324161 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324166 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 324170 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 324174 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 324178 */     // MIs[3] Operand 1
     /* 324178 */     // No operand predicates
     /* 324178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324182 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 324184 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 324184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 324187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324191 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 324193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 324200 */     GIR_RootConstrainSelectedInstOperands,
     /* 324201 */     // GIR_Coverage, 6291,
     /* 324201 */     GIR_EraseRootFromParent_Done,
     /* 324202 */   // Label 6375: @324202
     /* 324202 */   GIM_Try, /*On fail goto*//*Label 6376*/ GIMT_Encode4(324283), // Rule ID 6151 //
     /* 324207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 324218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324226 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 324230 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 324234 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324238 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 324242 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324247 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 324251 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 324255 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 324259 */     // MIs[3] Operand 1
     /* 324259 */     // No operand predicates
     /* 324259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324263 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 324265 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 324265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 324268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324270 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324272 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 324274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324278 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 324281 */     GIR_RootConstrainSelectedInstOperands,
     /* 324282 */     // GIR_Coverage, 6151,
     /* 324282 */     GIR_EraseRootFromParent_Done,
     /* 324283 */   // Label 6376: @324283
     /* 324283 */   GIM_Try, /*On fail goto*//*Label 6377*/ GIMT_Encode4(324352), // Rule ID 2540 //
     /* 324288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 324299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324303 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 324307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 324316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 324320 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 324324 */     // MIs[2] Operand 1
     /* 324324 */     // No operand predicates
     /* 324324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324332 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324334 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 324334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 324337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324339 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 324343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 324347 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 324350 */     GIR_RootConstrainSelectedInstOperands,
     /* 324351 */     // GIR_Coverage, 2540,
     /* 324351 */     GIR_EraseRootFromParent_Done,
     /* 324352 */   // Label 6377: @324352
     /* 324352 */   GIM_Try, /*On fail goto*//*Label 6378*/ GIMT_Encode4(324421), // Rule ID 6119 //
     /* 324357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 324368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 324372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324376 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 324380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 324389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 324393 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 324397 */     // MIs[2] Operand 1
     /* 324397 */     // No operand predicates
     /* 324397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324401 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324403 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 324403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 324406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324410 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 324412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 324416 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 324419 */     GIR_RootConstrainSelectedInstOperands,
     /* 324420 */     // GIR_Coverage, 6119,
     /* 324420 */     GIR_EraseRootFromParent_Done,
     /* 324421 */   // Label 6378: @324421
     /* 324421 */   GIM_Try, /*On fail goto*//*Label 6379*/ GIMT_Encode4(324514), // Rule ID 6273 //
     /* 324426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 324434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 324438 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 324442 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324446 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 324450 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324463 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324465 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 324465 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 324468 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324472 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324477 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 324480 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324484 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 324487 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324492 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 324500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324502 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 324506 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324512 */     GIR_RootConstrainSelectedInstOperands,
     /* 324513 */     // GIR_Coverage, 6273,
     /* 324513 */     GIR_EraseRootFromParent_Done,
     /* 324514 */   // Label 6379: @324514
     /* 324514 */   GIM_Try, /*On fail goto*//*Label 6380*/ GIMT_Encode4(324613), // Rule ID 6185 //
     /* 324519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 324530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 324534 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324547 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324551 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324560 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324562 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 324562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 324565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324574 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 324577 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 324581 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 324584 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324589 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 324597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324599 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 324605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324611 */     GIR_RootConstrainSelectedInstOperands,
     /* 324612 */     // GIR_Coverage, 6185,
     /* 324612 */     GIR_EraseRootFromParent_Done,
     /* 324613 */   // Label 6380: @324613
     /* 324613 */   GIM_Try, /*On fail goto*//*Label 6381*/ GIMT_Encode4(324709), // Rule ID 6217 //
     /* 324618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 324637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 324641 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 324645 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324658 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324660 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 324660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 324663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324672 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 324675 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324679 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 324682 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324687 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 324695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 324701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324707 */     GIR_RootConstrainSelectedInstOperands,
     /* 324708 */     // GIR_Coverage, 6217,
     /* 324708 */     GIR_EraseRootFromParent_Done,
     /* 324709 */   // Label 6381: @324709
     /* 324709 */   GIM_Try, /*On fail goto*//*Label 6382*/ GIMT_Encode4(324808), // Rule ID 6249 //
     /* 324714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324729 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324734 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324738 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 324742 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 324746 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324755 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324757 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 324757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 324760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324769 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 324772 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324776 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 324779 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324784 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 324792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324794 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 324800 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324806 */     GIR_RootConstrainSelectedInstOperands,
     /* 324807 */     // GIR_Coverage, 6249,
     /* 324807 */     GIR_EraseRootFromParent_Done,
     /* 324808 */   // Label 6382: @324808
     /* 324808 */   GIM_Try, /*On fail goto*//*Label 6383*/ GIMT_Encode4(324901), // Rule ID 6295 //
     /* 324813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 324821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 324825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 324829 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 324833 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324837 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 324841 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324850 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324852 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 324852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 324855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324864 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 324867 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324871 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 324874 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324879 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 324887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324891 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 324893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324899 */     GIR_RootConstrainSelectedInstOperands,
     /* 324900 */     // GIR_Coverage, 6295,
     /* 324900 */     GIR_EraseRootFromParent_Done,
     /* 324901 */   // Label 6383: @324901
     /* 324901 */   GIM_Try, /*On fail goto*//*Label 6384*/ GIMT_Encode4(324997), // Rule ID 6153 //
     /* 324906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 324917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 324929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 324933 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 324937 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324946 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324948 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 324948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 324951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324960 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 324963 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324967 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 324970 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324975 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 324983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324985 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324987 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 324989 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324995 */     GIR_RootConstrainSelectedInstOperands,
     /* 324996 */     // GIR_Coverage, 6153,
     /* 324996 */     GIR_EraseRootFromParent_Done,
     /* 324997 */   // Label 6384: @324997
     /* 324997 */   GIM_Try, /*On fail goto*//*Label 6385*/ GIMT_Encode4(325081), // Rule ID 2542 //
     /* 325002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 325013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 325017 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325030 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325032 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 325032 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 325035 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 325039 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325044 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 325047 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 325051 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 325054 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325059 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 325067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 325073 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325079 */     GIR_RootConstrainSelectedInstOperands,
     /* 325080 */     // GIR_Coverage, 2542,
     /* 325080 */     GIR_EraseRootFromParent_Done,
     /* 325081 */   // Label 6385: @325081
     /* 325081 */   GIM_Try, /*On fail goto*//*Label 6386*/ GIMT_Encode4(325131), // Rule ID 13478 //
     /* 325086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 325097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 325101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325116 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 325116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 325119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325121 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 325125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 325129 */     GIR_RootConstrainSelectedInstOperands,
     /* 325130 */     // GIR_Coverage, 13478,
     /* 325130 */     GIR_EraseRootFromParent_Done,
     /* 325131 */   // Label 6386: @325131
     /* 325131 */   GIM_Try, /*On fail goto*//*Label 6387*/ GIMT_Encode4(325215), // Rule ID 6121 //
     /* 325136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 325147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 325151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 325155 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325166 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 325166 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 325169 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 325173 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325178 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 325181 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 325185 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 325188 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325193 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 325201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325205 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325207 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325213 */     GIR_RootConstrainSelectedInstOperands,
     /* 325214 */     // GIR_Coverage, 6121,
     /* 325214 */     GIR_EraseRootFromParent_Done,
     /* 325215 */   // Label 6387: @325215
     /* 325215 */   GIM_Try, /*On fail goto*//*Label 6388*/ GIMT_Encode4(325265), // Rule ID 1310 //
     /* 325220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 325231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 325235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 325239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325250 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 325250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 325253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325257 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 325263 */     GIR_RootConstrainSelectedInstOperands,
     /* 325264 */     // GIR_Coverage, 1310,
     /* 325264 */     GIR_EraseRootFromParent_Done,
     /* 325265 */   // Label 6388: @325265
     /* 325265 */   GIM_Try, /*On fail goto*//*Label 6389*/ GIMT_Encode4(325298), // Rule ID 1300 //
     /* 325270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325285 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 325285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f32),
     /* 325288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 325294 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 325296 */     GIR_RootConstrainSelectedInstOperands,
     /* 325297 */     // GIR_Coverage, 1300,
     /* 325297 */     GIR_EraseRootFromParent_Done,
     /* 325298 */   // Label 6389: @325298
     /* 325298 */   GIM_Reject,
     /* 325299 */ // Label 6370: @325299
     /* 325299 */ GIM_Reject,
     /* 325300 */ // Label 6209: @325300
     /* 325300 */ GIM_Try, /*On fail goto*//*Label 6390*/ GIMT_Encode4(326478),
     /* 325305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325308 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 325311 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 325314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325318 */   GIM_Try, /*On fail goto*//*Label 6391*/ GIMT_Encode4(325402), // Rule ID 6167 //
     /* 325323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 325334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325338 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 325342 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 325347 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 325351 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325355 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 325359 */     // MIs[2] Operand 1
     /* 325359 */     // No operand predicates
     /* 325359 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 325363 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 325367 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325371 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325380 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325382 */     // (fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 325382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 325385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325387 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 325393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 325397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 325400 */     GIR_RootConstrainSelectedInstOperands,
     /* 325401 */     // GIR_Coverage, 6167,
     /* 325401 */     GIR_EraseRootFromParent_Done,
     /* 325402 */   // Label 6391: @325402
     /* 325402 */   GIM_Try, /*On fail goto*//*Label 6392*/ GIMT_Encode4(325483), // Rule ID 6199 //
     /* 325407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 325418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 325426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 325430 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325434 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 325438 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 325443 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 325447 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325451 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 325455 */     // MIs[3] Operand 1
     /* 325455 */     // No operand predicates
     /* 325455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325463 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325465 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 325465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 325468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 325474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 325478 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 325481 */     GIR_RootConstrainSelectedInstOperands,
     /* 325482 */     // GIR_Coverage, 6199,
     /* 325482 */     GIR_EraseRootFromParent_Done,
     /* 325483 */   // Label 6392: @325483
     /* 325483 */   GIM_Try, /*On fail goto*//*Label 6393*/ GIMT_Encode4(325567), // Rule ID 6231 //
     /* 325488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 325499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 325512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 325516 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325520 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 325524 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 325529 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 325533 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325537 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 325541 */     // MIs[3] Operand 1
     /* 325541 */     // No operand predicates
     /* 325541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325545 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325547 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 325547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 325550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 325562 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 325565 */     GIR_RootConstrainSelectedInstOperands,
     /* 325566 */     // GIR_Coverage, 6231,
     /* 325566 */     GIR_EraseRootFromParent_Done,
     /* 325567 */   // Label 6393: @325567
     /* 325567 */   GIM_Try, /*On fail goto*//*Label 6394*/ GIMT_Encode4(325648), // Rule ID 6135 //
     /* 325572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 325583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 325587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 325595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 325599 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325603 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 325607 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 325612 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 325616 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325620 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 325624 */     // MIs[3] Operand 1
     /* 325624 */     // No operand predicates
     /* 325624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325628 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325630 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 325630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 325633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325637 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 325643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 325646 */     GIR_RootConstrainSelectedInstOperands,
     /* 325647 */     // GIR_Coverage, 6135,
     /* 325647 */     GIR_EraseRootFromParent_Done,
     /* 325648 */   // Label 6394: @325648
     /* 325648 */   GIM_Try, /*On fail goto*//*Label 6395*/ GIMT_Encode4(325717), // Rule ID 2524 //
     /* 325653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 325664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 325672 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 325677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 325681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325685 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 325689 */     // MIs[2] Operand 1
     /* 325689 */     // No operand predicates
     /* 325689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325697 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325699 */     // (fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 325699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 325702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 325708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 325712 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 325715 */     GIR_RootConstrainSelectedInstOperands,
     /* 325716 */     // GIR_Coverage, 2524,
     /* 325716 */     GIR_EraseRootFromParent_Done,
     /* 325717 */   // Label 6395: @325717
     /* 325717 */   GIM_Try, /*On fail goto*//*Label 6396*/ GIMT_Encode4(325786), // Rule ID 6103 //
     /* 325722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 325733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 325737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325741 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 325745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 325750 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 325754 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325758 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 325762 */     // MIs[2] Operand 1
     /* 325762 */     // No operand predicates
     /* 325762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325766 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325768 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 325768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 325771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325773 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325775 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 325781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 325784 */     GIR_RootConstrainSelectedInstOperands,
     /* 325785 */     // GIR_Coverage, 6103,
     /* 325785 */     GIR_EraseRootFromParent_Done,
     /* 325786 */   // Label 6396: @325786
     /* 325786 */   GIM_Try, /*On fail goto*//*Label 6397*/ GIMT_Encode4(325885), // Rule ID 6169 //
     /* 325791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 325802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325806 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 325811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 325815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 325819 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325823 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325832 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325834 */     // (fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 325834 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 325837 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 325841 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325846 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 325849 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 325853 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 325856 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325861 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 325866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 325869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 325877 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325883 */     GIR_RootConstrainSelectedInstOperands,
     /* 325884 */     // GIR_Coverage, 6169,
     /* 325884 */     GIR_EraseRootFromParent_Done,
     /* 325885 */   // Label 6397: @325885
     /* 325885 */   GIM_Try, /*On fail goto*//*Label 6398*/ GIMT_Encode4(325981), // Rule ID 6201 //
     /* 325890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 325901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 325909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 325913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 325917 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 325922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325930 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325932 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 325932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 325935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 325939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325944 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 325947 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 325951 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 325954 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325959 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 325964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 325967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 325973 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325979 */     GIR_RootConstrainSelectedInstOperands,
     /* 325980 */     // GIR_Coverage, 6201,
     /* 325980 */     GIR_EraseRootFromParent_Done,
     /* 325981 */   // Label 6398: @325981
     /* 325981 */   GIM_Try, /*On fail goto*//*Label 6399*/ GIMT_Encode4(326080), // Rule ID 6233 //
     /* 325986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 325997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326001 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 326010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 326014 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 326018 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 326023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326027 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326029 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 326029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 326032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 326036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326041 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 326044 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 326048 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 326051 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326056 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 326061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 326064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 326068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 326072 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326078 */     GIR_RootConstrainSelectedInstOperands,
     /* 326079 */     // GIR_Coverage, 6233,
     /* 326079 */     GIR_EraseRootFromParent_Done,
     /* 326080 */   // Label 6399: @326080
     /* 326080 */   GIM_Try, /*On fail goto*//*Label 6400*/ GIMT_Encode4(326176), // Rule ID 6137 //
     /* 326085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 326088 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 326096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 326100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 326108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 326112 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 326116 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 326121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326125 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326127 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 326127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 326130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 326134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326139 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 326142 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 326146 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 326149 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326154 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 326159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 326162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326164 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 326166 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 326168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326174 */     GIR_RootConstrainSelectedInstOperands,
     /* 326175 */     // GIR_Coverage, 6137,
     /* 326175 */     GIR_EraseRootFromParent_Done,
     /* 326176 */   // Label 6400: @326176
     /* 326176 */   GIM_Try, /*On fail goto*//*Label 6401*/ GIMT_Encode4(326260), // Rule ID 2526 //
     /* 326181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 326184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 326192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 326196 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 326201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 326211 */     // (fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 326211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 326214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 326218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326223 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 326226 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 326230 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 326233 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326238 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 326243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 326246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 326250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 326252 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326258 */     GIR_RootConstrainSelectedInstOperands,
     /* 326259 */     // GIR_Coverage, 2526,
     /* 326259 */     GIR_EraseRootFromParent_Done,
     /* 326260 */   // Label 6401: @326260
     /* 326260 */   GIM_Try, /*On fail goto*//*Label 6402*/ GIMT_Encode4(326310), // Rule ID 13474 //
     /* 326265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 326268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 326276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326280 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 326295 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 326295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 326298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326300 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 326302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 326304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 326308 */     GIR_RootConstrainSelectedInstOperands,
     /* 326309 */     // GIR_Coverage, 13474,
     /* 326309 */     GIR_EraseRootFromParent_Done,
     /* 326310 */   // Label 6402: @326310
     /* 326310 */   GIM_Try, /*On fail goto*//*Label 6403*/ GIMT_Encode4(326394), // Rule ID 6105 //
     /* 326315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 326318 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 326326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 326330 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 326334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 326339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 326345 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 326345 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 326348 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 326352 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326357 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 326360 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 326364 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 326367 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326372 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 326377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 326380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326382 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 326384 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 326386 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326392 */     GIR_RootConstrainSelectedInstOperands,
     /* 326393 */     // GIR_Coverage, 6105,
     /* 326393 */     GIR_EraseRootFromParent_Done,
     /* 326394 */   // Label 6403: @326394
     /* 326394 */   GIM_Try, /*On fail goto*//*Label 6404*/ GIMT_Encode4(326444), // Rule ID 1306 //
     /* 326399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 326402 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 326410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 326414 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326418 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 326429 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 326429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 326432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 326436 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 326438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 326442 */     GIR_RootConstrainSelectedInstOperands,
     /* 326443 */     // GIR_Coverage, 1306,
     /* 326443 */     GIR_EraseRootFromParent_Done,
     /* 326444 */   // Label 6404: @326444
     /* 326444 */   GIM_Try, /*On fail goto*//*Label 6405*/ GIMT_Encode4(326477), // Rule ID 1296 //
     /* 326449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 326452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326464 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 326464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8f16),
     /* 326467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 326471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 326473 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 326475 */     GIR_RootConstrainSelectedInstOperands,
     /* 326476 */     // GIR_Coverage, 1296,
     /* 326476 */     GIR_EraseRootFromParent_Done,
     /* 326477 */   // Label 6405: @326477
     /* 326477 */   GIM_Reject,
     /* 326478 */ // Label 6390: @326478
     /* 326478 */ GIM_Reject,
     /* 326479 */ // Label 6210: @326479
     /* 326479 */ GIM_Reject,
     /* 326480 */ // Label 63: @326480
     /* 326480 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6414*/ GIMT_Encode4(327095),
     /* 326491 */ /*GILLT_s16*//*Label 6406*/ GIMT_Encode4(326531),
     /* 326495 */ /*GILLT_s32*//*Label 6407*/ GIMT_Encode4(326569),
     /* 326499 */ /*GILLT_s64*//*Label 6408*/ GIMT_Encode4(326607), GIMT_Encode4(0),
     /* 326507 */ /*GILLT_v2s32*//*Label 6409*/ GIMT_Encode4(326645),
     /* 326511 */ /*GILLT_v2s64*//*Label 6410*/ GIMT_Encode4(326683),
     /* 326515 */ /*GILLT_v4s16*//*Label 6411*/ GIMT_Encode4(326721),
     /* 326519 */ /*GILLT_v4s32*//*Label 6412*/ GIMT_Encode4(326759), GIMT_Encode4(0),
     /* 326527 */ /*GILLT_v8s16*//*Label 6413*/ GIMT_Encode4(326797),
     /* 326531 */ // Label 6406: @326531
     /* 326531 */ GIM_Try, /*On fail goto*//*Label 6415*/ GIMT_Encode4(326568), // Rule ID 590 //
     /* 326536 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 326539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 326542 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 326545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326549 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326553 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326557 */   // (fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FDIVHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 326557 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVHrr),
     /* 326562 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326566 */   GIR_RootConstrainSelectedInstOperands,
     /* 326567 */   // GIR_Coverage, 590,
     /* 326567 */   GIR_Done,
     /* 326568 */ // Label 6415: @326568
     /* 326568 */ GIM_Reject,
     /* 326569 */ // Label 6407: @326569
     /* 326569 */ GIM_Try, /*On fail goto*//*Label 6416*/ GIMT_Encode4(326606), // Rule ID 592 //
     /* 326574 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 326577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 326580 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 326583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326587 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326591 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326595 */   // (fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FDIVSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 326595 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVSrr),
     /* 326600 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326604 */   GIR_RootConstrainSelectedInstOperands,
     /* 326605 */   // GIR_Coverage, 592,
     /* 326605 */   GIR_Done,
     /* 326606 */ // Label 6416: @326606
     /* 326606 */ GIM_Reject,
     /* 326607 */ // Label 6408: @326607
     /* 326607 */ GIM_Try, /*On fail goto*//*Label 6417*/ GIMT_Encode4(326644), // Rule ID 594 //
     /* 326612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 326615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 326618 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 326621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326625 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326629 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326633 */   // (fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FDIVDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 326633 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVDrr),
     /* 326638 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326642 */   GIR_RootConstrainSelectedInstOperands,
     /* 326643 */   // GIR_Coverage, 594,
     /* 326643 */   GIR_Done,
     /* 326644 */ // Label 6417: @326644
     /* 326644 */ GIM_Reject,
     /* 326645 */ // Label 6409: @326645
     /* 326645 */ GIM_Try, /*On fail goto*//*Label 6418*/ GIMT_Encode4(326682), // Rule ID 1228 //
     /* 326650 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326653 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 326656 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 326659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326663 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326667 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326671 */   // (fdiv:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FDIVv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 326671 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f32),
     /* 326676 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326680 */   GIR_RootConstrainSelectedInstOperands,
     /* 326681 */   // GIR_Coverage, 1228,
     /* 326681 */   GIR_Done,
     /* 326682 */ // Label 6418: @326682
     /* 326682 */ GIM_Reject,
     /* 326683 */ // Label 6410: @326683
     /* 326683 */ GIM_Try, /*On fail goto*//*Label 6419*/ GIMT_Encode4(326720), // Rule ID 1232 //
     /* 326688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 326694 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 326697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326701 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326705 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326709 */   // (fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FDIVv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 326709 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f64),
     /* 326714 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326718 */   GIR_RootConstrainSelectedInstOperands,
     /* 326719 */   // GIR_Coverage, 1232,
     /* 326719 */   GIR_Done,
     /* 326720 */ // Label 6419: @326720
     /* 326720 */ GIM_Reject,
     /* 326721 */ // Label 6411: @326721
     /* 326721 */ GIM_Try, /*On fail goto*//*Label 6420*/ GIMT_Encode4(326758), // Rule ID 1224 //
     /* 326726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 326729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 326732 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 326735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326739 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326743 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326747 */   // (fdiv:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FDIVv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 326747 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f16),
     /* 326752 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326756 */   GIR_RootConstrainSelectedInstOperands,
     /* 326757 */   // GIR_Coverage, 1224,
     /* 326757 */   GIR_Done,
     /* 326758 */ // Label 6420: @326758
     /* 326758 */ GIM_Reject,
     /* 326759 */ // Label 6412: @326759
     /* 326759 */ GIM_Try, /*On fail goto*//*Label 6421*/ GIMT_Encode4(326796), // Rule ID 1230 //
     /* 326764 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326767 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 326770 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 326773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326777 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326781 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326785 */   // (fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FDIVv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 326785 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 326790 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326794 */   GIR_RootConstrainSelectedInstOperands,
     /* 326795 */   // GIR_Coverage, 1230,
     /* 326795 */   GIR_Done,
     /* 326796 */ // Label 6421: @326796
     /* 326796 */ GIM_Reject,
     /* 326797 */ // Label 6413: @326797
     /* 326797 */ GIM_Try, /*On fail goto*//*Label 6422*/ GIMT_Encode4(327094),
     /* 326802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326805 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 326808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326812 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326816 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326820 */   GIM_Try, /*On fail goto*//*Label 6423*/ GIMT_Encode4(326839), // Rule ID 1226 //
     /* 326825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 326828 */     // (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FDIVv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 326828 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv8f16),
     /* 326833 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326837 */     GIR_RootConstrainSelectedInstOperands,
     /* 326838 */     // GIR_Coverage, 1226,
     /* 326838 */     GIR_Done,
     /* 326839 */   // Label 6423: @326839
     /* 326839 */   GIM_Try, /*On fail goto*//*Label 6424*/ GIMT_Encode4(327093), // Rule ID 7084 //
     /* 326844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 326847 */     // (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FDIVv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FDIVv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 326847 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 326850 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 326854 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326859 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 326863 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 326865 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 326868 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 326872 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326877 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 326881 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 326883 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 326886 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 326890 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326895 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 326898 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 326901 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 326903 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 326906 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326910 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326915 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 326921 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326926 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326931 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 326934 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 326938 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326943 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 326946 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 326948 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 326951 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326955 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326960 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 326966 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326971 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326976 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 326979 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 326983 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326988 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 326991 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 326993 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 326996 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 327000 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327005 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 327008 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 327011 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 327013 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 327016 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 327020 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327025 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 327028 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 327030 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 327033 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 327037 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 327044 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 327047 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 327051 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327056 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 327059 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 327062 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 327065 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327070 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327075 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 327083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 327085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327088 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 327091 */     GIR_RootConstrainSelectedInstOperands,
     /* 327092 */     // GIR_Coverage, 7084,
     /* 327092 */     GIR_EraseRootFromParent_Done,
     /* 327093 */   // Label 6424: @327093
     /* 327093 */   GIM_Reject,
     /* 327094 */ // Label 6422: @327094
     /* 327094 */ GIM_Reject,
     /* 327095 */ // Label 6414: @327095
     /* 327095 */ GIM_Reject,
     /* 327096 */ // Label 64: @327096
     /* 327096 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6433*/ GIMT_Encode4(330602),
     /* 327107 */ /*GILLT_s16*//*Label 6425*/ GIMT_Encode4(327147),
     /* 327111 */ /*GILLT_s32*//*Label 6426*/ GIMT_Encode4(328315),
     /* 327115 */ /*GILLT_s64*//*Label 6427*/ GIMT_Encode4(329338), GIMT_Encode4(0),
     /* 327123 */ /*GILLT_v2s32*//*Label 6428*/ GIMT_Encode4(330361),
     /* 327127 */ /*GILLT_v2s64*//*Label 6429*/ GIMT_Encode4(330388),
     /* 327131 */ /*GILLT_v4s16*//*Label 6430*/ GIMT_Encode4(330415),
     /* 327135 */ /*GILLT_v4s32*//*Label 6431*/ GIMT_Encode4(330495), GIMT_Encode4(0),
     /* 327143 */ /*GILLT_v8s16*//*Label 6432*/ GIMT_Encode4(330522),
     /* 327147 */ // Label 6425: @327147
     /* 327147 */ GIM_Try, /*On fail goto*//*Label 6434*/ GIMT_Encode4(328314),
     /* 327152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 327155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327159 */   GIM_Try, /*On fail goto*//*Label 6435*/ GIMT_Encode4(327317), // Rule ID 4908 //
     /* 327164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 327167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 327175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 327179 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 327183 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 327187 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 327191 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327195 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 327199 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 327203 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327208 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 327212 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 327216 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327220 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 327224 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 327228 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327233 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 327237 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327242 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327244 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 327244 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 327247 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327251 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327256 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 327262 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327267 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 327275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327284 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 327290 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327295 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 327303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327308 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 327311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327315 */     GIR_RootConstrainSelectedInstOperands,
     /* 327316 */     // GIR_Coverage, 4908,
     /* 327316 */     GIR_EraseRootFromParent_Done,
     /* 327317 */   // Label 6435: @327317
     /* 327317 */   GIM_Try, /*On fail goto*//*Label 6436*/ GIMT_Encode4(327475), // Rule ID 4907 //
     /* 327322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 327325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 327333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 327337 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 327341 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 327345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 327349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327353 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 327357 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 327361 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327366 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 327370 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 327374 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327378 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 327382 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 327386 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327391 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 327395 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327400 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327402 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 327402 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 327405 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327409 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327414 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 327420 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327425 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 327433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327442 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 327448 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327453 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 327461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327463 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327466 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 327469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327473 */     GIR_RootConstrainSelectedInstOperands,
     /* 327474 */     // GIR_Coverage, 4907,
     /* 327474 */     GIR_EraseRootFromParent_Done,
     /* 327475 */   // Label 6436: @327475
     /* 327475 */   GIM_Try, /*On fail goto*//*Label 6437*/ GIMT_Encode4(327586), // Rule ID 4906 //
     /* 327480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 327483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 327491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 327495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 327499 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 327503 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 327507 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327511 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 327515 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 327519 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327524 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 327528 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327533 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327538 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327540 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 327540 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 327543 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327547 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327552 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 327558 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327563 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 327571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327573 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 327580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327584 */     GIR_RootConstrainSelectedInstOperands,
     /* 327585 */     // GIR_Coverage, 4906,
     /* 327585 */     GIR_EraseRootFromParent_Done,
     /* 327586 */   // Label 6437: @327586
     /* 327586 */   GIM_Try, /*On fail goto*//*Label 6438*/ GIMT_Encode4(327697), // Rule ID 4904 //
     /* 327591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 327594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 327602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 327606 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 327610 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 327614 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 327623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327627 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 327631 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 327635 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327640 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 327644 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327649 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327651 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 327651 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 327654 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327658 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327663 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 327669 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327674 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 327682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 327688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327695 */     GIR_RootConstrainSelectedInstOperands,
     /* 327696 */     // GIR_Coverage, 4904,
     /* 327696 */     GIR_EraseRootFromParent_Done,
     /* 327697 */   // Label 6438: @327697
     /* 327697 */   GIM_Try, /*On fail goto*//*Label 6439*/ GIMT_Encode4(327808), // Rule ID 4905 //
     /* 327702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 327705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 327713 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 327717 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 327721 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 327725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 327729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327733 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 327737 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 327741 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327746 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 327750 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327755 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327760 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327762 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 327762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 327765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327774 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 327780 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327785 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 327793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327795 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 327802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327806 */     GIR_RootConstrainSelectedInstOperands,
     /* 327807 */     // GIR_Coverage, 4905,
     /* 327807 */     GIR_EraseRootFromParent_Done,
     /* 327808 */   // Label 6439: @327808
     /* 327808 */   GIM_Try, /*On fail goto*//*Label 6440*/ GIMT_Encode4(327919), // Rule ID 4903 //
     /* 327813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 327816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 327824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 327828 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 327832 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 327836 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 327845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327849 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 327853 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 327857 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327862 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 327866 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327871 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327873 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 327873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 327876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327885 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 327891 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327896 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 327904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 327910 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327917 */     GIR_RootConstrainSelectedInstOperands,
     /* 327918 */     // GIR_Coverage, 4903,
     /* 327918 */     GIR_EraseRootFromParent_Done,
     /* 327919 */   // Label 6440: @327919
     /* 327919 */   GIM_Try, /*On fail goto*//*Label 6441*/ GIMT_Encode4(327983), // Rule ID 650 //
     /* 327924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 327927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 327935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 327939 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 327943 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 327947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327952 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327957 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 327964 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 327964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 327967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 327973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 327977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327981 */     GIR_RootConstrainSelectedInstOperands,
     /* 327982 */     // GIR_Coverage, 650,
     /* 327982 */     GIR_EraseRootFromParent_Done,
     /* 327983 */   // Label 6441: @327983
     /* 327983 */   GIM_Try, /*On fail goto*//*Label 6442*/ GIMT_Encode4(328047), // Rule ID 649 //
     /* 327988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 327991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 327999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 328003 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 328007 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 328011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 328016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 328021 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 328026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328028 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 328028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 328031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 328041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 328045 */     GIR_RootConstrainSelectedInstOperands,
     /* 328046 */     // GIR_Coverage, 649,
     /* 328046 */     GIR_EraseRootFromParent_Done,
     /* 328047 */   // Label 6442: @328047
     /* 328047 */   GIM_Try, /*On fail goto*//*Label 6443*/ GIMT_Encode4(328098), // Rule ID 626 //
     /* 328052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 328055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 328063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 328067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 328071 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 328076 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 328081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328083 */     // (fneg:{ *:[f16] } (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 328083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 328086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 328096 */     GIR_RootConstrainSelectedInstOperands,
     /* 328097 */     // GIR_Coverage, 626,
     /* 328097 */     GIR_EraseRootFromParent_Done,
     /* 328098 */   // Label 6443: @328098
     /* 328098 */   GIM_Try, /*On fail goto*//*Label 6444*/ GIMT_Encode4(328149), // Rule ID 625 //
     /* 328103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 328106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 328114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 328118 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 328122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 328127 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 328132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328134 */     // (fneg:{ *:[f16] } (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 328134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 328137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 328147 */     GIR_RootConstrainSelectedInstOperands,
     /* 328148 */     // GIR_Coverage, 625,
     /* 328148 */     GIR_EraseRootFromParent_Done,
     /* 328149 */   // Label 6444: @328149
     /* 328149 */   GIM_Try, /*On fail goto*//*Label 6445*/ GIMT_Encode4(328168), // Rule ID 524 //
     /* 328154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 328157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 328161 */     // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FNEGHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 328161 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGHr),
     /* 328166 */     GIR_RootConstrainSelectedInstOperands,
     /* 328167 */     // GIR_Coverage, 524,
     /* 328167 */     GIR_Done,
     /* 328168 */   // Label 6445: @328168
     /* 328168 */   GIM_Try, /*On fail goto*//*Label 6446*/ GIMT_Encode4(328313), // Rule ID 6435 //
     /* 328173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 328177 */     // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } (EORWri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), GPR32:{ *:[i32] }), (logical_imm32_XFORM:{ *:[i32] } 32768:{ *:[i32] })), FPR32:{ *:[i32] }), hsub:{ *:[i32] })
     /* 328177 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 328180 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 328184 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328189 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 328191 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 328194 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 328198 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328203 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 328206 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 328210 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 328213 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328218 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328223 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 328228 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 328231 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328235 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328240 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 328243 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 328248 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 328251 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::EORWri),
     /* 328255 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328260 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 328263 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // 
     /* 328268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 328270 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 328273 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328277 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328282 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 328285 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328295 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 328302 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 328307 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328312 */     // GIR_Coverage, 6435,
     /* 328312 */     GIR_EraseRootFromParent_Done,
     /* 328313 */   // Label 6446: @328313
     /* 328313 */   GIM_Reject,
     /* 328314 */ // Label 6434: @328314
     /* 328314 */ GIM_Reject,
     /* 328315 */ // Label 6426: @328315
     /* 328315 */ GIM_Try, /*On fail goto*//*Label 6447*/ GIMT_Encode4(329337),
     /* 328320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 328323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328327 */   GIM_Try, /*On fail goto*//*Label 6448*/ GIMT_Encode4(328485), // Rule ID 4914 //
     /* 328332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 328343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 328347 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 328351 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 328355 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 328359 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328363 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 328367 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 328371 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328376 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 328380 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 328384 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328388 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 328392 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 328396 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328401 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 328405 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328410 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328412 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 328412 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 328415 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328419 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328424 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 328430 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328435 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 328443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328452 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 328458 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328463 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 328471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328473 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 328479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 328483 */     GIR_RootConstrainSelectedInstOperands,
     /* 328484 */     // GIR_Coverage, 4914,
     /* 328484 */     GIR_EraseRootFromParent_Done,
     /* 328485 */   // Label 6448: @328485
     /* 328485 */   GIM_Try, /*On fail goto*//*Label 6449*/ GIMT_Encode4(328643), // Rule ID 4913 //
     /* 328490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 328501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 328505 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 328509 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 328513 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 328517 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328521 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 328525 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 328529 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328534 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 328538 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 328542 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328546 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 328550 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 328554 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328559 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 328563 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328568 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328570 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 328570 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 328573 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328577 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328582 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 328588 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328593 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328598 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 328601 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328605 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328610 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 328616 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328621 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 328629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328631 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328634 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 328637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 328641 */     GIR_RootConstrainSelectedInstOperands,
     /* 328642 */     // GIR_Coverage, 4913,
     /* 328642 */     GIR_EraseRootFromParent_Done,
     /* 328643 */   // Label 6449: @328643
     /* 328643 */   GIM_Try, /*On fail goto*//*Label 6450*/ GIMT_Encode4(328754), // Rule ID 4912 //
     /* 328648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 328659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 328663 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 328667 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 328671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 328675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328679 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 328683 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 328687 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328692 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 328696 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328706 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328708 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 328708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 328711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328720 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 328726 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328731 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 328739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 328748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 328752 */     GIR_RootConstrainSelectedInstOperands,
     /* 328753 */     // GIR_Coverage, 4912,
     /* 328753 */     GIR_EraseRootFromParent_Done,
     /* 328754 */   // Label 6450: @328754
     /* 328754 */   GIM_Try, /*On fail goto*//*Label 6451*/ GIMT_Encode4(328865), // Rule ID 4910 //
     /* 328759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 328770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 328774 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 328778 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 328782 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 328791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328795 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 328799 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 328803 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328808 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 328812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328817 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328819 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 328819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 328822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328831 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 328837 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328842 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 328850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 328863 */     GIR_RootConstrainSelectedInstOperands,
     /* 328864 */     // GIR_Coverage, 4910,
     /* 328864 */     GIR_EraseRootFromParent_Done,
     /* 328865 */   // Label 6451: @328865
     /* 328865 */   GIM_Try, /*On fail goto*//*Label 6452*/ GIMT_Encode4(328976), // Rule ID 4911 //
     /* 328870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 328881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 328885 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 328889 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 328893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 328897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328901 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 328905 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 328909 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328914 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 328918 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328923 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328928 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328930 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 328930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 328933 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328937 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328942 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 328948 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328953 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 328961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 328970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 328974 */     GIR_RootConstrainSelectedInstOperands,
     /* 328975 */     // GIR_Coverage, 4911,
     /* 328975 */     GIR_EraseRootFromParent_Done,
     /* 328976 */   // Label 6452: @328976
     /* 328976 */   GIM_Try, /*On fail goto*//*Label 6453*/ GIMT_Encode4(329087), // Rule ID 4909 //
     /* 328981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 328992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 328996 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 329000 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 329004 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329009 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 329013 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 329017 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 329021 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 329025 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329030 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 329034 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329039 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 329041 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 329041 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 329044 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329048 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329053 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 329059 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329064 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 329072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329078 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 329085 */     GIR_RootConstrainSelectedInstOperands,
     /* 329086 */     // GIR_Coverage, 4909,
     /* 329086 */     GIR_EraseRootFromParent_Done,
     /* 329087 */   // Label 6453: @329087
     /* 329087 */   GIM_Try, /*On fail goto*//*Label 6454*/ GIMT_Encode4(329151), // Rule ID 652 //
     /* 329092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 329103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 329107 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 329111 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 329115 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329120 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329132 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 329132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 329135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 329145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 329149 */     GIR_RootConstrainSelectedInstOperands,
     /* 329150 */     // GIR_Coverage, 652,
     /* 329150 */     GIR_EraseRootFromParent_Done,
     /* 329151 */   // Label 6454: @329151
     /* 329151 */   GIM_Try, /*On fail goto*//*Label 6455*/ GIMT_Encode4(329215), // Rule ID 651 //
     /* 329156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 329167 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 329171 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 329175 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 329179 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329184 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329196 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 329196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 329199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 329209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 329213 */     GIR_RootConstrainSelectedInstOperands,
     /* 329214 */     // GIR_Coverage, 651,
     /* 329214 */     GIR_EraseRootFromParent_Done,
     /* 329215 */   // Label 6455: @329215
     /* 329215 */   GIM_Try, /*On fail goto*//*Label 6456*/ GIMT_Encode4(329266), // Rule ID 628 //
     /* 329220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 329231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 329235 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 329239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329244 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329251 */     // (fneg:{ *:[f32] } (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 329251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 329254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 329264 */     GIR_RootConstrainSelectedInstOperands,
     /* 329265 */     // GIR_Coverage, 628,
     /* 329265 */     GIR_EraseRootFromParent_Done,
     /* 329266 */   // Label 6456: @329266
     /* 329266 */   GIM_Try, /*On fail goto*//*Label 6457*/ GIMT_Encode4(329317), // Rule ID 627 //
     /* 329271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 329282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 329286 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 329290 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329295 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329302 */     // (fneg:{ *:[f32] } (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 329302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 329305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 329315 */     GIR_RootConstrainSelectedInstOperands,
     /* 329316 */     // GIR_Coverage, 627,
     /* 329316 */     GIR_EraseRootFromParent_Done,
     /* 329317 */   // Label 6457: @329317
     /* 329317 */   GIM_Try, /*On fail goto*//*Label 6458*/ GIMT_Encode4(329336), // Rule ID 525 //
     /* 329322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329329 */     // (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FNEGSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 329329 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGSr),
     /* 329334 */     GIR_RootConstrainSelectedInstOperands,
     /* 329335 */     // GIR_Coverage, 525,
     /* 329335 */     GIR_Done,
     /* 329336 */   // Label 6458: @329336
     /* 329336 */   GIM_Reject,
     /* 329337 */ // Label 6447: @329337
     /* 329337 */ GIM_Reject,
     /* 329338 */ // Label 6427: @329338
     /* 329338 */ GIM_Try, /*On fail goto*//*Label 6459*/ GIMT_Encode4(330360),
     /* 329343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 329346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329350 */   GIM_Try, /*On fail goto*//*Label 6460*/ GIMT_Encode4(329508), // Rule ID 4920 //
     /* 329355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 329366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 329374 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 329378 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 329382 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 329386 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 329390 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 329394 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329399 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 329403 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 329407 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 329411 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 329415 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 329419 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329424 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 329428 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329433 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 329435 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 329435 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 329438 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329442 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329447 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 329453 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329458 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329463 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 329466 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329470 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329475 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 329481 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329486 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 329494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329496 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329499 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 329502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 329506 */     GIR_RootConstrainSelectedInstOperands,
     /* 329507 */     // GIR_Coverage, 4920,
     /* 329507 */     GIR_EraseRootFromParent_Done,
     /* 329508 */   // Label 6460: @329508
     /* 329508 */   GIM_Try, /*On fail goto*//*Label 6461*/ GIMT_Encode4(329666), // Rule ID 4919 //
     /* 329513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 329524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329528 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 329532 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 329536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 329540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 329544 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 329548 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 329552 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329557 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 329561 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 329565 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 329569 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 329573 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 329577 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329582 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 329586 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329591 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 329593 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 329593 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 329596 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329600 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329605 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 329611 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329616 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329621 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 329624 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329628 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329633 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 329639 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329644 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 329652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 329660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 329664 */     GIR_RootConstrainSelectedInstOperands,
     /* 329665 */     // GIR_Coverage, 4919,
     /* 329665 */     GIR_EraseRootFromParent_Done,
     /* 329666 */   // Label 6461: @329666
     /* 329666 */   GIM_Try, /*On fail goto*//*Label 6462*/ GIMT_Encode4(329777), // Rule ID 4918 //
     /* 329671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 329682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329686 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 329690 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 329694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 329698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 329702 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 329706 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 329710 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329715 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 329719 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329729 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 329731 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 329731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 329734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329743 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 329749 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329754 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 329762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329764 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 329771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 329775 */     GIR_RootConstrainSelectedInstOperands,
     /* 329776 */     // GIR_Coverage, 4918,
     /* 329776 */     GIR_EraseRootFromParent_Done,
     /* 329777 */   // Label 6462: @329777
     /* 329777 */   GIM_Try, /*On fail goto*//*Label 6463*/ GIMT_Encode4(329888), // Rule ID 4916 //
     /* 329782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 329793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329797 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 329801 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 329805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 329814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 329818 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 329822 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 329826 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329831 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 329835 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329840 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 329842 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 329842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 329845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329854 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 329860 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329865 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 329873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 329886 */     GIR_RootConstrainSelectedInstOperands,
     /* 329887 */     // GIR_Coverage, 4916,
     /* 329887 */     GIR_EraseRootFromParent_Done,
     /* 329888 */   // Label 6463: @329888
     /* 329888 */   GIM_Try, /*On fail goto*//*Label 6464*/ GIMT_Encode4(329999), // Rule ID 4917 //
     /* 329893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 329904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329908 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 329912 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 329916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 329920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 329924 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 329928 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 329932 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329937 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 329941 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329951 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 329953 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 329953 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 329956 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329960 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329965 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 329971 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329976 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 329984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329986 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 329993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 329997 */     GIR_RootConstrainSelectedInstOperands,
     /* 329998 */     // GIR_Coverage, 4917,
     /* 329998 */     GIR_EraseRootFromParent_Done,
     /* 329999 */   // Label 6464: @329999
     /* 329999 */   GIM_Try, /*On fail goto*//*Label 6465*/ GIMT_Encode4(330110), // Rule ID 4915 //
     /* 330004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 330015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 330023 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 330027 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330032 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 330036 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 330040 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 330044 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 330048 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330053 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 330057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330062 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 330064 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 330064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 330067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 330071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330076 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 330082 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330087 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 330095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330101 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 330108 */     GIR_RootConstrainSelectedInstOperands,
     /* 330109 */     // GIR_Coverage, 4915,
     /* 330109 */     GIR_EraseRootFromParent_Done,
     /* 330110 */   // Label 6465: @330110
     /* 330110 */   GIM_Try, /*On fail goto*//*Label 6466*/ GIMT_Encode4(330174), // Rule ID 654 //
     /* 330115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 330126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330130 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 330134 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 330138 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330143 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330148 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330155 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 330155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 330158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 330168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 330172 */     GIR_RootConstrainSelectedInstOperands,
     /* 330173 */     // GIR_Coverage, 654,
     /* 330173 */     GIR_EraseRootFromParent_Done,
     /* 330174 */   // Label 6466: @330174
     /* 330174 */   GIM_Try, /*On fail goto*//*Label 6467*/ GIMT_Encode4(330238), // Rule ID 653 //
     /* 330179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 330190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330194 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 330198 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 330202 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330207 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330219 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 330219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 330222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 330232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 330236 */     GIR_RootConstrainSelectedInstOperands,
     /* 330237 */     // GIR_Coverage, 653,
     /* 330237 */     GIR_EraseRootFromParent_Done,
     /* 330238 */   // Label 6467: @330238
     /* 330238 */   GIM_Try, /*On fail goto*//*Label 6468*/ GIMT_Encode4(330289), // Rule ID 630 //
     /* 330243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 330254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330258 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 330262 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330272 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330274 */     // (fneg:{ *:[f64] } (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 330274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 330277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 330287 */     GIR_RootConstrainSelectedInstOperands,
     /* 330288 */     // GIR_Coverage, 630,
     /* 330288 */     GIR_EraseRootFromParent_Done,
     /* 330289 */   // Label 6468: @330289
     /* 330289 */   GIM_Try, /*On fail goto*//*Label 6469*/ GIMT_Encode4(330340), // Rule ID 629 //
     /* 330294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 330305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330309 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 330313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330318 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330325 */     // (fneg:{ *:[f64] } (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 330325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 330328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 330338 */     GIR_RootConstrainSelectedInstOperands,
     /* 330339 */     // GIR_Coverage, 629,
     /* 330339 */     GIR_EraseRootFromParent_Done,
     /* 330340 */   // Label 6469: @330340
     /* 330340 */   GIM_Try, /*On fail goto*//*Label 6470*/ GIMT_Encode4(330359), // Rule ID 526 //
     /* 330345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330352 */     // (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FNEGDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 330352 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGDr),
     /* 330357 */     GIR_RootConstrainSelectedInstOperands,
     /* 330358 */     // GIR_Coverage, 526,
     /* 330358 */     GIR_Done,
     /* 330359 */   // Label 6470: @330359
     /* 330359 */   GIM_Reject,
     /* 330360 */ // Label 6459: @330360
     /* 330360 */ GIM_Reject,
     /* 330361 */ // Label 6428: @330361
     /* 330361 */ GIM_Try, /*On fail goto*//*Label 6471*/ GIMT_Encode4(330387), // Rule ID 860 //
     /* 330366 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 330369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 330372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330380 */   // (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FNEGv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 330380 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv2f32),
     /* 330385 */   GIR_RootConstrainSelectedInstOperands,
     /* 330386 */   // GIR_Coverage, 860,
     /* 330386 */   GIR_Done,
     /* 330387 */ // Label 6471: @330387
     /* 330387 */ GIM_Reject,
     /* 330388 */ // Label 6429: @330388
     /* 330388 */ GIM_Try, /*On fail goto*//*Label 6472*/ GIMT_Encode4(330414), // Rule ID 862 //
     /* 330393 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 330396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 330399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330403 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330407 */   // (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FNEGv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 330407 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv2f64),
     /* 330412 */   GIR_RootConstrainSelectedInstOperands,
     /* 330413 */   // GIR_Coverage, 862,
     /* 330413 */   GIR_Done,
     /* 330414 */ // Label 6472: @330414
     /* 330414 */ GIM_Reject,
     /* 330415 */ // Label 6430: @330415
     /* 330415 */ GIM_Try, /*On fail goto*//*Label 6473*/ GIMT_Encode4(330494),
     /* 330420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 330423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330427 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330431 */   GIM_Try, /*On fail goto*//*Label 6474*/ GIMT_Encode4(330446), // Rule ID 858 //
     /* 330436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 330439 */     // (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FNEGv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 330439 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv4f16),
     /* 330444 */     GIR_RootConstrainSelectedInstOperands,
     /* 330445 */     // GIR_Coverage, 858,
     /* 330445 */     GIR_Done,
     /* 330446 */   // Label 6474: @330446
     /* 330446 */   GIM_Try, /*On fail goto*//*Label 6475*/ GIMT_Encode4(330493), // Rule ID 6438 //
     /* 330451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 330454 */     // (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (EORv8i8:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (MOVIv4i16:{ *:[i64] } 128:{ *:[i32] }, 8:{ *:[i32] }))
     /* 330454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 330457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i16),
     /* 330461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330466 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(128),
     /* 330476 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 330479 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /* 330484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330486 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 330488 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330491 */     GIR_RootConstrainSelectedInstOperands,
     /* 330492 */     // GIR_Coverage, 6438,
     /* 330492 */     GIR_EraseRootFromParent_Done,
     /* 330493 */   // Label 6475: @330493
     /* 330493 */   GIM_Reject,
     /* 330494 */ // Label 6473: @330494
     /* 330494 */ GIM_Reject,
     /* 330495 */ // Label 6431: @330495
     /* 330495 */ GIM_Try, /*On fail goto*//*Label 6476*/ GIMT_Encode4(330521), // Rule ID 861 //
     /* 330500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 330503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 330506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330510 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330514 */   // (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FNEGv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 330514 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv4f32),
     /* 330519 */   GIR_RootConstrainSelectedInstOperands,
     /* 330520 */   // GIR_Coverage, 861,
     /* 330520 */   GIR_Done,
     /* 330521 */ // Label 6476: @330521
     /* 330521 */ GIM_Reject,
     /* 330522 */ // Label 6432: @330522
     /* 330522 */ GIM_Try, /*On fail goto*//*Label 6477*/ GIMT_Encode4(330601),
     /* 330527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 330530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330534 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330538 */   GIM_Try, /*On fail goto*//*Label 6478*/ GIMT_Encode4(330553), // Rule ID 859 //
     /* 330543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 330546 */     // (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FNEGv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 330546 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv8f16),
     /* 330551 */     GIR_RootConstrainSelectedInstOperands,
     /* 330552 */     // GIR_Coverage, 859,
     /* 330552 */     GIR_Done,
     /* 330553 */   // Label 6478: @330553
     /* 330553 */   GIM_Try, /*On fail goto*//*Label 6479*/ GIMT_Encode4(330600), // Rule ID 6439 //
     /* 330558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 330561 */     // (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (EORv16i8:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (MOVIv8i16:{ *:[f128] } 128:{ *:[i32] }, 8:{ *:[i32] }))
     /* 330561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 330564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv8i16),
     /* 330568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330573 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(128),
     /* 330583 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 330586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /* 330591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330593 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 330595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330598 */     GIR_RootConstrainSelectedInstOperands,
     /* 330599 */     // GIR_Coverage, 6439,
     /* 330599 */     GIR_EraseRootFromParent_Done,
     /* 330600 */   // Label 6479: @330600
     /* 330600 */   GIM_Reject,
     /* 330601 */ // Label 6477: @330601
     /* 330601 */ GIM_Reject,
     /* 330602 */ // Label 6433: @330602
     /* 330602 */ GIM_Reject,
     /* 330603 */ // Label 65: @330603
     /* 330603 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(9), /*)*//*default:*//*Label 6484*/ GIMT_Encode4(330850),
     /* 330614 */ /*GILLT_s32*//*Label 6480*/ GIMT_Encode4(330642),
     /* 330618 */ /*GILLT_s64*//*Label 6481*/ GIMT_Encode4(330673), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 330630 */ /*GILLT_v2s64*//*Label 6482*/ GIMT_Encode4(330734), GIMT_Encode4(0),
     /* 330638 */ /*GILLT_v4s32*//*Label 6483*/ GIMT_Encode4(330792),
     /* 330642 */ // Label 6480: @330642
     /* 330642 */ GIM_Try, /*On fail goto*//*Label 6485*/ GIMT_Encode4(330672), // Rule ID 516 //
     /* 330647 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 330653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 330657 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330661 */   // (fpextend:{ *:[f32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTSHr:{ *:[f32] } FPR16:{ *:[f16] }:$Rn)
     /* 330661 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTSHr),
     /* 330666 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330670 */   GIR_RootConstrainSelectedInstOperands,
     /* 330671 */   // GIR_Coverage, 516,
     /* 330671 */   GIR_Done,
     /* 330672 */ // Label 6485: @330672
     /* 330672 */ GIM_Reject,
     /* 330673 */ // Label 6481: @330673
     /* 330673 */ GIM_Try, /*On fail goto*//*Label 6486*/ GIMT_Encode4(330703), // Rule ID 514 //
     /* 330678 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 330684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330688 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330692 */   // (fpextend:{ *:[f64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTDHr:{ *:[f64] } FPR16:{ *:[f16] }:$Rn)
     /* 330692 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTDHr),
     /* 330697 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330701 */   GIR_RootConstrainSelectedInstOperands,
     /* 330702 */   // GIR_Coverage, 514,
     /* 330702 */   GIR_Done,
     /* 330703 */ // Label 6486: @330703
     /* 330703 */ GIM_Try, /*On fail goto*//*Label 6487*/ GIMT_Encode4(330733), // Rule ID 518 //
     /* 330708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330718 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 330722 */   // (fpextend:{ *:[f64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTDSr:{ *:[f64] } FPR32:{ *:[f32] }:$Rn)
     /* 330722 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTDSr),
     /* 330727 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330731 */   GIR_RootConstrainSelectedInstOperands,
     /* 330732 */   // GIR_Coverage, 518,
     /* 330732 */   GIR_Done,
     /* 330733 */ // Label 6487: @330733
     /* 330733 */ GIM_Reject,
     /* 330734 */ // Label 6482: @330734
     /* 330734 */ GIM_Try, /*On fail goto*//*Label 6488*/ GIMT_Encode4(330791),
     /* 330739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 330742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330746 */   GIM_Try, /*On fail goto*//*Label 6489*/ GIMT_Encode4(330770), // Rule ID 4963 //
     /* 330751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /* 330758 */     // (fpextend:{ *:[v2f64] } (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn))  =>  (FCVTLv4i32:{ *:[v2f64] } V128:{ *:[v4f32] }:$Rn)
     /* 330758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i32),
     /* 330761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 330768 */     GIR_RootConstrainSelectedInstOperands,
     /* 330769 */     // GIR_Coverage, 4963,
     /* 330769 */     GIR_EraseRootFromParent_Done,
     /* 330770 */   // Label 6489: @330770
     /* 330770 */   GIM_Try, /*On fail goto*//*Label 6490*/ GIMT_Encode4(330790), // Rule ID 4961 //
     /* 330775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330779 */     // (fpextend:{ *:[v2f64] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTLv2i32:{ *:[v2f64] } V64:{ *:[v2f32] }:$Rn)
     /* 330779 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv2i32),
     /* 330784 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330788 */     GIR_RootConstrainSelectedInstOperands,
     /* 330789 */     // GIR_Coverage, 4961,
     /* 330789 */     GIR_Done,
     /* 330790 */   // Label 6490: @330790
     /* 330790 */   GIM_Reject,
     /* 330791 */ // Label 6488: @330791
     /* 330791 */ GIM_Reject,
     /* 330792 */ // Label 6483: @330792
     /* 330792 */ GIM_Try, /*On fail goto*//*Label 6491*/ GIMT_Encode4(330849),
     /* 330797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 330800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330804 */   GIM_Try, /*On fail goto*//*Label 6492*/ GIMT_Encode4(330828), // Rule ID 4967 //
     /* 330809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /* 330816 */     // (fpextend:{ *:[v4f32] } (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn))  =>  (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)
     /* 330816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 330819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 330826 */     GIR_RootConstrainSelectedInstOperands,
     /* 330827 */     // GIR_Coverage, 4967,
     /* 330827 */     GIR_EraseRootFromParent_Done,
     /* 330828 */   // Label 6492: @330828
     /* 330828 */   GIM_Try, /*On fail goto*//*Label 6493*/ GIMT_Encode4(330848), // Rule ID 4965 //
     /* 330833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330837 */     // (fpextend:{ *:[v4f32] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTLv4i16:{ *:[v4f32] } V64:{ *:[v4f16] }:$Rn)
     /* 330837 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 330842 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330846 */     GIR_RootConstrainSelectedInstOperands,
     /* 330847 */     // GIR_Coverage, 4965,
     /* 330847 */     GIR_Done,
     /* 330848 */   // Label 6493: @330848
     /* 330848 */   GIM_Reject,
     /* 330849 */ // Label 6491: @330849
     /* 330849 */ GIM_Reject,
     /* 330850 */ // Label 6484: @330850
     /* 330850 */ GIM_Reject,
     /* 330851 */ // Label 66: @330851
     /* 330851 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 6498*/ GIMT_Encode4(331038),
     /* 330862 */ /*GILLT_s16*//*Label 6494*/ GIMT_Encode4(330890),
     /* 330866 */ /*GILLT_s32*//*Label 6495*/ GIMT_Encode4(330951), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 330878 */ /*GILLT_v2s32*//*Label 6496*/ GIMT_Encode4(330982), GIMT_Encode4(0),
     /* 330886 */ /*GILLT_v4s16*//*Label 6497*/ GIMT_Encode4(331010),
     /* 330890 */ // Label 6494: @330890
     /* 330890 */ GIM_Try, /*On fail goto*//*Label 6499*/ GIMT_Encode4(330920), // Rule ID 510 //
     /* 330895 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330905 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330909 */   // (fpround:{ *:[f16] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTHDr:{ *:[f16] } FPR64:{ *:[f64] }:$Rn)
     /* 330909 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTHDr),
     /* 330914 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330918 */   GIR_RootConstrainSelectedInstOperands,
     /* 330919 */   // GIR_Coverage, 510,
     /* 330919 */   GIR_Done,
     /* 330920 */ // Label 6499: @330920
     /* 330920 */ GIM_Try, /*On fail goto*//*Label 6500*/ GIMT_Encode4(330950), // Rule ID 520 //
     /* 330925 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330935 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 330939 */   // (fpround:{ *:[f16] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTHSr:{ *:[f16] } FPR32:{ *:[f32] }:$Rn)
     /* 330939 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTHSr),
     /* 330944 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330948 */   GIR_RootConstrainSelectedInstOperands,
     /* 330949 */   // GIR_Coverage, 520,
     /* 330949 */   GIR_Done,
     /* 330950 */ // Label 6500: @330950
     /* 330950 */ GIM_Reject,
     /* 330951 */ // Label 6495: @330951
     /* 330951 */ GIM_Try, /*On fail goto*//*Label 6501*/ GIMT_Encode4(330981), // Rule ID 512 //
     /* 330956 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 330966 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330970 */   // (fpround:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTSDr:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 330970 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTSDr),
     /* 330975 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330979 */   GIR_RootConstrainSelectedInstOperands,
     /* 330980 */   // GIR_Coverage, 512,
     /* 330980 */   GIR_Done,
     /* 330981 */ // Label 6501: @330981
     /* 330981 */ GIM_Reject,
     /* 330982 */ // Label 6496: @330982
     /* 330982 */ GIM_Try, /*On fail goto*//*Label 6502*/ GIMT_Encode4(331009), // Rule ID 4971 //
     /* 330987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 330990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330998 */   // (fpround:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNv2i32:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)
     /* 330998 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv2i32),
     /* 331003 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331007 */   GIR_RootConstrainSelectedInstOperands,
     /* 331008 */   // GIR_Coverage, 4971,
     /* 331008 */   GIR_Done,
     /* 331009 */ // Label 6502: @331009
     /* 331009 */ GIM_Reject,
     /* 331010 */ // Label 6497: @331010
     /* 331010 */ GIM_Try, /*On fail goto*//*Label 6503*/ GIMT_Encode4(331037), // Rule ID 4973 //
     /* 331015 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 331018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331026 */   // (fpround:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNv4i16:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn)
     /* 331026 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 331031 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331035 */   GIR_RootConstrainSelectedInstOperands,
     /* 331036 */   // GIR_Coverage, 4973,
     /* 331036 */   GIR_Done,
     /* 331037 */ // Label 6503: @331037
     /* 331037 */ GIM_Reject,
     /* 331038 */ // Label 6498: @331038
     /* 331038 */ GIM_Reject,
     /* 331039 */ // Label 67: @331039
     /* 331039 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6511*/ GIMT_Encode4(332015),
     /* 331050 */ /*GILLT_s32*//*Label 6504*/ GIMT_Encode4(331086),
     /* 331054 */ /*GILLT_s64*//*Label 6505*/ GIMT_Encode4(331473), GIMT_Encode4(0),
     /* 331062 */ /*GILLT_v2s32*//*Label 6506*/ GIMT_Encode4(331860),
     /* 331066 */ /*GILLT_v2s64*//*Label 6507*/ GIMT_Encode4(331891),
     /* 331070 */ /*GILLT_v4s16*//*Label 6508*/ GIMT_Encode4(331922),
     /* 331074 */ /*GILLT_v4s32*//*Label 6509*/ GIMT_Encode4(331953), GIMT_Encode4(0),
     /* 331082 */ /*GILLT_v8s16*//*Label 6510*/ GIMT_Encode4(331984),
     /* 331086 */ // Label 6504: @331086
     /* 331086 */ GIM_Try, /*On fail goto*//*Label 6512*/ GIMT_Encode4(331123), // Rule ID 4710 //
     /* 331091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331098 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331102 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 331106 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 331110 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331112 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 331112 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWSr),
     /* 331115 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331117 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331121 */   GIR_RootConstrainSelectedInstOperands,
     /* 331122 */   // GIR_Coverage, 4710,
     /* 331122 */   GIR_EraseRootFromParent_Done,
     /* 331123 */ // Label 6512: @331123
     /* 331123 */ GIM_Try, /*On fail goto*//*Label 6513*/ GIMT_Encode4(331160), // Rule ID 4712 //
     /* 331128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331135 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331139 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 331143 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 331147 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331149 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 331149 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWDr),
     /* 331152 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331154 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331158 */   GIR_RootConstrainSelectedInstOperands,
     /* 331159 */   // GIR_Coverage, 4712,
     /* 331159 */   GIR_EraseRootFromParent_Done,
     /* 331160 */ // Label 6513: @331160
     /* 331160 */ GIM_Try, /*On fail goto*//*Label 6514*/ GIMT_Encode4(331197), // Rule ID 4730 //
     /* 331165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331172 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331176 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 331180 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 331184 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331186 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 331186 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWSr),
     /* 331189 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331191 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331195 */   GIR_RootConstrainSelectedInstOperands,
     /* 331196 */   // GIR_Coverage, 4730,
     /* 331196 */   GIR_EraseRootFromParent_Done,
     /* 331197 */ // Label 6514: @331197
     /* 331197 */ GIM_Try, /*On fail goto*//*Label 6515*/ GIMT_Encode4(331234), // Rule ID 4732 //
     /* 331202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331209 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331213 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 331217 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 331221 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331223 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 331223 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWDr),
     /* 331226 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331228 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331232 */   GIR_RootConstrainSelectedInstOperands,
     /* 331233 */   // GIR_Coverage, 4732,
     /* 331233 */   GIR_EraseRootFromParent_Done,
     /* 331234 */ // Label 6515: @331234
     /* 331234 */ GIM_Try, /*On fail goto*//*Label 6516*/ GIMT_Encode4(331271), // Rule ID 4770 //
     /* 331239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331246 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331250 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 331254 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 331258 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331260 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTASUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 331260 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 331263 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331265 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331269 */   GIR_RootConstrainSelectedInstOperands,
     /* 331270 */   // GIR_Coverage, 4770,
     /* 331270 */   GIR_EraseRootFromParent_Done,
     /* 331271 */ // Label 6516: @331271
     /* 331271 */ GIM_Try, /*On fail goto*//*Label 6517*/ GIMT_Encode4(331308), // Rule ID 4772 //
     /* 331276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331283 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331287 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 331291 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 331295 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331297 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTASUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 331297 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 331300 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331302 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331306 */   GIR_RootConstrainSelectedInstOperands,
     /* 331307 */   // GIR_Coverage, 4772,
     /* 331307 */   GIR_EraseRootFromParent_Done,
     /* 331308 */ // Label 6517: @331308
     /* 331308 */ GIM_Try, /*On fail goto*//*Label 6518*/ GIMT_Encode4(331345), // Rule ID 4750 //
     /* 331313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331320 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331324 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 331328 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 331332 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331334 */   // (fp_to_sint:{ *:[i32] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 331334 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 331337 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331339 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331343 */   GIR_RootConstrainSelectedInstOperands,
     /* 331344 */   // GIR_Coverage, 4750,
     /* 331344 */   GIR_EraseRootFromParent_Done,
     /* 331345 */ // Label 6518: @331345
     /* 331345 */ GIM_Try, /*On fail goto*//*Label 6519*/ GIMT_Encode4(331382), // Rule ID 4752 //
     /* 331350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331357 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331361 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 331365 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 331369 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331371 */   // (fp_to_sint:{ *:[i32] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 331371 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 331374 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331376 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331380 */   GIR_RootConstrainSelectedInstOperands,
     /* 331381 */   // GIR_Coverage, 4752,
     /* 331381 */   GIR_EraseRootFromParent_Done,
     /* 331382 */ // Label 6519: @331382
     /* 331382 */ GIM_Try, /*On fail goto*//*Label 6520*/ GIMT_Encode4(331412), // Rule ID 395 //
     /* 331387 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 331390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 331393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331397 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331401 */   // (fp_to_sint:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 331401 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 331406 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331410 */   GIR_RootConstrainSelectedInstOperands,
     /* 331411 */   // GIR_Coverage, 395,
     /* 331411 */   GIR_Done,
     /* 331412 */ // Label 6520: @331412
     /* 331412 */ GIM_Try, /*On fail goto*//*Label 6521*/ GIMT_Encode4(331442), // Rule ID 399 //
     /* 331417 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 331420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331427 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 331431 */   // (fp_to_sint:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 331431 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 331436 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331440 */   GIR_RootConstrainSelectedInstOperands,
     /* 331441 */   // GIR_Coverage, 399,
     /* 331441 */   GIR_Done,
     /* 331442 */ // Label 6521: @331442
     /* 331442 */ GIM_Try, /*On fail goto*//*Label 6522*/ GIMT_Encode4(331472), // Rule ID 403 //
     /* 331447 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 331450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331457 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331461 */   // (fp_to_sint:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 331461 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 331466 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331470 */   GIR_RootConstrainSelectedInstOperands,
     /* 331471 */   // GIR_Coverage, 403,
     /* 331471 */   GIR_Done,
     /* 331472 */ // Label 6522: @331472
     /* 331472 */ GIM_Reject,
     /* 331473 */ // Label 6505: @331473
     /* 331473 */ GIM_Try, /*On fail goto*//*Label 6523*/ GIMT_Encode4(331510), // Rule ID 4711 //
     /* 331478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331485 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331489 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 331493 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 331497 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331499 */   // (fp_to_sint:{ *:[i64] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 331499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXSr),
     /* 331502 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331504 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331508 */   GIR_RootConstrainSelectedInstOperands,
     /* 331509 */   // GIR_Coverage, 4711,
     /* 331509 */   GIR_EraseRootFromParent_Done,
     /* 331510 */ // Label 6523: @331510
     /* 331510 */ GIM_Try, /*On fail goto*//*Label 6524*/ GIMT_Encode4(331547), // Rule ID 4713 //
     /* 331515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331522 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331526 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 331530 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 331534 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331536 */   // (fp_to_sint:{ *:[i64] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 331536 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXDr),
     /* 331539 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331541 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331545 */   GIR_RootConstrainSelectedInstOperands,
     /* 331546 */   // GIR_Coverage, 4713,
     /* 331546 */   GIR_EraseRootFromParent_Done,
     /* 331547 */ // Label 6524: @331547
     /* 331547 */ GIM_Try, /*On fail goto*//*Label 6525*/ GIMT_Encode4(331584), // Rule ID 4731 //
     /* 331552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331559 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331563 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 331567 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 331571 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331573 */   // (fp_to_sint:{ *:[i64] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 331573 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXSr),
     /* 331576 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331578 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331582 */   GIR_RootConstrainSelectedInstOperands,
     /* 331583 */   // GIR_Coverage, 4731,
     /* 331583 */   GIR_EraseRootFromParent_Done,
     /* 331584 */ // Label 6525: @331584
     /* 331584 */ GIM_Try, /*On fail goto*//*Label 6526*/ GIMT_Encode4(331621), // Rule ID 4733 //
     /* 331589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331596 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331600 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 331604 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 331608 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331610 */   // (fp_to_sint:{ *:[i64] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 331610 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXDr),
     /* 331613 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331615 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331619 */   GIR_RootConstrainSelectedInstOperands,
     /* 331620 */   // GIR_Coverage, 4733,
     /* 331620 */   GIR_EraseRootFromParent_Done,
     /* 331621 */ // Label 6526: @331621
     /* 331621 */ GIM_Try, /*On fail goto*//*Label 6527*/ GIMT_Encode4(331658), // Rule ID 4771 //
     /* 331626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331633 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331637 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 331641 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 331645 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331647 */   // (fp_to_sint:{ *:[i64] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 331647 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 331650 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331652 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331656 */   GIR_RootConstrainSelectedInstOperands,
     /* 331657 */   // GIR_Coverage, 4771,
     /* 331657 */   GIR_EraseRootFromParent_Done,
     /* 331658 */ // Label 6527: @331658
     /* 331658 */ GIM_Try, /*On fail goto*//*Label 6528*/ GIMT_Encode4(331695), // Rule ID 4773 //
     /* 331663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331670 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331674 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 331678 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 331682 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331684 */   // (fp_to_sint:{ *:[i64] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 331684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 331687 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331689 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331693 */   GIR_RootConstrainSelectedInstOperands,
     /* 331694 */   // GIR_Coverage, 4773,
     /* 331694 */   GIR_EraseRootFromParent_Done,
     /* 331695 */ // Label 6528: @331695
     /* 331695 */ GIM_Try, /*On fail goto*//*Label 6529*/ GIMT_Encode4(331732), // Rule ID 4751 //
     /* 331700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331707 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331711 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 331715 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 331719 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331721 */   // (fp_to_sint:{ *:[i64] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 331721 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 331724 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331726 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331730 */   GIR_RootConstrainSelectedInstOperands,
     /* 331731 */   // GIR_Coverage, 4751,
     /* 331731 */   GIR_EraseRootFromParent_Done,
     /* 331732 */ // Label 6529: @331732
     /* 331732 */ GIM_Try, /*On fail goto*//*Label 6530*/ GIMT_Encode4(331769), // Rule ID 4753 //
     /* 331737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331744 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331748 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 331752 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 331756 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331758 */   // (fp_to_sint:{ *:[i64] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 331758 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 331761 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331763 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331767 */   GIR_RootConstrainSelectedInstOperands,
     /* 331768 */   // GIR_Coverage, 4753,
     /* 331768 */   GIR_EraseRootFromParent_Done,
     /* 331769 */ // Label 6530: @331769
     /* 331769 */ GIM_Try, /*On fail goto*//*Label 6531*/ GIMT_Encode4(331799), // Rule ID 397 //
     /* 331774 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 331777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 331780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331784 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331788 */   // (fp_to_sint:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 331788 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 331793 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331797 */   GIR_RootConstrainSelectedInstOperands,
     /* 331798 */   // GIR_Coverage, 397,
     /* 331798 */   GIR_Done,
     /* 331799 */ // Label 6531: @331799
     /* 331799 */ GIM_Try, /*On fail goto*//*Label 6532*/ GIMT_Encode4(331829), // Rule ID 401 //
     /* 331804 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 331807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331814 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 331818 */   // (fp_to_sint:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 331818 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 331823 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331827 */   GIR_RootConstrainSelectedInstOperands,
     /* 331828 */   // GIR_Coverage, 401,
     /* 331828 */   GIR_Done,
     /* 331829 */ // Label 6532: @331829
     /* 331829 */ GIM_Try, /*On fail goto*//*Label 6533*/ GIMT_Encode4(331859), // Rule ID 405 //
     /* 331834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 331837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331844 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331848 */   // (fp_to_sint:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 331848 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 331853 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331857 */   GIR_RootConstrainSelectedInstOperands,
     /* 331858 */   // GIR_Coverage, 405,
     /* 331858 */   GIR_Done,
     /* 331859 */ // Label 6533: @331859
     /* 331859 */ GIM_Reject,
     /* 331860 */ // Label 6506: @331860
     /* 331860 */ GIM_Try, /*On fail goto*//*Label 6534*/ GIMT_Encode4(331890), // Rule ID 843 //
     /* 331865 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 331868 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 331871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331875 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331879 */   // (fp_to_sint:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 331879 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 331884 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331888 */   GIR_RootConstrainSelectedInstOperands,
     /* 331889 */   // GIR_Coverage, 843,
     /* 331889 */   GIR_Done,
     /* 331890 */ // Label 6534: @331890
     /* 331890 */ GIM_Reject,
     /* 331891 */ // Label 6507: @331891
     /* 331891 */ GIM_Try, /*On fail goto*//*Label 6535*/ GIMT_Encode4(331921), // Rule ID 847 //
     /* 331896 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 331899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 331902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331906 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331910 */   // (fp_to_sint:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 331910 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 331915 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331919 */   GIR_RootConstrainSelectedInstOperands,
     /* 331920 */   // GIR_Coverage, 847,
     /* 331920 */   GIR_Done,
     /* 331921 */ // Label 6535: @331921
     /* 331921 */ GIM_Reject,
     /* 331922 */ // Label 6508: @331922
     /* 331922 */ GIM_Try, /*On fail goto*//*Label 6536*/ GIMT_Encode4(331952), // Rule ID 839 //
     /* 331927 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 331930 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 331933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331937 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331941 */   // (fp_to_sint:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 331941 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 331946 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331950 */   GIR_RootConstrainSelectedInstOperands,
     /* 331951 */   // GIR_Coverage, 839,
     /* 331951 */   GIR_Done,
     /* 331952 */ // Label 6536: @331952
     /* 331952 */ GIM_Reject,
     /* 331953 */ // Label 6509: @331953
     /* 331953 */ GIM_Try, /*On fail goto*//*Label 6537*/ GIMT_Encode4(331983), // Rule ID 845 //
     /* 331958 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 331961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 331964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331968 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331972 */   // (fp_to_sint:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 331972 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 331977 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331981 */   GIR_RootConstrainSelectedInstOperands,
     /* 331982 */   // GIR_Coverage, 845,
     /* 331982 */   GIR_Done,
     /* 331983 */ // Label 6537: @331983
     /* 331983 */ GIM_Reject,
     /* 331984 */ // Label 6510: @331984
     /* 331984 */ GIM_Try, /*On fail goto*//*Label 6538*/ GIMT_Encode4(332014), // Rule ID 841 //
     /* 331989 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 331992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 331995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331999 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332003 */   // (fp_to_sint:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 332003 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 332008 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332012 */   GIR_RootConstrainSelectedInstOperands,
     /* 332013 */   // GIR_Coverage, 841,
     /* 332013 */   GIR_Done,
     /* 332014 */ // Label 6538: @332014
     /* 332014 */ GIM_Reject,
     /* 332015 */ // Label 6511: @332015
     /* 332015 */ GIM_Reject,
     /* 332016 */ // Label 68: @332016
     /* 332016 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6546*/ GIMT_Encode4(332992),
     /* 332027 */ /*GILLT_s32*//*Label 6539*/ GIMT_Encode4(332063),
     /* 332031 */ /*GILLT_s64*//*Label 6540*/ GIMT_Encode4(332450), GIMT_Encode4(0),
     /* 332039 */ /*GILLT_v2s32*//*Label 6541*/ GIMT_Encode4(332837),
     /* 332043 */ /*GILLT_v2s64*//*Label 6542*/ GIMT_Encode4(332868),
     /* 332047 */ /*GILLT_v4s16*//*Label 6543*/ GIMT_Encode4(332899),
     /* 332051 */ /*GILLT_v4s32*//*Label 6544*/ GIMT_Encode4(332930), GIMT_Encode4(0),
     /* 332059 */ /*GILLT_v8s16*//*Label 6545*/ GIMT_Encode4(332961),
     /* 332063 */ // Label 6539: @332063
     /* 332063 */ GIM_Try, /*On fail goto*//*Label 6547*/ GIMT_Encode4(332100), // Rule ID 4720 //
     /* 332068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 332075 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332079 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 332083 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 332087 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332089 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 332089 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWSr),
     /* 332092 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332094 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332098 */   GIR_RootConstrainSelectedInstOperands,
     /* 332099 */   // GIR_Coverage, 4720,
     /* 332099 */   GIR_EraseRootFromParent_Done,
     /* 332100 */ // Label 6547: @332100
     /* 332100 */ GIM_Try, /*On fail goto*//*Label 6548*/ GIMT_Encode4(332137), // Rule ID 4722 //
     /* 332105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 332108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 332112 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332116 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 332120 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 332124 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332126 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 332126 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWDr),
     /* 332129 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332131 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332135 */   GIR_RootConstrainSelectedInstOperands,
     /* 332136 */   // GIR_Coverage, 4722,
     /* 332136 */   GIR_EraseRootFromParent_Done,
     /* 332137 */ // Label 6548: @332137
     /* 332137 */ GIM_Try, /*On fail goto*//*Label 6549*/ GIMT_Encode4(332174), // Rule ID 4740 //
     /* 332142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 332149 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332153 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 332157 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 332161 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332163 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 332163 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWSr),
     /* 332166 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332168 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332172 */   GIR_RootConstrainSelectedInstOperands,
     /* 332173 */   // GIR_Coverage, 4740,
     /* 332173 */   GIR_EraseRootFromParent_Done,
     /* 332174 */ // Label 6549: @332174
     /* 332174 */ GIM_Try, /*On fail goto*//*Label 6550*/ GIMT_Encode4(332211), // Rule ID 4742 //
     /* 332179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 332182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 332186 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332190 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 332194 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 332198 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332200 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 332200 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWDr),
     /* 332203 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332205 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332209 */   GIR_RootConstrainSelectedInstOperands,
     /* 332210 */   // GIR_Coverage, 4742,
     /* 332210 */   GIR_EraseRootFromParent_Done,
     /* 332211 */ // Label 6550: @332211
     /* 332211 */ GIM_Try, /*On fail goto*//*Label 6551*/ GIMT_Encode4(332248), // Rule ID 4780 //
     /* 332216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 332223 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332227 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 332231 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 332235 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332237 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTAUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 332237 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWSr),
     /* 332240 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332242 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332246 */   GIR_RootConstrainSelectedInstOperands,
     /* 332247 */   // GIR_Coverage, 4780,
     /* 332247 */   GIR_EraseRootFromParent_Done,
     /* 332248 */ // Label 6551: @332248
     /* 332248 */ GIM_Try, /*On fail goto*//*Label 6552*/ GIMT_Encode4(332285), // Rule ID 4782 //
     /* 332253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 332256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 332260 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332264 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 332268 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 332272 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332274 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTAUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 332274 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWDr),
     /* 332277 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332279 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332283 */   GIR_RootConstrainSelectedInstOperands,
     /* 332284 */   // GIR_Coverage, 4782,
     /* 332284 */   GIR_EraseRootFromParent_Done,
     /* 332285 */ // Label 6552: @332285
     /* 332285 */ GIM_Try, /*On fail goto*//*Label 6553*/ GIMT_Encode4(332322), // Rule ID 4760 //
     /* 332290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 332297 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332301 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 332305 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 332309 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332311 */   // (fp_to_uint:{ *:[i32] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 332311 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 332314 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332316 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332320 */   GIR_RootConstrainSelectedInstOperands,
     /* 332321 */   // GIR_Coverage, 4760,
     /* 332321 */   GIR_EraseRootFromParent_Done,
     /* 332322 */ // Label 6553: @332322
     /* 332322 */ GIM_Try, /*On fail goto*//*Label 6554*/ GIMT_Encode4(332359), // Rule ID 4762 //
     /* 332327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 332330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 332334 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332338 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 332342 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 332346 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332348 */   // (fp_to_uint:{ *:[i32] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 332348 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 332351 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332353 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332357 */   GIR_RootConstrainSelectedInstOperands,
     /* 332358 */   // GIR_Coverage, 4762,
     /* 332358 */   GIR_EraseRootFromParent_Done,
     /* 332359 */ // Label 6554: @332359
     /* 332359 */ GIM_Try, /*On fail goto*//*Label 6555*/ GIMT_Encode4(332389), // Rule ID 407 //
     /* 332364 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 332367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 332370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 332374 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332378 */   // (fp_to_uint:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 332378 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 332383 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332387 */   GIR_RootConstrainSelectedInstOperands,
     /* 332388 */   // GIR_Coverage, 407,
     /* 332388 */   GIR_Done,
     /* 332389 */ // Label 6555: @332389
     /* 332389 */ GIM_Try, /*On fail goto*//*Label 6556*/ GIMT_Encode4(332419), // Rule ID 411 //
     /* 332394 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 332397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 332404 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332408 */   // (fp_to_uint:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 332408 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 332413 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332417 */   GIR_RootConstrainSelectedInstOperands,
     /* 332418 */   // GIR_Coverage, 411,
     /* 332418 */   GIR_Done,
     /* 332419 */ // Label 6556: @332419
     /* 332419 */ GIM_Try, /*On fail goto*//*Label 6557*/ GIMT_Encode4(332449), // Rule ID 415 //
     /* 332424 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 332427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 332430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 332434 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332438 */   // (fp_to_uint:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 332438 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 332443 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332447 */   GIR_RootConstrainSelectedInstOperands,
     /* 332448 */   // GIR_Coverage, 415,
     /* 332448 */   GIR_Done,
     /* 332449 */ // Label 6557: @332449
     /* 332449 */ GIM_Reject,
     /* 332450 */ // Label 6540: @332450
     /* 332450 */ GIM_Try, /*On fail goto*//*Label 6558*/ GIMT_Encode4(332487), // Rule ID 4721 //
     /* 332455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 332462 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332466 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 332470 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 332474 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332476 */   // (fp_to_uint:{ *:[i64] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 332476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXSr),
     /* 332479 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332481 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332485 */   GIR_RootConstrainSelectedInstOperands,
     /* 332486 */   // GIR_Coverage, 4721,
     /* 332486 */   GIR_EraseRootFromParent_Done,
     /* 332487 */ // Label 6558: @332487
     /* 332487 */ GIM_Try, /*On fail goto*//*Label 6559*/ GIMT_Encode4(332524), // Rule ID 4723 //
     /* 332492 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 332495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 332499 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332503 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 332507 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 332511 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332513 */   // (fp_to_uint:{ *:[i64] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 332513 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXDr),
     /* 332516 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332518 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332522 */   GIR_RootConstrainSelectedInstOperands,
     /* 332523 */   // GIR_Coverage, 4723,
     /* 332523 */   GIR_EraseRootFromParent_Done,
     /* 332524 */ // Label 6559: @332524
     /* 332524 */ GIM_Try, /*On fail goto*//*Label 6560*/ GIMT_Encode4(332561), // Rule ID 4741 //
     /* 332529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 332536 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332540 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 332544 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 332548 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332550 */   // (fp_to_uint:{ *:[i64] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 332550 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXSr),
     /* 332553 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332555 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332559 */   GIR_RootConstrainSelectedInstOperands,
     /* 332560 */   // GIR_Coverage, 4741,
     /* 332560 */   GIR_EraseRootFromParent_Done,
     /* 332561 */ // Label 6560: @332561
     /* 332561 */ GIM_Try, /*On fail goto*//*Label 6561*/ GIMT_Encode4(332598), // Rule ID 4743 //
     /* 332566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 332569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 332573 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332577 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 332581 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 332585 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332587 */   // (fp_to_uint:{ *:[i64] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 332587 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXDr),
     /* 332590 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332592 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332596 */   GIR_RootConstrainSelectedInstOperands,
     /* 332597 */   // GIR_Coverage, 4743,
     /* 332597 */   GIR_EraseRootFromParent_Done,
     /* 332598 */ // Label 6561: @332598
     /* 332598 */ GIM_Try, /*On fail goto*//*Label 6562*/ GIMT_Encode4(332635), // Rule ID 4781 //
     /* 332603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 332610 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332614 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 332618 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 332622 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332624 */   // (fp_to_uint:{ *:[i64] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTAUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 332624 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXSr),
     /* 332627 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332629 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332633 */   GIR_RootConstrainSelectedInstOperands,
     /* 332634 */   // GIR_Coverage, 4781,
     /* 332634 */   GIR_EraseRootFromParent_Done,
     /* 332635 */ // Label 6562: @332635
     /* 332635 */ GIM_Try, /*On fail goto*//*Label 6563*/ GIMT_Encode4(332672), // Rule ID 4783 //
     /* 332640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 332643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 332647 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332651 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 332655 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 332659 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332661 */   // (fp_to_uint:{ *:[i64] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTAUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 332661 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXDr),
     /* 332664 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332666 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332670 */   GIR_RootConstrainSelectedInstOperands,
     /* 332671 */   // GIR_Coverage, 4783,
     /* 332671 */   GIR_EraseRootFromParent_Done,
     /* 332672 */ // Label 6563: @332672
     /* 332672 */ GIM_Try, /*On fail goto*//*Label 6564*/ GIMT_Encode4(332709), // Rule ID 4761 //
     /* 332677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 332684 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332688 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 332692 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 332696 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332698 */   // (fp_to_uint:{ *:[i64] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 332698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 332701 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332703 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332707 */   GIR_RootConstrainSelectedInstOperands,
     /* 332708 */   // GIR_Coverage, 4761,
     /* 332708 */   GIR_EraseRootFromParent_Done,
     /* 332709 */ // Label 6564: @332709
     /* 332709 */ GIM_Try, /*On fail goto*//*Label 6565*/ GIMT_Encode4(332746), // Rule ID 4763 //
     /* 332714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 332717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 332721 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332725 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 332729 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 332733 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332735 */   // (fp_to_uint:{ *:[i64] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 332735 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 332738 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332740 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332744 */   GIR_RootConstrainSelectedInstOperands,
     /* 332745 */   // GIR_Coverage, 4763,
     /* 332745 */   GIR_EraseRootFromParent_Done,
     /* 332746 */ // Label 6565: @332746
     /* 332746 */ GIM_Try, /*On fail goto*//*Label 6566*/ GIMT_Encode4(332776), // Rule ID 409 //
     /* 332751 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 332754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 332757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 332761 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332765 */   // (fp_to_uint:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 332765 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 332770 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332774 */   GIR_RootConstrainSelectedInstOperands,
     /* 332775 */   // GIR_Coverage, 409,
     /* 332775 */   GIR_Done,
     /* 332776 */ // Label 6566: @332776
     /* 332776 */ GIM_Try, /*On fail goto*//*Label 6567*/ GIMT_Encode4(332806), // Rule ID 413 //
     /* 332781 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 332784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 332791 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332795 */   // (fp_to_uint:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 332795 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 332800 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332804 */   GIR_RootConstrainSelectedInstOperands,
     /* 332805 */   // GIR_Coverage, 413,
     /* 332805 */   GIR_Done,
     /* 332806 */ // Label 6567: @332806
     /* 332806 */ GIM_Try, /*On fail goto*//*Label 6568*/ GIMT_Encode4(332836), // Rule ID 417 //
     /* 332811 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 332814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 332817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 332821 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332825 */   // (fp_to_uint:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 332825 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 332830 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332834 */   GIR_RootConstrainSelectedInstOperands,
     /* 332835 */   // GIR_Coverage, 417,
     /* 332835 */   GIR_Done,
     /* 332836 */ // Label 6568: @332836
     /* 332836 */ GIM_Reject,
     /* 332837 */ // Label 6541: @332837
     /* 332837 */ GIM_Try, /*On fail goto*//*Label 6569*/ GIMT_Encode4(332867), // Rule ID 853 //
     /* 332842 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 332845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 332848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332852 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332856 */   // (fp_to_uint:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 332856 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 332861 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332865 */   GIR_RootConstrainSelectedInstOperands,
     /* 332866 */   // GIR_Coverage, 853,
     /* 332866 */   GIR_Done,
     /* 332867 */ // Label 6569: @332867
     /* 332867 */ GIM_Reject,
     /* 332868 */ // Label 6542: @332868
     /* 332868 */ GIM_Try, /*On fail goto*//*Label 6570*/ GIMT_Encode4(332898), // Rule ID 857 //
     /* 332873 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 332876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 332879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332883 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332887 */   // (fp_to_uint:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 332887 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 332892 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332896 */   GIR_RootConstrainSelectedInstOperands,
     /* 332897 */   // GIR_Coverage, 857,
     /* 332897 */   GIR_Done,
     /* 332898 */ // Label 6570: @332898
     /* 332898 */ GIM_Reject,
     /* 332899 */ // Label 6543: @332899
     /* 332899 */ GIM_Try, /*On fail goto*//*Label 6571*/ GIMT_Encode4(332929), // Rule ID 849 //
     /* 332904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 332907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 332910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332918 */   // (fp_to_uint:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 332918 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 332923 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332927 */   GIR_RootConstrainSelectedInstOperands,
     /* 332928 */   // GIR_Coverage, 849,
     /* 332928 */   GIR_Done,
     /* 332929 */ // Label 6571: @332929
     /* 332929 */ GIM_Reject,
     /* 332930 */ // Label 6544: @332930
     /* 332930 */ GIM_Try, /*On fail goto*//*Label 6572*/ GIMT_Encode4(332960), // Rule ID 855 //
     /* 332935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 332938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 332941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332945 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332949 */   // (fp_to_uint:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 332949 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 332954 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332958 */   GIR_RootConstrainSelectedInstOperands,
     /* 332959 */   // GIR_Coverage, 855,
     /* 332959 */   GIR_Done,
     /* 332960 */ // Label 6572: @332960
     /* 332960 */ GIM_Reject,
     /* 332961 */ // Label 6545: @332961
     /* 332961 */ GIM_Try, /*On fail goto*//*Label 6573*/ GIMT_Encode4(332991), // Rule ID 851 //
     /* 332966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 332969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 332972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332980 */   // (fp_to_uint:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 332980 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 332985 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332989 */   GIR_RootConstrainSelectedInstOperands,
     /* 332990 */   // GIR_Coverage, 851,
     /* 332990 */   GIR_Done,
     /* 332991 */ // Label 6573: @332991
     /* 332991 */ GIM_Reject,
     /* 332992 */ // Label 6546: @332992
     /* 332992 */ GIM_Reject,
     /* 332993 */ // Label 69: @332993
     /* 332993 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6582*/ GIMT_Encode4(337620),
     /* 333004 */ /*GILLT_s16*//*Label 6574*/ GIMT_Encode4(333044),
     /* 333008 */ /*GILLT_s32*//*Label 6575*/ GIMT_Encode4(333485),
     /* 333012 */ /*GILLT_s64*//*Label 6576*/ GIMT_Encode4(335481), GIMT_Encode4(0),
     /* 333020 */ /*GILLT_v2s32*//*Label 6577*/ GIMT_Encode4(337465),
     /* 333024 */ /*GILLT_v2s64*//*Label 6578*/ GIMT_Encode4(337496),
     /* 333028 */ /*GILLT_v4s16*//*Label 6579*/ GIMT_Encode4(337527),
     /* 333032 */ /*GILLT_v4s32*//*Label 6580*/ GIMT_Encode4(337558), GIMT_Encode4(0),
     /* 333040 */ /*GILLT_v8s16*//*Label 6581*/ GIMT_Encode4(337589),
     /* 333044 */ // Label 6574: @333044
     /* 333044 */ GIM_Try, /*On fail goto*//*Label 6583*/ GIMT_Encode4(333147), // Rule ID 5363 //
     /* 333049 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 333052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 333059 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333063 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 333067 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 333071 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 333075 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 333079 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 333083 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 333087 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333092 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 333096 */   // MIs[1] Operand 2
     /* 333096 */   GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 333107 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 333109 */   // (sint_to_fp:{ *:[f16] } (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), i16:{ *:[Other] }))  =>  (SCVTFv1i16:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR128:{ *:[v8i16] }:$Rn, hsub:{ *:[i32] }))
     /* 333109 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 333112 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333116 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333121 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 333127 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 333132 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333137 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 333140 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 333142 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333145 */   GIR_RootConstrainSelectedInstOperands,
     /* 333146 */   // GIR_Coverage, 5363,
     /* 333146 */   GIR_EraseRootFromParent_Done,
     /* 333147 */ // Label 6583: @333147
     /* 333147 */ GIM_Try, /*On fail goto*//*Label 6584*/ GIMT_Encode4(333227), // Rule ID 2447 //
     /* 333152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 333155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 333162 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333166 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 333170 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 333174 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 333178 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333183 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 333187 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333189 */   // (sint_to_fp:{ *:[f16] } (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFHSr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 333189 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 333192 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333196 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333201 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 333207 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333212 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333217 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHSr),
     /* 333220 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 333222 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333225 */   GIR_RootConstrainSelectedInstOperands,
     /* 333226 */   // GIR_Coverage, 2447,
     /* 333226 */   GIR_EraseRootFromParent_Done,
     /* 333227 */ // Label 6584: @333227
     /* 333227 */ GIM_Try, /*On fail goto*//*Label 6585*/ GIMT_Encode4(333307), // Rule ID 2451 //
     /* 333232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 333235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 333238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 333242 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333246 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 333250 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 333254 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 333258 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333263 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 333267 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333269 */   // (sint_to_fp:{ *:[f16] } (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFHDr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 333269 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 333272 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333276 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333281 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 333287 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333292 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333297 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHDr),
     /* 333300 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 333302 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333305 */   GIR_RootConstrainSelectedInstOperands,
     /* 333306 */   // GIR_Coverage, 2451,
     /* 333306 */   GIR_EraseRootFromParent_Done,
     /* 333307 */ // Label 6585: @333307
     /* 333307 */ GIM_Try, /*On fail goto*//*Label 6586*/ GIMT_Encode4(333364), // Rule ID 5354 //
     /* 333312 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 333315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 333322 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333326 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 333330 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 333334 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333336 */   // (sint_to_fp:{ *:[f16] } (fp_to_sint:{ *:[i32] } f16:{ *:[f16] }:$Rn))  =>  (SCVTFv1i16:{ *:[f16] } (FCVTZSv1f16:{ *:[f16] } f16:{ *:[f16] }:$Rn))
     /* 333336 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 333339 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1f16),
     /* 333343 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333348 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 333352 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333354 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 333357 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 333359 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333362 */   GIR_RootConstrainSelectedInstOperands,
     /* 333363 */   // GIR_Coverage, 5354,
     /* 333363 */   GIR_EraseRootFromParent_Done,
     /* 333364 */ // Label 6586: @333364
     /* 333364 */ GIM_Try, /*On fail goto*//*Label 6587*/ GIMT_Encode4(333394), // Rule ID 443 //
     /* 333369 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 333372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 333379 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 333383 */   // (sint_to_fp:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWHri:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)
     /* 333383 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWHri),
     /* 333388 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 333392 */   GIR_RootConstrainSelectedInstOperands,
     /* 333393 */   // GIR_Coverage, 443,
     /* 333393 */   GIR_Done,
     /* 333394 */ // Label 6587: @333394
     /* 333394 */ GIM_Try, /*On fail goto*//*Label 6588*/ GIMT_Encode4(333424), // Rule ID 449 //
     /* 333399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 333402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 333405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 333409 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 333413 */   // (sint_to_fp:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXHri:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)
     /* 333413 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXHri),
     /* 333418 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 333422 */   GIR_RootConstrainSelectedInstOperands,
     /* 333423 */   // GIR_Coverage, 449,
     /* 333423 */   GIR_Done,
     /* 333424 */ // Label 6588: @333424
     /* 333424 */ GIM_Try, /*On fail goto*//*Label 6589*/ GIMT_Encode4(333454), // Rule ID 491 //
     /* 333429 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 333432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 333439 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333443 */   // (sint_to_fp:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)  =>  (SCVTFHSr:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)
     /* 333443 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHSr),
     /* 333448 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 333452 */   GIR_RootConstrainSelectedInstOperands,
     /* 333453 */   // GIR_Coverage, 491,
     /* 333453 */   GIR_Done,
     /* 333454 */ // Label 6589: @333454
     /* 333454 */ GIM_Try, /*On fail goto*//*Label 6590*/ GIMT_Encode4(333484), // Rule ID 495 //
     /* 333459 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 333462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 333465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 333469 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333473 */   // (sint_to_fp:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)  =>  (SCVTFHDr:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)
     /* 333473 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHDr),
     /* 333478 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 333482 */   GIR_RootConstrainSelectedInstOperands,
     /* 333483 */   // GIR_Coverage, 495,
     /* 333483 */   GIR_Done,
     /* 333484 */ // Label 6590: @333484
     /* 333484 */ GIM_Reject,
     /* 333485 */ // Label 6575: @333485
     /* 333485 */ GIM_Try, /*On fail goto*//*Label 6591*/ GIMT_Encode4(333723), // Rule ID 6440 //
     /* 333490 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 333493 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333500 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333504 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 333508 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333511 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 333518 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 333522 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333524 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 333531 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$ext), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 333531 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 333534 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 333538 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333543 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333548 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 333553 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 333558 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 333563 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 333565 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 333568 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 333572 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333577 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 333579 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 333582 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 333586 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333591 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 333594 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 333597 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 333600 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333605 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333610 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 333615 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 333618 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 333622 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333627 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 333630 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 333633 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 333635 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 333638 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333642 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333647 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 333654 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333659 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333664 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 333667 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 333671 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333676 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 333679 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 333682 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333684 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 333687 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333691 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333696 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 333703 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333708 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333713 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 333716 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 333718 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333721 */   GIR_RootConstrainSelectedInstOperands,
     /* 333722 */   // GIR_Coverage, 6440,
     /* 333722 */   GIR_EraseRootFromParent_Done,
     /* 333723 */ // Label 6591: @333723
     /* 333723 */ GIM_Try, /*On fail goto*//*Label 6592*/ GIMT_Encode4(333961), // Rule ID 6441 //
     /* 333728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 333731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333738 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333742 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 333746 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333749 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 333756 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 333760 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333762 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 333769 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$ext), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 333769 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 333772 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 333776 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333781 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333786 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 333791 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 333796 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 333801 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 333803 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 333806 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 333810 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333815 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 333817 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 333820 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 333824 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333829 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 333832 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 333835 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 333838 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333843 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333848 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 333853 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 333856 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 333860 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333865 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 333868 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 333871 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 333873 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 333876 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333880 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333885 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 333892 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333897 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333902 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 333905 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 333909 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333914 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 333917 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 333920 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333922 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 333925 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333929 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333934 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 333941 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333946 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333951 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 333954 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 333956 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333959 */   GIR_RootConstrainSelectedInstOperands,
     /* 333960 */   // GIR_Coverage, 6441,
     /* 333960 */   GIR_EraseRootFromParent_Done,
     /* 333961 */ // Label 6592: @333961
     /* 333961 */ GIM_Try, /*On fail goto*//*Label 6593*/ GIMT_Encode4(334150), // Rule ID 6444 //
     /* 333966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 333969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333976 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333980 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 333984 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333987 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 333994 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 333998 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334000 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 334007 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 334007 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 334010 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 334014 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334019 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334024 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334029 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 334034 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 334039 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 334041 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 334044 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 334048 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334053 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 334055 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 334058 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 334062 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334067 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 334070 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 334073 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 334076 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334081 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334086 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 334091 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 334094 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 334098 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334103 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334106 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 334109 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334111 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334114 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334118 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334123 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 334130 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334135 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334140 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 334143 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 334145 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334148 */   GIR_RootConstrainSelectedInstOperands,
     /* 334149 */   // GIR_Coverage, 6444,
     /* 334149 */   GIR_EraseRootFromParent_Done,
     /* 334150 */ // Label 6593: @334150
     /* 334150 */ GIM_Try, /*On fail goto*//*Label 6594*/ GIMT_Encode4(334339), // Rule ID 6445 //
     /* 334155 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 334158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 334161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334165 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334169 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 334173 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334176 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 334183 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 334187 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334189 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 334196 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 334196 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 334199 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 334203 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334208 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334213 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334218 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 334223 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 334228 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 334230 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 334233 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 334237 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334242 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 334244 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 334247 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 334251 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334256 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 334259 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 334262 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 334265 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334270 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334275 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 334280 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 334283 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 334287 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334292 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334295 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 334298 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334300 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334303 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334307 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334312 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 334319 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334324 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334329 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 334332 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 334334 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334337 */   GIR_RootConstrainSelectedInstOperands,
     /* 334338 */   // GIR_Coverage, 6445,
     /* 334338 */   GIR_EraseRootFromParent_Done,
     /* 334339 */ // Label 6594: @334339
     /* 334339 */ GIM_Try, /*On fail goto*//*Label 6595*/ GIMT_Encode4(334572), // Rule ID 6442 //
     /* 334344 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 334347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 334350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334354 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334358 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 334362 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334365 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 334372 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 334376 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334378 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 334385 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 334385 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 334388 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 334392 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334397 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334402 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 334407 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 334412 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 334414 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 334417 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 334421 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334426 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 334428 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 334431 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 334435 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334440 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 334443 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 334446 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 334449 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334454 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334459 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 334464 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 334467 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 334471 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334476 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 334479 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 334482 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 334484 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 334487 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334491 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334496 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 334503 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334508 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334513 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 334516 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 334520 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334525 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334528 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 334531 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334533 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334536 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334540 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334545 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 334552 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334557 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334562 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 334565 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 334567 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334570 */   GIR_RootConstrainSelectedInstOperands,
     /* 334571 */   // GIR_Coverage, 6442,
     /* 334571 */   GIR_EraseRootFromParent_Done,
     /* 334572 */ // Label 6595: @334572
     /* 334572 */ GIM_Try, /*On fail goto*//*Label 6596*/ GIMT_Encode4(334805), // Rule ID 6443 //
     /* 334577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 334580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 334583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334587 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334591 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 334595 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334598 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 334605 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 334609 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334611 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 334618 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 334618 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 334621 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 334625 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334630 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334635 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 334640 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 334645 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 334647 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 334650 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 334654 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334659 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 334661 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 334664 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 334668 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334673 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 334676 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 334679 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 334682 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334687 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334692 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 334697 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 334700 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 334704 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334709 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 334712 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 334715 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 334717 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 334720 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334724 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334729 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 334736 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334741 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334746 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 334749 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 334753 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334758 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334761 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 334764 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334766 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334769 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334773 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334778 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 334785 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334790 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334795 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 334798 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 334800 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334803 */   GIR_RootConstrainSelectedInstOperands,
     /* 334804 */   // GIR_Coverage, 6443,
     /* 334804 */   GIR_EraseRootFromParent_Done,
     /* 334805 */ // Label 6596: @334805
     /* 334805 */ GIM_Try, /*On fail goto*//*Label 6597*/ GIMT_Encode4(334989), // Rule ID 6446 //
     /* 334810 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 334813 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 334816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334820 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334824 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 334828 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334831 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 334838 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 334842 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334844 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 334851 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 334851 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 334854 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 334858 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334863 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334868 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 334873 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 334878 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 334880 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 334883 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 334887 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334892 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 334894 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 334897 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 334901 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334906 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 334909 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 334912 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 334915 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334920 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334925 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 334930 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 334933 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 334937 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334942 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334945 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 334948 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334950 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334953 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334957 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334962 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 334969 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334974 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334979 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 334982 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 334984 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334987 */   GIR_RootConstrainSelectedInstOperands,
     /* 334988 */   // GIR_Coverage, 6446,
     /* 334988 */   GIR_EraseRootFromParent_Done,
     /* 334989 */ // Label 6597: @334989
     /* 334989 */ GIM_Try, /*On fail goto*//*Label 6598*/ GIMT_Encode4(335173), // Rule ID 6447 //
     /* 334994 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 334997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 335000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335004 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335008 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 335012 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335015 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 335022 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 335026 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335028 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 335035 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 335035 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 335038 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 335042 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335047 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335052 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 335057 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 335062 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 335064 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 335067 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 335071 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335076 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 335078 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 335081 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 335085 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335090 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 335093 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 335096 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 335099 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335104 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335109 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 335114 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 335117 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 335121 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335126 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 335129 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 335132 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 335134 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335137 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335141 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335146 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 335153 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335158 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335163 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 335166 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 335168 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335171 */   GIR_RootConstrainSelectedInstOperands,
     /* 335172 */   // GIR_Coverage, 6447,
     /* 335172 */   GIR_EraseRootFromParent_Done,
     /* 335173 */ // Label 6598: @335173
     /* 335173 */ GIM_Try, /*On fail goto*//*Label 6599*/ GIMT_Encode4(335253), // Rule ID 2453 //
     /* 335178 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 335181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 335184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335188 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335192 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 335196 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 335200 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 335204 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335209 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 335213 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335215 */   // (sint_to_fp:{ *:[f32] } (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFSDr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 335215 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 335218 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335222 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335227 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 335233 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335238 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335243 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFSDr),
     /* 335246 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 335248 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335251 */   GIR_RootConstrainSelectedInstOperands,
     /* 335252 */   // GIR_Coverage, 2453,
     /* 335252 */   GIR_EraseRootFromParent_Done,
     /* 335253 */ // Label 6599: @335253
     /* 335253 */ GIM_Try, /*On fail goto*//*Label 6600*/ GIMT_Encode4(335333), // Rule ID 5359 //
     /* 335258 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 335261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 335264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335268 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335272 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 335276 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 335280 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 335284 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335289 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 335293 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335295 */   // (sint_to_fp:{ *:[f32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 335295 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335298 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335302 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335307 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 335313 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335318 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 335326 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 335328 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335331 */   GIR_RootConstrainSelectedInstOperands,
     /* 335332 */   // GIR_Coverage, 5359,
     /* 335332 */   GIR_EraseRootFromParent_Done,
     /* 335333 */ // Label 6600: @335333
     /* 335333 */ GIM_Try, /*On fail goto*//*Label 6601*/ GIMT_Encode4(335390), // Rule ID 5342 //
     /* 335338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 335341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 335344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335348 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335352 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 335356 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 335360 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335362 */   // (sint_to_fp:{ *:[f32] } (fp_to_sint:{ *:[i32] } f32:{ *:[f32] }:$Rn))  =>  (SCVTFv1i32:{ *:[f32] } (FCVTZSv1i32:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 335362 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335365 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i32),
     /* 335369 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335374 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 335378 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335380 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 335383 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 335385 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335388 */   GIR_RootConstrainSelectedInstOperands,
     /* 335389 */   // GIR_Coverage, 5342,
     /* 335389 */   GIR_EraseRootFromParent_Done,
     /* 335390 */ // Label 6601: @335390
     /* 335390 */ GIM_Try, /*On fail goto*//*Label 6602*/ GIMT_Encode4(335420), // Rule ID 445 //
     /* 335395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 335398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 335401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335405 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 335409 */   // (sint_to_fp:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWSri:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)
     /* 335409 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWSri),
     /* 335414 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 335418 */   GIR_RootConstrainSelectedInstOperands,
     /* 335419 */   // GIR_Coverage, 445,
     /* 335419 */   GIR_Done,
     /* 335420 */ // Label 6602: @335420
     /* 335420 */ GIM_Try, /*On fail goto*//*Label 6603*/ GIMT_Encode4(335450), // Rule ID 451 //
     /* 335425 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 335428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 335431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335435 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 335439 */   // (sint_to_fp:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXSri:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)
     /* 335439 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXSri),
     /* 335444 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 335448 */   GIR_RootConstrainSelectedInstOperands,
     /* 335449 */   // GIR_Coverage, 451,
     /* 335449 */   GIR_Done,
     /* 335450 */ // Label 6603: @335450
     /* 335450 */ GIM_Try, /*On fail goto*//*Label 6604*/ GIMT_Encode4(335480), // Rule ID 497 //
     /* 335455 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 335458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 335461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335465 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335469 */   // (sint_to_fp:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)  =>  (SCVTFSDr:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)
     /* 335469 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFSDr),
     /* 335474 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 335478 */   GIR_RootConstrainSelectedInstOperands,
     /* 335479 */   // GIR_Coverage, 497,
     /* 335479 */   GIR_Done,
     /* 335480 */ // Label 6604: @335480
     /* 335480 */ GIM_Reject,
     /* 335481 */ // Label 6576: @335481
     /* 335481 */ GIM_Try, /*On fail goto*//*Label 6605*/ GIMT_Encode4(335667), // Rule ID 6452 //
     /* 335486 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 335489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 335492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335496 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335500 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335504 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335507 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 335511 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 335515 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335517 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 335524 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$ext), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 335524 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 335527 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 335531 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335536 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335541 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 335546 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 335551 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 335556 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 335558 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 335561 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 335565 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335570 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 335572 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 335575 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 335579 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335584 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 335587 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 335590 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 335593 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335598 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335603 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335608 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 335611 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 335615 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335620 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 335623 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 335626 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 335628 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 335631 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335635 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335640 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 335647 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335652 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 335660 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 335662 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335665 */   GIR_RootConstrainSelectedInstOperands,
     /* 335666 */   // GIR_Coverage, 6452,
     /* 335666 */   GIR_EraseRootFromParent_Done,
     /* 335667 */ // Label 6605: @335667
     /* 335667 */ GIM_Try, /*On fail goto*//*Label 6606*/ GIMT_Encode4(335853), // Rule ID 6453 //
     /* 335672 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 335675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 335678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335682 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335686 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335690 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335693 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 335697 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 335701 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335703 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 335710 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$ext), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 335710 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 335713 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 335717 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335722 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335727 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 335732 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 335737 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 335742 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 335744 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 335747 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 335751 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335756 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 335758 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 335761 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 335765 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335770 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 335773 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 335776 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 335779 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335784 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335789 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335794 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 335797 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 335801 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335806 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 335809 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 335812 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 335814 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 335817 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335821 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335826 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 335833 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335838 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335843 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 335846 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 335848 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335851 */   GIR_RootConstrainSelectedInstOperands,
     /* 335852 */   // GIR_Coverage, 6453,
     /* 335852 */   GIR_EraseRootFromParent_Done,
     /* 335853 */ // Label 6606: @335853
     /* 335853 */ GIM_Try, /*On fail goto*//*Label 6607*/ GIMT_Encode4(336091), // Rule ID 6448 //
     /* 335858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 335861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 335864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335868 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335872 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 335876 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335879 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 335886 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 335890 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335892 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 335899 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 335899 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 335902 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 335906 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335911 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335916 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 335921 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 335926 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 335931 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 335933 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 335936 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 335940 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335945 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 335947 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 335950 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 335954 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335959 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 335962 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 335965 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 335968 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335973 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335978 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 335983 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 335986 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 335990 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335995 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 335998 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 336001 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 336003 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 336006 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336010 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336015 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336022 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336027 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336032 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 336035 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 336039 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336044 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 336047 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 336050 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 336052 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 336055 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336059 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336064 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336071 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336076 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336081 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 336084 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336086 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336089 */   GIR_RootConstrainSelectedInstOperands,
     /* 336090 */   // GIR_Coverage, 6448,
     /* 336090 */   GIR_EraseRootFromParent_Done,
     /* 336091 */ // Label 6607: @336091
     /* 336091 */ GIM_Try, /*On fail goto*//*Label 6608*/ GIMT_Encode4(336329), // Rule ID 6449 //
     /* 336096 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 336099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336106 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336110 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 336114 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336117 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 336124 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 336128 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336130 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 336137 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 336137 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 336140 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 336144 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336149 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336154 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 336159 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 336164 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 336169 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 336171 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 336174 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336178 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336183 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 336185 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 336188 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 336192 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336197 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 336200 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 336203 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 336206 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336211 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336216 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 336221 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 336224 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 336228 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336233 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 336236 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 336239 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 336241 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 336244 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336248 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336253 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336260 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336265 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336270 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 336273 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 336277 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336282 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 336285 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 336288 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 336290 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 336293 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336297 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336302 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336309 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336314 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336319 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 336322 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336324 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336327 */   GIR_RootConstrainSelectedInstOperands,
     /* 336328 */   // GIR_Coverage, 6449,
     /* 336328 */   GIR_EraseRootFromParent_Done,
     /* 336329 */ // Label 6608: @336329
     /* 336329 */ GIM_Try, /*On fail goto*//*Label 6609*/ GIMT_Encode4(336510), // Rule ID 6454 //
     /* 336334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 336337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336344 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336348 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336352 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336355 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 336359 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 336363 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336365 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 336372 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 336372 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 336375 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 336379 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336384 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336389 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 336394 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 336399 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 336401 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 336404 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336408 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336413 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 336415 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 336418 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 336422 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336427 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 336430 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 336433 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 336436 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336441 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336446 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336451 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 336454 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 336458 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336463 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 336466 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 336469 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 336471 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 336474 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336478 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336483 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336490 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336495 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336500 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 336503 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336505 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336508 */   GIR_RootConstrainSelectedInstOperands,
     /* 336509 */   // GIR_Coverage, 6454,
     /* 336509 */   GIR_EraseRootFromParent_Done,
     /* 336510 */ // Label 6609: @336510
     /* 336510 */ GIM_Try, /*On fail goto*//*Label 6610*/ GIMT_Encode4(336691), // Rule ID 6455 //
     /* 336515 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 336518 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336525 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336529 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336533 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336536 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 336540 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 336544 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336546 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 336553 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 336553 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 336556 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 336560 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336565 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336570 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 336575 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 336580 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 336582 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 336585 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336589 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336594 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 336596 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 336599 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 336603 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336608 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 336611 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 336614 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 336617 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336622 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336627 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336632 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 336635 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 336639 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336644 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 336647 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 336650 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 336652 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 336655 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336659 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336664 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336671 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336676 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336681 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 336684 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336686 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336689 */   GIR_RootConstrainSelectedInstOperands,
     /* 336690 */   // GIR_Coverage, 6455,
     /* 336690 */   GIR_EraseRootFromParent_Done,
     /* 336691 */ // Label 6610: @336691
     /* 336691 */ GIM_Try, /*On fail goto*//*Label 6611*/ GIMT_Encode4(336924), // Rule ID 6450 //
     /* 336696 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 336699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336706 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336710 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 336714 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336717 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 336724 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 336728 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336730 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 336737 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 336737 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 336740 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 336744 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336749 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336754 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 336759 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 336764 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 336766 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 336769 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336773 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336778 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 336780 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 336783 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 336787 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336792 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 336795 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 336798 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 336801 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336806 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336811 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 336816 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 336819 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 336823 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336828 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 336831 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 336834 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 336836 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 336839 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336843 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336848 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336855 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336860 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336865 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 336868 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 336872 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336877 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 336880 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 336883 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 336885 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 336888 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336892 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336897 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336904 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336909 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336914 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 336917 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336919 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336922 */   GIR_RootConstrainSelectedInstOperands,
     /* 336923 */   // GIR_Coverage, 6450,
     /* 336923 */   GIR_EraseRootFromParent_Done,
     /* 336924 */ // Label 6611: @336924
     /* 336924 */ GIM_Try, /*On fail goto*//*Label 6612*/ GIMT_Encode4(337157), // Rule ID 6451 //
     /* 336929 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 336932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336939 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336943 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 336947 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336950 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 336957 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 336961 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336963 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 336970 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 336970 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 336973 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 336977 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336982 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336987 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 336992 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 336997 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 336999 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 337002 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337006 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337011 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 337013 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 337016 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337020 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337025 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 337028 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 337031 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 337034 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337039 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337044 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 337049 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 337052 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 337056 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337061 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 337064 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 337067 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 337069 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 337072 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337076 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337081 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 337088 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337093 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337098 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 337101 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 337105 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337110 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 337113 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 337116 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 337118 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 337121 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337125 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337130 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 337137 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337142 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337147 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 337150 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337152 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337155 */   GIR_RootConstrainSelectedInstOperands,
     /* 337156 */   // GIR_Coverage, 6451,
     /* 337156 */   GIR_EraseRootFromParent_Done,
     /* 337157 */ // Label 6612: @337157
     /* 337157 */ GIM_Try, /*On fail goto*//*Label 6613*/ GIMT_Encode4(337237), // Rule ID 2449 //
     /* 337162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 337165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337172 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337176 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 337180 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 337184 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 337188 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337193 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 337197 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337199 */   // (sint_to_fp:{ *:[f64] } (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFDSr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 337199 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337202 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337206 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337211 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 337217 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337222 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337227 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFDSr),
     /* 337230 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337232 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337235 */   GIR_RootConstrainSelectedInstOperands,
     /* 337236 */   // GIR_Coverage, 2449,
     /* 337236 */   GIR_EraseRootFromParent_Done,
     /* 337237 */ // Label 6613: @337237
     /* 337237 */ GIM_Try, /*On fail goto*//*Label 6614*/ GIMT_Encode4(337317), // Rule ID 5361 //
     /* 337242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 337245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 337248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337252 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337256 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 337260 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 337264 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 337268 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337273 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 337277 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337279 */   // (sint_to_fp:{ *:[f64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 337279 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 337282 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337286 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337291 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 337297 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337302 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337307 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 337310 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337312 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337315 */   GIR_RootConstrainSelectedInstOperands,
     /* 337316 */   // GIR_Coverage, 5361,
     /* 337316 */   GIR_EraseRootFromParent_Done,
     /* 337317 */ // Label 6614: @337317
     /* 337317 */ GIM_Try, /*On fail goto*//*Label 6615*/ GIMT_Encode4(337374), // Rule ID 5338 //
     /* 337322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 337325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 337328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337332 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337336 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 337340 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 337344 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337346 */   // (sint_to_fp:{ *:[f64] } (fp_to_sint:{ *:[i64] } f64:{ *:[f64] }:$Rn))  =>  (SCVTFv1i64:{ *:[f64] } (FCVTZSv1i64:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 337346 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 337349 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i64),
     /* 337353 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337358 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 337362 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337364 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 337367 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337369 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337372 */   GIR_RootConstrainSelectedInstOperands,
     /* 337373 */   // GIR_Coverage, 5338,
     /* 337373 */   GIR_EraseRootFromParent_Done,
     /* 337374 */ // Label 6615: @337374
     /* 337374 */ GIM_Try, /*On fail goto*//*Label 6616*/ GIMT_Encode4(337404), // Rule ID 447 //
     /* 337379 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 337382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337389 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 337393 */   // (sint_to_fp:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWDri:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)
     /* 337393 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWDri),
     /* 337398 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 337402 */   GIR_RootConstrainSelectedInstOperands,
     /* 337403 */   // GIR_Coverage, 447,
     /* 337403 */   GIR_Done,
     /* 337404 */ // Label 6616: @337404
     /* 337404 */ GIM_Try, /*On fail goto*//*Label 6617*/ GIMT_Encode4(337434), // Rule ID 453 //
     /* 337409 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 337412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 337415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337419 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 337423 */   // (sint_to_fp:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXDri:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)
     /* 337423 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXDri),
     /* 337428 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 337432 */   GIR_RootConstrainSelectedInstOperands,
     /* 337433 */   // GIR_Coverage, 453,
     /* 337433 */   GIR_Done,
     /* 337434 */ // Label 6617: @337434
     /* 337434 */ GIM_Try, /*On fail goto*//*Label 6618*/ GIMT_Encode4(337464), // Rule ID 493 //
     /* 337439 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 337442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337449 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337453 */   // (sint_to_fp:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)  =>  (SCVTFDSr:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)
     /* 337453 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFDSr),
     /* 337458 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 337462 */   GIR_RootConstrainSelectedInstOperands,
     /* 337463 */   // GIR_Coverage, 493,
     /* 337463 */   GIR_Done,
     /* 337464 */ // Label 6618: @337464
     /* 337464 */ GIM_Reject,
     /* 337465 */ // Label 6577: @337465
     /* 337465 */ GIM_Try, /*On fail goto*//*Label 6619*/ GIMT_Encode4(337495), // Rule ID 1017 //
     /* 337470 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 337473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 337476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337480 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337484 */   // (sint_to_fp:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)  =>  (SCVTFv2f32:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)
     /* 337484 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f32),
     /* 337489 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 337493 */   GIR_RootConstrainSelectedInstOperands,
     /* 337494 */   // GIR_Coverage, 1017,
     /* 337494 */   GIR_Done,
     /* 337495 */ // Label 6619: @337495
     /* 337495 */ GIM_Reject,
     /* 337496 */ // Label 6578: @337496
     /* 337496 */ GIM_Try, /*On fail goto*//*Label 6620*/ GIMT_Encode4(337526), // Rule ID 1021 //
     /* 337501 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 337504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 337507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337511 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337515 */   // (sint_to_fp:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)  =>  (SCVTFv2f64:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)
     /* 337515 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f64),
     /* 337520 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 337524 */   GIR_RootConstrainSelectedInstOperands,
     /* 337525 */   // GIR_Coverage, 1021,
     /* 337525 */   GIR_Done,
     /* 337526 */ // Label 6620: @337526
     /* 337526 */ GIM_Reject,
     /* 337527 */ // Label 6579: @337527
     /* 337527 */ GIM_Try, /*On fail goto*//*Label 6621*/ GIMT_Encode4(337557), // Rule ID 1013 //
     /* 337532 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 337535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 337538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337542 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337546 */   // (sint_to_fp:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)  =>  (SCVTFv4f16:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)
     /* 337546 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4f16),
     /* 337551 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 337555 */   GIR_RootConstrainSelectedInstOperands,
     /* 337556 */   // GIR_Coverage, 1013,
     /* 337556 */   GIR_Done,
     /* 337557 */ // Label 6621: @337557
     /* 337557 */ GIM_Reject,
     /* 337558 */ // Label 6580: @337558
     /* 337558 */ GIM_Try, /*On fail goto*//*Label 6622*/ GIMT_Encode4(337588), // Rule ID 1019 //
     /* 337563 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 337566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 337569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337573 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337577 */   // (sint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)  =>  (SCVTFv4f32:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)
     /* 337577 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4f32),
     /* 337582 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 337586 */   GIR_RootConstrainSelectedInstOperands,
     /* 337587 */   // GIR_Coverage, 1019,
     /* 337587 */   GIR_Done,
     /* 337588 */ // Label 6622: @337588
     /* 337588 */ GIM_Reject,
     /* 337589 */ // Label 6581: @337589
     /* 337589 */ GIM_Try, /*On fail goto*//*Label 6623*/ GIMT_Encode4(337619), // Rule ID 1015 //
     /* 337594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 337597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 337600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337604 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337608 */   // (sint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)  =>  (SCVTFv8f16:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)
     /* 337608 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv8f16),
     /* 337613 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 337617 */   GIR_RootConstrainSelectedInstOperands,
     /* 337618 */   // GIR_Coverage, 1015,
     /* 337618 */   GIR_Done,
     /* 337619 */ // Label 6623: @337619
     /* 337619 */ GIM_Reject,
     /* 337620 */ // Label 6582: @337620
     /* 337620 */ GIM_Reject,
     /* 337621 */ // Label 70: @337621
     /* 337621 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6632*/ GIMT_Encode4(341626),
     /* 337632 */ /*GILLT_s16*//*Label 6624*/ GIMT_Encode4(337672),
     /* 337636 */ /*GILLT_s32*//*Label 6625*/ GIMT_Encode4(338117),
     /* 337640 */ /*GILLT_s64*//*Label 6626*/ GIMT_Encode4(339525), GIMT_Encode4(0),
     /* 337648 */ /*GILLT_v2s32*//*Label 6627*/ GIMT_Encode4(341471),
     /* 337652 */ /*GILLT_v2s64*//*Label 6628*/ GIMT_Encode4(341502),
     /* 337656 */ /*GILLT_v4s16*//*Label 6629*/ GIMT_Encode4(341533),
     /* 337660 */ /*GILLT_v4s32*//*Label 6630*/ GIMT_Encode4(341564), GIMT_Encode4(0),
     /* 337668 */ /*GILLT_v8s16*//*Label 6631*/ GIMT_Encode4(341595),
     /* 337672 */ // Label 6624: @337672
     /* 337672 */ GIM_Try, /*On fail goto*//*Label 6633*/ GIMT_Encode4(337779), // Rule ID 5364 //
     /* 337677 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 337680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 337687 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337691 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 337695 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 337699 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 337703 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 337707 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 337711 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 337715 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 337719 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337724 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 337728 */   GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 337739 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337741 */   // (uint_to_fp:{ *:[f16] } (and:{ *:[i32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), 65535:{ *:[i32] }))  =>  (UCVTFv1i16:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR128:{ *:[v8i16] }:$Rn, hsub:{ *:[i32] }))
     /* 337741 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 337744 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337748 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337753 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 337759 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 337764 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337769 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 337772 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337774 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337777 */   GIR_RootConstrainSelectedInstOperands,
     /* 337778 */   // GIR_Coverage, 5364,
     /* 337778 */   GIR_EraseRootFromParent_Done,
     /* 337779 */ // Label 6633: @337779
     /* 337779 */ GIM_Try, /*On fail goto*//*Label 6634*/ GIMT_Encode4(337859), // Rule ID 4809 //
     /* 337784 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 337787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 337794 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337798 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 337802 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 337806 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 337810 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337815 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 337819 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337821 */   // (uint_to_fp:{ *:[f16] } (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFHSr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 337821 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337824 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337828 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337833 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 337839 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337844 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337849 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHSr),
     /* 337852 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337854 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337857 */   GIR_RootConstrainSelectedInstOperands,
     /* 337858 */   // GIR_Coverage, 4809,
     /* 337858 */   GIR_EraseRootFromParent_Done,
     /* 337859 */ // Label 6634: @337859
     /* 337859 */ GIM_Try, /*On fail goto*//*Label 6635*/ GIMT_Encode4(337939), // Rule ID 4813 //
     /* 337864 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 337867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 337870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 337874 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337878 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 337882 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 337886 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 337890 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337895 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 337899 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337901 */   // (uint_to_fp:{ *:[f16] } (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFHDr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 337901 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 337904 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337908 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337913 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 337919 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337924 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337929 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHDr),
     /* 337932 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337934 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337937 */   GIR_RootConstrainSelectedInstOperands,
     /* 337938 */   // GIR_Coverage, 4813,
     /* 337938 */   GIR_EraseRootFromParent_Done,
     /* 337939 */ // Label 6635: @337939
     /* 337939 */ GIM_Try, /*On fail goto*//*Label 6636*/ GIMT_Encode4(337996), // Rule ID 5358 //
     /* 337944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 337947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 337954 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337958 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 337962 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 337966 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337968 */   // (uint_to_fp:{ *:[f16] } (fp_to_uint:{ *:[i32] } f16:{ *:[f16] }:$Rn))  =>  (UCVTFv1i16:{ *:[f16] } (FCVTZUv1f16:{ *:[f16] } f16:{ *:[f16] }:$Rn))
     /* 337968 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 337971 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1f16),
     /* 337975 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337980 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 337984 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337986 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 337989 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337991 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337994 */   GIR_RootConstrainSelectedInstOperands,
     /* 337995 */   // GIR_Coverage, 5358,
     /* 337995 */   GIR_EraseRootFromParent_Done,
     /* 337996 */ // Label 6636: @337996
     /* 337996 */ GIM_Try, /*On fail goto*//*Label 6637*/ GIMT_Encode4(338026), // Rule ID 467 //
     /* 338001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 338004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338011 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 338015 */   // (uint_to_fp:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWHri:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)
     /* 338015 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWHri),
     /* 338020 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 338024 */   GIR_RootConstrainSelectedInstOperands,
     /* 338025 */   // GIR_Coverage, 467,
     /* 338025 */   GIR_Done,
     /* 338026 */ // Label 6637: @338026
     /* 338026 */ GIM_Try, /*On fail goto*//*Label 6638*/ GIMT_Encode4(338056), // Rule ID 473 //
     /* 338031 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 338034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 338037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338041 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 338045 */   // (uint_to_fp:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXHri:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)
     /* 338045 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXHri),
     /* 338050 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 338054 */   GIR_RootConstrainSelectedInstOperands,
     /* 338055 */   // GIR_Coverage, 473,
     /* 338055 */   GIR_Done,
     /* 338056 */ // Label 6638: @338056
     /* 338056 */ GIM_Try, /*On fail goto*//*Label 6639*/ GIMT_Encode4(338086), // Rule ID 499 //
     /* 338061 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 338064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338071 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338075 */   // (uint_to_fp:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)  =>  (UCVTFHSr:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)
     /* 338075 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHSr),
     /* 338080 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 338084 */   GIR_RootConstrainSelectedInstOperands,
     /* 338085 */   // GIR_Coverage, 499,
     /* 338085 */   GIR_Done,
     /* 338086 */ // Label 6639: @338086
     /* 338086 */ GIM_Try, /*On fail goto*//*Label 6640*/ GIMT_Encode4(338116), // Rule ID 503 //
     /* 338091 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 338094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 338097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338101 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338105 */   // (uint_to_fp:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)  =>  (UCVTFHDr:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)
     /* 338105 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHDr),
     /* 338110 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 338114 */   GIR_RootConstrainSelectedInstOperands,
     /* 338115 */   // GIR_Coverage, 503,
     /* 338115 */   GIR_Done,
     /* 338116 */ // Label 6640: @338116
     /* 338116 */ GIM_Reject,
     /* 338117 */ // Label 6625: @338117
     /* 338117 */ GIM_Try, /*On fail goto*//*Label 6641*/ GIMT_Encode4(338257), // Rule ID 5365 //
     /* 338122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338132 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338136 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 338140 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338143 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 338150 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 338154 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338156 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 338163 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 338163 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 338166 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 338170 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338175 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338180 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338185 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338190 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 338195 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 338197 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 338200 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338204 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338209 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 338211 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 338214 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338218 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338223 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338226 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 338229 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 338232 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338237 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338242 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 338247 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 338250 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338252 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338255 */   GIR_RootConstrainSelectedInstOperands,
     /* 338256 */   // GIR_Coverage, 5365,
     /* 338256 */   GIR_EraseRootFromParent_Done,
     /* 338257 */ // Label 6641: @338257
     /* 338257 */ GIM_Try, /*On fail goto*//*Label 6642*/ GIMT_Encode4(338397), // Rule ID 5366 //
     /* 338262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338272 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338276 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 338280 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338283 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 338290 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 338294 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338296 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 338303 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 338303 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 338306 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 338310 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338315 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338320 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338325 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338330 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 338335 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 338337 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 338340 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338344 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338349 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 338351 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 338354 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338358 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338363 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338366 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 338369 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 338372 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338377 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338382 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 338387 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 338390 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338392 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338395 */   GIR_RootConstrainSelectedInstOperands,
     /* 338396 */   // GIR_Coverage, 5366,
     /* 338396 */   GIR_EraseRootFromParent_Done,
     /* 338397 */ // Label 6642: @338397
     /* 338397 */ GIM_Try, /*On fail goto*//*Label 6643*/ GIMT_Encode4(338537), // Rule ID 5369 //
     /* 338402 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338412 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338416 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 338420 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338423 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 338430 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 338434 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338436 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 338443 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 338443 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 338446 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 338450 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338455 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338460 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338465 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338470 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 338475 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 338477 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 338480 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338484 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338489 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 338491 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 338494 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338498 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338503 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338506 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 338509 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 338512 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338517 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338522 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338527 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 338530 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338532 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338535 */   GIR_RootConstrainSelectedInstOperands,
     /* 338536 */   // GIR_Coverage, 5369,
     /* 338536 */   GIR_EraseRootFromParent_Done,
     /* 338537 */ // Label 6643: @338537
     /* 338537 */ GIM_Try, /*On fail goto*//*Label 6644*/ GIMT_Encode4(338677), // Rule ID 5370 //
     /* 338542 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338552 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338556 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 338560 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338563 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 338570 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 338574 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338576 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 338583 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 338583 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 338586 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 338590 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338595 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338600 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338605 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338610 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 338615 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 338617 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 338620 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338624 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338629 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 338631 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 338634 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338638 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338643 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338646 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 338649 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 338652 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338657 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338662 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338667 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 338670 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338672 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338675 */   GIR_RootConstrainSelectedInstOperands,
     /* 338676 */   // GIR_Coverage, 5370,
     /* 338676 */   GIR_EraseRootFromParent_Done,
     /* 338677 */ // Label 6644: @338677
     /* 338677 */ GIM_Try, /*On fail goto*//*Label 6645*/ GIMT_Encode4(338812), // Rule ID 5367 //
     /* 338682 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338692 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338696 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 338700 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338703 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 338710 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 338714 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338716 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 338723 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }))
     /* 338723 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 338726 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 338730 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338735 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338740 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338745 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 338750 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 338752 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 338755 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338759 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338764 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 338766 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 338769 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338773 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338778 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338781 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 338784 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 338787 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338792 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338797 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 338802 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 338805 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338807 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338810 */   GIR_RootConstrainSelectedInstOperands,
     /* 338811 */   // GIR_Coverage, 5367,
     /* 338811 */   GIR_EraseRootFromParent_Done,
     /* 338812 */ // Label 6645: @338812
     /* 338812 */ GIM_Try, /*On fail goto*//*Label 6646*/ GIMT_Encode4(338947), // Rule ID 5368 //
     /* 338817 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338827 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338831 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 338835 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338838 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 338845 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 338849 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338851 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 338858 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }))
     /* 338858 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 338861 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 338865 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338870 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338875 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338880 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 338885 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 338887 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 338890 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338894 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338899 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 338901 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 338904 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338908 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338913 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338916 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 338919 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 338922 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338927 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338932 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 338937 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 338940 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338942 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338945 */   GIR_RootConstrainSelectedInstOperands,
     /* 338946 */   // GIR_Coverage, 5368,
     /* 338946 */   GIR_EraseRootFromParent_Done,
     /* 338947 */ // Label 6646: @338947
     /* 338947 */ GIM_Try, /*On fail goto*//*Label 6647*/ GIMT_Encode4(339082), // Rule ID 5371 //
     /* 338952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338962 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338966 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 338970 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338973 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 338980 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 338984 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338986 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 338993 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }))
     /* 338993 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 338996 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 339000 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339005 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339010 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339015 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 339020 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 339022 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 339025 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339029 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339034 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 339036 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 339039 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 339043 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339048 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339051 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 339054 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 339057 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339062 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339067 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 339072 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 339075 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339077 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339080 */   GIR_RootConstrainSelectedInstOperands,
     /* 339081 */   // GIR_Coverage, 5371,
     /* 339081 */   GIR_EraseRootFromParent_Done,
     /* 339082 */ // Label 6647: @339082
     /* 339082 */ GIM_Try, /*On fail goto*//*Label 6648*/ GIMT_Encode4(339217), // Rule ID 5372 //
     /* 339087 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 339090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339097 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339101 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 339105 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339108 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 339115 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 339119 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339121 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 339128 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }))
     /* 339128 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 339131 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 339135 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339140 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339145 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339150 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 339155 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 339157 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 339160 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339164 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339169 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 339171 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 339174 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 339178 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339183 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339186 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 339189 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 339192 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339197 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339202 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 339207 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 339210 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339212 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339215 */   GIR_RootConstrainSelectedInstOperands,
     /* 339216 */   // GIR_Coverage, 5372,
     /* 339216 */   GIR_EraseRootFromParent_Done,
     /* 339217 */ // Label 6648: @339217
     /* 339217 */ GIM_Try, /*On fail goto*//*Label 6649*/ GIMT_Encode4(339297), // Rule ID 4815 //
     /* 339222 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 339225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 339228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339232 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339236 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 339240 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 339244 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 339248 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339253 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 339257 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339259 */   // (uint_to_fp:{ *:[f32] } (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFSDr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 339259 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339262 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 339266 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339271 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 339277 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339282 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339287 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFSDr),
     /* 339290 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339292 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339295 */   GIR_RootConstrainSelectedInstOperands,
     /* 339296 */   // GIR_Coverage, 4815,
     /* 339296 */   GIR_EraseRootFromParent_Done,
     /* 339297 */ // Label 6649: @339297
     /* 339297 */ GIM_Try, /*On fail goto*//*Label 6650*/ GIMT_Encode4(339377), // Rule ID 5360 //
     /* 339302 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 339305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339312 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339316 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 339320 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 339324 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 339328 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339333 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 339337 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339339 */   // (uint_to_fp:{ *:[f32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 339339 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 339342 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 339346 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339351 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 339357 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339362 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339367 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 339370 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339372 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339375 */   GIR_RootConstrainSelectedInstOperands,
     /* 339376 */   // GIR_Coverage, 5360,
     /* 339376 */   GIR_EraseRootFromParent_Done,
     /* 339377 */ // Label 6650: @339377
     /* 339377 */ GIM_Try, /*On fail goto*//*Label 6651*/ GIMT_Encode4(339434), // Rule ID 5350 //
     /* 339382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 339385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339392 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339396 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 339400 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 339404 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339406 */   // (uint_to_fp:{ *:[f32] } (fp_to_uint:{ *:[i32] } f32:{ *:[f32] }:$Rn))  =>  (UCVTFv1i32:{ *:[f32] } (FCVTZUv1i32:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 339406 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 339409 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i32),
     /* 339413 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339418 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 339422 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339424 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 339427 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339429 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339432 */   GIR_RootConstrainSelectedInstOperands,
     /* 339433 */   // GIR_Coverage, 5350,
     /* 339433 */   GIR_EraseRootFromParent_Done,
     /* 339434 */ // Label 6651: @339434
     /* 339434 */ GIM_Try, /*On fail goto*//*Label 6652*/ GIMT_Encode4(339464), // Rule ID 469 //
     /* 339439 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 339442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339449 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 339453 */   // (uint_to_fp:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWSri:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)
     /* 339453 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWSri),
     /* 339458 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339462 */   GIR_RootConstrainSelectedInstOperands,
     /* 339463 */   // GIR_Coverage, 469,
     /* 339463 */   GIR_Done,
     /* 339464 */ // Label 6652: @339464
     /* 339464 */ GIM_Try, /*On fail goto*//*Label 6653*/ GIMT_Encode4(339494), // Rule ID 475 //
     /* 339469 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 339472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 339475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339479 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 339483 */   // (uint_to_fp:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXSri:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)
     /* 339483 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXSri),
     /* 339488 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339492 */   GIR_RootConstrainSelectedInstOperands,
     /* 339493 */   // GIR_Coverage, 475,
     /* 339493 */   GIR_Done,
     /* 339494 */ // Label 6653: @339494
     /* 339494 */ GIM_Try, /*On fail goto*//*Label 6654*/ GIMT_Encode4(339524), // Rule ID 505 //
     /* 339499 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 339502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 339505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339509 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339513 */   // (uint_to_fp:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)  =>  (UCVTFSDr:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)
     /* 339513 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFSDr),
     /* 339518 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 339522 */   GIR_RootConstrainSelectedInstOperands,
     /* 339523 */   // GIR_Coverage, 505,
     /* 339523 */   GIR_Done,
     /* 339524 */ // Label 6654: @339524
     /* 339524 */ GIM_Reject,
     /* 339525 */ // Label 6626: @339525
     /* 339525 */ GIM_Try, /*On fail goto*//*Label 6655*/ GIMT_Encode4(339662), // Rule ID 5381 //
     /* 339530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 339533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339540 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339544 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339548 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339551 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 339555 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 339559 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339561 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 339568 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] }))
     /* 339568 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 339571 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 339575 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339580 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339585 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 339590 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 339595 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 339600 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 339602 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 339605 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339609 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339614 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 339616 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339619 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 339623 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339628 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339631 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 339634 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 339637 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339642 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339647 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339652 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 339655 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339657 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339660 */   GIR_RootConstrainSelectedInstOperands,
     /* 339661 */   // GIR_Coverage, 5381,
     /* 339661 */   GIR_EraseRootFromParent_Done,
     /* 339662 */ // Label 6655: @339662
     /* 339662 */ GIM_Try, /*On fail goto*//*Label 6656*/ GIMT_Encode4(339799), // Rule ID 5382 //
     /* 339667 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 339670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339677 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339681 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339685 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339688 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 339692 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 339696 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339698 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 339705 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] }))
     /* 339705 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 339708 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 339712 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339717 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339722 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 339727 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 339732 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 339737 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 339739 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 339742 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339746 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339751 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 339753 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339756 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 339760 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339765 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339768 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 339771 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 339774 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339779 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339784 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339789 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 339792 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339794 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339797 */   GIR_RootConstrainSelectedInstOperands,
     /* 339798 */   // GIR_Coverage, 5382,
     /* 339798 */   GIR_EraseRootFromParent_Done,
     /* 339799 */ // Label 6656: @339799
     /* 339799 */ GIM_Try, /*On fail goto*//*Label 6657*/ GIMT_Encode4(339939), // Rule ID 5373 //
     /* 339804 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 339807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339814 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339818 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 339822 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339825 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 339832 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 339836 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339838 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 339845 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 339845 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 339848 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 339852 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339857 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339862 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 339867 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 339872 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 339877 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 339879 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 339882 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339886 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339891 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 339893 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339896 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 339900 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339905 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339908 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 339911 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 339914 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339919 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339924 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 339929 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 339932 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339934 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339937 */   GIR_RootConstrainSelectedInstOperands,
     /* 339938 */   // GIR_Coverage, 5373,
     /* 339938 */   GIR_EraseRootFromParent_Done,
     /* 339939 */ // Label 6657: @339939
     /* 339939 */ GIM_Try, /*On fail goto*//*Label 6658*/ GIMT_Encode4(340079), // Rule ID 5374 //
     /* 339944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 339947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339954 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339958 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 339962 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339965 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 339972 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 339976 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339978 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 339985 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 339985 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 339988 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 339992 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339997 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340002 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 340007 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 340012 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 340017 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 340019 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 340022 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340026 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340031 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 340033 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 340036 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340040 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340045 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340048 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 340051 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 340054 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340059 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340064 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 340069 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 340072 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340074 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340077 */   GIR_RootConstrainSelectedInstOperands,
     /* 340078 */   // GIR_Coverage, 5374,
     /* 340078 */   GIR_EraseRootFromParent_Done,
     /* 340079 */ // Label 6658: @340079
     /* 340079 */ GIM_Try, /*On fail goto*//*Label 6659*/ GIMT_Encode4(340219), // Rule ID 5377 //
     /* 340084 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 340087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 340090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340094 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340098 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 340102 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340105 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 340112 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 340116 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340118 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 340125 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 340125 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 340128 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 340132 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340137 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340142 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 340147 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 340152 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 340157 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 340159 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 340162 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340166 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340171 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 340173 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 340176 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340180 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340185 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340188 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 340191 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 340194 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340199 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340204 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340209 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 340212 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340214 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340217 */   GIR_RootConstrainSelectedInstOperands,
     /* 340218 */   // GIR_Coverage, 5377,
     /* 340218 */   GIR_EraseRootFromParent_Done,
     /* 340219 */ // Label 6659: @340219
     /* 340219 */ GIM_Try, /*On fail goto*//*Label 6660*/ GIMT_Encode4(340359), // Rule ID 5378 //
     /* 340224 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 340227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 340230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340234 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340238 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 340242 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340245 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 340252 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 340256 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340258 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 340265 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 340265 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 340268 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 340272 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340277 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340282 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 340287 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 340292 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 340297 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 340299 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 340302 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340306 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340311 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 340313 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 340316 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340320 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340325 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340328 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 340331 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 340334 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340339 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340344 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340349 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 340352 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340354 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340357 */   GIR_RootConstrainSelectedInstOperands,
     /* 340358 */   // GIR_Coverage, 5378,
     /* 340358 */   GIR_EraseRootFromParent_Done,
     /* 340359 */ // Label 6660: @340359
     /* 340359 */ GIM_Try, /*On fail goto*//*Label 6661*/ GIMT_Encode4(340491), // Rule ID 5383 //
     /* 340364 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 340367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 340370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340374 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340378 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340382 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340385 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 340389 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 340393 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340395 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 340402 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] }))
     /* 340402 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 340405 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 340409 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340414 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340419 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 340424 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 340429 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 340431 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 340434 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340438 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340443 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 340445 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 340448 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340452 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340457 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340460 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 340463 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 340466 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340471 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340476 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340481 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 340484 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340486 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340489 */   GIR_RootConstrainSelectedInstOperands,
     /* 340490 */   // GIR_Coverage, 5383,
     /* 340490 */   GIR_EraseRootFromParent_Done,
     /* 340491 */ // Label 6661: @340491
     /* 340491 */ GIM_Try, /*On fail goto*//*Label 6662*/ GIMT_Encode4(340623), // Rule ID 5384 //
     /* 340496 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 340499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 340502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340506 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340510 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340514 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340517 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 340521 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 340525 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340527 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 340534 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] }))
     /* 340534 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 340537 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 340541 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340546 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340551 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 340556 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 340561 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 340563 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 340566 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340570 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340575 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 340577 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 340580 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340584 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340589 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340592 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 340595 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 340598 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340603 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340608 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340613 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 340616 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340618 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340621 */   GIR_RootConstrainSelectedInstOperands,
     /* 340622 */   // GIR_Coverage, 5384,
     /* 340622 */   GIR_EraseRootFromParent_Done,
     /* 340623 */ // Label 6662: @340623
     /* 340623 */ GIM_Try, /*On fail goto*//*Label 6663*/ GIMT_Encode4(340758), // Rule ID 5375 //
     /* 340628 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 340631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 340634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340638 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340642 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 340646 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340649 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 340656 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 340660 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340662 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 340669 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }))
     /* 340669 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 340672 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 340676 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340681 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340686 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 340691 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 340696 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 340698 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 340701 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340705 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340710 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 340712 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 340715 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340719 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340724 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340727 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 340730 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 340733 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340738 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340743 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 340748 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 340751 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340753 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340756 */   GIR_RootConstrainSelectedInstOperands,
     /* 340757 */   // GIR_Coverage, 5375,
     /* 340757 */   GIR_EraseRootFromParent_Done,
     /* 340758 */ // Label 6663: @340758
     /* 340758 */ GIM_Try, /*On fail goto*//*Label 6664*/ GIMT_Encode4(340893), // Rule ID 5376 //
     /* 340763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 340766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 340769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340773 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340777 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 340781 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340784 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 340791 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 340795 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340797 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 340804 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }))
     /* 340804 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 340807 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 340811 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340816 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340821 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 340826 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 340831 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 340833 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 340836 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340840 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340845 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 340847 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 340850 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340854 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340859 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340862 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 340865 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 340868 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340873 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340878 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 340883 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 340886 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340888 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340891 */   GIR_RootConstrainSelectedInstOperands,
     /* 340892 */   // GIR_Coverage, 5376,
     /* 340892 */   GIR_EraseRootFromParent_Done,
     /* 340893 */ // Label 6664: @340893
     /* 340893 */ GIM_Try, /*On fail goto*//*Label 6665*/ GIMT_Encode4(341028), // Rule ID 5379 //
     /* 340898 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 340901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 340904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340908 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340912 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 340916 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340919 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 340926 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 340930 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340932 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 340939 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }))
     /* 340939 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 340942 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 340946 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340951 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340956 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 340961 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 340966 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 340968 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 340971 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340975 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340980 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 340982 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 340985 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340989 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340994 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340997 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 341000 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 341003 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341008 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341013 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341018 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 341021 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341023 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341026 */   GIR_RootConstrainSelectedInstOperands,
     /* 341027 */   // GIR_Coverage, 5379,
     /* 341027 */   GIR_EraseRootFromParent_Done,
     /* 341028 */ // Label 6665: @341028
     /* 341028 */ GIM_Try, /*On fail goto*//*Label 6666*/ GIMT_Encode4(341163), // Rule ID 5380 //
     /* 341033 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 341036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 341039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341043 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341047 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 341051 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341054 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 341061 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 341065 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 341067 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 341074 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }))
     /* 341074 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 341077 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 341081 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341086 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341091 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 341096 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 341101 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 341103 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 341106 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 341110 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341115 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 341117 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 341120 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 341124 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341129 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 341132 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 341135 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 341138 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341143 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341148 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341153 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 341156 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341158 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341161 */   GIR_RootConstrainSelectedInstOperands,
     /* 341162 */   // GIR_Coverage, 5380,
     /* 341162 */   GIR_EraseRootFromParent_Done,
     /* 341163 */ // Label 6666: @341163
     /* 341163 */ GIM_Try, /*On fail goto*//*Label 6667*/ GIMT_Encode4(341243), // Rule ID 4811 //
     /* 341168 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 341171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 341174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341178 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341182 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 341186 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 341190 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 341194 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341199 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 341203 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 341205 */   // (uint_to_fp:{ *:[f64] } (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFDSr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 341205 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 341208 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 341212 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341217 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 341223 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 341228 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341233 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFDSr),
     /* 341236 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341238 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341241 */   GIR_RootConstrainSelectedInstOperands,
     /* 341242 */   // GIR_Coverage, 4811,
     /* 341242 */   GIR_EraseRootFromParent_Done,
     /* 341243 */ // Label 6667: @341243
     /* 341243 */ GIM_Try, /*On fail goto*//*Label 6668*/ GIMT_Encode4(341323), // Rule ID 5362 //
     /* 341248 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 341251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 341254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341258 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341262 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 341266 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 341270 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 341274 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341279 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 341283 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 341285 */   // (uint_to_fp:{ *:[f64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 341285 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 341288 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 341292 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341297 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 341303 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341308 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341313 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 341316 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341318 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341321 */   GIR_RootConstrainSelectedInstOperands,
     /* 341322 */   // GIR_Coverage, 5362,
     /* 341322 */   GIR_EraseRootFromParent_Done,
     /* 341323 */ // Label 6668: @341323
     /* 341323 */ GIM_Try, /*On fail goto*//*Label 6669*/ GIMT_Encode4(341380), // Rule ID 5346 //
     /* 341328 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 341331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 341334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341338 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341342 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 341346 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 341350 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 341352 */   // (uint_to_fp:{ *:[f64] } (fp_to_uint:{ *:[i64] } f64:{ *:[f64] }:$Rn))  =>  (UCVTFv1i64:{ *:[f64] } (FCVTZUv1i64:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 341352 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 341355 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i64),
     /* 341359 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341364 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 341368 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341370 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 341373 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341375 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341378 */   GIR_RootConstrainSelectedInstOperands,
     /* 341379 */   // GIR_Coverage, 5346,
     /* 341379 */   GIR_EraseRootFromParent_Done,
     /* 341380 */ // Label 6669: @341380
     /* 341380 */ GIM_Try, /*On fail goto*//*Label 6670*/ GIMT_Encode4(341410), // Rule ID 471 //
     /* 341385 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 341388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 341391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341395 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 341399 */   // (uint_to_fp:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWDri:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)
     /* 341399 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWDri),
     /* 341404 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341408 */   GIR_RootConstrainSelectedInstOperands,
     /* 341409 */   // GIR_Coverage, 471,
     /* 341409 */   GIR_Done,
     /* 341410 */ // Label 6670: @341410
     /* 341410 */ GIM_Try, /*On fail goto*//*Label 6671*/ GIMT_Encode4(341440), // Rule ID 477 //
     /* 341415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 341418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 341421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341425 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 341429 */   // (uint_to_fp:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXDri:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)
     /* 341429 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXDri),
     /* 341434 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341438 */   GIR_RootConstrainSelectedInstOperands,
     /* 341439 */   // GIR_Coverage, 477,
     /* 341439 */   GIR_Done,
     /* 341440 */ // Label 6671: @341440
     /* 341440 */ GIM_Try, /*On fail goto*//*Label 6672*/ GIMT_Encode4(341470), // Rule ID 501 //
     /* 341445 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 341448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 341451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341455 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 341459 */   // (uint_to_fp:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)  =>  (UCVTFDSr:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)
     /* 341459 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFDSr),
     /* 341464 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341468 */   GIR_RootConstrainSelectedInstOperands,
     /* 341469 */   // GIR_Coverage, 501,
     /* 341469 */   GIR_Done,
     /* 341470 */ // Label 6672: @341470
     /* 341470 */ GIM_Reject,
     /* 341471 */ // Label 6627: @341471
     /* 341471 */ GIM_Try, /*On fail goto*//*Label 6673*/ GIMT_Encode4(341501), // Rule ID 1078 //
     /* 341476 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 341482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341486 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341490 */   // (uint_to_fp:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)  =>  (UCVTFv2f32:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)
     /* 341490 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f32),
     /* 341495 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341499 */   GIR_RootConstrainSelectedInstOperands,
     /* 341500 */   // GIR_Coverage, 1078,
     /* 341500 */   GIR_Done,
     /* 341501 */ // Label 6673: @341501
     /* 341501 */ GIM_Reject,
     /* 341502 */ // Label 6628: @341502
     /* 341502 */ GIM_Try, /*On fail goto*//*Label 6674*/ GIMT_Encode4(341532), // Rule ID 1082 //
     /* 341507 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 341513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341517 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341521 */   // (uint_to_fp:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)  =>  (UCVTFv2f64:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)
     /* 341521 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f64),
     /* 341526 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341530 */   GIR_RootConstrainSelectedInstOperands,
     /* 341531 */   // GIR_Coverage, 1082,
     /* 341531 */   GIR_Done,
     /* 341532 */ // Label 6674: @341532
     /* 341532 */ GIM_Reject,
     /* 341533 */ // Label 6629: @341533
     /* 341533 */ GIM_Try, /*On fail goto*//*Label 6675*/ GIMT_Encode4(341563), // Rule ID 1074 //
     /* 341538 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 341541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 341544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341548 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341552 */   // (uint_to_fp:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)  =>  (UCVTFv4f16:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)
     /* 341552 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4f16),
     /* 341557 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341561 */   GIR_RootConstrainSelectedInstOperands,
     /* 341562 */   // GIR_Coverage, 1074,
     /* 341562 */   GIR_Done,
     /* 341563 */ // Label 6675: @341563
     /* 341563 */ GIM_Reject,
     /* 341564 */ // Label 6630: @341564
     /* 341564 */ GIM_Try, /*On fail goto*//*Label 6676*/ GIMT_Encode4(341594), // Rule ID 1080 //
     /* 341569 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 341575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341579 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341583 */   // (uint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)  =>  (UCVTFv4f32:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)
     /* 341583 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4f32),
     /* 341588 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341592 */   GIR_RootConstrainSelectedInstOperands,
     /* 341593 */   // GIR_Coverage, 1080,
     /* 341593 */   GIR_Done,
     /* 341594 */ // Label 6676: @341594
     /* 341594 */ GIM_Reject,
     /* 341595 */ // Label 6631: @341595
     /* 341595 */ GIM_Try, /*On fail goto*//*Label 6677*/ GIMT_Encode4(341625), // Rule ID 1076 //
     /* 341600 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 341603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 341606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341610 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341614 */   // (uint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)  =>  (UCVTFv8f16:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)
     /* 341614 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv8f16),
     /* 341619 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341623 */   GIR_RootConstrainSelectedInstOperands,
     /* 341624 */   // GIR_Coverage, 1076,
     /* 341624 */   GIR_Done,
     /* 341625 */ // Label 6677: @341625
     /* 341625 */ GIM_Reject,
     /* 341626 */ // Label 6632: @341626
     /* 341626 */ GIM_Reject,
     /* 341627 */ // Label 71: @341627
     /* 341627 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6685*/ GIMT_Encode4(341946),
     /* 341638 */ /*GILLT_s32*//*Label 6678*/ GIMT_Encode4(341674),
     /* 341642 */ /*GILLT_s64*//*Label 6679*/ GIMT_Encode4(341747), GIMT_Encode4(0),
     /* 341650 */ /*GILLT_v2s32*//*Label 6680*/ GIMT_Encode4(341820),
     /* 341654 */ /*GILLT_v2s64*//*Label 6681*/ GIMT_Encode4(341844),
     /* 341658 */ /*GILLT_v4s16*//*Label 6682*/ GIMT_Encode4(341868),
     /* 341662 */ /*GILLT_v4s32*//*Label 6683*/ GIMT_Encode4(341895), GIMT_Encode4(0),
     /* 341670 */ /*GILLT_v8s16*//*Label 6684*/ GIMT_Encode4(341919),
     /* 341674 */ // Label 6678: @341674
     /* 341674 */ GIM_Try, /*On fail goto*//*Label 6686*/ GIMT_Encode4(341700), // Rule ID 4644 //
     /* 341679 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 341682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 341685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 341689 */   // (fp_to_sint_sat_gi:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 341689 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 341694 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341698 */   GIR_RootConstrainSelectedInstOperands,
     /* 341699 */   // GIR_Coverage, 4644,
     /* 341699 */   GIR_Done,
     /* 341700 */ // Label 6686: @341700
     /* 341700 */ GIM_Try, /*On fail goto*//*Label 6687*/ GIMT_Encode4(341723), // Rule ID 4646 //
     /* 341705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 341708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 341712 */   // (fp_to_sint_sat_gi:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 341712 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 341717 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341721 */   GIR_RootConstrainSelectedInstOperands,
     /* 341722 */   // GIR_Coverage, 4646,
     /* 341722 */   GIR_Done,
     /* 341723 */ // Label 6687: @341723
     /* 341723 */ GIM_Try, /*On fail goto*//*Label 6688*/ GIMT_Encode4(341746), // Rule ID 4648 //
     /* 341728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 341731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 341735 */   // (fp_to_sint_sat_gi:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 341735 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 341740 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341744 */   GIR_RootConstrainSelectedInstOperands,
     /* 341745 */   // GIR_Coverage, 4648,
     /* 341745 */   GIR_Done,
     /* 341746 */ // Label 6688: @341746
     /* 341746 */ GIM_Reject,
     /* 341747 */ // Label 6679: @341747
     /* 341747 */ GIM_Try, /*On fail goto*//*Label 6689*/ GIMT_Encode4(341773), // Rule ID 4645 //
     /* 341752 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 341755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 341758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 341762 */   // (fp_to_sint_sat_gi:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 341762 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 341767 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341771 */   GIR_RootConstrainSelectedInstOperands,
     /* 341772 */   // GIR_Coverage, 4645,
     /* 341772 */   GIR_Done,
     /* 341773 */ // Label 6689: @341773
     /* 341773 */ GIM_Try, /*On fail goto*//*Label 6690*/ GIMT_Encode4(341796), // Rule ID 4647 //
     /* 341778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 341781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 341785 */   // (fp_to_sint_sat_gi:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 341785 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 341790 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341794 */   GIR_RootConstrainSelectedInstOperands,
     /* 341795 */   // GIR_Coverage, 4647,
     /* 341795 */   GIR_Done,
     /* 341796 */ // Label 6690: @341796
     /* 341796 */ GIM_Try, /*On fail goto*//*Label 6691*/ GIMT_Encode4(341819), // Rule ID 4649 //
     /* 341801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 341804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 341808 */   // (fp_to_sint_sat_gi:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 341808 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 341813 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341817 */   GIR_RootConstrainSelectedInstOperands,
     /* 341818 */   // GIR_Coverage, 4649,
     /* 341818 */   GIR_Done,
     /* 341819 */ // Label 6691: @341819
     /* 341819 */ GIM_Reject,
     /* 341820 */ // Label 6680: @341820
     /* 341820 */ GIM_Try, /*On fail goto*//*Label 6692*/ GIMT_Encode4(341843), // Rule ID 4985 //
     /* 341825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 341828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341832 */   // (fp_to_sint_sat_gi:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)
     /* 341832 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 341837 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341841 */   GIR_RootConstrainSelectedInstOperands,
     /* 341842 */   // GIR_Coverage, 4985,
     /* 341842 */   GIR_Done,
     /* 341843 */ // Label 6692: @341843
     /* 341843 */ GIM_Reject,
     /* 341844 */ // Label 6681: @341844
     /* 341844 */ GIM_Try, /*On fail goto*//*Label 6693*/ GIMT_Encode4(341867), // Rule ID 4987 //
     /* 341849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 341852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341856 */   // (fp_to_sint_sat_gi:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)
     /* 341856 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 341861 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341865 */   GIR_RootConstrainSelectedInstOperands,
     /* 341866 */   // GIR_Coverage, 4987,
     /* 341866 */   GIR_Done,
     /* 341867 */ // Label 6693: @341867
     /* 341867 */ GIM_Reject,
     /* 341868 */ // Label 6682: @341868
     /* 341868 */ GIM_Try, /*On fail goto*//*Label 6694*/ GIMT_Encode4(341894), // Rule ID 4980 //
     /* 341873 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 341876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 341879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341883 */   // (fp_to_sint_sat_gi:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)
     /* 341883 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 341888 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341892 */   GIR_RootConstrainSelectedInstOperands,
     /* 341893 */   // GIR_Coverage, 4980,
     /* 341893 */   GIR_Done,
     /* 341894 */ // Label 6694: @341894
     /* 341894 */ GIM_Reject,
     /* 341895 */ // Label 6683: @341895
     /* 341895 */ GIM_Try, /*On fail goto*//*Label 6695*/ GIMT_Encode4(341918), // Rule ID 4986 //
     /* 341900 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 341903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341907 */   // (fp_to_sint_sat_gi:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)
     /* 341907 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 341912 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341916 */   GIR_RootConstrainSelectedInstOperands,
     /* 341917 */   // GIR_Coverage, 4986,
     /* 341917 */   GIR_Done,
     /* 341918 */ // Label 6695: @341918
     /* 341918 */ GIM_Reject,
     /* 341919 */ // Label 6684: @341919
     /* 341919 */ GIM_Try, /*On fail goto*//*Label 6696*/ GIMT_Encode4(341945), // Rule ID 4981 //
     /* 341924 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 341927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 341930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341934 */   // (fp_to_sint_sat_gi:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)
     /* 341934 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 341939 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341943 */   GIR_RootConstrainSelectedInstOperands,
     /* 341944 */   // GIR_Coverage, 4981,
     /* 341944 */   GIR_Done,
     /* 341945 */ // Label 6696: @341945
     /* 341945 */ GIM_Reject,
     /* 341946 */ // Label 6685: @341946
     /* 341946 */ GIM_Reject,
     /* 341947 */ // Label 72: @341947
     /* 341947 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6704*/ GIMT_Encode4(342266),
     /* 341958 */ /*GILLT_s32*//*Label 6697*/ GIMT_Encode4(341994),
     /* 341962 */ /*GILLT_s64*//*Label 6698*/ GIMT_Encode4(342067), GIMT_Encode4(0),
     /* 341970 */ /*GILLT_v2s32*//*Label 6699*/ GIMT_Encode4(342140),
     /* 341974 */ /*GILLT_v2s64*//*Label 6700*/ GIMT_Encode4(342164),
     /* 341978 */ /*GILLT_v4s16*//*Label 6701*/ GIMT_Encode4(342188),
     /* 341982 */ /*GILLT_v4s32*//*Label 6702*/ GIMT_Encode4(342215), GIMT_Encode4(0),
     /* 341990 */ /*GILLT_v8s16*//*Label 6703*/ GIMT_Encode4(342239),
     /* 341994 */ // Label 6697: @341994
     /* 341994 */ GIM_Try, /*On fail goto*//*Label 6705*/ GIMT_Encode4(342020), // Rule ID 4668 //
     /* 341999 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 342002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 342005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 342009 */   // (fp_to_uint_sat_gi:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 342009 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 342014 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342018 */   GIR_RootConstrainSelectedInstOperands,
     /* 342019 */   // GIR_Coverage, 4668,
     /* 342019 */   GIR_Done,
     /* 342020 */ // Label 6705: @342020
     /* 342020 */ GIM_Try, /*On fail goto*//*Label 6706*/ GIMT_Encode4(342043), // Rule ID 4670 //
     /* 342025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 342028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 342032 */   // (fp_to_uint_sat_gi:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 342032 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 342037 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342041 */   GIR_RootConstrainSelectedInstOperands,
     /* 342042 */   // GIR_Coverage, 4670,
     /* 342042 */   GIR_Done,
     /* 342043 */ // Label 6706: @342043
     /* 342043 */ GIM_Try, /*On fail goto*//*Label 6707*/ GIMT_Encode4(342066), // Rule ID 4672 //
     /* 342048 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 342051 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 342055 */   // (fp_to_uint_sat_gi:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 342055 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 342060 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342064 */   GIR_RootConstrainSelectedInstOperands,
     /* 342065 */   // GIR_Coverage, 4672,
     /* 342065 */   GIR_Done,
     /* 342066 */ // Label 6707: @342066
     /* 342066 */ GIM_Reject,
     /* 342067 */ // Label 6698: @342067
     /* 342067 */ GIM_Try, /*On fail goto*//*Label 6708*/ GIMT_Encode4(342093), // Rule ID 4669 //
     /* 342072 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 342075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 342078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 342082 */   // (fp_to_uint_sat_gi:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 342082 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 342087 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342091 */   GIR_RootConstrainSelectedInstOperands,
     /* 342092 */   // GIR_Coverage, 4669,
     /* 342092 */   GIR_Done,
     /* 342093 */ // Label 6708: @342093
     /* 342093 */ GIM_Try, /*On fail goto*//*Label 6709*/ GIMT_Encode4(342116), // Rule ID 4671 //
     /* 342098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 342101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 342105 */   // (fp_to_uint_sat_gi:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 342105 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 342110 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342114 */   GIR_RootConstrainSelectedInstOperands,
     /* 342115 */   // GIR_Coverage, 4671,
     /* 342115 */   GIR_Done,
     /* 342116 */ // Label 6709: @342116
     /* 342116 */ GIM_Try, /*On fail goto*//*Label 6710*/ GIMT_Encode4(342139), // Rule ID 4673 //
     /* 342121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 342124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 342128 */   // (fp_to_uint_sat_gi:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 342128 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 342133 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342137 */   GIR_RootConstrainSelectedInstOperands,
     /* 342138 */   // GIR_Coverage, 4673,
     /* 342138 */   GIR_Done,
     /* 342139 */ // Label 6710: @342139
     /* 342139 */ GIM_Reject,
     /* 342140 */ // Label 6699: @342140
     /* 342140 */ GIM_Try, /*On fail goto*//*Label 6711*/ GIMT_Encode4(342163), // Rule ID 4995 //
     /* 342145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 342148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342152 */   // (fp_to_uint_sat_gi:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)
     /* 342152 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 342157 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342161 */   GIR_RootConstrainSelectedInstOperands,
     /* 342162 */   // GIR_Coverage, 4995,
     /* 342162 */   GIR_Done,
     /* 342163 */ // Label 6711: @342163
     /* 342163 */ GIM_Reject,
     /* 342164 */ // Label 6700: @342164
     /* 342164 */ GIM_Try, /*On fail goto*//*Label 6712*/ GIMT_Encode4(342187), // Rule ID 4997 //
     /* 342169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 342172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342176 */   // (fp_to_uint_sat_gi:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)
     /* 342176 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 342181 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342185 */   GIR_RootConstrainSelectedInstOperands,
     /* 342186 */   // GIR_Coverage, 4997,
     /* 342186 */   GIR_Done,
     /* 342187 */ // Label 6712: @342187
     /* 342187 */ GIM_Reject,
     /* 342188 */ // Label 6701: @342188
     /* 342188 */ GIM_Try, /*On fail goto*//*Label 6713*/ GIMT_Encode4(342214), // Rule ID 4990 //
     /* 342193 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 342196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 342199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342203 */   // (fp_to_uint_sat_gi:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)
     /* 342203 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 342208 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342212 */   GIR_RootConstrainSelectedInstOperands,
     /* 342213 */   // GIR_Coverage, 4990,
     /* 342213 */   GIR_Done,
     /* 342214 */ // Label 6713: @342214
     /* 342214 */ GIM_Reject,
     /* 342215 */ // Label 6702: @342215
     /* 342215 */ GIM_Try, /*On fail goto*//*Label 6714*/ GIMT_Encode4(342238), // Rule ID 4996 //
     /* 342220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 342223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342227 */   // (fp_to_uint_sat_gi:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)
     /* 342227 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 342232 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342236 */   GIR_RootConstrainSelectedInstOperands,
     /* 342237 */   // GIR_Coverage, 4996,
     /* 342237 */   GIR_Done,
     /* 342238 */ // Label 6714: @342238
     /* 342238 */ GIM_Reject,
     /* 342239 */ // Label 6703: @342239
     /* 342239 */ GIM_Try, /*On fail goto*//*Label 6715*/ GIMT_Encode4(342265), // Rule ID 4991 //
     /* 342244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 342247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 342250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342254 */   // (fp_to_uint_sat_gi:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)
     /* 342254 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 342259 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342263 */   GIR_RootConstrainSelectedInstOperands,
     /* 342264 */   // GIR_Coverage, 4991,
     /* 342264 */   GIR_Done,
     /* 342265 */ // Label 6715: @342265
     /* 342265 */ GIM_Reject,
     /* 342266 */ // Label 6704: @342266
     /* 342266 */ GIM_Reject,
     /* 342267 */ // Label 73: @342267
     /* 342267 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6724*/ GIMT_Encode4(343123),
     /* 342278 */ /*GILLT_s16*//*Label 6716*/ GIMT_Encode4(342318),
     /* 342282 */ /*GILLT_s32*//*Label 6717*/ GIMT_Encode4(342537),
     /* 342286 */ /*GILLT_s64*//*Label 6718*/ GIMT_Encode4(342611), GIMT_Encode4(0),
     /* 342294 */ /*GILLT_v2s32*//*Label 6719*/ GIMT_Encode4(342685),
     /* 342298 */ /*GILLT_v2s64*//*Label 6720*/ GIMT_Encode4(342759),
     /* 342302 */ /*GILLT_v4s16*//*Label 6721*/ GIMT_Encode4(342833),
     /* 342306 */ /*GILLT_v4s32*//*Label 6722*/ GIMT_Encode4(342941), GIMT_Encode4(0),
     /* 342314 */ /*GILLT_v8s16*//*Label 6723*/ GIMT_Encode4(343015),
     /* 342318 */ // Label 6716: @342318
     /* 342318 */ GIM_Try, /*On fail goto*//*Label 6725*/ GIMT_Encode4(342536),
     /* 342323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 342326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342330 */   GIM_Try, /*On fail goto*//*Label 6726*/ GIMT_Encode4(342371), // Rule ID 5248 //
     /* 342335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 342338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 342346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 342350 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 342354 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 342356 */     // (fabs:{ *:[f16] } (fsub:{ *:[f16] } f16:{ *:[f16] }:$Rn, f16:{ *:[f16] }:$Rm))  =>  (FABD16:{ *:[f16] } f16:{ *:[f16] }:$Rn, f16:{ *:[f16] }:$Rm)
     /* 342356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD16),
     /* 342359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 342361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 342369 */     GIR_RootConstrainSelectedInstOperands,
     /* 342370 */     // GIR_Coverage, 5248,
     /* 342370 */     GIR_EraseRootFromParent_Done,
     /* 342371 */   // Label 6726: @342371
     /* 342371 */   GIM_Try, /*On fail goto*//*Label 6727*/ GIMT_Encode4(342390), // Rule ID 521 //
     /* 342376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 342379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342383 */     // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FABSHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 342383 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSHr),
     /* 342388 */     GIR_RootConstrainSelectedInstOperands,
     /* 342389 */     // GIR_Coverage, 521,
     /* 342389 */     GIR_Done,
     /* 342390 */   // Label 6727: @342390
     /* 342390 */   GIM_Try, /*On fail goto*//*Label 6728*/ GIMT_Encode4(342535), // Rule ID 6434 //
     /* 342395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342399 */     // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } (ANDWri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), GPR32:{ *:[i32] }), (logical_imm32_XFORM:{ *:[i32] } 32767:{ *:[i32] })), FPR32:{ *:[i32] }), hsub:{ *:[i32] })
     /* 342399 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 342402 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 342406 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342411 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 342413 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 342416 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 342420 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342425 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 342428 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 342432 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 342435 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342440 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342445 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342450 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 342453 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 342457 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342462 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 342465 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 342470 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 342473 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::ANDWri),
     /* 342477 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342482 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 342485 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // 
     /* 342490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 342492 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 342495 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 342499 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342504 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 342507 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 342515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342517 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 342524 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342529 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342534 */     // GIR_Coverage, 6434,
     /* 342534 */     GIR_EraseRootFromParent_Done,
     /* 342535 */   // Label 6728: @342535
     /* 342535 */   GIM_Reject,
     /* 342536 */ // Label 6725: @342536
     /* 342536 */ GIM_Reject,
     /* 342537 */ // Label 6717: @342537
     /* 342537 */ GIM_Try, /*On fail goto*//*Label 6729*/ GIMT_Encode4(342610),
     /* 342542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 342545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342549 */   GIM_Try, /*On fail goto*//*Label 6730*/ GIMT_Encode4(342590), // Rule ID 5249 //
     /* 342554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 342565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 342569 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 342573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 342575 */     // (fabs:{ *:[f32] } (fsub:{ *:[f32] } f32:{ *:[f32] }:$Rn, f32:{ *:[f32] }:$Rm))  =>  (FABD32:{ *:[f32] } f32:{ *:[f32] }:$Rn, f32:{ *:[f32] }:$Rm)
     /* 342575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD32),
     /* 342578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 342580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 342588 */     GIR_RootConstrainSelectedInstOperands,
     /* 342589 */     // GIR_Coverage, 5249,
     /* 342589 */     GIR_EraseRootFromParent_Done,
     /* 342590 */   // Label 6730: @342590
     /* 342590 */   GIM_Try, /*On fail goto*//*Label 6731*/ GIMT_Encode4(342609), // Rule ID 522 //
     /* 342595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 342598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342602 */     // (fabs:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FABSSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 342602 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSSr),
     /* 342607 */     GIR_RootConstrainSelectedInstOperands,
     /* 342608 */     // GIR_Coverage, 522,
     /* 342608 */     GIR_Done,
     /* 342609 */   // Label 6731: @342609
     /* 342609 */   GIM_Reject,
     /* 342610 */ // Label 6729: @342610
     /* 342610 */ GIM_Reject,
     /* 342611 */ // Label 6718: @342611
     /* 342611 */ GIM_Try, /*On fail goto*//*Label 6732*/ GIMT_Encode4(342684),
     /* 342616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 342619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342623 */   GIM_Try, /*On fail goto*//*Label 6733*/ GIMT_Encode4(342664), // Rule ID 5250 //
     /* 342628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 342639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 342643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 342647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 342649 */     // (fabs:{ *:[f64] } (fsub:{ *:[f64] } f64:{ *:[f64] }:$Rn, f64:{ *:[f64] }:$Rm))  =>  (FABD64:{ *:[f64] } f64:{ *:[f64] }:$Rn, f64:{ *:[f64] }:$Rm)
     /* 342649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 342652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 342654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 342662 */     GIR_RootConstrainSelectedInstOperands,
     /* 342663 */     // GIR_Coverage, 5250,
     /* 342663 */     GIR_EraseRootFromParent_Done,
     /* 342664 */   // Label 6733: @342664
     /* 342664 */   GIM_Try, /*On fail goto*//*Label 6734*/ GIMT_Encode4(342683), // Rule ID 523 //
     /* 342669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 342672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342676 */     // (fabs:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FABSDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 342676 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSDr),
     /* 342681 */     GIR_RootConstrainSelectedInstOperands,
     /* 342682 */     // GIR_Coverage, 523,
     /* 342682 */     GIR_Done,
     /* 342683 */   // Label 6734: @342683
     /* 342683 */   GIM_Reject,
     /* 342684 */ // Label 6732: @342684
     /* 342684 */ GIM_Reject,
     /* 342685 */ // Label 6719: @342685
     /* 342685 */ GIM_Try, /*On fail goto*//*Label 6735*/ GIMT_Encode4(342758),
     /* 342690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 342693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342697 */   GIM_Try, /*On fail goto*//*Label 6736*/ GIMT_Encode4(342738), // Rule ID 5062 //
     /* 342702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 342713 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 342717 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 342721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 342723 */     // (fabs:{ *:[v2f32] } (fsub:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$Rn, v2f32:{ *:[v2f32] }:$Rm))  =>  (FABDv2f32:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$Rn, v2f32:{ *:[v2f32] }:$Rm)
     /* 342723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f32),
     /* 342726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 342728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 342736 */     GIR_RootConstrainSelectedInstOperands,
     /* 342737 */     // GIR_Coverage, 5062,
     /* 342737 */     GIR_EraseRootFromParent_Done,
     /* 342738 */   // Label 6736: @342738
     /* 342738 */   GIM_Try, /*On fail goto*//*Label 6737*/ GIMT_Encode4(342757), // Rule ID 768 //
     /* 342743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342750 */     // (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FABSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 342750 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv2f32),
     /* 342755 */     GIR_RootConstrainSelectedInstOperands,
     /* 342756 */     // GIR_Coverage, 768,
     /* 342756 */     GIR_Done,
     /* 342757 */   // Label 6737: @342757
     /* 342757 */   GIM_Reject,
     /* 342758 */ // Label 6735: @342758
     /* 342758 */ GIM_Reject,
     /* 342759 */ // Label 6720: @342759
     /* 342759 */ GIM_Try, /*On fail goto*//*Label 6738*/ GIMT_Encode4(342832),
     /* 342764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 342767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342771 */   GIM_Try, /*On fail goto*//*Label 6739*/ GIMT_Encode4(342812), // Rule ID 5064 //
     /* 342776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 342787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 342791 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 342795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 342797 */     // (fabs:{ *:[v2f64] } (fsub:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, v2f64:{ *:[v2f64] }:$Rm))  =>  (FABDv2f64:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, v2f64:{ *:[v2f64] }:$Rm)
     /* 342797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f64),
     /* 342800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 342802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 342810 */     GIR_RootConstrainSelectedInstOperands,
     /* 342811 */     // GIR_Coverage, 5064,
     /* 342811 */     GIR_EraseRootFromParent_Done,
     /* 342812 */   // Label 6739: @342812
     /* 342812 */   GIM_Try, /*On fail goto*//*Label 6740*/ GIMT_Encode4(342831), // Rule ID 770 //
     /* 342817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342824 */     // (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FABSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 342824 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv2f64),
     /* 342829 */     GIR_RootConstrainSelectedInstOperands,
     /* 342830 */     // GIR_Coverage, 770,
     /* 342830 */     GIR_Done,
     /* 342831 */   // Label 6740: @342831
     /* 342831 */   GIM_Reject,
     /* 342832 */ // Label 6738: @342832
     /* 342832 */ GIM_Reject,
     /* 342833 */ // Label 6721: @342833
     /* 342833 */ GIM_Try, /*On fail goto*//*Label 6741*/ GIMT_Encode4(342940),
     /* 342838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 342841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342845 */   GIM_Try, /*On fail goto*//*Label 6742*/ GIMT_Encode4(342886), // Rule ID 5065 //
     /* 342850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 342853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 342861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 342865 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 342869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 342871 */     // (fabs:{ *:[v4f16] } (fsub:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$Rn, v4f16:{ *:[v4f16] }:$Rm))  =>  (FABDv4f16:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$Rn, v4f16:{ *:[v4f16] }:$Rm)
     /* 342871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f16),
     /* 342874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 342876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 342884 */     GIR_RootConstrainSelectedInstOperands,
     /* 342885 */     // GIR_Coverage, 5065,
     /* 342885 */     GIR_EraseRootFromParent_Done,
     /* 342886 */   // Label 6742: @342886
     /* 342886 */   GIM_Try, /*On fail goto*//*Label 6743*/ GIMT_Encode4(342905), // Rule ID 766 //
     /* 342891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 342894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342898 */     // (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FABSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 342898 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv4f16),
     /* 342903 */     GIR_RootConstrainSelectedInstOperands,
     /* 342904 */     // GIR_Coverage, 766,
     /* 342904 */     GIR_Done,
     /* 342905 */   // Label 6743: @342905
     /* 342905 */   GIM_Try, /*On fail goto*//*Label 6744*/ GIMT_Encode4(342939), // Rule ID 6436 //
     /* 342910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342917 */     // (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (BICv4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, 128:{ *:[i32] }, 8:{ *:[i32] })
     /* 342917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv4i16),
     /* 342920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342922 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 342924 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /* 342934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 342937 */     GIR_RootConstrainSelectedInstOperands,
     /* 342938 */     // GIR_Coverage, 6436,
     /* 342938 */     GIR_EraseRootFromParent_Done,
     /* 342939 */   // Label 6744: @342939
     /* 342939 */   GIM_Reject,
     /* 342940 */ // Label 6741: @342940
     /* 342940 */ GIM_Reject,
     /* 342941 */ // Label 6722: @342941
     /* 342941 */ GIM_Try, /*On fail goto*//*Label 6745*/ GIMT_Encode4(343014),
     /* 342946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 342949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342953 */   GIM_Try, /*On fail goto*//*Label 6746*/ GIMT_Encode4(342994), // Rule ID 5063 //
     /* 342958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 342969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 342973 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 342977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 342979 */     // (fabs:{ *:[v4f32] } (fsub:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, v4f32:{ *:[v4f32] }:$Rm))  =>  (FABDv4f32:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, v4f32:{ *:[v4f32] }:$Rm)
     /* 342979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f32),
     /* 342982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 342984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 342992 */     GIR_RootConstrainSelectedInstOperands,
     /* 342993 */     // GIR_Coverage, 5063,
     /* 342993 */     GIR_EraseRootFromParent_Done,
     /* 342994 */   // Label 6746: @342994
     /* 342994 */   GIM_Try, /*On fail goto*//*Label 6747*/ GIMT_Encode4(343013), // Rule ID 769 //
     /* 342999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343006 */     // (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FABSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 343006 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv4f32),
     /* 343011 */     GIR_RootConstrainSelectedInstOperands,
     /* 343012 */     // GIR_Coverage, 769,
     /* 343012 */     GIR_Done,
     /* 343013 */   // Label 6747: @343013
     /* 343013 */   GIM_Reject,
     /* 343014 */ // Label 6745: @343014
     /* 343014 */ GIM_Reject,
     /* 343015 */ // Label 6723: @343015
     /* 343015 */ GIM_Try, /*On fail goto*//*Label 6748*/ GIMT_Encode4(343122),
     /* 343020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 343023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343027 */   GIM_Try, /*On fail goto*//*Label 6749*/ GIMT_Encode4(343068), // Rule ID 5066 //
     /* 343032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 343035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 343043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 343047 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 343051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 343053 */     // (fabs:{ *:[v8f16] } (fsub:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, v8f16:{ *:[v8f16] }:$Rm))  =>  (FABDv8f16:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, v8f16:{ *:[v8f16] }:$Rm)
     /* 343053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv8f16),
     /* 343056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 343058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 343066 */     GIR_RootConstrainSelectedInstOperands,
     /* 343067 */     // GIR_Coverage, 5066,
     /* 343067 */     GIR_EraseRootFromParent_Done,
     /* 343068 */   // Label 6749: @343068
     /* 343068 */   GIM_Try, /*On fail goto*//*Label 6750*/ GIMT_Encode4(343087), // Rule ID 767 //
     /* 343073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 343076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343080 */     // (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FABSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 343080 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv8f16),
     /* 343085 */     GIR_RootConstrainSelectedInstOperands,
     /* 343086 */     // GIR_Coverage, 767,
     /* 343086 */     GIR_Done,
     /* 343087 */   // Label 6750: @343087
     /* 343087 */   GIM_Try, /*On fail goto*//*Label 6751*/ GIMT_Encode4(343121), // Rule ID 6437 //
     /* 343092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343099 */     // (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (BICv8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, 128:{ *:[i32] }, 8:{ *:[i32] })
     /* 343099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i16),
     /* 343102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343104 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 343106 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /* 343116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 343119 */     GIR_RootConstrainSelectedInstOperands,
     /* 343120 */     // GIR_Coverage, 6437,
     /* 343120 */     GIR_EraseRootFromParent_Done,
     /* 343121 */   // Label 6751: @343121
     /* 343121 */   GIM_Reject,
     /* 343122 */ // Label 6748: @343122
     /* 343122 */ GIM_Reject,
     /* 343123 */ // Label 6724: @343123
     /* 343123 */ GIM_Reject,
     /* 343124 */ // Label 74: @343124
     /* 343124 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6760*/ GIMT_Encode4(343405),
     /* 343135 */ /*GILLT_s16*//*Label 6752*/ GIMT_Encode4(343175),
     /* 343139 */ /*GILLT_s32*//*Label 6753*/ GIMT_Encode4(343202),
     /* 343143 */ /*GILLT_s64*//*Label 6754*/ GIMT_Encode4(343226), GIMT_Encode4(0),
     /* 343151 */ /*GILLT_v2s32*//*Label 6755*/ GIMT_Encode4(343250),
     /* 343155 */ /*GILLT_v2s64*//*Label 6756*/ GIMT_Encode4(343281),
     /* 343159 */ /*GILLT_v4s16*//*Label 6757*/ GIMT_Encode4(343312),
     /* 343163 */ /*GILLT_v4s32*//*Label 6758*/ GIMT_Encode4(343343), GIMT_Encode4(0),
     /* 343171 */ /*GILLT_v8s16*//*Label 6759*/ GIMT_Encode4(343374),
     /* 343175 */ // Label 6752: @343175
     /* 343175 */ GIM_Try, /*On fail goto*//*Label 6761*/ GIMT_Encode4(343201), // Rule ID 4884 //
     /* 343180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 343183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 343186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343190 */   // (fcanonicalize:{ *:[f16] } f16:{ *:[f16] }:$a)  =>  (FMINNMHrr:{ *:[f16] } f16:{ *:[f16] }:$a, f16:{ *:[f16] }:$a)
     /* 343190 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 343193 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 343195 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 343197 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 343199 */   GIR_RootConstrainSelectedInstOperands,
     /* 343200 */   // GIR_Coverage, 4884,
     /* 343200 */   GIR_EraseRootFromParent_Done,
     /* 343201 */ // Label 6761: @343201
     /* 343201 */ GIM_Reject,
     /* 343202 */ // Label 6753: @343202
     /* 343202 */ GIM_Try, /*On fail goto*//*Label 6762*/ GIMT_Encode4(343225), // Rule ID 4881 //
     /* 343207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 343210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343214 */   // (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$a)  =>  (FMINNMSrr:{ *:[f32] } f32:{ *:[f32] }:$a, f32:{ *:[f32] }:$a)
     /* 343214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 343217 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 343219 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 343221 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 343223 */   GIR_RootConstrainSelectedInstOperands,
     /* 343224 */   // GIR_Coverage, 4881,
     /* 343224 */   GIR_EraseRootFromParent_Done,
     /* 343225 */ // Label 6762: @343225
     /* 343225 */ GIM_Reject,
     /* 343226 */ // Label 6754: @343226
     /* 343226 */ GIM_Try, /*On fail goto*//*Label 6763*/ GIMT_Encode4(343249), // Rule ID 4878 //
     /* 343231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 343234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343238 */   // (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$a)  =>  (FMINNMDrr:{ *:[f64] } f64:{ *:[f64] }:$a, f64:{ *:[f64] }:$a)
     /* 343238 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 343241 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 343243 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 343245 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 343247 */   GIR_RootConstrainSelectedInstOperands,
     /* 343248 */   // GIR_Coverage, 4878,
     /* 343248 */   GIR_EraseRootFromParent_Done,
     /* 343249 */ // Label 6763: @343249
     /* 343249 */ GIM_Reject,
     /* 343250 */ // Label 6755: @343250
     /* 343250 */ GIM_Try, /*On fail goto*//*Label 6764*/ GIMT_Encode4(343280), // Rule ID 5075 //
     /* 343255 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 343261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343265 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343269 */   // (fcanonicalize:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rn)
     /* 343269 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 343272 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 343274 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 343276 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 343278 */   GIR_RootConstrainSelectedInstOperands,
     /* 343279 */   // GIR_Coverage, 5075,
     /* 343279 */   GIR_EraseRootFromParent_Done,
     /* 343280 */ // Label 6764: @343280
     /* 343280 */ GIM_Reject,
     /* 343281 */ // Label 6756: @343281
     /* 343281 */ GIM_Try, /*On fail goto*//*Label 6765*/ GIMT_Encode4(343311), // Rule ID 5069 //
     /* 343286 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343289 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 343292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343296 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343300 */   // (fcanonicalize:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn)
     /* 343300 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 343303 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 343305 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 343307 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 343309 */   GIR_RootConstrainSelectedInstOperands,
     /* 343310 */   // GIR_Coverage, 5069,
     /* 343310 */   GIR_EraseRootFromParent_Done,
     /* 343311 */ // Label 6765: @343311
     /* 343311 */ GIM_Reject,
     /* 343312 */ // Label 6757: @343312
     /* 343312 */ GIM_Try, /*On fail goto*//*Label 6766*/ GIMT_Encode4(343342), // Rule ID 5081 //
     /* 343317 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 343320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 343323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343327 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343331 */   // (fcanonicalize:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rn)
     /* 343331 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 343334 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 343336 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 343338 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 343340 */   GIR_RootConstrainSelectedInstOperands,
     /* 343341 */   // GIR_Coverage, 5081,
     /* 343341 */   GIR_EraseRootFromParent_Done,
     /* 343342 */ // Label 6766: @343342
     /* 343342 */ GIM_Reject,
     /* 343343 */ // Label 6758: @343343
     /* 343343 */ GIM_Try, /*On fail goto*//*Label 6767*/ GIMT_Encode4(343373), // Rule ID 5072 //
     /* 343348 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343351 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 343354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343358 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343362 */   // (fcanonicalize:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn)
     /* 343362 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 343365 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 343367 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 343369 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 343371 */   GIR_RootConstrainSelectedInstOperands,
     /* 343372 */   // GIR_Coverage, 5072,
     /* 343372 */   GIR_EraseRootFromParent_Done,
     /* 343373 */ // Label 6767: @343373
     /* 343373 */ GIM_Reject,
     /* 343374 */ // Label 6759: @343374
     /* 343374 */ GIM_Try, /*On fail goto*//*Label 6768*/ GIMT_Encode4(343404), // Rule ID 5078 //
     /* 343379 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 343382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 343385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343389 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343393 */   // (fcanonicalize:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn)
     /* 343393 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 343396 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 343398 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 343400 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 343402 */   GIR_RootConstrainSelectedInstOperands,
     /* 343403 */   // GIR_Coverage, 5078,
     /* 343403 */   GIR_EraseRootFromParent_Done,
     /* 343404 */ // Label 6768: @343404
     /* 343404 */ GIM_Reject,
     /* 343405 */ // Label 6760: @343405
     /* 343405 */ GIM_Reject,
     /* 343406 */ // Label 75: @343406
     /* 343406 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6777*/ GIMT_Encode4(343783),
     /* 343417 */ /*GILLT_s16*//*Label 6769*/ GIMT_Encode4(343457),
     /* 343421 */ /*GILLT_s32*//*Label 6770*/ GIMT_Encode4(343495),
     /* 343425 */ /*GILLT_s64*//*Label 6771*/ GIMT_Encode4(343533), GIMT_Encode4(0),
     /* 343433 */ /*GILLT_v2s32*//*Label 6772*/ GIMT_Encode4(343593),
     /* 343437 */ /*GILLT_v2s64*//*Label 6773*/ GIMT_Encode4(343631),
     /* 343441 */ /*GILLT_v4s16*//*Label 6774*/ GIMT_Encode4(343669),
     /* 343445 */ /*GILLT_v4s32*//*Label 6775*/ GIMT_Encode4(343707), GIMT_Encode4(0),
     /* 343453 */ /*GILLT_v8s16*//*Label 6776*/ GIMT_Encode4(343745),
     /* 343457 */ // Label 6769: @343457
     /* 343457 */ GIM_Try, /*On fail goto*//*Label 6778*/ GIMT_Encode4(343494), // Rule ID 608 //
     /* 343462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 343465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 343468 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 343471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343475 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343479 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343483 */   // (fminnum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMINNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 343483 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 343488 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343492 */   GIR_RootConstrainSelectedInstOperands,
     /* 343493 */   // GIR_Coverage, 608,
     /* 343493 */   GIR_Done,
     /* 343494 */ // Label 6778: @343494
     /* 343494 */ GIM_Reject,
     /* 343495 */ // Label 6770: @343495
     /* 343495 */ GIM_Try, /*On fail goto*//*Label 6779*/ GIMT_Encode4(343532), // Rule ID 610 //
     /* 343500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 343503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 343506 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 343509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343513 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343517 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343521 */   // (fminnum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMINNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 343521 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 343526 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343530 */   GIR_RootConstrainSelectedInstOperands,
     /* 343531 */   // GIR_Coverage, 610,
     /* 343531 */   GIR_Done,
     /* 343532 */ // Label 6779: @343532
     /* 343532 */ GIM_Reject,
     /* 343533 */ // Label 6771: @343533
     /* 343533 */ GIM_Try, /*On fail goto*//*Label 6780*/ GIMT_Encode4(343592),
     /* 343538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 343541 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 343544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343548 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343552 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343556 */   GIM_Try, /*On fail goto*//*Label 6781*/ GIMT_Encode4(343575), // Rule ID 612 //
     /* 343561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 343564 */     // (fminnum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMINNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 343564 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 343569 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343573 */     GIR_RootConstrainSelectedInstOperands,
     /* 343574 */     // GIR_Coverage, 612,
     /* 343574 */     GIR_Done,
     /* 343575 */   // Label 6781: @343575
     /* 343575 */   GIM_Try, /*On fail goto*//*Label 6782*/ GIMT_Encode4(343591), // Rule ID 4875 //
     /* 343580 */     // (fminnum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMINNMDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 343580 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 343585 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343589 */     GIR_RootConstrainSelectedInstOperands,
     /* 343590 */     // GIR_Coverage, 4875,
     /* 343590 */     GIR_Done,
     /* 343591 */   // Label 6782: @343591
     /* 343591 */   GIM_Reject,
     /* 343592 */ // Label 6780: @343592
     /* 343592 */ GIM_Reject,
     /* 343593 */ // Label 6772: @343593
     /* 343593 */ GIM_Try, /*On fail goto*//*Label 6783*/ GIMT_Encode4(343630), // Rule ID 1273 //
     /* 343598 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 343604 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 343607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343611 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343615 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343619 */   // (fminnum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 343619 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 343624 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343628 */   GIR_RootConstrainSelectedInstOperands,
     /* 343629 */   // GIR_Coverage, 1273,
     /* 343629 */   GIR_Done,
     /* 343630 */ // Label 6783: @343630
     /* 343630 */ GIM_Reject,
     /* 343631 */ // Label 6773: @343631
     /* 343631 */ GIM_Try, /*On fail goto*//*Label 6784*/ GIMT_Encode4(343668), // Rule ID 1277 //
     /* 343636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 343642 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 343645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343649 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343653 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343657 */   // (fminnum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 343657 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 343662 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343666 */   GIR_RootConstrainSelectedInstOperands,
     /* 343667 */   // GIR_Coverage, 1277,
     /* 343667 */   GIR_Done,
     /* 343668 */ // Label 6784: @343668
     /* 343668 */ GIM_Reject,
     /* 343669 */ // Label 6774: @343669
     /* 343669 */ GIM_Try, /*On fail goto*//*Label 6785*/ GIMT_Encode4(343706), // Rule ID 1269 //
     /* 343674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 343677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 343680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 343683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343687 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343691 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343695 */   // (fminnum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 343695 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 343700 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343704 */   GIR_RootConstrainSelectedInstOperands,
     /* 343705 */   // GIR_Coverage, 1269,
     /* 343705 */   GIR_Done,
     /* 343706 */ // Label 6785: @343706
     /* 343706 */ GIM_Reject,
     /* 343707 */ // Label 6775: @343707
     /* 343707 */ GIM_Try, /*On fail goto*//*Label 6786*/ GIMT_Encode4(343744), // Rule ID 1275 //
     /* 343712 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 343718 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 343721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343725 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343729 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343733 */   // (fminnum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 343733 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 343738 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343742 */   GIR_RootConstrainSelectedInstOperands,
     /* 343743 */   // GIR_Coverage, 1275,
     /* 343743 */   GIR_Done,
     /* 343744 */ // Label 6786: @343744
     /* 343744 */ GIM_Reject,
     /* 343745 */ // Label 6776: @343745
     /* 343745 */ GIM_Try, /*On fail goto*//*Label 6787*/ GIMT_Encode4(343782), // Rule ID 1271 //
     /* 343750 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 343753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 343756 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 343759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343763 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343767 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343771 */   // (fminnum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 343771 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 343776 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343780 */   GIR_RootConstrainSelectedInstOperands,
     /* 343781 */   // GIR_Coverage, 1271,
     /* 343781 */   GIR_Done,
     /* 343782 */ // Label 6787: @343782
     /* 343782 */ GIM_Reject,
     /* 343783 */ // Label 6777: @343783
     /* 343783 */ GIM_Reject,
     /* 343784 */ // Label 76: @343784
     /* 343784 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6796*/ GIMT_Encode4(344161),
     /* 343795 */ /*GILLT_s16*//*Label 6788*/ GIMT_Encode4(343835),
     /* 343799 */ /*GILLT_s32*//*Label 6789*/ GIMT_Encode4(343873),
     /* 343803 */ /*GILLT_s64*//*Label 6790*/ GIMT_Encode4(343911), GIMT_Encode4(0),
     /* 343811 */ /*GILLT_v2s32*//*Label 6791*/ GIMT_Encode4(343971),
     /* 343815 */ /*GILLT_v2s64*//*Label 6792*/ GIMT_Encode4(344009),
     /* 343819 */ /*GILLT_v4s16*//*Label 6793*/ GIMT_Encode4(344047),
     /* 343823 */ /*GILLT_v4s32*//*Label 6794*/ GIMT_Encode4(344085), GIMT_Encode4(0),
     /* 343831 */ /*GILLT_v8s16*//*Label 6795*/ GIMT_Encode4(344123),
     /* 343835 */ // Label 6788: @343835
     /* 343835 */ GIM_Try, /*On fail goto*//*Label 6797*/ GIMT_Encode4(343872), // Rule ID 596 //
     /* 343840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 343843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 343846 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 343849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343853 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343857 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343861 */   // (fmaxnum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMAXNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 343861 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMHrr),
     /* 343866 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343870 */   GIR_RootConstrainSelectedInstOperands,
     /* 343871 */   // GIR_Coverage, 596,
     /* 343871 */   GIR_Done,
     /* 343872 */ // Label 6797: @343872
     /* 343872 */ GIM_Reject,
     /* 343873 */ // Label 6789: @343873
     /* 343873 */ GIM_Try, /*On fail goto*//*Label 6798*/ GIMT_Encode4(343910), // Rule ID 598 //
     /* 343878 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 343881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 343884 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 343887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343891 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343895 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343899 */   // (fmaxnum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMAXNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 343899 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMSrr),
     /* 343904 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343908 */   GIR_RootConstrainSelectedInstOperands,
     /* 343909 */   // GIR_Coverage, 598,
     /* 343909 */   GIR_Done,
     /* 343910 */ // Label 6798: @343910
     /* 343910 */ GIM_Reject,
     /* 343911 */ // Label 6790: @343911
     /* 343911 */ GIM_Try, /*On fail goto*//*Label 6799*/ GIMT_Encode4(343970),
     /* 343916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 343919 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 343922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343926 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343930 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343934 */   GIM_Try, /*On fail goto*//*Label 6800*/ GIMT_Encode4(343953), // Rule ID 600 //
     /* 343939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 343942 */     // (fmaxnum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMAXNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 343942 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 343947 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343951 */     GIR_RootConstrainSelectedInstOperands,
     /* 343952 */     // GIR_Coverage, 600,
     /* 343952 */     GIR_Done,
     /* 343953 */   // Label 6800: @343953
     /* 343953 */   GIM_Try, /*On fail goto*//*Label 6801*/ GIMT_Encode4(343969), // Rule ID 4874 //
     /* 343958 */     // (fmaxnum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMAXNMDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 343958 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 343963 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343967 */     GIR_RootConstrainSelectedInstOperands,
     /* 343968 */     // GIR_Coverage, 4874,
     /* 343968 */     GIR_Done,
     /* 343969 */   // Label 6801: @343969
     /* 343969 */   GIM_Reject,
     /* 343970 */ // Label 6799: @343970
     /* 343970 */ GIM_Reject,
     /* 343971 */ // Label 6791: @343971
     /* 343971 */ GIM_Try, /*On fail goto*//*Label 6802*/ GIMT_Encode4(344008), // Rule ID 1243 //
     /* 343976 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 343982 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 343985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343989 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343993 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343997 */   // (fmaxnum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 343997 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f32),
     /* 344002 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344006 */   GIR_RootConstrainSelectedInstOperands,
     /* 344007 */   // GIR_Coverage, 1243,
     /* 344007 */   GIR_Done,
     /* 344008 */ // Label 6802: @344008
     /* 344008 */ GIM_Reject,
     /* 344009 */ // Label 6792: @344009
     /* 344009 */ GIM_Try, /*On fail goto*//*Label 6803*/ GIMT_Encode4(344046), // Rule ID 1247 //
     /* 344014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 344020 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 344023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344027 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344031 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344035 */   // (fmaxnum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 344035 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f64),
     /* 344040 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344044 */   GIR_RootConstrainSelectedInstOperands,
     /* 344045 */   // GIR_Coverage, 1247,
     /* 344045 */   GIR_Done,
     /* 344046 */ // Label 6803: @344046
     /* 344046 */ GIM_Reject,
     /* 344047 */ // Label 6793: @344047
     /* 344047 */ GIM_Try, /*On fail goto*//*Label 6804*/ GIMT_Encode4(344084), // Rule ID 1239 //
     /* 344052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 344055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 344058 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 344061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344065 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344069 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344073 */   // (fmaxnum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 344073 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f16),
     /* 344078 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344082 */   GIR_RootConstrainSelectedInstOperands,
     /* 344083 */   // GIR_Coverage, 1239,
     /* 344083 */   GIR_Done,
     /* 344084 */ // Label 6804: @344084
     /* 344084 */ GIM_Reject,
     /* 344085 */ // Label 6794: @344085
     /* 344085 */ GIM_Try, /*On fail goto*//*Label 6805*/ GIMT_Encode4(344122), // Rule ID 1245 //
     /* 344090 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 344096 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 344099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344103 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344107 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344111 */   // (fmaxnum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 344111 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f32),
     /* 344116 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344120 */   GIR_RootConstrainSelectedInstOperands,
     /* 344121 */   // GIR_Coverage, 1245,
     /* 344121 */   GIR_Done,
     /* 344122 */ // Label 6805: @344122
     /* 344122 */ GIM_Reject,
     /* 344123 */ // Label 6795: @344123
     /* 344123 */ GIM_Try, /*On fail goto*//*Label 6806*/ GIMT_Encode4(344160), // Rule ID 1241 //
     /* 344128 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 344131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 344134 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 344137 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344141 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344145 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344149 */   // (fmaxnum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 344149 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv8f16),
     /* 344154 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344158 */   GIR_RootConstrainSelectedInstOperands,
     /* 344159 */   // GIR_Coverage, 1241,
     /* 344159 */   GIR_Done,
     /* 344160 */ // Label 6806: @344160
     /* 344160 */ GIM_Reject,
     /* 344161 */ // Label 6796: @344161
     /* 344161 */ GIM_Reject,
     /* 344162 */ // Label 77: @344162
     /* 344162 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6815*/ GIMT_Encode4(344511),
     /* 344173 */ /*GILLT_s16*//*Label 6807*/ GIMT_Encode4(344213),
     /* 344177 */ /*GILLT_s32*//*Label 6808*/ GIMT_Encode4(344251),
     /* 344181 */ /*GILLT_s64*//*Label 6809*/ GIMT_Encode4(344286), GIMT_Encode4(0),
     /* 344189 */ /*GILLT_v2s32*//*Label 6810*/ GIMT_Encode4(344321),
     /* 344193 */ /*GILLT_v2s64*//*Label 6811*/ GIMT_Encode4(344359),
     /* 344197 */ /*GILLT_v4s16*//*Label 6812*/ GIMT_Encode4(344397),
     /* 344201 */ /*GILLT_v4s32*//*Label 6813*/ GIMT_Encode4(344435), GIMT_Encode4(0),
     /* 344209 */ /*GILLT_v8s16*//*Label 6814*/ GIMT_Encode4(344473),
     /* 344213 */ // Label 6807: @344213
     /* 344213 */ GIM_Try, /*On fail goto*//*Label 6816*/ GIMT_Encode4(344250), // Rule ID 4882 //
     /* 344218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 344221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 344224 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 344227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344231 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344235 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344239 */   // (fminnum_ieee:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)  =>  (FMINNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 344239 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 344244 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344248 */   GIR_RootConstrainSelectedInstOperands,
     /* 344249 */   // GIR_Coverage, 4882,
     /* 344249 */   GIR_Done,
     /* 344250 */ // Label 6816: @344250
     /* 344250 */ GIM_Reject,
     /* 344251 */ // Label 6808: @344251
     /* 344251 */ GIM_Try, /*On fail goto*//*Label 6817*/ GIMT_Encode4(344285), // Rule ID 4879 //
     /* 344256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 344259 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344266 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344270 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344274 */   // (fminnum_ieee:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)  =>  (FMINNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 344274 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 344279 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344283 */   GIR_RootConstrainSelectedInstOperands,
     /* 344284 */   // GIR_Coverage, 4879,
     /* 344284 */   GIR_Done,
     /* 344285 */ // Label 6817: @344285
     /* 344285 */ GIM_Reject,
     /* 344286 */ // Label 6809: @344286
     /* 344286 */ GIM_Try, /*On fail goto*//*Label 6818*/ GIMT_Encode4(344320), // Rule ID 4876 //
     /* 344291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 344294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 344297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344305 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344309 */   // (fminnum_ieee:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)  =>  (FMINNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 344309 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 344314 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344318 */   GIR_RootConstrainSelectedInstOperands,
     /* 344319 */   // GIR_Coverage, 4876,
     /* 344319 */   GIR_Done,
     /* 344320 */ // Label 6818: @344320
     /* 344320 */ GIM_Reject,
     /* 344321 */ // Label 6810: @344321
     /* 344321 */ GIM_Try, /*On fail goto*//*Label 6819*/ GIMT_Encode4(344358), // Rule ID 5073 //
     /* 344326 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 344332 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 344335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344339 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344343 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344347 */   // (fminnum_ieee:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 344347 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 344352 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344356 */   GIR_RootConstrainSelectedInstOperands,
     /* 344357 */   // GIR_Coverage, 5073,
     /* 344357 */   GIR_Done,
     /* 344358 */ // Label 6819: @344358
     /* 344358 */ GIM_Reject,
     /* 344359 */ // Label 6811: @344359
     /* 344359 */ GIM_Try, /*On fail goto*//*Label 6820*/ GIMT_Encode4(344396), // Rule ID 5067 //
     /* 344364 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 344370 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 344373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344377 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344381 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344385 */   // (fminnum_ieee:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 344385 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 344390 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344394 */   GIR_RootConstrainSelectedInstOperands,
     /* 344395 */   // GIR_Coverage, 5067,
     /* 344395 */   GIR_Done,
     /* 344396 */ // Label 6820: @344396
     /* 344396 */ GIM_Reject,
     /* 344397 */ // Label 6812: @344397
     /* 344397 */ GIM_Try, /*On fail goto*//*Label 6821*/ GIMT_Encode4(344434), // Rule ID 5079 //
     /* 344402 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 344405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 344408 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 344411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344419 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344423 */   // (fminnum_ieee:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 344423 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 344428 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344432 */   GIR_RootConstrainSelectedInstOperands,
     /* 344433 */   // GIR_Coverage, 5079,
     /* 344433 */   GIR_Done,
     /* 344434 */ // Label 6821: @344434
     /* 344434 */ GIM_Reject,
     /* 344435 */ // Label 6813: @344435
     /* 344435 */ GIM_Try, /*On fail goto*//*Label 6822*/ GIMT_Encode4(344472), // Rule ID 5070 //
     /* 344440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 344446 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 344449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344453 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344457 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344461 */   // (fminnum_ieee:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 344461 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 344466 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344470 */   GIR_RootConstrainSelectedInstOperands,
     /* 344471 */   // GIR_Coverage, 5070,
     /* 344471 */   GIR_Done,
     /* 344472 */ // Label 6822: @344472
     /* 344472 */ GIM_Reject,
     /* 344473 */ // Label 6814: @344473
     /* 344473 */ GIM_Try, /*On fail goto*//*Label 6823*/ GIMT_Encode4(344510), // Rule ID 5076 //
     /* 344478 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 344481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 344484 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 344487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344491 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344495 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344499 */   // (fminnum_ieee:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 344499 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 344504 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344508 */   GIR_RootConstrainSelectedInstOperands,
     /* 344509 */   // GIR_Coverage, 5076,
     /* 344509 */   GIR_Done,
     /* 344510 */ // Label 6823: @344510
     /* 344510 */ GIM_Reject,
     /* 344511 */ // Label 6815: @344511
     /* 344511 */ GIM_Reject,
     /* 344512 */ // Label 78: @344512
     /* 344512 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6832*/ GIMT_Encode4(344861),
     /* 344523 */ /*GILLT_s16*//*Label 6824*/ GIMT_Encode4(344563),
     /* 344527 */ /*GILLT_s32*//*Label 6825*/ GIMT_Encode4(344601),
     /* 344531 */ /*GILLT_s64*//*Label 6826*/ GIMT_Encode4(344636), GIMT_Encode4(0),
     /* 344539 */ /*GILLT_v2s32*//*Label 6827*/ GIMT_Encode4(344671),
     /* 344543 */ /*GILLT_v2s64*//*Label 6828*/ GIMT_Encode4(344709),
     /* 344547 */ /*GILLT_v4s16*//*Label 6829*/ GIMT_Encode4(344747),
     /* 344551 */ /*GILLT_v4s32*//*Label 6830*/ GIMT_Encode4(344785), GIMT_Encode4(0),
     /* 344559 */ /*GILLT_v8s16*//*Label 6831*/ GIMT_Encode4(344823),
     /* 344563 */ // Label 6824: @344563
     /* 344563 */ GIM_Try, /*On fail goto*//*Label 6833*/ GIMT_Encode4(344600), // Rule ID 4883 //
     /* 344568 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 344571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 344574 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 344577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344581 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344585 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344589 */   // (fmaxnum_ieee:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)  =>  (FMAXNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 344589 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMHrr),
     /* 344594 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344598 */   GIR_RootConstrainSelectedInstOperands,
     /* 344599 */   // GIR_Coverage, 4883,
     /* 344599 */   GIR_Done,
     /* 344600 */ // Label 6833: @344600
     /* 344600 */ GIM_Reject,
     /* 344601 */ // Label 6825: @344601
     /* 344601 */ GIM_Try, /*On fail goto*//*Label 6834*/ GIMT_Encode4(344635), // Rule ID 4880 //
     /* 344606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 344609 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344616 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344620 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344624 */   // (fmaxnum_ieee:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)  =>  (FMAXNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 344624 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMSrr),
     /* 344629 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344633 */   GIR_RootConstrainSelectedInstOperands,
     /* 344634 */   // GIR_Coverage, 4880,
     /* 344634 */   GIR_Done,
     /* 344635 */ // Label 6834: @344635
     /* 344635 */ GIM_Reject,
     /* 344636 */ // Label 6826: @344636
     /* 344636 */ GIM_Try, /*On fail goto*//*Label 6835*/ GIMT_Encode4(344670), // Rule ID 4877 //
     /* 344641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 344644 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 344647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344651 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344655 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344659 */   // (fmaxnum_ieee:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)  =>  (FMAXNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 344659 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 344664 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344668 */   GIR_RootConstrainSelectedInstOperands,
     /* 344669 */   // GIR_Coverage, 4877,
     /* 344669 */   GIR_Done,
     /* 344670 */ // Label 6835: @344670
     /* 344670 */ GIM_Reject,
     /* 344671 */ // Label 6827: @344671
     /* 344671 */ GIM_Try, /*On fail goto*//*Label 6836*/ GIMT_Encode4(344708), // Rule ID 5074 //
     /* 344676 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 344682 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 344685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344689 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344693 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344697 */   // (fmaxnum_ieee:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 344697 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f32),
     /* 344702 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344706 */   GIR_RootConstrainSelectedInstOperands,
     /* 344707 */   // GIR_Coverage, 5074,
     /* 344707 */   GIR_Done,
     /* 344708 */ // Label 6836: @344708
     /* 344708 */ GIM_Reject,
     /* 344709 */ // Label 6828: @344709
     /* 344709 */ GIM_Try, /*On fail goto*//*Label 6837*/ GIMT_Encode4(344746), // Rule ID 5068 //
     /* 344714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 344720 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 344723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344727 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344731 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344735 */   // (fmaxnum_ieee:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 344735 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f64),
     /* 344740 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344744 */   GIR_RootConstrainSelectedInstOperands,
     /* 344745 */   // GIR_Coverage, 5068,
     /* 344745 */   GIR_Done,
     /* 344746 */ // Label 6837: @344746
     /* 344746 */ GIM_Reject,
     /* 344747 */ // Label 6829: @344747
     /* 344747 */ GIM_Try, /*On fail goto*//*Label 6838*/ GIMT_Encode4(344784), // Rule ID 5080 //
     /* 344752 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 344755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 344758 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 344761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344765 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344769 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344773 */   // (fmaxnum_ieee:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 344773 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f16),
     /* 344778 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344782 */   GIR_RootConstrainSelectedInstOperands,
     /* 344783 */   // GIR_Coverage, 5080,
     /* 344783 */   GIR_Done,
     /* 344784 */ // Label 6838: @344784
     /* 344784 */ GIM_Reject,
     /* 344785 */ // Label 6830: @344785
     /* 344785 */ GIM_Try, /*On fail goto*//*Label 6839*/ GIMT_Encode4(344822), // Rule ID 5071 //
     /* 344790 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 344796 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 344799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344803 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344807 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344811 */   // (fmaxnum_ieee:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 344811 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f32),
     /* 344816 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344820 */   GIR_RootConstrainSelectedInstOperands,
     /* 344821 */   // GIR_Coverage, 5071,
     /* 344821 */   GIR_Done,
     /* 344822 */ // Label 6839: @344822
     /* 344822 */ GIM_Reject,
     /* 344823 */ // Label 6831: @344823
     /* 344823 */ GIM_Try, /*On fail goto*//*Label 6840*/ GIMT_Encode4(344860), // Rule ID 5077 //
     /* 344828 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 344831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 344834 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 344837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344841 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344845 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344849 */   // (fmaxnum_ieee:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 344849 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv8f16),
     /* 344854 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344858 */   GIR_RootConstrainSelectedInstOperands,
     /* 344859 */   // GIR_Coverage, 5077,
     /* 344859 */   GIR_Done,
     /* 344860 */ // Label 6840: @344860
     /* 344860 */ GIM_Reject,
     /* 344861 */ // Label 6832: @344861
     /* 344861 */ GIM_Reject,
     /* 344862 */ // Label 79: @344862
     /* 344862 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6849*/ GIMT_Encode4(345564),
     /* 344873 */ /*GILLT_s16*//*Label 6841*/ GIMT_Encode4(344913),
     /* 344877 */ /*GILLT_s32*//*Label 6842*/ GIMT_Encode4(344951),
     /* 344881 */ /*GILLT_s64*//*Label 6843*/ GIMT_Encode4(344989), GIMT_Encode4(0),
     /* 344889 */ /*GILLT_v2s32*//*Label 6844*/ GIMT_Encode4(345049),
     /* 344893 */ /*GILLT_v2s64*//*Label 6845*/ GIMT_Encode4(345152),
     /* 344897 */ /*GILLT_v4s16*//*Label 6846*/ GIMT_Encode4(345255),
     /* 344901 */ /*GILLT_v4s32*//*Label 6847*/ GIMT_Encode4(345358), GIMT_Encode4(0),
     /* 344909 */ /*GILLT_v8s16*//*Label 6848*/ GIMT_Encode4(345461),
     /* 344913 */ // Label 6841: @344913
     /* 344913 */ GIM_Try, /*On fail goto*//*Label 6850*/ GIMT_Encode4(344950), // Rule ID 614 //
     /* 344918 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 344921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 344924 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 344927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344931 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344935 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344939 */   // (fminimum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMINHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 344939 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINHrr),
     /* 344944 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344948 */   GIR_RootConstrainSelectedInstOperands,
     /* 344949 */   // GIR_Coverage, 614,
     /* 344949 */   GIR_Done,
     /* 344950 */ // Label 6850: @344950
     /* 344950 */ GIM_Reject,
     /* 344951 */ // Label 6842: @344951
     /* 344951 */ GIM_Try, /*On fail goto*//*Label 6851*/ GIMT_Encode4(344988), // Rule ID 616 //
     /* 344956 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 344959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 344962 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344969 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344973 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344977 */   // (fminimum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMINSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 344977 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINSrr),
     /* 344982 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344986 */   GIR_RootConstrainSelectedInstOperands,
     /* 344987 */   // GIR_Coverage, 616,
     /* 344987 */   GIR_Done,
     /* 344988 */ // Label 6851: @344988
     /* 344988 */ GIM_Reject,
     /* 344989 */ // Label 6843: @344989
     /* 344989 */ GIM_Try, /*On fail goto*//*Label 6852*/ GIMT_Encode4(345048),
     /* 344994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 344997 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 345000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345004 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345008 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345012 */   GIM_Try, /*On fail goto*//*Label 6853*/ GIMT_Encode4(345031), // Rule ID 618 //
     /* 345017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 345020 */     // (fminimum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMINDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 345020 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINDrr),
     /* 345025 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 345029 */     GIR_RootConstrainSelectedInstOperands,
     /* 345030 */     // GIR_Coverage, 618,
     /* 345030 */     GIR_Done,
     /* 345031 */   // Label 6853: @345031
     /* 345031 */   GIM_Try, /*On fail goto*//*Label 6854*/ GIMT_Encode4(345047), // Rule ID 4873 //
     /* 345036 */     // (fminimum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMINDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 345036 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINDrr),
     /* 345041 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 345045 */     GIR_RootConstrainSelectedInstOperands,
     /* 345046 */     // GIR_Coverage, 4873,
     /* 345046 */     GIR_Done,
     /* 345047 */   // Label 6854: @345047
     /* 345047 */   GIM_Reject,
     /* 345048 */ // Label 6852: @345048
     /* 345048 */ GIM_Reject,
     /* 345049 */ // Label 6844: @345049
     /* 345049 */ GIM_Try, /*On fail goto*//*Label 6855*/ GIMT_Encode4(345151),
     /* 345054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 345057 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 345060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345064 */   GIM_Try, /*On fail goto*//*Label 6856*/ GIMT_Encode4(345123), // Rule ID 2366 //
     /* 345069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 345072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 345080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 345084 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345089 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345093 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 345097 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 345101 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345106 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345108 */     // (fminimum:{ *:[v2f32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FAMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 345108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f32),
     /* 345111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 345113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 345117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 345121 */     GIR_RootConstrainSelectedInstOperands,
     /* 345122 */     // GIR_Coverage, 2366,
     /* 345122 */     GIR_EraseRootFromParent_Done,
     /* 345123 */   // Label 6856: @345123
     /* 345123 */   GIM_Try, /*On fail goto*//*Label 6857*/ GIMT_Encode4(345150), // Rule ID 1288 //
     /* 345128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345139 */     // (fminimum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 345139 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv2f32),
     /* 345144 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 345148 */     GIR_RootConstrainSelectedInstOperands,
     /* 345149 */     // GIR_Coverage, 1288,
     /* 345149 */     GIR_Done,
     /* 345150 */   // Label 6857: @345150
     /* 345150 */   GIM_Reject,
     /* 345151 */ // Label 6855: @345151
     /* 345151 */ GIM_Reject,
     /* 345152 */ // Label 6845: @345152
     /* 345152 */ GIM_Try, /*On fail goto*//*Label 6858*/ GIMT_Encode4(345254),
     /* 345157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 345160 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 345163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345167 */   GIM_Try, /*On fail goto*//*Label 6859*/ GIMT_Encode4(345226), // Rule ID 2372 //
     /* 345172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 345175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 345183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 345187 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345192 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345196 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 345200 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 345204 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345209 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345211 */     // (fminimum:{ *:[v2f64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FAMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 345211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f64),
     /* 345214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 345216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 345220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 345224 */     GIR_RootConstrainSelectedInstOperands,
     /* 345225 */     // GIR_Coverage, 2372,
     /* 345225 */     GIR_EraseRootFromParent_Done,
     /* 345226 */   // Label 6859: @345226
     /* 345226 */   GIM_Try, /*On fail goto*//*Label 6860*/ GIMT_Encode4(345253), // Rule ID 1292 //
     /* 345231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345242 */     // (fminimum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 345242 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv2f64),
     /* 345247 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 345251 */     GIR_RootConstrainSelectedInstOperands,
     /* 345252 */     // GIR_Coverage, 1292,
     /* 345252 */     GIR_Done,
     /* 345253 */   // Label 6860: @345253
     /* 345253 */   GIM_Reject,
     /* 345254 */ // Label 6858: @345254
     /* 345254 */ GIM_Reject,
     /* 345255 */ // Label 6846: @345255
     /* 345255 */ GIM_Try, /*On fail goto*//*Label 6861*/ GIMT_Encode4(345357),
     /* 345260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 345263 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 345266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345270 */   GIM_Try, /*On fail goto*//*Label 6862*/ GIMT_Encode4(345329), // Rule ID 2360 //
     /* 345275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 345278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 345286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 345290 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 345303 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 345307 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345312 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345314 */     // (fminimum:{ *:[v4f16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FAMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 345314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f16),
     /* 345317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 345319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 345323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 345327 */     GIR_RootConstrainSelectedInstOperands,
     /* 345328 */     // GIR_Coverage, 2360,
     /* 345328 */     GIR_EraseRootFromParent_Done,
     /* 345329 */   // Label 6862: @345329
     /* 345329 */   GIM_Try, /*On fail goto*//*Label 6863*/ GIMT_Encode4(345356), // Rule ID 1284 //
     /* 345334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 345337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345345 */     // (fminimum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 345345 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv4f16),
     /* 345350 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 345354 */     GIR_RootConstrainSelectedInstOperands,
     /* 345355 */     // GIR_Coverage, 1284,
     /* 345355 */     GIR_Done,
     /* 345356 */   // Label 6863: @345356
     /* 345356 */   GIM_Reject,
     /* 345357 */ // Label 6861: @345357
     /* 345357 */ GIM_Reject,
     /* 345358 */ // Label 6847: @345358
     /* 345358 */ GIM_Try, /*On fail goto*//*Label 6864*/ GIMT_Encode4(345460),
     /* 345363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 345366 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 345369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345373 */   GIM_Try, /*On fail goto*//*Label 6865*/ GIMT_Encode4(345432), // Rule ID 2369 //
     /* 345378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 345381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 345389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 345393 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345398 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345402 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 345406 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 345410 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345415 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345417 */     // (fminimum:{ *:[v4f32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FAMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 345417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f32),
     /* 345420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 345422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 345426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 345430 */     GIR_RootConstrainSelectedInstOperands,
     /* 345431 */     // GIR_Coverage, 2369,
     /* 345431 */     GIR_EraseRootFromParent_Done,
     /* 345432 */   // Label 6865: @345432
     /* 345432 */   GIM_Try, /*On fail goto*//*Label 6866*/ GIMT_Encode4(345459), // Rule ID 1290 //
     /* 345437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345448 */     // (fminimum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 345448 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv4f32),
     /* 345453 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 345457 */     GIR_RootConstrainSelectedInstOperands,
     /* 345458 */     // GIR_Coverage, 1290,
     /* 345458 */     GIR_Done,
     /* 345459 */   // Label 6866: @345459
     /* 345459 */   GIM_Reject,
     /* 345460 */ // Label 6864: @345460
     /* 345460 */ GIM_Reject,
     /* 345461 */ // Label 6848: @345461
     /* 345461 */ GIM_Try, /*On fail goto*//*Label 6867*/ GIMT_Encode4(345563),
     /* 345466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 345469 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 345472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345476 */   GIM_Try, /*On fail goto*//*Label 6868*/ GIMT_Encode4(345535), // Rule ID 2363 //
     /* 345481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 345484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 345492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 345496 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345501 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345505 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 345509 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 345513 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345518 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345520 */     // (fminimum:{ *:[v8f16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FAMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 345520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv8f16),
     /* 345523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 345525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 345529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 345533 */     GIR_RootConstrainSelectedInstOperands,
     /* 345534 */     // GIR_Coverage, 2363,
     /* 345534 */     GIR_EraseRootFromParent_Done,
     /* 345535 */   // Label 6868: @345535
     /* 345535 */   GIM_Try, /*On fail goto*//*Label 6869*/ GIMT_Encode4(345562), // Rule ID 1286 //
     /* 345540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 345543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345551 */     // (fminimum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 345551 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv8f16),
     /* 345556 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 345560 */     GIR_RootConstrainSelectedInstOperands,
     /* 345561 */     // GIR_Coverage, 1286,
     /* 345561 */     GIR_Done,
     /* 345562 */   // Label 6869: @345562
     /* 345562 */   GIM_Reject,
     /* 345563 */ // Label 6867: @345563
     /* 345563 */ GIM_Reject,
     /* 345564 */ // Label 6849: @345564
     /* 345564 */ GIM_Reject,
     /* 345565 */ // Label 80: @345565
     /* 345565 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6878*/ GIMT_Encode4(346267),
     /* 345576 */ /*GILLT_s16*//*Label 6870*/ GIMT_Encode4(345616),
     /* 345580 */ /*GILLT_s32*//*Label 6871*/ GIMT_Encode4(345654),
     /* 345584 */ /*GILLT_s64*//*Label 6872*/ GIMT_Encode4(345692), GIMT_Encode4(0),
     /* 345592 */ /*GILLT_v2s32*//*Label 6873*/ GIMT_Encode4(345752),
     /* 345596 */ /*GILLT_v2s64*//*Label 6874*/ GIMT_Encode4(345855),
     /* 345600 */ /*GILLT_v4s16*//*Label 6875*/ GIMT_Encode4(345958),
     /* 345604 */ /*GILLT_v4s32*//*Label 6876*/ GIMT_Encode4(346061), GIMT_Encode4(0),
     /* 345612 */ /*GILLT_v8s16*//*Label 6877*/ GIMT_Encode4(346164),
     /* 345616 */ // Label 6870: @345616
     /* 345616 */ GIM_Try, /*On fail goto*//*Label 6879*/ GIMT_Encode4(345653), // Rule ID 602 //
     /* 345621 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 345624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 345627 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 345630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 345634 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 345638 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 345642 */   // (fmaximum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMAXHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 345642 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXHrr),
     /* 345647 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 345651 */   GIR_RootConstrainSelectedInstOperands,
     /* 345652 */   // GIR_Coverage, 602,
     /* 345652 */   GIR_Done,
     /* 345653 */ // Label 6879: @345653
     /* 345653 */ GIM_Reject,
     /* 345654 */ // Label 6871: @345654
     /* 345654 */ GIM_Try, /*On fail goto*//*Label 6880*/ GIMT_Encode4(345691), // Rule ID 604 //
     /* 345659 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 345662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 345665 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 345668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345672 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345676 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345680 */   // (fmaximum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMAXSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 345680 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXSrr),
     /* 345685 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 345689 */   GIR_RootConstrainSelectedInstOperands,
     /* 345690 */   // GIR_Coverage, 604,
     /* 345690 */   GIR_Done,
     /* 345691 */ // Label 6880: @345691
     /* 345691 */ GIM_Reject,
     /* 345692 */ // Label 6872: @345692
     /* 345692 */ GIM_Try, /*On fail goto*//*Label 6881*/ GIMT_Encode4(345751),
     /* 345697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 345700 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 345703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345707 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345711 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345715 */   GIM_Try, /*On fail goto*//*Label 6882*/ GIMT_Encode4(345734), // Rule ID 606 //
     /* 345720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 345723 */     // (fmaximum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMAXDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 345723 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXDrr),
     /* 345728 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 345732 */     GIR_RootConstrainSelectedInstOperands,
     /* 345733 */     // GIR_Coverage, 606,
     /* 345733 */     GIR_Done,
     /* 345734 */   // Label 6882: @345734
     /* 345734 */   GIM_Try, /*On fail goto*//*Label 6883*/ GIMT_Encode4(345750), // Rule ID 4872 //
     /* 345739 */     // (fmaximum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMAXDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 345739 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXDrr),
     /* 345744 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 345748 */     GIR_RootConstrainSelectedInstOperands,
     /* 345749 */     // GIR_Coverage, 4872,
     /* 345749 */     GIR_Done,
     /* 345750 */   // Label 6883: @345750
     /* 345750 */   GIM_Reject,
     /* 345751 */ // Label 6881: @345751
     /* 345751 */ GIM_Reject,
     /* 345752 */ // Label 6873: @345752
     /* 345752 */ GIM_Try, /*On fail goto*//*Label 6884*/ GIMT_Encode4(345854),
     /* 345757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 345760 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 345763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345767 */   GIM_Try, /*On fail goto*//*Label 6885*/ GIMT_Encode4(345826), // Rule ID 2351 //
     /* 345772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 345775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 345783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 345787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345792 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345796 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 345800 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 345804 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345809 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345811 */     // (fmaximum:{ *:[v2f32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FAMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 345811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f32),
     /* 345814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 345816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 345820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 345824 */     GIR_RootConstrainSelectedInstOperands,
     /* 345825 */     // GIR_Coverage, 2351,
     /* 345825 */     GIR_EraseRootFromParent_Done,
     /* 345826 */   // Label 6885: @345826
     /* 345826 */   GIM_Try, /*On fail goto*//*Label 6886*/ GIMT_Encode4(345853), // Rule ID 1258 //
     /* 345831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345842 */     // (fmaximum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 345842 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv2f32),
     /* 345847 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 345851 */     GIR_RootConstrainSelectedInstOperands,
     /* 345852 */     // GIR_Coverage, 1258,
     /* 345852 */     GIR_Done,
     /* 345853 */   // Label 6886: @345853
     /* 345853 */   GIM_Reject,
     /* 345854 */ // Label 6884: @345854
     /* 345854 */ GIM_Reject,
     /* 345855 */ // Label 6874: @345855
     /* 345855 */ GIM_Try, /*On fail goto*//*Label 6887*/ GIMT_Encode4(345957),
     /* 345860 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 345863 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 345866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345870 */   GIM_Try, /*On fail goto*//*Label 6888*/ GIMT_Encode4(345929), // Rule ID 2357 //
     /* 345875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 345878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 345886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 345890 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345895 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345899 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 345903 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 345907 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345912 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345914 */     // (fmaximum:{ *:[v2f64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FAMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 345914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f64),
     /* 345917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 345919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 345923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 345927 */     GIR_RootConstrainSelectedInstOperands,
     /* 345928 */     // GIR_Coverage, 2357,
     /* 345928 */     GIR_EraseRootFromParent_Done,
     /* 345929 */   // Label 6888: @345929
     /* 345929 */   GIM_Try, /*On fail goto*//*Label 6889*/ GIMT_Encode4(345956), // Rule ID 1262 //
     /* 345934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345945 */     // (fmaximum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 345945 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv2f64),
     /* 345950 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 345954 */     GIR_RootConstrainSelectedInstOperands,
     /* 345955 */     // GIR_Coverage, 1262,
     /* 345955 */     GIR_Done,
     /* 345956 */   // Label 6889: @345956
     /* 345956 */   GIM_Reject,
     /* 345957 */ // Label 6887: @345957
     /* 345957 */ GIM_Reject,
     /* 345958 */ // Label 6875: @345958
     /* 345958 */ GIM_Try, /*On fail goto*//*Label 6890*/ GIMT_Encode4(346060),
     /* 345963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 345966 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 345969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345973 */   GIM_Try, /*On fail goto*//*Label 6891*/ GIMT_Encode4(346032), // Rule ID 2345 //
     /* 345978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 345981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 345989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 345993 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 346006 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 346010 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346015 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346017 */     // (fmaximum:{ *:[v4f16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FAMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 346017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f16),
     /* 346020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 346026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 346030 */     GIR_RootConstrainSelectedInstOperands,
     /* 346031 */     // GIR_Coverage, 2345,
     /* 346031 */     GIR_EraseRootFromParent_Done,
     /* 346032 */   // Label 6891: @346032
     /* 346032 */   GIM_Try, /*On fail goto*//*Label 6892*/ GIMT_Encode4(346059), // Rule ID 1254 //
     /* 346037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 346040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346048 */     // (fmaximum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 346048 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv4f16),
     /* 346053 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 346057 */     GIR_RootConstrainSelectedInstOperands,
     /* 346058 */     // GIR_Coverage, 1254,
     /* 346058 */     GIR_Done,
     /* 346059 */   // Label 6892: @346059
     /* 346059 */   GIM_Reject,
     /* 346060 */ // Label 6890: @346060
     /* 346060 */ GIM_Reject,
     /* 346061 */ // Label 6876: @346061
     /* 346061 */ GIM_Try, /*On fail goto*//*Label 6893*/ GIMT_Encode4(346163),
     /* 346066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 346069 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 346072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346076 */   GIM_Try, /*On fail goto*//*Label 6894*/ GIMT_Encode4(346135), // Rule ID 2354 //
     /* 346081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 346084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 346092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 346096 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 346109 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 346113 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346118 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346120 */     // (fmaximum:{ *:[v4f32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FAMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 346120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f32),
     /* 346123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 346129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 346133 */     GIR_RootConstrainSelectedInstOperands,
     /* 346134 */     // GIR_Coverage, 2354,
     /* 346134 */     GIR_EraseRootFromParent_Done,
     /* 346135 */   // Label 6894: @346135
     /* 346135 */   GIM_Try, /*On fail goto*//*Label 6895*/ GIMT_Encode4(346162), // Rule ID 1260 //
     /* 346140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346151 */     // (fmaximum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 346151 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv4f32),
     /* 346156 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 346160 */     GIR_RootConstrainSelectedInstOperands,
     /* 346161 */     // GIR_Coverage, 1260,
     /* 346161 */     GIR_Done,
     /* 346162 */   // Label 6895: @346162
     /* 346162 */   GIM_Reject,
     /* 346163 */ // Label 6893: @346163
     /* 346163 */ GIM_Reject,
     /* 346164 */ // Label 6877: @346164
     /* 346164 */ GIM_Try, /*On fail goto*//*Label 6896*/ GIMT_Encode4(346266),
     /* 346169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 346172 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 346175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346179 */   GIM_Try, /*On fail goto*//*Label 6897*/ GIMT_Encode4(346238), // Rule ID 2348 //
     /* 346184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 346187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 346195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 346199 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346204 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346208 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 346212 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 346216 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346221 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346223 */     // (fmaximum:{ *:[v8f16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FAMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 346223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv8f16),
     /* 346226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 346232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 346236 */     GIR_RootConstrainSelectedInstOperands,
     /* 346237 */     // GIR_Coverage, 2348,
     /* 346237 */     GIR_EraseRootFromParent_Done,
     /* 346238 */   // Label 6897: @346238
     /* 346238 */   GIM_Try, /*On fail goto*//*Label 6898*/ GIMT_Encode4(346265), // Rule ID 1256 //
     /* 346243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 346246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346254 */     // (fmaximum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 346254 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv8f16),
     /* 346259 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 346263 */     GIR_RootConstrainSelectedInstOperands,
     /* 346264 */     // GIR_Coverage, 1256,
     /* 346264 */     GIR_Done,
     /* 346265 */   // Label 6898: @346265
     /* 346265 */   GIM_Reject,
     /* 346266 */ // Label 6896: @346266
     /* 346266 */ GIM_Reject,
     /* 346267 */ // Label 6878: @346267
     /* 346267 */ GIM_Reject,
     /* 346268 */ // Label 81: @346268
     /* 346268 */ GIM_Try, /*On fail goto*//*Label 6899*/ GIMT_Encode4(346767),
     /* 346273 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 346276 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/64,
     /* 346280 */   GIM_Try, /*On fail goto*//*Label 6900*/ GIMT_Encode4(346371), // Rule ID 7064 //
     /* 346285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCPA),
     /* 346288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 346292 */     // MIs[0] Rn
     /* 346292 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 346296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 346300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 346308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 346312 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 346316 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /* 346320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 346324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 346328 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 346332 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 346336 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 346341 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 346345 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346349 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /* 346353 */     // MIs[3] Operand 1
     /* 346353 */     // No operand predicates
     /* 346353 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346355 */     // (ptradd:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (sub:{ *:[i64] } 0:{ *:[i64] }, (shl:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm)))  =>  (SUBPT_shift:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm)
     /* 346355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBPT_shift),
     /* 346358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346360 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 346362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 346366 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /* 346369 */     GIR_RootConstrainSelectedInstOperands,
     /* 346370 */     // GIR_Coverage, 7064,
     /* 346370 */     GIR_EraseRootFromParent_Done,
     /* 346371 */   // Label 6900: @346371
     /* 346371 */   GIM_Try, /*On fail goto*//*Label 6901*/ GIMT_Encode4(346535),
     /* 346376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346380 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 346384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346388 */     GIM_Try, /*On fail goto*//*Label 6902*/ GIMT_Encode4(346461), // Rule ID 15134 //
     /* 346393 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCPA),
     /* 346396 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346400 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 346404 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 346408 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 346412 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 346416 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 346420 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 346424 */       GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 346428 */       GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 0,
     /* 346432 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346437 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346442 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346444 */       // (ptradd:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sub:{ *:[i64] } 0:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64:{ *:[i64] }:$Rn))  =>  (MSUBPT:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /* 346444 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBPT),
     /* 346447 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346449 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 346453 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 346457 */       GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /* 346459 */       GIR_RootConstrainSelectedInstOperands,
     /* 346460 */       // GIR_Coverage, 15134,
     /* 346460 */       GIR_EraseRootFromParent_Done,
     /* 346461 */     // Label 6902: @346461
     /* 346461 */     GIM_Try, /*On fail goto*//*Label 6903*/ GIMT_Encode4(346534), // Rule ID 7066 //
     /* 346466 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCPA),
     /* 346469 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346473 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 346477 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 346481 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 346485 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346490 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 346494 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 346498 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 346502 */       GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 346506 */       GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 0,
     /* 346510 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346515 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346517 */       // (ptradd:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sub:{ *:[i64] } 0:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm)))  =>  (MSUBPT:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /* 346517 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBPT),
     /* 346520 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346522 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 346526 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 346530 */       GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /* 346532 */       GIR_RootConstrainSelectedInstOperands,
     /* 346533 */       // GIR_Coverage, 7066,
     /* 346533 */       GIR_EraseRootFromParent_Done,
     /* 346534 */     // Label 6903: @346534
     /* 346534 */     GIM_Reject,
     /* 346535 */   // Label 6901: @346535
     /* 346535 */   GIM_Try, /*On fail goto*//*Label 6904*/ GIMT_Encode4(346663),
     /* 346540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 346544 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 346548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 346552 */     GIM_Try, /*On fail goto*//*Label 6905*/ GIMT_Encode4(346603), // Rule ID 7063 //
     /* 346557 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCPA),
     /* 346560 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346564 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 346568 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 346572 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 346576 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /* 346580 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 346585 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 346587 */       // (ptradd:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (sub:{ *:[i64] } 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rm))  =>  (SUBPT_shift:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm, 0:{ *:[i64] })
     /* 346587 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBPT_shift),
     /* 346590 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346592 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 346594 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 346598 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346601 */       GIR_RootConstrainSelectedInstOperands,
     /* 346602 */       // GIR_Coverage, 7063,
     /* 346602 */       GIR_EraseRootFromParent_Done,
     /* 346603 */     // Label 6905: @346603
     /* 346603 */     GIM_Try, /*On fail goto*//*Label 6906*/ GIMT_Encode4(346662), // Rule ID 7062 //
     /* 346608 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCPA),
     /* 346611 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346615 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 346619 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 346623 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 346627 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 346632 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 346636 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346640 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /* 346644 */       // MIs[2] Operand 1
     /* 346644 */       // No operand predicates
     /* 346644 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346646 */       // (ptradd:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (shl:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm))  =>  (ADDPT_shift:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm)
     /* 346646 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPT_shift),
     /* 346649 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346651 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 346653 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 346657 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 346660 */       GIR_RootConstrainSelectedInstOperands,
     /* 346661 */       // GIR_Coverage, 7062,
     /* 346661 */       GIR_EraseRootFromParent_Done,
     /* 346662 */     // Label 6906: @346662
     /* 346662 */     GIM_Reject,
     /* 346663 */   // Label 6904: @346663
     /* 346663 */   GIM_Try, /*On fail goto*//*Label 6907*/ GIMT_Encode4(346728), // Rule ID 7065 //
     /* 346668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCPA),
     /* 346671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346675 */     // MIs[0] Ra
     /* 346675 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 346679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 346691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 346695 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 346699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 346711 */     // (ptradd:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm))  =>  (MADDPT:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /* 346711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MADDPT),
     /* 346714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 346720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 346724 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /* 346726 */     GIR_RootConstrainSelectedInstOperands,
     /* 346727 */     // GIR_Coverage, 7065,
     /* 346727 */     GIR_EraseRootFromParent_Done,
     /* 346728 */   // Label 6907: @346728
     /* 346728 */   GIM_Try, /*On fail goto*//*Label 6908*/ GIMT_Encode4(346766), // Rule ID 7061 //
     /* 346733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCPA),
     /* 346736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 346740 */     // MIs[0] Rn
     /* 346740 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 346744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 346748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 346752 */     // (ptradd:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)  =>  (ADDPT_shift:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm, 0:{ *:[i64] })
     /* 346752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPT_shift),
     /* 346755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346757 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 346759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 346761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346764 */     GIR_RootConstrainSelectedInstOperands,
     /* 346765 */     // GIR_Coverage, 7061,
     /* 346765 */     GIR_EraseRootFromParent_Done,
     /* 346766 */   // Label 6908: @346766
     /* 346766 */   GIM_Reject,
     /* 346767 */ // Label 6899: @346767
     /* 346767 */ GIM_Reject,
     /* 346768 */ // Label 82: @346768
     /* 346768 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6917*/ GIMT_Encode4(347171),
     /* 346779 */ /*GILLT_s32*//*Label 6909*/ GIMT_Encode4(346819),
     /* 346783 */ /*GILLT_s64*//*Label 6910*/ GIMT_Encode4(346893), GIMT_Encode4(0),
     /* 346791 */ /*GILLT_v2s32*//*Label 6911*/ GIMT_Encode4(346967), GIMT_Encode4(0),
     /* 346799 */ /*GILLT_v4s16*//*Label 6912*/ GIMT_Encode4(347001),
     /* 346803 */ /*GILLT_v4s32*//*Label 6913*/ GIMT_Encode4(347035),
     /* 346807 */ /*GILLT_v8s8*//*Label 6914*/ GIMT_Encode4(347069),
     /* 346811 */ /*GILLT_v8s16*//*Label 6915*/ GIMT_Encode4(347103),
     /* 346815 */ /*GILLT_v16s8*//*Label 6916*/ GIMT_Encode4(347137),
     /* 346819 */ // Label 6909: @346819
     /* 346819 */ GIM_Try, /*On fail goto*//*Label 6918*/ GIMT_Encode4(346892),
     /* 346824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 346827 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 346830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 346834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 346838 */   GIM_Try, /*On fail goto*//*Label 6919*/ GIMT_Encode4(346872), // Rule ID 2328 //
     /* 346843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 346846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346854 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_32b),
     /* 346858 */     // MIs[1] Operand 1
     /* 346858 */     // No operand predicates
     /* 346858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 346860 */     // (smin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_simm8_32b>>:$imm)  =>  (SMINWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 346860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINWri),
     /* 346863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346865 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 346867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 346870 */     GIR_RootConstrainSelectedInstOperands,
     /* 346871 */     // GIR_Coverage, 2328,
     /* 346871 */     GIR_EraseRootFromParent_Done,
     /* 346872 */   // Label 6919: @346872
     /* 346872 */   GIM_Try, /*On fail goto*//*Label 6920*/ GIMT_Encode4(346891), // Rule ID 2327 //
     /* 346877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 346880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 346884 */     // (smin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SMINWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 346884 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINWrr),
     /* 346889 */     GIR_RootConstrainSelectedInstOperands,
     /* 346890 */     // GIR_Coverage, 2327,
     /* 346890 */     GIR_Done,
     /* 346891 */   // Label 6920: @346891
     /* 346891 */   GIM_Reject,
     /* 346892 */ // Label 6918: @346892
     /* 346892 */ GIM_Reject,
     /* 346893 */ // Label 6910: @346893
     /* 346893 */ GIM_Try, /*On fail goto*//*Label 6921*/ GIMT_Encode4(346966),
     /* 346898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 346901 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 346904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346908 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346912 */   GIM_Try, /*On fail goto*//*Label 6922*/ GIMT_Encode4(346946), // Rule ID 2330 //
     /* 346917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 346920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346928 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_64b),
     /* 346932 */     // MIs[1] Operand 1
     /* 346932 */     // No operand predicates
     /* 346932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 346934 */     // (smin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm8_64b>>:$imm)  =>  (SMINXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 346934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINXri),
     /* 346937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346939 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 346941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 346944 */     GIR_RootConstrainSelectedInstOperands,
     /* 346945 */     // GIR_Coverage, 2330,
     /* 346945 */     GIR_EraseRootFromParent_Done,
     /* 346946 */   // Label 6922: @346946
     /* 346946 */   GIM_Try, /*On fail goto*//*Label 6923*/ GIMT_Encode4(346965), // Rule ID 2329 //
     /* 346951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 346954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346958 */     // (smin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMINXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 346958 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINXrr),
     /* 346963 */     GIR_RootConstrainSelectedInstOperands,
     /* 346964 */     // GIR_Coverage, 2329,
     /* 346964 */     GIR_Done,
     /* 346965 */   // Label 6923: @346965
     /* 346965 */   GIM_Reject,
     /* 346966 */ // Label 6921: @346966
     /* 346966 */ GIM_Reject,
     /* 346967 */ // Label 6911: @346967
     /* 346967 */ GIM_Try, /*On fail goto*//*Label 6924*/ GIMT_Encode4(347000), // Rule ID 1414 //
     /* 346972 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 346978 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 346981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346985 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346989 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346993 */   // (smin:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMINv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 346993 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv2i32),
     /* 346998 */   GIR_RootConstrainSelectedInstOperands,
     /* 346999 */   // GIR_Coverage, 1414,
     /* 346999 */   GIR_Done,
     /* 347000 */ // Label 6924: @347000
     /* 347000 */ GIM_Reject,
     /* 347001 */ // Label 6912: @347001
     /* 347001 */ GIM_Try, /*On fail goto*//*Label 6925*/ GIMT_Encode4(347034), // Rule ID 1412 //
     /* 347006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 347012 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 347015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347019 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347023 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347027 */   // (smin:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMINv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 347027 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv4i16),
     /* 347032 */   GIR_RootConstrainSelectedInstOperands,
     /* 347033 */   // GIR_Coverage, 1412,
     /* 347033 */   GIR_Done,
     /* 347034 */ // Label 6925: @347034
     /* 347034 */ GIM_Reject,
     /* 347035 */ // Label 6913: @347035
     /* 347035 */ GIM_Try, /*On fail goto*//*Label 6926*/ GIMT_Encode4(347068), // Rule ID 1415 //
     /* 347040 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 347046 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 347049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347053 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347057 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347061 */   // (smin:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMINv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 347061 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv4i32),
     /* 347066 */   GIR_RootConstrainSelectedInstOperands,
     /* 347067 */   // GIR_Coverage, 1415,
     /* 347067 */   GIR_Done,
     /* 347068 */ // Label 6926: @347068
     /* 347068 */ GIM_Reject,
     /* 347069 */ // Label 6914: @347069
     /* 347069 */ GIM_Try, /*On fail goto*//*Label 6927*/ GIMT_Encode4(347102), // Rule ID 1410 //
     /* 347074 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347077 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 347080 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 347083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347087 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347091 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347095 */   // (smin:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMINv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 347095 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv8i8),
     /* 347100 */   GIR_RootConstrainSelectedInstOperands,
     /* 347101 */   // GIR_Coverage, 1410,
     /* 347101 */   GIR_Done,
     /* 347102 */ // Label 6927: @347102
     /* 347102 */ GIM_Reject,
     /* 347103 */ // Label 6915: @347103
     /* 347103 */ GIM_Try, /*On fail goto*//*Label 6928*/ GIMT_Encode4(347136), // Rule ID 1413 //
     /* 347108 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 347114 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 347117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347121 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347125 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347129 */   // (smin:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMINv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 347129 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv8i16),
     /* 347134 */   GIR_RootConstrainSelectedInstOperands,
     /* 347135 */   // GIR_Coverage, 1413,
     /* 347135 */   GIR_Done,
     /* 347136 */ // Label 6928: @347136
     /* 347136 */ GIM_Reject,
     /* 347137 */ // Label 6916: @347137
     /* 347137 */ GIM_Try, /*On fail goto*//*Label 6929*/ GIMT_Encode4(347170), // Rule ID 1411 //
     /* 347142 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 347148 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 347151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347155 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347159 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347163 */   // (smin:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMINv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 347163 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv16i8),
     /* 347168 */   GIR_RootConstrainSelectedInstOperands,
     /* 347169 */   // GIR_Coverage, 1411,
     /* 347169 */   GIR_Done,
     /* 347170 */ // Label 6929: @347170
     /* 347170 */ GIM_Reject,
     /* 347171 */ // Label 6917: @347171
     /* 347171 */ GIM_Reject,
     /* 347172 */ // Label 83: @347172
     /* 347172 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6938*/ GIMT_Encode4(347575),
     /* 347183 */ /*GILLT_s32*//*Label 6930*/ GIMT_Encode4(347223),
     /* 347187 */ /*GILLT_s64*//*Label 6931*/ GIMT_Encode4(347297), GIMT_Encode4(0),
     /* 347195 */ /*GILLT_v2s32*//*Label 6932*/ GIMT_Encode4(347371), GIMT_Encode4(0),
     /* 347203 */ /*GILLT_v4s16*//*Label 6933*/ GIMT_Encode4(347405),
     /* 347207 */ /*GILLT_v4s32*//*Label 6934*/ GIMT_Encode4(347439),
     /* 347211 */ /*GILLT_v8s8*//*Label 6935*/ GIMT_Encode4(347473),
     /* 347215 */ /*GILLT_v8s16*//*Label 6936*/ GIMT_Encode4(347507),
     /* 347219 */ /*GILLT_v16s8*//*Label 6937*/ GIMT_Encode4(347541),
     /* 347223 */ // Label 6930: @347223
     /* 347223 */ GIM_Try, /*On fail goto*//*Label 6939*/ GIMT_Encode4(347296),
     /* 347228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 347231 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 347238 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 347242 */   GIM_Try, /*On fail goto*//*Label 6940*/ GIMT_Encode4(347276), // Rule ID 2324 //
     /* 347247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 347250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 347254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 347258 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_32b),
     /* 347262 */     // MIs[1] Operand 1
     /* 347262 */     // No operand predicates
     /* 347262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 347264 */     // (smax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_simm8_32b>>:$imm)  =>  (SMAXWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 347264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXWri),
     /* 347267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 347269 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 347271 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 347274 */     GIR_RootConstrainSelectedInstOperands,
     /* 347275 */     // GIR_Coverage, 2324,
     /* 347275 */     GIR_EraseRootFromParent_Done,
     /* 347276 */   // Label 6940: @347276
     /* 347276 */   GIM_Try, /*On fail goto*//*Label 6941*/ GIMT_Encode4(347295), // Rule ID 2323 //
     /* 347281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 347284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 347288 */     // (smax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SMAXWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 347288 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXWrr),
     /* 347293 */     GIR_RootConstrainSelectedInstOperands,
     /* 347294 */     // GIR_Coverage, 2323,
     /* 347294 */     GIR_Done,
     /* 347295 */   // Label 6941: @347295
     /* 347295 */   GIM_Reject,
     /* 347296 */ // Label 6939: @347296
     /* 347296 */ GIM_Reject,
     /* 347297 */ // Label 6931: @347297
     /* 347297 */ GIM_Try, /*On fail goto*//*Label 6942*/ GIMT_Encode4(347370),
     /* 347302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 347305 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 347308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 347312 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 347316 */   GIM_Try, /*On fail goto*//*Label 6943*/ GIMT_Encode4(347350), // Rule ID 2326 //
     /* 347321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 347324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 347328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 347332 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_64b),
     /* 347336 */     // MIs[1] Operand 1
     /* 347336 */     // No operand predicates
     /* 347336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 347338 */     // (smax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm8_64b>>:$imm)  =>  (SMAXXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 347338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXXri),
     /* 347341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 347343 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 347345 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 347348 */     GIR_RootConstrainSelectedInstOperands,
     /* 347349 */     // GIR_Coverage, 2326,
     /* 347349 */     GIR_EraseRootFromParent_Done,
     /* 347350 */   // Label 6943: @347350
     /* 347350 */   GIM_Try, /*On fail goto*//*Label 6944*/ GIMT_Encode4(347369), // Rule ID 2325 //
     /* 347355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 347358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 347362 */     // (smax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMAXXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 347362 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXXrr),
     /* 347367 */     GIR_RootConstrainSelectedInstOperands,
     /* 347368 */     // GIR_Coverage, 2325,
     /* 347368 */     GIR_Done,
     /* 347369 */   // Label 6944: @347369
     /* 347369 */   GIM_Reject,
     /* 347370 */ // Label 6942: @347370
     /* 347370 */ GIM_Reject,
     /* 347371 */ // Label 6932: @347371
     /* 347371 */ GIM_Try, /*On fail goto*//*Label 6945*/ GIMT_Encode4(347404), // Rule ID 1402 //
     /* 347376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 347382 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 347385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347389 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347393 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347397 */   // (smax:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMAXv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 347397 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv2i32),
     /* 347402 */   GIR_RootConstrainSelectedInstOperands,
     /* 347403 */   // GIR_Coverage, 1402,
     /* 347403 */   GIR_Done,
     /* 347404 */ // Label 6945: @347404
     /* 347404 */ GIM_Reject,
     /* 347405 */ // Label 6933: @347405
     /* 347405 */ GIM_Try, /*On fail goto*//*Label 6946*/ GIMT_Encode4(347438), // Rule ID 1400 //
     /* 347410 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 347416 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 347419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347423 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347427 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347431 */   // (smax:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMAXv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 347431 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv4i16),
     /* 347436 */   GIR_RootConstrainSelectedInstOperands,
     /* 347437 */   // GIR_Coverage, 1400,
     /* 347437 */   GIR_Done,
     /* 347438 */ // Label 6946: @347438
     /* 347438 */ GIM_Reject,
     /* 347439 */ // Label 6934: @347439
     /* 347439 */ GIM_Try, /*On fail goto*//*Label 6947*/ GIMT_Encode4(347472), // Rule ID 1403 //
     /* 347444 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 347450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 347453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347457 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347461 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347465 */   // (smax:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMAXv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 347465 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv4i32),
     /* 347470 */   GIR_RootConstrainSelectedInstOperands,
     /* 347471 */   // GIR_Coverage, 1403,
     /* 347471 */   GIR_Done,
     /* 347472 */ // Label 6947: @347472
     /* 347472 */ GIM_Reject,
     /* 347473 */ // Label 6935: @347473
     /* 347473 */ GIM_Try, /*On fail goto*//*Label 6948*/ GIMT_Encode4(347506), // Rule ID 1398 //
     /* 347478 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 347484 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 347487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347491 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347495 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347499 */   // (smax:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMAXv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 347499 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv8i8),
     /* 347504 */   GIR_RootConstrainSelectedInstOperands,
     /* 347505 */   // GIR_Coverage, 1398,
     /* 347505 */   GIR_Done,
     /* 347506 */ // Label 6948: @347506
     /* 347506 */ GIM_Reject,
     /* 347507 */ // Label 6936: @347507
     /* 347507 */ GIM_Try, /*On fail goto*//*Label 6949*/ GIMT_Encode4(347540), // Rule ID 1401 //
     /* 347512 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 347518 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 347521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347525 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347529 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347533 */   // (smax:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMAXv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 347533 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv8i16),
     /* 347538 */   GIR_RootConstrainSelectedInstOperands,
     /* 347539 */   // GIR_Coverage, 1401,
     /* 347539 */   GIR_Done,
     /* 347540 */ // Label 6949: @347540
     /* 347540 */ GIM_Reject,
     /* 347541 */ // Label 6937: @347541
     /* 347541 */ GIM_Try, /*On fail goto*//*Label 6950*/ GIMT_Encode4(347574), // Rule ID 1399 //
     /* 347546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 347552 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 347555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347559 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347563 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347567 */   // (smax:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMAXv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 347567 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv16i8),
     /* 347572 */   GIR_RootConstrainSelectedInstOperands,
     /* 347573 */   // GIR_Coverage, 1399,
     /* 347573 */   GIR_Done,
     /* 347574 */ // Label 6950: @347574
     /* 347574 */ GIM_Reject,
     /* 347575 */ // Label 6938: @347575
     /* 347575 */ GIM_Reject,
     /* 347576 */ // Label 84: @347576
     /* 347576 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6959*/ GIMT_Encode4(347979),
     /* 347587 */ /*GILLT_s32*//*Label 6951*/ GIMT_Encode4(347627),
     /* 347591 */ /*GILLT_s64*//*Label 6952*/ GIMT_Encode4(347701), GIMT_Encode4(0),
     /* 347599 */ /*GILLT_v2s32*//*Label 6953*/ GIMT_Encode4(347775), GIMT_Encode4(0),
     /* 347607 */ /*GILLT_v4s16*//*Label 6954*/ GIMT_Encode4(347809),
     /* 347611 */ /*GILLT_v4s32*//*Label 6955*/ GIMT_Encode4(347843),
     /* 347615 */ /*GILLT_v8s8*//*Label 6956*/ GIMT_Encode4(347877),
     /* 347619 */ /*GILLT_v8s16*//*Label 6957*/ GIMT_Encode4(347911),
     /* 347623 */ /*GILLT_v16s8*//*Label 6958*/ GIMT_Encode4(347945),
     /* 347627 */ // Label 6951: @347627
     /* 347627 */ GIM_Try, /*On fail goto*//*Label 6960*/ GIMT_Encode4(347700),
     /* 347632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 347635 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 347642 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 347646 */   GIM_Try, /*On fail goto*//*Label 6961*/ GIMT_Encode4(347680), // Rule ID 2336 //
     /* 347651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 347654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 347658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 347662 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_32b),
     /* 347666 */     // MIs[1] Operand 1
     /* 347666 */     // No operand predicates
     /* 347666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 347668 */     // (umin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_uimm8_32b>>:$imm)  =>  (UMINWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 347668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINWri),
     /* 347671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 347673 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 347675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 347678 */     GIR_RootConstrainSelectedInstOperands,
     /* 347679 */     // GIR_Coverage, 2336,
     /* 347679 */     GIR_EraseRootFromParent_Done,
     /* 347680 */   // Label 6961: @347680
     /* 347680 */   GIM_Try, /*On fail goto*//*Label 6962*/ GIMT_Encode4(347699), // Rule ID 2335 //
     /* 347685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 347688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 347692 */     // (umin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UMINWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 347692 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINWrr),
     /* 347697 */     GIR_RootConstrainSelectedInstOperands,
     /* 347698 */     // GIR_Coverage, 2335,
     /* 347698 */     GIR_Done,
     /* 347699 */   // Label 6962: @347699
     /* 347699 */   GIM_Reject,
     /* 347700 */ // Label 6960: @347700
     /* 347700 */ GIM_Reject,
     /* 347701 */ // Label 6952: @347701
     /* 347701 */ GIM_Try, /*On fail goto*//*Label 6963*/ GIMT_Encode4(347774),
     /* 347706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 347709 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 347712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 347716 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 347720 */   GIM_Try, /*On fail goto*//*Label 6964*/ GIMT_Encode4(347754), // Rule ID 2338 //
     /* 347725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 347728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 347732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 347736 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_64b),
     /* 347740 */     // MIs[1] Operand 1
     /* 347740 */     // No operand predicates
     /* 347740 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 347742 */     // (umin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_uimm8_64b>>:$imm)  =>  (UMINXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 347742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINXri),
     /* 347745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 347747 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 347749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 347752 */     GIR_RootConstrainSelectedInstOperands,
     /* 347753 */     // GIR_Coverage, 2338,
     /* 347753 */     GIR_EraseRootFromParent_Done,
     /* 347754 */   // Label 6964: @347754
     /* 347754 */   GIM_Try, /*On fail goto*//*Label 6965*/ GIMT_Encode4(347773), // Rule ID 2337 //
     /* 347759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 347762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 347766 */     // (umin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMINXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 347766 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINXrr),
     /* 347771 */     GIR_RootConstrainSelectedInstOperands,
     /* 347772 */     // GIR_Coverage, 2337,
     /* 347772 */     GIR_Done,
     /* 347773 */   // Label 6965: @347773
     /* 347773 */   GIM_Reject,
     /* 347774 */ // Label 6963: @347774
     /* 347774 */ GIM_Reject,
     /* 347775 */ // Label 6953: @347775
     /* 347775 */ GIM_Try, /*On fail goto*//*Label 6966*/ GIMT_Encode4(347808), // Rule ID 1537 //
     /* 347780 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 347786 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 347789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347793 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347797 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347801 */   // (umin:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMINv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 347801 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv2i32),
     /* 347806 */   GIR_RootConstrainSelectedInstOperands,
     /* 347807 */   // GIR_Coverage, 1537,
     /* 347807 */   GIR_Done,
     /* 347808 */ // Label 6966: @347808
     /* 347808 */ GIM_Reject,
     /* 347809 */ // Label 6954: @347809
     /* 347809 */ GIM_Try, /*On fail goto*//*Label 6967*/ GIMT_Encode4(347842), // Rule ID 1535 //
     /* 347814 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 347820 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 347823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347827 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347831 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347835 */   // (umin:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMINv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 347835 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv4i16),
     /* 347840 */   GIR_RootConstrainSelectedInstOperands,
     /* 347841 */   // GIR_Coverage, 1535,
     /* 347841 */   GIR_Done,
     /* 347842 */ // Label 6967: @347842
     /* 347842 */ GIM_Reject,
     /* 347843 */ // Label 6955: @347843
     /* 347843 */ GIM_Try, /*On fail goto*//*Label 6968*/ GIMT_Encode4(347876), // Rule ID 1538 //
     /* 347848 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 347854 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 347857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347865 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347869 */   // (umin:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMINv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 347869 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv4i32),
     /* 347874 */   GIR_RootConstrainSelectedInstOperands,
     /* 347875 */   // GIR_Coverage, 1538,
     /* 347875 */   GIR_Done,
     /* 347876 */ // Label 6968: @347876
     /* 347876 */ GIM_Reject,
     /* 347877 */ // Label 6956: @347877
     /* 347877 */ GIM_Try, /*On fail goto*//*Label 6969*/ GIMT_Encode4(347910), // Rule ID 1533 //
     /* 347882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 347888 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 347891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347895 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347899 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347903 */   // (umin:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMINv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 347903 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv8i8),
     /* 347908 */   GIR_RootConstrainSelectedInstOperands,
     /* 347909 */   // GIR_Coverage, 1533,
     /* 347909 */   GIR_Done,
     /* 347910 */ // Label 6969: @347910
     /* 347910 */ GIM_Reject,
     /* 347911 */ // Label 6957: @347911
     /* 347911 */ GIM_Try, /*On fail goto*//*Label 6970*/ GIMT_Encode4(347944), // Rule ID 1536 //
     /* 347916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 347922 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 347925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347933 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347937 */   // (umin:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMINv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 347937 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv8i16),
     /* 347942 */   GIR_RootConstrainSelectedInstOperands,
     /* 347943 */   // GIR_Coverage, 1536,
     /* 347943 */   GIR_Done,
     /* 347944 */ // Label 6970: @347944
     /* 347944 */ GIM_Reject,
     /* 347945 */ // Label 6958: @347945
     /* 347945 */ GIM_Try, /*On fail goto*//*Label 6971*/ GIMT_Encode4(347978), // Rule ID 1534 //
     /* 347950 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 347956 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 347959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347963 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347967 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347971 */   // (umin:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMINv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 347971 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv16i8),
     /* 347976 */   GIR_RootConstrainSelectedInstOperands,
     /* 347977 */   // GIR_Coverage, 1534,
     /* 347977 */   GIR_Done,
     /* 347978 */ // Label 6971: @347978
     /* 347978 */ GIM_Reject,
     /* 347979 */ // Label 6959: @347979
     /* 347979 */ GIM_Reject,
     /* 347980 */ // Label 85: @347980
     /* 347980 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6980*/ GIMT_Encode4(348383),
     /* 347991 */ /*GILLT_s32*//*Label 6972*/ GIMT_Encode4(348031),
     /* 347995 */ /*GILLT_s64*//*Label 6973*/ GIMT_Encode4(348105), GIMT_Encode4(0),
     /* 348003 */ /*GILLT_v2s32*//*Label 6974*/ GIMT_Encode4(348179), GIMT_Encode4(0),
     /* 348011 */ /*GILLT_v4s16*//*Label 6975*/ GIMT_Encode4(348213),
     /* 348015 */ /*GILLT_v4s32*//*Label 6976*/ GIMT_Encode4(348247),
     /* 348019 */ /*GILLT_v8s8*//*Label 6977*/ GIMT_Encode4(348281),
     /* 348023 */ /*GILLT_v8s16*//*Label 6978*/ GIMT_Encode4(348315),
     /* 348027 */ /*GILLT_v16s8*//*Label 6979*/ GIMT_Encode4(348349),
     /* 348031 */ // Label 6972: @348031
     /* 348031 */ GIM_Try, /*On fail goto*//*Label 6981*/ GIMT_Encode4(348104),
     /* 348036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 348039 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 348042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 348046 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 348050 */   GIM_Try, /*On fail goto*//*Label 6982*/ GIMT_Encode4(348084), // Rule ID 2332 //
     /* 348055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 348058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 348062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 348066 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_32b),
     /* 348070 */     // MIs[1] Operand 1
     /* 348070 */     // No operand predicates
     /* 348070 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 348072 */     // (umax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_uimm8_32b>>:$imm)  =>  (UMAXWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 348072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXWri),
     /* 348075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 348077 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 348079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 348082 */     GIR_RootConstrainSelectedInstOperands,
     /* 348083 */     // GIR_Coverage, 2332,
     /* 348083 */     GIR_EraseRootFromParent_Done,
     /* 348084 */   // Label 6982: @348084
     /* 348084 */   GIM_Try, /*On fail goto*//*Label 6983*/ GIMT_Encode4(348103), // Rule ID 2331 //
     /* 348089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 348092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 348096 */     // (umax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UMAXWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 348096 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXWrr),
     /* 348101 */     GIR_RootConstrainSelectedInstOperands,
     /* 348102 */     // GIR_Coverage, 2331,
     /* 348102 */     GIR_Done,
     /* 348103 */   // Label 6983: @348103
     /* 348103 */   GIM_Reject,
     /* 348104 */ // Label 6981: @348104
     /* 348104 */ GIM_Reject,
     /* 348105 */ // Label 6973: @348105
     /* 348105 */ GIM_Try, /*On fail goto*//*Label 6984*/ GIMT_Encode4(348178),
     /* 348110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 348113 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 348116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 348120 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 348124 */   GIM_Try, /*On fail goto*//*Label 6985*/ GIMT_Encode4(348158), // Rule ID 2334 //
     /* 348129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 348132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 348136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 348140 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_64b),
     /* 348144 */     // MIs[1] Operand 1
     /* 348144 */     // No operand predicates
     /* 348144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 348146 */     // (umax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_uimm8_64b>>:$imm)  =>  (UMAXXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 348146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXXri),
     /* 348149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 348151 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 348153 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 348156 */     GIR_RootConstrainSelectedInstOperands,
     /* 348157 */     // GIR_Coverage, 2334,
     /* 348157 */     GIR_EraseRootFromParent_Done,
     /* 348158 */   // Label 6985: @348158
     /* 348158 */   GIM_Try, /*On fail goto*//*Label 6986*/ GIMT_Encode4(348177), // Rule ID 2333 //
     /* 348163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 348166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 348170 */     // (umax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMAXXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 348170 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXXrr),
     /* 348175 */     GIR_RootConstrainSelectedInstOperands,
     /* 348176 */     // GIR_Coverage, 2333,
     /* 348176 */     GIR_Done,
     /* 348177 */   // Label 6986: @348177
     /* 348177 */   GIM_Reject,
     /* 348178 */ // Label 6984: @348178
     /* 348178 */ GIM_Reject,
     /* 348179 */ // Label 6974: @348179
     /* 348179 */ GIM_Try, /*On fail goto*//*Label 6987*/ GIMT_Encode4(348212), // Rule ID 1525 //
     /* 348184 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 348187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 348190 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 348193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348197 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348201 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348205 */   // (umax:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMAXv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 348205 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv2i32),
     /* 348210 */   GIR_RootConstrainSelectedInstOperands,
     /* 348211 */   // GIR_Coverage, 1525,
     /* 348211 */   GIR_Done,
     /* 348212 */ // Label 6987: @348212
     /* 348212 */ GIM_Reject,
     /* 348213 */ // Label 6975: @348213
     /* 348213 */ GIM_Try, /*On fail goto*//*Label 6988*/ GIMT_Encode4(348246), // Rule ID 1523 //
     /* 348218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 348221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 348224 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 348227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348231 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348235 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348239 */   // (umax:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMAXv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 348239 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv4i16),
     /* 348244 */   GIR_RootConstrainSelectedInstOperands,
     /* 348245 */   // GIR_Coverage, 1523,
     /* 348245 */   GIR_Done,
     /* 348246 */ // Label 6988: @348246
     /* 348246 */ GIM_Reject,
     /* 348247 */ // Label 6976: @348247
     /* 348247 */ GIM_Try, /*On fail goto*//*Label 6989*/ GIMT_Encode4(348280), // Rule ID 1526 //
     /* 348252 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 348255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 348258 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 348261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348265 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348269 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348273 */   // (umax:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMAXv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 348273 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv4i32),
     /* 348278 */   GIR_RootConstrainSelectedInstOperands,
     /* 348279 */   // GIR_Coverage, 1526,
     /* 348279 */   GIR_Done,
     /* 348280 */ // Label 6989: @348280
     /* 348280 */ GIM_Reject,
     /* 348281 */ // Label 6977: @348281
     /* 348281 */ GIM_Try, /*On fail goto*//*Label 6990*/ GIMT_Encode4(348314), // Rule ID 1521 //
     /* 348286 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 348289 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 348292 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 348295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348299 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348303 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348307 */   // (umax:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMAXv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 348307 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv8i8),
     /* 348312 */   GIR_RootConstrainSelectedInstOperands,
     /* 348313 */   // GIR_Coverage, 1521,
     /* 348313 */   GIR_Done,
     /* 348314 */ // Label 6990: @348314
     /* 348314 */ GIM_Reject,
     /* 348315 */ // Label 6978: @348315
     /* 348315 */ GIM_Try, /*On fail goto*//*Label 6991*/ GIMT_Encode4(348348), // Rule ID 1524 //
     /* 348320 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 348323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 348326 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 348329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348333 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348337 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348341 */   // (umax:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMAXv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 348341 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv8i16),
     /* 348346 */   GIR_RootConstrainSelectedInstOperands,
     /* 348347 */   // GIR_Coverage, 1524,
     /* 348347 */   GIR_Done,
     /* 348348 */ // Label 6991: @348348
     /* 348348 */ GIM_Reject,
     /* 348349 */ // Label 6979: @348349
     /* 348349 */ GIM_Try, /*On fail goto*//*Label 6992*/ GIMT_Encode4(348382), // Rule ID 1522 //
     /* 348354 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 348357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 348360 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 348363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348367 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348371 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348375 */   // (umax:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMAXv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 348375 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv16i8),
     /* 348380 */   GIR_RootConstrainSelectedInstOperands,
     /* 348381 */   // GIR_Coverage, 1522,
     /* 348381 */   GIR_Done,
     /* 348382 */ // Label 6992: @348382
     /* 348382 */ GIM_Reject,
     /* 348383 */ // Label 6980: @348383
     /* 348383 */ GIM_Reject,
     /* 348384 */ // Label 86: @348384
     /* 348384 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7002*/ GIMT_Encode4(349198),
     /* 348395 */ /*GILLT_s32*//*Label 6993*/ GIMT_Encode4(348435),
     /* 348399 */ /*GILLT_s64*//*Label 6994*/ GIMT_Encode4(348462), GIMT_Encode4(0),
     /* 348407 */ /*GILLT_v2s32*//*Label 6995*/ GIMT_Encode4(348541),
     /* 348411 */ /*GILLT_v2s64*//*Label 6996*/ GIMT_Encode4(348568),
     /* 348415 */ /*GILLT_v4s16*//*Label 6997*/ GIMT_Encode4(348751),
     /* 348419 */ /*GILLT_v4s32*//*Label 6998*/ GIMT_Encode4(348778),
     /* 348423 */ /*GILLT_v8s8*//*Label 6999*/ GIMT_Encode4(348961),
     /* 348427 */ /*GILLT_v8s16*//*Label 7000*/ GIMT_Encode4(348988),
     /* 348431 */ /*GILLT_v16s8*//*Label 7001*/ GIMT_Encode4(349171),
     /* 348435 */ // Label 6993: @348435
     /* 348435 */ GIM_Try, /*On fail goto*//*Label 7003*/ GIMT_Encode4(348461), // Rule ID 2317 //
     /* 348440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 348443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 348446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 348450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 348454 */   // (abs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (ABSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 348454 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSWr),
     /* 348459 */   GIR_RootConstrainSelectedInstOperands,
     /* 348460 */   // GIR_Coverage, 2317,
     /* 348460 */   GIR_Done,
     /* 348461 */ // Label 7003: @348461
     /* 348461 */ GIM_Reject,
     /* 348462 */ // Label 6994: @348462
     /* 348462 */ GIM_Try, /*On fail goto*//*Label 7004*/ GIMT_Encode4(348540),
     /* 348467 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 348470 */   GIM_Try, /*On fail goto*//*Label 7005*/ GIMT_Encode4(348493), // Rule ID 1652 //
     /* 348475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 348478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348486 */     // (abs:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)  =>  (ABSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 348486 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv1i64),
     /* 348491 */     GIR_RootConstrainSelectedInstOperands,
     /* 348492 */     // GIR_Coverage, 1652,
     /* 348492 */     GIR_Done,
     /* 348493 */   // Label 7005: @348493
     /* 348493 */   GIM_Try, /*On fail goto*//*Label 7006*/ GIMT_Encode4(348516), // Rule ID 2318 //
     /* 348498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 348501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 348505 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 348509 */     // (abs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (ABSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 348509 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSXr),
     /* 348514 */     GIR_RootConstrainSelectedInstOperands,
     /* 348515 */     // GIR_Coverage, 2318,
     /* 348515 */     GIR_Done,
     /* 348516 */   // Label 7006: @348516
     /* 348516 */   GIM_Try, /*On fail goto*//*Label 7007*/ GIMT_Encode4(348539), // Rule ID 2510 //
     /* 348521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoCSSC),
     /* 348524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348532 */     // (abs:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)  =>  (ABSv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 348532 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv1i64),
     /* 348537 */     GIR_RootConstrainSelectedInstOperands,
     /* 348538 */     // GIR_Coverage, 2510,
     /* 348538 */     GIR_Done,
     /* 348539 */   // Label 7007: @348539
     /* 348539 */   GIM_Reject,
     /* 348540 */ // Label 7004: @348540
     /* 348540 */ GIM_Reject,
     /* 348541 */ // Label 6995: @348541
     /* 348541 */ GIM_Try, /*On fail goto*//*Label 7008*/ GIMT_Encode4(348567), // Rule ID 707 //
     /* 348546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 348549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 348552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348556 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348560 */   // (abs:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (ABSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 348560 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv2i32),
     /* 348565 */   GIR_RootConstrainSelectedInstOperands,
     /* 348566 */   // GIR_Coverage, 707,
     /* 348566 */   GIR_Done,
     /* 348567 */ // Label 7008: @348567
     /* 348567 */ GIM_Reject,
     /* 348568 */ // Label 6996: @348568
     /* 348568 */ GIM_Try, /*On fail goto*//*Label 7009*/ GIMT_Encode4(348750),
     /* 348573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 348576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348580 */   GIM_Try, /*On fail goto*//*Label 7010*/ GIMT_Encode4(348658), // Rule ID 4950 //
     /* 348585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 348593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 348597 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 348601 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 348605 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 348609 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 348613 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 348617 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 348621 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 348625 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 348627 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 348634 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 348641 */     // (abs:{ *:[v2i64] } (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$opA)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$opB))))  =>  (UABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$opA, V128:{ *:[v4i32] }:$opB)
     /* 348641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i32_v2i64),
     /* 348644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 348646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 348651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 348656 */     GIR_RootConstrainSelectedInstOperands,
     /* 348657 */     // GIR_Coverage, 4950,
     /* 348657 */     GIR_EraseRootFromParent_Done,
     /* 348658 */   // Label 7010: @348658
     /* 348658 */   GIM_Try, /*On fail goto*//*Label 7011*/ GIMT_Encode4(348730), // Rule ID 4949 //
     /* 348663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 348671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 348675 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 348679 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 348683 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 348687 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 348691 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348696 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 348700 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 348704 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 348708 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348713 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 348715 */     // (abs:{ *:[v2i64] } (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$opA), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$opB)))  =>  (UABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$opA, V64:{ *:[v2i32] }:$opB)
     /* 348715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv2i32_v2i64),
     /* 348718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 348720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 348724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 348728 */     GIR_RootConstrainSelectedInstOperands,
     /* 348729 */     // GIR_Coverage, 4949,
     /* 348729 */     GIR_EraseRootFromParent_Done,
     /* 348730 */   // Label 7011: @348730
     /* 348730 */   GIM_Try, /*On fail goto*//*Label 7012*/ GIMT_Encode4(348749), // Rule ID 709 //
     /* 348735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 348738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348742 */     // (abs:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)  =>  (ABSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 348742 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv2i64),
     /* 348747 */     GIR_RootConstrainSelectedInstOperands,
     /* 348748 */     // GIR_Coverage, 709,
     /* 348748 */     GIR_Done,
     /* 348749 */   // Label 7012: @348749
     /* 348749 */   GIM_Reject,
     /* 348750 */ // Label 7009: @348750
     /* 348750 */ GIM_Reject,
     /* 348751 */ // Label 6997: @348751
     /* 348751 */ GIM_Try, /*On fail goto*//*Label 7013*/ GIMT_Encode4(348777), // Rule ID 705 //
     /* 348756 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 348759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 348762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348766 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348770 */   // (abs:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (ABSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 348770 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv4i16),
     /* 348775 */   GIR_RootConstrainSelectedInstOperands,
     /* 348776 */   // GIR_Coverage, 705,
     /* 348776 */   GIR_Done,
     /* 348777 */ // Label 7013: @348777
     /* 348777 */ GIM_Reject,
     /* 348778 */ // Label 6998: @348778
     /* 348778 */ GIM_Try, /*On fail goto*//*Label 7014*/ GIMT_Encode4(348960),
     /* 348783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 348786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348790 */   GIM_Try, /*On fail goto*//*Label 7015*/ GIMT_Encode4(348868), // Rule ID 4948 //
     /* 348795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 348803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 348807 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 348811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 348815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 348819 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 348823 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 348827 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 348831 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 348835 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 348837 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 348844 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 348851 */     // (abs:{ *:[v4i32] } (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$opA)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$opB))))  =>  (UABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$opA, V128:{ *:[v8i16] }:$opB)
     /* 348851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i16_v4i32),
     /* 348854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 348856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 348861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 348866 */     GIR_RootConstrainSelectedInstOperands,
     /* 348867 */     // GIR_Coverage, 4948,
     /* 348867 */     GIR_EraseRootFromParent_Done,
     /* 348868 */   // Label 7015: @348868
     /* 348868 */   GIM_Try, /*On fail goto*//*Label 7016*/ GIMT_Encode4(348940), // Rule ID 4947 //
     /* 348873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 348881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 348885 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 348889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 348893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 348897 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 348901 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348906 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 348910 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 348914 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 348918 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348923 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 348925 */     // (abs:{ *:[v4i32] } (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$opA), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$opB)))  =>  (UABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$opA, V64:{ *:[v4i16] }:$opB)
     /* 348925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i16_v4i32),
     /* 348928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 348930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 348934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 348938 */     GIR_RootConstrainSelectedInstOperands,
     /* 348939 */     // GIR_Coverage, 4947,
     /* 348939 */     GIR_EraseRootFromParent_Done,
     /* 348940 */   // Label 7016: @348940
     /* 348940 */   GIM_Try, /*On fail goto*//*Label 7017*/ GIMT_Encode4(348959), // Rule ID 708 //
     /* 348945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 348948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348952 */     // (abs:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (ABSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 348952 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv4i32),
     /* 348957 */     GIR_RootConstrainSelectedInstOperands,
     /* 348958 */     // GIR_Coverage, 708,
     /* 348958 */     GIR_Done,
     /* 348959 */   // Label 7017: @348959
     /* 348959 */   GIM_Reject,
     /* 348960 */ // Label 7014: @348960
     /* 348960 */ GIM_Reject,
     /* 348961 */ // Label 6999: @348961
     /* 348961 */ GIM_Try, /*On fail goto*//*Label 7018*/ GIMT_Encode4(348987), // Rule ID 703 //
     /* 348966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 348969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 348972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348980 */   // (abs:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (ABSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 348980 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv8i8),
     /* 348985 */   GIR_RootConstrainSelectedInstOperands,
     /* 348986 */   // GIR_Coverage, 703,
     /* 348986 */   GIR_Done,
     /* 348987 */ // Label 7018: @348987
     /* 348987 */ GIM_Reject,
     /* 348988 */ // Label 7000: @348988
     /* 348988 */ GIM_Try, /*On fail goto*//*Label 7019*/ GIMT_Encode4(349170),
     /* 348993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 348996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349000 */   GIM_Try, /*On fail goto*//*Label 7020*/ GIMT_Encode4(349078), // Rule ID 4946 //
     /* 349005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 349013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 349017 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 349021 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 349025 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 349029 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 349033 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 349037 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 349041 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 349045 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 349047 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 349054 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 349061 */     // (abs:{ *:[v8i16] } (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$opA)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$opB))))  =>  (UABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$opA, V128:{ *:[v16i8] }:$opB)
     /* 349061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv16i8_v8i16),
     /* 349064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 349066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 349071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 349076 */     GIR_RootConstrainSelectedInstOperands,
     /* 349077 */     // GIR_Coverage, 4946,
     /* 349077 */     GIR_EraseRootFromParent_Done,
     /* 349078 */   // Label 7020: @349078
     /* 349078 */   GIM_Try, /*On fail goto*//*Label 7021*/ GIMT_Encode4(349150), // Rule ID 4945 //
     /* 349083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 349091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 349095 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 349099 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 349103 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 349107 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 349111 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349116 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 349120 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 349124 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 349128 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349133 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 349135 */     // (abs:{ *:[v8i16] } (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$opA), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$opB)))  =>  (UABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$opA, V64:{ *:[v8i8] }:$opB)
     /* 349135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i8_v8i16),
     /* 349138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 349140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 349144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 349148 */     GIR_RootConstrainSelectedInstOperands,
     /* 349149 */     // GIR_Coverage, 4945,
     /* 349149 */     GIR_EraseRootFromParent_Done,
     /* 349150 */   // Label 7021: @349150
     /* 349150 */   GIM_Try, /*On fail goto*//*Label 7022*/ GIMT_Encode4(349169), // Rule ID 706 //
     /* 349155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 349158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349162 */     // (abs:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (ABSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 349162 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv8i16),
     /* 349167 */     GIR_RootConstrainSelectedInstOperands,
     /* 349168 */     // GIR_Coverage, 706,
     /* 349168 */     GIR_Done,
     /* 349169 */   // Label 7022: @349169
     /* 349169 */   GIM_Reject,
     /* 349170 */ // Label 7019: @349170
     /* 349170 */ GIM_Reject,
     /* 349171 */ // Label 7001: @349171
     /* 349171 */ GIM_Try, /*On fail goto*//*Label 7023*/ GIMT_Encode4(349197), // Rule ID 704 //
     /* 349176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 349179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 349182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349186 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349190 */   // (abs:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (ABSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 349190 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv16i8),
     /* 349195 */   GIR_RootConstrainSelectedInstOperands,
     /* 349196 */   // GIR_Coverage, 704,
     /* 349196 */   GIR_Done,
     /* 349197 */ // Label 7023: @349197
     /* 349197 */ GIM_Reject,
     /* 349198 */ // Label 7002: @349198
     /* 349198 */ GIM_Reject,
     /* 349199 */ // Label 87: @349199
     /* 349199 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 7026*/ GIMT_Encode4(349364),
     /* 349210 */ /*GILLT_s32*//*Label 7024*/ GIMT_Encode4(349218),
     /* 349214 */ /*GILLT_s64*//*Label 7025*/ GIMT_Encode4(349291),
     /* 349218 */ // Label 7024: @349218
     /* 349218 */ GIM_Try, /*On fail goto*//*Label 7027*/ GIMT_Encode4(349244), // Rule ID 4791 //
     /* 349223 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 349226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 349229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 349233 */   // (lround:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 349233 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWHr),
     /* 349238 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 349242 */   GIR_RootConstrainSelectedInstOperands,
     /* 349243 */   // GIR_Coverage, 4791,
     /* 349243 */   GIR_Done,
     /* 349244 */ // Label 7027: @349244
     /* 349244 */ GIM_Try, /*On fail goto*//*Label 7028*/ GIMT_Encode4(349267), // Rule ID 4797 //
     /* 349249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 349252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 349256 */   // (lround:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 349256 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 349261 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 349265 */   GIR_RootConstrainSelectedInstOperands,
     /* 349266 */   // GIR_Coverage, 4797,
     /* 349266 */   GIR_Done,
     /* 349267 */ // Label 7028: @349267
     /* 349267 */ GIM_Try, /*On fail goto*//*Label 7029*/ GIMT_Encode4(349290), // Rule ID 4799 //
     /* 349272 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 349275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 349279 */   // (lround:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 349279 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 349284 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 349288 */   GIR_RootConstrainSelectedInstOperands,
     /* 349289 */   // GIR_Coverage, 4799,
     /* 349289 */   GIR_Done,
     /* 349290 */ // Label 7029: @349290
     /* 349290 */ GIM_Reject,
     /* 349291 */ // Label 7025: @349291
     /* 349291 */ GIM_Try, /*On fail goto*//*Label 7030*/ GIMT_Encode4(349317), // Rule ID 4793 //
     /* 349296 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 349299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 349302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 349306 */   // (lround:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 349306 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 349311 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 349315 */   GIR_RootConstrainSelectedInstOperands,
     /* 349316 */   // GIR_Coverage, 4793,
     /* 349316 */   GIR_Done,
     /* 349317 */ // Label 7030: @349317
     /* 349317 */ GIM_Try, /*On fail goto*//*Label 7031*/ GIMT_Encode4(349340), // Rule ID 4801 //
     /* 349322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 349325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 349329 */   // (lround:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 349329 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 349334 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 349338 */   GIR_RootConstrainSelectedInstOperands,
     /* 349339 */   // GIR_Coverage, 4801,
     /* 349339 */   GIR_Done,
     /* 349340 */ // Label 7031: @349340
     /* 349340 */ GIM_Try, /*On fail goto*//*Label 7032*/ GIMT_Encode4(349363), // Rule ID 4803 //
     /* 349345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 349348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 349352 */   // (lround:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 349352 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 349357 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 349361 */   GIR_RootConstrainSelectedInstOperands,
     /* 349362 */   // GIR_Coverage, 4803,
     /* 349362 */   GIR_Done,
     /* 349363 */ // Label 7032: @349363
     /* 349363 */ GIM_Reject,
     /* 349364 */ // Label 7026: @349364
     /* 349364 */ GIM_Reject,
     /* 349365 */ // Label 88: @349365
     /* 349365 */ GIM_Try, /*On fail goto*//*Label 7033*/ GIMT_Encode4(349463),
     /* 349370 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 349373 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7037*/ GIMT_Encode4(349462),
     /* 349384 */   /*GILLT_s16*//*Label 7034*/ GIMT_Encode4(349396),
     /* 349388 */   /*GILLT_s32*//*Label 7035*/ GIMT_Encode4(349420),
     /* 349392 */   /*GILLT_s64*//*Label 7036*/ GIMT_Encode4(349441),
     /* 349396 */   // Label 7034: @349396
     /* 349396 */   GIM_Try, /*On fail goto*//*Label 7038*/ GIMT_Encode4(349419), // Rule ID 4795 //
     /* 349401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 349404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 349408 */     // (llround:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 349408 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 349413 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 349417 */     GIR_RootConstrainSelectedInstOperands,
     /* 349418 */     // GIR_Coverage, 4795,
     /* 349418 */     GIR_Done,
     /* 349419 */   // Label 7038: @349419
     /* 349419 */   GIM_Reject,
     /* 349420 */   // Label 7035: @349420
     /* 349420 */   GIM_Try, /*On fail goto*//*Label 7039*/ GIMT_Encode4(349440), // Rule ID 4805 //
     /* 349425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 349429 */     // (llround:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 349429 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 349434 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 349438 */     GIR_RootConstrainSelectedInstOperands,
     /* 349439 */     // GIR_Coverage, 4805,
     /* 349439 */     GIR_Done,
     /* 349440 */   // Label 7039: @349440
     /* 349440 */   GIM_Reject,
     /* 349441 */   // Label 7036: @349441
     /* 349441 */   GIM_Try, /*On fail goto*//*Label 7040*/ GIMT_Encode4(349461), // Rule ID 4807 //
     /* 349446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 349450 */     // (llround:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 349450 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 349455 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 349459 */     GIR_RootConstrainSelectedInstOperands,
     /* 349460 */     // GIR_Coverage, 4807,
     /* 349460 */     GIR_Done,
     /* 349461 */   // Label 7040: @349461
     /* 349461 */   GIM_Reject,
     /* 349462 */   // Label 7037: @349462
     /* 349462 */   GIM_Reject,
     /* 349463 */ // Label 7033: @349463
     /* 349463 */ GIM_Reject,
     /* 349464 */ // Label 89: @349464
     /* 349464 */ GIM_Try, /*On fail goto*//*Label 7041*/ GIMT_Encode4(349479), // Rule ID 225 //
     /* 349469 */   // MIs[0] addr
     /* 349469 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 349472 */   // (br (bb:{ *:[Other] }):$addr)  =>  (B (bb:{ *:[Other] }):$addr)
     /* 349472 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::B),
     /* 349477 */   GIR_RootConstrainSelectedInstOperands,
     /* 349478 */   // GIR_Coverage, 225,
     /* 349478 */   GIR_Done,
     /* 349479 */ // Label 7041: @349479
     /* 349479 */ GIM_Reject,
     /* 349480 */ // Label 90: @349480
     /* 349480 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(21), /*)*//*default:*//*Label 7053*/ GIMT_Encode4(354851),
     /* 349491 */ /*GILLT_s64*//*Label 7042*/ GIMT_Encode4(349563), GIMT_Encode4(0),
     /* 349499 */ /*GILLT_v2s32*//*Label 7043*/ GIMT_Encode4(349965), GIMT_Encode4(0),
     /* 349507 */ /*GILLT_v4s16*//*Label 7044*/ GIMT_Encode4(350367), GIMT_Encode4(0),
     /* 349515 */ /*GILLT_v8s8*//*Label 7045*/ GIMT_Encode4(350769), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 349527 */ /*GILLT_nxv1s1*//*Label 7046*/ GIMT_Encode4(350949),
     /* 349531 */ /*GILLT_nxv2s1*//*Label 7047*/ GIMT_Encode4(353212),
     /* 349535 */ /*GILLT_nxv2s16*//*Label 7048*/ GIMT_Encode4(354067),
     /* 349539 */ /*GILLT_nxv2s32*//*Label 7049*/ GIMT_Encode4(354354), GIMT_Encode4(0),
     /* 349547 */ /*GILLT_nxv4s1*//*Label 7050*/ GIMT_Encode4(354424),
     /* 349551 */ /*GILLT_nxv4s16*//*Label 7051*/ GIMT_Encode4(354711), GIMT_Encode4(0),
     /* 349559 */ /*GILLT_nxv8s1*//*Label 7052*/ GIMT_Encode4(354781),
     /* 349563 */ // Label 7042: @349563
     /* 349563 */ GIM_Try, /*On fail goto*//*Label 7054*/ GIMT_Encode4(349964),
     /* 349568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 349571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349575 */   GIM_Try, /*On fail goto*//*Label 7055*/ GIMT_Encode4(349627), // Rule ID 5620 //
     /* 349580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 349588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 349592 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 349594 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349599 */     // MIs[0] Operand 2
     /* 349599 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 349610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 349612 */     // (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Vn)<<P:Predicate_anyext_oneuse>>, 0:{ *:[i64] })  =>  (ZIP1v2i32:{ *:[v1i64] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vn)
     /* 349612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 349615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 349617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 349621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 349625 */     GIR_RootConstrainSelectedInstOperands,
     /* 349626 */     // GIR_Coverage, 5620,
     /* 349626 */     GIR_EraseRootFromParent_Done,
     /* 349627 */   // Label 7055: @349627
     /* 349627 */   GIM_Try, /*On fail goto*//*Label 7056*/ GIMT_Encode4(349679), // Rule ID 5623 //
     /* 349632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 349640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 349644 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 349646 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349651 */     // MIs[0] Operand 2
     /* 349651 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 349662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 349664 */     // (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Vn)<<P:Predicate_anyext_oneuse>>, 1:{ *:[i64] })  =>  (ZIP2v2i32:{ *:[v1i64] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vn)
     /* 349664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 349667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 349669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 349673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 349677 */     GIR_RootConstrainSelectedInstOperands,
     /* 349678 */     // GIR_Coverage, 5623,
     /* 349678 */     GIR_EraseRootFromParent_Done,
     /* 349679 */   // Label 7056: @349679
     /* 349679 */   GIM_Try, /*On fail goto*//*Label 7057*/ GIMT_Encode4(349747), // Rule ID 5499 //
     /* 349684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349688 */     // MIs[0] Operand 2
     /* 349688 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 349699 */     // (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 349699 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 349702 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 349706 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349711 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 349715 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 349719 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 349722 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349729 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 349736 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349741 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349746 */     // GIR_Coverage, 5499,
     /* 349746 */     GIR_EraseRootFromParent_Done,
     /* 349747 */   // Label 7057: @349747
     /* 349747 */   GIM_Try, /*On fail goto*//*Label 7058*/ GIMT_Encode4(349815), // Rule ID 5504 //
     /* 349752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349756 */     // MIs[0] Operand 2
     /* 349756 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 349767 */     // (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 349767 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 349770 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 349774 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349779 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 349783 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 349787 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 349790 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349797 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 349804 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349809 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349814 */     // GIR_Coverage, 5504,
     /* 349814 */     GIR_EraseRootFromParent_Done,
     /* 349815 */   // Label 7058: @349815
     /* 349815 */   GIM_Try, /*On fail goto*//*Label 7059*/ GIMT_Encode4(349857), // Rule ID 6961 //
     /* 349820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349824 */     // MIs[0] Operand 2
     /* 349824 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 349835 */     // (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] })
     /* 349835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349840 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 349846 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349851 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349856 */     // GIR_Coverage, 6961,
     /* 349856 */     GIR_EraseRootFromParent_Done,
     /* 349857 */   // Label 7059: @349857
     /* 349857 */   GIM_Try, /*On fail goto*//*Label 7060*/ GIMT_Encode4(349899), // Rule ID 6962 //
     /* 349862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349866 */     // MIs[0] Operand 2
     /* 349866 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 349877 */     // (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] })
     /* 349877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349882 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 349888 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349893 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349898 */     // GIR_Coverage, 6962,
     /* 349898 */     GIR_EraseRootFromParent_Done,
     /* 349899 */   // Label 7060: @349899
     /* 349899 */   GIM_Try, /*On fail goto*//*Label 7061*/ GIMT_Encode4(349963), // Rule ID 6966 //
     /* 349904 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349908 */     // MIs[0] Operand 2
     /* 349908 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 349919 */     // (extract_subvector:{ *:[v1i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 349919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 349922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 349926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349931 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 349935 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 349938 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349945 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 349952 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349957 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349962 */     // GIR_Coverage, 6966,
     /* 349962 */     GIR_EraseRootFromParent_Done,
     /* 349963 */   // Label 7061: @349963
     /* 349963 */   GIM_Reject,
     /* 349964 */ // Label 7054: @349964
     /* 349964 */ GIM_Reject,
     /* 349965 */ // Label 7043: @349965
     /* 349965 */ GIM_Try, /*On fail goto*//*Label 7062*/ GIMT_Encode4(350366),
     /* 349970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 349973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349977 */   GIM_Try, /*On fail goto*//*Label 7063*/ GIMT_Encode4(350029), // Rule ID 5619 //
     /* 349982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 349990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 349994 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 349996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350001 */     // MIs[0] Operand 2
     /* 350001 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 350012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 350014 */     // (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Vn)<<P:Predicate_anyext_oneuse>>, 0:{ *:[i64] })  =>  (ZIP1v4i16:{ *:[v2i32] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vn)
     /* 350014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 350017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 350019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 350023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 350027 */     GIR_RootConstrainSelectedInstOperands,
     /* 350028 */     // GIR_Coverage, 5619,
     /* 350028 */     GIR_EraseRootFromParent_Done,
     /* 350029 */   // Label 7063: @350029
     /* 350029 */   GIM_Try, /*On fail goto*//*Label 7064*/ GIMT_Encode4(350081), // Rule ID 5622 //
     /* 350034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 350042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 350046 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 350048 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350053 */     // MIs[0] Operand 2
     /* 350053 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 350064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 350066 */     // (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Vn)<<P:Predicate_anyext_oneuse>>, 2:{ *:[i64] })  =>  (ZIP2v4i16:{ *:[v2i32] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vn)
     /* 350066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 350069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 350071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 350075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 350079 */     GIR_RootConstrainSelectedInstOperands,
     /* 350080 */     // GIR_Coverage, 5622,
     /* 350080 */     GIR_EraseRootFromParent_Done,
     /* 350081 */   // Label 7064: @350081
     /* 350081 */   GIM_Try, /*On fail goto*//*Label 7065*/ GIMT_Encode4(350149), // Rule ID 5489 //
     /* 350086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350090 */     // MIs[0] Operand 2
     /* 350090 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 350101 */     // (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 350101 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 350104 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 350108 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350113 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 350117 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 350121 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 350124 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350131 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 350138 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350143 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350148 */     // GIR_Coverage, 5489,
     /* 350148 */     GIR_EraseRootFromParent_Done,
     /* 350149 */   // Label 7065: @350149
     /* 350149 */   GIM_Try, /*On fail goto*//*Label 7066*/ GIMT_Encode4(350217), // Rule ID 5494 //
     /* 350154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350158 */     // MIs[0] Operand 2
     /* 350158 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 350169 */     // (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 350169 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 350172 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 350176 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350181 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 350185 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 350189 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 350192 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350199 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 350206 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350211 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350216 */     // GIR_Coverage, 5494,
     /* 350216 */     GIR_EraseRootFromParent_Done,
     /* 350217 */   // Label 7066: @350217
     /* 350217 */   GIM_Try, /*On fail goto*//*Label 7067*/ GIMT_Encode4(350259), // Rule ID 6958 //
     /* 350222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350226 */     // MIs[0] Operand 2
     /* 350226 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 350237 */     // (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] })
     /* 350237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350242 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 350248 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350253 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350258 */     // GIR_Coverage, 6958,
     /* 350258 */     GIR_EraseRootFromParent_Done,
     /* 350259 */   // Label 7067: @350259
     /* 350259 */   GIM_Try, /*On fail goto*//*Label 7068*/ GIMT_Encode4(350301), // Rule ID 6960 //
     /* 350264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350268 */     // MIs[0] Operand 2
     /* 350268 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 350279 */     // (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] })
     /* 350279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350284 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 350290 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350295 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350300 */     // GIR_Coverage, 6960,
     /* 350300 */     GIR_EraseRootFromParent_Done,
     /* 350301 */   // Label 7068: @350301
     /* 350301 */   GIM_Try, /*On fail goto*//*Label 7069*/ GIMT_Encode4(350365), // Rule ID 6965 //
     /* 350306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350310 */     // MIs[0] Operand 2
     /* 350310 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 350321 */     // (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 350321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 350324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 350328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350333 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 350337 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 350340 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350347 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 350354 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350359 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350364 */     // GIR_Coverage, 6965,
     /* 350364 */     GIR_EraseRootFromParent_Done,
     /* 350365 */   // Label 7069: @350365
     /* 350365 */   GIM_Reject,
     /* 350366 */ // Label 7062: @350366
     /* 350366 */ GIM_Reject,
     /* 350367 */ // Label 7044: @350367
     /* 350367 */ GIM_Try, /*On fail goto*//*Label 7070*/ GIMT_Encode4(350768),
     /* 350372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 350375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350379 */   GIM_Try, /*On fail goto*//*Label 7071*/ GIMT_Encode4(350431), // Rule ID 5618 //
     /* 350384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 350392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 350396 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 350398 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350403 */     // MIs[0] Operand 2
     /* 350403 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 350414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 350416 */     // (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Vn)<<P:Predicate_anyext_oneuse>>, 0:{ *:[i64] })  =>  (ZIP1v8i8:{ *:[v4i16] } V64:{ *:[v8i8] }:$Vn, V64:{ *:[v8i8] }:$Vn)
     /* 350416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i8),
     /* 350419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 350421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 350425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 350429 */     GIR_RootConstrainSelectedInstOperands,
     /* 350430 */     // GIR_Coverage, 5618,
     /* 350430 */     GIR_EraseRootFromParent_Done,
     /* 350431 */   // Label 7071: @350431
     /* 350431 */   GIM_Try, /*On fail goto*//*Label 7072*/ GIMT_Encode4(350483), // Rule ID 5621 //
     /* 350436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 350444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 350448 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 350450 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350455 */     // MIs[0] Operand 2
     /* 350455 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 350466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 350468 */     // (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Vn)<<P:Predicate_anyext_oneuse>>, 4:{ *:[i64] })  =>  (ZIP2v8i8:{ *:[v4i16] } V64:{ *:[v8i8] }:$Vn, V64:{ *:[v8i8] }:$Vn)
     /* 350468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i8),
     /* 350471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 350473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 350477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 350481 */     GIR_RootConstrainSelectedInstOperands,
     /* 350482 */     // GIR_Coverage, 5621,
     /* 350482 */     GIR_EraseRootFromParent_Done,
     /* 350483 */   // Label 7072: @350483
     /* 350483 */   GIM_Try, /*On fail goto*//*Label 7073*/ GIMT_Encode4(350551), // Rule ID 5479 //
     /* 350488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350492 */     // MIs[0] Operand 2
     /* 350492 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 350503 */     // (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 350503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 350506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 350510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350515 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 350519 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 350523 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 350526 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350533 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 350540 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350545 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350550 */     // GIR_Coverage, 5479,
     /* 350550 */     GIR_EraseRootFromParent_Done,
     /* 350551 */   // Label 7073: @350551
     /* 350551 */   GIM_Try, /*On fail goto*//*Label 7074*/ GIMT_Encode4(350619), // Rule ID 5484 //
     /* 350556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350560 */     // MIs[0] Operand 2
     /* 350560 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 350571 */     // (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 350571 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 350574 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 350578 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350583 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 350587 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 350591 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 350594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350601 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 350608 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350613 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350618 */     // GIR_Coverage, 5484,
     /* 350618 */     GIR_EraseRootFromParent_Done,
     /* 350619 */   // Label 7074: @350619
     /* 350619 */   GIM_Try, /*On fail goto*//*Label 7075*/ GIMT_Encode4(350661), // Rule ID 6956 //
     /* 350624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350628 */     // MIs[0] Operand 2
     /* 350628 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 350639 */     // (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] })
     /* 350639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350644 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 350650 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350655 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350660 */     // GIR_Coverage, 6956,
     /* 350660 */     GIR_EraseRootFromParent_Done,
     /* 350661 */   // Label 7075: @350661
     /* 350661 */   GIM_Try, /*On fail goto*//*Label 7076*/ GIMT_Encode4(350703), // Rule ID 6959 //
     /* 350666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350670 */     // MIs[0] Operand 2
     /* 350670 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 350681 */     // (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })
     /* 350681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350686 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 350692 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350697 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350702 */     // GIR_Coverage, 6959,
     /* 350702 */     GIR_EraseRootFromParent_Done,
     /* 350703 */   // Label 7076: @350703
     /* 350703 */   GIM_Try, /*On fail goto*//*Label 7077*/ GIMT_Encode4(350767), // Rule ID 6964 //
     /* 350708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350712 */     // MIs[0] Operand 2
     /* 350712 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 350723 */     // (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 350723 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 350726 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 350730 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350735 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 350739 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 350742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350749 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 350756 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350761 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350766 */     // GIR_Coverage, 6964,
     /* 350766 */     GIR_EraseRootFromParent_Done,
     /* 350767 */   // Label 7077: @350767
     /* 350767 */   GIM_Reject,
     /* 350768 */ // Label 7070: @350768
     /* 350768 */ GIM_Reject,
     /* 350769 */ // Label 7045: @350769
     /* 350769 */ GIM_Try, /*On fail goto*//*Label 7078*/ GIMT_Encode4(350948),
     /* 350774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 350777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350785 */   GIM_Try, /*On fail goto*//*Label 7079*/ GIMT_Encode4(350849), // Rule ID 5474 //
     /* 350790 */     // MIs[0] Operand 2
     /* 350790 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 350801 */     // (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (EXTv16i8:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 350801 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 350804 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 350808 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350813 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 350817 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 350821 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 350824 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350831 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 350838 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350843 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350848 */     // GIR_Coverage, 5474,
     /* 350848 */     GIR_EraseRootFromParent_Done,
     /* 350849 */   // Label 7079: @350849
     /* 350849 */   GIM_Try, /*On fail goto*//*Label 7080*/ GIMT_Encode4(350887), // Rule ID 6957 //
     /* 350854 */     // MIs[0] Operand 2
     /* 350854 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 350865 */     // (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] })
     /* 350865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350870 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 350876 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350881 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350886 */     // GIR_Coverage, 6957,
     /* 350886 */     GIR_EraseRootFromParent_Done,
     /* 350887 */   // Label 7080: @350887
     /* 350887 */   GIM_Try, /*On fail goto*//*Label 7081*/ GIMT_Encode4(350947), // Rule ID 6963 //
     /* 350892 */     // MIs[0] Operand 2
     /* 350892 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 350903 */     // (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 350903 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 350906 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 350910 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350915 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 350919 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 350922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350929 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 350936 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350941 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350946 */     // GIR_Coverage, 6963,
     /* 350946 */     GIR_EraseRootFromParent_Done,
     /* 350947 */   // Label 7081: @350947
     /* 350947 */   GIM_Reject,
     /* 350948 */ // Label 7078: @350948
     /* 350948 */ GIM_Reject,
     /* 350949 */ // Label 7046: @350949
     /* 350949 */ GIM_Try, /*On fail goto*//*Label 7082*/ GIMT_Encode4(350984), // Rule ID 9086 //
     /* 350954 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 350960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350964 */   // MIs[0] Operand 2
     /* 350964 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 350975 */   // (extract_subvector:{ *:[nxv1i1] } nxv2i1:{ *:[nxv2i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv2i1] }:$Ps)
     /* 350975 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350978 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350980 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 350982 */   GIR_RootConstrainSelectedInstOperands,
     /* 350983 */   // GIR_Coverage, 9086,
     /* 350983 */   GIR_EraseRootFromParent_Done,
     /* 350984 */ // Label 7082: @350984
     /* 350984 */ GIM_Try, /*On fail goto*//*Label 7083*/ GIMT_Encode4(351019), // Rule ID 9087 //
     /* 350989 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 350995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350999 */   // MIs[0] Operand 2
     /* 350999 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 351010 */   // (extract_subvector:{ *:[nxv1i1] } nxv2i1:{ *:[nxv2i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv2i1] }:$Ps)
     /* 351010 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351013 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351015 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 351017 */   GIR_RootConstrainSelectedInstOperands,
     /* 351018 */   // GIR_Coverage, 9087,
     /* 351018 */   GIR_EraseRootFromParent_Done,
     /* 351019 */ // Label 7083: @351019
     /* 351019 */ GIM_Try, /*On fail goto*//*Label 7084*/ GIMT_Encode4(351073), // Rule ID 9094 //
     /* 351024 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 351030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351034 */   // MIs[0] Operand 2
     /* 351034 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 351045 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 351045 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351048 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351052 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351057 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351061 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351063 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351066 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351068 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351071 */   GIR_RootConstrainSelectedInstOperands,
     /* 351072 */   // GIR_Coverage, 9094,
     /* 351072 */   GIR_EraseRootFromParent_Done,
     /* 351073 */ // Label 7084: @351073
     /* 351073 */ GIM_Try, /*On fail goto*//*Label 7085*/ GIMT_Encode4(351127), // Rule ID 9095 //
     /* 351078 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 351084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351088 */   // MIs[0] Operand 2
     /* 351088 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 351099 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 351099 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351102 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351106 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351111 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351115 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351117 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351120 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351122 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351125 */   GIR_RootConstrainSelectedInstOperands,
     /* 351126 */   // GIR_Coverage, 9095,
     /* 351126 */   GIR_EraseRootFromParent_Done,
     /* 351127 */ // Label 7085: @351127
     /* 351127 */ GIM_Try, /*On fail goto*//*Label 7086*/ GIMT_Encode4(351181), // Rule ID 9096 //
     /* 351132 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 351138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351142 */   // MIs[0] Operand 2
     /* 351142 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 351153 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 351153 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351156 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351160 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351165 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351169 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351171 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351174 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351176 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351179 */   GIR_RootConstrainSelectedInstOperands,
     /* 351180 */   // GIR_Coverage, 9096,
     /* 351180 */   GIR_EraseRootFromParent_Done,
     /* 351181 */ // Label 7086: @351181
     /* 351181 */ GIM_Try, /*On fail goto*//*Label 7087*/ GIMT_Encode4(351235), // Rule ID 9097 //
     /* 351186 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 351192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351196 */   // MIs[0] Operand 2
     /* 351196 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 351207 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 351207 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351210 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351214 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351219 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351223 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351225 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351228 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351230 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351233 */   GIR_RootConstrainSelectedInstOperands,
     /* 351234 */   // GIR_Coverage, 9097,
     /* 351234 */   GIR_EraseRootFromParent_Done,
     /* 351235 */ // Label 7087: @351235
     /* 351235 */ GIM_Try, /*On fail goto*//*Label 7088*/ GIMT_Encode4(351306), // Rule ID 9106 //
     /* 351240 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 351246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351250 */   // MIs[0] Operand 2
     /* 351250 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 351261 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 351261 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351264 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351268 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351273 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351277 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351279 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351282 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351286 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351291 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351294 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351296 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351299 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351301 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351304 */   GIR_RootConstrainSelectedInstOperands,
     /* 351305 */   // GIR_Coverage, 9106,
     /* 351305 */   GIR_EraseRootFromParent_Done,
     /* 351306 */ // Label 7088: @351306
     /* 351306 */ GIM_Try, /*On fail goto*//*Label 7089*/ GIMT_Encode4(351377), // Rule ID 9107 //
     /* 351311 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 351317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351321 */   // MIs[0] Operand 2
     /* 351321 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 351332 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 351332 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351335 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351339 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351344 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351348 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351350 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351353 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351357 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351362 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351365 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351367 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351370 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351372 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351375 */   GIR_RootConstrainSelectedInstOperands,
     /* 351376 */   // GIR_Coverage, 9107,
     /* 351376 */   GIR_EraseRootFromParent_Done,
     /* 351377 */ // Label 7089: @351377
     /* 351377 */ GIM_Try, /*On fail goto*//*Label 7090*/ GIMT_Encode4(351448), // Rule ID 9108 //
     /* 351382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 351388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351392 */   // MIs[0] Operand 2
     /* 351392 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 351403 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 351403 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351406 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351410 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351415 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351419 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351421 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351424 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351428 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351433 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351436 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351438 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351441 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351443 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351446 */   GIR_RootConstrainSelectedInstOperands,
     /* 351447 */   // GIR_Coverage, 9108,
     /* 351447 */   GIR_EraseRootFromParent_Done,
     /* 351448 */ // Label 7090: @351448
     /* 351448 */ GIM_Try, /*On fail goto*//*Label 7091*/ GIMT_Encode4(351519), // Rule ID 9109 //
     /* 351453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 351459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351463 */   // MIs[0] Operand 2
     /* 351463 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 351474 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 351474 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351477 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351481 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351486 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351490 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351492 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351495 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351499 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351504 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351507 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351509 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351512 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351514 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351517 */   GIR_RootConstrainSelectedInstOperands,
     /* 351518 */   // GIR_Coverage, 9109,
     /* 351518 */   GIR_EraseRootFromParent_Done,
     /* 351519 */ // Label 7091: @351519
     /* 351519 */ GIM_Try, /*On fail goto*//*Label 7092*/ GIMT_Encode4(351590), // Rule ID 9110 //
     /* 351524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 351530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351534 */   // MIs[0] Operand 2
     /* 351534 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 351545 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 351545 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351548 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351552 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351557 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351561 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351563 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351566 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351570 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351575 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351578 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351583 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351585 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351588 */   GIR_RootConstrainSelectedInstOperands,
     /* 351589 */   // GIR_Coverage, 9110,
     /* 351589 */   GIR_EraseRootFromParent_Done,
     /* 351590 */ // Label 7092: @351590
     /* 351590 */ GIM_Try, /*On fail goto*//*Label 7093*/ GIMT_Encode4(351661), // Rule ID 9111 //
     /* 351595 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 351601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351605 */   // MIs[0] Operand 2
     /* 351605 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(5),
     /* 351616 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 5:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 351616 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351619 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351623 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351628 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351632 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351634 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351637 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351641 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351646 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351649 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351651 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351654 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351656 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351659 */   GIR_RootConstrainSelectedInstOperands,
     /* 351660 */   // GIR_Coverage, 9111,
     /* 351660 */   GIR_EraseRootFromParent_Done,
     /* 351661 */ // Label 7093: @351661
     /* 351661 */ GIM_Try, /*On fail goto*//*Label 7094*/ GIMT_Encode4(351732), // Rule ID 9112 //
     /* 351666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 351672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351676 */   // MIs[0] Operand 2
     /* 351676 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 351687 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 351687 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351690 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351694 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351699 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351703 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351705 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351708 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351712 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351717 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351720 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351725 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351727 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351730 */   GIR_RootConstrainSelectedInstOperands,
     /* 351731 */   // GIR_Coverage, 9112,
     /* 351731 */   GIR_EraseRootFromParent_Done,
     /* 351732 */ // Label 7094: @351732
     /* 351732 */ GIM_Try, /*On fail goto*//*Label 7095*/ GIMT_Encode4(351803), // Rule ID 9113 //
     /* 351737 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 351743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351747 */   // MIs[0] Operand 2
     /* 351747 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 351758 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 7:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 351758 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351761 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351765 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351770 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351774 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351776 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351779 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351783 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351788 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351791 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351793 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351796 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351798 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351801 */   GIR_RootConstrainSelectedInstOperands,
     /* 351802 */   // GIR_Coverage, 9113,
     /* 351802 */   GIR_EraseRootFromParent_Done,
     /* 351803 */ // Label 7095: @351803
     /* 351803 */ GIM_Try, /*On fail goto*//*Label 7096*/ GIMT_Encode4(351891), // Rule ID 9122 //
     /* 351808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351818 */   // MIs[0] Operand 2
     /* 351818 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 351829 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 351829 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 351832 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351836 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351841 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351845 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 351847 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351850 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351854 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351859 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 351862 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351864 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351867 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351871 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351876 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351879 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351881 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351884 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351886 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351889 */   GIR_RootConstrainSelectedInstOperands,
     /* 351890 */   // GIR_Coverage, 9122,
     /* 351890 */   GIR_EraseRootFromParent_Done,
     /* 351891 */ // Label 7096: @351891
     /* 351891 */ GIM_Try, /*On fail goto*//*Label 7097*/ GIMT_Encode4(351979), // Rule ID 9123 //
     /* 351896 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351906 */   // MIs[0] Operand 2
     /* 351906 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 351917 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 351917 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 351920 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351924 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351929 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351933 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 351935 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351938 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351942 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351947 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 351950 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351952 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351955 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351959 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351964 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351967 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351969 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351972 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351974 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351977 */   GIR_RootConstrainSelectedInstOperands,
     /* 351978 */   // GIR_Coverage, 9123,
     /* 351978 */   GIR_EraseRootFromParent_Done,
     /* 351979 */ // Label 7097: @351979
     /* 351979 */ GIM_Try, /*On fail goto*//*Label 7098*/ GIMT_Encode4(352067), // Rule ID 9124 //
     /* 351984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351994 */   // MIs[0] Operand 2
     /* 351994 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 352005 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 352005 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 352008 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352012 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352017 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352021 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 352023 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 352026 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352030 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352035 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 352038 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 352040 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352043 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352047 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352052 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352055 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352057 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352060 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352062 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352065 */   GIR_RootConstrainSelectedInstOperands,
     /* 352066 */   // GIR_Coverage, 9124,
     /* 352066 */   GIR_EraseRootFromParent_Done,
     /* 352067 */ // Label 7098: @352067
     /* 352067 */ GIM_Try, /*On fail goto*//*Label 7099*/ GIMT_Encode4(352155), // Rule ID 9125 //
     /* 352072 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352082 */   // MIs[0] Operand 2
     /* 352082 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 352093 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 352093 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 352096 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352100 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352105 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352109 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 352111 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 352114 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352118 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352123 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 352126 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 352128 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352131 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352135 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352140 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352143 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352145 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352148 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352150 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352153 */   GIR_RootConstrainSelectedInstOperands,
     /* 352154 */   // GIR_Coverage, 9125,
     /* 352154 */   GIR_EraseRootFromParent_Done,
     /* 352155 */ // Label 7099: @352155
     /* 352155 */ GIM_Try, /*On fail goto*//*Label 7100*/ GIMT_Encode4(352243), // Rule ID 9126 //
     /* 352160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352170 */   // MIs[0] Operand 2
     /* 352170 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 352181 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 352181 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 352184 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352188 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352193 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352197 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 352199 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 352202 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352206 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352211 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 352214 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 352216 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352219 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352223 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352228 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352231 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352233 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352236 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352238 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352241 */   GIR_RootConstrainSelectedInstOperands,
     /* 352242 */   // GIR_Coverage, 9126,
     /* 352242 */   GIR_EraseRootFromParent_Done,
     /* 352243 */ // Label 7100: @352243
     /* 352243 */ GIM_Try, /*On fail goto*//*Label 7101*/ GIMT_Encode4(352331), // Rule ID 9127 //
     /* 352248 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352258 */   // MIs[0] Operand 2
     /* 352258 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(5),
     /* 352269 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 5:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 352269 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 352272 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352276 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352281 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352285 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 352287 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 352290 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352294 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352299 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 352302 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 352304 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352307 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352311 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352316 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352319 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352321 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352324 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352326 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352329 */   GIR_RootConstrainSelectedInstOperands,
     /* 352330 */   // GIR_Coverage, 9127,
     /* 352330 */   GIR_EraseRootFromParent_Done,
     /* 352331 */ // Label 7101: @352331
     /* 352331 */ GIM_Try, /*On fail goto*//*Label 7102*/ GIMT_Encode4(352419), // Rule ID 9128 //
     /* 352336 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352339 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352346 */   // MIs[0] Operand 2
     /* 352346 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 352357 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 352357 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 352360 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352364 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352369 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352373 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 352375 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 352378 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352382 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352387 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 352390 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 352392 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352395 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352399 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352404 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352407 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352409 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352412 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352414 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352417 */   GIR_RootConstrainSelectedInstOperands,
     /* 352418 */   // GIR_Coverage, 9128,
     /* 352418 */   GIR_EraseRootFromParent_Done,
     /* 352419 */ // Label 7102: @352419
     /* 352419 */ GIM_Try, /*On fail goto*//*Label 7103*/ GIMT_Encode4(352507), // Rule ID 9129 //
     /* 352424 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352434 */   // MIs[0] Operand 2
     /* 352434 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 352445 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 7:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 352445 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 352448 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352452 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352457 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352461 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 352463 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 352466 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352470 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352475 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 352478 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 352480 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352483 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352487 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352492 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352495 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352497 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352500 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352502 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352505 */   GIR_RootConstrainSelectedInstOperands,
     /* 352506 */   // GIR_Coverage, 9129,
     /* 352506 */   GIR_EraseRootFromParent_Done,
     /* 352507 */ // Label 7103: @352507
     /* 352507 */ GIM_Try, /*On fail goto*//*Label 7104*/ GIMT_Encode4(352595), // Rule ID 9130 //
     /* 352512 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352522 */   // MIs[0] Operand 2
     /* 352522 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 352533 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 352533 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 352536 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352540 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352545 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352549 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 352551 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 352554 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352558 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352563 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 352566 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 352568 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352571 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352575 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352580 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352583 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352585 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352588 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352590 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352593 */   GIR_RootConstrainSelectedInstOperands,
     /* 352594 */   // GIR_Coverage, 9130,
     /* 352594 */   GIR_EraseRootFromParent_Done,
     /* 352595 */ // Label 7104: @352595
     /* 352595 */ GIM_Try, /*On fail goto*//*Label 7105*/ GIMT_Encode4(352683), // Rule ID 9131 //
     /* 352600 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352610 */   // MIs[0] Operand 2
     /* 352610 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(9),
     /* 352621 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 9:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 352621 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 352624 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352628 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352633 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352637 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 352639 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 352642 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352646 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352651 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 352654 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 352656 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352659 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352663 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352668 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352671 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352673 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352676 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352678 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352681 */   GIR_RootConstrainSelectedInstOperands,
     /* 352682 */   // GIR_Coverage, 9131,
     /* 352682 */   GIR_EraseRootFromParent_Done,
     /* 352683 */ // Label 7105: @352683
     /* 352683 */ GIM_Try, /*On fail goto*//*Label 7106*/ GIMT_Encode4(352771), // Rule ID 9132 //
     /* 352688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352698 */   // MIs[0] Operand 2
     /* 352698 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(10),
     /* 352709 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 10:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 352709 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 352712 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352716 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352721 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352725 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 352727 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 352730 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352734 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352739 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 352742 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 352744 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352747 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352751 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352756 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352759 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352761 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352764 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352766 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352769 */   GIR_RootConstrainSelectedInstOperands,
     /* 352770 */   // GIR_Coverage, 9132,
     /* 352770 */   GIR_EraseRootFromParent_Done,
     /* 352771 */ // Label 7106: @352771
     /* 352771 */ GIM_Try, /*On fail goto*//*Label 7107*/ GIMT_Encode4(352859), // Rule ID 9133 //
     /* 352776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352786 */   // MIs[0] Operand 2
     /* 352786 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(11),
     /* 352797 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 11:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 352797 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 352800 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352804 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352809 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352813 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 352815 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 352818 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352822 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352827 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 352830 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 352832 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352835 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352839 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352844 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352847 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352849 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352852 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352854 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352857 */   GIR_RootConstrainSelectedInstOperands,
     /* 352858 */   // GIR_Coverage, 9133,
     /* 352858 */   GIR_EraseRootFromParent_Done,
     /* 352859 */ // Label 7107: @352859
     /* 352859 */ GIM_Try, /*On fail goto*//*Label 7108*/ GIMT_Encode4(352947), // Rule ID 9134 //
     /* 352864 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352874 */   // MIs[0] Operand 2
     /* 352874 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 352885 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 352885 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 352888 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352892 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352897 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352901 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 352903 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 352906 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352910 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352915 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 352918 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 352920 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352923 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352927 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352932 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352935 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352937 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352940 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352942 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352945 */   GIR_RootConstrainSelectedInstOperands,
     /* 352946 */   // GIR_Coverage, 9134,
     /* 352946 */   GIR_EraseRootFromParent_Done,
     /* 352947 */ // Label 7108: @352947
     /* 352947 */ GIM_Try, /*On fail goto*//*Label 7109*/ GIMT_Encode4(353035), // Rule ID 9135 //
     /* 352952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352962 */   // MIs[0] Operand 2
     /* 352962 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(13),
     /* 352973 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 13:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 352973 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 352976 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352980 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352985 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352989 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 352991 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 352994 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352998 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353003 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 353006 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 353008 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 353011 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 353015 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353020 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 353023 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353025 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353028 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 353030 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353033 */   GIR_RootConstrainSelectedInstOperands,
     /* 353034 */   // GIR_Coverage, 9135,
     /* 353034 */   GIR_EraseRootFromParent_Done,
     /* 353035 */ // Label 7109: @353035
     /* 353035 */ GIM_Try, /*On fail goto*//*Label 7110*/ GIMT_Encode4(353123), // Rule ID 9136 //
     /* 353040 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 353046 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 353050 */   // MIs[0] Operand 2
     /* 353050 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(14),
     /* 353061 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 14:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 353061 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 353064 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353068 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353073 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 353077 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 353079 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 353082 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353086 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353091 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 353094 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 353096 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 353099 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353103 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353108 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 353111 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353113 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 353116 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 353118 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353121 */   GIR_RootConstrainSelectedInstOperands,
     /* 353122 */   // GIR_Coverage, 9136,
     /* 353122 */   GIR_EraseRootFromParent_Done,
     /* 353123 */ // Label 7110: @353123
     /* 353123 */ GIM_Try, /*On fail goto*//*Label 7111*/ GIMT_Encode4(353211), // Rule ID 9137 //
     /* 353128 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 353134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 353138 */   // MIs[0] Operand 2
     /* 353138 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 353149 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 15:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 353149 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 353152 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353156 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353161 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 353165 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 353167 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 353170 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353174 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353179 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 353182 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 353184 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 353187 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353191 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353196 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 353199 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353201 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353204 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 353206 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353209 */   GIR_RootConstrainSelectedInstOperands,
     /* 353210 */   // GIR_Coverage, 9137,
     /* 353210 */   GIR_EraseRootFromParent_Done,
     /* 353211 */ // Label 7111: @353211
     /* 353211 */ GIM_Reject,
     /* 353212 */ // Label 7047: @353212
     /* 353212 */ GIM_Try, /*On fail goto*//*Label 7112*/ GIMT_Encode4(353247), // Rule ID 9088 //
     /* 353217 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 353223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 353227 */   // MIs[0] Operand 2
     /* 353227 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 353238 */   // (extract_subvector:{ *:[nxv2i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } PPR:{ *:[nxv4i1] }:$Ps)
     /* 353238 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 353241 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 353243 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 353245 */   GIR_RootConstrainSelectedInstOperands,
     /* 353246 */   // GIR_Coverage, 9088,
     /* 353246 */   GIR_EraseRootFromParent_Done,
     /* 353247 */ // Label 7112: @353247
     /* 353247 */ GIM_Try, /*On fail goto*//*Label 7113*/ GIMT_Encode4(353282), // Rule ID 9089 //
     /* 353252 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 353258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 353262 */   // MIs[0] Operand 2
     /* 353262 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 353273 */   // (extract_subvector:{ *:[nxv2i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } PPR:{ *:[nxv4i1] }:$Ps)
     /* 353273 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353276 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 353278 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 353280 */   GIR_RootConstrainSelectedInstOperands,
     /* 353281 */   // GIR_Coverage, 9089,
     /* 353281 */   GIR_EraseRootFromParent_Done,
     /* 353282 */ // Label 7113: @353282
     /* 353282 */ GIM_Try, /*On fail goto*//*Label 7114*/ GIMT_Encode4(353336), // Rule ID 9098 //
     /* 353287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 353293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 353297 */   // MIs[0] Operand 2
     /* 353297 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 353308 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 353308 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 353311 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 353315 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353320 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 353324 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353326 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 353329 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 353331 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353334 */   GIR_RootConstrainSelectedInstOperands,
     /* 353335 */   // GIR_Coverage, 9098,
     /* 353335 */   GIR_EraseRootFromParent_Done,
     /* 353336 */ // Label 7114: @353336
     /* 353336 */ GIM_Try, /*On fail goto*//*Label 7115*/ GIMT_Encode4(353390), // Rule ID 9099 //
     /* 353341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 353347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 353351 */   // MIs[0] Operand 2
     /* 353351 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 353362 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 353362 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 353365 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 353369 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353374 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 353378 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353380 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353383 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 353385 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353388 */   GIR_RootConstrainSelectedInstOperands,
     /* 353389 */   // GIR_Coverage, 9099,
     /* 353389 */   GIR_EraseRootFromParent_Done,
     /* 353390 */ // Label 7115: @353390
     /* 353390 */ GIM_Try, /*On fail goto*//*Label 7116*/ GIMT_Encode4(353444), // Rule ID 9100 //
     /* 353395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 353401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 353405 */   // MIs[0] Operand 2
     /* 353405 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 353416 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 353416 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 353419 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353423 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353428 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 353432 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353434 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 353437 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 353439 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353442 */   GIR_RootConstrainSelectedInstOperands,
     /* 353443 */   // GIR_Coverage, 9100,
     /* 353443 */   GIR_EraseRootFromParent_Done,
     /* 353444 */ // Label 7116: @353444
     /* 353444 */ GIM_Try, /*On fail goto*//*Label 7117*/ GIMT_Encode4(353498), // Rule ID 9101 //
     /* 353449 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 353455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 353459 */   // MIs[0] Operand 2
     /* 353459 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 353470 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 353470 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 353473 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353477 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353482 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 353486 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353488 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353491 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 353493 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353496 */   GIR_RootConstrainSelectedInstOperands,
     /* 353497 */   // GIR_Coverage, 9101,
     /* 353497 */   GIR_EraseRootFromParent_Done,
     /* 353498 */ // Label 7117: @353498
     /* 353498 */ GIM_Try, /*On fail goto*//*Label 7118*/ GIMT_Encode4(353569), // Rule ID 9114 //
     /* 353503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 353509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 353513 */   // MIs[0] Operand 2
     /* 353513 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 353524 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 353524 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 353527 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 353531 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353536 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 353540 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 353542 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 353545 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 353549 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353554 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 353557 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353559 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 353562 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 353564 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353567 */   GIR_RootConstrainSelectedInstOperands,
     /* 353568 */   // GIR_Coverage, 9114,
     /* 353568 */   GIR_EraseRootFromParent_Done,
     /* 353569 */ // Label 7118: @353569
     /* 353569 */ GIM_Try, /*On fail goto*//*Label 7119*/ GIMT_Encode4(353640), // Rule ID 9115 //
     /* 353574 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 353580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 353584 */   // MIs[0] Operand 2
     /* 353584 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 353595 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 353595 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 353598 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 353602 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353607 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 353611 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 353613 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 353616 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 353620 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353625 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 353628 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353630 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353633 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 353635 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353638 */   GIR_RootConstrainSelectedInstOperands,
     /* 353639 */   // GIR_Coverage, 9115,
     /* 353639 */   GIR_EraseRootFromParent_Done,
     /* 353640 */ // Label 7119: @353640
     /* 353640 */ GIM_Try, /*On fail goto*//*Label 7120*/ GIMT_Encode4(353711), // Rule ID 9116 //
     /* 353645 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 353651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 353655 */   // MIs[0] Operand 2
     /* 353655 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 353666 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 353666 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 353669 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 353673 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353678 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 353682 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 353684 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 353687 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353691 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353696 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 353699 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353701 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 353704 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 353706 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353709 */   GIR_RootConstrainSelectedInstOperands,
     /* 353710 */   // GIR_Coverage, 9116,
     /* 353710 */   GIR_EraseRootFromParent_Done,
     /* 353711 */ // Label 7120: @353711
     /* 353711 */ GIM_Try, /*On fail goto*//*Label 7121*/ GIMT_Encode4(353782), // Rule ID 9117 //
     /* 353716 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 353722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 353726 */   // MIs[0] Operand 2
     /* 353726 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 353737 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 353737 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 353740 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 353744 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353749 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 353753 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 353755 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 353758 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353762 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353767 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 353770 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353775 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 353777 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353780 */   GIR_RootConstrainSelectedInstOperands,
     /* 353781 */   // GIR_Coverage, 9117,
     /* 353781 */   GIR_EraseRootFromParent_Done,
     /* 353782 */ // Label 7121: @353782
     /* 353782 */ GIM_Try, /*On fail goto*//*Label 7122*/ GIMT_Encode4(353853), // Rule ID 9118 //
     /* 353787 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 353793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 353797 */   // MIs[0] Operand 2
     /* 353797 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 353808 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 353808 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 353811 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353815 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353820 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 353824 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 353826 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 353829 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 353833 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353838 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 353841 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353843 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 353846 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 353848 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353851 */   GIR_RootConstrainSelectedInstOperands,
     /* 353852 */   // GIR_Coverage, 9118,
     /* 353852 */   GIR_EraseRootFromParent_Done,
     /* 353853 */ // Label 7122: @353853
     /* 353853 */ GIM_Try, /*On fail goto*//*Label 7123*/ GIMT_Encode4(353924), // Rule ID 9119 //
     /* 353858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 353864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 353868 */   // MIs[0] Operand 2
     /* 353868 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(10),
     /* 353879 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 10:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 353879 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 353882 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353886 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353891 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 353895 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 353897 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 353900 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 353904 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353909 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 353912 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353914 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353917 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 353919 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353922 */   GIR_RootConstrainSelectedInstOperands,
     /* 353923 */   // GIR_Coverage, 9119,
     /* 353923 */   GIR_EraseRootFromParent_Done,
     /* 353924 */ // Label 7123: @353924
     /* 353924 */ GIM_Try, /*On fail goto*//*Label 7124*/ GIMT_Encode4(353995), // Rule ID 9120 //
     /* 353929 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 353935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 353939 */   // MIs[0] Operand 2
     /* 353939 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 353950 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 353950 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 353953 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353957 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353962 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 353966 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 353968 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 353971 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353975 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353980 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 353983 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353985 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 353988 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 353990 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353993 */   GIR_RootConstrainSelectedInstOperands,
     /* 353994 */   // GIR_Coverage, 9120,
     /* 353994 */   GIR_EraseRootFromParent_Done,
     /* 353995 */ // Label 7124: @353995
     /* 353995 */ GIM_Try, /*On fail goto*//*Label 7125*/ GIMT_Encode4(354066), // Rule ID 9121 //
     /* 354000 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 354006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 354010 */   // MIs[0] Operand 2
     /* 354010 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(14),
     /* 354021 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 14:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 354021 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 354024 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 354028 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354033 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 354037 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 354039 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 354042 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 354046 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354051 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 354054 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 354059 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 354061 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354064 */   GIR_RootConstrainSelectedInstOperands,
     /* 354065 */   // GIR_Coverage, 9121,
     /* 354065 */   GIR_EraseRootFromParent_Done,
     /* 354066 */ // Label 7125: @354066
     /* 354066 */ GIM_Reject,
     /* 354067 */ // Label 7048: @354067
     /* 354067 */ GIM_Try, /*On fail goto*//*Label 7126*/ GIMT_Encode4(354102), // Rule ID 9138 //
     /* 354072 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 354078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354082 */   // MIs[0] Operand 2
     /* 354082 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 354093 */   // (extract_subvector:{ *:[nxv2f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$Zs)
     /* 354093 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 354096 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 354098 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 354100 */   GIR_RootConstrainSelectedInstOperands,
     /* 354101 */   // GIR_Coverage, 9138,
     /* 354101 */   GIR_EraseRootFromParent_Done,
     /* 354102 */ // Label 7126: @354102
     /* 354102 */ GIM_Try, /*On fail goto*//*Label 7127*/ GIMT_Encode4(354137), // Rule ID 9139 //
     /* 354107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 354113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354117 */   // MIs[0] Operand 2
     /* 354117 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 354128 */   // (extract_subvector:{ *:[nxv2f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$Zs)
     /* 354128 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 354131 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 354133 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 354135 */   GIR_RootConstrainSelectedInstOperands,
     /* 354136 */   // GIR_Coverage, 9139,
     /* 354136 */   GIR_EraseRootFromParent_Done,
     /* 354137 */ // Label 7127: @354137
     /* 354137 */ GIM_Try, /*On fail goto*//*Label 7128*/ GIMT_Encode4(354191), // Rule ID 9144 //
     /* 354142 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 354148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354152 */   // MIs[0] Operand 2
     /* 354152 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 354163 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } (UUNPKLO_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 354163 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 354166 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 354170 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354175 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 354179 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354181 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 354184 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 354186 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354189 */   GIR_RootConstrainSelectedInstOperands,
     /* 354190 */   // GIR_Coverage, 9144,
     /* 354190 */   GIR_EraseRootFromParent_Done,
     /* 354191 */ // Label 7128: @354191
     /* 354191 */ GIM_Try, /*On fail goto*//*Label 7129*/ GIMT_Encode4(354245), // Rule ID 9145 //
     /* 354196 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 354202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354206 */   // MIs[0] Operand 2
     /* 354206 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 354217 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } (UUNPKLO_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 354217 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 354220 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 354224 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354229 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 354233 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354235 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 354238 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 354240 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354243 */   GIR_RootConstrainSelectedInstOperands,
     /* 354244 */   // GIR_Coverage, 9145,
     /* 354244 */   GIR_EraseRootFromParent_Done,
     /* 354245 */ // Label 7129: @354245
     /* 354245 */ GIM_Try, /*On fail goto*//*Label 7130*/ GIMT_Encode4(354299), // Rule ID 9146 //
     /* 354250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 354256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354260 */   // MIs[0] Operand 2
     /* 354260 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 354271 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 4:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } (UUNPKHI_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 354271 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 354274 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 354278 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354283 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 354287 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354289 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 354292 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 354294 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354297 */   GIR_RootConstrainSelectedInstOperands,
     /* 354298 */   // GIR_Coverage, 9146,
     /* 354298 */   GIR_EraseRootFromParent_Done,
     /* 354299 */ // Label 7130: @354299
     /* 354299 */ GIM_Try, /*On fail goto*//*Label 7131*/ GIMT_Encode4(354353), // Rule ID 9147 //
     /* 354304 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 354310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354314 */   // MIs[0] Operand 2
     /* 354314 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 354325 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 6:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } (UUNPKHI_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 354325 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 354328 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 354332 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354337 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 354341 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354343 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 354346 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 354348 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354351 */   GIR_RootConstrainSelectedInstOperands,
     /* 354352 */   // GIR_Coverage, 9147,
     /* 354352 */   GIR_EraseRootFromParent_Done,
     /* 354353 */ // Label 7131: @354353
     /* 354353 */ GIM_Reject,
     /* 354354 */ // Label 7049: @354354
     /* 354354 */ GIM_Try, /*On fail goto*//*Label 7132*/ GIMT_Encode4(354423),
     /* 354359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 354362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354366 */   GIM_Try, /*On fail goto*//*Label 7133*/ GIMT_Encode4(354394), // Rule ID 9142 //
     /* 354371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354374 */     // MIs[0] Operand 2
     /* 354374 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 354385 */     // (extract_subvector:{ *:[nxv2f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$Zs)
     /* 354385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 354388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 354390 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 354392 */     GIR_RootConstrainSelectedInstOperands,
     /* 354393 */     // GIR_Coverage, 9142,
     /* 354393 */     GIR_EraseRootFromParent_Done,
     /* 354394 */   // Label 7133: @354394
     /* 354394 */   GIM_Try, /*On fail goto*//*Label 7134*/ GIMT_Encode4(354422), // Rule ID 9143 //
     /* 354399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354402 */     // MIs[0] Operand 2
     /* 354402 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 354413 */     // (extract_subvector:{ *:[nxv2f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$Zs)
     /* 354413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 354416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 354418 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 354420 */     GIR_RootConstrainSelectedInstOperands,
     /* 354421 */     // GIR_Coverage, 9143,
     /* 354421 */     GIR_EraseRootFromParent_Done,
     /* 354422 */   // Label 7134: @354422
     /* 354422 */   GIM_Reject,
     /* 354423 */ // Label 7132: @354423
     /* 354423 */ GIM_Reject,
     /* 354424 */ // Label 7050: @354424
     /* 354424 */ GIM_Try, /*On fail goto*//*Label 7135*/ GIMT_Encode4(354459), // Rule ID 9090 //
     /* 354429 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 354435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 354439 */   // MIs[0] Operand 2
     /* 354439 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 354450 */   // (extract_subvector:{ *:[nxv4i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } PPR:{ *:[nxv8i1] }:$Ps)
     /* 354450 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 354453 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 354455 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 354457 */   GIR_RootConstrainSelectedInstOperands,
     /* 354458 */   // GIR_Coverage, 9090,
     /* 354458 */   GIR_EraseRootFromParent_Done,
     /* 354459 */ // Label 7135: @354459
     /* 354459 */ GIM_Try, /*On fail goto*//*Label 7136*/ GIMT_Encode4(354494), // Rule ID 9091 //
     /* 354464 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354467 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 354470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 354474 */   // MIs[0] Operand 2
     /* 354474 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 354485 */   // (extract_subvector:{ *:[nxv4i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } PPR:{ *:[nxv8i1] }:$Ps)
     /* 354485 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 354488 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 354490 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 354492 */   GIR_RootConstrainSelectedInstOperands,
     /* 354493 */   // GIR_Coverage, 9091,
     /* 354493 */   GIR_EraseRootFromParent_Done,
     /* 354494 */ // Label 7136: @354494
     /* 354494 */ GIM_Try, /*On fail goto*//*Label 7137*/ GIMT_Encode4(354548), // Rule ID 9102 //
     /* 354499 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 354505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 354509 */   // MIs[0] Operand 2
     /* 354509 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 354520 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 354520 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 354523 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 354527 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354532 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 354536 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354538 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 354541 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 354543 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354546 */   GIR_RootConstrainSelectedInstOperands,
     /* 354547 */   // GIR_Coverage, 9102,
     /* 354547 */   GIR_EraseRootFromParent_Done,
     /* 354548 */ // Label 7137: @354548
     /* 354548 */ GIM_Try, /*On fail goto*//*Label 7138*/ GIMT_Encode4(354602), // Rule ID 9103 //
     /* 354553 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 354559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 354563 */   // MIs[0] Operand 2
     /* 354563 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 354574 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 354574 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 354577 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 354581 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354586 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 354590 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 354595 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 354597 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354600 */   GIR_RootConstrainSelectedInstOperands,
     /* 354601 */   // GIR_Coverage, 9103,
     /* 354601 */   GIR_EraseRootFromParent_Done,
     /* 354602 */ // Label 7138: @354602
     /* 354602 */ GIM_Try, /*On fail goto*//*Label 7139*/ GIMT_Encode4(354656), // Rule ID 9104 //
     /* 354607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 354613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 354617 */   // MIs[0] Operand 2
     /* 354617 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 354628 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 354628 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 354631 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 354635 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354640 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 354644 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354646 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 354649 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 354651 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354654 */   GIR_RootConstrainSelectedInstOperands,
     /* 354655 */   // GIR_Coverage, 9104,
     /* 354655 */   GIR_EraseRootFromParent_Done,
     /* 354656 */ // Label 7139: @354656
     /* 354656 */ GIM_Try, /*On fail goto*//*Label 7140*/ GIMT_Encode4(354710), // Rule ID 9105 //
     /* 354661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 354667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 354671 */   // MIs[0] Operand 2
     /* 354671 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 354682 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 354682 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 354685 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 354689 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354694 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 354698 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 354703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 354705 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354708 */   GIR_RootConstrainSelectedInstOperands,
     /* 354709 */   // GIR_Coverage, 9105,
     /* 354709 */   GIR_EraseRootFromParent_Done,
     /* 354710 */ // Label 7140: @354710
     /* 354710 */ GIM_Reject,
     /* 354711 */ // Label 7051: @354711
     /* 354711 */ GIM_Try, /*On fail goto*//*Label 7141*/ GIMT_Encode4(354780),
     /* 354716 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 354719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354723 */   GIM_Try, /*On fail goto*//*Label 7142*/ GIMT_Encode4(354751), // Rule ID 9140 //
     /* 354728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354731 */     // MIs[0] Operand 2
     /* 354731 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 354742 */     // (extract_subvector:{ *:[nxv4f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_S:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$Zs)
     /* 354742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 354745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 354747 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 354749 */     GIR_RootConstrainSelectedInstOperands,
     /* 354750 */     // GIR_Coverage, 9140,
     /* 354750 */     GIR_EraseRootFromParent_Done,
     /* 354751 */   // Label 7142: @354751
     /* 354751 */   GIM_Try, /*On fail goto*//*Label 7143*/ GIMT_Encode4(354779), // Rule ID 9141 //
     /* 354756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354759 */     // MIs[0] Operand 2
     /* 354759 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 354770 */     // (extract_subvector:{ *:[nxv4f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 4:{ *:[i64] })  =>  (UUNPKHI_ZZ_S:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$Zs)
     /* 354770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 354773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 354775 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 354777 */     GIR_RootConstrainSelectedInstOperands,
     /* 354778 */     // GIR_Coverage, 9141,
     /* 354778 */     GIR_EraseRootFromParent_Done,
     /* 354779 */   // Label 7143: @354779
     /* 354779 */   GIM_Reject,
     /* 354780 */ // Label 7141: @354780
     /* 354780 */ GIM_Reject,
     /* 354781 */ // Label 7052: @354781
     /* 354781 */ GIM_Try, /*On fail goto*//*Label 7144*/ GIMT_Encode4(354850),
     /* 354786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 354789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 354793 */   GIM_Try, /*On fail goto*//*Label 7145*/ GIMT_Encode4(354821), // Rule ID 9092 //
     /* 354798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354801 */     // MIs[0] Operand 2
     /* 354801 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 354812 */     // (extract_subvector:{ *:[nxv8i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv8i1] } PPR:{ *:[nxv16i1] }:$Ps)
     /* 354812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 354815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 354817 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 354819 */     GIR_RootConstrainSelectedInstOperands,
     /* 354820 */     // GIR_Coverage, 9092,
     /* 354820 */     GIR_EraseRootFromParent_Done,
     /* 354821 */   // Label 7145: @354821
     /* 354821 */   GIM_Try, /*On fail goto*//*Label 7146*/ GIMT_Encode4(354849), // Rule ID 9093 //
     /* 354826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354829 */     // MIs[0] Operand 2
     /* 354829 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 354840 */     // (extract_subvector:{ *:[nxv8i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv8i1] } PPR:{ *:[nxv16i1] }:$Ps)
     /* 354840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 354843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 354845 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 354847 */     GIR_RootConstrainSelectedInstOperands,
     /* 354848 */     // GIR_Coverage, 9093,
     /* 354848 */     GIR_EraseRootFromParent_Done,
     /* 354849 */   // Label 7146: @354849
     /* 354849 */   GIM_Reject,
     /* 354850 */ // Label 7144: @354850
     /* 354850 */ GIM_Reject,
     /* 354851 */ // Label 7053: @354851
     /* 354851 */ GIM_Reject,
     /* 354852 */ // Label 91: @354852
     /* 354852 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 7162*/ GIMT_Encode4(387773),
     /* 354863 */ /*GILLT_s64*//*Label 7147*/ GIMT_Encode4(354947), GIMT_Encode4(0),
     /* 354871 */ /*GILLT_v2s32*//*Label 7148*/ GIMT_Encode4(355657),
     /* 354875 */ /*GILLT_v2s64*//*Label 7149*/ GIMT_Encode4(359188),
     /* 354879 */ /*GILLT_v4s16*//*Label 7150*/ GIMT_Encode4(362429),
     /* 354883 */ /*GILLT_v4s32*//*Label 7151*/ GIMT_Encode4(366069),
     /* 354887 */ /*GILLT_v8s8*//*Label 7152*/ GIMT_Encode4(369137),
     /* 354891 */ /*GILLT_v8s16*//*Label 7153*/ GIMT_Encode4(372350),
     /* 354895 */ /*GILLT_v16s8*//*Label 7154*/ GIMT_Encode4(375769), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 354907 */ /*GILLT_nxv2s16*//*Label 7155*/ GIMT_Encode4(378973),
     /* 354911 */ /*GILLT_nxv2s32*//*Label 7156*/ GIMT_Encode4(379098),
     /* 354915 */ /*GILLT_nxv2s64*//*Label 7157*/ GIMT_Encode4(379223), GIMT_Encode4(0),
     /* 354923 */ /*GILLT_nxv4s16*//*Label 7158*/ GIMT_Encode4(381201),
     /* 354927 */ /*GILLT_nxv4s32*//*Label 7159*/ GIMT_Encode4(381353), GIMT_Encode4(0),
     /* 354935 */ /*GILLT_nxv8s16*//*Label 7160*/ GIMT_Encode4(383385), GIMT_Encode4(0),
     /* 354943 */ /*GILLT_nxv16s8*//*Label 7161*/ GIMT_Encode4(385653),
     /* 354947 */ // Label 7147: @354947
     /* 354947 */ GIM_Try, /*On fail goto*//*Label 7163*/ GIMT_Encode4(355656),
     /* 354952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 354955 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 354958 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 354961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354965 */   GIM_Try, /*On fail goto*//*Label 7164*/ GIMT_Encode4(355095), // Rule ID 5776 //
     /* 354970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 354978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 354982 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 354986 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 354990 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 354999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355003 */     // MIs[2] Operand 1
     /* 355003 */     // No operand predicates
     /* 355003 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 355007 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355011 */     // MIs[3] Operand 1
     /* 355011 */     // No operand predicates
     /* 355011 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355013 */     // (vector_insert:{ *:[v1f64] } V64:{ *:[v1f64] }:$src, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 355013 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 355016 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355020 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355025 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 355028 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 355032 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 355035 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355040 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355045 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 355048 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 355052 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355057 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 355060 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 355063 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 355067 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 355070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 355075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355077 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 355084 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355089 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355094 */     // GIR_Coverage, 5776,
     /* 355094 */     GIR_EraseRootFromParent_Done,
     /* 355095 */   // Label 7164: @355095
     /* 355095 */   GIM_Try, /*On fail goto*//*Label 7165*/ GIMT_Encode4(355256), // Rule ID 5777 //
     /* 355100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 355112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 355116 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 355120 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 355129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355133 */     // MIs[2] Operand 1
     /* 355133 */     // No operand predicates
     /* 355133 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 355137 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355141 */     // MIs[3] Operand 1
     /* 355141 */     // No operand predicates
     /* 355141 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355143 */     // (vector_insert:{ *:[v1f64] } V64:{ *:[v1f64] }:$src, (vector_extract:{ *:[f64] } V64:{ *:[v1f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 355143 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 355146 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355150 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355155 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 355158 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 355162 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 355165 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355170 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355175 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 355178 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355182 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355187 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 355190 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 355194 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 355197 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355202 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 355210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 355214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355219 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 355222 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 355225 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 355228 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 355231 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 355236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355238 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 355245 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355250 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355255 */     // GIR_Coverage, 5777,
     /* 355255 */     GIR_EraseRootFromParent_Done,
     /* 355256 */   // Label 7165: @355256
     /* 355256 */   GIM_Try, /*On fail goto*//*Label 7166*/ GIMT_Encode4(355386), // Rule ID 5816 //
     /* 355261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 355273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 355277 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 355281 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 355290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355294 */     // MIs[2] Operand 1
     /* 355294 */     // No operand predicates
     /* 355294 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 355298 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355302 */     // MIs[3] Operand 1
     /* 355302 */     // No operand predicates
     /* 355302 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355304 */     // (vector_insert:{ *:[v1i64] } V64:{ *:[v1i64] }:$src, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 355304 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 355307 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355311 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355316 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 355319 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 355323 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 355326 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355331 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355336 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 355339 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 355343 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355348 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 355351 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 355354 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 355358 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 355361 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 355366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355368 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 355375 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355380 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355385 */     // GIR_Coverage, 5816,
     /* 355385 */     GIR_EraseRootFromParent_Done,
     /* 355386 */   // Label 7166: @355386
     /* 355386 */   GIM_Try, /*On fail goto*//*Label 7167*/ GIMT_Encode4(355547), // Rule ID 5817 //
     /* 355391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 355403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 355407 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 355411 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355416 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 355420 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355424 */     // MIs[2] Operand 1
     /* 355424 */     // No operand predicates
     /* 355424 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 355428 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355432 */     // MIs[3] Operand 1
     /* 355432 */     // No operand predicates
     /* 355432 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355434 */     // (vector_insert:{ *:[v1i64] } V64:{ *:[v1i64] }:$src, (vector_extract:{ *:[i64] } V64:{ *:[v1i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 355434 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 355437 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355441 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355446 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 355449 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 355453 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 355456 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355461 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355466 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 355469 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355473 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355478 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 355481 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 355485 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 355488 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355493 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 355501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 355505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355510 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 355513 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 355516 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 355519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 355522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 355527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355529 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 355536 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355541 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355546 */     // GIR_Coverage, 5817,
     /* 355546 */     GIR_EraseRootFromParent_Done,
     /* 355547 */   // Label 7167: @355547
     /* 355547 */   GIM_Try, /*On fail goto*//*Label 7168*/ GIMT_Encode4(355583), // Rule ID 6737 //
     /* 355552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355564 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 355570 */     // (vector_insert:{ *:[v1i64] } (undef:{ *:[v1i64] }), GPR64:{ *:[i64] }:$Xn, 0:{ *:[i64] })  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 355570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 355573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 355577 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355582 */     // GIR_Coverage, 6737,
     /* 355582 */     GIR_EraseRootFromParent_Done,
     /* 355583 */   // Label 7168: @355583
     /* 355583 */   GIM_Try, /*On fail goto*//*Label 7169*/ GIMT_Encode4(355619), // Rule ID 6739 //
     /* 355588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355600 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 355606 */     // (vector_insert:{ *:[v1f64] } (undef:{ *:[v1f64] }), GPR64:{ *:[i64] }:$Xn, 0:{ *:[i64] })  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 355606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 355609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 355613 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355618 */     // GIR_Coverage, 6739,
     /* 355618 */     GIR_EraseRootFromParent_Done,
     /* 355619 */   // Label 7169: @355619
     /* 355619 */   GIM_Try, /*On fail goto*//*Label 7170*/ GIMT_Encode4(355655), // Rule ID 6741 //
     /* 355624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355636 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355640 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 355642 */     // (vector_insert:{ *:[v1f64] } (undef:{ *:[v1f64] }), FPR64:{ *:[f64] }:$Xn, 0:{ *:[i64] })  =>  FPR64:{ *:[v1f64] }:$Xn
     /* 355642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 355645 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 355647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 355649 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355654 */     // GIR_Coverage, 6741,
     /* 355654 */     GIR_EraseRootFromParent_Done,
     /* 355655 */   // Label 7170: @355655
     /* 355655 */   GIM_Reject,
     /* 355656 */ // Label 7163: @355656
     /* 355656 */ GIM_Reject,
     /* 355657 */ // Label 7148: @355657
     /* 355657 */ GIM_Try, /*On fail goto*//*Label 7171*/ GIMT_Encode4(359187),
     /* 355662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 355665 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 355668 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 355671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355675 */   GIM_Try, /*On fail goto*//*Label 7172*/ GIMT_Encode4(355784), // Rule ID 4333 //
     /* 355680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355684 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 355690 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 355692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355700 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355703 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355707 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355711 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355715 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355717 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 355724 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 355724 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 355727 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 355731 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 355746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 355751 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355757 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355767 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 355773 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355778 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 355783 */     // GIR_Coverage, 4333,
     /* 355783 */     GIR_EraseRootFromParent_Done,
     /* 355784 */   // Label 7172: @355784
     /* 355784 */   GIM_Try, /*On fail goto*//*Label 7173*/ GIMT_Encode4(355893), // Rule ID 4334 //
     /* 355789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355793 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 355799 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 355801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355809 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355812 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355816 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355820 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355824 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355826 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 355833 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 355833 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 355836 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 355840 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 355855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 355860 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 355882 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355887 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 355892 */     // GIR_Coverage, 4334,
     /* 355892 */     GIR_EraseRootFromParent_Done,
     /* 355893 */   // Label 7173: @355893
     /* 355893 */   GIM_Try, /*On fail goto*//*Label 7174*/ GIMT_Encode4(356002), // Rule ID 4441 //
     /* 355898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355902 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 355908 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 355910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355918 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355921 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355925 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355929 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355933 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355935 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 355942 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 355942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 355945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 355949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 355964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 355969 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355975 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 355991 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355996 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356001 */     // GIR_Coverage, 4441,
     /* 356001 */     GIR_EraseRootFromParent_Done,
     /* 356002 */   // Label 7174: @356002
     /* 356002 */   GIM_Try, /*On fail goto*//*Label 7175*/ GIMT_Encode4(356111), // Rule ID 4442 //
     /* 356007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356011 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 356017 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 356019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356027 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356030 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356034 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356038 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356042 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356044 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 356051 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 356051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 356058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356078 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356094 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356100 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356105 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356110 */     // GIR_Coverage, 4442,
     /* 356110 */     GIR_EraseRootFromParent_Done,
     /* 356111 */   // Label 7175: @356111
     /* 356111 */   GIM_Try, /*On fail goto*//*Label 7176*/ GIMT_Encode4(356216), // Rule ID 4339 //
     /* 356116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356132 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356135 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356139 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356143 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356147 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356149 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 356156 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 356156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 356163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356183 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356189 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356205 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356210 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356215 */     // GIR_Coverage, 4339,
     /* 356215 */     GIR_EraseRootFromParent_Done,
     /* 356216 */   // Label 7176: @356216
     /* 356216 */   GIM_Try, /*On fail goto*//*Label 7177*/ GIMT_Encode4(356321), // Rule ID 4341 //
     /* 356221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356237 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356240 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356244 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356248 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356252 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356254 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 356261 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 356261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 356268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356288 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356310 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356315 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356320 */     // GIR_Coverage, 4341,
     /* 356320 */     GIR_EraseRootFromParent_Done,
     /* 356321 */   // Label 7177: @356321
     /* 356321 */   GIM_Try, /*On fail goto*//*Label 7178*/ GIMT_Encode4(356426), // Rule ID 4447 //
     /* 356326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356334 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356338 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356342 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356345 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356349 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356353 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356357 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356359 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 356366 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 356366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 356373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356393 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356399 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356415 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356420 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356425 */     // GIR_Coverage, 4447,
     /* 356425 */     GIR_EraseRootFromParent_Done,
     /* 356426 */   // Label 7178: @356426
     /* 356426 */   GIM_Try, /*On fail goto*//*Label 7179*/ GIMT_Encode4(356531), // Rule ID 4449 //
     /* 356431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356439 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356443 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356447 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356450 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356454 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356458 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356462 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356464 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 356471 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 356471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 356478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356498 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356520 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356525 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356530 */     // GIR_Coverage, 4449,
     /* 356530 */     GIR_EraseRootFromParent_Done,
     /* 356531 */   // Label 7179: @356531
     /* 356531 */   GIM_Try, /*On fail goto*//*Label 7180*/ GIMT_Encode4(356635), // Rule ID 4331 //
     /* 356536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356540 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 356546 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 356548 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356552 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356556 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356559 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356563 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356567 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356571 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356573 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 356580 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 356580 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356583 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 356587 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 356602 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356624 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356629 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356634 */     // GIR_Coverage, 4331,
     /* 356634 */     GIR_EraseRootFromParent_Done,
     /* 356635 */   // Label 7180: @356635
     /* 356635 */   GIM_Try, /*On fail goto*//*Label 7181*/ GIMT_Encode4(356739), // Rule ID 4332 //
     /* 356640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356644 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 356650 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 356652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356660 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356663 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356667 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356671 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356675 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356677 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 356684 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 356684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 356691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 356706 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356728 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356733 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356738 */     // GIR_Coverage, 4332,
     /* 356738 */     GIR_EraseRootFromParent_Done,
     /* 356739 */   // Label 7181: @356739
     /* 356739 */   GIM_Try, /*On fail goto*//*Label 7182*/ GIMT_Encode4(356843), // Rule ID 4439 //
     /* 356744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356748 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 356754 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 356756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356764 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356767 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356771 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356775 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356779 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356781 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 356788 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 356788 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356791 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 356795 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 356810 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356832 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356837 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356842 */     // GIR_Coverage, 4439,
     /* 356842 */     GIR_EraseRootFromParent_Done,
     /* 356843 */   // Label 7182: @356843
     /* 356843 */   GIM_Try, /*On fail goto*//*Label 7183*/ GIMT_Encode4(356947), // Rule ID 4440 //
     /* 356848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356852 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 356858 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 356860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356868 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356871 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356875 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356879 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356883 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356885 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 356892 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 356892 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356895 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 356899 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 356914 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356920 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356936 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356941 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356946 */     // GIR_Coverage, 4440,
     /* 356946 */     GIR_EraseRootFromParent_Done,
     /* 356947 */   // Label 7183: @356947
     /* 356947 */   GIM_Try, /*On fail goto*//*Label 7184*/ GIMT_Encode4(357047), // Rule ID 4335 //
     /* 356952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356968 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356971 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356975 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356979 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356983 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356985 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 356992 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 356992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 356999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 357014 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357020 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357030 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 357036 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357041 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357046 */     // GIR_Coverage, 4335,
     /* 357046 */     GIR_EraseRootFromParent_Done,
     /* 357047 */   // Label 7184: @357047
     /* 357047 */   GIM_Try, /*On fail goto*//*Label 7185*/ GIMT_Encode4(357147), // Rule ID 4337 //
     /* 357052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357068 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357071 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357075 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357079 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357083 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357085 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 357092 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 357092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 357095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 357099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 357114 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357130 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 357136 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357141 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357146 */     // GIR_Coverage, 4337,
     /* 357146 */     GIR_EraseRootFromParent_Done,
     /* 357147 */   // Label 7185: @357147
     /* 357147 */   GIM_Try, /*On fail goto*//*Label 7186*/ GIMT_Encode4(357247), // Rule ID 4443 //
     /* 357152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357168 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357171 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357175 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357179 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357183 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357185 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 357192 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 357192 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 357195 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 357199 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 357214 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 357236 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357241 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357246 */     // GIR_Coverage, 4443,
     /* 357246 */     GIR_EraseRootFromParent_Done,
     /* 357247 */   // Label 7186: @357247
     /* 357247 */   GIM_Try, /*On fail goto*//*Label 7187*/ GIMT_Encode4(357347), // Rule ID 4445 //
     /* 357252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357268 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357271 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357275 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357279 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357283 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357285 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 357292 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 357292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 357295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 357299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 357314 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357330 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 357336 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357341 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357346 */     // GIR_Coverage, 4445,
     /* 357346 */     GIR_EraseRootFromParent_Done,
     /* 357347 */   // Label 7187: @357347
     /* 357347 */   GIM_Try, /*On fail goto*//*Label 7188*/ GIMT_Encode4(357467), // Rule ID 6515 //
     /* 357352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 357355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357363 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357367 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357371 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357374 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357378 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 357385 */     // MIs[2] Rn
     /* 357385 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 357389 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 357394 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357398 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357400 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i16:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 357400 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 357403 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 357407 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 357414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 357417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 357421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357426 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 357429 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 357432 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 357436 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357442 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357449 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 357456 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357461 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357466 */     // GIR_Coverage, 6515,
     /* 357466 */     GIR_EraseRootFromParent_Done,
     /* 357467 */   // Label 7188: @357467
     /* 357467 */   GIM_Try, /*On fail goto*//*Label 7189*/ GIMT_Encode4(357587), // Rule ID 6517 //
     /* 357472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 357475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357483 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357491 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357494 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357498 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 357505 */     // MIs[2] Rn
     /* 357505 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 357509 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 357514 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357518 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357520 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i8:{ *:[f128] } (IMPLICIT_DEF:{ *:[v16i8] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 357520 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 357523 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 357527 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 357534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 357537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 357541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357546 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 357549 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 357552 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 357556 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357569 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 357576 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357581 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357586 */     // GIR_Coverage, 6517,
     /* 357586 */     GIR_EraseRootFromParent_Done,
     /* 357587 */   // Label 7189: @357587
     /* 357587 */   GIM_Try, /*On fail goto*//*Label 7190*/ GIMT_Encode4(357717), // Rule ID 5768 //
     /* 357592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 357600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 357604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 357608 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 357612 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 357621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357625 */     // MIs[2] Operand 1
     /* 357625 */     // No operand predicates
     /* 357625 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 357629 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357633 */     // MIs[3] Operand 1
     /* 357633 */     // No operand predicates
     /* 357633 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 357635 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$src, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 357635 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 357638 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357642 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357647 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 357650 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 357654 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 357657 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357662 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357667 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 357670 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 357674 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357679 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 357682 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 357685 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 357689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 357692 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357699 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 357706 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357711 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357716 */     // GIR_Coverage, 5768,
     /* 357716 */     GIR_EraseRootFromParent_Done,
     /* 357717 */   // Label 7190: @357717
     /* 357717 */   GIM_Try, /*On fail goto*//*Label 7191*/ GIMT_Encode4(357878), // Rule ID 5769 //
     /* 357722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 357730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 357734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 357738 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 357742 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 357751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357755 */     // MIs[2] Operand 1
     /* 357755 */     // No operand predicates
     /* 357755 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 357759 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357763 */     // MIs[3] Operand 1
     /* 357763 */     // No operand predicates
     /* 357763 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 357765 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$src, (vector_extract:{ *:[f32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 357765 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 357768 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357772 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357777 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 357780 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 357784 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 357787 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357792 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357797 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 357800 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357804 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357809 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 357812 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 357816 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 357819 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357824 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357829 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 357832 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 357836 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357841 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 357844 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 357847 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 357850 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 357853 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357860 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 357867 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357872 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357877 */     // GIR_Coverage, 5769,
     /* 357877 */     GIR_EraseRootFromParent_Done,
     /* 357878 */   // Label 7191: @357878
     /* 357878 */   GIM_Try, /*On fail goto*//*Label 7192*/ GIMT_Encode4(358008), // Rule ID 5808 //
     /* 357883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 357891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 357895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 357899 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 357903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 357912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357916 */     // MIs[2] Operand 1
     /* 357916 */     // No operand predicates
     /* 357916 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 357920 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357924 */     // MIs[3] Operand 1
     /* 357924 */     // No operand predicates
     /* 357924 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 357926 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 357926 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 357929 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357933 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357938 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 357941 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 357945 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 357948 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357953 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 357961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 357965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357970 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 357973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 357976 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 357980 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 357983 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357990 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 357997 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358002 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358007 */     // GIR_Coverage, 5808,
     /* 358007 */     GIR_EraseRootFromParent_Done,
     /* 358008 */   // Label 7192: @358008
     /* 358008 */   GIM_Try, /*On fail goto*//*Label 7193*/ GIMT_Encode4(358169), // Rule ID 5809 //
     /* 358013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 358021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 358029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 358033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 358042 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358046 */     // MIs[2] Operand 1
     /* 358046 */     // No operand predicates
     /* 358046 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 358050 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358054 */     // MIs[3] Operand 1
     /* 358054 */     // No operand predicates
     /* 358054 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 358056 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 358056 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 358059 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358063 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358068 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 358071 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 358075 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 358078 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358083 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358088 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 358091 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358095 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358100 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 358103 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 358107 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 358110 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358115 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 358123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 358127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358132 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 358135 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 358138 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 358141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 358144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 358149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358151 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 358158 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358163 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358168 */     // GIR_Coverage, 5809,
     /* 358168 */     GIR_EraseRootFromParent_Done,
     /* 358169 */   // Label 7193: @358169
     /* 358169 */   GIM_Try, /*On fail goto*//*Label 7194*/ GIMT_Encode4(358235), // Rule ID 5715 //
     /* 358174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 358186 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358190 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 358192 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i32] } (IMPLICIT_DEF:{ *:[v2i32] }), GPR32:{ *:[i32] }:$Rn, ssub:{ *:[i32] })
     /* 358192 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 358195 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 358199 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358204 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 358209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358211 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358214 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 358216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 358219 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358224 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358229 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 358234 */     // GIR_Coverage, 5715,
     /* 358234 */     GIR_EraseRootFromParent_Done,
     /* 358235 */   // Label 7194: @358235
     /* 358235 */   GIM_Try, /*On fail goto*//*Label 7195*/ GIMT_Encode4(358301), // Rule ID 5731 //
     /* 358240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 358252 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 358258 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), FPR32:{ *:[f32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] })
     /* 358258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 358261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 358265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 358275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 358282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 358285 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358290 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358295 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 358300 */     // GIR_Coverage, 5731,
     /* 358300 */     GIR_EraseRootFromParent_Done,
     /* 358301 */   // Label 7195: @358301
     /* 358301 */   GIM_Try, /*On fail goto*//*Label 7196*/ GIMT_Encode4(358436), // Rule ID 5739 //
     /* 358306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 358314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 358318 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 358322 */     // MIs[1] Operand 1
     /* 358322 */     // No operand predicates
     /* 358322 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 358326 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358330 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 358334 */     // MIs[2] Operand 1
     /* 358334 */     // No operand predicates
     /* 358334 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358336 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, WZR:{ *:[i32] }), dsub:{ *:[i32] })
     /* 358336 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 358339 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 358343 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358348 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 358350 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 358353 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 358357 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358362 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 358365 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 358369 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 358372 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358377 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358382 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358387 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 358390 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 358394 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358399 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 358402 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /* 358405 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 358411 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 358416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358418 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 358425 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358430 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358435 */     // GIR_Coverage, 5739,
     /* 358435 */     GIR_EraseRootFromParent_Done,
     /* 358436 */   // Label 7196: @358436
     /* 358436 */   GIM_Try, /*On fail goto*//*Label 7197*/ GIMT_Encode4(358568), // Rule ID 6524 //
     /* 358441 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 358449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358453 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358456 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 358460 */     // MIs[1] Rn
     /* 358460 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 358464 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 358469 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 358473 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358477 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 358481 */     // MIs[2] Operand 1
     /* 358481 */     // No operand predicates
     /* 358481 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358483 */     // (vector_insert:{ *:[v2i32] } VecListOne64:{ *:[v2i32] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i32:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 358483 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 358486 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358490 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358495 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 358498 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 358502 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 358505 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358510 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 358518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 358522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358527 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 358530 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 358533 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 358537 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358543 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 358548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358550 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 358557 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358562 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358567 */     // GIR_Coverage, 6524,
     /* 358567 */     GIR_EraseRootFromParent_Done,
     /* 358568 */   // Label 7197: @358568
     /* 358568 */   GIM_Try, /*On fail goto*//*Label 7198*/ GIMT_Encode4(358700), // Rule ID 6525 //
     /* 358573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 358581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358585 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358588 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 358592 */     // MIs[1] Rn
     /* 358592 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 358596 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 358601 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 358605 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358609 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 358613 */     // MIs[2] Operand 1
     /* 358613 */     // No operand predicates
     /* 358613 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358615 */     // (vector_insert:{ *:[v2f32] } VecListOne64:{ *:[v2f32] }:$Rd, (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (LD1i32:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 358615 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 358618 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358622 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358627 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 358630 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 358634 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 358637 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358642 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 358650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 358654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358659 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 358662 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 358665 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 358669 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 358680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358682 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 358689 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358694 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358699 */     // GIR_Coverage, 6525,
     /* 358699 */     GIR_EraseRootFromParent_Done,
     /* 358700 */   // Label 7198: @358700
     /* 358700 */   GIM_Try, /*On fail goto*//*Label 7199*/ GIMT_Encode4(358883), // Rule ID 5819 //
     /* 358705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 358709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 358713 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 358717 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 358722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 358726 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358730 */     // MIs[2] Operand 1
     /* 358730 */     // No operand predicates
     /* 358730 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358732 */     // (vector_insert:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$src, (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR32:{ *:[f32] }:$Sn, ssub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 358732 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s128,
     /* 358735 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 358739 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358744 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 358746 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 358749 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 358753 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358758 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 358761 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 358765 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/18,
     /* 358768 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358773 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358778 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 358783 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 358786 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 358790 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 358797 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 358800 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 358804 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358809 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 358812 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 358816 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 358819 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358824 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358829 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358834 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 358837 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 358841 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358846 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 358849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immd
     /* 358852 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 358855 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 358858 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 358863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358865 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 358872 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358877 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358882 */     // GIR_Coverage, 5819,
     /* 358882 */     GIR_EraseRootFromParent_Done,
     /* 358883 */   // Label 7199: @358883
     /* 358883 */   GIM_Try, /*On fail goto*//*Label 7200*/ GIMT_Encode4(359061), // Rule ID 5742 //
     /* 358888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 358896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 358900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358904 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 358908 */     // MIs[1] Operand 1
     /* 358908 */     // No operand predicates
     /* 358908 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 358910 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 358910 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 358913 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 358917 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 358924 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 358927 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 358931 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358936 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 358939 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 358943 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/18,
     /* 358946 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358951 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358956 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 358961 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 358964 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 358968 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358973 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 358975 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 358978 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 358982 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358987 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 358990 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 358994 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 358997 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359002 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359007 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 359015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 359019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359024 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 359027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 359030 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 359033 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 359036 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 359041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359043 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 359050 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359055 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359060 */     // GIR_Coverage, 5742,
     /* 359060 */     GIR_EraseRootFromParent_Done,
     /* 359061 */   // Label 7200: @359061
     /* 359061 */   GIM_Try, /*On fail goto*//*Label 7201*/ GIMT_Encode4(359186), // Rule ID 5745 //
     /* 359066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 359074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 359078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359082 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 359086 */     // MIs[1] Operand 1
     /* 359086 */     // No operand predicates
     /* 359086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 359088 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 359088 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 359091 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 359095 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359100 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 359102 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 359105 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 359109 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359114 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 359117 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 359121 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 359124 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359129 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359134 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359139 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 359142 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 359146 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359151 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 359154 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 359157 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 359161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 359166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359168 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 359175 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359180 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359185 */     // GIR_Coverage, 5745,
     /* 359185 */     GIR_EraseRootFromParent_Done,
     /* 359186 */   // Label 7201: @359186
     /* 359186 */   GIM_Reject,
     /* 359187 */ // Label 7171: @359187
     /* 359187 */ GIM_Reject,
     /* 359188 */ // Label 7149: @359188
     /* 359188 */ GIM_Try, /*On fail goto*//*Label 7202*/ GIMT_Encode4(362428),
     /* 359193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 359196 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 359199 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 359202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359206 */   GIM_Try, /*On fail goto*//*Label 7203*/ GIMT_Encode4(359315), // Rule ID 4357 //
     /* 359211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359215 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 359221 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 359223 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359227 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359231 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359234 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359238 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359242 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359246 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359248 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 359255 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 359255 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 359258 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 359262 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 359277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 359282 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359288 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359298 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359304 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359309 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359314 */     // GIR_Coverage, 4357,
     /* 359314 */     GIR_EraseRootFromParent_Done,
     /* 359315 */   // Label 7203: @359315
     /* 359315 */   GIM_Try, /*On fail goto*//*Label 7204*/ GIMT_Encode4(359424), // Rule ID 4358 //
     /* 359320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359324 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 359330 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 359332 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359336 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359340 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359343 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359347 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359351 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359355 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359357 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 359364 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 359364 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 359367 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 359371 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 359386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 359391 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359407 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359413 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359418 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359423 */     // GIR_Coverage, 4358,
     /* 359423 */     GIR_EraseRootFromParent_Done,
     /* 359424 */   // Label 7204: @359424
     /* 359424 */   GIM_Try, /*On fail goto*//*Label 7205*/ GIMT_Encode4(359533), // Rule ID 4465 //
     /* 359429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359433 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 359439 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 359441 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359445 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359449 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359452 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359456 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359460 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359464 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359466 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 359473 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 359473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 359476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 359480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 359495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 359500 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359522 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359527 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359532 */     // GIR_Coverage, 4465,
     /* 359532 */     GIR_EraseRootFromParent_Done,
     /* 359533 */   // Label 7205: @359533
     /* 359533 */   GIM_Try, /*On fail goto*//*Label 7206*/ GIMT_Encode4(359642), // Rule ID 4466 //
     /* 359538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359542 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 359548 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 359550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359558 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359561 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359565 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359569 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359573 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359575 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 359582 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 359582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 359585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 359589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 359604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 359609 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359615 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359625 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359631 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359636 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359641 */     // GIR_Coverage, 4466,
     /* 359641 */     GIR_EraseRootFromParent_Done,
     /* 359642 */   // Label 7206: @359642
     /* 359642 */   GIM_Try, /*On fail goto*//*Label 7207*/ GIMT_Encode4(359747), // Rule ID 4363 //
     /* 359647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359655 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359659 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359663 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359666 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359670 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359674 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359678 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359680 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 359687 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 359687 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 359690 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 359694 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 359709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 359714 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359730 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359736 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359741 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359746 */     // GIR_Coverage, 4363,
     /* 359746 */     GIR_EraseRootFromParent_Done,
     /* 359747 */   // Label 7207: @359747
     /* 359747 */   GIM_Try, /*On fail goto*//*Label 7208*/ GIMT_Encode4(359852), // Rule ID 4365 //
     /* 359752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359760 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359764 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359768 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359771 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359775 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359779 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359783 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359785 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 359792 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 359792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 359795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 359799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 359814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 359819 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359825 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359841 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359846 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359851 */     // GIR_Coverage, 4365,
     /* 359851 */     GIR_EraseRootFromParent_Done,
     /* 359852 */   // Label 7208: @359852
     /* 359852 */   GIM_Try, /*On fail goto*//*Label 7209*/ GIMT_Encode4(359957), // Rule ID 4471 //
     /* 359857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359873 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359876 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359880 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359884 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359888 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359890 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 359897 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 359897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 359900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 359904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 359919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 359924 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359930 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359940 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359946 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359951 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359956 */     // GIR_Coverage, 4471,
     /* 359956 */     GIR_EraseRootFromParent_Done,
     /* 359957 */   // Label 7209: @359957
     /* 359957 */   GIM_Try, /*On fail goto*//*Label 7210*/ GIMT_Encode4(360062), // Rule ID 4473 //
     /* 359962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359970 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359974 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359978 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359981 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359985 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359989 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359993 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359995 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 360002 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 360002 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 360005 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 360009 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 360024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 360029 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 360051 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360056 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360061 */     // GIR_Coverage, 4473,
     /* 360061 */     GIR_EraseRootFromParent_Done,
     /* 360062 */   // Label 7210: @360062
     /* 360062 */   GIM_Try, /*On fail goto*//*Label 7211*/ GIMT_Encode4(360166), // Rule ID 4355 //
     /* 360067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360071 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 360077 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 360079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360087 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360090 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360094 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360098 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360102 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360104 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 360111 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 360111 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 360114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 360118 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 360133 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360139 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360149 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 360155 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360160 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360165 */     // GIR_Coverage, 4355,
     /* 360165 */     GIR_EraseRootFromParent_Done,
     /* 360166 */   // Label 7211: @360166
     /* 360166 */   GIM_Try, /*On fail goto*//*Label 7212*/ GIMT_Encode4(360270), // Rule ID 4356 //
     /* 360171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360175 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 360181 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 360183 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360187 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360191 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360194 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360198 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360202 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360206 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360208 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 360215 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 360215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 360218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 360222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 360237 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360243 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360253 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 360259 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360264 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360269 */     // GIR_Coverage, 4356,
     /* 360269 */     GIR_EraseRootFromParent_Done,
     /* 360270 */   // Label 7212: @360270
     /* 360270 */   GIM_Try, /*On fail goto*//*Label 7213*/ GIMT_Encode4(360374), // Rule ID 4463 //
     /* 360275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360279 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 360285 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 360287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360295 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360298 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360302 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360306 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360310 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360312 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 360319 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 360319 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 360322 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 360326 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 360341 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360357 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 360363 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360368 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360373 */     // GIR_Coverage, 4463,
     /* 360373 */     GIR_EraseRootFromParent_Done,
     /* 360374 */   // Label 7213: @360374
     /* 360374 */   GIM_Try, /*On fail goto*//*Label 7214*/ GIMT_Encode4(360478), // Rule ID 4464 //
     /* 360379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360383 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 360389 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 360391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360399 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360402 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360406 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360410 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360414 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360416 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 360423 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 360423 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 360426 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 360430 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 360445 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360451 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 360467 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360472 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360477 */     // GIR_Coverage, 4464,
     /* 360477 */     GIR_EraseRootFromParent_Done,
     /* 360478 */   // Label 7214: @360478
     /* 360478 */   GIM_Try, /*On fail goto*//*Label 7215*/ GIMT_Encode4(360578), // Rule ID 4359 //
     /* 360483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 360491 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360495 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360499 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360502 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360506 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360510 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360514 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360516 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 360523 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 360523 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 360526 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 360530 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 360545 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360551 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360561 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 360567 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360572 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360577 */     // GIR_Coverage, 4359,
     /* 360577 */     GIR_EraseRootFromParent_Done,
     /* 360578 */   // Label 7215: @360578
     /* 360578 */   GIM_Try, /*On fail goto*//*Label 7216*/ GIMT_Encode4(360678), // Rule ID 4361 //
     /* 360583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 360591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360599 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360602 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360606 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360610 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360614 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360616 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 360623 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 360623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 360626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 360630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 360645 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360651 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 360667 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360672 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360677 */     // GIR_Coverage, 4361,
     /* 360677 */     GIR_EraseRootFromParent_Done,
     /* 360678 */   // Label 7216: @360678
     /* 360678 */   GIM_Try, /*On fail goto*//*Label 7217*/ GIMT_Encode4(360778), // Rule ID 4467 //
     /* 360683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 360691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360699 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360702 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360706 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360710 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360714 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360716 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 360723 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 360723 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 360726 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 360730 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 360745 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360751 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360761 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 360767 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360772 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360777 */     // GIR_Coverage, 4467,
     /* 360777 */     GIR_EraseRootFromParent_Done,
     /* 360778 */   // Label 7217: @360778
     /* 360778 */   GIM_Try, /*On fail goto*//*Label 7218*/ GIMT_Encode4(360878), // Rule ID 4469 //
     /* 360783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 360791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360799 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360802 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360806 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360810 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360814 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360816 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 360823 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 360823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 360826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 360830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 360845 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360851 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360861 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 360867 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360872 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360877 */     // GIR_Coverage, 4469,
     /* 360877 */     GIR_EraseRootFromParent_Done,
     /* 360878 */   // Label 7218: @360878
     /* 360878 */   GIM_Try, /*On fail goto*//*Label 7219*/ GIMT_Encode4(360991), // Rule ID 5774 //
     /* 360883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 360891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360899 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 360903 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 360907 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360912 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 360916 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360920 */     // MIs[3] Operand 1
     /* 360920 */     // No operand predicates
     /* 360920 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360924 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 360926 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), (DUPi64:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 360926 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 360929 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi64),
     /* 360933 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360938 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 360942 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 360945 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 360947 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 360950 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 360954 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360959 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 360964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360966 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 360972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 360975 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360980 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360985 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360990 */     // GIR_Coverage, 5774,
     /* 360990 */     GIR_EraseRootFromParent_Done,
     /* 360991 */   // Label 7219: @360991
     /* 360991 */   GIM_Try, /*On fail goto*//*Label 7220*/ GIMT_Encode4(361104), // Rule ID 5814 //
     /* 360996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 361004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361012 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 361016 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 361020 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361025 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 361029 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361033 */     // MIs[3] Operand 1
     /* 361033 */     // No operand predicates
     /* 361033 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361037 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 361039 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (DUPi64:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 361039 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 361042 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi64),
     /* 361046 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361051 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 361055 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 361058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 361060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 361063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 361067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 361077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 361085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 361088 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361093 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361098 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361103 */     // GIR_Coverage, 5814,
     /* 361103 */     GIR_EraseRootFromParent_Done,
     /* 361104 */   // Label 7220: @361104
     /* 361104 */   GIM_Try, /*On fail goto*//*Label 7221*/ GIMT_Encode4(361182), // Rule ID 1941 //
     /* 361109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 361112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 361128 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361137 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 361141 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361145 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 361149 */     // MIs[2] Operand 1
     /* 361149 */     // No operand predicates
     /* 361149 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 361153 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361157 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 361161 */     // MIs[3] Operand 1
     /* 361161 */     // No operand predicates
     /* 361161 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 361163 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 361163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 361166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361168 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 361170 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 361173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 361177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 361180 */     GIR_RootConstrainSelectedInstOperands,
     /* 361181 */     // GIR_Coverage, 1941,
     /* 361181 */     GIR_EraseRootFromParent_Done,
     /* 361182 */   // Label 7221: @361182
     /* 361182 */   GIM_Try, /*On fail goto*//*Label 7222*/ GIMT_Encode4(361277), // Rule ID 7510 //
     /* 361187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 361190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 361202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 361206 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 361210 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361214 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 361217 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361221 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 361228 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 361231 */     // MIs[2] Rn
     /* 361231 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 361235 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 361240 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 361244 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361248 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 361252 */     // MIs[3] Operand 1
     /* 361252 */     // No operand predicates
     /* 361252 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 361254 */     // (vector_insert:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15858>>), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LDAP1:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 361254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAP1),
     /* 361257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361259 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 361261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 361264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 361268 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 361275 */     GIR_RootConstrainSelectedInstOperands,
     /* 361276 */     // GIR_Coverage, 7510,
     /* 361276 */     GIR_EraseRootFromParent_Done,
     /* 361277 */   // Label 7222: @361277
     /* 361277 */   GIM_Try, /*On fail goto*//*Label 7223*/ GIMT_Encode4(361366), // Rule ID 5771 //
     /* 361282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361290 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 361294 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 361302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361306 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 361310 */     // MIs[2] Operand 1
     /* 361310 */     // No operand predicates
     /* 361310 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 361314 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361318 */     // MIs[3] Operand 1
     /* 361318 */     // No operand predicates
     /* 361318 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 361320 */     // (vector_insert:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v2f64] } ZPR:{ *:[nxv2f64] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$Immn)
     /* 361320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 361323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361332 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 361338 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361343 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 361351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361353 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 361355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 361358 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361361 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 361364 */     GIR_RootConstrainSelectedInstOperands,
     /* 361365 */     // GIR_Coverage, 5771,
     /* 361365 */     GIR_EraseRootFromParent_Done,
     /* 361366 */   // Label 7223: @361366
     /* 361366 */   GIM_Try, /*On fail goto*//*Label 7224*/ GIMT_Encode4(361455), // Rule ID 5811 //
     /* 361371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 361383 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361387 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 361391 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361395 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 361399 */     // MIs[2] Operand 1
     /* 361399 */     // No operand predicates
     /* 361399 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 361403 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361407 */     // MIs[3] Operand 1
     /* 361407 */     // No operand predicates
     /* 361407 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 361409 */     // (vector_insert:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v2i64] } ZPR:{ *:[nxv2i64] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$Immn)
     /* 361409 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 361412 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361416 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361421 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 361427 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361432 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 361440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361442 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 361444 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 361447 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361450 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 361453 */     GIR_RootConstrainSelectedInstOperands,
     /* 361454 */     // GIR_Coverage, 5811,
     /* 361454 */     GIR_EraseRootFromParent_Done,
     /* 361455 */   // Label 7224: @361455
     /* 361455 */   GIM_Try, /*On fail goto*//*Label 7225*/ GIMT_Encode4(361522), // Rule ID 5773 //
     /* 361460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 361476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 361489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361493 */     // MIs[2] Operand 1
     /* 361493 */     // No operand predicates
     /* 361493 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 361497 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361501 */     // MIs[3] Operand 1
     /* 361501 */     // No operand predicates
     /* 361501 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 361503 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 361503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 361506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361508 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 361510 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 361513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 361517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 361520 */     GIR_RootConstrainSelectedInstOperands,
     /* 361521 */     // GIR_Coverage, 5773,
     /* 361521 */     GIR_EraseRootFromParent_Done,
     /* 361522 */   // Label 7225: @361522
     /* 361522 */   GIM_Try, /*On fail goto*//*Label 7226*/ GIMT_Encode4(361620), // Rule ID 5775 //
     /* 361527 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 361543 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361547 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 361556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361560 */     // MIs[2] Operand 1
     /* 361560 */     // No operand predicates
     /* 361560 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 361564 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361568 */     // MIs[3] Operand 1
     /* 361568 */     // No operand predicates
     /* 361568 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 361570 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (vector_extract:{ *:[f64] } V64:{ *:[v1f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 361570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 361573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361582 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 361585 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 361589 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 361592 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361597 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 361605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361607 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 361609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 361612 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 361618 */     GIR_RootConstrainSelectedInstOperands,
     /* 361619 */     // GIR_Coverage, 5775,
     /* 361619 */     GIR_EraseRootFromParent_Done,
     /* 361620 */   // Label 7226: @361620
     /* 361620 */   GIM_Try, /*On fail goto*//*Label 7227*/ GIMT_Encode4(361687), // Rule ID 5813 //
     /* 361625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 361641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 361654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361658 */     // MIs[2] Operand 1
     /* 361658 */     // No operand predicates
     /* 361658 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 361662 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361666 */     // MIs[3] Operand 1
     /* 361666 */     // No operand predicates
     /* 361666 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 361668 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 361668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 361671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361673 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 361675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 361678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 361682 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 361685 */     GIR_RootConstrainSelectedInstOperands,
     /* 361686 */     // GIR_Coverage, 5813,
     /* 361686 */     GIR_EraseRootFromParent_Done,
     /* 361687 */   // Label 7227: @361687
     /* 361687 */   GIM_Try, /*On fail goto*//*Label 7228*/ GIMT_Encode4(361785), // Rule ID 5815 //
     /* 361692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361704 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 361708 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361717 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 361721 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361725 */     // MIs[2] Operand 1
     /* 361725 */     // No operand predicates
     /* 361725 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 361729 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361733 */     // MIs[3] Operand 1
     /* 361733 */     // No operand predicates
     /* 361733 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 361735 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (vector_extract:{ *:[i64] } V64:{ *:[v1i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 361735 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 361738 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361742 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361747 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 361750 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 361754 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 361757 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361762 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 361770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361772 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 361774 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 361777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361780 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 361783 */     GIR_RootConstrainSelectedInstOperands,
     /* 361784 */     // GIR_Coverage, 5815,
     /* 361784 */     GIR_EraseRootFromParent_Done,
     /* 361785 */   // Label 7228: @361785
     /* 361785 */   GIM_Try, /*On fail goto*//*Label 7229*/ GIMT_Encode4(361851), // Rule ID 5719 //
     /* 361790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 361798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 361802 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361806 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 361808 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), GPR64:{ *:[i64] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), GPR64:{ *:[i64] }:$Rn, dsub:{ *:[i32] })
     /* 361808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 361811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 361815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361820 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 361825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361827 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 361832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 361835 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361840 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361845 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 361850 */     // GIR_Coverage, 5719,
     /* 361850 */     GIR_EraseRootFromParent_Done,
     /* 361851 */   // Label 7229: @361851
     /* 361851 */   GIM_Try, /*On fail goto*//*Label 7230*/ GIMT_Encode4(361917), // Rule ID 5733 //
     /* 361856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 361864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361868 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 361874 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rn, dsub:{ *:[i32] })
     /* 361874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 361877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 361881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 361891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 361898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 361901 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361906 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361911 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361916 */     // GIR_Coverage, 5733,
     /* 361916 */     GIR_EraseRootFromParent_Done,
     /* 361917 */   // Label 7230: @361917
     /* 361917 */   GIM_Try, /*On fail goto*//*Label 7231*/ GIMT_Encode4(361986), // Rule ID 6506 //
     /* 361922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361934 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361937 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 361941 */     // MIs[1] Rn
     /* 361941 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 361945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 361950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 361954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361958 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 361962 */     // MIs[2] Operand 1
     /* 361962 */     // No operand predicates
     /* 361962 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361964 */     // (vector_insert:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LD1i64:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 361964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i64),
     /* 361967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361969 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 361971 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 361974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 361978 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361984 */     GIR_RootConstrainSelectedInstOperands,
     /* 361985 */     // GIR_Coverage, 6506,
     /* 361985 */     GIR_EraseRootFromParent_Done,
     /* 361986 */   // Label 7231: @361986
     /* 361986 */   GIM_Try, /*On fail goto*//*Label 7232*/ GIMT_Encode4(362055), // Rule ID 6507 //
     /* 361991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362003 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362006 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 362010 */     // MIs[1] Rn
     /* 362010 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 362014 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 362019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 362023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362027 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 362031 */     // MIs[2] Operand 1
     /* 362031 */     // No operand predicates
     /* 362031 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362033 */     // (vector_insert:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LD1i64:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 362033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i64),
     /* 362036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362038 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 362040 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 362043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 362047 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362053 */     GIR_RootConstrainSelectedInstOperands,
     /* 362054 */     // GIR_Coverage, 6507,
     /* 362054 */     GIR_EraseRootFromParent_Done,
     /* 362055 */   // Label 7232: @362055
     /* 362055 */   GIM_Try, /*On fail goto*//*Label 7233*/ GIMT_Encode4(362137), // Rule ID 7509 //
     /* 362060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 362063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362075 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 362078 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 362082 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 362089 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 362092 */     // MIs[1] Rn
     /* 362092 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 362096 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 362101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 362105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362109 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 362113 */     // MIs[2] Operand 1
     /* 362113 */     // No operand predicates
     /* 362113 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362115 */     // (vector_insert:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15858>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LDAP1:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 362115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAP1),
     /* 362118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362120 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 362122 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 362125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 362129 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362135 */     GIR_RootConstrainSelectedInstOperands,
     /* 362136 */     // GIR_Coverage, 7509,
     /* 362136 */     GIR_EraseRootFromParent_Done,
     /* 362137 */   // Label 7233: @362137
     /* 362137 */   GIM_Try, /*On fail goto*//*Label 7234*/ GIMT_Encode4(362186), // Rule ID 5740 //
     /* 362142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 362150 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 362154 */     // MIs[1] Operand 1
     /* 362154 */     // No operand predicates
     /* 362154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 362158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362162 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 362166 */     // MIs[2] Operand 1
     /* 362166 */     // No operand predicates
     /* 362166 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362168 */     // (vector_insert:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (INSvi64gpr:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, XZR:{ *:[i64] })
     /* 362168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64gpr),
     /* 362171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362173 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 362175 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 362178 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 362184 */     GIR_RootConstrainSelectedInstOperands,
     /* 362185 */     // GIR_Coverage, 5740,
     /* 362185 */     GIR_EraseRootFromParent_Done,
     /* 362186 */   // Label 7234: @362186
     /* 362186 */   GIM_Try, /*On fail goto*//*Label 7235*/ GIMT_Encode4(362287), // Rule ID 5820 //
     /* 362191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 362199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 362203 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 362212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362216 */     // MIs[2] Operand 1
     /* 362216 */     // No operand predicates
     /* 362216 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362218 */     // (vector_insert:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$src, (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR64:{ *:[f64] }:$Sn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 362218 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 362221 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 362225 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362230 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 362232 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 362235 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 362239 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362244 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 362247 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 362251 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 362254 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362259 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362264 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 362272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362274 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 362276 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immd
     /* 362279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362285 */     GIR_RootConstrainSelectedInstOperands,
     /* 362286 */     // GIR_Coverage, 5820,
     /* 362286 */     GIR_EraseRootFromParent_Done,
     /* 362287 */   // Label 7235: @362287
     /* 362287 */   GIM_Try, /*On fail goto*//*Label 7236*/ GIMT_Encode4(362331), // Rule ID 1937 //
     /* 362292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 362295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 362303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 362307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362311 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 362315 */     // MIs[1] Operand 1
     /* 362315 */     // No operand predicates
     /* 362315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362317 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (INSvi64gpr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] }):$idx, GPR64:{ *:[i64] }:$Rn)
     /* 362317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64gpr),
     /* 362320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362322 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 362324 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 362327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 362329 */     GIR_RootConstrainSelectedInstOperands,
     /* 362330 */     // GIR_Coverage, 1937,
     /* 362330 */     GIR_EraseRootFromParent_Done,
     /* 362331 */   // Label 7236: @362331
     /* 362331 */   GIM_Try, /*On fail goto*//*Label 7237*/ GIMT_Encode4(362427), // Rule ID 5744 //
     /* 362336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 362348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362352 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 362356 */     // MIs[1] Operand 1
     /* 362356 */     // No operand predicates
     /* 362356 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362358 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm, (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 362358 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 362361 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 362365 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362370 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 362372 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 362375 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 362379 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362384 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 362387 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 362391 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 362394 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362399 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362404 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 362412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362414 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 362416 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 362419 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362425 */     GIR_RootConstrainSelectedInstOperands,
     /* 362426 */     // GIR_Coverage, 5744,
     /* 362426 */     GIR_EraseRootFromParent_Done,
     /* 362427 */   // Label 7237: @362427
     /* 362427 */   GIM_Reject,
     /* 362428 */ // Label 7202: @362428
     /* 362428 */ GIM_Reject,
     /* 362429 */ // Label 7150: @362429
     /* 362429 */ GIM_Try, /*On fail goto*//*Label 7238*/ GIMT_Encode4(366068),
     /* 362434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 362437 */   GIM_Try, /*On fail goto*//*Label 7239*/ GIMT_Encode4(362563), // Rule ID 4297 //
     /* 362442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 362445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362456 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 362462 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 362464 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362468 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362472 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362475 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 362479 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 362486 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 362490 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362494 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362496 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 362503 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 362503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 362506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 362510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 362520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 362525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 362530 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362552 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362557 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362562 */     // GIR_Coverage, 4297,
     /* 362562 */     GIR_EraseRootFromParent_Done,
     /* 362563 */   // Label 7239: @362563
     /* 362563 */   GIM_Try, /*On fail goto*//*Label 7240*/ GIMT_Encode4(362689), // Rule ID 4298 //
     /* 362568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 362571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362582 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 362588 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 362590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362598 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362601 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 362605 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 362612 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 362616 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362620 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362622 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 362629 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 362629 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 362632 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 362636 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 362646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 362651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 362656 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362672 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362678 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362683 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362688 */     // GIR_Coverage, 4298,
     /* 362688 */     GIR_EraseRootFromParent_Done,
     /* 362689 */   // Label 7240: @362689
     /* 362689 */   GIM_Try, /*On fail goto*//*Label 7241*/ GIMT_Encode4(362808), // Rule ID 4405 //
     /* 362694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 362697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362708 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 362714 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 362716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362724 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362727 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 362731 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 362735 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362739 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362741 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 362748 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 362748 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 362751 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 362755 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 362765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 362770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 362775 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362781 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362791 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362797 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362802 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362807 */     // GIR_Coverage, 4405,
     /* 362807 */     GIR_EraseRootFromParent_Done,
     /* 362808 */   // Label 7241: @362808
     /* 362808 */   GIM_Try, /*On fail goto*//*Label 7242*/ GIMT_Encode4(362927), // Rule ID 4406 //
     /* 362813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 362816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362827 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 362833 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 362835 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362839 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362843 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362846 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 362850 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 362854 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362858 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362860 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 362867 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 362867 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 362870 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 362874 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 362884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 362889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 362894 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362900 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362910 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362916 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362921 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362926 */     // GIR_Coverage, 4406,
     /* 362926 */     GIR_EraseRootFromParent_Done,
     /* 362927 */   // Label 7242: @362927
     /* 362927 */   GIM_Try, /*On fail goto*//*Label 7243*/ GIMT_Encode4(363049), // Rule ID 4303 //
     /* 362932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 362935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 362950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362958 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362961 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 362965 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 362972 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 362976 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362980 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362982 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 362989 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 362989 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 362992 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 362996 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 363011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 363016 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363032 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 363038 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363043 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363048 */     // GIR_Coverage, 4303,
     /* 363048 */     GIR_EraseRootFromParent_Done,
     /* 363049 */   // Label 7243: @363049
     /* 363049 */   GIM_Try, /*On fail goto*//*Label 7244*/ GIMT_Encode4(363171), // Rule ID 4305 //
     /* 363054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 363057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 363072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363080 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363083 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363087 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 363094 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363098 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363102 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363104 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 363111 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 363111 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 363114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 363118 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 363133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 363138 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363154 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 363160 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363165 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363170 */     // GIR_Coverage, 4305,
     /* 363170 */     GIR_EraseRootFromParent_Done,
     /* 363171 */   // Label 7244: @363171
     /* 363171 */   GIM_Try, /*On fail goto*//*Label 7245*/ GIMT_Encode4(363286), // Rule ID 4411 //
     /* 363176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 363179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 363194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363202 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363205 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363209 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363213 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363217 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363219 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 363226 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 363226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 363229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 363233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 363248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 363253 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363269 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 363275 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363280 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363285 */     // GIR_Coverage, 4411,
     /* 363285 */     GIR_EraseRootFromParent_Done,
     /* 363286 */   // Label 7245: @363286
     /* 363286 */   GIM_Try, /*On fail goto*//*Label 7246*/ GIMT_Encode4(363401), // Rule ID 4413 //
     /* 363291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 363294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 363309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363317 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363320 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363324 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363328 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363332 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363334 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 363341 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 363341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 363344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 363348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 363363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 363368 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363384 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 363390 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363395 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363400 */     // GIR_Coverage, 4413,
     /* 363400 */     GIR_EraseRootFromParent_Done,
     /* 363401 */   // Label 7246: @363401
     /* 363401 */   GIM_Try, /*On fail goto*//*Label 7247*/ GIMT_Encode4(363522), // Rule ID 4295 //
     /* 363406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 363409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363420 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 363426 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 363428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363436 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363439 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363443 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 363450 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363454 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363458 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363460 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 363467 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 363467 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 363470 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 363474 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 363489 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363495 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363505 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 363511 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363516 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363521 */     // GIR_Coverage, 4295,
     /* 363521 */     GIR_EraseRootFromParent_Done,
     /* 363522 */   // Label 7247: @363522
     /* 363522 */   GIM_Try, /*On fail goto*//*Label 7248*/ GIMT_Encode4(363643), // Rule ID 4296 //
     /* 363527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 363530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363541 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 363547 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 363549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363557 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363560 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363564 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 363571 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363575 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363579 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363581 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 363588 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 363588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 363591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 363595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 363610 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363616 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363626 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 363632 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363637 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363642 */     // GIR_Coverage, 4296,
     /* 363642 */     GIR_EraseRootFromParent_Done,
     /* 363643 */   // Label 7248: @363643
     /* 363643 */   GIM_Try, /*On fail goto*//*Label 7249*/ GIMT_Encode4(363757), // Rule ID 4403 //
     /* 363648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 363651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363662 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 363668 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 363670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363678 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363681 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363685 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363689 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363693 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363695 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 363702 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 363702 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 363705 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 363709 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 363724 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363730 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 363746 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363751 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363756 */     // GIR_Coverage, 4403,
     /* 363756 */     GIR_EraseRootFromParent_Done,
     /* 363757 */   // Label 7249: @363757
     /* 363757 */   GIM_Try, /*On fail goto*//*Label 7250*/ GIMT_Encode4(363871), // Rule ID 4404 //
     /* 363762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 363765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363776 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 363782 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 363784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363792 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363795 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363799 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363803 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363807 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363809 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 363816 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 363816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 363819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 363823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 363838 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363844 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 363860 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363865 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363870 */     // GIR_Coverage, 4404,
     /* 363870 */     GIR_EraseRootFromParent_Done,
     /* 363871 */   // Label 7250: @363871
     /* 363871 */   GIM_Try, /*On fail goto*//*Label 7251*/ GIMT_Encode4(363988), // Rule ID 4299 //
     /* 363876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 363879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 363894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363902 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363905 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363909 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 363916 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363920 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363924 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363926 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 363933 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 363933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 363936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 363940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 363955 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363961 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 363977 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363982 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363987 */     // GIR_Coverage, 4299,
     /* 363987 */     GIR_EraseRootFromParent_Done,
     /* 363988 */   // Label 7251: @363988
     /* 363988 */   GIM_Try, /*On fail goto*//*Label 7252*/ GIMT_Encode4(364105), // Rule ID 4301 //
     /* 363993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 363996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 364011 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364015 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364019 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364022 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364026 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 364033 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364037 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364041 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364043 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 364050 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 364050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 364053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 364057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 364072 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364078 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364088 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 364094 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364099 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364104 */     // GIR_Coverage, 4301,
     /* 364104 */     GIR_EraseRootFromParent_Done,
     /* 364105 */   // Label 7252: @364105
     /* 364105 */   GIM_Try, /*On fail goto*//*Label 7253*/ GIMT_Encode4(364215), // Rule ID 4407 //
     /* 364110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 364113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 364116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 364128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364136 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364139 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364143 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364147 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364151 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364153 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 364160 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 364160 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 364163 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 364167 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 364182 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364188 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364198 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 364204 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364209 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364214 */     // GIR_Coverage, 4407,
     /* 364214 */     GIR_EraseRootFromParent_Done,
     /* 364215 */   // Label 7253: @364215
     /* 364215 */   GIM_Try, /*On fail goto*//*Label 7254*/ GIMT_Encode4(364325), // Rule ID 4409 //
     /* 364220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 364223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 364226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 364238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364246 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364249 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364253 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364257 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364261 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364263 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 364270 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 364270 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 364273 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 364277 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 364292 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364308 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 364314 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364319 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364324 */     // GIR_Coverage, 4409,
     /* 364324 */     GIR_EraseRootFromParent_Done,
     /* 364325 */   // Label 7254: @364325
     /* 364325 */   GIM_Try, /*On fail goto*//*Label 7255*/ GIMT_Encode4(364455), // Rule ID 6519 //
     /* 364330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 364333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 364336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 364339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 364351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364359 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364362 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364366 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 364373 */     // MIs[2] Rn
     /* 364373 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 364377 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 364382 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364386 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364388 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (LD1i8:{ *:[f128] } (IMPLICIT_DEF:{ *:[v16i8] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 364388 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 364391 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 364395 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 364402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 364405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 364409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364414 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 364417 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 364420 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 364424 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364430 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364437 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 364444 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364449 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364454 */     // GIR_Coverage, 6519,
     /* 364454 */     GIR_EraseRootFromParent_Done,
     /* 364455 */   // Label 7255: @364455
     /* 364455 */   GIM_Try, /*On fail goto*//*Label 7256*/ GIMT_Encode4(364595), // Rule ID 5760 //
     /* 364460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 364463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 364466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 364478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 364486 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 364490 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 364499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364503 */     // MIs[2] Operand 1
     /* 364503 */     // No operand predicates
     /* 364503 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 364507 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364511 */     // MIs[3] Operand 1
     /* 364511 */     // No operand predicates
     /* 364511 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 364513 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$src, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 364513 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 364516 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364520 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364525 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 364528 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 364532 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 364535 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364540 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364545 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 364548 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 364552 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364557 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 364560 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 364563 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 364567 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 364570 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364577 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 364584 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364589 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364594 */     // GIR_Coverage, 5760,
     /* 364594 */     GIR_EraseRootFromParent_Done,
     /* 364595 */   // Label 7256: @364595
     /* 364595 */   GIM_Try, /*On fail goto*//*Label 7257*/ GIMT_Encode4(364766), // Rule ID 5761 //
     /* 364600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 364603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 364606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364610 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 364618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 364626 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 364630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 364639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364643 */     // MIs[2] Operand 1
     /* 364643 */     // No operand predicates
     /* 364643 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 364647 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364651 */     // MIs[3] Operand 1
     /* 364651 */     // No operand predicates
     /* 364651 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 364653 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$src, (vector_extract:{ *:[f16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 364653 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 364656 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364660 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364665 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 364668 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 364672 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 364675 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364680 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364685 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 364688 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364692 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364697 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 364700 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 364704 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 364707 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364712 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 364720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 364724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364729 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 364732 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 364735 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 364738 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 364741 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364748 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 364755 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364760 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364765 */     // GIR_Coverage, 5761,
     /* 364765 */     GIR_EraseRootFromParent_Done,
     /* 364766 */   // Label 7257: @364766
     /* 364766 */   GIM_Try, /*On fail goto*//*Label 7258*/ GIMT_Encode4(364906), // Rule ID 5800 //
     /* 364771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 364774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 364777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 364789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 364797 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 364801 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 364810 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364814 */     // MIs[2] Operand 1
     /* 364814 */     // No operand predicates
     /* 364814 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 364818 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364822 */     // MIs[3] Operand 1
     /* 364822 */     // No operand predicates
     /* 364822 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 364824 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 364824 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 364827 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364831 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364836 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 364839 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 364843 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 364846 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364851 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364856 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 364859 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 364863 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364868 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 364871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 364874 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 364878 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 364881 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364888 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 364895 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364900 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364905 */     // GIR_Coverage, 5800,
     /* 364905 */     GIR_EraseRootFromParent_Done,
     /* 364906 */   // Label 7258: @364906
     /* 364906 */   GIM_Try, /*On fail goto*//*Label 7259*/ GIMT_Encode4(365077), // Rule ID 5801 //
     /* 364911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 364914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 364917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 364929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 364937 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 364941 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364946 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 364950 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364954 */     // MIs[2] Operand 1
     /* 364954 */     // No operand predicates
     /* 364954 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 364958 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364962 */     // MIs[3] Operand 1
     /* 364962 */     // No operand predicates
     /* 364962 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 364964 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 364964 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 364967 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364971 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364976 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 364979 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 364983 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 364986 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364991 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364996 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 364999 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365003 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365008 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 365011 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 365015 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 365018 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365023 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365028 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 365031 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 365035 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365040 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 365043 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 365046 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 365049 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 365052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365059 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 365066 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365071 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365076 */     // GIR_Coverage, 5801,
     /* 365076 */     GIR_EraseRootFromParent_Done,
     /* 365077 */   // Label 7259: @365077
     /* 365077 */   GIM_Try, /*On fail goto*//*Label 7260*/ GIMT_Encode4(365156), // Rule ID 5713 //
     /* 365082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 365085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 365088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 365100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 365104 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365108 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365110 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 365110 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 365113 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365117 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365122 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 365126 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365139 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 365145 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365150 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365155 */     // GIR_Coverage, 5713,
     /* 365155 */     GIR_EraseRootFromParent_Done,
     /* 365156 */   // Label 7260: @365156
     /* 365156 */   GIM_Try, /*On fail goto*//*Label 7261*/ GIMT_Encode4(365232), // Rule ID 5721 //
     /* 365161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 365164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 365167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 365179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365183 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365189 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 365189 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 365192 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 365196 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 365206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 365213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 365216 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365221 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365226 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365231 */     // GIR_Coverage, 5721,
     /* 365231 */     GIR_EraseRootFromParent_Done,
     /* 365232 */   // Label 7261: @365232
     /* 365232 */   GIM_Try, /*On fail goto*//*Label 7262*/ GIMT_Encode4(365308), // Rule ID 5725 //
     /* 365237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 365240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 365243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 365255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365259 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365265 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 365265 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 365268 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 365272 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365277 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 365282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365284 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 365289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 365292 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365297 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365302 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365307 */     // GIR_Coverage, 5725,
     /* 365307 */     GIR_EraseRootFromParent_Done,
     /* 365308 */   // Label 7262: @365308
     /* 365308 */   GIM_Try, /*On fail goto*//*Label 7263*/ GIMT_Encode4(365453), // Rule ID 5737 //
     /* 365313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 365316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 365319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 365335 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 365339 */     // MIs[1] Operand 1
     /* 365339 */     // No operand predicates
     /* 365339 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 365343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365347 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 365351 */     // MIs[2] Operand 1
     /* 365351 */     // No operand predicates
     /* 365351 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365353 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, WZR:{ *:[i32] }), dsub:{ *:[i32] })
     /* 365353 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 365356 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 365360 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365365 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 365367 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 365370 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 365374 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365379 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 365382 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 365386 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 365389 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365394 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365399 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365404 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 365407 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 365411 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365416 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 365419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /* 365422 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 365428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365435 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 365442 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365447 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365452 */     // GIR_Coverage, 5737,
     /* 365452 */     GIR_EraseRootFromParent_Done,
     /* 365453 */   // Label 7263: @365453
     /* 365453 */   GIM_Try, /*On fail goto*//*Label 7264*/ GIMT_Encode4(365602), // Rule ID 6523 //
     /* 365458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 365461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 365464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 365480 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 365483 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 365487 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 365494 */     // MIs[1] Rn
     /* 365494 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 365498 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 365503 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 365507 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365511 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 365515 */     // MIs[2] Operand 1
     /* 365515 */     // No operand predicates
     /* 365515 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365517 */     // (vector_insert:{ *:[v4i16] } VecListOne64:{ *:[v4i16] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (LD1i16:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 365517 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 365520 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365524 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365529 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 365532 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 365536 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 365539 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365544 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365549 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 365552 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 365556 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365561 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 365564 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 365567 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 365571 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 365577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365584 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 365591 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365596 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365601 */     // GIR_Coverage, 6523,
     /* 365601 */     GIR_EraseRootFromParent_Done,
     /* 365602 */   // Label 7264: @365602
     /* 365602 */   GIM_Try, /*On fail goto*//*Label 7265*/ GIMT_Encode4(365744), // Rule ID 6526 //
     /* 365607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 365610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 365613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 365629 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 365632 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 365636 */     // MIs[1] Rn
     /* 365636 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 365640 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 365645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 365649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365653 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 365657 */     // MIs[2] Operand 1
     /* 365657 */     // No operand predicates
     /* 365657 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365659 */     // (vector_insert:{ *:[v4f16] } VecListOne64:{ *:[v4f16] }:$Rd, (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (LD1i16:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 365659 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 365662 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365666 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365671 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 365674 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 365678 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 365681 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365686 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 365694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 365698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365703 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 365706 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 365709 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 365713 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 365719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365726 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 365733 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365738 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365743 */     // GIR_Coverage, 6526,
     /* 365743 */     GIR_EraseRootFromParent_Done,
     /* 365744 */   // Label 7265: @365744
     /* 365744 */   GIM_Try, /*On fail goto*//*Label 7266*/ GIMT_Encode4(365932), // Rule ID 5735 //
     /* 365749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 365752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 365755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 365771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365775 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 365779 */     // MIs[1] Operand 1
     /* 365779 */     // No operand predicates
     /* 365779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365781 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 365781 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s16,
     /* 365784 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 365788 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 365795 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s16,
     /* 365798 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 365802 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365807 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 365810 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 365814 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 365817 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365822 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365827 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365832 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 365835 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 365839 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365844 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 365846 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 365849 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 365853 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365858 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 365861 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 365865 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 365868 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365873 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365878 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365883 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 365886 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 365890 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365895 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 365898 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 365901 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 365904 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 365907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365914 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 365921 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365926 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365931 */     // GIR_Coverage, 5735,
     /* 365931 */     GIR_EraseRootFromParent_Done,
     /* 365932 */   // Label 7266: @365932
     /* 365932 */   GIM_Try, /*On fail goto*//*Label 7267*/ GIMT_Encode4(366067), // Rule ID 5746 //
     /* 365937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 365940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 365943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 365955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 365959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365963 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 365967 */     // MIs[1] Operand 1
     /* 365967 */     // No operand predicates
     /* 365967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365969 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 365969 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 365972 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 365976 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365981 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 365983 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 365986 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 365990 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365995 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 365998 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 366002 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 366005 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366010 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366015 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366020 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 366023 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 366027 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366032 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 366035 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 366038 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 366042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366049 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 366056 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366061 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366066 */     // GIR_Coverage, 5746,
     /* 366066 */     GIR_EraseRootFromParent_Done,
     /* 366067 */   // Label 7267: @366067
     /* 366067 */   GIM_Reject,
     /* 366068 */ // Label 7238: @366068
     /* 366068 */ GIM_Reject,
     /* 366069 */ // Label 7151: @366069
     /* 366069 */ GIM_Try, /*On fail goto*//*Label 7268*/ GIMT_Encode4(369136),
     /* 366074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 366077 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 366080 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 366083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366087 */   GIM_Try, /*On fail goto*//*Label 7269*/ GIMT_Encode4(366196), // Rule ID 4321 //
     /* 366092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366096 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 366102 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 366104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 366112 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 366115 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 366119 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 366123 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 366127 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366129 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 366136 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 366136 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 366139 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 366143 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 366153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 366158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 366163 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 366169 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 366174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 366185 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366190 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366195 */     // GIR_Coverage, 4321,
     /* 366195 */     GIR_EraseRootFromParent_Done,
     /* 366196 */   // Label 7269: @366196
     /* 366196 */   GIM_Try, /*On fail goto*//*Label 7270*/ GIMT_Encode4(366305), // Rule ID 4322 //
     /* 366201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366205 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 366211 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 366213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 366221 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 366224 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 366228 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 366232 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 366236 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366238 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 366245 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 366245 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 366248 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 366252 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 366262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 366267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 366272 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 366278 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 366283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366288 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 366294 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366299 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366304 */     // GIR_Coverage, 4322,
     /* 366304 */     GIR_EraseRootFromParent_Done,
     /* 366305 */   // Label 7270: @366305
     /* 366305 */   GIM_Try, /*On fail goto*//*Label 7271*/ GIMT_Encode4(366414), // Rule ID 4429 //
     /* 366310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366314 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 366320 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 366322 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366326 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 366330 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 366333 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 366337 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 366341 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 366345 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366347 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 366354 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 366354 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 366357 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 366361 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 366371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 366376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 366381 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 366387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 366392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366397 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 366403 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366408 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366413 */     // GIR_Coverage, 4429,
     /* 366413 */     GIR_EraseRootFromParent_Done,
     /* 366414 */   // Label 7271: @366414
     /* 366414 */   GIM_Try, /*On fail goto*//*Label 7272*/ GIMT_Encode4(366523), // Rule ID 4430 //
     /* 366419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366423 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 366429 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 366431 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366435 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 366439 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 366442 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 366446 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 366450 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 366454 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366456 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 366463 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 366463 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 366466 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 366470 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 366480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 366485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 366490 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 366496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 366501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366506 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 366512 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366517 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366522 */     // GIR_Coverage, 4430,
     /* 366522 */     GIR_EraseRootFromParent_Done,
     /* 366523 */   // Label 7272: @366523
     /* 366523 */   GIM_Try, /*On fail goto*//*Label 7273*/ GIMT_Encode4(366628), // Rule ID 4327 //
     /* 366528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 366536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 366544 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 366547 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 366551 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 366555 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 366559 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366561 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 366568 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 366568 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 366571 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 366575 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 366585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 366590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 366595 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 366601 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 366606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 366617 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366622 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366627 */     // GIR_Coverage, 4327,
     /* 366627 */     GIR_EraseRootFromParent_Done,
     /* 366628 */   // Label 7273: @366628
     /* 366628 */   GIM_Try, /*On fail goto*//*Label 7274*/ GIMT_Encode4(366733), // Rule ID 4329 //
     /* 366633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 366641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 366649 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 366652 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 366656 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 366660 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 366664 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366666 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 366673 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 366673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 366676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 366680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 366690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 366695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 366700 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 366706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 366711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366716 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 366722 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366727 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366732 */     // GIR_Coverage, 4329,
     /* 366732 */     GIR_EraseRootFromParent_Done,
     /* 366733 */   // Label 7274: @366733
     /* 366733 */   GIM_Try, /*On fail goto*//*Label 7275*/ GIMT_Encode4(366838), // Rule ID 4435 //
     /* 366738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 366746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 366754 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 366757 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 366761 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 366765 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 366769 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366771 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 366778 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 366778 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 366781 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 366785 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 366795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 366800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 366805 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 366811 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 366816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366821 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 366827 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366832 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366837 */     // GIR_Coverage, 4435,
     /* 366837 */     GIR_EraseRootFromParent_Done,
     /* 366838 */   // Label 7275: @366838
     /* 366838 */   GIM_Try, /*On fail goto*//*Label 7276*/ GIMT_Encode4(366943), // Rule ID 4437 //
     /* 366843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 366851 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 366859 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 366862 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 366866 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 366870 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 366874 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366876 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 366883 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 366883 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 366886 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 366890 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 366900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 366905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 366910 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 366916 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 366921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 366932 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366937 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366942 */     // GIR_Coverage, 4437,
     /* 366942 */     GIR_EraseRootFromParent_Done,
     /* 366943 */   // Label 7276: @366943
     /* 366943 */   GIM_Try, /*On fail goto*//*Label 7277*/ GIMT_Encode4(367047), // Rule ID 4319 //
     /* 366948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366952 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 366958 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 366960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 366968 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 366971 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 366975 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 366979 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 366983 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366985 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 366992 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 366992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 366995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 366999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 367009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 367014 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 367020 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367030 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 367036 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367041 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367046 */     // GIR_Coverage, 4319,
     /* 367046 */     GIR_EraseRootFromParent_Done,
     /* 367047 */   // Label 7277: @367047
     /* 367047 */   GIM_Try, /*On fail goto*//*Label 7278*/ GIMT_Encode4(367151), // Rule ID 4320 //
     /* 367052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367056 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 367062 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 367064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367072 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367075 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 367079 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 367083 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367087 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367089 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 367096 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 367096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 367099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 367103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 367113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 367118 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 367124 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367134 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 367140 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367145 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367150 */     // GIR_Coverage, 4320,
     /* 367150 */     GIR_EraseRootFromParent_Done,
     /* 367151 */   // Label 7278: @367151
     /* 367151 */   GIM_Try, /*On fail goto*//*Label 7279*/ GIMT_Encode4(367255), // Rule ID 4427 //
     /* 367156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367160 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 367166 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 367168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367176 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367179 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 367183 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 367187 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367191 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367193 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 367200 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 367200 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 367203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 367207 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 367217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 367222 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 367228 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367238 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 367244 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367249 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367254 */     // GIR_Coverage, 4427,
     /* 367254 */     GIR_EraseRootFromParent_Done,
     /* 367255 */   // Label 7279: @367255
     /* 367255 */   GIM_Try, /*On fail goto*//*Label 7280*/ GIMT_Encode4(367359), // Rule ID 4428 //
     /* 367260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367264 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 367270 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 367272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367280 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367283 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 367287 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 367291 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367295 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367297 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 367304 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 367304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 367307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 367311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 367321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 367326 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 367332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 367348 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367353 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367358 */     // GIR_Coverage, 4428,
     /* 367358 */     GIR_EraseRootFromParent_Done,
     /* 367359 */   // Label 7280: @367359
     /* 367359 */   GIM_Try, /*On fail goto*//*Label 7281*/ GIMT_Encode4(367459), // Rule ID 4323 //
     /* 367364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 367372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367380 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367383 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 367387 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 367391 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367395 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367397 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 367404 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 367404 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 367407 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 367411 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 367421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 367426 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 367432 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 367448 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367453 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367458 */     // GIR_Coverage, 4323,
     /* 367458 */     GIR_EraseRootFromParent_Done,
     /* 367459 */   // Label 7281: @367459
     /* 367459 */   GIM_Try, /*On fail goto*//*Label 7282*/ GIMT_Encode4(367559), // Rule ID 4325 //
     /* 367464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 367472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367480 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367483 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 367487 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 367491 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367495 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367497 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 367504 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 367504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 367507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 367511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 367521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 367526 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 367532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367542 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 367548 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367553 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367558 */     // GIR_Coverage, 4325,
     /* 367558 */     GIR_EraseRootFromParent_Done,
     /* 367559 */   // Label 7282: @367559
     /* 367559 */   GIM_Try, /*On fail goto*//*Label 7283*/ GIMT_Encode4(367659), // Rule ID 4431 //
     /* 367564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 367572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367580 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367583 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 367587 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 367591 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367595 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367597 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 367604 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 367604 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 367607 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 367611 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 367621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 367626 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 367632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367642 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 367648 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367653 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367658 */     // GIR_Coverage, 4431,
     /* 367658 */     GIR_EraseRootFromParent_Done,
     /* 367659 */   // Label 7283: @367659
     /* 367659 */   GIM_Try, /*On fail goto*//*Label 7284*/ GIMT_Encode4(367759), // Rule ID 4433 //
     /* 367664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 367672 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367676 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367680 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367683 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 367687 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 367691 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367695 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367697 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 367704 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 367704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 367707 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 367711 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 367721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 367726 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 367732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 367748 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367753 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367758 */     // GIR_Coverage, 4433,
     /* 367758 */     GIR_EraseRootFromParent_Done,
     /* 367759 */   // Label 7284: @367759
     /* 367759 */   GIM_Try, /*On fail goto*//*Label 7285*/ GIMT_Encode4(367872), // Rule ID 5766 //
     /* 367764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 367772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367780 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367784 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 367788 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367793 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 367797 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367801 */     // MIs[3] Operand 1
     /* 367801 */     // No operand predicates
     /* 367801 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367805 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367807 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), (DUPi32:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), ssub:{ *:[i32] })
     /* 367807 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 367810 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi32),
     /* 367814 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367819 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 367823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 367826 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 367828 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 367831 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 367835 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367840 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 367845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367847 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367850 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 367853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 367856 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367861 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367866 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367871 */     // GIR_Coverage, 5766,
     /* 367871 */     GIR_EraseRootFromParent_Done,
     /* 367872 */   // Label 7285: @367872
     /* 367872 */   GIM_Try, /*On fail goto*//*Label 7286*/ GIMT_Encode4(367985), // Rule ID 5806 //
     /* 367877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 367885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367893 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367897 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 367901 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367906 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 367910 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367914 */     // MIs[3] Operand 1
     /* 367914 */     // No operand predicates
     /* 367914 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367918 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367920 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), (DUPi32:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), ssub:{ *:[i32] })
     /* 367920 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 367923 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi32),
     /* 367927 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367932 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 367936 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 367939 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 367941 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 367944 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 367948 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367953 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 367958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367960 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 367966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 367969 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367974 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367979 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367984 */     // GIR_Coverage, 5806,
     /* 367984 */     GIR_EraseRootFromParent_Done,
     /* 367985 */   // Label 7286: @367985
     /* 367985 */   GIM_Try, /*On fail goto*//*Label 7287*/ GIMT_Encode4(368063), // Rule ID 1940 //
     /* 367990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367993 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 368001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368009 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368026 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 368030 */     // MIs[2] Operand 1
     /* 368030 */     // No operand predicates
     /* 368030 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 368034 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368038 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 368042 */     // MIs[3] Operand 1
     /* 368042 */     // No operand predicates
     /* 368042 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368044 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 368044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 368047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368049 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 368051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 368054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 368058 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 368061 */     GIR_RootConstrainSelectedInstOperands,
     /* 368062 */     // GIR_Coverage, 1940,
     /* 368062 */     GIR_EraseRootFromParent_Done,
     /* 368063 */   // Label 7287: @368063
     /* 368063 */   GIM_Try, /*On fail goto*//*Label 7288*/ GIMT_Encode4(368152), // Rule ID 5763 //
     /* 368068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 368072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 368080 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368092 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 368096 */     // MIs[2] Operand 1
     /* 368096 */     // No operand predicates
     /* 368096 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 368100 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368104 */     // MIs[3] Operand 1
     /* 368104 */     // No operand predicates
     /* 368104 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368106 */     // (vector_insert:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v4f32] } ZPR:{ *:[nxv4f32] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$Immn)
     /* 368106 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 368109 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368113 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368118 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 368124 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368129 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 368134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 368137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368139 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 368141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 368144 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 368150 */     GIR_RootConstrainSelectedInstOperands,
     /* 368151 */     // GIR_Coverage, 5763,
     /* 368151 */     GIR_EraseRootFromParent_Done,
     /* 368152 */   // Label 7288: @368152
     /* 368152 */   GIM_Try, /*On fail goto*//*Label 7289*/ GIMT_Encode4(368241), // Rule ID 5803 //
     /* 368157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 368161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 368169 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368181 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 368185 */     // MIs[2] Operand 1
     /* 368185 */     // No operand predicates
     /* 368185 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 368189 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368193 */     // MIs[3] Operand 1
     /* 368193 */     // No operand predicates
     /* 368193 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368195 */     // (vector_insert:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$Immn)
     /* 368195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 368198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368207 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 368213 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368218 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 368223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 368226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368228 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 368230 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 368233 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368236 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 368239 */     GIR_RootConstrainSelectedInstOperands,
     /* 368240 */     // GIR_Coverage, 5803,
     /* 368240 */     GIR_EraseRootFromParent_Done,
     /* 368241 */   // Label 7289: @368241
     /* 368241 */   GIM_Try, /*On fail goto*//*Label 7290*/ GIMT_Encode4(368308), // Rule ID 5765 //
     /* 368246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 368254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368262 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368266 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368279 */     // MIs[2] Operand 1
     /* 368279 */     // No operand predicates
     /* 368279 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 368283 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368287 */     // MIs[3] Operand 1
     /* 368287 */     // No operand predicates
     /* 368287 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368289 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 368289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 368292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368294 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 368296 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 368299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 368303 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 368306 */     GIR_RootConstrainSelectedInstOperands,
     /* 368307 */     // GIR_Coverage, 5765,
     /* 368307 */     GIR_EraseRootFromParent_Done,
     /* 368308 */   // Label 7290: @368308
     /* 368308 */   GIM_Try, /*On fail goto*//*Label 7291*/ GIMT_Encode4(368406), // Rule ID 5767 //
     /* 368313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 368321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 368329 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368333 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368338 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368342 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368346 */     // MIs[2] Operand 1
     /* 368346 */     // No operand predicates
     /* 368346 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 368350 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368354 */     // MIs[3] Operand 1
     /* 368354 */     // No operand predicates
     /* 368354 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368356 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (vector_extract:{ *:[f32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 368356 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 368359 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368363 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368368 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 368371 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 368375 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 368378 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368383 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 368391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368393 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 368395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 368398 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368401 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 368404 */     GIR_RootConstrainSelectedInstOperands,
     /* 368405 */     // GIR_Coverage, 5767,
     /* 368405 */     GIR_EraseRootFromParent_Done,
     /* 368406 */   // Label 7291: @368406
     /* 368406 */   GIM_Try, /*On fail goto*//*Label 7292*/ GIMT_Encode4(368473), // Rule ID 5805 //
     /* 368411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 368419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368427 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368431 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368436 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368440 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368444 */     // MIs[2] Operand 1
     /* 368444 */     // No operand predicates
     /* 368444 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 368448 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368452 */     // MIs[3] Operand 1
     /* 368452 */     // No operand predicates
     /* 368452 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368454 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 368454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 368457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368459 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 368461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 368464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 368468 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 368471 */     GIR_RootConstrainSelectedInstOperands,
     /* 368472 */     // GIR_Coverage, 5805,
     /* 368472 */     GIR_EraseRootFromParent_Done,
     /* 368473 */   // Label 7292: @368473
     /* 368473 */   GIM_Try, /*On fail goto*//*Label 7293*/ GIMT_Encode4(368571), // Rule ID 5807 //
     /* 368478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 368486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368490 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 368494 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368498 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368503 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368507 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368511 */     // MIs[2] Operand 1
     /* 368511 */     // No operand predicates
     /* 368511 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 368515 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368519 */     // MIs[3] Operand 1
     /* 368519 */     // No operand predicates
     /* 368519 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368521 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 368521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 368524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368533 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 368536 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 368540 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 368543 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368548 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 368556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368558 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 368560 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 368563 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368566 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 368569 */     GIR_RootConstrainSelectedInstOperands,
     /* 368570 */     // GIR_Coverage, 5807,
     /* 368570 */     GIR_EraseRootFromParent_Done,
     /* 368571 */   // Label 7293: @368571
     /* 368571 */   GIM_Try, /*On fail goto*//*Label 7294*/ GIMT_Encode4(368637), // Rule ID 5717 //
     /* 368576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 368584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 368588 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 368592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 368594 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), GPR32:{ *:[i32] }:$Rn, ssub:{ *:[i32] })
     /* 368594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 368597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 368601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 368611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 368618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 368621 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368626 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368631 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 368636 */     // GIR_Coverage, 5717,
     /* 368636 */     GIR_EraseRootFromParent_Done,
     /* 368637 */   // Label 7294: @368637
     /* 368637 */   GIM_Try, /*On fail goto*//*Label 7295*/ GIMT_Encode4(368703), // Rule ID 5729 //
     /* 368642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 368650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368654 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 368658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 368660 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] })
     /* 368660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 368663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 368667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 368677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368679 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 368684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 368687 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368692 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368697 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368702 */     // GIR_Coverage, 5729,
     /* 368702 */     GIR_EraseRootFromParent_Done,
     /* 368703 */   // Label 7295: @368703
     /* 368703 */   GIM_Try, /*On fail goto*//*Label 7296*/ GIMT_Encode4(368756), // Rule ID 5738 //
     /* 368708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 368716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 368720 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 368724 */     // MIs[1] Operand 1
     /* 368724 */     // No operand predicates
     /* 368724 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 368728 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368732 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 368736 */     // MIs[2] Operand 1
     /* 368736 */     // No operand predicates
     /* 368736 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368738 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (INSvi32gpr:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, WZR:{ *:[i32] })
     /* 368738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 368741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368743 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 368745 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 368748 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 368754 */     GIR_RootConstrainSelectedInstOperands,
     /* 368755 */     // GIR_Coverage, 5738,
     /* 368755 */     GIR_EraseRootFromParent_Done,
     /* 368756 */   // Label 7296: @368756
     /* 368756 */   GIM_Try, /*On fail goto*//*Label 7297*/ GIMT_Encode4(368825), // Rule ID 6504 //
     /* 368761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 368769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 368773 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 368776 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 368780 */     // MIs[1] Rn
     /* 368780 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 368784 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 368789 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 368793 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368797 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 368801 */     // MIs[2] Operand 1
     /* 368801 */     // No operand predicates
     /* 368801 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368803 */     // (vector_insert:{ *:[v4i32] } VecListOne128:{ *:[v4i32] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (LD1i32:{ *:[v4i32] } VecListOne128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 368803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 368806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368808 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 368810 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 368813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 368817 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 368823 */     GIR_RootConstrainSelectedInstOperands,
     /* 368824 */     // GIR_Coverage, 6504,
     /* 368824 */     GIR_EraseRootFromParent_Done,
     /* 368825 */   // Label 7297: @368825
     /* 368825 */   GIM_Try, /*On fail goto*//*Label 7298*/ GIMT_Encode4(368894), // Rule ID 6505 //
     /* 368830 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 368838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 368842 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 368845 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 368849 */     // MIs[1] Rn
     /* 368849 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 368853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 368858 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 368862 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368866 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 368870 */     // MIs[2] Operand 1
     /* 368870 */     // No operand predicates
     /* 368870 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368872 */     // (vector_insert:{ *:[v4f32] } VecListOne128:{ *:[v4f32] }:$Rd, (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (LD1i32:{ *:[v4f32] } VecListOne128:{ *:[v4f32] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 368872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 368875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368877 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 368879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 368882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 368886 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 368892 */     GIR_RootConstrainSelectedInstOperands,
     /* 368893 */     // GIR_Coverage, 6505,
     /* 368893 */     GIR_EraseRootFromParent_Done,
     /* 368894 */   // Label 7298: @368894
     /* 368894 */   GIM_Try, /*On fail goto*//*Label 7299*/ GIMT_Encode4(368995), // Rule ID 5818 //
     /* 368899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 368903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 368907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 368911 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 368920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368924 */     // MIs[2] Operand 1
     /* 368924 */     // No operand predicates
     /* 368924 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368926 */     // (vector_insert:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src, (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR32:{ *:[f32] }:$Sn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 368926 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 368929 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 368933 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368938 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 368940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 368943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 368947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368952 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 368955 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 368959 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 368962 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368967 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368972 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 368980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368982 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 368984 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immd
     /* 368987 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368993 */     GIR_RootConstrainSelectedInstOperands,
     /* 368994 */     // GIR_Coverage, 5818,
     /* 368994 */     GIR_EraseRootFromParent_Done,
     /* 368995 */   // Label 7299: @368995
     /* 368995 */   GIM_Try, /*On fail goto*//*Label 7300*/ GIMT_Encode4(369039), // Rule ID 1936 //
     /* 369000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369003 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 369011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 369015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369019 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 369023 */     // MIs[1] Operand 1
     /* 369023 */     // No operand predicates
     /* 369023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 369025 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (INSvi32gpr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 369025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 369028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369030 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 369032 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 369035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 369037 */     GIR_RootConstrainSelectedInstOperands,
     /* 369038 */     // GIR_Coverage, 1936,
     /* 369038 */     GIR_EraseRootFromParent_Done,
     /* 369039 */   // Label 7300: @369039
     /* 369039 */   GIM_Try, /*On fail goto*//*Label 7301*/ GIMT_Encode4(369135), // Rule ID 5743 //
     /* 369044 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 369056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369060 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 369064 */     // MIs[1] Operand 1
     /* 369064 */     // No operand predicates
     /* 369064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 369066 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 369066 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 369069 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 369073 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369078 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 369080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 369083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 369087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369092 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 369095 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 369099 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 369102 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369107 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369112 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 369120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369122 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 369124 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 369127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369133 */     GIR_RootConstrainSelectedInstOperands,
     /* 369134 */     // GIR_Coverage, 5743,
     /* 369134 */     GIR_EraseRootFromParent_Done,
     /* 369135 */   // Label 7301: @369135
     /* 369135 */   GIM_Reject,
     /* 369136 */ // Label 7268: @369136
     /* 369136 */ GIM_Reject,
     /* 369137 */ // Label 7152: @369137
     /* 369137 */ GIM_Try, /*On fail goto*//*Label 7302*/ GIMT_Encode4(372349),
     /* 369142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 369145 */   GIM_Try, /*On fail goto*//*Label 7303*/ GIMT_Encode4(369264), // Rule ID 4225 //
     /* 369150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 369153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369164 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 369170 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 369172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 369180 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 369183 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 369187 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 369191 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 369195 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369197 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 369204 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 369204 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 369207 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 369211 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 369221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 369226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 369231 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 369237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369247 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 369253 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369258 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 369263 */     // GIR_Coverage, 4225,
     /* 369263 */     GIR_EraseRootFromParent_Done,
     /* 369264 */   // Label 7303: @369264
     /* 369264 */   GIM_Try, /*On fail goto*//*Label 7304*/ GIMT_Encode4(369383), // Rule ID 4226 //
     /* 369269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 369272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369283 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 369289 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 369291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 369299 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 369302 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 369306 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 369310 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 369314 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369316 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 369323 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 369323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 369326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 369330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 369340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 369345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 369350 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 369356 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 369372 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369377 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 369382 */     // GIR_Coverage, 4226,
     /* 369382 */     GIR_EraseRootFromParent_Done,
     /* 369383 */   // Label 7304: @369383
     /* 369383 */   GIM_Try, /*On fail goto*//*Label 7305*/ GIMT_Encode4(369509), // Rule ID 4261 //
     /* 369388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 369391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369402 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 369408 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 369410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369414 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 369418 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 369421 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 369425 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 369432 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 369436 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 369440 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369442 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 369449 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 369449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 369452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 369456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 369466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 369471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 369476 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 369482 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 369498 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369503 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 369508 */     // GIR_Coverage, 4261,
     /* 369508 */     GIR_EraseRootFromParent_Done,
     /* 369509 */   // Label 7305: @369509
     /* 369509 */   GIM_Try, /*On fail goto*//*Label 7306*/ GIMT_Encode4(369635), // Rule ID 4262 //
     /* 369514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 369517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369528 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 369534 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 369536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 369544 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 369547 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 369551 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 369558 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 369562 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 369566 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369568 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 369575 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 369575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 369578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 369582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 369592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 369597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 369602 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 369608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 369624 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369629 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 369634 */     // GIR_Coverage, 4262,
     /* 369634 */     GIR_EraseRootFromParent_Done,
     /* 369635 */   // Label 7306: @369635
     /* 369635 */   GIM_Try, /*On fail goto*//*Label 7307*/ GIMT_Encode4(369750), // Rule ID 4231 //
     /* 369640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 369643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 369658 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369662 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 369666 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 369669 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 369673 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 369677 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 369681 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369683 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 369690 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 369690 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 369693 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 369697 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 369707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 369712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 369717 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 369723 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369733 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 369739 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369744 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 369749 */     // GIR_Coverage, 4231,
     /* 369749 */     GIR_EraseRootFromParent_Done,
     /* 369750 */   // Label 7307: @369750
     /* 369750 */   GIM_Try, /*On fail goto*//*Label 7308*/ GIMT_Encode4(369865), // Rule ID 4233 //
     /* 369755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 369758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 369773 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369777 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 369781 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 369784 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 369788 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 369792 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 369796 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369798 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 369805 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 369805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 369808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 369812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 369822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 369827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 369832 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 369838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369848 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 369854 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369859 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 369864 */     // GIR_Coverage, 4233,
     /* 369864 */     GIR_EraseRootFromParent_Done,
     /* 369865 */   // Label 7308: @369865
     /* 369865 */   GIM_Try, /*On fail goto*//*Label 7309*/ GIMT_Encode4(369987), // Rule ID 4267 //
     /* 369870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 369873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 369888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 369896 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 369899 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 369903 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 369910 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 369914 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 369918 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369920 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 369927 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 369927 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 369930 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 369934 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 369944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 369949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 369954 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 369960 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 369976 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369981 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 369986 */     // GIR_Coverage, 4267,
     /* 369986 */     GIR_EraseRootFromParent_Done,
     /* 369987 */   // Label 7309: @369987
     /* 369987 */   GIM_Try, /*On fail goto*//*Label 7310*/ GIMT_Encode4(370109), // Rule ID 4269 //
     /* 369992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 369995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 370010 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370014 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370018 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370021 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 370025 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 370032 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 370036 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 370040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370042 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 370049 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 370049 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 370052 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 370056 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 370066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 370071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 370076 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 370082 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 370098 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370103 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 370108 */     // GIR_Coverage, 4269,
     /* 370108 */     GIR_EraseRootFromParent_Done,
     /* 370109 */   // Label 7310: @370109
     /* 370109 */   GIM_Try, /*On fail goto*//*Label 7311*/ GIMT_Encode4(370223), // Rule ID 4223 //
     /* 370114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 370117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370128 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 370134 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 370136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370144 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370147 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 370151 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 370155 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 370159 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370161 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 370168 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 370168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 370171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 370175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 370185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 370190 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 370196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 370212 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370217 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 370222 */     // GIR_Coverage, 4223,
     /* 370222 */     GIR_EraseRootFromParent_Done,
     /* 370223 */   // Label 7311: @370223
     /* 370223 */   GIM_Try, /*On fail goto*//*Label 7312*/ GIMT_Encode4(370337), // Rule ID 4224 //
     /* 370228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 370231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370242 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 370248 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 370250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370258 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370261 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 370265 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 370269 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 370273 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370275 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 370282 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 370282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 370285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 370289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 370299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 370304 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 370310 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370320 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 370326 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370331 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 370336 */     // GIR_Coverage, 4224,
     /* 370336 */     GIR_EraseRootFromParent_Done,
     /* 370337 */   // Label 7312: @370337
     /* 370337 */   GIM_Try, /*On fail goto*//*Label 7313*/ GIMT_Encode4(370458), // Rule ID 4259 //
     /* 370342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 370345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370356 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 370362 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 370364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370372 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370375 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 370379 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 370386 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 370390 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 370394 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370396 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 370403 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 370403 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 370406 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 370410 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 370420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 370425 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 370431 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 370447 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370452 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 370457 */     // GIR_Coverage, 4259,
     /* 370457 */     GIR_EraseRootFromParent_Done,
     /* 370458 */   // Label 7313: @370458
     /* 370458 */   GIM_Try, /*On fail goto*//*Label 7314*/ GIMT_Encode4(370579), // Rule ID 4260 //
     /* 370463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 370466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370477 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 370483 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 370485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370493 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370496 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 370500 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 370507 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 370511 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 370515 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370517 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 370524 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 370524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 370527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 370531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 370541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 370546 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 370552 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370562 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 370568 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370573 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 370578 */     // GIR_Coverage, 4260,
     /* 370578 */     GIR_EraseRootFromParent_Done,
     /* 370579 */   // Label 7314: @370579
     /* 370579 */   GIM_Try, /*On fail goto*//*Label 7315*/ GIMT_Encode4(370689), // Rule ID 4227 //
     /* 370584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 370587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 370602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370606 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370610 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370613 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 370617 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 370621 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 370625 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370627 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 370634 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 370634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 370637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 370641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 370651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 370656 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 370662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370672 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 370678 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370683 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 370688 */     // GIR_Coverage, 4227,
     /* 370688 */     GIR_EraseRootFromParent_Done,
     /* 370689 */   // Label 7315: @370689
     /* 370689 */   GIM_Try, /*On fail goto*//*Label 7316*/ GIMT_Encode4(370799), // Rule ID 4229 //
     /* 370694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 370697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 370712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370716 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370720 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370723 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 370727 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 370731 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 370735 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370737 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 370744 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 370744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 370747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 370751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 370761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 370766 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 370772 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370782 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 370788 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370793 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 370798 */     // GIR_Coverage, 4229,
     /* 370798 */     GIR_EraseRootFromParent_Done,
     /* 370799 */   // Label 7316: @370799
     /* 370799 */   GIM_Try, /*On fail goto*//*Label 7317*/ GIMT_Encode4(370916), // Rule ID 4263 //
     /* 370804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 370807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 370822 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370826 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370830 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370833 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 370837 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 370844 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 370848 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 370852 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370854 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 370861 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 370861 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 370864 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 370868 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 370878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 370883 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 370889 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 370905 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370910 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 370915 */     // GIR_Coverage, 4263,
     /* 370915 */     GIR_EraseRootFromParent_Done,
     /* 370916 */   // Label 7317: @370916
     /* 370916 */   GIM_Try, /*On fail goto*//*Label 7318*/ GIMT_Encode4(371033), // Rule ID 4265 //
     /* 370921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 370924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 370939 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370947 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370950 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 370954 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 370961 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 370965 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 370969 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370971 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 370978 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 370978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 370981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 370985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 370995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 371000 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 371006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371016 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 371022 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371027 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 371032 */     // GIR_Coverage, 4265,
     /* 371032 */     GIR_EraseRootFromParent_Done,
     /* 371033 */   // Label 7318: @371033
     /* 371033 */   GIM_Try, /*On fail goto*//*Label 7319*/ GIMT_Encode4(371173), // Rule ID 5784 //
     /* 371038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 371041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 371056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 371064 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371068 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 371077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371081 */     // MIs[2] Operand 1
     /* 371081 */     // No operand predicates
     /* 371081 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 371085 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371089 */     // MIs[3] Operand 1
     /* 371089 */     // No operand predicates
     /* 371089 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371091 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 371091 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 371094 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371098 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371103 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 371106 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 371110 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 371113 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371118 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371123 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 371126 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 371130 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371135 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 371138 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 371141 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 371145 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 371148 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371155 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 371162 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371167 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371172 */     // GIR_Coverage, 5784,
     /* 371172 */     GIR_EraseRootFromParent_Done,
     /* 371173 */   // Label 7319: @371173
     /* 371173 */   GIM_Try, /*On fail goto*//*Label 7320*/ GIMT_Encode4(371344), // Rule ID 5785 //
     /* 371178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 371181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 371196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 371204 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 371217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371221 */     // MIs[2] Operand 1
     /* 371221 */     // No operand predicates
     /* 371221 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 371225 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371229 */     // MIs[3] Operand 1
     /* 371229 */     // No operand predicates
     /* 371229 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371231 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 371231 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 371234 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371238 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371243 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 371246 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 371250 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 371253 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371258 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371263 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 371266 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371270 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371275 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 371278 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 371282 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 371285 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371290 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371295 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 371298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 371302 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371307 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 371310 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 371313 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 371316 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 371319 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371326 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 371333 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371338 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371343 */     // GIR_Coverage, 5785,
     /* 371343 */     GIR_EraseRootFromParent_Done,
     /* 371344 */   // Label 7320: @371344
     /* 371344 */   GIM_Try, /*On fail goto*//*Label 7321*/ GIMT_Encode4(371484), // Rule ID 5792 //
     /* 371349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 371352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 371367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 371375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371379 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 371388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371392 */     // MIs[2] Operand 1
     /* 371392 */     // No operand predicates
     /* 371392 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 371396 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371400 */     // MIs[3] Operand 1
     /* 371400 */     // No operand predicates
     /* 371400 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371402 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 371402 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 371405 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371409 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371414 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 371417 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 371421 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 371424 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371429 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371434 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 371437 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 371441 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371446 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 371449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 371452 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 371456 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 371459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371466 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 371473 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371478 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371483 */     // GIR_Coverage, 5792,
     /* 371483 */     GIR_EraseRootFromParent_Done,
     /* 371484 */   // Label 7321: @371484
     /* 371484 */   GIM_Try, /*On fail goto*//*Label 7322*/ GIMT_Encode4(371655), // Rule ID 5793 //
     /* 371489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 371492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 371507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 371515 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 371528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371532 */     // MIs[2] Operand 1
     /* 371532 */     // No operand predicates
     /* 371532 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 371536 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371540 */     // MIs[3] Operand 1
     /* 371540 */     // No operand predicates
     /* 371540 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371542 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 371542 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 371545 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371549 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371554 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 371557 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 371561 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 371564 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371569 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371574 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 371577 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371581 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371586 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 371589 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 371593 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 371596 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371601 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 371609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 371613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371618 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 371621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 371624 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 371627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 371630 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371637 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 371644 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371649 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371654 */     // GIR_Coverage, 5793,
     /* 371654 */     GIR_EraseRootFromParent_Done,
     /* 371655 */   // Label 7322: @371655
     /* 371655 */   GIM_Try, /*On fail goto*//*Label 7323*/ GIMT_Encode4(371734), // Rule ID 5708 //
     /* 371660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 371663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 371678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 371682 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 371686 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 371688 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 371688 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 371691 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371695 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371700 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 371704 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 371709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371717 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 371723 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371728 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 371733 */     // GIR_Coverage, 5708,
     /* 371733 */     GIR_EraseRootFromParent_Done,
     /* 371734 */   // Label 7323: @371734
     /* 371734 */   GIM_Try, /*On fail goto*//*Label 7324*/ GIMT_Encode4(371876), // Rule ID 6521 //
     /* 371739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 371742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 371757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 371761 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 371764 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 371768 */     // MIs[1] Rn
     /* 371768 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 371772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 371777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 371781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371785 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 371789 */     // MIs[2] Operand 1
     /* 371789 */     // No operand predicates
     /* 371789 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371791 */     // (vector_insert:{ *:[v8i8] } VecListOne64:{ *:[v8i8] }:$Rd, (ld:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (LD1i8:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 371791 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 371794 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371798 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371803 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 371806 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 371810 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 371813 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371818 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 371826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 371830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371835 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 371838 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 371841 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 371845 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 371851 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371858 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 371865 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371870 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371875 */     // GIR_Coverage, 6521,
     /* 371875 */     GIR_EraseRootFromParent_Done,
     /* 371876 */   // Label 7324: @371876
     /* 371876 */   GIM_Try, /*On fail goto*//*Label 7325*/ GIMT_Encode4(372025), // Rule ID 6522 //
     /* 371881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 371884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 371899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 371903 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 371906 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 371910 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 371917 */     // MIs[1] Rn
     /* 371917 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 371921 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 371926 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 371930 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371934 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 371938 */     // MIs[2] Operand 1
     /* 371938 */     // No operand predicates
     /* 371938 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371940 */     // (vector_insert:{ *:[v8i8] } VecListOne64:{ *:[v8i8] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (LD1i8:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 371940 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 371943 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371947 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371952 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 371955 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 371959 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 371962 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371967 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 371975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 371979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371984 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 371987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 371990 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 371994 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 372000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 372002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372007 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 372014 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372019 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372024 */     // GIR_Coverage, 6522,
     /* 372024 */     GIR_EraseRootFromParent_Done,
     /* 372025 */   // Label 7325: @372025
     /* 372025 */   GIM_Try, /*On fail goto*//*Label 7326*/ GIMT_Encode4(372160), // Rule ID 5747 //
     /* 372030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 372033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 372048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 372052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372056 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 372060 */     // MIs[1] Operand 1
     /* 372060 */     // No operand predicates
     /* 372060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 372062 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 372062 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 372065 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 372069 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372074 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 372076 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 372079 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 372083 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372088 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 372091 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 372095 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 372098 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372103 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372108 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372113 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 372116 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8gpr),
     /* 372120 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372125 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 372128 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 372131 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 372135 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 372137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372142 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 372149 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372154 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372159 */     // GIR_Coverage, 5747,
     /* 372159 */     GIR_EraseRootFromParent_Done,
     /* 372160 */   // Label 7326: @372160
     /* 372160 */   GIM_Try, /*On fail goto*//*Label 7327*/ GIMT_Encode4(372348), // Rule ID 5748 //
     /* 372165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 372168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 372183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 372187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372191 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 372195 */     // MIs[1] Operand 1
     /* 372195 */     // No operand predicates
     /* 372195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 372197 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, FPR8:{ *:[i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rm, bsub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 372197 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s8,
     /* 372200 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 372204 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 372211 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s8,
     /* 372214 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 372218 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372223 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 372226 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 372230 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 372233 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372238 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372243 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 372248 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 372251 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 372255 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372260 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 372262 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 372265 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 372269 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372274 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 372277 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 372281 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 372284 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372289 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372294 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 372302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 372306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372311 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 372314 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 372317 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 372320 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 372323 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 372325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372330 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 372337 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372342 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372347 */     // GIR_Coverage, 5748,
     /* 372347 */     GIR_EraseRootFromParent_Done,
     /* 372348 */   // Label 7327: @372348
     /* 372348 */   GIM_Reject,
     /* 372349 */ // Label 7302: @372349
     /* 372349 */ GIM_Reject,
     /* 372350 */ // Label 7153: @372350
     /* 372350 */ GIM_Try, /*On fail goto*//*Label 7328*/ GIMT_Encode4(375768),
     /* 372355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372358 */   GIM_Try, /*On fail goto*//*Label 7329*/ GIMT_Encode4(372484), // Rule ID 4285 //
     /* 372363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 372366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372377 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 372383 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 372385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 372393 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 372396 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 372400 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 372407 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 372411 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 372415 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372417 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 372424 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 372424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 372427 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 372431 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 372441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 372446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 372451 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 372457 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 372459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 372462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372467 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 372473 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372478 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372483 */     // GIR_Coverage, 4285,
     /* 372483 */     GIR_EraseRootFromParent_Done,
     /* 372484 */   // Label 7329: @372484
     /* 372484 */   GIM_Try, /*On fail goto*//*Label 7330*/ GIMT_Encode4(372610), // Rule ID 4286 //
     /* 372489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 372492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372503 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 372509 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 372511 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372515 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 372519 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 372522 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 372526 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 372533 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 372537 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 372541 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372543 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 372550 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 372550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 372553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 372557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 372567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 372572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 372577 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 372583 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 372585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 372588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 372599 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372604 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372609 */     // GIR_Coverage, 4286,
     /* 372609 */     GIR_EraseRootFromParent_Done,
     /* 372610 */   // Label 7330: @372610
     /* 372610 */   GIM_Try, /*On fail goto*//*Label 7331*/ GIMT_Encode4(372729), // Rule ID 4393 //
     /* 372615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 372618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372629 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 372635 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 372637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 372645 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 372648 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 372652 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 372656 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 372660 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372662 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 372669 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 372669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 372672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 372676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 372686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 372691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 372696 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 372702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 372704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 372707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372712 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 372718 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372723 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372728 */     // GIR_Coverage, 4393,
     /* 372728 */     GIR_EraseRootFromParent_Done,
     /* 372729 */   // Label 7331: @372729
     /* 372729 */   GIM_Try, /*On fail goto*//*Label 7332*/ GIMT_Encode4(372848), // Rule ID 4394 //
     /* 372734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 372737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372748 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 372754 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 372756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 372764 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 372767 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 372771 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 372775 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 372779 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372781 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 372788 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 372788 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 372791 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 372795 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 372805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 372810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 372815 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 372821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 372823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 372826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372831 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 372837 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372842 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372847 */     // GIR_Coverage, 4394,
     /* 372847 */     GIR_EraseRootFromParent_Done,
     /* 372848 */   // Label 7332: @372848
     /* 372848 */   GIM_Try, /*On fail goto*//*Label 7333*/ GIMT_Encode4(372970), // Rule ID 4291 //
     /* 372853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 372856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 372871 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372875 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 372879 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 372882 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 372886 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 372893 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 372897 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 372901 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372903 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 372910 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 372910 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 372913 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 372917 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 372927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 372932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 372937 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 372943 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 372945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 372948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372953 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 372959 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372964 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372969 */     // GIR_Coverage, 4291,
     /* 372969 */     GIR_EraseRootFromParent_Done,
     /* 372970 */   // Label 7333: @372970
     /* 372970 */   GIM_Try, /*On fail goto*//*Label 7334*/ GIMT_Encode4(373092), // Rule ID 4293 //
     /* 372975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 372978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 372993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 373001 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 373004 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 373008 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 373015 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 373019 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 373023 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373025 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 373032 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 373032 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 373035 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 373039 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 373049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 373054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 373059 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 373065 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 373067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 373081 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373086 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373091 */     // GIR_Coverage, 4293,
     /* 373091 */     GIR_EraseRootFromParent_Done,
     /* 373092 */   // Label 7334: @373092
     /* 373092 */   GIM_Try, /*On fail goto*//*Label 7335*/ GIMT_Encode4(373207), // Rule ID 4399 //
     /* 373097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 373100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 373115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 373123 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 373126 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 373130 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 373134 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 373138 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373140 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 373147 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 373147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 373150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 373154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 373164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 373169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 373174 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 373180 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 373182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373190 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 373196 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373201 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373206 */     // GIR_Coverage, 4399,
     /* 373206 */     GIR_EraseRootFromParent_Done,
     /* 373207 */   // Label 7335: @373207
     /* 373207 */   GIM_Try, /*On fail goto*//*Label 7336*/ GIMT_Encode4(373322), // Rule ID 4401 //
     /* 373212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 373215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 373230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 373238 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 373241 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 373245 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 373249 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 373253 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373255 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 373262 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 373262 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 373265 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 373269 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 373279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 373284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 373289 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 373295 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 373297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 373311 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373316 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373321 */     // GIR_Coverage, 4401,
     /* 373321 */     GIR_EraseRootFromParent_Done,
     /* 373322 */   // Label 7336: @373322
     /* 373322 */   GIM_Try, /*On fail goto*//*Label 7337*/ GIMT_Encode4(373443), // Rule ID 4283 //
     /* 373327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 373330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373341 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 373347 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 373349 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373353 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 373357 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 373360 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 373364 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 373371 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 373375 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 373379 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373381 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 373388 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 373388 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 373391 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 373395 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 373405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 373410 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 373416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 373418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 373432 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373437 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373442 */     // GIR_Coverage, 4283,
     /* 373442 */     GIR_EraseRootFromParent_Done,
     /* 373443 */   // Label 7337: @373443
     /* 373443 */   GIM_Try, /*On fail goto*//*Label 7338*/ GIMT_Encode4(373564), // Rule ID 4284 //
     /* 373448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 373451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373462 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 373468 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 373470 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373474 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 373478 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 373481 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 373485 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 373492 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 373496 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 373500 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373502 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 373509 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 373509 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 373512 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 373516 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 373526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 373531 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 373537 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 373539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373547 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 373553 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373558 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373563 */     // GIR_Coverage, 4284,
     /* 373563 */     GIR_EraseRootFromParent_Done,
     /* 373564 */   // Label 7338: @373564
     /* 373564 */   GIM_Try, /*On fail goto*//*Label 7339*/ GIMT_Encode4(373678), // Rule ID 4391 //
     /* 373569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 373572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373583 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 373589 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 373591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 373599 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 373602 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 373606 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 373610 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 373614 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373616 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 373623 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 373623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 373626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 373630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 373640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 373645 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 373651 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 373653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 373667 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373672 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373677 */     // GIR_Coverage, 4391,
     /* 373677 */     GIR_EraseRootFromParent_Done,
     /* 373678 */   // Label 7339: @373678
     /* 373678 */   GIM_Try, /*On fail goto*//*Label 7340*/ GIMT_Encode4(373792), // Rule ID 4392 //
     /* 373683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 373686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373697 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 373703 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 373705 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373709 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 373713 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 373716 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 373720 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 373724 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 373728 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373730 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 373737 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 373737 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 373740 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 373744 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 373754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 373759 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 373765 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 373767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 373781 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373786 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373791 */     // GIR_Coverage, 4392,
     /* 373791 */     GIR_EraseRootFromParent_Done,
     /* 373792 */   // Label 7340: @373792
     /* 373792 */   GIM_Try, /*On fail goto*//*Label 7341*/ GIMT_Encode4(373909), // Rule ID 4287 //
     /* 373797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 373800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 373815 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373819 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 373823 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 373826 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 373830 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 373837 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 373841 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 373845 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373847 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 373854 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 373854 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 373857 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 373861 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 373871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 373876 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 373882 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 373884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373892 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 373898 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373903 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373908 */     // GIR_Coverage, 4287,
     /* 373908 */     GIR_EraseRootFromParent_Done,
     /* 373909 */   // Label 7341: @373909
     /* 373909 */   GIM_Try, /*On fail goto*//*Label 7342*/ GIMT_Encode4(374026), // Rule ID 4289 //
     /* 373914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 373917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 373932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 373940 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 373943 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 373947 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 373954 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 373958 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 373962 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373964 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 373971 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 373971 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 373974 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 373978 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 373988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 373993 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 373999 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 374015 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374020 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374025 */     // GIR_Coverage, 4289,
     /* 374025 */     GIR_EraseRootFromParent_Done,
     /* 374026 */   // Label 7342: @374026
     /* 374026 */   GIM_Try, /*On fail goto*//*Label 7343*/ GIMT_Encode4(374136), // Rule ID 4395 //
     /* 374031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 374034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 374049 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374053 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 374057 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 374060 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 374064 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 374068 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374072 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374074 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 374081 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 374081 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 374084 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 374088 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 374098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 374103 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 374109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 374125 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374130 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374135 */     // GIR_Coverage, 4395,
     /* 374135 */     GIR_EraseRootFromParent_Done,
     /* 374136 */   // Label 7343: @374136
     /* 374136 */   GIM_Try, /*On fail goto*//*Label 7344*/ GIMT_Encode4(374246), // Rule ID 4397 //
     /* 374141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 374144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 374159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 374167 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 374170 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 374174 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 374178 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374182 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374184 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 374191 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 374191 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 374194 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 374198 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 374208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 374213 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 374219 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374229 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 374235 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374240 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374245 */     // GIR_Coverage, 4397,
     /* 374245 */     GIR_EraseRootFromParent_Done,
     /* 374246 */   // Label 7344: @374246
     /* 374246 */   GIM_Try, /*On fail goto*//*Label 7345*/ GIMT_Encode4(374369), // Rule ID 5758 //
     /* 374251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 374254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 374269 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374273 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374277 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 374281 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 374285 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374290 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 374294 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374298 */     // MIs[3] Operand 1
     /* 374298 */     // No operand predicates
     /* 374298 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374302 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374304 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), (DUPi16:{ *:[i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), hsub:{ *:[i32] })
     /* 374304 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 374307 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi16),
     /* 374311 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374316 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 374320 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 374323 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 374325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 374328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 374332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 374342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 374350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 374353 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374358 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374363 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374368 */     // GIR_Coverage, 5758,
     /* 374368 */     GIR_EraseRootFromParent_Done,
     /* 374369 */   // Label 7345: @374369
     /* 374369 */   GIM_Try, /*On fail goto*//*Label 7346*/ GIMT_Encode4(374492), // Rule ID 5798 //
     /* 374374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 374377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 374392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374400 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 374404 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 374408 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374413 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 374417 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374421 */     // MIs[3] Operand 1
     /* 374421 */     // No operand predicates
     /* 374421 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374425 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374427 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), (DUPi16:{ *:[i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), hsub:{ *:[i32] })
     /* 374427 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 374430 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi16),
     /* 374434 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374439 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 374443 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 374446 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 374448 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 374451 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 374455 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374460 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 374465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374467 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374470 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 374473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 374476 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374481 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374486 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374491 */     // GIR_Coverage, 5798,
     /* 374491 */     GIR_EraseRootFromParent_Done,
     /* 374492 */   // Label 7346: @374492
     /* 374492 */   GIM_Try, /*On fail goto*//*Label 7347*/ GIMT_Encode4(374580), // Rule ID 1939 //
     /* 374497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 374503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 374526 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374530 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374535 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 374539 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374543 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 374547 */     // MIs[2] Operand 1
     /* 374547 */     // No operand predicates
     /* 374547 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 374551 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374555 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 374559 */     // MIs[3] Operand 1
     /* 374559 */     // No operand predicates
     /* 374559 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374561 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 374561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 374564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374566 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 374568 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 374571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 374575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 374578 */     GIR_RootConstrainSelectedInstOperands,
     /* 374579 */     // GIR_Coverage, 1939,
     /* 374579 */     GIR_EraseRootFromParent_Done,
     /* 374580 */   // Label 7347: @374580
     /* 374580 */   GIM_Try, /*On fail goto*//*Label 7348*/ GIMT_Encode4(374679), // Rule ID 5755 //
     /* 374585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 374588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 374607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374611 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 374615 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374619 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 374623 */     // MIs[2] Operand 1
     /* 374623 */     // No operand predicates
     /* 374623 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 374627 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374631 */     // MIs[3] Operand 1
     /* 374631 */     // No operand predicates
     /* 374631 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374633 */     // (vector_insert:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v8f16] } ZPR:{ *:[nxv8f16] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$Immn)
     /* 374633 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 374636 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 374640 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374645 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 374651 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374656 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 374661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 374664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374666 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 374668 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 374671 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374674 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 374677 */     GIR_RootConstrainSelectedInstOperands,
     /* 374678 */     // GIR_Coverage, 5755,
     /* 374678 */     GIR_EraseRootFromParent_Done,
     /* 374679 */   // Label 7348: @374679
     /* 374679 */   GIM_Try, /*On fail goto*//*Label 7349*/ GIMT_Encode4(374778), // Rule ID 5795 //
     /* 374684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 374687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 374706 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374710 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 374714 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374718 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 374722 */     // MIs[2] Operand 1
     /* 374722 */     // No operand predicates
     /* 374722 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 374726 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374730 */     // MIs[3] Operand 1
     /* 374730 */     // No operand predicates
     /* 374730 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374732 */     // (vector_insert:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$Immn)
     /* 374732 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 374735 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 374739 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374744 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 374750 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374755 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 374760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 374763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374765 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 374767 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 374770 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 374776 */     GIR_RootConstrainSelectedInstOperands,
     /* 374777 */     // GIR_Coverage, 5795,
     /* 374777 */     GIR_EraseRootFromParent_Done,
     /* 374778 */   // Label 7349: @374778
     /* 374778 */   GIM_Try, /*On fail goto*//*Label 7350*/ GIMT_Encode4(374855), // Rule ID 5757 //
     /* 374783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 374786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374793 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 374809 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374813 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 374822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374826 */     // MIs[2] Operand 1
     /* 374826 */     // No operand predicates
     /* 374826 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 374830 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374834 */     // MIs[3] Operand 1
     /* 374834 */     // No operand predicates
     /* 374834 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374836 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 374836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 374839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374841 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 374843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 374846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 374850 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 374853 */     GIR_RootConstrainSelectedInstOperands,
     /* 374854 */     // GIR_Coverage, 5757,
     /* 374854 */     GIR_EraseRootFromParent_Done,
     /* 374855 */   // Label 7350: @374855
     /* 374855 */   GIM_Try, /*On fail goto*//*Label 7351*/ GIMT_Encode4(374963), // Rule ID 5759 //
     /* 374860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 374863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374882 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 374886 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374890 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374895 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 374899 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374903 */     // MIs[2] Operand 1
     /* 374903 */     // No operand predicates
     /* 374903 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 374907 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374911 */     // MIs[3] Operand 1
     /* 374911 */     // No operand predicates
     /* 374911 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374913 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (vector_extract:{ *:[f16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 374913 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 374916 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374920 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374925 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 374928 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 374932 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 374935 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374940 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 374948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374950 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 374952 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 374955 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374958 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 374961 */     GIR_RootConstrainSelectedInstOperands,
     /* 374962 */     // GIR_Coverage, 5759,
     /* 374962 */     GIR_EraseRootFromParent_Done,
     /* 374963 */   // Label 7351: @374963
     /* 374963 */   GIM_Try, /*On fail goto*//*Label 7352*/ GIMT_Encode4(375040), // Rule ID 5797 //
     /* 374968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 374971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 374994 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374998 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375003 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375007 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375011 */     // MIs[2] Operand 1
     /* 375011 */     // No operand predicates
     /* 375011 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 375015 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375019 */     // MIs[3] Operand 1
     /* 375019 */     // No operand predicates
     /* 375019 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375021 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 375021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 375024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375026 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 375028 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 375031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 375035 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 375038 */     GIR_RootConstrainSelectedInstOperands,
     /* 375039 */     // GIR_Coverage, 5797,
     /* 375039 */     GIR_EraseRootFromParent_Done,
     /* 375040 */   // Label 7352: @375040
     /* 375040 */   GIM_Try, /*On fail goto*//*Label 7353*/ GIMT_Encode4(375148), // Rule ID 5799 //
     /* 375045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 375048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 375071 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375088 */     // MIs[2] Operand 1
     /* 375088 */     // No operand predicates
     /* 375088 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 375092 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375096 */     // MIs[3] Operand 1
     /* 375096 */     // No operand predicates
     /* 375096 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375098 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 375098 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 375101 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375105 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375110 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 375113 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 375117 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 375120 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375125 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 375133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375135 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 375137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 375140 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 375146 */     GIR_RootConstrainSelectedInstOperands,
     /* 375147 */     // GIR_Coverage, 5799,
     /* 375147 */     GIR_EraseRootFromParent_Done,
     /* 375148 */   // Label 7353: @375148
     /* 375148 */   GIM_Try, /*On fail goto*//*Label 7354*/ GIMT_Encode4(375227), // Rule ID 5711 //
     /* 375153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 375156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 375171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 375175 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 375179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 375181 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 375181 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 375184 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 375188 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375193 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 375197 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375210 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 375216 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375221 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375226 */     // GIR_Coverage, 5711,
     /* 375226 */     GIR_EraseRootFromParent_Done,
     /* 375227 */   // Label 7354: @375227
     /* 375227 */   GIM_Try, /*On fail goto*//*Label 7355*/ GIMT_Encode4(375303), // Rule ID 5723 //
     /* 375232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 375235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 375250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 375254 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 375258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 375260 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 375260 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 375263 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 375267 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375272 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 375274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 375277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 375284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 375287 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375292 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375297 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 375302 */     // GIR_Coverage, 5723,
     /* 375302 */     GIR_EraseRootFromParent_Done,
     /* 375303 */   // Label 7355: @375303
     /* 375303 */   GIM_Try, /*On fail goto*//*Label 7356*/ GIMT_Encode4(375379), // Rule ID 5727 //
     /* 375308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 375311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 375326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 375330 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 375334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 375336 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 375336 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 375339 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 375343 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375348 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 375350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 375353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375355 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 375360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 375363 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375368 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375373 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 375378 */     // GIR_Coverage, 5727,
     /* 375378 */     GIR_EraseRootFromParent_Done,
     /* 375379 */   // Label 7356: @375379
     /* 375379 */   GIM_Try, /*On fail goto*//*Label 7357*/ GIMT_Encode4(375442), // Rule ID 5736 //
     /* 375384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 375387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 375406 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 375410 */     // MIs[1] Operand 1
     /* 375410 */     // No operand predicates
     /* 375410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 375414 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375418 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 375422 */     // MIs[2] Operand 1
     /* 375422 */     // No operand predicates
     /* 375422 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375424 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (INSvi16gpr:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, WZR:{ *:[i32] })
     /* 375424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 375427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375429 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 375431 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 375434 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 375440 */     GIR_RootConstrainSelectedInstOperands,
     /* 375441 */     // GIR_Coverage, 5736,
     /* 375441 */     GIR_EraseRootFromParent_Done,
     /* 375442 */   // Label 7357: @375442
     /* 375442 */   GIM_Try, /*On fail goto*//*Label 7358*/ GIMT_Encode4(375528), // Rule ID 6503 //
     /* 375447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 375450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 375469 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 375472 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 375476 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 375483 */     // MIs[1] Rn
     /* 375483 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 375487 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 375492 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 375496 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375500 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 375504 */     // MIs[2] Operand 1
     /* 375504 */     // No operand predicates
     /* 375504 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375506 */     // (vector_insert:{ *:[v8i16] } VecListOne128:{ *:[v8i16] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (LD1i16:{ *:[v8i16] } VecListOne128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 375506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 375509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375511 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 375513 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 375516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 375520 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 375526 */     GIR_RootConstrainSelectedInstOperands,
     /* 375527 */     // GIR_Coverage, 6503,
     /* 375527 */     GIR_EraseRootFromParent_Done,
     /* 375528 */   // Label 7358: @375528
     /* 375528 */   GIM_Try, /*On fail goto*//*Label 7359*/ GIMT_Encode4(375607), // Rule ID 6508 //
     /* 375533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 375536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 375555 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 375558 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 375562 */     // MIs[1] Rn
     /* 375562 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 375566 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 375571 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 375575 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375579 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 375583 */     // MIs[2] Operand 1
     /* 375583 */     // No operand predicates
     /* 375583 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375585 */     // (vector_insert:{ *:[v8f16] } VecListOne128:{ *:[v8f16] }:$Rd, (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (LD1i16:{ *:[v8f16] } VecListOne128:{ *:[v8f16] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 375585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 375588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375590 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 375592 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 375595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 375599 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 375605 */     GIR_RootConstrainSelectedInstOperands,
     /* 375606 */     // GIR_Coverage, 6508,
     /* 375606 */     GIR_EraseRootFromParent_Done,
     /* 375607 */   // Label 7359: @375607
     /* 375607 */   GIM_Try, /*On fail goto*//*Label 7360*/ GIMT_Encode4(375661), // Rule ID 1935 //
     /* 375612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 375618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 375633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 375637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375641 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 375645 */     // MIs[1] Operand 1
     /* 375645 */     // No operand predicates
     /* 375645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 375647 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (INSvi16gpr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 375647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 375650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375652 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 375654 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 375657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 375659 */     GIR_RootConstrainSelectedInstOperands,
     /* 375660 */     // GIR_Coverage, 1935,
     /* 375660 */     GIR_EraseRootFromParent_Done,
     /* 375661 */   // Label 7360: @375661
     /* 375661 */   GIM_Try, /*On fail goto*//*Label 7361*/ GIMT_Encode4(375767), // Rule ID 5741 //
     /* 375666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 375669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 375684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 375688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375692 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 375696 */     // MIs[1] Operand 1
     /* 375696 */     // No operand predicates
     /* 375696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 375698 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 375698 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 375701 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 375705 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375710 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 375712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 375715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 375719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375724 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 375727 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 375731 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 375734 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375739 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375744 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 375749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 375752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375754 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 375756 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 375759 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375765 */     GIR_RootConstrainSelectedInstOperands,
     /* 375766 */     // GIR_Coverage, 5741,
     /* 375766 */     GIR_EraseRootFromParent_Done,
     /* 375767 */   // Label 7361: @375767
     /* 375767 */   GIM_Reject,
     /* 375768 */ // Label 7328: @375768
     /* 375768 */ GIM_Reject,
     /* 375769 */ // Label 7154: @375769
     /* 375769 */ GIM_Try, /*On fail goto*//*Label 7362*/ GIMT_Encode4(378972),
     /* 375774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 375777 */   GIM_Try, /*On fail goto*//*Label 7363*/ GIMT_Encode4(375896), // Rule ID 4213 //
     /* 375782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 375785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375796 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 375802 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 375804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 375812 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 375815 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 375819 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 375823 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 375827 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375829 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 375836 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 375836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 375839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 375843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 375853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 375858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 375863 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 375869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 375871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 375885 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375890 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 375895 */     // GIR_Coverage, 4213,
     /* 375895 */     GIR_EraseRootFromParent_Done,
     /* 375896 */   // Label 7363: @375896
     /* 375896 */   GIM_Try, /*On fail goto*//*Label 7364*/ GIMT_Encode4(376015), // Rule ID 4214 //
     /* 375901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 375904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375915 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 375921 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 375923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 375931 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 375934 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 375938 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 375942 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 375946 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375948 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 375955 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 375955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 375958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 375962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 375972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 375977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 375982 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 375988 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 375990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375998 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 376004 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376009 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 376014 */     // GIR_Coverage, 4214,
     /* 376014 */     GIR_EraseRootFromParent_Done,
     /* 376015 */   // Label 7364: @376015
     /* 376015 */   GIM_Try, /*On fail goto*//*Label 7365*/ GIMT_Encode4(376141), // Rule ID 4249 //
     /* 376020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 376023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376034 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 376040 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 376042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 376050 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 376053 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 376057 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 376064 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 376068 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 376072 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376074 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 376081 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 376081 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 376084 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 376088 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 376098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 376103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 376108 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 376114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 376116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376124 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 376130 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376135 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 376140 */     // GIR_Coverage, 4249,
     /* 376140 */     GIR_EraseRootFromParent_Done,
     /* 376141 */   // Label 7365: @376141
     /* 376141 */   GIM_Try, /*On fail goto*//*Label 7366*/ GIMT_Encode4(376267), // Rule ID 4250 //
     /* 376146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 376149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376160 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 376166 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 376168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 376176 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 376179 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 376183 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 376190 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 376194 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 376198 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376200 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 376207 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 376207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 376210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 376214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 376224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 376229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 376234 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 376240 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 376242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376250 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 376256 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376261 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 376266 */     // GIR_Coverage, 4250,
     /* 376266 */     GIR_EraseRootFromParent_Done,
     /* 376267 */   // Label 7366: @376267
     /* 376267 */   GIM_Try, /*On fail goto*//*Label 7367*/ GIMT_Encode4(376382), // Rule ID 4219 //
     /* 376272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 376275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 376290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 376298 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 376301 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 376305 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 376309 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 376313 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376315 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 376322 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 376322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 376325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 376329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 376339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 376344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 376349 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 376355 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 376357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376365 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 376371 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376376 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 376381 */     // GIR_Coverage, 4219,
     /* 376381 */     GIR_EraseRootFromParent_Done,
     /* 376382 */   // Label 7367: @376382
     /* 376382 */   GIM_Try, /*On fail goto*//*Label 7368*/ GIMT_Encode4(376497), // Rule ID 4221 //
     /* 376387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 376390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 376405 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376409 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 376413 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 376416 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 376420 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 376424 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 376428 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376430 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 376437 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 376437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 376440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 376444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 376454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 376459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 376464 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 376470 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 376472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376480 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 376486 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376491 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 376496 */     // GIR_Coverage, 4221,
     /* 376496 */     GIR_EraseRootFromParent_Done,
     /* 376497 */   // Label 7368: @376497
     /* 376497 */   GIM_Try, /*On fail goto*//*Label 7369*/ GIMT_Encode4(376619), // Rule ID 4255 //
     /* 376502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 376505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 376520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376524 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 376528 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 376531 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 376535 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 376542 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 376546 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 376550 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376552 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 376559 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 376559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 376562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 376566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 376576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 376581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 376586 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 376592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 376594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376602 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 376608 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376613 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 376618 */     // GIR_Coverage, 4255,
     /* 376618 */     GIR_EraseRootFromParent_Done,
     /* 376619 */   // Label 7369: @376619
     /* 376619 */   GIM_Try, /*On fail goto*//*Label 7370*/ GIMT_Encode4(376741), // Rule ID 4257 //
     /* 376624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 376627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 376642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 376650 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 376653 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 376657 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 376664 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 376668 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 376672 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376674 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 376681 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 376681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 376684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 376688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 376698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 376703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 376708 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 376714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 376716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 376730 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376735 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 376740 */     // GIR_Coverage, 4257,
     /* 376740 */     GIR_EraseRootFromParent_Done,
     /* 376741 */   // Label 7370: @376741
     /* 376741 */   GIM_Try, /*On fail goto*//*Label 7371*/ GIMT_Encode4(376855), // Rule ID 4211 //
     /* 376746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 376749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376760 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 376766 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 376768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 376776 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 376779 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 376783 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 376787 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 376791 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376793 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 376800 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 376800 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 376803 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 376807 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 376817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 376822 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 376828 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 376830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376838 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 376844 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376849 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 376854 */     // GIR_Coverage, 4211,
     /* 376854 */     GIR_EraseRootFromParent_Done,
     /* 376855 */   // Label 7371: @376855
     /* 376855 */   GIM_Try, /*On fail goto*//*Label 7372*/ GIMT_Encode4(376969), // Rule ID 4212 //
     /* 376860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 376863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376874 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 376880 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 376882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 376890 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 376893 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 376897 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 376901 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 376905 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376907 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 376914 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 376914 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 376917 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 376921 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 376931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 376936 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 376942 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 376944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376952 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 376958 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376963 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 376968 */     // GIR_Coverage, 4212,
     /* 376968 */     GIR_EraseRootFromParent_Done,
     /* 376969 */   // Label 7372: @376969
     /* 376969 */   GIM_Try, /*On fail goto*//*Label 7373*/ GIMT_Encode4(377090), // Rule ID 4247 //
     /* 376974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 376977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376988 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 376994 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 376996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377004 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377007 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 377011 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 377018 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 377022 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377026 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377028 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 377035 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 377035 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 377038 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 377042 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 377052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 377057 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 377063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377073 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 377079 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377084 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 377089 */     // GIR_Coverage, 4247,
     /* 377089 */     GIR_EraseRootFromParent_Done,
     /* 377090 */   // Label 7373: @377090
     /* 377090 */   GIM_Try, /*On fail goto*//*Label 7374*/ GIMT_Encode4(377211), // Rule ID 4248 //
     /* 377095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 377098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 377101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377109 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 377115 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 377117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377125 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377128 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 377132 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 377139 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 377143 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377147 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377149 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 377156 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 377156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 377159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 377163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 377173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 377178 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 377184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377194 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 377200 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377205 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 377210 */     // GIR_Coverage, 4248,
     /* 377210 */     GIR_EraseRootFromParent_Done,
     /* 377211 */   // Label 7374: @377211
     /* 377211 */   GIM_Try, /*On fail goto*//*Label 7375*/ GIMT_Encode4(377321), // Rule ID 4215 //
     /* 377216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 377219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 377222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 377234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377242 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377245 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 377249 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 377253 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377257 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377259 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 377266 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 377266 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 377269 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 377273 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 377283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 377288 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 377294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 377310 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377315 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 377320 */     // GIR_Coverage, 4215,
     /* 377320 */     GIR_EraseRootFromParent_Done,
     /* 377321 */   // Label 7375: @377321
     /* 377321 */   GIM_Try, /*On fail goto*//*Label 7376*/ GIMT_Encode4(377431), // Rule ID 4217 //
     /* 377326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 377329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 377332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 377344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377352 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377355 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 377359 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 377363 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377367 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377369 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 377376 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 377376 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 377379 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 377383 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 377393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 377398 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 377404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377414 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 377420 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377425 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 377430 */     // GIR_Coverage, 4217,
     /* 377430 */     GIR_EraseRootFromParent_Done,
     /* 377431 */   // Label 7376: @377431
     /* 377431 */   GIM_Try, /*On fail goto*//*Label 7377*/ GIMT_Encode4(377548), // Rule ID 4251 //
     /* 377436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 377439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 377442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 377454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377458 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377462 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377465 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 377469 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 377476 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 377480 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377484 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377486 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 377493 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 377493 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 377496 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 377500 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 377510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 377515 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 377521 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377531 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 377537 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377542 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 377547 */     // GIR_Coverage, 4251,
     /* 377547 */     GIR_EraseRootFromParent_Done,
     /* 377548 */   // Label 7377: @377548
     /* 377548 */   GIM_Try, /*On fail goto*//*Label 7378*/ GIMT_Encode4(377665), // Rule ID 4253 //
     /* 377553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 377556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 377559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 377571 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377575 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377579 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377582 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 377586 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 377593 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 377597 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377601 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377603 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 377610 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 377610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 377613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 377617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 377627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 377632 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 377638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377648 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 377654 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377659 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 377664 */     // GIR_Coverage, 4253,
     /* 377664 */     GIR_EraseRootFromParent_Done,
     /* 377665 */   // Label 7378: @377665
     /* 377665 */   GIM_Try, /*On fail goto*//*Label 7379*/ GIMT_Encode4(377788), // Rule ID 5782 //
     /* 377670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 377673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 377676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 377688 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377692 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377696 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 377700 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 377704 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377709 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 377713 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377717 */     // MIs[3] Operand 1
     /* 377717 */     // No operand predicates
     /* 377717 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377721 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377723 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (vector_extract:{ *:[i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (DUPi8:{ *:[i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), bsub:{ *:[i32] })
     /* 377723 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s8,
     /* 377726 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi8),
     /* 377730 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377735 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 377739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 377742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 377744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 377747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 377751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377756 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 377761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377763 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377766 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 377769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 377772 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377777 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377782 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 377787 */     // GIR_Coverage, 5782,
     /* 377787 */     GIR_EraseRootFromParent_Done,
     /* 377788 */   // Label 7379: @377788
     /* 377788 */   GIM_Try, /*On fail goto*//*Label 7380*/ GIMT_Encode4(377911), // Rule ID 5790 //
     /* 377793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 377796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 377799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 377811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377819 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 377823 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 377827 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377832 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 377836 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377840 */     // MIs[3] Operand 1
     /* 377840 */     // No operand predicates
     /* 377840 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377844 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377846 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (DUPi8:{ *:[i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), bsub:{ *:[i32] })
     /* 377846 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s8,
     /* 377849 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi8),
     /* 377853 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377858 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 377862 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 377865 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 377867 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 377870 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 377874 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 377884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377886 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377889 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 377892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 377895 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377900 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377905 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 377910 */     // GIR_Coverage, 5790,
     /* 377910 */     GIR_EraseRootFromParent_Done,
     /* 377911 */   // Label 7380: @377911
     /* 377911 */   GIM_Try, /*On fail goto*//*Label 7381*/ GIMT_Encode4(377999), // Rule ID 1938 //
     /* 377916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 377922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 377925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 377945 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377949 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377954 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 377958 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377962 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 377966 */     // MIs[2] Operand 1
     /* 377966 */     // No operand predicates
     /* 377966 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 377970 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377974 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 377978 */     // MIs[3] Operand 1
     /* 377978 */     // No operand predicates
     /* 377978 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377980 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 377980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 377983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377985 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 377987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 377990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 377994 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 377997 */     GIR_RootConstrainSelectedInstOperands,
     /* 377998 */     // GIR_Coverage, 1938,
     /* 377998 */     GIR_EraseRootFromParent_Done,
     /* 377999 */   // Label 7381: @377999
     /* 377999 */   GIM_Try, /*On fail goto*//*Label 7382*/ GIMT_Encode4(378098), // Rule ID 5779 //
     /* 378004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 378007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 378010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 378026 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378030 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 378034 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378038 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 378042 */     // MIs[2] Operand 1
     /* 378042 */     // No operand predicates
     /* 378042 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 378046 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378050 */     // MIs[3] Operand 1
     /* 378050 */     // No operand predicates
     /* 378050 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378052 */     // (vector_insert:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, (vector_extract:{ *:[i8] } nxv16i8:{ *:[nxv16i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$Immn)
     /* 378052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 378055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 378059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378064 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 378070 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378075 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 378083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378085 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378087 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 378090 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 378096 */     GIR_RootConstrainSelectedInstOperands,
     /* 378097 */     // GIR_Coverage, 5779,
     /* 378097 */     GIR_EraseRootFromParent_Done,
     /* 378098 */   // Label 7382: @378098
     /* 378098 */   GIM_Try, /*On fail goto*//*Label 7383*/ GIMT_Encode4(378197), // Rule ID 5787 //
     /* 378103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 378106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 378109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 378125 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 378133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378137 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 378141 */     // MIs[2] Operand 1
     /* 378141 */     // No operand predicates
     /* 378141 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 378145 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378149 */     // MIs[3] Operand 1
     /* 378149 */     // No operand predicates
     /* 378149 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378151 */     // (vector_insert:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$Immn)
     /* 378151 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 378154 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 378158 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378163 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 378169 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378174 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 378182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378184 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378186 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 378189 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378192 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 378195 */     GIR_RootConstrainSelectedInstOperands,
     /* 378196 */     // GIR_Coverage, 5787,
     /* 378196 */     GIR_EraseRootFromParent_Done,
     /* 378197 */   // Label 7383: @378197
     /* 378197 */   GIM_Try, /*On fail goto*//*Label 7384*/ GIMT_Encode4(378274), // Rule ID 5781 //
     /* 378202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 378205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 378208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378224 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 378228 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378232 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378237 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 378241 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378245 */     // MIs[2] Operand 1
     /* 378245 */     // No operand predicates
     /* 378245 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 378249 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378253 */     // MIs[3] Operand 1
     /* 378253 */     // No operand predicates
     /* 378253 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378255 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 378255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 378258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378260 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 378262 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 378265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 378269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 378272 */     GIR_RootConstrainSelectedInstOperands,
     /* 378273 */     // GIR_Coverage, 5781,
     /* 378273 */     GIR_EraseRootFromParent_Done,
     /* 378274 */   // Label 7384: @378274
     /* 378274 */   GIM_Try, /*On fail goto*//*Label 7385*/ GIMT_Encode4(378382), // Rule ID 5783 //
     /* 378279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 378282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 378285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378289 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 378305 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378309 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378314 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 378318 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378322 */     // MIs[2] Operand 1
     /* 378322 */     // No operand predicates
     /* 378322 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 378326 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378330 */     // MIs[3] Operand 1
     /* 378330 */     // No operand predicates
     /* 378330 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378332 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 378332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 378335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378344 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 378347 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 378351 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 378354 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378359 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 378367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378369 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 378371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 378374 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 378380 */     GIR_RootConstrainSelectedInstOperands,
     /* 378381 */     // GIR_Coverage, 5783,
     /* 378381 */     GIR_EraseRootFromParent_Done,
     /* 378382 */   // Label 7385: @378382
     /* 378382 */   GIM_Try, /*On fail goto*//*Label 7386*/ GIMT_Encode4(378459), // Rule ID 5789 //
     /* 378387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 378390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 378393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 378413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 378426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378430 */     // MIs[2] Operand 1
     /* 378430 */     // No operand predicates
     /* 378430 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 378434 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378438 */     // MIs[3] Operand 1
     /* 378438 */     // No operand predicates
     /* 378438 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378440 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 378440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 378443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378445 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 378447 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 378450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 378454 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 378457 */     GIR_RootConstrainSelectedInstOperands,
     /* 378458 */     // GIR_Coverage, 5789,
     /* 378458 */     GIR_EraseRootFromParent_Done,
     /* 378459 */   // Label 7386: @378459
     /* 378459 */   GIM_Try, /*On fail goto*//*Label 7387*/ GIMT_Encode4(378567), // Rule ID 5791 //
     /* 378464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 378467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 378470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 378490 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 378503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378507 */     // MIs[2] Operand 1
     /* 378507 */     // No operand predicates
     /* 378507 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 378511 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378515 */     // MIs[3] Operand 1
     /* 378515 */     // No operand predicates
     /* 378515 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378517 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 378517 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 378520 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378524 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378529 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 378532 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 378536 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 378539 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378544 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 378552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378554 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 378556 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 378559 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378562 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 378565 */     GIR_RootConstrainSelectedInstOperands,
     /* 378566 */     // GIR_Coverage, 5791,
     /* 378566 */     GIR_EraseRootFromParent_Done,
     /* 378567 */   // Label 7387: @378567
     /* 378567 */   GIM_Try, /*On fail goto*//*Label 7388*/ GIMT_Encode4(378646), // Rule ID 5706 //
     /* 378572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 378575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 378578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 378590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 378594 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 378598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 378600 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 378600 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 378603 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 378607 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378612 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 378616 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378629 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 378635 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378640 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378645 */     // GIR_Coverage, 5706,
     /* 378645 */     GIR_EraseRootFromParent_Done,
     /* 378646 */   // Label 7388: @378646
     /* 378646 */   GIM_Try, /*On fail goto*//*Label 7389*/ GIMT_Encode4(378725), // Rule ID 6501 //
     /* 378651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 378654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 378657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 378673 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 378676 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 378680 */     // MIs[1] Rn
     /* 378680 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 378684 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 378689 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 378693 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378697 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 378701 */     // MIs[2] Operand 1
     /* 378701 */     // No operand predicates
     /* 378701 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378703 */     // (vector_insert:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (ld:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (LD1i8:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 378703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 378706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378708 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 378710 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 378713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 378717 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 378723 */     GIR_RootConstrainSelectedInstOperands,
     /* 378724 */     // GIR_Coverage, 6501,
     /* 378724 */     GIR_EraseRootFromParent_Done,
     /* 378725 */   // Label 7389: @378725
     /* 378725 */   GIM_Try, /*On fail goto*//*Label 7390*/ GIMT_Encode4(378811), // Rule ID 6502 //
     /* 378730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 378733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 378736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 378752 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 378755 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 378759 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 378766 */     // MIs[1] Rn
     /* 378766 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 378770 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 378775 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 378779 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378783 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 378787 */     // MIs[2] Operand 1
     /* 378787 */     // No operand predicates
     /* 378787 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378789 */     // (vector_insert:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (LD1i8:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 378789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 378792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378794 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 378796 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 378799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 378803 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 378809 */     GIR_RootConstrainSelectedInstOperands,
     /* 378810 */     // GIR_Coverage, 6502,
     /* 378810 */     GIR_EraseRootFromParent_Done,
     /* 378811 */   // Label 7390: @378811
     /* 378811 */   GIM_Try, /*On fail goto*//*Label 7391*/ GIMT_Encode4(378865), // Rule ID 1934 //
     /* 378816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 378822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 378825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378829 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 378837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 378841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378845 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 378849 */     // MIs[1] Operand 1
     /* 378849 */     // No operand predicates
     /* 378849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 378851 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (INSvi8gpr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 378851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8gpr),
     /* 378854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378856 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 378858 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 378861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 378863 */     GIR_RootConstrainSelectedInstOperands,
     /* 378864 */     // GIR_Coverage, 1934,
     /* 378864 */     GIR_EraseRootFromParent_Done,
     /* 378865 */   // Label 7391: @378865
     /* 378865 */   GIM_Try, /*On fail goto*//*Label 7392*/ GIMT_Encode4(378971), // Rule ID 5749 //
     /* 378870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 378873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 378876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 378888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 378892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378896 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 378900 */     // MIs[1] Operand 1
     /* 378900 */     // No operand predicates
     /* 378900 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 378902 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, FPR8:{ *:[i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rm, bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 378902 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 378905 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 378909 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 378916 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 378919 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 378923 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378928 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 378931 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 378935 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 378938 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378943 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378948 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 378953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 378956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378958 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378960 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 378963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378969 */     GIR_RootConstrainSelectedInstOperands,
     /* 378970 */     // GIR_Coverage, 5749,
     /* 378970 */     GIR_EraseRootFromParent_Done,
     /* 378971 */   // Label 7392: @378971
     /* 378971 */   GIM_Reject,
     /* 378972 */ // Label 7362: @378972
     /* 378972 */ GIM_Reject,
     /* 378973 */ // Label 7155: @378973
     /* 378973 */ GIM_Try, /*On fail goto*//*Label 7393*/ GIMT_Encode4(379097), // Rule ID 11307 //
     /* 378978 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 378981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 378984 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 378987 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 378990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378994 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378998 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 379002 */   // (vector_insert:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv2f16] } ZPR:{ *:[nxv2f16] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), ?:{ *:[f16] }:$src)
     /* 379002 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 379005 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 379009 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379014 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 379018 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 379020 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 379023 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 379027 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379032 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 379035 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 379038 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 379040 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 379043 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 379047 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379052 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 379055 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 379057 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 379060 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 379064 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379069 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 379072 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 379075 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 379078 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 379081 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379083 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 379086 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 379088 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 379090 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379093 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 379095 */   GIR_RootConstrainSelectedInstOperands,
     /* 379096 */   // GIR_Coverage, 11307,
     /* 379096 */   GIR_EraseRootFromParent_Done,
     /* 379097 */ // Label 7393: @379097
     /* 379097 */ GIM_Reject,
     /* 379098 */ // Label 7156: @379098
     /* 379098 */ GIM_Try, /*On fail goto*//*Label 7394*/ GIMT_Encode4(379222), // Rule ID 11310 //
     /* 379103 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 379106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 379109 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 379112 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 379115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379119 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379123 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 379127 */   // (vector_insert:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$vec, FPR32:{ *:[f32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_S:{ *:[nxv2f32] } ZPR:{ *:[nxv2f32] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), ?:{ *:[f32] }:$src)
     /* 379127 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 379130 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 379134 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379139 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 379143 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 379145 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 379148 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 379152 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379157 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 379160 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 379163 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 379165 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 379168 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 379172 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379177 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 379180 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 379182 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 379185 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 379189 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379194 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 379197 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 379200 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 379203 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 379206 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379208 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_S),
     /* 379211 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 379213 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 379215 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379218 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 379220 */   GIR_RootConstrainSelectedInstOperands,
     /* 379221 */   // GIR_Coverage, 11310,
     /* 379221 */   GIR_EraseRootFromParent_Done,
     /* 379222 */ // Label 7394: @379222
     /* 379222 */ GIM_Reject,
     /* 379223 */ // Label 7157: @379223
     /* 379223 */ GIM_Try, /*On fail goto*//*Label 7395*/ GIMT_Encode4(381200),
     /* 379228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 379231 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 379234 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 379237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379241 */   GIM_Try, /*On fail goto*//*Label 7396*/ GIMT_Encode4(379350), // Rule ID 4381 //
     /* 379246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379250 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 379256 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 379258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379266 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379269 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379273 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379277 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379281 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379283 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 379290 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 379290 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 379293 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 379297 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 379312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 379317 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379323 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379333 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 379339 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379344 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379349 */     // GIR_Coverage, 4381,
     /* 379349 */     GIR_EraseRootFromParent_Done,
     /* 379350 */   // Label 7396: @379350
     /* 379350 */   GIM_Try, /*On fail goto*//*Label 7397*/ GIMT_Encode4(379459), // Rule ID 4382 //
     /* 379355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379359 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 379365 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 379367 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379371 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379375 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379378 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379382 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379386 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379390 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379392 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 379399 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 379399 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 379402 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 379406 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 379421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 379426 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379432 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 379448 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379453 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379458 */     // GIR_Coverage, 4382,
     /* 379458 */     GIR_EraseRootFromParent_Done,
     /* 379459 */   // Label 7397: @379459
     /* 379459 */   GIM_Try, /*On fail goto*//*Label 7398*/ GIMT_Encode4(379568), // Rule ID 4489 //
     /* 379464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379468 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 379474 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 379476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379480 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379484 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379487 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379491 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379495 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379499 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379501 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 379508 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 379508 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 379511 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 379515 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 379530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 379535 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379541 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379551 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 379557 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379562 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379567 */     // GIR_Coverage, 4489,
     /* 379567 */     GIR_EraseRootFromParent_Done,
     /* 379568 */   // Label 7398: @379568
     /* 379568 */   GIM_Try, /*On fail goto*//*Label 7399*/ GIMT_Encode4(379677), // Rule ID 4490 //
     /* 379573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379577 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 379583 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 379585 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379589 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379593 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379596 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379600 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379604 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379608 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379610 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 379617 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 379617 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 379620 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 379624 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 379639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 379644 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379660 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 379666 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379671 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379676 */     // GIR_Coverage, 4490,
     /* 379676 */     GIR_EraseRootFromParent_Done,
     /* 379677 */   // Label 7399: @379677
     /* 379677 */   GIM_Try, /*On fail goto*//*Label 7400*/ GIMT_Encode4(379782), // Rule ID 4387 //
     /* 379682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 379690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379698 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379701 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379705 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379709 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379713 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379715 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 379722 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 379722 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 379725 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 379729 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 379744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 379749 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379755 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 379771 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379776 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379781 */     // GIR_Coverage, 4387,
     /* 379781 */     GIR_EraseRootFromParent_Done,
     /* 379782 */   // Label 7400: @379782
     /* 379782 */   GIM_Try, /*On fail goto*//*Label 7401*/ GIMT_Encode4(379887), // Rule ID 4389 //
     /* 379787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 379795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379803 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379806 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379810 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379814 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379818 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379820 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 379827 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 379827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 379830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 379834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 379849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 379854 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379860 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379870 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 379876 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379881 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379886 */     // GIR_Coverage, 4389,
     /* 379886 */     GIR_EraseRootFromParent_Done,
     /* 379887 */   // Label 7401: @379887
     /* 379887 */   GIM_Try, /*On fail goto*//*Label 7402*/ GIMT_Encode4(379992), // Rule ID 4495 //
     /* 379892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 379900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379908 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379911 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379915 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379919 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379923 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379925 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 379932 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 379932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 379935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 379939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 379954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 379959 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379965 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 379981 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379986 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379991 */     // GIR_Coverage, 4495,
     /* 379991 */     GIR_EraseRootFromParent_Done,
     /* 379992 */   // Label 7402: @379992
     /* 379992 */   GIM_Try, /*On fail goto*//*Label 7403*/ GIMT_Encode4(380097), // Rule ID 4497 //
     /* 379997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 380005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380013 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380016 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380020 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380024 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380028 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380030 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 380037 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 380037 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 380040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 380044 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 380059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 380064 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380080 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 380086 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380091 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380096 */     // GIR_Coverage, 4497,
     /* 380096 */     GIR_EraseRootFromParent_Done,
     /* 380097 */   // Label 7403: @380097
     /* 380097 */   GIM_Try, /*On fail goto*//*Label 7404*/ GIMT_Encode4(380201), // Rule ID 4379 //
     /* 380102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380106 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 380112 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 380114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380122 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380125 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380129 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380133 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380137 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380139 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 380146 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 380146 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 380149 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 380153 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 380168 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380184 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 380190 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380195 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380200 */     // GIR_Coverage, 4379,
     /* 380200 */     GIR_EraseRootFromParent_Done,
     /* 380201 */   // Label 7404: @380201
     /* 380201 */   GIM_Try, /*On fail goto*//*Label 7405*/ GIMT_Encode4(380305), // Rule ID 4380 //
     /* 380206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380210 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 380216 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 380218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380226 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380229 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380233 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380237 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380241 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380243 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 380250 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 380250 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 380253 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 380257 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 380272 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380278 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380288 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 380294 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380299 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380304 */     // GIR_Coverage, 4380,
     /* 380304 */     GIR_EraseRootFromParent_Done,
     /* 380305 */   // Label 7405: @380305
     /* 380305 */   GIM_Try, /*On fail goto*//*Label 7406*/ GIMT_Encode4(380409), // Rule ID 4487 //
     /* 380310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380314 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 380320 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 380322 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380326 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380330 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380333 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380337 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380341 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380345 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380347 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 380354 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 380354 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 380357 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 380361 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 380376 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380392 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 380398 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380403 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380408 */     // GIR_Coverage, 4487,
     /* 380408 */     GIR_EraseRootFromParent_Done,
     /* 380409 */   // Label 7406: @380409
     /* 380409 */   GIM_Try, /*On fail goto*//*Label 7407*/ GIMT_Encode4(380513), // Rule ID 4488 //
     /* 380414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380418 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 380424 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 380426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380430 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380434 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380437 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380441 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380445 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380449 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380451 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 380458 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 380458 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 380461 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 380465 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 380480 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380486 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380496 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 380502 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380507 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380512 */     // GIR_Coverage, 4488,
     /* 380512 */     GIR_EraseRootFromParent_Done,
     /* 380513 */   // Label 7407: @380513
     /* 380513 */   GIM_Try, /*On fail goto*//*Label 7408*/ GIMT_Encode4(380613), // Rule ID 4383 //
     /* 380518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 380526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380534 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380537 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380541 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380545 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380549 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380551 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 380558 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 380558 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 380561 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 380565 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 380580 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380596 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 380602 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380607 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380612 */     // GIR_Coverage, 4383,
     /* 380612 */     GIR_EraseRootFromParent_Done,
     /* 380613 */   // Label 7408: @380613
     /* 380613 */   GIM_Try, /*On fail goto*//*Label 7409*/ GIMT_Encode4(380713), // Rule ID 4385 //
     /* 380618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 380626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380630 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380634 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380637 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380641 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380645 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380649 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380651 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 380658 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 380658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 380661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 380665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 380680 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380686 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380696 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 380702 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380707 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380712 */     // GIR_Coverage, 4385,
     /* 380712 */     GIR_EraseRootFromParent_Done,
     /* 380713 */   // Label 7409: @380713
     /* 380713 */   GIM_Try, /*On fail goto*//*Label 7410*/ GIMT_Encode4(380813), // Rule ID 4491 //
     /* 380718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 380726 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380730 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380734 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380737 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380741 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380745 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380749 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380751 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 380758 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 380758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 380761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 380765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 380780 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380796 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 380802 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380807 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380812 */     // GIR_Coverage, 4491,
     /* 380812 */     GIR_EraseRootFromParent_Done,
     /* 380813 */   // Label 7410: @380813
     /* 380813 */   GIM_Try, /*On fail goto*//*Label 7411*/ GIMT_Encode4(380913), // Rule ID 4493 //
     /* 380818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 380826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380834 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380837 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380841 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380845 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380849 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380851 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 380858 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 380858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 380861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 380865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 380880 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380896 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 380902 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380907 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380912 */     // GIR_Coverage, 4493,
     /* 380912 */     GIR_EraseRootFromParent_Done,
     /* 380913 */   // Label 7411: @380913
     /* 380913 */   GIM_Try, /*On fail goto*//*Label 7412*/ GIMT_Encode4(380977), // Rule ID 11365 //
     /* 380918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 380921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 380929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380937 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 380941 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 380945 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 380949 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 380953 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 380957 */     // MIs[3] Operand 1
     /* 380957 */     // No operand predicates
     /* 380957 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380961 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 380963 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$Idx), 0:{ *:[i64] })  =>  (DUP_ZZI_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$Idx)
     /* 380963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 380966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 380968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vec
     /* 380972 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Idx
     /* 380975 */     GIR_RootConstrainSelectedInstOperands,
     /* 380976 */     // GIR_Coverage, 11365,
     /* 380976 */     GIR_EraseRootFromParent_Done,
     /* 380977 */   // Label 7412: @380977
     /* 380977 */   GIM_Try, /*On fail goto*//*Label 7413*/ GIMT_Encode4(381088), // Rule ID 11306 //
     /* 380982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 380985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 380989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 380993 */     // (vector_insert:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$vec, GPR64:{ *:[i64] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), GPR64:{ *:[i64] }:$src)
     /* 380993 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 380996 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 381000 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381005 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 381009 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 381011 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 381014 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 381018 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381023 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 381026 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 381029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 381031 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 381034 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 381038 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381043 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 381046 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 381048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 381051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 381055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381060 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 381063 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 381066 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 381069 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 381072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_D),
     /* 381077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 381079 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 381081 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381084 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 381086 */     GIR_RootConstrainSelectedInstOperands,
     /* 381087 */     // GIR_Coverage, 11306,
     /* 381087 */     GIR_EraseRootFromParent_Done,
     /* 381088 */   // Label 7413: @381088
     /* 381088 */   GIM_Try, /*On fail goto*//*Label 7414*/ GIMT_Encode4(381199), // Rule ID 11312 //
     /* 381093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 381096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 381104 */     // (vector_insert:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$vec, FPR64:{ *:[f64] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_D:{ *:[nxv2f64] } ZPR:{ *:[nxv2f64] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } ?:{ *:[i64] }:$index)), ?:{ *:[f64] }:$src)
     /* 381104 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 381107 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 381111 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381116 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 381120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 381122 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 381125 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 381129 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381134 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 381137 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 381140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 381142 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 381145 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 381149 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381154 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 381157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 381159 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 381162 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 381166 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381171 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 381174 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 381177 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 381180 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 381183 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_D),
     /* 381188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 381190 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 381192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381195 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 381197 */     GIR_RootConstrainSelectedInstOperands,
     /* 381198 */     // GIR_Coverage, 11312,
     /* 381198 */     GIR_EraseRootFromParent_Done,
     /* 381199 */   // Label 7414: @381199
     /* 381199 */   GIM_Reject,
     /* 381200 */ // Label 7395: @381200
     /* 381200 */ GIM_Reject,
     /* 381201 */ // Label 7158: @381201
     /* 381201 */ GIM_Try, /*On fail goto*//*Label 7415*/ GIMT_Encode4(381352), // Rule ID 11308 //
     /* 381206 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 381209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 381212 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 381215 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 381218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381222 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381226 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 381230 */   // (vector_insert:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv4f16] } ZPR:{ *:[nxv4f16] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f16] }:$src)
     /* 381230 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 381233 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381237 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381242 */   GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 381248 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 381253 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 381258 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 381261 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 381265 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381270 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 381273 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 381275 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 381278 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 381282 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381287 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 381290 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 381293 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 381295 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 381298 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 381302 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381307 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 381310 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 381312 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 381315 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 381319 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381324 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 381327 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 381330 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 381333 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 381336 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381338 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 381341 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 381343 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 381345 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381348 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 381350 */   GIR_RootConstrainSelectedInstOperands,
     /* 381351 */   // GIR_Coverage, 11308,
     /* 381351 */   GIR_EraseRootFromParent_Done,
     /* 381352 */ // Label 7415: @381352
     /* 381352 */ GIM_Reject,
     /* 381353 */ // Label 7159: @381353
     /* 381353 */ GIM_Try, /*On fail goto*//*Label 7416*/ GIMT_Encode4(383384),
     /* 381358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 381361 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 381364 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 381367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381371 */   GIM_Try, /*On fail goto*//*Label 7417*/ GIMT_Encode4(381480), // Rule ID 4345 //
     /* 381376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381380 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 381386 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 381388 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381392 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381396 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381399 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381403 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381407 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381411 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381413 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 381420 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 381420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 381423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 381427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 381442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 381447 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381463 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 381469 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381474 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381479 */     // GIR_Coverage, 4345,
     /* 381479 */     GIR_EraseRootFromParent_Done,
     /* 381480 */   // Label 7417: @381480
     /* 381480 */   GIM_Try, /*On fail goto*//*Label 7418*/ GIMT_Encode4(381589), // Rule ID 4346 //
     /* 381485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381489 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 381495 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 381497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381505 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381508 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381512 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381516 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381520 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381522 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 381529 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 381529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 381532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 381536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 381551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 381556 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381572 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 381578 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381583 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381588 */     // GIR_Coverage, 4346,
     /* 381588 */     GIR_EraseRootFromParent_Done,
     /* 381589 */   // Label 7418: @381589
     /* 381589 */   GIM_Try, /*On fail goto*//*Label 7419*/ GIMT_Encode4(381698), // Rule ID 4453 //
     /* 381594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381598 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 381604 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 381606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381610 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381614 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381617 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381621 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381625 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381629 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381631 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 381638 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 381638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 381641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 381645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 381660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 381665 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381671 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381681 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 381687 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381692 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381697 */     // GIR_Coverage, 4453,
     /* 381697 */     GIR_EraseRootFromParent_Done,
     /* 381698 */   // Label 7419: @381698
     /* 381698 */   GIM_Try, /*On fail goto*//*Label 7420*/ GIMT_Encode4(381807), // Rule ID 4454 //
     /* 381703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381707 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 381713 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 381715 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381719 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381723 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381726 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381730 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381734 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381738 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381740 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 381747 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 381747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 381750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 381754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 381769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 381774 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381780 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 381796 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381801 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381806 */     // GIR_Coverage, 4454,
     /* 381806 */     GIR_EraseRootFromParent_Done,
     /* 381807 */   // Label 7420: @381807
     /* 381807 */   GIM_Try, /*On fail goto*//*Label 7421*/ GIMT_Encode4(381912), // Rule ID 4351 //
     /* 381812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 381820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381828 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381831 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381835 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381839 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381843 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381845 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 381852 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 381852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 381855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 381859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 381874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 381879 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381885 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381895 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 381901 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381906 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381911 */     // GIR_Coverage, 4351,
     /* 381911 */     GIR_EraseRootFromParent_Done,
     /* 381912 */   // Label 7421: @381912
     /* 381912 */   GIM_Try, /*On fail goto*//*Label 7422*/ GIMT_Encode4(382017), // Rule ID 4353 //
     /* 381917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 381925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381933 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381936 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381940 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381944 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381948 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381950 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 381957 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 381957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 381960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 381964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 381979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 381984 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382000 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 382006 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382011 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382016 */     // GIR_Coverage, 4353,
     /* 382016 */     GIR_EraseRootFromParent_Done,
     /* 382017 */   // Label 7422: @382017
     /* 382017 */   GIM_Try, /*On fail goto*//*Label 7423*/ GIMT_Encode4(382122), // Rule ID 4459 //
     /* 382022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 382030 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382034 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382038 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382041 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382045 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382049 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382053 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382055 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 382062 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 382062 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 382065 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 382069 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 382084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 382089 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382095 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382105 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 382111 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382116 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382121 */     // GIR_Coverage, 4459,
     /* 382121 */     GIR_EraseRootFromParent_Done,
     /* 382122 */   // Label 7423: @382122
     /* 382122 */   GIM_Try, /*On fail goto*//*Label 7424*/ GIMT_Encode4(382227), // Rule ID 4461 //
     /* 382127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 382135 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382139 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382143 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382146 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382150 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382154 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382158 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382160 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 382167 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 382167 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 382170 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 382174 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 382189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 382194 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382200 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382210 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 382216 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382221 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382226 */     // GIR_Coverage, 4461,
     /* 382226 */     GIR_EraseRootFromParent_Done,
     /* 382227 */   // Label 7424: @382227
     /* 382227 */   GIM_Try, /*On fail goto*//*Label 7425*/ GIMT_Encode4(382331), // Rule ID 4343 //
     /* 382232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382236 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 382242 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 382244 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382248 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382252 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382255 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382259 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382263 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382267 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382269 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 382276 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 382276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 382279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 382283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 382298 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382314 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 382320 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382325 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382330 */     // GIR_Coverage, 4343,
     /* 382330 */     GIR_EraseRootFromParent_Done,
     /* 382331 */   // Label 7425: @382331
     /* 382331 */   GIM_Try, /*On fail goto*//*Label 7426*/ GIMT_Encode4(382435), // Rule ID 4344 //
     /* 382336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382340 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 382346 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 382348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382356 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382359 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382363 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382367 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382371 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382373 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 382380 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 382380 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 382383 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 382387 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 382402 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382408 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382418 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 382424 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382429 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382434 */     // GIR_Coverage, 4344,
     /* 382434 */     GIR_EraseRootFromParent_Done,
     /* 382435 */   // Label 7426: @382435
     /* 382435 */   GIM_Try, /*On fail goto*//*Label 7427*/ GIMT_Encode4(382539), // Rule ID 4451 //
     /* 382440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382444 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 382450 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 382452 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382456 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382460 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382463 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382467 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382471 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382475 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382477 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 382484 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 382484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 382487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 382491 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 382506 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382512 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 382528 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382533 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382538 */     // GIR_Coverage, 4451,
     /* 382538 */     GIR_EraseRootFromParent_Done,
     /* 382539 */   // Label 7427: @382539
     /* 382539 */   GIM_Try, /*On fail goto*//*Label 7428*/ GIMT_Encode4(382643), // Rule ID 4452 //
     /* 382544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382548 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 382554 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 382556 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382560 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382564 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382567 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382571 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382575 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382579 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382581 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 382588 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 382588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 382591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 382595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 382610 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382616 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382626 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 382632 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382637 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382642 */     // GIR_Coverage, 4452,
     /* 382642 */     GIR_EraseRootFromParent_Done,
     /* 382643 */   // Label 7428: @382643
     /* 382643 */   GIM_Try, /*On fail goto*//*Label 7429*/ GIMT_Encode4(382743), // Rule ID 4347 //
     /* 382648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 382656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382660 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382664 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382667 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382671 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382675 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382679 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382681 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 382688 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 382688 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 382691 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 382695 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 382710 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 382732 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382737 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382742 */     // GIR_Coverage, 4347,
     /* 382742 */     GIR_EraseRootFromParent_Done,
     /* 382743 */   // Label 7429: @382743
     /* 382743 */   GIM_Try, /*On fail goto*//*Label 7430*/ GIMT_Encode4(382843), // Rule ID 4349 //
     /* 382748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 382756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382764 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382767 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382771 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382775 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382779 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382781 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 382788 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 382788 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 382791 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 382795 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 382810 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 382832 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382837 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382842 */     // GIR_Coverage, 4349,
     /* 382842 */     GIR_EraseRootFromParent_Done,
     /* 382843 */   // Label 7430: @382843
     /* 382843 */   GIM_Try, /*On fail goto*//*Label 7431*/ GIMT_Encode4(382943), // Rule ID 4455 //
     /* 382848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 382856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382864 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382867 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382871 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382875 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382879 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382881 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 382888 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 382888 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 382891 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 382895 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 382910 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382916 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 382932 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382937 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382942 */     // GIR_Coverage, 4455,
     /* 382942 */     GIR_EraseRootFromParent_Done,
     /* 382943 */   // Label 7431: @382943
     /* 382943 */   GIM_Try, /*On fail goto*//*Label 7432*/ GIMT_Encode4(383043), // Rule ID 4457 //
     /* 382948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 382956 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382960 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382964 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382967 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382971 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382975 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382979 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382981 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 382988 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 382988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 382991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 382995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 383010 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 383032 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383037 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383042 */     // GIR_Coverage, 4457,
     /* 383042 */     GIR_EraseRootFromParent_Done,
     /* 383043 */   // Label 7432: @383043
     /* 383043 */   GIM_Try, /*On fail goto*//*Label 7433*/ GIMT_Encode4(383107), // Rule ID 11363 //
     /* 383048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 383051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 383059 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383063 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383067 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 383071 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 383075 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 383079 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 383083 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 383087 */     // MIs[3] Operand 1
     /* 383087 */     // No operand predicates
     /* 383087 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383091 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383093 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$Idx), 0:{ *:[i64] })  =>  (DUP_ZZI_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$Idx)
     /* 383093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 383096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 383098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vec
     /* 383102 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Idx
     /* 383105 */     GIR_RootConstrainSelectedInstOperands,
     /* 383106 */     // GIR_Coverage, 11363,
     /* 383106 */     GIR_EraseRootFromParent_Done,
     /* 383107 */   // Label 7433: @383107
     /* 383107 */   GIM_Try, /*On fail goto*//*Label 7434*/ GIMT_Encode4(383245), // Rule ID 11305 //
     /* 383112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 383115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 383119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 383123 */     // (vector_insert:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 383123 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 383126 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383130 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383135 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 383141 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 383146 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 383151 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 383154 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 383158 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383163 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 383166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 383168 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 383171 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 383175 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383180 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 383183 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 383186 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 383188 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 383191 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 383195 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383200 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 383203 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 383205 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 383208 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 383212 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383217 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 383220 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 383223 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 383226 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 383229 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_S),
     /* 383234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 383236 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 383238 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383241 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 383243 */     GIR_RootConstrainSelectedInstOperands,
     /* 383244 */     // GIR_Coverage, 11305,
     /* 383244 */     GIR_EraseRootFromParent_Done,
     /* 383245 */   // Label 7434: @383245
     /* 383245 */   GIM_Try, /*On fail goto*//*Label 7435*/ GIMT_Encode4(383383), // Rule ID 11311 //
     /* 383250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 383253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 383261 */     // (vector_insert:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$vec, FPR32:{ *:[f32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_S:{ *:[nxv4f32] } ZPR:{ *:[nxv4f32] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f32] }:$src)
     /* 383261 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 383264 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383268 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383273 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 383279 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 383284 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 383289 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 383292 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 383296 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383301 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 383304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 383306 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 383309 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 383313 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383318 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 383321 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 383324 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 383326 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 383329 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 383333 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383338 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 383341 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 383343 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 383346 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 383350 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383355 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 383358 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 383361 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 383364 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 383367 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_S),
     /* 383372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 383374 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 383376 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383379 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 383381 */     GIR_RootConstrainSelectedInstOperands,
     /* 383382 */     // GIR_Coverage, 11311,
     /* 383382 */     GIR_EraseRootFromParent_Done,
     /* 383383 */   // Label 7435: @383383
     /* 383383 */   GIM_Reject,
     /* 383384 */ // Label 7416: @383384
     /* 383384 */ GIM_Reject,
     /* 383385 */ // Label 7160: @383385
     /* 383385 */ GIM_Try, /*On fail goto*//*Label 7436*/ GIMT_Encode4(385652),
     /* 383390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 383393 */   GIM_Try, /*On fail goto*//*Label 7437*/ GIMT_Encode4(383519), // Rule ID 4309 //
     /* 383398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 383401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383412 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 383418 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 383420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383428 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383431 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383435 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 383442 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383446 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383450 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383452 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 383459 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 383459 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 383462 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 383466 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 383481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 383486 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 383508 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383513 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383518 */     // GIR_Coverage, 4309,
     /* 383518 */     GIR_EraseRootFromParent_Done,
     /* 383519 */   // Label 7437: @383519
     /* 383519 */   GIM_Try, /*On fail goto*//*Label 7438*/ GIMT_Encode4(383645), // Rule ID 4310 //
     /* 383524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 383527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383538 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 383544 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 383546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383554 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383557 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383561 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 383568 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383572 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383576 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383578 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 383585 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 383585 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 383588 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 383592 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 383607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 383612 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383628 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 383634 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383639 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383644 */     // GIR_Coverage, 4310,
     /* 383644 */     GIR_EraseRootFromParent_Done,
     /* 383645 */   // Label 7438: @383645
     /* 383645 */   GIM_Try, /*On fail goto*//*Label 7439*/ GIMT_Encode4(383764), // Rule ID 4417 //
     /* 383650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 383653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383664 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 383670 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 383672 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383676 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383680 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383683 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383687 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383691 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383695 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383697 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 383704 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 383704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 383707 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 383711 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 383726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 383731 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383737 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383747 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 383753 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383758 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383763 */     // GIR_Coverage, 4417,
     /* 383763 */     GIR_EraseRootFromParent_Done,
     /* 383764 */   // Label 7439: @383764
     /* 383764 */   GIM_Try, /*On fail goto*//*Label 7440*/ GIMT_Encode4(383883), // Rule ID 4418 //
     /* 383769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 383772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383783 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 383789 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 383791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383799 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383802 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383806 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383810 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383814 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383816 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 383823 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 383823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 383826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 383830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 383845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 383850 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383856 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383866 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 383872 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383877 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383882 */     // GIR_Coverage, 4418,
     /* 383882 */     GIR_EraseRootFromParent_Done,
     /* 383883 */   // Label 7440: @383883
     /* 383883 */   GIM_Try, /*On fail goto*//*Label 7441*/ GIMT_Encode4(384005), // Rule ID 4315 //
     /* 383888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 383891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 383906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383914 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383917 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383921 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 383928 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383932 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383936 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383938 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 383945 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 383945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 383948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 383952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 383967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 383972 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383978 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383988 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 383994 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383999 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 384004 */     // GIR_Coverage, 4315,
     /* 384004 */     GIR_EraseRootFromParent_Done,
     /* 384005 */   // Label 7441: @384005
     /* 384005 */   GIM_Try, /*On fail goto*//*Label 7442*/ GIMT_Encode4(384127), // Rule ID 4317 //
     /* 384010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 384013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 384028 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384032 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384036 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384039 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384043 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 384050 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384054 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384058 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384060 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 384067 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 384067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 384070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 384074 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 384089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 384094 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384100 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384110 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 384116 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384121 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 384126 */     // GIR_Coverage, 4317,
     /* 384126 */     GIR_EraseRootFromParent_Done,
     /* 384127 */   // Label 7442: @384127
     /* 384127 */   GIM_Try, /*On fail goto*//*Label 7443*/ GIMT_Encode4(384242), // Rule ID 4423 //
     /* 384132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 384135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 384150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384158 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384161 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384165 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384169 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384173 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384175 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 384182 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 384182 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 384185 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 384189 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 384204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 384209 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384215 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384225 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 384231 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384236 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 384241 */     // GIR_Coverage, 4423,
     /* 384241 */     GIR_EraseRootFromParent_Done,
     /* 384242 */   // Label 7443: @384242
     /* 384242 */   GIM_Try, /*On fail goto*//*Label 7444*/ GIMT_Encode4(384357), // Rule ID 4425 //
     /* 384247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 384250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 384265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384273 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384276 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384280 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384284 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384288 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384290 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 384297 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 384297 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 384300 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 384304 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 384319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 384324 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384330 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 384346 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384351 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 384356 */     // GIR_Coverage, 4425,
     /* 384356 */     GIR_EraseRootFromParent_Done,
     /* 384357 */   // Label 7444: @384357
     /* 384357 */   GIM_Try, /*On fail goto*//*Label 7445*/ GIMT_Encode4(384478), // Rule ID 4307 //
     /* 384362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 384365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384376 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 384382 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 384384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384392 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384395 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384399 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 384406 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384410 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384414 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384416 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 384423 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 384423 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 384426 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 384430 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 384445 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384451 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 384467 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384472 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 384477 */     // GIR_Coverage, 4307,
     /* 384477 */     GIR_EraseRootFromParent_Done,
     /* 384478 */   // Label 7445: @384478
     /* 384478 */   GIM_Try, /*On fail goto*//*Label 7446*/ GIMT_Encode4(384599), // Rule ID 4308 //
     /* 384483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 384486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384497 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 384503 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 384505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384513 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384516 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384520 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 384527 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384531 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384535 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384537 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 384544 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 384544 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 384547 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 384551 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 384566 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384572 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384582 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 384588 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384593 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 384598 */     // GIR_Coverage, 4308,
     /* 384598 */     GIR_EraseRootFromParent_Done,
     /* 384599 */   // Label 7446: @384599
     /* 384599 */   GIM_Try, /*On fail goto*//*Label 7447*/ GIMT_Encode4(384713), // Rule ID 4415 //
     /* 384604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 384607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384618 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 384624 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 384626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384630 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384634 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384637 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384641 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384645 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384649 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384651 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 384658 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 384658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 384661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 384665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 384680 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384686 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384696 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 384702 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384707 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 384712 */     // GIR_Coverage, 4415,
     /* 384712 */     GIR_EraseRootFromParent_Done,
     /* 384713 */   // Label 7447: @384713
     /* 384713 */   GIM_Try, /*On fail goto*//*Label 7448*/ GIMT_Encode4(384827), // Rule ID 4416 //
     /* 384718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 384721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384732 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 384738 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 384740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384748 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384751 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384755 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384759 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384763 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384765 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 384772 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 384772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 384775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 384779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 384794 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384800 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384810 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 384816 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384821 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 384826 */     // GIR_Coverage, 4416,
     /* 384826 */     GIR_EraseRootFromParent_Done,
     /* 384827 */   // Label 7448: @384827
     /* 384827 */   GIM_Try, /*On fail goto*//*Label 7449*/ GIMT_Encode4(384944), // Rule ID 4311 //
     /* 384832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 384835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 384850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384858 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384861 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384865 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 384872 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384876 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384880 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384882 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 384889 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 384889 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 384892 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 384896 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 384911 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384917 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384927 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 384933 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384938 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 384943 */     // GIR_Coverage, 4311,
     /* 384943 */     GIR_EraseRootFromParent_Done,
     /* 384944 */   // Label 7449: @384944
     /* 384944 */   GIM_Try, /*On fail goto*//*Label 7450*/ GIMT_Encode4(385061), // Rule ID 4313 //
     /* 384949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 384952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 384967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384975 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384978 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384982 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 384989 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384993 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384997 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384999 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 385006 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 385006 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 385009 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 385013 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 385023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 385028 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 385034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 385050 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385055 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385060 */     // GIR_Coverage, 4313,
     /* 385060 */     GIR_EraseRootFromParent_Done,
     /* 385061 */   // Label 7450: @385061
     /* 385061 */   GIM_Try, /*On fail goto*//*Label 7451*/ GIMT_Encode4(385171), // Rule ID 4419 //
     /* 385066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 385069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 385072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 385084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385092 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385095 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 385099 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 385103 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 385107 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385109 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 385116 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 385116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 385119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 385123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 385133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 385138 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 385144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385154 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 385160 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385165 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385170 */     // GIR_Coverage, 4419,
     /* 385170 */     GIR_EraseRootFromParent_Done,
     /* 385171 */   // Label 7451: @385171
     /* 385171 */   GIM_Try, /*On fail goto*//*Label 7452*/ GIMT_Encode4(385281), // Rule ID 4421 //
     /* 385176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 385179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 385182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 385194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385202 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385205 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 385209 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 385213 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 385217 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385219 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 385226 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 385226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 385229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 385233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 385243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 385248 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 385254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385264 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 385270 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385275 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385280 */     // GIR_Coverage, 4421,
     /* 385280 */     GIR_EraseRootFromParent_Done,
     /* 385281 */   // Label 7452: @385281
     /* 385281 */   GIM_Try, /*On fail goto*//*Label 7453*/ GIMT_Encode4(385355), // Rule ID 11361 //
     /* 385286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 385289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 385292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 385295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 385307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 385315 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 385319 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 385323 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 385327 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385331 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 385335 */     // MIs[3] Operand 1
     /* 385335 */     // No operand predicates
     /* 385335 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 385339 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385341 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$Idx), 0:{ *:[i64] })  =>  (DUP_ZZI_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$Idx)
     /* 385341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 385344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 385346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vec
     /* 385350 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Idx
     /* 385353 */     GIR_RootConstrainSelectedInstOperands,
     /* 385354 */     // GIR_Coverage, 11361,
     /* 385354 */     GIR_EraseRootFromParent_Done,
     /* 385355 */   // Label 7453: @385355
     /* 385355 */   GIM_Try, /*On fail goto*//*Label 7454*/ GIMT_Encode4(385503), // Rule ID 11304 //
     /* 385360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 385363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 385366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 385369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 385377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 385381 */     // (vector_insert:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (CMPEQ_PPzZZ_H:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_H:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_H:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 385381 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 385384 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385388 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385393 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 385399 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 385404 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 385409 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 385412 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 385416 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385421 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 385424 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 385426 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 385429 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_H),
     /* 385433 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385438 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 385441 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 385444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 385446 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 385449 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 385453 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385458 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 385461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 385463 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 385466 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_H),
     /* 385470 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385475 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 385478 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 385481 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 385484 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 385487 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_H),
     /* 385492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 385494 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 385496 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385499 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 385501 */     GIR_RootConstrainSelectedInstOperands,
     /* 385502 */     // GIR_Coverage, 11304,
     /* 385502 */     GIR_EraseRootFromParent_Done,
     /* 385503 */   // Label 7454: @385503
     /* 385503 */   GIM_Try, /*On fail goto*//*Label 7455*/ GIMT_Encode4(385651), // Rule ID 11309 //
     /* 385508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 385511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 385514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 385517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 385529 */     // (vector_insert:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv8f16] } ZPR:{ *:[nxv8f16] }:$vec, (CMPEQ_PPzZZ_H:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_H:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_H:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f16] }:$src)
     /* 385529 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 385532 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385536 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385541 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 385547 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 385552 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 385557 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 385560 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 385564 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385569 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 385572 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 385574 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 385577 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_H),
     /* 385581 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385586 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 385589 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 385592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 385594 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 385597 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 385601 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385606 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 385609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 385611 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 385614 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_H),
     /* 385618 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385623 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 385626 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 385629 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 385632 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 385635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 385640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 385642 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 385644 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385647 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 385649 */     GIR_RootConstrainSelectedInstOperands,
     /* 385650 */     // GIR_Coverage, 11309,
     /* 385650 */     GIR_EraseRootFromParent_Done,
     /* 385651 */   // Label 7455: @385651
     /* 385651 */   GIM_Reject,
     /* 385652 */ // Label 7436: @385652
     /* 385652 */ GIM_Reject,
     /* 385653 */ // Label 7161: @385653
     /* 385653 */ GIM_Try, /*On fail goto*//*Label 7456*/ GIMT_Encode4(387772),
     /* 385658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 385661 */   GIM_Try, /*On fail goto*//*Label 7457*/ GIMT_Encode4(385780), // Rule ID 4237 //
     /* 385666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 385669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 385672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385680 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 385686 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 385688 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385692 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385696 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385699 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 385703 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 385707 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 385711 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385713 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 385720 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 385720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 385723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 385727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 385737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 385742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 385747 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 385753 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385763 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 385769 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385774 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 385779 */     // GIR_Coverage, 4237,
     /* 385779 */     GIR_EraseRootFromParent_Done,
     /* 385780 */   // Label 7457: @385780
     /* 385780 */   GIM_Try, /*On fail goto*//*Label 7458*/ GIMT_Encode4(385899), // Rule ID 4238 //
     /* 385785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 385788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 385791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385799 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 385805 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 385807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385815 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385818 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 385822 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 385826 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 385830 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385832 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 385839 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 385839 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 385842 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 385846 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 385856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 385861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 385866 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 385872 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 385888 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385893 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 385898 */     // GIR_Coverage, 4238,
     /* 385898 */     GIR_EraseRootFromParent_Done,
     /* 385899 */   // Label 7458: @385899
     /* 385899 */   GIM_Try, /*On fail goto*//*Label 7459*/ GIMT_Encode4(386025), // Rule ID 4273 //
     /* 385904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 385907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 385910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385918 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 385924 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 385926 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385930 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385934 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385937 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 385941 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 385948 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 385952 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 385956 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385958 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 385965 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 385965 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 385968 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 385972 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 385982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 385987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 385992 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 385998 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386008 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 386014 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386019 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 386024 */     // GIR_Coverage, 4273,
     /* 386024 */     GIR_EraseRootFromParent_Done,
     /* 386025 */   // Label 7459: @386025
     /* 386025 */   GIM_Try, /*On fail goto*//*Label 7460*/ GIMT_Encode4(386151), // Rule ID 4274 //
     /* 386030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 386033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 386036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386044 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 386050 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 386052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 386060 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 386063 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 386067 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 386074 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 386078 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 386082 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386084 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 386091 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 386091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 386094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 386098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 386108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 386113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 386118 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 386124 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386134 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 386140 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386145 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 386150 */     // GIR_Coverage, 4274,
     /* 386150 */     GIR_EraseRootFromParent_Done,
     /* 386151 */   // Label 7460: @386151
     /* 386151 */   GIM_Try, /*On fail goto*//*Label 7461*/ GIMT_Encode4(386266), // Rule ID 4243 //
     /* 386156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 386159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 386162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 386174 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386178 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 386182 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 386185 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 386189 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 386193 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 386197 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386199 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 386206 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 386206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 386209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 386213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 386223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 386228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 386233 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 386239 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 386255 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386260 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 386265 */     // GIR_Coverage, 4243,
     /* 386265 */     GIR_EraseRootFromParent_Done,
     /* 386266 */   // Label 7461: @386266
     /* 386266 */   GIM_Try, /*On fail goto*//*Label 7462*/ GIMT_Encode4(386381), // Rule ID 4245 //
     /* 386271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 386274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 386277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 386289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 386297 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 386300 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 386304 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 386308 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 386312 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386314 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 386321 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 386321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 386324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 386328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 386338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 386343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 386348 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 386354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386364 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 386370 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386375 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 386380 */     // GIR_Coverage, 4245,
     /* 386380 */     GIR_EraseRootFromParent_Done,
     /* 386381 */   // Label 7462: @386381
     /* 386381 */   GIM_Try, /*On fail goto*//*Label 7463*/ GIMT_Encode4(386503), // Rule ID 4279 //
     /* 386386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 386389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 386392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 386404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 386412 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 386415 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 386419 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 386426 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 386430 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 386434 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386436 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 386443 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 386443 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 386446 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 386450 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 386460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 386465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 386470 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 386476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386486 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 386492 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386497 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 386502 */     // GIR_Coverage, 4279,
     /* 386502 */     GIR_EraseRootFromParent_Done,
     /* 386503 */   // Label 7463: @386503
     /* 386503 */   GIM_Try, /*On fail goto*//*Label 7464*/ GIMT_Encode4(386625), // Rule ID 4281 //
     /* 386508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 386511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 386514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 386526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 386534 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 386537 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 386541 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 386548 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 386552 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 386556 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386558 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 386565 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 386565 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 386568 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 386572 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 386582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 386587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 386592 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 386598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386608 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 386614 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386619 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 386624 */     // GIR_Coverage, 4281,
     /* 386624 */     GIR_EraseRootFromParent_Done,
     /* 386625 */   // Label 7464: @386625
     /* 386625 */   GIM_Try, /*On fail goto*//*Label 7465*/ GIMT_Encode4(386739), // Rule ID 4235 //
     /* 386630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 386633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 386636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386644 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 386650 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 386652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 386660 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 386663 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 386667 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 386671 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 386675 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386677 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 386684 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 386684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 386687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 386691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 386701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 386706 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 386712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 386728 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386733 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 386738 */     // GIR_Coverage, 4235,
     /* 386738 */     GIR_EraseRootFromParent_Done,
     /* 386739 */   // Label 7465: @386739
     /* 386739 */   GIM_Try, /*On fail goto*//*Label 7466*/ GIMT_Encode4(386853), // Rule ID 4236 //
     /* 386744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 386747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 386750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386758 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 386764 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 386766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386770 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 386774 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 386777 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 386781 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 386785 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 386789 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386791 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 386798 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 386798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 386801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 386805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 386815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 386820 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 386826 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386836 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 386842 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386847 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 386852 */     // GIR_Coverage, 4236,
     /* 386852 */     GIR_EraseRootFromParent_Done,
     /* 386853 */   // Label 7466: @386853
     /* 386853 */   GIM_Try, /*On fail goto*//*Label 7467*/ GIMT_Encode4(386974), // Rule ID 4271 //
     /* 386858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 386861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 386864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386872 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 386878 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 386880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 386888 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 386891 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 386895 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 386902 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 386906 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 386910 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386912 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 386919 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 386919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 386922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 386926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 386936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 386941 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 386947 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 386963 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386968 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 386973 */     // GIR_Coverage, 4271,
     /* 386973 */     GIR_EraseRootFromParent_Done,
     /* 386974 */   // Label 7467: @386974
     /* 386974 */   GIM_Try, /*On fail goto*//*Label 7468*/ GIMT_Encode4(387095), // Rule ID 4272 //
     /* 386979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 386982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 386985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386993 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 386999 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 387001 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387005 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 387009 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 387012 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 387016 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 387023 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 387027 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 387031 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 387033 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 387040 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 387040 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 387043 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 387047 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 387057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 387062 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 387068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 387073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387078 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 387084 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387089 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 387094 */     // GIR_Coverage, 4272,
     /* 387094 */     GIR_EraseRootFromParent_Done,
     /* 387095 */   // Label 7468: @387095
     /* 387095 */   GIM_Try, /*On fail goto*//*Label 7469*/ GIMT_Encode4(387205), // Rule ID 4239 //
     /* 387100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 387103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 387106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 387118 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387122 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 387126 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 387129 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 387133 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 387137 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 387141 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 387143 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 387150 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 387150 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 387153 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 387157 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 387167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 387172 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 387178 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 387183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387188 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 387194 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387199 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 387204 */     // GIR_Coverage, 4239,
     /* 387204 */     GIR_EraseRootFromParent_Done,
     /* 387205 */   // Label 7469: @387205
     /* 387205 */   GIM_Try, /*On fail goto*//*Label 7470*/ GIMT_Encode4(387315), // Rule ID 4241 //
     /* 387210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 387213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 387216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 387228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 387236 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 387239 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 387243 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 387247 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 387251 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 387253 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 387260 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 387260 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 387263 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 387267 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 387277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 387282 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 387288 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 387293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387298 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 387304 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387309 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 387314 */     // GIR_Coverage, 4241,
     /* 387314 */     GIR_EraseRootFromParent_Done,
     /* 387315 */   // Label 7470: @387315
     /* 387315 */   GIM_Try, /*On fail goto*//*Label 7471*/ GIMT_Encode4(387432), // Rule ID 4275 //
     /* 387320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 387323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 387326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 387338 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387342 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 387346 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 387349 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 387353 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 387360 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 387364 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 387368 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 387370 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 387377 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 387377 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 387380 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 387384 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 387394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 387399 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 387405 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 387410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387415 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 387421 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387426 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 387431 */     // GIR_Coverage, 4275,
     /* 387431 */     GIR_EraseRootFromParent_Done,
     /* 387432 */   // Label 7471: @387432
     /* 387432 */   GIM_Try, /*On fail goto*//*Label 7472*/ GIMT_Encode4(387549), // Rule ID 4277 //
     /* 387437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 387440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 387443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 387455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 387463 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 387466 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 387470 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 387477 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 387481 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 387485 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 387487 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 387494 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 387494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 387497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 387501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 387511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 387516 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 387522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 387527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387532 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 387538 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387543 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 387548 */     // GIR_Coverage, 4277,
     /* 387548 */     GIR_EraseRootFromParent_Done,
     /* 387549 */   // Label 7472: @387549
     /* 387549 */   GIM_Try, /*On fail goto*//*Label 7473*/ GIMT_Encode4(387623), // Rule ID 11359 //
     /* 387554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 387560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 387563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 387575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387579 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 387583 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 387587 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 387591 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 387595 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387599 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 387603 */     // MIs[3] Operand 1
     /* 387603 */     // No operand predicates
     /* 387603 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 387607 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387609 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$Idx), 0:{ *:[i64] })  =>  (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$Idx)
     /* 387609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 387612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 387614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vec
     /* 387618 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Idx
     /* 387621 */     GIR_RootConstrainSelectedInstOperands,
     /* 387622 */     // GIR_Coverage, 11359,
     /* 387622 */     GIR_EraseRootFromParent_Done,
     /* 387623 */   // Label 7473: @387623
     /* 387623 */   GIM_Try, /*On fail goto*//*Label 7474*/ GIMT_Encode4(387771), // Rule ID 11303 //
     /* 387628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 387634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 387637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 387645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 387649 */     // (vector_insert:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (CMPEQ_PPzZZ_B:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_B:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_B:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 387649 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 387652 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387656 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387661 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 387667 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 387672 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 387677 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 387680 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_B),
     /* 387684 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387689 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 387692 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 387694 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 387697 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_B),
     /* 387701 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387706 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 387709 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 387712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 387714 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 387717 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 387721 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387726 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 387729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 387731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 387734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_B),
     /* 387738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387743 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 387746 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 387749 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 387752 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 387755 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_B),
     /* 387760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 387762 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 387764 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387767 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 387769 */     GIR_RootConstrainSelectedInstOperands,
     /* 387770 */     // GIR_Coverage, 11303,
     /* 387770 */     GIR_EraseRootFromParent_Done,
     /* 387771 */   // Label 7474: @387771
     /* 387771 */   GIM_Reject,
     /* 387772 */ // Label 7456: @387772
     /* 387772 */ GIM_Reject,
     /* 387773 */ // Label 7162: @387773
     /* 387773 */ GIM_Reject,
     /* 387774 */ // Label 92: @387774
     /* 387774 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7478*/ GIMT_Encode4(390691),
     /* 387785 */ /*GILLT_s16*//*Label 7475*/ GIMT_Encode4(387797),
     /* 387789 */ /*GILLT_s32*//*Label 7476*/ GIMT_Encode4(388431),
     /* 387793 */ /*GILLT_s64*//*Label 7477*/ GIMT_Encode4(390024),
     /* 387797 */ // Label 7475: @387797
     /* 387797 */ GIM_Try, /*On fail goto*//*Label 7479*/ GIMT_Encode4(387841), // Rule ID 11352 //
     /* 387802 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 387808 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 387815 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 387819 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$Zs, hsub:{ *:[i32] })
     /* 387819 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387822 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387824 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 387830 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 387835 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387840 */   // GIR_Coverage, 11352,
     /* 387840 */   GIR_EraseRootFromParent_Done,
     /* 387841 */ // Label 7479: @387841
     /* 387841 */ GIM_Try, /*On fail goto*//*Label 7480*/ GIMT_Encode4(387885), // Rule ID 11353 //
     /* 387846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 387852 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 387859 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 387863 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$Zs, hsub:{ *:[i32] })
     /* 387863 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387866 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387868 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 387874 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 387879 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387884 */   // GIR_Coverage, 11353,
     /* 387884 */   GIR_EraseRootFromParent_Done,
     /* 387885 */ // Label 7480: @387885
     /* 387885 */ GIM_Try, /*On fail goto*//*Label 7481*/ GIMT_Encode4(387929), // Rule ID 11354 //
     /* 387890 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 387896 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 387903 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 387907 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv2f16] }:$Zs, hsub:{ *:[i32] })
     /* 387907 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387910 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387912 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 387918 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 387923 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387928 */   // GIR_Coverage, 11354,
     /* 387928 */   GIR_EraseRootFromParent_Done,
     /* 387929 */ // Label 7481: @387929
     /* 387929 */ GIM_Try, /*On fail goto*//*Label 7482*/ GIMT_Encode4(387974), // Rule ID 5843 //
     /* 387934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 387937 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 387944 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387948 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 387952 */   // (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] })
     /* 387952 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387955 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387957 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 387963 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 387968 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387973 */   // GIR_Coverage, 5843,
     /* 387973 */   GIR_EraseRootFromParent_Done,
     /* 387974 */ // Label 7482: @387974
     /* 387974 */ GIM_Try, /*On fail goto*//*Label 7483*/ GIMT_Encode4(388019), // Rule ID 5846 //
     /* 387979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 387982 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 387989 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387993 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387997 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388001 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 388005 */   // MIs[1] Operand 1
     /* 388005 */   // No operand predicates
     /* 388005 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388007 */   // (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPi16:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 388007 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi16),
     /* 388010 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388012 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388014 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 388017 */   GIR_RootConstrainSelectedInstOperands,
     /* 388018 */   // GIR_Coverage, 5846,
     /* 388018 */   GIR_EraseRootFromParent_Done,
     /* 388019 */ // Label 7483: @388019
     /* 388019 */ GIM_Try, /*On fail goto*//*Label 7484*/ GIMT_Encode4(388095), // Rule ID 11327 //
     /* 388024 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 388030 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 388037 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388041 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388045 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 388049 */   // MIs[1] Operand 1
     /* 388049 */   // No operand predicates
     /* 388049 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388051 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_H:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index), hsub:{ *:[i32] })
     /* 388051 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 388054 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 388058 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388063 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 388067 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 388070 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388072 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388075 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388077 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 388084 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 388089 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388094 */   // GIR_Coverage, 11327,
     /* 388094 */   GIR_EraseRootFromParent_Done,
     /* 388095 */ // Label 7484: @388095
     /* 388095 */ GIM_Try, /*On fail goto*//*Label 7485*/ GIMT_Encode4(388171), // Rule ID 11328 //
     /* 388100 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 388106 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 388113 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388117 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388121 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 388125 */   // MIs[1] Operand 1
     /* 388125 */   // No operand predicates
     /* 388125 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388127 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), hsub:{ *:[i32] })
     /* 388127 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 388130 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 388134 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388139 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 388143 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 388146 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388148 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388151 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388153 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 388160 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 388165 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388170 */   // GIR_Coverage, 11328,
     /* 388170 */   GIR_EraseRootFromParent_Done,
     /* 388171 */ // Label 7485: @388171
     /* 388171 */ GIM_Try, /*On fail goto*//*Label 7486*/ GIMT_Encode4(388247), // Rule ID 11329 //
     /* 388176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 388182 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 388189 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388193 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388197 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 388201 */   // MIs[1] Operand 1
     /* 388201 */   // No operand predicates
     /* 388201 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388203 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), hsub:{ *:[i32] })
     /* 388203 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 388206 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 388210 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388215 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 388219 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 388222 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388224 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388227 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388229 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 388236 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 388241 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388246 */   // GIR_Coverage, 11329,
     /* 388246 */   GIR_EraseRootFromParent_Done,
     /* 388247 */ // Label 7486: @388247
     /* 388247 */ GIM_Try, /*On fail goto*//*Label 7487*/ GIMT_Encode4(388308), // Rule ID 11317 //
     /* 388252 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 388258 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 388265 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 388269 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_H:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv8f16] }:$vec)
     /* 388269 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 388272 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 388276 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388281 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 388287 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 388291 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 388294 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388296 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 388299 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 388301 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388304 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 388306 */   GIR_RootConstrainSelectedInstOperands,
     /* 388307 */   // GIR_Coverage, 11317,
     /* 388307 */   GIR_EraseRootFromParent_Done,
     /* 388308 */ // Label 7487: @388308
     /* 388308 */ GIM_Try, /*On fail goto*//*Label 7488*/ GIMT_Encode4(388369), // Rule ID 11318 //
     /* 388313 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 388319 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 388326 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 388330 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4f16] }:$vec)
     /* 388330 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 388333 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 388337 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388342 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 388348 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 388352 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 388355 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388357 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 388360 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 388362 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388365 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 388367 */   GIR_RootConstrainSelectedInstOperands,
     /* 388368 */   // GIR_Coverage, 11318,
     /* 388368 */   GIR_EraseRootFromParent_Done,
     /* 388369 */ // Label 7488: @388369
     /* 388369 */ GIM_Try, /*On fail goto*//*Label 7489*/ GIMT_Encode4(388430), // Rule ID 11319 //
     /* 388374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 388380 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 388387 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 388391 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f16] }:$vec)
     /* 388391 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 388394 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 388398 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388403 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 388409 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 388413 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 388416 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388418 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 388421 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 388423 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388426 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 388428 */   GIR_RootConstrainSelectedInstOperands,
     /* 388429 */   // GIR_Coverage, 11319,
     /* 388429 */   GIR_EraseRootFromParent_Done,
     /* 388430 */ // Label 7489: @388430
     /* 388430 */ GIM_Reject,
     /* 388431 */ // Label 7476: @388431
     /* 388431 */ GIM_Try, /*On fail goto*//*Label 7490*/ GIMT_Encode4(388476), // Rule ID 7030 //
     /* 388436 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 388439 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388446 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388450 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 388454 */   // (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$V, ssub:{ *:[i32] })
     /* 388454 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388457 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388459 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // V
     /* 388465 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388470 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388475 */   // GIR_Coverage, 7030,
     /* 388475 */   GIR_EraseRootFromParent_Done,
     /* 388476 */ // Label 7490: @388476
     /* 388476 */ GIM_Try, /*On fail goto*//*Label 7491*/ GIMT_Encode4(388521), // Rule ID 7031 //
     /* 388481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 388484 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388491 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388495 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 388499 */   // (extractelt:{ *:[i32] } V64:{ *:[v2i32] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } V64:{ *:[v2i32] }:$V, ssub:{ *:[i32] })
     /* 388499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388502 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388504 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // V
     /* 388510 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388515 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388520 */   // GIR_Coverage, 7031,
     /* 388520 */   GIR_EraseRootFromParent_Done,
     /* 388521 */ // Label 7491: @388521
     /* 388521 */ GIM_Try, /*On fail goto*//*Label 7492*/ GIMT_Encode4(388565), // Rule ID 11348 //
     /* 388526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 388532 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388539 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 388543 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv16i8] }:$Zs, ssub:{ *:[i32] })
     /* 388543 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388546 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388548 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 388554 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388559 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388564 */   // GIR_Coverage, 11348,
     /* 388564 */   GIR_EraseRootFromParent_Done,
     /* 388565 */ // Label 7492: @388565
     /* 388565 */ GIM_Try, /*On fail goto*//*Label 7493*/ GIMT_Encode4(388609), // Rule ID 11349 //
     /* 388570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 388576 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388583 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 388587 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv8i16] }:$Zs, ssub:{ *:[i32] })
     /* 388587 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388590 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388592 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 388598 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388603 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388608 */   // GIR_Coverage, 11349,
     /* 388608 */   GIR_EraseRootFromParent_Done,
     /* 388609 */ // Label 7493: @388609
     /* 388609 */ GIM_Try, /*On fail goto*//*Label 7494*/ GIMT_Encode4(388653), // Rule ID 11350 //
     /* 388614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 388620 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388627 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 388631 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv4i32] }:$Zs, ssub:{ *:[i32] })
     /* 388631 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388634 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388636 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 388642 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388647 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388652 */   // GIR_Coverage, 11350,
     /* 388652 */   GIR_EraseRootFromParent_Done,
     /* 388653 */ // Label 7494: @388653
     /* 388653 */ GIM_Try, /*On fail goto*//*Label 7495*/ GIMT_Encode4(388697), // Rule ID 11355 //
     /* 388658 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 388664 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388671 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 388675 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$Zs, ssub:{ *:[i32] })
     /* 388675 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388678 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388680 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 388686 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388691 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388696 */   // GIR_Coverage, 11355,
     /* 388696 */   GIR_EraseRootFromParent_Done,
     /* 388697 */ // Label 7495: @388697
     /* 388697 */ GIM_Try, /*On fail goto*//*Label 7496*/ GIMT_Encode4(388741), // Rule ID 11356 //
     /* 388702 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 388708 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388715 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 388719 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } ZPR:{ *:[nxv2f32] }:$Zs, ssub:{ *:[i32] })
     /* 388719 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388722 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388724 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 388730 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388735 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388740 */   // GIR_Coverage, 11356,
     /* 388740 */   GIR_EraseRootFromParent_Done,
     /* 388741 */ // Label 7496: @388741
     /* 388741 */ GIM_Try, /*On fail goto*//*Label 7497*/ GIMT_Encode4(388786), // Rule ID 5842 //
     /* 388746 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 388749 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388756 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388760 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 388764 */   // (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] })
     /* 388764 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388767 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388769 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 388775 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388780 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388785 */   // GIR_Coverage, 5842,
     /* 388785 */   GIR_EraseRootFromParent_Done,
     /* 388786 */ // Label 7497: @388786
     /* 388786 */ GIM_Try, /*On fail goto*//*Label 7498*/ GIMT_Encode4(388859), // Rule ID 11333 //
     /* 388791 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 388797 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 388804 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388808 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388812 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 388816 */   // MIs[1] Operand 1
     /* 388816 */   // No operand predicates
     /* 388816 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388818 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)  =>  (UMOVvi8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 388818 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 388821 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388825 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388830 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 388836 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388841 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388846 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /* 388849 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388851 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388854 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 388857 */   GIR_RootConstrainSelectedInstOperands,
     /* 388858 */   // GIR_Coverage, 11333,
     /* 388858 */   GIR_EraseRootFromParent_Done,
     /* 388859 */ // Label 7498: @388859
     /* 388859 */ GIM_Try, /*On fail goto*//*Label 7499*/ GIMT_Encode4(388932), // Rule ID 11334 //
     /* 388864 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 388870 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 388877 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388881 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388885 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 388889 */   // MIs[1] Operand 1
     /* 388889 */   // No operand predicates
     /* 388889 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388891 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)  =>  (UMOVvi16:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 388891 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 388894 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388898 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388903 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 388909 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388914 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388919 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /* 388922 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388924 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388927 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 388930 */   GIR_RootConstrainSelectedInstOperands,
     /* 388931 */   // GIR_Coverage, 11334,
     /* 388931 */   GIR_EraseRootFromParent_Done,
     /* 388932 */ // Label 7499: @388932
     /* 388932 */ GIM_Try, /*On fail goto*//*Label 7500*/ GIMT_Encode4(389005), // Rule ID 11335 //
     /* 388937 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 388943 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 388950 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388954 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388958 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 388962 */   // MIs[1] Operand 1
     /* 388962 */   // No operand predicates
     /* 388962 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388964 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)  =>  (UMOVvi32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)
     /* 388964 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 388967 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388971 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388976 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 388982 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388987 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388992 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32),
     /* 388995 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388997 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389000 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 389003 */   GIR_RootConstrainSelectedInstOperands,
     /* 389004 */   // GIR_Coverage, 11335,
     /* 389004 */   GIR_EraseRootFromParent_Done,
     /* 389005 */ // Label 7500: @389005
     /* 389005 */ GIM_Try, /*On fail goto*//*Label 7501*/ GIMT_Encode4(389053), // Rule ID 1926 //
     /* 389010 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 389013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 389016 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 389023 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389027 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389031 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389035 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 389039 */   // MIs[1] Operand 1
     /* 389039 */   // No operand predicates
     /* 389039 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389041 */   // (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi8_idx0:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 389041 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8_idx0),
     /* 389044 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389046 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389048 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 389051 */   GIR_RootConstrainSelectedInstOperands,
     /* 389052 */   // GIR_Coverage, 1926,
     /* 389052 */   GIR_EraseRootFromParent_Done,
     /* 389053 */ // Label 7501: @389053
     /* 389053 */ GIM_Try, /*On fail goto*//*Label 7502*/ GIMT_Encode4(389101), // Rule ID 1927 //
     /* 389058 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 389061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 389064 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 389071 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389075 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389079 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389083 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 389087 */   // MIs[1] Operand 1
     /* 389087 */   // No operand predicates
     /* 389087 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389089 */   // (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi16_idx0:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 389089 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16_idx0),
     /* 389092 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389094 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389096 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 389099 */   GIR_RootConstrainSelectedInstOperands,
     /* 389100 */   // GIR_Coverage, 1927,
     /* 389100 */   GIR_EraseRootFromParent_Done,
     /* 389101 */ // Label 7502: @389101
     /* 389101 */ GIM_Try, /*On fail goto*//*Label 7503*/ GIMT_Encode4(389149), // Rule ID 1928 //
     /* 389106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 389109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389112 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 389119 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389123 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389127 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389131 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 389135 */   // MIs[1] Operand 1
     /* 389135 */   // No operand predicates
     /* 389135 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389137 */   // (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi32_idx0:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 389137 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32_idx0),
     /* 389140 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389142 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389144 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 389147 */   GIR_RootConstrainSelectedInstOperands,
     /* 389148 */   // GIR_Coverage, 1928,
     /* 389148 */   GIR_EraseRootFromParent_Done,
     /* 389149 */ // Label 7503: @389149
     /* 389149 */ GIM_Try, /*On fail goto*//*Label 7504*/ GIMT_Encode4(389197), // Rule ID 1930 //
     /* 389154 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 389160 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 389167 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389171 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389175 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389179 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 389183 */   // MIs[1] Operand 1
     /* 389183 */   // No operand predicates
     /* 389183 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389185 */   // (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 389185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /* 389188 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389190 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389192 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 389195 */   GIR_RootConstrainSelectedInstOperands,
     /* 389196 */   // GIR_Coverage, 1930,
     /* 389196 */   GIR_EraseRootFromParent_Done,
     /* 389197 */ // Label 7504: @389197
     /* 389197 */ GIM_Try, /*On fail goto*//*Label 7505*/ GIMT_Encode4(389245), // Rule ID 1931 //
     /* 389202 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 389208 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 389215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389219 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389223 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389227 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 389231 */   // MIs[1] Operand 1
     /* 389231 */   // No operand predicates
     /* 389231 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389233 */   // (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 389233 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /* 389236 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389238 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389240 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 389243 */   GIR_RootConstrainSelectedInstOperands,
     /* 389244 */   // GIR_Coverage, 1931,
     /* 389244 */   GIR_EraseRootFromParent_Done,
     /* 389245 */ // Label 7505: @389245
     /* 389245 */ GIM_Try, /*On fail goto*//*Label 7506*/ GIMT_Encode4(389293), // Rule ID 1932 //
     /* 389250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389256 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 389263 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389267 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389271 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389275 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 389279 */   // MIs[1] Operand 1
     /* 389279 */   // No operand predicates
     /* 389279 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389281 */   // (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (UMOVvi32:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 389281 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32),
     /* 389284 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389286 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389288 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 389291 */   GIR_RootConstrainSelectedInstOperands,
     /* 389292 */   // GIR_Coverage, 1932,
     /* 389292 */   GIR_EraseRootFromParent_Done,
     /* 389293 */ // Label 7506: @389293
     /* 389293 */ GIM_Try, /*On fail goto*//*Label 7507*/ GIMT_Encode4(389338), // Rule ID 5845 //
     /* 389298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389301 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389308 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389312 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389316 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389320 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 389324 */   // MIs[1] Operand 1
     /* 389324 */   // No operand predicates
     /* 389324 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389326 */   // (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPi32:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 389326 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi32),
     /* 389329 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389331 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389333 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 389336 */   GIR_RootConstrainSelectedInstOperands,
     /* 389337 */   // GIR_Coverage, 5845,
     /* 389337 */   GIR_EraseRootFromParent_Done,
     /* 389338 */ // Label 7507: @389338
     /* 389338 */ GIM_Try, /*On fail goto*//*Label 7508*/ GIMT_Encode4(389414), // Rule ID 11323 //
     /* 389343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 389349 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389356 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389360 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389364 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 389368 */   // MIs[1] Operand 1
     /* 389368 */   // No operand predicates
     /* 389368 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389370 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index), ssub:{ *:[i32] })
     /* 389370 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 389373 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 389377 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389382 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 389386 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 389389 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 389391 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 389394 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389396 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 389403 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389408 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389413 */   // GIR_Coverage, 11323,
     /* 389413 */   GIR_EraseRootFromParent_Done,
     /* 389414 */ // Label 7508: @389414
     /* 389414 */ GIM_Try, /*On fail goto*//*Label 7509*/ GIMT_Encode4(389490), // Rule ID 11324 //
     /* 389419 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 389425 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389432 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389436 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389440 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 389444 */   // MIs[1] Operand 1
     /* 389444 */   // No operand predicates
     /* 389444 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389446 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_H:{ *:[nxv16i8] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index), ssub:{ *:[i32] })
     /* 389446 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 389449 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 389453 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389458 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 389462 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 389465 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 389467 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 389470 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389472 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 389479 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389484 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389489 */   // GIR_Coverage, 11324,
     /* 389489 */   GIR_EraseRootFromParent_Done,
     /* 389490 */ // Label 7509: @389490
     /* 389490 */ GIM_Try, /*On fail goto*//*Label 7510*/ GIMT_Encode4(389566), // Rule ID 11325 //
     /* 389495 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 389501 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389508 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389512 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389516 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 389520 */   // MIs[1] Operand 1
     /* 389520 */   // No operand predicates
     /* 389520 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389522 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), ssub:{ *:[i32] })
     /* 389522 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 389525 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 389529 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389534 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 389538 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 389541 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 389543 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 389546 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389548 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 389555 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389560 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389565 */   // GIR_Coverage, 11325,
     /* 389565 */   GIR_EraseRootFromParent_Done,
     /* 389566 */ // Label 7510: @389566
     /* 389566 */ GIM_Try, /*On fail goto*//*Label 7511*/ GIMT_Encode4(389642), // Rule ID 11330 //
     /* 389571 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 389577 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389584 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389588 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389592 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 389596 */   // MIs[1] Operand 1
     /* 389596 */   // No operand predicates
     /* 389596 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389598 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f32] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), ssub:{ *:[i32] })
     /* 389598 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 389601 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 389605 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389610 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 389614 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 389617 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 389619 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 389622 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389624 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 389631 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389636 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389641 */   // GIR_Coverage, 11330,
     /* 389641 */   GIR_EraseRootFromParent_Done,
     /* 389642 */ // Label 7511: @389642
     /* 389642 */ GIM_Try, /*On fail goto*//*Label 7512*/ GIMT_Encode4(389718), // Rule ID 11331 //
     /* 389647 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 389653 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389660 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389664 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389668 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 389672 */   // MIs[1] Operand 1
     /* 389672 */   // No operand predicates
     /* 389672 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389674 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f32] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), ssub:{ *:[i32] })
     /* 389674 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 389677 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 389681 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389686 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 389690 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 389693 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 389695 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 389698 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389700 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 389707 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389712 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389717 */   // GIR_Coverage, 11331,
     /* 389717 */   GIR_EraseRootFromParent_Done,
     /* 389718 */ // Label 7512: @389718
     /* 389718 */ GIM_Try, /*On fail goto*//*Label 7513*/ GIMT_Encode4(389779), // Rule ID 11313 //
     /* 389723 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 389729 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 389736 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 389740 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_B:{ *:[i32] } (WHILELS_PXX_B:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv16i8] }:$vec)
     /* 389740 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 389743 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_B),
     /* 389747 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389752 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 389758 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 389762 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 389765 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 389767 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_B),
     /* 389770 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389772 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389775 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 389777 */   GIR_RootConstrainSelectedInstOperands,
     /* 389778 */   // GIR_Coverage, 11313,
     /* 389778 */   GIR_EraseRootFromParent_Done,
     /* 389779 */ // Label 7513: @389779
     /* 389779 */ GIM_Try, /*On fail goto*//*Label 7514*/ GIMT_Encode4(389840), // Rule ID 11314 //
     /* 389784 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 389790 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 389797 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 389801 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_H:{ *:[i32] } (WHILELS_PXX_H:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv8i16] }:$vec)
     /* 389801 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 389804 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 389808 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389813 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 389819 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 389823 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 389826 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 389828 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_H),
     /* 389831 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389833 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389836 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 389838 */   GIR_RootConstrainSelectedInstOperands,
     /* 389839 */   // GIR_Coverage, 11314,
     /* 389839 */   GIR_EraseRootFromParent_Done,
     /* 389840 */ // Label 7514: @389840
     /* 389840 */ GIM_Try, /*On fail goto*//*Label 7515*/ GIMT_Encode4(389901), // Rule ID 11315 //
     /* 389845 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 389851 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 389858 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 389862 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_S:{ *:[i32] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4i32] }:$vec)
     /* 389862 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 389865 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 389869 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389874 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 389880 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 389884 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 389887 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 389889 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_S),
     /* 389892 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389894 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389897 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 389899 */   GIR_RootConstrainSelectedInstOperands,
     /* 389900 */   // GIR_Coverage, 11315,
     /* 389900 */   GIR_EraseRootFromParent_Done,
     /* 389901 */ // Label 7515: @389901
     /* 389901 */ GIM_Try, /*On fail goto*//*Label 7516*/ GIMT_Encode4(389962), // Rule ID 11320 //
     /* 389906 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 389912 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389919 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 389923 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_S:{ *:[f32] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4f32] }:$vec)
     /* 389923 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 389926 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 389930 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389935 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 389941 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 389945 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 389948 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 389950 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_S),
     /* 389953 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 389955 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389958 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 389960 */   GIR_RootConstrainSelectedInstOperands,
     /* 389961 */   // GIR_Coverage, 11320,
     /* 389961 */   GIR_EraseRootFromParent_Done,
     /* 389962 */ // Label 7516: @389962
     /* 389962 */ GIM_Try, /*On fail goto*//*Label 7517*/ GIMT_Encode4(390023), // Rule ID 11321 //
     /* 389967 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 389973 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389980 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 389984 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_S:{ *:[f32] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f32] }:$vec)
     /* 389984 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 389987 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 389991 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389996 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 390002 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 390006 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 390009 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 390011 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_S),
     /* 390014 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 390016 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390019 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 390021 */   GIR_RootConstrainSelectedInstOperands,
     /* 390022 */   // GIR_Coverage, 11321,
     /* 390022 */   GIR_EraseRootFromParent_Done,
     /* 390023 */ // Label 7517: @390023
     /* 390023 */ GIM_Reject,
     /* 390024 */ // Label 7477: @390024
     /* 390024 */ GIM_Try, /*On fail goto*//*Label 7518*/ GIMT_Encode4(390069), // Rule ID 7029 //
     /* 390029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 390032 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 390035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390039 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390043 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 390047 */   // (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$V, dsub:{ *:[i32] })
     /* 390047 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 390050 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390052 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // V
     /* 390058 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390063 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390068 */   // GIR_Coverage, 7029,
     /* 390068 */   GIR_EraseRootFromParent_Done,
     /* 390069 */ // Label 7518: @390069
     /* 390069 */ GIM_Try, /*On fail goto*//*Label 7519*/ GIMT_Encode4(390113), // Rule ID 11351 //
     /* 390074 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390077 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 390080 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 390083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390087 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 390091 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i64] } ZPR:{ *:[nxv2i64] }:$Zs, dsub:{ *:[i32] })
     /* 390091 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 390094 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390096 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Zs
     /* 390102 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390107 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390112 */   // GIR_Coverage, 11351,
     /* 390112 */   GIR_EraseRootFromParent_Done,
     /* 390113 */ // Label 7519: @390113
     /* 390113 */ GIM_Try, /*On fail goto*//*Label 7520*/ GIMT_Encode4(390157), // Rule ID 11357 //
     /* 390118 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 390124 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 390127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390131 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 390135 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f64] } ZPR:{ *:[nxv2f64] }:$Zs, dsub:{ *:[i32] })
     /* 390135 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 390138 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390140 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Zs
     /* 390146 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390151 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390156 */   // GIR_Coverage, 11357,
     /* 390156 */   GIR_EraseRootFromParent_Done,
     /* 390157 */ // Label 7520: @390157
     /* 390157 */ GIM_Try, /*On fail goto*//*Label 7521*/ GIMT_Encode4(390202), // Rule ID 5841 //
     /* 390162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 390165 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 390168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390172 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390176 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 390180 */   // (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] })
     /* 390180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 390183 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390185 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 390191 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390196 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390201 */   // GIR_Coverage, 5841,
     /* 390201 */   GIR_EraseRootFromParent_Done,
     /* 390202 */ // Label 7521: @390202
     /* 390202 */ GIM_Try, /*On fail goto*//*Label 7522*/ GIMT_Encode4(390275), // Rule ID 11336 //
     /* 390207 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 390213 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 390216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 390220 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 390224 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390228 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 390232 */   // MIs[1] Operand 1
     /* 390232 */   // No operand predicates
     /* 390232 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390234 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$index)  =>  (UMOVvi64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v2i64] } ZPR:{ *:[nxv2i64] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$index)
     /* 390234 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 390237 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 390241 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390246 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 390252 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390257 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390262 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64),
     /* 390265 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 390267 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390270 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 390273 */   GIR_RootConstrainSelectedInstOperands,
     /* 390274 */   // GIR_Coverage, 11336,
     /* 390274 */   GIR_EraseRootFromParent_Done,
     /* 390275 */ // Label 7522: @390275
     /* 390275 */ GIM_Try, /*On fail goto*//*Label 7523*/ GIMT_Encode4(390323), // Rule ID 1929 //
     /* 390280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 390283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 390286 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 390289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 390293 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390297 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 390301 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390305 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 390309 */   // MIs[1] Operand 1
     /* 390309 */   // No operand predicates
     /* 390309 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390311 */   // (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi64_idx0:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 390311 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64_idx0),
     /* 390314 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 390316 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390318 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 390321 */   GIR_RootConstrainSelectedInstOperands,
     /* 390322 */   // GIR_Coverage, 1929,
     /* 390322 */   GIR_EraseRootFromParent_Done,
     /* 390323 */ // Label 7523: @390323
     /* 390323 */ GIM_Try, /*On fail goto*//*Label 7524*/ GIMT_Encode4(390371), // Rule ID 1933 //
     /* 390328 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 390334 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 390337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 390341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390345 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 390349 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390353 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 390357 */   // MIs[1] Operand 1
     /* 390357 */   // No operand predicates
     /* 390357 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390359 */   // (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (UMOVvi64:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 390359 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64),
     /* 390362 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 390364 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390366 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 390369 */   GIR_RootConstrainSelectedInstOperands,
     /* 390370 */   // GIR_Coverage, 1933,
     /* 390370 */   GIR_EraseRootFromParent_Done,
     /* 390371 */ // Label 7524: @390371
     /* 390371 */ GIM_Try, /*On fail goto*//*Label 7525*/ GIMT_Encode4(390416), // Rule ID 5844 //
     /* 390376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 390379 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 390382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390386 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390390 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 390394 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390398 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 390402 */   // MIs[1] Operand 1
     /* 390402 */   // No operand predicates
     /* 390402 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390404 */   // (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (DUPi64:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 390404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi64),
     /* 390407 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390409 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390411 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 390414 */   GIR_RootConstrainSelectedInstOperands,
     /* 390415 */   // GIR_Coverage, 5844,
     /* 390415 */   GIR_EraseRootFromParent_Done,
     /* 390416 */ // Label 7525: @390416
     /* 390416 */ GIM_Try, /*On fail goto*//*Label 7526*/ GIMT_Encode4(390492), // Rule ID 11326 //
     /* 390421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 390427 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 390430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390434 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 390438 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390442 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 390446 */   // MIs[1] Operand 1
     /* 390446 */   // No operand predicates
     /* 390446 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390448 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i64] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), dsub:{ *:[i32] })
     /* 390448 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 390451 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 390455 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390460 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 390464 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 390467 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 390469 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 390472 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390474 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 390481 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390486 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390491 */   // GIR_Coverage, 11326,
     /* 390491 */   GIR_EraseRootFromParent_Done,
     /* 390492 */ // Label 7526: @390492
     /* 390492 */ GIM_Try, /*On fail goto*//*Label 7527*/ GIMT_Encode4(390568), // Rule ID 11332 //
     /* 390497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 390503 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 390506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390510 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 390514 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390518 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 390522 */   // MIs[1] Operand 1
     /* 390522 */   // No operand predicates
     /* 390522 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390524 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f64] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), dsub:{ *:[i32] })
     /* 390524 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 390527 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 390531 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390536 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 390540 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 390543 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 390545 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 390548 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390550 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 390557 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390562 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390567 */   // GIR_Coverage, 11332,
     /* 390567 */   GIR_EraseRootFromParent_Done,
     /* 390568 */ // Label 7527: @390568
     /* 390568 */ GIM_Try, /*On fail goto*//*Label 7528*/ GIMT_Encode4(390629), // Rule ID 11316 //
     /* 390573 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 390579 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 390582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 390586 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 390590 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_D:{ *:[i64] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2i64] }:$vec)
     /* 390590 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 390593 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 390597 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390602 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 390608 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 390612 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 390615 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 390617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_D),
     /* 390620 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 390622 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390625 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 390627 */   GIR_RootConstrainSelectedInstOperands,
     /* 390628 */   // GIR_Coverage, 11316,
     /* 390628 */   GIR_EraseRootFromParent_Done,
     /* 390629 */ // Label 7528: @390629
     /* 390629 */ GIM_Try, /*On fail goto*//*Label 7529*/ GIMT_Encode4(390690), // Rule ID 11322 //
     /* 390634 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 390640 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 390643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390647 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 390651 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_D:{ *:[f64] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f64] }:$vec)
     /* 390651 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 390654 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 390658 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390663 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 390669 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 390673 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 390676 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 390678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_D),
     /* 390681 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 390683 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390686 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 390688 */   GIR_RootConstrainSelectedInstOperands,
     /* 390689 */   // GIR_Coverage, 11322,
     /* 390689 */   GIR_EraseRootFromParent_Done,
     /* 390690 */ // Label 7529: @390690
     /* 390690 */ GIM_Reject,
     /* 390691 */ // Label 7478: @390691
     /* 390691 */ GIM_Reject,
     /* 390692 */ // Label 93: @390692
     /* 390692 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(14), GIMT_Encode2(24), /*)*//*default:*//*Label 7537*/ GIMT_Encode4(393011),
     /* 390703 */ /*GILLT_nxv2s16*//*Label 7530*/ GIMT_Encode4(390743),
     /* 390707 */ /*GILLT_nxv2s32*//*Label 7531*/ GIMT_Encode4(391102),
     /* 390711 */ /*GILLT_nxv2s64*//*Label 7532*/ GIMT_Encode4(391404), GIMT_Encode4(0),
     /* 390719 */ /*GILLT_nxv4s16*//*Label 7533*/ GIMT_Encode4(391779),
     /* 390723 */ /*GILLT_nxv4s32*//*Label 7534*/ GIMT_Encode4(392081), GIMT_Encode4(0),
     /* 390731 */ /*GILLT_nxv8s16*//*Label 7535*/ GIMT_Encode4(392456), GIMT_Encode4(0),
     /* 390739 */ /*GILLT_nxv16s8*//*Label 7536*/ GIMT_Encode4(392867),
     /* 390743 */ // Label 7530: @390743
     /* 390743 */ GIM_Try, /*On fail goto*//*Label 7538*/ GIMT_Encode4(391101),
     /* 390748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 390751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390755 */   GIM_Try, /*On fail goto*//*Label 7539*/ GIMT_Encode4(390819), // Rule ID 6075 //
     /* 390760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 390771 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 390775 */     // MIs[1] Operand 1
     /* 390775 */     // No operand predicates
     /* 390775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390777 */     // (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv2f16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 390777 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390780 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 390784 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390789 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390792 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 390794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 390808 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390813 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390818 */     // GIR_Coverage, 6075,
     /* 390818 */     GIR_EraseRootFromParent_Done,
     /* 390819 */   // Label 7539: @390819
     /* 390819 */   GIM_Try, /*On fail goto*//*Label 7540*/ GIMT_Encode4(390876), // Rule ID 2671 //
     /* 390824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 390835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 390839 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 390843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 390852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390856 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 390860 */     // MIs[2] Operand 1
     /* 390860 */     // No operand predicates
     /* 390860 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390862 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 390862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 390865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 390871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 390874 */     GIR_RootConstrainSelectedInstOperands,
     /* 390875 */     // GIR_Coverage, 2671,
     /* 390875 */     GIR_EraseRootFromParent_Done,
     /* 390876 */   // Label 7540: @390876
     /* 390876 */   GIM_Try, /*On fail goto*//*Label 7541*/ GIMT_Encode4(390933), // Rule ID 2673 //
     /* 390881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 390892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 390896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 390900 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 390909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390913 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 390917 */     // MIs[2] Operand 1
     /* 390917 */     // No operand predicates
     /* 390917 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390919 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f16] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 390919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 390922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 390928 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 390931 */     GIR_RootConstrainSelectedInstOperands,
     /* 390932 */     // GIR_Coverage, 2673,
     /* 390932 */     GIR_EraseRootFromParent_Done,
     /* 390933 */   // Label 7541: @390933
     /* 390933 */   GIM_Try, /*On fail goto*//*Label 7542*/ GIMT_Encode4(390990), // Rule ID 8456 //
     /* 390938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 390949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 390953 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 390957 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 390966 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390970 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 390974 */     // MIs[2] Operand 1
     /* 390974 */     // No operand predicates
     /* 390974 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390976 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv2f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 390976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 390979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 390985 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 390988 */     GIR_RootConstrainSelectedInstOperands,
     /* 390989 */     // GIR_Coverage, 8456,
     /* 390989 */     GIR_EraseRootFromParent_Done,
     /* 390990 */   // Label 7542: @390990
     /* 390990 */   GIM_Try, /*On fail goto*//*Label 7543*/ GIMT_Encode4(391024), // Rule ID 8499 //
     /* 390995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 391006 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 391010 */     // MIs[1] Operand 1
     /* 391010 */     // No operand predicates
     /* 391010 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391012 */     // (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv2f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 391012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 391015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 391017 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 391022 */     GIR_RootConstrainSelectedInstOperands,
     /* 391023 */     // GIR_Coverage, 8499,
     /* 391023 */     GIR_EraseRootFromParent_Done,
     /* 391024 */   // Label 7543: @391024
     /* 391024 */   GIM_Try, /*On fail goto*//*Label 7544*/ GIMT_Encode4(391100), // Rule ID 8477 //
     /* 391029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 391036 */     // (splat_vector:{ *:[nxv2f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv2f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 391036 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 391039 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 391043 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 391050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 391053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 391057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391062 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 391065 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 391069 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 391072 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391077 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391082 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 391087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 391090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 391092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391098 */     GIR_RootConstrainSelectedInstOperands,
     /* 391099 */     // GIR_Coverage, 8477,
     /* 391099 */     GIR_EraseRootFromParent_Done,
     /* 391100 */   // Label 7544: @391100
     /* 391100 */   GIM_Reject,
     /* 391101 */ // Label 7538: @391101
     /* 391101 */ GIM_Reject,
     /* 391102 */ // Label 7531: @391102
     /* 391102 */ GIM_Try, /*On fail goto*//*Label 7545*/ GIMT_Encode4(391403),
     /* 391107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 391110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391114 */   GIM_Try, /*On fail goto*//*Label 7546*/ GIMT_Encode4(391178), // Rule ID 6073 //
     /* 391119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 391130 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 391134 */     // MIs[1] Operand 1
     /* 391134 */     // No operand predicates
     /* 391134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391136 */     // (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv2f32] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 391136 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 391139 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 391143 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391148 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 391151 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 391153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 391167 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391172 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391177 */     // GIR_Coverage, 6073,
     /* 391177 */     GIR_EraseRootFromParent_Done,
     /* 391178 */   // Label 7546: @391178
     /* 391178 */   GIM_Try, /*On fail goto*//*Label 7547*/ GIMT_Encode4(391235), // Rule ID 8465 //
     /* 391183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 391194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 391198 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 391202 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391207 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 391211 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391215 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 391219 */     // MIs[2] Operand 1
     /* 391219 */     // No operand predicates
     /* 391219 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391221 */     // (splat_vector:{ *:[nxv2f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 391221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 391224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 391226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 391230 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 391233 */     GIR_RootConstrainSelectedInstOperands,
     /* 391234 */     // GIR_Coverage, 8465,
     /* 391234 */     GIR_EraseRootFromParent_Done,
     /* 391235 */   // Label 7547: @391235
     /* 391235 */   GIM_Try, /*On fail goto*//*Label 7548*/ GIMT_Encode4(391292), // Rule ID 8474 //
     /* 391240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 391251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 391255 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 391259 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 391268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391272 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 391276 */     // MIs[2] Operand 1
     /* 391276 */     // No operand predicates
     /* 391276 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391278 */     // (splat_vector:{ *:[nxv2f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f32] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 391278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 391281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 391283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 391287 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 391290 */     GIR_RootConstrainSelectedInstOperands,
     /* 391291 */     // GIR_Coverage, 8474,
     /* 391291 */     GIR_EraseRootFromParent_Done,
     /* 391292 */   // Label 7548: @391292
     /* 391292 */   GIM_Try, /*On fail goto*//*Label 7549*/ GIMT_Encode4(391326), // Rule ID 8501 //
     /* 391297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 391308 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 391312 */     // MIs[1] Operand 1
     /* 391312 */     // No operand predicates
     /* 391312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391314 */     // (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8)  =>  (FDUP_ZI_S:{ *:[nxv2f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 391314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_S),
     /* 391317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 391319 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 391324 */     GIR_RootConstrainSelectedInstOperands,
     /* 391325 */     // GIR_Coverage, 8501,
     /* 391325 */     GIR_EraseRootFromParent_Done,
     /* 391326 */   // Label 7549: @391326
     /* 391326 */   GIM_Try, /*On fail goto*//*Label 7550*/ GIMT_Encode4(391402), // Rule ID 8479 //
     /* 391331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391334 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 391338 */     // (splat_vector:{ *:[nxv2f32] } FPR32:{ *:[f32] }:$src)  =>  (DUP_ZZI_S:{ *:[nxv2f32] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR32:{ *:[f32] }:$src, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 391338 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 391341 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 391345 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391350 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 391352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 391355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 391359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391364 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 391367 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 391371 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 391374 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391379 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391384 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 391389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 391392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 391394 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391400 */     GIR_RootConstrainSelectedInstOperands,
     /* 391401 */     // GIR_Coverage, 8479,
     /* 391401 */     GIR_EraseRootFromParent_Done,
     /* 391402 */   // Label 7550: @391402
     /* 391402 */   GIM_Reject,
     /* 391403 */ // Label 7545: @391403
     /* 391403 */ GIM_Reject,
     /* 391404 */ // Label 7532: @391404
     /* 391404 */ GIM_Try, /*On fail goto*//*Label 7551*/ GIMT_Encode4(391778),
     /* 391409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 391412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391416 */   GIM_Try, /*On fail goto*//*Label 7552*/ GIMT_Encode4(391470), // Rule ID 6068 //
     /* 391421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391424 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 391428 */     // (splat_vector:{ *:[nxv2i64] } 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 391428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 391431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 391435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391440 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 391443 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 391445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391453 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 391459 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391464 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391469 */     // GIR_Coverage, 6068,
     /* 391469 */     GIR_EraseRootFromParent_Done,
     /* 391470 */   // Label 7552: @391470
     /* 391470 */   GIM_Try, /*On fail goto*//*Label 7553*/ GIMT_Encode4(391534), // Rule ID 6072 //
     /* 391475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 391486 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 391490 */     // MIs[1] Operand 1
     /* 391490 */     // No operand predicates
     /* 391490 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391492 */     // (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 391492 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 391495 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 391499 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391504 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 391507 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 391509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391517 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 391523 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391528 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391533 */     // GIR_Coverage, 6072,
     /* 391533 */     GIR_EraseRootFromParent_Done,
     /* 391534 */   // Label 7553: @391534
     /* 391534 */   GIM_Try, /*On fail goto*//*Label 7554*/ GIMT_Encode4(391591), // Rule ID 2668 //
     /* 391539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 391550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 391554 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 391558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391563 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 391567 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391571 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 391575 */     // MIs[2] Operand 1
     /* 391575 */     // No operand predicates
     /* 391575 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391577 */     // (splat_vector:{ *:[nxv2i64] } (vector_extract:{ *:[i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 391577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 391580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 391582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 391586 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 391589 */     GIR_RootConstrainSelectedInstOperands,
     /* 391590 */     // GIR_Coverage, 2668,
     /* 391590 */     GIR_EraseRootFromParent_Done,
     /* 391591 */   // Label 7554: @391591
     /* 391591 */   GIM_Try, /*On fail goto*//*Label 7555*/ GIMT_Encode4(391648), // Rule ID 8471 //
     /* 391596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 391607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 391611 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 391615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 391624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391628 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 391632 */     // MIs[2] Operand 1
     /* 391632 */     // No operand predicates
     /* 391632 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391634 */     // (splat_vector:{ *:[nxv2f64] } (vector_extract:{ *:[f64] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f64] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 391634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 391637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 391639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 391643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 391646 */     GIR_RootConstrainSelectedInstOperands,
     /* 391647 */     // GIR_Coverage, 8471,
     /* 391647 */     GIR_EraseRootFromParent_Done,
     /* 391648 */   // Label 7555: @391648
     /* 391648 */   GIM_Try, /*On fail goto*//*Label 7556*/ GIMT_Encode4(391682), // Rule ID 8502 //
     /* 391653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 391664 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 391668 */     // MIs[1] Operand 1
     /* 391668 */     // No operand predicates
     /* 391668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391670 */     // (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm8)  =>  (FDUP_ZI_D:{ *:[nxv2f64] } (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>>:$imm8))
     /* 391670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_D),
     /* 391673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 391675 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm8
     /* 391680 */     GIR_RootConstrainSelectedInstOperands,
     /* 391681 */     // GIR_Coverage, 8502,
     /* 391681 */     GIR_EraseRootFromParent_Done,
     /* 391682 */   // Label 7556: @391682
     /* 391682 */   GIM_Try, /*On fail goto*//*Label 7557*/ GIMT_Encode4(391701), // Rule ID 2391 //
     /* 391687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 391694 */     // (splat_vector:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$Rn)  =>  (DUP_ZR_D:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 391694 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 391699 */     GIR_RootConstrainSelectedInstOperands,
     /* 391700 */     // GIR_Coverage, 2391,
     /* 391700 */     GIR_Done,
     /* 391701 */   // Label 7557: @391701
     /* 391701 */   GIM_Try, /*On fail goto*//*Label 7558*/ GIMT_Encode4(391777), // Rule ID 8480 //
     /* 391706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391713 */     // (splat_vector:{ *:[nxv2f64] } FPR64:{ *:[f64] }:$src)  =>  (DUP_ZZI_D:{ *:[nxv2f64] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR64:{ *:[f64] }:$src, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 391713 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 391716 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 391720 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391725 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 391727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 391730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 391734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391739 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 391742 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 391746 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 391749 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391754 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391759 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 391767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 391769 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391775 */     GIR_RootConstrainSelectedInstOperands,
     /* 391776 */     // GIR_Coverage, 8480,
     /* 391776 */     GIR_EraseRootFromParent_Done,
     /* 391777 */   // Label 7558: @391777
     /* 391777 */   GIM_Reject,
     /* 391778 */ // Label 7551: @391778
     /* 391778 */ GIM_Reject,
     /* 391779 */ // Label 7533: @391779
     /* 391779 */ GIM_Try, /*On fail goto*//*Label 7559*/ GIMT_Encode4(392080),
     /* 391784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 391787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391791 */   GIM_Try, /*On fail goto*//*Label 7560*/ GIMT_Encode4(391855), // Rule ID 6076 //
     /* 391796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 391807 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 391811 */     // MIs[1] Operand 1
     /* 391811 */     // No operand predicates
     /* 391811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391813 */     // (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv4f16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 391813 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 391816 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 391820 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391825 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 391828 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 391830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391838 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 391844 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391849 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391854 */     // GIR_Coverage, 6076,
     /* 391854 */     GIR_EraseRootFromParent_Done,
     /* 391855 */   // Label 7560: @391855
     /* 391855 */   GIM_Try, /*On fail goto*//*Label 7561*/ GIMT_Encode4(391912), // Rule ID 2672 //
     /* 391860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 391871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 391875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 391879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 391888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391892 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 391896 */     // MIs[2] Operand 1
     /* 391896 */     // No operand predicates
     /* 391896 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391898 */     // (splat_vector:{ *:[nxv4f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 391898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 391901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 391903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 391907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 391910 */     GIR_RootConstrainSelectedInstOperands,
     /* 391911 */     // GIR_Coverage, 2672,
     /* 391911 */     GIR_EraseRootFromParent_Done,
     /* 391912 */   // Label 7561: @391912
     /* 391912 */   GIM_Try, /*On fail goto*//*Label 7562*/ GIMT_Encode4(391969), // Rule ID 8459 //
     /* 391917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 391928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 391932 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 391936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 391945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391949 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 391953 */     // MIs[2] Operand 1
     /* 391953 */     // No operand predicates
     /* 391953 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391955 */     // (splat_vector:{ *:[nxv4f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 391955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 391958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 391960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 391964 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 391967 */     GIR_RootConstrainSelectedInstOperands,
     /* 391968 */     // GIR_Coverage, 8459,
     /* 391968 */     GIR_EraseRootFromParent_Done,
     /* 391969 */   // Label 7562: @391969
     /* 391969 */   GIM_Try, /*On fail goto*//*Label 7563*/ GIMT_Encode4(392003), // Rule ID 8498 //
     /* 391974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 391985 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 391989 */     // MIs[1] Operand 1
     /* 391989 */     // No operand predicates
     /* 391989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391991 */     // (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv4f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 391991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 391994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 391996 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 392001 */     GIR_RootConstrainSelectedInstOperands,
     /* 392002 */     // GIR_Coverage, 8498,
     /* 392002 */     GIR_EraseRootFromParent_Done,
     /* 392003 */   // Label 7563: @392003
     /* 392003 */   GIM_Try, /*On fail goto*//*Label 7564*/ GIMT_Encode4(392079), // Rule ID 8476 //
     /* 392008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 392011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392015 */     // (splat_vector:{ *:[nxv4f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv4f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 392015 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 392018 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 392022 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392027 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 392029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 392032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 392036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392041 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 392044 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 392048 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 392051 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392056 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392061 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 392069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 392071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392077 */     GIR_RootConstrainSelectedInstOperands,
     /* 392078 */     // GIR_Coverage, 8476,
     /* 392078 */     GIR_EraseRootFromParent_Done,
     /* 392079 */   // Label 7564: @392079
     /* 392079 */   GIM_Reject,
     /* 392080 */ // Label 7559: @392080
     /* 392080 */ GIM_Reject,
     /* 392081 */ // Label 7534: @392081
     /* 392081 */ GIM_Try, /*On fail goto*//*Label 7565*/ GIMT_Encode4(392455),
     /* 392086 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 392089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392093 */   GIM_Try, /*On fail goto*//*Label 7566*/ GIMT_Encode4(392147), // Rule ID 6069 //
     /* 392098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392101 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 392105 */     // (splat_vector:{ *:[nxv4i32] } 0:{ *:[i32] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 392105 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 392108 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 392112 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392117 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 392120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 392122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 392125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392130 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 392136 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392141 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392146 */     // GIR_Coverage, 6069,
     /* 392146 */     GIR_EraseRootFromParent_Done,
     /* 392147 */   // Label 7566: @392147
     /* 392147 */   GIM_Try, /*On fail goto*//*Label 7567*/ GIMT_Encode4(392211), // Rule ID 6074 //
     /* 392152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 392163 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 392167 */     // MIs[1] Operand 1
     /* 392167 */     // No operand predicates
     /* 392167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 392169 */     // (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 392169 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 392172 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 392176 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392181 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 392184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 392186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 392189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392194 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 392200 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392205 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392210 */     // GIR_Coverage, 6074,
     /* 392210 */     GIR_EraseRootFromParent_Done,
     /* 392211 */   // Label 7567: @392211
     /* 392211 */   GIM_Try, /*On fail goto*//*Label 7568*/ GIMT_Encode4(392268), // Rule ID 2665 //
     /* 392216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 392219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 392227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 392231 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 392235 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 392244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 392248 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 392252 */     // MIs[2] Operand 1
     /* 392252 */     // No operand predicates
     /* 392252 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 392254 */     // (splat_vector:{ *:[nxv4i32] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 392254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 392257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 392259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 392263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 392266 */     GIR_RootConstrainSelectedInstOperands,
     /* 392267 */     // GIR_Coverage, 2665,
     /* 392267 */     GIR_EraseRootFromParent_Done,
     /* 392268 */   // Label 7568: @392268
     /* 392268 */   GIM_Try, /*On fail goto*//*Label 7569*/ GIMT_Encode4(392325), // Rule ID 8468 //
     /* 392273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 392276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 392284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 392288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 392292 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392297 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 392301 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 392305 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 392309 */     // MIs[2] Operand 1
     /* 392309 */     // No operand predicates
     /* 392309 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 392311 */     // (splat_vector:{ *:[nxv4f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 392311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 392314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 392316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 392320 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 392323 */     GIR_RootConstrainSelectedInstOperands,
     /* 392324 */     // GIR_Coverage, 8468,
     /* 392324 */     GIR_EraseRootFromParent_Done,
     /* 392325 */   // Label 7569: @392325
     /* 392325 */   GIM_Try, /*On fail goto*//*Label 7570*/ GIMT_Encode4(392359), // Rule ID 8500 //
     /* 392330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 392333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 392341 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 392345 */     // MIs[1] Operand 1
     /* 392345 */     // No operand predicates
     /* 392345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 392347 */     // (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8)  =>  (FDUP_ZI_S:{ *:[nxv4f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 392347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_S),
     /* 392350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 392352 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 392357 */     GIR_RootConstrainSelectedInstOperands,
     /* 392358 */     // GIR_Coverage, 8500,
     /* 392358 */     GIR_EraseRootFromParent_Done,
     /* 392359 */   // Label 7570: @392359
     /* 392359 */   GIM_Try, /*On fail goto*//*Label 7571*/ GIMT_Encode4(392378), // Rule ID 2390 //
     /* 392364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 392367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 392371 */     // (splat_vector:{ *:[nxv4i32] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_S:{ *:[nxv4i32] } GPR32sp:{ *:[i32] }:$Rn)
     /* 392371 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 392376 */     GIR_RootConstrainSelectedInstOperands,
     /* 392377 */     // GIR_Coverage, 2390,
     /* 392377 */     GIR_Done,
     /* 392378 */   // Label 7571: @392378
     /* 392378 */   GIM_Try, /*On fail goto*//*Label 7572*/ GIMT_Encode4(392454), // Rule ID 8478 //
     /* 392383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 392386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392390 */     // (splat_vector:{ *:[nxv4f32] } FPR32:{ *:[f32] }:$src)  =>  (DUP_ZZI_S:{ *:[nxv4f32] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR32:{ *:[f32] }:$src, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 392390 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 392393 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 392397 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 392404 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 392407 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 392411 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392416 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 392419 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 392423 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 392426 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392431 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392436 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 392444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 392446 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392452 */     GIR_RootConstrainSelectedInstOperands,
     /* 392453 */     // GIR_Coverage, 8478,
     /* 392453 */     GIR_EraseRootFromParent_Done,
     /* 392454 */   // Label 7572: @392454
     /* 392454 */   GIM_Reject,
     /* 392455 */ // Label 7565: @392455
     /* 392455 */ GIM_Reject,
     /* 392456 */ // Label 7535: @392456
     /* 392456 */ GIM_Try, /*On fail goto*//*Label 7573*/ GIMT_Encode4(392517), // Rule ID 6070 //
     /* 392461 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 392467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392471 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 392475 */   // (splat_vector:{ *:[nxv8i16] } 0:{ *:[i32] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 392475 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 392478 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 392482 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392487 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 392490 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 392492 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 392495 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392497 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392500 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392503 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 392506 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392511 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392516 */   // GIR_Coverage, 6070,
     /* 392516 */   GIR_EraseRootFromParent_Done,
     /* 392517 */ // Label 7573: @392517
     /* 392517 */ GIM_Try, /*On fail goto*//*Label 7574*/ GIMT_Encode4(392588), // Rule ID 6077 //
     /* 392522 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 392528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392532 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392536 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 392540 */   GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 392544 */   // MIs[1] Operand 1
     /* 392544 */   // No operand predicates
     /* 392544 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 392546 */   // (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 392546 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 392549 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 392553 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392558 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 392561 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 392563 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 392566 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392568 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392571 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392574 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 392577 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392582 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392587 */   // GIR_Coverage, 6077,
     /* 392587 */   GIR_EraseRootFromParent_Done,
     /* 392588 */ // Label 7574: @392588
     /* 392588 */ GIM_Try, /*On fail goto*//*Label 7575*/ GIMT_Encode4(392652), // Rule ID 2662 //
     /* 392593 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 392596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 392599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392603 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392607 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 392611 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 392615 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 392619 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392624 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 392628 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 392632 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 392636 */   // MIs[2] Operand 1
     /* 392636 */   // No operand predicates
     /* 392636 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 392638 */   // (splat_vector:{ *:[nxv8i16] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 392638 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 392641 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 392643 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 392647 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 392650 */   GIR_RootConstrainSelectedInstOperands,
     /* 392651 */   // GIR_Coverage, 2662,
     /* 392651 */   GIR_EraseRootFromParent_Done,
     /* 392652 */ // Label 7575: @392652
     /* 392652 */ GIM_Try, /*On fail goto*//*Label 7576*/ GIMT_Encode4(392716), // Rule ID 8462 //
     /* 392657 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 392660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 392663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392667 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392671 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 392675 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 392679 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 392683 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392688 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 392692 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 392696 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 392700 */   // MIs[2] Operand 1
     /* 392700 */   // No operand predicates
     /* 392700 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 392702 */   // (splat_vector:{ *:[nxv8f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv8f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 392702 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 392705 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 392707 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 392711 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 392714 */   GIR_RootConstrainSelectedInstOperands,
     /* 392715 */   // GIR_Coverage, 8462,
     /* 392715 */   GIR_EraseRootFromParent_Done,
     /* 392716 */ // Label 7576: @392716
     /* 392716 */ GIM_Try, /*On fail goto*//*Label 7577*/ GIMT_Encode4(392757), // Rule ID 8497 //
     /* 392721 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 392724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 392727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392731 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392735 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 392739 */   GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 392743 */   // MIs[1] Operand 1
     /* 392743 */   // No operand predicates
     /* 392743 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 392745 */   // (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv8f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 392745 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 392748 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 392750 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 392755 */   GIR_RootConstrainSelectedInstOperands,
     /* 392756 */   // GIR_Coverage, 8497,
     /* 392756 */   GIR_EraseRootFromParent_Done,
     /* 392757 */ // Label 7577: @392757
     /* 392757 */ GIM_Try, /*On fail goto*//*Label 7578*/ GIMT_Encode4(392783), // Rule ID 2389 //
     /* 392762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 392765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 392768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392772 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 392776 */   // (splat_vector:{ *:[nxv8i16] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_H:{ *:[nxv8i16] } GPR32sp:{ *:[i32] }:$Rn)
     /* 392776 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 392781 */   GIR_RootConstrainSelectedInstOperands,
     /* 392782 */   // GIR_Coverage, 2389,
     /* 392782 */   GIR_Done,
     /* 392783 */ // Label 7578: @392783
     /* 392783 */ GIM_Try, /*On fail goto*//*Label 7579*/ GIMT_Encode4(392866), // Rule ID 8475 //
     /* 392788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 392791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 392794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392798 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392802 */   // (splat_vector:{ *:[nxv8f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv8f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 392802 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 392805 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 392809 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392814 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 392816 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 392819 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 392823 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392828 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 392831 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 392835 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 392838 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392843 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392848 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392853 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 392856 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 392858 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392861 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392864 */   GIR_RootConstrainSelectedInstOperands,
     /* 392865 */   // GIR_Coverage, 8475,
     /* 392865 */   GIR_EraseRootFromParent_Done,
     /* 392866 */ // Label 7579: @392866
     /* 392866 */ GIM_Reject,
     /* 392867 */ // Label 7536: @392867
     /* 392867 */ GIM_Try, /*On fail goto*//*Label 7580*/ GIMT_Encode4(393010),
     /* 392872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 392875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392879 */   GIM_Try, /*On fail goto*//*Label 7581*/ GIMT_Encode4(392933), // Rule ID 6071 //
     /* 392884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392887 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 392891 */     // (splat_vector:{ *:[nxv16i8] } 0:{ *:[i32] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 392891 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 392894 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 392898 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392903 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 392906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 392908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 392911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 392922 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392927 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392932 */     // GIR_Coverage, 6071,
     /* 392932 */     GIR_EraseRootFromParent_Done,
     /* 392933 */   // Label 7581: @392933
     /* 392933 */   GIM_Try, /*On fail goto*//*Label 7582*/ GIMT_Encode4(392990), // Rule ID 2659 //
     /* 392938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 392941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 392949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 392953 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 392957 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 392966 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 392970 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 392974 */     // MIs[2] Operand 1
     /* 392974 */     // No operand predicates
     /* 392974 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 392976 */     // (splat_vector:{ *:[nxv16i8] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index))  =>  (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index)
     /* 392976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 392979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 392981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 392985 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 392988 */     GIR_RootConstrainSelectedInstOperands,
     /* 392989 */     // GIR_Coverage, 2659,
     /* 392989 */     GIR_EraseRootFromParent_Done,
     /* 392990 */   // Label 7582: @392990
     /* 392990 */   GIM_Try, /*On fail goto*//*Label 7583*/ GIMT_Encode4(393009), // Rule ID 2388 //
     /* 392995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 392998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 393002 */     // (splat_vector:{ *:[nxv16i8] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_B:{ *:[nxv16i8] } GPR32sp:{ *:[i32] }:$Rn)
     /* 393002 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_B),
     /* 393007 */     GIR_RootConstrainSelectedInstOperands,
     /* 393008 */     // GIR_Coverage, 2388,
     /* 393008 */     GIR_Done,
     /* 393009 */   // Label 7583: @393009
     /* 393009 */   GIM_Reject,
     /* 393010 */ // Label 7580: @393010
     /* 393010 */ GIM_Reject,
     /* 393011 */ // Label 7537: @393011
     /* 393011 */ GIM_Reject,
     /* 393012 */ // Label 94: @393012
     /* 393012 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 7586*/ GIMT_Encode4(393163),
     /* 393023 */ /*GILLT_s32*//*Label 7584*/ GIMT_Encode4(393031),
     /* 393027 */ /*GILLT_s64*//*Label 7585*/ GIMT_Encode4(393097),
     /* 393031 */ // Label 7584: @393031
     /* 393031 */ GIM_Try, /*On fail goto*//*Label 7587*/ GIMT_Encode4(393096),
     /* 393036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 393039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 393043 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 393047 */   GIM_Try, /*On fail goto*//*Label 7588*/ GIMT_Encode4(393062), // Rule ID 2321 //
     /* 393052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 393055 */     // (cttz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CTZWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 393055 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CTZWr),
     /* 393060 */     GIR_RootConstrainSelectedInstOperands,
     /* 393061 */     // GIR_Coverage, 2321,
     /* 393061 */     GIR_Done,
     /* 393062 */   // Label 7588: @393062
     /* 393062 */   GIM_Try, /*On fail goto*//*Label 7589*/ GIMT_Encode4(393095), // Rule ID 4030 //
     /* 393067 */     // (cttz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CLZWr:{ *:[i32] } (RBITWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn))
     /* 393067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 393070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::RBITWr),
     /* 393074 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393079 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 393083 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 393085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLZWr),
     /* 393088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393090 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 393093 */     GIR_RootConstrainSelectedInstOperands,
     /* 393094 */     // GIR_Coverage, 4030,
     /* 393094 */     GIR_EraseRootFromParent_Done,
     /* 393095 */   // Label 7589: @393095
     /* 393095 */   GIM_Reject,
     /* 393096 */ // Label 7587: @393096
     /* 393096 */ GIM_Reject,
     /* 393097 */ // Label 7585: @393097
     /* 393097 */ GIM_Try, /*On fail goto*//*Label 7590*/ GIMT_Encode4(393162),
     /* 393102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 393105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 393109 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 393113 */   GIM_Try, /*On fail goto*//*Label 7591*/ GIMT_Encode4(393128), // Rule ID 2322 //
     /* 393118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 393121 */     // (cttz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CTZXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 393121 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CTZXr),
     /* 393126 */     GIR_RootConstrainSelectedInstOperands,
     /* 393127 */     // GIR_Coverage, 2322,
     /* 393127 */     GIR_Done,
     /* 393128 */   // Label 7591: @393128
     /* 393128 */   GIM_Try, /*On fail goto*//*Label 7592*/ GIMT_Encode4(393161), // Rule ID 4031 //
     /* 393133 */     // (cttz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CLZXr:{ *:[i64] } (RBITXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn))
     /* 393133 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 393136 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::RBITXr),
     /* 393140 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393145 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 393149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 393151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLZXr),
     /* 393154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393156 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 393159 */     GIR_RootConstrainSelectedInstOperands,
     /* 393160 */     // GIR_Coverage, 4031,
     /* 393160 */     GIR_EraseRootFromParent_Done,
     /* 393161 */   // Label 7592: @393161
     /* 393161 */   GIM_Reject,
     /* 393162 */ // Label 7590: @393162
     /* 393162 */ GIM_Reject,
     /* 393163 */ // Label 7586: @393163
     /* 393163 */ GIM_Reject,
     /* 393164 */ // Label 95: @393164
     /* 393164 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7601*/ GIMT_Encode4(393837),
     /* 393175 */ /*GILLT_s32*//*Label 7593*/ GIMT_Encode4(393215),
     /* 393179 */ /*GILLT_s64*//*Label 7594*/ GIMT_Encode4(393445), GIMT_Encode4(0),
     /* 393187 */ /*GILLT_v2s32*//*Label 7595*/ GIMT_Encode4(393675), GIMT_Encode4(0),
     /* 393195 */ /*GILLT_v4s16*//*Label 7596*/ GIMT_Encode4(393702),
     /* 393199 */ /*GILLT_v4s32*//*Label 7597*/ GIMT_Encode4(393729),
     /* 393203 */ /*GILLT_v8s8*//*Label 7598*/ GIMT_Encode4(393756),
     /* 393207 */ /*GILLT_v8s16*//*Label 7599*/ GIMT_Encode4(393783),
     /* 393211 */ /*GILLT_v16s8*//*Label 7600*/ GIMT_Encode4(393810),
     /* 393215 */ // Label 7593: @393215
     /* 393215 */ GIM_Try, /*On fail goto*//*Label 7602*/ GIMT_Encode4(393444),
     /* 393220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 393223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 393227 */   GIM_Try, /*On fail goto*//*Label 7603*/ GIMT_Encode4(393327), // Rule ID 4032 //
     /* 393232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 393240 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 393244 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 393248 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 393252 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 393256 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 393260 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 393264 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 393268 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 393272 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 393276 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 393280 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 393284 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /* 393288 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 393292 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 393297 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 31,
     /* 393301 */     // MIs[3] Rn
     /* 393301 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /* 393306 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 393310 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 393314 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 393316 */     // (ctlz:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (xor:{ *:[i32] } (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 31:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn), 1:{ *:[i64] }), 1:{ *:[i32] }))  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 393316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 393319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /* 393325 */     GIR_RootConstrainSelectedInstOperands,
     /* 393326 */     // GIR_Coverage, 4032,
     /* 393326 */     GIR_EraseRootFromParent_Done,
     /* 393327 */   // Label 7603: @393327
     /* 393327 */   GIM_Try, /*On fail goto*//*Label 7604*/ GIMT_Encode4(393427), // Rule ID 13950 //
     /* 393332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 393340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 393344 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 393348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 393352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 393356 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 393360 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 393364 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 393368 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 393372 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 393376 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 393380 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 393385 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 393389 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 393393 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 393397 */     // MIs[4] Rn
     /* 393397 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /* 393402 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 31,
     /* 393406 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 393410 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 393414 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 393416 */     // (ctlz:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 31:{ *:[i64] })), 1:{ *:[i64] }), 1:{ *:[i32] }))  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 393416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 393419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 393425 */     GIR_RootConstrainSelectedInstOperands,
     /* 393426 */     // GIR_Coverage, 13950,
     /* 393426 */     GIR_EraseRootFromParent_Done,
     /* 393427 */   // Label 7604: @393427
     /* 393427 */   GIM_Try, /*On fail goto*//*Label 7605*/ GIMT_Encode4(393443), // Rule ID 180 //
     /* 393432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 393436 */     // (ctlz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CLZWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 393436 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZWr),
     /* 393441 */     GIR_RootConstrainSelectedInstOperands,
     /* 393442 */     // GIR_Coverage, 180,
     /* 393442 */     GIR_Done,
     /* 393443 */   // Label 7605: @393443
     /* 393443 */   GIM_Reject,
     /* 393444 */ // Label 7602: @393444
     /* 393444 */ GIM_Reject,
     /* 393445 */ // Label 7594: @393445
     /* 393445 */ GIM_Try, /*On fail goto*//*Label 7606*/ GIMT_Encode4(393674),
     /* 393450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 393453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 393457 */   GIM_Try, /*On fail goto*//*Label 7607*/ GIMT_Encode4(393557), // Rule ID 4033 //
     /* 393462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 393470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 393474 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 393478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 393482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 393486 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 393490 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 393494 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 393498 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 393502 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 393506 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 393510 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 393514 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /* 393518 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 393522 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 393527 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 63,
     /* 393531 */     // MIs[3] Rn
     /* 393531 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /* 393536 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 393540 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 393544 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 393546 */     // (ctlz:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (xor:{ *:[i64] } (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 63:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn), 1:{ *:[i64] }), 1:{ *:[i64] }))  =>  (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 393546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 393549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /* 393555 */     GIR_RootConstrainSelectedInstOperands,
     /* 393556 */     // GIR_Coverage, 4033,
     /* 393556 */     GIR_EraseRootFromParent_Done,
     /* 393557 */   // Label 7607: @393557
     /* 393557 */   GIM_Try, /*On fail goto*//*Label 7608*/ GIMT_Encode4(393657), // Rule ID 13951 //
     /* 393562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 393570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 393574 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 393578 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 393582 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 393586 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 393590 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 393594 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 393598 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 393602 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 393606 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 393610 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 393615 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 393619 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 393623 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 393627 */     // MIs[4] Rn
     /* 393627 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /* 393632 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 63,
     /* 393636 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 393640 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 393644 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 393646 */     // (ctlz:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 63:{ *:[i64] })), 1:{ *:[i64] }), 1:{ *:[i64] }))  =>  (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 393646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 393649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 393655 */     GIR_RootConstrainSelectedInstOperands,
     /* 393656 */     // GIR_Coverage, 13951,
     /* 393656 */     GIR_EraseRootFromParent_Done,
     /* 393657 */   // Label 7608: @393657
     /* 393657 */   GIM_Try, /*On fail goto*//*Label 7609*/ GIMT_Encode4(393673), // Rule ID 181 //
     /* 393662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 393666 */     // (ctlz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CLZXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 393666 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZXr),
     /* 393671 */     GIR_RootConstrainSelectedInstOperands,
     /* 393672 */     // GIR_Coverage, 181,
     /* 393672 */     GIR_Done,
     /* 393673 */   // Label 7609: @393673
     /* 393673 */   GIM_Reject,
     /* 393674 */ // Label 7606: @393674
     /* 393674 */ GIM_Reject,
     /* 393675 */ // Label 7595: @393675
     /* 393675 */ GIM_Try, /*On fail goto*//*Label 7610*/ GIMT_Encode4(393701), // Rule ID 720 //
     /* 393680 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 393686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393690 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393694 */   // (ctlz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (CLZv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 393694 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv2i32),
     /* 393699 */   GIR_RootConstrainSelectedInstOperands,
     /* 393700 */   // GIR_Coverage, 720,
     /* 393700 */   GIR_Done,
     /* 393701 */ // Label 7610: @393701
     /* 393701 */ GIM_Reject,
     /* 393702 */ // Label 7596: @393702
     /* 393702 */ GIM_Try, /*On fail goto*//*Label 7611*/ GIMT_Encode4(393728), // Rule ID 718 //
     /* 393707 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393717 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393721 */   // (ctlz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (CLZv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 393721 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv4i16),
     /* 393726 */   GIR_RootConstrainSelectedInstOperands,
     /* 393727 */   // GIR_Coverage, 718,
     /* 393727 */   GIR_Done,
     /* 393728 */ // Label 7611: @393728
     /* 393728 */ GIM_Reject,
     /* 393729 */ // Label 7597: @393729
     /* 393729 */ GIM_Try, /*On fail goto*//*Label 7612*/ GIMT_Encode4(393755), // Rule ID 721 //
     /* 393734 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393744 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393748 */   // (ctlz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (CLZv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 393748 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv4i32),
     /* 393753 */   GIR_RootConstrainSelectedInstOperands,
     /* 393754 */   // GIR_Coverage, 721,
     /* 393754 */   GIR_Done,
     /* 393755 */ // Label 7612: @393755
     /* 393755 */ GIM_Reject,
     /* 393756 */ // Label 7598: @393756
     /* 393756 */ GIM_Try, /*On fail goto*//*Label 7613*/ GIMT_Encode4(393782), // Rule ID 716 //
     /* 393761 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 393767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393771 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393775 */   // (ctlz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (CLZv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 393775 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv8i8),
     /* 393780 */   GIR_RootConstrainSelectedInstOperands,
     /* 393781 */   // GIR_Coverage, 716,
     /* 393781 */   GIR_Done,
     /* 393782 */ // Label 7613: @393782
     /* 393782 */ GIM_Reject,
     /* 393783 */ // Label 7599: @393783
     /* 393783 */ GIM_Try, /*On fail goto*//*Label 7614*/ GIMT_Encode4(393809), // Rule ID 719 //
     /* 393788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393798 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393802 */   // (ctlz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (CLZv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 393802 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv8i16),
     /* 393807 */   GIR_RootConstrainSelectedInstOperands,
     /* 393808 */   // GIR_Coverage, 719,
     /* 393808 */   GIR_Done,
     /* 393809 */ // Label 7614: @393809
     /* 393809 */ GIM_Reject,
     /* 393810 */ // Label 7600: @393810
     /* 393810 */ GIM_Try, /*On fail goto*//*Label 7615*/ GIMT_Encode4(393836), // Rule ID 717 //
     /* 393815 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 393821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393825 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393829 */   // (ctlz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (CLZv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 393829 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv16i8),
     /* 393834 */   GIR_RootConstrainSelectedInstOperands,
     /* 393835 */   // GIR_Coverage, 717,
     /* 393835 */   GIR_Done,
     /* 393836 */ // Label 7615: @393836
     /* 393836 */ GIM_Reject,
     /* 393837 */ // Label 7601: @393837
     /* 393837 */ GIM_Reject,
     /* 393838 */ // Label 96: @393838
     /* 393838 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7620*/ GIMT_Encode4(393997),
     /* 393849 */ /*GILLT_s32*//*Label 7616*/ GIMT_Encode4(393889),
     /* 393853 */ /*GILLT_s64*//*Label 7617*/ GIMT_Encode4(393916), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 393877 */ /*GILLT_v8s8*//*Label 7618*/ GIMT_Encode4(393943), GIMT_Encode4(0),
     /* 393885 */ /*GILLT_v16s8*//*Label 7619*/ GIMT_Encode4(393970),
     /* 393889 */ // Label 7616: @393889
     /* 393889 */ GIM_Try, /*On fail goto*//*Label 7621*/ GIMT_Encode4(393915), // Rule ID 2319 //
     /* 393894 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 393897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 393900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 393904 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 393908 */   // (ctpop:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CNTWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 393908 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTWr),
     /* 393913 */   GIR_RootConstrainSelectedInstOperands,
     /* 393914 */   // GIR_Coverage, 2319,
     /* 393914 */   GIR_Done,
     /* 393915 */ // Label 7621: @393915
     /* 393915 */ GIM_Reject,
     /* 393916 */ // Label 7617: @393916
     /* 393916 */ GIM_Try, /*On fail goto*//*Label 7622*/ GIMT_Encode4(393942), // Rule ID 2320 //
     /* 393921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 393924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 393927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 393931 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 393935 */   // (ctpop:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CNTXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 393935 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTXr),
     /* 393940 */   GIR_RootConstrainSelectedInstOperands,
     /* 393941 */   // GIR_Coverage, 2320,
     /* 393941 */   GIR_Done,
     /* 393942 */ // Label 7622: @393942
     /* 393942 */ GIM_Reject,
     /* 393943 */ // Label 7618: @393943
     /* 393943 */ GIM_Try, /*On fail goto*//*Label 7623*/ GIMT_Encode4(393969), // Rule ID 764 //
     /* 393948 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 393954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393958 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393962 */   // (ctpop:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (CNTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 393962 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTv8i8),
     /* 393967 */   GIR_RootConstrainSelectedInstOperands,
     /* 393968 */   // GIR_Coverage, 764,
     /* 393968 */   GIR_Done,
     /* 393969 */ // Label 7623: @393969
     /* 393969 */ GIM_Reject,
     /* 393970 */ // Label 7619: @393970
     /* 393970 */ GIM_Try, /*On fail goto*//*Label 7624*/ GIMT_Encode4(393996), // Rule ID 765 //
     /* 393975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 393981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393985 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393989 */   // (ctpop:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (CNTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 393989 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTv16i8),
     /* 393994 */   GIR_RootConstrainSelectedInstOperands,
     /* 393995 */   // GIR_Coverage, 765,
     /* 393995 */   GIR_Done,
     /* 393996 */ // Label 7624: @393996
     /* 393996 */ GIM_Reject,
     /* 393997 */ // Label 7620: @393997
     /* 393997 */ GIM_Reject,
     /* 393998 */ // Label 97: @393998
     /* 393998 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 7632*/ GIMT_Encode4(394311),
     /* 394009 */ /*GILLT_s32*//*Label 7625*/ GIMT_Encode4(394045),
     /* 394013 */ /*GILLT_s64*//*Label 7626*/ GIMT_Encode4(394118), GIMT_Encode4(0),
     /* 394021 */ /*GILLT_v2s32*//*Label 7627*/ GIMT_Encode4(394191),
     /* 394025 */ /*GILLT_v2s64*//*Label 7628*/ GIMT_Encode4(394215),
     /* 394029 */ /*GILLT_v4s16*//*Label 7629*/ GIMT_Encode4(394239),
     /* 394033 */ /*GILLT_v4s32*//*Label 7630*/ GIMT_Encode4(394263), GIMT_Encode4(0),
     /* 394041 */ /*GILLT_v8s16*//*Label 7631*/ GIMT_Encode4(394287),
     /* 394045 */ // Label 7625: @394045
     /* 394045 */ GIM_Try, /*On fail goto*//*Label 7633*/ GIMT_Encode4(394117),
     /* 394050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 394053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 394057 */   GIM_Try, /*On fail goto*//*Label 7634*/ GIMT_Encode4(394100), // Rule ID 4036 //
     /* 394062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /* 394070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 394074 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 394078 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 394083 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 394087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394089 */     // (bswap:{ *:[i32] } (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 16:{ *:[i64] }))  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 394089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 394092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 394098 */     GIR_RootConstrainSelectedInstOperands,
     /* 394099 */     // GIR_Coverage, 4036,
     /* 394099 */     GIR_EraseRootFromParent_Done,
     /* 394100 */   // Label 7634: @394100
     /* 394100 */   GIM_Try, /*On fail goto*//*Label 7635*/ GIMT_Encode4(394116), // Rule ID 185 //
     /* 394105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 394109 */     // (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (REVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 394109 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REVWr),
     /* 394114 */     GIR_RootConstrainSelectedInstOperands,
     /* 394115 */     // GIR_Coverage, 185,
     /* 394115 */     GIR_Done,
     /* 394116 */   // Label 7635: @394116
     /* 394116 */   GIM_Reject,
     /* 394117 */ // Label 7633: @394117
     /* 394117 */ GIM_Reject,
     /* 394118 */ // Label 7626: @394118
     /* 394118 */ GIM_Try, /*On fail goto*//*Label 7636*/ GIMT_Encode4(394190),
     /* 394123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 394126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 394130 */   GIM_Try, /*On fail goto*//*Label 7637*/ GIMT_Encode4(394173), // Rule ID 4037 //
     /* 394135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /* 394143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 394147 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 394151 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 394156 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 32,
     /* 394160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394162 */     // (bswap:{ *:[i64] } (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 32:{ *:[i64] }))  =>  (REV32Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 394162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV32Xr),
     /* 394165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 394171 */     GIR_RootConstrainSelectedInstOperands,
     /* 394172 */     // GIR_Coverage, 4037,
     /* 394172 */     GIR_EraseRootFromParent_Done,
     /* 394173 */   // Label 7637: @394173
     /* 394173 */   GIM_Try, /*On fail goto*//*Label 7638*/ GIMT_Encode4(394189), // Rule ID 186 //
     /* 394178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 394182 */     // (bswap:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (REVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 394182 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REVXr),
     /* 394187 */     GIR_RootConstrainSelectedInstOperands,
     /* 394188 */     // GIR_Coverage, 186,
     /* 394188 */     GIR_Done,
     /* 394189 */   // Label 7638: @394189
     /* 394189 */   GIM_Reject,
     /* 394190 */ // Label 7636: @394190
     /* 394190 */ GIM_Reject,
     /* 394191 */ // Label 7627: @394191
     /* 394191 */ GIM_Try, /*On fail goto*//*Label 7639*/ GIMT_Encode4(394214), // Rule ID 5049 //
     /* 394196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 394199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394203 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394207 */   // (bswap:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (REV32v8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 394207 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 394212 */   GIR_RootConstrainSelectedInstOperands,
     /* 394213 */   // GIR_Coverage, 5049,
     /* 394213 */   GIR_Done,
     /* 394214 */ // Label 7639: @394214
     /* 394214 */ GIM_Reject,
     /* 394215 */ // Label 7628: @394215
     /* 394215 */ GIM_Try, /*On fail goto*//*Label 7640*/ GIMT_Encode4(394238), // Rule ID 5051 //
     /* 394220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 394223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394227 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394231 */   // (bswap:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)  =>  (REV64v16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 394231 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 394236 */   GIR_RootConstrainSelectedInstOperands,
     /* 394237 */   // GIR_Coverage, 5051,
     /* 394237 */   GIR_Done,
     /* 394238 */ // Label 7640: @394238
     /* 394238 */ GIM_Reject,
     /* 394239 */ // Label 7629: @394239
     /* 394239 */ GIM_Try, /*On fail goto*//*Label 7641*/ GIMT_Encode4(394262), // Rule ID 5047 //
     /* 394244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 394247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394251 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394255 */   // (bswap:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV16v8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 394255 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 394260 */   GIR_RootConstrainSelectedInstOperands,
     /* 394261 */   // GIR_Coverage, 5047,
     /* 394261 */   GIR_Done,
     /* 394262 */ // Label 7641: @394262
     /* 394262 */ GIM_Reject,
     /* 394263 */ // Label 7630: @394263
     /* 394263 */ GIM_Try, /*On fail goto*//*Label 7642*/ GIMT_Encode4(394286), // Rule ID 5050 //
     /* 394268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394275 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394279 */   // (bswap:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (REV32v16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 394279 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 394284 */   GIR_RootConstrainSelectedInstOperands,
     /* 394285 */   // GIR_Coverage, 5050,
     /* 394285 */   GIR_Done,
     /* 394286 */ // Label 7642: @394286
     /* 394286 */ GIM_Reject,
     /* 394287 */ // Label 7631: @394287
     /* 394287 */ GIM_Try, /*On fail goto*//*Label 7643*/ GIMT_Encode4(394310), // Rule ID 5048 //
     /* 394292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394299 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394303 */   // (bswap:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV16v16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 394303 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 394308 */   GIR_RootConstrainSelectedInstOperands,
     /* 394309 */   // GIR_Coverage, 5048,
     /* 394309 */   GIR_Done,
     /* 394310 */ // Label 7643: @394310
     /* 394310 */ GIM_Reject,
     /* 394311 */ // Label 7632: @394311
     /* 394311 */ GIM_Reject,
     /* 394312 */ // Label 98: @394312
     /* 394312 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7648*/ GIMT_Encode4(394465),
     /* 394323 */ /*GILLT_s32*//*Label 7644*/ GIMT_Encode4(394363),
     /* 394327 */ /*GILLT_s64*//*Label 7645*/ GIMT_Encode4(394387), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 394351 */ /*GILLT_v8s8*//*Label 7646*/ GIMT_Encode4(394411), GIMT_Encode4(0),
     /* 394359 */ /*GILLT_v16s8*//*Label 7647*/ GIMT_Encode4(394438),
     /* 394363 */ // Label 7644: @394363
     /* 394363 */ GIM_Try, /*On fail goto*//*Label 7649*/ GIMT_Encode4(394386), // Rule ID 182 //
     /* 394368 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 394371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 394375 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 394379 */   // (bitreverse:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (RBITWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 394379 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITWr),
     /* 394384 */   GIR_RootConstrainSelectedInstOperands,
     /* 394385 */   // GIR_Coverage, 182,
     /* 394385 */   GIR_Done,
     /* 394386 */ // Label 7649: @394386
     /* 394386 */ GIM_Reject,
     /* 394387 */ // Label 7645: @394387
     /* 394387 */ GIM_Try, /*On fail goto*//*Label 7650*/ GIMT_Encode4(394410), // Rule ID 183 //
     /* 394392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 394395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 394399 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 394403 */   // (bitreverse:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (RBITXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 394403 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITXr),
     /* 394408 */   GIR_RootConstrainSelectedInstOperands,
     /* 394409 */   // GIR_Coverage, 183,
     /* 394409 */   GIR_Done,
     /* 394410 */ // Label 7650: @394410
     /* 394410 */ GIM_Reject,
     /* 394411 */ // Label 7646: @394411
     /* 394411 */ GIM_Try, /*On fail goto*//*Label 7651*/ GIMT_Encode4(394437), // Rule ID 974 //
     /* 394416 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 394422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394426 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394430 */   // (bitreverse:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (RBITv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 394430 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITv8i8),
     /* 394435 */   GIR_RootConstrainSelectedInstOperands,
     /* 394436 */   // GIR_Coverage, 974,
     /* 394436 */   GIR_Done,
     /* 394437 */ // Label 7651: @394437
     /* 394437 */ GIM_Reject,
     /* 394438 */ // Label 7647: @394438
     /* 394438 */ GIM_Try, /*On fail goto*//*Label 7652*/ GIMT_Encode4(394464), // Rule ID 975 //
     /* 394443 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 394449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394453 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394457 */   // (bitreverse:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (RBITv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 394457 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITv16i8),
     /* 394462 */   GIR_RootConstrainSelectedInstOperands,
     /* 394463 */   // GIR_Coverage, 975,
     /* 394463 */   GIR_Done,
     /* 394464 */ // Label 7652: @394464
     /* 394464 */ GIM_Reject,
     /* 394465 */ // Label 7648: @394465
     /* 394465 */ GIM_Reject,
     /* 394466 */ // Label 99: @394466
     /* 394466 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7661*/ GIMT_Encode4(394956),
     /* 394477 */ /*GILLT_s16*//*Label 7653*/ GIMT_Encode4(394517),
     /* 394481 */ /*GILLT_s32*//*Label 7654*/ GIMT_Encode4(394548),
     /* 394485 */ /*GILLT_s64*//*Label 7655*/ GIMT_Encode4(394579), GIMT_Encode4(0),
     /* 394493 */ /*GILLT_v2s32*//*Label 7656*/ GIMT_Encode4(394610),
     /* 394497 */ /*GILLT_v2s64*//*Label 7657*/ GIMT_Encode4(394641),
     /* 394501 */ /*GILLT_v4s16*//*Label 7658*/ GIMT_Encode4(394672),
     /* 394505 */ /*GILLT_v4s32*//*Label 7659*/ GIMT_Encode4(394703), GIMT_Encode4(0),
     /* 394513 */ /*GILLT_v8s16*//*Label 7660*/ GIMT_Encode4(394734),
     /* 394517 */ // Label 7653: @394517
     /* 394517 */ GIM_Try, /*On fail goto*//*Label 7662*/ GIMT_Encode4(394547), // Rule ID 552 //
     /* 394522 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 394525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 394528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394532 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394536 */   // (fceil:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTPHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 394536 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPHr),
     /* 394541 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394545 */   GIR_RootConstrainSelectedInstOperands,
     /* 394546 */   // GIR_Coverage, 552,
     /* 394546 */   GIR_Done,
     /* 394547 */ // Label 7662: @394547
     /* 394547 */ GIM_Reject,
     /* 394548 */ // Label 7654: @394548
     /* 394548 */ GIM_Try, /*On fail goto*//*Label 7663*/ GIMT_Encode4(394578), // Rule ID 554 //
     /* 394553 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 394556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 394559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394563 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394567 */   // (fceil:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTPSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 394567 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPSr),
     /* 394572 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394576 */   GIR_RootConstrainSelectedInstOperands,
     /* 394577 */   // GIR_Coverage, 554,
     /* 394577 */   GIR_Done,
     /* 394578 */ // Label 7663: @394578
     /* 394578 */ GIM_Reject,
     /* 394579 */ // Label 7655: @394579
     /* 394579 */ GIM_Try, /*On fail goto*//*Label 7664*/ GIMT_Encode4(394609), // Rule ID 556 //
     /* 394584 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 394587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 394590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394594 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394598 */   // (fceil:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTPDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 394598 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPDr),
     /* 394603 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394607 */   GIR_RootConstrainSelectedInstOperands,
     /* 394608 */   // GIR_Coverage, 556,
     /* 394608 */   GIR_Done,
     /* 394609 */ // Label 7664: @394609
     /* 394609 */ GIM_Reject,
     /* 394610 */ // Label 7656: @394610
     /* 394610 */ GIM_Try, /*On fail goto*//*Label 7665*/ GIMT_Encode4(394640), // Rule ID 913 //
     /* 394615 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 394621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394625 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394629 */   // (fceil:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 394629 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv2f32),
     /* 394634 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394638 */   GIR_RootConstrainSelectedInstOperands,
     /* 394639 */   // GIR_Coverage, 913,
     /* 394639 */   GIR_Done,
     /* 394640 */ // Label 7665: @394640
     /* 394640 */ GIM_Reject,
     /* 394641 */ // Label 7657: @394641
     /* 394641 */ GIM_Try, /*On fail goto*//*Label 7666*/ GIMT_Encode4(394671), // Rule ID 917 //
     /* 394646 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 394652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394656 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394660 */   // (fceil:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 394660 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv2f64),
     /* 394665 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394669 */   GIR_RootConstrainSelectedInstOperands,
     /* 394670 */   // GIR_Coverage, 917,
     /* 394670 */   GIR_Done,
     /* 394671 */ // Label 7666: @394671
     /* 394671 */ GIM_Reject,
     /* 394672 */ // Label 7658: @394672
     /* 394672 */ GIM_Try, /*On fail goto*//*Label 7667*/ GIMT_Encode4(394702), // Rule ID 909 //
     /* 394677 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 394680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 394683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394687 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394691 */   // (fceil:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 394691 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f16),
     /* 394696 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394700 */   GIR_RootConstrainSelectedInstOperands,
     /* 394701 */   // GIR_Coverage, 909,
     /* 394701 */   GIR_Done,
     /* 394702 */ // Label 7667: @394702
     /* 394702 */ GIM_Reject,
     /* 394703 */ // Label 7659: @394703
     /* 394703 */ GIM_Try, /*On fail goto*//*Label 7668*/ GIMT_Encode4(394733), // Rule ID 915 //
     /* 394708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394718 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394722 */   // (fceil:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 394722 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 394727 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394731 */   GIR_RootConstrainSelectedInstOperands,
     /* 394732 */   // GIR_Coverage, 915,
     /* 394732 */   GIR_Done,
     /* 394733 */ // Label 7668: @394733
     /* 394733 */ GIM_Reject,
     /* 394734 */ // Label 7660: @394734
     /* 394734 */ GIM_Try, /*On fail goto*//*Label 7669*/ GIMT_Encode4(394955),
     /* 394739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394746 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394750 */   GIM_Try, /*On fail goto*//*Label 7670*/ GIMT_Encode4(394769), // Rule ID 911 //
     /* 394755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 394758 */     // (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 394758 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv8f16),
     /* 394763 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394767 */     GIR_RootConstrainSelectedInstOperands,
     /* 394768 */     // GIR_Coverage, 911,
     /* 394768 */     GIR_Done,
     /* 394769 */   // Label 7670: @394769
     /* 394769 */   GIM_Try, /*On fail goto*//*Label 7671*/ GIMT_Encode4(394954), // Rule ID 7068 //
     /* 394774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 394777 */     // (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTPv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTPv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 394777 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 394780 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 394784 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394789 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 394793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 394795 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 394798 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 394802 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394807 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 394810 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 394812 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 394815 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 394819 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394824 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 394830 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394835 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394840 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 394843 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 394847 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394852 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 394855 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 394857 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 394860 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 394864 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394869 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 394872 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 394874 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 394877 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 394881 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394886 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 394889 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 394891 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 394894 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 394898 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394903 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 394905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 394908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 394912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394917 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 394920 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 394923 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 394926 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394931 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394936 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 394944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 394949 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 394952 */     GIR_RootConstrainSelectedInstOperands,
     /* 394953 */     // GIR_Coverage, 7068,
     /* 394953 */     GIR_EraseRootFromParent_Done,
     /* 394954 */   // Label 7671: @394954
     /* 394954 */   GIM_Reject,
     /* 394955 */ // Label 7669: @394955
     /* 394955 */ GIM_Reject,
     /* 394956 */ // Label 7661: @394956
     /* 394956 */ GIM_Reject,
     /* 394957 */ // Label 100: @394957
     /* 394957 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7680*/ GIMT_Encode4(395256),
     /* 394968 */ /*GILLT_s16*//*Label 7672*/ GIMT_Encode4(395008),
     /* 394972 */ /*GILLT_s32*//*Label 7673*/ GIMT_Encode4(395039),
     /* 394976 */ /*GILLT_s64*//*Label 7674*/ GIMT_Encode4(395070), GIMT_Encode4(0),
     /* 394984 */ /*GILLT_v2s32*//*Label 7675*/ GIMT_Encode4(395101),
     /* 394988 */ /*GILLT_v2s64*//*Label 7676*/ GIMT_Encode4(395132),
     /* 394992 */ /*GILLT_v4s16*//*Label 7677*/ GIMT_Encode4(395163),
     /* 394996 */ /*GILLT_v4s32*//*Label 7678*/ GIMT_Encode4(395194), GIMT_Encode4(0),
     /* 395004 */ /*GILLT_v8s16*//*Label 7679*/ GIMT_Encode4(395225),
     /* 395008 */ // Label 7672: @395008
     /* 395008 */ GIM_Try, /*On fail goto*//*Label 7681*/ GIMT_Encode4(395038), // Rule ID 570 //
     /* 395013 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 395016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 395019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395023 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395027 */   // (fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FSQRTHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 395027 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTHr),
     /* 395032 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395036 */   GIR_RootConstrainSelectedInstOperands,
     /* 395037 */   // GIR_Coverage, 570,
     /* 395037 */   GIR_Done,
     /* 395038 */ // Label 7681: @395038
     /* 395038 */ GIM_Reject,
     /* 395039 */ // Label 7673: @395039
     /* 395039 */ GIM_Try, /*On fail goto*//*Label 7682*/ GIMT_Encode4(395069), // Rule ID 572 //
     /* 395044 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 395047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 395050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395054 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395058 */   // (fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FSQRTSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 395058 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTSr),
     /* 395063 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395067 */   GIR_RootConstrainSelectedInstOperands,
     /* 395068 */   // GIR_Coverage, 572,
     /* 395068 */   GIR_Done,
     /* 395069 */ // Label 7682: @395069
     /* 395069 */ GIM_Reject,
     /* 395070 */ // Label 7674: @395070
     /* 395070 */ GIM_Try, /*On fail goto*//*Label 7683*/ GIMT_Encode4(395100), // Rule ID 574 //
     /* 395075 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 395078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 395081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395085 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395089 */   // (fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FSQRTDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 395089 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTDr),
     /* 395094 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395098 */   GIR_RootConstrainSelectedInstOperands,
     /* 395099 */   // GIR_Coverage, 574,
     /* 395099 */   GIR_Done,
     /* 395100 */ // Label 7683: @395100
     /* 395100 */ GIM_Reject,
     /* 395101 */ // Label 7675: @395101
     /* 395101 */ GIM_Try, /*On fail goto*//*Label 7684*/ GIMT_Encode4(395131), // Rule ID 960 //
     /* 395106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 395112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395116 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395120 */   // (fsqrt:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FSQRTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 395120 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f32),
     /* 395125 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395129 */   GIR_RootConstrainSelectedInstOperands,
     /* 395130 */   // GIR_Coverage, 960,
     /* 395130 */   GIR_Done,
     /* 395131 */ // Label 7684: @395131
     /* 395131 */ GIM_Reject,
     /* 395132 */ // Label 7676: @395132
     /* 395132 */ GIM_Try, /*On fail goto*//*Label 7685*/ GIMT_Encode4(395162), // Rule ID 964 //
     /* 395137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 395143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395147 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395151 */   // (fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FSQRTv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 395151 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f64),
     /* 395156 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395160 */   GIR_RootConstrainSelectedInstOperands,
     /* 395161 */   // GIR_Coverage, 964,
     /* 395161 */   GIR_Done,
     /* 395162 */ // Label 7685: @395162
     /* 395162 */ GIM_Reject,
     /* 395163 */ // Label 7677: @395163
     /* 395163 */ GIM_Try, /*On fail goto*//*Label 7686*/ GIMT_Encode4(395193), // Rule ID 956 //
     /* 395168 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 395174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395178 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395182 */   // (fsqrt:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FSQRTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 395182 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f16),
     /* 395187 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395191 */   GIR_RootConstrainSelectedInstOperands,
     /* 395192 */   // GIR_Coverage, 956,
     /* 395192 */   GIR_Done,
     /* 395193 */ // Label 7686: @395193
     /* 395193 */ GIM_Reject,
     /* 395194 */ // Label 7678: @395194
     /* 395194 */ GIM_Try, /*On fail goto*//*Label 7687*/ GIMT_Encode4(395224), // Rule ID 962 //
     /* 395199 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395209 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395213 */   // (fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FSQRTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 395213 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f32),
     /* 395218 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395222 */   GIR_RootConstrainSelectedInstOperands,
     /* 395223 */   // GIR_Coverage, 962,
     /* 395223 */   GIR_Done,
     /* 395224 */ // Label 7687: @395224
     /* 395224 */ GIM_Reject,
     /* 395225 */ // Label 7679: @395225
     /* 395225 */ GIM_Try, /*On fail goto*//*Label 7688*/ GIMT_Encode4(395255), // Rule ID 958 //
     /* 395230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395240 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395244 */   // (fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FSQRTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 395244 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv8f16),
     /* 395249 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395253 */   GIR_RootConstrainSelectedInstOperands,
     /* 395254 */   // GIR_Coverage, 958,
     /* 395254 */   GIR_Done,
     /* 395255 */ // Label 7688: @395255
     /* 395255 */ GIM_Reject,
     /* 395256 */ // Label 7680: @395256
     /* 395256 */ GIM_Reject,
     /* 395257 */ // Label 101: @395257
     /* 395257 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7697*/ GIMT_Encode4(395747),
     /* 395268 */ /*GILLT_s16*//*Label 7689*/ GIMT_Encode4(395308),
     /* 395272 */ /*GILLT_s32*//*Label 7690*/ GIMT_Encode4(395339),
     /* 395276 */ /*GILLT_s64*//*Label 7691*/ GIMT_Encode4(395370), GIMT_Encode4(0),
     /* 395284 */ /*GILLT_v2s32*//*Label 7692*/ GIMT_Encode4(395401),
     /* 395288 */ /*GILLT_v2s64*//*Label 7693*/ GIMT_Encode4(395432),
     /* 395292 */ /*GILLT_v4s16*//*Label 7694*/ GIMT_Encode4(395463),
     /* 395296 */ /*GILLT_v4s32*//*Label 7695*/ GIMT_Encode4(395494), GIMT_Encode4(0),
     /* 395304 */ /*GILLT_v8s16*//*Label 7696*/ GIMT_Encode4(395525),
     /* 395308 */ // Label 7689: @395308
     /* 395308 */ GIM_Try, /*On fail goto*//*Label 7698*/ GIMT_Encode4(395338), // Rule ID 540 //
     /* 395313 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 395316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 395319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395323 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395327 */   // (ffloor:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTMHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 395327 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMHr),
     /* 395332 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395336 */   GIR_RootConstrainSelectedInstOperands,
     /* 395337 */   // GIR_Coverage, 540,
     /* 395337 */   GIR_Done,
     /* 395338 */ // Label 7698: @395338
     /* 395338 */ GIM_Reject,
     /* 395339 */ // Label 7690: @395339
     /* 395339 */ GIM_Try, /*On fail goto*//*Label 7699*/ GIMT_Encode4(395369), // Rule ID 542 //
     /* 395344 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 395347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 395350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395358 */   // (ffloor:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTMSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 395358 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMSr),
     /* 395363 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395367 */   GIR_RootConstrainSelectedInstOperands,
     /* 395368 */   // GIR_Coverage, 542,
     /* 395368 */   GIR_Done,
     /* 395369 */ // Label 7699: @395369
     /* 395369 */ GIM_Reject,
     /* 395370 */ // Label 7691: @395370
     /* 395370 */ GIM_Try, /*On fail goto*//*Label 7700*/ GIMT_Encode4(395400), // Rule ID 544 //
     /* 395375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 395378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 395381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395385 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395389 */   // (ffloor:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTMDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 395389 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMDr),
     /* 395394 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395398 */   GIR_RootConstrainSelectedInstOperands,
     /* 395399 */   // GIR_Coverage, 544,
     /* 395399 */   GIR_Done,
     /* 395400 */ // Label 7700: @395400
     /* 395400 */ GIM_Reject,
     /* 395401 */ // Label 7692: @395401
     /* 395401 */ GIM_Try, /*On fail goto*//*Label 7701*/ GIMT_Encode4(395431), // Rule ID 893 //
     /* 395406 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 395412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395416 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395420 */   // (ffloor:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 395420 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv2f32),
     /* 395425 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395429 */   GIR_RootConstrainSelectedInstOperands,
     /* 395430 */   // GIR_Coverage, 893,
     /* 395430 */   GIR_Done,
     /* 395431 */ // Label 7701: @395431
     /* 395431 */ GIM_Reject,
     /* 395432 */ // Label 7693: @395432
     /* 395432 */ GIM_Try, /*On fail goto*//*Label 7702*/ GIMT_Encode4(395462), // Rule ID 897 //
     /* 395437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 395443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395447 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395451 */   // (ffloor:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 395451 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv2f64),
     /* 395456 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395460 */   GIR_RootConstrainSelectedInstOperands,
     /* 395461 */   // GIR_Coverage, 897,
     /* 395461 */   GIR_Done,
     /* 395462 */ // Label 7702: @395462
     /* 395462 */ GIM_Reject,
     /* 395463 */ // Label 7694: @395463
     /* 395463 */ GIM_Try, /*On fail goto*//*Label 7703*/ GIMT_Encode4(395493), // Rule ID 889 //
     /* 395468 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395471 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 395474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395478 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395482 */   // (ffloor:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 395482 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f16),
     /* 395487 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395491 */   GIR_RootConstrainSelectedInstOperands,
     /* 395492 */   // GIR_Coverage, 889,
     /* 395492 */   GIR_Done,
     /* 395493 */ // Label 7703: @395493
     /* 395493 */ GIM_Reject,
     /* 395494 */ // Label 7695: @395494
     /* 395494 */ GIM_Try, /*On fail goto*//*Label 7704*/ GIMT_Encode4(395524), // Rule ID 895 //
     /* 395499 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395509 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395513 */   // (ffloor:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 395513 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 395518 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395522 */   GIR_RootConstrainSelectedInstOperands,
     /* 395523 */   // GIR_Coverage, 895,
     /* 395523 */   GIR_Done,
     /* 395524 */ // Label 7704: @395524
     /* 395524 */ GIM_Reject,
     /* 395525 */ // Label 7696: @395525
     /* 395525 */ GIM_Try, /*On fail goto*//*Label 7705*/ GIMT_Encode4(395746),
     /* 395530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395537 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395541 */   GIM_Try, /*On fail goto*//*Label 7706*/ GIMT_Encode4(395560), // Rule ID 891 //
     /* 395546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395549 */     // (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 395549 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv8f16),
     /* 395554 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395558 */     GIR_RootConstrainSelectedInstOperands,
     /* 395559 */     // GIR_Coverage, 891,
     /* 395559 */     GIR_Done,
     /* 395560 */   // Label 7706: @395560
     /* 395560 */   GIM_Try, /*On fail goto*//*Label 7707*/ GIMT_Encode4(395745), // Rule ID 7070 //
     /* 395565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 395568 */     // (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTMv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTMv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 395568 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 395571 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 395575 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395580 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 395584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 395586 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 395589 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 395593 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395598 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 395601 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 395603 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 395606 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 395610 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395615 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 395621 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395626 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395631 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 395634 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 395638 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395643 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 395646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 395648 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 395651 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 395655 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395660 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 395663 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 395665 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 395668 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 395672 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395677 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 395680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 395682 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 395685 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 395689 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 395696 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 395699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 395703 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395708 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 395711 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 395714 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 395717 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395722 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395727 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 395735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395737 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 395740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 395743 */     GIR_RootConstrainSelectedInstOperands,
     /* 395744 */     // GIR_Coverage, 7070,
     /* 395744 */     GIR_EraseRootFromParent_Done,
     /* 395745 */   // Label 7707: @395745
     /* 395745 */   GIM_Reject,
     /* 395746 */ // Label 7705: @395746
     /* 395746 */ GIM_Reject,
     /* 395747 */ // Label 7697: @395747
     /* 395747 */ GIM_Reject,
     /* 395748 */ // Label 102: @395748
     /* 395748 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7716*/ GIMT_Encode4(396238),
     /* 395759 */ /*GILLT_s16*//*Label 7708*/ GIMT_Encode4(395799),
     /* 395763 */ /*GILLT_s32*//*Label 7709*/ GIMT_Encode4(395830),
     /* 395767 */ /*GILLT_s64*//*Label 7710*/ GIMT_Encode4(395861), GIMT_Encode4(0),
     /* 395775 */ /*GILLT_v2s32*//*Label 7711*/ GIMT_Encode4(395892),
     /* 395779 */ /*GILLT_v2s64*//*Label 7712*/ GIMT_Encode4(395923),
     /* 395783 */ /*GILLT_v4s16*//*Label 7713*/ GIMT_Encode4(395954),
     /* 395787 */ /*GILLT_v4s32*//*Label 7714*/ GIMT_Encode4(395985), GIMT_Encode4(0),
     /* 395795 */ /*GILLT_v8s16*//*Label 7715*/ GIMT_Encode4(396016),
     /* 395799 */ // Label 7708: @395799
     /* 395799 */ GIM_Try, /*On fail goto*//*Label 7717*/ GIMT_Encode4(395829), // Rule ID 558 //
     /* 395804 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 395807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 395810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395814 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395818 */   // (frint:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTXHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 395818 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /* 395823 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395827 */   GIR_RootConstrainSelectedInstOperands,
     /* 395828 */   // GIR_Coverage, 558,
     /* 395828 */   GIR_Done,
     /* 395829 */ // Label 7717: @395829
     /* 395829 */ GIM_Reject,
     /* 395830 */ // Label 7709: @395830
     /* 395830 */ GIM_Try, /*On fail goto*//*Label 7718*/ GIMT_Encode4(395860), // Rule ID 560 //
     /* 395835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 395838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 395841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395849 */   // (frint:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTXSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 395849 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /* 395854 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395858 */   GIR_RootConstrainSelectedInstOperands,
     /* 395859 */   // GIR_Coverage, 560,
     /* 395859 */   GIR_Done,
     /* 395860 */ // Label 7718: @395860
     /* 395860 */ GIM_Reject,
     /* 395861 */ // Label 7710: @395861
     /* 395861 */ GIM_Try, /*On fail goto*//*Label 7719*/ GIMT_Encode4(395891), // Rule ID 562 //
     /* 395866 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 395869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 395872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395876 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395880 */   // (frint:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTXDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 395880 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /* 395885 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395889 */   GIR_RootConstrainSelectedInstOperands,
     /* 395890 */   // GIR_Coverage, 562,
     /* 395890 */   GIR_Done,
     /* 395891 */ // Label 7719: @395891
     /* 395891 */ GIM_Reject,
     /* 395892 */ // Label 7711: @395892
     /* 395892 */ GIM_Try, /*On fail goto*//*Label 7720*/ GIMT_Encode4(395922), // Rule ID 923 //
     /* 395897 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395900 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 395903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395907 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395911 */   // (frint:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 395911 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv2f32),
     /* 395916 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395920 */   GIR_RootConstrainSelectedInstOperands,
     /* 395921 */   // GIR_Coverage, 923,
     /* 395921 */   GIR_Done,
     /* 395922 */ // Label 7720: @395922
     /* 395922 */ GIM_Reject,
     /* 395923 */ // Label 7712: @395923
     /* 395923 */ GIM_Try, /*On fail goto*//*Label 7721*/ GIMT_Encode4(395953), // Rule ID 927 //
     /* 395928 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 395934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395938 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395942 */   // (frint:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 395942 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv2f64),
     /* 395947 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395951 */   GIR_RootConstrainSelectedInstOperands,
     /* 395952 */   // GIR_Coverage, 927,
     /* 395952 */   GIR_Done,
     /* 395953 */ // Label 7721: @395953
     /* 395953 */ GIM_Reject,
     /* 395954 */ // Label 7713: @395954
     /* 395954 */ GIM_Try, /*On fail goto*//*Label 7722*/ GIMT_Encode4(395984), // Rule ID 919 //
     /* 395959 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 395965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395969 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395973 */   // (frint:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 395973 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f16),
     /* 395978 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395982 */   GIR_RootConstrainSelectedInstOperands,
     /* 395983 */   // GIR_Coverage, 919,
     /* 395983 */   GIR_Done,
     /* 395984 */ // Label 7722: @395984
     /* 395984 */ GIM_Reject,
     /* 395985 */ // Label 7714: @395985
     /* 395985 */ GIM_Try, /*On fail goto*//*Label 7723*/ GIMT_Encode4(396015), // Rule ID 925 //
     /* 395990 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396004 */   // (frint:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 396004 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 396009 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396013 */   GIR_RootConstrainSelectedInstOperands,
     /* 396014 */   // GIR_Coverage, 925,
     /* 396014 */   GIR_Done,
     /* 396015 */ // Label 7723: @396015
     /* 396015 */ GIM_Reject,
     /* 396016 */ // Label 7715: @396016
     /* 396016 */ GIM_Try, /*On fail goto*//*Label 7724*/ GIMT_Encode4(396237),
     /* 396021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396028 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396032 */   GIM_Try, /*On fail goto*//*Label 7725*/ GIMT_Encode4(396051), // Rule ID 921 //
     /* 396037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 396040 */     // (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 396040 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv8f16),
     /* 396045 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396049 */     GIR_RootConstrainSelectedInstOperands,
     /* 396050 */     // GIR_Coverage, 921,
     /* 396050 */     GIR_Done,
     /* 396051 */   // Label 7725: @396051
     /* 396051 */   GIM_Try, /*On fail goto*//*Label 7726*/ GIMT_Encode4(396236), // Rule ID 7078 //
     /* 396056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 396059 */     // (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTXv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTXv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 396059 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 396062 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 396066 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396071 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 396075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 396077 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 396080 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 396084 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396089 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 396092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 396094 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 396097 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 396101 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396106 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 396112 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396117 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396122 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 396125 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 396129 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396134 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 396137 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 396139 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 396142 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 396146 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396151 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 396154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 396156 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 396159 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 396163 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396168 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 396171 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 396173 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 396176 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 396180 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 396187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 396190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 396194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396199 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 396202 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 396205 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 396208 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396213 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396218 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 396226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396228 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 396234 */     GIR_RootConstrainSelectedInstOperands,
     /* 396235 */     // GIR_Coverage, 7078,
     /* 396235 */     GIR_EraseRootFromParent_Done,
     /* 396236 */   // Label 7726: @396236
     /* 396236 */   GIM_Reject,
     /* 396237 */ // Label 7724: @396237
     /* 396237 */ GIM_Reject,
     /* 396238 */ // Label 7716: @396238
     /* 396238 */ GIM_Reject,
     /* 396239 */ // Label 103: @396239
     /* 396239 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7735*/ GIMT_Encode4(396729),
     /* 396250 */ /*GILLT_s16*//*Label 7727*/ GIMT_Encode4(396290),
     /* 396254 */ /*GILLT_s32*//*Label 7728*/ GIMT_Encode4(396321),
     /* 396258 */ /*GILLT_s64*//*Label 7729*/ GIMT_Encode4(396352), GIMT_Encode4(0),
     /* 396266 */ /*GILLT_v2s32*//*Label 7730*/ GIMT_Encode4(396383),
     /* 396270 */ /*GILLT_v2s64*//*Label 7731*/ GIMT_Encode4(396414),
     /* 396274 */ /*GILLT_v4s16*//*Label 7732*/ GIMT_Encode4(396445),
     /* 396278 */ /*GILLT_v4s32*//*Label 7733*/ GIMT_Encode4(396476), GIMT_Encode4(0),
     /* 396286 */ /*GILLT_v8s16*//*Label 7734*/ GIMT_Encode4(396507),
     /* 396290 */ // Label 7727: @396290
     /* 396290 */ GIM_Try, /*On fail goto*//*Label 7736*/ GIMT_Encode4(396320), // Rule ID 534 //
     /* 396295 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 396298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 396301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396305 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396309 */   // (fnearbyint:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTIHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 396309 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIHr),
     /* 396314 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396318 */   GIR_RootConstrainSelectedInstOperands,
     /* 396319 */   // GIR_Coverage, 534,
     /* 396319 */   GIR_Done,
     /* 396320 */ // Label 7736: @396320
     /* 396320 */ GIM_Reject,
     /* 396321 */ // Label 7728: @396321
     /* 396321 */ GIM_Try, /*On fail goto*//*Label 7737*/ GIMT_Encode4(396351), // Rule ID 536 //
     /* 396326 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 396329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 396332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396336 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396340 */   // (fnearbyint:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTISr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 396340 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTISr),
     /* 396345 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396349 */   GIR_RootConstrainSelectedInstOperands,
     /* 396350 */   // GIR_Coverage, 536,
     /* 396350 */   GIR_Done,
     /* 396351 */ // Label 7737: @396351
     /* 396351 */ GIM_Reject,
     /* 396352 */ // Label 7729: @396352
     /* 396352 */ GIM_Try, /*On fail goto*//*Label 7738*/ GIMT_Encode4(396382), // Rule ID 538 //
     /* 396357 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 396360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 396363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396367 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396371 */   // (fnearbyint:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTIDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 396371 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIDr),
     /* 396376 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396380 */   GIR_RootConstrainSelectedInstOperands,
     /* 396381 */   // GIR_Coverage, 538,
     /* 396381 */   GIR_Done,
     /* 396382 */ // Label 7738: @396382
     /* 396382 */ GIM_Reject,
     /* 396383 */ // Label 7730: @396383
     /* 396383 */ GIM_Try, /*On fail goto*//*Label 7739*/ GIMT_Encode4(396413), // Rule ID 883 //
     /* 396388 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 396394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396398 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396402 */   // (fnearbyint:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTIv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 396402 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv2f32),
     /* 396407 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396411 */   GIR_RootConstrainSelectedInstOperands,
     /* 396412 */   // GIR_Coverage, 883,
     /* 396412 */   GIR_Done,
     /* 396413 */ // Label 7739: @396413
     /* 396413 */ GIM_Reject,
     /* 396414 */ // Label 7731: @396414
     /* 396414 */ GIM_Try, /*On fail goto*//*Label 7740*/ GIMT_Encode4(396444), // Rule ID 887 //
     /* 396419 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 396425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396429 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396433 */   // (fnearbyint:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTIv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 396433 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv2f64),
     /* 396438 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396442 */   GIR_RootConstrainSelectedInstOperands,
     /* 396443 */   // GIR_Coverage, 887,
     /* 396443 */   GIR_Done,
     /* 396444 */ // Label 7740: @396444
     /* 396444 */ GIM_Reject,
     /* 396445 */ // Label 7732: @396445
     /* 396445 */ GIM_Try, /*On fail goto*//*Label 7741*/ GIMT_Encode4(396475), // Rule ID 879 //
     /* 396450 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 396453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 396456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396460 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396464 */   // (fnearbyint:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTIv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 396464 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f16),
     /* 396469 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396473 */   GIR_RootConstrainSelectedInstOperands,
     /* 396474 */   // GIR_Coverage, 879,
     /* 396474 */   GIR_Done,
     /* 396475 */ // Label 7741: @396475
     /* 396475 */ GIM_Reject,
     /* 396476 */ // Label 7733: @396476
     /* 396476 */ GIM_Try, /*On fail goto*//*Label 7742*/ GIMT_Encode4(396506), // Rule ID 885 //
     /* 396481 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396491 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396495 */   // (fnearbyint:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTIv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 396495 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 396500 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396504 */   GIR_RootConstrainSelectedInstOperands,
     /* 396505 */   // GIR_Coverage, 885,
     /* 396505 */   GIR_Done,
     /* 396506 */ // Label 7742: @396506
     /* 396506 */ GIM_Reject,
     /* 396507 */ // Label 7734: @396507
     /* 396507 */ GIM_Try, /*On fail goto*//*Label 7743*/ GIMT_Encode4(396728),
     /* 396512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396519 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396523 */   GIM_Try, /*On fail goto*//*Label 7744*/ GIMT_Encode4(396542), // Rule ID 881 //
     /* 396528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 396531 */     // (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTIv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 396531 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv8f16),
     /* 396536 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396540 */     GIR_RootConstrainSelectedInstOperands,
     /* 396541 */     // GIR_Coverage, 881,
     /* 396541 */     GIR_Done,
     /* 396542 */   // Label 7744: @396542
     /* 396542 */   GIM_Try, /*On fail goto*//*Label 7745*/ GIMT_Encode4(396727), // Rule ID 7072 //
     /* 396547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 396550 */     // (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTIv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTIv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 396550 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 396553 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 396557 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396562 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 396566 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 396568 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 396571 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 396575 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396580 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 396583 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 396585 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 396588 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 396592 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396597 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 396603 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396608 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396613 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 396616 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 396620 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396625 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 396628 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 396630 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 396633 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 396637 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396642 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 396645 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 396647 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 396650 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 396654 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396659 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 396662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 396664 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 396667 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 396671 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396676 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 396678 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 396681 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 396685 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396690 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 396693 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 396696 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 396699 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396704 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396709 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 396717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396719 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 396725 */     GIR_RootConstrainSelectedInstOperands,
     /* 396726 */     // GIR_Coverage, 7072,
     /* 396726 */     GIR_EraseRootFromParent_Done,
     /* 396727 */   // Label 7745: @396727
     /* 396727 */   GIM_Reject,
     /* 396728 */ // Label 7743: @396728
     /* 396728 */ GIM_Reject,
     /* 396729 */ // Label 7735: @396729
     /* 396729 */ GIM_Reject,
     /* 396730 */ // Label 104: @396730
     /* 396730 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7754*/ GIMT_Encode4(397855),
     /* 396741 */ /*GILLT_s16*//*Label 7746*/ GIMT_Encode4(396781),
     /* 396745 */ /*GILLT_s32*//*Label 7747*/ GIMT_Encode4(397007),
     /* 396749 */ /*GILLT_s64*//*Label 7748*/ GIMT_Encode4(397233), GIMT_Encode4(0),
     /* 396757 */ /*GILLT_v2s32*//*Label 7749*/ GIMT_Encode4(397405),
     /* 396761 */ /*GILLT_v2s64*//*Label 7750*/ GIMT_Encode4(397443),
     /* 396765 */ /*GILLT_v4s16*//*Label 7751*/ GIMT_Encode4(397481),
     /* 396769 */ /*GILLT_v4s32*//*Label 7752*/ GIMT_Encode4(397519), GIMT_Encode4(0),
     /* 396777 */ /*GILLT_v8s16*//*Label 7753*/ GIMT_Encode4(397557),
     /* 396781 */ // Label 7746: @396781
     /* 396781 */ GIM_Try, /*On fail goto*//*Label 7755*/ GIMT_Encode4(397006),
     /* 396786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 396789 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 396792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396796 */   GIM_Try, /*On fail goto*//*Label 7756*/ GIMT_Encode4(396887), // Rule ID 6986 //
     /* 396801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396813 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 396817 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396822 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 396826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 396830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396834 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 396838 */     // MIs[2] Rn
     /* 396838 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 396843 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 396847 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 396849 */     // (strict_fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 396849 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 396852 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 396856 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396861 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 396867 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396872 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 396880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396885 */     GIR_RootConstrainSelectedInstOperands,
     /* 396886 */     // GIR_Coverage, 6986,
     /* 396886 */     GIR_EraseRootFromParent_Done,
     /* 396887 */   // Label 7756: @396887
     /* 396887 */   GIM_Try, /*On fail goto*//*Label 7757*/ GIMT_Encode4(396978), // Rule ID 14088 //
     /* 396892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396904 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 396908 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396913 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 396917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 396921 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396925 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 396929 */     // MIs[2] Rn
     /* 396929 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 396934 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 396938 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 396940 */     // (strict_fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 396940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 396943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 396947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396952 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 396958 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396963 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 396971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396973 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396976 */     GIR_RootConstrainSelectedInstOperands,
     /* 396977 */     // GIR_Coverage, 14088,
     /* 396977 */     GIR_EraseRootFromParent_Done,
     /* 396978 */   // Label 7757: @396978
     /* 396978 */   GIM_Try, /*On fail goto*//*Label 7758*/ GIMT_Encode4(397005), // Rule ID 583 //
     /* 396983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 396986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396994 */     // (strict_fadd:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FADDHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 396994 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDHrr),
     /* 396999 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397003 */     GIR_RootConstrainSelectedInstOperands,
     /* 397004 */     // GIR_Coverage, 583,
     /* 397004 */     GIR_Done,
     /* 397005 */   // Label 7758: @397005
     /* 397005 */   GIM_Reject,
     /* 397006 */ // Label 7755: @397006
     /* 397006 */ GIM_Reject,
     /* 397007 */ // Label 7747: @397007
     /* 397007 */ GIM_Try, /*On fail goto*//*Label 7759*/ GIMT_Encode4(397232),
     /* 397012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 397015 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 397018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397022 */   GIM_Try, /*On fail goto*//*Label 7760*/ GIMT_Encode4(397113), // Rule ID 6984 //
     /* 397027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397039 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397043 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397048 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 397052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 397056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397060 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 397064 */     // MIs[2] Rn
     /* 397064 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 397069 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 397073 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 397075 */     // (strict_fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 397075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 397078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 397082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397087 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 397093 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397098 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 397106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397108 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397111 */     GIR_RootConstrainSelectedInstOperands,
     /* 397112 */     // GIR_Coverage, 6984,
     /* 397112 */     GIR_EraseRootFromParent_Done,
     /* 397113 */   // Label 7760: @397113
     /* 397113 */   GIM_Try, /*On fail goto*//*Label 7761*/ GIMT_Encode4(397204), // Rule ID 14086 //
     /* 397118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397130 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397139 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 397143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 397147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397151 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 397155 */     // MIs[2] Rn
     /* 397155 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 397160 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 397164 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 397166 */     // (strict_fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 397166 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 397169 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 397173 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397178 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 397184 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397189 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 397197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397202 */     GIR_RootConstrainSelectedInstOperands,
     /* 397203 */     // GIR_Coverage, 14086,
     /* 397203 */     GIR_EraseRootFromParent_Done,
     /* 397204 */   // Label 7761: @397204
     /* 397204 */   GIM_Try, /*On fail goto*//*Label 7762*/ GIMT_Encode4(397231), // Rule ID 585 //
     /* 397209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 397212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397220 */     // (strict_fadd:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FADDSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 397220 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDSrr),
     /* 397225 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397229 */     GIR_RootConstrainSelectedInstOperands,
     /* 397230 */     // GIR_Coverage, 585,
     /* 397230 */     GIR_Done,
     /* 397231 */   // Label 7762: @397231
     /* 397231 */   GIM_Reject,
     /* 397232 */ // Label 7759: @397232
     /* 397232 */ GIM_Reject,
     /* 397233 */ // Label 7748: @397233
     /* 397233 */ GIM_Try, /*On fail goto*//*Label 7763*/ GIMT_Encode4(397404),
     /* 397238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 397241 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 397244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397248 */   GIM_Try, /*On fail goto*//*Label 7764*/ GIMT_Encode4(397312), // Rule ID 6982 //
     /* 397253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397265 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397269 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397274 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 397278 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 397282 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397286 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 397290 */     // MIs[2] Rn
     /* 397290 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 397295 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 397299 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 397301 */     // (strict_fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 397301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 397304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 397310 */     GIR_RootConstrainSelectedInstOperands,
     /* 397311 */     // GIR_Coverage, 6982,
     /* 397311 */     GIR_EraseRootFromParent_Done,
     /* 397312 */   // Label 7764: @397312
     /* 397312 */   GIM_Try, /*On fail goto*//*Label 7765*/ GIMT_Encode4(397376), // Rule ID 14084 //
     /* 397317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397329 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397333 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397338 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 397342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 397346 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397350 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 397354 */     // MIs[2] Rn
     /* 397354 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 397359 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 397363 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 397365 */     // (strict_fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 397365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 397368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 397374 */     GIR_RootConstrainSelectedInstOperands,
     /* 397375 */     // GIR_Coverage, 14084,
     /* 397375 */     GIR_EraseRootFromParent_Done,
     /* 397376 */   // Label 7765: @397376
     /* 397376 */   GIM_Try, /*On fail goto*//*Label 7766*/ GIMT_Encode4(397403), // Rule ID 587 //
     /* 397381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 397384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397392 */     // (strict_fadd:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FADDDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 397392 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDDrr),
     /* 397397 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397401 */     GIR_RootConstrainSelectedInstOperands,
     /* 397402 */     // GIR_Coverage, 587,
     /* 397402 */     GIR_Done,
     /* 397403 */   // Label 7766: @397403
     /* 397403 */   GIM_Reject,
     /* 397404 */ // Label 7763: @397404
     /* 397404 */ GIM_Reject,
     /* 397405 */ // Label 7749: @397405
     /* 397405 */ GIM_Try, /*On fail goto*//*Label 7767*/ GIMT_Encode4(397442), // Rule ID 1202 //
     /* 397410 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 397416 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 397419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397423 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397427 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397431 */   // (strict_fadd:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 397431 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f32),
     /* 397436 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397440 */   GIR_RootConstrainSelectedInstOperands,
     /* 397441 */   // GIR_Coverage, 1202,
     /* 397441 */   GIR_Done,
     /* 397442 */ // Label 7767: @397442
     /* 397442 */ GIM_Reject,
     /* 397443 */ // Label 7750: @397443
     /* 397443 */ GIM_Try, /*On fail goto*//*Label 7768*/ GIMT_Encode4(397480), // Rule ID 1206 //
     /* 397448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397454 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 397457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397461 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397465 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397469 */   // (strict_fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 397469 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f64),
     /* 397474 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397478 */   GIR_RootConstrainSelectedInstOperands,
     /* 397479 */   // GIR_Coverage, 1206,
     /* 397479 */   GIR_Done,
     /* 397480 */ // Label 7768: @397480
     /* 397480 */ GIM_Reject,
     /* 397481 */ // Label 7751: @397481
     /* 397481 */ GIM_Try, /*On fail goto*//*Label 7769*/ GIMT_Encode4(397518), // Rule ID 1198 //
     /* 397486 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 397489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 397492 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 397495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397499 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397503 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397507 */   // (strict_fadd:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 397507 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f16),
     /* 397512 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397516 */   GIR_RootConstrainSelectedInstOperands,
     /* 397517 */   // GIR_Coverage, 1198,
     /* 397517 */   GIR_Done,
     /* 397518 */ // Label 7769: @397518
     /* 397518 */ GIM_Reject,
     /* 397519 */ // Label 7752: @397519
     /* 397519 */ GIM_Try, /*On fail goto*//*Label 7770*/ GIMT_Encode4(397556), // Rule ID 1204 //
     /* 397524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397530 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 397533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397537 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397541 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397545 */   // (strict_fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 397545 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 397550 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397554 */   GIR_RootConstrainSelectedInstOperands,
     /* 397555 */   // GIR_Coverage, 1204,
     /* 397555 */   GIR_Done,
     /* 397556 */ // Label 7770: @397556
     /* 397556 */ GIM_Reject,
     /* 397557 */ // Label 7753: @397557
     /* 397557 */ GIM_Try, /*On fail goto*//*Label 7771*/ GIMT_Encode4(397854),
     /* 397562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 397568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397572 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397576 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397580 */   GIM_Try, /*On fail goto*//*Label 7772*/ GIMT_Encode4(397599), // Rule ID 1200 //
     /* 397585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 397588 */     // (strict_fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 397588 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv8f16),
     /* 397593 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397597 */     GIR_RootConstrainSelectedInstOperands,
     /* 397598 */     // GIR_Coverage, 1200,
     /* 397598 */     GIR_Done,
     /* 397599 */   // Label 7772: @397599
     /* 397599 */   GIM_Try, /*On fail goto*//*Label 7773*/ GIMT_Encode4(397853), // Rule ID 7081 //
     /* 397604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 397607 */     // (strict_fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FADDv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FADDv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 397607 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 397610 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 397614 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397619 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 397623 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 397625 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 397628 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 397632 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397637 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 397641 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 397643 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 397646 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 397650 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397655 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 397658 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 397661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 397663 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 397666 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 397670 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397675 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 397681 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397686 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397691 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 397694 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 397698 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397703 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 397706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 397708 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 397711 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 397715 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397720 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 397726 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397731 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397736 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 397739 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 397743 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397748 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 397751 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 397753 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 397756 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 397760 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397765 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 397768 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 397771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 397773 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 397776 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 397780 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397785 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 397788 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 397790 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 397793 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 397797 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397802 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 397804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 397807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 397811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397816 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 397819 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 397822 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 397825 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397830 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397835 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 397843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 397845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397848 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 397851 */     GIR_RootConstrainSelectedInstOperands,
     /* 397852 */     // GIR_Coverage, 7081,
     /* 397852 */     GIR_EraseRootFromParent_Done,
     /* 397853 */   // Label 7773: @397853
     /* 397853 */   GIM_Reject,
     /* 397854 */ // Label 7771: @397854
     /* 397854 */ GIM_Reject,
     /* 397855 */ // Label 7754: @397855
     /* 397855 */ GIM_Reject,
     /* 397856 */ // Label 105: @397856
     /* 397856 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7782*/ GIMT_Encode4(398471),
     /* 397867 */ /*GILLT_s16*//*Label 7774*/ GIMT_Encode4(397907),
     /* 397871 */ /*GILLT_s32*//*Label 7775*/ GIMT_Encode4(397945),
     /* 397875 */ /*GILLT_s64*//*Label 7776*/ GIMT_Encode4(397983), GIMT_Encode4(0),
     /* 397883 */ /*GILLT_v2s32*//*Label 7777*/ GIMT_Encode4(398021),
     /* 397887 */ /*GILLT_v2s64*//*Label 7778*/ GIMT_Encode4(398059),
     /* 397891 */ /*GILLT_v4s16*//*Label 7779*/ GIMT_Encode4(398097),
     /* 397895 */ /*GILLT_v4s32*//*Label 7780*/ GIMT_Encode4(398135), GIMT_Encode4(0),
     /* 397903 */ /*GILLT_v8s16*//*Label 7781*/ GIMT_Encode4(398173),
     /* 397907 */ // Label 7774: @397907
     /* 397907 */ GIM_Try, /*On fail goto*//*Label 7783*/ GIMT_Encode4(397944), // Rule ID 631 //
     /* 397912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 397915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 397918 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 397921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397925 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397929 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397933 */   // (strict_fsub:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FSUBHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 397933 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBHrr),
     /* 397938 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397942 */   GIR_RootConstrainSelectedInstOperands,
     /* 397943 */   // GIR_Coverage, 631,
     /* 397943 */   GIR_Done,
     /* 397944 */ // Label 7783: @397944
     /* 397944 */ GIM_Reject,
     /* 397945 */ // Label 7775: @397945
     /* 397945 */ GIM_Try, /*On fail goto*//*Label 7784*/ GIMT_Encode4(397982), // Rule ID 633 //
     /* 397950 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 397953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 397956 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 397959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397963 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397967 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397971 */   // (strict_fsub:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FSUBSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 397971 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBSrr),
     /* 397976 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397980 */   GIR_RootConstrainSelectedInstOperands,
     /* 397981 */   // GIR_Coverage, 633,
     /* 397981 */   GIR_Done,
     /* 397982 */ // Label 7784: @397982
     /* 397982 */ GIM_Reject,
     /* 397983 */ // Label 7776: @397983
     /* 397983 */ GIM_Try, /*On fail goto*//*Label 7785*/ GIMT_Encode4(398020), // Rule ID 635 //
     /* 397988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 397991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 397994 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 397997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398001 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398005 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398009 */   // (strict_fsub:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FSUBDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 398009 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBDrr),
     /* 398014 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 398018 */   GIR_RootConstrainSelectedInstOperands,
     /* 398019 */   // GIR_Coverage, 635,
     /* 398019 */   GIR_Done,
     /* 398020 */ // Label 7785: @398020
     /* 398020 */ GIM_Reject,
     /* 398021 */ // Label 7777: @398021
     /* 398021 */ GIM_Try, /*On fail goto*//*Label 7786*/ GIMT_Encode4(398058), // Rule ID 1342 //
     /* 398026 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 398032 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 398035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398039 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398043 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398047 */   // (strict_fsub:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FSUBv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 398047 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f32),
     /* 398052 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 398056 */   GIR_RootConstrainSelectedInstOperands,
     /* 398057 */   // GIR_Coverage, 1342,
     /* 398057 */   GIR_Done,
     /* 398058 */ // Label 7786: @398058
     /* 398058 */ GIM_Reject,
     /* 398059 */ // Label 7778: @398059
     /* 398059 */ GIM_Try, /*On fail goto*//*Label 7787*/ GIMT_Encode4(398096), // Rule ID 1346 //
     /* 398064 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 398070 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 398073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398077 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398081 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398085 */   // (strict_fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FSUBv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 398085 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f64),
     /* 398090 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 398094 */   GIR_RootConstrainSelectedInstOperands,
     /* 398095 */   // GIR_Coverage, 1346,
     /* 398095 */   GIR_Done,
     /* 398096 */ // Label 7787: @398096
     /* 398096 */ GIM_Reject,
     /* 398097 */ // Label 7779: @398097
     /* 398097 */ GIM_Try, /*On fail goto*//*Label 7788*/ GIMT_Encode4(398134), // Rule ID 1338 //
     /* 398102 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 398105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 398108 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 398111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398115 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398119 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398123 */   // (strict_fsub:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FSUBv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 398123 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f16),
     /* 398128 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 398132 */   GIR_RootConstrainSelectedInstOperands,
     /* 398133 */   // GIR_Coverage, 1338,
     /* 398133 */   GIR_Done,
     /* 398134 */ // Label 7788: @398134
     /* 398134 */ GIM_Reject,
     /* 398135 */ // Label 7780: @398135
     /* 398135 */ GIM_Try, /*On fail goto*//*Label 7789*/ GIMT_Encode4(398172), // Rule ID 1344 //
     /* 398140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398146 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 398149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398153 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398157 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398161 */   // (strict_fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FSUBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 398161 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 398166 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 398170 */   GIR_RootConstrainSelectedInstOperands,
     /* 398171 */   // GIR_Coverage, 1344,
     /* 398171 */   GIR_Done,
     /* 398172 */ // Label 7789: @398172
     /* 398172 */ GIM_Reject,
     /* 398173 */ // Label 7781: @398173
     /* 398173 */ GIM_Try, /*On fail goto*//*Label 7790*/ GIMT_Encode4(398470),
     /* 398178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398181 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 398184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398188 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398192 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398196 */   GIM_Try, /*On fail goto*//*Label 7791*/ GIMT_Encode4(398215), // Rule ID 1340 //
     /* 398201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 398204 */     // (strict_fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FSUBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 398204 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv8f16),
     /* 398209 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 398213 */     GIR_RootConstrainSelectedInstOperands,
     /* 398214 */     // GIR_Coverage, 1340,
     /* 398214 */     GIR_Done,
     /* 398215 */   // Label 7791: @398215
     /* 398215 */   GIM_Try, /*On fail goto*//*Label 7792*/ GIMT_Encode4(398469), // Rule ID 7087 //
     /* 398220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 398223 */     // (strict_fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FSUBv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FSUBv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 398223 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 398226 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 398230 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398235 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 398239 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 398241 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 398244 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 398248 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398253 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 398257 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 398259 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 398262 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 398266 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398271 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 398274 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 398277 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 398279 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 398282 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 398286 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398291 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 398297 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398302 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398307 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 398310 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 398314 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398319 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 398322 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 398324 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 398327 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 398331 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398336 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 398342 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398347 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398352 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 398355 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 398359 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398364 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 398367 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 398369 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 398372 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 398376 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398381 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 398384 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 398387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 398389 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 398392 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 398396 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398401 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 398404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 398406 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 398409 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 398413 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 398420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 398423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 398427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398432 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 398435 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 398438 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 398441 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398446 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398451 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 398459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 398461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 398464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 398467 */     GIR_RootConstrainSelectedInstOperands,
     /* 398468 */     // GIR_Coverage, 7087,
     /* 398468 */     GIR_EraseRootFromParent_Done,
     /* 398469 */   // Label 7792: @398469
     /* 398469 */   GIM_Reject,
     /* 398470 */ // Label 7790: @398470
     /* 398470 */ GIM_Reject,
     /* 398471 */ // Label 7782: @398471
     /* 398471 */ GIM_Reject,
     /* 398472 */ // Label 106: @398472
     /* 398472 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7801*/ GIMT_Encode4(402193),
     /* 398483 */ /*GILLT_s16*//*Label 7793*/ GIMT_Encode4(398523),
     /* 398487 */ /*GILLT_s32*//*Label 7794*/ GIMT_Encode4(399077),
     /* 398491 */ /*GILLT_s64*//*Label 7795*/ GIMT_Encode4(399625), GIMT_Encode4(0),
     /* 398499 */ /*GILLT_v2s32*//*Label 7796*/ GIMT_Encode4(400173),
     /* 398503 */ /*GILLT_v2s64*//*Label 7797*/ GIMT_Encode4(400703),
     /* 398507 */ /*GILLT_v4s16*//*Label 7798*/ GIMT_Encode4(401061),
     /* 398511 */ /*GILLT_v4s32*//*Label 7799*/ GIMT_Encode4(401403), GIMT_Encode4(0),
     /* 398519 */ /*GILLT_v8s16*//*Label 7800*/ GIMT_Encode4(401761),
     /* 398523 */ // Label 7793: @398523
     /* 398523 */ GIM_Try, /*On fail goto*//*Label 7802*/ GIMT_Encode4(399076),
     /* 398528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 398531 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 398534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 398538 */   GIM_Try, /*On fail goto*//*Label 7803*/ GIMT_Encode4(398651), // Rule ID 6306 //
     /* 398543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 398546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 398554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398558 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398562 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398567 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 398571 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 398575 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 398579 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398583 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 398587 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398592 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 398596 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398600 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 398604 */     // MIs[3] Operand 1
     /* 398604 */     // No operand predicates
     /* 398604 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398606 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 398606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 398609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 398613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398618 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 398624 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 398629 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 398637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 398642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 398646 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 398649 */     GIR_RootConstrainSelectedInstOperands,
     /* 398650 */     // GIR_Coverage, 6306,
     /* 398650 */     GIR_EraseRootFromParent_Done,
     /* 398651 */   // Label 7803: @398651
     /* 398651 */   GIM_Try, /*On fail goto*//*Label 7804*/ GIMT_Encode4(398764), // Rule ID 14065 //
     /* 398656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 398659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 398667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398671 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398675 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398684 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398688 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 398692 */     // MIs[2] Operand 1
     /* 398692 */     // No operand predicates
     /* 398692 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 398696 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 398700 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398704 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 398708 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398713 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 398717 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398719 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 398719 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 398722 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 398726 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398731 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 398737 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 398742 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 398750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398752 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 398755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 398762 */     GIR_RootConstrainSelectedInstOperands,
     /* 398763 */     // GIR_Coverage, 14065,
     /* 398763 */     GIR_EraseRootFromParent_Done,
     /* 398764 */   // Label 7804: @398764
     /* 398764 */   GIM_Try, /*On fail goto*//*Label 7805*/ GIMT_Encode4(398843), // Rule ID 13999 //
     /* 398769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 398772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 398780 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398784 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398793 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 398797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 398801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398803 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 398803 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 398806 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 398810 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398815 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 398821 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 398826 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 398834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 398838 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 398841 */     GIR_RootConstrainSelectedInstOperands,
     /* 398842 */     // GIR_Coverage, 13999,
     /* 398842 */     GIR_EraseRootFromParent_Done,
     /* 398843 */   // Label 7805: @398843
     /* 398843 */   GIM_Try, /*On fail goto*//*Label 7806*/ GIMT_Encode4(398922), // Rule ID 4863 //
     /* 398848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 398851 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 398855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 398863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398876 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 398880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398882 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 398882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 398885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 398889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398894 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 398900 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 398905 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 398913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398915 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398917 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 398920 */     GIR_RootConstrainSelectedInstOperands,
     /* 398921 */     // GIR_Coverage, 4863,
     /* 398921 */     GIR_EraseRootFromParent_Done,
     /* 398922 */   // Label 7806: @398922
     /* 398922 */   GIM_Try, /*On fail goto*//*Label 7807*/ GIMT_Encode4(398985), // Rule ID 13605 //
     /* 398927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 398930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 398938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398942 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 398951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398959 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 398963 */     // MIs[2] Operand 1
     /* 398963 */     // No operand predicates
     /* 398963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 398967 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 398969 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 398969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 398972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 398976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398980 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 398983 */     GIR_RootConstrainSelectedInstOperands,
     /* 398984 */     // GIR_Coverage, 13605,
     /* 398984 */     GIR_EraseRootFromParent_Done,
     /* 398985 */   // Label 7807: @398985
     /* 398985 */   GIM_Try, /*On fail goto*//*Label 7808*/ GIMT_Encode4(399048), // Rule ID 2011 //
     /* 398990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 398993 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 398997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 399001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 399005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399009 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 399013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 399018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399026 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 399030 */     // MIs[2] Operand 1
     /* 399030 */     // No operand predicates
     /* 399030 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 399032 */     // (strict_fmul:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 399032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 399035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399037 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399043 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 399046 */     GIR_RootConstrainSelectedInstOperands,
     /* 399047 */     // GIR_Coverage, 2011,
     /* 399047 */     GIR_EraseRootFromParent_Done,
     /* 399048 */   // Label 7808: @399048
     /* 399048 */   GIM_Try, /*On fail goto*//*Label 7809*/ GIMT_Encode4(399075), // Rule ID 619 //
     /* 399053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 399056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 399060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 399064 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 399064 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 399069 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399073 */     GIR_RootConstrainSelectedInstOperands,
     /* 399074 */     // GIR_Coverage, 619,
     /* 399074 */     GIR_Done,
     /* 399075 */   // Label 7809: @399075
     /* 399075 */   GIM_Reject,
     /* 399076 */ // Label 7802: @399076
     /* 399076 */ GIM_Reject,
     /* 399077 */ // Label 7794: @399077
     /* 399077 */ GIM_Try, /*On fail goto*//*Label 7810*/ GIMT_Encode4(399624),
     /* 399082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 399085 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 399088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399092 */   GIM_Try, /*On fail goto*//*Label 7811*/ GIMT_Encode4(399205), // Rule ID 6308 //
     /* 399097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 399108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399112 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 399116 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399121 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 399125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 399129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 399133 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399137 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 399141 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399146 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 399150 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399154 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 399158 */     // MIs[3] Operand 1
     /* 399158 */     // No operand predicates
     /* 399158 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399160 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 399160 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 399163 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 399167 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399172 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 399178 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399183 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 399191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399193 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 399196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 399200 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 399203 */     GIR_RootConstrainSelectedInstOperands,
     /* 399204 */     // GIR_Coverage, 6308,
     /* 399204 */     GIR_EraseRootFromParent_Done,
     /* 399205 */   // Label 7811: @399205
     /* 399205 */   GIM_Try, /*On fail goto*//*Label 7812*/ GIMT_Encode4(399318), // Rule ID 14067 //
     /* 399210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 399221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399225 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 399229 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399242 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 399246 */     // MIs[2] Operand 1
     /* 399246 */     // No operand predicates
     /* 399246 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 399250 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 399254 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399258 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 399262 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399267 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 399271 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399273 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 399273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 399276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 399280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399285 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 399291 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399296 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 399304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399306 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 399309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 399316 */     GIR_RootConstrainSelectedInstOperands,
     /* 399317 */     // GIR_Coverage, 14067,
     /* 399317 */     GIR_EraseRootFromParent_Done,
     /* 399318 */   // Label 7812: @399318
     /* 399318 */   GIM_Try, /*On fail goto*//*Label 7813*/ GIMT_Encode4(399394), // Rule ID 14001 //
     /* 399323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 399331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399335 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 399339 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399344 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 399348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399354 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 399354 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 399357 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 399361 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399366 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 399372 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399377 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 399385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 399389 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 399392 */     GIR_RootConstrainSelectedInstOperands,
     /* 399393 */     // GIR_Coverage, 14001,
     /* 399393 */     GIR_EraseRootFromParent_Done,
     /* 399394 */   // Label 7813: @399394
     /* 399394 */   GIM_Try, /*On fail goto*//*Label 7814*/ GIMT_Encode4(399470), // Rule ID 4865 //
     /* 399399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 399407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 399411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399415 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 399419 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399424 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 399428 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399430 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 399430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 399433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 399437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399442 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 399448 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399453 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 399461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399463 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399465 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 399468 */     GIR_RootConstrainSelectedInstOperands,
     /* 399469 */     // GIR_Coverage, 4865,
     /* 399469 */     GIR_EraseRootFromParent_Done,
     /* 399470 */   // Label 7814: @399470
     /* 399470 */   GIM_Try, /*On fail goto*//*Label 7815*/ GIMT_Encode4(399533), // Rule ID 13607 //
     /* 399475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 399486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399490 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 399494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399507 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 399511 */     // MIs[2] Operand 1
     /* 399511 */     // No operand predicates
     /* 399511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399515 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 399517 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 399517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 399520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 399524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399528 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 399531 */     GIR_RootConstrainSelectedInstOperands,
     /* 399532 */     // GIR_Coverage, 13607,
     /* 399532 */     GIR_EraseRootFromParent_Done,
     /* 399533 */   // Label 7815: @399533
     /* 399533 */   GIM_Try, /*On fail goto*//*Label 7816*/ GIMT_Encode4(399596), // Rule ID 2013 //
     /* 399538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 399549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 399553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399557 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 399561 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399566 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399570 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399574 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 399578 */     // MIs[2] Operand 1
     /* 399578 */     // No operand predicates
     /* 399578 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 399580 */     // (strict_fmul:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 399580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 399583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399585 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 399594 */     GIR_RootConstrainSelectedInstOperands,
     /* 399595 */     // GIR_Coverage, 2013,
     /* 399595 */     GIR_EraseRootFromParent_Done,
     /* 399596 */   // Label 7816: @399596
     /* 399596 */   GIM_Try, /*On fail goto*//*Label 7817*/ GIMT_Encode4(399623), // Rule ID 621 //
     /* 399601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 399604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399612 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 399612 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 399617 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399621 */     GIR_RootConstrainSelectedInstOperands,
     /* 399622 */     // GIR_Coverage, 621,
     /* 399622 */     GIR_Done,
     /* 399623 */   // Label 7817: @399623
     /* 399623 */   GIM_Reject,
     /* 399624 */ // Label 7810: @399624
     /* 399624 */ GIM_Reject,
     /* 399625 */ // Label 7795: @399625
     /* 399625 */ GIM_Try, /*On fail goto*//*Label 7818*/ GIMT_Encode4(400172),
     /* 399630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 399633 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 399636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399640 */   GIM_Try, /*On fail goto*//*Label 7819*/ GIMT_Encode4(399753), // Rule ID 6310 //
     /* 399645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 399656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 399660 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 399664 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399669 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 399673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 399677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 399681 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 399685 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 399689 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399694 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 399698 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399702 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 399706 */     // MIs[3] Operand 1
     /* 399706 */     // No operand predicates
     /* 399706 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399708 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 399708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 399711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 399715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399720 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 399726 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399731 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 399739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 399744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 399748 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 399751 */     GIR_RootConstrainSelectedInstOperands,
     /* 399752 */     // GIR_Coverage, 6310,
     /* 399752 */     GIR_EraseRootFromParent_Done,
     /* 399753 */   // Label 7819: @399753
     /* 399753 */   GIM_Try, /*On fail goto*//*Label 7820*/ GIMT_Encode4(399866), // Rule ID 14069 //
     /* 399758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 399769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 399773 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 399777 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399782 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399786 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399790 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 399794 */     // MIs[2] Operand 1
     /* 399794 */     // No operand predicates
     /* 399794 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 399798 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 399802 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 399806 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 399810 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399815 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 399819 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399821 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 399821 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 399824 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 399828 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399833 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 399839 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399844 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 399852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 399857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 399864 */     GIR_RootConstrainSelectedInstOperands,
     /* 399865 */     // GIR_Coverage, 14069,
     /* 399865 */     GIR_EraseRootFromParent_Done,
     /* 399866 */   // Label 7820: @399866
     /* 399866 */   GIM_Try, /*On fail goto*//*Label 7821*/ GIMT_Encode4(399942), // Rule ID 14003 //
     /* 399871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 399879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 399883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 399887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399892 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 399896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399900 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399902 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 399902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 399905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 399909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399914 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 399920 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399925 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 399933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 399937 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 399940 */     GIR_RootConstrainSelectedInstOperands,
     /* 399941 */     // GIR_Coverage, 14003,
     /* 399941 */     GIR_EraseRootFromParent_Done,
     /* 399942 */   // Label 7821: @399942
     /* 399942 */   GIM_Try, /*On fail goto*//*Label 7822*/ GIMT_Encode4(400018), // Rule ID 4867 //
     /* 399947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 399955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 399959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 399963 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 399967 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399972 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 399976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399978 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 399978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 399981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 399985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399990 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 399996 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400001 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 400009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400011 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 400016 */     GIR_RootConstrainSelectedInstOperands,
     /* 400017 */     // GIR_Coverage, 4867,
     /* 400017 */     GIR_EraseRootFromParent_Done,
     /* 400018 */   // Label 7822: @400018
     /* 400018 */   GIM_Try, /*On fail goto*//*Label 7823*/ GIMT_Encode4(400081), // Rule ID 13609 //
     /* 400023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 400034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 400038 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 400042 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400047 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 400051 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400055 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 400059 */     // MIs[2] Operand 1
     /* 400059 */     // No operand predicates
     /* 400059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400063 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 400065 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 400068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 400072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 400076 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 400079 */     GIR_RootConstrainSelectedInstOperands,
     /* 400080 */     // GIR_Coverage, 13609,
     /* 400080 */     GIR_EraseRootFromParent_Done,
     /* 400081 */   // Label 7823: @400081
     /* 400081 */   GIM_Try, /*On fail goto*//*Label 7824*/ GIMT_Encode4(400144), // Rule ID 2015 //
     /* 400086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 400101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 400105 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 400109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 400118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400122 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 400126 */     // MIs[2] Operand 1
     /* 400126 */     // No operand predicates
     /* 400126 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 400128 */     // (strict_fmul:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 400131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400133 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 400139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 400142 */     GIR_RootConstrainSelectedInstOperands,
     /* 400143 */     // GIR_Coverage, 2015,
     /* 400143 */     GIR_EraseRootFromParent_Done,
     /* 400144 */   // Label 7824: @400144
     /* 400144 */   GIM_Try, /*On fail goto*//*Label 7825*/ GIMT_Encode4(400171), // Rule ID 623 //
     /* 400149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 400152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400160 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 400160 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 400165 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400169 */     GIR_RootConstrainSelectedInstOperands,
     /* 400170 */     // GIR_Coverage, 623,
     /* 400170 */     GIR_Done,
     /* 400171 */   // Label 7825: @400171
     /* 400171 */   GIM_Reject,
     /* 400172 */ // Label 7818: @400172
     /* 400172 */ GIM_Reject,
     /* 400173 */ // Label 7796: @400173
     /* 400173 */ GIM_Try, /*On fail goto*//*Label 7826*/ GIMT_Encode4(400702),
     /* 400178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 400181 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 400184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400188 */   GIM_Try, /*On fail goto*//*Label 7827*/ GIMT_Encode4(400274), // Rule ID 13597 //
     /* 400193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 400204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 400212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 400216 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400220 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 400224 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400229 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 400233 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400237 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 400241 */     // MIs[3] Operand 1
     /* 400241 */     // No operand predicates
     /* 400241 */     // MIs[1] Operand 2
     /* 400241 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 400252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400256 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400258 */     // (strict_fmul:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 400261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 400265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 400269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 400272 */     GIR_RootConstrainSelectedInstOperands,
     /* 400273 */     // GIR_Coverage, 13597,
     /* 400273 */     GIR_EraseRootFromParent_Done,
     /* 400274 */   // Label 7827: @400274
     /* 400274 */   GIM_Try, /*On fail goto*//*Label 7828*/ GIMT_Encode4(400360), // Rule ID 2003 //
     /* 400279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 400294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 400302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 400306 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400310 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 400314 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400319 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 400323 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400327 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 400331 */     // MIs[3] Operand 1
     /* 400331 */     // No operand predicates
     /* 400331 */     // MIs[1] Operand 2
     /* 400331 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 400342 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400344 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 400347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400349 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 400355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 400358 */     GIR_RootConstrainSelectedInstOperands,
     /* 400359 */     // GIR_Coverage, 2003,
     /* 400359 */     GIR_EraseRootFromParent_Done,
     /* 400360 */   // Label 7828: @400360
     /* 400360 */   GIM_Try, /*On fail goto*//*Label 7829*/ GIMT_Encode4(400423), // Rule ID 13598 //
     /* 400365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 400376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400380 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 400384 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 400393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400397 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 400401 */     // MIs[2] Operand 1
     /* 400401 */     // No operand predicates
     /* 400401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400405 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 400407 */     // (strict_fmul:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 400410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 400414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 400418 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 400421 */     GIR_RootConstrainSelectedInstOperands,
     /* 400422 */     // GIR_Coverage, 13598,
     /* 400422 */     GIR_EraseRootFromParent_Done,
     /* 400423 */   // Label 7829: @400423
     /* 400423 */   GIM_Try, /*On fail goto*//*Label 7830*/ GIMT_Encode4(400486), // Rule ID 2004 //
     /* 400428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 400443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400447 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 400451 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 400460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400464 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 400468 */     // MIs[2] Operand 1
     /* 400468 */     // No operand predicates
     /* 400468 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 400470 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 400473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400475 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 400481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 400484 */     GIR_RootConstrainSelectedInstOperands,
     /* 400485 */     // GIR_Coverage, 2004,
     /* 400485 */     GIR_EraseRootFromParent_Done,
     /* 400486 */   // Label 7830: @400486
     /* 400486 */   GIM_Try, /*On fail goto*//*Label 7831*/ GIMT_Encode4(400580), // Rule ID 14071 //
     /* 400491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 400499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 400503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 400508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400514 */     // (strict_fmul:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 400514 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 400517 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 400521 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400526 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 400528 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 400531 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 400535 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400540 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 400543 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 400547 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 400550 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400555 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400560 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 400565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 400568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 400572 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 400575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400578 */     GIR_RootConstrainSelectedInstOperands,
     /* 400579 */     // GIR_Coverage, 14071,
     /* 400579 */     GIR_EraseRootFromParent_Done,
     /* 400580 */   // Label 7831: @400580
     /* 400580 */   GIM_Try, /*On fail goto*//*Label 7832*/ GIMT_Encode4(400674), // Rule ID 6312 //
     /* 400585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 400597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 400601 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 400606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400608 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 400608 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 400611 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 400615 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400620 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 400622 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 400625 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 400629 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400634 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 400637 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 400641 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 400644 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400649 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400654 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 400659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 400662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400664 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400666 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 400669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400672 */     GIR_RootConstrainSelectedInstOperands,
     /* 400673 */     // GIR_Coverage, 6312,
     /* 400673 */     GIR_EraseRootFromParent_Done,
     /* 400674 */   // Label 7832: @400674
     /* 400674 */   GIM_Try, /*On fail goto*//*Label 7833*/ GIMT_Encode4(400701), // Rule ID 1322 //
     /* 400679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400690 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 400690 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f32),
     /* 400695 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400699 */     GIR_RootConstrainSelectedInstOperands,
     /* 400700 */     // GIR_Coverage, 1322,
     /* 400700 */     GIR_Done,
     /* 400701 */   // Label 7833: @400701
     /* 400701 */   GIM_Reject,
     /* 400702 */ // Label 7826: @400702
     /* 400702 */ GIM_Reject,
     /* 400703 */ // Label 7797: @400703
     /* 400703 */ GIM_Try, /*On fail goto*//*Label 7834*/ GIMT_Encode4(401060),
     /* 400708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 400711 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 400714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400718 */   GIM_Try, /*On fail goto*//*Label 7835*/ GIMT_Encode4(400781), // Rule ID 13603 //
     /* 400723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 400734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 400738 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 400742 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 400751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400755 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 400759 */     // MIs[2] Operand 1
     /* 400759 */     // No operand predicates
     /* 400759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400763 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 400765 */     // (strict_fmul:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 400768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 400772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 400776 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 400779 */     GIR_RootConstrainSelectedInstOperands,
     /* 400780 */     // GIR_Coverage, 13603,
     /* 400780 */     GIR_EraseRootFromParent_Done,
     /* 400781 */   // Label 7835: @400781
     /* 400781 */   GIM_Try, /*On fail goto*//*Label 7836*/ GIMT_Encode4(400844), // Rule ID 2009 //
     /* 400786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400789 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 400801 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 400805 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 400809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 400818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400822 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 400826 */     // MIs[2] Operand 1
     /* 400826 */     // No operand predicates
     /* 400826 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 400828 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 400831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400833 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 400839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 400842 */     GIR_RootConstrainSelectedInstOperands,
     /* 400843 */     // GIR_Coverage, 2009,
     /* 400843 */     GIR_EraseRootFromParent_Done,
     /* 400844 */   // Label 7836: @400844
     /* 400844 */   GIM_Try, /*On fail goto*//*Label 7837*/ GIMT_Encode4(400938), // Rule ID 14075 //
     /* 400849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 400857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 400861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400872 */     // (strict_fmul:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 400872 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 400875 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 400879 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400884 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 400886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 400889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 400893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400898 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 400901 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 400905 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 400908 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400913 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400918 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 400926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 400930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 400933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400936 */     GIR_RootConstrainSelectedInstOperands,
     /* 400937 */     // GIR_Coverage, 14075,
     /* 400937 */     GIR_EraseRootFromParent_Done,
     /* 400938 */   // Label 7837: @400938
     /* 400938 */   GIM_Try, /*On fail goto*//*Label 7838*/ GIMT_Encode4(401032), // Rule ID 6316 //
     /* 400943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 400955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 400959 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400966 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 400966 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 400969 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 400973 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400978 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 400980 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 400983 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 400987 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400992 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 400995 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 400999 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 401002 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401007 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401012 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 401020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401022 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 401024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 401027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401030 */     GIR_RootConstrainSelectedInstOperands,
     /* 401031 */     // GIR_Coverage, 6316,
     /* 401031 */     GIR_EraseRootFromParent_Done,
     /* 401032 */   // Label 7838: @401032
     /* 401032 */   GIM_Try, /*On fail goto*//*Label 7839*/ GIMT_Encode4(401059), // Rule ID 1326 //
     /* 401037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401048 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 401048 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f64),
     /* 401053 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401057 */     GIR_RootConstrainSelectedInstOperands,
     /* 401058 */     // GIR_Coverage, 1326,
     /* 401058 */     GIR_Done,
     /* 401059 */   // Label 7839: @401059
     /* 401059 */   GIM_Reject,
     /* 401060 */ // Label 7834: @401060
     /* 401060 */ GIM_Reject,
     /* 401061 */ // Label 7798: @401061
     /* 401061 */ GIM_Try, /*On fail goto*//*Label 7840*/ GIMT_Encode4(401402),
     /* 401066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 401069 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 401072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401076 */   GIM_Try, /*On fail goto*//*Label 7841*/ GIMT_Encode4(401162), // Rule ID 13591 //
     /* 401081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 401092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 401100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 401104 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401108 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 401112 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 401117 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 401121 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401125 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 401129 */     // MIs[3] Operand 1
     /* 401129 */     // No operand predicates
     /* 401129 */     // MIs[1] Operand 2
     /* 401129 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 401140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401144 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 401146 */     // (strict_fmul:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 401146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 401149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 401153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 401157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 401160 */     GIR_RootConstrainSelectedInstOperands,
     /* 401161 */     // GIR_Coverage, 13591,
     /* 401161 */     GIR_EraseRootFromParent_Done,
     /* 401162 */   // Label 7841: @401162
     /* 401162 */   GIM_Try, /*On fail goto*//*Label 7842*/ GIMT_Encode4(401248), // Rule ID 1997 //
     /* 401167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 401178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 401182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401186 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 401190 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 401194 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401198 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 401202 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 401207 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 401211 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401215 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 401219 */     // MIs[3] Operand 1
     /* 401219 */     // No operand predicates
     /* 401219 */     // MIs[1] Operand 2
     /* 401219 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 401230 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 401232 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 401232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 401235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401237 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 401239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 401243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 401246 */     GIR_RootConstrainSelectedInstOperands,
     /* 401247 */     // GIR_Coverage, 1997,
     /* 401247 */     GIR_EraseRootFromParent_Done,
     /* 401248 */   // Label 7842: @401248
     /* 401248 */   GIM_Try, /*On fail goto*//*Label 7843*/ GIMT_Encode4(401311), // Rule ID 13592 //
     /* 401253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 401264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 401272 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 401277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 401281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401285 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 401289 */     // MIs[2] Operand 1
     /* 401289 */     // No operand predicates
     /* 401289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401293 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 401295 */     // (strict_fmul:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 401295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 401298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 401302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 401306 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 401309 */     GIR_RootConstrainSelectedInstOperands,
     /* 401310 */     // GIR_Coverage, 13592,
     /* 401310 */     GIR_EraseRootFromParent_Done,
     /* 401311 */   // Label 7843: @401311
     /* 401311 */   GIM_Try, /*On fail goto*//*Label 7844*/ GIMT_Encode4(401374), // Rule ID 1998 //
     /* 401316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 401327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 401331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401335 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 401339 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 401344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 401348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401352 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 401356 */     // MIs[2] Operand 1
     /* 401356 */     // No operand predicates
     /* 401356 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 401358 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 401358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 401361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401363 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 401365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 401369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 401372 */     GIR_RootConstrainSelectedInstOperands,
     /* 401373 */     // GIR_Coverage, 1998,
     /* 401373 */     GIR_EraseRootFromParent_Done,
     /* 401374 */   // Label 7844: @401374
     /* 401374 */   GIM_Try, /*On fail goto*//*Label 7845*/ GIMT_Encode4(401401), // Rule ID 1318 //
     /* 401379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401390 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 401390 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f16),
     /* 401395 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401399 */     GIR_RootConstrainSelectedInstOperands,
     /* 401400 */     // GIR_Coverage, 1318,
     /* 401400 */     GIR_Done,
     /* 401401 */   // Label 7845: @401401
     /* 401401 */   GIM_Reject,
     /* 401402 */ // Label 7840: @401402
     /* 401402 */ GIM_Reject,
     /* 401403 */ // Label 7799: @401403
     /* 401403 */ GIM_Try, /*On fail goto*//*Label 7846*/ GIMT_Encode4(401760),
     /* 401408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 401411 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 401414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401418 */   GIM_Try, /*On fail goto*//*Label 7847*/ GIMT_Encode4(401481), // Rule ID 13601 //
     /* 401423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 401434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 401438 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 401442 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 401451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401455 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 401459 */     // MIs[2] Operand 1
     /* 401459 */     // No operand predicates
     /* 401459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401463 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 401465 */     // (strict_fmul:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 401465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 401468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 401472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 401476 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 401479 */     GIR_RootConstrainSelectedInstOperands,
     /* 401480 */     // GIR_Coverage, 13601,
     /* 401480 */     GIR_EraseRootFromParent_Done,
     /* 401481 */   // Label 7847: @401481
     /* 401481 */   GIM_Try, /*On fail goto*//*Label 7848*/ GIMT_Encode4(401544), // Rule ID 2007 //
     /* 401486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401489 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 401497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 401501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 401505 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 401509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 401518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401522 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 401526 */     // MIs[2] Operand 1
     /* 401526 */     // No operand predicates
     /* 401526 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 401528 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 401528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 401531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401533 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 401535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 401539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 401542 */     GIR_RootConstrainSelectedInstOperands,
     /* 401543 */     // GIR_Coverage, 2007,
     /* 401543 */     GIR_EraseRootFromParent_Done,
     /* 401544 */   // Label 7848: @401544
     /* 401544 */   GIM_Try, /*On fail goto*//*Label 7849*/ GIMT_Encode4(401638), // Rule ID 14073 //
     /* 401549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 401557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 401561 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 401566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401570 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401572 */     // (strict_fmul:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 401572 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 401575 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 401579 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 401586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 401589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 401593 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401598 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 401601 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 401605 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 401608 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401613 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401618 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 401623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 401626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 401630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 401633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401636 */     GIR_RootConstrainSelectedInstOperands,
     /* 401637 */     // GIR_Coverage, 14073,
     /* 401637 */     GIR_EraseRootFromParent_Done,
     /* 401638 */   // Label 7849: @401638
     /* 401638 */   GIM_Try, /*On fail goto*//*Label 7850*/ GIMT_Encode4(401732), // Rule ID 6314 //
     /* 401643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 401651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 401655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 401659 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 401664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401666 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 401666 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 401669 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 401673 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401678 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 401680 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 401683 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 401687 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401692 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 401695 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 401699 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 401702 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401707 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401712 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 401717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 401720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401722 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 401724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 401727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401730 */     GIR_RootConstrainSelectedInstOperands,
     /* 401731 */     // GIR_Coverage, 6314,
     /* 401731 */     GIR_EraseRootFromParent_Done,
     /* 401732 */   // Label 7850: @401732
     /* 401732 */   GIM_Try, /*On fail goto*//*Label 7851*/ GIMT_Encode4(401759), // Rule ID 1324 //
     /* 401737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401748 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 401748 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 401753 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401757 */     GIR_RootConstrainSelectedInstOperands,
     /* 401758 */     // GIR_Coverage, 1324,
     /* 401758 */     GIR_Done,
     /* 401759 */   // Label 7851: @401759
     /* 401759 */   GIM_Reject,
     /* 401760 */ // Label 7846: @401760
     /* 401760 */ GIM_Reject,
     /* 401761 */ // Label 7800: @401761
     /* 401761 */ GIM_Try, /*On fail goto*//*Label 7852*/ GIMT_Encode4(402192),
     /* 401766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401769 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 401772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401776 */   GIM_Try, /*On fail goto*//*Label 7853*/ GIMT_Encode4(401839), // Rule ID 13595 //
     /* 401781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 401792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401796 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 401800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 401805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 401809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401813 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 401817 */     // MIs[2] Operand 1
     /* 401817 */     // No operand predicates
     /* 401817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401821 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 401823 */     // (strict_fmul:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 401823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 401826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 401830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 401834 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 401837 */     GIR_RootConstrainSelectedInstOperands,
     /* 401838 */     // GIR_Coverage, 13595,
     /* 401838 */     GIR_EraseRootFromParent_Done,
     /* 401839 */   // Label 7853: @401839
     /* 401839 */   GIM_Try, /*On fail goto*//*Label 7854*/ GIMT_Encode4(401902), // Rule ID 2001 //
     /* 401844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 401855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 401859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 401867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 401872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 401876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401880 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 401884 */     // MIs[2] Operand 1
     /* 401884 */     // No operand predicates
     /* 401884 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 401886 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 401886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 401889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401891 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 401893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 401897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 401900 */     GIR_RootConstrainSelectedInstOperands,
     /* 401901 */     // GIR_Coverage, 2001,
     /* 401901 */     GIR_EraseRootFromParent_Done,
     /* 401902 */   // Label 7854: @401902
     /* 401902 */   GIM_Try, /*On fail goto*//*Label 7855*/ GIMT_Encode4(401929), // Rule ID 1320 //
     /* 401907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401918 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 401918 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv8f16),
     /* 401923 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401927 */     GIR_RootConstrainSelectedInstOperands,
     /* 401928 */     // GIR_Coverage, 1320,
     /* 401928 */     GIR_Done,
     /* 401929 */   // Label 7855: @401929
     /* 401929 */   GIM_Try, /*On fail goto*//*Label 7856*/ GIMT_Encode4(402191), // Rule ID 7085 //
     /* 401934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 401937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401945 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FMULv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FMULv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 401945 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 401948 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 401952 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401957 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 401961 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 401963 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 401966 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 401970 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401975 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 401979 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 401981 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 401984 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 401988 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401993 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 401996 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 401999 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 402001 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 402004 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402008 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402013 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 402019 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402024 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402029 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 402032 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 402036 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402041 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 402044 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 402046 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 402049 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402053 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402058 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 402064 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402069 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402074 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 402077 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 402081 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402086 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 402089 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 402091 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 402094 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 402098 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402103 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 402106 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 402109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 402111 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 402114 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 402118 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402123 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 402126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 402128 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 402131 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 402135 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 402142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 402145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 402149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402154 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 402157 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 402160 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 402163 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402168 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402173 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 402181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 402183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 402186 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 402189 */     GIR_RootConstrainSelectedInstOperands,
     /* 402190 */     // GIR_Coverage, 7085,
     /* 402190 */     GIR_EraseRootFromParent_Done,
     /* 402191 */   // Label 7856: @402191
     /* 402191 */   GIM_Reject,
     /* 402192 */ // Label 7852: @402192
     /* 402192 */ GIM_Reject,
     /* 402193 */ // Label 7801: @402193
     /* 402193 */ GIM_Reject,
     /* 402194 */ // Label 107: @402194
     /* 402194 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7865*/ GIMT_Encode4(402809),
     /* 402205 */ /*GILLT_s16*//*Label 7857*/ GIMT_Encode4(402245),
     /* 402209 */ /*GILLT_s32*//*Label 7858*/ GIMT_Encode4(402283),
     /* 402213 */ /*GILLT_s64*//*Label 7859*/ GIMT_Encode4(402321), GIMT_Encode4(0),
     /* 402221 */ /*GILLT_v2s32*//*Label 7860*/ GIMT_Encode4(402359),
     /* 402225 */ /*GILLT_v2s64*//*Label 7861*/ GIMT_Encode4(402397),
     /* 402229 */ /*GILLT_v4s16*//*Label 7862*/ GIMT_Encode4(402435),
     /* 402233 */ /*GILLT_v4s32*//*Label 7863*/ GIMT_Encode4(402473), GIMT_Encode4(0),
     /* 402241 */ /*GILLT_v8s16*//*Label 7864*/ GIMT_Encode4(402511),
     /* 402245 */ // Label 7857: @402245
     /* 402245 */ GIM_Try, /*On fail goto*//*Label 7866*/ GIMT_Encode4(402282), // Rule ID 589 //
     /* 402250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 402253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 402256 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 402259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402263 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402267 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402271 */   // (strict_fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FDIVHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 402271 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVHrr),
     /* 402276 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402280 */   GIR_RootConstrainSelectedInstOperands,
     /* 402281 */   // GIR_Coverage, 589,
     /* 402281 */   GIR_Done,
     /* 402282 */ // Label 7866: @402282
     /* 402282 */ GIM_Reject,
     /* 402283 */ // Label 7858: @402283
     /* 402283 */ GIM_Try, /*On fail goto*//*Label 7867*/ GIMT_Encode4(402320), // Rule ID 591 //
     /* 402288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 402291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 402294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 402297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 402301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 402305 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 402309 */   // (strict_fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FDIVSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 402309 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVSrr),
     /* 402314 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402318 */   GIR_RootConstrainSelectedInstOperands,
     /* 402319 */   // GIR_Coverage, 591,
     /* 402319 */   GIR_Done,
     /* 402320 */ // Label 7867: @402320
     /* 402320 */ GIM_Reject,
     /* 402321 */ // Label 7859: @402321
     /* 402321 */ GIM_Try, /*On fail goto*//*Label 7868*/ GIMT_Encode4(402358), // Rule ID 593 //
     /* 402326 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 402329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 402332 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 402335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402339 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402343 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402347 */   // (strict_fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FDIVDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 402347 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVDrr),
     /* 402352 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402356 */   GIR_RootConstrainSelectedInstOperands,
     /* 402357 */   // GIR_Coverage, 593,
     /* 402357 */   GIR_Done,
     /* 402358 */ // Label 7868: @402358
     /* 402358 */ GIM_Reject,
     /* 402359 */ // Label 7860: @402359
     /* 402359 */ GIM_Try, /*On fail goto*//*Label 7869*/ GIMT_Encode4(402396), // Rule ID 1227 //
     /* 402364 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 402370 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 402373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402377 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402381 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402385 */   // (strict_fdiv:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FDIVv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 402385 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f32),
     /* 402390 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402394 */   GIR_RootConstrainSelectedInstOperands,
     /* 402395 */   // GIR_Coverage, 1227,
     /* 402395 */   GIR_Done,
     /* 402396 */ // Label 7869: @402396
     /* 402396 */ GIM_Reject,
     /* 402397 */ // Label 7861: @402397
     /* 402397 */ GIM_Try, /*On fail goto*//*Label 7870*/ GIMT_Encode4(402434), // Rule ID 1231 //
     /* 402402 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 402408 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 402411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402419 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402423 */   // (strict_fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FDIVv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 402423 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f64),
     /* 402428 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402432 */   GIR_RootConstrainSelectedInstOperands,
     /* 402433 */   // GIR_Coverage, 1231,
     /* 402433 */   GIR_Done,
     /* 402434 */ // Label 7870: @402434
     /* 402434 */ GIM_Reject,
     /* 402435 */ // Label 7862: @402435
     /* 402435 */ GIM_Try, /*On fail goto*//*Label 7871*/ GIMT_Encode4(402472), // Rule ID 1223 //
     /* 402440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 402446 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 402449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402453 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402457 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402461 */   // (strict_fdiv:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FDIVv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 402461 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f16),
     /* 402466 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402470 */   GIR_RootConstrainSelectedInstOperands,
     /* 402471 */   // GIR_Coverage, 1223,
     /* 402471 */   GIR_Done,
     /* 402472 */ // Label 7871: @402472
     /* 402472 */ GIM_Reject,
     /* 402473 */ // Label 7863: @402473
     /* 402473 */ GIM_Try, /*On fail goto*//*Label 7872*/ GIMT_Encode4(402510), // Rule ID 1229 //
     /* 402478 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 402484 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 402487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402491 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402495 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402499 */   // (strict_fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FDIVv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 402499 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 402504 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402508 */   GIR_RootConstrainSelectedInstOperands,
     /* 402509 */   // GIR_Coverage, 1229,
     /* 402509 */   GIR_Done,
     /* 402510 */ // Label 7872: @402510
     /* 402510 */ GIM_Reject,
     /* 402511 */ // Label 7864: @402511
     /* 402511 */ GIM_Try, /*On fail goto*//*Label 7873*/ GIMT_Encode4(402808),
     /* 402516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402519 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 402522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402530 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402534 */   GIM_Try, /*On fail goto*//*Label 7874*/ GIMT_Encode4(402553), // Rule ID 1225 //
     /* 402539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402542 */     // (strict_fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FDIVv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 402542 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv8f16),
     /* 402547 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402551 */     GIR_RootConstrainSelectedInstOperands,
     /* 402552 */     // GIR_Coverage, 1225,
     /* 402552 */     GIR_Done,
     /* 402553 */   // Label 7874: @402553
     /* 402553 */   GIM_Try, /*On fail goto*//*Label 7875*/ GIMT_Encode4(402807), // Rule ID 7083 //
     /* 402558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 402561 */     // (strict_fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FDIVv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FDIVv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 402561 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 402564 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 402568 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402573 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 402577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 402579 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 402582 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 402586 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402591 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 402595 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 402597 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 402600 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 402604 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402609 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 402612 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 402615 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 402617 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 402620 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402624 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402629 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 402635 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402640 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402645 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 402648 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 402652 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402657 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 402660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 402662 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 402665 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402669 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402674 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 402680 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402685 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402690 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 402693 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 402697 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402702 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 402705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 402707 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 402710 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 402714 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402719 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 402722 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 402725 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 402727 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 402730 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 402734 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402739 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 402742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 402744 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 402747 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 402751 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402756 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 402758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 402761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 402765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402770 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 402773 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 402776 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 402779 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402784 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402789 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 402797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 402799 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 402802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 402805 */     GIR_RootConstrainSelectedInstOperands,
     /* 402806 */     // GIR_Coverage, 7083,
     /* 402806 */     GIR_EraseRootFromParent_Done,
     /* 402807 */   // Label 7875: @402807
     /* 402807 */   GIM_Reject,
     /* 402808 */ // Label 7873: @402808
     /* 402808 */ GIM_Reject,
     /* 402809 */ // Label 7865: @402809
     /* 402809 */ GIM_Reject,
     /* 402810 */ // Label 108: @402810
     /* 402810 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7884*/ GIMT_Encode4(418416),
     /* 402821 */ /*GILLT_s16*//*Label 7876*/ GIMT_Encode4(402861),
     /* 402825 */ /*GILLT_s32*//*Label 7877*/ GIMT_Encode4(405635),
     /* 402829 */ /*GILLT_s64*//*Label 7878*/ GIMT_Encode4(408565), GIMT_Encode4(0),
     /* 402837 */ /*GILLT_v2s32*//*Label 7879*/ GIMT_Encode4(411495),
     /* 402841 */ /*GILLT_v2s64*//*Label 7880*/ GIMT_Encode4(413016),
     /* 402845 */ /*GILLT_v4s16*//*Label 7881*/ GIMT_Encode4(414537),
     /* 402849 */ /*GILLT_v4s32*//*Label 7882*/ GIMT_Encode4(415716), GIMT_Encode4(0),
     /* 402857 */ /*GILLT_v8s16*//*Label 7883*/ GIMT_Encode4(417237),
     /* 402861 */ // Label 7876: @402861
     /* 402861 */ GIM_Try, /*On fail goto*//*Label 7885*/ GIMT_Encode4(405634),
     /* 402866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 402869 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 402872 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 402875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402879 */   GIM_Try, /*On fail goto*//*Label 7886*/ GIMT_Encode4(403029), // Rule ID 4925 //
     /* 402884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 402887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402899 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 402903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402908 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 402912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 402916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402920 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402924 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 402928 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402933 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 402937 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 402941 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 402945 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 402949 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402954 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 402956 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 402956 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 402959 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402963 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402968 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 402974 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402979 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 402987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402996 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 403002 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403007 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 403015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403017 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403020 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 403023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 403027 */     GIR_RootConstrainSelectedInstOperands,
     /* 403028 */     // GIR_Coverage, 4925,
     /* 403028 */     GIR_EraseRootFromParent_Done,
     /* 403029 */   // Label 7886: @403029
     /* 403029 */   GIM_Try, /*On fail goto*//*Label 7887*/ GIMT_Encode4(403176), // Rule ID 4889 //
     /* 403034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 403037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403049 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 403053 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403058 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 403062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 403066 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403070 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 403074 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 403078 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403082 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403086 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 403090 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403095 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 403099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403103 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403105 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 403105 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 403108 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403112 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403117 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 403123 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403128 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403133 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 403136 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403140 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403145 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 403151 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403156 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 403164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403166 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 403172 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 403174 */     GIR_RootConstrainSelectedInstOperands,
     /* 403175 */     // GIR_Coverage, 4889,
     /* 403175 */     GIR_EraseRootFromParent_Done,
     /* 403176 */   // Label 7887: @403176
     /* 403176 */   GIM_Try, /*On fail goto*//*Label 7888*/ GIMT_Encode4(403323), // Rule ID 14012 //
     /* 403181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 403184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 403196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 403200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403204 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403208 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 403212 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403217 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 403221 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 403225 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403229 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403233 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 403237 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403242 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 403246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403250 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403252 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 403252 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 403255 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403259 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403264 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 403270 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403275 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403280 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 403283 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403287 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403292 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 403298 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403303 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 403311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403316 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 403319 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 403321 */     GIR_RootConstrainSelectedInstOperands,
     /* 403322 */     // GIR_Coverage, 14012,
     /* 403322 */     GIR_EraseRootFromParent_Done,
     /* 403323 */   // Label 7888: @403323
     /* 403323 */   GIM_Try, /*On fail goto*//*Label 7889*/ GIMT_Encode4(403454), // Rule ID 6144 //
     /* 403328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 403331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403343 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 403347 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403352 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 403356 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 403360 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403364 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 403368 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 403372 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403376 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403380 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 403384 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 403389 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 403393 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403397 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 403401 */     // MIs[4] Operand 1
     /* 403401 */     // No operand predicates
     /* 403401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403405 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 403407 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 403407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 403410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403419 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 403425 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403430 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 403438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 403442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 403449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 403452 */     GIR_RootConstrainSelectedInstOperands,
     /* 403453 */     // GIR_Coverage, 6144,
     /* 403453 */     GIR_EraseRootFromParent_Done,
     /* 403454 */   // Label 7889: @403454
     /* 403454 */   GIM_Try, /*On fail goto*//*Label 7890*/ GIMT_Encode4(403585), // Rule ID 6176 //
     /* 403459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 403462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403474 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 403478 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 403483 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 403487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403491 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 403495 */     // MIs[2] Operand 1
     /* 403495 */     // No operand predicates
     /* 403495 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 403499 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403503 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 403507 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 403511 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403515 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403519 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 403523 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403528 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 403532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403536 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 403538 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 403538 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 403541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403545 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403550 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 403556 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403561 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 403569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403571 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 403573 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 403580 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 403583 */     GIR_RootConstrainSelectedInstOperands,
     /* 403584 */     // GIR_Coverage, 6176,
     /* 403584 */     GIR_EraseRootFromParent_Done,
     /* 403585 */   // Label 7890: @403585
     /* 403585 */   GIM_Try, /*On fail goto*//*Label 7891*/ GIMT_Encode4(403716), // Rule ID 6240 //
     /* 403590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 403593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 403605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 403609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403613 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403617 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 403621 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403626 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 403630 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 403634 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403638 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403642 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 403646 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 403651 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 403655 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403659 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 403663 */     // MIs[4] Operand 1
     /* 403663 */     // No operand predicates
     /* 403663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403667 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 403669 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 403669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 403672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403681 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 403687 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403692 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 403700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403702 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 403704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 403711 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 403714 */     GIR_RootConstrainSelectedInstOperands,
     /* 403715 */     // GIR_Coverage, 6240,
     /* 403715 */     GIR_EraseRootFromParent_Done,
     /* 403716 */   // Label 7891: @403716
     /* 403716 */   GIM_Try, /*On fail goto*//*Label 7892*/ GIMT_Encode4(403847), // Rule ID 6208 //
     /* 403721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 403724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 403736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 403740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403748 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 403752 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 403757 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 403761 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403765 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 403769 */     // MIs[3] Operand 1
     /* 403769 */     // No operand predicates
     /* 403769 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 403773 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403777 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403781 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 403785 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403790 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 403794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403798 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 403800 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 403800 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 403803 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403807 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403812 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 403818 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403823 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 403831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 403835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 403842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 403845 */     GIR_RootConstrainSelectedInstOperands,
     /* 403846 */     // GIR_Coverage, 6208,
     /* 403846 */     GIR_EraseRootFromParent_Done,
     /* 403847 */   // Label 7892: @403847
     /* 403847 */   GIM_Try, /*On fail goto*//*Label 7893*/ GIMT_Encode4(403982), // Rule ID 2458 //
     /* 403852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 403855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 403871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403876 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 403880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 403884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403888 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403892 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 403896 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403901 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 403905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403909 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 403911 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 403911 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 403914 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403918 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403923 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 403929 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403934 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403939 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 403942 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403946 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403951 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 403957 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403962 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 403970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403972 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 403978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 403980 */     GIR_RootConstrainSelectedInstOperands,
     /* 403981 */     // GIR_Coverage, 2458,
     /* 403981 */     GIR_EraseRootFromParent_Done,
     /* 403982 */   // Label 7893: @403982
     /* 403982 */   GIM_Try, /*On fail goto*//*Label 7894*/ GIMT_Encode4(404101), // Rule ID 6112 //
     /* 403987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 403990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404011 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 404015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 404019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404023 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404027 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404031 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 404036 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 404040 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404044 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 404048 */     // MIs[3] Operand 1
     /* 404048 */     // No operand predicates
     /* 404048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404052 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404054 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 404054 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 404057 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404061 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404066 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 404072 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404077 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 404085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404087 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 404089 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 404096 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 404099 */     GIR_RootConstrainSelectedInstOperands,
     /* 404100 */     // GIR_Coverage, 6112,
     /* 404100 */     GIR_EraseRootFromParent_Done,
     /* 404101 */   // Label 7894: @404101
     /* 404101 */   GIM_Try, /*On fail goto*//*Label 7895*/ GIMT_Encode4(404220), // Rule ID 2533 //
     /* 404106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 404109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 404130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 404134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404138 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 404142 */     // MIs[2] Operand 1
     /* 404142 */     // No operand predicates
     /* 404142 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 404146 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404150 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404154 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 404158 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404163 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 404167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404171 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404173 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 404173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 404176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404185 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 404191 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404196 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 404204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 404208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 404215 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 404218 */     GIR_RootConstrainSelectedInstOperands,
     /* 404219 */     // GIR_Coverage, 2533,
     /* 404219 */     GIR_EraseRootFromParent_Done,
     /* 404220 */   // Label 7895: @404220
     /* 404220 */   GIM_Try, /*On fail goto*//*Label 7896*/ GIMT_Encode4(404320), // Rule ID 4887 //
     /* 404225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 404228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404240 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404244 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404249 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 404253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 404257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404261 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 404265 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404274 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 404276 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 404276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 404279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404288 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 404294 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404299 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 404307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404309 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 404316 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 404318 */     GIR_RootConstrainSelectedInstOperands,
     /* 404319 */     // GIR_Coverage, 4887,
     /* 404319 */     GIR_EraseRootFromParent_Done,
     /* 404320 */   // Label 7896: @404320
     /* 404320 */   GIM_Try, /*On fail goto*//*Label 7897*/ GIMT_Encode4(404420), // Rule ID 4923 //
     /* 404325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 404328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404340 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404344 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404349 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 404353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 404361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 404369 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404374 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 404376 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 404376 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 404379 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404383 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404388 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 404394 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404399 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 404407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 404414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 404418 */     GIR_RootConstrainSelectedInstOperands,
     /* 404419 */     // GIR_Coverage, 4923,
     /* 404419 */     GIR_EraseRootFromParent_Done,
     /* 404420 */   // Label 7897: @404420
     /* 404420 */   GIM_Try, /*On fail goto*//*Label 7898*/ GIMT_Encode4(404517), // Rule ID 14008 //
     /* 404425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 404428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 404440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404448 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404452 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404456 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404461 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 404465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404473 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 404475 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 404475 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 404478 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404482 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404487 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 404493 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404498 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 404506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 404510 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404513 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 404515 */     GIR_RootConstrainSelectedInstOperands,
     /* 404516 */     // GIR_Coverage, 14008,
     /* 404516 */     GIR_EraseRootFromParent_Done,
     /* 404517 */   // Label 7898: @404517
     /* 404517 */   GIM_Try, /*On fail goto*//*Label 7899*/ GIMT_Encode4(404617), // Rule ID 14010 //
     /* 404522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 404525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 404537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404542 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 404546 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404550 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404554 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404558 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404563 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 404567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404571 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 404573 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 404573 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 404576 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404580 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404585 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 404591 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404596 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 404604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404606 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 404613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 404615 */     GIR_RootConstrainSelectedInstOperands,
     /* 404616 */     // GIR_Coverage, 14010,
     /* 404616 */     GIR_EraseRootFromParent_Done,
     /* 404617 */   // Label 7899: @404617
     /* 404617 */   GIM_Try, /*On fail goto*//*Label 7900*/ GIMT_Encode4(404717), // Rule ID 4921 //
     /* 404622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 404625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 404633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404650 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 404654 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 404658 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404662 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 404666 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404671 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 404673 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 404673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 404676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404685 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 404691 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404696 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 404704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404706 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404708 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 404715 */     GIR_RootConstrainSelectedInstOperands,
     /* 404716 */     // GIR_Coverage, 4921,
     /* 404716 */     GIR_EraseRootFromParent_Done,
     /* 404717 */   // Label 7900: @404717
     /* 404717 */   GIM_Try, /*On fail goto*//*Label 7901*/ GIMT_Encode4(404814), // Rule ID 4885 //
     /* 404722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 404725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 404733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 404741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404749 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404753 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404757 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404762 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 404766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404770 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 404772 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 404772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 404775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404784 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 404790 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404795 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 404803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404805 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404807 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 404812 */     GIR_RootConstrainSelectedInstOperands,
     /* 404813 */     // GIR_Coverage, 4885,
     /* 404813 */     GIR_EraseRootFromParent_Done,
     /* 404814 */   // Label 7901: @404814
     /* 404814 */   GIM_Try, /*On fail goto*//*Label 7902*/ GIMT_Encode4(404898), // Rule ID 6174 //
     /* 404819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 404822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404834 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404838 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 404843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 404847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404851 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 404855 */     // MIs[2] Operand 1
     /* 404855 */     // No operand predicates
     /* 404855 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 404859 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404863 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 404867 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404876 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404878 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 404878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 404881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404883 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 404885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 404889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 404893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 404896 */     GIR_RootConstrainSelectedInstOperands,
     /* 404897 */     // GIR_Coverage, 6174,
     /* 404897 */     GIR_EraseRootFromParent_Done,
     /* 404898 */   // Label 7902: @404898
     /* 404898 */   GIM_Try, /*On fail goto*//*Label 7903*/ GIMT_Encode4(404979), // Rule ID 6206 //
     /* 404903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 404906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 404918 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404922 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404926 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404930 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404934 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 404939 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 404943 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404947 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 404951 */     // MIs[3] Operand 1
     /* 404951 */     // No operand predicates
     /* 404951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404959 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404961 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 404961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 404964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 404968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 404970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 404974 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 404977 */     GIR_RootConstrainSelectedInstOperands,
     /* 404978 */     // GIR_Coverage, 6206,
     /* 404978 */     GIR_EraseRootFromParent_Done,
     /* 404979 */   // Label 7903: @404979
     /* 404979 */   GIM_Try, /*On fail goto*//*Label 7904*/ GIMT_Encode4(405063), // Rule ID 6238 //
     /* 404984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 404987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 404999 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 405008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405012 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405016 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405020 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 405025 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 405029 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405033 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 405037 */     // MIs[3] Operand 1
     /* 405037 */     // No operand predicates
     /* 405037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405041 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405043 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 405043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 405046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 405048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 405050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 405054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405058 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 405061 */     GIR_RootConstrainSelectedInstOperands,
     /* 405062 */     // GIR_Coverage, 6238,
     /* 405062 */     GIR_EraseRootFromParent_Done,
     /* 405063 */   // Label 7904: @405063
     /* 405063 */   GIM_Try, /*On fail goto*//*Label 7905*/ GIMT_Encode4(405144), // Rule ID 6142 //
     /* 405068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 405071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 405087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405095 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405099 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405103 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 405108 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 405112 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405116 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 405120 */     // MIs[3] Operand 1
     /* 405120 */     // No operand predicates
     /* 405120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405124 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405126 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 405126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 405129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 405131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 405133 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 405142 */     GIR_RootConstrainSelectedInstOperands,
     /* 405143 */     // GIR_Coverage, 6142,
     /* 405143 */     GIR_EraseRootFromParent_Done,
     /* 405144 */   // Label 7905: @405144
     /* 405144 */   GIM_Try, /*On fail goto*//*Label 7906*/ GIMT_Encode4(405229), // Rule ID 2456 //
     /* 405149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 405152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405164 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405168 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405173 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 405177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405187 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 405187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 405190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405199 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 405205 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405210 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 405218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 405223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 405225 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 405227 */     GIR_RootConstrainSelectedInstOperands,
     /* 405228 */     // GIR_Coverage, 2456,
     /* 405228 */     GIR_EraseRootFromParent_Done,
     /* 405229 */   // Label 7906: @405229
     /* 405229 */   GIM_Try, /*On fail goto*//*Label 7907*/ GIMT_Encode4(405314), // Rule ID 2454 //
     /* 405234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 405237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405253 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405257 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405262 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 405266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405270 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405272 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 405272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 405275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405284 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 405290 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405295 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 405303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405305 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 405310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 405312 */     GIR_RootConstrainSelectedInstOperands,
     /* 405313 */     // GIR_Coverage, 2454,
     /* 405313 */     GIR_EraseRootFromParent_Done,
     /* 405314 */   // Label 7907: @405314
     /* 405314 */   GIM_Try, /*On fail goto*//*Label 7908*/ GIMT_Encode4(405383), // Rule ID 2531 //
     /* 405319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 405322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405330 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405334 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405338 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 405343 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 405347 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405351 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 405355 */     // MIs[2] Operand 1
     /* 405355 */     // No operand predicates
     /* 405355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405363 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 405365 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 405365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 405368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 405370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 405372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 405374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 405378 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 405381 */     GIR_RootConstrainSelectedInstOperands,
     /* 405382 */     // GIR_Coverage, 2531,
     /* 405382 */     GIR_EraseRootFromParent_Done,
     /* 405383 */   // Label 7908: @405383
     /* 405383 */   GIM_Try, /*On fail goto*//*Label 7909*/ GIMT_Encode4(405452), // Rule ID 6110 //
     /* 405388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 405391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405407 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405411 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 405416 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 405420 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405424 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 405428 */     // MIs[2] Operand 1
     /* 405428 */     // No operand predicates
     /* 405428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405432 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 405434 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 405434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 405437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 405439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 405441 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 405447 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 405450 */     GIR_RootConstrainSelectedInstOperands,
     /* 405451 */     // GIR_Coverage, 6110,
     /* 405451 */     GIR_EraseRootFromParent_Done,
     /* 405452 */   // Label 7909: @405452
     /* 405452 */   GIM_Try, /*On fail goto*//*Label 7910*/ GIMT_Encode4(405502), // Rule ID 13441 //
     /* 405457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 405460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 405472 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405487 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 405487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 405490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 405494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 405498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 405500 */     GIR_RootConstrainSelectedInstOperands,
     /* 405501 */     // GIR_Coverage, 13441,
     /* 405501 */     GIR_EraseRootFromParent_Done,
     /* 405502 */   // Label 7910: @405502
     /* 405502 */   GIM_Try, /*On fail goto*//*Label 7911*/ GIMT_Encode4(405552), // Rule ID 643 //
     /* 405507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 405510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 405526 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405537 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 405537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 405540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405542 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 405548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 405550 */     GIR_RootConstrainSelectedInstOperands,
     /* 405551 */     // GIR_Coverage, 643,
     /* 405551 */     GIR_EraseRootFromParent_Done,
     /* 405552 */   // Label 7911: @405552
     /* 405552 */   GIM_Try, /*On fail goto*//*Label 7912*/ GIMT_Encode4(405602), // Rule ID 655 //
     /* 405557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 405560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 405572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 405580 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405587 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 405587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 405590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405592 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 405596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 405600 */     GIR_RootConstrainSelectedInstOperands,
     /* 405601 */     // GIR_Coverage, 655,
     /* 405601 */     GIR_EraseRootFromParent_Done,
     /* 405602 */   // Label 7912: @405602
     /* 405602 */   GIM_Try, /*On fail goto*//*Label 7913*/ GIMT_Encode4(405633), // Rule ID 637 //
     /* 405607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 405610 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405622 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 405622 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 405627 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 405631 */     GIR_RootConstrainSelectedInstOperands,
     /* 405632 */     // GIR_Coverage, 637,
     /* 405632 */     GIR_Done,
     /* 405633 */   // Label 7913: @405633
     /* 405633 */   GIM_Reject,
     /* 405634 */ // Label 7885: @405634
     /* 405634 */ GIM_Reject,
     /* 405635 */ // Label 7877: @405635
     /* 405635 */ GIM_Try, /*On fail goto*//*Label 7914*/ GIMT_Encode4(408564),
     /* 405640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 405643 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 405646 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 405649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405653 */   GIM_Try, /*On fail goto*//*Label 7915*/ GIMT_Encode4(405803), // Rule ID 4931 //
     /* 405658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 405661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405673 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405682 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 405686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 405690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405694 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405698 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405702 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405707 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 405711 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 405715 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405719 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 405723 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405728 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405730 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 405730 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 405733 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405737 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405742 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 405748 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405753 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 405761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405770 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 405776 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405781 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 405789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405791 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 405794 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 405797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 405801 */     GIR_RootConstrainSelectedInstOperands,
     /* 405802 */     // GIR_Coverage, 4931,
     /* 405802 */     GIR_EraseRootFromParent_Done,
     /* 405803 */   // Label 7915: @405803
     /* 405803 */   GIM_Try, /*On fail goto*//*Label 7916*/ GIMT_Encode4(405950), // Rule ID 4895 //
     /* 405808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 405811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405823 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405827 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405832 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 405836 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 405840 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405844 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 405848 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 405852 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405856 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405860 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 405864 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405869 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 405873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405877 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405879 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 405879 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 405882 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405886 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405891 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 405897 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405902 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 405910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405919 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 405925 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405930 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 405938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405940 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 405943 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 405946 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 405948 */     GIR_RootConstrainSelectedInstOperands,
     /* 405949 */     // GIR_Coverage, 4895,
     /* 405949 */     GIR_EraseRootFromParent_Done,
     /* 405950 */   // Label 7916: @405950
     /* 405950 */   GIM_Try, /*On fail goto*//*Label 7917*/ GIMT_Encode4(406097), // Rule ID 14018 //
     /* 405955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 405958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 405970 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405974 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405978 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405982 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405986 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405991 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 405995 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 405999 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406003 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406007 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 406011 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406016 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 406020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406024 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406026 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 406026 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 406029 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406033 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406038 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 406044 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406049 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406054 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 406057 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406061 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406066 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 406072 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406077 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 406085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406087 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406090 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 406093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 406095 */     GIR_RootConstrainSelectedInstOperands,
     /* 406096 */     // GIR_Coverage, 14018,
     /* 406096 */     GIR_EraseRootFromParent_Done,
     /* 406097 */   // Label 7917: @406097
     /* 406097 */   GIM_Try, /*On fail goto*//*Label 7918*/ GIMT_Encode4(406228), // Rule ID 6160 //
     /* 406102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406117 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 406121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406126 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 406130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 406134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406138 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 406142 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 406146 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406150 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406154 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 406158 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406163 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 406167 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 406171 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 406175 */     // MIs[4] Operand 1
     /* 406175 */     // No operand predicates
     /* 406175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406179 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 406181 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 406181 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 406184 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406188 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406193 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 406199 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406204 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 406212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 406214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 406216 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 406223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 406226 */     GIR_RootConstrainSelectedInstOperands,
     /* 406227 */     // GIR_Coverage, 6160,
     /* 406227 */     GIR_EraseRootFromParent_Done,
     /* 406228 */   // Label 7918: @406228
     /* 406228 */   GIM_Try, /*On fail goto*//*Label 7919*/ GIMT_Encode4(406359), // Rule ID 6192 //
     /* 406233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406248 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 406252 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 406261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 406265 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 406269 */     // MIs[2] Operand 1
     /* 406269 */     // No operand predicates
     /* 406269 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 406273 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406277 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 406281 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 406285 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406289 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406293 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 406297 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406302 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 406306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406310 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 406312 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 406312 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 406315 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406319 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406324 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 406330 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406335 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 406343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 406345 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 406347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 406354 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 406357 */     GIR_RootConstrainSelectedInstOperands,
     /* 406358 */     // GIR_Coverage, 6192,
     /* 406358 */     GIR_EraseRootFromParent_Done,
     /* 406359 */   // Label 7919: @406359
     /* 406359 */   GIM_Try, /*On fail goto*//*Label 7920*/ GIMT_Encode4(406490), // Rule ID 6256 //
     /* 406364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 406379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 406383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406387 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406391 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 406395 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406400 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 406404 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 406408 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406412 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406416 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 406420 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406425 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 406429 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 406433 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 406437 */     // MIs[4] Operand 1
     /* 406437 */     // No operand predicates
     /* 406437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406441 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 406443 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 406443 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 406446 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406450 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406455 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 406461 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406466 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 406474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 406476 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 406478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 406485 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 406488 */     GIR_RootConstrainSelectedInstOperands,
     /* 406489 */     // GIR_Coverage, 6256,
     /* 406489 */     GIR_EraseRootFromParent_Done,
     /* 406490 */   // Label 7920: @406490
     /* 406490 */   GIM_Try, /*On fail goto*//*Label 7921*/ GIMT_Encode4(406621), // Rule ID 6224 //
     /* 406495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 406510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 406514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406518 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406522 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 406526 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406531 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 406535 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 406539 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 406543 */     // MIs[3] Operand 1
     /* 406543 */     // No operand predicates
     /* 406543 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 406547 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406551 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406555 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 406559 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406564 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 406568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406572 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 406574 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 406574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 406577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406586 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 406592 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406597 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 406605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 406607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 406609 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 406616 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 406619 */     GIR_RootConstrainSelectedInstOperands,
     /* 406620 */     // GIR_Coverage, 6224,
     /* 406620 */     GIR_EraseRootFromParent_Done,
     /* 406621 */   // Label 7921: @406621
     /* 406621 */   GIM_Try, /*On fail goto*//*Label 7922*/ GIMT_Encode4(406756), // Rule ID 2464 //
     /* 406626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 406629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 406645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406650 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 406654 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 406658 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406662 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406666 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 406670 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406675 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 406679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406683 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 406685 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 406685 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 406688 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406692 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406697 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 406703 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406708 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406713 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 406716 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406720 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406725 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 406731 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406736 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 406744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406746 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 406752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 406754 */     GIR_RootConstrainSelectedInstOperands,
     /* 406755 */     // GIR_Coverage, 2464,
     /* 406755 */     GIR_EraseRootFromParent_Done,
     /* 406756 */   // Label 7922: @406756
     /* 406756 */   GIM_Try, /*On fail goto*//*Label 7923*/ GIMT_Encode4(406875), // Rule ID 6128 //
     /* 406761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406776 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 406780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406785 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 406789 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 406793 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406797 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406801 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 406805 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406810 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 406814 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 406818 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 406822 */     // MIs[3] Operand 1
     /* 406822 */     // No operand predicates
     /* 406822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406826 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406828 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 406828 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 406831 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406835 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406840 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 406846 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406851 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 406859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 406861 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 406863 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 406870 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 406873 */     GIR_RootConstrainSelectedInstOperands,
     /* 406874 */     // GIR_Coverage, 6128,
     /* 406874 */     GIR_EraseRootFromParent_Done,
     /* 406875 */   // Label 7923: @406875
     /* 406875 */   GIM_Try, /*On fail goto*//*Label 7924*/ GIMT_Encode4(406994), // Rule ID 2549 //
     /* 406880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 406899 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406904 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 406908 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 406912 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 406916 */     // MIs[2] Operand 1
     /* 406916 */     // No operand predicates
     /* 406916 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 406920 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406924 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406928 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 406932 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406937 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 406941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406945 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406947 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 406947 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 406950 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406954 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406959 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 406965 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406970 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 406978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 406980 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 406982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 406989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 406992 */     GIR_RootConstrainSelectedInstOperands,
     /* 406993 */     // GIR_Coverage, 2549,
     /* 406993 */     GIR_EraseRootFromParent_Done,
     /* 406994 */   // Label 7924: @406994
     /* 406994 */   GIM_Try, /*On fail goto*//*Label 7925*/ GIMT_Encode4(407094), // Rule ID 4893 //
     /* 406999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 407002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407014 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 407018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407023 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 407027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 407031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407035 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 407039 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407048 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 407050 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 407050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 407053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407062 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 407068 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407073 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 407081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407083 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 407090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 407092 */     GIR_RootConstrainSelectedInstOperands,
     /* 407093 */     // GIR_Coverage, 4893,
     /* 407093 */     GIR_EraseRootFromParent_Done,
     /* 407094 */   // Label 7925: @407094
     /* 407094 */   GIM_Try, /*On fail goto*//*Label 7926*/ GIMT_Encode4(407194), // Rule ID 4929 //
     /* 407099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 407102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407114 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 407118 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407123 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 407127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 407135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407139 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 407143 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407148 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 407150 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 407150 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 407153 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407157 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407162 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 407168 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407173 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 407181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 407188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 407192 */     GIR_RootConstrainSelectedInstOperands,
     /* 407193 */     // GIR_Coverage, 4929,
     /* 407193 */     GIR_EraseRootFromParent_Done,
     /* 407194 */   // Label 7926: @407194
     /* 407194 */   GIM_Try, /*On fail goto*//*Label 7927*/ GIMT_Encode4(407291), // Rule ID 14014 //
     /* 407199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 407202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 407214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 407218 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407222 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407226 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 407230 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407235 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 407239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407247 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 407249 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 407249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 407252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407261 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 407267 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407272 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 407280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 407284 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407287 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 407289 */     GIR_RootConstrainSelectedInstOperands,
     /* 407290 */     // GIR_Coverage, 14014,
     /* 407290 */     GIR_EraseRootFromParent_Done,
     /* 407291 */   // Label 7927: @407291
     /* 407291 */   GIM_Try, /*On fail goto*//*Label 7928*/ GIMT_Encode4(407391), // Rule ID 14016 //
     /* 407296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 407299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 407311 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 407320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407324 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407328 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 407332 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407337 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 407341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407345 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 407347 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 407347 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 407350 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407354 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407359 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 407365 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407370 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 407378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407380 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 407387 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 407389 */     GIR_RootConstrainSelectedInstOperands,
     /* 407390 */     // GIR_Coverage, 14016,
     /* 407390 */     GIR_EraseRootFromParent_Done,
     /* 407391 */   // Label 7928: @407391
     /* 407391 */   GIM_Try, /*On fail goto*//*Label 7929*/ GIMT_Encode4(407491), // Rule ID 4927 //
     /* 407396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 407399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 407407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407415 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 407419 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407424 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 407428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 407432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 407440 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407445 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 407447 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 407447 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 407450 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407454 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407459 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 407465 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407470 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 407478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407480 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 407482 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 407489 */     GIR_RootConstrainSelectedInstOperands,
     /* 407490 */     // GIR_Coverage, 4927,
     /* 407490 */     GIR_EraseRootFromParent_Done,
     /* 407491 */   // Label 7929: @407491
     /* 407491 */   GIM_Try, /*On fail goto*//*Label 7930*/ GIMT_Encode4(407588), // Rule ID 4891 //
     /* 407496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 407499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 407507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 407515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 407519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407523 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407527 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 407531 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407536 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 407540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407544 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 407546 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 407546 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 407549 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407553 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407558 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 407564 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407569 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 407577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407579 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 407581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 407586 */     GIR_RootConstrainSelectedInstOperands,
     /* 407587 */     // GIR_Coverage, 4891,
     /* 407587 */     GIR_EraseRootFromParent_Done,
     /* 407588 */   // Label 7930: @407588
     /* 407588 */   GIM_Try, /*On fail goto*//*Label 7931*/ GIMT_Encode4(407666), // Rule ID 6278 //
     /* 407593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407605 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 407609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 407613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407617 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407621 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407626 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 407630 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407634 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 407638 */     // MIs[3] Operand 1
     /* 407638 */     // No operand predicates
     /* 407638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407646 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407648 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 407648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 407651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 407655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 407657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 407661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 407664 */     GIR_RootConstrainSelectedInstOperands,
     /* 407665 */     // GIR_Coverage, 6278,
     /* 407665 */     GIR_EraseRootFromParent_Done,
     /* 407666 */   // Label 7931: @407666
     /* 407666 */   GIM_Try, /*On fail goto*//*Label 7932*/ GIMT_Encode4(407750), // Rule ID 6190 //
     /* 407671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407686 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 407690 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 407699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407703 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 407707 */     // MIs[2] Operand 1
     /* 407707 */     // No operand predicates
     /* 407707 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 407711 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407715 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 407719 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407728 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407730 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 407730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 407733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407735 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 407737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 407741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 407745 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 407748 */     GIR_RootConstrainSelectedInstOperands,
     /* 407749 */     // GIR_Coverage, 6190,
     /* 407749 */     GIR_EraseRootFromParent_Done,
     /* 407750 */   // Label 7932: @407750
     /* 407750 */   GIM_Try, /*On fail goto*//*Label 7933*/ GIMT_Encode4(407831), // Rule ID 6222 //
     /* 407755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 407770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 407774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407778 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407782 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 407786 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407791 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 407795 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407799 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 407803 */     // MIs[3] Operand 1
     /* 407803 */     // No operand predicates
     /* 407803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407811 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407813 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 407813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 407816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407818 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 407820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 407822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 407826 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 407829 */     GIR_RootConstrainSelectedInstOperands,
     /* 407830 */     // GIR_Coverage, 6222,
     /* 407830 */     GIR_EraseRootFromParent_Done,
     /* 407831 */   // Label 7933: @407831
     /* 407831 */   GIM_Try, /*On fail goto*//*Label 7934*/ GIMT_Encode4(407915), // Rule ID 6254 //
     /* 407836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 407851 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 407860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407864 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407868 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 407872 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407877 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 407881 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407885 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 407889 */     // MIs[3] Operand 1
     /* 407889 */     // No operand predicates
     /* 407889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407893 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407895 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 407895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 407898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407900 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 407902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 407906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 407910 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 407913 */     GIR_RootConstrainSelectedInstOperands,
     /* 407914 */     // GIR_Coverage, 6254,
     /* 407914 */     GIR_EraseRootFromParent_Done,
     /* 407915 */   // Label 7934: @407915
     /* 407915 */   GIM_Try, /*On fail goto*//*Label 7935*/ GIMT_Encode4(407993), // Rule ID 6300 //
     /* 407920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 407928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407936 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 407940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 407944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407948 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407952 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407957 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 407961 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407965 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 407969 */     // MIs[3] Operand 1
     /* 407969 */     // No operand predicates
     /* 407969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407973 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407975 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 407975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 407978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407980 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 407982 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 407984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 407988 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 407991 */     GIR_RootConstrainSelectedInstOperands,
     /* 407992 */     // GIR_Coverage, 6300,
     /* 407992 */     GIR_EraseRootFromParent_Done,
     /* 407993 */   // Label 7935: @407993
     /* 407993 */   GIM_Try, /*On fail goto*//*Label 7936*/ GIMT_Encode4(408074), // Rule ID 6158 //
     /* 407998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408001 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 408009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 408017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408025 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408029 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408033 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408038 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408042 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408046 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 408050 */     // MIs[3] Operand 1
     /* 408050 */     // No operand predicates
     /* 408050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408054 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408056 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 408056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 408059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 408063 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 408065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 408069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 408072 */     GIR_RootConstrainSelectedInstOperands,
     /* 408073 */     // GIR_Coverage, 6158,
     /* 408073 */     GIR_EraseRootFromParent_Done,
     /* 408074 */   // Label 7936: @408074
     /* 408074 */   GIM_Try, /*On fail goto*//*Label 7937*/ GIMT_Encode4(408159), // Rule ID 2462 //
     /* 408079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 408082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408094 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408098 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408103 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 408107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 408117 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 408117 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 408120 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 408124 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408129 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 408135 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408140 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 408148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408150 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 408155 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 408157 */     GIR_RootConstrainSelectedInstOperands,
     /* 408158 */     // GIR_Coverage, 2462,
     /* 408158 */     GIR_EraseRootFromParent_Done,
     /* 408159 */   // Label 7937: @408159
     /* 408159 */   GIM_Try, /*On fail goto*//*Label 7938*/ GIMT_Encode4(408244), // Rule ID 2460 //
     /* 408164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 408167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 408175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408183 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408187 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408192 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 408196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 408202 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 408202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 408205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 408209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408214 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 408220 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408225 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 408233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408235 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 408237 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 408242 */     GIR_RootConstrainSelectedInstOperands,
     /* 408243 */     // GIR_Coverage, 2460,
     /* 408243 */     GIR_EraseRootFromParent_Done,
     /* 408244 */   // Label 7938: @408244
     /* 408244 */   GIM_Try, /*On fail goto*//*Label 7939*/ GIMT_Encode4(408313), // Rule ID 2547 //
     /* 408249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408264 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408268 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 408277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408281 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 408285 */     // MIs[2] Operand 1
     /* 408285 */     // No operand predicates
     /* 408285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408293 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 408295 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 408295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 408298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408300 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 408302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 408304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 408308 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 408311 */     GIR_RootConstrainSelectedInstOperands,
     /* 408312 */     // GIR_Coverage, 2547,
     /* 408312 */     GIR_EraseRootFromParent_Done,
     /* 408313 */   // Label 7939: @408313
     /* 408313 */   GIM_Try, /*On fail goto*//*Label 7940*/ GIMT_Encode4(408382), // Rule ID 6126 //
     /* 408318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 408329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408337 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408341 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 408350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408354 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 408358 */     // MIs[2] Operand 1
     /* 408358 */     // No operand predicates
     /* 408358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408362 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 408364 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 408364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 408367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 408371 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 408373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 408377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 408380 */     GIR_RootConstrainSelectedInstOperands,
     /* 408381 */     // GIR_Coverage, 6126,
     /* 408381 */     GIR_EraseRootFromParent_Done,
     /* 408382 */   // Label 7940: @408382
     /* 408382 */   GIM_Try, /*On fail goto*//*Label 7941*/ GIMT_Encode4(408432), // Rule ID 13443 //
     /* 408387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 408390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408398 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 408402 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 408417 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 408417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 408420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 408424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 408428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 408430 */     GIR_RootConstrainSelectedInstOperands,
     /* 408431 */     // GIR_Coverage, 13443,
     /* 408431 */     GIR_EraseRootFromParent_Done,
     /* 408432 */   // Label 7941: @408432
     /* 408432 */   GIM_Try, /*On fail goto*//*Label 7942*/ GIMT_Encode4(408482), // Rule ID 645 //
     /* 408437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 408440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 408448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 408456 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 408467 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 408467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 408470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408472 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 408474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 408478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 408480 */     GIR_RootConstrainSelectedInstOperands,
     /* 408481 */     // GIR_Coverage, 645,
     /* 408481 */     GIR_EraseRootFromParent_Done,
     /* 408482 */   // Label 7942: @408482
     /* 408482 */   GIM_Try, /*On fail goto*//*Label 7943*/ GIMT_Encode4(408532), // Rule ID 657 //
     /* 408487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 408490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 408502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 408510 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 408517 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 408517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 408520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408522 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 408524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 408526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 408530 */     GIR_RootConstrainSelectedInstOperands,
     /* 408531 */     // GIR_Coverage, 657,
     /* 408531 */     GIR_EraseRootFromParent_Done,
     /* 408532 */   // Label 7943: @408532
     /* 408532 */   GIM_Try, /*On fail goto*//*Label 7944*/ GIMT_Encode4(408563), // Rule ID 639 //
     /* 408537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 408540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408552 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 408552 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 408557 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 408561 */     GIR_RootConstrainSelectedInstOperands,
     /* 408562 */     // GIR_Coverage, 639,
     /* 408562 */     GIR_Done,
     /* 408563 */   // Label 7944: @408563
     /* 408563 */   GIM_Reject,
     /* 408564 */ // Label 7914: @408564
     /* 408564 */ GIM_Reject,
     /* 408565 */ // Label 7878: @408565
     /* 408565 */ GIM_Try, /*On fail goto*//*Label 7945*/ GIMT_Encode4(411494),
     /* 408570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 408573 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 408576 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 408579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408583 */   GIM_Try, /*On fail goto*//*Label 7946*/ GIMT_Encode4(408733), // Rule ID 4937 //
     /* 408588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 408591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408603 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408607 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408612 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 408616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 408620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408624 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408628 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408632 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408637 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 408641 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 408645 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408649 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 408653 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408658 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408660 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 408660 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 408663 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 408667 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408672 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 408678 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408683 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408688 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 408691 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 408695 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408700 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 408706 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408711 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 408719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408721 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 408727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 408731 */     GIR_RootConstrainSelectedInstOperands,
     /* 408732 */     // GIR_Coverage, 4937,
     /* 408732 */     GIR_EraseRootFromParent_Done,
     /* 408733 */   // Label 7946: @408733
     /* 408733 */   GIM_Try, /*On fail goto*//*Label 7947*/ GIMT_Encode4(408880), // Rule ID 4901 //
     /* 408738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 408741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408753 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408757 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408762 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 408766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 408770 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408774 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 408778 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 408782 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408786 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408790 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 408794 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408799 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 408803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408807 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408809 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 408809 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 408812 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 408816 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408821 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 408827 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408832 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 408840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 408844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408849 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 408855 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408860 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 408868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408870 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408873 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 408876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 408878 */     GIR_RootConstrainSelectedInstOperands,
     /* 408879 */     // GIR_Coverage, 4901,
     /* 408879 */     GIR_EraseRootFromParent_Done,
     /* 408880 */   // Label 7947: @408880
     /* 408880 */   GIM_Try, /*On fail goto*//*Label 7948*/ GIMT_Encode4(409027), // Rule ID 14024 //
     /* 408885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 408888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 408900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408908 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408912 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408916 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408921 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 408925 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 408929 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408933 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408937 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 408941 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408946 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 408950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408954 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408956 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 408956 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 408959 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 408963 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408968 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 408974 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408979 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 408987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 408991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408996 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 409002 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409007 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 409015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409017 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 409020 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 409023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 409025 */     GIR_RootConstrainSelectedInstOperands,
     /* 409026 */     // GIR_Coverage, 14024,
     /* 409026 */     GIR_EraseRootFromParent_Done,
     /* 409027 */   // Label 7948: @409027
     /* 409027 */   GIM_Try, /*On fail goto*//*Label 7949*/ GIMT_Encode4(409158), // Rule ID 6164 //
     /* 409032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409047 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409051 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409056 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 409060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 409064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409068 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 409072 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 409076 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409080 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409084 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 409088 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409093 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 409097 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409101 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 409105 */     // MIs[4] Operand 1
     /* 409105 */     // No operand predicates
     /* 409105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409109 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 409111 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 409111 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 409114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 409118 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 409123 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 409129 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409134 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 409142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409146 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 409149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 409153 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 409156 */     GIR_RootConstrainSelectedInstOperands,
     /* 409157 */     // GIR_Coverage, 6164,
     /* 409157 */     GIR_EraseRootFromParent_Done,
     /* 409158 */   // Label 7949: @409158
     /* 409158 */   GIM_Try, /*On fail goto*//*Label 7950*/ GIMT_Encode4(409289), // Rule ID 6196 //
     /* 409163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409178 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409182 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409187 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 409191 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409195 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 409199 */     // MIs[2] Operand 1
     /* 409199 */     // No operand predicates
     /* 409199 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 409203 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409207 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 409211 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 409215 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409219 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409223 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 409227 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409232 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 409236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409240 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 409242 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 409242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 409245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 409249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 409254 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 409260 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409265 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 409273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 409280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 409284 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 409287 */     GIR_RootConstrainSelectedInstOperands,
     /* 409288 */     // GIR_Coverage, 6196,
     /* 409288 */     GIR_EraseRootFromParent_Done,
     /* 409289 */   // Label 7950: @409289
     /* 409289 */   GIM_Try, /*On fail goto*//*Label 7951*/ GIMT_Encode4(409420), // Rule ID 6260 //
     /* 409294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 409309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409317 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409321 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409325 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409330 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 409334 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 409338 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409342 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409346 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 409350 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409355 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 409359 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409363 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 409367 */     // MIs[4] Operand 1
     /* 409367 */     // No operand predicates
     /* 409367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409371 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 409373 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 409373 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 409376 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 409380 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 409385 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 409391 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409396 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 409404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 409411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 409415 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 409418 */     GIR_RootConstrainSelectedInstOperands,
     /* 409419 */     // GIR_Coverage, 6260,
     /* 409419 */     GIR_EraseRootFromParent_Done,
     /* 409420 */   // Label 7951: @409420
     /* 409420 */   GIM_Try, /*On fail goto*//*Label 7952*/ GIMT_Encode4(409551), // Rule ID 6228 //
     /* 409425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 409440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409448 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409452 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409456 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409461 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409465 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409469 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 409473 */     // MIs[3] Operand 1
     /* 409473 */     // No operand predicates
     /* 409473 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 409477 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409481 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409485 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 409489 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409494 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 409498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409502 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 409504 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 409504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 409507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 409511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 409516 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 409522 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409527 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 409535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 409542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409546 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409549 */     GIR_RootConstrainSelectedInstOperands,
     /* 409550 */     // GIR_Coverage, 6228,
     /* 409550 */     GIR_EraseRootFromParent_Done,
     /* 409551 */   // Label 7952: @409551
     /* 409551 */   GIM_Try, /*On fail goto*//*Label 7953*/ GIMT_Encode4(409686), // Rule ID 2470 //
     /* 409556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 409559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409571 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409575 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409580 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 409584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 409588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409592 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409596 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409600 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409605 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 409609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409613 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 409615 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 409615 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 409618 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 409622 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 409627 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 409633 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409638 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409643 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 409646 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 409650 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 409655 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 409661 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409666 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 409674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409676 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 409679 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 409682 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 409684 */     GIR_RootConstrainSelectedInstOperands,
     /* 409685 */     // GIR_Coverage, 2470,
     /* 409685 */     GIR_EraseRootFromParent_Done,
     /* 409686 */   // Label 7953: @409686
     /* 409686 */   GIM_Try, /*On fail goto*//*Label 7954*/ GIMT_Encode4(409805), // Rule ID 6132 //
     /* 409691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409706 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409710 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409715 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 409719 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 409723 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409727 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409731 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409735 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409740 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409744 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409748 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 409752 */     // MIs[3] Operand 1
     /* 409752 */     // No operand predicates
     /* 409752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409756 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409758 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 409758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 409761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 409765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 409770 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 409776 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409781 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 409789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409791 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 409796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409800 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409803 */     GIR_RootConstrainSelectedInstOperands,
     /* 409804 */     // GIR_Coverage, 6132,
     /* 409804 */     GIR_EraseRootFromParent_Done,
     /* 409805 */   // Label 7954: @409805
     /* 409805 */   GIM_Try, /*On fail goto*//*Label 7955*/ GIMT_Encode4(409924), // Rule ID 2553 //
     /* 409810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409825 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 409838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409842 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 409846 */     // MIs[2] Operand 1
     /* 409846 */     // No operand predicates
     /* 409846 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 409850 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409854 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409858 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 409862 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409867 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 409871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409875 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409877 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 409877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 409880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 409884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 409889 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 409895 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409900 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 409908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409912 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 409915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 409919 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 409922 */     GIR_RootConstrainSelectedInstOperands,
     /* 409923 */     // GIR_Coverage, 2553,
     /* 409923 */     GIR_EraseRootFromParent_Done,
     /* 409924 */   // Label 7955: @409924
     /* 409924 */   GIM_Try, /*On fail goto*//*Label 7956*/ GIMT_Encode4(410024), // Rule ID 4899 //
     /* 409929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 409932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409944 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409948 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409953 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 409957 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 409961 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409965 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 409969 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409978 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 409980 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 409980 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 409983 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 409987 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 409992 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 409998 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410003 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 410011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 410013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 410016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 410022 */     GIR_RootConstrainSelectedInstOperands,
     /* 410023 */     // GIR_Coverage, 4899,
     /* 410023 */     GIR_EraseRootFromParent_Done,
     /* 410024 */   // Label 7956: @410024
     /* 410024 */   GIM_Try, /*On fail goto*//*Label 7957*/ GIMT_Encode4(410124), // Rule ID 4935 //
     /* 410029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 410032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 410040 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410044 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 410048 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410053 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 410057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410061 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 410065 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410069 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 410073 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410078 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 410080 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 410080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 410083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 410087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 410092 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 410098 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410103 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 410111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 410113 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 410116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 410118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 410122 */     GIR_RootConstrainSelectedInstOperands,
     /* 410123 */     // GIR_Coverage, 4935,
     /* 410123 */     GIR_EraseRootFromParent_Done,
     /* 410124 */   // Label 7957: @410124
     /* 410124 */   GIM_Try, /*On fail goto*//*Label 7958*/ GIMT_Encode4(410221), // Rule ID 14020 //
     /* 410129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 410132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 410144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 410148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 410152 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410156 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 410160 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410165 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 410169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410177 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 410179 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 410179 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 410182 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 410186 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 410191 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 410197 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410202 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 410210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 410212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 410214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 410217 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 410219 */     GIR_RootConstrainSelectedInstOperands,
     /* 410220 */     // GIR_Coverage, 14020,
     /* 410220 */     GIR_EraseRootFromParent_Done,
     /* 410221 */   // Label 7958: @410221
     /* 410221 */   GIM_Try, /*On fail goto*//*Label 7959*/ GIMT_Encode4(410321), // Rule ID 14022 //
     /* 410226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 410229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 410241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 410250 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 410254 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410258 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 410262 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410267 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 410271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410275 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 410277 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 410277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 410280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 410284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 410289 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 410295 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410300 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 410308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 410310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 410313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 410317 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 410319 */     GIR_RootConstrainSelectedInstOperands,
     /* 410320 */     // GIR_Coverage, 14022,
     /* 410320 */     GIR_EraseRootFromParent_Done,
     /* 410321 */   // Label 7959: @410321
     /* 410321 */   GIM_Try, /*On fail goto*//*Label 7960*/ GIMT_Encode4(410421), // Rule ID 4933 //
     /* 410326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 410329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 410337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 410341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410345 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 410349 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410354 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 410358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 410362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410366 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 410370 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410375 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 410377 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 410377 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 410380 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 410384 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 410389 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 410395 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410400 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 410408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 410410 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 410412 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 410415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 410419 */     GIR_RootConstrainSelectedInstOperands,
     /* 410420 */     // GIR_Coverage, 4933,
     /* 410420 */     GIR_EraseRootFromParent_Done,
     /* 410421 */   // Label 7960: @410421
     /* 410421 */   GIM_Try, /*On fail goto*//*Label 7961*/ GIMT_Encode4(410518), // Rule ID 4897 //
     /* 410426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 410429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 410437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 410445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 410449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 410453 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410457 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 410461 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410466 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 410470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410474 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 410476 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 410476 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 410479 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 410483 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 410488 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 410494 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410499 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 410507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 410509 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 410511 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 410514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 410516 */     GIR_RootConstrainSelectedInstOperands,
     /* 410517 */     // GIR_Coverage, 4897,
     /* 410517 */     GIR_EraseRootFromParent_Done,
     /* 410518 */   // Label 7961: @410518
     /* 410518 */   GIM_Try, /*On fail goto*//*Label 7962*/ GIMT_Encode4(410596), // Rule ID 6282 //
     /* 410523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 410531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410535 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 410539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 410543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410547 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410551 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410556 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 410560 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410564 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 410568 */     // MIs[3] Operand 1
     /* 410568 */     // No operand predicates
     /* 410568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410576 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410578 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 410578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 410581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 410587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 410594 */     GIR_RootConstrainSelectedInstOperands,
     /* 410595 */     // GIR_Coverage, 6282,
     /* 410595 */     GIR_EraseRootFromParent_Done,
     /* 410596 */   // Label 7962: @410596
     /* 410596 */   GIM_Try, /*On fail goto*//*Label 7963*/ GIMT_Encode4(410680), // Rule ID 6194 //
     /* 410601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 410612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410616 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 410620 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410625 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 410629 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410633 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 410637 */     // MIs[2] Operand 1
     /* 410637 */     // No operand predicates
     /* 410637 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 410641 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410645 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 410649 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410658 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410660 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 410660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 410663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410665 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 410671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 410675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 410678 */     GIR_RootConstrainSelectedInstOperands,
     /* 410679 */     // GIR_Coverage, 6194,
     /* 410679 */     GIR_EraseRootFromParent_Done,
     /* 410680 */   // Label 7963: @410680
     /* 410680 */   GIM_Try, /*On fail goto*//*Label 7964*/ GIMT_Encode4(410761), // Rule ID 6226 //
     /* 410685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 410700 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 410704 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 410708 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410712 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 410716 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410721 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 410725 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410729 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 410733 */     // MIs[3] Operand 1
     /* 410733 */     // No operand predicates
     /* 410733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410741 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410743 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 410743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 410746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 410752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410756 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 410759 */     GIR_RootConstrainSelectedInstOperands,
     /* 410760 */     // GIR_Coverage, 6226,
     /* 410760 */     GIR_EraseRootFromParent_Done,
     /* 410761 */   // Label 7964: @410761
     /* 410761 */   GIM_Try, /*On fail goto*//*Label 7965*/ GIMT_Encode4(410845), // Rule ID 6258 //
     /* 410766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 410781 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 410790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 410794 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410798 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 410802 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410807 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 410811 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410815 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 410819 */     // MIs[3] Operand 1
     /* 410819 */     // No operand predicates
     /* 410819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410823 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410825 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 410825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 410828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 410836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410840 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 410843 */     GIR_RootConstrainSelectedInstOperands,
     /* 410844 */     // GIR_Coverage, 6258,
     /* 410844 */     GIR_EraseRootFromParent_Done,
     /* 410845 */   // Label 7965: @410845
     /* 410845 */   GIM_Try, /*On fail goto*//*Label 7966*/ GIMT_Encode4(410923), // Rule ID 6304 //
     /* 410850 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 410858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 410862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410866 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 410870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 410874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410878 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410882 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410887 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 410891 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410895 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 410899 */     // MIs[3] Operand 1
     /* 410899 */     // No operand predicates
     /* 410899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410903 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410905 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 410905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 410908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410912 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 410914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410918 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 410921 */     GIR_RootConstrainSelectedInstOperands,
     /* 410922 */     // GIR_Coverage, 6304,
     /* 410922 */     GIR_EraseRootFromParent_Done,
     /* 410923 */   // Label 7966: @410923
     /* 410923 */   GIM_Try, /*On fail goto*//*Label 7967*/ GIMT_Encode4(411004), // Rule ID 6162 //
     /* 410928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 410939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 410947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 410951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 410955 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410959 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 410963 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410968 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 410972 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410976 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 410980 */     // MIs[3] Operand 1
     /* 410980 */     // No operand predicates
     /* 410980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410984 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410986 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 410986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 410989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410993 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 410995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 411002 */     GIR_RootConstrainSelectedInstOperands,
     /* 411003 */     // GIR_Coverage, 6162,
     /* 411003 */     GIR_EraseRootFromParent_Done,
     /* 411004 */   // Label 7967: @411004
     /* 411004 */   GIM_Try, /*On fail goto*//*Label 7968*/ GIMT_Encode4(411089), // Rule ID 2468 //
     /* 411009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 411012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 411020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411024 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 411028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411033 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 411037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 411047 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 411047 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 411050 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 411054 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 411059 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 411065 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411070 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 411078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 411080 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 411083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 411085 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 411087 */     GIR_RootConstrainSelectedInstOperands,
     /* 411088 */     // GIR_Coverage, 2468,
     /* 411088 */     GIR_EraseRootFromParent_Done,
     /* 411089 */   // Label 7968: @411089
     /* 411089 */   GIM_Try, /*On fail goto*//*Label 7969*/ GIMT_Encode4(411174), // Rule ID 2466 //
     /* 411094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 411097 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 411109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 411117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411122 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 411126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 411132 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 411132 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 411135 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 411139 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 411144 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 411150 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411155 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 411163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 411165 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411167 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 411170 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 411172 */     GIR_RootConstrainSelectedInstOperands,
     /* 411173 */     // GIR_Coverage, 2466,
     /* 411173 */     GIR_EraseRootFromParent_Done,
     /* 411174 */   // Label 7969: @411174
     /* 411174 */   GIM_Try, /*On fail goto*//*Label 7970*/ GIMT_Encode4(411243), // Rule ID 2551 //
     /* 411179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 411190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411194 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 411198 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411203 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 411207 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411211 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 411215 */     // MIs[2] Operand 1
     /* 411215 */     // No operand predicates
     /* 411215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411223 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 411225 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 411225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 411228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 411234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 411238 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 411241 */     GIR_RootConstrainSelectedInstOperands,
     /* 411242 */     // GIR_Coverage, 2551,
     /* 411242 */     GIR_EraseRootFromParent_Done,
     /* 411243 */   // Label 7970: @411243
     /* 411243 */   GIM_Try, /*On fail goto*//*Label 7971*/ GIMT_Encode4(411312), // Rule ID 6130 //
     /* 411248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411251 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 411263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411267 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 411271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 411280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411284 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 411288 */     // MIs[2] Operand 1
     /* 411288 */     // No operand predicates
     /* 411288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 411294 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 411294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 411297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411301 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 411307 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 411310 */     GIR_RootConstrainSelectedInstOperands,
     /* 411311 */     // GIR_Coverage, 6130,
     /* 411311 */     GIR_EraseRootFromParent_Done,
     /* 411312 */   // Label 7971: @411312
     /* 411312 */   GIM_Try, /*On fail goto*//*Label 7972*/ GIMT_Encode4(411362), // Rule ID 13445 //
     /* 411317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 411320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 411332 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 411347 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 411347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 411350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 411352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 411354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 411358 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 411360 */     GIR_RootConstrainSelectedInstOperands,
     /* 411361 */     // GIR_Coverage, 13445,
     /* 411361 */     GIR_EraseRootFromParent_Done,
     /* 411362 */   // Label 7972: @411362
     /* 411362 */   GIM_Try, /*On fail goto*//*Label 7973*/ GIMT_Encode4(411412), // Rule ID 647 //
     /* 411367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 411370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 411386 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 411397 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 411397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 411400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 411402 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 411408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 411410 */     GIR_RootConstrainSelectedInstOperands,
     /* 411411 */     // GIR_Coverage, 647,
     /* 411411 */     GIR_EraseRootFromParent_Done,
     /* 411412 */   // Label 7973: @411412
     /* 411412 */   GIM_Try, /*On fail goto*//*Label 7974*/ GIMT_Encode4(411462), // Rule ID 659 //
     /* 411417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 411420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 411432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 411440 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 411447 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 411447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 411450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 411452 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 411456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 411460 */     GIR_RootConstrainSelectedInstOperands,
     /* 411461 */     // GIR_Coverage, 659,
     /* 411461 */     GIR_EraseRootFromParent_Done,
     /* 411462 */   // Label 7974: @411462
     /* 411462 */   GIM_Try, /*On fail goto*//*Label 7975*/ GIMT_Encode4(411493), // Rule ID 641 //
     /* 411467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 411470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411482 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 411482 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 411487 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 411491 */     GIR_RootConstrainSelectedInstOperands,
     /* 411492 */     // GIR_Coverage, 641,
     /* 411492 */     GIR_Done,
     /* 411493 */   // Label 7975: @411493
     /* 411493 */   GIM_Reject,
     /* 411494 */ // Label 7945: @411494
     /* 411494 */ GIM_Reject,
     /* 411495 */ // Label 7879: @411495
     /* 411495 */ GIM_Try, /*On fail goto*//*Label 7976*/ GIMT_Encode4(413015),
     /* 411500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 411503 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 411506 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 411509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411513 */   GIM_Try, /*On fail goto*//*Label 7977*/ GIMT_Encode4(411591), // Rule ID 6262 //
     /* 411518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 411526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 411530 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 411534 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 411538 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411542 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 411546 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411551 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 411555 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411559 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 411563 */     // MIs[3] Operand 1
     /* 411563 */     // No operand predicates
     /* 411563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411571 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411573 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 411573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 411576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 411582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 411586 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 411589 */     GIR_RootConstrainSelectedInstOperands,
     /* 411590 */     // GIR_Coverage, 6262,
     /* 411590 */     GIR_EraseRootFromParent_Done,
     /* 411591 */   // Label 7977: @411591
     /* 411591 */   GIM_Try, /*On fail goto*//*Label 7978*/ GIMT_Encode4(411675), // Rule ID 6178 //
     /* 411596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 411607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 411611 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 411615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 411624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411628 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 411632 */     // MIs[2] Operand 1
     /* 411632 */     // No operand predicates
     /* 411632 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 411636 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411640 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 411644 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411653 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411655 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 411655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 411658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411660 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 411666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 411670 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 411673 */     GIR_RootConstrainSelectedInstOperands,
     /* 411674 */     // GIR_Coverage, 6178,
     /* 411674 */     GIR_EraseRootFromParent_Done,
     /* 411675 */   // Label 7978: @411675
     /* 411675 */   GIM_Try, /*On fail goto*//*Label 7979*/ GIMT_Encode4(411756), // Rule ID 6210 //
     /* 411680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 411695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 411699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 411703 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 411707 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 411711 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411716 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 411720 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411724 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 411728 */     // MIs[3] Operand 1
     /* 411728 */     // No operand predicates
     /* 411728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411736 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411738 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 411738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 411741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 411747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 411751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 411754 */     GIR_RootConstrainSelectedInstOperands,
     /* 411755 */     // GIR_Coverage, 6210,
     /* 411755 */     GIR_EraseRootFromParent_Done,
     /* 411756 */   // Label 7979: @411756
     /* 411756 */   GIM_Try, /*On fail goto*//*Label 7980*/ GIMT_Encode4(411840), // Rule ID 6242 //
     /* 411761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 411776 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411781 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 411785 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 411789 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 411793 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 411797 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411802 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 411806 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411810 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 411814 */     // MIs[3] Operand 1
     /* 411814 */     // No operand predicates
     /* 411814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411818 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411820 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 411820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 411823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 411831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 411835 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 411838 */     GIR_RootConstrainSelectedInstOperands,
     /* 411839 */     // GIR_Coverage, 6242,
     /* 411839 */     GIR_EraseRootFromParent_Done,
     /* 411840 */   // Label 7980: @411840
     /* 411840 */   GIM_Try, /*On fail goto*//*Label 7981*/ GIMT_Encode4(411918), // Rule ID 6284 //
     /* 411845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 411857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 411861 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 411865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 411869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411873 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 411877 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411882 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 411886 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411890 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 411894 */     // MIs[3] Operand 1
     /* 411894 */     // No operand predicates
     /* 411894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411898 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411900 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 411900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 411903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411907 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 411913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 411916 */     GIR_RootConstrainSelectedInstOperands,
     /* 411917 */     // GIR_Coverage, 6284,
     /* 411917 */     GIR_EraseRootFromParent_Done,
     /* 411918 */   // Label 7981: @411918
     /* 411918 */   GIM_Try, /*On fail goto*//*Label 7982*/ GIMT_Encode4(411999), // Rule ID 6146 //
     /* 411923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 411942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 411946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 411950 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 411954 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 411958 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411963 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 411967 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411971 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 411975 */     // MIs[3] Operand 1
     /* 411975 */     // No operand predicates
     /* 411975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411979 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411981 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 411981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 411984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411988 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 411994 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 411997 */     GIR_RootConstrainSelectedInstOperands,
     /* 411998 */     // GIR_Coverage, 6146,
     /* 411998 */     GIR_EraseRootFromParent_Done,
     /* 411999 */   // Label 7982: @411999
     /* 411999 */   GIM_Try, /*On fail goto*//*Label 7983*/ GIMT_Encode4(412068), // Rule ID 2535 //
     /* 412004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 412015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 412019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 412023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412028 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 412032 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412036 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 412040 */     // MIs[2] Operand 1
     /* 412040 */     // No operand predicates
     /* 412040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412048 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412050 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 412050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 412053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 412059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 412063 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 412066 */     GIR_RootConstrainSelectedInstOperands,
     /* 412067 */     // GIR_Coverage, 2535,
     /* 412067 */     GIR_EraseRootFromParent_Done,
     /* 412068 */   // Label 7983: @412068
     /* 412068 */   GIM_Try, /*On fail goto*//*Label 7984*/ GIMT_Encode4(412137), // Rule ID 6114 //
     /* 412073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 412088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 412092 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 412096 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 412105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412109 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 412113 */     // MIs[2] Operand 1
     /* 412113 */     // No operand predicates
     /* 412113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412117 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412119 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 412119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 412122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412126 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 412132 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 412135 */     GIR_RootConstrainSelectedInstOperands,
     /* 412136 */     // GIR_Coverage, 6114,
     /* 412136 */     GIR_EraseRootFromParent_Done,
     /* 412137 */   // Label 7984: @412137
     /* 412137 */   GIM_Try, /*On fail goto*//*Label 7985*/ GIMT_Encode4(412230), // Rule ID 6266 //
     /* 412142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 412150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 412154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 412158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412162 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 412166 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 412171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412179 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412181 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 412181 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 412184 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412188 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412193 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 412196 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412200 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 412203 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412208 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 412213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 412216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 412222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412228 */     GIR_RootConstrainSelectedInstOperands,
     /* 412229 */     // GIR_Coverage, 6266,
     /* 412229 */     GIR_EraseRootFromParent_Done,
     /* 412230 */   // Label 7985: @412230
     /* 412230 */   GIM_Try, /*On fail goto*//*Label 7986*/ GIMT_Encode4(412329), // Rule ID 6180 //
     /* 412235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 412246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 412250 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 412255 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 412259 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412263 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 412267 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412276 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412278 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 412278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 412281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412290 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 412293 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 412297 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 412300 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412305 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 412310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 412313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 412321 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412327 */     GIR_RootConstrainSelectedInstOperands,
     /* 412328 */     // GIR_Coverage, 6180,
     /* 412328 */     GIR_EraseRootFromParent_Done,
     /* 412329 */   // Label 7986: @412329
     /* 412329 */   GIM_Try, /*On fail goto*//*Label 7987*/ GIMT_Encode4(412425), // Rule ID 6212 //
     /* 412334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 412349 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 412353 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 412357 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 412361 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 412366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412374 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412376 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 412376 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 412379 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412383 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412388 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 412391 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412395 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 412398 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412403 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 412408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 412411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412413 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 412417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412423 */     GIR_RootConstrainSelectedInstOperands,
     /* 412424 */     // GIR_Coverage, 6212,
     /* 412424 */     GIR_EraseRootFromParent_Done,
     /* 412425 */   // Label 7987: @412425
     /* 412425 */   GIM_Try, /*On fail goto*//*Label 7988*/ GIMT_Encode4(412524), // Rule ID 6244 //
     /* 412430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 412445 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 412454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 412458 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 412462 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 412467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412471 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412473 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 412473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 412476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412485 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 412488 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412492 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 412495 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412500 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 412505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 412508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 412516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412522 */     GIR_RootConstrainSelectedInstOperands,
     /* 412523 */     // GIR_Coverage, 6244,
     /* 412523 */     GIR_EraseRootFromParent_Done,
     /* 412524 */   // Label 7988: @412524
     /* 412524 */   GIM_Try, /*On fail goto*//*Label 7989*/ GIMT_Encode4(412617), // Rule ID 6288 //
     /* 412529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 412541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 412545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 412549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412553 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 412557 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 412562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412566 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412568 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 412568 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 412571 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412575 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412580 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 412583 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412587 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 412590 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412595 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 412600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 412603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412605 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412607 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412609 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412615 */     GIR_RootConstrainSelectedInstOperands,
     /* 412616 */     // GIR_Coverage, 6288,
     /* 412616 */     GIR_EraseRootFromParent_Done,
     /* 412617 */   // Label 7989: @412617
     /* 412617 */   GIM_Try, /*On fail goto*//*Label 7990*/ GIMT_Encode4(412713), // Rule ID 6148 //
     /* 412622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 412641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 412645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 412649 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 412653 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 412658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412662 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412664 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 412664 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 412667 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412671 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412676 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 412679 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412683 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 412686 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412691 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 412696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 412699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412701 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412703 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412705 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412711 */     GIR_RootConstrainSelectedInstOperands,
     /* 412712 */     // GIR_Coverage, 6148,
     /* 412712 */     GIR_EraseRootFromParent_Done,
     /* 412713 */   // Label 7990: @412713
     /* 412713 */   GIM_Try, /*On fail goto*//*Label 7991*/ GIMT_Encode4(412797), // Rule ID 2537 //
     /* 412718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 412729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 412733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 412738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412746 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412748 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 412748 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 412751 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412755 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412760 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 412763 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 412767 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 412770 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412775 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 412780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 412783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412785 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 412789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412795 */     GIR_RootConstrainSelectedInstOperands,
     /* 412796 */     // GIR_Coverage, 2537,
     /* 412796 */     GIR_EraseRootFromParent_Done,
     /* 412797 */   // Label 7991: @412797
     /* 412797 */   GIM_Try, /*On fail goto*//*Label 7992*/ GIMT_Encode4(412847), // Rule ID 13475 //
     /* 412802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 412817 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412832 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 412832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 412835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 412841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 412845 */     GIR_RootConstrainSelectedInstOperands,
     /* 412846 */     // GIR_Coverage, 13475,
     /* 412846 */     GIR_EraseRootFromParent_Done,
     /* 412847 */   // Label 7992: @412847
     /* 412847 */   GIM_Try, /*On fail goto*//*Label 7993*/ GIMT_Encode4(412931), // Rule ID 6116 //
     /* 412852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 412867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 412871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 412876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412882 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 412882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 412885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412894 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 412897 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 412901 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 412904 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412909 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 412914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 412917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412921 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412923 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412929 */     GIR_RootConstrainSelectedInstOperands,
     /* 412930 */     // GIR_Coverage, 6116,
     /* 412930 */     GIR_EraseRootFromParent_Done,
     /* 412931 */   // Label 7993: @412931
     /* 412931 */   GIM_Try, /*On fail goto*//*Label 7994*/ GIMT_Encode4(412981), // Rule ID 1307 //
     /* 412936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 412955 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412966 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 412966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 412969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412973 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 412979 */     GIR_RootConstrainSelectedInstOperands,
     /* 412980 */     // GIR_Coverage, 1307,
     /* 412980 */     GIR_EraseRootFromParent_Done,
     /* 412981 */   // Label 7994: @412981
     /* 412981 */   GIM_Try, /*On fail goto*//*Label 7995*/ GIMT_Encode4(413014), // Rule ID 1297 //
     /* 412986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412989 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413001 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 413001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f32),
     /* 413004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413010 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 413012 */     GIR_RootConstrainSelectedInstOperands,
     /* 413013 */     // GIR_Coverage, 1297,
     /* 413013 */     GIR_EraseRootFromParent_Done,
     /* 413014 */   // Label 7995: @413014
     /* 413014 */   GIM_Reject,
     /* 413015 */ // Label 7976: @413015
     /* 413015 */ GIM_Reject,
     /* 413016 */ // Label 7880: @413016
     /* 413016 */ GIM_Try, /*On fail goto*//*Label 7996*/ GIMT_Encode4(414536),
     /* 413021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 413024 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 413027 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 413030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413034 */   GIM_Try, /*On fail goto*//*Label 7997*/ GIMT_Encode4(413112), // Rule ID 6274 //
     /* 413039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 413047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 413051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 413055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 413059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 413067 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413072 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 413076 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413080 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 413084 */     // MIs[3] Operand 1
     /* 413084 */     // No operand predicates
     /* 413084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413092 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413094 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 413094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 413097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413107 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 413110 */     GIR_RootConstrainSelectedInstOperands,
     /* 413111 */     // GIR_Coverage, 6274,
     /* 413111 */     GIR_EraseRootFromParent_Done,
     /* 413112 */   // Label 7997: @413112
     /* 413112 */   GIM_Try, /*On fail goto*//*Label 7998*/ GIMT_Encode4(413196), // Rule ID 6186 //
     /* 413117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 413128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 413132 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 413136 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 413145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413149 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 413153 */     // MIs[2] Operand 1
     /* 413153 */     // No operand predicates
     /* 413153 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 413157 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413161 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 413165 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413174 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413176 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 413176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 413179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 413187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 413191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 413194 */     GIR_RootConstrainSelectedInstOperands,
     /* 413195 */     // GIR_Coverage, 6186,
     /* 413195 */     GIR_EraseRootFromParent_Done,
     /* 413196 */   // Label 7998: @413196
     /* 413196 */   GIM_Try, /*On fail goto*//*Label 7999*/ GIMT_Encode4(413277), // Rule ID 6218 //
     /* 413201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 413216 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 413220 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 413224 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 413228 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 413232 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413237 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413241 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413245 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 413249 */     // MIs[3] Operand 1
     /* 413249 */     // No operand predicates
     /* 413249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413257 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413259 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 413259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 413262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413272 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 413275 */     GIR_RootConstrainSelectedInstOperands,
     /* 413276 */     // GIR_Coverage, 6218,
     /* 413276 */     GIR_EraseRootFromParent_Done,
     /* 413277 */   // Label 7999: @413277
     /* 413277 */   GIM_Try, /*On fail goto*//*Label 8000*/ GIMT_Encode4(413361), // Rule ID 6250 //
     /* 413282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 413297 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 413306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 413310 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 413314 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 413318 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413323 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413327 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413331 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 413335 */     // MIs[3] Operand 1
     /* 413335 */     // No operand predicates
     /* 413335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413339 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413341 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 413341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 413344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413348 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 413352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413356 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 413359 */     GIR_RootConstrainSelectedInstOperands,
     /* 413360 */     // GIR_Coverage, 6250,
     /* 413360 */     GIR_EraseRootFromParent_Done,
     /* 413361 */   // Label 8000: @413361
     /* 413361 */   GIM_Try, /*On fail goto*//*Label 8001*/ GIMT_Encode4(413439), // Rule ID 6296 //
     /* 413366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 413378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 413382 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 413386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 413390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413394 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 413398 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413403 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 413407 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413411 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 413415 */     // MIs[3] Operand 1
     /* 413415 */     // No operand predicates
     /* 413415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413419 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413421 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 413421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 413424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413426 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413428 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413434 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 413437 */     GIR_RootConstrainSelectedInstOperands,
     /* 413438 */     // GIR_Coverage, 6296,
     /* 413438 */     GIR_EraseRootFromParent_Done,
     /* 413439 */   // Label 8001: @413439
     /* 413439 */   GIM_Try, /*On fail goto*//*Label 8002*/ GIMT_Encode4(413520), // Rule ID 6154 //
     /* 413444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413447 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 413463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 413467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 413471 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 413475 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 413479 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413484 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413488 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413492 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 413496 */     // MIs[3] Operand 1
     /* 413496 */     // No operand predicates
     /* 413496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413500 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413502 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 413502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 413505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413507 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413509 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413515 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 413518 */     GIR_RootConstrainSelectedInstOperands,
     /* 413519 */     // GIR_Coverage, 6154,
     /* 413519 */     GIR_EraseRootFromParent_Done,
     /* 413520 */   // Label 8002: @413520
     /* 413520 */   GIM_Try, /*On fail goto*//*Label 8003*/ GIMT_Encode4(413589), // Rule ID 2543 //
     /* 413525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 413536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 413540 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 413544 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 413553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413557 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 413561 */     // MIs[2] Operand 1
     /* 413561 */     // No operand predicates
     /* 413561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413569 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 413571 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 413571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 413574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413576 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 413584 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 413587 */     GIR_RootConstrainSelectedInstOperands,
     /* 413588 */     // GIR_Coverage, 2543,
     /* 413588 */     GIR_EraseRootFromParent_Done,
     /* 413589 */   // Label 8003: @413589
     /* 413589 */   GIM_Try, /*On fail goto*//*Label 8004*/ GIMT_Encode4(413658), // Rule ID 6122 //
     /* 413594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 413609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 413613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 413617 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 413626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413630 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 413634 */     // MIs[2] Operand 1
     /* 413634 */     // No operand predicates
     /* 413634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413638 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 413640 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 413640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 413643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413647 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 413653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 413656 */     GIR_RootConstrainSelectedInstOperands,
     /* 413657 */     // GIR_Coverage, 6122,
     /* 413657 */     GIR_EraseRootFromParent_Done,
     /* 413658 */   // Label 8004: @413658
     /* 413658 */   GIM_Try, /*On fail goto*//*Label 8005*/ GIMT_Encode4(413751), // Rule ID 6276 //
     /* 413663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 413671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 413675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 413679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413683 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 413687 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413700 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 413702 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 413702 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 413705 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 413709 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 413714 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 413717 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413721 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 413724 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413729 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 413737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413739 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413743 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 413746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413749 */     GIR_RootConstrainSelectedInstOperands,
     /* 413750 */     // GIR_Coverage, 6276,
     /* 413750 */     GIR_EraseRootFromParent_Done,
     /* 413751 */   // Label 8005: @413751
     /* 413751 */   GIM_Try, /*On fail goto*//*Label 8006*/ GIMT_Encode4(413850), // Rule ID 6188 //
     /* 413756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 413767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 413771 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413776 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 413780 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413784 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 413788 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413797 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 413799 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 413799 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 413802 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 413806 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 413811 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 413814 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 413818 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 413821 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413826 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 413834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413836 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 413842 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 413845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413848 */     GIR_RootConstrainSelectedInstOperands,
     /* 413849 */     // GIR_Coverage, 6188,
     /* 413849 */     GIR_EraseRootFromParent_Done,
     /* 413850 */   // Label 8006: @413850
     /* 413850 */   GIM_Try, /*On fail goto*//*Label 8007*/ GIMT_Encode4(413946), // Rule ID 6220 //
     /* 413855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 413870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 413874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 413878 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 413882 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413895 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 413897 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 413897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 413900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 413904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 413909 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 413912 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413916 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 413919 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413924 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 413932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413938 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 413941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413944 */     GIR_RootConstrainSelectedInstOperands,
     /* 413945 */     // GIR_Coverage, 6220,
     /* 413945 */     GIR_EraseRootFromParent_Done,
     /* 413946 */   // Label 8007: @413946
     /* 413946 */   GIM_Try, /*On fail goto*//*Label 8008*/ GIMT_Encode4(414045), // Rule ID 6252 //
     /* 413951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 413966 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 413975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 413979 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 413983 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413992 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 413994 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 413994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 413997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 414001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 414006 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 414009 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414013 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 414016 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414021 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 414029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414031 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 414037 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 414040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414043 */     GIR_RootConstrainSelectedInstOperands,
     /* 414044 */     // GIR_Coverage, 6252,
     /* 414044 */     GIR_EraseRootFromParent_Done,
     /* 414045 */   // Label 8008: @414045
     /* 414045 */   GIM_Try, /*On fail goto*//*Label 8009*/ GIMT_Encode4(414138), // Rule ID 6298 //
     /* 414050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 414058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 414062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 414066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 414070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414074 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 414078 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414087 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 414089 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 414089 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 414092 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 414096 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 414101 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 414104 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414108 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 414111 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414116 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 414124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414128 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 414130 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 414133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414136 */     GIR_RootConstrainSelectedInstOperands,
     /* 414137 */     // GIR_Coverage, 6298,
     /* 414137 */     GIR_EraseRootFromParent_Done,
     /* 414138 */   // Label 8009: @414138
     /* 414138 */   GIM_Try, /*On fail goto*//*Label 8010*/ GIMT_Encode4(414234), // Rule ID 6156 //
     /* 414143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 414154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 414162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 414166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 414170 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 414174 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414183 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 414185 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 414185 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 414188 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 414192 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 414197 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 414200 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414204 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 414207 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414212 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 414220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414224 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 414226 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 414229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414232 */     GIR_RootConstrainSelectedInstOperands,
     /* 414233 */     // GIR_Coverage, 6156,
     /* 414233 */     GIR_EraseRootFromParent_Done,
     /* 414234 */   // Label 8010: @414234
     /* 414234 */   GIM_Try, /*On fail goto*//*Label 8011*/ GIMT_Encode4(414318), // Rule ID 2545 //
     /* 414239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 414250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 414254 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 414269 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 414269 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 414272 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 414276 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 414281 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 414284 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414288 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 414291 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414296 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 414304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414306 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 414310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 414313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414316 */     GIR_RootConstrainSelectedInstOperands,
     /* 414317 */     // GIR_Coverage, 2545,
     /* 414317 */     GIR_EraseRootFromParent_Done,
     /* 414318 */   // Label 8011: @414318
     /* 414318 */   GIM_Try, /*On fail goto*//*Label 8012*/ GIMT_Encode4(414368), // Rule ID 13479 //
     /* 414323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 414338 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 414353 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 414353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 414356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414358 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 414362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414366 */     GIR_RootConstrainSelectedInstOperands,
     /* 414367 */     // GIR_Coverage, 13479,
     /* 414367 */     GIR_EraseRootFromParent_Done,
     /* 414368 */   // Label 8012: @414368
     /* 414368 */   GIM_Try, /*On fail goto*//*Label 8013*/ GIMT_Encode4(414452), // Rule ID 6124 //
     /* 414373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 414384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 414388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 414392 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 414403 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 414403 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 414406 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 414410 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 414415 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 414418 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414422 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 414425 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414430 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 414438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414442 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 414444 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 414447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414450 */     GIR_RootConstrainSelectedInstOperands,
     /* 414451 */     // GIR_Coverage, 6124,
     /* 414451 */     GIR_EraseRootFromParent_Done,
     /* 414452 */   // Label 8013: @414452
     /* 414452 */   GIM_Try, /*On fail goto*//*Label 8014*/ GIMT_Encode4(414502), // Rule ID 1311 //
     /* 414457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 414468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 414476 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 414487 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 414487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 414490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414492 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414494 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 414496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414500 */     GIR_RootConstrainSelectedInstOperands,
     /* 414501 */     // GIR_Coverage, 1311,
     /* 414501 */     GIR_EraseRootFromParent_Done,
     /* 414502 */   // Label 8014: @414502
     /* 414502 */   GIM_Try, /*On fail goto*//*Label 8015*/ GIMT_Encode4(414535), // Rule ID 1301 //
     /* 414507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414522 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 414522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f64),
     /* 414525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414527 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 414531 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 414533 */     GIR_RootConstrainSelectedInstOperands,
     /* 414534 */     // GIR_Coverage, 1301,
     /* 414534 */     GIR_EraseRootFromParent_Done,
     /* 414535 */   // Label 8015: @414535
     /* 414535 */   GIM_Reject,
     /* 414536 */ // Label 7996: @414536
     /* 414536 */ GIM_Reject,
     /* 414537 */ // Label 7881: @414537
     /* 414537 */ GIM_Try, /*On fail goto*//*Label 8016*/ GIMT_Encode4(415715),
     /* 414542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 414545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 414548 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 414551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414555 */   GIM_Try, /*On fail goto*//*Label 8017*/ GIMT_Encode4(414639), // Rule ID 6170 //
     /* 414560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 414563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 414571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414575 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 414579 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 414584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 414588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414592 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 414596 */     // MIs[2] Operand 1
     /* 414596 */     // No operand predicates
     /* 414596 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 414600 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414604 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 414608 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414617 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414619 */     // (strict_fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 414619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 414622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 414630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414634 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 414637 */     GIR_RootConstrainSelectedInstOperands,
     /* 414638 */     // GIR_Coverage, 6170,
     /* 414638 */     GIR_EraseRootFromParent_Done,
     /* 414639 */   // Label 8017: @414639
     /* 414639 */   GIM_Try, /*On fail goto*//*Label 8018*/ GIMT_Encode4(414720), // Rule ID 6202 //
     /* 414644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 414647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 414659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 414663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 414667 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414671 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 414675 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 414680 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 414684 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414688 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 414692 */     // MIs[3] Operand 1
     /* 414692 */     // No operand predicates
     /* 414692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414700 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414702 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 414702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 414705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414707 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 414711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 414718 */     GIR_RootConstrainSelectedInstOperands,
     /* 414719 */     // GIR_Coverage, 6202,
     /* 414719 */     GIR_EraseRootFromParent_Done,
     /* 414720 */   // Label 8018: @414720
     /* 414720 */   GIM_Try, /*On fail goto*//*Label 8019*/ GIMT_Encode4(414804), // Rule ID 6234 //
     /* 414725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 414728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 414740 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 414749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 414753 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414757 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 414761 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 414766 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 414770 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414774 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 414778 */     // MIs[3] Operand 1
     /* 414778 */     // No operand predicates
     /* 414778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414782 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414784 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 414784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 414787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 414795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 414802 */     GIR_RootConstrainSelectedInstOperands,
     /* 414803 */     // GIR_Coverage, 6234,
     /* 414803 */     GIR_EraseRootFromParent_Done,
     /* 414804 */   // Label 8019: @414804
     /* 414804 */   GIM_Try, /*On fail goto*//*Label 8020*/ GIMT_Encode4(414885), // Rule ID 6138 //
     /* 414809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 414812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 414820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 414828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 414832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 414836 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414840 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 414844 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 414849 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 414853 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414857 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 414861 */     // MIs[3] Operand 1
     /* 414861 */     // No operand predicates
     /* 414861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414865 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414867 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 414867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 414870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414874 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 414876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414880 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 414883 */     GIR_RootConstrainSelectedInstOperands,
     /* 414884 */     // GIR_Coverage, 6138,
     /* 414884 */     GIR_EraseRootFromParent_Done,
     /* 414885 */   // Label 8020: @414885
     /* 414885 */   GIM_Try, /*On fail goto*//*Label 8021*/ GIMT_Encode4(414954), // Rule ID 2527 //
     /* 414890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 414893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 414901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414905 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 414909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 414914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 414918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414922 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 414926 */     // MIs[2] Operand 1
     /* 414926 */     // No operand predicates
     /* 414926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414934 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 414936 */     // (strict_fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 414936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 414939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414941 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 414945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 414952 */     GIR_RootConstrainSelectedInstOperands,
     /* 414953 */     // GIR_Coverage, 2527,
     /* 414953 */     GIR_EraseRootFromParent_Done,
     /* 414954 */   // Label 8021: @414954
     /* 414954 */   GIM_Try, /*On fail goto*//*Label 8022*/ GIMT_Encode4(415023), // Rule ID 6106 //
     /* 414959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 414962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 414970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 414974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414978 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 414982 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 414987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 414991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414995 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 414999 */     // MIs[2] Operand 1
     /* 414999 */     // No operand predicates
     /* 414999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415003 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 415005 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 415005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 415008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415012 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 415018 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 415021 */     GIR_RootConstrainSelectedInstOperands,
     /* 415022 */     // GIR_Coverage, 6106,
     /* 415022 */     GIR_EraseRootFromParent_Done,
     /* 415023 */   // Label 8022: @415023
     /* 415023 */   GIM_Try, /*On fail goto*//*Label 8023*/ GIMT_Encode4(415122), // Rule ID 6172 //
     /* 415028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 415039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 415043 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 415052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415056 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 415060 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415069 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 415071 */     // (strict_fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 415071 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 415074 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 415078 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 415083 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 415086 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 415090 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 415093 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415098 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 415106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 415114 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 415117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415120 */     GIR_RootConstrainSelectedInstOperands,
     /* 415121 */     // GIR_Coverage, 6172,
     /* 415121 */     GIR_EraseRootFromParent_Done,
     /* 415122 */   // Label 8023: @415122
     /* 415122 */   GIM_Try, /*On fail goto*//*Label 8024*/ GIMT_Encode4(415218), // Rule ID 6204 //
     /* 415127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 415142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 415146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 415150 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 415154 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415167 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 415169 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 415169 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 415172 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 415176 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 415181 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 415184 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 415188 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 415191 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415196 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 415204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 415210 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 415213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415216 */     GIR_RootConstrainSelectedInstOperands,
     /* 415217 */     // GIR_Coverage, 6204,
     /* 415217 */     GIR_EraseRootFromParent_Done,
     /* 415218 */   // Label 8024: @415218
     /* 415218 */   GIM_Try, /*On fail goto*//*Label 8025*/ GIMT_Encode4(415317), // Rule ID 6236 //
     /* 415223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 415238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415243 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 415247 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 415251 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 415255 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415264 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 415266 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 415266 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 415269 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 415273 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 415278 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 415281 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 415285 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 415288 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415293 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 415301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 415309 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 415312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415315 */     GIR_RootConstrainSelectedInstOperands,
     /* 415316 */     // GIR_Coverage, 6236,
     /* 415316 */     GIR_EraseRootFromParent_Done,
     /* 415317 */   // Label 8025: @415317
     /* 415317 */   GIM_Try, /*On fail goto*//*Label 8026*/ GIMT_Encode4(415413), // Rule ID 6140 //
     /* 415322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 415333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 415341 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 415345 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 415349 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 415353 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415362 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 415364 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 415364 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 415367 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 415371 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 415376 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 415379 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 415383 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 415386 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415391 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 415399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415401 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415403 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415405 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 415408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415411 */     GIR_RootConstrainSelectedInstOperands,
     /* 415412 */     // GIR_Coverage, 6140,
     /* 415412 */     GIR_EraseRootFromParent_Done,
     /* 415413 */   // Label 8026: @415413
     /* 415413 */   GIM_Try, /*On fail goto*//*Label 8027*/ GIMT_Encode4(415497), // Rule ID 2529 //
     /* 415418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 415429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 415433 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 415448 */     // (strict_fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 415448 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 415451 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 415455 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 415460 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 415463 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 415467 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 415470 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415475 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 415483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 415489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 415492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415495 */     GIR_RootConstrainSelectedInstOperands,
     /* 415496 */     // GIR_Coverage, 2529,
     /* 415496 */     GIR_EraseRootFromParent_Done,
     /* 415497 */   // Label 8027: @415497
     /* 415497 */   GIM_Try, /*On fail goto*//*Label 8028*/ GIMT_Encode4(415547), // Rule ID 13471 //
     /* 415502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 415517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415530 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 415532 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 415532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 415535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 415541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 415545 */     GIR_RootConstrainSelectedInstOperands,
     /* 415546 */     // GIR_Coverage, 13471,
     /* 415546 */     GIR_EraseRootFromParent_Done,
     /* 415547 */   // Label 8028: @415547
     /* 415547 */   GIM_Try, /*On fail goto*//*Label 8029*/ GIMT_Encode4(415631), // Rule ID 6108 //
     /* 415552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 415563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 415567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 415571 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 415582 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 415582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 415585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 415589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 415594 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 415597 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 415601 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 415604 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415609 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 415617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415621 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415623 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 415626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415629 */     GIR_RootConstrainSelectedInstOperands,
     /* 415630 */     // GIR_Coverage, 6108,
     /* 415630 */     GIR_EraseRootFromParent_Done,
     /* 415631 */   // Label 8029: @415631
     /* 415631 */   GIM_Try, /*On fail goto*//*Label 8030*/ GIMT_Encode4(415681), // Rule ID 1303 //
     /* 415636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 415647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 415655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 415666 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 415666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 415669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415671 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415673 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 415679 */     GIR_RootConstrainSelectedInstOperands,
     /* 415680 */     // GIR_Coverage, 1303,
     /* 415680 */     GIR_EraseRootFromParent_Done,
     /* 415681 */   // Label 8030: @415681
     /* 415681 */   GIM_Try, /*On fail goto*//*Label 8031*/ GIMT_Encode4(415714), // Rule ID 1293 //
     /* 415686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415701 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 415701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f16),
     /* 415704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415706 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 415710 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 415712 */     GIR_RootConstrainSelectedInstOperands,
     /* 415713 */     // GIR_Coverage, 1293,
     /* 415713 */     GIR_EraseRootFromParent_Done,
     /* 415714 */   // Label 8031: @415714
     /* 415714 */   GIM_Reject,
     /* 415715 */ // Label 8016: @415715
     /* 415715 */ GIM_Reject,
     /* 415716 */ // Label 7882: @415716
     /* 415716 */ GIM_Try, /*On fail goto*//*Label 8032*/ GIMT_Encode4(417236),
     /* 415721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 415724 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 415727 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 415730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415734 */   GIM_Try, /*On fail goto*//*Label 8033*/ GIMT_Encode4(415812), // Rule ID 6268 //
     /* 415739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 415747 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 415751 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 415755 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 415759 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415763 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 415767 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415772 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 415776 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 415780 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 415784 */     // MIs[3] Operand 1
     /* 415784 */     // No operand predicates
     /* 415784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415792 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 415794 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 415794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 415797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415799 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 415803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 415807 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 415810 */     GIR_RootConstrainSelectedInstOperands,
     /* 415811 */     // GIR_Coverage, 6268,
     /* 415811 */     GIR_EraseRootFromParent_Done,
     /* 415812 */   // Label 8033: @415812
     /* 415812 */   GIM_Try, /*On fail goto*//*Label 8034*/ GIMT_Encode4(415896), // Rule ID 6182 //
     /* 415817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 415828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 415832 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 415836 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 415845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 415849 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 415853 */     // MIs[2] Operand 1
     /* 415853 */     // No operand predicates
     /* 415853 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 415857 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415861 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 415865 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415874 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 415876 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 415876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 415879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415881 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 415887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 415891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 415894 */     GIR_RootConstrainSelectedInstOperands,
     /* 415895 */     // GIR_Coverage, 6182,
     /* 415895 */     GIR_EraseRootFromParent_Done,
     /* 415896 */   // Label 8034: @415896
     /* 415896 */   GIM_Try, /*On fail goto*//*Label 8035*/ GIMT_Encode4(415977), // Rule ID 6214 //
     /* 415901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 415916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 415920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 415924 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 415928 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 415932 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415937 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 415941 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 415945 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 415949 */     // MIs[3] Operand 1
     /* 415949 */     // No operand predicates
     /* 415949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415957 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 415959 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 415959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 415962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 415968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 415972 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 415975 */     GIR_RootConstrainSelectedInstOperands,
     /* 415976 */     // GIR_Coverage, 6214,
     /* 415976 */     GIR_EraseRootFromParent_Done,
     /* 415977 */   // Label 8035: @415977
     /* 415977 */   GIM_Try, /*On fail goto*//*Label 8036*/ GIMT_Encode4(416061), // Rule ID 6246 //
     /* 415982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 415997 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 416006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 416010 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 416014 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 416018 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416023 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 416027 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 416031 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 416035 */     // MIs[3] Operand 1
     /* 416035 */     // No operand predicates
     /* 416035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416039 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 416041 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 416041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 416044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416046 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 416052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 416056 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 416059 */     GIR_RootConstrainSelectedInstOperands,
     /* 416060 */     // GIR_Coverage, 6246,
     /* 416060 */     GIR_EraseRootFromParent_Done,
     /* 416061 */   // Label 8036: @416061
     /* 416061 */   GIM_Try, /*On fail goto*//*Label 8037*/ GIMT_Encode4(416139), // Rule ID 6290 //
     /* 416066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 416074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 416078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 416082 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 416086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 416090 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 416094 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 416098 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416103 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 416107 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 416111 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 416115 */     // MIs[3] Operand 1
     /* 416115 */     // No operand predicates
     /* 416115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416119 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 416121 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 416121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 416124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416128 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 416134 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 416137 */     GIR_RootConstrainSelectedInstOperands,
     /* 416138 */     // GIR_Coverage, 6290,
     /* 416138 */     GIR_EraseRootFromParent_Done,
     /* 416139 */   // Label 8037: @416139
     /* 416139 */   GIM_Try, /*On fail goto*//*Label 8038*/ GIMT_Encode4(416220), // Rule ID 6150 //
     /* 416144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 416155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 416159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 416163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 416167 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 416171 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 416175 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 416179 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416184 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 416188 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 416192 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 416196 */     // MIs[3] Operand 1
     /* 416196 */     // No operand predicates
     /* 416196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416200 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 416202 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 416202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 416205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416207 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416209 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 416215 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 416218 */     GIR_RootConstrainSelectedInstOperands,
     /* 416219 */     // GIR_Coverage, 6150,
     /* 416219 */     GIR_EraseRootFromParent_Done,
     /* 416220 */   // Label 8038: @416220
     /* 416220 */   GIM_Try, /*On fail goto*//*Label 8039*/ GIMT_Encode4(416289), // Rule ID 2539 //
     /* 416225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 416236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 416240 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 416244 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 416253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 416257 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 416261 */     // MIs[2] Operand 1
     /* 416261 */     // No operand predicates
     /* 416261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416269 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 416271 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 416271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 416274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 416280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 416284 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 416287 */     GIR_RootConstrainSelectedInstOperands,
     /* 416288 */     // GIR_Coverage, 2539,
     /* 416288 */     GIR_EraseRootFromParent_Done,
     /* 416289 */   // Label 8039: @416289
     /* 416289 */   GIM_Try, /*On fail goto*//*Label 8040*/ GIMT_Encode4(416358), // Rule ID 6118 //
     /* 416294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416297 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 416305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 416309 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 416313 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 416317 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416322 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 416326 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 416330 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 416334 */     // MIs[2] Operand 1
     /* 416334 */     // No operand predicates
     /* 416334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416338 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 416340 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 416340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 416343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416345 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416347 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 416353 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 416356 */     GIR_RootConstrainSelectedInstOperands,
     /* 416357 */     // GIR_Coverage, 6118,
     /* 416357 */     GIR_EraseRootFromParent_Done,
     /* 416358 */   // Label 8040: @416358
     /* 416358 */   GIM_Try, /*On fail goto*//*Label 8041*/ GIMT_Encode4(416451), // Rule ID 6272 //
     /* 416363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 416371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 416375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 416379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 416383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 416387 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 416392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416400 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 416402 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 416402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 416405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 416409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 416414 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 416417 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 416421 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 416424 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416429 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 416434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 416437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 416443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 416446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416449 */     GIR_RootConstrainSelectedInstOperands,
     /* 416450 */     // GIR_Coverage, 6272,
     /* 416450 */     GIR_EraseRootFromParent_Done,
     /* 416451 */   // Label 8041: @416451
     /* 416451 */   GIM_Try, /*On fail goto*//*Label 8042*/ GIMT_Encode4(416550), // Rule ID 6184 //
     /* 416456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 416467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 416471 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 416476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 416480 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 416484 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 416488 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416497 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 416499 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 416499 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 416502 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 416506 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 416511 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 416514 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 416518 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 416521 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416526 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 416531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 416534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 416542 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 416545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416548 */     GIR_RootConstrainSelectedInstOperands,
     /* 416549 */     // GIR_Coverage, 6184,
     /* 416549 */     GIR_EraseRootFromParent_Done,
     /* 416550 */   // Label 8042: @416550
     /* 416550 */   GIM_Try, /*On fail goto*//*Label 8043*/ GIMT_Encode4(416646), // Rule ID 6216 //
     /* 416555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 416566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 416570 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 416574 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 416578 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 416582 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 416587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416595 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 416597 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 416597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 416600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 416604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 416609 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 416612 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 416616 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 416619 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416624 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 416629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 416632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 416638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 416641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416644 */     GIR_RootConstrainSelectedInstOperands,
     /* 416645 */     // GIR_Coverage, 6216,
     /* 416645 */     GIR_EraseRootFromParent_Done,
     /* 416646 */   // Label 8043: @416646
     /* 416646 */   GIM_Try, /*On fail goto*//*Label 8044*/ GIMT_Encode4(416745), // Rule ID 6248 //
     /* 416651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 416662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 416666 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 416675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 416679 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 416683 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 416688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416692 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 416694 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 416694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 416697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 416701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 416706 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 416709 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 416713 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 416716 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416721 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 416726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 416729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 416737 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 416740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416743 */     GIR_RootConstrainSelectedInstOperands,
     /* 416744 */     // GIR_Coverage, 6248,
     /* 416744 */     GIR_EraseRootFromParent_Done,
     /* 416745 */   // Label 8044: @416745
     /* 416745 */   GIM_Try, /*On fail goto*//*Label 8045*/ GIMT_Encode4(416838), // Rule ID 6294 //
     /* 416750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 416758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 416762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 416766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 416770 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 416774 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 416778 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 416783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416787 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 416789 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 416789 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 416792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 416796 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 416801 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 416804 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 416808 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 416811 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416816 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 416821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 416824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416828 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416830 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 416833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416836 */     GIR_RootConstrainSelectedInstOperands,
     /* 416837 */     // GIR_Coverage, 6294,
     /* 416837 */     GIR_EraseRootFromParent_Done,
     /* 416838 */   // Label 8045: @416838
     /* 416838 */   GIM_Try, /*On fail goto*//*Label 8046*/ GIMT_Encode4(416934), // Rule ID 6152 //
     /* 416843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 416854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 416858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 416862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 416866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 416870 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 416874 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 416879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416883 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 416885 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 416885 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 416888 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 416892 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 416897 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 416900 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 416904 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 416907 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416912 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 416917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 416920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416924 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 416929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416932 */     GIR_RootConstrainSelectedInstOperands,
     /* 416933 */     // GIR_Coverage, 6152,
     /* 416933 */     GIR_EraseRootFromParent_Done,
     /* 416934 */   // Label 8046: @416934
     /* 416934 */   GIM_Try, /*On fail goto*//*Label 8047*/ GIMT_Encode4(417018), // Rule ID 2541 //
     /* 416939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 416950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 416954 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 416959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 416969 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 416969 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 416972 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 416976 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 416981 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 416984 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 416988 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 416991 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416996 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 417004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 417006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 417008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 417010 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 417013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417016 */     GIR_RootConstrainSelectedInstOperands,
     /* 417017 */     // GIR_Coverage, 2541,
     /* 417017 */     GIR_EraseRootFromParent_Done,
     /* 417018 */   // Label 8047: @417018
     /* 417018 */   GIM_Try, /*On fail goto*//*Label 8048*/ GIMT_Encode4(417068), // Rule ID 13477 //
     /* 417023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 417034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 417038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417053 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 417053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 417056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 417058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 417060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 417062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 417066 */     GIR_RootConstrainSelectedInstOperands,
     /* 417067 */     // GIR_Coverage, 13477,
     /* 417067 */     GIR_EraseRootFromParent_Done,
     /* 417068 */   // Label 8048: @417068
     /* 417068 */   GIM_Try, /*On fail goto*//*Label 8049*/ GIMT_Encode4(417152), // Rule ID 6120 //
     /* 417073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 417084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 417088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 417092 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417103 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 417103 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 417106 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 417110 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 417115 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 417118 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 417122 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 417125 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417130 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 417138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 417140 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 417142 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 417144 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 417147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417150 */     GIR_RootConstrainSelectedInstOperands,
     /* 417151 */     // GIR_Coverage, 6120,
     /* 417151 */     GIR_EraseRootFromParent_Done,
     /* 417152 */   // Label 8049: @417152
     /* 417152 */   GIM_Try, /*On fail goto*//*Label 8050*/ GIMT_Encode4(417202), // Rule ID 1309 //
     /* 417157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 417168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 417172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 417176 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417187 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 417187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 417190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 417192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 417194 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 417196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 417200 */     GIR_RootConstrainSelectedInstOperands,
     /* 417201 */     // GIR_Coverage, 1309,
     /* 417201 */     GIR_EraseRootFromParent_Done,
     /* 417202 */   // Label 8050: @417202
     /* 417202 */   GIM_Try, /*On fail goto*//*Label 8051*/ GIMT_Encode4(417235), // Rule ID 1299 //
     /* 417207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417222 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 417222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f32),
     /* 417225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 417227 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 417229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 417231 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 417233 */     GIR_RootConstrainSelectedInstOperands,
     /* 417234 */     // GIR_Coverage, 1299,
     /* 417234 */     GIR_EraseRootFromParent_Done,
     /* 417235 */   // Label 8051: @417235
     /* 417235 */   GIM_Reject,
     /* 417236 */ // Label 8032: @417236
     /* 417236 */ GIM_Reject,
     /* 417237 */ // Label 7883: @417237
     /* 417237 */ GIM_Try, /*On fail goto*//*Label 8052*/ GIMT_Encode4(418415),
     /* 417242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417245 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 417248 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 417251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417255 */   GIM_Try, /*On fail goto*//*Label 8053*/ GIMT_Encode4(417339), // Rule ID 6166 //
     /* 417260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 417263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 417271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417275 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 417279 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 417284 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 417288 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 417292 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 417296 */     // MIs[2] Operand 1
     /* 417296 */     // No operand predicates
     /* 417296 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 417300 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 417304 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417308 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417317 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 417319 */     // (strict_fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 417319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 417322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 417324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 417326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 417330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 417334 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 417337 */     GIR_RootConstrainSelectedInstOperands,
     /* 417338 */     // GIR_Coverage, 6166,
     /* 417338 */     GIR_EraseRootFromParent_Done,
     /* 417339 */   // Label 8053: @417339
     /* 417339 */   GIM_Try, /*On fail goto*//*Label 8054*/ GIMT_Encode4(417420), // Rule ID 6198 //
     /* 417344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 417347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 417355 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 417363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 417367 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417371 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 417375 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 417380 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 417384 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 417388 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 417392 */     // MIs[3] Operand 1
     /* 417392 */     // No operand predicates
     /* 417392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417400 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 417402 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 417402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 417405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 417407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 417409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 417411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 417415 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 417418 */     GIR_RootConstrainSelectedInstOperands,
     /* 417419 */     // GIR_Coverage, 6198,
     /* 417419 */     GIR_EraseRootFromParent_Done,
     /* 417420 */   // Label 8054: @417420
     /* 417420 */   GIM_Try, /*On fail goto*//*Label 8055*/ GIMT_Encode4(417504), // Rule ID 6230 //
     /* 417425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 417428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 417436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417440 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 417449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 417453 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417457 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 417461 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 417466 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 417470 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 417474 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 417478 */     // MIs[3] Operand 1
     /* 417478 */     // No operand predicates
     /* 417478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417482 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 417484 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 417484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 417487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 417489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 417491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 417495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 417499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 417502 */     GIR_RootConstrainSelectedInstOperands,
     /* 417503 */     // GIR_Coverage, 6230,
     /* 417503 */     GIR_EraseRootFromParent_Done,
     /* 417504 */   // Label 8055: @417504
     /* 417504 */   GIM_Try, /*On fail goto*//*Label 8056*/ GIMT_Encode4(417585), // Rule ID 6134 //
     /* 417509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 417512 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 417520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 417524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 417532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 417536 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417540 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 417544 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 417549 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 417553 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 417557 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 417561 */     // MIs[3] Operand 1
     /* 417561 */     // No operand predicates
     /* 417561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417565 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 417567 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 417567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 417570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 417572 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 417574 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 417576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 417580 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 417583 */     GIR_RootConstrainSelectedInstOperands,
     /* 417584 */     // GIR_Coverage, 6134,
     /* 417584 */     GIR_EraseRootFromParent_Done,
     /* 417585 */   // Label 8056: @417585
     /* 417585 */   GIM_Try, /*On fail goto*//*Label 8057*/ GIMT_Encode4(417654), // Rule ID 2523 //
     /* 417590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 417593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 417601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417605 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 417609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 417614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 417618 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 417622 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 417626 */     // MIs[2] Operand 1
     /* 417626 */     // No operand predicates
     /* 417626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417634 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 417636 */     // (strict_fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 417636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 417639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 417641 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 417643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 417645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 417649 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 417652 */     GIR_RootConstrainSelectedInstOperands,
     /* 417653 */     // GIR_Coverage, 2523,
     /* 417653 */     GIR_EraseRootFromParent_Done,
     /* 417654 */   // Label 8057: @417654
     /* 417654 */   GIM_Try, /*On fail goto*//*Label 8058*/ GIMT_Encode4(417723), // Rule ID 6102 //
     /* 417659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 417662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 417670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 417674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417678 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 417682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 417687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 417691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 417695 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 417699 */     // MIs[2] Operand 1
     /* 417699 */     // No operand predicates
     /* 417699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417703 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 417705 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 417705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 417708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 417710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 417712 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 417714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 417718 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 417721 */     GIR_RootConstrainSelectedInstOperands,
     /* 417722 */     // GIR_Coverage, 6102,
     /* 417722 */     GIR_EraseRootFromParent_Done,
     /* 417723 */   // Label 8058: @417723
     /* 417723 */   GIM_Try, /*On fail goto*//*Label 8059*/ GIMT_Encode4(417822), // Rule ID 6168 //
     /* 417728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 417731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 417739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 417743 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 417748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 417752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 417756 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417760 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417769 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 417771 */     // (strict_fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 417771 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 417774 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 417778 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 417783 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 417786 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 417790 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 417793 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417798 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 417803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 417806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 417808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 417810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 417814 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 417817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417820 */     GIR_RootConstrainSelectedInstOperands,
     /* 417821 */     // GIR_Coverage, 6168,
     /* 417821 */     GIR_EraseRootFromParent_Done,
     /* 417822 */   // Label 8059: @417822
     /* 417822 */   GIM_Try, /*On fail goto*//*Label 8060*/ GIMT_Encode4(417918), // Rule ID 6200 //
     /* 417827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 417830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 417838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417842 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 417846 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 417850 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 417854 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 417859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417867 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 417869 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 417869 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 417872 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 417876 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 417881 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 417884 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 417888 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 417891 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417896 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 417901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 417904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 417906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 417908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 417910 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 417913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417916 */     GIR_RootConstrainSelectedInstOperands,
     /* 417917 */     // GIR_Coverage, 6200,
     /* 417917 */     GIR_EraseRootFromParent_Done,
     /* 417918 */   // Label 8060: @417918
     /* 417918 */   GIM_Try, /*On fail goto*//*Label 8061*/ GIMT_Encode4(418017), // Rule ID 6232 //
     /* 417923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 417926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 417934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 417947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 417951 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 417955 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 417960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417964 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 417966 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 417966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 417969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 417973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 417978 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 417981 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 417985 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 417988 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417993 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 417998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 418001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 418003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 418005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 418009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 418012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418015 */     GIR_RootConstrainSelectedInstOperands,
     /* 418016 */     // GIR_Coverage, 6232,
     /* 418016 */     GIR_EraseRootFromParent_Done,
     /* 418017 */   // Label 8061: @418017
     /* 418017 */   GIM_Try, /*On fail goto*//*Label 8062*/ GIMT_Encode4(418113), // Rule ID 6136 //
     /* 418022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 418025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 418033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 418037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 418041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 418045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 418049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 418053 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 418058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418062 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 418064 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 418064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 418067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 418071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 418076 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 418079 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 418083 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 418086 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418091 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 418096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 418099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 418101 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 418103 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 418105 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 418108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418111 */     GIR_RootConstrainSelectedInstOperands,
     /* 418112 */     // GIR_Coverage, 6136,
     /* 418112 */     GIR_EraseRootFromParent_Done,
     /* 418113 */   // Label 8062: @418113
     /* 418113 */   GIM_Try, /*On fail goto*//*Label 8063*/ GIMT_Encode4(418197), // Rule ID 2525 //
     /* 418118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 418121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 418129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 418133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 418138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418146 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418148 */     // (strict_fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 418148 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 418151 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 418155 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 418160 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 418163 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 418167 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 418170 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418175 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 418180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 418183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 418185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 418187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 418189 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 418192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418195 */     GIR_RootConstrainSelectedInstOperands,
     /* 418196 */     // GIR_Coverage, 2525,
     /* 418196 */     GIR_EraseRootFromParent_Done,
     /* 418197 */   // Label 8063: @418197
     /* 418197 */   GIM_Try, /*On fail goto*//*Label 8064*/ GIMT_Encode4(418247), // Rule ID 13473 //
     /* 418202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 418205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 418213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 418217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418230 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418232 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 418232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 418235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 418237 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 418239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 418241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 418245 */     GIR_RootConstrainSelectedInstOperands,
     /* 418246 */     // GIR_Coverage, 13473,
     /* 418246 */     GIR_EraseRootFromParent_Done,
     /* 418247 */   // Label 8064: @418247
     /* 418247 */   GIM_Try, /*On fail goto*//*Label 8065*/ GIMT_Encode4(418331), // Rule ID 6104 //
     /* 418252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 418255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 418263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 418267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 418271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 418276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418282 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 418282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 418285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 418289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 418294 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 418297 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 418301 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 418304 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418309 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 418314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 418317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 418319 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 418321 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 418323 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 418326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418329 */     GIR_RootConstrainSelectedInstOperands,
     /* 418330 */     // GIR_Coverage, 6104,
     /* 418330 */     GIR_EraseRootFromParent_Done,
     /* 418331 */   // Label 8065: @418331
     /* 418331 */   GIM_Try, /*On fail goto*//*Label 8066*/ GIMT_Encode4(418381), // Rule ID 1305 //
     /* 418336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 418339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 418347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 418351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 418355 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418366 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 418366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 418369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 418371 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 418373 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 418375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 418379 */     GIR_RootConstrainSelectedInstOperands,
     /* 418380 */     // GIR_Coverage, 1305,
     /* 418380 */     GIR_EraseRootFromParent_Done,
     /* 418381 */   // Label 8066: @418381
     /* 418381 */   GIM_Try, /*On fail goto*//*Label 8067*/ GIMT_Encode4(418414), // Rule ID 1295 //
     /* 418386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 418389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418401 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 418401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8f16),
     /* 418404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 418406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 418408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 418410 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 418412 */     GIR_RootConstrainSelectedInstOperands,
     /* 418413 */     // GIR_Coverage, 1295,
     /* 418413 */     GIR_EraseRootFromParent_Done,
     /* 418414 */   // Label 8067: @418414
     /* 418414 */   GIM_Reject,
     /* 418415 */ // Label 8052: @418415
     /* 418415 */ GIM_Reject,
     /* 418416 */ // Label 7884: @418416
     /* 418416 */ GIM_Reject,
     /* 418417 */ // Label 109: @418417
     /* 418417 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 8076*/ GIMT_Encode4(418716),
     /* 418428 */ /*GILLT_s16*//*Label 8068*/ GIMT_Encode4(418468),
     /* 418432 */ /*GILLT_s32*//*Label 8069*/ GIMT_Encode4(418499),
     /* 418436 */ /*GILLT_s64*//*Label 8070*/ GIMT_Encode4(418530), GIMT_Encode4(0),
     /* 418444 */ /*GILLT_v2s32*//*Label 8071*/ GIMT_Encode4(418561),
     /* 418448 */ /*GILLT_v2s64*//*Label 8072*/ GIMT_Encode4(418592),
     /* 418452 */ /*GILLT_v4s16*//*Label 8073*/ GIMT_Encode4(418623),
     /* 418456 */ /*GILLT_v4s32*//*Label 8074*/ GIMT_Encode4(418654), GIMT_Encode4(0),
     /* 418464 */ /*GILLT_v8s16*//*Label 8075*/ GIMT_Encode4(418685),
     /* 418468 */ // Label 8068: @418468
     /* 418468 */ GIM_Try, /*On fail goto*//*Label 8077*/ GIMT_Encode4(418498), // Rule ID 569 //
     /* 418473 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 418476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 418479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418483 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418487 */   // (strict_fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FSQRTHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 418487 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTHr),
     /* 418492 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418496 */   GIR_RootConstrainSelectedInstOperands,
     /* 418497 */   // GIR_Coverage, 569,
     /* 418497 */   GIR_Done,
     /* 418498 */ // Label 8077: @418498
     /* 418498 */ GIM_Reject,
     /* 418499 */ // Label 8069: @418499
     /* 418499 */ GIM_Try, /*On fail goto*//*Label 8078*/ GIMT_Encode4(418529), // Rule ID 571 //
     /* 418504 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 418507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 418510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418514 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418518 */   // (strict_fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FSQRTSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 418518 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTSr),
     /* 418523 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418527 */   GIR_RootConstrainSelectedInstOperands,
     /* 418528 */   // GIR_Coverage, 571,
     /* 418528 */   GIR_Done,
     /* 418529 */ // Label 8078: @418529
     /* 418529 */ GIM_Reject,
     /* 418530 */ // Label 8070: @418530
     /* 418530 */ GIM_Try, /*On fail goto*//*Label 8079*/ GIMT_Encode4(418560), // Rule ID 573 //
     /* 418535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 418538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 418541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418545 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418549 */   // (strict_fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FSQRTDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 418549 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTDr),
     /* 418554 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418558 */   GIR_RootConstrainSelectedInstOperands,
     /* 418559 */   // GIR_Coverage, 573,
     /* 418559 */   GIR_Done,
     /* 418560 */ // Label 8079: @418560
     /* 418560 */ GIM_Reject,
     /* 418561 */ // Label 8071: @418561
     /* 418561 */ GIM_Try, /*On fail goto*//*Label 8080*/ GIMT_Encode4(418591), // Rule ID 959 //
     /* 418566 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 418569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 418572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418580 */   // (strict_fsqrt:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FSQRTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 418580 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f32),
     /* 418585 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418589 */   GIR_RootConstrainSelectedInstOperands,
     /* 418590 */   // GIR_Coverage, 959,
     /* 418590 */   GIR_Done,
     /* 418591 */ // Label 8080: @418591
     /* 418591 */ GIM_Reject,
     /* 418592 */ // Label 8072: @418592
     /* 418592 */ GIM_Try, /*On fail goto*//*Label 8081*/ GIMT_Encode4(418622), // Rule ID 963 //
     /* 418597 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 418600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 418603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418607 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418611 */   // (strict_fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FSQRTv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 418611 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f64),
     /* 418616 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418620 */   GIR_RootConstrainSelectedInstOperands,
     /* 418621 */   // GIR_Coverage, 963,
     /* 418621 */   GIR_Done,
     /* 418622 */ // Label 8081: @418622
     /* 418622 */ GIM_Reject,
     /* 418623 */ // Label 8073: @418623
     /* 418623 */ GIM_Try, /*On fail goto*//*Label 8082*/ GIMT_Encode4(418653), // Rule ID 955 //
     /* 418628 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 418631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 418634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418638 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418642 */   // (strict_fsqrt:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FSQRTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 418642 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f16),
     /* 418647 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418651 */   GIR_RootConstrainSelectedInstOperands,
     /* 418652 */   // GIR_Coverage, 955,
     /* 418652 */   GIR_Done,
     /* 418653 */ // Label 8082: @418653
     /* 418653 */ GIM_Reject,
     /* 418654 */ // Label 8074: @418654
     /* 418654 */ GIM_Try, /*On fail goto*//*Label 8083*/ GIMT_Encode4(418684), // Rule ID 961 //
     /* 418659 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 418662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 418665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418669 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418673 */   // (strict_fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FSQRTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 418673 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f32),
     /* 418678 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418682 */   GIR_RootConstrainSelectedInstOperands,
     /* 418683 */   // GIR_Coverage, 961,
     /* 418683 */   GIR_Done,
     /* 418684 */ // Label 8083: @418684
     /* 418684 */ GIM_Reject,
     /* 418685 */ // Label 8075: @418685
     /* 418685 */ GIM_Try, /*On fail goto*//*Label 8084*/ GIMT_Encode4(418715), // Rule ID 957 //
     /* 418690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 418693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 418696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418700 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418704 */   // (strict_fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FSQRTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 418704 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv8f16),
     /* 418709 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418713 */   GIR_RootConstrainSelectedInstOperands,
     /* 418714 */   // GIR_Coverage, 957,
     /* 418714 */   GIR_Done,
     /* 418715 */ // Label 8084: @418715
     /* 418715 */ GIM_Reject,
     /* 418716 */ // Label 8076: @418716
     /* 418716 */ GIM_Reject,
     /* 418717 */ // Label 110: @418717
     /* 418717 */ GIM_Try, /*On fail goto*//*Label 8085*/ GIMT_Encode4(418730), // Rule ID 6591 //
     /* 418722 */   // (trap)  =>  (BRK 1:{ *:[i32] })
     /* 418722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 418725 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 418728 */   GIR_RootConstrainSelectedInstOperands,
     /* 418729 */   // GIR_Coverage, 6591,
     /* 418729 */   GIR_EraseRootFromParent_Done,
     /* 418730 */ // Label 8085: @418730
     /* 418730 */ GIM_Reject,
     /* 418731 */ // Label 111: @418731
     /* 418731 */ GIM_Try, /*On fail goto*//*Label 8086*/ GIMT_Encode4(418751), // Rule ID 6592 //
     /* 418736 */   // (debugtrap)  =>  (BRK 61440:{ *:[i32] })
     /* 418736 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 418739 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(61440),
     /* 418749 */   GIR_RootConstrainSelectedInstOperands,
     /* 418750 */   // GIR_Coverage, 6592,
     /* 418750 */   GIR_EraseRootFromParent_Done,
     /* 418751 */ // Label 8086: @418751
     /* 418751 */ GIM_Reject,
     /* 418752 */ // Label 112: @418752
     /* 418752 */ GIM_Try, /*On fail goto*//*Label 8087*/ GIMT_Encode4(418776), // Rule ID 6593 //
     /* 418757 */   // MIs[0] kind
     /* 418757 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 418760 */   GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_ubsan_trap_imm),
     /* 418765 */   // (ubsantrap (timm:{ *:[i32] })<<P:Predicate_ubsan_trap_imm>><<X:ubsan_trap_xform>>:$kind)  =>  (BRK (ubsan_trap_xform:{ *:[i32] } (timm:{ *:[i32] })<<P:Predicate_ubsan_trap_imm>>:$kind))
     /* 418765 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 418768 */   GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, /*OperandRenderer*/GIMT_Encode2(GICR_renderUbsanTrap), // kind
     /* 418774 */   GIR_RootConstrainSelectedInstOperands,
     /* 418775 */   // GIR_Coverage, 6593,
     /* 418775 */   GIR_EraseRootFromParent_Done,
     /* 418776 */ // Label 8087: @418776
     /* 418776 */ GIM_Reject,
     /* 418777 */ // Label 113: @418777
     /* 418777 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8091*/ GIMT_Encode4(419086),
     /* 418788 */ /*GILLT_s16*//*Label 8088*/ GIMT_Encode4(418800),
     /* 418792 */ /*GILLT_s32*//*Label 8089*/ GIMT_Encode4(418953),
     /* 418796 */ /*GILLT_s64*//*Label 8090*/ GIMT_Encode4(419058),
     /* 418800 */ // Label 8088: @418800
     /* 418800 */ GIM_Try, /*On fail goto*//*Label 8092*/ GIMT_Encode4(418901), // Rule ID 5646 //
     /* 418805 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 418808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 418811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418815 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418819 */   // (vecreduce_fadd:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv8f16:{ *:[f128] } (FADDPv8f16:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rn), dsub:{ *:[i32] }))
     /* 418819 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 418822 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 418826 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 418831 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 418835 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 418839 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 418841 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 418844 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 418848 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 418853 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 418856 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 418860 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 418862 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 418865 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 418869 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 418874 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 418881 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418886 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418891 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 418894 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418896 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 418899 */   GIR_RootConstrainSelectedInstOperands,
     /* 418900 */   // GIR_Coverage, 5646,
     /* 418900 */   GIR_EraseRootFromParent_Done,
     /* 418901 */ // Label 8092: @418901
     /* 418901 */ GIM_Try, /*On fail goto*//*Label 8093*/ GIMT_Encode4(418952), // Rule ID 5647 //
     /* 418906 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 418909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 418912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418916 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418920 */   // (vecreduce_fadd:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FADDPv2i16p:{ *:[f16] } (FADDPv4f16:{ *:[i64] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rn))
     /* 418920 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 418923 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f16),
     /* 418927 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 418932 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 418936 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 418940 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 418942 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 418945 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418947 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 418950 */   GIR_RootConstrainSelectedInstOperands,
     /* 418951 */   // GIR_Coverage, 5647,
     /* 418951 */   GIR_EraseRootFromParent_Done,
     /* 418952 */ // Label 8093: @418952
     /* 418952 */ GIM_Reject,
     /* 418953 */ // Label 8089: @418953
     /* 418953 */ GIM_Try, /*On fail goto*//*Label 8094*/ GIMT_Encode4(419030), // Rule ID 5648 //
     /* 418958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 418961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418965 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418969 */   // (vecreduce_fadd:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv4f32:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] }))
     /* 418969 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 418972 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 418976 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 418981 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 418985 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 418989 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 418991 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 418994 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 418998 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 419003 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 419010 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419015 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 419023 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 419025 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 419028 */   GIR_RootConstrainSelectedInstOperands,
     /* 419029 */   // GIR_Coverage, 5648,
     /* 419029 */   GIR_EraseRootFromParent_Done,
     /* 419030 */ // Label 8094: @419030
     /* 419030 */ GIM_Try, /*On fail goto*//*Label 8095*/ GIMT_Encode4(419057), // Rule ID 5649 //
     /* 419035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 419038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419046 */   // (vecreduce_fadd:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 419046 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 419051 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 419055 */   GIR_RootConstrainSelectedInstOperands,
     /* 419056 */   // GIR_Coverage, 5649,
     /* 419056 */   GIR_Done,
     /* 419057 */ // Label 8095: @419057
     /* 419057 */ GIM_Reject,
     /* 419058 */ // Label 8090: @419058
     /* 419058 */ GIM_Try, /*On fail goto*//*Label 8096*/ GIMT_Encode4(419085), // Rule ID 5650 //
     /* 419063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 419066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419070 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419074 */   // (vecreduce_fadd:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FADDPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 419074 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 419079 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 419083 */   GIR_RootConstrainSelectedInstOperands,
     /* 419084 */   // GIR_Coverage, 5650,
     /* 419084 */   GIR_Done,
     /* 419085 */ // Label 8096: @419085
     /* 419085 */ GIM_Reject,
     /* 419086 */ // Label 8091: @419086
     /* 419086 */ GIM_Reject,
     /* 419087 */ // Label 114: @419087
     /* 419087 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8100*/ GIMT_Encode4(419257),
     /* 419098 */ /*GILLT_s16*//*Label 8097*/ GIMT_Encode4(419110),
     /* 419102 */ /*GILLT_s32*//*Label 8098*/ GIMT_Encode4(419171),
     /* 419106 */ /*GILLT_s64*//*Label 8099*/ GIMT_Encode4(419229),
     /* 419110 */ // Label 8097: @419110
     /* 419110 */ GIM_Try, /*On fail goto*//*Label 8101*/ GIMT_Encode4(419140), // Rule ID 1942 //
     /* 419115 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 419118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 419121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 419125 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419129 */   // (vecreduce_fmax:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMAXNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 419129 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i16v),
     /* 419134 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 419138 */   GIR_RootConstrainSelectedInstOperands,
     /* 419139 */   // GIR_Coverage, 1942,
     /* 419139 */   GIR_Done,
     /* 419140 */ // Label 8101: @419140
     /* 419140 */ GIM_Try, /*On fail goto*//*Label 8102*/ GIMT_Encode4(419170), // Rule ID 1944 //
     /* 419145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 419148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 419151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 419155 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419159 */   // (vecreduce_fmax:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMAXNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 419159 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv8i16v),
     /* 419164 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 419168 */   GIR_RootConstrainSelectedInstOperands,
     /* 419169 */   // GIR_Coverage, 1944,
     /* 419169 */   GIR_Done,
     /* 419170 */ // Label 8102: @419170
     /* 419170 */ GIM_Reject,
     /* 419171 */ // Label 8098: @419171
     /* 419171 */ GIM_Try, /*On fail goto*//*Label 8103*/ GIMT_Encode4(419201), // Rule ID 1946 //
     /* 419176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 419179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 419182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419186 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419190 */   // (vecreduce_fmax:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMAXNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 419190 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i32v),
     /* 419195 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 419199 */   GIR_RootConstrainSelectedInstOperands,
     /* 419200 */   // GIR_Coverage, 1946,
     /* 419200 */   GIR_Done,
     /* 419201 */ // Label 8103: @419201
     /* 419201 */ GIM_Try, /*On fail goto*//*Label 8104*/ GIMT_Encode4(419228), // Rule ID 5656 //
     /* 419206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 419209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419213 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419217 */   // (vecreduce_fmax:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMAXNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 419217 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i32p),
     /* 419222 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 419226 */   GIR_RootConstrainSelectedInstOperands,
     /* 419227 */   // GIR_Coverage, 5656,
     /* 419227 */   GIR_Done,
     /* 419228 */ // Label 8104: @419228
     /* 419228 */ GIM_Reject,
     /* 419229 */ // Label 8099: @419229
     /* 419229 */ GIM_Try, /*On fail goto*//*Label 8105*/ GIMT_Encode4(419256), // Rule ID 5658 //
     /* 419234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 419237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419241 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419245 */   // (vecreduce_fmax:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMAXNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 419245 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i64p),
     /* 419250 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 419254 */   GIR_RootConstrainSelectedInstOperands,
     /* 419255 */   // GIR_Coverage, 5658,
     /* 419255 */   GIR_Done,
     /* 419256 */ // Label 8105: @419256
     /* 419256 */ GIM_Reject,
     /* 419257 */ // Label 8100: @419257
     /* 419257 */ GIM_Reject,
     /* 419258 */ // Label 115: @419258
     /* 419258 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8109*/ GIMT_Encode4(419428),
     /* 419269 */ /*GILLT_s16*//*Label 8106*/ GIMT_Encode4(419281),
     /* 419273 */ /*GILLT_s32*//*Label 8107*/ GIMT_Encode4(419342),
     /* 419277 */ /*GILLT_s64*//*Label 8108*/ GIMT_Encode4(419400),
     /* 419281 */ // Label 8106: @419281
     /* 419281 */ GIM_Try, /*On fail goto*//*Label 8110*/ GIMT_Encode4(419311), // Rule ID 1954 //
     /* 419286 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 419289 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 419292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 419296 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419300 */   // (vecreduce_fmin:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 419300 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i16v),
     /* 419305 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 419309 */   GIR_RootConstrainSelectedInstOperands,
     /* 419310 */   // GIR_Coverage, 1954,
     /* 419310 */   GIR_Done,
     /* 419311 */ // Label 8110: @419311
     /* 419311 */ GIM_Try, /*On fail goto*//*Label 8111*/ GIMT_Encode4(419341), // Rule ID 1956 //
     /* 419316 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 419319 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 419322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 419326 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419330 */   // (vecreduce_fmin:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 419330 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv8i16v),
     /* 419335 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 419339 */   GIR_RootConstrainSelectedInstOperands,
     /* 419340 */   // GIR_Coverage, 1956,
     /* 419340 */   GIR_Done,
     /* 419341 */ // Label 8111: @419341
     /* 419341 */ GIM_Reject,
     /* 419342 */ // Label 8107: @419342
     /* 419342 */ GIM_Try, /*On fail goto*//*Label 8112*/ GIMT_Encode4(419372), // Rule ID 1958 //
     /* 419347 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 419350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 419353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419357 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419361 */   // (vecreduce_fmin:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 419361 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i32v),
     /* 419366 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 419370 */   GIR_RootConstrainSelectedInstOperands,
     /* 419371 */   // GIR_Coverage, 1958,
     /* 419371 */   GIR_Done,
     /* 419372 */ // Label 8112: @419372
     /* 419372 */ GIM_Try, /*On fail goto*//*Label 8113*/ GIMT_Encode4(419399), // Rule ID 5664 //
     /* 419377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 419380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419388 */   // (vecreduce_fmin:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 419388 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i32p),
     /* 419393 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 419397 */   GIR_RootConstrainSelectedInstOperands,
     /* 419398 */   // GIR_Coverage, 5664,
     /* 419398 */   GIR_Done,
     /* 419399 */ // Label 8113: @419399
     /* 419399 */ GIM_Reject,
     /* 419400 */ // Label 8108: @419400
     /* 419400 */ GIM_Try, /*On fail goto*//*Label 8114*/ GIMT_Encode4(419427), // Rule ID 5666 //
     /* 419405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 419408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419412 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419416 */   // (vecreduce_fmin:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 419416 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i64p),
     /* 419421 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 419425 */   GIR_RootConstrainSelectedInstOperands,
     /* 419426 */   // GIR_Coverage, 5666,
     /* 419426 */   GIR_Done,
     /* 419427 */ // Label 8114: @419427
     /* 419427 */ GIM_Reject,
     /* 419428 */ // Label 8109: @419428
     /* 419428 */ GIM_Reject,
     /* 419429 */ // Label 116: @419429
     /* 419429 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8118*/ GIMT_Encode4(419599),
     /* 419440 */ /*GILLT_s16*//*Label 8115*/ GIMT_Encode4(419452),
     /* 419444 */ /*GILLT_s32*//*Label 8116*/ GIMT_Encode4(419513),
     /* 419448 */ /*GILLT_s64*//*Label 8117*/ GIMT_Encode4(419571),
     /* 419452 */ // Label 8115: @419452
     /* 419452 */ GIM_Try, /*On fail goto*//*Label 8119*/ GIMT_Encode4(419482), // Rule ID 1948 //
     /* 419457 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 419460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 419463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 419467 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419471 */   // (vecreduce_fmaximum:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMAXVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 419471 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i16v),
     /* 419476 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 419480 */   GIR_RootConstrainSelectedInstOperands,
     /* 419481 */   // GIR_Coverage, 1948,
     /* 419481 */   GIR_Done,
     /* 419482 */ // Label 8119: @419482
     /* 419482 */ GIM_Try, /*On fail goto*//*Label 8120*/ GIMT_Encode4(419512), // Rule ID 1950 //
     /* 419487 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 419490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 419493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 419497 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419501 */   // (vecreduce_fmaximum:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMAXVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 419501 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv8i16v),
     /* 419506 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 419510 */   GIR_RootConstrainSelectedInstOperands,
     /* 419511 */   // GIR_Coverage, 1950,
     /* 419511 */   GIR_Done,
     /* 419512 */ // Label 8120: @419512
     /* 419512 */ GIM_Reject,
     /* 419513 */ // Label 8116: @419513
     /* 419513 */ GIM_Try, /*On fail goto*//*Label 8121*/ GIMT_Encode4(419543), // Rule ID 1952 //
     /* 419518 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 419521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 419524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419528 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419532 */   // (vecreduce_fmaximum:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMAXVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 419532 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i32v),
     /* 419537 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 419541 */   GIR_RootConstrainSelectedInstOperands,
     /* 419542 */   // GIR_Coverage, 1952,
     /* 419542 */   GIR_Done,
     /* 419543 */ // Label 8121: @419543
     /* 419543 */ GIM_Try, /*On fail goto*//*Label 8122*/ GIMT_Encode4(419570), // Rule ID 5660 //
     /* 419548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 419551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419555 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419559 */   // (vecreduce_fmaximum:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMAXPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 419559 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i32p),
     /* 419564 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 419568 */   GIR_RootConstrainSelectedInstOperands,
     /* 419569 */   // GIR_Coverage, 5660,
     /* 419569 */   GIR_Done,
     /* 419570 */ // Label 8122: @419570
     /* 419570 */ GIM_Reject,
     /* 419571 */ // Label 8117: @419571
     /* 419571 */ GIM_Try, /*On fail goto*//*Label 8123*/ GIMT_Encode4(419598), // Rule ID 5662 //
     /* 419576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 419579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419583 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419587 */   // (vecreduce_fmaximum:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMAXPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 419587 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i64p),
     /* 419592 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 419596 */   GIR_RootConstrainSelectedInstOperands,
     /* 419597 */   // GIR_Coverage, 5662,
     /* 419597 */   GIR_Done,
     /* 419598 */ // Label 8123: @419598
     /* 419598 */ GIM_Reject,
     /* 419599 */ // Label 8118: @419599
     /* 419599 */ GIM_Reject,
     /* 419600 */ // Label 117: @419600
     /* 419600 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8127*/ GIMT_Encode4(419770),
     /* 419611 */ /*GILLT_s16*//*Label 8124*/ GIMT_Encode4(419623),
     /* 419615 */ /*GILLT_s32*//*Label 8125*/ GIMT_Encode4(419684),
     /* 419619 */ /*GILLT_s64*//*Label 8126*/ GIMT_Encode4(419742),
     /* 419623 */ // Label 8124: @419623
     /* 419623 */ GIM_Try, /*On fail goto*//*Label 8128*/ GIMT_Encode4(419653), // Rule ID 1960 //
     /* 419628 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 419631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 419634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 419638 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419642 */   // (vecreduce_fminimum:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 419642 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i16v),
     /* 419647 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 419651 */   GIR_RootConstrainSelectedInstOperands,
     /* 419652 */   // GIR_Coverage, 1960,
     /* 419652 */   GIR_Done,
     /* 419653 */ // Label 8128: @419653
     /* 419653 */ GIM_Try, /*On fail goto*//*Label 8129*/ GIMT_Encode4(419683), // Rule ID 1962 //
     /* 419658 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 419661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 419664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 419668 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419672 */   // (vecreduce_fminimum:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 419672 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv8i16v),
     /* 419677 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 419681 */   GIR_RootConstrainSelectedInstOperands,
     /* 419682 */   // GIR_Coverage, 1962,
     /* 419682 */   GIR_Done,
     /* 419683 */ // Label 8129: @419683
     /* 419683 */ GIM_Reject,
     /* 419684 */ // Label 8125: @419684
     /* 419684 */ GIM_Try, /*On fail goto*//*Label 8130*/ GIMT_Encode4(419714), // Rule ID 1964 //
     /* 419689 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 419692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 419695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419703 */   // (vecreduce_fminimum:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 419703 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i32v),
     /* 419708 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 419712 */   GIR_RootConstrainSelectedInstOperands,
     /* 419713 */   // GIR_Coverage, 1964,
     /* 419713 */   GIR_Done,
     /* 419714 */ // Label 8130: @419714
     /* 419714 */ GIM_Try, /*On fail goto*//*Label 8131*/ GIMT_Encode4(419741), // Rule ID 5668 //
     /* 419719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 419722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419726 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419730 */   // (vecreduce_fminimum:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 419730 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i32p),
     /* 419735 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 419739 */   GIR_RootConstrainSelectedInstOperands,
     /* 419740 */   // GIR_Coverage, 5668,
     /* 419740 */   GIR_Done,
     /* 419741 */ // Label 8131: @419741
     /* 419741 */ GIM_Reject,
     /* 419742 */ // Label 8126: @419742
     /* 419742 */ GIM_Try, /*On fail goto*//*Label 8132*/ GIMT_Encode4(419769), // Rule ID 5670 //
     /* 419747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 419750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419754 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419758 */   // (vecreduce_fminimum:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 419758 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i64p),
     /* 419763 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 419767 */   GIR_RootConstrainSelectedInstOperands,
     /* 419768 */   // GIR_Coverage, 5670,
     /* 419768 */   GIR_Done,
     /* 419769 */ // Label 8132: @419769
     /* 419769 */ GIM_Reject,
     /* 419770 */ // Label 8127: @419770
     /* 419770 */ GIM_Reject,
     /* 419771 */ // Label 118: @419771
     /* 419771 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(4), /*)*//*default:*//*Label 8137*/ GIMT_Encode4(420899),
     /* 419782 */ /*GILLT_s8*//*Label 8133*/ GIMT_Encode4(419798),
     /* 419786 */ /*GILLT_s16*//*Label 8134*/ GIMT_Encode4(419845),
     /* 419790 */ /*GILLT_s32*//*Label 8135*/ GIMT_Encode4(420260),
     /* 419794 */ /*GILLT_s64*//*Label 8136*/ GIMT_Encode4(420713),
     /* 419798 */ // Label 8133: @419798
     /* 419798 */ GIM_Try, /*On fail goto*//*Label 8138*/ GIMT_Encode4(419821), // Rule ID 5955 //
     /* 419803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 419806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 419810 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419814 */   // (vecreduce_add:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 419814 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 419819 */   GIR_RootConstrainSelectedInstOperands,
     /* 419820 */   // GIR_Coverage, 5955,
     /* 419820 */   GIR_Done,
     /* 419821 */ // Label 8138: @419821
     /* 419821 */ GIM_Try, /*On fail goto*//*Label 8139*/ GIMT_Encode4(419844), // Rule ID 5956 //
     /* 419826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 419829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 419833 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419837 */   // (vecreduce_add:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 419837 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 419842 */   GIR_RootConstrainSelectedInstOperands,
     /* 419843 */   // GIR_Coverage, 5956,
     /* 419843 */   GIR_Done,
     /* 419844 */ // Label 8139: @419844
     /* 419844 */ GIM_Reject,
     /* 419845 */ // Label 8134: @419845
     /* 419845 */ GIM_Try, /*On fail goto*//*Label 8140*/ GIMT_Encode4(419895), // Rule ID 5902 //
     /* 419850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 419853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 419857 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419861 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 419865 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 419868 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 419873 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 419877 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419882 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 419884 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v4i16] } 735:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 419884 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 419887 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 419889 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 419893 */   GIR_RootConstrainSelectedInstOperands,
     /* 419894 */   // GIR_Coverage, 5902,
     /* 419894 */   GIR_EraseRootFromParent_Done,
     /* 419895 */ // Label 8140: @419895
     /* 419895 */ GIM_Try, /*On fail goto*//*Label 8141*/ GIMT_Encode4(419945), // Rule ID 5904 //
     /* 419900 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 419903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 419907 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419911 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 419915 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 419918 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 419923 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 419927 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419932 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 419934 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v8i16] } 735:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 419934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 419937 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 419939 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 419943 */   GIR_RootConstrainSelectedInstOperands,
     /* 419944 */   // GIR_Coverage, 5904,
     /* 419944 */   GIR_EraseRootFromParent_Done,
     /* 419945 */ // Label 8141: @419945
     /* 419945 */ GIM_Try, /*On fail goto*//*Label 8142*/ GIMT_Encode4(419995), // Rule ID 5912 //
     /* 419950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 419953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 419957 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419961 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 419965 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 419968 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 419973 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 419977 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419982 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 419984 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v4i16] } 670:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 419984 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 419987 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 419989 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 419993 */   GIR_RootConstrainSelectedInstOperands,
     /* 419994 */   // GIR_Coverage, 5912,
     /* 419994 */   GIR_EraseRootFromParent_Done,
     /* 419995 */ // Label 8142: @419995
     /* 419995 */ GIM_Try, /*On fail goto*//*Label 8143*/ GIMT_Encode4(420045), // Rule ID 5914 //
     /* 420000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 420003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 420007 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420011 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 420015 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 420018 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 420023 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 420027 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420032 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420034 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v8i16] } 670:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 420034 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 420037 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 420039 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 420043 */   GIR_RootConstrainSelectedInstOperands,
     /* 420044 */   // GIR_Coverage, 5914,
     /* 420044 */   GIR_EraseRootFromParent_Done,
     /* 420045 */ // Label 8143: @420045
     /* 420045 */ GIM_Try, /*On fail goto*//*Label 8144*/ GIMT_Encode4(420087), // Rule ID 5911 //
     /* 420050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 420053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 420057 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420061 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 420065 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 420069 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420074 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420076 */   // (vecreduce_add:{ *:[i16] } (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 420076 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 420079 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 420081 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 420085 */   GIR_RootConstrainSelectedInstOperands,
     /* 420086 */   // GIR_Coverage, 5911,
     /* 420086 */   GIR_EraseRootFromParent_Done,
     /* 420087 */ // Label 8144: @420087
     /* 420087 */ GIM_Try, /*On fail goto*//*Label 8145*/ GIMT_Encode4(420129), // Rule ID 5913 //
     /* 420092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 420095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 420099 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420103 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 420107 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 420111 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420116 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420118 */   // (vecreduce_add:{ *:[i16] } (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 420118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 420121 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 420123 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 420127 */   GIR_RootConstrainSelectedInstOperands,
     /* 420128 */   // GIR_Coverage, 5913,
     /* 420128 */   GIR_EraseRootFromParent_Done,
     /* 420129 */ // Label 8145: @420129
     /* 420129 */ GIM_Try, /*On fail goto*//*Label 8146*/ GIMT_Encode4(420171), // Rule ID 5901 //
     /* 420134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 420137 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 420141 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420145 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 420149 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 420153 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420158 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420160 */   // (vecreduce_add:{ *:[i16] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 420160 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 420163 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 420165 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 420169 */   GIR_RootConstrainSelectedInstOperands,
     /* 420170 */   // GIR_Coverage, 5901,
     /* 420170 */   GIR_EraseRootFromParent_Done,
     /* 420171 */ // Label 8146: @420171
     /* 420171 */ GIM_Try, /*On fail goto*//*Label 8147*/ GIMT_Encode4(420213), // Rule ID 5903 //
     /* 420176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 420179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 420183 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420187 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 420191 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 420195 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420200 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420202 */   // (vecreduce_add:{ *:[i16] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 420202 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 420205 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 420207 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 420211 */   GIR_RootConstrainSelectedInstOperands,
     /* 420212 */   // GIR_Coverage, 5903,
     /* 420212 */   GIR_EraseRootFromParent_Done,
     /* 420213 */ // Label 8147: @420213
     /* 420213 */ GIM_Try, /*On fail goto*//*Label 8148*/ GIMT_Encode4(420236), // Rule ID 5957 //
     /* 420218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 420221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 420225 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420229 */   // (vecreduce_add:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 420229 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 420234 */   GIR_RootConstrainSelectedInstOperands,
     /* 420235 */   // GIR_Coverage, 5957,
     /* 420235 */   GIR_Done,
     /* 420236 */ // Label 8148: @420236
     /* 420236 */ GIM_Try, /*On fail goto*//*Label 8149*/ GIMT_Encode4(420259), // Rule ID 5958 //
     /* 420241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 420244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 420248 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420252 */   // (vecreduce_add:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 420252 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 420257 */   GIR_RootConstrainSelectedInstOperands,
     /* 420258 */   // GIR_Coverage, 5958,
     /* 420258 */   GIR_Done,
     /* 420259 */ // Label 8149: @420259
     /* 420259 */ GIM_Reject,
     /* 420260 */ // Label 8135: @420260
     /* 420260 */ GIM_Try, /*On fail goto*//*Label 8150*/ GIMT_Encode4(420310), // Rule ID 5906 //
     /* 420265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 420268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 420272 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420276 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 420280 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 420283 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 420288 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 420292 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420297 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420299 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 735:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 420299 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 420302 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 420304 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 420308 */   GIR_RootConstrainSelectedInstOperands,
     /* 420309 */   // GIR_Coverage, 5906,
     /* 420309 */   GIR_EraseRootFromParent_Done,
     /* 420310 */ // Label 8150: @420310
     /* 420310 */ GIM_Try, /*On fail goto*//*Label 8151*/ GIMT_Encode4(420360), // Rule ID 5908 //
     /* 420315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 420318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 420322 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420326 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 420330 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 420333 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 420338 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 420342 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420347 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420349 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v2i32] } 735:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 420349 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 420352 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 420354 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 420358 */   GIR_RootConstrainSelectedInstOperands,
     /* 420359 */   // GIR_Coverage, 5908,
     /* 420359 */   GIR_EraseRootFromParent_Done,
     /* 420360 */ // Label 8151: @420360
     /* 420360 */ GIM_Try, /*On fail goto*//*Label 8152*/ GIMT_Encode4(420410), // Rule ID 5916 //
     /* 420365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 420368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 420372 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420376 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 420380 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 420383 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 420388 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 420392 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420397 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420399 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 670:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 420399 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 420402 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 420404 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 420408 */   GIR_RootConstrainSelectedInstOperands,
     /* 420409 */   // GIR_Coverage, 5916,
     /* 420409 */   GIR_EraseRootFromParent_Done,
     /* 420410 */ // Label 8152: @420410
     /* 420410 */ GIM_Try, /*On fail goto*//*Label 8153*/ GIMT_Encode4(420460), // Rule ID 5918 //
     /* 420415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 420418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 420422 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420426 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 420430 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 420433 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 420438 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 420442 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420447 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420449 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v2i32] } 670:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 420449 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 420452 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 420454 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 420458 */   GIR_RootConstrainSelectedInstOperands,
     /* 420459 */   // GIR_Coverage, 5918,
     /* 420459 */   GIR_EraseRootFromParent_Done,
     /* 420460 */ // Label 8153: @420460
     /* 420460 */ GIM_Try, /*On fail goto*//*Label 8154*/ GIMT_Encode4(420502), // Rule ID 5915 //
     /* 420465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 420468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 420472 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420476 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 420480 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 420484 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420489 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420491 */   // (vecreduce_add:{ *:[i32] } (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 420491 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 420494 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 420496 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 420500 */   GIR_RootConstrainSelectedInstOperands,
     /* 420501 */   // GIR_Coverage, 5915,
     /* 420501 */   GIR_EraseRootFromParent_Done,
     /* 420502 */ // Label 8154: @420502
     /* 420502 */ GIM_Try, /*On fail goto*//*Label 8155*/ GIMT_Encode4(420544), // Rule ID 5917 //
     /* 420507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 420510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 420514 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420518 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 420522 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 420526 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420531 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420533 */   // (vecreduce_add:{ *:[i32] } (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 420533 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 420536 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 420538 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 420542 */   GIR_RootConstrainSelectedInstOperands,
     /* 420543 */   // GIR_Coverage, 5917,
     /* 420543 */   GIR_EraseRootFromParent_Done,
     /* 420544 */ // Label 8155: @420544
     /* 420544 */ GIM_Try, /*On fail goto*//*Label 8156*/ GIMT_Encode4(420586), // Rule ID 5905 //
     /* 420549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 420552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 420556 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420560 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 420564 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 420568 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420573 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420575 */   // (vecreduce_add:{ *:[i32] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 420575 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 420578 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 420580 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 420584 */   GIR_RootConstrainSelectedInstOperands,
     /* 420585 */   // GIR_Coverage, 5905,
     /* 420585 */   GIR_EraseRootFromParent_Done,
     /* 420586 */ // Label 8156: @420586
     /* 420586 */ GIM_Try, /*On fail goto*//*Label 8157*/ GIMT_Encode4(420628), // Rule ID 5907 //
     /* 420591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 420594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 420598 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420602 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 420606 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 420610 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420615 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420617 */   // (vecreduce_add:{ *:[i32] } (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 420617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 420620 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 420622 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 420626 */   GIR_RootConstrainSelectedInstOperands,
     /* 420627 */   // GIR_Coverage, 5907,
     /* 420627 */   GIR_EraseRootFromParent_Done,
     /* 420628 */ // Label 8157: @420628
     /* 420628 */ GIM_Try, /*On fail goto*//*Label 8158*/ GIMT_Encode4(420689), // Rule ID 5959 //
     /* 420633 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 420636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 420640 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420644 */   // (vecreduce_add:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 420644 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 420647 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 420651 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 420656 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 420660 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 420664 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 420666 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 420669 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 420671 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 420678 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 420683 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420688 */   // GIR_Coverage, 5959,
     /* 420688 */   GIR_EraseRootFromParent_Done,
     /* 420689 */ // Label 8158: @420689
     /* 420689 */ GIM_Try, /*On fail goto*//*Label 8159*/ GIMT_Encode4(420712), // Rule ID 5960 //
     /* 420694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 420697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 420701 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420705 */   // (vecreduce_add:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 420705 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 420710 */   GIR_RootConstrainSelectedInstOperands,
     /* 420711 */   // GIR_Coverage, 5960,
     /* 420711 */   GIR_Done,
     /* 420712 */ // Label 8159: @420712
     /* 420712 */ GIM_Reject,
     /* 420713 */ // Label 8136: @420713
     /* 420713 */ GIM_Try, /*On fail goto*//*Label 8160*/ GIMT_Encode4(420898),
     /* 420718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 420721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420725 */   GIM_Try, /*On fail goto*//*Label 8161*/ GIMT_Encode4(420768), // Rule ID 5910 //
     /* 420730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 420738 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 420741 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 420746 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 420750 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420757 */     // (vecreduce_add:{ *:[i64] } (intrinsic_wo_chain:{ *:[v2i64] } 735:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 420757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 420760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 420762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 420766 */     GIR_RootConstrainSelectedInstOperands,
     /* 420767 */     // GIR_Coverage, 5910,
     /* 420767 */     GIR_EraseRootFromParent_Done,
     /* 420768 */   // Label 8161: @420768
     /* 420768 */   GIM_Try, /*On fail goto*//*Label 8162*/ GIMT_Encode4(420811), // Rule ID 5920 //
     /* 420773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 420781 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 420784 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 420789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 420793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420800 */     // (vecreduce_add:{ *:[i64] } (intrinsic_wo_chain:{ *:[v2i64] } 670:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 420800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 420803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 420805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 420809 */     GIR_RootConstrainSelectedInstOperands,
     /* 420810 */     // GIR_Coverage, 5920,
     /* 420810 */     GIR_EraseRootFromParent_Done,
     /* 420811 */   // Label 8162: @420811
     /* 420811 */   GIM_Try, /*On fail goto*//*Label 8163*/ GIMT_Encode4(420846), // Rule ID 5919 //
     /* 420816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 420824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 420828 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420835 */     // (vecreduce_add:{ *:[i64] } (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 420835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 420838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 420840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 420844 */     GIR_RootConstrainSelectedInstOperands,
     /* 420845 */     // GIR_Coverage, 5919,
     /* 420845 */     GIR_EraseRootFromParent_Done,
     /* 420846 */   // Label 8163: @420846
     /* 420846 */   GIM_Try, /*On fail goto*//*Label 8164*/ GIMT_Encode4(420881), // Rule ID 5909 //
     /* 420851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 420859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 420863 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 420870 */     // (vecreduce_add:{ *:[i64] } (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 420870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 420873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 420875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 420879 */     GIR_RootConstrainSelectedInstOperands,
     /* 420880 */     // GIR_Coverage, 5909,
     /* 420880 */     GIR_EraseRootFromParent_Done,
     /* 420881 */   // Label 8164: @420881
     /* 420881 */   GIM_Try, /*On fail goto*//*Label 8165*/ GIMT_Encode4(420897), // Rule ID 5961 //
     /* 420886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420890 */     // (vecreduce_add:{ *:[i64] } V128:{ *:[v2i64] }:$Rn)  =>  (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn)
     /* 420890 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 420895 */     GIR_RootConstrainSelectedInstOperands,
     /* 420896 */     // GIR_Coverage, 5961,
     /* 420896 */     GIR_Done,
     /* 420897 */   // Label 8165: @420897
     /* 420897 */   GIM_Reject,
     /* 420898 */ // Label 8160: @420898
     /* 420898 */ GIM_Reject,
     /* 420899 */ // Label 8137: @420899
     /* 420899 */ GIM_Reject,
     /* 420900 */ // Label 119: @420900
     /* 420900 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 8169*/ GIMT_Encode4(421102),
     /* 420911 */ /*GILLT_s8*//*Label 8166*/ GIMT_Encode4(420923),
     /* 420915 */ /*GILLT_s16*//*Label 8167*/ GIMT_Encode4(420970),
     /* 420919 */ /*GILLT_s32*//*Label 8168*/ GIMT_Encode4(421017),
     /* 420923 */ // Label 8166: @420923
     /* 420923 */ GIM_Try, /*On fail goto*//*Label 8170*/ GIMT_Encode4(420946), // Rule ID 6052 //
     /* 420928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 420931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 420935 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420939 */   // (vecreduce_smax:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (SMAXVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 420939 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 420944 */   GIR_RootConstrainSelectedInstOperands,
     /* 420945 */   // GIR_Coverage, 6052,
     /* 420945 */   GIR_Done,
     /* 420946 */ // Label 8170: @420946
     /* 420946 */ GIM_Try, /*On fail goto*//*Label 8171*/ GIMT_Encode4(420969), // Rule ID 6053 //
     /* 420951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 420954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 420958 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420962 */   // (vecreduce_smax:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (SMAXVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 420962 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 420967 */   GIR_RootConstrainSelectedInstOperands,
     /* 420968 */   // GIR_Coverage, 6053,
     /* 420968 */   GIR_Done,
     /* 420969 */ // Label 8171: @420969
     /* 420969 */ GIM_Reject,
     /* 420970 */ // Label 8167: @420970
     /* 420970 */ GIM_Try, /*On fail goto*//*Label 8172*/ GIMT_Encode4(420993), // Rule ID 6054 //
     /* 420975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 420978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 420982 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420986 */   // (vecreduce_smax:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (SMAXVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 420986 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 420991 */   GIR_RootConstrainSelectedInstOperands,
     /* 420992 */   // GIR_Coverage, 6054,
     /* 420992 */   GIR_Done,
     /* 420993 */ // Label 8172: @420993
     /* 420993 */ GIM_Try, /*On fail goto*//*Label 8173*/ GIMT_Encode4(421016), // Rule ID 6055 //
     /* 420998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 421001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 421005 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421009 */   // (vecreduce_smax:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (SMAXVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 421009 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 421014 */   GIR_RootConstrainSelectedInstOperands,
     /* 421015 */   // GIR_Coverage, 6055,
     /* 421015 */   GIR_Done,
     /* 421016 */ // Label 8173: @421016
     /* 421016 */ GIM_Reject,
     /* 421017 */ // Label 8168: @421017
     /* 421017 */ GIM_Try, /*On fail goto*//*Label 8174*/ GIMT_Encode4(421040), // Rule ID 6056 //
     /* 421022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 421025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 421029 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421033 */   // (vecreduce_smax:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (SMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 421033 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i32v),
     /* 421038 */   GIR_RootConstrainSelectedInstOperands,
     /* 421039 */   // GIR_Coverage, 6056,
     /* 421039 */   GIR_Done,
     /* 421040 */ // Label 8174: @421040
     /* 421040 */ GIM_Try, /*On fail goto*//*Label 8175*/ GIMT_Encode4(421101), // Rule ID 6057 //
     /* 421045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 421048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 421052 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421056 */   // (vecreduce_smax:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (SMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 421056 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 421059 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 421063 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 421068 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 421072 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 421076 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 421078 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 421081 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 421083 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 421090 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 421095 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421100 */   // GIR_Coverage, 6057,
     /* 421100 */   GIR_EraseRootFromParent_Done,
     /* 421101 */ // Label 8175: @421101
     /* 421101 */ GIM_Reject,
     /* 421102 */ // Label 8169: @421102
     /* 421102 */ GIM_Reject,
     /* 421103 */ // Label 120: @421103
     /* 421103 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 8179*/ GIMT_Encode4(421305),
     /* 421114 */ /*GILLT_s8*//*Label 8176*/ GIMT_Encode4(421126),
     /* 421118 */ /*GILLT_s16*//*Label 8177*/ GIMT_Encode4(421173),
     /* 421122 */ /*GILLT_s32*//*Label 8178*/ GIMT_Encode4(421220),
     /* 421126 */ // Label 8176: @421126
     /* 421126 */ GIM_Try, /*On fail goto*//*Label 8180*/ GIMT_Encode4(421149), // Rule ID 6046 //
     /* 421131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 421134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 421138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421142 */   // (vecreduce_smin:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (SMINVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 421142 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 421147 */   GIR_RootConstrainSelectedInstOperands,
     /* 421148 */   // GIR_Coverage, 6046,
     /* 421148 */   GIR_Done,
     /* 421149 */ // Label 8180: @421149
     /* 421149 */ GIM_Try, /*On fail goto*//*Label 8181*/ GIMT_Encode4(421172), // Rule ID 6047 //
     /* 421154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 421157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 421161 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421165 */   // (vecreduce_smin:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (SMINVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 421165 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 421170 */   GIR_RootConstrainSelectedInstOperands,
     /* 421171 */   // GIR_Coverage, 6047,
     /* 421171 */   GIR_Done,
     /* 421172 */ // Label 8181: @421172
     /* 421172 */ GIM_Reject,
     /* 421173 */ // Label 8177: @421173
     /* 421173 */ GIM_Try, /*On fail goto*//*Label 8182*/ GIMT_Encode4(421196), // Rule ID 6048 //
     /* 421178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 421181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 421185 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421189 */   // (vecreduce_smin:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (SMINVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 421189 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 421194 */   GIR_RootConstrainSelectedInstOperands,
     /* 421195 */   // GIR_Coverage, 6048,
     /* 421195 */   GIR_Done,
     /* 421196 */ // Label 8182: @421196
     /* 421196 */ GIM_Try, /*On fail goto*//*Label 8183*/ GIMT_Encode4(421219), // Rule ID 6049 //
     /* 421201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 421204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 421208 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421212 */   // (vecreduce_smin:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (SMINVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 421212 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 421217 */   GIR_RootConstrainSelectedInstOperands,
     /* 421218 */   // GIR_Coverage, 6049,
     /* 421218 */   GIR_Done,
     /* 421219 */ // Label 8183: @421219
     /* 421219 */ GIM_Reject,
     /* 421220 */ // Label 8178: @421220
     /* 421220 */ GIM_Try, /*On fail goto*//*Label 8184*/ GIMT_Encode4(421243), // Rule ID 6050 //
     /* 421225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 421228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 421232 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421236 */   // (vecreduce_smin:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (SMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 421236 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i32v),
     /* 421241 */   GIR_RootConstrainSelectedInstOperands,
     /* 421242 */   // GIR_Coverage, 6050,
     /* 421242 */   GIR_Done,
     /* 421243 */ // Label 8184: @421243
     /* 421243 */ GIM_Try, /*On fail goto*//*Label 8185*/ GIMT_Encode4(421304), // Rule ID 6051 //
     /* 421248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 421251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 421255 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421259 */   // (vecreduce_smin:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (SMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 421259 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 421262 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 421266 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 421271 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 421275 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 421279 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 421281 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 421284 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 421286 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 421293 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 421298 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421303 */   // GIR_Coverage, 6051,
     /* 421303 */   GIR_EraseRootFromParent_Done,
     /* 421304 */ // Label 8185: @421304
     /* 421304 */ GIM_Reject,
     /* 421305 */ // Label 8179: @421305
     /* 421305 */ GIM_Reject,
     /* 421306 */ // Label 121: @421306
     /* 421306 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 8189*/ GIMT_Encode4(421508),
     /* 421317 */ /*GILLT_s8*//*Label 8186*/ GIMT_Encode4(421329),
     /* 421321 */ /*GILLT_s16*//*Label 8187*/ GIMT_Encode4(421376),
     /* 421325 */ /*GILLT_s32*//*Label 8188*/ GIMT_Encode4(421423),
     /* 421329 */ // Label 8186: @421329
     /* 421329 */ GIM_Try, /*On fail goto*//*Label 8190*/ GIMT_Encode4(421352), // Rule ID 6040 //
     /* 421334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 421337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 421341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421345 */   // (vecreduce_umax:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (UMAXVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 421345 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 421350 */   GIR_RootConstrainSelectedInstOperands,
     /* 421351 */   // GIR_Coverage, 6040,
     /* 421351 */   GIR_Done,
     /* 421352 */ // Label 8190: @421352
     /* 421352 */ GIM_Try, /*On fail goto*//*Label 8191*/ GIMT_Encode4(421375), // Rule ID 6041 //
     /* 421357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 421360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 421364 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421368 */   // (vecreduce_umax:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (UMAXVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 421368 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 421373 */   GIR_RootConstrainSelectedInstOperands,
     /* 421374 */   // GIR_Coverage, 6041,
     /* 421374 */   GIR_Done,
     /* 421375 */ // Label 8191: @421375
     /* 421375 */ GIM_Reject,
     /* 421376 */ // Label 8187: @421376
     /* 421376 */ GIM_Try, /*On fail goto*//*Label 8192*/ GIMT_Encode4(421399), // Rule ID 6042 //
     /* 421381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 421384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 421388 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421392 */   // (vecreduce_umax:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (UMAXVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 421392 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 421397 */   GIR_RootConstrainSelectedInstOperands,
     /* 421398 */   // GIR_Coverage, 6042,
     /* 421398 */   GIR_Done,
     /* 421399 */ // Label 8192: @421399
     /* 421399 */ GIM_Try, /*On fail goto*//*Label 8193*/ GIMT_Encode4(421422), // Rule ID 6043 //
     /* 421404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 421407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 421411 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421415 */   // (vecreduce_umax:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (UMAXVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 421415 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 421420 */   GIR_RootConstrainSelectedInstOperands,
     /* 421421 */   // GIR_Coverage, 6043,
     /* 421421 */   GIR_Done,
     /* 421422 */ // Label 8193: @421422
     /* 421422 */ GIM_Reject,
     /* 421423 */ // Label 8188: @421423
     /* 421423 */ GIM_Try, /*On fail goto*//*Label 8194*/ GIMT_Encode4(421446), // Rule ID 6044 //
     /* 421428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 421431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 421435 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421439 */   // (vecreduce_umax:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (UMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 421439 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i32v),
     /* 421444 */   GIR_RootConstrainSelectedInstOperands,
     /* 421445 */   // GIR_Coverage, 6044,
     /* 421445 */   GIR_Done,
     /* 421446 */ // Label 8194: @421446
     /* 421446 */ GIM_Try, /*On fail goto*//*Label 8195*/ GIMT_Encode4(421507), // Rule ID 6045 //
     /* 421451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 421454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 421458 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421462 */   // (vecreduce_umax:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (UMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 421462 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 421465 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 421469 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 421474 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 421478 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 421482 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 421484 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 421487 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 421489 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 421496 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 421501 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421506 */   // GIR_Coverage, 6045,
     /* 421506 */   GIR_EraseRootFromParent_Done,
     /* 421507 */ // Label 8195: @421507
     /* 421507 */ GIM_Reject,
     /* 421508 */ // Label 8189: @421508
     /* 421508 */ GIM_Reject,
     /* 421509 */ // Label 122: @421509
     /* 421509 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 8199*/ GIMT_Encode4(421711),
     /* 421520 */ /*GILLT_s8*//*Label 8196*/ GIMT_Encode4(421532),
     /* 421524 */ /*GILLT_s16*//*Label 8197*/ GIMT_Encode4(421579),
     /* 421528 */ /*GILLT_s32*//*Label 8198*/ GIMT_Encode4(421626),
     /* 421532 */ // Label 8196: @421532
     /* 421532 */ GIM_Try, /*On fail goto*//*Label 8200*/ GIMT_Encode4(421555), // Rule ID 6034 //
     /* 421537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 421540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 421544 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421548 */   // (vecreduce_umin:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (UMINVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 421548 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 421553 */   GIR_RootConstrainSelectedInstOperands,
     /* 421554 */   // GIR_Coverage, 6034,
     /* 421554 */   GIR_Done,
     /* 421555 */ // Label 8200: @421555
     /* 421555 */ GIM_Try, /*On fail goto*//*Label 8201*/ GIMT_Encode4(421578), // Rule ID 6035 //
     /* 421560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 421563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 421567 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421571 */   // (vecreduce_umin:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (UMINVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 421571 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 421576 */   GIR_RootConstrainSelectedInstOperands,
     /* 421577 */   // GIR_Coverage, 6035,
     /* 421577 */   GIR_Done,
     /* 421578 */ // Label 8201: @421578
     /* 421578 */ GIM_Reject,
     /* 421579 */ // Label 8197: @421579
     /* 421579 */ GIM_Try, /*On fail goto*//*Label 8202*/ GIMT_Encode4(421602), // Rule ID 6036 //
     /* 421584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 421587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 421591 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421595 */   // (vecreduce_umin:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (UMINVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 421595 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 421600 */   GIR_RootConstrainSelectedInstOperands,
     /* 421601 */   // GIR_Coverage, 6036,
     /* 421601 */   GIR_Done,
     /* 421602 */ // Label 8202: @421602
     /* 421602 */ GIM_Try, /*On fail goto*//*Label 8203*/ GIMT_Encode4(421625), // Rule ID 6037 //
     /* 421607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 421610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 421614 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421618 */   // (vecreduce_umin:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (UMINVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 421618 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 421623 */   GIR_RootConstrainSelectedInstOperands,
     /* 421624 */   // GIR_Coverage, 6037,
     /* 421624 */   GIR_Done,
     /* 421625 */ // Label 8203: @421625
     /* 421625 */ GIM_Reject,
     /* 421626 */ // Label 8198: @421626
     /* 421626 */ GIM_Try, /*On fail goto*//*Label 8204*/ GIMT_Encode4(421649), // Rule ID 6038 //
     /* 421631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 421634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 421638 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421642 */   // (vecreduce_umin:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (UMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 421642 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i32v),
     /* 421647 */   GIR_RootConstrainSelectedInstOperands,
     /* 421648 */   // GIR_Coverage, 6038,
     /* 421648 */   GIR_Done,
     /* 421649 */ // Label 8204: @421649
     /* 421649 */ GIM_Try, /*On fail goto*//*Label 8205*/ GIMT_Encode4(421710), // Rule ID 6039 //
     /* 421654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 421657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 421661 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421665 */   // (vecreduce_umin:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (UMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 421665 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 421668 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 421672 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 421677 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 421681 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 421685 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 421687 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 421690 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 421692 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 421699 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 421704 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421709 */   // GIR_Coverage, 6039,
     /* 421709 */   GIR_EraseRootFromParent_Done,
     /* 421710 */ // Label 8205: @421710
     /* 421710 */ GIM_Reject,
     /* 421711 */ // Label 8199: @421711
     /* 421711 */ GIM_Reject,
     /* 421712 */ // Label 123: @421712
     /* 421712 */ GIM_Try, /*On fail goto*//*Label 8206*/ GIMT_Encode4(421851),
     /* 421717 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 421720 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 421724 */   GIM_Try, /*On fail goto*//*Label 8207*/ GIMT_Encode4(421758), // Rule ID 257 //
     /* 421729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 421736 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))  =>  (PRFMroW (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 421736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMroW),
     /* 421739 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 421741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 421746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 421751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 421756 */     GIR_RootConstrainSelectedInstOperands,
     /* 421757 */     // GIR_Coverage, 257,
     /* 421757 */     GIR_EraseRootFromParent_Done,
     /* 421758 */   // Label 8207: @421758
     /* 421758 */   GIM_Try, /*On fail goto*//*Label 8208*/ GIMT_Encode4(421792), // Rule ID 258 //
     /* 421763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 421770 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))  =>  (PRFMroX (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 421770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMroX),
     /* 421773 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 421775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 421780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 421785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 421790 */     GIR_RootConstrainSelectedInstOperands,
     /* 421791 */     // GIR_Coverage, 258,
     /* 421791 */     GIR_EraseRootFromParent_Done,
     /* 421792 */   // Label 8208: @421792
     /* 421792 */   GIM_Try, /*On fail goto*//*Label 8209*/ GIMT_Encode4(421821), // Rule ID 273 //
     /* 421797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 421804 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))  =>  (PRFMui (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 421804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMui),
     /* 421807 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 421809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 421814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 421819 */     GIR_RootConstrainSelectedInstOperands,
     /* 421820 */     // GIR_Coverage, 273,
     /* 421820 */     GIR_EraseRootFromParent_Done,
     /* 421821 */   // Label 8209: @421821
     /* 421821 */   GIM_Try, /*On fail goto*//*Label 8210*/ GIMT_Encode4(421850), // Rule ID 294 //
     /* 421826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 421833 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))  =>  (PRFUMi (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 421833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFUMi),
     /* 421836 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 421838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 421843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 421848 */     GIR_RootConstrainSelectedInstOperands,
     /* 421849 */     // GIR_Coverage, 294,
     /* 421849 */     GIR_EraseRootFromParent_Done,
     /* 421850 */   // Label 8210: @421850
     /* 421850 */   GIM_Reject,
     /* 421851 */ // Label 8206: @421851
     /* 421851 */ GIM_Reject,
     /* 421852 */ // Label 124: @421852
     /* 421852 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 8223*/ GIMT_Encode4(422839),
     /* 421863 */ /*GILLT_s64*//*Label 8211*/ GIMT_Encode4(421947), GIMT_Encode4(0),
     /* 421871 */ /*GILLT_v2s32*//*Label 8212*/ GIMT_Encode4(421985),
     /* 421875 */ /*GILLT_v2s64*//*Label 8213*/ GIMT_Encode4(422023),
     /* 421879 */ /*GILLT_v4s16*//*Label 8214*/ GIMT_Encode4(422061),
     /* 421883 */ /*GILLT_v4s32*//*Label 8215*/ GIMT_Encode4(422099),
     /* 421887 */ /*GILLT_v8s8*//*Label 8216*/ GIMT_Encode4(422137),
     /* 421891 */ /*GILLT_v8s16*//*Label 8217*/ GIMT_Encode4(422175),
     /* 421895 */ /*GILLT_v16s8*//*Label 8218*/ GIMT_Encode4(422213), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 421915 */ /*GILLT_nxv2s64*//*Label 8219*/ GIMT_Encode4(422251), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 421927 */ /*GILLT_nxv4s32*//*Label 8220*/ GIMT_Encode4(422398), GIMT_Encode4(0),
     /* 421935 */ /*GILLT_nxv8s16*//*Label 8221*/ GIMT_Encode4(422545), GIMT_Encode4(0),
     /* 421943 */ /*GILLT_nxv16s8*//*Label 8222*/ GIMT_Encode4(422692),
     /* 421947 */ // Label 8211: @421947
     /* 421947 */ GIM_Try, /*On fail goto*//*Label 8224*/ GIMT_Encode4(421984), // Rule ID 5109 //
     /* 421952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 421955 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 421958 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 421961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421965 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421969 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421973 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421977 */   // (AArch64bsp:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm)  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm)
     /* 421977 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 421982 */   GIR_RootConstrainSelectedInstOperands,
     /* 421983 */   // GIR_Coverage, 5109,
     /* 421983 */   GIR_Done,
     /* 421984 */ // Label 8224: @421984
     /* 421984 */ GIM_Reject,
     /* 421985 */ // Label 8212: @421985
     /* 421985 */ GIM_Try, /*On fail goto*//*Label 8225*/ GIMT_Encode4(422022), // Rule ID 5108 //
     /* 421990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 421993 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 421996 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 421999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422003 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422007 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422011 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422015 */   // (AArch64bsp:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 422015 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 422020 */   GIR_RootConstrainSelectedInstOperands,
     /* 422021 */   // GIR_Coverage, 5108,
     /* 422021 */   GIR_Done,
     /* 422022 */ // Label 8225: @422022
     /* 422022 */ GIM_Reject,
     /* 422023 */ // Label 8213: @422023
     /* 422023 */ GIM_Try, /*On fail goto*//*Label 8226*/ GIMT_Encode4(422060), // Rule ID 5113 //
     /* 422028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 422031 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 422034 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 422037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422041 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422045 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422049 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422053 */   // (AArch64bsp:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 422053 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 422058 */   GIR_RootConstrainSelectedInstOperands,
     /* 422059 */   // GIR_Coverage, 5113,
     /* 422059 */   GIR_Done,
     /* 422060 */ // Label 8226: @422060
     /* 422060 */ GIM_Reject,
     /* 422061 */ // Label 8214: @422061
     /* 422061 */ GIM_Try, /*On fail goto*//*Label 8227*/ GIMT_Encode4(422098), // Rule ID 5107 //
     /* 422066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 422069 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 422072 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 422075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422079 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422083 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422087 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422091 */   // (AArch64bsp:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 422091 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 422096 */   GIR_RootConstrainSelectedInstOperands,
     /* 422097 */   // GIR_Coverage, 5107,
     /* 422097 */   GIR_Done,
     /* 422098 */ // Label 8227: @422098
     /* 422098 */ GIM_Reject,
     /* 422099 */ // Label 8215: @422099
     /* 422099 */ GIM_Try, /*On fail goto*//*Label 8228*/ GIMT_Encode4(422136), // Rule ID 5112 //
     /* 422104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 422107 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 422110 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 422113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422117 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422121 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422125 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422129 */   // (AArch64bsp:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 422129 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 422134 */   GIR_RootConstrainSelectedInstOperands,
     /* 422135 */   // GIR_Coverage, 5112,
     /* 422135 */   GIR_Done,
     /* 422136 */ // Label 8228: @422136
     /* 422136 */ GIM_Reject,
     /* 422137 */ // Label 8216: @422137
     /* 422137 */ GIM_Try, /*On fail goto*//*Label 8229*/ GIMT_Encode4(422174), // Rule ID 5106 //
     /* 422142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 422145 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 422148 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 422151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422155 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422159 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422163 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422167 */   // (AArch64bsp:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 422167 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 422172 */   GIR_RootConstrainSelectedInstOperands,
     /* 422173 */   // GIR_Coverage, 5106,
     /* 422173 */   GIR_Done,
     /* 422174 */ // Label 8229: @422174
     /* 422174 */ GIM_Reject,
     /* 422175 */ // Label 8217: @422175
     /* 422175 */ GIM_Try, /*On fail goto*//*Label 8230*/ GIMT_Encode4(422212), // Rule ID 5111 //
     /* 422180 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 422183 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 422186 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 422189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422193 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422197 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422201 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422205 */   // (AArch64bsp:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 422205 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 422210 */   GIR_RootConstrainSelectedInstOperands,
     /* 422211 */   // GIR_Coverage, 5111,
     /* 422211 */   GIR_Done,
     /* 422212 */ // Label 8230: @422212
     /* 422212 */ GIM_Reject,
     /* 422213 */ // Label 8218: @422213
     /* 422213 */ GIM_Try, /*On fail goto*//*Label 8231*/ GIMT_Encode4(422250), // Rule ID 5110 //
     /* 422218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 422221 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 422224 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 422227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422231 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422235 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422239 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422243 */   // (AArch64bsp:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 422243 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 422248 */   GIR_RootConstrainSelectedInstOperands,
     /* 422249 */   // GIR_Coverage, 5110,
     /* 422249 */   GIR_Done,
     /* 422250 */ // Label 8231: @422250
     /* 422250 */ GIM_Reject,
     /* 422251 */ // Label 8219: @422251
     /* 422251 */ GIM_Try, /*On fail goto*//*Label 8232*/ GIMT_Encode4(422397),
     /* 422256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 422259 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 422262 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 422265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 422269 */   GIM_Try, /*On fail goto*//*Label 8233*/ GIMT_Encode4(422322), // Rule ID 12016 //
     /* 422274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 422277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 422281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 422285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 422289 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 422293 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 422297 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 422303 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 422305 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 422307 */     // (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 422307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 422310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 422312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /* 422316 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 422318 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 422320 */     GIR_RootConstrainSelectedInstOperands,
     /* 422321 */     // GIR_Coverage, 12016,
     /* 422321 */     GIR_EraseRootFromParent_Done,
     /* 422322 */   // Label 8233: @422322
     /* 422322 */   GIM_Try, /*On fail goto*//*Label 8234*/ GIMT_Encode4(422375), // Rule ID 12027 //
     /* 422327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 422330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 422334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 422338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 422342 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 422346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 422350 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 422356 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 422358 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 422360 */     // (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] }))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 422360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 422363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 422365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 422367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /* 422371 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 422373 */     GIR_RootConstrainSelectedInstOperands,
     /* 422374 */     // GIR_Coverage, 12027,
     /* 422374 */     GIR_EraseRootFromParent_Done,
     /* 422375 */   // Label 8234: @422375
     /* 422375 */   GIM_Try, /*On fail goto*//*Label 8235*/ GIMT_Encode4(422396), // Rule ID 12008 //
     /* 422380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 422383 */     // (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 422383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 422386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 422388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 422390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 422392 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 422394 */     GIR_RootConstrainSelectedInstOperands,
     /* 422395 */     // GIR_Coverage, 12008,
     /* 422395 */     GIR_EraseRootFromParent_Done,
     /* 422396 */   // Label 8235: @422396
     /* 422396 */   GIM_Reject,
     /* 422397 */ // Label 8232: @422397
     /* 422397 */ GIM_Reject,
     /* 422398 */ // Label 8220: @422398
     /* 422398 */ GIM_Try, /*On fail goto*//*Label 8236*/ GIMT_Encode4(422544),
     /* 422403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 422406 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 422409 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 422412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 422416 */   GIM_Try, /*On fail goto*//*Label 8237*/ GIMT_Encode4(422469), // Rule ID 12014 //
     /* 422421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 422424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 422428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 422432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 422436 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 422440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 422444 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 422450 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 422452 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 422454 */     // (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 422454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 422457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 422459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /* 422463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 422465 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 422467 */     GIR_RootConstrainSelectedInstOperands,
     /* 422468 */     // GIR_Coverage, 12014,
     /* 422468 */     GIR_EraseRootFromParent_Done,
     /* 422469 */   // Label 8237: @422469
     /* 422469 */   GIM_Try, /*On fail goto*//*Label 8238*/ GIMT_Encode4(422522), // Rule ID 12024 //
     /* 422474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 422477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 422481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 422485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 422489 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 422493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 422497 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 422503 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 422505 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 422507 */     // (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] }))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 422507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 422510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 422512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 422514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /* 422518 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 422520 */     GIR_RootConstrainSelectedInstOperands,
     /* 422521 */     // GIR_Coverage, 12024,
     /* 422521 */     GIR_EraseRootFromParent_Done,
     /* 422522 */   // Label 8238: @422522
     /* 422522 */   GIM_Try, /*On fail goto*//*Label 8239*/ GIMT_Encode4(422543), // Rule ID 12006 //
     /* 422527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 422530 */     // (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 422530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 422533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 422535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 422537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 422539 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 422541 */     GIR_RootConstrainSelectedInstOperands,
     /* 422542 */     // GIR_Coverage, 12006,
     /* 422542 */     GIR_EraseRootFromParent_Done,
     /* 422543 */   // Label 8239: @422543
     /* 422543 */   GIM_Reject,
     /* 422544 */ // Label 8236: @422544
     /* 422544 */ GIM_Reject,
     /* 422545 */ // Label 8221: @422545
     /* 422545 */ GIM_Try, /*On fail goto*//*Label 8240*/ GIMT_Encode4(422691),
     /* 422550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 422553 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 422556 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 422559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 422563 */   GIM_Try, /*On fail goto*//*Label 8241*/ GIMT_Encode4(422616), // Rule ID 12012 //
     /* 422568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 422571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 422575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 422579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 422583 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 422587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 422591 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 422597 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 422599 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 422601 */     // (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 422601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 422604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 422606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /* 422610 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 422612 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 422614 */     GIR_RootConstrainSelectedInstOperands,
     /* 422615 */     // GIR_Coverage, 12012,
     /* 422615 */     GIR_EraseRootFromParent_Done,
     /* 422616 */   // Label 8241: @422616
     /* 422616 */   GIM_Try, /*On fail goto*//*Label 8242*/ GIMT_Encode4(422669), // Rule ID 12021 //
     /* 422621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 422624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 422628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 422632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 422636 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 422640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 422644 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 422650 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 422652 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 422654 */     // (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] }))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 422654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 422657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 422659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 422661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /* 422665 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 422667 */     GIR_RootConstrainSelectedInstOperands,
     /* 422668 */     // GIR_Coverage, 12021,
     /* 422668 */     GIR_EraseRootFromParent_Done,
     /* 422669 */   // Label 8242: @422669
     /* 422669 */   GIM_Try, /*On fail goto*//*Label 8243*/ GIMT_Encode4(422690), // Rule ID 12004 //
     /* 422674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 422677 */     // (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 422677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 422680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 422682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 422684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 422686 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 422688 */     GIR_RootConstrainSelectedInstOperands,
     /* 422689 */     // GIR_Coverage, 12004,
     /* 422689 */     GIR_EraseRootFromParent_Done,
     /* 422690 */   // Label 8243: @422690
     /* 422690 */   GIM_Reject,
     /* 422691 */ // Label 8240: @422691
     /* 422691 */ GIM_Reject,
     /* 422692 */ // Label 8222: @422692
     /* 422692 */ GIM_Try, /*On fail goto*//*Label 8244*/ GIMT_Encode4(422838),
     /* 422697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 422700 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 422703 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 422706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 422710 */   GIM_Try, /*On fail goto*//*Label 8245*/ GIMT_Encode4(422763), // Rule ID 12010 //
     /* 422715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 422718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 422722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 422726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 422730 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 422734 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 422738 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 422744 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 422746 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 422748 */     // (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 422748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 422751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 422753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /* 422757 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 422759 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 422761 */     GIR_RootConstrainSelectedInstOperands,
     /* 422762 */     // GIR_Coverage, 12010,
     /* 422762 */     GIR_EraseRootFromParent_Done,
     /* 422763 */   // Label 8245: @422763
     /* 422763 */   GIM_Try, /*On fail goto*//*Label 8246*/ GIMT_Encode4(422816), // Rule ID 12018 //
     /* 422768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 422771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 422775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 422779 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 422783 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 422787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 422791 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 422797 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 422799 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 422801 */     // (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] }))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 422801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 422804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 422806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 422808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /* 422812 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 422814 */     GIR_RootConstrainSelectedInstOperands,
     /* 422815 */     // GIR_Coverage, 12018,
     /* 422815 */     GIR_EraseRootFromParent_Done,
     /* 422816 */   // Label 8246: @422816
     /* 422816 */   GIM_Try, /*On fail goto*//*Label 8247*/ GIMT_Encode4(422837), // Rule ID 12002 //
     /* 422821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 422824 */     // (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 422824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 422827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 422829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 422831 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 422833 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 422835 */     GIR_RootConstrainSelectedInstOperands,
     /* 422836 */     // GIR_Coverage, 12002,
     /* 422836 */     GIR_EraseRootFromParent_Done,
     /* 422837 */   // Label 8247: @422837
     /* 422837 */   GIM_Reject,
     /* 422838 */ // Label 8244: @422838
     /* 422838 */ GIM_Reject,
     /* 422839 */ // Label 8223: @422839
     /* 422839 */ GIM_Reject,
     /* 422840 */ // Label 125: @422840
     /* 422840 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8256*/ GIMT_Encode4(424822),
     /* 422851 */ /*GILLT_s64*//*Label 8248*/ GIMT_Encode4(422887), GIMT_Encode4(0),
     /* 422859 */ /*GILLT_v2s32*//*Label 8249*/ GIMT_Encode4(423082),
     /* 422863 */ /*GILLT_v2s64*//*Label 8250*/ GIMT_Encode4(423329),
     /* 422867 */ /*GILLT_v4s16*//*Label 8251*/ GIMT_Encode4(423576),
     /* 422871 */ /*GILLT_v4s32*//*Label 8252*/ GIMT_Encode4(423852),
     /* 422875 */ /*GILLT_v8s8*//*Label 8253*/ GIMT_Encode4(424099),
     /* 422879 */ /*GILLT_v8s16*//*Label 8254*/ GIMT_Encode4(424324),
     /* 422883 */ /*GILLT_v16s8*//*Label 8255*/ GIMT_Encode4(424600),
     /* 422887 */ // Label 8248: @422887
     /* 422887 */ GIM_Try, /*On fail goto*//*Label 8257*/ GIMT_Encode4(423081),
     /* 422892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 422895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422899 */   GIM_Try, /*On fail goto*//*Label 8258*/ GIMT_Encode4(422946), // Rule ID 6487 //
     /* 422904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422912 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422915 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422919 */     // MIs[1] Rn
     /* 422919 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 422923 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422930 */     // (AArch64dup:{ *:[v1i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 422933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422939 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422944 */     GIR_RootConstrainSelectedInstOperands,
     /* 422945 */     // GIR_Coverage, 6487,
     /* 422945 */     GIR_EraseRootFromParent_Done,
     /* 422946 */   // Label 8258: @422946
     /* 422946 */   GIM_Try, /*On fail goto*//*Label 8259*/ GIMT_Encode4(422993), // Rule ID 6498 //
     /* 422951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422959 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422962 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422966 */     // MIs[1] Rn
     /* 422966 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 422970 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422977 */     // (AArch64dup:{ *:[v1f64] } (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 422980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422986 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422991 */     GIR_RootConstrainSelectedInstOperands,
     /* 422992 */     // GIR_Coverage, 6498,
     /* 422992 */     GIR_EraseRootFromParent_Done,
     /* 422993 */   // Label 8259: @422993
     /* 422993 */   GIM_Try, /*On fail goto*//*Label 8260*/ GIMT_Encode4(423040), // Rule ID 13344 //
     /* 422998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 423006 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 423009 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 423013 */     // MIs[1] Rn
     /* 423013 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 423017 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 423022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423024 */     // (AArch64dup:{ *:[v1i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 423024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 423027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 423029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423033 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 423038 */     GIR_RootConstrainSelectedInstOperands,
     /* 423039 */     // GIR_Coverage, 13344,
     /* 423039 */     GIR_EraseRootFromParent_Done,
     /* 423040 */   // Label 8260: @423040
     /* 423040 */   GIM_Try, /*On fail goto*//*Label 8261*/ GIMT_Encode4(423060), // Rule ID 5672 //
     /* 423045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 423049 */     // (AArch64dup:{ *:[v1i64] } GPR64:{ *:[i64] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i32] })
     /* 423049 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 423054 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423059 */     // GIR_Coverage, 5672,
     /* 423059 */     GIR_Done,
     /* 423060 */   // Label 8261: @423060
     /* 423060 */   GIM_Try, /*On fail goto*//*Label 8262*/ GIMT_Encode4(423080), // Rule ID 5673 //
     /* 423065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423069 */     // (AArch64dup:{ *:[v1f64] } FPR64:{ *:[f64] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[i32] })
     /* 423069 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 423074 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423079 */     // GIR_Coverage, 5673,
     /* 423079 */     GIR_Done,
     /* 423080 */   // Label 8262: @423080
     /* 423080 */   GIM_Reject,
     /* 423081 */ // Label 8257: @423081
     /* 423081 */ GIM_Reject,
     /* 423082 */ // Label 8249: @423082
     /* 423082 */ GIM_Try, /*On fail goto*//*Label 8263*/ GIMT_Encode4(423328),
     /* 423087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 423090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423094 */   GIM_Try, /*On fail goto*//*Label 8264*/ GIMT_Encode4(423141), // Rule ID 6484 //
     /* 423099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 423107 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 423110 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 423114 */     // MIs[1] Rn
     /* 423114 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 423118 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 423123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423125 */     // (AArch64dup:{ *:[v2i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 423125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 423128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 423130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 423139 */     GIR_RootConstrainSelectedInstOperands,
     /* 423140 */     // GIR_Coverage, 6484,
     /* 423140 */     GIR_EraseRootFromParent_Done,
     /* 423141 */   // Label 8264: @423141
     /* 423141 */   GIM_Try, /*On fail goto*//*Label 8265*/ GIMT_Encode4(423188), // Rule ID 6495 //
     /* 423146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 423154 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 423157 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 423161 */     // MIs[1] Rn
     /* 423161 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 423165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 423170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423172 */     // (AArch64dup:{ *:[v2f32] } (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 423172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 423175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 423177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423181 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 423186 */     GIR_RootConstrainSelectedInstOperands,
     /* 423187 */     // GIR_Coverage, 6495,
     /* 423187 */     GIR_EraseRootFromParent_Done,
     /* 423188 */   // Label 8265: @423188
     /* 423188 */   GIM_Try, /*On fail goto*//*Label 8266*/ GIMT_Encode4(423235), // Rule ID 13341 //
     /* 423193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 423201 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 423204 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 423208 */     // MIs[1] Rn
     /* 423208 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 423212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 423217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423219 */     // (AArch64dup:{ *:[v2i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 423219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 423222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 423224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423228 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 423233 */     GIR_RootConstrainSelectedInstOperands,
     /* 423234 */     // GIR_Coverage, 13341,
     /* 423234 */     GIR_EraseRootFromParent_Done,
     /* 423235 */   // Label 8266: @423235
     /* 423235 */   GIM_Try, /*On fail goto*//*Label 8267*/ GIMT_Encode4(423254), // Rule ID 1916 //
     /* 423240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 423243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 423247 */     // (AArch64dup:{ *:[v2i32] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv2i32gpr:{ *:[v2i32] } GPR32:{ *:[i32] }:$Rn)
     /* 423247 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32gpr),
     /* 423252 */     GIR_RootConstrainSelectedInstOperands,
     /* 423253 */     // GIR_Coverage, 1916,
     /* 423253 */     GIR_Done,
     /* 423254 */   // Label 8267: @423254
     /* 423254 */   GIM_Try, /*On fail goto*//*Label 8268*/ GIMT_Encode4(423327), // Rule ID 5674 //
     /* 423259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 423263 */     // (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rn)  =>  (DUPv2i32lane:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 423263 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 423266 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 423270 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 423275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 423277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 423280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 423284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 423289 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 423292 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 423296 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 423299 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423304 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423309 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 423314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 423317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 423322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423325 */     GIR_RootConstrainSelectedInstOperands,
     /* 423326 */     // GIR_Coverage, 5674,
     /* 423326 */     GIR_EraseRootFromParent_Done,
     /* 423327 */   // Label 8268: @423327
     /* 423327 */   GIM_Reject,
     /* 423328 */ // Label 8263: @423328
     /* 423328 */ GIM_Reject,
     /* 423329 */ // Label 8250: @423329
     /* 423329 */ GIM_Try, /*On fail goto*//*Label 8269*/ GIMT_Encode4(423575),
     /* 423334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 423337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423341 */   GIM_Try, /*On fail goto*//*Label 8270*/ GIMT_Encode4(423388), // Rule ID 6486 //
     /* 423346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 423354 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 423357 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 423361 */     // MIs[1] Rn
     /* 423361 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 423365 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 423370 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423372 */     // (AArch64dup:{ *:[v2i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 423372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 423375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 423377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423381 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 423386 */     GIR_RootConstrainSelectedInstOperands,
     /* 423387 */     // GIR_Coverage, 6486,
     /* 423387 */     GIR_EraseRootFromParent_Done,
     /* 423388 */   // Label 8270: @423388
     /* 423388 */   GIM_Try, /*On fail goto*//*Label 8271*/ GIMT_Encode4(423435), // Rule ID 6497 //
     /* 423393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 423401 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 423404 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 423408 */     // MIs[1] Rn
     /* 423408 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 423412 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 423417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423419 */     // (AArch64dup:{ *:[v2f64] } (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 423419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 423422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 423424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423428 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 423433 */     GIR_RootConstrainSelectedInstOperands,
     /* 423434 */     // GIR_Coverage, 6497,
     /* 423434 */     GIR_EraseRootFromParent_Done,
     /* 423435 */   // Label 8271: @423435
     /* 423435 */   GIM_Try, /*On fail goto*//*Label 8272*/ GIMT_Encode4(423482), // Rule ID 13343 //
     /* 423440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 423448 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 423451 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 423455 */     // MIs[1] Rn
     /* 423455 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 423459 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 423464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423466 */     // (AArch64dup:{ *:[v2i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 423466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 423469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 423471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423475 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 423480 */     GIR_RootConstrainSelectedInstOperands,
     /* 423481 */     // GIR_Coverage, 13343,
     /* 423481 */     GIR_EraseRootFromParent_Done,
     /* 423482 */   // Label 8272: @423482
     /* 423482 */   GIM_Try, /*On fail goto*//*Label 8273*/ GIMT_Encode4(423501), // Rule ID 1918 //
     /* 423487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 423490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 423494 */     // (AArch64dup:{ *:[v2i64] } GPR64:{ *:[i64] }:$Rn)  =>  (DUPv2i64gpr:{ *:[v2i64] } GPR64:{ *:[i64] }:$Rn)
     /* 423494 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64gpr),
     /* 423499 */     GIR_RootConstrainSelectedInstOperands,
     /* 423500 */     // GIR_Coverage, 1918,
     /* 423500 */     GIR_Done,
     /* 423501 */   // Label 8273: @423501
     /* 423501 */   GIM_Try, /*On fail goto*//*Label 8274*/ GIMT_Encode4(423574), // Rule ID 5676 //
     /* 423506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423510 */     // (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rn)  =>  (DUPv2i64lane:{ *:[v2f64] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 423510 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 423513 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 423517 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 423522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 423524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 423527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 423531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 423536 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 423539 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 423543 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 423546 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423551 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423556 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 423564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423566 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 423569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423572 */     GIR_RootConstrainSelectedInstOperands,
     /* 423573 */     // GIR_Coverage, 5676,
     /* 423573 */     GIR_EraseRootFromParent_Done,
     /* 423574 */   // Label 8274: @423574
     /* 423574 */   GIM_Reject,
     /* 423575 */ // Label 8269: @423575
     /* 423575 */ GIM_Reject,
     /* 423576 */ // Label 8251: @423576
     /* 423576 */ GIM_Try, /*On fail goto*//*Label 8275*/ GIMT_Encode4(423637), // Rule ID 6482 //
     /* 423581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 423584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423588 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423592 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 423596 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 423599 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 423603 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 423610 */   // MIs[1] Rn
     /* 423610 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 423614 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 423619 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423621 */   // (AArch64dup:{ *:[v4i16] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>)  =>  (LD1Rv4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 423621 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 423624 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 423626 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423630 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 423635 */   GIR_RootConstrainSelectedInstOperands,
     /* 423636 */   // GIR_Coverage, 6482,
     /* 423636 */   GIR_EraseRootFromParent_Done,
     /* 423637 */ // Label 8275: @423637
     /* 423637 */ GIM_Try, /*On fail goto*//*Label 8276*/ GIMT_Encode4(423691), // Rule ID 6499 //
     /* 423642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 423645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423649 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423653 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 423657 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 423660 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 423664 */   // MIs[1] Rn
     /* 423664 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 423668 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 423673 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423675 */   // (AArch64dup:{ *:[v4f16] } (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4h:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 423675 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 423678 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 423680 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423684 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 423689 */   GIR_RootConstrainSelectedInstOperands,
     /* 423690 */   // GIR_Coverage, 6499,
     /* 423690 */   GIR_EraseRootFromParent_Done,
     /* 423691 */ // Label 8276: @423691
     /* 423691 */ GIM_Try, /*On fail goto*//*Label 8277*/ GIMT_Encode4(423745), // Rule ID 13339 //
     /* 423696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 423699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423703 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423707 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 423711 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 423714 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 423718 */   // MIs[1] Rn
     /* 423718 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 423722 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 423727 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423729 */   // (AArch64dup:{ *:[v4i16] } (ld:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 423729 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 423732 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 423734 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423738 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 423743 */   GIR_RootConstrainSelectedInstOperands,
     /* 423744 */   // GIR_Coverage, 13339,
     /* 423744 */   GIR_EraseRootFromParent_Done,
     /* 423745 */ // Label 8277: @423745
     /* 423745 */ GIM_Try, /*On fail goto*//*Label 8278*/ GIMT_Encode4(423771), // Rule ID 1914 //
     /* 423750 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 423753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 423756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423760 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 423764 */   // (AArch64dup:{ *:[v4i16] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv4i16gpr:{ *:[v4i16] } GPR32:{ *:[i32] }:$Rn)
     /* 423764 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16gpr),
     /* 423769 */   GIR_RootConstrainSelectedInstOperands,
     /* 423770 */   // GIR_Coverage, 1914,
     /* 423770 */   GIR_Done,
     /* 423771 */ // Label 8278: @423771
     /* 423771 */ GIM_Try, /*On fail goto*//*Label 8279*/ GIMT_Encode4(423851), // Rule ID 5677 //
     /* 423776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 423779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423783 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 423787 */   // (AArch64dup:{ *:[v4f16] } FPR16:{ *:[f16] }:$Rn)  =>  (DUPv4i16lane:{ *:[v4f16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 423787 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 423790 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 423794 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 423799 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 423801 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 423804 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 423808 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 423813 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 423816 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 423820 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 423823 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423828 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423833 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 423838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 423841 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423843 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 423846 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423849 */   GIR_RootConstrainSelectedInstOperands,
     /* 423850 */   // GIR_Coverage, 5677,
     /* 423850 */   GIR_EraseRootFromParent_Done,
     /* 423851 */ // Label 8279: @423851
     /* 423851 */ GIM_Reject,
     /* 423852 */ // Label 8252: @423852
     /* 423852 */ GIM_Try, /*On fail goto*//*Label 8280*/ GIMT_Encode4(424098),
     /* 423857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 423860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423864 */   GIM_Try, /*On fail goto*//*Label 8281*/ GIMT_Encode4(423911), // Rule ID 6485 //
     /* 423869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 423877 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 423880 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 423884 */     // MIs[1] Rn
     /* 423884 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 423888 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 423893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423895 */     // (AArch64dup:{ *:[v4i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 423895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 423898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 423900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423904 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 423909 */     GIR_RootConstrainSelectedInstOperands,
     /* 423910 */     // GIR_Coverage, 6485,
     /* 423910 */     GIR_EraseRootFromParent_Done,
     /* 423911 */   // Label 8281: @423911
     /* 423911 */   GIM_Try, /*On fail goto*//*Label 8282*/ GIMT_Encode4(423958), // Rule ID 6496 //
     /* 423916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 423924 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 423927 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 423931 */     // MIs[1] Rn
     /* 423931 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 423935 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 423940 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423942 */     // (AArch64dup:{ *:[v4f32] } (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 423942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 423945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 423947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423951 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 423956 */     GIR_RootConstrainSelectedInstOperands,
     /* 423957 */     // GIR_Coverage, 6496,
     /* 423957 */     GIR_EraseRootFromParent_Done,
     /* 423958 */   // Label 8282: @423958
     /* 423958 */   GIM_Try, /*On fail goto*//*Label 8283*/ GIMT_Encode4(424005), // Rule ID 13342 //
     /* 423963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 423971 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 423974 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 423978 */     // MIs[1] Rn
     /* 423978 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 423982 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 423987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423989 */     // (AArch64dup:{ *:[v4i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 423989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 423992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 423994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423998 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 424003 */     GIR_RootConstrainSelectedInstOperands,
     /* 424004 */     // GIR_Coverage, 13342,
     /* 424004 */     GIR_EraseRootFromParent_Done,
     /* 424005 */   // Label 8283: @424005
     /* 424005 */   GIM_Try, /*On fail goto*//*Label 8284*/ GIMT_Encode4(424024), // Rule ID 1917 //
     /* 424010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 424013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 424017 */     // (AArch64dup:{ *:[v4i32] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv4i32gpr:{ *:[v4i32] } GPR32:{ *:[i32] }:$Rn)
     /* 424017 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32gpr),
     /* 424022 */     GIR_RootConstrainSelectedInstOperands,
     /* 424023 */     // GIR_Coverage, 1917,
     /* 424023 */     GIR_Done,
     /* 424024 */   // Label 8284: @424024
     /* 424024 */   GIM_Try, /*On fail goto*//*Label 8285*/ GIMT_Encode4(424097), // Rule ID 5675 //
     /* 424029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 424033 */     // (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rn)  =>  (DUPv4i32lane:{ *:[v4f32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 424033 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 424036 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 424040 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 424045 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 424047 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 424050 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 424054 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 424059 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 424062 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 424066 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 424069 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424074 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424079 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 424084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 424087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424089 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 424092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424095 */     GIR_RootConstrainSelectedInstOperands,
     /* 424096 */     // GIR_Coverage, 5675,
     /* 424096 */     GIR_EraseRootFromParent_Done,
     /* 424097 */   // Label 8285: @424097
     /* 424097 */   GIM_Reject,
     /* 424098 */ // Label 8280: @424098
     /* 424098 */ GIM_Reject,
     /* 424099 */ // Label 8253: @424099
     /* 424099 */ GIM_Try, /*On fail goto*//*Label 8286*/ GIMT_Encode4(424156), // Rule ID 13337 //
     /* 424104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 424107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424111 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424115 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 424119 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 424122 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 424126 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 424130 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424132 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 424139 */   // (AArch64dup:{ *:[v8i8] } (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 424139 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8b),
     /* 424142 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 424144 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 424149 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 424154 */   GIR_RootConstrainSelectedInstOperands,
     /* 424155 */   // GIR_Coverage, 13337,
     /* 424155 */   GIR_EraseRootFromParent_Done,
     /* 424156 */ // Label 8286: @424156
     /* 424156 */ GIM_Try, /*On fail goto*//*Label 8287*/ GIMT_Encode4(424217), // Rule ID 6480 //
     /* 424161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 424164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424168 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424172 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 424176 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 424179 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 424183 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 424190 */   // MIs[1] Rn
     /* 424190 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 424194 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 424199 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424201 */   // (AArch64dup:{ *:[v8i8] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>)  =>  (LD1Rv8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 424201 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8b),
     /* 424204 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 424206 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424210 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 424215 */   GIR_RootConstrainSelectedInstOperands,
     /* 424216 */   // GIR_Coverage, 6480,
     /* 424216 */   GIR_EraseRootFromParent_Done,
     /* 424217 */ // Label 8287: @424217
     /* 424217 */ GIM_Try, /*On fail goto*//*Label 8288*/ GIMT_Encode4(424243), // Rule ID 1912 //
     /* 424222 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 424225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 424228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424232 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 424236 */   // (AArch64dup:{ *:[v8i8] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv8i8gpr:{ *:[v8i8] } GPR32:{ *:[i32] }:$Rn)
     /* 424236 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i8gpr),
     /* 424241 */   GIR_RootConstrainSelectedInstOperands,
     /* 424242 */   // GIR_Coverage, 1912,
     /* 424242 */   GIR_Done,
     /* 424243 */ // Label 8288: @424243
     /* 424243 */ GIM_Try, /*On fail goto*//*Label 8289*/ GIMT_Encode4(424323), // Rule ID 5679 //
     /* 424248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 424251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424255 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 424259 */   // (AArch64dup:{ *:[v8i8] } FPR8:{ *:[i8] }:$Rn)  =>  (DUPv8i8lane:{ *:[v8i8] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rn, bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 424259 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 424262 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 424266 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 424271 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 424273 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 424276 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 424280 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 424285 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 424288 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 424292 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 424295 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424300 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424305 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 424310 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i8lane),
     /* 424313 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424315 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 424318 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424321 */   GIR_RootConstrainSelectedInstOperands,
     /* 424322 */   // GIR_Coverage, 5679,
     /* 424322 */   GIR_EraseRootFromParent_Done,
     /* 424323 */ // Label 8289: @424323
     /* 424323 */ GIM_Reject,
     /* 424324 */ // Label 8254: @424324
     /* 424324 */ GIM_Try, /*On fail goto*//*Label 8290*/ GIMT_Encode4(424385), // Rule ID 6483 //
     /* 424329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 424332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424336 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424340 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 424344 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 424347 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 424351 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 424358 */   // MIs[1] Rn
     /* 424358 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 424362 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 424367 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424369 */   // (AArch64dup:{ *:[v8i16] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>)  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 424369 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 424372 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 424374 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424378 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 424383 */   GIR_RootConstrainSelectedInstOperands,
     /* 424384 */   // GIR_Coverage, 6483,
     /* 424384 */   GIR_EraseRootFromParent_Done,
     /* 424385 */ // Label 8290: @424385
     /* 424385 */ GIM_Try, /*On fail goto*//*Label 8291*/ GIMT_Encode4(424439), // Rule ID 6500 //
     /* 424390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 424393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424397 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424401 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 424405 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 424408 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 424412 */   // MIs[1] Rn
     /* 424412 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 424416 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 424421 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424423 */   // (AArch64dup:{ *:[v8f16] } (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8h:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 424423 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 424426 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 424428 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424432 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 424437 */   GIR_RootConstrainSelectedInstOperands,
     /* 424438 */   // GIR_Coverage, 6500,
     /* 424438 */   GIR_EraseRootFromParent_Done,
     /* 424439 */ // Label 8291: @424439
     /* 424439 */ GIM_Try, /*On fail goto*//*Label 8292*/ GIMT_Encode4(424493), // Rule ID 13340 //
     /* 424444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 424447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424451 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424455 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 424459 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 424462 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 424466 */   // MIs[1] Rn
     /* 424466 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 424470 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 424475 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424477 */   // (AArch64dup:{ *:[v8i16] } (ld:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 424477 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 424480 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 424482 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424486 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 424491 */   GIR_RootConstrainSelectedInstOperands,
     /* 424492 */   // GIR_Coverage, 13340,
     /* 424492 */   GIR_EraseRootFromParent_Done,
     /* 424493 */ // Label 8292: @424493
     /* 424493 */ GIM_Try, /*On fail goto*//*Label 8293*/ GIMT_Encode4(424519), // Rule ID 1915 //
     /* 424498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 424501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 424504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424508 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 424512 */   // (AArch64dup:{ *:[v8i16] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv8i16gpr:{ *:[v8i16] } GPR32:{ *:[i32] }:$Rn)
     /* 424512 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16gpr),
     /* 424517 */   GIR_RootConstrainSelectedInstOperands,
     /* 424518 */   // GIR_Coverage, 1915,
     /* 424518 */   GIR_Done,
     /* 424519 */ // Label 8293: @424519
     /* 424519 */ GIM_Try, /*On fail goto*//*Label 8294*/ GIMT_Encode4(424599), // Rule ID 5678 //
     /* 424524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 424527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424531 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 424535 */   // (AArch64dup:{ *:[v8f16] } FPR16:{ *:[f16] }:$Rn)  =>  (DUPv8i16lane:{ *:[v8f16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 424535 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 424538 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 424542 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 424547 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 424549 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 424552 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 424556 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 424561 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 424564 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 424568 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 424571 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424576 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424581 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 424586 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 424589 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424591 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 424594 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424597 */   GIR_RootConstrainSelectedInstOperands,
     /* 424598 */   // GIR_Coverage, 5678,
     /* 424598 */   GIR_EraseRootFromParent_Done,
     /* 424599 */ // Label 8294: @424599
     /* 424599 */ GIM_Reject,
     /* 424600 */ // Label 8255: @424600
     /* 424600 */ GIM_Try, /*On fail goto*//*Label 8295*/ GIMT_Encode4(424661), // Rule ID 6481 //
     /* 424605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 424608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424612 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424616 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 424620 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 424623 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 424627 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 424634 */   // MIs[1] Rn
     /* 424634 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 424638 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 424643 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424645 */   // (AArch64dup:{ *:[v16i8] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>)  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 424645 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 424648 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 424650 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424654 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 424659 */   GIR_RootConstrainSelectedInstOperands,
     /* 424660 */   // GIR_Coverage, 6481,
     /* 424660 */   GIR_EraseRootFromParent_Done,
     /* 424661 */ // Label 8295: @424661
     /* 424661 */ GIM_Try, /*On fail goto*//*Label 8296*/ GIMT_Encode4(424715), // Rule ID 13338 //
     /* 424666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 424669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424673 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424677 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 424681 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 424684 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 424688 */   // MIs[1] Rn
     /* 424688 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 424692 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 424697 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424699 */   // (AArch64dup:{ *:[v16i8] } (ld:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 424699 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 424702 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 424704 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424708 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 424713 */   GIR_RootConstrainSelectedInstOperands,
     /* 424714 */   // GIR_Coverage, 13338,
     /* 424714 */   GIR_EraseRootFromParent_Done,
     /* 424715 */ // Label 8296: @424715
     /* 424715 */ GIM_Try, /*On fail goto*//*Label 8297*/ GIMT_Encode4(424741), // Rule ID 1913 //
     /* 424720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 424723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 424726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424730 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 424734 */   // (AArch64dup:{ *:[v16i8] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv16i8gpr:{ *:[v16i8] } GPR32:{ *:[i32] }:$Rn)
     /* 424734 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv16i8gpr),
     /* 424739 */   GIR_RootConstrainSelectedInstOperands,
     /* 424740 */   // GIR_Coverage, 1913,
     /* 424740 */   GIR_Done,
     /* 424741 */ // Label 8297: @424741
     /* 424741 */ GIM_Try, /*On fail goto*//*Label 8298*/ GIMT_Encode4(424821), // Rule ID 5680 //
     /* 424746 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 424749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424753 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 424757 */   // (AArch64dup:{ *:[v16i8] } FPR8:{ *:[i8] }:$Rn)  =>  (DUPv16i8lane:{ *:[v16i8] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rn, bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 424757 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 424760 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 424764 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 424769 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 424771 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 424774 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 424778 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 424783 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 424786 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 424790 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 424793 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424798 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424803 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 424808 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv16i8lane),
     /* 424811 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424813 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 424816 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424819 */   GIR_RootConstrainSelectedInstOperands,
     /* 424820 */   // GIR_Coverage, 5680,
     /* 424820 */   GIR_EraseRootFromParent_Done,
     /* 424821 */ // Label 8298: @424821
     /* 424821 */ GIM_Reject,
     /* 424822 */ // Label 8256: @424822
     /* 424822 */ GIM_Reject,
     /* 424823 */ // Label 126: @424823
     /* 424823 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(11), /*)*//*default:*//*Label 8301*/ GIMT_Encode4(425077),
     /* 424834 */ /*GILLT_v4s16*//*Label 8299*/ GIMT_Encode4(424850), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 424846 */ /*GILLT_v8s16*//*Label 8300*/ GIMT_Encode4(424936),
     /* 424850 */ // Label 8299: @424850
     /* 424850 */ GIM_Try, /*On fail goto*//*Label 8302*/ GIMT_Encode4(424935),
     /* 424855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 424858 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 424861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424865 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424869 */   GIM_Try, /*On fail goto*//*Label 8303*/ GIMT_Encode4(424903), // Rule ID 1922 //
     /* 424874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 424877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 424881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424885 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 424889 */     // MIs[1] Operand 1
     /* 424889 */     // No operand predicates
     /* 424889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424891 */     // (AArch64duplane16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPv4i16lane:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 424891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 424894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424896 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424898 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 424901 */     GIR_RootConstrainSelectedInstOperands,
     /* 424902 */     // GIR_Coverage, 1922,
     /* 424902 */     GIR_EraseRootFromParent_Done,
     /* 424903 */   // Label 8303: @424903
     /* 424903 */   GIM_Try, /*On fail goto*//*Label 8304*/ GIMT_Encode4(424934), // Rule ID 5681 //
     /* 424908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 424912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424916 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 424920 */     // MIs[1] Operand 1
     /* 424920 */     // No operand predicates
     /* 424920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424922 */     // (AArch64duplane16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (DUPv4i16lane:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)
     /* 424922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 424925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424927 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 424932 */     GIR_RootConstrainSelectedInstOperands,
     /* 424933 */     // GIR_Coverage, 5681,
     /* 424933 */     GIR_EraseRootFromParent_Done,
     /* 424934 */   // Label 8304: @424934
     /* 424934 */   GIM_Reject,
     /* 424935 */ // Label 8302: @424935
     /* 424935 */ GIM_Reject,
     /* 424936 */ // Label 8300: @424936
     /* 424936 */ GIM_Try, /*On fail goto*//*Label 8305*/ GIMT_Encode4(425076),
     /* 424941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 424944 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 424947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424951 */   GIM_Try, /*On fail goto*//*Label 8306*/ GIMT_Encode4(425002), // Rule ID 6491 //
     /* 424956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 424964 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 424967 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 424971 */     // MIs[1] Rn
     /* 424971 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 424975 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 424980 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 424984 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424986 */     // (AArch64duplane16:{ *:[v8i16] } (ld:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 424986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 424989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 424991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424995 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 425000 */     GIR_RootConstrainSelectedInstOperands,
     /* 425001 */     // GIR_Coverage, 6491,
     /* 425001 */     GIR_EraseRootFromParent_Done,
     /* 425002 */   // Label 8306: @425002
     /* 425002 */   GIM_Try, /*On fail goto*//*Label 8307*/ GIMT_Encode4(425040), // Rule ID 1923 //
     /* 425007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 425018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425022 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 425026 */     // MIs[1] Operand 1
     /* 425026 */     // No operand predicates
     /* 425026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425028 */     // (AArch64duplane16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPv8i16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 425028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 425031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425033 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425035 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 425038 */     GIR_RootConstrainSelectedInstOperands,
     /* 425039 */     // GIR_Coverage, 1923,
     /* 425039 */     GIR_EraseRootFromParent_Done,
     /* 425040 */   // Label 8307: @425040
     /* 425040 */   GIM_Try, /*On fail goto*//*Label 8308*/ GIMT_Encode4(425075), // Rule ID 5682 //
     /* 425045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 425053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425057 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 425061 */     // MIs[1] Operand 1
     /* 425061 */     // No operand predicates
     /* 425061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425063 */     // (AArch64duplane16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (DUPv8i16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)
     /* 425063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 425066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425068 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425070 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 425073 */     GIR_RootConstrainSelectedInstOperands,
     /* 425074 */     // GIR_Coverage, 5682,
     /* 425074 */     GIR_EraseRootFromParent_Done,
     /* 425075 */   // Label 8308: @425075
     /* 425075 */   GIM_Reject,
     /* 425076 */ // Label 8305: @425076
     /* 425076 */ GIM_Reject,
     /* 425077 */ // Label 8301: @425077
     /* 425077 */ GIM_Reject,
     /* 425078 */ // Label 127: @425078
     /* 425078 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(9), /*)*//*default:*//*Label 8311*/ GIMT_Encode4(425332),
     /* 425089 */ /*GILLT_v2s32*//*Label 8309*/ GIMT_Encode4(425105), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 425101 */ /*GILLT_v4s32*//*Label 8310*/ GIMT_Encode4(425191),
     /* 425105 */ // Label 8309: @425105
     /* 425105 */ GIM_Try, /*On fail goto*//*Label 8312*/ GIMT_Encode4(425190),
     /* 425110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 425113 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 425116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425120 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425124 */   GIM_Try, /*On fail goto*//*Label 8313*/ GIMT_Encode4(425158), // Rule ID 1920 //
     /* 425129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 425136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425140 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 425144 */     // MIs[1] Operand 1
     /* 425144 */     // No operand predicates
     /* 425144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425146 */     // (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPv2i32lane:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 425146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 425149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425151 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425153 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 425156 */     GIR_RootConstrainSelectedInstOperands,
     /* 425157 */     // GIR_Coverage, 1920,
     /* 425157 */     GIR_EraseRootFromParent_Done,
     /* 425158 */   // Label 8313: @425158
     /* 425158 */   GIM_Try, /*On fail goto*//*Label 8314*/ GIMT_Encode4(425189), // Rule ID 5683 //
     /* 425163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 425167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425171 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 425175 */     // MIs[1] Operand 1
     /* 425175 */     // No operand predicates
     /* 425175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425177 */     // (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (DUPv2i32lane:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)
     /* 425177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 425180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425182 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425184 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 425187 */     GIR_RootConstrainSelectedInstOperands,
     /* 425188 */     // GIR_Coverage, 5683,
     /* 425188 */     GIR_EraseRootFromParent_Done,
     /* 425189 */   // Label 8314: @425189
     /* 425189 */   GIM_Reject,
     /* 425190 */ // Label 8312: @425190
     /* 425190 */ GIM_Reject,
     /* 425191 */ // Label 8310: @425191
     /* 425191 */ GIM_Try, /*On fail goto*//*Label 8315*/ GIMT_Encode4(425331),
     /* 425196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 425199 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 425202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425206 */   GIM_Try, /*On fail goto*//*Label 8316*/ GIMT_Encode4(425257), // Rule ID 6493 //
     /* 425211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 425219 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 425222 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 425226 */     // MIs[1] Rn
     /* 425226 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 425230 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 425235 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 425239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425241 */     // (AArch64duplane32:{ *:[v4i32] } (ld:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 425241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 425244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 425246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 425250 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 425255 */     GIR_RootConstrainSelectedInstOperands,
     /* 425256 */     // GIR_Coverage, 6493,
     /* 425256 */     GIR_EraseRootFromParent_Done,
     /* 425257 */   // Label 8316: @425257
     /* 425257 */   GIM_Try, /*On fail goto*//*Label 8317*/ GIMT_Encode4(425295), // Rule ID 1921 //
     /* 425262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 425273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425277 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 425281 */     // MIs[1] Operand 1
     /* 425281 */     // No operand predicates
     /* 425281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425283 */     // (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPv4i32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 425283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 425286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425288 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425290 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 425293 */     GIR_RootConstrainSelectedInstOperands,
     /* 425294 */     // GIR_Coverage, 1921,
     /* 425294 */     GIR_EraseRootFromParent_Done,
     /* 425295 */   // Label 8317: @425295
     /* 425295 */   GIM_Try, /*On fail goto*//*Label 8318*/ GIMT_Encode4(425330), // Rule ID 5684 //
     /* 425300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 425308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425312 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 425316 */     // MIs[1] Operand 1
     /* 425316 */     // No operand predicates
     /* 425316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425318 */     // (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (DUPv4i32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)
     /* 425318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 425321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425323 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 425328 */     GIR_RootConstrainSelectedInstOperands,
     /* 425329 */     // GIR_Coverage, 5684,
     /* 425329 */     GIR_EraseRootFromParent_Done,
     /* 425330 */   // Label 8318: @425330
     /* 425330 */   GIM_Reject,
     /* 425331 */ // Label 8315: @425331
     /* 425331 */ GIM_Reject,
     /* 425332 */ // Label 8311: @425332
     /* 425332 */ GIM_Reject,
     /* 425333 */ // Label 128: @425333
     /* 425333 */ GIM_Try, /*On fail goto*//*Label 8319*/ GIMT_Encode4(425478),
     /* 425338 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 425341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 425344 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 425347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425351 */   GIM_Try, /*On fail goto*//*Label 8320*/ GIMT_Encode4(425402), // Rule ID 6494 //
     /* 425356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 425364 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 425367 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 425371 */     // MIs[1] Rn
     /* 425371 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 425375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 425380 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 425384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425386 */     // (AArch64duplane64:{ *:[v2i64] } (ld:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 425386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 425389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 425391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 425395 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 425400 */     GIR_RootConstrainSelectedInstOperands,
     /* 425401 */     // GIR_Coverage, 6494,
     /* 425401 */     GIR_EraseRootFromParent_Done,
     /* 425402 */   // Label 8320: @425402
     /* 425402 */   GIM_Try, /*On fail goto*//*Label 8321*/ GIMT_Encode4(425477),
     /* 425407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425411 */     GIM_Try, /*On fail goto*//*Label 8322*/ GIMT_Encode4(425445), // Rule ID 1919 //
     /* 425416 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425419 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 425423 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425427 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 425431 */       // MIs[1] Operand 1
     /* 425431 */       // No operand predicates
     /* 425431 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425433 */       // (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (DUPv2i64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 425433 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 425436 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425438 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425440 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 425443 */       GIR_RootConstrainSelectedInstOperands,
     /* 425444 */       // GIR_Coverage, 1919,
     /* 425444 */       GIR_EraseRootFromParent_Done,
     /* 425445 */     // Label 8322: @425445
     /* 425445 */     GIM_Try, /*On fail goto*//*Label 8323*/ GIMT_Encode4(425476), // Rule ID 5685 //
     /* 425450 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 425454 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425458 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 425462 */       // MIs[1] Operand 1
     /* 425462 */       // No operand predicates
     /* 425462 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425464 */       // (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (DUPv2i64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)
     /* 425464 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 425467 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425469 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425471 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 425474 */       GIR_RootConstrainSelectedInstOperands,
     /* 425475 */       // GIR_Coverage, 5685,
     /* 425475 */       GIR_EraseRootFromParent_Done,
     /* 425476 */     // Label 8323: @425476
     /* 425476 */     GIM_Reject,
     /* 425477 */   // Label 8321: @425477
     /* 425477 */   GIM_Reject,
     /* 425478 */ // Label 8319: @425478
     /* 425478 */ GIM_Reject,
     /* 425479 */ // Label 129: @425479
     /* 425479 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(12), /*)*//*default:*//*Label 8326*/ GIMT_Encode4(425657),
     /* 425490 */ /*GILLT_v8s8*//*Label 8324*/ GIMT_Encode4(425502), GIMT_Encode4(0),
     /* 425498 */ /*GILLT_v16s8*//*Label 8325*/ GIMT_Encode4(425551),
     /* 425502 */ // Label 8324: @425502
     /* 425502 */ GIM_Try, /*On fail goto*//*Label 8327*/ GIMT_Encode4(425550), // Rule ID 1924 //
     /* 425507 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 425513 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 425516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425520 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425524 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 425528 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425532 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 425536 */   // MIs[1] Operand 1
     /* 425536 */   // No operand predicates
     /* 425536 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425538 */   // (AArch64duplane8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (DUPv8i8lane:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 425538 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i8lane),
     /* 425541 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425543 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425545 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 425548 */   GIR_RootConstrainSelectedInstOperands,
     /* 425549 */   // GIR_Coverage, 1924,
     /* 425549 */   GIR_EraseRootFromParent_Done,
     /* 425550 */ // Label 8327: @425550
     /* 425550 */ GIM_Reject,
     /* 425551 */ // Label 8325: @425551
     /* 425551 */ GIM_Try, /*On fail goto*//*Label 8328*/ GIMT_Encode4(425656),
     /* 425556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 425559 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 425562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425566 */   GIM_Try, /*On fail goto*//*Label 8329*/ GIMT_Encode4(425617), // Rule ID 6489 //
     /* 425571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 425579 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 425582 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 425586 */     // MIs[1] Rn
     /* 425586 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 425590 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 425595 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 425599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425601 */     // (AArch64duplane8:{ *:[v16i8] } (ld:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 425601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 425604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 425606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 425610 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 425615 */     GIR_RootConstrainSelectedInstOperands,
     /* 425616 */     // GIR_Coverage, 6489,
     /* 425616 */     GIR_EraseRootFromParent_Done,
     /* 425617 */   // Label 8329: @425617
     /* 425617 */   GIM_Try, /*On fail goto*//*Label 8330*/ GIMT_Encode4(425655), // Rule ID 1925 //
     /* 425622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 425633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425637 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 425641 */     // MIs[1] Operand 1
     /* 425641 */     // No operand predicates
     /* 425641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425643 */     // (AArch64duplane8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (DUPv16i8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 425643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv16i8lane),
     /* 425646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425648 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425650 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 425653 */     GIR_RootConstrainSelectedInstOperands,
     /* 425654 */     // GIR_Coverage, 1925,
     /* 425654 */     GIR_EraseRootFromParent_Done,
     /* 425655 */   // Label 8330: @425655
     /* 425655 */   GIM_Reject,
     /* 425656 */ // Label 8328: @425656
     /* 425656 */ GIM_Reject,
     /* 425657 */ // Label 8326: @425657
     /* 425657 */ GIM_Reject,
     /* 425658 */ // Label 130: @425658
     /* 425658 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 8340*/ GIMT_Encode4(427307),
     /* 425669 */ /*GILLT_s64*//*Label 8331*/ GIMT_Encode4(425753), GIMT_Encode4(0),
     /* 425677 */ /*GILLT_v2s32*//*Label 8332*/ GIMT_Encode4(426074),
     /* 425681 */ /*GILLT_v2s64*//*Label 8333*/ GIMT_Encode4(426395),
     /* 425685 */ /*GILLT_v4s16*//*Label 8334*/ GIMT_Encode4(426478),
     /* 425689 */ /*GILLT_v4s32*//*Label 8335*/ GIMT_Encode4(426799),
     /* 425693 */ /*GILLT_v8s8*//*Label 8336*/ GIMT_Encode4(426882),
     /* 425697 */ /*GILLT_v8s16*//*Label 8337*/ GIMT_Encode4(427091),
     /* 425701 */ /*GILLT_v16s8*//*Label 8338*/ GIMT_Encode4(427174), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 425749 */ /*GILLT_nxv16s8*//*Label 8339*/ GIMT_Encode4(427260),
     /* 425753 */ // Label 8331: @425753
     /* 425753 */ GIM_Try, /*On fail goto*//*Label 8341*/ GIMT_Encode4(426073),
     /* 425758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 425761 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 425764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425768 */   GIM_Try, /*On fail goto*//*Label 8342*/ GIMT_Encode4(425883), // Rule ID 5500 //
     /* 425773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 425781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 425785 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425790 */     // MIs[1] Operand 2
     /* 425790 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 425801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 425805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 425809 */     // MIs[2] Rn
     /* 425809 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 425814 */     // MIs[2] Operand 2
     /* 425814 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(1),
     /* 425825 */     // MIs[0] imm
     /* 425825 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 425829 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425833 */     // MIs[3] Operand 1
     /* 425833 */     // No operand predicates
     /* 425833 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 425835 */     // (AArch64ext:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 425835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 425838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 425842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 425847 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 425851 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 425855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 425858 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 425860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 425863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 425865 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 425872 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425877 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425882 */     // GIR_Coverage, 5500,
     /* 425882 */     GIR_EraseRootFromParent_Done,
     /* 425883 */   // Label 8342: @425883
     /* 425883 */   GIM_Try, /*On fail goto*//*Label 8343*/ GIMT_Encode4(425998), // Rule ID 5505 //
     /* 425888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 425896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 425900 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425905 */     // MIs[1] Operand 2
     /* 425905 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 425916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 425920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 425924 */     // MIs[2] Rn
     /* 425924 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 425929 */     // MIs[2] Operand 2
     /* 425929 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(1),
     /* 425940 */     // MIs[0] imm
     /* 425940 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 425944 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425948 */     // MIs[3] Operand 1
     /* 425948 */     // No operand predicates
     /* 425948 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 425950 */     // (AArch64ext:{ *:[v1f64] } (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 425950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 425953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 425957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 425962 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 425966 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 425970 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 425973 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 425975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 425978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 425980 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 425987 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425992 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425997 */     // GIR_Coverage, 5505,
     /* 425997 */     GIR_EraseRootFromParent_Done,
     /* 425998 */   // Label 8343: @425998
     /* 425998 */   GIM_Try, /*On fail goto*//*Label 8344*/ GIMT_Encode4(426035), // Rule ID 5497 //
     /* 426003 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426011 */     // MIs[0] imm
     /* 426011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 426015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 426019 */     // MIs[1] Operand 1
     /* 426019 */     // No operand predicates
     /* 426019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426021 */     // (AArch64ext:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 426021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 426024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426026 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 426030 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 426033 */     GIR_RootConstrainSelectedInstOperands,
     /* 426034 */     // GIR_Coverage, 5497,
     /* 426034 */     GIR_EraseRootFromParent_Done,
     /* 426035 */   // Label 8344: @426035
     /* 426035 */   GIM_Try, /*On fail goto*//*Label 8345*/ GIMT_Encode4(426072), // Rule ID 5502 //
     /* 426040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426048 */     // MIs[0] imm
     /* 426048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 426052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 426056 */     // MIs[1] Operand 1
     /* 426056 */     // No operand predicates
     /* 426056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426058 */     // (AArch64ext:{ *:[v1f64] } V64:{ *:[v1f64] }:$Rn, V64:{ *:[v1f64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v1f64] } V64:{ *:[v1f64] }:$Rn, V64:{ *:[v1f64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 426058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 426061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426063 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 426067 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 426070 */     GIR_RootConstrainSelectedInstOperands,
     /* 426071 */     // GIR_Coverage, 5502,
     /* 426071 */     GIR_EraseRootFromParent_Done,
     /* 426072 */   // Label 8345: @426072
     /* 426072 */   GIM_Reject,
     /* 426073 */ // Label 8341: @426073
     /* 426073 */ GIM_Reject,
     /* 426074 */ // Label 8332: @426074
     /* 426074 */ GIM_Try, /*On fail goto*//*Label 8346*/ GIMT_Encode4(426394),
     /* 426079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 426082 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 426085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426089 */   GIM_Try, /*On fail goto*//*Label 8347*/ GIMT_Encode4(426204), // Rule ID 5490 //
     /* 426094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 426102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 426106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426111 */     // MIs[1] Operand 2
     /* 426111 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 426122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 426126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 426130 */     // MIs[2] Rn
     /* 426130 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 426135 */     // MIs[2] Operand 2
     /* 426135 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 426146 */     // MIs[0] imm
     /* 426146 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 426150 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 426154 */     // MIs[3] Operand 1
     /* 426154 */     // No operand predicates
     /* 426154 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 426156 */     // (AArch64ext:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 426156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 426159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 426163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 426168 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 426172 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 426176 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 426179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 426181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 426184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 426186 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 426193 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426198 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426203 */     // GIR_Coverage, 5490,
     /* 426203 */     GIR_EraseRootFromParent_Done,
     /* 426204 */   // Label 8347: @426204
     /* 426204 */   GIM_Try, /*On fail goto*//*Label 8348*/ GIMT_Encode4(426319), // Rule ID 5495 //
     /* 426209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 426217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 426221 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426226 */     // MIs[1] Operand 2
     /* 426226 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 426237 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 426241 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 426245 */     // MIs[2] Rn
     /* 426245 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 426250 */     // MIs[2] Operand 2
     /* 426250 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 426261 */     // MIs[0] imm
     /* 426261 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 426265 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 426269 */     // MIs[3] Operand 1
     /* 426269 */     // No operand predicates
     /* 426269 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 426271 */     // (AArch64ext:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 426271 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 426274 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 426278 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 426283 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 426287 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 426291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 426294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 426296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 426299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 426301 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 426308 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426313 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426318 */     // GIR_Coverage, 5495,
     /* 426318 */     GIR_EraseRootFromParent_Done,
     /* 426319 */   // Label 8348: @426319
     /* 426319 */   GIM_Try, /*On fail goto*//*Label 8349*/ GIMT_Encode4(426356), // Rule ID 5487 //
     /* 426324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426332 */     // MIs[0] imm
     /* 426332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 426336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 426340 */     // MIs[1] Operand 1
     /* 426340 */     // No operand predicates
     /* 426340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426342 */     // (AArch64ext:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 426342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 426345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426347 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 426351 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 426354 */     GIR_RootConstrainSelectedInstOperands,
     /* 426355 */     // GIR_Coverage, 5487,
     /* 426355 */     GIR_EraseRootFromParent_Done,
     /* 426356 */   // Label 8349: @426356
     /* 426356 */   GIM_Try, /*On fail goto*//*Label 8350*/ GIMT_Encode4(426393), // Rule ID 5492 //
     /* 426361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426369 */     // MIs[0] imm
     /* 426369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 426373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 426377 */     // MIs[1] Operand 1
     /* 426377 */     // No operand predicates
     /* 426377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426379 */     // (AArch64ext:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 426379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 426382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426384 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 426388 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 426391 */     GIR_RootConstrainSelectedInstOperands,
     /* 426392 */     // GIR_Coverage, 5492,
     /* 426392 */     GIR_EraseRootFromParent_Done,
     /* 426393 */   // Label 8350: @426393
     /* 426393 */   GIM_Reject,
     /* 426394 */ // Label 8346: @426394
     /* 426394 */ GIM_Reject,
     /* 426395 */ // Label 8333: @426395
     /* 426395 */ GIM_Try, /*On fail goto*//*Label 8351*/ GIMT_Encode4(426477),
     /* 426400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 426403 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 426406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426410 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426414 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426418 */   GIM_Try, /*On fail goto*//*Label 8352*/ GIMT_Encode4(426447), // Rule ID 5498 //
     /* 426423 */     // MIs[0] imm
     /* 426423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 426427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 426431 */     // MIs[1] Operand 1
     /* 426431 */     // No operand predicates
     /* 426431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426433 */     // (AArch64ext:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 426433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 426436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426438 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 426442 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 426445 */     GIR_RootConstrainSelectedInstOperands,
     /* 426446 */     // GIR_Coverage, 5498,
     /* 426446 */     GIR_EraseRootFromParent_Done,
     /* 426447 */   // Label 8352: @426447
     /* 426447 */   GIM_Try, /*On fail goto*//*Label 8353*/ GIMT_Encode4(426476), // Rule ID 5503 //
     /* 426452 */     // MIs[0] imm
     /* 426452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 426456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 426460 */     // MIs[1] Operand 1
     /* 426460 */     // No operand predicates
     /* 426460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426462 */     // (AArch64ext:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 426462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 426465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426467 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 426471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 426474 */     GIR_RootConstrainSelectedInstOperands,
     /* 426475 */     // GIR_Coverage, 5503,
     /* 426475 */     GIR_EraseRootFromParent_Done,
     /* 426476 */   // Label 8353: @426476
     /* 426476 */   GIM_Reject,
     /* 426477 */ // Label 8351: @426477
     /* 426477 */ GIM_Reject,
     /* 426478 */ // Label 8334: @426478
     /* 426478 */ GIM_Try, /*On fail goto*//*Label 8354*/ GIMT_Encode4(426798),
     /* 426483 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 426486 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 426489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426493 */   GIM_Try, /*On fail goto*//*Label 8355*/ GIMT_Encode4(426608), // Rule ID 5480 //
     /* 426498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 426506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 426510 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426515 */     // MIs[1] Operand 2
     /* 426515 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 426526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 426530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 426534 */     // MIs[2] Rn
     /* 426534 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 426539 */     // MIs[2] Operand 2
     /* 426539 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 426550 */     // MIs[0] imm
     /* 426550 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 426554 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 426558 */     // MIs[3] Operand 1
     /* 426558 */     // No operand predicates
     /* 426558 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 426560 */     // (AArch64ext:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 426560 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 426563 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 426567 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 426572 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 426576 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 426580 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 426583 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 426585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 426588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 426590 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 426597 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426602 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426607 */     // GIR_Coverage, 5480,
     /* 426607 */     GIR_EraseRootFromParent_Done,
     /* 426608 */   // Label 8355: @426608
     /* 426608 */   GIM_Try, /*On fail goto*//*Label 8356*/ GIMT_Encode4(426723), // Rule ID 5485 //
     /* 426613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 426621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 426625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426630 */     // MIs[1] Operand 2
     /* 426630 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 426641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 426645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 426649 */     // MIs[2] Rn
     /* 426649 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 426654 */     // MIs[2] Operand 2
     /* 426654 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 426665 */     // MIs[0] imm
     /* 426665 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 426669 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 426673 */     // MIs[3] Operand 1
     /* 426673 */     // No operand predicates
     /* 426673 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 426675 */     // (AArch64ext:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 426675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 426678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 426682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 426687 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 426691 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 426695 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 426698 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 426700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 426703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 426705 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 426712 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426717 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426722 */     // GIR_Coverage, 5485,
     /* 426722 */     GIR_EraseRootFromParent_Done,
     /* 426723 */   // Label 8356: @426723
     /* 426723 */   GIM_Try, /*On fail goto*//*Label 8357*/ GIMT_Encode4(426760), // Rule ID 5477 //
     /* 426728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426736 */     // MIs[0] imm
     /* 426736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 426740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 426744 */     // MIs[1] Operand 1
     /* 426744 */     // No operand predicates
     /* 426744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426746 */     // (AArch64ext:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 426746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 426749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426751 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 426755 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 426758 */     GIR_RootConstrainSelectedInstOperands,
     /* 426759 */     // GIR_Coverage, 5477,
     /* 426759 */     GIR_EraseRootFromParent_Done,
     /* 426760 */   // Label 8357: @426760
     /* 426760 */   GIM_Try, /*On fail goto*//*Label 8358*/ GIMT_Encode4(426797), // Rule ID 5482 //
     /* 426765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426773 */     // MIs[0] imm
     /* 426773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 426777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 426781 */     // MIs[1] Operand 1
     /* 426781 */     // No operand predicates
     /* 426781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426783 */     // (AArch64ext:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 426783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 426786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426788 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 426792 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 426795 */     GIR_RootConstrainSelectedInstOperands,
     /* 426796 */     // GIR_Coverage, 5482,
     /* 426796 */     GIR_EraseRootFromParent_Done,
     /* 426797 */   // Label 8358: @426797
     /* 426797 */   GIM_Reject,
     /* 426798 */ // Label 8354: @426798
     /* 426798 */ GIM_Reject,
     /* 426799 */ // Label 8335: @426799
     /* 426799 */ GIM_Try, /*On fail goto*//*Label 8359*/ GIMT_Encode4(426881),
     /* 426804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 426807 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 426810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426814 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426818 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426822 */   GIM_Try, /*On fail goto*//*Label 8360*/ GIMT_Encode4(426851), // Rule ID 5488 //
     /* 426827 */     // MIs[0] imm
     /* 426827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 426831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 426835 */     // MIs[1] Operand 1
     /* 426835 */     // No operand predicates
     /* 426835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426837 */     // (AArch64ext:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 426837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 426840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426842 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 426846 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 426849 */     GIR_RootConstrainSelectedInstOperands,
     /* 426850 */     // GIR_Coverage, 5488,
     /* 426850 */     GIR_EraseRootFromParent_Done,
     /* 426851 */   // Label 8360: @426851
     /* 426851 */   GIM_Try, /*On fail goto*//*Label 8361*/ GIMT_Encode4(426880), // Rule ID 5493 //
     /* 426856 */     // MIs[0] imm
     /* 426856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 426860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 426864 */     // MIs[1] Operand 1
     /* 426864 */     // No operand predicates
     /* 426864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426866 */     // (AArch64ext:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 426866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 426869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426871 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 426875 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 426878 */     GIR_RootConstrainSelectedInstOperands,
     /* 426879 */     // GIR_Coverage, 5493,
     /* 426879 */     GIR_EraseRootFromParent_Done,
     /* 426880 */   // Label 8361: @426880
     /* 426880 */   GIM_Reject,
     /* 426881 */ // Label 8359: @426881
     /* 426881 */ GIM_Reject,
     /* 426882 */ // Label 8336: @426882
     /* 426882 */ GIM_Try, /*On fail goto*//*Label 8362*/ GIMT_Encode4(427090),
     /* 426887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 426890 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 426893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426897 */   GIM_Try, /*On fail goto*//*Label 8363*/ GIMT_Encode4(427012), // Rule ID 5475 //
     /* 426902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 426910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 426914 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426919 */     // MIs[1] Operand 2
     /* 426919 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 426930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 426934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 426938 */     // MIs[2] Rn
     /* 426938 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 426943 */     // MIs[2] Operand 2
     /* 426943 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 426954 */     // MIs[0] imm
     /* 426954 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 426958 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 426962 */     // MIs[3] Operand 1
     /* 426962 */     // No operand predicates
     /* 426962 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 426964 */     // (AArch64ext:{ *:[v8i8] } (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (EXTv16i8:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 426964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 426967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 426971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 426976 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 426980 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 426984 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 426987 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 426989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 426992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 426994 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 427001 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427006 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427011 */     // GIR_Coverage, 5475,
     /* 427011 */     GIR_EraseRootFromParent_Done,
     /* 427012 */   // Label 8363: @427012
     /* 427012 */   GIM_Try, /*On fail goto*//*Label 8364*/ GIMT_Encode4(427052), // Rule ID 1868 //
     /* 427017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427028 */     // MIs[0] imm
     /* 427028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 427032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 427036 */     // MIs[1] Operand 1
     /* 427036 */     // No operand predicates
     /* 427036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427038 */     // (AArch64ext:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 427038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 427041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427043 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 427045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 427047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 427050 */     GIR_RootConstrainSelectedInstOperands,
     /* 427051 */     // GIR_Coverage, 1868,
     /* 427051 */     GIR_EraseRootFromParent_Done,
     /* 427052 */   // Label 8364: @427052
     /* 427052 */   GIM_Try, /*On fail goto*//*Label 8365*/ GIMT_Encode4(427089), // Rule ID 5472 //
     /* 427057 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427065 */     // MIs[0] imm
     /* 427065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 427069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 427073 */     // MIs[1] Operand 1
     /* 427073 */     // No operand predicates
     /* 427073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427075 */     // (AArch64ext:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 427075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 427078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427080 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 427082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 427084 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 427087 */     GIR_RootConstrainSelectedInstOperands,
     /* 427088 */     // GIR_Coverage, 5472,
     /* 427088 */     GIR_EraseRootFromParent_Done,
     /* 427089 */   // Label 8365: @427089
     /* 427089 */   GIM_Reject,
     /* 427090 */ // Label 8362: @427090
     /* 427090 */ GIM_Reject,
     /* 427091 */ // Label 8337: @427091
     /* 427091 */ GIM_Try, /*On fail goto*//*Label 8366*/ GIMT_Encode4(427173),
     /* 427096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 427099 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 427102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427106 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427110 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427114 */   GIM_Try, /*On fail goto*//*Label 8367*/ GIMT_Encode4(427143), // Rule ID 5478 //
     /* 427119 */     // MIs[0] imm
     /* 427119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 427123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 427127 */     // MIs[1] Operand 1
     /* 427127 */     // No operand predicates
     /* 427127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427129 */     // (AArch64ext:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 427129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 427132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427134 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 427136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 427138 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 427141 */     GIR_RootConstrainSelectedInstOperands,
     /* 427142 */     // GIR_Coverage, 5478,
     /* 427142 */     GIR_EraseRootFromParent_Done,
     /* 427143 */   // Label 8367: @427143
     /* 427143 */   GIM_Try, /*On fail goto*//*Label 8368*/ GIMT_Encode4(427172), // Rule ID 5483 //
     /* 427148 */     // MIs[0] imm
     /* 427148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 427152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 427156 */     // MIs[1] Operand 1
     /* 427156 */     // No operand predicates
     /* 427156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427158 */     // (AArch64ext:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 427158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 427161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427163 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 427165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 427167 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 427170 */     GIR_RootConstrainSelectedInstOperands,
     /* 427171 */     // GIR_Coverage, 5483,
     /* 427171 */     GIR_EraseRootFromParent_Done,
     /* 427172 */   // Label 8368: @427172
     /* 427172 */   GIM_Reject,
     /* 427173 */ // Label 8366: @427173
     /* 427173 */ GIM_Reject,
     /* 427174 */ // Label 8338: @427174
     /* 427174 */ GIM_Try, /*On fail goto*//*Label 8369*/ GIMT_Encode4(427259),
     /* 427179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 427182 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 427185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427189 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427193 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427197 */   GIM_Try, /*On fail goto*//*Label 8370*/ GIMT_Encode4(427229), // Rule ID 1869 //
     /* 427202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427205 */     // MIs[0] imm
     /* 427205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 427209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 427213 */     // MIs[1] Operand 1
     /* 427213 */     // No operand predicates
     /* 427213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427215 */     // (AArch64ext:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 427215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 427218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427220 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 427222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 427224 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 427227 */     GIR_RootConstrainSelectedInstOperands,
     /* 427228 */     // GIR_Coverage, 1869,
     /* 427228 */     GIR_EraseRootFromParent_Done,
     /* 427229 */   // Label 8370: @427229
     /* 427229 */   GIM_Try, /*On fail goto*//*Label 8371*/ GIMT_Encode4(427258), // Rule ID 5473 //
     /* 427234 */     // MIs[0] imm
     /* 427234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 427238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 427242 */     // MIs[1] Operand 1
     /* 427242 */     // No operand predicates
     /* 427242 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427244 */     // (AArch64ext:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 427244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 427247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427249 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 427251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 427253 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 427256 */     GIR_RootConstrainSelectedInstOperands,
     /* 427257 */     // GIR_Coverage, 5473,
     /* 427257 */     GIR_EraseRootFromParent_Done,
     /* 427258 */   // Label 8371: @427258
     /* 427258 */   GIM_Reject,
     /* 427259 */ // Label 8369: @427259
     /* 427259 */ GIM_Reject,
     /* 427260 */ // Label 8339: @427260
     /* 427260 */ GIM_Try, /*On fail goto*//*Label 8372*/ GIMT_Encode4(427306), // Rule ID 2729 //
     /* 427265 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 427268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 427271 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 427274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 427278 */   // MIs[0] Op3
     /* 427278 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 427282 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 427286 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255),
     /* 427290 */   // MIs[1] Operand 1
     /* 427290 */   // No operand predicates
     /* 427290 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427292 */   // (AArch64ext:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$Op3)  =>  (EXT_ZZI:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$Op3)
     /* 427292 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXT_ZZI),
     /* 427295 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 427297 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 427299 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /* 427301 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // Op3
     /* 427304 */   GIR_RootConstrainSelectedInstOperands,
     /* 427305 */   // GIR_Coverage, 2729,
     /* 427305 */   GIR_EraseRootFromParent_Done,
     /* 427306 */ // Label 8372: @427306
     /* 427306 */ GIM_Reject,
     /* 427307 */ // Label 8340: @427307
     /* 427307 */ GIM_Reject,
     /* 427308 */ // Label 131: @427308
     /* 427308 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8380*/ GIMT_Encode4(427866),
     /* 427319 */ /*GILLT_s32*//*Label 8373*/ GIMT_Encode4(427355),
     /* 427323 */ /*GILLT_s64*//*Label 8374*/ GIMT_Encode4(427393), GIMT_Encode4(0),
     /* 427331 */ /*GILLT_v2s32*//*Label 8375*/ GIMT_Encode4(427491),
     /* 427335 */ /*GILLT_v2s64*//*Label 8376*/ GIMT_Encode4(427566),
     /* 427339 */ /*GILLT_v4s16*//*Label 8377*/ GIMT_Encode4(427641),
     /* 427343 */ /*GILLT_v4s32*//*Label 8378*/ GIMT_Encode4(427716), GIMT_Encode4(0),
     /* 427351 */ /*GILLT_v8s16*//*Label 8379*/ GIMT_Encode4(427791),
     /* 427355 */ // Label 8373: @427355
     /* 427355 */ GIM_Try, /*On fail goto*//*Label 8381*/ GIMT_Encode4(427392), // Rule ID 1622 //
     /* 427360 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 427366 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 427369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 427373 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 427377 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 427381 */   // (AArch64fcmeq:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMEQ32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 427381 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ32),
     /* 427386 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 427390 */   GIR_RootConstrainSelectedInstOperands,
     /* 427391 */   // GIR_Coverage, 1622,
     /* 427391 */   GIR_Done,
     /* 427392 */ // Label 8381: @427392
     /* 427392 */ GIM_Reject,
     /* 427393 */ // Label 8374: @427393
     /* 427393 */ GIM_Try, /*On fail goto*//*Label 8382*/ GIMT_Encode4(427490),
     /* 427398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 427401 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 427404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427412 */   GIM_Try, /*On fail goto*//*Label 8383*/ GIMT_Encode4(427443), // Rule ID 2509 //
     /* 427417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 427424 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427430 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427434 */     // (AArch64fcmeq:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (FCMEQv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 427434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv1i64rz),
     /* 427437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427439 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 427441 */     GIR_RootConstrainSelectedInstOperands,
     /* 427442 */     // GIR_Coverage, 2509,
     /* 427442 */     GIR_EraseRootFromParent_Done,
     /* 427443 */   // Label 8383: @427443
     /* 427443 */   GIM_Try, /*On fail goto*//*Label 8384*/ GIMT_Encode4(427466), // Rule ID 1621 //
     /* 427448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427455 */     // (AArch64fcmeq:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMEQ64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 427455 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ64),
     /* 427460 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 427464 */     GIR_RootConstrainSelectedInstOperands,
     /* 427465 */     // GIR_Coverage, 1621,
     /* 427465 */     GIR_Done,
     /* 427466 */   // Label 8384: @427466
     /* 427466 */   GIM_Try, /*On fail goto*//*Label 8385*/ GIMT_Encode4(427489), // Rule ID 5252 //
     /* 427471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427478 */     // (AArch64fcmeq:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMEQ64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 427478 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ64),
     /* 427483 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 427487 */     GIR_RootConstrainSelectedInstOperands,
     /* 427488 */     // GIR_Coverage, 5252,
     /* 427488 */     GIR_Done,
     /* 427489 */   // Label 8385: @427489
     /* 427489 */   GIM_Reject,
     /* 427490 */ // Label 8382: @427490
     /* 427490 */ GIM_Reject,
     /* 427491 */ // Label 8375: @427491
     /* 427491 */ GIM_Try, /*On fail goto*//*Label 8386*/ GIMT_Encode4(427565),
     /* 427496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 427499 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 427502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427506 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427510 */   GIM_Try, /*On fail goto*//*Label 8387*/ GIMT_Encode4(427541), // Rule ID 773 //
     /* 427515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 427522 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427528 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427530 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427532 */     // (AArch64fcmeq:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (FCMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 427532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2i32rz),
     /* 427535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427537 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 427539 */     GIR_RootConstrainSelectedInstOperands,
     /* 427540 */     // GIR_Coverage, 773,
     /* 427540 */     GIR_EraseRootFromParent_Done,
     /* 427541 */   // Label 8387: @427541
     /* 427541 */   GIM_Try, /*On fail goto*//*Label 8388*/ GIMT_Encode4(427564), // Rule ID 1210 //
     /* 427546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427553 */     // (AArch64fcmeq:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMEQv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 427553 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2f32),
     /* 427558 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 427562 */     GIR_RootConstrainSelectedInstOperands,
     /* 427563 */     // GIR_Coverage, 1210,
     /* 427563 */     GIR_Done,
     /* 427564 */   // Label 8388: @427564
     /* 427564 */   GIM_Reject,
     /* 427565 */ // Label 8386: @427565
     /* 427565 */ GIM_Reject,
     /* 427566 */ // Label 8376: @427566
     /* 427566 */ GIM_Try, /*On fail goto*//*Label 8389*/ GIMT_Encode4(427640),
     /* 427571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 427574 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 427577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427581 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427585 */   GIM_Try, /*On fail goto*//*Label 8390*/ GIMT_Encode4(427616), // Rule ID 775 //
     /* 427590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 427597 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427603 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427607 */     // (AArch64fcmeq:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, immAllZerosV:{ *:[v2f64] })  =>  (FCMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 427607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2i64rz),
     /* 427610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427612 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 427614 */     GIR_RootConstrainSelectedInstOperands,
     /* 427615 */     // GIR_Coverage, 775,
     /* 427615 */     GIR_EraseRootFromParent_Done,
     /* 427616 */   // Label 8390: @427616
     /* 427616 */   GIM_Try, /*On fail goto*//*Label 8391*/ GIMT_Encode4(427639), // Rule ID 1212 //
     /* 427621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427628 */     // (AArch64fcmeq:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMEQv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 427628 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2f64),
     /* 427633 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 427637 */     GIR_RootConstrainSelectedInstOperands,
     /* 427638 */     // GIR_Coverage, 1212,
     /* 427638 */     GIR_Done,
     /* 427639 */   // Label 8391: @427639
     /* 427639 */   GIM_Reject,
     /* 427640 */ // Label 8389: @427640
     /* 427640 */ GIM_Reject,
     /* 427641 */ // Label 8377: @427641
     /* 427641 */ GIM_Try, /*On fail goto*//*Label 8392*/ GIMT_Encode4(427715),
     /* 427646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 427649 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 427652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427656 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427660 */   GIM_Try, /*On fail goto*//*Label 8393*/ GIMT_Encode4(427691), // Rule ID 771 //
     /* 427665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 427668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 427672 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427678 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427682 */     // (AArch64fcmeq:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (FCMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 427682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4i16rz),
     /* 427685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427687 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 427689 */     GIR_RootConstrainSelectedInstOperands,
     /* 427690 */     // GIR_Coverage, 771,
     /* 427690 */     GIR_EraseRootFromParent_Done,
     /* 427691 */   // Label 8393: @427691
     /* 427691 */   GIM_Try, /*On fail goto*//*Label 8394*/ GIMT_Encode4(427714), // Rule ID 1208 //
     /* 427696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 427699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427703 */     // (AArch64fcmeq:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMEQv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 427703 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f16),
     /* 427708 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 427712 */     GIR_RootConstrainSelectedInstOperands,
     /* 427713 */     // GIR_Coverage, 1208,
     /* 427713 */     GIR_Done,
     /* 427714 */   // Label 8394: @427714
     /* 427714 */   GIM_Reject,
     /* 427715 */ // Label 8392: @427715
     /* 427715 */ GIM_Reject,
     /* 427716 */ // Label 8378: @427716
     /* 427716 */ GIM_Try, /*On fail goto*//*Label 8395*/ GIMT_Encode4(427790),
     /* 427721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 427724 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 427727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427731 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427735 */   GIM_Try, /*On fail goto*//*Label 8396*/ GIMT_Encode4(427766), // Rule ID 774 //
     /* 427740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 427747 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427753 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427757 */     // (AArch64fcmeq:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, immAllZerosV:{ *:[v4f32] })  =>  (FCMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 427757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4i32rz),
     /* 427760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427762 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 427764 */     GIR_RootConstrainSelectedInstOperands,
     /* 427765 */     // GIR_Coverage, 774,
     /* 427765 */     GIR_EraseRootFromParent_Done,
     /* 427766 */   // Label 8396: @427766
     /* 427766 */   GIM_Try, /*On fail goto*//*Label 8397*/ GIMT_Encode4(427789), // Rule ID 1211 //
     /* 427771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427778 */     // (AArch64fcmeq:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMEQv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 427778 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
     /* 427783 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 427787 */     GIR_RootConstrainSelectedInstOperands,
     /* 427788 */     // GIR_Coverage, 1211,
     /* 427788 */     GIR_Done,
     /* 427789 */   // Label 8397: @427789
     /* 427789 */   GIM_Reject,
     /* 427790 */ // Label 8395: @427790
     /* 427790 */ GIM_Reject,
     /* 427791 */ // Label 8379: @427791
     /* 427791 */ GIM_Try, /*On fail goto*//*Label 8398*/ GIMT_Encode4(427865),
     /* 427796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 427799 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 427802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427806 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427810 */   GIM_Try, /*On fail goto*//*Label 8399*/ GIMT_Encode4(427841), // Rule ID 772 //
     /* 427815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 427818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 427822 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427828 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427832 */     // (AArch64fcmeq:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, immAllZerosV:{ *:[v8f16] })  =>  (FCMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 427832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv8i16rz),
     /* 427835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427837 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 427839 */     GIR_RootConstrainSelectedInstOperands,
     /* 427840 */     // GIR_Coverage, 772,
     /* 427840 */     GIR_EraseRootFromParent_Done,
     /* 427841 */   // Label 8399: @427841
     /* 427841 */   GIM_Try, /*On fail goto*//*Label 8400*/ GIMT_Encode4(427864), // Rule ID 1209 //
     /* 427846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 427849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427853 */     // (AArch64fcmeq:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMEQv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 427853 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv8f16),
     /* 427858 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 427862 */     GIR_RootConstrainSelectedInstOperands,
     /* 427863 */     // GIR_Coverage, 1209,
     /* 427863 */     GIR_Done,
     /* 427864 */   // Label 8400: @427864
     /* 427864 */   GIM_Reject,
     /* 427865 */ // Label 8398: @427865
     /* 427865 */ GIM_Reject,
     /* 427866 */ // Label 8380: @427866
     /* 427866 */ GIM_Reject,
     /* 427867 */ // Label 132: @427867
     /* 427867 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8408*/ GIMT_Encode4(428958),
     /* 427878 */ /*GILLT_s32*//*Label 8401*/ GIMT_Encode4(427914),
     /* 427882 */ /*GILLT_s64*//*Label 8402*/ GIMT_Encode4(427952), GIMT_Encode4(0),
     /* 427890 */ /*GILLT_v2s32*//*Label 8403*/ GIMT_Encode4(428093),
     /* 427894 */ /*GILLT_v2s64*//*Label 8404*/ GIMT_Encode4(428266),
     /* 427898 */ /*GILLT_v4s16*//*Label 8405*/ GIMT_Encode4(428439),
     /* 427902 */ /*GILLT_v4s32*//*Label 8406*/ GIMT_Encode4(428612), GIMT_Encode4(0),
     /* 427910 */ /*GILLT_v8s16*//*Label 8407*/ GIMT_Encode4(428785),
     /* 427914 */ // Label 8401: @427914
     /* 427914 */ GIM_Try, /*On fail goto*//*Label 8409*/ GIMT_Encode4(427951), // Rule ID 1624 //
     /* 427919 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 427925 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 427928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 427932 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 427936 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 427940 */   // (AArch64fcmge:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMGE32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 427940 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE32),
     /* 427945 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 427949 */   GIR_RootConstrainSelectedInstOperands,
     /* 427950 */   // GIR_Coverage, 1624,
     /* 427950 */   GIR_Done,
     /* 427951 */ // Label 8409: @427951
     /* 427951 */ GIM_Reject,
     /* 427952 */ // Label 8402: @427952
     /* 427952 */ GIM_Try, /*On fail goto*//*Label 8410*/ GIMT_Encode4(428092),
     /* 427957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 427960 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 427963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427967 */   GIM_Try, /*On fail goto*//*Label 8411*/ GIMT_Encode4(428002), // Rule ID 5286 //
     /* 427972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427979 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427985 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427993 */     // (AArch64fcmge:{ *:[v1i64] } immAllZerosV:{ *:[v1f64] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMLEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 427993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv1i64rz),
     /* 427996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 428000 */     GIR_RootConstrainSelectedInstOperands,
     /* 428001 */     // GIR_Coverage, 5286,
     /* 428001 */     GIR_EraseRootFromParent_Done,
     /* 428002 */   // Label 8411: @428002
     /* 428002 */   GIM_Try, /*On fail goto*//*Label 8412*/ GIMT_Encode4(428037), // Rule ID 5284 //
     /* 428007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 428018 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 428024 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 428026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 428028 */     // (AArch64fcmge:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (FCMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 428028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv1i64rz),
     /* 428031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428033 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 428035 */     GIR_RootConstrainSelectedInstOperands,
     /* 428036 */     // GIR_Coverage, 5284,
     /* 428036 */     GIR_EraseRootFromParent_Done,
     /* 428037 */   // Label 8412: @428037
     /* 428037 */   GIM_Try, /*On fail goto*//*Label 8413*/ GIMT_Encode4(428064), // Rule ID 1623 //
     /* 428042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428053 */     // (AArch64fcmge:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMGE64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 428053 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE64),
     /* 428058 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 428062 */     GIR_RootConstrainSelectedInstOperands,
     /* 428063 */     // GIR_Coverage, 1623,
     /* 428063 */     GIR_Done,
     /* 428064 */   // Label 8413: @428064
     /* 428064 */   GIM_Try, /*On fail goto*//*Label 8414*/ GIMT_Encode4(428091), // Rule ID 5253 //
     /* 428069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428080 */     // (AArch64fcmge:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMGE64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 428080 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE64),
     /* 428085 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 428089 */     GIR_RootConstrainSelectedInstOperands,
     /* 428090 */     // GIR_Coverage, 5253,
     /* 428090 */     GIR_Done,
     /* 428091 */   // Label 8414: @428091
     /* 428091 */   GIM_Reject,
     /* 428092 */ // Label 8410: @428092
     /* 428092 */ GIM_Reject,
     /* 428093 */ // Label 8403: @428093
     /* 428093 */ GIM_Try, /*On fail goto*//*Label 8415*/ GIMT_Encode4(428265),
     /* 428098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 428101 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 428104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428108 */   GIM_Try, /*On fail goto*//*Label 8416*/ GIMT_Encode4(428167), // Rule ID 1172 //
     /* 428113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 428124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 428128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 428137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 428141 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 428145 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428150 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 428152 */     // (AArch64fcmge:{ *:[v2i32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FACGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 428152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f32),
     /* 428155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 428161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 428165 */     GIR_RootConstrainSelectedInstOperands,
     /* 428166 */     // GIR_Coverage, 1172,
     /* 428166 */     GIR_EraseRootFromParent_Done,
     /* 428167 */   // Label 8416: @428167
     /* 428167 */   GIM_Try, /*On fail goto*//*Label 8417*/ GIMT_Encode4(428202), // Rule ID 788 //
     /* 428172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428179 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 428185 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 428187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 428193 */     // (AArch64fcmge:{ *:[v2i32] } immAllZerosV:{ *:[v2f32] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 428193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv2i32rz),
     /* 428196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 428200 */     GIR_RootConstrainSelectedInstOperands,
     /* 428201 */     // GIR_Coverage, 788,
     /* 428201 */     GIR_EraseRootFromParent_Done,
     /* 428202 */   // Label 8417: @428202
     /* 428202 */   GIM_Try, /*On fail goto*//*Label 8418*/ GIMT_Encode4(428237), // Rule ID 778 //
     /* 428207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 428218 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 428224 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 428226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 428228 */     // (AArch64fcmge:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (FCMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 428228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2i32rz),
     /* 428231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428233 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 428235 */     GIR_RootConstrainSelectedInstOperands,
     /* 428236 */     // GIR_Coverage, 778,
     /* 428236 */     GIR_EraseRootFromParent_Done,
     /* 428237 */   // Label 8418: @428237
     /* 428237 */   GIM_Try, /*On fail goto*//*Label 8419*/ GIMT_Encode4(428264), // Rule ID 1215 //
     /* 428242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428253 */     // (AArch64fcmge:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 428253 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2f32),
     /* 428258 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 428262 */     GIR_RootConstrainSelectedInstOperands,
     /* 428263 */     // GIR_Coverage, 1215,
     /* 428263 */     GIR_Done,
     /* 428264 */   // Label 8419: @428264
     /* 428264 */   GIM_Reject,
     /* 428265 */ // Label 8415: @428265
     /* 428265 */ GIM_Reject,
     /* 428266 */ // Label 8404: @428266
     /* 428266 */ GIM_Try, /*On fail goto*//*Label 8420*/ GIMT_Encode4(428438),
     /* 428271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 428274 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 428277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428281 */   GIM_Try, /*On fail goto*//*Label 8421*/ GIMT_Encode4(428340), // Rule ID 1176 //
     /* 428286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 428297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 428301 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428306 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 428310 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 428314 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 428318 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428323 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 428325 */     // (AArch64fcmge:{ *:[v2i64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FACGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 428325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f64),
     /* 428328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 428334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 428338 */     GIR_RootConstrainSelectedInstOperands,
     /* 428339 */     // GIR_Coverage, 1176,
     /* 428339 */     GIR_EraseRootFromParent_Done,
     /* 428340 */   // Label 8421: @428340
     /* 428340 */   GIM_Try, /*On fail goto*//*Label 8422*/ GIMT_Encode4(428375), // Rule ID 790 //
     /* 428345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428352 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 428358 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 428360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 428366 */     // (AArch64fcmge:{ *:[v2i64] } immAllZerosV:{ *:[v2f64] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 428366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv2i64rz),
     /* 428369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 428373 */     GIR_RootConstrainSelectedInstOperands,
     /* 428374 */     // GIR_Coverage, 790,
     /* 428374 */     GIR_EraseRootFromParent_Done,
     /* 428375 */   // Label 8422: @428375
     /* 428375 */   GIM_Try, /*On fail goto*//*Label 8423*/ GIMT_Encode4(428410), // Rule ID 780 //
     /* 428380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 428391 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 428397 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 428399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 428401 */     // (AArch64fcmge:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, immAllZerosV:{ *:[v2f64] })  =>  (FCMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 428401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2i64rz),
     /* 428404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428406 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 428408 */     GIR_RootConstrainSelectedInstOperands,
     /* 428409 */     // GIR_Coverage, 780,
     /* 428409 */     GIR_EraseRootFromParent_Done,
     /* 428410 */   // Label 8423: @428410
     /* 428410 */   GIM_Try, /*On fail goto*//*Label 8424*/ GIMT_Encode4(428437), // Rule ID 1217 //
     /* 428415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428426 */     // (AArch64fcmge:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 428426 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2f64),
     /* 428431 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 428435 */     GIR_RootConstrainSelectedInstOperands,
     /* 428436 */     // GIR_Coverage, 1217,
     /* 428436 */     GIR_Done,
     /* 428437 */   // Label 8424: @428437
     /* 428437 */   GIM_Reject,
     /* 428438 */ // Label 8420: @428438
     /* 428438 */ GIM_Reject,
     /* 428439 */ // Label 8405: @428439
     /* 428439 */ GIM_Try, /*On fail goto*//*Label 8425*/ GIMT_Encode4(428611),
     /* 428444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 428447 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 428450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428454 */   GIM_Try, /*On fail goto*//*Label 8426*/ GIMT_Encode4(428513), // Rule ID 1168 //
     /* 428459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 428462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 428470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 428474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428479 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 428483 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 428487 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 428491 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428496 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 428498 */     // (AArch64fcmge:{ *:[v4i16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FACGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 428498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f16),
     /* 428501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 428507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 428511 */     GIR_RootConstrainSelectedInstOperands,
     /* 428512 */     // GIR_Coverage, 1168,
     /* 428512 */     GIR_EraseRootFromParent_Done,
     /* 428513 */   // Label 8426: @428513
     /* 428513 */   GIM_Try, /*On fail goto*//*Label 8427*/ GIMT_Encode4(428548), // Rule ID 786 //
     /* 428518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 428521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428525 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 428531 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 428533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 428539 */     // (AArch64fcmge:{ *:[v4i16] } immAllZerosV:{ *:[v4f16] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 428539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv4i16rz),
     /* 428542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 428546 */     GIR_RootConstrainSelectedInstOperands,
     /* 428547 */     // GIR_Coverage, 786,
     /* 428547 */     GIR_EraseRootFromParent_Done,
     /* 428548 */   // Label 8427: @428548
     /* 428548 */   GIM_Try, /*On fail goto*//*Label 8428*/ GIMT_Encode4(428583), // Rule ID 776 //
     /* 428553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 428556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 428564 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 428570 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 428572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 428574 */     // (AArch64fcmge:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (FCMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 428574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4i16rz),
     /* 428577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428579 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 428581 */     GIR_RootConstrainSelectedInstOperands,
     /* 428582 */     // GIR_Coverage, 776,
     /* 428582 */     GIR_EraseRootFromParent_Done,
     /* 428583 */   // Label 8428: @428583
     /* 428583 */   GIM_Try, /*On fail goto*//*Label 8429*/ GIMT_Encode4(428610), // Rule ID 1213 //
     /* 428588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 428591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428599 */     // (AArch64fcmge:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 428599 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4f16),
     /* 428604 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 428608 */     GIR_RootConstrainSelectedInstOperands,
     /* 428609 */     // GIR_Coverage, 1213,
     /* 428609 */     GIR_Done,
     /* 428610 */   // Label 8429: @428610
     /* 428610 */   GIM_Reject,
     /* 428611 */ // Label 8425: @428611
     /* 428611 */ GIM_Reject,
     /* 428612 */ // Label 8406: @428612
     /* 428612 */ GIM_Try, /*On fail goto*//*Label 8430*/ GIMT_Encode4(428784),
     /* 428617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 428620 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 428623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428627 */   GIM_Try, /*On fail goto*//*Label 8431*/ GIMT_Encode4(428686), // Rule ID 1174 //
     /* 428632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 428643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 428647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 428656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 428660 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 428664 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428669 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 428671 */     // (AArch64fcmge:{ *:[v4i32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FACGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 428671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f32),
     /* 428674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 428680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 428684 */     GIR_RootConstrainSelectedInstOperands,
     /* 428685 */     // GIR_Coverage, 1174,
     /* 428685 */     GIR_EraseRootFromParent_Done,
     /* 428686 */   // Label 8431: @428686
     /* 428686 */   GIM_Try, /*On fail goto*//*Label 8432*/ GIMT_Encode4(428721), // Rule ID 789 //
     /* 428691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428698 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 428704 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 428706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 428712 */     // (AArch64fcmge:{ *:[v4i32] } immAllZerosV:{ *:[v4f32] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 428712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv4i32rz),
     /* 428715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 428719 */     GIR_RootConstrainSelectedInstOperands,
     /* 428720 */     // GIR_Coverage, 789,
     /* 428720 */     GIR_EraseRootFromParent_Done,
     /* 428721 */   // Label 8432: @428721
     /* 428721 */   GIM_Try, /*On fail goto*//*Label 8433*/ GIMT_Encode4(428756), // Rule ID 779 //
     /* 428726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 428737 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 428743 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 428745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 428747 */     // (AArch64fcmge:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, immAllZerosV:{ *:[v4f32] })  =>  (FCMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 428747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4i32rz),
     /* 428750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428752 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 428754 */     GIR_RootConstrainSelectedInstOperands,
     /* 428755 */     // GIR_Coverage, 779,
     /* 428755 */     GIR_EraseRootFromParent_Done,
     /* 428756 */   // Label 8433: @428756
     /* 428756 */   GIM_Try, /*On fail goto*//*Label 8434*/ GIMT_Encode4(428783), // Rule ID 1216 //
     /* 428761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428772 */     // (AArch64fcmge:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 428772 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4f32),
     /* 428777 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 428781 */     GIR_RootConstrainSelectedInstOperands,
     /* 428782 */     // GIR_Coverage, 1216,
     /* 428782 */     GIR_Done,
     /* 428783 */   // Label 8434: @428783
     /* 428783 */   GIM_Reject,
     /* 428784 */ // Label 8430: @428784
     /* 428784 */ GIM_Reject,
     /* 428785 */ // Label 8407: @428785
     /* 428785 */ GIM_Try, /*On fail goto*//*Label 8435*/ GIMT_Encode4(428957),
     /* 428790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 428793 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 428796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428800 */   GIM_Try, /*On fail goto*//*Label 8436*/ GIMT_Encode4(428859), // Rule ID 1170 //
     /* 428805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 428808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 428816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 428820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 428829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 428833 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 428837 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428842 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 428844 */     // (AArch64fcmge:{ *:[v8i16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FACGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 428844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv8f16),
     /* 428847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 428853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 428857 */     GIR_RootConstrainSelectedInstOperands,
     /* 428858 */     // GIR_Coverage, 1170,
     /* 428858 */     GIR_EraseRootFromParent_Done,
     /* 428859 */   // Label 8436: @428859
     /* 428859 */   GIM_Try, /*On fail goto*//*Label 8437*/ GIMT_Encode4(428894), // Rule ID 787 //
     /* 428864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 428867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428871 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 428877 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 428879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 428885 */     // (AArch64fcmge:{ *:[v8i16] } immAllZerosV:{ *:[v8f16] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 428885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv8i16rz),
     /* 428888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 428892 */     GIR_RootConstrainSelectedInstOperands,
     /* 428893 */     // GIR_Coverage, 787,
     /* 428893 */     GIR_EraseRootFromParent_Done,
     /* 428894 */   // Label 8437: @428894
     /* 428894 */   GIM_Try, /*On fail goto*//*Label 8438*/ GIMT_Encode4(428929), // Rule ID 777 //
     /* 428899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 428902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 428910 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 428916 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 428918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 428920 */     // (AArch64fcmge:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, immAllZerosV:{ *:[v8f16] })  =>  (FCMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 428920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv8i16rz),
     /* 428923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428925 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 428927 */     GIR_RootConstrainSelectedInstOperands,
     /* 428928 */     // GIR_Coverage, 777,
     /* 428928 */     GIR_EraseRootFromParent_Done,
     /* 428929 */   // Label 8438: @428929
     /* 428929 */   GIM_Try, /*On fail goto*//*Label 8439*/ GIMT_Encode4(428956), // Rule ID 1214 //
     /* 428934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 428937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428945 */     // (AArch64fcmge:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 428945 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv8f16),
     /* 428950 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 428954 */     GIR_RootConstrainSelectedInstOperands,
     /* 428955 */     // GIR_Coverage, 1214,
     /* 428955 */     GIR_Done,
     /* 428956 */   // Label 8439: @428956
     /* 428956 */   GIM_Reject,
     /* 428957 */ // Label 8435: @428957
     /* 428957 */ GIM_Reject,
     /* 428958 */ // Label 8408: @428958
     /* 428958 */ GIM_Reject,
     /* 428959 */ // Label 133: @428959
     /* 428959 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8447*/ GIMT_Encode4(430050),
     /* 428970 */ /*GILLT_s32*//*Label 8440*/ GIMT_Encode4(429006),
     /* 428974 */ /*GILLT_s64*//*Label 8441*/ GIMT_Encode4(429044), GIMT_Encode4(0),
     /* 428982 */ /*GILLT_v2s32*//*Label 8442*/ GIMT_Encode4(429185),
     /* 428986 */ /*GILLT_v2s64*//*Label 8443*/ GIMT_Encode4(429358),
     /* 428990 */ /*GILLT_v4s16*//*Label 8444*/ GIMT_Encode4(429531),
     /* 428994 */ /*GILLT_v4s32*//*Label 8445*/ GIMT_Encode4(429704), GIMT_Encode4(0),
     /* 429002 */ /*GILLT_v8s16*//*Label 8446*/ GIMT_Encode4(429877),
     /* 429006 */ // Label 8440: @429006
     /* 429006 */ GIM_Try, /*On fail goto*//*Label 8448*/ GIMT_Encode4(429043), // Rule ID 1626 //
     /* 429011 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 429017 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 429020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 429024 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 429028 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 429032 */   // (AArch64fcmgt:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMGT32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 429032 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT32),
     /* 429037 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 429041 */   GIR_RootConstrainSelectedInstOperands,
     /* 429042 */   // GIR_Coverage, 1626,
     /* 429042 */   GIR_Done,
     /* 429043 */ // Label 8448: @429043
     /* 429043 */ GIM_Reject,
     /* 429044 */ // Label 8441: @429044
     /* 429044 */ GIM_Try, /*On fail goto*//*Label 8449*/ GIMT_Encode4(429184),
     /* 429049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 429052 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 429055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429059 */   GIM_Try, /*On fail goto*//*Label 8450*/ GIMT_Encode4(429094), // Rule ID 5287 //
     /* 429064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429071 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 429077 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 429079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 429085 */     // (AArch64fcmgt:{ *:[v1i64] } immAllZerosV:{ *:[v1f64] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMLTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 429085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv1i64rz),
     /* 429088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 429092 */     GIR_RootConstrainSelectedInstOperands,
     /* 429093 */     // GIR_Coverage, 5287,
     /* 429093 */     GIR_EraseRootFromParent_Done,
     /* 429094 */   // Label 8450: @429094
     /* 429094 */   GIM_Try, /*On fail goto*//*Label 8451*/ GIMT_Encode4(429129), // Rule ID 5285 //
     /* 429099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 429110 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 429116 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 429118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 429120 */     // (AArch64fcmgt:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (FCMGTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 429120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv1i64rz),
     /* 429123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429125 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 429127 */     GIR_RootConstrainSelectedInstOperands,
     /* 429128 */     // GIR_Coverage, 5285,
     /* 429128 */     GIR_EraseRootFromParent_Done,
     /* 429129 */   // Label 8451: @429129
     /* 429129 */   GIM_Try, /*On fail goto*//*Label 8452*/ GIMT_Encode4(429156), // Rule ID 1625 //
     /* 429134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429145 */     // (AArch64fcmgt:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMGT64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 429145 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT64),
     /* 429150 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 429154 */     GIR_RootConstrainSelectedInstOperands,
     /* 429155 */     // GIR_Coverage, 1625,
     /* 429155 */     GIR_Done,
     /* 429156 */   // Label 8452: @429156
     /* 429156 */   GIM_Try, /*On fail goto*//*Label 8453*/ GIMT_Encode4(429183), // Rule ID 5254 //
     /* 429161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429172 */     // (AArch64fcmgt:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMGT64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 429172 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT64),
     /* 429177 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 429181 */     GIR_RootConstrainSelectedInstOperands,
     /* 429182 */     // GIR_Coverage, 5254,
     /* 429182 */     GIR_Done,
     /* 429183 */   // Label 8453: @429183
     /* 429183 */   GIM_Reject,
     /* 429184 */ // Label 8449: @429184
     /* 429184 */ GIM_Reject,
     /* 429185 */ // Label 8442: @429185
     /* 429185 */ GIM_Try, /*On fail goto*//*Label 8454*/ GIMT_Encode4(429357),
     /* 429190 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 429193 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 429196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429200 */   GIM_Try, /*On fail goto*//*Label 8455*/ GIMT_Encode4(429259), // Rule ID 1182 //
     /* 429205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 429216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 429220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429225 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 429229 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 429233 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 429237 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429242 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 429244 */     // (AArch64fcmgt:{ *:[v2i32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FACGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 429244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f32),
     /* 429247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 429253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 429257 */     GIR_RootConstrainSelectedInstOperands,
     /* 429258 */     // GIR_Coverage, 1182,
     /* 429258 */     GIR_EraseRootFromParent_Done,
     /* 429259 */   // Label 8455: @429259
     /* 429259 */   GIM_Try, /*On fail goto*//*Label 8456*/ GIMT_Encode4(429294), // Rule ID 793 //
     /* 429264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429271 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 429277 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 429279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 429285 */     // (AArch64fcmgt:{ *:[v2i32] } immAllZerosV:{ *:[v2f32] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 429285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv2i32rz),
     /* 429288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 429292 */     GIR_RootConstrainSelectedInstOperands,
     /* 429293 */     // GIR_Coverage, 793,
     /* 429293 */     GIR_EraseRootFromParent_Done,
     /* 429294 */   // Label 8456: @429294
     /* 429294 */   GIM_Try, /*On fail goto*//*Label 8457*/ GIMT_Encode4(429329), // Rule ID 783 //
     /* 429299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 429310 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 429316 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 429318 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 429320 */     // (AArch64fcmgt:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (FCMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 429320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2i32rz),
     /* 429323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429325 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 429327 */     GIR_RootConstrainSelectedInstOperands,
     /* 429328 */     // GIR_Coverage, 783,
     /* 429328 */     GIR_EraseRootFromParent_Done,
     /* 429329 */   // Label 8457: @429329
     /* 429329 */   GIM_Try, /*On fail goto*//*Label 8458*/ GIMT_Encode4(429356), // Rule ID 1220 //
     /* 429334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429345 */     // (AArch64fcmgt:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 429345 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2f32),
     /* 429350 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 429354 */     GIR_RootConstrainSelectedInstOperands,
     /* 429355 */     // GIR_Coverage, 1220,
     /* 429355 */     GIR_Done,
     /* 429356 */   // Label 8458: @429356
     /* 429356 */   GIM_Reject,
     /* 429357 */ // Label 8454: @429357
     /* 429357 */ GIM_Reject,
     /* 429358 */ // Label 8443: @429358
     /* 429358 */ GIM_Try, /*On fail goto*//*Label 8459*/ GIMT_Encode4(429530),
     /* 429363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 429366 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 429369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429373 */   GIM_Try, /*On fail goto*//*Label 8460*/ GIMT_Encode4(429432), // Rule ID 1186 //
     /* 429378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 429389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 429393 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429398 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 429402 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 429406 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 429410 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429415 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 429417 */     // (AArch64fcmgt:{ *:[v2i64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FACGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 429417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f64),
     /* 429420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 429426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 429430 */     GIR_RootConstrainSelectedInstOperands,
     /* 429431 */     // GIR_Coverage, 1186,
     /* 429431 */     GIR_EraseRootFromParent_Done,
     /* 429432 */   // Label 8460: @429432
     /* 429432 */   GIM_Try, /*On fail goto*//*Label 8461*/ GIMT_Encode4(429467), // Rule ID 795 //
     /* 429437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429444 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 429450 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 429452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 429458 */     // (AArch64fcmgt:{ *:[v2i64] } immAllZerosV:{ *:[v2f64] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 429458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv2i64rz),
     /* 429461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 429465 */     GIR_RootConstrainSelectedInstOperands,
     /* 429466 */     // GIR_Coverage, 795,
     /* 429466 */     GIR_EraseRootFromParent_Done,
     /* 429467 */   // Label 8461: @429467
     /* 429467 */   GIM_Try, /*On fail goto*//*Label 8462*/ GIMT_Encode4(429502), // Rule ID 785 //
     /* 429472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 429483 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 429489 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 429491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 429493 */     // (AArch64fcmgt:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, immAllZerosV:{ *:[v2f64] })  =>  (FCMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 429493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2i64rz),
     /* 429496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429498 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 429500 */     GIR_RootConstrainSelectedInstOperands,
     /* 429501 */     // GIR_Coverage, 785,
     /* 429501 */     GIR_EraseRootFromParent_Done,
     /* 429502 */   // Label 8462: @429502
     /* 429502 */   GIM_Try, /*On fail goto*//*Label 8463*/ GIMT_Encode4(429529), // Rule ID 1222 //
     /* 429507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429518 */     // (AArch64fcmgt:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 429518 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2f64),
     /* 429523 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 429527 */     GIR_RootConstrainSelectedInstOperands,
     /* 429528 */     // GIR_Coverage, 1222,
     /* 429528 */     GIR_Done,
     /* 429529 */   // Label 8463: @429529
     /* 429529 */   GIM_Reject,
     /* 429530 */ // Label 8459: @429530
     /* 429530 */ GIM_Reject,
     /* 429531 */ // Label 8444: @429531
     /* 429531 */ GIM_Try, /*On fail goto*//*Label 8464*/ GIMT_Encode4(429703),
     /* 429536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 429539 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 429542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429546 */   GIM_Try, /*On fail goto*//*Label 8465*/ GIMT_Encode4(429605), // Rule ID 1178 //
     /* 429551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 429554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 429562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 429566 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429571 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 429575 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 429579 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 429583 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429588 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 429590 */     // (AArch64fcmgt:{ *:[v4i16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FACGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 429590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f16),
     /* 429593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 429599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 429603 */     GIR_RootConstrainSelectedInstOperands,
     /* 429604 */     // GIR_Coverage, 1178,
     /* 429604 */     GIR_EraseRootFromParent_Done,
     /* 429605 */   // Label 8465: @429605
     /* 429605 */   GIM_Try, /*On fail goto*//*Label 8466*/ GIMT_Encode4(429640), // Rule ID 791 //
     /* 429610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 429613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429617 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 429623 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 429625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 429631 */     // (AArch64fcmgt:{ *:[v4i16] } immAllZerosV:{ *:[v4f16] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 429631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv4i16rz),
     /* 429634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 429638 */     GIR_RootConstrainSelectedInstOperands,
     /* 429639 */     // GIR_Coverage, 791,
     /* 429639 */     GIR_EraseRootFromParent_Done,
     /* 429640 */   // Label 8466: @429640
     /* 429640 */   GIM_Try, /*On fail goto*//*Label 8467*/ GIMT_Encode4(429675), // Rule ID 781 //
     /* 429645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 429648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 429656 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 429662 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 429664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 429666 */     // (AArch64fcmgt:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (FCMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 429666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4i16rz),
     /* 429669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429671 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 429673 */     GIR_RootConstrainSelectedInstOperands,
     /* 429674 */     // GIR_Coverage, 781,
     /* 429674 */     GIR_EraseRootFromParent_Done,
     /* 429675 */   // Label 8467: @429675
     /* 429675 */   GIM_Try, /*On fail goto*//*Label 8468*/ GIMT_Encode4(429702), // Rule ID 1218 //
     /* 429680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 429683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429691 */     // (AArch64fcmgt:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 429691 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4f16),
     /* 429696 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 429700 */     GIR_RootConstrainSelectedInstOperands,
     /* 429701 */     // GIR_Coverage, 1218,
     /* 429701 */     GIR_Done,
     /* 429702 */   // Label 8468: @429702
     /* 429702 */   GIM_Reject,
     /* 429703 */ // Label 8464: @429703
     /* 429703 */ GIM_Reject,
     /* 429704 */ // Label 8445: @429704
     /* 429704 */ GIM_Try, /*On fail goto*//*Label 8469*/ GIMT_Encode4(429876),
     /* 429709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 429712 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 429715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429719 */   GIM_Try, /*On fail goto*//*Label 8470*/ GIMT_Encode4(429778), // Rule ID 1184 //
     /* 429724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 429735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 429739 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 429748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 429752 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 429756 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429761 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 429763 */     // (AArch64fcmgt:{ *:[v4i32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FACGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 429763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f32),
     /* 429766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 429772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 429776 */     GIR_RootConstrainSelectedInstOperands,
     /* 429777 */     // GIR_Coverage, 1184,
     /* 429777 */     GIR_EraseRootFromParent_Done,
     /* 429778 */   // Label 8470: @429778
     /* 429778 */   GIM_Try, /*On fail goto*//*Label 8471*/ GIMT_Encode4(429813), // Rule ID 794 //
     /* 429783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429790 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 429796 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 429798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429802 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 429804 */     // (AArch64fcmgt:{ *:[v4i32] } immAllZerosV:{ *:[v4f32] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 429804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv4i32rz),
     /* 429807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 429811 */     GIR_RootConstrainSelectedInstOperands,
     /* 429812 */     // GIR_Coverage, 794,
     /* 429812 */     GIR_EraseRootFromParent_Done,
     /* 429813 */   // Label 8471: @429813
     /* 429813 */   GIM_Try, /*On fail goto*//*Label 8472*/ GIMT_Encode4(429848), // Rule ID 784 //
     /* 429818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 429829 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 429835 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 429837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 429839 */     // (AArch64fcmgt:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, immAllZerosV:{ *:[v4f32] })  =>  (FCMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 429839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4i32rz),
     /* 429842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429844 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 429846 */     GIR_RootConstrainSelectedInstOperands,
     /* 429847 */     // GIR_Coverage, 784,
     /* 429847 */     GIR_EraseRootFromParent_Done,
     /* 429848 */   // Label 8472: @429848
     /* 429848 */   GIM_Try, /*On fail goto*//*Label 8473*/ GIMT_Encode4(429875), // Rule ID 1221 //
     /* 429853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429864 */     // (AArch64fcmgt:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 429864 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4f32),
     /* 429869 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 429873 */     GIR_RootConstrainSelectedInstOperands,
     /* 429874 */     // GIR_Coverage, 1221,
     /* 429874 */     GIR_Done,
     /* 429875 */   // Label 8473: @429875
     /* 429875 */   GIM_Reject,
     /* 429876 */ // Label 8469: @429876
     /* 429876 */ GIM_Reject,
     /* 429877 */ // Label 8446: @429877
     /* 429877 */ GIM_Try, /*On fail goto*//*Label 8474*/ GIMT_Encode4(430049),
     /* 429882 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 429885 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 429888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429892 */   GIM_Try, /*On fail goto*//*Label 8475*/ GIMT_Encode4(429951), // Rule ID 1180 //
     /* 429897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 429900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 429908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 429912 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 429921 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 429925 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 429929 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429934 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 429936 */     // (AArch64fcmgt:{ *:[v8i16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FACGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 429936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv8f16),
     /* 429939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 429945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 429949 */     GIR_RootConstrainSelectedInstOperands,
     /* 429950 */     // GIR_Coverage, 1180,
     /* 429950 */     GIR_EraseRootFromParent_Done,
     /* 429951 */   // Label 8475: @429951
     /* 429951 */   GIM_Try, /*On fail goto*//*Label 8476*/ GIMT_Encode4(429986), // Rule ID 792 //
     /* 429956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 429959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429963 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 429969 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 429971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 429977 */     // (AArch64fcmgt:{ *:[v8i16] } immAllZerosV:{ *:[v8f16] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 429977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv8i16rz),
     /* 429980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 429984 */     GIR_RootConstrainSelectedInstOperands,
     /* 429985 */     // GIR_Coverage, 792,
     /* 429985 */     GIR_EraseRootFromParent_Done,
     /* 429986 */   // Label 8476: @429986
     /* 429986 */   GIM_Try, /*On fail goto*//*Label 8477*/ GIMT_Encode4(430021), // Rule ID 782 //
     /* 429991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 429994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 430002 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 430008 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 430010 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 430012 */     // (AArch64fcmgt:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, immAllZerosV:{ *:[v8f16] })  =>  (FCMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 430012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv8i16rz),
     /* 430015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 430017 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 430019 */     GIR_RootConstrainSelectedInstOperands,
     /* 430020 */     // GIR_Coverage, 782,
     /* 430020 */     GIR_EraseRootFromParent_Done,
     /* 430021 */   // Label 8477: @430021
     /* 430021 */   GIM_Try, /*On fail goto*//*Label 8478*/ GIMT_Encode4(430048), // Rule ID 1219 //
     /* 430026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 430029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430037 */     // (AArch64fcmgt:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 430037 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv8f16),
     /* 430042 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 430046 */     GIR_RootConstrainSelectedInstOperands,
     /* 430047 */     // GIR_Coverage, 1219,
     /* 430047 */     GIR_Done,
     /* 430048 */   // Label 8478: @430048
     /* 430048 */   GIM_Reject,
     /* 430049 */ // Label 8474: @430049
     /* 430049 */ GIM_Reject,
     /* 430050 */ // Label 8447: @430050
     /* 430050 */ GIM_Reject,
     /* 430051 */ // Label 134: @430051
     /* 430051 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 8483*/ GIMT_Encode4(430204),
     /* 430062 */ /*GILLT_s32*//*Label 8479*/ GIMT_Encode4(430102),
     /* 430066 */ /*GILLT_s64*//*Label 8480*/ GIMT_Encode4(430126), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 430090 */ /*GILLT_v8s8*//*Label 8481*/ GIMT_Encode4(430150), GIMT_Encode4(0),
     /* 430098 */ /*GILLT_v16s8*//*Label 8482*/ GIMT_Encode4(430177),
     /* 430102 */ // Label 8479: @430102
     /* 430102 */ GIM_Try, /*On fail goto*//*Label 8484*/ GIMT_Encode4(430125), // Rule ID 4040 //
     /* 430107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 430110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 430114 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 430118 */   // (AArch64rev16:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 430118 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 430123 */   GIR_RootConstrainSelectedInstOperands,
     /* 430124 */   // GIR_Coverage, 4040,
     /* 430124 */   GIR_Done,
     /* 430125 */ // Label 8484: @430125
     /* 430125 */ GIM_Reject,
     /* 430126 */ // Label 8480: @430126
     /* 430126 */ GIM_Try, /*On fail goto*//*Label 8485*/ GIMT_Encode4(430149), // Rule ID 4041 //
     /* 430131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 430134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 430138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 430142 */   // (AArch64rev16:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 430142 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /* 430147 */   GIR_RootConstrainSelectedInstOperands,
     /* 430148 */   // GIR_Coverage, 4041,
     /* 430148 */   GIR_Done,
     /* 430149 */ // Label 8485: @430149
     /* 430149 */ GIM_Reject,
     /* 430150 */ // Label 8481: @430150
     /* 430150 */ GIM_Try, /*On fail goto*//*Label 8486*/ GIMT_Encode4(430176), // Rule ID 976 //
     /* 430155 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 430161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430165 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430169 */   // (AArch64rev16:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV16v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 430169 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 430174 */   GIR_RootConstrainSelectedInstOperands,
     /* 430175 */   // GIR_Coverage, 976,
     /* 430175 */   GIR_Done,
     /* 430176 */ // Label 8486: @430176
     /* 430176 */ GIM_Reject,
     /* 430177 */ // Label 8482: @430177
     /* 430177 */ GIM_Try, /*On fail goto*//*Label 8487*/ GIMT_Encode4(430203), // Rule ID 977 //
     /* 430182 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 430188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430192 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430196 */   // (AArch64rev16:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV16v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 430196 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 430201 */   GIR_RootConstrainSelectedInstOperands,
     /* 430202 */   // GIR_Coverage, 977,
     /* 430202 */   GIR_Done,
     /* 430203 */ // Label 8487: @430203
     /* 430203 */ GIM_Reject,
     /* 430204 */ // Label 8483: @430204
     /* 430204 */ GIM_Reject,
     /* 430205 */ // Label 135: @430205
     /* 430205 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(12), /*)*//*default:*//*Label 8492*/ GIMT_Encode4(430380),
     /* 430216 */ /*GILLT_v4s16*//*Label 8488*/ GIMT_Encode4(430236), GIMT_Encode4(0),
     /* 430224 */ /*GILLT_v8s8*//*Label 8489*/ GIMT_Encode4(430281),
     /* 430228 */ /*GILLT_v8s16*//*Label 8490*/ GIMT_Encode4(430308),
     /* 430232 */ /*GILLT_v16s8*//*Label 8491*/ GIMT_Encode4(430353),
     /* 430236 */ // Label 8488: @430236
     /* 430236 */ GIM_Try, /*On fail goto*//*Label 8493*/ GIMT_Encode4(430280),
     /* 430241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 430244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430248 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430252 */   GIM_Try, /*On fail goto*//*Label 8494*/ GIMT_Encode4(430267), // Rule ID 980 //
     /* 430257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430260 */     // (AArch64rev32:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV32v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 430260 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 430265 */     GIR_RootConstrainSelectedInstOperands,
     /* 430266 */     // GIR_Coverage, 980,
     /* 430266 */     GIR_Done,
     /* 430267 */   // Label 8494: @430267
     /* 430267 */   GIM_Try, /*On fail goto*//*Label 8495*/ GIMT_Encode4(430279), // Rule ID 5023 //
     /* 430272 */     // (AArch64rev32:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (REV32v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 430272 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 430277 */     GIR_RootConstrainSelectedInstOperands,
     /* 430278 */     // GIR_Coverage, 5023,
     /* 430278 */     GIR_Done,
     /* 430279 */   // Label 8495: @430279
     /* 430279 */   GIM_Reject,
     /* 430280 */ // Label 8493: @430280
     /* 430280 */ GIM_Reject,
     /* 430281 */ // Label 8489: @430281
     /* 430281 */ GIM_Try, /*On fail goto*//*Label 8496*/ GIMT_Encode4(430307), // Rule ID 978 //
     /* 430286 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430289 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 430292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430296 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430300 */   // (AArch64rev32:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV32v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 430300 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 430305 */   GIR_RootConstrainSelectedInstOperands,
     /* 430306 */   // GIR_Coverage, 978,
     /* 430306 */   GIR_Done,
     /* 430307 */ // Label 8496: @430307
     /* 430307 */ GIM_Reject,
     /* 430308 */ // Label 8490: @430308
     /* 430308 */ GIM_Try, /*On fail goto*//*Label 8497*/ GIMT_Encode4(430352),
     /* 430313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 430316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430320 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430324 */   GIM_Try, /*On fail goto*//*Label 8498*/ GIMT_Encode4(430339), // Rule ID 981 //
     /* 430329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430332 */     // (AArch64rev32:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV32v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 430332 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 430337 */     GIR_RootConstrainSelectedInstOperands,
     /* 430338 */     // GIR_Coverage, 981,
     /* 430338 */     GIR_Done,
     /* 430339 */   // Label 8498: @430339
     /* 430339 */   GIM_Try, /*On fail goto*//*Label 8499*/ GIMT_Encode4(430351), // Rule ID 5025 //
     /* 430344 */     // (AArch64rev32:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (REV32v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 430344 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 430349 */     GIR_RootConstrainSelectedInstOperands,
     /* 430350 */     // GIR_Coverage, 5025,
     /* 430350 */     GIR_Done,
     /* 430351 */   // Label 8499: @430351
     /* 430351 */   GIM_Reject,
     /* 430352 */ // Label 8497: @430352
     /* 430352 */ GIM_Reject,
     /* 430353 */ // Label 8491: @430353
     /* 430353 */ GIM_Try, /*On fail goto*//*Label 8500*/ GIMT_Encode4(430379), // Rule ID 979 //
     /* 430358 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430361 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 430364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430368 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430372 */   // (AArch64rev32:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV32v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 430372 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 430377 */   GIR_RootConstrainSelectedInstOperands,
     /* 430378 */   // GIR_Coverage, 979,
     /* 430378 */   GIR_Done,
     /* 430379 */ // Label 8500: @430379
     /* 430379 */ GIM_Reject,
     /* 430380 */ // Label 8492: @430380
     /* 430380 */ GIM_Reject,
     /* 430381 */ // Label 136: @430381
     /* 430381 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(12), /*)*//*default:*//*Label 8507*/ GIMT_Encode4(430654),
     /* 430392 */ /*GILLT_v2s32*//*Label 8501*/ GIMT_Encode4(430420), GIMT_Encode4(0),
     /* 430400 */ /*GILLT_v4s16*//*Label 8502*/ GIMT_Encode4(430465),
     /* 430404 */ /*GILLT_v4s32*//*Label 8503*/ GIMT_Encode4(430510),
     /* 430408 */ /*GILLT_v8s8*//*Label 8504*/ GIMT_Encode4(430555),
     /* 430412 */ /*GILLT_v8s16*//*Label 8505*/ GIMT_Encode4(430582),
     /* 430416 */ /*GILLT_v16s8*//*Label 8506*/ GIMT_Encode4(430627),
     /* 430420 */ // Label 8501: @430420
     /* 430420 */ GIM_Try, /*On fail goto*//*Label 8508*/ GIMT_Encode4(430464),
     /* 430425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 430428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430432 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430436 */   GIM_Try, /*On fail goto*//*Label 8509*/ GIMT_Encode4(430451), // Rule ID 986 //
     /* 430441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430444 */     // (AArch64rev64:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (REV64v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 430444 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 430449 */     GIR_RootConstrainSelectedInstOperands,
     /* 430450 */     // GIR_Coverage, 986,
     /* 430450 */     GIR_Done,
     /* 430451 */   // Label 8509: @430451
     /* 430451 */   GIM_Try, /*On fail goto*//*Label 8510*/ GIMT_Encode4(430463), // Rule ID 5027 //
     /* 430456 */     // (AArch64rev64:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (REV64v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 430456 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 430461 */     GIR_RootConstrainSelectedInstOperands,
     /* 430462 */     // GIR_Coverage, 5027,
     /* 430462 */     GIR_Done,
     /* 430463 */   // Label 8510: @430463
     /* 430463 */   GIM_Reject,
     /* 430464 */ // Label 8508: @430464
     /* 430464 */ GIM_Reject,
     /* 430465 */ // Label 8502: @430465
     /* 430465 */ GIM_Try, /*On fail goto*//*Label 8511*/ GIMT_Encode4(430509),
     /* 430470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 430473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430477 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430481 */   GIM_Try, /*On fail goto*//*Label 8512*/ GIMT_Encode4(430496), // Rule ID 984 //
     /* 430486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430489 */     // (AArch64rev64:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV64v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 430489 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 430494 */     GIR_RootConstrainSelectedInstOperands,
     /* 430495 */     // GIR_Coverage, 984,
     /* 430495 */     GIR_Done,
     /* 430496 */   // Label 8512: @430496
     /* 430496 */   GIM_Try, /*On fail goto*//*Label 8513*/ GIMT_Encode4(430508), // Rule ID 5024 //
     /* 430501 */     // (AArch64rev64:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (REV64v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 430501 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 430506 */     GIR_RootConstrainSelectedInstOperands,
     /* 430507 */     // GIR_Coverage, 5024,
     /* 430507 */     GIR_Done,
     /* 430508 */   // Label 8513: @430508
     /* 430508 */   GIM_Reject,
     /* 430509 */ // Label 8511: @430509
     /* 430509 */ GIM_Reject,
     /* 430510 */ // Label 8503: @430510
     /* 430510 */ GIM_Try, /*On fail goto*//*Label 8514*/ GIMT_Encode4(430554),
     /* 430515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 430518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430526 */   GIM_Try, /*On fail goto*//*Label 8515*/ GIMT_Encode4(430541), // Rule ID 987 //
     /* 430531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430534 */     // (AArch64rev64:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (REV64v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 430534 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 430539 */     GIR_RootConstrainSelectedInstOperands,
     /* 430540 */     // GIR_Coverage, 987,
     /* 430540 */     GIR_Done,
     /* 430541 */   // Label 8515: @430541
     /* 430541 */   GIM_Try, /*On fail goto*//*Label 8516*/ GIMT_Encode4(430553), // Rule ID 5028 //
     /* 430546 */     // (AArch64rev64:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (REV64v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 430546 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 430551 */     GIR_RootConstrainSelectedInstOperands,
     /* 430552 */     // GIR_Coverage, 5028,
     /* 430552 */     GIR_Done,
     /* 430553 */   // Label 8516: @430553
     /* 430553 */   GIM_Reject,
     /* 430554 */ // Label 8514: @430554
     /* 430554 */ GIM_Reject,
     /* 430555 */ // Label 8504: @430555
     /* 430555 */ GIM_Try, /*On fail goto*//*Label 8517*/ GIMT_Encode4(430581), // Rule ID 982 //
     /* 430560 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 430566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430574 */   // (AArch64rev64:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV64v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 430574 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 430579 */   GIR_RootConstrainSelectedInstOperands,
     /* 430580 */   // GIR_Coverage, 982,
     /* 430580 */   GIR_Done,
     /* 430581 */ // Label 8517: @430581
     /* 430581 */ GIM_Reject,
     /* 430582 */ // Label 8505: @430582
     /* 430582 */ GIM_Try, /*On fail goto*//*Label 8518*/ GIMT_Encode4(430626),
     /* 430587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 430590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430594 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430598 */   GIM_Try, /*On fail goto*//*Label 8519*/ GIMT_Encode4(430613), // Rule ID 985 //
     /* 430603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430606 */     // (AArch64rev64:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV64v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 430606 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 430611 */     GIR_RootConstrainSelectedInstOperands,
     /* 430612 */     // GIR_Coverage, 985,
     /* 430612 */     GIR_Done,
     /* 430613 */   // Label 8519: @430613
     /* 430613 */   GIM_Try, /*On fail goto*//*Label 8520*/ GIMT_Encode4(430625), // Rule ID 5026 //
     /* 430618 */     // (AArch64rev64:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (REV64v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 430618 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 430623 */     GIR_RootConstrainSelectedInstOperands,
     /* 430624 */     // GIR_Coverage, 5026,
     /* 430624 */     GIR_Done,
     /* 430625 */   // Label 8520: @430625
     /* 430625 */   GIM_Reject,
     /* 430626 */ // Label 8518: @430626
     /* 430626 */ GIM_Reject,
     /* 430627 */ // Label 8506: @430627
     /* 430627 */ GIM_Try, /*On fail goto*//*Label 8521*/ GIMT_Encode4(430653), // Rule ID 983 //
     /* 430632 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 430638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430642 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430646 */   // (AArch64rev64:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV64v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 430646 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 430651 */   GIR_RootConstrainSelectedInstOperands,
     /* 430652 */   // GIR_Coverage, 983,
     /* 430652 */   GIR_Done,
     /* 430653 */ // Label 8521: @430653
     /* 430653 */ GIM_Reject,
     /* 430654 */ // Label 8507: @430654
     /* 430654 */ GIM_Reject,
     /* 430655 */ // Label 137: @430655
     /* 430655 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8528*/ GIMT_Encode4(430860),
     /* 430666 */ /*GILLT_s64*//*Label 8522*/ GIMT_Encode4(430698), GIMT_Encode4(0),
     /* 430674 */ /*GILLT_v2s32*//*Label 8523*/ GIMT_Encode4(430725),
     /* 430678 */ /*GILLT_v2s64*//*Label 8524*/ GIMT_Encode4(430752),
     /* 430682 */ /*GILLT_v4s16*//*Label 8525*/ GIMT_Encode4(430779),
     /* 430686 */ /*GILLT_v4s32*//*Label 8526*/ GIMT_Encode4(430806), GIMT_Encode4(0),
     /* 430694 */ /*GILLT_v8s16*//*Label 8527*/ GIMT_Encode4(430833),
     /* 430698 */ // Label 8522: @430698
     /* 430698 */ GIM_Try, /*On fail goto*//*Label 8529*/ GIMT_Encode4(430724), // Rule ID 1008 //
     /* 430703 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 430709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430713 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430717 */   // (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)  =>  (SADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 430717 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 430722 */   GIR_RootConstrainSelectedInstOperands,
     /* 430723 */   // GIR_Coverage, 1008,
     /* 430723 */   GIR_Done,
     /* 430724 */ // Label 8529: @430724
     /* 430724 */ GIM_Reject,
     /* 430725 */ // Label 8523: @430725
     /* 430725 */ GIM_Try, /*On fail goto*//*Label 8530*/ GIMT_Encode4(430751), // Rule ID 1004 //
     /* 430730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 430736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430744 */   // (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 430744 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i16_v2i32),
     /* 430749 */   GIR_RootConstrainSelectedInstOperands,
     /* 430750 */   // GIR_Coverage, 1004,
     /* 430750 */   GIR_Done,
     /* 430751 */ // Label 8530: @430751
     /* 430751 */ GIM_Reject,
     /* 430752 */ // Label 8524: @430752
     /* 430752 */ GIM_Try, /*On fail goto*//*Label 8531*/ GIMT_Encode4(430778), // Rule ID 1010 //
     /* 430757 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 430763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430767 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430771 */   // (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 430771 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i32_v2i64),
     /* 430776 */   GIR_RootConstrainSelectedInstOperands,
     /* 430777 */   // GIR_Coverage, 1010,
     /* 430777 */   GIR_Done,
     /* 430778 */ // Label 8531: @430778
     /* 430778 */ GIM_Reject,
     /* 430779 */ // Label 8525: @430779
     /* 430779 */ GIM_Try, /*On fail goto*//*Label 8532*/ GIMT_Encode4(430805), // Rule ID 1000 //
     /* 430784 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 430790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430794 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430798 */   // (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)  =>  (SADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 430798 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i8_v4i16),
     /* 430803 */   GIR_RootConstrainSelectedInstOperands,
     /* 430804 */   // GIR_Coverage, 1000,
     /* 430804 */   GIR_Done,
     /* 430805 */ // Label 8532: @430805
     /* 430805 */ GIM_Reject,
     /* 430806 */ // Label 8526: @430806
     /* 430806 */ GIM_Try, /*On fail goto*//*Label 8533*/ GIMT_Encode4(430832), // Rule ID 1006 //
     /* 430811 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 430817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430821 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430825 */   // (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 430825 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i16_v4i32),
     /* 430830 */   GIR_RootConstrainSelectedInstOperands,
     /* 430831 */   // GIR_Coverage, 1006,
     /* 430831 */   GIR_Done,
     /* 430832 */ // Label 8533: @430832
     /* 430832 */ GIM_Reject,
     /* 430833 */ // Label 8527: @430833
     /* 430833 */ GIM_Try, /*On fail goto*//*Label 8534*/ GIMT_Encode4(430859), // Rule ID 1002 //
     /* 430838 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 430844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430848 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430852 */   // (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)  =>  (SADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 430852 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv16i8_v8i16),
     /* 430857 */   GIR_RootConstrainSelectedInstOperands,
     /* 430858 */   // GIR_Coverage, 1002,
     /* 430858 */   GIR_Done,
     /* 430859 */ // Label 8534: @430859
     /* 430859 */ GIM_Reject,
     /* 430860 */ // Label 8528: @430860
     /* 430860 */ GIM_Reject,
     /* 430861 */ // Label 138: @430861
     /* 430861 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(9), /*)*//*default:*//*Label 8537*/ GIMT_Encode4(431259),
     /* 430872 */ /*GILLT_v2s64*//*Label 8535*/ GIMT_Encode4(430884), GIMT_Encode4(0),
     /* 430880 */ /*GILLT_v4s32*//*Label 8536*/ GIMT_Encode4(431022),
     /* 430884 */ // Label 8535: @430884
     /* 430884 */ GIM_Try, /*On fail goto*//*Label 8538*/ GIMT_Encode4(430943), // Rule ID 5936 //
     /* 430889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 430892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430900 */   // (AArch64saddlv:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 430900 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 430903 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 430907 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 430912 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 430916 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 430918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 430921 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 430923 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430926 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 430929 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 430932 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430937 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430942 */   // GIR_Coverage, 5936,
     /* 430942 */   GIR_EraseRootFromParent_Done,
     /* 430943 */ // Label 8538: @430943
     /* 430943 */ GIM_Try, /*On fail goto*//*Label 8539*/ GIMT_Encode4(431021), // Rule ID 6058 //
     /* 430948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 430951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430955 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430959 */   // (AArch64saddlv:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (SADDLPv2i32_v1i64:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /* 430959 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 430962 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 430966 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 430971 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 430975 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 430977 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 430980 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 430984 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 430989 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 430991 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 430994 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 430996 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 430999 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 431002 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 431005 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431010 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431015 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431020 */   // GIR_Coverage, 6058,
     /* 431020 */   GIR_EraseRootFromParent_Done,
     /* 431021 */ // Label 8539: @431021
     /* 431021 */ GIM_Reject,
     /* 431022 */ // Label 8536: @431022
     /* 431022 */ GIM_Try, /*On fail goto*//*Label 8540*/ GIMT_Encode4(431081), // Rule ID 5932 //
     /* 431027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 431030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431034 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431038 */   // (AArch64saddlv:{ *:[v4i32] } V64:{ *:[v8i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn), hsub:{ *:[i32] })
     /* 431038 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 431041 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 431045 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 431050 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 431054 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 431056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 431059 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 431061 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431064 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 431067 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 431070 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431075 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 431080 */   // GIR_Coverage, 5932,
     /* 431080 */   GIR_EraseRootFromParent_Done,
     /* 431081 */ // Label 8540: @431081
     /* 431081 */ GIM_Try, /*On fail goto*//*Label 8541*/ GIMT_Encode4(431140), // Rule ID 5933 //
     /* 431086 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 431089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431093 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431097 */   // (AArch64saddlv:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn), ssub:{ *:[i32] })
     /* 431097 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 431100 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 431104 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 431109 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 431113 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 431115 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 431118 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 431120 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431123 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 431126 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 431129 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431134 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 431139 */   // GIR_Coverage, 5933,
     /* 431139 */   GIR_EraseRootFromParent_Done,
     /* 431140 */ // Label 8541: @431140
     /* 431140 */ GIM_Try, /*On fail goto*//*Label 8542*/ GIMT_Encode4(431199), // Rule ID 5934 //
     /* 431145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 431148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431152 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431156 */   // (AArch64saddlv:{ *:[v4i32] } V128:{ *:[v16i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn), hsub:{ *:[i32] })
     /* 431156 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 431159 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 431163 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 431168 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 431172 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 431174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 431177 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 431179 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431182 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 431185 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 431188 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431193 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 431198 */   // GIR_Coverage, 5934,
     /* 431198 */   GIR_EraseRootFromParent_Done,
     /* 431199 */ // Label 8542: @431199
     /* 431199 */ GIM_Try, /*On fail goto*//*Label 8543*/ GIMT_Encode4(431258), // Rule ID 5935 //
     /* 431204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 431207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431211 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431215 */   // (AArch64saddlv:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn), ssub:{ *:[i32] })
     /* 431215 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 431218 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 431222 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 431227 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 431231 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 431233 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 431236 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 431238 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431241 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 431244 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 431247 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431252 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 431257 */   // GIR_Coverage, 5935,
     /* 431257 */   GIR_EraseRootFromParent_Done,
     /* 431258 */ // Label 8543: @431258
     /* 431258 */ GIM_Reject,
     /* 431259 */ // Label 8537: @431259
     /* 431259 */ GIM_Reject,
     /* 431260 */ // Label 139: @431260
     /* 431260 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(20), /*)*//*default:*//*Label 8548*/ GIMT_Encode4(431629),
     /* 431271 */ /*GILLT_v2s32*//*Label 8544*/ GIMT_Encode4(431331), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 431283 */ /*GILLT_v4s32*//*Label 8545*/ GIMT_Encode4(431451), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 431315 */ /*GILLT_nxv2s64*//*Label 8546*/ GIMT_Encode4(431571), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 431327 */ /*GILLT_nxv4s32*//*Label 8547*/ GIMT_Encode4(431600),
     /* 431331 */ // Label 8544: @431331
     /* 431331 */ GIM_Try, /*On fail goto*//*Label 8549*/ GIMT_Encode4(431450),
     /* 431336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 431339 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 431342 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 431345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431349 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431353 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431357 */   GIM_Try, /*On fail goto*//*Label 8550*/ GIMT_Encode4(431430), // Rule ID 26 //
     /* 431362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 431365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 431369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 431373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 431377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 431381 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 431385 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 431389 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 431393 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431398 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 431402 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 431406 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 431410 */     // MIs[3] Operand 1
     /* 431410 */     // No operand predicates
     /* 431410 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 431412 */     // (AArch64sdot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, (bitconvert:{ *:[v8i8] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SDOTlanev8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 431412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOTlanev8i8),
     /* 431415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 431417 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 431419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 431421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 431425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 431428 */     GIR_RootConstrainSelectedInstOperands,
     /* 431429 */     // GIR_Coverage, 26,
     /* 431429 */     GIR_EraseRootFromParent_Done,
     /* 431430 */   // Label 8550: @431430
     /* 431430 */   GIM_Try, /*On fail goto*//*Label 8551*/ GIMT_Encode4(431449), // Rule ID 22 //
     /* 431435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 431438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431442 */     // (AArch64sdot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SDOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 431442 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOTv8i8),
     /* 431447 */     GIR_RootConstrainSelectedInstOperands,
     /* 431448 */     // GIR_Coverage, 22,
     /* 431448 */     GIR_Done,
     /* 431449 */   // Label 8551: @431449
     /* 431449 */   GIM_Reject,
     /* 431450 */ // Label 8549: @431450
     /* 431450 */ GIM_Reject,
     /* 431451 */ // Label 8545: @431451
     /* 431451 */ GIM_Try, /*On fail goto*//*Label 8552*/ GIMT_Encode4(431570),
     /* 431456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 431459 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 431462 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 431465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431469 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431473 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431477 */   GIM_Try, /*On fail goto*//*Label 8553*/ GIMT_Encode4(431550), // Rule ID 27 //
     /* 431482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 431485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 431489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 431493 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 431497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 431501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 431505 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 431509 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 431513 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431518 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 431522 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 431526 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 431530 */     // MIs[3] Operand 1
     /* 431530 */     // No operand predicates
     /* 431530 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 431532 */     // (AArch64sdot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, (bitconvert:{ *:[v16i8] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SDOTlanev16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 431532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOTlanev16i8),
     /* 431535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 431537 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 431539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 431541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 431545 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 431548 */     GIR_RootConstrainSelectedInstOperands,
     /* 431549 */     // GIR_Coverage, 27,
     /* 431549 */     GIR_EraseRootFromParent_Done,
     /* 431550 */   // Label 8553: @431550
     /* 431550 */   GIM_Try, /*On fail goto*//*Label 8554*/ GIMT_Encode4(431569), // Rule ID 23 //
     /* 431555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 431558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431562 */     // (AArch64sdot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SDOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 431562 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOTv16i8),
     /* 431567 */     GIR_RootConstrainSelectedInstOperands,
     /* 431568 */     // GIR_Coverage, 23,
     /* 431568 */     GIR_Done,
     /* 431569 */   // Label 8554: @431569
     /* 431569 */   GIM_Reject,
     /* 431570 */ // Label 8552: @431570
     /* 431570 */ GIM_Reject,
     /* 431571 */ // Label 8546: @431571
     /* 431571 */ GIM_Try, /*On fail goto*//*Label 8555*/ GIMT_Encode4(431599), // Rule ID 2997 //
     /* 431576 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 431582 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 431585 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 431588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 431592 */   // (AArch64sdot:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SDOT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 431592 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_D),
     /* 431597 */   GIR_RootConstrainSelectedInstOperands,
     /* 431598 */   // GIR_Coverage, 2997,
     /* 431598 */   GIR_Done,
     /* 431599 */ // Label 8555: @431599
     /* 431599 */ GIM_Reject,
     /* 431600 */ // Label 8547: @431600
     /* 431600 */ GIM_Try, /*On fail goto*//*Label 8556*/ GIMT_Encode4(431628), // Rule ID 2996 //
     /* 431605 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 431611 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 431614 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 431617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 431621 */   // (AArch64sdot:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SDOT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 431621 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_S),
     /* 431626 */   GIR_RootConstrainSelectedInstOperands,
     /* 431627 */   // GIR_Coverage, 2996,
     /* 431627 */   GIR_Done,
     /* 431628 */ // Label 8556: @431628
     /* 431628 */ GIM_Reject,
     /* 431629 */ // Label 8548: @431629
     /* 431629 */ GIM_Reject,
     /* 431630 */ // Label 140: @431630
     /* 431630 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8560*/ GIMT_Encode4(431746),
     /* 431641 */ /*GILLT_s16*//*Label 8557*/ GIMT_Encode4(431653),
     /* 431645 */ /*GILLT_s32*//*Label 8558*/ GIMT_Encode4(431684),
     /* 431649 */ /*GILLT_s64*//*Label 8559*/ GIMT_Encode4(431715),
     /* 431653 */ // Label 8557: @431653
     /* 431653 */ GIM_Try, /*On fail goto*//*Label 8561*/ GIMT_Encode4(431683), // Rule ID 1658 //
     /* 431658 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 431661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 431664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 431668 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 431672 */   // (AArch64sitof:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (SCVTFv1i16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 431672 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 431677 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 431681 */   GIR_RootConstrainSelectedInstOperands,
     /* 431682 */   // GIR_Coverage, 1658,
     /* 431682 */   GIR_Done,
     /* 431683 */ // Label 8561: @431683
     /* 431683 */ GIM_Reject,
     /* 431684 */ // Label 8558: @431684
     /* 431684 */ GIM_Try, /*On fail goto*//*Label 8562*/ GIMT_Encode4(431714), // Rule ID 1657 //
     /* 431689 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 431692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 431695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 431699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 431703 */   // (AArch64sitof:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (SCVTFv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 431703 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 431708 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 431712 */   GIR_RootConstrainSelectedInstOperands,
     /* 431713 */   // GIR_Coverage, 1657,
     /* 431713 */   GIR_Done,
     /* 431714 */ // Label 8562: @431714
     /* 431714 */ GIM_Reject,
     /* 431715 */ // Label 8559: @431715
     /* 431715 */ GIM_Try, /*On fail goto*//*Label 8563*/ GIMT_Encode4(431745), // Rule ID 1656 //
     /* 431720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 431723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 431726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431730 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431734 */   // (AArch64sitof:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (SCVTFv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 431734 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 431739 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 431743 */   GIR_RootConstrainSelectedInstOperands,
     /* 431744 */   // GIR_Coverage, 1656,
     /* 431744 */   GIR_Done,
     /* 431745 */ // Label 8563: @431745
     /* 431745 */ GIM_Reject,
     /* 431746 */ // Label 8560: @431746
     /* 431746 */ GIM_Reject,
     /* 431747 */ // Label 141: @431747
     /* 431747 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(11), /*)*//*default:*//*Label 8567*/ GIMT_Encode4(432979),
     /* 431758 */ /*GILLT_v2s64*//*Label 8564*/ GIMT_Encode4(431778), GIMT_Encode4(0),
     /* 431766 */ /*GILLT_v4s32*//*Label 8565*/ GIMT_Encode4(432339), GIMT_Encode4(0),
     /* 431774 */ /*GILLT_v8s16*//*Label 8566*/ GIMT_Encode4(432900),
     /* 431778 */ // Label 8564: @431778
     /* 431778 */ GIM_Try, /*On fail goto*//*Label 8568*/ GIMT_Encode4(432338),
     /* 431783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 431786 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 431789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431793 */   GIM_Try, /*On fail goto*//*Label 8569*/ GIMT_Encode4(431885), // Rule ID 2054 //
     /* 431798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 431805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 431809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 431813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 431817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 431821 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 431825 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 431829 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431834 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 431838 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 431842 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 431846 */     // MIs[3] Operand 1
     /* 431846 */     // No operand predicates
     /* 431846 */     // MIs[1] Operand 2
     /* 431846 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 431857 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 431859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 431866 */     // (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (SMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 431866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_indexed),
     /* 431869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 431871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 431876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 431880 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 431883 */     GIR_RootConstrainSelectedInstOperands,
     /* 431884 */     // GIR_Coverage, 2054,
     /* 431884 */     GIR_EraseRootFromParent_Done,
     /* 431885 */   // Label 8569: @431885
     /* 431885 */   GIM_Try, /*On fail goto*//*Label 8570*/ GIMT_Encode4(431977), // Rule ID 13646 //
     /* 431890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 431897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 431901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 431905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 431909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 431913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 431917 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 431921 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431926 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 431930 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 431934 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 431938 */     // MIs[3] Operand 1
     /* 431938 */     // No operand predicates
     /* 431938 */     // MIs[1] Operand 2
     /* 431938 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 431949 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 431951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 431958 */     // (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (SMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 431958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_indexed),
     /* 431961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 431963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 431968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 431972 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 431975 */     GIR_RootConstrainSelectedInstOperands,
     /* 431976 */     // GIR_Coverage, 13646,
     /* 431976 */     GIR_EraseRootFromParent_Done,
     /* 431977 */   // Label 8570: @431977
     /* 431977 */   GIM_Try, /*On fail goto*//*Label 8571*/ GIMT_Encode4(432063), // Rule ID 13644 //
     /* 431982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 431989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 431993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 431997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 432001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 432005 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 432009 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 432013 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432018 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 432022 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 432026 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 432030 */     // MIs[3] Operand 1
     /* 432030 */     // No operand predicates
     /* 432030 */     // MIs[1] Operand 2
     /* 432030 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 432041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432045 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 432047 */     // (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 432047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 432050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 432052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 432054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 432058 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 432061 */     GIR_RootConstrainSelectedInstOperands,
     /* 432062 */     // GIR_Coverage, 13644,
     /* 432062 */     GIR_EraseRootFromParent_Done,
     /* 432063 */   // Label 8571: @432063
     /* 432063 */   GIM_Try, /*On fail goto*//*Label 8572*/ GIMT_Encode4(432149), // Rule ID 2052 //
     /* 432068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 432079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 432083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 432087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 432091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 432095 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 432099 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 432103 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432108 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 432112 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 432116 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 432120 */     // MIs[3] Operand 1
     /* 432120 */     // No operand predicates
     /* 432120 */     // MIs[1] Operand 2
     /* 432120 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 432131 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 432133 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 432133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 432136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 432138 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 432140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 432144 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 432147 */     GIR_RootConstrainSelectedInstOperands,
     /* 432148 */     // GIR_Coverage, 2052,
     /* 432148 */     GIR_EraseRootFromParent_Done,
     /* 432149 */   // Label 8572: @432149
     /* 432149 */   GIM_Try, /*On fail goto*//*Label 8573*/ GIMT_Encode4(432188), // Rule ID 1741 //
     /* 432154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 432164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 432171 */     // (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (SMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 432171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_v2i64),
     /* 432174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 432176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 432181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 432186 */     GIR_RootConstrainSelectedInstOperands,
     /* 432187 */     // GIR_Coverage, 1741,
     /* 432187 */     GIR_EraseRootFromParent_Done,
     /* 432188 */   // Label 8573: @432188
     /* 432188 */   GIM_Try, /*On fail goto*//*Label 8574*/ GIMT_Encode4(432251), // Rule ID 13645 //
     /* 432193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 432200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 432204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 432208 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 432212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 432221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 432225 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 432229 */     // MIs[2] Operand 1
     /* 432229 */     // No operand predicates
     /* 432229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432233 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 432235 */     // (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 432235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 432238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 432240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 432242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 432246 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 432249 */     GIR_RootConstrainSelectedInstOperands,
     /* 432250 */     // GIR_Coverage, 13645,
     /* 432250 */     GIR_EraseRootFromParent_Done,
     /* 432251 */   // Label 8574: @432251
     /* 432251 */   GIM_Try, /*On fail goto*//*Label 8575*/ GIMT_Encode4(432314), // Rule ID 2053 //
     /* 432256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 432267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 432271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 432275 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 432279 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432284 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 432288 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 432292 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 432296 */     // MIs[2] Operand 1
     /* 432296 */     // No operand predicates
     /* 432296 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 432298 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 432298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 432301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 432303 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 432305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 432309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 432312 */     GIR_RootConstrainSelectedInstOperands,
     /* 432313 */     // GIR_Coverage, 2053,
     /* 432313 */     GIR_EraseRootFromParent_Done,
     /* 432314 */   // Label 8575: @432314
     /* 432314 */   GIM_Try, /*On fail goto*//*Label 8576*/ GIMT_Encode4(432337), // Rule ID 1740 //
     /* 432319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432330 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 432330 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_v2i64),
     /* 432335 */     GIR_RootConstrainSelectedInstOperands,
     /* 432336 */     // GIR_Coverage, 1740,
     /* 432336 */     GIR_Done,
     /* 432337 */   // Label 8576: @432337
     /* 432337 */   GIM_Reject,
     /* 432338 */ // Label 8568: @432338
     /* 432338 */ GIM_Reject,
     /* 432339 */ // Label 8565: @432339
     /* 432339 */ GIM_Try, /*On fail goto*//*Label 8577*/ GIMT_Encode4(432899),
     /* 432344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 432347 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 432350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432354 */   GIM_Try, /*On fail goto*//*Label 8578*/ GIMT_Encode4(432446), // Rule ID 2051 //
     /* 432359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 432366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 432370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 432374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 432378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 432382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 432386 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 432390 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 432395 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 432399 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 432403 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 432407 */     // MIs[3] Operand 1
     /* 432407 */     // No operand predicates
     /* 432407 */     // MIs[1] Operand 2
     /* 432407 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 432418 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 432420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 432427 */     // (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (SMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 432427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_indexed),
     /* 432430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 432432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 432437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 432441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 432444 */     GIR_RootConstrainSelectedInstOperands,
     /* 432445 */     // GIR_Coverage, 2051,
     /* 432445 */     GIR_EraseRootFromParent_Done,
     /* 432446 */   // Label 8578: @432446
     /* 432446 */   GIM_Try, /*On fail goto*//*Label 8579*/ GIMT_Encode4(432538), // Rule ID 13643 //
     /* 432451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 432458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 432462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 432466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 432470 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 432474 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 432478 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 432482 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 432487 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 432491 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 432495 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 432499 */     // MIs[3] Operand 1
     /* 432499 */     // No operand predicates
     /* 432499 */     // MIs[1] Operand 2
     /* 432499 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 432510 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 432512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 432519 */     // (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (SMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 432519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_indexed),
     /* 432522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 432524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 432529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 432533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 432536 */     GIR_RootConstrainSelectedInstOperands,
     /* 432537 */     // GIR_Coverage, 13643,
     /* 432537 */     GIR_EraseRootFromParent_Done,
     /* 432538 */   // Label 8579: @432538
     /* 432538 */   GIM_Try, /*On fail goto*//*Label 8580*/ GIMT_Encode4(432624), // Rule ID 13641 //
     /* 432543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 432550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 432554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 432558 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 432562 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 432566 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 432570 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 432574 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 432579 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 432583 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 432587 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 432591 */     // MIs[3] Operand 1
     /* 432591 */     // No operand predicates
     /* 432591 */     // MIs[1] Operand 2
     /* 432591 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 432602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432606 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 432608 */     // (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 432608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 432611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 432613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 432615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 432619 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 432622 */     GIR_RootConstrainSelectedInstOperands,
     /* 432623 */     // GIR_Coverage, 13641,
     /* 432623 */     GIR_EraseRootFromParent_Done,
     /* 432624 */   // Label 8580: @432624
     /* 432624 */   GIM_Try, /*On fail goto*//*Label 8581*/ GIMT_Encode4(432710), // Rule ID 2049 //
     /* 432629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 432640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 432644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 432648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 432652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 432656 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 432660 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 432664 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 432669 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 432673 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 432677 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 432681 */     // MIs[3] Operand 1
     /* 432681 */     // No operand predicates
     /* 432681 */     // MIs[1] Operand 2
     /* 432681 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 432692 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 432694 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 432694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 432697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 432699 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 432701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 432705 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 432708 */     GIR_RootConstrainSelectedInstOperands,
     /* 432709 */     // GIR_Coverage, 2049,
     /* 432709 */     GIR_EraseRootFromParent_Done,
     /* 432710 */   // Label 8581: @432710
     /* 432710 */   GIM_Try, /*On fail goto*//*Label 8582*/ GIMT_Encode4(432749), // Rule ID 1739 //
     /* 432715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 432725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 432732 */     // (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (SMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 432732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_v4i32),
     /* 432735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 432737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 432742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 432747 */     GIR_RootConstrainSelectedInstOperands,
     /* 432748 */     // GIR_Coverage, 1739,
     /* 432748 */     GIR_EraseRootFromParent_Done,
     /* 432749 */   // Label 8582: @432749
     /* 432749 */   GIM_Try, /*On fail goto*//*Label 8583*/ GIMT_Encode4(432812), // Rule ID 13642 //
     /* 432754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 432761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 432765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 432769 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 432773 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 432778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 432782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 432786 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 432790 */     // MIs[2] Operand 1
     /* 432790 */     // No operand predicates
     /* 432790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432794 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 432796 */     // (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 432796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 432799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 432801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 432803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 432807 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 432810 */     GIR_RootConstrainSelectedInstOperands,
     /* 432811 */     // GIR_Coverage, 13642,
     /* 432811 */     GIR_EraseRootFromParent_Done,
     /* 432812 */   // Label 8583: @432812
     /* 432812 */   GIM_Try, /*On fail goto*//*Label 8584*/ GIMT_Encode4(432875), // Rule ID 2050 //
     /* 432817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 432828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 432832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 432836 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 432840 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 432845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 432849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 432853 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 432857 */     // MIs[2] Operand 1
     /* 432857 */     // No operand predicates
     /* 432857 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 432859 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 432859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 432862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 432864 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 432866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 432870 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 432873 */     GIR_RootConstrainSelectedInstOperands,
     /* 432874 */     // GIR_Coverage, 2050,
     /* 432874 */     GIR_EraseRootFromParent_Done,
     /* 432875 */   // Label 8584: @432875
     /* 432875 */   GIM_Try, /*On fail goto*//*Label 8585*/ GIMT_Encode4(432898), // Rule ID 1738 //
     /* 432880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432891 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 432891 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_v4i32),
     /* 432896 */     GIR_RootConstrainSelectedInstOperands,
     /* 432897 */     // GIR_Coverage, 1738,
     /* 432897 */     GIR_Done,
     /* 432898 */   // Label 8585: @432898
     /* 432898 */   GIM_Reject,
     /* 432899 */ // Label 8577: @432899
     /* 432899 */ GIM_Reject,
     /* 432900 */ // Label 8566: @432900
     /* 432900 */ GIM_Try, /*On fail goto*//*Label 8586*/ GIMT_Encode4(432978),
     /* 432905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 432908 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 432911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432915 */   GIM_Try, /*On fail goto*//*Label 8587*/ GIMT_Encode4(432954), // Rule ID 1737 //
     /* 432920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 432930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 432937 */     // (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (SMULLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 432937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv16i8_v8i16),
     /* 432940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 432942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 432947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 432952 */     GIR_RootConstrainSelectedInstOperands,
     /* 432953 */     // GIR_Coverage, 1737,
     /* 432953 */     GIR_EraseRootFromParent_Done,
     /* 432954 */   // Label 8587: @432954
     /* 432954 */   GIM_Try, /*On fail goto*//*Label 8588*/ GIMT_Encode4(432977), // Rule ID 1736 //
     /* 432959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432970 */     // (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMULLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 432970 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i8_v8i16),
     /* 432975 */     GIR_RootConstrainSelectedInstOperands,
     /* 432976 */     // GIR_Coverage, 1736,
     /* 432976 */     GIR_Done,
     /* 432977 */   // Label 8588: @432977
     /* 432977 */   GIM_Reject,
     /* 432978 */ // Label 8586: @432978
     /* 432978 */ GIM_Reject,
     /* 432979 */ // Label 8567: @432979
     /* 432979 */ GIM_Reject,
     /* 432980 */ // Label 142: @432980
     /* 432980 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8607*/ GIMT_Encode4(433759),
     /* 432991 */ /*GILLT_v2s32*//*Label 8589*/ GIMT_Encode4(433067),
     /* 432995 */ /*GILLT_v2s64*//*Label 8590*/ GIMT_Encode4(433122),
     /* 432999 */ /*GILLT_v4s16*//*Label 8591*/ GIMT_Encode4(433177),
     /* 433003 */ /*GILLT_v4s32*//*Label 8592*/ GIMT_Encode4(433232),
     /* 433007 */ /*GILLT_v8s8*//*Label 8593*/ GIMT_Encode4(433287),
     /* 433011 */ /*GILLT_v8s16*//*Label 8594*/ GIMT_Encode4(433321),
     /* 433015 */ /*GILLT_v16s8*//*Label 8595*/ GIMT_Encode4(433376), GIMT_Encode4(0),
     /* 433023 */ /*GILLT_nxv2s1*//*Label 8596*/ GIMT_Encode4(433410),
     /* 433027 */ /*GILLT_nxv2s16*//*Label 8597*/ GIMT_Encode4(433436),
     /* 433031 */ /*GILLT_nxv2s32*//*Label 8598*/ GIMT_Encode4(433462),
     /* 433035 */ /*GILLT_nxv2s64*//*Label 8599*/ GIMT_Encode4(433488),
     /* 433039 */ /*GILLT_nxv4s1*//*Label 8600*/ GIMT_Encode4(433535),
     /* 433043 */ /*GILLT_nxv4s16*//*Label 8601*/ GIMT_Encode4(433561),
     /* 433047 */ /*GILLT_nxv4s32*//*Label 8602*/ GIMT_Encode4(433587),
     /* 433051 */ /*GILLT_nxv8s1*//*Label 8603*/ GIMT_Encode4(433634),
     /* 433055 */ /*GILLT_nxv8s16*//*Label 8604*/ GIMT_Encode4(433660),
     /* 433059 */ /*GILLT_nxv16s1*//*Label 8605*/ GIMT_Encode4(433707),
     /* 433063 */ /*GILLT_nxv16s8*//*Label 8606*/ GIMT_Encode4(433733),
     /* 433067 */ // Label 8589: @433067
     /* 433067 */ GIM_Try, /*On fail goto*//*Label 8608*/ GIMT_Encode4(433121),
     /* 433072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 433075 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 433078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433082 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433086 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433090 */   GIM_Try, /*On fail goto*//*Label 8609*/ GIMT_Encode4(433105), // Rule ID 1874 //
     /* 433095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433098 */     // (AArch64trn1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (TRN1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 433098 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i32),
     /* 433103 */     GIR_RootConstrainSelectedInstOperands,
     /* 433104 */     // GIR_Coverage, 1874,
     /* 433104 */     GIR_Done,
     /* 433105 */   // Label 8609: @433105
     /* 433105 */   GIM_Try, /*On fail goto*//*Label 8610*/ GIMT_Encode4(433120), // Rule ID 2501 //
     /* 433110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433113 */     // (AArch64trn1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (TRN1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 433113 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i32),
     /* 433118 */     GIR_RootConstrainSelectedInstOperands,
     /* 433119 */     // GIR_Coverage, 2501,
     /* 433119 */     GIR_Done,
     /* 433120 */   // Label 8610: @433120
     /* 433120 */   GIM_Reject,
     /* 433121 */ // Label 8608: @433121
     /* 433121 */ GIM_Reject,
     /* 433122 */ // Label 8590: @433122
     /* 433122 */ GIM_Try, /*On fail goto*//*Label 8611*/ GIMT_Encode4(433176),
     /* 433127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 433130 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 433133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433137 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433141 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433145 */   GIM_Try, /*On fail goto*//*Label 8612*/ GIMT_Encode4(433160), // Rule ID 1876 //
     /* 433150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433153 */     // (AArch64trn1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (TRN1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 433153 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i64),
     /* 433158 */     GIR_RootConstrainSelectedInstOperands,
     /* 433159 */     // GIR_Coverage, 1876,
     /* 433159 */     GIR_Done,
     /* 433160 */   // Label 8612: @433160
     /* 433160 */   GIM_Try, /*On fail goto*//*Label 8613*/ GIMT_Encode4(433175), // Rule ID 2503 //
     /* 433165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433168 */     // (AArch64trn1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (TRN1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 433168 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i64),
     /* 433173 */     GIR_RootConstrainSelectedInstOperands,
     /* 433174 */     // GIR_Coverage, 2503,
     /* 433174 */     GIR_Done,
     /* 433175 */   // Label 8613: @433175
     /* 433175 */   GIM_Reject,
     /* 433176 */ // Label 8611: @433176
     /* 433176 */ GIM_Reject,
     /* 433177 */ // Label 8591: @433177
     /* 433177 */ GIM_Try, /*On fail goto*//*Label 8614*/ GIMT_Encode4(433231),
     /* 433182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 433185 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 433188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433192 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433196 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433200 */   GIM_Try, /*On fail goto*//*Label 8615*/ GIMT_Encode4(433215), // Rule ID 1872 //
     /* 433205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433208 */     // (AArch64trn1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (TRN1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 433208 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i16),
     /* 433213 */     GIR_RootConstrainSelectedInstOperands,
     /* 433214 */     // GIR_Coverage, 1872,
     /* 433214 */     GIR_Done,
     /* 433215 */   // Label 8615: @433215
     /* 433215 */   GIM_Try, /*On fail goto*//*Label 8616*/ GIMT_Encode4(433230), // Rule ID 2499 //
     /* 433220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433223 */     // (AArch64trn1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (TRN1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 433223 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i16),
     /* 433228 */     GIR_RootConstrainSelectedInstOperands,
     /* 433229 */     // GIR_Coverage, 2499,
     /* 433229 */     GIR_Done,
     /* 433230 */   // Label 8616: @433230
     /* 433230 */   GIM_Reject,
     /* 433231 */ // Label 8614: @433231
     /* 433231 */ GIM_Reject,
     /* 433232 */ // Label 8592: @433232
     /* 433232 */ GIM_Try, /*On fail goto*//*Label 8617*/ GIMT_Encode4(433286),
     /* 433237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 433240 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 433243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433247 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433251 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433255 */   GIM_Try, /*On fail goto*//*Label 8618*/ GIMT_Encode4(433270), // Rule ID 1875 //
     /* 433260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433263 */     // (AArch64trn1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (TRN1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 433263 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i32),
     /* 433268 */     GIR_RootConstrainSelectedInstOperands,
     /* 433269 */     // GIR_Coverage, 1875,
     /* 433269 */     GIR_Done,
     /* 433270 */   // Label 8618: @433270
     /* 433270 */   GIM_Try, /*On fail goto*//*Label 8619*/ GIMT_Encode4(433285), // Rule ID 2502 //
     /* 433275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433278 */     // (AArch64trn1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (TRN1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 433278 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i32),
     /* 433283 */     GIR_RootConstrainSelectedInstOperands,
     /* 433284 */     // GIR_Coverage, 2502,
     /* 433284 */     GIR_Done,
     /* 433285 */   // Label 8619: @433285
     /* 433285 */   GIM_Reject,
     /* 433286 */ // Label 8617: @433286
     /* 433286 */ GIM_Reject,
     /* 433287 */ // Label 8593: @433287
     /* 433287 */ GIM_Try, /*On fail goto*//*Label 8620*/ GIMT_Encode4(433320), // Rule ID 1870 //
     /* 433292 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 433298 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 433301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433305 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433309 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433313 */   // (AArch64trn1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (TRN1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 433313 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i8),
     /* 433318 */   GIR_RootConstrainSelectedInstOperands,
     /* 433319 */   // GIR_Coverage, 1870,
     /* 433319 */   GIR_Done,
     /* 433320 */ // Label 8620: @433320
     /* 433320 */ GIM_Reject,
     /* 433321 */ // Label 8594: @433321
     /* 433321 */ GIM_Try, /*On fail goto*//*Label 8621*/ GIMT_Encode4(433375),
     /* 433326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 433329 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 433332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433336 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433340 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433344 */   GIM_Try, /*On fail goto*//*Label 8622*/ GIMT_Encode4(433359), // Rule ID 1873 //
     /* 433349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433352 */     // (AArch64trn1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (TRN1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 433352 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i16),
     /* 433357 */     GIR_RootConstrainSelectedInstOperands,
     /* 433358 */     // GIR_Coverage, 1873,
     /* 433358 */     GIR_Done,
     /* 433359 */   // Label 8622: @433359
     /* 433359 */   GIM_Try, /*On fail goto*//*Label 8623*/ GIMT_Encode4(433374), // Rule ID 2500 //
     /* 433364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433367 */     // (AArch64trn1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (TRN1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 433367 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i16),
     /* 433372 */     GIR_RootConstrainSelectedInstOperands,
     /* 433373 */     // GIR_Coverage, 2500,
     /* 433373 */     GIR_Done,
     /* 433374 */   // Label 8623: @433374
     /* 433374 */   GIM_Reject,
     /* 433375 */ // Label 8621: @433375
     /* 433375 */ GIM_Reject,
     /* 433376 */ // Label 8595: @433376
     /* 433376 */ GIM_Try, /*On fail goto*//*Label 8624*/ GIMT_Encode4(433409), // Rule ID 1871 //
     /* 433381 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 433387 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 433390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433394 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433398 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433402 */   // (AArch64trn1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (TRN1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 433402 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v16i8),
     /* 433407 */   GIR_RootConstrainSelectedInstOperands,
     /* 433408 */   // GIR_Coverage, 1871,
     /* 433408 */   GIR_Done,
     /* 433409 */ // Label 8624: @433409
     /* 433409 */ GIM_Reject,
     /* 433410 */ // Label 8596: @433410
     /* 433410 */ GIM_Try, /*On fail goto*//*Label 8625*/ GIMT_Encode4(433435), // Rule ID 9082 //
     /* 433415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 433421 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 433424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 433428 */   // (AArch64trn1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (TRN1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 433428 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_D),
     /* 433433 */   GIR_RootConstrainSelectedInstOperands,
     /* 433434 */   // GIR_Coverage, 9082,
     /* 433434 */   GIR_Done,
     /* 433435 */ // Label 8625: @433435
     /* 433435 */ GIM_Reject,
     /* 433436 */ // Label 8597: @433436
     /* 433436 */ GIM_Try, /*On fail goto*//*Label 8626*/ GIMT_Encode4(433461), // Rule ID 9058 //
     /* 433441 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 433447 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 433450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 433454 */   // (AArch64trn1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 433454 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 433459 */   GIR_RootConstrainSelectedInstOperands,
     /* 433460 */   // GIR_Coverage, 9058,
     /* 433460 */   GIR_Done,
     /* 433461 */ // Label 8626: @433461
     /* 433461 */ GIM_Reject,
     /* 433462 */ // Label 8598: @433462
     /* 433462 */ GIM_Try, /*On fail goto*//*Label 8627*/ GIMT_Encode4(433487), // Rule ID 9059 //
     /* 433467 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 433473 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 433476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 433480 */   // (AArch64trn1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 433480 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 433485 */   GIR_RootConstrainSelectedInstOperands,
     /* 433486 */   // GIR_Coverage, 9059,
     /* 433486 */   GIR_Done,
     /* 433487 */ // Label 8627: @433487
     /* 433487 */ GIM_Reject,
     /* 433488 */ // Label 8599: @433488
     /* 433488 */ GIM_Try, /*On fail goto*//*Label 8628*/ GIMT_Encode4(433534),
     /* 433493 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 433496 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 433499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 433503 */   GIM_Try, /*On fail goto*//*Label 8629*/ GIMT_Encode4(433518), // Rule ID 9054 //
     /* 433508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433511 */     // (AArch64trn1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 433511 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 433516 */     GIR_RootConstrainSelectedInstOperands,
     /* 433517 */     // GIR_Coverage, 9054,
     /* 433517 */     GIR_Done,
     /* 433518 */   // Label 8629: @433518
     /* 433518 */   GIM_Try, /*On fail goto*//*Label 8630*/ GIMT_Encode4(433533), // Rule ID 9060 //
     /* 433523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433526 */     // (AArch64trn1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 433526 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 433531 */     GIR_RootConstrainSelectedInstOperands,
     /* 433532 */     // GIR_Coverage, 9060,
     /* 433532 */     GIR_Done,
     /* 433533 */   // Label 8630: @433533
     /* 433533 */   GIM_Reject,
     /* 433534 */ // Label 8628: @433534
     /* 433534 */ GIM_Reject,
     /* 433535 */ // Label 8600: @433535
     /* 433535 */ GIM_Try, /*On fail goto*//*Label 8631*/ GIMT_Encode4(433560), // Rule ID 9081 //
     /* 433540 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 433546 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 433549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 433553 */   // (AArch64trn1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (TRN1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 433553 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_S),
     /* 433558 */   GIR_RootConstrainSelectedInstOperands,
     /* 433559 */   // GIR_Coverage, 9081,
     /* 433559 */   GIR_Done,
     /* 433560 */ // Label 8631: @433560
     /* 433560 */ GIM_Reject,
     /* 433561 */ // Label 8601: @433561
     /* 433561 */ GIM_Try, /*On fail goto*//*Label 8632*/ GIMT_Encode4(433586), // Rule ID 9056 //
     /* 433566 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 433572 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 433575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 433579 */   // (AArch64trn1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 433579 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 433584 */   GIR_RootConstrainSelectedInstOperands,
     /* 433585 */   // GIR_Coverage, 9056,
     /* 433585 */   GIR_Done,
     /* 433586 */ // Label 8632: @433586
     /* 433586 */ GIM_Reject,
     /* 433587 */ // Label 8602: @433587
     /* 433587 */ GIM_Try, /*On fail goto*//*Label 8633*/ GIMT_Encode4(433633),
     /* 433592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 433595 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 433598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 433602 */   GIM_Try, /*On fail goto*//*Label 8634*/ GIMT_Encode4(433617), // Rule ID 9053 //
     /* 433607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433610 */     // (AArch64trn1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 433610 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 433615 */     GIR_RootConstrainSelectedInstOperands,
     /* 433616 */     // GIR_Coverage, 9053,
     /* 433616 */     GIR_Done,
     /* 433617 */   // Label 8634: @433617
     /* 433617 */   GIM_Try, /*On fail goto*//*Label 8635*/ GIMT_Encode4(433632), // Rule ID 9057 //
     /* 433622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433625 */     // (AArch64trn1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 433625 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 433630 */     GIR_RootConstrainSelectedInstOperands,
     /* 433631 */     // GIR_Coverage, 9057,
     /* 433631 */     GIR_Done,
     /* 433632 */   // Label 8635: @433632
     /* 433632 */   GIM_Reject,
     /* 433633 */ // Label 8633: @433633
     /* 433633 */ GIM_Reject,
     /* 433634 */ // Label 8603: @433634
     /* 433634 */ GIM_Try, /*On fail goto*//*Label 8636*/ GIMT_Encode4(433659), // Rule ID 9080 //
     /* 433639 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 433645 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 433648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 433652 */   // (AArch64trn1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (TRN1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 433652 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_H),
     /* 433657 */   GIR_RootConstrainSelectedInstOperands,
     /* 433658 */   // GIR_Coverage, 9080,
     /* 433658 */   GIR_Done,
     /* 433659 */ // Label 8636: @433659
     /* 433659 */ GIM_Reject,
     /* 433660 */ // Label 8604: @433660
     /* 433660 */ GIM_Try, /*On fail goto*//*Label 8637*/ GIMT_Encode4(433706),
     /* 433665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 433668 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 433671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 433675 */   GIM_Try, /*On fail goto*//*Label 8638*/ GIMT_Encode4(433690), // Rule ID 9052 //
     /* 433680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433683 */     // (AArch64trn1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 433683 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_H),
     /* 433688 */     GIR_RootConstrainSelectedInstOperands,
     /* 433689 */     // GIR_Coverage, 9052,
     /* 433689 */     GIR_Done,
     /* 433690 */   // Label 8638: @433690
     /* 433690 */   GIM_Try, /*On fail goto*//*Label 8639*/ GIMT_Encode4(433705), // Rule ID 9055 //
     /* 433695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433698 */     // (AArch64trn1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 433698 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_H),
     /* 433703 */     GIR_RootConstrainSelectedInstOperands,
     /* 433704 */     // GIR_Coverage, 9055,
     /* 433704 */     GIR_Done,
     /* 433705 */   // Label 8639: @433705
     /* 433705 */   GIM_Reject,
     /* 433706 */ // Label 8637: @433706
     /* 433706 */ GIM_Reject,
     /* 433707 */ // Label 8605: @433707
     /* 433707 */ GIM_Try, /*On fail goto*//*Label 8640*/ GIMT_Encode4(433732), // Rule ID 2414 //
     /* 433712 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 433718 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 433721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 433725 */   // (AArch64trn1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 433725 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_B),
     /* 433730 */   GIR_RootConstrainSelectedInstOperands,
     /* 433731 */   // GIR_Coverage, 2414,
     /* 433731 */   GIR_Done,
     /* 433732 */ // Label 8640: @433732
     /* 433732 */ GIM_Reject,
     /* 433733 */ // Label 8606: @433733
     /* 433733 */ GIM_Try, /*On fail goto*//*Label 8641*/ GIMT_Encode4(433758), // Rule ID 9051 //
     /* 433738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 433744 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 433747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 433751 */   // (AArch64trn1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 433751 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_B),
     /* 433756 */   GIR_RootConstrainSelectedInstOperands,
     /* 433757 */   // GIR_Coverage, 9051,
     /* 433757 */   GIR_Done,
     /* 433758 */ // Label 8641: @433758
     /* 433758 */ GIM_Reject,
     /* 433759 */ // Label 8607: @433759
     /* 433759 */ GIM_Reject,
     /* 433760 */ // Label 143: @433760
     /* 433760 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8660*/ GIMT_Encode4(434539),
     /* 433771 */ /*GILLT_v2s32*//*Label 8642*/ GIMT_Encode4(433847),
     /* 433775 */ /*GILLT_v2s64*//*Label 8643*/ GIMT_Encode4(433902),
     /* 433779 */ /*GILLT_v4s16*//*Label 8644*/ GIMT_Encode4(433957),
     /* 433783 */ /*GILLT_v4s32*//*Label 8645*/ GIMT_Encode4(434012),
     /* 433787 */ /*GILLT_v8s8*//*Label 8646*/ GIMT_Encode4(434067),
     /* 433791 */ /*GILLT_v8s16*//*Label 8647*/ GIMT_Encode4(434101),
     /* 433795 */ /*GILLT_v16s8*//*Label 8648*/ GIMT_Encode4(434156), GIMT_Encode4(0),
     /* 433803 */ /*GILLT_nxv2s1*//*Label 8649*/ GIMT_Encode4(434190),
     /* 433807 */ /*GILLT_nxv2s16*//*Label 8650*/ GIMT_Encode4(434216),
     /* 433811 */ /*GILLT_nxv2s32*//*Label 8651*/ GIMT_Encode4(434242),
     /* 433815 */ /*GILLT_nxv2s64*//*Label 8652*/ GIMT_Encode4(434268),
     /* 433819 */ /*GILLT_nxv4s1*//*Label 8653*/ GIMT_Encode4(434315),
     /* 433823 */ /*GILLT_nxv4s16*//*Label 8654*/ GIMT_Encode4(434341),
     /* 433827 */ /*GILLT_nxv4s32*//*Label 8655*/ GIMT_Encode4(434367),
     /* 433831 */ /*GILLT_nxv8s1*//*Label 8656*/ GIMT_Encode4(434414),
     /* 433835 */ /*GILLT_nxv8s16*//*Label 8657*/ GIMT_Encode4(434440),
     /* 433839 */ /*GILLT_nxv16s1*//*Label 8658*/ GIMT_Encode4(434487),
     /* 433843 */ /*GILLT_nxv16s8*//*Label 8659*/ GIMT_Encode4(434513),
     /* 433847 */ // Label 8642: @433847
     /* 433847 */ GIM_Try, /*On fail goto*//*Label 8661*/ GIMT_Encode4(433901),
     /* 433852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 433855 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 433858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433862 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433866 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433870 */   GIM_Try, /*On fail goto*//*Label 8662*/ GIMT_Encode4(433885), // Rule ID 1881 //
     /* 433875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433878 */     // (AArch64trn2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (TRN2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 433878 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i32),
     /* 433883 */     GIR_RootConstrainSelectedInstOperands,
     /* 433884 */     // GIR_Coverage, 1881,
     /* 433884 */     GIR_Done,
     /* 433885 */   // Label 8662: @433885
     /* 433885 */   GIM_Try, /*On fail goto*//*Label 8663*/ GIMT_Encode4(433900), // Rule ID 5509 //
     /* 433890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433893 */     // (AArch64trn2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (TRN2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 433893 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i32),
     /* 433898 */     GIR_RootConstrainSelectedInstOperands,
     /* 433899 */     // GIR_Coverage, 5509,
     /* 433899 */     GIR_Done,
     /* 433900 */   // Label 8663: @433900
     /* 433900 */   GIM_Reject,
     /* 433901 */ // Label 8661: @433901
     /* 433901 */ GIM_Reject,
     /* 433902 */ // Label 8643: @433902
     /* 433902 */ GIM_Try, /*On fail goto*//*Label 8664*/ GIMT_Encode4(433956),
     /* 433907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 433910 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 433913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433917 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433921 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433925 */   GIM_Try, /*On fail goto*//*Label 8665*/ GIMT_Encode4(433940), // Rule ID 1883 //
     /* 433930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433933 */     // (AArch64trn2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (TRN2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 433933 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i64),
     /* 433938 */     GIR_RootConstrainSelectedInstOperands,
     /* 433939 */     // GIR_Coverage, 1883,
     /* 433939 */     GIR_Done,
     /* 433940 */   // Label 8665: @433940
     /* 433940 */   GIM_Try, /*On fail goto*//*Label 8666*/ GIMT_Encode4(433955), // Rule ID 5511 //
     /* 433945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433948 */     // (AArch64trn2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (TRN2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 433948 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i64),
     /* 433953 */     GIR_RootConstrainSelectedInstOperands,
     /* 433954 */     // GIR_Coverage, 5511,
     /* 433954 */     GIR_Done,
     /* 433955 */   // Label 8666: @433955
     /* 433955 */   GIM_Reject,
     /* 433956 */ // Label 8664: @433956
     /* 433956 */ GIM_Reject,
     /* 433957 */ // Label 8644: @433957
     /* 433957 */ GIM_Try, /*On fail goto*//*Label 8667*/ GIMT_Encode4(434011),
     /* 433962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 433965 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 433968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433976 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433980 */   GIM_Try, /*On fail goto*//*Label 8668*/ GIMT_Encode4(433995), // Rule ID 1879 //
     /* 433985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433988 */     // (AArch64trn2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (TRN2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 433988 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i16),
     /* 433993 */     GIR_RootConstrainSelectedInstOperands,
     /* 433994 */     // GIR_Coverage, 1879,
     /* 433994 */     GIR_Done,
     /* 433995 */   // Label 8668: @433995
     /* 433995 */   GIM_Try, /*On fail goto*//*Label 8669*/ GIMT_Encode4(434010), // Rule ID 5507 //
     /* 434000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434003 */     // (AArch64trn2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (TRN2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 434003 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i16),
     /* 434008 */     GIR_RootConstrainSelectedInstOperands,
     /* 434009 */     // GIR_Coverage, 5507,
     /* 434009 */     GIR_Done,
     /* 434010 */   // Label 8669: @434010
     /* 434010 */   GIM_Reject,
     /* 434011 */ // Label 8667: @434011
     /* 434011 */ GIM_Reject,
     /* 434012 */ // Label 8645: @434012
     /* 434012 */ GIM_Try, /*On fail goto*//*Label 8670*/ GIMT_Encode4(434066),
     /* 434017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 434020 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 434023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434027 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434031 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434035 */   GIM_Try, /*On fail goto*//*Label 8671*/ GIMT_Encode4(434050), // Rule ID 1882 //
     /* 434040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434043 */     // (AArch64trn2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (TRN2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 434043 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i32),
     /* 434048 */     GIR_RootConstrainSelectedInstOperands,
     /* 434049 */     // GIR_Coverage, 1882,
     /* 434049 */     GIR_Done,
     /* 434050 */   // Label 8671: @434050
     /* 434050 */   GIM_Try, /*On fail goto*//*Label 8672*/ GIMT_Encode4(434065), // Rule ID 5510 //
     /* 434055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434058 */     // (AArch64trn2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (TRN2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 434058 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i32),
     /* 434063 */     GIR_RootConstrainSelectedInstOperands,
     /* 434064 */     // GIR_Coverage, 5510,
     /* 434064 */     GIR_Done,
     /* 434065 */   // Label 8672: @434065
     /* 434065 */   GIM_Reject,
     /* 434066 */ // Label 8670: @434066
     /* 434066 */ GIM_Reject,
     /* 434067 */ // Label 8646: @434067
     /* 434067 */ GIM_Try, /*On fail goto*//*Label 8673*/ GIMT_Encode4(434100), // Rule ID 1877 //
     /* 434072 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 434078 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 434081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434085 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434089 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434093 */   // (AArch64trn2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (TRN2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 434093 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i8),
     /* 434098 */   GIR_RootConstrainSelectedInstOperands,
     /* 434099 */   // GIR_Coverage, 1877,
     /* 434099 */   GIR_Done,
     /* 434100 */ // Label 8673: @434100
     /* 434100 */ GIM_Reject,
     /* 434101 */ // Label 8647: @434101
     /* 434101 */ GIM_Try, /*On fail goto*//*Label 8674*/ GIMT_Encode4(434155),
     /* 434106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 434109 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 434112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434116 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434120 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434124 */   GIM_Try, /*On fail goto*//*Label 8675*/ GIMT_Encode4(434139), // Rule ID 1880 //
     /* 434129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434132 */     // (AArch64trn2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (TRN2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 434132 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i16),
     /* 434137 */     GIR_RootConstrainSelectedInstOperands,
     /* 434138 */     // GIR_Coverage, 1880,
     /* 434138 */     GIR_Done,
     /* 434139 */   // Label 8675: @434139
     /* 434139 */   GIM_Try, /*On fail goto*//*Label 8676*/ GIMT_Encode4(434154), // Rule ID 5508 //
     /* 434144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434147 */     // (AArch64trn2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (TRN2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 434147 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i16),
     /* 434152 */     GIR_RootConstrainSelectedInstOperands,
     /* 434153 */     // GIR_Coverage, 5508,
     /* 434153 */     GIR_Done,
     /* 434154 */   // Label 8676: @434154
     /* 434154 */   GIM_Reject,
     /* 434155 */ // Label 8674: @434155
     /* 434155 */ GIM_Reject,
     /* 434156 */ // Label 8648: @434156
     /* 434156 */ GIM_Try, /*On fail goto*//*Label 8677*/ GIMT_Encode4(434189), // Rule ID 1878 //
     /* 434161 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434164 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 434167 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 434170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434178 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434182 */   // (AArch64trn2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (TRN2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 434182 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v16i8),
     /* 434187 */   GIR_RootConstrainSelectedInstOperands,
     /* 434188 */   // GIR_Coverage, 1878,
     /* 434188 */   GIR_Done,
     /* 434189 */ // Label 8677: @434189
     /* 434189 */ GIM_Reject,
     /* 434190 */ // Label 8649: @434190
     /* 434190 */ GIM_Try, /*On fail goto*//*Label 8678*/ GIMT_Encode4(434215), // Rule ID 9085 //
     /* 434195 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 434198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 434201 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 434204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 434208 */   // (AArch64trn2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (TRN2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 434208 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_D),
     /* 434213 */   GIR_RootConstrainSelectedInstOperands,
     /* 434214 */   // GIR_Coverage, 9085,
     /* 434214 */   GIR_Done,
     /* 434215 */ // Label 8678: @434215
     /* 434215 */ GIM_Reject,
     /* 434216 */ // Label 8650: @434216
     /* 434216 */ GIM_Try, /*On fail goto*//*Label 8679*/ GIMT_Encode4(434241), // Rule ID 9068 //
     /* 434221 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 434224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 434227 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 434230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 434234 */   // (AArch64trn2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 434234 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 434239 */   GIR_RootConstrainSelectedInstOperands,
     /* 434240 */   // GIR_Coverage, 9068,
     /* 434240 */   GIR_Done,
     /* 434241 */ // Label 8679: @434241
     /* 434241 */ GIM_Reject,
     /* 434242 */ // Label 8651: @434242
     /* 434242 */ GIM_Try, /*On fail goto*//*Label 8680*/ GIMT_Encode4(434267), // Rule ID 9069 //
     /* 434247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 434250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 434253 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 434256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 434260 */   // (AArch64trn2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 434260 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 434265 */   GIR_RootConstrainSelectedInstOperands,
     /* 434266 */   // GIR_Coverage, 9069,
     /* 434266 */   GIR_Done,
     /* 434267 */ // Label 8680: @434267
     /* 434267 */ GIM_Reject,
     /* 434268 */ // Label 8652: @434268
     /* 434268 */ GIM_Try, /*On fail goto*//*Label 8681*/ GIMT_Encode4(434314),
     /* 434273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 434276 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 434279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 434283 */   GIM_Try, /*On fail goto*//*Label 8682*/ GIMT_Encode4(434298), // Rule ID 9064 //
     /* 434288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 434291 */     // (AArch64trn2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 434291 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 434296 */     GIR_RootConstrainSelectedInstOperands,
     /* 434297 */     // GIR_Coverage, 9064,
     /* 434297 */     GIR_Done,
     /* 434298 */   // Label 8682: @434298
     /* 434298 */   GIM_Try, /*On fail goto*//*Label 8683*/ GIMT_Encode4(434313), // Rule ID 9070 //
     /* 434303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 434306 */     // (AArch64trn2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 434306 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 434311 */     GIR_RootConstrainSelectedInstOperands,
     /* 434312 */     // GIR_Coverage, 9070,
     /* 434312 */     GIR_Done,
     /* 434313 */   // Label 8683: @434313
     /* 434313 */   GIM_Reject,
     /* 434314 */ // Label 8681: @434314
     /* 434314 */ GIM_Reject,
     /* 434315 */ // Label 8653: @434315
     /* 434315 */ GIM_Try, /*On fail goto*//*Label 8684*/ GIMT_Encode4(434340), // Rule ID 9084 //
     /* 434320 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 434323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 434326 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 434329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 434333 */   // (AArch64trn2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (TRN2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 434333 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_S),
     /* 434338 */   GIR_RootConstrainSelectedInstOperands,
     /* 434339 */   // GIR_Coverage, 9084,
     /* 434339 */   GIR_Done,
     /* 434340 */ // Label 8684: @434340
     /* 434340 */ GIM_Reject,
     /* 434341 */ // Label 8654: @434341
     /* 434341 */ GIM_Try, /*On fail goto*//*Label 8685*/ GIMT_Encode4(434366), // Rule ID 9066 //
     /* 434346 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 434349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 434352 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 434355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 434359 */   // (AArch64trn2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 434359 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 434364 */   GIR_RootConstrainSelectedInstOperands,
     /* 434365 */   // GIR_Coverage, 9066,
     /* 434365 */   GIR_Done,
     /* 434366 */ // Label 8685: @434366
     /* 434366 */ GIM_Reject,
     /* 434367 */ // Label 8655: @434367
     /* 434367 */ GIM_Try, /*On fail goto*//*Label 8686*/ GIMT_Encode4(434413),
     /* 434372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 434375 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 434378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 434382 */   GIM_Try, /*On fail goto*//*Label 8687*/ GIMT_Encode4(434397), // Rule ID 9063 //
     /* 434387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 434390 */     // (AArch64trn2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 434390 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 434395 */     GIR_RootConstrainSelectedInstOperands,
     /* 434396 */     // GIR_Coverage, 9063,
     /* 434396 */     GIR_Done,
     /* 434397 */   // Label 8687: @434397
     /* 434397 */   GIM_Try, /*On fail goto*//*Label 8688*/ GIMT_Encode4(434412), // Rule ID 9067 //
     /* 434402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 434405 */     // (AArch64trn2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 434405 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 434410 */     GIR_RootConstrainSelectedInstOperands,
     /* 434411 */     // GIR_Coverage, 9067,
     /* 434411 */     GIR_Done,
     /* 434412 */   // Label 8688: @434412
     /* 434412 */   GIM_Reject,
     /* 434413 */ // Label 8686: @434413
     /* 434413 */ GIM_Reject,
     /* 434414 */ // Label 8656: @434414
     /* 434414 */ GIM_Try, /*On fail goto*//*Label 8689*/ GIMT_Encode4(434439), // Rule ID 9083 //
     /* 434419 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 434422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 434425 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 434428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 434432 */   // (AArch64trn2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (TRN2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 434432 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_H),
     /* 434437 */   GIR_RootConstrainSelectedInstOperands,
     /* 434438 */   // GIR_Coverage, 9083,
     /* 434438 */   GIR_Done,
     /* 434439 */ // Label 8689: @434439
     /* 434439 */ GIM_Reject,
     /* 434440 */ // Label 8657: @434440
     /* 434440 */ GIM_Try, /*On fail goto*//*Label 8690*/ GIMT_Encode4(434486),
     /* 434445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 434448 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 434451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 434455 */   GIM_Try, /*On fail goto*//*Label 8691*/ GIMT_Encode4(434470), // Rule ID 9062 //
     /* 434460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 434463 */     // (AArch64trn2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 434463 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_H),
     /* 434468 */     GIR_RootConstrainSelectedInstOperands,
     /* 434469 */     // GIR_Coverage, 9062,
     /* 434469 */     GIR_Done,
     /* 434470 */   // Label 8691: @434470
     /* 434470 */   GIM_Try, /*On fail goto*//*Label 8692*/ GIMT_Encode4(434485), // Rule ID 9065 //
     /* 434475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 434478 */     // (AArch64trn2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 434478 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_H),
     /* 434483 */     GIR_RootConstrainSelectedInstOperands,
     /* 434484 */     // GIR_Coverage, 9065,
     /* 434484 */     GIR_Done,
     /* 434485 */   // Label 8692: @434485
     /* 434485 */   GIM_Reject,
     /* 434486 */ // Label 8690: @434486
     /* 434486 */ GIM_Reject,
     /* 434487 */ // Label 8658: @434487
     /* 434487 */ GIM_Try, /*On fail goto*//*Label 8693*/ GIMT_Encode4(434512), // Rule ID 2418 //
     /* 434492 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 434495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 434498 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 434501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 434505 */   // (AArch64trn2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 434505 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_B),
     /* 434510 */   GIR_RootConstrainSelectedInstOperands,
     /* 434511 */   // GIR_Coverage, 2418,
     /* 434511 */   GIR_Done,
     /* 434512 */ // Label 8693: @434512
     /* 434512 */ GIM_Reject,
     /* 434513 */ // Label 8659: @434513
     /* 434513 */ GIM_Try, /*On fail goto*//*Label 8694*/ GIMT_Encode4(434538), // Rule ID 9061 //
     /* 434518 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 434521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 434524 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 434527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 434531 */   // (AArch64trn2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 434531 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_B),
     /* 434536 */   GIR_RootConstrainSelectedInstOperands,
     /* 434537 */   // GIR_Coverage, 9061,
     /* 434537 */   GIR_Done,
     /* 434538 */ // Label 8694: @434538
     /* 434538 */ GIM_Reject,
     /* 434539 */ // Label 8660: @434539
     /* 434539 */ GIM_Reject,
     /* 434540 */ // Label 144: @434540
     /* 434540 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8701*/ GIMT_Encode4(434745),
     /* 434551 */ /*GILLT_s64*//*Label 8695*/ GIMT_Encode4(434583), GIMT_Encode4(0),
     /* 434559 */ /*GILLT_v2s32*//*Label 8696*/ GIMT_Encode4(434610),
     /* 434563 */ /*GILLT_v2s64*//*Label 8697*/ GIMT_Encode4(434637),
     /* 434567 */ /*GILLT_v4s16*//*Label 8698*/ GIMT_Encode4(434664),
     /* 434571 */ /*GILLT_v4s32*//*Label 8699*/ GIMT_Encode4(434691), GIMT_Encode4(0),
     /* 434579 */ /*GILLT_v8s16*//*Label 8700*/ GIMT_Encode4(434718),
     /* 434583 */ // Label 8695: @434583
     /* 434583 */ GIM_Try, /*On fail goto*//*Label 8702*/ GIMT_Encode4(434609), // Rule ID 1069 //
     /* 434588 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 434594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434598 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434602 */   // (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)  =>  (UADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 434602 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 434607 */   GIR_RootConstrainSelectedInstOperands,
     /* 434608 */   // GIR_Coverage, 1069,
     /* 434608 */   GIR_Done,
     /* 434609 */ // Label 8702: @434609
     /* 434609 */ GIM_Reject,
     /* 434610 */ // Label 8696: @434610
     /* 434610 */ GIM_Try, /*On fail goto*//*Label 8703*/ GIMT_Encode4(434636), // Rule ID 1065 //
     /* 434615 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 434621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434625 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434629 */   // (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)  =>  (UADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 434629 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i16_v2i32),
     /* 434634 */   GIR_RootConstrainSelectedInstOperands,
     /* 434635 */   // GIR_Coverage, 1065,
     /* 434635 */   GIR_Done,
     /* 434636 */ // Label 8703: @434636
     /* 434636 */ GIM_Reject,
     /* 434637 */ // Label 8697: @434637
     /* 434637 */ GIM_Try, /*On fail goto*//*Label 8704*/ GIMT_Encode4(434663), // Rule ID 1071 //
     /* 434642 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 434648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434652 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434656 */   // (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (UADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 434656 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i32_v2i64),
     /* 434661 */   GIR_RootConstrainSelectedInstOperands,
     /* 434662 */   // GIR_Coverage, 1071,
     /* 434662 */   GIR_Done,
     /* 434663 */ // Label 8704: @434663
     /* 434663 */ GIM_Reject,
     /* 434664 */ // Label 8698: @434664
     /* 434664 */ GIM_Try, /*On fail goto*//*Label 8705*/ GIMT_Encode4(434690), // Rule ID 1061 //
     /* 434669 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434672 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 434675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434679 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434683 */   // (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)  =>  (UADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 434683 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i8_v4i16),
     /* 434688 */   GIR_RootConstrainSelectedInstOperands,
     /* 434689 */   // GIR_Coverage, 1061,
     /* 434689 */   GIR_Done,
     /* 434690 */ // Label 8705: @434690
     /* 434690 */ GIM_Reject,
     /* 434691 */ // Label 8699: @434691
     /* 434691 */ GIM_Try, /*On fail goto*//*Label 8706*/ GIMT_Encode4(434717), // Rule ID 1067 //
     /* 434696 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 434702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434706 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434710 */   // (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (UADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 434710 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i16_v4i32),
     /* 434715 */   GIR_RootConstrainSelectedInstOperands,
     /* 434716 */   // GIR_Coverage, 1067,
     /* 434716 */   GIR_Done,
     /* 434717 */ // Label 8706: @434717
     /* 434717 */ GIM_Reject,
     /* 434718 */ // Label 8700: @434718
     /* 434718 */ GIM_Try, /*On fail goto*//*Label 8707*/ GIMT_Encode4(434744), // Rule ID 1063 //
     /* 434723 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 434729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434733 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434737 */   // (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)  =>  (UADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 434737 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv16i8_v8i16),
     /* 434742 */   GIR_RootConstrainSelectedInstOperands,
     /* 434743 */   // GIR_Coverage, 1063,
     /* 434743 */   GIR_Done,
     /* 434744 */ // Label 8707: @434744
     /* 434744 */ GIM_Reject,
     /* 434745 */ // Label 8701: @434745
     /* 434745 */ GIM_Reject,
     /* 434746 */ // Label 145: @434746
     /* 434746 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(9), /*)*//*default:*//*Label 8710*/ GIMT_Encode4(435612),
     /* 434757 */ /*GILLT_v2s64*//*Label 8708*/ GIMT_Encode4(434769), GIMT_Encode4(0),
     /* 434765 */ /*GILLT_v4s32*//*Label 8709*/ GIMT_Encode4(435063),
     /* 434769 */ // Label 8708: @434769
     /* 434769 */ GIM_Try, /*On fail goto*//*Label 8711*/ GIMT_Encode4(434851), // Rule ID 5922 //
     /* 434774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 434777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434781 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 434785 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 434789 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 434792 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 434797 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 434801 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434806 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 434808 */   // (AArch64uaddlv:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v4i32] } 735:{ *:[iPTR] }, V128:{ *:[v8i16] }:$op))  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$op), ssub:{ *:[i32] })
     /* 434808 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 434811 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 434815 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 434820 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 434824 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 434826 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 434829 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 434831 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434834 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 434837 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 434840 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434845 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 434850 */   // GIR_Coverage, 5922,
     /* 434850 */   GIR_EraseRootFromParent_Done,
     /* 434851 */ // Label 8711: @434851
     /* 434851 */ GIM_Try, /*On fail goto*//*Label 8712*/ GIMT_Encode4(434925), // Rule ID 5921 //
     /* 434856 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 434859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434863 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 434867 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 434871 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 434875 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434880 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 434882 */   // (AArch64uaddlv:{ *:[v2i64] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$op))  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$op), ssub:{ *:[i32] })
     /* 434882 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 434885 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 434889 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 434894 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 434898 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 434900 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 434903 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 434905 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434908 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 434911 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 434914 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434919 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 434924 */   // GIR_Coverage, 5921,
     /* 434924 */   GIR_EraseRootFromParent_Done,
     /* 434925 */ // Label 8712: @434925
     /* 434925 */ GIM_Try, /*On fail goto*//*Label 8713*/ GIMT_Encode4(434984), // Rule ID 5931 //
     /* 434930 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 434933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434937 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434941 */   // (AArch64uaddlv:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 434941 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 434944 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 434948 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 434953 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 434957 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 434959 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 434962 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 434964 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434967 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 434970 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 434973 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434978 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434983 */   // GIR_Coverage, 5931,
     /* 434983 */   GIR_EraseRootFromParent_Done,
     /* 434984 */ // Label 8713: @434984
     /* 434984 */ GIM_Try, /*On fail goto*//*Label 8714*/ GIMT_Encode4(435062), // Rule ID 6059 //
     /* 434989 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 434992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434996 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435000 */   // (AArch64uaddlv:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (UADDLPv2i32_v1i64:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /* 435000 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 435003 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 435007 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 435012 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 435016 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 435018 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 435021 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 435025 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 435030 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 435032 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 435035 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 435037 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 435040 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 435043 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 435046 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435051 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435056 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435061 */   // GIR_Coverage, 6059,
     /* 435061 */   GIR_EraseRootFromParent_Done,
     /* 435062 */ // Label 8714: @435062
     /* 435062 */ GIM_Reject,
     /* 435063 */ // Label 8709: @435063
     /* 435063 */ GIM_Try, /*On fail goto*//*Label 8715*/ GIMT_Encode4(435145), // Rule ID 5924 //
     /* 435068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 435071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435075 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 435079 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 435083 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 435086 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 435091 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 435095 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435100 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 435102 */   // (AArch64uaddlv:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v8i16] } 735:{ *:[iPTR] }, V128:{ *:[v16i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$op), hsub:{ *:[i32] })
     /* 435102 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 435105 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 435109 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 435114 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 435118 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 435120 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 435123 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 435125 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435128 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 435131 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 435134 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435139 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 435144 */   // GIR_Coverage, 5924,
     /* 435144 */   GIR_EraseRootFromParent_Done,
     /* 435145 */ // Label 8715: @435145
     /* 435145 */ GIM_Try, /*On fail goto*//*Label 8716*/ GIMT_Encode4(435227), // Rule ID 5926 //
     /* 435150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 435153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435157 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 435161 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 435165 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 435168 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 435173 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 435177 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435182 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 435184 */   // (AArch64uaddlv:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 735:{ *:[iPTR] }, V64:{ *:[v8i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$op), hsub:{ *:[i32] })
     /* 435184 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 435187 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 435191 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 435196 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 435200 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 435202 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 435205 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 435207 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435210 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 435213 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 435216 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435221 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 435226 */   // GIR_Coverage, 5926,
     /* 435226 */   GIR_EraseRootFromParent_Done,
     /* 435227 */ // Label 8716: @435227
     /* 435227 */ GIM_Try, /*On fail goto*//*Label 8717*/ GIMT_Encode4(435301), // Rule ID 5923 //
     /* 435232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 435235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435239 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 435243 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 435247 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 435251 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435256 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 435258 */   // (AArch64uaddlv:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$op), hsub:{ *:[i32] })
     /* 435258 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 435261 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 435265 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 435270 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 435274 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 435276 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 435279 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 435281 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435284 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 435287 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 435290 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435295 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 435300 */   // GIR_Coverage, 5923,
     /* 435300 */   GIR_EraseRootFromParent_Done,
     /* 435301 */ // Label 8717: @435301
     /* 435301 */ GIM_Try, /*On fail goto*//*Label 8718*/ GIMT_Encode4(435375), // Rule ID 5925 //
     /* 435306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 435309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435313 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 435317 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 435321 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 435325 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435330 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 435332 */   // (AArch64uaddlv:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$op), hsub:{ *:[i32] })
     /* 435332 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 435335 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 435339 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 435344 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 435348 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 435350 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 435353 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 435355 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435358 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 435361 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 435364 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435369 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 435374 */   // GIR_Coverage, 5925,
     /* 435374 */   GIR_EraseRootFromParent_Done,
     /* 435375 */ // Label 8718: @435375
     /* 435375 */ GIM_Try, /*On fail goto*//*Label 8719*/ GIMT_Encode4(435434), // Rule ID 5927 //
     /* 435380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 435383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435387 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435391 */   // (AArch64uaddlv:{ *:[v4i32] } V64:{ *:[v8i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn), hsub:{ *:[i32] })
     /* 435391 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 435394 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 435398 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 435403 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 435407 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 435409 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 435412 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 435414 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435417 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 435420 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 435423 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435428 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 435433 */   // GIR_Coverage, 5927,
     /* 435433 */   GIR_EraseRootFromParent_Done,
     /* 435434 */ // Label 8719: @435434
     /* 435434 */ GIM_Try, /*On fail goto*//*Label 8720*/ GIMT_Encode4(435493), // Rule ID 5928 //
     /* 435439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 435442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435446 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435450 */   // (AArch64uaddlv:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn), ssub:{ *:[i32] })
     /* 435450 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 435453 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 435457 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 435462 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 435466 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 435468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 435471 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 435473 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435476 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 435479 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 435482 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435487 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 435492 */   // GIR_Coverage, 5928,
     /* 435492 */   GIR_EraseRootFromParent_Done,
     /* 435493 */ // Label 8720: @435493
     /* 435493 */ GIM_Try, /*On fail goto*//*Label 8721*/ GIMT_Encode4(435552), // Rule ID 5929 //
     /* 435498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 435501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435505 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435509 */   // (AArch64uaddlv:{ *:[v4i32] } V128:{ *:[v16i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn), hsub:{ *:[i32] })
     /* 435509 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 435512 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 435516 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 435521 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 435525 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 435527 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 435530 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 435532 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435535 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 435538 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 435541 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435546 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 435551 */   // GIR_Coverage, 5929,
     /* 435551 */   GIR_EraseRootFromParent_Done,
     /* 435552 */ // Label 8721: @435552
     /* 435552 */ GIM_Try, /*On fail goto*//*Label 8722*/ GIMT_Encode4(435611), // Rule ID 5930 //
     /* 435557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 435560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435564 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435568 */   // (AArch64uaddlv:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn), ssub:{ *:[i32] })
     /* 435568 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 435571 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 435575 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 435580 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 435584 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 435586 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 435589 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 435591 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435594 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 435597 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 435600 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435605 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 435610 */   // GIR_Coverage, 5930,
     /* 435610 */   GIR_EraseRootFromParent_Done,
     /* 435611 */ // Label 8722: @435611
     /* 435611 */ GIM_Reject,
     /* 435612 */ // Label 8710: @435612
     /* 435612 */ GIM_Reject,
     /* 435613 */ // Label 146: @435613
     /* 435613 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(20), /*)*//*default:*//*Label 8727*/ GIMT_Encode4(435982),
     /* 435624 */ /*GILLT_v2s32*//*Label 8723*/ GIMT_Encode4(435684), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 435636 */ /*GILLT_v4s32*//*Label 8724*/ GIMT_Encode4(435804), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 435668 */ /*GILLT_nxv2s64*//*Label 8725*/ GIMT_Encode4(435924), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 435680 */ /*GILLT_nxv4s32*//*Label 8726*/ GIMT_Encode4(435953),
     /* 435684 */ // Label 8723: @435684
     /* 435684 */ GIM_Try, /*On fail goto*//*Label 8728*/ GIMT_Encode4(435803),
     /* 435689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 435692 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 435695 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 435698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435702 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435706 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435710 */   GIM_Try, /*On fail goto*//*Label 8729*/ GIMT_Encode4(435783), // Rule ID 28 //
     /* 435715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 435718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 435722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 435726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 435730 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 435734 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 435738 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 435742 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 435746 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435751 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 435755 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 435759 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 435763 */     // MIs[3] Operand 1
     /* 435763 */     // No operand predicates
     /* 435763 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 435765 */     // (AArch64udot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, (bitconvert:{ *:[v8i8] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UDOTlanev8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 435765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOTlanev8i8),
     /* 435768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 435770 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 435772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 435774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 435778 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 435781 */     GIR_RootConstrainSelectedInstOperands,
     /* 435782 */     // GIR_Coverage, 28,
     /* 435782 */     GIR_EraseRootFromParent_Done,
     /* 435783 */   // Label 8729: @435783
     /* 435783 */   GIM_Try, /*On fail goto*//*Label 8730*/ GIMT_Encode4(435802), // Rule ID 24 //
     /* 435788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 435791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435795 */     // (AArch64udot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UDOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 435795 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOTv8i8),
     /* 435800 */     GIR_RootConstrainSelectedInstOperands,
     /* 435801 */     // GIR_Coverage, 24,
     /* 435801 */     GIR_Done,
     /* 435802 */   // Label 8730: @435802
     /* 435802 */   GIM_Reject,
     /* 435803 */ // Label 8728: @435803
     /* 435803 */ GIM_Reject,
     /* 435804 */ // Label 8724: @435804
     /* 435804 */ GIM_Try, /*On fail goto*//*Label 8731*/ GIMT_Encode4(435923),
     /* 435809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 435812 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 435815 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 435818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435822 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435826 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435830 */   GIM_Try, /*On fail goto*//*Label 8732*/ GIMT_Encode4(435903), // Rule ID 29 //
     /* 435835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 435838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 435842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 435846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 435850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 435854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 435858 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 435862 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 435866 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435871 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 435875 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 435879 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 435883 */     // MIs[3] Operand 1
     /* 435883 */     // No operand predicates
     /* 435883 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 435885 */     // (AArch64udot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, (bitconvert:{ *:[v16i8] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UDOTlanev16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 435885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOTlanev16i8),
     /* 435888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 435890 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 435892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 435894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 435898 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 435901 */     GIR_RootConstrainSelectedInstOperands,
     /* 435902 */     // GIR_Coverage, 29,
     /* 435902 */     GIR_EraseRootFromParent_Done,
     /* 435903 */   // Label 8732: @435903
     /* 435903 */   GIM_Try, /*On fail goto*//*Label 8733*/ GIMT_Encode4(435922), // Rule ID 25 //
     /* 435908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 435911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435915 */     // (AArch64udot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UDOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 435915 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOTv16i8),
     /* 435920 */     GIR_RootConstrainSelectedInstOperands,
     /* 435921 */     // GIR_Coverage, 25,
     /* 435921 */     GIR_Done,
     /* 435922 */   // Label 8733: @435922
     /* 435922 */   GIM_Reject,
     /* 435923 */ // Label 8731: @435923
     /* 435923 */ GIM_Reject,
     /* 435924 */ // Label 8725: @435924
     /* 435924 */ GIM_Try, /*On fail goto*//*Label 8734*/ GIMT_Encode4(435952), // Rule ID 7743 //
     /* 435929 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 435935 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 435938 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 435941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 435945 */   // (AArch64udot:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UDOT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 435945 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_D),
     /* 435950 */   GIR_RootConstrainSelectedInstOperands,
     /* 435951 */   // GIR_Coverage, 7743,
     /* 435951 */   GIR_Done,
     /* 435952 */ // Label 8734: @435952
     /* 435952 */ GIM_Reject,
     /* 435953 */ // Label 8726: @435953
     /* 435953 */ GIM_Try, /*On fail goto*//*Label 8735*/ GIMT_Encode4(435981), // Rule ID 7742 //
     /* 435958 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 435964 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 435967 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 435970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 435974 */   // (AArch64udot:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UDOT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 435974 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_S),
     /* 435979 */   GIR_RootConstrainSelectedInstOperands,
     /* 435980 */   // GIR_Coverage, 7742,
     /* 435980 */   GIR_Done,
     /* 435981 */ // Label 8735: @435981
     /* 435981 */ GIM_Reject,
     /* 435982 */ // Label 8727: @435982
     /* 435982 */ GIM_Reject,
     /* 435983 */ // Label 147: @435983
     /* 435983 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8739*/ GIMT_Encode4(436099),
     /* 435994 */ /*GILLT_s16*//*Label 8736*/ GIMT_Encode4(436006),
     /* 435998 */ /*GILLT_s32*//*Label 8737*/ GIMT_Encode4(436037),
     /* 436002 */ /*GILLT_s64*//*Label 8738*/ GIMT_Encode4(436068),
     /* 436006 */ // Label 8736: @436006
     /* 436006 */ GIM_Try, /*On fail goto*//*Label 8740*/ GIMT_Encode4(436036), // Rule ID 1669 //
     /* 436011 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 436014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 436017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 436021 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 436025 */   // (AArch64uitof:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (UCVTFv1i16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 436025 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 436030 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 436034 */   GIR_RootConstrainSelectedInstOperands,
     /* 436035 */   // GIR_Coverage, 1669,
     /* 436035 */   GIR_Done,
     /* 436036 */ // Label 8740: @436036
     /* 436036 */ GIM_Reject,
     /* 436037 */ // Label 8737: @436037
     /* 436037 */ GIM_Try, /*On fail goto*//*Label 8741*/ GIMT_Encode4(436067), // Rule ID 1668 //
     /* 436042 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 436045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 436048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 436052 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 436056 */   // (AArch64uitof:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (UCVTFv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 436056 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 436061 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 436065 */   GIR_RootConstrainSelectedInstOperands,
     /* 436066 */   // GIR_Coverage, 1668,
     /* 436066 */   GIR_Done,
     /* 436067 */ // Label 8741: @436067
     /* 436067 */ GIM_Reject,
     /* 436068 */ // Label 8738: @436068
     /* 436068 */ GIM_Try, /*On fail goto*//*Label 8742*/ GIMT_Encode4(436098), // Rule ID 1667 //
     /* 436073 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 436076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 436079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436083 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436087 */   // (AArch64uitof:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (UCVTFv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 436087 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 436092 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 436096 */   GIR_RootConstrainSelectedInstOperands,
     /* 436097 */   // GIR_Coverage, 1667,
     /* 436097 */   GIR_Done,
     /* 436098 */ // Label 8742: @436098
     /* 436098 */ GIM_Reject,
     /* 436099 */ // Label 8739: @436099
     /* 436099 */ GIM_Reject,
     /* 436100 */ // Label 148: @436100
     /* 436100 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(11), /*)*//*default:*//*Label 8746*/ GIMT_Encode4(437332),
     /* 436111 */ /*GILLT_v2s64*//*Label 8743*/ GIMT_Encode4(436131), GIMT_Encode4(0),
     /* 436119 */ /*GILLT_v4s32*//*Label 8744*/ GIMT_Encode4(436692), GIMT_Encode4(0),
     /* 436127 */ /*GILLT_v8s16*//*Label 8745*/ GIMT_Encode4(437253),
     /* 436131 */ // Label 8743: @436131
     /* 436131 */ GIM_Try, /*On fail goto*//*Label 8747*/ GIMT_Encode4(436691),
     /* 436136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 436139 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 436142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436146 */   GIM_Try, /*On fail goto*//*Label 8748*/ GIMT_Encode4(436238), // Rule ID 2106 //
     /* 436151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 436158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 436162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 436166 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 436170 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 436174 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 436178 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 436182 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436187 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 436191 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 436195 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 436199 */     // MIs[3] Operand 1
     /* 436199 */     // No operand predicates
     /* 436199 */     // MIs[1] Operand 2
     /* 436199 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 436210 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 436212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 436219 */     // (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (UMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 436219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_indexed),
     /* 436222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 436229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 436233 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 436236 */     GIR_RootConstrainSelectedInstOperands,
     /* 436237 */     // GIR_Coverage, 2106,
     /* 436237 */     GIR_EraseRootFromParent_Done,
     /* 436238 */   // Label 8748: @436238
     /* 436238 */   GIM_Try, /*On fail goto*//*Label 8749*/ GIMT_Encode4(436330), // Rule ID 13682 //
     /* 436243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 436250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 436254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 436258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 436262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 436266 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 436270 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 436274 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436279 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 436283 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 436287 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 436291 */     // MIs[3] Operand 1
     /* 436291 */     // No operand predicates
     /* 436291 */     // MIs[1] Operand 2
     /* 436291 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 436302 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 436304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 436311 */     // (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (UMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 436311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_indexed),
     /* 436314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 436321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 436325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 436328 */     GIR_RootConstrainSelectedInstOperands,
     /* 436329 */     // GIR_Coverage, 13682,
     /* 436329 */     GIR_EraseRootFromParent_Done,
     /* 436330 */   // Label 8749: @436330
     /* 436330 */   GIM_Try, /*On fail goto*//*Label 8750*/ GIMT_Encode4(436416), // Rule ID 13680 //
     /* 436335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 436342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 436346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 436350 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 436354 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 436358 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 436362 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 436366 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436371 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 436375 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 436379 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 436383 */     // MIs[3] Operand 1
     /* 436383 */     // No operand predicates
     /* 436383 */     // MIs[1] Operand 2
     /* 436383 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 436394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436398 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 436400 */     // (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 436400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 436403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 436407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 436411 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 436414 */     GIR_RootConstrainSelectedInstOperands,
     /* 436415 */     // GIR_Coverage, 13680,
     /* 436415 */     GIR_EraseRootFromParent_Done,
     /* 436416 */   // Label 8750: @436416
     /* 436416 */   GIM_Try, /*On fail goto*//*Label 8751*/ GIMT_Encode4(436502), // Rule ID 2104 //
     /* 436421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 436432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 436436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 436440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 436444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 436448 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 436452 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 436456 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436461 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 436465 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 436469 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 436473 */     // MIs[3] Operand 1
     /* 436473 */     // No operand predicates
     /* 436473 */     // MIs[1] Operand 2
     /* 436473 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 436484 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 436486 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 436486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 436489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436491 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 436497 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 436500 */     GIR_RootConstrainSelectedInstOperands,
     /* 436501 */     // GIR_Coverage, 2104,
     /* 436501 */     GIR_EraseRootFromParent_Done,
     /* 436502 */   // Label 8751: @436502
     /* 436502 */   GIM_Try, /*On fail goto*//*Label 8752*/ GIMT_Encode4(436541), // Rule ID 1831 //
     /* 436507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 436517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 436524 */     // (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (UMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 436524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_v2i64),
     /* 436527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 436534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 436539 */     GIR_RootConstrainSelectedInstOperands,
     /* 436540 */     // GIR_Coverage, 1831,
     /* 436540 */     GIR_EraseRootFromParent_Done,
     /* 436541 */   // Label 8752: @436541
     /* 436541 */   GIM_Try, /*On fail goto*//*Label 8753*/ GIMT_Encode4(436604), // Rule ID 13681 //
     /* 436546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 436553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 436557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 436561 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 436565 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436570 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 436574 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 436578 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 436582 */     // MIs[2] Operand 1
     /* 436582 */     // No operand predicates
     /* 436582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436586 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 436588 */     // (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 436588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 436591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 436595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 436599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 436602 */     GIR_RootConstrainSelectedInstOperands,
     /* 436603 */     // GIR_Coverage, 13681,
     /* 436603 */     GIR_EraseRootFromParent_Done,
     /* 436604 */   // Label 8753: @436604
     /* 436604 */   GIM_Try, /*On fail goto*//*Label 8754*/ GIMT_Encode4(436667), // Rule ID 2105 //
     /* 436609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436612 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 436620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 436624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 436628 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 436632 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 436641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 436645 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 436649 */     // MIs[2] Operand 1
     /* 436649 */     // No operand predicates
     /* 436649 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 436651 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 436651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 436654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436656 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 436662 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 436665 */     GIR_RootConstrainSelectedInstOperands,
     /* 436666 */     // GIR_Coverage, 2105,
     /* 436666 */     GIR_EraseRootFromParent_Done,
     /* 436667 */   // Label 8754: @436667
     /* 436667 */   GIM_Try, /*On fail goto*//*Label 8755*/ GIMT_Encode4(436690), // Rule ID 1830 //
     /* 436672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436683 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 436683 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_v2i64),
     /* 436688 */     GIR_RootConstrainSelectedInstOperands,
     /* 436689 */     // GIR_Coverage, 1830,
     /* 436689 */     GIR_Done,
     /* 436690 */   // Label 8755: @436690
     /* 436690 */   GIM_Reject,
     /* 436691 */ // Label 8747: @436691
     /* 436691 */ GIM_Reject,
     /* 436692 */ // Label 8744: @436692
     /* 436692 */ GIM_Try, /*On fail goto*//*Label 8756*/ GIMT_Encode4(437252),
     /* 436697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 436700 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 436703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436707 */   GIM_Try, /*On fail goto*//*Label 8757*/ GIMT_Encode4(436799), // Rule ID 2103 //
     /* 436712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 436719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 436723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 436727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 436731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 436735 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 436739 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 436743 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 436748 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 436752 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 436756 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 436760 */     // MIs[3] Operand 1
     /* 436760 */     // No operand predicates
     /* 436760 */     // MIs[1] Operand 2
     /* 436760 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 436771 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 436773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 436780 */     // (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (UMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 436780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_indexed),
     /* 436783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 436790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 436794 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 436797 */     GIR_RootConstrainSelectedInstOperands,
     /* 436798 */     // GIR_Coverage, 2103,
     /* 436798 */     GIR_EraseRootFromParent_Done,
     /* 436799 */   // Label 8757: @436799
     /* 436799 */   GIM_Try, /*On fail goto*//*Label 8758*/ GIMT_Encode4(436891), // Rule ID 13679 //
     /* 436804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 436811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 436815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 436819 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 436823 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 436827 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 436831 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 436835 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 436840 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 436844 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 436848 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 436852 */     // MIs[3] Operand 1
     /* 436852 */     // No operand predicates
     /* 436852 */     // MIs[1] Operand 2
     /* 436852 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 436863 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 436865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 436872 */     // (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (UMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 436872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_indexed),
     /* 436875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 436882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 436886 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 436889 */     GIR_RootConstrainSelectedInstOperands,
     /* 436890 */     // GIR_Coverage, 13679,
     /* 436890 */     GIR_EraseRootFromParent_Done,
     /* 436891 */   // Label 8758: @436891
     /* 436891 */   GIM_Try, /*On fail goto*//*Label 8759*/ GIMT_Encode4(436977), // Rule ID 13677 //
     /* 436896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 436903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 436907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 436911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 436915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 436919 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 436923 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 436927 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 436932 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 436936 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 436940 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 436944 */     // MIs[3] Operand 1
     /* 436944 */     // No operand predicates
     /* 436944 */     // MIs[1] Operand 2
     /* 436944 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 436955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436959 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 436961 */     // (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 436961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 436964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 436968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 436972 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 436975 */     GIR_RootConstrainSelectedInstOperands,
     /* 436976 */     // GIR_Coverage, 13677,
     /* 436976 */     GIR_EraseRootFromParent_Done,
     /* 436977 */   // Label 8759: @436977
     /* 436977 */   GIM_Try, /*On fail goto*//*Label 8760*/ GIMT_Encode4(437063), // Rule ID 2101 //
     /* 436982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436985 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 436993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 436997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 437001 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 437005 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 437009 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 437013 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 437017 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 437022 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 437026 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437030 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 437034 */     // MIs[3] Operand 1
     /* 437034 */     // No operand predicates
     /* 437034 */     // MIs[1] Operand 2
     /* 437034 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 437045 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 437047 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 437047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 437050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437052 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 437058 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 437061 */     GIR_RootConstrainSelectedInstOperands,
     /* 437062 */     // GIR_Coverage, 2101,
     /* 437062 */     GIR_EraseRootFromParent_Done,
     /* 437063 */   // Label 8760: @437063
     /* 437063 */   GIM_Try, /*On fail goto*//*Label 8761*/ GIMT_Encode4(437102), // Rule ID 1829 //
     /* 437068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 437078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 437085 */     // (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (UMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 437085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_v4i32),
     /* 437088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 437095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 437100 */     GIR_RootConstrainSelectedInstOperands,
     /* 437101 */     // GIR_Coverage, 1829,
     /* 437101 */     GIR_EraseRootFromParent_Done,
     /* 437102 */   // Label 8761: @437102
     /* 437102 */   GIM_Try, /*On fail goto*//*Label 8762*/ GIMT_Encode4(437165), // Rule ID 13678 //
     /* 437107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 437114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 437118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 437122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 437126 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 437131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 437135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437139 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 437143 */     // MIs[2] Operand 1
     /* 437143 */     // No operand predicates
     /* 437143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437147 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 437149 */     // (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 437149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 437152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 437156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 437160 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 437163 */     GIR_RootConstrainSelectedInstOperands,
     /* 437164 */     // GIR_Coverage, 13678,
     /* 437164 */     GIR_EraseRootFromParent_Done,
     /* 437165 */   // Label 8762: @437165
     /* 437165 */   GIM_Try, /*On fail goto*//*Label 8763*/ GIMT_Encode4(437228), // Rule ID 2102 //
     /* 437170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 437185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 437189 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 437193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 437198 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 437202 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437206 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 437210 */     // MIs[2] Operand 1
     /* 437210 */     // No operand predicates
     /* 437210 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 437212 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 437212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 437215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437217 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 437223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 437226 */     GIR_RootConstrainSelectedInstOperands,
     /* 437227 */     // GIR_Coverage, 2102,
     /* 437227 */     GIR_EraseRootFromParent_Done,
     /* 437228 */   // Label 8763: @437228
     /* 437228 */   GIM_Try, /*On fail goto*//*Label 8764*/ GIMT_Encode4(437251), // Rule ID 1828 //
     /* 437233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437244 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 437244 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_v4i32),
     /* 437249 */     GIR_RootConstrainSelectedInstOperands,
     /* 437250 */     // GIR_Coverage, 1828,
     /* 437250 */     GIR_Done,
     /* 437251 */   // Label 8764: @437251
     /* 437251 */   GIM_Reject,
     /* 437252 */ // Label 8756: @437252
     /* 437252 */ GIM_Reject,
     /* 437253 */ // Label 8745: @437253
     /* 437253 */ GIM_Try, /*On fail goto*//*Label 8765*/ GIMT_Encode4(437331),
     /* 437258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 437261 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 437264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437268 */   GIM_Try, /*On fail goto*//*Label 8766*/ GIMT_Encode4(437307), // Rule ID 1827 //
     /* 437273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 437283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 437290 */     // (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (UMULLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 437290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv16i8_v8i16),
     /* 437293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 437300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 437305 */     GIR_RootConstrainSelectedInstOperands,
     /* 437306 */     // GIR_Coverage, 1827,
     /* 437306 */     GIR_EraseRootFromParent_Done,
     /* 437307 */   // Label 8766: @437307
     /* 437307 */   GIM_Try, /*On fail goto*//*Label 8767*/ GIMT_Encode4(437330), // Rule ID 1826 //
     /* 437312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437323 */     // (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMULLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 437323 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i8_v8i16),
     /* 437328 */     GIR_RootConstrainSelectedInstOperands,
     /* 437329 */     // GIR_Coverage, 1826,
     /* 437329 */     GIR_Done,
     /* 437330 */   // Label 8767: @437330
     /* 437330 */   GIM_Reject,
     /* 437331 */ // Label 8765: @437331
     /* 437331 */ GIM_Reject,
     /* 437332 */ // Label 8746: @437332
     /* 437332 */ GIM_Reject,
     /* 437333 */ // Label 149: @437333
     /* 437333 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8786*/ GIMT_Encode4(438112),
     /* 437344 */ /*GILLT_v2s32*//*Label 8768*/ GIMT_Encode4(437420),
     /* 437348 */ /*GILLT_v2s64*//*Label 8769*/ GIMT_Encode4(437475),
     /* 437352 */ /*GILLT_v4s16*//*Label 8770*/ GIMT_Encode4(437530),
     /* 437356 */ /*GILLT_v4s32*//*Label 8771*/ GIMT_Encode4(437585),
     /* 437360 */ /*GILLT_v8s8*//*Label 8772*/ GIMT_Encode4(437640),
     /* 437364 */ /*GILLT_v8s16*//*Label 8773*/ GIMT_Encode4(437674),
     /* 437368 */ /*GILLT_v16s8*//*Label 8774*/ GIMT_Encode4(437729), GIMT_Encode4(0),
     /* 437376 */ /*GILLT_nxv2s1*//*Label 8775*/ GIMT_Encode4(437763),
     /* 437380 */ /*GILLT_nxv2s16*//*Label 8776*/ GIMT_Encode4(437789),
     /* 437384 */ /*GILLT_nxv2s32*//*Label 8777*/ GIMT_Encode4(437815),
     /* 437388 */ /*GILLT_nxv2s64*//*Label 8778*/ GIMT_Encode4(437841),
     /* 437392 */ /*GILLT_nxv4s1*//*Label 8779*/ GIMT_Encode4(437888),
     /* 437396 */ /*GILLT_nxv4s16*//*Label 8780*/ GIMT_Encode4(437914),
     /* 437400 */ /*GILLT_nxv4s32*//*Label 8781*/ GIMT_Encode4(437940),
     /* 437404 */ /*GILLT_nxv8s1*//*Label 8782*/ GIMT_Encode4(437987),
     /* 437408 */ /*GILLT_nxv8s16*//*Label 8783*/ GIMT_Encode4(438013),
     /* 437412 */ /*GILLT_nxv16s1*//*Label 8784*/ GIMT_Encode4(438060),
     /* 437416 */ /*GILLT_nxv16s8*//*Label 8785*/ GIMT_Encode4(438086),
     /* 437420 */ // Label 8768: @437420
     /* 437420 */ GIM_Try, /*On fail goto*//*Label 8787*/ GIMT_Encode4(437474),
     /* 437425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 437428 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 437431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437435 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437439 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437443 */   GIM_Try, /*On fail goto*//*Label 8788*/ GIMT_Encode4(437458), // Rule ID 1888 //
     /* 437448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437451 */     // (AArch64uzp1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UZP1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 437451 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i32),
     /* 437456 */     GIR_RootConstrainSelectedInstOperands,
     /* 437457 */     // GIR_Coverage, 1888,
     /* 437457 */     GIR_Done,
     /* 437458 */   // Label 8788: @437458
     /* 437458 */   GIM_Try, /*On fail goto*//*Label 8789*/ GIMT_Encode4(437473), // Rule ID 5514 //
     /* 437463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437466 */     // (AArch64uzp1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (UZP1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 437466 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i32),
     /* 437471 */     GIR_RootConstrainSelectedInstOperands,
     /* 437472 */     // GIR_Coverage, 5514,
     /* 437472 */     GIR_Done,
     /* 437473 */   // Label 8789: @437473
     /* 437473 */   GIM_Reject,
     /* 437474 */ // Label 8787: @437474
     /* 437474 */ GIM_Reject,
     /* 437475 */ // Label 8769: @437475
     /* 437475 */ GIM_Try, /*On fail goto*//*Label 8790*/ GIMT_Encode4(437529),
     /* 437480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 437483 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 437486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437490 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437494 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437498 */   GIM_Try, /*On fail goto*//*Label 8791*/ GIMT_Encode4(437513), // Rule ID 1890 //
     /* 437503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437506 */     // (AArch64uzp1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UZP1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 437506 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i64),
     /* 437511 */     GIR_RootConstrainSelectedInstOperands,
     /* 437512 */     // GIR_Coverage, 1890,
     /* 437512 */     GIR_Done,
     /* 437513 */   // Label 8791: @437513
     /* 437513 */   GIM_Try, /*On fail goto*//*Label 8792*/ GIMT_Encode4(437528), // Rule ID 5516 //
     /* 437518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437521 */     // (AArch64uzp1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (UZP1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 437521 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i64),
     /* 437526 */     GIR_RootConstrainSelectedInstOperands,
     /* 437527 */     // GIR_Coverage, 5516,
     /* 437527 */     GIR_Done,
     /* 437528 */   // Label 8792: @437528
     /* 437528 */   GIM_Reject,
     /* 437529 */ // Label 8790: @437529
     /* 437529 */ GIM_Reject,
     /* 437530 */ // Label 8770: @437530
     /* 437530 */ GIM_Try, /*On fail goto*//*Label 8793*/ GIMT_Encode4(437584),
     /* 437535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 437538 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 437541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437545 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437549 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437553 */   GIM_Try, /*On fail goto*//*Label 8794*/ GIMT_Encode4(437568), // Rule ID 1886 //
     /* 437558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437561 */     // (AArch64uzp1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UZP1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 437561 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 437566 */     GIR_RootConstrainSelectedInstOperands,
     /* 437567 */     // GIR_Coverage, 1886,
     /* 437567 */     GIR_Done,
     /* 437568 */   // Label 8794: @437568
     /* 437568 */   GIM_Try, /*On fail goto*//*Label 8795*/ GIMT_Encode4(437583), // Rule ID 5512 //
     /* 437573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437576 */     // (AArch64uzp1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (UZP1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 437576 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 437581 */     GIR_RootConstrainSelectedInstOperands,
     /* 437582 */     // GIR_Coverage, 5512,
     /* 437582 */     GIR_Done,
     /* 437583 */   // Label 8795: @437583
     /* 437583 */   GIM_Reject,
     /* 437584 */ // Label 8793: @437584
     /* 437584 */ GIM_Reject,
     /* 437585 */ // Label 8771: @437585
     /* 437585 */ GIM_Try, /*On fail goto*//*Label 8796*/ GIMT_Encode4(437639),
     /* 437590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 437593 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 437596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437604 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437608 */   GIM_Try, /*On fail goto*//*Label 8797*/ GIMT_Encode4(437623), // Rule ID 1889 //
     /* 437613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437616 */     // (AArch64uzp1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 437616 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 437621 */     GIR_RootConstrainSelectedInstOperands,
     /* 437622 */     // GIR_Coverage, 1889,
     /* 437622 */     GIR_Done,
     /* 437623 */   // Label 8797: @437623
     /* 437623 */   GIM_Try, /*On fail goto*//*Label 8798*/ GIMT_Encode4(437638), // Rule ID 5515 //
     /* 437628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437631 */     // (AArch64uzp1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (UZP1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 437631 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 437636 */     GIR_RootConstrainSelectedInstOperands,
     /* 437637 */     // GIR_Coverage, 5515,
     /* 437637 */     GIR_Done,
     /* 437638 */   // Label 8798: @437638
     /* 437638 */   GIM_Reject,
     /* 437639 */ // Label 8796: @437639
     /* 437639 */ GIM_Reject,
     /* 437640 */ // Label 8772: @437640
     /* 437640 */ GIM_Try, /*On fail goto*//*Label 8799*/ GIMT_Encode4(437673), // Rule ID 1884 //
     /* 437645 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 437651 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 437654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437658 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437662 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437666 */   // (AArch64uzp1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UZP1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 437666 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i8),
     /* 437671 */   GIR_RootConstrainSelectedInstOperands,
     /* 437672 */   // GIR_Coverage, 1884,
     /* 437672 */   GIR_Done,
     /* 437673 */ // Label 8799: @437673
     /* 437673 */ GIM_Reject,
     /* 437674 */ // Label 8773: @437674
     /* 437674 */ GIM_Try, /*On fail goto*//*Label 8800*/ GIMT_Encode4(437728),
     /* 437679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 437682 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 437685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437689 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437693 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437697 */   GIM_Try, /*On fail goto*//*Label 8801*/ GIMT_Encode4(437712), // Rule ID 1887 //
     /* 437702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437705 */     // (AArch64uzp1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 437705 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 437710 */     GIR_RootConstrainSelectedInstOperands,
     /* 437711 */     // GIR_Coverage, 1887,
     /* 437711 */     GIR_Done,
     /* 437712 */   // Label 8801: @437712
     /* 437712 */   GIM_Try, /*On fail goto*//*Label 8802*/ GIMT_Encode4(437727), // Rule ID 5513 //
     /* 437717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437720 */     // (AArch64uzp1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (UZP1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 437720 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 437725 */     GIR_RootConstrainSelectedInstOperands,
     /* 437726 */     // GIR_Coverage, 5513,
     /* 437726 */     GIR_Done,
     /* 437727 */   // Label 8802: @437727
     /* 437727 */   GIM_Reject,
     /* 437728 */ // Label 8800: @437728
     /* 437728 */ GIM_Reject,
     /* 437729 */ // Label 8774: @437729
     /* 437729 */ GIM_Try, /*On fail goto*//*Label 8803*/ GIMT_Encode4(437762), // Rule ID 1885 //
     /* 437734 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 437740 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 437743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437747 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437751 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437755 */   // (AArch64uzp1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 437755 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v16i8),
     /* 437760 */   GIR_RootConstrainSelectedInstOperands,
     /* 437761 */   // GIR_Coverage, 1885,
     /* 437761 */   GIR_Done,
     /* 437762 */ // Label 8803: @437762
     /* 437762 */ GIM_Reject,
     /* 437763 */ // Label 8775: @437763
     /* 437763 */ GIM_Try, /*On fail goto*//*Label 8804*/ GIMT_Encode4(437788), // Rule ID 9076 //
     /* 437768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 437774 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 437777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 437781 */   // (AArch64uzp1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UZP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 437781 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /* 437786 */   GIR_RootConstrainSelectedInstOperands,
     /* 437787 */   // GIR_Coverage, 9076,
     /* 437787 */   GIR_Done,
     /* 437788 */ // Label 8804: @437788
     /* 437788 */ GIM_Reject,
     /* 437789 */ // Label 8776: @437789
     /* 437789 */ GIM_Try, /*On fail goto*//*Label 8805*/ GIMT_Encode4(437814), // Rule ID 9038 //
     /* 437794 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 437800 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 437803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 437807 */   // (AArch64uzp1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 437807 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 437812 */   GIR_RootConstrainSelectedInstOperands,
     /* 437813 */   // GIR_Coverage, 9038,
     /* 437813 */   GIR_Done,
     /* 437814 */ // Label 8805: @437814
     /* 437814 */ GIM_Reject,
     /* 437815 */ // Label 8777: @437815
     /* 437815 */ GIM_Try, /*On fail goto*//*Label 8806*/ GIMT_Encode4(437840), // Rule ID 9039 //
     /* 437820 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 437826 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 437829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 437833 */   // (AArch64uzp1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 437833 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 437838 */   GIR_RootConstrainSelectedInstOperands,
     /* 437839 */   // GIR_Coverage, 9039,
     /* 437839 */   GIR_Done,
     /* 437840 */ // Label 8806: @437840
     /* 437840 */ GIM_Reject,
     /* 437841 */ // Label 8778: @437841
     /* 437841 */ GIM_Try, /*On fail goto*//*Label 8807*/ GIMT_Encode4(437887),
     /* 437846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 437849 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 437852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 437856 */   GIM_Try, /*On fail goto*//*Label 8808*/ GIMT_Encode4(437871), // Rule ID 9034 //
     /* 437861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437864 */     // (AArch64uzp1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 437864 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 437869 */     GIR_RootConstrainSelectedInstOperands,
     /* 437870 */     // GIR_Coverage, 9034,
     /* 437870 */     GIR_Done,
     /* 437871 */   // Label 8808: @437871
     /* 437871 */   GIM_Try, /*On fail goto*//*Label 8809*/ GIMT_Encode4(437886), // Rule ID 9040 //
     /* 437876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437879 */     // (AArch64uzp1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 437879 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 437884 */     GIR_RootConstrainSelectedInstOperands,
     /* 437885 */     // GIR_Coverage, 9040,
     /* 437885 */     GIR_Done,
     /* 437886 */   // Label 8809: @437886
     /* 437886 */   GIM_Reject,
     /* 437887 */ // Label 8807: @437887
     /* 437887 */ GIM_Reject,
     /* 437888 */ // Label 8779: @437888
     /* 437888 */ GIM_Try, /*On fail goto*//*Label 8810*/ GIMT_Encode4(437913), // Rule ID 9075 //
     /* 437893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 437899 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 437902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 437906 */   // (AArch64uzp1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UZP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 437906 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /* 437911 */   GIR_RootConstrainSelectedInstOperands,
     /* 437912 */   // GIR_Coverage, 9075,
     /* 437912 */   GIR_Done,
     /* 437913 */ // Label 8810: @437913
     /* 437913 */ GIM_Reject,
     /* 437914 */ // Label 8780: @437914
     /* 437914 */ GIM_Try, /*On fail goto*//*Label 8811*/ GIMT_Encode4(437939), // Rule ID 9036 //
     /* 437919 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 437925 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 437928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 437932 */   // (AArch64uzp1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 437932 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 437937 */   GIR_RootConstrainSelectedInstOperands,
     /* 437938 */   // GIR_Coverage, 9036,
     /* 437938 */   GIR_Done,
     /* 437939 */ // Label 8811: @437939
     /* 437939 */ GIM_Reject,
     /* 437940 */ // Label 8781: @437940
     /* 437940 */ GIM_Try, /*On fail goto*//*Label 8812*/ GIMT_Encode4(437986),
     /* 437945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 437948 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 437951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 437955 */   GIM_Try, /*On fail goto*//*Label 8813*/ GIMT_Encode4(437970), // Rule ID 9033 //
     /* 437960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437963 */     // (AArch64uzp1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 437963 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 437968 */     GIR_RootConstrainSelectedInstOperands,
     /* 437969 */     // GIR_Coverage, 9033,
     /* 437969 */     GIR_Done,
     /* 437970 */   // Label 8813: @437970
     /* 437970 */   GIM_Try, /*On fail goto*//*Label 8814*/ GIMT_Encode4(437985), // Rule ID 9037 //
     /* 437975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437978 */     // (AArch64uzp1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 437978 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 437983 */     GIR_RootConstrainSelectedInstOperands,
     /* 437984 */     // GIR_Coverage, 9037,
     /* 437984 */     GIR_Done,
     /* 437985 */   // Label 8814: @437985
     /* 437985 */   GIM_Reject,
     /* 437986 */ // Label 8812: @437986
     /* 437986 */ GIM_Reject,
     /* 437987 */ // Label 8782: @437987
     /* 437987 */ GIM_Try, /*On fail goto*//*Label 8815*/ GIMT_Encode4(438012), // Rule ID 9074 //
     /* 437992 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 437998 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 438001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 438005 */   // (AArch64uzp1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UZP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 438005 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /* 438010 */   GIR_RootConstrainSelectedInstOperands,
     /* 438011 */   // GIR_Coverage, 9074,
     /* 438011 */   GIR_Done,
     /* 438012 */ // Label 8815: @438012
     /* 438012 */ GIM_Reject,
     /* 438013 */ // Label 8783: @438013
     /* 438013 */ GIM_Try, /*On fail goto*//*Label 8816*/ GIMT_Encode4(438059),
     /* 438018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 438021 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 438024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 438028 */   GIM_Try, /*On fail goto*//*Label 8817*/ GIMT_Encode4(438043), // Rule ID 9032 //
     /* 438033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438036 */     // (AArch64uzp1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 438036 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /* 438041 */     GIR_RootConstrainSelectedInstOperands,
     /* 438042 */     // GIR_Coverage, 9032,
     /* 438042 */     GIR_Done,
     /* 438043 */   // Label 8817: @438043
     /* 438043 */   GIM_Try, /*On fail goto*//*Label 8818*/ GIMT_Encode4(438058), // Rule ID 9035 //
     /* 438048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438051 */     // (AArch64uzp1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 438051 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /* 438056 */     GIR_RootConstrainSelectedInstOperands,
     /* 438057 */     // GIR_Coverage, 9035,
     /* 438057 */     GIR_Done,
     /* 438058 */   // Label 8818: @438058
     /* 438058 */   GIM_Reject,
     /* 438059 */ // Label 8816: @438059
     /* 438059 */ GIM_Reject,
     /* 438060 */ // Label 8784: @438060
     /* 438060 */ GIM_Try, /*On fail goto*//*Label 8819*/ GIMT_Encode4(438085), // Rule ID 2406 //
     /* 438065 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 438071 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 438074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 438078 */   // (AArch64uzp1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 438078 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_B),
     /* 438083 */   GIR_RootConstrainSelectedInstOperands,
     /* 438084 */   // GIR_Coverage, 2406,
     /* 438084 */   GIR_Done,
     /* 438085 */ // Label 8819: @438085
     /* 438085 */ GIM_Reject,
     /* 438086 */ // Label 8785: @438086
     /* 438086 */ GIM_Try, /*On fail goto*//*Label 8820*/ GIMT_Encode4(438111), // Rule ID 9031 //
     /* 438091 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 438097 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 438100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 438104 */   // (AArch64uzp1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 438104 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_B),
     /* 438109 */   GIR_RootConstrainSelectedInstOperands,
     /* 438110 */   // GIR_Coverage, 9031,
     /* 438110 */   GIR_Done,
     /* 438111 */ // Label 8820: @438111
     /* 438111 */ GIM_Reject,
     /* 438112 */ // Label 8786: @438112
     /* 438112 */ GIM_Reject,
     /* 438113 */ // Label 150: @438113
     /* 438113 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8839*/ GIMT_Encode4(438892),
     /* 438124 */ /*GILLT_v2s32*//*Label 8821*/ GIMT_Encode4(438200),
     /* 438128 */ /*GILLT_v2s64*//*Label 8822*/ GIMT_Encode4(438255),
     /* 438132 */ /*GILLT_v4s16*//*Label 8823*/ GIMT_Encode4(438310),
     /* 438136 */ /*GILLT_v4s32*//*Label 8824*/ GIMT_Encode4(438365),
     /* 438140 */ /*GILLT_v8s8*//*Label 8825*/ GIMT_Encode4(438420),
     /* 438144 */ /*GILLT_v8s16*//*Label 8826*/ GIMT_Encode4(438454),
     /* 438148 */ /*GILLT_v16s8*//*Label 8827*/ GIMT_Encode4(438509), GIMT_Encode4(0),
     /* 438156 */ /*GILLT_nxv2s1*//*Label 8828*/ GIMT_Encode4(438543),
     /* 438160 */ /*GILLT_nxv2s16*//*Label 8829*/ GIMT_Encode4(438569),
     /* 438164 */ /*GILLT_nxv2s32*//*Label 8830*/ GIMT_Encode4(438595),
     /* 438168 */ /*GILLT_nxv2s64*//*Label 8831*/ GIMT_Encode4(438621),
     /* 438172 */ /*GILLT_nxv4s1*//*Label 8832*/ GIMT_Encode4(438668),
     /* 438176 */ /*GILLT_nxv4s16*//*Label 8833*/ GIMT_Encode4(438694),
     /* 438180 */ /*GILLT_nxv4s32*//*Label 8834*/ GIMT_Encode4(438720),
     /* 438184 */ /*GILLT_nxv8s1*//*Label 8835*/ GIMT_Encode4(438767),
     /* 438188 */ /*GILLT_nxv8s16*//*Label 8836*/ GIMT_Encode4(438793),
     /* 438192 */ /*GILLT_nxv16s1*//*Label 8837*/ GIMT_Encode4(438840),
     /* 438196 */ /*GILLT_nxv16s8*//*Label 8838*/ GIMT_Encode4(438866),
     /* 438200 */ // Label 8821: @438200
     /* 438200 */ GIM_Try, /*On fail goto*//*Label 8840*/ GIMT_Encode4(438254),
     /* 438205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 438208 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 438211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438219 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438223 */   GIM_Try, /*On fail goto*//*Label 8841*/ GIMT_Encode4(438238), // Rule ID 1895 //
     /* 438228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438231 */     // (AArch64uzp2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UZP2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 438231 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i32),
     /* 438236 */     GIR_RootConstrainSelectedInstOperands,
     /* 438237 */     // GIR_Coverage, 1895,
     /* 438237 */     GIR_Done,
     /* 438238 */   // Label 8841: @438238
     /* 438238 */   GIM_Try, /*On fail goto*//*Label 8842*/ GIMT_Encode4(438253), // Rule ID 5519 //
     /* 438243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438246 */     // (AArch64uzp2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (UZP2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 438246 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i32),
     /* 438251 */     GIR_RootConstrainSelectedInstOperands,
     /* 438252 */     // GIR_Coverage, 5519,
     /* 438252 */     GIR_Done,
     /* 438253 */   // Label 8842: @438253
     /* 438253 */   GIM_Reject,
     /* 438254 */ // Label 8840: @438254
     /* 438254 */ GIM_Reject,
     /* 438255 */ // Label 8822: @438255
     /* 438255 */ GIM_Try, /*On fail goto*//*Label 8843*/ GIMT_Encode4(438309),
     /* 438260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 438263 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 438266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438270 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438274 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438278 */   GIM_Try, /*On fail goto*//*Label 8844*/ GIMT_Encode4(438293), // Rule ID 1897 //
     /* 438283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438286 */     // (AArch64uzp2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UZP2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 438286 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i64),
     /* 438291 */     GIR_RootConstrainSelectedInstOperands,
     /* 438292 */     // GIR_Coverage, 1897,
     /* 438292 */     GIR_Done,
     /* 438293 */   // Label 8844: @438293
     /* 438293 */   GIM_Try, /*On fail goto*//*Label 8845*/ GIMT_Encode4(438308), // Rule ID 5521 //
     /* 438298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438301 */     // (AArch64uzp2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (UZP2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 438301 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i64),
     /* 438306 */     GIR_RootConstrainSelectedInstOperands,
     /* 438307 */     // GIR_Coverage, 5521,
     /* 438307 */     GIR_Done,
     /* 438308 */   // Label 8845: @438308
     /* 438308 */   GIM_Reject,
     /* 438309 */ // Label 8843: @438309
     /* 438309 */ GIM_Reject,
     /* 438310 */ // Label 8823: @438310
     /* 438310 */ GIM_Try, /*On fail goto*//*Label 8846*/ GIMT_Encode4(438364),
     /* 438315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 438318 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 438321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438325 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438329 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438333 */   GIM_Try, /*On fail goto*//*Label 8847*/ GIMT_Encode4(438348), // Rule ID 1893 //
     /* 438338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438341 */     // (AArch64uzp2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UZP2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 438341 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i16),
     /* 438346 */     GIR_RootConstrainSelectedInstOperands,
     /* 438347 */     // GIR_Coverage, 1893,
     /* 438347 */     GIR_Done,
     /* 438348 */   // Label 8847: @438348
     /* 438348 */   GIM_Try, /*On fail goto*//*Label 8848*/ GIMT_Encode4(438363), // Rule ID 5517 //
     /* 438353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438356 */     // (AArch64uzp2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (UZP2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 438356 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i16),
     /* 438361 */     GIR_RootConstrainSelectedInstOperands,
     /* 438362 */     // GIR_Coverage, 5517,
     /* 438362 */     GIR_Done,
     /* 438363 */   // Label 8848: @438363
     /* 438363 */   GIM_Reject,
     /* 438364 */ // Label 8846: @438364
     /* 438364 */ GIM_Reject,
     /* 438365 */ // Label 8824: @438365
     /* 438365 */ GIM_Try, /*On fail goto*//*Label 8849*/ GIMT_Encode4(438419),
     /* 438370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 438373 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 438376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438380 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438384 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438388 */   GIM_Try, /*On fail goto*//*Label 8850*/ GIMT_Encode4(438403), // Rule ID 1896 //
     /* 438393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438396 */     // (AArch64uzp2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 438396 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 438401 */     GIR_RootConstrainSelectedInstOperands,
     /* 438402 */     // GIR_Coverage, 1896,
     /* 438402 */     GIR_Done,
     /* 438403 */   // Label 8850: @438403
     /* 438403 */   GIM_Try, /*On fail goto*//*Label 8851*/ GIMT_Encode4(438418), // Rule ID 5520 //
     /* 438408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438411 */     // (AArch64uzp2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 438411 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 438416 */     GIR_RootConstrainSelectedInstOperands,
     /* 438417 */     // GIR_Coverage, 5520,
     /* 438417 */     GIR_Done,
     /* 438418 */   // Label 8851: @438418
     /* 438418 */   GIM_Reject,
     /* 438419 */ // Label 8849: @438419
     /* 438419 */ GIM_Reject,
     /* 438420 */ // Label 8825: @438420
     /* 438420 */ GIM_Try, /*On fail goto*//*Label 8852*/ GIMT_Encode4(438453), // Rule ID 1891 //
     /* 438425 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 438431 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 438434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438438 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438442 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438446 */   // (AArch64uzp2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UZP2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 438446 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i8),
     /* 438451 */   GIR_RootConstrainSelectedInstOperands,
     /* 438452 */   // GIR_Coverage, 1891,
     /* 438452 */   GIR_Done,
     /* 438453 */ // Label 8852: @438453
     /* 438453 */ GIM_Reject,
     /* 438454 */ // Label 8826: @438454
     /* 438454 */ GIM_Try, /*On fail goto*//*Label 8853*/ GIMT_Encode4(438508),
     /* 438459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 438462 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 438465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438469 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438473 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438477 */   GIM_Try, /*On fail goto*//*Label 8854*/ GIMT_Encode4(438492), // Rule ID 1894 //
     /* 438482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438485 */     // (AArch64uzp2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 438485 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 438490 */     GIR_RootConstrainSelectedInstOperands,
     /* 438491 */     // GIR_Coverage, 1894,
     /* 438491 */     GIR_Done,
     /* 438492 */   // Label 8854: @438492
     /* 438492 */   GIM_Try, /*On fail goto*//*Label 8855*/ GIMT_Encode4(438507), // Rule ID 5518 //
     /* 438497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438500 */     // (AArch64uzp2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 438500 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 438505 */     GIR_RootConstrainSelectedInstOperands,
     /* 438506 */     // GIR_Coverage, 5518,
     /* 438506 */     GIR_Done,
     /* 438507 */   // Label 8855: @438507
     /* 438507 */   GIM_Reject,
     /* 438508 */ // Label 8853: @438508
     /* 438508 */ GIM_Reject,
     /* 438509 */ // Label 8827: @438509
     /* 438509 */ GIM_Try, /*On fail goto*//*Label 8856*/ GIMT_Encode4(438542), // Rule ID 1892 //
     /* 438514 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 438520 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 438523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438527 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438531 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438535 */   // (AArch64uzp2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 438535 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 438540 */   GIR_RootConstrainSelectedInstOperands,
     /* 438541 */   // GIR_Coverage, 1892,
     /* 438541 */   GIR_Done,
     /* 438542 */ // Label 8856: @438542
     /* 438542 */ GIM_Reject,
     /* 438543 */ // Label 8828: @438543
     /* 438543 */ GIM_Try, /*On fail goto*//*Label 8857*/ GIMT_Encode4(438568), // Rule ID 9079 //
     /* 438548 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 438554 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 438557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 438561 */   // (AArch64uzp2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UZP2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 438561 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_D),
     /* 438566 */   GIR_RootConstrainSelectedInstOperands,
     /* 438567 */   // GIR_Coverage, 9079,
     /* 438567 */   GIR_Done,
     /* 438568 */ // Label 8857: @438568
     /* 438568 */ GIM_Reject,
     /* 438569 */ // Label 8829: @438569
     /* 438569 */ GIM_Try, /*On fail goto*//*Label 8858*/ GIMT_Encode4(438594), // Rule ID 9048 //
     /* 438574 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 438580 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 438583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 438587 */   // (AArch64uzp2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 438587 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 438592 */   GIR_RootConstrainSelectedInstOperands,
     /* 438593 */   // GIR_Coverage, 9048,
     /* 438593 */   GIR_Done,
     /* 438594 */ // Label 8858: @438594
     /* 438594 */ GIM_Reject,
     /* 438595 */ // Label 8830: @438595
     /* 438595 */ GIM_Try, /*On fail goto*//*Label 8859*/ GIMT_Encode4(438620), // Rule ID 9049 //
     /* 438600 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 438606 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 438609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 438613 */   // (AArch64uzp2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 438613 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 438618 */   GIR_RootConstrainSelectedInstOperands,
     /* 438619 */   // GIR_Coverage, 9049,
     /* 438619 */   GIR_Done,
     /* 438620 */ // Label 8859: @438620
     /* 438620 */ GIM_Reject,
     /* 438621 */ // Label 8831: @438621
     /* 438621 */ GIM_Try, /*On fail goto*//*Label 8860*/ GIMT_Encode4(438667),
     /* 438626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 438629 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 438632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 438636 */   GIM_Try, /*On fail goto*//*Label 8861*/ GIMT_Encode4(438651), // Rule ID 9044 //
     /* 438641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438644 */     // (AArch64uzp2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 438644 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 438649 */     GIR_RootConstrainSelectedInstOperands,
     /* 438650 */     // GIR_Coverage, 9044,
     /* 438650 */     GIR_Done,
     /* 438651 */   // Label 8861: @438651
     /* 438651 */   GIM_Try, /*On fail goto*//*Label 8862*/ GIMT_Encode4(438666), // Rule ID 9050 //
     /* 438656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438659 */     // (AArch64uzp2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 438659 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 438664 */     GIR_RootConstrainSelectedInstOperands,
     /* 438665 */     // GIR_Coverage, 9050,
     /* 438665 */     GIR_Done,
     /* 438666 */   // Label 8862: @438666
     /* 438666 */   GIM_Reject,
     /* 438667 */ // Label 8860: @438667
     /* 438667 */ GIM_Reject,
     /* 438668 */ // Label 8832: @438668
     /* 438668 */ GIM_Try, /*On fail goto*//*Label 8863*/ GIMT_Encode4(438693), // Rule ID 9078 //
     /* 438673 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 438679 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 438682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 438686 */   // (AArch64uzp2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UZP2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 438686 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_S),
     /* 438691 */   GIR_RootConstrainSelectedInstOperands,
     /* 438692 */   // GIR_Coverage, 9078,
     /* 438692 */   GIR_Done,
     /* 438693 */ // Label 8863: @438693
     /* 438693 */ GIM_Reject,
     /* 438694 */ // Label 8833: @438694
     /* 438694 */ GIM_Try, /*On fail goto*//*Label 8864*/ GIMT_Encode4(438719), // Rule ID 9046 //
     /* 438699 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 438705 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 438708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 438712 */   // (AArch64uzp2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 438712 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 438717 */   GIR_RootConstrainSelectedInstOperands,
     /* 438718 */   // GIR_Coverage, 9046,
     /* 438718 */   GIR_Done,
     /* 438719 */ // Label 8864: @438719
     /* 438719 */ GIM_Reject,
     /* 438720 */ // Label 8834: @438720
     /* 438720 */ GIM_Try, /*On fail goto*//*Label 8865*/ GIMT_Encode4(438766),
     /* 438725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 438728 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 438731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 438735 */   GIM_Try, /*On fail goto*//*Label 8866*/ GIMT_Encode4(438750), // Rule ID 9043 //
     /* 438740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438743 */     // (AArch64uzp2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 438743 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 438748 */     GIR_RootConstrainSelectedInstOperands,
     /* 438749 */     // GIR_Coverage, 9043,
     /* 438749 */     GIR_Done,
     /* 438750 */   // Label 8866: @438750
     /* 438750 */   GIM_Try, /*On fail goto*//*Label 8867*/ GIMT_Encode4(438765), // Rule ID 9047 //
     /* 438755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438758 */     // (AArch64uzp2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 438758 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 438763 */     GIR_RootConstrainSelectedInstOperands,
     /* 438764 */     // GIR_Coverage, 9047,
     /* 438764 */     GIR_Done,
     /* 438765 */   // Label 8867: @438765
     /* 438765 */   GIM_Reject,
     /* 438766 */ // Label 8865: @438766
     /* 438766 */ GIM_Reject,
     /* 438767 */ // Label 8835: @438767
     /* 438767 */ GIM_Try, /*On fail goto*//*Label 8868*/ GIMT_Encode4(438792), // Rule ID 9077 //
     /* 438772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 438778 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 438781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 438785 */   // (AArch64uzp2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UZP2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 438785 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_H),
     /* 438790 */   GIR_RootConstrainSelectedInstOperands,
     /* 438791 */   // GIR_Coverage, 9077,
     /* 438791 */   GIR_Done,
     /* 438792 */ // Label 8868: @438792
     /* 438792 */ GIM_Reject,
     /* 438793 */ // Label 8836: @438793
     /* 438793 */ GIM_Try, /*On fail goto*//*Label 8869*/ GIMT_Encode4(438839),
     /* 438798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 438801 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 438804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 438808 */   GIM_Try, /*On fail goto*//*Label 8870*/ GIMT_Encode4(438823), // Rule ID 9042 //
     /* 438813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438816 */     // (AArch64uzp2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 438816 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_H),
     /* 438821 */     GIR_RootConstrainSelectedInstOperands,
     /* 438822 */     // GIR_Coverage, 9042,
     /* 438822 */     GIR_Done,
     /* 438823 */   // Label 8870: @438823
     /* 438823 */   GIM_Try, /*On fail goto*//*Label 8871*/ GIMT_Encode4(438838), // Rule ID 9045 //
     /* 438828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438831 */     // (AArch64uzp2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 438831 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_H),
     /* 438836 */     GIR_RootConstrainSelectedInstOperands,
     /* 438837 */     // GIR_Coverage, 9045,
     /* 438837 */     GIR_Done,
     /* 438838 */   // Label 8871: @438838
     /* 438838 */   GIM_Reject,
     /* 438839 */ // Label 8869: @438839
     /* 438839 */ GIM_Reject,
     /* 438840 */ // Label 8837: @438840
     /* 438840 */ GIM_Try, /*On fail goto*//*Label 8872*/ GIMT_Encode4(438865), // Rule ID 2410 //
     /* 438845 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 438851 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 438854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 438858 */   // (AArch64uzp2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 438858 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_B),
     /* 438863 */   GIR_RootConstrainSelectedInstOperands,
     /* 438864 */   // GIR_Coverage, 2410,
     /* 438864 */   GIR_Done,
     /* 438865 */ // Label 8872: @438865
     /* 438865 */ GIM_Reject,
     /* 438866 */ // Label 8838: @438866
     /* 438866 */ GIM_Try, /*On fail goto*//*Label 8873*/ GIMT_Encode4(438891), // Rule ID 9041 //
     /* 438871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 438877 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 438880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 438884 */   // (AArch64uzp2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 438884 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_B),
     /* 438889 */   GIR_RootConstrainSelectedInstOperands,
     /* 438890 */   // GIR_Coverage, 9041,
     /* 438890 */   GIR_Done,
     /* 438891 */ // Label 8873: @438891
     /* 438891 */ GIM_Reject,
     /* 438892 */ // Label 8839: @438892
     /* 438892 */ GIM_Reject,
     /* 438893 */ // Label 151: @438893
     /* 438893 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8882*/ GIMT_Encode4(439590),
     /* 438904 */ /*GILLT_s64*//*Label 8874*/ GIMT_Encode4(438940), GIMT_Encode4(0),
     /* 438912 */ /*GILLT_v2s32*//*Label 8875*/ GIMT_Encode4(439051),
     /* 438916 */ /*GILLT_v2s64*//*Label 8876*/ GIMT_Encode4(439128),
     /* 438920 */ /*GILLT_v4s16*//*Label 8877*/ GIMT_Encode4(439205),
     /* 438924 */ /*GILLT_v4s32*//*Label 8878*/ GIMT_Encode4(439282),
     /* 438928 */ /*GILLT_v8s8*//*Label 8879*/ GIMT_Encode4(439359),
     /* 438932 */ /*GILLT_v8s16*//*Label 8880*/ GIMT_Encode4(439436),
     /* 438936 */ /*GILLT_v16s8*//*Label 8881*/ GIMT_Encode4(439513),
     /* 438940 */ // Label 8874: @438940
     /* 438940 */ GIM_Try, /*On fail goto*//*Label 8883*/ GIMT_Encode4(439050),
     /* 438945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 438948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438956 */   GIM_Try, /*On fail goto*//*Label 8884*/ GIMT_Encode4(438981), // Rule ID 5291 //
     /* 438961 */     // MIs[0] Operand 2
     /* 438961 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(63),
     /* 438972 */     // (AArch64vashr:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, 63:{ *:[i32] })  =>  (CMLTv1i64rz:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn)
     /* 438972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv1i64rz),
     /* 438975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 438977 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 438979 */     GIR_RootConstrainSelectedInstOperands,
     /* 438980 */     // GIR_Coverage, 5291,
     /* 438980 */     GIR_EraseRootFromParent_Done,
     /* 438981 */   // Label 8884: @438981
     /* 438981 */   GIM_Try, /*On fail goto*//*Label 8885*/ GIMT_Encode4(439015), // Rule ID 2120 //
     /* 438986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438989 */     // MIs[0] imm
     /* 438989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 438993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 438997 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 439001 */     // MIs[1] Operand 1
     /* 439001 */     // No operand predicates
     /* 439001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 439003 */     // (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRd:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 439003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRd),
     /* 439006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 439008 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 439010 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 439013 */     GIR_RootConstrainSelectedInstOperands,
     /* 439014 */     // GIR_Coverage, 2120,
     /* 439014 */     GIR_EraseRootFromParent_Done,
     /* 439015 */   // Label 8885: @439015
     /* 439015 */   GIM_Try, /*On fail goto*//*Label 8886*/ GIMT_Encode4(439049), // Rule ID 6355 //
     /* 439020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439023 */     // MIs[0] imm
     /* 439023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 439027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 439031 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 439035 */     // MIs[1] Operand 1
     /* 439035 */     // No operand predicates
     /* 439035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 439037 */     // (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 439037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRd),
     /* 439040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 439042 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 439044 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 439047 */     GIR_RootConstrainSelectedInstOperands,
     /* 439048 */     // GIR_Coverage, 6355,
     /* 439048 */     GIR_EraseRootFromParent_Done,
     /* 439049 */   // Label 8886: @439049
     /* 439049 */   GIM_Reject,
     /* 439050 */ // Label 8883: @439050
     /* 439050 */ GIM_Reject,
     /* 439051 */ // Label 8875: @439051
     /* 439051 */ GIM_Try, /*On fail goto*//*Label 8887*/ GIMT_Encode4(439127),
     /* 439056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 439059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439063 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439067 */   GIM_Try, /*On fail goto*//*Label 8888*/ GIMT_Encode4(439092), // Rule ID 4953 //
     /* 439072 */     // MIs[0] Operand 2
     /* 439072 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(31),
     /* 439083 */     // (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, 31:{ *:[i32] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 439083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 439086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 439088 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 439090 */     GIR_RootConstrainSelectedInstOperands,
     /* 439091 */     // GIR_Coverage, 4953,
     /* 439091 */     GIR_EraseRootFromParent_Done,
     /* 439092 */   // Label 8888: @439092
     /* 439092 */   GIM_Try, /*On fail goto*//*Label 8889*/ GIMT_Encode4(439126), // Rule ID 2227 //
     /* 439097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439100 */     // MIs[0] imm
     /* 439100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 439104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 439108 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 439112 */     // MIs[1] Operand 1
     /* 439112 */     // No operand predicates
     /* 439112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 439114 */     // (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SSHRv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 439114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv2i32_shift),
     /* 439117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 439119 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 439121 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 439124 */     GIR_RootConstrainSelectedInstOperands,
     /* 439125 */     // GIR_Coverage, 2227,
     /* 439125 */     GIR_EraseRootFromParent_Done,
     /* 439126 */   // Label 8889: @439126
     /* 439126 */   GIM_Reject,
     /* 439127 */ // Label 8887: @439127
     /* 439127 */ GIM_Reject,
     /* 439128 */ // Label 8876: @439128
     /* 439128 */ GIM_Try, /*On fail goto*//*Label 8890*/ GIMT_Encode4(439204),
     /* 439133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 439136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439140 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439144 */   GIM_Try, /*On fail goto*//*Label 8891*/ GIMT_Encode4(439169), // Rule ID 4957 //
     /* 439149 */     // MIs[0] Operand 2
     /* 439149 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(63),
     /* 439160 */     // (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, 63:{ *:[i32] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 439160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 439163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 439165 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 439167 */     GIR_RootConstrainSelectedInstOperands,
     /* 439168 */     // GIR_Coverage, 4957,
     /* 439168 */     GIR_EraseRootFromParent_Done,
     /* 439169 */   // Label 8891: @439169
     /* 439169 */   GIM_Try, /*On fail goto*//*Label 8892*/ GIMT_Encode4(439203), // Rule ID 2229 //
     /* 439174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439177 */     // MIs[0] imm
     /* 439177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 439181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 439185 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 439189 */     // MIs[1] Operand 1
     /* 439189 */     // No operand predicates
     /* 439189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 439191 */     // (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 439191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv2i64_shift),
     /* 439194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 439196 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 439198 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 439201 */     GIR_RootConstrainSelectedInstOperands,
     /* 439202 */     // GIR_Coverage, 2229,
     /* 439202 */     GIR_EraseRootFromParent_Done,
     /* 439203 */   // Label 8892: @439203
     /* 439203 */   GIM_Reject,
     /* 439204 */ // Label 8890: @439204
     /* 439204 */ GIM_Reject,
     /* 439205 */ // Label 8877: @439205
     /* 439205 */ GIM_Try, /*On fail goto*//*Label 8893*/ GIMT_Encode4(439281),
     /* 439210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 439213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439217 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439221 */   GIM_Try, /*On fail goto*//*Label 8894*/ GIMT_Encode4(439246), // Rule ID 4952 //
     /* 439226 */     // MIs[0] Operand 2
     /* 439226 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 439237 */     // (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, 15:{ *:[i32] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 439237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 439240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 439242 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 439244 */     GIR_RootConstrainSelectedInstOperands,
     /* 439245 */     // GIR_Coverage, 4952,
     /* 439245 */     GIR_EraseRootFromParent_Done,
     /* 439246 */   // Label 8894: @439246
     /* 439246 */   GIM_Try, /*On fail goto*//*Label 8895*/ GIMT_Encode4(439280), // Rule ID 2225 //
     /* 439251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439254 */     // MIs[0] imm
     /* 439254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 439258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 439262 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 439266 */     // MIs[1] Operand 1
     /* 439266 */     // No operand predicates
     /* 439266 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 439268 */     // (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SSHRv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 439268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv4i16_shift),
     /* 439271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 439273 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 439275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 439278 */     GIR_RootConstrainSelectedInstOperands,
     /* 439279 */     // GIR_Coverage, 2225,
     /* 439279 */     GIR_EraseRootFromParent_Done,
     /* 439280 */   // Label 8895: @439280
     /* 439280 */   GIM_Reject,
     /* 439281 */ // Label 8893: @439281
     /* 439281 */ GIM_Reject,
     /* 439282 */ // Label 8878: @439282
     /* 439282 */ GIM_Try, /*On fail goto*//*Label 8896*/ GIMT_Encode4(439358),
     /* 439287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 439290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439294 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439298 */   GIM_Try, /*On fail goto*//*Label 8897*/ GIMT_Encode4(439323), // Rule ID 4956 //
     /* 439303 */     // MIs[0] Operand 2
     /* 439303 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(31),
     /* 439314 */     // (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, 31:{ *:[i32] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 439314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 439317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 439319 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 439321 */     GIR_RootConstrainSelectedInstOperands,
     /* 439322 */     // GIR_Coverage, 4956,
     /* 439322 */     GIR_EraseRootFromParent_Done,
     /* 439323 */   // Label 8897: @439323
     /* 439323 */   GIM_Try, /*On fail goto*//*Label 8898*/ GIMT_Encode4(439357), // Rule ID 2228 //
     /* 439328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439331 */     // MIs[0] imm
     /* 439331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 439335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 439339 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 439343 */     // MIs[1] Operand 1
     /* 439343 */     // No operand predicates
     /* 439343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 439345 */     // (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SSHRv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 439345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv4i32_shift),
     /* 439348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 439350 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 439352 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 439355 */     GIR_RootConstrainSelectedInstOperands,
     /* 439356 */     // GIR_Coverage, 2228,
     /* 439356 */     GIR_EraseRootFromParent_Done,
     /* 439357 */   // Label 8898: @439357
     /* 439357 */   GIM_Reject,
     /* 439358 */ // Label 8896: @439358
     /* 439358 */ GIM_Reject,
     /* 439359 */ // Label 8879: @439359
     /* 439359 */ GIM_Try, /*On fail goto*//*Label 8899*/ GIMT_Encode4(439435),
     /* 439364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 439367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439371 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439375 */   GIM_Try, /*On fail goto*//*Label 8900*/ GIMT_Encode4(439400), // Rule ID 4951 //
     /* 439380 */     // MIs[0] Operand 2
     /* 439380 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 439391 */     // (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, 7:{ *:[i32] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 439391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 439394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 439396 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 439398 */     GIR_RootConstrainSelectedInstOperands,
     /* 439399 */     // GIR_Coverage, 4951,
     /* 439399 */     GIR_EraseRootFromParent_Done,
     /* 439400 */   // Label 8900: @439400
     /* 439400 */   GIM_Try, /*On fail goto*//*Label 8901*/ GIMT_Encode4(439434), // Rule ID 2223 //
     /* 439405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439408 */     // MIs[0] imm
     /* 439408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 439412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 439416 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 439420 */     // MIs[1] Operand 1
     /* 439420 */     // No operand predicates
     /* 439420 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 439422 */     // (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (SSHRv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 439422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv8i8_shift),
     /* 439425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 439427 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 439429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 439432 */     GIR_RootConstrainSelectedInstOperands,
     /* 439433 */     // GIR_Coverage, 2223,
     /* 439433 */     GIR_EraseRootFromParent_Done,
     /* 439434 */   // Label 8901: @439434
     /* 439434 */   GIM_Reject,
     /* 439435 */ // Label 8899: @439435
     /* 439435 */ GIM_Reject,
     /* 439436 */ // Label 8880: @439436
     /* 439436 */ GIM_Try, /*On fail goto*//*Label 8902*/ GIMT_Encode4(439512),
     /* 439441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 439444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439448 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439452 */   GIM_Try, /*On fail goto*//*Label 8903*/ GIMT_Encode4(439477), // Rule ID 4955 //
     /* 439457 */     // MIs[0] Operand 2
     /* 439457 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 439468 */     // (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, 15:{ *:[i32] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 439468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 439471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 439473 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 439475 */     GIR_RootConstrainSelectedInstOperands,
     /* 439476 */     // GIR_Coverage, 4955,
     /* 439476 */     GIR_EraseRootFromParent_Done,
     /* 439477 */   // Label 8903: @439477
     /* 439477 */   GIM_Try, /*On fail goto*//*Label 8904*/ GIMT_Encode4(439511), // Rule ID 2226 //
     /* 439482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439485 */     // MIs[0] imm
     /* 439485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 439489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 439493 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 439497 */     // MIs[1] Operand 1
     /* 439497 */     // No operand predicates
     /* 439497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 439499 */     // (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SSHRv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 439499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv8i16_shift),
     /* 439502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 439504 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 439506 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 439509 */     GIR_RootConstrainSelectedInstOperands,
     /* 439510 */     // GIR_Coverage, 2226,
     /* 439510 */     GIR_EraseRootFromParent_Done,
     /* 439511 */   // Label 8904: @439511
     /* 439511 */   GIM_Reject,
     /* 439512 */ // Label 8902: @439512
     /* 439512 */ GIM_Reject,
     /* 439513 */ // Label 8881: @439513
     /* 439513 */ GIM_Try, /*On fail goto*//*Label 8905*/ GIMT_Encode4(439589),
     /* 439518 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 439521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439525 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439529 */   GIM_Try, /*On fail goto*//*Label 8906*/ GIMT_Encode4(439554), // Rule ID 4954 //
     /* 439534 */     // MIs[0] Operand 2
     /* 439534 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 439545 */     // (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, 7:{ *:[i32] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 439545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 439548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 439550 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 439552 */     GIR_RootConstrainSelectedInstOperands,
     /* 439553 */     // GIR_Coverage, 4954,
     /* 439553 */     GIR_EraseRootFromParent_Done,
     /* 439554 */   // Label 8906: @439554
     /* 439554 */   GIM_Try, /*On fail goto*//*Label 8907*/ GIMT_Encode4(439588), // Rule ID 2224 //
     /* 439559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439562 */     // MIs[0] imm
     /* 439562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 439566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 439570 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 439574 */     // MIs[1] Operand 1
     /* 439574 */     // No operand predicates
     /* 439574 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 439576 */     // (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (SSHRv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 439576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv16i8_shift),
     /* 439579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 439581 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 439583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 439586 */     GIR_RootConstrainSelectedInstOperands,
     /* 439587 */     // GIR_Coverage, 2224,
     /* 439587 */     GIR_EraseRootFromParent_Done,
     /* 439588 */   // Label 8907: @439588
     /* 439588 */   GIM_Reject,
     /* 439589 */ // Label 8905: @439589
     /* 439589 */ GIM_Reject,
     /* 439590 */ // Label 8882: @439590
     /* 439590 */ GIM_Reject,
     /* 439591 */ // Label 152: @439591
     /* 439591 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8916*/ GIMT_Encode4(440046),
     /* 439602 */ /*GILLT_s64*//*Label 8908*/ GIMT_Encode4(439638), GIMT_Encode4(0),
     /* 439610 */ /*GILLT_v2s32*//*Label 8909*/ GIMT_Encode4(439724),
     /* 439614 */ /*GILLT_v2s64*//*Label 8910*/ GIMT_Encode4(439770),
     /* 439618 */ /*GILLT_v4s16*//*Label 8911*/ GIMT_Encode4(439816),
     /* 439622 */ /*GILLT_v4s32*//*Label 8912*/ GIMT_Encode4(439862),
     /* 439626 */ /*GILLT_v8s8*//*Label 8913*/ GIMT_Encode4(439908),
     /* 439630 */ /*GILLT_v8s16*//*Label 8914*/ GIMT_Encode4(439954),
     /* 439634 */ /*GILLT_v16s8*//*Label 8915*/ GIMT_Encode4(440000),
     /* 439638 */ // Label 8908: @439638
     /* 439638 */ GIM_Try, /*On fail goto*//*Label 8917*/ GIMT_Encode4(439723),
     /* 439643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 439646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439650 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439654 */   GIM_Try, /*On fail goto*//*Label 8918*/ GIMT_Encode4(439688), // Rule ID 2129 //
     /* 439659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439662 */     // MIs[0] imm
     /* 439662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 439666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 439670 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 439674 */     // MIs[1] Operand 1
     /* 439674 */     // No operand predicates
     /* 439674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 439676 */     // (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRd:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 439676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRd),
     /* 439679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 439681 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 439683 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 439686 */     GIR_RootConstrainSelectedInstOperands,
     /* 439687 */     // GIR_Coverage, 2129,
     /* 439687 */     GIR_EraseRootFromParent_Done,
     /* 439688 */   // Label 8918: @439688
     /* 439688 */   GIM_Try, /*On fail goto*//*Label 8919*/ GIMT_Encode4(439722), // Rule ID 6358 //
     /* 439693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439696 */     // MIs[0] imm
     /* 439696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 439700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 439704 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 439708 */     // MIs[1] Operand 1
     /* 439708 */     // No operand predicates
     /* 439708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 439710 */     // (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 439710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRd),
     /* 439713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 439715 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 439717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 439720 */     GIR_RootConstrainSelectedInstOperands,
     /* 439721 */     // GIR_Coverage, 6358,
     /* 439721 */     GIR_EraseRootFromParent_Done,
     /* 439722 */   // Label 8919: @439722
     /* 439722 */   GIM_Reject,
     /* 439723 */ // Label 8917: @439723
     /* 439723 */ GIM_Reject,
     /* 439724 */ // Label 8909: @439724
     /* 439724 */ GIM_Try, /*On fail goto*//*Label 8920*/ GIMT_Encode4(439769), // Rule ID 2286 //
     /* 439729 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 439735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439739 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439743 */   // MIs[0] imm
     /* 439743 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 439747 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 439751 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 439755 */   // MIs[1] Operand 1
     /* 439755 */   // No operand predicates
     /* 439755 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 439757 */   // (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (USHRv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 439757 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv2i32_shift),
     /* 439760 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 439762 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 439764 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 439767 */   GIR_RootConstrainSelectedInstOperands,
     /* 439768 */   // GIR_Coverage, 2286,
     /* 439768 */   GIR_EraseRootFromParent_Done,
     /* 439769 */ // Label 8920: @439769
     /* 439769 */ GIM_Reject,
     /* 439770 */ // Label 8910: @439770
     /* 439770 */ GIM_Try, /*On fail goto*//*Label 8921*/ GIMT_Encode4(439815), // Rule ID 2288 //
     /* 439775 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 439781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439785 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439789 */   // MIs[0] imm
     /* 439789 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 439793 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 439797 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 439801 */   // MIs[1] Operand 1
     /* 439801 */   // No operand predicates
     /* 439801 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 439803 */   // (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 439803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv2i64_shift),
     /* 439806 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 439808 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 439810 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 439813 */   GIR_RootConstrainSelectedInstOperands,
     /* 439814 */   // GIR_Coverage, 2288,
     /* 439814 */   GIR_EraseRootFromParent_Done,
     /* 439815 */ // Label 8921: @439815
     /* 439815 */ GIM_Reject,
     /* 439816 */ // Label 8911: @439816
     /* 439816 */ GIM_Try, /*On fail goto*//*Label 8922*/ GIMT_Encode4(439861), // Rule ID 2284 //
     /* 439821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 439827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439835 */   // MIs[0] imm
     /* 439835 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 439839 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 439843 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 439847 */   // MIs[1] Operand 1
     /* 439847 */   // No operand predicates
     /* 439847 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 439849 */   // (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (USHRv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 439849 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i16_shift),
     /* 439852 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 439854 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 439856 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 439859 */   GIR_RootConstrainSelectedInstOperands,
     /* 439860 */   // GIR_Coverage, 2284,
     /* 439860 */   GIR_EraseRootFromParent_Done,
     /* 439861 */ // Label 8922: @439861
     /* 439861 */ GIM_Reject,
     /* 439862 */ // Label 8912: @439862
     /* 439862 */ GIM_Try, /*On fail goto*//*Label 8923*/ GIMT_Encode4(439907), // Rule ID 2287 //
     /* 439867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 439873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439877 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439881 */   // MIs[0] imm
     /* 439881 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 439885 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 439889 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 439893 */   // MIs[1] Operand 1
     /* 439893 */   // No operand predicates
     /* 439893 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 439895 */   // (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (USHRv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 439895 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
     /* 439898 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 439900 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 439902 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 439905 */   GIR_RootConstrainSelectedInstOperands,
     /* 439906 */   // GIR_Coverage, 2287,
     /* 439906 */   GIR_EraseRootFromParent_Done,
     /* 439907 */ // Label 8923: @439907
     /* 439907 */ GIM_Reject,
     /* 439908 */ // Label 8913: @439908
     /* 439908 */ GIM_Try, /*On fail goto*//*Label 8924*/ GIMT_Encode4(439953), // Rule ID 2282 //
     /* 439913 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 439919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439923 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439927 */   // MIs[0] imm
     /* 439927 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 439931 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 439935 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 439939 */   // MIs[1] Operand 1
     /* 439939 */   // No operand predicates
     /* 439939 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 439941 */   // (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (USHRv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 439941 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv8i8_shift),
     /* 439944 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 439946 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 439948 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 439951 */   GIR_RootConstrainSelectedInstOperands,
     /* 439952 */   // GIR_Coverage, 2282,
     /* 439952 */   GIR_EraseRootFromParent_Done,
     /* 439953 */ // Label 8924: @439953
     /* 439953 */ GIM_Reject,
     /* 439954 */ // Label 8914: @439954
     /* 439954 */ GIM_Try, /*On fail goto*//*Label 8925*/ GIMT_Encode4(439999), // Rule ID 2285 //
     /* 439959 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 439965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439969 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439973 */   // MIs[0] imm
     /* 439973 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 439977 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 439981 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 439985 */   // MIs[1] Operand 1
     /* 439985 */   // No operand predicates
     /* 439985 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 439987 */   // (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (USHRv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 439987 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv8i16_shift),
     /* 439990 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 439992 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 439994 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 439997 */   GIR_RootConstrainSelectedInstOperands,
     /* 439998 */   // GIR_Coverage, 2285,
     /* 439998 */   GIR_EraseRootFromParent_Done,
     /* 439999 */ // Label 8925: @439999
     /* 439999 */ GIM_Reject,
     /* 440000 */ // Label 8915: @440000
     /* 440000 */ GIM_Try, /*On fail goto*//*Label 8926*/ GIMT_Encode4(440045), // Rule ID 2283 //
     /* 440005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 440008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 440011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440019 */   // MIs[0] imm
     /* 440019 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 440023 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 440027 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 440031 */   // MIs[1] Operand 1
     /* 440031 */   // No operand predicates
     /* 440031 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 440033 */   // (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (USHRv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 440033 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv16i8_shift),
     /* 440036 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 440038 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 440040 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 440043 */   GIR_RootConstrainSelectedInstOperands,
     /* 440044 */   // GIR_Coverage, 2283,
     /* 440044 */   GIR_EraseRootFromParent_Done,
     /* 440045 */ // Label 8926: @440045
     /* 440045 */ GIM_Reject,
     /* 440046 */ // Label 8916: @440046
     /* 440046 */ GIM_Reject,
     /* 440047 */ // Label 153: @440047
     /* 440047 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8945*/ GIMT_Encode4(440826),
     /* 440058 */ /*GILLT_v2s32*//*Label 8927*/ GIMT_Encode4(440134),
     /* 440062 */ /*GILLT_v2s64*//*Label 8928*/ GIMT_Encode4(440189),
     /* 440066 */ /*GILLT_v4s16*//*Label 8929*/ GIMT_Encode4(440244),
     /* 440070 */ /*GILLT_v4s32*//*Label 8930*/ GIMT_Encode4(440299),
     /* 440074 */ /*GILLT_v8s8*//*Label 8931*/ GIMT_Encode4(440354),
     /* 440078 */ /*GILLT_v8s16*//*Label 8932*/ GIMT_Encode4(440388),
     /* 440082 */ /*GILLT_v16s8*//*Label 8933*/ GIMT_Encode4(440443), GIMT_Encode4(0),
     /* 440090 */ /*GILLT_nxv2s1*//*Label 8934*/ GIMT_Encode4(440477),
     /* 440094 */ /*GILLT_nxv2s16*//*Label 8935*/ GIMT_Encode4(440503),
     /* 440098 */ /*GILLT_nxv2s32*//*Label 8936*/ GIMT_Encode4(440529),
     /* 440102 */ /*GILLT_nxv2s64*//*Label 8937*/ GIMT_Encode4(440555),
     /* 440106 */ /*GILLT_nxv4s1*//*Label 8938*/ GIMT_Encode4(440602),
     /* 440110 */ /*GILLT_nxv4s16*//*Label 8939*/ GIMT_Encode4(440628),
     /* 440114 */ /*GILLT_nxv4s32*//*Label 8940*/ GIMT_Encode4(440654),
     /* 440118 */ /*GILLT_nxv8s1*//*Label 8941*/ GIMT_Encode4(440701),
     /* 440122 */ /*GILLT_nxv8s16*//*Label 8942*/ GIMT_Encode4(440727),
     /* 440126 */ /*GILLT_nxv16s1*//*Label 8943*/ GIMT_Encode4(440774),
     /* 440130 */ /*GILLT_nxv16s8*//*Label 8944*/ GIMT_Encode4(440800),
     /* 440134 */ // Label 8927: @440134
     /* 440134 */ GIM_Try, /*On fail goto*//*Label 8946*/ GIMT_Encode4(440188),
     /* 440139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 440142 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 440145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 440149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 440153 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 440157 */   GIM_Try, /*On fail goto*//*Label 8947*/ GIMT_Encode4(440172), // Rule ID 1902 //
     /* 440162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 440165 */     // (AArch64zip1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ZIP1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 440165 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 440170 */     GIR_RootConstrainSelectedInstOperands,
     /* 440171 */     // GIR_Coverage, 1902,
     /* 440171 */     GIR_Done,
     /* 440172 */   // Label 8947: @440172
     /* 440172 */   GIM_Try, /*On fail goto*//*Label 8948*/ GIMT_Encode4(440187), // Rule ID 5524 //
     /* 440177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 440180 */     // (AArch64zip1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (ZIP1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 440180 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 440185 */     GIR_RootConstrainSelectedInstOperands,
     /* 440186 */     // GIR_Coverage, 5524,
     /* 440186 */     GIR_Done,
     /* 440187 */   // Label 8948: @440187
     /* 440187 */   GIM_Reject,
     /* 440188 */ // Label 8946: @440188
     /* 440188 */ GIM_Reject,
     /* 440189 */ // Label 8928: @440189
     /* 440189 */ GIM_Try, /*On fail goto*//*Label 8949*/ GIMT_Encode4(440243),
     /* 440194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 440197 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 440200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440204 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440208 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440212 */   GIM_Try, /*On fail goto*//*Label 8950*/ GIMT_Encode4(440227), // Rule ID 1904 //
     /* 440217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 440220 */     // (AArch64zip1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ZIP1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 440220 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i64),
     /* 440225 */     GIR_RootConstrainSelectedInstOperands,
     /* 440226 */     // GIR_Coverage, 1904,
     /* 440226 */     GIR_Done,
     /* 440227 */   // Label 8950: @440227
     /* 440227 */   GIM_Try, /*On fail goto*//*Label 8951*/ GIMT_Encode4(440242), // Rule ID 5526 //
     /* 440232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 440235 */     // (AArch64zip1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (ZIP1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 440235 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i64),
     /* 440240 */     GIR_RootConstrainSelectedInstOperands,
     /* 440241 */     // GIR_Coverage, 5526,
     /* 440241 */     GIR_Done,
     /* 440242 */   // Label 8951: @440242
     /* 440242 */   GIM_Reject,
     /* 440243 */ // Label 8949: @440243
     /* 440243 */ GIM_Reject,
     /* 440244 */ // Label 8929: @440244
     /* 440244 */ GIM_Try, /*On fail goto*//*Label 8952*/ GIMT_Encode4(440298),
     /* 440249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 440252 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 440255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 440259 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 440263 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 440267 */   GIM_Try, /*On fail goto*//*Label 8953*/ GIMT_Encode4(440282), // Rule ID 1900 //
     /* 440272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 440275 */     // (AArch64zip1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ZIP1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 440275 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 440280 */     GIR_RootConstrainSelectedInstOperands,
     /* 440281 */     // GIR_Coverage, 1900,
     /* 440281 */     GIR_Done,
     /* 440282 */   // Label 8953: @440282
     /* 440282 */   GIM_Try, /*On fail goto*//*Label 8954*/ GIMT_Encode4(440297), // Rule ID 5522 //
     /* 440287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 440290 */     // (AArch64zip1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (ZIP1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 440290 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 440295 */     GIR_RootConstrainSelectedInstOperands,
     /* 440296 */     // GIR_Coverage, 5522,
     /* 440296 */     GIR_Done,
     /* 440297 */   // Label 8954: @440297
     /* 440297 */   GIM_Reject,
     /* 440298 */ // Label 8952: @440298
     /* 440298 */ GIM_Reject,
     /* 440299 */ // Label 8930: @440299
     /* 440299 */ GIM_Try, /*On fail goto*//*Label 8955*/ GIMT_Encode4(440353),
     /* 440304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 440307 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 440310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440314 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440318 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440322 */   GIM_Try, /*On fail goto*//*Label 8956*/ GIMT_Encode4(440337), // Rule ID 1903 //
     /* 440327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 440330 */     // (AArch64zip1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ZIP1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 440330 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i32),
     /* 440335 */     GIR_RootConstrainSelectedInstOperands,
     /* 440336 */     // GIR_Coverage, 1903,
     /* 440336 */     GIR_Done,
     /* 440337 */   // Label 8956: @440337
     /* 440337 */   GIM_Try, /*On fail goto*//*Label 8957*/ GIMT_Encode4(440352), // Rule ID 5525 //
     /* 440342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 440345 */     // (AArch64zip1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (ZIP1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 440345 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i32),
     /* 440350 */     GIR_RootConstrainSelectedInstOperands,
     /* 440351 */     // GIR_Coverage, 5525,
     /* 440351 */     GIR_Done,
     /* 440352 */   // Label 8957: @440352
     /* 440352 */   GIM_Reject,
     /* 440353 */ // Label 8955: @440353
     /* 440353 */ GIM_Reject,
     /* 440354 */ // Label 8931: @440354
     /* 440354 */ GIM_Try, /*On fail goto*//*Label 8958*/ GIMT_Encode4(440387), // Rule ID 1898 //
     /* 440359 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 440362 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 440365 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 440368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 440372 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 440376 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 440380 */   // (AArch64zip1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ZIP1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 440380 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i8),
     /* 440385 */   GIR_RootConstrainSelectedInstOperands,
     /* 440386 */   // GIR_Coverage, 1898,
     /* 440386 */   GIR_Done,
     /* 440387 */ // Label 8958: @440387
     /* 440387 */ GIM_Reject,
     /* 440388 */ // Label 8932: @440388
     /* 440388 */ GIM_Try, /*On fail goto*//*Label 8959*/ GIMT_Encode4(440442),
     /* 440393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 440396 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 440399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440403 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440407 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440411 */   GIM_Try, /*On fail goto*//*Label 8960*/ GIMT_Encode4(440426), // Rule ID 1901 //
     /* 440416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 440419 */     // (AArch64zip1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ZIP1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 440419 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i16),
     /* 440424 */     GIR_RootConstrainSelectedInstOperands,
     /* 440425 */     // GIR_Coverage, 1901,
     /* 440425 */     GIR_Done,
     /* 440426 */   // Label 8960: @440426
     /* 440426 */   GIM_Try, /*On fail goto*//*Label 8961*/ GIMT_Encode4(440441), // Rule ID 5523 //
     /* 440431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 440434 */     // (AArch64zip1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (ZIP1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 440434 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i16),
     /* 440439 */     GIR_RootConstrainSelectedInstOperands,
     /* 440440 */     // GIR_Coverage, 5523,
     /* 440440 */     GIR_Done,
     /* 440441 */   // Label 8961: @440441
     /* 440441 */   GIM_Reject,
     /* 440442 */ // Label 8959: @440442
     /* 440442 */ GIM_Reject,
     /* 440443 */ // Label 8933: @440443
     /* 440443 */ GIM_Try, /*On fail goto*//*Label 8962*/ GIMT_Encode4(440476), // Rule ID 1899 //
     /* 440448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 440451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 440454 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 440457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440461 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440465 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440469 */   // (AArch64zip1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ZIP1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 440469 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v16i8),
     /* 440474 */   GIR_RootConstrainSelectedInstOperands,
     /* 440475 */   // GIR_Coverage, 1899,
     /* 440475 */   GIR_Done,
     /* 440476 */ // Label 8962: @440476
     /* 440476 */ GIM_Reject,
     /* 440477 */ // Label 8934: @440477
     /* 440477 */ GIM_Try, /*On fail goto*//*Label 8963*/ GIMT_Encode4(440502), // Rule ID 3359 //
     /* 440482 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 440485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 440488 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 440491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 440495 */   // (AArch64zip1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (ZIP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 440495 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_D),
     /* 440500 */   GIR_RootConstrainSelectedInstOperands,
     /* 440501 */   // GIR_Coverage, 3359,
     /* 440501 */   GIR_Done,
     /* 440502 */ // Label 8963: @440502
     /* 440502 */ GIM_Reject,
     /* 440503 */ // Label 8935: @440503
     /* 440503 */ GIM_Try, /*On fail goto*//*Label 8964*/ GIMT_Encode4(440528), // Rule ID 2890 //
     /* 440508 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 440511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 440514 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 440517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 440521 */   // (AArch64zip1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 440521 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 440526 */   GIR_RootConstrainSelectedInstOperands,
     /* 440527 */   // GIR_Coverage, 2890,
     /* 440527 */   GIR_Done,
     /* 440528 */ // Label 8964: @440528
     /* 440528 */ GIM_Reject,
     /* 440529 */ // Label 8936: @440529
     /* 440529 */ GIM_Try, /*On fail goto*//*Label 8965*/ GIMT_Encode4(440554), // Rule ID 2891 //
     /* 440534 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 440537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 440540 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 440543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 440547 */   // (AArch64zip1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 440547 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 440552 */   GIR_RootConstrainSelectedInstOperands,
     /* 440553 */   // GIR_Coverage, 2891,
     /* 440553 */   GIR_Done,
     /* 440554 */ // Label 8965: @440554
     /* 440554 */ GIM_Reject,
     /* 440555 */ // Label 8937: @440555
     /* 440555 */ GIM_Try, /*On fail goto*//*Label 8966*/ GIMT_Encode4(440601),
     /* 440560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 440563 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 440566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 440570 */   GIM_Try, /*On fail goto*//*Label 8967*/ GIMT_Encode4(440585), // Rule ID 2886 //
     /* 440575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 440578 */     // (AArch64zip1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 440578 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 440583 */     GIR_RootConstrainSelectedInstOperands,
     /* 440584 */     // GIR_Coverage, 2886,
     /* 440584 */     GIR_Done,
     /* 440585 */   // Label 8967: @440585
     /* 440585 */   GIM_Try, /*On fail goto*//*Label 8968*/ GIMT_Encode4(440600), // Rule ID 2892 //
     /* 440590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 440593 */     // (AArch64zip1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 440593 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 440598 */     GIR_RootConstrainSelectedInstOperands,
     /* 440599 */     // GIR_Coverage, 2892,
     /* 440599 */     GIR_Done,
     /* 440600 */   // Label 8968: @440600
     /* 440600 */   GIM_Reject,
     /* 440601 */ // Label 8966: @440601
     /* 440601 */ GIM_Reject,
     /* 440602 */ // Label 8938: @440602
     /* 440602 */ GIM_Try, /*On fail goto*//*Label 8969*/ GIMT_Encode4(440627), // Rule ID 3358 //
     /* 440607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 440610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 440613 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 440616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 440620 */   // (AArch64zip1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (ZIP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 440620 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_S),
     /* 440625 */   GIR_RootConstrainSelectedInstOperands,
     /* 440626 */   // GIR_Coverage, 3358,
     /* 440626 */   GIR_Done,
     /* 440627 */ // Label 8969: @440627
     /* 440627 */ GIM_Reject,
     /* 440628 */ // Label 8939: @440628
     /* 440628 */ GIM_Try, /*On fail goto*//*Label 8970*/ GIMT_Encode4(440653), // Rule ID 2888 //
     /* 440633 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 440636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 440639 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 440642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 440646 */   // (AArch64zip1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 440646 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 440651 */   GIR_RootConstrainSelectedInstOperands,
     /* 440652 */   // GIR_Coverage, 2888,
     /* 440652 */   GIR_Done,
     /* 440653 */ // Label 8970: @440653
     /* 440653 */ GIM_Reject,
     /* 440654 */ // Label 8940: @440654
     /* 440654 */ GIM_Try, /*On fail goto*//*Label 8971*/ GIMT_Encode4(440700),
     /* 440659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 440662 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 440665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 440669 */   GIM_Try, /*On fail goto*//*Label 8972*/ GIMT_Encode4(440684), // Rule ID 2885 //
     /* 440674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 440677 */     // (AArch64zip1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 440677 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 440682 */     GIR_RootConstrainSelectedInstOperands,
     /* 440683 */     // GIR_Coverage, 2885,
     /* 440683 */     GIR_Done,
     /* 440684 */   // Label 8972: @440684
     /* 440684 */   GIM_Try, /*On fail goto*//*Label 8973*/ GIMT_Encode4(440699), // Rule ID 2889 //
     /* 440689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 440692 */     // (AArch64zip1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 440692 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 440697 */     GIR_RootConstrainSelectedInstOperands,
     /* 440698 */     // GIR_Coverage, 2889,
     /* 440698 */     GIR_Done,
     /* 440699 */   // Label 8973: @440699
     /* 440699 */   GIM_Reject,
     /* 440700 */ // Label 8971: @440700
     /* 440700 */ GIM_Reject,
     /* 440701 */ // Label 8941: @440701
     /* 440701 */ GIM_Try, /*On fail goto*//*Label 8974*/ GIMT_Encode4(440726), // Rule ID 3357 //
     /* 440706 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 440709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 440712 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 440715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 440719 */   // (AArch64zip1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (ZIP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 440719 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_H),
     /* 440724 */   GIR_RootConstrainSelectedInstOperands,
     /* 440725 */   // GIR_Coverage, 3357,
     /* 440725 */   GIR_Done,
     /* 440726 */ // Label 8974: @440726
     /* 440726 */ GIM_Reject,
     /* 440727 */ // Label 8942: @440727
     /* 440727 */ GIM_Try, /*On fail goto*//*Label 8975*/ GIMT_Encode4(440773),
     /* 440732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 440735 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 440738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 440742 */   GIM_Try, /*On fail goto*//*Label 8976*/ GIMT_Encode4(440757), // Rule ID 2884 //
     /* 440747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 440750 */     // (AArch64zip1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 440750 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_H),
     /* 440755 */     GIR_RootConstrainSelectedInstOperands,
     /* 440756 */     // GIR_Coverage, 2884,
     /* 440756 */     GIR_Done,
     /* 440757 */   // Label 8976: @440757
     /* 440757 */   GIM_Try, /*On fail goto*//*Label 8977*/ GIMT_Encode4(440772), // Rule ID 2887 //
     /* 440762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 440765 */     // (AArch64zip1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 440765 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_H),
     /* 440770 */     GIR_RootConstrainSelectedInstOperands,
     /* 440771 */     // GIR_Coverage, 2887,
     /* 440771 */     GIR_Done,
     /* 440772 */   // Label 8977: @440772
     /* 440772 */   GIM_Reject,
     /* 440773 */ // Label 8975: @440773
     /* 440773 */ GIM_Reject,
     /* 440774 */ // Label 8943: @440774
     /* 440774 */ GIM_Try, /*On fail goto*//*Label 8978*/ GIMT_Encode4(440799), // Rule ID 2398 //
     /* 440779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 440782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 440785 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 440788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 440792 */   // (AArch64zip1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 440792 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_B),
     /* 440797 */   GIR_RootConstrainSelectedInstOperands,
     /* 440798 */   // GIR_Coverage, 2398,
     /* 440798 */   GIR_Done,
     /* 440799 */ // Label 8978: @440799
     /* 440799 */ GIM_Reject,
     /* 440800 */ // Label 8944: @440800
     /* 440800 */ GIM_Try, /*On fail goto*//*Label 8979*/ GIMT_Encode4(440825), // Rule ID 2883 //
     /* 440805 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 440808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 440811 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 440814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 440818 */   // (AArch64zip1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 440818 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_B),
     /* 440823 */   GIR_RootConstrainSelectedInstOperands,
     /* 440824 */   // GIR_Coverage, 2883,
     /* 440824 */   GIR_Done,
     /* 440825 */ // Label 8979: @440825
     /* 440825 */ GIM_Reject,
     /* 440826 */ // Label 8945: @440826
     /* 440826 */ GIM_Reject,
     /* 440827 */ // Label 154: @440827
     /* 440827 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8998*/ GIMT_Encode4(441606),
     /* 440838 */ /*GILLT_v2s32*//*Label 8980*/ GIMT_Encode4(440914),
     /* 440842 */ /*GILLT_v2s64*//*Label 8981*/ GIMT_Encode4(440969),
     /* 440846 */ /*GILLT_v4s16*//*Label 8982*/ GIMT_Encode4(441024),
     /* 440850 */ /*GILLT_v4s32*//*Label 8983*/ GIMT_Encode4(441079),
     /* 440854 */ /*GILLT_v8s8*//*Label 8984*/ GIMT_Encode4(441134),
     /* 440858 */ /*GILLT_v8s16*//*Label 8985*/ GIMT_Encode4(441168),
     /* 440862 */ /*GILLT_v16s8*//*Label 8986*/ GIMT_Encode4(441223), GIMT_Encode4(0),
     /* 440870 */ /*GILLT_nxv2s1*//*Label 8987*/ GIMT_Encode4(441257),
     /* 440874 */ /*GILLT_nxv2s16*//*Label 8988*/ GIMT_Encode4(441283),
     /* 440878 */ /*GILLT_nxv2s32*//*Label 8989*/ GIMT_Encode4(441309),
     /* 440882 */ /*GILLT_nxv2s64*//*Label 8990*/ GIMT_Encode4(441335),
     /* 440886 */ /*GILLT_nxv4s1*//*Label 8991*/ GIMT_Encode4(441382),
     /* 440890 */ /*GILLT_nxv4s16*//*Label 8992*/ GIMT_Encode4(441408),
     /* 440894 */ /*GILLT_nxv4s32*//*Label 8993*/ GIMT_Encode4(441434),
     /* 440898 */ /*GILLT_nxv8s1*//*Label 8994*/ GIMT_Encode4(441481),
     /* 440902 */ /*GILLT_nxv8s16*//*Label 8995*/ GIMT_Encode4(441507),
     /* 440906 */ /*GILLT_nxv16s1*//*Label 8996*/ GIMT_Encode4(441554),
     /* 440910 */ /*GILLT_nxv16s8*//*Label 8997*/ GIMT_Encode4(441580),
     /* 440914 */ // Label 8980: @440914
     /* 440914 */ GIM_Try, /*On fail goto*//*Label 8999*/ GIMT_Encode4(440968),
     /* 440919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 440922 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 440925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 440929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 440933 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 440937 */   GIM_Try, /*On fail goto*//*Label 9000*/ GIMT_Encode4(440952), // Rule ID 1909 //
     /* 440942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 440945 */     // (AArch64zip2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ZIP2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 440945 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 440950 */     GIR_RootConstrainSelectedInstOperands,
     /* 440951 */     // GIR_Coverage, 1909,
     /* 440951 */     GIR_Done,
     /* 440952 */   // Label 9000: @440952
     /* 440952 */   GIM_Try, /*On fail goto*//*Label 9001*/ GIMT_Encode4(440967), // Rule ID 5529 //
     /* 440957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 440960 */     // (AArch64zip2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (ZIP2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 440960 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 440965 */     GIR_RootConstrainSelectedInstOperands,
     /* 440966 */     // GIR_Coverage, 5529,
     /* 440966 */     GIR_Done,
     /* 440967 */   // Label 9001: @440967
     /* 440967 */   GIM_Reject,
     /* 440968 */ // Label 8999: @440968
     /* 440968 */ GIM_Reject,
     /* 440969 */ // Label 8981: @440969
     /* 440969 */ GIM_Try, /*On fail goto*//*Label 9002*/ GIMT_Encode4(441023),
     /* 440974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 440977 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 440980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440988 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440992 */   GIM_Try, /*On fail goto*//*Label 9003*/ GIMT_Encode4(441007), // Rule ID 1911 //
     /* 440997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 441000 */     // (AArch64zip2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ZIP2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 441000 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i64),
     /* 441005 */     GIR_RootConstrainSelectedInstOperands,
     /* 441006 */     // GIR_Coverage, 1911,
     /* 441006 */     GIR_Done,
     /* 441007 */   // Label 9003: @441007
     /* 441007 */   GIM_Try, /*On fail goto*//*Label 9004*/ GIMT_Encode4(441022), // Rule ID 5531 //
     /* 441012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 441015 */     // (AArch64zip2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (ZIP2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 441015 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i64),
     /* 441020 */     GIR_RootConstrainSelectedInstOperands,
     /* 441021 */     // GIR_Coverage, 5531,
     /* 441021 */     GIR_Done,
     /* 441022 */   // Label 9004: @441022
     /* 441022 */   GIM_Reject,
     /* 441023 */ // Label 9002: @441023
     /* 441023 */ GIM_Reject,
     /* 441024 */ // Label 8982: @441024
     /* 441024 */ GIM_Try, /*On fail goto*//*Label 9005*/ GIMT_Encode4(441078),
     /* 441029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 441032 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 441035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 441039 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 441043 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 441047 */   GIM_Try, /*On fail goto*//*Label 9006*/ GIMT_Encode4(441062), // Rule ID 1907 //
     /* 441052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 441055 */     // (AArch64zip2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ZIP2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 441055 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 441060 */     GIR_RootConstrainSelectedInstOperands,
     /* 441061 */     // GIR_Coverage, 1907,
     /* 441061 */     GIR_Done,
     /* 441062 */   // Label 9006: @441062
     /* 441062 */   GIM_Try, /*On fail goto*//*Label 9007*/ GIMT_Encode4(441077), // Rule ID 5527 //
     /* 441067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 441070 */     // (AArch64zip2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (ZIP2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 441070 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 441075 */     GIR_RootConstrainSelectedInstOperands,
     /* 441076 */     // GIR_Coverage, 5527,
     /* 441076 */     GIR_Done,
     /* 441077 */   // Label 9007: @441077
     /* 441077 */   GIM_Reject,
     /* 441078 */ // Label 9005: @441078
     /* 441078 */ GIM_Reject,
     /* 441079 */ // Label 8983: @441079
     /* 441079 */ GIM_Try, /*On fail goto*//*Label 9008*/ GIMT_Encode4(441133),
     /* 441084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 441087 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 441090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 441094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 441098 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 441102 */   GIM_Try, /*On fail goto*//*Label 9009*/ GIMT_Encode4(441117), // Rule ID 1910 //
     /* 441107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 441110 */     // (AArch64zip2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ZIP2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 441110 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i32),
     /* 441115 */     GIR_RootConstrainSelectedInstOperands,
     /* 441116 */     // GIR_Coverage, 1910,
     /* 441116 */     GIR_Done,
     /* 441117 */   // Label 9009: @441117
     /* 441117 */   GIM_Try, /*On fail goto*//*Label 9010*/ GIMT_Encode4(441132), // Rule ID 5530 //
     /* 441122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 441125 */     // (AArch64zip2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (ZIP2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 441125 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i32),
     /* 441130 */     GIR_RootConstrainSelectedInstOperands,
     /* 441131 */     // GIR_Coverage, 5530,
     /* 441131 */     GIR_Done,
     /* 441132 */   // Label 9010: @441132
     /* 441132 */   GIM_Reject,
     /* 441133 */ // Label 9008: @441133
     /* 441133 */ GIM_Reject,
     /* 441134 */ // Label 8984: @441134
     /* 441134 */ GIM_Try, /*On fail goto*//*Label 9011*/ GIMT_Encode4(441167), // Rule ID 1905 //
     /* 441139 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 441142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 441145 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 441148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 441152 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 441156 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 441160 */   // (AArch64zip2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ZIP2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 441160 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i8),
     /* 441165 */   GIR_RootConstrainSelectedInstOperands,
     /* 441166 */   // GIR_Coverage, 1905,
     /* 441166 */   GIR_Done,
     /* 441167 */ // Label 9011: @441167
     /* 441167 */ GIM_Reject,
     /* 441168 */ // Label 8985: @441168
     /* 441168 */ GIM_Try, /*On fail goto*//*Label 9012*/ GIMT_Encode4(441222),
     /* 441173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 441176 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 441179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 441183 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 441187 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 441191 */   GIM_Try, /*On fail goto*//*Label 9013*/ GIMT_Encode4(441206), // Rule ID 1908 //
     /* 441196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 441199 */     // (AArch64zip2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ZIP2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 441199 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i16),
     /* 441204 */     GIR_RootConstrainSelectedInstOperands,
     /* 441205 */     // GIR_Coverage, 1908,
     /* 441205 */     GIR_Done,
     /* 441206 */   // Label 9013: @441206
     /* 441206 */   GIM_Try, /*On fail goto*//*Label 9014*/ GIMT_Encode4(441221), // Rule ID 5528 //
     /* 441211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 441214 */     // (AArch64zip2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (ZIP2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 441214 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i16),
     /* 441219 */     GIR_RootConstrainSelectedInstOperands,
     /* 441220 */     // GIR_Coverage, 5528,
     /* 441220 */     GIR_Done,
     /* 441221 */   // Label 9014: @441221
     /* 441221 */   GIM_Reject,
     /* 441222 */ // Label 9012: @441222
     /* 441222 */ GIM_Reject,
     /* 441223 */ // Label 8986: @441223
     /* 441223 */ GIM_Try, /*On fail goto*//*Label 9015*/ GIMT_Encode4(441256), // Rule ID 1906 //
     /* 441228 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 441231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 441234 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 441237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 441241 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 441245 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 441249 */   // (AArch64zip2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ZIP2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 441249 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v16i8),
     /* 441254 */   GIR_RootConstrainSelectedInstOperands,
     /* 441255 */   // GIR_Coverage, 1906,
     /* 441255 */   GIR_Done,
     /* 441256 */ // Label 9015: @441256
     /* 441256 */ GIM_Reject,
     /* 441257 */ // Label 8987: @441257
     /* 441257 */ GIM_Try, /*On fail goto*//*Label 9016*/ GIMT_Encode4(441282), // Rule ID 9073 //
     /* 441262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 441265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 441268 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 441271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 441275 */   // (AArch64zip2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (ZIP2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 441275 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_D),
     /* 441280 */   GIR_RootConstrainSelectedInstOperands,
     /* 441281 */   // GIR_Coverage, 9073,
     /* 441281 */   GIR_Done,
     /* 441282 */ // Label 9016: @441282
     /* 441282 */ GIM_Reject,
     /* 441283 */ // Label 8988: @441283
     /* 441283 */ GIM_Try, /*On fail goto*//*Label 9017*/ GIMT_Encode4(441308), // Rule ID 9028 //
     /* 441288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 441291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 441294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 441297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 441301 */   // (AArch64zip2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 441301 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 441306 */   GIR_RootConstrainSelectedInstOperands,
     /* 441307 */   // GIR_Coverage, 9028,
     /* 441307 */   GIR_Done,
     /* 441308 */ // Label 9017: @441308
     /* 441308 */ GIM_Reject,
     /* 441309 */ // Label 8989: @441309
     /* 441309 */ GIM_Try, /*On fail goto*//*Label 9018*/ GIMT_Encode4(441334), // Rule ID 9029 //
     /* 441314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 441317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 441320 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 441323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 441327 */   // (AArch64zip2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 441327 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 441332 */   GIR_RootConstrainSelectedInstOperands,
     /* 441333 */   // GIR_Coverage, 9029,
     /* 441333 */   GIR_Done,
     /* 441334 */ // Label 9018: @441334
     /* 441334 */ GIM_Reject,
     /* 441335 */ // Label 8990: @441335
     /* 441335 */ GIM_Try, /*On fail goto*//*Label 9019*/ GIMT_Encode4(441381),
     /* 441340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 441343 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 441346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 441350 */   GIM_Try, /*On fail goto*//*Label 9020*/ GIMT_Encode4(441365), // Rule ID 9024 //
     /* 441355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 441358 */     // (AArch64zip2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 441358 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 441363 */     GIR_RootConstrainSelectedInstOperands,
     /* 441364 */     // GIR_Coverage, 9024,
     /* 441364 */     GIR_Done,
     /* 441365 */   // Label 9020: @441365
     /* 441365 */   GIM_Try, /*On fail goto*//*Label 9021*/ GIMT_Encode4(441380), // Rule ID 9030 //
     /* 441370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 441373 */     // (AArch64zip2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 441373 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 441378 */     GIR_RootConstrainSelectedInstOperands,
     /* 441379 */     // GIR_Coverage, 9030,
     /* 441379 */     GIR_Done,
     /* 441380 */   // Label 9021: @441380
     /* 441380 */   GIM_Reject,
     /* 441381 */ // Label 9019: @441381
     /* 441381 */ GIM_Reject,
     /* 441382 */ // Label 8991: @441382
     /* 441382 */ GIM_Try, /*On fail goto*//*Label 9022*/ GIMT_Encode4(441407), // Rule ID 9072 //
     /* 441387 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 441390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 441393 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 441396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 441400 */   // (AArch64zip2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (ZIP2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 441400 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_S),
     /* 441405 */   GIR_RootConstrainSelectedInstOperands,
     /* 441406 */   // GIR_Coverage, 9072,
     /* 441406 */   GIR_Done,
     /* 441407 */ // Label 9022: @441407
     /* 441407 */ GIM_Reject,
     /* 441408 */ // Label 8992: @441408
     /* 441408 */ GIM_Try, /*On fail goto*//*Label 9023*/ GIMT_Encode4(441433), // Rule ID 9026 //
     /* 441413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 441416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 441419 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 441422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 441426 */   // (AArch64zip2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 441426 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 441431 */   GIR_RootConstrainSelectedInstOperands,
     /* 441432 */   // GIR_Coverage, 9026,
     /* 441432 */   GIR_Done,
     /* 441433 */ // Label 9023: @441433
     /* 441433 */ GIM_Reject,
     /* 441434 */ // Label 8993: @441434
     /* 441434 */ GIM_Try, /*On fail goto*//*Label 9024*/ GIMT_Encode4(441480),
     /* 441439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 441442 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 441445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 441449 */   GIM_Try, /*On fail goto*//*Label 9025*/ GIMT_Encode4(441464), // Rule ID 9023 //
     /* 441454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 441457 */     // (AArch64zip2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 441457 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 441462 */     GIR_RootConstrainSelectedInstOperands,
     /* 441463 */     // GIR_Coverage, 9023,
     /* 441463 */     GIR_Done,
     /* 441464 */   // Label 9025: @441464
     /* 441464 */   GIM_Try, /*On fail goto*//*Label 9026*/ GIMT_Encode4(441479), // Rule ID 9027 //
     /* 441469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 441472 */     // (AArch64zip2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 441472 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 441477 */     GIR_RootConstrainSelectedInstOperands,
     /* 441478 */     // GIR_Coverage, 9027,
     /* 441478 */     GIR_Done,
     /* 441479 */   // Label 9026: @441479
     /* 441479 */   GIM_Reject,
     /* 441480 */ // Label 9024: @441480
     /* 441480 */ GIM_Reject,
     /* 441481 */ // Label 8994: @441481
     /* 441481 */ GIM_Try, /*On fail goto*//*Label 9027*/ GIMT_Encode4(441506), // Rule ID 9071 //
     /* 441486 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 441489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 441492 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 441495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 441499 */   // (AArch64zip2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (ZIP2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 441499 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_H),
     /* 441504 */   GIR_RootConstrainSelectedInstOperands,
     /* 441505 */   // GIR_Coverage, 9071,
     /* 441505 */   GIR_Done,
     /* 441506 */ // Label 9027: @441506
     /* 441506 */ GIM_Reject,
     /* 441507 */ // Label 8995: @441507
     /* 441507 */ GIM_Try, /*On fail goto*//*Label 9028*/ GIMT_Encode4(441553),
     /* 441512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 441515 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 441518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 441522 */   GIM_Try, /*On fail goto*//*Label 9029*/ GIMT_Encode4(441537), // Rule ID 9022 //
     /* 441527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 441530 */     // (AArch64zip2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 441530 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_H),
     /* 441535 */     GIR_RootConstrainSelectedInstOperands,
     /* 441536 */     // GIR_Coverage, 9022,
     /* 441536 */     GIR_Done,
     /* 441537 */   // Label 9029: @441537
     /* 441537 */   GIM_Try, /*On fail goto*//*Label 9030*/ GIMT_Encode4(441552), // Rule ID 9025 //
     /* 441542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 441545 */     // (AArch64zip2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 441545 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_H),
     /* 441550 */     GIR_RootConstrainSelectedInstOperands,
     /* 441551 */     // GIR_Coverage, 9025,
     /* 441551 */     GIR_Done,
     /* 441552 */   // Label 9030: @441552
     /* 441552 */   GIM_Reject,
     /* 441553 */ // Label 9028: @441553
     /* 441553 */ GIM_Reject,
     /* 441554 */ // Label 8996: @441554
     /* 441554 */ GIM_Try, /*On fail goto*//*Label 9031*/ GIMT_Encode4(441579), // Rule ID 2402 //
     /* 441559 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 441562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 441565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 441568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 441572 */   // (AArch64zip2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 441572 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_B),
     /* 441577 */   GIR_RootConstrainSelectedInstOperands,
     /* 441578 */   // GIR_Coverage, 2402,
     /* 441578 */   GIR_Done,
     /* 441579 */ // Label 9031: @441579
     /* 441579 */ GIM_Reject,
     /* 441580 */ // Label 8997: @441580
     /* 441580 */ GIM_Try, /*On fail goto*//*Label 9032*/ GIMT_Encode4(441605), // Rule ID 9021 //
     /* 441585 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 441588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 441591 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 441594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 441598 */   // (AArch64zip2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 441598 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_B),
     /* 441603 */   GIR_RootConstrainSelectedInstOperands,
     /* 441604 */   // GIR_Coverage, 9021,
     /* 441604 */   GIR_Done,
     /* 441605 */ // Label 9032: @441605
     /* 441605 */ GIM_Reject,
     /* 441606 */ // Label 8998: @441606
     /* 441606 */ GIM_Reject,
     /* 441607 */ // Label 155: @441607
     /* 441607 */ GIM_Reject,
     /* 441608 */ }; // Size: 441608 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
